/**
 * @license
 * Copyright 2019 The Emscripten Authors
 * SPDX-License-Identifier: MIT
 */

// wasm2js.js - enough of a polyfill for the WebAssembly object so that we can load
// wasm2js code that way.

// Emit "var WebAssembly" if definitely using wasm2js. Otherwise, in MAYBE_WASM2JS
// mode, we can't use a "var" since it would prevent normal wasm from working.
/** @suppress{duplicate, const} */
var
WebAssembly = {
  // Note that we do not use closure quoting (this['buffer'], etc.) on these
  // functions, as they are just meant for internal use. In other words, this is
  // not a fully general polyfill.
  /** @constructor */
  Memory: function(opts) {
    this.buffer = new ArrayBuffer(opts['initial'] * 65536);
  },

  Module: function(binary) {
    // TODO: use the binary and info somehow - right now the wasm2js output is embedded in
    // the main JS
  },

  /** @constructor */
  Instance: function(module, info) {
    // TODO: use the module somehow - right now the wasm2js output is embedded in
    // the main JS
    // This will be replaced by the actual wasm2js code.
    this.exports = (
// EMSCRIPTEN_START_ASM
function instantiate(rb) {
 function c(d) {
  d.set = function(a, b) {
   this[a] = b;
  };
  d.get = function(a) {
   return this[a];
  };
  return d;
 }
 var e;
 var f = new ArrayBuffer(16);
 var g = new Int32Array(f);
 var h = new Float32Array(f);
 var i = new Float64Array(f);
 function j(k) {
  return g[k];
 }
 function l(k, m) {
  g[k] = m;
 }
 function n() {
  return i[0];
 }
 function o(m) {
  i[0] = m;
 }
 function p() {
  throw new Error("abort");
 }
 function q(m) {
  h[2] = m;
 }
 function r() {
  return h[2];
 }
 function pb(qb) {
  var s = new ArrayBuffer(16777216);
  var t = new Int8Array(s);
  var u = new Int16Array(s);
  var v = new Int32Array(s);
  var w = new Uint8Array(s);
  var x = new Uint16Array(s);
  var y = new Uint32Array(s);
  var z = new Float32Array(s);
  var A = new Float64Array(s);
  var B = Math.imul;
  var C = Math.fround;
  var D = Math.abs;
  var E = Math.clz32;
  var F = Math.min;
  var G = Math.max;
  var H = Math.floor;
  var I = Math.ceil;
  var J = Math.trunc;
  var K = Math.sqrt;
  var L = qb.a;
  var M = L.a;
  var N = L.b;
  var O = L.c;
  var P = L.d;
  var Q = L.e;
  var R = L.f;
  var S = L.g;
  var T = L.h;
  var U = L.i;
  var V = L.j;
  var W = L.k;
  var X = L.l;
  var Y = L.m;
  var Z = L.n;
  var _ = L.o;
  var $ = L.p;
  var aa = L.q;
  var ba = L.r;
  var ca = L.s;
  var da = L.t;
  var ea = L.u;
  var fa = L.v;
  var ga = L.w;
  var ha = L.x;
  var ia = L.y;
  var ja = L.z;
  var ka = L.A;
  var la = L.B;
  var ma = L.C;
  var na = L.D;
  var oa = L.E;
  var pa = L.F;
  var qa = L.G;
  var ra = L.H;
  var sa = L.I;
  var ta = L.J;
  var ua = L.K;
  var va = L.L;
  var wa = L.M;
  var xa = L.N;
  var ya = L.O;
  var za = L.P;
  var Aa = L.Q;
  var Ba = L.R;
  var Ca = L.S;
  var Da = L.T;
  var Ea = L.U;
  var Fa = L.V;
  var Ga = L.W;
  var Ha = L.X;
  var Ia = L.Y;
  var Ja = L.Z;
  var Ka = L._;
  var La = L.$;
  var Ma = L.aa;
  var Na = L.ba;
  var Oa = L.ca;
  var Pa = L.da;
  var Qa = L.ea;
  var Ra = L.fa;
  var Sa = L.ga;
  var Ta = L.ha;
  var Ua = L.ia;
  var Va = L.ja;
  var Wa = L.ka;
  var Xa = L.la;
  var Ya = L.ma;
  var Za = L.na;
  var _a = L.oa;
  var $a = L.pa;
  var ab = L.qa;
  var bb = L.ra;
  var cb = L.sa;
  var db = L.ta;
  var eb = 567760;
  var fb = 0;
  var gb = 0;
  
// EMSCRIPTEN_START_FUNCS
function _ra(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, q = 0, r = 0, s = 0, z = 0, A = 0, C = 0, D = 0, E = 0, F = 0, G = 0, H = 0, I = 0, J = 0, K = 0, L = 0, S = 0, W = 0;
 e = eb - 608 | 0;
 eb = e;
 xc(b);
 d = eb - 16 | 0;
 eb = d;
 g = e + 416 | 0;
 sw(d + 8 | 0, g);
 k = v[d + 12 >> 2];
 ic(d, v[b >> 2], v[b + 8 >> 2], v[d + 8 >> 2], v[d + 12 >> 2]);
 i = v[d + 4 >> 2];
 if ((i | 0) == (k | 0)) {
  Ub(b, v[d + 12 >> 2]);
 }
 eb = d + 16 | 0;
 d = (i | 0) == (k | 0);
 if (!d) {
  EZ(g);
 }
 a: {
  b: {
   c: {
    if (!d) {
     break c;
    }
    if (!GZ(g)) {
     break c;
    }
    if (!Lb(v[b >> 2], v[b + 8 >> 2], Ac(FZ(g), gb))) {
     break c;
    }
    f = 1;
    if ((c | 0) == 64) {
     break c;
    }
    Cd(a, 32);
    t[e + 415 | 0] = 0;
    k = Eb(e + 400 | 0);
    d: {
     e: {
      f: {
       g: {
        h: {
         i: {
          if ((w[e + 416 | 0] | w[e + 417 | 0] << 8 | (w[e + 418 | 0] << 16 | w[e + 419 | 0] << 24)) == 778924148) {
           v[31601] = 0;
           N(417, a | 0, 16777216);
           d = v[31601];
           v[31601] = 0;
           if ((d | 0) == 1) {
            break b;
           }
           d = v[b >> 2];
           v[31601] = 0;
           d = Q(154, d | 0) | 0;
           f = v[31601];
           v[31601] = 0;
           if ((f | 0) == 1) {
            break b;
           }
           v[31601] = 0;
           O(149, b | 0, d - 4 | 0) | 0;
           d = v[31601];
           v[31601] = 0;
           if ((d | 0) == 1) {
            break b;
           }
           v[31601] = 0;
           C = Q(151, b | 0) | 0;
           d = v[31601];
           v[31601] = 0;
           if ((d | 0) != 1) {
            break i;
           }
           break b;
          }
          j: {
           k: {
            l: {
             m: {
              n: {
               o: {
                if (((w[e + 456 | 0] | w[e + 457 | 0] << 8) - 2185 & 65535) >>> 0 > 1910) {
                 break o;
                }
                d = v[b >> 2];
                v[31601] = 0;
                d = Q(154, d | 0) | 0;
                f = v[31601];
                v[31601] = 0;
                if ((f | 0) == 1) {
                 break b;
                }
                v[31601] = 0;
                O(149, b | 0, d - 4 | 0) | 0;
                d = v[31601];
                v[31601] = 0;
                if ((d | 0) == 1) {
                 break b;
                }
                v[31601] = 0;
                C = Q(151, b | 0) | 0;
                d = v[31601];
                v[31601] = 0;
                if ((d | 0) == 1) {
                 break b;
                }
                if (C >>> 0 < 256) {
                 break o;
                }
                d = v[b >> 2];
                v[31601] = 0;
                d = Q(154, d | 0) | 0;
                f = v[31601];
                v[31601] = 0;
                if ((f | 0) == 1) {
                 break b;
                }
                if (d >>> 0 <= C >>> 0) {
                 break o;
                }
                v[31601] = 0;
                d = O(149, b | 0, C | 0) | 0;
                f = v[31601];
                v[31601] = 0;
                if ((f | 0) == 1) {
                 break b;
                }
                if (!d) {
                 break o;
                }
                v[31601] = 0;
                d = Q(418, b | 0) | 0;
                f = v[31601];
                v[31601] = 0;
                if ((f | 0) == 1) {
                 break b;
                }
                if (!d) {
                 break o;
                }
                v[31601] = 0;
                N(417, a | 0, 16777216);
                d = v[31601];
                v[31601] = 0;
                if ((d | 0) == 1) {
                 break b;
                }
                d = w[e + 456 | 0] | w[e + 457 | 0] << 8;
                if (d >>> 0 >= 4096) {
                 v[31601] = 0;
                 c = O(1, e + 160 | 0, 16517) | 0;
                 b = v[31601];
                 v[31601] = 0;
                 if ((b | 0) == 1) {
                  break h;
                 }
                 a = v[a + 1298472 >> 2];
                 v[31601] = 0;
                 R(385, a | 0, 1, c | 0);
                 a = v[31601];
                 v[31601] = 0;
                 if ((a | 0) != 1) {
                  sb(c);
                  f = 0;
                  break d;
                 }
                 b = M() | 0;
                 sb(c);
                 break a;
                }
                if (d >>> 0 < 2194) {
                 break o;
                }
                v[31601] = 0;
                d = O(1, e + 388 | 0, 16046) | 0;
                f = v[31601];
                v[31601] = 0;
                if ((f | 0) == 1) {
                 break n;
                }
                f = v[a + 1298472 >> 2];
                v[31601] = 0;
                R(385, f | 0, 4, d | 0);
                f = v[31601];
                v[31601] = 0;
                if ((f | 0) == 1) {
                 break m;
                }
                sb(d);
               }
               if (v[a + 480180 >> 2] != 32) {
                break i;
               }
               d = w[e + 456 | 0] | w[e + 457 | 0] << 8;
               if ((d & 61440) != 20480) {
                break j;
               }
               d = d & 4095;
               f = d << 16;
               if ((w[e + 476 | 0] | w[e + 477 | 0] << 8 | (w[e + 478 | 0] << 16 | w[e + 479 | 0] << 24)) != 1414548815) {
                break l;
               }
               t[e + 415 | 0] = 1;
               break k;
              }
              b = M() | 0;
              break a;
             }
             b = M() | 0;
             sb(d);
             break a;
            }
            if (d >>> 0 < 297) {
             break k;
            }
            f = w[e + 476 | 0] | w[e + 477 | 0] << 8 | f;
           }
           v[a + 1074308 >> 2] = f;
           break i;
          }
          f = w[e + 458 | 0] | w[e + 459 | 0] << 8;
          if (!((f | 0) != 2184 & (d | 0) != 2184)) {
           t[e + 415 | 0] = 1;
           v[a + 1074308 >> 2] = 18284544;
           break i;
          }
          if ((d | 0) != 768) {
           if ((d | 0) != 532 | (f | 0) != 514 | (w[e + 476 | 0] | w[e + 477 | 0] << 8 | (w[e + 478 | 0] << 16 | w[e + 479 | 0] << 24))) {
            break i;
           }
           v[a + 1074308 >> 2] = 17367040;
           v[31601] = 0;
           d = O(1, e + 376 | 0, 14689) | 0;
           f = v[31601];
           v[31601] = 0;
           if ((f | 0) != 1) {
            yb(k, d);
            sb(d);
            t[e + 415 | 0] = 1;
            break i;
           }
           b = M() | 0;
           break a;
          }
          if (w[e + 476 | 0] | w[e + 477 | 0] << 8 | (w[e + 478 | 0] << 16 | w[e + 479 | 0] << 24) | (f | 0) != 768 | ((w[e + 448 | 0] | w[e + 449 | 0] << 8) != 256 | w[e + 468 | 0] != 128)) {
           break i;
          }
          if (w[e + 469 | 0]) {
           break i;
          }
          v[a + 1074308 >> 2] = 18285088;
          t[e + 415 | 0] = 1;
         }
         d = w[e + 460 | 0] | w[e + 461 | 0] << 8;
         f = d >>> 2 | 0;
         v[a + 480208 >> 2] = d << 3 & 32768 | (f & 8 | (f & 4 | (v[a + 480208 >> 2] & -32797 | d << 1 & 16)));
         f = e + 280 | 0;
         n = e + 420 | 0;
         Yr(f, n);
         v[31601] = 0;
         d = e + 160 | 0;
         N(218, d | 0, f | 0);
         f = v[31601];
         v[31601] = 0;
         if ((f | 0) == 1) {
          break g;
         }
         yb(a + 1298308 | 0, d);
         sb(d);
         if (!(!(w[e + 462 | 0] & 4) | v[a + 1074308 >> 2] - 18285314 >>> 0 > 4276681982)) {
          v[a + 480216 >> 2] = w[e + 446 | 0];
          v[a + 480220 >> 2] = w[e + 447 | 0];
         }
         d = w[e + 464 | 0];
         v[a + 480200 >> 2] = d >>> 0 > 128 ? 256 : d << 1;
         d = w[e + 466 | 0];
         if (d) {
          v[a + 480196 >> 2] = d;
         }
         t[e + 160 | 0] = 31;
         t[e + 280 | 0] = w[e + 467 | 0];
         d = e + 160 | 0;
         f = e + 280 | 0;
         S = a, W = B(w[cf(d, f) | 0], 1e4), v[S + 480204 >> 2] = W;
         t[e + 160 | 0] = w[e + 465 | 0];
         t[e + 280 | 0] = 128;
         S = a, W = w[Pb(d, f) | 0], v[S + 480228 >> 2] = W;
         i = a + 480280 | 0;
         h = e + 480 | 0;
         m = e + 544 | 0;
         f = 0;
         while (1) {
          if ((f | 0) == 64) {
           p: {
            v[31601] = 0;
            O(149, b | 0, 192) | 0;
            d = v[31601];
            v[31601] = 0;
            if ((d | 0) == 1) {
             break b;
            }
            if (v[a + 480180 >> 2] == 16777216) {
             if (((w[e + 456 | 0] | w[e + 457 | 0] << 8) - 2187 & 65535) >>> 0 <= 2) {
              break p;
             }
            }
            d = w[a + 484376 | 0];
            f = v[a + 484360 >> 2];
            v[31601] = 0;
            $(348, Wb(f, d) | 0, b | 0, w[e + 448 | 0] | w[e + 449 | 0] << 8, 255, 254);
            d = v[31601];
            v[31601] = 0;
            if ((d | 0) == 1) {
             break b;
            }
            break e;
           }
          } else {
           g = f + h | 0;
           q: {
            if (w[g | 0] == 255) {
             break q;
            }
            d = i + (f << 5) | 0;
            Ve(d);
            S = d, W = Kd(w[f + m | 0], 0, 64), u[S + 6 >> 1] = W;
            g = t[g | 0];
            if ((g | 0) < 0) {
             v[d >> 2] = v[d >> 2] | 1024;
            }
            g = g & 127;
            if (g >>> 0 <= 64) {
             u[d + 4 >> 1] = g << 2;
             break q;
            }
            if ((g | 0) != 100) {
             break q;
            }
            v[d >> 2] = v[d >> 2] | 256;
           }
           f = f + 1 | 0;
           continue;
          }
          break;
         }
         f = 0;
         v[31601] = 0;
         d = Q(189, b | 0) | 0;
         g = v[31601];
         v[31601] = 0;
         if ((g | 0) == 1) {
          break f;
         }
         if (d) {
          break d;
         }
         v[31601] = 0;
         d = Q(151, b | 0) | 0;
         g = v[31601];
         v[31601] = 0;
         r: {
          if ((g | 0) == 1) {
           break r;
          }
          if (d >>> 0 > 4e3) {
           break d;
          }
          g = w[a + 484376 | 0];
          m = v[a + 484360 >> 2];
          v[31601] = 0;
          d = T(419, Wb(m, g) | 0, b | 0, d | 0) | 0;
          g = v[31601];
          v[31601] = 0;
          if ((g | 0) == 1) {
           break r;
          }
          if (!d) {
           break d;
          }
          break e;
         }
         b = M() | 0;
         break a;
        }
        b = M() | 0;
        break a;
       }
       b = M() | 0;
       break a;
      }
      b = M() | 0;
      break a;
     }
     s = Mb(e + 364 | 0);
     o = Mb(e + 352 | 0);
     f = 0;
     m = Mb(e + 340 | 0);
     v[31601] = 0;
     d = T(420, b | 0, s | 0, w[e + 450 | 0] | w[e + 451 | 0] << 8) | 0;
     g = v[31601];
     v[31601] = 0;
     s: {
      t: {
       u: {
        if ((g | 0) == 1) {
         break u;
        }
        if (!d) {
         break s;
        }
        v[31601] = 0;
        d = T(420, b | 0, o | 0, w[e + 452 | 0] | w[e + 453 | 0] << 8) | 0;
        g = v[31601];
        v[31601] = 0;
        if ((g | 0) == 1) {
         break u;
        }
        if (!d) {
         break s;
        }
        v[31601] = 0;
        d = T(420, b | 0, m | 0, w[e + 454 | 0] | w[e + 455 | 0] << 8) | 0;
        g = v[31601];
        v[31601] = 0;
        if ((g | 0) == 1) {
         break u;
        }
        if (!d) {
         break s;
        }
        v[e + 336 >> 2] = -1;
        S = e, W = vb(v[s >> 2]), v[S + 160 >> 2] = W;
        g = vb(v[s + 4 >> 2]);
        d = v[e + 336 >> 2];
        while (1) {
         f = v[e + 160 >> 2];
         if (Hb(f, g)) {
          f = w[f | 0] | w[f + 1 | 0] << 8 | (w[f + 2 | 0] << 16 | w[f + 3 | 0] << 24);
          if (!(!f | d >>> 0 <= f >>> 0)) {
           v[e + 336 >> 2] = f;
           d = f;
          }
          Xe(e + 160 | 0);
          continue;
         } else {
          S = e, W = vb(v[o >> 2]), v[S + 160 >> 2] = W;
          g = vb(v[o + 4 >> 2]);
          d = v[e + 336 >> 2];
          while (1) {
           f = v[e + 160 >> 2];
           if (Hb(f, g)) {
            f = w[f | 0] | w[f + 1 | 0] << 8 | (w[f + 2 | 0] << 16 | w[f + 3 | 0] << 24);
            if (!(!f | d >>> 0 <= f >>> 0)) {
             v[e + 336 >> 2] = f;
             d = f;
            }
            Xe(e + 160 | 0);
            continue;
           } else {
            S = e, W = vb(v[m >> 2]), v[S + 160 >> 2] = W;
            g = vb(v[m + 4 >> 2]);
            d = v[e + 336 >> 2];
            v: {
             w: {
              x: {
               y: {
                z: {
                 A: {
                  B: {
                   C: {
                    D: {
                     E: {
                      while (1) {
                       f = v[e + 160 >> 2];
                       if (Hb(f, g)) {
                        f = w[f | 0] | w[f + 1 | 0] << 8 | (w[f + 2 | 0] << 16 | w[f + 3 | 0] << 24);
                        if (!(!f | d >>> 0 <= f >>> 0)) {
                         v[e + 336 >> 2] = f;
                         d = f;
                        }
                        Xe(e + 160 | 0);
                        continue;
                       } else {
                        if (t[e + 462 | 0] & 1) {
                         v[e + 160 >> 2] = w[e + 472 | 0] | w[e + 473 | 0] << 8 | (w[e + 474 | 0] << 16 | w[e + 475 | 0] << 24);
                         d = v[Gb(e + 336 | 0, e + 160 | 0) >> 2];
                         v[e + 336 >> 2] = d;
                        }
                        g = 0;
                        if ((w[e + 458 | 0] | w[e + 459 | 0] << 8) != 532) {
                         break D;
                        }
                        f = w[e + 456 | 0] | w[e + 457 | 0] << 8;
                        if (w[e + 447 | 0] | (f ? (f | 0) != 532 : 0) | (w[e + 446 | 0] | w[e + 469 | 0])) {
                         break D;
                        }
                        if (w[e + 460 | 0] & 192 | (w[e + 476 | 0] | w[e + 477 | 0] << 8 | (w[e + 478 | 0] << 16 | w[e + 479 | 0] << 24))) {
                         break D;
                        }
                        if (w[e + 450 | 0] | w[e + 451 | 0] << 8) {
                         break E;
                        }
                        g = w[e + 452 | 0] | w[e + 453 | 0] << 8;
                        if (!g) {
                         break E;
                        }
                        if ((v[b + 8 >> 2] + (nc(v[o >> 2], v[o + 4 >> 2]) << 2) | 0) + 2 >>> 0 > d >>> 0) {
                         break E;
                        }
                       }
                       break;
                      }
                      f = 0;
                      while (1) {
                       d = f & 65535;
                       if (d >>> 0 < (g & 65535) >>> 0) {
                        v[31601] = 0;
                        g = Q(151, b | 0) | 0;
                        j = v[31601];
                        v[31601] = 0;
                        F: {
                         if ((j | 0) != 1) {
                          if (!g) {
                           break F;
                          }
                          Hh(b, (d << 2) + 4 | 0);
                          break E;
                         }
                         b = M() | 0;
                         break t;
                        }
                        f = f + 1 | 0;
                        g = w[e + 452 | 0] | w[e + 453 | 0] << 8;
                        continue;
                       }
                       break;
                      }
                      v[31601] = 0;
                      d = O(1, e + 324 | 0, 14968) | 0;
                      f = v[31601];
                      v[31601] = 0;
                      if ((f | 0) == 1) {
                       break C;
                      }
                      yb(k, d);
                      sb(d);
                     }
                     g = 1;
                     if (w[e + 456 | 0] | w[e + 457 | 0] << 8) {
                      break D;
                     }
                     v[31601] = 0;
                     d = O(1, e + 312 | 0, 15475) | 0;
                     f = v[31601];
                     v[31601] = 0;
                     if ((f | 0) == 1) {
                      break B;
                     }
                     yb(k, d);
                     sb(d);
                    }
                    d = w[e + 462 | 0] | w[e + 463 | 0] << 8;
                    G: {
                     if (d & 2) {
                      v[31601] = 0;
                      f = Q(189, b | 0) | 0;
                      d = v[31601];
                      v[31601] = 0;
                      if ((d | 0) == 1) {
                       break w;
                      }
                      d = v[b + 8 >> 2];
                      j = v[b >> 2];
                      v[31601] = 0;
                      l = d;
                      d = f << 3;
                      j = T(150, j | 0, l | 0, d | 0) | 0;
                      l = v[31601];
                      v[31601] = 0;
                      if ((l | 0) == 1) {
                       break w;
                      }
                      if (!(!j | y[e + 336 >> 2] < d + v[b + 8 >> 2] >>> 0)) {
                       v[31601] = 0;
                       N(421, a + 1298412 | 0, f | 0);
                       d = v[31601];
                       v[31601] = 0;
                       if ((d | 0) == 1) {
                        break w;
                       }
                       S = e, W = vb(v[a + 1298412 >> 2]), v[S + 280 >> 2] = W;
                       j = vb(v[a + 1298416 >> 2]);
                       H: {
                        I: {
                         while (1) {
                          d = v[e + 280 >> 2];
                          if (!Hb(d, j)) {
                           if (!(!f & g)) {
                            break G;
                           }
                           if (!(w[e + 462 | 0] & 4)) {
                            break H;
                           }
                           v[31601] = 0;
                           d = O(1, e + 300 | 0, 15515) | 0;
                           f = v[31601];
                           v[31601] = 0;
                           if ((f | 0) == 1) {
                            break I;
                           }
                           yb(k, d);
                           sb(d);
                           break G;
                          }
                          v[31601] = 0;
                          N(422, b | 0, e + 160 | 0);
                          l = v[31601];
                          v[31601] = 0;
                          if ((l | 0) != 1) {
                           v[d >> 2] = 0;
                           v[d + 4 >> 2] = 0;
                           v[d + 24 >> 2] = 0;
                           v[d + 28 >> 2] = 0;
                           v[d + 8 >> 2] = 0;
                           v[d + 12 >> 2] = 0;
                           v[d + 16 >> 2] = 0;
                           l = w[e + 160 | 0] | w[e + 161 | 0] << 8;
                           if (l | (w[e + 162 | 0] | w[e + 163 | 0] << 8)) {
                            v[d >> 2] = ((l & 65024) >>> 9 | 0) + 1980;
                            S = d, W = Xb((w[e + 160 | 0] | w[e + 161 | 0] << 8) >>> 5 & 15, 1, 12), v[S + 4 >> 2] = W;
                            S = d, W = Xb((w[e + 160 | 0] | w[e + 161 | 0] << 8) & 31, 1, 31), v[S + 8 >> 2] = W;
                            S = d, W = Xb((w[e + 162 | 0] | w[e + 163 | 0] << 8) >>> 11 | 0, 0, 23), v[S + 12 >> 2] = W;
                            S = d, W = Xb((w[e + 162 | 0] | w[e + 163 | 0] << 8) >>> 5 & 63, 0, 59), v[S + 16 >> 2] = W;
                            l = Xb((w[e + 162 | 0] | w[e + 163 | 0] << 8) << 1 & 62, 0, 59);
                            v[d + 24 >> 2] = l;
                            v[d + 28 >> 2] = l >> 31;
                           }
                           v[d + 32 >> 2] = w[e + 164 | 0] | w[e + 165 | 0] << 8 | (w[e + 166 | 0] << 16 | w[e + 167 | 0] << 24);
                           v[e + 280 >> 2] = v[e + 280 >> 2] + 40;
                           continue;
                          }
                          break;
                         }
                         b = M() | 0;
                         break t;
                        }
                        b = M() | 0;
                        break t;
                       }
                       v[31601] = 0;
                       d = O(1, e + 300 | 0, 14990) | 0;
                       f = v[31601];
                       v[31601] = 0;
                       if ((f | 0) != 1) {
                        yb(k, d);
                        sb(d);
                        break G;
                       }
                       b = M() | 0;
                       break t;
                      }
                      Hh(b, 2);
                      break G;
                     }
                     if (g ^ 1 | d >>> 0 > 1) {
                      break G;
                     }
                     v[31601] = 0;
                     d = Q(189, b | 0) | 0;
                     f = v[31601];
                     v[31601] = 0;
                     if ((f | 0) == 1) {
                      break v;
                     }
                     if (!d) {
                      v[31601] = 0;
                      d = O(1, e + 300 | 0, 14968) | 0;
                      f = v[31601];
                      v[31601] = 0;
                      if ((f | 0) != 1) {
                       yb(k, d);
                       sb(d);
                       break G;
                      }
                      b = M() | 0;
                      break t;
                     }
                     Hh(b, 2);
                    }
                    J: {
                     if (!(w[e + 460 | 0] & 128 | w[e + 462 | 0] & 8)) {
                      break J;
                     }
                     v[31601] = 0;
                     d = a + 901404 | 0;
                     f = O(423, b | 0, d | 0) | 0;
                     g = v[31601];
                     v[31601] = 0;
                     if ((g | 0) == 1) {
                      break A;
                     }
                     if (!f) {
                      break J;
                     }
                     ED(d);
                    }
                    if ((w[e + 458 | 0] | w[e + 459 | 0] << 8) >>> 0 <= 531) {
                     lr(a + 901404 | 0);
                    }
                    v[31601] = 0;
                    D = Q(168, e + 280 | 0) | 0;
                    d = v[31601];
                    v[31601] = 0;
                    K: {
                     L: {
                      M: {
                       if ((d | 0) != 1) {
                        v[31601] = 0;
                        f = O(412, b | 0, 13890) | 0;
                        d = v[31601];
                        v[31601] = 0;
                        if ((d | 0) == 1) {
                         break M;
                        }
                        if (f) {
                         v[31601] = 0;
                         g = Q(151, b | 0) | 0;
                         d = v[31601];
                         v[31601] = 0;
                         if ((d | 0) == 1) {
                          break L;
                         }
                         v[31601] = 0;
                         d = e + 260 | 0;
                         R(185, d | 0, b | 0, g | 0);
                         g = v[31601];
                         v[31601] = 0;
                         if ((g | 0) == 1) {
                          break L;
                         }
                         g = gc(e + 160 | 0, d);
                         jd(D, g);
                         tb(g);
                         tb(d);
                        }
                        u[a + 480188 >> 1] = 1;
                        v[31601] = 0;
                        d = O(412, b | 0, 13895) | 0;
                        g = v[31601];
                        v[31601] = 0;
                        if ((g | 0) == 1) {
                         break M;
                        }
                        if (!d) {
                         break y;
                        }
                        v[31601] = 0;
                        d = Q(151, b | 0) | 0;
                        f = v[31601];
                        v[31601] = 0;
                        if ((f | 0) != 1) {
                         v[31601] = 0;
                         R(185, e + 260 | 0, b | 0, d | 0);
                         d = v[31601];
                         v[31601] = 0;
                         if ((d | 0) != 1) {
                          break K;
                         }
                        }
                        b = M() | 0;
                        break x;
                       }
                       b = M() | 0;
                       break t;
                      }
                      b = M() | 0;
                      break x;
                     }
                     b = M() | 0;
                     break x;
                    }
                    f = e + 260 | 0;
                    d = gc(e + 160 | 0, f);
                    tb(f);
                    g = v[d >> 2];
                    v[31601] = 0;
                    g = Q(154, g | 0) | 0;
                    j = v[31601];
                    v[31601] = 0;
                    if ((j | 0) == 1) {
                     break z;
                    }
                    u[e + 260 >> 1] = (g >>> 0) / 20;
                    g = x[Nc(25012, f) >> 1];
                    u[a + 480188 >> 1] = g;
                    f = 0;
                    while (1) {
                     if ((f | 0) == (g | 0)) {
                      tb(d);
                      f = 1;
                      break y;
                     }
                     v[31601] = 0;
                     R(424, d | 0, (i + (f << 5) | 0) + 9 | 0, 20);
                     j = v[31601];
                     v[31601] = 0;
                     if ((j | 0) != 1) {
                      f = f + 1 | 0;
                      continue;
                     }
                     break;
                    }
                    break z;
                   }
                   b = M() | 0;
                   break t;
                  }
                  b = M() | 0;
                  break t;
                 }
                 b = M() | 0;
                 break t;
                }
                b = M() | 0;
                tb(d);
                break x;
               }
               N: {
                O: {
                 P: {
                  Q: {
                   R: {
                    S: {
                     T: {
                      U: {
                       V: {
                        d = v[e + 336 >> 2];
                        g = v[b + 8 >> 2];
                        W: {
                         if (d >>> 0 >= g >>> 0) {
                          d = d - g | 0;
                          break W;
                         }
                         v[31601] = 0;
                         d = Q(202, b | 0) | 0;
                         g = v[31601];
                         v[31601] = 0;
                         if ((g | 0) == 1) {
                          break V;
                         }
                        }
                        v[31601] = 0;
                        g = e + 160 | 0;
                        R(185, g | 0, b | 0, d | 0);
                        d = v[31601];
                        v[31601] = 0;
                        if ((d | 0) == 1) {
                         break V;
                        }
                        G = gc(e + 260 | 0, g);
                        tb(g);
                        v[31601] = 0;
                        d = e + 258 | 0;
                        R(425, d | 0, a | 0, G | 0);
                        g = v[31601];
                        v[31601] = 0;
                        if ((g | 0) == 1) {
                         break U;
                        }
                        H = Ic(d);
                        I = w[e + 258 | 0] != 0 | f;
                        if ((w[e + 456 | 0] | w[e + 457 | 0] << 8) != 535 | (w[e + 458 | 0] | w[e + 459 | 0] << 8) != 512 | (w[H | 0] | (w[e + 476 | 0] | w[e + 477 | 0] << 8 | (w[e + 478 | 0] << 16 | w[e + 479 | 0] << 24)))) {
                         break Q;
                        }
                        X: {
                         if (I) {
                          break X;
                         }
                         f = Wb(v[a + 484360 >> 2], w[a + 484376 | 0]);
                         d = v[f + 4 >> 2];
                         if (!lc(v[f >> 2], d)) {
                          if (x[Fn(d) >> 1] == 65535) {
                           break X;
                          }
                         }
                         if (!rq(h, 255, 64)) {
                          break S;
                         }
                        }
                        v[a + 1074308 >> 2] = 18219008;
                        v[31601] = 0;
                        d = O(1, e + 244 | 0, 14819) | 0;
                        f = v[31601];
                        v[31601] = 0;
                        if ((f | 0) == 1) {
                         break T;
                        }
                        break R;
                       }
                       b = M() | 0;
                       break x;
                      }
                      b = M() | 0;
                      break N;
                     }
                     b = M() | 0;
                     break N;
                    }
                    v[a + 1074308 >> 2] = 18284544;
                    v[31601] = 0;
                    d = O(1, e + 244 | 0, 16868) | 0;
                    f = v[31601];
                    v[31601] = 0;
                    if ((f | 0) == 1) {
                     break P;
                    }
                   }
                   yb(k, d);
                   sb(d);
                   t[e + 415 | 0] = 1;
                  }
                  Y: {
                   if (!(t[e + 462 | 0] & 1) | !(w[e + 470 | 0] | w[e + 471 | 0] << 8)) {
                    break Y;
                   }
                   v[31601] = 0;
                   d = O(149, b | 0, w[e + 472 | 0] | w[e + 473 | 0] << 8 | (w[e + 474 | 0] << 16 | w[e + 475 | 0] << 24)) | 0;
                   f = v[31601];
                   v[31601] = 0;
                   if ((f | 0) == 1) {
                    break O;
                   }
                   if (!d) {
                    break Y;
                   }
                   v[31601] = 0;
                   U(336, a + 1298332 | 0, b | 0, w[e + 470 | 0] | w[e + 471 | 0] << 8, 4);
                   d = v[31601];
                   v[31601] = 0;
                   if ((d | 0) == 1) {
                    break O;
                   }
                  }
                  u[a + 480192 >> 1] = 0;
                  d = 0;
                  if (w[e + 460 | 0] & 4) {
                   u[e + 160 >> 1] = w[e + 450 | 0] | w[e + 451 | 0] << 8;
                   u[e + 100 >> 1] = 255;
                   d = x[Nc(e + 160 | 0, e + 100 | 0) >> 1];
                   u[a + 480192 >> 1] = d;
                  }
                  f = 0;
                  Z: {
                   while (1) {
                    if ((d & 65535) >>> 0 <= f >>> 0) {
                     v[e + 240 >> 2] = 0;
                     f = w[e + 452 | 0] | w[e + 453 | 0] << 8;
                     if (f) {
                      d = xb(v[o >> 2], f - 1 | 0);
                      v[e + 240 >> 2] = (w[d | 0] | w[d + 1 | 0] << 8 | (w[d + 2 | 0] << 16 | w[d + 3 | 0] << 24)) + 80;
                     }
                     u[e + 160 >> 1] = f;
                     u[e + 100 >> 1] = 3999;
                     d = x[Nc(e + 160 | 0, e + 100 | 0) >> 1];
                     u[a + 480190 >> 1] = d;
                     l = c & 2;
                     z = a + 946304 | 0;
                     q = a + 484380 | 0;
                     E = e + 180 | 0;
                     f = 0;
                     j = 0;
                     while (1) {
                      _: {
                       $: {
                        aa: {
                         ba: {
                          ca: {
                           da: {
                            ea: {
                             fa: {
                              ga: {
                               if ((d & 65535) >>> 0 > f >>> 0) {
                                d = xb(v[o >> 2], f);
                                d = w[d | 0] | w[d + 1 | 0] << 8 | (w[d + 2 | 0] << 16 | w[d + 3 | 0] << 24);
                                if (!d) {
                                 break $;
                                }
                                v[31601] = 0;
                                d = O(149, b | 0, d | 0) | 0;
                                g = v[31601];
                                v[31601] = 0;
                                ha: {
                                 ia: {
                                  ja: {
                                   ka: {
                                    la: {
                                     if ((g | 0) == 1) {
                                      break la;
                                     }
                                     if (!d) {
                                      break $;
                                     }
                                     v[31601] = 0;
                                     d = e + 160 | 0;
                                     g = O(426, b | 0, d | 0) | 0;
                                     i = v[31601];
                                     v[31601] = 0;
                                     if ((i | 0) == 1) {
                                      break la;
                                     }
                                     if (!g) {
                                      break $;
                                     }
                                     v[31601] = 0;
                                     i = f + 1 | 0;
                                     g = q + B(i, 104) | 0;
                                     h = O(427, d | 0, g | 0) | 0;
                                     d = v[31601];
                                     v[31601] = 0;
                                     if ((d | 0) == 1) {
                                      break ka;
                                     }
                                     r = e + 148 | 0;
                                     Yr(r, E);
                                     v[31601] = 0;
                                     d = e + 100 | 0;
                                     N(218, d | 0, r | 0);
                                     r = v[31601];
                                     v[31601] = 0;
                                     if ((r | 0) == 1) {
                                      break ja;
                                     }
                                     zc(z + (i << 5) | 0, d);
                                     sb(d);
                                     v[31601] = 0;
                                     h = O(149, b | 0, h | 0) | 0;
                                     r = v[31601];
                                     v[31601] = 0;
                                     if ((r | 0) == 1) {
                                      break ka;
                                     }
                                     if (!h) {
                                      break $;
                                     }
                                     h = x[g + 34 >> 1];
                                     if (!(h & 512)) {
                                      break ia;
                                     }
                                     v[31601] = 0;
                                     d = O(428, b | 0, d | 0) | 0;
                                     i = v[31601];
                                     v[31601] = 0;
                                     if ((i | 0) == 1) {
                                      break ga;
                                     }
                                     if (!d) {
                                      break ha;
                                     }
                                     v[e + 16 >> 2] = w[e + 108 | 0] | w[e + 109 | 0] << 8 | (w[e + 110 | 0] << 16 | w[e + 111 | 0] << 24);
                                     d = w[e + 104 | 0] | w[e + 105 | 0] << 8 | (w[e + 106 | 0] << 16 | w[e + 107 | 0] << 24);
                                     v[e + 8 >> 2] = w[e + 100 | 0] | w[e + 101 | 0] << 8 | (w[e + 102 | 0] << 16 | w[e + 103 | 0] << 24);
                                     v[e + 12 >> 2] = d;
                                     Qk(g, 1, e + 8 | 0);
                                     break ha;
                                    }
                                    b = M() | 0;
                                    break N;
                                   }
                                   b = M() | 0;
                                   break N;
                                  }
                                  b = M() | 0;
                                  break N;
                                 }
                                 if (!(h & 16384)) {
                                  r = w[e + 456 | 0] | w[e + 457 | 0] << 8;
                                  F = e + 100 | 0;
                                  i = w[e + 178 | 0];
                                  j = i & 2;
                                  d = w[e + 206 | 0];
                                  h = Yc(F, j ? 16 : 8, 1, 0, (d ^ -1) & 1);
                                  if (!(!(i & 4) | r >>> 0 < 532)) {
                                   wp(h, 3);
                                  }
                                  ma: {
                                   na: {
                                    if (i & 8) {
                                     i = d & 4 ? 5 : 4;
                                     break na;
                                    }
                                    if (!j) {
                                     i = 10;
                                     if ((d | 0) == 255) {
                                      break na;
                                     }
                                    }
                                    if (d & 2) {
                                     t[h + 2 | 0] = 1;
                                    }
                                    if (d & 4) {
                                     vg(h, 2);
                                    }
                                    if (!(d & 8)) {
                                     break ma;
                                    }
                                    i = 9;
                                    if (!j) {
                                     break ma;
                                    }
                                   }
                                   vg(h, i);
                                  }
                                  if (l) {
                                   j = 0;
                                   v[31601] = 0;
                                   T(215, F | 0, g | 0, b | 0) | 0;
                                   d = v[31601];
                                   v[31601] = 0;
                                   if ((d | 0) != 1) {
                                    break ca;
                                   }
                                   break _;
                                  }
                                  j = 1;
                                  d = w[e + 103 | 0];
                                  if (d >>> 0 > 17) {
                                   break ba;
                                  }
                                  i = 1 << d;
                                  if (!(i & 63503)) {
                                   if (!(i & 198144)) {
                                    break ba;
                                   }
                                   break da;
                                  }
                                  if (w[e + 100 | 0]) {
                                   break da;
                                  }
                                  break ca;
                                 }
                                 v[31601] = 0;
                                 N(429, b | 0, e + 88 | 0);
                                 d = v[31601];
                                 v[31601] = 0;
                                 if ((d | 0) == 1) {
                                  break ea;
                                 }
                                 g = v[e + 88 >> 2];
                                 if (!(!l | !g)) {
                                  d = Eb(e + 100 | 0);
                                  v[31601] = 0;
                                  R(270, b | 0, d | 0, g | 0);
                                  g = v[31601];
                                  v[31601] = 0;
                                  oa: {
                                   pa: {
                                    qa: {
                                     ra: {
                                      sa: {
                                       ta: {
                                        ua: {
                                         if ((g | 0) != 1) {
                                          v[31601] = 0;
                                          g = e + 136 | 0;
                                          N(383, g | 0, 16439);
                                          h = v[31601];
                                          v[31601] = 0;
                                          if ((h | 0) == 1) {
                                           break ua;
                                          }
                                          v[e + 76 >> 2] = i;
                                          v[31601] = 0;
                                          i = e + 124 | 0;
                                          R(258, i | 0, 0, d | 0);
                                          h = v[31601];
                                          v[31601] = 0;
                                          if ((h | 0) == 1) {
                                           break ta;
                                          }
                                          v[31601] = 0;
                                          h = e + 148 | 0;
                                          U(430, h | 0, g | 0, e + 76 | 0, i | 0);
                                          j = v[31601];
                                          v[31601] = 0;
                                          if ((j | 0) == 1) {
                                           break sa;
                                          }
                                          j = v[a + 1298472 >> 2];
                                          v[31601] = 0;
                                          R(385, j | 0, 2, h | 0);
                                          j = v[31601];
                                          v[31601] = 0;
                                          if ((j | 0) == 1) {
                                           break ra;
                                          }
                                          sb(h);
                                          sb(i);
                                          Db(g);
                                          sb(d);
                                          break ha;
                                         }
                                         b = M() | 0;
                                         break oa;
                                        }
                                        b = M() | 0;
                                        break oa;
                                       }
                                       b = M() | 0;
                                       break pa;
                                      }
                                      b = M() | 0;
                                      break qa;
                                     }
                                     b = M() | 0;
                                     sb(e + 148 | 0);
                                    }
                                    sb(e + 124 | 0);
                                   }
                                   Db(e + 136 | 0);
                                  }
                                  sb(d);
                                  break N;
                                 }
                                 v[31601] = 0;
                                 O(183, b | 0, g | 0) | 0;
                                 d = v[31601];
                                 v[31601] = 0;
                                 if ((d | 0) == 1) {
                                  break ea;
                                 }
                                }
                                j = 0;
                                break aa;
                               }
                               u[e + 160 >> 1] = 1;
                               u[e + 100 >> 1] = d;
                               S = a, W = x[qe(e + 160 | 0, e + 100 | 0) >> 1], u[S + 480190 >> 1] = W;
                               if (!((w[e + 456 | 0] | w[e + 457 | 0] << 8) == 516 & A) | (w[e + 458 | 0] | w[e + 459 | 0] << 8) != 512 | (w[e + 462 | 0] | w[e + 463 | 0] << 8 | (w[e + 476 | 0] | w[e + 477 | 0] << 8 | (w[e + 478 | 0] << 16 | w[e + 479 | 0] << 24)))) {
                                break fa;
                               }
                               if (((w[e + 460 | 0] | w[e + 461 | 0] << 8) & 65527) != 21 | w[e + 464 | 0] != 128 | (w[e + 465 | 0] != 48 | w[e + 468 | 0] != 128)) {
                                break fa;
                               }
                               if (w[e + 469 | 0] | (w[e + 470 | 0] | w[e + 471 | 0] << 8)) {
                                break fa;
                               }
                               f = 1;
                               g = 64;
                               while (1) {
                                d = 128;
                                if ((g | 0) == 128) {
                                 while (1) if ((d | 0) == 192) {
                                  d = 20;
                                  while (1) {
                                   if ((d | 0) == 26) {
                                    va: {
                                     if (!(f & 1)) {
                                      break fa;
                                     }
                                     v[31601] = 0;
                                     d = O(1, e + 148 | 0, 9879) | 0;
                                     f = v[31601];
                                     v[31601] = 0;
                                     if ((f | 0) == 1) {
                                      break va;
                                     }
                                     yb(k, d);
                                     sb(d);
                                     break fa;
                                    }
                                   } else {
                                    f = !w[d + n | 0] & f;
                                    d = d + 1 | 0;
                                    continue;
                                   }
                                   break;
                                  }
                                  b = M() | 0;
                                  break N;
                                 } else {
                                  f = w[(e + 416 | 0) + d | 0] == 64 & f;
                                  d = d + 1 | 0;
                                  continue;
                                 }
                                } else {
                                 f = (w[(e + 416 | 0) + g | 0] & 127) == 32 & f;
                                 g = g + 1 | 0;
                                 continue;
                                }
                               }
                              }
                              b = M() | 0;
                              break N;
                             }
                             v[a + 480260 >> 2] = 0;
                             v[a + 480264 >> 2] = 2147483647;
                             f = nc(v[m >> 2], v[m + 4 >> 2]);
                             u[e + 160 >> 1] = f;
                             d = e + 160 | 0;
                             z = x[Nc(d, v[a + 8 >> 2] + 10 | 0) >> 1];
                             u[e + 122 >> 1] = z;
                             wa: {
                              xa: {
                               ya: {
                                za: {
                                 if ((f | 0) != (z | 0)) {
                                  v[31601] = 0;
                                  f = e + 100 | 0;
                                  V(431, f | 0);
                                  g = v[31601];
                                  v[31601] = 0;
                                  if ((g | 0) == 1) {
                                   break wa;
                                  }
                                  g = v[m + 4 >> 2];
                                  i = v[m >> 2];
                                  v[31601] = 0;
                                  S = e, W = nc(i, g), v[S + 136 >> 2] = W;
                                  U(432, d | 0, f | 0, e + 136 | 0, e + 122 | 0);
                                  g = v[31601];
                                  v[31601] = 0;
                                  if ((g | 0) == 1) {
                                   break ya;
                                  }
                                  g = v[a + 1298472 >> 2];
                                  v[31601] = 0;
                                  R(385, g | 0, 2, d | 0);
                                  g = v[31601];
                                  v[31601] = 0;
                                  if ((g | 0) == 1) {
                                   break za;
                                  }
                                  sb(d);
                                  Db(f);
                                 }
                                 if (!(c & 1)) {
                                  u[e + 122 >> 1] = 0;
                                  z = 0;
                                 }
                                 i = 0;
                                 Aa: {
                                  Ba: {
                                   Ca: {
                                    Da: {
                                     Ea: {
                                      Fa: {
                                       Ga: {
                                        Ha: {
                                         Ia: {
                                          Ja: {
                                           Ka: {
                                            La: {
                                             Ma: {
                                              Na: {
                                               Oa: {
                                                Pa: {
                                                 Qa: {
                                                  while (1) {
                                                   Ra: {
                                                    if ((i | 0) == (z | 0)) {
                                                     c = v[e + 240 >> 2];
                                                     if (!c) {
                                                      break Oa;
                                                     }
                                                     v[31601] = 0;
                                                     O(149, b | 0, c | 0) | 0;
                                                     c = v[31601];
                                                     v[31601] = 0;
                                                     if ((c | 0) == 1) {
                                                      break Qa;
                                                     }
                                                     if (!j) {
                                                      break Oa;
                                                     }
                                                     while (1) {
                                                      Sa: {
                                                       c = v[b + 8 >> 2];
                                                       d = v[b >> 2];
                                                       v[31601] = 0;
                                                       c = T(150, d | 0, c | 0, 4) | 0;
                                                       d = v[31601];
                                                       v[31601] = 0;
                                                       if ((d | 0) == 1) {
                                                        break Sa;
                                                       }
                                                       if (!c) {
                                                        break Oa;
                                                       }
                                                       v[31601] = 0;
                                                       c = O(412, b | 0, 13869) | 0;
                                                       d = v[31601];
                                                       v[31601] = 0;
                                                       if ((d | 0) == 1) {
                                                        break Sa;
                                                       }
                                                       Ta: {
                                                        if (!c) {
                                                         v[31601] = 0;
                                                         c = O(412, b | 0, 13874) | 0;
                                                         d = v[31601];
                                                         v[31601] = 0;
                                                         if ((d | 0) == 1) {
                                                          break Sa;
                                                         }
                                                         if (!c) {
                                                          break Ta;
                                                         }
                                                        }
                                                        v[31601] = 0;
                                                        c = Q(151, b | 0) | 0;
                                                        d = v[31601];
                                                        v[31601] = 0;
                                                        if ((d | 0) == 1) {
                                                         break Pa;
                                                        }
                                                        Hh(b, 8);
                                                        if (c & -2139062144) {
                                                         break Ta;
                                                        }
                                                        if (c & 1616928864) {
                                                         break Oa;
                                                        }
                                                       }
                                                       v[31601] = 0;
                                                       c = Q(189, b | 0) | 0;
                                                       d = v[31601];
                                                       v[31601] = 0;
                                                       if ((d | 0) == 1) {
                                                        break Sa;
                                                       }
                                                       v[31601] = 0;
                                                       O(183, b | 0, c | 0) | 0;
                                                       c = v[31601];
                                                       v[31601] = 0;
                                                       if ((c | 0) != 1) {
                                                        continue;
                                                       }
                                                      }
                                                      break;
                                                     }
                                                     b = M() | 0;
                                                     break N;
                                                    }
                                                    Ua: {
                                                     c = xb(v[m >> 2], i);
                                                     c = w[c | 0] | w[c + 1 | 0] << 8 | (w[c + 2 | 0] << 16 | w[c + 3 | 0] << 24);
                                                     Va: {
                                                      if (!c) {
                                                       break Va;
                                                      }
                                                      v[31601] = 0;
                                                      c = O(149, b | 0, c | 0) | 0;
                                                      d = v[31601];
                                                      v[31601] = 0;
                                                      if ((d | 0) == 1) {
                                                       break Na;
                                                      }
                                                      if (!c) {
                                                       break Va;
                                                      }
                                                      v[31601] = 0;
                                                      c = Q(189, b | 0) | 0;
                                                      d = v[31601];
                                                      v[31601] = 0;
                                                      if ((d | 0) == 1) {
                                                       break Aa;
                                                      }
                                                      v[31601] = 0;
                                                      n = Q(189, b | 0) | 0;
                                                      d = v[31601];
                                                      v[31601] = 0;
                                                      if ((d | 0) == 1) {
                                                       break Ba;
                                                      }
                                                      if ((n - 1025 & 65535) >>> 0 < 64512) {
                                                       break Va;
                                                      }
                                                      v[31601] = 0;
                                                      d = O(183, b | 0, 4) | 0;
                                                      f = v[31601];
                                                      v[31601] = 0;
                                                      if ((f | 0) == 1) {
                                                       break Ba;
                                                      }
                                                      if (!d) {
                                                       break Va;
                                                      }
                                                      v[31601] = 0;
                                                      d = e + 100 | 0;
                                                      R(185, d | 0, b | 0, c | 0);
                                                      c = v[31601];
                                                      v[31601] = 0;
                                                      if ((c | 0) == 1) {
                                                       break Ca;
                                                      }
                                                      c = gc(e + 160 | 0, d);
                                                      tb(d);
                                                      d = x[a + 480188 >> 1];
                                                      l = 0;
                                                      v[31601] = 0;
                                                      d = O(433, e + 136 | 0, d | 0) | 0;
                                                      f = v[31601];
                                                      v[31601] = 0;
                                                      if ((f | 0) == 1) {
                                                       break Ea;
                                                      }
                                                      Wa: {
                                                       Xa: while (1) {
                                                        A = l >>> 0 >= n >>> 0;
                                                        while (1) {
                                                         if (A) {
                                                          break Wa;
                                                         }
                                                         f = v[c >> 2];
                                                         v[31601] = 0;
                                                         f = T(150, f | 0, v[e + 168 >> 2], 1) | 0;
                                                         g = v[31601];
                                                         v[31601] = 0;
                                                         if ((g | 0) == 1) {
                                                          break Ua;
                                                         }
                                                         if (!f) {
                                                          break Wa;
                                                         }
                                                         v[31601] = 0;
                                                         f = Q(197, c | 0) | 0;
                                                         g = v[31601];
                                                         v[31601] = 0;
                                                         Ya: {
                                                          if ((g | 0) != 1) {
                                                           f = f << 24 >> 24;
                                                           if (f) {
                                                            break Ya;
                                                           }
                                                           l = l + 1 | 0;
                                                           continue Xa;
                                                          }
                                                          break Ra;
                                                         }
                                                         Za: {
                                                          g = f & 127;
                                                          q = g ? g + 65535 | 0 : 0;
                                                          h = q & 65535;
                                                          if (Sc(v[d >> 2], v[e + 140 >> 2]) >>> 0 > h >>> 0) {
                                                           break Za;
                                                          }
                                                          v[31601] = 0;
                                                          t[e + 100 | 0] = 0;
                                                          R(434, d | 0, h + 1 | 0, e + 100 | 0);
                                                          g = v[31601];
                                                          v[31601] = 0;
                                                          if ((g | 0) != 1) {
                                                           break Za;
                                                          }
                                                          break Ra;
                                                         }
                                                         _a: {
                                                          if ((f | 0) < 0) {
                                                           v[31601] = 0;
                                                           f = Q(197, c | 0) | 0;
                                                           g = v[31601];
                                                           v[31601] = 0;
                                                           if ((g | 0) == 1) {
                                                            break _a;
                                                           }
                                                           S = wb(v[d >> 2], h), W = f, t[S | 0] = W;
                                                          }
                                                          f = wb(v[d >> 2], h);
                                                          g = w[f | 0];
                                                          if (!(!(g & 15) | h >>> 0 < x[a + 480188 >> 1])) {
                                                           u[a + 480188 >> 1] = q + 1;
                                                           g = w[f | 0];
                                                          }
                                                          if (g & 1) {
                                                           v[31601] = 0;
                                                           O(183, c | 0, 1) | 0;
                                                           f = v[31601];
                                                           v[31601] = 0;
                                                           if ((f | 0) == 1) {
                                                            break _a;
                                                           }
                                                           f = wb(v[d >> 2], h);
                                                          }
                                                          if (w[f | 0] & 2) {
                                                           v[31601] = 0;
                                                           O(183, c | 0, 1) | 0;
                                                           f = v[31601];
                                                           v[31601] = 0;
                                                           if ((f | 0) == 1) {
                                                            break _a;
                                                           }
                                                           f = wb(v[d >> 2], h);
                                                          }
                                                          if (w[f | 0] & 4) {
                                                           v[31601] = 0;
                                                           O(183, c | 0, 1) | 0;
                                                           f = v[31601];
                                                           v[31601] = 0;
                                                           if ((f | 0) == 1) {
                                                            break _a;
                                                           }
                                                           f = wb(v[d >> 2], h);
                                                          }
                                                          if (!(w[f | 0] & 8)) {
                                                           continue;
                                                          }
                                                          v[31601] = 0;
                                                          O(183, c | 0, 2) | 0;
                                                          f = v[31601];
                                                          v[31601] = 0;
                                                          if ((f | 0) != 1) {
                                                           continue;
                                                          }
                                                         }
                                                         break;
                                                        }
                                                        break;
                                                       }
                                                       break Ra;
                                                      }
                                                      v[e + 100 >> 2] = v[b + 8 >> 2];
                                                      S = e, W = v[ad(e + 240 | 0, e + 100 | 0) >> 2], v[S + 240 >> 2] = W;
                                                      ec(d);
                                                      tb(c);
                                                     }
                                                     i = i + 1 | 0;
                                                     continue;
                                                    }
                                                   }
                                                   break;
                                                  }
                                                  b = M() | 0;
                                                  ec(d);
                                                  break Da;
                                                 }
                                                 b = M() | 0;
                                                 break N;
                                                }
                                                b = M() | 0;
                                                break N;
                                               }
                                               v[31601] = 0;
                                               E = O(435, a | 0, b | 0) | 0;
                                               c = v[31601];
                                               v[31601] = 0;
                                               if ((c | 0) != 1) {
                                                c = E | w[e + 415 | 0];
                                                t[e + 415 | 0] = c;
                                                if (!(w[H | 0] | !(c & 255))) {
                                                 Uv(a + 1074312 | 0);
                                                 t[a + 1074368 | 0] = 0;
                                                }
                                                v[31601] = 0;
                                                r = aa(436, a | 0, b | 0, 0, e + 415 | 0) | 0;
                                                c = v[31601];
                                                v[31601] = 0;
                                                $a: {
                                                 if ((c | 0) == 1) {
                                                  break $a;
                                                 }
                                                 v[31601] = 0;
                                                 q = a + 484344 | 0;
                                                 N(223, q | 0, z | 0);
                                                 c = v[31601];
                                                 v[31601] = 0;
                                                 if ((c | 0) == 1) {
                                                  break $a;
                                                 }
                                                 L = a + 480183 | 0;
                                                 i = 0;
                                                 while (1) {
                                                  ab: {
                                                   bb: {
                                                    cb: {
                                                     db: {
                                                      eb: {
                                                       fb: {
                                                        gb: {
                                                         hb: {
                                                          ib: {
                                                           jb: {
                                                            kb: {
                                                             lb: {
                                                              mb: {
                                                               nb: {
                                                                ob: {
                                                                 pb: {
                                                                  qb: {
                                                                   rb: {
                                                                    sb: {
                                                                     tb: {
                                                                      if ((i | 0) != (z | 0)) {
                                                                       c = xb(v[m >> 2], i);
                                                                       c = w[c | 0] | w[c + 1 | 0] << 8 | (w[c + 2 | 0] << 16 | w[c + 3 | 0] << 24);
                                                                       if (c) {
                                                                        v[31601] = 0;
                                                                        c = O(149, b | 0, c | 0) | 0;
                                                                        d = v[31601];
                                                                        v[31601] = 0;
                                                                        if ((d | 0) == 1) {
                                                                         break ob;
                                                                        }
                                                                        if (c) {
                                                                         break nb;
                                                                        }
                                                                       }
                                                                       v[31601] = 0;
                                                                       c = T(196, q | 0, i & 65535, 64) | 0;
                                                                       d = v[31601];
                                                                       v[31601] = 0;
                                                                       if ((d | 0) == 1) {
                                                                        break ob;
                                                                       }
                                                                       if (c) {
                                                                        break pb;
                                                                       }
                                                                       u[e + 64 >> 1] = i;
                                                                       v[31601] = 0;
                                                                       c = e + 100 | 0;
                                                                       V(437, c | 0);
                                                                       d = v[31601];
                                                                       v[31601] = 0;
                                                                       if ((d | 0) == 1) {
                                                                        break tb;
                                                                       }
                                                                       v[31601] = 0;
                                                                       d = e + 160 | 0;
                                                                       R(438, d | 0, c | 0, e - -64 | 0);
                                                                       f = v[31601];
                                                                       v[31601] = 0;
                                                                       if ((f | 0) == 1) {
                                                                        break sb;
                                                                       }
                                                                       f = v[a + 1298472 >> 2];
                                                                       v[31601] = 0;
                                                                       R(385, f | 0, 2, d | 0);
                                                                       f = v[31601];
                                                                       v[31601] = 0;
                                                                       if ((f | 0) == 1) {
                                                                        break rb;
                                                                       }
                                                                       sb(d);
                                                                       Db(c);
                                                                      }
                                                                      if (!v[a + 1074308 >> 2]) {
                                                                       f = w[e + 456 | 0] | w[e + 457 | 0] << 8;
                                                                       if ((f | 0) != 2184) {
                                                                        break lb;
                                                                       }
                                                                       v[a + 1074308 >> 2] = 18284544;
                                                                      }
                                                                      if (!zd(v[k + 4 >> 2], w[k + 11 | 0])) {
                                                                       break mb;
                                                                      }
                                                                      v[31601] = 0;
                                                                      c = O(1, e + 100 | 0, 18226) | 0;
                                                                      d = v[31601];
                                                                      v[31601] = 0;
                                                                      if ((d | 0) == 1) {
                                                                       break cb;
                                                                      }
                                                                      f = v[a + 1074308 >> 2];
                                                                      v[31601] = 0;
                                                                      d = e + 76 | 0;
                                                                      N(134, d | 0, f | 0);
                                                                      f = v[31601];
                                                                      v[31601] = 0;
                                                                      if ((f | 0) == 1) {
                                                                       break eb;
                                                                      }
                                                                      v[31601] = 0;
                                                                      f = e + 160 | 0;
                                                                      R(2, f | 0, c | 0, d | 0);
                                                                      g = v[31601];
                                                                      v[31601] = 0;
                                                                      if ((g | 0) == 1) {
                                                                       break fb;
                                                                      }
                                                                      g = yb(k, f);
                                                                      sb(f);
                                                                      sb(d);
                                                                      sb(c);
                                                                      f = v[a + 1074308 >> 2];
                                                                      if ((w[e + 476 | 0] | w[e + 477 | 0] << 8 | (w[e + 478 | 0] << 16 | w[e + 479 | 0] << 24)) == 1414548815) {
                                                                       break kb;
                                                                      }
                                                                      if ((f | 0) != 18284544) {
                                                                       break jb;
                                                                      }
                                                                      f = 18284544;
                                                                      if (!(E | (r | I))) {
                                                                       break ib;
                                                                      }
                                                                      break hb;
                                                                     }
                                                                     b = M() | 0;
                                                                     break N;
                                                                    }
                                                                    b = M() | 0;
                                                                    break qb;
                                                                   }
                                                                   b = M() | 0;
                                                                   sb(e + 160 | 0);
                                                                  }
                                                                  Db(e + 100 | 0);
                                                                  break N;
                                                                 }
                                                                 c = v[q >> 2];
                                                                 v[31601] = 0;
                                                                 N(439, Vb(c, i) | 0, D | 0);
                                                                 c = v[31601];
                                                                 v[31601] = 0;
                                                                 if ((c | 0) != 1) {
                                                                  break ab;
                                                                 }
                                                                }
                                                                b = M() | 0;
                                                                break N;
                                                               }
                                                               v[31601] = 0;
                                                               d = Q(189, b | 0) | 0;
                                                               c = v[31601];
                                                               v[31601] = 0;
                                                               if ((c | 0) == 1) {
                                                                break Fa;
                                                               }
                                                               v[31601] = 0;
                                                               F = Q(189, b | 0) | 0;
                                                               c = v[31601];
                                                               v[31601] = 0;
                                                               if ((c | 0) == 1) {
                                                                break Ga;
                                                               }
                                                               v[31601] = 0;
                                                               c = O(183, b | 0, 4) | 0;
                                                               f = v[31601];
                                                               v[31601] = 0;
                                                               if ((f | 0) == 1) {
                                                                break Ga;
                                                               }
                                                               if (!c) {
                                                                break ab;
                                                               }
                                                               v[31601] = 0;
                                                               c = T(196, q | 0, i & 65535, F | 0) | 0;
                                                               f = v[31601];
                                                               v[31601] = 0;
                                                               if ((f | 0) == 1) {
                                                                break Ga;
                                                               }
                                                               if (!c) {
                                                                break ab;
                                                               }
                                                               v[31601] = 0;
                                                               c = e + 100 | 0;
                                                               R(185, c | 0, b | 0, d | 0);
                                                               d = v[31601];
                                                               v[31601] = 0;
                                                               if ((d | 0) == 1) {
                                                                break Ha;
                                                               }
                                                               l = gc(e + 160 | 0, c);
                                                               tb(c);
                                                               d = v[q >> 2];
                                                               v[31601] = 0;
                                                               N(439, Vb(d, i) | 0, D | 0);
                                                               d = v[31601];
                                                               v[31601] = 0;
                                                               if ((d | 0) == 1) {
                                                                break Ja;
                                                               }
                                                               d = x[a + 480188 >> 1];
                                                               v[31601] = 0;
                                                               n = O(433, e + 124 | 0, d | 0) | 0;
                                                               d = v[31601];
                                                               v[31601] = 0;
                                                               if ((d | 0) == 1) {
                                                                break Ka;
                                                               }
                                                               d = x[a + 480188 >> 1];
                                                               u[e + 104 >> 1] = 0;
                                                               v[31601] = 0;
                                                               v[e + 100 >> 2] = 0;
                                                               j = T(440, e + 88 | 0, d | 0, c | 0) | 0;
                                                               c = v[31601];
                                                               v[31601] = 0;
                                                               if ((c | 0) == 1) {
                                                                break Ma;
                                                               }
                                                               S = e, W = vb(v[Vb(v[q >> 2], i) >> 2]), v[S + 76 >> 2] = W;
                                                               A = 0;
                                                               while (1) {
                                                                ub: {
                                                                 vb: {
                                                                  wb: {
                                                                   xb: {
                                                                    if (A >>> 0 >= F >>> 0) {
                                                                     break xb;
                                                                    }
                                                                    c = v[l >> 2];
                                                                    v[31601] = 0;
                                                                    c = T(150, c | 0, v[e + 168 >> 2], 1) | 0;
                                                                    d = v[31601];
                                                                    v[31601] = 0;
                                                                    if ((d | 0) == 1) {
                                                                     break bb;
                                                                    }
                                                                    if (!c) {
                                                                     break xb;
                                                                    }
                                                                    v[31601] = 0;
                                                                    c = Q(197, l | 0) | 0;
                                                                    d = v[31601];
                                                                    v[31601] = 0;
                                                                    yb: {
                                                                     if ((d | 0) != 1) {
                                                                      c = c << 24 >> 24;
                                                                      if (c) {
                                                                       break yb;
                                                                      }
                                                                      q_(e + 76 | 0, x[a + 480188 >> 1]);
                                                                      A = A + 1 | 0;
                                                                      continue;
                                                                     }
                                                                     break bb;
                                                                    }
                                                                    zb: {
                                                                     d = c & 127;
                                                                     h = d ? d - 1 & 65535 : 0;
                                                                     if (Sc(v[n >> 2], v[e + 128 >> 2]) >>> 0 > h >>> 0) {
                                                                      break zb;
                                                                     }
                                                                     v[31601] = 0;
                                                                     t[e + 100 | 0] = 0;
                                                                     d = h + 1 | 0;
                                                                     f = e + 100 | 0;
                                                                     R(434, n | 0, d | 0, f | 0);
                                                                     g = v[31601];
                                                                     v[31601] = 0;
                                                                     if ((g | 0) == 1) {
                                                                      break bb;
                                                                     }
                                                                     u[e + 104 >> 1] = 0;
                                                                     v[31601] = 0;
                                                                     v[e + 100 >> 2] = 0;
                                                                     R(441, j | 0, d | 0, f | 0);
                                                                     d = v[31601];
                                                                     v[31601] = 0;
                                                                     if ((d | 0) != 1) {
                                                                      break zb;
                                                                     }
                                                                     break bb;
                                                                    }
                                                                    if ((c | 0) < 0) {
                                                                     v[31601] = 0;
                                                                     c = Q(197, l | 0) | 0;
                                                                     d = v[31601];
                                                                     v[31601] = 0;
                                                                     if ((d | 0) == 1) {
                                                                      break bb;
                                                                     }
                                                                     S = wb(v[n >> 2], h), W = c, t[S | 0] = W;
                                                                    }
                                                                    u[e + 104 >> 1] = 0;
                                                                    v[e + 100 >> 2] = 0;
                                                                    d = e + 100 | 0;
                                                                    if (h >>> 0 < x[a + 480188 >> 1]) {
                                                                     d = Xc(v[e + 76 >> 2], h);
                                                                    }
                                                                    g = wb(v[n >> 2], h);
                                                                    f = w[g | 0];
                                                                    if (f & 16) {
                                                                     S = d, W = w[Xc(v[j >> 2], h) | 0], t[S | 0] = W;
                                                                     f = w[g | 0];
                                                                    }
                                                                    if (f & 32) {
                                                                     S = d, W = w[Xc(v[j >> 2], h) + 1 | 0], t[S + 1 | 0] = W;
                                                                     f = w[g | 0];
                                                                    }
                                                                    if (f & 64) {
                                                                     c = Xc(v[j >> 2], h);
                                                                     t[d + 2 | 0] = w[c + 2 | 0];
                                                                     t[d + 4 | 0] = w[c + 4 | 0];
                                                                     f = w[g | 0];
                                                                    }
                                                                    if (f << 24 >> 24 < 0) {
                                                                     c = Xc(v[j >> 2], h);
                                                                     t[d + 3 | 0] = w[c + 3 | 0];
                                                                     t[d + 5 | 0] = w[c + 5 | 0];
                                                                     f = w[g | 0];
                                                                    }
                                                                    if (f & 1) {
                                                                     v[31601] = 0;
                                                                     c = Q(197, l | 0) | 0;
                                                                     f = v[31601];
                                                                     v[31601] = 0;
                                                                     Ab: {
                                                                      Bb: {
                                                                       if ((f | 0) != 1) {
                                                                        c = c << 24 >> 24;
                                                                        c = (((c ^ -1) & 128) >>> 7 | 0) + c | 0;
                                                                        if (!(t[L | 0] & 1)) {
                                                                         break Bb;
                                                                        }
                                                                        f = c;
                                                                        break Ab;
                                                                       }
                                                                       break bb;
                                                                      }
                                                                      f = 253;
                                                                      if ((c - 121 & 255) >>> 0 < 132) {
                                                                       break Ab;
                                                                      }
                                                                      f = (c & 255) != 253 ? c : 0;
                                                                     }
                                                                     t[d | 0] = f;
                                                                     S = Xc(v[j >> 2], h), W = f, t[S | 0] = W;
                                                                     g = wb(v[n >> 2], h);
                                                                    }
                                                                    if (w[g | 0] & 2) {
                                                                     v[31601] = 0;
                                                                     c = Q(197, l | 0) | 0;
                                                                     f = v[31601];
                                                                     v[31601] = 0;
                                                                     if ((f | 0) == 1) {
                                                                      break bb;
                                                                     }
                                                                     t[d + 1 | 0] = c;
                                                                     S = Xc(v[j >> 2], h), W = c, t[S + 1 | 0] = W;
                                                                     g = wb(v[n >> 2], h);
                                                                    }
                                                                    if (!(w[g | 0] & 4)) {
                                                                     break ub;
                                                                    }
                                                                    v[31601] = 0;
                                                                    g = Q(197, l | 0) | 0;
                                                                    c = v[31601];
                                                                    v[31601] = 0;
                                                                    Cb: {
                                                                     Db: {
                                                                      if ((c | 0) != 1) {
                                                                       if (g >>> 0 > 64) {
                                                                        break Db;
                                                                       }
                                                                       t[d + 4 | 0] = g;
                                                                       f = 1;
                                                                       break Cb;
                                                                      }
                                                                      break bb;
                                                                     }
                                                                     if (g << 24 >> 24 <= -64) {
                                                                      f = 2;
                                                                      t[d + 2 | 0] = 2;
                                                                      g = g & 127;
                                                                      t[d + 4 | 0] = g;
                                                                      break vb;
                                                                     }
                                                                     if (g >>> 0 <= 74) {
                                                                      f = 5;
                                                                      t[d + 2 | 0] = 5;
                                                                      g = g - 65 | 0;
                                                                      t[d + 4 | 0] = g;
                                                                      break vb;
                                                                     }
                                                                     if (g >>> 0 <= 84) {
                                                                      f = 6;
                                                                      t[d + 2 | 0] = 6;
                                                                      g = g - 75 | 0;
                                                                      t[d + 4 | 0] = g;
                                                                      break vb;
                                                                     }
                                                                     if (g >>> 0 <= 94) {
                                                                      f = 3;
                                                                      t[d + 2 | 0] = 3;
                                                                      g = g - 85 | 0;
                                                                      t[d + 4 | 0] = g;
                                                                      break vb;
                                                                     }
                                                                     if (g >>> 0 <= 104) {
                                                                      f = 4;
                                                                      t[d + 2 | 0] = 4;
                                                                      g = g - 95 | 0;
                                                                      t[d + 4 | 0] = g;
                                                                      break vb;
                                                                     }
                                                                     if (g >>> 0 <= 114) {
                                                                      f = 13;
                                                                      t[d + 2 | 0] = 13;
                                                                      g = g - 105 | 0;
                                                                      t[d + 4 | 0] = g;
                                                                      break vb;
                                                                     }
                                                                     if (g >>> 0 <= 124) {
                                                                      f = 12;
                                                                      t[d + 2 | 0] = 12;
                                                                      g = g - 115 | 0;
                                                                      t[d + 4 | 0] = g;
                                                                      break vb;
                                                                     }
                                                                     c = g + 63 | 0;
                                                                     if ((c & 255) >>> 0 <= 9) {
                                                                      t[d + 4 | 0] = c;
                                                                      f = 11;
                                                                      t[d + 2 | 0] = 11;
                                                                      g = c;
                                                                      break vb;
                                                                     }
                                                                     c = g + 53 | 0;
                                                                     J = c & 255;
                                                                     if (J >>> 0 <= 9) {
                                                                      t[d + 4 | 0] = c;
                                                                      f = 8;
                                                                      t[d + 2 | 0] = 8;
                                                                      if (!J) {
                                                                       g = 0;
                                                                       break vb;
                                                                      }
                                                                      if (v[a + 1074308 >> 2] - 1 >>> 0 > 18285139) {
                                                                       break wb;
                                                                      }
                                                                      f = 7;
                                                                      t[d + 2 | 0] = 7;
                                                                      break wb;
                                                                     }
                                                                     g = g + 33 | 0;
                                                                     if ((g & 255) >>> 0 >= 10) {
                                                                      g = w[d + 4 | 0];
                                                                      f = w[d + 2 | 0];
                                                                      break vb;
                                                                     }
                                                                     t[d + 4 | 0] = g;
                                                                     f = 15;
                                                                    }
                                                                    t[d + 2 | 0] = f;
                                                                    break vb;
                                                                   }
                                                                   Jk(j);
                                                                   ec(n);
                                                                   tb(l);
                                                                   break ab;
                                                                  }
                                                                  g = c;
                                                                 }
                                                                 c = Xc(v[j >> 2], h);
                                                                 t[c + 4 | 0] = g;
                                                                 t[c + 2 | 0] = f;
                                                                 g = wb(v[n >> 2], h);
                                                                }
                                                                if (!(w[g | 0] & 8)) {
                                                                 continue;
                                                                }
                                                                v[31601] = 0;
                                                                c = e + 52 | 0;
                                                                N(198, c | 0, l | 0);
                                                                f = v[31601];
                                                                v[31601] = 0;
                                                                if ((f | 0) != 1) {
                                                                 CD(d, w[e + 52 | 0], w[Ic(c) | 0], 1);
                                                                 c = Xc(v[j >> 2], h);
                                                                 t[c + 3 | 0] = w[d + 3 | 0];
                                                                 t[c + 5 | 0] = w[d + 5 | 0];
                                                                 continue;
                                                                }
                                                                break;
                                                               }
                                                               break bb;
                                                              }
                                                              f = w[e + 456 | 0] | w[e + 457 | 0] << 8;
                                                             }
                                                             Eb: {
                                                              Fb: {
                                                               Gb: {
                                                                Hb: {
                                                                 Ib: {
                                                                  Jb: {
                                                                   Kb: {
                                                                    Lb: {
                                                                     Mb: {
                                                                      Nb: {
                                                                       Ob: {
                                                                        Pb: {
                                                                         c = f & 65535;
                                                                         switch (c >>> 12 | 0) {
                                                                         case 13:
                                                                          break Jb;

                                                                         case 7:
                                                                          break Kb;

                                                                         case 6:
                                                                          break Lb;

                                                                         case 4:
                                                                          break Mb;

                                                                         case 1:
                                                                          break Ob;

                                                                         case 0:
                                                                          break Pb;

                                                                         default:
                                                                          break gb;
                                                                         }
                                                                        }
                                                                        if (w[H | 0]) {
                                                                         v[31601] = 0;
                                                                         c = O(1, e + 160 | 0, 8340) | 0;
                                                                         d = v[31601];
                                                                         v[31601] = 0;
                                                                         if ((d | 0) != 1) {
                                                                          yb(k, c);
                                                                          sb(c);
                                                                          break gb;
                                                                         }
                                                                         b = M() | 0;
                                                                         break N;
                                                                        }
                                                                        Qb: {
                                                                         Rb: {
                                                                          Sb: {
                                                                           Tb: {
                                                                            Ub: {
                                                                             Vb: {
                                                                              Wb: {
                                                                               Xb: {
                                                                                Yb: {
                                                                                 c = f & 65535;
                                                                                 if ((c | 0) != 532) {
                                                                                  break Yb;
                                                                                 }
                                                                                 d = w[e + 458 | 0] | w[e + 459 | 0] << 8;
                                                                                 if ((d | 0) != 512) {
                                                                                  break Xb;
                                                                                 }
                                                                                 if (w[e + 462 | 0] | w[e + 463 | 0] << 8 | (w[e + 460 | 0] | w[e + 461 | 0] << 8) != 9 | (w[e + 447 | 0] | w[e + 446 | 0])) {
                                                                                  break Yb;
                                                                                 }
                                                                                 if (w[e + 450 | 0] | w[e + 451 | 0] << 8 | ((w[e + 454 | 0] | w[e + 455 | 0] << 8) + 1 | 0) != (w[e + 448 | 0] | w[e + 449 | 0] << 8) | (w[e + 464 | 0] != 128 | w[e + 465 | 0] != 100)) {
                                                                                  break Yb;
                                                                                 }
                                                                                 if (w[e + 466 | 0] != 1 | w[e + 468 | 0] != 128 | (w[e + 469 | 0] | (w[e + 470 | 0] | w[e + 471 | 0] << 8))) {
                                                                                  break Yb;
                                                                                 }
                                                                                 if (w[e + 472 | 0] | w[e + 473 | 0] << 8 | (w[e + 474 | 0] << 16 | w[e + 475 | 0] << 24) | (w[e + 476 | 0] | w[e + 477 | 0] << 8 | (w[e + 478 | 0] << 16 | w[e + 479 | 0] << 24))) {
                                                                                  break Yb;
                                                                                 }
                                                                                 v[31601] = 0;
                                                                                 c = O(1, e + 160 | 0, 9860) | 0;
                                                                                 d = v[31601];
                                                                                 v[31601] = 0;
                                                                                 if ((d | 0) != 1) {
                                                                                  yb(k, c);
                                                                                  sb(c);
                                                                                  break gb;
                                                                                 }
                                                                                 b = M() | 0;
                                                                                 break N;
                                                                                }
                                                                                Zb: {
                                                                                 if ((c | 0) != 514 | (w[e + 458 | 0] | w[e + 459 | 0] << 8) != 512 | (w[e + 447 | 0] | w[e + 446 | 0])) {
                                                                                  break Zb;
                                                                                 }
                                                                                 if (w[e + 476 | 0] | w[e + 477 | 0] << 8 | (w[e + 478 | 0] << 16 | w[e + 479 | 0] << 24)) {
                                                                                  break Zb;
                                                                                 }
                                                                                 c = v[m >> 2];
                                                                                 if (lc(c, v[m + 4 >> 2])) {
                                                                                  break Vb;
                                                                                 }
                                                                                 d = v[o >> 2];
                                                                                 if (lc(d, v[o + 4 >> 2])) {
                                                                                  break Vb;
                                                                                 }
                                                                                 c = xb(c, 0);
                                                                                 g = w[c | 0] | w[c + 1 | 0] << 8 | (w[c + 2 | 0] << 16 | w[c + 3 | 0] << 24);
                                                                                 if (!g) {
                                                                                  break Vb;
                                                                                 }
                                                                                 c = xb(d, 0);
                                                                                 if (g >>> 0 >= (w[c | 0] | w[c + 1 | 0] << 8 | (w[c + 2 | 0] << 16 | w[c + 3 | 0] << 24)) >>> 0) {
                                                                                  break Vb;
                                                                                 }
                                                                                 v[a + 1074308 >> 2] = 16777376;
                                                                                 v[31601] = 0;
                                                                                 c = O(1, e + 160 | 0, 13471) | 0;
                                                                                 d = v[31601];
                                                                                 v[31601] = 0;
                                                                                 if ((d | 0) != 1) {
                                                                                  yb(k, c);
                                                                                  sb(c);
                                                                                  t[e + 415 | 0] = 1;
                                                                                  break gb;
                                                                                 }
                                                                                 b = M() | 0;
                                                                                 break N;
                                                                                }
                                                                                if ((f & 65535) != 532) {
                                                                                 break Wb;
                                                                                }
                                                                                d = w[e + 458 | 0] | w[e + 459 | 0] << 8;
                                                                                if ((d | 0) != 512) {
                                                                                 break Xb;
                                                                                }
                                                                                f = 532;
                                                                                if (w[e + 447 | 0] | w[e + 446 | 0]) {
                                                                                 break Fb;
                                                                                }
                                                                                d = 512;
                                                                                if (w[e + 476 | 0] | w[e + 477 | 0] << 8 | (w[e + 478 | 0] << 16 | w[e + 479 | 0] << 24)) {
                                                                                 break Eb;
                                                                                }
                                                                                _b: {
                                                                                 if (w[e + 462 | 0] & 6) {
                                                                                  $b: {
                                                                                   d = v[s >> 2];
                                                                                   if (nc(d, v[s + 4 >> 2]) >>> 0 < 2) {
                                                                                    break $b;
                                                                                   }
                                                                                   c = xb(d, 1);
                                                                                   f = w[c | 0] | w[c + 1 | 0] << 8 | (w[c + 2 | 0] << 16 | w[c + 3 | 0] << 24);
                                                                                   c = xb(d, 0);
                                                                                   if ((f - (w[c | 0] | w[c + 1 | 0] << 8 | (w[c + 2 | 0] << 16 | w[c + 3 | 0] << 24)) | 0) != 557) {
                                                                                    break $b;
                                                                                   }
                                                                                   v[a + 1074308 >> 2] = 16777394;
                                                                                   v[31601] = 0;
                                                                                   c = O(1, e + 160 | 0, 15194) | 0;
                                                                                   d = v[31601];
                                                                                   v[31601] = 0;
                                                                                   if ((d | 0) != 1) {
                                                                                    break _b;
                                                                                   }
                                                                                   b = M() | 0;
                                                                                   break N;
                                                                                  }
                                                                                  v[a + 1074308 >> 2] = 16777393;
                                                                                  v[31601] = 0;
                                                                                  c = O(1, e + 160 | 0, 13361) | 0;
                                                                                  d = v[31601];
                                                                                  v[31601] = 0;
                                                                                  if ((d | 0) != 1) {
                                                                                   break _b;
                                                                                  }
                                                                                  b = M() | 0;
                                                                                  break N;
                                                                                 }
                                                                                 v[a + 1074308 >> 2] = 16777381;
                                                                                 v[31601] = 0;
                                                                                 c = O(1, e + 160 | 0, 14900) | 0;
                                                                                 d = v[31601];
                                                                                 v[31601] = 0;
                                                                                 if ((d | 0) == 1) {
                                                                                  break Ib;
                                                                                 }
                                                                                }
                                                                                yb(k, c);
                                                                                sb(c);
                                                                                t[e + 415 | 0] = 1;
                                                                                break gb;
                                                                               }
                                                                               f = 532;
                                                                               if ((d | 0) != 532) {
                                                                                break Ub;
                                                                               }
                                                                               if ((w[e + 476 | 0] | w[e + 477 | 0] << 8 | (w[e + 478 | 0] << 16 | w[e + 479 | 0] << 24)) == 1229080643) {
                                                                                v[31601] = 0;
                                                                                c = O(1, e + 160 | 0, 8378) | 0;
                                                                                d = v[31601];
                                                                                v[31601] = 0;
                                                                                if ((d | 0) != 1) {
                                                                                 yb(k, c);
                                                                                 sb(c);
                                                                                 f = a + 1074312 | 0;
                                                                                 d = 38;
                                                                                 break Nb;
                                                                                }
                                                                                b = M() | 0;
                                                                                break N;
                                                                               }
                                                                               if (w[e + 469 | 0] | (w[e + 462 | 0] | w[e + 463 | 0] << 8) >>> 0 > 1 | (w[e + 476 | 0] | w[e + 477 | 0] << 8 | (w[e + 478 | 0] << 16 | w[e + 479 | 0] << 24) | ((w[e + 460 | 0] | w[e + 461 | 0] << 8) & 4294) != 4)) {
                                                                                break Vb;
                                                                               }
                                                                               if (!x[a + 480190 >> 1]) {
                                                                                break Vb;
                                                                               }
                                                                               v[31601] = 0;
                                                                               f = O(36, e + 100 | 0, 13604) | 0;
                                                                               c = v[31601];
                                                                               v[31601] = 0;
                                                                               if ((c | 0) == 1) {
                                                                                break Sb;
                                                                               }
                                                                               c = eb - 32 | 0;
                                                                               eb = c;
                                                                               d = eb - 16 | 0;
                                                                               eb = d;
                                                                               Tw(d + 8 | 0, a + 484527 | 0);
                                                                               kZ(c + 24 | 0, v[d + 8 >> 2], v[d + 12 >> 2]);
                                                                               eb = d + 16 | 0;
                                                                               ee(c + 16 | 0, f);
                                                                               d = v[c + 20 >> 2];
                                                                               v[c + 8 >> 2] = v[c + 16 >> 2];
                                                                               v[c + 12 >> 2] = d;
                                                                               d = Hc(v[c + 24 >> 2], v[c + 28 >> 2], c + 8 | 0);
                                                                               eb = c + 32 | 0;
                                                                               sb(f);
                                                                               if (d) {
                                                                                break Tb;
                                                                               }
                                                                               f = w[e + 456 | 0] | w[e + 457 | 0] << 8;
                                                                              }
                                                                              if (f & 65535) {
                                                                               break Vb;
                                                                              }
                                                                              if (zd(v[k + 4 >> 2], w[k + 11 | 0])) {
                                                                               break Qb;
                                                                              }
                                                                             }
                                                                             d = w[e + 458 | 0] | w[e + 459 | 0] << 8;
                                                                            }
                                                                            if ((d & 65535) >>> 0 > 767) {
                                                                             break gb;
                                                                            }
                                                                            break Eb;
                                                                           }
                                                                           v[31601] = 0;
                                                                           c = O(1, e + 160 | 0, 8404) | 0;
                                                                           d = v[31601];
                                                                           v[31601] = 0;
                                                                           if ((d | 0) == 1) {
                                                                            break Rb;
                                                                           }
                                                                           yb(k, c);
                                                                           sb(c);
                                                                           break gb;
                                                                          }
                                                                          b = M() | 0;
                                                                          break N;
                                                                         }
                                                                         b = M() | 0;
                                                                         break N;
                                                                        }
                                                                        v[31601] = 0;
                                                                        c = O(1, e + 160 | 0, 9750) | 0;
                                                                        d = v[31601];
                                                                        v[31601] = 0;
                                                                        if ((d | 0) != 1) {
                                                                         yb(k, c);
                                                                         sb(c);
                                                                         break gb;
                                                                        }
                                                                        b = M() | 0;
                                                                        break N;
                                                                       }
                                                                       f = w[e + 476 | 0] | w[e + 477 | 0] << 8 | (w[e + 478 | 0] << 16 | w[e + 479 | 0] << 24);
                                                                       v[31601] = 0;
                                                                       d = e + 160 | 0;
                                                                       R(442, d | 0, c | 0, w[e + 476 | 0] | w[e + 477 | 0] << 8 | (w[e + 478 | 0] << 16 | w[e + 479 | 0] << 24));
                                                                       g = v[31601];
                                                                       v[31601] = 0;
                                                                       ac: {
                                                                        bc: {
                                                                         cc: {
                                                                          dc: {
                                                                           ec: {
                                                                            fc: {
                                                                             gc: {
                                                                              hc: {
                                                                               ic: {
                                                                                jc: {
                                                                                 kc: {
                                                                                  lc: {
                                                                                   mc: {
                                                                                    nc: {
                                                                                     if ((g | 0) != 1) {
                                                                                      yb(k, d);
                                                                                      sb(d);
                                                                                      c = (c | 0) == 8191 ? f : c - 4176 | 0;
                                                                                      if ((c | 0) > 1915) {
                                                                                       break nc;
                                                                                      }
                                                                                      d = v[a + 480208 >> 2];
                                                                                      if (!(d & 16)) {
                                                                                       break mc;
                                                                                      }
                                                                                      v[31601] = 0;
                                                                                      O(267, a + 1074312 | 0, 7) | 0;
                                                                                      c = v[31601];
                                                                                      v[31601] = 0;
                                                                                      if ((c | 0) != 1) {
                                                                                       break lc;
                                                                                      }
                                                                                      break Gb;
                                                                                     }
                                                                                     b = M() | 0;
                                                                                     break N;
                                                                                    }
                                                                                    if (c >>> 0 > 4200) {
                                                                                     break jc;
                                                                                    }
                                                                                    d = v[a + 480208 >> 2];
                                                                                   }
                                                                                   if (!(d & 16)) {
                                                                                    v[31601] = 0;
                                                                                    O(267, a + 1074312 | 0, 7) | 0;
                                                                                    d = v[31601];
                                                                                    v[31601] = 0;
                                                                                    if ((d | 0) == 1) {
                                                                                     break Gb;
                                                                                    }
                                                                                   }
                                                                                   if ((c | 0) > 2385) {
                                                                                    break kc;
                                                                                   }
                                                                                  }
                                                                                  v[31601] = 0;
                                                                                  O(267, a + 1074312 | 0, 38) | 0;
                                                                                  c = v[31601];
                                                                                  v[31601] = 0;
                                                                                  if ((c | 0) == 1) {
                                                                                   break Gb;
                                                                                  }
                                                                                 }
                                                                                 v[31601] = 0;
                                                                                 c = O(267, a + 1074312 | 0, 102) | 0;
                                                                                 d = v[31601];
                                                                                 v[31601] = 0;
                                                                                 if ((d | 0) == 1) {
                                                                                  break Gb;
                                                                                 }
                                                                                 v[31601] = 0;
                                                                                 O(267, c | 0, 48) | 0;
                                                                                 c = v[31601];
                                                                                 v[31601] = 0;
                                                                                 if ((c | 0) == 1) {
                                                                                  break Gb;
                                                                                 }
                                                                                 break ic;
                                                                                }
                                                                                if (c >>> 0 > 4383) {
                                                                                 break hc;
                                                                                }
                                                                               }
                                                                               v[31601] = 0;
                                                                               c = T(266, a + 1074312 | 0, 116, 1) | 0;
                                                                               d = v[31601];
                                                                               v[31601] = 0;
                                                                               if ((d | 0) == 1) {
                                                                                break Gb;
                                                                               }
                                                                               v[31601] = 0;
                                                                               O(267, c | 0, 115) | 0;
                                                                               c = v[31601];
                                                                               v[31601] = 0;
                                                                               if ((c | 0) == 1) {
                                                                                break Gb;
                                                                               }
                                                                               break gc;
                                                                              }
                                                                              if (c >>> 0 > 4563) {
                                                                               break fc;
                                                                              }
                                                                             }
                                                                             v[31601] = 0;
                                                                             c = O(267, a + 1074312 | 0, 43) | 0;
                                                                             d = v[31601];
                                                                             v[31601] = 0;
                                                                             if ((d | 0) == 1) {
                                                                              break Gb;
                                                                             }
                                                                             v[31601] = 0;
                                                                             c = O(267, c | 0, 42) | 0;
                                                                             d = v[31601];
                                                                             v[31601] = 0;
                                                                             if ((d | 0) == 1) {
                                                                              break Gb;
                                                                             }
                                                                             v[31601] = 0;
                                                                             O(267, c | 0, 87) | 0;
                                                                             c = v[31601];
                                                                             v[31601] = 0;
                                                                             if ((c | 0) == 1) {
                                                                              break Gb;
                                                                             }
                                                                             break ec;
                                                                            }
                                                                            if (c >>> 0 > 4876) {
                                                                             break dc;
                                                                            }
                                                                           }
                                                                           v[31601] = 0;
                                                                           O(267, a + 1074312 | 0, 120) | 0;
                                                                           c = v[31601];
                                                                           v[31601] = 0;
                                                                           if ((c | 0) == 1) {
                                                                            break Gb;
                                                                           }
                                                                           break cc;
                                                                          }
                                                                          if (c >>> 0 > 5100) {
                                                                           break bc;
                                                                          }
                                                                         }
                                                                         v[31601] = 0;
                                                                         c = O(267, a + 1074312 | 0, 47) | 0;
                                                                         d = v[31601];
                                                                         v[31601] = 0;
                                                                         if ((d | 0) == 1) {
                                                                          break Gb;
                                                                         }
                                                                         v[31601] = 0;
                                                                         O(267, c | 0, 39) | 0;
                                                                         c = v[31601];
                                                                         v[31601] = 0;
                                                                         if ((c | 0) == 1) {
                                                                          break Gb;
                                                                         }
                                                                         break ac;
                                                                        }
                                                                        if (c >>> 0 > 5103) {
                                                                         break gb;
                                                                        }
                                                                       }
                                                                       v[31601] = 0;
                                                                       f = O(267, a + 1074312 | 0, 44) | 0;
                                                                       c = v[31601];
                                                                       v[31601] = 0;
                                                                       d = 87;
                                                                       if ((c | 0) == 1) {
                                                                        break Gb;
                                                                       }
                                                                      }
                                                                      v[31601] = 0;
                                                                      O(267, f | 0, d | 0) | 0;
                                                                      c = v[31601];
                                                                      v[31601] = 0;
                                                                      if ((c | 0) == 1) {
                                                                       break Gb;
                                                                      }
                                                                      break gb;
                                                                     }
                                                                     v[31601] = 0;
                                                                     c = e + 100 | 0;
                                                                     V(443, c | 0);
                                                                     d = v[31601];
                                                                     v[31601] = 0;
                                                                     oc: {
                                                                      pc: {
                                                                       qc: {
                                                                        if ((d | 0) != 1) {
                                                                         d = w[e + 456 | 0] | w[e + 457 | 0] << 8;
                                                                         v[e + 64 >> 2] = d >>> 8 & 15;
                                                                         v[31601] = 0;
                                                                         v[e + 52 >> 2] = d & 255;
                                                                         d = e + 76 | 0;
                                                                         N(444, d | 0, e + 52 | 0);
                                                                         f = v[31601];
                                                                         v[31601] = 0;
                                                                         if ((f | 0) == 1) {
                                                                          break qc;
                                                                         }
                                                                         v[31601] = 0;
                                                                         f = e + 160 | 0;
                                                                         U(430, f | 0, c | 0, e - -64 | 0, d | 0);
                                                                         g = v[31601];
                                                                         v[31601] = 0;
                                                                         if ((g | 0) == 1) {
                                                                          break pc;
                                                                         }
                                                                         yb(k, f);
                                                                         sb(f);
                                                                         sb(d);
                                                                         Db(c);
                                                                         break gb;
                                                                        }
                                                                        b = M() | 0;
                                                                        break N;
                                                                       }
                                                                       b = M() | 0;
                                                                       break oc;
                                                                      }
                                                                      b = M() | 0;
                                                                      sb(e + 76 | 0);
                                                                     }
                                                                     Db(e + 100 | 0);
                                                                     break N;
                                                                    }
                                                                    v[31601] = 0;
                                                                    c = O(1, e + 160 | 0, 8340) | 0;
                                                                    d = v[31601];
                                                                    v[31601] = 0;
                                                                    if ((d | 0) != 1) {
                                                                     yb(k, c);
                                                                     sb(c);
                                                                     break gb;
                                                                    }
                                                                    b = M() | 0;
                                                                    break N;
                                                                   }
                                                                   if (!((c | 0) != 32767 | (w[e + 458 | 0] | w[e + 459 | 0] << 8) != 533)) {
                                                                    v[31601] = 0;
                                                                    c = O(1, e + 160 | 0, 5042) | 0;
                                                                    d = v[31601];
                                                                    v[31601] = 0;
                                                                    if ((d | 0) != 1) {
                                                                     yb(k, c);
                                                                     sb(c);
                                                                     break gb;
                                                                    }
                                                                    b = M() | 0;
                                                                    break N;
                                                                   }
                                                                   v[31601] = 0;
                                                                   c = e + 100 | 0;
                                                                   N(131, c | 0, 4150);
                                                                   d = v[31601];
                                                                   v[31601] = 0;
                                                                   rc: {
                                                                    if ((d | 0) != 1) {
                                                                     d = w[e + 456 | 0] | w[e + 457 | 0] << 8;
                                                                     v[e + 76 >> 2] = d >>> 8 & 15;
                                                                     v[e + 64 >> 2] = d >>> 4 & 15;
                                                                     v[31601] = 0;
                                                                     v[e + 52 >> 2] = d & 15;
                                                                     d = e + 160 | 0;
                                                                     $(132, d | 0, c | 0, e + 76 | 0, e - -64 | 0, e + 52 | 0);
                                                                     f = v[31601];
                                                                     v[31601] = 0;
                                                                     if ((f | 0) == 1) {
                                                                      break rc;
                                                                     }
                                                                     yb(k, d);
                                                                     sb(d);
                                                                     Db(c);
                                                                     break gb;
                                                                    }
                                                                    b = M() | 0;
                                                                    break N;
                                                                   }
                                                                   b = M() | 0;
                                                                   Db(e + 100 | 0);
                                                                   break N;
                                                                  }
                                                                  v[31601] = 0;
                                                                  c = O(1, e + 160 | 0, 6123) | 0;
                                                                  d = v[31601];
                                                                  v[31601] = 0;
                                                                  if ((d | 0) == 1) {
                                                                   break Hb;
                                                                  }
                                                                  yb(k, c);
                                                                  sb(c);
                                                                  break gb;
                                                                 }
                                                                 b = M() | 0;
                                                                 break N;
                                                                }
                                                                b = M() | 0;
                                                                break N;
                                                               }
                                                               b = M() | 0;
                                                               break N;
                                                              }
                                                              d = 512;
                                                             }
                                                             if (!zd(v[k + 4 >> 2], w[k + 11 | 0])) {
                                                              break gb;
                                                             }
                                                             sc: {
                                                              tc: {
                                                               uc: {
                                                                vc: {
                                                                 wc: {
                                                                  if ((d & 65535) >>> 0 >= 533) {
                                                                   v[31601] = 0;
                                                                   c = O(1, e + 76 | 0, 14932) | 0;
                                                                   d = v[31601];
                                                                   v[31601] = 0;
                                                                   if ((d | 0) != 1) {
                                                                    yb(k, c);
                                                                    sb(c);
                                                                    break wc;
                                                                   }
                                                                   b = M() | 0;
                                                                   break N;
                                                                  }
                                                                  if ((f & 65535) >>> 0 >= 533) {
                                                                   v[31601] = 0;
                                                                   c = e + 76 | 0;
                                                                   N(445, c | 0, 4015);
                                                                   d = v[31601];
                                                                   v[31601] = 0;
                                                                   xc: {
                                                                    if ((d | 0) != 1) {
                                                                     v[31601] = 0;
                                                                     v[e + 64 >> 2] = (w[e + 456 | 0] | w[e + 457 | 0] << 8) - 532;
                                                                     d = e + 160 | 0;
                                                                     R(446, d | 0, c | 0, e - -64 | 0);
                                                                     f = v[31601];
                                                                     v[31601] = 0;
                                                                     if ((f | 0) == 1) {
                                                                      break xc;
                                                                     }
                                                                     yb(k, d);
                                                                     sb(d);
                                                                     Db(c);
                                                                     break wc;
                                                                    }
                                                                    b = M() | 0;
                                                                    break N;
                                                                   }
                                                                   b = M() | 0;
                                                                   Db(e + 76 | 0);
                                                                   break N;
                                                                  }
                                                                  v[31601] = 0;
                                                                  c = e + 76 | 0;
                                                                  N(268, c | 0, 4314);
                                                                  d = v[31601];
                                                                  v[31601] = 0;
                                                                  if ((d | 0) == 1) {
                                                                   break vc;
                                                                  }
                                                                  d = w[e + 456 | 0] | w[e + 457 | 0] << 8;
                                                                  v[e + 52 >> 2] = d >>> 8 & 15;
                                                                  v[31601] = 0;
                                                                  v[e + 40 >> 2] = d & 255;
                                                                  d = e - -64 | 0;
                                                                  N(444, d | 0, e + 40 | 0);
                                                                  f = v[31601];
                                                                  v[31601] = 0;
                                                                  if ((f | 0) == 1) {
                                                                   break uc;
                                                                  }
                                                                  v[31601] = 0;
                                                                  f = e + 160 | 0;
                                                                  U(430, f | 0, c | 0, e + 52 | 0, d | 0);
                                                                  g = v[31601];
                                                                  v[31601] = 0;
                                                                  if ((g | 0) == 1) {
                                                                   break tc;
                                                                  }
                                                                  yb(k, f);
                                                                  sb(f);
                                                                  sb(d);
                                                                  Db(c);
                                                                 }
                                                                 if (!lc(v[a + 1298412 >> 2], v[a + 1298416 >> 2])) {
                                                                  break gb;
                                                                 }
                                                                 c = w[e + 476 | 0] | w[e + 477 | 0] << 8 | (w[e + 478 | 0] << 16 | w[e + 479 | 0] << 24);
                                                                 if (!c) {
                                                                  break gb;
                                                                 }
                                                                 c = GF(w[e + 456 | 0] | w[e + 457 | 0] << 8, c);
                                                                 d = kp(e + 160 | 0);
                                                                 v[d + 32 >> 2] = c;
                                                                 v[31601] = 0;
                                                                 N(447, a + 1298412 | 0, d | 0);
                                                                 c = v[31601];
                                                                 v[31601] = 0;
                                                                 if ((c | 0) != 1) {
                                                                  break gb;
                                                                 }
                                                                 b = M() | 0;
                                                                 break N;
                                                                }
                                                                b = M() | 0;
                                                                break N;
                                                               }
                                                               b = M() | 0;
                                                               break sc;
                                                              }
                                                              b = M() | 0;
                                                              sb(e - -64 | 0);
                                                             }
                                                             Db(e + 76 | 0);
                                                             break N;
                                                            }
                                                            if (!(E | (r | (f | 0) != 18284544 | I))) {
                                                             break ib;
                                                            }
                                                            break hb;
                                                           }
                                                           if (((w[e + 456 | 0] | w[e + 457 | 0] << 8) & 61440) != 20480) {
                                                            break hb;
                                                           }
                                                          }
                                                          v[31601] = 0;
                                                          c = O(1, e + 160 | 0, 16880) | 0;
                                                          d = v[31601];
                                                          v[31601] = 0;
                                                          yc: {
                                                           if ((d | 0) != 1) {
                                                            v[31601] = 0;
                                                            O(74, g | 0, c | 0) | 0;
                                                            d = v[31601];
                                                            v[31601] = 0;
                                                            if ((d | 0) == 1) {
                                                             break yc;
                                                            }
                                                            sb(c);
                                                            break gb;
                                                           }
                                                           b = M() | 0;
                                                           break N;
                                                          }
                                                          b = M() | 0;
                                                          sb(c);
                                                          break N;
                                                         }
                                                         if (!SG(f)) {
                                                          break gb;
                                                         }
                                                         v[31601] = 0;
                                                         c = O(1, e + 160 | 0, 17116) | 0;
                                                         d = v[31601];
                                                         v[31601] = 0;
                                                         zc: {
                                                          if ((d | 0) != 1) {
                                                           v[31601] = 0;
                                                           O(74, g | 0, c | 0) | 0;
                                                           d = v[31601];
                                                           v[31601] = 0;
                                                           if ((d | 0) == 1) {
                                                            break zc;
                                                           }
                                                           sb(c);
                                                           break gb;
                                                          }
                                                          b = M() | 0;
                                                          break N;
                                                         }
                                                         b = M() | 0;
                                                         sb(c);
                                                         break N;
                                                        }
                                                        Ac: {
                                                         Bc: {
                                                          Cc: {
                                                           Dc: {
                                                            Ec: {
                                                             Fc: {
                                                              Gc: {
                                                               Hc: {
                                                                Ic: {
                                                                 if (K & 1) {
                                                                  v[31601] = 0;
                                                                  c = O(1, e - -64 | 0, 17130) | 0;
                                                                  d = v[31601];
                                                                  v[31601] = 0;
                                                                  if ((d | 0) == 1) {
                                                                   break Ic;
                                                                  }
                                                                  v[31601] = 0;
                                                                  O(74, k | 0, c | 0) | 0;
                                                                  d = v[31601];
                                                                  v[31601] = 0;
                                                                  if ((d | 0) == 1) {
                                                                   break Hc;
                                                                  }
                                                                  sb(c);
                                                                 }
                                                                 f = v[a + 480180 >> 2];
                                                                 if (!((f | 0) != 16777216 | (w[e + 456 | 0] | w[e + 457 | 0] << 8) >>> 0 < 2186)) {
                                                                  v[31601] = 0;
                                                                  c = O(149, b | 0, C | 0) | 0;
                                                                  d = v[31601];
                                                                  v[31601] = 0;
                                                                  if ((d | 0) == 1) {
                                                                   break $a;
                                                                  }
                                                                  if (c) {
                                                                   v[31601] = 0;
                                                                   R(448, a | 0, b | 0, w[e + 456 | 0] | w[e + 457 | 0] << 8);
                                                                   b = v[31601];
                                                                   v[31601] = 0;
                                                                   if ((b | 0) == 1) {
                                                                    break $a;
                                                                   }
                                                                  }
                                                                  f = v[a + 480180 >> 2];
                                                                 }
                                                                 if ((f | 0) != 16777216) {
                                                                  break Gc;
                                                                 }
                                                                 v[31601] = 0;
                                                                 O(1, e + 52 | 0, 13852) | 0;
                                                                 b = v[31601];
                                                                 v[31601] = 0;
                                                                 if ((b | 0) != 1) {
                                                                  break Fc;
                                                                 }
                                                                 b = M() | 0;
                                                                 break N;
                                                                }
                                                                b = M() | 0;
                                                                break N;
                                                               }
                                                               b = M() | 0;
                                                               sb(c);
                                                               break N;
                                                              }
                                                              v[31601] = 0;
                                                              b = e + 40 | 0;
                                                              N(268, b | 0, 4314);
                                                              c = v[31601];
                                                              v[31601] = 0;
                                                              if ((c | 0) == 1) {
                                                               break Ec;
                                                              }
                                                              c = w[e + 458 | 0] | w[e + 459 | 0] << 8;
                                                              v[e + 36 >> 2] = c >>> 8;
                                                              v[31601] = 0;
                                                              v[e + 20 >> 2] = c & 255;
                                                              c = e + 24 | 0;
                                                              N(444, c | 0, e + 20 | 0);
                                                              d = v[31601];
                                                              v[31601] = 0;
                                                              if ((d | 0) == 1) {
                                                               break Dc;
                                                              }
                                                              v[31601] = 0;
                                                              U(430, e + 52 | 0, b | 0, e + 36 | 0, c | 0);
                                                              b = v[31601];
                                                              v[31601] = 0;
                                                              if ((b | 0) == 1) {
                                                               break Cc;
                                                              }
                                                             }
                                                             b = e + 52 | 0;
                                                             yb(a + 1298344 | 0, b);
                                                             sb(b);
                                                             if ((f | 0) != 16777216) {
                                                              sb(e + 24 | 0);
                                                              Db(e + 40 | 0);
                                                             }
                                                             b = v[a + 480180 >> 2];
                                                             v[31601] = 0;
                                                             b = O(1, e + 52 | 0, ((b | 0) == 16777216 ? 10124 : 6127) | 0) | 0;
                                                             c = v[31601];
                                                             v[31601] = 0;
                                                             f = 1;
                                                             if ((c | 0) == 1) {
                                                              break Ac;
                                                             }
                                                             yb(a + 1298356 | 0, b);
                                                             sb(b);
                                                             yb(a + 1298368 | 0, k);
                                                             S = a, W = v[Ec(e + 36 | 0, v[a + 1074308 >> 2] ? 22 : 4) >> 2], v[S + 1298404 >> 2] = W;
                                                             v[a + 1298408 >> 2] = 0;
                                                             tb(G);
                                                             tb(D);
                                                             break s;
                                                            }
                                                            b = M() | 0;
                                                            break N;
                                                           }
                                                           b = M() | 0;
                                                           break Bc;
                                                          }
                                                          b = M() | 0;
                                                          sb(e + 24 | 0);
                                                         }
                                                         Db(e + 40 | 0);
                                                         break N;
                                                        }
                                                        b = M() | 0;
                                                        break N;
                                                       }
                                                       b = M() | 0;
                                                       sb(e + 76 | 0);
                                                       break db;
                                                      }
                                                      b = M() | 0;
                                                     }
                                                     sb(c);
                                                     break N;
                                                    }
                                                    b = M() | 0;
                                                    break N;
                                                   }
                                                   b = M() | 0;
                                                   Jk(j);
                                                   break La;
                                                  }
                                                  i = i + 1 | 0;
                                                  continue;
                                                 }
                                                }
                                                b = M() | 0;
                                                break N;
                                               }
                                               b = M() | 0;
                                               break N;
                                              }
                                              b = M() | 0;
                                              break N;
                                             }
                                             b = M() | 0;
                                            }
                                            ec(n);
                                            break Ia;
                                           }
                                           b = M() | 0;
                                           break Ia;
                                          }
                                          b = M() | 0;
                                         }
                                         tb(l);
                                         break N;
                                        }
                                        b = M() | 0;
                                        break N;
                                       }
                                       b = M() | 0;
                                       break N;
                                      }
                                      b = M() | 0;
                                      break N;
                                     }
                                     b = M() | 0;
                                    }
                                    tb(c);
                                    break N;
                                   }
                                   b = M() | 0;
                                   break N;
                                  }
                                  b = M() | 0;
                                  break N;
                                 }
                                 b = M() | 0;
                                 break N;
                                }
                                b = M() | 0;
                                sb(e + 160 | 0);
                                break xa;
                               }
                               b = M() | 0;
                              }
                              Db(e + 100 | 0);
                              break N;
                             }
                             b = M() | 0;
                             break N;
                            }
                            b = M() | 0;
                            break N;
                           }
                           j = 0;
                           d = BD(e + 100 | 0, v[g >> 2]);
                           v[31601] = 0;
                           O(183, b | 0, d | 0) | 0;
                           d = v[31601];
                           v[31601] = 0;
                           if ((d | 0) == 1) {
                            break _;
                           }
                          }
                          d = w[e + 103 | 0];
                          if (!v[g >> 2] | (d | 0) != 1) {
                           break ba;
                          }
                          A = 1;
                          break aa;
                         }
                         K = (d | 0) == 10 | K;
                        }
                        v[e + 100 >> 2] = v[b + 8 >> 2];
                        S = e, W = v[ad(e + 240 | 0, e + 100 | 0) >> 2], v[S + 240 >> 2] = W;
                       }
                       f = f + 1 | 0;
                       d = x[a + 480190 >> 1];
                       continue;
                      }
                      break;
                     }
                     b = M() | 0;
                     break N;
                    }
                    Jc: {
                     d = xb(v[s >> 2], f);
                     d = w[d | 0] | w[d + 1 | 0] << 8 | (w[d + 2 | 0] << 16 | w[d + 3 | 0] << 24);
                     Kc: {
                      if (!d) {
                       break Kc;
                      }
                      v[31601] = 0;
                      d = O(149, b | 0, d | 0) | 0;
                      g = v[31601];
                      v[31601] = 0;
                      if ((g | 0) == 1) {
                       break Jc;
                      }
                      if (!d) {
                       break Kc;
                      }
                      d = v[b + 8 >> 2];
                      g = v[b >> 2];
                      v[31601] = 0;
                      d = T(150, g | 0, d | 0, 554) | 0;
                      g = v[31601];
                      v[31601] = 0;
                      if ((g | 0) == 1) {
                       break Jc;
                      }
                      if (!d) {
                       break Kc;
                      }
                      v[31601] = 0;
                      d = T(251, a | 0, f + 1 & 65535, 0) | 0;
                      g = v[31601];
                      v[31601] = 0;
                      if ((g | 0) == 1) {
                       break Z;
                      }
                      if (!d) {
                       break Kc;
                      }
                      v[31601] = 0;
                      U(449, a | 0, b | 0, d | 0, w[e + 458 | 0] | w[e + 459 | 0] << 8);
                      g = v[31601];
                      v[31601] = 0;
                      if ((g | 0) == 1) {
                       break Z;
                      }
                      t[d + 33 | 0] = w[e + 469 | 0];
                     }
                     f = f + 1 | 0;
                     d = x[a + 480192 >> 1];
                     continue;
                    }
                    break;
                   }
                   b = M() | 0;
                   break N;
                  }
                  b = M() | 0;
                  break N;
                 }
                 b = M() | 0;
                 break N;
                }
                b = M() | 0;
               }
               tb(G);
              }
              tb(D);
              break t;
             }
             b = M() | 0;
             break t;
            }
            b = M() | 0;
            break t;
           }
          }
         }
        }
       }
       b = M() | 0;
      }
      uc(m);
      uc(o);
      uc(s);
      break a;
     }
     uc(m);
     uc(o);
     uc(s);
    }
    sb(k);
   }
   eb = e + 608 | 0;
   return f | 0;
  }
  b = M() | 0;
 }
 sb(k);
 P(b | 0);
 p();
}

function GM(a, b, c) {
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, q = 0, r = 0, s = 0, A = 0, E = 0, F = 0, G = 0, H = 0, I = 0, J = 0, K = 0, L = 0, O = 0, Q = 0, S = 0, T = 0, U = 0, V = C(0), W = 0, X = 0, Y = 0, Z = 0, _ = 0, $ = 0, aa = 0, ba = 0, ca = 0, da = 0, ea = 0, fa = 0, ga = 0, ha = 0, ia = 0, ja = 0, ka = 0, la = 0, ma = 0, na = 0, oa = 0, pa = 0, qa = C(0), ra = 0, sa = 0, ta = 0, ua = 0, va = 0, wa = 0, xa = 0, ya = 0, za = 0, Aa = 0, Ba = 0, Ca = 0, Da = 0, Ea = C(0), Fa = 0;
 aa = eb - 32 | 0;
 eb = aa;
 ba = aa + 28 | 0;
 v[ba >> 2] = 48804;
 v[ba >> 2] = 48704;
 e = EB(aa + 20 | 0);
 f = EB(aa + 12 | 0);
 ca = b;
 ga = c;
 ha = v[e >> 2];
 sa = w[e + 4 | 0];
 ia = v[f >> 2];
 ta = w[f + 4 | 0];
 b = 0;
 F = eb - 96 | 0;
 eb = F;
 d = a;
 ja = a + 24604 | 0;
 a = ja;
 a: {
  if (!v[a + 16 >> 2]) {
   break a;
  }
  c = v[a + 20 >> 2];
  if (c >>> 0 > 4 | !(1 << c & 22)) {
   break a;
  }
  a = v[a + 28 >> 2];
  if (a >>> 0 > 4) {
   break a;
  }
  b = 23 >>> a & 1;
 }
 if (!b) {
  a = F + 80 | 0;
  bS(a, 9133, 13070, 221, 45);
  b = eb - 48 | 0;
  eb = b;
  c = tc(b + 24 | 0, 18355);
  v[31601] = 0;
  f = b + 12 | 0;
  N(883, f | 0, 17431);
  e = v[31601];
  v[31601] = 0;
  b: {
   c: {
    d: {
     e: {
      if ((e | 0) != 1) {
       v[31601] = 0;
       e = b + 36 | 0;
       R(2, e | 0, c | 0, f | 0);
       f = v[31601];
       v[31601] = 0;
       if ((f | 0) == 1) {
        break e;
       }
       v[31601] = 0;
       R(884, a | 0, 1, e | 0);
       a = v[31601];
       v[31601] = 0;
       if ((a | 0) != 1) {
        break b;
       }
       a = M() | 0;
       sb(e);
       break d;
      }
      a = M() | 0;
      break c;
     }
     a = M() | 0;
    }
    sb(b + 12 | 0);
   }
   sb(c);
   P(a | 0);
   p();
  }
  sb(b + 36 | 0);
  sb(b + 12 | 0);
  sb(c);
  eb = b + 48 | 0;
 }
 ka = d + 8204 | 0;
 la = d + 397452 | 0;
 ma = d + 397448 | 0;
 Z = d + 393352 | 0;
 A = d + 397456 | 0;
 W = d + 12 | 0;
 ua = d + 16396 | 0;
 va = d + 1074376 | 0;
 while (1) {
  f: {
   g: {
    b = v[d + 480208 >> 2];
    if (!(!ca | b & 512)) {
     h: {
      if (v[d + 1074380 >> 2]) {
       break h;
      }
      a = b | 512;
      i: {
       if (b & 256) {
        break i;
       }
       n = eb - 48 | 0;
       eb = n;
       s = eb - 32 | 0;
       eb = s;
       l = d + 1074312 | 0;
       h = d + 1074992 | 0;
       j = d + 1298264 | 0;
       o = d + 1074424 | 0;
       G = d + 484360 | 0;
       m = d + 1074448 | 0;
       q = d + 1074376 | 0;
       a = v[d + 1074392 >> 2];
       Q = d + 480210 | 0;
       j: {
        k: while (1) {
         l: {
          a = a + 1 | 0;
          v[d + 1074392 >> 2] = a;
          if (Hl(q) >>> 0 > a >>> 0) {
           break l;
          }
          xT(s + 30 | 0, v[d + 480180 >> 2], x[d + 480188 >> 1], q, (v[d + 480208 >> 2] & 524288) >>> 19 | 0);
          m: {
           n: {
            o: {
             p: {
              r = v[d + 480208 >> 2];
              if (r & 32) {
               e = v[d + 484348 >> 2];
               g = v[d + 484344 >> 2];
               b = x[d + 1074446 >> 1];
               break p;
              }
              b = 65535;
              I = Wb(v[d + 484360 >> 2], w[d + 484376 | 0]);
              i = v[I >> 2];
              H = v[I + 4 >> 2];
              f = _c(i, H);
              a = x[d + 1074448 >> 1];
              if (f >>> 0 > a >>> 0) {
               b = x[$b(i, a) >> 1];
              }
              u[d + 1074446 >> 1] = b;
              q: {
               r: {
                c = b & 65535;
                g = v[d + 484344 >> 2];
                e = v[d + 484348 >> 2];
                J = Xj(g, e);
                if (c >>> 0 >= J >>> 0) {
                 break r;
                }
                c = Vb(g, c);
                if (Hb(v[c >> 2], v[c + 4 >> 2])) {
                 break r;
                }
                c = 0;
                break q;
               }
               c = 1;
              }
              while (1) {
               if (!c) {
                b = 65534;
                u[d + 1074446 >> 1] = 65534;
                c = 1;
                continue;
               }
               c = x[I + 28 >> 1];
               while (1) {
                s: {
                 t: {
                  u: {
                   k = b & 65535;
                   if (k >>> 0 >= J >>> 0) {
                    b = a & 65535;
                    if (!((k | 0) != 65535 & f >>> 0 > b >>> 0)) {
                     if (c) {
                      a = c;
                      k = _c(i, H);
                      break t;
                     }
                     if (!(a & 65535) | b >>> 0 > f >>> 0) {
                      break u;
                     }
                     while (1) {
                      a = b;
                      b = a - 1 | 0;
                      if (!b) {
                       break u;
                      }
                      if (x[$b(i, b) >> 1] != 65535) {
                       continue;
                      }
                      break;
                     }
                     k = f;
                     break t;
                    }
                    a = a + 1 | 0;
                    u[m >> 1] = a;
                    b = a & 65535;
                    break s;
                   }
                   u[d + 1074450 >> 1] = a;
                   break p;
                  }
                  a = 0;
                  k = f;
                 }
                 u[d + 1074448 >> 1] = a;
                 r = r & -524289;
                 v[d + 480208 >> 2] = r;
                 while (1) {
                  b = a & 65535;
                  if (k >>> 0 <= b >>> 0) {
                   break o;
                  }
                  if (x[$b(i, b) >> 1] == 65534) {
                   a = a + 1 | 0;
                   u[m >> 1] = a;
                   continue;
                  }
                  break;
                 }
                 if (!Vi(I, a & 65535)) {
                  break o;
                 }
                }
                if (b >>> 0 >= f >>> 0) {
                 b = 65535;
                 u[d + 1074446 >> 1] = 65535;
                 continue;
                }
                b = x[$b(i, b) >> 1];
                u[d + 1074446 >> 1] = b;
                if (b >>> 0 >= J >>> 0) {
                 continue;
                }
                k = Vb(g, b);
                if (Hb(v[k >> 2], v[k + 4 >> 2])) {
                 continue;
                }
                break;
               }
               c = 0;
               continue;
              }
             }
             b = b & 65535;
             if (!Ie(g, e, b)) {
              break n;
             }
             a = v[o >> 2];
             if (a >>> 0 >= y[Vb(g, b) + 12 >> 2]) {
              v[o >> 2] = 0;
              a = 0;
             }
             if (r & 32 ? v[d + 480272 >> 2] != -1 : 0) {
              break m;
             }
             if (!Zu(j, x[m >> 1], a, Jq(s + 20 | 0, h), w[s + 30 | 0])) {
              break m;
             }
             a = v[d + 480272 >> 2];
             if (a) {
              if ((a | 0) > 0) {
               v[d + 480272 >> 2] = a - 1;
              }
              Lo(j, 1);
              Zu(j, x[m >> 1], v[o >> 2], Jq(s + 20 | 0, h), w[s + 30 | 0]);
              break m;
             }
             if (!(w[Q | 0] & 64)) {
              break o;
             }
             if (!Yu(j, m, o)) {
              v[d + 1074424 >> 2] = 0;
              v[d + 1074428 >> 2] = 0;
              v[d + 1074448 >> 2] = 0;
              b = Fj(v[d + 484360 >> 2], v[d + 484364 >> 2]) - 1 | 0;
              a = w[d + 484376 | 0];
              if ((b | 0) <= (a | 0)) {
               Vj(G, 0);
               break o;
              }
              Vj(G, a + 1 & 255);
              Lo(j, 1);
             }
             a = 0;
             while (1) if ((a | 0) == 256) {
              TR(d);
              v[d + 1074416 >> 2] = v[d + 480196 >> 2];
              v[d + 1074420 >> 2] = v[d + 480204 >> 2];
              v[d + 1074456 >> 2] = v[d + 480200 >> 2];
              a = x[d + 1074448 >> 1];
              u[d + 1074450 >> 1] = a;
              b = v[d + 1074424 >> 2];
              v[d + 1074428 >> 2] = b;
              c = Wb(v[d + 484360 >> 2], w[d + 484376 | 0]);
              e = v[c >> 2];
              if (_c(e, v[c + 4 >> 2]) >>> 0 > a >>> 0) {
               Ca = d, Da = x[$b(e, a) >> 1], u[Ca + 1074446 >> 1] = Da;
              }
              Zu(j, a, b, Jq(s + 20 | 0, h), w[s + 30 | 0]);
              if (!Ie(v[d + 484344 >> 2], v[d + 484348 >> 2], x[d + 1074446 >> 1])) {
               break n;
              }
              break m;
             } else {
              Po(h + B(a, 872) | 0, d, a & 65535, 134217728);
              a = a + 1 | 0;
              continue;
             }
            }
            Lo(j, 1);
           }
           a = 0;
           break j;
          }
          wT(d, q, (v[d + 480208 >> 2] & 32) >>> 5 | 0);
          a = Vb(v[d + 484344 >> 2], x[d + 1074446 >> 1]);
          b = ld(v[a >> 2], v[v[a + 48 >> 2] + 12 >> 2], v[d + 1074424 >> 2], 0);
          e = h + B(x[d + 480188 >> 1], 872) | 0;
          a = h;
          while (1) {
           if ((a | 0) == (e | 0)) {
            v: {
             w: {
              a = v[d + 484344 >> 2];
              b = x[d + 1074446 >> 1];
              if (An(a, v[d + 484348 >> 2], b)) {
               a = Vb(a, b);
               b = v[a + 16 >> 2];
               a = v[a + 20 >> 2];
               if (tT(b, a)) {
                break w;
               }
              }
              v[d + 1074408 >> 2] = v[d + 480216 >> 2];
              a = v[d + 480220 >> 2];
              break v;
             }
             v[d + 1074408 >> 2] = b;
            }
            v[d + 1074412 >> 2] = a;
            if (!w[s + 30 | 0]) {
             break l;
            }
            a = v[d + 1074416 >> 2];
            v[d + 1074392 >> 2] = a;
            continue k;
           }
           Ib(s + 20 | 0, l, 82);
           x: {
            if (!Fb(v[v[s + 20 >> 2] >> 2], v[s + 24 >> 2]) | w[a + 805 | 0] != 1) {
             break x;
            }
            c = w[b + 3 | 0];
            if ((c | 0) != 2 & (c | 0) != 3) {
             break x;
            }
            Ca = a, Da = yh(d, w[a + 800 | 0], u[a + 772 >> 1], v[a + 704 >> 2]), v[Ca + 700 >> 2] = Da;
           }
           Ib(s + 20 | 0, l, 91);
           y: {
            if (!Fb(v[v[s + 20 >> 2] >> 2], v[s + 24 >> 2])) {
             break y;
            }
            if (Tc(w[b | 0])) {
             break y;
            }
            c = w[a + 788 | 0];
            if (!Tc(c) | w[a + 791 | 0] != 19) {
             break y;
            }
            f = w[a + 793 | 0];
            if ((f & 240) != 208 | y[d + 1074416 >> 2] > (f & 15) >>> 0) {
             break y;
            }
            Ca = a, Da = yh(d, c, u[a + 772 >> 1], 0), v[Ca + 700 >> 2] = Da;
           }
           Ib(s + 20 | 0, l, 118);
           z: {
            if (!Fb(v[v[s + 20 >> 2] >> 2], v[s + 24 >> 2])) {
             break z;
            }
            if (Tc(w[b | 0]) | !(w[a + 89 | 0] & 2)) {
             break z;
            }
            c = v[a + 708 >> 2];
            if (!c) {
             break z;
            }
            if (!Tc(w[a + 788 | 0])) {
             break z;
            }
            if (!Il(w[a + 790 | 0], w[a + 791 | 0])) {
             break z;
            }
            v[a + 700 >> 2] = c;
           }
           c = s + 20 | 0;
           Ib(c, l, 92);
           A: {
            if (!Fb(v[v[s + 20 >> 2] >> 2], v[s + 24 >> 2])) {
             break A;
            }
            Ib(s + 12 | 0, l, 5);
            if (Fb(v[v[s + 12 >> 2] >> 2], v[s + 16 >> 2]) | v[d + 1074416 >> 2] != 1 | w[a + 791 | 0] != 17) {
             break A;
            }
            t[s + 20 | 0] = 1;
            Ca = d, Da = B(w[cf(c, a + 793 | 0) | 0], 1e4), v[Ca + 1074420 >> 2] = Da;
           }
           c = w[b | 0] | w[b + 1 | 0] << 8 | (w[b + 2 | 0] << 16 | w[b + 3 | 0] << 24);
           t[a + 788 | 0] = c;
           t[a + 789 | 0] = c >>> 8;
           t[a + 790 | 0] = c >>> 16;
           t[a + 791 | 0] = c >>> 24;
           c = w[b + 4 | 0] | w[b + 5 | 0] << 8;
           t[a + 792 | 0] = c;
           t[a + 793 | 0] = c >>> 8;
           c = v[a + 676 >> 2];
           v[a + 20 >> 2] = v[a + 672 >> 2];
           v[a + 24 >> 2] = c;
           v[a + 88 >> 2] = v[a + 88 >> 2] & -393217;
           Ib(s + 20 | 0, l, 21);
           if (!Fb(v[v[s + 20 >> 2] >> 2], v[s + 24 >> 2])) {
            t[a + 831 | 0] = 0;
           }
           v[a + 860 >> 2] = 0;
           t[a + 805 | 0] = 0;
           b = b + 6 | 0;
           a = a + 872 | 0;
           continue;
          }
         }
         break;
        }
        c = v[d + 1074416 >> 2];
        if (!c) {
         v[d + 1074416 >> 2] = 1;
         c = 1;
        }
        a = v[d + 480208 >> 2];
        e = v[d + 1074392 >> 2];
        B: {
         C: {
          if (e) {
           b = a & -4097;
           v[d + 480208 >> 2] = b;
           f = v[d + 480180 >> 2];
           if (f & 1048580 | !(a & 2097152) & (f | 0) == 1) {
            break B;
           }
           if (Hl(q) >>> 0 <= e >>> 0) {
            break B;
           }
           if (!((e >>> 0) % (v[d + 1074400 >> 2] + c >>> 0) | 0)) {
            break C;
           }
           break B;
          }
          b = a & -528385;
         }
         v[d + 480208 >> 2] = b | 4096;
        }
        r = 0;
        i = eb - 16 | 0;
        eb = i;
        u[d + 1074444 >> 1] = 65535;
        v[d + 1074436 >> 2] = -1;
        v[d + 1074440 >> 2] = -1;
        X = d + 1075809 | 0;
        Q = d + 480280 | 0;
        E = d + 900380 | 0;
        J = d + 484380 | 0;
        o = d + 1074312 | 0;
        K = d + 906300 | 0;
        S = d + 1074992 | 0;
        G = d + 1074376 | 0;
        O = d + 480209 | 0;
        _ = d + 480210 | 0;
        while (1) {
         if (x[d + 480188 >> 1] <= r >>> 0) {
          D: {
           if (!(w[d + 480209 | 0] & 16)) {
            break D;
           }
           if (!lT(d, G, Wb(v[d + 484360 >> 2], w[d + 484376 | 0]), 1)) {
            break D;
           }
           v[d + 480208 >> 2] = v[d + 480208 >> 2] | 524288;
          }
          eb = i + 16 | 0;
         } else {
          h = S + B(r, 872) | 0;
          a = w[h + 789 | 0];
          c = w[h + 793 | 0];
          q = w[h + 792 | 0];
          b = v[d + 1074400 >> 2];
          e = v[d + 1074392 >> 2];
          f = v[d + 1074416 >> 2];
          k = w[h + 790 | 0];
          H = w[h + 791 | 0];
          g = Il(k, H);
          t[h + 851 | 0] = v[d + 480208 >> 2] >>> 12 & 1 | w[h + 851 | 0] & 254;
          f = (e >>> 0) % (b + f >>> 0) | 0;
          b = w[h + 788 | 0];
          E: {
           F: {
            G: {
             if ((b | 0) == 252) {
              j = Bj(k, q);
              l = Bj(H, c);
              b = 252;
              e = a - 1 | 0;
              if ((e & 255) >>> 0 > 249) {
               break G;
              }
              e = v[_d(K, e) >> 2];
              if (!e) {
               break G;
              }
              hb[v[v[e >> 2] + 44 >> 2]](e, j, C(C(l >>> 0) / C(999)));
              b = w[h + 788 | 0];
             }
             if ((b & 255) == 251) {
              break F;
             }
            }
            if (z[h + 860 >> 2] == C(0) | H) {
             break E;
            }
           }
           j = v[d + 480208 >> 2] & 4096;
           H: {
            if (!j) {
             e = w[h + 870 | 0];
             break H;
            }
            e = w[h + 789 | 0];
            t[h + 870 | 0] = e;
           }
           if ((e - 1 & 255) >>> 0 > 249) {
            break E;
           }
           l = _d(K, (e & 255) - 1 | 0);
           e = v[l >> 2];
           if (!e) {
            break E;
           }
           I: {
            if (!j) {
             b = x[h + 868 >> 1];
             break I;
            }
            b = sB(w[h + 790 | 0], w[h + 792 | 0]);
            u[h + 868 >> 1] = b;
            V = C(C(sB(w[h + 791 | 0], w[h + 793 | 0]) >>> 0) / C(999));
            z[h + 864 >> 2] = V;
            Ca = h, Ea = C(C(V - C(hb[v[v[e >> 2] + 48 >> 2]](e, b))) / C(Hl(G) >>> 0)), z[Ca + 860 >> 2] = Ea;
            e = v[l >> 2];
           }
           j = b;
           b = (v[d + 1074392 >> 2] + 1 | 0) == (Hl(G) | 0);
           hb[v[v[e >> 2] + (b ? 44 : 108) >> 2]](e, j, z[h + (b ? 864 : 860) >> 2]);
           b = w[h + 788 | 0];
          }
          if (bT(b & 255)) {
           b = eb - 16 | 0;
           eb = b;
           u[b + 12 >> 1] = 0;
           v[b + 8 >> 2] = 0;
           a = Mg(b + 8 | 0);
           c = w[a | 0] | w[a + 1 | 0] << 8 | (w[a + 2 | 0] << 16 | w[a + 3 | 0] << 24);
           t[h + 788 | 0] = c;
           t[h + 789 | 0] = c >>> 8;
           t[h + 790 | 0] = c >>> 16;
           t[h + 791 | 0] = c >>> 24;
           a = w[a + 4 | 0] | w[a + 5 | 0] << 8;
           t[h + 792 | 0] = a;
           t[h + 793 | 0] = a >>> 8;
           eb = b + 16 | 0;
           H = 0;
           q = 0;
           k = 0;
           c = 0;
           g = 0;
           a = 0;
          }
          J: {
           if (!(w[O | 0] & 16)) {
            ES(d, h);
            break J;
           }
           if (!a) {
            break J;
           }
           v[h + 760 >> 2] = 0;
          }
          K: {
           L: {
            if ((H | 0) == 33) {
             Ib(i + 8 | 0, o, 30);
             b = c >>> 4 | 0;
             eB(d, r & 65535, b + (c & 15) | 0, Fb(v[v[i + 8 >> 2] >> 2], v[i + 12 >> 2]));
             break L;
            }
            b = 0;
            if ((H - 19 & 255) >>> 0 > 1) {
             break L;
            }
            M: {
             if (!(!(v[d + 480180 >> 2] & 16777250) | c)) {
              c = w[h + 833 | 0];
              break M;
             }
             t[h + 833 | 0] = c;
            }
            e = c & 240;
            if ((e | 0) == 208) {
             e = c & 15;
             if (!e) {
              e = v[d + 480180 >> 2];
              if (e & 16777248) {
               b = 1;
               break L;
              }
              if ((e | 0) != 2) {
               break L;
              }
              break K;
             }
             if (e >>> 0 >= v[d + 1074400 >> 2] + v[d + 1074416 >> 2] >>> 0) {
              Ib(i + 8 | 0, o, 14);
              b = e;
              if (!Fb(v[v[i + 8 >> 2] >> 2], v[i + 12 >> 2])) {
               break L;
              }
              if (!a) {
               break K;
              }
              t[h + 803 | 0] = a;
              break K;
             }
             b = e;
             break L;
            }
            if (!(v[d + 480208 >> 2] & 4096) | (e | 0) != 224) {
             break L;
            }
            e = v[d + 480180 >> 2];
            if (v[d + 1074396 >> 2] ? e & 16777250 : 0) {
             break L;
            }
            j = c & 15;
            if (!(e & 2 ? j : 1)) {
             break L;
            }
            v[d + 1074396 >> 2] = j + 1;
           }
           j = v[d + 480180 >> 2] == 16 & (H | 0) == 19 & (c & 240) == 208;
           I = j ? 0 : b;
           N: {
            if (!I | w[h + 788 | 0] != 255 | w[h + 790 | 0] != 2) {
             break N;
            }
            Ib(i + 8 | 0, o, 74);
            if (!Fb(v[v[i + 8 >> 2] >> 2], v[i + 12 >> 2])) {
             break N;
            }
            t[h + 790 | 0] = 0;
           }
           m = c & 159;
           e = v[d + 1074392 >> 2];
           Ib(i + 8 | 0, o, 72);
           O: {
            if (Fb(v[v[i + 8 >> 2] >> 2], v[i + 12 >> 2])) {
             l = 0;
             if (I >>> 0 >= y[d + 1074416 >> 2]) {
              break O;
             }
            }
            Ib(i + 8 | 0, o, 88);
            e = (e | 0) == (I | 0);
            l = e | (f | 0) == (I | 0);
            if (!(!I | !Fb(v[v[i + 8 >> 2] >> 2], v[i + 12 >> 2]))) {
             break O;
            }
            l = e;
           }
           c = j ? m : c;
           b = i + 8 | 0;
           Ib(b, o, 44);
           e = w[h + 851 | 0];
           Ca = h, Da = (Fb(v[v[i + 8 >> 2] >> 2], v[i + 12 >> 2]) ? e & 252 | (f | 0) == (I | 0) : e) & 253, 
           t[Ca + 851 | 0] = Da;
           Ib(b, o, 66);
           e = (!I | Fb(v[v[i + 8 >> 2] >> 2], v[i + 12 >> 2]) ^ 1) & g;
           P: {
            Q: {
             R: {
              if (!(v[d + 1074392 >> 2] | (!(w[_ | 0] & 32) | !a))) {
               v[h + 660 >> 2] = 0;
               if (l) {
                g = w[h + 788 | 0];
                break R;
               }
               if (!Li(v[h + 8 >> 2], v[h + 12 >> 2])) {
                break P;
               }
               t[h + 803 | 0] = a;
               if (x[d + 480190 >> 1] < a >>> 0) {
                break P;
               }
               a = J + B(a, 104) | 0;
               v[h + 688 >> 2] = x[a + 30 >> 1];
               u[h + 772 >> 1] = t[a + 37 | 0];
               break P;
              }
              if (!l) {
               break P;
              }
              g = w[h + 788 | 0];
              if (!a) {
               break Q;
              }
             }
             t[h + 803 | 0] = a;
            }
            S: {
             T: {
              b = g & 255;
              if (!Tc(b)) {
               break T;
              }
              Ib(i + 8 | 0, o, 67);
              if (!Fb(v[v[i + 8 >> 2] >> 2], v[i + 12 >> 2])) {
               break T;
              }
              f = u[h + 770 >> 1];
              U: {
               if (!a | e) {
                break U;
               }
               j = rr(d, b, a);
               if (!j) {
                break U;
               }
               f = t[mi(d, j) + 36 | 0];
              }
              g = (b + f | 0) - 132 >>> 0 >= 4294967176 ? g : 0;
              break S;
             }
             if (!(v[d + 480180 >> 2] & 25165856)) {
              break S;
             }
             f = x[d + 480192 >> 1];
             if (!f) {
              break S;
             }
             if (b) {
              b = Tc(b);
             } else {
              b = 1;
             }
             if (!b) {
              break S;
             }
             b = a;
             V: {
              if (!a) {
               b = w[h + 804 | 0];
               if (!b) {
                break V;
               }
              }
              if (v[E + (b << 2) >> 2] ? b >>> 0 <= f >>> 0 : 0) {
               break S;
              }
              g = 0;
             }
             a = 0;
            }
            if (!((H | 0) != 25 | c)) {
             Ib(i + 8 | 0, o, 55);
             b = Fb(v[v[i + 8 >> 2] >> 2], v[i + 12 >> 2]);
             a = b ? 0 : a;
             g = b ? 0 : g;
            }
            b = i + 8 | 0;
            Ib(b, o, 65);
            m = Fb(v[v[i + 8 >> 2] >> 2], v[i + 12 >> 2]);
            L = 1;
            if (!(v[d + 480180 >> 2] & 16777248)) {
             Ib(b, o, 107);
             L = Fb(v[v[i + 8 >> 2] >> 2], v[i + 12 >> 2]);
            }
            f = (a | 0) != 0;
            b = g & 255;
            U = !b;
            Ib(i + 8 | 0, o, 85);
            W: {
             if (!Fb(v[v[i + 8 >> 2] >> 2], v[i + 12 >> 2])) {
              break W;
             }
             if (Li(v[h + 8 >> 2], v[h + 12 >> 2])) {
              break W;
             }
             j = v[h + 104 >> 2];
             if (j) {
              if (ke(v[j >> 2], v[j + 20 >> 2])) {
               break W;
              }
             }
             L = 1;
            }
            j = f & U;
            m = f & m;
            X: {
             Y: {
              Z: {
               _: {
                $: {
                 aa: {
                  if (!(v[d + 480180 >> 2] & 1048580)) {
                   break aa;
                  }
                  ba: {
                   if ((b | 0) != 255) {
                    break ba;
                   }
                   if (!(!((k | 0) == 1 | a) & (H | 0) != 13)) {
                    Ib(i + 8 | 0, o, 55);
                    if (Fb(v[v[i + 8 >> 2] >> 2], v[i + 12 >> 2])) {
                     break ba;
                    }
                   }
                   f = v[h + 656 >> 2];
                   if (t[f + 60 | 0] & 1 ? f : 0) {
                    break ba;
                   }
                   v[h + 688 >> 2] = 0;
                   v[h + 88 >> 2] = v[h + 88 >> 2] | 2097152;
                   ca: {
                    if (!(v[d + 480208 >> 2] & 4096)) {
                     break ca;
                    }
                    Ib(i + 8 | 0, o, 86);
                    if (!Fb(v[v[i + 8 >> 2] >> 2], v[i + 12 >> 2])) {
                     break ca;
                    }
                    v[h + 88 >> 2] = v[h + 88 >> 2] | 4096;
                   }
                   a = 0;
                   g = 0;
                   b = 0;
                   f = 0;
                   j = 1;
                   if (m) {
                    break Y;
                   }
                   break X;
                  }
                  Ib(i + 8 | 0, o, 59);
                  if (!Fb(v[v[i + 8 >> 2] >> 2], v[i + 12 >> 2]) | v[d + 480208 >> 2] & 4096) {
                   break aa;
                  }
                  da: {
                   if (!b) {
                    g = w[h + 797 | 0] - w[h + 770 | 0] | 0;
                    break da;
                   }
                   if (b >>> 0 > 250) {
                    L = 0;
                    m = 1;
                    g = 0;
                    break da;
                   }
                   ea: {
                    if (a) {
                     break ea;
                    }
                    Ib(i + 8 | 0, o, 98);
                    if (!Fb(v[v[i + 8 >> 2] >> 2], v[i + 12 >> 2])) {
                     break ea;
                    }
                    a = 0;
                    break da;
                   }
                   L = 1;
                   m = 1;
                  }
                  f = g;
                  e = 0;
                  break $;
                 }
                 f = 0;
                 if (!j) {
                  break _;
                 }
                }
                Ib(i + 8 | 0, o, 65);
                if (!Fb(v[v[i + 8 >> 2] >> 2], v[i + 12 >> 2])) {
                 break Z;
                }
                g = f;
                f = 1;
               }
               b = g;
               j = 1;
               if (m) {
                break Y;
               }
               break X;
              }
              g = f;
              f = 1;
              j = m;
             }
             fa: {
              ga: {
               if (!x[d + 480192 >> 1]) {
                if (x[d + 480190 >> 1] < a >>> 0) {
                 break fa;
                }
                b = J + B(a, 104) | 0;
                break ga;
               }
               b = v[h + 104 >> 2];
               if (!b) {
                break fa;
               }
              }
              ha: {
               if (u[b + 34 >> 1] < 0) {
                break ha;
               }
               if (v[d + 480180 >> 2] == 2) {
                if (!ke(v[b >> 2], v[b + 20 >> 2])) {
                 break ha;
                }
               }
               v[h + 688 >> 2] = x[b + 30 >> 1];
               v[h + 88 >> 2] = v[h + 88 >> 2] | 2097152;
              }
              if (!j) {
               break fa;
              }
              Sq(h, x[b + 28 >> 1], d);
             }
             b = g;
            }
            Ib(i + 8 | 0, o, 71);
            if (!(!Fb(v[v[i + 8 >> 2] >> 2], v[i + 12 >> 2]) | !a)) {
             t[h + 839 | 0] = 32;
            }
            ia: {
             if (!x[d + 480192 >> 1]) {
              break ia;
             }
             Ib(i + 8 | 0, o, 100);
             if (!Fb(v[v[i + 8 >> 2] >> 2], v[i + 12 >> 2]) | !a) {
              break ia;
             }
             if (Tc(b & 255)) {
              break ia;
             }
             g = v[d + 480208 >> 2];
             ja: {
              if (e) {
               if (g & 8) {
                break ja;
               }
               break ia;
              }
              if (!(g & 4)) {
               break ia;
              }
             }
             Xm(h);
             v[h + 696 >> 2] = 65536;
             v[h + 88 >> 2] = v[h + 88 >> 2] | 2097152;
            }
            if (f) {
             Ib(i + 8 | 0, o, 11);
             ka: {
              la: {
               ma: {
                if (!(Fb(v[v[i + 8 >> 2] >> 2], v[i + 12 >> 2]) | v[d + 480180 >> 2] == 268435456)) {
                 g = x[d + 480192 >> 1];
                 break ma;
                }
                Ib(i + 8 | 0, o, 87);
                f = 0;
                if (Fb(v[v[i + 8 >> 2] >> 2], v[i + 12 >> 2])) {
                 f = Li(v[h + 8 >> 2], v[h + 12 >> 2]) ^ 1;
                }
                g = x[d + 480192 >> 1];
                na: {
                 if (g) {
                  if (a >>> 0 > g >>> 0) {
                   break la;
                  }
                  if (v[h + 656 >> 2] != v[E + (a << 2) >> 2] | f) {
                   break na;
                  }
                  break la;
                 }
                 if ((f ^ -1) & v[h + 104 >> 2] == (J + B(a, 104) | 0)) {
                  break ka;
                 }
                }
                b = w[h + 797 | 0];
               }
               if (!(g & 65535)) {
                break ka;
               }
              }
              if (!(v[d + 480180 >> 2] & 1048588)) {
               break ka;
              }
              Xm(h);
              t[h + 818 | 0] = 0;
              v[h + 756 >> 2] = 0;
              v[h + 696 >> 2] = 65536;
              v[h + 88 >> 2] = v[h + 88 >> 2] & -2101249 | 2097152;
              Ib(i + 8 | 0, o, 86);
              if (!Fb(v[v[i + 8 >> 2] >> 2], v[i + 12 >> 2])) {
               break ka;
              }
              v[h + 88 >> 2] = v[h + 88 >> 2] & -2049;
             }
             a = L ? a : 0;
            }
            g = b & 255;
            oa: {
             if (g >>> 0 < 251) {
              break oa;
             }
             Ib(i + 8 | 0, o, 50);
             pa: {
              if (!Fb(v[v[i + 8 >> 2] >> 2], v[i + 12 >> 2]) | !a) {
               break pa;
              }
              f = rr(d, w[h + 799 | 0], a);
              if (!f) {
               break pa;
              }
              f = J + B(f, 104) | 0;
              if (u[f + 34 >> 1] < 0) {
               break pa;
              }
              v[h + 688 >> 2] = x[f + 30 >> 1];
             }
             Ib(i + 8 | 0, o, 100);
             if (Ca = Fb(v[v[i + 8 >> 2] >> 2], v[i + 12 >> 2]), Da = 0, Fa = v[d + 480208 >> 2] & 4, 
             Fa ? Ca : Da) {
              break oa;
             }
             a = 0;
            }
            j = Tc(g);
            if (j) {
             t[h + 802 | 0] = b;
             t[h + 799 | 0] = b;
             if (!e) {
              FS(d, r & 65535, a, g, 0);
             }
             fV(h);
            }
            qa: {
             ra: {
              sa: {
               ta: {
                ua: {
                 if (a) {
                  f = v[h + 104 >> 2];
                  Ko(d, h, a, e, 1, 1);
                  b = v[h + 104 >> 2];
                  va: {
                   if (!b | !(w[b + 35 | 0] & 2)) {
                    break va;
                   }
                   m = v[d + 1298300 >> 2];
                   if (!Dd(m)) {
                    break va;
                   }
                   SB(m, r & 65535, b + 68 | 0);
                  }
                  wa: {
                   xa: {
                    if (v[d + 480180 >> 2] == 1) {
                     if (!e) {
                      break xa;
                     }
                     Ib(i + 8 | 0, o, 85);
                     if (!Fb(v[v[i + 8 >> 2] >> 2], v[i + 12 >> 2])) {
                      break xa;
                     }
                     break wa;
                    }
                    Ib(i + 8 | 0, o, 50);
                    if ((j | Fb(v[v[i + 8 >> 2] >> 2], v[i + 12 >> 2]) ^ 1) != 1) {
                     break wa;
                    }
                   }
                   t[h + 803 | 0] = 0;
                  }
                  Ib(i + 8 | 0, o, 42);
                  if (Fb(v[v[i + 8 >> 2] >> 2], v[i + 12 >> 2])) {
                   if (!j | (f | 0) == v[h + 104 >> 2]) {
                    break ta;
                   }
                   break ua;
                  }
                  if (v[d + 480180 >> 2] & 16777248) {
                   b = 0;
                   if (j & (f | 0) != v[h + 104 >> 2]) {
                    break sa;
                   }
                  }
                  Ib(i + 8 | 0, o, 107);
                  if (!(!Fb(v[v[i + 8 >> 2] >> 2], v[i + 12 >> 2]) | (!(j ^ 1 | e) | (f | 0) == v[h + 104 >> 2]) | y[h + 76 >> 2] >= y[h + 4 >> 2])) {
                   v[h + 76 >> 2] = 0;
                   break ta;
                  }
                  Ib(i + 8 | 0, o, 85);
                  if (!Fb(v[v[i + 8 >> 2] >> 2], v[i + 12 >> 2])) {
                   break ta;
                  }
                  if (!Li(v[h + 8 >> 2], v[h + 12 >> 2])) {
                   break ua;
                  }
                  break ta;
                 }
                 if (!g) {
                  b = e;
                  break qa;
                 }
                 f = 0;
                 b = w[h + 803 | 0];
                 if (!(!b | j ^ 1)) {
                  Ko(d, h, b, e, !(v[h + 104 >> 2] ? 1 : v[h + 656 >> 2]), !(v[d + 480180 >> 2] & 1048580));
                  t[h + 803 | 0] = 0;
                  f = 1;
                 }
                 b = e;
                 break ra;
                }
                v[h >> 2] = 0;
                v[h + 4 >> 2] = 0;
               }
               b = e;
              }
              f = 0;
              if (!g) {
               break qa;
              }
             }
             e = v[h + 104 >> 2];
             ya: {
              if (!e | !(w[e + 35 | 0] & 2)) {
               break ya;
              }
              j = v[d + 1298300 >> 2];
              if (!Dd(j)) {
               break ya;
              }
              if (!f) {
               if (GS(j, r & 65535)) {
                break ya;
               }
              }
              SB(j, r & 65535, e + 68 | 0);
             }
             e = r & 65535;
             Tu(d, h, g, b, !(v[d + 480180 >> 2] & 1048580), 0, e);
             qT(v[d + 480180 >> 2], x[d + 480188 >> 1], G, e);
             if (!(!(v[d + 480180 >> 2] & 1048580) | (!b | !a))) {
              v[h + 88 >> 2] = v[h + 88 >> 2] | 2097152;
              Xm(h);
              t[h + 818 | 0] = 0;
              v[h + 756 >> 2] = 0;
             }
             if (!(v[h + 88 >> 2] & 512)) {
              break qa;
             }
             if (!Dd(v[d + 1298300 >> 2])) {
              break qa;
             }
             if (g >>> 0 <= 253) {
              if ((g | 0) != 253) {
               break qa;
              }
              Ib(i + 8 | 0, o, 99);
              if (Fb(v[v[i + 8 >> 2] >> 2], v[i + 12 >> 2])) {
               break qa;
              }
             }
             Ib(i + 8 | 0, o, 110);
             if (Fb(v[v[i + 8 >> 2] >> 2], v[i + 12 >> 2])) {
              TB(v[d + 1298300 >> 2], e, 0, 1, 0);
             }
             xk(v[d + 1298300 >> 2], e);
            }
            za: {
             Aa: {
              switch (k - 1 | 0) {
              case 0:
               v[h + 88 >> 2] = v[h + 88 >> 2] | 2097152;
               q = q >>> 0 >= 64 ? 64 : q;
               v[h + 688 >> 2] = q << 2;
               break za;

              case 1:
               break Aa;

              default:
               break za;
              }
             }
             Ym(d, h, q, 6);
            }
            if (x[d + 480192 >> 1]) {
             DS(d, r & 65535);
            }
            e = b;
           }
           b = i + 8 | 0;
           Ib(b, o, 77);
           if (Ca = Fb(v[v[i + 8 >> 2] >> 2], v[i + 12 >> 2]), Da = 0, Fa = v[Q + (r << 5) >> 2] & 1024, 
           Fa ? Ca : Da) {
            break K;
           }
           a = v[d + 1074392 >> 2];
           Ib(b, o, 75);
           f = a >>> 0 >= I >>> 0;
           Ba: {
            Ca: {
             Da: {
              Ea: {
               if (!I | !Fb(v[v[i + 8 >> 2] >> 2], v[i + 12 >> 2])) {
                break Ea;
               }
               b = v[d + 1074392 >> 2];
               if (!b) {
                break Da;
               }
               f = 1;
               if ((b | 0) != (I | 0)) {
                break Ea;
               }
               f = !w[h + 789 | 0] & (k | 0) != 11;
              }
              a = k;
              if (!f | a >>> 0 < 3) {
               break Da;
              }
              if ((a | 0) == 11) {
               a = i + 8 | 0;
               yB(a, d, w[h + 791 | 0], w[h + 792 | 0], I);
               a = w[_e(a) | 0];
               dB(d, r & 65535, x[i + 8 >> 1]);
               if (a) {
                break Ca;
               }
               k = 11;
               break Da;
              }
              Ib(i + 8 | 0, o, 62);
              Fa: {
               Ga: {
                Ha: {
                 Ia: {
                  Ja: {
                   Ka: {
                    La: {
                     if (!(!Fb(v[v[i + 8 >> 2] >> 2], v[i + 12 >> 2]) | q)) {
                      q = 0;
                      k = 0;
                      Ma: {
                       switch (a - 8 | 0) {
                       case 0:
                        break La;

                       case 1:
                        break Ma;

                       default:
                        break Da;
                       }
                      }
                      if (w[O | 0] & 16) {
                       break Da;
                      }
                      v[h + 692 >> 2] = 0;
                      break Da;
                     }
                     Ib(i + 8 | 0, o, 41);
                     Na: {
                      if (Fb(v[v[i + 8 >> 2] >> 2], v[i + 12 >> 2])) {
                       break Na;
                      }
                      if (q) {
                       t[h + 834 | 0] = q;
                       break Na;
                      }
                      q = w[h + 834 | 0];
                     }
                     Oa: {
                      switch (a - 3 | 0) {
                      case 0:
                      case 1:
                       Pa: {
                        Qa: {
                         if (q) {
                          break Qa;
                         }
                         Ib(i + 8 | 0, o, 41);
                         if (!Fb(v[v[i + 8 >> 2] >> 2], v[i + 12 >> 2])) {
                          break Qa;
                         }
                         q = w[h + 834 | 0];
                         if (q) {
                          break Pa;
                         }
                         q = 0;
                         break Da;
                        }
                        t[h + 834 | 0] = q;
                       }
                       Io(d, h, ((a | 0) == 3 ? q << 4 : q) & 255);
                       break Da;

                      case 2:
                       if ((I | 0) != v[d + 1074392 >> 2]) {
                        Ib(i + 8 | 0, o, 41);
                        k = 5;
                        if (Fb(v[v[i + 8 >> 2] >> 2], v[i + 12 >> 2])) {
                         break Da;
                        }
                       }
                       Ib(i + 8 | 0, o, 41);
                       Ho(d, h, q, Fb(v[v[i + 8 >> 2] >> 2], v[i + 12 >> 2]));
                       k = 5;
                       break Da;

                      case 3:
                       if ((I | 0) != v[d + 1074392 >> 2]) {
                        Ib(i + 8 | 0, o, 41);
                        k = 6;
                        if (Fb(v[v[i + 8 >> 2] >> 2], v[i + 12 >> 2])) {
                         break Da;
                        }
                       }
                       Ib(i + 8 | 0, o, 41);
                       Go(d, h, q, Fb(v[v[i + 8 >> 2] >> 2], v[i + 12 >> 2]));
                       k = 6;
                       break Da;

                      case 11:
                       break Fa;

                      case 12:
                       break Ga;

                      case 10:
                       break Ha;

                      case 9:
                       break Ia;

                      case 7:
                       break Ja;

                      case 6:
                       break Ka;

                      case 5:
                       break La;

                      case 4:
                       break Oa;

                      default:
                       break Da;
                      }
                     }
                     Ib(i + 8 | 0, o, 53);
                     if (Fb(v[v[i + 8 >> 2] >> 2], v[i + 12 >> 2])) {
                      t[h + 823 | 0] = q & 15;
                      k = 7;
                      break Da;
                     }
                     Fl(h, q << 4);
                     k = 7;
                     break Da;
                    }
                    Fl(h, q);
                    k = 8;
                    break Da;
                   }
                   Ib(i + 8 | 0, o, 62);
                   cB(d, h, q, Fb(v[v[i + 8 >> 2] >> 2], v[i + 12 >> 2]) ^ 1);
                   k = 9;
                   break Da;
                  }
                  Ib(i + 8 | 0, o, 62);
                  cB(d, h, q << 4 & 240, Fb(v[v[i + 8 >> 2] >> 2], v[i + 12 >> 2]) ^ 1);
                  k = 10;
                  break Da;
                 }
                 k = 12;
                 Ib(i + 8 | 0, o, 12);
                 CS(d, r & 65535, q << 2 & 252, Fb(v[v[i + 8 >> 2] >> 2], v[i + 12 >> 2]));
                 break Da;
                }
                Ib(i + 8 | 0, o, 12);
                BS(d, r & 65535, q << 2 & 252, Fb(v[v[i + 8 >> 2] >> 2], v[i + 12 >> 2]));
                k = 13;
                break Da;
               }
               k = 15;
               if (!l) {
                break Da;
               }
               a = v[h + 104 >> 2];
               if (!a | q >>> 0 > 9) {
                break Da;
               }
               Ra: {
                if (!q) {
                 a = v[h + 664 >> 2];
                 break Ra;
                }
                a = v[xb(a + 68 | 0, q - 1 | 0) >> 2];
                v[h + 664 >> 2] = a;
               }
               Jo(d, h, a);
               break Da;
              }
              k = 14;
              if (q >>> 0 > 1) {
               break Da;
              }
              t[h + 851 | 0] = (w[h + 851 | 0] & 247 | q << 3) ^ 8;
             }
             a = c;
             Sa: {
              Ta: {
               Ua: {
                switch (H - 1 | 0) {
                case 12:
                 if (!(w[d + 480209 | 0] & 16)) {
                  break Ca;
                 }
                 v[h + 688 >> 2] = c >>> 0 >= 64 ? 256 : c << 2;
                 v[h + 88 >> 2] = v[h + 88 >> 2] | 2097152;
                 break Ca;

                case 45:
                 if (!(w[d + 480209 | 0] & 16)) {
                  break Ca;
                 }
                 v[h + 688 >> 2] = c;
                 v[h + 88 >> 2] = v[h + 88 >> 2] | 2097152;
                 break Ca;

                case 1:
                 if (!c) {
                  a = 0;
                  if (t[d + 480180 | 0] & 1) {
                   break Ba;
                  }
                 }
                 CS(d, r & 65535, c, 0);
                 break Ca;

                case 2:
                 if (!c) {
                  a = 0;
                  if (t[d + 480180 | 0] & 1) {
                   break Ba;
                  }
                 }
                 BS(d, r & 65535, c, 0);
                 break Ca;

                case 10:
                 if (!c) {
                  a = 0;
                  if (v[d + 480180 >> 2] == 1) {
                   break Ba;
                  }
                 }
                 Io(d, h, c);
                 break Ca;

                case 3:
                 dB(d, r & 65535, c);
                 break Ca;

                case 5:
                 if (!(!c & v[d + 480180 >> 2] == 1)) {
                  Io(d, h, c);
                 }
                 dB(d, r & 65535, 0);
                 break Ca;

                case 4:
                 Fl(h, c);
                 break Ca;

                case 6:
                 if (!(!c & v[d + 480180 >> 2] == 1)) {
                  Io(d, h, c);
                 }
                 Fl(h, 0);
                 break Ca;

                case 15:
                 if (!(w[d + 480209 | 0] & 16)) {
                  break Ca;
                 }
                 break Sa;

                case 16:
                 Ib(i + 8 | 0, o, 5);
                 if (Fb(v[v[i + 8 >> 2] >> 2], v[i + 12 >> 2])) {
                  if (!(w[d + 480209 | 0] & 16)) {
                   break Ca;
                  }
                  if (c) {
                   break Sa;
                  }
                  break Ca;
                 }
                 a = Fo(d, x[d + 1074446 >> 1], v[d + 1074424 >> 2], r & 65535, 0);
                 Va: {
                  if (!(v[d + 480180 >> 2] & 16777250)) {
                   break Va;
                  }
                  if (a) {
                   t[h + 835 | 0] = a;
                   break Va;
                  }
                  a = w[h + 835 | 0];
                 }
                 v[i + 8 >> 2] = B(a, 1e4);
                 wc(i + 8 | 0, B(v[v[d + 8 >> 2] + 24 >> 2], 1e4));
                 b = eb - 16 | 0;
                 eb = b;
                 e = v[i + 8 >> 2];
                 v[b + 12 >> 2] = e;
                 c = v[d + 8 >> 2];
                 Wa: {
                  if (e >>> 0 >= (v[d + 480180 >> 2] & 16393 ? 1e4 : 32e4) >>> 0) {
                   e = v[d + 480208 >> 2];
                   f = b + 4 | 0;
                   Ib(f, d + 1074312 | 0, 92);
                   if ((Fb(v[v[b + 4 >> 2] >> 2], v[b + 8 >> 2]) | 0) == ((e & 4096) >>> 12 | 0)) {
                    break Wa;
                   }
                   v[b + 4 >> 2] = B(v[c + 24 >> 2], 1e4);
                   Ca = d, Da = v[Gb(b + 12 | 0, f) >> 2], v[Ca + 1074420 >> 2] = Da;
                   break Wa;
                  }
                  if (w[d + 480209 | 0] & 16) {
                   break Wa;
                  }
                  e = (e >>> 0) / 1e4 | 0;
                  f = B(e & 15, 1e4);
                  v[d + 1074420 >> 2] = v[d + 1074420 >> 2] + ((e & 240) == 16 ? f : 0 - f | 0);
                  e = v[c + 20 >> 2];
                  c = v[c + 24 >> 2];
                  Ib(b + 4 | 0, d + 1074312 | 0, 8);
                  Fp(d + 1074420 | 0, B(e, 1e4), Fb(v[v[b + 4 >> 2] >> 2], v[b + 8 >> 2]) ? 255e4 : B(c, 1e4));
                 }
                 eb = b + 16 | 0;
                 break Ba;

                case 9:
                 if (!l | v[d + 480180 >> 2] == 4 & e) {
                  break Ca;
                 }
                 pT(d, h, r & 65535, v[d + 1074424 >> 2], x[d + 1074446 >> 1]);
                 break Ca;

                case 43:
                 if (!l) {
                  break Ca;
                 }
                 b = Aua(v[h + 76 >> 2], 0, c, 0);
                 a = gb;
                 m = a >>> 8 | 0;
                 Jo(d, h, Ac((a & 255) << 24 | b >>> 8, m));
                 break Ca;

                case 0:
                 if (v[d + 1074392 >> 2]) {
                  break Ca;
                 }
                 Xa: {
                  if (w[h + 797 | 0] ? v[h + 700 >> 2] : 0) {
                   break Xa;
                  }
                  a = v[h + 656 >> 2];
                  if (a) {
                   if (Ij(w[a + 31 | 0])) {
                    break Xa;
                   }
                  }
                  Ib(i + 8 | 0, o, 13);
                  if (Fb(v[v[i + 8 >> 2] >> 2], v[i + 12 >> 2])) {
                   break Xa;
                  }
                  if (v[d + 480180 >> 2] & 16777248) {
                   break Ca;
                  }
                 }
                 if (!c) {
                  a = 0;
                  if (w[d + 480180 | 0] & 5) {
                   break Ba;
                  }
                  t[h + 805 | 0] = 1;
                  break Ba;
                 }
                 t[h + 806 | 0] = c;
                 t[h + 805 | 0] = 1;
                 break Ca;

                case 14:
                 if (v[d + 480180 >> 2] & 1048580) {
                  c = c & 240 ? c : w[h + 807 | 0] & 240 | c;
                  if (!(c & 15)) {
                   c = w[h + 807 | 0] & 15 | c;
                  }
                  a = c | 256;
                 } else {
                  a = c;
                 }
                 Ib(i + 8 | 0, o, 23);
                 if (Fb(v[v[i + 8 >> 2] >> 2], v[i + 12 >> 2])) {
                  c = d;
                  f = r & 65535;
                  if (a) {
                   t[h + 807 | 0] = a;
                   b = a;
                  } else {
                   b = w[h + 807 | 0];
                  }
                  bB(c, f, b & 255, (k | 0) == 15 ? q + 1 | 0 : 0);
                  break Ba;
                 }
                 Ya: {
                  if (a) {
                   t[h + 807 | 0] = a;
                   break Ya;
                  }
                  a = w[h + 807 | 0];
                 }
                 bB(d, r & 65535, a, (k | 0) == 15 ? q + 1 | 0 : 0);
                 break Ba;

                case 17:
                 if (!(w[d + 480209 | 0] & 16)) {
                  break Ca;
                 }
                 Ib(i + 8 | 0, o, 22);
                 Za: {
                  _a: {
                   if (Fb(v[v[i + 8 >> 2] >> 2], v[i + 12 >> 2])) {
                    if (!c) {
                     c = 0;
                     break _a;
                    }
                    if (w[d + 480208 | 0] & 4) {
                     break _a;
                    }
                    a = c & 240 ? c - 16 | 0 : c;
                    c = a - ((a & 15) != 0) | 0;
                    t[h + 840 | 0] = c;
                    break _a;
                   }
                   Ib(i + 8 | 0, o, 71);
                   if (!Fb(v[v[i + 8 >> 2] >> 2], v[i + 12 >> 2])) {
                    break Za;
                   }
                  }
                  t[h + 839 | 0] = w[h + 839 | 0] | 128;
                 }
                 t[h + 805 | 0] = 18;
                 if (!c) {
                  a = 0;
                  break Ba;
                 }
                 t[h + 840 | 0] = c;
                 break Ca;

                case 22:
                 if (!(w[d + 480209 | 0] & 16)) {
                  break Ca;
                 }
                 b = v[d + 480180 >> 2];
                 a = c << !(b & 59593760);
                 if (a >>> 0 <= 128) {
                  v[d + 1074456 >> 2] = a << 1;
                  break Ba;
                 }
                 if (b & 16777250) {
                  break Ba;
                 }
                 v[d + 1074456 >> 2] = 256;
                 break Ba;

                case 23:
                 Ib(i + 8 | 0, o, 9);
                 if (Fb(v[v[i + 8 >> 2] >> 2], v[i + 12 >> 2])) {
                  AS(d, c, h + 817 | 0);
                  break Ca;
                 }
                 AS(d, c, X);
                 break Ca;

                case 8:
                 if (!(w[d + 480209 | 0] & 16)) {
                  break Ca;
                 }
                 Ym(d, h, c, 8);
                 break Ca;

                case 28:
                 cB(d, h, c, 1);
                 break Ca;

                case 7:
                 hT(h, c);
                 break Ca;

                case 25:
                 iT(d, h, c);
                 break Ca;

                case 18:
                 e = eb - 16 | 0;
                 eb = e;
                 g = d + 1074992 | 0;
                 f = r & 65535;
                 b = g + B(f, 872) | 0;
                 a = c & 15;
                 $a: {
                  ab: {
                   switch (c >>> 4 | 0) {
                   case 0:
                    a = (c & 1) << 14;
                    f = x[d + 480188 >> 1];
                    b = 0;
                    while (1) {
                     if ((b | 0) == (f | 0)) {
                      break $a;
                     }
                     k = g + B(b, 872) | 0;
                     v[k + 88 >> 2] = (a | v[k + 88 >> 2] & -16385) ^ 16384;
                     b = b + 1 | 0;
                     continue;
                    }
                    ;

                   case 1:
                    if (!a) {
                     a = 0;
                     if (!(v[d + 480180 >> 2] & 1048580)) {
                      break $a;
                     }
                    }
                    oB(d, b, a);
                    Ib(e + 8 | 0, d + 1074312 | 0, 117);
                    if (Fb(v[v[e + 8 >> 2] >> 2], v[e + 12 >> 2])) {
                     break $a;
                    }
                    zo(d, f, c | 240, 1);
                    break $a;

                   case 2:
                    if (!a) {
                     a = 0;
                     if (!(v[d + 480180 >> 2] & 1048580)) {
                      break $a;
                     }
                    }
                    nB(d, b, a);
                    Ib(e + 8 | 0, d + 1074312 | 0, 117);
                    if (Fb(v[v[e + 8 >> 2] >> 2], v[e + 12 >> 2])) {
                     break $a;
                    }
                    zo(d, f, 0 - (c | 240) | 0, 1);
                    break $a;

                   case 3:
                    v[b + 88 >> 2] = v[b + 88 >> 2] & -1048577 | ((a | 0) != 0) << 20;
                    break $a;

                   case 4:
                    t[b + 822 | 0] = c & 7;
                    break $a;

                   case 5:
                    if (!(w[d + 480209 | 0] & 16)) {
                     break $a;
                    }
                    g = v[d + 480180 >> 2];
                    if (g & 69206025) {
                     a = a << 28 >> 24;
                     u[b + 772 >> 1] = a;
                     if (!v[b + 700 >> 2]) {
                      break $a;
                     }
                     if (!Tc(w[b + 788 | 0])) {
                      break $a;
                     }
                     Ca = b, Da = yh(d, w[b + 797 | 0], a, v[b + 704 >> 2]), v[Ca + 700 >> 2] = Da;
                     break $a;
                    }
                    f = Tc(w[b + 788 | 0]);
                    if ((g | 0) == 16) {
                     if (!f) {
                      break $a;
                     }
                     f = v[b + 104 >> 2];
                     if (!f) {
                      break $a;
                     }
                     t[f + 37 | 0] = a;
                     u[b + 772 >> 1] = a;
                     if (!v[b + 700 >> 2]) {
                      break $a;
                     }
                     Ca = b, Da = yh(d, w[b + 797 | 0], a, v[b + 704 >> 2]), v[Ca + 700 >> 2] = Da;
                     break $a;
                    }
                    if (!f) {
                     break $a;
                    }
                    a = (c << 4 ^ -128) << 24 >> 24;
                    u[b + 772 >> 1] = a;
                    if (!v[b + 700 >> 2]) {
                     break $a;
                    }
                    Ca = b, Da = yh(d, w[b + 797 | 0], a, v[b + 704 >> 2]), v[Ca + 700 >> 2] = Da;
                    break $a;

                   case 6:
                    if (!(w[d + 480209 | 0] & 16)) {
                     break $a;
                    }
                    wB(d, d + 1074376 | 0, f, a);
                    break $a;

                   case 7:
                    t[b + 825 | 0] = c & 7;
                    break $a;

                   case 8:
                    if (!(w[d + 480209 | 0] & 16)) {
                     break $a;
                    }
                    Ym(d, b, a, 4);
                    break $a;

                   case 9:
                    bB(d, f, a, 0);
                    break $a;

                   case 10:
                    if (a) {
                     Ho(d, b, a, 0);
                     break $a;
                    }
                    if (!(v[d + 480180 >> 2] & 1048580)) {
                     break $a;
                    }
                    Ho(d, b, 0, 0);
                    break $a;

                   case 11:
                    if (a) {
                     Go(d, b, a, 0);
                     break $a;
                    }
                    if (!(v[d + 480180 >> 2] & 1048580)) {
                     break $a;
                    }
                    Go(d, b, 0, 0);
                    break $a;

                   case 12:
                    eB(d, f, a, 0);
                    break $a;

                   case 15:
                    break ab;

                   default:
                    break $a;
                   }
                  }
                  if (v[d + 480180 >> 2] == 1) {
                   t[b + 846 | 0] = a;
                   if (!(w[d + 480209 | 0] & 16)) {
                    break $a;
                   }
                   ES(d, b);
                   break $a;
                  }
                  t[b + 844 | 0] = a;
                 }
                 eb = e + 16 | 0;
                 break Ca;

                case 19:
                 zS(d, r & 65535, c);
                 break Ca;

                case 24:
                 Ib(i + 8 | 0, o, 55);
                 if (Fb(v[v[i + 8 >> 2] >> 2], v[i + 12 >> 2])) {
                  if (v[d + 1074392 >> 2] != (c | 0)) {
                   break Ca;
                  }
                  a = v[h + 656 >> 2];
                  if (t[a + 60 | 0] & 1 ? a : 0) {
                   break Ta;
                  }
                  if (!(!(w[h + 789 | 0] | w[h + 790 | 0]) | c)) {
                   v[h + 88 >> 2] = v[h + 88 >> 2] | 4096;
                   break Ta;
                  }
                  v[h + 688 >> 2] = 0;
                  v[h + 88 >> 2] = v[h + 88 >> 2] | 2097152;
                  break Ta;
                 }
                 if (w[d + 480209 | 0] & 16) {
                  break Ta;
                 }
                 break Ca;

                case 27:
                 a = (c & 240) - 16 >>> 4 | 0;
                 if (a >>> 0 > 9) {
                  break Ca;
                 }
                 if (!(1 << a & 880)) {
                  if (a) {
                   if ((a | 0) != 1) {
                    break Ca;
                   }
                   a = c & 15;
                   mB(d, h, a);
                   Ib(i + 8 | 0, o, 117);
                   if (Fb(v[v[i + 8 >> 2] >> 2], v[i + 12 >> 2])) {
                    break Ca;
                   }
                   zo(d, r & 65535, -224 - a | 0, 1);
                   break Ca;
                  }
                  a = c & 15;
                  pB(d, h, a);
                  Ib(i + 8 | 0, o, 117);
                  if (Fb(v[v[i + 8 >> 2] >> 2], v[i + 12 >> 2])) {
                   break Ca;
                  }
                  zo(d, r & 65535, a | 224, 1);
                  break Ca;
                 }
                 Ib(i + 8 | 0, o, 58);
                 if (Fb(v[v[i + 8 >> 2] >> 2], v[i + 12 >> 2])) {
                  break Ca;
                 }
                 zS(d, r & 65535, c);
                 break Ca;

                case 34:
                case 35:
                 f = (H | 0) == 36;
                 if (!(f | v[d + 480208 >> 2] & 4096)) {
                  break Ca;
                 }
                 e = r & 65535;
                 g = G + B(e, 872) | 0;
                 a = g + 616 | 0;
                 b = mT(d, x[d + 1074446 >> 1], v[d + 1074424 >> 2], e);
                 bb: {
                  if (!f) {
                   break bb;
                  }
                  f = Hl(G) - v[G + 16 >> 2] | 0;
                  if ((f | 0) < 2) {
                   break bb;
                  }
                  j = b;
                  b = u[a + 774 >> 1];
                  b = fd(((j - b | 0) / (f | 0) | 0) + b | 0);
                 }
                 u[a + 774 >> 1] = b;
                 a = Eq(d, v[g + 704 >> 2], v[a + 656 >> 2]);
                 if (a) {
                  hb[v[v[a >> 2] + 80 >> 2]](a, (b << 16 >> 16) + 32768 >>> 2 | 0, e);
                 }
                 break Ca;

                case 20:
                 if (!(w[d + 480209 | 0] & 16) | c >>> 0 > 64) {
                  break Ca;
                 }
                 v[h + 748 >> 2] = c;
                 v[h + 88 >> 2] = v[h + 88 >> 2] | 2097152;
                 break Ca;

                case 21:
                 g = v[d + 480180 >> 2];
                 f = v[d + 480208 >> 2];
                 b = c;
                 cb: {
                  if (b) {
                   t[h + 816 | 0] = b;
                   break cb;
                  }
                  b = w[h + 816 | 0];
                 }
                 a = b & 15;
                 e = b & 255;
                 db: {
                  eb: {
                   if (!((a | 0) != 15 | e >>> 0 < 16)) {
                    if (!(f & 4096)) {
                     break db;
                    }
                    a = e >>> 4 | 0;
                    break eb;
                   }
                   f = f & 4096;
                   k = e & 240;
                   if (!(!a | (k | 0) != 240)) {
                    if (!f) {
                     break db;
                    }
                    a = 0 - a | 0;
                    break eb;
                   }
                   if (f) {
                    break db;
                   }
                   if (a) {
                    a = 0 - a | 0;
                    if (!k | !(g & 25690144)) {
                     break eb;
                    }
                    break db;
                   }
                   if ((b & 255) >>> 0 < 16) {
                    break db;
                   }
                   a = e >>> 4 | 0;
                  }
                  Ca = h, Da = Xb(a + v[h + 748 >> 2] | 0, 0, 64), v[Ca + 748 >> 2] = Da;
                 }
                 break Ca;

                case 26:
                 gT(h, c);
                 break Ca;

                case 29:
                 if (!(w[d + 480209 | 0] & 16)) {
                  break Ca;
                 }
                 v[h + 724 >> 2] = c;
                 Ib(i + 8 | 0, o, 60);
                 if (Ca = 0, Da = Fb(v[v[i + 8 >> 2] >> 2], v[i + 12 >> 2]), Fa = w[h + 730 | 0] & 4, 
                 Fa ? Ca : Da) {
                  break Ca;
                 }
                 v[h + 740 >> 2] = c;
                 v[h + 732 >> 2] = c;
                 break Ca;

                case 11:
                 kT(d, G, r & 65535);
                 break Ca;

                case 13:
                 a = jT(d, G, r & 65535, c);
                 if ((a | 0) == -1) {
                  break Ca;
                 }
                 v[d + 1074436 >> 2] = a;
                 if (!(w[d + 480208 | 0] & 32)) {
                  break Ca;
                 }
                 u[d + 1074444 >> 1] = x[d + 1074448 >> 1];
                 break Ca;

                case 37:
                case 38:
                case 39:
                case 40:
                 _S(d, h, c, (H | 0) == 38 | (H | 0) == 40, (H & 254) == 40);
                 break Ca;

                case 41:
                 oT(h, c);
                 break Ca;

                case 42:
                 if (v[d + 1074392 >> 2] | c >>> 0 > 47) {
                  break Ca;
                 }
                 b = c & 15;
                 if (b >>> 0 > 1) {
                  break Ca;
                 }
                 a = (c & 48) == 16;
                 f = a ? x[d + 480188 >> 1] - 1 | 0 : r;
                 a = a ? 0 : r;
                 b = ((b | 0) == 1) << 26;
                 while (1) {
                  e = a & 65535;
                  if (e >>> 0 > (f & 65535) >>> 0) {
                   break Ca;
                  }
                  g = S + B(e, 872) | 0;
                  k = v[g + 88 >> 2];
                  e = Q + (e << 5) | 0;
                  v[e >> 2] = b | v[e >> 2] & -67108865;
                  v[g + 88 >> 2] = b | k & -67108865;
                  a = a + 1 | 0;
                  continue;
                 }
                 ;

                case 44:
                 break Ua;

                default:
                 break Ba;
                }
               }
               nT(h, c);
               break Ca;
              }
              Eo(d, h);
              break Ca;
             }
             uT(d, G, c);
            }
            a = c;
           }
           Ib(i + 8 | 0, o, 78);
           if (!(!Fb(v[v[i + 8 >> 2] >> 2], v[i + 12 >> 2]) | !a)) {
            dT(h, a & 255);
           }
           a = w[h + 789 | 0];
           if (!a) {
            break K;
           }
           t[h + 804 | 0] = a;
          }
          r = r + 1 | 0;
          continue;
         }
         break;
        }
        a = 1;
       }
       eb = s + 32 | 0;
       J = a & v[d + 1074420 >> 2] != 0;
       fb: {
        if (!J) {
         break fb;
        }
        a = sT(d, d + 1074376 | 0);
        v[d + 1074380 >> 2] = a;
        v[d + 1074404 >> 2] = a;
        b = Kd(x[d + 480188 >> 1], 1, 31);
        gb: {
         if (Hd(w[d + 1074366 | 0])) {
          a = v[d + 24628 >> 2];
          if ((a | 0) >= 129) {
           a = ((B(a - 128 | 0, b + 4 | 0) | 0) / 16 | 0) + 128 | 0;
          }
          o = ((B(v[d + 480228 >> 2], a) << 1 & -128) >>> 0) / w[(b >>> 1 | 0) + 30464 | 0] | 0;
          break gb;
         }
         o = v[d + 480228 >> 2];
        }
        u[d + 480212 >> 1] = 0;
        j = d + 1074478 | 0;
        Q = d + 480280 | 0;
        q = d + 1074312 | 0;
        H = d + 1074992 | 0;
        I = d + 480210 | 0;
        G = d + 480209 | 0;
        i = 0;
        while (1) {
         if ((i | 0) == 256) {
          a = v[d + 24608 >> 2];
          b = x[d + 480212 >> 1];
          if (a >>> 0 > b >>> 0) {
           break fb;
          }
          k = eb - 16 | 0;
          eb = k;
          v[k + 12 >> 2] = d;
          c = j + (a << 1) | 0;
          if ((j | 0) != (c | 0)) {
           e = j + (b << 1) | 0;
           h = k + 12 | 0;
           hb: {
            a = c - j >> 1;
            if ((a | 0) < 2) {
             break hb;
            }
            b = a - 2 >>> 1 | 0;
            while (1) {
             if ((b | 0) < 0) {
              break hb;
             }
             ER(j, v[h >> 2], a, j + (b << 1) | 0);
             b = b - 1 | 0;
             continue;
            }
           }
           a = c - j >> 1;
           b = c;
           while (1) {
            if ((b | 0) != (e | 0)) {
             if (Cl(v[h >> 2], x[b >> 1], x[j >> 1])) {
              DR(b, j);
              ER(j, v[h >> 2], a, j);
             }
             b = b + 2 | 0;
             continue;
            }
            break;
           }
           a = c - j >> 1;
           while (1) {
            if ((a | 0) > 1) {
             g = x[j >> 1];
             b = j;
             m = v[h >> 2];
             f = 0;
             e = a;
             i = a - 2 >>> 1 | 0;
             while (1) {
              l = f << 1;
              f = l | 1;
              o = b + l | 0;
              a = o + 2 | 0;
              l = l + 2 | 0;
              if ((l | 0) < (e | 0)) {
               q = l;
               l = o + 4 | 0;
               o = Cl(m, x[a >> 1], x[l >> 1]);
               f = o ? q : f;
               a = o ? l : a;
              }
              u[b >> 1] = x[a >> 1];
              b = a;
              if ((f | 0) <= (i | 0)) {
               continue;
              }
              break;
             }
             f = c - 2 | 0;
             ib: {
              if ((f | 0) == (a | 0)) {
               u[a >> 1] = g;
               break ib;
              }
              u[b >> 1] = x[f >> 1];
              u[f >> 1] = g;
              l = v[h >> 2];
              b = b + 2 | 0;
              a = b - j >> 1;
              jb: {
               if ((a | 0) < 2) {
                break jb;
               }
               f = a - 2 | 0;
               a = j + (f & -2) | 0;
               b = b - 2 | 0;
               if (!Cl(l, x[a >> 1], x[b >> 1])) {
                break jb;
               }
               f = f >>> 1 | 0;
               m = x[b >> 1];
               while (1) {
                kb: {
                 g = b;
                 b = a;
                 u[g >> 1] = x[a >> 1];
                 if (!f) {
                  break kb;
                 }
                 a = f - 1 | 0;
                 f = a >>> 1 | 0;
                 a = j + (a & -2) | 0;
                 if (Cl(l, x[a >> 1], m)) {
                  continue;
                 }
                }
                break;
               }
               u[b >> 1] = m;
              }
             }
             a = e - 1 | 0;
             c = c - 2 | 0;
             continue;
            }
            break;
           }
          }
          eb = k + 16 | 0;
         } else {
          g = H + B(i, 872) | 0;
          lb: {
           if (!(v[g + 88 >> 2] & 4096) | (v[g + 24 >> 2] | (v[g + 20 >> 2] | v[g + 696 >> 2]))) {
            break lb;
           }
           Ib(n + 16 | 0, q, 64);
           if (Fb(v[v[n + 16 >> 2] >> 2], v[n + 20 >> 2])) {
            break lb;
           }
           v[g + 76 >> 2] = 0;
           v[g + 92 >> 2] = 0;
           v[g + 96 >> 2] = 0;
          }
          c = x[d + 480188 >> 1];
          b = v[g + 88 >> 2];
          mb: {
           if (v[g + 76 >> 2] | c >>> 0 > i >>> 0 ? b & 1024 : 1) {
            if (c >>> 0 > i >>> 0) {
             JR(d, i & 65535);
            }
            u[g + 842 >> 1] = 0;
            break mb;
           }
           a = 0;
           v[g + 720 >> 2] = 0;
           v[g + 680 >> 2] = 0;
           v[g + 100 >> 2] = 0;
           v[g + 8 >> 2] = 0;
           v[g + 12 >> 2] = 0;
           v[n + 44 >> 2] = 1065353216;
           u[n + 42 >> 1] = 0;
           s = v[g + 656 >> 2];
           v[n + 36 >> 2] = 0;
           k = 0;
           k = v[g + 700 >> 2] ? v[g + 76 >> 2] != 0 : k;
           nb: {
            ob: {
             pb: {
              if (c >>> 0 <= i >>> 0) {
               break pb;
              }
              if (w[(Q + (i << 5) | 0) + 8 | 0]) {
               break ob;
              }
              if (!s) {
               break pb;
              }
              a = w[s + 34 | 0] != 0;
             }
             if ((a | k) != 1) {
              break nb;
             }
            }
            v[n + 8 >> 2] = v[g + 688 >> 2];
            v[n + 32 >> 2] = v[g + 752 >> 2];
            l = n + 16 | 0;
            Ib(l, q, 28);
            e = n + 8 | 0;
            a = Fb(v[v[n + 16 >> 2] >> 2], v[n + 20 >> 2]) ? n + 32 | 0 : e;
            b = d + 1074312 | 0;
            qb: {
             if (Nb(b, 28)) {
              v[a >> 2] = v[a >> 2] + u[g + 776 >> 1];
              Fe(a, 0, 64);
              break qb;
             }
             c = Nb(b, 1);
             b = u[g + 776 >> 1];
             if (c) {
              v[a >> 2] = b + v[a >> 2];
              Fe(a, 0, 256);
              break qb;
             }
             v[g + 688 >> 2] = b + v[g + 688 >> 2];
             Fe(g + 688 | 0, 0, 256);
             v[a >> 2] = v[g + 688 >> 2];
             u[g + 776 >> 1] = 0;
            }
            rb: {
             sb: {
              a = d + 1074312 | 0;
              if (!Nb(a, 28)) {
               if (!Nb(a, 1)) {
                break sb;
               }
              }
              v[g + 684 >> 2] = v[g + 692 >> 2] + u[g + 778 >> 1];
              Fe(g + 684 | 0, 0, 256);
              break rb;
             }
             v[g + 692 >> 2] = v[g + 692 >> 2] + u[g + 778 >> 1];
             Fe(g + 692 | 0, 0, 256);
             u[g + 778 >> 1] = 0;
             v[g + 684 >> 2] = v[g + 692 >> 2];
            }
            tb: {
             if (!(w[g + 90 | 0] & 4) | (v[d + 480208 >> 2] & 2101248) == 2101248) {
              break tb;
             }
             ub: {
              if (v[e >> 2] <= 0) {
               if (!Nb(d + 1074312 | 0, 21)) {
                break ub;
               }
              }
              c = 5;
              if (!(w[d + 480180 | 0] & 5)) {
               c = Nb(d + 1074312 | 0, 21) ? 5 : 6;
              }
              a = LA(d, w[g + 825 | 0], w[g + 820 | 0]);
              vb: {
               if ((w[g + 825 | 0] & 3) != 1) {
                break vb;
               }
               if (!Nb(d + 1074312 | 0, 89)) {
                break vb;
               }
               a = w[g + 819 | 0];
               f = w[g + 820 | 0];
               b = f << 2 & 124;
               a = (!(w[g + 90 | 0] & 2) | w[d + 480209 | 0] & 16 ? a : w[g + 823 | 0] + a | 0) & 32 ? b ^ 127 : b;
               a = f & 32 ? 0 - a | 0 : a;
              }
              if (v[d + 480180 >> 2] != 131072) {
               a = v[e >> 2] + ((B(w[g + 827 | 0], a) | 0) / (1 << c) | 0) | 0;
              } else {
               b = 64 - a | 0;
               a = v[e >> 2];
               a = ((B(w[g + 827 | 0], B(b, a)) | 0) / -8192 | 0) + a | 0;
              }
              v[e >> 2] = a;
             }
             a = v[d + 480208 >> 2];
             if (!(v[d + 480180 >> 2] & 16777248) | a & 4 ? a & 4096 : 0) {
              break tb;
             }
             a = Nb(d + 1074312 | 0, 21);
             b = w[g + 826 | 0];
             c = w[g + 820 | 0];
             t[g + 820 | 0] = (a ? b << 2 : c) + (a ? c : b);
            }
            f = eb - 16 | 0;
            eb = f;
            a = d + 1074312 | 0;
            Ib(f + 8 | 0, a, 71);
            h = i & 65535;
            b = (B(h, 872) + d | 0) + 1074992 | 0;
            wb: {
             if (Fb(v[v[f + 8 >> 2] >> 2], v[f + 12 >> 2])) {
              c = t[b + 839 | 0];
              if ((c | 0) >= 0) {
               break wb;
              }
              if (!(w[d + 480209 | 0] & 16 | w[b + 805 | 0] != 18)) {
               xb: {
                yb: {
                 if ((c & -33) != -64) {
                  a = c & 223;
                  if ((a | 0) != 128) {
                   break yb;
                  }
                  c = w[b + 840 | 0] >>> 4 | -64;
                  break xb;
                 }
                 c = w[b + 840 | 0] & 15 | -128;
                 break xb;
                }
                c = a - 1 | 0;
               }
               t[b + 839 | 0] = c;
               v[b + 88 >> 2] = v[b + 88 >> 2] | 2097152;
              }
              if ((c & 224) != 128) {
               break wb;
              }
              v[e >> 2] = 0;
              break wb;
             }
             if (w[b + 805 | 0] != 18) {
              break wb;
             }
             Ib(f + 8 | 0, a, 22);
             zb: {
              if (Fb(v[v[f + 8 >> 2] >> 2], v[f + 12 >> 2])) {
               a = w[b + 839 | 0];
               c = a << 24 >> 24;
               if (!(!v[b + 76 >> 2] | (c | 0) >= 0)) {
                Ab: {
                 Bb: {
                  if ((a | 0) != 192) {
                   if ((a | 0) != 128) {
                    break Bb;
                   }
                   c = w[b + 840 | 0] >>> 4 | -64;
                   break Ab;
                  }
                  c = w[b + 840 | 0] & 15 | -128;
                  break Ab;
                 }
                 c = c - 1 | 0;
                }
                t[b + 839 | 0] = c;
               }
               if ((c & 192) != 128) {
                break zb;
               }
               v[e >> 2] = 0;
               break zb;
              }
              a = w[b + 840 | 0];
              c = a >>> 4 | 0;
              r = c + (a & 15) | 0;
              m = v[d + 480180 >> 2];
              if (!(w[d + 480208 | 0] & 4 ? 0 : m & 16777248)) {
               r = r + 2 | 0;
               c = c + 1 | 0;
              }
              a = w[b + 839 | 0];
              if (!(m & 4)) {
               a = (a & 255) >>> 0 < r >>> 0 ? a : 0;
               if ((a & 255) >>> 0 >= c >>> 0) {
                v[e >> 2] = 0;
               }
               t[b + 839 | 0] = a + 1;
               break zb;
              }
              Cb: {
               if (w[d + 480209 | 0] & 16) {
                a = a & 255;
                m = a - 1 | 0;
                a = a >>> 0 >= m >>> 0 ? m : 0;
                break Cb;
               }
               t[b + 839 | 0] = a + 1;
              }
              if (((a & 255) >>> 0) % (r >>> 0) >>> 0 < c >>> 0) {
               break zb;
              }
              v[e >> 2] = 0;
             }
             v[b + 88 >> 2] = v[b + 88 >> 2] | 2097152;
            }
            Db: {
             if (w[b + 805 | 0] != 18) {
              break Db;
             }
             c = v[b + 656 >> 2];
             if (!c) {
              break Db;
             }
             a = w[c + 34 | 0];
             if (v[b + 88 >> 2] & 134218752 | (!a | w[c + 15 | 0] & 2)) {
              break Db;
             }
             m = w[b + 799 | 0];
             if (!Tc(m)) {
              break Db;
             }
             a = v[_d(d + 906300 | 0, a - 1 | 0) >> 2];
             if (!a) {
              break Db;
             }
             m = hb[v[v[a >> 2] + 104 >> 2]](a, m, h) | 0;
             r = v[e >> 2];
             if (!(!m | r)) {
              hb[v[v[a >> 2] + 96 >> 2]](a, c, w[b + 799 | 0] | 256, 0, h);
              break Db;
             }
             if (m | !r) {
              break Db;
             }
             hb[v[v[a >> 2] + 96 >> 2]](a, c, w[b + 799 | 0], x[b + 688 >> 1], h);
            }
            eb = f + 16 | 0;
            Fe(e, 0, 256);
            v[n + 8 >> 2] = v[n + 8 >> 2] << 6;
            Eb: {
             if (s) {
              Ib(l, q, 31);
              if (Fb(v[v[n + 16 >> 2] >> 2], v[n + 20 >> 2])) {
               Ou(d, g);
              }
              a = n + 8 | 0;
              Fb: {
               if (!JA(d, g, 0)) {
                break Fb;
               }
               c = v[g + 656 >> 2];
               e = d + 1074312 | 0;
               f = Nb(e, 31);
               b = v[g + 724 >> 2];
               if (b ? 0 : f) {
                break Fb;
               }
               l = b - Nb(e, 31) | 0;
               b = Rq(c + 48 | 0, l, 256, 64);
               m = w[c + 65 | 0];
               Gb: {
                if ((m | 0) == 255) {
                 break Gb;
                }
                f = u[g + 728 >> 1];
                if ((f | 0) == -1) {
                 break Gb;
                }
                m = xb(v[c + 48 >> 2], m);
                r = w[m + 2 | 0];
                c = r << 2;
                b = (l | 0) == x[m >> 1] ? c : b;
                if (Nb(e, 94)) {
                 b = f + (b - c << 1) | 0;
                 break Gb;
                }
                if (!r) {
                 b = 0;
                 break Gb;
                }
                b = (B(b, f) | 0) / (c | 0) | 0;
               }
               Ca = a, Da = (B(Xb(b, 0, 512), v[a >> 2]) | 0) / 256 | 0, v[Ca >> 2] = Da;
              }
              YS(g, a);
              Hb: {
               if (!JA(d, g, 1)) {
                break Hb;
               }
               a = v[g + 656 >> 2];
               b = d + 1074312 | 0;
               f = Nb(b, 31);
               c = v[g + 732 >> 2];
               if (c ? 0 : f) {
                break Hb;
               }
               b = Rq(a + 68 | 0, c - Nb(b, 31) | 0, 64, 64) - 32 | 0;
               a = v[g + 684 >> 2];
               Ca = g, Da = Xb(((B(b, (a | 0) > 127 ? 256 - a | 0 : a) | 0) / 32 | 0) + a | 0, 0, 256), 
               v[Ca + 684 >> 2] = Da;
              }
              Ib(n + 16 | 0, q, 115);
              if (Fb(v[v[n + 16 >> 2] >> 2], v[n + 20 >> 2])) {
               break Eb;
              }
              b = w[g + 797 | 0];
              if (!b) {
               break Eb;
              }
              a = v[g + 656 >> 2];
              if (!a | !w[a + 26 | 0]) {
               break Eb;
              }
              $S(g + 684 | 0, b, w[a + 26 | 0], w[a + 27 | 0]);
              break Eb;
             }
             if (!(w[g + 89 | 0] & 16)) {
              break Eb;
             }
             v[g + 696 >> 2] = 0;
             v[n + 8 >> 2] = 0;
            }
            Ib: {
             if (w[g + 851 | 0] & 8) {
              b = 0;
              v[n + 8 >> 2] = 0;
              break Ib;
             }
             b = v[n + 8 >> 2];
             if (!b) {
              b = 0;
              break Ib;
             }
             if (w[g + 91 | 0] & 8) {
              v[g + 680 >> 2] = 0;
              break Ib;
             }
             if (Hd(w[d + 1074365 | 0])) {
              a = B(v[n + 32 >> 2], v[g + 748 >> 2]);
              c = a;
              f = a >> 31;
              a = b << 8;
              Ca = g, Da = Fc(Bua(Aua(c, f, a, a >> 31), gb, 1048576, 0), gb), v[Ca + 680 >> 2] = Da;
              break Ib;
             }
             a = B(v[n + 32 >> 2], v[g + 748 >> 2]);
             c = a;
             f = a >> 31;
             a = B(v[d + 1074456 >> 2], b);
             Ca = g, Da = Fc(Bua(Aua(c, f, a, a >> 31), gb, 1048576, 0), gb), v[Ca + 680 >> 2] = Da;
            }
            r = g + 700 | 0;
            v[g + 720 >> 2] = b;
            Jb: {
             Kb: {
              b = v[g + 700 >> 2];
              if (!(v[d + 480180 >> 2] == 2 | (b | 0) >= v[d + 480260 >> 2])) {
               if (!yj(d)) {
                break Kb;
               }
               b = v[r >> 2];
              }
              if ((b | 0) < v[d + 480264 >> 2]) {
               break Jb;
              }
              Ib(n + 16 | 0, q, 113);
              if (!Fb(v[v[n + 16 >> 2] >> 2], v[n + 20 >> 2])) {
               break Jb;
              }
              if (yj(d)) {
               break Jb;
              }
              v[r >> 2] = v[d + 480264 >> 2];
              break Jb;
             }
             v[r >> 2] = v[d + 480260 >> 2];
            }
            Ib(n + 16 | 0, q, 73);
            a = v[g + 700 >> 2];
            v[n + 36 >> 2] = a;
            Lb: {
             if ((v[g + 88 >> 2] & 1572864) != 1572864) {
              break Lb;
             }
             b = v[d + 480208 >> 2];
             if (b & 2097152) {
              if (!Il(w[g + 790 | 0], w[g + 791 | 0]) | b & 4096) {
               break Lb;
              }
             }
             Mb: {
              if ((a | 0) == v[g + 712 >> 2]) {
               b = v[g + 716 >> 2];
               break Mb;
              }
              v[g + 712 >> 2] = a;
              b = yh(d, Lu(d, a, u[g + 772 >> 1], v[g + 704 >> 2]), u[g + 772 >> 1], v[g + 704 >> 2]);
              v[g + 716 >> 2] = b;
             }
             v[n + 36 >> 2] = b;
            }
            l = eb - 16 | 0;
            eb = l;
            a = B(h, 872) + d | 0;
            e = a + 1074992 | 0;
            a = v[a + 1075648 >> 2];
            Nb: {
             if (!a) {
              break Nb;
             }
             b = w[a + 34 | 0];
             if (v[e + 88 >> 2] & 134218752 | (!b | w[a + 15 | 0] & 2)) {
              break Nb;
             }
             if (!v[_d(d + 906300 | 0, b - 1 | 0) >> 2]) {
              break Nb;
             }
             a = w[e + 801 | 0];
             f = w[e + 791 | 0];
             Ob: {
              Pb: {
               if ((f | 0) == 1) {
                b = a;
                Qb: {
                 Rb: {
                  switch (((y[d + 1074392 >> 2] % (v[d + 1074400 >> 2] + v[d + 1074416 >> 2] >>> 0) >>> 0) % 3 | 0) - 1 | 0) {
                  case 0:
                   b = a + (w[e + 806 | 0] >>> 4 | 0) | 0;
                   break Qb;

                  case 1:
                   break Rb;

                  default:
                   break Qb;
                  }
                 }
                 b = a + (w[e + 806 | 0] & 15) | 0;
                }
                if (w[e + 800 | 0] == (b & 255)) {
                 break Ob;
                }
                if (!(t[e + 851 | 0] & 1)) {
                 break Pb;
                }
                if (!Tc(w[e + 788 | 0])) {
                 break Pb;
                }
                if (Il(w[e + 790 | 0], 1)) {
                 break Pb;
                }
                break Ob;
               }
               if (w[e + 788 | 0]) {
                b = a;
                if (!Il(w[e + 790 | 0], f)) {
                 break Ob;
                }
               }
               b = a;
               if (!w[e + 800 | 0]) {
                break Ob;
               }
              }
              Wm(d, h, b & 255 | 512, x[e + 688 >> 1]);
             }
             c = w[e + 800 | 0];
             Sb: {
              Tb: {
               if (c) {
                if ((f | 0) != 1 | (b & 255) != (c | 0)) {
                 break Tb;
                }
                break Sb;
               }
               if (!(t[e + 851 | 0] & 1) | (f | 0) != 1) {
                break Sb;
               }
               if (Tc(w[e + 788 | 0])) {
                break Sb;
               }
               c = a;
               if (!Tc(a)) {
                break Sb;
               }
              }
              Wm(d, h, c & 255 | 256, 0);
             }
             t[e + 800 | 0] = w[e + 791 | 0] == 1 ? b : 0;
            }
            Ub: {
             if (w[e + 805 | 0] != 1) {
              break Ub;
             }
             if (Jj(v[e + 656 >> 2])) {
              b = 0;
              Vb: {
               Wb: {
                switch ((y[d + 1074392 >> 2] % 3 | 0) - 1 | 0) {
                case 0:
                 b = w[e + 806 | 0] >>> 4 | 0;
                 break Vb;

                case 1:
                 break Wb;

                default:
                 break Vb;
                }
               }
               b = w[e + 806 | 0] & 15;
              }
              u[n + 42 >> 1] = b;
              t[e + 851 | 0] = w[e + 851 | 0] | 96;
              break Ub;
             }
             if (!(!(w[d + 480209 | 0] & 16) | v[d + 480180 >> 2] != 1048576)) {
              a = yh(d, w[e + 797 | 0], u[e + 772 >> 1], v[e + 704 >> 2]);
              v[n + 36 >> 2] = a;
              v[e + 700 >> 2] = a;
             }
             c = d + 1074312 | 0;
             Ib(l + 8 | 0, c, 13);
             if (Fb(v[v[l + 8 >> 2] >> 2], v[l + 12 >> 2])) {
              b = w[e + 806 | 0];
              if (!b) {
               break Ub;
              }
              a = 65536;
              Xb: {
               switch (((y[d + 1074392 >> 2] % (v[d + 1074400 >> 2] + v[d + 1074416 >> 2] >>> 0) >>> 0) % 3 | 0) - 1 | 0) {
               case 1:
                b = b << 4;

               case 0:
                a = v[((b & 240) << 2) + 35472 >> 2];
                break;

               default:
                break Xb;
               }
              }
              e = yj(d);
              b = v[n + 36 >> 2];
              c = b >> 31;
              if (e) {
               a = Aua(b, c, a, a >> 31);
               f = gb;
               a = a + 32768 | 0;
               f = a >>> 0 < 32768 ? f + 1 | 0 : f;
               a = Bua(a, f, 65536, 0);
               b = gb;
              } else {
               e = (a | 0) / 2 | 0;
               f = e >> 31;
               h = c << 16 | b >>> 16;
               c = b << 16;
               b = c + e | 0;
               m = h + f | 0;
               a = Bua(b, b >>> 0 < c >>> 0 ? m + 1 | 0 : m, a, a >> 31);
               b = gb;
              }
              Ca = n, Da = Fc(a, b), v[Ca + 36 >> 2] = Da;
              break Ub;
             }
             Ib(l + 8 | 0, c, 51);
             if (Fb(v[v[l + 8 >> 2] >> 2], v[l + 12 >> 2])) {
              if (w[d + 480209 | 0] & 16) {
               break Ub;
              }
              Yb: {
               Zb: {
                a = v[d + 1074416 >> 2];
                a = a - (y[d + 1074392 >> 2] % (a >>> 0) | 0) | 0;
                if ((a | 0) > 16) {
                 break Zb;
                }
                if ((a | 0) == 16) {
                 break Ub;
                }
                b = 0;
                _b: {
                 switch ((a | 0) % 3 | 0) {
                 case 0:
                  break Ub;

                 case 2:
                  break Zb;

                 case 1:
                  break _b;

                 default:
                  break Yb;
                 }
                }
                b = w[e + 806 | 0] >>> 4 | 0;
                break Yb;
               }
               b = w[e + 806 | 0] & 15;
              }
              a = Lu(d, v[n + 36 >> 2], u[e + 772 >> 1], v[e + 704 >> 2]) + b | 0;
              b = yh(d, a, u[e + 772 >> 1], v[e + 704 >> 2]);
              v[n + 36 >> 2] = b;
              if (a >>> 0 < 109) {
               break Ub;
              }
              v[l + 8 >> 2] = b;
              Ca = l, Da = yh(d, 109, 0, v[e + 704 >> 2]), v[Ca + 4 >> 2] = Da;
              Ca = n, Da = v[ad(l + 8 | 0, l + 4 | 0) >> 2], v[Ca + 36 >> 2] = Da;
              break Ub;
             }
             f = v[d + 1074392 >> 2];
             a = v[d + 480180 >> 2];
             $b: {
              if ((a | 0) != 1) {
               b = w[e + 797 | 0];
               break $b;
              }
              b = Lu(d, v[n + 36 >> 2], u[e + 772 >> 1], v[e + 704 >> 2]);
              a = v[d + 480180 >> 2];
             }
             ac: {
              bc: {
               switch ((((a & 67633152 ? f + 2 | 0 : f) >>> 0) % 3 | 0) - 1 | 0) {
               case 0:
                b = (w[e + 806 | 0] >>> 4 | 0) + b | 0;
                break ac;

               case 1:
                break bc;

               default:
                break ac;
               }
              }
              b = (w[e + 806 | 0] & 15) + b | 0;
             }
             if (!(a & 67633408 | w[e + 797 | 0] != (b & 255))) {
              Ib(l + 8 | 0, c, 82);
              if (!Fb(v[v[l + 8 >> 2] >> 2], v[l + 12 >> 2])) {
               break Ub;
              }
             }
             if (w[d + 480210 | 0] & 32) {
              a = b & 255;
              if ((a | 0) == 85) {
               v[n + 36 >> 2] = 2147483647;
               break Ub;
              }
              b = a >>> 0 > 85 ? b - 37 | 0 : b;
             }
             a = yh(d, b & 255, u[e + 772 >> 1], v[e + 704 >> 2]);
             v[n + 36 >> 2] = a;
             if (v[d + 480180 >> 2] & 71860480) {
              v[e + 700 >> 2] = a;
              break Ub;
             }
             Ib(l + 8 | 0, c, 82);
             if (!Fb(v[v[l + 8 >> 2] >> 2], v[l + 12 >> 2])) {
              break Ub;
             }
             t[e + 800 | 0] = b;
            }
            eb = l + 16 | 0;
            if (!(!(w[I | 0] & 33) | v[n + 36 >> 2] == 2147483647)) {
             cc: {
              if (v[d + 480180 >> 2] == 2) {
               b = 452;
               a = 3424;
               break cc;
              }
              a = B(x[g + 772 >> 1] >>> 4 & 15, 24);
              b = x[a + 31206 >> 1] >>> 1 | 0;
              b = b >>> 0 <= 452 ? 452 : b;
              a = x[a + 31184 >> 1] << 1;
             }
             Fe(n + 36 | 0, b, a);
             Fe(r, b, a);
            }
            eT(d, g);
            b = v[g + 88 >> 2];
           }
           dc: {
            if (!(b & 256) | w[G | 0] & 64) {
             break dc;
            }
            Ib(n + 16 | 0, q, 37);
            if (!Fb(v[v[n + 16 >> 2] >> 2], v[n + 20 >> 2])) {
             break dc;
            }
            v[g + 684 >> 2] = 128;
           }
           a = rT(d, g);
           ec: {
            if ((a | 0) < 0 | !(w[g + 89 | 0] & 2)) {
             break ec;
            }
            b = v[d + 1298300 >> 2];
            if (!Dd(b)) {
             break ec;
            }
            Pq(b, i & 65535, a & 255, 1);
           }
           l = i & 65535;
           JR(d, l);
           fc: {
            if (!k) {
             break fc;
            }
            a = ZS(d, g, n + 36 | 0);
            if ((a | 0) < 0 | !(w[g + 89 | 0] & 2)) {
             break fc;
            }
            b = v[d + 1298300 >> 2];
            if (!Dd(b)) {
             break fc;
            }
            Pq(b, l, a >>> 2 & 255, 1);
           }
           gc: {
            if (w[g + 790 | 0] != 8) {
             break gc;
            }
            hc: {
             ic: {
              a = w[g + 791 | 0];
              switch (a - 5 | 0) {
              case 1:
               break gc;

              case 0:
              case 2:
               break hc;

              default:
               break ic;
              }
             }
             if ((a | 0) != 26) {
              break gc;
             }
            }
            a = v[d + 480180 >> 2];
            if ((a | 0) == 4) {
             if (w[G | 0] & 16) {
              break gc;
             }
             t[g + 819 | 0] = w[g + 819 | 0] + w[g + 823 | 0];
             break gc;
            }
            if (!(a & 16777248)) {
             break gc;
            }
            Fl(g, w[g + 792 | 0]);
            IR(d, l, n + 36 | 0, n + 44 | 0);
           }
           a = n + 36 | 0;
           IR(d, l, a, n + 44 | 0);
           jc: {
            if (!k) {
             break jc;
            }
            v[n + 32 >> 2] = 0;
            h = eb - 16 | 0;
            eb = h;
            c = v[g + 104 >> 2];
            kc: {
             if (!c | !w[c + 40 | 0]) {
              break kc;
             }
             m = Jj(v[g + 656 >> 2]);
             k = yj(d);
             b = k ? 36496 : 35472;
             e = k ? 35472 : 36496;
             if (!(m | !Nb(d + 1074312 | 0, 21) | v[d + 480180 >> 2] == 1048576)) {
              r = w[c + 41 | 0];
              if (!r) {
               break kc;
              }
              f = w[g + 818 | 0];
              v[h + 12 >> 2] = v[g + 756 >> 2] + w[c + 39 | 0];
              ti(h + 12 | 0, w[c + 40 | 0] << 8);
              m = v[h + 12 >> 2];
              t[g + 818 | 0] = f + r;
              v[g + 756 >> 2] = m;
              m = (m | 0) / 256 | 0;
              lc: {
               mc: {
                switch (w[c + 38 | 0] - 1 | 0) {
                case 3:
                 f = GR(Do(d)) + -64 | 0;
                 break lc;

                case 2:
                 f = 64 - (f + 1 >>> 1 | 0) | 0;
                 break lc;

                case 1:
                 f = (f + 1 >>> 1 | 0) + -64 | 0;
                 break lc;

                case 0:
                 f = (f ^ -1) >>> 1 & 64;
                 break lc;

                default:
                 break mc;
                }
               }
               f = t[f + 31776 | 0];
              }
              ti(a, 8388607);
              c = v[a >> 2] << 8;
              v[a >> 2] = c;
              E = B(f, m);
              m = (E | 0) / 64 | 0;
              f = m >> 31;
              f = (f ^ m) - f | 0;
              m = f & 3;
              r = f >>> 2 | 0;
              f = a;
              a = c >> 31;
              L = a;
              nc: {
               oc: {
                if ((E | 0) <= -64) {
                 b = v[(r << 2) + b >> 2];
                 a = Fc(Bua(Aua(b, b >> 31, c, a), gb, 65536, 0), gb) - c | 0;
                 if (!m) {
                  break nc;
                 }
                 b = k ? 35408 : 35344;
                 break oc;
                }
                b = v[e + (r << 2) >> 2];
                a = Fc(Bua(Aua(b, b >> 31, c, a), gb, 65536, 0), gb) - c | 0;
                if (!m) {
                 break nc;
                }
                b = k ? 35344 : 35408;
               }
               b = v[(m << 2) + b >> 2];
               a = (Fc(Bua(Aua(c, L, b, b >> 31), gb, 65536, 0), gb) + a | 0) - c | 0;
              }
              v[f >> 2] = (a + c | 0) / 256;
              v[n + 32 >> 2] = a & 255;
              break kc;
             }
             k = v[d + 480180 >> 2] & 16777248;
             f = w[c + 39 | 0];
             pc: {
              if (!(k | f)) {
               v[g + 756 >> 2] = w[c + 40 | 0] << 8;
               break pc;
              }
              qc: {
               if (k) {
                v[g + 756 >> 2] = v[g + 756 >> 2] + (f << 1);
                k = w[c + 40 | 0];
                break qc;
               }
               k = w[c + 40 | 0];
               if (w[g + 89 | 0] & 8) {
                break qc;
               }
               v[g + 756 >> 2] = v[g + 756 >> 2] + (((k << 8 & 65280) >>> 0) / (f >>> 0) | 0);
              }
              ti(g + 756 | 0, k << 8);
             }
             f = w[g + 818 | 0] + w[c + 41 | 0] | 0;
             t[g + 818 | 0] = f;
             f = f << 24 >> 24;
             rc: {
              sc: {
               switch (w[c + 38 | 0] - 1 | 0) {
               case 3:
                t[g + 818 | 0] = f + 1;
                k = t[(f & 63) + 31712 | 0];
                break rc;

               case 2:
                k = (64 - (f >>> 1 | 0) & 127) + -64 | 0;
                break rc;

               case 1:
                k = ((f & 254) >>> 1 ^ 64) + -64 | 0;
                break rc;

               case 0:
                k = (f | 0) >= 0 ? -64 : 64;
                break rc;

               default:
                break sc;
               }
              }
              k = 0 - t[(f & 255) + 31776 | 0] | 0;
              if (v[d + 480180 >> 2] != 1048576) {
               break rc;
              }
              k = (64 - t[(f + -64 & 255) + 31776 | 0] | 0) / 2 << 16 >> 16;
             }
             f = k;
             r = B(f, v[g + 756 >> 2]);
             k = (r | 0) / 256 | 0;
             if (m) {
              z[n + 44 >> 2] = z[n + 44 >> 2] + C(C(C(C(w[c + 40 | 0]) * C(.05000000074505806)) * C(f | 0)) * C(.000244140625));
              t[g + 851 | 0] = w[g + 851 | 0] | 64;
              break kc;
             }
             if (v[d + 480180 >> 2] != 4) {
              tc: {
               if ((r | 0) <= -256) {
                k = 0 - k | 0;
                c = k >>> 8 | 0;
                e = (c << 2) + b | 0;
                break tc;
               }
               b = e;
               c = k >>> 8 | 0;
               e = b + (c << 2) | 0;
              }
              f = v[a >> 2];
              c = v[((c << 2) + b | 0) + 4 >> 2];
              b = v[e >> 2];
              b = ((B(c - b | 0, k >>> 2 & 63) | 0) / 64 | 0) + b | 0;
              b = Fc(Bua(Aua(f, f >> 31, b, b >> 31), gb, 256, 0), gb);
              v[a >> 2] = b;
              v[n + 32 >> 2] = b & 255;
              v[a >> 2] = v[a >> 2] / 256;
              break kc;
             }
             v[a >> 2] = v[a >> 2] + ((r | 0) / 16384 | 0);
            }
            eb = h + 16 | 0;
            k = v[n + 36 >> 2];
            if ((k | 0) <= v[d + 480260 >> 2]) {
             Ib(n + 16 | 0, q, 81);
             if (Fb(v[v[n + 16 >> 2] >> 2], v[n + 20 >> 2])) {
              v[g + 76 >> 2] = 0;
             }
             k = v[d + 480260 >> 2];
             v[n + 36 >> 2] = k;
            }
            uc: {
             if (!Jj(v[g + 656 >> 2])) {
              break uc;
             }
             a = w[g + 851 | 0];
             if (!(v[d + 1074392 >> 2] | !(a & 32) ? a & 64 : 1)) {
              break uc;
             }
             eV(g, z[n + 44 >> 2], u[n + 42 >> 1], d);
             a = w[g + 851 | 0];
             t[g + 851 | 0] = (a & 64 ? -65 : -97) & a;
            }
            a = n + 16 | 0;
            zB(a, d, g, k, v[n + 32 >> 2]);
            c = zb(a);
            a = Aua(v[n + 16 >> 2], v[n + 20 >> 2], v[d + 480240 >> 2], 0);
            m = gb;
            b = Bua(a, m, 65536, 0);
            e = gb;
            f = b;
            a = a + 65535 | 0;
            b = !(a >>> 0 < 65535 ? m + 1 | 0 : m) & a >>> 0 < 131071;
            a = b ? 1 : f;
            v[n + 16 >> 2] = a;
            b = b ? 0 : e;
            v[n + 20 >> 2] = b;
            v[g + 8 >> 2] = a;
            v[g + 12 >> 2] = b;
            if ((v[g + 88 >> 2] & 134219264) != 512) {
             break jc;
            }
            if (!Dd(v[d + 1298300 >> 2])) {
             break jc;
            }
            Ib(n + 8 | 0, q, 99);
            a = v[g + 88 >> 2];
            b = a & 4096;
            vc: {
             wc: {
              if (Ca = Fb(v[v[n + 8 >> 2] >> 2], v[n + 12 >> 2]), Da = 1, Fa = b, Fa ? Ca : Da) {
               e = v[d + 480180 >> 2];
               break wc;
              }
              e = v[d + 480180 >> 2];
              if ((e | 0) != 2) {
               break vc;
              }
             }
             f = (e | 0) == 2;
             e = a & 2048;
             xc: {
              if (e ? f : 0) {
               break xc;
              }
              a = v[d + 480240 >> 2];
              c = Aua(v[c >> 2], 0, 261625, 0);
              f = gb;
              c = c + 66904 | 0;
              f = c >>> 0 < 66904 ? f + 1 | 0 : f;
              a = Aua(a, 0, Ac(Cua(c, f, 133808, 0), gb), 0);
              m = gb;
              a = a + 32768 | 0;
              m = a >>> 0 < 32768 ? m + 1 | 0 : m;
              c = Ac((m & 65535) << 16 | a >>> 16, m >>> 16 | 0);
              a = 1;
              yc: {
               if (e) {
                break yc;
               }
               a = 0;
               if (!b) {
                break yc;
               }
               a = !v[g + 696 >> 2];
              }
              b = n + 8 | 0;
              Ib(b, q, 110);
              if (Ca = Fb(v[v[n + 8 >> 2] >> 2], v[n + 12 >> 2]), Da = 0, Fa = a, Fa ? Ca : Da) {
               break xc;
              }
              e = v[d + 1298300 >> 2];
              Ib(b, q, 95);
              TB(e, l, c, a, Fb(v[v[n + 8 >> 2] >> 2], v[n + 12 >> 2]));
             }
             a = v[d + 1298300 >> 2];
             b = Aua(B(v[g + 752 >> 2], B(v[g + 748 >> 2], v[g + 720 >> 2])), 0, 63, 0);
             h = gb;
             b = b + 33554432 | 0;
             h = b >>> 0 < 33554432 ? h + 1 | 0 : h;
             Pq(a, l, Ac((h & 67108863) << 6 | b >>> 26, h >>> 26 | 0) & 255, 0);
             b = v[g + 684 >> 2];
             c = 0;
             a = v[d + 1298300 >> 2];
             e = Ol(a, l);
             zc: {
              if ((e | 0) == 255) {
               break zc;
              }
              f = v[a >> 2];
              if (Ej(f)) {
               break zc;
              }
              c = wb(Ud(a + 318 | 0, e), 10);
              h = v[a + 4 >> 2];
              e = cv(e) | 192;
              a = w[c | 0] & -49;
              a = (b | 0) < 171 ? a | 16 : a;
              a = (b | 0) > 84 ? a | 32 : a;
              zh(f, h, l, e, a & 255);
              c = (a >>> 5 & 1) + (a << 27 >> 31) | 0;
             }
             v[g + 684 >> 2] = (c << 7) + 128;
            }
            Ac: {
             a = v[g + 656 >> 2];
             if (!a | (w[a + 60 | 0] & 7) != 1) {
              break Ac;
             }
             b = v[a + 48 >> 2];
             a = v[a + 52 >> 2];
             if (lc(b, a)) {
              break Ac;
             }
             b = v[HR(g, 0) >> 2];
             a = wf(a);
             if (b >>> 0 < x[a >> 1] | w[a + 2 | 0]) {
              break Ac;
             }
             Dj(v[d + 1298300 >> 2], l, 1);
             Ib(n + 8 | 0, q, 109);
             a = v[v[n + 8 >> 2] >> 2];
             b = v[n + 12 >> 2];
             v[g + 696 >> 2] = 0;
             c = v[g + 88 >> 2];
             Ca = g, Da = (Fb(a, b) ? c : c & -4609) | 4096, v[Ca + 88 >> 2] = Da;
             break jc;
            }
            Ib(n + 8 | 0, q, 99);
            if (!Fb(v[v[n + 8 >> 2] >> 2], v[n + 12 >> 2]) | !(w[g + 89 | 0] & 16) | v[g + 696 >> 2]) {
             break jc;
            }
            Dj(v[d + 1298300 >> 2], l, 1);
            v[g + 88 >> 2] = v[g + 88 >> 2] & -513;
           }
           Bc: {
            if (!s) {
             break Bc;
            }
            Ib(n + 16 | 0, q, 31);
            if (Fb(v[v[n + 16 >> 2] >> 2], v[n + 20 >> 2])) {
             break Bc;
            }
            Ou(d, g);
           }
           v[g + 672 >> 2] = 0;
           v[g + 676 >> 2] = 0;
           a = w[g + 842 | 0];
           b = a - 4 | 0;
           b = a >>> 0 >= b >>> 0 ? b : 0;
           t[g + 842 | 0] = b;
           a = w[g + 843 | 0];
           c = a - 4 | 0;
           a = a >>> 0 >= c >>> 0 ? c : 0;
           t[g + 843 | 0] = a;
           f = v[g + 88 >> 2];
           h = v[g + 680 >> 2];
           e = f & -65537 | (h | (v[g + 24 >> 2] | v[g + 20 >> 2]) ? !(f & 512) << 16 : 0);
           v[g + 88 >> 2] = e;
           Cc: {
            Dc: {
             Ec: {
              Fc: {
               Gc: {
                Hc: {
                 Ic: {
                  Jc: {
                   Kc: {
                    c = v[g + 104 >> 2];
                    Lc: {
                     if (!c) {
                      break Lc;
                     }
                     k = v[c + 20 >> 2];
                     if (!ke(v[c >> 2], k) | !v[g + 76 >> 2]) {
                      break Lc;
                     }
                     if (Li(v[g + 8 >> 2], v[g + 12 >> 2])) {
                      break Kc;
                     }
                    }
                    v[g + 16 >> 2] = 0;
                    break Jc;
                   }
                   v[g + 16 >> 2] = k;
                   if (k) {
                    break Ic;
                   }
                  }
                  if (!Aj(v[g + 656 >> 2])) {
                   break Hc;
                  }
                  k = 0;
                  if (f & 6144) {
                   break Hc;
                  }
                 }
                 l = v[g + 684 >> 2];
                 c = (B(h, 256 - l | 0) | 0) / 16384 | 0;
                 c = c >>> 0 >= 127 ? 127 : c;
                 if (b << 24 >> 24 < 0) {
                  t[g + 842 | 0] = c;
                  m = c;
                 } else {
                  m = b;
                 }
                 b = c >>> 1 | 0;
                 if ((m & 255) >>> 0 < b >>> 0) {
                  t[g + 842 | 0] = b;
                 }
                 b = (B(h, l) | 0) / 16384 | 0;
                 b = b >>> 0 >= 127 ? 127 : b;
                 if (a << 24 >> 24 < 0) {
                  t[g + 843 | 0] = b;
                  a = b;
                 }
                 b = b >>> 1 | 0;
                 if (b >>> 0 > (a & 255) >>> 0) {
                  break Gc;
                 }
                 break Fc;
                }
                if ((b & 255) >>> 0 >= 129) {
                 t[g + 842 | 0] = 0;
                }
                k = 0;
                b = 0;
                if ((a & 255) >>> 0 < 129) {
                 break Ec;
                }
               }
               t[g + 843 | 0] = b;
              }
              if (!k) {
               break Ec;
              }
              k = 128;
              e = v[d + 24624 >> 2];
              if (e >>> 0 >= 2) {
               k = Xb(v[g + 684 >> 2], 0, 256);
              }
              v[n + 16 >> 2] = k;
              b = B(h, o) >>> (Hd(w[d + 1074366 | 0]) ? 7 : 8) | 0;
              Mc: {
               Nc: {
                Oc: {
                 switch (w[d + 1074364 | 0]) {
                 case 0:
                  if (!(w[d + 24616 | 0] & 16)) {
                   break Nc;
                  }

                 case 1:
                  if ((k | 0) <= 127) {
                   a = b >>> 1 | 0;
                   c = (B(b, k) | 0) / 256 | 0;
                   break Mc;
                  }
                  a = (B(b, 256 - k | 0) | 0) / 256 | 0;
                  c = b >>> 1 | 0;
                  break Mc;

                 case 3:
                  break Oc;

                 default:
                  break Nc;
                 }
                }
                ti(n + 16 | 0, 255);
                c = v[n + 16 >> 2];
                if ((c | 0) <= 0) {
                 a = 65536;
                } else {
                 a = x[(0 - c << 1) + 38032 >> 1];
                }
                a = B(a, b) >>> 16 | 0;
                c = B(b, x[(c << 1) + 37520 >> 1]) >>> 16 | 0;
                break Mc;
               }
               a = (B(b, 256 - k | 0) | 0) / 256 | 0;
               c = (B(b, k) | 0) / 256 | 0;
              }
              b = v[g + 656 >> 2];
              Pc: {
               if (b) {
                k = w[b + 14 | 0];
                if (up(k)) {
                 break Pc;
                }
               }
               k = w[d + 480268 | 0];
               if (up(k)) {
                break Pc;
               }
               b = w[d + 24648 | 0];
               k = w[I | 0] & 128 ? v[d + 24668 >> 2] ? -1 : b : b;
              }
              t[g + 794 | 0] = k;
              b = v[g + 8 >> 2];
              h = v[g + 12 >> 2];
              if (!(f & 131072 | ((b | 0) != 0 | (h | 0) != 1) | (v[g + 756 >> 2] | (k & 255) == 255))) {
               t[g + 794 | 0] = 0;
              }
              k = a;
              a = 1 << v[d + 1074360 >> 2];
              v[g + 672 >> 2] = (k | 0) / (a | 0);
              a = (c | 0) / (a | 0) | 0;
              v[g + 676 >> 2] = (f & 256) >>> 8 | 0 ? (e | 0) == 2 ? 0 - a | 0 : a : a;
              if (f & 128) {
               v[g + 8 >> 2] = 0 - b;
               v[g + 12 >> 2] = 0 - (((b | 0) != 0) + h | 0);
              }
              r = 0;
              h = eb - 16 | 0;
              eb = h;
              v[g + 28 >> 2] = 0;
              v[g + 32 >> 2] = 0;
              ti(g + 672 | 0, 524287);
              ti(g + 676 | 0, 524287);
              a = v[g + 676 >> 2];
              b = v[g + 672 >> 2];
              Qc: {
               Rc: {
                c = v[g + 88 >> 2];
                if (!(c & 65536)) {
                 break Rc;
                }
                e = v[g + 20 >> 2];
                f = v[g + 24 >> 2];
                if ((e | 0) == (b | 0) & (f | 0) == (a | 0)) {
                 break Rc;
                }
                c = v[d + 24620 >> 2];
                e = (b | 0) <= (e | 0) & (a | 0) <= (f | 0);
                Sc: {
                 if (!e) {
                  a = gv(c, v[d + 24636 >> 2]);
                  break Sc;
                 }
                 a = gv(c, v[d + 24640 >> 2]);
                }
                if (!(!Nb(d + 1074312 | 0, 4) | !(w[d + 480180 | 0] & 4))) {
                 a = v[d + 24620 >> 2];
                 a = Aua(a, a >> 31, 5, 0);
                 f = gb;
                 a = a + 500 | 0;
                 f = a >>> 0 < 500 ? f + 1 | 0 : f;
                 a = Fc(Bua(a, f, 1e3, 0), gb);
                }
                b = a;
                c = v[g + 656 >> 2];
                Tc: {
                 if (e | !c) {
                  break Tc;
                 }
                 c = x[c + 12 >> 1];
                 if (!c) {
                  break Tc;
                 }
                 r = 1;
                 b = (B(c, v[d + 24620 >> 2]) >>> 0) / 1e5 | 0;
                }
                c = b >>> 0 <= 1 ? 1 : b;
                f = v[g + 672 >> 2];
                l = v[g + 20 >> 2];
                m = f - l << 12;
                L = g;
                e = v[g + 676 >> 2];
                b = v[g + 24 >> 2];
                k = e - b << 12;
                if (!(w[g + 90 | 0] & 32 | (!(e | f) | (!(b | l) | r)))) {
                 v[h + 12 >> 2] = v[d + 1074380 >> 2];
                 Fe(h + 12 | 0, a, 2048);
                 c = v[h + 12 >> 2];
                }
                k = (k | 0) / (c | 0) | 0;
                v[L + 32 >> 2] = k;
                l = (m | 0) / (c | 0) | 0;
                v[g + 28 >> 2] = l;
                a = e + ((B(c, k) | 0) / -4096 | 0) | 0;
                v[g + 24 >> 2] = a;
                b = f + ((B(c, l) | 0) / -4096 | 0) | 0;
                v[g + 20 >> 2] = b;
                if (k | l) {
                 v[g + 100 >> 2] = c;
                 c = v[g + 88 >> 2];
                 break Qc;
                }
                v[g + 24 >> 2] = e;
                v[g + 20 >> 2] = f;
                a = e;
                b = f;
                c = v[g + 88 >> 2] & -65537;
                break Qc;
               }
               v[g + 24 >> 2] = a;
               v[g + 20 >> 2] = b;
               c = c & -65537;
              }
              v[g + 88 >> 2] = c & -2097153;
              v[g + 40 >> 2] = a << 12;
              v[g + 36 >> 2] = b << 12;
              eb = h + 16 | 0;
              e = v[g + 88 >> 2];
              if (!(e & 512)) {
               break Dc;
              }
              break Cc;
             }
             v[g + 76 >> 2] = 0;
             v[g + 20 >> 2] = 0;
             v[g + 24 >> 2] = 0;
             if (v[g + 96 >> 2]) {
              break Dc;
             }
             if (!v[g + 92 >> 2]) {
              break Cc;
             }
            }
            a = x[d + 480212 >> 1];
            u[d + 480212 >> 1] = a + 1;
            u[j + (a << 1) >> 1] = i;
           }
           v[g + 668 >> 2] = e;
           t[g + 851 | 0] = w[g + 851 | 0] & 253;
          }
          i = i + 1 | 0;
          continue;
         }
         break;
        }
       }
       eb = n + 48 | 0;
       if (J) {
        b = v[d + 480208 >> 2];
        break h;
       }
       if (Hd(w[d + 1298424 | 0])) {
        a = v[d + 480208 >> 2] | 512;
        break i;
       }
       f = 0;
       Uc: {
        a = v[d + 24620 >> 2] / 10 | 0;
        b = Fc(a, a >> 31);
        if (!b) {
         break Uc;
        }
        c = b >>> 0 >= 1048576 ? 1048576 : b;
        v[d + 1074380 >> 2] = c;
        e = d + 1074478 | 0;
        g = d + 1074992 | 0;
        h = x[d + 480212 >> 1];
        while (1) {
         if ((h | 0) == (f | 0)) {
          break Uc;
         }
         a = g + B(x[e + (f << 1) >> 1], 872) | 0;
         v[a + 672 >> 2] = 0;
         v[a + 676 >> 2] = 0;
         v[a + 100 >> 2] = c;
         k = v[a + 24 >> 2] << 12;
         v[a + 40 >> 2] = k;
         n = v[a + 20 >> 2] << 12;
         v[a + 36 >> 2] = n;
         v[a + 88 >> 2] = v[a + 88 >> 2] | 65536;
         v[a + 28 >> 2] = (0 - n | 0) / (c | 0);
         v[a + 32 >> 2] = (0 - k | 0) / (c | 0);
         f = f + 1 | 0;
         continue;
        }
       }
       c = v[d + 480208 >> 2];
       a = c | 256;
       if (b) {
        break i;
       }
       a = c | 512;
      }
      b = a;
      v[d + 480208 >> 2] = b;
     }
     if (!(b & 512)) {
      break g;
     }
     Ca = d, Da = Hl(va), v[Ca + 1074392 >> 2] = Da;
    }
    eb = F + 96 | 0;
    break f;
   }
   v[F + 80 >> 2] = 512;
   a = v[d + 1074380 >> 2];
   v[F + 88 >> 2] = ca;
   v[F + 84 >> 2] = a;
   n = tE(F + 80 | 0);
   if (v[d + 24632 >> 2]) {
    k = 0;
    a = eb - 48 | 0;
    eb = a;
    b = d + 16396 | 0;
    c = n << 2;
    while (1) {
     if ((k | 0) == 4) {
      Vc: {
       k = 0;
       while (1) {
        if ((k | 0) == 4) {
         break Vc;
        }
        v[(a + 32 | 0) + (k << 2) >> 2] = b + (k << 11);
        k = k + 1 | 0;
        continue;
       }
      }
     } else {
      v[a + 32 >> 2] = 0;
      e = b + (k << 11) | 0;
      _z(e, c + e | 0, a + 32 | 0);
      k = k + 1 | 0;
      continue;
     }
     break;
    }
    b = v[d + 24632 >> 2];
    v[a + 28 >> 2] = n;
    v[a + 24 >> 2] = b;
    v[a + 20 >> 2] = a + 32;
    b = v[v[ba >> 2] + 8 >> 2];
    v[a + 16 >> 2] = n;
    c = v[a + 24 >> 2];
    v[a + 8 >> 2] = v[a + 20 >> 2];
    v[a + 12 >> 2] = c;
    hb[b | 0](ba, a + 8 | 0);
    eb = a + 48 | 0;
   }
   if (Hd(ta)) {
    b = 0;
    while (1) {
     if ((b | 0) == 4) {
      a = v[d + 24632 >> 2];
      v[F + 76 >> 2] = n;
      v[F + 72 >> 2] = a;
      v[F + 68 >> 2] = F + 80;
      a = v[v[ia >> 2] + 8 >> 2];
      v[F + 40 >> 2] = n;
      b = v[F + 72 >> 2];
      v[F + 32 >> 2] = v[F + 68 >> 2];
      v[F + 36 >> 2] = b;
      hb[a | 0](ia, F + 32 | 0);
     } else {
      v[(F + 80 | 0) + (b << 2) >> 2] = (b << 11) + ua;
      b = b + 1 | 0;
      continue;
     }
     break;
    }
   }
   O = 0;
   l = eb - 48 | 0;
   eb = l;
   if (n) {
    G = d + 12 | 0;
    J = d + 24592 | 0;
    Q = d + 24588 | 0;
    Jn(G, n, J, Q);
    if (y[d + 24624 >> 2] >= 3) {
     Jn(d + 8204 | 0, n, d + 24600 | 0, d + 24596 | 0);
    }
    u[l + 42 >> 1] = 0;
    da = d + 484380 | 0;
    _ = d + 1074312 | 0;
    ea = d + 24648 | 0;
    U = d + 906300 | 0;
    fa = d + 24596 | 0;
    wa = d + 24600 | 0;
    xa = d + 8204 | 0;
    q = d + 397452 | 0;
    s = d + 397448 | 0;
    I = d + 393352 | 0;
    T = d + 397456 | 0;
    ya = d + 1074478 | 0;
    za = d + 1074992 | 0;
    Aa = d + 1074376 | 0;
    while (1) {
     if (x[d + 480212 >> 1] <= O >>> 0) {
      Ca = d, Da = x[qe(d + 480214 | 0, l + 42 | 0) >> 1], u[Ca + 480214 >> 1] = Da;
     } else {
      f = ya + (O << 1) | 0;
      E = x[f >> 1];
      j = za + B(E, 872) | 0;
      Wc: {
       if (!(v[j + 16 >> 2] | v[j + 96 >> 2] | v[j + 92 >> 2])) {
        break Wc;
       }
       a = w[j + 794 | 0] + 1 & 255;
       if (a >>> 0 <= 5) {
        h = v[(a << 2) + 26112 >> 2];
       } else {
        h = 0;
       }
       g = v[j + 88 >> 2];
       Xc: {
        if (!(w[d + 24612 | 0] & 32) | (g & 16777216) >>> 24) {
         b = Q;
         c = J;
         e = g;
         a = G;
         if (!(g & 8388608)) {
          break Xc;
         }
        }
        if (!w[T + 12 | 0]) {
         Jn(I, n, s, q);
        }
        t[T + 12 | 0] = 1;
        E = x[f >> 1];
        e = v[j + 88 >> 2];
        b = q;
        c = s;
        a = I;
       }
       f = b;
       b = e >>> 8 & y[d + 24624 >> 2] > 2;
       H = b ? fa : f;
       K = b ? wa : c;
       c = b ? xa : a;
       $ = mm(d, Aa, E & 65535, 2, 1) - 1 | 0;
       na = ($ & 255) >>> 0 > 249;
       Yc: {
        if (na) {
         break Yc;
        }
        b = v[_d(U, $) >> 2];
        if (!b) {
         break Yc;
        }
        a = v[b + 24 >> 2];
        if (!a) {
         break Yc;
        }
        H = b + 36 | 0;
        K = b + 40 | 0;
        if (!(t[b + 28 | 0] & 1)) {
         Jn(a, n, K, H);
         v[b + 28 >> 2] = v[b + 28 >> 2] | 1;
        }
        c = a;
       }
       if (w[j + 851 | 0] & 8) {
        XF(j, c, n);
        v[K >> 2] = v[K >> 2] + v[j + 92 >> 2];
        v[H >> 2] = v[H >> 2] + v[j + 96 >> 2];
        v[j + 92 >> 2] = 0;
        v[j + 96 >> 2] = 0;
        break Wc;
       }
       L = 0;
       a = l + 20 | 0;
       v[a >> 2] = 0;
       v[a + 4 >> 2] = 0;
       v[a + 8 >> 2] = 0;
       v[a + 12 >> 2] = 0;
       b = d + 1074312 | 0;
       Ca = a, Da = Nb(b, 33), t[Ca + 16 | 0] = Da;
       Ca = a, Da = Nb(b, 116) ^ 1, t[Ca + 17 | 0] = Da;
       if (v[j + 16 >> 2]) {
        WF(a, j);
        b = v[j + 12 >> 2];
        f = b >> 31;
        e = f;
        k = e ^ v[j + 8 >> 2];
        b = (b ^ e) - ((e >>> 0 > k >>> 0) + e | 0) | 0;
        v[a + 12 >> 2] = b >>> 0 > 8191 ? 2 : 16384 / (b + 1 >>> 0) | 0;
       }
       Ba = g >>> 12 & 8 | (g >>> 5 & 2 | (h | g & 1));
       S = j + 76 | 0;
       r = a;
       b = n;
       while (1) {
        Zc: {
         a = v[j + 100 >> 2];
         X = a ? a >>> 0 > b >>> 0 ? b : a : b;
         v[l + 12 >> 2] = X;
         _c: {
          $c: {
           if (!X) {
            break $c;
           }
           g = v[j + 8 >> 2];
           a = v[j + 12 >> 2];
           if (!(g | a)) {
            break $c;
           }
           h = v[S >> 2];
           if (!h) {
            break $c;
           }
           e = v[r >> 2];
           if (!e) {
            break $c;
           }
           E = v[j + 88 >> 2];
           i = E & 2;
           m = v[j + 80 >> 2];
           v[j + 16 >> 2] = e;
           e = v[j >> 2];
           ad: {
            bd: {
             k = m & E << 30 >> 31;
             f = v[j + 4 >> 2];
             if ((k | 0) > (f | 0)) {
              if ((a | 0) < 0) {
               e = gh(0, k << 1, e, f);
               v[j >> 2] = e;
               f = gb;
               v[j + 4 >> 2] = f;
               if (!(f >>> 0 < h + k >>> 1 >>> 0 & (f | 0) >= (k | 0))) {
                e = 0;
                v[j >> 2] = e;
                f = k;
                v[j + 4 >> 2] = f;
               }
               cd: {
                if (E & 4) {
                 a = 0 - (((g | 0) != 0) + a | 0) | 0;
                 g = 0 - g | 0;
                 v[j + 8 >> 2] = g;
                 v[j + 12 >> 2] = a;
                 E = E & -129;
                 v[j + 88 >> 2] = E;
                 break cd;
                }
                v[j >> 2] = e;
                f = h - 1 | 0;
                v[j + 4 >> 2] = f;
               }
               if (!i) {
                break $c;
               }
               if (h >>> 0 > f >>> 0) {
                break ad;
               }
               break $c;
              }
              if ((f | 0) > 0 | (f | 0) >= 0) {
               break ad;
              }
              f = 0;
              break bd;
             }
             if (h >>> 0 > f >>> 0) {
              break ad;
             }
             if (!i) {
              break $c;
             }
             if (E & 4) {
              if (!!g & (a | 0) >= 0 | (a | 0) > 0) {
               a = 0 - (((g | 0) != 0) + a | 0) | 0;
               g = 0 - g | 0;
               v[j + 8 >> 2] = g;
               v[j + 12 >> 2] = a;
              }
              E = E | 128;
              v[j + 88 >> 2] = E;
              if (w[l + 37 | 0]) {
               i = w[l + 36 | 0];
               o = v[j + 84 >> 2] - (i + m | 0) | 0;
               e = gh(e, f, 0, h);
               f = gb;
               if (f >>> 0 < o >>> 0) {
                e = gh(0, h - i | 0, e, f);
                f = gb;
                break bd;
               }
               f = m;
               e = 0;
               break bd;
              }
              i = 0 - e | 0;
              o = (h << 1) - ((1 - ((e | 0) != 0) | 0) + f | 0) | 0;
              f = o;
              e = i;
              v[j >> 2] = e;
              Y = 0;
              f = Y | f;
              v[j + 4 >> 2] = f;
              if (m >>> 0 < o >>> 0 & h >>> 0 > o >>> 0) {
               break ad;
              }
              v[l + 44 >> 2] = w[l + 36 | 0] + 1;
              f = Y | h - v[Gb(S, l + 44 | 0) >> 2];
              break bd;
             }
             if ((a | 0) < 0) {
              a = 0 - (((g | 0) != 0) + a | 0) | 0;
              g = 0 - g | 0;
              v[j + 8 >> 2] = g;
              v[j + 12 >> 2] = a;
             }
             Ob(j, 0, m - h | 0);
             E = v[j + 88 >> 2] | 8192;
             v[j + 88 >> 2] = E;
             e = v[j >> 2];
             f = v[j + 4 >> 2];
             break ad;
            }
            v[j >> 2] = e;
            v[j + 4 >> 2] = f;
           }
           dd: {
            if ((f | 0) < (k | 0)) {
             if ((a | f) < 0) {
              break $c;
             }
             v[l + 44 >> 2] = X;
             h = g;
             m = a;
             break dd;
            }
            h = v[S >> 2];
            if (h >>> 0 < f >>> 0 | (!!g & (a | 0) >= 0 | (a | 0) > 0) & (h | 0) == (f | 0)) {
             break $c;
            }
            v[l + 44 >> 2] = X;
            h = a >> 31;
            i = h;
            o = h ^ g;
            h = o - h | 0;
            m = (a ^ i) - ((i >>> 0 > o >>> 0) + i | 0) | 0;
           }
           i = h;
           o = m;
           wc(l + 12 | 0, v[l + 32 >> 2]);
           oa = v[l + 12 >> 2];
           eg(e, f, uf(g, a, oa - 1 | 0), gb);
           m = gb;
           h = v[j + 80 >> 2];
           pa = h >>> 0 > f >>> 0 | f >>> 0 >= h + 16 >>> 0;
           if (pa) {
            E = E & -8193;
            v[j + 88 >> 2] = E;
           }
           ed: {
            fd: {
             Y = v[l + 24 >> 2];
             gd: {
              if (Y) {
               h = v[l + 28 >> 2];
               if (h >>> 0 <= f >>> 0) {
                hd: {
                 if ((a | 0) < 0) {
                  g = 0;
                  a = h;
                  break hd;
                 }
                 g = e;
                 a = f;
                 e = 0;
                 f = v[j + 84 >> 2];
                }
                Ca = l, Da = Gp(gh(gh(e, f, g, a), gb, 1, 0), gb, i, o) + 1 | 0, v[Ca + 44 >> 2] = Da;
                v[j + 16 >> 2] = Y;
                break ed;
               }
               if (!(pa | !(E & 8192))) {
                Ca = l, Da = Gp(gh(gh(0, k + 16 | 0, e, f), gb, 1, 0), gb, i, o) + 1 | 0, v[Ca + 44 >> 2] = Da;
                Ca = j, Da = Y + B(v[j + 84 >> 2] - k | 0, Xk(x[v[j + 104 >> 2] + 34 >> 1])) | 0, 
                v[Ca + 16 >> 2] = Da;
                break ed;
               }
               if (!g & (a | 0) <= 0 | (a | 0) < 0) {
                break gd;
               }
               if (X >>> 0 < 2 | h >>> 0 > m >>> 0) {
                break fd;
               }
               Ca = l, Da = Gp(gh(gh(0, h, e, f), gb, 1, 0), gb, i, o) + 1 | 0, v[Ca + 44 >> 2] = Da;
               break ed;
              }
              if ((a | 0) > 0 | (a | 0) >= 0) {
               break fd;
              }
             }
             if ((k | 0) <= (m | 0)) {
              break ed;
             }
             Ca = l, Da = Gp(gh(gh(e, f, 0, k), gb, 1, 0), gb, i, o) + 1 | 0, v[Ca + 44 >> 2] = Da;
             break ed;
            }
            h = v[S >> 2];
            if ((h | 0) > (m | 0)) {
             break ed;
            }
            Ca = l, Da = Gp(gh(gh(0, h, e, f), gb, 1, 0), gb, i, o) + 1 | 0, v[Ca + 44 >> 2] = Da;
           }
           Fp(l + 44 | 0, 1, oa);
           f = v[l + 44 >> 2];
           if ((f | 0) > 0) {
            break _c;
           }
          }
          v[j + 76 >> 2] = 0;
          v[j + 16 >> 2] = 0;
          v[j + 100 >> 2] = 0;
          v[j >> 2] = 0;
          v[j + 4 >> 2] = 0;
          XF(j, c, b);
          v[K >> 2] = v[K >> 2] + v[j + 92 >> 2];
          v[H >> 2] = v[H >> 2] + v[j + 96 >> 2];
          v[j + 92 >> 2] = 0;
          v[j + 96 >> 2] = 0;
          v[j + 88 >> 2] = v[j + 88 >> 2] & -129;
          break Zc;
         }
         id: {
          jd: {
           if (y[d + 24608 >> 2] > x[l + 42 >> 1]) {
            a = 4;
            if (v[j + 100 >> 2]) {
             break jd;
            }
            a = 0;
            if (v[j + 24 >> 2] | v[j + 20 >> 2]) {
             break jd;
            }
           }
           Ob(j, uf(v[j + 8 >> 2], v[j + 12 >> 2], f), gb);
           v[j + 92 >> 2] = 0;
           v[j + 96 >> 2] = 0;
           L = 0;
           c = (f << 3) + c | 0;
           break id;
          }
          e = (f << 3) + c | 0;
          g = e - 8 | 0;
          v[j + 92 >> 2] = 0 - v[g >> 2];
          h = e - 4 | 0;
          v[j + 96 >> 2] = 0 - v[h >> 2];
          hb[v[((a | Ba) << 2) + 25728 >> 2]](j, ea, c, f);
          v[j + 92 >> 2] = v[j + 92 >> 2] + v[g >> 2];
          v[j + 96 >> 2] = v[j + 96 >> 2] + v[h >> 2];
          L = 1;
          c = e;
         }
         a = v[j + 100 >> 2];
         kd: {
          if (!a) {
           break kd;
          }
          if (a >>> 0 <= f >>> 0) {
           v[j + 100 >> 2] = 0;
           v[j + 28 >> 2] = 0;
           v[j + 32 >> 2] = 0;
           a = v[j + 676 >> 2];
           v[j + 20 >> 2] = v[j + 672 >> 2];
           v[j + 24 >> 2] = a;
           if (v[j + 696 >> 2] | !(w[j + 89 | 0] & 16)) {
            break kd;
           }
           v[j + 16 >> 2] = 0;
           v[j + 76 >> 2] = 0;
           break kd;
          }
          v[j + 100 >> 2] = a - f;
         }
         i = 0;
         E = 0;
         a = v[j + 4 >> 2];
         E = a >>> 0 >= y[j + 84 >> 2] ? (w[j + 88 | 0] & 2) >>> 1 | 0 : E;
         e = a;
         a = v[S >> 2];
         i = v[j + 88 >> 2] & 2 | (e >>> 0 < a >>> 0 | !a) ? i : !x[j + 786 >> 1];
         b = b - f | 0;
         Ib(l + 12 | 0, _, 85);
         ld: {
          md: {
           nd: {
            if (!Fb(v[v[l + 12 >> 2] >> 2], v[l + 16 >> 2])) {
             break nd;
            }
            a = w[j + 803 | 0];
            if (!a) {
             break nd;
            }
            if (a >>> 0 <= x[d + 480190 >> 1]) {
             break md;
            }
           }
           e = 0;
           break ld;
          }
          f = v[j + 104 >> 2];
          a = da + B(a, 104) | 0;
          e = (f | 0) != (a | 0);
          if ((a | 0) == (f | 0) | (i | E) != 1) {
           break ld;
          }
          v[j + 104 >> 2] = a;
          e = v[a + 20 >> 2];
          v[j + 16 >> 2] = e;
          f = x[a + 34 >> 1];
          v[j + 88 >> 2] = f | v[j + 88 >> 2] & -768;
          g = f << 30 >> 31;
          f = v[a + 8 >> 2];
          v[j + 76 >> 2] = g & f;
          a = v[a + 4 >> 2];
          v[j + 84 >> 2] = f;
          v[j + 80 >> 2] = a;
          v[j + 4 >> 2] = a;
          WF(r, j);
          if (!e) {
           break Zc;
          }
          if ((b | 0) > 0) {
           continue;
          }
          break Zc;
         }
         od: {
          if (!E | e) {
           break od;
          }
          Ib(l + 12 | 0, _, 83);
          if (!Fb(v[v[l + 12 >> 2] >> 2], v[l + 16 >> 2]) | v[j + 80 >> 2]) {
           break od;
          }
          v[j >> 2] = v[j >> 2];
          v[j + 4 >> 2] = 0;
          a = v[v[j + 104 >> 2] + 8 >> 2];
          v[j + 84 >> 2] = a;
          v[j + 76 >> 2] = a;
         }
         if ((b | 0) > 0) {
          continue;
         }
        }
        break;
       }
       v[j + 16 >> 2] = v[r >> 2];
       u[l + 42 >> 1] = x[l + 42 >> 1] + L;
       if (na | !L) {
        break Wc;
       }
       a = v[_d(U, $) >> 2];
       if (!a) {
        break Wc;
       }
       hb[v[v[a >> 2] + 152 >> 2]](a);
      }
      O = O + 1 | 0;
      continue;
     }
     break;
    }
   }
   eb = l + 48 | 0;
   r = v[d + 1298300 >> 2];
   if (Dd(r)) {
    b = W;
    a = n;
    c = (B(v[d + 480232 >> 2], v[d + 480236 >> 2]) >>> 0) / 48 | 0;
    k = eb - 16 | 0;
    eb = k;
    pd: {
     if (!w[r + 534 | 0]) {
      break pd;
     }
     e = Aua(c, 0, 6169, 0);
     c = gb;
     m = c >>> 16 | 0;
     q = Ac((c & 65535) << 16 | e >>> 16, m);
     while (1) {
      if (!a) {
       break pd;
      }
      h = v[r >> 2];
      e = v[h >> 2];
      c = v[h + 4 >> 2];
      while (1) {
       if ((c | 0) >= (e | 0)) {
        v[h + 8 >> 2] = v[h + 12 >> 2];
        e = 0;
        j = 0;
        i = 0;
        c = eb - 16 | 0;
        eb = c;
        I = h + 16 | 0;
        while (1) {
         if ((i | 0) == 18) {
          e = (e | 0) >= 32767 ? 32767 : e;
          u[h + 12 >> 1] = (e | 0) <= -32768 ? -32768 : e;
          e = (j | 0) >= 32767 ? 32767 : j;
          u[h + 14 >> 1] = (e | 0) <= -32768 ? -32768 : e;
          u[h + 3832 >> 1] = x[h + 3832 >> 1] + 1;
          e = (x[h + 3834 >> 1] + 1 >>> 0) % 13440 | 0;
          u[h + 3834 >> 1] = e;
          e = e >>> 0 < 6720 ? e : 13440 - e | 0;
          u[h + 3836 >> 1] = e >>> 8;
          if (!w[h + 3843 | 0]) {
           u[h + 3836 >> 1] = e >>> 10;
          }
          e = x[h + 3838 >> 1] + 1 | 0;
          u[h + 3838 >> 1] = e;
          if ((e & 65535) >>> 0 >= 1024) {
           u[h + 3838 >> 1] = 0;
           u[h + 3840 >> 1] = x[h + 3840 >> 1] + 1 & 7;
          }
          eb = c + 16 | 0;
         } else {
          g = I + B(i, 44) | 0;
          qd: {
           if (!w[g + 40 | 0]) {
            u[c + 12 >> 1] = 0;
            u[c + 14 >> 1] = 0;
            break qd;
           }
           l = v[g + 16 >> 2];
           f = x[l + 3840 >> 1];
           if (f & 3) {
            l = (x[g + 20 >> 1] >>> 7 & 7) >>> (w[l + 3844 | 0] ^ 1) >>> (f & 1) << x[g + 22 >> 1];
            f = f & 4 ? 0 - l | 0 : l;
           } else {
            f = 0;
           }
           l = v[g + 36 >> 2];
           rd: {
            if (l) {
             G = x[l + 32 >> 1];
             s = x[g + 32 >> 1];
             f = f << 16 >> 16;
             l = Dg(v[g >> 2], v[g + 24 >> 2], f, 0, u[g + 30 >> 1]);
             m = v[g + 24 >> 2];
             o = v[g + 4 >> 2];
             if (!G) {
              if (!s) {
               l = Dg(o, m, f, l, 0);
               l = Dg(v[g + 8 >> 2], v[g + 24 >> 2], f, l, 0);
               f = Dg(v[g + 12 >> 2], v[g + 24 >> 2], f, l, 0);
               break rd;
              }
              m = Dg(o, m, f, 0, 0);
              m = Dg(v[g + 8 >> 2], v[g + 24 >> 2], f, m, 0);
              f = Dg(v[g + 12 >> 2], v[g + 24 >> 2], f, m, 0) + l | 0;
              break rd;
             }
             if (!s) {
              l = Dg(o, m, f, l, 0);
              m = Dg(v[g + 8 >> 2], v[g + 24 >> 2], f, 0, 0);
              f = Dg(v[g + 12 >> 2], v[g + 24 >> 2], f, m, 0) + l | 0;
              break rd;
             }
             m = Dg(o, m, f, 0, 0);
             f = (Dg(v[g + 8 >> 2], v[g + 24 >> 2], f, m, 0) + l | 0) + Dg(v[g + 12 >> 2], v[g + 24 >> 2], f, 0, 0) | 0;
             break rd;
            }
            s = x[g + 32 >> 1];
            f = f << 16 >> 16;
            l = Dg(v[g >> 2], v[g + 24 >> 2], f, 0, u[g + 30 >> 1]);
            m = v[g + 24 >> 2];
            o = v[g + 4 >> 2];
            if (!s) {
             f = Dg(o, m, f, l, 0);
             break rd;
            }
            f = Dg(o, m, f, 0, 0) + l | 0;
           }
           u[c + 14 >> 1] = w[g + 41 | 0] ? f : 0;
           u[c + 12 >> 1] = w[g + 42 | 0] ? f : 0;
          }
          i = i + 1 | 0;
          j = u[c + 12 >> 1] + j | 0;
          e = u[c + 14 >> 1] + e | 0;
          continue;
         }
         break;
        }
        e = v[h >> 2];
        c = v[h + 4 >> 2] - e | 0;
        v[h + 4 >> 2] = c;
        continue;
       }
       break;
      }
      f = e - c | 0;
      u[k + 14 >> 1] = (B(u[h + 12 >> 1], c) + B(f, u[h + 8 >> 1]) | 0) / (e | 0);
      u[k + 12 >> 1] = (B(u[h + 14 >> 1], c) + B(f, u[h + 10 >> 1]) | 0) / (e | 0);
      v[h + 4 >> 2] = c + 49716;
      v[b >> 2] = v[b >> 2] + B(q, u[k + 14 >> 1]);
      v[b + 4 >> 2] = v[b + 4 >> 2] + B(q, u[k + 12 >> 1]);
      b = b + 8 | 0;
      a = a - 1 | 0;
      continue;
     }
    }
    eb = k + 16 | 0;
   }
   a = w[A + 12 | 0];
   if (a | v[A + 16 >> 2]) {
    if (!a) {
     Jn(Z, n, ma, la);
    }
    a = v[A >> 2];
    b = v[A + 80 >> 2];
    c = B(a, b) >>> 4 | 0;
    c = c >>> 0 >= 32767 ? 32767 : c;
    u[A + 98 >> 1] = c;
    u[A + 96 >> 1] = c;
    c = v[A + 49948 >> 2];
    e = B(c, a) >>> 4 | 0;
    e = e >>> 0 >= 65536 ? 65536 : e;
    f = e + 127 >>> 3 | 0;
    u[A + 49946 >> 1] = f;
    e = e + 255 >>> 4 | 0;
    u[A + 49944 >> 1] = e;
    u[A + 49942 >> 1] = e;
    u[A + 49940 >> 1] = f;
    b = (b | 0) > (c | 0) ? b : c;
    a = 36 - a >>> 1 | 0;
    a = 16 - (a >>> 0 <= 8 ? 8 : a) | 0;
    a = 16 - (B((b | 0) >= 32768 ? 32768 : b, a >>> 0 <= 16 ? a : 0) >> 15) | 0;
    k = 0;
    while (1) {
     if ((k | 0) != (n | 0)) {
      b = k << 3;
      c = b + W | 0;
      v[c >> 2] = v[c >> 2] + B(a, v[b + Z >> 2] >> 4);
      b = b | 4;
      c = b + W | 0;
      v[c >> 2] = v[c >> 2] + B(a, v[b + Z >> 2] >> 4);
      k = k + 1 | 0;
      continue;
     }
     break;
    }
    j = A + 68 | 0;
    e = 0;
    f = v[A + 40 >> 2];
    g = v[A + 36 >> 2];
    b = u[A + 84 >> 1];
    while (1) {
     if ((e | 0) == (n | 0)) {
      v[A + 40 >> 2] = f;
      v[A + 36 >> 2] = g;
      h = n;
     } else {
      a = (e << 3) + Z | 0;
      c = v[a >> 2] >> 12;
      g = (B(b, c - g | 0) >> 15) + c | 0;
      v[a >> 2] = g;
      c = a;
      a = v[a + 4 >> 2] >> 12;
      f = (B(b, a - f | 0) >> 15) + a | 0;
      v[c + 4 >> 2] = f;
      e = e + 1 | 0;
      continue;
     }
     break;
    }
    if (h) {
     a = Z;
     b = h;
     o = j + 160 | 0;
     g = j + 32928 | 0;
     e = v[j >> 2] - 1 | 0;
     c = x[j + 22 >> 1];
     q = x[j + 20 >> 1];
     k = u[j + 26 >> 1];
     l = u[j + 24 >> 1];
     r = u[j + 18 >> 1];
     s = u[j + 16 >> 1];
     f = v[j + 4 >> 2];
     while (1) {
      if (b) {
       m = od(v[a >> 2]);
       i = od(v[a + 4 >> 2]);
       q = od((q << 16 >> 16) - m | 0);
       c = od((c << 16 >> 16) - i | 0);
       q = fd(od((B(q, s) | 0) / 65536 << 1) + m | 0);
       c = fd(od((B(c, r) | 0) / 65536 << 1) + i | 0);
       i = g + (f << 2) | 0;
       I = u[i >> 1];
       m = fd(((B(I, l) | 0) / -65536 | 0) + q | 0);
       f = f + 1 & 127;
       G = g + (f << 2) | 0;
       i = u[i + 2 >> 1];
       J = fd(((B(i, k) | 0) / -65536 | 0) + c | 0);
       u[G + 2 >> 1] = J;
       u[G >> 1] = m;
       e = e + 1 & 8191;
       G = o + (e << 2) | 0;
       Ca = G, Da = fd(I + ((B(l, m) | 0) / 65536 | 0) | 0), u[Ca >> 1] = Da;
       Ca = G, Da = fd(i + ((B(k, J) | 0) / 65536 | 0) | 0), u[Ca + 2 >> 1] = Da;
       a = a + 8 | 0;
       b = b - 1 | 0;
       continue;
      }
      break;
     }
     u[j + 22 >> 1] = c;
     u[j + 20 >> 1] = q;
     v[j + 4 >> 2] = f;
    }
    k = A + 49892 | 0;
    I = A + 33508 | 0;
    a = h;
    b = Z;
    while (1) {
     if (a) {
      c = v[A + 76 >> 2];
      e = c & 4095;
      r = I + (e << 2) | 0;
      f = b;
      e = 4096 - e | 0;
      Q = c - v[A + 49892 >> 2] & 4095;
      c = 4096 - Q | 0;
      c = c >>> 0 > e >>> 0 ? e : c;
      c = a >>> 0 < c >>> 0 ? a : c;
      g = c >>> 0 >= 64 ? 64 : c;
      q = g;
      c = 0;
      l = eb - 32 | 0;
      eb = l;
      m = j + 32 | 0;
      e = v[j >> 2];
      while (1) {
       if ((c | 0) == 7) {
        sd: {
         s = j + 160 | 0;
         G = u[j + 28 >> 1] / 8 << 16 >> 16;
         td: while (1) {
          if (!q) {
           break sd;
          }
          q = q - 1 | 0;
          c = 0;
          i = 0;
          e = 0;
          while (1) if ((c | 0) == 4) {
           c = 4;
           K = 0;
           J = fd((e | 0) / 32768 | 0);
           H = fd((i | 0) / 32768 | 0);
           i = 0;
           while (1) if ((c | 0) == 7) {
            c = fd(J + ((i | 0) / 32768 | 0) | 0);
            u[r >> 1] = c;
            v[f >> 2] = B(c, G);
            c = fd(H + ((K | 0) / 32768 | 0) | 0);
            u[r + 2 >> 1] = c;
            v[f + 4 >> 2] = B(c, G);
            f = f + 8 | 0;
            r = r + 4 | 0;
            continue td;
           } else {
            e = l + (c << 2) | 0;
            o = v[e >> 2] + 1 & 8191;
            v[e >> 2] = o;
            o = s + (o << 2) | 0;
            E = u[o >> 1];
            e = m + (c << 4) | 0;
            o = u[o + 2 >> 1];
            K = (B(E, u[e + 12 >> 1]) + K | 0) + B(o, u[e + 14 >> 1]) | 0;
            i = (B(E, u[e + 8 >> 1]) + i | 0) + B(o, u[e + 10 >> 1]) | 0;
            c = c + 1 | 0;
            continue;
           }
          } else {
           o = l + (c << 2) | 0;
           J = v[o >> 2] + 1 & 8191;
           v[o >> 2] = J;
           L = i;
           i = s + (J << 2) | 0;
           J = u[i >> 1];
           o = m + (c << 4) | 0;
           H = u[i + 2 >> 1];
           i = (L + B(J, u[o + 12 >> 1]) | 0) + B(H, u[o + 14 >> 1]) | 0;
           e = (B(J, u[o + 8 >> 1]) + e | 0) + B(H, u[o + 10 >> 1]) | 0;
           c = c + 1 | 0;
           continue;
          }
         }
        }
       } else {
        v[l + (c << 2) >> 2] = e + (v[m + (c << 4) >> 2] ^ -1);
        c = c + 1 | 0;
        continue;
       }
       break;
      }
      eb = l + 32 | 0;
      H = I + (Q << 2) | 0;
      c = b;
      f = g;
      l = k + 16448 | 0;
      X = k + 8258 | 0;
      G = k + 8256 | 0;
      _ = k + 66 | 0;
      J = k - -64 | 0;
      m = k + 24640 | 0;
      e = v[k + 4 >> 2];
      while (1) {
       i = e & 2047;
       if (f) {
        Q = u[G + ((e + 1206 & 2047) << 2) >> 1];
        E = u[X + ((e + 754 & 2047) << 2) >> 1];
        s = u[_ + ((e + 1602 & 2047) << 2) >> 1];
        L = u[J + ((e + 1750 & 2047) << 2) >> 1];
        o = u[H >> 1];
        r = u[H + 2 >> 1];
        q = m + ((e + 502 & 2047) << 2) | 0;
        K = u[q >> 1];
        S = od(u[k + 32 >> 1] - K | 0);
        q = u[q + 2 >> 1];
        O = od(u[k + 34 >> 1] - q | 0);
        U = u[k + 26 >> 1];
        T = m + ((e + 22 & 2047) << 2) | 0;
        $ = u[T >> 1];
        Y = od(u[k + 36 >> 1] - $ | 0);
        da = u[k + 28 >> 1];
        T = u[T + 2 >> 1];
        ea = od(u[k + 38 >> 1] - T | 0);
        fa = u[k + 30 >> 1];
        K = fd(od((B(S, u[k + 24 >> 1]) | 0) / 65536 << 1) + K | 0);
        u[k + 32 >> 1] = K;
        Ca = k, Da = fd(od((B(O, U) | 0) / 65536 << 1) + q | 0), u[Ca + 34 >> 1] = Da;
        Ca = k, Da = fd(od((B(Y, da) | 0) / 65536 << 1) + $ | 0), u[Ca + 36 >> 1] = Da;
        q = fd(od((B(ea, fa) | 0) / 65536 << 1) + T | 0);
        u[k + 38 >> 1] = q;
        K = od((B(K, u[k + 16 >> 1]) | 0) / 32768 | 0);
        q = od((B(q, u[k + 22 >> 1]) | 0) / 32768 | 0);
        K = od(((o | 0) / 4 << 16 >> 16) + K | 0);
        S = od(q + ((r | 0) / 4 << 16 >> 16) | 0);
        o = u[k + 8 >> 1];
        O = od(K + ((B(o, L) | 0) / -65536 | 0) | 0);
        r = i << 2;
        U = r + J | 0;
        q = u[k + 10 >> 1];
        T = od(S + ((B(q, s) | 0) / -65536 | 0) | 0);
        u[U + 2 >> 1] = T;
        u[U >> 1] = O;
        L = od(L + ((B(o, O) | 0) / 65536 | 0) | 0);
        O = l + r | 0;
        s = od(s + ((B(q, T) | 0) / 65536 | 0) | 0);
        u[O + 2 >> 1] = s;
        u[O >> 1] = L;
        L = od(K + L | 0);
        K = od(s + S | 0);
        s = l + ((e + 682 & 2047) << 2) | 0;
        S = u[s + 2 >> 1];
        O = u[s >> 1];
        s = od((B(S, u[k + 42 >> 1]) + B(O, u[k + 40 >> 1]) | 0) / 32768 | 0);
        e = l + ((e + 426 & 2047) << 2) | 0;
        U = u[e + 2 >> 1];
        T = u[e >> 1];
        e = od((B(U, u[k + 46 >> 1]) + B(T, u[k + 44 >> 1]) | 0) / 32768 | 0);
        O = od(od(L + O | 0) - s | 0);
        S = od(od(K + S | 0) - e | 0);
        L = od(od(L + T | 0) - s | 0);
        K = od(od(K + U | 0) - e | 0);
        s = od(s + ((B(o, Q) | 0) / -65536 | 0) | 0);
        U = r + G | 0;
        T = od(e + ((B(q, E) | 0) / -65536 | 0) | 0);
        u[U + 2 >> 1] = T;
        u[U >> 1] = s;
        o = (B(o, s) | 0) / 65536 | 0;
        e = od(o + Q | 0);
        r = m + r | 0;
        q = (B(q, T) | 0) / 65536 | 0;
        s = od(q + E | 0);
        u[r + 2 >> 1] = s;
        u[r >> 1] = e;
        Ca = c, Da = (v[c >> 2] + B(od(e + O | 0), u[k + 48 >> 1]) | 0) + B(od(s + S | 0), u[k + 50 >> 1]) | 0, 
        v[Ca >> 2] = Da;
        Ca = c, Da = (v[c + 4 >> 2] + B(od(od(o) + L | 0), u[k + 52 >> 1]) | 0) + B(od(od(q) + K | 0), u[k + 54 >> 1]) | 0, 
        v[Ca + 4 >> 2] = Da;
        c = c + 8 | 0;
        e = i + 1 | 0;
        H = H + 4 | 0;
        f = f - 1 | 0;
        continue;
       }
       break;
      }
      v[k + 4 >> 2] = i;
      v[A + 76 >> 2] = g + v[A + 76 >> 2] & 4095;
      v[A + 68 >> 2] = g + v[A + 68 >> 2] & 8191;
      a = a - g | 0;
      b = (g << 3) + b | 0;
      continue;
     }
     break;
    }
    v[A + 68 >> 2] = v[A + 68 >> 2] & 8191;
    e = Z;
    c = W;
    f = h;
    g = 0;
    j = 0;
    i = v[A + 56 >> 2];
    k = v[A + 52 >> 2];
    a = v[A + 64 >> 2];
    b = v[A + 60 >> 2];
    while (1) {
     if (f) {
      g = v[e >> 2];
      j = v[e + 4 >> 2];
      a = a - j | 0;
      a = (((a | 0) / 1024 | 0) - a | 0) + i | 0;
      v[c + 4 >> 2] = a + v[c + 4 >> 2];
      b = b - g | 0;
      b = (((b | 0) / 1024 | 0) - b | 0) + k | 0;
      v[c >> 2] = b + v[c >> 2];
      i = a + ((a | 0) / -512 | 0) | 0;
      k = b + ((b | 0) / -512 | 0) | 0;
      c = c + 8 | 0;
      e = e + 8 | 0;
      f = f - 1 | 0;
      b = g;
      a = j;
      continue;
     }
     break;
    }
    v[A + 64 >> 2] = j;
    v[A + 60 >> 2] = g;
    v[A + 56 >> 2] = i;
    v[A + 52 >> 2] = k;
    a = v[A + 20 >> 2];
    ud: {
     if (w[A + 12 | 0]) {
      break ud;
     }
     a = v[A + 16 >> 2];
     if (a >>> 0 > h >>> 0) {
      a = a - h | 0;
      break ud;
     }
     HP(A, ma, la);
     a = 0;
    }
    t[A + 12 | 0] = 0;
    v[A + 16 >> 2] = a;
   }
   if (v[d + 946300 >> 2]) {
    vd: {
     b = 0;
     c = 0;
     g = n << 2;
     o = d + 906300 | 0;
     q = x[d + 480214 >> 1] != 0;
     qa = z[d + 1074336 >> 2];
     V = z[d + 1074332 >> 2];
     while (1) if ((b | 0) == 250) {
      g = d + 12 | 0;
      j = d + 12300 | 0;
      l = d + 14348 | 0;
      $w(g, j, l, n, V);
      G = w[d + 1074476 | 0];
      t[d + 1074476 | 0] = 0;
      a = l;
      b = j;
      while (1) {
       wd: {
        xd: {
         yd: {
          if ((c | 0) != 250) {
           m = _d(o, c);
           h = v[m >> 2];
           if (!h | !v[h + 24 >> 2]) {
            break wd;
           }
           if (!si(h + 44 | 0)) {
            break wd;
           }
           i = h;
           zd: {
            if (Ep(w[m + 24 | 0])) {
             break zd;
            }
            e = hb[v[v[h >> 2] + 148 >> 2]](h) | 0;
            i = v[m >> 2];
            if (e) {
             break zd;
            }
            e = 0;
            if (w[i + 28 | 0] & 2) {
             break zd;
            }
            while (1) {
             if ((c | 0) == (e | 0)) {
              break wd;
             }
             f = _d(o, e);
             e = e + 1 | 0;
             if ((Hn(v[f + 28 >> 2]) | 0) != (c | 0)) {
              continue;
             }
             break;
            }
           }
           e = v[h + 44 >> 2];
           r = Gc(e, 0);
           I = Gc(e, 1);
           s = (b | 0) == (r | 0);
           b = s ? j : b;
           k = b;
           a = s ? l : a;
           f = v[m + 28 >> 2];
           e = a;
           Ad: {
            if (!f) {
             break Ad;
            }
            f = Hn(f);
            e = a;
            if (f >>> 0 <= c >>> 0) {
             break Ad;
            }
            e = a;
            if (f >>> 0 > 249) {
             break Ad;
            }
            f = v[_d(o, f) >> 2];
            e = a;
            if (!f) {
             break Ad;
            }
            if (!(w[i + 28 | 0] & 4)) {
             hb[v[v[f >> 2] + 152 >> 2]](f);
            }
            e = a;
            if (!si(f + 44 | 0)) {
             break Ad;
            }
            e = v[f + 44 >> 2];
            k = Gc(e, 0);
            e = Gc(e, 1);
           }
           f = e;
           if (!Ep(w[m + 24 | 0])) {
            break xd;
           }
           e = 0;
           Bd: {
            if (s) {
             break Bd;
            }
            while (1) {
             if ((e | 0) == (n | 0)) {
              break Bd;
             }
             s = e << 2;
             J = s + r | 0;
             Q = b + s | 0;
             z[J >> 2] = z[Q >> 2] + z[J >> 2];
             J = s + I | 0;
             s = a + s | 0;
             z[J >> 2] = z[s >> 2] + z[J >> 2];
             v[Q >> 2] = 0;
             v[s >> 2] = 0;
             e = e + 1 | 0;
             continue;
            }
           }
           a = f;
           b = k;
           if (!(q & 1)) {
            break xd;
           }
           a = v[m >> 2];
           if (a) {
            hb[v[v[a >> 2] + 152 >> 2]](a);
           }
           e = Hn(v[m + 28 >> 2]);
           b = c;
           while (1) {
            a = e;
            e = a & 255;
            if (e >>> 0 > 249 | e >>> 0 <= (b & 255) >>> 0) {
             break yd;
            }
            s = _d(o, e);
            e = Hn(v[s + 28 >> 2]);
            b = a;
            a = v[s >> 2];
            if (!a) {
             continue;
            }
            hb[v[v[a >> 2] + 152 >> 2]](a);
            continue;
           }
          }
          k = 0;
          while (1) {
           if ((k | 0) != (n | 0)) {
            V = C(z[b >> 2] * qa);
            Cd: {
             if (C(D(V)) < C(2147483648)) {
              c = ~~V;
              break Cd;
             }
             c = -2147483648;
            }
            v[g >> 2] = c;
            V = C(z[a >> 2] * qa);
            Dd: {
             if (C(D(V)) < C(2147483648)) {
              c = ~~V;
              break Dd;
             }
             c = -2147483648;
            }
            v[g + 4 >> 2] = c;
            k = k + 1 | 0;
            g = g + 8 | 0;
            a = a + 4 | 0;
            b = b + 4 | 0;
            continue;
           }
           break;
          }
          break vd;
         }
         a = f;
         b = k;
        }
        Ed: {
         Fd: {
          e = w[m + 24 | 0];
          if (!TF(e)) {
           if (!SF(e) | !(w[i + 28 | 0] & 4)) {
            break Fd;
           }
          }
          e = 0;
          while (1) {
           if ((e | 0) == (n | 0)) {
            break Ed;
           }
           h = e << 2;
           m = h + k | 0;
           z[m >> 2] = z[h + r >> 2] + z[m >> 2];
           m = h + f | 0;
           z[m >> 2] = z[h + I >> 2] + z[m >> 2];
           e = e + 1 | 0;
           continue;
          }
         }
         if (G) {
          hb[v[v[h >> 2] + 132 >> 2]](h);
         }
         hb[v[v[h >> 2] + 60 >> 2]](h, k, f, n);
         v[i + 32 >> 2] = n + v[i + 32 >> 2];
         if (!SF(w[m + 24 | 0])) {
          break Ed;
         }
         if ((hb[v[v[h >> 2] + 160 >> 2]](h) | 0) <= 0) {
          break Ed;
         }
         e = 0;
         if (y[i + 32 >> 2] < v[d + 24620 >> 2] << 2 >>> 0) {
          break Ed;
         }
         Gd: {
          while (1) {
           if ((e | 0) == (n | 0)) {
            break Gd;
           }
           h = e << 2;
           if (!(C(D(z[h + k >> 2])) >= C(1.1920928955078125e-7))) {
            e = e + 1 | 0;
            if (!(C(D(z[h + f >> 2])) >= C(1.1920928955078125e-7))) {
             continue;
            }
           }
           break;
          }
          v[i + 32 >> 2] = 0;
          break Ed;
         }
         v[i + 28 >> 2] = v[i + 28 >> 2] | 4;
        }
        v[i + 28 >> 2] = v[i + 28 >> 2] & -3;
       }
       c = c + 1 | 0;
       continue;
      }
     } else {
      h = _d(o, b);
      a = v[h >> 2];
      Hd: {
       if (!a | !v[a + 24 >> 2]) {
        break Hd;
       }
       if (!si(a + 44 | 0)) {
        break Hd;
       }
       if (!(hb[v[v[a >> 2] + 116 >> 2]](a) | 0)) {
        hb[v[v[a >> 2] + 112 >> 2]](a, 1);
        hb[v[v[a >> 2] + 124 >> 2]](a);
       }
       f = v[a + 44 >> 2];
       e = Gc(f, 0);
       f = Gc(f, 1);
       Id: {
        if (t[a + 28 | 0] & 1) {
         $w(v[a + 24 >> 2], e, f, n, V);
         break Id;
        }
        if (v[a + 40 >> 2] | v[a + 36 >> 2]) {
         Jn(v[a + 24 >> 2], n, a + 40 | 0, a + 36 | 0);
         $w(v[a + 24 >> 2], e, f, n, V);
         break Id;
        }
        Qb(e, 0, g);
        Qb(f, 0, g);
       }
       f = a;
       a = v[a + 28 >> 2];
       v[f + 28 >> 2] = a & -2;
       if (Ep(w[h + 24 | 0])) {
        break Hd;
       }
       q = !(a & 4) | q;
      }
      b = b + 1 | 0;
      continue;
     }
    }
   }
   if (v[d + 24624 >> 2] == 1) {
    a = 0;
    while (1) {
     if ((a | 0) != (n | 0)) {
      b = (a << 3) + W | 0;
      v[(a << 2) + W >> 2] = (v[b + 4 >> 2] + v[b >> 2] | 0) / 2;
      a = a + 1 | 0;
      continue;
     }
     break;
    }
   }
   if (Hd(w[d + 1074365 | 0])) {
    e = 0;
    h = eb - 16 | 0;
    eb = h;
    Jd: {
     if (!v[d + 1074376 >> 2]) {
      v[d + 1074460 >> 2] = 0;
      v[d + 1074464 >> 2] = 0;
      b = v[d + 1074456 >> 2];
      v[d + 1074468 >> 2] = b;
      g = d + 1074460 | 0;
      break Jd;
     }
     a = v[d + 1074468 >> 2];
     b = v[d + 1074456 >> 2];
     Kd: {
      if ((a | 0) == (b | 0)) {
       c = v[d + 1074460 >> 2];
       break Kd;
      }
      v[d + 1074468 >> 2] = b;
      c = v[d + 24620 >> 2];
      Ld: {
       if ((a | 0) < (b | 0)) {
        c = gv(c, v[d + 24636 >> 2]);
        break Ld;
       }
       c = gv(c, v[d + 24640 >> 2]);
      }
      v[d + 1074460 >> 2] = c;
      v[d + 1074464 >> 2] = c;
      a = b;
     }
     g = d + 1074460 | 0;
     if ((c | 0) <= 0) {
      break Jd;
     }
     a = (a << 12) - v[d + 1074472 >> 2] | 0;
     e = (a | 0) / (c | 0) | 0;
     if (w[d + 1074368 | 0] != 2) {
      break Jd;
     }
     v[h + 12 >> 2] = 50;
     f = v[d + 1074464 >> 2];
     v[h + 8 >> 2] = 1e4 / (f + 1 | 0);
     k = v[Ye(h + 12 | 0, h + 8 | 0) >> 2];
     while (1) {
      j = e >> 31;
      if ((k | 0) >= ((j ^ e) - j | 0)) {
       break Jd;
      }
      c = c + f | 0;
      v[g >> 2] = c;
      e = (a | 0) / (c | 0) | 0;
      continue;
     }
    }
    Md: {
     Nd: {
      switch (v[d + 24624 >> 2] - 1 | 0) {
      case 0:
       k = b << 12;
       c = d + 12 | 0;
       j = b >> 31;
       a = 0;
       while (1) {
        if ((a | 0) == (n | 0)) {
         break Md;
        }
        Od: {
         if (v[g >> 2] > 0) {
          f = v[d + 1074472 >> 2] + e | 0;
          v[d + 1074472 >> 2] = f;
          l = v[c >> 2];
          Ca = c, Da = Fc(Bua(Aua(l, l >> 31, f, f >> 31), gb, 1048576, 0), gb), v[Ca >> 2] = Da;
          v[d + 1074460 >> 2] = v[d + 1074460 >> 2] - 1;
          break Od;
         }
         f = v[c >> 2];
         Ca = c, Da = Fc(Bua(Aua(f, f >> 31, b, j), gb, 256, 0), gb), v[Ca >> 2] = Da;
         v[d + 1074472 >> 2] = k;
        }
        a = a + 1 | 0;
        c = c + 4 | 0;
        continue;
       }
       ;

      case 1:
       j = b << 12;
       c = d + 12 | 0;
       f = b >> 31;
       a = 0;
       while (1) {
        if ((a | 0) == (n | 0)) {
         break Md;
        }
        Pd: {
         if (v[g >> 2] > 0) {
          k = v[d + 1074472 >> 2] + e | 0;
          v[d + 1074472 >> 2] = k;
          l = v[c >> 2];
          Ca = c, Da = Fc(Bua(Aua(l, l >> 31, k, k >> 31), gb, 1048576, 0), gb), v[Ca >> 2] = Da;
          k = v[d + 1074472 >> 2];
          i = k;
          m = k >> 31;
          k = v[c + 4 >> 2];
          Ca = c, Da = Fc(Bua(Aua(i, m, k, k >> 31), gb, 1048576, 0), gb), v[Ca + 4 >> 2] = Da;
          v[d + 1074460 >> 2] = v[d + 1074460 >> 2] - 1;
          break Pd;
         }
         k = v[c >> 2];
         Ca = c, Da = Fc(Bua(Aua(k, k >> 31, b, f), gb, 256, 0), gb), v[Ca >> 2] = Da;
         k = v[c + 4 >> 2];
         Ca = c, Da = Fc(Bua(Aua(k, k >> 31, b, f), gb, 256, 0), gb), v[Ca + 4 >> 2] = Da;
         v[d + 1074472 >> 2] = j;
        }
        a = a + 1 | 0;
        c = c + 8 | 0;
        continue;
       }
       ;

      case 3:
       break Nd;

      default:
       break Md;
      }
     }
     l = b << 12;
     c = d + 8204 | 0;
     a = d + 12 | 0;
     f = b;
     k = b >> 31;
     b = 0;
     while (1) {
      if ((b | 0) == (n | 0)) {
       break Md;
      }
      Qd: {
       if (v[g >> 2] > 0) {
        j = v[d + 1074472 >> 2] + e | 0;
        v[d + 1074472 >> 2] = j;
        m = v[a >> 2];
        Ca = a, Da = Fc(Bua(Aua(m, m >> 31, j, j >> 31), gb, 1048576, 0), gb), v[Ca >> 2] = Da;
        j = v[d + 1074472 >> 2];
        i = j;
        m = j >> 31;
        j = v[a + 4 >> 2];
        Ca = a, Da = Fc(Bua(Aua(i, m, j, j >> 31), gb, 1048576, 0), gb), v[Ca + 4 >> 2] = Da;
        j = v[d + 1074472 >> 2];
        i = j;
        m = j >> 31;
        j = v[c >> 2];
        Ca = c, Da = Fc(Bua(Aua(i, m, j, j >> 31), gb, 1048576, 0), gb), v[Ca >> 2] = Da;
        j = v[d + 1074472 >> 2];
        i = j;
        m = j >> 31;
        j = v[c + 4 >> 2];
        Ca = c, Da = Fc(Bua(Aua(i, m, j, j >> 31), gb, 1048576, 0), gb), v[Ca + 4 >> 2] = Da;
        v[d + 1074460 >> 2] = v[d + 1074460 >> 2] - 1;
        break Qd;
       }
       j = v[a >> 2];
       Ca = a, Da = Fc(Bua(Aua(j, j >> 31, f, k), gb, 256, 0), gb), v[Ca >> 2] = Da;
       j = v[a + 4 >> 2];
       Ca = a, Da = Fc(Bua(Aua(j, j >> 31, f, k), gb, 256, 0), gb), v[Ca + 4 >> 2] = Da;
       j = v[c >> 2];
       Ca = c, Da = Fc(Bua(Aua(j, j >> 31, f, k), gb, 256, 0), gb), v[Ca >> 2] = Da;
       j = v[c + 4 >> 2];
       Ca = c, Da = Fc(Bua(Aua(j, j >> 31, f, k), gb, 256, 0), gb), v[Ca + 4 >> 2] = Da;
       v[d + 1074472 >> 2] = l;
      }
      b = b + 1 | 0;
      c = c + 8 | 0;
      a = a + 8 | 0;
      continue;
     }
    }
    eb = h + 16 | 0;
   }
   if (v[ja >> 2] != 128) {
    b = d + 12 | 0;
    c = d + 8204 | 0;
    a = v[d + 24604 >> 2];
    e = v[d + 24624 >> 2];
    Rd: {
     if ((a | 0) == 128 | e >>> 0 < 2) {
      break Rd;
     }
     CR(b, n, a);
     if (e >>> 0 < 4) {
      break Rd;
     }
     CR(c, n, a);
    }
   }
   b = v[d + 24624 >> 2];
   if ((b | 0) == 4) {
    b = n;
    while (1) {
     b = b - 1 | 0;
     if ((b | 0) >= 0) {
      a = (b << 4) + W | 0;
      c = b << 3;
      e = c | 4;
      v[a + 12 >> 2] = v[e + ka >> 2];
      v[a + 8 >> 2] = v[c + ka >> 2];
      v[a + 4 >> 2] = v[e + W >> 2];
      v[a >> 2] = v[c + W >> 2];
      continue;
     }
     break;
    }
    b = v[d + 24624 >> 2];
   }
   if (Hd(sa)) {
    v[F - -64 >> 2] = n;
    v[F + 60 >> 2] = b;
    v[F + 56 >> 2] = W;
    a = v[v[ha >> 2] + 8 >> 2];
    v[F + 24 >> 2] = n;
    b = v[F + 60 >> 2];
    v[F + 16 >> 2] = v[F + 56 >> 2];
    v[F + 20 >> 2] = b;
    hb[a | 0](ha, F + 16 | 0);
    b = v[d + 24624 >> 2];
   }
   v[F + 52 >> 2] = n;
   v[F + 48 >> 2] = b;
   v[F + 44 >> 2] = W;
   a = v[v[ga >> 2] + 8 >> 2];
   v[F + 8 >> 2] = n;
   b = v[F + 48 >> 2];
   v[F >> 2] = v[F + 44 >> 2];
   v[F + 4 >> 2] = b;
   hb[a | 0](ga, F);
   v[d + 1074380 >> 2] = v[d + 1074380 >> 2] - n;
   v[d + 1074376 >> 2] = n + v[d + 1074376 >> 2];
   ca = ca - n | 0;
   ra = n + ra | 0;
   continue;
  }
  break;
 }
 eb = aa + 32 | 0;
 return ra;
}

function Cqa(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, q = 0, r = 0, s = 0, z = 0, A = 0, C = 0, D = 0, E = 0, F = 0, G = 0, H = 0, I = 0, J = 0, K = 0, L = 0, S = 0, W = 0, X = 0, Y = 0;
 e = eb - 1712 | 0;
 eb = e;
 xc(b);
 a: {
  b: {
   c: {
    d: {
     e: {
      f: {
       g: {
        h: {
         d = e + 1704 | 0;
         i: {
          if (!ui(b, d)) {
           break i;
          }
          if (!nY(d)) {
           break i;
          }
          f = 1;
          if ((c | 0) == 64) {
           break i;
          }
          k = w[e + 1707 | 0];
          t[e + 1703 | 0] = k;
          v[e + 1696 >> 2] = -1;
          v[e + 1692 >> 2] = 1048576;
          if (k >>> 0 >= 5) {
           d = Qg(b);
           v[e + 1696 >> 2] = d;
           f = 0;
           if (!Lb(v[b >> 2], v[b + 8 >> 2], d)) {
            break i;
           }
           v[e + 288 >> 2] = 134217727;
           X = e, Y = v[Gb(e + 288 | 0, e + 1696 | 0) >> 2] << 5, v[X + 1692 >> 2] = Y;
          }
          D = Mb(e + 1680 | 0);
          v[e + 288 >> 2] = w[e + 1708 | 0] | w[e + 1709 | 0] << 8 | (w[e + 1710 | 0] << 16 | w[e + 1711 | 0] << 24);
          d = v[Gb(e + 1692 | 0, e + 288 | 0) >> 2];
          v[31601] = 0;
          N(552, D | 0, d | 0);
          d = v[31601];
          v[31601] = 0;
          j: {
           k: {
            l: {
             m: {
              if ((d | 0) != 1) {
               v[31601] = 0;
               d = T(553, b | 0, D | 0, w[e + 1708 | 0] | w[e + 1709 | 0] << 8 | (w[e + 1710 | 0] << 16 | w[e + 1711 | 0] << 24)) | 0;
               h = v[31601];
               v[31601] = 0;
               n: {
                if ((h | 0) == 1) {
                 break n;
                }
                f = 0;
                if (!d) {
                 break j;
                }
                if (k >>> 0 >= 5) {
                 v[31601] = 0;
                 O(149, b | 0, v[e + 1696 >> 2] + 12 | 0) | 0;
                 d = v[31601];
                 v[31601] = 0;
                 if ((d | 0) == 1) {
                  break n;
                 }
                }
                v[31601] = 0;
                N(246, a | 0, 0);
                d = v[31601];
                v[31601] = 0;
                if ((d | 0) == 1) {
                 break n;
                }
                dg(a);
                oe(e + 1648 | 0, v[D >> 2], v[D + 4 >> 2]);
                d = Ld(e + 1640 | 0);
                v[31601] = 0;
                h = v[d + 4 >> 2];
                v[e + 88 >> 2] = v[d >> 2];
                v[e + 92 >> 2] = h;
                m = gg(554, e + 1660 | 0, v[e + 1648 >> 2], v[e + 1652 >> 2], e + 88 | 0);
                d = v[31601];
                v[31601] = 0;
                o: {
                 p: {
                  q: {
                   if ((d | 0) != 1) {
                    v[31601] = 0;
                    R(358, m | 0, a + 1298308 | 0, -1);
                    d = v[31601];
                    v[31601] = 0;
                    if ((d | 0) == 1) {
                     break q;
                    }
                    v[31601] = 0;
                    R(358, m | 0, a + 1298332 | 0, -1);
                    d = v[31601];
                    v[31601] = 0;
                    if ((d | 0) == 1) {
                     break q;
                    }
                    v[31601] = 0;
                    d = O(555, m | 0, e + 1218 | 0) | 0;
                    h = v[31601];
                    v[31601] = 0;
                    if ((h | 0) == 1) {
                     break m;
                    }
                    if (!d) {
                     break k;
                    }
                    d = t[e + 1218 | 0];
                    if ((d | 0) <= 0 | (w[e + 1227 | 0] | w[e + 1228 | 0] << 8) >>> 0 > 255 | (w[e + 1229 | 0] | w[e + 1230 | 0] << 8) >>> 0 > 3999) {
                     break k;
                    }
                    u[a + 480188 >> 1] = d & 255;
                    $e(Wb(v[a + 484360 >> 2], w[a + 484376 | 0]), w[e + 1221 | 0] | w[e + 1222 | 0] << 8);
                    u[a + 480192 >> 1] = w[e + 1227 | 0] | w[e + 1228 | 0] << 8;
                    u[a + 480190 >> 1] = w[e + 1229 | 0] | w[e + 1230 | 0] << 8;
                    d = w[e + 1231 | 0];
                    v[a + 480196 >> 2] = d ? d : 6;
                    d = w[e + 1232 | 0];
                    v[a + 480204 >> 2] = B(d ? d : 125, 1e4);
                    h = w[e + 1233 | 0] | w[e + 1234 | 0] << 8 | (w[e + 1235 | 0] << 16 | w[e + 1236 | 0] << 24);
                    d = 32;
                    r: {
                     if (h & 256) {
                      break r;
                     }
                     d = 2;
                     if (h & 2) {
                      break r;
                     }
                     d = 1;
                     if (h & 128) {
                      break r;
                     }
                     d = h & 8 ? 16 : 4;
                    }
                    v[31601] = 0;
                    N(417, a | 0, d | 0);
                    d = v[31601];
                    v[31601] = 0;
                    if ((d | 0) == 1) {
                     break m;
                    }
                    d = v[a + 480208 >> 2];
                    g = d | 16777216;
                    v[a + 480208 >> 2] = g;
                    h = w[e + 1233 | 0] | w[e + 1234 | 0] << 8 | (w[e + 1235 | 0] << 16 | w[e + 1236 | 0] << 24);
                    if (h & 1) {
                     g = d | 16777232;
                     v[a + 480208 >> 2] = g;
                    }
                    d = v[a + 480180 >> 2];
                    i = (d | 0) == 32;
                    f = i & !(h & 1024);
                    j = (d | 0) == 2;
                    o = j & h >>> 4;
                    s = h & 2097152;
                    j = j & h >>> 2;
                    i = i & !(h & 2048);
                    if (f | (s | j | (i | o))) {
                     g = o ? g | 65536 : g;
                     g = j ? g | 2 : g;
                     g = i ? g | 4 : g;
                     v[a + 480208 >> 2] = s >>> 6 | (f ? g | 8 : g);
                    }
                    if (h & 524288) {
                     v[31601] = 0;
                     T(266, a + 1074312 | 0, 5, 1) | 0;
                     d = v[31601];
                     v[31601] = 0;
                     if ((d | 0) == 1) {
                      break m;
                     }
                     d = v[a + 480180 >> 2];
                    }
                    if ((d | 0) == 2) {
                     break p;
                    }
                    if ((d | 0) != 32) {
                     break o;
                    }
                    t[e + 288 | 0] = w[e + 1237 | 0];
                    t[e + 220 | 0] = 128;
                    X = a, Y = w[Pb(e + 288 | 0, e + 220 | 0) | 0] << 1, v[X + 480200 >> 2] = Y;
                    break o;
                   }
                   d = M() | 0;
                   break a;
                  }
                  d = M() | 0;
                  break b;
                 }
                 t[e + 288 | 0] = w[e + 1237 | 0];
                 t[e + 220 | 0] = 64;
                 X = a, Y = w[Pb(e + 288 | 0, e + 220 | 0) | 0] << 2, v[X + 480200 >> 2] = Y;
                }
                F = a + 480188 | 0;
                h = t[e + 1239 | 0];
                s: {
                 if ((h | 0) < 0) {
                  h = h + 52 << 24 >> 24;
                  break s;
                 }
                 H = Qt(+(h | 0) * 3.1 / 20);
                 t: {
                  if (H < 4294967296 & H >= 0) {
                   h = ~~H >>> 0;
                   break t;
                  }
                  h = 0;
                 }
                 h = h + 51 | 0;
                }
                v[a + 480228 >> 2] = h;
                u[e + 288 >> 1] = 64;
                s = a + 480280 | 0;
                g = x[Nc(F, e + 288 | 0) >> 1];
                o = e + 1304 | 0;
                i = e + 1240 | 0;
                f = 0;
                j = (d | 0) != 32;
                r = (d | 0) == 4;
                while (1) {
                 if ((f | 0) == (g | 0)) {
                  f = 0;
                  g = 0;
                  h = e + 1368 | 0;
                 } else {
                  u: {
                   v: {
                    if (!j) {
                     t[e + 288 | 0] = w[f + i | 0];
                     t[e + 220 | 0] = 64;
                     X = s + (f << 5) | 0, Y = w[Pb(e + 288 | 0, e + 220 | 0) | 0], u[X + 6 >> 1] = Y;
                     break v;
                    }
                    if (r) {
                     break u;
                    }
                   }
                   w: {
                    h = w[f + o | 0];
                    if ((h | 0) != 255) {
                     if ((h | 0) != 127) {
                      break w;
                     }
                     v[s + (f << 5) >> 2] = 256;
                     break u;
                    }
                    u[(s + (f << 5) | 0) + 4 >> 1] = 256;
                    break u;
                   }
                   u[(s + (f << 5) | 0) + 4 >> 1] = h;
                  }
                  f = f + 1 | 0;
                  continue;
                 }
                 break;
                }
                while (1) {
                 if ((f | 0) != 16) {
                  g = w[f + h | 0] != 0 | g;
                  f = f + 1 | 0;
                  continue;
                 }
                 break;
                }
                o = e + 1384 | 0;
                f = 0;
                while (1) if ((f | 0) == 128) {
                 if (!(g & 1)) {
                  break l;
                 }
                 d = a + 901692 | 0;
                 f = 0;
                 while (1) {
                  if ((f | 0) == 16) {
                   d = a + 902204 | 0;
                   f = 0;
                   while (1) {
                    if ((f | 0) != 128) {
                     h = o + (f << 1) | 0;
                     x: {
                      if (w[h + 1 | 0]) {
                       v[31601] = 0;
                       g = e + 220 | 0;
                       V(556, g | 0);
                       i = v[31601];
                       v[31601] = 0;
                       y: {
                        z: {
                         A: {
                          B: {
                           C: {
                            if ((i | 0) != 1) {
                             i = w[h + 1 | 0];
                             v[31601] = 0;
                             v[e + 244 >> 2] = i - 1;
                             i = e + 1164 | 0;
                             N(557, i | 0, e + 244 | 0);
                             j = v[31601];
                             v[31601] = 0;
                             if ((j | 0) == 1) {
                              break C;
                             }
                             h = w[h | 0];
                             v[31601] = 0;
                             t[e + 192 | 0] = h;
                             h = e + 1144 | 0;
                             N(558, h | 0, e + 192 | 0);
                             j = v[31601];
                             v[31601] = 0;
                             if ((j | 0) == 1) {
                              break B;
                             }
                             v[31601] = 0;
                             j = e + 288 | 0;
                             U(559, j | 0, g | 0, i | 0, h | 0);
                             r = v[31601];
                             v[31601] = 0;
                             if ((r | 0) == 1) {
                              break A;
                             }
                             ee(e + 1192 | 0, j);
                             qf(Oe(d, f), v[e + 1192 >> 2], v[e + 1196 >> 2]);
                             sb(j);
                             sb(h);
                             sb(i);
                             Db(g);
                             break x;
                            }
                            d = M() | 0;
                            break b;
                           }
                           d = M() | 0;
                           break y;
                          }
                          d = M() | 0;
                          break z;
                         }
                         d = M() | 0;
                         sb(e + 1144 | 0);
                        }
                        sb(e + 1164 | 0);
                       }
                       Db(e + 220 | 0);
                       break b;
                      }
                      h = oc(e + 1184 | 0, 22256);
                      qf(Oe(d, f), v[h >> 2], v[e + 1188 >> 2]);
                     }
                     f = f + 1 | 0;
                     continue;
                    }
                    break;
                   }
                   d = v[a + 480180 >> 2];
                   break l;
                  }
                  i = f + h | 0;
                  D: {
                   if (w[i | 0]) {
                    v[31601] = 0;
                    g = e + 220 | 0;
                    V(560, g | 0);
                    j = v[31601];
                    v[31601] = 0;
                    E: {
                     F: {
                      G: {
                       if ((j | 0) != 1) {
                        i = w[i | 0];
                        v[31601] = 0;
                        v[e + 1144 >> 2] = i - 1;
                        i = e + 1164 | 0;
                        N(557, i | 0, e + 1144 | 0);
                        j = v[31601];
                        v[31601] = 0;
                        if ((j | 0) == 1) {
                         break G;
                        }
                        v[31601] = 0;
                        j = e + 288 | 0;
                        R(290, j | 0, g | 0, i | 0);
                        r = v[31601];
                        v[31601] = 0;
                        if ((r | 0) == 1) {
                         break F;
                        }
                        ee(e + 1208 | 0, j);
                        qf(Oe(d, f), v[e + 1208 >> 2], v[e + 1212 >> 2]);
                        sb(j);
                        sb(i);
                        Db(g);
                        break D;
                       }
                       d = M() | 0;
                       break b;
                      }
                      d = M() | 0;
                      break E;
                     }
                     d = M() | 0;
                     sb(e + 1164 | 0);
                    }
                    Db(e + 220 | 0);
                    break b;
                   }
                   g = oc(e + 1200 | 0, 22256);
                   qf(Oe(d, f), v[g >> 2], v[e + 1204 >> 2]);
                  }
                  f = f + 1 | 0;
                  continue;
                 }
                } else {
                 g = w[(o + (f << 1) | 0) + 1 | 0] != 0 | g;
                 f = f + 1 | 0;
                 continue;
                }
               }
               d = M() | 0;
               break a;
              }
              d = M() | 0;
              break a;
             }
             d = M() | 0;
             break b;
            }
            h = w[a + 484376 | 0];
            g = v[a + 484360 >> 2];
            v[31601] = 0;
            d = d & 5;
            $(348, Wb(g, h) | 0, m | 0, w[e + 1219 | 0] | w[e + 1220 | 0] << 8, (d ? 65535 : 255) | 0, (d ? 65535 : 254) | 0);
            d = v[31601];
            v[31601] = 0;
            if ((d | 0) == 1) {
             break c;
            }
            v[31601] = 0;
            d = e + 288 | 0;
            R(185, d | 0, m | 0, B(w[e + 1218 | 0], w[e + 1223 | 0] | w[e + 1224 | 0] << 8) << 1);
            h = v[31601];
            v[31601] = 0;
            if ((h | 0) == 1) {
             break d;
            }
            I = gc(e + 1164 | 0, d);
            tb(d);
            v[31601] = 0;
            R(185, d | 0, m | 0, (w[e + 1223 | 0] | w[e + 1224 | 0] << 8) << 1);
            h = v[31601];
            v[31601] = 0;
            if ((h | 0) == 1) {
             break f;
            }
            J = gc(e + 1144 | 0, d);
            tb(d);
            v[31601] = 0;
            r = O(214, e + 1132 | 0, w[e + 1225 | 0] | w[e + 1226 | 0] << 8) | 0;
            d = v[31601];
            v[31601] = 0;
            if ((d | 0) == 1) {
             break h;
            }
            X = e, Y = vb(v[r >> 2]), v[X + 244 >> 2] = Y;
            h = vb(v[r + 4 >> 2]);
            H: {
             I: {
              J: {
               while (1) {
                g = v[e + 244 >> 2];
                if (!Hb(g, h)) {
                 d = v[a + 480180 >> 2];
                 E = c & 1;
                 if (!E) {
                  break I;
                 }
                 v[31601] = 0;
                 N(223, a + 484344 | 0, w[e + 1223 | 0] | w[e + 1224 | 0] << 8);
                 h = v[31601];
                 v[31601] = 0;
                 if ((h | 0) != 1) {
                  break I;
                 }
                 d = M() | 0;
                 break H;
                }
                v[31601] = 0;
                f = Q(151, m | 0) | 0;
                d = v[31601];
                v[31601] = 0;
                if ((d | 0) != 1) {
                 v[31601] = 0;
                 d = e + 220 | 0;
                 R(185, d | 0, m | 0, f | 0);
                 f = v[31601];
                 v[31601] = 0;
                 if ((f | 0) == 1) {
                  break J;
                 }
                 o = g;
                 g = gc(e + 288 | 0, d);
                 jd(o, g);
                 tb(g);
                 tb(d);
                 Pf(e + 244 | 0);
                 continue;
                }
                break;
               }
               d = M() | 0;
               break H;
              }
              d = M() | 0;
              break H;
             }
             q = (d | 0) == 16 ? 14 : (d | 0) == 32 ? 1 : 13;
             K = a + 484344 | 0;
             j = 1;
             while (1) {
              K: {
               L: {
                M: {
                 N: {
                  O: {
                   P: {
                    if ((w[e + 1223 | 0] | w[e + 1224 | 0] << 8) >>> 0 <= l >>> 0) {
                     switch (v[a + 480180 >> 2] - 1 | 0) {
                     case 0:
                      break N;

                     case 3:
                      break P;

                     default:
                      break M;
                     }
                    }
                    v[31601] = 0;
                    d = Q(189, J | 0) | 0;
                    h = v[31601];
                    v[31601] = 0;
                    if ((h | 0) == 1) {
                     break O;
                    }
                    v[e + 220 >> 2] = d;
                    if (!E) {
                     break K;
                    }
                    v[31601] = 0;
                    d = T(196, K | 0, l & 65535, d | 0) | 0;
                    h = v[31601];
                    v[31601] = 0;
                    if ((h | 0) == 1) {
                     break O;
                    }
                    h = 0;
                    if (!d) {
                     break K;
                    }
                    while (1) {
                     f = h & 65535;
                     if (f >>> 0 >= w[e + 1218 | 0]) {
                      break K;
                     }
                     v[31601] = 0;
                     d = Q(189, I | 0) | 0;
                     g = v[31601];
                     v[31601] = 0;
                     Q: {
                      if ((g | 0) != 1) {
                       g = v[r >> 2];
                       if (Rf(g, v[r + 4 >> 2]) >>> 0 <= d >>> 0) {
                        break Q;
                       }
                       A = bh(g, d);
                       xc(A);
                       g = 0;
                       d = Vb(v[K >> 2], l);
                       f = ld(v[d >> 2], v[v[d + 48 >> 2] + 12 >> 2], 0, f);
                       R: while (1) {
                        if (y[e + 220 >> 2] <= g >>> 0) {
                         break Q;
                        }
                        v[31601] = 0;
                        d = Q(197, A | 0) | 0;
                        o = v[31601];
                        v[31601] = 0;
                        if ((o | 0) != 1) {
                         if (!d) {
                          break Q;
                         }
                         z = d >>> 4 | 0;
                         C = d & 15;
                         i = 0;
                         o = Mg(e + 288 | 0);
                         while (1) {
                          S: {
                           T: {
                            U: {
                             if (C >>> 0 > (i & 255) >>> 0) {
                              v[31601] = 0;
                              d = e + 244 | 0;
                              N(198, d | 0, A | 0);
                              n = v[31601];
                              v[31601] = 0;
                              if ((n | 0) == 1) {
                               break U;
                              }
                              V: {
                               W: {
                                X: {
                                 Y: {
                                  Z: {
                                   _: {
                                    $: {
                                     aa: {
                                      ba: {
                                       ca: {
                                        da: {
                                         ea: {
                                          fa: {
                                           ga: {
                                            ha: {
                                             ia: {
                                              ja: {
                                               ka: {
                                                la: {
                                                 d = w[wb(d, 0) | 0];
                                                 switch (d - 1 | 0) {
                                                 case 5:
                                                  break ia;

                                                 case 1:
                                                  break ja;

                                                 case 0:
                                                  break ka;

                                                 case 2:
                                                 case 3:
                                                 case 4:
                                                 case 7:
                                                 case 8:
                                                 case 9:
                                                 case 11:
                                                 case 12:
                                                 case 13:
                                                 case 16:
                                                 case 18:
                                                 case 21:
                                                 case 22:
                                                 case 23:
                                                 case 24:
                                                 case 25:
                                                 case 27:
                                                 case 32:
                                                  break V;

                                                 case 33:
                                                  break Z;

                                                 case 30:
                                                 case 31:
                                                  break _;

                                                 case 29:
                                                  break $;

                                                 case 28:
                                                  break aa;

                                                 case 26:
                                                  break ba;

                                                 case 19:
                                                 case 20:
                                                  break ca;

                                                 case 17:
                                                  break da;

                                                 case 15:
                                                  break ea;

                                                 case 14:
                                                  break fa;

                                                 case 10:
                                                  break ga;

                                                 case 6:
                                                  break ha;

                                                 default:
                                                  break la;
                                                 }
                                                }
                                                switch (d - 48 | 0) {
                                                case 4:
                                                 break W;

                                                case 1:
                                                case 2:
                                                 break X;

                                                case 0:
                                                 break Y;

                                                default:
                                                 break V;
                                                }
                                               }
                                               d = w[wb(e + 244 | 0, 1) | 0];
                                               ma: {
                                                if (d >>> 0 <= 119) {
                                                 d = d + q | 0;
                                                 break ma;
                                                }
                                                na: {
                                                 switch (d - 254 | 0) {
                                                 case 1:
                                                  d = 255;
                                                  break ma;

                                                 case 0:
                                                  d = 254;
                                                  break ma;

                                                 default:
                                                  break na;
                                                 }
                                                }
                                                d = 253;
                                               }
                                               t[o | 0] = d;
                                               j = PD(d) & j;
                                               break S;
                                              }
                                              X = e, Y = w[wb(e + 244 | 0, 1) | 0] + 1 | 0, t[X + 289 | 0] = Y;
                                              break S;
                                             }
                                             oa: {
                                              if (w[e + 290 | 0]) {
                                               break oa;
                                              }
                                              d = v[a + 480180 >> 2];
                                              if ((d | 0) != 32) {
                                               if ((d | 0) != 4) {
                                                break oa;
                                               }
                                               d = w[wb(e + 244 | 0, 1) | 0];
                                               if (d & 15) {
                                                break oa;
                                               }
                                               t[e + 290 | 0] = 11;
                                               t[e + 292 | 0] = d >>> 4;
                                               break S;
                                              }
                                              d = 0;
                                              n = w[wb(e + 244 | 0, 1) | 0];
                                              while (1) {
                                               if ((d | 0) == 10) {
                                                break oa;
                                               }
                                               if ((n | 0) == w[d + 42112 | 0]) {
                                                t[e + 292 | 0] = d;
                                                t[e + 290 | 0] = 11;
                                                break S;
                                               } else {
                                                d = d + 1 | 0;
                                                continue;
                                               }
                                              }
                                             }
                                             X = e, Y = w[wb(e + 244 | 0, 1) | 0], t[X + 293 | 0] = Y;
                                             t[e + 291 | 0] = 4;
                                             break S;
                                            }
                                            d = wb(e + 244 | 0, 1);
                                            pa: {
                                             if (w[e + 290 | 0]) {
                                              break pa;
                                             }
                                             n = w[d | 0];
                                             if (v[a + 480180 >> 2] != 32 | n >>> 0 > 9) {
                                              break pa;
                                             }
                                             t[e + 292 | 0] = n;
                                             t[e + 290 | 0] = 8;
                                             break S;
                                            }
                                            t[e + 293 | 0] = w[d | 0];
                                            t[e + 291 | 0] = 5;
                                            break S;
                                           }
                                           qa: {
                                            if (w[e + 290 | 0]) {
                                             break qa;
                                            }
                                            ra: {
                                             d = v[a + 480180 >> 2];
                                             if ((d | 0) != 4) {
                                              if ((d | 0) != 32) {
                                               break qa;
                                              }
                                              d = wb(e + 244 | 0, 1);
                                              n = w[d | 0];
                                              if ((n | 0) != 255) {
                                               break ra;
                                              }
                                              t[e + 292 | 0] = 64;
                                              t[e + 290 | 0] = 2;
                                              break S;
                                             }
                                             d = wb(e + 244 | 0, 1);
                                             if (w[d | 0] & 15) {
                                              break qa;
                                             }
                                             break T;
                                            }
                                            if (!(n & 3)) {
                                             break T;
                                            }
                                           }
                                           X = e, Y = w[wb(e + 244 | 0, 1) | 0], t[X + 293 | 0] = Y;
                                           t[e + 291 | 0] = 9;
                                           break S;
                                          }
                                          n = w[e + 290 | 0];
                                          d = wb(e + 244 | 0, 1);
                                          sa: {
                                           if (n | v[a + 480180 >> 2] == 1) {
                                            break sa;
                                           }
                                           n = w[d | 0];
                                           if (n >>> 0 > 64) {
                                            break sa;
                                           }
                                           t[e + 292 | 0] = n;
                                           t[e + 290 | 0] = 1;
                                           break S;
                                          }
                                          t[e + 293 | 0] = w[d | 0];
                                          t[e + 291 | 0] = 13;
                                          break S;
                                         }
                                         d = w[wb(e + 244 | 0, 1) | 0];
                                         t[e + 293 | 0] = d;
                                         t[e + 291 | 0] = 14;
                                         if (v[a + 480180 >> 2] == 32) {
                                          break S;
                                         }
                                         t[e + 293 | 0] = B((d & 240) >>> 4 | 0, 10) + (d & 15);
                                         break S;
                                        }
                                        d = w[wb(e + 244 | 0, 1) | 0];
                                        t[e + 293 | 0] = d;
                                        t[e + 291 | 0] = d >>> 0 < 32 ? 16 : 17;
                                        break S;
                                       }
                                       n = w[wb(e + 244 | 0, 1) | 0];
                                       if (n >>> 0 >= 16) {
                                        t[e + 292 | 0] = n >>> 4;
                                        t[e + 290 | 0] = (d | 0) == 20 ? 3 : 5;
                                        break S;
                                       }
                                       t[e + 292 | 0] = n;
                                       t[e + 290 | 0] = (d | 0) == 20 ? 4 : 6;
                                       break S;
                                      }
                                      d = w[wb(e + 244 | 0, 1) | 0];
                                      if (d >>> 0 >= 16) {
                                       t[e + 290 | 0] = 10;
                                       t[e + 292 | 0] = d >>> 4;
                                       break S;
                                      }
                                      t[e + 292 | 0] = d;
                                      t[e + 290 | 0] = 9;
                                      break S;
                                     }
                                     d = w[wb(e + 244 | 0, 1) | 0];
                                     t[e + 291 | 0] = 28;
                                     t[e + 293 | 0] = d | 16;
                                     break S;
                                    }
                                    d = w[wb(e + 244 | 0, 1) | 0];
                                    t[e + 291 | 0] = 28;
                                    t[e + 293 | 0] = d | 32;
                                    break S;
                                   }
                                   X = e, Y = w[wb(e + 244 | 0, 1) | 0], t[X + 292 | 0] = Y;
                                   t[e + 290 | 0] = (d | 0) == 31 ? 7 : 8;
                                   break S;
                                  }
                                  d = w[e + 291 | 0];
                                  t[e + 291 | 0] = (d | 0) == 4 ? 6 : (d | 0) == 5 ? 7 : 11;
                                  X = e, Y = w[wb(e + 244 | 0, 1) | 0], t[X + 293 | 0] = Y;
                                  break S;
                                 }
                                 d = wb(e + 244 | 0, 1);
                                 t[e + 292 | 0] = w[d | 0] % 10;
                                 d = w[d | 0];
                                 if (d >>> 0 <= 9) {
                                  t[e + 290 | 0] = 5;
                                  break S;
                                 }
                                 if (d >>> 0 <= 19) {
                                  t[e + 290 | 0] = 6;
                                  break S;
                                 }
                                 if (d >>> 0 <= 29) {
                                  t[e + 290 | 0] = 3;
                                  break S;
                                 }
                                 if (d >>> 0 > 39) {
                                  break S;
                                 }
                                 t[e + 290 | 0] = 4;
                                 break S;
                                }
                                X = e, Y = w[wb(e + 244 | 0, 1) | 0], t[X + 292 | 0] = Y;
                                t[e + 290 | 0] = (d | 0) == 49 ? 13 : 12;
                                break S;
                               }
                               d = w[wb(e + 244 | 0, 1) | 0] + 33 | 0;
                               if ((d & 255) >>> 0 > 9) {
                                break S;
                               }
                               t[e + 290 | 0] = 15;
                               t[e + 292 | 0] = d;
                               break S;
                              }
                              if (d >>> 0 > 57) {
                               break S;
                              }
                              X = e, Y = w[wb(e + 244 | 0, 1) | 0], t[X + 293 | 0] = Y;
                              t[e + 291 | 0] = w[d + 25184 | 0];
                              break S;
                             }
                             v[e + 244 >> 2] = g + z;
                             d = v[Gb(e + 244 | 0, e + 220 | 0) >> 2];
                             d = d >>> 0 < g >>> 0 ? g : d;
                             while (1) {
                              if ((d | 0) != (g | 0)) {
                               i = w[o | 0] | w[o + 1 | 0] << 8 | (w[o + 2 | 0] << 16 | w[o + 3 | 0] << 24);
                               t[f | 0] = i;
                               t[f + 1 | 0] = i >>> 8;
                               t[f + 2 | 0] = i >>> 16;
                               t[f + 3 | 0] = i >>> 24;
                               i = w[o + 4 | 0] | w[o + 5 | 0] << 8;
                               t[f + 4 | 0] = i;
                               t[f + 5 | 0] = i >>> 8;
                               g = g + 1 | 0;
                               f = B(w[e + 1218 | 0], 6) + f | 0;
                               continue;
                              }
                              break;
                             }
                             g = d;
                             continue R;
                            }
                            d = M() | 0;
                            break H;
                           }
                           d = w[d | 0];
                           t[e + 290 | 0] = 2;
                           t[e + 292 | 0] = d >>> 2;
                          }
                          i = i + 1 | 0;
                          continue;
                         }
                        }
                        break;
                       }
                       d = M() | 0;
                       break H;
                      }
                      d = M() | 0;
                      break H;
                     }
                     h = h + 1 | 0;
                     continue;
                    }
                   }
                   f = x[a + 480192 >> 1];
                   d = 0;
                   break L;
                  }
                  d = M() | 0;
                  break H;
                 }
                 if (!(x[F >> 1] == 4 & j)) {
                  break M;
                 }
                 v[a + 480208 >> 2] = v[a + 480208 >> 2] | 8454144;
                }
                f = 0;
                d = !((w[e + 1233 | 0] | w[e + 1234 | 0] << 8 | (w[e + 1235 | 0] << 16 | w[e + 1236 | 0] << 24)) & 512);
               }
               v[31601] = 0;
               A = O(561, e + 1120 | 0, f | 0) | 0;
               h = v[31601];
               v[31601] = 0;
               ta: {
                ua: {
                 va: {
                  wa: {
                   xa: {
                    if ((h | 0) != 1) {
                     o = k >>> 0 < 5;
                     i = 1;
                     ya: {
                      while (1) {
                       f = i & 65535;
                       if (f >>> 0 > x[a + 480192 >> 1]) {
                        break ya;
                       }
                       za: {
                        Aa: {
                         Ba: {
                          Ca: {
                           if (!d) {
                            v[31601] = 0;
                            g = T(251, a | 0, f | 0, 0) | 0;
                            h = v[31601];
                            v[31601] = 0;
                            if ((h | 0) == 1) {
                             break Ca;
                            }
                            if (g) {
                             break Ba;
                            }
                           }
                           while (1) {
                            v[31601] = 0;
                            h = Q(197, m | 0) | 0;
                            g = v[31601];
                            v[31601] = 0;
                            if ((g | 0) == 1) {
                             break ua;
                            }
                            if (h) {
                             continue;
                            }
                            break;
                           }
                           if (!o) {
                            while (1) {
                             v[31601] = 0;
                             h = Q(197, m | 0) | 0;
                             g = v[31601];
                             v[31601] = 0;
                             if ((g | 0) == 1) {
                              d = M() | 0;
                              break ta;
                             }
                             if (h) {
                              continue;
                             }
                             break;
                            }
                           }
                           v[31601] = 0;
                           O(183, m | 0, 826) | 0;
                           h = v[31601];
                           v[31601] = 0;
                           if ((h | 0) != 1) {
                            break Aa;
                           }
                          }
                          d = M() | 0;
                          break ta;
                         }
                         h = Eb(e + 220 | 0);
                         v[31601] = 0;
                         R(358, m | 0, h | 0, -1);
                         j = v[31601];
                         v[31601] = 0;
                         if ((j | 0) == 1) {
                          break za;
                         }
                         zc(g + 492 | 0, h);
                         if (!o) {
                          v[31601] = 0;
                          R(358, m | 0, h | 0, -1);
                          j = v[31601];
                          v[31601] = 0;
                          if ((j | 0) == 1) {
                           break za;
                          }
                          zc(g + 524 | 0, h);
                         }
                         v[31601] = 0;
                         j = e + 288 | 0;
                         l = O(562, m | 0, j | 0) | 0;
                         k = v[31601];
                         v[31601] = 0;
                         if ((k | 0) == 1) {
                          break va;
                         }
                         if (!l) {
                          break xa;
                         }
                         l = v[a + 480180 >> 2];
                         v[31601] = 0;
                         R(563, j | 0, g | 0, l | 0);
                         g = v[31601];
                         v[31601] = 0;
                         if ((g | 0) == 1) {
                          break va;
                         }
                         if (v[a + 480180 >> 2] == 4) {
                          g = xb(v[A >> 2], f - 1 | 0);
                          f = w[e + 1090 | 0] | w[e + 1091 | 0] << 8 | (w[e + 1092 | 0] << 16 | w[e + 1093 | 0] << 24);
                          t[g | 0] = f;
                          t[g + 1 | 0] = f >>> 8;
                          t[g + 2 | 0] = f >>> 16;
                          t[g + 3 | 0] = f >>> 24;
                         }
                         sb(h);
                        }
                        i = i + 1 | 0;
                        continue;
                       }
                       break;
                      }
                      break va;
                     }
                     if (!d) {
                      break wa;
                     }
                     u[a + 480192 >> 1] = 0;
                     break wa;
                    }
                    d = M() | 0;
                    break H;
                   }
                   sb(h);
                  }
                  d = x[a + 480190 >> 1];
                  v[31601] = 0;
                  o = O(564, e + 276 | 0, d | 0) | 0;
                  d = v[31601];
                  v[31601] = 0;
                  if ((d | 0) != 1) {
                   C = w[e + 1703 | 0];
                   S = !(t[e + 1233 | 0] & 1) | C >>> 0 > 4;
                   n = c & 2;
                   W = a + 946304 | 0;
                   E = a + 484380 | 0;
                   i = 1;
                   d = 0;
                   while (1) {
                    h = d;
                    Da: {
                     Ea: {
                      Fa: {
                       Ga: {
                        Ha: {
                         Ia: {
                          Ja: {
                           Ka: {
                            La: {
                             Ma: {
                              Na: {
                               Oa: {
                                Pa: {
                                 Qa: {
                                  Ra: {
                                   Sa: {
                                    Ta: {
                                     Ua: {
                                      Va: {
                                       Wa: {
                                        Xa: {
                                         j = i & 65535;
                                         if (j >>> 0 <= x[a + 480190 >> 1]) {
                                          f = Eb(e + 264 | 0);
                                          v[31601] = 0;
                                          R(358, m | 0, f | 0, -1);
                                          c = v[31601];
                                          v[31601] = 0;
                                          Ya: {
                                           Za: {
                                            if ((c | 0) != 1) {
                                             zc((j << 5) + W | 0, f);
                                             d = C >>> 0 < 5;
                                             if (d) {
                                              break Za;
                                             }
                                             v[31601] = 0;
                                             R(358, m | 0, f | 0, -1);
                                             c = v[31601];
                                             v[31601] = 0;
                                             if ((c | 0) != 1) {
                                              break Ya;
                                             }
                                            }
                                            d = M() | 0;
                                            break Ga;
                                           }
                                           sf(f);
                                          }
                                          v[31601] = 0;
                                          c = e + 288 | 0;
                                          g = O(565, m | 0, c | 0) | 0;
                                          l = v[31601];
                                          v[31601] = 0;
                                          _a: {
                                           $a: {
                                            if ((l | 0) == 1) {
                                             break $a;
                                            }
                                            if (!g) {
                                             break _a;
                                            }
                                            g = v[a + 480180 >> 2];
                                            v[31601] = 0;
                                            k = c;
                                            c = E + B(j, 104) | 0;
                                            U(566, k | 0, c | 0, g | 0, S | 0);
                                            g = v[31601];
                                            v[31601] = 0;
                                            if ((g | 0) == 1) {
                                             break $a;
                                            }
                                            Ae(c + 43 | 0, f);
                                            q = 0;
                                            ab: {
                                             if (((w[e + 308 | 0] | w[e + 309 | 0] << 8) & 61440) != 28672 | d) {
                                              break ab;
                                             }
                                             v[31601] = 0;
                                             q = Q(567, m | 0) | 0;
                                             d = v[31601];
                                             v[31601] = 0;
                                             if ((d | 0) != 1) {
                                              break ab;
                                             }
                                             d = M() | 0;
                                             break Ga;
                                            }
                                            if (!n) {
                                             break Ea;
                                            }
                                            g = w[e + 323 | 0] | w[e + 324 | 0] << 8 | (w[e + 325 | 0] << 16 | w[e + 326 | 0] << 24);
                                            d = w[e + 308 | 0] | w[e + 309 | 0] << 8;
                                            l = d & 61440;
                                            if (!(g | l)) {
                                             d = Yc(e + 220 | 0, d & 1 ? 16 : 8, d & 1024 ? 3 : 1, 0, 0);
                                             v[31601] = 0;
                                             T(215, d | 0, c | 0, b | 0) | 0;
                                             c = v[31601];
                                             v[31601] = 0;
                                             if ((c | 0) != 1) {
                                              break Ea;
                                             }
                                             d = M() | 0;
                                             break Ga;
                                            }
                                            if ((g | 0) < 0) {
                                             d = g + j | 0;
                                             if ((d | 0) <= 0) {
                                              break Ea;
                                             }
                                             mY(c, E + B(d, 104) | 0);
                                             break Ea;
                                            }
                                            if ((g | 0) <= 0) {
                                             break Ea;
                                            }
                                            if (d & 1) {
                                             u[c + 34 >> 1] = x[c + 34 >> 1] | 1;
                                            }
                                            if (d & 1024) {
                                             u[c + 34 >> 1] = x[c + 34 >> 1] | 64;
                                            }
                                            v[31601] = 0;
                                            k = e + 220 | 0;
                                            R(185, k | 0, b | 0, g | 0);
                                            g = v[31601];
                                            v[31601] = 0;
                                            bb: {
                                             cb: {
                                              db: {
                                               eb: {
                                                fb: {
                                                 gb: {
                                                  if ((g | 0) != 1) {
                                                   g = gc(e + 244 | 0, k);
                                                   tb(k);
                                                   k = Zd(x[c + 34 >> 1]);
                                                   L = (l | 0) == 16384;
                                                   if (!L & (l | 0) != 8192) {
                                                    break eb;
                                                   }
                                                   z = v[g >> 2];
                                                   v[31601] = 0;
                                                   z = Q(154, z | 0) | 0;
                                                   G = v[31601];
                                                   v[31601] = 0;
                                                   if ((G | 0) == 1) {
                                                    break bb;
                                                   }
                                                   G = 4 / (k >>> 0) | 0;
                                                   Aua(G, 0, z, 0);
                                                   wc(c, gb ? -1 : B(z, G));
                                                   if ((l | 0) == 8192) {
                                                    break gb;
                                                   }
                                                   if (!L) {
                                                    break eb;
                                                   }
                                                   if (!Fh(c)) {
                                                    break db;
                                                   }
                                                   d = v[c >> 2];
                                                   c = v[c + 20 >> 2];
                                                   if (!(t[e + 308 | 0] & 1)) {
                                                    break fb;
                                                   }
                                                   v[31601] = 0;
                                                   U(568, g | 0, c | 0, d | 0, k | 0);
                                                   c = v[31601];
                                                   v[31601] = 0;
                                                   d = h;
                                                   if ((c | 0) == 1) {
                                                    break Ia;
                                                   }
                                                   break cb;
                                                  }
                                                  d = M() | 0;
                                                  break Ga;
                                                 }
                                                 if (!Fh(c)) {
                                                  break db;
                                                 }
                                                 d = v[c >> 2];
                                                 c = v[c + 20 >> 2];
                                                 if (t[e + 308 | 0] & 1) {
                                                  v[31601] = 0;
                                                  U(569, g | 0, c | 0, d | 0, k | 0);
                                                  c = v[31601];
                                                  v[31601] = 0;
                                                  d = h;
                                                  if ((c | 0) != 1) {
                                                   break cb;
                                                  }
                                                  break Ia;
                                                 }
                                                 v[31601] = 0;
                                                 U(570, g | 0, c | 0, d | 0, k | 0);
                                                 c = v[31601];
                                                 v[31601] = 0;
                                                 d = h;
                                                 if ((c | 0) == 1) {
                                                  break Ia;
                                                 }
                                                 break cb;
                                                }
                                                v[31601] = 0;
                                                U(571, g | 0, c | 0, d | 0, k | 0);
                                                c = v[31601];
                                                v[31601] = 0;
                                                d = h;
                                                if ((c | 0) == 1) {
                                                 break Ia;
                                                }
                                                break cb;
                                               }
                                               if ((d & 45056) == 12288) {
                                                c = lY(e + 220 | 0, g, w[e + 327 | 0] | w[e + 328 | 0] << 8, q);
                                                X = jd(vf(v[o >> 2], j - 1 | 0), c), Y = v[c + 20 >> 2], v[X + 20 >> 2] = Y;
                                                tb(c);
                                                break db;
                                               }
                                               if ((l | 0) != 32768) {
                                                d = 1;
                                                if ((l | 0) != 4096) {
                                                 break cb;
                                                }
                                                l = Ge(e + 220 | 0, g);
                                                v[31601] = 0;
                                                d = O(572, e + 214 | 0, g | 0) | 0;
                                                k = v[31601];
                                                v[31601] = 0;
                                                if ((k | 0) != 1) {
                                                 hb: {
                                                  ib: {
                                                   if (!w[e + 219 | 0]) {
                                                    break ib;
                                                   }
                                                   q = w[e + 327 | 0] | w[e + 328 | 0] << 8;
                                                   k = x[e + 216 >> 1] << 1;
                                                   if (q >>> 0 < (k & 65535) >>> 0) {
                                                    break ib;
                                                   }
                                                   k = q - k | 0;
                                                   t[e + 327 | 0] = k;
                                                   t[e + 328 | 0] = k >>> 8;
                                                   d = x[d >> 1];
                                                   v[31601] = 0;
                                                   O(149, g | 0, d | 0) | 0;
                                                   d = v[31601];
                                                   v[31601] = 0;
                                                   if ((d | 0) == 1) {
                                                    break hb;
                                                   }
                                                   v[31601] = 0;
                                                   k = Q(202, g | 0) | 0;
                                                   d = v[31601];
                                                   v[31601] = 0;
                                                   if ((d | 0) == 1) {
                                                    break hb;
                                                   }
                                                   v[31601] = 0;
                                                   d = e + 172 | 0;
                                                   R(185, d | 0, g | 0, k | 0);
                                                   k = v[31601];
                                                   v[31601] = 0;
                                                   if ((k | 0) == 1) {
                                                    break hb;
                                                   }
                                                   k = gc(e + 192 | 0, d);
                                                   jd(l, k);
                                                   tb(k);
                                                   tb(d);
                                                  }
                                                  v[31601] = 0;
                                                  j = T(573, a | 0, j | 0, l | 0) | 0;
                                                  d = v[31601];
                                                  v[31601] = 0;
                                                  if ((d | 0) == 1) {
                                                   break hb;
                                                  }
                                                  d = 1;
                                                  if (j) {
                                                   d = w[e + 327 | 0] | w[e + 328 | 0] << 8;
                                                   jb: {
                                                    if (!d) {
                                                     break jb;
                                                    }
                                                    j = x[c + 34 >> 1];
                                                    k = Nk(v[c >> 2], j);
                                                    if (k >>> 0 <= d >>> 0) {
                                                     break jb;
                                                    }
                                                    j = Xk(j);
                                                    q = v[c + 20 >> 2];
                                                    fl(q, d + q | 0, k - d | 0);
                                                    v[c >> 2] = v[c >> 2] - ((d >>> 0) / (j >>> 0) | 0);
                                                   }
                                                   wc(c, w[e + 296 | 0] | w[e + 297 | 0] << 8 | (w[e + 298 | 0] << 16 | w[e + 299 | 0] << 24));
                                                   d = h;
                                                  }
                                                  tb(l);
                                                  break cb;
                                                 }
                                                }
                                                d = M() | 0;
                                                tb(l);
                                                break Ha;
                                               }
                                               v[31601] = 0;
                                               d = O(428, g | 0, e + 220 | 0) | 0;
                                               j = v[31601];
                                               v[31601] = 0;
                                               if ((j | 0) == 1) {
                                                break Xa;
                                               }
                                               if (!d) {
                                                break db;
                                               }
                                               v[e + 80 >> 2] = w[e + 228 | 0] | w[e + 229 | 0] << 8 | (w[e + 230 | 0] << 16 | w[e + 231 | 0] << 24);
                                               d = w[e + 224 | 0] | w[e + 225 | 0] << 8 | (w[e + 226 | 0] << 16 | w[e + 227 | 0] << 24);
                                               v[e + 72 >> 2] = w[e + 220 | 0] | w[e + 221 | 0] << 8 | (w[e + 222 | 0] << 16 | w[e + 223 | 0] << 24);
                                               v[e + 76 >> 2] = d;
                                               Qk(c, 1, e + 72 | 0);
                                              }
                                              d = h;
                                             }
                                             tb(g);
                                             break Da;
                                            }
                                            d = M() | 0;
                                            break Ha;
                                           }
                                           d = M() | 0;
                                           break Ga;
                                          }
                                          sb(f);
                                         }
                                         kb: {
                                          if (!n) {
                                           break kb;
                                          }
                                          k = 1;
                                          while (1) {
                                           d = k & 65535;
                                           if (d >>> 0 > x[a + 480190 >> 1]) {
                                            break kb;
                                           }
                                           b = vf(v[o >> 2], d - 1 | 0);
                                           c = v[b >> 2];
                                           v[31601] = 0;
                                           c = Q(172, c | 0) | 0;
                                           g = v[31601];
                                           v[31601] = 0;
                                           if ((g | 0) == 1) {
                                            break Wa;
                                           }
                                           lb: {
                                            mb: {
                                             if (!c) {
                                              break mb;
                                             }
                                             c = d + u[b + 22 >> 1] | 0;
                                             c = ((c | 0) > 0 ? c : k) & 65535;
                                             i = x[b + 20 >> 1];
                                             f = (c | 0) != (d | 0) & (c | 0) != 0 & c >>> 0 <= x[a + 480190 >> 1] & (i | 0) != 0;
                                             nb: {
                                              if (f) {
                                               g = vf(v[o >> 2], c - 1 | 0);
                                               break nb;
                                              }
                                              c = v[b >> 2];
                                              v[31601] = 0;
                                              i = Q(154, c | 0) | 0;
                                              c = v[31601];
                                              v[31601] = 0;
                                              g = b;
                                              if ((c | 0) == 1) {
                                               break Va;
                                              }
                                             }
                                             xc(g);
                                             ob: {
                                              if (f) {
                                               c = v[g + 8 >> 2];
                                               j = v[g >> 2];
                                               l = x[b + 20 >> 1];
                                               v[31601] = 0;
                                               c = T(150, j | 0, c | 0, l | 0) | 0;
                                               j = v[31601];
                                               v[31601] = 0;
                                               if ((j | 0) == 1) {
                                                break Va;
                                               }
                                               if (!c) {
                                                break mb;
                                               }
                                               v[e + 220 >> 2] = 0;
                                               v[e + 244 >> 2] = 0;
                                               v[31601] = 0;
                                               j = e + 288 | 0;
                                               R(186, j | 0, g | 0, i | 0);
                                               c = v[31601];
                                               v[31601] = 0;
                                               pb: {
                                                if ((c | 0) != 1) {
                                                 c = dD(Ze(j), th(v[e + 288 >> 2]), e + 220 | 0, e + 244 | 0);
                                                 v[31601] = 0;
                                                 O(183, g | 0, v[e + 220 >> 2]) | 0;
                                                 g = v[31601];
                                                 v[31601] = 0;
                                                 if ((g | 0) == 1) {
                                                  break pb;
                                                 }
                                                 Jc(j);
                                                 break ob;
                                                }
                                                d = M() | 0;
                                                break Fa;
                                               }
                                               d = M() | 0;
                                               Jc(e + 288 | 0);
                                               break Fa;
                                              }
                                              c = 0;
                                              v[e + 220 >> 2] = 0;
                                              v[e + 244 >> 2] = 0;
                                             }
                                             v[31601] = 0;
                                             g = e + 288 | 0;
                                             N(574, g | 0, b | 0);
                                             i = v[31601];
                                             v[31601] = 0;
                                             qb: {
                                              rb: {
                                               if ((i | 0) != 1) {
                                                j = Ze(g);
                                                i = v[e + 288 >> 2];
                                                if (!f) {
                                                 c = dD(j, th(i), e + 220 | 0, e + 244 | 0);
                                                 v[31601] = 0;
                                                 g = v[e + 220 >> 2];
                                                 O(183, b | 0, g | 0) | 0;
                                                 f = v[31601];
                                                 v[31601] = 0;
                                                 if ((f | 0) == 1) {
                                                  break lb;
                                                 }
                                                 j = g + j | 0;
                                                 i = i - g | 0;
                                                }
                                                if (c) {
                                                 break rb;
                                                }
                                                h = 1;
                                                break qb;
                                               }
                                               d = M() | 0;
                                               break Fa;
                                              }
                                              l = E + B(d, 104) | 0;
                                              Fh(l);
                                              g = 0;
                                              f = v[e + 244 >> 2];
                                              while (1) {
                                               sb: {
                                                if (!i | (f | 0) != 1 ? f : 0) {
                                                 break sb;
                                                }
                                                d = v[l >> 2];
                                                if (d >>> 0 <= g >>> 0) {
                                                 break sb;
                                                }
                                                if (!ke(d, v[l + 20 >> 2])) {
                                                 break sb;
                                                }
                                                v[e + 192 >> 2] = 0;
                                                v[e + 172 >> 2] = 0;
                                                d = e + 172 | 0;
                                                n = kY(c, j, th(i), e + 192 | 0, e + 264 | 0, d);
                                                v[31601] = 0;
                                                v[e + 220 >> 2] = n;
                                                O(183, b | 0, n | 0) | 0;
                                                f = v[31601];
                                                v[31601] = 0;
                                                if ((f | 0) == 1) {
                                                 break Ja;
                                                }
                                                ti(d, th(v[l >> 2] - g | 0));
                                                d = v[e + 172 >> 2];
                                                tb: {
                                                 if ((d | 0) <= 0) {
                                                  break tb;
                                                 }
                                                 f = v[e + 192 >> 2];
                                                 C = x[l + 34 >> 1];
                                                 if ((Zd(C) | 0) != (f | 0)) {
                                                  break tb;
                                                 }
                                                 q = B(f, g);
                                                 z = v[l + 20 >> 2];
                                                 if (C & 1) {
                                                  v[e + 168 >> 2] = d;
                                                  v[e + 156 >> 2] = d;
                                                  v[e - -64 >> 2] = d;
                                                  v[e + 48 >> 2] = d;
                                                  v[e + 152 >> 2] = f;
                                                  v[e + 148 >> 2] = v[e + 264 >> 2];
                                                  v[e + 164 >> 2] = f;
                                                  v[e + 160 >> 2] = z + (q << 1);
                                                  v[31601] = 0;
                                                  f = v[e + 152 >> 2];
                                                  v[e + 40 >> 2] = v[e + 148 >> 2];
                                                  v[e + 44 >> 2] = f;
                                                  f = v[e + 164 >> 2];
                                                  v[e + 56 >> 2] = v[e + 160 >> 2];
                                                  v[e + 60 >> 2] = f;
                                                  N(575, e + 56 | 0, e + 40 | 0);
                                                  f = v[31601];
                                                  v[31601] = 0;
                                                  if ((f | 0) != 1) {
                                                   break tb;
                                                  }
                                                  break Ja;
                                                 }
                                                 v[e + 144 >> 2] = d;
                                                 v[e + 132 >> 2] = d;
                                                 v[e + 32 >> 2] = d;
                                                 v[e + 16 >> 2] = d;
                                                 v[e + 128 >> 2] = f;
                                                 v[e + 124 >> 2] = v[e + 264 >> 2];
                                                 v[e + 140 >> 2] = f;
                                                 v[e + 136 >> 2] = q + z;
                                                 v[31601] = 0;
                                                 f = v[e + 128 >> 2];
                                                 v[e + 8 >> 2] = v[e + 124 >> 2];
                                                 v[e + 12 >> 2] = f;
                                                 f = v[e + 140 >> 2];
                                                 v[e + 24 >> 2] = v[e + 136 >> 2];
                                                 v[e + 28 >> 2] = f;
                                                 N(576, e + 24 | 0, e + 8 | 0);
                                                 f = v[31601];
                                                 v[31601] = 0;
                                                 if ((f | 0) == 1) {
                                                  break Ja;
                                                 }
                                                }
                                                i = i - n | 0;
                                                j = j + n | 0;
                                                f = jY(c);
                                                v[e + 244 >> 2] = f;
                                                g = d + g | 0;
                                                continue;
                                               }
                                               break;
                                              }
                                              iY(c);
                                             }
                                             Jc(e + 288 | 0);
                                            }
                                            k = k + 1 | 0;
                                            continue;
                                           }
                                           break;
                                          }
                                          break Ja;
                                         }
                                         ub: {
                                          if (v[a + 480180 >> 2] != 4) {
                                           break ub;
                                          }
                                          f = 0;
                                          while (1) {
                                           if (x[a + 480192 >> 1] <= f >>> 0) {
                                            break ub;
                                           }
                                           b = xb(v[A >> 2], f);
                                           c = w[b + 3 | 0];
                                           d = w[b + 2 | 0];
                                           g = w[b + 1 | 0];
                                           b = w[b | 0];
                                           v[31601] = 0;
                                           f = f + 1 | 0;
                                           ia(400, a | 0, f & 65535, b | 0, g | 0, d | 0, c | 0);
                                           b = v[31601];
                                           v[31601] = 0;
                                           if ((b | 0) != 1) {
                                            continue;
                                           }
                                           break;
                                          }
                                          d = M() | 0;
                                          break Fa;
                                         }
                                         if (!(w[e + 1235 | 0] & 16)) {
                                          break Ra;
                                         }
                                         b = v[m + 8 >> 2];
                                         c = v[m >> 2];
                                         v[31601] = 0;
                                         b = T(150, c | 0, b | 0, 1) | 0;
                                         c = v[31601];
                                         v[31601] = 0;
                                         if ((c | 0) == 1) {
                                          break Ta;
                                         }
                                         if (!b) {
                                          break Ra;
                                         }
                                         f = 0;
                                         v[31601] = 0;
                                         b = Q(197, m | 0) | 0;
                                         c = v[31601];
                                         v[31601] = 0;
                                         if ((c | 0) == 1) {
                                          break Ua;
                                         }
                                         if (!(b & 1)) {
                                          break Sa;
                                         }
                                         while (1) {
                                          if (x[F >> 1] <= f >>> 0) {
                                           break Sa;
                                          }
                                          v[31601] = 0;
                                          b = Q(151, m | 0) | 0;
                                          c = v[31601];
                                          v[31601] = 0;
                                          if ((c | 0) != 1) {
                                           t[(s + (f << 5) | 0) + 8 | 0] = b;
                                           f = f + 1 | 0;
                                           continue;
                                          }
                                          break;
                                         }
                                         d = M() | 0;
                                         break Fa;
                                        }
                                        d = M() | 0;
                                        break Ha;
                                       }
                                       d = M() | 0;
                                       break Fa;
                                      }
                                      d = M() | 0;
                                      break Fa;
                                     }
                                     d = M() | 0;
                                     break Fa;
                                    }
                                    d = M() | 0;
                                    break Fa;
                                   }
                                   g = a + 906300 | 0;
                                   while (1) {
                                    b = v[m + 8 >> 2];
                                    c = v[m >> 2];
                                    v[31601] = 0;
                                    b = T(150, c | 0, b | 0, 1) | 0;
                                    c = v[31601];
                                    v[31601] = 0;
                                    if ((c | 0) == 1) {
                                     break Ka;
                                    }
                                    if (!b) {
                                     break Ra;
                                    }
                                    v[31601] = 0;
                                    b = Q(197, m | 0) | 0;
                                    c = v[31601];
                                    v[31601] = 0;
                                    if ((c | 0) == 1) {
                                     break Pa;
                                    }
                                    if (!b) {
                                     break Ra;
                                    }
                                    v[31601] = 0;
                                    c = Q(151, m | 0) | 0;
                                    d = v[31601];
                                    v[31601] = 0;
                                    if ((d | 0) == 1) {
                                     break Qa;
                                    }
                                    v[31601] = 0;
                                    d = e + 220 | 0;
                                    R(185, d | 0, m | 0, c | 0);
                                    c = v[31601];
                                    v[31601] = 0;
                                    if ((c | 0) == 1) {
                                     break Qa;
                                    }
                                    c = gc(e + 288 | 0, d);
                                    tb(d);
                                    vb: {
                                     if (b >>> 0 <= 250) {
                                      v[31601] = 0;
                                      N(450, c | 0, _d(g, b - 1 | 0) | 0);
                                      b = v[31601];
                                      v[31601] = 0;
                                      if ((b | 0) == 1) {
                                       break vb;
                                      }
                                     }
                                     tb(c);
                                     continue;
                                    }
                                    break;
                                   }
                                   d = M() | 0;
                                   tb(c);
                                   break Fa;
                                  }
                                  l = a + 901404 | 0;
                                  g = Eb(e + 192 | 0);
                                  c = 0;
                                  j = 0;
                                  while (1) {
                                   b = v[m + 8 >> 2];
                                   d = v[m >> 2];
                                   v[31601] = 0;
                                   b = T(150, d | 0, b | 0, 8) | 0;
                                   d = v[31601];
                                   v[31601] = 0;
                                   wb: {
                                    xb: {
                                     yb: {
                                      zb: {
                                       Ab: {
                                        if ((d | 0) != 1) {
                                         if (b) {
                                          v[31601] = 0;
                                          d = Q(151, m | 0) | 0;
                                          b = v[31601];
                                          v[31601] = 0;
                                          Bb: {
                                           Cb: {
                                            Db: {
                                             Eb: {
                                              Fb: {
                                               Gb: {
                                                Hb: {
                                                 Ib: {
                                                  if ((b | 0) != 1) {
                                                   v[31601] = 0;
                                                   b = Q(151, m | 0) | 0;
                                                   f = v[31601];
                                                   v[31601] = 0;
                                                   if ((f | 0) == 1) {
                                                    break Ib;
                                                   }
                                                   v[31601] = 0;
                                                   f = e + 288 | 0;
                                                   R(185, f | 0, m | 0, b | 0);
                                                   b = v[31601];
                                                   v[31601] = 0;
                                                   if ((b | 0) == 1) {
                                                    break Hb;
                                                   }
                                                   b = gc(e + 220 | 0, f);
                                                   tb(f);
                                                   if ((d | 0) == 1229211981) {
                                                    break Eb;
                                                   }
                                                   if ((d | 0) == 1229476432) {
                                                    break Fb;
                                                   }
                                                   if ((d | 0) == 1397900630) {
                                                    break Gb;
                                                   }
                                                   if ((d | 0) != 1414548815) {
                                                    break wb;
                                                   }
                                                   v[31601] = 0;
                                                   d = O(412, b | 0, 13890) | 0;
                                                   i = v[31601];
                                                   v[31601] = 0;
                                                   if ((i | 0) == 1) {
                                                    break Oa;
                                                   }
                                                   if (!d) {
                                                    break xb;
                                                   }
                                                   v[31601] = 0;
                                                   d = Q(151, b | 0) | 0;
                                                   i = v[31601];
                                                   v[31601] = 0;
                                                   if ((i | 0) != 1) {
                                                    v[31601] = 0;
                                                    R(185, f | 0, b | 0, d | 0);
                                                    d = v[31601];
                                                    v[31601] = 0;
                                                    if ((d | 0) != 1) {
                                                     break Db;
                                                    }
                                                   }
                                                   d = M() | 0;
                                                   break Na;
                                                  }
                                                  d = M() | 0;
                                                  break La;
                                                 }
                                                 d = M() | 0;
                                                 break La;
                                                }
                                                d = M() | 0;
                                                break La;
                                               }
                                               Jb: {
                                                Kb: {
                                                 Lb: {
                                                  d = v[a + 480180 >> 2];
                                                  switch (d - 2 | 0) {
                                                  case 1:
                                                   break wb;

                                                  case 0:
                                                   break Cb;

                                                  case 2:
                                                   break Kb;

                                                  default:
                                                   break Lb;
                                                  }
                                                 }
                                                 if ((d | 0) == 16) {
                                                  break Jb;
                                                 }
                                                 if ((d | 0) != 32) {
                                                  break wb;
                                                 }
                                                 v[31601] = 0;
                                                 c = Q(189, b | 0) | 0;
                                                 d = v[31601];
                                                 v[31601] = 0;
                                                 if ((d | 0) == 1) {
                                                  break Oa;
                                                 }
                                                 v[31601] = 0;
                                                 j = Q(189, b | 0) | 0;
                                                 d = v[31601];
                                                 v[31601] = 0;
                                                 if ((d | 0) != 1) {
                                                  break wb;
                                                 }
                                                 break Oa;
                                                }
                                                d = Ec(e + 120 | 0, 4);
                                                v[e + 288 >> 2] = 32;
                                                f = v[b >> 2];
                                                v[31601] = 0;
                                                f = Q(154, f | 0) | 0;
                                                i = v[31601];
                                                v[31601] = 0;
                                                if ((i | 0) != 1) {
                                                 v[e + 244 >> 2] = f;
                                                 d = v[d >> 2];
                                                 f = v[Gb(e + 288 | 0, e + 244 | 0) >> 2];
                                                 v[31601] = 0;
                                                 U(577, b | 0, g | 0, d | 0, f | 0);
                                                 d = v[31601];
                                                 v[31601] = 0;
                                                 if ((d | 0) != 1) {
                                                  break wb;
                                                 }
                                                }
                                                d = M() | 0;
                                                break Na;
                                               }
                                               v[31601] = 0;
                                               d = Q(197, b | 0) | 0;
                                               f = v[31601];
                                               v[31601] = 0;
                                               if ((f | 0) == 1) {
                                                break Bb;
                                               }
                                               v[31601] = 0;
                                               f = e + 244 | 0;
                                               N(578, f | 0, 4211);
                                               i = v[31601];
                                               v[31601] = 0;
                                               Mb: {
                                                if ((i | 0) != 1) {
                                                 v[e + 264 >> 2] = d >>> 4;
                                                 v[31601] = 0;
                                                 v[e + 104 >> 2] = d & 15;
                                                 d = e + 288 | 0;
                                                 U(307, d | 0, f | 0, e + 264 | 0, e + 104 | 0);
                                                 i = v[31601];
                                                 v[31601] = 0;
                                                 if ((i | 0) == 1) {
                                                  break Mb;
                                                 }
                                                 yb(g, d);
                                                 sb(d);
                                                 Db(f);
                                                 break wb;
                                                }
                                                d = M() | 0;
                                                break Na;
                                               }
                                               d = M() | 0;
                                               Db(e + 244 | 0);
                                               break Na;
                                              }
                                              v[31601] = 0;
                                              d = Q(197, b | 0) | 0;
                                              f = v[31601];
                                              v[31601] = 0;
                                              if ((f | 0) == 1) {
                                               break Oa;
                                              }
                                              v[a + 480216 >> 2] = d;
                                              v[31601] = 0;
                                              d = Q(197, b | 0) | 0;
                                              f = v[31601];
                                              v[31601] = 0;
                                              if ((f | 0) == 1) {
                                               break Oa;
                                              }
                                              v[a + 480220 >> 2] = d;
                                              break wb;
                                             }
                                             v[31601] = 0;
                                             O(423, b | 0, l | 0) | 0;
                                             d = v[31601];
                                             v[31601] = 0;
                                             if ((d | 0) == 1) {
                                              break Oa;
                                             }
                                             ED(l);
                                             break wb;
                                            }
                                            d = e + 288 | 0;
                                            i = gc(e + 244 | 0, d);
                                            tb(d);
                                            f = v[i >> 2];
                                            v[31601] = 0;
                                            f = Q(154, f | 0) | 0;
                                            k = v[31601];
                                            v[31601] = 0;
                                            if ((k | 0) == 1) {
                                             break yb;
                                            }
                                            u[e + 288 >> 1] = f >>> 5;
                                            X = e, Y = Xj(v[a + 484344 >> 2], v[a + 484348 >> 2]), u[X + 264 >> 1] = Y;
                                            d = x[Nc(d, e + 264 | 0) >> 1];
                                            f = 0;
                                            while (1) {
                                             if ((d | 0) == (f | 0)) {
                                              tb(i);
                                              break xb;
                                             }
                                             v[31601] = 0;
                                             k = e + 288 | 0;
                                             N(579, i | 0, k | 0);
                                             n = v[31601];
                                             v[31601] = 0;
                                             Nb: {
                                              if ((n | 0) == 1) {
                                               break Nb;
                                              }
                                              n = v[K >> 2];
                                              v[31601] = 0;
                                              N(580, Vb(n, f) | 0, k | 0);
                                              k = v[31601];
                                              v[31601] = 0;
                                              if ((k | 0) == 1) {
                                               break Nb;
                                              }
                                              f = f + 1 | 0;
                                              continue;
                                             }
                                             break;
                                            }
                                            break yb;
                                           }
                                           v[31601] = 0;
                                           c = Q(189, b | 0) | 0;
                                           d = v[31601];
                                           v[31601] = 0;
                                           if ((d | 0) == 1) {
                                            break Oa;
                                           }
                                           break wb;
                                          }
                                          d = M() | 0;
                                          break Na;
                                         }
                                         b = v[a + 480180 >> 2];
                                         Ob: {
                                          Pb: {
                                           Qb: {
                                            if ((b | 0) != 32) {
                                             break Qb;
                                            }
                                            d = c & 65535;
                                            if (d >>> 0 < 256) {
                                             break Qb;
                                            }
                                            if (d >>> 0 < 532) {
                                             break Pb;
                                            }
                                           }
                                           b = (b | 0) != 2;
                                           Rb: {
                                            if (b) {
                                             break Rb;
                                            }
                                            d = c & 65535;
                                            if (d >>> 0 < 12544) {
                                             break Rb;
                                            }
                                            if (d >>> 0 < 12820) {
                                             break Pb;
                                            }
                                           }
                                           if (b) {
                                            break Ob;
                                           }
                                           b = c & 65535;
                                           if (b >>> 0 < 4864 | b >>> 0 > 4895) {
                                            break Ob;
                                           }
                                          }
                                          lr(l);
                                         }
                                         Sb: {
                                          if (!(t[e + 1235 | 0] & 1)) {
                                           break Sb;
                                          }
                                          f = v[a + 1074308 >> 2];
                                          if (!f) {
                                           c = a + 900380 | 0;
                                           f = 1;
                                           while (1) {
                                            b = f & 65535;
                                            if (b >>> 0 <= x[a + 480192 >> 1]) {
                                             b = v[c + (b << 2) >> 2];
                                             if (b) {
                                              d = v[a + 480180 >> 2];
                                              v[31601] = 0;
                                              N(581, Vh(b, 2) | 0, d | 0);
                                              d = v[31601];
                                              v[31601] = 0;
                                              if ((d | 0) == 1) {
                                               break Ab;
                                              }
                                              t[b + 19 | 0] = w[b + 19 | 0] + 3 >>> 2;
                                             }
                                             f = f + 1 | 0;
                                             continue;
                                            }
                                            break;
                                           }
                                           f = v[a + 1074308 >> 2];
                                          }
                                          if (f >>> 0 <= 18350079) {
                                           v[31601] = 0;
                                           b = O(267, a + 1074312 | 0, 27) | 0;
                                           c = v[31601];
                                           v[31601] = 0;
                                           if ((c | 0) == 1) {
                                            break Ma;
                                           }
                                           v[31601] = 0;
                                           O(267, b | 0, 57) | 0;
                                           b = v[31601];
                                           v[31601] = 0;
                                           if ((b | 0) == 1) {
                                            break Ma;
                                           }
                                           f = v[a + 1074308 >> 2];
                                          }
                                          if (f >>> 0 <= 19070975) {
                                           v[31601] = 0;
                                           O(267, a + 1074312 | 0, 73) | 0;
                                           b = v[31601];
                                           v[31601] = 0;
                                           if ((b | 0) == 1) {
                                            break Ma;
                                           }
                                           f = v[a + 1074308 >> 2];
                                          }
                                          if (f >>> 0 > 19267583) {
                                           break Sb;
                                          }
                                          v[31601] = 0;
                                          O(267, a + 1074312 | 0, 50) | 0;
                                          b = v[31601];
                                          v[31601] = 0;
                                          if ((b | 0) == 1) {
                                           break Ma;
                                          }
                                         }
                                         Tb: {
                                          Ub: {
                                           Vb: {
                                            Wb: {
                                             Xb: {
                                              Yb: {
                                               Zb: {
                                                _b: {
                                                 $b: {
                                                  ac: {
                                                   bc: {
                                                    cc: {
                                                     dc: {
                                                      ec: {
                                                       if (zd(v[g + 4 >> 2], w[g + 11 | 0])) {
                                                        v[31601] = 0;
                                                        c = e + 220 | 0;
                                                        V(582, c | 0);
                                                        b = v[31601];
                                                        v[31601] = 0;
                                                        fc: {
                                                         if ((b | 0) != 1) {
                                                          v[31601] = 0;
                                                          d = e + 288 | 0;
                                                          R(550, d | 0, c | 0, e + 1703 | 0);
                                                          b = v[31601];
                                                          v[31601] = 0;
                                                          if ((b | 0) == 1) {
                                                           break fc;
                                                          }
                                                          break ec;
                                                         }
                                                         d = M() | 0;
                                                         break La;
                                                        }
                                                        d = M() | 0;
                                                        Db(e + 220 | 0);
                                                        break La;
                                                       }
                                                       v[31601] = 0;
                                                       c = e + 220 | 0;
                                                       V(583, c | 0);
                                                       b = v[31601];
                                                       v[31601] = 0;
                                                       if ((b | 0) == 1) {
                                                        break dc;
                                                       }
                                                       v[31601] = 0;
                                                       d = e + 288 | 0;
                                                       U(584, d | 0, c | 0, e + 1703 | 0, g | 0);
                                                       b = v[31601];
                                                       v[31601] = 0;
                                                       if ((b | 0) == 1) {
                                                        break cc;
                                                       }
                                                      }
                                                      yb(g, d);
                                                      sb(d);
                                                      Db(c);
                                                      v[31601] = 0;
                                                      c = e + 220 | 0;
                                                      N(549, c | 0, 3977);
                                                      b = v[31601];
                                                      v[31601] = 0;
                                                      if ((b | 0) == 1) {
                                                       break ac;
                                                      }
                                                      v[31601] = 0;
                                                      b = e + 288 | 0;
                                                      R(550, b | 0, c | 0, e + 1703 | 0);
                                                      d = v[31601];
                                                      v[31601] = 0;
                                                      if ((d | 0) == 1) {
                                                       break $b;
                                                      }
                                                      yb(a + 1298344 | 0, b);
                                                      sb(b);
                                                      Db(c);
                                                      v[31601] = 0;
                                                      b = O(1, b | 0, 14986) | 0;
                                                      c = v[31601];
                                                      v[31601] = 0;
                                                      if ((c | 0) == 1) {
                                                       break _b;
                                                      }
                                                      yb(a + 1298356 | 0, b);
                                                      sb(b);
                                                      b = v[a + 480180 >> 2];
                                                      switch (b - 1 | 0) {
                                                      case 2:
                                                       break zb;

                                                      case 1:
                                                       break Wb;

                                                      case 3:
                                                       break Xb;

                                                      case 0:
                                                       break Yb;

                                                      default:
                                                       break bc;
                                                      }
                                                     }
                                                     d = M() | 0;
                                                     break La;
                                                    }
                                                    d = M() | 0;
                                                    Db(e + 220 | 0);
                                                    break La;
                                                   }
                                                   if ((b | 0) == 16) {
                                                    break Zb;
                                                   }
                                                   if ((b | 0) == 32) {
                                                    break Vb;
                                                   }
                                                   if ((b | 0) != 16777216) {
                                                    break zb;
                                                   }
                                                   v[31601] = 0;
                                                   b = O(1, e + 220 | 0, 10124) | 0;
                                                   c = v[31601];
                                                   v[31601] = 0;
                                                   if ((c | 0) == 1) {
                                                    break Ub;
                                                   }
                                                   yb(a + 1298392 | 0, b);
                                                   sb(b);
                                                   v[31601] = 0;
                                                   b = O(1, e + 244 | 0, 13852) | 0;
                                                   c = v[31601];
                                                   v[31601] = 0;
                                                   if ((c | 0) == 1) {
                                                    break Tb;
                                                   }
                                                   yb(a + 1298380 | 0, b);
                                                   sb(b);
                                                   break zb;
                                                  }
                                                  d = M() | 0;
                                                  break La;
                                                 }
                                                 d = M() | 0;
                                                 Db(e + 220 | 0);
                                                 break La;
                                                }
                                                d = M() | 0;
                                                break La;
                                               }
                                               v[31601] = 0;
                                               b = O(1, e + 220 | 0, 10129) | 0;
                                               c = v[31601];
                                               v[31601] = 0;
                                               gc: {
                                                if ((c | 0) != 1) {
                                                 yb(a + 1298392 | 0, b);
                                                 sb(b);
                                                 v[31601] = 0;
                                                 b = O(1, e + 244 | 0, 8365) | 0;
                                                 c = v[31601];
                                                 v[31601] = 0;
                                                 if ((c | 0) == 1) {
                                                  break gc;
                                                 }
                                                 yb(a + 1298380 | 0, b);
                                                 sb(b);
                                                 break zb;
                                                }
                                                d = M() | 0;
                                                break La;
                                               }
                                               d = M() | 0;
                                               break La;
                                              }
                                              v[31601] = 0;
                                              b = O(1, e + 220 | 0, 12386) | 0;
                                              c = v[31601];
                                              v[31601] = 0;
                                              hc: {
                                               if ((c | 0) != 1) {
                                                yb(a + 1298392 | 0, b);
                                                sb(b);
                                                v[31601] = 0;
                                                b = O(1, e + 244 | 0, 14248) | 0;
                                                c = v[31601];
                                                v[31601] = 0;
                                                if ((c | 0) == 1) {
                                                 break hc;
                                                }
                                                yb(a + 1298380 | 0, b);
                                                sb(b);
                                                break zb;
                                               }
                                               d = M() | 0;
                                               break La;
                                              }
                                              d = M() | 0;
                                              break La;
                                             }
                                             v[31601] = 0;
                                             b = O(1, e + 220 | 0, 10102) | 0;
                                             c = v[31601];
                                             v[31601] = 0;
                                             ic: {
                                              if ((c | 0) != 1) {
                                               yb(a + 1298392 | 0, b);
                                               sb(b);
                                               v[31601] = 0;
                                               b = O(1, e + 244 | 0, 15280) | 0;
                                               c = v[31601];
                                               v[31601] = 0;
                                               if ((c | 0) == 1) {
                                                break ic;
                                               }
                                               yb(a + 1298380 | 0, b);
                                               sb(b);
                                               break zb;
                                              }
                                              d = M() | 0;
                                              break La;
                                             }
                                             d = M() | 0;
                                             break La;
                                            }
                                            v[31601] = 0;
                                            b = O(1, e + 220 | 0, 10474) | 0;
                                            c = v[31601];
                                            v[31601] = 0;
                                            jc: {
                                             if ((c | 0) != 1) {
                                              yb(a + 1298392 | 0, b);
                                              sb(b);
                                              v[31601] = 0;
                                              b = O(1, e + 244 | 0, 15021) | 0;
                                              c = v[31601];
                                              v[31601] = 0;
                                              if ((c | 0) == 1) {
                                               break jc;
                                              }
                                              yb(a + 1298380 | 0, b);
                                              sb(b);
                                              break zb;
                                             }
                                             d = M() | 0;
                                             break La;
                                            }
                                            d = M() | 0;
                                            break La;
                                           }
                                           v[31601] = 0;
                                           b = O(1, e + 220 | 0, 6127) | 0;
                                           c = v[31601];
                                           v[31601] = 0;
                                           kc: {
                                            lc: {
                                             mc: {
                                              nc: {
                                               oc: {
                                                if ((c | 0) != 1) {
                                                 yb(a + 1298392 | 0, b);
                                                 sb(b);
                                                 if (!(j & 65535)) {
                                                  break kc;
                                                 }
                                                 v[31601] = 0;
                                                 b = e + 264 | 0;
                                                 N(268, b | 0, 4314);
                                                 c = v[31601];
                                                 v[31601] = 0;
                                                 if ((c | 0) == 1) {
                                                  break oc;
                                                 }
                                                 v[e + 116 >> 2] = (j & 65280) >>> 8;
                                                 v[31601] = 0;
                                                 v[e + 100 >> 2] = j & 255;
                                                 c = e + 104 | 0;
                                                 N(444, c | 0, e + 100 | 0);
                                                 d = v[31601];
                                                 v[31601] = 0;
                                                 if ((d | 0) == 1) {
                                                  break nc;
                                                 }
                                                 v[31601] = 0;
                                                 d = e + 244 | 0;
                                                 U(430, d | 0, b | 0, e + 116 | 0, c | 0);
                                                 f = v[31601];
                                                 v[31601] = 0;
                                                 if ((f | 0) == 1) {
                                                  break mc;
                                                 }
                                                 yb(a + 1298380 | 0, d);
                                                 sb(d);
                                                 sb(c);
                                                 Db(b);
                                                 break zb;
                                                }
                                                d = M() | 0;
                                                break La;
                                               }
                                               d = M() | 0;
                                               break La;
                                              }
                                              d = M() | 0;
                                              break lc;
                                             }
                                             d = M() | 0;
                                             sb(e + 104 | 0);
                                            }
                                            Db(e + 264 | 0);
                                            break La;
                                           }
                                           v[31601] = 0;
                                           b = O(1, e + 244 | 0, 8557) | 0;
                                           c = v[31601];
                                           v[31601] = 0;
                                           if ((c | 0) != 1) {
                                            yb(a + 1298380 | 0, b);
                                            sb(b);
                                            break zb;
                                           }
                                           d = M() | 0;
                                           break La;
                                          }
                                          d = M() | 0;
                                          break La;
                                         }
                                         d = M() | 0;
                                         break La;
                                        }
                                        d = M() | 0;
                                        break La;
                                       }
                                       d = M() | 0;
                                       break La;
                                      }
                                      yb(a + 1298368 | 0, g);
                                      pc: {
                                       if (v[a + 1074308 >> 2]) {
                                        X = a, Y = v[Ec(e + 264 | 0, 22) >> 2], v[X + 1298404 >> 2] = Y;
                                        break pc;
                                       }
                                       if (v[a + 480180 >> 2] == 1) {
                                        X = a, Y = v[Ec(e + 264 | 0, 28) >> 2], v[X + 1298404 >> 2] = Y;
                                        break pc;
                                       }
                                       X = a, Y = v[Ec(e + 264 | 0, 4) >> 2], v[X + 1298404 >> 2] = Y;
                                      }
                                      f = 1;
                                      qc: {
                                       rc: {
                                        if (h & 1) {
                                         v[31601] = 0;
                                         b = O(1, e + 264 | 0, 16651) | 0;
                                         c = v[31601];
                                         v[31601] = 0;
                                         if ((c | 0) == 1) {
                                          break rc;
                                         }
                                         a = v[a + 1298472 >> 2];
                                         v[31601] = 0;
                                         R(385, a | 0, 2, b | 0);
                                         a = v[31601];
                                         v[31601] = 0;
                                         if ((a | 0) == 1) {
                                          break qc;
                                         }
                                         sb(b);
                                        }
                                        sb(g);
                                        hY(o);
                                        uc(A);
                                        Qc(r);
                                        tb(J);
                                        tb(I);
                                        break k;
                                       }
                                       d = M() | 0;
                                       break La;
                                      }
                                      d = M() | 0;
                                      sb(b);
                                      break La;
                                     }
                                     d = M() | 0;
                                     tb(i);
                                     break Na;
                                    }
                                    v[31601] = 0;
                                    d = O(412, b | 0, 13895) | 0;
                                    f = v[31601];
                                    v[31601] = 0;
                                    if ((f | 0) == 1) {
                                     break Oa;
                                    }
                                    sc: {
                                     if (!d) {
                                      break sc;
                                     }
                                     v[31601] = 0;
                                     d = Q(151, b | 0) | 0;
                                     f = v[31601];
                                     v[31601] = 0;
                                     tc: {
                                      if ((f | 0) != 1) {
                                       v[31601] = 0;
                                       R(185, e + 244 | 0, b | 0, d | 0);
                                       d = v[31601];
                                       v[31601] = 0;
                                       if ((d | 0) != 1) {
                                        break tc;
                                       }
                                      }
                                      d = M() | 0;
                                      break Na;
                                     }
                                     d = e + 244 | 0;
                                     i = gc(e + 288 | 0, d);
                                     tb(d);
                                     f = v[i >> 2];
                                     v[31601] = 0;
                                     f = Q(154, f | 0) | 0;
                                     k = v[31601];
                                     v[31601] = 0;
                                     if ((k | 0) != 1) {
                                      u[e + 244 >> 1] = (f >>> 0) / 20;
                                      u[e + 264 >> 1] = x[F >> 1];
                                      d = x[Nc(d, e + 264 | 0) >> 1];
                                      f = 0;
                                      while (1) {
                                       if ((d | 0) == (f | 0)) {
                                        tb(i);
                                        break sc;
                                       }
                                       v[31601] = 0;
                                       R(424, i | 0, (s + (f << 5) | 0) + 9 | 0, 20);
                                       k = v[31601];
                                       v[31601] = 0;
                                       if ((k | 0) != 1) {
                                        f = f + 1 | 0;
                                        continue;
                                       }
                                       break;
                                      }
                                     }
                                     d = M() | 0;
                                     tb(i);
                                     break Na;
                                    }
                                    v[31601] = 0;
                                    O(435, a | 0, b | 0) | 0;
                                    d = v[31601];
                                    v[31601] = 0;
                                    if ((d | 0) == 1) {
                                     break Oa;
                                    }
                                    v[31601] = 0;
                                    aa(436, a | 0, b | 0, 1, 0) | 0;
                                    d = v[31601];
                                    v[31601] = 0;
                                    if ((d | 0) == 1) {
                                     break Oa;
                                    }
                                    if ((c - 2186 & 65535) >>> 0 <= 117) {
                                     v[a + 480180 >> 2] = 16777216;
                                     v[31601] = 0;
                                     R(448, a | 0, b | 0, c & 65535);
                                     d = v[31601];
                                     v[31601] = 0;
                                     if ((d | 0) == 1) {
                                      break Oa;
                                     }
                                    }
                                    if (!v[a + 1074308 >> 2]) {
                                     break wb;
                                    }
                                    v[31601] = 0;
                                    f = O(1, e + 172 | 0, 18226) | 0;
                                    d = v[31601];
                                    v[31601] = 0;
                                    uc: {
                                     vc: {
                                      wc: {
                                       if ((d | 0) != 1) {
                                        i = v[a + 1074308 >> 2];
                                        v[31601] = 0;
                                        d = e + 244 | 0;
                                        N(134, d | 0, i | 0);
                                        i = v[31601];
                                        v[31601] = 0;
                                        if ((i | 0) == 1) {
                                         break wc;
                                        }
                                        v[31601] = 0;
                                        i = e + 288 | 0;
                                        R(2, i | 0, f | 0, d | 0);
                                        k = v[31601];
                                        v[31601] = 0;
                                        if ((k | 0) == 1) {
                                         break vc;
                                        }
                                        yb(g, i);
                                        sb(i);
                                        sb(d);
                                        sb(f);
                                        break wb;
                                       }
                                       d = M() | 0;
                                       break Na;
                                      }
                                      d = M() | 0;
                                      break uc;
                                     }
                                     d = M() | 0;
                                     sb(e + 244 | 0);
                                    }
                                    sb(f);
                                    break Na;
                                   }
                                   tb(b);
                                   continue;
                                  }
                                 }
                                 d = M() | 0;
                                 break Fa;
                                }
                                d = M() | 0;
                                break Fa;
                               }
                               d = M() | 0;
                              }
                              tb(b);
                              break La;
                             }
                             d = M() | 0;
                            }
                            sb(g);
                            break Fa;
                           }
                           d = M() | 0;
                           break Fa;
                          }
                          d = M() | 0;
                          Jc(e + 288 | 0);
                          break Fa;
                         }
                         d = M() | 0;
                        }
                        tb(g);
                       }
                       sb(f);
                      }
                      hY(o);
                      break ta;
                     }
                     d = h;
                    }
                    sb(f);
                    i = i + 1 | 0;
                    continue;
                   }
                  }
                  d = M() | 0;
                  break ta;
                 }
                 d = M() | 0;
                 sb(h);
                 break ta;
                }
                d = M() | 0;
               }
               uc(A);
               break H;
              }
              l = l + 1 | 0;
              continue;
             }
            }
            Qc(r);
            break g;
           }
           tb(m);
          }
          ec(D);
         }
         eb = e + 1712 | 0;
         return f | 0;
        }
        d = M() | 0;
       }
       tb(J);
       break e;
      }
      d = M() | 0;
     }
     tb(I);
     break b;
    }
    d = M() | 0;
    break b;
   }
   d = M() | 0;
  }
  tb(m);
 }
 ec(D);
 P(d | 0);
 p();
}

function Oqa(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, q = 0, r = 0, s = 0, y = 0, z = 0, A = 0, C = 0, D = 0, E = 0, F = 0, G = 0, H = 0, I = 0, J = 0, K = 0, L = 0, S = 0, V = 0, W = 0, X = 0, Y = 0, Z = 0, _ = 0, $ = 0, aa = 0, ba = 0, ca = 0, da = 0, ea = 0, fa = 0, ga = 0, ha = 0, ia = 0, ja = 0, ka = 0, la = 0, ma = 0;
 f = eb - 944 | 0;
 eb = f;
 xc(b);
 d = f + 892 | 0;
 a: {
  if (!BY(b, d)) {
   break a;
  }
  if (!GY(d)) {
   break a;
  }
  if (!Lb(v[b >> 2], v[b + 8 >> 2], Ac(FY(d), gb))) {
   break a;
  }
  e = 1;
  if ((c | 0) == 64) {
   break a;
  }
  Cd(a, 8);
  dg(a);
  h = w[f + 895 | 0] - 48 | 0;
  t[f + 891 | 0] = h;
  cd(b, _b(w[f + 900 | 0] | w[f + 901 | 0] << 8 | (w[f + 902 | 0] << 16 | w[f + 903 | 0] << 24)));
  d = f + 584 | 0;
  ge(d, b, 504);
  V = gc(f + 868 | 0, d);
  tb(d);
  e = 0;
  v[31601] = 0;
  N(523, b | 0, d | 0);
  d = v[31601];
  v[31601] = 0;
  b: {
   c: {
    d: {
     e: {
      f: {
       g: {
        if ((d | 0) != 1) {
         if (w[f + 867 | 0] > 63) {
          break b;
         }
         if (Ab(x[f + 584 >> 1]) << 16 >> 16 < 0) {
          break b;
         }
         d = f + 504 | 0;
         Qb(d, 0, 80);
         h: {
          e = _b(w[f + 924 | 0] | w[f + 925 | 0] << 8 | (w[f + 926 | 0] << 16 | w[f + 927 | 0] << 24));
          if (!e) {
           break h;
          }
          v[31601] = 0;
          e = O(149, b | 0, e | 0) | 0;
          k = v[31601];
          v[31601] = 0;
          if ((k | 0) != 1) {
           if (!e) {
            break h;
           }
           v[31601] = 0;
           N(524, b | 0, d | 0);
           d = v[31601];
           v[31601] = 0;
           if ((d | 0) != 1) {
            break h;
           }
          }
          g = M() | 0;
          break e;
         }
         v[31601] = 0;
         d = f + 500 | 0;
         R(525, d | 0, b | 0, h & 255);
         e = v[31601];
         v[31601] = 0;
         if ((e | 0) != 1) {
          Z = _e(d);
          e = 0;
          d = x[f + 500 >> 1];
          if ((d - 128 & 65535) >>> 0 < 65409) {
           break b;
          }
          u[a + 480188 >> 1] = d;
          I = Mb(f + 488 | 0);
          d = _b(w[f + 916 | 0] | w[f + 917 | 0] << 8 | (w[f + 918 | 0] << 16 | w[f + 919 | 0] << 24));
          i: {
           if (d) {
            v[31601] = 0;
            O(149, b | 0, d | 0) | 0;
            d = v[31601];
            v[31601] = 0;
            if ((d | 0) == 1) {
             break g;
            }
            v[31601] = 0;
            R(526, b | 0, I | 0, w[f + 867 | 0]);
            d = v[31601];
            v[31601] = 0;
            if ((d | 0) == 1) {
             break g;
            }
            d = w[f + 867 | 0];
            break i;
           }
           d = w[f + 867 | 0];
           if (d) {
            break c;
           }
          }
          G = a + 480188 | 0;
          d = d & 255;
          u[a + 480192 >> 1] = d;
          u[a + 480190 >> 1] = d;
          _ = (h & 255) >>> 0 < 2 | t[f + 848 | 0] >= 0;
          s = !_;
          C = c & 2;
          n = a + 484380 | 0;
          J = a + 900380 | 0;
          m = 1;
          l = 1;
          while (1) {
           j: {
            k: {
             l: {
              m: {
               n: {
                o: {
                 h = d & 65535;
                 d = l & 65535;
                 if (h >>> 0 >= d >>> 0) {
                  v[31601] = 0;
                  z = m & 65535;
                  h = T(251, a | 0, d | 0, z | 0) | 0;
                  e = v[31601];
                  v[31601] = 0;
                  p: {
                   if ((e | 0) != 1) {
                    if (h) {
                     break p;
                    }
                    break d;
                   }
                   g = M() | 0;
                   break f;
                  }
                  h = v[(d << 2) + J >> 2];
                  u[f + 92 >> 1] = 0;
                  v[f + 88 >> 2] = 0;
                  v[31601] = 0;
                  o = Q(168, f + 468 | 0) | 0;
                  e = v[31601];
                  v[31601] = 0;
                  q: {
                   if ((e | 0) != 1) {
                    d = xb(v[I >> 2], d - 1 | 0);
                    d = _b(w[d | 0] | w[d + 1 | 0] << 8 | (w[d + 2 | 0] << 16 | w[d + 3 | 0] << 24));
                    r: {
                     if (!d) {
                      break r;
                     }
                     v[31601] = 0;
                     d = O(149, b | 0, d | 0) | 0;
                     e = v[31601];
                     v[31601] = 0;
                     if ((e | 0) == 1) {
                      break k;
                     }
                     if (!d) {
                      break r;
                     }
                     v[31601] = 0;
                     N(527, b | 0, f + 88 | 0);
                     d = v[31601];
                     v[31601] = 0;
                     if ((d | 0) == 1) {
                      break k;
                     }
                     e = v[f + 88 >> 2];
                     k = u[f + 92 >> 1];
                     v[31601] = 0;
                     d = f + 128 | 0;
                     g = _b(e);
                     e = ye(k);
                     R(185, d | 0, b | 0, g << ((e | 0) > 0 & (e & 65504) >>> 5));
                     e = v[31601];
                     v[31601] = 0;
                     if ((e | 0) == 1) {
                      break k;
                     }
                     e = gc(f + 188 | 0, d);
                     jd(o, e);
                     tb(e);
                     tb(d);
                    }
                    g = ye(u[f + 92 >> 1]);
                    d = g & 15;
                    if ((g | 0) >= 0) {
                     break q;
                    }
                    Ov(h, 0);
                    ba = 1;
                    break o;
                   }
                   g = M() | 0;
                   break f;
                  }
                  if (d >>> 0 > 6) {
                   break o;
                  }
                  j = w[d + 25062 | 0];
                  if (!d) {
                   break m;
                  }
                  u[a + 480190 >> 1] = (x[a + 480190 >> 1] + j | 0) - 1;
                  i = h + 108 | 0;
                  y = h + 236 | 0;
                  k = 4;
                  q = j - 2 << 3;
                  s: while (1) {
                   d = 1;
                   if ((k | 0) == 10) {
                    break n;
                   }
                   d = B(k, 12);
                   e = k + q | 0;
                   r = w[e + 25068 | 0] + m | 0;
                   D = w[e + 25116 | 0];
                   e = 0;
                   while (1) if ((e | 0) == 12) {
                    k = k + 1 | 0;
                    continue s;
                   } else {
                    A = d + e | 0;
                    la = $b(y, A), ma = r, u[la >> 1] = ma;
                    A = wb(i, A);
                    t[A | 0] = D + w[A | 0];
                    e = e + 1 | 0;
                    continue;
                   }
                  }
                 }
                 t: {
                  u: {
                   v: {
                    w: {
                     x: {
                      y: {
                       z: {
                        A: {
                         B: {
                          C: {
                           D: {
                            d = _b(v[f + 508 >> 2]);
                            if (!d) {
                             break D;
                            }
                            if (!Ab(x[f + 512 >> 1])) {
                             break D;
                            }
                            v[31601] = 0;
                            d = O(149, b | 0, d | 0) | 0;
                            h = v[31601];
                            v[31601] = 0;
                            if ((h | 0) == 1) {
                             break C;
                            }
                            if (!d) {
                             break D;
                            }
                            la = f, ma = Ab(x[f + 512 >> 1]), u[la + 188 >> 1] = ma;
                            u[f + 128 >> 1] = w[f + 867 | 0];
                            i = x[Nc(f + 188 | 0, f + 128 | 0) >> 1];
                            h = f + 136 | 0;
                            m = f + 132 | 0;
                            k = Ab(x[f + 514 >> 1]);
                            l = k >>> 0 < 5;
                            o = k >>> 0 < 19;
                            z = k >>> 0 < 21;
                            q = k >>> 0 < 15;
                            s = k >>> 0 < 6;
                            d = 0;
                            while (1) {
                             if ((d | 0) == (i | 0)) {
                              break D;
                             }
                             v[31601] = 0;
                             R(528, b | 0, f + 188 | 0, k | 0);
                             e = v[31601];
                             v[31601] = 0;
                             E: {
                              F: {
                               G: {
                                if ((e | 0) != 1) {
                                 d = d + 1 | 0;
                                 e = v[(d << 2) + J >> 2];
                                 g = w[f + 188 | 0];
                                 if (g) {
                                  y = Wl(f + 128 | 0, 0, 64);
                                  Wl(m, g - 1 & 65535, 64);
                                  j = w[f + 189 | 0];
                                  if (j) {
                                   j = 64 / (j >>> 0) | 0;
                                  } else {
                                   j = 0;
                                  }
                                  Wl(h, j + g | 0, 0);
                                  v[31601] = 0;
                                  g = e + 48 | 0;
                                  R(529, g | 0, y | 0, 3);
                                  j = v[31601];
                                  v[31601] = 0;
                                  if ((j | 0) == 1) {
                                   break G;
                                  }
                                  if (w[f + 188 | 0] == 1) {
                                   j = v[ub(f + 464 | 0, vb(v[g >> 2])) >> 2];
                                   y = vb(v[g >> 2]);
                                   j = v[g >> 2] + (Mv(j, y) << 2) | 0;
                                   Id(g, Lv(j + 4 | 0, v[g + 4 >> 2], j));
                                   vb(j);
                                  }
                                  g = w[f + 189 | 0];
                                  v[e >> 2] = g ? g << 9 : 32767;
                                  t[e + 60 | 0] = w[e + 60 | 0] | 1;
                                  y = 1;
                                 }
                                 H: {
                                  if (l) {
                                   break H;
                                  }
                                  g = w[f + 192 | 0];
                                  if (g) {
                                   la = wb(e + 108 | 0, 24), ma = g + 24 | 0, t[la | 0] = ma;
                                   y = 1;
                                  }
                                  if (o) {
                                   break H;
                                  }
                                  v[e + 4 >> 2] = w[f + 206 | 0] + 1 >>> 1;
                                  if (z) {
                                   break H;
                                  }
                                  u[e + 28 >> 1] = w[f + 208 | 0] | w[f + 209 | 0] << 8;
                                 }
                                 e = n + B(x[$b(e + 236 | 0, 61) >> 1], 104) | 0;
                                 t[e + 37 | 0] = w[f + 191 | 0] << 4;
                                 if (q) {
                                  break F;
                                 }
                                 g = _b(w[f + 198 | 0] | w[f + 199 | 0] << 8 | (w[f + 200 | 0] << 16 | w[f + 201 | 0] << 24));
                                 v[e + 4 >> 2] = g;
                                 la = e, ma = _b(w[f + 202 | 0] | w[f + 203 | 0] << 8 | (w[f + 204 | 0] << 16 | w[f + 205 | 0] << 24)) + g | 0, 
                                 v[la + 8 >> 2] = ma;
                                 break E;
                                }
                                g = M() | 0;
                                break f;
                               }
                               g = M() | 0;
                               break f;
                              }
                              if (s) {
                               continue;
                              }
                             }
                             g = w[f + 193 | 0];
                             u[e + 34 >> 1] = x[e + 34 >> 1] & 65529 | g << 1 & 2 | g >>> 1 & 4;
                             if (!(g & 4)) {
                              continue;
                             }
                             u[e + 32 >> 1] = 0;
                             continue;
                            }
                           }
                           I: {
                            d = _b(v[f + 524 >> 2]);
                            if (!d) {
                             break I;
                            }
                            if (!Ab(x[f + 528 >> 1])) {
                             break I;
                            }
                            v[31601] = 0;
                            d = O(149, b | 0, d | 0) | 0;
                            h = v[31601];
                            v[31601] = 0;
                            if ((h | 0) == 1) {
                             break C;
                            }
                            if (!d) {
                             break I;
                            }
                            la = f, ma = Ab(x[f + 528 >> 1]), u[la + 188 >> 1] = ma;
                            u[f + 128 >> 1] = w[f + 867 | 0];
                            g = a + 946304 | 0;
                            j = x[Nc(f + 188 | 0, f + 128 | 0) >> 1];
                            i = Ab(x[f + 530 >> 1]);
                            k = 0;
                            J: while (1) {
                             if ((j | 0) == (k | 0)) {
                              break I;
                             }
                             v[31601] = 0;
                             d = f + 188 | 0;
                             R(530, b | 0, d | 0, i | 0);
                             h = v[31601];
                             v[31601] = 0;
                             if ((h | 0) == 1) {
                              break t;
                             }
                             h = f + 88 | 0;
                             y_(h, d);
                             v[31601] = 0;
                             d = f + 128 | 0;
                             N(218, d | 0, h | 0);
                             h = v[31601];
                             v[31601] = 0;
                             if ((h | 0) == 1) {
                              break u;
                             }
                             k = k + 1 | 0;
                             e = (k << 2) + J | 0;
                             zc(v[e >> 2] + 492 | 0, d);
                             sb(d);
                             h = v[e >> 2];
                             v[31601] = 0;
                             N(389, d | 0, h | 0);
                             h = v[31601];
                             v[31601] = 0;
                             if ((h | 0) == 1) {
                              break v;
                             }
                             la = f, ma = Si(v[f + 128 >> 2]), v[la + 88 >> 2] = ma;
                             m = Of(d);
                             while (1) {
                              d = v[f + 88 >> 2];
                              if (Hb(d, m)) {
                               h = g + (x[cp(d) >> 1] << 5) | 0;
                               d = v[e >> 2];
                               l = v[d + 496 >> 2];
                               v[h >> 2] = v[d + 492 >> 2];
                               v[h + 4 >> 2] = l;
                               l = v[d + 520 >> 2];
                               v[h + 24 >> 2] = v[d + 516 >> 2];
                               v[h + 28 >> 2] = l;
                               l = v[d + 512 >> 2];
                               v[h + 16 >> 2] = v[d + 508 >> 2];
                               v[h + 20 >> 2] = l;
                               l = v[d + 504 >> 2];
                               v[h + 8 >> 2] = v[d + 500 >> 2];
                               v[h + 12 >> 2] = l;
                               $g(f + 88 | 0);
                               continue;
                              } else {
                               Yv(f + 128 | 0);
                               continue J;
                              }
                             }
                            }
                           }
                           lr(a + 901404 | 0);
                           d = oc(f + 456 | 0, 4940);
                           qf(Oe(a + 901692 | 0, 0), v[d >> 2], v[d + 4 >> 2]);
                           xc(b);
                           ca = c & 1;
                           z = a + 484344 | 0;
                           q = a + 1298332 | 0;
                           $ = a + 1298308 | 0;
                           D = a + 480280 | 0;
                           W = a + 484360 | 0;
                           da = f + 850 | 0;
                           k = 0;
                           m = 0;
                           while (1) {
                            K: {
                             c = k & 255;
                             if (c >>> 0 >= w[Z | 0]) {
                              break K;
                             }
                             v[31601] = 0;
                             U(531, b | 0, f + 892 | 0, f + 504 | 0, f + 584 | 0);
                             d = v[31601];
                             v[31601] = 0;
                             L: {
                              M: {
                               N: {
                                O: {
                                 P: {
                                  Q: {
                                   R: {
                                    S: {
                                     T: {
                                      U: {
                                       V: {
                                        W: {
                                         X: {
                                          if ((d | 0) == 1) {
                                           break X;
                                          }
                                          Y: {
                                           if (!c) {
                                            e = 0;
                                            break Y;
                                           }
                                           v[31601] = 0;
                                           c = Q(274, W | 0) | 0;
                                           d = v[31601];
                                           v[31601] = 0;
                                           if ((d | 0) == 1) {
                                            break X;
                                           }
                                           e = k;
                                           if ((c | 0) == 255) {
                                            break d;
                                           }
                                          }
                                          j = Lj(v[W >> 2], e & 255);
                                          o = ng(f + 444 | 0);
                                          Mc(j);
                                          if (w[f + 891 | 0] <= 1) {
                                           c = Ab(x[f + 586 >> 1]);
                                           if (c >>> 0 > 256) {
                                            break Q;
                                           }
                                           d = f + 188 | 0;
                                           zY(d, f + 584 | 0);
                                           v[31601] = 0;
                                           R(532, j | 0, d | 0, c | 0);
                                           c = v[31601];
                                           v[31601] = 0;
                                           if ((c | 0) == 1) {
                                            break W;
                                           }
                                           la = f, ma = vb(v[j >> 2]), v[la + 188 >> 2] = ma;
                                           d = vb(v[j + 4 >> 2]);
                                           while (1) {
                                            c = v[f + 188 >> 2];
                                            if (Hb(c, d)) {
                                             u[c >> 1] = x[c >> 1] + m;
                                             fe(f + 188 | 0);
                                             continue;
                                            }
                                            break;
                                           }
                                           Th(a, 1);
                                           u[f + 188 >> 1] = 16;
                                           c = x[Nc(G, f + 188 | 0) >> 1];
                                           e = 0;
                                           while (1) if ((c | 0) == (e | 0)) {
                                            c = 32;
                                            break M;
                                           } else {
                                            t[f + 188 | 0] = w[e + da | 0];
                                            t[f + 128 | 0] = 64;
                                            la = (e << 5) + D | 0, ma = w[Pb(f + 188 | 0, f + 128 | 0) | 0], u[la + 6 >> 1] = ma;
                                            e = e + 1 | 0;
                                            continue;
                                           }
                                          }
                                          zY(f + 188 | 0, f + 584 | 0);
                                          c = Ab(x[f + 200 >> 1]);
                                          if (!c | c >>> 0 > 64 | x[G >> 1] > 64) {
                                           break Q;
                                          }
                                          l = _b(v[f + 208 >> 2]);
                                          c = Ab(x[f + 212 >> 1]);
                                          if (c) {
                                           u[f + 128 >> 1] = c;
                                           u[f + 88 >> 1] = 800;
                                           c = Ac(((x[Nc(f + 128 | 0, f + 88 | 0) >> 1] << 5) + 50 >>> 0) / 100 | 0, 0);
                                          } else {
                                           c = 32;
                                          }
                                          d = v[f + 196 >> 2];
                                          v[31601] = 0;
                                          d = O(149, b | 0, _b(d) | 0) | 0;
                                          h = v[31601];
                                          v[31601] = 0;
                                          if ((h | 0) == 1) {
                                           break V;
                                          }
                                          e = 0;
                                          Z: {
                                           if (!d) {
                                            break Z;
                                           }
                                           while (1) {
                                            if (x[G >> 1] <= e >>> 0) {
                                             break Z;
                                            }
                                            v[31601] = 0;
                                            d = Q(197, b | 0) | 0;
                                            h = v[31601];
                                            v[31601] = 0;
                                            if ((h | 0) != 1) {
                                             t[f + 128 | 0] = d;
                                             t[f + 88 | 0] = 64;
                                             la = (e << 5) + D | 0, ma = w[Pb(f + 128 | 0, f + 88 | 0) | 0], u[la + 6 >> 1] = ma;
                                             e = e + 1 | 0;
                                             continue;
                                            }
                                            break;
                                           }
                                           g = M() | 0;
                                           break w;
                                          }
                                          _: {
                                           $: {
                                            d = _b(v[f + 204 >> 2]);
                                            if (!d) {
                                             break $;
                                            }
                                            v[31601] = 0;
                                            d = O(149, b | 0, d | 0) | 0;
                                            h = v[31601];
                                            v[31601] = 0;
                                            if ((h | 0) == 1) {
                                             break V;
                                            }
                                            e = 0;
                                            if (!d) {
                                             break $;
                                            }
                                            while (1) {
                                             if (x[G >> 1] <= e >>> 0) {
                                              break _;
                                             }
                                             v[31601] = 0;
                                             d = Q(533, b | 0) | 0;
                                             h = v[31601];
                                             v[31601] = 0;
                                             if ((h | 0) != 1) {
                                              la = (e << 5) + D | 0, ma = (Xb(d, -16, 16) << 3) + 128 | 0, u[la + 4 >> 1] = ma;
                                              e = e + 1 | 0;
                                              continue;
                                             }
                                             break;
                                            }
                                            g = M() | 0;
                                            break w;
                                           }
                                           Th(a, 1);
                                          }
                                          h = Mb(f + 176 | 0);
                                          d = v[f + 192 >> 2];
                                          v[31601] = 0;
                                          g = O(149, b | 0, _b(d) | 0) | 0;
                                          d = v[31601];
                                          v[31601] = 0;
                                          aa: {
                                           if ((d | 0) == 1) {
                                            break aa;
                                           }
                                           d = 33;
                                           e = 0;
                                           if (!g) {
                                            break N;
                                           }
                                           g = x[f + 586 >> 1];
                                           i = v[b + 8 >> 2];
                                           n = v[b >> 2];
                                           v[31601] = 0;
                                           g = T(150, n | 0, i | 0, Ab(g) << 1) | 0;
                                           i = v[31601];
                                           v[31601] = 0;
                                           if ((i | 0) == 1) {
                                            break aa;
                                           }
                                           if (!g) {
                                            break N;
                                           }
                                           g = x[f + 586 >> 1];
                                           v[31601] = 0;
                                           g = T(534, b | 0, h | 0, Ab(g) | 0) | 0;
                                           i = v[31601];
                                           v[31601] = 0;
                                           if ((i | 0) == 1) {
                                            break aa;
                                           }
                                           if (!g) {
                                            break N;
                                           }
                                           la = f, ma = vb(v[h >> 2]), v[la + 172 >> 2] = ma;
                                           n = vb(v[f + 180 >> 2]);
                                           s = v[f + 188 >> 2];
                                           C = x[f + 202 >> 1];
                                           while (1) {
                                            d = v[f + 172 >> 2];
                                            if (!Hb(d, n)) {
                                             d = 0;
                                             e = 1;
                                             break N;
                                            }
                                            d = Ab(w[d | 0] | w[d + 1 | 0] << 8);
                                            ba: {
                                             if (Ab(C) >>> 0 < d >>> 0) {
                                              break ba;
                                             }
                                             v[31601] = 0;
                                             O(149, b | 0, _b(s) + (d << 2) | 0) | 0;
                                             d = v[31601];
                                             v[31601] = 0;
                                             if ((d | 0) == 1) {
                                              break U;
                                             }
                                             v[31601] = 0;
                                             d = Q(281, b | 0) | 0;
                                             e = v[31601];
                                             v[31601] = 0;
                                             if ((e | 0) == 1) {
                                              break U;
                                             }
                                             v[31601] = 0;
                                             d = O(149, b | 0, d | 0) | 0;
                                             e = v[31601];
                                             v[31601] = 0;
                                             if ((e | 0) == 1) {
                                              break U;
                                             }
                                             if (!d) {
                                              break ba;
                                             }
                                             d = v[b + 8 >> 2];
                                             e = v[b >> 2];
                                             v[31601] = 0;
                                             d = T(150, e | 0, d | 0, 42) | 0;
                                             e = v[31601];
                                             v[31601] = 0;
                                             if ((e | 0) == 1) {
                                              break U;
                                             }
                                             if (!d) {
                                              break ba;
                                             }
                                             v[31601] = 0;
                                             N(535, b | 0, f + 128 | 0);
                                             d = v[31601];
                                             v[31601] = 0;
                                             ca: {
                                              if ((d | 0) != 1) {
                                               if (lc(v[j >> 2], v[j + 4 >> 2])) {
                                                break ca;
                                               }
                                               v[31601] = 0;
                                               N(536, j | 0, 65534);
                                               d = v[31601];
                                               v[31601] = 0;
                                               if ((d | 0) != 1) {
                                                break ca;
                                               }
                                              }
                                              g = M() | 0;
                                              break O;
                                             }
                                             d = Ab(w[f + 168 | 0] | w[f + 169 | 0] << 8);
                                             v[f + 124 >> 2] = d;
                                             e = v[b + 8 >> 2];
                                             g = v[b >> 2];
                                             v[31601] = 0;
                                             d = T(150, g | 0, e | 0, d | 0) | 0;
                                             e = v[31601];
                                             v[31601] = 0;
                                             if ((e | 0) == 1) {
                                              break T;
                                             }
                                             if (!d) {
                                              v[31601] = 0;
                                              d = Q(202, b | 0) | 0;
                                              e = v[31601];
                                              v[31601] = 0;
                                              if ((e | 0) == 1) {
                                               break T;
                                              }
                                              wc(f + 124 | 0, d);
                                             }
                                             wc(f + 124 | 0, 65534);
                                             d = v[j + 4 >> 2];
                                             g = v[j >> 2];
                                             e = 0;
                                             v[31601] = 0;
                                             i = v[f + 124 >> 2];
                                             r = _c(g, d);
                                             N(537, j | 0, i + r | 0);
                                             d = v[31601];
                                             v[31601] = 0;
                                             if ((d | 0) == 1) {
                                              break P;
                                             }
                                             while (1) {
                                              da: {
                                               if ((e | 0) == (i | 0)) {
                                                if (w[f + 128 | 0]) {
                                                 Dn(f + 88 | 0, f + 128 | 0);
                                                 v[31601] = 0;
                                                 d = f + 112 | 0;
                                                 R(538, d | 0, v[f + 88 >> 2], v[f + 92 >> 2]);
                                                 e = v[31601];
                                                 v[31601] = 0;
                                                 if ((e | 0) == 1) {
                                                  break S;
                                                 }
                                                 pp(j, d);
                                                 sb(d);
                                                }
                                                d = _b(w[f + 160 | 0] | w[f + 161 | 0] << 8 | (w[f + 162 | 0] << 16 | w[f + 163 | 0] << 24));
                                                if (!d) {
                                                 break ba;
                                                }
                                                v[31601] = 0;
                                                d = O(149, b | 0, d | 0) | 0;
                                                e = v[31601];
                                                v[31601] = 0;
                                                if ((e | 0) != 1) {
                                                 break da;
                                                }
                                                break P;
                                               }
                                               v[31601] = 0;
                                               d = Q(273, b | 0) | 0;
                                               g = v[31601];
                                               v[31601] = 0;
                                               ea: {
                                                if ((g | 0) != 1) {
                                                 d = d << 16 >> 16;
                                                 if ((d | 0) < 0) {
                                                  break ea;
                                                 }
                                                 v[31601] = 0;
                                                 N(536, j | 0, d + m & 65535);
                                                 d = v[31601];
                                                 v[31601] = 0;
                                                 if ((d | 0) != 1) {
                                                  break ea;
                                                 }
                                                }
                                                g = M() | 0;
                                                break O;
                                               }
                                               e = e + 1 | 0;
                                               continue;
                                              }
                                              break;
                                             }
                                             if (!d) {
                                              break ba;
                                             }
                                             while (1) {
                                              fa: {
                                               v[31601] = 0;
                                               d = O(539, b | 0, f + 108 | 0) | 0;
                                               e = v[31601];
                                               v[31601] = 0;
                                               ga: {
                                                ha: {
                                                 ia: {
                                                  ja: {
                                                   if ((e | 0) != 1) {
                                                    if (!d) {
                                                     break ba;
                                                    }
                                                    v[31601] = 0;
                                                    e = f + 68 | 0;
                                                    R(185, e | 0, b | 0, w[f + 111 | 0]);
                                                    d = v[31601];
                                                    v[31601] = 0;
                                                    if ((d | 0) == 1) {
                                                     break ja;
                                                    }
                                                    d = gc(f + 88 | 0, e);
                                                    tb(e);
                                                    g = Ab(x[f + 108 >> 1]);
                                                    e = $l(g + r | 0);
                                                    u[f + 68 >> 1] = e;
                                                    if ((g | 0) == 65535) {
                                                     break fa;
                                                    }
                                                    g = v[j >> 2];
                                                    if (_c(g, v[j + 4 >> 2]) >>> 0 <= e >>> 0) {
                                                     break fa;
                                                    }
                                                    i = 65535;
                                                    switch (w[f + 110 | 0] - 1 | 0) {
                                                    case 0:
                                                     break ha;

                                                    case 1:
                                                     break ia;

                                                    default:
                                                     break ga;
                                                    }
                                                   }
                                                   g = M() | 0;
                                                   break O;
                                                  }
                                                  g = M() | 0;
                                                  break O;
                                                 }
                                                 v[31601] = 0;
                                                 e = Q(273, d | 0) | 0;
                                                 g = v[31601];
                                                 v[31601] = 0;
                                                 if ((g | 0) == 1) {
                                                  break R;
                                                 }
                                                 v[31601] = 0;
                                                 g = O(540, o | 0, f + 68 | 0) | 0;
                                                 i = v[31601];
                                                 v[31601] = 0;
                                                 if ((i | 0) == 1) {
                                                  break R;
                                                 }
                                                 u[g >> 1] = e;
                                                 g = v[j >> 2];
                                                 i = 65534;
                                                 e = x[f + 68 >> 1];
                                                }
                                                la = $b(g, e), ma = i, u[la >> 1] = ma;
                                               }
                                               tb(d);
                                               continue;
                                              }
                                              break;
                                             }
                                             tb(d);
                                            }
                                            fe(f + 172 | 0);
                                            continue;
                                           }
                                          }
                                          g = M() | 0;
                                          break O;
                                         }
                                         g = M() | 0;
                                         break f;
                                        }
                                        g = M() | 0;
                                        break w;
                                       }
                                       g = M() | 0;
                                       break w;
                                      }
                                      g = M() | 0;
                                      break O;
                                     }
                                     g = M() | 0;
                                     break O;
                                    }
                                    g = M() | 0;
                                    break O;
                                   }
                                   g = M() | 0;
                                   tb(d);
                                   break O;
                                  }
                                  jD(o);
                                  break d;
                                 }
                                 g = M() | 0;
                                }
                                nd(h);
                                break w;
                               }
                               nd(h);
                               if (!e) {
                                break L;
                               }
                               c = c >>> (l >>> 1 & 1) | 0;
                              }
                              e = Ab(x[f + 844 >> 1]);
                              h = w[f + 847 | 0];
                              aa = h & 64;
                              d = w[f + 848 | 0];
                              X = d & 32;
                              K = (d & 31) + 1 | 0;
                              la = a, ma = vY(e, aa >>> 6 | 0, X >>> 5 | 0, K), v[la + 480204 >> 2] = ma;
                              la = a, ma = Kd(w[f + 849 | 0], 1, 32), v[la + 480196 >> 2] = ma;
                              if (X) {
                               v[a + 480216 >> 2] = K;
                               v[a + 480220 >> 2] = K << 2;
                              }
                              d = w[f + 866 | 0];
                              if (d) {
                               t[f + 188 | 0] = d;
                               t[f + 128 | 0] = 64;
                               la = a, ma = w[Pb(f + 188 | 0, f + 128 | 0) | 0] << 2, v[la + 480200 >> 2] = ma;
                              }
                              v[a + 480228 >> 2] = c;
                              v[a + 480232 >> 2] = c;
                              v[a + 480208 >> 2] = v[a + 480208 >> 2] & -3 | (h ^ -1) >>> 4 & 2;
                              ka: {
                               la: {
                                ma: {
                                 na: {
                                  oa: {
                                   pa: {
                                    qa: {
                                     ra: {
                                      sa: {
                                       ta: {
                                        c = _b(v[f + 548 >> 2]);
                                        ua: {
                                         if (!c) {
                                          break ua;
                                         }
                                         v[31601] = 0;
                                         c = O(149, b | 0, c | 0) | 0;
                                         d = v[31601];
                                         v[31601] = 0;
                                         if ((d | 0) == 1) {
                                          break ta;
                                         }
                                         if (!c) {
                                          break ua;
                                         }
                                         c = v[f + 552 >> 2];
                                         v[31601] = 0;
                                         R(270, b | 0, $ | 0, _b(c) | 0);
                                         c = v[31601];
                                         v[31601] = 0;
                                         if ((c | 0) == 1) {
                                          break ta;
                                         }
                                         if (w[Z | 0] < 2) {
                                          break ua;
                                         }
                                         v[31601] = 0;
                                         c = f + 56 | 0;
                                         R(258, c | 0, 28, $ | 0);
                                         d = v[31601];
                                         v[31601] = 0;
                                         if ((d | 0) == 1) {
                                          break ta;
                                         }
                                         pp(j, c);
                                         sb(c);
                                        }
                                        va: {
                                         if (_b(v[f + 520 >> 2]) >>> 0 < 2) {
                                          break va;
                                         }
                                         c = v[f + 516 >> 2];
                                         v[31601] = 0;
                                         c = O(149, b | 0, _b(c) | 0) | 0;
                                         d = v[31601];
                                         v[31601] = 0;
                                         if ((d | 0) == 1) {
                                          break ta;
                                         }
                                         if (!c) {
                                          break va;
                                         }
                                         c = v[f + 520 >> 2];
                                         v[31601] = 0;
                                         U(336, q | 0, b | 0, _b(c) - 1 | 0, 4);
                                         c = v[31601];
                                         v[31601] = 0;
                                         if ((c | 0) == 1) {
                                          break ta;
                                         }
                                        }
                                        c = _b(v[f + 560 >> 2]);
                                        if (!c) {
                                         break ka;
                                        }
                                        v[31601] = 0;
                                        c = O(149, b | 0, c | 0) | 0;
                                        d = v[31601];
                                        v[31601] = 0;
                                        if ((d | 0) == 1) {
                                         break ta;
                                        }
                                        if (!c) {
                                         break ka;
                                        }
                                        c = v[b + 8 >> 2];
                                        d = v[b >> 2];
                                        v[31601] = 0;
                                        c = T(150, d | 0, c | 0, 12) | 0;
                                        d = v[31601];
                                        v[31601] = 0;
                                        if ((d | 0) == 1) {
                                         break ta;
                                        }
                                        if (!c) {
                                         break ka;
                                        }
                                        v[31601] = 0;
                                        O(183, b | 0, 6) | 0;
                                        c = v[31601];
                                        v[31601] = 0;
                                        if ((c | 0) == 1) {
                                         break ta;
                                        }
                                        v[31601] = 0;
                                        c = Q(273, b | 0) | 0;
                                        d = v[31601];
                                        v[31601] = 0;
                                        if ((d | 0) == 1) {
                                         break ta;
                                        }
                                        if ((c | 0) != 1) {
                                         break ka;
                                        }
                                        v[31601] = 0;
                                        c = Q(281, b | 0) | 0;
                                        d = v[31601];
                                        v[31601] = 0;
                                        if ((d | 0) == 1) {
                                         break ra;
                                        }
                                        if (!c) {
                                         break ka;
                                        }
                                        d = v[b + 8 >> 2];
                                        e = v[b >> 2];
                                        v[31601] = 0;
                                        d = T(150, e | 0, d | 0, c | 0) | 0;
                                        e = v[31601];
                                        v[31601] = 0;
                                        if ((e | 0) == 1) {
                                         break ra;
                                        }
                                        if (d) {
                                         break sa;
                                        }
                                        break ka;
                                       }
                                       g = M() | 0;
                                       break w;
                                      }
                                      d = UG(f + 188 | 0, q);
                                      v[31601] = 0;
                                      U(336, q | 0, b | 0, c | 0, 4);
                                      c = v[31601];
                                      v[31601] = 0;
                                      if ((c | 0) == 1) {
                                       break ma;
                                      }
                                      if (!zd(v[f + 192 >> 2], w[f + 199 | 0])) {
                                       v[31601] = 0;
                                       c = T(541, f + 32 | 0, 2, 13) | 0;
                                       e = v[31601];
                                       v[31601] = 0;
                                       if ((e | 0) == 1) {
                                        break qa;
                                       }
                                       v[31601] = 0;
                                       e = f + 128 | 0;
                                       R(542, e | 0, d | 0, c | 0);
                                       g = v[31601];
                                       v[31601] = 0;
                                       if ((g | 0) == 1) {
                                        break pa;
                                       }
                                       v[31601] = 0;
                                       g = f + 44 | 0;
                                       R(543, g | 0, e | 0, q | 0);
                                       i = v[31601];
                                       v[31601] = 0;
                                       if ((i | 0) == 1) {
                                        break oa;
                                       }
                                       yb(q, g);
                                       sb(g);
                                       sb(e);
                                       sb(c);
                                      }
                                      sb(d);
                                      break ka;
                                     }
                                     g = M() | 0;
                                     break w;
                                    }
                                    g = M() | 0;
                                    break la;
                                   }
                                   g = M() | 0;
                                   break na;
                                  }
                                  g = M() | 0;
                                  sb(f + 128 | 0);
                                 }
                                 sb(c);
                                 break la;
                                }
                                g = M() | 0;
                               }
                               sb(d);
                               break w;
                              }
                              wa: {
                               L = w[f + 891 | 0];
                               if (L >>> 0 < 2) {
                                break wa;
                               }
                               g = 0;
                               if (!_b(v[f + 572 >> 2])) {
                                break wa;
                               }
                               while (1) {
                                if (x[G >> 1] <= g >>> 0) {
                                 break wa;
                                }
                                c = v[f + 572 >> 2];
                                v[31601] = 0;
                                c = O(149, b | 0, _b(c) + (g << 2) | 0) | 0;
                                d = v[31601];
                                v[31601] = 0;
                                if ((d | 0) == 1) {
                                 break x;
                                }
                                xa: {
                                 if (!c) {
                                  break xa;
                                 }
                                 v[31601] = 0;
                                 c = Q(281, b | 0) | 0;
                                 d = v[31601];
                                 v[31601] = 0;
                                 if ((d | 0) == 1) {
                                  break x;
                                 }
                                 v[31601] = 0;
                                 c = O(149, b | 0, c | 0) | 0;
                                 d = v[31601];
                                 v[31601] = 0;
                                 if ((d | 0) == 1) {
                                  break x;
                                 }
                                 i = 0;
                                 d = 0;
                                 if (!c) {
                                  break xa;
                                 }
                                 while (1) {
                                  ya: {
                                   c = v[b + 8 >> 2];
                                   e = v[b >> 2];
                                   v[31601] = 0;
                                   c = T(150, e | 0, c | 0, 8) | 0;
                                   e = v[31601];
                                   v[31601] = 0;
                                   za: {
                                    Aa: {
                                     Ba: {
                                      if ((e | 0) != 1) {
                                       if (!c) {
                                        break ya;
                                       }
                                       v[31601] = 0;
                                       N(544, b | 0, f + 188 | 0);
                                       c = v[31601];
                                       v[31601] = 0;
                                       if ((c | 0) == 1) {
                                        break Ba;
                                       }
                                       c = _b(v[f + 188 >> 2]);
                                       if (!c) {
                                        break ya;
                                       }
                                       switch ((c & 536870911) - 1 | 0) {
                                       case 1:
                                        break za;

                                       case 0:
                                        break Aa;

                                       default:
                                        continue;
                                       }
                                      }
                                      g = M() | 0;
                                      break w;
                                     }
                                     g = M() | 0;
                                     break w;
                                    }
                                    i = _b(v[f + 192 >> 2]);
                                    continue;
                                   }
                                   d = _b(v[f + 192 >> 2]);
                                   continue;
                                  }
                                  break;
                                 }
                                 if (!i | !d) {
                                  break xa;
                                 }
                                 v[31601] = 0;
                                 c = O(149, b | 0, i | 0) | 0;
                                 e = v[31601];
                                 v[31601] = 0;
                                 if ((e | 0) == 1) {
                                  break y;
                                 }
                                 if (!c) {
                                  break xa;
                                 }
                                 v[31601] = 0;
                                 R(424, b | 0, ((g << 5) + D | 0) + 9 | 0, d | 0);
                                 c = v[31601];
                                 v[31601] = 0;
                                 if ((c | 0) == 1) {
                                  break y;
                                 }
                                }
                                g = g + 1 | 0;
                                continue;
                               }
                              }
                              la = f, ma = Ab(x[f + 584 >> 1]), u[la + 172 >> 1] = ma;
                              Gf(f + 172 | 0, (m ^ -1) & 65535);
                              v[31601] = 0;
                              s = x[f + 172 >> 1];
                              N(223, z | 0, s + m & 65535);
                              c = v[31601];
                              v[31601] = 0;
                              Ca: {
                               if ((c | 0) == 1) {
                                break Ca;
                               }
                               ea = m & 65535;
                               C = 0;
                               fa = (h & 16) != 0;
                               Da: {
                                Ea: {
                                 while (1) {
                                  if ((s | 0) == (C | 0)) {
                                   la = f, ma = Si(v[o >> 2]), v[la + 128 >> 2] = ma;
                                   h = Of(o);
                                   while (1) {
                                    Fa: {
                                     Ga: {
                                      Ha: {
                                       Ia: {
                                        Ja: {
                                         Ka: {
                                          c = v[f + 128 >> 2];
                                          if (!Yg(c, h)) {
                                           c = _b(v[f + 504 >> 2]);
                                           if (c) {
                                            break Ka;
                                           }
                                           d = 31;
                                           break Ja;
                                          }
                                          c = cp(c);
                                          d = _e(c);
                                          e = x[c >> 1];
                                          if (!e) {
                                           e = 0;
                                           break Ia;
                                          }
                                          g = e - 1 & 65535;
                                          if (!Vi(j, g)) {
                                           break Ia;
                                          }
                                          v[31601] = 0;
                                          e = O(368, j | 0, g | 0) | 0;
                                          c = v[31601];
                                          v[31601] = 0;
                                          if ((c | 0) == 1) {
                                           break Fa;
                                          }
                                          break Ha;
                                         }
                                         v[31601] = 0;
                                         c = O(149, b | 0, c | 0) | 0;
                                         d = v[31601];
                                         v[31601] = 0;
                                         if ((d | 0) == 1) {
                                          break Ca;
                                         }
                                         d = c ? 0 : 31;
                                        }
                                        m = m + s | 0;
                                        break L;
                                       }
                                       if (x[d >> 1] == (e + 1 | 0)) {
                                        break Ga;
                                       }
                                       v[31601] = 0;
                                       e = O(367, z | 0, 1) | 0;
                                       g = v[31601];
                                       v[31601] = 0;
                                       if ((g | 0) == 1) {
                                        break Fa;
                                       }
                                       if ((e | 0) == 65535) {
                                        break Ga;
                                       }
                                       la = $b(v[j >> 2], x[c >> 1]), ma = e, u[la >> 1] = ma;
                                      }
                                      c = Vb(v[z >> 2], e);
                                      ze(c, zn(We(Ne(f + 188 | 0, 12, fw(x[d >> 1])), v[c + 12 >> 2] - 1 | 0)));
                                      s = (s & 65535) >>> 0 > e >>> 0 ? s : e + 1 | 0;
                                     }
                                     $g(f + 128 | 0);
                                     continue;
                                    }
                                    break;
                                   }
                                   g = M() | 0;
                                   break w;
                                  }
                                  La: {
                                   Ma: {
                                    if (!ca) {
                                     break Ma;
                                    }
                                    c = w[f + 908 | 0] | w[f + 909 | 0] << 8 | (w[f + 910 | 0] << 16 | w[f + 911 | 0] << 24);
                                    v[31601] = 0;
                                    c = O(149, b | 0, _b(c) + (C << 2) | 0) | 0;
                                    d = v[31601];
                                    v[31601] = 0;
                                    if ((d | 0) == 1) {
                                     break Ea;
                                    }
                                    if (!c) {
                                     break Ma;
                                    }
                                    v[31601] = 0;
                                    c = Q(281, b | 0) | 0;
                                    d = v[31601];
                                    v[31601] = 0;
                                    if ((d | 0) == 1) {
                                     break Ea;
                                    }
                                    v[31601] = 0;
                                    c = O(149, b | 0, c | 0) | 0;
                                    d = v[31601];
                                    v[31601] = 0;
                                    if ((d | 0) == 1) {
                                     break Ea;
                                    }
                                    if (!c) {
                                     break Ma;
                                    }
                                    A = Eb(f + 68 | 0);
                                    v[31601] = 0;
                                    c = t[f + 846 | 0];
                                    S = Q(168, f + 12 | 0) | 0;
                                    d = v[31601];
                                    v[31601] = 0;
                                    Na: {
                                     Oa: {
                                      if ((d | 0) != 1) {
                                       l = c + 48 | 0;
                                       if (L) {
                                        break Oa;
                                       }
                                       v[31601] = 0;
                                       N(545, b | 0, f + 188 | 0);
                                       c = v[31601];
                                       v[31601] = 0;
                                       if ((c | 0) == 1) {
                                        break La;
                                       }
                                       u[f + 124 >> 1] = w[f + 188 | 0];
                                       r = w[f + 189 | 0] + 1 | 0;
                                       break Na;
                                      }
                                      g = M() | 0;
                                      break z;
                                     }
                                     v[31601] = 0;
                                     N(546, b | 0, f + 176 | 0);
                                     d = v[31601];
                                     v[31601] = 0;
                                     Pa: {
                                      Qa: {
                                       if ((d | 0) != 1) {
                                        h = Ab(x[f + 176 >> 1]);
                                        u[f + 124 >> 1] = h;
                                        r = Ab(x[f + 178 >> 1]) + 1 | 0;
                                        d = _b(x[f + 180 >> 1] | x[f + 182 >> 1] << 16);
                                        if (!d) {
                                         break Pa;
                                        }
                                        e = v[b + 8 >> 2];
                                        v[31601] = 0;
                                        O(149, b | 0, d | 0) | 0;
                                        d = v[31601];
                                        v[31601] = 0;
                                        if ((d | 0) == 1) {
                                         break A;
                                        }
                                        v[31601] = 0;
                                        N(547, b | 0, f + 188 | 0);
                                        d = v[31601];
                                        v[31601] = 0;
                                        if ((d | 0) == 1) {
                                         break A;
                                        }
                                        d = w[f + 192 | 0] | w[f + 193 | 0] << 8 | (w[f + 194 | 0] << 16 | w[f + 195 | 0] << 24);
                                        v[31601] = 0;
                                        d = O(149, b | 0, _b(d) | 0) | 0;
                                        g = v[31601];
                                        v[31601] = 0;
                                        if ((g | 0) == 1) {
                                         break A;
                                        }
                                        if (!d) {
                                         break Qa;
                                        }
                                        d = w[f + 196 | 0] | w[f + 197 | 0] << 8 | (w[f + 198 | 0] << 16 | w[f + 199 | 0] << 24);
                                        v[31601] = 0;
                                        R(270, b | 0, A | 0, _b(d) | 0);
                                        d = v[31601];
                                        v[31601] = 0;
                                        if ((d | 0) != 1) {
                                         break Qa;
                                        }
                                        break A;
                                       }
                                       break A;
                                      }
                                      d = _b(w[f + 204 | 0] | w[f + 205 | 0] << 8 | (w[f + 206 | 0] << 16 | w[f + 207 | 0] << 24));
                                      Ra: {
                                       if (!d) {
                                        break Ra;
                                       }
                                       v[31601] = 0;
                                       d = O(149, b | 0, d | 0) | 0;
                                       g = v[31601];
                                       v[31601] = 0;
                                       if ((g | 0) == 1) {
                                        break A;
                                       }
                                       if (!d) {
                                        break Ra;
                                       }
                                       v[31601] = 0;
                                       d = Q(281, b | 0) | 0;
                                       g = v[31601];
                                       v[31601] = 0;
                                       if ((g | 0) == 1) {
                                        break A;
                                       }
                                       v[31601] = 0;
                                       d = O(149, b | 0, d | 0) | 0;
                                       g = v[31601];
                                       v[31601] = 0;
                                       if ((g | 0) == 1) {
                                        break A;
                                       }
                                       if (!d) {
                                        break Ra;
                                       }
                                       v[31601] = 0;
                                       d = f + 88 | 0;
                                       R(185, d | 0, b | 0, B(h, r) | 0);
                                       h = v[31601];
                                       v[31601] = 0;
                                       if ((h | 0) == 1) {
                                        break A;
                                       }
                                       h = gc(f + 128 | 0, d);
                                       jd(S, h);
                                       tb(h);
                                       tb(d);
                                      }
                                      v[31601] = 0;
                                      O(149, b | 0, e | 0) | 0;
                                      d = v[31601];
                                      v[31601] = 0;
                                      if ((d | 0) == 1) {
                                       break A;
                                      }
                                     }
                                     l = L >>> 0 > 2 ? c + 24 | 0 : l;
                                    }
                                    v[31601] = 0;
                                    c = C + ea | 0;
                                    d = T(196, z | 0, c & 65535, r | 0) | 0;
                                    h = v[31601];
                                    v[31601] = 0;
                                    if ((h | 0) == 1) {
                                     break A;
                                    }
                                    Sa: {
                                     if (!d) {
                                      break Sa;
                                     }
                                     d = v[z >> 2];
                                     v[31601] = 0;
                                     n = Vb(d, c);
                                     N(283, n | 0, A | 0);
                                     c = v[31601];
                                     v[31601] = 0;
                                     if ((c | 0) == 1) {
                                      break Da;
                                     }
                                     Gf(f + 124 | 0, x[G >> 1]);
                                     ga = r - 1 | 0;
                                     c = 0;
                                     ha = x[f + 124 >> 1];
                                     Ta: while (1) {
                                      if ((c | 0) == (r | 0)) {
                                       break Sa;
                                      }
                                      h = c + 1 | 0;
                                      ia = c - 1 | 0;
                                      g = 0;
                                      e = ld(v[n >> 2], v[v[n + 48 >> 2] + 12 >> 2], c, 0);
                                      ja = c >>> 0 >= ga >>> 0;
                                      while (1) {
                                       H = g & 65535;
                                       if (ha >>> 0 <= H >>> 0) {
                                        c = h;
                                        continue Ta;
                                       }
                                       AD(f + 128 | 0, w[e + 3 | 0], e + 5 | 0);
                                       Ua: {
                                        if (!L) {
                                         v[31601] = 0;
                                         d = f + 188 | 0;
                                         N(548, d | 0, b | 0);
                                         i = v[31601];
                                         v[31601] = 0;
                                         if ((i | 0) != 1) {
                                          i = w[f + 188 | 0];
                                          E = Ic(d);
                                          t[e + 1 | 0] = i >>> 3 & 16 | w[E | 0] >>> 4 | i >>> 1 & 32;
                                          E = w[E | 0];
                                          la = e, ma = w[_e(d) | 0], t[la + 5 | 0] = ma;
                                          d = i & 63;
                                          d = d ? d + l | 0 : 0;
                                          i = E & 15;
                                          break Ua;
                                         }
                                         break A;
                                        }
                                        v[31601] = 0;
                                        d = f + 188 | 0;
                                        N(357, d | 0, b | 0);
                                        i = v[31601];
                                        v[31601] = 0;
                                        Va: {
                                         Wa: {
                                          if ((i | 0) != 1) {
                                           i = Ic(d);
                                           E = _e(d);
                                           Y = Xi(d);
                                           v[31601] = 0;
                                           d = Q(197, S | 0) | 0;
                                           F = v[31601];
                                           v[31601] = 0;
                                           if ((F | 0) == 1) {
                                            break A;
                                           }
                                           t[e + 4 | 0] = d;
                                           F = w[f + 188 | 0];
                                           d = F & 127;
                                           if (!d) {
                                            break Wa;
                                           }
                                           d = d + l | 0;
                                           break Va;
                                          }
                                          break A;
                                         }
                                         d = 0;
                                         if ((F | 0) != 128) {
                                          break Va;
                                         }
                                         t[e | 0] = 254;
                                        }
                                        t[e + 1 | 0] = w[i | 0] & 63;
                                        i = w[E | 0];
                                        t[e + 5 | 0] = w[Y | 0];
                                       }
                                       if (d - 1 >>> 0 <= 119) {
                                        t[e | 0] = d;
                                       }
                                       Y = (d | 0) > 84;
                                       E = f + 188 | 0;
                                       F = (aa | 0) != 0;
                                       ka = (X | 0) != 0;
                                       d = eb - 16 | 0;
                                       eb = d;
                                       t[e + 3 | 0] = 0;
                                       Xa: {
                                        Ya: {
                                         Za: {
                                          _a: {
                                           $a: {
                                            ab: {
                                             bb: {
                                              cb: {
                                               db: {
                                                eb: {
                                                 fb: {
                                                  gb: {
                                                   hb: {
                                                    ib: {
                                                     jb: {
                                                      kb: {
                                                       lb: {
                                                        mb: {
                                                         nb: {
                                                          ob: {
                                                           pb: {
                                                            qb: {
                                                             rb: {
                                                              sb: {
                                                               tb: {
                                                                i = i & 255;
                                                                switch (i - 4 | 0) {
                                                                case 4:
                                                                case 10:
                                                                 break Ya;

                                                                case 42:
                                                                 break _a;

                                                                case 37:
                                                                 break $a;

                                                                case 28:
                                                                 break ab;

                                                                case 27:
                                                                 break bb;

                                                                case 26:
                                                                 break cb;

                                                                case 25:
                                                                 break db;

                                                                case 24:
                                                                 break eb;

                                                                case 23:
                                                                 break fb;

                                                                case 22:
                                                                 break gb;

                                                                case 21:
                                                                 break hb;

                                                                case 20:
                                                                 break ib;

                                                                case 18:
                                                                 break jb;

                                                                case 17:
                                                                 break kb;

                                                                case 16:
                                                                 break lb;

                                                                case 14:
                                                                 break mb;

                                                                case 13:
                                                                 break nb;

                                                                case 12:
                                                                 break ob;

                                                                case 11:
                                                                 break pb;

                                                                case 9:
                                                                 break qb;

                                                                case 8:
                                                                 break rb;

                                                                case 5:
                                                                 break sb;

                                                                case 0:
                                                                 break tb;

                                                                default:
                                                                 break Za;
                                                                }
                                                               }
                                                               t[e + 3 | 0] = 5;
                                                               i = w[e + 5 | 0];
                                                               t[d + 15 | 0] = i >>> 3;
                                                               t[d + 14 | 0] = 15;
                                                               F = w[Pb(d + 15 | 0, d + 14 | 0) | 0];
                                                               t[d + 13 | 0] = i << 1 & 30;
                                                               t[d + 12 | 0] = 15;
                                                               la = e, ma = w[Pb(d + 13 | 0, d + 12 | 0) | 0] | F << 4, t[la + 5 | 0] = ma;
                                                               break Ya;
                                                              }
                                                              if ((w[e + 5 | 0] - 1 & 255) >>> 0 > 19) {
                                                               break Ya;
                                                              }
                                                              t[e + 3 | 0] = 16;
                                                              break Ya;
                                                             }
                                                             t[e + 3 | 0] = 13;
                                                             i = w[e + 5 | 0];
                                                             ub: {
                                                              if (!fa) {
                                                               if (i >>> 0 > 152) {
                                                                break ub;
                                                               }
                                                               t[e + 5 | 0] = B((i & 240) >>> 4 | 0, 10) + (i & 15);
                                                               break Ya;
                                                              }
                                                              t[e + 5 | 0] = (i & 127) + 1 >>> 1;
                                                              break Ya;
                                                             }
                                                             t[e + 3 | 0] = 0;
                                                             break Ya;
                                                            }
                                                            t[e + 3 | 0] = 11;
                                                            break Ya;
                                                           }
                                                           i = w[e + 5 | 0];
                                                           if (!i) {
                                                            t[e + 3 | 0] = 14;
                                                            break Ya;
                                                           }
                                                           if (i >>> 0 > 240) {
                                                            break Ya;
                                                           }
                                                           t[e + 3 | 0] = 17;
                                                           if (i >>> 0 <= 2) {
                                                            t[e + 5 | 0] = 112;
                                                            break Ya;
                                                           }
                                                           i = MD(+(vY(i, F, ka, K) >>> 0) / 1e4);
                                                           if (i >>> 0 <= 255) {
                                                            t[e + 5 | 0] = i;
                                                            break Ya;
                                                           }
                                                           t[e + 5 | 0] = i >>> 8;
                                                           t[d + 11 | 0] = i;
                                                           de(E, 34, d + 11 | 0);
                                                           break Xa;
                                                          }
                                                          t[e + 3 | 0] = 31;
                                                          t[e + 5 | 0] = w[e + 5 | 0] | 128;
                                                          break Ya;
                                                         }
                                                         t[e + 3 | 0] = 19;
                                                         t[d + 10 | 0] = 15;
                                                         la = e, ma = w[Pb(e + 5 | 0, d + 10 | 0) | 0] | 16, t[la + 5 | 0] = ma;
                                                         break Ya;
                                                        }
                                                        t[e + 3 | 0] = 19;
                                                        t[d + 9 | 0] = 15;
                                                        la = e, ma = w[Pb(e + 5 | 0, d + 9 | 0) | 0] | 32, t[la + 5 | 0] = ma;
                                                        break Ya;
                                                       }
                                                       t[e + 3 | 0] = 5;
                                                       i = w[e + 5 | 0];
                                                       t[d + 8 | 0] = (i >>> 4 | 0) + 1;
                                                       t[d + 7 | 0] = 15;
                                                       la = e, ma = i & 15 | w[Pb(d + 8 | 0, d + 7 | 0) | 0] << 4, t[la + 5 | 0] = ma;
                                                       break Ya;
                                                      }
                                                      t[e + 3 | 0] = 19;
                                                      t[e + 5 | 0] = w[e + 5 | 0] & 15 | 80;
                                                      break Ya;
                                                     }
                                                     t[e + 3 | 0] = 19;
                                                     t[d + 6 | 0] = 15;
                                                     la = e, ma = w[Pb(e + 5 | 0, d + 6 | 0) | 0] | 96, t[la + 5 | 0] = ma;
                                                     break Ya;
                                                    }
                                                    t[e + 3 | 0] = 19;
                                                    t[d + 5 | 0] = 15;
                                                    la = e, ma = w[Pb(e + 5 | 0, d + 5 | 0) | 0] | 192, t[la + 5 | 0] = ma;
                                                    break Ya;
                                                   }
                                                   t[e + 3 | 0] = 10;
                                                   break Ya;
                                                  }
                                                  t[e + 3 | 0] = 19;
                                                  t[d + 4 | 0] = 15;
                                                  la = e, ma = w[Pb(e + 5 | 0, d + 4 | 0) | 0] | 160, t[la + 5 | 0] = ma;
                                                  break Ya;
                                                 }
                                                 t[e + 3 | 0] = 19;
                                                 t[d + 3 | 0] = 15;
                                                 la = e, ma = w[Pb(e + 5 | 0, d + 3 | 0) | 0] | 176, t[la + 5 | 0] = ma;
                                                 break Ya;
                                                }
                                                i = w[e + 5 | 0] - 1 << 24 >> 24;
                                                if ((i | 0) < 0) {
                                                 break Ya;
                                                }
                                                t[e + 5 | 0] = i;
                                                t[e + 3 | 0] = 31;
                                                break Ya;
                                               }
                                               t[e + 3 | 0] = 14;
                                               break Ya;
                                              }
                                              t[e + 3 | 0] = 19;
                                              t[d + 2 | 0] = 15;
                                              la = e, ma = w[Pb(e + 5 | 0, d + 2 | 0) | 0] | 224, t[la + 5 | 0] = ma;
                                              break Ya;
                                             }
                                             i = w[e + 5 | 0];
                                             if (i >>> 0 >= 16) {
                                              t[e + 3 | 0] = 19;
                                              t[e + 5 | 0] = i >>> 4 | 208;
                                              break Ya;
                                             }
                                             if (!i) {
                                              break Ya;
                                             }
                                             t[e + 3 | 0] = 19;
                                             t[e + 5 | 0] = i | 144;
                                             break Ya;
                                            }
                                            if (w[e + 5 | 0] | w[e + 4 | 0]) {
                                             break Ya;
                                            }
                                            if (!Tc(w[e | 0])) {
                                             break Ya;
                                            }
                                            t[e + 5 | 0] = 159;
                                            t[e + 3 | 0] = 20;
                                            break Ya;
                                           }
                                           i = w[e + 4 | 0];
                                           if (!i) {
                                            break Ya;
                                           }
                                           t[e + 3 | 0] = 44;
                                           la = e, ma = ri(Ac(((w[e + 5 | 0] << 8 & 65280) >>> 0) / (i >>> 0) | 0, 0)), t[la + 5 | 0] = ma;
                                           break Ya;
                                          }
                                          i = w[e + 5 | 0];
                                          if ((i + 16 & 255) >>> 0 > 32) {
                                           break Ya;
                                          }
                                          t[e + 3 | 0] = 9;
                                          la = e, ma = Dh(((i ^ 128) << 3) - 896 | 0), t[la + 5 | 0] = ma;
                                          break Ya;
                                         }
                                         if (i >>> 0 > 15) {
                                          break Ya;
                                         }
                                         Bf(e, i, w[e + 5 | 0]);
                                        }
                                        t[d + 1 | 0] = 0;
                                        AD(E, 0, d + 1 | 0);
                                       }
                                       eb = d + 16 | 0;
                                       vb: {
                                        if (w[f + 128 | 0] != 34) {
                                         break vb;
                                        }
                                        if (!w[e + 3 | 0]) {
                                         d = x[f + 128 >> 1];
                                         t[e + 3 | 0] = d;
                                         t[e + 5 | 0] = d >>> 8;
                                         break vb;
                                        }
                                        if (!c) {
                                         break vb;
                                        }
                                        la = ld(v[n >> 2], v[v[n + 48 >> 2] + 12 >> 2], ia, H), ma = 255, t[la + 5 | 0] = ma;
                                       }
                                       d = Y & _;
                                       wb: {
                                        if (!w[f + 188 | 0]) {
                                         break wb;
                                        }
                                        if (!ja) {
                                         i = ld(v[n >> 2], v[v[n + 48 >> 2] + 12 >> 2], h, H);
                                         H = x[f + 188 >> 1];
                                         t[i + 3 | 0] = H;
                                         t[i + 5 | 0] = H >>> 8;
                                         break wb;
                                        }
                                        t[e + 5 | 0] = 255;
                                       }
                                       y = d | y;
                                       e = e + 6 | 0;
                                       g = g + 1 | 0;
                                       continue;
                                      }
                                     }
                                    }
                                    tb(S);
                                    sb(A);
                                   }
                                   C = C + 1 | 0;
                                   continue;
                                  }
                                  break;
                                 }
                                 break A;
                                }
                                g = M() | 0;
                                break w;
                               }
                               break A;
                              }
                              g = M() | 0;
                              break w;
                             }
                             jD(o);
                             e = 0;
                             xb: {
                              switch (d - 31 | 0) {
                              default:
                               if (d) {
                                break c;
                               }
                               break;

                              case 2:
                               break xb;

                              case 1:
                               break c;

                              case 0:
                               break K;
                              }
                             }
                             k = k + 1 | 0;
                             continue;
                            }
                            break;
                           }
                           Vj(W, 0);
                           e = 1;
                           if (y & 1) {
                            break B;
                           }
                           while (1) {
                            b = e & 65535;
                            if (b >>> 0 > x[a + 480192 >> 1]) {
                             u[a + 480192 >> 1] = 0;
                             break B;
                            }
                            b = (b << 2) + J | 0;
                            c = v[b >> 2];
                            if (c) {
                             Bb(Nv(c));
                            }
                            v[b >> 2] = 0;
                            e = e + 1 | 0;
                            continue;
                           }
                          }
                          g = M() | 0;
                          break f;
                         }
                         yb: {
                          if (!ba) {
                           break yb;
                          }
                          v[31601] = 0;
                          b = O(1, f + 188 | 0, 16392) | 0;
                          c = v[31601];
                          v[31601] = 0;
                          zb: {
                           if ((c | 0) != 1) {
                            c = v[a + 1298472 >> 2];
                            v[31601] = 0;
                            R(385, c | 0, 2, b | 0);
                            c = v[31601];
                            v[31601] = 0;
                            if ((c | 0) == 1) {
                             break zb;
                            }
                            sb(b);
                            break yb;
                           }
                           g = M() | 0;
                           break f;
                          }
                          g = M() | 0;
                          sb(b);
                          break f;
                         }
                         d = 22256;
                         Ab: {
                          Bb: {
                           switch (w[f + 891 | 0]) {
                           case 0:
                            d = x[G >> 1] > 4 ? 17280 : 17266;
                            break Ab;

                           case 1:
                            d = 17248;
                            break Ab;

                           case 2:
                            d = 17230;
                            break Ab;

                           case 3:
                            break Bb;

                           default:
                            break Ab;
                           }
                          }
                          d = 17203;
                         }
                         v[31601] = 0;
                         b = f + 88 | 0;
                         N(549, b | 0, 16802);
                         c = v[31601];
                         v[31601] = 0;
                         Cb: {
                          Db: {
                           Eb: {
                            if ((c | 0) != 1) {
                             v[31601] = 0;
                             c = f + 128 | 0;
                             R(550, c | 0, b | 0, f + 891 | 0);
                             h = v[31601];
                             v[31601] = 0;
                             if ((h | 0) == 1) {
                              break Eb;
                             }
                             yb(a + 1298344 | 0, c);
                             sb(c);
                             Db(b);
                             v[31601] = 0;
                             c = O(1, c | 0, 12706) | 0;
                             h = v[31601];
                             v[31601] = 0;
                             if ((h | 0) == 1) {
                              break Db;
                             }
                             yb(a + 1298356 | 0, c);
                             sb(c);
                             v[31601] = 0;
                             N(130, a + 1298368 | 0, d | 0);
                             c = v[31601];
                             v[31601] = 0;
                             if ((c | 0) == 1) {
                              break Cb;
                             }
                             la = a, ma = v[Ec(b, 28) >> 2], v[la + 1298404 >> 2] = ma;
                             e = 1;
                             break c;
                            }
                            g = M() | 0;
                            break f;
                           }
                           g = M() | 0;
                           Db(f + 88 | 0);
                           break f;
                          }
                          g = M() | 0;
                          break f;
                         }
                         g = M() | 0;
                         break f;
                        }
                        g = M() | 0;
                        tb(S);
                       }
                       sb(A);
                       break w;
                      }
                      g = M() | 0;
                      break w;
                     }
                     g = M() | 0;
                    }
                    jD(o);
                    break f;
                   }
                   g = M() | 0;
                   break f;
                  }
                  g = M() | 0;
                  break f;
                 }
                 g = M() | 0;
                 break f;
                }
                j = 1;
                if ((d | 0) != 7) {
                 break m;
                }
                e = h + 108 | 0;
                d = RC(e);
                while (1) {
                 if ((d | 0) != (e | 0)) {
                  la = e, ma = gp(w[e | 0] - 24 | 0), t[la | 0] = ma;
                  e = e + 1 | 0;
                  continue;
                 }
                 break;
                }
                d = 0;
               }
               y = 1;
               break l;
              }
              d = 0;
              Fb: {
               if (s | (g | 0) < 0) {
                break Fb;
               }
               i = h + 108 | 0;
               k = 7;
               Gb: while (1) {
                if ((k | 0) == 10) {
                 break Fb;
                }
                q = B(k, 12);
                r = B(k, -12) + 72 | 0;
                e = 0;
                while (1) if ((e | 0) == 12) {
                 k = k + 1 | 0;
                 continue Gb;
                } else {
                 D = wb(i, e + q | 0);
                 t[D | 0] = r + w[D | 0];
                 e = e + 1 | 0;
                 continue;
                }
               }
              }
             }
             v[31601] = 0;
             N(551, V | 0, f + 188 | 0);
             e = v[31601];
             v[31601] = 0;
             if ((e | 0) != 1) {
              Hb: {
               e = w[f + 192 | 0];
               if ((e - 1 & 255) >>> 0 <= 15) {
                t[h + 31 | 0] = e;
                y = 1;
               }
               e = w[f + 193 | 0];
               if (e - 1 << 24 >> 24 >= 0) {
                t[h + 30 | 0] = e;
               }
               e = 0;
               Ib: {
                while (1) {
                 if ((e | 0) == (j | 0)) {
                  if (!C) {
                   break j;
                  }
                  if ((g | 0) >= 0) {
                   break Ib;
                  }
                  break j;
                 }
                 v[31601] = 0;
                 h = n + B(e + z | 0, 104) | 0;
                 N(279, h | 0, 8);
                 k = v[31601];
                 v[31601] = 0;
                 if ((k | 0) != 1) {
                  t[f + 128 | 0] = w[f + 194 | 0];
                  t[f + 68 | 0] = 64;
                  la = h, ma = w[Pb(f + 128 | 0, f + 68 | 0) | 0] << 2, u[la + 30 >> 1] = ma;
                  t[h + 36 | 0] = w[f + 195 | 0];
                  e = e + 1 | 0;
                  continue;
                 }
                 break;
                }
                break k;
               }
               k = Yc(f + 128 | 0, 8, 1, 1, 0);
               q = Ab(x[f + 190 >> 1]);
               i = Ab(x[f + 188 >> 1]);
               h = v[o >> 2];
               v[31601] = 0;
               g = Q(154, h | 0) | 0;
               h = v[31601];
               v[31601] = 0;
               if ((h | 0) != 1) {
                h = ye(u[f + 92 >> 1]);
                if (h & 16) {
                 gd(k, 16);
                 g = g >>> 1 | 0;
                }
                if (h & 32) {
                 wp(k, 3);
                 g = g >>> 1 | 0;
                }
                if (h & 64) {
                 vg(k, 2);
                }
                if (d) {
                 g = (g >>> 0) / ((-1 << j ^ -1) >>> 0) | 0;
                }
                d = i + q | 0;
                e = 0;
                while (1) {
                 if ((e | 0) == (j | 0)) {
                  break j;
                 }
                 h = n + B(e + z | 0, 104) | 0;
                 v[h >> 2] = g;
                 v[31601] = 0;
                 T(215, k | 0, h | 0, o | 0) | 0;
                 r = v[31601];
                 v[31601] = 0;
                 if ((r | 0) == 1) {
                  break Hb;
                 }
                 i = i << 1;
                 d = d << 1;
                 if (q >>> 0 >= 2) {
                  v[h + 8 >> 2] = d;
                  v[h + 4 >> 2] = i;
                  u[h + 34 >> 1] = x[h + 34 >> 1] | 2;
                 }
                 e = e + 1 | 0;
                 g = g << 1;
                 continue;
                }
               }
              }
             }
            }
            g = M() | 0;
            tb(o);
            break f;
           }
           tb(o);
           l = l + 1 | 0;
           m = j + m | 0;
           d = x[a + 480192 >> 1];
           continue;
          }
         }
         g = M() | 0;
         break e;
        }
        g = M() | 0;
        break e;
       }
       g = M() | 0;
      }
      uc(I);
     }
     tb(V);
     P(g | 0);
     p();
    }
    e = 0;
   }
   uc(I);
  }
  tb(V);
 }
 eb = f + 944 | 0;
 return e | 0;
}

function cg(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = C(0), m = 0, o = 0, q = 0, s = 0, E = 0, F = C(0), G = 0, H = 0, I = 0, J = C(0), K = 0, L = 0, N = 0, U = 0, V = 0;
 m = eb - 2240 | 0;
 eb = m;
 a: {
  b: {
   c: {
    d: {
     e: {
      f: {
       if (bx(v[c >> 2])) {
        wc(b, 268435456);
        L = v[c + 8 >> 2];
        I = m + 2220 | 0;
        d = I;
        v[d >> 2] = 0;
        v[d + 4 >> 2] = 0;
        Mb(d + 8 | 0);
        v[m + 2216 >> 2] = 0;
        g: {
         h: {
          i: {
           j: {
            k: {
             l: {
              d = w[a + 3 | 0];
              m: {
               n: {
                if ((d - 4 & 255) >>> 0 <= 4) {
                 v[31601] = 0;
                 f = Q(202, c | 0) | 0;
                 d = v[31601];
                 v[31601] = 0;
                 if ((d | 0) == 1) {
                  break l;
                 }
                 v[m + 2216 >> 2] = f;
                 break n;
                }
                if (d >>> 0 > 17) {
                 break m;
                }
                o: {
                 j = 1 << d;
                 if (!(j & 63503)) {
                  if (!(j & 198144)) {
                   break m;
                  }
                  break o;
                 }
                 if (w[a | 0]) {
                  break o;
                 }
                 break n;
                }
                d = 0;
                e = BD(a, v[b >> 2]);
                v[31601] = 0;
                f = m + 48 | 0;
                R(186, f | 0, c | 0, e | 0);
                e = v[31601];
                v[31601] = 0;
                if ((e | 0) == 1) {
                 break k;
                }
                e = v[f + 4 >> 2];
                v[I >> 2] = v[f >> 2];
                v[I + 4 >> 2] = e;
                yn(I + 8 | 0, f + 8 | 0);
                Jc(f);
                e = Ze(I);
                f = v[I >> 2];
                v[m + 2216 >> 2] = f;
                if (!e) {
                 break g;
                }
               }
               d = w[a + 3 | 0];
              }
              p: {
               q: {
                switch (d & 255) {
                case 0:
                case 1:
                case 2:
                case 3:
                case 11:
                case 12:
                case 13:
                case 14:
                case 15:
                 g = w[a | 0];
                 break p;

                case 9:
                case 10:
                case 16:
                case 17:
                 break q;

                default:
                 break p;
                }
               }
               g = 8;
              }
              j = !g;
              g = v[b >> 2];
              if (!(j | g >>> 0 < 262145)) {
               j = d & 255;
               v[m + 48 >> 2] = ((j | 0) == 10) << 4;
               f = f - v[Gb(m + 48 | 0, m + 2216 | 0) >> 2] | 0;
               if (j >>> 0 > 15) {
                break j;
               }
               r: {
                if (!(1 << j & 63503)) {
                 if ((j | 0) == 10) {
                  break r;
                 }
                 break j;
                }
                if (!(w[a | 0] & 7)) {
                 break j;
                }
               }
               d = (f | 0) < 0 ? -1 : f << 1;
               break i;
              }
              d = d & 255;
              if (d >>> 0 > 8) {
               break h;
              }
              if (!(1 << d & 432)) {
               if ((d | 0) != 6) {
                break h;
               }
               d = 0;
               if (f >>> 0 < 10) {
                break g;
               }
               v[31601] = 0;
               O(183, c | 0, 4) | 0;
               d = v[31601];
               v[31601] = 0;
               if ((d | 0) == 1) {
                break l;
               }
               v[31601] = 0;
               g = Q(151, c | 0) | 0;
               d = v[31601];
               v[31601] = 0;
               if ((d | 0) != 1) {
                v[m + 48 >> 2] = g;
                v[m + 28 >> 2] = v[m + 2216 >> 2];
                d = v[Gb(m + 48 | 0, m + 28 | 0) >> 2];
                Hh(c, 8);
                d = ((d >>> 0 > 50529027 ? -1 : B(d, 85)) >>> 0) / (w[a | 0] >>> 3 >>> 0) | 0;
                break i;
               }
               a = M() | 0;
               break a;
              }
              g = 8 / (jr(w[a + 1 | 0]) >>> 0) | 0;
              d = B(g, f);
              Aua(g, 0, f, 0);
              d = gb ? -1 : d;
              break i;
             }
             a = M() | 0;
             break a;
            }
            a = M() | 0;
            break a;
           }
           g = 0;
           d = jr(w[a + 1 | 0]);
           s: {
            t: {
             switch (j | 0) {
             case 0:
             case 1:
             case 2:
             case 3:
             case 11:
             case 12:
             case 13:
             case 14:
             case 15:
              g = w[a | 0];
              break s;

             case 9:
              g = 16;
              break s;

             case 10:
              g = 4;
              break s;

             case 16:
             case 17:
              break t;

             default:
              break s;
             }
            }
            g = 8;
           }
           g = B(d, g & 255) >>> 3 | 0;
           d = (g + f | 0) - 1 | 0;
           d = ((d >>> 0 < f >>> 0 ? -1 : d) >>> 0) / (g >>> 0) | 0;
          }
          wc(b, d);
          g = v[b >> 2];
         }
         if (!g) {
          d = 0;
          break g;
         }
         u[b + 34 >> 1] = x[b + 34 >> 1] & 65470 | w[a | 0] > 15 | (w[a + 1 | 0] != 1) << 6;
         if (!Fh(b)) {
          d = 0;
          v[b >> 2] = 0;
          break g;
         }
         u: {
          d = m + 48 | 0;
          if (ne(a, Yc(d, 8, 1, 0, 10))) {
           v[31601] = 0;
           g = O(203, c | 0, d | 0) | 0;
           a = v[31601];
           v[31601] = 0;
           if ((a | 0) != 1) {
            d = 0;
            if (!g) {
             break u;
            }
            a = v[b >> 2];
            f = 0;
            v[31601] = 0;
            v[m + 28 >> 2] = a + 1 >>> 1;
            d = Q(202, c | 0) | 0;
            a = v[31601];
            v[31601] = 0;
            if ((a | 0) == 1) {
             break b;
            }
            wc(m + 28 | 0, d);
            a = e + 16 | 0;
            b = v[b + 20 >> 2];
            h = v[m + 28 >> 2];
            d = h;
            while (1) if (d) {
             g = m + 48 | 0;
             e = f + w[g | w[a | 0] & 15] | 0;
             t[b | 0] = e;
             f = w[g | w[a | 0] >>> 4] + (e & 255) | 0;
             t[b + 1 | 0] = f;
             d = d - 1 | 0;
             a = a + 1 | 0;
             b = b + 2 | 0;
             continue;
            } else {
             d = h + 16 | 0;
             break u;
            }
           }
           a = M() | 0;
           break a;
          }
          v: {
           w: {
            x: {
             y: {
              z: {
               A: {
                B: {
                 C: {
                  D: {
                   E: {
                    F: {
                     G: {
                      H: {
                       f = w[a + 3 | 0];
                       switch (f - 4 | 0) {
                       case 3:
                        break B;

                       case 4:
                        break E;

                       case 5:
                        break F;

                       case 2:
                        break G;

                       case 0:
                       case 1:
                        break H;

                       default:
                        break D;
                       }
                      }
                      v[31601] = 0;
                      b = aa(204, m + 1128 | 0, c | 0, b | 0, (f | 0) == 5 | 0) | 0;
                      a = v[31601];
                      v[31601] = 0;
                      if ((a | 0) == 1) {
                       break f;
                      }
                      tb(b);
                      d = v[c + 8 >> 2] - L | 0;
                      break u;
                     }
                     if (w[a + 1 | 0] != 1) {
                      break C;
                     }
                     v[31601] = 0;
                     O(183, c | 0, 4) | 0;
                     a = v[31601];
                     v[31601] = 0;
                     if ((a | 0) == 1) {
                      break f;
                     }
                     v[31601] = 0;
                     e = Q(151, c | 0) | 0;
                     a = v[31601];
                     v[31601] = 0;
                     I: {
                      J: {
                       K: {
                        if ((a | 0) != 1) {
                         v[31601] = 0;
                         v[m + 28 >> 2] = e;
                         d = Q(197, c | 0) | 0;
                         a = v[31601];
                         v[31601] = 0;
                         if ((a | 0) == 1) {
                          break K;
                         }
                         v[31601] = 0;
                         g = m + 48 | 0;
                         R(205, g | 0, c | 0, e | 0);
                         a = v[31601];
                         v[31601] = 0;
                         if ((a | 0) == 1) {
                          break J;
                         }
                         wc(m + 28 | 0, v[m + 48 >> 2]);
                         e = v[m + 28 >> 2];
                         Ln(m + 1120 | 0, g);
                         ac(m + 1112 | 0, v[b + 20 >> 2], Nk(v[b >> 2], x[b + 34 >> 1]));
                         v[31601] = 0;
                         $(206, v[m + 1120 >> 2], v[m + 1124 >> 2], v[m + 1112 >> 2], v[m + 1116 >> 2], d << 24 >> 24);
                         a = v[31601];
                         v[31601] = 0;
                         if ((a | 0) == 1) {
                          break I;
                         }
                         d = e + 9 | 0;
                         Jc(g);
                         break u;
                        }
                        a = M() | 0;
                        break a;
                       }
                       a = M() | 0;
                       break a;
                      }
                      a = M() | 0;
                      break a;
                     }
                     a = M() | 0;
                     Jc(m + 48 | 0);
                     break a;
                    }
                    if (w[a + 1 | 0] != 1 | w[a | 0] != 16) {
                     break C;
                    }
                    f = v[m + 2216 >> 2];
                    d = Vk(m + 1110 | 0);
                    a = v[b >> 2];
                    g = v[b + 20 >> 2];
                    d = x[d >> 1];
                    h = eb - 16 | 0;
                    eb = h;
                    v[h + 12 >> 2] = f >>> 1;
                    v[h + 8 >> 2] = a;
                    b = v[Gb(h + 12 | 0, h + 8 | 0) >> 2];
                    f = b;
                    while (1) {
                     if (f) {
                      a = w[e | 0] + d | 0;
                      d = a + w[e + 1 | 0] | 0;
                      u[g >> 1] = d << 8 | a & 255;
                      g = g + 2 | 0;
                      e = e + 2 | 0;
                      f = f - 1 | 0;
                      continue;
                     }
                     break;
                    }
                    eb = h + 16 | 0;
                    d = b << 1;
                    break u;
                   }
                   if (w[a + 1 | 0] != 1 | w[a | 0] > 16) {
                    break C;
                   }
                   g = v[c + 8 >> 2];
                   e = v[c >> 2];
                   d = 0;
                   v[31601] = 0;
                   g = T(150, e | 0, g | 0, 8) | 0;
                   e = v[31601];
                   v[31601] = 0;
                   if ((e | 0) == 1) {
                    break f;
                   }
                   if (!g) {
                    break u;
                   }
                   v[31601] = 0;
                   g = Q(151, c | 0) | 0;
                   e = v[31601];
                   v[31601] = 0;
                   if ((e | 0) == 1) {
                    break f;
                   }
                   v[m + 2216 >> 2] = g;
                   if (g >>> 0 < 4) {
                    break u;
                   }
                   v[31601] = 0;
                   d = m + 28 | 0;
                   R(185, d | 0, c | 0, g | 0);
                   e = v[31601];
                   v[31601] = 0;
                   if ((e | 0) == 1) {
                    break c;
                   }
                   E = ns(m + 48 | 0, d);
                   tb(d);
                   e = v[E >> 2];
                   v[31601] = 0;
                   d = Q(207, e | 0) | 0;
                   e = v[31601];
                   v[31601] = 0;
                   if ((e | 0) == 1) {
                    break e;
                   }
                   d = d + 4 | 0;
                   o = w[a | 0];
                   i = (o | 0) != 16;
                   e = 0;
                   while (1) {
                    if (y[b >> 2] <= e >>> 0) {
                     break w;
                    }
                    L: {
                     if (i) {
                      break L;
                     }
                     v[31601] = 0;
                     h = O(158, E | 0, 8) | 0;
                     a = v[31601];
                     v[31601] = 0;
                     if ((a | 0) != 1) {
                      break L;
                     }
                     a = S(28784) | 0;
                     break x;
                    }
                    v[31601] = 0;
                    j = O(158, E | 0, 1) | 0;
                    a = v[31601];
                    v[31601] = 0;
                    if ((a | 0) == 1) {
                     break y;
                    }
                    v[31601] = 0;
                    g = O(158, E | 0, 1) | 0;
                    a = v[31601];
                    v[31601] = 0;
                    if ((a | 0) == 1) {
                     break y;
                    }
                    M: {
                     N: {
                      O: {
                       if (!g) {
                        g = 8;
                        while (1) {
                         v[31601] = 0;
                         f = O(158, E | 0, 1) | 0;
                         a = v[31601];
                         v[31601] = 0;
                         if ((a | 0) == 1) {
                          break M;
                         }
                         if (f) {
                          break O;
                         }
                         g = g + 16 | 0;
                         continue;
                        }
                       }
                       v[31601] = 0;
                       a = O(158, E | 0, 3) | 0;
                       g = v[31601];
                       v[31601] = 0;
                       if ((g | 0) != 1) {
                        break N;
                       }
                       break y;
                      }
                      v[31601] = 0;
                      f = O(158, E | 0, 4) | 0;
                      a = v[31601];
                      v[31601] = 0;
                      if ((a | 0) == 1) {
                       break y;
                      }
                      a = f + g | 0;
                     }
                     s = (s & 255) + (((j ? -1 : 0) ^ a) & 255) | 0;
                     P: {
                      if ((o | 0) != 16) {
                       t[v[b + 20 >> 2] + e | 0] = s;
                       break P;
                      }
                      u[v[b + 20 >> 2] + (e << 1) >> 1] = h & 255 | s << 8;
                     }
                     e = e + 1 | 0;
                     continue;
                    }
                    break;
                   }
                   a = S(28784) | 0;
                   break x;
                  }
                  Q: {
                   if ((f | 0) == 16) {
                    d = w[a | 0];
                    break Q;
                   }
                   d = w[a | 0];
                   if ((f | 0) != 17) {
                    break z;
                   }
                  }
                  if ((d & 255) != 16) {
                   break z;
                  }
                  g = w[a + 1 | 0];
                  if ((g - 1 & 255) >>> 0 > 1) {
                   break z;
                  }
                  N = m, U = B(v[b >> 2], jr(g)), v[N + 48 >> 2] = U;
                  wc(m + 48 | 0, v[m + 2216 >> 2]);
                  a = v[b + 20 >> 2];
                  d = v[m + 48 >> 2];
                  if ((f | 0) == 16) {
                   b = d;
                   while (1) {
                    if (!b) {
                     break u;
                    }
                    N = a, U = x[$b(28816, w[e | 0]) >> 1], u[N >> 1] = U;
                    a = a + 2 | 0;
                    e = e + 1 | 0;
                    b = b - 1 | 0;
                    continue;
                   }
                  }
                  b = d;
                  while (1) {
                   if (!b) {
                    break u;
                   }
                   N = a, U = x[$b(29328, w[e | 0]) >> 1], u[N >> 1] = U;
                   a = a + 2 | 0;
                   e = e + 1 | 0;
                   b = b - 1 | 0;
                   continue;
                  }
                 }
                 if ((f | 0) != 7) {
                  break A;
                 }
                }
                if (w[a + 1 | 0] != 1 | w[a | 0] > 16) {
                 break A;
                }
                d = 0;
                if (y[m + 2216 >> 2] < 5) {
                 break u;
                }
                d = v[b + 20 >> 2];
                e = x[b + 34 >> 1];
                a = v[b >> 2];
                v[31601] = 0;
                d = T(208, c | 0, d | 0, Nk(a, e) | 0) | 0;
                a = v[31601];
                v[31601] = 0;
                if ((a | 0) != 1) {
                 break u;
                }
                break f;
               }
               d = w[a | 0];
              }
              g = (d & 255) != 8;
              if (!(g | w[a + 1 | 0] != 1)) {
               R: {
                switch (f | 0) {
                case 0:
                 a = v[b >> 2];
                 f = v[b + 20 >> 2];
                 g = eb - 16 | 0;
                 eb = g;
                 v[g + 12 >> 2] = v[m + 2216 >> 2];
                 v[g + 8 >> 2] = a;
                 d = v[Gb(g + 12 | 0, g + 8 | 0) >> 2];
                 b = d;
                 while (1) {
                  if (b) {
                   t[f | 0] = w[e | 0];
                   f = f + 1 | 0;
                   e = e + 1 | 0;
                   b = b - 1 | 0;
                   continue;
                  }
                  break;
                 }
                 ;
                 eb = g + 16 | 0;
                 break u;

                case 1:
                 a = v[b >> 2];
                 f = v[b + 20 >> 2];
                 g = eb - 16 | 0;
                 eb = g;
                 v[g + 12 >> 2] = v[m + 2216 >> 2];
                 v[g + 8 >> 2] = a;
                 d = v[Gb(g + 12 | 0, g + 8 | 0) >> 2];
                 b = d;
                 while (1) {
                  if (b) {
                   t[f | 0] = w[e | 0] ^ 128;
                   f = f + 1 | 0;
                   e = e + 1 | 0;
                   b = b - 1 | 0;
                   continue;
                  }
                  break;
                 }
                 ;
                 eb = g + 16 | 0;
                 break u;

                default:
                 d = 0;
                 if ((f | 0) != 11) {
                  break u;
                 }
                 break;

                case 2:
                 break R;
                }
               }
               f = v[m + 2216 >> 2];
               d = vv(m + 27 | 0);
               a = v[b >> 2];
               g = v[b + 20 >> 2];
               b = w[d | 0];
               h = eb - 16 | 0;
               eb = h;
               v[h + 12 >> 2] = f;
               v[h + 8 >> 2] = a;
               a = v[Gb(h + 12 | 0, h + 8 | 0) >> 2];
               d = a;
               while (1) {
                if (d) {
                 b = w[e | 0] + b | 0;
                 t[g | 0] = b;
                 g = g + 1 | 0;
                 e = e + 1 | 0;
                 d = d - 1 | 0;
                 continue;
                }
                break;
               }
               eb = h + 16 | 0;
               d = a;
               break u;
              }
              if (!(w[a + 1 | 0] != 3 | g)) {
               S: {
                switch (f | 0) {
                case 0:
                 j = eb - 16 | 0;
                 eb = j;
                 g = v[m + 2216 >> 2];
                 v[j + 12 >> 2] = g;
                 d = v[b >> 2];
                 v[j + 8 >> 2] = d;
                 a = j + 8 | 0;
                 f = v[Gb(a, j + 12 | 0) >> 2];
                 v[j + 8 >> 2] = d;
                 v[j + 4 >> 2] = g - f;
                 d = v[Gb(a, j + 4 | 0) >> 2];
                 h = v[b + 20 >> 2];
                 a = f;
                 g = e;
                 while (1) {
                  if (a) {
                   t[h | 0] = w[g | 0];
                   h = h + 2 | 0;
                   g = g + 1 | 0;
                   a = a - 1 | 0;
                   continue;
                  }
                  break;
                 }
                 ;
                 h = v[b + 20 >> 2] + 1 | 0;
                 g = v[b >> 2] + e | 0;
                 a = d;
                 while (1) {
                  if (a) {
                   t[h | 0] = w[g | 0];
                   h = h + 2 | 0;
                   g = g + 1 | 0;
                   a = a - 1 | 0;
                   continue;
                  }
                  break;
                 }
                 ;
                 eb = j + 16 | 0;
                 d = d + f | 0;
                 break u;

                case 1:
                 j = eb - 16 | 0;
                 eb = j;
                 g = v[m + 2216 >> 2];
                 v[j + 12 >> 2] = g;
                 d = v[b >> 2];
                 v[j + 8 >> 2] = d;
                 a = j + 8 | 0;
                 f = v[Gb(a, j + 12 | 0) >> 2];
                 v[j + 8 >> 2] = d;
                 v[j + 4 >> 2] = g - f;
                 d = v[Gb(a, j + 4 | 0) >> 2];
                 h = v[b + 20 >> 2];
                 a = f;
                 g = e;
                 while (1) {
                  if (a) {
                   t[h | 0] = w[g | 0] ^ 128;
                   h = h + 2 | 0;
                   g = g + 1 | 0;
                   a = a - 1 | 0;
                   continue;
                  }
                  break;
                 }
                 ;
                 h = v[b + 20 >> 2] + 1 | 0;
                 g = v[b >> 2] + e | 0;
                 a = d;
                 while (1) {
                  if (a) {
                   t[h | 0] = w[g | 0] ^ 128;
                   h = h + 2 | 0;
                   g = g + 1 | 0;
                   a = a - 1 | 0;
                   continue;
                  }
                  break;
                 }
                 ;
                 eb = j + 16 | 0;
                 d = d + f | 0;
                 break u;

                default:
                 d = 0;
                 if ((f | 0) != 11) {
                  break u;
                 }
                 break;

                case 2:
                 break S;
                }
               }
               j = v[m + 2216 >> 2];
               f = w[vv(m + 26 | 0) | 0];
               o = eb - 16 | 0;
               eb = o;
               v[o + 12 >> 2] = j;
               g = v[b >> 2];
               v[o + 8 >> 2] = g;
               d = o + 8 | 0;
               h = v[Gb(d, o + 12 | 0) >> 2];
               v[o + 8 >> 2] = g;
               v[o + 4 >> 2] = j - h;
               g = v[Gb(d, o + 4 | 0) >> 2];
               j = b;
               s = v[b + 20 >> 2];
               d = f;
               b = h;
               i = e;
               while (1) {
                if (b) {
                 d = w[i | 0] + d | 0;
                 t[s | 0] = d;
                 s = s + 2 | 0;
                 i = i + 1 | 0;
                 b = b - 1 | 0;
                 continue;
                }
                break;
               }
               s = v[j + 20 >> 2] + 1 | 0;
               i = v[j >> 2] + e | 0;
               b = g;
               while (1) {
                if (b) {
                 f = w[i | 0] + f | 0;
                 t[s | 0] = f;
                 s = s + 2 | 0;
                 i = i + 1 | 0;
                 b = b - 1 | 0;
                 continue;
                }
                break;
               }
               eb = o + 16 | 0;
               d = g + h | 0;
               if (w[a + 3 | 0] != 11) {
                break u;
               }
               a = v[j + 20 >> 2];
               b = a + (v[j >> 2] << 1) | 0;
               while (1) {
                if (a >>> 0 >= b >>> 0) {
                 break u;
                }
                t[a + 1 | 0] = w[a + 1 | 0] + w[a | 0];
                a = a + 2 | 0;
                continue;
               }
              }
              g = d & 255;
              if (!((g | 0) != 8 | w[a + 1 | 0] != 2)) {
               d = 0;
               T: {
                switch (f | 0) {
                case 0:
                 a = v[b >> 2];
                 f = v[b + 20 >> 2];
                 d = eb - 16 | 0;
                 eb = d;
                 v[d + 12 >> 2] = v[m + 2216 >> 2] >>> 1;
                 v[d + 8 >> 2] = a;
                 a = v[Gb(d + 12 | 0, d + 8 | 0) >> 2];
                 b = a;
                 while (1) {
                  if (b) {
                   t[f | 0] = w[e | 0];
                   t[f + 1 | 0] = w[e + 1 | 0];
                   f = f + 2 | 0;
                   e = e + 2 | 0;
                   b = b - 1 | 0;
                   continue;
                  }
                  break;
                 }
                 ;
                 eb = d + 16 | 0;
                 d = a << 1;
                 break u;

                case 1:
                 a = v[b >> 2];
                 f = v[b + 20 >> 2];
                 d = eb - 16 | 0;
                 eb = d;
                 v[d + 12 >> 2] = v[m + 2216 >> 2] >>> 1;
                 v[d + 8 >> 2] = a;
                 a = v[Gb(d + 12 | 0, d + 8 | 0) >> 2];
                 b = a;
                 while (1) {
                  if (b) {
                   t[f | 0] = w[e | 0] ^ 128;
                   t[f + 1 | 0] = w[e + 1 | 0] ^ 128;
                   f = f + 2 | 0;
                   e = e + 2 | 0;
                   b = b - 1 | 0;
                   continue;
                  }
                  break;
                 }
                 ;
                 eb = d + 16 | 0;
                 d = a << 1;
                 break u;

                case 2:
                 break T;

                default:
                 break u;
                }
               }
               f = v[m + 2216 >> 2];
               d = vv(m + 25 | 0);
               a = v[b >> 2];
               g = v[b + 20 >> 2];
               b = w[d | 0];
               h = eb - 16 | 0;
               eb = h;
               v[h + 12 >> 2] = f >>> 1;
               v[h + 8 >> 2] = a;
               a = b;
               d = v[Gb(h + 12 | 0, h + 8 | 0) >> 2];
               f = d;
               while (1) {
                if (f) {
                 b = w[e | 0] + b | 0;
                 t[g | 0] = b;
                 a = w[e + 1 | 0] + a | 0;
                 t[g + 1 | 0] = a;
                 g = g + 2 | 0;
                 e = e + 2 | 0;
                 f = f - 1 | 0;
                 continue;
                }
                break;
               }
               eb = h + 16 | 0;
               d = d << 1;
               break u;
              }
              if (!(w[a + 2 | 0] | ((g | 0) != 16 | w[a + 1 | 0] != 1))) {
               U: {
                switch (f | 0) {
                case 0:
                 a = v[b >> 2];
                 f = v[b + 20 >> 2];
                 d = eb - 16 | 0;
                 eb = d;
                 v[d + 12 >> 2] = v[m + 2216 >> 2] >>> 1;
                 v[d + 8 >> 2] = a;
                 a = v[Gb(d + 12 | 0, d + 8 | 0) >> 2];
                 b = a;
                 while (1) {
                  if (b) {
                   u[f >> 1] = w[e | 0] | w[e + 1 | 0] << 8;
                   f = f + 2 | 0;
                   e = e + 2 | 0;
                   b = b - 1 | 0;
                   continue;
                  }
                  break;
                 }
                 ;
                 eb = d + 16 | 0;
                 d = a << 1;
                 break u;

                case 1:
                 a = v[b >> 2];
                 f = v[b + 20 >> 2];
                 d = eb - 16 | 0;
                 eb = d;
                 v[d + 12 >> 2] = v[m + 2216 >> 2] >>> 1;
                 v[d + 8 >> 2] = a;
                 a = v[Gb(d + 12 | 0, d + 8 | 0) >> 2];
                 b = a;
                 while (1) {
                  if (b) {
                   u[f >> 1] = (w[e | 0] | w[e + 1 | 0] << 8) ^ 32768;
                   f = f + 2 | 0;
                   e = e + 2 | 0;
                   b = b - 1 | 0;
                   continue;
                  }
                  break;
                 }
                 ;
                 eb = d + 16 | 0;
                 d = a << 1;
                 break u;

                default:
                 d = 0;
                 if ((f | 0) != 11) {
                  break u;
                 }
                 break;

                case 2:
                 break U;
                }
               }
               f = v[m + 2216 >> 2];
               d = Vk(m + 22 | 0);
               a = v[b >> 2];
               g = v[b + 20 >> 2];
               b = x[d >> 1];
               h = eb - 16 | 0;
               eb = h;
               v[h + 12 >> 2] = f >>> 1;
               v[h + 8 >> 2] = a;
               a = v[Gb(h + 12 | 0, h + 8 | 0) >> 2];
               d = a;
               while (1) {
                if (d) {
                 b = (w[e | 0] + b | 0) + (w[e + 1 | 0] << 8) | 0;
                 u[g >> 1] = b;
                 g = g + 2 | 0;
                 e = e + 2 | 0;
                 d = d - 1 | 0;
                 continue;
                }
                break;
               }
               eb = h + 16 | 0;
               d = a << 1;
               break u;
              }
              g = d & 255;
              if (!((g | 0) != 16 | w[a + 1 | 0] != 1 | w[a + 2 | 0] != 1)) {
               d = 0;
               V: {
                switch (f | 0) {
                case 0:
                 a = v[b >> 2];
                 f = v[b + 20 >> 2];
                 g = eb - 16 | 0;
                 eb = g;
                 v[g + 12 >> 2] = v[m + 2216 >> 2] >>> 1;
                 v[g + 8 >> 2] = a;
                 b = v[Gb(g + 12 | 0, g + 8 | 0) >> 2];
                 d = b;
                 while (1) {
                  if (d) {
                   a = w[e | 0] | w[e + 1 | 0] << 8;
                   u[f >> 1] = a << 8 | a >>> 8;
                   f = f + 2 | 0;
                   e = e + 2 | 0;
                   d = d - 1 | 0;
                   continue;
                  }
                  break;
                 }
                 ;
                 eb = g + 16 | 0;
                 d = b << 1;
                 break u;

                case 1:
                 a = v[b >> 2];
                 f = v[b + 20 >> 2];
                 g = eb - 16 | 0;
                 eb = g;
                 v[g + 12 >> 2] = v[m + 2216 >> 2] >>> 1;
                 v[g + 8 >> 2] = a;
                 b = v[Gb(g + 12 | 0, g + 8 | 0) >> 2];
                 d = b;
                 while (1) {
                  if (d) {
                   a = w[e | 0] | w[e + 1 | 0] << 8;
                   u[f >> 1] = (a << 8 | a >>> 8) ^ 32768;
                   f = f + 2 | 0;
                   e = e + 2 | 0;
                   d = d - 1 | 0;
                   continue;
                  }
                  break;
                 }
                 ;
                 eb = g + 16 | 0;
                 d = b << 1;
                 break u;

                case 2:
                 break V;

                default:
                 break u;
                }
               }
               f = v[m + 2216 >> 2];
               d = Vk(m + 20 | 0);
               a = v[b >> 2];
               g = v[b + 20 >> 2];
               b = x[d >> 1];
               h = eb - 16 | 0;
               eb = h;
               v[h + 12 >> 2] = f >>> 1;
               v[h + 8 >> 2] = a;
               a = v[Gb(h + 12 | 0, h + 8 | 0) >> 2];
               d = a;
               while (1) {
                if (d) {
                 b = (w[e + 1 | 0] + b | 0) + (w[e | 0] << 8) | 0;
                 u[g >> 1] = b;
                 g = g + 2 | 0;
                 e = e + 2 | 0;
                 d = d - 1 | 0;
                 continue;
                }
                break;
               }
               eb = h + 16 | 0;
               d = a << 1;
               break u;
              }
              if (!(w[a + 2 | 0] | ((g | 0) != 16 | w[a + 1 | 0] != 3))) {
               W: {
                switch (f | 0) {
                case 0:
                 i = eb - 16 | 0;
                 eb = i;
                 d = v[m + 2216 >> 2];
                 v[i + 12 >> 2] = d;
                 j = v[b >> 2] << 1;
                 v[i + 8 >> 2] = j;
                 a = i + 8 | 0;
                 g = v[Gb(a, i + 12 | 0) >> 2];
                 v[i + 8 >> 2] = j;
                 v[i + 4 >> 2] = d - g;
                 a = v[Gb(a, i + 4 | 0) >> 2];
                 f = v[b + 20 >> 2];
                 d = g >>> 1 | 0;
                 h = d;
                 g = e;
                 while (1) {
                  if (h) {
                   u[f >> 1] = w[g | 0] | w[g + 1 | 0] << 8;
                   f = f + 4 | 0;
                   g = g + 2 | 0;
                   h = h - 1 | 0;
                   continue;
                  }
                  break;
                 }
                 ;
                 f = e + j | 0;
                 g = v[b + 20 >> 2] + 2 | 0;
                 a = a >>> 1 | 0;
                 h = a;
                 while (1) {
                  if (h) {
                   u[g >> 1] = w[f | 0] | w[f + 1 | 0] << 8;
                   g = g + 4 | 0;
                   f = f + 2 | 0;
                   h = h - 1 | 0;
                   continue;
                  }
                  break;
                 }
                 ;
                 eb = i + 16 | 0;
                 d = a + d << 1;
                 break u;

                case 1:
                 i = eb - 16 | 0;
                 eb = i;
                 d = v[m + 2216 >> 2];
                 v[i + 12 >> 2] = d;
                 j = v[b >> 2] << 1;
                 v[i + 8 >> 2] = j;
                 a = i + 8 | 0;
                 g = v[Gb(a, i + 12 | 0) >> 2];
                 v[i + 8 >> 2] = j;
                 v[i + 4 >> 2] = d - g;
                 a = v[Gb(a, i + 4 | 0) >> 2];
                 f = v[b + 20 >> 2];
                 d = g >>> 1 | 0;
                 h = d;
                 g = e;
                 while (1) {
                  if (h) {
                   u[f >> 1] = (w[g | 0] | w[g + 1 | 0] << 8) ^ 32768;
                   f = f + 4 | 0;
                   g = g + 2 | 0;
                   h = h - 1 | 0;
                   continue;
                  }
                  break;
                 }
                 ;
                 f = e + j | 0;
                 g = v[b + 20 >> 2] + 2 | 0;
                 a = a >>> 1 | 0;
                 h = a;
                 while (1) {
                  if (h) {
                   u[g >> 1] = (w[f | 0] | w[f + 1 | 0] << 8) ^ 32768;
                   g = g + 4 | 0;
                   f = f + 2 | 0;
                   h = h - 1 | 0;
                   continue;
                  }
                  break;
                 }
                 ;
                 eb = i + 16 | 0;
                 d = a + d << 1;
                 break u;

                default:
                 d = 0;
                 if ((f | 0) != 11) {
                  break u;
                 }
                 break;

                case 2:
                 break W;
                }
               }
               h = v[m + 2216 >> 2];
               f = x[Vk(m + 18 | 0) >> 1];
               E = eb - 16 | 0;
               eb = E;
               v[E + 12 >> 2] = h;
               o = v[b >> 2] << 1;
               v[E + 8 >> 2] = o;
               d = E + 8 | 0;
               g = v[Gb(d, E + 12 | 0) >> 2];
               v[E + 8 >> 2] = o;
               v[E + 4 >> 2] = h - g;
               j = v[Gb(d, E + 4 | 0) >> 2];
               s = v[b + 20 >> 2];
               d = f;
               h = g >>> 1 | 0;
               i = h;
               g = e;
               while (1) {
                if (i) {
                 d = (w[g | 0] + d | 0) + (w[g + 1 | 0] << 8) | 0;
                 u[s >> 1] = d;
                 s = s + 4 | 0;
                 g = g + 2 | 0;
                 i = i - 1 | 0;
                 continue;
                }
                break;
               }
               g = e + o | 0;
               s = v[b + 20 >> 2] + 2 | 0;
               e = j >>> 1 | 0;
               i = e;
               while (1) {
                if (i) {
                 f = (w[g | 0] + f | 0) + (w[g + 1 | 0] << 8) | 0;
                 u[s >> 1] = f;
                 s = s + 4 | 0;
                 g = g + 2 | 0;
                 i = i - 1 | 0;
                 continue;
                }
                break;
               }
               eb = E + 16 | 0;
               d = e + h << 1;
               if (w[a + 3 | 0] != 11) {
                break u;
               }
               a = v[b + 20 >> 2];
               b = a + (v[b >> 2] << 2) | 0;
               while (1) {
                if (a >>> 0 >= b >>> 0) {
                 break u;
                }
                u[a + 2 >> 1] = x[a + 2 >> 1] + x[a >> 1];
                a = a + 4 | 0;
                continue;
               }
              }
              g = d & 255;
              if (!((g | 0) != 16 | w[a + 1 | 0] != 3 | w[a + 2 | 0] != 1)) {
               d = 0;
               X: {
                switch (f | 0) {
                case 0:
                 o = eb - 16 | 0;
                 eb = o;
                 d = v[m + 2216 >> 2];
                 v[o + 12 >> 2] = d;
                 j = v[b >> 2] << 1;
                 v[o + 8 >> 2] = j;
                 a = o + 8 | 0;
                 f = v[Gb(a, o + 12 | 0) >> 2];
                 v[o + 8 >> 2] = j;
                 v[o + 4 >> 2] = d - f;
                 g = v[Gb(a, o + 4 | 0) >> 2];
                 i = v[b + 20 >> 2];
                 d = f >>> 1 | 0;
                 f = d;
                 h = e;
                 while (1) {
                  if (f) {
                   a = w[h | 0] | w[h + 1 | 0] << 8;
                   u[i >> 1] = a << 8 | a >>> 8;
                   i = i + 4 | 0;
                   h = h + 2 | 0;
                   f = f - 1 | 0;
                   continue;
                  }
                  break;
                 }
                 ;
                 i = e + j | 0;
                 h = v[b + 20 >> 2] + 2 | 0;
                 b = g >>> 1 | 0;
                 f = b;
                 while (1) {
                  if (f) {
                   a = w[i | 0] | w[i + 1 | 0] << 8;
                   u[h >> 1] = a << 8 | a >>> 8;
                   h = h + 4 | 0;
                   i = i + 2 | 0;
                   f = f - 1 | 0;
                   continue;
                  }
                  break;
                 }
                 ;
                 eb = o + 16 | 0;
                 d = b + d << 1;
                 break u;

                case 1:
                 o = eb - 16 | 0;
                 eb = o;
                 d = v[m + 2216 >> 2];
                 v[o + 12 >> 2] = d;
                 j = v[b >> 2] << 1;
                 v[o + 8 >> 2] = j;
                 a = o + 8 | 0;
                 f = v[Gb(a, o + 12 | 0) >> 2];
                 v[o + 8 >> 2] = j;
                 v[o + 4 >> 2] = d - f;
                 g = v[Gb(a, o + 4 | 0) >> 2];
                 i = v[b + 20 >> 2];
                 d = f >>> 1 | 0;
                 f = d;
                 h = e;
                 while (1) {
                  if (f) {
                   a = w[h | 0] | w[h + 1 | 0] << 8;
                   u[i >> 1] = (a << 8 | a >>> 8) ^ 32768;
                   i = i + 4 | 0;
                   h = h + 2 | 0;
                   f = f - 1 | 0;
                   continue;
                  }
                  break;
                 }
                 ;
                 i = e + j | 0;
                 h = v[b + 20 >> 2] + 2 | 0;
                 b = g >>> 1 | 0;
                 f = b;
                 while (1) {
                  if (f) {
                   a = w[i | 0] | w[i + 1 | 0] << 8;
                   u[h >> 1] = (a << 8 | a >>> 8) ^ 32768;
                   h = h + 4 | 0;
                   i = i + 2 | 0;
                   f = f - 1 | 0;
                   continue;
                  }
                  break;
                 }
                 ;
                 eb = o + 16 | 0;
                 d = b + d << 1;
                 break u;

                case 2:
                 break X;

                default:
                 break u;
                }
               }
               f = v[m + 2216 >> 2];
               d = x[Vk(m + 16 | 0) >> 1];
               E = eb - 16 | 0;
               eb = E;
               v[E + 12 >> 2] = f;
               o = v[b >> 2] << 1;
               v[E + 8 >> 2] = o;
               a = E + 8 | 0;
               g = v[Gb(a, E + 12 | 0) >> 2];
               v[E + 8 >> 2] = o;
               v[E + 4 >> 2] = f - g;
               j = v[Gb(a, E + 4 | 0) >> 2];
               i = v[b + 20 >> 2];
               a = d;
               h = g >>> 1 | 0;
               f = h;
               g = e;
               while (1) {
                if (f) {
                 a = (w[g + 1 | 0] + a | 0) + (w[g | 0] << 8) | 0;
                 u[i >> 1] = a;
                 i = i + 4 | 0;
                 g = g + 2 | 0;
                 f = f - 1 | 0;
                 continue;
                }
                break;
               }
               g = e + o | 0;
               i = v[b + 20 >> 2] + 2 | 0;
               a = j >>> 1 | 0;
               f = a;
               while (1) {
                if (f) {
                 d = (w[g + 1 | 0] + d | 0) + (w[g | 0] << 8) | 0;
                 u[i >> 1] = d;
                 i = i + 4 | 0;
                 g = g + 2 | 0;
                 f = f - 1 | 0;
                 continue;
                }
                break;
               }
               eb = E + 16 | 0;
               d = a + h << 1;
               break u;
              }
              if (!(w[a + 2 | 0] | ((g | 0) != 16 | w[a + 1 | 0] != 2))) {
               d = 0;
               Y: {
                switch (f | 0) {
                case 0:
                 a = v[b >> 2];
                 f = v[b + 20 >> 2];
                 d = eb - 16 | 0;
                 eb = d;
                 v[d + 12 >> 2] = v[m + 2216 >> 2] >>> 2;
                 v[d + 8 >> 2] = a;
                 a = v[Gb(d + 12 | 0, d + 8 | 0) >> 2];
                 b = a;
                 while (1) {
                  if (b) {
                   u[f >> 1] = w[e | 0] | w[e + 1 | 0] << 8;
                   u[f + 2 >> 1] = w[e + 2 | 0] | w[e + 3 | 0] << 8;
                   f = f + 4 | 0;
                   e = e + 4 | 0;
                   b = b - 1 | 0;
                   continue;
                  }
                  break;
                 }
                 ;
                 eb = d + 16 | 0;
                 d = a << 2;
                 break u;

                case 1:
                 a = v[b >> 2];
                 f = v[b + 20 >> 2];
                 d = eb - 16 | 0;
                 eb = d;
                 v[d + 12 >> 2] = v[m + 2216 >> 2] >>> 2;
                 v[d + 8 >> 2] = a;
                 a = v[Gb(d + 12 | 0, d + 8 | 0) >> 2];
                 b = a;
                 while (1) {
                  if (b) {
                   u[f >> 1] = (w[e | 0] | w[e + 1 | 0] << 8) ^ 32768;
                   u[f + 2 >> 1] = (w[e + 2 | 0] | w[e + 3 | 0] << 8) ^ 32768;
                   f = f + 4 | 0;
                   e = e + 4 | 0;
                   b = b - 1 | 0;
                   continue;
                  }
                  break;
                 }
                 ;
                 eb = d + 16 | 0;
                 d = a << 2;
                 break u;

                case 2:
                 break Y;

                default:
                 break u;
                }
               }
               f = v[m + 2216 >> 2];
               d = Vk(m + 14 | 0);
               a = v[b >> 2];
               g = v[b + 20 >> 2];
               b = x[d >> 1];
               h = eb - 16 | 0;
               eb = h;
               v[h + 12 >> 2] = f >>> 2;
               v[h + 8 >> 2] = a;
               a = b;
               d = v[Gb(h + 12 | 0, h + 8 | 0) >> 2];
               f = d;
               while (1) {
                if (f) {
                 b = (w[e | 0] + b | 0) + (w[e + 1 | 0] << 8) | 0;
                 u[g >> 1] = b;
                 a = (w[e + 2 | 0] + a | 0) + (w[e + 3 | 0] << 8) | 0;
                 u[g + 2 >> 1] = a;
                 g = g + 4 | 0;
                 e = e + 4 | 0;
                 f = f - 1 | 0;
                 continue;
                }
                break;
               }
               eb = h + 16 | 0;
               d = d << 2;
               break u;
              }
              g = d & 255;
              if (!((g | 0) != 16 | w[a + 1 | 0] != 2 | w[a + 2 | 0] != 1)) {
               d = 0;
               Z: {
                switch (f | 0) {
                case 0:
                 a = v[b >> 2];
                 f = v[b + 20 >> 2];
                 g = eb - 16 | 0;
                 eb = g;
                 v[g + 12 >> 2] = v[m + 2216 >> 2] >>> 2;
                 v[g + 8 >> 2] = a;
                 b = v[Gb(g + 12 | 0, g + 8 | 0) >> 2];
                 d = b;
                 while (1) {
                  if (d) {
                   a = w[e | 0] | w[e + 1 | 0] << 8;
                   u[f >> 1] = a << 8 | a >>> 8;
                   a = w[e + 2 | 0] | w[e + 3 | 0] << 8;
                   u[f + 2 >> 1] = a << 8 | a >>> 8;
                   f = f + 4 | 0;
                   e = e + 4 | 0;
                   d = d - 1 | 0;
                   continue;
                  }
                  break;
                 }
                 ;
                 eb = g + 16 | 0;
                 d = b << 2;
                 break u;

                case 1:
                 a = v[b >> 2];
                 f = v[b + 20 >> 2];
                 g = eb - 16 | 0;
                 eb = g;
                 v[g + 12 >> 2] = v[m + 2216 >> 2] >>> 2;
                 v[g + 8 >> 2] = a;
                 b = v[Gb(g + 12 | 0, g + 8 | 0) >> 2];
                 d = b;
                 while (1) {
                  if (d) {
                   a = w[e | 0] | w[e + 1 | 0] << 8;
                   u[f >> 1] = (a << 8 | a >>> 8) ^ 32768;
                   a = w[e + 2 | 0] | w[e + 3 | 0] << 8;
                   u[f + 2 >> 1] = (a << 8 | a >>> 8) ^ 32768;
                   f = f + 4 | 0;
                   e = e + 4 | 0;
                   d = d - 1 | 0;
                   continue;
                  }
                  break;
                 }
                 ;
                 eb = g + 16 | 0;
                 d = b << 2;
                 break u;

                case 2:
                 break Z;

                default:
                 break u;
                }
               }
               f = v[m + 2216 >> 2];
               d = Vk(m + 12 | 0);
               a = v[b >> 2];
               g = v[b + 20 >> 2];
               b = x[d >> 1];
               h = eb - 16 | 0;
               eb = h;
               v[h + 12 >> 2] = f >>> 2;
               v[h + 8 >> 2] = a;
               a = b;
               d = v[Gb(h + 12 | 0, h + 8 | 0) >> 2];
               f = d;
               while (1) {
                if (f) {
                 b = (w[e + 1 | 0] + b | 0) + (w[e | 0] << 8) | 0;
                 u[g >> 1] = b;
                 a = (w[e + 3 | 0] + a | 0) + (w[e + 2 | 0] << 8) | 0;
                 u[g + 2 >> 1] = a;
                 g = g + 4 | 0;
                 e = e + 4 | 0;
                 f = f - 1 | 0;
                 continue;
                }
                break;
               }
               eb = h + 16 | 0;
               d = d << 2;
               break u;
              }
              if (!(f | w[a + 1 | 0] != 1 | (g | 0) != 24)) {
               d = v[b + 20 >> 2];
               g = v[b >> 2];
               b = v[m + 2216 >> 2];
               if (!w[a + 2 | 0]) {
                f = eb - 16 | 0;
                eb = f;
                v[f + 12 >> 2] = (b >>> 0) / 3;
                v[f + 8 >> 2] = g;
                a = v[Gb(f + 12 | 0, f + 8 | 0) >> 2];
                b = a;
                while (1) {
                 if (b) {
                  N = d, U = qd(w[e + 1 | 0] << 16 | w[e | 0] << 8 | w[e + 2 | 0] << 24, 16), u[N >> 1] = U;
                  d = d + 2 | 0;
                  e = e + 3 | 0;
                  b = b - 1 | 0;
                  continue;
                 }
                 break;
                }
                eb = f + 16 | 0;
                d = B(a, 3);
                break u;
               }
               f = eb - 16 | 0;
               eb = f;
               v[f + 12 >> 2] = (b >>> 0) / 3;
               v[f + 8 >> 2] = g;
               a = v[Gb(f + 12 | 0, f + 8 | 0) >> 2];
               b = a;
               while (1) {
                if (b) {
                 N = d, U = qd(w[e + 1 | 0] << 16 | w[e + 2 | 0] << 8 | w[e | 0] << 24, 16), u[N >> 1] = U;
                 d = d + 2 | 0;
                 e = e + 3 | 0;
                 b = b - 1 | 0;
                 continue;
                }
                break;
               }
               eb = f + 16 | 0;
               d = B(a, 3);
               break u;
              }
              g = d & 255;
              if (!(f | w[a + 1 | 0] != 2 | (g | 0) != 24)) {
               d = v[b + 20 >> 2];
               g = v[b >> 2];
               b = v[m + 2216 >> 2];
               if (!w[a + 2 | 0]) {
                f = eb - 16 | 0;
                eb = f;
                v[f + 12 >> 2] = (b >>> 0) / 6;
                v[f + 8 >> 2] = g;
                a = v[Gb(f + 12 | 0, f + 8 | 0) >> 2];
                b = a;
                while (1) {
                 if (b) {
                  N = d, U = qd(w[e + 1 | 0] << 16 | w[e | 0] << 8 | w[e + 2 | 0] << 24, 16), u[N >> 1] = U;
                  N = d, U = qd(w[e + 4 | 0] << 16 | w[e + 3 | 0] << 8 | w[e + 5 | 0] << 24, 16), 
                  u[N + 2 >> 1] = U;
                  d = d + 4 | 0;
                  e = e + 6 | 0;
                  b = b - 1 | 0;
                  continue;
                 }
                 break;
                }
                eb = f + 16 | 0;
                d = B(a, 6);
                break u;
               }
               f = eb - 16 | 0;
               eb = f;
               v[f + 12 >> 2] = (b >>> 0) / 6;
               v[f + 8 >> 2] = g;
               a = v[Gb(f + 12 | 0, f + 8 | 0) >> 2];
               b = a;
               while (1) {
                if (b) {
                 N = d, U = qd(w[e + 1 | 0] << 16 | w[e + 2 | 0] << 8 | w[e | 0] << 24, 16), u[N >> 1] = U;
                 N = d, U = qd(w[e + 4 | 0] << 16 | w[e + 5 | 0] << 8 | w[e + 3 | 0] << 24, 16), 
                 u[N + 2 >> 1] = U;
                 d = d + 4 | 0;
                 e = e + 6 | 0;
                 b = b - 1 | 0;
                 continue;
                }
                break;
               }
               eb = f + 16 | 0;
               d = B(a, 6);
               break u;
              }
              if (!(f | w[a + 1 | 0] != 1 | (g | 0) != 32)) {
               d = v[b + 20 >> 2];
               g = v[b >> 2];
               b = v[m + 2216 >> 2];
               if (!w[a + 2 | 0]) {
                f = eb - 16 | 0;
                eb = f;
                v[f + 12 >> 2] = b >>> 2;
                v[f + 8 >> 2] = g;
                a = v[Gb(f + 12 | 0, f + 8 | 0) >> 2];
                b = a;
                while (1) {
                 if (b) {
                  N = d, U = qd(w[e | 0] | w[e + 1 | 0] << 8 | (w[e + 2 | 0] << 16 | w[e + 3 | 0] << 24), 16), 
                  u[N >> 1] = U;
                  d = d + 2 | 0;
                  e = e + 4 | 0;
                  b = b - 1 | 0;
                  continue;
                 }
                 break;
                }
                eb = f + 16 | 0;
                d = a << 2;
                break u;
               }
               h = eb - 16 | 0;
               eb = h;
               v[h + 12 >> 2] = b >>> 2;
               v[h + 8 >> 2] = g;
               a = v[Gb(h + 12 | 0, h + 8 | 0) >> 2];
               f = a;
               while (1) {
                if (f) {
                 b = w[e | 0] | w[e + 1 | 0] << 8 | (w[e + 2 | 0] << 16 | w[e + 3 | 0] << 24);
                 N = d, U = qd(b << 24 | (b & 65280) << 8 | (b >>> 8 & 65280 | b >>> 24), 16), u[N >> 1] = U;
                 d = d + 2 | 0;
                 e = e + 4 | 0;
                 f = f - 1 | 0;
                 continue;
                }
                break;
               }
               eb = h + 16 | 0;
               d = a << 2;
               break u;
              }
              g = d & 255;
              if (!(f | w[a + 1 | 0] != 2 | (g | 0) != 32)) {
               d = v[b + 20 >> 2];
               g = v[b >> 2];
               b = v[m + 2216 >> 2];
               if (!w[a + 2 | 0]) {
                f = eb - 16 | 0;
                eb = f;
                v[f + 12 >> 2] = b >>> 3;
                v[f + 8 >> 2] = g;
                a = v[Gb(f + 12 | 0, f + 8 | 0) >> 2];
                b = a;
                while (1) {
                 if (b) {
                  N = d, U = qd(w[e | 0] | w[e + 1 | 0] << 8 | (w[e + 2 | 0] << 16 | w[e + 3 | 0] << 24), 16), 
                  u[N >> 1] = U;
                  N = d, U = qd(w[e + 4 | 0] | w[e + 5 | 0] << 8 | (w[e + 6 | 0] << 16 | w[e + 7 | 0] << 24), 16), 
                  u[N + 2 >> 1] = U;
                  d = d + 4 | 0;
                  e = e + 8 | 0;
                  b = b - 1 | 0;
                  continue;
                 }
                 break;
                }
                eb = f + 16 | 0;
                d = a << 3;
                break u;
               }
               h = eb - 16 | 0;
               eb = h;
               v[h + 12 >> 2] = b >>> 3;
               v[h + 8 >> 2] = g;
               a = v[Gb(h + 12 | 0, h + 8 | 0) >> 2];
               f = a;
               while (1) {
                if (f) {
                 b = w[e | 0] | w[e + 1 | 0] << 8 | (w[e + 2 | 0] << 16 | w[e + 3 | 0] << 24);
                 N = d, U = qd(b << 24 | (b & 65280) << 8 | (b >>> 8 & 65280 | b >>> 24), 16), u[N >> 1] = U;
                 b = w[e + 4 | 0] | w[e + 5 | 0] << 8 | (w[e + 6 | 0] << 16 | w[e + 7 | 0] << 24);
                 N = d, U = qd(b << 24 | (b & 65280) << 8 | (b >>> 8 & 65280 | b >>> 24), 16), u[N + 2 >> 1] = U;
                 d = d + 4 | 0;
                 e = e + 8 | 0;
                 f = f - 1 | 0;
                 continue;
                }
                break;
               }
               eb = h + 16 | 0;
               d = a << 3;
               break u;
              }
              if (!(f | w[a + 1 | 0] != 1 | (g | 0) != 64)) {
               d = v[b + 20 >> 2];
               g = v[b >> 2];
               b = v[m + 2216 >> 2];
               if (!w[a + 2 | 0]) {
                f = eb - 16 | 0;
                eb = f;
                v[f + 12 >> 2] = b >>> 3;
                v[f + 8 >> 2] = g;
                a = v[Gb(f + 12 | 0, f + 8 | 0) >> 2];
                b = a;
                while (1) {
                 if (b) {
                  N = d, U = Rc(w[e | 0] | w[e + 1 | 0] << 8 | (w[e + 2 | 0] << 16 | w[e + 3 | 0] << 24), w[e + 4 | 0] | w[e + 5 | 0] << 8 | (w[e + 6 | 0] << 16 | w[e + 7 | 0] << 24), 48), 
                  u[N >> 1] = U;
                  d = d + 2 | 0;
                  e = e + 8 | 0;
                  b = b - 1 | 0;
                  continue;
                 }
                 break;
                }
                eb = f + 16 | 0;
                d = a << 3;
                break u;
               }
               o = eb - 16 | 0;
               eb = o;
               v[o + 12 >> 2] = b >>> 3;
               v[o + 8 >> 2] = g;
               h = v[Gb(o + 12 | 0, o + 8 | 0) >> 2];
               b = h;
               while (1) {
                if (b) {
                 i = w[e | 0] | w[e + 1 | 0] << 8 | (w[e + 2 | 0] << 16 | w[e + 3 | 0] << 24);
                 f = i << 24 | (i & 65280) << 8;
                 a = i & -16777216;
                 g = a >>> 24 | 0;
                 s = a << 8;
                 a = i & 16711680;
                 j = w[e + 4 | 0] | w[e + 5 | 0] << 8 | (w[e + 6 | 0] << 16 | w[e + 7 | 0] << 24);
                 N = d, U = Rc(s | a << 24 | (((j & 255) << 24 | i >>> 8) & -16777216 | ((j & 16777215) << 8 | i >>> 24) & 16711680 | (j >>> 8 & 65280 | j >>> 24)), f | (g | a >>> 8), 48), 
                 u[N >> 1] = U;
                 d = d + 2 | 0;
                 e = e + 8 | 0;
                 b = b - 1 | 0;
                 continue;
                }
                break;
               }
               eb = o + 16 | 0;
               d = h << 3;
               break u;
              }
              g = d & 255;
              if (!(f | w[a + 1 | 0] != 2 | (g | 0) != 64)) {
               d = v[b + 20 >> 2];
               g = v[b >> 2];
               b = v[m + 2216 >> 2];
               if (!w[a + 2 | 0]) {
                f = eb - 16 | 0;
                eb = f;
                v[f + 12 >> 2] = b >>> 4;
                v[f + 8 >> 2] = g;
                a = v[Gb(f + 12 | 0, f + 8 | 0) >> 2];
                b = a;
                while (1) {
                 if (b) {
                  N = d, U = Rc(w[e | 0] | w[e + 1 | 0] << 8 | (w[e + 2 | 0] << 16 | w[e + 3 | 0] << 24), w[e + 4 | 0] | w[e + 5 | 0] << 8 | (w[e + 6 | 0] << 16 | w[e + 7 | 0] << 24), 48), 
                  u[N >> 1] = U;
                  N = d, U = Rc(w[e + 8 | 0] | w[e + 9 | 0] << 8 | (w[e + 10 | 0] << 16 | w[e + 11 | 0] << 24), w[e + 12 | 0] | w[e + 13 | 0] << 8 | (w[e + 14 | 0] << 16 | w[e + 15 | 0] << 24), 48), 
                  u[N + 2 >> 1] = U;
                  d = d + 4 | 0;
                  e = e + 16 | 0;
                  b = b - 1 | 0;
                  continue;
                 }
                 break;
                }
                eb = f + 16 | 0;
                d = a << 4;
                break u;
               }
               o = eb - 16 | 0;
               eb = o;
               v[o + 12 >> 2] = b >>> 4;
               v[o + 8 >> 2] = g;
               h = v[Gb(o + 12 | 0, o + 8 | 0) >> 2];
               b = h;
               while (1) {
                if (b) {
                 i = w[e | 0] | w[e + 1 | 0] << 8 | (w[e + 2 | 0] << 16 | w[e + 3 | 0] << 24);
                 f = i << 24 | (i & 65280) << 8;
                 a = i & -16777216;
                 g = a >>> 24 | 0;
                 s = a << 8;
                 a = i & 16711680;
                 j = w[e + 4 | 0] | w[e + 5 | 0] << 8 | (w[e + 6 | 0] << 16 | w[e + 7 | 0] << 24);
                 N = d, U = Rc(s | a << 24 | (((j & 255) << 24 | i >>> 8) & -16777216 | ((j & 16777215) << 8 | i >>> 24) & 16711680 | (j >>> 8 & 65280 | j >>> 24)), f | (g | a >>> 8), 48), 
                 u[N >> 1] = U;
                 i = w[e + 8 | 0] | w[e + 9 | 0] << 8 | (w[e + 10 | 0] << 16 | w[e + 11 | 0] << 24);
                 f = i << 24 | (i & 65280) << 8;
                 a = i & -16777216;
                 g = a >>> 24 | 0;
                 s = a << 8;
                 a = i & 16711680;
                 j = w[e + 12 | 0] | w[e + 13 | 0] << 8 | (w[e + 14 | 0] << 16 | w[e + 15 | 0] << 24);
                 N = d, U = Rc(s | a << 24 | (((j & 255) << 24 | i >>> 8) & -16777216 | ((j & 16777215) << 8 | i >>> 24) & 16711680 | (j >>> 8 & 65280 | j >>> 24)), f | (g | a >>> 8), 48), 
                 u[N + 2 >> 1] = U;
                 d = d + 4 | 0;
                 e = e + 16 | 0;
                 b = b - 1 | 0;
                 continue;
                }
                break;
               }
               eb = o + 16 | 0;
               d = h << 4;
               break u;
              }
              if (!(w[a + 1 | 0] != 1 | (f | 0) != 3 | (g | 0) != 32)) {
               d = v[b + 20 >> 2];
               g = v[b >> 2];
               b = v[m + 2216 >> 2];
               if (!w[a + 2 | 0]) {
                f = eb - 16 | 0;
                eb = f;
                v[f + 12 >> 2] = b >>> 2;
                v[f + 8 >> 2] = g;
                a = v[Gb(f + 12 | 0, f + 8 | 0) >> 2];
                b = a;
                while (1) {
                 if (b) {
                  k = $f((l(2, w[e | 0] | w[e + 1 | 0] << 8 | (w[e + 2 | 0] << 16 | w[e + 3 | 0] << 24)), 
                  r()));
                  k = ki(C(Od(Jg(k) ? k >= C(0) ? C(1) : C(-1) : k, C(-1)) * C(32768)));
                  _: {
                   if (C(D(k)) < C(2147483648)) {
                    h = ~~k;
                    break _;
                   }
                   h = -2147483648;
                  }
                  N = d, U = fd(h), u[N >> 1] = U;
                  d = d + 2 | 0;
                  e = e + 4 | 0;
                  b = b - 1 | 0;
                  continue;
                 }
                 break;
                }
                eb = f + 16 | 0;
                d = a << 2;
                break u;
               }
               h = eb - 16 | 0;
               eb = h;
               v[h + 12 >> 2] = b >>> 2;
               v[h + 8 >> 2] = g;
               a = v[Gb(h + 12 | 0, h + 8 | 0) >> 2];
               f = a;
               while (1) {
                if (f) {
                 b = w[e | 0] | w[e + 1 | 0] << 8 | (w[e + 2 | 0] << 16 | w[e + 3 | 0] << 24);
                 k = $f((l(2, b << 24 | (b & 65280) << 8 | (b >>> 8 & 65280 | b >>> 24)), r()));
                 k = ki(C(Od(Jg(k) ? k >= C(0) ? C(1) : C(-1) : k, C(-1)) * C(32768)));
                 $: {
                  if (C(D(k)) < C(2147483648)) {
                   b = ~~k;
                   break $;
                  }
                  b = -2147483648;
                 }
                 N = d, U = fd(b), u[N >> 1] = U;
                 d = d + 2 | 0;
                 e = e + 4 | 0;
                 f = f - 1 | 0;
                 continue;
                }
                break;
               }
               eb = h + 16 | 0;
               d = a << 2;
               break u;
              }
              g = d & 255;
              if (!(w[a + 1 | 0] != 2 | (f | 0) != 3 | (g | 0) != 32)) {
               d = v[b + 20 >> 2];
               g = v[b >> 2];
               b = v[m + 2216 >> 2];
               if (!w[a + 2 | 0]) {
                f = eb - 16 | 0;
                eb = f;
                v[f + 12 >> 2] = b >>> 3;
                v[f + 8 >> 2] = g;
                a = v[Gb(f + 12 | 0, f + 8 | 0) >> 2];
                b = a;
                while (1) {
                 if (b) {
                  k = $f((l(2, w[e | 0] | w[e + 1 | 0] << 8 | (w[e + 2 | 0] << 16 | w[e + 3 | 0] << 24)), 
                  r()));
                  k = ki(C(Od(Jg(k) ? k >= C(0) ? C(1) : C(-1) : k, C(-1)) * C(32768)));
                  aa: {
                   if (C(D(k)) < C(2147483648)) {
                    h = ~~k;
                    break aa;
                   }
                   h = -2147483648;
                  }
                  N = d, U = fd(h), u[N >> 1] = U;
                  k = $f((l(2, w[e + 4 | 0] | w[e + 5 | 0] << 8 | (w[e + 6 | 0] << 16 | w[e + 7 | 0] << 24)), 
                  r()));
                  k = ki(C(Od(Jg(k) ? k >= C(0) ? C(1) : C(-1) : k, C(-1)) * C(32768)));
                  ba: {
                   if (C(D(k)) < C(2147483648)) {
                    h = ~~k;
                    break ba;
                   }
                   h = -2147483648;
                  }
                  N = d, U = fd(h), u[N + 2 >> 1] = U;
                  d = d + 4 | 0;
                  e = e + 8 | 0;
                  b = b - 1 | 0;
                  continue;
                 }
                 break;
                }
                eb = f + 16 | 0;
                d = a << 3;
                break u;
               }
               h = eb - 16 | 0;
               eb = h;
               v[h + 12 >> 2] = b >>> 3;
               v[h + 8 >> 2] = g;
               a = v[Gb(h + 12 | 0, h + 8 | 0) >> 2];
               f = a;
               while (1) {
                if (f) {
                 b = w[e | 0] | w[e + 1 | 0] << 8 | (w[e + 2 | 0] << 16 | w[e + 3 | 0] << 24);
                 k = $f((l(2, b << 24 | (b & 65280) << 8 | (b >>> 8 & 65280 | b >>> 24)), r()));
                 k = ki(C(Od(Jg(k) ? k >= C(0) ? C(1) : C(-1) : k, C(-1)) * C(32768)));
                 ca: {
                  if (C(D(k)) < C(2147483648)) {
                   b = ~~k;
                   break ca;
                  }
                  b = -2147483648;
                 }
                 N = d, U = fd(b), u[N >> 1] = U;
                 b = w[e + 4 | 0] | w[e + 5 | 0] << 8 | (w[e + 6 | 0] << 16 | w[e + 7 | 0] << 24);
                 k = $f((l(2, b << 24 | (b & 65280) << 8 | (b >>> 8 & 65280 | b >>> 24)), r()));
                 k = ki(C(Od(Jg(k) ? k >= C(0) ? C(1) : C(-1) : k, C(-1)) * C(32768)));
                 da: {
                  if (C(D(k)) < C(2147483648)) {
                   b = ~~k;
                   break da;
                  }
                  b = -2147483648;
                 }
                 N = d, U = fd(b), u[N + 2 >> 1] = U;
                 d = d + 4 | 0;
                 e = e + 8 | 0;
                 f = f - 1 | 0;
                 continue;
                }
                break;
               }
               eb = h + 16 | 0;
               d = a << 3;
               break u;
              }
              if (!(w[a + 1 | 0] != 1 | (f | 0) != 3 | (g | 0) != 64)) {
               d = v[b + 20 >> 2];
               g = v[b >> 2];
               b = v[m + 2216 >> 2];
               if (!w[a + 2 | 0]) {
                f = eb - 32 | 0;
                eb = f;
                v[f + 24 >> 2] = b >>> 3;
                v[f + 16 >> 2] = g;
                g = v[Gb(f + 24 | 0, f + 16 | 0) >> 2];
                b = g;
                while (1) {
                 if (b) {
                  a = w[e + 4 | 0] | w[e + 5 | 0] << 8 | (w[e + 6 | 0] << 16 | w[e + 7 | 0] << 24);
                  l(0, w[e | 0] | w[e + 1 | 0] << 8 | (w[e + 2 | 0] << 16 | w[e + 3 | 0] << 24));
                  l(1, a | 0);
                  q = Ig(+n());
                  N = f, V = zf(q) ? q >= 0 ? 1 : -1 : q, A[N + 24 >> 3] = V;
                  v[f + 16 >> 2] = 0;
                  v[f + 20 >> 2] = -1074790400;
                  v[f + 8 >> 2] = 0;
                  v[f + 12 >> 2] = 1072693248;
                  q = Ee(A[Xg(f + 24 | 0, f + 16 | 0, f + 8 | 0) >> 3] * 32768);
                  ea: {
                   if (D(q) < 2147483648) {
                    a = ~~q;
                    break ea;
                   }
                   a = -2147483648;
                  }
                  N = d, U = fd(a), u[N >> 1] = U;
                  d = d + 2 | 0;
                  e = e + 8 | 0;
                  b = b - 1 | 0;
                  continue;
                 }
                 break;
                }
                eb = f + 32 | 0;
                d = g << 3;
                break u;
               }
               o = eb - 32 | 0;
               eb = o;
               v[o + 24 >> 2] = b >>> 3;
               v[o + 16 >> 2] = g;
               h = v[Gb(o + 24 | 0, o + 16 | 0) >> 2];
               b = h;
               while (1) {
                if (b) {
                 i = w[e | 0] | w[e + 1 | 0] << 8 | (w[e + 2 | 0] << 16 | w[e + 3 | 0] << 24);
                 f = i << 24 | (i & 65280) << 8;
                 a = i & -16777216;
                 g = a >>> 24 | 0;
                 s = a << 8;
                 a = i & 16711680;
                 j = w[e + 4 | 0] | w[e + 5 | 0] << 8 | (w[e + 6 | 0] << 16 | w[e + 7 | 0] << 24);
                 l(0, s | a << 24 | (((j & 255) << 24 | i >>> 8) & -16777216 | ((j & 16777215) << 8 | i >>> 24) & 16711680 | (j >>> 8 & 65280 | j >>> 24)));
                 l(1, f | (g | a >>> 8));
                 q = Ig(+n());
                 N = o, V = zf(q) ? q >= 0 ? 1 : -1 : q, A[N + 24 >> 3] = V;
                 v[o + 16 >> 2] = 0;
                 v[o + 20 >> 2] = -1074790400;
                 v[o + 8 >> 2] = 0;
                 v[o + 12 >> 2] = 1072693248;
                 q = Ee(A[Xg(o + 24 | 0, o + 16 | 0, o + 8 | 0) >> 3] * 32768);
                 fa: {
                  if (D(q) < 2147483648) {
                   a = ~~q;
                   break fa;
                  }
                  a = -2147483648;
                 }
                 N = d, U = fd(a), u[N >> 1] = U;
                 d = d + 2 | 0;
                 e = e + 8 | 0;
                 b = b - 1 | 0;
                 continue;
                }
                break;
               }
               eb = o + 32 | 0;
               d = h << 3;
               break u;
              }
              g = d & 255;
              if (!(w[a + 1 | 0] != 2 | (f | 0) != 3 | (g | 0) != 64)) {
               d = v[b + 20 >> 2];
               g = v[b >> 2];
               b = v[m + 2216 >> 2];
               if (!w[a + 2 | 0]) {
                f = eb - 32 | 0;
                eb = f;
                v[f + 24 >> 2] = b >>> 4;
                v[f + 16 >> 2] = g;
                g = v[Gb(f + 24 | 0, f + 16 | 0) >> 2];
                b = g;
                while (1) {
                 if (b) {
                  a = w[e + 4 | 0] | w[e + 5 | 0] << 8 | (w[e + 6 | 0] << 16 | w[e + 7 | 0] << 24);
                  l(0, w[e | 0] | w[e + 1 | 0] << 8 | (w[e + 2 | 0] << 16 | w[e + 3 | 0] << 24));
                  l(1, a | 0);
                  q = Ig(+n());
                  N = f, V = zf(q) ? q >= 0 ? 1 : -1 : q, A[N + 24 >> 3] = V;
                  v[f + 16 >> 2] = 0;
                  v[f + 20 >> 2] = -1074790400;
                  v[f + 8 >> 2] = 0;
                  v[f + 12 >> 2] = 1072693248;
                  q = Ee(A[Xg(f + 24 | 0, f + 16 | 0, f + 8 | 0) >> 3] * 32768);
                  ga: {
                   if (D(q) < 2147483648) {
                    a = ~~q;
                    break ga;
                   }
                   a = -2147483648;
                  }
                  N = d, U = fd(a), u[N >> 1] = U;
                  a = w[e + 12 | 0] | w[e + 13 | 0] << 8 | (w[e + 14 | 0] << 16 | w[e + 15 | 0] << 24);
                  l(0, w[e + 8 | 0] | w[e + 9 | 0] << 8 | (w[e + 10 | 0] << 16 | w[e + 11 | 0] << 24));
                  l(1, a | 0);
                  q = Ig(+n());
                  N = f, V = zf(q) ? q >= 0 ? 1 : -1 : q, A[N + 24 >> 3] = V;
                  v[f + 16 >> 2] = 0;
                  v[f + 20 >> 2] = -1074790400;
                  v[f + 8 >> 2] = 0;
                  v[f + 12 >> 2] = 1072693248;
                  q = Ee(A[Xg(f + 24 | 0, f + 16 | 0, f + 8 | 0) >> 3] * 32768);
                  ha: {
                   if (D(q) < 2147483648) {
                    a = ~~q;
                    break ha;
                   }
                   a = -2147483648;
                  }
                  N = d, U = fd(a), u[N + 2 >> 1] = U;
                  d = d + 4 | 0;
                  e = e + 16 | 0;
                  b = b - 1 | 0;
                  continue;
                 }
                 break;
                }
                eb = f + 32 | 0;
                d = g << 4;
                break u;
               }
               o = eb - 32 | 0;
               eb = o;
               v[o + 24 >> 2] = b >>> 4;
               v[o + 16 >> 2] = g;
               h = v[Gb(o + 24 | 0, o + 16 | 0) >> 2];
               b = h;
               while (1) {
                if (b) {
                 i = w[e | 0] | w[e + 1 | 0] << 8 | (w[e + 2 | 0] << 16 | w[e + 3 | 0] << 24);
                 f = i << 24 | (i & 65280) << 8;
                 a = i & -16777216;
                 g = a >>> 24 | 0;
                 s = a << 8;
                 a = i & 16711680;
                 j = w[e + 4 | 0] | w[e + 5 | 0] << 8 | (w[e + 6 | 0] << 16 | w[e + 7 | 0] << 24);
                 l(0, s | a << 24 | (((j & 255) << 24 | i >>> 8) & -16777216 | ((j & 16777215) << 8 | i >>> 24) & 16711680 | (j >>> 8 & 65280 | j >>> 24)));
                 l(1, f | (g | a >>> 8));
                 q = Ig(+n());
                 N = o, V = zf(q) ? q >= 0 ? 1 : -1 : q, A[N + 24 >> 3] = V;
                 v[o + 16 >> 2] = 0;
                 v[o + 20 >> 2] = -1074790400;
                 v[o + 8 >> 2] = 0;
                 v[o + 12 >> 2] = 1072693248;
                 q = Ee(A[Xg(o + 24 | 0, o + 16 | 0, o + 8 | 0) >> 3] * 32768);
                 ia: {
                  if (D(q) < 2147483648) {
                   a = ~~q;
                   break ia;
                  }
                  a = -2147483648;
                 }
                 N = d, U = fd(a), u[N >> 1] = U;
                 i = w[e + 8 | 0] | w[e + 9 | 0] << 8 | (w[e + 10 | 0] << 16 | w[e + 11 | 0] << 24);
                 f = i << 24 | (i & 65280) << 8;
                 a = i & -16777216;
                 g = a >>> 24 | 0;
                 s = a << 8;
                 a = i & 16711680;
                 j = w[e + 12 | 0] | w[e + 13 | 0] << 8 | (w[e + 14 | 0] << 16 | w[e + 15 | 0] << 24);
                 l(0, s | a << 24 | (((j & 255) << 24 | i >>> 8) & -16777216 | ((j & 16777215) << 8 | i >>> 24) & 16711680 | (j >>> 8 & 65280 | j >>> 24)));
                 l(1, f | (g | a >>> 8));
                 q = Ig(+n());
                 N = o, V = zf(q) ? q >= 0 ? 1 : -1 : q, A[N + 24 >> 3] = V;
                 v[o + 16 >> 2] = 0;
                 v[o + 20 >> 2] = -1074790400;
                 v[o + 8 >> 2] = 0;
                 v[o + 12 >> 2] = 1072693248;
                 q = Ee(A[Xg(o + 24 | 0, o + 16 | 0, o + 8 | 0) >> 3] * 32768);
                 ja: {
                  if (D(q) < 2147483648) {
                   a = ~~q;
                   break ja;
                  }
                  a = -2147483648;
                 }
                 N = d, U = fd(a), u[N + 2 >> 1] = U;
                 d = d + 4 | 0;
                 e = e + 16 | 0;
                 b = b - 1 | 0;
                 continue;
                }
                break;
               }
               eb = o + 32 | 0;
               d = h << 4;
               break u;
              }
              ka: {
               if ((g | 0) == 24) {
                if ((f | 0) != 15 | (w[a + 1 | 0] - 1 & 255) >>> 0 > 1) {
                 break ka;
                }
                v[m + 48 >> 2] = -2147483648;
                d = v[m + 2216 >> 2];
                la: {
                 if (!w[a + 2 | 0]) {
                  E = m + 48 | 0;
                  f = 0;
                  s = eb - 16 | 0;
                  eb = s;
                  N = s, U = B(v[b >> 2], Zd(x[b + 34 >> 1])), v[N + 12 >> 2] = U;
                  wc(s + 12 | 0, (d >>> 0) / 3 | 0);
                  d = e;
                  h = v[s + 12 >> 2];
                  g = h;
                  while (1) {
                   if (g) {
                    i = w[d + 1 | 0] << 16 | w[d | 0] << 8 | w[d + 2 | 0] << 24;
                    ma: {
                     if ((i | 0) < 0) {
                      a = -2147483648;
                      if ((i | 0) == -2147483648) {
                       break ma;
                      }
                      i = 0 - i | 0;
                     }
                     a = f >>> 0 < i >>> 0 ? i : f;
                    }
                    f = a;
                    g = g - 1 | 0;
                    d = d + 3 | 0;
                    continue;
                   } else {
                    na: {
                     if (!f) {
                      break na;
                     }
                     o = f - 1 | 0;
                     j = f >>> 1 | 0;
                     i = v[b + 20 >> 2];
                     d = h;
                     while (1) {
                      if (!d) {
                       break na;
                      }
                      a = w[e + 1 | 0] << 16 | w[e | 0] << 8 | w[e + 2 | 0] << 24;
                      g = a & -2147483648 | a >>> 1;
                      a = j | a << 31;
                      oa: {
                       if ((g | 0) > 0 | (g | 0) >= 0) {
                        a = Cua(a, g, f, 0);
                        g = gb;
                        break oa;
                       }
                       g = Cua(o - a | 0, 0 - ((a >>> 0 > o >>> 0) + g | 0) | 0, f, 0);
                       a = 0 - g | 0;
                       g = 0 - (gb + ((g | 0) != 0) | 0) | 0;
                      }
                      N = i, U = qd(Fc(a, g), 16), u[N >> 1] = U;
                      d = d - 1 | 0;
                      e = e + 3 | 0;
                      i = i + 2 | 0;
                      continue;
                     }
                    }
                   }
                   break;
                  }
                  if (E) {
                   v[E >> 2] = f;
                  }
                  eb = s + 16 | 0;
                  d = B(h, 3);
                  break la;
                 }
                 E = m + 48 | 0;
                 f = 0;
                 s = eb - 16 | 0;
                 eb = s;
                 N = s, U = B(v[b >> 2], Zd(x[b + 34 >> 1])), v[N + 12 >> 2] = U;
                 wc(s + 12 | 0, (d >>> 0) / 3 | 0);
                 d = e;
                 h = v[s + 12 >> 2];
                 g = h;
                 while (1) {
                  if (g) {
                   i = w[d + 1 | 0] << 16 | w[d + 2 | 0] << 8 | w[d | 0] << 24;
                   pa: {
                    if ((i | 0) < 0) {
                     a = -2147483648;
                     if ((i | 0) == -2147483648) {
                      break pa;
                     }
                     i = 0 - i | 0;
                    }
                    a = f >>> 0 < i >>> 0 ? i : f;
                   }
                   f = a;
                   g = g - 1 | 0;
                   d = d + 3 | 0;
                   continue;
                  } else {
                   qa: {
                    if (!f) {
                     break qa;
                    }
                    o = f - 1 | 0;
                    j = f >>> 1 | 0;
                    i = v[b + 20 >> 2];
                    d = h;
                    while (1) {
                     if (!d) {
                      break qa;
                     }
                     a = w[e + 1 | 0] << 16 | w[e + 2 | 0] << 8 | w[e | 0] << 24;
                     g = a & -2147483648 | a >>> 1;
                     a = j | a << 31;
                     ra: {
                      if ((g | 0) > 0 | (g | 0) >= 0) {
                       a = Cua(a, g, f, 0);
                       g = gb;
                       break ra;
                      }
                      g = Cua(o - a | 0, 0 - ((a >>> 0 > o >>> 0) + g | 0) | 0, f, 0);
                      a = 0 - g | 0;
                      g = 0 - (gb + ((g | 0) != 0) | 0) | 0;
                     }
                     N = i, U = qd(Fc(a, g), 16), u[N >> 1] = U;
                     d = d - 1 | 0;
                     e = e + 3 | 0;
                     i = i + 2 | 0;
                     continue;
                    }
                   }
                  }
                  break;
                 }
                 if (E) {
                  v[E >> 2] = f;
                 }
                 eb = s + 16 | 0;
                 d = B(h, 3);
                }
                if (!d) {
                 break u;
                }
                a = v[m + 48 >> 2];
                if ((a | 0) == -2147483648) {
                 break u;
                }
                e = Aua(x[b + 32 >> 1], 0, a, 0);
                a = gb;
                e = e + 1073741824 | 0;
                a = e >>> 0 < 1073741824 ? a + 1 | 0 : a;
                N = b, U = Kd(Ac((a & 2147483647) << 1 | e >>> 31, a >>> 31 | 0), 1, 64), u[N + 32 >> 1] = U;
                u[b + 34 >> 1] = x[b + 34 >> 1] | 8192;
                break u;
               }
               g = d & 255;
               if ((g | 0) == 32) {
                if (!((f | 0) != 15 | (w[a + 1 | 0] - 1 & 255) >>> 0 > 1)) {
                 v[m + 48 >> 2] = -2147483648;
                 d = v[m + 2216 >> 2];
                 sa: {
                  if (!w[a + 2 | 0]) {
                   E = m + 48 | 0;
                   s = eb - 16 | 0;
                   eb = s;
                   N = s, U = B(v[b >> 2], Zd(x[b + 34 >> 1])), v[N + 12 >> 2] = U;
                   wc(s + 12 | 0, d >>> 2 | 0);
                   g = e;
                   h = v[s + 12 >> 2];
                   f = h;
                   while (1) {
                    if (f) {
                     d = w[g | 0] | w[g + 1 | 0] << 8 | (w[g + 2 | 0] << 16 | w[g + 3 | 0] << 24);
                     ta: {
                      if ((d | 0) < 0) {
                       a = -2147483648;
                       if ((d | 0) == -2147483648) {
                        break ta;
                       }
                       d = 0 - d | 0;
                      }
                      a = d >>> 0 > i >>> 0 ? d : i;
                     }
                     i = a;
                     f = f - 1 | 0;
                     g = g + 4 | 0;
                     continue;
                    } else {
                     ua: {
                      if (!i) {
                       break ua;
                      }
                      o = i - 1 | 0;
                      j = i >>> 1 | 0;
                      f = v[b + 20 >> 2];
                      d = h;
                      while (1) {
                       if (!d) {
                        break ua;
                       }
                       a = w[e | 0] | w[e + 1 | 0] << 8 | (w[e + 2 | 0] << 16 | w[e + 3 | 0] << 24);
                       g = a & -2147483648 | a >>> 1;
                       a = j | a << 31;
                       va: {
                        if ((g | 0) > 0 | (g | 0) >= 0) {
                         a = Cua(a, g, i, 0);
                         g = gb;
                         break va;
                        }
                        g = Cua(o - a | 0, 0 - ((a >>> 0 > o >>> 0) + g | 0) | 0, i, 0);
                        a = 0 - g | 0;
                        g = 0 - (gb + ((g | 0) != 0) | 0) | 0;
                       }
                       N = f, U = qd(Fc(a, g), 16), u[N >> 1] = U;
                       d = d - 1 | 0;
                       e = e + 4 | 0;
                       f = f + 2 | 0;
                       continue;
                      }
                     }
                    }
                    break;
                   }
                   if (E) {
                    v[E >> 2] = i;
                   }
                   eb = s + 16 | 0;
                   d = h << 2;
                   break sa;
                  }
                  E = m + 48 | 0;
                  s = eb - 16 | 0;
                  eb = s;
                  N = s, U = B(v[b >> 2], Zd(x[b + 34 >> 1])), v[N + 12 >> 2] = U;
                  wc(s + 12 | 0, d >>> 2 | 0);
                  f = e;
                  h = v[s + 12 >> 2];
                  d = h;
                  while (1) {
                   if (d) {
                    a = w[f | 0] | w[f + 1 | 0] << 8 | (w[f + 2 | 0] << 16 | w[f + 3 | 0] << 24);
                    g = a << 24 | (a & 65280) << 8 | (a >>> 8 & 65280 | a >>> 24);
                    wa: {
                     if ((g | 0) < 0) {
                      a = -2147483648;
                      if ((g | 0) == -2147483648) {
                       break wa;
                      }
                      g = 0 - g | 0;
                     }
                     a = g >>> 0 > i >>> 0 ? g : i;
                    }
                    i = a;
                    d = d - 1 | 0;
                    f = f + 4 | 0;
                    continue;
                   } else {
                    xa: {
                     if (!i) {
                      break xa;
                     }
                     o = i - 1 | 0;
                     j = i >>> 1 | 0;
                     f = v[b + 20 >> 2];
                     d = h;
                     while (1) {
                      if (!d) {
                       break xa;
                      }
                      a = w[e | 0] | w[e + 1 | 0] << 8 | (w[e + 2 | 0] << 16 | w[e + 3 | 0] << 24);
                      a = a << 24 | (a & 65280) << 8 | (a >>> 8 & 65280 | a >>> 24);
                      g = a & -2147483648 | a >>> 1;
                      a = j | a << 31;
                      ya: {
                       if ((g | 0) > 0 | (g | 0) >= 0) {
                        a = Cua(a, g, i, 0);
                        g = gb;
                        break ya;
                       }
                       g = Cua(o - a | 0, 0 - ((a >>> 0 > o >>> 0) + g | 0) | 0, i, 0);
                       a = 0 - g | 0;
                       g = 0 - (gb + ((g | 0) != 0) | 0) | 0;
                      }
                      N = f, U = qd(Fc(a, g), 16), u[N >> 1] = U;
                      d = d - 1 | 0;
                      e = e + 4 | 0;
                      f = f + 2 | 0;
                      continue;
                     }
                    }
                   }
                   break;
                  }
                  if (E) {
                   v[E >> 2] = i;
                  }
                  eb = s + 16 | 0;
                  d = h << 2;
                 }
                 if (!d) {
                  break u;
                 }
                 a = v[m + 48 >> 2];
                 if ((a | 0) == -2147483648) {
                  break u;
                 }
                 e = Aua(x[b + 32 >> 1], 0, a, 0);
                 a = gb;
                 e = e + 1073741824 | 0;
                 a = e >>> 0 < 1073741824 ? a + 1 | 0 : a;
                 N = b, U = Kd(Ac((a & 2147483647) << 1 | e >>> 31, a >>> 31 | 0), 1, 64), u[N + 32 >> 1] = U;
                 u[b + 34 >> 1] = x[b + 34 >> 1] | 8192;
                 break u;
                }
                if ((f | 0) != 14 | (w[a + 1 | 0] - 1 & 255) >>> 0 > 1) {
                 break ka;
                }
                v[m + 48 >> 2] = 1065353216;
                d = v[m + 2216 >> 2];
                za: {
                 if (!w[a + 2 | 0]) {
                  g = m + 48 | 0;
                  f = eb - 16 | 0;
                  eb = f;
                  N = f, U = B(v[b >> 2], Zd(x[b + 34 >> 1])), v[N + 12 >> 2] = U;
                  wc(f + 12 | 0, d >>> 2 | 0);
                  h = e;
                  a = v[f + 12 >> 2];
                  d = a;
                  while (1) {
                   if (d) {
                    k = $f((l(2, w[h | 0] | w[h + 1 | 0] << 8 | (w[h + 2 | 0] << 16 | w[h + 3 | 0] << 24)), 
                    r()));
                    k = C(D(Jg(k) ? k >= C(0) ? C(1) : C(-1) : k));
                    F = k > F ? k : F;
                    d = d - 1 | 0;
                    h = h + 4 | 0;
                    continue;
                   } else {
                    Aa: {
                     if (F == C(0)) {
                      break Aa;
                     }
                     J = C(C(1) / F);
                     h = v[b + 20 >> 2];
                     d = a;
                     while (1) {
                      if (!d) {
                       break Aa;
                      }
                      k = $f((l(2, w[e | 0] | w[e + 1 | 0] << 8 | (w[e + 2 | 0] << 16 | w[e + 3 | 0] << 24)), 
                      r()));
                      k = ki(C(Od(C(J * (Jg(k) ? k >= C(0) ? C(1) : C(-1) : k)), C(-1)) * C(32768)));
                      Ba: {
                       if (C(D(k)) < C(2147483648)) {
                        i = ~~k;
                        break Ba;
                       }
                       i = -2147483648;
                      }
                      N = h, U = fd(i), u[N >> 1] = U;
                      d = d - 1 | 0;
                      e = e + 4 | 0;
                      h = h + 2 | 0;
                      continue;
                     }
                    }
                    if (g) {
                     z[g >> 2] = F;
                    }
                    eb = f + 16 | 0;
                    d = a << 2;
                   }
                   break;
                  }
                  break za;
                 }
                 g = m + 48 | 0;
                 j = eb - 16 | 0;
                 eb = j;
                 N = j, U = B(v[b >> 2], Zd(x[b + 34 >> 1])), v[N + 12 >> 2] = U;
                 wc(j + 12 | 0, d >>> 2 | 0);
                 f = e;
                 a = v[j + 12 >> 2];
                 d = a;
                 while (1) {
                  if (d) {
                   h = w[f | 0] | w[f + 1 | 0] << 8 | (w[f + 2 | 0] << 16 | w[f + 3 | 0] << 24);
                   k = $f((l(2, h << 24 | (h & 65280) << 8 | (h >>> 8 & 65280 | h >>> 24)), r()));
                   k = C(D(Jg(k) ? k >= C(0) ? C(1) : C(-1) : k));
                   F = k > F ? k : F;
                   d = d - 1 | 0;
                   f = f + 4 | 0;
                   continue;
                  } else {
                   Ca: {
                    if (F == C(0)) {
                     break Ca;
                    }
                    J = C(C(1) / F);
                    f = v[b + 20 >> 2];
                    d = a;
                    while (1) {
                     if (!d) {
                      break Ca;
                     }
                     h = w[e | 0] | w[e + 1 | 0] << 8 | (w[e + 2 | 0] << 16 | w[e + 3 | 0] << 24);
                     k = $f((l(2, h << 24 | (h & 65280) << 8 | (h >>> 8 & 65280 | h >>> 24)), r()));
                     k = ki(C(Od(C(J * (Jg(k) ? k >= C(0) ? C(1) : C(-1) : k)), C(-1)) * C(32768)));
                     Da: {
                      if (C(D(k)) < C(2147483648)) {
                       h = ~~k;
                       break Da;
                      }
                      h = -2147483648;
                     }
                     N = f, U = fd(h), u[N >> 1] = U;
                     d = d - 1 | 0;
                     e = e + 4 | 0;
                     f = f + 2 | 0;
                     continue;
                    }
                   }
                   if (g) {
                    z[g >> 2] = F;
                   }
                   eb = j + 16 | 0;
                   d = a << 2;
                  }
                  break;
                 }
                }
                if (!d) {
                 break u;
                }
                k = z[m + 48 >> 2];
                if (k == C(1)) {
                 break u;
                }
                k = ki(DB(C(k * C(x[b + 32 >> 1])), C(1), C(64)));
                a = 65535;
                Ea: {
                 if (k >= C(65535)) {
                  break Ea;
                 }
                 a = 0;
                 if (k <= C(0)) {
                  break Ea;
                 }
                 a = ~~k >>> 0;
                 if (k < C(4294967296) & k >= C(0)) {
                  break Ea;
                 }
                 a = 0;
                }
                u[b + 32 >> 1] = a;
                u[b + 34 >> 1] = x[b + 34 >> 1] | 8192;
                break u;
               }
               if ((f | 0) != 14 | (w[a + 1 | 0] - 1 & 255) >>> 0 > 1 | (g | 0) != 64) {
                break ka;
               }
               v[m + 48 >> 2] = 0;
               v[m + 52 >> 2] = 1072693248;
               d = v[m + 2216 >> 2];
               Fa: {
                if (!w[a + 2 | 0]) {
                 h = m + 48 | 0;
                 j = eb - 32 | 0;
                 eb = j;
                 N = j, U = B(v[b >> 2], Zd(x[b + 34 >> 1])), v[N + 4 >> 2] = U;
                 wc(j + 4 | 0, d >>> 3 | 0);
                 g = e;
                 a = v[j + 4 >> 2];
                 d = a;
                 while (1) {
                  if (d) {
                   f = w[g + 4 | 0] | w[g + 5 | 0] << 8 | (w[g + 6 | 0] << 16 | w[g + 7 | 0] << 24);
                   l(0, w[g | 0] | w[g + 1 | 0] << 8 | (w[g + 2 | 0] << 16 | w[g + 3 | 0] << 24));
                   l(1, f | 0);
                   q = Ig(+n());
                   q = D(zf(q) ? q >= 0 ? 1 : -1 : q);
                   H = q > H ? q : H;
                   d = d - 1 | 0;
                   g = g + 8 | 0;
                   continue;
                  } else {
                   Ga: {
                    if (H == 0) {
                     break Ga;
                    }
                    K = 1 / H;
                    g = v[b + 20 >> 2];
                    d = a;
                    while (1) {
                     if (!d) {
                      break Ga;
                     }
                     f = w[e + 4 | 0] | w[e + 5 | 0] << 8 | (w[e + 6 | 0] << 16 | w[e + 7 | 0] << 24);
                     l(0, w[e | 0] | w[e + 1 | 0] << 8 | (w[e + 2 | 0] << 16 | w[e + 3 | 0] << 24));
                     l(1, f | 0);
                     q = Ig(+n());
                     N = j, V = K * (zf(q) ? q >= 0 ? 1 : -1 : q), A[N + 24 >> 3] = V;
                     v[j + 16 >> 2] = 0;
                     v[j + 20 >> 2] = -1074790400;
                     v[j + 8 >> 2] = 0;
                     v[j + 12 >> 2] = 1072693248;
                     q = Ee(A[Xg(j + 24 | 0, j + 16 | 0, j + 8 | 0) >> 3] * 32768);
                     Ha: {
                      if (D(q) < 2147483648) {
                       f = ~~q;
                       break Ha;
                      }
                      f = -2147483648;
                     }
                     N = g, U = fd(f), u[N >> 1] = U;
                     d = d - 1 | 0;
                     e = e + 8 | 0;
                     g = g + 2 | 0;
                     continue;
                    }
                   }
                   if (h) {
                    A[h >> 3] = H;
                   }
                   eb = j + 32 | 0;
                   d = a << 3;
                  }
                  break;
                 }
                 break Fa;
                }
                E = m + 48 | 0;
                G = eb - 32 | 0;
                eb = G;
                N = G, U = B(v[b >> 2], Zd(x[b + 34 >> 1])), v[N + 4 >> 2] = U;
                wc(G + 4 | 0, d >>> 3 | 0);
                g = e;
                a = v[G + 4 >> 2];
                d = a;
                while (1) {
                 if (d) {
                  o = w[g | 0] | w[g + 1 | 0] << 8 | (w[g + 2 | 0] << 16 | w[g + 3 | 0] << 24);
                  j = o << 24 | (o & 65280) << 8;
                  f = o & -16777216;
                  h = f >>> 24 | 0;
                  s = f << 8;
                  f = o & 16711680;
                  i = w[g + 4 | 0] | w[g + 5 | 0] << 8 | (w[g + 6 | 0] << 16 | w[g + 7 | 0] << 24);
                  l(0, s | f << 24 | (((i & 255) << 24 | o >>> 8) & -16777216 | ((i & 16777215) << 8 | o >>> 24) & 16711680 | (i >>> 8 & 65280 | i >>> 24)));
                  l(1, j | (h | f >>> 8));
                  q = Ig(+n());
                  q = D(zf(q) ? q >= 0 ? 1 : -1 : q);
                  H = q > H ? q : H;
                  d = d - 1 | 0;
                  g = g + 8 | 0;
                  continue;
                 } else {
                  Ia: {
                   if (H == 0) {
                    break Ia;
                   }
                   K = 1 / H;
                   g = v[b + 20 >> 2];
                   d = a;
                   while (1) {
                    if (!d) {
                     break Ia;
                    }
                    s = w[e | 0] | w[e + 1 | 0] << 8 | (w[e + 2 | 0] << 16 | w[e + 3 | 0] << 24);
                    o = s << 24 | (s & 65280) << 8;
                    i = s & 16711680;
                    j = i >>> 8 | 0;
                    h = s & -16777216;
                    f = h >>> 24 | 0;
                    i = h << 8 | i << 24;
                    h = w[e + 4 | 0] | w[e + 5 | 0] << 8 | (w[e + 6 | 0] << 16 | w[e + 7 | 0] << 24);
                    l(0, i | (((h & 255) << 24 | s >>> 8) & -16777216 | ((h & 16777215) << 8 | s >>> 24) & 16711680 | (h >>> 8 & 65280 | h >>> 24)));
                    l(1, o | (f | j));
                    q = Ig(+n());
                    N = G, V = K * (zf(q) ? q >= 0 ? 1 : -1 : q), A[N + 24 >> 3] = V;
                    v[G + 16 >> 2] = 0;
                    v[G + 20 >> 2] = -1074790400;
                    v[G + 8 >> 2] = 0;
                    v[G + 12 >> 2] = 1072693248;
                    q = Ee(A[Xg(G + 24 | 0, G + 16 | 0, G + 8 | 0) >> 3] * 32768);
                    Ja: {
                     if (D(q) < 2147483648) {
                      f = ~~q;
                      break Ja;
                     }
                     f = -2147483648;
                    }
                    N = g, U = fd(f), u[N >> 1] = U;
                    d = d - 1 | 0;
                    e = e + 8 | 0;
                    g = g + 2 | 0;
                    continue;
                   }
                  }
                  if (E) {
                   A[E >> 3] = H;
                  }
                  eb = G + 32 | 0;
                  d = a << 3;
                 }
                 break;
                }
               }
               if (!d) {
                break u;
               }
               q = A[m + 48 >> 3];
               if (q == 1) {
                break u;
               }
               N = b, U = MD(Zv(q * +x[b + 32 >> 1], 1, 64)), u[N + 32 >> 1] = U;
               u[b + 34 >> 1] = x[b + 34 >> 1] | 8192;
               break u;
              }
              Ka: {
               La: {
                Ma: {
                 Na: {
                  g = (d & 255) != 32;
                  Oa: {
                   if (!(g | (w[a + 1 | 0] != 1 | (f | 0) != 12))) {
                    F = C(30517578125e-15);
                    d = v[m + 2216 >> 2];
                    if (!w[a + 2 | 0]) {
                     break Oa;
                    }
                    break Ka;
                   }
                   if (!(w[a + 1 | 0] != 2 | (f | 0) != 12 | g)) {
                    F = C(30517578125e-15);
                    d = v[m + 2216 >> 2];
                    if (!w[a + 2 | 0]) {
                     break Ma;
                    }
                    break La;
                   }
                   g = (d & 255) != 32;
                   if (g | (w[a + 1 | 0] != 1 | (f | 0) != 13)) {
                    break Na;
                   }
                   F = C(1.1920928955078125e-7);
                   d = v[m + 2216 >> 2];
                   if (w[a + 2 | 0]) {
                    break Ka;
                   }
                  }
                  a = v[b >> 2];
                  f = v[b + 20 >> 2];
                  g = eb - 16 | 0;
                  eb = g;
                  v[g + 12 >> 2] = d >>> 2;
                  v[g + 8 >> 2] = a;
                  a = v[Gb(g + 12 | 0, g + 8 | 0) >> 2];
                  b = a;
                  while (1) {
                   if (b) {
                    k = $f((l(2, w[e | 0] | w[e + 1 | 0] << 8 | (w[e + 2 | 0] << 16 | w[e + 3 | 0] << 24)), 
                    r()));
                    k = ki(C(Od(C((Jg(k) ? k >= C(0) ? C(1) : C(-1) : k) * F), C(-1)) * C(32768)));
                    Pa: {
                     if (C(D(k)) < C(2147483648)) {
                      d = ~~k;
                      break Pa;
                     }
                     d = -2147483648;
                    }
                    N = f, U = fd(d), u[N >> 1] = U;
                    f = f + 2 | 0;
                    e = e + 4 | 0;
                    b = b - 1 | 0;
                    continue;
                   }
                   break;
                  }
                  eb = g + 16 | 0;
                  d = a << 2;
                  break u;
                 }
                 d = 0;
                 if (w[a + 1 | 0] != 2 | (f | 0) != 13 | g) {
                  break u;
                 }
                 F = C(1.1920928955078125e-7);
                 d = v[m + 2216 >> 2];
                 if (w[a + 2 | 0]) {
                  break La;
                 }
                }
                a = v[b >> 2];
                f = v[b + 20 >> 2];
                g = eb - 16 | 0;
                eb = g;
                v[g + 12 >> 2] = d >>> 3;
                v[g + 8 >> 2] = a;
                a = v[Gb(g + 12 | 0, g + 8 | 0) >> 2];
                b = a;
                while (1) {
                 if (b) {
                  k = $f((l(2, w[e | 0] | w[e + 1 | 0] << 8 | (w[e + 2 | 0] << 16 | w[e + 3 | 0] << 24)), 
                  r()));
                  k = ki(C(Od(C((Jg(k) ? k >= C(0) ? C(1) : C(-1) : k) * F), C(-1)) * C(32768)));
                  Qa: {
                   if (C(D(k)) < C(2147483648)) {
                    d = ~~k;
                    break Qa;
                   }
                   d = -2147483648;
                  }
                  N = f, U = fd(d), u[N >> 1] = U;
                  k = $f((l(2, w[e + 4 | 0] | w[e + 5 | 0] << 8 | (w[e + 6 | 0] << 16 | w[e + 7 | 0] << 24)), 
                  r()));
                  k = ki(C(Od(C((Jg(k) ? k >= C(0) ? C(1) : C(-1) : k) * F), C(-1)) * C(32768)));
                  Ra: {
                   if (C(D(k)) < C(2147483648)) {
                    d = ~~k;
                    break Ra;
                   }
                   d = -2147483648;
                  }
                  N = f, U = fd(d), u[N + 2 >> 1] = U;
                  f = f + 4 | 0;
                  e = e + 8 | 0;
                  b = b - 1 | 0;
                  continue;
                 }
                 break;
                }
                eb = g + 16 | 0;
                d = a << 3;
                break u;
               }
               a = v[b >> 2];
               f = v[b + 20 >> 2];
               g = eb - 16 | 0;
               eb = g;
               v[g + 12 >> 2] = d >>> 3;
               v[g + 8 >> 2] = a;
               a = v[Gb(g + 12 | 0, g + 8 | 0) >> 2];
               d = a;
               while (1) {
                if (d) {
                 b = w[e | 0] | w[e + 1 | 0] << 8 | (w[e + 2 | 0] << 16 | w[e + 3 | 0] << 24);
                 k = $f((l(2, b << 24 | (b & 65280) << 8 | (b >>> 8 & 65280 | b >>> 24)), r()));
                 k = ki(C(Od(C((Jg(k) ? k >= C(0) ? C(1) : C(-1) : k) * F), C(-1)) * C(32768)));
                 Sa: {
                  if (C(D(k)) < C(2147483648)) {
                   b = ~~k;
                   break Sa;
                  }
                  b = -2147483648;
                 }
                 N = f, U = fd(b), u[N >> 1] = U;
                 b = w[e + 4 | 0] | w[e + 5 | 0] << 8 | (w[e + 6 | 0] << 16 | w[e + 7 | 0] << 24);
                 k = $f((l(2, b << 24 | (b & 65280) << 8 | (b >>> 8 & 65280 | b >>> 24)), r()));
                 k = ki(C(Od(C((Jg(k) ? k >= C(0) ? C(1) : C(-1) : k) * F), C(-1)) * C(32768)));
                 Ta: {
                  if (C(D(k)) < C(2147483648)) {
                   b = ~~k;
                   break Ta;
                  }
                  b = -2147483648;
                 }
                 N = f, U = fd(b), u[N + 2 >> 1] = U;
                 f = f + 4 | 0;
                 e = e + 8 | 0;
                 d = d - 1 | 0;
                 continue;
                }
                break;
               }
               eb = g + 16 | 0;
               d = a << 3;
               break u;
              }
              a = v[b >> 2];
              f = v[b + 20 >> 2];
              g = eb - 16 | 0;
              eb = g;
              v[g + 12 >> 2] = d >>> 2;
              v[g + 8 >> 2] = a;
              a = v[Gb(g + 12 | 0, g + 8 | 0) >> 2];
              d = a;
              while (1) {
               if (d) {
                b = w[e | 0] | w[e + 1 | 0] << 8 | (w[e + 2 | 0] << 16 | w[e + 3 | 0] << 24);
                k = $f((l(2, b << 24 | (b & 65280) << 8 | (b >>> 8 & 65280 | b >>> 24)), r()));
                k = ki(C(Od(C((Jg(k) ? k >= C(0) ? C(1) : C(-1) : k) * F), C(-1)) * C(32768)));
                Ua: {
                 if (C(D(k)) < C(2147483648)) {
                  b = ~~k;
                  break Ua;
                 }
                 b = -2147483648;
                }
                N = f, U = fd(b), u[N >> 1] = U;
                f = f + 2 | 0;
                e = e + 4 | 0;
                d = d - 1 | 0;
                continue;
               }
               break;
              }
              eb = g + 16 | 0;
              d = a << 2;
              break u;
             }
             a = S(28784) | 0;
            }
            if ((fb | 0) != (_(28784) | 0)) {
             break d;
            }
            X(a | 0) | 0;
            v[31601] = 0;
            W(26);
            a = v[31601];
            v[31601] = 0;
            if ((a | 0) == 1) {
             break v;
            }
           }
           tb(E);
           break u;
          }
          a = M() | 0;
          break d;
         }
         v[31601] = 0;
         O(149, c | 0, d + L | 0) | 0;
         a = v[31601];
         v[31601] = 0;
         if ((a | 0) == 1) {
          break f;
         }
        }
        Jc(I);
       }
       eb = m + 2240 | 0;
       return d | 0;
      }
      a = M() | 0;
      break a;
     }
     a = M() | 0;
    }
    tb(E);
    break a;
   }
   a = M() | 0;
   break a;
  }
  a = M() | 0;
 }
 Jc(I);
 P(a | 0);
 p();
}

function kja(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, q = 0, r = 0, s = 0, z = 0, A = 0, C = 0, D = 0, E = 0, F = 0, G = 0, H = 0, I = 0, J = 0, K = 0, L = 0, N = 0, O = 0, Q = 0, R = 0, S = 0, U = 0, V = 0, W = 0, X = 0, Y = 0, _ = 0, $ = 0, aa = 0, ba = 0, ca = 0, da = 0, ea = 0, fa = 0;
 m = eb - 1168 | 0;
 eb = m;
 xc(b);
 a: {
  b: {
   c: {
    d: {
     e = m + 1144 | 0;
     e: {
      if (!ps(b, e)) {
       break e;
      }
      if (!mR(e)) {
       break e;
      }
      if ((w[m + 1152 | 0] | w[m + 1153 | 0] << 8 | (w[m + 1154 | 0] << 16 | w[m + 1155 | 0] << 24)) != (Kh(v[b >> 2]) | 0)) {
       break e;
      }
      if ((w[m + 1160 | 0] | w[m + 1161 | 0] << 8 | (w[m + 1162 | 0] << 16 | w[m + 1163 | 0] << 24)) != (jf(b) | 0)) {
       break e;
      }
      d = 1;
      if ((c | 0) == 64) {
       break e;
      }
      d = 0;
      e = m + 1088 | 0;
      Qb(e, 0, 56);
      f = -2;
      f: {
       if (!e) {
        break f;
       }
       v[e + 44 >> 2] = 0;
       v[e + 48 >> 2] = 0;
       v[e + 52 >> 2] = 0;
       v[e + 20 >> 2] = 0;
       v[e + 24 >> 2] = 0;
       v[e + 8 >> 2] = 0;
       h = v[e + 32 >> 2];
       if (!h) {
        v[e + 32 >> 2] = 1213;
        h = 1213;
       }
       if (!v[e + 36 >> 2]) {
        v[e + 36 >> 2] = 1214;
       }
       h = hb[h | 0](v[e + 40 >> 2], 1, 43784) | 0;
       f = -4;
       if (!h) {
        break f;
       }
       v[e + 28 >> 2] = h;
       v[h + 43780 >> 2] = 1;
       v[h + 10992 >> 2] = 0;
       v[h + 10996 >> 2] = 0;
       v[h >> 2] = 0;
       v[h + 11008 >> 2] = 15;
       v[h + 11e3 >> 2] = 1;
       v[h + 11004 >> 2] = 0;
       f = 0;
      }
      if (f) {
       break e;
      }
      d = w[m + 1160 | 0] | w[m + 1161 | 0] << 8 | (w[m + 1162 | 0] << 16 | w[m + 1163 | 0] << 24);
      v[m + 1084 >> 2] = d;
      J = w[m + 1164 | 0] | w[m + 1165 | 0] << 8 | (w[m + 1166 | 0] << 16 | w[m + 1167 | 0] << 24);
      S = DZ(m + 1072 | 0, J);
      while (1) {
       if (!(!J | !d | (g | 0) == 1)) {
        v[m + 32 >> 2] = 1024;
        h = m + 48 | 0;
        g = m + 32 | 0;
        V = v[Gb(g, m + 1084 | 0) >> 2];
        d = Yb(m + 40 | 0, h, V);
        e = v[d >> 2];
        d = v[d + 4 >> 2];
        v[31601] = 0;
        Xn(159, g, b, e, d);
        g = v[31601];
        v[31601] = 0;
        if ((g | 0) == 1) {
         break b;
        }
        d = h;
        g = V;
        e = ba ^ -1;
        while (1) {
         if (g >>> 0 < 4) {
          while (1) {
           if (g) {
            e = v[(((w[d | 0] ^ e) & 255) << 2) + 79280 >> 2] ^ e >>> 8;
            g = g - 1 | 0;
            d = d + 1 | 0;
            continue;
           }
           break;
          }
          g = e ^ -1;
         } else {
          e = v[(((w[d | 0] ^ e) & 255) << 2) + 79280 >> 2] ^ e >>> 8;
          e = e >>> 8 ^ v[(((e ^ w[d + 1 | 0]) & 255) << 2) + 79280 >> 2];
          e = e >>> 8 ^ v[(((e ^ w[d + 2 | 0]) & 255) << 2) + 79280 >> 2];
          e = e >>> 8 ^ v[(((e ^ w[d + 3 | 0]) & 255) << 2) + 79280 >> 2];
          g = g - 4 | 0;
          d = d + 4 | 0;
          continue;
         }
         break;
        }
        ba = g;
        v[m + 1092 >> 2] = V;
        v[m + 1088 >> 2] = h;
        v[m + 1104 >> 2] = J;
        v[m + 1100 >> 2] = v[S >> 2] + ca;
        D = eb - 16 | 0;
        eb = D;
        e = -2;
        q = m + 1088 | 0;
        g: {
         if (!q) {
          break g;
         }
         i = v[q + 28 >> 2];
         if (!i) {
          break g;
         }
         fa = v[q + 4 >> 2];
         v[i + 11e3 >> 2] = 0;
         h: {
          if (v[i + 43780 >> 2] < 0) {
           break h;
          }
          if (v[i + 11004 >> 2]) {
           break g;
          }
          e = 0;
          g = v[i + 10996 >> 2];
          if (!g) {
           X = v[i + 11008 >> 2] > 0 ? 11 : 10;
           I = i + 11012 | 0;
           h = v[q + 4 >> 2];
           n = v[i + 10992 >> 2];
           while (1) {
            v[D + 12 >> 2] = h;
            v[D + 8 >> 2] = 32768 - n;
            C = v[q >> 2];
            d = 0;
            E = 0;
            F = 0;
            K = 0;
            W = 0;
            L = 0;
            U = 0;
            Y = 0;
            _ = eb - 144 | 0;
            eb = _;
            i: {
             j: {
              N = n + I | 0;
              if (N >>> 0 >= I >>> 0) {
               G = v[D + 8 >> 2] + N | 0;
               H = G - I | 0;
               $ = (I ^ -1) + G | 0;
               if (!(H & $)) {
                break j;
               }
              }
              v[D + 8 >> 2] = 0;
              v[D + 12 >> 2] = 0;
              l = -3;
              break i;
             }
             k = v[D + 12 >> 2];
             A = k + C | 0;
             O = v[i + 60 >> 2];
             s = v[i + 40 >> 2];
             g = v[i + 36 >> 2];
             r = v[i + 32 >> 2];
             h = v[i + 56 >> 2];
             f = v[i + 4 >> 2];
             l = -1;
             o = N;
             j = C;
             n = -1;
             k: {
              l: {
               m: {
                n: {
                 o: {
                  p: {
                   q: {
                    r: {
                     s: {
                      t: {
                       u: {
                        v: {
                         w: {
                          x: {
                           y: {
                            z: {
                             A: {
                              B: {
                               C: {
                                D: {
                                 E: {
                                  F: {
                                   G: {
                                    H: {
                                     I: {
                                      J: {
                                       K: {
                                        L: {
                                         M: {
                                          N: {
                                           O: {
                                            P: {
                                             Q: {
                                              R: {
                                               S: {
                                                T: {
                                                 U: {
                                                  V: {
                                                   W: {
                                                    z = v[i >> 2];
                                                    switch (z | 0) {
                                                    case 10:
                                                    case 17:
                                                    case 21:
                                                    case 35:
                                                    case 36:
                                                    case 37:
                                                    case 39:
                                                     break m;

                                                    case 2:
                                                     break s;

                                                    case 53:
                                                     break w;

                                                    case 26:
                                                     break y;

                                                    case 25:
                                                     break z;

                                                    case 24:
                                                     break A;

                                                    case 23:
                                                     break B;

                                                    case 18:
                                                     break C;

                                                    case 16:
                                                     break D;

                                                    case 14:
                                                     break E;

                                                    case 51:
                                                     break H;

                                                    case 6:
                                                     break I;

                                                    case 3:
                                                     break J;

                                                    case 34:
                                                     break K;

                                                    case 42:
                                                     break L;

                                                    case 41:
                                                     break M;

                                                    case 32:
                                                     break N;

                                                    case 27:
                                                     break O;

                                                    case 11:
                                                     break P;

                                                    case 38:
                                                     break Q;

                                                    case 9:
                                                     break R;

                                                    case 52:
                                                     break S;

                                                    case 7:
                                                     break T;

                                                    case 5:
                                                     break U;

                                                    case 1:
                                                     break V;

                                                    case 0:
                                                     break W;

                                                    default:
                                                     break l;
                                                    }
                                                   }
                                                   v[i + 28 >> 2] = 1;
                                                   h = 0;
                                                   v[i + 8 >> 2] = 0;
                                                   v[i + 12 >> 2] = 0;
                                                   v[i + 16 >> 2] = 1;
                                                   s = 0;
                                                   g = 0;
                                                   r = 0;
                                                   f = 0;
                                                   if (X & 1) {
                                                    break V;
                                                   }
                                                   break r;
                                                  }
                                                  if ((k | 0) <= 0) {
                                                   l = 1;
                                                   v[i >> 2] = 1;
                                                   break k;
                                                  }
                                                  v[i + 8 >> 2] = w[C | 0];
                                                  j = C + 1 | 0;
                                                  break s;
                                                 }
                                                 if ((k | 0) <= 0) {
                                                  break t;
                                                 }
                                                 W = f + 8 | 0;
                                                 j = C + 1 | 0;
                                                 h = w[C | 0] << f | h;
                                                 d = 2;
                                                 break q;
                                                }
                                                d = 4;
                                                break q;
                                               }
                                               L = h;
                                               break G;
                                              }
                                              d = 7;
                                              break q;
                                             }
                                             d = 8;
                                             break q;
                                            }
                                            E = g;
                                            break F;
                                           }
                                           F = h;
                                           break x;
                                          }
                                          l = 1;
                                          if ((k | 0) <= 0) {
                                           break u;
                                          }
                                          f = f + 8 | 0;
                                          j = C + 1 | 0;
                                          break p;
                                         }
                                         e = g;
                                         d = f;
                                         break v;
                                        }
                                        k = 2;
                                        break o;
                                       }
                                       n = 0;
                                       z = 34;
                                       break m;
                                      }
                                      d = 1;
                                      break q;
                                     }
                                     d = 3;
                                     break q;
                                    }
                                    d = 5;
                                    break q;
                                   }
                                   d = 6;
                                   break q;
                                  }
                                  d = 9;
                                  break q;
                                 }
                                 d = 10;
                                 break q;
                                }
                                d = 11;
                                break q;
                               }
                               d = 12;
                               break q;
                              }
                              d = 13;
                              break q;
                             }
                             d = 14;
                             break q;
                            }
                            d = 15;
                            break q;
                           }
                           d = 16;
                           break q;
                          }
                          d = 17;
                          break q;
                         }
                         d = 18;
                         break q;
                        }
                        k = 1;
                        break o;
                       }
                       v[i >> 2] = 32;
                       break k;
                      }
                      v[i >> 2] = 5;
                      l = 1;
                      break k;
                     }
                     if (j >>> 0 >= A >>> 0) {
                      v[i >> 2] = 2;
                      l = 1;
                      break k;
                     }
                     g = w[j | 0];
                     v[i + 12 >> 2] = g;
                     j = j + 1 | 0;
                     z = 36;
                     d = v[i + 8 >> 2];
                     e = 256 << (d >>> 4);
                     if (e >>> 0 > 32768 | e >>> 0 > H >>> 0 | (((g | d << 8) >>> 0) % 31 | g & 32)) {
                      break n;
                     }
                     g = 0;
                     if ((d & 15) != 8) {
                      break n;
                     }
                    }
                    d = 0;
                   }
                   X: while (1) {
                    Y: {
                     Z: {
                      _: {
                       $: {
                        aa: {
                         ba: {
                          ca: {
                           da: {
                            ea: {
                             fa: {
                              ga: {
                               ha: {
                                ia: {
                                 ja: {
                                  ka: {
                                   la: {
                                    ma: {
                                     na: {
                                      oa: {
                                       pa: {
                                        qa: {
                                         ra: {
                                          sa: {
                                           ta: {
                                            ua: {
                                             va: {
                                              wa: {
                                               xa: {
                                                ya: {
                                                 za: {
                                                  Aa: {
                                                   Ba: {
                                                    Ca: {
                                                     Da: {
                                                      switch (d | 0) {
                                                      case 0:
                                                       if (f >>> 0 > 2) {
                                                        break Ca;
                                                       }
                                                       d = 1;
                                                       continue;

                                                      case 9:
                                                       break ha;

                                                      case 10:
                                                       break ia;

                                                      case 11:
                                                       break ja;

                                                      case 12:
                                                       break ka;

                                                      case 13:
                                                       break la;

                                                      case 14:
                                                       break ma;

                                                      case 15:
                                                       break na;

                                                      case 16:
                                                       break oa;

                                                      case 17:
                                                       break pa;

                                                      case 8:
                                                       break va;

                                                      case 7:
                                                       break wa;

                                                      case 6:
                                                       break xa;

                                                      case 5:
                                                       break ya;

                                                      case 4:
                                                       break za;

                                                      case 3:
                                                       break Aa;

                                                      case 2:
                                                       break Ba;

                                                      case 1:
                                                       break Da;

                                                      default:
                                                       break qa;
                                                      }
                                                     }
                                                     while (1) {
                                                      if (j >>> 0 >= A >>> 0) {
                                                       v[i >> 2] = 3;
                                                       l = 1;
                                                       break k;
                                                      }
                                                      h = w[j | 0] << f | h;
                                                      j = j + 1 | 0;
                                                      f = f + 8 | 0;
                                                      if (f >>> 0 < 3) {
                                                       continue;
                                                      }
                                                      break;
                                                     }
                                                    }
                                                    d = h & 7;
                                                    v[i + 20 >> 2] = d;
                                                    e = d >>> 1 | 0;
                                                    v[i + 24 >> 2] = e;
                                                    f = f - 3 | 0;
                                                    h = h >>> 3 | 0;
                                                    if (d >>> 0 >= 2) {
                                                     break ua;
                                                    }
                                                    W = f;
                                                    break ra;
                                                   }
                                                   f = W & -8;
                                                   h = h >>> (W & 7) | 0;
                                                   g = 0;
                                                   d = 0;
                                                   break ta;
                                                  }
                                                  while (1) {
                                                   if (j >>> 0 >= A >>> 0) {
                                                    v[i >> 2] = 6;
                                                    l = 1;
                                                    break k;
                                                   }
                                                   h = w[j | 0] << f | h;
                                                   d = f >>> 0 > 4294967287;
                                                   j = j + 1 | 0;
                                                   f = f + 8 | 0;
                                                   if (d) {
                                                    continue;
                                                   }
                                                   break;
                                                  }
                                                  d = 1;
                                                  break ta;
                                                 }
                                                 if (j >>> 0 >= A >>> 0) {
                                                  v[i >> 2] = 7;
                                                  l = 1;
                                                  break k;
                                                 }
                                                 t[(g + i | 0) + 10528 | 0] = w[j | 0];
                                                 j = j + 1 | 0;
                                                 d = 2;
                                                 break ta;
                                                }
                                                while (1) {
                                                 if (j >>> 0 >= A >>> 0) {
                                                  v[i >> 2] = 51;
                                                  l = 1;
                                                  break k;
                                                 }
                                                 h = w[j | 0] << f | h;
                                                 d = f >>> 0 > 4294967287;
                                                 j = j + 1 | 0;
                                                 f = f + 8 | 0;
                                                 if (d) {
                                                  continue;
                                                 }
                                                 break;
                                                }
                                                break $;
                                               }
                                               if (o >>> 0 < G >>> 0) {
                                                t[o | 0] = r;
                                                g = g - 1 | 0;
                                                o = o + 1 | 0;
                                                h = L;
                                                break aa;
                                               }
                                               n = 2;
                                               z = 52;
                                               h = L;
                                               break m;
                                              }
                                              if (o >>> 0 < G >>> 0) {
                                               break sa;
                                              }
                                              n = 2;
                                              z = 9;
                                              break m;
                                             }
                                             if (j >>> 0 < A >>> 0) {
                                              d = G - o | 0;
                                              e = A - j | 0;
                                              d = d >>> 0 < e >>> 0 ? d : e;
                                              d = d >>> 0 < g >>> 0 ? d : g;
                                              g = g - d | 0;
                                              o = yc(o, j, d) + d | 0;
                                              j = d + j | 0;
                                              break _;
                                             }
                                             v[i >> 2] = 38;
                                             l = 1;
                                             break k;
                                            }
                                            n = -1;
                                            z = 10;
                                            E = 0;
                                            Ea: {
                                             switch (e - 1 | 0) {
                                             case 0:
                                              v[i + 3552 >> 2] = 84215045;
                                              v[i + 3556 >> 2] = 84215045;
                                              v[i + 44 >> 2] = 288;
                                              v[i + 48 >> 2] = 32;
                                              d = i + 3560 | 0;
                                              v[d >> 2] = 84215045;
                                              v[d + 4 >> 2] = 84215045;
                                              d = i + 3568 | 0;
                                              v[d >> 2] = 84215045;
                                              v[d + 4 >> 2] = 84215045;
                                              d = i + 3576 | 0;
                                              v[d >> 2] = 84215045;
                                              v[d + 4 >> 2] = 84215045;
                                              d = i - -64 | 0;
                                              e = 0;
                                              while (1) {
                                               k = 144;
                                               if ((e | 0) == 144) {
                                                while (1) {
                                                 e = 256;
                                                 if ((k | 0) == 256) {
                                                  while (1) {
                                                   k = 280;
                                                   if ((e | 0) == 280) {
                                                    while (1) {
                                                     if ((k | 0) == 288) {
                                                      break ea;
                                                     }
                                                     t[d | 0] = 8;
                                                     k = k + 1 | 0;
                                                     d = d + 1 | 0;
                                                     continue;
                                                    }
                                                   } else {
                                                    t[d | 0] = 7;
                                                    e = e + 1 | 0;
                                                    d = d + 1 | 0;
                                                    continue;
                                                   }
                                                  }
                                                 } else {
                                                  t[d | 0] = 9;
                                                  k = k + 1 | 0;
                                                  d = d + 1 | 0;
                                                  continue;
                                                 }
                                                }
                                               } else {
                                                t[d | 0] = 8;
                                                e = e + 1 | 0;
                                                d = d + 1 | 0;
                                                continue;
                                               }
                                              }
                                              ;

                                             case 2:
                                              break m;

                                             default:
                                              break Ea;
                                             }
                                            }
                                            d = 0;
                                            break ga;
                                           }
                                           while (1) {
                                            Fa: {
                                             Ga: {
                                              Ha: {
                                               Ia: {
                                                Ja: {
                                                 Ka: {
                                                  switch (d | 0) {
                                                  case 0:
                                                   if (g >>> 0 > 3) {
                                                    break Ja;
                                                   }
                                                   if (!f) {
                                                    f = 0;
                                                    break Ia;
                                                   }
                                                   if (f >>> 0 > 7) {
                                                    break Ga;
                                                   }
                                                   d = 3;
                                                   continue X;

                                                  case 1:
                                                   t[(g + i | 0) + 10528 | 0] = h;
                                                   f = f - 8 | 0;
                                                   h = h >>> 8 | 0;
                                                   break Fa;

                                                  default:
                                                   break Ka;
                                                  }
                                                 }
                                                 g = g + 1 | 0;
                                                 break Ha;
                                                }
                                                g = x[i + 10528 >> 1];
                                                if ((g ^ x[i + 10530 >> 1]) == 65535) {
                                                 break aa;
                                                }
                                                z = 39;
                                                n = -1;
                                                break m;
                                               }
                                               d = 4;
                                               continue X;
                                              }
                                              d = 0;
                                              continue;
                                             }
                                             d = 1;
                                             continue;
                                            }
                                            d = 2;
                                            continue;
                                           }
                                          }
                                          d = 8;
                                          continue;
                                         }
                                         d = 2;
                                         continue;
                                        }
                                        if (o >>> 0 < G >>> 0) {
                                         t[o | 0] = w[(O - r & $) + I | 0];
                                         o = o + 1 | 0;
                                         O = O + 1 | 0;
                                         d = 7;
                                         break ba;
                                        }
                                        n = 2;
                                        z = 53;
                                        break m;
                                       }
                                       while (1) {
                                        if (j >>> 0 >= A >>> 0) {
                                         v[i >> 2] = 27;
                                         l = 1;
                                         h = F;
                                         break k;
                                        }
                                        F = w[j | 0] << f | F;
                                        j = j + 1 | 0;
                                        f = f + 8 | 0;
                                        if (s >>> 0 > f >>> 0) {
                                         continue;
                                        }
                                        break;
                                       }
                                       d = 6;
                                       break ba;
                                      }
                                      if (j >>> 0 >= A >>> 0) {
                                       v[i >> 2] = 26;
                                       l = 1;
                                       break k;
                                      }
                                      h = w[j | 0] << f | h;
                                      j = j + 1 | 0;
                                      f = f + 8 | 0;
                                      d = 4;
                                      if (f >>> 0 < 15) {
                                       break ba;
                                      }
                                      d = 5;
                                      break ba;
                                     }
                                     while (1) {
                                      if (j >>> 0 >= A >>> 0) {
                                       v[i >> 2] = 25;
                                       l = 1;
                                       break k;
                                      }
                                      h = w[j | 0] << f | h;
                                      j = j + 1 | 0;
                                      f = f + 8 | 0;
                                      if (s >>> 0 > f >>> 0) {
                                       continue;
                                      }
                                      break;
                                     }
                                     d = 3;
                                     break ba;
                                    }
                                    if (o >>> 0 >= G >>> 0) {
                                     n = 2;
                                     z = 24;
                                     break m;
                                    }
                                    t[o | 0] = g;
                                    o = o + 1 | 0;
                                    break ca;
                                   }
                                   if (j >>> 0 >= A >>> 0) {
                                    v[i >> 2] = 23;
                                    l = 1;
                                    break k;
                                   }
                                   h = w[j | 0] << f | h;
                                   j = j + 1 | 0;
                                   f = f + 8 | 0;
                                   d = 0;
                                   if (f >>> 0 < 15) {
                                    break ba;
                                   }
                                   d = 1;
                                   break ba;
                                  }
                                  while (1) {
                                   if (j >>> 0 >= A >>> 0) {
                                    v[i >> 2] = 18;
                                    l = 1;
                                    break k;
                                   }
                                   h = w[j | 0] << f | h;
                                   j = j + 1 | 0;
                                   f = f + 8 | 0;
                                   if (s >>> 0 > f >>> 0) {
                                    continue;
                                   }
                                   break;
                                  }
                                  Y = r - 16 | 0;
                                  d = 3;
                                  break da;
                                 }
                                 if (j >>> 0 >= A >>> 0) {
                                  v[i >> 2] = 16;
                                  l = 1;
                                  break k;
                                 }
                                 h = w[j | 0] << f | h;
                                 j = j + 1 | 0;
                                 f = f + 8 | 0;
                                 d = 1;
                                 if (f >>> 0 < 15) {
                                  break da;
                                 }
                                 d = 2;
                                 break da;
                                }
                                while (1) {
                                 if (j >>> 0 >= A >>> 0) {
                                  v[i >> 2] = 14;
                                  l = 1;
                                  break k;
                                 }
                                 h = w[j | 0] << f | h;
                                 j = j + 1 | 0;
                                 f = f + 8 | 0;
                                 if (f >>> 0 < 3) {
                                  continue;
                                 }
                                 break;
                                }
                                d = 1;
                                break fa;
                               }
                               d = E + 22237 | 0;
                               while (1) {
                                if (j >>> 0 >= A >>> 0) {
                                 v[i >> 2] = 11;
                                 l = 1;
                                 g = E;
                                 break k;
                                }
                                h = w[j | 0] << f | h;
                                j = j + 1 | 0;
                                f = f + 8 | 0;
                                K = t[d | 0];
                                if (f >>> 0 < K >>> 0) {
                                 continue;
                                }
                                break;
                               }
                               d = 1;
                              }
                              while (1) {
                               La: {
                                Ma: {
                                 Na: {
                                  if (!d) {
                                   if (E >>> 0 > 2) {
                                    break Na;
                                   }
                                   K = t[E + 22237 | 0];
                                   if (K >>> 0 <= f >>> 0) {
                                    break La;
                                   }
                                   d = 9;
                                   continue X;
                                  }
                                  d = E << 2;
                                  v[(d + i | 0) + 44 >> 2] = v[d + 80816 >> 2] + ((-1 << K ^ -1) & h);
                                  E = E + 1 | 0;
                                  f = f - K | 0;
                                  h = h >>> K | 0;
                                  break Ma;
                                 }
                                 g = 0;
                                 Qb(i + 7040 | 0, 0, 288);
                                 d = 0;
                                 break fa;
                                }
                                d = 0;
                                continue;
                               }
                               d = 1;
                               continue;
                              }
                             }
                             while (1) {
                              Oa: {
                               Pa: {
                                Qa: {
                                 if (!d) {
                                  if (y[i + 52 >> 2] <= g >>> 0) {
                                   break Qa;
                                  }
                                  if (f >>> 0 > 2) {
                                   break Oa;
                                  }
                                  d = 10;
                                  continue X;
                                 }
                                 t[(w[g + 80832 | 0] + i | 0) + 7040 | 0] = h & 7;
                                 g = g + 1 | 0;
                                 f = f - 3 | 0;
                                 h = h >>> 3 | 0;
                                 break Pa;
                                }
                                v[i + 52 >> 2] = 19;
                                break ea;
                               }
                               d = 0;
                               continue;
                              }
                              d = 1;
                              continue;
                             }
                            }
                            U = v[i + 24 >> 2];
                            d = 0;
                           }
                           while (1) {
                            Ra: {
                             Sa: {
                              Ta: {
                               Ua: {
                                Va: {
                                 Wa: {
                                  Xa: {
                                   Ya: {
                                    Za: {
                                     switch (d | 0) {
                                     case 0:
                                      d = 0;
                                      if ((U | 0) < 0) {
                                       break ca;
                                      }
                                      H = Qb(_, 0, 64);
                                      e = B(U, 3488) + i | 0;
                                      da = Qb(e + 352 | 0, 0, 3200);
                                      ea = i + 44 | 0;
                                      Q = v[i + 24 >> 2];
                                      k = v[ea + (Q << 2) >> 2];
                                      aa = e - -64 | 0;
                                      while (1) {
                                       if ((d | 0) != (k | 0)) {
                                        e = (w[d + aa | 0] << 2) + H | 0;
                                        v[e >> 2] = v[e >> 2] + 1;
                                        d = d + 1 | 0;
                                        continue;
                                       }
                                       break;
                                      }
                                      ;
                                      v[H + 64 >> 2] = 0;
                                      v[H + 68 >> 2] = 0;
                                      l = 0;
                                      d = 1;
                                      e = 0;
                                      while (1) {
                                       if ((d | 0) != 16) {
                                        n = d << 2;
                                        d = d + 1 | 0;
                                        n = v[n + H >> 2];
                                        e = n + e << 1;
                                        v[(H - -64 | 0) + (d << 2) >> 2] = e;
                                        l = l + n | 0;
                                        continue;
                                       }
                                       break;
                                      }
                                      ;
                                      R = 0;
                                      n = -1;
                                      if ((e | 0) != 65536) {
                                       z = 35;
                                       if (l >>> 0 > 1) {
                                        break m;
                                       }
                                      }
                                      z = aa + 2336 | 0;
                                      while (1) {
                                       if (k >>> 0 > R >>> 0) {
                                        l = w[R + aa | 0];
                                        _a: {
                                         if (!l) {
                                          break _a;
                                         }
                                         d = (H - -64 | 0) + (l << 2) | 0;
                                         e = v[d >> 2];
                                         v[d >> 2] = e + 1;
                                         d = 0;
                                         k = l;
                                         while (1) {
                                          if (k) {
                                           d = e & 1 | d << 1;
                                           e = e >>> 1 | 0;
                                           k = k - 1 | 0;
                                           continue;
                                          }
                                          break;
                                         }
                                         if (l >>> 0 <= 10) {
                                          e = 1 << l;
                                          l = l << 9 | R;
                                          while (1) {
                                           if (d >>> 0 > 1023) {
                                            break _a;
                                           }
                                           u[(d << 1) + da >> 1] = l;
                                           d = d + e | 0;
                                           continue;
                                          }
                                         }
                                         e = ((d & 1023) << 1) + da | 0;
                                         k = u[e >> 1];
                                         $a: {
                                          if (k) {
                                           e = n;
                                           n = k;
                                           break $a;
                                          }
                                          u[e >> 1] = n;
                                          e = n - 2 | 0;
                                         }
                                         d = d >>> 9 | 0;
                                         while (1) {
                                          d = d >>> 1 | 0;
                                          k = d & 1;
                                          if (l >>> 0 >= 12) {
                                           k = z + (k + (n ^ -1) << 1) | 0;
                                           n = u[k >> 1];
                                           if (!n) {
                                            u[k >> 1] = e;
                                            n = e;
                                            e = e - 2 | 0;
                                           }
                                           l = l - 1 | 0;
                                           continue;
                                          }
                                          break;
                                         }
                                         u[z + (k + (n ^ -1) << 1) >> 1] = R;
                                         n = e;
                                        }
                                        R = R + 1 | 0;
                                        Q = v[i + 24 >> 2];
                                        k = v[ea + (Q << 2) >> 2];
                                        continue;
                                       }
                                       break;
                                      }
                                      ;
                                      d = 0;
                                      if ((Q | 0) != 2) {
                                       break Sa;
                                      }
                                      break Wa;

                                     case 1:
                                      k = u[(((h & 1023) << 1) + i | 0) + 7328 >> 1];
                                      ab: {
                                       if ((k | 0) >= 0) {
                                        if (k >>> 0 < 512 | k >>> 9 >>> 0 > f >>> 0) {
                                         break ab;
                                        }
                                        break Va;
                                       }
                                       if (f >>> 0 < 11) {
                                        break ab;
                                       }
                                       e = i + 9376 | 0;
                                       d = 10;
                                       while (1) {
                                        k = u[e + ((h >>> d & 1) + (k ^ -1) << 1) >> 1];
                                        if ((k | 0) < 0) {
                                         l = d + 2 | 0;
                                         d = d + 1 | 0;
                                         if (f >>> 0 >= l >>> 0) {
                                          continue;
                                         }
                                        }
                                        break;
                                       }
                                       if ((k | 0) >= 0) {
                                        break Va;
                                       }
                                      }
                                      d = 11;
                                      continue X;

                                     case 2:
                                      r = u[(((h & 1023) << 1) + i | 0) + 7328 >> 1];
                                      if ((r | 0) >= 0) {
                                       break Ya;
                                      }
                                      e = i + 9376 | 0;
                                      d = 10;
                                      while (1) {
                                       l = h >>> d | 0;
                                       d = d + 1 | 0;
                                       r = u[e + ((l & 1) + (r ^ -1) << 1) >> 1];
                                       if ((r | 0) < 0) {
                                        continue;
                                       }
                                       break;
                                      }
                                      ;
                                      break Xa;

                                     default:
                                      break Za;
                                     }
                                    }
                                    d = t[Y + 18432 | 0] + ((-1 << s ^ -1) & h) | 0;
                                    f = f - s | 0;
                                    h = h >>> s | 0;
                                    e = (i + 10532 | 0) + g | 0;
                                    Qb(e, (r | 0) == 16 ? w[e - 1 | 0] : 0, d);
                                    d = d + g | 0;
                                    break Wa;
                                   }
                                   d = r >>> 9 | 0;
                                   r = r & 511;
                                  }
                                  f = f - d | 0;
                                  h = h >>> d | 0;
                                  if (r >>> 0 > 15) {
                                   break Ua;
                                  }
                                  t[(g + i | 0) + 10532 | 0] = r;
                                  d = g + 1 | 0;
                                 }
                                 e = v[i + 48 >> 2];
                                 g = v[i + 44 >> 2];
                                 l = e + g | 0;
                                 if (l >>> 0 <= d >>> 0) {
                                  break Ta;
                                 }
                                 if (f >>> 0 <= 14) {
                                  if ((A - j | 0) <= 1) {
                                   g = d;
                                   d = 1;
                                   continue;
                                  }
                                  h = w[j | 0] << f | w[j + 1 | 0] << f + 8 | h;
                                  j = j + 2 | 0;
                                  f = f | 16;
                                 }
                                 g = d;
                                }
                                d = 2;
                                continue;
                               }
                               if (!((r | 0) != 16 | g)) {
                                n = -1;
                                g = 0;
                                z = 17;
                                r = 16;
                                break m;
                               }
                               Y = r - 16 | 0;
                               s = t[r + 22217 | 0];
                               if (s >>> 0 <= f >>> 0) {
                                break Ra;
                               }
                               d = 12;
                               continue X;
                              }
                              if ((d | 0) != (l | 0)) {
                               z = 21;
                               g = d;
                               n = -1;
                               break m;
                              }
                              l = i + 10532 | 0;
                              yc(i - -64 | 0, l, g);
                              yc(i + 3552 | 0, g + l | 0, e);
                              Q = v[i + 24 >> 2];
                              g = d;
                             }
                             U = Q - 1 | 0;
                             v[i + 24 >> 2] = U;
                             d = 0;
                             continue;
                            }
                            d = 3;
                            continue;
                           }
                          }
                          d = 2;
                         }
                         bb: while (1) {
                          cb: {
                           db: {
                            eb: {
                             fb: {
                              gb: {
                               hb: {
                                ib: {
                                 jb: {
                                  kb: {
                                   lb: {
                                    mb: {
                                     nb: {
                                      ob: {
                                       pb: {
                                        qb: {
                                         rb: {
                                          switch (d | 0) {
                                          case 0:
                                           k = u[(((h & 1023) << 1) + i | 0) + 352 >> 1];
                                           sb: {
                                            if ((k | 0) >= 0) {
                                             if (k >>> 0 < 512 | k >>> 9 >>> 0 > f >>> 0) {
                                              break sb;
                                             }
                                             break cb;
                                            }
                                            if (f >>> 0 < 11) {
                                             break sb;
                                            }
                                            e = i + 2400 | 0;
                                            d = 10;
                                            while (1) {
                                             k = u[e + ((h >>> d & 1) + (k ^ -1) << 1) >> 1];
                                             if ((k | 0) < 0) {
                                              l = d + 2 | 0;
                                              d = d + 1 | 0;
                                              if (f >>> 0 >= l >>> 0) {
                                               continue;
                                              }
                                             }
                                             break;
                                            }
                                            if ((k | 0) >= 0) {
                                             break cb;
                                            }
                                           }
                                           d = 13;
                                           continue X;

                                          case 1:
                                           g = u[(((h & 1023) << 1) + i | 0) + 352 >> 1];
                                           if ((g | 0) >= 0) {
                                            break qb;
                                           }
                                           e = i + 2400 | 0;
                                           d = 10;
                                           while (1) {
                                            l = h >>> d | 0;
                                            d = d + 1 | 0;
                                            g = u[e + ((l & 1) + (g ^ -1) << 1) >> 1];
                                            if ((g | 0) < 0) {
                                             continue;
                                            }
                                            break;
                                           }
                                           ;
                                           break pb;

                                          case 3:
                                           break fb;

                                          case 4:
                                           break gb;

                                          case 5:
                                           break lb;

                                          case 6:
                                           break mb;

                                          case 2:
                                           break rb;

                                          default:
                                           break nb;
                                          }
                                         }
                                         n = i + 2400 | 0;
                                         z = i + 352 | 0;
                                         while (1) {
                                          d = A - j | 0;
                                          if (!((G - o | 0) > 1 & (d | 0) >= 4)) {
                                           if (f >>> 0 > 14) {
                                            break cb;
                                           }
                                           if ((d | 0) <= 1) {
                                            d = 0;
                                            continue bb;
                                           }
                                           h = w[j | 0] << f | w[j + 1 | 0] << f + 8 | h;
                                           f = f | 16;
                                           j = j + 2 | 0;
                                           break cb;
                                          }
                                          if (f >>> 0 > 14) {
                                           l = j;
                                          } else {
                                           h = (w[j | 0] | w[j + 1 | 0] << 8) << f | h;
                                           f = f | 16;
                                           l = j + 2 | 0;
                                          }
                                          g = u[z + ((h & 1023) << 1) >> 1];
                                          tb: {
                                           if ((g | 0) < 0) {
                                            d = 10;
                                            while (1) {
                                             e = h >>> d | 0;
                                             d = d + 1 | 0;
                                             g = u[n + ((e & 1) + (g ^ -1) << 1) >> 1];
                                             if ((g | 0) < 0) {
                                              continue;
                                             }
                                             break;
                                            }
                                            break tb;
                                           }
                                           d = g >>> 9 | 0;
                                          }
                                          f = f - d | 0;
                                          h = h >>> d | 0;
                                          if (g & 256) {
                                           j = l;
                                           break ob;
                                          }
                                          if (f >>> 0 > 14) {
                                           e = f;
                                          } else {
                                           h = (w[l | 0] | w[l + 1 | 0] << 8) << f | h;
                                           l = l + 2 | 0;
                                           e = f | 16;
                                          }
                                          j = l;
                                          k = u[z + ((h & 1023) << 1) >> 1];
                                          ub: {
                                           if ((k | 0) < 0) {
                                            d = 10;
                                            while (1) {
                                             f = h >>> d | 0;
                                             d = d + 1 | 0;
                                             k = u[n + ((f & 1) + (k ^ -1) << 1) >> 1];
                                             if ((k | 0) < 0) {
                                              continue;
                                             }
                                             break;
                                            }
                                            break ub;
                                           }
                                           d = k >>> 9 | 0;
                                          }
                                          t[o | 0] = g;
                                          f = e - d | 0;
                                          h = h >>> d | 0;
                                          if (!(k & 256)) {
                                           t[o + 1 | 0] = k;
                                           o = o + 2 | 0;
                                           continue;
                                          }
                                          break;
                                         }
                                         o = o + 1 | 0;
                                         g = k;
                                         break ob;
                                        }
                                        d = g >>> 9 | 0;
                                        g = g & 511;
                                       }
                                       f = f - d | 0;
                                       h = h >>> d | 0;
                                       if (g >>> 0 > 255) {
                                        break ob;
                                       }
                                       d = 14;
                                       continue X;
                                      }
                                      e = g & 511;
                                      g = 256;
                                      if ((e | 0) == 256) {
                                       break Z;
                                      }
                                      d = e - 257 << 2;
                                      g = v[d + 80304 >> 2];
                                      s = 0;
                                      if (e - 285 >>> 0 < 4294967276) {
                                       break eb;
                                      }
                                      s = v[d + 80432 >> 2];
                                      if (s >>> 0 > f >>> 0) {
                                       d = 15;
                                       continue X;
                                      }
                                      d = 3;
                                      continue;
                                     }
                                     if (!g) {
                                      g = -1;
                                      break jb;
                                     }
                                     g = g - 1 | 0;
                                     d = 18;
                                     continue X;
                                    }
                                    f = f - s | 0;
                                    h = F >>> s | 0;
                                    r = ((-1 << s ^ -1) & F) + r | 0;
                                    break kb;
                                   }
                                   k = u[(((h & 1023) << 1) + i | 0) + 3840 >> 1];
                                   vb: {
                                    if ((k | 0) < 0) {
                                     e = i + 5888 | 0;
                                     d = 10;
                                     while (1) {
                                      l = h >>> d | 0;
                                      d = d + 1 | 0;
                                      k = u[e + ((l & 1) + (k ^ -1) << 1) >> 1];
                                      if ((k | 0) < 0) {
                                       continue;
                                      }
                                      break;
                                     }
                                     break vb;
                                    }
                                    d = k >>> 9 | 0;
                                    k = k & 511;
                                   }
                                   f = f - d | 0;
                                   F = h >>> d | 0;
                                   d = k << 2;
                                   r = v[d + 80560 >> 2];
                                   s = 0;
                                   if (k - 30 >>> 0 < 4294967270) {
                                    h = F;
                                    break kb;
                                   }
                                   s = v[d + 80688 >> 2];
                                   if (s >>> 0 <= f >>> 0) {
                                    break ib;
                                   }
                                   d = 17;
                                   continue X;
                                  }
                                  O = o - I | 0;
                                  d = (O - r & $) + I | 0;
                                  if ((d >>> 0 < o >>> 0 ? o : d) + g >>> 0 > G >>> 0) {
                                   break hb;
                                  }
                                  while (1) {
                                   if (g >>> 0 >= 3) {
                                    t[o | 0] = w[d | 0];
                                    t[o + 1 | 0] = w[d + 1 | 0];
                                    t[o + 2 | 0] = w[d + 2 | 0];
                                    g = g - 3 | 0;
                                    d = d + 3 | 0;
                                    o = o + 3 | 0;
                                    continue;
                                   }
                                   break;
                                  }
                                  if (!g) {
                                   g = 0;
                                   break jb;
                                  }
                                  t[o | 0] = w[d | 0];
                                  if ((g | 0) == 2) {
                                   t[o + 1 | 0] = w[d + 1 | 0];
                                  }
                                  o = g + o | 0;
                                 }
                                 d = 2;
                                 continue;
                                }
                                d = 6;
                                continue;
                               }
                               d = 7;
                               continue;
                              }
                              k = u[(((h & 1023) << 1) + i | 0) + 3840 >> 1];
                              wb: {
                               if ((k | 0) >= 0) {
                                if (k >>> 0 < 512 | k >>> 9 >>> 0 > f >>> 0) {
                                 break wb;
                                }
                                break db;
                               }
                               if (f >>> 0 < 11) {
                                break wb;
                               }
                               e = i + 5888 | 0;
                               d = 10;
                               while (1) {
                                k = u[e + ((h >>> d & 1) + (k ^ -1) << 1) >> 1];
                                if ((k | 0) < 0) {
                                 l = d + 2 | 0;
                                 d = d + 1 | 0;
                                 if (f >>> 0 >= l >>> 0) {
                                  continue;
                                 }
                                }
                                break;
                               }
                               if ((k | 0) >= 0) {
                                break db;
                               }
                              }
                              d = 16;
                              continue X;
                             }
                             f = f - s | 0;
                             g = ((-1 << s ^ -1) & h) + g | 0;
                             h = h >>> s | 0;
                            }
                            if (f >>> 0 > 14) {
                             break db;
                            }
                            if ((A - j | 0) <= 1) {
                             d = 4;
                             continue;
                            }
                            h = w[j | 0] << f | w[j + 1 | 0] << f + 8 | h;
                            f = f | 16;
                            j = j + 2 | 0;
                           }
                           d = 5;
                           continue;
                          }
                          d = 1;
                          continue;
                         }
                        }
                        if (!g | !f) {
                         break _;
                        }
                        if (f >>> 0 > 7) {
                         break $;
                        }
                        d = 5;
                        continue;
                       }
                       f = f - 8 | 0;
                       L = h >>> 8 | 0;
                       r = h & 255;
                       d = 6;
                       continue;
                      }
                      if (g) {
                       break Y;
                      }
                      g = 0;
                     }
                     if (t[i + 20 | 0] & 1) {
                      break p;
                     }
                     d = 0;
                     continue;
                    }
                    d = 7;
                    continue;
                   }
                  }
                  h = 0;
                  d = f >>> 3 | 0;
                  e = j - C | 0;
                  e = e >>> 0 <= j >>> 0 ? e : 0;
                  d = d >>> 0 < e >>> 0 ? d : e;
                  if ((f & -8) == d << 3) {
                   j = j - d | 0;
                   z = 34;
                   e = 0;
                   d = 0;
                   f = 0;
                   n = 0;
                   if (!(X & 1)) {
                    break m;
                   }
                   k = 0;
                   break o;
                  }
                  Z(6874, 13236, 2797, 6884);
                  p();
                 }
                 while (1) {
                  xb: {
                   yb: {
                    zb: {
                     Ab: {
                      Bb: {
                       switch (k | 0) {
                       case 0:
                        if (e >>> 0 > 3) {
                         n = 0;
                         z = 34;
                         g = e;
                         f = d;
                         break m;
                        }
                        f = 0;
                        if (!d) {
                         g = e;
                         break xb;
                        }
                        if (d >>> 0 > 7) {
                         break Ab;
                        }
                        k = 1;
                        continue;

                       case 1:
                        break Bb;

                       default:
                        break zb;
                       }
                      }
                      while (1) {
                       if (j >>> 0 >= A >>> 0) {
                        v[i >> 2] = 41;
                        l = 1;
                        g = e;
                        f = d;
                        break k;
                       }
                       h = w[j | 0] << d | h;
                       l = d >>> 0 > 4294967287;
                       j = j + 1 | 0;
                       d = d + 8 | 0;
                       if (l) {
                        continue;
                       }
                       break;
                      }
                     }
                     k = h & 255;
                     h = h >>> 8 | 0;
                     d = d - 8 | 0;
                     break yb;
                    }
                    if (j >>> 0 >= A >>> 0) {
                     v[i >> 2] = 42;
                     l = 1;
                     break k;
                    }
                    k = w[j | 0];
                    j = j + 1 | 0;
                    e = g;
                    d = f;
                   }
                   v[i + 16 >> 2] = v[i + 16 >> 2] << 8 | k;
                   e = e + 1 | 0;
                   k = 0;
                   continue;
                  }
                  k = 2;
                  continue;
                 }
                }
                g = 1;
               }
               v[i >> 2] = z;
               l = n;
              }
              d = f >>> 3 | 0;
              e = j - C | 0;
              e = e >>> 0 <= j >>> 0 ? e : 0;
              d = d >>> 0 < e >>> 0 ? d : e;
              j = j - d | 0;
              f = f - (d << 3) | 0;
             }
             v[i + 4 >> 2] = f;
             v[i + 60 >> 2] = O;
             v[i + 40 >> 2] = s;
             v[i + 36 >> 2] = g;
             v[i + 32 >> 2] = r;
             v[i + 56 >> 2] = (((f & 63) >>> 0 < 32 ? -1 << f : 0) ^ -1) & h;
             v[D + 12 >> 2] = j - C;
             f = o - N | 0;
             v[D + 8 >> 2] = f;
             if ((l | 0) < 0) {
              break i;
             }
             j = (f >>> 0) % 5552 | 0;
             g = v[i + 28 >> 2];
             h = g >>> 16 | 0;
             k = g & 65535;
             Cb: while (1) {
              Db: {
               e = 0;
               if (!f) {
                break Db;
               }
               d = N;
               while (1) if ((e | 7) >>> 0 >= j >>> 0) {
                e = j & 8184;
                while (1) {
                 if ((e | 0) != (j | 0)) {
                  e = e + 1 | 0;
                  k = w[d | 0] + k | 0;
                  h = k + h | 0;
                  d = d + 1 | 0;
                  continue;
                 }
                 break;
                }
                f = f - j | 0;
                h = (h >>> 0) % 65521 | 0;
                k = (k >>> 0) % 65521 | 0;
                N = j + N | 0;
                j = 5552;
                continue Cb;
               } else {
                g = w[d | 0] + k | 0;
                n = g + w[d + 1 | 0] | 0;
                F = n + w[d + 2 | 0] | 0;
                L = F + w[d + 3 | 0] | 0;
                E = L + w[d + 4 | 0] | 0;
                o = E + w[d + 5 | 0] | 0;
                C = o + w[d + 6 | 0] | 0;
                k = C + w[d + 7 | 0] | 0;
                h = k + (C + (o + (E + (L + (F + (n + (g + h | 0) | 0) | 0) | 0) | 0) | 0) | 0) | 0;
                d = d + 8 | 0;
                e = e + 8 | 0;
                continue;
               }
              }
              break;
             }
             g = h << 16 | k;
             v[i + 28 >> 2] = g;
             if (l) {
              break i;
             }
             l = 0;
             if (!(X & 1)) {
              break i;
             }
             l = (g | 0) != v[i + 16 >> 2] ? -2 : 0;
            }
            eb = _ + 144 | 0;
            v[i + 43780 >> 2] = l;
            g = v[D + 12 >> 2];
            v[q >> 2] = g + v[q >> 2];
            v[q + 4 >> 2] = v[q + 4 >> 2] - g;
            v[q + 8 >> 2] = g + v[q + 8 >> 2];
            v[q + 48 >> 2] = v[i + 28 >> 2];
            g = v[D + 8 >> 2];
            v[i + 10996 >> 2] = g;
            d = v[q + 16 >> 2];
            g = d >>> 0 > g >>> 0 ? g : d;
            yc(v[q + 12 >> 2], v[i + 10992 >> 2] + I | 0, g);
            v[q + 12 >> 2] = g + v[q + 12 >> 2];
            v[q + 16 >> 2] = v[q + 16 >> 2] - g;
            v[q + 20 >> 2] = g + v[q + 20 >> 2];
            d = v[i + 10996 >> 2];
            v[i + 10996 >> 2] = d - g;
            n = g + v[i + 10992 >> 2] & 32767;
            v[i + 10992 >> 2] = n;
            if ((l | 0) < 0) {
             break h;
            }
            if (!((l | 0) != 1 | fa)) {
             e = -5;
             break g;
            }
            if (l) {
             e = 0;
             h = v[q + 4 >> 2];
             if (!h | !v[q + 16 >> 2]) {
              break g;
             }
             if ((d | 0) == (g | 0)) {
              continue;
             }
             break g;
            }
            break;
           }
           e = (d | 0) == (g | 0);
           break g;
          }
          d = v[q + 16 >> 2];
          g = d >>> 0 > g >>> 0 ? g : d;
          yc(v[q + 12 >> 2], (v[i + 10992 >> 2] + i | 0) + 11012 | 0, g);
          v[q + 12 >> 2] = g + v[q + 12 >> 2];
          v[q + 16 >> 2] = v[q + 16 >> 2] - g;
          v[q + 20 >> 2] = g + v[q + 20 >> 2];
          d = v[i + 10996 >> 2];
          v[i + 10996 >> 2] = d - g;
          v[i + 10992 >> 2] = g + v[i + 10992 >> 2] & 32767;
          if (v[i + 43780 >> 2]) {
           break g;
          }
          e = (d | 0) == (g | 0);
          break g;
         }
         e = -3;
        }
        eb = D + 16 | 0;
        g = e;
        d = v[m + 1084 >> 2] - V | 0;
        v[m + 1084 >> 2] = d;
        e = J + ca | 0;
        J = v[m + 1104 >> 2];
        ca = e - J | 0;
        continue;
       }
       break;
      }
      b = m + 1088 | 0;
      Eb: {
       if (!b) {
        break Eb;
       }
       d = v[b + 28 >> 2];
       if (!d) {
        break Eb;
       }
       hb[v[b + 36 >> 2]](v[b + 40 >> 2], d);
       v[b + 28 >> 2] = 0;
      }
      d = 0;
      if (!((w[m + 1156 | 0] | w[m + 1157 | 0] << 8 | (w[m + 1158 | 0] << 16 | w[m + 1159 | 0] << 24)) != (ba | 0) | (g | 0) != 1 | J)) {
       oe(m + 24 | 0, v[S >> 2], v[S + 4 >> 2]);
       b = Ld(m + 16 | 0);
       v[31601] = 0;
       g = v[b + 4 >> 2];
       v[m + 8 >> 2] = v[b >> 2];
       v[m + 12 >> 2] = g;
       b = gg(554, m + 48 | 0, v[m + 24 >> 2], v[m + 28 >> 2], m + 8 | 0);
       g = v[31601];
       v[31601] = 0;
       if ((g | 0) == 1) {
        break d;
       }
       v[31601] = 0;
       d = T(912, a | 0, b | 0, c | 0) | 0;
       a = v[31601];
       v[31601] = 0;
       if ((a | 0) == 1) {
        break c;
       }
       tb(b);
      }
      ec(S);
     }
     eb = m + 1168 | 0;
     return d | 0;
    }
    a = M() | 0;
    break a;
   }
   a = M() | 0;
   tb(b);
   break a;
  }
  a = M() | 0;
 }
 ec(S);
 P(a | 0);
 p();
}

function roa(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = C(0), k = 0, l = 0, m = 0, n = 0, o = 0, q = 0, r = 0, s = 0, A = 0, D = 0, E = 0, F = C(0), G = 0, H = 0, I = 0, J = 0, K = 0, L = 0, S = 0, W = 0, X = 0, Y = 0, Z = 0, _ = 0, $ = 0, ba = 0, ca = 0, da = 0, ea = C(0), fa = 0, ha = 0, ia = 0, ja = 0, ka = 0;
 f = eb - 608 | 0;
 eb = f;
 xc(b);
 a: {
  b: {
   c: {
    e = f + 600 | 0;
    if (!ui(b, e)) {
     break c;
    }
    if (!jW(e)) {
     break c;
    }
    if ((op(b) | 0) >= 0) {
     break c;
    }
    d = 1;
    if ((c | 0) == 64) {
     break c;
    }
    Cd(a, 16777216);
    v[a + 480208 >> 2] = v[a + 480208 >> 2] | 1681e4;
    sr(f + 256 | 0, 32);
    e = v[f + 268 >> 2];
    d = a + 1074320 | 0;
    v[d >> 2] = v[f + 264 >> 2];
    v[d + 4 >> 2] = e;
    d = v[f + 260 >> 2];
    v[a + 1074312 >> 2] = v[f + 256 >> 2];
    v[a + 1074316 >> 2] = d;
    ag(a + 1074312 | 0, 38);
    r = Mb(f + 588 | 0);
    s = Mb(f + 576 | 0);
    E = Mb(f + 564 | 0);
    k = Mb(f + 552 | 0);
    Hh(b, 4);
    o = a + 484380 | 0;
    m = a + 480190 | 0;
    K = c & 1;
    G = a + 1298332 | 0;
    q = 2500;
    H = !(c & 2);
    d: {
     e: {
      f: {
       while (1) {
        c = v[b + 8 >> 2];
        d = v[b >> 2];
        v[31601] = 0;
        c = T(150, d | 0, c | 0, 4) | 0;
        d = v[31601];
        v[31601] = 0;
        g: {
         h: {
          i: {
           j: {
            k: {
             l: {
              m: {
               n: {
                if ((d | 0) != 1) {
                 o: {
                  if (c) {
                   v[31601] = 0;
                   c = Q(710, b | 0) | 0;
                   d = v[31601];
                   v[31601] = 0;
                   p: {
                    if ((d | 0) == 1) {
                     break p;
                    }
                    n = 4;
                    d = 0;
                    q: {
                     r: {
                      s: {
                       switch (c + 21 | 0) {
                       case 20:
                        v[31601] = 0;
                        c = Q(281, b | 0) | 0;
                        d = v[31601];
                        v[31601] = 0;
                        if ((d | 0) != 1) {
                         d = c & 65535;
                         if (x[a + 480188 >> 1] | d - 1 >>> 0 > 126) {
                          continue;
                         }
                         u[a + 480188 >> 1] = c;
                         ja = a, ka = Xb(512 / (d >>> 0) | 0, 16, 128), v[ja + 480228 >> 2] = ka;
                         continue;
                        }
                        c = M() | 0;
                        break a;

                       case 19:
                        v[31601] = 0;
                        S = Q(281, b | 0) | 0;
                        c = v[31601];
                        v[31601] = 0;
                        if ((c | 0) == 1) {
                         break p;
                        }
                        if (S >>> 0 <= 1024) {
                         continue;
                        }
                        break n;

                       case 16:
                        v[31601] = 0;
                        c = Q(281, b | 0) | 0;
                        e = v[31601];
                        v[31601] = 0;
                        if ((e | 0) != 1) {
                         if ((c & 65535) == 4) {
                          continue;
                         }
                         break n;
                        }
                        c = M() | 0;
                        break a;

                       case 15:
                        v[31601] = 0;
                        c = Q(281, b | 0) | 0;
                        d = v[31601];
                        v[31601] = 0;
                        if ((d | 0) != 1) {
                         v[f + 256 >> 2] = c;
                         v[f + 152 >> 2] = 800;
                         ja = a, ka = Te(+y[Gb(f + 256 | 0, f + 152 | 0) >> 2] * 1.24 * 1e4), v[ja + 480204 >> 2] = ka;
                         continue;
                        }
                        c = M() | 0;
                        break a;

                       case 31:
                        v[31601] = 0;
                        c = Q(281, b | 0) | 0;
                        d = v[31601];
                        v[31601] = 0;
                        if ((d | 0) == 1) {
                         break p;
                        }
                        Z = 1;
                        q = Kd(c, 0, 1e4);
                        continue;

                       case 32:
                       case 33:
                        v[31601] = 0;
                        c = Q(281, b | 0) | 0;
                        d = v[31601];
                        v[31601] = 0;
                        t: {
                         u: {
                          if ((d | 0) != 1) {
                           Z = 1;
                           if (!c) {
                            continue;
                           }
                           v[31601] = 0;
                           d = O(1, f + 540 | 0, 12615) | 0;
                           c = v[31601];
                           v[31601] = 0;
                           if ((c | 0) == 1) {
                            break u;
                           }
                           c = v[a + 1298472 >> 2];
                           v[31601] = 0;
                           R(385, c | 0, 2, d | 0);
                           c = v[31601];
                           v[31601] = 0;
                           if ((c | 0) == 1) {
                            break t;
                           }
                           sb(d);
                           continue;
                          }
                          c = M() | 0;
                          break a;
                         }
                         c = M() | 0;
                         break a;
                        }
                        c = M() | 0;
                        sb(d);
                        break a;

                       case 14:
                        v[31601] = 0;
                        O(183, b | 0, 4) | 0;
                        c = v[31601];
                        v[31601] = 0;
                        if ((c | 0) == 1) {
                         break p;
                        }
                        h = !x[m >> 1] | h;
                        continue;

                       case 11:
                        if (!K) {
                         break r;
                        }
                        if (!lc(v[r >> 2], v[r + 4 >> 2])) {
                         break r;
                        }
                        v[31601] = 0;
                        c = f + 256 | 0;
                        N(711, c | 0, b | 0);
                        d = v[31601];
                        v[31601] = 0;
                        if ((d | 0) != 1) {
                         if (v[r >> 2]) {
                          Mc(r);
                          d = v[r >> 2];
                          Yo(r);
                          Bb(d);
                          ja = zb(r), ka = 0, v[ja >> 2] = ka;
                          v[r >> 2] = 0;
                          v[r + 4 >> 2] = 0;
                         }
                         v[r >> 2] = v[c >> 2];
                         v[r + 4 >> 2] = v[c + 4 >> 2];
                         d = zb(c);
                         ja = zb(r), ka = v[d >> 2], v[ja >> 2] = ka;
                         v[d >> 2] = 0;
                         v[c >> 2] = 0;
                         v[c + 4 >> 2] = 0;
                         Pi(c);
                         continue;
                        }
                        c = M() | 0;
                        break a;

                       case 3:
                       case 4:
                       case 10:
                        e = Qh(v[k >> 2], v[k + 4 >> 2]);
                        d = x[m >> 1];
                        if (e >>> 0 <= d >>> 0) {
                         continue;
                        }
                        if ((h | H) & 1) {
                         break r;
                        }
                        if (!ni(d)) {
                         break r;
                        }
                        d = d + 1 | 0;
                        u[m >> 1] = d;
                        D = Mb(f + 528 | 0);
                        v[31601] = 0;
                        n = Q(168, f + 508 | 0) | 0;
                        e = v[31601];
                        v[31601] = 0;
                        v: {
                         w: {
                          x: {
                           if ((e | 0) != 1) {
                            if ((c | 0) == -17) {
                             break x;
                            }
                            if ((c | 0) != -11) {
                             break w;
                            }
                            v[31601] = 0;
                            e = Q(281, b | 0) | 0;
                            c = v[31601];
                            v[31601] = 0;
                            if ((c | 0) == 1) {
                             break v;
                            }
                            v[31601] = 0;
                            c = f + 152 | 0;
                            R(185, c | 0, b | 0, e | 0);
                            e = v[31601];
                            v[31601] = 0;
                            if ((e | 0) == 1) {
                             break v;
                            }
                            e = gc(f + 256 | 0, c);
                            jd(n, e);
                            tb(e);
                            break g;
                           }
                           c = M() | 0;
                           break d;
                          }
                          v[31601] = 0;
                          c = f + 256 | 0;
                          N(712, c | 0, b | 0);
                          e = v[31601];
                          v[31601] = 0;
                          y: {
                           if ((e | 0) != 1) {
                            e = yn(D, c);
                            ec(c);
                            oe(f + 480 | 0, v[e >> 2], v[f + 532 >> 2]);
                            c = Ld(f + 472 | 0);
                            v[31601] = 0;
                            e = v[c + 4 >> 2];
                            v[f + 16 >> 2] = v[c >> 2];
                            v[f + 20 >> 2] = e;
                            c = gg(327, f + 488 | 0, v[f + 480 >> 2], v[f + 484 >> 2], f + 16 | 0);
                            e = v[31601];
                            v[31601] = 0;
                            if ((e | 0) == 1) {
                             break y;
                            }
                            jd(n, c);
                            break g;
                           }
                           c = M() | 0;
                           break e;
                          }
                          c = M() | 0;
                          break e;
                         }
                         v[31601] = 0;
                         c = f + 256 | 0;
                         N(713, c | 0, b | 0);
                         e = v[31601];
                         v[31601] = 0;
                         z: {
                          if ((e | 0) != 1) {
                           e = yn(D, c);
                           ec(c);
                           oe(f + 440 | 0, v[e >> 2], v[f + 532 >> 2]);
                           c = Ld(f + 432 | 0);
                           v[31601] = 0;
                           e = v[c + 4 >> 2];
                           v[f + 8 >> 2] = v[c >> 2];
                           v[f + 12 >> 2] = e;
                           c = gg(327, f + 452 | 0, v[f + 440 >> 2], v[f + 444 >> 2], f + 8 | 0);
                           e = v[31601];
                           v[31601] = 0;
                           if ((e | 0) == 1) {
                            break z;
                           }
                           jd(n, c);
                           break g;
                          }
                          c = M() | 0;
                          break e;
                         }
                         c = M() | 0;
                         break e;
                        }
                        c = M() | 0;
                        break e;

                       case 9:
                        c = x[m >> 1];
                        if (!ni(c)) {
                         continue;
                        }
                        u[m >> 1] = c + 1;
                        continue;

                       case 8:
                        if (!K) {
                         break r;
                        }
                        if (!lc(v[E >> 2], v[E + 4 >> 2])) {
                         break r;
                        }
                        v[31601] = 0;
                        c = f + 256 | 0;
                        N(714, c | 0, b | 0);
                        d = v[31601];
                        v[31601] = 0;
                        if ((d | 0) != 1) {
                         iW(E, c);
                         uc(c);
                         continue;
                        }
                        c = M() | 0;
                        break a;

                       case 7:
                        if (!lc(v[k >> 2], v[k + 4 >> 2])) {
                         break r;
                        }
                        v[31601] = 0;
                        c = f + 256 | 0;
                        N(715, c | 0, b | 0);
                        d = v[31601];
                        v[31601] = 0;
                        if ((d | 0) != 1) {
                         if (v[k >> 2]) {
                          Mc(k);
                          d = v[k >> 2];
                          pC(k);
                          Bb(d);
                          ja = zb(k), ka = 0, v[ja >> 2] = ka;
                          v[k >> 2] = 0;
                          v[k + 4 >> 2] = 0;
                         }
                         v[k >> 2] = v[c >> 2];
                         v[k + 4 >> 2] = v[c + 4 >> 2];
                         d = zb(c);
                         ja = zb(k), ka = v[d >> 2], v[ja >> 2] = ka;
                         v[d >> 2] = 0;
                         v[c >> 2] = 0;
                         v[c + 4 >> 2] = 0;
                         uv(c);
                         continue;
                        }
                        c = M() | 0;
                        break a;

                       case 6:
                        if (!K) {
                         break r;
                        }
                        if (!lc(v[s >> 2], v[s + 4 >> 2])) {
                         break r;
                        }
                        v[31601] = 0;
                        c = f + 256 | 0;
                        N(716, c | 0, b | 0);
                        d = v[31601];
                        v[31601] = 0;
                        if ((d | 0) != 1) {
                         if (v[s >> 2]) {
                          Mc(s);
                          d = v[s >> 2];
                          lv(s);
                          Bb(d);
                          ja = zb(s), ka = 0, v[ja >> 2] = ka;
                          v[s >> 2] = 0;
                          v[s + 4 >> 2] = 0;
                         }
                         v[s >> 2] = v[c >> 2];
                         v[s + 4 >> 2] = v[c + 4 >> 2];
                         d = zb(c);
                         ja = zb(s), ka = v[d >> 2], v[ja >> 2] = ka;
                         v[d >> 2] = 0;
                         v[c >> 2] = 0;
                         v[c + 4 >> 2] = 0;
                         jn(c);
                         continue;
                        }
                        c = M() | 0;
                        break a;

                       case 17:
                       case 18:
                        break q;

                       case 0:
                       case 1:
                       case 2:
                        break r;

                       case 5:
                        break s;

                       default:
                        break n;
                       }
                      }
                      v[31601] = 0;
                      d = f + 256 | 0;
                      N(717, d | 0, b | 0);
                      c = v[31601];
                      v[31601] = 0;
                      if ((c | 0) == 1) {
                       break o;
                      }
                      A: {
                       c = v[f + 256 >> 2];
                       e = v[f + 260 >> 2];
                       if (lc(c, e)) {
                        break A;
                       }
                       v[31601] = 0;
                       U(343, G | 0, c | 0, Sc(c, e) | 0, 1);
                       c = v[31601];
                       v[31601] = 0;
                       if ((c | 0) != 1) {
                        break A;
                       }
                       c = M() | 0;
                       ec(d);
                       break a;
                      }
                      ec(f + 256 | 0);
                      continue;
                     }
                     v[31601] = 0;
                     n = Q(281, b | 0) | 0;
                     c = v[31601];
                     v[31601] = 0;
                     if ((c | 0) == 1) {
                      break p;
                     }
                    }
                    v[31601] = 0;
                    O(183, b | 0, n | 0) | 0;
                    c = v[31601];
                    v[31601] = 0;
                    if ((c | 0) != 1) {
                     continue;
                    }
                   }
                   c = M() | 0;
                   break a;
                  }
                  d = 0;
                  if (!x[a + 480188 >> 1] | !S) {
                   break n;
                  }
                  b = v[k >> 2];
                  c = v[k + 4 >> 2];
                  if (lc(b, c)) {
                   break n;
                  }
                  if (K) {
                   if (lc(v[r >> 2], v[r + 4 >> 2])) {
                    break n;
                   }
                   if (lc(v[E >> 2], v[E + 4 >> 2])) {
                    break n;
                   }
                   if (lc(v[s >> 2], v[s + 4 >> 2])) {
                    break n;
                   }
                  }
                  b = Qh(b, c);
                  if (b >>> 0 >= 256) {
                   v[31601] = 0;
                   N(718, k | 0, 255);
                   b = v[31601];
                   v[31601] = 0;
                   if ((b | 0) == 1) {
                    break b;
                   }
                   b = Qh(v[k >> 2], v[k + 4 >> 2]);
                  }
                  u[a + 480192 >> 1] = b;
                  n = a + 480192 | 0;
                  ja = a, ka = x[qe(m, n) >> 1], u[ja + 480190 >> 1] = ka;
                  if (h & 1) {
                   v[31601] = 0;
                   b = O(1, f + 528 | 0, 16481) | 0;
                   c = v[31601];
                   v[31601] = 0;
                   if ((c | 0) == 1) {
                    break h;
                   }
                   c = v[a + 1298472 >> 2];
                   v[31601] = 0;
                   R(385, c | 0, 2, b | 0);
                   c = v[31601];
                   v[31601] = 0;
                   if ((c | 0) == 1) {
                    break i;
                   }
                   sb(b);
                  }
                  i = a + 946304 | 0;
                  h = 0;
                  B: while (1) {
                   if ((h | 0) != 2) {
                    d = 1;
                    while (1) {
                     g = d & 65535;
                     if (g >>> 0 > x[n >> 1]) {
                      h = h + 1 | 0;
                      continue B;
                     }
                     C: {
                      e = gn(v[k >> 2], g - 1 | 0);
                      if (!w[e | 0] | t[e + 128 | 0] < 0) {
                       break C;
                      }
                      if ((rv(e) | 0) == ((h | 0) != 1 | 0)) {
                       break C;
                      }
                      D: {
                       E: {
                        F: {
                         c = 0;
                         G: {
                          if (!rv(e)) {
                           break G;
                          }
                          if (Ab(w[e + 6 | 0] | w[e + 7 | 0] << 8)) {
                           break G;
                          }
                          if (Ab(w[e + 14 | 0] | w[e + 15 | 0] << 8) >>> 0 > 20) {
                           break G;
                          }
                          c = (Ab(w[e + 18 | 0] | w[e + 19 | 0] << 8) | 0) == 4;
                         }
                         H: {
                          I: {
                           if (c) {
                            c = w[e + 23 | 0];
                            b = w[e + 140 | 0];
                            v[31601] = 0;
                            b = ga(719, e | 0, a | 0, (b & 2) >>> 1 | 0, o + B(g, 104) | 0, q & 65535) | 0;
                            l = v[31601];
                            v[31601] = 0;
                            J: {
                             K: {
                              if ((l | 0) != 1) {
                               if (!b) {
                                break J;
                               }
                               v[31601] = 0;
                               b = O(36, f + 384 | 0, 10755) | 0;
                               l = v[31601];
                               v[31601] = 0;
                               if ((l | 0) == 1) {
                                break K;
                               }
                               zc(i + (g << 5) | 0, b);
                               sb(b);
                               l = v[k >> 2];
                               b = d;
                               if (Qh(l, v[k + 4 >> 2]) >>> 0 <= c >>> 0) {
                                break H;
                               }
                               ja = e, ka = w[e + 143 | 0] + w[gn(l, c) + 143 | 0] | 0, t[ja + 143 | 0] = ka;
                               break I;
                              }
                              c = M() | 0;
                              break a;
                             }
                             c = M() | 0;
                             break a;
                            }
                            b = c + 1 | 0;
                            break H;
                           }
                           c = 0;
                           L: {
                            if (!rv(e)) {
                             break L;
                            }
                            if ((Ab(w[e + 6 | 0] | w[e + 7 | 0] << 8) | 0) != 1) {
                             break L;
                            }
                            if ((Ab(w[e + 14 | 0] | w[e + 15 | 0] << 8) | 0) != 2) {
                             break L;
                            }
                            c = (Ab(w[e + 18 | 0] | w[e + 19 | 0] << 8) | 0) == 10;
                           }
                           b = d;
                           if (!c) {
                            break H;
                           }
                           c = f + 256 | 0;
                           aW(c, e);
                           b = Ab(w[f + 276 | 0] | w[f + 277 | 0] << 8);
                           if (b >>> 0 >= x[m >> 1]) {
                            break I;
                           }
                           v[31601] = 0;
                           l = Q(708, f + 152 | 0) | 0;
                           A = v[31601];
                           v[31601] = 0;
                           if ((A | 0) == 1) {
                            break F;
                           }
                           A = w[f + 292 | 0] | w[f + 293 | 0] << 8;
                           D = x[m >> 1];
                           v[31601] = 0;
                           G = (o + B(b, 104) | 0) + 104 | 0;
                           b = Ab(A);
                           b = aa(720, c | 0, G | 0, (b >>> 0 < D >>> 0 ? (o + B(b, 104) | 0) + 104 | 0 : l) | 0, o + B(g, 104) | 0) | 0;
                           c = v[31601];
                           v[31601] = 0;
                           if ((c | 0) == 1) {
                            break E;
                           }
                           if (!b) {
                            break I;
                           }
                           v[31601] = 0;
                           b = O(36, f + 140 | 0, 11253) | 0;
                           c = v[31601];
                           v[31601] = 0;
                           if ((c | 0) == 1) {
                            break D;
                           }
                           zc(i + (g << 5) | 0, b);
                           sb(b);
                           t[e + 139 | 0] = w[e + 139 | 0] + 12;
                          }
                          b = d;
                         }
                         v[31601] = 0;
                         b = b & 65535;
                         c = T(251, a | 0, g | 0, b | 0) | 0;
                         g = v[31601];
                         v[31601] = 0;
                         if ((g | 0) != 1) {
                          if (!c | b >>> 0 > x[m >> 1]) {
                           break C;
                          }
                          v[31601] = 0;
                          U(721, e | 0, c | 0, o + B(b, 104) | 0, a | 0);
                          b = v[31601];
                          v[31601] = 0;
                          if ((b | 0) != 1) {
                           break C;
                          }
                         }
                         c = M() | 0;
                         break a;
                        }
                        c = M() | 0;
                        break a;
                       }
                       c = M() | 0;
                       break a;
                      }
                      c = M() | 0;
                      break a;
                     }
                     d = d + 1 | 0;
                     continue;
                    }
                   }
                   break;
                  }
                  H = ng(f + 128 | 0);
                  A = ng(f + 116 | 0);
                  b = nc(v[E >> 2], v[E + 4 >> 2]);
                  _ = B(x[a + 480188 >> 1], S);
                  $ = $l((b >>> 0) / (_ >>> 0) | 0);
                  v[31601] = 0;
                  X = a + 484344 | 0;
                  N(223, X | 0, $ | 0);
                  b = v[31601];
                  v[31601] = 0;
                  if ((b | 0) == 1) {
                   break k;
                  }
                  Mc(Wb(v[a + 484360 >> 2], w[a + 484376 | 0]));
                  b = x[a + 480188 >> 1];
                  v[31601] = 0;
                  D = O(722, f + 104 | 0, b | 0) | 0;
                  b = v[31601];
                  v[31601] = 0;
                  if ((b | 0) == 1) {
                   break l;
                  }
                  ja = f, ka = vb(v[s >> 2]), v[ja + 52 >> 2] = ka;
                  fa = a + 902204 | 0;
                  ha = vb(v[s + 4 >> 2]);
                  while (1) {
                   M: {
                    N: {
                     m = v[f + 52 >> 2];
                     if (!Hb(m, ha)) {
                      break N;
                     }
                     b = ye((w[m + 6 | 0] | w[m + 7 | 0] << 8) << 16 >> 16);
                     if ((b | 0) == 1) {
                      break M;
                     }
                     if ((b & 65535) == 65535) {
                      break N;
                     }
                     e = Ab(w[m | 0] | w[m + 1 | 0] << 8);
                     b = v[r >> 2];
                     g = v[r + 4 >> 2];
                     c = Lg(b, g);
                     if (e >>> 0 >= c >>> 0) {
                      break M;
                     }
                     d = Ab(w[m + 2 | 0] | w[m + 3 | 0] << 8);
                     if (d >>> 0 > c >>> 0 | !d | e >>> 0 > c - d >>> 0) {
                      break M;
                     }
                     c = b + (Lg(b, g) << 5) | 0;
                     v[f + 256 >> 2] = b;
                     v[f + 260 >> 2] = c - b >> 5;
                     b = v[f + 256 >> 2];
                     Yb(f + 76 | 0, b + (Ab(w[m | 0] | w[m + 1 | 0] << 8) << 5) | 0, Ab(w[m + 2 | 0] | w[m + 3 | 0] << 8));
                     O: {
                      I = Wb(v[a + 484360 >> 2], w[a + 484376 | 0]);
                      if (lc(v[I >> 2], v[I + 4 >> 2])) {
                       break O;
                      }
                      v[31601] = 0;
                      N(536, I | 0, 65534);
                      b = v[31601];
                      v[31601] = 0;
                      if ((b | 0) != 1) {
                       break O;
                      }
                      break m;
                     }
                     ja = f, ka = vb(v[f + 76 >> 2]), v[ja + 40 >> 2] = ka;
                     b = eb - 16 | 0;
                     eb = b;
                     ia = v[ub(b + 12 | 0, v[f + 76 >> 2] + (v[f + 80 >> 2] << 5) | 0) >> 2];
                     eb = b + 16 | 0;
                     while (1) {
                      i = v[f + 40 >> 2];
                      if (!Hb(i, ia)) {
                       break M;
                      }
                      b = ye(ye((w[m + 8 | 0] | w[m + 9 | 0] << 8) << 16 >> 16) + ye((w[i + 16 | 0] | w[i + 17 | 0] << 8) << 16 >> 16) << 16 >> 16);
                      t[i + 16 | 0] = b;
                      t[i + 17 | 0] = b >>> 8;
                      b = ce(H);
                      while (1) {
                       P: {
                        c = 0;
                        if (!b) {
                         break P;
                        }
                        d = b + 14 | 0;
                        if (!nv(i, d)) {
                         c = 1;
                         if (!nv(d, i)) {
                          break P;
                         }
                         b = b + 4 | 0;
                        }
                        b = v[b >> 2];
                        continue;
                       }
                       break;
                      }
                      Q: {
                       R: {
                        S: {
                         if (c) {
                          v[31601] = 0;
                          b = O(723, H | 0, i | 0) | 0;
                          c = v[31601];
                          v[31601] = 0;
                          if ((c | 0) == 1) {
                           break m;
                          }
                          G = x[b >> 1];
                          break S;
                         }
                         G = 0;
                         if (!K) {
                          break S;
                         }
                         b = w[i + 12 | 0] | w[i + 13 | 0] << 8;
                         v[31601] = 0;
                         G = O(367, X | 0, Ab(b) | 0) | 0;
                         b = v[31601];
                         v[31601] = 0;
                         if ((b | 0) == 1) {
                          break m;
                         }
                         if ((G | 0) == 65535) {
                          break M;
                         }
                         v[31601] = 0;
                         b = O(723, H | 0, i | 0) | 0;
                         c = v[31601];
                         v[31601] = 0;
                         if ((c | 0) == 1) {
                          break m;
                         }
                         u[b >> 1] = G;
                         if (Ab(w[i + 8 | 0] | w[i + 9 | 0] << 8) >>> 0 >= $ >>> 0) {
                          break R;
                         }
                         if (Ab(w[i + 10 | 0] | w[i + 11 | 0] << 8) >>> 0 >= S >>> 0) {
                          break R;
                         }
                         q = Ab(w[i + 14 | 0] | w[i + 15 | 0] << 8);
                         c = Dk(vb(v[E >> 2]), B(Ab(w[i + 8 | 0] | w[i + 9 | 0] << 8), _));
                         b = x[a + 480188 >> 1];
                         ja = f, ka = Dk(c, B(b, Ab(w[i + 10 | 0] | w[i + 11 | 0] << 8))), v[ja + 28 >> 2] = ka;
                         W = 0;
                         v[f + 100 >> 2] = 0;
                         o = Mg(f - -64 | 0);
                         T: while (1) {
                          U: {
                           d = Ab(w[i + 12 | 0] | w[i + 13 | 0] << 8);
                           c = Vb(v[X >> 2], G);
                           if (d >>> 0 <= W >>> 0) {
                            break U;
                           }
                           n = 0;
                           Y = ld(v[c >> 2], v[v[c + 48 >> 2] + 12 >> 2], W, 0);
                           c = 0;
                           while (1) {
                            if ((b & 65535) >>> 0 <= n >>> 0) {
                             W = W + 1 | 0;
                             continue T;
                            }
                            b = vb(v[E + 4 >> 2]);
                            d = v[f + 28 >> 2];
                            g = Hb(d, b) ? d : f + 100 | 0;
                            b = vb(v[E + 4 >> 2]);
                            if (Hb(v[f + 28 >> 2], b)) {
                             gW(f + 28 | 0);
                            }
                            d = Y + B(n, 6) | 0;
                            e = w[g + 1 | 0];
                            b = (e >>> 0 >= 85 ? -1 : e + 25 | 0) << 24 >> 24;
                            l = 0;
                            h = v[k >> 2];
                            L = Qh(h, v[k + 4 >> 2]);
                            J = w[g + 3 | 0];
                            V: {
                             if (L >>> 0 <= J >>> 0) {
                              break V;
                             }
                             l = J + 1 | 0;
                             if (t[gn(h, J) + 142 | 0] & 1 | (b | 0) < 0) {
                              break V;
                             }
                             b = ye((w[i + 16 | 0] | w[i + 17 | 0] << 8) << 16 >> 16) + b << 24 >> 24;
                             ba = b & 255;
                             b = (b | 0) <= 0 ? 1 : ba >>> 0 >= 120 ? 120 : ba;
                            }
                            W: {
                             if (!w[d | 0] | !(w[g | 0] | (e | 0) != 255 | J | w[g + 2 | 0])) {
                              break W;
                             }
                             e = w[d + 1 | 0];
                             if (!e | e >>> 0 > L >>> 0) {
                              break W;
                             }
                             if (w[gn(h, e - 1 | 0) + 132 | 0] != 2) {
                              break W;
                             }
                             Vo(d);
                            }
                            e = tv(v[D >> 2], n);
                            X: {
                             Y: {
                              if (!(c & 1)) {
                               h = w[g | 0];
                               break Y;
                              }
                              c = w[o | 0] | w[o + 1 | 0] << 8 | (w[o + 2 | 0] << 16 | w[o + 3 | 0] << 24);
                              t[d | 0] = c;
                              t[d + 1 | 0] = c >>> 8;
                              t[d + 2 | 0] = c >>> 16;
                              t[d + 3 | 0] = c >>> 24;
                              c = w[o + 4 | 0] | w[o + 5 | 0] << 8;
                              t[d + 4 | 0] = c;
                              t[d + 5 | 0] = c >>> 8;
                              Z: {
                               if (w[d + 3 | 0]) {
                                break Z;
                               }
                               h = w[e + 21 | 0];
                               c = w[tv(v[D >> 2], n - 1 | 0) + 21 | 0];
                               if ((h | 0) == (c | 0)) {
                                break Z;
                               }
                               t[d + 3 | 0] = 21;
                               t[e + 21 | 0] = c;
                               t[d + 5 | 0] = c;
                              }
                              c = 0;
                              h = w[g | 0];
                              if (!(h - 24 >>> 0 < 2 | (h | 0) == 9 | !h & (w[g + 2 | 0] + 7 & 255) >>> 0 < 2)) {
                               break X;
                              }
                             }
                             _: {
                              $: {
                               aa: {
                                ba: {
                                 switch (h | 0) {
                                 case 5:
                                  c = w[e + 17 | 0];
                                  break aa;

                                 case 0:
                                  ca: {
                                   da: {
                                    c = w[g + 2 | 0];
                                    if (c >>> 0 >= 201) {
                                     h = 0;
                                     ea: {
                                      switch (c - 242 | 0) {
                                      case 11:
                                       t[d + 4 | 0] = 1;
                                       t[d + 2 | 0] = 14;
                                       t[e + 16 | 0] = 0;
                                       break ca;

                                      case 9:
                                       if (!w[d | 0]) {
                                        t[d | 0] = w[e + 17 | 0];
                                       }
                                       t[d + 4 | 0] = 1;
                                       t[d + 2 | 0] = 15;
                                       break ca;

                                      case 8:
                                       if ((q & 255) >>> 0 < 2) {
                                        break ca;
                                       }
                                       t[d + 3 | 0] = 16;
                                       q = q - 1 | 0;
                                       t[d + 5 | 0] = q;
                                       break ca;

                                      case 7:
                                       if ((q & 255) == 255) {
                                        q = 255;
                                        break ca;
                                       }
                                       t[d + 3 | 0] = 16;
                                       q = q + 1 | 0;
                                       t[d + 5 | 0] = q;
                                       break ca;

                                      case 6:
                                       t[e + 17 | 0] = b;
                                       if (w[e + 18 | 0] != (l & 255)) {
                                        break ca;
                                       }
                                       t[d + 5 | 0] = 255;
                                       t[d + 3 | 0] = 4;
                                       t[d | 0] = b;
                                       u[e + 32 >> 1] = 0;
                                       v[e + 8 >> 2] = 0;
                                       break ca;

                                      case 5:
                                       t[d + 5 | 0] = 242;
                                       t[d + 3 | 0] = 2;
                                       break ca;

                                      case 4:
                                       t[d + 5 | 0] = 242;
                                       t[d + 3 | 0] = 3;
                                       break ca;

                                      case 3:
                                       t[d + 5 | 0] = 244;
                                       t[d + 3 | 0] = 2;
                                       break ca;

                                      case 2:
                                       t[d + 5 | 0] = 244;
                                       t[d + 3 | 0] = 3;
                                       break ca;

                                      case 1:
                                       t[d + 5 | 0] = 248;
                                       t[d + 3 | 0] = 2;
                                       break ca;

                                      case 12:
                                       break da;

                                      case 0:
                                       break ea;

                                      default:
                                       break ca;
                                      }
                                     }
                                     t[d + 5 | 0] = 248;
                                     t[d + 3 | 0] = 3;
                                     break ca;
                                    }
                                    h = 0;
                                    L = t[g + 1 | 0];
                                    if ((L | 0) < 0 & c >>> 0 > 99) {
                                     break ca;
                                    }
                                    if ((L | 0) >= 0) {
                                     t[e + 17 | 0] = b;
                                     t[d | 0] = b;
                                     t[e + 18 | 0] = l;
                                     t[d + 1 | 0] = l;
                                     u[e + 32 >> 1] = 0;
                                     v[e + 8 >> 2] = 0;
                                     c = w[g + 2 | 0];
                                    }
                                    b = c & 255;
                                    if (!b) {
                                     break ca;
                                    }
                                    ja = e, ka = Xl(+(b >>> 0) * .64), t[ja + 19 | 0] = ka;
                                    j = z[e >> 2];
                                    v[e >> 2] = 0;
                                    h = j != C(0);
                                    break ca;
                                   }
                                   t[d + 4 | 0] = 0;
                                   t[d + 2 | 0] = 14;
                                   t[e + 16 | 0] = 1;
                                  }
                                  b = Ac(((B(w[e + 20 | 0], w[e + 19 | 0]) + 50 & 65535) >>> 0) / 100 | 0, 0);
                                  if (!(!h & w[e + 21 | 0] == (b & 255))) {
                                   t[e + 21 | 0] = b;
                                   t[d + 5 | 0] = b;
                                   t[d + 3 | 0] = 21;
                                  }
                                  if (n & 1 | t[g + 1 | 0] <= 0 | (x[a + 480188 >> 1] - 1 | 0) <= (n | 0)) {
                                   break _;
                                  }
                                  b = v[k >> 2];
                                  if (Qh(b, v[k + 4 >> 2]) >>> 0 <= J >>> 0) {
                                   break _;
                                  }
                                  if (w[gn(b, J) + 132 | 0] != 1) {
                                   break _;
                                  }
                                  g = n | 1;
                                  b = Y + B(g, 6) | 0;
                                  c = w[d | 0] | w[d + 1 | 0] << 8 | (w[d + 2 | 0] << 16 | w[d + 3 | 0] << 24);
                                  t[b | 0] = c;
                                  t[b + 1 | 0] = c >>> 8;
                                  t[b + 2 | 0] = c >>> 16;
                                  t[b + 3 | 0] = c >>> 24;
                                  c = w[d + 4 | 0] | w[d + 5 | 0] << 8;
                                  t[b + 4 | 0] = c;
                                  t[b + 5 | 0] = c >>> 8;
                                  t[b + 1 | 0] = w[b + 1 | 0] + 1;
                                  b = tv(v[D >> 2], g);
                                  t[b + 19 | 0] = w[e + 19 | 0];
                                  z[b >> 2] = z[e >> 2];
                                  z[b + 4 >> 2] = z[e + 4 >> 2];
                                  z[b + 8 >> 2] = z[e + 8 >> 2];
                                  z[b + 12 >> 2] = z[e + 12 >> 2];
                                  u[b + 30 >> 1] = x[e + 30 >> 1];
                                  break _;

                                 case 1:
                                  v[e + 4 >> 2] = 0;
                                  z[e >> 2] = C(w[g + 2 | 0]) * C(.0333000011742115);
                                  break _;

                                 case 2:
                                  v[e + 4 >> 2] = 0;
                                  z[e >> 2] = C(w[g + 2 | 0]) * C(-.0333000011742115);
                                  break _;

                                 case 12:
                                  t[f + 256 | 0] = 15;
                                  t[f + 96 | 0] = w[g + 3 | 0] >>> 3;
                                  b = w[Pb(f + 256 | 0, f + 96 | 0) | 0];
                                  t[f + 256 | 0] = 15;
                                  t[f + 96 | 0] = w[g + 2 | 0] >>> 3;
                                  ja = e, ka = w[Pb(f + 256 | 0, f + 96 | 0) | 0] | b << 4, t[ja + 24 | 0] = ka;
                                  break _;

                                 case 3:
                                  v[e + 12 >> 2] = 0;
                                  b = w[g + 2 | 0];
                                  u[e + 32 >> 1] = 0;
                                  z[e + 8 >> 2] = C(b >>> 0) * C(.0333000011742115);
                                  break _;

                                 case 4:
                                  v[e + 12 >> 2] = 0;
                                  b = w[g + 2 | 0];
                                  u[e + 32 >> 1] = 0;
                                  z[e + 8 >> 2] = C(b >>> 0) * C(-.0333000011742115);
                                  break _;

                                 case 15:
                                  if (!w[g + 2 | 0] | (b | 0) < 0) {
                                   break _;
                                  }
                                  h = b - w[e + 17 | 0] << 5;
                                  c = h >> 31;
                                  c = (c ^ h) - c | 0;
                                  v[f + 256 >> 2] = c;
                                  t[e + 17 | 0] = b;
                                  v[e + 8 >> 2] = 0;
                                  t[d + 3 | 0] = 4;
                                  t[d | 0] = b;
                                  b = Dh((c >>> 0) / (w[g + 2 | 0] << 1 >>> 0) | 0);
                                  t[d + 5 | 0] = b;
                                  t[e + 27 | 0] = b;
                                  v[f + 96 >> 2] = B(b, (q & 255) - 1 | 0);
                                  ja = e, ka = c - v[Bd(f + 256 | 0, f + 96 | 0) >> 2] | 0, u[ja + 32 >> 1] = ka;
                                  break _;

                                 case 13:
                                  t[f + 256 | 0] = 15;
                                  t[f + 96 | 0] = w[g + 3 | 0] >>> 3;
                                  b = w[Pb(f + 256 | 0, f + 96 | 0) | 0];
                                  t[f + 256 | 0] = 15;
                                  t[f + 96 | 0] = w[g + 2 | 0];
                                  ja = e, ka = w[Pb(f + 256 | 0, f + 96 | 0) | 0] | b << 4, t[ja + 23 | 0] = ka;
                                  break _;

                                 case 18:
                                  b = w[g + 2 | 0] + w[e + 17 | 0] & 255;
                                  b = b ? b >>> 0 >= 120 ? 120 : b : 1;
                                  t[e + 17 | 0] = b;
                                  t[d + 5 | 0] = 255;
                                  t[d + 3 | 0] = 4;
                                  t[d | 0] = b;
                                  break $;

                                 case 23:
                                 case 24:
                                 case 25:
                                  b = ce(A);
                                  while (1) {
                                   fa: {
                                    c = 0;
                                    if (!b) {
                                     break fa;
                                    }
                                    h = b + 13 | 0;
                                    if (!pv(g, h)) {
                                     c = 1;
                                     if (!pv(h, g)) {
                                      break fa;
                                     }
                                     b = b + 4 | 0;
                                    }
                                    b = v[b >> 2];
                                    continue;
                                   }
                                   break;
                                  }
                                  ;
                                  if (c) {
                                   t[d + 3 | 0] = 31;
                                   v[31601] = 0;
                                   b = O(724, A | 0, g | 0) | 0;
                                   c = v[31601];
                                   v[31601] = 0;
                                   if ((c | 0) == 1) {
                                    break m;
                                   }
                                   t[d + 5 | 0] = w[b | 0];
                                   break _;
                                  }
                                  b = v[zb(A) >> 2];
                                  if (b >>> 0 > 127) {
                                   break _;
                                  }
                                  v[f + 92 >> 2] = w[g | 0] | w[g + 1 | 0] << 8 | (w[g + 2 | 0] << 16 | w[g + 3 | 0] << 24);
                                  c = v[a + 480208 >> 2];
                                  v[31601] = 0;
                                  v[f + 24 >> 2] = v[f + 92 >> 2];
                                  c = T(725, f + 24 | 0, Oe(fa, b) | 0, c | 0) | 0;
                                  h = v[31601];
                                  v[31601] = 0;
                                  ga: {
                                   if ((h | 0) == 1) {
                                    break ga;
                                   }
                                   if (!c) {
                                    break _;
                                   }
                                   t[d + 3 | 0] = 31;
                                   v[31601] = 0;
                                   c = O(724, A | 0, g | 0) | 0;
                                   h = v[31601];
                                   v[31601] = 0;
                                   if ((h | 0) == 1) {
                                    break ga;
                                   }
                                   b = b | -128;
                                   t[c | 0] = b;
                                   t[d + 5 | 0] = b;
                                   ca = (w[g | 0] & 254) == 24 | ca;
                                   break _;
                                  }
                                  break m;

                                 case 16:
                                  if (!w[g + 2 | 0]) {
                                   break _;
                                  }
                                  t[d + 3 | 0] = 15;
                                  v[f + 256 >> 2] = 15;
                                  v[f + 96 >> 2] = w[g + 3 | 0] + 1;
                                  ja = d, ka = v[Bd(f + 256 | 0, f + 96 | 0) >> 2], t[ja + 5 | 0] = ka;
                                  u[e + 30 >> 1] = B(w[g + 2 | 0], w[g + 3 | 0] + 1 | 0);
                                  break _;

                                 case 9:
                                  t[d + 3 | 0] = 16;
                                  b = w[g + 2 | 0];
                                  q = b ? b : 4;
                                  t[d + 5 | 0] = q;
                                  break _;

                                 case 19:
                                  ha: {
                                   b = w[g + 1 | 0];
                                   switch (b | 0) {
                                   case 0:
                                   case 4:
                                    break ha;

                                   default:
                                    break _;
                                   }
                                  }
                                  h = 128;
                                  h = (b | 0) == 4 ? w[g + 3 | 0] : h;
                                  t[f + 91 | 0] = h;
                                  t[f + 256 | 0] = w[g + 2 | 0];
                                  t[f + 96 | 0] = 100;
                                  b = f + 256 | 0;
                                  l = f + 96 | 0;
                                  c = w[Pb(b, l) | 0];
                                  v[f + 256 >> 2] = 128;
                                  v[f + 96 >> 2] = 256 - (h & 255);
                                  h = v[Bd(b, l) >> 2];
                                  t[f + 256 | 0] = 128;
                                  b = w[Pb(b, f + 91 | 0) | 0];
                                  h = (B(c, h) | 0) / 128 | 0;
                                  l = h & 255;
                                  if ((l | 0) != w[e + 20 | 0]) {
                                   t[e + 20 | 0] = h;
                                   t[d + 3 | 0] = 21;
                                   h = Ac(((B(l, w[e + 19 | 0]) + 50 & 65535) >>> 0) / 100 | 0, 0);
                                   t[e + 21 | 0] = h;
                                   t[d + 5 | 0] = h;
                                  }
                                  if (w[g + 1 | 0] != 4 | (x[a + 480188 >> 1] - 1 | 0) <= (n | 0)) {
                                   break _;
                                  }
                                  g = n + 1 | 0;
                                  h = tv(v[D >> 2], g);
                                  b = B(b, c) >>> 7 | 0;
                                  if (w[h + 20 | 0] == (b & 255)) {
                                   break _;
                                  }
                                  t[h + 20 | 0] = b;
                                  b = Y + B(g, 6) | 0;
                                  t[b + 3 | 0] = 21;
                                  c = Ac(((B(w[e + 20 | 0], w[e + 19 | 0]) + 50 & 65535) >>> 0) / 100 | 0, 0);
                                  t[e + 21 | 0] = c;
                                  t[b + 5 | 0] = c;
                                  break _;

                                 case 10:
                                 case 11:
                                 case 17:
                                 case 20:
                                  t[d + 3 | 0] = 0;
                                  break _;

                                 case 7:
                                  b = w[g + 2 | 0];
                                  t[e + 25 | 0] = 0;
                                  t[e + 26 | 0] = 0;
                                  t[e + 22 | 0] = b;
                                  break _;

                                 case 8:
                                  t[e + 22 | 0] = w[e + 22 | 0] + w[g + 2 | 0];
                                  break _;

                                 case 14:
                                  t[e + 25 | 0] = w[g + 3 | 0];
                                  t[e + 26 | 0] = w[g + 2 | 0];
                                  break _;

                                 case 6:
                                  break ba;

                                 default:
                                  break _;
                                 }
                                }
                                t[e + 18 | 0] = l;
                                t[e + 17 | 0] = b;
                                t[d + 1 | 0] = l;
                                c = b;
                               }
                               t[d | 0] = c;
                               if ((b | 0) >= 0) {
                                t[e + 18 | 0] = l;
                                t[d + 1 | 0] = l;
                               }
                               if (w[g | 0] == 5) {
                                t[d + 4 | 0] = 1;
                                t[d + 2 | 0] = 11;
                               }
                               b = w[e + 26 | 0];
                               c = w[e + 22 | 0];
                               if (!(b | (c | w[g + 2 | 0]))) {
                                break $;
                               }
                               if (b) {
                                da = (Oi(+x[e + 28 >> 1] * .006135923151542565 + 4.71238898038469) + -1) * +(b >>> 0) * .25;
                               } else {
                                da = 0;
                               }
                               t[d + 3 | 0] = 44;
                               ja = d, ka = Xl(da + +(c + w[g + 2 | 0] | 0)), t[ja + 5 | 0] = ka;
                              }
                              u[e + 32 >> 1] = 0;
                             }
                             ia: {
                              if (w[d | 0]) {
                               t[e + 16 | 0] = 0;
                               break ia;
                              }
                              c = 0;
                              if (w[e + 16 | 0]) {
                               break X;
                              }
                             }
                             ja: {
                              if (!x[e + 30 >> 1]) {
                               break ja;
                              }
                              b = q & 255;
                              u[f + 256 >> 1] = b;
                              c = e + 30 | 0;
                              ja = c, ka = x[qe(c, f + 256 | 0) >> 1] - b | 0, u[ja >> 1] = ka;
                              if (w[d + 3 | 0]) {
                               break ja;
                              }
                              t[d + 5 | 0] = 0;
                              t[d + 3 | 0] = 15;
                             }
                             j = z[e >> 2];
                             ka: {
                              if (j == C(0)) {
                               break ka;
                              }
                              b = q & 255;
                              j = C(C(j * C(b >>> 0)) + z[e + 4 >> 2]);
                              z[e + 4 >> 2] = j;
                              if (w[d + 3 | 0]) {
                               break ka;
                              }
                              la: {
                               ma: {
                                na: {
                                 oa: {
                                  if (b >>> 0 >= 2) {
                                   g = b - 1 | 0;
                                   F = C(g | 0);
                                   if (!(F <= j)) {
                                    break oa;
                                   }
                                   t[f + 256 | 0] = 15;
                                   ja = f, ka = Ah(C(j / F)), t[ja + 96 | 0] = ka;
                                   b = w[Pb(f + 256 | 0, f + 96 | 0) | 0];
                                   z[e + 4 >> 2] = j - C(B(b, g) | 0);
                                   t[d + 3 | 0] = 22;
                                   c = b << 4;
                                   break la;
                                  }
                                  if (!(j >= C(1))) {
                                   break na;
                                  }
                                  break ma;
                                 }
                                 if (j >= C(1)) {
                                  break ma;
                                 }
                                 if (!(j <= C(1 - b | 0))) {
                                  break na;
                                 }
                                 t[f + 256 | 0] = 15;
                                 ja = f, ka = Ah(C(C(-j) / F)), t[ja + 96 | 0] = ka;
                                 c = w[Pb(f + 256 | 0, f + 96 | 0) | 0];
                                 z[e + 4 >> 2] = j + C(B(g, c) | 0);
                                 t[d + 3 | 0] = 22;
                                 break la;
                                }
                                if (!(j <= C(-1))) {
                                 break ka;
                                }
                                t[f + 256 | 0] = 14;
                                ja = f, ka = Ah(C(-j)), t[ja + 96 | 0] = ka;
                                b = w[Pb(f + 256 | 0, f + 96 | 0) | 0];
                                z[e + 4 >> 2] = j + C(b >>> 0);
                                t[d + 3 | 0] = 22;
                                c = b | -16;
                                break la;
                               }
                               t[f + 256 | 0] = 15;
                               ja = f, ka = Ah(j), t[ja + 96 | 0] = ka;
                               b = w[Pb(f + 256 | 0, f + 96 | 0) | 0];
                               z[e + 4 >> 2] = j - C(b >>> 0);
                               t[d + 3 | 0] = 22;
                               c = b << 4 | 15;
                              }
                              t[d + 5 | 0] = c;
                             }
                             j = z[e + 8 >> 2];
                             pa: {
                              if (j == C(0)) {
                               break pa;
                              }
                              b = q & 255;
                              j = C(C(j * C(b >>> 0)) + z[e + 12 >> 2]);
                              z[e + 12 >> 2] = j;
                              qa: {
                               ra: {
                                if (!w[d + 3 | 0]) {
                                 sa: {
                                  ta: {
                                   if (b >>> 0 >= 2) {
                                    g = b - 1 | 0;
                                    F = C(g | 0);
                                    if (!(F <= j)) {
                                     break ta;
                                    }
                                    t[f + 256 | 0] = 223;
                                    ja = f, ka = Ah(C(j / F)), t[ja + 96 | 0] = ka;
                                    c = w[Pb(f + 256 | 0, f + 96 | 0) | 0];
                                    z[e + 12 >> 2] = j - C(B(g, c) | 0);
                                    t[d + 3 | 0] = 2;
                                    b = 5;
                                    break qa;
                                   }
                                   if (!(j >= C(1))) {
                                    break sa;
                                   }
                                   break ra;
                                  }
                                  if (j >= C(1)) {
                                   break ra;
                                  }
                                  if (!(C(1 - b | 0) >= j)) {
                                   break sa;
                                  }
                                  t[f + 256 | 0] = 223;
                                  ja = f, ka = Ah(C(C(-j) / F)), t[ja + 96 | 0] = ka;
                                  c = w[Pb(f + 256 | 0, f + 96 | 0) | 0];
                                  z[e + 12 >> 2] = j + C(B(g, c) | 0);
                                  t[d + 3 | 0] = 3;
                                  b = 5;
                                  break qa;
                                 }
                                 if (!(j <= C(-1))) {
                                  break pa;
                                 }
                                 t[f + 256 | 0] = 14;
                                 ja = f, ka = Ah(C(-j)), t[ja + 96 | 0] = ka;
                                 b = w[Pb(f + 256 | 0, f + 96 | 0) | 0];
                                 z[e + 12 >> 2] = j + C(b >>> 0);
                                 t[d + 3 | 0] = 3;
                                 c = b | -16;
                                 b = 5;
                                 break qa;
                                }
                                if (w[d + 2 | 0] | b >>> 0 < 2) {
                                 break pa;
                                }
                                ea = C(j * C(.25));
                                g = b - 1 | 0;
                                F = C(g | 0);
                                ua: {
                                 if (ea >= F) {
                                  t[f + 256 | 0] = 9;
                                  ja = f, ka = Ah(C(j / F)) >>> 2 | 0, t[ja + 96 | 0] = ka;
                                  c = w[Pb(f + 256 | 0, f + 96 | 0) | 0];
                                  z[e + 12 >> 2] = j - C(B(g, c) << 2);
                                  t[d + 2 | 0] = 12;
                                  break ua;
                                 }
                                 if (!(ea <= C(1 - b | 0))) {
                                  break pa;
                                 }
                                 t[f + 256 | 0] = 9;
                                 ja = f, ka = Ah(C(C(-j) / F)) >>> 2 | 0, t[ja + 96 | 0] = ka;
                                 c = w[Pb(f + 256 | 0, f + 96 | 0) | 0];
                                 z[e + 12 >> 2] = j + C(B(g, c) << 2);
                                 t[d + 2 | 0] = 13;
                                }
                                b = 4;
                                break qa;
                               }
                               t[f + 256 | 0] = 15;
                               ja = f, ka = Ah(j), t[ja + 96 | 0] = ka;
                               b = w[Pb(f + 256 | 0, f + 96 | 0) | 0];
                               z[e + 12 >> 2] = j - C(b >>> 0);
                               t[d + 3 | 0] = 2;
                               c = b | -16;
                               b = 5;
                              }
                              t[b + d | 0] = c;
                             }
                             va: {
                              wa: {
                               xa: {
                                ya: {
                                 za: {
                                  Aa: {
                                   Ba: {
                                    b = w[d + 3 | 0];
                                    switch (b | 0) {
                                    case 4:
                                     break va;

                                    case 0:
                                     break Ba;

                                    default:
                                     break Aa;
                                    }
                                   }
                                   Ca: {
                                    b = w[e + 23 | 0];
                                    if (!b) {
                                     b = w[e + 24 | 0];
                                     if (b) {
                                      break Ca;
                                     }
                                     if (!x[e + 32 >> 1]) {
                                      break va;
                                     }
                                     h = e + 32 | 0;
                                     break za;
                                    }
                                    t[d + 5 | 0] = b;
                                    t[d + 3 | 0] = 5;
                                    if (!x[e + 32 >> 1]) {
                                     break va;
                                    }
                                    break ya;
                                   }
                                   t[d + 5 | 0] = b;
                                   t[d + 3 | 0] = 8;
                                   if (x[e + 32 >> 1]) {
                                    break ya;
                                   }
                                   break va;
                                  }
                                  if (!x[e + 32 >> 1]) {
                                   break va;
                                  }
                                  h = e + 32 | 0;
                                  if (b) {
                                   break xa;
                                  }
                                 }
                                 t[d + 3 | 0] = 4;
                                 break wa;
                                }
                                h = e + 32 | 0;
                               }
                               t[d + 2 | 0] = 11;
                              }
                              u[f + 256 >> 1] = B(w[e + 27 | 0], (q & 255) - 1 | 0);
                              ja = e, ka = x[e + 32 >> 1] - x[Nc(h, f + 256 | 0) >> 1] | 0, u[ja + 32 >> 1] = ka;
                             }
                             u[e + 28 >> 1] = x[e + 28 >> 1] + B(w[e + 25 | 0], q & 255) & 1023;
                             c = 0;
                             if (n & 1) {
                              break X;
                             }
                             b = w[e + 18 | 0];
                             if (!b) {
                              break X;
                             }
                             e = v[k >> 2];
                             if (Qh(e, v[k + 4 >> 2]) >>> 0 < b >>> 0) {
                              break X;
                             }
                             e = gn(e, b - 1 | 0);
                             if (!(w[e + 142 | 0] & 4)) {
                              break X;
                             }
                             b = w[d | 0] | w[d + 1 | 0] << 8 | (w[d + 2 | 0] << 16 | w[d + 3 | 0] << 24);
                             t[o | 0] = b;
                             t[o + 1 | 0] = b >>> 8;
                             t[o + 2 | 0] = b >>> 16;
                             t[o + 3 | 0] = b >>> 24;
                             b = w[d + 4 | 0] | w[d + 5 | 0] << 8;
                             t[o + 4 | 0] = b;
                             t[o + 5 | 0] = b >>> 8;
                             c = 1;
                             b = w[f + 65 | 0];
                             if (!b | w[e + 132 | 0] != 1) {
                              break X;
                             }
                             t[f + 65 | 0] = b + 1;
                            }
                            n = n + 1 | 0;
                            b = x[a + 480188 >> 1];
                            continue;
                           }
                          }
                          break;
                         }
                         ze(c, Uh(We(Ne(f + 256 | 0, 16, Ab(w[i + 14 | 0] | w[i + 15 | 0] << 8) & 255), 0)));
                        }
                        b = am(v[I >> 2], v[I + 4 >> 2]);
                        ja = f, ka = Ab(w[i + 4 | 0] | w[i + 5 | 0] << 8), u[ja + 256 >> 1] = ka;
                        u[f + 64 >> 1] = 1;
                        c = x[qe(f + 256 | 0, f - -64 | 0) >> 1];
                        v[31601] = 0;
                        U(726, I | 0, b | 0, c | 0, G & 65535);
                        b = v[31601];
                        v[31601] = 0;
                        if ((b | 0) == 1) {
                         break Q;
                        }
                        b = ye((w[m + 8 | 0] | w[m + 9 | 0] << 8) << 16 >> 16);
                        b = ye(ye((w[i + 16 | 0] | w[i + 17 | 0] << 8) << 16 >> 16) - b << 16 >> 16);
                        t[i + 16 | 0] = b;
                        t[i + 17 | 0] = b >>> 8;
                       }
                       Zq(f + 40 | 0);
                       continue;
                      }
                      break;
                     }
                     break m;
                    }
                    d = ca & 1;
                    if (d) {
                     v[31601] = 0;
                     e = a + 906300 | 0;
                     b = _d(e, 0);
                     V(286, b | 0);
                     c = v[31601];
                     v[31601] = 0;
                     if ((c | 0) == 1) {
                      break m;
                     }
                     v[b + 24 >> 2] = 655376;
                     v[b + 28 >> 2] = 0;
                     v[b + 16 >> 2] = 1299020115;
                     v[b + 20 >> 2] = 1869112133;
                     v[f + 256 >> 2] = 0;
                     g = b + 48 | 0;
                     c = f + 256 | 0;
                     $$(b + 32 | 0, g, c);
                     v[31601] = 0;
                     c = O(36, c | 0, 9571) | 0;
                     h = v[31601];
                     v[31601] = 0;
                     if ((h | 0) == 1) {
                      break m;
                     }
                     vE(g, c);
                     sb(c);
                     v[31601] = 0;
                     c = O(36, f + 76 | 0, 9564) | 0;
                     g = v[31601];
                     v[31601] = 0;
                     if ((g | 0) == 1) {
                      break m;
                     }
                     rw(b + 80 | 0, c);
                     sb(c);
                     v[31601] = 0;
                     b = O(36, f - -64 | 0, 9556) | 0;
                     c = v[31601];
                     v[31601] = 0;
                     if ((c | 0) == 1) {
                      break m;
                     }
                     vE(_d(e, 1) + 48 | 0, b);
                     sb(b);
                    }
                    c = a + 480280 | 0;
                    b = 0;
                    while (1) {
                     if (x[a + 480188 >> 1] > b >>> 0) {
                      bE(a, b & 65535);
                      e = c + (b << 5) | 0;
                      t[e + 8 | 0] = d;
                      u[e + 4 >> 1] = b << 8 & 256;
                      b = b + 1 | 0;
                      continue;
                     }
                     break;
                    }
                    v[31601] = 0;
                    b = O(1, f + 52 | 0, 12165) | 0;
                    c = v[31601];
                    v[31601] = 0;
                    Da: {
                     Ea: {
                      Fa: {
                       if ((c | 0) != 1) {
                        yb(a + 1298344 | 0, b);
                        sb(b);
                        v[31601] = 0;
                        b = O(1, f + 40 | 0, 12383) | 0;
                        c = v[31601];
                        v[31601] = 0;
                        if ((c | 0) == 1) {
                         break m;
                        }
                        yb(a + 1298356 | 0, b);
                        sb(b);
                        if (Z) {
                         break Fa;
                        }
                        v[31601] = 0;
                        b = O(1, f + 28 | 0, 12165) | 0;
                        c = v[31601];
                        v[31601] = 0;
                        if ((c | 0) == 1) {
                         break m;
                        }
                        break Ea;
                       }
                       break m;
                      }
                      if (Qh(v[k >> 2], v[k + 4 >> 2]) >>> 0 <= 128) {
                       v[31601] = 0;
                       b = O(1, f + 28 | 0, 9298) | 0;
                       c = v[31601];
                       v[31601] = 0;
                       if ((c | 0) != 1) {
                        break Ea;
                       }
                       break m;
                      }
                      v[31601] = 0;
                      b = O(1, f + 28 | 0, 14791) | 0;
                      c = v[31601];
                      v[31601] = 0;
                      if ((c | 0) == 1) {
                       break Da;
                      }
                     }
                     yb(a + 1298368 | 0, b);
                     sb(b);
                     ja = a, ka = v[Ec(f + 100 | 0, 28) >> 2], v[ja + 1298404 >> 2] = ka;
                     fW(D);
                     WV(A);
                     VV(H);
                     d = 1;
                     break n;
                    }
                    break m;
                   }
                   Uo(f + 52 | 0);
                   continue;
                  }
                 }
                 c = M() | 0;
                 break a;
                }
                c = M() | 0;
                break a;
               }
               uv(k);
               uc(E);
               jn(s);
               Pi(r);
               break c;
              }
              c = M() | 0;
              fW(D);
              break j;
             }
             c = M() | 0;
             break j;
            }
            c = M() | 0;
           }
           WV(A);
           VV(H);
           break a;
          }
          c = M() | 0;
          sb(b);
          break a;
         }
         c = M() | 0;
         break a;
        }
        tb(c);
        v[31601] = 0;
        c = d & 65535;
        d = T(727, a | 0, c | 0, n | 0) | 0;
        e = v[31601];
        v[31601] = 0;
        Ga: {
         Ha: {
          Ia: {
           Ja: {
            if ((e | 0) == 1) {
             break Ja;
            }
            if (d) {
             break Ga;
            }
            v[31601] = 0;
            d = T(728, a | 0, c | 0, n | 0) | 0;
            e = v[31601];
            v[31601] = 0;
            if ((e | 0) == 1) {
             break Ja;
            }
            if (d) {
             break Ga;
            }
            v[31601] = 0;
            d = T(729, a | 0, c | 0, n | 0) | 0;
            e = v[31601];
            v[31601] = 0;
            if ((e | 0) == 1) {
             break Ja;
            }
            if (d) {
             break Ga;
            }
            v[31601] = 0;
            d = O(730, o + B(c, 104) | 0, n | 0) | 0;
            e = v[31601];
            v[31601] = 0;
            if ((e | 0) == 1) {
             break Ja;
            }
            if (d) {
             break Ga;
            }
            v[31601] = 0;
            d = O(1, f + 420 | 0, 16192) | 0;
            e = v[31601];
            v[31601] = 0;
            if ((e | 0) == 1) {
             break Ia;
            }
            e = v[a + 1298472 >> 2];
            v[31601] = 0;
            R(385, e | 0, 2, d | 0);
            e = v[31601];
            v[31601] = 0;
            if ((e | 0) == 1) {
             break Ha;
            }
            sb(d);
            break Ga;
           }
           c = M() | 0;
           break e;
          }
          c = M() | 0;
          break e;
         }
         c = M() | 0;
         sb(d);
         break e;
        }
        Ka: {
         La: {
          Ma: {
           i = o + B(c, 104) | 0;
           if (w[i + 34 | 0] & 64) {
            d = x[m >> 1];
            if (ni(d)) {
             break Ma;
            }
           }
           d = v[k >> 2];
           if (Qh(d, v[k + 4 >> 2]) >>> 0 <= c >>> 0) {
            break La;
           }
           if (w[gn(d, c) + 132 | 0] != 2) {
            break La;
           }
           c = x[m >> 1];
           if (!ni(c)) {
            break La;
           }
           u[m >> 1] = c + 1;
           break La;
          }
          c = d + 1 | 0;
          u[a + 480190 >> 1] = c;
          A = o + B(c & 65535, 104) | 0;
          e = v[i >> 2];
          c = v[i + 20 >> 2];
          Na: {
           if (!ke(e, c)) {
            break Na;
           }
           d = (i | 0) == (A | 0);
           g = x[i + 34 >> 1];
           if (d | (Zd(g) | 0) != 2) {
            break Na;
           }
           if (!(ke(v[A >> 2], v[A + 20 >> 2]) ? d : 1)) {
            break Na;
           }
           ke(v[i >> 2], v[i + 20 >> 2]);
           if (!d) {
            c = qv(e, In(g));
           }
           g = v[i + 20 >> 2];
           if (!(g ? c : 0)) {
            if (!d) {
             eC(c);
            }
            break Na;
           }
           Oa: {
            Pa: {
             switch (In(x[i + 34 >> 1]) - 1 | 0) {
             case 1:
              d = c;
              e = g;
              h = v[i + 20 >> 2];
              l = v[i >> 2];
              while (1) {
               if (l) {
                u[d >> 1] = x[h >> 1];
                u[e >> 1] = x[h + 2 >> 1];
                h = h + 4 | 0;
                e = e + 2 | 0;
                d = d + 2 | 0;
                l = l - 1 | 0;
                continue;
               }
               break;
              }
              ;
              break Oa;

             case 0:
              break Pa;

             default:
              break Oa;
             }
            }
            d = c;
            e = g;
            h = v[i + 20 >> 2];
            l = v[i >> 2];
            while (1) {
             if (l) {
              t[d | 0] = w[h | 0];
              t[e | 0] = w[h + 1 | 0];
              h = h + 2 | 0;
              e = e + 1 | 0;
              d = d + 1 | 0;
              l = l - 1 | 0;
              continue;
             }
             break;
            }
           }
           d = Wo(A, i);
           u[d + 34 >> 1] = x[d + 34 >> 1] & 65471;
           v[A + 20 >> 2] = c;
           c = Wo(i, i);
           u[c + 34 >> 1] = x[c + 34 >> 1] & 65471;
           v[i + 20 >> 2] = g;
           h = 1074992;
           while (1) {
            if ((h | 0) != 1298224) {
             e = a + h | 0;
             g = v[e + 104 >> 2];
             if (!((g | 0) != (d | 0) & (c | 0) != (g | 0))) {
              v[e + 88 >> 2] = v[e + 88 >> 2] & -65;
             }
             h = h + 872 | 0;
             continue;
            }
            break;
           }
           Hj(d, a);
           Hj(c, a);
          }
          v[31601] = 0;
          c = O(36, f + 408 | 0, 6320) | 0;
          d = v[31601];
          v[31601] = 0;
          if ((d | 0) == 1) {
           break Ka;
          }
          Ae(A + 43 | 0, c);
          sb(c);
          v[31601] = 0;
          c = O(36, f + 396 | 0, 6223) | 0;
          d = v[31601];
          v[31601] = 0;
          if ((d | 0) == 1) {
           break f;
          }
          Ae(i + 43 | 0, c);
          sb(c);
         }
         tb(n);
         ec(D);
         h = 0;
         continue;
        }
        break;
       }
       c = M() | 0;
       break e;
      }
      c = M() | 0;
     }
     tb(n);
    }
    ec(D);
    break a;
   }
   eb = f + 608 | 0;
   return d | 0;
  }
  c = M() | 0;
 }
 uv(k);
 uc(E);
 jn(s);
 Pi(r);
 P(c | 0);
 p();
}

function Gv(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, k = 0, l = 0, m = 0, n = 0, q = 0, r = 0, s = 0, D = 0, E = 0, F = 0, G = 0, H = 0, I = 0, J = 0, K = 0, L = 0, Q = 0, S = 0, W = 0, X = 0, Y = 0, Z = 0, _ = 0, aa = 0, ba = 0, ca = 0, da = 0, ea = 0, ha = 0, ja = 0, ka = 0, la = 0, ma = 0, na = 0, oa = 0, pa = 0, qa = 0, ra = 0, sa = 0, ta = C(0), ua = 0, wa = 0, xa = 0, ya = C(0);
 k = eb - 192 | 0;
 eb = k;
 X = Mb(a);
 r = k + 160 | 0;
 t[r + 26 | 0] = 0;
 u[r + 24 >> 1] = 0;
 v[r + 16 >> 2] = 0;
 v[r + 20 >> 2] = -1;
 v[r + 8 >> 2] = -1;
 v[r + 12 >> 2] = -1;
 v[r >> 2] = 0;
 v[r + 4 >> 2] = 0;
 ca = v[d + 16 >> 2];
 a = w[d + 6 | 0];
 n = v[b + 484360 >> 2];
 ha = (ua = a, wa = w[b + 484376 | 0], xa = Fj(n, v[b + 484364 >> 2]) >>> 0 > a >>> 0, 
 xa ? ua : wa);
 a = ha & 255;
 H = Lj(n, a);
 v[31601] = 0;
 s = O(602, k + 128 | 0, b | 0) | 0;
 n = v[31601];
 v[31601] = 0;
 a: {
  b: {
   c: {
    d: {
     e: {
      f: {
       g: {
        if ((n | 0) != 1) {
         m = v[s + 4 >> 2];
         v[31601] = 0;
         G = T(603, k + 92 | 0, b | 0, a | 0) | 0;
         a = v[31601];
         v[31601] = 0;
         if ((a | 0) == 1) {
          break g;
         }
         na = b + 484360 | 0;
         _ = c & 7;
         f = v[d >> 2];
         a = x[d + 4 >> 1];
         n = _c(v[H >> 2], v[H + 4 >> 2]);
         while (1) {
          q = a & 65535;
          if (q >>> 0 >= n >>> 0) {
           break f;
          }
          if (Vi(H, q)) {
           break f;
          }
          a = a + 1 | 0;
          f = 0;
          continue;
         }
        }
        a = M() | 0;
        break d;
       }
       a = M() | 0;
       break e;
      }
      v[d >> 2] = f;
      u[d + 4 >> 1] = a;
      v[m + 52 >> 2] = f;
      v[m + 48 >> 2] = f;
      v[r + 16 >> 2] = f;
      u[m + 74 >> 1] = a;
      u[m + 72 >> 1] = a;
      u[r + 24 >> 1] = a;
      ja = Ld(k + 84 | 0);
      h: {
       if ((_ | 0) != 7) {
        break h;
       }
       a = eb - 16 | 0;
       eb = a;
       n = a + 8 | 0;
       Ib(n, ja, 1);
       ap(n);
       eb = a + 16 | 0;
       if ((ca | 0) != 2) {
        break h;
       }
       a = v[H >> 2];
       e = _c(a, v[H + 4 >> 2]);
       n = x[d + 12 >> 1];
       if (e >>> 0 <= n >>> 0) {
        break h;
       }
       q = v[b + 484344 >> 2];
       e = v[b + 484348 >> 2];
       a = x[$b(a, n) >> 1];
       if (!Ie(q, e, a)) {
        break h;
       }
       n = Vb(q, a);
       q = v[d + 8 >> 2];
       if (y[n + 12 >> 2] <= q >>> 0) {
        break h;
       }
       a = 0;
       l = ld(v[n >> 2], v[v[n + 48 >> 2] + 12 >> 2], q, 0);
       n = v[s + 8 >> 2];
       q = x[b + 480188 >> 1];
       e = x[b + 480192 >> 1];
       while (1) {
        if ((a | 0) == (q | 0)) {
         break h;
        }
        i: {
         j: {
          k: {
           l: {
            i = w[l | 0];
            switch (i - 253 | 0) {
            case 1:
            case 2:
             break j;

            case 0:
             break l;

            default:
             break k;
            }
           }
           if (e) {
            break j;
           }
          }
          if (!Tc(i) | !w[l + 1 | 0]) {
           break i;
          }
          if (Il(w[l + 2 | 0], w[l + 3 | 0])) {
           break i;
          }
         }
         ua = Se(n, a), wa = -1, v[ua >> 2] = wa;
        }
        l = l + 6 | 0;
        a = a + 1 | 0;
        continue;
       }
      }
      Y = c & 1;
      if (Y) {
       yT(m + 223860 | 0);
      }
      K = m + 74 | 0;
      J = m + 48 | 0;
      oa = m + 223872 | 0;
      L = m + 80 | 0;
      pa = b + 901692 | 0;
      qa = b + 902204 | 0;
      aa = m + 44 | 0;
      ra = b + 484380 | 0;
      ka = b + 900380 | 0;
      da = m + 223860 | 0;
      Z = m + 20 | 0;
      sa = b + 480280 | 0;
      F = b + 1074312 | 0;
      W = m + 616 | 0;
      ba = 32768;
      la = (_ | 0) != 7;
      a = 0;
      n = 0;
      m: {
       n: {
        o: {
         p: {
          q: {
           r: {
            s: {
             t: {
              u: while (1) {
               ea = a & 1;
               v: while (1) {
                ma = A[d + 8 >> 3];
                o(+ma);
                q = j(1) | 0;
                e = j(0) | 0;
                i = v[d + 16 >> 2];
                Q = (i | 0) != 3;
                w: {
                 x: {
                  y: {
                   z: {
                    while (1) {
                     xT(k + 24 | 0, v[b + 480180 >> 2], x[b + 480188 >> 1], m, ea);
                     D = w[k + 24 | 0];
                     if (!Q & A[s + 24 >> 3] >= ma) {
                      break z;
                     }
                     a = 65535;
                     g = v[H >> 2];
                     f = _c(g, v[H + 4 >> 2]);
                     l = x[m + 72 >> 1];
                     if (f >>> 0 > l >>> 0) {
                      a = x[$b(g, l) >> 1];
                     }
                     u[m + 70 >> 1] = a;
                     g = v[b + 484344 >> 2];
                     h = v[b + 484348 >> 2];
                     f = a & 65535;
                     if (!(Ie(g, h, f) | (i | 0) != 2 | (f | 0) == 65535) & (l | 0) == (q & 65535)) {
                      break z;
                     }
                     A: {
                      while (1) {
                       S = Xj(g, h);
                       E = v[H >> 2];
                       while (1) {
                        l = a & 65535;
                        if (l >>> 0 < S >>> 0) {
                         break A;
                        }
                        a = x[m + 72 >> 1];
                        B: {
                         C: {
                          if ((l | 0) != 65535) {
                           f = _c(E, v[H + 4 >> 2]);
                           if (a >>> 0 < f >>> 0) {
                            break C;
                           }
                          }
                          l = x[H + 28 >> 1];
                          if ((a | 0) == (l | 0)) {
                           break A;
                          }
                          f = _c(E, v[H + 4 >> 2]);
                          break B;
                         }
                         l = a + 1 | 0;
                        }
                        u[m + 72 >> 1] = l;
                        a = 65535;
                        I = f;
                        f = l & 65535;
                        if (I >>> 0 > f >>> 0) {
                         a = x[$b(E, f) >> 1];
                        }
                        u[m + 74 >> 1] = l;
                        u[m + 70 >> 1] = a;
                        if (Ie(g, h, a & 65535)) {
                         continue;
                        }
                        break;
                       }
                       a = Jq(k + 24 | 0, W);
                       v[31601] = 0;
                       a = ga(604, G | 0, l & 65535, 0, a | 0, (D | 0) != 0 | 0) | 0;
                       g = v[31601];
                       v[31601] = 0;
                       if ((g | 0) == 1) {
                        break q;
                       }
                       if (!a) {
                        h = v[b + 484348 >> 2];
                        g = v[b + 484344 >> 2];
                        a = x[m + 70 >> 1];
                        continue;
                       }
                       break;
                      }
                      if (ca >>> 0 <= 1) {
                       a = x[m + 72 >> 1];
                       v[r + 8 >> 2] = 0;
                       u[r + 20 >> 1] = a;
                      }
                      if (!i) {
                       break A;
                      }
                      if (!Yu(G, K, J)) {
                       break A;
                      }
                      A[r >> 3] = A[s + 24 >> 3];
                      v[31601] = 0;
                      N(605, X | 0, r | 0);
                      a = v[31601];
                      v[31601] = 0;
                      if ((a | 0) == 1) {
                       break r;
                      }
                      v[r + 16 >> 2] = v[J >> 2];
                      u[r + 24 >> 1] = x[K >> 1];
                      v[31601] = 0;
                      V(606, s | 0);
                      a = v[31601];
                      v[31601] = 0;
                      if ((a | 0) == 1) {
                       break r;
                      }
                      a = x[m + 74 >> 1];
                      u[m + 72 >> 1] = a;
                      ua = m, wa = x[$b(v[H >> 2], a) >> 1], u[ua + 70 >> 1] = wa;
                      v[m + 52 >> 2] = v[m + 48 >> 2];
                     }
                     if (x[K >> 1] == 65535) {
                      break n;
                     }
                     a = v[b + 484344 >> 2];
                     g = x[m + 70 >> 1];
                     if (!Ie(a, v[b + 484348 >> 2], g)) {
                      a = x[m + 72 >> 1];
                      if ((a | 0) == x[H + 28 >> 1]) {
                       if (!i) {
                        break o;
                       }
                       if (!Yu(G, K, J)) {
                        break p;
                       }
                       A[r >> 3] = A[s + 24 >> 3];
                       v[31601] = 0;
                       N(605, X | 0, r | 0);
                       a = v[31601];
                       v[31601] = 0;
                       if ((a | 0) == 1) {
                        break r;
                       }
                       v[r + 16 >> 2] = v[J >> 2];
                       u[r + 24 >> 1] = x[K >> 1];
                       v[31601] = 0;
                       V(606, s | 0);
                       a = v[31601];
                       v[31601] = 0;
                       if ((a | 0) == 1) {
                        break r;
                       }
                       v[m + 52 >> 2] = v[m + 48 >> 2];
                       continue;
                      }
                      u[K >> 1] = a + 1;
                      continue;
                     }
                     break;
                    }
                    f = v[J >> 2];
                    if (f >>> 0 >= y[Vb(a, g) + 12 >> 2]) {
                     v[J >> 2] = 0;
                     f = 0;
                    }
                    if ((i | 0) != 2) {
                     break y;
                    }
                    if (x[m + 72 >> 1] != (q & 65535) | (f | 0) != (e | 0)) {
                     break x;
                    }
                   }
                   i = 1;
                   t[r + 26 | 0] = 1;
                   break n;
                  }
                  a = 0;
                  if ((i | 0) == 3) {
                   break w;
                  }
                 }
                 a = 0;
                 if (y[G + 28 >> 2] < ba >>> 0) {
                  break w;
                 }
                 v[s + 24 >> 2] = 0;
                 v[s + 28 >> 2] = 2146435072;
                 v[G + 28 >> 2] = 0;
                 ba = ba >>> (ba >>> 0 > 256) | 0;
                 f = v[J >> 2];
                 a = 1;
                }
                q = x[m + 72 >> 1];
                e = Jq(k + 24 | 0, W);
                v[31601] = 0;
                q = ga(604, G | 0, q | 0, f | 0, e | 0, (D | 0) != 0 | 0) | 0;
                e = v[31601];
                v[31601] = 0;
                if ((e | 0) == 1) {
                 break t;
                }
                if ((a | q) == 1) {
                 if (ca >>> 0 <= 1) {
                  u[r + 20 >> 1] = x[m + 72 >> 1];
                  v[r + 8 >> 2] = v[m + 48 >> 2];
                 }
                 if (!i) {
                  break o;
                 }
                 if (!Yu(G, K, J)) {
                  break p;
                 }
                 A[r >> 3] = A[s + 24 >> 3];
                 v[31601] = 0;
                 N(605, X | 0, r | 0);
                 a = v[31601];
                 v[31601] = 0;
                 if ((a | 0) == 1) {
                  break s;
                 }
                 v[r + 16 >> 2] = v[J >> 2];
                 u[r + 24 >> 1] = x[K >> 1];
                 v[31601] = 0;
                 V(606, s | 0);
                 a = v[31601];
                 v[31601] = 0;
                 if ((a | 0) == 1) {
                  break s;
                 }
                 v[m + 52 >> 2] = v[m + 48 >> 2];
                 continue;
                }
                u[r + 22 >> 1] = x[m + 72 >> 1];
                v[r + 12 >> 2] = v[m + 48 >> 2];
                wT(b, m, 0);
                l = v[m + 48 >> 2];
                q = Vb(v[b + 484344 >> 2], x[m + 70 >> 1]);
                if (l >>> 0 >= y[q + 12 >> 2]) {
                 v[J >> 2] = 0;
                 l = 0;
                }
                if (D) {
                 continue;
                }
                a = 0;
                l = ld(v[q >> 2], v[v[q + 48 >> 2] + 12 >> 2], l, 0);
                Ib(k + 24 | 0, F, 77);
                g = Fb(v[v[k + 24 >> 2] >> 2], v[k + 28 >> 2]);
                D: {
                 while (1) {
                  if (x[b + 480188 >> 1] > a >>> 0) {
                   q = B(a, 872) + W | 0;
                   E: {
                    F: {
                     if (!AB(l)) {
                      if (!g | !(w[((a << 5) + sa | 0) + 1 | 0] & 4)) {
                       break F;
                      }
                     }
                     Vo(q + 788 | 0);
                     break E;
                    }
                    if (Vg(w[l | 0])) {
                     G: {
                      if (!Hd(w[m + 223884 | 0])) {
                       break G;
                      }
                      e = w[l + 1 | 0];
                      if (e - 251 >>> 0 < 5 | !e) {
                       break G;
                      }
                      h = w[l + 5 | 0];
                      f = w[l + 3 | 0];
                      D = Bj(w[l + 2 | 0], w[l + 4 | 0]);
                      i = k + 24 | 0;
                      t[i | 0] = e - 1;
                      v[i + 4 >> 2] = D & 65535;
                      v[31601] = 0;
                      e = O(607, oa | 0, i | 0) | 0;
                      i = v[31601];
                      v[31601] = 0;
                      if ((i | 0) == 1) {
                       break D;
                      }
                      ua = e, ya = C(C(Bj(f, h) >>> 0) / C(999)), z[ua >> 2] = ya;
                     }
                     Vo(q + 788 | 0);
                     break E;
                    }
                    e = w[l | 0] | w[l + 1 | 0] << 8 | (w[l + 2 | 0] << 16 | w[l + 3 | 0] << 24);
                    t[q + 788 | 0] = e;
                    t[q + 789 | 0] = e >>> 8;
                    t[q + 790 | 0] = e >>> 16;
                    t[q + 791 | 0] = e >>> 24;
                    e = w[l + 4 | 0] | w[l + 5 | 0] << 8;
                    t[q + 792 | 0] = e;
                    t[q + 793 | 0] = e >>> 8;
                    H: {
                     I: {
                      J: {
                       K: {
                        switch (w[l + 3 | 0] - 16 | 0) {
                        case 0:
                         f = w[l + 5 | 0];
                         break J;

                        case 3:
                         break H;

                        case 4:
                         break I;

                        case 1:
                         break K;

                        default:
                         break E;
                        }
                       }
                       Ib(k + 24 | 0, F, 5);
                       if (!Fb(v[v[k + 24 >> 2] >> 2], v[k + 28 >> 2])) {
                        break E;
                       }
                       f = w[l + 5 | 0];
                       if (!f) {
                        break E;
                       }
                      }
                      uT(b, m, f & 255);
                      break E;
                     }
                     e = w[q + 793 | 0];
                     L: {
                      if (!(e | !(v[b + 480180 >> 2] & 16777250))) {
                       t[q + 793 | 0] = w[q + 833 | 0];
                       break L;
                      }
                      t[q + 833 | 0] = e;
                     }
                     q = w[l + 5 | 0];
                     e = q & 240;
                     if ((e | 0) != 224) {
                      if ((e | 0) != 96) {
                       break E;
                      }
                      v[m + 24 >> 2] = v[m + 24 >> 2] + (q & 15);
                      break E;
                     }
                     if (v[Z >> 2]) {
                      break E;
                     }
                     q = q & 15;
                     if (q ? 0 : w[b + 480180 | 0] & 2) {
                      break E;
                     }
                     v[Z >> 2] = q + 1;
                     break E;
                    }
                    q = w[l + 5 | 0];
                    if ((q & 240) != 224) {
                     break E;
                    }
                    v[Z >> 2] = (q & 15) + 1;
                   }
                   l = l + 6 | 0;
                   a = a + 1 | 0;
                   continue;
                  }
                  break;
                 }
                 q = Hl(m);
                 v[k + 24 >> 2] = 1;
                 a = v[ad(Z, k + 24 | 0) >> 2];
                 u[m + 68 >> 1] = 65535;
                 v[m + 60 >> 2] = -1;
                 v[m + 64 >> 2] = -1;
                 E = q - 1 | 0;
                 e = q - a | 0;
                 Q = B(e, 1e4);
                 l = 0;
                 while (1) {
                  M: {
                   N: {
                    O: {
                     P: {
                      Q: {
                       if (x[b + 480188 >> 1] <= l >>> 0) {
                        if (v[b + 480180 >> 2] != 4 | v[m + 40 >> 2] != 65535) {
                         break Q;
                        }
                        v[m + 52 >> 2] = v[m + 48 >> 2];
                        u[m + 74 >> 1] = x[m + 72 >> 1];
                        continue v;
                       }
                       h = B(l, 872) + W | 0;
                       if (AB(h + 788 | 0)) {
                        break M;
                       }
                       D = w[h + 791 | 0];
                       f = w[h + 793 | 0];
                       if (!Y) {
                        break O;
                       }
                       a = w[h + 788 | 0];
                       i = w[h + 789 | 0];
                       if (i) {
                        t[h + 799 | 0] = 0;
                        t[h + 803 | 0] = i;
                        ua = Se(v[s + 8 >> 2], l), wa = 255, t[ua + 5 | 0] = wa;
                        i = w[h + 788 | 0];
                       } else {
                        i = a;
                       }
                       R: {
                        if (!Tc(i)) {
                         break R;
                        }
                        t[h + 799 | 0] = a;
                        fV(h);
                        if (!la) {
                         if (v[Se(v[s + 8 >> 2], l) >> 2] != -1) {
                          break R;
                         }
                        }
                        g = h + 656 | 0;
                        i = w[h + 803 | 0];
                        i = v[(i ? i >>> 0 > x[b + 480192 >> 1] ? g : (i << 2) + ka | 0 : g) >> 2];
                        if (!i) {
                         break R;
                        }
                        g = w[i + 21 | 0];
                        if (ud(g)) {
                         ua = h, wa = Gh(g), t[ua + 837 | 0] = wa;
                        }
                        i = w[i + 22 | 0];
                        if (!ud(i)) {
                         break R;
                        }
                        ua = h, wa = Gh(i), t[ua + 838 | 0] = wa;
                       }
                       S: {
                        if (!(Tc(w[h + 788 | 0]) | w[h + 789 | 0])) {
                         break S;
                        }
                        g = w[h + 803 | 0];
                        T: {
                         if (!g) {
                          g = 0;
                          break T;
                         }
                         if (x[b + 480192 >> 1] < g >>> 0) {
                          break T;
                         }
                         i = v[(g << 2) + ka >> 2];
                         if (!i | !(t[i + 15 | 0] & 1)) {
                          break T;
                         }
                         Sq(h, v[i + 8 >> 2], b);
                         g = w[h + 803 | 0];
                        }
                        a = rr(b, a, g & 255);
                        if (!a) {
                         break S;
                        }
                        a = B(a, 104) + ra | 0;
                        if (!(w[a + 34 | 0] & 32)) {
                         break S;
                        }
                        Sq(h, x[a + 28 >> 1], b);
                       }
                       U: {
                        V: {
                         W: {
                          a = w[h + 790 | 0];
                          switch (a - 1 | 0) {
                          case 1:
                           break O;

                          case 2:
                          case 3:
                           break V;

                          case 0:
                           break W;

                          default:
                           break U;
                          }
                         }
                         ua = Se(v[s + 8 >> 2], l), wa = w[h + 792 | 0], t[ua + 5 | 0] = wa;
                         break O;
                        }
                        a = w[h + 792 | 0];
                        if (!a) {
                         break O;
                        }
                        t[h + 834 | 0] = a;
                        break O;
                       }
                       if ((a | 0) == 11) {
                        break P;
                       }
                       break O;
                      }
                      v[m + 32 >> 2] = v[b + 480216 >> 2];
                      a = Vb(v[b + 484344 >> 2], x[m + 70 >> 1]);
                      e = v[a + 16 >> 2];
                      if (tT(e, v[a + 20 >> 2])) {
                       v[m + 32 >> 2] = e;
                      }
                      i = sT(b, m);
                      a = B(i, q);
                      A[s + 24 >> 3] = A[s + 24 >> 3] + +(a >>> 0) / +y[b + 24620 >> 2];
                      v[m >> 2] = a + v[m >> 2];
                      X: {
                       Y: {
                        Z: {
                         if (la) {
                          break Z;
                         }
                         f = 0;
                         ea = (n | 0) != 0 & (i | 0) != (n | 0);
                         while (1) {
                          if (x[b + 480188 >> 1] <= f >>> 0) {
                           break Z;
                          }
                          E = Se(v[s + 8 >> 2], f);
                          _: {
                           if (v[E >> 2] == -1) {
                            break _;
                           }
                           a = B(f, 872) + W | 0;
                           D = a + 788 | 0;
                           Q = v[a + 700 >> 2];
                           if (!Q) {
                            if (AB(D)) {
                             break _;
                            }
                           }
                           l = w[a + 793 | 0];
                           g = Il(w[a + 790 | 0], w[a + 791 | 0]);
                           if (w[a + 789 | 0]) {
                            v[a + 660 >> 2] = 0;
                           }
                           e = l & 15;
                           h = 0;
                           $: {
                            if (!Tc(w[D | 0])) {
                             break $;
                            }
                            if (g & w[E + 4 | 0] != 0) {
                             zB(k + 24 | 0, b, a, Q, 0);
                             h = v[k + 28 >> 2];
                             v[a + 8 >> 2] = v[k + 24 >> 2];
                             v[a + 12 >> 2] = h;
                            }
                            t[a + 802 | 0] = w[a + 799 | 0];
                            Q = v[a + 692 >> 2];
                            h = w[a + 803 | 0];
                            if (h) {
                             Ko(b, a, h, g, 1, 1);
                            }
                            h = w[a + 788 | 0];
                            v[31601] = 0;
                            fa(608, b | 0, a | 0, h | 0, g | 0, 1, 0, 65535);
                            h = v[31601];
                            v[31601] = 0;
                            if ((h | 0) == 1) {
                             break Y;
                            }
                            l = l >>> 4 | 0;
                            rT(b, a);
                            qT(v[b + 480180 >> 2], x[b + 480188 >> 1], m, f & 65535);
                            S = Se(v[s + 8 >> 2], f);
                            t[S + 4 | 0] = 1;
                            E = w[a + 791 | 0];
                            aa: {
                             if (!((w[a + 793 | 0] & 240) != 208 | (E - 19 & 255) >>> 0 > 1)) {
                              h = e;
                              if (h >>> 0 < q >>> 0) {
                               break aa;
                              }
                             }
                             h = (E | 0) == 33 ? l >>> 0 < q >>> 0 ? l : 0 : 0;
                            }
                            I = v[Z >> 2];
                            if (!(!(v[b + 480180 >> 2] & 16777250) | (!h | I >>> 0 < 2))) {
                             h = B(I - 1 | 0, v[m + 24 >> 2] + v[m + 40 >> 2] | 0) + h | 0;
                            }
                            if (!g) {
                             v[S >> 2] = 0;
                            }
                            ba: {
                             if ((E | 0) == 9) {
                              break ba;
                             }
                             ca: {
                              if ((E | 0) != 19) {
                               if ((E | 0) != 20 | (l | 0) != 8) {
                                break ca;
                               }
                               break ba;
                              }
                              if ((l | 0) == 8) {
                               break ba;
                              }
                             }
                             if (w[a + 790 | 0] != 2) {
                              break $;
                             }
                            }
                            v[a + 692 >> 2] = Q;
                           }
                           da: {
                            if (!Tc(w[D | 0])) {
                             Ib(k + 24 | 0, F, 114);
                             if (!Fb(v[v[k + 24 >> 2] >> 2], v[k + 28 >> 2])) {
                              break da;
                             }
                            }
                            ea: {
                             fa: {
                              ga: {
                               ha: {
                                g = w[a + 791 | 0];
                                switch (g - 42 | 0) {
                                case 1:
                                 break ea;

                                case 0:
                                 break fa;

                                case 2:
                                 break ga;

                                default:
                                 break ha;
                                }
                               }
                               if ((g | 0) != 10) {
                                break ea;
                               }
                               g = x[m + 70 >> 1];
                               l = v[m + 48 >> 2];
                               v[31601] = 0;
                               $(609, b | 0, a | 0, f & 65535, l | 0, g | 0);
                               g = v[31601];
                               v[31601] = 0;
                               if ((g | 0) != 1) {
                                break da;
                               }
                               break X;
                              }
                              l = Aua(w[a + 793 | 0], 0, v[a + 76 >> 2], 0);
                              g = gb;
                              E = g >>> 8 | 0;
                              Jo(b, a, Ac((g & 255) << 24 | l >>> 8, E));
                              break da;
                             }
                             if (!v[a + 104 >> 2]) {
                              break ea;
                             }
                             v[31601] = 0;
                             U(610, s | 0, f & 65535, n | 0, -1);
                             g = v[31601];
                             v[31601] = 0;
                             if ((g | 0) == 1) {
                              break X;
                             }
                             oT(a, w[a + 793 | 0]);
                             h = v[m + 40 >> 2] - 1 | 0;
                             break da;
                            }
                            if (w[a + 790 | 0] != 15) {
                             break da;
                            }
                            l = v[a + 104 >> 2];
                            if (!l) {
                             break da;
                            }
                            g = w[a + 792 | 0];
                            if (g >>> 0 > 9) {
                             break da;
                            }
                            ia: {
                             if (!g) {
                              g = v[a + 664 >> 2];
                              break ia;
                             }
                             g = v[xb(l + 68 | 0, g - 1 | 0) >> 2];
                             v[a + 664 >> 2] = g;
                            }
                            Jo(b, a, g);
                           }
                           ja: {
                            ka: {
                             la: {
                              switch (w[D | 0] - 253 | 0) {
                              case 0:
                               if (x[b + 480192 >> 1]) {
                                break ka;
                               }
                               break;

                              case 1:
                              case 2:
                               break ka;

                              default:
                               break la;
                              }
                             }
                             g = w[a + 791 | 0];
                             if (!((w[a + 793 | 0] & 240) != 192 | (g - 19 & 255) >>> 0 > 1) & e >>> 0 < q >>> 0) {
                              break ka;
                             }
                             E = g & 255;
                             if ((E | 0) == 25) {
                              break ka;
                             }
                             l = 1;
                             if (!((E | 0) == 33 & (e | 0) != 0 & q >>> 0 > h + e >>> 0)) {
                              break ja;
                             }
                            }
                            g = w[a + 791 | 0];
                            l = 0;
                           }
                           ma: {
                            na: {
                             oa: {
                              e = g & 255;
                              if ((e | 0) != 46) {
                               if ((e | 0) != 13) {
                                break oa;
                               }
                               I = w[a + 793 | 0] << 2;
                               break na;
                              }
                              I = w[a + 793 | 0];
                              break na;
                             }
                             if (w[a + 790 | 0] != 1) {
                              break ma;
                             }
                             I = w[a + 792 | 0] << 2;
                            }
                            v[a + 688 >> 2] = I;
                           }
                           pa: {
                            qa: {
                             ra: {
                              if (!(l & (v[a + 104 >> 2] != 0 & e >>> 0 < 47))) {
                               break ra;
                              }
                              Ib(k + 24 | 0, ja, e);
                              if (Fb(v[v[k + 24 >> 2] >> 2], v[k + 28 >> 2])) {
                               break qa;
                              }
                              g = w[a + 791 | 0];
                              if ((g | 0) != 19) {
                               break ra;
                              }
                              e = w[a + 793 | 0] & 240;
                              if ((e | 0) == 16) {
                               break qa;
                              }
                              g = 19;
                              if ((e | 0) == 32) {
                               break qa;
                              }
                             }
                             if (l) {
                              break pa;
                             }
                            }
                            gV(a);
                            ua = Se(v[s + 8 >> 2], f), wa = 0, v[ua >> 2] = wa;
                            break _;
                           }
                           if (ea) {
                            v[31601] = 0;
                            U(610, s | 0, f & 65535, n | 0, -1);
                            e = v[31601];
                            v[31601] = 0;
                            if ((e | 0) == 1) {
                             break X;
                            }
                            g = w[a + 791 | 0];
                           }
                           sa: {
                            ta: {
                             ua: {
                              va: {
                               wa: {
                                e = g & 255;
                                if (e - 6 >>> 0 >= 2) {
                                 xa: {
                                  switch (e - 19 | 0) {
                                  case 1:
                                   break va;

                                  case 0:
                                   break wa;

                                  default:
                                   break xa;
                                  }
                                 }
                                 if (e - 35 >>> 0 < 2) {
                                  break ta;
                                 }
                                 if ((e | 0) == 45) {
                                  break ua;
                                 }
                                 if ((e | 0) != 11) {
                                  break sa;
                                 }
                                }
                                if (!w[a + 793 | 0] & v[b + 480180 >> 2] == 1) {
                                 break sa;
                                }
                                l = 0;
                                while (1) {
                                 if ((l | 0) == (q | 0)) {
                                  break sa;
                                 }
                                 t[a + 851 | 0] = !l | w[a + 851 | 0] & 254;
                                 Io(b, a, w[a + 793 | 0]);
                                 l = l + 1 | 0;
                                 continue;
                                }
                               }
                               g = w[a + 793 | 0];
                               e = g & 15;
                               if (!(e | v[b + 480180 >> 2] & 1048580)) {
                                break sa;
                               }
                               t[a + 851 | 0] = w[a + 851 | 0] | 1;
                               g = g & 240;
                               if ((g | 0) != 176) {
                                if ((g | 0) != 160) {
                                 break sa;
                                }
                                Ho(b, a, e, 0);
                                break sa;
                               }
                               Go(b, a, e, 0);
                               break sa;
                              }
                              ya: {
                               za: {
                                Aa: {
                                 e = w[a + 793 | 0];
                                 switch (e - 158 | 0) {
                                 case 1:
                                  break za;

                                 case 0:
                                  break Aa;

                                 default:
                                  break ya;
                                 }
                                }
                                v[31601] = 0;
                                U(610, s | 0, f & 65535, n | 0, -1);
                                e = v[31601];
                                v[31601] = 0;
                                if ((e | 0) == 1) {
                                 break X;
                                }
                                v[a + 88 >> 2] = v[a + 88 >> 2] & -129;
                                break sa;
                               }
                               v[31601] = 0;
                               U(610, s | 0, f & 65535, n | 0, -1);
                               e = v[31601];
                               v[31601] = 0;
                               if ((e | 0) == 1) {
                                break X;
                               }
                               e = v[a + 88 >> 2];
                               v[a + 88 >> 2] = e | 128;
                               if (v[a + 4 >> 2]) {
                                break sa;
                               }
                               g = v[a + 76 >> 2];
                               if (!g) {
                                break sa;
                               }
                               if (!(ua = Tc(w[D | 0]), wa = 1, xa = e & 2, xa ? ua : wa)) {
                                break sa;
                               }
                               v[a >> 2] = -1;
                               v[a + 4 >> 2] = g - 1;
                               break sa;
                              }
                              if ((e & 240) != 112 | e >>> 0 < 115) {
                               break sa;
                              }
                              dV(a, e, v[b + 480180 >> 2]);
                              break sa;
                             }
                             nT(a, w[a + 793 | 0]);
                             break sa;
                            }
                            v[31601] = 0;
                            e = f & 65535;
                            U(610, s | 0, e | 0, n | 0, -1);
                            g = v[31601];
                            v[31601] = 0;
                            if ((g | 0) == 1) {
                             break X;
                            }
                            ua = a, wa = mT(b, x[m + 70 >> 1], v[m + 48 >> 2], e), u[ua + 774 >> 1] = wa;
                           }
                           e = w[a + 851 | 0] | 1;
                           t[a + 851 | 0] = e;
                           Ba: {
                            Ca: {
                             switch (w[a + 790 | 0] - 3 | 0) {
                             case 2:
                              e = w[a + 792 | 0];
                              Ib(k + 24 | 0, F, 41);
                              Ho(b, a, e, Fb(v[v[k + 24 >> 2] >> 2], v[k + 28 >> 2]));
                              break Ba;

                             case 3:
                              e = w[a + 792 | 0];
                              Ib(k + 24 | 0, F, 41);
                              Go(b, a, e, Fb(v[v[k + 24 >> 2] >> 2], v[k + 28 >> 2]));
                              break Ba;

                             case 0:
                             case 1:
                              g = w[a + 792 | 0];
                              Da: {
                               if (g) {
                                break Da;
                               }
                               Ib(k + 24 | 0, F, 41);
                               g = 0;
                               if (!Fb(v[v[k + 24 >> 2] >> 2], v[k + 28 >> 2])) {
                                break Da;
                               }
                               g = w[a + 834 | 0];
                               if (!g) {
                                break Ba;
                               }
                              }
                              l = 0;
                              e = (w[a + 790 | 0] == 3 ? g << 4 : g) & 255;
                              while (1) {
                               if ((l | 0) == (q | 0)) {
                                break Ba;
                               }
                               t[a + 851 | 0] = !l | w[a + 851 | 0] & 254;
                               Io(b, a, e);
                               l = l + 1 | 0;
                               continue;
                              }
                              ;

                             case 11:
                              break Ca;

                             default:
                              break Ba;
                             }
                            }
                            g = w[a + 792 | 0];
                            if (g >>> 0 > 1) {
                             break Ba;
                            }
                            t[a + 851 | 0] = (e & 247 | g << 3) ^ 8;
                           }
                           if (w[a + 851 | 0] & 8) {
                            break _;
                           }
                           l = 1;
                           Ea: {
                            Fa: {
                             Ga: {
                              a = w[D + 3 | 0];
                              if (a >>> 0 > 28) {
                               break Ga;
                              }
                              e = 1 << a;
                              if (e & 92) {
                               break Ea;
                              }
                              if (!(e & 268959744)) {
                               break Ga;
                              }
                              if ((w[D + 5 | 0] - 16 & 255) >>> 0 < 32) {
                               break Ea;
                              }
                              break Fa;
                             }
                             if (a - 38 >>> 0 < 4) {
                              break Ea;
                             }
                            }
                            l = (w[D + 2 | 0] - 11 & 255) >>> 0 < 3;
                           }
                           if (l) {
                            e = Se(v[s + 8 >> 2], f);
                            a = v[e >> 2];
                            v[e >> 2] = a + q;
                            v[31601] = 0;
                            U(610, s | 0, f & 65535, i | 0, a + h | 0);
                            a = v[31601];
                            v[31601] = 0;
                            if ((a | 0) != 1) {
                             break _;
                            }
                            a = M() | 0;
                            break m;
                           }
                           a = Se(v[s + 8 >> 2], f);
                           v[a >> 2] = v[a >> 2] + (q - h | 0);
                          }
                          f = f + 1 | 0;
                          continue;
                         }
                        }
                        a = lT(b, m, H, 0);
                        n = i;
                        continue u;
                       }
                       a = M() | 0;
                       break m;
                      }
                      a = M() | 0;
                      break m;
                     }
                     a = w[h + 792 | 0];
                     if (!a) {
                      break O;
                     }
                     i = k + 24 | 0;
                     yB(i, b, w[h + 791 | 0], a, 0);
                     u[h + 768 >> 1] = x[k + 24 >> 1];
                     if (w[_e(i) | 0]) {
                      break N;
                     }
                    }
                    Ha: {
                     Ia: {
                      Ja: {
                       Ka: {
                        La: {
                         switch (D - 12 | 0) {
                         case 0:
                          kT(b, m, l & 65535);
                          break Ha;

                         case 2:
                          a = jT(b, m, l & 65535, f);
                          if ((a | 0) == -1) {
                           break Ha;
                          }
                          v[m + 60 >> 2] = a;
                          break Ha;

                         case 5:
                          Ib(k + 24 | 0, F, 5);
                          if (Fb(v[v[k + 24 >> 2] >> 2], v[k + 28 >> 2])) {
                           break Ha;
                          }
                          g = B(Fo(b, x[m + 70 >> 1], v[m + 48 >> 2], l & 65535, 0), 1e4);
                          v[k + 56 >> 2] = g;
                          Ma: {
                           if (!Y | !(v[b + 480180 >> 2] & 16777250)) {
                            break Ma;
                           }
                           if (g >>> 0 >= 1e4) {
                            t[h + 835 | 0] = (g >>> 0) / 1e4;
                            break Ma;
                           }
                           g = B(w[h + 835 | 0], 1e4);
                           v[k + 56 >> 2] = g;
                          }
                          a = v[b + 8 >> 2];
                          if (g >>> 0 >= 32e4) {
                           v[k + 24 >> 2] = B(v[a + 24 >> 2], 1e4);
                           ua = aa, wa = v[Gb(k + 56 | 0, k + 24 | 0) >> 2], v[ua >> 2] = wa;
                           break Ha;
                          }
                          i = v[aa >> 2];
                          S = (g >>> 0) / 1e4 | 0;
                          I = B(Q, S & 15);
                          g = i - I | 0;
                          v[aa >> 2] = (S & 48) == 16 ? i + I | 0 : g >>> 0 <= i >>> 0 ? g : 0;
                          i = v[a + 20 >> 2];
                          a = v[a + 24 >> 2];
                          Ib(k + 24 | 0, F, 8);
                          Fp(aa, B(i, 1e4), Fb(v[v[k + 24 >> 2] >> 2], v[k + 28 >> 2]) ? 255e4 : B(a, 1e4));
                          break Ha;

                         case 8:
                          Na: {
                           switch (f - 144 >>> 4 | 0) {
                           case 0:
                            if (f >>> 0 > 145) {
                             break Ha;
                            }
                            v[h + 88 >> 2] = v[h + 88 >> 2] & -257 | ((f | 0) == 145) << 8;
                            break Ha;

                           case 1:
                            t[h + 836 | 0] = f & 15;
                            break Ha;

                           case 2:
                            break Ka;

                           case 6:
                            break Na;

                           default:
                            break Ha;
                           }
                          }
                          t[h + 844 | 0] = f & 15;
                          break Ha;

                         case 1:
                         case 3:
                         case 4:
                         case 6:
                          break Ha;

                         case 7:
                          break La;

                         default:
                          break Ia;
                         }
                        }
                        a = f & 240;
                        if ((a | 0) == 240) {
                         break Ja;
                        }
                        if ((a | 0) != 96) {
                         break Ha;
                        }
                       }
                       wB(b, m, l & 65535, f & 15);
                       break Ha;
                      }
                      t[h + 844 | 0] = f & 15;
                      break Ha;
                     }
                     if ((D | 0) != 28 | (f & 240) != 160) {
                      break Ha;
                     }
                     Ib(k + 24 | 0, F, 58);
                     if (Fb(v[v[k + 24 >> 2] >> 2], v[k + 28 >> 2])) {
                      break Ha;
                     }
                     t[h + 836 | 0] = f & 15;
                    }
                    if (!Y) {
                     break M;
                    }
                    Oa: {
                     Pa: {
                      Qa: {
                       Ra: {
                        Sa: {
                         Ta: {
                          Ua: {
                           Va: {
                            Wa: {
                             switch (D - 2 | 0) {
                             case 0:
                              if (!f) {
                               break Oa;
                              }
                              Ib(k + 24 | 0, F, 90);
                              if (!Fb(v[v[k + 24 >> 2] >> 2], v[k + 28 >> 2])) {
                               t[h + 812 | 0] = f;
                              }
                              t[h + 811 | 0] = f;
                              break N;

                             case 1:
                              if (!f) {
                               break Oa;
                              }
                              Ib(k + 24 | 0, F, 90);
                              if (!Fb(v[v[k + 24 >> 2] >> 2], v[k + 28 >> 2])) {
                               t[h + 811 | 0] = f;
                              }
                              t[h + 812 | 0] = f;
                              break N;

                             case 2:
                              if (!f) {
                               break Oa;
                              }
                              u[h + 768 >> 1] = f;
                              break N;

                             case 8:
                              if (!f) {
                               break Oa;
                              }
                              v[h + 664 >> 2] = f << 8;
                              break N;

                             case 4:
                             case 9:
                              if (!f) {
                               break Oa;
                              }
                              t[h + 809 | 0] = f;
                              break N;

                             case 11:
                              ua = Se(v[s + 8 >> 2], l), wa = f, t[ua + 5 | 0] = wa;
                              break N;

                             case 44:
                              ua = Se(v[s + 8 >> 2], l), wa = f + 3 >>> 2 | 0, t[ua + 5 | 0] = wa;
                              break N;

                             case 21:
                              a = v[b + 480180 >> 2];
                              f = f << (!(a & 59593760) & f << 24 >> 24 >= 0);
                              i = f & 255;
                              if (i >>> 0 <= 128) {
                               v[L >> 2] = i << 1;
                               break N;
                              }
                              if (a & 16777250) {
                               break N;
                              }
                              v[L >> 2] = 256;
                              break N;

                             case 22:
                              Ib(k + 24 | 0, F, 9);
                              Xa: {
                               if (Fb(v[v[k + 24 >> 2] >> 2], v[k + 28 >> 2])) {
                                if (f) {
                                 t[h + 817 | 0] = f;
                                 break Xa;
                                }
                                f = w[h + 817 | 0];
                                break Xa;
                               }
                               if (f) {
                                t[m + 1433 | 0] = f;
                                break Xa;
                               }
                               f = w[m + 1433 | 0];
                              }
                              a = f & 15;
                              i = f & 255;
                              Ya: {
                               if (!((a | 0) != 15 | i >>> 0 < 16)) {
                                f = (f & 240) >>> 4 << !(v[b + 480180 >> 2] & 59593760);
                                a = v[L >> 2] + (f << 1) | 0;
                                break Ya;
                               }
                               i = i & 240;
                               if (!(!a | (i | 0) != 240)) {
                                f = a << (v[b + 480180 >> 2] & 59593760 ? 1 : 2);
                                a = v[L >> 2] - f | 0;
                                break Ya;
                               }
                               if (i) {
                                f = (f >>> 3 & 30) << !(v[b + 480180 >> 2] & 59593760);
                                a = v[L >> 2] + B(e, f) | 0;
                                break Ya;
                               }
                               f = f << (v[b + 480180 >> 2] & 59593760 ? 1 : 2);
                               a = v[L >> 2] - B(e, f & 255) | 0;
                              }
                              v[L >> 2] = a;
                              Fe(L, 0, 256);
                              break N;

                             case 19:
                              if (f >>> 0 > 64) {
                               break N;
                              }
                              v[h + 748 >> 2] = f;
                              break N;

                             case 20:
                              Za: {
                               if (f) {
                                t[h + 816 | 0] = f;
                                break Za;
                               }
                               f = w[h + 816 | 0];
                              }
                              a = v[h + 748 >> 2];
                              i = f & 15;
                              g = f & 255;
                              _a: {
                               if (!((i | 0) != 15 | g >>> 0 < 16)) {
                                v[k + 24 >> 2] = a + (g >>> 4 | 0);
                                break _a;
                               }
                               if (!(!i | (g & 240) != 240)) {
                                v[k + 24 >> 2] = a - i;
                                break _a;
                               }
                               if (i) {
                                v[k + 24 >> 2] = a - B(e, i);
                                break _a;
                               }
                               v[k + 24 >> 2] = a + B(e, g >>> 4 | 0);
                              }
                              Fe(k + 24 | 0, 0, 64);
                              v[h + 748 >> 2] = v[k + 24 >> 2];
                              break N;

                             case 7:
                              Ym(b, h, f, 8);
                              break N;

                             case 29:
                             case 30:
                              break Pa;

                             case 25:
                              break Qa;

                             case 6:
                              break Ra;

                             case 24:
                              break Sa;

                             case 3:
                              break Ta;

                             case 5:
                              break Ua;

                             case 18:
                              break Va;

                             case 17:
                              break Wa;

                             default:
                              break N;
                             }
                            }
                            if (f >>> 0 > 15) {
                             break Va;
                            }
                            i = (f & 1) << 14;
                            g = x[b + 480188 >> 1];
                            a = 0;
                            while (1) {
                             if ((a | 0) == (g | 0)) {
                              break Va;
                             }
                             D = B(a, 872) + W | 0;
                             v[D + 88 >> 2] = (i | v[D + 88 >> 2] & -16385) ^ 16384;
                             a = a + 1 | 0;
                             continue;
                            }
                           }
                           if ((f & 240) != 128) {
                            break N;
                           }
                           Ym(b, h, f & 15, 4);
                           break N;
                          }
                          if (f) {
                           t[h + 809 | 0] = f;
                          }
                          f = 0;
                         }
                         Fl(h, f);
                         break N;
                        }
                        iT(b, h, f);
                        break N;
                       }
                       hT(h, f);
                       break N;
                      }
                      gT(h, f);
                      break N;
                     }
                     $a: {
                      if (f << 24 >> 24 >= 0) {
                       a = Oe(pa, w[h + 844 | 0]);
                       break $a;
                      }
                      a = Oe(qa, f & 127);
                     }
                     i = w[h + 793 | 0];
                     v[31601] = 0;
                     ia(611, b | 0, m | 0, l & 65535, 0, a | 0, i | 0);
                     a = v[31601];
                     v[31601] = 0;
                     if ((a | 0) != 1) {
                      break N;
                     }
                     a = M() | 0;
                     break m;
                    }
                    f = 0;
                   }
                   ab: {
                    bb: {
                     switch (w[h + 790 | 0] - 2 | 0) {
                     case 0:
                      Ym(b, h, w[h + 792 | 0], 6);
                      break ab;

                     case 5:
                      Ib(k + 24 | 0, F, 53);
                      a = w[h + 792 | 0];
                      if (Fb(v[v[k + 24 >> 2] >> 2], v[k + 28 >> 2])) {
                       t[h + 823 | 0] = a & 15;
                       break ab;
                      }
                      Fl(h, a << 4);
                      break ab;

                     case 6:
                      break bb;

                     default:
                      break ab;
                     }
                    }
                    Fl(h, w[h + 792 | 0]);
                   }
                   cb: {
                    db: {
                     eb: {
                      fb: {
                       gb: {
                        a = w[h + 791 | 0];
                        switch (a - 5 | 0) {
                        case 1:
                         break cb;

                        case 3:
                         break eb;

                        case 0:
                        case 2:
                         break fb;

                        default:
                         break gb;
                        }
                       }
                       switch (a - 26 | 0) {
                       case 1:
                        break db;

                       case 0:
                        break fb;

                       default:
                        break cb;
                       }
                      }
                      hb: {
                       if (v[b + 480180 >> 2] & 16777248) {
                        a = q;
                        if (!(w[b + 480208 | 0] & 4)) {
                         break hb;
                        }
                       }
                       a = e;
                      }
                      i = w[h + 823 | 0];
                      Ib(k + 24 | 0, F, 21);
                      a = B(a, i);
                      ua = h, wa = w[h + 819 | 0] + (Fb(v[v[k + 24 >> 2] >> 2], v[k + 28 >> 2]) ? a << 2 : a) | 0, 
                      t[ua + 819 | 0] = wa;
                      break cb;
                     }
                     ib: {
                      if (v[b + 480180 >> 2] & 16777248) {
                       a = q;
                       if (!(w[b + 480208 | 0] & 4)) {
                        break ib;
                       }
                      }
                      a = e;
                     }
                     i = w[h + 826 | 0];
                     Ib(k + 24 | 0, F, 21);
                     a = B(a, i);
                     ua = h, wa = w[h + 820 | 0] + (Fb(v[v[k + 24 >> 2] >> 2], v[k + 28 >> 2]) ? a << 2 : a) | 0, 
                     t[ua + 820 | 0] = wa;
                     break cb;
                    }
                    t[h + 821 | 0] = w[h + 821 | 0] + B(E, w[h + 829 | 0]);
                    eT(b, h);
                   }
                   Ib(k + 24 | 0, F, 78);
                   if (!Fb(v[v[k + 24 >> 2] >> 2], v[k + 28 >> 2])) {
                    break M;
                   }
                   a = f & 255;
                   if (!a) {
                    break M;
                   }
                   dT(h, a);
                  }
                  l = l + 1 | 0;
                  continue;
                 }
                }
                break;
               }
               break;
              }
              a = M() | 0;
              break m;
             }
             a = M() | 0;
             break m;
            }
            a = M() | 0;
            break m;
           }
           a = M() | 0;
           break m;
          }
          a = M() | 0;
          break m;
         }
         i = 1;
         break n;
        }
        i = 0;
       }
       jb: {
        if ((_ | 0) != 7) {
         break jb;
        }
        a = 0;
        while (1) {
         if (x[b + 480188 >> 1] <= a >>> 0) {
          break jb;
         }
         kb: {
          if (v[Se(v[s + 8 >> 2], a) >> 2] == -1) {
           break kb;
          }
          v[31601] = 0;
          U(610, s | 0, a & 65535, n | 0, -1);
          d = v[31601];
          v[31601] = 0;
          if ((d | 0) != 1) {
           break kb;
          }
          a = M() | 0;
          break m;
         }
         a = a + 1 | 0;
         continue;
        }
       }
       if (w[r + 26 | 0]) {
        u[r + 20 >> 1] = x[m + 72 >> 1];
        v[r + 8 >> 2] = v[m + 48 >> 2];
       }
       A[r >> 3] = A[s + 24 >> 3];
       v[31601] = 0;
       N(605, X | 0, r | 0);
       a = v[31601];
       v[31601] = 0;
       if ((a | 0) != 1) {
        if (!Y) {
         break a;
        }
        if (!(i ? w[r + 26 | 0] : 1)) {
         break c;
        }
        q = jB(k + 56 | 0);
        if (Hd(w[da + 24 | 0])) {
         TS(q, da);
        }
        vB(da);
        n = m + 616 | 0;
        d = yc(b + 1074376 | 0, m, 614);
        e = d + 616 | 0;
        a = 0;
        while (1) {
         if ((a | 0) == 256) {
          yn(d + 223848 | 0, m + 223848 | 0);
          a = d + 223860 | 0;
          e = w[a + 24 | 0];
          n = m + 223860 | 0;
          lb: {
           if ((Hd(w[n + 24 | 0]) | 0) == (e | 0)) {
            if (!e) {
             break lb;
            }
            e = fc(a);
            Nu(a, v[e >> 2]);
            v[a >> 2] = v[n >> 2];
            v[a + 4 >> 2] = v[n + 4 >> 2];
            v[a + 8 >> 2] = v[n + 8 >> 2];
            mb: {
             if (!v[zb(a) >> 2]) {
              v[a >> 2] = e;
              break mb;
             }
             v[v[e >> 2] + 8 >> 2] = e;
             e = fc(n);
             v[n >> 2] = e;
             v[e >> 2] = 0;
             ua = zb(n), wa = 0, v[ua >> 2] = wa;
            }
            a = a + 12 | 0;
            e = fc(a);
            Mu(a, v[e >> 2]);
            n = n + 12 | 0;
            v[a >> 2] = v[n >> 2];
            v[a + 4 >> 2] = v[n + 4 >> 2];
            v[a + 8 >> 2] = v[n + 8 >> 2];
            nb: {
             if (!v[zb(a) >> 2]) {
              v[a >> 2] = e;
              break nb;
             }
             v[v[e >> 2] + 8 >> 2] = e;
             a = fc(n);
             v[n >> 2] = a;
             v[a >> 2] = 0;
             ua = zb(n), wa = 0, v[ua >> 2] = wa;
            }
            break lb;
           }
           if (e) {
            vB(a);
            break lb;
           }
           TS(a, n);
          }
         } else {
          i = B(a, 872);
          Gq(i + e | 0, i + n | 0);
          a = a + 1 | 0;
          continue;
         }
         break;
        }
        tB(d);
        v[b + 1074400 >> 2] = 0;
        t[b + 1074476 | 0] = 1;
        v[b + 1074392 >> 2] = -2;
        v[b + 1074396 >> 2] = 0;
        v[b + 1074428 >> 2] = v[b + 1074424 >> 2];
        ob: {
         pb: {
          a = v[b + 1298300 >> 2];
          if (Ej(a)) {
           break pb;
          }
          v[31601] = 0;
          V(612, a | 0);
          a = v[31601];
          v[31601] = 0;
          if ((a | 0) != 1) {
           break pb;
          }
          break ob;
         }
         e = b + 1074992 | 0;
         i = (_ | 0) == 7;
         a = 0;
         while (1) {
          if (x[b + 480188 >> 1] <= a >>> 0) {
           d = JC(k + 24 | 0);
           a = Si(v[q + 12 >> 2]);
           v[k + 20 >> 2] = a;
           e = b + 906300 | 0;
           g = Of(q + 12 | 0);
           while (1) {
            if (!Yg(a, g)) {
             qb: {
              a = 250;
              n = d;
              rb: {
               while (1) {
                if (a >>> 0 >= 32) {
                 if (v[n >> 2]) {
                  a = 1;
                  break rb;
                 } else {
                  a = a - 32 | 0;
                  n = n + 4 | 0;
                  continue;
                 }
                }
                break;
               }
               a = (v[d + 28 >> 2] & 67108863) != 0;
              }
              if (!a) {
               break qb;
              }
              a = 0;
              while (1) {
               if ((a | 0) == 250) {
                break qb;
               }
               Ib(k + 12 | 0, d, a);
               sb: {
                if (!Fb(v[v[k + 12 >> 2] >> 2], v[k + 16 >> 2])) {
                 break sb;
                }
                n = v[_d(e, a) >> 2];
                i = v[v[n >> 2] + 180 >> 2];
                v[31601] = 0;
                V(i | 0, n | 0);
                n = v[31601];
                v[31601] = 0;
                if ((n | 0) != 1) {
                 break sb;
                }
                break ob;
               }
               a = a + 1 | 0;
               continue;
              }
             }
             a = Si(v[q >> 2]);
             v[k + 12 >> 2] = a;
             d = Of(q);
             while (1) if (Yg(a, d)) {
              a = td(a);
              n = fc(a);
              ua = _d(e, w[a | 0]), ya = z[n >> 2], z[ua + 144 >> 2] = ya;
              a = v[$g(k + 12 | 0) >> 2];
              continue;
             } else {
              Hq(q);
              break b;
             }
            }
            n = td(a);
            h = zb(n);
            tb: {
             i = w[n | 0];
             a = v[_d(e, i) >> 2];
             if (a) {
              Ib(k + 12 | 0, d, i);
              if (!Fb(v[v[k + 12 >> 2] >> 2], v[k + 16 >> 2])) {
               v[31601] = 0;
               O(613, d | 0, i | 0) | 0;
               i = v[31601];
               v[31601] = 0;
               if ((i | 0) == 1) {
                break tb;
               }
               i = v[v[a >> 2] + 176 >> 2];
               v[31601] = 0;
               N(i | 0, a | 0, -1);
               i = v[31601];
               v[31601] = 0;
               if ((i | 0) == 1) {
                break tb;
               }
              }
              ta = z[h >> 2];
              n = v[n + 4 >> 2];
              i = v[v[a >> 2] + 44 >> 2];
              v[31601] = 0;
              va(i | 0, a | 0, n | 0, C(ta));
              a = v[31601];
              v[31601] = 0;
              if ((a | 0) == 1) {
               break tb;
              }
             }
             a = v[$g(k + 20 | 0) >> 2];
             continue;
            }
            break;
           }
           break ob;
          }
          d = e + B(a, 872) | 0;
          n = w[d + 799 | 0];
          if (n) {
           t[d + 802 | 0] = n;
          }
          n = Se(v[s + 8 >> 2], a);
          if (!(w[n + 5 | 0] == 255 | i)) {
           t[k + 24 | 0] = 64;
           ua = d, wa = w[Pb(n + 5 | 0, k + 24 | 0) | 0] << 2, v[ua + 688 >> 2] = wa;
          }
          ub: {
           n = v[d + 104 >> 2];
           if (!n | !(w[n + 35 | 0] & 2)) {
            break ub;
           }
           g = v[b + 1298300 >> 2];
           if (!Dd(g)) {
            break ub;
           }
           v[31601] = 0;
           f = g;
           g = a & 65535;
           R(614, f | 0, g | 0, n + 68 | 0);
           n = v[31601];
           v[31601] = 0;
           if ((n | 0) != 1) {
            n = v[b + 1298300 >> 2];
            v[31601] = 0;
            R(615, n | 0, g | 0, 1);
            n = v[31601];
            v[31601] = 0;
            if ((n | 0) != 1) {
             break ub;
            }
           }
           break ob;
          }
          v[d + 16 >> 2] = 0;
          a = a + 1 | 0;
          continue;
         }
        }
        a = M() | 0;
        Hq(q);
        break m;
       }
       a = M() | 0;
      }
      Su(G);
     }
     cT(s);
    }
    Pi(X);
    P(a | 0);
    p();
   }
   if ((c | 0) == 3) {
    break b;
   }
   v[b + 1074416 >> 2] = v[b + 480196 >> 2];
   v[b + 1074420 >> 2] = v[b + 480204 >> 2];
   v[b + 1074456 >> 2] = v[b + 480200 >> 2];
  }
  a = ha & 255;
  if ((a | 0) == w[b + 484376 | 0]) {
   break a;
  }
  Vj(na, a);
 }
 if (c & 9) {
  a = b + 1298264 | 0;
  if (v[a >> 2]) {
   ZT(a);
   b = v[a >> 2];
   al(a);
   Bb(b);
   ua = zb(a), wa = 0, v[ua >> 2] = wa;
   v[a >> 2] = 0;
   v[a + 4 >> 2] = 0;
  }
  v[a >> 2] = v[G >> 2];
  v[a + 4 >> 2] = v[G + 4 >> 2];
  b = zb(G);
  ua = zb(a), wa = v[b >> 2], v[ua >> 2] = wa;
  v[b >> 2] = 0;
  v[G >> 2] = 0;
  v[G + 4 >> 2] = 0;
  a = a + 12 | 0;
  c = fc(a);
  Mq(a, v[c >> 2]);
  b = G + 12 | 0;
  v[a >> 2] = v[b >> 2];
  v[a + 4 >> 2] = v[b + 4 >> 2];
  v[a + 8 >> 2] = v[b + 8 >> 2];
  vb: {
   if (!v[zb(a) >> 2]) {
    v[a >> 2] = c;
    break vb;
   }
   v[v[c >> 2] + 8 >> 2] = c;
   a = fc(b);
   v[b >> 2] = a;
   v[a >> 2] = 0;
   ua = zb(b), wa = 0, v[ua >> 2] = wa;
  }
 }
 Su(G);
 cT(s);
 eb = k + 192 | 0;
}

function dpa(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, q = 0, r = 0, s = 0, z = 0, A = 0;
 d = eb - 336 | 0;
 eb = d;
 xc(b);
 k = d + 324 | 0;
 a: {
  if (!fp(b, k)) {
   break a;
  }
  if (!iX(k)) {
   break a;
  }
  r = Ge(d + 304 | 0, b);
  q = Mb(d + 292 | 0);
  b: {
   c: {
    d: {
     e: {
      f: {
       g: {
        h: {
         i: {
          j: {
           k: {
            l: {
             m: {
              n: {
               o: {
                p: {
                 q: {
                  r: {
                   s: {
                    t: {
                     u: {
                      v: {
                       w: {
                        x: {
                         if ((c | 0) == 64) {
                          v[31601] = 0;
                          e = d + 40 | 0;
                          N(663, e | 0, r | 0);
                          b = v[31601];
                          v[31601] = 0;
                          if ((b | 0) == 1) {
                           break v;
                          }
                          break x;
                         }
                         v[31601] = 0;
                         e = d + 40 | 0;
                         N(664, e | 0, r | 0);
                         b = v[31601];
                         v[31601] = 0;
                         if ((b | 0) == 1) {
                          break w;
                         }
                        }
                        Dv(q, e);
                        je(e);
                        v[31601] = 0;
                        b = d + 40 | 0;
                        R(665, b | 0, q | 0, 1413891155);
                        e = v[31601];
                        v[31601] = 0;
                        y: {
                         z: {
                          if ((e | 0) != 1) {
                           v[31601] = 0;
                           e = O(666, b | 0, 14138) | 0;
                           k = v[31601];
                           v[31601] = 0;
                           if ((k | 0) == 1) {
                            break z;
                           }
                           tb(b);
                           if ((c | 0) != 64 & e) {
                            break y;
                           }
                           break b;
                          }
                          b = M() | 0;
                          break c;
                         }
                         b = M() | 0;
                         tb(d + 40 | 0);
                         break c;
                        }
                        v[31601] = 0;
                        N(246, a | 0, 4194304);
                        b = v[31601];
                        v[31601] = 0;
                        if ((b | 0) == 1) {
                         break d;
                        }
                        v[a + 480208 >> 2] = 12;
                        v[31601] = 0;
                        b = d + 272 | 0;
                        R(665, b | 0, q | 0, 1280592212);
                        e = v[31601];
                        v[31601] = 0;
                        if ((e | 0) == 1) {
                         break e;
                        }
                        v[31601] = 0;
                        e = Q(154, v[d + 272 >> 2]) | 0;
                        k = v[31601];
                        v[31601] = 0;
                        if ((k | 0) == 1) {
                         break g;
                        }
                        v[31601] = 0;
                        R(455, b | 0, a + 1298308 | 0, e | 0);
                        b = v[31601];
                        v[31601] = 0;
                        if ((b | 0) == 1) {
                         break g;
                        }
                        Mc(Wb(v[a + 484360 >> 2], w[a + 484376 | 0]));
                        k = Mb(d + 260 | 0);
                        t[d + 259 | 0] = 0;
                        t[d + 258 | 0] = 0;
                        v[31601] = 0;
                        R(667, d + 244 | 0, q | 0, 1196314451);
                        b = v[31601];
                        v[31601] = 0;
                        if ((b | 0) == 1) {
                         break i;
                        }
                        o = a + 484360 | 0;
                        z = d, A = vb(v[d + 244 >> 2]), v[z + 240 >> 2] = A;
                        n = d + 228 | 0;
                        m = vb(v[d + 248 >> 2]);
                        A: {
                         while (1) {
                          b = v[d + 240 >> 2];
                          if (!Hb(b, m)) {
                           break A;
                          }
                          f = Ge(d + 40 | 0, b);
                          v[31601] = 0;
                          e = d + 28 | 0;
                          h = O(668, f | 0, e | 0) | 0;
                          b = v[31601];
                          v[31601] = 0;
                          B: {
                           C: {
                            if ((b | 0) != 1) {
                             b = 1;
                             if (!(h & w[d + 37 | 0] == 1)) {
                              break B;
                             }
                             z = a, A = Kd(w[d + 38 | 0], x[a + 480188 >> 1], 127), u[z + 480188 >> 1] = A;
                             v[31601] = 0;
                             h = Q(669, d + 184 | 0) | 0;
                             b = v[31601];
                             v[31601] = 0;
                             D: {
                              E: {
                               F: {
                                if ((b | 0) != 1) {
                                 i = d + 172 | 0;
                                 bf(i, e, 9, 1);
                                 v[31601] = 0;
                                 b = d + 136 | 0;
                                 N(218, b | 0, i | 0);
                                 e = v[31601];
                                 v[31601] = 0;
                                 if ((e | 0) == 1) {
                                  break F;
                                 }
                                 e = d + 16 | 0;
                                 Yb(e, n, 10);
                                 lm(e, b);
                                 sb(b);
                                 b = Wb(v[a + 484360 >> 2], w[a + 484376 | 0]);
                                 if (lc(v[b >> 2], v[b + 4 >> 2])) {
                                  break D;
                                 }
                                 v[31601] = 0;
                                 b = Q(274, o | 0) | 0;
                                 e = v[31601];
                                 v[31601] = 0;
                                 if ((e | 0) == 1) {
                                  break m;
                                 }
                                 if ((b | 0) != 255) {
                                  break E;
                                 }
                                 b = 2;
                                 break C;
                                }
                                b = M() | 0;
                                break k;
                               }
                               b = M() | 0;
                               break l;
                              }
                              b = Wb(v[a + 484360 >> 2], w[a + 484376 | 0]);
                             }
                             v[31601] = 0;
                             e = d + 160 | 0;
                             N(670, e | 0, n | 0);
                             i = v[31601];
                             v[31601] = 0;
                             if ((i | 0) == 1) {
                              break m;
                             }
                             pp(b, e);
                             sb(e);
                             v[31601] = 0;
                             N(664, d + 172 | 0, f | 0);
                             b = v[31601];
                             v[31601] = 0;
                             if ((b | 0) != 1) {
                              z = d, A = vb(v[d + 172 >> 2]), v[z + 156 >> 2] = A;
                              j = vb(v[d + 176 >> 2]);
                              while (1) {
                               G: {
                                H: {
                                 I: {
                                  J: {
                                   K: {
                                    b = v[d + 156 >> 2];
                                    if (Hb(b, j)) {
                                     mp(d + 136 | 0, b);
                                     pi(d + 16 | 0, v[b >> 2], v[b + 4 >> 2]);
                                     e = v[d + 16 >> 2];
                                     if ((e | 0) == 1212960847) {
                                      break K;
                                     }
                                     b = 0;
                                     if ((e | 0) != 1312903248) {
                                      break G;
                                     }
                                     while (1) {
                                      e = b & 65535;
                                      if (e >>> 0 >= x[a + 480188 >> 1]) {
                                       break G;
                                      }
                                      v[31601] = 0;
                                      i = T(150, v[d + 136 >> 2], v[d + 144 >> 2], 2) | 0;
                                      g = v[31601];
                                      v[31601] = 0;
                                      if ((g | 0) == 1) {
                                       break I;
                                      }
                                      if (!i) {
                                       break G;
                                      }
                                      v[31601] = 0;
                                      i = d + 8 | 0;
                                      N(198, i | 0, d + 136 | 0);
                                      g = v[31601];
                                      v[31601] = 0;
                                      if ((g | 0) != 1) {
                                       HC(h, e, w[d + 8 | 0], w[Ic(i) | 0], d + 259 | 0, k);
                                       b = b + 1 | 0;
                                       continue;
                                      }
                                      break;
                                     }
                                     break I;
                                    }
                                    b = 0;
                                    if (x[d + 220 >> 1] == 65535 | x[d + 222 >> 1] == 65535) {
                                     break J;
                                    }
                                    b = w[a + 484376 | 0];
                                    e = v[a + 484360 >> 2];
                                    v[31601] = 0;
                                    V(671, Wb(e, b) | 0);
                                    b = v[31601];
                                    v[31601] = 0;
                                    if ((b | 0) != 1) {
                                     b = 0;
                                     v[31601] = 0;
                                     N(672, k | 0, h | 0);
                                     e = v[31601];
                                     v[31601] = 0;
                                     if ((e | 0) != 1) {
                                      break J;
                                     }
                                    }
                                    b = M() | 0;
                                    break H;
                                   }
                                   if (y[d + 20 >> 2] < 9) {
                                    break G;
                                   }
                                   e = 0;
                                   v[31601] = 0;
                                   O(183, d + 136 | 0, 2) | 0;
                                   b = v[31601];
                                   v[31601] = 0;
                                   i = 65535;
                                   L: {
                                    if ((b | 0) != 1) {
                                     while (1) {
                                      v[31601] = 0;
                                      b = T(150, v[d + 136 >> 2], v[d + 144 >> 2], 1) | 0;
                                      g = v[31601];
                                      v[31601] = 0;
                                      M: {
                                       N: {
                                        O: {
                                         P: {
                                          Q: {
                                           R: {
                                            S: {
                                             T: {
                                              U: {
                                               V: {
                                                W: {
                                                 X: {
                                                  if ((g | 0) != 1) {
                                                   if (!b) {
                                                    break G;
                                                   }
                                                   v[31601] = 0;
                                                   g = Q(197, d + 136 | 0) | 0;
                                                   b = v[31601];
                                                   v[31601] = 0;
                                                   if ((b | 0) == 1) {
                                                    break I;
                                                   }
                                                   b = 4;
                                                   switch (g | 0) {
                                                   case 0:
                                                    break G;

                                                   case 14:
                                                    break N;

                                                   case 13:
                                                    break O;

                                                   case 12:
                                                    break Q;

                                                   case 8:
                                                    break R;

                                                   case 7:
                                                    break S;

                                                   case 2:
                                                    break T;

                                                   case 6:
                                                    break U;

                                                   case 5:
                                                    break V;

                                                   case 3:
                                                   case 4:
                                                    break W;

                                                   case 1:
                                                    break X;

                                                   default:
                                                    break P;
                                                   }
                                                  }
                                                  break I;
                                                 }
                                                 b = Wb(v[a + 484360 >> 2], w[a + 484376 | 0]);
                                                 if (x[d + 220 >> 1] == 65535) {
                                                  z = d, A = am(v[b >> 2], v[b + 4 >> 2]), u[z + 220 >> 1] = A;
                                                 }
                                                 b = am(v[b >> 2], v[b + 4 >> 2]);
                                                 v[31601] = 0;
                                                 u[d + 222 >> 1] = b;
                                                 b = O(673, d + 136 | 0, d + 258 | 0) | 0;
                                                 g = v[31601];
                                                 v[31601] = 0;
                                                 if ((g | 0) == 1) {
                                                  break I;
                                                 }
                                                 Y: {
                                                  Z: {
                                                   switch (b - 254 | 0) {
                                                   case 1:
                                                    b = 65535;
                                                    break Y;

                                                   case 0:
                                                    break Z;

                                                   default:
                                                    break Y;
                                                   }
                                                  }
                                                  b = 65534;
                                                 }
                                                 g = w[a + 484376 | 0];
                                                 l = v[a + 484360 >> 2];
                                                 v[31601] = 0;
                                                 N(536, Wb(l, g) | 0, b | 0);
                                                 b = v[31601];
                                                 v[31601] = 0;
                                                 if ((b | 0) == 1) {
                                                  break I;
                                                 }
                                                 i = (i & 65535) == 65535 ? e : i;
                                                 break M;
                                                }
                                                v[31601] = 0;
                                                b = Q(189, d + 136 | 0) | 0;
                                                l = v[31601];
                                                v[31601] = 0;
                                                if ((l | 0) != 1) {
                                                 _: {
                                                  if (b >>> 0 < (i & 65535) >>> 0) {
                                                   b = x[d + 224 >> 1];
                                                   break _;
                                                  }
                                                  b = b - i | 0;
                                                  u[d + 224 >> 1] = b;
                                                 }
                                                 $e(Wb(v[a + 484360 >> 2], w[a + 484376 | 0]), b & 65535);
                                                 if ((g | 0) != 3) {
                                                  break M;
                                                 }
                                                 v[31601] = 0;
                                                 O(183, d + 136 | 0, 1) | 0;
                                                 b = v[31601];
                                                 v[31601] = 0;
                                                 if ((b | 0) != 1) {
                                                  break M;
                                                 }
                                                }
                                                break I;
                                               }
                                               v[31601] = 0;
                                               b = d + 8 | 0;
                                               N(198, b | 0, d + 136 | 0);
                                               g = v[31601];
                                               v[31601] = 0;
                                               if ((g | 0) != 1) {
                                                HC(h, w[d + 8 | 0], w[Ic(b) | 0], -1, d + 259 | 0, k);
                                                break M;
                                               }
                                               break I;
                                              }
                                              b = 1;
                                             }
                                             v[31601] = 0;
                                             O(183, d + 136 | 0, b | 0) | 0;
                                             b = v[31601];
                                             v[31601] = 0;
                                             if ((b | 0) != 1) {
                                              break M;
                                             }
                                             break I;
                                            }
                                            v[31601] = 0;
                                            b = Q(197, d + 136 | 0) | 0;
                                            g = v[31601];
                                            v[31601] = 0;
                                            if ((g | 0) == 1) {
                                             break I;
                                            }
                                            t[d + 227 | 0] = b;
                                            break M;
                                           }
                                           v[31601] = 0;
                                           b = Q(197, d + 136 | 0) | 0;
                                           g = v[31601];
                                           v[31601] = 0;
                                           if ((g | 0) == 1) {
                                            break I;
                                           }
                                           t[d + 226 | 0] = b;
                                           break M;
                                          }
                                          v[31601] = 0;
                                          b = O(631, d + 136 | 0, d + 8 | 0) | 0;
                                          g = v[31601];
                                          v[31601] = 0;
                                          if ((g | 0) == 1) {
                                           break I;
                                          }
                                          if (w[d + 8 | 0] | !b | (w[d + 10 | 0] | w[d + 9 | 0] != 255)) {
                                           break P;
                                          }
                                          if (w[d + 11 | 0] | w[d + 12 | 0] != 1) {
                                           break P;
                                          }
                                          if (!w[d + 13 | 0]) {
                                           break M;
                                          }
                                         }
                                         tb(d + 136 | 0);
                                         b = 1;
                                         break J;
                                        }
                                        v[31601] = 0;
                                        b = d + 8 | 0;
                                        N(548, b | 0, d + 136 | 0);
                                        g = v[31601];
                                        v[31601] = 0;
                                        if ((g | 0) != 1) {
                                         g = Ic(b);
                                         HC(h, w[d + 8 | 0], w[_e(b) | 0], w[g | 0], d + 259 | 0, k);
                                         break M;
                                        }
                                        break I;
                                       }
                                       v[31601] = 0;
                                       b = d + 8 | 0;
                                       N(198, b | 0, d + 136 | 0);
                                       g = v[31601];
                                       v[31601] = 0;
                                       if ((g | 0) == 1) {
                                        break L;
                                       }
                                       g = v[d + 196 >> 2];
                                       s = Sc(g, v[d + 200 >> 2]);
                                       l = w[d + 8 | 0];
                                       if (s >>> 0 <= l >>> 0) {
                                        break M;
                                       }
                                       b = Ic(b);
                                       z = wb(g, l), A = (w[b | 0] >>> 2 | 0) + 1 | 0, t[z | 0] = A;
                                      }
                                      e = e + 1 | 0;
                                      continue;
                                     }
                                    }
                                    break I;
                                   }
                                   break I;
                                  }
                                  je(d + 172 | 0);
                                  break C;
                                 }
                                 b = M() | 0;
                                 tb(d + 136 | 0);
                                }
                                je(d + 172 | 0);
                                break l;
                               }
                               tb(d + 136 | 0);
                               bm(d + 156 | 0);
                               continue;
                              }
                             }
                             b = M() | 0;
                             break l;
                            }
                            b = M() | 0;
                            break k;
                           }
                           ar(h);
                          }
                          tb(f);
                          if (!b) {
                           Pf(d + 240 | 0);
                           continue;
                          }
                          break;
                         }
                         e = 0;
                         if ((b | 0) != 2) {
                          break s;
                         }
                        }
                        e = 0;
                        Vj(o, 0);
                        b = v[k >> 2];
                        if (lc(b, v[k + 4 >> 2])) {
                         break s;
                        }
                        if (!(c & 2)) {
                         break t;
                        }
                        v[31601] = 0;
                        R(667, d + 136 | 0, q | 0, 1347244868);
                        b = v[31601];
                        v[31601] = 0;
                        $: {
                         if ((b | 0) != 1) {
                          z = d, A = vb(v[d + 136 >> 2]), v[z + 16 >> 2] = A;
                          i = a + 946304 | 0;
                          e = a + 484380 | 0;
                          b = a + 480190 | 0;
                          o = d + 53 | 0;
                          n = d + 57 | 0;
                          g = vb(v[d + 140 >> 2]);
                          m = w[d + 258 | 0];
                          while (1) {
                           h = v[d + 16 >> 2];
                           if (!Hb(h, g)) {
                            Qc(d + 136 | 0);
                            b = v[k >> 2];
                            break t;
                           }
                           aa: {
                            ba: {
                             ca: {
                              if (!m) {
                               v[31601] = 0;
                               f = d + 40 | 0;
                               j = O(674, h | 0, f | 0) | 0;
                               l = v[31601];
                               v[31601] = 0;
                               if ((l | 0) == 1) {
                                break aa;
                               }
                               if (!j) {
                                break ba;
                               }
                               j = w[d + 92 | 0] | w[d + 93 | 0] << 8;
                               l = j + 1 | 0;
                               u[d + 8 >> 1] = l;
                               if (j >>> 0 > 3998) {
                                break ca;
                               }
                               z = b, A = x[qe(b, d + 8 | 0) >> 1], u[z >> 1] = A;
                               v[31601] = 0;
                               N(675, f | 0, e + B(l & 65535, 104) | 0);
                               f = v[31601];
                               v[31601] = 0;
                               if ((f | 0) == 1) {
                                break aa;
                               }
                               j = d + 28 | 0;
                               hX(j, o);
                               v[31601] = 0;
                               f = d + 172 | 0;
                               N(218, f | 0, j | 0);
                               j = v[31601];
                               v[31601] = 0;
                               if ((j | 0) == 1) {
                                break u;
                               }
                               zc(i + (x[d + 8 >> 1] << 5) | 0, f);
                               sb(f);
                               break ca;
                              }
                              v[31601] = 0;
                              f = d + 40 | 0;
                              j = O(676, h | 0, f | 0) | 0;
                              l = v[31601];
                              v[31601] = 0;
                              if ((l | 0) == 1) {
                               break u;
                              }
                              if (!j) {
                               break ba;
                              }
                              j = w[d + 96 | 0] | w[d + 97 | 0] << 8;
                              l = j + 1 | 0;
                              u[d + 8 >> 1] = l;
                              if (j >>> 0 > 3998) {
                               break ca;
                              }
                              z = b, A = x[qe(b, d + 8 | 0) >> 1], u[z >> 1] = A;
                              v[31601] = 0;
                              N(677, f | 0, e + B(l & 65535, 104) | 0);
                              f = v[31601];
                              v[31601] = 0;
                              if ((f | 0) == 1) {
                               break u;
                              }
                              j = d + 28 | 0;
                              hX(j, n);
                              v[31601] = 0;
                              f = d + 172 | 0;
                              N(218, f | 0, j | 0);
                              j = v[31601];
                              v[31601] = 0;
                              if ((j | 0) == 1) {
                               break $;
                              }
                              zc(i + (x[d + 8 >> 1] << 5) | 0, f);
                              sb(f);
                             }
                             f = x[d + 8 >> 1];
                             if ((f - 1 & 65535) >>> 0 > 3998) {
                              break ba;
                             }
                             j = Yc(d + 40 | 0, 8, 1, 0, 2);
                             v[31601] = 0;
                             T(215, j | 0, e + B(f, 104) | 0, h | 0) | 0;
                             h = v[31601];
                             v[31601] = 0;
                             if ((h | 0) != 1) {
                              break ba;
                             }
                             break u;
                            }
                            Pf(d + 16 | 0);
                            continue;
                           }
                           break;
                          }
                          break u;
                         }
                         b = M() | 0;
                         break j;
                        }
                        break u;
                       }
                       b = M() | 0;
                       break c;
                      }
                      b = M() | 0;
                      break c;
                     }
                     b = M() | 0;
                     Qc(d + 136 | 0);
                     break j;
                    }
                    b = GC(b, 0);
                    v[a + 480196 >> 2] = w[b + 43 | 0];
                    v[a + 480204 >> 2] = B(w[b + 42 | 0], 1e4);
                    $e(Wb(v[a + 484360 >> 2], w[a + 484376 | 0]), x[b + 40 >> 1]);
                    i = a + 480280 | 0;
                    b = 0;
                    while (1) {
                     if (x[a + 480188 >> 1] > b >>> 0) {
                      e = i + (b << 5) | 0;
                      Ve(e);
                      h = GC(v[k >> 2], 0);
                      z = e, A = w[wb(v[h + 12 >> 2], b) | 0], u[z + 6 >> 1] = A;
                      z = e, A = w[wb(v[h >> 2], b) | 0], u[z + 4 >> 1] = A;
                      Ib(d + 40 | 0, v[h + 24 >> 2], b);
                      z = e, A = v[e >> 2] & -257 | (Fb(v[v[d + 40 >> 2] >> 2], v[d + 44 >> 2]) ? 256 : 0), 
                      v[z >> 2] = A;
                      b = b + 1 | 0;
                      continue;
                     }
                     break;
                    }
                    v[31601] = 0;
                    b = O(1, d + 172 | 0, (w[d + 258 | 0] ? 17146 : 17003) | 0) | 0;
                    e = v[31601];
                    v[31601] = 0;
                    if ((e | 0) == 1) {
                     break n;
                    }
                    yb(a + 1298344 | 0, b);
                    sb(b);
                    v[31601] = 0;
                    b = O(1, d + 28 | 0, 10137) | 0;
                    e = v[31601];
                    v[31601] = 0;
                    if ((e | 0) == 1) {
                     break o;
                    }
                    yb(a + 1298356 | 0, b);
                    sb(b);
                    z = a, A = v[Ec(d + 40 | 0, 4) >> 2], v[z + 1298404 >> 2] = A;
                    e = 1;
                    if (!(c & 1) | !x[a + 480188 >> 1]) {
                     break s;
                    }
                    v[31601] = 0;
                    R(667, d + 16 | 0, q | 0, 1146045008);
                    b = v[31601];
                    v[31601] = 0;
                    if ((b | 0) == 1) {
                     break p;
                    }
                    b = v[d + 20 >> 2];
                    c = v[d + 16 >> 2];
                    v[31601] = 0;
                    i = a + 484344 | 0;
                    N(223, i | 0, Rf(c, b) & 65535);
                    b = v[31601];
                    v[31601] = 0;
                    if ((b | 0) == 1) {
                     break r;
                    }
                    z = d, A = vb(v[d + 16 >> 2]), v[z + 240 >> 2] = A;
                    g = vb(v[d + 20 >> 2]);
                    while (1) {
                     h = v[d + 240 >> 2];
                     if (!Hb(h, g)) {
                      da: {
                       ea: {
                        b = v[k >> 2];
                        e = v[k + 4 >> 2];
                        if (Cv(b, e) >>> 0 < 2) {
                         break ea;
                        }
                        o = w[d + 259 | 0];
                        c = 0;
                        while (1) {
                         if (Cv(b, e) >>> 0 <= c >>> 0) {
                          break ea;
                         }
                         g = v[a + 484344 >> 2];
                         j = v[a + 484348 >> 2];
                         f = Lj(v[a + 484360 >> 2], c & 255);
                         l = v[f >> 2];
                         h = GC(b, c);
                         n = x[h + 36 >> 1];
                         if (Ie(g, j, x[$b(l, n) >> 1])) {
                          v[31601] = 0;
                          e = O(368, f | 0, n | 0) | 0;
                          b = v[31601];
                          v[31601] = 0;
                          if ((b | 0) == 1) {
                           break da;
                          }
                          fa: {
                           if (!o) {
                            break fa;
                           }
                           b = 0;
                           while (1) {
                            if (x[a + 480188 >> 1] <= b >>> 0) {
                             break fa;
                            }
                            n = FC(v[h + 24 >> 2], b);
                            f = Vb(v[i >> 2], e);
                            ga: {
                             if (n) {
                              ze(f, Uh(ip(We(Ne(d + 40 | 0, 20, 145), 0), b & 65535)));
                              break ga;
                             }
                             ze(f, Uh(ip(We(Ne(d + 40 | 0, 9, w[wb(v[h >> 2], b) | 0]), 0), b & 65535)));
                            }
                            b = b + 1 | 0;
                            continue;
                           }
                          }
                          b = d + 40 | 0;
                          ze(Vb(v[i >> 2], e), Uh(We(Ne(b, 16, w[h + 43 | 0]), 0)));
                          ze(Vb(v[i >> 2], e), Uh(We(Ne(b, 17, w[h + 42 | 0]), 0)));
                          e = v[k + 4 >> 2];
                          b = v[k >> 2];
                         }
                         c = c + 1 | 0;
                         continue;
                        }
                       }
                       Qc(d + 16 | 0);
                       e = 1;
                       break s;
                      }
                      b = M() | 0;
                      break q;
                     }
                     b = v[h >> 2];
                     v[31601] = 0;
                     b = Q(154, b | 0) | 0;
                     c = v[31601];
                     v[31601] = 0;
                     ha: {
                      ia: {
                       ja: {
                        ka: {
                         la: {
                          ma: {
                           na: {
                            if ((c | 0) == 1) {
                             break na;
                            }
                            v[31601] = 0;
                            c = Q(151, h | 0) | 0;
                            e = v[31601];
                            v[31601] = 0;
                            if ((e | 0) == 1) {
                             break na;
                            }
                            if ((b | 0) != (c | 0)) {
                             break ha;
                            }
                            b = v[h >> 2];
                            v[31601] = 0;
                            b = O(678, b | 0, 8) | 0;
                            c = v[31601];
                            v[31601] = 0;
                            if ((c | 0) == 1) {
                             break na;
                            }
                            if (!b) {
                             break ha;
                            }
                            v[31601] = 0;
                            o = O(673, h | 0, d + 258 | 0) | 0;
                            b = v[31601];
                            v[31601] = 0;
                            if ((b | 0) == 1) {
                             break ia;
                            }
                            v[31601] = 0;
                            n = Q(189, h | 0) | 0;
                            b = v[31601];
                            v[31601] = 0;
                            if ((b | 0) == 1) {
                             break ja;
                            }
                            v[31601] = 0;
                            b = T(196, i | 0, o | 0, n | 0) | 0;
                            c = v[31601];
                            v[31601] = 0;
                            if ((c | 0) == 1) {
                             break ja;
                            }
                            if (!b) {
                             break ha;
                            }
                            f = 0;
                            while (1) {
                             if ((f | 0) == (n | 0)) {
                              break ha;
                             }
                             b = Vb(v[i >> 2], o);
                             af(d + 8 | 0, v[b >> 2], v[v[b + 48 >> 2] + 12 >> 2], f);
                             v[31601] = 0;
                             b = Q(189, h | 0) | 0;
                             c = v[31601];
                             v[31601] = 0;
                             if ((c | 0) == 1) {
                              break ma;
                             }
                             oa: {
                              if (b >>> 0 >= 3) {
                               v[31601] = 0;
                               c = d + 136 | 0;
                               R(185, c | 0, h | 0, b - 2 | 0);
                               b = v[31601];
                               v[31601] = 0;
                               if ((b | 0) == 1) {
                                break ka;
                               }
                               e = gc(d + 40 | 0, c);
                               tb(c);
                               while (1) {
                                b = v[e >> 2];
                                v[31601] = 0;
                                b = T(150, b | 0, v[d + 48 >> 2], 3) | 0;
                                c = v[31601];
                                v[31601] = 0;
                                if ((c | 0) == 1) {
                                 break oa;
                                }
                                if (b) {
                                 v[31601] = 0;
                                 b = d + 136 | 0;
                                 N(198, b | 0, e | 0);
                                 c = v[31601];
                                 v[31601] = 0;
                                 pa: {
                                  qa: {
                                   ra: {
                                    sa: {
                                     if ((c | 0) != 1) {
                                      u[d + 156 >> 1] = x[a + 480188 >> 1] - 1;
                                      z = d, A = w[Ic(b) | 0], u[z + 6 >> 1] = A;
                                      c = Xc(v[d + 8 >> 2], x[Nc(d + 156 | 0, d + 6 | 0) >> 1]);
                                      b = t[d + 136 | 0];
                                      if ((b | 0) >= 0) {
                                       break pa;
                                      }
                                      v[31601] = 0;
                                      b = Q(197, e | 0) | 0;
                                      m = v[31601];
                                      v[31601] = 0;
                                      if ((m | 0) == 1) {
                                       break la;
                                      }
                                      if (w[d + 258 | 0]) {
                                       break ra;
                                      }
                                      if ((b | 0) != 255) {
                                       break sa;
                                      }
                                      b = 254;
                                      break qa;
                                     }
                                     break la;
                                    }
                                    if (b >>> 0 > 128) {
                                     break qa;
                                    }
                                    b = (B(b >>> 4 | 0, 12) + (b & 15) | 0) + 13 | 0;
                                    break qa;
                                   }
                                   b = b >>> 0 < 85 ? b + 36 | 0 : b;
                                  }
                                  t[c | 0] = b;
                                  b = w[d + 136 | 0];
                                 }
                                 if (b & 64) {
                                  v[31601] = 0;
                                  b = Q(197, e | 0) | 0;
                                  m = v[31601];
                                  v[31601] = 0;
                                  if ((m | 0) == 1) {
                                   break la;
                                  }
                                  t[c + 1 | 0] = b + 1;
                                  b = w[d + 136 | 0];
                                 }
                                 if (b & 32) {
                                  v[31601] = 0;
                                  b = Q(197, e | 0) | 0;
                                  m = v[31601];
                                  v[31601] = 0;
                                  if ((m | 0) == 1) {
                                   break la;
                                  }
                                  t[d + 156 | 0] = b;
                                  t[c + 2 | 0] = 1;
                                  t[d + 6 | 0] = 127;
                                  z = c, A = w[Pb(d + 156 | 0, d + 6 | 0) | 0] + 1 >>> 1 | 0, t[z + 4 | 0] = A;
                                  b = w[d + 136 | 0];
                                 }
                                 if (!(b & 16)) {
                                  continue;
                                 }
                                 v[31601] = 0;
                                 b = d + 156 | 0;
                                 N(198, b | 0, e | 0);
                                 m = v[31601];
                                 v[31601] = 0;
                                 ta: {
                                  ua: {
                                   va: {
                                    wa: {
                                     xa: {
                                      ya: {
                                       za: {
                                        Aa: {
                                         Ba: {
                                          Ca: {
                                           Da: {
                                            Ea: {
                                             Fa: {
                                              Ga: {
                                               Ha: {
                                                Ia: {
                                                 Ja: {
                                                  Ka: {
                                                   La: {
                                                    Ma: {
                                                     Na: {
                                                      Oa: {
                                                       Pa: {
                                                        Qa: {
                                                         Ra: {
                                                          Sa: {
                                                           Ta: {
                                                            Ua: {
                                                             Va: {
                                                              Wa: {
                                                               Xa: {
                                                                Ya: {
                                                                 Za: {
                                                                  _a: {
                                                                   if ((m | 0) != 1) {
                                                                    b = w[Ic(b) | 0];
                                                                    t[c + 5 | 0] = b;
                                                                    switch (w[d + 156 | 0] - 1 | 0) {
                                                                    case 72:
                                                                     break ua;

                                                                    case 71:
                                                                     break va;

                                                                    case 70:
                                                                     break wa;

                                                                    case 61:
                                                                     break xa;

                                                                    case 60:
                                                                     break ya;

                                                                    case 53:
                                                                     break za;

                                                                    case 52:
                                                                     break Aa;

                                                                    case 51:
                                                                     break Ba;

                                                                    case 50:
                                                                     break Da;

                                                                    case 43:
                                                                     break Ea;

                                                                    case 42:
                                                                     break Fa;

                                                                    case 41:
                                                                     break Ga;

                                                                    case 40:
                                                                     break Ha;

                                                                    case 31:
                                                                     break Ia;

                                                                    case 30:
                                                                     break Ja;

                                                                    case 23:
                                                                     break Ka;

                                                                    case 22:
                                                                     break La;

                                                                    case 21:
                                                                     break Ma;

                                                                    case 20:
                                                                     break Na;

                                                                    case 18:
                                                                     break Oa;

                                                                    case 17:
                                                                     break Pa;

                                                                    case 15:
                                                                     break Qa;

                                                                    case 16:
                                                                     break Ra;

                                                                    case 14:
                                                                     break Sa;

                                                                    case 13:
                                                                     break Ta;

                                                                    case 12:
                                                                     break Ua;

                                                                    case 11:
                                                                     break Va;

                                                                    case 10:
                                                                     break Wa;

                                                                    case 3:
                                                                     break Xa;

                                                                    case 2:
                                                                     break Ya;

                                                                    case 1:
                                                                     break Za;

                                                                    case 0:
                                                                     break _a;

                                                                    default:
                                                                     break ta;
                                                                    }
                                                                   }
                                                                   break la;
                                                                  }
                                                                  t[c + 3 | 0] = 11;
                                                                  if (w[d + 258 | 0]) {
                                                                   t[c + 5 | 0] = b << 4 | 15;
                                                                   continue;
                                                                  }
                                                                  t[c + 5 | 0] = b << 3 | 15;
                                                                  continue;
                                                                 }
                                                                 t[c + 3 | 0] = 11;
                                                                 if (w[d + 258 | 0]) {
                                                                  t[c + 5 | 0] = b << 4;
                                                                  continue;
                                                                 }
                                                                 t[c + 5 | 0] = b << 3 & 240;
                                                                 continue;
                                                                }
                                                                t[c + 3 | 0] = 11;
                                                                if (w[d + 258 | 0]) {
                                                                 t[c + 5 | 0] = b | 240;
                                                                 continue;
                                                                }
                                                                t[c + 5 | 0] = b >>> 1 | 240;
                                                                continue;
                                                               }
                                                               t[c + 3 | 0] = 11;
                                                               if (w[d + 258 | 0]) {
                                                                t[c + 5 | 0] = b & 15;
                                                                continue;
                                                               }
                                                               if (b >>> 0 <= 1) {
                                                                t[c + 5 | 0] = b | 240;
                                                                continue;
                                                               }
                                                               t[c + 5 | 0] = b >>> 1 & 15;
                                                               continue;
                                                              }
                                                              t[c + 3 | 0] = 2;
                                                              z = c, A = Bv(b, w[d + 258 | 0]) | 240, t[z + 5 | 0] = A;
                                                              continue;
                                                             }
                                                             t[c + 3 | 0] = 2;
                                                             z = c, A = Bv(b, w[d + 258 | 0]), t[z + 5 | 0] = A;
                                                             continue;
                                                            }
                                                            t[c + 3 | 0] = 3;
                                                            z = c, A = Bv(b, w[d + 258 | 0]) | 240, t[z + 5 | 0] = A;
                                                            continue;
                                                           }
                                                           t[c + 3 | 0] = 3;
                                                           z = c, A = Bv(b, w[d + 258 | 0]), t[z + 5 | 0] = A;
                                                           continue;
                                                          }
                                                          t[c + 3 | 0] = 4;
                                                          if (w[d + 258 | 0]) {
                                                           continue;
                                                          }
                                                          t[c + 5 | 0] = (b & 252) >>> 2;
                                                          continue;
                                                         }
                                                         t[c + 3 | 0] = 20;
                                                         t[c + 5 | 0] = b & 1 | 16;
                                                         continue;
                                                        }
                                                        t[c + 3 | 0] = 6;
                                                        t[c + 5 | 0] = b & 240;
                                                        continue;
                                                       }
                                                       t[c + 3 | 0] = 6;
                                                       t[c + 5 | 0] = (b & 240) >>> 4;
                                                       continue;
                                                      }
                                                      t[c + 3 | 0] = 20;
                                                      continue;
                                                     }
                                                     t[c + 3 | 0] = 5;
                                                     continue;
                                                    }
                                                    t[c + 3 | 0] = 20;
                                                    t[c + 5 | 0] = b & 15 | 48;
                                                    continue;
                                                   }
                                                   t[c + 3 | 0] = 7;
                                                   t[c + 5 | 0] = b | 240;
                                                   continue;
                                                  }
                                                  t[c + 3 | 0] = 7;
                                                  continue;
                                                 }
                                                 t[c + 3 | 0] = 8;
                                                 continue;
                                                }
                                                t[c + 3 | 0] = 20;
                                                t[c + 5 | 0] = b & 15 | 64;
                                                continue;
                                               }
                                               t[c + 3 | 0] = 10;
                                               v[31601] = 0;
                                               b = Q(197, e | 0) | 0;
                                               m = v[31601];
                                               v[31601] = 0;
                                               if ((m | 0) != 1) {
                                                break Ca;
                                               }
                                               break la;
                                              }
                                              t[c + 3 | 0] = 15;
                                              continue;
                                             }
                                             t[c + 3 | 0] = 20;
                                             t[c + 5 | 0] = b & 15 | 192;
                                             continue;
                                            }
                                            t[c + 3 | 0] = 20;
                                            t[c + 5 | 0] = b & 15 | 208;
                                            continue;
                                           }
                                           t[c + 3 | 0] = 12;
                                           b = (b & 254) >>> 1 | 0;
                                          }
                                          t[c + 5 | 0] = b;
                                          v[31601] = 0;
                                          O(183, e | 0, 1) | 0;
                                          b = v[31601];
                                          v[31601] = 0;
                                          if ((b | 0) != 1) {
                                           continue;
                                          }
                                          break la;
                                         }
                                         t[c + 5 | 0] = 0;
                                         t[c + 3 | 0] = 14;
                                         continue;
                                        }
                                        t[c + 3 | 0] = 20;
                                        t[c + 5 | 0] = b & 15 | 176;
                                        continue;
                                       }
                                       t[c + 3 | 0] = 20;
                                       t[c + 5 | 0] = b & 15 | 224;
                                       continue;
                                      }
                                      t[c + 3 | 0] = 16;
                                      continue;
                                     }
                                     t[c + 3 | 0] = 17;
                                     continue;
                                    }
                                    t[c + 3 | 0] = 1;
                                    continue;
                                   }
                                   t[c + 3 | 0] = 20;
                                   t[c + 5 | 0] = b & 15 | 32;
                                   continue;
                                  }
                                  t[c + 3 | 0] = 20;
                                  t[c + 5 | 0] = b & 15 | 128;
                                  continue;
                                 }
                                 t[c + 3 | 0] = 0;
                                 continue;
                                }
                                break;
                               }
                               tb(e);
                              }
                              f = f + 1 | 0;
                              continue;
                             }
                             break;
                            }
                            break la;
                           }
                           b = M() | 0;
                           break q;
                          }
                          b = M() | 0;
                          break q;
                         }
                         b = M() | 0;
                         tb(e);
                         break q;
                        }
                        b = M() | 0;
                        break q;
                       }
                       b = M() | 0;
                       break q;
                      }
                      b = M() | 0;
                      break q;
                     }
                     Pf(d + 240 | 0);
                     continue;
                    }
                   }
                   Qc(d + 244 | 0);
                   gX(k);
                   tb(d + 272 | 0);
                   break b;
                  }
                  b = M() | 0;
                 }
                 Qc(d + 16 | 0);
                 break j;
                }
                b = M() | 0;
                break j;
               }
               b = M() | 0;
               break j;
              }
              b = M() | 0;
              break j;
             }
             b = M() | 0;
            }
            ar(h);
           }
           tb(f);
          }
          Qc(d + 244 | 0);
          break h;
         }
         b = M() | 0;
        }
        gX(k);
        break f;
       }
       b = M() | 0;
      }
      tb(d + 272 | 0);
      break c;
     }
     b = M() | 0;
     break c;
    }
    b = M() | 0;
   }
   je(q);
   tb(r);
   P(b | 0);
   p();
  }
  je(q);
  tb(r);
 }
 eb = d + 336 | 0;
 return e | 0;
}

function Esa(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, q = 0, r = 0, s = 0, z = 0, A = 0, C = 0, D = 0, E = 0;
 d = eb - 1120 | 0;
 eb = d;
 xc(b);
 i = eb - 16 | 0;
 eb = i;
 h = d + 884 | 0;
 c_(i + 8 | 0, h);
 g = v[i + 12 >> 2];
 ic(i, v[b >> 2], v[b + 8 >> 2], v[i + 8 >> 2], v[i + 12 >> 2]);
 e = v[i + 4 >> 2];
 if ((e | 0) == (g | 0)) {
  Ub(b, v[i + 12 >> 2]);
 }
 eb = i + 16 | 0;
 e = (e | 0) == (g | 0);
 if (!e) {
  b_(h);
 }
 a: {
  b: {
   c: {
    d: {
     e: {
      f: {
       g: {
        h: {
         i: {
          j: {
           k: {
            l: {
             m: {
              n: {
               o: {
                if (!e) {
                 break o;
                }
                if (!e_(h)) {
                 break o;
                }
                if (!Lb(v[b >> 2], v[b + 8 >> 2], Ac(d_(w[d + 888 | 0] | w[d + 889 | 0] << 8 | (w[d + 890 | 0] << 16 | w[d + 891 | 0] << 24)), gb))) {
                 break o;
                }
                f = 1;
                if ((c | 0) == 64) {
                 break o;
                }
                Cd(a, 16777216);
                dg(a);
                v[a + 480208 >> 2] = v[a + 480208 >> 2] | 16809984;
                g = d + 448 | 0;
                sr(g, 32);
                e = v[d + 460 >> 2];
                f = a + 1074320 | 0;
                v[f >> 2] = v[d + 456 >> 2];
                v[f + 4 >> 2] = e;
                e = v[d + 452 >> 2];
                v[a + 1074312 >> 2] = v[d + 448 >> 2];
                v[a + 1074316 >> 2] = e;
                Kb(Kb(a + 1074312 | 0, 57, w[d + 887 | 0] > 5), 114, 1);
                e = kp(d + 840 | 0);
                D = e, E = Kd(w[d + 1084 | 0], 1, 31), v[D + 8 >> 2] = E;
                D = e, E = Kd(w[d + 1085 | 0], 1, 12), v[D + 4 >> 2] = E;
                D = e, E = Ab(w[d + 1086 | 0] | w[d + 1087 | 0] << 8), v[D >> 2] = E;
                mE(a + 1298412 | 0, e);
                u[a + 480188 >> 1] = 32;
                e = d + 36 | 0;
                a_(e, 3, d + 1088 | 0);
                Er(g, 1, e);
                yb(a + 1298368 | 0, g);
                sb(g);
                p: {
                 if (w[d + 887 | 0] <= 5) {
                  fg(e, 3924);
                  break p;
                 }
                 f = eb - 16 | 0;
                 eb = f;
                 e = tc(f + 4 | 0, 3993);
                 Uc(d + 36 | 0, e);
                 sb(e);
                 eb = f + 16 | 0;
                }
                v[31601] = 0;
                g = d + 448 | 0;
                f = d + 36 | 0;
                R(370, g | 0, f | 0, w[d + 887 | 0]);
                e = v[31601];
                v[31601] = 0;
                q: {
                 r: {
                  s: {
                   t: {
                    u: {
                     v: {
                      w: {
                       x: {
                        y: {
                         z: {
                          A: {
                           B: {
                            C: {
                             D: {
                              E: {
                               F: {
                                if ((e | 0) != 1) {
                                 yb(a + 1298344 | 0, g);
                                 sb(g);
                                 Db(f);
                                 e = tc(g, 15114);
                                 yb(a + 1298356 | 0, e);
                                 sb(e);
                                 D = a, E = v[Ec(g, 26) >> 2], v[D + 1298404 >> 2] = E;
                                 Ue(f, 3, d + 892 | 0);
                                 Bc(g, f);
                                 yb(a + 1298308 | 0, g);
                                 sb(g);
                                 v[a + 480228 >> 2] = 256;
                                 v[a + 480200 >> 2] = 384 / (x[a + 480188 >> 1] + 3 >>> 0);
                                 G: {
                                  if (w[d + 887 | 0] > 5) {
                                   break G;
                                  }
                                  D = d, E = Ab(w[d + 1112 | 0] | w[d + 1113 | 0] << 8), u[D + 448 >> 1] = E;
                                  u[d + 36 >> 1] = 1;
                                  D = a, E = x[qe(g, f) >> 1], v[D + 480196 >> 2] = E;
                                  D = d, E = Ab(w[d + 1114 | 0] | w[d + 1115 | 0] << 8), u[D + 448 >> 1] = E;
                                  u[d + 36 >> 1] = 1;
                                  D = a, E = B(x[qe(g, f) >> 1], 1e4), v[D + 480204 >> 2] = E;
                                  D = d, E = Ac(((Ab(w[d + 1116 | 0] | w[d + 1117 | 0] << 8) << 8) + 2047 >>> 0) / 4095 | 0, 0), 
                                  v[D + 448 >> 2] = E;
                                  v[d + 36 >> 2] = 256;
                                  D = a, E = v[Gb(g, f) >> 2], v[D + 480200 >> 2] = E;
                                  D = d, E = Ab(w[d + 1118 | 0] | w[d + 1119 | 0] << 8), u[D + 448 >> 1] = E;
                                  Gf(g, 127);
                                  h = a + 480280 | 0;
                                  f = 0;
                                  g = x[d + 448 >> 1];
                                  while (1) {
                                   if ((f | 0) == (g | 0)) {
                                    break G;
                                   }
                                   D = d, E = Ac(((Mk(b) << 8) + 2047 >>> 0) / 4095 | 0, 0), u[D + 36 >> 1] = E;
                                   u[d + 344 >> 1] = 256;
                                   D = h + (f << 5) | 0, E = x[Nc(d + 36 | 0, d + 344 | 0) >> 1], u[D + 4 >> 1] = E;
                                   f = f + 1 | 0;
                                   continue;
                                  }
                                 }
                                 cd(b, _b(w[d + 888 | 0] | w[d + 889 | 0] << 8 | (w[d + 890 | 0] << 16 | w[d + 891 | 0] << 24)));
                                 C = Ge(d + 820 | 0, b);
                                 v[31601] = 0;
                                 f = d + 808 | 0;
                                 N(375, f | 0, C | 0);
                                 b = v[31601];
                                 v[31601] = 0;
                                 H: {
                                  I: {
                                   J: {
                                    K: {
                                     L: {
                                      if ((b | 0) != 1) {
                                       v[31601] = 0;
                                       g = d + 448 | 0;
                                       R(376, g | 0, f | 0, 1346458707);
                                       b = v[31601];
                                       v[31601] = 0;
                                       if ((b | 0) == 1) {
                                        break H;
                                       }
                                       v[31601] = 0;
                                       e = T(150, v[d + 448 >> 2], v[d + 456 >> 2], 2) | 0;
                                       b = v[31601];
                                       v[31601] = 0;
                                       if ((b | 0) == 1) {
                                        break K;
                                       }
                                       if (!e) {
                                        break I;
                                       }
                                       v[31601] = 0;
                                       e = Q(273, g | 0) | 0;
                                       b = v[31601];
                                       v[31601] = 0;
                                       if ((b | 0) == 1) {
                                        break K;
                                       }
                                       if ((e - 1 & 65535) >>> 0 > 126) {
                                        break I;
                                       }
                                       u[a + 480188 >> 1] = e;
                                       tb(g);
                                       v[31601] = 0;
                                       R(376, g | 0, f | 0, 1397706311);
                                       b = v[31601];
                                       v[31601] = 0;
                                       if ((b | 0) != 1) {
                                        break L;
                                       }
                                       a = M() | 0;
                                       break c;
                                      }
                                      a = M() | 0;
                                      break b;
                                     }
                                     v[31601] = 0;
                                     e = T(150, v[d + 448 >> 2], v[d + 456 >> 2], 2) | 0;
                                     b = v[31601];
                                     v[31601] = 0;
                                     if ((b | 0) == 1) {
                                      break E;
                                     }
                                     if (!e) {
                                      break I;
                                     }
                                     v[31601] = 0;
                                     h = d + 448 | 0;
                                     e = Q(273, h | 0) | 0;
                                     b = v[31601];
                                     v[31601] = 0;
                                     M: {
                                      if ((b | 0) == 1) {
                                       break M;
                                      }
                                      u[d + 36 >> 1] = e;
                                      g = w[a + 484376 | 0];
                                      f = v[a + 484360 >> 2];
                                      v[31601] = 0;
                                      e = Q(273, h | 0) | 0;
                                      b = v[31601];
                                      v[31601] = 0;
                                      if ((b | 0) == 1) {
                                       break M;
                                      }
                                      $e(Wb(f, g), e);
                                      v[31601] = 0;
                                      e = Q(202, h | 0) | 0;
                                      b = v[31601];
                                      v[31601] = 0;
                                      if ((b | 0) == 1) {
                                       break M;
                                      }
                                      Gf(d + 36 | 0, $l(e >>> 1 | 0));
                                      e = w[a + 484376 | 0];
                                      b = v[a + 484360 >> 2];
                                      v[31601] = 0;
                                      R(276, Wb(b, e) | 0, h | 0, x[d + 36 >> 1]);
                                      b = v[31601];
                                      v[31601] = 0;
                                      if ((b | 0) != 1) {
                                       break J;
                                      }
                                     }
                                     break E;
                                    }
                                    a = M() | 0;
                                    tb(d + 448 | 0);
                                    break c;
                                   }
                                   b = d + 448 | 0;
                                   tb(b);
                                   v[31601] = 0;
                                   R(376, b | 0, d + 808 | 0, 1480806221);
                                   b = v[31601];
                                   v[31601] = 0;
                                   if ((b | 0) == 1) {
                                    break F;
                                   }
                                   v[31601] = 0;
                                   e = T(150, v[d + 448 >> 2], v[d + 456 >> 2], 3) | 0;
                                   b = v[31601];
                                   v[31601] = 0;
                                   if ((b | 0) != 1) {
                                    if (e) {
                                     break D;
                                    }
                                    e = d + 924 | 0;
                                    f = 160;
                                    while (1) {
                                     N: {
                                      b = f;
                                      if (!b) {
                                       b = 0;
                                       break N;
                                      }
                                      f = b - 1 | 0;
                                      if (w[e + f | 0] == 32) {
                                       continue;
                                      }
                                     }
                                     break;
                                    }
                                    v[31601] = 0;
                                    U(343, a + 1298332 | 0, e | 0, b | 0, 4);
                                    b = v[31601];
                                    v[31601] = 0;
                                    if ((b | 0) != 1) {
                                     break C;
                                    }
                                    break B;
                                   }
                                   break B;
                                  }
                                  tb(d + 448 | 0);
                                  f = 0;
                                  break q;
                                 }
                                 a = M() | 0;
                                 break c;
                                }
                                a = M() | 0;
                                Db(d + 36 | 0);
                                break a;
                               }
                               a = M() | 0;
                               break c;
                              }
                              a = M() | 0;
                              tb(d + 448 | 0);
                              break c;
                             }
                             v[31601] = 0;
                             f = d + 448 | 0;
                             e = Q(273, f | 0) | 0;
                             b = v[31601];
                             v[31601] = 0;
                             if ((b | 0) != 1) {
                              v[31601] = 0;
                              U(336, a + 1298332 | 0, f | 0, e | 0, 4);
                              b = v[31601];
                              v[31601] = 0;
                              if ((b | 0) != 1) {
                               break C;
                              }
                             }
                             break B;
                            }
                            f = d + 448 | 0;
                            tb(f);
                            v[31601] = 0;
                            R(376, f | 0, d + 808 | 0, 1413697073);
                            b = v[31601];
                            v[31601] = 0;
                            if ((b | 0) == 1) {
                             break A;
                            }
                            v[31601] = 0;
                            e = Q(197, f | 0) | 0;
                            b = v[31601];
                            v[31601] = 0;
                            if ((b | 0) == 1) {
                             break y;
                            }
                            if (e) {
                             break z;
                            }
                            v[31601] = 0;
                            e = O(149, f | 0, 2648) | 0;
                            b = v[31601];
                            v[31601] = 0;
                            if ((b | 0) == 1) {
                             break y;
                            }
                            if (!e) {
                             break z;
                            }
                            b = 0;
                            v[31601] = 0;
                            g = Q(281, f | 0) | 0;
                            e = v[31601];
                            v[31601] = 0;
                            if ((e | 0) == 1) {
                             break y;
                            }
                            f = a + 480280 | 0;
                            while (1) {
                             if ((b | 0) == 32) {
                              break z;
                             }
                             e = f + (b << 5) | 0;
                             v[e >> 2] = v[e >> 2] & -1025 | !(g >>> b & 1) << 10;
                             b = b + 1 | 0;
                             continue;
                            }
                           }
                           a = M() | 0;
                           tb(d + 448 | 0);
                           break c;
                          }
                          a = M() | 0;
                          break c;
                         }
                         k = d + 448 | 0;
                         tb(k);
                         v[31601] = 0;
                         R(376, k | 0, d + 808 | 0, 1413697074);
                         b = v[31601];
                         v[31601] = 0;
                         if ((b | 0) == 1) {
                          break x;
                         }
                         v[31601] = 0;
                         e = T(150, v[d + 448 >> 2], v[d + 456 >> 2], 12) | 0;
                         b = v[31601];
                         v[31601] = 0;
                         if ((b | 0) == 1) {
                          break w;
                         }
                         O: {
                          if (!e) {
                           break O;
                          }
                          v[31601] = 0;
                          f = d + 36 | 0;
                          N(377, f | 0, k | 0);
                          b = v[31601];
                          v[31601] = 0;
                          if ((b | 0) == 1) {
                           break w;
                          }
                          e = _e(f);
                          b = fc(f);
                          i = $Z(f);
                          h = zb(f);
                          g = _Z(f);
                          e = B(Kd(Ab(w[e | 0] | w[e + 1 | 0] << 8), 32, 999), 1e4);
                          b = Aua(Ab(w[b | 0] | w[b + 1 | 0] << 8), 0, 1e4, 0);
                          j = gb;
                          b = b + 32768 | 0;
                          j = b >>> 0 < 32768 ? j + 1 | 0 : j;
                          D = a, E = ((Ac((j & 65535) << 16 | b >>> 16, j >>> 16 | 0) >>> 0) % 1e4 | 0) + e | 0, 
                          v[D + 480204 >> 2] = E;
                          D = a, E = Kd(Ab(w[i | 0] | w[i + 1 | 0] << 8), 1, 255), v[D + 480196 >> 2] = E;
                          b = 16 / (Kd(Ab(w[g | 0] | w[g + 1 | 0] << 8), 1, 16) >>> 0) | 0;
                          v[a + 480216 >> 2] = b;
                          D = a, E = B(Kd(Ab(w[h | 0] | w[h + 1 | 0] << 8), 1, 16), b), v[D + 480220 >> 2] = E;
                          if (!Ab(x[d + 36 >> 1])) {
                           break O;
                          }
                          v[31601] = 0;
                          e = Q(273, k | 0) | 0;
                          b = v[31601];
                          v[31601] = 0;
                          if ((b | 0) == 1) {
                           break w;
                          }
                          v[a + 480208 >> 2] = v[a + 480208 >> 2] & -17 | !e << 4;
                         }
                         f = d + 448 | 0;
                         tb(f);
                         v[31601] = 0;
                         R(376, f | 0, d + 808 | 0, 1414942540);
                         b = v[31601];
                         v[31601] = 0;
                         if ((b | 0) == 1) {
                          break v;
                         }
                         v[31601] = 0;
                         e = T(150, v[d + 448 >> 2], v[d + 456 >> 2], 2) | 0;
                         b = v[31601];
                         v[31601] = 0;
                         if ((b | 0) == 1) {
                          break t;
                         }
                         if (!e) {
                          break u;
                         }
                         v[31601] = 0;
                         e = Q(273, f | 0) | 0;
                         b = v[31601];
                         v[31601] = 0;
                         if ((b | 0) == 1) {
                          break t;
                         }
                         u[d + 36 >> 1] = e;
                         u[d + 344 >> 1] = x[a + 480188 >> 1];
                         h = a + 480280 | 0;
                         g = x[Nc(d + 36 | 0, d + 344 | 0) >> 1];
                         b = 0;
                         while (1) {
                          if ((b | 0) == (g | 0)) {
                           break u;
                          }
                          v[31601] = 0;
                          f = Q(273, d + 448 | 0) | 0;
                          e = v[31601];
                          v[31601] = 0;
                          if ((e | 0) == 1) {
                           break t;
                          }
                          u[d + 36 >> 1] = f;
                          u[d + 344 >> 1] = 4096;
                          D = h + (b << 5) | 0, E = x[Nc(d + 36 | 0, d + 344 | 0) >> 1] >>> 6 & 255, u[D + 6 >> 1] = E;
                          b = b + 1 | 0;
                          continue;
                         }
                        }
                        a = M() | 0;
                        tb(d + 448 | 0);
                        break c;
                       }
                       a = M() | 0;
                       break c;
                      }
                      a = M() | 0;
                      tb(d + 448 | 0);
                      break c;
                     }
                     a = M() | 0;
                     break c;
                    }
                    g = d + 448 | 0;
                    tb(g);
                    v[31601] = 0;
                    f = d + 36 | 0;
                    R(376, f | 0, d + 808 | 0, 1296652368);
                    b = v[31601];
                    v[31601] = 0;
                    if ((b | 0) == 1) {
                     break s;
                    }
                    v[31601] = 0;
                    e = T(150, v[d + 36 >> 2], v[d + 44 >> 2], 56) | 0;
                    b = v[31601];
                    v[31601] = 0;
                    if ((b | 0) == 1) {
                     break d;
                    }
                    if (!e) {
                     break r;
                    }
                    v[31601] = 0;
                    N(378, f | 0, g | 0);
                    b = v[31601];
                    v[31601] = 0;
                    if ((b | 0) == 1) {
                     break d;
                    }
                    if ((Ab(w[d + 482 | 0] | w[d + 483 | 0] << 8) | 0) != 4) {
                     break r;
                    }
                    if ((Ab(w[d + 496 | 0] | w[d + 497 | 0] << 8) | 0) != 257) {
                     break r;
                    }
                    D = d, E = Ab(w[d + 488 | 0] | w[d + 489 | 0] << 8), u[D + 344 >> 1] = E;
                    u[d + 796 >> 1] = 16384;
                    b = x[Nc(d + 344 | 0, d + 796 | 0) >> 1];
                    f = b >>> 24 | 0;
                    b = (b << 8) + 2048 | 0;
                    f = b >>> 0 < 2048 ? f + 1 | 0 : f;
                    D = a, E = Ac((f & 4095) << 20 | b >>> 12, f >>> 12 | 0), v[D + 480200 >> 2] = E;
                    h = a + 480280 | 0;
                    b = 0;
                    while (1) {
                     if (Ab(w[d + 486 | 0] | w[d + 487 | 0] << 8) >>> 0 <= (b & 65535) >>> 0) {
                      break r;
                     }
                     v[31601] = 0;
                     N(379, d + 36 | 0, d + 344 | 0);
                     e = v[31601];
                     v[31601] = 0;
                     if ((e | 0) == 1) {
                      break d;
                     }
                     P: {
                      if (w[d + 344 | 0]) {
                       break P;
                      }
                      f = Ab(w[d + 346 | 0] | w[d + 347 | 0] << 8);
                      if (f >>> 0 >= x[a + 480188 >> 1]) {
                       break P;
                      }
                      g = h + (f << 5) | 0;
                      D = g, E = Ac(((Ab(w[d + 350 | 0] | w[d + 351 | 0] << 8) << 8) + 2047 >>> 0) / 4095 | 0, 0), 
                      u[D + 4 >> 1] = E;
                      e = Ab(w[d + 348 | 0] | w[d + 349 | 0] << 8);
                      f = e >>> 26 | 0;
                      e = (e << 6) + 2048 | 0;
                      f = e >>> 0 < 2048 ? f + 1 | 0 : f;
                      D = g, E = Ac((f & 4095) << 20 | e >>> 12, f >>> 12 | 0) & 255, u[D + 6 >> 1] = E;
                     }
                     b = b + 1 | 0;
                     continue;
                    }
                   }
                   a = M() | 0;
                   tb(d + 448 | 0);
                   break c;
                  }
                  a = M() | 0;
                  break c;
                 }
                 b = d + 36 | 0;
                 tb(b);
                 v[31601] = 0;
                 R(380, b | 0, d + 808 | 0, 1396788530);
                 b = v[31601];
                 v[31601] = 0;
                 if ((b | 0) == 1) {
                  break e;
                 }
                 D = d, E = vb(v[d + 36 >> 2]), v[D + 760 >> 2] = E;
                 j = c & 2;
                 k = a + 946304 | 0;
                 o = a + 484380 | 0;
                 g = d + 450 | 0;
                 f = vb(v[d + 40 >> 2]);
                 Q: {
                  R: {
                   S: {
                    T: {
                     U: {
                      V: {
                       W: {
                        X: {
                         Y: {
                          Z: {
                           while (1) {
                            n = v[d + 760 >> 2];
                            if (!Hb(n, f)) {
                             b = d + 36 | 0;
                             Qc(b);
                             v[31601] = 0;
                             R(380, b | 0, d + 808 | 0, 1396788560);
                             b = v[31601];
                             v[31601] = 0;
                             if ((b | 0) == 1) {
                              break f;
                             }
                             D = d, E = vb(v[d + 36 >> 2]), v[D + 784 >> 2] = E;
                             g = d + 450 | 0;
                             f = vb(v[d + 40 >> 2]);
                             break Q;
                            }
                            v[31601] = 0;
                            e = O(381, n | 0, d + 448 | 0) | 0;
                            b = v[31601];
                            v[31601] = 0;
                            if ((b | 0) == 1) {
                             break S;
                            }
                            _: {
                             $: {
                              if (!e) {
                               break $;
                              }
                              b = Ab(x[d + 448 >> 1]);
                              if ((b - 4e3 & 65535) >>> 0 < 61537) {
                               break $;
                              }
                              if (Ab(x[d + 496 >> 1]) >>> 0 > 1) {
                               break $;
                              }
                              if (Ab(x[d + 478 >> 1]) >>> 0 > 1) {
                               break $;
                              }
                              if (b >>> 0 > x[a + 480190 >> 1]) {
                               u[a + 480190 >> 1] = b;
                              }
                              v[31601] = 0;
                              h = o + B(b, 104) | 0;
                              N(382, d + 448 | 0, h | 0);
                              b = v[31601];
                              v[31601] = 0;
                              aa: {
                               ba: {
                                ca: {
                                 if ((b | 0) == 1) {
                                  break ca;
                                 }
                                 b = d + 796 | 0;
                                 Ui(b, 3, g);
                                 v[31601] = 0;
                                 i = d + 344 | 0;
                                 N(218, i | 0, b | 0);
                                 b = v[31601];
                                 v[31601] = 0;
                                 if ((b | 0) == 1) {
                                  break ba;
                                 }
                                 zc(k + (Ab(x[d + 448 >> 1]) << 5) | 0, i);
                                 sb(i);
                                 if (!j) {
                                  break $;
                                 }
                                 b = x[d + 522 >> 1] | x[d + 524 >> 1] << 16;
                                 v[31601] = 0;
                                 e = O(149, n | 0, _b(b) - 8 | 0) | 0;
                                 b = v[31601];
                                 v[31601] = 0;
                                 if ((b | 0) == 1) {
                                  break ca;
                                 }
                                 if (!e) {
                                  break $;
                                 }
                                 if (Ab(x[d + 478 >> 1])) {
                                  break aa;
                                 }
                                 Yc(i, (Ab(w[d + 480 | 0] | w[d + 481 | 0] << 8) | 0) == 8 ? 8 : 16, (Ab(w[d + 484 | 0] | w[d + 485 | 0] << 8) | 0) == 1 ? 1 : 2, !Ab(w[d + 482 | 0] | w[d + 483 | 0] << 8), 0);
                                 v[31601] = 0;
                                 T(215, i | 0, h | 0, n | 0) | 0;
                                 b = v[31601];
                                 v[31601] = 0;
                                 if ((b | 0) != 1) {
                                  break aa;
                                 }
                                 a = M() | 0;
                                 break R;
                                }
                                a = M() | 0;
                                break R;
                               }
                               a = M() | 0;
                               break R;
                              }
                              l = Eb(d + 344 | 0);
                              b = x[d + 498 >> 1];
                              v[31601] = 0;
                              R(270, n | 0, l | 0, Ab(b) | 0);
                              b = v[31601];
                              v[31601] = 0;
                              if ((b | 0) == 1) {
                               break U;
                              }
                              Ae(h + 43 | 0, l);
                              if ((Ab(x[d + 478 >> 1]) | 0) == 1) {
                               v[31601] = 0;
                               i = d + 784 | 0;
                               N(383, i | 0, 16439);
                               b = v[31601];
                               v[31601] = 0;
                               if ((b | 0) == 1) {
                                break _;
                               }
                               v[31601] = 0;
                               h = d + 772 | 0;
                               R(258, h | 0, 0, l | 0);
                               b = v[31601];
                               v[31601] = 0;
                               if ((b | 0) == 1) {
                                break Z;
                               }
                               v[31601] = 0;
                               e = d + 796 | 0;
                               U(384, e | 0, i | 0, x[d + 448 >> 1], h | 0);
                               b = v[31601];
                               v[31601] = 0;
                               if ((b | 0) == 1) {
                                break Y;
                               }
                               b = v[a + 1298472 >> 2];
                               v[31601] = 0;
                               R(385, b | 0, 2, e | 0);
                               b = v[31601];
                               v[31601] = 0;
                               if ((b | 0) == 1) {
                                break X;
                               }
                               sb(e);
                               sb(h);
                               Db(i);
                              }
                              sb(l);
                             }
                             Pf(d + 760 | 0);
                             continue;
                            }
                            break;
                           }
                           a = M() | 0;
                           break T;
                          }
                          a = M() | 0;
                          break V;
                         }
                         a = M() | 0;
                         break W;
                        }
                        a = M() | 0;
                        sb(d + 796 | 0);
                       }
                       sb(d + 772 | 0);
                      }
                      Db(d + 784 | 0);
                      break T;
                     }
                     a = M() | 0;
                    }
                    sb(l);
                    break R;
                   }
                   a = M() | 0;
                  }
                  Qc(d + 36 | 0);
                  break c;
                 }
                 da: {
                  while (1) {
                   ea: {
                    h = v[d + 784 >> 2];
                    if (!Hb(h, f)) {
                     Qc(d + 36 | 0);
                     v[31601] = 0;
                     R(380, d + 796 | 0, d + 808 | 0, 1447382614);
                     b = v[31601];
                     v[31601] = 0;
                     if ((b | 0) != 1) {
                      break da;
                     }
                     a = M() | 0;
                     break c;
                    }
                    v[31601] = 0;
                    e = O(386, h | 0, d + 448 | 0) | 0;
                    b = v[31601];
                    v[31601] = 0;
                    if ((b | 0) == 1) {
                     break ea;
                    }
                    fa: {
                     ga: {
                      if (!e) {
                       break ga;
                      }
                      b = Ab(x[d + 448 >> 1]);
                      if ((b - 4e3 & 65535) >>> 0 < 61537) {
                       break ga;
                      }
                      if (Ab(x[d + 502 >> 1])) {
                       break ga;
                      }
                      if (b >>> 0 > x[a + 480190 >> 1]) {
                       u[a + 480190 >> 1] = b;
                      }
                      v[31601] = 0;
                      e = o + B(b, 104) | 0;
                      N(387, d + 448 | 0, e | 0);
                      b = v[31601];
                      v[31601] = 0;
                      if ((b | 0) == 1) {
                       break ea;
                      }
                      b = d + 796 | 0;
                      Ui(b, 3, g);
                      v[31601] = 0;
                      i = d + 344 | 0;
                      N(218, i | 0, b | 0);
                      b = v[31601];
                      v[31601] = 0;
                      if ((b | 0) == 1) {
                       break ea;
                      }
                      zc(k + (Ab(x[d + 448 >> 1]) << 5) | 0, i);
                      sb(i);
                      if (!j) {
                       break ga;
                      }
                      b = x[d + 478 >> 1];
                      Yc(i, (Ab(x[d + 482 >> 1]) | 0) == 8 ? 8 : 16, Ab(b) & 1 ? 2 : 1, 1, 0);
                      v[31601] = 0;
                      T(215, i | 0, e | 0, h | 0) | 0;
                      b = v[31601];
                      v[31601] = 0;
                      if ((b | 0) == 1) {
                       break fa;
                      }
                     }
                     Pf(d + 784 | 0);
                     continue;
                    }
                   }
                   break;
                  }
                  a = M() | 0;
                  Qc(d + 36 | 0);
                  break c;
                 }
                 v[31601] = 0;
                 e = d + 808 | 0;
                 R(380, d + 784 | 0, e | 0, 1413828182);
                 b = v[31601];
                 v[31601] = 0;
                 if ((b | 0) == 1) {
                  break h;
                 }
                 v[31601] = 0;
                 R(380, d + 772 | 0, e | 0, 1346719318);
                 b = v[31601];
                 v[31601] = 0;
                 if ((b | 0) == 1) {
                  break j;
                 }
                 v[31601] = 0;
                 R(380, d + 760 | 0, e | 0, 1229869908);
                 b = v[31601];
                 v[31601] = 0;
                 if ((b | 0) == 1) {
                  break l;
                 }
                 D = d, E = vb(v[d + 760 >> 2]), v[D + 12 >> 2] = E;
                 r = d + 394 | 0;
                 s = d + 346 | 0;
                 z = d + 500 | 0;
                 l = d + 450 | 0;
                 n = vb(v[d + 764 >> 2]);
                 while (1) {
                  ha: {
                   ia: {
                    ja: {
                     ka: {
                      q = v[d + 12 >> 2];
                      if (!Hb(q, n)) {
                       Qc(d + 760 | 0);
                       v[31601] = 0;
                       R(380, d + 344 | 0, d + 808 | 0, 1346458692);
                       b = v[31601];
                       v[31601] = 0;
                       if ((b | 0) != 1) {
                        break ka;
                       }
                       a = M() | 0;
                       break k;
                      }
                      v[31601] = 0;
                      e = O(388, q | 0, d + 448 | 0) | 0;
                      b = v[31601];
                      v[31601] = 0;
                      if ((b | 0) == 1) {
                       break n;
                      }
                      if (!e) {
                       break ha;
                      }
                      if (Ab(x[d + 478 >> 1])) {
                       break ha;
                      }
                      b = x[d + 448 >> 1];
                      v[31601] = 0;
                      e = T(251, a | 0, Ab(b) | 0, 0) | 0;
                      b = v[31601];
                      v[31601] = 0;
                      if ((b | 0) == 1) {
                       break n;
                      }
                      if (!e) {
                       break ha;
                      }
                      b = Ab(x[d + 448 >> 1]);
                      if (b >>> 0 > x[a + 480192 >> 1]) {
                       u[a + 480192 >> 1] = b;
                      }
                      b = d + 344 | 0;
                      Ui(b, 3, l);
                      v[31601] = 0;
                      f = d + 36 | 0;
                      N(218, f | 0, b | 0);
                      b = v[31601];
                      v[31601] = 0;
                      if ((b | 0) == 1) {
                       break ja;
                      }
                      zc(e + 492 | 0, f);
                      sb(f);
                      t[e + 33 | 0] = 2;
                      if ((ye(u[d + 482 >> 1]) | 0) > 0) {
                       t[e + 15 | 0] = w[e + 15 | 0] | 1;
                       b = ye(u[d + 482 >> 1]);
                       f = b >>> 24 | 0;
                       b = (b << 8 & -256) + 2047 | 0;
                       j = f & 255;
                       D = e, E = Ac(Cua(b, b >>> 0 < 2047 ? j + 1 | 0 : j, 4095, 0), gb), v[D + 8 >> 2] = E;
                      }
                      i = e + 108 | 0;
                      h = e + 236 | 0;
                      f = 0;
                      while (1) {
                       la: {
                        v[d + 36 >> 2] = 128;
                        v[d + 344 >> 2] = 128;
                        b = f & 255;
                        g = d + 36 | 0;
                        if (b >>> 0 >= y[Gb(g, d + 344 | 0) >> 2]) {
                         v[31601] = 0;
                         N(389, g | 0, e | 0);
                         b = v[31601];
                         v[31601] = 0;
                         if ((b | 0) == 1) {
                          break la;
                         }
                         D = d, E = Si(v[d + 36 >> 2]), v[D + 344 >> 2] = E;
                         h = Of(g);
                         g = x[a + 480190 >> 1];
                         f = x[d + 480 >> 1];
                         while (1) {
                          b = v[d + 344 >> 2];
                          if (Hb(b, h)) {
                           b = x[cp(b) >> 1];
                           if (g >>> 0 > (b - 1 & 65535) >>> 0) {
                            D = o + B(b, 104) | 0, E = Ab(f), u[D + 30 >> 1] = E;
                           }
                           $g(d + 344 | 0);
                           continue;
                          }
                          break;
                         }
                         Yv(d + 36 | 0);
                         bk(e, 127, 1);
                         ak(e, 0, 1);
                         b = Ab(x[d + 498 >> 1]);
                         if (!b) {
                          v[e >> 2] = 0;
                          b = x[d + 484 >> 1];
                          v[31601] = 0;
                          U(390, e | 0, 0, Ab(b) | 0, d + 796 | 0);
                          b = v[31601];
                          v[31601] = 0;
                          if ((b | 0) == 1) {
                           break n;
                          }
                          b = x[d + 488 >> 1];
                          v[31601] = 0;
                          U(390, e | 0, 1, Ab(b) | 0, d + 772 | 0);
                          b = v[31601];
                          v[31601] = 0;
                          if ((b | 0) == 1) {
                           break n;
                          }
                          b = x[d + 486 >> 1];
                          v[31601] = 0;
                          U(390, e | 0, 2, Ab(b) | 0, d + 784 | 0);
                          b = v[31601];
                          v[31601] = 0;
                          if ((b | 0) != 1) {
                           break ha;
                          }
                          break n;
                         }
                         v[31601] = 0;
                         R(391, q | 0, d + 344 | 0, ((b | 0) == 1 ? 98 : 102) | 0);
                         b = v[31601];
                         v[31601] = 0;
                         ma: {
                          na: {
                           oa: {
                            if ((b | 0) != 1) {
                             f = Ab(x[d + 344 >> 1]);
                             j = f & 1;
                             if (!j) {
                              break ia;
                             }
                             b = f & 24;
                             if (b) {
                              break oa;
                             }
                             b = 0;
                             break na;
                            }
                            a = M() | 0;
                            break m;
                           }
                           if ((b | 0) != 8) {
                            break ma;
                           }
                           b = 1;
                          }
                          t[e + 25 | 0] = b;
                         }
                         pa: {
                          qa: {
                           ra: {
                            sa: {
                             if (!(f & 2)) {
                              break sa;
                             }
                             v[31601] = 0;
                             f = T(392, d + 332 | 0, s | 0, 24) | 0;
                             b = v[31601];
                             v[31601] = 0;
                             if ((b | 0) == 1) {
                              break ra;
                             }
                             v[31601] = 0;
                             A = +ha(393, f | 0);
                             b = v[31601];
                             v[31601] = 0;
                             if ((b | 0) == 1) {
                              break qa;
                             }
                             sb(f);
                             if (!(A > 20)) {
                              break sa;
                             }
                             bk(e, KD(v[a + 480208 >> 2], A), 1);
                            }
                            if (Ab(x[d + 344 >> 1]) & 4) {
                             break pa;
                            }
                            break ia;
                           }
                           a = M() | 0;
                           break m;
                          }
                          a = M() | 0;
                          sb(f);
                          break m;
                         }
                         v[31601] = 0;
                         f = T(392, d + 320 | 0, r | 0, 24) | 0;
                         b = v[31601];
                         v[31601] = 0;
                         ta: {
                          if ((b | 0) != 1) {
                           v[31601] = 0;
                           A = +ha(393, f | 0);
                           b = v[31601];
                           v[31601] = 0;
                           if ((b | 0) == 1) {
                            break ta;
                           }
                           sb(f);
                           ak(e, Xl(A * 127 / 24), 1);
                           break ia;
                          }
                          a = M() | 0;
                          break m;
                         }
                         a = M() | 0;
                         sb(f);
                         break m;
                        } else {
                         g = z + (b << 1) | 0;
                         D = $b(h, b), E = w[g | 0], u[D >> 1] = E;
                         b = wb(i, b);
                         D = b, E = gp(t[g + 1 | 0] + w[b | 0] | 0), t[D | 0] = E;
                         f = f + 1 | 0;
                         continue;
                        }
                       }
                       break;
                      }
                      a = M() | 0;
                      break m;
                     }
                     e = v[d + 348 >> 2];
                     b = v[d + 344 >> 2];
                     v[31601] = 0;
                     r = a + 484344 | 0;
                     N(223, r | 0, Rf(b, e) & 65535);
                     b = v[31601];
                     v[31601] = 0;
                     ua: {
                      if ((b | 0) != 1) {
                       v[d + 32 >> 2] = v[a + 480204 >> 2];
                       v[d + 28 >> 2] = v[a + 480196 >> 2];
                       D = d, E = vb(v[d + 344 >> 2]), v[D + 24 >> 2] = E;
                       j = c & 1;
                       k = vb(v[d + 348 >> 2]);
                       while (1) {
                        va: {
                         wa: {
                          xa: {
                           ya: {
                            za: {
                             Aa: {
                              m = v[d + 24 >> 2];
                              if (!Hb(m, k)) {
                               v[31601] = 0;
                               R(376, d + 36 | 0, d + 808 | 0, 1414414669);
                               b = v[31601];
                               v[31601] = 0;
                               if ((b | 0) != 1) {
                                break Aa;
                               }
                               a = M() | 0;
                               break ua;
                              }
                              if (!j) {
                               break va;
                              }
                              c = v[m + 8 >> 2];
                              b = v[m >> 2];
                              v[31601] = 0;
                              c = T(150, b | 0, c | 0, 24) | 0;
                              b = v[31601];
                              v[31601] = 0;
                              if ((b | 0) == 1) {
                               break za;
                              }
                              if (!c) {
                               break va;
                              }
                              v[31601] = 0;
                              s = Q(273, m | 0) | 0;
                              b = v[31601];
                              v[31601] = 0;
                              Ba: {
                               Ca: {
                                Da: {
                                 Ea: {
                                  if ((b | 0) != 1) {
                                   t[d + 464 | 0] = 0;
                                   v[d + 456 >> 2] = 0;
                                   v[d + 460 >> 2] = 0;
                                   v[d + 448 >> 2] = 0;
                                   v[d + 452 >> 2] = 0;
                                   v[31601] = 0;
                                   e = d + 448 | 0;
                                   N(394, m | 0, e | 0);
                                   b = v[31601];
                                   v[31601] = 0;
                                   if ((b | 0) == 1) {
                                    break Ea;
                                   }
                                   v[31601] = 0;
                                   n = Q(273, m | 0) | 0;
                                   b = v[31601];
                                   v[31601] = 0;
                                   if ((b | 0) == 1) {
                                    break Da;
                                   }
                                   v[31601] = 0;
                                   z = Q(273, m | 0) | 0;
                                   b = v[31601];
                                   v[31601] = 0;
                                   if ((b | 0) == 1) {
                                    break Ca;
                                   }
                                   v[31601] = 0;
                                   l = Q(273, m | 0) | 0;
                                   b = v[31601];
                                   v[31601] = 0;
                                   Fa: {
                                    if ((b | 0) == 1) {
                                     break Fa;
                                    }
                                    c = v[m + 8 >> 2];
                                    b = v[m >> 2];
                                    v[31601] = 0;
                                    c = T(150, b | 0, c | 0, B(B(l, z), 5) | 0) | 0;
                                    b = v[31601];
                                    v[31601] = 0;
                                    if ((b | 0) == 1) {
                                     break Fa;
                                    }
                                    if (!(c & n >>> 0 < 2)) {
                                     break va;
                                    }
                                    v[31601] = 0;
                                    c = T(196, r | 0, s | 0, z | 0) | 0;
                                    b = v[31601];
                                    v[31601] = 0;
                                    if ((b | 0) == 1) {
                                     break Fa;
                                    }
                                    if (!c) {
                                     break va;
                                    }
                                    b = v[r >> 2];
                                    v[31601] = 0;
                                    N(395, Vb(b, s) | 0, e | 0);
                                    b = v[31601];
                                    v[31601] = 0;
                                    if ((b | 0) != 1) {
                                     break Ba;
                                    }
                                   }
                                   a = M() | 0;
                                   break ua;
                                  }
                                  a = M() | 0;
                                  break ua;
                                 }
                                 a = M() | 0;
                                 break ua;
                                }
                                a = M() | 0;
                                break ua;
                               }
                               a = M() | 0;
                               break ua;
                              }
                              t[d + 12 | 0] = 0;
                              b = de(d + 36 | 0, 0, d + 12 | 0);
                              v[31601] = 0;
                              o = T(371, d + 760 | 0, l | 0, b | 0) | 0;
                              b = v[31601];
                              v[31601] = 0;
                              if ((b | 0) == 1) {
                               break wa;
                              }
                              q = 0;
                              Ga: while (1) {
                               if ((q | 0) == (z | 0)) {
                                nd(o);
                                break va;
                               }
                               b = Vb(v[r >> 2], s);
                               af(d + 36 | 0, v[b >> 2], v[v[b + 48 >> 2] + 12 >> 2], q);
                               b = 0;
                               while (1) {
                                if ((b | 0) == (l | 0)) {
                                 q = q + 1 | 0;
                                 continue Ga;
                                }
                                f = Mg(d + 12 | 0);
                                if (x[a + 480188 >> 1] > b >>> 0) {
                                 f = Xc(v[d + 36 >> 2], b);
                                }
                                v[31601] = 0;
                                N(396, m | 0, d | 0);
                                c = v[31601];
                                v[31601] = 0;
                                Ha: {
                                 if ((c | 0) == 1) {
                                  break Ha;
                                 }
                                 c = w[d | 0];
                                 if ((c - 1 & 255) >>> 0 <= 119) {
                                  c = c + 1 | 0;
                                  t[f | 0] = c;
                                  D = $b(v[o >> 2], b), E = c, t[D | 0] = E;
                                 }
                                 c = w[d + 1 | 0];
                                 if (c) {
                                  t[f + 1 | 0] = c;
                                  D = $b(v[o >> 2], b), E = c, t[D + 1 | 0] = E;
                                 }
                                 c = w[d + 4 | 0];
                                 if (c) {
                                  t[f + 2 | 0] = 1;
                                  t[f + 4 | 0] = n ? c - 16 | 0 : c >>> 2 | 0;
                                 }
                                 i = w[d + 887 | 0];
                                 h = w[d + 3 | 0];
                                 g = w[d + 2 | 0];
                                 c = $b(v[o >> 2], b);
                                 e = w[c + 1 | 0];
                                 c = w[c | 0];
                                 v[31601] = 0;
                                 xa(373, a | 0, f | 0, g | 0, h | 0, i | 0, c | 0, e | 0, d + 32 | 0, d + 28 | 0);
                                 c = v[31601];
                                 v[31601] = 0;
                                 if ((c | 0) == 1) {
                                  break Ha;
                                 }
                                 b = b + 1 | 0;
                                 continue;
                                }
                                break;
                               }
                               break;
                              }
                              a = M() | 0;
                              nd(o);
                              break ua;
                             }
                             v[31601] = 0;
                             c = T(150, v[d + 36 >> 2], v[d + 44 >> 2], 38) | 0;
                             b = v[31601];
                             v[31601] = 0;
                             if ((b | 0) != 1) {
                              if (!c) {
                               break xa;
                              }
                              v[31601] = 0;
                              h = Q(273, d + 36 | 0) | 0;
                              b = v[31601];
                              v[31601] = 0;
                              if ((b | 0) == 1) {
                               break ya;
                              }
                              g = a + 480280 | 0;
                              f = d + 452 | 0;
                              b = 0;
                              Ia: {
                               while (1) {
                                if (h >>> 0 <= (b & 65535) >>> 0) {
                                 break xa;
                                }
                                v[31601] = 0;
                                e = T(150, v[d + 36 >> 2], v[d + 44 >> 2], 36) | 0;
                                c = v[31601];
                                v[31601] = 0;
                                Ja: {
                                 if ((c | 0) != 1) {
                                  if (e) {
                                   break Ja;
                                  }
                                  break xa;
                                 }
                                 break ya;
                                }
                                v[31601] = 0;
                                N(397, d + 36 | 0, d + 448 | 0);
                                c = v[31601];
                                v[31601] = 0;
                                if ((c | 0) != 1) {
                                 Ka: {
                                  if (Ab(x[d + 448 >> 1])) {
                                   break Ka;
                                  }
                                  if (Ab(x[d + 450 >> 1]) >>> 0 >= x[a + 480188 >> 1]) {
                                   break Ka;
                                  }
                                  Ue(d, 3, f);
                                  v[31601] = 0;
                                  e = d + 12 | 0;
                                  N(218, e | 0, d | 0);
                                  c = v[31601];
                                  v[31601] = 0;
                                  if ((c | 0) == 1) {
                                   break Ia;
                                  }
                                  em((g + (Ab(x[d + 450 >> 1]) << 5) | 0) + 9 | 0, e);
                                  sb(e);
                                 }
                                 b = b + 1 | 0;
                                 continue;
                                }
                                break;
                               }
                               break ya;
                              }
                              break ya;
                             }
                             break ya;
                            }
                            a = M() | 0;
                            break ua;
                           }
                           a = M() | 0;
                           tb(d + 36 | 0);
                           break ua;
                          }
                          tb(d + 36 | 0);
                          Qc(d + 344 | 0);
                          Qc(d + 772 | 0);
                          Qc(d + 784 | 0);
                          Qc(d + 796 | 0);
                          f = 1;
                          break q;
                         }
                         a = M() | 0;
                         break ua;
                        }
                        Pf(d + 24 | 0);
                        continue;
                       }
                      }
                      a = M() | 0;
                     }
                     Qc(d + 344 | 0);
                     break k;
                    }
                    a = M() | 0;
                    break m;
                   }
                   b = 0;
                   while (1) {
                    if (w[d + 445 | 0] <= b >>> 0) {
                     break ha;
                    }
                    v[31601] = 0;
                    g = d + 36 | 0;
                    N(398, q | 0, g | 0);
                    f = v[31601];
                    v[31601] = 0;
                    La: {
                     Ma: {
                      if ((f | 0) != 1) {
                       t[d | 0] = 0;
                       t[d + 1 | 0] = 2;
                       t[d + 2 | 0] = 1;
                       t[d + 3 | 0] = 2;
                       D = d, E = (Ab(x[d + 484 >> 1]) | 0) != 0, t[D + 32 | 0] = E;
                       D = d, E = (Ab(x[d + 486 >> 1]) | 0) != 0, t[D + 33 | 0] = E;
                       D = d, E = (Ab(x[d + 488 >> 1]) | 0) != 0, t[D + 34 | 0] = E;
                       D = d, E = j & (Ab(x[d + 490 >> 1]) | 0) != 0, t[D + 35 | 0] = E;
                       if (!w[(d + 32 | 0) + b | 0] | b >>> 0 > 3) {
                        break La;
                       }
                       h = (b | 0) != 3;
                       if (!h & (t[e + 100 | 0] & 1)) {
                        break La;
                       }
                       v[31601] = 0;
                       f = g;
                       g = w[b + d | 0];
                       R(399, f | 0, e | 0, g | 0);
                       f = v[31601];
                       v[31601] = 0;
                       if ((f | 0) == 1) {
                        break Ma;
                       }
                       if (!h) {
                        t[e + 100 | 0] = w[e + 100 | 0] | 16;
                       }
                       Na: {
                        switch (g | 0) {
                        case 0:
                         if (Ab(w[d + 48 | 0] | w[d + 49 | 0] << 8) & 1) {
                          f = Ab(w[d + 46 | 0] | w[d + 47 | 0] << 8) & 32767;
                         } else {
                          f = 0;
                         }
                         v[e >> 2] = f;
                         break La;

                        case 2:
                         break Na;

                        default:
                         break La;
                        }
                       }
                       if (!(Ab(w[d + 48 | 0] | w[d + 49 | 0] << 8) & 2)) {
                        break La;
                       }
                       D = d, E = Ab(w[d + 42 | 0] | w[d + 43 | 0] << 8), u[D + 28 >> 1] = E;
                       u[d + 24 >> 1] = 1;
                       k = x[qe(d + 28 | 0, d + 24 | 0) >> 1];
                       i = ri(Ac(((Ab(w[d + 38 | 0] | w[d + 39 | 0] << 8) << 6 | 48) >>> 0) / 100 | 0, 0));
                       D = d, E = Ab(w[d + 40 | 0] | w[d + 41 | 0] << 8), u[D + 28 >> 1] = E;
                       u[d + 24 >> 1] = 1;
                       h = Dh(256 / x[qe(d + 28 | 0, d + 24 | 0) >> 1] | 0);
                       g = x[d + 448 >> 1];
                       f = w[d + 44 | 0] | w[d + 45 | 0] << 8;
                       v[31601] = 0;
                       g = Ab(g);
                       f = Ab(f);
                       ia(400, a | 0, g | 0, w[(f >>> 0 < 6 ? f : 0) + 24960 | 0], 255 / (k >>> 0) | 0, i | 0, h | 0);
                       f = v[31601];
                       v[31601] = 0;
                       if ((f | 0) != 1) {
                        break La;
                       }
                       a = M() | 0;
                       break m;
                      }
                      a = M() | 0;
                      break m;
                     }
                     a = M() | 0;
                     break m;
                    }
                    b = b + 1 | 0;
                    continue;
                   }
                  }
                  Pf(d + 12 | 0);
                  continue;
                 }
                }
                je(d + 808 | 0);
                tb(C);
               }
               eb = d + 1120 | 0;
               return f | 0;
              }
              a = M() | 0;
             }
             Qc(d + 760 | 0);
             break k;
            }
            a = M() | 0;
           }
           Qc(d + 772 | 0);
           break i;
          }
          a = M() | 0;
         }
         Qc(d + 784 | 0);
         break g;
        }
        a = M() | 0;
       }
       Qc(d + 796 | 0);
       break c;
      }
      a = M() | 0;
      break c;
     }
     a = M() | 0;
     break c;
    }
    a = M() | 0;
    tb(d + 36 | 0);
   }
   je(d + 808 | 0);
  }
  tb(C);
 }
 P(a | 0);
 p();
}

function hua(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, q = 0, r = 0, s = 0, y = 0, z = 0, A = 0, C = 0, D = 0;
 d = eb - 416 | 0;
 eb = d;
 xc(b);
 a: {
  b: {
   c: {
    d: {
     e: {
      f: {
       g: {
        h: {
         i: {
          j: {
           k: {
            l: {
             m: {
              n: {
               o: {
                p: {
                 q: {
                  r: {
                   e = d + 408 | 0;
                   s: {
                    if (!ui(b, e)) {
                     break s;
                    }
                    if (!g0(e)) {
                     break s;
                    }
                    o = 1;
                    if ((c | 0) == 64) {
                     break s;
                    }
                    q = Ge(d + 388 | 0, b);
                    v[31601] = 0;
                    e = d + 376 | 0;
                    N(263, e | 0, q | 0);
                    b = v[31601];
                    v[31601] = 0;
                    t: {
                     u: {
                      v: {
                       w: {
                        x: {
                         y: {
                          z: {
                           A: {
                            B: {
                             C: {
                              D: {
                               E: {
                                F: {
                                 G: {
                                  H: {
                                   I: {
                                    J: {
                                     K: {
                                      L: {
                                       M: {
                                        if ((b | 0) != 1) {
                                         v[31601] = 0;
                                         b = d + 208 | 0;
                                         R(264, b | 0, e | 0, 1229866575);
                                         e = v[31601];
                                         v[31601] = 0;
                                         if ((e | 0) == 1) {
                                          break K;
                                         }
                                         v[31601] = 0;
                                         o = O(265, b | 0, d + 366 | 0) | 0;
                                         e = v[31601];
                                         v[31601] = 0;
                                         if ((e | 0) == 1) {
                                          break M;
                                         }
                                         tb(b);
                                         if (!o) {
                                          break t;
                                         }
                                         v[31601] = 0;
                                         N(246, a | 0, 524288);
                                         e = v[31601];
                                         v[31601] = 0;
                                         N: {
                                          if ((e | 0) == 1) {
                                           break N;
                                          }
                                          dg(a);
                                          v[a + 480208 >> 2] = 12;
                                          C = a, D = Kd(Ab(x[d + 374 >> 1]), 1, 127), u[C + 480188 >> 1] = D;
                                          C = d, D = Ab(x[d + 366 >> 1]), u[C + 208 >> 1] = D;
                                          u[d + 320 >> 1] = 255;
                                          e = d + 320 | 0;
                                          C = a, D = x[Nc(b, e) >> 1], u[C + 480192 >> 1] = D;
                                          C = d, D = Ab(x[d + 368 >> 1]), u[C + 208 >> 1] = D;
                                          u[d + 320 >> 1] = 3999;
                                          C = a, D = x[Nc(b, e) >> 1], u[C + 480190 >> 1] = D;
                                          v[31601] = 0;
                                          b = T(266, a + 1074312 | 0, 6, 1) | 0;
                                          e = v[31601];
                                          v[31601] = 0;
                                          if ((e | 0) == 1) {
                                           break N;
                                          }
                                          v[31601] = 0;
                                          b = O(267, b | 0, 21) | 0;
                                          e = v[31601];
                                          v[31601] = 0;
                                          if ((e | 0) == 1) {
                                           break N;
                                          }
                                          v[31601] = 0;
                                          O(267, b | 0, 13) | 0;
                                          b = v[31601];
                                          v[31601] = 0;
                                          if ((b | 0) != 1) {
                                           break L;
                                          }
                                         }
                                         b = M() | 0;
                                         break b;
                                        }
                                        b = M() | 0;
                                        break a;
                                       }
                                       b = M() | 0;
                                       tb(d + 208 | 0);
                                       break b;
                                      }
                                      v[31601] = 0;
                                      b = O(1, d + 352 | 0, 9282) | 0;
                                      e = v[31601];
                                      v[31601] = 0;
                                      if ((e | 0) == 1) {
                                       break c;
                                      }
                                      yb(a + 1298344 | 0, b);
                                      sb(b);
                                      v[31601] = 0;
                                      b = O(1, d + 340 | 0, 10317) | 0;
                                      e = v[31601];
                                      v[31601] = 0;
                                      if ((e | 0) == 1) {
                                       break d;
                                      }
                                      yb(a + 1298356 | 0, b);
                                      sb(b);
                                      v[31601] = 0;
                                      b = d + 320 | 0;
                                      N(268, b | 0, 4336);
                                      e = v[31601];
                                      v[31601] = 0;
                                      if ((e | 0) == 1) {
                                       break e;
                                      }
                                      v[31601] = 0;
                                      e = d + 300 | 0;
                                      N(269, e | 0, d + 412 | 0);
                                      f = v[31601];
                                      v[31601] = 0;
                                      if ((f | 0) == 1) {
                                       break g;
                                      }
                                      v[31601] = 0;
                                      g = d + 264 | 0;
                                      N(269, g | 0, d + 413 | 0);
                                      f = v[31601];
                                      v[31601] = 0;
                                      if ((f | 0) == 1) {
                                       break i;
                                      }
                                      v[31601] = 0;
                                      f = d + 208 | 0;
                                      U(89, f | 0, b | 0, e | 0, g | 0);
                                      h = v[31601];
                                      v[31601] = 0;
                                      if ((h | 0) == 1) {
                                       break j;
                                      }
                                      yb(a + 1298368 | 0, f);
                                      sb(f);
                                      sb(g);
                                      sb(e);
                                      Db(b);
                                      C = a, D = v[Ec(f, 28) >> 2], v[C + 1298404 >> 2] = D;
                                      v[31601] = 0;
                                      f = d + 376 | 0;
                                      R(264, b | 0, f | 0, 1312902469);
                                      g = v[31601];
                                      v[31601] = 0;
                                      if ((g | 0) == 1) {
                                       break k;
                                      }
                                      v[31601] = 0;
                                      g = Q(154, v[d + 320 >> 2]) | 0;
                                      h = v[31601];
                                      v[31601] = 0;
                                      if ((h | 0) == 1) {
                                       break m;
                                      }
                                      v[31601] = 0;
                                      h = a + 1298308 | 0;
                                      R(270, b | 0, h | 0, g | 0);
                                      b = v[31601];
                                      v[31601] = 0;
                                      if ((b | 0) == 1) {
                                       break m;
                                      }
                                      v[31601] = 0;
                                      R(264, e | 0, f | 0, 1397706311);
                                      b = v[31601];
                                      v[31601] = 0;
                                      if ((b | 0) == 1) {
                                       break n;
                                      }
                                      Mc(Wb(v[a + 484360 >> 2], w[a + 484376 | 0]));
                                      f = a + 484360 | 0;
                                      j = Ab(x[d + 370 >> 1]);
                                      e = 0;
                                      O: {
                                       while (1) {
                                        P: {
                                         if (j >>> 0 <= (e & 65535) >>> 0) {
                                          break P;
                                         }
                                         v[31601] = 0;
                                         b = T(150, v[d + 300 >> 2], v[d + 308 >> 2], 46) | 0;
                                         g = v[31601];
                                         v[31601] = 0;
                                         Q: {
                                          if ((g | 0) != 1) {
                                           if (!b) {
                                            break P;
                                           }
                                           v[31601] = 0;
                                           b = d + 208 | 0;
                                           N(271, d + 300 | 0, b | 0);
                                           g = v[31601];
                                           v[31601] = 0;
                                           if ((g | 0) != 1) {
                                            if (!zd(v[a + 1298312 >> 2], w[a + 1298319 | 0])) {
                                             break Q;
                                            }
                                            v[31601] = 0;
                                            N(272, h | 0, b | 0);
                                            b = v[31601];
                                            v[31601] = 0;
                                            if ((b | 0) != 1) {
                                             break Q;
                                            }
                                           }
                                           b = M() | 0;
                                           break o;
                                          }
                                          b = M() | 0;
                                          break o;
                                         }
                                         v[31601] = 0;
                                         i = Q(273, d + 300 | 0) | 0;
                                         b = v[31601];
                                         v[31601] = 0;
                                         if ((b | 0) == 1) {
                                          break O;
                                         }
                                         b = Wb(v[a + 484360 >> 2], w[a + 484376 | 0]);
                                         if (!lc(v[b >> 2], v[b + 4 >> 2])) {
                                          v[31601] = 0;
                                          b = Q(274, f | 0) | 0;
                                          g = v[31601];
                                          v[31601] = 0;
                                          if ((g | 0) == 1) {
                                           break O;
                                          }
                                          if ((b | 0) == 255) {
                                           break P;
                                          }
                                          b = Wb(v[a + 484360 >> 2], w[a + 484376 | 0]);
                                         }
                                         v[31601] = 0;
                                         g = d + 288 | 0;
                                         N(275, g | 0, d + 208 | 0);
                                         k = v[31601];
                                         v[31601] = 0;
                                         if ((k | 0) == 1) {
                                          break O;
                                         }
                                         pp(b, g);
                                         sb(g);
                                         b = w[a + 484376 | 0];
                                         g = v[a + 484360 >> 2];
                                         v[31601] = 0;
                                         R(276, Wb(g, b) | 0, d + 300 | 0, i | 0);
                                         b = v[31601];
                                         v[31601] = 0;
                                         if ((b | 0) == 1) {
                                          break O;
                                         }
                                         e = e + 1 | 0;
                                         continue;
                                        }
                                        break;
                                       }
                                       Vj(f, 0);
                                       v[31601] = 0;
                                       R(264, d + 264 | 0, d + 376 | 0, 1229869908);
                                       b = v[31601];
                                       v[31601] = 0;
                                       if ((b | 0) != 1) {
                                        v[31601] = 0;
                                        b = Q(277, v[d + 264 >> 2]) | 0;
                                        e = v[31601];
                                        v[31601] = 0;
                                        if ((e | 0) == 1) {
                                         break p;
                                        }
                                        R: {
                                         S: {
                                          if (!b) {
                                           break S;
                                          }
                                          j = a + 484380 | 0;
                                          i = a + 946304 | 0;
                                          e = 1;
                                          T: {
                                           while (1) {
                                            b = e & 65535;
                                            if (b >>> 0 > x[a + 480192 >> 1]) {
                                             v[31601] = 0;
                                             R(264, d + 188 | 0, d + 376 | 0, 1447382614);
                                             b = v[31601];
                                             v[31601] = 0;
                                             if ((b | 0) != 1) {
                                              break T;
                                             }
                                             break p;
                                            }
                                            v[31601] = 0;
                                            h = d + 208 | 0;
                                            N(278, d + 264 | 0, h | 0);
                                            f = v[31601];
                                            v[31601] = 0;
                                            if ((f | 0) == 1) {
                                             break p;
                                            }
                                            f = w[d + 238 | 0] | w[d + 239 | 0] << 8;
                                            v[31601] = 0;
                                            b = T(251, a | 0, b | 0, Ab(f) | 0) | 0;
                                            f = v[31601];
                                            v[31601] = 0;
                                            if ((f | 0) == 1) {
                                             break R;
                                            }
                                            U: {
                                             V: {
                                              if (!b) {
                                               break V;
                                              }
                                              if (Ab(w[d + 238 | 0] | w[d + 239 | 0] << 8) >>> 0 > 3999) {
                                               break V;
                                              }
                                              g = d + 112 | 0;
                                              wE(g, 2, h);
                                              v[31601] = 0;
                                              f = d + 136 | 0;
                                              N(218, f | 0, g | 0);
                                              k = v[31601];
                                              v[31601] = 0;
                                              if ((k | 0) == 1) {
                                               break U;
                                              }
                                              zc(b + 492 | 0, f);
                                              sb(f);
                                              wE(g, 2, h);
                                              v[31601] = 0;
                                              N(218, f | 0, g | 0);
                                              h = v[31601];
                                              v[31601] = 0;
                                              if ((h | 0) == 1) {
                                               break p;
                                              }
                                              zc(i + (Ab(w[d + 238 | 0] | w[d + 239 | 0] << 8) << 5) | 0, f);
                                              sb(f);
                                              v[b >> 2] = 0;
                                              C = b, D = ye((w[d + 254 | 0] | w[d + 255 | 0] << 8) << 16 >> 16) + 128 & 65535, 
                                              v[C + 8 >> 2] = D;
                                              wc(b + 8 | 0, 256);
                                              t[b + 15 | 0] = w[b + 15 | 0] | 1;
                                              b = w[d + 238 | 0] | w[d + 239 | 0] << 8;
                                              v[31601] = 0;
                                              b = j + B(Ab(b), 104) | 0;
                                              N(279, b | 0, 0);
                                              h = v[31601];
                                              v[31601] = 0;
                                              if ((h | 0) == 1) {
                                               break p;
                                              }
                                              C = d, D = Ab(w[d + 240 | 0] | w[d + 241 | 0] << 8), u[C + 136 >> 1] = D;
                                              u[d + 112 >> 1] = 64;
                                              C = b, D = x[Nc(f, g) >> 1] << 2, u[C + 30 >> 1] = D;
                                              f = _b(w[d + 242 | 0] | w[d + 243 | 0] << 8 | (w[d + 244 | 0] << 16 | w[d + 245 | 0] << 24));
                                              g = Aua(f, f >> 31, 8303, 0);
                                              f = gb;
                                              g = g + 4181 | 0;
                                              f = g >>> 0 < 4181 ? f + 1 | 0 : f;
                                              C = b, D = Fc(Bua(g, f, 8363, 0), gb), v[C + 24 >> 2] = D;
                                              f = _b(w[d + 250 | 0] | w[d + 251 | 0] << 8 | (w[d + 252 | 0] << 16 | w[d + 253 | 0] << 24));
                                              if (!f) {
                                               break V;
                                              }
                                              g = Ab(w[d + 256 | 0] | w[d + 257 | 0] << 8);
                                              if (!(g & 3)) {
                                               break V;
                                              }
                                              h = _b(w[d + 246 | 0] | w[d + 247 | 0] << 8 | (w[d + 248 | 0] << 16 | w[d + 249 | 0] << 24));
                                              v[b + 4 >> 2] = h;
                                              v[b + 8 >> 2] = f + h;
                                              f = x[b + 34 >> 1];
                                              u[b + 34 >> 1] = f | 2;
                                              if (!(g & 2)) {
                                               break V;
                                              }
                                              u[b + 34 >> 1] = f | 6;
                                             }
                                             e = e + 1 | 0;
                                             continue;
                                            }
                                            break;
                                           }
                                           break p;
                                          }
                                          b = v[d + 200 >> 2];
                                          v[d + 32 >> 2] = v[d + 196 >> 2];
                                          v[d + 36 >> 2] = b;
                                          v[d + 40 >> 2] = v[d + 204 >> 2];
                                          v[31601] = 0;
                                          b = v[d + 192 >> 2];
                                          v[d + 24 >> 2] = v[d + 188 >> 2];
                                          v[d + 28 >> 2] = b;
                                          U(280, d + 24 | 0, 0, a | 0, 0);
                                          b = v[31601];
                                          v[31601] = 0;
                                          if ((b | 0) == 1) {
                                           break p;
                                          }
                                          v[31601] = 0;
                                          R(264, d + 168 | 0, d + 376 | 0, 1346719318);
                                          b = v[31601];
                                          v[31601] = 0;
                                          if ((b | 0) == 1) {
                                           break p;
                                          }
                                          b = v[d + 180 >> 2];
                                          v[d + 8 >> 2] = v[d + 176 >> 2];
                                          v[d + 12 >> 2] = b;
                                          v[d + 16 >> 2] = v[d + 184 >> 2];
                                          v[31601] = 0;
                                          b = v[d + 172 >> 2];
                                          v[d >> 2] = v[d + 168 >> 2];
                                          v[d + 4 >> 2] = b;
                                          U(280, d | 0, 1, a | 0, w[d + 412 | 0] > 2 | 0);
                                          b = v[31601];
                                          v[31601] = 0;
                                          if ((b | 0) == 1) {
                                           break p;
                                          }
                                          b = x[a + 480192 >> 1] + 1 & 65535;
                                          f = b >>> 0 <= 1 ? 1 : b;
                                          g = a + 900380 | 0;
                                          b = 1;
                                          while (1) {
                                           if ((b | 0) == (f | 0)) {
                                            break S;
                                           }
                                           e = v[g + (b << 2) >> 2];
                                           if (!(!e | t[e + 60 | 0] & 1)) {
                                            v[e >> 2] = 32767;
                                           }
                                           b = b + 1 | 0;
                                           continue;
                                          }
                                         }
                                         b = d + 264 | 0;
                                         tb(b);
                                         v[31601] = 0;
                                         e = d + 376 | 0;
                                         R(264, d + 208 | 0, e | 0, 1346458708);
                                         f = v[31601];
                                         v[31601] = 0;
                                         if ((f | 0) == 1) {
                                          break x;
                                         }
                                         v[31601] = 0;
                                         f = Q(172, v[d + 208 >> 2]) | 0;
                                         g = v[31601];
                                         v[31601] = 0;
                                         if ((g | 0) == 1) {
                                          break y;
                                         }
                                         if (!(c & 1) | f ^ 1) {
                                          break J;
                                         }
                                         v[31601] = 0;
                                         R(264, b | 0, e | 0, 1347305805);
                                         e = v[31601];
                                         v[31601] = 0;
                                         if ((e | 0) == 1) {
                                          break z;
                                         }
                                         v[31601] = 0;
                                         O(183, b | 0, 1) | 0;
                                         b = v[31601];
                                         v[31601] = 0;
                                         if ((b | 0) == 1) {
                                          break B;
                                         }
                                         b = x[d + 372 >> 1];
                                         v[31601] = 0;
                                         k = a + 484344 | 0;
                                         N(223, k | 0, Ab(b) | 0);
                                         b = v[31601];
                                         v[31601] = 0;
                                         if ((b | 0) == 1) {
                                          break B;
                                         }
                                         j = Mb(d + 156 | 0);
                                         i = 0;
                                         W: {
                                          while (1) {
                                           if (Ab(x[d + 372 >> 1]) >>> 0 <= i >>> 0) {
                                            nd(j);
                                            tb(d + 264 | 0);
                                            if (c & 4) {
                                             e = 0;
                                             if (!y) {
                                              break w;
                                             }
                                             f = a + 480280 | 0;
                                             g = x[a + 480188 >> 1];
                                             b = 0;
                                             while (1) if ((b | 0) == (g | 0)) {
                                              e = 1;
                                              break w;
                                             } else {
                                              e = f + (b << 5) | 0;
                                              t[e + 8 | 0] = 1;
                                              v[e >> 2] = v[e >> 2] | 67108864;
                                              b = b + 1 | 0;
                                              continue;
                                             }
                                            }
                                            if (!r) {
                                             break u;
                                            }
                                            break v;
                                           }
                                           v[31601] = 0;
                                           e = d + 208 | 0;
                                           b = Q(273, e | 0) | 0;
                                           f = v[31601];
                                           v[31601] = 0;
                                           if ((f | 0) == 1) {
                                            break D;
                                           }
                                           v[31601] = 0;
                                           g = Q(281, e | 0) | 0;
                                           f = v[31601];
                                           v[31601] = 0;
                                           if ((f | 0) == 1) {
                                            break E;
                                           }
                                           v[31601] = 0;
                                           f = d + 112 | 0;
                                           R(185, f | 0, e | 0, g | 0);
                                           e = v[31601];
                                           v[31601] = 0;
                                           if ((e | 0) == 1) {
                                            break F;
                                           }
                                           h = gc(d + 136 | 0, f);
                                           tb(f);
                                           v[31601] = 0;
                                           e = T(196, k | 0, i & 65535, b | 0) | 0;
                                           f = v[31601];
                                           v[31601] = 0;
                                           if ((f | 0) == 1) {
                                            break H;
                                           }
                                           X: {
                                            if (e) {
                                             n = Eb(d + 100 | 0);
                                             v[31601] = 0;
                                             N(282, d + 264 | 0, n | 0);
                                             e = v[31601];
                                             v[31601] = 0;
                                             if ((e | 0) == 1) {
                                              break I;
                                             }
                                             e = v[k >> 2];
                                             v[31601] = 0;
                                             N(283, Vb(e, i) | 0, n | 0);
                                             e = v[31601];
                                             v[31601] = 0;
                                             if ((e | 0) == 1) {
                                              break I;
                                             }
                                             l = 0;
                                             e = Vb(v[k >> 2], i);
                                             af(d + 88 | 0, v[e >> 2], v[v[e + 48 >> 2] + 12 >> 2], 0);
                                             Mc(j);
                                             z = (b >>> 0 <= 1 ? 1 : b) - 1 | 0;
                                             Y: while (1) {
                                              b = v[h >> 2];
                                              v[31601] = 0;
                                              b = T(150, b | 0, v[d + 144 >> 2], 1) | 0;
                                              e = v[31601];
                                              v[31601] = 0;
                                              if ((e | 0) == 1) {
                                               break X;
                                              }
                                              Z: {
                                               if (!b) {
                                                break Z;
                                               }
                                               v[31601] = 0;
                                               b = Q(197, h | 0) | 0;
                                               e = v[31601];
                                               v[31601] = 0;
                                               if ((e | 0) == 1) {
                                                break I;
                                               }
                                               if (!b) {
                                                C = d, D = vb(v[j >> 2]), v[C + 84 >> 2] = D;
                                                e = vb(v[j + 4 >> 2]);
                                                while (1) {
                                                 b = v[d + 84 >> 2];
                                                 if (Hb(b, e)) {
                                                  ze(Vb(v[k >> 2], i), We(Ne(d + 112 | 0, w[b | 0], w[b + 1 | 0]), l));
                                                  fe(d + 84 | 0);
                                                  continue;
                                                 } else {
                                                  Mc(j);
                                                  if ((l | 0) == (z | 0)) {
                                                   break Z;
                                                  }
                                                  b = Vb(v[k >> 2], i);
                                                  l = l + 1 | 0;
                                                  af(d + 112 | 0, v[b >> 2], v[v[b + 48 >> 2] + 12 >> 2], l);
                                                  b = v[d + 116 >> 2];
                                                  v[d + 88 >> 2] = v[d + 112 >> 2];
                                                  v[d + 92 >> 2] = b;
                                                  continue Y;
                                                 }
                                                }
                                               }
                                               u[d + 116 >> 1] = 0;
                                               v[d + 112 >> 2] = 0;
                                               g = d + 112 | 0;
                                               if (b >>> 0 <= x[a + 480188 >> 1]) {
                                                g = Xc(v[d + 88 >> 2], b - 1 | 0);
                                               }
                                               v[31601] = 0;
                                               b = Q(197, h | 0) | 0;
                                               e = v[31601];
                                               v[31601] = 0;
                                               _: {
                                                $: {
                                                 if ((e | 0) != 1) {
                                                  aa: {
                                                   if (!(b & 1)) {
                                                    break aa;
                                                   }
                                                   v[31601] = 0;
                                                   e = Q(197, h | 0) | 0;
                                                   f = v[31601];
                                                   v[31601] = 0;
                                                   if ((f | 0) == 1) {
                                                    break I;
                                                   }
                                                   if ((e | 0) != 31) {
                                                    if ((e - 1 & 255) >>> 0 > 252) {
                                                     break aa;
                                                    }
                                                    e = (B(e >>> 4 | 0, 12) + (e & 15) | 0) + 13 | 0;
                                                   } else {
                                                    e = 255;
                                                   }
                                                   t[g | 0] = e;
                                                  }
                                                  if (!(b & 2)) {
                                                   break _;
                                                  }
                                                  v[31601] = 0;
                                                  e = Q(197, h | 0) | 0;
                                                  f = v[31601];
                                                  v[31601] = 0;
                                                  if ((f | 0) != 1) {
                                                   break $;
                                                  }
                                                 }
                                                 break I;
                                                }
                                                t[g + 1 | 0] = e;
                                               }
                                               if (!(b & 60)) {
                                                continue;
                                               }
                                               e = 0;
                                               m = 0;
                                               if (b & 4) {
                                                v[31601] = 0;
                                                m = Q(197, h | 0) | 0;
                                                f = v[31601];
                                                v[31601] = 0;
                                                if ((f | 0) == 1) {
                                                 break I;
                                                }
                                               }
                                               if (b & 8) {
                                                v[31601] = 0;
                                                e = Q(197, h | 0) | 0;
                                                f = v[31601];
                                                v[31601] = 0;
                                                if ((f | 0) == 1) {
                                                 break I;
                                                }
                                               }
                                               f = 0;
                                               s = 0;
                                               if (b & 16) {
                                                v[31601] = 0;
                                                s = Q(197, h | 0) | 0;
                                                A = v[31601];
                                                v[31601] = 0;
                                                if ((A | 0) == 1) {
                                                 break I;
                                                }
                                               }
                                               if (b & 32) {
                                                v[31601] = 0;
                                                f = Q(197, h | 0) | 0;
                                                b = v[31601];
                                                v[31601] = 0;
                                                if ((b | 0) == 1) {
                                                 break I;
                                                }
                                               }
                                               b = d + 84 | 0;
                                               d0(b, s, f);
                                               f = Ic(b);
                                               b = d + 82 | 0;
                                               d0(b, m, e);
                                               e = Ic(b);
                                               b = w[d + 82 | 0];
                                               ba: {
                                                if ((b | 0) != 13) {
                                                 if (b) {
                                                  break ba;
                                                 }
                                                 b = 0;
                                                 if (w[d + 84 | 0] == 13) {
                                                  break ba;
                                                 }
                                                }
                                                qg(d + 84 | 0, d + 82 | 0);
                                                qg(f, e);
                                                b = w[d + 82 | 0];
                                               }
                                               m = d + 80 | 0;
                                               cm(m, g, w[d + 84 | 0], w[f | 0], b & 255, w[e | 0]);
                                               if (c0(w[d + 80 | 0], w[d + 81 | 0])) {
                                                b = v[ub(d + 76 | 0, vb(v[j >> 2])) >> 2];
                                                v[31601] = 0;
                                                R(284, j | 0, b | 0, m | 0);
                                                b = v[31601];
                                                v[31601] = 0;
                                                if ((b | 0) == 1) {
                                                 break W;
                                                }
                                               }
                                               b = w[g + 3 | 0];
                                               if ((b | 0) == 43) {
                                                y = 1;
                                                continue;
                                               }
                                               if ((b | 0) != 31) {
                                                continue;
                                               }
                                               r = 1;
                                               continue;
                                              }
                                              break;
                                             }
                                             sb(n);
                                            }
                                            tb(h);
                                            i = i + 1 | 0;
                                            continue;
                                           }
                                           break;
                                          }
                                          break I;
                                         }
                                         break I;
                                        }
                                        break p;
                                       }
                                       b = M() | 0;
                                       break o;
                                      }
                                      b = M() | 0;
                                      break o;
                                     }
                                     b = M() | 0;
                                     break b;
                                    }
                                    e = 0;
                                    if (c & 4) {
                                     break w;
                                    }
                                    break u;
                                   }
                                   b = M() | 0;
                                   sb(n);
                                   break G;
                                  }
                                  b = M() | 0;
                                 }
                                 tb(h);
                                 break C;
                                }
                                b = M() | 0;
                                break C;
                               }
                               b = M() | 0;
                               break C;
                              }
                              b = M() | 0;
                             }
                             nd(j);
                             break A;
                            }
                            b = M() | 0;
                           }
                           tb(d + 264 | 0);
                           break q;
                          }
                          b = M() | 0;
                          break q;
                         }
                         b = M() | 0;
                         break q;
                        }
                        b = M() | 0;
                        break o;
                       }
                       t[d + 156 | 0] = 0;
                       t[d + 157 | 0] = 80;
                       t[d + 158 | 0] = 0;
                       t[d + 159 | 0] = 150;
                       t[d + 160 | 0] = 0;
                       t[d + 161 | 0] = 80;
                       t[d + 162 | 0] = 0;
                       t[d + 163 | 0] = 255;
                       v[31601] = 0;
                       R(264, d + 264 | 0, d + 376 | 0, 1146310725);
                       b = v[31601];
                       v[31601] = 0;
                       ca: {
                        da: {
                         if ((b | 0) != 1) {
                          v[31601] = 0;
                          b = Q(277, v[d + 264 >> 2]) | 0;
                          f = v[31601];
                          v[31601] = 0;
                          if ((f | 0) != 1) {
                           if (!b) {
                            f = e;
                            break ca;
                           }
                           v[31601] = 0;
                           j = Q(273, d + 264 | 0) | 0;
                           b = v[31601];
                           v[31601] = 0;
                           if ((b | 0) == 1) {
                            break da;
                           }
                           g = a + 480280 | 0;
                           b = 0;
                           f = e;
                           while (1) {
                            if ((b | 0) == (j | 0)) {
                             v[31601] = 0;
                             N(285, d + 264 | 0, d + 156 | 0);
                             b = v[31601];
                             v[31601] = 0;
                             if ((b | 0) != 1) {
                              break ca;
                             }
                             break da;
                            }
                            v[31601] = 0;
                            h = Q(197, d + 264 | 0) | 0;
                            i = v[31601];
                            v[31601] = 0;
                            ea: {
                             fa: {
                              if ((i | 0) != 1) {
                               if (x[a + 480188 >> 1] <= b >>> 0) {
                                break ea;
                               }
                               if (!e) {
                                break fa;
                               }
                               i = g + (b << 5) | 0;
                               v[i >> 2] = v[i >> 2] & -67108865 | ((h | 0) != 0) << 26;
                               break ea;
                              }
                              break da;
                             }
                             if (h) {
                              break ea;
                             }
                             f = 1;
                             t[(g + (b << 5) | 0) + 8 | 0] = 1;
                            }
                            b = b + 1 | 0;
                            continue;
                           }
                          }
                          break da;
                         }
                         b = M() | 0;
                         break q;
                        }
                        b = M() | 0;
                        tb(d + 264 | 0);
                        break q;
                       }
                       e = d + 264 | 0;
                       tb(e);
                       ga: {
                        ha: {
                         if (f & 1) {
                          v[31601] = 0;
                          b = _d(a + 906300 | 0, 0);
                          V(286, b | 0);
                          f = v[31601];
                          v[31601] = 0;
                          if ((f | 0) == 1) {
                           break r;
                          }
                          v[b + 24 >> 2] = 655376;
                          v[b + 28 >> 2] = 0;
                          v[b + 16 >> 2] = 810369604;
                          v[b + 20 >> 2] = 1869112133;
                          v[d + 264 >> 2] = 0;
                          g = b + 48 | 0;
                          $$(b + 32 | 0, g, e);
                          v[31601] = 0;
                          f = O(36, d + 136 | 0, 9571) | 0;
                          h = v[31601];
                          v[31601] = 0;
                          if ((h | 0) == 1) {
                           break ha;
                          }
                          vE(g, f);
                          sb(f);
                          v[31601] = 0;
                          f = O(36, d + 112 | 0, 9535) | 0;
                          g = v[31601];
                          v[31601] = 0;
                          if ((g | 0) == 1) {
                           break ga;
                          }
                          rw(b + 80 | 0, f);
                          sb(f);
                          v[31601] = 0;
                          N(287, b + 4 | 0, 8);
                          f = v[31601];
                          v[31601] = 0;
                          if ((f | 0) == 1) {
                           break r;
                          }
                          _$(e, w[d + 157 | 0], w[d + 159 | 0], w[d + 161 | 0], w[d + 163 | 0]);
                          e = v[d + 268 >> 2];
                          b = v[b + 4 >> 2];
                          f = v[d + 264 >> 2];
                          t[b | 0] = f;
                          t[b + 1 | 0] = f >>> 8;
                          t[b + 2 | 0] = f >>> 16;
                          t[b + 3 | 0] = f >>> 24;
                          t[b + 4 | 0] = e;
                          t[b + 5 | 0] = e >>> 8;
                          t[b + 6 | 0] = e >>> 16;
                          t[b + 7 | 0] = e >>> 24;
                         }
                         if (r) {
                          break v;
                         }
                         break u;
                        }
                        b = M() | 0;
                        break q;
                       }
                       b = M() | 0;
                       break q;
                      }
                      h = a + 902204 | 0;
                      b = 0;
                      ia: {
                       ja: {
                        ka: {
                         la: {
                          ma: {
                           na: {
                            oa: {
                             pa: {
                              qa: {
                               ra: {
                                sa: {
                                 ta: {
                                  ua: {
                                   va: {
                                    wa: {
                                     while (1) {
                                      if ((b | 0) == 32) {
                                       break u;
                                      }
                                      v[d + 88 >> 2] = B(b, 127) >>> 5;
                                      v[31601] = 0;
                                      e = d + 156 | 0;
                                      N(288, e | 0, 4093);
                                      f = v[31601];
                                      v[31601] = 0;
                                      if ((f | 0) != 1) {
                                       v[31601] = 0;
                                       f = d + 100 | 0;
                                       j = d + 88 | 0;
                                       N(289, f | 0, j | 0);
                                       g = v[31601];
                                       v[31601] = 0;
                                       if ((g | 0) == 1) {
                                        break wa;
                                       }
                                       v[31601] = 0;
                                       g = d + 264 | 0;
                                       R(290, g | 0, e | 0, f | 0);
                                       i = v[31601];
                                       v[31601] = 0;
                                       if ((i | 0) == 1) {
                                        break va;
                                       }
                                       ee(d + 68 | 0, g);
                                       qf(Oe(h, b), v[d + 68 >> 2], v[d + 72 >> 2]);
                                       sb(g);
                                       sb(f);
                                       Db(e);
                                       v[31601] = 0;
                                       N(288, e | 0, 4075);
                                       i = v[31601];
                                       v[31601] = 0;
                                       if ((i | 0) == 1) {
                                        break ta;
                                       }
                                       v[31601] = 0;
                                       N(289, f | 0, j | 0);
                                       i = v[31601];
                                       v[31601] = 0;
                                       if ((i | 0) == 1) {
                                        break sa;
                                       }
                                       v[31601] = 0;
                                       R(290, g | 0, e | 0, f | 0);
                                       i = v[31601];
                                       v[31601] = 0;
                                       if ((i | 0) == 1) {
                                        break ra;
                                       }
                                       ee(d + 60 | 0, g);
                                       qf(Oe(h, b | 32), v[d + 60 >> 2], v[d + 64 >> 2]);
                                       sb(g);
                                       sb(f);
                                       Db(e);
                                       v[31601] = 0;
                                       N(288, e | 0, 4066);
                                       i = v[31601];
                                       v[31601] = 0;
                                       if ((i | 0) == 1) {
                                        break pa;
                                       }
                                       v[31601] = 0;
                                       N(289, f | 0, j | 0);
                                       i = v[31601];
                                       v[31601] = 0;
                                       if ((i | 0) == 1) {
                                        break oa;
                                       }
                                       v[31601] = 0;
                                       R(290, g | 0, e | 0, f | 0);
                                       i = v[31601];
                                       v[31601] = 0;
                                       if ((i | 0) == 1) {
                                        break na;
                                       }
                                       ee(d + 52 | 0, g);
                                       qf(Oe(h, b | 64), v[d + 52 >> 2], v[d + 56 >> 2]);
                                       sb(g);
                                       sb(f);
                                       Db(e);
                                       v[31601] = 0;
                                       N(288, e | 0, 4039);
                                       i = v[31601];
                                       v[31601] = 0;
                                       if ((i | 0) == 1) {
                                        break la;
                                       }
                                       v[31601] = 0;
                                       N(289, f | 0, j | 0);
                                       j = v[31601];
                                       v[31601] = 0;
                                       if ((j | 0) == 1) {
                                        break ka;
                                       }
                                       v[31601] = 0;
                                       R(290, g | 0, e | 0, f | 0);
                                       f = v[31601];
                                       v[31601] = 0;
                                       if ((f | 0) == 1) {
                                        break ja;
                                       }
                                       ee(d + 44 | 0, g);
                                       qf(Oe(h, b | 96), v[d + 44 >> 2], v[d + 48 >> 2]);
                                       b = b + 1 | 0;
                                       sb(d + 264 | 0);
                                       sb(d + 100 | 0);
                                       Db(e);
                                       continue;
                                      }
                                      break;
                                     }
                                     b = M() | 0;
                                     break q;
                                    }
                                    b = M() | 0;
                                    break ua;
                                   }
                                   b = M() | 0;
                                   sb(d + 100 | 0);
                                  }
                                  Db(d + 156 | 0);
                                  break q;
                                 }
                                 b = M() | 0;
                                 break q;
                                }
                                b = M() | 0;
                                break qa;
                               }
                               b = M() | 0;
                               sb(d + 100 | 0);
                              }
                              Db(d + 156 | 0);
                              break q;
                             }
                             b = M() | 0;
                             break q;
                            }
                            b = M() | 0;
                            break ma;
                           }
                           b = M() | 0;
                           sb(d + 100 | 0);
                          }
                          Db(d + 156 | 0);
                          break q;
                         }
                         b = M() | 0;
                         break q;
                        }
                        b = M() | 0;
                        break ia;
                       }
                       b = M() | 0;
                       sb(d + 100 | 0);
                      }
                      Db(d + 156 | 0);
                      break q;
                     }
                     v[31601] = 0;
                     R(264, d + 264 | 0, d + 376 | 0, 1397575756);
                     b = v[31601];
                     v[31601] = 0;
                     xa: {
                      if ((b | 0) != 1) {
                       v[31601] = 0;
                       b = Q(172, v[d + 264 >> 2]) | 0;
                       e = v[31601];
                       v[31601] = 0;
                       if ((e | 0) != 1) {
                        ya: {
                         if (!(c & 2) | b ^ 1) {
                          break xa;
                         }
                         f = a + 484380 | 0;
                         e = 1;
                         while (1) {
                          g = e & 65535;
                          if (g >>> 0 > x[a + 480190 >> 1]) {
                           break xa;
                          }
                          v[31601] = 0;
                          c = d + 264 | 0;
                          b = Q(281, c | 0) | 0;
                          h = v[31601];
                          v[31601] = 0;
                          za: {
                           if ((h | 0) != 1) {
                            v[31601] = 0;
                            h = Q(281, c | 0) | 0;
                            j = v[31601];
                            v[31601] = 0;
                            if ((j | 0) == 1) {
                             break ya;
                            }
                            if (!(b & 7)) {
                             break za;
                            }
                            g = f + B(g, 104) | 0;
                            v[g >> 2] = h;
                            b = Yc(d + 156 | 0, b & 4 ? 32 : b & 2 ? 16 : 8, 1, 1, 0);
                            v[31601] = 0;
                            T(215, b | 0, g | 0, c | 0) | 0;
                            b = v[31601];
                            v[31601] = 0;
                            if ((b | 0) != 1) {
                             break za;
                            }
                            break ya;
                           }
                           break ya;
                          }
                          e = e + 1 | 0;
                          continue;
                         }
                        }
                       }
                       b = M() | 0;
                       tb(d + 264 | 0);
                       break q;
                      }
                      b = M() | 0;
                      break q;
                     }
                     tb(d + 264 | 0);
                     tb(d + 208 | 0);
                     tb(d + 300 | 0);
                     tb(d + 320 | 0);
                    }
                    je(d + 376 | 0);
                    tb(q);
                   }
                   eb = d + 416 | 0;
                   return o | 0;
                  }
                  b = M() | 0;
                 }
                 tb(d + 208 | 0);
                 break o;
                }
                b = M() | 0;
                tb(d + 264 | 0);
               }
               tb(d + 300 | 0);
               break l;
              }
              b = M() | 0;
              break l;
             }
             b = M() | 0;
            }
            tb(d + 320 | 0);
            break b;
           }
           b = M() | 0;
           break b;
          }
          b = M() | 0;
          sb(d + 264 | 0);
          break h;
         }
         b = M() | 0;
        }
        sb(d + 300 | 0);
        break f;
       }
       b = M() | 0;
      }
      Db(d + 320 | 0);
      break b;
     }
     b = M() | 0;
     break b;
    }
    b = M() | 0;
    break b;
   }
   b = M() | 0;
  }
  je(d + 376 | 0);
 }
 tb(q);
 P(b | 0);
 p();
}

function Kpa(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, q = 0, r = 0, s = 0, z = 0, A = 0, C = 0, D = 0, E = 0, F = 0, G = 0, H = 0, I = 0;
 e = eb - 1728 | 0;
 eb = e;
 xc(b);
 d = eb - 16 | 0;
 eb = d;
 i = e + 1602 | 0;
 EX(d + 8 | 0, i);
 g = v[d + 12 >> 2];
 ic(d, v[b >> 2], v[b + 8 >> 2], v[d + 8 >> 2], v[d + 12 >> 2]);
 j = v[d + 4 >> 2];
 if ((j | 0) == (g | 0)) {
  Ub(b, v[d + 12 >> 2]);
 }
 eb = d + 16 | 0;
 d = (g | 0) == (j | 0);
 if (!d) {
  DX(i);
 }
 a: {
  b: {
   c: {
    d: {
     e: {
      f: {
       g: {
        if (!d) {
         break g;
        }
        if (!FX(i)) {
         break g;
        }
        if (!Lb(v[b >> 2], v[b + 8 >> 2], Ac(256, 0))) {
         break g;
        }
        f = 1;
        if ((c | 0) == 64) {
         break g;
        }
        Cd(a, 1048576);
        dg(a);
        d = eb - 16 | 0;
        eb = d;
        f = e + 1344 | 0;
        i = tc(d + 4 | 0, 4230);
        Uc(f, i);
        sb(i);
        eb = d + 16 | 0;
        d = w[e + 1610 | 0] | w[e + 1611 | 0] << 8;
        v[e + 144 >> 2] = d >>> 8;
        v[31601] = 0;
        v[e >> 2] = d & 255;
        i = e + 68 | 0;
        N(444, i | 0, e | 0);
        d = v[31601];
        v[31601] = 0;
        h: {
         i: {
          j: {
           k: {
            if ((d | 0) != 1) {
             v[31601] = 0;
             d = e + 256 | 0;
             U(430, d | 0, f | 0, e + 144 | 0, i | 0);
             g = v[31601];
             v[31601] = 0;
             if ((g | 0) == 1) {
              break k;
             }
             yb(a + 1298344 | 0, d);
             sb(d);
             sb(i);
             Db(f);
             i = tc(d, 15110);
             yb(a + 1298356 | 0, i);
             sb(i);
             Ue(f, 2, e + 1612 | 0);
             Er(d, 22, f);
             yb(a + 1298368 | 0, d);
             sb(d);
             H = a, I = v[Ec(d, 22) >> 2], v[H + 1298404 >> 2] = I;
             LC(f, 2, e + 1644 | 0);
             Bc(d, f);
             yb(a + 1298308 | 0, d);
             sb(d);
             u[a + 480188 >> 1] = w[e + 1714 | 0] | w[e + 1715 | 0] << 8;
             i = w[e + 1718 | 0];
             v[a + 480204 >> 2] = 125e4;
             v[a + 480208 >> 2] = 32792;
             H = a, I = Kd(i, 1, 31), v[H + 480196 >> 2] = I;
             u[a + 480192 >> 1] = w[e + 1724 | 0] | w[e + 1725 | 0] << 8;
             u[a + 480190 >> 1] = w[e + 1726 | 0] | w[e + 1727 | 0] << 8;
             i = Kd(w[e + 1719 | 0], 1, 32);
             v[a + 480216 >> 2] = i;
             v[a + 480228 >> 2] = 96;
             v[a + 480232 >> 2] = 48;
             v[a + 480220 >> 2] = i << 2;
             Hw(b, f);
             Qr(Wb(v[a + 484360 >> 2], w[a + 484376 | 0]), f, w[e + 1708 | 0] | w[e + 1709 | 0] << 8, 65535, 65535);
             $e(Wb(v[a + 484360 >> 2], w[a + 484376 | 0]), w[e + 1710 | 0] | w[e + 1711 | 0] << 8);
             s = fh(b);
             ge(d, b, s ? 274 : 0);
             E = gc(e + 1324 | 0, d);
             tb(d);
             v[31601] = 0;
             f = Q(151, b | 0) | 0;
             i = v[31601];
             v[31601] = 0;
             if ((i | 0) == 1) {
              break i;
             }
             v[31601] = 0;
             R(185, d | 0, b | 0, f | 0);
             f = v[31601];
             v[31601] = 0;
             if ((f | 0) == 1) {
              break i;
             }
             A = gc(e + 1304 | 0, d);
             tb(d);
             o = x[a + 480188 >> 1];
             if (s) {
              u[a + 480188 >> 1] = o + 8;
             }
             C = c & 1;
             if (!C) {
              break h;
             }
             v[31601] = 0;
             N(223, a + 484344 | 0, w[e + 1712 | 0] | w[e + 1713 | 0] << 8);
             d = v[31601];
             v[31601] = 0;
             if ((d | 0) != 1) {
              break h;
             }
             g = M() | 0;
             break c;
            }
            g = M() | 0;
            break j;
           }
           g = M() | 0;
           sb(e + 68 | 0);
          }
          Db(e + 1344 | 0);
          break a;
         }
         g = M() | 0;
         break b;
        }
        q = a + 484344 | 0;
        g = 0;
        while (1) {
         l: {
          m: {
           n: {
            o: {
             p: {
              q: {
               if ((w[e + 1712 | 0] | w[e + 1713 | 0] << 8) >>> 0 <= h >>> 0) {
                d = w[e + 1716 | 0] | w[e + 1717 | 0] << 8;
                if ((d - 2 & 65535) >>> 0 >= 4998) {
                 break o;
                }
                if (!(g & 1)) {
                 break q;
                }
                j = 0;
                d = Fc(((d >>> 1 | 0) + 11025e5 >>> 0) / (d >>> 0) | 0, 0);
                break p;
               }
               v[31601] = 0;
               d = Q(189, b | 0) | 0;
               f = v[31601];
               v[31601] = 0;
               if ((f | 0) == 1) {
                break d;
               }
               v[e >> 2] = d;
               v[31601] = 0;
               f = Q(151, b | 0) | 0;
               d = v[31601];
               v[31601] = 0;
               if ((d | 0) == 1) {
                break e;
               }
               v[31601] = 0;
               d = e + 68 | 0;
               R(185, d | 0, b | 0, f + 1 & -2);
               f = v[31601];
               v[31601] = 0;
               if ((f | 0) == 1) {
                break e;
               }
               n = gc(e + 256 | 0, d);
               tb(d);
               wc(e, 1024);
               if (!C) {
                break m;
               }
               r = v[e >> 2];
               if (!r) {
                break m;
               }
               v[31601] = 0;
               d = T(196, q | 0, h & 65535, r | 0) | 0;
               f = v[31601];
               v[31601] = 0;
               if ((f | 0) != 1) {
                if (!d) {
                 break m;
                }
                k = 0;
                f = 0;
                if (t[e + 1720 | 0] & 1) {
                 break n;
                }
                r: while (1) {
                 if ((k | 0) == (r | 0)) {
                  break m;
                 }
                 d = Vb(v[q >> 2], h);
                 af(e + 68 | 0, v[d >> 2], v[v[d + 48 >> 2] + 12 >> 2], k);
                 f = 0;
                 while (1) {
                  if ((f | 0) == (o | 0)) {
                   k = k + 1 | 0;
                   continue r;
                  }
                  v[31601] = 0;
                  d = e + 144 | 0;
                  N(622, n | 0, d | 0);
                  i = v[31601];
                  v[31601] = 0;
                  if ((i | 0) != 1) {
                   g = CX(Xc(v[e + 68 >> 2], f), d) | g;
                   f = f + 1 | 0;
                   continue;
                  }
                  break;
                 }
                 break;
                }
                break f;
               }
               break f;
              }
              j = 2;
              d = Te(2646e3 / +(B(d, B(v[a + 480216 >> 2], v[a + 480196 >> 2])) >>> 0) * 1e4);
             }
             t[a + 480224 | 0] = j;
             v[a + 480204 >> 2] = d;
            }
            d = x[a + 480188 >> 1];
            v[31601] = 0;
            t[e + 256 | 0] = 0;
            r = T(623, e + 1292 | 0, d | 0, e + 256 | 0) | 0;
            d = v[31601];
            v[31601] = 0;
            s: {
             t: {
              if ((d | 0) != 1) {
               k = a + 1298320 | 0;
               i = a + 480280 | 0;
               m = a + 1298332 | 0;
               n = 0;
               u: {
                v: {
                 w: {
                  x: {
                   y: {
                    while (1) {
                     d = v[A + 8 >> 2];
                     f = v[A >> 2];
                     v[31601] = 0;
                     d = T(150, f | 0, d | 0, 8) | 0;
                     f = v[31601];
                     v[31601] = 0;
                     z: {
                      if ((f | 0) != 1) {
                       if (d) {
                        break z;
                       }
                       h = a + 906300 | 0;
                       g = v[r >> 2];
                       k = 0;
                       while (1) {
                        f = x[a + 480188 >> 1];
                        if (f >>> 0 <= k >>> 0) {
                         A: {
                          v[e + 248 >> 2] = 0;
                          v[e + 252 >> 2] = 0;
                          v[e + 240 >> 2] = 0;
                          v[e + 244 >> 2] = 0;
                          v[e + 232 >> 2] = 0;
                          v[e + 236 >> 2] = 0;
                          v[e + 224 >> 2] = 0;
                          v[e + 228 >> 2] = 0;
                          if (s) {
                           break A;
                          }
                          break t;
                         }
                        } else {
                         d = t[wb(g, k) | 0];
                         B: {
                          if ((d | 0) <= (k | 0) | d >>> 0 >= f >>> 0) {
                           break B;
                          }
                          d = w[(i + (d << 5) | 0) + 8 | 0];
                          if (!d) {
                           break B;
                          }
                          f = i + (k << 5) | 0;
                          j = w[f + 8 | 0];
                          if (!j) {
                           t[f + 8 | 0] = d;
                           break B;
                          }
                          f = j - 1 | 0;
                          while (1) {
                           j = _d(h, f & 255);
                           f = Hn(v[j + 28 >> 2]);
                           if ((f | 0) != 255) {
                            continue;
                           }
                           break;
                          }
                          d = d - 1 & 255;
                          v[j + 28 >> 2] = d >>> 0 < 250 ? d + 128 | 0 : 0;
                         }
                         k = k + 1 | 0;
                         continue;
                        }
                        break;
                       }
                       v[31601] = 0;
                       N(624, E | 0, e + 256 | 0);
                       d = v[31601];
                       v[31601] = 0;
                       if ((d | 0) != 1) {
                        g = e + 258 | 0;
                        f = 0;
                        while (1) {
                         if ((f | 0) == 8) {
                          f = 0;
                          v[31601] = 0;
                          j = O(214, e + 212 | 0, x[e + 256 >> 1]) | 0;
                          d = v[31601];
                          v[31601] = 0;
                          if ((d | 0) != 1) {
                           C: {
                            D: {
                             E: {
                              F: {
                               while (1) {
                                if (x[e + 256 >> 1] <= f >>> 0) {
                                 v[31601] = 0;
                                 k = T(625, e + 200 | 0, w[e + 1712 | 0] | w[e + 1713 | 0] << 8, 25288) | 0;
                                 d = v[31601];
                                 v[31601] = 0;
                                 if ((d | 0) == 1) {
                                  break D;
                                 }
                                 l = e + 274 | 0;
                                 h = 0;
                                 break E;
                                }
                                v[31601] = 0;
                                h = Q(189, b | 0) | 0;
                                d = v[31601];
                                v[31601] = 0;
                                if ((d | 0) != 1) {
                                 v[31601] = 0;
                                 d = e + 144 | 0;
                                 R(185, d | 0, b | 0, h << 5);
                                 h = v[31601];
                                 v[31601] = 0;
                                 if ((h | 0) == 1) {
                                  break F;
                                 }
                                 h = gc(e + 68 | 0, d);
                                 jd(bh(v[j >> 2], f), h);
                                 tb(h);
                                 f = f + 1 | 0;
                                 tb(d);
                                 continue;
                                }
                                break;
                               }
                               g = M() | 0;
                               break C;
                              }
                              g = M() | 0;
                              break C;
                             }
                             while (1) {
                              if ((w[e + 1708 | 0] | w[e + 1709 | 0] << 8) >>> 0 <= h >>> 0) {
                               nd(k);
                               Qc(j);
                               break t;
                              }
                              G: {
                               i = h + l | 0;
                               f = w[i | 0];
                               if (f >>> 0 >= x[e + 256 >> 1]) {
                                break G;
                               }
                               d = x[$b(v[Wb(v[a + 484360 >> 2], w[a + 484376 | 0]) >> 2], h) >> 1];
                               if (d >>> 0 >= (w[e + 1712 | 0] | w[e + 1713 | 0] << 8) >>> 0) {
                                break G;
                               }
                               H: {
                                g = $b(v[k >> 2], d);
                                m = x[g >> 1];
                                I: {
                                 if ((m | 0) == 65535) {
                                  u[g >> 1] = f;
                                  break I;
                                 }
                                 if ((f | 0) == (m | 0)) {
                                  break I;
                                 }
                                 v[31601] = 0;
                                 f = O(626, q | 0, d | 0) | 0;
                                 g = v[31601];
                                 v[31601] = 0;
                                 if ((g | 0) == 1) {
                                  break H;
                                 }
                                 if ((f | 0) == 65535) {
                                  break I;
                                 }
                                 H = $b(v[Wb(v[a + 484360 >> 2], w[a + 484376 | 0]) >> 2], h), I = f, u[H >> 1] = I;
                                 d = f;
                                }
                                if (!Ie(v[a + 484344 >> 2], v[a + 484348 >> 2], d)) {
                                 break G;
                                }
                                m = bh(v[j >> 2], w[i | 0]);
                                xc(m);
                                f = v[m >> 2];
                                v[31601] = 0;
                                f = Q(154, f | 0) | 0;
                                i = v[31601];
                                v[31601] = 0;
                                if ((i | 0) == 1) {
                                 break H;
                                }
                                s = f >>> 5 | 0;
                                i = 0;
                                J: while (1) {
                                 f = Vb(v[q >> 2], d);
                                 if (y[f + 12 >> 2] <= i >>> 0) {
                                  break G;
                                 }
                                 g = 0;
                                 f = ld(v[f >> 2], v[v[f + 48 >> 2] + 12 >> 2], i, x[a + 480188 >> 1] - 8 & 65535);
                                 C = i >>> 0 >= s >>> 0;
                                 while (1) {
                                  if ((g | 0) == 8) {
                                   i = i + 1 | 0;
                                   continue J;
                                  }
                                  t[f | 0] = 0;
                                  t[f + 1 | 0] = 0;
                                  t[f + 2 | 0] = 0;
                                  t[f + 3 | 0] = 0;
                                  t[f + 4 | 0] = 0;
                                  t[f + 5 | 0] = 0;
                                  K: {
                                   if (C) {
                                    break K;
                                   }
                                   v[31601] = 0;
                                   O(627, m | 0, e + 68 | 0) | 0;
                                   z = v[31601];
                                   v[31601] = 0;
                                   if ((z | 0) == 1) {
                                    break H;
                                   }
                                   if (t[e + 68 | 0] >= 0) {
                                    break K;
                                   }
                                   t[f | 0] = 61;
                                   t[f + 1 | 0] = w[(e + 240 | 0) + (g << 1) | 0];
                                   z = w[e + 68 | 0] & 31;
                                   t[e + 144 | 0] = z;
                                   if (z) {
                                    Nf(e + 144 | 0, 15);
                                    t[f + 3 | 0] = 20;
                                    t[f + 5 | 0] = w[e + 144 | 0] | 208;
                                   }
                                   t[f + 2 | 0] = 1;
                                   t[f + 4 | 0] = w[e + 69 | 0] + 3 >>> 2;
                                  }
                                  f = f + 6 | 0;
                                  g = g + 1 | 0;
                                  continue;
                                 }
                                }
                               }
                               g = M() | 0;
                               nd(k);
                               break C;
                              }
                              h = h + 1 | 0;
                              continue;
                             }
                            }
                            g = M() | 0;
                           }
                           Qc(j);
                           break s;
                          }
                          g = M() | 0;
                          break s;
                         }
                         h = f << 1;
                         i = h + (e + 240 | 0) | 0;
                         d = x[a + 480192 >> 1] + 1 & 65535;
                         j = a + 900380 | 0;
                         k = x[v[a + 8 >> 2] + 58 >> 1];
                         while (1) {
                          L: {
                           M: {
                            m = d & 65535;
                            if (m >>> 0 <= k >>> 0) {
                             if (v[j + (m << 2) >> 2]) {
                              break M;
                             }
                            } else {
                             d = 65535;
                            }
                            d = d & 65535;
                            break L;
                           }
                           d = d + 1 | 0;
                           continue;
                          }
                          break;
                         }
                         u[i >> 1] = d;
                         j = h + (e + 224 | 0) | 0;
                         h = x[g + h >> 1];
                         u[j >> 1] = h;
                         N: {
                          if ((d | 0) != 65535) {
                           v[31601] = 0;
                           d = T(251, a | 0, d | 0, h + 1 & 65535) | 0;
                           h = v[31601];
                           v[31601] = 0;
                           O: {
                            P: {
                             if ((h | 0) != 1) {
                              if (!d) {
                               break N;
                              }
                              v[31601] = 0;
                              h = e + 144 | 0;
                              N(288, h | 0, 4475);
                              i = v[31601];
                              v[31601] = 0;
                              if ((i | 0) == 1) {
                               break P;
                              }
                              v[31601] = 0;
                              v[e >> 2] = f + 1;
                              i = e + 68 | 0;
                              R(628, i | 0, h | 0, e | 0);
                              j = v[31601];
                              v[31601] = 0;
                              if ((j | 0) == 1) {
                               break O;
                              }
                              zc(d + 492 | 0, i);
                              sb(i);
                              Db(h);
                              break N;
                             }
                             g = M() | 0;
                             break s;
                            }
                            g = M() | 0;
                            break s;
                           }
                           g = M() | 0;
                           Db(e + 144 | 0);
                           break s;
                          }
                          u[i >> 1] = 0;
                         }
                         f = f + 1 | 0;
                         continue;
                        }
                       }
                       g = M() | 0;
                       break s;
                      }
                      g = M() | 0;
                      break s;
                     }
                     v[31601] = 0;
                     h = Q(151, A | 0) | 0;
                     d = v[31601];
                     v[31601] = 0;
                     Q: {
                      R: {
                       S: {
                        T: {
                         U: {
                          V: {
                           W: {
                            X: {
                             Y: {
                              if ((d | 0) != 1) {
                               v[31601] = 0;
                               d = Q(151, A | 0) | 0;
                               f = v[31601];
                               v[31601] = 0;
                               if ((f | 0) == 1) {
                                break Y;
                               }
                               v[31601] = 0;
                               f = e + 256 | 0;
                               R(185, f | 0, A | 0, d | 0);
                               d = v[31601];
                               v[31601] = 0;
                               if ((d | 0) == 1) {
                                break Y;
                               }
                               d = gc(e + 68 | 0, f);
                               tb(f);
                               if ((h | 0) == 4674381) {
                                break U;
                               }
                               if ((h | 0) == 5068115) {
                                break T;
                               }
                               if ((h | 0) == 726487106) {
                                break X;
                               }
                               if ((h | 0) == 844387158) {
                                break S;
                               }
                               f = 0;
                               if ((h | 0) == 1280004692) {
                                break W;
                               }
                               if ((h | 0) == 1314144592) {
                                break V;
                               }
                               if ((h | 0) != 1397445204) {
                                break R;
                               }
                               v[31601] = 0;
                               f = Q(189, d | 0) | 0;
                               h = v[31601];
                               v[31601] = 0;
                               if ((h | 0) == 1) {
                                break v;
                               }
                               f = f >>> 0 < 256 ? 48 : f >>> 8 | 0;
                               v[a + 480228 >> 2] = f;
                               v[a + 480232 >> 2] = f >>> 1;
                               f = 0;
                               while (1) {
                                if (x[a + 480188 >> 1] <= f >>> 0) {
                                 break R;
                                }
                                v[31601] = 0;
                                h = O(629, d | 0, e + 256 | 0) | 0;
                                j = v[31601];
                                v[31601] = 0;
                                if ((j | 0) == 1) {
                                 break y;
                                }
                                if (h) {
                                 u[(i + (f << 5) | 0) + 6 >> 1] = x[e + 256 >> 1] >>> 10;
                                 H = wb(v[r >> 2], f), I = w[e + 259 | 0], t[H | 0] = I;
                                }
                                f = f + 1 | 0;
                                continue;
                               }
                              }
                              g = M() | 0;
                              break s;
                             }
                             g = M() | 0;
                             break s;
                            }
                            if (g & 1) {
                             break R;
                            }
                            t[a + 480224 | 0] = 2;
                            v[31601] = 0;
                            F = +ha(630, d | 0);
                            f = v[31601];
                            v[31601] = 0;
                            if ((f | 0) == 1) {
                             break Q;
                            }
                            if (!(F > 1e-8)) {
                             break R;
                            }
                            H = a, I = Te(2646e3 / (F * +(B(v[a + 480216 >> 2], v[a + 480196 >> 2]) >>> 0)) * 1e4), 
                            v[H + 480204 >> 2] = I;
                            break R;
                           }
                           while (1) {
                            Z: {
                             if (x[a + 480188 >> 1] <= f >>> 0) {
                              break R;
                             }
                             h = v[d >> 2];
                             v[31601] = 0;
                             h = T(150, h | 0, v[e + 76 >> 2], 1) | 0;
                             j = v[31601];
                             v[31601] = 0;
                             if ((j | 0) == 1) {
                              break x;
                             }
                             if (!h) {
                              break R;
                             }
                             h = Eb(e + 256 | 0);
                             v[31601] = 0;
                             R(358, d | 0, h | 0, -1);
                             j = v[31601];
                             v[31601] = 0;
                             if ((j | 0) != 1) {
                              tg(e, 3, Jb(h), Zc(v[e + 260 >> 2], w[e + 267 | 0]));
                              v[31601] = 0;
                              j = e + 144 | 0;
                              N(218, j | 0, e | 0);
                              l = v[31601];
                              v[31601] = 0;
                              if ((l | 0) == 1) {
                               break Z;
                              }
                              em((i + (f << 5) | 0) + 9 | 0, j);
                              sb(j);
                              sb(h);
                              f = f + 1 | 0;
                              continue;
                             }
                            }
                            break;
                           }
                           g = M() | 0;
                           sb(h);
                           break u;
                          }
                          while (1) {
                           if ((w[e + 1712 | 0] | w[e + 1713 | 0] << 8) >>> 0 <= f >>> 0) {
                            break R;
                           }
                           h = v[d >> 2];
                           v[31601] = 0;
                           h = T(150, h | 0, v[e + 76 >> 2], 1) | 0;
                           j = v[31601];
                           v[31601] = 0;
                           if ((j | 0) == 1) {
                            break w;
                           }
                           if (!h) {
                            break R;
                           }
                           if (!An(v[a + 484344 >> 2], v[a + 484348 >> 2], f & 65535)) {
                            break R;
                           }
                           h = Eb(e + 256 | 0);
                           v[31601] = 0;
                           R(358, d | 0, h | 0, -1);
                           j = v[31601];
                           v[31601] = 0;
                           _: {
                            if ((j | 0) == 1) {
                             break _;
                            }
                            j = v[q >> 2];
                            v[31601] = 0;
                            N(283, Vb(j, f) | 0, h | 0);
                            j = v[31601];
                            v[31601] = 0;
                            if ((j | 0) == 1) {
                             break _;
                            }
                            sb(h);
                            f = f + 1 | 0;
                            continue;
                           }
                           break;
                          }
                          g = M() | 0;
                          sb(h);
                          break u;
                         }
                         v[31601] = 0;
                         O(183, d | 0, 1) | 0;
                         f = v[31601];
                         v[31601] = 0;
                         if ((f | 0) == 1) {
                          break v;
                         }
                         v[31601] = 0;
                         f = Q(202, d | 0) | 0;
                         h = v[31601];
                         v[31601] = 0;
                         if ((h | 0) == 1) {
                          break v;
                         }
                         v[31601] = 0;
                         U(336, m | 0, d | 0, f | 0, 2);
                         f = v[31601];
                         v[31601] = 0;
                         if ((f | 0) != 1) {
                          break R;
                         }
                         break v;
                        }
                        v[31601] = 0;
                        O(631, d | 0, e | 0) | 0;
                        f = v[31601];
                        v[31601] = 0;
                        $: {
                         if ((f | 0) != 1) {
                          f = Eb(e + 256 | 0);
                          v[31601] = 0;
                          R(358, d | 0, f | 0, -1);
                          h = v[31601];
                          v[31601] = 0;
                          if ((h | 0) == 1) {
                           break $;
                          }
                          if (!Md(f, 12682)) {
                           v[31601] = 0;
                           h = e + 144 | 0;
                           R(258, h | 0, 22, f | 0);
                           j = v[31601];
                           v[31601] = 0;
                           if ((j | 0) == 1) {
                            break $;
                           }
                           yb(k, h);
                           sb(h);
                          }
                          sb(f);
                          break R;
                         }
                         g = M() | 0;
                         break u;
                        }
                        g = M() | 0;
                        sb(f);
                        break u;
                       }
                       v[31601] = 0;
                       n = Q(151, d | 0) | 0;
                       f = v[31601];
                       v[31601] = 0;
                       if ((f | 0) == 1) {
                        break v;
                       }
                      }
                      tb(d);
                      continue;
                     }
                     break;
                    }
                    g = M() | 0;
                    break u;
                   }
                   g = M() | 0;
                   break u;
                  }
                  g = M() | 0;
                  break u;
                 }
                 g = M() | 0;
                 break u;
                }
                g = M() | 0;
               }
               tb(d);
               break s;
              }
              g = M() | 0;
              break c;
             }
             aa: {
              ba: {
               d = w[e + 1720 | 0] | w[e + 1721 | 0] << 8 | (w[e + 1722 | 0] << 16 | w[e + 1723 | 0] << 24);
               if (!(d & 2)) {
                break ba;
               }
               h = (((d & 8 ? x[a + 480188 >> 1] : o) & 65535) + ((w[e + 1610 | 0] | w[e + 1611 | 0] << 8) >>> 0 > 591 ? n : 0) | 0) + (d >>> 4 & 1) | 0;
               d = 0;
               ca: while (1) {
                f = 0;
                if ((w[e + 1712 | 0] | w[e + 1713 | 0] << 8) >>> 0 <= d >>> 0) {
                 break ba;
                }
                while (1) {
                 da: {
                  if ((f | 0) != (h | 0)) {
                   i = v[b + 8 >> 2];
                   g = v[b >> 2];
                   v[31601] = 0;
                   i = T(150, g | 0, i | 0, 4) | 0;
                   g = v[31601];
                   v[31601] = 0;
                   if ((g | 0) == 1) {
                    break aa;
                   }
                   if (i) {
                    break da;
                   }
                  }
                  d = d + 1 | 0;
                  continue ca;
                 }
                 v[31601] = 0;
                 N(632, w[e + 1610 | 0] | w[e + 1611 | 0] << 8, b | 0);
                 i = v[31601];
                 v[31601] = 0;
                 if ((i | 0) == 1) {
                  break aa;
                 }
                 f = f + 1 | 0;
                 continue;
                }
               }
              }
              v[31601] = 0;
              n = O(214, e + 188 | 0, 255) | 0;
              d = v[31601];
              v[31601] = 0;
              if ((d | 0) != 1) {
               q = e + 76 | 0;
               h = 0;
               while (1) {
                ea: {
                 d = h;
                 fa: {
                  if ((d | 0) == 255) {
                   q = a + 900380 | 0;
                   m = a + 484380 | 0;
                   i = a + 946304 | 0;
                   o = JC(e + 68 | 0);
                   l = JC(e + 144 | 0);
                   g = 0;
                   while (1) {
                    ga: {
                     ha: {
                      ia: {
                       if ((g | 0) == 256) {
                        s = e + 258 | 0;
                        k = 0;
                        break ia;
                       }
                       v[31601] = 0;
                       f = e + 256 | 0;
                       N(633, b | 0, f | 0);
                       d = v[31601];
                       v[31601] = 0;
                       if ((d | 0) == 1) {
                        break ha;
                       }
                       v[31601] = 0;
                       d = Q(151, b | 0) | 0;
                       h = v[31601];
                       v[31601] = 0;
                       ja: {
                        ka: {
                         la: {
                          if ((h | 0) != 1) {
                           v[31601] = 0;
                           R(185, e | 0, b | 0, d | 0);
                           h = v[31601];
                           v[31601] = 0;
                           if ((h | 0) == 1) {
                            break la;
                           }
                           h = gc(e + 40 | 0, e);
                           tb(e);
                           if ((w[e + 1726 | 0] | w[e + 1727 | 0] << 8) >>> 0 > g >>> 0) {
                            j = e + 28 | 0;
                            Ue(j, 2, f);
                            v[31601] = 0;
                            N(218, e | 0, j | 0);
                            f = v[31601];
                            v[31601] = 0;
                            if ((f | 0) == 1) {
                             break ja;
                            }
                            zc((i + (g << 5) | 0) + 32 | 0, e);
                            sb(e);
                           }
                           if (!d) {
                            break ga;
                           }
                           if ((w[e + 1726 | 0] | w[e + 1727 | 0] << 8) >>> 0 > g >>> 0) {
                            break ka;
                           }
                           break ga;
                          }
                          g = M() | 0;
                          break fa;
                         }
                         g = M() | 0;
                         break fa;
                        }
                        v[31601] = 0;
                        d = (m + B(g, 104) | 0) + 104 | 0;
                        N(279, d | 0, 32);
                        f = v[31601];
                        v[31601] = 0;
                        ma: {
                         na: {
                          oa: {
                           if ((f | 0) != 1) {
                            xp(d);
                            v[31601] = 0;
                            N(634, h | 0, e | 0);
                            f = v[31601];
                            v[31601] = 0;
                            if ((f | 0) == 1) {
                             break ja;
                            }
                            j = v[e >> 2];
                            v[d >> 2] = j;
                            v[d + 24 >> 2] = v[e + 4 >> 2];
                            if (w[e + 8 | 0] >= 2) {
                             j = j >>> 1 | 0;
                             v[d >> 2] = j;
                             u[d + 34 >> 1] = x[d + 34 >> 1] | 1;
                            }
                            if (w[e + 9 | 0] >= 2) {
                             v[d >> 2] = j >>> 1;
                             u[d + 34 >> 1] = x[d + 34 >> 1] | 64;
                            }
                            j = 2;
                            switch (w[e + 11 | 0] - 1 | 0) {
                            case 0:
                             break na;

                            case 1:
                             break oa;

                            default:
                             break ma;
                            }
                           }
                           break ja;
                          }
                          j = 6;
                         }
                         u[d + 34 >> 1] = x[d + 34 >> 1] | j;
                        }
                        v[d + 4 >> 2] = v[e + 12 >> 2];
                        v[d + 8 >> 2] = v[e + 16 >> 2];
                        u[d + 30 >> 1] = x[e + 20 >> 1] >>> 7;
                        f = w[e + 22 | 0];
                        pa: {
                         if ((f | 0) == 128) {
                          j = x[d + 34 >> 1] | 256;
                          u[d + 34 >> 1] = j;
                          break pa;
                         }
                         u[d + 28 >> 1] = (f << 24 >> 24) + 128;
                         j = x[d + 34 >> 1];
                        }
                        u[d + 34 >> 1] = j | 32;
                        t[d + 36 | 0] = w[e + 23 | 0];
                        j = w[e + 10 | 0];
                        if (j & 2) {
                         f = e + 28 | 0;
                         Ib(f, l, g);
                         ap(f);
                         j = w[e + 10 | 0];
                        }
                        if (j & 5) {
                         u[d + 34 >> 1] = x[d + 34 >> 1] | 16384;
                        }
                        if (!(j & 8)) {
                         break ga;
                        }
                        d = e + 28 | 0;
                        Ib(d, o, g);
                        ap(d);
                        f = 0;
                        while (1) {
                         if ((f | 0) == 8) {
                          break ga;
                         }
                         d = f << 1;
                         qa: {
                          if (x[d + (e + 224 | 0) >> 1] != (g | 0)) {
                           break qa;
                          }
                          d = v[q + (x[d + (e + 240 | 0) >> 1] << 2) >> 2];
                          if (!d) {
                           break qa;
                          }
                          t[d + 14 | 0] = 0;
                         }
                         f = f + 1 | 0;
                         continue;
                        }
                       }
                       g = M() | 0;
                       tb(h);
                       break fa;
                      }
                      while (1) {
                       ra: {
                        sa: {
                         if ((w[e + 1724 | 0] | w[e + 1725 | 0] << 8) >>> 0 <= k >>> 0) {
                          if (!(c & 2)) {
                           break sa;
                          }
                          g = 0;
                          ta: {
                           ua: {
                            va: {
                             wa: {
                              xa: {
                               ya: {
                                za: {
                                 Aa: {
                                  while (1) {
                                   if (x[a + 480190 >> 1] <= g >>> 0) {
                                    break sa;
                                   }
                                   g = g + 1 | 0;
                                   c = m + B(g, 104) | 0;
                                   Yl(c, (+(t[c + 36 | 0] - 49 | 0) + +t[c + 37 | 0] * -.0078125) / -12);
                                   u[c + 36 >> 1] = 0;
                                   d = x[c + 34 >> 1];
                                   if (!(d & 16384)) {
                                    d = Yc(e + 256 | 0, d & 1 ? 16 : 8, d & 64 ? 3 : 1, 0, 11);
                                    v[31601] = 0;
                                    T(215, d | 0, c | 0, b | 0) | 0;
                                    c = v[31601];
                                    v[31601] = 0;
                                    if ((c | 0) != 1) {
                                     continue;
                                    }
                                    g = M() | 0;
                                    break fa;
                                   }
                                   v[31601] = 0;
                                   f = Q(151, b | 0) | 0;
                                   d = v[31601];
                                   v[31601] = 0;
                                   Ba: {
                                    if ((d | 0) == 1) {
                                     break Ba;
                                    }
                                    v[31601] = 0;
                                    O(183, b | 0, 12) | 0;
                                    d = v[31601];
                                    v[31601] = 0;
                                    if ((d | 0) == 1) {
                                     break Ba;
                                    }
                                    d = Eb(e + 256 | 0);
                                    v[31601] = 0;
                                    R(270, b | 0, d | 0, f | 0);
                                    f = v[31601];
                                    v[31601] = 0;
                                    if ((f | 0) == 1) {
                                     break Aa;
                                    }
                                    Ae(c + 43 | 0, d);
                                    v[31601] = 0;
                                    c = e + 40 | 0;
                                    N(383, c | 0, 16439);
                                    f = v[31601];
                                    v[31601] = 0;
                                    if ((f | 0) == 1) {
                                     break za;
                                    }
                                    v[e + 140 >> 2] = g;
                                    h = v[a + 1298404 >> 2];
                                    v[31601] = 0;
                                    f = e + 28 | 0;
                                    R(635, f | 0, h | 0, d | 0);
                                    h = v[31601];
                                    v[31601] = 0;
                                    if ((h | 0) == 1) {
                                     break ya;
                                    }
                                    v[31601] = 0;
                                    U(430, e | 0, c | 0, e + 140 | 0, f | 0);
                                    h = v[31601];
                                    v[31601] = 0;
                                    if ((h | 0) == 1) {
                                     break xa;
                                    }
                                    h = v[a + 1298472 >> 2];
                                    v[31601] = 0;
                                    R(385, h | 0, 2, e | 0);
                                    h = v[31601];
                                    v[31601] = 0;
                                    if ((h | 0) == 1) {
                                     break wa;
                                    }
                                    sb(e);
                                    sb(f);
                                    Db(c);
                                    sb(d);
                                    continue;
                                   }
                                   break;
                                  }
                                  g = M() | 0;
                                  break fa;
                                 }
                                 g = M() | 0;
                                 break ta;
                                }
                                g = M() | 0;
                                break ta;
                               }
                               g = M() | 0;
                               break ua;
                              }
                              g = M() | 0;
                              break va;
                             }
                             g = M() | 0;
                             sb(e);
                            }
                            sb(e + 28 | 0);
                           }
                           Db(e + 40 | 0);
                          }
                          sb(d);
                          break fa;
                         }
                         d = v[bh(v[n >> 2], k) >> 2];
                         v[31601] = 0;
                         d = Q(154, d | 0) | 0;
                         f = v[31601];
                         v[31601] = 0;
                         Ca: {
                          Da: {
                           if ((f | 0) != 1) {
                            if (!d) {
                             k = k + 1 | 0;
                             continue;
                            }
                            d = bh(v[n >> 2], k);
                            xc(d);
                            v[31601] = 0;
                            N(636, d | 0, e + 256 | 0);
                            d = v[31601];
                            v[31601] = 0;
                            if ((d | 0) == 1) {
                             break Da;
                            }
                            i = Mb(e);
                            v[31601] = 0;
                            R(637, b | 0, i | 0, x[e + 256 >> 1]);
                            d = v[31601];
                            v[31601] = 0;
                            if ((d | 0) == 1) {
                             break Ca;
                            }
                            k = k + 1 | 0;
                            d = v[q + (k << 2) >> 2];
                            if (!d | w[d + 34 | 0]) {
                             break ra;
                            }
                            v[d + 4 >> 2] = 32;
                            f = 0;
                            Ov(d, 0);
                            C = d + 108 | 0;
                            z = d + 236 | 0;
                            while (1) {
                             if ((f | 0) == 96) {
                              break ra;
                             }
                             h = w[f + s | 0];
                             Ea: {
                              if (h >>> 0 >= x[e + 256 >> 1]) {
                               break Ea;
                              }
                              g = Se(v[i >> 2], h);
                              D = f + 12 | 0;
                              G = $b(z, D);
                              h = w[g | 0];
                              j = h + 1 | 0;
                              u[G >> 1] = j;
                              if (h >>> 0 >= x[a + 480190 >> 1]) {
                               break Ea;
                              }
                              h = m + B(j, 104) | 0;
                              t[h + 38 | 0] = w[e + 354 | 0] & 3;
                              t[h + 39 | 0] = w[e + 355 | 0];
                              t[h + 40 | 0] = w[e + 356 | 0];
                              t[h + 41 | 0] = w[e + 357 | 0];
                              u[h + 32 >> 1] = w[g + 1 | 0] << 1;
                              t[h + 37 | 0] = w[g + 2 | 0];
                              h = j - 1 | 0;
                              Ib(e + 40 | 0, o, h);
                              if (Fb(v[v[e + 40 >> 2] >> 2], v[e + 44 >> 2])) {
                               t[d + 14 | 0] = 0;
                              }
                              Ib(e + 40 | 0, l, h);
                              if (!Fb(v[v[e + 40 >> 2] >> 2], v[e + 44 >> 2])) {
                               break Ea;
                              }
                              H = wb(C, D), I = 61, t[H | 0] = I;
                             }
                             f = f + 1 | 0;
                             continue;
                            }
                           }
                           g = M() | 0;
                           break fa;
                          }
                          g = M() | 0;
                          break fa;
                         }
                         g = M() | 0;
                         Be(i);
                         break fa;
                        }
                        Qc(n);
                        ec(r);
                        tb(A);
                        tb(E);
                        f = 1;
                        break g;
                       }
                       Be(i);
                       continue;
                      }
                     }
                     g = M() | 0;
                     break fa;
                    }
                    tb(h);
                    g = g + 1 | 0;
                    continue;
                   }
                  }
                  v[31601] = 0;
                  N(633, b | 0, e + 144 | 0);
                  f = v[31601];
                  v[31601] = 0;
                  Fa: {
                   Ga: {
                    Ha: {
                     Ia: {
                      if ((f | 0) != 1) {
                       v[31601] = 0;
                       f = Q(151, b | 0) | 0;
                       h = v[31601];
                       v[31601] = 0;
                       if ((h | 0) == 1) {
                        break Ia;
                       }
                       v[31601] = 0;
                       i = e + 68 | 0;
                       f = (f | 0) == 32 ? 428 : f;
                       g = f ? (w[e + 1610 | 0] | w[e + 1611 | 0] << 8) >>> 0 > 513 ? f + 4 | 0 : f : f;
                       R(185, i | 0, b | 0, g | 0);
                       f = v[31601];
                       v[31601] = 0;
                       if ((f | 0) == 1) {
                        break Ha;
                       }
                       f = gc(e + 256 | 0, i);
                       j = Ge(e, jd(bh(v[n >> 2], d), f));
                       tb(f);
                       h = d + 1 | 0;
                       tb(i);
                       if (d >>> 0 >= (w[e + 1724 | 0] | w[e + 1725 | 0] << 8) >>> 0) {
                        break ea;
                       }
                       v[31601] = 0;
                       d = h & 65535;
                       i = T(251, a | 0, d | 0, d | 0) | 0;
                       d = v[31601];
                       v[31601] = 0;
                       if ((d | 0) != 1) {
                        break Ga;
                       }
                       break Fa;
                      }
                      g = M() | 0;
                      break fa;
                     }
                     g = M() | 0;
                     break fa;
                    }
                    g = M() | 0;
                    break fa;
                   }
                   if (!i) {
                    break ea;
                   }
                   f = e + 68 | 0;
                   Ue(f, 2, e + 144 | 0);
                   v[31601] = 0;
                   d = e + 256 | 0;
                   N(218, d | 0, f | 0);
                   f = v[31601];
                   v[31601] = 0;
                   Ja: {
                    if ((f | 0) != 1) {
                     zc(i + 492 | 0, d);
                     sb(d);
                     if (!g) {
                      break ea;
                     }
                     v[31601] = 0;
                     N(636, j | 0, d | 0);
                     d = v[31601];
                     v[31601] = 0;
                     Ka: {
                      if ((d | 0) != 1) {
                       d = 3;
                       k = 0;
                       if ((w[e + 1610 | 0] | w[e + 1611 | 0] << 8) >>> 0 >= 513) {
                        break Ka;
                       }
                       m = 0;
                       break Ja;
                      }
                      break Fa;
                     }
                     v[31601] = 0;
                     m = Q(189, j | 0) | 0;
                     f = v[31601];
                     v[31601] = 0;
                     if ((f | 0) == 1) {
                      break Fa;
                     }
                     if ((w[e + 1610 | 0] | w[e + 1611 | 0] << 8) >>> 0 < 514) {
                      break Ja;
                     }
                     v[31601] = 0;
                     d = Q(151, j | 0) | 0;
                     f = v[31601];
                     v[31601] = 0;
                     if ((f | 0) != 1) {
                      break Ja;
                     }
                     break Fa;
                    }
                    break Fa;
                   }
                   v[i >> 2] = w[e + 358 | 0] | w[e + 359 | 0] << 8;
                   t[e + 40 | 0] = 0;
                   t[e + 41 | 0] = 1;
                   t[e + 42 | 0] = 2;
                   t[e + 43 | 0] = 3;
                   t[e + 28 | 0] = 0;
                   t[e + 29 | 0] = 1;
                   t[e + 30 | 0] = 2;
                   t[e + 31 | 0] = 3;
                   t[e + 140 | 0] = 0;
                   t[e + 141 | 0] = 2;
                   t[e + 142 | 0] = 1;
                   t[e + 143 | 0] = 2;
                   t[i + 16 | 0] = w[(e + 40 | 0) + ((w[e + 360 | 0] | w[e + 361 | 0] << 8) & 3) | 0];
                   t[i + 17 | 0] = w[(e + 28 | 0) + (w[e + 361 | 0] & 3) | 0];
                   t[i + 18 | 0] = w[(e + 140 | 0) + ((w[e + 360 | 0] | w[e + 361 | 0] << 8) >>> 12 & 3) | 0];
                   while (1) {
                    La: {
                     Ma: {
                      if ((k | 0) == 4) {
                       if (!(t[i + 60 | 0] & 1 | w[i + 16 | 0] == 3)) {
                        v[i >> 2] = 32767;
                       }
                       bk(i, 127, 1);
                       ak(i, 0, 1);
                       if (!m) {
                        break ea;
                       }
                       v[31601] = 0;
                       N(638, j | 0, e + 68 | 0);
                       d = v[31601];
                       v[31601] = 0;
                       if ((d | 0) == 1) {
                        break Fa;
                       }
                       if (m & 2) {
                        bk(i, KD(v[a + 480208 >> 2], +((w[e + 70 | 0] | w[e + 71 | 0] << 8) >>> 0)), 1);
                        ak(i, w[e + 72 | 0], 1);
                       }
                       t[i + 25 | 0] = w[e + 69 | 0] == 1;
                       if (!(m & 4)) {
                        break ea;
                       }
                       t[i + 31 | 0] = w[e + 75 | 0] + 1;
                       d = t[e + 76 | 0];
                       t[i + 34 | 0] = d + 1;
                       if ((d | 0) < 0) {
                        t[i + 30 | 0] = w[e + 83 | 0] + 1;
                       }
                       if (!w[e + 80 | 0]) {
                        break Ma;
                       }
                       g = i + 108 | 0;
                       f = 0;
                       while (1) {
                        if ((f | 0) == 128) {
                         break Ma;
                        }
                        d = f + 1 | 0;
                        v[e + 64 >> 2] = d + t[e + 80 | 0];
                        AX(e - -64 | 0);
                        H = wb(g, f), I = v[e + 64 >> 2], t[H | 0] = I;
                        f = d;
                        continue;
                       }
                      }
                      if (!(d & 1)) {
                       break La;
                      }
                      v[31601] = 0;
                      N(639, j | 0, e + 68 | 0);
                      f = v[31601];
                      v[31601] = 0;
                      if ((f | 0) == 1) {
                       break Fa;
                      }
                      t[e + 64 | 0] = 0;
                      t[e + 65 | 0] = 1;
                      t[e + 66 | 0] = 2;
                      t[e + 67 | 0] = 2;
                      g = Vh(i, w[(e - -64 | 0) + k | 0]);
                      f = w[e + 68 | 0];
                      o = f & 1;
                      t[g + 12 | 0] = w[g + 12 | 0] & 232 | ((k | 0) == 3 ? 0 - o & 16 : 0) | f << 1 & 4 | f >>> 1 & 2 | o;
                      t[e + 63 | 0] = w[e + 69 | 0];
                      t[e + 62 | 0] = 16;
                      f = w[Pb(e + 63 | 0, e + 62 | 0) | 0];
                      v[31601] = 0;
                      N(293, g | 0, f | 0);
                      f = v[31601];
                      v[31601] = 0;
                      if ((f | 0) != 1) {
                       f = w[e + 70 | 0];
                       t[g + 15 | 0] = f;
                       t[g + 16 | 0] = f;
                       t[g + 13 | 0] = w[e + 71 | 0];
                       t[g + 14 | 0] = w[e + 72 | 0];
                       f = 0;
                       o = v[g >> 2];
                       l = Rd(o, v[g + 4 >> 2]);
                       while (1) {
                        if ((f | 0) == (l | 0)) {
                         break La;
                        }
                        s = xb(o, f);
                        g = q + (f << 2) | 0;
                        u[s >> 1] = w[g | 0] | w[g + 1 | 0] << 8;
                        H = s, I = Kd(w[g + 2 | 0] | w[g + 3 | 0] << 8, 0, 64), t[H + 2 | 0] = I;
                        f = f + 1 | 0;
                        continue;
                       }
                      }
                      break Fa;
                     }
                     Ov(i, 0);
                     break ea;
                    }
                    k = k + 1 | 0;
                    d = d >>> 1 | 0;
                    continue;
                   }
                  }
                  g = M() | 0;
                  tb(j);
                 }
                 Qc(n);
                 break s;
                }
                tb(j);
                continue;
               }
              }
              g = M() | 0;
              break s;
             }
             g = M() | 0;
            }
            ec(r);
            break c;
           }
           while (1) {
            d = v[n >> 2];
            v[31601] = 0;
            d = T(150, d | 0, v[e + 264 >> 2], 1) | 0;
            i = v[31601];
            v[31601] = 0;
            Na: {
             if ((i | 0) != 1) {
              if (!d) {
               break m;
              }
              v[31601] = 0;
              j = Q(197, n | 0) | 0;
              d = v[31601];
              v[31601] = 0;
              if ((d | 0) == 1) {
               break f;
              }
              m = 0;
              if ((j | 0) != 255) {
               break Na;
              }
              v[31601] = 0;
              m = Q(197, n | 0) | 0;
              d = v[31601];
              v[31601] = 0;
              if ((d | 0) != 1) {
               v[31601] = 0;
               j = Q(197, n | 0) | 0;
               d = v[31601];
               v[31601] = 0;
               if ((d | 0) != 1) {
                break Na;
               }
              }
              break f;
             }
             break f;
            }
            if (j & 127) {
             d = Vb(v[q >> 2], h);
             i = ld(v[d >> 2], v[v[d + 48 >> 2] + 12 >> 2], f, k & 65535);
             FE(e + 68 | 0);
             if (j & 1) {
              v[31601] = 0;
              d = Q(197, n | 0) | 0;
              l = v[31601];
              v[31601] = 0;
              if ((l | 0) == 1) {
               break l;
              }
              t[e + 68 | 0] = d;
             }
             if (j & 2) {
              v[31601] = 0;
              d = Q(197, n | 0) | 0;
              l = v[31601];
              v[31601] = 0;
              if ((l | 0) == 1) {
               break l;
              }
              t[e + 69 | 0] = d;
             }
             if (j & 4) {
              v[31601] = 0;
              d = Q(197, n | 0) | 0;
              l = v[31601];
              v[31601] = 0;
              if ((l | 0) == 1) {
               break l;
              }
              t[e + 70 | 0] = d;
             }
             if (j & 8) {
              v[31601] = 0;
              d = Q(197, n | 0) | 0;
              l = v[31601];
              v[31601] = 0;
              if ((l | 0) == 1) {
               break l;
              }
              t[e + 71 | 0] = d;
             }
             if (j & 16) {
              v[31601] = 0;
              d = Q(197, n | 0) | 0;
              l = v[31601];
              v[31601] = 0;
              if ((l | 0) == 1) {
               break l;
              }
              t[e + 72 | 0] = d;
             }
             if (j & 32) {
              v[31601] = 0;
              d = Q(197, n | 0) | 0;
              l = v[31601];
              v[31601] = 0;
              if ((l | 0) == 1) {
               break l;
              }
              t[e + 73 | 0] = d;
             }
             if (j & 64) {
              v[31601] = 0;
              d = Q(197, n | 0) | 0;
              j = v[31601];
              v[31601] = 0;
              if ((j | 0) == 1) {
               break l;
              }
              t[e + 74 | 0] = d;
             }
             z = CX(i, e + 68 | 0);
             v[e + 144 >> 2] = m;
             v[e + 40 >> 2] = r + (f ^ -1);
             D = v[Gb(e + 144 | 0, e + 40 | 0) >> 2];
             j = 0;
             d = i;
             while (1) {
              if ((j | 0) != (D | 0)) {
               d = B(x[a + 480188 >> 1], 6) + d | 0;
               l = w[i | 0] | w[i + 1 | 0] << 8 | (w[i + 2 | 0] << 16 | w[i + 3 | 0] << 24);
               t[d | 0] = l;
               t[d + 1 | 0] = l >>> 8;
               t[d + 2 | 0] = l >>> 16;
               t[d + 3 | 0] = l >>> 24;
               l = w[i + 4 | 0] | w[i + 5 | 0] << 8;
               t[d + 4 | 0] = l;
               t[d + 5 | 0] = l >>> 8;
               j = j + 1 | 0;
               continue;
              }
              break;
             }
             g = g | z;
            }
            f = (f + m | 0) + 1 | 0;
            while (1) {
             if (f >>> 0 >= r >>> 0) {
              k = k + 1 | 0;
              f = f - r | 0;
              continue;
             }
             break;
            }
            if (o >>> 0 > (k & 65535) >>> 0) {
             continue;
            }
            break;
           }
          }
          tb(n);
          h = h + 1 | 0;
          continue;
         }
         break;
        }
        break f;
       }
       eb = e + 1728 | 0;
       return f | 0;
      }
      g = M() | 0;
      tb(n);
      break c;
     }
     g = M() | 0;
     break c;
    }
    g = M() | 0;
   }
   tb(A);
  }
  tb(E);
 }
 P(g | 0);
 p();
}

function fta(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, q = 0, r = 0, s = 0, z = 0, A = 0, C = 0, D = 0, E = 0, F = 0, G = 0, H = 0;
 e = eb - 240 | 0;
 eb = e;
 xc(b);
 f = eb - 16 | 0;
 eb = f;
 g = e + 218 | 0;
 cw(f + 8 | 0, g);
 h = v[f + 12 >> 2];
 ic(f, v[b >> 2], v[b + 8 >> 2], v[f + 8 >> 2], v[f + 12 >> 2]);
 m = v[f + 4 >> 2];
 if ((m | 0) == (h | 0)) {
  Ub(b, v[f + 12 >> 2]);
 }
 eb = f + 16 | 0;
 f = (h | 0) == (m | 0);
 if (!f) {
  L_(g);
 }
 a: {
  b: {
   c: {
    d: {
     e: {
      f: {
       g: {
        h: {
         i: {
          j: {
           k: {
            l: {
             m: {
              n: {
               if (!f) {
                break n;
               }
               if (!M_(g)) {
                break n;
               }
               d = 1;
               if ((c | 0) == 64) {
                break n;
               }
               Cd(a, 1024);
               dg(a);
               v[a + 480208 >> 2] = v[a + 480208 >> 2] | 12;
               ag(a + 1074312 | 0, 21);
               d = Ab(w[e + 234 | 0] | w[e + 235 | 0] << 8);
               if (d) {
                v[a + 480204 >> 2] = B(d, 1e4);
               }
               d = Ab(w[e + 232 | 0] | w[e + 233 | 0] << 8);
               if (d) {
                v[a + 480196 >> 2] = d;
               }
               if (!w[e + 228 | 0]) {
                Th(a, 1);
               }
               xE(b, a + 1298308 | 0, _b(w[e + 222 | 0] | w[e + 223 | 0] << 8 | (w[e + 224 | 0] << 16 | w[e + 225 | 0] << 24)) - 14 | 0);
               d = e + 112 | 0;
               b = Ge(d, b);
               v[31601] = 0;
               f = e + 204 | 0;
               N(346, f | 0, b | 0);
               g = v[31601];
               v[31601] = 0;
               o: {
                p: {
                 q: {
                  r: {
                   s: {
                    t: {
                     u: {
                      v: {
                       w: {
                        x: {
                         y: {
                          z: {
                           if ((g | 0) != 1) {
                            tb(b);
                            v[31601] = 0;
                            R(347, d | 0, f | 0, 1395544366);
                            b = v[31601];
                            v[31601] = 0;
                            if ((b | 0) == 1) {
                             break s;
                            }
                            v[31601] = 0;
                            b = Q(277, v[e + 112 >> 2]) | 0;
                            f = v[31601];
                            v[31601] = 0;
                            if ((f | 0) == 1) {
                             break y;
                            }
                            if (!b) {
                             break r;
                            }
                            v[31601] = 0;
                            b = Q(273, d | 0) | 0;
                            f = v[31601];
                            v[31601] = 0;
                            if ((f | 0) == 1) {
                             break y;
                            }
                            v[31601] = 0;
                            f = Q(273, d | 0) | 0;
                            g = v[31601];
                            v[31601] = 0;
                            A: {
                             if ((g | 0) == 1) {
                              break A;
                             }
                             v[31601] = 0;
                             O(183, d | 0, 4) | 0;
                             g = v[31601];
                             v[31601] = 0;
                             if ((g | 0) == 1) {
                              break A;
                             }
                             g = w[a + 484376 | 0];
                             h = v[a + 484360 >> 2];
                             v[31601] = 0;
                             $(348, Wb(h, g) | 0, d | 0, b | 0, 65535, 65535);
                             b = v[31601];
                             v[31601] = 0;
                             if ((b | 0) != 1) {
                              break z;
                             }
                            }
                            break y;
                           }
                           d = M() | 0;
                           tb(b);
                           break a;
                          }
                          $e(Wb(v[a + 484360 >> 2], w[a + 484376 | 0]), f);
                          f = e + 112 | 0;
                          tb(f);
                          v[31601] = 0;
                          R(347, f | 0, e + 204 | 0, 1346458708);
                          b = v[31601];
                          v[31601] = 0;
                          if ((b | 0) == 1) {
                           break x;
                          }
                          v[31601] = 0;
                          g = Q(277, v[e + 112 >> 2]) | 0;
                          b = v[31601];
                          v[31601] = 0;
                          if ((b | 0) == 1) {
                           break w;
                          }
                          d = 0;
                          b = 0;
                          if (!g) {
                           break t;
                          }
                          v[31601] = 0;
                          g = Q(273, f | 0) | 0;
                          h = v[31601];
                          v[31601] = 0;
                          if ((h | 0) == 1) {
                           break w;
                          }
                          u[a + 480188 >> 1] = g;
                          if ((g - 33 & 65535) >>> 0 < 65504) {
                           break t;
                          }
                          v[31601] = 0;
                          b = Q(273, f | 0) | 0;
                          n = v[31601];
                          v[31601] = 0;
                          if ((n | 0) == 1) {
                           break w;
                          }
                          v[31601] = 0;
                          N(223, a + 484344 | 0, b | 0);
                          b = v[31601];
                          v[31601] = 0;
                          if ((b | 0) == 1) {
                           break w;
                          }
                          b = 0;
                          v[31601] = 0;
                          n = Q(281, f | 0) | 0;
                          f = v[31601];
                          v[31601] = 0;
                          if ((f | 0) == 1) {
                           break w;
                          }
                          switch (n - 841887796 | 0) {
                          case 1:
                           break t;

                          case 0:
                          case 2:
                           break u;

                          default:
                           break v;
                          }
                         }
                         d = M() | 0;
                         tb(e + 112 | 0);
                         break b;
                        }
                        d = M() | 0;
                        break b;
                       }
                       d = M() | 0;
                       tb(e + 112 | 0);
                       break b;
                      }
                      if (n) {
                       break t;
                      }
                     }
                     b = 1;
                    }
                    f = e + 112 | 0;
                    tb(f);
                    if (!b) {
                     break o;
                    }
                    v[31601] = 0;
                    d = e + 184 | 0;
                    R(347, d | 0, e + 204 | 0, 1398157625);
                    b = v[31601];
                    v[31601] = 0;
                    if ((b | 0) == 1) {
                     break d;
                    }
                    v[31601] = 0;
                    b = Q(277, v[e + 184 >> 2]) | 0;
                    g = v[31601];
                    v[31601] = 0;
                    if ((g | 0) == 1) {
                     break c;
                    }
                    if (!b) {
                     break q;
                    }
                    v[31601] = 0;
                    O(183, d | 0, 2) | 0;
                    b = v[31601];
                    v[31601] = 0;
                    if ((b | 0) == 1) {
                     break c;
                    }
                    v[31601] = 0;
                    b = Q(281, d | 0) | 0;
                    g = v[31601];
                    v[31601] = 0;
                    if ((g | 0) == 1) {
                     break c;
                    }
                    G = a, H = Te((+(b >>> 0) * 2.3283064365386963e-10 + +(y[a + 480204 >> 2] / 1e4 >>> 0)) * 1e4), 
                    v[G + 480204 >> 2] = H;
                    b = 0;
                    v[31601] = 0;
                    O(349, d | 0, f | 0) | 0;
                    d = v[31601];
                    v[31601] = 0;
                    if ((d | 0) == 1) {
                     break c;
                    }
                    f = a + 480280 | 0;
                    g = x[a + 480188 >> 1];
                    while (1) {
                     if ((b | 0) != 32 & (b | 0) != (g | 0)) {
                      G = e, H = Ab(x[(e + 112 | 0) + (b << 1) >> 1]), v[G + 48 >> 2] = H;
                      v[e + 32 >> 2] = 180;
                      d = v[Bd(e + 48 | 0, e + 32 | 0) >> 2];
                      m = d >> 31 << 7 | d >>> 25;
                      d = d << 7;
                      G = f + (b << 5) | 0, H = Fc(Bua(d - 11475 | 0, m - (d >>> 0 < 11475) | 0, 90, 0), gb) + 128 | 0, 
                      u[G + 4 >> 1] = H;
                      b = b + 1 | 0;
                      continue;
                     } else {
                      B: {
                       v[31601] = 0;
                       O(183, e + 184 | 0, 16) | 0;
                       b = v[31601];
                       v[31601] = 0;
                       if ((b | 0) != 1) {
                        break B;
                       }
                       break c;
                      }
                     }
                     break;
                    }
                    v[31601] = 0;
                    b = T(150, v[e + 184 >> 2], v[e + 192 >> 2], 2) | 0;
                    d = v[31601];
                    v[31601] = 0;
                    if ((d | 0) == 1) {
                     break c;
                    }
                    C: {
                     if (b) {
                      v[31601] = 0;
                      b = Q(273, e + 184 | 0) | 0;
                      d = v[31601];
                      v[31601] = 0;
                      if ((d | 0) == 1) {
                       break C;
                      }
                      u[e + 48 >> 1] = b;
                      u[e + 32 >> 1] = 256;
                      G = a, H = x[Nc(e + 48 | 0, e + 32 | 0) >> 1], v[G + 480200 >> 2] = H;
                     }
                     v[31601] = 0;
                     b = e + 184 | 0;
                     O(183, b | 0, 128) | 0;
                     d = v[31601];
                     v[31601] = 0;
                     if ((d | 0) == 1) {
                      break c;
                     }
                     v[31601] = 0;
                     b = O(349, b | 0, e + 48 | 0) | 0;
                     d = v[31601];
                     v[31601] = 0;
                     if ((d | 0) != 1) {
                      if (!b) {
                       break q;
                      }
                      d = x[a + 480188 >> 1];
                      b = 0;
                      while (1) if ((b | 0) != 32 & (b | 0) != (d | 0)) {
                       G = e, H = Ab(x[(e + 48 | 0) + (b << 1) >> 1]), v[G + 32 >> 2] = H;
                       v[e + 20 >> 2] = 128;
                       G = f + (b << 5) | 0, H = v[Bd(e + 32 | 0, e + 20 | 0) >> 2] / 2 & 255, u[G + 6 >> 1] = H;
                       b = b + 1 | 0;
                       continue;
                      } else {
                       v[a + 480228 >> 2] = v[a + 480228 >> 2] << 1;
                       break q;
                      }
                     }
                     break c;
                    }
                    break c;
                   }
                   d = M() | 0;
                   break b;
                  }
                  tb(e + 112 | 0);
                  break p;
                 }
                 tb(e + 184 | 0);
                 v[31601] = 0;
                 b = e + 112 | 0;
                 R(347, b | 0, e + 204 | 0, 1413830740);
                 d = v[31601];
                 v[31601] = 0;
                 D: {
                  E: {
                   if ((d | 0) != 1) {
                    v[31601] = 0;
                    d = Q(277, v[e + 112 >> 2]) | 0;
                    f = v[31601];
                    v[31601] = 0;
                    if ((f | 0) == 1) {
                     break e;
                    }
                    if (!d) {
                     break D;
                    }
                    v[31601] = 0;
                    N(350, b | 0, e + 48 | 0);
                    d = v[31601];
                    v[31601] = 0;
                    if ((d | 0) == 1) {
                     break e;
                    }
                    if ((Ab(w[e + 58 | 0] | w[e + 59 | 0] << 8) | 0) != 65535) {
                     break E;
                    }
                    v[31601] = 0;
                    O(183, b | 0, 1) | 0;
                    b = v[31601];
                    v[31601] = 0;
                    if ((b | 0) != 1) {
                     break E;
                    }
                    break e;
                   }
                   d = M() | 0;
                   break b;
                  }
                  v[31601] = 0;
                  b = e + 112 | 0;
                  d = Q(202, b | 0) | 0;
                  f = v[31601];
                  v[31601] = 0;
                  if ((f | 0) == 1) {
                   break e;
                  }
                  v[31601] = 0;
                  U(336, a + 1298332 | 0, b | 0, d | 0, 2);
                  b = v[31601];
                  v[31601] = 0;
                  if ((b | 0) == 1) {
                   break e;
                  }
                 }
                 tb(e + 112 | 0);
                 v[31601] = 0;
                 b = e + 48 | 0;
                 R(347, b | 0, e + 204 | 0, 1229869908);
                 d = v[31601];
                 v[31601] = 0;
                 if ((d | 0) == 1) {
                  break h;
                 }
                 v[31601] = 0;
                 d = Q(277, v[e + 48 >> 2]) | 0;
                 f = v[31601];
                 v[31601] = 0;
                 if ((f | 0) == 1) {
                  break l;
                 }
                 F: {
                  if (!d) {
                   break F;
                  }
                  v[31601] = 0;
                  b = Q(273, b | 0) | 0;
                  d = v[31601];
                  v[31601] = 0;
                  if ((d | 0) == 1) {
                   break i;
                  }
                  G: {
                   H: {
                    b = b << 16 >> 16;
                    f = b & 32767;
                    if (f >>> 0 > 3999) {
                     break H;
                    }
                    v[31601] = 0;
                    d = T(150, v[e + 48 >> 2], v[e + 56 >> 2], B(f, (b >>> 14 & 2) + 50 | 0) | 0) | 0;
                    g = v[31601];
                    v[31601] = 0;
                    if ((g | 0) == 1) {
                     break g;
                    }
                    if (!d) {
                     break H;
                    }
                    u[a + 480190 >> 1] = f;
                    m = a + 946304 | 0;
                    g = a + 484380 | 0;
                    h = a + 480190 | 0;
                    k = e + 130 | 0;
                    l = (b | 0) >= 0;
                    b = 1;
                    I: {
                     J: {
                      K: {
                       L: {
                        while (1) {
                         if (f >>> 0 < (b & 65535) >>> 0) {
                          v[31601] = 0;
                          b = Q(273, e + 48 | 0) | 0;
                          d = v[31601];
                          v[31601] = 0;
                          if ((d | 0) != 1) {
                           break I;
                          }
                          break g;
                         }
                         M: {
                          if (l) {
                           i = b;
                          } else {
                           v[31601] = 0;
                           d = Q(273, e + 48 | 0) | 0;
                           j = v[31601];
                           v[31601] = 0;
                           if ((j | 0) == 1) {
                            break M;
                           }
                           i = d + 1 | 0;
                          }
                          u[e + 20 >> 1] = i;
                          v[31601] = 0;
                          d = e + 112 | 0;
                          N(351, e + 48 | 0, d | 0);
                          j = v[31601];
                          v[31601] = 0;
                          if ((j | 0) == 1) {
                           break L;
                          }
                          j = x[e + 20 >> 1];
                          if ((j - 4e3 & 65535) >>> 0 >= 61537) {
                           G = h, H = x[qe(h, e + 20 | 0) >> 1], u[G >> 1] = H;
                           q = w[e + 236 | 0] | w[e + 237 | 0] << 8 | (w[e + 238 | 0] << 16 | w[e + 239 | 0] << 24);
                           v[31601] = 0;
                           U(352, d | 0, g + B(j, 104) | 0, _b(q) | 0, n | 0);
                           d = v[31601];
                           v[31601] = 0;
                           if ((d | 0) == 1) {
                            break K;
                           }
                           j = e + 32 | 0;
                           Pk(j, 2, k);
                           v[31601] = 0;
                           d = e + 184 | 0;
                           N(218, d | 0, j | 0);
                           j = v[31601];
                           v[31601] = 0;
                           if ((j | 0) == 1) {
                            break J;
                           }
                           zc(m + (x[e + 20 >> 1] << 5) | 0, d);
                           sb(d);
                          }
                          b = b + 1 | 0;
                          continue;
                         }
                         break;
                        }
                        d = M() | 0;
                        break f;
                       }
                       d = M() | 0;
                       break f;
                      }
                      d = M() | 0;
                      break f;
                     }
                     d = M() | 0;
                     break f;
                    }
                    if ((b | 0) != 4) {
                     break F;
                    }
                    u[e + 112 >> 1] = x[a + 480190 >> 1];
                    u[e + 184 >> 1] = 255;
                    b = e + 184 | 0;
                    G = a, H = x[Nc(e + 112 | 0, b) >> 1], u[G + 480192 >> 1] = H;
                    v[31601] = 0;
                    R(347, b | 0, e + 204 | 0, 1229278806);
                    b = v[31601];
                    v[31601] = 0;
                    if ((b | 0) == 1) {
                     break j;
                    }
                    m = e + 114 | 0;
                    N: while (1) {
                     O: {
                      v[31601] = 0;
                      b = T(150, v[e + 48 >> 2], v[e + 56 >> 2], 15) | 0;
                      d = v[31601];
                      v[31601] = 0;
                      if ((d | 0) == 1) {
                       break O;
                      }
                      if (!b) {
                       break G;
                      }
                      v[31601] = 0;
                      N(353, e + 48 | 0, e + 32 | 0);
                      b = v[31601];
                      v[31601] = 0;
                      if ((b | 0) == 1) {
                       break k;
                      }
                      b = Ab(x[e + 32 >> 1]);
                      if (b >>> 0 >= x[a + 480192 >> 1]) {
                       continue;
                      }
                      d = g + B(b, 104) | 0;
                      t[d + 144 | 0] = w[e + 40 | 0];
                      f = w[e + 39 | 0];
                      t[d + 143 | 0] = 255;
                      t[d + 145 | 0] = f;
                      v[31601] = 0;
                      b = b + 1 & 65535;
                      d = T(251, a | 0, b | 0, b | 0) | 0;
                      b = v[31601];
                      v[31601] = 0;
                      if ((b | 0) == 1) {
                       break k;
                      }
                      if (!d) {
                       continue;
                      }
                      G = e, H = Ab(w[e + 37 | 0] | w[e + 38 | 0] << 8), u[G + 112 >> 1] = H;
                      u[e + 20 >> 1] = 4095;
                      b = e + 112 | 0;
                      f = e + 20 | 0;
                      G = d, H = x[Nc(b, f) >> 1], v[G >> 2] = H;
                      h = w[e + 35 | 0];
                      if ((h | 0) == 255) {
                       continue;
                      }
                      v[31601] = 0;
                      k = e + 184 | 0;
                      h = O(149, k | 0, B(h, 34) + 2 | 0) | 0;
                      l = v[31601];
                      v[31601] = 0;
                      if ((l | 0) == 1) {
                       break k;
                      }
                      if (!h) {
                       continue;
                      }
                      v[31601] = 0;
                      N(354, k | 0, b | 0);
                      b = v[31601];
                      v[31601] = 0;
                      if ((b | 0) == 1) {
                       break k;
                      }
                      t[d + 60 | 0] = w[d + 60 | 0] | 1;
                      b = x[e + 112 >> 1];
                      v[e + 24 >> 2] = 16;
                      v[e + 28 >> 2] = 240;
                      G = e, H = Ab(b), v[G + 20 >> 2] = H;
                      b = tE(f);
                      v[31601] = 0;
                      N(293, d + 48 | 0, b | 0);
                      b = v[31601];
                      v[31601] = 0;
                      if ((b | 0) == 1) {
                       break k;
                      }
                      b = 0;
                      f = v[d + 48 >> 2];
                      k = v[d + 52 >> 2];
                      h = Rd(f, k);
                      while (1) if (b >>> 0 >= h >>> 0) {
                       b = w[e + 36 | 0];
                       if ((b | 0) != 255) {
                        t[d + 64 | 0] = b;
                        t[d + 63 | 0] = b;
                        t[d + 60 | 0] = w[d + 60 | 0] | 4;
                       }
                       if (lc(f, k)) {
                        continue N;
                       }
                       b = h - 1 | 0;
                       t[d + 62 | 0] = b;
                       t[d + 61 | 0] = b;
                       t[d + 60 | 0] = w[d + 60 | 0] | 2;
                       continue N;
                      } else {
                       t[e + 20 | 0] = 64;
                       l = m + (b << 1) | 0;
                       t[e + 16 | 0] = w[l | 0];
                       j = Pb(e + 20 | 0, e + 16 | 0);
                       q = xb(f, b);
                       t[q + 2 | 0] = w[j | 0];
                       u[q >> 1] = w[l + 1 | 0];
                       b = b + 1 | 0;
                       continue;
                      }
                     }
                     break;
                    }
                    break k;
                   }
                   tb(e + 48 | 0);
                   break p;
                  }
                  tb(e + 184 | 0);
                 }
                 b = e + 48 | 0;
                 tb(b);
                 v[31601] = 0;
                 R(355, e + 184 | 0, e + 204 | 0, 1145131092);
                 d = v[31601];
                 v[31601] = 0;
                 if ((d | 0) == 1) {
                  break m;
                 }
                 G = e, H = vb(v[e + 184 >> 2]), v[G + 20 >> 2] = H;
                 m = a + 484344 | 0;
                 z = c & 1;
                 q = b | 4;
                 A = vb(v[e + 188 >> 2]);
                 r = (n | 0) != 841887798;
                 C = (n | 0) != 841887796;
                 while (1) {
                  P: {
                   Q: {
                    R: {
                     S: {
                      T: {
                       U: {
                        V: {
                         W: {
                          X: {
                           Y: {
                            Z: {
                             _: {
                              $: {
                               aa: {
                                f = v[e + 20 >> 2];
                                if (!Hb(f, A)) {
                                 Qc(e + 184 | 0);
                                 v[31601] = 0;
                                 R(347, e + 112 | 0, e + 204 | 0, 1346458702);
                                 b = v[31601];
                                 v[31601] = 0;
                                 if ((b | 0) != 1) {
                                  break aa;
                                 }
                                 d = M() | 0;
                                 break b;
                                }
                                v[31601] = 0;
                                O(183, f | 0, 4) | 0;
                                b = v[31601];
                                v[31601] = 0;
                                if ((b | 0) != 1) {
                                 v[31601] = 0;
                                 k = Q(273, f | 0) | 0;
                                 b = v[31601];
                                 v[31601] = 0;
                                 ba: {
                                  if ((b | 0) != 1) {
                                   v[31601] = 0;
                                   l = Q(273, f | 0) | 0;
                                   b = v[31601];
                                   v[31601] = 0;
                                   if ((b | 0) == 1) {
                                    break R;
                                   }
                                   l = r ? l : (l >>> 0) / y[a + 480196 >> 2] | 0;
                                   if (!z | k >>> 0 > 255) {
                                    break P;
                                   }
                                   v[31601] = 0;
                                   b = T(196, m | 0, k | 0, l | 0) | 0;
                                   d = v[31601];
                                   v[31601] = 0;
                                   if ((d | 0) == 1) {
                                    break R;
                                   }
                                   if (b) {
                                    break ba;
                                   }
                                   break P;
                                  }
                                  d = M() | 0;
                                  break Q;
                                 }
                                 if (!r) {
                                  j = 0;
                                  v[31601] = 0;
                                  O(183, f | 0, 4) | 0;
                                  b = v[31601];
                                  v[31601] = 0;
                                  if ((b | 0) == 1) {
                                   break R;
                                  }
                                  while (1) {
                                   s = j & 65535;
                                   if (s >>> 0 >= x[a + 480188 >> 1]) {
                                    break P;
                                   }
                                   v[31601] = 0;
                                   b = Q(273, f | 0) | 0;
                                   d = v[31601];
                                   v[31601] = 0;
                                   if ((d | 0) == 1) {
                                    break $;
                                   }
                                   v[31601] = 0;
                                   d = e + 48 | 0;
                                   R(185, d | 0, f | 0, b + (b & 1) & 65535);
                                   b = v[31601];
                                   v[31601] = 0;
                                   if ((b | 0) == 1) {
                                    break S;
                                   }
                                   g = gc(e + 112 | 0, d);
                                   tb(d);
                                   v[e + 48 >> 2] = 0;
                                   v[e + 52 >> 2] = 0;
                                   d = 0;
                                   ca: {
                                    while (1) {
                                     b = v[g >> 2];
                                     v[31601] = 0;
                                     b = T(150, b | 0, v[e + 120 >> 2], 6) | 0;
                                     h = v[31601];
                                     v[31601] = 0;
                                     if ((h | 0) == 1) {
                                      break ca;
                                     }
                                     i = b;
                                     b = v[e + 48 >> 2];
                                     if (i & b >>> 0 < l >>> 0) {
                                      h = Vb(v[m >> 2], k);
                                      b = ld(v[h >> 2], v[v[h + 48 >> 2] + 12 >> 2], b, s);
                                      v[31601] = 0;
                                      h = e + 32 | 0;
                                      N(356, h | 0, g | 0);
                                      i = v[31601];
                                      v[31601] = 0;
                                      da: {
                                       ea: {
                                        if ((i | 0) != 1) {
                                         i = Ic(h);
                                         D = _e(h);
                                         E = Xi(h);
                                         F = fc(h);
                                         o = t[e + 32 | 0];
                                         if ((o - 1 & 255) >>> 0 > 95) {
                                          break ea;
                                         }
                                         t[b | 0] = o + 13;
                                         if (!v[e + 52 >> 2]) {
                                          break da;
                                         }
                                         t[b + 3 | 0] = 19;
                                         v[e + 16 >> 2] = 15;
                                         G = b, H = w[Bd(q, e + 16 | 0) | 0] | 208, t[G + 5 | 0] = H;
                                         break da;
                                        }
                                        break T;
                                       }
                                       if ((o | 0) >= 0) {
                                        break da;
                                       }
                                       if (v[e + 52 >> 2]) {
                                        t[b + 3 | 0] = 19;
                                        v[e + 16 >> 2] = 15;
                                        G = b, H = w[Bd(q, e + 16 | 0) | 0] | 192, t[G + 5 | 0] = H;
                                        break da;
                                       }
                                       t[b | 0] = 254;
                                      }
                                      if (w[i | 0]) {
                                       t[b + 2 | 0] = 1;
                                       t[e + 16 | 0] = 64;
                                       G = b, H = w[Pb(i, e + 16 | 0) | 0], t[G + 4 | 0] = H;
                                      }
                                      i = w[D | 0];
                                      if (i) {
                                       t[b + 1 | 0] = i;
                                      }
                                      i = w[E | 0];
                                      o = w[F | 0];
                                      if (i | o) {
                                       Bf(b, i, o);
                                      }
                                      h = t[h + 5 | 0];
                                      b = h & 255;
                                      i = e + 48 | 0;
                                      if ((h | 0) < 0) {
                                       v[31601] = 0;
                                       h = Q(197, g | 0) | 0;
                                       o = v[31601];
                                       v[31601] = 0;
                                       if ((o | 0) == 1) {
                                        break T;
                                       }
                                       b = h | b << 8 & 32512;
                                      }
                                      d = b + d | 0;
                                      hE(i, d, v[a + 480196 >> 2]);
                                      continue;
                                     }
                                     break;
                                    }
                                    tb(g);
                                    j = j + 1 | 0;
                                    continue;
                                   }
                                   break;
                                  }
                                  break T;
                                 }
                                 b = Vb(v[m >> 2], k);
                                 G = e, H = vb(v[b >> 2]), v[G + 48 >> 2] = H;
                                 l = vb(v[b + 4 >> 2]);
                                 while (1) {
                                  b = v[e + 48 >> 2];
                                  if (!Hb(b, l)) {
                                   break P;
                                  }
                                  v[31601] = 0;
                                  N(357, e + 32 | 0, f | 0);
                                  d = v[31601];
                                  v[31601] = 0;
                                  if ((d | 0) != 1) {
                                   t[e + 15 | 0] = 0;
                                   fa: {
                                    if (!C) {
                                     d = v[e + 32 >> 2];
                                     v[e + 112 >> 2] = d;
                                     g = e + 112 | 0;
                                     h = Ic(g);
                                     k = _e(g);
                                     g = Xi(g);
                                     if (d << 24 >> 24 > 0) {
                                      t[b | 0] = (B((d & 240) >>> 4 | 0, 12) + (d & 15) | 0) + 12;
                                     }
                                     d = w[h | 0];
                                     if (d >>> 0 >= 4) {
                                      t[b + 2 | 0] = 1;
                                      t[b + 4 | 0] = (d >>> 2 | 0) - 1;
                                      d = w[h | 0];
                                     }
                                     t[b + 1 | 0] = d << 4 & 48 | w[k | 0] >>> 4;
                                     d = w[k | 0] & 15;
                                     t[e + 15 | 0] = d;
                                     g = w[g | 0];
                                     t[b + 5 | 0] = g;
                                     break fa;
                                    }
                                    d = v[e + 32 >> 2];
                                    v[e + 8 >> 2] = d;
                                    v[e + 4 >> 2] = d;
                                    d = e + 16 | 0;
                                    dp(d, e + 4 | 0, b);
                                    g = e + 112 | 0;
                                    _D(g, e + 15 | 0, b + 5 | 0);
                                    ZD(g, d);
                                    G = b, H = w[b + 1 | 0] | w[wb(e + 32 | 0, 0) | 0] & 48, t[G + 1 | 0] = H;
                                    g = w[b + 5 | 0];
                                    d = w[e + 15 | 0];
                                   }
                                   Bf(b, d & 255, g);
                                   d = w[b + 3 | 0];
                                   ga: {
                                    if (d >>> 0 > 11) {
                                     break ga;
                                    }
                                    d = 1 << d;
                                    ha: {
                                     if (!(d & 2240)) {
                                      if (!(d & 12)) {
                                       break ga;
                                      }
                                      if (!w[b + 5 | 0]) {
                                       break ha;
                                      }
                                      break ga;
                                     }
                                     d = w[b + 5 | 0];
                                     g = d & 240;
                                     if (g) {
                                      t[b + 5 | 0] = g;
                                      break ga;
                                     }
                                     if (d) {
                                      break ga;
                                     }
                                    }
                                    t[b + 3 | 0] = 0;
                                   }
                                   sg(e + 48 | 0);
                                   continue;
                                  }
                                  break;
                                 }
                                 d = M() | 0;
                                 break Q;
                                }
                                d = M() | 0;
                                break Q;
                               }
                               v[31601] = 0;
                               b = Q(277, v[e + 112 >> 2]) | 0;
                               d = v[31601];
                               v[31601] = 0;
                               ia: {
                                ja: {
                                 ka: {
                                  la: {
                                   ma: {
                                    if ((d | 0) != 1) {
                                     if (b) {
                                      f = Eb(e + 48 | 0);
                                      b = 0;
                                      na: {
                                       while (1) {
                                        oa: {
                                         v[31601] = 0;
                                         d = T(150, v[e + 112 >> 2], v[e + 120 >> 2], 1) | 0;
                                         g = v[31601];
                                         v[31601] = 0;
                                         if ((g | 0) == 1) {
                                          break oa;
                                         }
                                         if (!d) {
                                          break na;
                                         }
                                         if (Xj(v[a + 484344 >> 2], v[a + 484348 >> 2]) >>> 0 <= b >>> 0) {
                                          break na;
                                         }
                                         v[31601] = 0;
                                         R(358, e + 112 | 0, f | 0, 32);
                                         d = v[31601];
                                         v[31601] = 0;
                                         if ((d | 0) == 1) {
                                          break oa;
                                         }
                                         d = v[m >> 2];
                                         v[31601] = 0;
                                         N(283, Vb(d, b) | 0, f | 0);
                                         d = v[31601];
                                         v[31601] = 0;
                                         if ((d | 0) == 1) {
                                          break oa;
                                         }
                                         b = b + 1 | 0;
                                         continue;
                                        }
                                        break;
                                       }
                                       d = M() | 0;
                                       sb(f);
                                       break ma;
                                      }
                                      sb(f);
                                     }
                                     b = e + 112 | 0;
                                     tb(b);
                                     v[31601] = 0;
                                     R(347, b | 0, e + 204 | 0, 1414679374);
                                     b = v[31601];
                                     v[31601] = 0;
                                     if ((b | 0) == 1) {
                                      break la;
                                     }
                                     v[31601] = 0;
                                     b = Q(277, v[e + 112 >> 2]) | 0;
                                     d = v[31601];
                                     v[31601] = 0;
                                     if ((d | 0) == 1) {
                                      break V;
                                     }
                                     if (!b) {
                                      break ia;
                                     }
                                     d = a + 480280 | 0;
                                     f = Eb(e + 48 | 0);
                                     b = 0;
                                     while (1) {
                                      v[31601] = 0;
                                      g = T(150, v[e + 112 >> 2], v[e + 120 >> 2], 1) | 0;
                                      h = v[31601];
                                      v[31601] = 0;
                                      if ((h | 0) == 1) {
                                       break ka;
                                      }
                                      if (!(x[a + 480188 >> 1] > b >>> 0 & g)) {
                                       break ja;
                                      }
                                      v[31601] = 0;
                                      R(358, e + 112 | 0, f | 0, 32);
                                      g = v[31601];
                                      v[31601] = 0;
                                      if ((g | 0) == 1) {
                                       break ka;
                                      }
                                      em((d + (b << 5) | 0) + 9 | 0, f);
                                      b = b + 1 | 0;
                                      continue;
                                     }
                                    }
                                    d = M() | 0;
                                   }
                                   tb(e + 112 | 0);
                                   break b;
                                  }
                                  d = M() | 0;
                                  break b;
                                 }
                                 d = M() | 0;
                                 sb(f);
                                 break U;
                                }
                                sb(f);
                               }
                               b = e + 112 | 0;
                               tb(b);
                               v[31601] = 0;
                               R(355, b | 0, e + 204 | 0, 1145129300);
                               b = v[31601];
                               v[31601] = 0;
                               if ((b | 0) == 1) {
                                break W;
                               }
                               G = e, H = vb(v[e + 112 >> 2]), v[G + 48 >> 2] = H;
                               d = a + 484380 | 0;
                               f = c & 2;
                               g = vb(v[e + 116 >> 2]);
                               pa: {
                                qa: {
                                 ra: {
                                  sa: {
                                   ta: {
                                    ua: {
                                     while (1) {
                                      b = v[e + 48 >> 2];
                                      if (!Hb(b, g)) {
                                       c = e + 112 | 0;
                                       Qc(c);
                                       b = Eb(e + 48 | 0);
                                       if ((n | 0) != 841887798) {
                                        break ta;
                                       }
                                       v[31601] = 0;
                                       c = O(1, c | 0, 9490) | 0;
                                       d = v[31601];
                                       v[31601] = 0;
                                       if ((d | 0) == 1) {
                                        break ua;
                                       }
                                       yb(b, c);
                                       sb(c);
                                       break sa;
                                      }
                                      v[31601] = 0;
                                      c = Q(273, b | 0) | 0;
                                      h = v[31601];
                                      v[31601] = 0;
                                      if ((h | 0) == 1) {
                                       break X;
                                      }
                                      va: {
                                       if (!(!f | c >>> 0 >= x[a + 480190 >> 1])) {
                                        c = d + B(c, 104) | 0;
                                        h = x[c + 138 >> 1];
                                        h = Yc(e + 184 | 0, h & 1 ? 16 : 8, h & 64 ? 2 : 1, 1, 0);
                                        v[31601] = 0;
                                        T(215, h | 0, c + 104 | 0, b | 0) | 0;
                                        b = v[31601];
                                        v[31601] = 0;
                                        if ((b | 0) == 1) {
                                         break va;
                                        }
                                       }
                                       Pf(e + 48 | 0);
                                       continue;
                                      }
                                      break;
                                     }
                                     break X;
                                    }
                                    d = M() | 0;
                                    break Y;
                                   }
                                   v[31601] = 0;
                                   c = e + 112 | 0;
                                   R(347, c | 0, e + 204 | 0, 1447383635);
                                   d = v[31601];
                                   v[31601] = 0;
                                   wa: {
                                    xa: {
                                     ya: {
                                      za: {
                                       Aa: {
                                        if ((d | 0) != 1) {
                                         v[31601] = 0;
                                         d = Q(277, v[e + 112 >> 2]) | 0;
                                         f = v[31601];
                                         v[31601] = 0;
                                         if ((f | 0) == 1) {
                                          break ra;
                                         }
                                         if (!d) {
                                          break xa;
                                         }
                                         v[31601] = 0;
                                         c = Q(281, c | 0) | 0;
                                         d = v[31601];
                                         v[31601] = 0;
                                         if ((d | 0) == 1) {
                                          break Aa;
                                         }
                                         v[31601] = 0;
                                         d = e + 32 | 0;
                                         N(268, d | 0, 4292);
                                         f = v[31601];
                                         v[31601] = 0;
                                         if ((f | 0) == 1) {
                                          break za;
                                         }
                                         v[e + 20 >> 2] = c >>> 4;
                                         v[31601] = 0;
                                         v[e + 16 >> 2] = c & 15;
                                         c = e + 184 | 0;
                                         U(359, c | 0, d | 0, e + 20 | 0, e + 16 | 0);
                                         f = v[31601];
                                         v[31601] = 0;
                                         if ((f | 0) == 1) {
                                          break ya;
                                         }
                                         yb(b, c);
                                         sb(c);
                                         Db(d);
                                         break wa;
                                        }
                                        d = M() | 0;
                                        break Y;
                                       }
                                       d = M() | 0;
                                       break Z;
                                      }
                                      d = M() | 0;
                                      break Z;
                                     }
                                     d = M() | 0;
                                     Db(e + 32 | 0);
                                     break Z;
                                    }
                                    v[31601] = 0;
                                    c = O(1, e + 184 | 0, 8509) | 0;
                                    d = v[31601];
                                    v[31601] = 0;
                                    if ((d | 0) == 1) {
                                     break _;
                                    }
                                    yb(b, c);
                                    sb(c);
                                   }
                                   tb(e + 112 | 0);
                                  }
                                  v[31601] = 0;
                                  c = O(1, e + 32 | 0, 8509) | 0;
                                  d = v[31601];
                                  v[31601] = 0;
                                  if ((d | 0) == 1) {
                                   break qa;
                                  }
                                  yb(a + 1298344 | 0, c);
                                  sb(c);
                                  v[31601] = 0;
                                  c = O(1, e + 20 | 0, 10133) | 0;
                                  d = v[31601];
                                  v[31601] = 0;
                                  if ((d | 0) == 1) {
                                   break pa;
                                  }
                                  yb(a + 1298356 | 0, c);
                                  sb(c);
                                  yb(a + 1298368 | 0, b);
                                  G = a, H = v[Ec(e + 16 | 0, 28) >> 2], v[G + 1298404 >> 2] = H;
                                  sb(b);
                                  d = 1;
                                  break o;
                                 }
                                 d = M() | 0;
                                 break Z;
                                }
                                d = M() | 0;
                                break Y;
                               }
                               d = M() | 0;
                               break Y;
                              }
                              d = M() | 0;
                              break Q;
                             }
                             d = M() | 0;
                            }
                            tb(e + 112 | 0);
                           }
                           sb(b);
                           break b;
                          }
                          d = M() | 0;
                          Qc(e + 112 | 0);
                          break b;
                         }
                         d = M() | 0;
                         break b;
                        }
                        d = M() | 0;
                       }
                       tb(e + 112 | 0);
                       break b;
                      }
                      d = M() | 0;
                      tb(g);
                      break Q;
                     }
                     d = M() | 0;
                     break Q;
                    }
                    d = M() | 0;
                   }
                   Qc(e + 184 | 0);
                   break b;
                  }
                  Pf(e + 20 | 0);
                  continue;
                 }
                }
                d = 0;
               }
               je(e + 204 | 0);
              }
              eb = e + 240 | 0;
              return d | 0;
             }
             d = M() | 0;
             break b;
            }
            d = M() | 0;
            break f;
           }
           d = M() | 0;
           tb(e + 184 | 0);
           break f;
          }
          d = M() | 0;
          break f;
         }
         d = M() | 0;
         break f;
        }
        d = M() | 0;
        break b;
       }
       d = M() | 0;
      }
      tb(e + 48 | 0);
      break b;
     }
     d = M() | 0;
     tb(e + 112 | 0);
     break b;
    }
    d = M() | 0;
    break b;
   }
   d = M() | 0;
   tb(e + 184 | 0);
  }
  je(e + 204 | 0);
 }
 P(d | 0);
 p();
}

function cra(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, q = 0, r = 0, s = 0, y = 0, z = 0, A = 0, C = 0, D = 0, E = 0, F = 0, G = 0, H = 0, I = 0, J = 0;
 e = eb - 416 | 0;
 eb = e;
 xc(b);
 f = e + 411 | 0;
 d = AE(b, f);
 if (!d) {
  SY(f);
 }
 a: {
  b: {
   c: {
    d: {
     e: {
      f: {
       g: {
        h: {
         i: {
          j: {
           if (!d) {
            break j;
           }
           if (!TY(f)) {
            break j;
           }
           F = 1;
           if ((c | 0) == 64) {
            break j;
           }
           H = Ge(e + 388 | 0, b);
           v[31601] = 0;
           d = e + 376 | 0;
           N(507, d | 0, H | 0);
           b = v[31601];
           v[31601] = 0;
           k: {
            l: {
             m: {
              n: {
               o: {
                p: {
                 q: {
                  r: {
                   s: {
                    t: {
                     if ((b | 0) != 1) {
                      v[31601] = 0;
                      f = e + 356 | 0;
                      R(508, f | 0, d | 0, 20041);
                      b = v[31601];
                      v[31601] = 0;
                      if ((b | 0) == 1) {
                       break t;
                      }
                      F = 0;
                      v[31601] = 0;
                      d = Q(172, v[e + 356 >> 2]) | 0;
                      b = v[31601];
                      v[31601] = 0;
                      if ((b | 0) == 1) {
                       break l;
                      }
                      if (!d) {
                       break k;
                      }
                      v[31601] = 0;
                      d = O(509, f | 0, e + 265 | 0) | 0;
                      b = v[31601];
                      v[31601] = 0;
                      if ((b | 0) == 1) {
                       break l;
                      }
                      if (!d) {
                       break k;
                      }
                      v[31601] = 0;
                      N(246, a | 0, 16384);
                      b = v[31601];
                      v[31601] = 0;
                      if ((b | 0) == 1) {
                       break l;
                      }
                      v[a + 480208 >> 2] = 8;
                      v[31601] = 0;
                      d = T(266, a + 1074312 | 0, 9, 1) | 0;
                      b = v[31601];
                      v[31601] = 0;
                      if ((b | 0) == 1) {
                       break l;
                      }
                      v[31601] = 0;
                      d = T(266, d | 0, 114, 1) | 0;
                      b = v[31601];
                      v[31601] = 0;
                      if ((b | 0) == 1) {
                       break l;
                      }
                      v[31601] = 0;
                      d = O(267, d | 0, 21) | 0;
                      b = v[31601];
                      v[31601] = 0;
                      if ((b | 0) == 1) {
                       break l;
                      }
                      v[31601] = 0;
                      O(267, d | 0, 30) | 0;
                      b = v[31601];
                      v[31601] = 0;
                      if ((b | 0) == 1) {
                       break l;
                      }
                      v[31601] = 0;
                      d = O(1, e + 252 | 0, 8280) | 0;
                      b = v[31601];
                      v[31601] = 0;
                      if ((b | 0) == 1) {
                       break q;
                      }
                      yb(a + 1298344 | 0, d);
                      sb(d);
                      v[31601] = 0;
                      d = O(1, e + 240 | 0, 10751) | 0;
                      b = v[31601];
                      v[31601] = 0;
                      if ((b | 0) == 1) {
                       break p;
                      }
                      yb(a + 1298356 | 0, d);
                      sb(d);
                      v[31601] = 0;
                      f = O(1, e + 228 | 0, 18113) | 0;
                      b = v[31601];
                      v[31601] = 0;
                      if ((b | 0) == 1) {
                       break o;
                      }
                      d = 15036;
                      b = w[e + 415 | 0];
                      switch (b - 16 | 0) {
                      case 1:
                       break m;

                      case 0:
                       break s;

                      default:
                       break r;
                      }
                     }
                     g = M() | 0;
                     break a;
                    }
                    g = M() | 0;
                    break b;
                   }
                   d = 15017;
                   break m;
                  }
                  if (!b) {
                   break n;
                  }
                  d = 22256;
                  break m;
                 }
                 g = M() | 0;
                 break c;
                }
                g = M() | 0;
                break c;
               }
               g = M() | 0;
               break c;
              }
              d = 13322;
             }
             v[31601] = 0;
             d = O(1, e + 216 | 0, d | 0) | 0;
             b = v[31601];
             v[31601] = 0;
             if ((b | 0) == 1) {
              break e;
             }
             v[31601] = 0;
             i = e + 192 | 0;
             R(2, i | 0, f | 0, d | 0);
             b = v[31601];
             v[31601] = 0;
             if ((b | 0) == 1) {
              break f;
             }
             yb(a + 1298368 | 0, i);
             sb(i);
             sb(d);
             sb(f);
             I = a, J = v[Ec(i, 4) >> 2], v[I + 1298404 >> 2] = J;
             d = e + 84 | 0;
             Ue(d, 3, e + 265 | 0);
             v[31601] = 0;
             N(218, i | 0, d | 0);
             b = v[31601];
             v[31601] = 0;
             if ((b | 0) == 1) {
              break g;
             }
             yb(a + 1298308 | 0, i);
             sb(i);
             oi(d, 3, e + 297 | 0);
             v[31601] = 0;
             R(369, i | 0, 4, d | 0);
             b = v[31601];
             v[31601] = 0;
             if ((b | 0) == 1) {
              break h;
             }
             yb(a + 1298320 | 0, i);
             sb(i);
             v[a + 480200 >> 2] = w[e + 321 | 0] + 1;
             I = a, J = Kd(w[e + 322 | 0], 1, 255), v[I + 480196 >> 2] = J;
             I = a, J = B(Kd(w[e + 323 | 0], 4, 255), 1e4), v[I + 480204 >> 2] = J;
             d = v[a + 484360 >> 2];
             b = w[a + 484376 | 0];
             v[31601] = 0;
             $(348, Wb(d, b) | 0, e + 356 | 0, w[e + 317 | 0] | w[e + 318 | 0] << 8, 65535, 65535);
             b = v[31601];
             v[31601] = 0;
             if ((b | 0) == 1) {
              break l;
             }
             $e(Wb(v[a + 484360 >> 2], w[a + 484376 | 0]), w[e + 319 | 0] | w[e + 320 | 0] << 8);
             u[a + 480188 >> 1] = 0;
             h = a + 480280 | 0;
             i = e + 324 | 0;
             b = 0;
             while (1) {
              if ((b | 0) == 32) {
               v[31601] = 0;
               h = e + 192 | 0;
               f = e + 376 | 0;
               R(508, h | 0, f | 0, 17741);
               b = v[31601];
               v[31601] = 0;
               if ((b | 0) != 1) {
                i = jd(e + 356 | 0, h);
                tb(h);
                b = v[i >> 2];
                v[31601] = 0;
                d = Q(154, b | 0) | 0;
                b = v[31601];
                v[31601] = 0;
                if ((b | 0) == 1) {
                 break l;
                }
                v[31601] = 0;
                U(336, a + 1298332 | 0, i | 0, d | 0, 0);
                b = v[31601];
                v[31601] = 0;
                if ((b | 0) == 1) {
                 break l;
                }
                v[31601] = 0;
                R(508, h | 0, f | 0, 21321);
                b = v[31601];
                v[31601] = 0;
                if ((b | 0) != 1) {
                 j = jd(i, h);
                 tb(h);
                 b = v[j >> 2];
                 v[31601] = 0;
                 d = Q(172, b | 0) | 0;
                 b = v[31601];
                 v[31601] = 0;
                 if ((b | 0) == 1) {
                  break l;
                 }
                 u: {
                  v: {
                   if (d) {
                    v[31601] = 0;
                    R(508, h | 0, f | 0, 16723);
                    b = v[31601];
                    v[31601] = 0;
                    if ((b | 0) == 1) {
                     break u;
                    }
                    v[31601] = 0;
                    G = Q(197, j | 0) | 0;
                    b = v[31601];
                    v[31601] = 0;
                    w: {
                     if ((b | 0) != 1) {
                      r = c & 2;
                      h = a + 946304 | 0;
                      i = a + 484380 | 0;
                      f = 0;
                      while (1) {
                       if (G >>> 0 <= (f & 255) >>> 0) {
                        break w;
                       }
                       v[31601] = 0;
                       l = Q(197, j | 0) | 0;
                       b = v[31601];
                       v[31601] = 0;
                       if ((b | 0) == 1) {
                        break v;
                       }
                       if (!l) {
                        break w;
                       }
                       d = v[j + 8 >> 2];
                       b = v[j >> 2];
                       v[31601] = 0;
                       d = T(150, b | 0, d | 0, 56) | 0;
                       b = v[31601];
                       v[31601] = 0;
                       if ((b | 0) == 1) {
                        break v;
                       }
                       if (!d) {
                        break w;
                       }
                       if (l >>> 0 > x[a + 480190 >> 1]) {
                        u[a + 480190 >> 1] = l;
                       }
                       v[31601] = 0;
                       k = i + B(l, 104) | 0;
                       N(279, k | 0, 0);
                       b = v[31601];
                       v[31601] = 0;
                       if ((b | 0) == 1) {
                        break v;
                       }
                       ep(k);
                       v[31601] = 0;
                       R(317, j | 0, h + (l << 5) | 0, 32);
                       b = v[31601];
                       v[31601] = 0;
                       if ((b | 0) == 1) {
                        break v;
                       }
                       v[31601] = 0;
                       N(320, j | 0, k + 43 | 0);
                       b = v[31601];
                       v[31601] = 0;
                       if ((b | 0) == 1) {
                        break v;
                       }
                       x: {
                        if (w[e + 415 | 0] <= 15) {
                         v[31601] = 0;
                         g = Q(189, j | 0) | 0;
                         b = v[31601];
                         v[31601] = 0;
                         if ((b | 0) != 1) {
                          break x;
                         }
                         break v;
                        }
                        v[31601] = 0;
                        g = Q(151, j | 0) | 0;
                        b = v[31601];
                        v[31601] = 0;
                        if ((b | 0) == 1) {
                         break v;
                        }
                       }
                       v[k + 24 >> 2] = g << 1;
                       v[31601] = 0;
                       d = Q(151, j | 0) | 0;
                       b = v[31601];
                       v[31601] = 0;
                       if ((b | 0) == 1) {
                        break v;
                       }
                       v[k >> 2] = d;
                       v[31601] = 0;
                       d = Q(151, j | 0) | 0;
                       b = v[31601];
                       v[31601] = 0;
                       if ((b | 0) == 1) {
                        break v;
                       }
                       v[k + 4 >> 2] = d;
                       v[31601] = 0;
                       d = Q(151, j | 0) | 0;
                       b = v[31601];
                       v[31601] = 0;
                       if ((b | 0) == 1) {
                        break v;
                       }
                       v[k + 8 >> 2] = d;
                       if (d) {
                        u[k + 34 >> 1] = x[k + 34 >> 1] | 2;
                        v[k + 8 >> 2] = d + v[k + 4 >> 2];
                       }
                       v[31601] = 0;
                       d = Q(197, j | 0) | 0;
                       b = v[31601];
                       v[31601] = 0;
                       if ((b | 0) == 1) {
                        break v;
                       }
                       if (w[e + 415 | 0] <= 15) {
                        u[k + 30 >> 1] = d;
                       }
                       v[31601] = 0;
                       d = Q(197, j | 0) | 0;
                       b = v[31601];
                       v[31601] = 0;
                       if ((b | 0) == 1) {
                        break v;
                       }
                       m = x[k + 34 >> 1];
                       C = 8;
                       if (d & 1) {
                        m = m | 1;
                        u[k + 34 >> 1] = m;
                        v[k >> 2] = v[k >> 2] >>> 1;
                        v[k + 4 >> 2] = v[k + 4 >> 2] >>> 1;
                        v[k + 8 >> 2] = v[k + 8 >> 2] >>> 1;
                        C = 16;
                       }
                       u[k + 34 >> 1] = m & 65531 | d << 1 & 4;
                       b = Yc(e + 84 | 0, C, 1, 0, ((d & 12) != 0) << 3);
                       y: {
                        if (!r) {
                         break y;
                        }
                        v[31601] = 0;
                        T(215, b | 0, k | 0, e + 192 | 0) | 0;
                        b = v[31601];
                        v[31601] = 0;
                        if ((b | 0) != 1) {
                         break y;
                        }
                        break v;
                       }
                       f = f + 1 | 0;
                       continue;
                      }
                     }
                     break v;
                    }
                    tb(e + 192 | 0);
                   }
                   v[31601] = 0;
                   d = e + 192 | 0;
                   f = e + 376 | 0;
                   R(508, d | 0, f | 0, 18761);
                   b = v[31601];
                   v[31601] = 0;
                   z: {
                    if ((b | 0) != 1) {
                     n = jd(j, d);
                     tb(d);
                     b = v[n >> 2];
                     v[31601] = 0;
                     d = Q(172, b | 0) | 0;
                     b = v[31601];
                     v[31601] = 0;
                     if ((b | 0) == 1) {
                      break l;
                     }
                     if (!d) {
                      break z;
                     }
                     q = Mb(e + 84 | 0);
                     y = Mb(e + 180 | 0);
                     s = Mb(e + 168 | 0);
                     v[31601] = 0;
                     R(508, e + 148 | 0, f | 0, 17750);
                     b = v[31601];
                     v[31601] = 0;
                     A: {
                      if ((b | 0) == 1) {
                       break A;
                      }
                      b = v[e + 160 >> 2];
                      v[e + 56 >> 2] = v[e + 156 >> 2];
                      v[e + 60 >> 2] = b;
                      v[e - -64 >> 2] = v[e + 164 >> 2];
                      v[31601] = 0;
                      b = v[e + 152 >> 2];
                      v[e + 48 >> 2] = v[e + 148 >> 2];
                      v[e + 52 >> 2] = b;
                      N(510, e + 48 | 0, q | 0);
                      b = v[31601];
                      v[31601] = 0;
                      if ((b | 0) == 1) {
                       break A;
                      }
                      v[31601] = 0;
                      R(508, e + 128 | 0, f | 0, 17744);
                      b = v[31601];
                      v[31601] = 0;
                      if ((b | 0) == 1) {
                       break A;
                      }
                      b = v[e + 140 >> 2];
                      v[e + 32 >> 2] = v[e + 136 >> 2];
                      v[e + 36 >> 2] = b;
                      v[e + 40 >> 2] = v[e + 144 >> 2];
                      v[31601] = 0;
                      b = v[e + 132 >> 2];
                      v[e + 24 >> 2] = v[e + 128 >> 2];
                      v[e + 28 >> 2] = b;
                      N(510, e + 24 | 0, y | 0);
                      b = v[31601];
                      v[31601] = 0;
                      if ((b | 0) == 1) {
                       break A;
                      }
                      v[31601] = 0;
                      R(508, e + 108 | 0, f | 0, 17734);
                      b = v[31601];
                      v[31601] = 0;
                      if ((b | 0) == 1) {
                       break A;
                      }
                      b = v[e + 120 >> 2];
                      v[e + 8 >> 2] = v[e + 116 >> 2];
                      v[e + 12 >> 2] = b;
                      v[e + 16 >> 2] = v[e + 124 >> 2];
                      v[31601] = 0;
                      b = v[e + 112 >> 2];
                      v[e >> 2] = v[e + 108 >> 2];
                      v[e + 4 >> 2] = b;
                      N(510, e | 0, s | 0);
                      b = v[31601];
                      v[31601] = 0;
                      if ((b | 0) == 1) {
                       break A;
                      }
                      v[31601] = 0;
                      k = Q(197, n | 0) | 0;
                      b = v[31601];
                      v[31601] = 0;
                      if ((b | 0) == 1) {
                       break A;
                      }
                      j = a + 484380 | 0;
                      while (1) {
                       if (k >>> 0 <= (z & 255) >>> 0) {
                        Zo(s);
                        Zo(y);
                        Zo(q);
                        break z;
                       }
                       v[31601] = 0;
                       d = e + 72 | 0;
                       N(198, d | 0, n | 0);
                       b = v[31601];
                       v[31601] = 0;
                       B: {
                        if ((b | 0) != 1) {
                         F = Ic(d);
                         C: {
                          D: {
                           if (!w[e + 72 | 0]) {
                            break D;
                           }
                           f = v[n + 8 >> 2];
                           d = v[n >> 2];
                           b = w[F | 0];
                           v[31601] = 0;
                           d = T(150, d | 0, f | 0, B(b, 14) + 32 | 0) | 0;
                           b = v[31601];
                           v[31601] = 0;
                           if ((b | 0) == 1) {
                            break A;
                           }
                           if (!d) {
                            break D;
                           }
                           v[31601] = 0;
                           o = T(251, a | 0, w[e + 72 | 0], 0) | 0;
                           b = v[31601];
                           v[31601] = 0;
                           if ((b | 0) == 1) {
                            break A;
                           }
                           if (o) {
                            break C;
                           }
                          }
                          b = w[F | 0];
                          v[31601] = 0;
                          O(183, n | 0, B(b, 14) + 32 | 0) | 0;
                          b = v[31601];
                          v[31601] = 0;
                          if ((b | 0) != 1) {
                           break B;
                          }
                          break A;
                         }
                         v[31601] = 0;
                         R(317, n | 0, o + 492 | 0, 32);
                         b = v[31601];
                         v[31601] = 0;
                         if ((b | 0) == 1) {
                          break A;
                         }
                         l = o + 88 | 0;
                         G = o + 68 | 0;
                         r = o + 48 | 0;
                         h = o + 236 | 0;
                         b = 0;
                         m = 0;
                         while (1) {
                          if (w[F | 0] <= (m & 255) >>> 0) {
                           break B;
                          }
                          v[31601] = 0;
                          N(511, n | 0, e + 192 | 0);
                          d = v[31601];
                          v[31601] = 0;
                          if ((d | 0) == 1) {
                           break A;
                          }
                          d = w[e + 192 | 0];
                          E: {
                           if (!d | d >>> 0 > x[a + 480190 >> 1]) {
                            break E;
                           }
                           if (w[e + 193 | 0] >= 129) {
                            t[e + 193 | 0] = 128;
                           }
                           while (1) {
                            d = b & 255;
                            i = w[e + 193 | 0];
                            if (d >>> 0 > i >>> 0) {
                             d = v[q + 4 >> 2];
                             b = v[q >> 2];
                             v[31601] = 0;
                             U(512, r | 0, w[e + 195 | 0], b | 0, d | 0);
                             b = v[31601];
                             v[31601] = 0;
                             if ((b | 0) == 1) {
                              break A;
                             }
                             d = v[y + 4 >> 2];
                             b = v[y >> 2];
                             v[31601] = 0;
                             U(512, G | 0, w[e + 197 | 0], b | 0, d | 0);
                             b = v[31601];
                             v[31601] = 0;
                             if ((b | 0) == 1) {
                              break A;
                             }
                             d = v[s + 4 >> 2];
                             b = v[s >> 2];
                             v[31601] = 0;
                             U(512, l | 0, w[e + 205 | 0], b | 0, d | 0);
                             b = v[31601];
                             v[31601] = 0;
                             if ((b | 0) == 1) {
                              break A;
                             }
                             v[o >> 2] = (w[e + 198 | 0] | w[e + 199 | 0] << 8) + 1 >>> 1;
                             d = j + B(w[e + 192 | 0], 104) | 0;
                             F: {
                              if (w[e + 195 | 0] & 64) {
                               u[d + 30 >> 1] = w[e + 194 | 0];
                               break F;
                              }
                              u[d + 34 >> 1] = x[d + 34 >> 1] | 32768;
                             }
                             u[e + 106 >> 1] = w[e + 196 | 0] << 1;
                             u[e + 104 >> 1] = 254;
                             I = d, J = x[Nc(e + 106 | 0, e + 104 | 0) >> 1], u[I + 28 >> 1] = J;
                             t[d + 38 | 0] = w[(w[e + 203 | 0] & 3) + 25028 | 0];
                             E = w[e + 202 | 0];
                             t[d + 39 | 0] = E;
                             f = w[e + 201 | 0] + 3 >>> 2 | 0;
                             t[d + 40 | 0] = f;
                             t[d + 41 | 0] = w[e + 200 | 0];
                             b = i + 1 | 0;
                             if (E) {
                              f = ri(Ac(((f << 8 | E >>> 1) >>> 0) / (E >>> 0) | 0, 0));
                             } else {
                              f = 255;
                             }
                             t[d + 39 | 0] = f;
                             if (!(w[e + 197 | 0] & 64)) {
                              break E;
                             }
                             u[d + 34 >> 1] = x[d + 34 >> 1] | 32;
                            } else {
                             I = $b(h, d), J = w[e + 192 | 0], u[I >> 1] = J;
                             b = b + 1 | 0;
                             continue;
                            }
                            break;
                           }
                          }
                          m = m + 1 | 0;
                          continue;
                         }
                        }
                        break A;
                       }
                       z = z + 1 | 0;
                       continue;
                      }
                     }
                     g = M() | 0;
                     Zo(s);
                     Zo(y);
                     Zo(q);
                     break c;
                    }
                    g = M() | 0;
                    break c;
                   }
                   F = 1;
                   o = Mb(e + 180 | 0);
                   G: {
                    if (!(c & 1)) {
                     break G;
                    }
                    v[31601] = 0;
                    d = e + 192 | 0;
                    R(508, d | 0, e + 376 | 0, 21076);
                    b = v[31601];
                    v[31601] = 0;
                    H: {
                     I: {
                      J: {
                       K: {
                        L: {
                         M: {
                          if ((b | 0) != 1) {
                           h = jd(n, d);
                           b = v[h >> 2];
                           v[31601] = 0;
                           c = Q(172, b | 0) | 0;
                           b = v[31601];
                           v[31601] = 0;
                           N: {
                            O: {
                             P: {
                              if ((b | 0) != 1) {
                               tb(d);
                               if (!c) {
                                break N;
                               }
                               v[31601] = 0;
                               d = Q(189, h | 0) | 0;
                               c = v[31601];
                               v[31601] = 0;
                               b = 1;
                               if ((c | 0) == 1) {
                                break P;
                               }
                               v[31601] = 0;
                               f = d + 1 | 0;
                               N(513, o | 0, f | 0);
                               c = v[31601];
                               v[31601] = 0;
                               if ((c | 0) == 1) {
                                break P;
                               }
                               while (1) {
                                if ((b | 0) == (f | 0)) {
                                 break N;
                                }
                                v[31601] = 0;
                                d = Q(189, h | 0) | 0;
                                c = v[31601];
                                v[31601] = 0;
                                if ((c | 0) == 1) {
                                 break O;
                                }
                                v[31601] = 0;
                                i = e + 84 | 0;
                                R(185, i | 0, h | 0, d | 0);
                                c = v[31601];
                                v[31601] = 0;
                                if ((c | 0) == 1) {
                                 break O;
                                }
                                c = gc(e + 192 | 0, i);
                                jd(bh(v[o >> 2], b), c);
                                tb(c);
                                b = b + 1 | 0;
                                tb(i);
                                continue;
                               }
                              }
                              g = M() | 0;
                              tb(e + 192 | 0);
                              break H;
                             }
                             g = M() | 0;
                             break H;
                            }
                            g = M() | 0;
                            break H;
                           }
                           v[31601] = 0;
                           d = e + 192 | 0;
                           R(508, d | 0, e + 376 | 0, 16720);
                           b = v[31601];
                           v[31601] = 0;
                           if ((b | 0) == 1) {
                            break J;
                           }
                           D = jd(h, d);
                           b = v[D >> 2];
                           v[31601] = 0;
                           c = Q(172, b | 0) | 0;
                           b = v[31601];
                           v[31601] = 0;
                           if ((b | 0) == 1) {
                            break K;
                           }
                           tb(d);
                           if (!c) {
                            break M;
                           }
                           v[31601] = 0;
                           E = Q(197, D | 0) | 0;
                           b = v[31601];
                           v[31601] = 0;
                           if ((b | 0) == 1) {
                            break I;
                           }
                           C = 0;
                           Q: {
                            R: {
                             S: while (1) {
                              T: {
                               if (E >>> 0 <= (C & 65535) >>> 0) {
                                v[31601] = 0;
                                O(149, D | 0, 1) | 0;
                                b = v[31601];
                                v[31601] = 0;
                                if ((b | 0) != 1) {
                                 break T;
                                }
                                break I;
                               }
                               m = 32;
                               U: {
                                if (w[e + 415 | 0] < 16) {
                                 break U;
                                }
                                v[31601] = 0;
                                N(514, D | 0, e + 192 | 0);
                                b = v[31601];
                                v[31601] = 0;
                                if ((b | 0) == 1) {
                                 break Q;
                                }
                                m = w[e + 192 | 0];
                                if (m >>> 0 <= x[a + 480188 >> 1] | m >>> 0 > 32) {
                                 break U;
                                }
                                u[a + 480188 >> 1] = m;
                               }
                               b = 0;
                               while (1) {
                                f = b & 65535;
                                if (f >>> 0 >= m >>> 0) {
                                 C = C + 1 | 0;
                                 continue S;
                                }
                                v[31601] = 0;
                                d = Q(189, D | 0) | 0;
                                c = v[31601];
                                v[31601] = 0;
                                if ((c | 0) == 1) {
                                 break R;
                                }
                                if (!(!d | f >>> 0 > 31 | f >>> 0 < x[a + 480188 >> 1])) {
                                 u[a + 480188 >> 1] = b + 1;
                                }
                                b = b + 1 | 0;
                                continue;
                               }
                              }
                              break;
                             }
                             v[31601] = 0;
                             q = a + 484344 | 0;
                             N(223, q | 0, E | 0);
                             b = v[31601];
                             v[31601] = 0;
                             if ((b | 0) == 1) {
                              break I;
                             }
                             G = e + 194 | 0;
                             n = 0;
                             while (1) {
                              if ((n | 0) == (E | 0)) {
                               break M;
                              }
                              y = Eb(e + 84 | 0);
                              V: {
                               if (w[e + 415 | 0] < 16) {
                                c = 32;
                                i = 64;
                                break V;
                               }
                               v[31601] = 0;
                               N(514, D | 0, e + 192 | 0);
                               b = v[31601];
                               v[31601] = 0;
                               if ((b | 0) == 1) {
                                break L;
                               }
                               d = w[e + 193 | 0];
                               c = w[e + 192 | 0];
                               b = e + 72 | 0;
                               bf(b, G, 16, 3);
                               v[31601] = 0;
                               f = e + 168 | 0;
                               N(218, f | 0, b | 0);
                               b = v[31601];
                               v[31601] = 0;
                               if ((b | 0) == 1) {
                                break L;
                               }
                               yb(y, f);
                               sb(f);
                               i = d + 1 | 0;
                              }
                              v[31601] = 0;
                              d = T(196, q | 0, n & 65535, i | 0) | 0;
                              b = v[31601];
                              v[31601] = 0;
                              if ((b | 0) == 1) {
                               break L;
                              }
                              W: {
                               if (!d) {
                                v[31601] = 0;
                                O(183, D | 0, c << 1) | 0;
                                b = v[31601];
                                v[31601] = 0;
                                if ((b | 0) != 1) {
                                 break W;
                                }
                                break L;
                               }
                               b = v[q >> 2];
                               v[31601] = 0;
                               N(283, Vb(b, n) | 0, y | 0);
                               b = v[31601];
                               v[31601] = 0;
                               if ((b | 0) == 1) {
                                break L;
                               }
                               r = i - 1 | 0;
                               k = 0;
                               while (1) {
                                s = k & 65535;
                                if (s >>> 0 >= c >>> 0) {
                                 break W;
                                }
                                v[31601] = 0;
                                d = Q(189, D | 0) | 0;
                                b = v[31601];
                                v[31601] = 0;
                                X: {
                                 if ((b | 0) != 1) {
                                  if (!d) {
                                   break X;
                                  }
                                  b = v[o >> 2];
                                  if (Rf(b, v[o + 4 >> 2]) >>> 0 <= d >>> 0 | s >>> 0 >= x[a + 480188 >> 1]) {
                                   break X;
                                  }
                                  A = bh(b, d);
                                  xc(A);
                                  f = 0;
                                  Y: while (1) {
                                   d = f;
                                   if (i >>> 0 <= d >>> 0) {
                                    break X;
                                   }
                                   f = v[A + 8 >> 2];
                                   b = v[A >> 2];
                                   v[31601] = 0;
                                   f = T(150, b | 0, f | 0, 1) | 0;
                                   b = v[31601];
                                   v[31601] = 0;
                                   Z: {
                                    _: {
                                     $: {
                                      aa: {
                                       ba: {
                                        if ((b | 0) != 1) {
                                         if (!f) {
                                          break X;
                                         }
                                         b = Vb(v[q >> 2], n);
                                         b = ld(v[b >> 2], v[v[b + 48 >> 2] + 12 >> 2], d, s);
                                         v[31601] = 0;
                                         h = Q(197, A | 0) | 0;
                                         f = v[31601];
                                         v[31601] = 0;
                                         if ((f | 0) == 1) {
                                          break L;
                                         }
                                         j = h << 24 >> 24;
                                         g = (j & 252) >>> 2 | 0;
                                         switch ((j & 3) - 1 | 0) {
                                         case 2:
                                          break _;

                                         case 1:
                                          break $;

                                         case 0:
                                          break aa;

                                         default:
                                          break ba;
                                         }
                                        }
                                        break L;
                                       }
                                       f = (d + g | 0) + 1 | 0;
                                       continue;
                                      }
                                      f = 0;
                                      if (!d) {
                                       continue;
                                      }
                                      f = Vb(v[q >> 2], n);
                                      l = ld(v[f >> 2], v[v[f + 48 >> 2] + 12 >> 2], d - 1 | 0, s);
                                      while (1) {
                                       f = w[l | 0] | w[l + 1 | 0] << 8 | (w[l + 2 | 0] << 16 | w[l + 3 | 0] << 24);
                                       t[b | 0] = f;
                                       t[b + 1 | 0] = f >>> 8;
                                       t[b + 2 | 0] = f >>> 16;
                                       t[b + 3 | 0] = f >>> 24;
                                       f = w[l + 4 | 0] | w[l + 5 | 0] << 8;
                                       t[b + 4 | 0] = f;
                                       t[b + 5 | 0] = f >>> 8;
                                       f = d + 1 | 0;
                                       if ((d | 0) == (r | 0)) {
                                        continue Y;
                                       }
                                       b = B(x[a + 480188 >> 1], 6) + b | 0;
                                       h = g & 255;
                                       d = f;
                                       g = g - 1 | 0;
                                       if (h) {
                                        continue;
                                       }
                                       break;
                                      }
                                      continue;
                                     }
                                     if (d >>> 0 <= g >>> 0) {
                                      break Z;
                                     }
                                     f = Vb(v[q >> 2], n);
                                     h = ld(v[f >> 2], v[v[f + 48 >> 2] + 12 >> 2], g, s);
                                     f = w[h | 0] | w[h + 1 | 0] << 8 | (w[h + 2 | 0] << 16 | w[h + 3 | 0] << 24);
                                     t[b | 0] = f;
                                     t[b + 1 | 0] = f >>> 8;
                                     t[b + 2 | 0] = f >>> 16;
                                     t[b + 3 | 0] = f >>> 24;
                                     f = w[h + 4 | 0] | w[h + 5 | 0] << 8;
                                     t[b + 4 | 0] = f;
                                     t[b + 5 | 0] = f >>> 8;
                                     break Z;
                                    }
                                    if (g & 1) {
                                     v[31601] = 0;
                                     h = Q(197, A | 0) | 0;
                                     f = v[31601];
                                     v[31601] = 0;
                                     if ((f | 0) == 1) {
                                      break L;
                                     }
                                     t[b | 0] = h >>> 0 > 120 ? -1 : h;
                                    }
                                    if (g & 2) {
                                     v[31601] = 0;
                                     h = Q(197, A | 0) | 0;
                                     f = v[31601];
                                     v[31601] = 0;
                                     if ((f | 0) == 1) {
                                      break L;
                                     }
                                     t[b + 1 | 0] = h;
                                    }
                                    C = 0;
                                    m = 0;
                                    ca: {
                                     if (g & 4) {
                                      v[31601] = 0;
                                      m = Q(197, A | 0) | 0;
                                      f = v[31601];
                                      v[31601] = 0;
                                      if ((f | 0) == 1) {
                                       break ca;
                                      }
                                     }
                                     f = 0;
                                     if (g & 8) {
                                      v[31601] = 0;
                                      h = Q(197, A | 0) | 0;
                                      f = v[31601];
                                      v[31601] = 0;
                                      if ((f | 0) == 1) {
                                       break ca;
                                      }
                                      C = h & 15;
                                      f = h >>> 4 | 0;
                                     }
                                     l = 0;
                                     z = 0;
                                     if (g & 16) {
                                      v[31601] = 0;
                                      z = Q(197, A | 0) | 0;
                                      h = v[31601];
                                      v[31601] = 0;
                                      if ((h | 0) == 1) {
                                       break ca;
                                      }
                                     }
                                     if ((j | 0) < 0) {
                                      v[31601] = 0;
                                      l = Q(197, A | 0) | 0;
                                      h = v[31601];
                                      v[31601] = 0;
                                      if ((h | 0) == 1) {
                                       break ca;
                                      }
                                     }
                                     g = eb - 16 | 0;
                                     eb = g;
                                     h = g + 14 | 0;
                                     QY(h, C, z);
                                     j = Ic(h);
                                     h = g + 12 | 0;
                                     QY(h, ((f - 1 & 255) >>> 0 < 6 ? f + 15 | 0 : f) & 255, l);
                                     l = Ic(h);
                                     da: {
                                      ea: {
                                       fa: {
                                        if (w[g + 14 | 0] == 10) {
                                         h = w[l | 0];
                                         f = w[j | 0] & 15;
                                         t[j | 0] = f ? -1 : h;
                                         z = h | f << 8;
                                         f = w[g + 12 | 0];
                                         if ((f | 0) != 10) {
                                          break fa;
                                         }
                                         f = 0;
                                         t[g + 12 | 0] = 0;
                                         break fa;
                                        }
                                        if (w[g + 12 | 0] != 10) {
                                         break ea;
                                        }
                                        f = w[l | 0] & 15;
                                        t[l | 0] = f ? -1 : 0;
                                        z = f << 8;
                                        f = w[g + 14 | 0];
                                       }
                                       if (z - 256 >>> 0 > 4294967038) {
                                        break ea;
                                       }
                                       if (qi(f) >>> 0 >= qi(10) >>> 0) {
                                        break ea;
                                       }
                                       t[b + 5 | 0] = z;
                                       t[b + 2 | 0] = 15;
                                       t[b + 3 | 0] = 10;
                                       t[b + 4 | 0] = z >>> 8;
                                       break da;
                                      }
                                      if (m) {
                                       t[b + 2 | 0] = 1;
                                       t[b + 4 | 0] = m + 2 >>> 2;
                                      }
                                      vw(g + 14 | 0, j, g + 12 | 0, l);
                                      h = w[g + 14 | 0];
                                      f = w[g + 12 | 0];
                                      if ((h | 0) == 20 | (f | 0) != (h | 0) ? h : 0) {
                                       if (!f) {
                                        t[b + 5 | 0] = w[j | 0];
                                        t[b + 3 | 0] = h;
                                        break da;
                                       }
                                       if (!m) {
                                        cm(g + 10 | 0, b, h, w[j | 0], f, w[l | 0]);
                                        break da;
                                       }
                                       if (qi(h) >>> 0 > qi(f) >>> 0) {
                                        t[b + 5 | 0] = w[j | 0];
                                        t[b + 3 | 0] = h;
                                        break da;
                                       }
                                      }
                                      t[b + 5 | 0] = w[l | 0];
                                      t[b + 3 | 0] = f;
                                     }
                                     eb = g + 16 | 0;
                                     break Z;
                                    }
                                    break L;
                                   }
                                   f = d + 1 | 0;
                                   continue;
                                  }
                                 }
                                 break L;
                                }
                                k = k + 1 | 0;
                                continue;
                               }
                              }
                              sb(y);
                              n = n + 1 | 0;
                              continue;
                             }
                            }
                            g = M() | 0;
                            break H;
                           }
                           g = M() | 0;
                           break H;
                          }
                          g = M() | 0;
                          break H;
                         }
                         v[31601] = 0;
                         d = e + 192 | 0;
                         R(508, d | 0, e + 376 | 0, 20048);
                         b = v[31601];
                         v[31601] = 0;
                         ga: {
                          ha: {
                           if ((b | 0) != 1) {
                            f = jd(D, d);
                            b = v[f >> 2];
                            v[31601] = 0;
                            c = Q(172, b | 0) | 0;
                            b = v[31601];
                            v[31601] = 0;
                            if ((b | 0) == 1) {
                             break ha;
                            }
                            tb(d);
                            if (!c) {
                             break G;
                            }
                            while (1) {
                             if (!Xj(v[a + 484344 >> 2], v[a + 484348 >> 2])) {
                              break G;
                             }
                             c = v[f + 8 >> 2];
                             b = v[f >> 2];
                             v[31601] = 0;
                             c = T(150, b | 0, c | 0, 16) | 0;
                             b = v[31601];
                             v[31601] = 0;
                             if ((b | 0) == 1) {
                              break ga;
                             }
                             if (!c) {
                              break G;
                             }
                             v[31601] = 0;
                             c = e + 192 | 0;
                             N(394, f | 0, c | 0);
                             b = v[31601];
                             v[31601] = 0;
                             if ((b | 0) != 1) {
                              b = v[a + 484344 >> 2];
                              v[31601] = 0;
                              N(395, Vb(b, 0) | 0, c | 0);
                              b = v[31601];
                              v[31601] = 0;
                              if ((b | 0) != 1) {
                               continue;
                              }
                             }
                             break;
                            }
                            g = M() | 0;
                            break H;
                           }
                           g = M() | 0;
                           break H;
                          }
                          g = M() | 0;
                          tb(e + 192 | 0);
                          break H;
                         }
                         g = M() | 0;
                         break H;
                        }
                        g = M() | 0;
                        sb(y);
                        break H;
                       }
                       g = M() | 0;
                       tb(e + 192 | 0);
                       break H;
                      }
                      g = M() | 0;
                      break H;
                     }
                     g = M() | 0;
                    }
                    Qc(o);
                    break c;
                   }
                   Qc(o);
                   break k;
                  }
                  g = M() | 0;
                  tb(e + 192 | 0);
                  break c;
                 }
                 g = M() | 0;
                 break c;
                }
                g = M() | 0;
                break c;
               }
               g = M() | 0;
               break c;
              }
              r = h + (b << 5) | 0;
              Ve(r);
              f = t[b + i | 0];
              d = f << 1 & 254;
              u[r + 4 >> 1] = (d | 0) == 254 ? 256 : d;
              ia: {
               if ((f | 0) < 0) {
                v[r >> 2] = v[r >> 2] | 1024;
                break ia;
               }
               u[a + 480188 >> 1] = b + 1;
              }
              v[31601] = 0;
              N(515, e + 356 | 0, r + 9 | 0);
              d = v[31601];
              v[31601] = 0;
              if ((d | 0) == 1) {
               break i;
              }
              b = b + 1 | 0;
              continue;
             }
            }
            g = M() | 0;
            break c;
           }
           tb(e + 356 | 0);
           je(e + 376 | 0);
           tb(H);
          }
          eb = e + 416 | 0;
          return F | 0;
         }
         g = M() | 0;
         break c;
        }
        g = M() | 0;
        break c;
       }
       g = M() | 0;
       break c;
      }
      g = M() | 0;
      sb(d);
      break d;
     }
     g = M() | 0;
    }
    sb(f);
   }
   tb(e + 356 | 0);
  }
  je(e + 376 | 0);
 }
 tb(H);
 P(g | 0);
 p();
}

function k1(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, q = 0, r = 0;
 a: {
  n = $j(b, 13869);
  if (!n) {
   break a;
  }
  o = a + 900380 | 0;
  b: while (1) {
   if (!Lb(v[b >> 2], v[b + 8 >> 2], 6)) {
    break a;
   }
   f = Qg(b);
   if (!(!((f | 0) == (Cn(13719) | 0) | !(f & 1616928864) | f & -2139062144) & (f | 0) != 70791730)) {
    Hh(b, 4);
    break a;
   }
   l = 1;
   c = fh(b);
   while (1) {
    e = l & 65535;
    if (e >>> 0 > x[a + 480192 >> 1]) {
     continue b;
    }
    e = v[(e << 2) + o >> 2];
    if (e) {
     c: {
      g = 0;
      if ((Cn(16754) | 0) == (f | 0)) {
       Ub(b, c);
       break c;
      }
      h = eb - 48 | 0;
      eb = h;
      d: {
       e: {
        f: {
         g: {
          h: {
           i: {
            j: {
             k: {
              l: {
               m: {
                n: {
                 o: {
                  p: {
                   q: {
                    r: {
                     s: {
                      t: {
                       u: {
                        v: {
                         w: {
                          x: {
                           y: {
                            z: {
                             A: {
                              B: {
                               C: {
                                D: {
                                 E: {
                                  F: {
                                   G: {
                                    H: {
                                     I: {
                                      J: {
                                       K: {
                                        L: {
                                         M: {
                                          N: {
                                           O: {
                                            P: {
                                             Q: {
                                              R: {
                                               S: {
                                                T: {
                                                 U: {
                                                  V: {
                                                   W: {
                                                    X: {
                                                     Y: {
                                                      switch (f - 1349079874 | 0) {
                                                      default:
                                                       if ((f | 0) == 1095062094) {
                                                        break t;
                                                       }
                                                       if ((f | 0) == 1095126087) {
                                                        break q;
                                                       }
                                                       if ((f | 0) == 1129524782) {
                                                        break z;
                                                       }
                                                       if ((f | 0) == 1145263150) {
                                                        break W;
                                                       }
                                                       if ((f | 0) == 1145979182) {
                                                        break V;
                                                       }
                                                       if ((f | 0) == 1179463214) {
                                                        break x;
                                                       }
                                                       if ((f | 0) == 1851469358) {
                                                        break D;
                                                       }
                                                       if ((f | 0) == 1179931728) {
                                                        break l;
                                                       }
                                                       Z: {
                                                        _: {
                                                         $: {
                                                          aa: {
                                                           ba: {
                                                            ca: {
                                                             da: {
                                                              ea: {
                                                               fa: {
                                                                ga: {
                                                                 ha: {
                                                                  if ((f | 0) != 1196830254) {
                                                                   if ((f | 0) == 1229341486) {
                                                                    break S;
                                                                   }
                                                                   if ((f | 0) == 1229345326) {
                                                                    break R;
                                                                   }
                                                                   if ((f | 0) == 1264266798) {
                                                                    break E;
                                                                   }
                                                                   if ((f | 0) == 1296182830) {
                                                                    break Q;
                                                                   }
                                                                   if ((f | 0) == 1296248366) {
                                                                    break O;
                                                                   }
                                                                   if ((f | 0) == 1297100334) {
                                                                    break P;
                                                                   }
                                                                   if ((f | 0) == 1297110852) {
                                                                    break o;
                                                                   }
                                                                   if ((f | 0) == 1298747438) {
                                                                    break B;
                                                                   }
                                                                   if ((f | 0) == 1313692462) {
                                                                    break F;
                                                                   }
                                                                   if ((f | 0) == 1313751342) {
                                                                    break X;
                                                                   }
                                                                   if ((f | 0) == 1345203758) {
                                                                    break ha;
                                                                   }
                                                                   if ((f | 0) == 1346711086) {
                                                                    break j;
                                                                   }
                                                                   if ((f | 0) == 1346720334) {
                                                                    break u;
                                                                   }
                                                                   if ((f | 0) == 1346722606) {
                                                                    break H;
                                                                   }
                                                                   if ((f | 0) == 1346784327) {
                                                                    break r;
                                                                   }
                                                                   if ((f | 0) == 1347175726) {
                                                                    break ba;
                                                                   }
                                                                   if ((f | 0) == 1347179310) {
                                                                    break ca;
                                                                   }
                                                                   if ((f | 0) == 1347437358) {
                                                                    break M;
                                                                   }
                                                                   if ((f | 0) == 1347441454) {
                                                                    break N;
                                                                   }
                                                                   if ((f | 0) == 1347443502) {
                                                                    break K;
                                                                   }
                                                                   if ((f | 0) == 1347628590) {
                                                                    break U;
                                                                   }
                                                                   if ((f | 0) == 1347633710) {
                                                                    break aa;
                                                                   }
                                                                   if ((f | 0) == 1347634478) {
                                                                    break $;
                                                                   }
                                                                   if ((f | 0) == 1347703884) {
                                                                    break m;
                                                                   }
                                                                   if ((f | 0) == 1347831112) {
                                                                    break w;
                                                                   }
                                                                   if ((f | 0) == 1347833672) {
                                                                    break v;
                                                                   }
                                                                   if ((f | 0) == 1349076270) {
                                                                    break i;
                                                                   }
                                                                   if ((f | 0) == 1349076315) {
                                                                    break G;
                                                                   }
                                                                   if ((f | 0) == 1349078085) {
                                                                    break Z;
                                                                   }
                                                                   if ((f | 0) == 1349078099) {
                                                                    break _;
                                                                   }
                                                                   if ((f | 0) == 1349079131) {
                                                                    break J;
                                                                   }
                                                                   if ((f | 0) == 1378758190) {
                                                                    break n;
                                                                   }
                                                                   if ((f | 0) == 1381183022) {
                                                                    break y;
                                                                   }
                                                                   if ((f | 0) == 1447374382) {
                                                                    break k;
                                                                   }
                                                                   if ((f | 0) == 1447383630) {
                                                                    break s;
                                                                   }
                                                                   if ((f | 0) == 1447385902) {
                                                                    break I;
                                                                   }
                                                                   if ((f | 0) == 1447447623) {
                                                                    break p;
                                                                   }
                                                                   if ((f | 0) == 1447839022) {
                                                                    break fa;
                                                                   }
                                                                   if ((f | 0) == 1447842606) {
                                                                    break ga;
                                                                   }
                                                                   if ((f | 0) == 1448106798) {
                                                                    break L;
                                                                   }
                                                                   if ((f | 0) == 1448226350) {
                                                                    break A;
                                                                   }
                                                                   if ((f | 0) == 1448291886) {
                                                                    break T;
                                                                   }
                                                                   if ((f | 0) == 1448297006) {
                                                                    break ea;
                                                                   }
                                                                   if ((f | 0) == 1448297774) {
                                                                    break da;
                                                                   }
                                                                   if ((f | 0) != 1682320942) {
                                                                    if ((f | 0) == 1718508334) {
                                                                     break C;
                                                                    }
                                                                    if ((f | 0) != 1179594286 | c >>> 0 > 4) {
                                                                     break d;
                                                                    }
                                                                    if (!Lb(v[b >> 2], v[b + 8 >> 2], c)) {
                                                                     break d;
                                                                    }
                                                                    q = e, r = Qw(b, c), v[q >> 2] = r;
                                                                    break e;
                                                                   }
                                                                   if (c >>> 0 > 1) {
                                                                    break d;
                                                                   }
                                                                   if (!Lb(v[b >> 2], v[b + 8 >> 2], c)) {
                                                                    break d;
                                                                   }
                                                                   q = e, r = Jd(b, c), t[q + 15 | 0] = r;
                                                                   break e;
                                                                  }
                                                                  if (c >>> 0 > 4) {
                                                                   break d;
                                                                  }
                                                                  if (!Lb(v[b >> 2], v[b + 8 >> 2], c)) {
                                                                   break d;
                                                                  }
                                                                  q = e, r = Qw(b, c), v[q + 4 >> 2] = r;
                                                                  break e;
                                                                 }
                                                                 if (c >>> 0 > 4) {
                                                                  break d;
                                                                 }
                                                                 if (!Lb(v[b >> 2], v[b + 8 >> 2], c)) {
                                                                  break d;
                                                                 }
                                                                 q = e, r = Qw(b, c), v[q + 8 >> 2] = r;
                                                                 break e;
                                                                }
                                                                if (c >>> 0 > 1) {
                                                                 break d;
                                                                }
                                                                if (!Lb(v[b >> 2], v[b + 8 >> 2], c)) {
                                                                 break d;
                                                                }
                                                                q = e, r = Jd(b, c), t[q + 61 | 0] = r;
                                                                break e;
                                                               }
                                                               if (c >>> 0 > 1) {
                                                                break d;
                                                               }
                                                               if (!Lb(v[b >> 2], v[b + 8 >> 2], c)) {
                                                                break d;
                                                               }
                                                               q = e, r = Jd(b, c), t[q + 62 | 0] = r;
                                                               break e;
                                                              }
                                                              if (c >>> 0 > 1) {
                                                               break d;
                                                              }
                                                              if (!Lb(v[b >> 2], v[b + 8 >> 2], c)) {
                                                               break d;
                                                              }
                                                              q = e, r = Jd(b, c), t[q + 63 | 0] = r;
                                                              break e;
                                                             }
                                                             if (c >>> 0 > 1) {
                                                              break d;
                                                             }
                                                             if (!Lb(v[b >> 2], v[b + 8 >> 2], c)) {
                                                              break d;
                                                             }
                                                             q = e, r = Jd(b, c), t[q + 64 | 0] = r;
                                                             break e;
                                                            }
                                                            if (c >>> 0 > 1) {
                                                             break d;
                                                            }
                                                            if (!Lb(v[b >> 2], v[b + 8 >> 2], c)) {
                                                             break d;
                                                            }
                                                            q = e, r = Jd(b, c), t[q + 81 | 0] = r;
                                                            break e;
                                                           }
                                                           if (c >>> 0 > 1) {
                                                            break d;
                                                           }
                                                           if (!Lb(v[b >> 2], v[b + 8 >> 2], c)) {
                                                            break d;
                                                           }
                                                           q = e, r = Jd(b, c), t[q + 82 | 0] = r;
                                                           break e;
                                                          }
                                                          if (c >>> 0 > 1) {
                                                           break d;
                                                          }
                                                          if (!Lb(v[b >> 2], v[b + 8 >> 2], c)) {
                                                           break d;
                                                          }
                                                          q = e, r = Jd(b, c), t[q + 83 | 0] = r;
                                                          break e;
                                                         }
                                                         if (c >>> 0 > 1) {
                                                          break d;
                                                         }
                                                         if (!Lb(v[b >> 2], v[b + 8 >> 2], c)) {
                                                          break d;
                                                         }
                                                         q = e, r = Jd(b, c), t[q + 84 | 0] = r;
                                                         break e;
                                                        }
                                                        if (c >>> 0 > 1) {
                                                         break d;
                                                        }
                                                        if (!Lb(v[b >> 2], v[b + 8 >> 2], c)) {
                                                         break d;
                                                        }
                                                        q = e, r = Jd(b, c), t[q + 101 | 0] = r;
                                                        break e;
                                                       }
                                                       if (c >>> 0 > 1) {
                                                        break d;
                                                       }
                                                       if (!Lb(v[b >> 2], v[b + 8 >> 2], c)) {
                                                        break d;
                                                       }
                                                       q = e, r = Jd(b, c), t[q + 102 | 0] = r;
                                                       break e;

                                                      case 0:
                                                       if (c >>> 0 > 1) {
                                                        break d;
                                                       }
                                                       if (!Lb(v[b >> 2], v[b + 8 >> 2], c)) {
                                                        break d;
                                                       }
                                                       q = e, r = Jd(b, c), t[q + 103 | 0] = r;
                                                       break e;

                                                      case 3:
                                                       break Y;

                                                      case 1:
                                                      case 2:
                                                       break d;
                                                      }
                                                     }
                                                     if (c >>> 0 > 1) {
                                                      break d;
                                                     }
                                                     if (!Lb(v[b >> 2], v[b + 8 >> 2], c)) {
                                                      break d;
                                                     }
                                                     q = e, r = Jd(b, c), t[q + 104 | 0] = r;
                                                     break e;
                                                    }
                                                    if (c >>> 0 > 1) {
                                                     break d;
                                                    }
                                                    if (!Lb(v[b >> 2], v[b + 8 >> 2], c)) {
                                                     break d;
                                                    }
                                                    q = e, r = Jd(b, c), t[q + 16 | 0] = r;
                                                    break e;
                                                   }
                                                   if (c >>> 0 > 1) {
                                                    break d;
                                                   }
                                                   if (!Lb(v[b >> 2], v[b + 8 >> 2], c)) {
                                                    break d;
                                                   }
                                                   q = e, r = Jd(b, c), t[q + 17 | 0] = r;
                                                   break e;
                                                  }
                                                  if (c >>> 0 > 1) {
                                                   break d;
                                                  }
                                                  if (!Lb(v[b >> 2], v[b + 8 >> 2], c)) {
                                                   break d;
                                                  }
                                                  q = e, r = Jd(b, c), t[q + 18 | 0] = r;
                                                  break e;
                                                 }
                                                 if (c >>> 0 > 1) {
                                                  break d;
                                                 }
                                                 if (!Lb(v[b >> 2], v[b + 8 >> 2], c)) {
                                                  break d;
                                                 }
                                                 q = e, r = Jd(b, c), t[q + 19 | 0] = r;
                                                 break e;
                                                }
                                                if (c >>> 0 > 1) {
                                                 break d;
                                                }
                                                if (!Lb(v[b >> 2], v[b + 8 >> 2], c)) {
                                                 break d;
                                                }
                                                q = e, r = Jd(b, c), t[q + 20 | 0] = r;
                                                break e;
                                               }
                                               if (c >>> 0 > 1) {
                                                break d;
                                               }
                                               if (!Lb(v[b >> 2], v[b + 8 >> 2], c)) {
                                                break d;
                                               }
                                               q = e, r = Jd(b, c), t[q + 21 | 0] = r;
                                               break e;
                                              }
                                              if (c >>> 0 > 1) {
                                               break d;
                                              }
                                              if (!Lb(v[b >> 2], v[b + 8 >> 2], c)) {
                                               break d;
                                              }
                                              q = e, r = Jd(b, c), t[q + 22 | 0] = r;
                                              break e;
                                             }
                                             if (c >>> 0 > 2) {
                                              break d;
                                             }
                                             if (!Lb(v[b >> 2], v[b + 8 >> 2], c)) {
                                              break d;
                                             }
                                             q = e, r = FF(b, c), u[q + 28 >> 1] = r;
                                             break e;
                                            }
                                            if (c >>> 0 > 1) {
                                             break d;
                                            }
                                            if (!Lb(v[b >> 2], v[b + 8 >> 2], c)) {
                                             break d;
                                            }
                                            q = e, r = Jd(b, c), t[q + 30 | 0] = r;
                                            break e;
                                           }
                                           if (c >>> 0 > 1) {
                                            break d;
                                           }
                                           if (!Lb(v[b >> 2], v[b + 8 >> 2], c)) {
                                            break d;
                                           }
                                           q = e, r = Jd(b, c), t[q + 31 | 0] = r;
                                           break e;
                                          }
                                          if (c >>> 0 > 1) {
                                           break d;
                                          }
                                          if (!Lb(v[b >> 2], v[b + 8 >> 2], c)) {
                                           break d;
                                          }
                                          q = e, r = EF(b, c), t[q + 26 | 0] = r;
                                          break e;
                                         }
                                         if (c >>> 0 > 1) {
                                          break d;
                                         }
                                         if (!Lb(v[b >> 2], v[b + 8 >> 2], c)) {
                                          break d;
                                         }
                                         q = e, r = Jd(b, c), t[q + 27 | 0] = r;
                                         break e;
                                        }
                                        d = h + 8 | 0;
                                        ge(d, b, c);
                                        j = gc(h + 28 | 0, d);
                                        tb(d);
                                        i = Vh(e, 0);
                                        g = v[i >> 2];
                                        d = 0;
                                        while (1) {
                                         if (Rd(g, v[i + 4 >> 2]) >>> 0 <= d >>> 0) {
                                          tb(j);
                                          break e;
                                         }
                                         v[31601] = 0;
                                         k = Q(192, j | 0) | 0;
                                         g = v[31601];
                                         v[31601] = 0;
                                         if ((g | 0) == 1) {
                                          break h;
                                         }
                                         g = v[i >> 2];
                                         q = xb(g, d), r = k, u[q >> 1] = r;
                                         d = d + 1 | 0;
                                         continue;
                                        }
                                       }
                                       d = h + 8 | 0;
                                       ge(d, b, c);
                                       j = gc(h + 28 | 0, d);
                                       tb(d);
                                       i = Vh(e, 1);
                                       g = v[i >> 2];
                                       d = 0;
                                       while (1) {
                                        if (Rd(g, v[i + 4 >> 2]) >>> 0 <= d >>> 0) {
                                         tb(j);
                                         break e;
                                        }
                                        v[31601] = 0;
                                        k = Q(192, j | 0) | 0;
                                        g = v[31601];
                                        v[31601] = 0;
                                        if ((g | 0) != 1) {
                                         g = v[i >> 2];
                                         q = xb(g, d), r = k, u[q >> 1] = r;
                                         d = d + 1 | 0;
                                         continue;
                                        }
                                        break;
                                       }
                                       d = M() | 0;
                                       break g;
                                      }
                                      d = h + 8 | 0;
                                      ge(d, b, c);
                                      j = gc(h + 28 | 0, d);
                                      tb(d);
                                      i = Vh(e, 2);
                                      g = v[i >> 2];
                                      d = 0;
                                      while (1) {
                                       if (Rd(g, v[i + 4 >> 2]) >>> 0 <= d >>> 0) {
                                        tb(j);
                                        break e;
                                       }
                                       v[31601] = 0;
                                       k = Q(192, j | 0) | 0;
                                       g = v[31601];
                                       v[31601] = 0;
                                       if ((g | 0) != 1) {
                                        g = v[i >> 2];
                                        q = xb(g, d), r = k, u[q >> 1] = r;
                                        d = d + 1 | 0;
                                        continue;
                                       }
                                       break;
                                      }
                                      d = M() | 0;
                                      break g;
                                     }
                                     d = h + 8 | 0;
                                     ge(d, b, c);
                                     j = gc(h + 28 | 0, d);
                                     tb(d);
                                     i = Vh(e, 0);
                                     g = v[i >> 2];
                                     d = 0;
                                     while (1) {
                                      if (Rd(g, v[i + 4 >> 2]) >>> 0 <= d >>> 0) {
                                       tb(j);
                                       break e;
                                      }
                                      v[31601] = 0;
                                      k = Q(193, j | 0) | 0;
                                      g = v[31601];
                                      v[31601] = 0;
                                      if ((g | 0) != 1) {
                                       g = v[i >> 2];
                                       q = xb(g, d), r = k, t[q + 2 | 0] = r;
                                       d = d + 1 | 0;
                                       continue;
                                      }
                                      break;
                                     }
                                     d = M() | 0;
                                     break g;
                                    }
                                    d = h + 8 | 0;
                                    ge(d, b, c);
                                    j = gc(h + 28 | 0, d);
                                    tb(d);
                                    i = Vh(e, 1);
                                    g = v[i >> 2];
                                    d = 0;
                                    while (1) {
                                     if (Rd(g, v[i + 4 >> 2]) >>> 0 <= d >>> 0) {
                                      tb(j);
                                      break e;
                                     }
                                     v[31601] = 0;
                                     k = Q(193, j | 0) | 0;
                                     g = v[31601];
                                     v[31601] = 0;
                                     if ((g | 0) != 1) {
                                      g = v[i >> 2];
                                      q = xb(g, d), r = k, t[q + 2 | 0] = r;
                                      d = d + 1 | 0;
                                      continue;
                                     }
                                     break;
                                    }
                                    d = M() | 0;
                                    break g;
                                   }
                                   d = h + 8 | 0;
                                   ge(d, b, c);
                                   j = gc(h + 28 | 0, d);
                                   tb(d);
                                   i = Vh(e, 2);
                                   g = v[i >> 2];
                                   d = 0;
                                   while (1) {
                                    if (Rd(g, v[i + 4 >> 2]) >>> 0 <= d >>> 0) {
                                     tb(j);
                                     break e;
                                    }
                                    v[31601] = 0;
                                    k = Q(193, j | 0) | 0;
                                    g = v[31601];
                                    v[31601] = 0;
                                    if ((g | 0) != 1) {
                                     g = v[i >> 2];
                                     q = xb(g, d), r = k, t[q + 2 | 0] = r;
                                     d = d + 1 | 0;
                                     continue;
                                    }
                                    break;
                                   }
                                   d = M() | 0;
                                   break g;
                                  }
                                  if (c >>> 0 > 128) {
                                   break d;
                                  }
                                  g = e + 108 | 0;
                                  d = h + 8 | 0;
                                  ge(d, b, c);
                                  j = gc(h + 28 | 0, d);
                                  tb(d);
                                  d = 0;
                                  while (1) {
                                   if ((d | 0) == 128) {
                                    tb(j);
                                    break e;
                                   }
                                   v[31601] = 0;
                                   i = Q(193, j | 0) | 0;
                                   k = v[31601];
                                   v[31601] = 0;
                                   if ((k | 0) != 1) {
                                    q = wb(g, d), r = i, t[q | 0] = r;
                                    d = d + 1 | 0;
                                    continue;
                                   }
                                   break;
                                  }
                                  d = M() | 0;
                                  break g;
                                 }
                                 if (c >>> 0 > 256) {
                                  break d;
                                 }
                                 g = e + 236 | 0;
                                 d = h + 8 | 0;
                                 ge(d, b, c);
                                 j = gc(h + 28 | 0, d);
                                 tb(d);
                                 d = 0;
                                 while (1) {
                                  if ((d | 0) == 128) {
                                   tb(j);
                                   break e;
                                  }
                                  v[31601] = 0;
                                  i = Q(192, j | 0) | 0;
                                  k = v[31601];
                                  v[31601] = 0;
                                  if ((k | 0) != 1) {
                                   q = $b(g, d), r = i, u[q >> 1] = r;
                                   d = d + 1 | 0;
                                   continue;
                                  }
                                  break;
                                 }
                                 d = M() | 0;
                                 break g;
                                }
                                if (c >>> 0 > 32) {
                                 break d;
                                }
                                i = e + 492 | 0;
                                d = h + 8 | 0;
                                ge(d, b, c);
                                j = gc(h + 28 | 0, d);
                                tb(d);
                                g = Eb(d);
                                d = 0;
                                while (1) {
                                 if ((c | 0) == (d | 0)) {
                                  break f;
                                 }
                                 v[31601] = 0;
                                 k = Q(194, j | 0) | 0;
                                 m = v[31601];
                                 v[31601] = 0;
                                 ia: {
                                  if ((m | 0) == 1) {
                                   break ia;
                                  }
                                  v[31601] = 0;
                                  O(195, g | 0, k | 0) | 0;
                                  k = v[31601];
                                  v[31601] = 0;
                                  if ((k | 0) == 1) {
                                   break ia;
                                  }
                                  d = d + 1 | 0;
                                  continue;
                                 }
                                 break;
                                }
                                d = M() | 0;
                                sb(g);
                                break g;
                               }
                               if (c >>> 0 > 32) {
                                break d;
                               }
                               i = e + 524 | 0;
                               d = h + 8 | 0;
                               ge(d, b, c);
                               j = gc(h + 28 | 0, d);
                               tb(d);
                               g = Eb(d);
                               d = 0;
                               ja: {
                                while (1) {
                                 if ((c | 0) != (d | 0)) {
                                  v[31601] = 0;
                                  k = Q(194, j | 0) | 0;
                                  m = v[31601];
                                  v[31601] = 0;
                                  if ((m | 0) == 1) {
                                   break ja;
                                  }
                                  v[31601] = 0;
                                  O(195, g | 0, k | 0) | 0;
                                  k = v[31601];
                                  v[31601] = 0;
                                  if ((k | 0) == 1) {
                                   break ja;
                                  }
                                  d = d + 1 | 0;
                                  continue;
                                 }
                                 break;
                                }
                                zc(i, g);
                                sb(g);
                                tb(j);
                                break e;
                               }
                               d = M() | 0;
                               sb(g);
                               break g;
                              }
                              if (c >>> 0 > 1) {
                               break d;
                              }
                              if (!Lb(v[b >> 2], v[b + 8 >> 2], c)) {
                               break d;
                              }
                              q = e, r = Jd(b, c), t[q + 34 | 0] = r;
                              break e;
                             }
                             if (c >>> 0 > 2) {
                              break d;
                             }
                             if (!Lb(v[b >> 2], v[b + 8 >> 2], c)) {
                              break d;
                             }
                             q = e, r = FF(b, c), u[q + 12 >> 1] = r;
                             break e;
                            }
                            if (c >>> 0 > 1) {
                             break d;
                            }
                            if (!Lb(v[b >> 2], v[b + 8 >> 2], c)) {
                             break d;
                            }
                            q = e, r = Jd(b, c), t[q + 23 | 0] = r;
                            break e;
                           }
                           if (c >>> 0 > 1) {
                            break d;
                           }
                           if (!Lb(v[b >> 2], v[b + 8 >> 2], c)) {
                            break d;
                           }
                           q = e, r = Jd(b, c), t[q + 24 | 0] = r;
                           break e;
                          }
                          if (c >>> 0 > 1) {
                           break d;
                          }
                          if (!Lb(v[b >> 2], v[b + 8 >> 2], c)) {
                           break d;
                          }
                          q = e, r = Jd(b, c), t[q + 25 | 0] = r;
                          break e;
                         }
                         if (c >>> 0 > 1) {
                          break d;
                         }
                         if (!Lb(v[b >> 2], v[b + 8 >> 2], c)) {
                          break d;
                         }
                         q = e, r = Jd(b, c), t[q + 35 | 0] = r;
                         break e;
                        }
                        if (c >>> 0 > 1) {
                         break d;
                        }
                        if (!Lb(v[b >> 2], v[b + 8 >> 2], c)) {
                         break d;
                        }
                        q = e, r = Jd(b, c), t[q + 36 | 0] = r;
                        break e;
                       }
                       if (c >>> 0 > 1) {
                        break d;
                       }
                       if (!Lb(v[b >> 2], v[b + 8 >> 2], c)) {
                        break d;
                       }
                       q = e, r = Jd(b, c), t[q + 105 | 0] = r;
                       break e;
                      }
                      if (c >>> 0 > 1) {
                       break d;
                      }
                      if (!Lb(v[b >> 2], v[b + 8 >> 2], c)) {
                       break d;
                      }
                      q = e, r = Jd(b, c), t[q + 85 | 0] = r;
                      break e;
                     }
                     if (c >>> 0 > 1) {
                      break d;
                     }
                     if (!Lb(v[b >> 2], v[b + 8 >> 2], c)) {
                      break d;
                     }
                     q = e, r = Jd(b, c), t[q + 65 | 0] = r;
                     break e;
                    }
                    if (c >>> 0 > 1) {
                     break d;
                    }
                    if (!Lb(v[b >> 2], v[b + 8 >> 2], c)) {
                     break d;
                    }
                    q = e, r = Jd(b, c), t[q + 100 | 0] = r;
                    break e;
                   }
                   if (c >>> 0 > 1) {
                    break d;
                   }
                   if (!Lb(v[b >> 2], v[b + 8 >> 2], c)) {
                    break d;
                   }
                   q = e, r = Jd(b, c), t[q + 80 | 0] = r;
                   break e;
                  }
                  if (c >>> 0 > 1) {
                   break d;
                  }
                  if (!Lb(v[b >> 2], v[b + 8 >> 2], c)) {
                   break d;
                  }
                  q = e, r = Jd(b, c), t[q + 60 | 0] = r;
                  break e;
                 }
                 if (c >>> 0 > 1) {
                  break d;
                 }
                 if (!Lb(v[b >> 2], v[b + 8 >> 2], c)) {
                  break d;
                 }
                 q = e, r = EF(b, c), t[q + 33 | 0] = r;
                 break e;
                }
                g = 1;
                d = vp(b, c);
                if (!up(d)) {
                 break d;
                }
                t[e + 14 | 0] = d;
                break d;
               }
               q = e, r = B(Ow(b, c), 1e4) + (y[e + 40 >> 2] % 1e4 | 0) | 0, v[q + 40 >> 2] = r;
               break e;
              }
              g = (Ow(b, c) >>> 0) % 1e4 | 0;
              d = v[e + 40 >> 2];
              v[e + 40 >> 2] = g + d - (d >>> 0) % 1e4;
              break e;
             }
             v[h + 28 >> 2] = 240;
             q = h, r = vp(b, c), v[q + 8 >> 2] = r;
             eh(e + 48 | 0, v[Gb(h + 28 | 0, h + 8 | 0) >> 2]);
             break e;
            }
            v[h + 28 >> 2] = 240;
            q = h, r = vp(b, c), v[q + 8 >> 2] = r;
            eh(e + 68 | 0, v[Gb(h + 28 | 0, h + 8 | 0) >> 2]);
            break e;
           }
           v[h + 28 >> 2] = 240;
           q = h, r = vp(b, c), v[q + 8 >> 2] = r;
           eh(e + 88 | 0, v[Gb(h + 28 | 0, h + 8 | 0) >> 2]);
           break e;
          }
          d = M() | 0;
         }
         tb(j);
         P(d | 0);
         p();
        }
        zc(i, g);
        sb(g);
        tb(j);
       }
       g = 1;
      }
      eb = h + 48 | 0;
      if (!g) {
       Ub(b, c);
       break c;
      }
      if ((Cn(16759) | 0) == (f | 0)) {
       d = w[e + 15 | 0];
       t[e + 15 | 0] = 0;
       t[e + 60 | 0] = d >>> 1 & 2 | (d << 1 & 4 | (w[e + 60 | 0] & 240 | d & 1));
       t[e + 100 | 0] = d >>> 5 & 4 | (w[e + 100 | 0] & 224 | d >>> 6 & 1);
       t[e + 80 | 0] = d >>> 4 & 2 | (d >>> 2 & 4 | (w[e + 80 | 0] & 240 | d >>> 3 & 1));
      }
     }
    }
    l = l + 1 | 0;
    continue;
   }
  }
 }
 return n | 0;
}

function kY(a, b, c, d, e, f) {
 var g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = C(0), o = 0, q = 0, r = 0, s = C(0), A = 0, D = C(0), E = 0, F = 0, G = C(0), H = C(0), I = 0, J = C(0), K = C(0), L = 0, M = 0, N = 0, O = 0, P = 0, Q = 0, R = 0, S = 0, T = 0, U = 0, V = 0, W = 0, X = 0, Y = C(0), _ = C(0), $ = 0, aa = 0, ba = 0, ca = 0, da = C(0), ea = C(0), fa = 0, ga = C(0), ha = 0, ia = 0, ja = 0, ka = 0, la = 0, ma = 0, na = 0, oa = 0, pa = 0, qa = 0, ra = 0, sa = 0, ta = 0;
 ba = eb - 16 | 0;
 eb = ba;
 a: {
  if (v[a + 1420 >> 2] >= 0) {
   v[f >> 2] = 0;
   d = b;
   e = 0;
   h = v[a + 1420 >> 2];
   b = (h | 0) > 0 ? h : 0;
   q = a + 1424 | 0;
   while (1) {
    if ((b | 0) != (e | 0)) {
     v[(q + B(e, 20) | 0) + 12 >> 2] = 0;
     e = e + 1 | 0;
     continue;
    }
    break;
   }
   b: {
    c: {
     d: {
      if ((h | 0) > 3) {
       break d;
      }
      e = 0;
      if ((c | 0) < 4) {
       break c;
      }
      c = c - 3 | 0;
      b = 0;
      while (1) {
       if ((b | 0) == (c | 0)) {
        break d;
       }
       e: {
        f: {
         k = b + d | 0;
         if (w[k | 0] != 79 | (w[k | 0] | w[k + 1 | 0] << 8 | (w[k + 2 | 0] << 16 | w[k + 3 | 0] << 24)) != (w[125436] | w[125437] << 8 | (w[125438] << 16 | w[125439] << 24))) {
          break f;
         }
         j = b + 26 | 0;
         if ((j | 0) >= (c | 0)) {
          break e;
         }
         e = b + 27 | 0;
         i = d + j | 0;
         f = w[i | 0];
         if ((e + f | 0) >= (c | 0)) {
          break e;
         }
         l = d + e | 0;
         g = f + 27 | 0;
         e = 0;
         while (1) if ((e | 0) == (f | 0)) {
          e = 0;
          f = 0;
          while (1) {
           o = 22;
           if ((e | 0) != 22) {
            f = hz(f, w[e + k | 0]);
            e = e + 1 | 0;
            continue;
           }
           break;
          }
          while (1) {
           if ((o | 0) != 26) {
            o = o + 1 | 0;
            f = hz(f, 0);
            continue;
           }
           break;
          }
          v[a + 1420 >> 2] = h + 1;
          e = q + B(h, 20) | 0;
          v[e + 8 >> 2] = f;
          v[e + 4 >> 2] = g - 26;
          v[e >> 2] = w[k + 22 | 0] | w[k + 23 | 0] << 8 | (w[k + 24 | 0] << 16 | w[k + 25 | 0] << 24);
          f = -1;
          if (w[(l + w[i | 0] | 0) - 1 | 0] != 255) {
           f = w[k + 6 | 0] | w[k + 7 | 0] << 8 | (w[k + 8 | 0] << 16 | w[k + 9 | 0] << 24);
          }
          v[e + 12 >> 2] = j;
          v[e + 16 >> 2] = f;
          h = v[a + 1420 >> 2];
          if ((h | 0) != 4) {
           break f;
          }
          h = 4;
          break d;
         } else {
          g = w[e + l | 0] + g | 0;
          e = e + 1 | 0;
          continue;
         }
        }
        b = b + 1 | 0;
        continue;
       }
       break;
      }
      c = b;
     }
     g = 0;
     g: while (1) {
      m = (g | 0) > (h | 0) ? g : h;
      while (1) {
       if ((g | 0) == (m | 0)) {
        break b;
       }
       e = 0;
       b = q + B(g, 20) | 0;
       k = v[b + 4 >> 2];
       l = v[b + 12 >> 2];
       i = c - l | 0;
       j = (i | 0) > (k | 0) ? k : i;
       E = (j | 0) > 0 ? j : 0;
       U = d + l | 0;
       f = v[b + 8 >> 2];
       while (1) {
        if ((e | 0) != (E | 0)) {
         f = hz(f, w[e + U | 0]);
         e = e + 1 | 0;
         continue;
        }
        break;
       }
       v[b + 8 >> 2] = f;
       v[b + 4 >> 2] = k - j;
       if ((i | 0) >= (k | 0)) {
        if (v[b >> 2] == (f | 0)) {
         v[a + 1380 >> 2] = -1;
         v[a + 992 >> 2] = 0;
         v[a + 1420 >> 2] = -1;
         b = v[b + 16 >> 2];
         v[a + 1060 >> 2] = b;
         v[a + 1064 >> 2] = (b | 0) != -1;
         e = j + l | 0;
         break c;
        }
        e = h - 1 | 0;
        v[a + 1420 >> 2] = e;
        e = q + B(e, 20) | 0;
        f = v[e + 4 >> 2];
        v[b >> 2] = v[e >> 2];
        v[b + 4 >> 2] = f;
        v[b + 16 >> 2] = v[e + 16 >> 2];
        f = v[e + 12 >> 2];
        v[b + 8 >> 2] = v[e + 8 >> 2];
        v[b + 12 >> 2] = f;
        h = v[a + 1420 >> 2];
        continue g;
       } else {
        g = g + 1 | 0;
        continue;
       }
      }
     }
    }
    c = e;
   }
   break a;
  }
  v[a + 100 >> 2] = 0;
  v[a + 32 >> 2] = b;
  v[a + 40 >> 2] = b + c;
  if (!NL(a)) {
   v[f >> 2] = 0;
   c = 0;
   break a;
  }
  ca = eb - 16 | 0;
  eb = ca;
  la = ba + 4 | 0;
  v[a + 1504 >> 2] = 0;
  v[a + 1508 >> 2] = 0;
  h: {
   if (v[a + 96 >> 2]) {
    break h;
   }
   i: {
    j: {
     k: {
      if (v[a + 1380 >> 2] != -1) {
       break k;
      }
      c = ff(a);
      if (v[a + 96 >> 2]) {
       break i;
      }
      if ((c | 0) != 79) {
       break j;
      }
      if ((ff(a) | 0) != 103) {
       break j;
      }
      if ((ff(a) | 0) != 103) {
       break j;
      }
      if ((ff(a) | 0) != 83) {
       break j;
      }
      if (!ML(a)) {
       break i;
      }
      if (!(t[a + 1375 | 0] & 1)) {
       break k;
      }
      t[a + 1376 | 0] = 0;
      v[a + 1384 >> 2] = 0;
      bc(a, 32);
      break i;
     }
     g = ez(a);
     break i;
    }
    bc(a, 30);
   }
   if (!g) {
    break h;
   }
   if (qc(a, 1)) {
    bc(a, 35);
    break h;
   }
   l: {
    m: {
     if (!(v[a + 84 >> 2] != v[a + 92 >> 2] ? v[a + 80 >> 2] : 0)) {
      c = qc(a, Hm(v[a + 408 >> 2] - 1 | 0));
      if ((c | 0) == -1 | (c | 0) >= v[a + 408 >> 2]) {
       break h;
      }
      v[ca + 12 >> 2] = c;
      q = B(c, 6) + a | 0;
      if (!w[q + 412 | 0]) {
       h = v[a + 112 >> 2];
       g = h >> 1;
       break m;
      }
      h = v[a + 116 >> 2];
      g = h >> 1;
      c = qc(a, 1);
      k = (qc(a, 1) | 0) != 0;
      if (c | !w[q + 412 | 0]) {
       break m;
      }
      v[la >> 2] = h - v[a + 112 >> 2] >> 2;
      c = v[a + 112 >> 2] + h >> 2;
      break l;
     }
     Z(6325, 13258, 3152, 10763);
     p();
    }
    v[la >> 2] = 0;
    c = g;
   }
   v[ca + 8 >> 2] = c;
   n: {
    if (!(!w[q + 412 | 0] | k)) {
     c = B(h, 3);
     v[ba + 8 >> 2] = c - v[a + 112 >> 2] >> 2;
     h = c + v[a + 112 >> 2] >> 2;
     break n;
    }
    v[ba + 8 >> 2] = g;
   }
   v[ca + 4 >> 2] = h;
   h = 1;
  }
  if (h) {
   U = v[la >> 2];
   ha = v[ba + 8 >> 2];
   ma = v[ca + 4 >> 2];
   h = 0;
   N = eb - 2368 | 0;
   eb = N;
   O = a + 996 | 0;
   A = a + 132 | 0;
   oa = B(v[ca + 12 >> 2], 6) + a | 0;
   P = v[a + 404 >> 2] + B(w[oa + 413 | 0], 40) | 0;
   r = P + 9 | 0;
   V = v[((w[oa + 412 | 0] << 2) + a | 0) + 104 >> 2];
   ia = V >> 1;
   ra = 0 - ia | 0;
   o: {
    while (1) {
     c = v[a + 4 >> 2];
     if ((c | 0) > (h | 0)) {
      c = w[(v[P + 4 >> 2] + B(h, 3) | 0) + 2 | 0];
      g = h << 2;
      L = g + (N + 1344 | 0) | 0;
      v[L >> 2] = 0;
      k = w[c + r | 0];
      if (x[A + (k << 1) >> 1]) {
       q = v[a + 260 >> 2];
       p: {
        q: {
         if (!qc(a, 1)) {
          break q;
         }
         c = 2;
         l = v[g + O >> 2];
         q = q + B(k, 1596) | 0;
         E = v[(w[q + 1588 | 0] << 2) + 88844 >> 2];
         g = Hm(E) - 1 | 0;
         sa = l, ta = qc(a, g), u[sa >> 1] = ta;
         sa = l, ta = qc(a, g), u[sa + 2 >> 1] = ta;
         fa = q + 82 | 0;
         Q = q + 65 | 0;
         T = q + 49 | 0;
         $ = q + 33 | 0;
         R = q + 1 | 0;
         j = 0;
         while (1) {
          if (w[q | 0] > j >>> 0) {
           i = w[j + R | 0];
           o = w[i + T | 0];
           m = -1 << o;
           S = w[i + $ | 0];
           r: {
            if (!o) {
             k = 0;
             break r;
            }
            g = v[a + 124 >> 2] + B(w[i + Q | 0], 2096) | 0;
            if (v[a + 1396 >> 2] <= 9) {
             tl(a);
            }
            k = v[a + 1392 >> 2];
            W = u[(g + ((k & 1023) << 1) | 0) + 36 >> 1];
            s: {
             if ((W | 0) >= 0) {
              F = k;
              W = W & 65535;
              k = w[W + v[g + 8 >> 2] | 0];
              v[a + 1392 >> 2] = F >>> k;
              k = v[a + 1396 >> 2] - k | 0;
              v[a + 1396 >> 2] = (k | 0) > 0 ? k : 0;
              k = (k | 0) < 0 ? -1 : W;
              break s;
             }
             k = Gm(a, g);
            }
            if (!w[g + 23 | 0]) {
             break r;
            }
            k = v[v[g + 2088 >> 2] + (k << 2) >> 2];
           }
           W = m ^ -1;
           g = c + S | 0;
           S = fa + (i << 4) | 0;
           while (1) {
            if ((c | 0) != (g | 0)) {
             m = 0;
             i = u[S + ((k & W) << 1) >> 1];
             t: {
              if ((i | 0) < 0) {
               break t;
              }
              i = v[a + 124 >> 2] + B(i & 65535, 2096) | 0;
              if (v[a + 1396 >> 2] <= 9) {
               tl(a);
              }
              m = v[a + 1392 >> 2];
              M = u[(i + ((m & 1023) << 1) | 0) + 36 >> 1];
              u: {
               if ((M | 0) >= 0) {
                F = m;
                M = M & 65535;
                m = w[M + v[i + 8 >> 2] | 0];
                v[a + 1392 >> 2] = F >>> m;
                m = v[a + 1396 >> 2] - m | 0;
                v[a + 1396 >> 2] = (m | 0) > 0 ? m : 0;
                m = (m | 0) < 0 ? -1 : M;
                break u;
               }
               m = Gm(a, i);
              }
              if (!w[i + 23 | 0]) {
               break t;
              }
              m = v[v[i + 2088 >> 2] + (m << 2) >> 2];
             }
             k = k >> o;
             u[l + (c << 1) >> 1] = m;
             c = c + 1 | 0;
             continue;
            }
            break;
           }
           j = j + 1 | 0;
           c = g;
           continue;
          }
          break;
         }
         if (v[a + 1396 >> 2] == -1) {
          break q;
         }
         u[N + 320 >> 1] = 257;
         g = q + 338 | 0;
         o = q + 1088 | 0;
         c = 2;
         while (1) {
          m = v[q + 1592 >> 2];
          if ((m | 0) <= (c | 0)) {
           c = 0;
           while (1) {
            if ((c | 0) >= (m | 0)) {
             break p;
            }
            if (!w[(N + 320 | 0) + c | 0]) {
             u[l + (c << 1) >> 1] = 65535;
             m = v[q + 1592 >> 2];
            }
            c = c + 1 | 0;
            continue;
           }
          } else {
           k = c << 1;
           i = k + o | 0;
           L = w[i | 0];
           m = L << 1;
           j = x[m + g >> 1];
           fa = w[i + 1 | 0];
           Q = fa << 1;
           T = u[l + m >> 1];
           i = u[Q + l >> 1] - T | 0;
           m = i >> 31;
           j = (B((i ^ m) - m | 0, x[g + k >> 1] - j | 0) | 0) / (x[g + Q >> 1] - j | 0) | 0;
           m = T + ((i | 0) < 0 ? 0 - j | 0 : j) | 0;
           Q = k + l | 0;
           j = x[Q >> 1];
           v: {
            w: {
             if (j) {
              k = N + 320 | 0;
              t[k + fa | 0] = 1;
              t[k + L | 0] = 1;
              t[c + k | 0] = 1;
              k = j << 16 >> 16;
              i = E - m | 0;
              if ((k | 0) >= ((i | 0) < (m | 0) ? i : m) << 1) {
               if ((i | 0) > (m | 0)) {
                break v;
               }
               m = E + (j ^ -1) | 0;
               break w;
              }
              if (k & 1) {
               m = m - (k + 1 >>> 1 | 0) | 0;
               break w;
              }
              m = (k >> 1) + m | 0;
              break w;
             }
             t[(N + 320 | 0) + c | 0] = 0;
            }
            u[Q >> 1] = m;
           }
           c = c + 1 | 0;
           continue;
          }
         }
        }
        v[L >> 2] = 1;
       }
       h = h + 1 | 0;
       continue;
      } else {
       bc(a, 21);
       c = 0;
       break o;
      }
     }
     break;
    }
    if (!(v[a + 84 >> 2] != v[a + 92 >> 2] ? v[a + 80 >> 2] : 0)) {
     yc(N + 320 | 0, N + 1344 | 0, c << 2);
     h = x[P >> 1];
     c = 0;
     while (1) {
      if ((c | 0) == (h | 0)) {
       pa = P + 24 | 0;
       fa = a + 800 | 0;
      } else {
       g = v[P + 4 >> 2] + B(c, 3) | 0;
       k = (N + 1344 | 0) + (w[g | 0] << 2) | 0;
       x: {
        y: {
         if (!v[k >> 2]) {
          m = w[g + 1 | 0];
          break y;
         }
         m = w[g + 1 | 0];
         if (v[(N + 1344 | 0) + (m << 2) >> 2]) {
          break x;
         }
        }
        v[(N + 1344 | 0) + (m << 2) >> 2] = 0;
        v[k >> 2] = 0;
       }
       c = c + 1 | 0;
       continue;
      }
      break;
     }
     k = 0;
     while (1) {
      z: {
       if (w[P + 8 | 0] > k >>> 0) {
        m = 0;
        c = v[a + 4 >> 2];
        q = (c | 0) > 0 ? c : 0;
        c = 0;
        while (1) {
         if ((c | 0) == (q | 0)) {
          break z;
         }
         if (w[(v[P + 4 >> 2] + B(c, 3) | 0) + 2 | 0] == (k | 0)) {
          g = c << 2;
          A: {
           if (v[g + (N + 1344 | 0) >> 2]) {
            h = 1;
            g = 0;
            break A;
           }
           h = 0;
           g = v[g + fa >> 2];
          }
          t[m + N | 0] = h;
          v[(N + 256 | 0) + (m << 2) >> 2] = g;
          m = m + 1 | 0;
         }
         c = c + 1 | 0;
         continue;
        }
       }
       if (!(v[a + 84 >> 2] != v[a + 92 >> 2] ? v[a + 80 >> 2] : 0)) {
        g = (ia | 0) > 0 ? ia : 0;
        m = x[P >> 1];
        B: while (1) {
         if ((m | 0) <= 0) {
          Q = ia << 2;
          m = 0;
          c = 0;
          while (1) {
           k = v[a + 4 >> 2];
           if ((k | 0) <= (c | 0)) {
            while (1) {
             if ((k | 0) > (m | 0)) {
              Q = w[oa + 412 | 0];
              L = V >> 1;
              g = L << 2;
              W = v[a + 92 >> 2];
              o = V >> 3;
              $ = V >> 2;
              k = v[(m << 2) + fa >> 2];
              c = L << 2;
              P = k + c | 0;
              C: {
               if (v[a + 80 >> 2]) {
                q = no(a, g);
                break C;
               }
               q = Fd(g);
              }
              c = (q + c | 0) - 8 | 0;
              E = v[((Q << 2) + a | 0) + 1068 >> 2];
              i = E;
              g = k;
              while (1) {
               if ((g | 0) != (P | 0)) {
                z[c + 4 >> 2] = C(z[g >> 2] * z[i >> 2]) - C(z[i + 4 >> 2] * z[g + 8 >> 2]);
                z[c >> 2] = C(z[g >> 2] * z[i + 4 >> 2]) + C(z[g + 8 >> 2] * z[i >> 2]);
                g = g + 16 | 0;
                i = i + 8 | 0;
                c = c - 8 | 0;
                continue;
               }
               break;
              }
              g = P - 12 | 0;
              while (1) {
               if (c >>> 0 >= q >>> 0) {
                z[c + 4 >> 2] = C(z[g >> 2] * z[i + 4 >> 2]) - C(z[g + 8 >> 2] * z[i >> 2]);
                z[c >> 2] = C(C(-z[g + 8 >> 2]) * z[i + 4 >> 2]) - C(z[i >> 2] * z[g >> 2]);
                g = g - 16 | 0;
                i = i + 8 | 0;
                c = c - 8 | 0;
                continue;
               }
               break;
              }
              c = $ << 2;
              g = c + k | 0;
              i = c + q | 0;
              h = E + (L << 2) | 0;
              c = q;
              j = k;
              while (1) {
               l = h - 32 | 0;
               if (l >>> 0 >= E >>> 0) {
                n = z[c >> 2];
                s = z[i >> 2];
                D = z[i + 4 >> 2];
                G = z[c + 4 >> 2];
                z[g + 4 >> 2] = D + G;
                z[g >> 2] = z[i >> 2] + z[c >> 2];
                D = C(D - G);
                A = h - 16 | 0;
                r = h - 12 | 0;
                n = C(s - n);
                z[j + 4 >> 2] = C(D * z[A >> 2]) - C(z[r >> 2] * n);
                z[j >> 2] = C(n * z[A >> 2]) + C(D * z[r >> 2]);
                n = z[c + 8 >> 2];
                s = z[i + 8 >> 2];
                D = z[i + 12 >> 2];
                G = z[c + 12 >> 2];
                z[g + 12 >> 2] = D + G;
                z[g + 8 >> 2] = z[i + 8 >> 2] + z[c + 8 >> 2];
                D = C(D - G);
                h = h - 28 | 0;
                n = C(s - n);
                z[j + 12 >> 2] = C(D * z[l >> 2]) - C(z[h >> 2] * n);
                z[j + 8 >> 2] = C(n * z[l >> 2]) + C(D * z[h >> 2]);
                c = c + 16 | 0;
                i = i + 16 | 0;
                j = j + 16 | 0;
                g = g + 16 | 0;
                h = l;
                continue;
               }
               break;
              }
              g = Hm(V);
              c = V >> 4;
              h = L - 1 | 0;
              j = 0 - o | 0;
              JL(c, k, h, j, E);
              JL(c, k, h - $ | 0, j, E);
              T = V >> 5;
              c = 0 - c | 0;
              hq(T, k, h, c, E, 16);
              hq(T, k, h - o | 0, c, E, 16);
              hq(T, k, h - (o << 1) | 0, c, E, 16);
              hq(T, k, h + B(o, -3) | 0, c, E, 16);
              c = g - 4 >> 1;
              o = (c | 0) <= 2 ? 2 : c;
              c = 2;
              while (1) {
               D: {
                E: {
                 F: {
                  if ((c | 0) == (o | 0)) {
                   M = g - 7 | 0;
                   break F;
                  }
                  i = 0;
                  j = 2 << c;
                  j = (j | 0) > 0 ? j : 0;
                  l = 8 << c;
                  A = V >> c + 4;
                  r = V >> c + 2;
                  R = 0 - (r >> 1) | 0;
                  while (1) {
                   if ((i | 0) == (j | 0)) {
                    break E;
                   }
                   hq(A, k, h - B(i, r) | 0, R, E, l);
                   i = i + 1 | 0;
                   continue;
                  }
                 }
                 while (1) {
                  G: {
                   if ((o | 0) < (M | 0)) {
                    l = 2 << o;
                    R = 8 << o;
                    i = V >> o + 6;
                    aa = V >> o + 2;
                    X = 0 - (aa >> 1) | 0;
                    pa = 32 << o << 2;
                    c = h;
                    g = E;
                    while (1) {
                     if ((i | 0) <= 0) {
                      break G;
                     }
                     j = l;
                     A = (c << 2) + k | 0;
                     r = A + (X << 2) | 0;
                     S = B(R, 12) + g | 0;
                     n = z[S >> 2];
                     O = (R << 3) + g | 0;
                     s = z[O >> 2];
                     F = (R << 2) + g | 0;
                     D = z[F >> 2];
                     G = z[S + 4 >> 2];
                     J = z[O + 4 >> 2];
                     Y = z[F + 4 >> 2];
                     _ = z[g + 4 >> 2];
                     ga = z[g >> 2];
                     S = 0 - aa << 2;
                     while (1) {
                      if ((j | 0) > 0) {
                       O = r - 4 | 0;
                       K = z[O >> 2];
                       da = z[A >> 2];
                       ea = z[r >> 2];
                       z[A >> 2] = da + ea;
                       F = A - 4 | 0;
                       H = z[F >> 2];
                       z[F >> 2] = H + z[O >> 2];
                       H = C(H - K);
                       K = C(da - ea);
                       z[O >> 2] = C(H * ga) + C(_ * K);
                       z[r >> 2] = C(K * ga) - C(_ * H);
                       O = r - 12 | 0;
                       da = z[O >> 2];
                       F = A - 8 | 0;
                       H = z[F >> 2];
                       I = F;
                       F = r - 8 | 0;
                       ea = z[F >> 2];
                       z[I >> 2] = H + ea;
                       I = A - 12 | 0;
                       K = z[I >> 2];
                       z[I >> 2] = K + z[O >> 2];
                       K = C(K - da);
                       H = C(H - ea);
                       z[O >> 2] = C(K * D) + C(Y * H);
                       z[F >> 2] = C(H * D) - C(Y * K);
                       O = r - 20 | 0;
                       da = z[O >> 2];
                       F = A - 16 | 0;
                       H = z[F >> 2];
                       I = F;
                       F = r - 16 | 0;
                       ea = z[F >> 2];
                       z[I >> 2] = H + ea;
                       I = A - 20 | 0;
                       K = z[I >> 2];
                       z[I >> 2] = K + z[O >> 2];
                       K = C(K - da);
                       H = C(H - ea);
                       z[O >> 2] = C(K * s) + C(J * H);
                       z[F >> 2] = C(H * s) - C(J * K);
                       O = r - 28 | 0;
                       da = z[O >> 2];
                       F = A - 24 | 0;
                       H = z[F >> 2];
                       I = F;
                       F = r - 24 | 0;
                       ea = z[F >> 2];
                       z[I >> 2] = H + ea;
                       I = A - 28 | 0;
                       K = z[I >> 2];
                       z[I >> 2] = K + z[O >> 2];
                       K = C(K - da);
                       H = C(H - ea);
                       z[O >> 2] = C(K * n) + C(G * H);
                       z[F >> 2] = C(H * n) - C(G * K);
                       j = j - 1 | 0;
                       r = r + S | 0;
                       A = A + S | 0;
                       continue;
                      }
                      break;
                     }
                     i = i - 1 | 0;
                     c = c - 8 | 0;
                     g = g + pa | 0;
                     continue;
                    }
                   }
                   l = (h << 2) + k | 0;
                   g = l - (T << 6) | 0;
                   n = z[E + (V >> 3 << 2) >> 2];
                   ga = C(-n);
                   while (1) {
                    if (g >>> 0 < l >>> 0) {
                     J = z[l >> 2];
                     c = l - 32 | 0;
                     Y = z[c >> 2];
                     z[l >> 2] = J + Y;
                     h = l - 4 | 0;
                     s = z[h >> 2];
                     j = h;
                     h = l - 36 | 0;
                     _ = z[h >> 2];
                     z[j >> 2] = s + _;
                     j = l - 8 | 0;
                     D = z[j >> 2];
                     F = j;
                     j = l - 40 | 0;
                     H = z[j >> 2];
                     z[F >> 2] = D + H;
                     i = l - 12 | 0;
                     G = z[i >> 2];
                     F = i;
                     i = l - 44 | 0;
                     K = z[i >> 2];
                     z[F >> 2] = G + K;
                     z[c >> 2] = J - Y;
                     z[h >> 2] = s - _;
                     h = l - 16 | 0;
                     s = z[h >> 2];
                     F = h;
                     h = l - 48 | 0;
                     da = z[h >> 2];
                     z[F >> 2] = s + da;
                     D = C(D - H);
                     G = C(G - K);
                     z[j >> 2] = n * C(D + G);
                     z[i >> 2] = n * C(G - D);
                     j = l - 28 | 0;
                     D = z[j >> 2];
                     i = l - 60 | 0;
                     G = z[i >> 2];
                     E = l - 24 | 0;
                     J = z[E >> 2];
                     o = l - 56 | 0;
                     Y = z[o >> 2];
                     A = l - 20 | 0;
                     _ = z[A >> 2];
                     F = A;
                     A = l - 52 | 0;
                     H = z[A >> 2];
                     z[F >> 2] = _ + H;
                     z[E >> 2] = J + Y;
                     z[j >> 2] = D + G;
                     z[h >> 2] = _ - H;
                     z[A >> 2] = -C(s - da);
                     s = C(D - G);
                     D = C(J - Y);
                     z[o >> 2] = n * C(s - D);
                     z[i >> 2] = C(D + s) * ga;
                     IL(l);
                     IL(c);
                     l = l + -64 | 0;
                     continue;
                    }
                    break;
                   }
                   l = L - 4 | 0;
                   c = q + (l << 2) | 0;
                   i = (q + ($ << 2) | 0) - 16 | 0;
                   g = v[((Q << 2) + a | 0) + 1100 >> 2];
                   while (1) {
                    if (i >>> 0 >= q >>> 0) {
                     h = (x[g >> 1] << 2) + k | 0;
                     z[c + 12 >> 2] = z[h >> 2];
                     z[c + 8 >> 2] = z[h + 4 >> 2];
                     z[i + 12 >> 2] = z[h + 8 >> 2];
                     z[i + 8 >> 2] = z[h + 12 >> 2];
                     h = (x[g + 2 >> 1] << 2) + k | 0;
                     z[c + 4 >> 2] = z[h >> 2];
                     z[c >> 2] = z[h + 4 >> 2];
                     z[i + 4 >> 2] = z[h + 8 >> 2];
                     z[i >> 2] = z[h + 12 >> 2];
                     g = g + 4 | 0;
                     c = c - 16 | 0;
                     i = i - 16 | 0;
                     continue;
                    }
                    break;
                   }
                   g = v[((Q << 2) + a | 0) + 1084 >> 2];
                   i = q;
                   c = i + (L << 2) | 0;
                   h = c;
                   while (1) {
                    j = h - 16 | 0;
                    if (j >>> 0 > i >>> 0) {
                     n = z[i + 4 >> 2];
                     E = h - 4 | 0;
                     s = z[E >> 2];
                     D = C(n - s);
                     G = z[g + 4 >> 2];
                     n = C(n + s);
                     s = z[i >> 2];
                     o = h - 8 | 0;
                     J = z[o >> 2];
                     Y = C(s - J);
                     _ = z[g >> 2];
                     ga = C(C(G * n) - C(Y * _));
                     z[i + 4 >> 2] = D + ga;
                     s = C(s + J);
                     n = C(C(G * Y) + C(n * _));
                     z[i >> 2] = s + n;
                     z[E >> 2] = ga - D;
                     z[o >> 2] = s - n;
                     n = z[i + 8 >> 2];
                     s = z[j >> 2];
                     D = C(n + s);
                     G = z[g + 12 >> 2];
                     n = C(n - s);
                     s = z[i + 12 >> 2];
                     h = h - 12 | 0;
                     J = z[h >> 2];
                     Y = C(s + J);
                     _ = z[g + 8 >> 2];
                     ga = C(C(G * n) + C(Y * _));
                     z[i + 8 >> 2] = D + ga;
                     s = C(s - J);
                     n = C(C(G * Y) - C(n * _));
                     z[i + 12 >> 2] = s + n;
                     z[j >> 2] = D - ga;
                     z[h >> 2] = n - s;
                     i = i + 16 | 0;
                     g = g + 16 | 0;
                     h = j;
                     continue;
                    }
                    break;
                   }
                   i = v[((Q << 2) + a | 0) + 1076 >> 2] + (L << 2) | 0;
                   h = (V << 2) + k | 0;
                   g = (l << 2) + k | 0;
                   while (1) {
                    j = c - 32 | 0;
                    if (j >>> 0 >= q >>> 0) {
                     n = z[c - 8 >> 2];
                     s = z[i - 4 >> 2];
                     D = z[i - 8 >> 2];
                     G = z[c - 4 >> 2];
                     J = C(C(n * s) - C(D * G));
                     z[k >> 2] = J;
                     z[g + 12 >> 2] = -J;
                     n = C(C(D * C(-n)) - C(s * G));
                     z[P >> 2] = n;
                     z[h - 4 >> 2] = n;
                     n = z[c - 16 >> 2];
                     s = z[i - 12 >> 2];
                     D = z[i - 16 >> 2];
                     G = z[c - 12 >> 2];
                     J = C(C(n * s) - C(D * G));
                     z[k + 4 >> 2] = J;
                     z[g + 8 >> 2] = -J;
                     n = C(C(D * C(-n)) - C(s * G));
                     z[P + 4 >> 2] = n;
                     z[h - 8 >> 2] = n;
                     n = z[c - 24 >> 2];
                     s = z[i - 20 >> 2];
                     D = z[i - 24 >> 2];
                     G = z[c - 20 >> 2];
                     J = C(C(n * s) - C(D * G));
                     z[k + 8 >> 2] = J;
                     z[g + 4 >> 2] = -J;
                     n = C(C(D * C(-n)) - C(s * G));
                     z[P + 8 >> 2] = n;
                     z[h - 12 >> 2] = n;
                     n = z[j >> 2];
                     s = z[i - 28 >> 2];
                     i = i - 32 | 0;
                     D = z[i >> 2];
                     G = z[c - 28 >> 2];
                     J = C(C(n * s) - C(D * G));
                     z[k + 12 >> 2] = J;
                     z[g >> 2] = -J;
                     n = C(C(D * C(-n)) - C(s * G));
                     z[P + 12 >> 2] = n;
                     h = h - 16 | 0;
                     z[h >> 2] = n;
                     g = g - 16 | 0;
                     P = P + 16 | 0;
                     k = k + 16 | 0;
                     c = j;
                     continue;
                    }
                    break;
                   }
                   if (!v[a + 80 >> 2]) {
                    Bb(q);
                   }
                   v[a + 92 >> 2] = W;
                   break D;
                  }
                  o = o + 1 | 0;
                  continue;
                 }
                }
                c = c + 1 | 0;
                continue;
               }
               break;
              }
              m = m + 1 | 0;
              k = v[a + 4 >> 2];
              continue;
             }
             break;
            }
           } else {
            g = c << 2;
            i = v[g + fa >> 2];
            H: {
             if (v[g + (N + 320 | 0) >> 2]) {
              Qb(i, 0, Q);
              break H;
             }
             L = v[g + O >> 2];
             I: {
              g = w[(w[(v[P + 4 >> 2] + B(c, 3) | 0) + 2 | 0] + P | 0) + 9 | 0];
              if (!x[((g << 1) + a | 0) + 132 >> 1]) {
               bc(a, 21);
               break I;
              }
              E = V >> 1;
              o = v[a + 260 >> 2] + B(g, 1596) | 0;
              T = o + 338 | 0;
              $ = o + 838 | 0;
              g = B(w[o + 1588 | 0], u[L >> 1]);
              j = 1;
              h = 0;
              while (1) {
               if (v[o + 1592 >> 2] > (j | 0)) {
                k = w[j + $ | 0] << 1;
                q = u[k + L >> 1];
                if ((q | 0) >= 0) {
                 q = B(w[o + 1588 | 0], q & 65535);
                 k = x[k + T >> 1];
                 if ((k | 0) != (h | 0)) {
                  l = q - g | 0;
                  A = k - h | 0;
                  r = (l | 0) / (A | 0) | 0;
                  J: {
                   R = (k | 0) < (E | 0) ? k : E;
                   if ((R | 0) <= (h | 0)) {
                    break J;
                   }
                   F = l;
                   l = l >> 31;
                   S = r >> 31;
                   S = ((F ^ l) - l | 0) - B(A, (S ^ r) - S | 0) | 0;
                   W = l | 1;
                   l = i + (h << 2) | 0;
                   z[l >> 2] = z[((g & 255) << 2) + 88864 >> 2] * z[l >> 2];
                   R = R - 1 | 0;
                   l = 0;
                   while (1) {
                    if ((h | 0) == (R | 0)) {
                     break J;
                    }
                    h = h + 1 | 0;
                    M = i + (h << 2) | 0;
                    l = l + S | 0;
                    aa = (l | 0) < (A | 0);
                    g = (g + r | 0) + (aa ? 0 : W) | 0;
                    z[M >> 2] = z[((g & 255) << 2) + 88864 >> 2] * z[M >> 2];
                    l = l - (aa ? 0 : A) | 0;
                    continue;
                   }
                  }
                  h = k;
                 }
                 g = q;
                }
                j = j + 1 | 0;
                continue;
               }
               break;
              }
              if ((h | 0) >= (E | 0)) {
               break I;
              }
              g = (g << 2) + 88864 | 0;
              while (1) {
               if ((h | 0) == (E | 0)) {
                break I;
               }
               k = i + (h << 2) | 0;
               z[k >> 2] = z[g >> 2] * z[k >> 2];
               h = h + 1 | 0;
               continue;
              }
             }
            }
            c = c + 1 | 0;
            continue;
           }
           break;
          }
          LL(a);
          K: {
           if (w[a + 1377 | 0]) {
            v[a + 1060 >> 2] = ra;
            t[a + 1377 | 0] = 0;
            v[a + 1064 >> 2] = 1;
            v[a + 1412 >> 2] = V - ma;
            break K;
           }
           c = v[a + 1412 >> 2];
           if (!c) {
            break K;
           }
           g = ha - U | 0;
           if ((g | 0) <= (c | 0)) {
            v[a + 1412 >> 2] = c - g;
            v[la >> 2] = ha;
            U = ha;
            break K;
           }
           U = c + U | 0;
           v[la >> 2] = U;
           v[a + 1412 >> 2] = 0;
          }
          c = v[a + 1064 >> 2];
          L: {
           M: {
            N: {
             O: {
              if (v[a + 1388 >> 2] == v[a + 1404 >> 2]) {
               P: {
                if (!c | !(w[a + 1375 | 0] & 4)) {
                 break P;
                }
                c = v[a + 1408 >> 2];
                g = v[a + 1060 >> 2];
                if (c >>> 0 >= g + (ma - U | 0) >>> 0) {
                 break P;
                }
                g = c - g | 0;
                c = (c >>> 0 >= g >>> 0 ? g : 0) + U | 0;
                c = (c | 0) < (ma | 0) ? c : ma;
                v[ba + 12 >> 2] = c;
                v[a + 1060 >> 2] = c + v[a + 1060 >> 2];
                break M;
               }
               v[a + 1064 >> 2] = 1;
               c = v[a + 1408 >> 2] + (U - ia | 0) | 0;
               break O;
              }
              if (!c) {
               break N;
              }
              c = v[a + 1060 >> 2];
             }
             v[a + 1060 >> 2] = c + (ha - U | 0);
            }
            if (v[a + 84 >> 2] != v[a + 92 >> 2] ? v[a + 80 >> 2] : 0) {
             break L;
            }
            v[ba + 12 >> 2] = ma;
           }
           c = 1;
           break o;
          }
          Z(6325, 13258, 3451, 5634);
          p();
         }
         m = m - 1 | 0;
         c = v[P + 4 >> 2] + B(m, 3) | 0;
         h = v[(w[c + 1 | 0] << 2) + fa >> 2];
         k = v[(w[c | 0] << 2) + fa >> 2];
         c = 0;
         while (1) {
          if ((c | 0) == (g | 0)) {
           continue B;
          }
          q = c << 2;
          j = q + h | 0;
          D = z[j >> 2];
          q = k + q | 0;
          n = z[q >> 2];
          Q: {
           if (n > C(0)) {
            if (D > C(0)) {
             s = C(n - D);
             break Q;
            }
            s = n;
            n = C(n + D);
            break Q;
           }
           if (D > C(0)) {
            s = C(n + D);
            break Q;
           }
           s = n;
           n = C(n - D);
          }
          z[q >> 2] = n;
          z[j >> 2] = s;
          c = c + 1 | 0;
          continue;
         }
        }
       }
       Z(6325, 13258, 3335, 5634);
       p();
      }
      T = N + 256 | 0;
      E = eb - 16 | 0;
      eb = E;
      g = v[a + 4 >> 2];
      c = w[k + pa | 0];
      i = v[a + 396 >> 2] + B(c, 24) | 0;
      h = v[i + 4 >> 2];
      W = x[((c << 1) + a | 0) + 268 >> 1];
      c = ia << ((W | 0) == 2);
      j = c >>> 0 > h >>> 0 ? h : c;
      h = v[i >> 2];
      L = (j - (c >>> 0 > h >>> 0 ? h : c) >>> 0) / y[i + 8 >> 2] | 0;
      q = L << 2;
      c = B(g, q + 4 | 0);
      S = v[v[a + 124 >> 2] + B(w[i + 13 | 0], 2096) >> 2];
      F = v[a + 92 >> 2];
      R: {
       if (v[a + 80 >> 2]) {
        h = no(a, c);
        g = v[a + 4 >> 2];
        break R;
       }
       h = Fd(c);
      }
      j = (m | 0) > 0 ? m : 0;
      o = ia << 2;
      l = 0;
      c = (g | 0) > 0 ? g : 0;
      g = h + (g << 2) | 0;
      while (1) {
       if ((c | 0) != (l | 0)) {
        v[h + (l << 2) >> 2] = g;
        l = l + 1 | 0;
        g = g + q | 0;
        continue;
       }
       break;
      }
      q = h;
      c = 0;
      while (1) {
       if ((c | 0) != (j | 0)) {
        if (!w[c + N | 0]) {
         Qb(v[T + (c << 2) >> 2], 0, o);
        }
        c = c + 1 | 0;
        continue;
       }
       break;
      }
      S: {
       if (!((m | 0) == 1 | (W | 0) != 2)) {
        c = 0;
        while (1) {
         T: {
          if ((c | 0) != (j | 0)) {
           if (w[c + N | 0]) {
            break T;
           }
          } else {
           c = j;
          }
          if ((c | 0) == (m | 0)) {
           break S;
          }
          l = (m | 0) != 2;
          A = (m | 0) < 3;
          h = 0;
          while (1) {
           if ((h | 0) == 8) {
            break S;
           }
           U: {
            if (!l) {
             g = 0;
             o = 0;
             while (1) {
              if ((o | 0) >= (L | 0)) {
               break U;
              }
              c = v[i >> 2] + B(v[i + 8 >> 2], o) | 0;
              v[E + 12 >> 2] = c & 1;
              v[E + 8 >> 2] = c >> 1;
              if (!h) {
               j = v[a + 124 >> 2] + B(w[i + 13 | 0], 2096) | 0;
               if (v[a + 1396 >> 2] <= 9) {
                tl(a);
               }
               c = v[a + 1392 >> 2];
               r = u[(j + ((c & 1023) << 1) | 0) + 36 >> 1];
               V: {
                if ((r | 0) >= 0) {
                 I = c;
                 r = r & 65535;
                 c = w[r + v[j + 8 >> 2] | 0];
                 v[a + 1392 >> 2] = I >>> c;
                 c = v[a + 1396 >> 2] - c | 0;
                 v[a + 1396 >> 2] = (c | 0) > 0 ? c : 0;
                 c = (c | 0) < 0 ? -1 : r;
                 break V;
                }
                c = Gm(a, j);
               }
               c = w[j + 23 | 0] ? v[v[j + 2088 >> 2] + (c << 2) >> 2] : c;
               if ((c | 0) == -1) {
                break S;
               }
               v[v[q >> 2] + (g << 2) >> 2] = v[v[i + 16 >> 2] + (c << 2) >> 2];
              }
              c = 0;
              while (1) {
               if (!((c | 0) >= (S | 0) | (o | 0) >= (L | 0))) {
                j = v[i + 8 >> 2];
                r = u[(v[i + 20 >> 2] + (w[v[v[q >> 2] + (g << 2) >> 2] + c | 0] << 4) | 0) + (h << 1) >> 1];
                W: {
                 if ((r | 0) >= 0) {
                  if (!KL(a, v[a + 124 >> 2] + B(r & 65535, 2096) | 0, T, 2, E + 12 | 0, E + 8 | 0, ia, j)) {
                   break S;
                  }
                  o = o + 1 | 0;
                  break W;
                 }
                 o = o + 1 | 0;
                 j = v[i >> 2] + B(j, o) | 0;
                 v[E + 8 >> 2] = j >> 1;
                 v[E + 12 >> 2] = j & 1;
                }
                c = c + 1 | 0;
                continue;
               }
               break;
              }
              g = g + 1 | 0;
              continue;
             }
            }
            if (A) {
             break U;
            }
            g = 0;
            o = 0;
            while (1) {
             if ((o | 0) >= (L | 0)) {
              break U;
             }
             j = v[i >> 2] + B(v[i + 8 >> 2], o) | 0;
             c = (j | 0) / (m | 0) | 0;
             v[E + 12 >> 2] = j - B(c, m);
             v[E + 8 >> 2] = c;
             if (!h) {
              j = v[a + 124 >> 2] + B(w[i + 13 | 0], 2096) | 0;
              if (v[a + 1396 >> 2] <= 9) {
               tl(a);
              }
              c = v[a + 1392 >> 2];
              r = u[(j + ((c & 1023) << 1) | 0) + 36 >> 1];
              X: {
               if ((r | 0) >= 0) {
                I = c;
                r = r & 65535;
                c = w[r + v[j + 8 >> 2] | 0];
                v[a + 1392 >> 2] = I >>> c;
                c = v[a + 1396 >> 2] - c | 0;
                v[a + 1396 >> 2] = (c | 0) > 0 ? c : 0;
                c = (c | 0) < 0 ? -1 : r;
                break X;
               }
               c = Gm(a, j);
              }
              c = w[j + 23 | 0] ? v[v[j + 2088 >> 2] + (c << 2) >> 2] : c;
              if ((c | 0) == -1) {
               break S;
              }
              v[v[q >> 2] + (g << 2) >> 2] = v[v[i + 16 >> 2] + (c << 2) >> 2];
             }
             c = 0;
             while (1) {
              if (!((c | 0) >= (S | 0) | (o | 0) >= (L | 0))) {
               j = v[i + 8 >> 2];
               r = u[(v[i + 20 >> 2] + (w[v[v[q >> 2] + (g << 2) >> 2] + c | 0] << 4) | 0) + (h << 1) >> 1];
               Y: {
                if ((r | 0) >= 0) {
                 if (!KL(a, v[a + 124 >> 2] + B(r & 65535, 2096) | 0, T, m, E + 12 | 0, E + 8 | 0, ia, j)) {
                  break S;
                 }
                 o = o + 1 | 0;
                 break Y;
                }
                o = o + 1 | 0;
                j = v[i >> 2] + B(j, o) | 0;
                r = (j | 0) / (m | 0) | 0;
                v[E + 8 >> 2] = r;
                v[E + 12 >> 2] = j - B(m, r);
               }
               c = c + 1 | 0;
               continue;
              }
              break;
             }
             g = g + 1 | 0;
             continue;
            }
           }
           h = h + 1 | 0;
           continue;
          }
         }
         c = c + 1 | 0;
         continue;
        }
       }
       g = 0;
       while (1) {
        if ((g | 0) == 8) {
         break S;
        }
        m = 0;
        $ = 0;
        while (1) {
         if ((m | 0) < (L | 0)) {
          Z: {
           if (g) {
            break Z;
           }
           c = 0;
           while (1) {
            if ((c | 0) == (j | 0)) {
             break Z;
            }
            if (!w[c + N | 0]) {
             l = v[a + 124 >> 2] + B(w[i + 13 | 0], 2096) | 0;
             if (v[a + 1396 >> 2] <= 9) {
              tl(a);
             }
             h = v[a + 1392 >> 2];
             o = u[(l + ((h & 1023) << 1) | 0) + 36 >> 1];
             _: {
              if ((o | 0) >= 0) {
               A = h;
               o = o & 65535;
               h = w[o + v[l + 8 >> 2] | 0];
               v[a + 1392 >> 2] = A >>> h;
               h = v[a + 1396 >> 2] - h | 0;
               v[a + 1396 >> 2] = (h | 0) > 0 ? h : 0;
               h = (h | 0) < 0 ? -1 : o;
               break _;
              }
              h = Gm(a, l);
             }
             h = w[l + 23 | 0] ? v[v[l + 2088 >> 2] + (h << 2) >> 2] : h;
             if ((h | 0) == -1) {
              break S;
             }
             v[v[q + (c << 2) >> 2] + ($ << 2) >> 2] = v[v[i + 16 >> 2] + (h << 2) >> 2];
            }
            c = c + 1 | 0;
            continue;
           }
          }
          h = 0;
          while (1) {
           $: {
            if ((h | 0) >= (S | 0)) {
             break $;
            }
            c = 0;
            if ((m | 0) >= (L | 0)) {
             break $;
            }
            while (1) {
             if ((c | 0) != (j | 0)) {
              aa: {
               if (w[c + N | 0]) {
                break aa;
               }
               l = c << 2;
               o = u[(v[i + 20 >> 2] + (w[v[v[l + q >> 2] + ($ << 2) >> 2] + h | 0] << 4) | 0) + (g << 1) >> 1];
               if ((o | 0) < 0) {
                break aa;
               }
               r = v[a + 124 >> 2] + B(o & 65535, 2096) | 0;
               M = v[l + T >> 2];
               R = v[i + 8 >> 2];
               Q = v[i >> 2] + B(R, m) | 0;
               ba: {
                ca: {
                 if (W) {
                  o = 0;
                  while (1) {
                   l = 1;
                   if ((o | 0) >= (R | 0)) {
                    break ba;
                   }
                   aa = M + (Q << 2) | 0;
                   l = R - o | 0;
                   A = 0;
                   n = C(0);
                   da: {
                    I = HL(a, r);
                    if ((I | 0) < 0) {
                     break da;
                    }
                    X = v[r >> 2];
                    A = (l | 0) > (X | 0) ? X : l;
                    X = B(X, I);
                    if (w[r + 22 | 0]) {
                     l = 0;
                     I = (A | 0) > 0 ? A : 0;
                     A = 1;
                     while (1) {
                      if ((l | 0) == (I | 0)) {
                       break da;
                      }
                      ja = l << 2;
                      ka = ja + aa | 0;
                      n = C(n + z[ja + (v[r + 28 >> 2] + (X << 2) | 0) >> 2]);
                      z[ka >> 2] = z[ka >> 2] + n;
                      n = C(n + z[r + 12 >> 2]);
                      l = l + 1 | 0;
                      continue;
                     }
                    }
                    l = 0;
                    I = (A | 0) > 0 ? A : 0;
                    A = 1;
                    while (1) {
                     if ((l | 0) == (I | 0)) {
                      break da;
                     }
                     ja = l << 2;
                     ka = ja + aa | 0;
                     z[ka >> 2] = z[ka >> 2] + C(z[ja + (v[r + 28 >> 2] + (X << 2) | 0) >> 2] + C(0));
                     l = l + 1 | 0;
                     continue;
                    }
                   }
                   if (!A) {
                    break ca;
                   }
                   l = v[r >> 2];
                   Q = l + Q | 0;
                   o = l + o | 0;
                   continue;
                  }
                 }
                 o = 0;
                 aa = (R | 0) / v[r >> 2] | 0;
                 I = (aa | 0) > 0 ? aa : 0;
                 ja = M + (Q << 2) | 0;
                 l = 1;
                 while (1) {
                  if ((o | 0) == (I | 0)) {
                   break ba;
                  }
                  A = o + Q | 0;
                  M = o << 2;
                  o = o + 1 | 0;
                  ka = M + ja | 0;
                  M = R - A | 0;
                  X = 0;
                  n = C(0);
                  ea: {
                   na = HL(a, r);
                   if ((na | 0) < 0) {
                    break ea;
                   }
                   A = 0;
                   X = v[r >> 2];
                   M = (M | 0) > (X | 0) ? X : M;
                   M = (M | 0) > 0 ? M : 0;
                   na = B(X, na) << 2;
                   X = 1;
                   while (1) {
                    if ((A | 0) == (M | 0)) {
                     break ea;
                    }
                    qa = ka + (B(A, aa) << 2) | 0;
                    s = C(n + z[(na + v[r + 28 >> 2] | 0) + (A << 2) >> 2]);
                    z[qa >> 2] = z[qa >> 2] + s;
                    n = w[r + 22 | 0] ? s : n;
                    A = A + 1 | 0;
                    continue;
                   }
                  }
                  if (X) {
                   continue;
                  }
                  break;
                 }
                }
                l = 0;
               }
               if (!l) {
                break S;
               }
              }
              c = c + 1 | 0;
              continue;
             }
             break;
            }
            m = m + 1 | 0;
            h = h + 1 | 0;
            continue;
           }
           break;
          }
          $ = $ + 1 | 0;
          continue;
         }
         break;
        }
        g = g + 1 | 0;
        continue;
       }
      }
      if (!v[a + 80 >> 2]) {
       Bb(q);
      }
      v[a + 92 >> 2] = F;
      eb = E + 16 | 0;
      k = k + 1 | 0;
      continue;
     }
    }
    Z(6325, 13258, 3302, 5634);
    p();
   }
   eb = N + 2368 | 0;
  } else {
   c = 0;
  }
  eb = ca + 16 | 0;
  if (!c) {
   fa: {
    ga: {
     ha: {
      c = v[a + 100 >> 2];
      switch (c - 32 | 0) {
      case 0:
       break ga;

      case 3:
       break ha;

      default:
       break fa;
      }
     }
     v[a + 100 >> 2] = 0;
     while (1) {
      if ((Mh(a) | 0) != -1 & !v[a + 96 >> 2]) {
       continue;
      }
      break;
     }
     v[f >> 2] = 0;
     c = v[a + 32 >> 2] - b | 0;
     break a;
    }
    if (v[a + 992 >> 2]) {
     break fa;
    }
    v[a + 100 >> 2] = 0;
    while (1) {
     if ((Mh(a) | 0) != -1 & !v[a + 96 >> 2]) {
      continue;
     }
     break;
    }
    v[f >> 2] = 0;
    c = v[a + 32 >> 2] - b | 0;
    break a;
   }
   v[a + 1420 >> 2] = 0;
   v[a + 992 >> 2] = 0;
   v[a + 1504 >> 2] = 0;
   v[a + 1508 >> 2] = 0;
   v[a + 1412 >> 2] = 0;
   v[a + 1416 >> 2] = 0;
   t[a + 1377 | 0] = 0;
   v[a + 1064 >> 2] = 0;
   v[a + 100 >> 2] = c;
   v[f >> 2] = 0;
   c = 1;
   break a;
  }
  q = v[ba + 12 >> 2];
  l = v[ba + 4 >> 2];
  k = v[ba + 8 >> 2];
  h = 1;
  j = v[a + 992 >> 2];
  ia: {
   if (j) {
    h = 1092;
    c = j << 1;
    ja: {
     if ((c | 0) != v[a + 112 >> 2]) {
      h = 1096;
      g = 0;
      if ((c | 0) != v[a + 116 >> 2]) {
       break ja;
      }
     }
     g = v[a + h >> 2];
    }
    c = 0;
    if (!g) {
     break ia;
    }
    h = 0;
    i = (j | 0) > 0 ? j : 0;
    m = a + 928 | 0;
    E = a + 800 | 0;
    U = g + (j << 2) | 0;
    while (1) {
     if (v[a + 4 >> 2] > (h | 0)) {
      c = h << 2;
      ca = c + m | 0;
      ha = c + E | 0;
      c = 0;
      while (1) {
       if ((c | 0) != (i | 0)) {
        j = c << 2;
        o = (j + v[ha >> 2] | 0) + (l << 2) | 0;
        z[o >> 2] = C(z[o >> 2] * z[g + j >> 2]) + C(z[j + v[ca >> 2] >> 2] * z[U + ((c ^ -1) << 2) >> 2]);
        c = c + 1 | 0;
        continue;
       }
       break;
      }
      h = h + 1 | 0;
      continue;
     }
     break;
    }
    h = !v[a + 992 >> 2];
   }
   v[a + 992 >> 2] = q - k;
   j = a + 928 | 0;
   i = a + 800 | 0;
   m = (k | 0) > (q | 0);
   E = (m ? k : q) - k | 0;
   g = 0;
   while (1) {
    if (v[a + 4 >> 2] > (g | 0)) {
     c = g << 2;
     U = c + j | 0;
     ca = c + i | 0;
     c = 0;
     while (1) {
      if ((c | 0) != (E | 0)) {
       ha = c << 2;
       z[ha + v[U >> 2] >> 2] = z[(ha + v[ca >> 2] | 0) + (k << 2) >> 2];
       c = c + 1 | 0;
       continue;
      }
      break;
     }
     g = g + 1 | 0;
     continue;
    }
    break;
   }
   c = 0;
   if (!h) {
    c = (m ? q : k) - l | 0;
    v[a + 1416 >> 2] = c + v[a + 1416 >> 2];
   }
  }
  g = c;
  c = 0;
  h = v[a + 4 >> 2];
  q = (h | 0) > 0 ? h : 0;
  k = a + 864 | 0;
  j = a + 800 | 0;
  while (1) {
   if ((c | 0) != (q | 0)) {
    i = c << 2;
    v[i + k >> 2] = v[i + j >> 2] + (l << 2);
    c = c + 1 | 0;
    continue;
   }
   break;
  }
  if (d) {
   v[d >> 2] = h;
  }
  v[f >> 2] = g;
  v[e >> 2] = k;
  c = v[a + 32 >> 2] - b | 0;
 }
 eb = ba + 16 | 0;
 return c;
}

function jqa(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, q = 0, r = 0, s = 0, y = 0, A = 0, D = C(0), E = 0, F = 0, G = 0, H = 0, I = 0, J = 0, K = 0, L = 0, N = 0, O = C(0), R = C(0), U = 0, V = 0, Y = 0, Z = 0, $ = 0, aa = 0, ba = 0, ca = 0, da = 0, ea = 0, fa = 0, ga = 0, ha = 0, ia = 0, ja = 0, ka = 0, la = 0, ma = 0, na = C(0), oa = 0, pa = 0, qa = 0, ra = 0, sa = 0, ta = 0, ua = 0, va = 0, wa = 0, xa = 0, ya = C(0);
 y = eb - 96 | 0;
 eb = y;
 xc(c);
 a: {
  while (1) {
   b: {
    if (!Lb(v[c >> 2], v[c + 8 >> 2], 4)) {
     break b;
    }
    j = y + 76 | 0;
    d = eb - 16 | 0;
    eb = d;
    c: {
     if (!Lb(v[c >> 2], v[c + 8 >> 2], 3)) {
      h = 0;
      while (1) {
       if ((h | 0) != 3) {
        ch(h + j | 0);
        h = h + 1 | 0;
        continue;
       }
       break;
      }
      break c;
     }
     dx(d + 8 | 0, j);
     rd(d, c, v[d + 8 >> 2], v[d + 12 >> 2]);
    }
    eb = d + 16 | 0;
    d: {
     e: {
      if (!id(j, 15013, 3)) {
       j = y + 32 | 0;
       d = eb - 16 | 0;
       eb = d;
       f: {
        if (!Lb(v[c >> 2], v[c + 8 >> 2], 7)) {
         h = 0;
         while (1) {
          if ((h | 0) != 7) {
           ch(h + j | 0);
           h = h + 1 | 0;
           continue;
          }
          break;
         }
         break f;
        }
        Jr(d + 8 | 0, j);
        rd(d, c, v[d + 8 >> 2], v[d + 12 >> 2]);
       }
       eb = d + 16 | 0;
       N = 0;
       j = 3;
       while (1) {
        if ((j | 0) == 7) {
         break d;
        }
        d = t[(y + 32 | 0) + j | 0];
        if ((d | 0) < 0) {
         break e;
        }
        j = j + 1 | 0;
        N = d & 255 | N << 7;
        continue;
       }
      }
      g: {
       if (id(y + 76 | 0, 14195, 3)) {
        break g;
       }
       if (!VX(c, 13675)) {
        break g;
       }
       Ub(c, Qg(c) + 16 | 0);
       continue;
      }
      d = y + 76 | 0;
      if (!id(d, 28526, 3)) {
       continue;
      }
      if (!id(d, 28530, 3)) {
       continue;
      }
      if (!w[y + 76 | 0]) {
       Hh(c, 2);
       continue;
      }
      if (kV(y + 76 | 0)) {
       break b;
      }
     }
     j = 0;
     break a;
    }
    Ub(c, N);
    continue;
   }
   break;
  }
  xc(c);
  d = y + 76 | 0;
  xD(d, c);
  Z = v[y + 76 >> 2];
  c = Ze(d);
  U = Mb(y - -64 | 0);
  v[31601] = 0;
  da = Q(591, y + 60 | 0) | 0;
  d = v[31601];
  v[31601] = 0;
  h: {
   i: {
    j: {
     if ((d | 0) != 1) {
      JB(Qb(v[da >> 2], 0, 6668));
      v[y + 48 >> 2] = 0;
      v[y + 52 >> 2] = 0;
      v[y + 40 >> 2] = 0;
      v[y + 44 >> 2] = 0;
      v[y + 32 >> 2] = 0;
      v[y + 36 >> 2] = 0;
      v[31601] = 0;
      ea = Q(592, y + 20 | 0) | 0;
      d = v[31601];
      v[31601] = 0;
      k: {
       if ((d | 0) != 1) {
        N = 0;
        while (1) {
         F = v[da >> 2];
         g = Fc(Z, ba);
         $ = v[ea >> 2];
         K = y + 32 | 0;
         d = 0;
         l = 0;
         r = eb - 17152 | 0;
         eb = r;
         v[r + 17148 >> 2] = 0;
         l: {
          m: {
           n: {
            if (w[F + 6152 | 0] != 255 | (g | 0) < 5) {
             break n;
            }
            if (!jq(F + 6152 | 0, c)) {
             break n;
            }
            j = nz(w[c + 1 | 0], w[c + 2 | 0], v[F + 6148 >> 2]) + iq(c) | 0;
            v[r + 17148 >> 2] = j;
            if ((g | 0) == (j | 0)) {
             j = g;
             break m;
            }
            o: {
             if ((g | 0) >= (j + 4 | 0)) {
              if (jq(c, c + j | 0)) {
               break o;
              }
             }
             v[r + 17148 >> 2] = 0;
             break n;
            }
            if (j) {
             break m;
            }
           }
           h = c;
           n = Qb(F, 0, 6668) + 6148 | 0;
           s = r + 17148 | 0;
           L = g - 4 | 0;
           H = (L | 0) > 0 ? L : 0;
           while (1) {
            p: {
             q: {
              r: {
               s: {
                if ((l | 0) == (H | 0)) {
                 l = g;
                 break s;
                }
                if (!TL(h)) {
                 break q;
                }
                f = nz(w[h + 1 | 0], w[h + 2 | 0], v[n >> 2]);
                j = f + iq(h) | 0;
                i = 4;
                q = l + 4 | 0;
                t: {
                 while (1) {
                  if (!(i >>> 0 > 2303 | f)) {
                   if ((L | 0) <= ((i << 1) + l | 0)) {
                    break t;
                   }
                   f = 0;
                   k = h + i | 0;
                   u: {
                    if (!jq(h, k)) {
                     break u;
                    }
                    e = i - iq(h) | 0;
                    m = iq(k) + e | 0;
                    if ((g | 0) < (m + (i + q | 0) | 0)) {
                     break u;
                    }
                    if (!jq(h, k + m | 0)) {
                     break u;
                    }
                    v[n >> 2] = e;
                    f = e;
                    j = i;
                   }
                   i = i + 1 | 0;
                   continue;
                  }
                  break;
                 }
                 if (!f | (g | 0) < (j + l | 0)) {
                  break t;
                 }
                 q = g - l | 0;
                 i = 0;
                 e = 0;
                 while (1) {
                  v: {
                   w: {
                    if ((e | 0) != 10) {
                     k = (e | 0) != 0;
                     J = i;
                     i = h + i | 0;
                     i = (J + nz(w[i + 1 | 0], w[i + 2 | 0], f) | 0) + iq(i) | 0;
                     if ((q | 0) < (i + 4 | 0)) {
                      break v;
                     }
                     if (jq(h, h + i | 0)) {
                      break w;
                     }
                     k = 0;
                    } else {
                     k = 1;
                    }
                    break v;
                   }
                   e = e + 1 | 0;
                   continue;
                  }
                  break;
                 }
                 if (!k) {
                  break t;
                 }
                 d = j;
                 break s;
                }
                if ((g | 0) != (j | 0) | l) {
                 break r;
                }
                l = 0;
                d = g;
               }
               v[s >> 2] = d;
               d = l;
               break p;
              }
              v[n >> 2] = 0;
             }
             h = h + 1 | 0;
             l = l + 1 | 0;
             continue;
            }
            break;
           }
           j = v[r + 17148 >> 2];
           if ((g | 0) >= (d + j | 0) ? j : 0) {
            break m;
           }
           v[K >> 2] = d;
           o = 0;
           break l;
          }
          E = c + d | 0;
          v[F + 6152 >> 2] = w[E | 0] | w[E + 1 | 0] << 8 | (w[E + 2 | 0] << 16 | w[E + 3 | 0] << 24);
          v[K + 4 >> 2] = d;
          v[K >> 2] = d + j;
          v[K + 8 >> 2] = w[E + 3 | 0] > 191 ? 1 : 2;
          wa = K, xa = WL(w[E + 1 | 0], w[E + 2 | 0]), v[wa + 12 >> 2] = xa;
          v[K + 16 >> 2] = 4 - (w[E + 1 | 0] >>> 1 & 3);
          wa = K, xa = mz(w[E + 1 | 0], w[E + 2 | 0]), v[wa + 20 >> 2] = xa;
          if (!$) {
           o = lz(w[E + 1 | 0]);
           break l;
          }
          d = r + 17136 | 0;
          VL(d, E + 4 | 0, j - 4 | 0);
          if (!(t[E + 1 | 0] & 1)) {
           ue(d, 16);
          }
          x: {
           if (v[K + 16 >> 2] == 3) {
            o = 0;
            d = r + 17136 | 0;
            ka = r + 3728 | 0;
            h = ka;
            l = 0;
            j = w[E + 1 | 0];
            e = B((j >>> 3 & 1) + (j >>> 4 & 1) | 0, 3) + (w[E + 2 | 0] >>> 2 & 3) | 0;
            e = e - ((e | 0) != 0) | 0;
            i = w[E + 3 | 0] > 191 ? 1 : 2;
            y: {
             if (j & 8) {
              k = ue(d, 9);
              i = i << 1;
              l = ue(d, i + 7 | 0);
              break y;
             }
             k = ue(d, i | 8) >>> i | 0;
            }
            j = B(e, 40);
            n = j + 81152 | 0;
            L = j + 81472 | 0;
            s = B(e, 23) + 80960 | 0;
            j = -1;
            e = 0;
            z: {
             while (1) {
              g = w[E + 3 | 0];
              H = ue(d, 12);
              u[h + 4 >> 1] = H;
              f = ue(d, 9);
              u[h + 6 >> 1] = f;
              if ((f & 65535) >>> 0 > 288) {
               break z;
              }
              f = g >>> 0 > 191 ? l << 4 : l;
              wa = h, xa = ue(d, 8), t[wa + 10 | 0] = xa;
              g = ue(d, w[E + 1 | 0] & 8 ? 4 : 9);
              t[h + 13 | 0] = 22;
              t[h + 14 | 0] = 0;
              v[h >> 2] = s;
              u[h + 8 >> 1] = g;
              A: {
               if (ue(d, 1)) {
                g = ue(d, 2);
                t[h + 11 | 0] = g;
                if (!(g & 255)) {
                 break z;
                }
                g = ue(d, 1);
                u[h + 18 >> 1] = 65287;
                t[h + 12 | 0] = g;
                if (w[h + 11 | 0] == 2) {
                 B: {
                  if (!(g & 255)) {
                   v[h >> 2] = n;
                   t[h + 18 | 0] = 8;
                   l = 0;
                   g = 39;
                   break B;
                  }
                  v[h >> 2] = L;
                  l = w[E + 1 | 0] & 8 ? 8 : 6;
                  g = 30;
                 }
                 t[h + 14 | 0] = g;
                 t[h + 13 | 0] = l;
                 f = f & 3855;
                }
                g = ue(d, 10);
                wa = h, xa = ue(d, 3), t[wa + 21 | 0] = xa;
                wa = h, xa = ue(d, 3), t[wa + 22 | 0] = xa;
                wa = h, xa = ue(d, 3), t[wa + 23 | 0] = xa;
                l = g << 5;
                break A;
               }
               t[h + 11 | 0] = 0;
               t[h + 12 | 0] = 0;
               l = ue(d, 15);
               wa = h, xa = ue(d, 4), t[wa + 18 | 0] = xa;
               g = ue(d, 3);
               t[h + 20 | 0] = 255;
               t[h + 19 | 0] = g;
              }
              t[h + 17 | 0] = l & 31;
              t[h + 15 | 0] = l >>> 10;
              t[h + 16 | 0] = l >>> 5 & 31;
              e = (H & 65535) + e | 0;
              C: {
               if (w[E + 1 | 0] & 8) {
                g = ue(d, 1);
                break C;
               }
               g = x[h + 8 >> 1] > 499;
              }
              t[h + 24 | 0] = g;
              wa = h, xa = ue(d, 1), t[wa + 25 | 0] = xa;
              g = ue(d, 1);
              t[h + 27 | 0] = f >>> 12 & 15;
              t[h + 26 | 0] = g;
              h = h + 28 | 0;
              l = f << 4;
              i = i - 1 | 0;
              if (i) {
               continue;
              }
              break;
             }
             j = (v[d + 4 >> 2] + e | 0) > (v[d + 8 >> 2] + (k << 3) | 0) ? -1 : k;
            }
            if (!((j | 0) < 0 | v[r + 17140 >> 2] > v[r + 17144 >> 2])) {
             g = v[d + 4 >> 2];
             f = v[d + 8 >> 2];
             i = r + 900 | 0;
             h = v[F + 6144 >> 2];
             e = h - j | 0;
             h = (h | 0) < (j | 0) ? h : j;
             e = yc(i + 12 | 0, (((e | 0) > 0 ? e : 0) + F | 0) + 6156 | 0, h);
             l = v[d >> 2] + (v[d + 4 >> 2] / 8 | 0) | 0;
             d = (f - g | 0) / 8 | 0;
             yc(e + h | 0, l, d);
             VL(i, e, d + h | 0);
             D: {
              j = v[F + 6144 >> 2] >= (j | 0);
              if (!j) {
               break D;
              }
              oa = F + 2304 | 0;
              pa = r + 8608 | 0;
              qa = r + 3840 | 0;
              while (1) {
               if ((w[E + 1 | 0] & 8 ? 2 : 1) >>> 0 <= o >>> 0) {
                break D;
               }
               ra = Qb(qa, 0, 4608);
               e = v[K + 8 >> 2];
               h = B(B(e, o), 28) + ka | 0;
               d = 0;
               la = (e | 0) > 0 ? e : 0;
               n = r + 900 | 0;
               L = n + 2940 | 0;
               H = n + 7548 | 0;
               sa = n + 16156 | 0;
               aa = F + 6152 | 0;
               while (1) {
                if ((d | 0) != (la | 0)) {
                 f = B(d, 28) + h | 0;
                 J = x[f + 4 >> 1];
                 Y = v[n + 4 >> 2];
                 A = B(d, 39) + sa | 0;
                 e = H;
                 s = d;
                 g = eb - 48 | 0;
                 eb = g;
                 d = f;
                 I = w[d + 25 | 0];
                 G = B(!w[d + 13 | 0] + (w[d + 14 | 0] != 0) | 0, 28) + 81792 | 0;
                 E: {
                  if (w[aa + 1 | 0] & 8) {
                   k = w[d + 27 | 0];
                   f = w[x[d + 8 >> 1] + 81888 | 0];
                   i = f & 3;
                   t[g + 47 | 0] = i;
                   t[g + 46 | 0] = i;
                   f = f >>> 2 | 0;
                   t[g + 45 | 0] = f;
                   t[g + 44 | 0] = f;
                   break E;
                  }
                  f = (w[aa + 3 | 0] & 16) >>> 4 & (s | 0) != 0;
                  m = f ? 12 : 0;
                  q = x[d + 8 >> 1] >>> f | 0;
                  while (1) {
                   if ((q | 0) >= 0) {
                    k = 3;
                    i = 1;
                    while (1) {
                     if ((k | 0) >= 0) {
                      f = w[(k + m | 0) + 81904 | 0];
                      t[(g + 44 | 0) + k | 0] = ((q >>> 0) / (i >>> 0) >>> 0) % (f >>> 0);
                      k = k - 1 | 0;
                      i = B(f, i);
                      continue;
                     }
                     break;
                    }
                    m = m + 4 | 0;
                    q = q - i | 0;
                    continue;
                   }
                   break;
                  }
                  G = m + G | 0;
                  k = -16;
                 }
                 i = g;
                 fa = g + 44 | 0;
                 q = 0;
                 while (1) {
                  F: {
                   G: {
                    H: {
                     if ((q | 0) == 4) {
                      break H;
                     }
                     f = w[q + G | 0];
                     if (!f) {
                      break H;
                     }
                     if (k & 8) {
                      yc(i, A, f);
                      break G;
                     }
                     m = w[q + fa | 0];
                     if (!m) {
                      Qb(i, 0, f);
                      Qb(A, 0, f);
                      break G;
                     }
                     ga = (k | 0) >= 0 ? -1 : -1 << m ^ -1;
                     l = 0;
                     while (1) {
                      if ((f | 0) == (l | 0)) {
                       break G;
                      }
                      V = ue(n, m);
                      t[l + A | 0] = (V | 0) == (ga | 0) ? -1 : V;
                      t[i + l | 0] = V;
                      l = l + 1 | 0;
                      continue;
                     }
                    }
                    t[i + 2 | 0] = 0;
                    t[i | 0] = 0;
                    t[i + 1 | 0] = 0;
                    break F;
                   }
                   k = k << 1;
                   q = q + 1 | 0;
                   i = f + i | 0;
                   A = f + A | 0;
                   continue;
                  }
                  break;
                 }
                 I: {
                  i = w[d + 14 | 0];
                  if (i) {
                   f = 2 - I | 0;
                   l = w[d + 23 | 0] << f;
                   q = w[d + 22 | 0] << f;
                   m = w[d + 21 | 0] << f;
                   A = w[d + 13 | 0];
                   k = 0;
                   while (1) {
                    if (i >>> 0 <= k >>> 0) {
                     break I;
                    }
                    f = g + (k + A | 0) | 0;
                    t[f | 0] = m + w[f | 0];
                    t[f + 1 | 0] = q + w[f + 1 | 0];
                    t[f + 2 | 0] = l + w[f + 2 | 0];
                    k = k + 3 | 0;
                    continue;
                   }
                  }
                  if (!w[d + 24 | 0]) {
                   break I;
                  }
                  k = 0;
                  while (1) {
                   if ((k | 0) == 10) {
                    break I;
                   }
                   f = g + k | 0;
                   t[f + 11 | 0] = w[f + 11 | 0] + w[k + 81928 | 0];
                   k = k + 1 | 0;
                   continue;
                  }
                 }
                 f = I + 1 | 0;
                 k = 0;
                 D = kz(C(2048), ((((w[aa + 3 | 0] & 224) == 96) << 1) - w[d + 10 | 0] | 0) + 258 | 0);
                 while (1) {
                  if (w[d + 13 | 0] + (i & 255) >>> 0 > k >>> 0) {
                   wa = e + (k << 2) | 0, ya = kz(D, w[g + k | 0] << f), z[wa >> 2] = ya;
                   k = k + 1 | 0;
                   i = w[d + 14 | 0];
                   continue;
                  }
                  break;
                 }
                 eb = g + 48 | 0;
                 l = L + B(s, 2304) | 0;
                 k = e;
                 fa = J + Y | 0;
                 D = C(0);
                 f = v[n + 4 >> 2];
                 g = v[n >> 2] + ((f | 0) / 8 | 0) | 0;
                 e = w[g | 0] | w[g + 1 | 0] << 8 | (w[g + 2 | 0] << 16 | w[g + 3 | 0] << 24);
                 e = (e << 24 | (e & 65280) << 8 | (e >>> 8 & 65280 | e >>> 24)) << (f & 7);
                 q = d;
                 ta = d + 18 | 0;
                 ua = d + 15 | 0;
                 m = f | -8;
                 A = g + 4 | 0;
                 G = v[d >> 2];
                 I = x[d + 6 >> 1];
                 d = 0;
                 while (1) {
                  J: {
                   K: {
                    if ((I | 0) > 0) {
                     g = d + 1 | 0;
                     f = w[d + ua | 0];
                     ga = (u[(f << 1) + 86352 >> 1] << 1) + 81968 | 0;
                     V = w[d + ta | 0];
                     if (f >>> 0 >= 16) {
                      ha = w[f + 86416 | 0];
                      va = 32 - ha | 0;
                      while (1) {
                       ia = w[G | 0] >>> 1 | 0;
                       ja = (I | 0) < (ia | 0) ? I : ia;
                       D = z[k >> 2];
                       while (1) {
                        f = e >>> 27 | 0;
                        d = 5;
                        while (1) {
                         f = u[ga + (f << 1) >> 1];
                         if ((f | 0) < 0) {
                          e = e << d;
                          i = f & 7;
                          f = (e >>> 32 - i | 0) - (f >> 3) | 0;
                          m = d + m | 0;
                          d = i;
                          continue;
                         }
                         break;
                        }
                        d = f >>> 8 | 0;
                        m = d + m | 0;
                        e = e << d;
                        i = 0;
                        while (1) {
                         if ((i | 0) != 2) {
                          J = f & 15;
                          L: {
                           if ((J | 0) == 15) {
                            m = m + ha | 0;
                            d = e << ha;
                            while (1) {
                             if ((m | 0) >= 0) {
                              d = w[A | 0] << m | d;
                              A = A + 1 | 0;
                              m = m - 8 | 0;
                              continue;
                             }
                             break;
                            }
                            J = (e >>> va | 0) + 15 | 0;
                            e = J;
                            M: {
                             if ((e | 0) <= 128) {
                              O = z[(e << 2) + 86512 >> 2];
                              break M;
                             }
                             ma = e >>> 0 < 1024;
                             e = ma ? e << 3 : e;
                             Y = e << 1 & 64;
                             R = C(C((e & 63) - Y | 0) / C(Y + (e & 2147483584) | 0));
                             O = C((ma ? C(16) : C(256)) * C(C(C(R * C(C(R * C(.2222222238779068)) + C(1.3333333730697632))) + C(1)) * z[(e + Y >>> 4 & 268435452) + 86512 >> 2]));
                            }
                            O = C(C(D * O) * C(d >> 31 | 1));
                            break L;
                           }
                           d = e;
                           O = C(D * z[(((d >>> 27 & 16 | J) ^ 16) << 2) + 86448 >> 2]);
                          }
                          z[l >> 2] = O;
                          f = f >>> 4 | 0;
                          l = l + 4 | 0;
                          i = i + 1 | 0;
                          e = (J | 0) != 0;
                          m = e + m | 0;
                          e = d << e;
                          continue;
                         }
                         break;
                        }
                        while (1) {
                         if ((m | 0) >= 0) {
                          e = w[A | 0] << m | e;
                          A = A + 1 | 0;
                          m = m - 8 | 0;
                          continue;
                         }
                         break;
                        }
                        ja = ja - 1 | 0;
                        if (ja) {
                         continue;
                        }
                        break;
                       }
                       k = k + 4 | 0;
                       G = G + 1 | 0;
                       I = I - ia | 0;
                       if ((I | 0) <= 0) {
                        break K;
                       }
                       d = (V | 0) > 0;
                       V = V - 1 | 0;
                       if (d) {
                        continue;
                       }
                       break;
                      }
                      break K;
                     }
                     while (1) {
                      Y = w[G | 0] >>> 1 | 0;
                      J = (I | 0) < (Y | 0) ? I : Y;
                      D = z[k >> 2];
                      while (1) {
                       d = e >>> 27 | 0;
                       f = 5;
                       while (1) {
                        d = u[ga + (d << 1) >> 1];
                        if ((d | 0) < 0) {
                         e = e << f;
                         i = d & 7;
                         d = (e >>> 32 - i | 0) - (d >> 3) | 0;
                         m = f + m | 0;
                         f = i;
                         continue;
                        }
                        break;
                       }
                       f = d >>> 8 | 0;
                       m = f + m | 0;
                       e = e << f;
                       f = 0;
                       while (1) {
                        if ((f | 0) != 2) {
                         i = d & 15;
                         z[l >> 2] = D * z[(((i | e >>> 27 & 16) ^ 16) << 2) + 86448 >> 2];
                         d = d >>> 4 | 0;
                         l = l + 4 | 0;
                         f = f + 1 | 0;
                         i = (i | 0) != 0;
                         m = i + m | 0;
                         e = e << i;
                         continue;
                        }
                        break;
                       }
                       while (1) {
                        if ((m | 0) >= 0) {
                         e = w[A | 0] << m | e;
                         A = A + 1 | 0;
                         m = m - 8 | 0;
                         continue;
                        }
                        break;
                       }
                       J = J - 1 | 0;
                       if (J) {
                        continue;
                       }
                       break;
                      }
                      k = k + 4 | 0;
                      G = G + 1 | 0;
                      I = I - Y | 0;
                      if ((I | 0) <= 0) {
                       break K;
                      }
                      d = (V | 0) > 0;
                      V = V - 1 | 0;
                      if (d) {
                       continue;
                      }
                      break;
                     }
                     break K;
                    }
                    f = 1 - I | 0;
                    while (1) {
                     N: {
                      g = w[q + 26 | 0] ? 86336 : 86304;
                      d = w[g + (e >>> 28 | 0) | 0];
                      if (!(d & 8)) {
                       d = w[g + (d >>> 3 | 0) + (e << 4 >>> 32 - (d & 3)) | 0];
                      }
                      g = d & 7;
                      m = g + m | 0;
                      if (((m + (A - v[n >> 2] << 3) | 0) - 24 | 0) > (fa | 0)) {
                       break N;
                      }
                      f = f - 1 | 0;
                      if (!f) {
                       f = w[G | 0];
                       if (f >>> 0 < 2) {
                        break N;
                       }
                       G = G + 1 | 0;
                       D = z[k >> 2];
                       k = k + 4 | 0;
                       f = f >>> 1 | 0;
                      }
                      e = e << g;
                      if (d >>> 0 >= 128) {
                       z[l >> 2] = (e | 0) < 0 ? C(-D) : D;
                       m = m + 1 | 0;
                       e = e << 1;
                      }
                      if (d & 64) {
                       z[l + 4 >> 2] = (e | 0) < 0 ? C(-D) : D;
                       m = m + 1 | 0;
                       e = e << 1;
                      }
                      f = f - 1 | 0;
                      if (!f) {
                       g = w[G | 0];
                       if (g >>> 0 < 2) {
                        break N;
                       }
                       G = G + 1 | 0;
                       D = z[k >> 2];
                       k = k + 4 | 0;
                       f = g >>> 1 | 0;
                      }
                      if (d & 32) {
                       z[l + 8 >> 2] = (e | 0) < 0 ? C(-D) : D;
                       m = m + 1 | 0;
                       e = e << 1;
                      }
                      if (d & 16) {
                       z[l + 12 >> 2] = (e | 0) < 0 ? C(-D) : D;
                       m = m + 1 | 0;
                       e = e << 1;
                      }
                      while (1) {
                       if ((m | 0) >= 0) {
                        e = w[A | 0] << m | e;
                        A = A + 1 | 0;
                        m = m - 8 | 0;
                        continue;
                       }
                       break;
                      }
                      l = l + 16 | 0;
                      continue;
                     }
                     break;
                    }
                    v[n + 4 >> 2] = fa;
                    break J;
                   }
                   d = g;
                   continue;
                  }
                  break;
                 }
                 d = s + 1 | 0;
                 continue;
                }
                break;
               }
               d = w[F + 6155 | 0];
               O: {
                if (d & 16) {
                 l = n + 16195 | 0;
                 f = 0;
                 g = eb - 16 | 0;
                 eb = g;
                 d = L;
                 k = d + 2304 | 0;
                 H = v[h >> 2];
                 m = w[h + 14 | 0];
                 A = w[h + 13 | 0];
                 s = m + A | 0;
                 e = g + 4 | 0;
                 v[e + 8 >> 2] = -1;
                 v[e >> 2] = -1;
                 v[e + 4 >> 2] = -1;
                 while (1) {
                  if ((f | 0) != (s | 0)) {
                   G = f + H | 0;
                   q = w[G | 0];
                   i = 0;
                   P: {
                    while (1) {
                     if (i >>> 0 >= q >>> 0) {
                      break P;
                     }
                     I = (i << 2) + k | 0;
                     if (z[I >> 2] == C(0)) {
                      i = i + 2 | 0;
                      if (z[I + 4 >> 2] == C(0)) {
                       continue;
                      }
                     }
                     break;
                    }
                    v[e + ((f >>> 0) % 3 << 2) >> 2] = f;
                    q = w[G | 0];
                   }
                   f = f + 1 | 0;
                   k = (q << 2) + k | 0;
                   continue;
                  }
                  break;
                 }
                 if (A) {
                  e = v[g + 4 >> 2];
                  f = v[g + 8 >> 2];
                  e = (e | 0) > (f | 0) ? e : f;
                  f = v[g + 12 >> 2];
                  e = (e | 0) > (f | 0) ? e : f;
                  v[g + 12 >> 2] = e;
                  v[g + 8 >> 2] = e;
                  v[g + 4 >> 2] = e;
                 }
                 e = m ? 3 : 1;
                 k = s - e | 0;
                 f = 0;
                 while (1) {
                  if ((e | 0) != (f | 0)) {
                   s = f + k | 0;
                   i = s - e | 0;
                   if ((i | 0) <= v[(g + 4 | 0) + (f << 2) >> 2]) {
                    i = w[aa + 1 | 0] << 28 >> 31 & 3;
                   } else {
                    i = w[i + l | 0];
                   }
                   t[l + s | 0] = i;
                   f = f + 1 | 0;
                   continue;
                  }
                  break;
                 }
                 s = v[h >> 2];
                 H = g + 4 | 0;
                 q = u[h + 36 >> 1] & 1;
                 i = 0;
                 m = w[aa + 1 | 0] & 8 ? 7 : 64;
                 while (1) {
                  A = i + s | 0;
                  e = w[A | 0];
                  if (e) {
                   k = w[aa + 3 | 0] & 32;
                   Q: {
                    R: {
                     if (v[H + ((i >>> 0) % 3 << 2) >> 2] >= (i | 0)) {
                      break R;
                     }
                     f = w[i + l | 0];
                     if (f >>> 0 >= m >>> 0) {
                      break R;
                     }
                     O = k ? C(1.4142135381698608) : C(1);
                     S: {
                      if (w[aa + 1 | 0] & 8) {
                       f = f << 3;
                       D = z[f + 87044 >> 2];
                       R = z[f + 87040 >> 2];
                       break S;
                      }
                      R = kz(C(1), f + 1 >>> 1 << q);
                      f = f & 1;
                      D = f ? C(1) : R;
                      R = f ? R : C(1);
                     }
                     R = C(O * R);
                     O = C(O * D);
                     f = 0;
                     while (1) {
                      if ((e | 0) != (f | 0)) {
                       k = (f << 2) + d | 0;
                       D = z[k >> 2];
                       z[k + 2304 >> 2] = D * O;
                       z[k >> 2] = D * R;
                       f = f + 1 | 0;
                       continue;
                      }
                      break;
                     }
                     break Q;
                    }
                    if (!k) {
                     break Q;
                    }
                    SL(d, e);
                   }
                   i = i + 1 | 0;
                   d = (w[A | 0] << 2) + d | 0;
                   continue;
                  }
                  break;
                 }
                 eb = g + 16 | 0;
                 break O;
                }
                if ((d & 224) != 96) {
                 break O;
                }
                SL(L, 576);
               }
               i = n + 7708 | 0;
               d = 0;
               while (1) {
                if ((d | 0) != (la | 0)) {
                 e = w[F + 6153 | 0];
                 f = (w[h + 12 | 0] != 0) << 1 << ((B((e >>> 3 & 1) + (e >>> 4 & 1) | 0, 3) + (w[F + 6154 | 0] >>> 2 & 3) | 0) == 2);
                 l = L + B(d, 2304) | 0;
                 k = l;
                 if (w[h + 14 | 0]) {
                  n = v[h >> 2] + w[h + 13 | 0] | 0;
                  m = B(f, 72) + k | 0;
                  g = m;
                  e = i;
                  while (1) {
                   s = w[n | 0];
                   if (s) {
                    q = s << 1;
                    H = 0;
                    while (1) {
                     if ((s | 0) != (H | 0)) {
                      z[e >> 2] = z[g >> 2];
                      z[e + 4 >> 2] = z[(s << 2) + g >> 2];
                      z[e + 8 >> 2] = z[(q << 2) + g >> 2];
                      g = g + 4 | 0;
                      H = H + 1 | 0;
                      e = e + 12 | 0;
                      continue;
                     }
                     break;
                    }
                    n = n + 3 | 0;
                    g = (q << 2) + g | 0;
                    continue;
                   }
                   break;
                  }
                  yc(m, i, e - i | 0);
                  e = f - 1 | 0;
                 } else {
                  e = 31;
                 }
                 while (1) {
                  g = 0;
                  if ((e | 0) > 0) {
                   while (1) {
                    if ((g | 0) != 8) {
                     n = g << 2;
                     s = n + k | 0;
                     D = z[s + 72 >> 2];
                     R = z[n + 87104 >> 2];
                     O = z[n + 87136 >> 2];
                     n = (17 - g << 2) + k | 0;
                     na = z[n >> 2];
                     z[s + 72 >> 2] = C(D * R) - C(O * na);
                     z[n >> 2] = C(D * O) + C(na * R);
                     g = g + 1 | 0;
                     continue;
                    }
                    break;
                   }
                   k = k + 72 | 0;
                   e = e - 1 | 0;
                   continue;
                  }
                  break;
                 }
                 g = l;
                 e = B(d, 1152) + F | 0;
                 k = w[h + 11 | 0];
                 if (f) {
                  RL(g, e, 87168, f);
                  g = B(f, 72) + g | 0;
                  e = B(f, 36) + e | 0;
                 }
                 T: {
                  if ((k | 0) == 2) {
                   k = 32 - f | 0;
                   f = eb - 80 | 0;
                   eb = f;
                   s = f | 8;
                   H = f | 4;
                   while (1) {
                    if ((k | 0) > 0) {
                     n = yc(f, g, 72);
                     q = v[e + 20 >> 2];
                     v[g + 16 >> 2] = v[e + 16 >> 2];
                     v[g + 20 >> 2] = q;
                     q = v[e + 12 >> 2];
                     v[g + 8 >> 2] = v[e + 8 >> 2];
                     v[g + 12 >> 2] = q;
                     q = v[e + 4 >> 2];
                     v[g >> 2] = v[e >> 2];
                     v[g + 4 >> 2] = q;
                     J = n;
                     n = e + 24 | 0;
                     jz(J, g + 24 | 0, n);
                     jz(H, g + 48 | 0, n);
                     jz(s, e, n);
                     g = g + 72 | 0;
                     e = e + 36 | 0;
                     k = k - 1 | 0;
                     continue;
                    }
                    break;
                   }
                   eb = f + 80 | 0;
                   break T;
                  }
                  RL(g, e, B((k | 0) == 3, 72) + 87168 | 0, 32 - f | 0);
                 }
                 f = 0;
                 l = l + 72 | 0;
                 while (1) {
                  g = 1;
                  if (f >>> 0 <= 31) {
                   while (1) {
                    if (g >>> 0 <= 17) {
                     e = (g << 2) + l | 0;
                     z[e >> 2] = -z[e >> 2];
                     g = g + 2 | 0;
                     continue;
                    }
                    break;
                   }
                   l = l + 144 | 0;
                   f = f + 2 | 0;
                   continue;
                  }
                  break;
                 }
                 h = h + 28 | 0;
                 d = d + 1 | 0;
                 continue;
                }
                break;
               }
               UL(oa, ra, 18, v[K + 8 >> 2], $, pa);
               o = o + 1 | 0;
               $ = B(v[K + 8 >> 2], 1152) + $ | 0;
               continue;
              }
             }
             h = r + 900 | 0;
             g = v[h + 8 >> 2] >>> 3 | 0;
             f = v[h + 4 >> 2] + 7 >>> 3 | 0;
             d = g - f | 0;
             e = (d | 0) >= 511 ? 511 : d;
             if ((d | 0) > 0) {
              fl(F + 6156 | 0, (h + (d >>> 0 > 511 ? g - 511 | 0 : f) | 0) + 12 | 0, e);
             }
             v[F + 6144 >> 2] = e;
             break x;
            }
            JB(F);
            break l;
           }
           l = r + 17136 | 0;
           o = 0;
           i = 0;
           k = 0;
           g = r + 770 | 0;
           h = r;
           d = 0;
           U: {
            V: {
             W: {
              j = w[E + 3 | 0];
              f = j >>> 6 | 0;
              switch (f - 1 | 0) {
              case 2:
               break U;

              case 0:
               break W;

              default:
               break V;
              }
             }
             d = (j >>> 2 & 12) + 4 | 0;
             break U;
            }
            d = 32;
           }
           j = w[E + 1 | 0];
           X: {
            if ((j & 6) == 6) {
             j = 32;
             e = 88572;
             break X;
            }
            if (!(j & 8)) {
             j = 30;
             e = 88575;
             break X;
            }
            n = w[E + 2 | 0];
            e = n >>> 2 & 3;
            j = mz(j, n) >>> ((f | 0) != 3) | 0;
            j = j ? j : 192;
            if (j >>> 0 <= 55) {
             j = (e | 0) == 2 ? 12 : 8;
             e = 88596;
             break X;
            }
            j = j >>> 0 <= 95 ? 27 : (e | 0) != 1 ? 30 : 27;
            e = 88584;
           }
           t[h + 768 | 0] = j;
           t[h + 769 | 0] = (d | 0) < (j | 0) ? d : j;
           j = e;
           f = 88480;
           while (1) {
            d = w[h + 768 | 0];
            if (o >>> 0 >= d >>> 0) {
             f = h + 834 | 0;
             o = 0;
             while (1) {
              e = d << 1 & 510;
              if (e >>> 0 > o >>> 0) {
               Y: {
                if (!w[g + o | 0]) {
                 j = 6;
                 break Y;
                }
                j = 2;
                if ((w[E + 1 | 0] & 6) == 6) {
                 break Y;
                }
                j = ue(l, 2);
                d = w[h + 768 | 0];
               }
               t[f + o | 0] = j;
               o = o + 1 | 0;
               continue;
              }
              break;
             }
             j = g;
             d = 0;
             k = e;
             while (1) {
              if ((d | 0) != (k | 0)) {
               i = w[j | 0];
               e = i ? 19 >>> w[d + f | 0] | 4 : 0;
               j = j + 1 | 0;
               n = B(i, 3) - 6 | 0;
               D = C(0);
               i = 4;
               while (1) {
                if (i) {
                 if (e & i) {
                  L = ue(l, 6);
                  s = (L | 0) / 3 | 0;
                  D = C(z[(n + (B(s, -3) + L | 0) << 2) + 88608 >> 2] * C(2097152 >>> s | 0));
                 }
                 z[h >> 2] = D;
                 i = i >>> 1 | 0;
                 h = h + 4 | 0;
                 continue;
                }
                break;
               }
               d = d + 1 | 0;
               continue;
              }
              break;
             }
             o = w[r + 769 | 0];
             d = w[r + 768 | 0];
             d = d >>> 0 < o >>> 0 ? o : d;
             while (1) {
              if ((d | 0) != (o | 0)) {
               t[(g + (o << 1) | 0) + 1 | 0] = 0;
               o = o + 1 | 0;
               continue;
              }
              break;
             }
            } else {
             if ((k | 0) == (o | 0)) {
              f = w[j | 0] + 88480 | 0;
              k = w[j + 2 | 0] + o | 0;
              i = w[j + 1 | 0];
              j = j + 3 | 0;
             }
             n = g + (o << 1) | 0;
             d = w[ue(l, i) + f | 0];
             t[n | 0] = d;
             e = w[h + 769 | 0];
             if (o >>> 0 < e >>> 0) {
              d = w[ue(l, i) + f | 0];
              e = w[h + 769 | 0];
             }
             t[n + 1 | 0] = e ? d : 0;
             o = o + 1 | 0;
             continue;
            }
            break;
           }
           j = 0;
           g = Qb(r + 3840 | 0, 0, 4608);
           H = F + 2304 | 0;
           q = r + 8608 | 0;
           o = 0;
           Z: {
            while (1) {
             if ((o | 0) == 3) {
              break Z;
             }
             m = g + (j << 2) | 0;
             n = r + 17136 | 0;
             h = 0;
             k = v[K + 16 >> 2] | 1;
             L = (k | 0) > 0 ? k : 0;
             E = r + 770 | 0;
             e = 576;
             while (1) {
              if ((h | 0) != 4) {
               l = m + (B(h, k) << 2) | 0;
               i = 0;
               while (1) {
                if (w[r + 768 | 0] << 1 >>> 0 > i >>> 0) {
                 _: {
                  f = w[i + E | 0];
                  if (!f) {
                   break _;
                  }
                  if (f >>> 0 <= 16) {
                   s = (-1 << f - 1) + 1 | 0;
                   d = 0;
                   while (1) {
                    if ((d | 0) == (L | 0)) {
                     break _;
                    }
                    wa = (d << 2) + l | 0, ya = C(ue(n, f) + s | 0), z[wa >> 2] = ya;
                    d = d + 1 | 0;
                    continue;
                   }
                  }
                  d = 2 << f - 17;
                  f = ue(n, (d - (d >>> 3 | 0) | 0) + 3 | 0);
                  A = d >>> 1 | 0;
                  s = d | 1;
                  d = 0;
                  while (1) {
                   if ((d | 0) == (L | 0)) {
                    break _;
                   }
                   J = f;
                   f = (f >>> 0) / (s >>> 0) | 0;
                   z[(d << 2) + l >> 2] = J - (A + B(s, f) | 0) | 0;
                   d = d + 1 | 0;
                   continue;
                  }
                 }
                 i = i + 1 | 0;
                 l = (e << 2) + l | 0;
                 e = 18 - e | 0;
                 continue;
                }
                break;
               }
               h = h + 1 | 0;
               continue;
              }
              break;
             }
             j = (k << 2) + j | 0;
             if ((j | 0) == 12) {
              d = (o << 2) + r | 0;
              j = g;
              h = w[r + 769 | 0];
              e = g + B(h, 72) | 0;
              yc(e + 2304 | 0, e, B(w[r + 768 | 0] - h | 0, 72));
              l = 0;
              while (1) {
               if (w[r + 768 | 0] > l >>> 0) {
                h = 0;
                while (1) {
                 if ((h | 0) != 12) {
                  e = (h << 2) + j | 0;
                  z[e >> 2] = z[d >> 2] * z[e >> 2];
                  e = e + 2304 | 0;
                  z[e >> 2] = z[d + 12 >> 2] * z[e >> 2];
                  h = h + 1 | 0;
                  continue;
                 }
                 break;
                }
                d = d + 24 | 0;
                j = j + 72 | 0;
                l = l + 1 | 0;
                continue;
               }
               break;
              }
              UL(H, g, 12, v[K + 8 >> 2], $, q);
              Qb(g, 0, 4608);
              $ = B(v[K + 8 >> 2], 768) + $ | 0;
              j = 0;
             }
             o = o + 1 | 0;
             if (v[r + 17140 >> 2] <= v[r + 17144 >> 2]) {
              continue;
             }
             break;
            }
            JB(F);
            o = 0;
            break l;
           }
           j = 1;
          }
          o = B(lz(w[F + 6153 | 0]), j);
         }
         eb = r + 17152 | 0;
         d = v[y + 32 >> 2];
         if ((d | 0) < 0 | !d) {
          break h;
         }
         j = v[y + 44 >> 2];
         if ((j | 0) != (ca | 0) ? ca : 0) {
          break h;
         }
         d = v[y + 40 >> 2];
         if ((d | 0) != (N | 0) ? N : 0) {
          break h;
         }
         if (d - 3 >>> 0 < 4294967294 | (j | 0) <= 0) {
          break i;
         }
         v[y + 16 >> 2] = 0;
         wa = y, xa = Fc(Z, ba), v[wa + 12 >> 2] = xa;
         h = y + 16 | 0;
         e = y + 12 | 0;
         N = v[Yj(K, h, e) >> 2];
         v[y + 16 >> 2] = 0;
         wa = y, xa = Fc(Z, ba), v[wa + 12 >> 2] = xa;
         h = v[Yj(K, h, e) >> 2];
         g = h >> 31;
         $: {
          if (!o) {
           break $;
          }
          e = v[ea >> 2];
          v[31601] = 0;
          T(593, U | 0, e | 0, e + (B(d, o) << 1) | 0) | 0;
          e = v[31601];
          v[31601] = 0;
          if ((e | 0) != 1) {
           break $;
          }
          c = S(124508) | 0;
          if ((fb | 0) == (_(124508) | 0)) {
           X(c | 0) | 0;
           v[31601] = 0;
           W(26);
           c = v[31601];
           v[31601] = 0;
           N = d;
           ca = j;
           if ((c | 0) != 1) {
            break h;
           }
           c = M() | 0;
          }
          nd(ea);
          break k;
         }
         if ((_c(v[U >> 2], v[U + 4 >> 2]) >>> 0) / (d >>> 0) >>> 0 > 268435456) {
          break i;
         }
         c = c + N | 0;
         ca = j;
         N = d;
         ba = ba - (g + (h >>> 0 > Z >>> 0) | 0) | 0;
         Z = Z - h | 0;
         if (!!Z & (ba | 0) >= 0 | (ba | 0) > 0) {
          continue;
         }
         break;
        }
        break h;
       }
       c = M() | 0;
      }
      MT(da);
      break j;
     }
     c = M() | 0;
    }
    nd(U);
    Jc(y + 76 | 0);
    P(c | 0);
    p();
   }
   N = d;
   ca = j;
  }
  j = 0;
  aa: {
   if (!ca | !N) {
    break aa;
   }
   c = v[U >> 2];
   d = v[U + 4 >> 2];
   if (lc(c, d)) {
    break aa;
   }
   if ((_c(c, d) >>> 0) / (N >>> 0) >>> 0 > 268435456) {
    break aa;
   }
   Wu(a, b);
   b = B(b, 104) + a | 0;
   a = b + 484380 | 0;
   wa = a, xa = (_c(v[U >> 2], v[U + 4 >> 2]) >>> 0) / (N >>> 0) | 0, v[wa >> 2] = xa;
   d = b + 484414 | 0;
   c = x[d >> 1];
   u[d >> 1] = (N | 0) == 2 ? c | 65 : c & 65470 | 1;
   Fh(a);
   j = ke(v[a >> 2], v[b + 484400 >> 2]);
   if (!j) {
    break aa;
   }
   XU(vb(v[U >> 2]), vb(v[U + 4 >> 2]), v[a + 20 >> 2]);
   j = ke(v[a >> 2], v[a + 20 >> 2]);
  }
  nd(ea);
  MT(da);
  nd(U);
  Jc(y + 76 | 0);
 }
 eb = y + 96 | 0;
 return j | 0;
}

function Aoa(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, q = 0, r = 0, s = 0, z = 0, A = 0, C = 0, D = 0, E = 0, F = 0, G = 0, H = 0, I = 0, J = 0, K = 0, L = 0, S = 0, U = 0, V = 0, W = 0;
 e = eb - 480 | 0;
 eb = e;
 xc(b);
 h = eb - 16 | 0;
 eb = h;
 k = e + 276 | 0;
 wW(h + 8 | 0, k);
 m = v[h + 12 >> 2];
 ic(h, v[b >> 2], v[b + 8 >> 2], v[h + 8 >> 2], v[h + 12 >> 2]);
 l = v[h + 4 >> 2];
 if ((l | 0) == (m | 0)) {
  Ub(b, v[h + 12 >> 2]);
 }
 eb = h + 16 | 0;
 h = (l | 0) == (m | 0);
 if (!h) {
  vW(k);
 }
 a: {
  if (!h) {
   break a;
  }
  if (!xW(k)) {
   break a;
  }
  d = 1;
  if ((c | 0) == 64) {
   break a;
  }
  Cd(a, 134217728);
  h = e + 8 | 0;
  fg(h, 3953);
  v[31601] = 0;
  d = e + 116 | 0;
  R(701, d | 0, h | 0, w[e + 280 | 0] | w[e + 281 | 0] << 8);
  k = v[31601];
  v[31601] = 0;
  b: {
   c: {
    d: {
     if ((k | 0) != 1) {
      yb(a + 1298344 | 0, d);
      sb(d);
      Db(h);
      h = tc(d, 8974);
      yb(a + 1298356 | 0, h);
      sb(h);
      V = a, W = v[Ec(d, 28) >> 2], v[V + 1298404 >> 2] = W;
      v[a + 480188 >> 2] = 4;
      V = a, W = Ab(w[e + 412 | 0] | w[e + 413 | 0] << 8), v[V + 480196 >> 2] = W;
      d = w[e + 416 | 0] | w[e + 417 | 0] << 8;
      v[a + 480260 >> 2] = 56;
      v[a + 480264 >> 2] = 13696;
      V = a, W = tW(Ab(d)), v[V + 480204 >> 2] = W;
      ow(Wb(v[a + 484360 >> 2], w[a + 484376 | 0]), e + 284 | 0, w[e + 282 | 0]);
      i = a + 946304 | 0;
      C = a + 484380 | 0;
      q = a + 480190 | 0;
      j = a + 480188 | 0;
      o = Mb(e + 264 | 0);
      D = Mb(e + 252 | 0);
      m = 0;
      e: {
       while (1) {
        f: {
         g: {
          h: {
           i: {
            j: {
             k: {
              l: {
               if (Ab(w[e + 476 | 0] | w[e + 477 | 0] << 8) >>> 0 > (m & 65535) >>> 0) {
                v[31601] = 0;
                d = Q(273, b | 0) | 0;
                h = v[31601];
                v[31601] = 0;
                if ((h | 0) == 1) {
                 break i;
                }
                u[e + 228 >> 1] = d;
                if ((d - 4e3 & 65535) >>> 0 <= 61536) {
                 break c;
                }
                d = Ab(w[e + 478 | 0] | w[e + 479 | 0] << 8);
                if ((Ab(w[e + 280 | 0] | w[e + 281 | 0] << 8) | 0) == 2) {
                 v[31601] = 0;
                 d = Q(281, b | 0) | 0;
                 h = v[31601];
                 v[31601] = 0;
                 if ((h | 0) == 1) {
                  break j;
                 }
                 d = d - 2 | 0;
                }
                v[31601] = 0;
                h = e + 8 | 0;
                R(185, h | 0, b | 0, d | 0);
                d = v[31601];
                v[31601] = 0;
                if ((d | 0) == 1) {
                 break k;
                }
                l = gc(e + 116 | 0, h);
                tb(h);
                F = x[qe(q, e + 228 | 0) >> 1];
                u[q >> 1] = F;
                v[31601] = 0;
                k = B(x[e + 228 >> 1], 104) + C | 0;
                N(279, k | 0, 1);
                d = v[31601];
                v[31601] = 0;
                m: {
                 n: {
                  o: {
                   if ((d | 0) == 1) {
                    break o;
                   }
                   if (Ab(w[e + 280 | 0] | w[e + 281 | 0] << 8) >>> 0 > 1) {
                    break n;
                   }
                   v[31601] = 0;
                   N(702, l | 0, k + 43 | 0);
                   d = v[31601];
                   v[31601] = 0;
                   if ((d | 0) == 1) {
                    break o;
                   }
                   v[31601] = 0;
                   O(183, l | 0, 1) | 0;
                   d = v[31601];
                   v[31601] = 0;
                   if ((d | 0) == 1) {
                    break o;
                   }
                   v[31601] = 0;
                   R(331, l | 0, i + (x[e + 228 >> 1] << 5) | 0, 30);
                   d = v[31601];
                   v[31601] = 0;
                   if ((d | 0) != 1) {
                    break m;
                   }
                  }
                  d = M() | 0;
                  break f;
                 }
                 h = Eb(e + 8 | 0);
                 v[31601] = 0;
                 R(358, l | 0, h | 0, 257);
                 d = v[31601];
                 v[31601] = 0;
                 p: {
                  q: {
                   if ((d | 0) == 1) {
                    break q;
                   }
                   Ae(k + 43 | 0, h);
                   v[31601] = 0;
                   O(183, l | 0, 1) | 0;
                   d = v[31601];
                   v[31601] = 0;
                   if ((d | 0) == 1) {
                    break q;
                   }
                   v[31601] = 0;
                   R(358, l | 0, h | 0, 31);
                   d = v[31601];
                   v[31601] = 0;
                   if ((d | 0) == 1) {
                    break q;
                   }
                   zc(i + (x[e + 228 >> 1] << 5) | 0, h);
                   if (!(t[e + 124 | 0] & 1)) {
                    break p;
                   }
                   v[31601] = 0;
                   O(183, l | 0, 1) | 0;
                   d = v[31601];
                   v[31601] = 0;
                   if ((d | 0) != 1) {
                    break p;
                   }
                  }
                  d = M() | 0;
                  sb(h);
                  break f;
                 }
                 sb(h);
                }
                v[31601] = 0;
                N(703, l | 0, e + 8 | 0);
                d = v[31601];
                v[31601] = 0;
                r: {
                 if ((d | 0) == 1) {
                  break r;
                 }
                 g = eb - 16 | 0;
                 eb = g;
                 d = _b(w[e + 8 | 0] | w[e + 9 | 0] << 8 | (w[e + 10 | 0] << 16 | w[e + 11 | 0] << 24));
                 v[k >> 2] = d;
                 t[g + 15 | 0] = w[e + 12 | 0];
                 t[g + 14 | 0] = 64;
                 V = k, W = w[Pb(g + 15 | 0, g + 14 | 0) | 0] << 2, u[V + 30 >> 1] = W;
                 f = _b(w[e + 14 | 0] | w[e + 15 | 0] << 8 | (w[e + 16 | 0] << 16 | w[e + 17 | 0] << 24));
                 v[k + 4 >> 2] = f;
                 h = _b(w[e + 14 | 0] | w[e + 15 | 0] << 8 | (w[e + 16 | 0] << 16 | w[e + 17 | 0] << 24)) + _b(w[e + 18 | 0] | w[e + 19 | 0] << 8 | (w[e + 20 | 0] << 16 | w[e + 21 | 0] << 24)) | 0;
                 v[k + 8 >> 2] = h;
                 if (d >>> 0 <= f >>> 0) {
                  f = d - 1 | 0;
                  v[k + 4 >> 2] = f;
                 }
                 if (d >>> 0 < h >>> 0) {
                  v[k + 8 >> 2] = d;
                  h = d;
                 }
                 s: {
                  if (f >>> 0 > h >>> 0) {
                   v[k + 4 >> 2] = 0;
                   v[k + 8 >> 2] = 0;
                   break s;
                  }
                  if (f >>> 0 >= h >>> 0) {
                   break s;
                  }
                  u[k + 34 >> 1] = x[k + 34 >> 1] | 2;
                  V = xb(k + 68 | 0, 0), W = f, v[V >> 2] = W;
                 }
                 eb = g + 16 | 0;
                 t: {
                  switch (Ab(w[e + 280 | 0] | w[e + 281 | 0] << 8) | 0) {
                  case 2:
                   t[k + 37 | 0] = w[e + 26 | 0] << 3;
                   break;

                  case 0:
                   break g;

                  default:
                   break t;
                  }
                 }
                 v[31601] = 0;
                 N(210, D | 0, F | 0);
                 d = v[31601];
                 v[31601] = 0;
                 if ((d | 0) == 1) {
                  break r;
                 }
                 v[31601] = 0;
                 N(704, o | 0, F | 0);
                 d = v[31601];
                 v[31601] = 0;
                 if ((d | 0) == 1) {
                  break r;
                 }
                 g = Ud(v[o >> 2], x[e + 228 >> 1] - 1 | 0);
                 Mc(g);
                 v[31601] = 0;
                 h = Q(273, b | 0) | 0;
                 d = v[31601];
                 v[31601] = 0;
                 if ((d | 0) == 1) {
                  break l;
                 }
                 d = v[b + 8 >> 2];
                 f = v[b >> 2];
                 v[31601] = 0;
                 d = T(150, f | 0, d | 0, h << 3) | 0;
                 f = v[31601];
                 v[31601] = 0;
                 if ((f | 0) == 1) {
                  break l;
                 }
                 if (d) {
                  v[31601] = 0;
                  N(705, g | 0, h | 0);
                  d = v[31601];
                  v[31601] = 0;
                  if ((d | 0) == 1) {
                   break l;
                  }
                  v[e + 248 >> 2] = 0;
                  if (!(w[k + 34 | 0] & 2) | h) {
                   break h;
                  }
                  d = v[k + 4 >> 2];
                  v[e + 240 >> 2] = d;
                  h = v[k + 8 >> 2];
                  v[31601] = 0;
                  v[e + 244 >> 2] = h - d;
                  N(706, g | 0, e + 240 | 0);
                  d = v[31601];
                  v[31601] = 0;
                  if ((d | 0) != 1) {
                   break g;
                  }
                  d = M() | 0;
                  break f;
                 }
                 tb(l);
                 break c;
                }
                d = M() | 0;
                break f;
               }
               u: {
                v: {
                 w: {
                  x: {
                   if (Ab(w[e + 280 | 0] | w[e + 281 | 0] << 8)) {
                    E = w[e + 283 | 0];
                    u[e + 238 >> 1] = 4;
                    G = 128;
                    break x;
                   }
                   v[31601] = 0;
                   G = Q(273, b | 0) | 0;
                   d = v[31601];
                   v[31601] = 0;
                   if ((d | 0) == 1) {
                    d = M() | 0;
                    break e;
                   }
                   d = w[e + 280 | 0] | w[e + 281 | 0] << 8;
                   E = w[e + 283 | 0];
                   u[e + 238 >> 1] = 4;
                   if (!Ab(d)) {
                    break w;
                   }
                  }
                  h = v[b + 8 >> 2];
                  k = 0;
                  while (1) {
                   y: {
                    if ((k & 65535) >>> 0 >= G >>> 0) {
                     break y;
                    }
                    v[31601] = 0;
                    d = Q(273, b | 0) | 0;
                    m = v[31601];
                    v[31601] = 0;
                    if ((m | 0) == 1) {
                     break v;
                    }
                    if ((d | 0) == 65535) {
                     break y;
                    }
                    v[31601] = 0;
                    E = Q(273, b | 0) | 0;
                    d = v[31601];
                    v[31601] = 0;
                    if ((d | 0) == 1) {
                     break v;
                    }
                    v[31601] = 0;
                    d = Q(273, b | 0) | 0;
                    m = v[31601];
                    v[31601] = 0;
                    if ((m | 0) == 1) {
                     break v;
                    }
                    u[e + 238 >> 1] = d;
                    if (d >>> 0 > 127) {
                     break c;
                    }
                    V = j, W = x[qe(j, e + 238 | 0) >> 1], u[V >> 1] = W;
                    v[31601] = 0;
                    O(183, b | 0, B(d, E) << 2) | 0;
                    d = v[31601];
                    v[31601] = 0;
                    if ((d | 0) == 1) {
                     break v;
                    }
                    k = k + 1 | 0;
                    continue;
                   }
                   break;
                  }
                  v[31601] = 0;
                  O(149, b | 0, h | 0) | 0;
                  d = v[31601];
                  v[31601] = 0;
                  if ((d | 0) == 1) {
                   break u;
                  }
                 }
                 d = x[j >> 1];
                 v[31601] = 0;
                 H = O(707, e + 240 | 0, d | 0) | 0;
                 d = v[31601];
                 v[31601] = 0;
                 if ((d | 0) != 1) {
                  L = a + 484344 | 0;
                  I = c & 1;
                  m = Ab(w[e + 414 | 0] | w[e + 415 | 0] << 8);
                  l = 0;
                  h = 0;
                  while (1) {
                   z: {
                    A: {
                     B: {
                      C: {
                       if ((l & 65535) >>> 0 >= G >>> 0) {
                        break C;
                       }
                       D: {
                        if (!Ab(w[e + 280 | 0] | w[e + 281 | 0] << 8)) {
                         d = x[e + 238 >> 1];
                         k = l;
                         break D;
                        }
                        v[31601] = 0;
                        k = Q(273, b | 0) | 0;
                        d = v[31601];
                        v[31601] = 0;
                        if ((d | 0) == 1) {
                         break z;
                        }
                        if ((k | 0) == 65535) {
                         break C;
                        }
                        v[31601] = 0;
                        E = Q(273, b | 0) | 0;
                        d = v[31601];
                        v[31601] = 0;
                        if ((d | 0) == 1) {
                         break z;
                        }
                        v[31601] = 0;
                        d = Q(273, b | 0) | 0;
                        g = v[31601];
                        v[31601] = 0;
                        if ((g | 0) == 1) {
                         break z;
                        }
                        u[e + 238 >> 1] = d;
                       }
                       g = v[b + 8 >> 2];
                       f = v[b >> 2];
                       v[31601] = 0;
                       s = g;
                       J = E & 65535;
                       g = J << 2;
                       d = T(150, f | 0, s | 0, B(g, d & 65535) | 0) | 0;
                       f = v[31601];
                       v[31601] = 0;
                       if ((f | 0) == 1) {
                        break z;
                       }
                       if (!d) {
                        break C;
                       }
                       if (!I) {
                        break B;
                       }
                       v[31601] = 0;
                       S = k & 65535;
                       d = T(196, L | 0, S | 0, J | 0) | 0;
                       k = v[31601];
                       v[31601] = 0;
                       if ((k | 0) == 1) {
                        break z;
                       }
                       if (!d) {
                        break B;
                       }
                       z = 0;
                       E: while (1) {
                        if ((z | 0) == (J | 0)) {
                         break A;
                        }
                        d = Vb(v[L >> 2], S);
                        af(e + 228 | 0, v[d >> 2], v[v[d + 48 >> 2] + 12 >> 2], z);
                        k = 0;
                        A = 0;
                        F: {
                         G: {
                          switch ((m & 3) - 1 | 0) {
                          case 0:
                           A = !(z & 3);
                           break F;

                          case 1:
                           A = !(z & 1);
                           break F;

                          case 2:
                           break G;

                          default:
                           break F;
                          }
                         }
                         A = (z & 3) != 3;
                        }
                        U = 0;
                        while (1) {
                         if (x[e + 238 >> 1] <= k >>> 0) {
                          z = z + 1 | 0;
                          continue E;
                         }
                         g = v[H >> 2];
                         f = Xc(v[e + 228 >> 2], k);
                         v[31601] = 0;
                         d = e + 224 | 0;
                         N(357, d | 0, b | 0);
                         j = v[31601];
                         v[31601] = 0;
                         if ((j | 0) == 1) {
                          break z;
                         }
                         j = B(k, 9) + g | 0;
                         g = Ic(d);
                         r = _e(d);
                         t[f + 1 | 0] = w[e + 224 | 0];
                         g = w[g | 0];
                         t[f | 0] = g;
                         d = w[Xi(d) | 0];
                         t[f + 5 | 0] = d;
                         n = f + 5 | 0;
                         if (g) {
                          t[f | 0] = g + 25;
                          t[j + 8 | 0] = 0;
                          t[j | 0] = 0;
                          t[j + 1 | 0] = 0;
                          t[j + 2 | 0] = 0;
                          t[j + 3 | 0] = 0;
                          t[j + 4 | 0] = 0;
                          t[j + 5 | 0] = 0;
                          t[j + 6 | 0] = 0;
                          t[j + 7 | 0] = 0;
                          d = w[f + 5 | 0];
                         }
                         i = d & 255;
                         r = w[r | 0];
                         H: {
                          I: {
                           if (r >>> 0 >= 240) {
                            d = i | (r & 15) << 8;
                            if (d) {
                             t[f + 3 | 0] = 17;
                             V = f, W = Xl(+(tW(d) >>> 0) / 1e4), t[V + 5 | 0] = W;
                             i = 0;
                             break H;
                            }
                            break I;
                           }
                           K = i >>> 4 | 0;
                           s = i << 4;
                           g = K | s;
                           J: {
                            switch (r | 0) {
                            case 0:
                             if (d & 255) {
                              t[f + 3 | 0] = 1;
                              i = 0;
                              break H;
                             }
                             break I;

                            case 1:
                             t[f + 3 | 0] = 2;
                             i = 0;
                             break H;

                            case 2:
                             t[f + 3 | 0] = 3;
                             i = 0;
                             break H;

                            case 3:
                             t[e + 220 | 0] = 15;
                             V = j, W = w[Pb(n, e + 220 | 0) | 0] | 16, t[V | 0] = W;
                             t[j + 7 | 0] = 0;
                             t[j + 1 | 0] = 0;
                             t[j + 2 | 0] = 0;
                             break I;

                            case 4:
                             t[e + 220 | 0] = 15;
                             V = j, W = w[Pb(n, e + 220 | 0) | 0] | 32, t[V | 0] = W;
                             t[j + 7 | 0] = 0;
                             t[j + 1 | 0] = 0;
                             t[j + 2 | 0] = 0;
                             break I;

                            case 5:
                             t[j + 7 | 0] = 0;
                             t[j + 2 | 0] = 0;
                             t[j + 1 | 0] = d;
                             t[j | 0] = 0;
                             break I;

                            case 6:
                             t[j + 7 | 0] = 0;
                             t[j + 2 | 0] = d;
                             t[j | 0] = 0;
                             t[j + 1 | 0] = 0;
                             break I;

                            case 7:
                             t[f + 3 | 0] = 23;
                             i = 0;
                             h = 0;
                             break H;

                            case 8:
                             t[f + 3 | 0] = 0;
                             i = 1;
                             h = g;
                             break H;

                            case 9:
                             t[f + 3 | 0] = 19;
                             t[e + 220 | 0] = 15;
                             V = f, W = w[Pb(n, e + 220 | 0) | 0] | 16, t[V + 5 | 0] = W;
                             i = 0;
                             break H;

                            case 10:
                             t[f + 3 | 0] = 19;
                             t[e + 220 | 0] = 15;
                             V = f, W = w[Pb(n, e + 220 | 0) | 0] | 32, t[V + 5 | 0] = W;
                             i = 0;
                             break H;

                            case 11:
                             t[j + 3 | 0] = g;
                             break I;

                            case 12:
                             t[f + 4 | 0] = d;
                             i = 1;
                             t[f + 2 | 0] = 1;
                             t[j + 3 | 0] = 0;
                             t[f + 3 | 0] = 0;
                             break H;

                            case 13:
                             g = d & 255;
                             K: {
                              L: {
                               if (g >>> 0 >= 16) {
                                t[f + 2 | 0] = 4;
                                d = (d & 240) >>> 4 | 0;
                                break L;
                               }
                               if (!g) {
                                break K;
                               }
                               t[f + 2 | 0] = 3;
                              }
                              t[f + 4 | 0] = d;
                             }
                             t[j + 3 | 0] = 0;
                             break I;

                            case 14:
                             t[f + 3 | 0] = 19;
                             t[f + 5 | 0] = !(d & 255);
                             i = 0;
                             break H;

                            case 15:
                             t[f + 3 | 0] = 16;
                             t[f + 5 | 0] = (d & 240) >>> 4;
                             i = 0;
                             m = d;
                             break H;

                            case 16:
                             t[j + 5 | 0] = 0;
                             t[j + 4 | 0] = d;
                             break I;

                            case 17:
                             t[j + 6 | 0] = i & 15 ? d : 0;
                             break I;

                            case 18:
                             t[f + 3 | 0] = 14;
                             i = 0;
                             break H;

                            case 19:
                             t[j + 8 | 0] = 0;
                             t[j + 7 | 0] = d;
                             t[j + 2 | 0] = 0;
                             t[j | 0] = 0;
                             t[j + 1 | 0] = 0;
                             break I;

                            case 20:
                             t[f + 3 | 0] = 12;
                             i = 0;
                             break H;

                            case 22:
                             g = w[f + 1 | 0];
                             M: {
                              if (!g) {
                               break M;
                              }
                              i = v[o >> 2];
                              if (Td(i, v[o + 4 >> 2]) >>> 0 < g >>> 0) {
                               break M;
                              }
                              d = d - 1 | 0;
                              t[n | 0] = d;
                              v[31601] = 0;
                              Q(708, e + 116 | 0) | 0;
                              r = v[31601];
                              v[31601] = 0;
                              if ((r | 0) == 1) {
                               break z;
                              }
                              v[e + 220 >> 2] = 9;
                              g = Ud(i, g - 1 | 0);
                              V = e, W = Td(v[g >> 2], v[g + 4 >> 2]), v[V + 112 >> 2] = W;
                              if (y[Gb(e + 220 | 0, e + 112 | 0) >> 2] <= (d & 255) >>> 0) {
                               break M;
                              }
                              t[f + 2 | 0] = 15;
                              t[f + 4 | 0] = w[f + 5 | 0];
                             }
                             break I;

                            case 23:
                             g = w[f + 1 | 0];
                             N: {
                              if (!g) {
                               break N;
                              }
                              i = v[o >> 2];
                              if (Td(i, v[o + 4 >> 2]) >>> 0 < g >>> 0) {
                               break N;
                              }
                              d = d - 1 | 0;
                              t[n | 0] = d;
                              g = Ud(i, g - 1 | 0);
                              i = v[g >> 2];
                              d = d & 255;
                              if (Td(i, v[g + 4 >> 2]) >>> 0 <= d >>> 0) {
                               break N;
                              }
                              g = Ud(i, d);
                              d = x[g + 8 >> 1];
                              O: {
                               if (d) {
                                break O;
                               }
                               d = 0;
                               i = x[q >> 1];
                               if (!ni(i)) {
                                break O;
                               }
                               d = i + 1 | 0;
                               u[q >> 1] = d;
                               u[g + 8 >> 1] = d;
                              }
                              t[f + 1 | 0] = d;
                             }
                             break I;

                            case 24:
                             g = w[f + 1 | 0];
                             P: {
                              if (!g) {
                               break P;
                              }
                              i = v[o >> 2];
                              if (Td(i, v[o + 4 >> 2]) >>> 0 < g >>> 0) {
                               break P;
                              }
                              d = d - 1 | 0;
                              t[n | 0] = d;
                              v[31601] = 0;
                              Q(708, e + 8 | 0) | 0;
                              r = v[31601];
                              v[31601] = 0;
                              if ((r | 0) == 1) {
                               break z;
                              }
                              v[e + 220 >> 2] = 9;
                              g = Ud(i, g - 1 | 0);
                              V = e, W = Td(v[g >> 2], v[g + 4 >> 2]), v[V + 112 >> 2] = W;
                              if (y[Gb(e + 220 | 0, e + 112 | 0) >> 2] > (d & 255) >>> 0) {
                               t[f + 2 | 0] = 15;
                               t[f + 4 | 0] = w[f + 5 | 0];
                              }
                              g = $b(v[D >> 2], w[f + 1 | 0] - 1 | 0);
                              d = x[g >> 1];
                              Q: {
                               if (d) {
                                break Q;
                               }
                               d = 0;
                               i = x[q >> 1];
                               if (!ni(i)) {
                                break Q;
                               }
                               d = i + 1 | 0;
                               u[q >> 1] = d;
                               u[g >> 1] = d;
                              }
                              t[f + 1 | 0] = d;
                             }
                             break I;

                            case 25:
                             g = w[f + 1 | 0];
                             R: {
                              if (!g) {
                               break R;
                              }
                              i = v[o >> 2];
                              if (Td(i, v[o + 4 >> 2]) >>> 0 < g >>> 0) {
                               break R;
                              }
                              d = d - 1 | 0;
                              t[n | 0] = d;
                              g = Ud(i, g - 1 | 0);
                              i = v[g >> 2];
                              d = d & 255;
                              if (Td(i, v[g + 4 >> 2]) >>> 0 <= d >>> 0) {
                               break R;
                              }
                              g = Ud(i, d);
                              d = x[g + 10 >> 1];
                              S: {
                               if (d) {
                                break S;
                               }
                               d = 0;
                               i = x[q >> 1];
                               if (!ni(i)) {
                                break S;
                               }
                               d = i + 1 | 0;
                               u[q >> 1] = d;
                               u[g + 10 >> 1] = d;
                              }
                              t[f + 1 | 0] = d;
                             }
                             break I;

                            case 29:
                             t[f + 5 | 0] = g;
                             t[f + 3 | 0] = 11;
                             if (i & 15) {
                              t[n | 0] = s | 15;
                              i = 0;
                              break H;
                             }
                             i = 0;
                             if ((d & 255) >>> 0 < 16) {
                              break H;
                             }
                             t[n | 0] = K | 240;
                             break H;

                            case 32:
                             if ((d & 255) >>> 0 >= 16) {
                              t[j + 3 | 0] = K;
                              break I;
                             }
                             t[f + 3 | 0] = 19;
                             t[f + 5 | 0] = d | 192;
                             i = 0;
                             break H;

                            case 33:
                             t[f + 3 | 0] = 19;
                             t[e + 220 | 0] = 15;
                             V = f, W = w[Pb(n, e + 220 | 0) | 0] | 208, t[V + 5 | 0] = W;
                             i = 0;
                             break H;

                            case 34:
                             t[f + 3 | 0] = 19;
                             t[e + 220 | 0] = 15;
                             V = f, W = w[Pb(n, e + 220 | 0) | 0] | 144, t[V + 5 | 0] = W;
                             i = 0;
                             break H;

                            case 73:
                             t[f + 3 | 0] = 10;
                             i = 0;
                             break H;

                            case 78:
                             if ((d & 112 | 128) == 224) {
                              t[f + 3 | 0] = 19;
                              i = 0;
                              break H;
                             }
                             break I;

                            case 79:
                             if ((d & 255) >>> 0 <= 31) {
                              t[f + 3 | 0] = 16;
                              i = 0;
                              m = 0;
                              break H;
                             }
                             t[f + 3 | 0] = 17;
                             i = 0;
                             break H;

                            default:
                             break J;
                            }
                           }
                          }
                          t[f + 3 | 0] = 0;
                          i = 1;
                         }
                         g = 0;
                         d = w[j + 3 | 0];
                         if (!(w[f + 2 | 0] | !d)) {
                          g = d;
                          s = d >>> 4 | 0;
                          d = d >>> 0 < 16;
                          t[f + 4 | 0] = d ? g : s;
                          t[f + 2 | 0] = d ? 6 : 5;
                          g = 1;
                         }
                         T: {
                          if (!i) {
                           break T;
                          }
                          d = w[j + 1 | 0];
                          U: {
                           if (d) {
                            t[f + 3 | 0] = 2;
                            break U;
                           }
                           d = w[j + 2 | 0];
                           if (d) {
                            t[f + 3 | 0] = 3;
                            break U;
                           }
                           d = w[j | 0];
                           if (d) {
                            t[f + 3 | 0] = 19;
                            break U;
                           }
                           d = w[j + 7 | 0];
                           if (d) {
                            t[f + 3 | 0] = 4;
                            t[j + 8 | 0] = d;
                            break U;
                           }
                           d = w[j + 4 | 0];
                           if (d) {
                            t[f + 3 | 0] = 5;
                            t[j + 5 | 0] = d;
                            break U;
                           }
                           d = w[j + 3 | 0];
                           if (!(!d | g)) {
                            t[f + 5 | 0] = d;
                            t[f + 3 | 0] = 11;
                            if (d & 15) {
                             d = d | -16;
                             break U;
                            }
                            d = d | 15;
                            break U;
                           }
                           d = w[j + 6 | 0];
                           if (d) {
                            t[f + 3 | 0] = 8;
                            break U;
                           }
                           if (A) {
                            t[f + 3 | 0] = 20;
                            A = 0;
                            d = 97;
                            break U;
                           }
                           A = 0;
                           if (!(h & 255) | U) {
                            break T;
                           }
                           t[f + 5 | 0] = h;
                           t[f + 3 | 0] = 24;
                           d = h & 15 ? h | -16 : h | 15;
                           U = 1;
                          }
                          t[n | 0] = d;
                         }
                         k = k + 1 | 0;
                         continue;
                        }
                       }
                      }
                      v[a + 480228 >> 2] = 256 / x[a + 480188 >> 1];
                      i = 1;
                      Th(a, 1);
                      if (Ab(w[e + 280 | 0] | w[e + 281 | 0] << 8)) {
                       V: {
                        while (1) {
                         a = v[b + 8 >> 2];
                         d = v[b >> 2];
                         v[31601] = 0;
                         a = T(150, d | 0, a | 0, 2) | 0;
                         d = v[31601];
                         v[31601] = 0;
                         if ((d | 0) == 1) {
                          break z;
                         }
                         if (!a) {
                          break V;
                         }
                         v[31601] = 0;
                         a = Q(273, b | 0) | 0;
                         d = v[31601];
                         v[31601] = 0;
                         if ((d | 0) == 1) {
                          break z;
                         }
                         if ((a | 0) == 65535) {
                          break V;
                         }
                         v[31601] = 0;
                         O(183, b | 0, 2) | 0;
                         a = v[31601];
                         v[31601] = 0;
                         if ((a | 0) == 1) {
                          break z;
                         }
                         v[31601] = 0;
                         a = Q(281, b | 0) | 0;
                         d = v[31601];
                         v[31601] = 0;
                         if ((d | 0) != 1) {
                          v[31601] = 0;
                          O(183, b | 0, a | 0) | 0;
                          a = v[31601];
                          v[31601] = 0;
                          if ((a | 0) != 1) {
                           continue;
                          }
                         }
                         break;
                        }
                        break z;
                       }
                       v[31601] = 0;
                       O(183, b | 0, 34) | 0;
                       a = v[31601];
                       v[31601] = 0;
                       if ((a | 0) == 1) {
                        break z;
                       }
                      }
                      W: {
                       if (!(c & 2)) {
                        break W;
                       }
                       while (1) {
                        a = i & 65535;
                        if (a >>> 0 > F >>> 0) {
                         break W;
                        }
                        X: {
                         c = B(a, 104) + C | 0;
                         if (!v[c >> 2]) {
                          break X;
                         }
                         d = Yc(e + 228 | 0, 8, 1, 0, 0);
                         v[31601] = 0;
                         T(215, d | 0, c | 0, b | 0) | 0;
                         d = v[31601];
                         v[31601] = 0;
                         if ((d | 0) == 1) {
                          break z;
                         }
                         d = v[o >> 2];
                         if (Td(d, v[o + 4 >> 2]) >>> 0 < a >>> 0) {
                          break X;
                         }
                         g = a - 1 | 0;
                         m = Ud(d, g);
                         a = 0;
                         k = 0;
                         f = eb - 112 | 0;
                         eb = f;
                         Y: {
                          l = v[c >> 2];
                          if (!ke(l, v[c + 20 >> 2])) {
                           break Y;
                          }
                          n = v[m >> 2];
                          d = Td(n, v[m + 4 >> 2]);
                          if (d >>> 0 < 2) {
                           break Y;
                          }
                          h = Wo(f + 8 | 0, c);
                          v[h + 20 >> 2] = 0;
                          v[h >> 2] = 0;
                          Z: {
                           while (1) {
                            if ((a | 0) == (d | 0)) {
                             break Z;
                            }
                            _: {
                             j = Ud(n, a);
                             q = v[j >> 2];
                             if (q >>> 0 >= l >>> 0) {
                              break _;
                             }
                             j = v[j + 4 >> 2];
                             if (j >>> 0 > l - q >>> 0 | 268435456 - j >>> 0 < k >>> 0) {
                              break _;
                             }
                             k = j + k | 0;
                             v[h >> 2] = k;
                             a = a + 1 | 0;
                             continue;
                            }
                            break;
                           }
                           d = a;
                          }
                          if (!Fh(h)) {
                           break Y;
                          }
                          j = h + 68 | 0;
                          k = 0;
                          a = 0;
                          while (1) {
                           if ((a | 0) == (d | 0)) {
                            mn(c);
                            a = Wo(c, h);
                            v[a + 4 >> 2] = 0;
                            v[a + 8 >> 2] = v[a >> 2];
                            u[a + 34 >> 1] = x[a + 34 >> 1] | 2;
                            break Y;
                           }
                           I = v[h + 20 >> 2] + k | 0;
                           s = v[c + 20 >> 2];
                           l = Ud(v[m >> 2], a);
                           yc(I, s + v[l >> 2] | 0, v[l + 4 >> 2]);
                           v[l >> 2] = k;
                           if (a - 10 >>> 0 >= 4294967287) {
                            V = xb(j, a - 1 | 0), W = k, v[V >> 2] = W;
                           }
                           a = a + 1 | 0;
                           k = v[l + 4 >> 2] + k | 0;
                           continue;
                          }
                         }
                         eb = f + 112 | 0;
                         a = x[$b(v[D >> 2], g) >> 1];
                         if (a) {
                          AC(c, B(a, 104) + C | 0, 0, v[c >> 2], 0);
                         }
                         a = Ud(v[o >> 2], g);
                         V = e, W = vb(v[a >> 2]), v[V + 228 >> 2] = W;
                         d = vb(v[a + 4 >> 2]);
                         while (1) {
                          a = v[e + 228 >> 2];
                          if (!Hb(a, d)) {
                           break X;
                          }
                          h = x[a + 8 >> 1];
                          if (h) {
                           AC(c, B(h, 104) + C | 0, v[a >> 2], v[a + 4 >> 2], 1);
                          }
                          h = x[a + 10 >> 1];
                          if (h) {
                           AC(c, B(h, 104) + C | 0, v[a >> 2], v[a + 4 >> 2], 0);
                          }
                          vm(e + 228 | 0);
                          continue;
                         }
                        }
                        i = i + 1 | 0;
                        continue;
                       }
                      }
                      yv(H);
                      d = 1;
                      break b;
                     }
                     v[31601] = 0;
                     O(183, b | 0, B(g, x[e + 238 >> 1]) | 0) | 0;
                     d = v[31601];
                     v[31601] = 0;
                     if ((d | 0) != 1) {
                      break A;
                     }
                     break z;
                    }
                    l = l + 1 | 0;
                    continue;
                   }
                   break;
                  }
                  d = M() | 0;
                  yv(H);
                  break e;
                 }
                 d = M() | 0;
                 break e;
                }
                d = M() | 0;
                break e;
               }
               d = M() | 0;
               break e;
              }
              d = M() | 0;
              break f;
             }
             d = M() | 0;
             break e;
            }
            d = M() | 0;
            break e;
           }
           d = M() | 0;
           break e;
          }
          d = 0;
          while (1) {
           if (h >>> 0 <= (d & 65535) >>> 0) {
            break g;
           }
           v[31601] = 0;
           k = Q(281, b | 0) | 0;
           f = v[31601];
           v[31601] = 0;
           $: {
            if ((f | 0) == 1) {
             break $;
            }
            v[31601] = 0;
            v[e + 240 >> 2] = k;
            k = Q(281, b | 0) | 0;
            f = v[31601];
            v[31601] = 0;
            if ((f | 0) == 1) {
             break $;
            }
            v[31601] = 0;
            v[e + 244 >> 2] = k;
            N(706, g | 0, e + 240 | 0);
            k = v[31601];
            v[31601] = 0;
            if ((k | 0) == 1) {
             break $;
            }
            d = d + 1 | 0;
            continue;
           }
           break;
          }
          d = M() | 0;
          break f;
         }
         tb(l);
         m = m + 1 | 0;
         continue;
        }
        break;
       }
       tb(l);
      }
      nd(D);
      rW(o);
      break d;
     }
     d = M() | 0;
     Db(e + 8 | 0);
    }
    P(d | 0);
    p();
   }
   d = 0;
  }
  nd(D);
  rW(o);
 }
 eb = e + 480 | 0;
 return d | 0;
}

function dD(a, b, c, d) {
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, q = 0, r = 0, s = 0, A = C(0), E = 0, F = 0, G = 0, I = 0, J = C(0), K = 0, L = 0, M = 0, N = 0, O = 0, P = C(0);
 r = eb - 1520 | 0;
 eb = r;
 e = r + 8 | 0;
 N = Qb(e, 0, 1512), O = -1, v[N + 1420 >> 2] = O;
 t[r + 56 | 0] = 1;
 v[r + 48 >> 2] = a + b;
 v[r + 40 >> 2] = a;
 l = eb - 1024 | 0;
 eb = l;
 t[e + 1377 | 0] = 1;
 a: {
  if (!Rt(e)) {
   break a;
  }
  b = w[e + 1375 | 0];
  if (!(b & 2)) {
   bc(e, 34);
   break a;
  }
  if (b & 4) {
   bc(e, 34);
   break a;
  }
  if (b & 1) {
   bc(e, 34);
   break a;
  }
  if (v[e + 1116 >> 2] != 1) {
   bc(e, 34);
   break a;
  }
  b = w[e + 1120 | 0];
  if ((b | 0) != 30) {
   b: {
    if ((b | 0) != 64) {
     break b;
    }
    if (!fz(e, l + 1018 | 0, 6) | w[l + 1018 | 0] != 102 | (w[l + 1019 | 0] != 105 | w[l + 1020 | 0] != 115)) {
     break b;
    }
    if (w[l + 1021 | 0] != 104 | w[l + 1022 | 0] != 101 | w[l + 1023 | 0] != 97) {
     break b;
    }
    if ((ff(e) | 0) != 100) {
     break b;
    }
    if (ff(e)) {
     break b;
    }
    bc(e, 38);
    break a;
   }
   bc(e, 34);
   break a;
  }
  if ((ff(e) | 0) != 1) {
   bc(e, 34);
   break a;
  }
  if (!fz(e, l + 1018 | 0, 6)) {
   bc(e, 10);
   break a;
  }
  if (!dz(l + 1018 | 0)) {
   bc(e, 34);
   break a;
  }
  if (qj(e)) {
   bc(e, 34);
   break a;
  }
  b = ff(e);
  v[e + 4 >> 2] = b;
  if (!b) {
   bc(e, 34);
   break a;
  }
  if (b >>> 0 >= 17) {
   bc(e, 5);
   break a;
  }
  b = qj(e);
  v[e >> 2] = b;
  if (!b) {
   bc(e, 34);
   break a;
  }
  qj(e);
  qj(e);
  qj(e);
  b = ff(e);
  g = b >>> 4 | 0;
  v[e + 116 >> 2] = 1 << g;
  i = b & 15;
  v[e + 112 >> 2] = 1 << i;
  if (i - 14 >>> 0 <= 4294967287) {
   bc(e, 20);
   break a;
  }
  if (b + 32 << 24 >> 24 >= 0) {
   bc(e, 20);
   break a;
  }
  c: {
   if (g >>> 0 < i >>> 0) {
    bc(e, 20);
    break c;
   }
   if (!(ff(e) & 1)) {
    bc(e, 34);
    break c;
   }
   if (!Rt(e)) {
    break a;
   }
   if (!ez(e)) {
    break a;
   }
   if (!gz(e)) {
    break a;
   }
   d: {
    e: {
     if ((Mh(e) | 0) == 3) {
      while (1) {
       if ((f | 0) != 6) {
        N = (l + 1018 | 0) + f | 0, O = Mh(e), t[N | 0] = O;
        f = f + 1 | 0;
        continue;
       }
       break;
      }
      if (!dz(l + 1018 | 0)) {
       bc(e, 20);
       break c;
      }
      b = cz(e);
      f = te(e, b + 1 | 0);
      v[e + 20 >> 2] = f;
      if (!f) {
       break e;
      }
      f = 0;
      i = (b | 0) > 0 ? b : 0;
      while (1) {
       if ((f | 0) != (i | 0)) {
        g = Mh(e);
        t[v[e + 20 >> 2] + f | 0] = g;
        f = f + 1 | 0;
        continue;
       }
       break;
      }
      t[b + v[e + 20 >> 2] | 0] = 0;
      b = cz(e);
      v[e + 28 >> 2] = 0;
      v[e + 24 >> 2] = b;
      if ((b | 0) <= 0) {
       break d;
      }
      b = te(e, b << 2);
      v[e + 28 >> 2] = b;
      if (b) {
       break d;
      }
      bc(e, 3);
      break c;
     }
     bc(e, 20);
     break c;
    }
    bc(e, 3);
    break c;
   }
   b = 0;
   while (1) {
    f: {
     g: {
      if (v[e + 24 >> 2] > (b | 0)) {
       i = cz(e);
       f = te(e, i + 1 | 0);
       g = b << 2;
       v[g + v[e + 28 >> 2] >> 2] = f;
       if (!v[g + v[e + 28 >> 2] >> 2]) {
        break g;
       }
       f = 0;
       j = (i | 0) > 0 ? i : 0;
       while (1) {
        if ((f | 0) == (j | 0)) {
         break f;
        }
        h = Mh(e);
        t[v[g + v[e + 28 >> 2] >> 2] + f | 0] = h;
        f = f + 1 | 0;
        continue;
       }
      }
      if (!(Mh(e) & 1)) {
       bc(e, 20);
       break c;
      }
      GL(e, w[e + 1376 | 0]);
      t[e + 1376 | 0] = 0;
      while (1) {
       b = gz(e);
       GL(e, b);
       t[e + 1376 | 0] = 0;
       if (b) {
        continue;
       }
       break;
      }
      f = 0;
      if (!ez(e)) {
       break a;
      }
      if (!NL(e)) {
       if (v[e + 100 >> 2] != 21) {
        break a;
       }
       v[e + 100 >> 2] = 20;
       break a;
      }
      b = 0;
      while (1) {
       if ((b | 0) != 256) {
        g = b << 24;
        i = 0;
        while (1) {
         if ((i | 0) != 8) {
          g = g >> 31 & 79764919 ^ g << 1;
          i = i + 1 | 0;
          continue;
         }
         break;
        }
        v[(b << 2) + 495296 >> 2] = g;
        b = b + 1 | 0;
        continue;
       }
       break;
      }
      if ((Mh(e) | 0) == 5) {
       while (1) {
        if ((f | 0) != 6) {
         N = (l + 1018 | 0) + f | 0, O = Mh(e), t[N | 0] = O;
         f = f + 1 | 0;
         continue;
        }
        break;
       }
       if (!dz(l + 1018 | 0)) {
        bc(e, 20);
        break c;
       }
       b = qc(e, 8) + 1 | 0;
       v[e + 120 >> 2] = b;
       b = te(e, B(b, 2096));
       v[e + 124 >> 2] = b;
       if (!b) {
        bc(e, 3);
        break c;
       }
       Qb(b, 0, B(v[e + 120 >> 2], 2096));
       h: {
        while (1) {
         i: {
          j: {
           if (v[e + 120 >> 2] > (m | 0)) {
            b = v[e + 124 >> 2];
            if ((qc(e, 8) & 255) != 66) {
             bc(e, 20);
             break c;
            }
            if ((qc(e, 8) & 255) != 67) {
             bc(e, 20);
             break c;
            }
            if ((qc(e, 8) & 255) != 86) {
             bc(e, 20);
             break c;
            }
            h = B(m, 2096) + b | 0;
            N = h, O = qc(e, 8) & 255 | qc(e, 8) << 8, v[N >> 2] = O;
            N = h, O = qc(e, 8) & 255 | (qc(e, 8) << 8 & 65280 | qc(e, 8) << 16), v[N + 4 >> 2] = O;
            g = 0;
            f = qc(e, 1);
            if (!f) {
             g = qc(e, 1);
            }
            t[h + 23 | 0] = g;
            b = v[h + 4 >> 2];
            if (!(v[h >> 2] | !b)) {
             bc(e, 20);
             break c;
            }
            k: {
             if (g & 255) {
              j = no(e, b);
              break k;
             }
             j = te(e, b);
             v[h + 8 >> 2] = j;
            }
            if (!j) {
             bc(e, 3);
             break c;
            }
            i = 0;
            if (f) {
             break j;
            }
            g = 0;
            while (1) {
             f = v[h + 4 >> 2];
             if ((f | 0) <= (g | 0)) {
              break i;
             }
             l: {
              m: {
               if (w[h + 23 | 0]) {
                if (!qc(e, 1)) {
                 break m;
                }
               }
               b = qc(e, 5) + 1 | 0;
               t[g + j | 0] = b;
               if ((b & 255) != 32) {
                i = i + 1 | 0;
                break l;
               }
               bc(e, 20);
               break c;
              }
              t[g + j | 0] = 255;
             }
             g = g + 1 | 0;
             continue;
            }
           }
           b = qc(e, 6) + 1 & 255;
           f = 0;
           n: {
            while (1) {
             if ((b | 0) == (f | 0)) {
              break n;
             }
             f = f + 1 | 0;
             if (!qc(e, 16)) {
              continue;
             }
             break;
            }
            bc(e, 20);
            break c;
           }
           b = qc(e, 6) + 1 | 0;
           v[e + 128 >> 2] = b;
           b = te(e, B(b, 1596));
           v[e + 260 >> 2] = b;
           o: {
            if (b) {
             o = e + 132 | 0;
             p: while (1) {
              if (v[e + 128 >> 2] <= (F | 0)) {
               break o;
              }
              b = qc(e, 16);
              u[o + (F << 1) >> 1] = b;
              b = b & 65535;
              if (b >>> 0 >= 2) {
               bc(e, 20);
               break c;
              }
              if (!b) {
               b = v[e + 260 >> 2] + B(F, 1596) | 0;
               N = b, O = qc(e, 8), t[N | 0] = O;
               N = b, O = qc(e, 16), u[N + 2 >> 1] = O;
               N = b, O = qc(e, 16), u[N + 4 >> 1] = O;
               N = b, O = qc(e, 6), t[N + 6 | 0] = O;
               N = b, O = qc(e, 8), t[N + 7 | 0] = O;
               g = qc(e, 4) + 1 | 0;
               t[b + 8 | 0] = g;
               i = b + 9 | 0;
               f = 0;
               while (1) {
                if ((g & 255) >>> 0 > f >>> 0) {
                 N = f + i | 0, O = qc(e, 8), t[N | 0] = O;
                 f = f + 1 | 0;
                 g = w[b + 8 | 0];
                 continue;
                }
                break;
               }
               bc(e, 4);
               break c;
              }
              b = v[e + 260 >> 2] + B(F, 1596) | 0;
              f = qc(e, 5);
              t[b | 0] = f;
              k = b + 1 | 0;
              g = 0;
              j = -1;
              while (1) if ((f & 255) >>> 0 <= g >>> 0) {
               i = j + 1 | 0;
               j = b + 82 | 0;
               h = b + 65 | 0;
               m = b + 49 | 0;
               n = b + 33 | 0;
               f = 0;
               while (1) {
                q: {
                 if ((f | 0) != (i | 0)) {
                  N = f + n | 0, O = qc(e, 3) + 1 | 0, t[N | 0] = O;
                  q = f + m | 0;
                  g = qc(e, 2);
                  t[q | 0] = g;
                  if (!(g & 255)) {
                   break q;
                  }
                  g = qc(e, 8);
                  t[f + h | 0] = g;
                  if (v[e + 120 >> 2] > (g & 255)) {
                   break q;
                  }
                  bc(e, 20);
                  break c;
                 }
                 j = 2;
                 N = b, O = qc(e, 2) + 1 | 0, t[N + 1588 | 0] = O;
                 f = qc(e, 4);
                 v[b + 1592 >> 2] = 2;
                 i = 0;
                 u[b + 338 >> 1] = 0;
                 t[b + 1589 | 0] = f;
                 u[b + 340 >> 1] = 1 << f;
                 h = b + 338 | 0;
                 m = 0;
                 while (1) {
                  if (w[b | 0] > m >>> 0) {
                   f = n + w[k + m | 0] | 0;
                   g = 0;
                   while (1) {
                    if (w[f | 0] > g >>> 0) {
                     j = qc(e, w[b + 1589 | 0]);
                     u[h + (v[b + 1592 >> 2] << 1) >> 1] = j;
                     j = v[b + 1592 >> 2] + 1 | 0;
                     v[b + 1592 >> 2] = j;
                     g = g + 1 | 0;
                     continue;
                    }
                    break;
                   }
                   m = m + 1 | 0;
                   continue;
                  }
                  break;
                 }
                 while (1) {
                  if ((i | 0) < (j | 0)) {
                   f = x[h + (i << 1) >> 1];
                   g = (l + 16 | 0) + (i << 2) | 0;
                   u[g + 2 >> 1] = i;
                   u[g >> 1] = f;
                   i = i + 1 | 0;
                   j = v[b + 1592 >> 2];
                   continue;
                  }
                  break;
                 }
                 FL(l + 16 | 0, j, 1215);
                 j = v[b + 1592 >> 2];
                 f = ((j | 0) <= 1 ? 1 : j) - 1 | 0;
                 g = 0;
                 r: {
                  while (1) {
                   if ((f | 0) == (g | 0)) {
                    f = b + 838 | 0;
                    g = 0;
                    break r;
                   }
                   i = l + 16 | 0;
                   k = x[i + (g << 2) >> 1];
                   g = g + 1 | 0;
                   if ((k | 0) != x[i + (g << 2) >> 1]) {
                    continue;
                   }
                   break;
                  }
                  bc(e, 20);
                  break c;
                 }
                 while (1) {
                  if ((g | 0) < (j | 0)) {
                   t[f + g | 0] = w[((l + 16 | 0) + (g << 2) | 0) + 2 | 0];
                   g = g + 1 | 0;
                   j = v[b + 1592 >> 2];
                   continue;
                  }
                  break;
                 }
                 q = b + 1088 | 0;
                 g = 2;
                 while (1) {
                  if ((g | 0) < (j | 0)) {
                   v[l + 12 >> 2] = 0;
                   v[l + 8 >> 2] = 0;
                   j = 0;
                   s = (g | 0) > 0 ? g : 0;
                   i = h + (g << 1) | 0;
                   k = 65536;
                   m = -1;
                   while (1) {
                    if ((j | 0) != (s | 0)) {
                     n = h + (j << 1) | 0;
                     f = x[n >> 1];
                     if (!((m | 0) >= (f | 0) | x[i >> 1] <= f >>> 0)) {
                      v[l + 12 >> 2] = j;
                      f = x[n >> 1];
                      m = f;
                     }
                     if (!((f | 0) >= (k | 0) | x[i >> 1] >= f >>> 0)) {
                      v[l + 8 >> 2] = j;
                      k = x[n >> 1];
                     }
                     j = j + 1 | 0;
                     continue;
                    }
                    break;
                   }
                   f = q + (g << 1) | 0;
                   t[f | 0] = v[l + 12 >> 2];
                   t[f + 1 | 0] = v[l + 8 >> 2];
                   g = g + 1 | 0;
                   j = v[b + 1592 >> 2];
                   continue;
                  }
                  break;
                 }
                 K = (j | 0) > (K | 0) ? j : K;
                 F = F + 1 | 0;
                 continue p;
                }
                g = 0;
                s: {
                 while (1) {
                  if (1 << w[q | 0] <= (g | 0)) {
                   break s;
                  }
                  s = qc(e, 8) - 1 | 0;
                  u[(j + (f << 4) | 0) + (g << 1) >> 1] = s;
                  g = g + 1 | 0;
                  if (v[e + 120 >> 2] > s << 16 >> 16) {
                   continue;
                  }
                  break;
                 }
                 bc(e, 20);
                 break c;
                }
                f = f + 1 | 0;
                continue;
               }
              } else {
               f = qc(e, 4);
               t[g + k | 0] = f;
               f = f & 255;
               j = (f | 0) > (j | 0) ? f : j;
               g = g + 1 | 0;
               f = w[b | 0];
               continue;
              }
             }
            }
            bc(e, 3);
            break c;
           }
           b = qc(e, 6) + 1 | 0;
           v[e + 264 >> 2] = b;
           b = te(e, B(b, 24));
           v[e + 396 >> 2] = b;
           if (!b) {
            bc(e, 3);
            break c;
           }
           m = 0;
           Qb(b, 0, B(v[e + 264 >> 2], 24));
           h = e + 268 | 0;
           t: while (1) {
            if (v[e + 264 >> 2] > (m | 0)) {
             b = v[e + 396 >> 2];
             f = qc(e, 16);
             u[h + (m << 1) >> 1] = f;
             if ((f & 65535) >>> 0 >= 3) {
              bc(e, 20);
              break c;
             }
             i = B(m, 24) + b | 0;
             N = i, O = qc(e, 24), v[N >> 2] = O;
             b = qc(e, 24);
             v[i + 4 >> 2] = b;
             if (b >>> 0 < y[i >> 2]) {
              bc(e, 20);
              break c;
             }
             N = i, O = qc(e, 24) + 1 | 0, v[N + 8 >> 2] = O;
             N = i, O = qc(e, 6) + 1 | 0, t[N + 12 | 0] = O;
             b = qc(e, 8);
             t[i + 13 | 0] = b;
             f = 0;
             if (v[e + 120 >> 2] <= (b & 255)) {
              bc(e, 20);
              break c;
             }
             while (1) {
              b = w[i + 12 | 0];
              if (b >>> 0 > f >>> 0) {
               g = (l + 16 | 0) + f | 0;
               j = qc(e, 3);
               if (qc(e, 1)) {
                b = qc(e, 5);
               } else {
                b = 0;
               }
               t[g | 0] = j + (b << 3);
               f = f + 1 | 0;
               continue;
              }
              break;
             }
             b = te(e, b << 4);
             v[i + 20 >> 2] = b;
             k = 0;
             if (!b) {
              bc(e, 3);
              break c;
             }
             while (1) {
              u: {
               if (w[i + 12 | 0] > k >>> 0) {
                b = w[(l + 16 | 0) + k | 0];
                f = 0;
                while (1) {
                 if ((f | 0) == 8) {
                  break u;
                 }
                 v: {
                  if (b >>> f & 1) {
                   g = qc(e, 8);
                   F = f << 1;
                   j = k << 4;
                   u[F + (j + v[i + 20 >> 2] | 0) >> 1] = g;
                   if (v[e + 120 >> 2] > u[F + (j + v[i + 20 >> 2] | 0) >> 1]) {
                    break v;
                   }
                   bc(e, 20);
                   break c;
                  }
                  u[(v[i + 20 >> 2] + (k << 4) | 0) + (f << 1) >> 1] = 65535;
                 }
                 f = f + 1 | 0;
                 continue;
                }
               }
               f = te(e, v[(v[e + 124 >> 2] + B(w[i + 13 | 0], 2096) | 0) + 4 >> 2] << 2);
               v[i + 16 >> 2] = f;
               if (!f) {
                bc(e, 3);
                break c;
               }
               b = 0;
               Qb(f, 0, v[(v[e + 124 >> 2] + B(w[i + 13 | 0], 2096) | 0) + 4 >> 2] << 2);
               while (1) {
                f = v[e + 124 >> 2] + B(w[i + 13 | 0], 2096) | 0;
                if (v[f + 4 >> 2] > (b | 0)) {
                 f = v[f >> 2];
                 j = te(e, f);
                 g = b << 2;
                 v[g + v[i + 16 >> 2] >> 2] = j;
                 j = b;
                 if (v[g + v[i + 16 >> 2] >> 2]) {
                  while (1) {
                   if ((f | 0) > 0) {
                    f = f - 1 | 0;
                    t[f + v[g + v[i + 16 >> 2] >> 2] | 0] = (j | 0) % w[i + 12 | 0];
                    j = (j | 0) / w[i + 12 | 0] | 0;
                    continue;
                   }
                   break;
                  }
                  b = b + 1 | 0;
                  continue;
                 } else {
                  bc(e, 3);
                  break c;
                 }
                }
                break;
               }
               m = m + 1 | 0;
               continue t;
              }
              k = k + 1 | 0;
              continue;
             }
            }
            break;
           }
           b = qc(e, 6) + 1 | 0;
           v[e + 400 >> 2] = b;
           b = te(e, B(b, 40));
           v[e + 404 >> 2] = b;
           if (!b) {
            bc(e, 3);
            break c;
           }
           Qb(b, 0, B(v[e + 400 >> 2], 40));
           i = 0;
           while (1) {
            if (v[e + 400 >> 2] > (i | 0)) {
             b = v[e + 404 >> 2];
             if (qc(e, 16)) {
              bc(e, 20);
              break c;
             }
             b = B(i, 40) + b | 0;
             f = te(e, B(v[e + 4 >> 2], 3));
             v[b + 4 >> 2] = f;
             if (!f) {
              bc(e, 3);
              break c;
             }
             if (qc(e, 1)) {
              f = qc(e, 4) + 1 | 0;
             } else {
              f = 1;
             }
             t[b + 8 | 0] = f;
             w: {
              if (qc(e, 1)) {
               g = qc(e, 8) + 1 | 0;
               u[b >> 1] = g;
               f = 0;
               j = v[e + 4 >> 2];
               if ((j | 0) < (g & 65535)) {
                bc(e, 20);
                break c;
               }
               while (1) {
                if (x[b >> 1] <= f >>> 0) {
                 break w;
                }
                j = qc(e, Hm(j - 1 | 0));
                g = B(f, 3);
                t[g + v[b + 4 >> 2] | 0] = j;
                j = qc(e, Hm(v[e + 4 >> 2] - 1 | 0));
                t[(g + v[b + 4 >> 2] | 0) + 1 | 0] = j;
                j = v[e + 4 >> 2];
                g = g + v[b + 4 >> 2] | 0;
                h = w[g | 0];
                if ((j | 0) <= (h | 0)) {
                 bc(e, 20);
                 break c;
                }
                g = w[g + 1 | 0];
                if (g >>> 0 >= j >>> 0) {
                 bc(e, 20);
                 break c;
                }
                f = f + 1 | 0;
                if ((g | 0) != (h | 0)) {
                 continue;
                }
                break;
               }
               bc(e, 20);
               break c;
              }
              u[b >> 1] = 0;
             }
             if (qc(e, 2)) {
              bc(e, 20);
              break c;
             }
             f = 0;
             x: {
              if (w[b + 8 | 0] >= 2) {
               while (1) {
                if (v[e + 4 >> 2] <= (f | 0)) {
                 break x;
                }
                g = qc(e, 4);
                j = B(f, 3);
                t[(j + v[b + 4 >> 2] | 0) + 2 | 0] = g;
                f = f + 1 | 0;
                if (w[(j + v[b + 4 >> 2] | 0) + 2 | 0] < w[b + 8 | 0]) {
                 continue;
                }
                break;
               }
               bc(e, 20);
               break c;
              }
              while (1) {
               if (v[e + 4 >> 2] <= (f | 0)) {
                break x;
               }
               t[(v[b + 4 >> 2] + B(f, 3) | 0) + 2 | 0] = 0;
               f = f + 1 | 0;
               continue;
              }
             }
             g = b + 24 | 0;
             j = b + 9 | 0;
             f = 0;
             y: {
              while (1) {
               if (w[b + 8 | 0] <= f >>> 0) {
                break y;
               }
               qc(e, 8);
               h = f + j | 0;
               N = h, O = qc(e, 8), t[N | 0] = O;
               k = qc(e, 8);
               t[f + g | 0] = k;
               if (v[e + 128 >> 2] <= w[h | 0]) {
                bc(e, 20);
                break c;
               }
               f = f + 1 | 0;
               if (v[e + 264 >> 2] > (k & 255)) {
                continue;
               }
               break;
              }
              bc(e, 20);
              break c;
             }
             i = i + 1 | 0;
             continue;
            }
            break;
           }
           N = e, O = qc(e, 6) + 1 | 0, v[N + 408 >> 2] = O;
           f = e + 412 | 0;
           g = 0;
           z: {
            while (1) {
             if (v[e + 408 >> 2] <= (g | 0)) {
              break z;
             }
             b = f + B(g, 6) | 0;
             N = b, O = qc(e, 1), t[N | 0] = O;
             N = b, O = qc(e, 16), u[N + 2 >> 1] = O;
             N = b, O = qc(e, 16), u[N + 4 >> 1] = O;
             i = qc(e, 8);
             t[b + 1 | 0] = i;
             if (x[b + 2 >> 1]) {
              bc(e, 20);
              break c;
             }
             if (x[b + 4 >> 1]) {
              bc(e, 20);
              break c;
             }
             g = g + 1 | 0;
             if (v[e + 400 >> 2] > (i & 255)) {
              continue;
             }
             break;
            }
            bc(e, 20);
            break c;
           }
           LL(e);
           v[e + 992 >> 2] = 0;
           i = e + 996 | 0;
           g = K << 1;
           j = e + 928 | 0;
           h = e + 800 | 0;
           f = 0;
           while (1) {
            if (v[e + 4 >> 2] > (f | 0)) {
             b = f << 2;
             k = b + h | 0;
             N = k, O = te(e, v[e + 116 >> 2] << 2), v[N >> 2] = O;
             m = b + j | 0;
             N = m, O = te(e, v[e + 116 >> 2] << 1 & 2147483646), v[N >> 2] = O;
             n = b + i | 0;
             b = te(e, g);
             v[n >> 2] = b;
             k = v[k >> 2];
             if (b ? !k | !v[m >> 2] : 1) {
              bc(e, 3);
              break c;
             }
             Qb(k, 0, v[e + 116 >> 2] << 2);
             f = f + 1 | 0;
             continue;
            }
            break;
           }
           f = 0;
           if (!EL(e, 0, v[e + 112 >> 2])) {
            break a;
           }
           if (!EL(e, 1, v[e + 116 >> 2])) {
            break a;
           }
           v[e + 104 >> 2] = v[e + 112 >> 2];
           i = v[e + 116 >> 2];
           v[e + 108 >> 2] = i;
           b = v[e + 264 >> 2];
           h = (b | 0) > 0 ? b : 0;
           b = (i | 0) / 2 | 0;
           j = 0;
           while (1) {
            if ((f | 0) != (h | 0)) {
             g = v[e + 396 >> 2] + B(f, 24) | 0;
             k = v[g + 4 >> 2];
             m = b >>> 0 > k >>> 0 ? k : b;
             k = v[g >> 2];
             g = (m - (b >>> 0 > k >>> 0 ? k : b) >>> 0) / y[g + 8 >> 2] | 0;
             j = (g | 0) > (j | 0) ? g : j;
             f = f + 1 | 0;
             continue;
            }
            break;
           }
           b = i << 1 & 2147483646;
           f = B(v[e + 4 >> 2], (j << 2) + 4 | 0);
           b = b >>> 0 > f >>> 0 ? b : f;
           v[e + 12 >> 2] = b;
           A: {
            B: {
             if (!v[e + 80 >> 2]) {
              break B;
             }
             f = v[e + 92 >> 2];
             if ((f | 0) != v[e + 84 >> 2]) {
              break A;
             }
             if (f >>> 0 >= (b + v[e + 88 >> 2] | 0) + 1512 >>> 0) {
              break B;
             }
             bc(e, 3);
             break c;
            }
            if (v[e + 1380 >> 2] == -1) {
             v[e + 52 >> 2] = w[e + 48 | 0] ? 0 : v[e + 32 >> 2] - v[e + 36 >> 2] | 0;
             f = 1;
             break a;
            }
            v[e + 52 >> 2] = 0;
            f = 1;
            break a;
           }
           Z(7344, 13258, 4196, 8829);
           p();
          }
          b = qc(e, 5);
          g = 0;
          while (1) {
           f = v[h + 4 >> 2];
           if ((f | 0) <= (g | 0)) {
            break i;
           }
           k = qc(e, Hm(f - g | 0));
           b = b + 1 | 0;
           if ((b | 0) >= 32) {
            bc(e, 20);
            break c;
           }
           f = g + k | 0;
           if ((f | 0) > v[h + 4 >> 2]) {
            bc(e, 20);
            break c;
           } else {
            Qb(g + j | 0, b, k);
            g = f;
            continue;
           }
          }
         }
         C: {
          D: {
           E: {
            F: {
             G: {
              H: {
               if (w[h + 23 | 0]) {
                if (f >> 2 > (i | 0)) {
                 break H;
                }
                if (v[e + 16 >> 2] < (f | 0)) {
                 v[e + 16 >> 2] = f;
                 f = v[h + 4 >> 2];
                }
                b = te(e, f);
                v[h + 8 >> 2] = b;
                if (!b) {
                 bc(e, 3);
                 break c;
                }
                yc(b, j, v[h + 4 >> 2]);
                pj(e, j, v[h + 4 >> 2]);
                t[h + 23 | 0] = 0;
                j = v[h + 8 >> 2];
                f = v[h + 4 >> 2];
               }
               b = 0;
               i = (f | 0) > 0 ? f : 0;
               g = 0;
               while (1) {
                if ((g | 0) == (i | 0)) {
                 break G;
                }
                b = ((w[g + j | 0] - 11 & 255) >>> 0 < 244) + b | 0;
                g = g + 1 | 0;
                continue;
               }
              }
              v[h + 2092 >> 2] = i;
              b = h + 2092 | 0;
              if (i) {
               break F;
              }
              g = 0;
              i = 0;
              break E;
             }
             v[h + 2092 >> 2] = b;
             b = te(e, f << 2);
             v[h + 32 >> 2] = b;
             if (b) {
              b = h + 2092 | 0;
              g = 0;
              break D;
             }
             bc(e, 3);
             break c;
            }
            f = te(e, i);
            v[h + 8 >> 2] = f;
            if (!f) {
             bc(e, 3);
             break c;
            }
            f = no(e, v[h + 2092 >> 2] << 2);
            v[h + 32 >> 2] = f;
            if (!f) {
             bc(e, 3);
             break c;
            }
            g = no(e, v[b >> 2] << 2);
            if (!g) {
             break C;
            }
            f = v[h + 4 >> 2];
            i = v[h + 2092 >> 2];
           }
           f = (i << 3) + f | 0;
           if (f >>> 0 <= y[e + 16 >> 2]) {
            break D;
           }
           v[e + 16 >> 2] = f;
          }
          n = v[h + 4 >> 2];
          f = 0;
          i = eb - 128 | 0;
          eb = i;
          o = Qb(i, 0, 128);
          i = (n | 0) > 0 ? n : 0;
          while (1) {
           I: {
            J: {
             if ((f | 0) != (i | 0)) {
              if (w[f + j | 0] == 255) {
               break J;
              }
              i = f;
             }
             if ((i | 0) == (n | 0)) {
              f = 1;
              if (!v[h + 2092 >> 2]) {
               break I;
              }
              Z(15760, 13258, 1103, 7588);
              p();
             }
             f = i + j | 0;
             k = w[f | 0];
             if (k >>> 0 < 32) {
              CL(h, 0, i, 0, k, g);
              q = 1;
              k = w[f | 0] + 1 | 0;
              f = 1;
              K: {
               while (1) {
                if ((f | 0) == (k | 0)) {
                 L: while (1) {
                  M: {
                   f = 1;
                   i = i + 1 | 0;
                   if ((n | 0) <= (i | 0)) {
                    break I;
                   }
                   G = i + j | 0;
                   k = w[G | 0];
                   if ((k | 0) == 255) {
                    continue;
                   }
                   f = k;
                   if (f >>> 0 >= 32) {
                    break M;
                   }
                   while (1) {
                    if ((f | 0) <= 0) {
                     f = 0;
                     break I;
                    }
                    I = o + (f << 2) | 0;
                    s = v[I >> 2];
                    if (!s) {
                     f = f - 1 | 0;
                     continue;
                    }
                    break;
                   }
                   v[I >> 2] = 0;
                   CL(h, Fm(s), i, q, k, g);
                   q = q + 1 | 0;
                   k = w[G | 0];
                   if ((k | 0) == (f | 0)) {
                    continue;
                   }
                   while (1) {
                    if ((f | 0) >= (k | 0)) {
                     continue L;
                    }
                    G = o + (k << 2) | 0;
                    if (v[G >> 2]) {
                     break K;
                    }
                    v[G >> 2] = s + (1 << 32 - k);
                    k = k - 1 | 0;
                    continue;
                   }
                  }
                  break;
                 }
                } else {
                 v[o + (f << 2) >> 2] = 1 << 32 - f;
                 f = f + 1 | 0;
                 continue;
                }
                break;
               }
               Z(15225, 13258, 1118, 7588);
               p();
              }
              Z(15804, 13258, 1133, 7588);
              p();
             }
             Z(15232, 13258, 1104, 7588);
             p();
            }
            f = f + 1 | 0;
            continue;
           }
           break;
          }
          eb = o + 128 | 0;
          if (!f) {
           if (w[h + 23 | 0]) {
            pj(e, g, 0);
           }
           bc(e, 20);
           break c;
          }
          f = v[b >> 2];
          if (f) {
           f = te(e, (f << 2) + 4 | 0);
           v[h + 2084 >> 2] = f;
           if (!f) {
            bc(e, 3);
            break c;
           }
           f = te(e, (v[h + 2092 >> 2] << 2) + 4 | 0);
           v[h + 2088 >> 2] = f;
           if (!f) {
            bc(e, 3);
            break c;
           }
           v[h + 2088 >> 2] = f + 4;
           v[f >> 2] = -1;
           f = 0;
           k = 0;
           N: {
            O: {
             P: {
              if (w[h + 23 | 0]) {
               while (1) {
                k = v[h + 2092 >> 2];
                if ((k | 0) <= (f | 0)) {
                 break P;
                }
                i = f << 2;
                N = i + v[h + 2084 >> 2] | 0, O = Fm(v[i + v[h + 32 >> 2] >> 2]), v[N >> 2] = O;
                f = f + 1 | 0;
                continue;
               }
              }
              while (1) {
               if (v[h + 4 >> 2] > (f | 0)) {
                if (BL(w[h + 23 | 0], w[f + j | 0])) {
                 N = v[h + 2084 >> 2] + (k << 2) | 0, O = Fm(v[v[h + 32 >> 2] + (f << 2) >> 2]), 
                 v[N >> 2] = O;
                 k = k + 1 | 0;
                }
                f = f + 1 | 0;
                continue;
               }
               break;
              }
              if (v[h + 2092 >> 2] != (k | 0)) {
               break O;
              }
             }
             FL(v[h + 2084 >> 2], k, 1216);
             v[v[h + 2084 >> 2] + (v[h + 2092 >> 2] << 2) >> 2] = -1;
             i = 0;
             f = v[h + (w[h + 23 | 0] ? 2092 : 4) >> 2];
             s = (f | 0) > 0 ? f : 0;
             Q: {
              while (1) {
               if ((i | 0) != (s | 0)) {
                f = i;
                k = w[h + 23 | 0];
                f = k ? v[(f << 2) + g >> 2] : f;
                G = w[f + j | 0];
                R: {
                 if (!BL(k, G)) {
                  break R;
                 }
                 I = i << 2;
                 n = Fm(v[I + v[h + 32 >> 2] >> 2]);
                 f = v[h + 2092 >> 2];
                 k = 0;
                 while (1) {
                  if ((f | 0) >= 2) {
                   o = f >>> 1 | 0;
                   L = o + k | 0;
                   q = n >>> 0 < y[v[h + 2084 >> 2] + (L << 2) >> 2];
                   f = q ? o : f - o | 0;
                   k = q ? k : L;
                   continue;
                  }
                  break;
                 }
                 f = k << 2;
                 if ((n | 0) != v[f + v[h + 2084 >> 2] >> 2]) {
                  break Q;
                 }
                 if (w[h + 23 | 0]) {
                  v[f + v[h + 2088 >> 2] >> 2] = v[g + I >> 2];
                  t[v[h + 8 >> 2] + k | 0] = G;
                  break R;
                 }
                 v[f + v[h + 2088 >> 2] >> 2] = i;
                }
                i = i + 1 | 0;
                continue;
               }
               break;
              }
              break N;
             }
             Z(12299, 13258, 1230, 9982);
             p();
            }
            Z(7529, 13258, 1200, 9982);
            p();
           }
          }
          if (w[h + 23 | 0]) {
           pj(e, g, v[h + 2092 >> 2] << 2);
           pj(e, v[h + 32 >> 2], v[h + 2092 >> 2] << 2);
           pj(e, j, v[h + 4 >> 2]);
           v[h + 32 >> 2] = 0;
          }
          g = 0;
          j = 0;
          f = h + 36 | 0;
          while (1) {
           if ((g | 0) != 1024) {
            u[f + (g << 1) >> 1] = 65535;
            g = g + 1 | 0;
            continue;
           }
           break;
          }
          i = v[h + (w[h + 23 | 0] ? 2092 : 4) >> 2];
          i = (i | 0) >= 32767 ? 32767 : i;
          i = (i | 0) > 0 ? i : 0;
          while (1) {
           if ((i | 0) != (j | 0)) {
            S: {
             if (w[v[h + 8 >> 2] + j | 0] > 10) {
              break S;
             }
             T: {
              if (w[h + 23 | 0]) {
               g = Fm(v[v[h + 2084 >> 2] + (j << 2) >> 2]);
               break T;
              }
              g = v[v[h + 32 >> 2] + (j << 2) >> 2];
             }
             while (1) {
              if (g >>> 0 > 1023) {
               break S;
              }
              u[f + (g << 1) >> 1] = j;
              g = (1 << w[v[h + 8 >> 2] + j | 0]) + g | 0;
              continue;
             }
            }
            j = j + 1 | 0;
            continue;
           }
           break;
          }
          f = qc(e, 4);
          t[h + 21 | 0] = f;
          f = f & 255;
          if (f >>> 0 >= 3) {
           bc(e, 20);
           break c;
          }
          if (f) {
           N = h, P = DL(qc(e, 32)), z[N + 12 >> 2] = P;
           N = h, P = DL(qc(e, 32)), z[N + 16 >> 2] = P;
           N = h, O = qc(e, 4) + 1 | 0, t[N + 20 | 0] = O;
           N = h, O = qc(e, 1), t[N + 22 | 0] = O;
           g = v[h >> 2];
           i = v[h + 4 >> 2];
           U: {
            if (w[h + 21 | 0] == 1) {
             E = H(Qt(+C(C(mq(+C(i | 0))) / C(g | 0))));
             V: {
              if (D(E) < 2147483648) {
               f = ~~E;
               break V;
              }
              f = -2147483648;
             }
             E = +(g | 0);
             M = H(lk(+C(C(f | 0) + C(1)), E));
             W: {
              if (D(M) < 2147483648) {
               g = ~~M;
               break W;
              }
              g = -2147483648;
             }
             f = ((g | 0) <= (i | 0)) + f | 0;
             A = C(f | 0);
             if (lk(+C(A + C(1)), E) <= +(i | 0)) {
              j = -1;
             } else {
              E = H(lk(+A, E));
              X: {
               if (D(E) < 2147483648) {
                g = ~~E;
                break X;
               }
               g = -2147483648;
              }
              j = (g | 0) > (i | 0) ? -1 : f;
             }
             if ((j | 0) >= 0) {
              break U;
             }
             bc(e, 20);
             break c;
            }
            j = B(g, i);
           }
           v[h + 24 >> 2] = j;
           if (!j) {
            bc(e, 20);
            break c;
           }
           g = 0;
           f = no(e, j << 1);
           if (!f) {
            bc(e, 3);
            break c;
           }
           Y: {
            while (1) {
             j = v[h + 24 >> 2];
             if ((j | 0) <= (g | 0)) {
              break Y;
             }
             i = qc(e, w[h + 20 | 0]);
             if ((i | 0) != -1) {
              u[f + (g << 1) >> 1] = i;
              g = g + 1 | 0;
              continue;
             }
             break;
            }
            pj(e, f, v[h + 24 >> 2] << 1);
            bc(e, 20);
            break c;
           }
           Z: {
            _: {
             if (w[h + 21 | 0] == 1) {
              o = w[h + 23 | 0];
              $: {
               if (o) {
                g = v[b >> 2];
                if (g) {
                 break $;
                }
                break Z;
               }
               g = v[h + 4 >> 2];
              }
              b = te(e, B(v[h >> 2], g) << 2);
              v[h + 28 >> 2] = b;
              if (!b) {
               pj(e, f, v[h + 24 >> 2] << 1);
               bc(e, 3);
               break c;
              }
              b = 0;
              i = v[h + (o ? 2092 : 4) >> 2];
              q = (i | 0) > 0 ? i : 0;
              A = C(0);
              while (1) {
               if ((b | 0) == (q | 0)) {
                break _;
               }
               i = o ? v[v[h + 2088 >> 2] + (b << 2) >> 2] : b;
               j = v[h >> 2];
               g = 0;
               k = 1;
               while (1) {
                if ((g | 0) < (j | 0)) {
                 J = C(A + C(C(C(x[f + (((i >>> 0) / (k >>> 0) >>> 0) % y[h + 24 >> 2] << 1) >> 1]) * z[h + 16 >> 2]) + z[h + 12 >> 2]));
                 z[(v[h + 28 >> 2] + (B(b, j) << 2) | 0) + (g << 2) >> 2] = J;
                 A = w[h + 22 | 0] ? J : A;
                 g = g + 1 | 0;
                 j = v[h >> 2];
                 if ((g | 0) >= (j | 0)) {
                  continue;
                 }
                 n = v[h + 24 >> 2];
                 Aua(n, 0, k, 0);
                 if (gb) {
                  pj(e, f, n << 1);
                  bc(e, 20);
                  break c;
                 } else {
                  k = B(k, n);
                  continue;
                 }
                }
                break;
               }
               b = b + 1 | 0;
               continue;
              }
             }
             b = te(e, j << 2);
             v[h + 28 >> 2] = b;
             if (!b) {
              break h;
             }
             g = 0;
             A = C(0);
             while (1) {
              j = v[h + 24 >> 2];
              if ((j | 0) <= (g | 0)) {
               break Z;
              }
              J = C(A + C(C(C(x[f + (g << 1) >> 1]) * z[h + 16 >> 2]) + z[h + 12 >> 2]));
              z[v[h + 28 >> 2] + (g << 2) >> 2] = J;
              A = w[h + 22 | 0] ? J : A;
              g = g + 1 | 0;
              continue;
             }
            }
            t[h + 21 | 0] = 2;
            j = v[h + 24 >> 2];
           }
           pj(e, f, j << 1);
          }
          m = m + 1 | 0;
          continue;
         }
         break;
        }
        bc(e, 3);
        break c;
       }
       pj(e, f, v[h + 24 >> 2] << 1);
       bc(e, 3);
       break c;
      }
      bc(e, 20);
      break c;
     }
     bc(e, 3);
     break c;
    }
    t[i + v[g + v[e + 28 >> 2] >> 2] | 0] = 0;
    b = b + 1 | 0;
    continue;
   }
  }
  f = 0;
 }
 eb = l + 1024 | 0;
 aa: {
  ba: {
   if (!f) {
    v[d >> 2] = v[r + 104 >> 2] ? 1 : v[r + 108 >> 2];
    iz(e);
    break ba;
   }
   f = r + 8 | 0;
   b = te(f, 1512);
   if (b) {
    N = c, O = v[yc(b, f, 1512) + 32 >> 2] - a | 0, v[N >> 2] = O;
    v[d >> 2] = 0;
    break aa;
   }
   iz(r + 8 | 0);
  }
  b = 0;
 }
 eb = r + 1520 | 0;
 return b;
}

function Gna(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, q = 0, r = 0, s = 0, z = 0, A = 0, C = 0, D = 0, E = 0, F = 0, G = 0, H = 0, I = 0, J = 0, K = 0, L = 0;
 d = eb - 576 | 0;
 eb = d;
 xc(b);
 a: {
  b: {
   c: {
    d: {
     e: {
      f: {
       g: {
        h: {
         i: {
          j: {
           k: {
            g = d + 496 | 0;
            l: {
             if (!DD(b, g)) {
              break l;
             }
             if (!wV(g)) {
              break l;
             }
             if (!Lb(v[b >> 2], v[b + 8 >> 2], Ac(vV(g), gb))) {
              break l;
             }
             e = 1;
             if ((c | 0) == 64) {
              break l;
             }
             Cd(a, 4);
             dg(a);
             t[a + 1074368 | 0] = 4;
             l = Eb(d + 484 | 0);
             k = d + 534 | 0;
             m: {
              if (!(id(k, 18399, 20) | (w[d + 556 | 0] | w[d + 557 | 0] << 8 | (w[d + 558 | 0] << 16 | w[d + 559 | 0] << 24)) != 276)) {
               r = 41048;
               e = 48;
               if ((w[d + 554 | 0] | w[d + 555 | 0] << 8) >>> 0 < 260) {
                break m;
               }
               e = rq(d + 513 | 0, 0, 20) ? 1154 : 34;
               break m;
              }
              r = 41048;
              if (!id(k, 18378, 20)) {
               break m;
              }
              e = d + 104 | 0;
              oi(e, 3, k);
              v[31601] = 0;
              g = d + 192 | 0;
              R(369, g | 0, 4, e | 0);
              e = v[31601];
              v[31601] = 0;
              n: {
               if ((e | 0) != 1) {
                yb(l, g);
                sb(g);
                if ((w[k | 0] | w[k + 1 | 0] << 8 | (w[k + 2 | 0] << 16 | w[k + 3 | 0] << 24)) != 1852141647 | (w[k + 4 | 0] | w[k + 5 | 0] << 8 | (w[k + 6 | 0] << 16 | w[k + 7 | 0] << 24)) != 542396493) {
                 break n;
                }
                e = 1048;
                break m;
               }
               b = M() | 0;
               break a;
              }
              if (!id(k, 18126, 12)) {
               e = 16;
               if ((w[d + 546 | 0] | w[d + 547 | 0] << 8 | (w[d + 548 | 0] << 16 | w[d + 549 | 0] << 24)) == 538976288 & (w[d + 550 | 0] | w[d + 551 | 0] << 8 | (w[d + 552 | 0] << 16 | w[d + 553 | 0] << 24)) == 538976288) {
                break m;
               }
               t[a + 1074368 | 0] = 5;
               break m;
              }
              if (!id(k, 11657, 20)) {
               e = 48;
               break m;
              }
              if (!id(k, 25424, 15)) {
               v[31601] = 0;
               g = O(267, a + 1074312 | 0, 54) | 0;
               e = v[31601];
               v[31601] = 0;
               if ((e | 0) == 1) {
                break b;
               }
               v[31601] = 0;
               O(267, g | 0, 51) | 0;
               g = v[31601];
               v[31601] = 0;
               if ((g | 0) == 1) {
                break b;
               }
               r = 41040;
               e = 16;
               break m;
              }
              o: {
               if (id(k, 25440, 14)) {
                if (id(k, 25455, 14)) {
                 break o;
                }
               }
               v[31601] = 0;
               g = O(267, a + 1074312 | 0, 57) | 0;
               e = v[31601];
               v[31601] = 0;
               if ((e | 0) == 1) {
                break b;
               }
               v[31601] = 0;
               O(267, g | 0, 51) | 0;
               g = v[31601];
               v[31601] = 0;
               e = 16;
               if ((g | 0) != 1) {
                break m;
               }
               break b;
              }
              e = id(k, 18214, 11) ? 16 : 256;
             }
             f = d + 104 | 0;
             C = d + 513 | 0;
             oi(f, 3, C);
             v[31601] = 0;
             g = d + 192 | 0;
             N(218, g | 0, f | 0);
             n = v[31601];
             v[31601] = 0;
             p: {
              q: {
               r: {
                s: {
                 t: {
                  if ((n | 0) != 1) {
                   yb(a + 1298308 | 0, g);
                   sb(g);
                   v[a + 480260 >> 2] = 1;
                   v[a + 480264 >> 2] = 31999;
                   $e(Wb(v[a + 484360 >> 2], w[a + 484376 | 0]), w[d + 562 | 0] | w[d + 563 | 0] << 8);
                   u[a + 480188 >> 1] = w[d + 564 | 0] | w[d + 565 | 0] << 8;
                   u[d + 192 >> 1] = w[d + 568 | 0] | w[d + 569 | 0] << 8;
                   u[d + 104 >> 1] = 255;
                   K = a, L = x[Nc(g, f) >> 1], u[K + 480192 >> 1] = L;
                   g = w[d + 572 | 0] | w[d + 573 | 0] << 8;
                   if (g) {
                    v[a + 480196 >> 2] = g;
                   }
                   g = w[d + 574 | 0] | w[d + 575 | 0] << 8;
                   if (g) {
                    g = B(g, 1e4);
                    g = g >>> 0 >= 1e7 ? 1e7 : g;
                    v[a + 480204 >> 2] = g >>> 0 <= 32e4 ? 32e4 : g;
                   }
                   g = w[d + 570 | 0] | w[d + 571 | 0] << 8;
                   v[a + 480208 >> 2] = g << 4 & 16 | g << 3 & 32768;
                   f = v[a + 484360 >> 2];
                   n = w[a + 484376 | 0];
                   v[31601] = 0;
                   $(348, Wb(f, n) | 0, b | 0, w[d + 560 | 0] | w[d + 561 | 0] << 8, 65535, 65535);
                   f = v[31601];
                   v[31601] = 0;
                   if ((f | 0) == 1) {
                    break b;
                   }
                   f = g >>> 12 & 1 ? (e | 0) == 34 ? 146 : e : e;
                   if (!(w[d + 560 | 0] | w[d + 561 | 0] << 8 | f >>> 0 > 1023)) {
                    g = w[a + 484376 | 0];
                    e = v[a + 484360 >> 2];
                    v[31601] = 0;
                    V(761, Wb(e, g) | 0);
                    g = v[31601];
                    v[31601] = 0;
                    if ((g | 0) == 1) {
                     break b;
                    }
                   }
                   v[31601] = 0;
                   O(149, b | 0, (w[d + 556 | 0] | w[d + 557 | 0] << 8 | (w[d + 558 | 0] << 16 | w[d + 559 | 0] << 24)) + 60 | 0) | 0;
                   g = v[31601];
                   v[31601] = 0;
                   if ((g | 0) == 1) {
                    break b;
                   }
                   if ((w[d + 554 | 0] | w[d + 555 | 0] << 8) >>> 0 >= 260) {
                    v[31601] = 0;
                    R(762, b | 0, d + 496 | 0, a | 0);
                    g = v[31601];
                    v[31601] = 0;
                    if ((g | 0) == 1) {
                     break b;
                    }
                   }
                   t[d + 483 | 0] = 0;
                   D = c & 2;
                   G = a + 946304 | 0;
                   s = a + 484380 | 0;
                   H = a + 900380 | 0;
                   I = d + 122 | 0;
                   o = d + 225 | 0;
                   n = Mb(d + 468 | 0);
                   z = 1;
                   g = -1;
                   while (1) {
                    e = z & 65535;
                    if (e >>> 0 > x[a + 480192 >> 1]) {
                     if (!(!(f & 2) | A & 255)) {
                      f = rq(C, 0, 20) ? f | 16 : f;
                     }
                     if ((w[d + 554 | 0] | w[d + 555 | 0] << 8) >>> 0 > 259) {
                      break r;
                     }
                     if (c & 3) {
                      v[31601] = 0;
                      R(762, b | 0, d + 496 | 0, a | 0);
                      c = v[31601];
                      v[31601] = 0;
                      if ((c | 0) == 1) {
                       break q;
                      }
                     }
                     if (!D) {
                      break r;
                     }
                     e = 1;
                     while (1) {
                      c = e & 65535;
                      if (c >>> 0 > x[a + 480190 >> 1]) {
                       break r;
                      }
                      o = v[n >> 2];
                      v[31601] = 0;
                      T(215, xb(o, c - 1 | 0) | 0, B(c, 104) + s | 0, b | 0) | 0;
                      c = v[31601];
                      v[31601] = 0;
                      if ((c | 0) != 1) {
                       e = e + 1 | 0;
                       continue;
                      }
                      break;
                     }
                     b = M() | 0;
                     break c;
                    }
                    v[31601] = 0;
                    j = Q(151, b | 0) | 0;
                    i = v[31601];
                    v[31601] = 0;
                    u: {
                     v: {
                      if ((i | 0) != 1) {
                       Hh(b, 4);
                       v[31601] = 0;
                       R(763, b | 0, d + 192 | 0, (j ? j : 263) | 0);
                       j = v[31601];
                       v[31601] = 0;
                       if ((j | 0) == 1) {
                        break s;
                       }
                       w: {
                        if ((f | 0) == 1) {
                         j = v[d + 192 >> 2];
                         if ((j | 0) != 263) {
                          f = 16;
                          if ((j | 0) != 245) {
                           break w;
                          }
                          v[a + 1074308 >> 2] = 16777381;
                          v[31601] = 0;
                          f = O(1, d + 180 | 0, 13445) | 0;
                          j = v[31601];
                          v[31601] = 0;
                          if ((j | 0) != 1) {
                           yb(l, f);
                           sb(f);
                           f = 17;
                           break w;
                          }
                          b = M() | 0;
                          break c;
                         }
                         v[a + 1074308 >> 2] = 16777395;
                         v[31601] = 0;
                         f = O(1, d + 168 | 0, 13336) | 0;
                         j = v[31601];
                         v[31601] = 0;
                         if ((j | 0) != 1) {
                          yb(l, f);
                          sb(f);
                          f = 17;
                          break w;
                         }
                         b = M() | 0;
                         break c;
                        }
                        if (w[d + 219 | 0] | w[d + 220 | 0] << 8) {
                         break w;
                        }
                        j = v[d + 192 >> 2];
                        if (!(!(f & 2) | (w[d + 221 | 0] | w[d + 222 | 0] << 8 | (w[d + 223 | 0] << 16 | w[d + 224 | 0] << 24)) | (j | 0) != 263)) {
                         f = f | 16;
                         break w;
                        }
                        if (!(!(f & 256) | (j | 0) == 29)) {
                         f = f & -257;
                         break w;
                        }
                        if (!(f & 160)) {
                         break w;
                        }
                        f = (j | 0) == 33 ? f : 0;
                       }
                       v[31601] = 0;
                       j = T(251, a | 0, e | 0, 0) | 0;
                       i = v[31601];
                       v[31601] = 0;
                       if ((i | 0) == 1) {
                        break s;
                       }
                       if (!j) {
                        break u;
                       }
                       j = (e << 2) + H | 0;
                       e = v[j >> 2];
                       v[31601] = 0;
                       N(764, d + 192 | 0, e | 0);
                       e = v[31601];
                       v[31601] = 0;
                       if ((e | 0) == 1) {
                        break s;
                       }
                       e = w[d + 218 | 0];
                       x: {
                        if ((g | 0) == -1) {
                         g = e;
                         break x;
                        }
                        if (!(f & 32) | (e | 0) == (g | 0)) {
                         break x;
                        }
                        f = f & -161 | 128;
                       }
                       e = w[d + 219 | 0] | w[d + 220 | 0] << 8;
                       if (!e) {
                        break u;
                       }
                       v[31601] = 0;
                       i = w[d + 439 | 0];
                       h = w[d + 435 | 0] | w[d + 436 | 0] << 8;
                       m = w[d + 434 | 0];
                       q = w[d + 433 | 0];
                       R(765, d + 156 | 0, a | 0, e | 0);
                       e = v[31601];
                       v[31601] = 0;
                       if ((e | 0) == 1) {
                        break t;
                       }
                       f = i | (h | (m | q)) ? f & -4 : f;
                       j = v[j >> 2] + 236 | 0;
                       e = 12;
                       i = v[d + 156 >> 2];
                       h = _c(i, v[d + 160 >> 2]);
                       y: {
                        while (1) {
                         z: {
                          if ((e | 0) == 108) {
                           if ((w[d + 554 | 0] | w[d + 555 | 0] << 8) >>> 0 > 259) {
                            Mc(n);
                           }
                           e = 0;
                           v[31601] = 0;
                           j = O(766, d + 144 | 0, w[d + 219 | 0] | w[d + 220 | 0] << 8) | 0;
                           i = v[31601];
                           v[31601] = 0;
                           if ((i | 0) != 1) {
                            break z;
                           }
                           b = M() | 0;
                           break y;
                          }
                          m = $b(j, e);
                          if (h >>> 0 > x[m >> 1]) {
                           K = m, L = x[$b(i, x[$b(j, e) >> 1]) >> 1], u[K >> 1] = L;
                          }
                          e = e + 1 | 0;
                          continue;
                         }
                         break;
                        }
                        A: {
                         B: {
                          C: {
                           D: {
                            while (1) {
                             i = w[d + 219 | 0] | w[d + 220 | 0] << 8;
                             if (e >>> 0 >= i >>> 0) {
                              e = 0;
                              if ((w[d + 554 | 0] | w[d + 555 | 0] << 8) >>> 0 <= 259) {
                               break v;
                              }
                              E: {
                               while (1) {
                                if (e >>> 0 >= i >>> 0) {
                                 break v;
                                }
                                m = w[xb(v[n >> 2], e) + 3 | 0];
                                i = v[xb(v[j >> 2], e) >> 2];
                                v[31601] = 0;
                                h = d + 72 | 0;
                                R(185, h | 0, b | 0, ((m | 0) == 10 ? (i + 1 >>> 1 | 0) + 16 | 0 : i) | 0);
                                i = v[31601];
                                v[31601] = 0;
                                if ((i | 0) != 1) {
                                 i = gc(d + 104 | 0, h);
                                 tb(h);
                                 h = v[d + 156 >> 2];
                                 if (!(!D | _c(h, v[d + 160 >> 2]) >>> 0 <= e >>> 0)) {
                                  m = x[$b(h, e) >> 1];
                                  h = xb(v[n >> 2], e);
                                  h = w[h | 0] | w[h + 1 | 0] << 8 | (w[h + 2 | 0] << 16 | w[h + 3 | 0] << 24);
                                  v[31601] = 0;
                                  v[d + 68 >> 2] = h;
                                  v[d + 8 >> 2] = h;
                                  h = aa(767, B(m, 104) + s | 0, d + 8 | 0, i | 0, d + 483 | 0) | 0;
                                  m = v[31601];
                                  v[31601] = 0;
                                  if ((m | 0) == 1) {
                                   break E;
                                  }
                                  E = h ^ 1 | E;
                                 }
                                 tb(i);
                                 e = e + 1 | 0;
                                 i = w[d + 219 | 0] | w[d + 220 | 0] << 8;
                                 continue;
                                }
                                break;
                               }
                               b = M() | 0;
                               break A;
                              }
                              b = M() | 0;
                              tb(i);
                              break A;
                             }
                             v[31601] = 0;
                             q = d + 104 | 0;
                             N(768, b | 0, q | 0);
                             i = v[31601];
                             v[31601] = 0;
                             if ((i | 0) == 1) {
                              break B;
                             }
                             i = d + 72 | 0;
                             h = w[d + 118 | 0];
                             F: {
                              if (!(h & 48 | w[d + 121 | 0] != 173)) {
                               Yc(i, 8, 1, 0, 10);
                               break F;
                              }
                              Yc(i, h & 16 ? 16 : 8, h & 32 ? 3 : 1, 0, 2);
                             }
                             v[31601] = 0;
                             N(769, n | 0, i | 0);
                             h = v[31601];
                             v[31601] = 0;
                             if ((h | 0) != 1) {
                              K = xb(v[j >> 2], e), L = v[d + 104 >> 2], v[K >> 2] = L;
                              J = w[d + 121 | 0];
                              h = v[d + 156 >> 2];
                              if (_c(h, v[d + 160 >> 2]) >>> 0 > e >>> 0) {
                               m = x[$b(h, e) >> 1];
                               v[31601] = 0;
                               h = B(m, 104) + s | 0;
                               N(770, q | 0, h | 0);
                               q = v[31601];
                               v[31601] = 0;
                               if ((q | 0) == 1) {
                                break D;
                               }
                               t[h + 38 | 0] = w[o + 202 | 0];
                               t[h + 39 | 0] = w[o + 203 | 0];
                               t[h + 40 | 0] = w[o + 204 | 0];
                               t[h + 41 | 0] = w[o + 205 | 0];
                               h = d + 92 | 0;
                               Pk(h, 3, I);
                               v[31601] = 0;
                               N(218, i | 0, h | 0);
                               h = v[31601];
                               v[31601] = 0;
                               if ((h | 0) == 1) {
                                break C;
                               }
                               zc((m << 5) + G | 0, i);
                               sb(i);
                               f = (w[d + 118 | 0] & 3) != 3 ? f : f & 2 ? f | 4 : f;
                              }
                              A = A | J;
                              e = e + 1 | 0;
                              F = w[wf(v[n + 4 >> 2]) + 3 | 0] == 10 | F;
                              continue;
                             }
                             break;
                            }
                            b = M() | 0;
                            break A;
                           }
                           b = M() | 0;
                           break A;
                          }
                          b = M() | 0;
                          break A;
                         }
                         b = M() | 0;
                        }
                        uc(j);
                       }
                       nd(d + 156 | 0);
                       break c;
                      }
                      b = M() | 0;
                      break c;
                     }
                     uc(j);
                     nd(d + 156 | 0);
                    }
                    z = z + 1 | 0;
                    continue;
                   }
                  }
                  b = M() | 0;
                  break a;
                 }
                 b = M() | 0;
                 break c;
                }
                b = M() | 0;
                break c;
               }
               G: {
                if (!(E & 1)) {
                 break G;
                }
                v[31601] = 0;
                c = O(1, d + 104 | 0, 16651) | 0;
                e = v[31601];
                v[31601] = 0;
                H: {
                 if ((e | 0) != 1) {
                  e = v[a + 1298472 >> 2];
                  v[31601] = 0;
                  R(385, e | 0, 2, c | 0);
                  e = v[31601];
                  v[31601] = 0;
                  if ((e | 0) == 1) {
                   break H;
                  }
                  sb(c);
                  break G;
                 }
                 b = M() | 0;
                 break c;
                }
                b = M() | 0;
                sb(c);
                break c;
               }
               v[31601] = 0;
               c = O(412, b | 0, 5558) | 0;
               e = v[31601];
               v[31601] = 0;
               if ((e | 0) == 1) {
                break q;
               }
               if (c) {
                v[31601] = 0;
                c = Q(151, b | 0) | 0;
                e = v[31601];
                v[31601] = 0;
                if ((e | 0) == 1) {
                 break q;
                }
                v[31601] = 0;
                U(336, a + 1298332 | 0, b | 0, c | 0, 0);
                c = v[31601];
                v[31601] = 0;
                if ((c | 0) == 1) {
                 break q;
                }
                f = f | 16;
               }
               v[31601] = 0;
               o = O(412, b | 0, 14118) | 0;
               c = v[31601];
               v[31601] = 0;
               if ((c | 0) == 1) {
                break d;
               }
               if (o) {
                v[31601] = 0;
                c = Q(151, b | 0) | 0;
                e = v[31601];
                v[31601] = 0;
                if ((e | 0) == 1) {
                 break d;
                }
                v[31601] = 0;
                e = a + 901404 | 0;
                R(771, b | 0, e | 0, c | 0);
                c = v[31601];
                v[31601] = 0;
                if ((c | 0) == 1) {
                 break d;
                }
                ED(e);
                f = f | 16;
               }
               v[31601] = 0;
               c = O(412, b | 0, 13890) | 0;
               e = v[31601];
               v[31601] = 0;
               if ((e | 0) == 1) {
                break d;
               }
               if (!c) {
                break p;
               }
               v[31601] = 0;
               c = Q(151, b | 0) | 0;
               e = v[31601];
               v[31601] = 0;
               if ((e | 0) != 1) {
                u[d + 192 >> 1] = c >>> 5;
                K = d, L = Xj(v[a + 484344 >> 2], v[a + 484348 >> 2]), u[K + 72 >> 1] = L;
                c = x[Nc(d + 192 | 0, d + 72 | 0) >> 1];
                e = 0;
                while (1) {
                 if ((c | 0) == (e | 0)) {
                  f = f | 16;
                  break p;
                 }
                 v[31601] = 0;
                 j = d + 192 | 0;
                 N(579, b | 0, j | 0);
                 i = v[31601];
                 v[31601] = 0;
                 I: {
                  if ((i | 0) == 1) {
                   break I;
                  }
                  i = v[a + 484344 >> 2];
                  v[31601] = 0;
                  N(580, Vb(i, e) | 0, j | 0);
                  j = v[31601];
                  v[31601] = 0;
                  if ((j | 0) == 1) {
                   break I;
                  }
                  e = e + 1 | 0;
                  continue;
                 }
                 break;
                }
                b = M() | 0;
                break c;
               }
               b = M() | 0;
               break c;
              }
              b = M() | 0;
              break c;
             }
             v[31601] = 0;
             c = O(412, b | 0, 13895) | 0;
             e = v[31601];
             v[31601] = 0;
             if ((e | 0) == 1) {
              break d;
             }
             J: {
              if (!c) {
               break J;
              }
              v[31601] = 0;
              c = Q(151, b | 0) | 0;
              e = v[31601];
              v[31601] = 0;
              if ((e | 0) != 1) {
               u[d + 192 >> 1] = (c >>> 0) / 20;
               u[d + 72 >> 1] = x[a + 480188 >> 1];
               c = a + 480280 | 0;
               j = x[Nc(d + 192 | 0, d + 72 | 0) >> 1];
               e = 0;
               while (1) {
                if ((e | 0) == (j | 0)) {
                 f = f | 16;
                 break J;
                }
                v[31601] = 0;
                R(424, b | 0, (c + (e << 5) | 0) + 9 | 0, 20);
                i = v[31601];
                v[31601] = 0;
                if ((i | 0) != 1) {
                 e = e + 1 | 0;
                 continue;
                }
                break;
               }
               b = M() | 0;
               break c;
              }
              b = M() | 0;
              break c;
             }
             c = v[b + 8 >> 2];
             e = v[b >> 2];
             v[31601] = 0;
             c = T(150, e | 0, c | 0, 8) | 0;
             e = v[31601];
             v[31601] = 0;
             if ((e | 0) == 1) {
              break d;
             }
             if (c) {
              c = v[b + 8 >> 2];
              v[31601] = 0;
              R(425, d + 192 | 0, a | 0, b | 0);
              e = v[31601];
              v[31601] = 0;
              if ((e | 0) == 1) {
               break h;
              }
              f = (c | 0) == v[b + 8 >> 2] ? f : f | 16;
             }
             K: {
              if (!(f & 16)) {
               break K;
              }
              if (f & 4) {
               v[a + 1074308 >> 2] = 17367040;
               v[31601] = 0;
               c = O(1, d + 192 | 0, 14668) | 0;
               e = v[31601];
               v[31601] = 0;
               if ((e | 0) != 1) {
                yb(l, c);
                sb(c);
                break K;
               }
               b = M() | 0;
               break c;
              }
              if (!(f & 2)) {
               break K;
              }
              v[a + 1074308 >> 2] = 18219008;
              v[31601] = 0;
              c = O(1, d + 192 | 0, 14847) | 0;
              e = v[31601];
              v[31601] = 0;
              if ((e | 0) == 1) {
               break g;
              }
              yb(l, c);
              sb(c);
             }
             L: {
              M: {
               N: {
                O: {
                 P: {
                  Q: {
                   R: {
                    if ((w[k | 0] | w[k + 1 | 0] << 8 | (w[k + 2 | 0] << 16 | w[k + 3 | 0] << 24)) == 1852141647 & (w[k + 4 | 0] | w[k + 5 | 0] << 8 | (w[k + 6 | 0] << 16 | w[k + 7 | 0] << 24)) == 542396493) {
                     v[31601] = 0;
                     c = T(392, d + 72 | 0, d + 542 | 0, 12) | 0;
                     e = v[31601];
                     v[31601] = 0;
                     if ((e | 0) == 1) {
                      break R;
                     }
                     v[31601] = 0;
                     e = d + 156 | 0;
                     R(258, e | 0, 1, c | 0);
                     f = v[31601];
                     v[31601] = 0;
                     if ((f | 0) == 1) {
                      break Q;
                     }
                     v[31601] = 0;
                     f = Q(772, e | 0) | 0;
                     k = v[31601];
                     v[31601] = 0;
                     if ((k | 0) == 1) {
                      break P;
                     }
                     v[a + 1074308 >> 2] = f;
                     sb(e);
                     t[a + 1074368 | 0] = y[a + 1074308 >> 2] < 19007257 ? 4 : 5;
                     sb(c);
                     f = 24;
                    }
                    if (!(!v[a + 1074308 >> 2] | f & 8)) {
                     t[a + 1074368 | 0] = 0;
                     Uv(a + 1074312 | 0);
                    }
                    c = f & 32;
                    S: {
                     if (!c) {
                      break S;
                     }
                     t[a + 1074368 | 0] = 5;
                     if (!o) {
                      lr(a + 901404 | 0);
                     }
                     if ((w[d + 554 | 0] | w[d + 555 | 0] << 8) >>> 0 < 260) {
                      break S;
                     }
                     v[31601] = 0;
                     T(266, a + 1074312 | 0, 4, 1) | 0;
                     e = v[31601];
                     v[31601] = 0;
                     if ((e | 0) == 1) {
                      break d;
                     }
                    }
                    if (!zd(v[l + 4 >> 2], w[l + 11 | 0])) {
                     break L;
                    }
                    if (!(f & 256) | A & 255 | g + 1 >>> 0 > 1) {
                     break M;
                    }
                    v[31601] = 0;
                    c = O(1, d + 156 | 0, 8292) | 0;
                    g = v[31601];
                    v[31601] = 0;
                    if ((g | 0) == 1) {
                     break N;
                    }
                    yb(l, c);
                    sb(c);
                    break L;
                   }
                   b = M() | 0;
                   break c;
                  }
                  b = M() | 0;
                  break O;
                 }
                 b = M() | 0;
                 sb(d + 156 | 0);
                }
                sb(c);
                break c;
               }
               b = M() | 0;
               break c;
              }
              if (c) {
               v[31601] = 0;
               c = O(1, d + 156 | 0, 12069) | 0;
               g = v[31601];
               v[31601] = 0;
               if ((g | 0) != 1) {
                yb(l, c);
                sb(c);
                break L;
               }
               b = M() | 0;
               break c;
              }
              v[31601] = 0;
              c = O(1, d + 156 | 0, 9750) | 0;
              g = v[31601];
              v[31601] = 0;
              if ((g | 0) == 1) {
               break f;
              }
              yb(l, c);
              sb(c);
             }
             t[d + 67 | 0] = 0;
             if (x[a + 480192 >> 1]) {
              v[31601] = 0;
              c = O(435, a | 0, b | 0) | 0;
              g = v[31601];
              v[31601] = 0;
              if ((g | 0) == 1) {
               break i;
              }
              t[d + 67 | 0] = c;
             }
             v[31601] = 0;
             aa(436, a | 0, b | 0, 1, d + 67 | 0) | 0;
             b = v[31601];
             v[31601] = 0;
             if ((b | 0) == 1) {
              break i;
             }
             e = v[a + 1074308 >> 2];
             T: {
              U: {
               V: {
                W: {
                 X: {
                  Y: {
                   Z: {
                    _: {
                     $: {
                      aa: {
                       ba: {
                        ca: {
                         da: {
                          ea: {
                           fa: {
                            if (w[d + 67 | 0]) {
                             if (e >>> 0 > 18284543) {
                              break fa;
                             }
                             v[a + 1074308 >> 2] = 18284544;
                             break fa;
                            }
                            if (e >>> 0 < 18284544) {
                             break ea;
                            }
                           }
                           v[31601] = 0;
                           c = O(1, d + 52 | 0, 18226) | 0;
                           b = v[31601];
                           v[31601] = 0;
                           if ((b | 0) == 1) {
                            break da;
                           }
                           g = v[a + 1074308 >> 2];
                           v[31601] = 0;
                           b = d + 40 | 0;
                           N(773, b | 0, g | 0);
                           g = v[31601];
                           v[31601] = 0;
                           if ((g | 0) == 1) {
                            break ca;
                           }
                           v[31601] = 0;
                           g = d + 92 | 0;
                           R(2, g | 0, c | 0, b | 0);
                           e = v[31601];
                           v[31601] = 0;
                           if ((e | 0) == 1) {
                            break ba;
                           }
                           yb(l, g);
                           sb(g);
                           sb(b);
                           sb(c);
                           e = v[a + 1074308 >> 2];
                          }
                          ga: {
                           if (e - 1 >>> 0 > 19005952) {
                            break ga;
                           }
                           b = v[a + 484344 >> 2];
                           f = v[a + 484348 >> 2];
                           if (!Ie(b, f, 254)) {
                            b = w[a + 484376 | 0];
                            c = v[a + 484360 >> 2];
                            v[31601] = 0;
                            V(774, Wb(c, b) | 0);
                            b = v[31601];
                            v[31601] = 0;
                            if ((b | 0) == 1) {
                             break i;
                            }
                            f = v[a + 484348 >> 2];
                            b = v[a + 484344 >> 2];
                           }
                           if (Ie(b, f, 255)) {
                            break ga;
                           }
                           VC(Wb(v[a + 484360 >> 2], w[a + 484376 | 0]), 255, 65535);
                          }
                          v[31601] = 0;
                          c = d + 40 | 0;
                          N(775, c | 0, 4102);
                          b = v[31601];
                          v[31601] = 0;
                          if ((b | 0) == 1) {
                           break $;
                          }
                          b = w[d + 554 | 0] | w[d + 555 | 0] << 8;
                          v[d + 12 >> 2] = b >>> 8;
                          v[31601] = 0;
                          v[d + 24 >> 2] = b & 255;
                          g = d + 28 | 0;
                          N(444, g | 0, d + 24 | 0);
                          b = v[31601];
                          v[31601] = 0;
                          if ((b | 0) == 1) {
                           break _;
                          }
                          v[31601] = 0;
                          b = d + 92 | 0;
                          U(430, b | 0, c | 0, d + 12 | 0, g | 0);
                          e = v[31601];
                          v[31601] = 0;
                          if ((e | 0) == 1) {
                           break Z;
                          }
                          e = yb(a + 1298344 | 0, b);
                          sb(b);
                          sb(g);
                          Db(c);
                          f = yb(a + 1298368 | 0, l);
                          K = a, L = v[Ec(b, v[(v[a + 1074308 >> 2] ? 41040 : r) >> 2]) >> 2], v[K + 1298404 >> 2] = L;
                          if (!w[d + 483 | 0]) {
                           break U;
                          }
                          yb(a + 1298380 | 0, e);
                          v[31601] = 0;
                          b = O(1, b | 0, 15273) | 0;
                          k = v[31601];
                          v[31601] = 0;
                          if ((k | 0) == 1) {
                           break X;
                          }
                          yb(e, b);
                          sb(b);
                          v[31601] = 0;
                          b = O(1, c | 0, 10101) | 0;
                          c = v[31601];
                          v[31601] = 0;
                          if ((c | 0) == 1) {
                           break W;
                          }
                          yb(a + 1298356 | 0, b);
                          sb(b);
                          v[31601] = 0;
                          b = O(1, g | 0, 10102) | 0;
                          c = v[31601];
                          v[31601] = 0;
                          if ((c | 0) == 1) {
                           break V;
                          }
                          yb(a + 1298392 | 0, b);
                          break T;
                         }
                         b = M() | 0;
                         break c;
                        }
                        b = M() | 0;
                        break aa;
                       }
                       b = M() | 0;
                       sb(d + 40 | 0);
                      }
                      sb(c);
                      break c;
                     }
                     b = M() | 0;
                     break c;
                    }
                    b = M() | 0;
                    break Y;
                   }
                   b = M() | 0;
                   sb(d + 28 | 0);
                  }
                  Db(d + 40 | 0);
                  break c;
                 }
                 b = M() | 0;
                 break c;
                }
                b = M() | 0;
                break c;
               }
               b = M() | 0;
               break c;
              }
              v[31601] = 0;
              b = O(1, d + 92 | 0, 10102) | 0;
              c = v[31601];
              v[31601] = 0;
              if ((c | 0) == 1) {
               break e;
              }
              yb(a + 1298356 | 0, b);
             }
             sb(b);
             e = 1;
             if (F & 1) {
              v[31601] = 0;
              a = O(1, d + 12 | 0, 17130) | 0;
              b = v[31601];
              v[31601] = 0;
              if ((b | 0) == 1) {
               break k;
              }
              v[31601] = 0;
              O(74, f | 0, a | 0) | 0;
              b = v[31601];
              v[31601] = 0;
              if ((b | 0) == 1) {
               break j;
              }
              sb(a);
             }
             uc(n);
             sb(l);
            }
            eb = d + 576 | 0;
            return e | 0;
           }
           b = M() | 0;
           break c;
          }
          b = M() | 0;
          sb(a);
          break c;
         }
         b = M() | 0;
         break c;
        }
        b = M() | 0;
        break c;
       }
       b = M() | 0;
       break c;
      }
      b = M() | 0;
      break c;
     }
     b = M() | 0;
     break c;
    }
    b = M() | 0;
   }
   uc(n);
   break a;
  }
  b = M() | 0;
 }
 sb(l);
 P(b | 0);
 p();
}

function rta(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, q = 0, r = 0, s = 0, y = 0, z = 0, A = 0, C = 0, D = 0, E = 0;
 e = eb - 416 | 0;
 eb = e;
 xc(b);
 d = e + 399 | 0;
 f = z0(b, d);
 if (!f) {
  HE(d);
 }
 a: {
  b: {
   c: {
    d: {
     e: {
      f: {
       if (!f) {
        break f;
       }
       if (!Y_(d)) {
        break f;
       }
       if (!Lb(v[b >> 2], v[b + 8 >> 2], Ac(72, 0))) {
        break f;
       }
       g = 1;
       if ((c | 0) == 64) {
        break f;
       }
       Cd(a, 1);
       v[a + 480208 >> 2] = v[a + 480208 >> 2] & -25231361 | 16842752;
       g = w[e + 408 | 0];
       u[a + 480190 >> 1] = 63;
       u[a + 480188 >> 1] = g;
       f = a + 480280 | 0;
       d = 0;
       g: {
        h: {
         i: {
          while (1) {
           if ((g & 65535) >>> 0 <= d >>> 0) {
            j: {
             Qb(e + 320 | 0, 0, 64);
             r = a + 484380 | 0;
             d = 1;
             k: {
              l: {
               m: {
                n: {
                 while (1) {
                  o: {
                   f = d & 65535;
                   if (f >>> 0 > x[a + 480190 >> 1]) {
                    KE(b, a + 1298308 | 0);
                    Z_(e + 312 | 0, b);
                    q = Mb(e + 300 | 0);
                    f = w[e + 409 | 0] | w[e + 410 | 0] << 8;
                    if (f) {
                     d = Mb(e + 212 | 0);
                     v[31601] = 0;
                     f = T(326, b | 0, d | 0, B(f, w[e + 408 | 0]) << 1) | 0;
                     h = v[31601];
                     v[31601] = 0;
                     if ((h | 0) == 1) {
                      break k;
                     }
                     if (!f) {
                      break j;
                     }
                     oe(e + 272 | 0, v[d >> 2], v[d + 4 >> 2]);
                     f = Ld(e + 264 | 0);
                     v[31601] = 0;
                     h = v[f + 4 >> 2];
                     v[e + 40 >> 2] = v[f >> 2];
                     v[e + 44 >> 2] = h;
                     f = gg(327, e + 280 | 0, v[e + 272 >> 2], v[e + 276 >> 2], e + 40 | 0);
                     h = v[31601];
                     v[31601] = 0;
                     if ((h | 0) == 1) {
                      break o;
                     }
                     h = v[d + 4 >> 2];
                     g = v[d >> 2];
                     v[31601] = 0;
                     T(213, f | 0, q | 0, Sc(g, h) >>> 1 | 0) | 0;
                     h = v[31601];
                     v[31601] = 0;
                     if ((h | 0) == 1) {
                      break n;
                     }
                     tb(f);
                     ec(d);
                    }
                    n = Mb(e + 252 | 0);
                    v[31601] = 0;
                    N(328, n | 0, (w[e + 411 | 0] | w[e + 412 | 0] << 8) << 8);
                    d = v[31601];
                    v[31601] = 0;
                    if ((d | 0) == 1) {
                     break i;
                    }
                    d = 0;
                    while (1) {
                     h = w[e + 411 | 0] | w[e + 412 | 0] << 8;
                     f = d & 65535;
                     if (h >>> 0 <= f >>> 0) {
                      break l;
                     }
                     v[e + 212 >> 2] = h - f;
                     v[e + 160 >> 2] = 2e3;
                     d = e + 212 | 0;
                     h = v[Bd(d, e + 160 | 0) >> 2];
                     d = Mb(d);
                     v[31601] = 0;
                     h = T(326, b | 0, d | 0, h << 8) | 0;
                     g = v[31601];
                     v[31601] = 0;
                     if ((g | 0) == 1) {
                      break d;
                     }
                     if (!h) {
                      break m;
                     }
                     h = ub(e + 248 | 0, vb(v[n + 4 >> 2]));
                     g = vb(v[d >> 2]);
                     i = vb(v[e + 216 >> 2]);
                     h = v[h >> 2];
                     v[31601] = 0;
                     U(329, n | 0, h | 0, g | 0, i | 0);
                     h = v[31601];
                     v[31601] = 0;
                     if ((h | 0) == 1) {
                      break d;
                     }
                     ec(d);
                     d = f + 2e3 | 0;
                     continue;
                    }
                   }
                   h = B(f, 104) + r | 0;
                   md(h, 1);
                   g = f + (e + 320 | 0) | 0;
                   f = Yd(b);
                   t[g | 0] = f;
                   if (f << 24 >> 24 >= 0) {
                    D = h, E = V_(b) << 1, v[D >> 2] = E;
                   }
                   d = d + 1 | 0;
                   continue;
                  }
                  break;
                 }
                 a = M() | 0;
                 break b;
                }
                a = M() | 0;
                tb(f);
                break b;
               }
               ec(d);
               g = 0;
               break h;
              }
              oe(e + 232 | 0, v[n >> 2], v[n + 4 >> 2]);
              lf(e + 240 | 0, v[e + 232 >> 2], v[e + 236 >> 2]);
              d = w[a + 484376 | 0];
              f = v[a + 484360 >> 2];
              v[31601] = 0;
              N(330, Wb(f, d) | 0, w[e + 409 | 0] | w[e + 410 | 0] << 8);
              d = v[31601];
              v[31601] = 0;
              if ((d | 0) == 1) {
               break e;
              }
              k = a + 484344 | 0;
              y = c & 1;
              i = 0;
              while (1) {
               if ((w[e + 409 | 0] | w[e + 410 | 0] << 8) >>> 0 <= i >>> 0) {
                h = c & 2;
                l = a + 946304 | 0;
                f = 1;
                p: {
                 q: {
                  r: {
                   s: {
                    t: {
                     u: {
                      v: {
                       w: {
                        x: {
                         y: {
                          z: {
                           A: {
                            while (1) {
                             c = f & 65535;
                             if (c >>> 0 > x[a + 480190 >> 1]) {
                              break w;
                             }
                             v[31601] = 0;
                             d = w[c + (e + 320 | 0) | 0];
                             R(331, b | 0, l + (c << 5) | 0, d & 63);
                             g = v[31601];
                             v[31601] = 0;
                             if ((g | 0) == 1) {
                              break u;
                             }
                             B: {
                              C: {
                               if (d << 24 >> 24 < 0) {
                                break C;
                               }
                               v[31601] = 0;
                               d = Q(332, b | 0) | 0;
                               g = v[31601];
                               v[31601] = 0;
                               D: {
                                E: {
                                 F: {
                                  G: {
                                   H: {
                                    I: {
                                     J: {
                                      K: {
                                       if ((g | 0) == 1) {
                                        break K;
                                       }
                                       c = B(c, 104) + r | 0;
                                       v[c + 12 >> 2] = d << 1;
                                       v[31601] = 0;
                                       d = Q(332, b | 0) | 0;
                                       g = v[31601];
                                       v[31601] = 0;
                                       if ((g | 0) == 1) {
                                        break J;
                                       }
                                       if (d >>> 0 >= 2) {
                                        v[c + 16 >> 2] = v[c + 12 >> 2] + (d << 1);
                                        u[c + 34 >> 1] = x[c + 34 >> 1] | 8;
                                       }
                                       v[31601] = 0;
                                       d = Q(197, b | 0) | 0;
                                       g = v[31601];
                                       v[31601] = 0;
                                       if ((g | 0) == 1) {
                                        break t;
                                       }
                                       t[e + 80 | 0] = d;
                                       t[e + 180 | 0] = 64;
                                       D = c, E = w[Pb(e + 80 | 0, e + 180 | 0) | 0] << 2, u[D + 30 >> 1] = E;
                                       v[31601] = 0;
                                       d = Q(197, b | 0) | 0;
                                       g = v[31601];
                                       v[31601] = 0;
                                       if ((g | 0) == 1) {
                                        break K;
                                       }
                                       t[c + 37 | 0] = d << 4;
                                       ep(c);
                                       if (!v[c >> 2]) {
                                        break C;
                                       }
                                       v[31601] = 0;
                                       d = Q(197, b | 0) | 0;
                                       g = v[31601];
                                       v[31601] = 0;
                                       if ((g | 0) == 1) {
                                        break E;
                                       }
                                       g = 0;
                                       switch (d | 0) {
                                       case 4:
                                       case 5:
                                        break D;

                                       case 2:
                                       case 3:
                                        break G;

                                       case 1:
                                        break H;

                                       case 0:
                                        break I;

                                       default:
                                        break h;
                                       }
                                      }
                                      a = M() | 0;
                                      break c;
                                     }
                                     a = M() | 0;
                                     break c;
                                    }
                                    if (h) {
                                     d = Mb(e + 80 | 0);
                                     i = v[b + 8 >> 2];
                                     j = v[b >> 2];
                                     k = v[c >> 2];
                                     v[31601] = 0;
                                     i = T(150, j | 0, i | 0, k | 0) | 0;
                                     j = v[31601];
                                     v[31601] = 0;
                                     if ((j | 0) == 1) {
                                      break s;
                                     }
                                     if (!i) {
                                      break x;
                                     }
                                     g = v[c >> 2];
                                     v[31601] = 0;
                                     R(333, b | 0, d | 0, g | 0);
                                     g = v[31601];
                                     v[31601] = 0;
                                     if ((g | 0) == 1) {
                                      break s;
                                     }
                                     D = e, E = vb(v[d >> 2]), v[D + 180 >> 2] = E;
                                     i = vb(v[e + 84 >> 2]);
                                     while (1) {
                                      g = v[e + 180 >> 2];
                                      if (Hb(g, i)) {
                                       j = g;
                                       g = w[g | 0];
                                       t[j | 0] = g << 7 | (g ^ -1) >>> 1 & 127;
                                       xe(e + 180 | 0);
                                       continue;
                                      }
                                      break;
                                     }
                                     oe(e + 200 | 0, v[d >> 2], v[e + 84 >> 2]);
                                     g = Ld(e + 192 | 0);
                                     v[31601] = 0;
                                     i = v[g + 4 >> 2];
                                     v[e + 16 >> 2] = v[g >> 2];
                                     v[e + 20 >> 2] = i;
                                     g = gg(327, e + 212 | 0, v[e + 200 >> 2], v[e + 204 >> 2], e + 16 | 0);
                                     i = v[31601];
                                     v[31601] = 0;
                                     L: {
                                      if ((i | 0) != 1) {
                                       i = Yc(e + 180 | 0, 16, 1, 0, 16);
                                       v[31601] = 0;
                                       T(215, i | 0, c | 0, g | 0) | 0;
                                       c = v[31601];
                                       v[31601] = 0;
                                       if ((c | 0) == 1) {
                                        break L;
                                       }
                                       tb(g);
                                       ec(d);
                                       break C;
                                      }
                                      a = M() | 0;
                                      break p;
                                     }
                                     a = M() | 0;
                                     tb(g);
                                     break p;
                                    }
                                    c = v[c >> 2];
                                    break F;
                                   }
                                   d = Mb(e + 80 | 0);
                                   i = v[c >> 2];
                                   v[31601] = 0;
                                   g = e + 180 | 0;
                                   R(334, g | 0, b | 0, i | 0);
                                   i = v[31601];
                                   v[31601] = 0;
                                   M: {
                                    N: {
                                     O: {
                                      if ((i | 0) != 1) {
                                       j = yn(d, g);
                                       ec(g);
                                       if (h) {
                                        oe(e + 152 | 0, v[j >> 2], v[e + 84 >> 2]);
                                        i = Ld(e + 144 | 0);
                                        v[31601] = 0;
                                        k = v[i + 4 >> 2];
                                        v[e + 24 >> 2] = v[i >> 2];
                                        v[e + 28 >> 2] = k;
                                        i = gg(327, e + 160 | 0, v[e + 152 >> 2], v[e + 156 >> 2], e + 24 | 0);
                                        k = v[31601];
                                        v[31601] = 0;
                                        if ((k | 0) == 1) {
                                         break O;
                                        }
                                        g = Yc(g, 8, 1, 0, 2);
                                        v[31601] = 0;
                                        T(215, g | 0, c | 0, i | 0) | 0;
                                        c = v[31601];
                                        v[31601] = 0;
                                        if ((c | 0) == 1) {
                                         break N;
                                        }
                                        tb(i);
                                       }
                                       ec(j);
                                       break C;
                                      }
                                      a = S(28784) | 0;
                                      if ((fb | 0) != (_(28784) | 0)) {
                                       break M;
                                      }
                                      X(a | 0) | 0;
                                      g = 0;
                                      v[31601] = 0;
                                      W(26);
                                      a = v[31601];
                                      v[31601] = 0;
                                      if ((a | 0) != 1) {
                                       break v;
                                      }
                                      a = M() | 0;
                                      break M;
                                     }
                                     a = M() | 0;
                                     break M;
                                    }
                                    a = M() | 0;
                                    tb(i);
                                   }
                                   ec(d);
                                   break c;
                                  }
                                  if (h) {
                                   d = Yc(e + 80 | 0, (d | 0) == 2 ? 8 : 16, 1, 0, 0);
                                   v[31601] = 0;
                                   T(215, d | 0, c | 0, b | 0) | 0;
                                   c = v[31601];
                                   v[31601] = 0;
                                   if ((c | 0) != 1) {
                                    break C;
                                   }
                                   a = M() | 0;
                                   break c;
                                  }
                                  c = B(v[c >> 2], d - 1 | 0);
                                 }
                                 v[31601] = 0;
                                 O(183, b | 0, c | 0) | 0;
                                 c = v[31601];
                                 v[31601] = 0;
                                 if ((c | 0) != 1) {
                                  break C;
                                 }
                                }
                                a = M() | 0;
                                break c;
                               }
                               i = Mb(e + 80 | 0);
                               g = v[c >> 2];
                               v[31601] = 0;
                               j = e + 180 | 0;
                               R(335, j | 0, b | 0, g | 0);
                               g = v[31601];
                               v[31601] = 0;
                               P: {
                                Q: {
                                 if ((g | 0) != 1) {
                                  g = yn(i, j);
                                  ec(j);
                                  if (!h) {
                                   break P;
                                  }
                                  if ((d | 0) != 5) {
                                   break Q;
                                  }
                                  D = e, E = vb(v[g >> 2]), v[D + 180 >> 2] = E;
                                  k = vb(v[e + 84 >> 2]);
                                  while (1) {
                                   j = v[e + 180 >> 2];
                                   if (!Hb(j, k)) {
                                    break Q;
                                   }
                                   m = j;
                                   j = w[j | 0];
                                   t[m | 0] = w[(j >>> 7 | 0) + 24721 | 0] ^ j;
                                   xe(e + 180 | 0);
                                   continue;
                                  }
                                 }
                                 a = S(28784) | 0;
                                 if ((fb | 0) != (_(28784) | 0)) {
                                  break y;
                                 }
                                 X(a | 0) | 0;
                                 g = 0;
                                 v[31601] = 0;
                                 W(26);
                                 a = v[31601];
                                 v[31601] = 0;
                                 if ((a | 0) != 1) {
                                  break B;
                                 }
                                 a = M() | 0;
                                 break y;
                                }
                                oe(e + 112 | 0, v[g >> 2], v[e + 84 >> 2]);
                                j = Ld(e + 104 | 0);
                                v[31601] = 0;
                                k = v[j + 4 >> 2];
                                v[e + 32 >> 2] = v[j >> 2];
                                v[e + 36 >> 2] = k;
                                j = gg(327, e + 124 | 0, v[e + 112 >> 2], v[e + 116 >> 2], e + 32 | 0);
                                k = v[31601];
                                v[31601] = 0;
                                if ((k | 0) == 1) {
                                 break A;
                                }
                                d = (d | 0) == 5;
                                d = Yc(e + 180 | 0, d ? 16 : 8, 1, 0, d ? 16 : 1);
                                v[31601] = 0;
                                T(215, d | 0, c | 0, j | 0) | 0;
                                c = v[31601];
                                v[31601] = 0;
                                if ((c | 0) == 1) {
                                 break z;
                                }
                                tb(j);
                               }
                               ec(g);
                              }
                              f = f + 1 | 0;
                              continue;
                             }
                             break;
                            }
                            ec(i);
                            break h;
                           }
                           a = M() | 0;
                           break y;
                          }
                          a = M() | 0;
                          tb(j);
                         }
                         ec(i);
                         break c;
                        }
                        ec(d);
                        break h;
                       }
                       d = 0;
                       t[e + 182 | 0] = 0;
                       u[e + 180 >> 1] = 0;
                       u[e + 80 >> 1] = w[e + 413 | 0] | w[e + 414 | 0] << 8;
                       t[e + 82 | 0] = w[e + 415 | 0];
                       while (1) {
                        if ((d | 0) != 3) {
                         c = wb(e + 80 | 0, d);
                         D = wb(e + 180 | 0, d), E = w[c | 0], t[D | 0] = E;
                         d = d + 1 | 0;
                         continue;
                        }
                        break;
                       }
                       R: {
                        S: {
                         T: {
                          U: {
                           c = e + 180 | 0;
                           d = bg(c);
                           if (d) {
                            c = Mb(c);
                            v[31601] = 0;
                            b = T(326, b | 0, c | 0, d | 0) | 0;
                            f = v[31601];
                            v[31601] = 0;
                            if ((f | 0) == 1) {
                             break r;
                            }
                            if (!b) {
                             break S;
                            }
                            oe(e + 72 | 0, v[c >> 2], v[c + 4 >> 2]);
                            b = Ld(e - -64 | 0);
                            v[31601] = 0;
                            f = v[b + 4 >> 2];
                            v[e + 8 >> 2] = v[b >> 2];
                            v[e + 12 >> 2] = f;
                            b = gg(327, e + 80 | 0, v[e + 72 >> 2], v[e + 76 >> 2], e + 8 | 0);
                            f = v[31601];
                            v[31601] = 0;
                            if ((f | 0) == 1) {
                             break U;
                            }
                            v[31601] = 0;
                            U(336, a + 1298332 | 0, b | 0, d | 0, 1);
                            d = v[31601];
                            v[31601] = 0;
                            if ((d | 0) == 1) {
                             break T;
                            }
                            tb(b);
                            ec(c);
                           }
                           v[31601] = 0;
                           V(337, e + 52 | 0);
                           b = v[31601];
                           v[31601] = 0;
                           if ((b | 0) != 1) {
                            break R;
                           }
                           a = M() | 0;
                           break c;
                          }
                          a = M() | 0;
                          break q;
                         }
                         a = M() | 0;
                         tb(b);
                         break q;
                        }
                        ec(c);
                        g = 0;
                        break h;
                       }
                       v[31601] = 0;
                       b = e + 180 | 0;
                       c = e + 52 | 0;
                       R(338, b | 0, c | 0, w[e + 407 | 0]);
                       d = v[31601];
                       v[31601] = 0;
                       V: {
                        W: {
                         if ((d | 0) != 1) {
                          yb(a + 1298344 | 0, b);
                          sb(b);
                          Db(c);
                          v[31601] = 0;
                          b = O(1, b | 0, 10096) | 0;
                          d = v[31601];
                          v[31601] = 0;
                          if ((d | 0) == 1) {
                           break W;
                          }
                          yb(a + 1298356 | 0, b);
                          sb(b);
                          v[31601] = 0;
                          b = O(1, c | 0, 5101) | 0;
                          c = v[31601];
                          v[31601] = 0;
                          if ((c | 0) == 1) {
                           break V;
                          }
                          yb(a + 1298368 | 0, b);
                          sb(b);
                          D = a, E = v[Ec(e + 48 | 0, 24) >> 2], v[D + 1298404 >> 2] = E;
                          g = 1;
                          break h;
                         }
                         a = M() | 0;
                         Db(e + 52 | 0);
                         break c;
                        }
                        a = M() | 0;
                        break c;
                       }
                       a = M() | 0;
                       break c;
                      }
                      ec(d);
                      break h;
                     }
                     a = M() | 0;
                     break c;
                    }
                    a = M() | 0;
                    break c;
                   }
                   a = M() | 0;
                   break p;
                  }
                  a = M() | 0;
                 }
                 ec(c);
                 break c;
                }
                ec(d);
                break c;
               }
               D = $b(v[Wb(v[a + 484360 >> 2], w[a + 484376 | 0]) >> 2], i), E = i, u[D >> 1] = E;
               X: {
                Y: {
                 if (!y) {
                  break Y;
                 }
                 v[31601] = 0;
                 s = i & 65535;
                 d = T(196, k | 0, s | 0, 64) | 0;
                 f = v[31601];
                 v[31601] = 0;
                 if ((f | 0) == 1) {
                  break X;
                 }
                 if (!d) {
                  break Y;
                 }
                 f = x[a + 480188 >> 1];
                 j = 0;
                 while (1) {
                  d = f & 65535;
                  if (d >>> 0 <= j >>> 0) {
                   break Y;
                  }
                  d = $b(v[q >> 2], B(d, i) + j | 0);
                  d = w[d | 0] | w[d + 1 | 0] << 8;
                  Z: {
                   if (d >>> 0 >= (w[e + 411 | 0] | w[e + 412 | 0] << 8) >>> 0) {
                    break Z;
                   }
                   g = 0;
                   z = d << 8;
                   d = Vb(v[k >> 2], i);
                   d = ld(v[d >> 2], v[v[d + 48 >> 2] + 12 >> 2], 0, j & 65535);
                   A = B(j, -6);
                   while (1) {
                    if ((g | 0) == 64) {
                     break Z;
                    }
                    wr(e + 212 | 0, v[e + 240 >> 2], v[e + 244 >> 2], g << 2 | z, 4);
                    f = v[e + 212 >> 2];
                    h = wb(f, 0);
                    o = w[h | 0] & 63;
                    t[d | 0] = o ? o + 48 | 0 : 0;
                    l = wb(f, 1);
                    t[d + 1 | 0] = w[l | 0] << 2 & 60 | w[h | 0] >>> 6;
                    m = w[l | 0];
                    h = wb(f, 2);
                    l = w[wb(f, 3) | 0];
                    f = w[h | 0];
                    h = l << 4 | f >>> 4;
                    u[e + 80 >> 1] = h;
                    C = m >>> 6 | 0;
                    m = f << 2 & 60;
                    f = C | m;
                    _: {
                     if (!(w[wb(e + 312 | 0, m >>> 3 | 0) | 0] >>> (f & 7) & 1) | !(f | h)) {
                      break _;
                     }
                     t[d + 5 | 0] = h;
                     m = l >>> 4 | 0;
                     t[d + 4 | 0] = m;
                     $: {
                      aa: {
                       ba: {
                        ca: {
                         da: {
                          ea: {
                           fa: {
                            ga: {
                             ha: {
                              ia: {
                               ja: {
                                ka: {
                                 switch (f | 0) {
                                 case 0:
                                 case 1:
                                 case 2:
                                 case 32:
                                 case 33:
                                 case 34:
                                  Bf(d, f & 15, h & 255);
                                  if (!w[d + 4 | 0]) {
                                   break _;
                                  }
                                  t[d + 2 | 0] = f >>> 0 < 32 ? 3 : 4;
                                  break _;

                                 case 9:
                                  t[d + 3 | 0] = 10;
                                  t[d + 5 | 0] = h >>> 1;
                                  if (h >>> 0 < 512) {
                                   break _;
                                  }
                                  t[d + 2 | 0] = 15;
                                  t[d + 4 | 0] = l >>> 5;
                                  break _;

                                 case 10:
                                 case 42:
                                  if (h >>> 0 > 254) {
                                   break ja;
                                  }
                                  f = f & 15;
                                  break;

                                 case 50:
                                  break aa;

                                 case 48:
                                  break ba;

                                 case 43:
                                  break ca;

                                 case 47:
                                  break da;

                                 case 17:
                                 case 18:
                                 case 26:
                                 case 27:
                                  break ea;

                                 case 22:
                                 case 25:
                                 case 28:
                                 case 29:
                                 case 30:
                                  break fa;

                                 case 16:
                                 case 19:
                                 case 20:
                                 case 21:
                                 case 23:
                                 case 31:
                                  break ga;

                                 case 13:
                                  break ha;

                                 case 11:
                                 case 15:
                                  break ia;

                                 case 3:
                                 case 4:
                                 case 5:
                                 case 6:
                                 case 7:
                                 case 12:
                                  break ka;

                                 default:
                                  break $;
                                 }
                                }
                                Bf(d, f, h & 255);
                                break _;
                               }
                               t[d + 3 | 0] = 19;
                               t[d + 5 | 0] = m | (f >>> 0 < 32 ? 16 : 32);
                               if (l & 15) {
                                t[d + 2 | 0] = 3;
                                t[d + 4 | 0] = (h & 240) >>> 4;
                                break _;
                               }
                               t[d + 4 | 0] = h;
                               t[d + 2 | 0] = 4;
                               break _;
                              }
                              t[d + 3 | 0] = (f | 0) == 11 ? 12 : 16;
                              D = d, E = fw(h), t[D + 5 | 0] = E;
                              break _;
                             }
                             t[d + 3 | 0] = 14;
                             if ((h & 255) >>> 0 < 64) {
                              break _;
                             }
                             t[d + 5 | 0] = 0;
                             break _;
                            }
                            t[d + 3 | 0] = 19;
                            t[d + 5 | 0] = h & 15 | f << 4;
                            break _;
                           }
                           t[d + 3 | 0] = 19;
                           u[e + 160 >> 1] = 15;
                           D = d, E = w[Nc(e + 80 | 0, e + 160 | 0) | 0] | f << 4, t[D + 5 | 0] = E;
                           break _;
                          }
                          t[d + 3 | 0] = 19;
                          if (h & 255) {
                           t[d + 5 | 0] = h & 15 | ((f | 0) == 17 ? 16 : (f | 0) == 26 ? 16 : 32);
                           if (l >>> 0 < 16) {
                            break _;
                           }
                           t[d + 2 | 0] = f >>> 0 > 25 ? 6 : 5;
                           break _;
                          }
                          t[d + 5 | 0] = m | (f >>> 0 > 25 ? -80 : -96);
                          break _;
                         }
                         if (!h) {
                          break $;
                         }
                         t[d + 3 | 0] = 17;
                         v[e + 160 >> 2] = 8;
                         v[e + 124 >> 2] = h + 4;
                         D = d, E = Dh(v[Ye(e + 160 | 0, e + 124 | 0) >> 2] / 8 | 0), t[D + 5 | 0] = E;
                         break _;
                        }
                        t[d + 3 | 0] = 14;
                        l = d + A | 0;
                        o = x[a + 480188 >> 1];
                        f = 0;
                        while (1) {
                         if ((f | 0) == (o | 0)) {
                          break _;
                         }
                         h = l + B(f, 6) | 0;
                         if (!w[h + 3 | 0]) {
                          t[h + 3 | 0] = 12;
                          D = h, E = fw(s), t[D + 5 | 0] = E;
                         }
                         f = f + 1 | 0;
                         continue;
                        }
                       }
                       t[d + 3 | 0] = 9;
                       f = h & 7;
                       if (f) {
                        t[d + 5 | 0] = w[f + 24713 | 0];
                        break _;
                       }
                       f = h >>> 4 | 0;
                       if ((f | 0) == 128) {
                        break $;
                       }
                       t[d + 5 | 0] = f;
                       if (h >>> 0 <= 2047) {
                        t[d + 5 | 0] = f | 128;
                        break _;
                       }
                       t[d + 5 | 0] = f ^ -1;
                       break _;
                      }
                      t[d + 5 | 0] = 0;
                      t[d + 3 | 0] = 0;
                      if (!o) {
                       t[d | 0] = 255;
                       break _;
                      }
                      t[d + 3 | 0] = 25;
                      break _;
                     }
                     t[d + 3 | 0] = 0;
                    }
                    g = g + 1 | 0;
                    f = x[a + 480188 >> 1];
                    d = B(f, 6) + d | 0;
                    continue;
                   }
                  }
                  j = j + 1 | 0;
                  continue;
                 }
                }
                i = i + 1 | 0;
                continue;
               }
               break;
              }
              a = M() | 0;
              break c;
             }
             a = M() | 0;
             break b;
            }
           } else {
            bE(a, d & 65535);
            u[(f + (d << 5) | 0) + 4 >> 1] = (d & 3) - 1 >>> 0 < 2 ? 64 : 192;
            d = d + 1 | 0;
            g = x[a + 480188 >> 1];
            continue;
           }
           break;
          }
          ec(d);
          g = 0;
          break g;
         }
         a = M() | 0;
         break c;
        }
        ec(n);
       }
       nd(q);
      }
      eb = e + 416 | 0;
      return g | 0;
     }
     a = M() | 0;
     break c;
    }
    a = M() | 0;
    ec(d);
   }
   ec(n);
   break a;
  }
  ec(d);
 }
 nd(q);
 P(a | 0);
 p();
}

function tP(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0;
 j = eb - 32 | 0;
 eb = j;
 a: {
  b: {
   c: {
    d: {
     e: {
      f: {
       if (Md(b, 22256)) {
        Eb(a);
        break f;
       }
       if (Md(b, 9893)) {
        b = eb - 96 | 0;
        eb = b;
        g = Eb(a);
        v[31601] = 0;
        V(128, b - -64 | 0);
        a = v[31601];
        v[31601] = 0;
        g: {
         h: {
          i: {
           j: {
            k: {
             l: {
              m: {
               n: {
                o: {
                 p: {
                  q: {
                   r: {
                    s: {
                     t: {
                      u: {
                       v: {
                        w: {
                         x: {
                          y: {
                           z: {
                            A: {
                             B: {
                              C: {
                               if ((a | 0) != 1) {
                                v[31601] = 0;
                                v[b + 40 >> 2] = 0;
                                a = b + 52 | 0;
                                c = b + 40 | 0;
                                N(1116, a | 0, c | 0);
                                d = v[31601];
                                v[31601] = 0;
                                if ((d | 0) == 1) {
                                 break C;
                                }
                                v[31601] = 0;
                                d = O(837, g | 0, a | 0) | 0;
                                f = v[31601];
                                v[31601] = 0;
                                if ((f | 0) == 1) {
                                 break B;
                                }
                                sb(a);
                                v[31601] = 0;
                                d = O(984, d | 0, 16770) | 0;
                                f = v[31601];
                                v[31601] = 0;
                                if ((f | 0) == 1) {
                                 break A;
                                }
                                v[31601] = 0;
                                v[b + 40 >> 2] = 7;
                                N(1116, a | 0, c | 0);
                                f = v[31601];
                                v[31601] = 0;
                                if ((f | 0) == 1) {
                                 break z;
                                }
                                v[31601] = 0;
                                d = O(837, d | 0, a | 0) | 0;
                                f = v[31601];
                                v[31601] = 0;
                                if ((f | 0) == 1) {
                                 break y;
                                }
                                sb(a);
                                v[31601] = 0;
                                d = O(984, d | 0, 16770) | 0;
                                f = v[31601];
                                v[31601] = 0;
                                if ((f | 0) == 1) {
                                 break A;
                                }
                                v[31601] = 0;
                                v[b + 40 >> 2] = 4;
                                N(1116, a | 0, c | 0);
                                f = v[31601];
                                v[31601] = 0;
                                if ((f | 0) == 1) {
                                 break x;
                                }
                                v[31601] = 0;
                                d = O(837, d | 0, a | 0) | 0;
                                f = v[31601];
                                v[31601] = 0;
                                if ((f | 0) == 1) {
                                 break w;
                                }
                                sb(a);
                                v[31601] = 0;
                                f = O(984, d | 0, 15486) | 0;
                                d = v[31601];
                                v[31601] = 0;
                                if ((d | 0) == 1) {
                                 break A;
                                }
                                d = Mb(a);
                                a = v[b + 76 >> 2];
                                if (a) {
                                 v[31601] = 0;
                                 v[b + 16 >> 2] = a;
                                 a = b + 28 | 0;
                                 N(1116, a | 0, b + 16 | 0);
                                 h = v[31601];
                                 v[31601] = 0;
                                 if ((h | 0) == 1) {
                                  break v;
                                 }
                                 v[31601] = 0;
                                 R(1010, c | 0, 8964, a | 0);
                                 h = v[31601];
                                 v[31601] = 0;
                                 if ((h | 0) == 1) {
                                  break u;
                                 }
                                 v[31601] = 0;
                                 N(178, d | 0, c | 0);
                                 h = v[31601];
                                 v[31601] = 0;
                                 if ((h | 0) == 1) {
                                  break t;
                                 }
                                 sb(c);
                                 sb(a);
                                }
                                if (!Hd(w[b + 80 | 0])) {
                                 break p;
                                }
                                v[31601] = 0;
                                c = O(36, b + 40 | 0, 12838) | 0;
                                a = v[31601];
                                v[31601] = 0;
                                if ((a | 0) == 1) {
                                 break r;
                                }
                                v[31601] = 0;
                                N(178, d | 0, c | 0);
                                a = v[31601];
                                v[31601] = 0;
                                if ((a | 0) == 1) {
                                 break q;
                                }
                                sb(c);
                                break o;
                               }
                               a = M() | 0;
                               break h;
                              }
                              a = M() | 0;
                              break i;
                             }
                             a = M() | 0;
                             sb(b + 52 | 0);
                             break i;
                            }
                            a = M() | 0;
                            break i;
                           }
                           a = M() | 0;
                           break i;
                          }
                          a = M() | 0;
                          sb(b + 52 | 0);
                          break i;
                         }
                         a = M() | 0;
                         break i;
                        }
                        a = M() | 0;
                        sb(b + 52 | 0);
                        break i;
                       }
                       a = M() | 0;
                       break j;
                      }
                      a = M() | 0;
                      break s;
                     }
                     a = M() | 0;
                     sb(b + 40 | 0);
                    }
                    sb(b + 28 | 0);
                    break j;
                   }
                   a = M() | 0;
                   break j;
                  }
                  a = M() | 0;
                  sb(c);
                  break j;
                 }
                 if (!Hd(w[b + 81 | 0])) {
                  break o;
                 }
                 v[31601] = 0;
                 c = O(36, b + 40 | 0, 12609) | 0;
                 a = v[31601];
                 v[31601] = 0;
                 if ((a | 0) == 1) {
                  break n;
                 }
                 v[31601] = 0;
                 N(178, d | 0, c | 0);
                 a = v[31601];
                 v[31601] = 0;
                 if ((a | 0) == 1) {
                  break m;
                 }
                 sb(c);
                }
                if (Hd(w[b + 82 | 0])) {
                 break l;
                }
                break k;
               }
               a = M() | 0;
               break j;
              }
              a = M() | 0;
              sb(c);
              break j;
             }
             v[31601] = 0;
             c = O(36, b + 28 | 0, 11128) | 0;
             a = v[31601];
             v[31601] = 0;
             D: {
              if ((a | 0) != 1) {
               v[31601] = 0;
               N(178, d | 0, c | 0);
               a = v[31601];
               v[31601] = 0;
               if ((a | 0) == 1) {
                break D;
               }
               sb(c);
               break k;
              }
              a = M() | 0;
              break j;
             }
             a = M() | 0;
             sb(c);
             break j;
            }
            if (lc(v[d >> 2], v[d + 4 >> 2])) {
             break g;
            }
            v[31601] = 0;
            f = O(984, f | 0, 16800) | 0;
            a = v[31601];
            v[31601] = 0;
            if ((a | 0) != 1) {
             v[31601] = 0;
             c = O(36, b + 4 | 0, 16770) | 0;
             a = v[31601];
             v[31601] = 0;
             E: {
              F: {
               G: {
                if ((a | 0) != 1) {
                 v[31601] = 0;
                 a = b + 16 | 0;
                 R(1117, a | 0, d | 0, c | 0);
                 h = v[31601];
                 v[31601] = 0;
                 if ((h | 0) == 1) {
                  break G;
                 }
                 v[31601] = 0;
                 O(837, f | 0, a | 0) | 0;
                 f = v[31601];
                 v[31601] = 0;
                 if ((f | 0) == 1) {
                  break F;
                 }
                 sb(a);
                 sb(c);
                 break g;
                }
                a = M() | 0;
                break j;
               }
               a = M() | 0;
               break E;
              }
              a = M() | 0;
              sb(b + 16 | 0);
             }
             sb(c);
             break j;
            }
            a = M() | 0;
           }
           Sd(d);
          }
          wg(b - -64 | 0);
         }
         sb(g);
         break a;
        }
        Sd(d);
        wg(b - -64 | 0);
        eb = b + 96 | 0;
        break f;
       }
       if (Md(b, 8132)) {
        v[j >> 2] = 0;
        br(a, j);
        break f;
       }
       if (Md(b, 8110)) {
        v[j >> 2] = 7;
        br(a, j);
        break f;
       }
       if (Md(b, 10853)) {
        v[j >> 2] = 4;
        br(a, j);
        break f;
       }
       if (Md(b, 10625)) {
        Cc(a, 15486);
        break f;
       }
       if (Md(b, 11403)) {
        Cc(a, 15833);
        break f;
       }
       if (Md(b, 7412)) {
        b = eb - 48 | 0;
        eb = b;
        d = b + 24 | 0;
        MG(d);
        v[31601] = 0;
        c = b + 12 | 0;
        V(145, c | 0);
        g = v[31601];
        v[31601] = 0;
        H: {
         I: {
          J: {
           K: {
            if ((g | 0) != 1) {
             v[31601] = 0;
             g = b + 36 | 0;
             R(146, g | 0, d | 0, c | 0);
             f = v[31601];
             v[31601] = 0;
             if ((f | 0) == 1) {
              break K;
             }
             v[31601] = 0;
             N(1058, a | 0, g | 0);
             a = v[31601];
             v[31601] = 0;
             if ((a | 0) == 1) {
              break J;
             }
             sb(g);
             sb(c);
             sb(d);
             eb = b + 48 | 0;
             break f;
            }
            a = M() | 0;
            break H;
           }
           a = M() | 0;
           break I;
          }
          a = M() | 0;
          sb(b + 36 | 0);
         }
         sb(b + 12 | 0);
        }
        sb(b + 24 | 0);
        break a;
       }
       if (Md(b, 9909)) {
        b = eb - 16 | 0;
        eb = b;
        f = eb - 16 | 0;
        eb = f;
        v[f + 12 >> 2] = 101;
        h = b + 4 | 0;
        d = eb - 96 | 0;
        eb = d;
        g = Mb(d + 84 | 0);
        L: {
         M: {
          N: {
           O: {
            P: {
             Q: {
              R: {
               S: {
                T: {
                 U: {
                  V: {
                   W: {
                    X: {
                     Y: {
                      Z: {
                       _: {
                        c = v[f + 12 >> 2];
                        if (c & 1) {
                         v[31601] = 0;
                         c = d + 52 | 0;
                         N(134, c | 0, 19989505);
                         e = v[31601];
                         v[31601] = 0;
                         if ((e | 0) == 1) {
                          break _;
                         }
                         v[31601] = 0;
                         N(101, g | 0, c | 0);
                         e = v[31601];
                         v[31601] = 0;
                         if ((e | 0) == 1) {
                          break Z;
                         }
                         sb(c);
                         c = v[f + 12 >> 2];
                        }
                        if (!(c & 4)) {
                         break X;
                        }
                        v[31601] = 0;
                        c = ba(135) | 0;
                        e = v[31601];
                        v[31601] = 0;
                        if ((e | 0) == 1) {
                         break W;
                        }
                        if (!c) {
                         break Y;
                        }
                        break X;
                       }
                       c = M() | 0;
                       break M;
                      }
                      c = M() | 0;
                      sb(d + 52 | 0);
                      break M;
                     }
                     v[31601] = 0;
                     c = d + 52 | 0;
                     V(136, c | 0);
                     e = v[31601];
                     v[31601] = 0;
                     $: {
                      if ((e | 0) != 1) {
                       v[31601] = 0;
                       N(101, g | 0, c | 0);
                       e = v[31601];
                       v[31601] = 0;
                       if ((e | 0) == 1) {
                        break $;
                       }
                       sb(c);
                       break X;
                      }
                      c = M() | 0;
                      break M;
                     }
                     c = M() | 0;
                     sb(d + 52 | 0);
                     break M;
                    }
                    aa: {
                     c = v[f + 12 >> 2];
                     if (!(c & 32)) {
                      break aa;
                     }
                     v[31601] = 0;
                     e = d + 52 | 0;
                     V(128, e | 0);
                     c = v[31601];
                     v[31601] = 0;
                     ba: {
                      ca: {
                       da: {
                        ea: {
                         fa: {
                          ga: {
                           ha: {
                            ia: {
                             ja: {
                              ka: {
                               la: {
                                ma: {
                                 na: {
                                  oa: {
                                   pa: {
                                    qa: {
                                     ra: {
                                      sa: {
                                       ta: {
                                        if ((c | 0) != 1) {
                                         v[31601] = 0;
                                         c = d + 40 | 0;
                                         N(137, c | 0, e | 0);
                                         i = v[31601];
                                         v[31601] = 0;
                                         if ((i | 0) == 1) {
                                          break ca;
                                         }
                                         i = zd(v[d + 44 >> 2], w[d + 51 | 0]);
                                         sb(c);
                                         if (!i) {
                                          v[31601] = 0;
                                          i = d + 28 | 0;
                                          V(138, i | 0);
                                          k = v[31601];
                                          v[31601] = 0;
                                          if ((k | 0) == 1) {
                                           break ta;
                                          }
                                          v[31601] = 0;
                                          k = d + 16 | 0;
                                          N(137, k | 0, e | 0);
                                          e = v[31601];
                                          v[31601] = 0;
                                          if ((e | 0) == 1) {
                                           break sa;
                                          }
                                          v[31601] = 0;
                                          R(139, c | 0, i | 0, k | 0);
                                          e = v[31601];
                                          v[31601] = 0;
                                          if ((e | 0) == 1) {
                                           break ra;
                                          }
                                          v[31601] = 0;
                                          N(101, g | 0, c | 0);
                                          e = v[31601];
                                          v[31601] = 0;
                                          if ((e | 0) == 1) {
                                           break qa;
                                          }
                                          sb(c);
                                          sb(k);
                                          Db(i);
                                         }
                                         c = Np(d + 52 | 0);
                                         if (!zd(v[c + 4 >> 2], w[c + 11 | 0])) {
                                          v[31601] = 0;
                                          e = d + 28 | 0;
                                          V(140, e | 0);
                                          i = v[31601];
                                          v[31601] = 0;
                                          if ((i | 0) == 1) {
                                           break na;
                                          }
                                          v[31601] = 0;
                                          i = d + 40 | 0;
                                          R(141, i | 0, e | 0, c | 0);
                                          c = v[31601];
                                          v[31601] = 0;
                                          if ((c | 0) == 1) {
                                           break ma;
                                          }
                                          v[31601] = 0;
                                          N(101, g | 0, i | 0);
                                          c = v[31601];
                                          v[31601] = 0;
                                          if ((c | 0) == 1) {
                                           break la;
                                          }
                                          sb(i);
                                          Db(e);
                                         }
                                         v[31601] = 0;
                                         c = d + 40 | 0;
                                         k = d + 52 | 0;
                                         N(142, c | 0, k | 0);
                                         e = v[31601];
                                         v[31601] = 0;
                                         if ((e | 0) == 1) {
                                          break ja;
                                         }
                                         e = zd(v[d + 44 >> 2], w[d + 51 | 0]);
                                         sb(c);
                                         if (!e) {
                                          v[31601] = 0;
                                          e = d + 28 | 0;
                                          V(138, e | 0);
                                          i = v[31601];
                                          v[31601] = 0;
                                          if ((i | 0) == 1) {
                                           break ia;
                                          }
                                          v[31601] = 0;
                                          i = d + 16 | 0;
                                          N(142, i | 0, k | 0);
                                          k = v[31601];
                                          v[31601] = 0;
                                          if ((k | 0) == 1) {
                                           break ha;
                                          }
                                          v[31601] = 0;
                                          R(139, c | 0, e | 0, i | 0);
                                          k = v[31601];
                                          v[31601] = 0;
                                          if ((k | 0) == 1) {
                                           break ga;
                                          }
                                          v[31601] = 0;
                                          N(101, g | 0, c | 0);
                                          k = v[31601];
                                          v[31601] = 0;
                                          if ((k | 0) == 1) {
                                           break fa;
                                          }
                                          sb(c);
                                          sb(i);
                                          Db(e);
                                         }
                                         wg(d + 52 | 0);
                                         c = v[f + 12 >> 2];
                                         break aa;
                                        }
                                        c = M() | 0;
                                        break M;
                                       }
                                       c = M() | 0;
                                       break ba;
                                      }
                                      c = M() | 0;
                                      break oa;
                                     }
                                     c = M() | 0;
                                     break pa;
                                    }
                                    c = M() | 0;
                                    sb(d + 40 | 0);
                                   }
                                   sb(d + 16 | 0);
                                  }
                                  Db(d + 28 | 0);
                                  break ba;
                                 }
                                 c = M() | 0;
                                 break ba;
                                }
                                c = M() | 0;
                                break ka;
                               }
                               c = M() | 0;
                               sb(d + 40 | 0);
                              }
                              Db(d + 28 | 0);
                              break ba;
                             }
                             c = M() | 0;
                             break ba;
                            }
                            c = M() | 0;
                            break ba;
                           }
                           c = M() | 0;
                           break da;
                          }
                          c = M() | 0;
                          break ea;
                         }
                         c = M() | 0;
                         sb(d + 40 | 0);
                        }
                        sb(d + 16 | 0);
                       }
                       Db(d + 28 | 0);
                       break ba;
                      }
                      c = M() | 0;
                     }
                     wg(d + 52 | 0);
                     break M;
                    }
                    ua: {
                     if (!(c & 64)) {
                      break ua;
                     }
                     v[31601] = 0;
                     c = ba(135) | 0;
                     e = v[31601];
                     v[31601] = 0;
                     if ((e | 0) == 1) {
                      break W;
                     }
                     if (c) {
                      break ua;
                     }
                     c = d + 52 | 0;
                     Eb(c);
                     v[31601] = 0;
                     N(101, g | 0, c | 0);
                     e = v[31601];
                     v[31601] = 0;
                     if ((e | 0) == 1) {
                      break N;
                     }
                     sb(c);
                    }
                    if (w[f + 12 | 0] & 128) {
                     v[31601] = 0;
                     c = d + 52 | 0;
                     V(143, c | 0);
                     e = v[31601];
                     v[31601] = 0;
                     if ((e | 0) == 1) {
                      break V;
                     }
                     v[31601] = 0;
                     N(101, g | 0, c | 0);
                     e = v[31601];
                     v[31601] = 0;
                     if ((e | 0) == 1) {
                      break U;
                     }
                     sb(c);
                    }
                    v[31601] = 0;
                    e = O(1, d + 52 | 0, 22256) | 0;
                    c = v[31601];
                    v[31601] = 0;
                    if ((c | 0) == 1) {
                     break T;
                    }
                    v[31601] = 0;
                    c = d + 4 | 0;
                    R(144, c | 0, g | 0, e | 0);
                    i = v[31601];
                    v[31601] = 0;
                    if ((i | 0) == 1) {
                     break S;
                    }
                    v[31601] = 0;
                    i = d + 40 | 0;
                    V(145, i | 0);
                    k = v[31601];
                    v[31601] = 0;
                    if ((k | 0) == 1) {
                     break R;
                    }
                    v[31601] = 0;
                    R(146, h | 0, c | 0, i | 0);
                    k = v[31601];
                    v[31601] = 0;
                    if ((k | 0) == 1) {
                     break Q;
                    }
                    sb(i);
                    sb(c);
                    sb(e);
                    Sd(g);
                    eb = d + 96 | 0;
                    break L;
                   }
                   c = M() | 0;
                   break M;
                  }
                  c = M() | 0;
                  break M;
                 }
                 c = M() | 0;
                 sb(d + 52 | 0);
                 break M;
                }
                c = M() | 0;
                break M;
               }
               c = M() | 0;
               break O;
              }
              c = M() | 0;
              break P;
             }
             c = M() | 0;
             sb(d + 40 | 0);
            }
            sb(d + 4 | 0);
           }
           sb(e);
           break M;
          }
          c = M() | 0;
          sb(d + 52 | 0);
         }
         Sd(g);
         P(c | 0);
         p();
        }
        eb = f + 16 | 0;
        v[31601] = 0;
        N(1058, a | 0, h | 0);
        a = v[31601];
        v[31601] = 0;
        if ((a | 0) != 1) {
         sb(h);
         eb = b + 16 | 0;
         break f;
        }
        break c;
       }
       if (Md(b, 10525)) {
        b = eb - 48 | 0;
        eb = b;
        d = b + 4 | 0;
        us(d);
        v[31601] = 0;
        c = b + 36 | 0;
        N(137, c | 0, d | 0);
        g = v[31601];
        v[31601] = 0;
        va: {
         wa: {
          if ((g | 0) != 1) {
           v[31601] = 0;
           N(1058, a | 0, c | 0);
           a = v[31601];
           v[31601] = 0;
           if ((a | 0) == 1) {
            break wa;
           }
           sb(c);
           wg(d);
           eb = b + 48 | 0;
           break f;
          }
          a = M() | 0;
          break va;
         }
         a = M() | 0;
         sb(b + 36 | 0);
        }
        wg(b + 4 | 0);
        break a;
       }
       if (Md(b, 11366)) {
        b = eb - 32 | 0;
        eb = b;
        us(b);
        v[31601] = 0;
        N(1118, a | 0, Np(b) | 0);
        a = v[31601];
        v[31601] = 0;
        if ((a | 0) != 1) {
         wg(b);
         eb = b + 32 | 0;
         break f;
        }
        a = M() | 0;
        wg(b);
        break a;
       }
       if (Md(b, 9922)) {
        b = eb - 48 | 0;
        eb = b;
        d = b + 16 | 0;
        us(d);
        c = v[b + 28 >> 2];
        xa: {
         if (c) {
          v[31601] = 0;
          v[b + 12 >> 2] = c;
          N(1116, a | 0, b + 12 | 0);
          a = v[31601];
          v[31601] = 0;
          if ((a | 0) != 1) {
           break xa;
          }
          a = M() | 0;
          wg(d);
          break a;
         }
         Eb(a);
        }
        wg(b + 16 | 0);
        eb = b + 48 | 0;
        break f;
       }
       if (Md(b, 12828)) {
        us(j);
        b = w[j + 16 | 0];
        v[31601] = 0;
        O(36, a | 0, (Hd(b) ? 15530 : 15833) | 0) | 0;
        a = v[31601];
        v[31601] = 0;
        if ((a | 0) == 1) {
         break e;
        }
        wg(j);
        break f;
       }
       if (Md(b, 9938)) {
        us(j);
        b = w[j + 17 | 0];
        v[31601] = 0;
        O(36, a | 0, (Hd(b) ? 15530 : 15833) | 0) | 0;
        a = v[31601];
        v[31601] = 0;
        if ((a | 0) != 1) {
         wg(j);
         break f;
        }
        break e;
       }
       if (Md(b, 12281)) {
        us(j);
        b = w[j + 18 | 0];
        v[31601] = 0;
        O(36, a | 0, (Hd(b) ? 15530 : 15833) | 0) | 0;
        a = v[31601];
        v[31601] = 0;
        if ((a | 0) != 1) {
         wg(j);
         break f;
        }
        break e;
       }
       if (Md(b, 12583)) {
        b = eb - 16 | 0;
        eb = b;
        d = eb - 32 | 0;
        eb = d;
        g = b + 4 | 0;
        c = Eb(g);
        v[31601] = 0;
        V(128, d | 0);
        f = v[31601];
        v[31601] = 0;
        ya: {
         za: {
          if ((f | 0) != 1) {
           v[31601] = 0;
           N(129, c | 0, Np(d) | 0);
           f = v[31601];
           v[31601] = 0;
           if ((f | 0) == 1) {
            break za;
           }
           wg(d);
           eb = d + 32 | 0;
           break ya;
          }
          a = M() | 0;
          break b;
         }
         a = M() | 0;
         wg(d);
         break b;
        }
        v[31601] = 0;
        N(1058, a | 0, g | 0);
        a = v[31601];
        v[31601] = 0;
        if ((a | 0) != 1) {
         sb(g);
         eb = b + 16 | 0;
         break f;
        }
        break c;
       }
       if (Md(b, 8253)) {
        b = eb - 16 | 0;
        eb = b;
        d = eb - 48 | 0;
        eb = d;
        g = b + 4 | 0;
        c = Eb(g);
        v[31601] = 0;
        f = d + 24 | 0;
        N(131, f | 0, 4135);
        h = v[31601];
        v[31601] = 0;
        Aa: {
         Ba: {
          Ca: {
           Da: {
            if ((h | 0) != 1) {
             v[d + 20 >> 2] = 19;
             v[d + 16 >> 2] = 0;
             v[31601] = 0;
             v[d + 12 >> 2] = 0;
             h = d + 36 | 0;
             $(132, h | 0, f | 0, d + 20 | 0, d + 16 | 0, d + 12 | 0);
             e = v[31601];
             v[31601] = 0;
             if ((e | 0) == 1) {
              break Da;
             }
             v[31601] = 0;
             O(74, c | 0, h | 0) | 0;
             e = v[31601];
             v[31601] = 0;
             if ((e | 0) == 1) {
              break Ca;
             }
             sb(h);
             Db(f);
             eb = d + 48 | 0;
             break Aa;
            }
            a = M() | 0;
            break b;
           }
           a = M() | 0;
           break Ba;
          }
          a = M() | 0;
          sb(d + 36 | 0);
         }
         Db(d + 24 | 0);
         break b;
        }
        v[31601] = 0;
        N(1058, a | 0, g | 0);
        a = v[31601];
        v[31601] = 0;
        if ((a | 0) != 1) {
         sb(g);
         eb = b + 16 | 0;
         break f;
        }
        break c;
       }
       if (Md(b, 6857)) {
        b = eb - 16 | 0;
        eb = b;
        c = b + 4 | 0;
        d = eb - 32 | 0;
        eb = d;
        g = d + 8 | 0;
        Cc(g, 20179);
        v[31601] = 0;
        f = d + 20 | 0;
        R(123, f | 0, 0, g | 0);
        h = v[31601];
        v[31601] = 0;
        Ea: {
         Fa: {
          Ga: {
           if ((h | 0) != 1) {
            v[31601] = 0;
            N(12, c | 0, f | 0);
            h = v[31601];
            v[31601] = 0;
            if ((h | 0) == 1) {
             break Ga;
            }
            Tb(f);
            sb(g);
            eb = d + 32 | 0;
            break Ea;
           }
           a = M() | 0;
           break Fa;
          }
          a = M() | 0;
          Tb(d + 20 | 0);
         }
         sb(d + 8 | 0);
         break a;
        }
        v[31601] = 0;
        N(1058, a | 0, c | 0);
        a = v[31601];
        v[31601] = 0;
        if ((a | 0) != 1) {
         sb(c);
         eb = b + 16 | 0;
         break f;
        }
        break c;
       }
       if (Md(b, 6455)) {
        b = eb - 48 | 0;
        eb = b;
        d = tc(b + 24 | 0, 18263);
        v[31601] = 0;
        c = b + 12 | 0;
        N(1119, c | 0, 2);
        g = v[31601];
        v[31601] = 0;
        Ha: {
         Ia: {
          Ja: {
           Ka: {
            if ((g | 0) != 1) {
             v[31601] = 0;
             g = b + 36 | 0;
             R(2, g | 0, d | 0, c | 0);
             f = v[31601];
             v[31601] = 0;
             if ((f | 0) == 1) {
              break Ka;
             }
             v[31601] = 0;
             N(1058, a | 0, g | 0);
             a = v[31601];
             v[31601] = 0;
             if ((a | 0) == 1) {
              break Ja;
             }
             sb(g);
             sb(c);
             sb(d);
             eb = b + 48 | 0;
             break f;
            }
            a = M() | 0;
            break Ha;
           }
           a = M() | 0;
           break Ia;
          }
          a = M() | 0;
          sb(b + 36 | 0);
         }
         sb(b + 12 | 0);
        }
        sb(d);
        break a;
       }
       if (Md(b, 11389)) {
        b = eb - 16 | 0;
        eb = b;
        d = eb - 16 | 0;
        eb = d;
        Cc(d + 4 | 0, 18579);
        f = b + 4 | 0;
        g = Eb(f);
        h = w[d + 15 | 0];
        e = v[d + 8 >> 2];
        v[31601] = 0;
        N(93, g | 0, xh(e, h) | 0);
        h = v[31601];
        v[31601] = 0;
        La: {
         if ((h | 0) != 1) {
          Ma: {
           while (1) {
            if (xh(v[d + 8 >> 2], w[d + 15 | 0]) >>> 0 > c >>> 0) {
             h = w[dc(d + 4 | 0, c) | 0];
             v[31601] = 0;
             N(95, g | 0, h | 0);
             h = v[31601];
             v[31601] = 0;
             if ((h | 0) == 1) {
              break Ma;
             }
             c = c + 1 | 0;
             continue;
            }
            break;
           }
           sb(d + 4 | 0);
           eb = d + 16 | 0;
           break La;
          }
         }
         a = M() | 0;
         sb(g);
         sb(d + 4 | 0);
         break a;
        }
        v[31601] = 0;
        N(1058, a | 0, f | 0);
        a = v[31601];
        v[31601] = 0;
        if ((a | 0) != 1) {
         sb(f);
         eb = b + 16 | 0;
         break f;
        }
        break c;
       }
       if (Md(b, 10532)) {
        b = eb - 16 | 0;
        eb = b;
        d = b + 4 | 0;
        qs(d, 0);
        v[31601] = 0;
        N(1058, a | 0, d | 0);
        a = v[31601];
        v[31601] = 0;
        if ((a | 0) != 1) {
         sb(d);
         eb = b + 16 | 0;
         break f;
        }
        break c;
       }
       if (Md(b, 10507)) {
        b = eb - 16 | 0;
        eb = b;
        d = b + 4 | 0;
        qs(d, 2);
        v[31601] = 0;
        N(1058, a | 0, d | 0);
        a = v[31601];
        v[31601] = 0;
        if ((a | 0) != 1) {
         sb(d);
         eb = b + 16 | 0;
         break f;
        }
        break c;
       }
       if (Md(b, 10492)) {
        b = eb - 16 | 0;
        eb = b;
        d = b + 4 | 0;
        qs(d, 3);
        v[31601] = 0;
        N(1058, a | 0, d | 0);
        a = v[31601];
        v[31601] = 0;
        if ((a | 0) != 1) {
         sb(d);
         eb = b + 16 | 0;
         break f;
        }
        break c;
       }
       Eb(a);
      }
      eb = j + 32 | 0;
      break d;
     }
     a = M() | 0;
     wg(j);
     break a;
    }
    return;
   }
   a = M() | 0;
   sb(b + 4 | 0);
   break a;
  }
  sb(c);
 }
 P(a | 0);
 p();
}

function Loa(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, q = 0, r = 0, s = 0, y = 0, z = 0, A = 0, C = 0, D = 0, E = 0, F = 0;
 e = eb - 304 | 0;
 eb = e;
 xc(b);
 a: {
  b: {
   f = e + 208 | 0;
   c: {
    if (!Ev(b, f)) {
     break c;
    }
    if (!RW(f)) {
     break c;
    }
    if (!Lb(v[b >> 2], v[b + 8 >> 2], Ac(QW(f), gb))) {
     break c;
    }
    d = 1;
    if ((c | 0) == 64) {
     break c;
    }
    Cd(a, 2);
    v[a + 480260 >> 2] = 64;
    v[a + 480264 >> 2] = 32767;
    i = Eb(e + 196 | 0);
    d = w[e + 248 | 0] | w[e + 249 | 0] << 8;
    j = (d | 0) == 20479 ? w[e + 262 | 0] | w[e + 263 | 0] << 8 : d - 16464 | 0;
    d: {
     e: {
      f: {
       g: {
        h: {
         i: {
          switch (d >>> 12 | 0) {
          case 0:
           f = 0;
           if ((d | 0) != 520) {
            break d;
           }
           v[31601] = 0;
           d = O(1, e + 184 | 0, 12377) | 0;
           g = v[31601];
           v[31601] = 0;
           if ((g | 0) != 1) {
            yb(i, d);
            break e;
           }
           b = M() | 0;
           break a;

          case 1:
           j: {
            if ((d | 0) != 4896) {
             break j;
            }
            d = w[e + 270 | 0] | w[e + 271 | 0] << 8;
            if (d) {
             break j;
            }
            if (!((w[e + 246 | 0] | w[e + 247 | 0] << 8) & 65455 | (w[e + 260 | 0] | w[e + 240 | 0] & 15))) {
             k: {
              if (t[e + 259 | 0] < 0) {
               v[a + 1074308 >> 2] = 18219008;
               v[31601] = 0;
               d = O(1, e + 184 | 0, 14760) | 0;
               f = v[31601];
               v[31601] = 0;
               if ((f | 0) != 1) {
                break k;
               }
               b = M() | 0;
               break a;
              }
              v[a + 1074308 >> 2] = 16777216;
              v[31601] = 0;
              d = O(1, e + 184 | 0, 13445) | 0;
              f = v[31601];
              v[31601] = 0;
              if ((f | 0) == 1) {
               break h;
              }
             }
             yb(i, d);
             sb(d);
             v[31601] = 0;
             f = 1;
             T(266, a + 1074312 | 0, 81, 1) | 0;
             d = v[31601];
             v[31601] = 0;
             g = 1;
             if ((d | 0) != 1) {
              break d;
             }
             break b;
            }
            if (w[e + 260 | 0] | d | (w[e + 261 | 0] | (w[e + 246 | 0] | w[e + 247 | 0] << 8))) {
             break j;
            }
            f = 0;
            v[31601] = 0;
            d = O(1, e + 184 | 0, 9476) | 0;
            g = v[31601];
            v[31601] = 0;
            if ((g | 0) != 1) {
             yb(i, d);
             break e;
            }
            b = M() | 0;
            break a;
           }
           v[31601] = 0;
           d = O(1, e + 184 | 0, 8494) | 0;
           f = v[31601];
           v[31601] = 0;
           l = 1;
           if ((f | 0) != 1) {
            yb(i, d);
            sb(d);
            break f;
           }
           b = M() | 0;
           break a;

          case 2:
           v[31601] = 0;
           d = O(1, e + 184 | 0, 6808) | 0;
           f = v[31601];
           v[31601] = 0;
           g = 1;
           if ((f | 0) != 1) {
            yb(i, d);
            sb(d);
            break f;
           }
           b = M() | 0;
           break a;

          case 3:
           l: {
            m: {
             n: {
              o: {
               if (d >>> 0 <= 12820) {
                v[31601] = 0;
                f = O(1, e + 184 | 0, 8557) | 0;
                g = v[31601];
                v[31601] = 0;
                if ((g | 0) != 1) {
                 yb(i, f);
                 sb(f);
                 break o;
                }
                b = M() | 0;
                break a;
               }
               v[31601] = 0;
               f = e + 184 | 0;
               N(445, f | 0, 4015);
               g = v[31601];
               v[31601] = 0;
               if ((g | 0) == 1) {
                break n;
               }
               v[31601] = 0;
               v[e + 172 >> 2] = (w[e + 248 | 0] | w[e + 249 | 0] << 8) - 12820;
               g = e + 48 | 0;
               R(446, g | 0, f | 0, e + 172 | 0);
               h = v[31601];
               v[31601] = 0;
               if ((h | 0) == 1) {
                break m;
               }
               yb(i, g);
               sb(g);
               Db(f);
              }
              f = w[e + 248 | 0] | w[e + 249 | 0] << 8;
              if (f >>> 0 < 12807) {
               break g;
              }
              g = w[e + 264 | 0] | w[e + 265 | 0] << 8 | (w[e + 266 | 0] << 16 | w[e + 267 | 0] << 24);
              if (g) {
               break l;
              }
              break g;
             }
             b = M() | 0;
             break a;
            }
            b = M() | 0;
            Db(e + 184 | 0);
            break a;
           }
           f = GF(f, g);
           g = kp(e + 48 | 0);
           v[g + 32 >> 2] = f;
           v[31601] = 0;
           N(447, a + 1298412 | 0, g | 0);
           f = v[31601];
           v[31601] = 0;
           if ((f | 0) != 1) {
            break g;
           }
           b = M() | 0;
           break a;

          case 4:
           if ((d | 0) == 16640) {
            f = 0;
            v[31601] = 0;
            d = O(1, e + 184 | 0, 8340) | 0;
            h = v[31601];
            v[31601] = 0;
            g = 1;
            if ((h | 0) != 1) {
             yb(i, d);
             sb(d);
             v[31601] = 0;
             T(266, a + 1074312 | 0, 81, 1) | 0;
             d = v[31601];
             v[31601] = 0;
             h = 0;
             if ((d | 0) == 1) {
              break b;
             }
             break d;
            }
            b = M() | 0;
            break a;
           }
           v[31601] = 0;
           f = e + 48 | 0;
           R(442, f | 0, d | 0, w[e + 262 | 0] | w[e + 263 | 0] << 8);
           d = v[31601];
           v[31601] = 0;
           p: {
            q: {
             r: {
              if ((d | 0) != 1) {
               yb(i, f);
               sb(f);
               v[a + 480260 >> 2] = 1;
               if ((j | 0) < 4201) {
                break r;
               }
               v[31601] = 0;
               T(266, a + 1074312 | 0, 7, 1) | 0;
               d = v[31601];
               v[31601] = 0;
               if ((d | 0) == 1) {
                break b;
               }
               break q;
              }
              b = M() | 0;
              break a;
             }
             if ((j | 0) < 2386) {
              break p;
             }
            }
            v[31601] = 0;
            T(266, a + 1074312 | 0, 38, 1) | 0;
            d = v[31601];
            v[31601] = 0;
            if ((d | 0) == 1) {
             break b;
            }
           }
           f = 0;
           v[31601] = 0;
           O(267, a + 1074312 | 0, 118) | 0;
           d = v[31601];
           v[31601] = 0;
           g = 1;
           h = 1;
           if ((d | 0) == 1) {
            break b;
           }
           break d;

          case 5:
           if ((d | 0) != 21575) {
            d = d & 4095;
            v[a + 1074308 >> 2] = d << 16 | (d >>> 0 > 296 ? w[e + 262 | 0] | w[e + 263 | 0] << 8 : 0) & 65535;
            v[31601] = 0;
            d = O(1, e + 184 | 0, 18226) | 0;
            f = v[31601];
            v[31601] = 0;
            s: {
             t: {
              u: {
               if ((f | 0) != 1) {
                f = v[a + 1074308 >> 2];
                v[31601] = 0;
                g = e + 172 | 0;
                N(134, g | 0, f | 0);
                f = v[31601];
                v[31601] = 0;
                if ((f | 0) == 1) {
                 break u;
                }
                f = 0;
                v[31601] = 0;
                h = e + 48 | 0;
                R(2, h | 0, d | 0, g | 0);
                l = v[31601];
                v[31601] = 0;
                if ((l | 0) == 1) {
                 break t;
                }
                yb(i, h);
                sb(h);
                sb(g);
                break e;
               }
               b = M() | 0;
               break a;
              }
              b = M() | 0;
              break s;
             }
             b = M() | 0;
             sb(e + 172 | 0);
            }
            sb(d);
            break a;
           }
           f = 0;
           v[31601] = 0;
           d = O(1, e + 184 | 0, 8541) | 0;
           g = v[31601];
           v[31601] = 0;
           if ((g | 0) != 1) {
            yb(i, d);
            break e;
           }
           b = M() | 0;
           break a;

          case 6:
           f = 0;
           v[31601] = 0;
           d = O(1, e + 184 | 0, 8340) | 0;
           g = v[31601];
           v[31601] = 0;
           if ((g | 0) != 1) {
            yb(i, d);
            sb(d);
            v[31601] = 0;
            T(266, a + 1074312 | 0, 81, 1) | 0;
            d = v[31601];
            v[31601] = 0;
            g = 0;
            if ((d | 0) == 1) {
             break b;
            }
            break d;
           }
           b = M() | 0;
           break a;

          case 7:
           f = 0;
           v[31601] = 0;
           d = O(1, e + 184 | 0, 8352) | 0;
           g = v[31601];
           v[31601] = 0;
           if ((g | 0) != 1) {
            yb(i, d);
            break e;
           }
           b = M() | 0;
           break a;

          default:
           break i;
          }
         }
         f = 0;
         if ((d | 0) != 51712) {
          break d;
         }
         v[31601] = 0;
         d = O(1, e + 184 | 0, 9275) | 0;
         g = v[31601];
         v[31601] = 0;
         if ((g | 0) != 1) {
          yb(i, d);
          break e;
         }
         b = M() | 0;
         break a;
        }
        b = M() | 0;
        break a;
       }
       v[31601] = 0;
       f = T(266, a + 1074312 | 0, 7, 1) | 0;
       g = v[31601];
       v[31601] = 0;
       if ((g | 0) == 1) {
        break b;
       }
       v[31601] = 0;
       f = T(266, f | 0, 23, 1) | 0;
       g = v[31601];
       v[31601] = 0;
       if ((g | 0) == 1) {
        break b;
       }
       v[31601] = 0;
       f = T(266, f | 0, 38, 1) | 0;
       g = v[31601];
       v[31601] = 0;
       if ((g | 0) == 1) {
        break b;
       }
       v[31601] = 0;
       T(266, f | 0, 107, 1) | 0;
       f = v[31601];
       v[31601] = 0;
       if ((f | 0) == 1) {
        break b;
       }
       g = 1;
       v[a + 480260 >> 2] = 1;
       f = 0;
       h = 0;
       if (d >>> 0 > 12820) {
        break d;
       }
      }
      v[31601] = 0;
      d = e + 172 | 0;
      V(693, d | 0);
      f = v[31601];
      v[31601] = 0;
      v: {
       w: {
        x: {
         if ((f | 0) != 1) {
          f = w[e + 248 | 0] | w[e + 249 | 0] << 8;
          v[e + 148 >> 2] = f >>> 8 & 15;
          v[31601] = 0;
          v[e + 132 >> 2] = f & 255;
          h = e + 160 | 0;
          N(444, h | 0, e + 132 | 0);
          f = v[31601];
          v[31601] = 0;
          if ((f | 0) == 1) {
           break x;
          }
          f = 0;
          v[31601] = 0;
          k = e + 48 | 0;
          $(694, k | 0, d | 0, i | 0, e + 148 | 0, h | 0);
          n = v[31601];
          v[31601] = 0;
          if ((n | 0) == 1) {
           break w;
          }
          yb(i, k);
          sb(k);
          sb(h);
          Db(d);
          h = 0;
          break d;
         }
         b = M() | 0;
         break a;
        }
        b = M() | 0;
        break v;
       }
       b = M() | 0;
       sb(e + 160 | 0);
      }
      Db(e + 172 | 0);
      break a;
     }
     sb(d);
     g = 0;
     l = 0;
     h = 0;
    }
    v[31601] = 0;
    d = O(1, e + 172 | 0, 15021) | 0;
    k = v[31601];
    v[31601] = 0;
    y: {
     z: {
      A: {
       B: {
        C: {
         D: {
          E: {
           F: {
            if ((k | 0) != 1) {
             yb(a + 1298344 | 0, d);
             sb(d);
             v[31601] = 0;
             d = O(1, e + 160 | 0, 10474) | 0;
             k = v[31601];
             v[31601] = 0;
             if ((k | 0) == 1) {
              break F;
             }
             yb(a + 1298356 | 0, d);
             sb(d);
             o = yb(a + 1298368 | 0, i);
             E = a, F = v[Ec(e + 48 | 0, v[a + 1074308 >> 2] ? 22 : 4) >> 2], v[E + 1298404 >> 2] = F;
             if (g) {
              v[31601] = 0;
              d = O(267, a + 1074312 | 0, 77) | 0;
              g = v[31601];
              v[31601] = 0;
              if ((g | 0) == 1) {
               break b;
              }
              v[31601] = 0;
              d = O(267, d | 0, 78) | 0;
              g = v[31601];
              v[31601] = 0;
              if ((g | 0) == 1) {
               break b;
              }
              v[31601] = 0;
              d = O(267, d | 0, 79) | 0;
              g = v[31601];
              v[31601] = 0;
              if ((g | 0) == 1) {
               break b;
              }
              v[31601] = 0;
              d = O(267, d | 0, 80) | 0;
              g = v[31601];
              v[31601] = 0;
              if ((g | 0) == 1) {
               break b;
              }
              v[31601] = 0;
              d = O(267, d | 0, 82) | 0;
              g = v[31601];
              v[31601] = 0;
              if ((g | 0) == 1) {
               break b;
              }
              v[31601] = 0;
              d = O(267, d | 0, 96) | 0;
              g = v[31601];
              v[31601] = 0;
              if ((g | 0) == 1) {
               break b;
              }
              v[31601] = 0;
              O(267, d | 0, 113) | 0;
              d = v[31601];
              v[31601] = 0;
              if ((d | 0) == 1) {
               break b;
              }
             }
             d = w[e + 248 | 0] | w[e + 249 | 0] << 8;
             if (d >>> 0 <= 4865) {
              v[31601] = 0;
              O(267, a + 1074312 | 0, 118) | 0;
              d = v[31601];
              v[31601] = 0;
              if ((d | 0) == 1) {
               break b;
              }
              d = w[e + 248 | 0] | w[e + 249 | 0] << 8;
             }
             g = d & 61440;
             if (g >>> 0 >= 4097) {
              f = (g | 0) != 12288 | (d & 65535) >>> 0 > 12819 | f;
             }
             v[31601] = 0;
             d = a + 901404 | 0;
             V(695, d | 0);
             g = v[31601];
             v[31601] = 0;
             if ((g | 0) == 1) {
              break b;
             }
             if (!f) {
              lr(d);
             }
             f = e + 148 | 0;
             Ui(f, 1, e + 208 | 0);
             v[31601] = 0;
             d = e + 48 | 0;
             N(218, d | 0, f | 0);
             f = v[31601];
             v[31601] = 0;
             if ((f | 0) == 1) {
              break C;
             }
             yb(a + 1298308 | 0, d);
             sb(d);
             d = w[e + 246 | 0] | w[e + 247 | 0] << 8;
             if (d & 16) {
              v[a + 480208 >> 2] = v[a + 480208 >> 2] | 65536;
             }
             if (d & 1) {
              v[a + 480208 >> 2] = v[a + 480208 >> 2] | 131072;
             }
             f = w[e + 248 | 0] | w[e + 249 | 0] << 8;
             if (!(!(d & 64) & (f | 0) != 4864)) {
              v[a + 480208 >> 2] = v[a + 480208 >> 2] | 2;
             }
             d = w[e + 257 | 0];
             v[a + 480196 >> 2] = d;
             if (!(!l | (d | 0) != 255 ? d : 0)) {
              v[a + 480196 >> 2] = 6;
             }
             d = w[e + 258 | 0];
             v[a + 480204 >> 2] = d >>> 0 < 33 ? l ? 125e4 : 32e4 : B(d, 1e4);
             t[e + 48 | 0] = w[e + 256 | 0];
             t[e + 148 | 0] = 64;
             d = w[Pb(e + 48 | 0, e + 148 | 0) | 0];
             v[a + 480200 >> 2] = d << 2;
             if (!(d | f >>> 0 > 4895)) {
              v[a + 480200 >> 2] = 256;
             }
             g = w[e + 259 | 0];
             if ((w[e + 250 | 0] | w[e + 251 | 0] << 8) != 1 | g >>> 0 > 7) {
              break E;
             }
             v[e + 48 >> 2] = (g << 4) + 16 & 240;
             v[e + 148 >> 2] = 127;
             d = v[Bd(e + 48 | 0, e + 148 | 0) >> 2];
             break D;
            }
            b = M() | 0;
            break a;
           }
           b = M() | 0;
           break a;
          }
          d = 32;
          if ((g | 16) == 18) {
           break D;
          }
          f = g & 127;
          d = 48;
          if (!f) {
           break D;
          }
          v[e + 48 >> 2] = f;
          v[e + 148 >> 2] = 16;
          d = v[Ye(e + 48 | 0, e + 148 | 0) >> 2];
         }
         f = d;
         v[a + 480228 >> 2] = f;
         d = 0;
         k = v[a + 1074308 >> 2] != 0 | g << 24 >> 24 < 0;
         if (!k) {
          E = a, F = Ac(Cua(f << 3 | 5, f >>> 29 | 0, 11, 0), gb), v[E + 480228 >> 2] = F;
         }
         u[a + 480188 >> 1] = 4;
         v[a + 480232 >> 2] = h ? (j | 0) < 3299 ? 64 : 36 : 36;
         g = a + 480280 | 0;
         C = e + 272 | 0;
         h = sc(e + 144 | 0);
         while (1) {
          if ((d | 0) == 32) {
           if (!x[a + 480188 >> 1]) {
            u[a + 480188 >> 1] = 1;
           }
           d = w[a + 484376 | 0];
           f = v[a + 484360 >> 2];
           v[31601] = 0;
           $(348, Wb(f, d) | 0, b | 0, w[e + 240 | 0] | w[e + 241 | 0] << 8, 255, 254);
           d = v[31601];
           v[31601] = 0;
           if ((d | 0) != 1) {
            s = Mb(e + 148 | 0);
            v[31601] = 0;
            T(213, b | 0, s | 0, w[e + 242 | 0] | w[e + 243 | 0] << 8) | 0;
            d = v[31601];
            v[31601] = 0;
            if ((d | 0) != 1) {
             y = Mb(e + 132 | 0);
             v[31601] = 0;
             T(213, b | 0, y | 0, w[e + 244 | 0] | w[e + 245 | 0] << 8) | 0;
             d = v[31601];
             v[31601] = 0;
             G: {
              if ((d | 0) != 1) {
               if (w[e + 261 | 0] != 252) {
                break B;
               }
               d = 0;
               v[31601] = 0;
               N(696, b | 0, e + 48 | 0);
               f = v[31601];
               v[31601] = 0;
               if ((f | 0) == 1) {
                break G;
               }
               while (1) {
                if ((d | 0) == 32) {
                 break B;
                }
                f = w[(e + 48 | 0) + d | 0];
                H: {
                 if (!(f & 32)) {
                  break H;
                 }
                 if (l) {
                  Pc(e + 36 | 0, h, d);
                  if (Fb(v[v[e + 36 >> 2] >> 2], v[e + 40 >> 2])) {
                   break H;
                  }
                 }
                 u[(g + (d << 5) | 0) + 4 >> 1] = (((f & 15) << 8 | 8) >>> 0) / 15;
                }
                d = d + 1 | 0;
                continue;
               }
              }
              b = M() | 0;
              break A;
             }
             b = M() | 0;
             break A;
            }
            b = M() | 0;
            break z;
           }
           b = M() | 0;
           break a;
          }
          f = g + (d << 5) | 0;
          Ve(f);
          j = w[d + C | 0];
          n = j & 126;
          I: {
           if ((j | 0) != 255) {
            j = j << 24 >> 24;
            u[a + 480188 >> 1] = d + 1;
            if (k) {
             u[f + 4 >> 1] = j & 8 ? 204 : 51;
            }
            if ((j | 0) >= 0) {
             break I;
            }
           }
           v[f >> 2] = 1024;
          }
          if ((n - 16 & 255) >>> 0 <= 13) {
           u[f + 4 >> 1] = 128;
           f = e + 48 | 0;
           Pc(f, h, d);
           ap(f);
          }
          d = d + 1 | 0;
          continue;
         }
        }
        b = M() | 0;
        break a;
       }
       u[e + 48 >> 1] = w[e + 242 | 0] | w[e + 243 | 0] << 8;
       u[e + 36 >> 1] = 3999;
       f = x[Nc(e + 48 | 0, e + 36 | 0) >> 1];
       u[a + 480190 >> 1] = f;
       h = c & 2;
       z = a + 946304 | 0;
       q = a + 484380 | 0;
       r = e + 96 | 0;
       d = 0;
       j = 0;
       k = 0;
       n = 0;
       J: {
        K: {
         L: {
          M: {
           N: {
            O: {
             P: {
              Q: {
               R: {
                while (1) {
                 if ((f & 65535) >>> 0 <= d >>> 0) {
                  d = n & 65535;
                  if (!(d | !(j & l)) & (w[e + 248 | 0] | w[e + 249 | 0] << 8) != 4864) {
                   break P;
                  }
                  if (!l) {
                   break O;
                  }
                  v[31601] = 0;
                  f = T(266, a + 1074312 | 0, 79, d >>> 0 > 1 | 0) | 0;
                  g = v[31601];
                  v[31601] = 0;
                  if ((g | 0) == 1) {
                   break M;
                  }
                  v[31601] = 0;
                  g = f;
                  f = d >>> 0 < 2;
                  g = T(266, g | 0, 107, f | 0) | 0;
                  h = v[31601];
                  v[31601] = 0;
                  if ((h | 0) == 1) {
                   break M;
                  }
                  v[31601] = 0;
                  T(266, g | 0, 38, f | 0) | 0;
                  g = v[31601];
                  v[31601] = 0;
                  if ((g | 0) == 1) {
                   break M;
                  }
                  v[31601] = 0;
                  O(127, o | 0, (d >>> 0 > 1 ? 17190 : 17197) | 0) | 0;
                  d = v[31601];
                  v[31601] = 0;
                  if ((d | 0) == 1) {
                   break M;
                  }
                  if (f) {
                   break O;
                  }
                  v[a + 480228 >> 2] = 48;
                  break O;
                 }
                 f = $b(v[s >> 2], d);
                 f = w[f | 0] | w[f + 1 | 0] << 8;
                 v[31601] = 0;
                 f = O(149, b | 0, f << 4) | 0;
                 g = v[31601];
                 v[31601] = 0;
                 if ((g | 0) == 1) {
                  break K;
                 }
                 S: {
                  T: {
                   if (!f) {
                    break T;
                   }
                   v[31601] = 0;
                   g = e + 48 | 0;
                   f = O(697, b | 0, g | 0) | 0;
                   m = v[31601];
                   v[31601] = 0;
                   if ((m | 0) == 1) {
                    break K;
                   }
                   if (!f) {
                    break T;
                   }
                   v[31601] = 0;
                   m = d + 1 | 0;
                   D = q + B(m, 104) | 0;
                   R(698, g | 0, D | 0, l | 0);
                   f = v[31601];
                   v[31601] = 0;
                   if ((f | 0) == 1) {
                    break K;
                   }
                   A = e + 24 | 0;
                   Ui(A, 1, r);
                   v[31601] = 0;
                   f = e + 36 | 0;
                   N(218, f | 0, A | 0);
                   A = v[31601];
                   v[31601] = 0;
                   if ((A | 0) == 1) {
                    break S;
                   }
                   zc(z + (m << 5) | 0, f);
                   sb(f);
                   if (w[e + 48 | 0] > 1) {
                    break T;
                   }
                   U: {
                    if (!h | !(w[e + 64 | 0] | w[e + 65 | 0] << 8 | (w[e + 66 | 0] << 16 | w[e + 67 | 0] << 24))) {
                     break U;
                    }
                    g = NW(g);
                    v[31601] = 0;
                    g = O(149, b | 0, g | 0) | 0;
                    m = v[31601];
                    v[31601] = 0;
                    if ((m | 0) == 1) {
                     break R;
                    }
                    if (!g) {
                     break U;
                    }
                    MW(f, w[e + 78 | 0], w[e + 79 | 0], (w[e + 250 | 0] | w[e + 251 | 0] << 8) == 1);
                    v[31601] = 0;
                    T(215, f | 0, D | 0, b | 0) | 0;
                    f = v[31601];
                    v[31601] = 0;
                    if ((f | 0) == 1) {
                     break Q;
                    }
                    k = w[e + 39 | 0] == 10 | k;
                    j = 1;
                   }
                   n = w[e + 88 | 0] | w[e + 89 | 0] << 8 | n;
                  }
                  d = d + 1 | 0;
                  f = x[a + 480190 >> 1];
                  continue;
                 }
                 break;
                }
                b = M() | 0;
                break A;
               }
               b = M() | 0;
               break A;
              }
              b = M() | 0;
              break A;
             }
             v[31601] = 0;
             d = O(1, e + 48 | 0, 9750) | 0;
             f = v[31601];
             v[31601] = 0;
             if ((f | 0) == 1) {
              break N;
             }
             yb(o, d);
             sb(d);
            }
            if (k & 1) {
             break L;
            }
            break J;
           }
           b = M() | 0;
           break A;
          }
          b = M() | 0;
          break A;
         }
         v[31601] = 0;
         d = O(1, e + 36 | 0, 17130) | 0;
         f = v[31601];
         v[31601] = 0;
         V: {
          if ((f | 0) != 1) {
           v[31601] = 0;
           O(74, o | 0, d | 0) | 0;
           f = v[31601];
           v[31601] = 0;
           if ((f | 0) == 1) {
            break V;
           }
           sb(d);
           break J;
          }
          b = M() | 0;
          break A;
         }
         b = M() | 0;
         sb(d);
         break A;
        }
        b = M() | 0;
        break A;
       }
       if (!(c & 1)) {
        break y;
       }
       c = w[e + 248 | 0] | w[e + 249 | 0] << 8;
       u[e + 24 >> 1] = w[e + 244 | 0] | w[e + 245 | 0] << 8;
       u[e + 16 >> 1] = 255;
       z = x[Nc(e + 24 | 0, e + 16 | 0) >> 1];
       v[31601] = 0;
       l = a + 484344 | 0;
       N(223, l | 0, z | 0);
       d = v[31601];
       v[31601] = 0;
       if ((d | 0) != 1) {
        k = c >>> 0 < 4896;
        h = 0;
        j = 0;
        o = 0;
        W: {
         X: {
          while (1) {
           if ((h | 0) == (z | 0)) {
            if (!(k & 1)) {
             break y;
            }
            a = x[a + 480188 >> 1];
            if ((a | 0) > (j + o | 0) | (a | 0) <= (j - o | 0)) {
             break y;
            }
            c = eb - 16 | 0;
            eb = c;
            a = vb(v[l >> 2]);
            v[c + 12 >> 2] = a;
            d = vb(v[l + 4 >> 2]);
            while (1) {
             if (Hb(a, d)) {
              b = vb(v[a >> 2]);
              f = vb(v[a + 4 >> 2]);
              a = eb - 16 | 0;
              eb = a;
              v[a + 12 >> 2] = b;
              while (1) {
               if (Hb(b, f)) {
                if (w[b + 3 | 0] == 31) {
                 t[b + 3 | 0] = 20;
                 t[b + 5 | 0] = w[b + 5 | 0] | 128;
                }
                b = v[sg(a + 12 | 0) >> 2];
                continue;
               }
               break;
              }
              eb = a + 16 | 0;
              a = v[Sl(c + 12 | 0) >> 2];
              continue;
             } else {
              eb = c + 16 | 0;
             }
             break;
            }
            break y;
           }
           v[31601] = 0;
           c = T(196, l | 0, h & 65535, 64) | 0;
           d = v[31601];
           v[31601] = 0;
           Y: {
            if ((d | 0) == 1) {
             break Y;
            }
            Z: {
             if (!c) {
              break Z;
             }
             c = $b(v[y >> 2], h);
             c = w[c | 0] | w[c + 1 | 0] << 8;
             if (!c) {
              break Z;
             }
             v[31601] = 0;
             c = O(149, b | 0, c << 4) | 0;
             d = v[31601];
             v[31601] = 0;
             if ((d | 0) == 1) {
              break Y;
             }
             if (!c) {
              break Z;
             }
             v[31601] = 0;
             O(183, b | 0, 2) | 0;
             c = v[31601];
             v[31601] = 0;
             if ((c | 0) == 1) {
              break Y;
             }
             d = 0;
             c = Vb(v[l >> 2], h);
             af(e + 24 | 0, v[c >> 2], v[v[c + 48 >> 2] + 12 >> 2], 0);
             while (1) {
              if (d >>> 0 > 63) {
               break Z;
              }
              f = d;
              v[31601] = 0;
              c = Q(197, b | 0) | 0;
              d = v[31601];
              v[31601] = 0;
              _: {
               if ((d | 0) != 1) {
                d = c << 24 >> 24;
                if (d) {
                 break _;
                }
                d = 64;
                if ((f | 0) == 63) {
                 continue;
                }
                c = Vb(v[l >> 2], h);
                d = f + 1 | 0;
                af(e + 16 | 0, v[c >> 2], v[v[c + 48 >> 2] + 12 >> 2], d);
                c = v[e + 20 >> 2];
                v[e + 24 >> 2] = v[e + 16 >> 2];
                v[e + 28 >> 2] = c;
                continue;
               }
               b = M() | 0;
               break A;
              }
              g = Mg(e + 16 | 0);
              q = d & 31;
              if (q >>> 0 < x[a + 480188 >> 1]) {
               g = Xc(v[e + 24 >> 2], q);
              }
              r = d & 255;
              if (r & 32) {
               v[31601] = 0;
               c = e + 14 | 0;
               N(198, c | 0, b | 0);
               m = v[31601];
               v[31601] = 0;
               $: {
                aa: {
                 ba: {
                  if ((m | 0) != 1) {
                   m = Ic(c);
                   c = w[e + 14 | 0];
                   if (c >>> 0 > 239) {
                    break ba;
                   }
                   c = LW((B(c >>> 4 | 0, 12) + (c & 15) | 0) + 13 | 0);
                   break aa;
                  }
                  b = M() | 0;
                  break A;
                 }
                 ca: {
                  switch (c - 254 | 0) {
                  case 0:
                   break aa;

                  case 1:
                   break ca;

                  default:
                   break $;
                  }
                 }
                 c = 0;
                }
                t[g | 0] = c;
               }
               t[g + 1 | 0] = w[m | 0];
              }
              if (r & 64) {
               v[31601] = 0;
               c = Q(197, b | 0) | 0;
               r = v[31601];
               v[31601] = 0;
               if ((r | 0) == 1) {
                break X;
               }
               c = c << 24 >> 24;
               t[e + 14 | 0] = c;
               da: {
                if ((c | 0) <= -64) {
                 t[g + 2 | 0] = 2;
                 c = c & 127;
                 break da;
                }
                t[g + 2 | 0] = 1;
                t[e + 13 | 0] = 64;
                c = w[Pb(e + 14 | 0, e + 13 | 0) | 0];
               }
               t[g + 4 | 0] = c;
              }
              ea: {
               if ((d | 0) >= 0) {
                break ea;
               }
               v[31601] = 0;
               c = e + 14 | 0;
               N(198, c | 0, b | 0);
               d = v[31601];
               v[31601] = 0;
               if ((d | 0) == 1) {
                break W;
               }
               CD(g, w[e + 14 | 0], w[Ic(c) | 0], 0);
               c = w[g + 3 | 0];
               fa: {
                if ((c | 0) != 10) {
                 if ((c | 0) != 31) {
                  if ((c | 0) != 20) {
                   break ea;
                  }
                  c = w[g + 5 | 0];
                  if ((c & 240) != 160 | (w[e + 248 | 0] | w[e + 249 | 0] << 8) >>> 0 > 4895) {
                   break ea;
                  }
                  if ((n & 65535) >>> 0 > 1) {
                   break fa;
                  }
                  d = w[q + C | 0];
                  q = d & 127;
                  if (q >>> 0 >= 16) {
                   break fa;
                  }
                  ga: {
                   switch (c - 160 | 0) {
                   case 0:
                   case 2:
                    t[g + 5 | 0] = d & 8 ? -116 : -125;
                    break ea;

                   case 1:
                   case 3:
                    t[g + 5 | 0] = q >>> 0 < 8 ? -116 : -125;
                    break ea;

                   default:
                    break ga;
                   }
                  }
                  if (c >>> 0 > 167) {
                   break fa;
                  }
                  t[g + 5 | 0] = 136;
                  break ea;
                 }
                 c = w[g + 5 | 0];
                 if (c >>> 0 > 15) {
                  k = 0;
                  break ea;
                 }
                 if (c >>> 0 <= 7) {
                  o = o + 1 | 0;
                  break ea;
                 }
                 j = ((c | 0) != 8) + j | 0;
                 break ea;
                }
                if (w[g + 5 | 0] | (w[e + 248 | 0] | w[e + 249 | 0] << 8) >>> 0 > 4865) {
                 break ea;
                }
               }
               t[g + 3 | 0] = 37;
              }
              d = f;
              continue;
             }
            }
            h = h + 1 | 0;
            continue;
           }
           break;
          }
          b = M() | 0;
          break A;
         }
         b = M() | 0;
         break A;
        }
        b = M() | 0;
        break A;
       }
       b = M() | 0;
      }
      nd(y);
     }
     nd(s);
     break a;
    }
    nd(y);
    nd(s);
    sb(i);
    d = 1;
   }
   eb = e + 304 | 0;
   return d | 0;
  }
  b = M() | 0;
 }
 sb(i);
 P(b | 0);
 p();
}

function wI(a, b, c, d) {
 var e = 0, f = 0, g = 0, h = 0, i = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, r = 0, s = 0, u = 0, x = 0, z = 0, A = 0, D = 0, F = 0, G = 0, H = 0, I = 0, J = 0, K = 0, L = 0, M = 0, N = 0;
 r = eb - 48 | 0;
 eb = r;
 a: {
  b: {
   if (c >>> 0 > 2) {
    break b;
   }
   c = c << 2;
   H = v[c + 104860 >> 2];
   I = v[c + 104848 >> 2];
   while (1) {
    c = v[b + 4 >> 2];
    c: {
     if ((c | 0) != v[b + 104 >> 2]) {
      v[b + 4 >> 2] = c + 1;
      c = w[c | 0];
      break c;
     }
     c = sd(b);
    }
    if (dl(c)) {
     continue;
    }
    break;
   }
   z = 1;
   d: {
    e: {
     switch (c - 43 | 0) {
     case 0:
     case 2:
      break e;

     default:
      break d;
     }
    }
    z = (c | 0) == 45 ? -1 : 1;
    c = v[b + 4 >> 2];
    if ((c | 0) != v[b + 104 >> 2]) {
     v[b + 4 >> 2] = c + 1;
     c = w[c | 0];
     break d;
    }
    c = sd(b);
   }
   f: {
    g: {
     h: {
      i: {
       n = c & -33;
       j: {
        if ((n | 0) == 73) {
         k: {
          while (1) {
           f = h;
           if ((f | 0) == 7) {
            break k;
           }
           c = v[b + 4 >> 2];
           l: {
            if ((c | 0) != v[b + 104 >> 2]) {
             v[b + 4 >> 2] = c + 1;
             c = w[c | 0];
             break l;
            }
            c = sd(b);
           }
           h = f + 1 | 0;
           if (t[f + 4953 | 0] == (c | 32)) {
            continue;
           }
           break;
          }
          m: {
           if ((f | 0) == 2) {
            h = 3;
            break m;
           }
           if ((f | 0) == 7) {
            break k;
           }
           n = (d | 0) != 0;
           if (!d | f >>> 0 < 3) {
            break j;
           }
           if ((h | 0) == 8) {
            break k;
           }
          }
          c = v[b + 116 >> 2];
          if ((c | 0) >= 0 | (c | 0) > 0) {
           v[b + 4 >> 2] = v[b + 4 >> 2] - 1;
          }
          if (!d | h >>> 0 < 4) {
           break k;
          }
          c = (c | 0) < 0;
          while (1) {
           if (!c) {
            v[b + 4 >> 2] = v[b + 4 >> 2] - 1;
           }
           h = h - 1 | 0;
           if (h >>> 0 > 3) {
            continue;
           }
           break;
          }
         }
         k = eb - 16 | 0;
         eb = k;
         l = (q(C(C(z | 0) * C(Infinity))), j(2));
         c = l & 2147483647;
         n: {
          if (c - 8388608 >>> 0 <= 2130706431) {
           d = c << 25;
           b = (c >>> 7 | 0) + 1065353216 | 0;
           break n;
          }
          d = l << 25;
          b = l >>> 7 | 2147418112;
          if (c >>> 0 >= 2139095040) {
           break n;
          }
          d = 0;
          b = 0;
          if (!c) {
           break n;
          }
          b = E(c);
          _f(k, c, 0, 0, 0, b + 81 | 0);
          i = v[k >> 2];
          g = v[k + 4 >> 2];
          d = v[k + 8 >> 2];
          b = v[k + 12 >> 2] ^ 65536 | 16265 - b << 16;
         }
         v[r >> 2] = i;
         v[r + 4 >> 2] = g;
         v[r + 8 >> 2] = d;
         v[r + 12 >> 2] = l & -2147483648 | b;
         eb = k + 16 | 0;
         i = v[r + 8 >> 2];
         g = v[r + 12 >> 2];
         l = v[r >> 2];
         m = v[r + 4 >> 2];
         break a;
        }
        if ((n | 0) != 78) {
         break f;
        }
        n = (d | 0) != 0;
        while (1) {
         if ((h | 0) == 2) {
          break i;
         }
         c = v[b + 4 >> 2];
         o: {
          if ((c | 0) != v[b + 104 >> 2]) {
           v[b + 4 >> 2] = c + 1;
           c = w[c | 0];
           break o;
          }
          c = sd(b);
         }
         f = h + 9979 | 0;
         h = h + 1 | 0;
         if (t[f | 0] == (c | 32)) {
          continue;
         }
         break;
        }
       }
       switch (h | 0) {
       case 3:
        break i;

       case 0:
        break f;

       default:
        break h;
       }
      }
      p: {
       c = v[b + 4 >> 2];
       q: {
        if ((c | 0) != v[b + 104 >> 2]) {
         v[b + 4 >> 2] = c + 1;
         c = w[c | 0];
         break q;
        }
        c = sd(b);
       }
       if ((c | 0) == 40) {
        h = 1;
        break p;
       }
       g = 2147450880;
       if (v[b + 116 >> 2] < 0) {
        break a;
       }
       v[b + 4 >> 2] = v[b + 4 >> 2] - 1;
       break a;
      }
      while (1) {
       c = v[b + 4 >> 2];
       r: {
        if ((c | 0) != v[b + 104 >> 2]) {
         v[b + 4 >> 2] = c + 1;
         c = w[c | 0];
         break r;
        }
        c = sd(b);
       }
       if (!(!(c - 48 >>> 0 < 10 | c - 65 >>> 0 < 26 | (c | 0) == 95) & c - 97 >>> 0 >= 26)) {
        h = h + 1 | 0;
        continue;
       }
       break;
      }
      g = 2147450880;
      if ((c | 0) == 41) {
       break a;
      }
      c = v[b + 116 >> 2];
      if ((c | 0) >= 0 | (c | 0) > 0) {
       v[b + 4 >> 2] = v[b + 4 >> 2] - 1;
      }
      s: {
       if (n) {
        if (h) {
         break s;
        }
        break a;
       }
       break g;
      }
      while (1) {
       if ((c | 0) > 0 | (c | 0) >= 0) {
        v[b + 4 >> 2] = v[b + 4 >> 2] - 1;
       }
       h = h - 1 | 0;
       if (h) {
        continue;
       }
       break;
      }
      break a;
     }
     c = v[b + 116 >> 2];
     if ((c | 0) > 0) {
      c = 1;
     } else {
      c = (c | 0) >= 0;
     }
     if (c) {
      v[b + 4 >> 2] = v[b + 4 >> 2] - 1;
     }
    }
    v[31476] = 28;
    Ai(b, 0, 0);
    break b;
   }
   t: {
    if ((c | 0) != 48) {
     break t;
    }
    h = v[b + 4 >> 2];
    u: {
     if ((h | 0) != v[b + 104 >> 2]) {
      v[b + 4 >> 2] = h + 1;
      h = w[h | 0];
      break u;
     }
     h = sd(b);
    }
    if ((h & -33) == 88) {
     n = 0;
     f = eb - 432 | 0;
     eb = f;
     c = v[b + 4 >> 2];
     v: {
      if ((c | 0) != v[b + 104 >> 2]) {
       v[b + 4 >> 2] = c + 1;
       c = w[c | 0];
       break v;
      }
      c = sd(b);
     }
     w: {
      x: {
       while (1) {
        if ((c | 0) != 48) {
         y: {
          if ((c | 0) != 46) {
           break w;
          }
          c = v[b + 4 >> 2];
          if ((c | 0) == v[b + 104 >> 2]) {
           break y;
          }
          v[b + 4 >> 2] = c + 1;
          c = w[c | 0];
          break x;
         }
        } else {
         c = v[b + 4 >> 2];
         if ((c | 0) != v[b + 104 >> 2]) {
          J = 1;
          v[b + 4 >> 2] = c + 1;
          c = w[c | 0];
         } else {
          J = 1;
          c = sd(b);
         }
         continue;
        }
        break;
       }
       c = sd(b);
      }
      x = 1;
      if ((c | 0) != 48) {
       break w;
      }
      while (1) {
       c = s;
       s = c - 1 | 0;
       u = u - !c | 0;
       c = v[b + 4 >> 2];
       z: {
        if ((c | 0) != v[b + 104 >> 2]) {
         v[b + 4 >> 2] = c + 1;
         c = w[c | 0];
         break z;
        }
        c = sd(b);
       }
       if ((c | 0) == 48) {
        continue;
       }
       break;
      }
      J = 1;
     }
     m = 1073676288;
     A: {
      while (1) {
       B: {
        h = c;
        C: {
         D: {
          L = c - 48 | 0;
          if (L >>> 0 < 10) {
           break D;
          }
          M = (c | 0) != 46;
          h = c | 32;
          if (M & h - 97 >>> 0 > 5) {
           break A;
          }
          if (M) {
           break D;
          }
          if (x) {
           break B;
          }
          x = 1;
          s = i;
          u = g;
          break C;
         }
         c = (c | 0) > 57 ? h - 87 | 0 : L;
         E: {
          if ((g | 0) <= 0 & i >>> 0 <= 7 | (g | 0) < 0) {
           n = c + (n << 4) | 0;
           break E;
          }
          if (!g & i >>> 0 <= 28) {
           jh(f + 48 | 0, c);
           Wd(f + 32 | 0, F, G, l, m, 0, 0, 0, 1073414144);
           F = v[f + 32 >> 2];
           G = v[f + 36 >> 2];
           l = v[f + 40 >> 2];
           m = v[f + 44 >> 2];
           Wd(f + 16 | 0, v[f + 48 >> 2], v[f + 52 >> 2], v[f + 56 >> 2], v[f + 60 >> 2], F, G, l, m);
           Tg(f, v[f + 16 >> 2], v[f + 20 >> 2], v[f + 24 >> 2], v[f + 28 >> 2], k, o, A, D);
           A = v[f + 8 >> 2];
           D = v[f + 12 >> 2];
           k = v[f >> 2];
           o = v[f + 4 >> 2];
           break E;
          }
          if (!c | p) {
           break E;
          }
          Wd(f + 80 | 0, F, G, l, m, 0, 0, 0, 1073610752);
          Tg(f - -64 | 0, v[f + 80 >> 2], v[f + 84 >> 2], v[f + 88 >> 2], v[f + 92 >> 2], k, o, A, D);
          A = v[f + 72 >> 2];
          D = v[f + 76 >> 2];
          p = 1;
          k = v[f + 64 >> 2];
          o = v[f + 68 >> 2];
         }
         i = i + 1 | 0;
         g = i ? g : g + 1 | 0;
         J = 1;
        }
        c = v[b + 4 >> 2];
        if ((c | 0) != v[b + 104 >> 2]) {
         v[b + 4 >> 2] = c + 1;
         c = w[c | 0];
        } else {
         c = sd(b);
        }
        continue;
       }
       break;
      }
      c = 46;
     }
     F: {
      if (!J) {
       c = v[b + 116 >> 2];
       if ((c | 0) > 0) {
        c = 1;
       } else {
        c = (c | 0) >= 0;
       }
       G: {
        H: {
         if (c) {
          c = v[b + 4 >> 2];
          v[b + 4 >> 2] = c - 1;
          if (!d) {
           break H;
          }
          v[b + 4 >> 2] = c - 2;
          if (!x) {
           break G;
          }
          v[b + 4 >> 2] = c - 3;
          break G;
         }
         if (d) {
          break G;
         }
        }
        Ai(b, 0, 0);
       }
       cj(f + 96 | 0, +(z | 0) * 0);
       k = v[f + 96 >> 2];
       o = v[f + 100 >> 2];
       c = v[f + 108 >> 2];
       b = v[f + 104 >> 2];
       break F;
      }
      if ((g | 0) <= 0 & i >>> 0 <= 7 | (g | 0) < 0) {
       l = i;
       m = g;
       while (1) {
        n = n << 4;
        l = l + 1 | 0;
        m = l ? m : m + 1 | 0;
        if ((l | 0) != 8 | m) {
         continue;
        }
        break;
       }
      }
      I: {
       J: {
        K: {
         if ((c & -33) == 80) {
          l = vI(b, d);
          c = gb;
          m = c;
          if (l | (c | 0) != -2147483648) {
           break I;
          }
          if (d) {
           c = v[b + 116 >> 2];
           if ((c | 0) > 0) {
            c = 1;
           } else {
            c = (c | 0) >= 0;
           }
           if (c) {
            break K;
           }
           break J;
          }
          k = 0;
          o = 0;
          Ai(b, 0, 0);
          c = 0;
          b = 0;
          break F;
         }
         l = 0;
         m = 0;
         if (v[b + 116 >> 2] < 0) {
          break I;
         }
        }
        v[b + 4 >> 2] = v[b + 4 >> 2] - 1;
       }
       l = 0;
       m = 0;
      }
      if (!n) {
       cj(f + 112 | 0, +(z | 0) * 0);
       k = v[f + 112 >> 2];
       o = v[f + 116 >> 2];
       c = v[f + 124 >> 2];
       b = v[f + 120 >> 2];
       break F;
      }
      b = x ? s : i;
      g = (x ? u : g) << 2 | b >>> 30;
      c = l + (b << 2) | 0;
      g = g + m | 0;
      b = 0 - H | 0;
      i = c - 32 | 0;
      d = i;
      g = (c >>> 0 < l >>> 0 ? g + 1 | 0 : g) - (c >>> 0 < 32) | 0;
      c = g;
      if ((c | 0) > 0) {
       b = 1;
      } else {
       b = b >>> 0 < d >>> 0 & (c | 0) >= 0;
      }
      if (b) {
       v[31476] = 68;
       jh(f + 160 | 0, z);
       Wd(f + 144 | 0, v[f + 160 >> 2], v[f + 164 >> 2], v[f + 168 >> 2], v[f + 172 >> 2], -1, -1, -1, 2147418111);
       Wd(f + 128 | 0, v[f + 144 >> 2], v[f + 148 >> 2], v[f + 152 >> 2], v[f + 156 >> 2], -1, -1, -1, 2147418111);
       k = v[f + 128 >> 2];
       o = v[f + 132 >> 2];
       c = v[f + 140 >> 2];
       b = v[f + 136 >> 2];
       break F;
      }
      b = H - 226 | 0;
      c = b >> 31;
      if ((g | 0) >= (c | 0) & b >>> 0 <= i >>> 0 | (c | 0) < (g | 0)) {
       if ((n | 0) >= 0) {
        while (1) {
         Tg(f + 416 | 0, k, o, A, D, 0, 0, 0, -1073807360);
         b = xV(k, o, A, D, 1073610752);
         c = (b | 0) >= 0;
         b = c;
         Tg(f + 400 | 0, k, o, A, D, b ? v[f + 416 >> 2] : k, b ? v[f + 420 >> 2] : o, b ? v[f + 424 >> 2] : A, b ? v[f + 428 >> 2] : D);
         b = i;
         i = b - 1 | 0;
         g = g - !b | 0;
         A = v[f + 408 >> 2];
         D = v[f + 412 >> 2];
         k = v[f + 400 >> 2];
         o = v[f + 404 >> 2];
         n = c | n << 1;
         if ((n | 0) >= 0) {
          continue;
         }
         break;
        }
       }
       g = g - ((H >> 31) + (i >>> 0 < H >>> 0) | 0) | 0;
       b = (i - H | 0) + 32 | 0;
       g = b >>> 0 < 32 ? g + 1 | 0 : g;
       c = b >>> 0 < I >>> 0 & (g | 0) <= 0 | (g | 0) < 0 ? (b | 0) > 0 ? b : 0 : I;
       L: {
        if ((c | 0) >= 113) {
         jh(f + 384 | 0, z);
         s = v[f + 392 >> 2];
         u = v[f + 396 >> 2];
         F = v[f + 384 >> 2];
         G = v[f + 388 >> 2];
         l = 0;
         b = 0;
         break L;
        }
        cj(f + 352 | 0, nk(1, 144 - c | 0));
        jh(f + 336 | 0, z);
        F = v[f + 336 >> 2];
        G = v[f + 340 >> 2];
        s = v[f + 344 >> 2];
        u = v[f + 348 >> 2];
        uI(f + 368 | 0, v[f + 352 >> 2], v[f + 356 >> 2], v[f + 360 >> 2], v[f + 364 >> 2], F, G, s, u);
        e = v[f + 376 >> 2];
        K = v[f + 380 >> 2];
        l = v[f + 372 >> 2];
        b = v[f + 368 >> 2];
       }
       d = !(n & 1) & ((fn(k, o, A, D, 0, 0, 0, 0) | 0) != 0 & (c | 0) < 32);
       Tn(f + 320 | 0, d | n);
       Wd(f + 304 | 0, F, G, s, u, v[f + 320 >> 2], v[f + 324 >> 2], v[f + 328 >> 2], v[f + 332 >> 2]);
       c = b;
       Tg(f + 272 | 0, v[f + 304 >> 2], v[f + 308 >> 2], v[f + 312 >> 2], v[f + 316 >> 2], b, l, e, K);
       b = d;
       Wd(f + 288 | 0, F, G, s, u, b ? 0 : k, b ? 0 : o, b ? 0 : A, b ? 0 : D);
       Tg(f + 256 | 0, v[f + 288 >> 2], v[f + 292 >> 2], v[f + 296 >> 2], v[f + 300 >> 2], v[f + 272 >> 2], v[f + 276 >> 2], v[f + 280 >> 2], v[f + 284 >> 2]);
       Hz(f + 240 | 0, v[f + 256 >> 2], v[f + 260 >> 2], v[f + 264 >> 2], v[f + 268 >> 2], c, l, e, K);
       b = v[f + 240 >> 2];
       d = v[f + 244 >> 2];
       c = v[f + 248 >> 2];
       l = v[f + 252 >> 2];
       if (!fn(b, d, c, l, 0, 0, 0, 0)) {
        v[31476] = 68;
       }
       tI(f + 224 | 0, b, d, c, l, i);
       k = v[f + 224 >> 2];
       o = v[f + 228 >> 2];
       c = v[f + 236 >> 2];
       b = v[f + 232 >> 2];
       break F;
      }
      v[31476] = 68;
      jh(f + 208 | 0, z);
      Wd(f + 192 | 0, v[f + 208 >> 2], v[f + 212 >> 2], v[f + 216 >> 2], v[f + 220 >> 2], 0, 0, 0, 65536);
      Wd(f + 176 | 0, v[f + 192 >> 2], v[f + 196 >> 2], v[f + 200 >> 2], v[f + 204 >> 2], 0, 0, 0, 65536);
      k = v[f + 176 >> 2];
      o = v[f + 180 >> 2];
      c = v[f + 188 >> 2];
      b = v[f + 184 >> 2];
     }
     v[r + 16 >> 2] = k;
     v[r + 20 >> 2] = o;
     v[r + 24 >> 2] = b;
     v[r + 28 >> 2] = c;
     eb = f + 432 | 0;
     i = v[r + 24 >> 2];
     g = v[r + 28 >> 2];
     l = v[r + 16 >> 2];
     m = v[r + 20 >> 2];
     break a;
    }
    if (v[b + 116 >> 2] < 0) {
     break t;
    }
    v[b + 4 >> 2] = v[b + 4 >> 2] - 1;
   }
   h = b;
   k = c;
   f = d;
   d = 0;
   n = 0;
   e = eb - 8976 | 0;
   eb = e;
   K = 0 - H | 0;
   J = K - I | 0;
   M: {
    N: {
     while (1) {
      if ((k | 0) != 48) {
       O: {
        if ((k | 0) != 46) {
         break M;
        }
        b = v[h + 4 >> 2];
        if ((b | 0) == v[h + 104 >> 2]) {
         break O;
        }
        v[h + 4 >> 2] = b + 1;
        k = w[b | 0];
        break N;
       }
      } else {
       b = v[h + 4 >> 2];
       if ((b | 0) != v[h + 104 >> 2]) {
        v[h + 4 >> 2] = b + 1;
        k = w[b | 0];
       } else {
        k = sd(h);
       }
       d = 1;
       continue;
      }
      break;
     }
     k = sd(h);
    }
    o = 1;
    if ((k | 0) != 48) {
     break M;
    }
    while (1) {
     b = i;
     i = b - 1 | 0;
     g = g - !b | 0;
     b = v[h + 4 >> 2];
     P: {
      if ((b | 0) != v[h + 104 >> 2]) {
       v[h + 4 >> 2] = b + 1;
       k = w[b | 0];
       break P;
      }
      k = sd(h);
     }
     if ((k | 0) == 48) {
      continue;
     }
     break;
    }
    d = 1;
   }
   v[e + 784 >> 2] = 0;
   Q: {
    R: {
     b = (k | 0) == 46;
     c = k - 48 | 0;
     S: {
      T: {
       U: {
        if (b | c >>> 0 <= 9) {
         while (1) {
          V: {
           if (b & 1) {
            if (!o) {
             i = l;
             g = m;
             o = 1;
             break V;
            }
            b = !d;
            break U;
           }
           l = l + 1 | 0;
           m = l ? m : m + 1 | 0;
           if ((n | 0) <= 2044) {
            x = (k | 0) == 48 ? x : l;
            b = (e + 784 | 0) + (n << 2) | 0;
            if (p) {
             c = (B(v[b >> 2], 10) + k | 0) - 48 | 0;
            }
            v[b >> 2] = c;
            d = 1;
            c = p + 1 | 0;
            b = (c | 0) == 9;
            p = b ? 0 : c;
            n = b + n | 0;
            break V;
           }
           if ((k | 0) == 48) {
            break V;
           }
           v[e + 8960 >> 2] = v[e + 8960 >> 2] | 1;
           x = 18396;
          }
          b = v[h + 4 >> 2];
          W: {
           if ((b | 0) != v[h + 104 >> 2]) {
            v[h + 4 >> 2] = b + 1;
            k = w[b | 0];
            break W;
           }
           k = sd(h);
          }
          b = (k | 0) == 46;
          c = k - 48 | 0;
          if (b | c >>> 0 < 10) {
           continue;
          }
          break;
         }
        }
        i = o ? i : l;
        g = o ? g : m;
        if (!(!d | (k & -33) != 69)) {
         k = vI(h, f);
         b = gb;
         o = b;
         X: {
          if (k | (b | 0) != -2147483648) {
           break X;
          }
          if (!f) {
           break S;
          }
          k = 0;
          o = 0;
          if (v[h + 116 >> 2] < 0) {
           break X;
          }
          v[h + 4 >> 2] = v[h + 4 >> 2] - 1;
         }
         b = g + o | 0;
         i = i + k | 0;
         g = i >>> 0 < k >>> 0 ? b + 1 | 0 : b;
         break R;
        }
        b = !d;
        if ((k | 0) < 0) {
         break T;
        }
       }
       if (v[h + 116 >> 2] < 0) {
        break T;
       }
       v[h + 4 >> 2] = v[h + 4 >> 2] - 1;
      }
      if (!b) {
       break R;
      }
      v[31476] = 28;
     }
     Ai(h, 0, 0);
     i = 0;
     g = 0;
     c = 0;
     b = 0;
     break Q;
    }
    b = v[e + 784 >> 2];
    if (!b) {
     cj(e, +(z | 0) * 0);
     i = v[e + 8 >> 2];
     g = v[e + 12 >> 2];
     c = v[e + 4 >> 2];
     b = v[e >> 2];
     break Q;
    }
    if (!((i | 0) != (l | 0) | (g | 0) != (m | 0) | (l >>> 0 > 9 & (m | 0) >= 0 | (m | 0) > 0) | (b >>> I | 0 ? (I | 0) <= 30 : 0))) {
     jh(e + 48 | 0, z);
     Tn(e + 32 | 0, b);
     Wd(e + 16 | 0, v[e + 48 >> 2], v[e + 52 >> 2], v[e + 56 >> 2], v[e + 60 >> 2], v[e + 32 >> 2], v[e + 36 >> 2], v[e + 40 >> 2], v[e + 44 >> 2]);
     i = v[e + 24 >> 2];
     g = v[e + 28 >> 2];
     c = v[e + 20 >> 2];
     b = v[e + 16 >> 2];
     break Q;
    }
    b = K >>> 1 | 0;
    if (b >>> 0 < i >>> 0 & (g | 0) >= 0 | (g | 0) > 0) {
     v[31476] = 68;
     jh(e + 96 | 0, z);
     Wd(e + 80 | 0, v[e + 96 >> 2], v[e + 100 >> 2], v[e + 104 >> 2], v[e + 108 >> 2], -1, -1, -1, 2147418111);
     Wd(e - -64 | 0, v[e + 80 >> 2], v[e + 84 >> 2], v[e + 88 >> 2], v[e + 92 >> 2], -1, -1, -1, 2147418111);
     i = v[e + 72 >> 2];
     g = v[e + 76 >> 2];
     c = v[e + 68 >> 2];
     b = v[e + 64 >> 2];
     break Q;
    }
    b = H - 226 | 0;
    c = i >>> 0 < b >>> 0;
    b = b >> 31;
    if (c & (g | 0) <= (b | 0) | (b | 0) > (g | 0)) {
     v[31476] = 68;
     jh(e + 144 | 0, z);
     Wd(e + 128 | 0, v[e + 144 >> 2], v[e + 148 >> 2], v[e + 152 >> 2], v[e + 156 >> 2], 0, 0, 0, 65536);
     Wd(e + 112 | 0, v[e + 128 >> 2], v[e + 132 >> 2], v[e + 136 >> 2], v[e + 140 >> 2], 0, 0, 0, 65536);
     i = v[e + 120 >> 2];
     g = v[e + 124 >> 2];
     c = v[e + 116 >> 2];
     b = v[e + 112 >> 2];
     break Q;
    }
    if (p) {
     if ((p | 0) <= 8) {
      b = (e + 784 | 0) + (n << 2) | 0;
      h = v[b >> 2];
      while (1) {
       h = B(h, 10);
       p = p + 1 | 0;
       if ((p | 0) != 9) {
        continue;
       }
       break;
      }
      v[b >> 2] = h;
     }
     n = n + 1 | 0;
    }
    p = i;
    Y: {
     if ((i | 0) < (x | 0) | (x | 0) >= 9 | (i | 0) > 17) {
      break Y;
     }
     if ((i | 0) == 9) {
      jh(e + 192 | 0, z);
      Tn(e + 176 | 0, v[e + 784 >> 2]);
      Wd(e + 160 | 0, v[e + 192 >> 2], v[e + 196 >> 2], v[e + 200 >> 2], v[e + 204 >> 2], v[e + 176 >> 2], v[e + 180 >> 2], v[e + 184 >> 2], v[e + 188 >> 2]);
      i = v[e + 168 >> 2];
      g = v[e + 172 >> 2];
      c = v[e + 164 >> 2];
      b = v[e + 160 >> 2];
      break Q;
     }
     if ((p | 0) <= 8) {
      jh(e + 272 | 0, z);
      Tn(e + 256 | 0, v[e + 784 >> 2]);
      Wd(e + 240 | 0, v[e + 272 >> 2], v[e + 276 >> 2], v[e + 280 >> 2], v[e + 284 >> 2], v[e + 256 >> 2], v[e + 260 >> 2], v[e + 264 >> 2], v[e + 268 >> 2]);
      jh(e + 224 | 0, v[(0 - p << 2) + 104848 >> 2]);
      uS(e + 208 | 0, v[e + 240 >> 2], v[e + 244 >> 2], v[e + 248 >> 2], v[e + 252 >> 2], v[e + 224 >> 2], v[e + 228 >> 2], v[e + 232 >> 2], v[e + 236 >> 2]);
      i = v[e + 216 >> 2];
      g = v[e + 220 >> 2];
      c = v[e + 212 >> 2];
      b = v[e + 208 >> 2];
      break Q;
     }
     b = (B(p, -3) + I | 0) + 27 | 0;
     c = v[e + 784 >> 2];
     if (c >>> b | 0 ? (b | 0) <= 30 : 0) {
      break Y;
     }
     jh(e + 352 | 0, z);
     Tn(e + 336 | 0, c);
     Wd(e + 320 | 0, v[e + 352 >> 2], v[e + 356 >> 2], v[e + 360 >> 2], v[e + 364 >> 2], v[e + 336 >> 2], v[e + 340 >> 2], v[e + 344 >> 2], v[e + 348 >> 2]);
     jh(e + 304 | 0, v[(p << 2) + 104776 >> 2]);
     Wd(e + 288 | 0, v[e + 320 >> 2], v[e + 324 >> 2], v[e + 328 >> 2], v[e + 332 >> 2], v[e + 304 >> 2], v[e + 308 >> 2], v[e + 312 >> 2], v[e + 316 >> 2]);
     i = v[e + 296 >> 2];
     g = v[e + 300 >> 2];
     c = v[e + 292 >> 2];
     b = v[e + 288 >> 2];
     break Q;
    }
    while (1) {
     b = n;
     n = b - 1 | 0;
     if (!v[(e + 784 | 0) + (n << 2) >> 2]) {
      continue;
     }
     break;
    }
    x = 0;
    d = (p | 0) % 9 | 0;
    Z: {
     if (!d) {
      c = 0;
      break Z;
     }
     c = 0;
     d = (p | 0) < 0 ? d + 9 | 0 : d;
     _: {
      if (!b) {
       b = 0;
       break _;
      }
      i = v[(0 - d << 2) + 104848 >> 2];
      g = 1e9 / (i | 0) | 0;
      k = 0;
      h = 0;
      while (1) {
       l = k;
       m = e + 784 | 0;
       k = m + (h << 2) | 0;
       n = v[k >> 2];
       f = (n >>> 0) / (i >>> 0) | 0;
       l = l + f | 0;
       v[k >> 2] = l;
       l = !l & (c | 0) == (h | 0);
       c = l ? c + 1 & 2047 : c;
       p = l ? p - 9 | 0 : p;
       k = B(g, n - B(f, i) | 0);
       h = h + 1 | 0;
       if ((h | 0) != (b | 0)) {
        continue;
       }
       break;
      }
      if (!k) {
       break _;
      }
      v[m + (b << 2) >> 2] = k;
      b = b + 1 | 0;
     }
     p = (p - d | 0) + 9 | 0;
    }
    while (1) {
     h = (e + 784 | 0) + (c << 2) | 0;
     f = (p | 0) < 36;
     $: {
      while (1) {
       aa: {
        if (f) {
         break aa;
        }
        if ((p | 0) != 36) {
         break $;
        }
        if (y[h >> 2] <= 10384592) {
         break aa;
        }
        p = 36;
        break $;
       }
       n = b + 2047 | 0;
       d = 0;
       while (1) {
        l = b;
        k = n & 2047;
        n = (e + 784 | 0) + (k << 2) | 0;
        b = v[n >> 2];
        m = b >>> 3 | 0;
        b = b << 29;
        i = b + d | 0;
        g = m;
        g = b >>> 0 > i >>> 0 ? g + 1 | 0 : g;
        if (!g & i >>> 0 < 1000000001) {
         d = 0;
        } else {
         d = Cua(i, g, 1e9, 0);
         b = Aua(d, gb, -1e9, -1);
         i = b + i | 0;
        }
        v[n >> 2] = i;
        b = (c | 0) == (k | 0) ? l : i ? l : k;
        i = l - 1 & 2047;
        b = (i | 0) != (k | 0) ? l : b;
        n = k - 1 | 0;
        if ((c | 0) != (k | 0)) {
         continue;
        }
        break;
       }
       x = x - 29 | 0;
       b = l;
       if (!d) {
        continue;
       }
       break;
      }
      c = c - 1 & 2047;
      if ((c | 0) == (b | 0)) {
       k = (b + 2046 & 2047) << 2;
       b = e + 784 | 0;
       l = k + b | 0;
       v[l >> 2] = v[l >> 2] | v[b + (i << 2) >> 2];
       b = i;
      }
      p = p + 9 | 0;
      v[(e + 784 | 0) + (c << 2) >> 2] = d;
      continue;
     }
     break;
    }
    ba: {
     ca: while (1) {
      i = b + 1 & 2047;
      k = (e + 784 | 0) + ((b - 1 & 2047) << 2) | 0;
      while (1) {
       l = (p | 0) > 45 ? 9 : 1;
       g = (p | 0) != 36;
       da: {
        while (1) {
         d = c;
         h = 0;
         ea: {
          while (1) {
           fa: {
            c = d + h & 2047;
            if ((c | 0) == (b | 0)) {
             break fa;
            }
            c = v[(e + 784 | 0) + (c << 2) >> 2];
            m = v[(h << 2) + 104800 >> 2];
            if (c >>> 0 < m >>> 0) {
             break fa;
            }
            if (c >>> 0 > m >>> 0) {
             break ea;
            }
            h = h + 1 | 0;
            if ((h | 0) != 4) {
             continue;
            }
           }
           break;
          }
          if (g) {
           break ea;
          }
          h = 0;
          i = 0;
          g = 0;
          l = 0;
          m = 0;
          while (1) {
           c = d + h & 2047;
           if ((c | 0) == (b | 0)) {
            b = b + 1 & 2047;
            v[(e + (b << 2) | 0) + 780 >> 2] = 0;
           }
           Tn(e + 768 | 0, v[(e + 784 | 0) + (c << 2) >> 2]);
           Wd(e + 752 | 0, i, g, l, m, 0, 0, 1342177280, 1075633366);
           Tg(e + 736 | 0, v[e + 752 >> 2], v[e + 756 >> 2], v[e + 760 >> 2], v[e + 764 >> 2], v[e + 768 >> 2], v[e + 772 >> 2], v[e + 776 >> 2], v[e + 780 >> 2]);
           l = v[e + 744 >> 2];
           m = v[e + 748 >> 2];
           i = v[e + 736 >> 2];
           g = v[e + 740 >> 2];
           h = h + 1 | 0;
           if ((h | 0) != 4) {
            continue;
           }
           break;
          }
          jh(e + 720 | 0, z);
          Wd(e + 704 | 0, i, g, l, m, v[e + 720 >> 2], v[e + 724 >> 2], v[e + 728 >> 2], v[e + 732 >> 2]);
          l = v[e + 712 >> 2];
          m = v[e + 716 >> 2];
          i = 0;
          g = 0;
          k = v[e + 704 >> 2];
          o = v[e + 708 >> 2];
          f = x + 113 | 0;
          h = f - H | 0;
          p = (h | 0) < (I | 0);
          c = p ? (h | 0) > 0 ? h : 0 : I;
          if ((c | 0) <= 112) {
           break da;
          }
          break ba;
         }
         x = l + x | 0;
         c = b;
         if ((b | 0) == (d | 0)) {
          continue;
         }
         break;
        }
        m = 1e9 >>> l | 0;
        n = -1 << l ^ -1;
        h = 0;
        c = d;
        while (1) {
         g = h;
         f = e + 784 | 0;
         h = f + (d << 2) | 0;
         o = v[h >> 2];
         g = g + (o >>> l | 0) | 0;
         v[h >> 2] = g;
         g = !g & (c | 0) == (d | 0);
         c = g ? c + 1 & 2047 : c;
         p = g ? p - 9 | 0 : p;
         h = B(m, n & o);
         d = d + 1 & 2047;
         if ((d | 0) != (b | 0)) {
          continue;
         }
         break;
        }
        if (!h) {
         continue;
        }
        if ((c | 0) != (i | 0)) {
         v[f + (b << 2) >> 2] = h;
         b = i;
         continue ca;
        }
        v[k >> 2] = v[k >> 2] | 1;
        continue;
       }
       break;
      }
      break;
     }
     cj(e + 656 | 0, nk(1, 225 - c | 0));
     uI(e + 688 | 0, v[e + 656 >> 2], v[e + 660 >> 2], v[e + 664 >> 2], v[e + 668 >> 2], k, o, l, m);
     F = v[e + 696 >> 2];
     G = v[e + 700 >> 2];
     A = v[e + 688 >> 2];
     D = v[e + 692 >> 2];
     cj(e + 640 | 0, nk(1, 113 - c | 0));
     BR(e + 672 | 0, k, o, l, m, v[e + 640 >> 2], v[e + 644 >> 2], v[e + 648 >> 2], v[e + 652 >> 2]);
     i = v[e + 672 >> 2];
     g = v[e + 676 >> 2];
     s = v[e + 680 >> 2];
     u = v[e + 684 >> 2];
     Hz(e + 624 | 0, k, o, l, m, i, g, s, u);
     Tg(e + 608 | 0, A, D, F, G, v[e + 624 >> 2], v[e + 628 >> 2], v[e + 632 >> 2], v[e + 636 >> 2]);
     l = v[e + 616 >> 2];
     m = v[e + 620 >> 2];
     k = v[e + 608 >> 2];
     o = v[e + 612 >> 2];
    }
    n = d + 4 & 2047;
    ga: {
     if ((n | 0) == (b | 0)) {
      break ga;
     }
     n = v[(e + 784 | 0) + (n << 2) >> 2];
     ha: {
      if (n >>> 0 <= 499999999) {
       if (!n & (d + 5 & 2047) == (b | 0)) {
        break ha;
       }
       cj(e + 496 | 0, +(z | 0) * .25);
       Tg(e + 480 | 0, i, g, s, u, v[e + 496 >> 2], v[e + 500 >> 2], v[e + 504 >> 2], v[e + 508 >> 2]);
       s = v[e + 488 >> 2];
       u = v[e + 492 >> 2];
       i = v[e + 480 >> 2];
       g = v[e + 484 >> 2];
       break ha;
      }
      if ((n | 0) != 5e8) {
       cj(e + 592 | 0, +(z | 0) * .75);
       Tg(e + 576 | 0, i, g, s, u, v[e + 592 >> 2], v[e + 596 >> 2], v[e + 600 >> 2], v[e + 604 >> 2]);
       s = v[e + 584 >> 2];
       u = v[e + 588 >> 2];
       i = v[e + 576 >> 2];
       g = v[e + 580 >> 2];
       break ha;
      }
      N = +(z | 0);
      if ((d + 5 & 2047) == (b | 0)) {
       cj(e + 528 | 0, N * .5);
       Tg(e + 512 | 0, i, g, s, u, v[e + 528 >> 2], v[e + 532 >> 2], v[e + 536 >> 2], v[e + 540 >> 2]);
       s = v[e + 520 >> 2];
       u = v[e + 524 >> 2];
       i = v[e + 512 >> 2];
       g = v[e + 516 >> 2];
       break ha;
      }
      cj(e + 560 | 0, N * .75);
      Tg(e + 544 | 0, i, g, s, u, v[e + 560 >> 2], v[e + 564 >> 2], v[e + 568 >> 2], v[e + 572 >> 2]);
      s = v[e + 552 >> 2];
      u = v[e + 556 >> 2];
      i = v[e + 544 >> 2];
      g = v[e + 548 >> 2];
     }
     if ((c | 0) > 111) {
      break ga;
     }
     BR(e + 464 | 0, i, g, s, u, 0, 0, 0, 1073676288);
     if (fn(v[e + 464 >> 2], v[e + 468 >> 2], v[e + 472 >> 2], v[e + 476 >> 2], 0, 0, 0, 0)) {
      break ga;
     }
     Tg(e + 448 | 0, i, g, s, u, 0, 0, 0, 1073676288);
     s = v[e + 456 >> 2];
     u = v[e + 460 >> 2];
     i = v[e + 448 >> 2];
     g = v[e + 452 >> 2];
    }
    Tg(e + 432 | 0, k, o, l, m, i, g, s, u);
    Hz(e + 416 | 0, v[e + 432 >> 2], v[e + 436 >> 2], v[e + 440 >> 2], v[e + 444 >> 2], A, D, F, G);
    l = v[e + 424 >> 2];
    m = v[e + 428 >> 2];
    k = v[e + 416 >> 2];
    o = v[e + 420 >> 2];
    ia: {
     if ((J - 2 | 0) >= (f & 2147483647)) {
      break ia;
     }
     v[e + 408 >> 2] = l;
     v[e + 412 >> 2] = m & 2147483647;
     v[e + 400 >> 2] = k;
     v[e + 404 >> 2] = o;
     Wd(e + 384 | 0, k, o, l, m, 0, 0, 0, 1073610752);
     d = xV(v[e + 400 >> 2], v[e + 404 >> 2], v[e + 408 >> 2], v[e + 412 >> 2], 1081081856);
     b = (d | 0) >= 0;
     l = b ? v[e + 392 >> 2] : l;
     m = b ? v[e + 396 >> 2] : m;
     k = b ? v[e + 384 >> 2] : k;
     o = b ? v[e + 388 >> 2] : o;
     x = b + x | 0;
     if (!(p & ((c | 0) != (h | 0) | (d | 0) < 0) & (fn(i, g, s, u, 0, 0, 0, 0) | 0) != 0) & (x + 110 | 0) <= (J | 0)) {
      break ia;
     }
     v[31476] = 68;
    }
    tI(e + 368 | 0, k, o, l, m, x);
    i = v[e + 376 >> 2];
    g = v[e + 380 >> 2];
    c = v[e + 372 >> 2];
    b = v[e + 368 >> 2];
   }
   v[r + 40 >> 2] = i;
   v[r + 44 >> 2] = g;
   v[r + 32 >> 2] = b;
   v[r + 36 >> 2] = c;
   eb = e + 8976 | 0;
   i = v[r + 40 >> 2];
   g = v[r + 44 >> 2];
   l = v[r + 32 >> 2];
   m = v[r + 36 >> 2];
   break a;
  }
  g = 0;
 }
 v[a >> 2] = l;
 v[a + 4 >> 2] = m;
 v[a + 8 >> 2] = i;
 v[a + 12 >> 2] = g;
 eb = r + 48 | 0;
}

function pK(a, b, c) {
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, x = 0, y = 0, D = 0, E = 0, F = 0, G = 0, H = C(0), I = 0;
 e = eb - 144 | 0;
 eb = e;
 d = Qb(e, 0, 144);
 v[d + 76 >> 2] = -1;
 v[d + 44 >> 2] = a;
 v[d + 32 >> 2] = 1250;
 v[d + 84 >> 2] = a;
 e = b;
 y = c;
 a = 0;
 j = eb - 304 | 0;
 eb = j;
 a: {
  b: {
   if (!v[d + 4 >> 2]) {
    At(d);
    if (!v[d + 4 >> 2]) {
     break b;
    }
   }
   c = w[e | 0];
   if (!c) {
    break a;
   }
   c: {
    d: {
     e: {
      f: {
       g: {
        while (1) {
         h: {
          b = c & 255;
          i: {
           if (dl(b)) {
            while (1) {
             c = e;
             e = e + 1 | 0;
             if (dl(w[c + 1 | 0])) {
              continue;
             }
             break;
            }
            Ai(d, 0, 0);
            while (1) {
             b = v[d + 4 >> 2];
             j: {
              if ((b | 0) != v[d + 104 >> 2]) {
               v[d + 4 >> 2] = b + 1;
               b = w[b | 0];
               break j;
              }
              b = sd(d);
             }
             if (dl(b)) {
              continue;
             }
             break;
            }
            e = v[d + 4 >> 2];
            b = v[d + 116 >> 2];
            if ((b | 0) > 0) {
             b = 1;
            } else {
             b = (b | 0) >= 0;
            }
            if (b) {
             e = e - 1 | 0;
             v[d + 4 >> 2] = e;
            }
            b = e - v[d + 44 >> 2] | 0;
            e = b;
            i = o + v[d + 124 >> 2] | 0;
            f = b >> 31;
            b = l + v[d + 120 >> 2] | 0;
            i = f + (b >>> 0 < l >>> 0 ? i + 1 | 0 : i) | 0;
            l = b + e | 0;
            o = l >>> 0 < b >>> 0 ? i + 1 | 0 : i;
            break i;
           }
           k: {
            l: {
             m: {
              if ((b | 0) == 37) {
               b = w[e + 1 | 0];
               if ((b | 0) == 42) {
                break m;
               }
               if ((b | 0) != 37) {
                break l;
               }
              }
              Ai(d, 0, 0);
              n: {
               if (w[e | 0] == 37) {
                while (1) {
                 b = v[d + 4 >> 2];
                 o: {
                  if ((b | 0) != v[d + 104 >> 2]) {
                   v[d + 4 >> 2] = b + 1;
                   c = w[b | 0];
                   break o;
                  }
                  c = sd(d);
                 }
                 if (dl(c)) {
                  continue;
                 }
                 break;
                }
                e = e + 1 | 0;
                break n;
               }
               b = v[d + 4 >> 2];
               if ((b | 0) != v[d + 104 >> 2]) {
                v[d + 4 >> 2] = b + 1;
                c = w[b | 0];
                break n;
               }
               c = sd(d);
              }
              if (w[e | 0] != (c | 0)) {
               a = v[d + 116 >> 2];
               if ((a | 0) > 0) {
                a = 1;
               } else {
                a = (a | 0) >= 0;
               }
               if (a) {
                v[d + 4 >> 2] = v[d + 4 >> 2] - 1;
               }
               if ((c | 0) >= 0 | x) {
                break a;
               }
               break b;
              }
              b = v[d + 4 >> 2] - v[d + 44 >> 2] | 0;
              f = b;
              g = b >> 31;
              b = o + v[d + 124 >> 2] | 0;
              c = l + v[d + 120 >> 2] | 0;
              h = (c >>> 0 < l >>> 0 ? b + 1 | 0 : b) + g | 0;
              l = c + f | 0;
              o = l >>> 0 < c >>> 0 ? h + 1 | 0 : h;
              c = e;
              break i;
             }
             k = 0;
             c = e + 2 | 0;
             break k;
            }
            b = b - 48 | 0;
            if (!(w[e + 2 | 0] != 36 | b >>> 0 > 9)) {
             c = eb - 16 | 0;
             v[c + 12 >> 2] = y;
             b = b >>> 0 > 1 ? ((b << 2) + y | 0) - 4 | 0 : y;
             v[c + 8 >> 2] = b + 4;
             k = v[b >> 2];
             c = e + 3 | 0;
             break k;
            }
            k = v[y >> 2];
            y = y + 4 | 0;
            c = e + 1 | 0;
           }
           q = 0;
           g = 0;
           e = w[c | 0];
           if (e - 48 >>> 0 <= 9) {
            while (1) {
             g = (B(g, 10) + e | 0) - 48 | 0;
             e = w[c + 1 | 0];
             c = c + 1 | 0;
             if (e - 48 >>> 0 < 10) {
              continue;
             }
             break;
            }
           }
           if ((e | 0) == 109) {
            n = 0;
            q = (k | 0) != 0;
            e = w[c + 1 | 0];
            a = 0;
            c = c + 1 | 0;
           }
           f = c;
           c = f + 1 | 0;
           b = 3;
           h = q;
           p: {
            q: {
             switch ((e & 255) - 65 | 0) {
             case 39:
              b = w[f + 1 | 0] == 104;
              c = b ? f + 2 | 0 : c;
              b = b ? -2 : -1;
              break p;

             case 43:
              b = w[f + 1 | 0] == 108;
              c = b ? f + 2 | 0 : c;
              b = b ? 3 : 1;
              break p;

             case 51:
             case 57:
              b = 1;
              break p;

             case 11:
              b = 2;
              break p;

             case 41:
              break p;

             case 0:
             case 2:
             case 4:
             case 5:
             case 6:
             case 18:
             case 23:
             case 26:
             case 32:
             case 34:
             case 35:
             case 36:
             case 37:
             case 38:
             case 40:
             case 45:
             case 46:
             case 47:
             case 50:
             case 52:
             case 55:
              break q;

             default:
              break d;
             }
            }
            b = 0;
            c = f;
           }
           f = b;
           b = w[c | 0];
           e = (b & 47) == 3;
           D = e ? 1 : f;
           p = e ? b | 32 : b;
           r: {
            if ((p | 0) == 91) {
             break r;
            }
            s: {
             if ((p | 0) != 110) {
              if ((p | 0) != 99) {
               break s;
              }
              g = (g | 0) <= 1 ? 1 : g;
              break r;
             }
             xI(k, D, l, o);
             break i;
            }
            Ai(d, 0, 0);
            while (1) {
             b = v[d + 4 >> 2];
             t: {
              if ((b | 0) != v[d + 104 >> 2]) {
               v[d + 4 >> 2] = b + 1;
               b = w[b | 0];
               break t;
              }
              b = sd(d);
             }
             if (dl(b)) {
              continue;
             }
             break;
            }
            e = v[d + 4 >> 2];
            b = v[d + 116 >> 2];
            if ((b | 0) > 0) {
             b = 1;
            } else {
             b = (b | 0) >= 0;
            }
            if (b) {
             e = e - 1 | 0;
             v[d + 4 >> 2] = e;
            }
            b = e - v[d + 44 >> 2] | 0;
            e = b;
            i = o + v[d + 124 >> 2] | 0;
            f = b >> 31;
            b = l + v[d + 120 >> 2] | 0;
            o = f + (b >>> 0 < l >>> 0 ? i + 1 | 0 : i) | 0;
            l = b + e | 0;
            o = l >>> 0 < b >>> 0 ? o + 1 | 0 : o;
           }
           r = g;
           m = g >> 31;
           Ai(d, g, m);
           b = v[d + 4 >> 2];
           u: {
            if ((b | 0) != v[d + 104 >> 2]) {
             v[d + 4 >> 2] = b + 1;
             break u;
            }
            if ((sd(d) | 0) < 0) {
             break e;
            }
           }
           b = v[d + 116 >> 2];
           if ((b | 0) > 0) {
            b = 1;
           } else {
            b = (b | 0) >= 0;
           }
           if (b) {
            v[d + 4 >> 2] = v[d + 4 >> 2] - 1;
           }
           e = 16;
           v: {
            w: {
             x: {
              y: {
               z: {
                switch (p - 88 | 0) {
                default:
                 b = p - 65 | 0;
                 if (b >>> 0 > 6 | !(1 << b & 113)) {
                  break v;
                 }

                case 9:
                case 13:
                case 14:
                case 15:
                 wI(j + 8 | 0, d, D, 0);
                 b = v[d + 4 >> 2] - v[d + 44 >> 2] | 0;
                 if (v[d + 120 >> 2] != (0 - b | 0) | v[d + 124 >> 2] != (0 - ((b >> 31) + ((b | 0) != 0) | 0) | 0)) {
                  break x;
                 }
                 break f;

                case 3:
                case 11:
                case 27:
                 if ((p | 16) == 115) {
                  Qb(j + 32 | 0, -1, 257);
                  t[j + 32 | 0] = 0;
                  if ((p | 0) != 115) {
                   break w;
                  }
                  t[j + 65 | 0] = 0;
                  t[j + 46 | 0] = 0;
                  u[j + 42 >> 1] = 0;
                  u[j + 44 >> 1] = 0;
                  break w;
                 }
                 e = w[c + 1 | 0];
                 f = (e | 0) == 94;
                 Qb(j + 32 | 0, f, 257);
                 t[j + 32 | 0] = 0;
                 b = f ? c + 2 | 0 : c + 1 | 0;
                 A: {
                  B: {
                   C: {
                    c = w[(f ? 2 : 1) + c | 0];
                    if ((c | 0) != 45) {
                     if ((c | 0) == 93) {
                      break C;
                     }
                     h = (e | 0) != 94;
                     break A;
                    }
                    h = (e | 0) != 94;
                    t[j + 78 | 0] = h;
                    break B;
                   }
                   h = (e | 0) != 94;
                   t[j + 126 | 0] = h;
                  }
                  b = b + 1 | 0;
                 }
                 c = b;
                 while (1) {
                  b = w[c | 0];
                  D: {
                   if ((b | 0) != 45) {
                    if (!b) {
                     break e;
                    }
                    if ((b | 0) == 93) {
                     break w;
                    }
                    break D;
                   }
                   b = 45;
                   f = w[c + 1 | 0];
                   if (!f | (f | 0) == 93) {
                    break D;
                   }
                   i = c + 1 | 0;
                   e = w[c - 1 | 0];
                   E: {
                    if (f >>> 0 <= e >>> 0) {
                     b = f;
                     break E;
                    }
                    while (1) {
                     e = e + 1 | 0;
                     t[e + (j + 32 | 0) | 0] = h;
                     b = w[i | 0];
                     if (e >>> 0 < b >>> 0) {
                      continue;
                     }
                     break;
                    }
                   }
                   c = i;
                  }
                  t[(b + j | 0) + 33 | 0] = h;
                  c = c + 1 | 0;
                  continue;
                 }
                 ;

                case 23:
                 e = 8;
                 break y;

                case 12:
                case 29:
                 e = 10;
                 break y;

                case 1:
                case 2:
                case 4:
                case 5:
                case 6:
                case 7:
                case 8:
                case 10:
                case 16:
                case 18:
                case 19:
                case 20:
                case 21:
                case 22:
                case 25:
                case 26:
                case 28:
                case 30:
                case 31:
                 break v;

                case 0:
                case 24:
                case 32:
                 break y;

                case 17:
                 break z;
                }
               }
               e = 0;
              }
              f = 0;
              i = 0;
              g = 0;
              h = 0;
              r = 0;
              E = eb - 16 | 0;
              eb = E;
              F: {
               if ((e | 0) == 1) {
                v[31476] = 28;
                break F;
               }
               while (1) {
                b = v[d + 4 >> 2];
                G: {
                 if ((b | 0) != v[d + 104 >> 2]) {
                  v[d + 4 >> 2] = b + 1;
                  b = w[b | 0];
                  break G;
                 }
                 b = sd(d);
                }
                if (dl(b)) {
                 continue;
                }
                break;
               }
               H: {
                I: {
                 switch (b - 43 | 0) {
                 case 0:
                 case 2:
                  break I;

                 default:
                  break H;
                 }
                }
                r = (b | 0) == 45 ? -1 : 0;
                b = v[d + 4 >> 2];
                if ((b | 0) != v[d + 104 >> 2]) {
                 v[d + 4 >> 2] = b + 1;
                 b = w[b | 0];
                 break H;
                }
                b = sd(d);
               }
               J: {
                K: {
                 L: {
                  M: {
                   if (!((e | 0) != 0 & (e | 0) != 16 | (b | 0) != 48)) {
                    b = v[d + 4 >> 2];
                    N: {
                     if ((b | 0) != v[d + 104 >> 2]) {
                      v[d + 4 >> 2] = b + 1;
                      b = w[b | 0];
                      break N;
                     }
                     b = sd(d);
                    }
                    if ((b & -33) == 88) {
                     e = 16;
                     b = v[d + 4 >> 2];
                     O: {
                      if ((b | 0) != v[d + 104 >> 2]) {
                       v[d + 4 >> 2] = b + 1;
                       b = w[b | 0];
                       break O;
                      }
                      b = sd(d);
                     }
                     if (w[b + 104529 | 0] < 16) {
                      break L;
                     }
                     b = v[d + 116 >> 2];
                     if ((b | 0) > 0) {
                      b = 1;
                     } else {
                      b = (b | 0) >= 0;
                     }
                     if (b) {
                      v[d + 4 >> 2] = v[d + 4 >> 2] - 1;
                     }
                     Ai(d, 0, 0);
                     break F;
                    }
                    if (e) {
                     break M;
                    }
                    e = 8;
                    break L;
                   }
                   e = e ? e : 10;
                   if (e >>> 0 > w[b + 104529 | 0]) {
                    break M;
                   }
                   b = v[d + 116 >> 2];
                   if ((b | 0) > 0) {
                    b = 1;
                   } else {
                    b = (b | 0) >= 0;
                   }
                   if (b) {
                    v[d + 4 >> 2] = v[d + 4 >> 2] - 1;
                   }
                   Ai(d, 0, 0);
                   v[31476] = 28;
                   break F;
                  }
                  if ((e | 0) != 10) {
                   break L;
                  }
                  g = b - 48 | 0;
                  if (g >>> 0 <= 9) {
                   b = 0;
                   while (1) {
                    b = B(b, 10) + g | 0;
                    f = b >>> 0 < 429496729;
                    e = v[d + 4 >> 2];
                    P: {
                     if ((e | 0) != v[d + 104 >> 2]) {
                      v[d + 4 >> 2] = e + 1;
                      e = w[e | 0];
                      break P;
                     }
                     e = sd(d);
                    }
                    g = e - 48 | 0;
                    if (f & g >>> 0 <= 9) {
                     continue;
                    }
                    break;
                   }
                   f = b;
                  }
                  if (g >>> 0 > 9) {
                   break J;
                  }
                  e = Aua(f, 0, 10, 0);
                  m = gb;
                  while (1) {
                   i = m;
                   f = e + g | 0;
                   i = f >>> 0 < g >>> 0 ? i + 1 | 0 : i;
                   e = (i | 0) == 429496729 & f >>> 0 < 2576980378 | i >>> 0 < 429496729;
                   b = v[d + 4 >> 2];
                   Q: {
                    if ((b | 0) != v[d + 104 >> 2]) {
                     v[d + 4 >> 2] = b + 1;
                     b = w[b | 0];
                     break Q;
                    }
                    b = sd(d);
                   }
                   h = b - 48 | 0;
                   if (!(e & h >>> 0 <= 9)) {
                    e = 10;
                    if (h >>> 0 <= 9) {
                     break K;
                    }
                    break J;
                   }
                   e = Aua(f, i, 10, 0);
                   m = gb;
                   g = h;
                   if ((m | 0) == -1 & (g ^ -1) >>> 0 >= e >>> 0 | (m | 0) != -1) {
                    continue;
                   }
                   break;
                  }
                  e = 10;
                  break K;
                 }
                 if (e - 1 & e) {
                  h = w[b + 104529 | 0];
                  if (h >>> 0 < e >>> 0) {
                   while (1) {
                    g = B(e, g) + h | 0;
                    f = g >>> 0 < 119304647;
                    b = v[d + 4 >> 2];
                    R: {
                     if ((b | 0) != v[d + 104 >> 2]) {
                      v[d + 4 >> 2] = b + 1;
                      b = w[b | 0];
                      break R;
                     }
                     b = sd(d);
                    }
                    h = w[b + 104529 | 0];
                    if (f & h >>> 0 < e >>> 0) {
                     continue;
                    }
                    break;
                   }
                   f = g;
                  }
                  if (e >>> 0 <= h >>> 0) {
                   break K;
                  }
                  while (1) {
                   g = Aua(f, i, e, 0);
                   m = gb;
                   h = h & 255;
                   if ((m | 0) == -1 & (h ^ -1) >>> 0 < g >>> 0) {
                    break K;
                   }
                   i = m;
                   f = g + h | 0;
                   i = f >>> 0 < h >>> 0 ? i + 1 | 0 : i;
                   b = v[d + 4 >> 2];
                   S: {
                    if ((b | 0) != v[d + 104 >> 2]) {
                     v[d + 4 >> 2] = b + 1;
                     b = w[b | 0];
                     break S;
                    }
                    b = sd(d);
                   }
                   h = w[b + 104529 | 0];
                   if (e >>> 0 <= h >>> 0) {
                    break K;
                   }
                   Lf(E, e, 0, 0, 0, f, i, 0, 0);
                   if (!(v[E + 8 >> 2] | v[E + 12 >> 2])) {
                    continue;
                   }
                   break;
                  }
                  break K;
                 }
                 m = t[(B(e, 23) >>> 5 & 7) + 104785 | 0];
                 g = w[b + 104529 | 0];
                 if (g >>> 0 < e >>> 0) {
                  while (1) {
                   h = h << m | g;
                   f = h >>> 0 < 134217728;
                   b = v[d + 4 >> 2];
                   T: {
                    if ((b | 0) != v[d + 104 >> 2]) {
                     v[d + 4 >> 2] = b + 1;
                     b = w[b | 0];
                     break T;
                    }
                    b = sd(d);
                   }
                   g = w[b + 104529 | 0];
                   if (f & g >>> 0 < e >>> 0) {
                    continue;
                   }
                   break;
                  }
                  f = h;
                 }
                 if (e >>> 0 <= g >>> 0) {
                  break K;
                 }
                 s = m & 31;
                 if ((m & 63) >>> 0 >= 32) {
                  h = 0;
                  s = -1 >>> s | 0;
                 } else {
                  h = -1 >>> s | 0;
                  s = h | (1 << s) - 1 << 32 - s;
                 }
                 if (!h & f >>> 0 > s >>> 0) {
                  break K;
                 }
                 while (1) {
                  F = g & 255;
                  g = f;
                  b = m & 31;
                  if ((m & 63) >>> 0 >= 32) {
                   i = f << b;
                   b = 0;
                  } else {
                   i = (1 << b) - 1 & g >>> 32 - b | i << b;
                   b = g << b;
                  }
                  f = F | b;
                  b = v[d + 4 >> 2];
                  U: {
                   if ((b | 0) != v[d + 104 >> 2]) {
                    v[d + 4 >> 2] = b + 1;
                    b = w[b | 0];
                    break U;
                   }
                   b = sd(d);
                  }
                  g = w[b + 104529 | 0];
                  if (e >>> 0 <= g >>> 0) {
                   break K;
                  }
                  if ((i | 0) == (h | 0) & f >>> 0 <= s >>> 0 | i >>> 0 < h >>> 0) {
                   continue;
                  }
                  break;
                 }
                }
                if (w[b + 104529 | 0] >= e >>> 0) {
                 break J;
                }
                while (1) {
                 b = v[d + 4 >> 2];
                 V: {
                  if ((b | 0) != v[d + 104 >> 2]) {
                   v[d + 4 >> 2] = b + 1;
                   b = w[b | 0];
                   break V;
                  }
                  b = sd(d);
                 }
                 if (w[b + 104529 | 0] < e >>> 0) {
                  continue;
                 }
                 break;
                }
                v[31476] = 68;
                f = -1;
                i = -1;
                r = 0;
               }
               b = v[d + 116 >> 2];
               if ((b | 0) > 0) {
                b = 1;
               } else {
                b = (b | 0) >= 0;
               }
               if (b) {
                v[d + 4 >> 2] = v[d + 4 >> 2] - 1;
               }
               b = f ^ r;
               f = b - r | 0;
               e = r >> 31;
               i = (e ^ i) - ((b >>> 0 < r >>> 0) + e | 0) | 0;
              }
              eb = E + 16 | 0;
              b = v[d + 4 >> 2] - v[d + 44 >> 2] | 0;
              if (v[d + 120 >> 2] == (0 - b | 0) & v[d + 124 >> 2] == (0 - ((b >> 31) + ((b | 0) != 0) | 0) | 0)) {
               break f;
              }
              if (!(!k | (p | 0) != 112)) {
               v[k >> 2] = f;
               break v;
              }
              xI(k, D, f, i);
              break v;
             }
             if (!k) {
              break v;
             }
             b = v[j + 16 >> 2];
             f = v[j + 20 >> 2];
             e = v[j + 8 >> 2];
             g = v[j + 12 >> 2];
             W: {
              switch (D | 0) {
              case 0:
               G = k, H = XG(e, g, b, f), z[G >> 2] = H;
               break v;

              case 1:
               G = k, I = Fx(e, g, b, f), A[G >> 3] = I;
               break v;

              case 2:
               break W;

              default:
               break v;
              }
             }
             v[k >> 2] = e;
             v[k + 4 >> 2] = g;
             v[k + 8 >> 2] = b;
             v[k + 12 >> 2] = f;
             break v;
            }
            i = (p | 0) != 99;
            b = i ? 31 : g + 1 | 0;
            X: {
             if ((D | 0) == 1) {
              g = k;
              if (q) {
               g = Fd(b << 2);
               if (!g) {
                break g;
               }
              }
              v[j + 296 >> 2] = 0;
              v[j + 300 >> 2] = 0;
              e = 0;
              while (1) {
               a = g;
               Y: {
                while (1) {
                 f = v[d + 4 >> 2];
                 Z: {
                  if ((f | 0) != v[d + 104 >> 2]) {
                   v[d + 4 >> 2] = f + 1;
                   f = w[f | 0];
                   break Z;
                  }
                  f = sd(d);
                 }
                 if (!w[(f + j | 0) + 33 | 0]) {
                  break Y;
                 }
                 t[j + 27 | 0] = f;
                 f = fq(j + 28 | 0, j + 27 | 0, 1, j + 296 | 0);
                 if ((f | 0) == -2) {
                  continue;
                 }
                 if ((f | 0) == -1) {
                  n = 0;
                  break e;
                 }
                 if (a) {
                  v[(e << 2) + a >> 2] = v[j + 28 >> 2];
                  e = e + 1 | 0;
                 }
                 if (!q | (b | 0) != (e | 0)) {
                  continue;
                 }
                 break;
                }
                h = 1;
                n = 0;
                e = b;
                b = b << 1 | 1;
                g = Vv(a, b << 2);
                if (g) {
                 continue;
                }
                break d;
               }
               break;
              }
              n = 0;
              b = a;
              f = j + 296 | 0;
              if (f) {
               f = v[f >> 2];
              } else {
               f = 0;
              }
              if (f) {
               break e;
              }
              break X;
             }
             if (q) {
              e = 0;
              g = Fd(b);
              if (!g) {
               break g;
              }
              while (1) {
               a = g;
               while (1) {
                f = v[d + 4 >> 2];
                _: {
                 if ((f | 0) != v[d + 104 >> 2]) {
                  v[d + 4 >> 2] = f + 1;
                  f = w[f | 0];
                  break _;
                 }
                 f = sd(d);
                }
                if (!w[(f + j | 0) + 33 | 0]) {
                 b = 0;
                 n = a;
                 break X;
                }
                t[a + e | 0] = f;
                e = e + 1 | 0;
                if ((e | 0) != (b | 0)) {
                 continue;
                }
                break;
               }
               h = 1;
               e = b;
               b = b << 1 | 1;
               g = Vv(a, b);
               if (g) {
                continue;
               }
               break;
              }
              n = a;
              a = 0;
              break d;
             }
             e = 0;
             if (k) {
              while (1) {
               a = v[d + 4 >> 2];
               $: {
                if ((a | 0) != v[d + 104 >> 2]) {
                 v[d + 4 >> 2] = a + 1;
                 a = w[a | 0];
                 break $;
                }
                a = sd(d);
               }
               if (w[(a + j | 0) + 33 | 0]) {
                t[e + k | 0] = a;
                e = e + 1 | 0;
                continue;
               } else {
                b = 0;
                a = k;
                n = a;
                break X;
               }
              }
             }
             while (1) {
              a = v[d + 4 >> 2];
              aa: {
               if ((a | 0) != v[d + 104 >> 2]) {
                v[d + 4 >> 2] = a + 1;
                a = w[a | 0];
                break aa;
               }
               a = sd(d);
              }
              if (w[(a + j | 0) + 33 | 0]) {
               continue;
              }
              break;
             }
             a = 0;
             n = 0;
             b = 0;
            }
            g = v[d + 4 >> 2];
            f = v[d + 116 >> 2];
            if ((f | 0) > 0) {
             f = 1;
            } else {
             f = (f | 0) >= 0;
            }
            if (f) {
             g = g - 1 | 0;
             v[d + 4 >> 2] = g;
            }
            g = g - v[d + 44 >> 2] | 0;
            f = g + v[d + 120 >> 2] | 0;
            h = v[d + 124 >> 2] + (g >> 31) | 0;
            h = f >>> 0 < g >>> 0 ? h + 1 | 0 : h;
            if (!(h | f) | !(i | (f | 0) == (r | 0) & (h | 0) == (m | 0))) {
             break h;
            }
            if (q) {
             v[k >> 2] = a;
            }
            ba: {
             if ((p | 0) == 99) {
              break ba;
             }
             if (b) {
              v[(e << 2) + b >> 2] = 0;
             }
             if (!n) {
              n = 0;
              break ba;
             }
             t[e + n | 0] = 0;
            }
            a = b;
           }
           b = v[d + 4 >> 2] - v[d + 44 >> 2] | 0;
           f = b;
           g = b >> 31;
           b = o + v[d + 124 >> 2] | 0;
           e = l + v[d + 120 >> 2] | 0;
           i = (e >>> 0 < l >>> 0 ? b + 1 | 0 : b) + g | 0;
           l = e + f | 0;
           o = l >>> 0 < e >>> 0 ? i + 1 | 0 : i;
           x = ((k | 0) != 0) + x | 0;
          }
          e = c + 1 | 0;
          c = w[c + 1 | 0];
          if (c) {
           continue;
          }
          break a;
         }
         break;
        }
        a = b;
        break f;
       }
       h = 1;
       n = 0;
       a = 0;
       break d;
      }
      h = q;
      break c;
     }
     h = q;
    }
    x = x ? x : -1;
   }
   if (!h) {
    break a;
   }
   Bb(n);
   Bb(a);
   break a;
  }
  x = -1;
 }
 eb = j + 304 | 0;
 eb = d + 144 | 0;
 return x;
}

function fR(a, b) {
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0;
 l = eb - 16 | 0;
 eb = l;
 a: {
  if (x[v[v[a + 48 >> 2] + 12 >> 2] + 480188 >> 1] != x[v[v[b + 48 >> 2] + 12 >> 2] + 480188 >> 1]) {
   break a;
  }
  if ((a | 0) != (b | 0)) {
   c = v[b >> 2];
   g = v[b + 4 >> 2];
   d = Fk(c, g);
   f = eb - 16 | 0;
   eb = f;
   b: {
    if (iw(a) >>> 0 >= d >>> 0) {
     h = v[a >> 2];
     i = Fk(h, v[a + 4 >> 2]);
     if (i >>> 0 < d >>> 0) {
      e = eb - 16 | 0;
      eb = e;
      v[e + 12 >> 2] = c;
      v[e + 12 >> 2] = v[e + 12 >> 2] + B(i, 6);
      eb = e + 16 | 0;
      e = v[e + 12 >> 2];
      vA(c, e, h);
      tA(a, e, g, d - Fk(v[a >> 2], v[a + 4 >> 2]) | 0);
      break b;
     }
     jR(f + 8 | 0, c, g, h);
     Id(a, v[f + 12 >> 2]);
     break b;
    }
    gR(a);
    vZ(a, uD(a, d));
    tA(a, c, g, d);
   }
   eb = f + 16 | 0;
  }
  v[a + 12 >> 2] = v[b + 12 >> 2];
  v[a + 16 >> 2] = v[b + 16 >> 2];
  v[a + 20 >> 2] = v[b + 20 >> 2];
  eR(a + 24 | 0, b + 24 | 0);
  EE(a + 36 | 0, b + 36 | 0);
  if (v[v[v[a + 48 >> 2] + 12 >> 2] + 480180 >> 2] == v[v[v[b + 48 >> 2] + 12 >> 2] + 480180 >> 2]) {
   break a;
  }
  c = vb(v[a >> 2]);
  v[l + 12 >> 2] = c;
  m = vb(v[a + 4 >> 2]);
  while (1) {
   if (!Hb(c, m)) {
    break a;
   }
   d = 0;
   g = eb - 112 | 0;
   eb = g;
   k = v[v[a + 48 >> 2] + 12 >> 2];
   f = v[k + 480180 >> 2];
   h = v[v[v[b + 48 >> 2] + 12 >> 2] + 480180 >> 2];
   c: {
    if ((f | 0) == (h | 0)) {
     break c;
    }
    e = w[c + 3 | 0];
    d: {
     e: {
      if ((f | 0) != 16) {
       break e;
      }
      i = w[c + 5 | 0];
      if (!((e | 0) != 19 | (i | 0) != 144)) {
       t[c + 3 | 0] = 0;
       f = 1;
       break d;
      }
      d = 5;
      f = 1;
      if ((e | 0) != 5) {
       break e;
      }
      t[c + 5 | 0] = i >>> 1 & 7 | i & 240;
      break d;
     }
     if (!((h | 0) == 67108864 | (e | 0) != 45)) {
      t[c + 5 | 0] = 159;
      d = 20;
      t[c + 3 | 0] = 20;
      break d;
     }
     if ((e | 0) != 46) {
      d = e;
      break d;
     }
     d = 13;
     t[c + 3 | 0] = 13;
     t[c + 5 | 0] = w[c + 5 | 0] + 3 >>> 2;
    }
    n = (f | 0) == 32 | (f | 0) == 16777216 | (f | 0) == 2;
    f: {
     g: {
      h: {
       i: {
        j: {
         k: {
          if ((h | 0) == 2) {
           e = 9;
           j = 1;
           i = QD(2);
           if ((d & 255) != 9) {
            break k;
           }
           t[c + 5 | 0] = w[c + 5 | 0] + 1 >>> 1;
           break h;
          }
          j = (h | 0) == 32 | (h | 0) == 16777216;
          e = 9;
          i = QD(h);
          if ((d & 255) != 9) {
           break k;
          }
          if ((f | 0) != 2) {
           break h;
          }
          e = w[c + 5 | 0];
          if ((e | 0) != 164) {
           break j;
          }
          t[c + 5 | 0] = 145;
          d = h & 16777248 ? 20 : 28;
          t[c + 3 | 0] = d;
          break g;
         }
         if ((d & 255) != 32) {
          e = d;
          break h;
         }
         d = v[i + 84 >> 2];
         if (Ti(d, 32)) {
          break i;
         }
         e = 31;
         if (!Ti(d, 31)) {
          break i;
         }
         t[c + 3 | 0] = 31;
         break h;
        }
        o = c, p = ri(e << 1), t[o + 5 | 0] = p;
        break g;
       }
       e = 32;
      }
      l: {
       if ((f | 0) == 16777216) {
        d = w[c | 0];
        m: {
         if (!Vg(d)) {
          d = e;
          break m;
         }
         j = v[i + 84 >> 2];
         d = (d | 0) == 252 ? 31 : 32;
         if (!Ti(j, d)) {
          d = Ti(j, 31) ? 31 : 0;
         }
         u[g + 4 >> 1] = 999;
         o = g, p = Bj(e, w[c + 5 | 0]), u[o + 110 >> 1] = p;
         o = c, p = (B(x[Nc(g + 4 | 0, g + 110 | 0) >> 1], 127) >>> 0) / 999 | 0, t[o + 5 | 0] = p;
         t[c + 2 | 0] = 0;
         t[c + 3 | 0] = d;
         t[c | 0] = 0;
         t[c + 1 | 0] = 0;
        }
        n: {
         o: {
          p: {
           e = d & 255;
           switch (e - 33 | 0) {
           case 1:
            break g;

           case 2:
           case 3:
            break n;

           case 0:
            break o;

           default:
            break p;
           }
          }
          if ((e | 0) != 20) {
           break g;
          }
          d = w[c + 5 | 0];
          if ((d & 240) != 112 | (d & 15) >>> 0 < 13) {
           break l;
          }
          t[c + 5 | 0] = 124;
          break l;
         }
         d = 20;
         t[c + 3 | 0] = 20;
         t[c + 5 | 0] = w[c + 5 | 0] >>> 4 | 208;
         break g;
        }
        q: {
         j = t[c + 5 | 0];
         r: {
          if ((j | 0) >= 0) {
           t[c + 3 | 0] = 3;
           e = -128 - j | 0;
           d = 3;
           break r;
          }
          e = 128;
          if ((j | 0) == -128) {
           break q;
          }
          t[c + 3 | 0] = 2;
          e = j & 127;
          d = 2;
         }
         t[c + 5 | 0] = e;
         if ((e & 255) >>> 0 > 30) {
          break q;
         }
         t[c + 5 | 0] = e + 1 >>> 1 | 224;
         break g;
        }
        t[g + 4 | 0] = (e & 255) + 7 >>> 3;
        t[g + 110 | 0] = 15;
        o = c, p = w[Pb(g + 4 | 0, g + 110 | 0) | 0] | 240, t[o + 5 | 0] = p;
        break g;
       }
       d = e;
       s: {
        switch (f - 1 | 0) {
        case 0:
        case 3:
         break s;

        default:
         break g;
        }
       }
       if (!j) {
        break g;
       }
       t: {
        u: {
         v: {
          w: {
           x: {
            y: {
             z: {
              A: {
               B: {
                C: {
                 d = d & 255;
                 switch (d - 1 | 0) {
                 case 2:
                  break x;

                 case 1:
                  break y;

                 case 0:
                  break B;

                 default:
                  break C;
                 }
                }
                D: {
                 switch (d - 25 | 0) {
                 case 1:
                 case 2:
                  break f;

                 case 4:
                  break u;

                 case 0:
                  break v;

                 case 3:
                  break w;

                 default:
                  break D;
                 }
                }
                if ((d | 0) == 13) {
                 break z;
                }
                if ((d | 0) == 19) {
                 break A;
                }
                if ((d | 0) != 37) {
                 break f;
                }
                t[c + 3 | 0] = 0;
                break f;
               }
               if (w[c + 5 | 0]) {
                break f;
               }
               t[c + 3 | 0] = 0;
               break f;
              }
              Lr(c);
              break f;
             }
             E: {
              switch (w[c + 2 | 0]) {
              case 0:
              case 1:
               t[c + 2 | 0] = 1;
               t[c + 3 | 0] = 0;
               d = w[c + 5 | 0];
               t[c + 5 | 0] = 0;
               t[c + 4 | 0] = d >>> 0 >= 64 ? 64 : d;
               break f;

              case 2:
               break E;

              default:
               break f;
              }
             }
             qg(c + 4 | 0, c + 5 | 0);
             t[c + 2 | 0] = 1;
             if (w[c + 4 | 0] >= 65) {
              t[c + 4 | 0] = 64;
             }
             t[c + 3 | 0] = 20;
             t[c + 5 | 0] = w[c + 5 | 0] >>> 2 | 128;
             break f;
            }
            if (w[c + 5 | 0] < 224) {
             break f;
            }
            t[c + 5 | 0] = 223;
            break f;
           }
           if (w[c + 5 | 0] < 224) {
            break f;
           }
           t[c + 5 | 0] = 223;
           break f;
          }
          d = w[c + 5 | 0];
          e = d - 16 >>> 4 | 0;
          if (e >>> 0 > 9) {
           break f;
          }
          if (!(1 << e & 880)) {
           if (!e) {
            break t;
           }
           if ((e | 0) != 1) {
            break f;
           }
           t[c + 3 | 0] = 3;
           t[c + 5 | 0] = d & 15 | 224;
           break f;
          }
          t[c + 3 | 0] = 20;
          if (!(h & 2) | (d | 0) != 145) {
           break f;
          }
          t[c + 5 | 0] = 164;
          t[c + 3 | 0] = 9;
          break f;
         }
         if (w[c | 0]) {
          break f;
         }
         t[c + 3 | 0] = 20;
         t[c | 0] = (h | 0) == 2 ? -2 : -1;
         d = w[c + 5 | 0];
         if (!d) {
          t[c + 1 | 0] = 0;
         }
         t[c + 5 | 0] = d & 15 | 208;
         break f;
        }
        d = w[c + 5 | 0];
        if (d >>> 0 >= 16) {
         t[g + 4 | 0] = 14;
         t[g + 110 | 0] = d >>> 4;
         o = c, p = w[Pb(g + 4 | 0, g + 110 | 0) | 0] | 240, t[o + 5 | 0] = p;
         break f;
        }
        t[g + 4 | 0] = 14;
        t[g + 110 | 0] = d;
        o = c, p = w[Pb(g + 4 | 0, g + 110 | 0) | 0] << 4 | 15, t[o + 5 | 0] = p;
        break f;
       }
       t[c + 3 | 0] = 2;
       t[c + 5 | 0] = d & 15 | 224;
       break f;
      }
      d = 20;
     }
     F: {
      if (!n) {
       break F;
      }
      G: {
       switch (h - 1 | 0) {
       case 0:
       case 3:
        break G;

       default:
        break F;
       }
      }
      H: {
       I: {
        switch (w[c | 0] - 253 | 0) {
        case 1:
         t[c | 0] = 0;
         if (!(d & 255 ? (h | 0) == 4 : 0)) {
          t[c + 5 | 0] = 0;
          t[c + 3 | 0] = 13;
          break f;
         }
         t[c + 4 | 0] = 0;
         t[c + 2 | 0] = 1;
         break H;

        case 0:
         break I;

        default:
         break H;
        }
       }
       t[c | 0] = 255;
      }
      J: {
       K: {
        L: {
         M: {
          N: {
           O: {
            P: {
             Q: {
              R: {
               e = d & 255;
               switch (e - 2 | 0) {
               case 2:
               case 3:
               case 6:
               case 7:
               case 8:
               case 10:
               case 11:
               case 12:
               case 14:
               case 16:
               case 17:
                break f;

               case 13:
                break J;

               case 15:
                break L;

               case 1:
                break M;

               case 0:
                break N;

               case 9:
                break O;

               case 4:
               case 5:
                break P;

               case 18:
                break Q;

               default:
                break R;
               }
              }
              if ((e | 0) != 29) {
               break f;
              }
              d = w[c + 5 | 0];
              e = d & 15;
              if ((e | 0) != 15 | d >>> 0 < 16) {
               break K;
              }
              t[c + 5 | 0] = d >>> 4;
              break f;
             }
             S: {
              if (w[c + 3 | 0] != 20) {
               break S;
              }
              t[c + 3 | 0] = 19;
              T: {
               U: {
                V: {
                 W: {
                  X: {
                   Y: {
                    Z: {
                     _: {
                      d = w[c + 5 | 0];
                      switch (d - 16 >>> 4 | 0) {
                      case 4:
                      case 5:
                      case 8:
                      case 9:
                       break T;

                      case 6:
                       break U;

                      case 10:
                       break V;

                      case 7:
                       break W;

                      case 3:
                       break X;

                      case 2:
                       break Y;

                      case 1:
                       break Z;

                      case 0:
                       break _;

                      default:
                       break S;
                      }
                     }
                     t[c + 5 | 0] = d & 15 | 48;
                     break S;
                    }
                    t[c + 5 | 0] = d & 175 ^ 120;
                    break S;
                   }
                   t[c + 5 | 0] = d & 15 | 64;
                   break S;
                  }
                  t[c + 5 | 0] = d & 15 | 112;
                  break S;
                 }
                 t[c + 3 | 0] = 9;
                 t[c + 5 | 0] = B(d & 15, 17);
                 break S;
                }
                t[c + 5 | 0] = d & 15 | 96;
                break S;
               }
               t[c + 3 | 0] = 0;
               break S;
              }
              t[c + 3 | 0] = 28;
             }
             break f;
            }
            if (w[c + 2 | 0]) {
             break O;
            }
            e = w[c + 5 | 0];
            j = e & 15;
            if (!((j | 0) == 15 & e >>> 0 >= 16) & (!j | (e & 240) != 240)) {
             break O;
            }
            e = 11;
            $: {
             switch ((d & 255) - 6 | 0) {
             case 1:
              e = 8;

             case 0:
              t[c + 2 | 0] = e;
              break;

             default:
              break $;
             }
            }
            t[c + 4 | 0] = 0;
           }
           d = w[c + 5 | 0];
           e = d & 15;
           if (!((e | 0) != 15 | d >>> 0 < 16)) {
            t[c + 3 | 0] = 19;
            t[c + 5 | 0] = d >>> 4 | 160;
            break f;
           }
           if (!e | (d & 240) != 240) {
            break f;
           }
           t[c + 3 | 0] = 19;
           t[c + 5 | 0] = e | 176;
           break f;
          }
          d = w[c + 5 | 0];
          if (d >>> 0 >= 240) {
           t[c + 3 | 0] = 19;
           t[c + 5 | 0] = d & 31;
           break f;
          }
          if (d >>> 0 >= 224) {
           d = d & 15;
           if ((h | 0) == 4) {
            t[c + 3 | 0] = 28;
            t[c + 5 | 0] = d | 16;
            break f;
           }
           t[c + 3 | 0] = 19;
           t[c + 5 | 0] = d + 3 >>> 2 | 16;
           break f;
          }
          t[c + 3 | 0] = 2;
          break f;
         }
         d = w[c + 5 | 0];
         if (d >>> 0 >= 240) {
          t[c + 3 | 0] = 19;
          t[c + 5 | 0] = d & 47;
          break f;
         }
         if (d >>> 0 >= 224) {
          if ((h | 0) == 4) {
           t[c + 3 | 0] = 28;
           t[c + 5 | 0] = d & 47;
           break f;
          }
          t[c + 3 | 0] = 19;
          t[c + 5 | 0] = (d & 15) + 3 >>> 2 | 32;
          break f;
         }
         t[c + 3 | 0] = 3;
         break f;
        }
        if (w[c + 5 | 0] > 31) {
         break f;
        }
        t[c + 3 | 0] = 0;
        break f;
       }
       if (!(!e | (d & 240) != 240)) {
        t[c + 5 | 0] = d << 4;
        break f;
       }
       if (e) {
        t[c + 5 | 0] = 240;
        break f;
       }
       if (!d) {
        break f;
       }
       t[c + 5 | 0] = 15;
       break f;
      }
      d = w[c + 5 | 0];
      if ((d - 1 & 255) >>> 0 > 14) {
       break f;
      }
      t[c + 5 | 0] = d | 128;
      break f;
     }
     if ((f | 0) != 16777216 & (f | 0) != 32 | (h | 0) != 2) {
      break f;
     }
     aa: {
      switch (w[c | 0] - 253 | 0) {
      case 0:
      case 2:
       t[c | 0] = 254;
       break;

      default:
       break aa;
      }
     }
     ba: {
      switch ((d & 255) - 20 | 0) {
      case 0:
       d = w[c + 5 | 0];
       e = d & 240;
       if ((e | 0) != 144) {
        if ((e | 0) != 112) {
         break f;
        }
        t[c + 3 | 0] = 0;
        break f;
       }
       ca: {
        switch (d - 144 | 0) {
        case 1:
         t[c + 5 | 0] = 164;
         t[c + 3 | 0] = 9;
         break f;

        case 0:
         break ca;

        default:
         break f;
        }
       }
       t[c + 5 | 0] = 64;
       t[c + 3 | 0] = 9;
       break f;

      case 3:
       break ba;

      default:
       break f;
      }
     }
     t[g + 4 | 0] = 128;
     o = c, p = w[Pb(g + 4 | 0, c + 5 | 0) | 0] + 1 >>> 1 | 0, t[o + 5 | 0] = p;
    }
    da: {
     ea: {
      fa: {
       ga: {
        ha: {
         ia: {
          ja: {
           if (!((f | 0) != 16777216 & (f | 0) != 32)) {
            if ((h | 0) != 4) {
             break ja;
            }
            d = w[c + 3 | 0];
            if ((d | 0) == 23) {
             break ia;
            }
            if ((d | 0) != 5) {
             break ga;
            }
            d = w[c + 5 | 0];
            t[c + 5 | 0] = (d & 15) + 1 >>> 1 | d & 240;
            break ha;
           }
           if ((f | 0) != 4) {
            break ja;
           }
           ka: {
            la: {
             switch (h - 1 | 0) {
             default:
              if ((h | 0) == 32 | (h | 0) == 16777216) {
               break ka;
              }
              break;

             case 1:
             case 2:
              break la;

             case 0:
             case 3:
              break ha;
             }
            }
            d = w[c + 3 | 0];
            break ea;
           }
           d = w[c + 3 | 0];
           if ((d | 0) != 23) {
            if ((d | 0) != 5) {
             break ja;
            }
            d = w[c + 5 | 0];
            t[g + 4 | 0] = d << 1 & 30;
            t[g + 110 | 0] = 15;
            o = c, p = w[Pb(g + 4 | 0, g + 110 | 0) | 0] | d & 240, t[o + 5 | 0] = p;
            break ja;
           }
           t[g + 4 | 0] = 64;
           o = c, p = w[Pb(g + 4 | 0, c + 5 | 0) | 0] << 1, t[o + 5 | 0] = p;
          }
          ma: {
           switch (h - 1 | 0) {
           case 0:
           case 3:
            break ha;

           default:
            break ma;
           }
          }
          d = w[c + 3 | 0];
          break fa;
         }
         t[g + 4 | 0] = 128;
         o = c, p = w[Pb(g + 4 | 0, c + 5 | 0) | 0] + 1 >>> 1 | 0, t[o + 5 | 0] = p;
        }
        d = w[c + 3 | 0];
       }
       na: {
        switch ((d & 255) - 16 | 0) {
        case 0:
         t[g + 4 | 0] = 31;
         o = c, p = w[Pb(c + 5 | 0, g + 4 | 0) | 0], t[o + 5 | 0] = p;
         d = 16;
         break fa;

        case 1:
         break na;

        default:
         break fa;
        }
       }
       t[g + 4 | 0] = 32;
       o = c, p = w[cf(c + 5 | 0, g + 4 | 0) | 0], t[o + 5 | 0] = p;
       d = 17;
      }
      oa: {
       if ((f | 0) != 1) {
        break oa;
       }
       pa: {
        qa: {
         ra: {
          sa: {
           ta: {
            ua: {
             va: {
              e = d & 255;
              switch (e - 2 | 0) {
              case 2:
              case 3:
              case 6:
              case 7:
              case 8:
               break oa;

              case 0:
              case 1:
              case 9:
               break sa;

              case 5:
               break ta;

              case 4:
               break ua;

              default:
               break va;
              }
             }
             switch (e - 19 | 0) {
             case 1:
              break qa;

             case 0:
              break ra;

             default:
              break oa;
             }
            }
            d = 6;
            if (w[c + 5 | 0]) {
             break oa;
            }
            e = 4;
            break pa;
           }
           d = 7;
           if (w[c + 5 | 0]) {
            break oa;
           }
           e = 5;
           break pa;
          }
          if (w[c + 5 | 0]) {
           break oa;
          }
          e = 0;
          break pa;
         }
         d = 19;
         j = w[c + 5 | 0];
         e = j + 96 | 0;
         e = (e << 4 | (e & 240) >>> 4) & 255;
         if (!(e >>> 0 > 8 | !(1 << e & 387))) {
          t[c + 3 | 0] = 0;
          d = 0;
         }
         e = 0;
         if (j >>> 0 > 239) {
          break pa;
         }
         break oa;
        }
        d = 20;
        e = 0;
        if (w[c + 5 | 0] < 240) {
         break oa;
        }
       }
       t[c + 3 | 0] = e;
       d = e;
      }
      if ((h | 0) != 1) {
       break ea;
      }
      wa: {
       xa: {
        ya: {
         za: {
          Aa: {
           if (Dl(w[c | 0])) {
            t[c | 0] = 0;
            Ba: {
             Ca: {
              e = d & 255;
              switch (e - 15 | 0) {
              case 1:
              case 2:
              case 3:
               break wa;

              case 0:
               break Aa;

              case 4:
               break Ba;

              default:
               break Ca;
              }
             }
             if (e) {
              break wa;
             }
             t[c + 5 | 0] = 0;
             d = 13;
             t[c + 3 | 0] = 13;
             break wa;
            }
            f = w[c + 5 | 0];
            if ((f & 240) != 208) {
             break ya;
            }
            t[c + 5 | 0] = f & 207;
            break wa;
           }
           Da: {
            e = d & 255;
            switch (e - 15 | 0) {
            case 1:
            case 2:
            case 3:
             break wa;

            case 4:
             break za;

            case 0:
             break Aa;

            default:
             break Da;
            }
           }
           if (!e) {
            break xa;
           }
           break wa;
          }
          d = 19;
          t[c + 3 | 0] = 19;
          t[c + 5 | 0] = w[c + 5 | 0] & 15 | 144;
          break wa;
         }
         f = w[c + 5 | 0];
        }
        if ((f & 255) >>> 0 < 240) {
         break wa;
        }
        t[c + 3 | 0] = 0;
       }
       d = 0;
       Ea: {
        switch (w[c + 2 | 0] - 1 | 0) {
        case 0:
         d = 13;
         t[c + 3 | 0] = 13;
         t[c + 5 | 0] = w[c + 4 | 0];
         break wa;

        case 1:
         d = 9;
         t[c + 3 | 0] = 9;
         e = w[c + 4 | 0];
         t[c + 5 | 0] = e >>> 0 >= 64 ? -1 : e << 2;
         break wa;

        case 3:
         d = 11;
         t[c + 3 | 0] = 11;
         t[c + 5 | 0] = w[c + 4 | 0];
         break wa;

        case 2:
         d = 11;
         t[c + 3 | 0] = 11;
         t[c + 5 | 0] = w[c + 4 | 0] << 4;
         break wa;

        case 5:
         d = 19;
         t[c + 3 | 0] = 19;
         t[c + 5 | 0] = w[c + 4 | 0] | 176;
         break wa;

        case 4:
         d = 19;
         t[c + 3 | 0] = 19;
         t[c + 5 | 0] = w[c + 4 | 0] | 160;
         break wa;

        case 12:
         d = 3;
         t[c + 3 | 0] = 3;
         t[c + 5 | 0] = w[c + 4 | 0] << 2;
         break wa;

        case 11:
         d = 2;
         t[c + 3 | 0] = 2;
         t[c + 5 | 0] = w[c + 4 | 0] << 2;
         break wa;

        case 10:
         d = 4;
         t[c + 3 | 0] = 4;
         t[c + 5 | 0] = w[c + 4 | 0] << 2;
         break wa;

        case 7:
         d = 5;
         t[c + 3 | 0] = 5;
         t[c + 5 | 0] = w[c + 4 | 0];
         break wa;

        case 6:
         break Ea;

        default:
         break wa;
        }
       }
       d = 5;
       t[c + 3 | 0] = 5;
       t[c + 5 | 0] = w[c + 4 | 0] << 4;
      }
      t[c + 2 | 0] = 0;
      break da;
     }
     if (!(d & 255 | (h | 0) != 2)) {
      d = 0;
      Fa: {
       switch (w[c + 2 | 0] - 3 | 0) {
       case 1:
        t[c + 2 | 0] = 0;
        t[c + 3 | 0] = 11;
        t[c + 5 | 0] = w[c + 4 | 0];
        d = 11;
        break da;

       case 0:
        t[c + 2 | 0] = 0;
        t[c + 3 | 0] = 11;
        t[c + 5 | 0] = w[c + 4 | 0] << 4;
        d = 11;
        break da;

       case 3:
        t[c + 2 | 0] = 0;
        t[c + 3 | 0] = 11;
        t[c + 5 | 0] = w[c + 4 | 0] | 240;
        d = 11;
        break da;

       case 2:
        t[c + 2 | 0] = 0;
        t[c + 3 | 0] = 11;
        t[c + 5 | 0] = w[c + 4 | 0] << 4 | 15;
        d = 11;
        break da;

       case 10:
        t[c + 2 | 0] = 0;
        t[c + 3 | 0] = 3;
        t[c + 5 | 0] = w[c + 4 | 0] << 2;
        d = 3;
        break da;

       case 9:
        t[c + 2 | 0] = 0;
        t[c + 3 | 0] = 2;
        d = 2;
        t[c + 5 | 0] = w[c + 4 | 0] << 2;
        break da;

       case 8:
        t[c + 2 | 0] = 0;
        t[c + 3 | 0] = 4;
        t[c + 5 | 0] = w[c + 4 | 0] << 2;
        d = 4;
        break da;

       case 5:
        t[c + 2 | 0] = 0;
        t[c + 3 | 0] = 5;
        t[c + 5 | 0] = w[c + 4 | 0];
        d = 5;
        break da;

       case 4:
        t[c + 2 | 0] = 0;
        t[c + 3 | 0] = 5;
        t[c + 5 | 0] = w[c + 4 | 0] << 4;
        d = 5;
        break da;

       case 6:
        t[c + 2 | 0] = 0;
        t[c + 3 | 0] = 29;
        t[c + 5 | 0] = w[c + 4 | 0] << 4;
        d = 29;
        break da;

       case 7:
        break Fa;

       default:
        break da;
       }
      }
      t[c + 2 | 0] = 0;
      t[c + 3 | 0] = 29;
      t[c + 5 | 0] = w[c + 4 | 0];
      d = 29;
      break da;
     }
     if ((h | 0) == 4) {
      f = w[c | 0];
      if (!(f | (w[c + 5 | 0] & 240) != 208 | (d & 255) != 19)) {
       f = 0;
       t[c + 5 | 0] = 0;
       t[c + 3 | 0] = 0;
       d = 0;
      }
      Ga: {
       if (Dl(f)) {
        t[c + 1 | 0] = 0;
        e = d & 255;
        if (!e) {
         break Ga;
        }
        if ((e | 0) != 19) {
         break da;
        }
        d = 19;
        e = w[c + 5 | 0];
        if ((e & 240) != 208) {
         break da;
        }
        d = 25;
        t[c + 3 | 0] = 25;
        t[c | 0] = 0;
        t[c + 5 | 0] = e & 15;
        break da;
       }
       if (d & 255) {
        break da;
       }
      }
      Ha: {
       switch (w[c + 2 | 0] - 11 | 0) {
       case 2:
        t[c + 2 | 0] = 0;
        t[c + 3 | 0] = 3;
        t[c + 5 | 0] = w[c + 4 | 0] << 2;
        d = 3;
        break da;

       case 1:
        t[c + 2 | 0] = 0;
        t[c + 3 | 0] = 2;
        d = 2;
        t[c + 5 | 0] = w[c + 4 | 0] << 2;
        break da;

       case 0:
        break Ha;

       default:
        break da;
       }
      }
      t[c + 2 | 0] = 0;
      t[c + 3 | 0] = 4;
      t[c + 5 | 0] = w[(w[c + 4 | 0] & 15) + 42112 | 0];
      d = 4;
      break da;
     }
     if ((h | 0) != 16777216 & (h | 0) != 32) {
      break da;
     }
     Ia: {
      if (d & 255 | ((f | 0) == 32 | (f | 0) == 16777216)) {
       break Ia;
      }
      d = 0;
      Ja: {
       Ka: {
        switch (w[c + 2 | 0] - 7 | 0) {
        case 2:
         t[c + 3 | 0] = 29;
         e = w[c + 4 | 0] << 4;
         d = 29;
         break Ja;

        case 3:
         t[c + 3 | 0] = 29;
         e = w[c + 4 | 0];
         d = 29;
         break Ja;

        case 0:
         t[c + 3 | 0] = 5;
         e = w[c + 4 | 0] << 4;
         d = 5;
         break Ja;

        case 4:
         break Ka;

        default:
         break Ia;
        }
       }
       t[c + 3 | 0] = 4;
       e = w[c + 4 | 0] << 4;
       d = 4;
      }
      t[c + 2 | 0] = 0;
      t[c + 5 | 0] = e;
     }
     e = w[c + 2 | 0];
     if (e >>> 0 > 15 | !(1 << e & 47480)) {
      break da;
     }
     t[g + 4 | 0] = 9;
     o = c, p = w[Pb(c + 4 | 0, g + 4 | 0) | 0], t[o + 4 | 0] = p;
    }
    La: {
     if (w[c + 2 | 0] != 15) {
      break La;
     }
     if ($v(v[i + 88 >> 2], 15)) {
      break La;
     }
     e = d & 255;
     if (!(!e | (e | 0) == 10)) {
      if (Ti(v[i + 84 >> 2], e)) {
       break La;
      }
     }
     t[c + 2 | 0] = 0;
     t[c + 3 | 0] = 10;
     Ma: {
      Na: {
       f = w[c + 1 | 0];
       if (!f) {
        break Na;
       }
       d = w[c + 5 | 0];
       if (x[k + 480192 >> 1] >= f >>> 0) {
        h = w[c | 0];
        Oa: {
         if (!Tc(h)) {
          break Oa;
         }
         j = v[((f << 2) + k | 0) + 900380 >> 2];
         if (!j) {
          break Oa;
         }
         f = x[$b(j + 236 | 0, h - 1 | 0) >> 1];
        }
        if (!(f & 65535)) {
         break Na;
        }
       }
       f = f & 65535;
       if (f >>> 0 > x[k + 480190 >> 1]) {
        break Na;
       }
       h = w[c + 4 | 0];
       _v(g + 4 | 0);
       if (h >>> 0 > 9) {
        break Na;
       }
       d = (e | 0) == 10 ? d : 0;
       e = mi(k, f);
       f = w[c + 4 | 0];
       if (!f) {
        e = Aua(v[e >> 2], 0, d & 255, 0);
        d = gb;
        e = e + 32768 | 0;
        d = e >>> 0 < 32768 ? d + 1 | 0 : d;
        d = ri(Ac((d & 65535) << 16 | e >>> 16, d >>> 16 | 0));
        break Ma;
       }
       d = ri((v[xb(e + 68 | 0, f - 1 | 0) >> 2] + ((d & 255) << 8) | 0) + 128 >>> 8 | 0);
       break Ma;
      }
      d = w[c + 4 | 0] << 3;
     }
     t[c + 5 | 0] = d;
     d = w[c + 3 | 0];
    }
    Pa: {
     Qa: {
      e = d & 255;
      switch (e - 42 | 0) {
      case 0:
      case 2:
       break Qa;

      default:
       break Pa;
      }
     }
     if (Ti(v[i + 84 >> 2], e)) {
      break Pa;
     }
     d = 10;
     t[c + 3 | 0] = 10;
    }
    f = w[c | 0];
    Ra: {
     if (f >>> 0 >= w[i + 8 | 0]) {
      e = 1;
      if (f >>> 0 <= w[i + 9 | 0]) {
       break Ra;
      }
     }
     if (Dl(f)) {
      Sa: {
       switch (f - 253 | 0) {
       case 1:
        e = w[i + 70 | 0] != 0;
        break Ra;

       case 2:
        e = w[i + 71 | 0] != 0;
        break Ra;

       case 0:
        e = w[i + 72 | 0] != 0;
        break Ra;

       default:
        break Sa;
       }
      }
      e = v[i >> 2] == 16777216;
      break Ra;
     }
     e = !f;
    }
    if (!e) {
     t[c | 0] = 0;
    }
    if (!Ti(v[i + 84 >> 2], d & 255)) {
     t[c + 3 | 0] = 0;
    }
    if ($v(v[i + 88 >> 2], w[c + 2 | 0])) {
     break c;
    }
    t[c + 2 | 0] = 0;
   }
   eb = g + 112 | 0;
   c = v[sg(l + 12 | 0) >> 2];
   continue;
  }
 }
 eb = l + 16 | 0;
 return a;
}

function wua(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, q = 0, r = 0, s = 0, y = 0, z = 0;
 e = eb - 272 | 0;
 eb = e;
 xc(b);
 a: {
  b: {
   c: {
    d: {
     if (Or(b, 18420)) {
      n = Eb(e + 260 | 0);
      v[31601] = 0;
      g = O(230, b | 0, n | 0) | 0;
      d = v[31601];
      v[31601] = 0;
      e: {
       if ((d | 0) != 1) {
        if (!g) {
         break e;
        }
        v[31601] = 0;
        i = e + 253 | 0;
        g = O(245, b | 0, i | 0) | 0;
        d = v[31601];
        v[31601] = 0;
        f: {
         if ((d | 0) == 1) {
          break f;
         }
         if (!g) {
          break e;
         }
         if (!w0(w[e + 253 | 0], w[e + 254 | 0])) {
          break e;
         }
         i = Ac(v0(i), gb);
         g = v[b + 8 >> 2];
         d = v[b >> 2];
         v[31601] = 0;
         g = T(150, d | 0, g | 0, i | 0) | 0;
         d = v[31601];
         v[31601] = 0;
         if ((d | 0) == 1) {
          break f;
         }
         if (!g) {
          break e;
         }
         f = 1;
         if ((c | 0) == 64) {
          break e;
         }
         v[31601] = 0;
         N(246, a | 0, 4096);
         d = v[31601];
         v[31601] = 0;
         if ((d | 0) == 1) {
          break f;
         }
         v[31601] = 0;
         N(247, a + 1298308 | 0, n | 0);
         d = v[31601];
         v[31601] = 0;
         if ((d | 0) == 1) {
          break f;
         }
         d = w[e + 255 | 0];
         u[a + 480188 >> 1] = 32;
         u[a + 480192 >> 1] = d;
         Th(a, 1);
         v[31601] = 0;
         f = O(1, e + 240 | 0, 9476) | 0;
         d = v[31601];
         v[31601] = 0;
         g: {
          h: {
           i: {
            j: {
             k: {
              l: {
               m: {
                n: {
                 o: {
                  if ((d | 0) != 1) {
                   yb(a + 1298344 | 0, f);
                   sb(f);
                   v[31601] = 0;
                   f = O(1, e + 228 | 0, 7105) | 0;
                   d = v[31601];
                   v[31601] = 0;
                   if ((d | 0) == 1) {
                    break o;
                   }
                   yb(a + 1298356 | 0, f);
                   sb(f);
                   v[31601] = 0;
                   g = e + 32 | 0;
                   V(248, g | 0);
                   d = v[31601];
                   v[31601] = 0;
                   if ((d | 0) == 1) {
                    break n;
                   }
                   t[e + 204 | 0] = w[e + 254 | 0];
                   v[31601] = 0;
                   t[e | 0] = w[e + 253 | 0];
                   f = e + 216 | 0;
                   N(249, f | 0, e | 0);
                   d = v[31601];
                   v[31601] = 0;
                   if ((d | 0) == 1) {
                    break m;
                   }
                   v[31601] = 0;
                   i = e + 80 | 0;
                   U(250, i | 0, g | 0, e + 204 | 0, f | 0);
                   d = v[31601];
                   v[31601] = 0;
                   if ((d | 0) == 1) {
                    break l;
                   }
                   yb(a + 1298368 | 0, i);
                   sb(i);
                   sb(f);
                   Db(g);
                   y = a, z = v[Ec(i, 4) >> 2], v[y + 1298404 >> 2] = z;
                   if (w[e + 253 | 0] < 2) {
                    break h;
                   }
                   u[e + 80 >> 1] = 8192;
                   v[31601] = 0;
                   f = Q(189, b | 0) | 0;
                   d = v[31601];
                   v[31601] = 0;
                   if ((d | 0) == 1) {
                    break j;
                   }
                   u[e + 32 >> 1] = f;
                   y = a, z = B(x[qe(i, g) >> 1], 1e4) >>> 8 | 0, v[y + 480204 >> 2] = z;
                   v[31601] = 0;
                   t[e + 80 | 0] = 1;
                   f = Q(197, b | 0) | 0;
                   d = v[31601];
                   v[31601] = 0;
                   if ((d | 0) == 1) {
                    break i;
                   }
                   t[e + 32 | 0] = f;
                   y = a, z = w[cf(i, g) | 0], v[y + 480196 >> 2] = z;
                   v[31601] = 0;
                   O(183, b | 0, 3) | 0;
                   d = v[31601];
                   v[31601] = 0;
                   if ((d | 0) != 1) {
                    v[31601] = 0;
                    f = Q(189, b | 0) | 0;
                    d = v[31601];
                    v[31601] = 0;
                    if ((d | 0) != 1) {
                     break g;
                    }
                   }
                   b = M() | 0;
                   break a;
                  }
                  b = M() | 0;
                  break a;
                 }
                 b = M() | 0;
                 break a;
                }
                b = M() | 0;
                break a;
               }
               b = M() | 0;
               break k;
              }
              b = M() | 0;
              sb(e + 216 | 0);
             }
             Db(e + 32 | 0);
             break a;
            }
            b = M() | 0;
            break a;
           }
           b = M() | 0;
           break a;
          }
          t[e + 80 | 0] = 32;
          v[31601] = 0;
          f = Q(197, b | 0) | 0;
          d = v[31601];
          v[31601] = 0;
          p: {
           if ((d | 0) != 1) {
            t[e + 32 | 0] = f;
            y = a, z = B(w[cf(e + 80 | 0, e + 32 | 0) | 0], 1e4), v[y + 480204 >> 2] = z;
            v[31601] = 0;
            t[e + 80 | 0] = 1;
            f = Q(197, b | 0) | 0;
            d = v[31601];
            v[31601] = 0;
            if ((d | 0) == 1) {
             break p;
            }
            t[e + 32 | 0] = f;
            y = a, z = w[cf(e + 80 | 0, e + 32 | 0) | 0], v[y + 480196 >> 2] = z;
            v[31601] = 0;
            f = Q(197, b | 0) | 0;
            d = v[31601];
            v[31601] = 0;
            if ((d | 0) != 1) {
             break g;
            }
            b = M() | 0;
            break a;
           }
           b = M() | 0;
           break a;
          }
          b = M() | 0;
          break a;
         }
         v[a + 480208 >> 2] = f >>> 2 & 16 | 12;
         o = a + 484380 | 0;
         s = a + 946304 | 0;
         l = Mb(e + 216 | 0);
         j = e + 80 | 12;
         m = Mb(e + 204 | 0);
         q = 1;
         while (1) {
          q: {
           r: {
            d = q & 65535;
            if (d >>> 0 > x[a + 480192 >> 1]) {
             break r;
            }
            v[31601] = 0;
            h = T(251, a | 0, d | 0, 0) | 0;
            d = v[31601];
            v[31601] = 0;
            s: {
             if ((d | 0) == 1) {
              break s;
             }
             if (!h) {
              break r;
             }
             v[31601] = 0;
             f = O(240, b | 0, h + 492 | 0) | 0;
             d = v[31601];
             v[31601] = 0;
             if ((d | 0) == 1) {
              break s;
             }
             if (!f) {
              break r;
             }
             v[31601] = 0;
             r = Q(197, b | 0) | 0;
             d = v[31601];
             v[31601] = 0;
             t: {
              u: {
               v: {
                if ((d | 0) != 1) {
                 d = e + 80 | 0;
                 Qb(d, 0, 120);
                 if (!r) {
                  break q;
                 }
                 w: {
                  if (w[e + 253 | 0]) {
                   v[31601] = 0;
                   f = O(252, b | 0, d | 0) | 0;
                   d = v[31601];
                   v[31601] = 0;
                   if ((d | 0) == 1) {
                    break v;
                   }
                   if (!f) {
                    break q;
                   }
                   if (w[e + 253 | 0]) {
                    break w;
                   }
                  }
                  d = Yb(e + 72 | 0, j, 96);
                  f = v[d >> 2];
                  d = v[d + 4 >> 2];
                  v[31601] = 0;
                  Xn(159, e + 32 | 0, b, f, d);
                  d = v[31601];
                  v[31601] = 0;
                  if ((d | 0) == 1) {
                   break u;
                  }
                  if (!v[e + 36 >> 2]) {
                   break q;
                  }
                 }
                 d = h + 236 | 0;
                 f = 0;
                 break t;
                }
                b = M() | 0;
                break b;
               }
               b = M() | 0;
               break b;
              }
              b = M() | 0;
              break b;
             }
             while (1) {
              if ((f | 0) != 120) {
               y = $b(d, f), z = (w[(e + 80 | 0) + f | 0] + x[a + 480190 >> 1] | 0) + 1 | 0, u[y >> 1] = z;
               f = f + 1 | 0;
               continue;
              }
              break;
             }
             v[31601] = 0;
             i = h + 48 | 0;
             R(253, e | 0, i | 0, b | 0);
             d = v[31601];
             v[31601] = 0;
             if ((d | 0) == 1) {
              break c;
             }
             v[31601] = 0;
             g = h + 68 | 0;
             R(253, e + 16 | 0, g | 0, b | 0);
             d = v[31601];
             v[31601] = 0;
             if ((d | 0) == 1) {
              break c;
             }
             v[31601] = 0;
             f = h + 88 | 0;
             R(253, e - -64 | 0, f | 0, b | 0);
             d = v[31601];
             v[31601] = 0;
             if ((d | 0) == 1) {
              break c;
             }
             v[31601] = 0;
             N(254, b | 0, e + 56 | 0);
             d = v[31601];
             v[31601] = 0;
             if ((d | 0) == 1) {
              break d;
             }
             v[h >> 2] = (w[e + 57 | 0] | w[e + 58 | 0] << 8) & 4095;
             d = w[e + 57 | 0] | w[e + 58 | 0] << 8;
             BE(w[e + 59 | 0] | w[e + 60 | 0] << 8, i, 0);
             BE(w[e + 59 | 0] | w[e + 60 | 0] << 8, g, 1);
             BE(w[e + 59 | 0] | w[e + 60 | 0] << 8, f, 2);
             y = e, z = vb(v[h + 48 >> 2]), v[y + 32 >> 2] = z;
             f = d >>> 12 | 0;
             d = vb(v[h + 52 >> 2]);
             while (1) {
              g = v[e + 32 >> 2];
              if (Hb(g, d)) {
               t[e + 28 | 0] = 64;
               t[e + 54 | 0] = ((w[g + 2 | 0] << 6) - -64 >>> 0) / 127;
               y = g, z = w[Pb(e + 28 | 0, e + 54 | 0) | 0], t[y + 2 | 0] = z;
               Xe(e + 32 | 0);
               continue;
              } else {
               y = e, z = vb(v[h + 68 >> 2]), v[y + 32 >> 2] = z;
               d = vb(v[h + 72 >> 2]);
              }
              break;
             }
             while (1) {
              g = v[e + 32 >> 2];
              if (Hb(g, d)) {
               t[e + 28 | 0] = 64;
               t[e + 54 | 0] = ((w[g + 2 | 0] << 6) + 128 >>> 0) / 255;
               y = g, z = w[Pb(e + 28 | 0, e + 54 | 0) | 0], t[y + 2 | 0] = z;
               Xe(e + 32 | 0);
               continue;
              }
              break;
             }
             y = e, z = vb(v[h + 88 >> 2]), v[y + 32 >> 2] = z;
             k = f & 3;
             i = vb(v[h + 92 >> 2]);
             while (1) {
              f = v[e + 32 >> 2];
              if (Hb(f, i)) {
               g = t[f + 2 | 0];
               d = g >> 31 ^ -1;
               g = g ^ -128;
               h = k & 31;
               if ((k & 63) >>> 0 >= 32) {
                d = g << h;
                h = 0;
               } else {
                d = (1 << h) - 1 & g >>> 32 - h | d << h;
                h = g << h;
               }
               x: {
                if ((d | 0) >= -1 & h >>> 0 >= 4294967292 | (d | 0) >= 0) {
                 g = h + 4 | 0;
                 d = (((g >>> 0 < 4 ? d + 1 | 0 : d) & 7) << 29 | g >>> 3) & 536870911;
                 g = 0;
                 break x;
                }
                g = 0 - ((h >>> 0 > 3) + d | 0) | 0;
                d = 3 - h | 0;
                g = ((g & 7) << 29 | d >>> 3) & 536870911;
                d = 0 - g | 0;
                g = 0 - ((g | 0) != 0) | 0;
               }
               y = f, z = Fc(d, g) ^ 128, t[y + 2 | 0] = z;
               Xe(e + 32 | 0);
               continue;
              } else {
               d = x[a + 480190 >> 1] + 1 | 0;
               u[e + 54 >> 1] = d;
               f = 0;
               h = d & 65535;
               d = 4e3 - h | 0;
               k = d >>> 0 <= 4e3 ? d : 0;
               y: {
                z: {
                 A: {
                  while (1) {
                   if ((f | 0) == (r | 0)) {
                    break z;
                   }
                   if ((f | 0) == (k | 0)) {
                    v[31601] = 0;
                    O(183, b | 0, 20) | 0;
                    d = v[31601];
                    v[31601] = 0;
                    if ((d | 0) != 1) {
                     break z;
                    }
                    b = M() | 0;
                    break b;
                   }
                   v[31601] = 0;
                   i = f + h | 0;
                   O(240, b | 0, s + (i << 5) | 0) | 0;
                   d = v[31601];
                   v[31601] = 0;
                   if ((d | 0) == 1) {
                    break y;
                   }
                   v[31601] = 0;
                   g = e + 32 | 0;
                   N(255, b | 0, g | 0);
                   d = v[31601];
                   v[31601] = 0;
                   B: {
                    if ((d | 0) == 1) {
                     break B;
                    }
                    v[31601] = 0;
                    N(256, g | 0, B(i, 104) + o | 0);
                    d = v[31601];
                    v[31601] = 0;
                    if ((d | 0) == 1) {
                     break B;
                    }
                    v[31601] = 0;
                    u[e + 28 >> 1] = w[e + 56 | 0] | f << 8 & 32512 | ((w[e + 51 | 0] & 3) != 0) << 15;
                    N(257, m | 0, e + 28 | 0);
                    d = v[31601];
                    v[31601] = 0;
                    if ((d | 0) == 1) {
                     break A;
                    }
                    f = f + 1 | 0;
                    continue;
                   }
                   break;
                  }
                  b = M() | 0;
                  break b;
                 }
                 b = M() | 0;
                 break b;
                }
                v[31601] = 0;
                N(257, l | 0, e + 54 | 0);
                d = v[31601];
                v[31601] = 0;
                if ((d | 0) != 1) {
                 v[e + 32 >> 2] = 3999;
                 v[e + 28 >> 2] = r + x[a + 480190 >> 1];
                 y = a, z = v[Bd(e + 32 | 0, e + 28 | 0) >> 2], u[y + 480190 >> 1] = z;
                 break q;
                }
                b = M() | 0;
                break b;
               }
               b = M() | 0;
               break b;
              }
             }
            }
            b = M() | 0;
            break b;
           }
           g = Eb(e + 80 | 0);
           v[31601] = 0;
           f = O(230, b | 0, g | 0) | 0;
           d = v[31601];
           v[31601] = 0;
           C: {
            D: {
             E: {
              F: {
               G: {
                if ((d | 0) != 1) {
                 H: {
                  if (f) {
                   v[31601] = 0;
                   f = e + 32 | 0;
                   R(258, f | 0, 21, g | 0);
                   d = v[31601];
                   v[31601] = 0;
                   if ((d | 0) == 1) {
                    break H;
                   }
                   yb(a + 1298320 | 0, f);
                   sb(f);
                  }
                  sb(g);
                  g = a + 480280 | 0;
                  f = 0;
                  I: {
                   while (1) {
                    if ((f | 0) == 32) {
                     v[31601] = 0;
                     f = O(259, b | 0, e + 16 | 0) | 0;
                     d = v[31601];
                     v[31601] = 0;
                     if ((d | 0) == 1) {
                      break E;
                     }
                     if (!f) {
                      break F;
                     }
                     g = v[e + 16 >> 2];
                     if (g >>> 0 < 12) {
                      break G;
                     }
                     f = v[b + 8 >> 2];
                     d = v[b >> 2];
                     v[31601] = 0;
                     f = T(150, d | 0, f | 0, g - 11 | 0) | 0;
                     d = v[31601];
                     v[31601] = 0;
                     if ((d | 0) == 1) {
                      break E;
                     }
                     if (f) {
                      break I;
                     }
                     break G;
                    }
                    d = g + (f << 5) | 0;
                    Ve(d);
                    v[31601] = 0;
                    N(231, b | 0, d + 9 | 0);
                    d = v[31601];
                    v[31601] = 0;
                    if ((d | 0) != 1) {
                     f = f + 1 | 0;
                     continue;
                    }
                    break;
                   }
                   b = M() | 0;
                   break b;
                  }
                  d = v[e + 16 >> 2] - 11 | 0;
                  v[e + 64 >> 2] = d;
                  h = Mb(e + 80 | 0);
                  v[31601] = 0;
                  R(234, b | 0, h | 0, d | 0);
                  d = v[31601];
                  v[31601] = 0;
                  J: {
                   if ((d | 0) != 1) {
                    v[e + 32 >> 2] = 50529027;
                    d = e + 32 | 0;
                    y = e, z = B(v[Gb(e - -64 | 0, d) >> 2], 85), v[y + 56 >> 2] = z;
                    j = Eb(d);
                    v[e >> 2] = v[e + 20 >> 2];
                    d = v[Gb(e + 56 | 0, e) >> 2];
                    v[31601] = 0;
                    N(114, j | 0, d | 0);
                    d = v[31601];
                    v[31601] = 0;
                    K: {
                     if ((d | 0) == 1) {
                      break K;
                     }
                     f = 0;
                     L: {
                      while (1) {
                       d = v[e + 64 >> 2];
                       if (d >>> 0 <= f >>> 0) {
                        break L;
                       }
                       k = v[h >> 2];
                       g = t[wb(k, f) | 0];
                       i = d;
                       d = f + 1 | 0;
                       if (!((g | 0) != -1 | i - d >>> 0 < 2)) {
                        i = t[wb(k, d) | 0];
                        g = w[wb(k, f + 2 | 0) | 0];
                        d = v[ub(e + 12 | 0, Cf(j)) >> 2];
                        v[31601] = 0;
                        U(237, j | 0, d | 0, g | 0, i | 0);
                        d = v[31601];
                        v[31601] = 0;
                        if ((d | 0) != 1) {
                         f = f + 3 | 0;
                         continue;
                        }
                        break K;
                       }
                       v[31601] = 0;
                       N(115, j | 0, g | 0);
                       g = v[31601];
                       v[31601] = 0;
                       f = d;
                       if ((g | 0) != 1) {
                        continue;
                       }
                       break;
                      }
                      break K;
                     }
                     v[31601] = 0;
                     R(235, e | 0, 21, j | 0);
                     d = v[31601];
                     v[31601] = 0;
                     if ((d | 0) != 1) {
                      M: {
                       i = yb(j, e);
                       sb(e);
                       g = Jb(i);
                       f = w[i + 11 | 0];
                       d = v[i + 4 >> 2];
                       v[31601] = 0;
                       $(236, a + 1298332 | 0, g | 0, Zc(d, f) | 0, 74, 0);
                       d = v[31601];
                       v[31601] = 0;
                       if ((d | 0) == 1) {
                        break M;
                       }
                       sb(i);
                       ec(h);
                       break G;
                      }
                     }
                    }
                    b = M() | 0;
                    sb(j);
                    break J;
                   }
                   b = M() | 0;
                  }
                  ec(h);
                  break b;
                 }
                }
                b = M() | 0;
                sb(g);
                break b;
               }
               f = w[a + 484376 | 0];
               d = v[a + 484360 >> 2];
               v[31601] = 0;
               R(238, Wb(d, f) | 0, b | 0, w[e + 258 | 0] | w[e + 259 | 0] << 8);
               d = v[31601];
               v[31601] = 0;
               if ((d | 0) == 1) {
                break E;
               }
               i = c & 1;
               if (i) {
                v[31601] = 0;
                N(223, a + 484344 | 0, w[e + 256 | 0] | w[e + 257 | 0] << 8);
                d = v[31601];
                v[31601] = 0;
                if ((d | 0) == 1) {
                 break E;
                }
               }
               k = a + 484344 | 0;
               f = 0;
               while (1) {
                N: {
                 if ((w[e + 256 | 0] | w[e + 257 | 0] << 8) >>> 0 > f >>> 0) {
                  g = v[b + 8 >> 2];
                  d = v[b >> 2];
                  v[31601] = 0;
                  g = T(150, d | 0, g | 0, 4) | 0;
                  d = v[31601];
                  v[31601] = 0;
                  if ((d | 0) == 1) {
                   break C;
                  }
                  if (g) {
                   break N;
                  }
                 }
                 if (!(c & 2)) {
                  break F;
                 }
                 f = 0;
                 while (1) {
                  c = x[a + 480190 >> 1];
                  if (f >>> 0 >= c >>> 0) {
                   f = 0;
                   while (1) {
                    if (c >>> 0 <= f >>> 0) {
                     break F;
                    }
                    g = x[$b(v[m >> 2], f) >> 1];
                    b = g & 255;
                    O: {
                     if (!b) {
                      break O;
                     }
                     d = v[l >> 2];
                     b = b - 1 & 65535;
                     if (_c(d, v[l + 4 >> 2]) >>> 0 <= b >>> 0) {
                      break O;
                     }
                     b = x[$b(d, b) >> 1] + (g >>> 8 & 127) & 65535;
                     if (b >>> 0 > c >>> 0) {
                      break O;
                     }
                     i = B(b, 104) + o | 0;
                     c = v[i >> 2];
                     if (!ke(c, v[i + 20 >> 2])) {
                      break O;
                     }
                     b = x[i + 34 >> 1];
                     g = B(f, 104) + o | 0;
                     d = g + 104 | 0;
                     v[d >> 2] = c;
                     u[g + 138 >> 1] = x[g + 138 >> 1] & 65534 | b & 1;
                     if (!Fh(d)) {
                      break O;
                     }
                     yc(v[d + 20 >> 2], v[i + 20 >> 2], Nk(v[i >> 2], x[i + 34 >> 1]));
                    }
                    f = f + 1 | 0;
                    c = x[a + 480190 >> 1];
                    continue;
                   }
                  }
                  c = x[$b(v[m >> 2], f) >> 1];
                  if (c & 255) {
                   f = f + 1 | 0;
                   continue;
                  }
                  f = f + 1 | 0;
                  d = B(f, 104) + o | 0;
                  c = Yc(e + 80 | 0, u[d + 34 >> 1] & 1 ? 16 : 8, 1, 0, c << 16 >> 16 < 0 ? 6 : 0);
                  v[31601] = 0;
                  T(215, c | 0, d | 0, b | 0) | 0;
                  c = v[31601];
                  v[31601] = 0;
                  if ((c | 0) != 1) {
                   continue;
                  }
                  break;
                 }
                 b = M() | 0;
                 break b;
                }
                v[31601] = 0;
                g = Q(151, b | 0) | 0;
                d = v[31601];
                v[31601] = 0;
                P: {
                 Q: {
                  R: {
                   S: {
                    if ((d | 0) != 1) {
                     v[31601] = 0;
                     h = e + 32 | 0;
                     R(185, h | 0, b | 0, g | 0);
                     d = v[31601];
                     v[31601] = 0;
                     if ((d | 0) == 1) {
                      break S;
                     }
                     j = gc(e + 80 | 0, h);
                     tb(h);
                     if (!i) {
                      break Q;
                     }
                     v[31601] = 0;
                     g = Q(197, j | 0) | 0;
                     d = v[31601];
                     v[31601] = 0;
                     if ((d | 0) == 1) {
                      break P;
                     }
                     v[31601] = 0;
                     O(183, j | 0, 1) | 0;
                     d = v[31601];
                     v[31601] = 0;
                     if ((d | 0) == 1) {
                      break P;
                     }
                     v[31601] = 0;
                     g = T(196, k | 0, f & 65535, g + 1 | 0) | 0;
                     d = v[31601];
                     v[31601] = 0;
                     if ((d | 0) == 1) {
                      break P;
                     }
                     if (!g) {
                      break Q;
                     }
                     v[31601] = 0;
                     g = O(232, j | 0, h | 0) | 0;
                     d = v[31601];
                     v[31601] = 0;
                     if ((d | 0) == 1) {
                      break D;
                     }
                     if (!g) {
                      break R;
                     }
                     d = v[k >> 2];
                     v[31601] = 0;
                     N(233, Vb(d, f) | 0, h | 0);
                     d = v[31601];
                     v[31601] = 0;
                     if ((d | 0) != 1) {
                      break R;
                     }
                     break D;
                    }
                    b = M() | 0;
                    break b;
                   }
                   b = M() | 0;
                   break b;
                  }
                  d = v[k >> 2];
                  v[31601] = 0;
                  R(239, Vb(d, f) | 0, 1, j | 0);
                  d = v[31601];
                  v[31601] = 0;
                  if ((d | 0) == 1) {
                   break D;
                  }
                 }
                 tb(j);
                 f = f + 1 | 0;
                 continue;
                }
                break;
               }
               break D;
              }
              nd(m);
              nd(l);
              f = 1;
              break e;
             }
             b = M() | 0;
             break b;
            }
            b = M() | 0;
            tb(j);
            break b;
           }
           b = M() | 0;
           break b;
          }
          q = q + 1 | 0;
          continue;
         }
        }
        b = M() | 0;
        break a;
       }
       b = M() | 0;
       break a;
      }
      sb(n);
     }
     eb = e + 272 | 0;
     return f | 0;
    }
    b = M() | 0;
    break b;
   }
   b = M() | 0;
  }
  nd(m);
  nd(l);
 }
 sb(n);
 P(b | 0);
 p();
}

function l2(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, q = 0, r = 0, s = 0, u = 0, z = 0, A = 0, C = 0;
 e = eb - 1456 | 0;
 eb = e;
 xc(b);
 Lp(a);
 a: {
  b: {
   c: {
    d = e + 1432 | 0;
    if (!ps(b, d)) {
     break c;
    }
    if (!IG(d)) {
     break c;
    }
    if (!c) {
     i = 1;
     break c;
    }
    if (!um(v[b >> 2], w[e + 1450 | 0] | w[e + 1451 | 0] << 8 | (w[e + 1452 | 0] << 16 | w[e + 1453 | 0] << 24))) {
     break c;
    }
    if (!um(v[b >> 2], (w[e + 1450 | 0] | w[e + 1451 | 0] << 8 | (w[e + 1452 | 0] << 16 | w[e + 1453 | 0] << 24)) + ((w[e + 1444 | 0] | w[e + 1445 | 0] << 8) << 2) | 0)) {
     break c;
    }
    tx(a);
    A = e, C = sx(), v[A + 68 >> 2] = C;
    c = e + 68 | 0;
    rx(bj(v[a + 4 >> 2]) + 32 | 0, c);
    os(c);
    l = v[bj(v[a + 4 >> 2]) + 32 >> 2];
    v[e + 1428 >> 2] = w[e + 1446 | 0] | w[e + 1447 | 0] << 8 | (w[e + 1448 | 0] << 16 | w[e + 1449 | 0] << 24);
    A = e, C = Kh(v[b >> 2]), v[A + 1168 >> 2] = C;
    v[e + 1136 >> 2] = 214748364;
    d = e + 1168 | 0;
    A = e, C = B(v[Gb(d, e + 1136 | 0) >> 2], 20), v[A + 68 >> 2] = C;
    so(l, v[Gb(e + 1428 | 0, c) >> 2]);
    Qb(d, 0, 256);
    s = Mb(e + 1156 | 0);
    while (1) {
     d: {
      e: {
       f: {
        g: {
         h: {
          i: {
           j: {
            k: {
             l: {
              m: {
               n: {
                o: {
                 p: {
                  q: {
                   r: {
                    i = (w[e + 1444 | 0] | w[e + 1445 | 0] << 8) >>> 0 <= u >>> 0;
                    if (!i) {
                     v[31601] = 0;
                     c = O(149, b | 0, (w[e + 1450 | 0] | w[e + 1451 | 0] << 8 | (w[e + 1452 | 0] << 16 | w[e + 1453 | 0] << 24)) + (u << 2) | 0) | 0;
                     d = v[31601];
                     v[31601] = 0;
                     if ((d | 0) == 1) {
                      break r;
                     }
                     if (!c) {
                      break h;
                     }
                     c = v[b + 8 >> 2];
                     d = v[b >> 2];
                     v[31601] = 0;
                     c = T(150, d | 0, c | 0, 4) | 0;
                     d = v[31601];
                     v[31601] = 0;
                     if ((d | 0) == 1) {
                      break r;
                     }
                     if (!c) {
                      break h;
                     }
                     v[31601] = 0;
                     c = Q(151, b | 0) | 0;
                     d = v[31601];
                     v[31601] = 0;
                     if ((d | 0) == 1) {
                      break q;
                     }
                     v[31601] = 0;
                     d = O(149, b | 0, c | 0) | 0;
                     f = v[31601];
                     v[31601] = 0;
                     if ((f | 0) == 1) {
                      break q;
                     }
                     if (!d) {
                      break h;
                     }
                     v[31601] = 0;
                     d = O(152, b | 0, e + 1136 | 0) | 0;
                     f = v[31601];
                     v[31601] = 0;
                     if ((f | 0) == 1) {
                      break p;
                     }
                     if (!d) {
                      break h;
                     }
                     v[31601] = 0;
                     d = T(153, b | 0, s | 0, w[e + 1148 | 0] | w[e + 1149 | 0] << 8) | 0;
                     f = v[31601];
                     v[31601] = 0;
                     if ((f | 0) == 1) {
                      break p;
                     }
                     if (!d) {
                      break h;
                     }
                     f = v[s >> 2];
                     h = v[b >> 2];
                     v[31601] = 0;
                     d = w[e + 1148 | 0] | w[e + 1149 | 0] << 8;
                     h = Q(154, h | 0) | 0;
                     j = v[31601];
                     v[31601] = 0;
                     if ((j | 0) == 1) {
                      break o;
                     }
                     n = h;
                     h = c + 20 | 0;
                     if (n >>> 0 <= h + (d << 3) >>> 0) {
                      break h;
                     }
                     c = d ? f : 0;
                     f = w[e + 1148 | 0] | w[e + 1149 | 0] << 8;
                     j = h + (f << 3) | 0;
                     d = 0;
                     h = w[e + 1150 | 0] | w[e + 1151 | 0] << 8;
                     if (!(h & 1)) {
                      while (1) {
                       if ((f & 65535) >>> 0 <= d >>> 0) {
                        break d;
                       }
                       if (!c) {
                        break h;
                       }
                       f = w[c + 4 | 0] | w[c + 5 | 0] << 8 | (w[c + 6 | 0] << 16 | w[c + 7 | 0] << 24);
                       h = w[c | 0] | w[c + 1 | 0] << 8 | (w[c + 2 | 0] << 16 | w[c + 3 | 0] << 24);
                       v[31601] = 0;
                       f = aa(155, h | 0, f | 0, l | 0, v[e + 1428 >> 2]) | 0;
                       h = v[31601];
                       v[31601] = 0;
                       s: {
                        if ((h | 0) == 1) {
                         break s;
                        }
                        if (!f) {
                         break h;
                        }
                        v[31601] = 0;
                        f = O(149, b | 0, j | 0) | 0;
                        h = v[31601];
                        v[31601] = 0;
                        if ((h | 0) == 1) {
                         break s;
                        }
                        if (!f) {
                         break h;
                        }
                        f = Yb(e + 1128 | 0, wb(v[l >> 2], w[c | 0] | w[c + 1 | 0] << 8 | (w[c + 2 | 0] << 16 | w[c + 3 | 0] << 24)), w[c + 4 | 0] | w[c + 5 | 0] << 8 | (w[c + 6 | 0] << 16 | w[c + 7 | 0] << 24));
                        h = v[f >> 2];
                        f = v[f + 4 >> 2];
                        v[31601] = 0;
                        Xn(156, e + 68 | 0, b, h, f);
                        f = v[31601];
                        v[31601] = 0;
                        if ((f | 0) == 1) {
                         break n;
                        }
                        if (v[e + 72 >> 2] != (w[c + 4 | 0] | w[c + 5 | 0] << 8 | (w[c + 6 | 0] << 16 | w[c + 7 | 0] << 24))) {
                         break h;
                        }
                        d = d + 1 | 0;
                        c = c + 8 | 0;
                        f = w[e + 1148 | 0] | w[e + 1149 | 0] << 8;
                        continue;
                       }
                       break;
                      }
                      i = M() | 0;
                      break a;
                     }
                     t: {
                      if (h & 4) {
                       if (!c) {
                        break h;
                       }
                       d = w[c + 4 | 0] | w[c + 5 | 0] << 8 | (w[c + 6 | 0] << 16 | w[c + 7 | 0] << 24);
                       f = w[c | 0] | w[c + 1 | 0] << 8 | (w[c + 2 | 0] << 16 | w[c + 3 | 0] << 24);
                       v[31601] = 0;
                       d = aa(155, f | 0, d | 0, l | 0, v[e + 1428 >> 2]) | 0;
                       f = v[31601];
                       v[31601] = 0;
                       if ((f | 0) == 1) {
                        break m;
                       }
                       if (!d) {
                        break h;
                       }
                       o = wb(v[l >> 2], w[c | 0] | w[c + 1 | 0] << 8 | (w[c + 2 | 0] << 16 | w[c + 3 | 0] << 24));
                       m = (w[c + 4 | 0] | w[c + 5 | 0] << 8 | (w[c + 6 | 0] << 16 | w[c + 7 | 0] << 24)) & -2;
                       if (!m) {
                        break h;
                       }
                       v[31601] = 0;
                       h = w[e + 1154 | 0] | w[e + 1155 | 0] << 8;
                       d = O(149, b | 0, j + (w[e + 1152 | 0] | w[e + 1153 | 0] << 8) | 0) | 0;
                       f = v[31601];
                       v[31601] = 0;
                       if ((f | 0) == 1) {
                        break l;
                       }
                       if (!d) {
                        break h;
                       }
                       d = v[b + 8 >> 2];
                       f = v[b >> 2];
                       v[31601] = 0;
                       d = T(150, f | 0, d | 0, (w[e + 1140 | 0] | w[e + 1141 | 0] << 8 | (w[e + 1142 | 0] << 16 | w[e + 1143 | 0] << 24)) - (w[e + 1152 | 0] | w[e + 1153 | 0] << 8) | 0) | 0;
                       f = v[31601];
                       v[31601] = 0;
                       if ((f | 0) == 1) {
                        break l;
                       }
                       if (!d) {
                        break h;
                       }
                       v[31601] = 0;
                       d = e + 48 | 0;
                       R(157, d | 0, b | 0, (w[e + 1140 | 0] | w[e + 1141 | 0] << 8 | (w[e + 1142 | 0] << 16 | w[e + 1143 | 0] << 24)) - (w[e + 1152 | 0] | w[e + 1153 | 0] << 8) | 0);
                       f = v[31601];
                       v[31601] = 0;
                       if ((f | 0) == 1) {
                        break b;
                       }
                       k = ns(e + 68 | 0, d);
                       tb(d);
                       r = 0;
                       j = 0;
                       while (1) {
                        f = 0;
                        u: {
                         while (1) {
                          if ((j & 65535) >>> 0 >= (w[e + 1148 | 0] | w[e + 1149 | 0] << 8) >>> 0) {
                           break e;
                          }
                          v[31601] = 0;
                          d = O(158, k | 0, h + 1 | 0) | 0;
                          g = v[31601];
                          v[31601] = 0;
                          if ((g | 0) == 1) {
                           break u;
                          }
                          g = h & 15;
                          q = x[(g << 1) + 24352 >> 1];
                          v: {
                           w: {
                            if (q >>> 0 > d >>> 0) {
                             break w;
                            }
                            v[31601] = 0;
                            g = w[g + 24400 | 0];
                            n = O(158, k | 0, g | 0) | 0;
                            z = v[31601];
                            v[31601] = 0;
                            if ((z | 0) == 1) {
                             break u;
                            }
                            d = n + (d - q << g) | 0;
                            if ((d | 0) != (h | 0)) {
                             h = d & 15;
                             break v;
                            }
                            v[31601] = 0;
                            d = O(158, k | 0, 4) | 0;
                            g = v[31601];
                            v[31601] = 0;
                            if ((g | 0) == 1) {
                             break u;
                            }
                            if ((d | 0) == 15) {
                             v[31601] = 0;
                             g = O(158, k | 0, 1) | 0;
                             d = v[31601];
                             v[31601] = 0;
                             if ((d | 0) == 1) {
                              break u;
                             }
                             d = 65535;
                             if (!g) {
                              break w;
                             }
                             break e;
                            }
                            d = d + 65520 | 0;
                            if (d >>> 0 > 65535) {
                             break v;
                            }
                           }
                           d = d & 1 ? 0 - (d + 1 >>> 1 | 0) | 0 : d >>> 1 | 0;
                           n = f + o | 0;
                           g = w[e + 1150 | 0] | w[e + 1151 | 0] << 8;
                           x: {
                            if (g & 2) {
                             r = d + r | 0;
                             d = r;
                             break x;
                            }
                            d = g & 512 ? d : d ^ 32768;
                           }
                           q = d >>> 8 | 0;
                           g = g & 1024;
                           t[n + 1 | 0] = g ? d : q;
                           t[n | 0] = g ? q : d;
                           f = f + 2 | 0;
                          }
                          if (f >>> 0 < m >>> 0) {
                           continue;
                          }
                          break;
                         }
                         j = j + 1 | 0;
                         if (j >>> 0 >= (w[e + 1148 | 0] | w[e + 1149 | 0] << 8) >>> 0) {
                          break e;
                         }
                         d = (j << 3) + c | 0;
                         f = w[d | 0] | w[d + 1 | 0] << 8 | (w[d + 2 | 0] << 16 | w[d + 3 | 0] << 24);
                         o = w[d + 4 | 0] | w[d + 5 | 0] << 8 | (w[d + 6 | 0] << 16 | w[d + 7 | 0] << 24);
                         v[31601] = 0;
                         f = aa(155, f | 0, o | 0, l | 0, v[e + 1428 >> 2]) | 0;
                         o = v[31601];
                         v[31601] = 0;
                         if ((o | 0) == 1) {
                          break u;
                         }
                         if (!f) {
                          break t;
                         }
                         m = (w[d + 4 | 0] | w[d + 5 | 0] << 8 | (w[d + 6 | 0] << 16 | w[d + 7 | 0] << 24)) & -2;
                         if (!m) {
                          break t;
                         }
                         o = wb(v[l >> 2], w[d | 0] | w[d + 1 | 0] << 8 | (w[d + 2 | 0] << 16 | w[d + 3 | 0] << 24));
                         continue;
                        }
                        break;
                       }
                       i = S(28784) | 0;
                       if ((fb | 0) == (_(28784) | 0)) {
                        X(i | 0) | 0;
                        v[31601] = 0;
                        W(26);
                        c = v[31601];
                        v[31601] = 0;
                        if ((c | 0) != 1) {
                         break e;
                        }
                        i = M() | 0;
                       }
                       tb(k);
                       break a;
                      }
                      if (!c) {
                       break h;
                      }
                      d = w[c + 4 | 0] | w[c + 5 | 0] << 8 | (w[c + 6 | 0] << 16 | w[c + 7 | 0] << 24);
                      f = w[c | 0] | w[c + 1 | 0] << 8 | (w[c + 2 | 0] << 16 | w[c + 3 | 0] << 24);
                      v[31601] = 0;
                      d = aa(155, f | 0, d | 0, l | 0, v[e + 1428 >> 2]) | 0;
                      f = v[31601];
                      v[31601] = 0;
                      if ((f | 0) == 1) {
                       break k;
                      }
                      if (!d) {
                       break h;
                      }
                      r = wb(v[l >> 2], w[c | 0] | w[c + 1 | 0] << 8 | (w[c + 2 | 0] << 16 | w[c + 3 | 0] << 24));
                      if ((w[e + 1152 | 0] | w[e + 1153 | 0] << 8) >>> 0 > 256) {
                       break h;
                      }
                      m = w[c + 4 | 0] | w[c + 5 | 0] << 8 | (w[c + 6 | 0] << 16 | w[c + 7 | 0] << 24);
                      h = w[e + 1154 | 0] | w[e + 1155 | 0] << 8;
                      v[31601] = 0;
                      d = O(149, b | 0, j | 0) | 0;
                      f = v[31601];
                      v[31601] = 0;
                      y: {
                       z: {
                        if ((f | 0) != 1) {
                         if (!d) {
                          break h;
                         }
                         d = Yb(e + 40 | 0, e + 1168 | 0, w[e + 1152 | 0] | w[e + 1153 | 0] << 8);
                         f = v[d >> 2];
                         d = v[d + 4 >> 2];
                         v[31601] = 0;
                         Xn(159, e + 68 | 0, b, f, d);
                         d = v[31601];
                         v[31601] = 0;
                         if ((d | 0) == 1) {
                          break z;
                         }
                         d = w[e + 1152 | 0] | w[e + 1153 | 0] << 8;
                         if (d >>> 0 > y[e + 72 >> 2]) {
                          break h;
                         }
                         f = v[b + 8 >> 2];
                         j = v[b >> 2];
                         v[31601] = 0;
                         d = T(150, j | 0, f | 0, (w[e + 1140 | 0] | w[e + 1141 | 0] << 8 | (w[e + 1142 | 0] << 16 | w[e + 1143 | 0] << 24)) - d | 0) | 0;
                         f = v[31601];
                         v[31601] = 0;
                         if ((f | 0) != 1) {
                          break y;
                         }
                        }
                        i = M() | 0;
                        break a;
                       }
                       i = M() | 0;
                       break a;
                      }
                      if (!d) {
                       break h;
                      }
                      v[31601] = 0;
                      d = e + 48 | 0;
                      R(157, d | 0, b | 0, (w[e + 1140 | 0] | w[e + 1141 | 0] << 8 | (w[e + 1142 | 0] << 16 | w[e + 1143 | 0] << 24)) - (w[e + 1152 | 0] | w[e + 1153 | 0] << 8) | 0);
                      f = v[31601];
                      v[31601] = 0;
                      if ((f | 0) == 1) {
                       break f;
                      }
                      k = ns(e + 68 | 0, d);
                      tb(d);
                      j = 0;
                      o = 0;
                      while (1) {
                       f = 0;
                       A: {
                        while (1) {
                         if ((j & 65535) >>> 0 >= (w[e + 1148 | 0] | w[e + 1149 | 0] << 8) >>> 0) {
                          break g;
                         }
                         v[31601] = 0;
                         d = O(158, k | 0, h + 1 | 0) | 0;
                         g = v[31601];
                         v[31601] = 0;
                         if ((g | 0) == 1) {
                          break A;
                         }
                         g = h & 7;
                         q = w[g + 24384 | 0];
                         B: {
                          C: {
                           if (q >>> 0 > d >>> 0) {
                            break C;
                           }
                           v[31601] = 0;
                           g = w[g + 24392 | 0];
                           n = O(158, k | 0, g | 0) | 0;
                           z = v[31601];
                           v[31601] = 0;
                           if ((z | 0) == 1) {
                            break A;
                           }
                           d = n + (d - q << g) | 0;
                           if ((d | 0) != (h | 0)) {
                            h = d & 7;
                            break B;
                           }
                           v[31601] = 0;
                           d = O(158, k | 0, 3) | 0;
                           g = v[31601];
                           v[31601] = 0;
                           if ((g | 0) == 1) {
                            break A;
                           }
                           if ((d | 0) == 7) {
                            v[31601] = 0;
                            g = O(158, k | 0, 1) | 0;
                            d = v[31601];
                            v[31601] = 0;
                            if ((d | 0) == 1) {
                             break A;
                            }
                            d = 255;
                            if (!g) {
                             break C;
                            }
                            break g;
                           }
                           d = d + 248 | 0;
                           if (d >>> 0 > 255) {
                            break B;
                           }
                          }
                          d = w[(e + 1168 | 0) + d | 0];
                          g = d + o | 0;
                          n = d;
                          d = (w[e + 1150 | 0] | w[e + 1151 | 0] << 8) & 2;
                          t[f + r | 0] = d ? g : n;
                          o = d ? g : o;
                          f = f + 1 | 0;
                         }
                         if (f >>> 0 < m >>> 0) {
                          continue;
                         }
                         break;
                        }
                        j = j + 1 | 0;
                        if (j >>> 0 >= (w[e + 1148 | 0] | w[e + 1149 | 0] << 8) >>> 0) {
                         break g;
                        }
                        d = (j << 3) + c | 0;
                        f = w[d | 0] | w[d + 1 | 0] << 8 | (w[d + 2 | 0] << 16 | w[d + 3 | 0] << 24);
                        m = w[d + 4 | 0] | w[d + 5 | 0] << 8 | (w[d + 6 | 0] << 16 | w[d + 7 | 0] << 24);
                        v[31601] = 0;
                        f = aa(155, f | 0, m | 0, l | 0, v[e + 1428 >> 2]) | 0;
                        m = v[31601];
                        v[31601] = 0;
                        if ((m | 0) == 1) {
                         break A;
                        }
                        if (!f) {
                         break j;
                        }
                        m = w[d + 4 | 0] | w[d + 5 | 0] << 8 | (w[d + 6 | 0] << 16 | w[d + 7 | 0] << 24);
                        r = wb(v[l >> 2], w[d | 0] | w[d + 1 | 0] << 8 | (w[d + 2 | 0] << 16 | w[d + 3 | 0] << 24));
                        continue;
                       }
                       break;
                      }
                      i = S(28784) | 0;
                      if ((fb | 0) == (_(28784) | 0)) {
                       X(i | 0) | 0;
                       v[31601] = 0;
                       W(26);
                       c = v[31601];
                       v[31601] = 0;
                       if ((c | 0) != 1) {
                        break g;
                       }
                       i = M() | 0;
                      }
                      tb(k);
                      break a;
                     }
                     tb(k);
                     break h;
                    }
                    oe(e + 24 | 0, v[l >> 2], v[l + 4 >> 2]);
                    lf(e + 32 | 0, v[e + 24 >> 2], v[e + 28 >> 2]);
                    b = Ld(e + 16 | 0);
                    v[31601] = 0;
                    c = v[b + 4 >> 2];
                    v[e + 8 >> 2] = v[b >> 2];
                    v[e + 12 >> 2] = c;
                    b = gg(160, e + 68 | 0, v[e + 32 >> 2], v[e + 36 >> 2], e + 8 | 0);
                    c = v[31601];
                    v[31601] = 0;
                    if ((c | 0) == 1) {
                     break i;
                    }
                    jd(bj(v[a + 4 >> 2]) + 12 | 0, b);
                    tb(b);
                    break h;
                   }
                   i = M() | 0;
                   break a;
                  }
                  i = M() | 0;
                  break a;
                 }
                 i = M() | 0;
                 break a;
                }
                i = M() | 0;
                break a;
               }
               i = M() | 0;
               break a;
              }
              i = M() | 0;
              break a;
             }
             i = M() | 0;
             break a;
            }
            i = M() | 0;
            break a;
           }
           tb(k);
           break h;
          }
          i = M() | 0;
          break a;
         }
         Be(s);
         break c;
        }
        tb(k);
        break d;
       }
       i = M() | 0;
       break a;
      }
      tb(k);
     }
     u = u + 1 | 0;
     continue;
    }
   }
   eb = e + 1456 | 0;
   return i | 0;
  }
  i = M() | 0;
 }
 Be(s);
 P(i | 0);
 p();
}

function zja(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, q = 0, r = 0, s = 0;
 d = eb - 720 | 0;
 eb = d;
 xc(b);
 a: {
  b: {
   c: {
    d: {
     if (!ui(b, d + 712 | 0)) {
      break d;
     }
     if (!qR(v[d + 712 >> 2], v[d + 716 >> 2])) {
      break d;
     }
     if (!Pr(b, d + 708 | 0)) {
      break d;
     }
     f = v[d + 708 >> 2];
     if (!pR(f)) {
      break d;
     }
     if ((f | 0) == 1179012417) {
      f = 0;
     } else {
      if ((f | 0) != 538987841) {
       break d;
      }
      f = 1;
     }
     e = f ? 2 : 1;
     g = f ? 1414090313 : 1313423693;
     o = Ge(d + 688 | 0, b);
     k = Mb(d + 676 | 0);
     e: {
      f: {
       g: {
        h: {
         i: {
          j: {
           k: {
            if ((c | 0) == 64) {
             v[31601] = 0;
             b = d + 112 | 0;
             U(893, b | 0, o | 0, e | 0, g | 0);
             e = v[31601];
             v[31601] = 0;
             if ((e | 0) != 1) {
              break k;
             }
             a = M() | 0;
             break a;
            }
            v[31601] = 0;
            b = d + 112 | 0;
            R(894, b | 0, o | 0, e | 0);
            e = v[31601];
            v[31601] = 0;
            if ((e | 0) == 1) {
             break j;
            }
           }
           Dv(k, b);
           je(b);
           v[31601] = 0;
           b = d + 656 | 0;
           R(895, b | 0, k | 0, g | 0);
           e = v[31601];
           v[31601] = 0;
           if ((e | 0) != 1) {
            v[31601] = 0;
            g = Q(172, v[d + 656 >> 2]) | 0;
            e = v[31601];
            v[31601] = 0;
            if ((e | 0) == 1) {
             break i;
            }
            e = 0;
            if (!g) {
             break e;
            }
            v[31601] = 0;
            i = d + 583 | 0;
            b = O(896, b | 0, i | 0) | 0;
            g = v[31601];
            v[31601] = 0;
            if ((g | 0) == 1) {
             break i;
            }
            if (!b) {
             break e;
            }
            b = w[d + 648 | 0];
            if (!b) {
             break e;
            }
            v[31601] = 0;
            e = T(150, v[d + 656 >> 2], v[d + 664 >> 2], b | 0) | 0;
            b = v[31601];
            v[31601] = 0;
            if ((b | 0) == 1) {
             break i;
            }
            if (!((c | 0) != 64 & e)) {
             break e;
            }
            v[31601] = 0;
            N(246, a | 0, 8388608);
            b = v[31601];
            v[31601] = 0;
            if ((b | 0) == 1) {
             break i;
            }
            v[a + 480208 >> 2] = w[d + 647 | 0] << 4 & 16 ^ 28;
            u[d + 112 >> 1] = w[d + 648 | 0];
            u[d + 464 >> 1] = 127;
            b = d + 112 | 0;
            e = d + 464 | 0;
            r = a, s = x[Nc(b, e) >> 1], u[r + 480188 >> 1] = s;
            v[a + 480196 >> 2] = w[d + 649 | 0];
            v[a + 480204 >> 2] = B(w[d + 650 | 0], 1e4);
            v[a + 480200 >> 2] = w[d + 655 | 0] << 1;
            v[31601] = 0;
            N(130, a + 1298344 | 0, (f ? 16935 : 16969) | 0);
            g = v[31601];
            v[31601] = 0;
            if ((g | 0) == 1) {
             break i;
            }
            v[31601] = 0;
            g = O(1, d + 568 | 0, 13318) | 0;
            m = v[31601];
            v[31601] = 0;
            if ((m | 0) == 1) {
             break g;
            }
            yb(a + 1298356 | 0, g);
            sb(g);
            r = a, s = v[Ec(b, 4) >> 2], v[r + 1298404 >> 2] = s;
            LC(e, 2, i);
            v[31601] = 0;
            N(218, b | 0, e | 0);
            e = v[31601];
            v[31601] = 0;
            if ((e | 0) == 1) {
             break h;
            }
            yb(a + 1298308 | 0, b);
            i = a + 480280 | 0;
            sb(b);
            b = 0;
            while (1) {
             l: {
              m: {
               n: {
                if (x[a + 480188 >> 1] <= b >>> 0) {
                 b = vb(v[k >> 2]);
                 g = vb(v[k + 4 >> 2]);
                 e = eb - 16 | 0;
                 eb = e;
                 v[e + 12 >> 2] = b;
                 while (1) {
                  o: {
                   if (!Hb(b, g)) {
                    break o;
                   }
                   if (r$(1380209231, v[b >> 2], v[b + 4 >> 2])) {
                    break o;
                   }
                   b = v[bm(e + 12 | 0) >> 2];
                   continue;
                  }
                  break;
                 }
                 eb = e + 16 | 0;
                 if (Hb(b, vb(v[k + 4 >> 2]))) {
                  break n;
                 }
                 break f;
                }
                g = i + (b << 5) | 0;
                Ve(g);
                v[31601] = 0;
                e = Q(197, d + 656 | 0) | 0;
                m = v[31601];
                v[31601] = 0;
                p: {
                 q: {
                  if ((m | 0) != 1) {
                   if (!f) {
                    break p;
                   }
                   if (e >>> 0 < 129) {
                    break q;
                   }
                   break m;
                  }
                  a = M() | 0;
                  break b;
                 }
                 u[g + 4 >> 1] = e << 1;
                 break l;
                }
                if (e << 24 >> 24 < 0) {
                 break m;
                }
                v[d + 112 >> 2] = e << 2;
                v[d + 464 >> 2] = 256;
                r = g, s = v[Bd(d + 112 | 0, d + 464 | 0) >> 2], u[r + 4 >> 1] = s;
                break l;
               }
               v[31601] = 0;
               b = d + 112 | 0;
               R(895, b | 0, k | 0, 1380209231);
               e = v[31601];
               v[31601] = 0;
               r: {
                if ((e | 0) != 1) {
                 v[31601] = 0;
                 e = Q(197, b | 0) | 0;
                 g = v[31601];
                 v[31601] = 0;
                 if ((g | 0) == 1) {
                  break r;
                 }
                 g = w[a + 484376 | 0];
                 i = v[a + 484360 >> 2];
                 v[31601] = 0;
                 $(348, Wb(i, g) | 0, b | 0, e + 1 & 255, 255, 254);
                 e = v[31601];
                 v[31601] = 0;
                 if ((e | 0) == 1) {
                  break r;
                 }
                 tb(b);
                 break f;
                }
                a = M() | 0;
                break b;
               }
               a = M() | 0;
               tb(d + 112 | 0);
               break b;
              }
              v[g >> 2] = 1024;
             }
             b = b + 1 | 0;
             continue;
            }
           }
           a = M() | 0;
           break a;
          }
          a = M() | 0;
          break a;
         }
         a = M() | 0;
         break b;
        }
        a = M() | 0;
        break b;
       }
       a = M() | 0;
       break b;
      }
      s: {
       if (!(c & 1)) {
        break s;
       }
       u[d + 48 >> 1] = 0;
       v[31601] = 0;
       R(897, d + 528 | 0, k | 0, 1414807888);
       b = v[31601];
       v[31601] = 0;
       if ((b | 0) == 1) {
        break c;
       }
       b = v[d + 532 >> 2];
       e = v[d + 528 >> 2];
       v[31601] = 0;
       i = a + 484344 | 0;
       N(223, i | 0, Rf(e, b) & 65535);
       b = v[31601];
       v[31601] = 0;
       t: {
        if ((b | 0) != 1) {
         r = d, s = vb(v[d + 528 >> 2]), v[r + 76 >> 2] = s;
         m = vb(v[d + 532 >> 2]);
         u: {
          v: {
           w: {
            x: {
             y: {
              while (1) {
               b = v[d + 76 >> 2];
               if (!Hb(b, m)) {
                b = 0;
                break u;
               }
               b = Ge(d + 112 | 0, b);
               v[31601] = 0;
               e = Q(197, b | 0) | 0;
               g = v[31601];
               v[31601] = 0;
               if ((g | 0) != 1) {
                v[31601] = 0;
                u[d + 452 >> 1] = e;
                e = Q(151, b | 0) | 0;
                g = v[31601];
                v[31601] = 0;
                if ((g | 0) == 1) {
                 break y;
                }
                v[31601] = 0;
                g = d + 464 | 0;
                R(185, g | 0, b | 0, e | 0);
                e = v[31601];
                v[31601] = 0;
                if ((e | 0) == 1) {
                 break x;
                }
                e = gc(d + 548 | 0, g);
                v[31601] = 0;
                n = v[e + 12 >> 2];
                v[d + 8 >> 2] = v[e + 8 >> 2];
                v[d + 12 >> 2] = n;
                v[d + 16 >> 2] = v[e + 16 >> 2];
                n = v[e + 4 >> 2];
                v[d >> 2] = v[e >> 2];
                v[d + 4 >> 2] = n;
                U(898, d | 0, x[d + 452 >> 1], f | 0, a | 0);
                e = v[31601];
                v[31601] = 0;
                if ((e | 0) == 1) {
                 break w;
                }
                tb(g);
                r = d, s = x[qe(d + 48 | 0, d + 452 | 0) >> 1], u[r + 48 >> 1] = s;
                tb(b);
                Pf(d + 76 | 0);
                continue;
               }
               break;
              }
              a = M() | 0;
              break v;
             }
             a = M() | 0;
             break v;
            }
            a = M() | 0;
            break v;
           }
           a = M() | 0;
           tb(d + 464 | 0);
          }
          tb(b);
          break t;
         }
         while (1) {
          e = b & 65535;
          if (e >>> 0 >= x[d + 48 >> 1]) {
           Qc(d + 528 | 0);
           break s;
          }
          z: {
           if (!Ie(v[a + 484344 >> 2], v[a + 484348 >> 2], e)) {
            v[31601] = 0;
            T(196, i | 0, e | 0, 64) | 0;
            e = v[31601];
            v[31601] = 0;
            if ((e | 0) == 1) {
             break z;
            }
           }
           b = b + 1 | 0;
           continue;
          }
          break;
         }
         a = M() | 0;
         break t;
        }
        a = M() | 0;
       }
       Qc(d + 528 | 0);
       break b;
      }
      A: {
       B: {
        C: {
         if (!f) {
          v[31601] = 0;
          R(897, d + 76 | 0, k | 0, 1414745673);
          b = v[31601];
          v[31601] = 0;
          if ((b | 0) == 1) {
           break B;
          }
          r = d, s = vb(v[d + 76 >> 2]), v[r + 100 >> 2] = s;
          g = c & 2;
          i = a + 484380 | 0;
          m = a + 946304 | 0;
          n = d + 472 | 0;
          q = vb(v[d + 80 >> 2]);
          while (1) {
           b = v[d + 100 >> 2];
           if (!Hb(b, q)) {
            Qc(d + 76 | 0);
            break A;
           }
           c = Ge(d + 528 | 0, b);
           v[31601] = 0;
           e = d + 112 | 0;
           b = O(899, c | 0, e | 0) | 0;
           f = v[31601];
           v[31601] = 0;
           if ((f | 0) != 1) {
            D: {
             if (!b) {
              break D;
             }
             b = w[d + 113 | 0];
             if ((b | 0) == 255) {
              break D;
             }
             v[31601] = 0;
             f = T(251, a | 0, b + 1 | 0, 0) | 0;
             b = v[31601];
             v[31601] = 0;
             if ((b | 0) == 1) {
              break C;
             }
             if (!f) {
              break D;
             }
             j = x[a + 480190 >> 1];
             b = 0;
             v[31601] = 0;
             R(900, e | 0, f | 0, j | 0);
             f = v[31601];
             v[31601] = 0;
             if ((f | 0) == 1) {
              break C;
             }
             while (1) {
              if (w[d + 142 | 0] <= b >>> 0) {
               break D;
              }
              E: {
               if (!ni(x[a + 480190 >> 1])) {
                break E;
               }
               v[31601] = 0;
               e = d + 464 | 0;
               f = O(901, c | 0, e | 0) | 0;
               j = v[31601];
               v[31601] = 0;
               if ((j | 0) == 1) {
                break C;
               }
               if (!f) {
                break E;
               }
               j = x[a + 480190 >> 1] + 1 | 0;
               u[a + 480190 >> 1] = j;
               if (v[d + 464 >> 2] != 1347240275) {
                break E;
               }
               h = d + 452 | 0;
               Ui(h, 2, n);
               v[31601] = 0;
               f = d + 48 | 0;
               N(218, f | 0, h | 0);
               h = v[31601];
               v[31601] = 0;
               F: {
                if ((h | 0) != 1) {
                 j = j & 65535;
                 zc(m + (j << 5) | 0, f);
                 sb(f);
                 v[31601] = 0;
                 h = e;
                 e = i + B(j, 104) | 0;
                 R(902, h | 0, d + 112 | 0, e | 0);
                 j = v[31601];
                 v[31601] = 0;
                 if ((j | 0) == 1) {
                  break C;
                 }
                 if (!g) {
                  break F;
                 }
                 oR(f, x[d + 502 >> 1]);
                 v[31601] = 0;
                 T(215, f | 0, e | 0, c | 0) | 0;
                 f = v[31601];
                 v[31601] = 0;
                 if ((f | 0) != 1) {
                  break E;
                 }
                 break C;
                }
                break C;
               }
               f = x[e + 34 >> 1];
               e = v[e >> 2];
               v[31601] = 0;
               O(183, c | 0, Nk(e, f) | 0) | 0;
               f = v[31601];
               v[31601] = 0;
               if ((f | 0) == 1) {
                break C;
               }
              }
              b = b + 1 | 0;
              continue;
             }
            }
            tb(c);
            Pf(d + 100 | 0);
            continue;
           }
           break;
          }
          break C;
         }
         v[31601] = 0;
         R(897, d + 452 | 0, k | 0, 1179011410);
         b = v[31601];
         v[31601] = 0;
         if ((b | 0) != 1) {
          r = d, s = vb(v[d + 452 >> 2]), v[r + 448 >> 2] = s;
          g = c & 2;
          i = a + 484380 | 0;
          m = a + 946304 | 0;
          n = d + 468 | 0;
          q = vb(v[d + 456 >> 2]);
          G: {
           H: {
            I: {
             J: {
              K: {
               L: {
                M: {
                 N: {
                  O: {
                   P: {
                    while (1) {
                     b = v[d + 448 >> 2];
                     if (!Hb(b, q)) {
                      Qc(d + 452 | 0);
                      break A;
                     }
                     c = Ge(d + 528 | 0, b);
                     v[31601] = 0;
                     b = Q(151, c | 0) | 0;
                     f = v[31601];
                     v[31601] = 0;
                     if ((f | 0) == 1) {
                      break P;
                     }
                     Q: {
                      R: {
                       if ((b | 0) != 538986817) {
                        break R;
                       }
                       v[31601] = 0;
                       b = O(903, c | 0, d + 440 | 0) | 0;
                       f = v[31601];
                       v[31601] = 0;
                       if ((f | 0) == 1) {
                        break O;
                       }
                       if (!(v[d + 440 >> 2] == 1414745673 & b)) {
                        break R;
                       }
                       v[31601] = 0;
                       f = d + 112 | 0;
                       b = O(904, c | 0, f | 0) | 0;
                       e = v[31601];
                       v[31601] = 0;
                       if ((e | 0) == 1) {
                        break N;
                       }
                       if (!b) {
                        break R;
                       }
                       b = w[d + 117 | 0];
                       if ((b | 0) == 255) {
                        break R;
                       }
                       v[31601] = 0;
                       b = T(251, a | 0, b + 1 | 0, 0) | 0;
                       e = v[31601];
                       v[31601] = 0;
                       if ((e | 0) == 1) {
                        break M;
                       }
                       if (!b) {
                        break R;
                       }
                       e = x[a + 480190 >> 1];
                       v[31601] = 0;
                       R(905, f | 0, b | 0, e | 0);
                       b = v[31601];
                       v[31601] = 0;
                       if ((b | 0) == 1) {
                        break M;
                       }
                       v[31601] = 0;
                       b = d + 464 | 0;
                       R(894, b | 0, c | 0, 2);
                       f = v[31601];
                       v[31601] = 0;
                       if ((f | 0) == 1) {
                        break Q;
                       }
                       v[31601] = 0;
                       R(897, d + 100 | 0, b | 0, 1179011410);
                       f = v[31601];
                       v[31601] = 0;
                       if ((f | 0) == 1) {
                        break L;
                       }
                       je(b);
                       r = d, s = vb(v[d + 100 >> 2]), v[r + 96 >> 2] = s;
                       j = vb(v[d + 104 >> 2]);
                       S: {
                        T: {
                         while (1) {
                          b = v[d + 96 >> 2];
                          if (!Hb(b, j)) {
                           break S;
                          }
                          b = Ge(d + 76 | 0, b);
                          v[31601] = 0;
                          f = Q(151, b | 0) | 0;
                          e = v[31601];
                          v[31601] = 0;
                          if ((e | 0) == 1) {
                           break K;
                          }
                          U: {
                           V: {
                            if ((f | 0) != 538989377) {
                             break V;
                            }
                            f = x[a + 480190 >> 1];
                            if (!ni(f)) {
                             break V;
                            }
                            e = w[d + 436 | 0] | w[d + 437 | 0] << 8;
                            h = e - 1 | 0;
                            t[d + 436 | 0] = h;
                            t[d + 437 | 0] = h >>> 8;
                            if (!e) {
                             tb(b);
                             break S;
                            }
                            h = f + 1 | 0;
                            u[a + 480190 >> 1] = h;
                            v[31601] = 0;
                            f = O(903, b | 0, d + 68 | 0) | 0;
                            e = v[31601];
                            v[31601] = 0;
                            if ((e | 0) == 1) {
                             break J;
                            }
                            if (!(v[d + 68 >> 2] == 1347240275 & f)) {
                             break T;
                            }
                            v[31601] = 0;
                            e = d + 464 | 0;
                            R(185, e | 0, b | 0, v[d + 72 >> 2]);
                            f = v[31601];
                            v[31601] = 0;
                            W: {
                             if ((f | 0) != 1) {
                              f = gc(d + 48 | 0, e);
                              tb(e);
                              v[31601] = 0;
                              e = O(906, f | 0, e | 0) | 0;
                              l = v[31601];
                              v[31601] = 0;
                              if ((l | 0) == 1) {
                               break U;
                              }
                              if (e) {
                               break W;
                              }
                              tb(f);
                              tb(b);
                              break S;
                             }
                             a = M() | 0;
                             break H;
                            }
                            l = d + 24 | 0;
                            Ue(l, 2, n);
                            v[31601] = 0;
                            e = d + 36 | 0;
                            N(218, e | 0, l | 0);
                            l = v[31601];
                            v[31601] = 0;
                            if ((l | 0) == 1) {
                             break I;
                            }
                            h = h & 65535;
                            zc(m + (h << 5) | 0, e);
                            sb(e);
                            v[31601] = 0;
                            h = i + B(h, 104) | 0;
                            R(907, d + 464 | 0, d + 112 | 0, h | 0);
                            l = v[31601];
                            v[31601] = 0;
                            if ((l | 0) == 1) {
                             break U;
                            }
                            X: {
                             if (!g) {
                              break X;
                             }
                             v[31601] = 0;
                             O(149, f | 0, v[d + 464 >> 2] + 4 | 0) | 0;
                             l = v[31601];
                             v[31601] = 0;
                             if ((l | 0) == 1) {
                              break U;
                             }
                             oR(e, x[d + 504 >> 1]);
                             v[31601] = 0;
                             T(215, e | 0, h | 0, f | 0) | 0;
                             e = v[31601];
                             v[31601] = 0;
                             if ((e | 0) != 1) {
                              break X;
                             }
                             break I;
                            }
                            tb(f);
                           }
                           tb(b);
                           Pf(d + 96 | 0);
                           continue;
                          }
                          break;
                         }
                         break I;
                        }
                        tb(b);
                       }
                       Qc(d + 100 | 0);
                      }
                      tb(c);
                      Pf(d + 448 | 0);
                      continue;
                     }
                     break;
                    }
                    a = M() | 0;
                    break G;
                   }
                   a = M() | 0;
                   break G;
                  }
                  a = M() | 0;
                  break G;
                 }
                 a = M() | 0;
                 break G;
                }
                a = M() | 0;
                break G;
               }
               a = M() | 0;
               je(d + 464 | 0);
               break G;
              }
              a = M() | 0;
              break H;
             }
             a = M() | 0;
             break H;
            }
            a = M() | 0;
            tb(f);
           }
           tb(b);
           Qc(d + 100 | 0);
          }
          tb(c);
          Qc(d + 452 | 0);
          break b;
         }
         a = M() | 0;
         break b;
        }
        a = M() | 0;
        tb(c);
        Qc(d + 76 | 0);
        break b;
       }
       a = M() | 0;
       break b;
      }
      e = 1;
     }
     tb(d + 656 | 0);
     je(k);
     tb(o);
    }
    eb = d + 720 | 0;
    return e | 0;
   }
   a = M() | 0;
  }
  tb(d + 656 | 0);
 }
 je(k);
 tb(o);
 P(a | 0);
 p();
}

function Fd(a) {
 a = a | 0;
 var b = 0, c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
 k = eb - 16 | 0;
 eb = k;
 a: {
  b: {
   c: {
    d: {
     e: {
      f: {
       g: {
        h: {
         i: {
          j: {
           if (a >>> 0 <= 244) {
            e = v[31477];
            g = a >>> 0 < 11 ? 16 : a + 11 & 504;
            a = g >>> 3 | 0;
            b = e >>> a | 0;
            if (b & 3) {
             c = a + ((b ^ -1) & 1) | 0;
             b = c << 3;
             a = b + 125948 | 0;
             b = v[b + 125956 >> 2];
             d = v[b + 8 >> 2];
             k: {
              if ((a | 0) == (d | 0)) {
               m = 125908, n = Dua(-2, c) & e, v[m >> 2] = n;
               break k;
              }
              v[d + 12 >> 2] = a;
              v[a + 8 >> 2] = d;
             }
             a = b + 8 | 0;
             c = c << 3;
             v[b + 4 >> 2] = c | 3;
             b = b + c | 0;
             v[b + 4 >> 2] = v[b + 4 >> 2] | 1;
             break a;
            }
            i = v[31479];
            if (i >>> 0 >= g >>> 0) {
             break j;
            }
            if (b) {
             c = 2 << a;
             a = zua((0 - c | c) & b << a);
             c = a << 3;
             b = c + 125948 | 0;
             c = v[c + 125956 >> 2];
             d = v[c + 8 >> 2];
             l: {
              if ((b | 0) == (d | 0)) {
               e = Dua(-2, a) & e;
               v[31477] = e;
               break l;
              }
              v[d + 12 >> 2] = b;
              v[b + 8 >> 2] = d;
             }
             v[c + 4 >> 2] = g | 3;
             h = c + g | 0;
             a = a << 3;
             f = a - g | 0;
             v[h + 4 >> 2] = f | 1;
             v[a + c >> 2] = f;
             if (i) {
              a = (i & -8) + 125948 | 0;
              d = v[31482];
              b = 1 << (i >>> 3);
              m: {
               if (!(b & e)) {
                v[31477] = b | e;
                b = a;
                break m;
               }
               b = v[a + 8 >> 2];
              }
              v[a + 8 >> 2] = d;
              v[b + 12 >> 2] = d;
              v[d + 12 >> 2] = a;
              v[d + 8 >> 2] = b;
             }
             a = c + 8 | 0;
             v[31482] = h;
             v[31479] = f;
             break a;
            }
            l = v[31478];
            if (!l) {
             break j;
            }
            c = v[(zua(l) << 2) + 126212 >> 2];
            f = (v[c + 4 >> 2] & -8) - g | 0;
            b = c;
            while (1) {
             n: {
              a = v[b + 16 >> 2];
              if (!a) {
               a = v[b + 20 >> 2];
               if (!a) {
                break n;
               }
              }
              d = (v[a + 4 >> 2] & -8) - g | 0;
              b = d >>> 0 < f >>> 0;
              f = b ? d : f;
              c = b ? a : c;
              b = a;
              continue;
             }
             break;
            }
            j = v[c + 24 >> 2];
            a = v[c + 12 >> 2];
            if ((c | 0) != (a | 0)) {
             b = v[c + 8 >> 2];
             v[b + 12 >> 2] = a;
             v[a + 8 >> 2] = b;
             break b;
            }
            b = v[c + 20 >> 2];
            if (b) {
             d = c + 20 | 0;
            } else {
             b = v[c + 16 >> 2];
             if (!b) {
              break i;
             }
             d = c + 16 | 0;
            }
            while (1) {
             h = d;
             a = b;
             d = a + 20 | 0;
             b = v[a + 20 >> 2];
             if (b) {
              continue;
             }
             d = a + 16 | 0;
             b = v[a + 16 >> 2];
             if (b) {
              continue;
             }
             break;
            }
            v[h >> 2] = 0;
            break b;
           }
           g = -1;
           if (a >>> 0 > 4294967231) {
            break j;
           }
           b = a + 11 | 0;
           g = b & -8;
           i = v[31478];
           if (!i) {
            break j;
           }
           f = 0 - g | 0;
           e = 0;
           o: {
            if (g >>> 0 < 256) {
             break o;
            }
            e = 31;
            if (g >>> 0 > 16777215) {
             break o;
            }
            a = E(b >>> 8 | 0);
            e = ((g >>> 38 - a & 1) - (a << 1) | 0) + 62 | 0;
           }
           b = v[(e << 2) + 126212 >> 2];
           p: {
            q: {
             r: {
              if (!b) {
               a = 0;
               break r;
              }
              a = 0;
              c = g << ((e | 0) != 31 ? 25 - (e >>> 1 | 0) | 0 : 0);
              while (1) {
               s: {
                h = (v[b + 4 >> 2] & -8) - g | 0;
                if (h >>> 0 >= f >>> 0) {
                 break s;
                }
                d = b;
                f = h;
                if (f) {
                 break s;
                }
                f = 0;
                a = b;
                break q;
               }
               h = v[b + 20 >> 2];
               b = v[((c >>> 29 & 4) + b | 0) + 16 >> 2];
               a = h ? (h | 0) == (b | 0) ? a : h : a;
               c = c << 1;
               if (b) {
                continue;
               }
               break;
              }
             }
             if (!(a | d)) {
              d = 0;
              a = 2 << e;
              a = (0 - a | a) & i;
              if (!a) {
               break j;
              }
              a = v[(zua(a) << 2) + 126212 >> 2];
             }
             if (!a) {
              break p;
             }
            }
            while (1) {
             c = (v[a + 4 >> 2] & -8) - g | 0;
             b = c >>> 0 < f >>> 0;
             f = b ? c : f;
             d = b ? a : d;
             b = v[a + 16 >> 2];
             if (b) {
              a = b;
             } else {
              a = v[a + 20 >> 2];
             }
             if (a) {
              continue;
             }
             break;
            }
           }
           if (!d | v[31479] - g >>> 0 <= f >>> 0) {
            break j;
           }
           h = v[d + 24 >> 2];
           a = v[d + 12 >> 2];
           if ((d | 0) != (a | 0)) {
            b = v[d + 8 >> 2];
            v[b + 12 >> 2] = a;
            v[a + 8 >> 2] = b;
            break c;
           }
           b = v[d + 20 >> 2];
           if (b) {
            c = d + 20 | 0;
           } else {
            b = v[d + 16 >> 2];
            if (!b) {
             break h;
            }
            c = d + 16 | 0;
           }
           while (1) {
            e = c;
            a = b;
            c = a + 20 | 0;
            b = v[a + 20 >> 2];
            if (b) {
             continue;
            }
            c = a + 16 | 0;
            b = v[a + 16 >> 2];
            if (b) {
             continue;
            }
            break;
           }
           v[e >> 2] = 0;
           break c;
          }
          d = v[31479];
          if (d >>> 0 >= g >>> 0) {
           a = v[31482];
           b = d - g | 0;
           t: {
            if (b >>> 0 >= 16) {
             c = a + g | 0;
             v[c + 4 >> 2] = b | 1;
             v[a + d >> 2] = b;
             v[a + 4 >> 2] = g | 3;
             break t;
            }
            v[a + 4 >> 2] = d | 3;
            b = a + d | 0;
            v[b + 4 >> 2] = v[b + 4 >> 2] | 1;
            c = 0;
            b = 0;
           }
           v[31479] = b;
           v[31482] = c;
           a = a + 8 | 0;
           break a;
          }
          c = v[31480];
          if (c >>> 0 > g >>> 0) {
           b = c - g | 0;
           v[31480] = b;
           a = v[31483];
           c = a + g | 0;
           v[31483] = c;
           v[c + 4 >> 2] = b | 1;
           v[a + 4 >> 2] = g | 3;
           a = a + 8 | 0;
           break a;
          }
          a = 0;
          f = g + 47 | 0;
          if (v[31595]) {
           b = v[31597];
          } else {
           v[31598] = -1;
           v[31599] = -1;
           v[31596] = 4096;
           v[31597] = 4096;
           v[31595] = k + 12 & -16 ^ 1431655768;
           v[31600] = 0;
           v[31588] = 0;
           b = 4096;
          }
          e = f + b | 0;
          h = 0 - b | 0;
          b = e & h;
          if (b >>> 0 <= g >>> 0) {
           break a;
          }
          i = v[31587];
          if (i) {
           j = v[31585];
           d = j + b | 0;
           if (d >>> 0 <= j >>> 0 | d >>> 0 > i >>> 0) {
            break a;
           }
          }
          u: {
           if (!(w[126352] & 4)) {
            v: {
             w: {
              x: {
               y: {
                d = v[31483];
                if (d) {
                 a = 126356;
                 while (1) {
                  i = v[a >> 2];
                  if (i >>> 0 <= d >>> 0 & d >>> 0 < i + v[a + 4 >> 2] >>> 0) {
                   break y;
                  }
                  a = v[a + 8 >> 2];
                  if (a) {
                   continue;
                  }
                  break;
                 }
                }
                c = hp(0);
                if ((c | 0) == -1) {
                 break v;
                }
                e = b;
                a = v[31596];
                d = a - 1 | 0;
                if (d & c) {
                 e = (b - c | 0) + (c + d & 0 - a) | 0;
                }
                if (e >>> 0 <= g >>> 0) {
                 break v;
                }
                d = v[31587];
                if (d) {
                 h = v[31585];
                 a = h + e | 0;
                 if (a >>> 0 <= h >>> 0 | a >>> 0 > d >>> 0) {
                  break v;
                 }
                }
                a = hp(e);
                if ((c | 0) != (a | 0)) {
                 break x;
                }
                break u;
               }
               e = h & e - c;
               c = hp(e);
               if ((c | 0) == (v[a >> 2] + v[a + 4 >> 2] | 0)) {
                break w;
               }
               a = c;
              }
              if ((a | 0) == -1) {
               break v;
              }
              if (g + 48 >>> 0 <= e >>> 0) {
               c = a;
               break u;
              }
              c = v[31597];
              c = c + (f - e | 0) & 0 - c;
              if ((hp(c) | 0) == -1) {
               break v;
              }
              e = c + e | 0;
              c = a;
              break u;
             }
             if ((c | 0) != -1) {
              break u;
             }
            }
            v[31588] = v[31588] | 4;
           }
           c = hp(b);
           a = hp(0);
           if ((c | 0) == -1 | (a | 0) == -1 | a >>> 0 <= c >>> 0) {
            break e;
           }
           e = a - c | 0;
           if (e >>> 0 <= g + 40 >>> 0) {
            break e;
           }
          }
          a = v[31585] + e | 0;
          v[31585] = a;
          if (a >>> 0 > y[31586]) {
           v[31586] = a;
          }
          z: {
           f = v[31483];
           if (f) {
            a = 126356;
            while (1) {
             b = v[a >> 2];
             d = v[a + 4 >> 2];
             if ((b + d | 0) == (c | 0)) {
              break z;
             }
             a = v[a + 8 >> 2];
             if (a) {
              continue;
             }
             break;
            }
            break g;
           }
           a = v[31481];
           if (!(a >>> 0 <= c >>> 0 ? a : 0)) {
            v[31481] = c;
           }
           a = 0;
           v[31590] = e;
           v[31589] = c;
           v[31485] = -1;
           v[31486] = v[31595];
           v[31592] = 0;
           while (1) {
            b = a << 3;
            d = b + 125948 | 0;
            v[b + 125956 >> 2] = d;
            v[b + 125960 >> 2] = d;
            a = a + 1 | 0;
            if ((a | 0) != 32) {
             continue;
            }
            break;
           }
           a = e - 40 | 0;
           b = -8 - c & 7;
           d = a - b | 0;
           v[31480] = d;
           b = b + c | 0;
           v[31483] = b;
           v[b + 4 >> 2] = d | 1;
           v[(a + c | 0) + 4 >> 2] = 40;
           v[31484] = v[31599];
           break f;
          }
          if (v[a + 12 >> 2] & 8 | (c >>> 0 <= f >>> 0 | b >>> 0 > f >>> 0)) {
           break g;
          }
          v[a + 4 >> 2] = d + e;
          a = -8 - f & 7;
          b = a + f | 0;
          v[31483] = b;
          c = v[31480] + e | 0;
          a = c - a | 0;
          v[31480] = a;
          v[b + 4 >> 2] = a | 1;
          v[(c + f | 0) + 4 >> 2] = 40;
          v[31484] = v[31599];
          break f;
         }
         a = 0;
         break b;
        }
        a = 0;
        break c;
       }
       if (y[31481] > c >>> 0) {
        v[31481] = c;
       }
       b = c + e | 0;
       a = 126356;
       A: {
        while (1) {
         if ((b | 0) != v[a >> 2]) {
          a = v[a + 8 >> 2];
          if (a) {
           continue;
          }
          break A;
         }
         break;
        }
        if (!(w[a + 12 | 0] & 8)) {
         break d;
        }
       }
       a = 126356;
       while (1) {
        B: {
         b = v[a >> 2];
         if (b >>> 0 <= f >>> 0) {
          d = b + v[a + 4 >> 2] | 0;
          if (d >>> 0 > f >>> 0) {
           break B;
          }
         }
         a = v[a + 8 >> 2];
         continue;
        }
        break;
       }
       a = e - 40 | 0;
       b = -8 - c & 7;
       h = a - b | 0;
       v[31480] = h;
       b = b + c | 0;
       v[31483] = b;
       v[b + 4 >> 2] = h | 1;
       v[(a + c | 0) + 4 >> 2] = 40;
       v[31484] = v[31599];
       a = (d + (39 - d & 7) | 0) - 47 | 0;
       b = a >>> 0 < f + 16 >>> 0 ? f : a;
       v[b + 4 >> 2] = 27;
       a = v[31592];
       v[b + 16 >> 2] = v[31591];
       v[b + 20 >> 2] = a;
       a = v[31590];
       v[b + 8 >> 2] = v[31589];
       v[b + 12 >> 2] = a;
       v[31591] = b + 8;
       v[31590] = e;
       v[31589] = c;
       v[31592] = 0;
       a = b + 24 | 0;
       while (1) {
        v[a + 4 >> 2] = 7;
        c = a + 8 | 0;
        a = a + 4 | 0;
        if (c >>> 0 < d >>> 0) {
         continue;
        }
        break;
       }
       if ((b | 0) == (f | 0)) {
        break f;
       }
       v[b + 4 >> 2] = v[b + 4 >> 2] & -2;
       c = b - f | 0;
       v[f + 4 >> 2] = c | 1;
       v[b >> 2] = c;
       C: {
        if (c >>> 0 <= 255) {
         a = (c & -8) + 125948 | 0;
         b = v[31477];
         c = 1 << (c >>> 3);
         D: {
          if (!(b & c)) {
           v[31477] = b | c;
           b = a;
           break D;
          }
          b = v[a + 8 >> 2];
         }
         v[a + 8 >> 2] = f;
         v[b + 12 >> 2] = f;
         d = 8;
         c = 12;
         break C;
        }
        a = 31;
        if (c >>> 0 <= 16777215) {
         a = E(c >>> 8 | 0);
         a = ((c >>> 38 - a & 1) - (a << 1) | 0) + 62 | 0;
        }
        v[f + 28 >> 2] = a;
        v[f + 16 >> 2] = 0;
        v[f + 20 >> 2] = 0;
        b = (a << 2) + 126212 | 0;
        E: {
         d = v[31478];
         e = 1 << a;
         F: {
          if (!(d & e)) {
           v[31478] = d | e;
           v[b >> 2] = f;
           break F;
          }
          a = c << ((a | 0) != 31 ? 25 - (a >>> 1 | 0) | 0 : 0);
          d = v[b >> 2];
          while (1) {
           b = d;
           if ((c | 0) == (v[b + 4 >> 2] & -8)) {
            break E;
           }
           d = a >>> 29 | 0;
           a = a << 1;
           e = (d & 4) + b | 0;
           d = v[e + 16 >> 2];
           if (d) {
            continue;
           }
           break;
          }
          v[e + 16 >> 2] = f;
         }
         v[f + 24 >> 2] = b;
         b = f;
         a = b;
         d = 12;
         c = 8;
         break C;
        }
        a = v[b + 8 >> 2];
        v[a + 12 >> 2] = f;
        v[b + 8 >> 2] = f;
        v[f + 8 >> 2] = a;
        a = 0;
        d = 12;
        c = 24;
       }
       v[d + f >> 2] = b;
       v[c + f >> 2] = a;
      }
      a = v[31480];
      if (a >>> 0 <= g >>> 0) {
       break e;
      }
      b = a - g | 0;
      v[31480] = b;
      a = v[31483];
      c = a + g | 0;
      v[31483] = c;
      v[c + 4 >> 2] = b | 1;
      v[a + 4 >> 2] = g | 3;
      a = a + 8 | 0;
      break a;
     }
     v[31476] = 48;
     a = 0;
     break a;
    }
    v[a >> 2] = c;
    v[a + 4 >> 2] = v[a + 4 >> 2] + e;
    j = (-8 - c & 7) + c | 0;
    v[j + 4 >> 2] = g | 3;
    e = b + (-8 - b & 7) | 0;
    f = g + j | 0;
    i = e - f | 0;
    G: {
     if (v[31483] == (e | 0)) {
      v[31483] = f;
      a = v[31480] + i | 0;
      v[31480] = a;
      v[f + 4 >> 2] = a | 1;
      break G;
     }
     if (v[31482] == (e | 0)) {
      v[31482] = f;
      a = v[31479] + i | 0;
      v[31479] = a;
      v[f + 4 >> 2] = a | 1;
      v[a + f >> 2] = a;
      break G;
     }
     a = v[e + 4 >> 2];
     if ((a & 3) == 1) {
      g = a & -8;
      c = v[e + 12 >> 2];
      H: {
       if (a >>> 0 <= 255) {
        b = v[e + 8 >> 2];
        if ((b | 0) == (c | 0)) {
         m = 125908, n = v[31477] & Dua(-2, a >>> 3 | 0), v[m >> 2] = n;
         break H;
        }
        v[b + 12 >> 2] = c;
        v[c + 8 >> 2] = b;
        break H;
       }
       h = v[e + 24 >> 2];
       I: {
        if ((c | 0) != (e | 0)) {
         a = v[e + 8 >> 2];
         v[a + 12 >> 2] = c;
         v[c + 8 >> 2] = a;
         break I;
        }
        J: {
         a = v[e + 20 >> 2];
         if (a) {
          b = e + 20 | 0;
         } else {
          a = v[e + 16 >> 2];
          if (!a) {
           break J;
          }
          b = e + 16 | 0;
         }
         while (1) {
          d = b;
          c = a;
          b = a + 20 | 0;
          a = v[a + 20 >> 2];
          if (a) {
           continue;
          }
          b = c + 16 | 0;
          a = v[c + 16 >> 2];
          if (a) {
           continue;
          }
          break;
         }
         v[d >> 2] = 0;
         break I;
        }
        c = 0;
       }
       if (!h) {
        break H;
       }
       a = v[e + 28 >> 2];
       b = (a << 2) + 126212 | 0;
       K: {
        if (v[b >> 2] == (e | 0)) {
         v[b >> 2] = c;
         if (c) {
          break K;
         }
         m = 125912, n = v[31478] & Dua(-2, a), v[m >> 2] = n;
         break H;
        }
        v[h + (v[h + 16 >> 2] == (e | 0) ? 16 : 20) >> 2] = c;
        if (!c) {
         break H;
        }
       }
       v[c + 24 >> 2] = h;
       a = v[e + 16 >> 2];
       if (a) {
        v[c + 16 >> 2] = a;
        v[a + 24 >> 2] = c;
       }
       a = v[e + 20 >> 2];
       if (!a) {
        break H;
       }
       v[c + 20 >> 2] = a;
       v[a + 24 >> 2] = c;
      }
      i = g + i | 0;
      e = e + g | 0;
      a = v[e + 4 >> 2];
     }
     v[e + 4 >> 2] = a & -2;
     v[f + 4 >> 2] = i | 1;
     v[f + i >> 2] = i;
     if (i >>> 0 <= 255) {
      a = (i & -8) + 125948 | 0;
      b = v[31477];
      c = 1 << (i >>> 3);
      L: {
       if (!(b & c)) {
        v[31477] = b | c;
        b = a;
        break L;
       }
       b = v[a + 8 >> 2];
      }
      v[a + 8 >> 2] = f;
      v[b + 12 >> 2] = f;
      v[f + 12 >> 2] = a;
      v[f + 8 >> 2] = b;
      break G;
     }
     c = 31;
     if (i >>> 0 <= 16777215) {
      a = E(i >>> 8 | 0);
      c = ((i >>> 38 - a & 1) - (a << 1) | 0) + 62 | 0;
     }
     v[f + 28 >> 2] = c;
     v[f + 16 >> 2] = 0;
     v[f + 20 >> 2] = 0;
     a = (c << 2) + 126212 | 0;
     M: {
      b = v[31478];
      d = 1 << c;
      N: {
       if (!(b & d)) {
        v[31478] = b | d;
        v[a >> 2] = f;
        break N;
       }
       c = i << ((c | 0) != 31 ? 25 - (c >>> 1 | 0) | 0 : 0);
       b = v[a >> 2];
       while (1) {
        a = b;
        if ((v[a + 4 >> 2] & -8) == (i | 0)) {
         break M;
        }
        b = c >>> 29 | 0;
        c = c << 1;
        d = (b & 4) + a | 0;
        b = v[d + 16 >> 2];
        if (b) {
         continue;
        }
        break;
       }
       v[d + 16 >> 2] = f;
      }
      v[f + 24 >> 2] = a;
      v[f + 12 >> 2] = f;
      v[f + 8 >> 2] = f;
      break G;
     }
     b = v[a + 8 >> 2];
     v[b + 12 >> 2] = f;
     v[a + 8 >> 2] = f;
     v[f + 24 >> 2] = 0;
     v[f + 12 >> 2] = a;
     v[f + 8 >> 2] = b;
    }
    a = j + 8 | 0;
    break a;
   }
   O: {
    if (!h) {
     break O;
    }
    b = v[d + 28 >> 2];
    c = (b << 2) + 126212 | 0;
    P: {
     if (v[c >> 2] == (d | 0)) {
      v[c >> 2] = a;
      if (a) {
       break P;
      }
      i = Dua(-2, b) & i;
      v[31478] = i;
      break O;
     }
     v[h + (v[h + 16 >> 2] == (d | 0) ? 16 : 20) >> 2] = a;
     if (!a) {
      break O;
     }
    }
    v[a + 24 >> 2] = h;
    b = v[d + 16 >> 2];
    if (b) {
     v[a + 16 >> 2] = b;
     v[b + 24 >> 2] = a;
    }
    b = v[d + 20 >> 2];
    if (!b) {
     break O;
    }
    v[a + 20 >> 2] = b;
    v[b + 24 >> 2] = a;
   }
   Q: {
    if (f >>> 0 <= 15) {
     a = f + g | 0;
     v[d + 4 >> 2] = a | 3;
     a = a + d | 0;
     v[a + 4 >> 2] = v[a + 4 >> 2] | 1;
     break Q;
    }
    v[d + 4 >> 2] = g | 3;
    e = d + g | 0;
    v[e + 4 >> 2] = f | 1;
    v[f + e >> 2] = f;
    if (f >>> 0 <= 255) {
     a = (f & -8) + 125948 | 0;
     b = v[31477];
     c = 1 << (f >>> 3);
     R: {
      if (!(b & c)) {
       v[31477] = b | c;
       b = a;
       break R;
      }
      b = v[a + 8 >> 2];
     }
     v[a + 8 >> 2] = e;
     v[b + 12 >> 2] = e;
     v[e + 12 >> 2] = a;
     v[e + 8 >> 2] = b;
     break Q;
    }
    a = 31;
    if (f >>> 0 <= 16777215) {
     a = E(f >>> 8 | 0);
     a = ((f >>> 38 - a & 1) - (a << 1) | 0) + 62 | 0;
    }
    v[e + 28 >> 2] = a;
    v[e + 16 >> 2] = 0;
    v[e + 20 >> 2] = 0;
    b = (a << 2) + 126212 | 0;
    S: {
     c = 1 << a;
     T: {
      if (!(c & i)) {
       v[31478] = c | i;
       v[b >> 2] = e;
       v[e + 24 >> 2] = b;
       break T;
      }
      a = f << ((a | 0) != 31 ? 25 - (a >>> 1 | 0) | 0 : 0);
      b = v[b >> 2];
      while (1) {
       c = b;
       if ((v[b + 4 >> 2] & -8) == (f | 0)) {
        break S;
       }
       h = a >>> 29 | 0;
       a = a << 1;
       h = b + (h & 4) | 0;
       b = v[h + 16 >> 2];
       if (b) {
        continue;
       }
       break;
      }
      v[h + 16 >> 2] = e;
      v[e + 24 >> 2] = c;
     }
     v[e + 12 >> 2] = e;
     v[e + 8 >> 2] = e;
     break Q;
    }
    a = v[c + 8 >> 2];
    v[a + 12 >> 2] = e;
    v[c + 8 >> 2] = e;
    v[e + 24 >> 2] = 0;
    v[e + 12 >> 2] = c;
    v[e + 8 >> 2] = a;
   }
   a = d + 8 | 0;
   break a;
  }
  U: {
   if (!j) {
    break U;
   }
   b = v[c + 28 >> 2];
   d = (b << 2) + 126212 | 0;
   V: {
    if (v[d >> 2] == (c | 0)) {
     v[d >> 2] = a;
     if (a) {
      break V;
     }
     m = 125912, n = Dua(-2, b) & l, v[m >> 2] = n;
     break U;
    }
    v[j + (v[j + 16 >> 2] == (c | 0) ? 16 : 20) >> 2] = a;
    if (!a) {
     break U;
    }
   }
   v[a + 24 >> 2] = j;
   b = v[c + 16 >> 2];
   if (b) {
    v[a + 16 >> 2] = b;
    v[b + 24 >> 2] = a;
   }
   b = v[c + 20 >> 2];
   if (!b) {
    break U;
   }
   v[a + 20 >> 2] = b;
   v[b + 24 >> 2] = a;
  }
  W: {
   if (f >>> 0 <= 15) {
    a = f + g | 0;
    v[c + 4 >> 2] = a | 3;
    a = a + c | 0;
    v[a + 4 >> 2] = v[a + 4 >> 2] | 1;
    break W;
   }
   v[c + 4 >> 2] = g | 3;
   h = c + g | 0;
   v[h + 4 >> 2] = f | 1;
   v[f + h >> 2] = f;
   if (i) {
    a = (i & -8) + 125948 | 0;
    d = v[31482];
    b = 1 << (i >>> 3);
    X: {
     if (!(b & e)) {
      v[31477] = b | e;
      b = a;
      break X;
     }
     b = v[a + 8 >> 2];
    }
    v[a + 8 >> 2] = d;
    v[b + 12 >> 2] = d;
    v[d + 12 >> 2] = a;
    v[d + 8 >> 2] = b;
   }
   v[31482] = h;
   v[31479] = f;
  }
  a = c + 8 | 0;
 }
 eb = k + 16 | 0;
 return a | 0;
}

function YL(a, b, c, d, e, f, g) {
 var h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, q = 0;
 i = eb - 208 | 0;
 eb = i;
 a: {
  b: {
   if (g) {
    rf(i + 196 | 0, f, 32);
    v[31601] = 0;
    T(541, i + 184 | 0, f | 0, 32) | 0;
    h = v[31601];
    v[31601] = 0;
    if ((h | 0) != 1) {
     break b;
    }
    f = M() | 0;
    break a;
   }
   Eb(i + 196 | 0);
   Eb(i + 184 | 0);
  }
  c: {
   d: {
    e: {
     f: {
      g: {
       h: {
        i: {
         j: {
          if (Vt(c)) {
           h = v[b + 24 >> 2];
           j = v[h + 484344 >> 2];
           if (Ie(j, v[h + 484348 >> 2], c & 65535)) {
            break j;
           }
          }
          v[31601] = 0;
          R(1210, a | 0, i + 196 | 0, i + 184 | 0);
          a = v[31601];
          v[31601] = 0;
          if ((a | 0) != 1) {
           break i;
          }
          f = M() | 0;
          break c;
         }
         c = Vb(j, c);
         if (!(!((e | 0) < 0 | v[c + 12 >> 2] <= (d | 0) | (d | 0) < 0) & x[h + 480188 >> 1] > e >>> 0)) {
          v[31601] = 0;
          R(1210, a | 0, i + 196 | 0, i + 184 | 0);
          a = v[31601];
          v[31601] = 0;
          if ((a | 0) != 1) {
           break i;
          }
          f = M() | 0;
          break c;
         }
         c = ld(v[c >> 2], v[v[c + 48 >> 2] + 12 >> 2], d, e & 65535);
         sf(i + 196 | 0);
         sf(i + 184 | 0);
         k: {
          l: {
           m: {
            n: {
             o: {
              p: {
               q: {
                r: {
                 s: {
                  t: {
                   u: {
                    v: {
                     w: {
                      x: {
                       y: {
                        z: {
                         A: {
                          d = w[c | 0];
                          if (!Tc(d)) {
                           if (!Dl(d)) {
                            break A;
                           }
                          }
                          e = w[c + 1 | 0];
                          h = v[b + 24 >> 2];
                          v[31601] = 0;
                          j = i + 160 | 0;
                          U(1211, j | 0, h | 0, d | 0, e | 0);
                          d = v[31601];
                          v[31601] = 0;
                          e = 1;
                          if ((d | 0) == 1) {
                           break y;
                          }
                          v[31601] = 0;
                          N(1058, i + 172 | 0, j | 0);
                          d = v[31601];
                          v[31601] = 0;
                          if ((d | 0) != 1) {
                           break z;
                          }
                          f = M() | 0;
                          break v;
                         }
                         e = 0;
                         v[31601] = 0;
                         O(36, i + 172 | 0, 16764) | 0;
                         d = v[31601];
                         v[31601] = 0;
                         if ((d | 0) == 1) {
                          break x;
                         }
                        }
                        v[31601] = 0;
                        h = i + 172 | 0;
                        d = O(837, i + 196 | 0, h | 0) | 0;
                        j = v[31601];
                        v[31601] = 0;
                        if ((j | 0) == 1) {
                         break w;
                        }
                        sb(h);
                        if (e) {
                         sb(i + 160 | 0);
                        }
                        e = 9968;
                        h = w[c | 0];
                        if (!Tc(h)) {
                         e = Dl(h) ? 10278 : 16764;
                        }
                        v[31601] = 0;
                        h = O(36, i + 172 | 0, e | 0) | 0;
                        e = v[31601];
                        v[31601] = 0;
                        if ((e | 0) == 1) {
                         break u;
                        }
                        v[31601] = 0;
                        e = O(837, i + 184 | 0, h | 0) | 0;
                        j = v[31601];
                        v[31601] = 0;
                        if ((j | 0) == 1) {
                         break t;
                        }
                        sb(h);
                        if (f - 6 >>> 0 > 4294967290) {
                         break l;
                        }
                        v[31601] = 0;
                        h = O(36, i + 148 | 0, 18418) | 0;
                        j = v[31601];
                        v[31601] = 0;
                        if ((j | 0) == 1) {
                         break s;
                        }
                        v[31601] = 0;
                        j = O(837, d | 0, h | 0) | 0;
                        m = v[31601];
                        v[31601] = 0;
                        if ((m | 0) == 1) {
                         break r;
                        }
                        sb(h);
                        v[31601] = 0;
                        h = O(36, i + 136 | 0, 18418) | 0;
                        m = v[31601];
                        v[31601] = 0;
                        if ((m | 0) == 1) {
                         break q;
                        }
                        v[31601] = 0;
                        m = O(837, e | 0, h | 0) | 0;
                        k = v[31601];
                        v[31601] = 0;
                        if ((k | 0) == 1) {
                         break p;
                        }
                        sb(h);
                        h = c + 1 | 0;
                        B: {
                         if (w[c + 1 | 0]) {
                          v[31601] = 0;
                          N(558, i + 124 | 0, h | 0);
                          k = v[31601];
                          v[31601] = 0;
                          if ((k | 0) != 1) {
                           break B;
                          }
                          break d;
                         }
                         v[31601] = 0;
                         O(36, i + 124 | 0, 16769) | 0;
                         k = v[31601];
                         v[31601] = 0;
                         if ((k | 0) == 1) {
                          break d;
                         }
                        }
                        v[31601] = 0;
                        k = j;
                        j = i + 124 | 0;
                        k = O(837, k | 0, j | 0) | 0;
                        l = v[31601];
                        v[31601] = 0;
                        if ((l | 0) == 1) {
                         break o;
                        }
                        sb(j);
                        h = w[h | 0];
                        v[31601] = 0;
                        h = O(36, j | 0, (h ? 10801 : 16769) | 0) | 0;
                        j = v[31601];
                        v[31601] = 0;
                        if ((j | 0) == 1) {
                         break n;
                        }
                        v[31601] = 0;
                        m = O(837, m | 0, h | 0) | 0;
                        j = v[31601];
                        v[31601] = 0;
                        if ((j | 0) != 1) {
                         break m;
                        }
                        f = M() | 0;
                        sb(h);
                        break c;
                       }
                       f = M() | 0;
                       break c;
                      }
                      f = M() | 0;
                      break c;
                     }
                     f = M() | 0;
                     sb(i + 172 | 0);
                     if (!e) {
                      break c;
                     }
                    }
                    sb(i + 160 | 0);
                    break c;
                   }
                   f = M() | 0;
                   break c;
                  }
                  f = M() | 0;
                  sb(h);
                  break c;
                 }
                 f = M() | 0;
                 break c;
                }
                f = M() | 0;
                sb(h);
                break c;
               }
               f = M() | 0;
               break c;
              }
              f = M() | 0;
              sb(h);
              break c;
             }
             f = M() | 0;
             sb(i + 124 | 0);
             break c;
            }
            f = M() | 0;
            break c;
           }
           sb(h);
           if (f - 9 >>> 0 > 4294967287) {
            break l;
           }
           C: {
            D: {
             E: {
              F: {
               G: {
                H: {
                 I: {
                  J: {
                   K: {
                    L: {
                     M: {
                      N: {
                       j = Vg(w[c | 0]);
                       O: {
                        if (j) {
                         v[31601] = 0;
                         l = O(36, i + 100 | 0, 18418) | 0;
                         h = v[31601];
                         v[31601] = 0;
                         if ((h | 0) == 1) {
                          break N;
                         }
                         h = w[c + 4 | 0];
                         n = w[c + 2 | 0];
                         v[31601] = 0;
                         o = i, q = Bj(n, h) & 255, v[o + 76 >> 2] = q;
                         n = i + 88 | 0;
                         N(557, n | 0, i + 76 | 0);
                         h = v[31601];
                         v[31601] = 0;
                         if ((h | 0) == 1) {
                          break M;
                         }
                         h = 0;
                         v[31601] = 0;
                         R(1014, i + 112 | 0, l | 0, n | 0);
                         l = v[31601];
                         v[31601] = 0;
                         if ((l | 0) != 1) {
                          break O;
                         }
                         f = M() | 0;
                         break G;
                        }
                        h = w[c + 2 | 0];
                        if (h) {
                         h = lR(v[v[v[b + 24 >> 2] + 8 >> 2] + 88 >> 2], h);
                         v[31601] = 0;
                         h = T(541, i + 100 | 0, 1, h | 0) | 0;
                         l = v[31601];
                         v[31601] = 0;
                         if ((l | 0) == 1) {
                          break E;
                         }
                         v[31601] = 0;
                         l = i + 88 | 0;
                         N(558, l | 0, c + 4 | 0);
                         n = v[31601];
                         v[31601] = 0;
                         if ((n | 0) == 1) {
                          break L;
                         }
                         v[31601] = 0;
                         R(1014, i + 112 | 0, h | 0, l | 0);
                         l = v[31601];
                         v[31601] = 0;
                         h = 1;
                         if ((l | 0) != 1) {
                          break O;
                         }
                         f = M() | 0;
                         break J;
                        }
                        h = 0;
                        v[31601] = 0;
                        O(36, i + 112 | 0, 16768) | 0;
                        l = v[31601];
                        v[31601] = 0;
                        if ((l | 0) == 1) {
                         break e;
                        }
                       }
                       v[31601] = 0;
                       l = k;
                       k = i + 112 | 0;
                       l = O(837, l | 0, k | 0) | 0;
                       n = v[31601];
                       v[31601] = 0;
                       if ((n | 0) == 1) {
                        break K;
                       }
                       sb(k);
                       if (h) {
                        sb(i + 88 | 0);
                        sb(i + 100 | 0);
                       }
                       if (j) {
                        sb(i + 88 | 0);
                        sb(i + 100 | 0);
                       }
                       h = 5488;
                       if (!Vg(w[c | 0])) {
                        h = w[c + 2 | 0] ? 5484 : 16768;
                       }
                       v[31601] = 0;
                       h = O(36, i + 112 | 0, h | 0) | 0;
                       j = v[31601];
                       v[31601] = 0;
                       if ((j | 0) == 1) {
                        break D;
                       }
                       v[31601] = 0;
                       j = O(837, m | 0, h | 0) | 0;
                       m = v[31601];
                       v[31601] = 0;
                       if ((m | 0) != 1) {
                        break C;
                       }
                       f = M() | 0;
                       sb(h);
                       break c;
                      }
                      f = M() | 0;
                      break c;
                     }
                     f = M() | 0;
                     break F;
                    }
                    f = M() | 0;
                    break I;
                   }
                   f = M() | 0;
                   sb(i + 112 | 0);
                   if (!h) {
                    break H;
                   }
                  }
                  sb(i + 88 | 0);
                 }
                 sb(i + 100 | 0);
                }
                if (!j) {
                 break c;
                }
               }
               sb(i + 88 | 0);
              }
              sb(i + 100 | 0);
              break c;
             }
             f = M() | 0;
             break c;
            }
            f = M() | 0;
            break c;
           }
           sb(h);
           if (f - 13 >>> 0 > 4294967283) {
            break l;
           }
           v[31601] = 0;
           h = O(36, i + 76 | 0, 18418) | 0;
           m = v[31601];
           v[31601] = 0;
           P: {
            Q: {
             R: {
              S: {
               T: {
                U: {
                 V: {
                  W: {
                   X: {
                    Y: {
                     Z: {
                      if ((m | 0) != 1) {
                       v[31601] = 0;
                       m = O(837, l | 0, h | 0) | 0;
                       k = v[31601];
                       v[31601] = 0;
                       if ((k | 0) == 1) {
                        break Z;
                       }
                       sb(h);
                       v[31601] = 0;
                       h = O(36, i - -64 | 0, 18418) | 0;
                       k = v[31601];
                       v[31601] = 0;
                       if ((k | 0) == 1) {
                        break Y;
                       }
                       v[31601] = 0;
                       j = O(837, j | 0, h | 0) | 0;
                       k = v[31601];
                       v[31601] = 0;
                       if ((k | 0) == 1) {
                        break X;
                       }
                       sb(h);
                       h = w[c + 3 | 0];
                       _: {
                        if (Vg(w[c | 0])) {
                         k = w[c + 5 | 0];
                         b = 0;
                         v[31601] = 0;
                         o = i, q = Bj(h, k) & 4095, v[o + 16 >> 2] = q;
                         N(1212, i + 52 | 0, i + 16 | 0);
                         h = v[31601];
                         v[31601] = 0;
                         if ((h | 0) != 1) {
                          break _;
                         }
                         f = M() | 0;
                         break c;
                        }
                        if (h) {
                         b = kR(v[v[v[b + 24 >> 2] + 8 >> 2] + 84 >> 2], h);
                         v[31601] = 0;
                         b = T(541, i + 40 | 0, 1, b | 0) | 0;
                         h = v[31601];
                         v[31601] = 0;
                         if ((h | 0) == 1) {
                          break W;
                         }
                         v[31601] = 0;
                         h = i + 28 | 0;
                         N(558, h | 0, c + 5 | 0);
                         k = v[31601];
                         v[31601] = 0;
                         if ((k | 0) == 1) {
                          break V;
                         }
                         v[31601] = 0;
                         R(1014, i + 52 | 0, b | 0, h | 0);
                         h = v[31601];
                         v[31601] = 0;
                         b = 1;
                         if ((h | 0) != 1) {
                          break _;
                         }
                         f = M() | 0;
                         break S;
                        }
                        b = 0;
                        v[31601] = 0;
                        O(36, i + 52 | 0, 16764) | 0;
                        h = v[31601];
                        v[31601] = 0;
                        if ((h | 0) == 1) {
                         break U;
                        }
                       }
                       v[31601] = 0;
                       h = i + 52 | 0;
                       O(837, m | 0, h | 0) | 0;
                       m = v[31601];
                       v[31601] = 0;
                       if ((m | 0) == 1) {
                        break T;
                       }
                       sb(h);
                       if (b) {
                        sb(i + 28 | 0);
                        sb(i + 40 | 0);
                       }
                       b = 11161;
                       if (!Vg(w[c | 0])) {
                        b = w[c + 3 | 0] ? 11161 : 16764;
                       }
                       v[31601] = 0;
                       b = O(36, i + 52 | 0, b | 0) | 0;
                       c = v[31601];
                       v[31601] = 0;
                       if ((c | 0) == 1) {
                        break Q;
                       }
                       v[31601] = 0;
                       O(837, j | 0, b | 0) | 0;
                       c = v[31601];
                       v[31601] = 0;
                       if ((c | 0) != 1) {
                        break P;
                       }
                       f = M() | 0;
                       sb(b);
                       break c;
                      }
                      f = M() | 0;
                      break c;
                     }
                     f = M() | 0;
                     sb(h);
                     break c;
                    }
                    f = M() | 0;
                    break c;
                   }
                   f = M() | 0;
                   sb(h);
                   break c;
                  }
                  f = M() | 0;
                  break c;
                 }
                 f = M() | 0;
                 break R;
                }
                f = M() | 0;
                break c;
               }
               f = M() | 0;
               sb(i + 52 | 0);
               if (!b) {
                break c;
               }
              }
              sb(i + 28 | 0);
             }
             sb(i + 40 | 0);
             break c;
            }
            f = M() | 0;
            break c;
           }
           sb(b);
           if (!f) {
            break k;
           }
          }
          $: {
           aa: {
            ba: {
             ca: {
              b = Zc(v[d + 4 >> 2], w[d + 11 | 0]);
              da: {
               if (b >>> 0 > f >>> 0) {
                v[31601] = 0;
                b = i + 16 | 0;
                U(121, b | 0, d | 0, 0, f | 0);
                c = v[31601];
                v[31601] = 0;
                if ((c | 0) != 1) {
                 yb(d, b);
                 sb(b);
                 break da;
                }
                f = M() | 0;
                break c;
               }
               if (!g) {
                break da;
               }
               v[31601] = 0;
               b = T(541, i + 16 | 0, f - b | 0, 32) | 0;
               c = v[31601];
               v[31601] = 0;
               if ((c | 0) == 1) {
                break ca;
               }
               v[31601] = 0;
               O(837, d | 0, b | 0) | 0;
               c = v[31601];
               v[31601] = 0;
               if ((c | 0) == 1) {
                break ba;
               }
               sb(b);
              }
              b = Zc(v[e + 4 >> 2], w[e + 11 | 0]);
              if (b >>> 0 <= f >>> 0) {
               break $;
              }
              v[31601] = 0;
              b = i + 4 | 0;
              U(121, b | 0, e | 0, 0, f | 0);
              c = v[31601];
              v[31601] = 0;
              if ((c | 0) == 1) {
               break aa;
              }
              yb(e, b);
              sb(b);
              break k;
             }
             f = M() | 0;
             break c;
            }
            f = M() | 0;
            sb(b);
            break c;
           }
           f = M() | 0;
           break c;
          }
          if (!g) {
           break k;
          }
          v[31601] = 0;
          b = T(541, i + 4 | 0, f - b | 0, 32) | 0;
          c = v[31601];
          v[31601] = 0;
          if ((c | 0) == 1) {
           break h;
          }
          v[31601] = 0;
          O(837, e | 0, b | 0) | 0;
          c = v[31601];
          v[31601] = 0;
          if ((c | 0) == 1) {
           break g;
          }
          sb(b);
         }
         v[31601] = 0;
         R(1210, a | 0, d | 0, e | 0);
         a = v[31601];
         v[31601] = 0;
         if ((a | 0) == 1) {
          break f;
         }
        }
        sb(i + 184 | 0);
        sb(i + 196 | 0);
        eb = i + 208 | 0;
        return;
       }
       f = M() | 0;
       break c;
      }
      f = M() | 0;
      sb(b);
      break c;
     }
     f = M() | 0;
     break c;
    }
    f = M() | 0;
    break c;
   }
   f = M() | 0;
  }
  sb(i + 184 | 0);
 }
 sb(i + 196 | 0);
 P(f | 0);
 p();
}

function aka(a) {
 a = a | 0;
 var b = 0, c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, k = 0, m = 0, n = 0, o = 0, s = 0, z = 0, A = 0, D = 0, E = 0, F = 0, G = 0, H = C(0), I = C(0), J = 0, K = 0;
 h = eb - 32 | 0;
 eb = h;
 c = v[a + 1074308 >> 2];
 if (!(c >>> 0 > 18285125 | (c | 0) == 18284544)) {
  ag(a + 1074312 | 0, 0);
 }
 c = h + 12 | 0;
 i = a + 1074312 | 0;
 Ib(c, i, 0);
 b = Fb(v[v[h + 12 >> 2] >> 2], v[h + 16 >> 2]);
 d = v[a + 480180 >> 2];
 Ib(c, i, 0);
 n = (d & 16777248) != 0 & b;
 D = Fb(v[v[h + 12 >> 2] >> 2], v[h + 16 >> 2]);
 E = v[a + 480180 >> 2];
 a: {
  c = v[a + 1074308 >> 2];
  if (c >>> 0 > 18874367) {
   break a;
  }
  d = a + 900380 | 0;
  c = 1;
  while (1) {
   b: {
    b = c & 65535;
    if (b >>> 0 <= x[a + 480192 >> 1]) {
     b = v[d + (b << 2) >> 2];
     if (!b) {
      break b;
     }
     v[h + 12 >> 2] = B(w[b + 20 | 0], 100) >>> 6;
     v[h + 24 >> 2] = 100;
     J = b, K = v[Gb(h + 12 | 0, h + 24 | 0) >> 2], t[J + 20 | 0] = K;
     if (y[a + 1074308 >> 2] > 18350079 & n) {
      break b;
     }
     f = t[b + 26 | 0];
     t[b + 26 | 0] = ((f >> 31 | 1) + f | 0) / 2;
     if (y[a + 1074308 >> 2] > 18285313 & n) {
      break b;
     }
     FD(Vh(b, 2), v[a + 480180 >> 2]);
     f = v[a + 1074308 >> 2];
     c: {
      if (f >>> 0 < 18284544) {
       break c;
      }
      if (f >>> 0 > 18285135) {
       break b;
      }
      if (!w[b + 34 | 0]) {
       break c;
      }
      if (!Ij(w[b + 31 | 0])) {
       break c;
      }
      Kb(i, 2, 1);
      if (y[a + 1074308 >> 2] > 18285135) {
       break b;
      }
     }
     if (!(w[b + 24 | 0] | (w[b + 23 | 0] | (w[b + 19 | 0] | w[b + 20 | 0])))) {
      break b;
     }
     Kb(i, 1, 1);
    }
    d: {
     if (!(v[a + 480180 >> 2] & 16777248) | y[a + 1074308 >> 2] > 18285313 & n) {
      break d;
     }
     c = x[a + 480190 >> 1] + 1 & 65535;
     d = c >>> 0 <= 1 ? 1 : c;
     f = a + 484380 | 0;
     b = 1;
     while (1) {
      if ((b | 0) == (d | 0)) {
       break d;
      }
      c = f + B(b, 104) | 0;
      if (!(w[c + 39 | 0] | !(w[c + 41 | 0] | w[c + 40 | 0]))) {
       t[c + 39 | 0] = 255;
      }
      b = b + 1 | 0;
      continue;
     }
    }
    c = a + 901404 | 0;
    d = c + 288 | 0;
    b = mV(d);
    while (1) {
     if ((b | 0) == (d | 0)) {
      e: {
       d = c + 800 | 0;
       c = xC(d);
       while (1) {
        if ((c | 0) == (d | 0)) {
         break e;
        }
        lV(d);
        d = d + 32 | 0;
        continue;
       }
      }
     } else {
      lV(d);
      d = d + 32 | 0;
      continue;
     }
     break;
    }
    c = v[a + 1074308 >> 2];
    break a;
   }
   c = c + 1 | 0;
   continue;
  }
 }
 f: {
  if (!(v[a + 480180 >> 2] & 16777252) | ((c | 0) == 18874368 | c >>> 0 > 18874895)) {
   break f;
  }
  b = x[a + 480192 >> 1] + 1 & 65535;
  f = b >>> 0 <= 1 ? 1 : b;
  g = a + 900380 | 0;
  b = 1;
  while (1) {
   if ((b | 0) == (f | 0)) {
    if (!(e & 1)) {
     break f;
    }
    Kb(i, 3, 1);
    c = v[a + 1074308 >> 2];
   } else {
    d = v[g + (b << 2) >> 2];
    if (!(!d | !w[d + 31 | 0])) {
     t[d + 33 | 0] = 13;
     e = 1;
    }
    b = b + 1 | 0;
    continue;
   }
   break;
  }
 }
 g: {
  if (!(v[a + 480180 >> 2] & 16777248) | ((c | 0) == 19005440 | c >>> 0 > 19006225)) {
   break g;
  }
  Ib(h + 12 | 0, i, 0);
  if (!Fb(v[v[h + 12 >> 2] >> 2], v[h + 16 >> 2])) {
   Ib(h + 24 | 0, i, 1);
   if (!Fb(v[v[h + 24 >> 2] >> 2], v[h + 28 >> 2])) {
    break g;
   }
  }
  c = x[a + 480192 >> 1] + 1 & 65535;
  d = c >>> 0 <= 1 ? 1 : c;
  e = a + 900380 | 0;
  b = 1;
  while (1) {
   if ((b | 0) == (d | 0)) {
    break g;
   }
   c = v[e + (b << 2) >> 2];
   if (!(!c | !w[c + 19 | 0] | !(t[c + 80 | 0] & 1))) {
    t[c + 19 | 0] = 0;
   }
   b = b + 1 | 0;
   continue;
  }
 }
 e = v[a + 480180 >> 2];
 h: {
  i: {
   if (!(e & 16777252)) {
    break i;
   }
   c = a + 906300 | 0;
   f = tk(c);
   b = c;
   while (1) {
    if ((b | 0) == (f | 0)) {
     break i;
    }
    d = b;
    b = b + 160 | 0;
    if (!Li(w[d + 16 | 0] | w[d + 17 | 0] << 8 | (w[d + 18 | 0] << 16 | w[d + 19 | 0] << 24), w[d + 20 | 0] | w[d + 21 | 0] << 8 | (w[d + 22 | 0] << 16 | w[d + 23 | 0] << 24))) {
     continue;
    }
    break;
   }
   s = 1;
   d = v[a + 1074308 >> 2];
   if (d >>> 0 > 19007232) {
    break h;
   }
   while (1) {
    if ((c | 0) != (f | 0)) {
     d = h + 12 | 0;
     b = eb - 32 | 0;
     eb = b;
     e = b + 8 | 0;
     k = c + 80 | 0;
     VR(e, k);
     v[31601] = 0;
     g = b + 20 | 0;
     R(123, g | 0, 22, e | 0);
     m = v[31601];
     v[31601] = 0;
     j: {
      k: {
       l: {
        if ((m | 0) != 1) {
         v[31601] = 0;
         R(244, d | 0, 0, g | 0);
         m = v[31601];
         v[31601] = 0;
         if ((m | 0) == 1) {
          break l;
         }
         Tb(g);
         sb(e);
         eb = b + 32 | 0;
         break j;
        }
        a = M() | 0;
        break k;
       }
       a = M() | 0;
       Tb(b + 20 | 0);
      }
      sb(b + 8 | 0);
      P(a | 0);
      p();
     }
     rw(k, d);
     c = c + 160 | 0;
     sb(d);
     continue;
    }
    break;
   }
   e = v[a + 480180 >> 2];
  }
  d = v[a + 1074308 >> 2];
 }
 m: {
  n: {
   o: {
    p: {
     q: {
      if ((e | 0) != 4) {
       break q;
      }
      if (d >>> 0 < 19007257) {
       break p;
      }
      if (w[a + 1074368 | 0] != 4 | d >>> 0 > 19071235) {
       break q;
      }
      TA(a, 5);
      d = v[a + 1074308 >> 2];
     }
     if (d >>> 0 > 19202054) {
      break o;
     }
     c = 19202048;
     if ((d | 0) == 19202048) {
      break n;
     }
    }
    c = x[a + 480192 >> 1] + 1 & 65535;
    f = c >>> 0 <= 1 ? 1 : c;
    g = a + 900380 | 0;
    c = 1;
    while (1) {
     if ((c | 0) == (f | 0)) {
      break o;
     }
     e = v[g + (c << 2) >> 2];
     r: {
      if (!e | !w[e + 20 | 0] | !w[e + 31 | 0]) {
       break r;
      }
      b = e + 236 | 0;
      k = ur(b);
      while (1) {
       if ((b | 0) != (k | 0)) {
        m = x[b >> 1];
        b = b + 2 | 0;
        if (!m) {
         continue;
        }
        break r;
       }
       break;
      }
      t[e + 20 | 0] = 0;
     }
     c = c + 1 | 0;
     continue;
    }
   }
   c = d;
   if (c >>> 0 > 19267583) {
    break m;
   }
  }
  b = x[a + 480192 >> 1] + 1 & 65535;
  e = b >>> 0 <= 1 ? 1 : b;
  f = a + 900380 | 0;
  b = 1;
  while (1) {
   if ((b | 0) == (e | 0)) {
    break m;
   }
   d = v[f + (b << 2) >> 2];
   s: {
    if (!d) {
     break s;
    }
    c = t[d + 26 | 0];
    t[d + 26 | 0] = ((c >> 31 | 1) + c | 0) / 2;
    c = v[a + 1074308 >> 2];
    if (c >>> 0 > 18350079 & n) {
     break s;
    }
    t[d + 19 | 0] = w[d + 19 | 0] + 3 >>> 2;
   }
   b = b + 1 | 0;
   continue;
  }
 }
 t: {
  if (c >>> 0 > 19398673) {
   break t;
  }
  d = a + 900380 | 0;
  e = x[a + 480192 >> 1];
  b = 1;
  while (1) {
   f = b & 65535;
   if (f >>> 0 > e >>> 0) {
    break t;
   }
   f = v[d + (f << 2) >> 2];
   if (!f | w[f + 65 | 0] == 255) {
    b = b + 1 | 0;
    continue;
   } else {
    Kb(i, 94, 1);
    c = v[a + 1074308 >> 2];
   }
   break;
  }
 }
 u: {
  if (c >>> 0 > 19399427) {
   break u;
  }
  d = a + 900380 | 0;
  e = x[a + 480192 >> 1];
  b = 1;
  while (1) {
   f = b & 65535;
   if (f >>> 0 > e >>> 0) {
    break u;
   }
   f = v[d + (f << 2) >> 2];
   if (!f | w[f + 36 | 0] > 1) {
    b = b + 1 | 0;
    continue;
   } else {
    Kb(i, 101, 1);
    c = v[a + 1074308 >> 2];
   }
   break;
  }
 }
 v: {
  if (c >>> 0 > 19923027) {
   break v;
  }
  d = a + 484380 | 0;
  e = x[a + 480190 >> 1];
  b = 1;
  while (1) {
   c = b & 65535;
   if (c >>> 0 > e >>> 0) {
    break v;
   }
   c = d + B(c, 104) | 0;
   if (!ke(v[c >> 2], v[c + 20 >> 2]) | !(w[c + 34 | 0] & 20)) {
    b = b + 1 | 0;
    continue;
   } else {
    Kb(i, 116, 1);
   }
   break;
  }
 }
 c = eb - 16 | 0;
 eb = c;
 u[h + 4 >> 1] = 0;
 v[h >> 2] = a;
 Ib(c + 8 | 0, a + 1074312 | 0, 0);
 J = h, K = Fb(v[v[c + 8 >> 2] >> 2], v[c + 12 >> 2]), t[J + 6 | 0] = K;
 eb = c + 16 | 0;
 c = v[h >> 2];
 A = v[h + 4 >> 2];
 f = eb - 32 | 0;
 eb = f;
 b = a + 484344 | 0;
 d = vb(v[b >> 2]);
 v[f + 28 >> 2] = d;
 F = vb(v[b + 4 >> 2]);
 while (1) {
  if (Hb(d, F)) {
   b = vb(v[d >> 2]);
   G = vb(v[d + 4 >> 2]);
   v[f + 16 >> 2] = c;
   v[f + 20 >> 2] = A;
   v[f >> 2] = c;
   v[f + 4 >> 2] = A;
   m = eb - 16 | 0;
   eb = m;
   v[m + 12 >> 2] = b;
   while (1) {
    if (Hb(b, G)) {
     z = x[f + 4 >> 1];
     d = z + 1 | 0;
     u[f + 4 >> 1] = d;
     e = v[f >> 2];
     u[f + 4 >> 1] = x[e + 480188 >> 1] > (d & 65535) >>> 0 ? d : 0;
     w: {
      if (Vg(w[b | 0])) {
       break w;
      }
      g = v[e + 1074308 >> 2];
      x: {
       k = v[e + 480180 >> 2];
       y: {
        z: {
         if ((k | 0) == 2) {
          if (g >>> 0 > 18415615) {
           break z;
          }
          if (w[b + 3 | 0] != 23) {
           break y;
          }
          Nf(b + 5 | 0, 64);
          break y;
         }
         A: {
          if (k & 16777248) {
           B: {
            C: {
             if (g >>> 0 >= 18285314) {
              if (w[f + 6 | 0]) {
               break C;
              }
              e = 0;
              d = 0;
              if (g >>> 0 > 18874367) {
               break B;
              }
             }
             D: {
              switch (w[b + 3 | 0] - 20 | 0) {
              case 3:
               Nf(b + 5 | 0, 128);
               break C;

              case 0:
               break D;

              default:
               break C;
              }
             }
             d = w[b + 5 | 0];
             if ((d | 0) != 208) {
              if ((d | 0) != 192) {
               break C;
              }
              t[b | 0] = 254;
              t[b + 3 | 0] = 0;
              break C;
             }
             t[b + 3 | 0] = 0;
            }
            E: {
             F: {
              G: {
               if (g >>> 0 >= 18350080) {
                if (w[f + 6 | 0]) {
                 break G;
                }
                e = 0;
                d = 0;
                if (g >>> 0 > 18874367) {
                 break B;
                }
               }
               d = w[b + 3 | 0];
               if (d >>> 0 > 29) {
                break F;
               }
               e = 1;
               if (!(1 << d & 536873152)) {
                break F;
               }
               break E;
              }
              e = 0;
              d = 0;
              if (g >>> 0 > 18874367) {
               break B;
              }
              d = w[b + 3 | 0];
             }
             e = 0;
            }
            d = (d | 0) == 24 | (d | 0) == 22;
           }
           H: {
            if (!(d | e)) {
             break H;
            }
            e = w[b + 5 | 0];
            d = e & 15;
            if (!d | (d | 0) == 15) {
             break H;
            }
            e = e & 240;
            if (!e | (e | 0) == 240) {
             break H;
            }
            t[b + 5 | 0] = w[b + 3 | 0] == 24 ? e : d;
           }
           I: {
            if ((g | 0) == 19005440 | g >>> 0 > 19005699) {
             break I;
            }
            d = x[v[f >> 2] + 480192 >> 1];
            if (w[f + 6 | 0] | (!d | d >>> 0 >= w[b + 1 | 0])) {
             break I;
            }
            t[b + 4 | 0] = 0;
            t[b + 2 | 0] = 1;
           }
           if (w[b + 3 | 0] != 18 | w[b + 5 | 0] != 17) {
            break z;
           }
           if (g >>> 0 > 19468801) {
            break x;
           }
           if (!Nb(v[f >> 2] + 1074312 | 0, 22) | w[v[f >> 2] + 480208 | 0] & 4) {
            break z;
           }
           d = b + 5 | 0;
           break A;
          }
          if ((k | 0) != 4) {
           break z;
          }
          d = !w[f + 6 | 0];
          J: {
           if ((d | g >>> 0 < 18285314) & g >>> 0 <= 18874367) {
            break J;
           }
           if (g >>> 0 > 19137025) {
            break x;
           }
           if (w[b + 3 | 0] != 23 | w[b + 5 | 0] < 65) {
            break J;
           }
           t[b + 3 | 0] = 0;
          }
          K: {
           L: {
            M: {
             if (!(!(d & g >>> 0 < 18874368) & g >>> 0 >= 18415616)) {
              e = w[b + 3 | 0];
              d = w[b + 2 | 0];
              if ((e | 0) != 10 | (d | 0) != 11) {
               break M;
              }
              e = 0;
              t[b + 3 | 0] = 0;
              break K;
             }
             if (g >>> 0 > 18874639) {
              break L;
             }
             e = w[b + 3 | 0];
             d = w[b + 2 | 0];
            }
            if ((d | 0) != 11 | (e | 0) != 4) {
             break K;
            }
            d = w[b + 4 | 0];
            if (!(d | w[f + 6 | 0])) {
             e = 4;
             break K;
            }
            e = 4;
            o = w[b + 5 | 0];
            if (!o) {
             break K;
            }
            t[b + 2 | 0] = 0;
            J = b, K = fw(o + (d << 4) | 0), t[J + 5 | 0] = K;
            break K;
           }
           if (g >>> 0 > 19007240) {
            break x;
           }
           e = w[b + 3 | 0];
          }
          if (w[b + 5 | 0] | (e | 0) != 16) {
           break z;
          }
          d = b + 3 | 0;
         }
         t[d | 0] = 0;
        }
        if (g >>> 0 > 18874367) {
         break x;
        }
       }
       e = w[b + 3 | 0];
       d = w[b + 5 | 0] & 240;
       N: {
        O: {
         if ((e | 0) != 28 | (d | 0) != 96) {
          o = 0;
         } else {
          if (!w[f + 6 | 0] | (k | 0) != 4) {
           break O;
          }
          o = g >>> 0 < 18350080;
         }
         if (!(o | (e | 0) == 20 & (d | 0) == 96)) {
          break N;
         }
        }
        e = B(z, -6) + b | 0;
        while (1) {
         if (b >>> 0 > e >>> 0) {
          if (!((w[e + 3 | 0] | 8) != 28 | (w[e + 5 | 0] & 240) != 96)) {
           t[e + 3 | 0] = 0;
          }
          e = e + 6 | 0;
          continue;
         }
         break;
        }
        e = w[b + 3 | 0];
       }
       if ((e | 0) != 20 | (d | 0) != 224) {
        break x;
       }
       e = B(z, -6) + b | 0;
       while (1) {
        if (b >>> 0 <= e >>> 0) {
         break x;
        }
        if (!(w[e + 3 | 0] != 20 | (w[e + 5 | 0] & 240) != 224)) {
         t[e + 3 | 0] = 0;
        }
        e = e + 6 | 0;
        continue;
       }
      }
      d = w[b + 2 | 0];
      if (!((d | 0) != 8 | g >>> 0 > 19333174 | (g | 0) == 19333120)) {
       e = w[b + 4 | 0];
       d = w[b + 3 | 0];
       if (!(!e | (d | 0) != 7)) {
        t[b + 3 | 0] = 11;
        break w;
       }
       P: {
        Q: {
         switch (d - 5 | 0) {
         default:
          if ((d | 0) != 26) {
           break w;
          }
          break;

         case 1:
          break w;

         case 2:
          break P;

         case 0:
          break Q;
         }
        }
        g = w[b + 5 | 0];
        if (!(g & 15)) {
         t[b + 2 | 0] = 0;
         t[b + 3 | 0] = 5;
         t[b + 5 | 0] = g | e & 15;
         break w;
        }
        R: {
         switch (d - 5 | 0) {
         case 1:
          break w;

         case 0:
         case 2:
          break P;

         default:
          break R;
         }
        }
        if ((d | 0) != 26) {
         break w;
        }
       }
       t[b + 2 | 0] = 0;
       break w;
      }
      S: {
       if (!((k | 0) == 16777216 | (d | 0) != 15)) {
        e = w[b + 3 | 0];
        if (e) {
         break S;
        }
        t[b + 2 | 0] = 0;
        t[b + 3 | 0] = 10;
        t[b + 5 | 0] = w[b + 4 | 0] << 3;
        break w;
       }
       if ((d | 0) != 15) {
        break w;
       }
       e = w[b + 3 | 0];
      }
      if ((e & 255) != 10 | g >>> 0 > 19922963) {
       break w;
      }
      if (w[b + 4 | 0] ? w[b + 5 | 0] : 1) {
       t[b + 2 | 0] = 0;
       break w;
      }
      t[b + 3 | 0] = 0;
     }
     b = v[sg(m + 12 | 0) >> 2];
     continue;
    }
    break;
   }
   b = v[f + 4 >> 2];
   v[f + 8 >> 2] = v[f >> 2];
   v[f + 12 >> 2] = b;
   eb = m + 16 | 0;
   d = v[Sl(f + 28 | 0) >> 2];
   continue;
  } else {
   eb = f + 32 | 0;
  }
  break;
 }
 T: {
  c = y[a + 1074308 >> 2] < 19267584;
  if (c & n) {
   b = 0;
   while (1) {
    if ((b | 0) == 344) {
     break T;
    }
    c = v[a + 1074308 >> 2];
    d = v[b + 40212 >> 2];
    Kb(i, v[b + 40208 >> 2], c >>> 0 >= d >>> 0 | (c | 0) == (d & -65536));
    b = b + 8 | 0;
    continue;
   }
  }
  if (!(c & ((E | 0) == 4 & D))) {
   break T;
  }
  b = 0;
  while (1) {
   if ((b | 0) == 240) {
    break T;
   }
   Kb(i, v[b + 40560 >> 2], y[a + 1074308 >> 2] >= y[b + 40564 >> 2]);
   b = b + 8 | 0;
   continue;
  }
 }
 U: {
  c = v[a + 480180 >> 2];
  if (c & 16777248) {
   b = 0;
   while (1) {
    if ((b | 0) == 72) {
     break U;
    }
    c = v[a + 1074308 >> 2];
    d = v[b + 40804 >> 2];
    e = d & -65536;
    if (!(c >>> 0 >= e >>> 0 & (c >>> 0 <= e >>> 0 | c >>> 0 >= d >>> 0))) {
     ag(i, v[b + 40800 >> 2]);
    }
    b = b + 8 | 0;
    continue;
   }
  }
  b = 0;
  V: {
   switch (c - 2 | 0) {
   case 2:
    while (1) {
     if ((b | 0) == 64) {
      break U;
     }
     if (y[a + 1074308 >> 2] < y[b + 40884 >> 2]) {
      ag(i, v[b + 40880 >> 2]);
     }
     b = b + 8 | 0;
     continue;
    }
    ;

   case 0:
    break V;

   default:
    break U;
   }
  }
  while (1) {
   if ((b | 0) == 96) {
    break U;
   }
   if (y[a + 1074308 >> 2] < y[b + 40948 >> 2]) {
    ag(i, v[b + 40944 >> 2]);
   }
   b = b + 8 | 0;
   continue;
  }
 }
 b = v[a + 1074308 >> 2];
 if (!(v[a + 480180 >> 2] != 4 | b >>> 0 > 18415615)) {
  Kb(i, 98, 1);
  b = v[a + 1074308 >> 2];
 }
 if (b - 19333159 >>> 0 <= 33) {
  b = 0;
  while (1) {
   if ((b | 0) != 5) {
    c = b + 77 | 0;
    Ib(h + 12 | 0, i, c);
    ag(Kb(i, b + 86 | 0, Fb(v[v[h + 12 >> 2] >> 2], v[h + 16 >> 2])), c);
    b = b + 1 | 0;
    continue;
   }
   break;
  }
  b = v[a + 1074308 >> 2];
 }
 c = 8;
 W: {
  if (b >>> 0 >= 18284544) {
   if (b >>> 0 > 18874627) {
    break W;
   }
   c = 6;
   if ((b | 0) == 18874368) {
    break W;
   }
  }
  Kb(i, c, 1);
 }
 c = v[a + 1074308 >> 2];
 X: {
  if (w[a + 480208 | 0] & 16) {
   if (c >>> 0 <= 19136511) {
    ag(i, 7);
    break X;
   }
   if (!(v[a + 480180 >> 2] & 16777248) | c >>> 0 > 19267583) {
    break X;
   }
   Kb(i, 7, 1);
   break X;
  }
  if ((c | 0) == 19922944 | c >>> 0 > 19922997) {
   break X;
  }
  ag(i, 7);
 }
 Ib(h + 12 | 0, i, 31);
 Y: {
  if (!Fb(v[v[h + 12 >> 2] >> 2], v[h + 16 >> 2])) {
   break Y;
  }
  c = v[a + 1074308 >> 2];
  if (c >>> 0 < 19071234 | c >>> 0 > 19398722) {
   break Y;
  }
  d = a + 900380 | 0;
  e = x[a + 480192 >> 1];
  b = 1;
  while (1) {
   c = b & 65535;
   if (c >>> 0 > e >>> 0) {
    break Y;
   }
   Z: {
    c = v[d + (c << 2) >> 2];
    if (!c) {
     break Z;
    }
    f = w[c + 65 | 0];
    if (!(w[c + 60 | 0] & 4) | (f | 0) == 255 | f >>> 0 <= w[c + 64 | 0]) {
     break Z;
    }
    Kb(i, 97, 1);
    break Y;
   }
   b = b + 1 | 0;
   continue;
  }
 }
 c = v[a + 480180 >> 2];
 _: {
  if (!(c & 16777218)) {
   break _;
  }
  d = a + 484380 | 0;
  e = x[a + 480190 >> 1];
  b = 1;
  while (1) {
   f = b & 65535;
   if (f >>> 0 > e >>> 0) {
    break _;
   }
   b = b + 1 | 0;
   if (!(w[(d + B(f, 104) | 0) + 35 | 0] & 2)) {
    continue;
   }
   break;
  }
  $: {
   aa: {
    ba: {
     if (!(!x[a + 480192 >> 1] | (c | 0) != 16777216)) {
      b = v[a + 1074308 >> 2];
      if (b >>> 0 < 19398688) {
       break aa;
      }
      if (b >>> 0 > 19464277) {
       break ba;
      }
      Kb(i, 109, 1);
     }
     b = v[a + 1074308 >> 2];
    }
    if ((b | 0) == 19922944 | b >>> 0 > 19922996) {
     break $;
    }
   }
   ag(i, 111);
   b = v[a + 1074308 >> 2];
  }
  c = v[a + 480180 >> 2];
  if (!((c | 0) != 2 | b >>> 0 > 19464191)) {
   Kb(i, 108, 1);
   break _;
  }
  if ((c | 0) == 2) {
   break _;
  }
  ag(i, 108);
 }
 ca: {
  c = v[a + 1074308 >> 2];
  if (c - 19333186 >>> 0 <= 589827) {
   if (!s) {
    break ca;
   }
   b = a + 906300 | 0;
   c = tk(b);
   while (1) {
    if ((b | 0) != (c | 0)) {
     da: {
      if ((w[b + 16 | 0] | w[b + 17 | 0] << 8 | (w[b + 18 | 0] << 16 | w[b + 19 | 0] << 24)) != 1146637647 | (w[b + 20 | 0] | w[b + 21 | 0] << 8 | (w[b + 22 | 0] << 16 | w[b + 23 | 0] << 24)) != -271958638) {
       break da;
      }
      if ((Sc(v[b + 4 >> 2], v[b + 8 >> 2]) | 0) != 32) {
       break da;
      }
      d = Cc(h + 12 | 0, 16851);
      rw(b + 80 | 0, d);
      sb(d);
     }
     b = b + 160 | 0;
     continue;
    }
    break;
   }
   c = v[a + 1074308 >> 2];
  }
  e = !s;
  ea: {
   if (e | c >>> 0 > 19923027) {
    break ea;
   }
   f = a + 900380 | 0;
   g = x[a + 480192 >> 1];
   b = 1;
   while (1) {
    d = b & 65535;
    if (d >>> 0 > g >>> 0) {
     break ea;
    }
    d = v[f + (d << 2) >> 2];
    if (!d | w[d + 30 | 0] != 1 & x[d + 28 >> 1] != 1) {
     b = b + 1 | 0;
     continue;
    } else {
     Kb(i, 121, 1);
     c = v[a + 1074308 >> 2];
    }
    break;
   }
  }
  b = !s;
  if (!(e | c >>> 0 > 19988488)) {
   Kb(i, 117, 1);
   c = v[a + 1074308 >> 2];
  }
  if (c - 19333120 >>> 0 > 591359 | b) {
   break ca;
  }
  b = a + 906300 | 0;
  d = tk(b);
  while (1) {
   if ((b | 0) == (d | 0)) {
    break ca;
   }
   fa: {
    if ((w[b + 16 | 0] | w[b + 17 | 0] << 8 | (w[b + 18 | 0] << 16 | w[b + 19 | 0] << 24)) != 1146637647 | (w[b + 20 | 0] | w[b + 21 | 0] << 8 | (w[b + 22 | 0] << 16 | w[b + 23 | 0] << 24)) != -281111764) {
     break fa;
    }
    a = v[b + 4 >> 2];
    if ((Sc(a, v[b + 8 >> 2]) | 0) != 24) {
     break fa;
    }
    H = Od(C(C(C((l(2, w[a + 12 | 0] | w[a + 13 | 0] << 8 | (w[a + 14 | 0] << 16 | w[a + 15 | 0] << 24)), 
    r()) * C(2e3)) + C(-1)) / C(1999)), C(0));
    I = Od(C(C(C((l(2, w[a + 16 | 0] | w[a + 17 | 0] << 8 | (w[a + 18 | 0] << 16 | w[a + 19 | 0] << 24)), 
    r()) * C(2e3)) + C(-1)) / C(1999)), C(0));
    c = (q(H), j(2));
    t[a + 12 | 0] = c;
    t[a + 13 | 0] = c >>> 8;
    t[a + 14 | 0] = c >>> 16;
    t[a + 15 | 0] = c >>> 24;
    a = v[b + 4 >> 2];
    c = (q(I), j(2));
    t[a + 16 | 0] = c;
    t[a + 17 | 0] = c >>> 8;
    t[a + 18 | 0] = c >>> 16;
    t[a + 19 | 0] = c >>> 24;
   }
   b = b + 160 | 0;
   continue;
  }
 }
 eb = h + 32 | 0;
}

function upa(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, q = 0, r = 0, s = 0, y = 0, z = 0, A = 0, C = 0, D = 0, E = 0, F = 0, G = 0;
 d = eb - 1328 | 0;
 eb = d;
 xc(b);
 e = eb - 16 | 0;
 eb = e;
 i = d + 220 | 0;
 vX(e + 8 | 0, i);
 h = v[e + 12 >> 2];
 ic(e, v[b >> 2], v[b + 8 >> 2], v[e + 8 >> 2], v[e + 12 >> 2]);
 f = v[e + 4 >> 2];
 if ((f | 0) == (h | 0)) {
  Ub(b, v[e + 12 >> 2]);
 }
 eb = e + 16 | 0;
 a: {
  if ((f | 0) != (h | 0)) {
   break a;
  }
  if (!xX(i)) {
   break a;
  }
  if (!Lb(v[b >> 2], v[b + 8 >> 2], Ac(wX(w[d + 1324 | 0] | w[d + 1325 | 0] << 8 | (w[d + 1326 | 0] << 16 | w[d + 1327 | 0] << 24)), gb))) {
   break a;
  }
  n = 1;
  if ((c | 0) == 64) {
   break a;
  }
  xc(b);
  b = Ge(d + 220 | 0, b);
  v[31601] = 0;
  e = d + 208 | 0;
  N(641, e | 0, b | 0);
  h = v[31601];
  v[31601] = 0;
  b: {
   c: {
    d: {
     e: {
      f: {
       g: {
        h: {
         i: {
          if ((h | 0) != 1) {
           tb(b);
           v[31601] = 0;
           R(642, d + 196 | 0, e | 0, 1196314451);
           b = v[31601];
           v[31601] = 0;
           if ((b | 0) == 1) {
            break i;
           }
           n = 0;
           v[31601] = 0;
           R(642, d + 184 | 0, e | 0, 1280331091);
           b = v[31601];
           v[31601] = 0;
           if ((b | 0) == 1) {
            break h;
           }
           if (lc(v[d + 196 >> 2], v[d + 200 >> 2])) {
            break b;
           }
           if (!lc(v[d + 184 >> 2], v[d + 188 >> 2])) {
            break g;
           }
           break b;
          }
          c = M() | 0;
          tb(b);
          break d;
         }
         c = M() | 0;
         break e;
        }
        c = M() | 0;
        break f;
       }
       v[31601] = 0;
       N(246, a | 0, 1);
       b = v[31601];
       v[31601] = 0;
       j: {
        if ((b | 0) != 1) {
         dg(a);
         v[a + 480188 >> 2] = 4;
         v[a + 480208 >> 2] = 25231360;
         F = d, G = vb(v[d + 184 >> 2]), v[F + 52 >> 2] = G;
         i = c & 2;
         o = a + 946304 | 0;
         q = a + 484380 | 0;
         f = vb(v[d + 188 >> 2]);
         k: {
          l: {
           while (1) {
            e = v[d + 52 >> 2];
            if (!Hb(e, f)) {
             break l;
            }
            b = x[a + 480190 >> 1];
            if (!ni(b)) {
             break l;
            }
            b = b + 1 | 0;
            u[a + 480190 >> 1] = b;
            v[31601] = 0;
            b = B(b & 65535, 104) + q | 0;
            N(279, b | 0, 1);
            h = v[31601];
            v[31601] = 0;
            m: {
             n: {
              if ((h | 0) != 1) {
               v[31601] = 0;
               h = d + 220 | 0;
               k = O(643, e | 0, h | 0) | 0;
               l = v[31601];
               v[31601] = 0;
               if ((l | 0) == 1) {
                break n;
               }
               if (!k) {
                break c;
               }
               if (Fv(h)) {
                break m;
               }
               break c;
              }
              c = M() | 0;
              break j;
             }
             c = M() | 0;
             break j;
            }
            v[31601] = 0;
            h = O(36, d + 172 | 0, d + 220 | 0) | 0;
            k = v[31601];
            v[31601] = 0;
            if ((k | 0) == 1) {
             break k;
            }
            zc((x[a + 480190 >> 1] << 5) + o | 0, h);
            sb(h);
            h = w[d + 256 | 0] | w[d + 257 | 0] << 8 | (w[d + 258 | 0] << 16 | w[d + 259 | 0] << 24);
            v[b + 8 >> 2] = h;
            v[b >> 2] = h;
            v[b + 4 >> 2] = w[d + 252 | 0] | w[d + 253 | 0] << 8 | (w[d + 254 | 0] << 16 | w[d + 255 | 0] << 24);
            u[b + 34 >> 1] = x[b + 34 >> 1] | 2;
            u[b + 30 >> 1] = 255;
            o: {
             if (i) {
              h = Yc(d + 24 | 0, 8, 1, 0, 0);
              v[31601] = 0;
              T(215, h | 0, b | 0, e | 0) | 0;
              b = v[31601];
              v[31601] = 0;
              if ((b | 0) == 1) {
               break o;
              }
             }
             Pf(d + 52 | 0);
             continue;
            }
            break;
           }
           c = M() | 0;
           break j;
          }
          F = d, G = vb(v[d + 196 >> 2]), v[F + 168 >> 2] = G;
          r = a + 484344 | 0;
          s = c & 1;
          y = a + 484360 | 0;
          C = d + 252 | 0;
          D = vb(v[d + 200 >> 2]);
          c = 1;
          n = 1;
          while (1) {
           p: {
            q: {
             r: {
              s: {
               t: {
                u: {
                 v: {
                  b = v[d + 168 >> 2];
                  if (!Hb(b, D)) {
                   break v;
                  }
                  if (!(c & 1)) {
                   v[31601] = 0;
                   c = Q(274, y | 0) | 0;
                   e = v[31601];
                   v[31601] = 0;
                   if ((e | 0) == 1) {
                    break u;
                   }
                   if (!c) {
                    break v;
                   }
                  }
                  Mc(Wb(v[a + 484360 >> 2], w[a + 484376 | 0]));
                  v[31601] = 0;
                  e = d + 220 | 0;
                  c = O(644, b | 0, e | 0) | 0;
                  h = v[31601];
                  v[31601] = 0;
                  if ((h | 0) == 1) {
                   break t;
                  }
                  if (!(!(w[d + 1306 | 0] | w[d + 1307 | 0] << 8) & c) | (w[d + 1308 | 0] | w[d + 1309 | 0] << 8 | (w[d + 1310 | 0] << 16 | w[d + 1311 | 0] << 24)) - 5 >>> 0 < 4294967292) {
                   break c;
                  }
                  h = w[a + 484376 | 0];
                  i = v[a + 484360 >> 2];
                  v[31601] = 0;
                  c = d + 156 | 0;
                  N(645, c | 0, e | 0);
                  e = v[31601];
                  v[31601] = 0;
                  if ((e | 0) == 1) {
                   break t;
                  }
                  pp(Wb(i, h), c);
                  sb(c);
                  w: {
                   if (s) {
                    v[31601] = 0;
                    R(185, d + 52 | 0, b | 0, w[d + 1316 | 0] | w[d + 1317 | 0] << 8 | (w[d + 1318 | 0] << 16 | w[d + 1319 | 0] << 24));
                    b = v[31601];
                    v[31601] = 0;
                    if ((b | 0) != 1) {
                     break w;
                    }
                    c = M() | 0;
                    break j;
                   }
                   v[31601] = 0;
                   b = Q(168, d + 116 | 0) | 0;
                   c = v[31601];
                   v[31601] = 0;
                   if ((c | 0) == 1) {
                    break s;
                   }
                   uG(d + 52 | 0, b);
                  }
                  b = d + 52 | 0;
                  k = gc(d + 136 | 0, b);
                  tb(b);
                  if (!s) {
                   tb(d + 116 | 0);
                  }
                  Qb(d + 52 | 0, 0, 64);
                  l = 1;
                  x: {
                   y: {
                    z: {
                     while (1) {
                      if ((l | 0) == 32) {
                       break z;
                      }
                      b = (B(l, 34) + C | 0) - 34 | 0;
                      Dn(d + 8 | 0, b);
                      A: {
                       B: {
                        if (Kj(w[v[d + 8 >> 2]])) {
                         break B;
                        }
                        c = w[b + 32 | 0];
                        if (c >>> 0 > 15) {
                         break y;
                        }
                        e = w[b + 33 | 0];
                        if (e >>> 0 > 64) {
                         break y;
                        }
                        if (!Fv(b)) {
                         break y;
                        }
                        h = e << 2;
                        i = c << 4;
                        c = 0;
                        b = 1;
                        while (1) {
                         f = b & 65535;
                         e = x[a + 480190 >> 1];
                         if (f >>> 0 <= e >>> 0) {
                          v[31601] = 0;
                          m = d + 24 | 0;
                          R(646, m | 0, v[d + 8 >> 2], v[d + 12 >> 2]);
                          e = v[31601];
                          v[31601] = 0;
                          if ((e | 0) == 1) {
                           break A;
                          }
                          e = eb - 32 | 0;
                          eb = e;
                          ee(e + 24 | 0, m);
                          sX(e + 16 | 0, (f << 5) + o | 0);
                          g = v[e + 20 >> 2];
                          v[e + 8 >> 2] = v[e + 16 >> 2];
                          v[e + 12 >> 2] = g;
                          g = Hc(v[e + 24 >> 2], v[e + 28 >> 2], e + 8 | 0);
                          eb = e + 32 | 0;
                          sb(m);
                          C: {
                           if (g ^ 1) {
                            break C;
                           }
                           F = $b(d + 52 | 0, l), G = b, u[F >> 1] = G;
                           e = B(f, 104) + q | 0;
                           f = x[e + 30 >> 1];
                           if ((f | 0) != 255) {
                            c = b;
                            if (w[e + 37 | 0] != (i & 255) | (f | 0) != (h | 0)) {
                             break C;
                            }
                           }
                           u[e + 30 >> 1] = h;
                           t[e + 37 | 0] = i;
                           break B;
                          }
                          b = b + 1 | 0;
                          continue;
                         }
                         break;
                        }
                        c = c & 65535;
                        if (!c) {
                         break B;
                        }
                        if (!ni(e)) {
                         break B;
                        }
                        b = e + 1 | 0;
                        u[a + 480190 >> 1] = b;
                        F = $b(d + 52 | 0, l), G = b, u[F >> 1] = G;
                        b = B(x[a + 480190 >> 1], 104) + q | 0;
                        mn(b);
                        e = B(c, 104) + q | 0;
                        b = Wo(b, e);
                        u[b + 30 >> 1] = h;
                        t[b + 37 | 0] = i;
                        mY(b, e);
                        c = (c << 5) + o | 0;
                        e = v[c + 4 >> 2];
                        b = (x[a + 480190 >> 1] << 5) + o | 0;
                        v[b >> 2] = v[c >> 2];
                        v[b + 4 >> 2] = e;
                        e = v[c + 28 >> 2];
                        v[b + 24 >> 2] = v[c + 24 >> 2];
                        v[b + 28 >> 2] = e;
                        e = v[c + 20 >> 2];
                        v[b + 16 >> 2] = v[c + 16 >> 2];
                        v[b + 20 >> 2] = e;
                        e = v[c + 12 >> 2];
                        v[b + 8 >> 2] = v[c + 8 >> 2];
                        v[b + 12 >> 2] = e;
                       }
                       l = l + 1 | 0;
                       continue;
                      }
                      break;
                     }
                     break r;
                    }
                    i = 0;
                    v[d + 48 >> 2] = 0;
                    v[d + 40 >> 2] = 0;
                    v[d + 44 >> 2] = 0;
                    v[d + 32 >> 2] = 0;
                    v[d + 36 >> 2] = 0;
                    v[d + 24 >> 2] = 0;
                    v[d + 28 >> 2] = 0;
                    e = 64;
                    h = 65535;
                    E = w[d + 1308 | 0] | w[d + 1309 | 0] << 8;
                    m = 0;
                    D: while (1) {
                     E: {
                      if (m) {
                       break E;
                      }
                      b = v[k >> 2];
                      v[31601] = 0;
                      b = T(150, b | 0, v[d + 144 >> 2], 1) | 0;
                      c = v[31601];
                      v[31601] = 0;
                      if ((c | 0) == 1) {
                       break x;
                      }
                      if (b) {
                       break E;
                      }
                      c = h;
                      b = e;
                      break q;
                     }
                     b = e + 1 | 0;
                     F: {
                      if (e >>> 0 < 63) {
                       e = b;
                       break F;
                      }
                      v[31601] = 0;
                      h = O(367, r | 0, 64) | 0;
                      c = v[31601];
                      v[31601] = 0;
                      if ((c | 0) == 1) {
                       break x;
                      }
                      c = 65535;
                      if ((h | 0) == 65535) {
                       break q;
                      }
                      b = w[a + 484376 | 0];
                      c = v[a + 484360 >> 2];
                      e = 0;
                      v[31601] = 0;
                      N(536, Wb(c, b) | 0, h | 0);
                      b = v[31601];
                      v[31601] = 0;
                      if ((b | 0) == 1) {
                       break x;
                      }
                     }
                     b = 0;
                     c = Vb(v[r >> 2], h & 65535);
                     c = ld(v[c >> 2], v[v[c + 48 >> 2] + 12 >> 2], e, 0);
                     while (1) {
                      if ((b | 0) == (E | 0)) {
                       continue D;
                      }
                      f = (d + 24 | 0) + B(b, 7) | 0;
                      g = w[f + 6 | 0];
                      G: {
                       if (g) {
                        t[f + 6 | 0] = g - 1;
                        g = w[f + 4 | 0] | w[f + 5 | 0] << 8;
                        t[c + 4 | 0] = g;
                        t[c + 5 | 0] = g >>> 8;
                        f = w[f | 0] | w[f + 1 | 0] << 8 | (w[f + 2 | 0] << 16 | w[f + 3 | 0] << 24);
                        t[c | 0] = f;
                        t[c + 1 | 0] = f >>> 8;
                        t[c + 2 | 0] = f >>> 16;
                        t[c + 3 | 0] = f >>> 24;
                        m = m - 1 | 0;
                        break G;
                       }
                       g = v[k >> 2];
                       v[31601] = 0;
                       g = T(150, g | 0, v[d + 144 >> 2], 1) | 0;
                       j = v[31601];
                       v[31601] = 0;
                       if ((j | 0) == 1) {
                        break r;
                       }
                       if (!g) {
                        break G;
                       }
                       if (v[d + 144 >> 2] == (w[d + 1312 | 0] | w[d + 1313 | 0] << 8 | (w[d + 1314 | 0] << 16 | w[d + 1315 | 0] << 24))) {
                        i = Wb(v[a + 484360 >> 2], w[a + 484376 | 0]);
                        $e(i, lE(v[i >> 2], v[i + 4 >> 2]));
                        i = e;
                       }
                       v[31601] = 0;
                       g = Q(197, k | 0) | 0;
                       j = v[31601];
                       v[31601] = 0;
                       H: {
                        if ((j | 0) != 1) {
                         g = g << 24 >> 24;
                         if ((g | 0) >= 0) {
                          break H;
                         }
                         g = g & 127;
                         t[f + 6 | 0] = g;
                         j = w[f + 4 | 0] | w[f + 5 | 0] << 8;
                         t[c + 4 | 0] = j;
                         t[c + 5 | 0] = j >>> 8;
                         f = w[f | 0] | w[f + 1 | 0] << 8 | (w[f + 2 | 0] << 16 | w[f + 3 | 0] << 24);
                         t[c | 0] = f;
                         t[c + 1 | 0] = f >>> 8;
                         t[c + 2 | 0] = f >>> 16;
                         t[c + 3 | 0] = f >>> 24;
                         m = g + m | 0;
                         break G;
                        }
                        break r;
                       }
                       if ((g - 1 & 255) >>> 0 <= 35) {
                        t[c | 0] = g + 48;
                       }
                       v[31601] = 0;
                       g = Q(197, k | 0) | 0;
                       j = v[31601];
                       v[31601] = 0;
                       I: {
                        J: {
                         if ((j | 0) != 1) {
                          g = g << 24 >> 24;
                          F = c, G = w[$b(d + 52 | 0, g & 31) | 0], t[F + 1 | 0] = G;
                          if ((g | 0) >= 0) {
                           break J;
                          }
                          t[c + 3 | 0] = w[f + 3 | 0];
                          t[c + 5 | 0] = w[f + 5 | 0];
                          break I;
                         }
                         break r;
                        }
                        v[31601] = 0;
                        j = d + 8 | 0;
                        N(198, j | 0, k | 0);
                        g = v[31601];
                        v[31601] = 0;
                        K: {
                         if ((g | 0) != 1) {
                          g = w[d + 8 | 0];
                          if (g >>> 0 > 19) {
                           break I;
                          }
                          z = g << 1;
                          A = w[z + 25296 | 0];
                          t[c + 3 | 0] = A;
                          j = w[Ic(j) | 0];
                          t[c + 5 | 0] = j;
                          if ((A | 0) != 16 | j >>> 0 < 32) {
                           break K;
                          }
                          t[c + 3 | 0] = 17;
                          break I;
                         }
                         break r;
                        }
                        if (819137 >>> g & 1) {
                         break I;
                        }
                        t[c + 5 | 0] = w[z + 25297 | 0] | j & 15;
                       }
                       g = w[c | 0] | w[c + 1 | 0] << 8 | (w[c + 2 | 0] << 16 | w[c + 3 | 0] << 24);
                       t[f | 0] = g;
                       t[f + 1 | 0] = g >>> 8;
                       t[f + 2 | 0] = g >>> 16;
                       t[f + 3 | 0] = g >>> 24;
                       g = w[c + 4 | 0] | w[c + 5 | 0] << 8;
                       t[f + 4 | 0] = g;
                       t[f + 5 | 0] = g >>> 8;
                      }
                      c = c + 6 | 0;
                      b = b + 1 | 0;
                      continue;
                     }
                    }
                   }
                   n = 0;
                   break p;
                  }
                  break r;
                 }
                 Vj(y, 0);
                 v[31601] = 0;
                 b = O(1, d + 220 | 0, 6467) | 0;
                 c = v[31601];
                 v[31601] = 0;
                 L: {
                  if ((c | 0) != 1) {
                   yb(a + 1298344 | 0, b);
                   sb(b);
                   v[31601] = 0;
                   b = O(1, d + 52 | 0, 6804) | 0;
                   c = v[31601];
                   v[31601] = 0;
                   if ((c | 0) == 1) {
                    break L;
                   }
                   yb(a + 1298356 | 0, b);
                   sb(b);
                   F = a, G = v[Ec(d + 24 | 0, 4) >> 2], v[F + 1298404 >> 2] = G;
                   n = 1;
                   break b;
                  }
                  c = M() | 0;
                  break j;
                 }
                 c = M() | 0;
                 break j;
                }
                c = M() | 0;
                break j;
               }
               c = M() | 0;
               break j;
              }
              c = M() | 0;
              break j;
             }
             c = M() | 0;
             tb(k);
             break j;
            }
            c = c & 65535;
            if (!((i | 0) != 0 | b >>> 0 < 63) | (c | 0) == 65535) {
             break p;
            }
            ze(Vb(v[r >> 2], c), Uh(We(Ne(d + 8 | 0, 14, i & 255), b)));
           }
           tb(k);
           if ((l | 0) != 32) {
            break b;
           }
           Pf(d + 168 | 0);
           c = 0;
           continue;
          }
         }
         c = M() | 0;
         break j;
        }
        c = M() | 0;
       }
       Qc(d + 184 | 0);
      }
      Qc(d + 196 | 0);
     }
     je(d + 208 | 0);
    }
    P(c | 0);
    p();
   }
   n = 0;
  }
  Qc(d + 184 | 0);
  Qc(d + 196 | 0);
  je(d + 208 | 0);
 }
 eb = d + 1328 | 0;
 return n | 0;
}

function Gta(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, q = 0;
 e = eb - 272 | 0;
 eb = e;
 xc(b);
 a: {
  b: {
   c: {
    d: {
     e: {
      f: {
       g: {
        h: {
         i: {
          j: {
           k: {
            l: {
             h = e + 206 | 0;
             m: {
              if (!B$(b, h)) {
               break m;
              }
              if (!C$(h)) {
               break m;
              }
              d = 1;
              if ((c | 0) == 64) {
               break m;
              }
              Cd(a, 131072);
              d = eb - 16 | 0;
              eb = d;
              h = e + 120 | 0;
              f = tc(d + 4 | 0, 3910);
              Uc(h, f);
              sb(f);
              eb = d + 16 | 0;
              v[31601] = 0;
              d = e + 160 | 0;
              R(209, d | 0, h | 0, e + 210 | 0);
              f = v[31601];
              v[31601] = 0;
              n: {
               o: {
                p: {
                 if ((f | 0) != 1) {
                  yb(a + 1298344 | 0, d);
                  sb(d);
                  Db(h);
                  f = tc(d, 11144);
                  yb(a + 1298356 | 0, f);
                  sb(f);
                  o = a, q = v[Ec(d, 4) >> 2], v[o + 1298404 >> 2] = q;
                  wE(h, 3, e + 219 | 0);
                  Bc(d, h);
                  yb(a + 1298308 | 0, d);
                  sb(d);
                  oi(h, 3, e + 249 | 0);
                  Er(d, 4, h);
                  yb(a + 1298320 | 0, d);
                  sb(d);
                  d = kp(d);
                  o = d, q = Kd(w[e + 269 | 0], 1, 31), v[o + 8 >> 2] = q;
                  o = d, q = Kd(w[e + 270 | 0], 1, 12), v[o + 4 >> 2] = q;
                  v[d >> 2] = w[e + 271 | 0] + 1900;
                  h = a + 1298412 | 0;
                  Mc(h);
                  mE(h, d);
                  m = e + 128 | 0;
                  h = Mb(e + 148 | 0);
                  q: {
                   r: {
                    s: {
                     while (1) {
                      d = v[b + 8 >> 2];
                      f = v[b >> 2];
                      v[31601] = 0;
                      d = T(150, f | 0, d | 0, 8) | 0;
                      f = v[31601];
                      v[31601] = 0;
                      t: {
                       u: {
                        v: {
                         w: {
                          x: {
                           if ((f | 0) != 1) {
                            if (!d) {
                             break q;
                            }
                            v[31601] = 0;
                            N(310, b | 0, e - -64 | 0);
                            d = v[31601];
                            v[31601] = 0;
                            if ((d | 0) == 1) {
                             break x;
                            }
                            d = v[e + 68 >> 2];
                            y: {
                             g = w[e + 210 | 0];
                             switch (g - 3 | 0) {
                             case 1:
                              break w;

                             case 0:
                              break y;

                             default:
                              break v;
                             }
                            }
                            f = 2;
                            if (v[e + 64 >> 2] != 1431389523) {
                             break u;
                            }
                            break t;
                           }
                           b = M() | 0;
                           break b;
                          }
                          b = M() | 0;
                          break b;
                         }
                         f = 4;
                         if (v[e + 64 >> 2] != 1431389523) {
                          break u;
                         }
                         break t;
                        }
                        f = 0;
                        if (g >>> 0 > 7) {
                         break t;
                        }
                       }
                       d = v[e + 64 >> 2] == 1146113363 ? -1 : d;
                       f = 0;
                      }
                      g = v[e + 68 >> 2];
                      v[e + 120 >> 2] = v[e + 64 >> 2];
                      v[e + 124 >> 2] = g;
                      v[31601] = 0;
                      g = e + 100 | 0;
                      R(185, g | 0, b | 0, d | 0);
                      d = v[31601];
                      v[31601] = 0;
                      if ((d | 0) == 1) {
                       break s;
                      }
                      gc(m, g);
                      v[31601] = 0;
                      d = e + 120 | 0;
                      N(311, h | 0, d | 0);
                      i = v[31601];
                      v[31601] = 0;
                      if ((i | 0) == 1) {
                       break r;
                      }
                      Gd(d);
                      tb(g);
                      v[31601] = 0;
                      O(183, b | 0, f | 0) | 0;
                      d = v[31601];
                      v[31601] = 0;
                      if ((d | 0) != 1) {
                       continue;
                      }
                      break;
                     }
                     b = M() | 0;
                     break b;
                    }
                    b = M() | 0;
                    break b;
                   }
                   b = M() | 0;
                   Gd(e + 120 | 0);
                   tb(e + 100 | 0);
                   break b;
                  }
                  v[31601] = 0;
                  m = Q(168, e + 120 | 0) | 0;
                  b = v[31601];
                  v[31601] = 0;
                  z: {
                   A: {
                    B: {
                     if ((b | 0) != 1) {
                      v[31601] = 0;
                      d = e + 100 | 0;
                      R(312, d | 0, h | 0, 1431389523);
                      b = v[31601];
                      v[31601] = 0;
                      if ((b | 0) == 1) {
                       break B;
                      }
                      b = jd(m, d);
                      tb(d);
                      u[e + 98 >> 1] = 0;
                      u[e + 96 >> 1] = 65534;
                      if (w[e + 210 | 0] < 3) {
                       break z;
                      }
                      v[31601] = 0;
                      d = Q(189, b | 0) | 0;
                      f = v[31601];
                      v[31601] = 0;
                      if ((f | 0) != 1) {
                       break A;
                      }
                      break d;
                     }
                     b = M() | 0;
                     break b;
                    }
                    b = M() | 0;
                    break c;
                   }
                   u[e + 98 >> 1] = d;
                   if (w[e + 210 | 0] < 4) {
                    break z;
                   }
                   v[31601] = 0;
                   d = Q(189, b | 0) | 0;
                   f = v[31601];
                   v[31601] = 0;
                   if ((f | 0) == 1) {
                    break d;
                   }
                   u[e + 96 >> 1] = w[e + 210 | 0] == 4 ? d ? d : -2 : d;
                  }
                  d = w[a + 484376 | 0];
                  f = v[a + 484360 >> 2];
                  v[31601] = 0;
                  g = Q(202, b | 0) | 0;
                  i = v[31601];
                  v[31601] = 0;
                  if ((i | 0) == 1) {
                   break d;
                  }
                  v[31601] = 0;
                  R(238, Wb(f, d) | 0, b | 0, g >>> 1 | 0);
                  d = v[31601];
                  v[31601] = 0;
                  if ((d | 0) == 1) {
                   break d;
                  }
                  d = Wb(v[a + 484360 >> 2], w[a + 484376 | 0]);
                  d = lE(v[d >> 2], v[d + 4 >> 2]);
                  Gf(e + 98 | 0, d);
                  Gf(e + 96 | 0, d);
                  v[31601] = 0;
                  d = e + 100 | 0;
                  R(312, d | 0, h | 0, 1414807888);
                  f = v[31601];
                  v[31601] = 0;
                  if ((f | 0) == 1) {
                   break e;
                  }
                  b = jd(b, d);
                  tb(d);
                  d = v[b >> 2];
                  v[31601] = 0;
                  d = Q(172, d | 0) | 0;
                  f = v[31601];
                  v[31601] = 0;
                  if ((f | 0) == 1) {
                   break d;
                  }
                  if (!(c & 1) | d ^ 1) {
                   break n;
                  }
                  v[31601] = 0;
                  N(313, b | 0, e + 8 | 0);
                  d = v[31601];
                  v[31601] = 0;
                  if ((d | 0) == 1) {
                   break f;
                  }
                  o = a, q = Kd(w[e + 10 | 0], 1, 32) + 1 | 0, u[o + 480188 >> 1] = q;
                  v[31601] = 0;
                  d = O(214, e + 84 | 0, x[e + 8 >> 1]) | 0;
                  f = v[31601];
                  v[31601] = 0;
                  if ((f | 0) == 1) {
                   break g;
                  }
                  o = e, q = vb(v[d >> 2]), v[o + 44 >> 2] = q;
                  i = vb(v[d + 4 >> 2]);
                  C: {
                   D: {
                    E: {
                     while (1) {
                      k = v[e + 44 >> 2];
                      if (!Hb(k, i)) {
                       f = x[a + 480188 >> 1];
                       v[31601] = 0;
                       f = O(314, e + 100 | 0, f | 0) | 0;
                       g = v[31601];
                       v[31601] = 0;
                       if ((g | 0) != 1) {
                        break C;
                       }
                       b = M() | 0;
                       break o;
                      }
                      v[31601] = 0;
                      f = w[e + 210 | 0] < 3 ? 9 : 8;
                      O(183, b | 0, f - 4 | 0) | 0;
                      g = v[31601];
                      v[31601] = 0;
                      if ((g | 0) != 1) {
                       v[31601] = 0;
                       l = Q(151, b | 0) | 0;
                       g = v[31601];
                       v[31601] = 0;
                       if ((g | 0) == 1) {
                        break E;
                       }
                       Hh(b, f);
                       v[31601] = 0;
                       g = e - -64 | 0;
                       R(185, g | 0, b | 0, f + l | 0);
                       f = v[31601];
                       v[31601] = 0;
                       if ((f | 0) == 1) {
                        break D;
                       }
                       f = gc(e + 100 | 0, g);
                       jd(k, f);
                       tb(f);
                       tb(g);
                       Pf(e + 44 | 0);
                       continue;
                      }
                      break;
                     }
                     b = M() | 0;
                     break o;
                    }
                    b = M() | 0;
                    break o;
                   }
                   b = M() | 0;
                   break o;
                  }
                  g = Wb(v[a + 484360 >> 2], w[a + 484376 | 0]);
                  g = am(v[g >> 2], v[g + 4 >> 2]);
                  v[31601] = 0;
                  l = a + 484344 | 0;
                  N(223, l | 0, g | 0);
                  g = v[31601];
                  v[31601] = 0;
                  if ((g | 0) != 1) {
                   g = Wb(v[a + 484360 >> 2], w[a + 484376 | 0]);
                   o = e, q = vb(v[g >> 2]), v[o + 64 >> 2] = q;
                   i = vb(v[g + 4 >> 2]);
                   while (1) {
                    g = v[e + 64 >> 2];
                    if (!Hb(g, i)) {
                     g = Wb(v[a + 484360 >> 2], w[a + 484376 | 0]);
                     i = x[e + 96 >> 1];
                     F: {
                      if (!Vi(g, i)) {
                       break F;
                      }
                      k = v[g >> 2];
                      j = x[e + 98 >> 1];
                      if (!j) {
                       if (lE(k, v[g + 4 >> 2]) >>> 0 <= i >>> 0) {
                        break F;
                       }
                      }
                      g = Vb(v[l >> 2], x[$b(k, i) >> 1]);
                      ze(g, zn(We(Ne(e - -64 | 0, 12, j & 255), v[g + 12 >> 2] - 1 | 0)));
                     }
                     Jk(f);
                     Qc(d);
                     break n;
                    }
                    k = v[d >> 2];
                    n = Rf(k, v[d + 4 >> 2]);
                    j = x[g >> 1];
                    if (n >>> 0 > j >>> 0) {
                     v[31601] = 0;
                     k = aa(315, bh(k, j) | 0, w[e + 210 | 0], f | 0, a | 0) | 0;
                     j = v[31601];
                     v[31601] = 0;
                     if ((j | 0) == 1) {
                      break p;
                     }
                     u[g >> 1] = k;
                    }
                    fe(e - -64 | 0);
                    continue;
                   }
                  }
                  break p;
                 }
                 b = M() | 0;
                 Db(e + 120 | 0);
                 break a;
                }
                b = M() | 0;
                Jk(f);
               }
               Qc(d);
               break c;
              }
              v[31601] = 0;
              d = e - -64 | 0;
              R(312, d | 0, h | 0, 1196641603);
              f = v[31601];
              v[31601] = 0;
              if ((f | 0) == 1) {
               break k;
              }
              b = jd(b, d);
              tb(d);
              d = v[b >> 2];
              v[31601] = 0;
              d = Q(172, d | 0) | 0;
              f = v[31601];
              v[31601] = 0;
              if ((f | 0) == 1) {
               break d;
              }
              if (d) {
               v[31601] = 0;
               O(183, b | 0, 1) | 0;
               d = v[31601];
               v[31601] = 0;
               if ((d | 0) == 1) {
                break d;
               }
               v[31601] = 0;
               d = Q(202, b | 0) | 0;
               f = v[31601];
               v[31601] = 0;
               if ((f | 0) == 1) {
                break d;
               }
               v[31601] = 0;
               $(316, a + 1298332 | 0, b | 0, d | 0, 40, 0);
               d = v[31601];
               v[31601] = 0;
               if ((d | 0) == 1) {
                break d;
               }
              }
              v[31601] = 0;
              R(312, e - -64 | 0, h | 0, 1146113363);
              d = v[31601];
              v[31601] = 0;
              if ((d | 0) == 1) {
               break h;
              }
              v[31601] = 0;
              d = e + 44 | 0;
              R(312, d | 0, h | 0, 1229999443);
              f = v[31601];
              v[31601] = 0;
              if ((f | 0) == 1) {
               break l;
              }
              b = jd(b, d);
              tb(d);
              v[31601] = 0;
              d = Q(197, b | 0) | 0;
              f = v[31601];
              v[31601] = 0;
              if ((f | 0) == 1) {
               break j;
              }
              u[a + 480190 >> 1] = d;
              i = a + 484380 | 0;
              k = a + 946304 | 0;
              l = !(c & 2);
              f = 1;
              G: {
               while (1) {
                H: {
                 c = f & 65535;
                 if (c >>> 0 > (d & 65535) >>> 0) {
                  break G;
                 }
                 d = 30;
                 I: {
                  J: {
                   K: {
                    if (w[e + 210 | 0] >= 2) {
                     v[31601] = 0;
                     d = Q(197, b | 0) | 0;
                     g = v[31601];
                     v[31601] = 0;
                     if ((g | 0) == 1) {
                      break K;
                     }
                    }
                    v[31601] = 0;
                    R(317, b | 0, k + (c << 5) | 0, d | 0);
                    d = v[31601];
                    v[31601] = 0;
                    if ((d | 0) == 1) {
                     break K;
                    }
                    v[31601] = 0;
                    d = e + 28 | 0;
                    N(318, b | 0, d | 0);
                    g = v[31601];
                    v[31601] = 0;
                    if ((g | 0) == 1) {
                     break J;
                    }
                    v[31601] = 0;
                    g = i + B(c, 104) | 0;
                    N(319, d | 0, g | 0);
                    c = v[31601];
                    v[31601] = 0;
                    if ((c | 0) == 1) {
                     break J;
                    }
                    d = w[e + 210 | 0];
                    if (d >>> 0 >= 8) {
                     v[31601] = 0;
                     N(320, b | 0, g + 43 | 0);
                     c = v[31601];
                     v[31601] = 0;
                     if ((c | 0) == 1) {
                      break J;
                     }
                     d = w[e + 210 | 0];
                    }
                    v[31601] = 0;
                    O(183, b | 0, ((d & 255) >>> 0 > 1 ? 6 : 2) | 0) | 0;
                    c = v[31601];
                    v[31601] = 0;
                    if ((c | 0) == 1) {
                     break J;
                    }
                    v[31601] = 0;
                    c = e - -64 | 0;
                    d = Q(151, c | 0) | 0;
                    j = v[31601];
                    v[31601] = 0;
                    if ((j | 0) != 1) {
                     v[31601] = 0;
                     R(185, e + 8 | 0, c | 0, d | 0);
                     c = v[31601];
                     v[31601] = 0;
                     if ((c | 0) != 1) {
                      break I;
                     }
                    }
                    b = M() | 0;
                    break i;
                   }
                   b = M() | 0;
                   break i;
                  }
                  b = M() | 0;
                  break i;
                 }
                 d = e + 8 | 0;
                 c = gc(e + 44 | 0, d);
                 tb(d);
                 j = v[c >> 2];
                 v[31601] = 0;
                 j = Q(172, j | 0) | 0;
                 n = v[31601];
                 v[31601] = 0;
                 if ((n | 0) != 1) {
                  L: {
                   if (l | j ^ 1) {
                    break L;
                   }
                   d = Yc(d, u[g + 34 >> 1] & 1 ? 16 : 8, 1, 0, (w[e + 43 | 0] & 12) == 4 ? 7 : 0);
                   v[31601] = 0;
                   T(215, d | 0, g | 0, c | 0) | 0;
                   d = v[31601];
                   v[31601] = 0;
                   if ((d | 0) != 1) {
                    break L;
                   }
                   break H;
                  }
                  tb(c);
                  f = f + 1 | 0;
                  d = x[a + 480190 >> 1];
                  continue;
                 }
                }
                break;
               }
               b = M() | 0;
               tb(c);
               break i;
              }
              dg(a);
              v[a + 480204 >> 2] = 12e5;
              v[a + 480208 >> 2] = 24;
              v[a + 480196 >> 2] = 6;
              v[a + 480200 >> 2] = 256;
              v[a + 480228 >> 2] = 48;
              v[a + 480232 >> 2] = 48;
              v[31601] = 0;
              d = 1;
              T(266, a + 1074312 | 0, 114, 1) | 0;
              a = v[31601];
              v[31601] = 0;
              if ((a | 0) == 1) {
               break j;
              }
              tb(e - -64 | 0);
              tb(b);
              je(h);
             }
             eb = e + 272 | 0;
             return d | 0;
            }
            b = M() | 0;
            break i;
           }
           b = M() | 0;
           break c;
          }
          b = M() | 0;
         }
         tb(e - -64 | 0);
         break c;
        }
        b = M() | 0;
        break c;
       }
       b = M() | 0;
       break c;
      }
      b = M() | 0;
      break c;
     }
     b = M() | 0;
     break c;
    }
    b = M() | 0;
   }
   tb(m);
  }
  je(h);
 }
 P(b | 0);
 p();
}

function b1(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, q = 0, r = 0, s = 0, y = 0, z = 0, A = 0, C = 0;
 e = eb - 208 | 0;
 eb = e;
 xc(b);
 d = e + 204 | 0;
 a: {
  if (!Pr(b, d)) {
   break a;
  }
  v[e + 184 >> 2] = 0;
  v[e + 188 >> 2] = 0;
  v[e + 176 >> 2] = 0;
  v[e + 180 >> 2] = 0;
  v[e + 168 >> 2] = 0;
  v[e + 172 >> 2] = 0;
  v[e + 160 >> 2] = 0;
  v[e + 164 >> 2] = 0;
  b: {
   c: {
    if (!dF(d)) {
     break c;
    }
    if (!Lb(v[b >> 2], v[b + 8 >> 2], 32)) {
     break c;
    }
    Gw(b, e + 160 | 0);
    break b;
   }
   q = 1;
   if (!cF(e + 204 | 0)) {
    break a;
   }
  }
  i = e + 155 | 0;
  f = bF(w[e + 207 | 0]);
  d = eb - 32 | 0;
  eb = d;
  v[d + 28 >> 2] = f;
  v[d + 8 >> 2] = 5;
  g = v[b >> 2];
  h = v[b + 8 >> 2];
  f = v[Gb(d + 28 | 0, d + 8 | 0) >> 2];
  if (!Lb(g, h, f)) {
   f = jf(b);
  }
  n = d + 8 | 0;
  Zj(n, i);
  o = Yb(d + 16 | 0, v[d + 8 >> 2], f);
  g = v[o >> 2];
  ic(d, v[b >> 2], v[b + 8 >> 2], g, v[o + 4 >> 2]);
  Zj(n, i);
  Qb(v[d + 8 >> 2] + f | 0, 0, 5 - f | 0);
  Ub(b, v[d + 28 >> 2]);
  eb = d + 32 | 0;
  if (!f) {
   break a;
  }
  if (!aF(i, w[e + 207 | 0])) {
   break a;
  }
  j = 1;
  if ((c | 0) == 64) {
   break a;
  }
  j = e + 207 | 0;
  Cd(a, 2048);
  dg(a);
  d: {
   e: {
    f: {
     g: {
      h: {
       i: {
        j: {
         k: {
          if (q) {
           d = eb - 16 | 0;
           eb = d;
           f = e + 4 | 0;
           i = tc(d + 4 | 0, 3893);
           Uc(f, i);
           sb(i);
           eb = d + 16 | 0;
           v[31601] = 0;
           d = e + 72 | 0;
           R(209, d | 0, f | 0, j | 0);
           j = v[31601];
           v[31601] = 0;
           if ((j | 0) == 1) {
            break j;
           }
           yb(a + 1298344 | 0, d);
           sb(d);
           Db(f);
           f = tc(d, 11144);
           yb(a + 1298356 | 0, f);
           break k;
          }
          f = e + 4 | 0;
          Ue(f, 2, e + 160 | 0);
          d = e + 72 | 0;
          Bc(d, f);
          yb(a + 1298308 | 0, d);
          sb(d);
          i = eb - 16 | 0;
          eb = i;
          n = tc(i + 4 | 0, 3944);
          Uc(f, n);
          sb(n);
          eb = i + 16 | 0;
          v[31601] = 0;
          R(209, d | 0, f | 0, j | 0);
          j = v[31601];
          v[31601] = 0;
          if ((j | 0) == 1) {
           break i;
          }
          yb(a + 1298344 | 0, d);
          sb(d);
          Db(f);
          f = tc(d, 11148);
          yb(a + 1298356 | 0, f);
         }
         sb(f);
         A = a, C = v[Ec(e + 72 | 0, 4) >> 2], v[A + 1298404 >> 2] = C;
         u[a + 480188 >> 1] = w[e + 159 | 0];
         u[a + 480190 >> 1] = w[e + 155 | 0];
         l: {
          f = w[e + 207 | 0];
          if (f >>> 0 > 8) {
           break l;
          }
          u[a + 480188 >> 1] = 4;
          j = a + 480280 | 0;
          d = 0;
          while (1) {
           if ((d | 0) == 4) {
            break l;
           }
           u[(j + (d << 5) | 0) + 4 >> 1] = d & 1 ? 192 : 64;
           d = d + 1 | 0;
           continue;
          }
         }
         m: {
          if (f >>> 0 >= 11) {
           j = (f | 0) == 11 ? 16 : 32;
           f = a + 480280 | 0;
           d = 0;
           while (1) {
            if ((d | 0) == (j | 0)) {
             break m;
            }
            i = Pw(b);
            n: {
             if ((i | 0) == 100) {
              v[f + (d << 5) >> 2] = 256;
              break n;
             }
             v[e + 72 >> 2] = (i << 1) + 128;
             v[e + 4 >> 2] = 0;
             v[e + 140 >> 2] = 256;
             A = f + (d << 5) | 0, C = v[Yj(e + 72 | 0, e + 4 | 0, e + 140 | 0) >> 2], u[A + 4 >> 1] = C;
            }
            d = d + 1 | 0;
            continue;
           }
          }
          if (f >>> 0 < 9) {
           break m;
          }
          Ub(b, 16);
          f = a + 480280 | 0;
          d = 0;
          while (1) {
           if ((d | 0) == 16) {
            break m;
           }
           u[(f + (d << 5) | 0) + 4 >> 1] = d & 1 ? 192 : 64;
           d = d + 1 | 0;
           continue;
          }
         }
         o: {
          if (w[e + 207 | 0] >= 13) {
           d = e + 72 | 0;
           Mw(d, b);
           f = Ic(d);
           d = w[e + 72 | 0];
           if (d >>> 0 <= 31) {
            t[e + 72 | 0] = 125;
            d = 125;
           }
           v[a + 480204 >> 2] = B(d, 1e4);
           v[a + 480196 >> 2] = w[f | 0];
           break o;
          }
          v[a + 480196 >> 2] = 6;
          v[a + 480204 >> 2] = 125e4;
         }
         ug(Wb(v[a + 484360 >> 2], w[a + 484376 | 0]), w[e + 156 | 0]);
         n = Mb(e + 140 | 0);
         d = v[b + 8 >> 2];
         f = w[e + 207 | 0] > 13;
         if (!f) {
          break h;
         }
         v[31601] = 0;
         N(210, n | 0, w[e + 156 | 0]);
         j = v[31601];
         v[31601] = 0;
         if ((j | 0) != 1) {
          break h;
         }
         d = M() | 0;
         break g;
        }
        d = M() | 0;
        Db(e + 4 | 0);
        break f;
       }
       d = M() | 0;
       Db(e + 4 | 0);
       break f;
      }
      y = d + (f << 1) | 0;
      d = 0;
      p: {
       q: {
        while (1) {
         if (w[e + 156 | 0] <= d >>> 0) {
          f = 0;
          if (w[e + 207 | 0] != 10) {
           break p;
          }
          o = v[b + 8 >> 2];
          d = 1;
          while (1) {
           f = x[a + 480190 >> 1] >= (d & 65535) >>> 0;
           if (!f) {
            break q;
           }
           v[31601] = 0;
           j = O(211, b | 0, e + 72 | 0) | 0;
           i = v[31601];
           v[31601] = 0;
           if ((i | 0) != 1) {
            if (j) {
             j = 0;
             r: {
              if (w[e + 155 | 0] < (w[e + 118 | 0] | w[e + 119 | 0] << 8 | (w[e + 120 | 0] << 16 | w[e + 121 | 0] << 24)) >>> 0 | w[e + 72 | 0] > 1) {
               break r;
              }
              i = w[e + 122 | 0] | w[e + 123 | 0] << 8 | (w[e + 124 | 0] << 16 | w[e + 125 | 0] << 24);
              if (i >>> 0 > 1048576 | w[e + 128 | 0] > 64 | i >>> 0 < (w[e + 129 | 0] | w[e + 130 | 0] << 8 | (w[e + 131 | 0] << 16 | w[e + 132 | 0] << 24)) >>> 0) {
               break r;
              }
              j = i >>> 0 >= (w[e + 133 | 0] | w[e + 134 | 0] << 8 | (w[e + 135 | 0] << 16 | w[e + 136 | 0] << 24)) >>> 0;
             }
             if (!j) {
              break q;
             }
            }
            d = d + 1 | 0;
            continue;
           }
           break;
          }
          d = M() | 0;
          break g;
         }
         A = $b(v[Wb(v[a + 484360 >> 2], w[a + 484376 | 0]) >> 2], d), C = d, u[A >> 1] = C;
         s: {
          if (w[e + 207 | 0] >= 14) {
           v[31601] = 0;
           f = Q(189, b | 0) | 0;
           j = v[31601];
           v[31601] = 0;
           if ((j | 0) == 1) {
            break s;
           }
           A = $b(v[n >> 2], d), C = f, u[A >> 1] = C;
          }
          f = x[a + 480188 >> 1];
          v[31601] = 0;
          O(183, b | 0, f << 1) | 0;
          f = v[31601];
          v[31601] = 0;
          if ((f | 0) == 1) {
           break s;
          }
          d = d + 1 | 0;
          continue;
         }
         break;
        }
        d = M() | 0;
        break g;
       }
       v[31601] = 0;
       O(149, b | 0, o | 0) | 0;
       d = v[31601];
       v[31601] = 0;
       if ((d | 0) != 1) {
        break p;
       }
       d = M() | 0;
       break g;
      }
      d = x[a + 480190 >> 1];
      v[31601] = 0;
      v[e + 72 >> 2] = 0;
      o = T(212, e + 60 | 0, d | 0, e + 72 | 0) | 0;
      d = v[31601];
      v[31601] = 0;
      t: {
       u: {
        v: {
         w: {
          if ((d | 0) != 1) {
           m = f ? 59 : 65;
           i = a + 946304 | 0;
           l = a + 484380 | 0;
           g = e + 73 | 0;
           j = 1;
           x: {
            while (1) {
             d = j & 65535;
             if (d >>> 0 > x[a + 480190 >> 1]) {
              i = Mb(e + 48 | 0);
              v[31601] = 0;
              j = T(213, b | 0, i | 0, w[e + 157 | 0] | w[e + 158 | 0] << 8) | 0;
              d = v[31601];
              v[31601] = 0;
              y: {
               if ((d | 0) != 1) {
                if (!j) {
                 break d;
                }
                d = 0;
                f = 0;
                g = v[i >> 2];
                if (!lc(g, v[i + 4 >> 2])) {
                 f = vb(g);
                 m = vb(v[i + 4 >> 2]);
                 g = eb - 16 | 0;
                 eb = g;
                 z: {
                  if (!Hb(f, m)) {
                   break z;
                  }
                  v[g + 12 >> 2] = f;
                  while (1) {
                   h = v[fe(g + 12 | 0) >> 2];
                   if (!Hb(h, m)) {
                    break z;
                   }
                   f = Wk(w[f | 0] | w[f + 1 | 0] << 8, w[h | 0] | w[h + 1 | 0] << 8) ? h : f;
                   continue;
                  }
                 }
                 eb = g + 16 | 0;
                 f = w[f | 0] | w[f + 1 | 0] << 8;
                }
                v[31601] = 0;
                h = O(214, e + 24 | 0, f | 0) | 0;
                g = v[31601];
                v[31601] = 0;
                if ((g | 0) == 1) {
                 break y;
                }
                A: {
                 while (1) {
                  if ((d | 0) == (f | 0)) {
                   if (!(c & 2)) {
                    break w;
                   }
                   k = Yc(e + 4 | 0, 8, 1, 0, q ? 2 : 1);
                   d = x[a + 480190 >> 1];
                   m = 1;
                   B: {
                    C: {
                     D: while (1) {
                      s = m & 65535;
                      if (s >>> 0 > (d & 65535) >>> 0) {
                       break w;
                      }
                      d = v[b + 8 >> 2];
                      g = v[b >> 2];
                      v[31601] = 0;
                      d = T(150, g | 0, d | 0, 1) | 0;
                      g = v[31601];
                      v[31601] = 0;
                      if ((g | 0) == 1) {
                       break B;
                      }
                      if (!d) {
                       break w;
                      }
                      z = v[b + 8 >> 2];
                      g = 0;
                      E: while (1) {
                       d = x[a + 480190 >> 1];
                       if (g >>> 0 >= d >>> 0) {
                        m = m + 1 | 0;
                        continue D;
                       }
                       if (v[xb(v[o >> 2], g) >> 2] != (s | 0)) {
                        g = g + 1 | 0;
                        continue;
                       }
                       v[31601] = 0;
                       O(149, b | 0, z | 0) | 0;
                       d = v[31601];
                       v[31601] = 0;
                       if ((d | 0) != 1) {
                        v[31601] = 0;
                        g = g + 1 | 0;
                        d = l + B(g, 104) | 0;
                        T(215, k | 0, d | 0, b | 0) | 0;
                        r = v[31601];
                        v[31601] = 0;
                        if ((r | 0) == 1) {
                         break C;
                        }
                        if (!q) {
                         continue;
                        }
                        ac(e + 72 | 0, v[d + 20 >> 2], v[d >> 2]);
                        A = e, C = vb(v[e + 72 >> 2]), v[A >> 2] = C;
                        r = Ok(v[e + 72 >> 2], v[e + 76 >> 2]);
                        while (1) {
                         d = v[e >> 2];
                         if (!Hb(d, r)) {
                          continue E;
                         }
                         t[d | 0] = w[d | 0] ^ 128;
                         xe(e);
                         continue;
                        }
                       }
                       break;
                      }
                      break;
                     }
                     d = M() | 0;
                     break v;
                    }
                    d = M() | 0;
                    break v;
                   }
                   d = M() | 0;
                   break v;
                  }
                  v[31601] = 0;
                  g = Q(189, b | 0) | 0;
                  m = v[31601];
                  v[31601] = 0;
                  F: {
                   if ((m | 0) == 1) {
                    break F;
                   }
                   v[31601] = 0;
                   O(183, b | 0, 1) | 0;
                   m = v[31601];
                   v[31601] = 0;
                   if ((m | 0) == 1) {
                    break F;
                   }
                   if (g) {
                    v[31601] = 0;
                    m = e + 4 | 0;
                    R(185, m | 0, b | 0, B(g, 3) + (w[e + 207 | 0] == 1 ? 3 : 0) | 0);
                    g = v[31601];
                    v[31601] = 0;
                    if ((g | 0) == 1) {
                     break A;
                    }
                    g = gc(e + 72 | 0, m);
                    jd(bh(v[h >> 2], d), g);
                    tb(g);
                    tb(m);
                   }
                   d = d + 1 | 0;
                   continue;
                  }
                  break;
                 }
                 d = M() | 0;
                 break v;
                }
                d = M() | 0;
                break v;
               }
               d = M() | 0;
               break u;
              }
              d = M() | 0;
              break u;
             }
             G: {
              H: {
               if (w[e + 207 | 0] <= 9) {
                v[31601] = 0;
                h = e + 72 | 0;
                N(216, b | 0, h | 0);
                k = v[31601];
                v[31601] = 0;
                I: {
                 J: {
                  if ((k | 0) == 1) {
                   break J;
                  }
                  v[31601] = 0;
                  N(217, h | 0, l + B(d, 104) | 0);
                  h = v[31601];
                  v[31601] = 0;
                  if ((h | 0) == 1) {
                   break J;
                  }
                  k = e + 48 | 0;
                  Ue(k, 2, g);
                  v[31601] = 0;
                  h = e + 4 | 0;
                  N(218, h | 0, k | 0);
                  k = v[31601];
                  v[31601] = 0;
                  if ((k | 0) == 1) {
                   break I;
                  }
                  zc(i + (d << 5) | 0, h);
                  sb(h);
                  A = xb(v[o >> 2], d - 1 | 0), C = w[e + 118 | 0] | w[e + 119 | 0] << 8 | (w[e + 120 | 0] << 16 | w[e + 121 | 0] << 24), 
                  v[A >> 2] = C;
                  break H;
                 }
                 d = M() | 0;
                 break t;
                }
                d = M() | 0;
                break t;
               }
               if (q) {
                v[31601] = 0;
                h = e + 72 | 0;
                N(219, b | 0, h | 0);
                k = v[31601];
                v[31601] = 0;
                K: {
                 L: {
                  if ((k | 0) == 1) {
                   break L;
                  }
                  v[31601] = 0;
                  N(220, h | 0, l + B(d, 104) | 0);
                  h = v[31601];
                  v[31601] = 0;
                  if ((h | 0) == 1) {
                   break L;
                  }
                  v[31601] = 0;
                  h = O(36, e + 36 | 0, 22256) | 0;
                  k = v[31601];
                  v[31601] = 0;
                  if ((k | 0) == 1) {
                   break K;
                  }
                  zc(i + (d << 5) | 0, h);
                  sb(h);
                  A = xb(v[o >> 2], d - 1 | 0), C = w[e + 74 | 0] | w[e + 75 | 0] << 8 | (w[e + 76 | 0] << 16 | w[e + 77 | 0] << 24), 
                  v[A >> 2] = C;
                  break H;
                 }
                 d = M() | 0;
                 break t;
                }
                d = M() | 0;
                break t;
               }
               v[31601] = 0;
               h = e + 72 | 0;
               R(221, b | 0, h | 0, m | 0);
               k = v[31601];
               v[31601] = 0;
               if ((k | 0) == 1) {
                break G;
               }
               v[31601] = 0;
               R(222, h | 0, l + B(d, 104) | 0, f | 0);
               h = v[31601];
               v[31601] = 0;
               if ((h | 0) == 1) {
                break G;
               }
               k = e + 48 | 0;
               Ue(k, 2, g);
               v[31601] = 0;
               h = e + 4 | 0;
               N(218, h | 0, k | 0);
               k = v[31601];
               v[31601] = 0;
               if ((k | 0) == 1) {
                break x;
               }
               zc(i + (d << 5) | 0, h);
               sb(h);
               A = xb(v[o >> 2], d - 1 | 0), C = w[e + 118 | 0] | w[e + 119 | 0] << 8 | (w[e + 120 | 0] << 16 | w[e + 121 | 0] << 24), 
               v[A >> 2] = C;
              }
              j = j + 1 | 0;
              continue;
             }
             break;
            }
            d = M() | 0;
            break t;
           }
           d = M() | 0;
           break t;
          }
          d = M() | 0;
          break g;
         }
         if (!(c & 1)) {
          break e;
         }
         v[31601] = 0;
         q = a + 484344 | 0;
         N(223, q | 0, w[e + 156 | 0]);
         c = v[31601];
         v[31601] = 0;
         M: {
          if ((c | 0) != 1) {
           c = 0;
           while (1) {
            N: {
             if (w[e + 156 | 0] <= c >>> 0) {
              break e;
             }
             d = 64;
             g = v[n >> 2];
             if (_c(g, v[n + 4 >> 2]) >>> 0 > c >>> 0) {
              d = x[$b(g, c) >> 1];
             }
             v[31601] = 0;
             d = T(196, q | 0, c & 65535, d & 65535) | 0;
             g = v[31601];
             v[31601] = 0;
             if ((g | 0) == 1) {
              break M;
             }
             O: {
              if (d) {
               d = x[a + 480188 >> 1];
               v[31601] = 0;
               O(149, b | 0, B(((w[e + 207 | 0] > 13) << 1) + (d << 1) | 0, c) + y | 0) | 0;
               d = v[31601];
               v[31601] = 0;
               if ((d | 0) == 1) {
                break M;
               }
               g = Mb(e + 72 | 0);
               d = x[a + 480188 >> 1];
               v[31601] = 0;
               l = T(213, b | 0, g | 0, d | 0) | 0;
               d = v[31601];
               v[31601] = 0;
               if ((d | 0) == 1) {
                break O;
               }
               d = 0;
               P: {
                if (!l) {
                 break P;
                }
                while (1) {
                 if (x[a + 480188 >> 1] <= d >>> 0) {
                  break P;
                 }
                 Q: {
                  l = $b(v[g >> 2], d);
                  l = (w[l | 0] | w[l + 1 | 0] << 8) - 1 | 0;
                  if ((l & 65535) >>> 0 >= (w[e + 157 | 0] | w[e + 158 | 0] << 8) >>> 0) {
                   break Q;
                  }
                  l = $b(v[i >> 2], l);
                  l = (w[l | 0] | w[l + 1 | 0] << 8) - 1 & 65535;
                  if (l >>> 0 >= f >>> 0) {
                   break Q;
                  }
                  m = v[q >> 2];
                  k = v[h >> 2];
                  v[31601] = 0;
                  R(224, Vb(m, c) | 0, d & 65535, bh(k, l) | 0);
                  l = v[31601];
                  v[31601] = 0;
                  if ((l | 0) != 1) {
                   break Q;
                  }
                  break N;
                 }
                 d = d + 1 | 0;
                 continue;
                }
               }
               nd(g);
              }
              c = c + 1 | 0;
              continue;
             }
            }
            break;
           }
           d = M() | 0;
           nd(g);
           break v;
          }
          d = M() | 0;
          break v;
         }
         d = M() | 0;
        }
        Qc(h);
       }
       nd(i);
      }
      uc(o);
     }
     nd(n);
    }
    P(d | 0);
    p();
   }
   Qc(h);
  }
  nd(i);
  uc(o);
  nd(n);
 }
 eb = e + 208 | 0;
 return j | 0;
}

function boa(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, q = 0, r = 0, s = 0, y = 0, z = 0;
 h = eb - 256 | 0;
 eb = h;
 e = eb - 112 | 0;
 eb = e;
 f = Ge(h + 76 | 0, c);
 v[31601] = 0;
 o = Q(168, f + 20 | 0) | 0;
 c = v[31601];
 v[31601] = 0;
 a: {
  b: {
   c: {
    d: {
     e: {
      f: {
       g: {
        h: {
         i: {
          j: {
           k: {
            l: {
             m: {
              n: {
               o: {
                p: {
                 q: {
                  r: {
                   s: {
                    t: {
                     u: {
                      v: {
                       w: {
                        x: {
                         y: {
                          z: {
                           A: {
                            B: {
                             if ((c | 0) != 1) {
                              v[31601] = 0;
                              r = Q(168, f + 40 | 0) | 0;
                              c = v[31601];
                              v[31601] = 0;
                              if ((c | 0) == 1) {
                               break B;
                              }
                              v[31601] = 0;
                              s = Q(168, f + 60 | 0) | 0;
                              c = v[31601];
                              v[31601] = 0;
                              if ((c | 0) == 1) {
                               break A;
                              }
                              v[31601] = 0;
                              i = Q(168, f + 80 | 0) | 0;
                              c = v[31601];
                              v[31601] = 0;
                              if ((c | 0) == 1) {
                               break z;
                              }
                              v[31601] = 0;
                              q = Q(168, f + 100 | 0) | 0;
                              c = v[31601];
                              v[31601] = 0;
                              if ((c | 0) == 1) {
                               break y;
                              }
                              v[31601] = 0;
                              m = Q(168, f + 120 | 0) | 0;
                              c = v[31601];
                              v[31601] = 0;
                              if ((c | 0) == 1) {
                               break x;
                              }
                              j = Mb(f + 140 | 0);
                              xc(f);
                              v[f + 172 >> 2] = 1873739776;
                              u[f + 176 >> 1] = 0;
                              v[31601] = 0;
                              d = O(805, f | 0, e + 100 | 0) | 0;
                              c = v[31601];
                              v[31601] = 0;
                              if ((c | 0) == 1) {
                               break w;
                              }
                              if (!d) {
                               break n;
                              }
                              d = v[e + 100 >> 2];
                              if ((d | 0) != 1414744396 & (d | 0) != 1179011410) {
                               break n;
                              }
                              c = v[e + 108 >> 2];
                              if ((c | 0) != 1163280727 & (c | 0) != 1702257015) {
                               break n;
                              }
                              t[f + 176 | 0] = (d | 0) == 1414744396;
                              v[31601] = 0;
                              g = e + 88 | 0;
                              R(806, g | 0, f | 0, 2);
                              c = v[31601];
                              v[31601] = 0;
                              if ((c | 0) == 1) {
                               break v;
                              }
                              k = v[e + 88 >> 2];
                              C: {
                               if (Hr(k, v[e + 92 >> 2]) >>> 0 < 4) {
                                break C;
                               }
                               l = e + 36 | 0;
                               c = zA(k, 1);
                               d = v[c >> 2];
                               c = v[c + 4 >> 2];
                               pi(l, d, c);
                               if (v[e + 36 >> 2] != 1635017060) {
                                break C;
                               }
                               pi(e + 60 | 0, d, c);
                               if (!(t[e + 64 | 0] & 1)) {
                                break C;
                               }
                               c = zA(k, 2);
                               pi(e + 16 | 0, v[c >> 2], v[c + 4 >> 2]);
                               if (w[e + 20 | 0] | w[e + 21 | 0] << 8 | (w[e + 22 | 0] << 16 | w[e + 23 | 0] << 24)) {
                                break C;
                               }
                               c = zA(k, 3);
                               pi(e + 80 | 0, v[c >> 2], v[c + 4 >> 2]);
                               if (v[e + 80 >> 2]) {
                                break C;
                               }
                               v[31601] = 0;
                               O(149, f | 0, 12) | 0;
                               c = v[31601];
                               v[31601] = 0;
                               if ((c | 0) == 1) {
                                break u;
                               }
                               v[31601] = 0;
                               R(806, l | 0, f | 0, 1);
                               c = v[31601];
                               v[31601] = 0;
                               if ((c | 0) == 1) {
                                break t;
                               }
                               Dv(g, l);
                               je(l);
                              }
                              v[31601] = 0;
                              g = e + 60 | 0;
                              R(807, g | 0, e + 88 | 0, 544501094);
                              c = v[31601];
                              v[31601] = 0;
                              if ((c | 0) == 1) {
                               break s;
                              }
                              v[31601] = 0;
                              d = O(808, g | 0, f + 156 | 0) | 0;
                              c = v[31601];
                              v[31601] = 0;
                              if ((c | 0) == 1) {
                               break k;
                              }
                              if (!d) {
                               break o;
                              }
                              d = x[f + 156 >> 1];
                              if ((d | 0) != 1) {
                               break q;
                              }
                              v[31601] = 0;
                              d = Q(202, g | 0) | 0;
                              c = v[31601];
                              v[31601] = 0;
                              if ((c | 0) != 1) {
                               break r;
                              }
                              break k;
                             }
                             d = M() | 0;
                             break b;
                            }
                            d = M() | 0;
                            break c;
                           }
                           d = M() | 0;
                           break d;
                          }
                          d = M() | 0;
                          break e;
                         }
                         d = M() | 0;
                         break f;
                        }
                        d = M() | 0;
                        break g;
                       }
                       d = M() | 0;
                       break h;
                      }
                      d = M() | 0;
                      break h;
                     }
                     d = M() | 0;
                     break i;
                    }
                    d = M() | 0;
                    break i;
                   }
                   d = M() | 0;
                   break i;
                  }
                  if ((d | 0) == 4) {
                   v[31601] = 0;
                   g = Q(192, e + 60 | 0) | 0;
                   c = v[31601];
                   v[31601] = 0;
                   D: {
                    if ((c | 0) != 1) {
                     v[31601] = 0;
                     d = Q(192, e + 60 | 0) | 0;
                     c = v[31601];
                     v[31601] = 0;
                     if ((c | 0) == 1) {
                      break D;
                     }
                     if ((g | 0) != 2 | (d | 0) != 1) {
                      break p;
                     }
                     t[f + 177 | 0] = 1;
                     break p;
                    }
                    d = M() | 0;
                    break j;
                   }
                   d = M() | 0;
                   break j;
                  }
                  d = x[f + 156 >> 1];
                 }
                 if ((d & 65535) != 65534) {
                  break p;
                 }
                 v[31601] = 0;
                 d = O(809, e + 60 | 0, e + 36 | 0) | 0;
                 c = v[31601];
                 v[31601] = 0;
                 if ((c | 0) == 1) {
                  break l;
                 }
                 if (!d) {
                  break o;
                 }
                 c = w[e + 56 | 0] | w[e + 57 | 0] << 8 | (w[e + 58 | 0] << 16 | w[e + 59 | 0] << 24);
                 v[e + 8 >> 2] = w[e + 52 | 0] | w[e + 53 | 0] << 8 | (w[e + 54 | 0] << 16 | w[e + 55 | 0] << 24);
                 v[e + 12 >> 2] = c;
                 c = w[e + 48 | 0] | w[e + 49 | 0] << 8 | (w[e + 50 | 0] << 16 | w[e + 51 | 0] << 24);
                 v[e >> 2] = w[e + 44 | 0] | w[e + 45 | 0] << 8 | (w[e + 46 | 0] << 16 | w[e + 47 | 0] << 24);
                 v[e + 4 >> 2] = c;
                 c = e + 16 | 0;
                 v[c >> 2] = w[e | 0] | w[e + 1 | 0] << 8 | (w[e + 2 | 0] << 16 | w[e + 3 | 0] << 24);
                 u[c + 4 >> 1] = w[e + 4 | 0] | w[e + 5 | 0] << 8;
                 u[c + 6 >> 1] = w[e + 6 | 0] | w[e + 7 | 0] << 8;
                 y = c, z = qA(w[e + 8 | 0] | w[e + 9 | 0] << 8 | (w[e + 10 | 0] << 16 | w[e + 11 | 0] << 24), w[e + 12 | 0] | w[e + 13 | 0] << 8 | (w[e + 14 | 0] << 16 | w[e + 15 | 0] << 24)), 
                 v[y + 8 >> 2] = z;
                 v[c + 12 >> 2] = gb;
                 u[f + 172 >> 1] = v[c >> 2];
                }
                v[31601] = 0;
                k = e + 36 | 0;
                g = e + 88 | 0;
                R(807, k | 0, g | 0, 1635017060);
                c = v[31601];
                v[31601] = 0;
                E: {
                 F: {
                  G: {
                   H: {
                    I: {
                     J: {
                      if ((c | 0) != 1) {
                       l = jd(o, k);
                       tb(k);
                       c = v[l >> 2];
                       v[31601] = 0;
                       d = Q(172, c | 0) | 0;
                       c = v[31601];
                       v[31601] = 0;
                       if ((c | 0) == 1) {
                        break k;
                       }
                       if (!d) {
                        v[31601] = 0;
                        R(807, k | 0, g | 0, 544039792);
                        c = v[31601];
                        v[31601] = 0;
                        if ((c | 0) == 1) {
                         break J;
                        }
                        jd(l, k);
                        tb(k);
                       }
                       v[31601] = 0;
                       g = e + 36 | 0;
                       R(807, g | 0, e + 88 | 0, 1952670054);
                       c = v[31601];
                       v[31601] = 0;
                       if ((c | 0) == 1) {
                        break I;
                       }
                       v[31601] = 0;
                       d = Q(151, g | 0) | 0;
                       c = v[31601];
                       v[31601] = 0;
                       if ((c | 0) == 1) {
                        break H;
                       }
                       v[f + 152 >> 2] = d;
                       tb(g);
                       if (v[f + 152 >> 2] ? x[f + 156 >> 1] == 17 : 0) {
                        break E;
                       }
                       g = x[f + 158 >> 1];
                       d = tR(g, x[f + 170 >> 1]);
                       if (!d) {
                        break E;
                       }
                       c = x[f + 168 >> 1];
                       if (c) {
                        if ((c >>> 0) / (g >>> 0) >>> 0 < d << 1 >>> 0) {
                         break G;
                        }
                       }
                       c = v[l >> 2];
                       v[31601] = 0;
                       d = Q(154, c | 0) | 0;
                       c = v[31601];
                       v[31601] = 0;
                       if ((c | 0) == 1) {
                        break k;
                       }
                       c = tR(x[f + 158 >> 1], x[f + 170 >> 1]);
                       break F;
                      }
                      d = M() | 0;
                      break j;
                     }
                     d = M() | 0;
                     break j;
                    }
                    d = M() | 0;
                    break j;
                   }
                   d = M() | 0;
                   tb(e + 36 | 0);
                   break j;
                  }
                  c = v[l >> 2];
                  v[31601] = 0;
                  d = Q(154, c | 0) | 0;
                  c = v[31601];
                  v[31601] = 0;
                  if ((c | 0) == 1) {
                   break k;
                  }
                  c = x[f + 168 >> 1];
                 }
                 v[f + 152 >> 2] = (d >>> 0) / ((c & 65535) >>> 0);
                }
                v[31601] = 0;
                g = e + 88 | 0;
                d = O(810, f | 0, g | 0) | 0;
                c = v[31601];
                v[31601] = 0;
                if ((c | 0) == 1) {
                 break k;
                }
                u[f + 174 >> 1] = d;
                v[31601] = 0;
                N(811, f | 0, g | 0);
                c = v[31601];
                v[31601] = 0;
                if ((c | 0) == 1) {
                 break k;
                }
                v[31601] = 0;
                d = e + 36 | 0;
                R(807, d | 0, g | 0, 1886221175);
                c = v[31601];
                v[31601] = 0;
                if ((c | 0) == 1) {
                 break m;
                }
                jd(q, d);
                tb(d);
               }
               tb(e + 60 | 0);
               je(e + 88 | 0);
              }
              eb = e + 112 | 0;
              break a;
             }
             d = M() | 0;
             break j;
            }
            d = M() | 0;
            break j;
           }
           d = M() | 0;
          }
          tb(e + 60 | 0);
         }
         je(e + 88 | 0);
        }
        je(j);
        tb(m);
       }
       tb(q);
      }
      tb(i);
     }
     tb(s);
    }
    tb(r);
   }
   tb(o);
  }
  tb(f);
  P(d | 0);
  p();
 }
 c = v[f + 20 >> 2];
 v[31601] = 0;
 d = Q(743, c | 0) | 0;
 c = v[31601];
 v[31601] = 0;
 K: {
  L: {
   if ((c | 0) != 1) {
    M: {
     if (!d | (x[f + 158 >> 1] - 3 & 65535) >>> 0 < 65534) {
      break M;
     }
     N: {
      O: {
       c = x[f + 170 >> 1];
       P: {
        if (!c) {
         if ((Bk(f) | 0) == 85) {
          break P;
         }
         break M;
        }
        if (c >>> 0 > 31) {
         break O;
        }
       }
       if ((Bk(f) | 0) != 3) {
        break N;
       }
       break M;
      }
      if (c >>> 0 > 64) {
       break M;
      }
     }
     d = Bk(f);
     c = 28544;
     while (1) {
      Q: {
       R: {
        if ((c | 0) != 28568) {
         if ((d | 0) != v[c >> 2]) {
          break R;
         }
        } else {
         c = 28568;
        }
        break Q;
       }
       c = c + 4 | 0;
       continue;
      }
      break;
     }
     if ((c | 0) == 28568) {
      break M;
     }
     Wu(a, b);
     v[31601] = 0;
     g = O(36, h - -64 | 0, 22256) | 0;
     c = v[31601];
     v[31601] = 0;
     S: {
      T: {
       U: {
        V: {
         W: {
          if ((c | 0) != 1) {
           d = zc(((b << 5) + a | 0) + 946304 | 0, g);
           sb(g);
           v[31601] = 0;
           i = (B(b, 104) + a | 0) + 484380 | 0;
           N(279, i | 0, 0);
           c = v[31601];
           v[31601] = 0;
           if ((c | 0) == 1) {
            break W;
           }
           v[i >> 2] = v[f + 152 >> 2];
           v[i + 24 >> 2] = v[f + 160 >> 2];
           c = v[a + 1298404 >> 2];
           v[31601] = 0;
           U(744, f | 0, i | 0, c | 0, d | 0);
           c = v[31601];
           v[31601] = 0;
           if ((c | 0) == 1) {
            break W;
           }
           Ge(h + 44 | 0, f + 20 | 0);
           d = x[f + 158 >> 1];
           j = Yc(h + 40 | 0, 8, d >>> 0 > 1 ? 2 : 1, 0, 0);
           c = Bk(f);
           if ((c | 0) != 17 | d >>> 0 > 2) {
            break U;
           }
           wc(i, 268435456);
           u[i + 34 >> 1] = x[i + 34 >> 1] & 65470 | ((d | 0) == 2) << 6 | 1;
           if (Fh(i)) {
            break V;
           }
           break S;
          }
          n = M() | 0;
          break K;
         }
         n = M() | 0;
         break K;
        }
        j = v[i >> 2];
        g = v[i + 20 >> 2];
        m = Ge(h + 20 | 0, h + 44 | 0);
        d = x[f + 158 >> 1];
        c = x[f + 168 >> 1];
        v[31601] = 0;
        b = v[m + 12 >> 2];
        v[h + 8 >> 2] = v[m + 8 >> 2];
        v[h + 12 >> 2] = b;
        v[h + 16 >> 2] = v[m + 16 >> 2];
        b = v[m + 4 >> 2];
        v[h >> 2] = v[m >> 2];
        v[h + 4 >> 2] = b;
        $(745, g | 0, j | 0, h | 0, c | 0, d | 0);
        b = v[31601];
        v[31601] = 0;
        if ((b | 0) == 1) {
         break L;
        }
        Hj(i, a);
        break T;
       }
       if ((c | 0) == 85) {
        v[31601] = 0;
        c = T(573, a | 0, b | 0, h + 44 | 0) | 0;
        b = v[31601];
        v[31601] = 0;
        if ((b | 0) == 1) {
         break L;
        }
        if (c) {
         break T;
        }
        break S;
       }
       X: {
        Y: {
         Z: {
          if (AV(x[f + 156 >> 1])) {
           break Z;
          }
          _: {
           if (!Hd(w[f + 177 | 0])) {
            break _;
           }
           if ((Bk(f) | 0) != 1 | x[f + 170 >> 1] != 32 | x[f + 168 >> 1] != d << 2) {
            break _;
           }
           gd(j, 32);
           b = 12;
           break Y;
          }
          if ((Bk(f) | 0) != 1 | x[f + 170 >> 1] != 24 | x[f + 168 >> 1] != d << 2) {
           break Z;
          }
          gd(j, 32);
          b = 13;
          break Y;
         }
         if ((Bk(f) & 65534) != 6) {
          break X;
         }
         gd(j, 16);
         b = (Bk(f) | 0) == 6 ? 17 : 16;
        }
        vg(j, b);
        v[31601] = 0;
        T(215, j | 0, i | 0, h + 44 | 0) | 0;
        b = v[31601];
        v[31601] = 0;
        if ((b | 0) != 1) {
         break T;
        }
        break L;
       }
       d = x[f + 170 >> 1];
       c = d - 1 | 0;
       b = c & -8;
       g = b & 31;
       if ((b & 63) >>> 0 >= 32) {
        b = 1074268168 >>> g | 0;
       } else {
        b = ((1 << g) - 1 & 1074268168) << 32 - g | 538447880 >>> g;
       }
       gd(j, (c >>> 0 >= 64 ? 8 : b) & 120);
       if (d >>> 0 < 9) {
        vg(j, 1);
       }
       if ((Bk(f) | 0) == 3) {
        vg(j, 3);
       }
       v[31601] = 0;
       T(215, j | 0, i | 0, h + 44 | 0) | 0;
       b = v[31601];
       v[31601] = 0;
       if ((b | 0) == 1) {
        break L;
       }
      }
      fC(i, v[a + 480180 >> 2]);
      Hj(i, a);
      n = 1;
     }
     tb(h + 44 | 0);
    }
    zV(f);
    eb = h + 256 | 0;
    return n | 0;
   }
   n = M() | 0;
   break K;
  }
  n = M() | 0;
  tb(h + 44 | 0);
 }
 zV(f);
 P(n | 0);
 p();
}

function Soa(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, q = 0, r = 0;
 e = eb - 272 | 0;
 eb = e;
 xc(b);
 d = eb - 16 | 0;
 eb = d;
 g = e + 126 | 0;
 XW(d + 8 | 0, g);
 f = v[d + 12 >> 2];
 ic(d, v[b >> 2], v[b + 8 >> 2], v[d + 8 >> 2], v[d + 12 >> 2]);
 h = v[d + 4 >> 2];
 if ((h | 0) == (f | 0)) {
  Ub(b, v[d + 12 >> 2]);
 }
 eb = d + 16 | 0;
 d = (f | 0) == (h | 0);
 if (!d) {
  WW(g);
 }
 a: {
  b: {
   c: {
    d: {
     if (!d) {
      break d;
     }
     if (!YW(g)) {
      break d;
     }
     k = 1;
     if ((c | 0) == 64) {
      break d;
     }
     Cd(a, 4194304);
     d = e + 40 | 0;
     g = tc(d, 17037);
     yb(a + 1298344 | 0, g);
     sb(g);
     g = tc(d, 10137);
     yb(a + 1298356 | 0, g);
     sb(g);
     q = a, r = v[Ec(d, 4) >> 2], v[q + 1298404 >> 2] = r;
     q = a, r = Kd(w[e + 204 | 0] | w[e + 205 | 0] << 8, w[e + 206 | 0] | w[e + 207 | 0] << 8, 127), 
     u[q + 480188 >> 1] = r;
     g = w[e + 195 | 0];
     v[a + 480228 >> 2] = (g | 0) == 255 ? 48 : g;
     v[a + 480196 >> 2] = w[e + 193 | 0];
     v[a + 480204 >> 2] = B(w[e + 194 | 0], 1e4);
     g = e + 104 | 0;
     bf(g, e + 130 | 0, 59, 3);
     Bc(d, g);
     yb(a + 1298308 | 0, d);
     sb(d);
     d = w[e + 208 | 0] | w[e + 209 | 0] << 8 | (w[e + 210 | 0] << 16 | w[e + 211 | 0] << 24);
     e: {
      if (d >>> 0 < 5) {
       break e;
      }
      if (!cd(b, d - 4 | 0)) {
       break e;
      }
      if (!$j(b, 14233)) {
       break e;
      }
      _j(Wb(v[a + 484360 >> 2], w[a + 484376 | 0]), b, w[e + 198 | 0] | w[e + 199 | 0] << 8, 65535, 65535);
     }
     f: {
      d = w[e + 212 | 0] | w[e + 213 | 0] << 8 | (w[e + 214 | 0] << 16 | w[e + 215 | 0] << 24);
      if (d >>> 0 < 5) {
       break f;
      }
      if (!cd(b, d - 4 | 0)) {
       break f;
      }
      if (!$j(b, 13843)) {
       break f;
      }
      g = a + 480280 | 0;
      d = 0;
      while (1) {
       if ((d | 0) == 32) {
        break f;
       }
       f = g + (d << 5) | 0;
       Ve(f);
       q = f, r = ((((Yd(b) ^ -1) & 15) << 8 | 8) >>> 0) / 15 | 0, u[q + 4 >> 1] = r;
       d = d + 1 | 0;
       continue;
      }
     }
     d = w[e + 220 | 0] | w[e + 221 | 0] << 8 | (w[e + 222 | 0] << 16 | w[e + 223 | 0] << 24);
     g: {
      if (d >>> 0 < 5) {
       break g;
      }
      if (!cd(b, d - 4 | 0)) {
       break g;
      }
      if (!$j(b, 14128)) {
       break g;
      }
      d = e + 40 | 0;
      ge(d, b, (w[e + 202 | 0] | w[e + 203 | 0] << 8) << 6);
      m = c & 2;
      l = a + 946304 | 0;
      k = a + 480190 | 0;
      j = a + 484380 | 0;
      g = gc(e + 104 | 0, d);
      tb(d);
      n = e + 53 | 0;
      d = 0;
      h: {
       while (1) {
        if ((d & 65535) >>> 0 >= (w[e + 202 | 0] | w[e + 203 | 0] << 8) >>> 0) {
         break h;
        }
        v[31601] = 0;
        h = e + 40 | 0;
        f = O(688, g | 0, h | 0) | 0;
        i = v[31601];
        v[31601] = 0;
        if ((i | 0) == 1) {
         break b;
        }
        if (!f) {
         break h;
        }
        f = w[e + 85 | 0] | w[e + 86 | 0] << 8;
        u[e + 38 >> 1] = f;
        i: {
         j: {
          if ((f - 1 & 65535) >>> 0 > 3998) {
           break j;
          }
          f = j + B(f, 104) | 0;
          if (ke(v[f >> 2], v[f + 20 >> 2])) {
           break j;
          }
          q = k, r = x[qe(k, e + 38 | 0) >> 1], u[q >> 1] = r;
          v[31601] = 0;
          N(689, h | 0, f | 0);
          f = v[31601];
          v[31601] = 0;
          if ((f | 0) == 1) {
           break i;
          }
          h = e + 12 | 0;
          a_(h, 1, n);
          v[31601] = 0;
          f = e + 24 | 0;
          N(218, f | 0, h | 0);
          h = v[31601];
          v[31601] = 0;
          if ((h | 0) == 1) {
           break b;
          }
          zc((x[e + 38 >> 1] << 5) + l | 0, f);
          sb(f);
          if (!m) {
           break j;
          }
          v[31601] = 0;
          O(149, b | 0, w[e + 77 | 0] | w[e + 78 | 0] << 8 | (w[e + 79 | 0] << 16 | w[e + 80 | 0] << 24)) | 0;
          h = v[31601];
          v[31601] = 0;
          if ((h | 0) == 1) {
           break i;
          }
          i = 1;
          h = w[e + 87 | 0];
          o = Yc(f, h & 4 ? 16 : 8, 1, 0, 0);
          k: {
           l: {
            if (h & 8) {
             break l;
            }
            i = 2;
            if (h & 16) {
             break l;
            }
            if (h & 103) {
             break k;
            }
           }
           vg(o, i);
          }
          v[31601] = 0;
          T(215, f | 0, j + B(x[e + 38 >> 1], 104) | 0, b | 0) | 0;
          f = v[31601];
          v[31601] = 0;
          if ((f | 0) != 1) {
           break j;
          }
          break b;
         }
         d = d + 1 | 0;
         continue;
        }
        break;
       }
       break b;
      }
      tb(g);
     }
     k = 1;
     if (!(c & 1)) {
      break d;
     }
     m: {
      c = w[e + 216 | 0] | w[e + 217 | 0] << 8 | (w[e + 218 | 0] << 16 | w[e + 219 | 0] << 24);
      if (c >>> 0 < 5) {
       break m;
      }
      if (!cd(b, c - 4 | 0)) {
       break m;
      }
      if (!$j(b, 13714)) {
       break m;
      }
      j = a + 484344 | 0;
      Sf(j, w[e + 200 | 0] | w[e + 201 | 0] << 8);
      f = 0;
      while (1) {
       if ((w[e + 200 | 0] | w[e + 201 | 0] << 8) >>> 0 <= f >>> 0) {
        break m;
       }
       if (!Pr(b, e + 24 | 0)) {
        break m;
       }
       n: {
        d = x[e + 24 >> 1];
        if (d >>> 0 > 3) {
         c = e + 104 | 0;
         ge(c, b, (d + 15 & 131056) - 4 | 0);
         g = gc(e + 40 | 0, c);
         tb(c);
         v[31601] = 0;
         c = T(196, j | 0, f & 65535, w[e + 26 | 0]) | 0;
         d = v[31601];
         v[31601] = 0;
         if ((d | 0) == 1) {
          break n;
         }
         h = 0;
         o: {
          if (!c) {
           break o;
          }
          p: while (1) {
           m = h & 255;
           while (1) {
            q: {
             c = v[g >> 2];
             v[31601] = 0;
             d = T(150, c | 0, v[e + 48 >> 2], 1) | 0;
             c = v[31601];
             v[31601] = 0;
             r: {
              if ((c | 0) != 1) {
               c = w[e + 26 | 0];
               if (!(d & c >>> 0 > m >>> 0)) {
                break q;
               }
               v[31601] = 0;
               c = Q(197, g | 0) | 0;
               d = v[31601];
               v[31601] = 0;
               if ((d | 0) == 1) {
                break c;
               }
               d = c << 24 >> 24;
               if (d) {
                break r;
               }
               h = h + 1 | 0;
               continue p;
              }
              break c;
             }
             c = v[a + 484344 >> 2];
             u[e + 104 >> 1] = d & 31;
             u[e + 12 >> 1] = x[a + 480188 >> 1] - 1;
             c = Vb(c, f);
             i = e + 104 | 0;
             c = ld(v[c >> 2], v[v[c + 48 >> 2] + 12 >> 2], h, x[Nc(i, e + 12 | 0) >> 1]);
             if ((d | 0) < 0) {
              v[31601] = 0;
              N(198, i | 0, g | 0);
              l = v[31601];
              v[31601] = 0;
              if ((l | 0) == 1) {
               break c;
              }
              t[c | 0] = w[e + 104 | 0] + 36;
              q = c, r = w[Ic(i) | 0], t[q + 1 | 0] = r;
             }
             d = d & 255;
             if (d & 64) {
              t[c + 2 | 0] = 1;
              v[31601] = 0;
              i = Q(197, g | 0) | 0;
              l = v[31601];
              v[31601] = 0;
              if ((l | 0) == 1) {
               break c;
              }
              t[e + 104 | 0] = i;
              t[e + 12 | 0] = 64;
              q = c, r = w[Pb(e + 104 | 0, e + 12 | 0) | 0], t[q + 4 | 0] = r;
             }
             if (!(d & 32)) {
              continue;
             }
             v[31601] = 0;
             d = e + 104 | 0;
             N(198, d | 0, g | 0);
             i = v[31601];
             v[31601] = 0;
             s: {
              t: {
               u: {
                v: {
                 w: {
                  x: {
                   y: {
                    z: {
                     A: {
                      B: {
                       C: {
                        D: {
                         E: {
                          F: {
                           G: {
                            H: {
                             I: {
                              J: {
                               K: {
                                L: {
                                 M: {
                                  N: {
                                   O: {
                                    P: {
                                     Q: {
                                      R: {
                                       S: {
                                        T: {
                                         U: {
                                          V: {
                                           W: {
                                            if ((i | 0) != 1) {
                                             d = w[Ic(d) | 0];
                                             t[c + 5 | 0] = d;
                                             X: {
                                              switch (w[e + 104 | 0] - 1 | 0) {
                                              case 71:
                                               break t;

                                              case 70:
                                               break u;

                                              case 69:
                                               break v;

                                              case 60:
                                               break w;

                                              case 59:
                                               break x;

                                              case 52:
                                               break y;

                                              case 51:
                                               break z;

                                              case 50:
                                               break A;

                                              case 49:
                                               break B;

                                              case 42:
                                               break C;

                                              case 41:
                                               break D;

                                              case 40:
                                               break E;

                                              case 39:
                                               break F;

                                              case 30:
                                               break G;

                                              case 29:
                                               break H;

                                              case 22:
                                               break I;

                                              case 21:
                                               break J;

                                              case 20:
                                               break K;

                                              case 19:
                                               break L;

                                              case 16:
                                               break M;

                                              case 15:
                                               break N;

                                              case 14:
                                               break O;

                                              case 13:
                                               break P;

                                              case 12:
                                               break Q;

                                              case 11:
                                               break R;

                                              case 10:
                                               break S;

                                              case 9:
                                               break T;

                                              case 3:
                                               break U;

                                              case 2:
                                               break V;

                                              case 1:
                                               break W;

                                              case 0:
                                               break X;

                                              default:
                                               break s;
                                              }
                                             }
                                             t[c + 3 | 0] = 11;
                                             t[c + 5 | 0] = d << 4 | 15;
                                             continue;
                                            }
                                            break c;
                                           }
                                           t[c + 3 | 0] = 11;
                                           t[c + 5 | 0] = d << 4;
                                           continue;
                                          }
                                          t[c + 3 | 0] = 11;
                                          t[c + 5 | 0] = d | 240;
                                          continue;
                                         }
                                         t[c + 3 | 0] = 11;
                                         t[c + 5 | 0] = d & 15;
                                         continue;
                                        }
                                        t[c + 3 | 0] = 2;
                                        t[c + 5 | 0] = d | 240;
                                        continue;
                                       }
                                       t[c + 3 | 0] = 2;
                                       continue;
                                      }
                                      t[c + 3 | 0] = 3;
                                      t[c + 5 | 0] = d | 240;
                                      continue;
                                     }
                                     t[c + 3 | 0] = 3;
                                     continue;
                                    }
                                    t[c + 3 | 0] = 4;
                                    continue;
                                   }
                                   t[c + 3 | 0] = 20;
                                   t[c + 5 | 0] = d | 16;
                                   continue;
                                  }
                                  t[c + 3 | 0] = 6;
                                  t[c + 5 | 0] = d << 4;
                                  continue;
                                 }
                                 t[c + 3 | 0] = 6;
                                 t[c + 5 | 0] = d & 15;
                                 continue;
                                }
                                t[c + 3 | 0] = 5;
                                continue;
                               }
                               t[c + 3 | 0] = 20;
                               t[c + 5 | 0] = d | 48;
                               continue;
                              }
                              t[c + 3 | 0] = 7;
                              t[c + 5 | 0] = d << 4;
                              continue;
                             }
                             t[c + 3 | 0] = 7;
                             t[c + 5 | 0] = d & 15;
                             continue;
                            }
                            t[c + 3 | 0] = 8;
                            continue;
                           }
                           t[c + 3 | 0] = 20;
                           t[c + 5 | 0] = d | 64;
                           continue;
                          }
                          t[c + 3 | 0] = 10;
                          v[31601] = 0;
                          d = Q(197, g | 0) | 0;
                          i = v[31601];
                          v[31601] = 0;
                          if ((i | 0) != 1) {
                           t[c + 5 | 0] = d;
                           v[31601] = 0;
                           O(183, g | 0, 1) | 0;
                           c = v[31601];
                           v[31601] = 0;
                           if ((c | 0) != 1) {
                            continue;
                           }
                          }
                          break c;
                         }
                         t[c + 3 | 0] = 15;
                         t[c + 5 | 0] = d & 15;
                         continue;
                        }
                        t[c + 3 | 0] = 20;
                        t[c + 5 | 0] = d | 192;
                        continue;
                       }
                       t[c + 3 | 0] = 20;
                       t[c + 5 | 0] = d | 208;
                       continue;
                      }
                      t[c + 3 | 0] = 12;
                      continue;
                     }
                     t[c + 3 | 0] = 14;
                     continue;
                    }
                    t[c + 3 | 0] = 20;
                    t[c + 5 | 0] = d | 176;
                    continue;
                   }
                   t[c + 3 | 0] = 20;
                   t[c + 5 | 0] = d | 224;
                   continue;
                  }
                  t[c + 3 | 0] = 16;
                  continue;
                 }
                 t[c + 3 | 0] = 17;
                 continue;
                }
                t[c + 3 | 0] = 1;
                continue;
               }
               t[c + 3 | 0] = 20;
               t[c + 5 | 0] = d & 15 | 32;
               continue;
              }
              t[c + 3 | 0] = 20;
              t[c + 5 | 0] = d & 15 | 128;
              continue;
             }
             t[c + 3 | 0] = 0;
             continue;
            }
            break;
           }
           break;
          }
          if ((c | 0) == 64) {
           break o;
          }
          ze(Vb(v[j >> 2], f), Uh(We(Ne(e + 104 | 0, 14, 0), c - 1 | 0)));
         }
         tb(g);
        }
        f = f + 1 | 0;
        continue;
       }
       break;
      }
      break c;
     }
     c = w[e + 224 | 0] | w[e + 225 | 0] << 8 | (w[e + 226 | 0] << 16 | w[e + 227 | 0] << 24);
     if (!c) {
      break d;
     }
     cd(b, c);
     cE(a + 1298332 | 0, b, fh(b), 4);
    }
    eb = e + 272 | 0;
    return k | 0;
   }
   a = M() | 0;
   break a;
  }
  a = M() | 0;
 }
 tb(g);
 P(a | 0);
 p();
}

function sL(a, b, c, d, e, f, g) {
 var h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, x = 0, y = 0, z = 0, C = 0, D = 0, E = 0, F = 0;
 j = eb - 80 | 0;
 eb = j;
 v[j + 76 >> 2] = b;
 E = j + 55 | 0;
 r = j + 56 | 0;
 a: {
  b: {
   c: {
    d: {
     e: while (1) {
      h = 0;
      f: while (1) {
       k = b;
       if ((o ^ 2147483647) < (h | 0)) {
        break d;
       }
       o = h + o | 0;
       g: {
        h: {
         i: {
          h = b;
          i = w[h | 0];
          if (i) {
           while (1) {
            j: {
             b = i & 255;
             k: {
              if (!b) {
               b = h;
               break k;
              }
              if ((b | 0) != 37) {
               break j;
              }
              i = h;
              while (1) {
               if (w[i + 1 | 0] != 37) {
                b = i;
                break k;
               }
               h = h + 1 | 0;
               m = w[i + 2 | 0];
               b = i + 2 | 0;
               i = b;
               if ((m | 0) == 37) {
                continue;
               }
               break;
              }
             }
             h = h - k | 0;
             D = o ^ 2147483647;
             if ((h | 0) > (D | 0)) {
              break d;
             }
             if (a) {
              Jf(a, k, h);
             }
             if (h) {
              continue f;
             }
             v[j + 76 >> 2] = b;
             h = b + 1 | 0;
             q = -1;
             m = t[b + 1 | 0] - 48 | 0;
             if (!(w[b + 2 | 0] != 36 | m >>> 0 > 9)) {
              s = 1;
              q = m;
              h = b + 3 | 0;
             }
             v[j + 76 >> 2] = h;
             n = 0;
             i = t[h | 0];
             b = i - 32 | 0;
             l: {
              if (b >>> 0 > 31) {
               m = h;
               break l;
              }
              m = h;
              b = 1 << b;
              if (!(b & 75913)) {
               break l;
              }
              while (1) {
               m = h + 1 | 0;
               v[j + 76 >> 2] = m;
               n = b | n;
               i = t[h + 1 | 0];
               b = i - 32 | 0;
               if (b >>> 0 >= 32) {
                break l;
               }
               h = m;
               b = 1 << b;
               if (b & 75913) {
                continue;
               }
               break;
              }
             }
             m: {
              if ((i | 0) == 42) {
               b = t[m + 1 | 0] - 48 | 0;
               n: {
                if (!(w[m + 2 | 0] != 36 | b >>> 0 > 9)) {
                 o: {
                  if (!a) {
                   v[(b << 2) + e >> 2] = 10;
                   p = 0;
                   break o;
                  }
                  p = v[(b << 3) + d >> 2];
                 }
                 b = m + 3 | 0;
                 s = 1;
                 break n;
                }
                if (s) {
                 break i;
                }
                b = m + 1 | 0;
                if (!a) {
                 v[j + 76 >> 2] = b;
                 s = 0;
                 p = 0;
                 break m;
                }
                h = v[c >> 2];
                v[c >> 2] = h + 4;
                p = v[h >> 2];
                s = 0;
               }
               v[j + 76 >> 2] = b;
               if ((p | 0) >= 0) {
                break m;
               }
               p = 0 - p | 0;
               n = n | 8192;
               break m;
              }
              p = rL(j + 76 | 0);
              if ((p | 0) < 0) {
               break d;
              }
              b = v[j + 76 >> 2];
             }
             h = 0;
             l = -1;
             i = 0;
             p: {
              if (w[b | 0] != 46) {
               break p;
              }
              if (w[b + 1 | 0] == 42) {
               m = t[b + 2 | 0] - 48 | 0;
               q: {
                if (!(w[b + 3 | 0] != 36 | m >>> 0 > 9)) {
                 b = b + 4 | 0;
                 r: {
                  if (!a) {
                   v[(m << 2) + e >> 2] = 10;
                   l = 0;
                   break r;
                  }
                  l = v[(m << 3) + d >> 2];
                 }
                 break q;
                }
                if (s) {
                 break i;
                }
                b = b + 2 | 0;
                l = 0;
                if (!a) {
                 break q;
                }
                m = v[c >> 2];
                v[c >> 2] = m + 4;
                l = v[m >> 2];
               }
               v[j + 76 >> 2] = b;
               i = (l | 0) >= 0;
               break p;
              }
              v[j + 76 >> 2] = b + 1;
              l = rL(j + 76 | 0);
              b = v[j + 76 >> 2];
              i = 1;
             }
             y = i;
             while (1) {
              x = h;
              m = 28;
              z = b;
              i = t[b | 0];
              if (i - 123 >>> 0 < 4294967238) {
               break c;
              }
              b = b + 1 | 0;
              h = w[(i + B(h, 58) | 0) + 92671 | 0];
              if (h - 1 >>> 0 < 8) {
               continue;
              }
              break;
             }
             v[j + 76 >> 2] = b;
             s: {
              if ((h | 0) != 27) {
               if (!h) {
                break c;
               }
               if ((q | 0) >= 0) {
                if (!a) {
                 v[(q << 2) + e >> 2] = h;
                 continue e;
                }
                h = (q << 3) + d | 0;
                m = v[h + 4 >> 2];
                v[j + 64 >> 2] = v[h >> 2];
                v[j + 68 >> 2] = m;
                break s;
               }
               if (!a) {
                break g;
               }
               qL(j - -64 | 0, h, c, g);
               break s;
              }
              if ((q | 0) >= 0) {
               break c;
              }
              h = 0;
              if (!a) {
               continue f;
              }
             }
             if (w[a | 0] & 32) {
              break b;
             }
             i = n & -65537;
             n = n & 8192 ? i : n;
             q = 0;
             C = 5286;
             m = r;
             t: {
              u: {
               v: {
                w: {
                 x: {
                  y: {
                   z: {
                    A: {
                     B: {
                      C: {
                       D: {
                        E: {
                         F: {
                          G: {
                           H: {
                            I: {
                             h = t[z | 0];
                             h = x ? (h & 15) == 3 ? h & -45 : h : h;
                             switch (h - 88 | 0) {
                             case 11:
                              break t;

                             case 9:
                             case 13:
                             case 14:
                             case 15:
                              break u;

                             case 27:
                              break z;

                             case 12:
                             case 17:
                              break C;

                             case 23:
                              break D;

                             case 0:
                             case 32:
                              break E;

                             case 24:
                              break F;

                             case 22:
                              break G;

                             case 29:
                              break H;

                             case 1:
                             case 2:
                             case 3:
                             case 4:
                             case 5:
                             case 6:
                             case 7:
                             case 8:
                             case 10:
                             case 16:
                             case 18:
                             case 19:
                             case 20:
                             case 21:
                             case 25:
                             case 26:
                             case 28:
                             case 30:
                             case 31:
                              break h;

                             default:
                              break I;
                             }
                            }
                            J: {
                             switch (h - 65 | 0) {
                             case 0:
                             case 4:
                             case 5:
                             case 6:
                              break u;

                             case 2:
                              break x;

                             case 1:
                             case 3:
                              break h;

                             default:
                              break J;
                             }
                            }
                            if ((h | 0) == 83) {
                             break y;
                            }
                            break h;
                           }
                           k = v[j + 64 >> 2];
                           i = v[j + 68 >> 2];
                           b = 5286;
                           break B;
                          }
                          h = 0;
                          K: {
                           switch (x & 255) {
                           case 0:
                            v[v[j + 64 >> 2] >> 2] = o;
                            continue f;

                           case 1:
                            v[v[j + 64 >> 2] >> 2] = o;
                            continue f;

                           case 2:
                            k = v[j + 64 >> 2];
                            v[k >> 2] = o;
                            v[k + 4 >> 2] = o >> 31;
                            continue f;

                           case 3:
                            u[v[j + 64 >> 2] >> 1] = o;
                            continue f;

                           case 4:
                            t[v[j + 64 >> 2]] = o;
                            continue f;

                           case 6:
                            v[v[j + 64 >> 2] >> 2] = o;
                            continue f;

                           case 7:
                            break K;

                           default:
                            continue f;
                           }
                          }
                          k = v[j + 64 >> 2];
                          v[k >> 2] = o;
                          v[k + 4 >> 2] = o >> 31;
                          continue f;
                         }
                         l = l >>> 0 <= 8 ? 8 : l;
                         n = n | 8;
                         h = 120;
                        }
                        b = r;
                        z = h & 32;
                        k = v[j + 64 >> 2];
                        i = v[j + 68 >> 2];
                        if (k | i) {
                         while (1) {
                          b = b - 1 | 0;
                          t[b | 0] = z | w[(k & 15) + 93200 | 0];
                          F = !i & k >>> 0 > 15 | (i | 0) != 0;
                          x = i;
                          i = i >>> 4 | 0;
                          k = (x & 15) << 28 | k >>> 4;
                          if (F) {
                           continue;
                          }
                          break;
                         }
                        }
                        k = b;
                        if (!(n & 8) | !(v[j + 64 >> 2] | v[j + 68 >> 2])) {
                         break A;
                        }
                        C = (h >>> 4 | 0) + 5286 | 0;
                        q = 2;
                        break A;
                       }
                       b = r;
                       h = v[j + 68 >> 2];
                       i = h;
                       k = v[j + 64 >> 2];
                       if (h | k) {
                        while (1) {
                         b = b - 1 | 0;
                         t[b | 0] = k & 7 | 48;
                         x = !i & k >>> 0 > 7 | (i | 0) != 0;
                         h = i;
                         i = h >>> 3 | 0;
                         k = (h & 7) << 29 | k >>> 3;
                         if (x) {
                          continue;
                         }
                         break;
                        }
                       }
                       k = b;
                       if (!(n & 8)) {
                        break A;
                       }
                       b = r - b | 0;
                       l = (b | 0) < (l | 0) ? l : b + 1 | 0;
                       break A;
                      }
                      k = v[j + 64 >> 2];
                      b = v[j + 68 >> 2];
                      i = b;
                      if ((b | 0) < 0) {
                       h = 0 - (b + ((k | 0) != 0) | 0) | 0;
                       i = h;
                       k = 0 - k | 0;
                       v[j + 64 >> 2] = k;
                       v[j + 68 >> 2] = h;
                       q = 1;
                       b = 5286;
                       break B;
                      }
                      if (n & 2048) {
                       q = 1;
                       b = 5287;
                       break B;
                      }
                      q = n & 1;
                      b = q ? 5288 : 5286;
                     }
                     C = b;
                     k = ko(k, i, r);
                    }
                    if ((l | 0) < 0 & y) {
                     break d;
                    }
                    n = y ? n & -65537 : n;
                    b = v[j + 64 >> 2];
                    h = v[j + 68 >> 2];
                    if (!((b | h) != 0 | l)) {
                     k = r;
                     l = 0;
                     break h;
                    }
                    b = !(b | h) + (r - k | 0) | 0;
                    l = (b | 0) < (l | 0) ? l : b;
                    break h;
                   }
                   b = v[j + 64 >> 2];
                   k = b ? b : 17071;
                   b = l >>> 0 >= 2147483647 ? 2147483647 : l;
                   h = Nz(k, 0, b);
                   b = h ? h - k | 0 : b;
                   m = b + k | 0;
                   if ((l | 0) >= 0) {
                    n = i;
                    l = b;
                    break h;
                   }
                   n = i;
                   l = b;
                   if (w[m | 0]) {
                    break d;
                   }
                   break h;
                  }
                  if (l) {
                   i = v[j + 64 >> 2];
                   break w;
                  }
                  h = 0;
                  Vf(a, 32, p, 0, n);
                  break v;
                 }
                 v[j + 12 >> 2] = 0;
                 v[j + 8 >> 2] = v[j + 64 >> 2];
                 i = j + 8 | 0;
                 v[j + 64 >> 2] = i;
                 l = -1;
                }
                h = 0;
                while (1) {
                 L: {
                  k = v[i >> 2];
                  if (!k) {
                   break L;
                  }
                  k = Kt(j + 4 | 0, k);
                  if ((k | 0) < 0) {
                   break b;
                  }
                  if (k >>> 0 > l - h >>> 0) {
                   break L;
                  }
                  i = i + 4 | 0;
                  h = h + k | 0;
                  if (l >>> 0 > h >>> 0) {
                   continue;
                  }
                 }
                 break;
                }
                m = 61;
                if ((h | 0) < 0) {
                 break c;
                }
                Vf(a, 32, p, h, n);
                if (!h) {
                 h = 0;
                 break v;
                }
                m = 0;
                i = v[j + 64 >> 2];
                while (1) {
                 k = v[i >> 2];
                 if (!k) {
                  break v;
                 }
                 l = j + 4 | 0;
                 k = Kt(l, k);
                 m = k + m | 0;
                 if (m >>> 0 > h >>> 0) {
                  break v;
                 }
                 Jf(a, l, k);
                 i = i + 4 | 0;
                 if (h >>> 0 > m >>> 0) {
                  continue;
                 }
                 break;
                }
               }
               Vf(a, 32, p, h, n ^ 8192);
               h = (h | 0) < (p | 0) ? p : h;
               continue f;
              }
              if ((l | 0) < 0 & y) {
               break d;
              }
              m = 61;
              h = hb[f | 0](a, A[j + 64 >> 3], p, l, n, h) | 0;
              if ((h | 0) >= 0) {
               continue f;
              }
              break c;
             }
             t[j + 55 | 0] = v[j + 64 >> 2];
             l = 1;
             k = E;
             n = i;
             break h;
            }
            i = w[h + 1 | 0];
            h = h + 1 | 0;
            continue;
           }
          }
          if (a) {
           break a;
          }
          if (!s) {
           break g;
          }
          h = 1;
          while (1) {
           a = v[(h << 2) + e >> 2];
           if (a) {
            qL((h << 3) + d | 0, a, c, g);
            o = 1;
            h = h + 1 | 0;
            if ((h | 0) != 10) {
             continue;
            }
            break a;
           }
           break;
          }
          o = 1;
          if (h >>> 0 >= 10) {
           break a;
          }
          while (1) {
           if (v[(h << 2) + e >> 2]) {
            break i;
           }
           h = h + 1 | 0;
           if ((h | 0) != 10) {
            continue;
           }
           break;
          }
          break a;
         }
         m = 28;
         break c;
        }
        i = m - k | 0;
        l = (i | 0) < (l | 0) ? l : i;
        if ((l | 0) > (q ^ 2147483647)) {
         break d;
        }
        m = 61;
        b = l + q | 0;
        h = (b | 0) < (p | 0) ? p : b;
        if ((D | 0) < (h | 0)) {
         break c;
        }
        Vf(a, 32, h, b, n);
        Jf(a, C, q);
        Vf(a, 48, h, b, n ^ 65536);
        Vf(a, 48, l, i, 0);
        Jf(a, k, i);
        Vf(a, 32, h, b, n ^ 8192);
        b = v[j + 76 >> 2];
        continue;
       }
       break;
      }
      break;
     }
     o = 0;
     break a;
    }
    m = 61;
   }
   v[31476] = m;
  }
  o = -1;
 }
 eb = j + 80 | 0;
 return o;
}

function w5(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0;
 e = wd(a, c);
 v[e >> 2] = 95180;
 f = EJ(e + 8 | 0);
 v[31601] = 0;
 b = O(71, e + 152 | 0, b | 0) | 0;
 a = v[31601];
 v[31601] = 0;
 a: {
  b: {
   c: {
    d: {
     e: {
      if ((a | 0) != 1) {
       v[31601] = 0;
       a = ba(104) | 0;
       c = v[31601];
       v[31601] = 0;
       if ((c | 0) == 1) {
        break e;
       }
       a = v[a >> 2];
       c = 0;
       v[31601] = 0;
       a = O(1328, f | 0, a + 8 | 0) | 0;
       d = v[31601];
       v[31601] = 0;
       if ((d | 0) == 1) {
        break e;
       }
       while (1) {
        f: {
         d = v[a >> 2];
         if (nc(d, v[e + 12 >> 2]) >>> 0 <= c >>> 0) {
          v[31601] = 0;
          c = Q(851, 12) | 0;
          a = v[31601];
          v[31601] = 0;
          if ((a | 0) != 1) {
           break f;
          }
          break e;
         }
         d = v[xb(d, c) >> 2];
         if (d) {
          nm(d);
         }
         c = c + 1 | 0;
         continue;
        }
        break;
       }
       v[31601] = 0;
       a = T(1329, c | 0, b | 0, 0) | 0;
       d = v[31601];
       v[31601] = 0;
       g: {
        h: {
         i: {
          j: {
           k: {
            l: {
             m: {
              n: {
               o: {
                p: {
                 q: {
                  r: {
                   s: {
                    t: {
                     if ((d | 0) != 1) {
                      v[31601] = 0;
                      N(1330, e | 0, a | 0);
                      a = v[31601];
                      v[31601] = 0;
                      if ((a | 0) == 1) {
                       break e;
                      }
                      v[31601] = 0;
                      c = Q(851, 12) | 0;
                      a = v[31601];
                      v[31601] = 0;
                      if ((a | 0) == 1) {
                       break e;
                      }
                      v[31601] = 0;
                      a = T(1331, c | 0, b | 0, 0) | 0;
                      d = v[31601];
                      v[31601] = 0;
                      if ((d | 0) == 1) {
                       break t;
                      }
                      v[31601] = 0;
                      N(1332, e | 0, a | 0);
                      a = v[31601];
                      v[31601] = 0;
                      if ((a | 0) == 1) {
                       break e;
                      }
                      v[31601] = 0;
                      c = Q(851, 20) | 0;
                      a = v[31601];
                      v[31601] = 0;
                      if ((a | 0) == 1) {
                       break e;
                      }
                      v[31601] = 0;
                      a = T(1333, c | 0, b | 0, 0) | 0;
                      d = v[31601];
                      v[31601] = 0;
                      if ((d | 0) == 1) {
                       break s;
                      }
                      v[31601] = 0;
                      N(1334, e | 0, a | 0);
                      a = v[31601];
                      v[31601] = 0;
                      if ((a | 0) == 1) {
                       break e;
                      }
                      v[31601] = 0;
                      c = Q(851, 12) | 0;
                      a = v[31601];
                      v[31601] = 0;
                      if ((a | 0) == 1) {
                       break e;
                      }
                      v[31601] = 0;
                      a = T(1335, c | 0, b | 0, 0) | 0;
                      d = v[31601];
                      v[31601] = 0;
                      if ((d | 0) == 1) {
                       break r;
                      }
                      v[31601] = 0;
                      N(1336, e | 0, a | 0);
                      a = v[31601];
                      v[31601] = 0;
                      if ((a | 0) == 1) {
                       break e;
                      }
                      v[31601] = 0;
                      a = Q(851, 8) | 0;
                      c = v[31601];
                      v[31601] = 0;
                      if ((c | 0) == 1) {
                       break e;
                      }
                      a = wd(a, 0);
                      v[a >> 2] = 97124;
                      v[a >> 2] = 102736;
                      v[31601] = 0;
                      N(1337, e | 0, a | 0);
                      a = v[31601];
                      v[31601] = 0;
                      if ((a | 0) == 1) {
                       break e;
                      }
                      v[31601] = 0;
                      c = Q(851, 12) | 0;
                      a = v[31601];
                      v[31601] = 0;
                      if ((a | 0) == 1) {
                       break e;
                      }
                      v[31601] = 0;
                      a = O(1338, c | 0, b | 0) | 0;
                      d = v[31601];
                      v[31601] = 0;
                      if ((d | 0) == 1) {
                       break q;
                      }
                      v[31601] = 0;
                      N(1339, e | 0, a | 0);
                      a = v[31601];
                      v[31601] = 0;
                      if ((a | 0) == 1) {
                       break e;
                      }
                      v[31601] = 0;
                      a = Q(851, 8) | 0;
                      c = v[31601];
                      v[31601] = 0;
                      if ((c | 0) == 1) {
                       break e;
                      }
                      a = wd(a, 0);
                      v[a >> 2] = 97272;
                      v[a >> 2] = 102944;
                      v[31601] = 0;
                      N(1340, e | 0, a | 0);
                      a = v[31601];
                      v[31601] = 0;
                      if ((a | 0) == 1) {
                       break e;
                      }
                      v[31601] = 0;
                      a = Q(851, 8) | 0;
                      c = v[31601];
                      v[31601] = 0;
                      if ((c | 0) == 1) {
                       break e;
                      }
                      a = wd(a, 0);
                      v[a >> 2] = 97504;
                      v[a >> 2] = 103048;
                      v[31601] = 0;
                      N(1341, e | 0, a | 0);
                      a = v[31601];
                      v[31601] = 0;
                      if ((a | 0) == 1) {
                       break e;
                      }
                      v[31601] = 0;
                      a = Q(851, 8) | 0;
                      c = v[31601];
                      v[31601] = 0;
                      if ((c | 0) == 1) {
                       break e;
                      }
                      a = wd(a, 0);
                      v[a >> 2] = 97388;
                      v[a >> 2] = 103152;
                      v[31601] = 0;
                      N(1342, e | 0, a | 0);
                      a = v[31601];
                      v[31601] = 0;
                      if ((a | 0) == 1) {
                       break e;
                      }
                      v[31601] = 0;
                      a = Q(851, 8) | 0;
                      c = v[31601];
                      v[31601] = 0;
                      if ((c | 0) == 1) {
                       break e;
                      }
                      a = wd(a, 0);
                      v[a >> 2] = 97620;
                      v[a >> 2] = 103256;
                      v[31601] = 0;
                      N(1343, e | 0, a | 0);
                      a = v[31601];
                      v[31601] = 0;
                      if ((a | 0) == 1) {
                       break e;
                      }
                      v[31601] = 0;
                      c = Q(851, 24) | 0;
                      a = v[31601];
                      v[31601] = 0;
                      if ((a | 0) == 1) {
                       break e;
                      }
                      v[31601] = 0;
                      a = T(1344, c | 0, b | 0, 0) | 0;
                      d = v[31601];
                      v[31601] = 0;
                      if ((d | 0) == 1) {
                       break p;
                      }
                      v[31601] = 0;
                      N(1345, e | 0, a | 0);
                      a = v[31601];
                      v[31601] = 0;
                      if ((a | 0) == 1) {
                       break e;
                      }
                      v[31601] = 0;
                      c = Q(851, 28) | 0;
                      a = v[31601];
                      v[31601] = 0;
                      if ((a | 0) == 1) {
                       break e;
                      }
                      v[31601] = 0;
                      a = T(1346, c | 0, b | 0, 0) | 0;
                      d = v[31601];
                      v[31601] = 0;
                      if ((d | 0) == 1) {
                       break o;
                      }
                      v[31601] = 0;
                      N(1347, e | 0, a | 0);
                      a = v[31601];
                      v[31601] = 0;
                      if ((a | 0) == 1) {
                       break e;
                      }
                      v[31601] = 0;
                      c = Q(851, 72) | 0;
                      a = v[31601];
                      v[31601] = 0;
                      if ((a | 0) == 1) {
                       break e;
                      }
                      v[31601] = 0;
                      a = O(1348, c | 0, b | 0) | 0;
                      d = v[31601];
                      v[31601] = 0;
                      if ((d | 0) == 1) {
                       break n;
                      }
                      v[31601] = 0;
                      N(1349, e | 0, a | 0);
                      a = v[31601];
                      v[31601] = 0;
                      if ((a | 0) == 1) {
                       break e;
                      }
                      v[31601] = 0;
                      c = Q(851, 72) | 0;
                      a = v[31601];
                      v[31601] = 0;
                      if ((a | 0) == 1) {
                       break e;
                      }
                      v[31601] = 0;
                      a = O(1350, c | 0, b | 0) | 0;
                      d = v[31601];
                      v[31601] = 0;
                      if ((d | 0) == 1) {
                       break m;
                      }
                      v[31601] = 0;
                      N(1351, e | 0, a | 0);
                      a = v[31601];
                      v[31601] = 0;
                      if ((a | 0) == 1) {
                       break e;
                      }
                      v[31601] = 0;
                      c = Q(851, 76) | 0;
                      a = v[31601];
                      v[31601] = 0;
                      if ((a | 0) == 1) {
                       break e;
                      }
                      v[31601] = 0;
                      a = O(1352, c | 0, b | 0) | 0;
                      d = v[31601];
                      v[31601] = 0;
                      if ((d | 0) == 1) {
                       break l;
                      }
                      v[31601] = 0;
                      N(1353, e | 0, a | 0);
                      a = v[31601];
                      v[31601] = 0;
                      if ((a | 0) == 1) {
                       break e;
                      }
                      v[31601] = 0;
                      c = Q(851, 76) | 0;
                      a = v[31601];
                      v[31601] = 0;
                      if ((a | 0) == 1) {
                       break e;
                      }
                      v[31601] = 0;
                      a = O(1354, c | 0, b | 0) | 0;
                      d = v[31601];
                      v[31601] = 0;
                      if ((d | 0) == 1) {
                       break k;
                      }
                      v[31601] = 0;
                      N(1355, e | 0, a | 0);
                      a = v[31601];
                      v[31601] = 0;
                      if ((a | 0) == 1) {
                       break e;
                      }
                      v[31601] = 0;
                      c = Q(851, 544) | 0;
                      a = v[31601];
                      v[31601] = 0;
                      if ((a | 0) == 1) {
                       break e;
                      }
                      v[31601] = 0;
                      a = O(1356, c | 0, b | 0) | 0;
                      d = v[31601];
                      v[31601] = 0;
                      if ((d | 0) == 1) {
                       break j;
                      }
                      v[31601] = 0;
                      N(1357, e | 0, a | 0);
                      a = v[31601];
                      v[31601] = 0;
                      if ((a | 0) == 1) {
                       break e;
                      }
                      v[31601] = 0;
                      c = Q(851, 544) | 0;
                      a = v[31601];
                      v[31601] = 0;
                      if ((a | 0) == 1) {
                       break e;
                      }
                      v[31601] = 0;
                      a = O(1358, c | 0, b | 0) | 0;
                      d = v[31601];
                      v[31601] = 0;
                      if ((d | 0) == 1) {
                       break i;
                      }
                      v[31601] = 0;
                      N(1359, e | 0, a | 0);
                      a = v[31601];
                      v[31601] = 0;
                      if ((a | 0) == 1) {
                       break e;
                      }
                      v[31601] = 0;
                      c = Q(851, 12) | 0;
                      a = v[31601];
                      v[31601] = 0;
                      if ((a | 0) == 1) {
                       break e;
                      }
                      v[31601] = 0;
                      a = O(1360, c | 0, b | 0) | 0;
                      d = v[31601];
                      v[31601] = 0;
                      if ((d | 0) == 1) {
                       break h;
                      }
                      v[31601] = 0;
                      N(1361, e | 0, a | 0);
                      a = v[31601];
                      v[31601] = 0;
                      if ((a | 0) == 1) {
                       break e;
                      }
                      v[31601] = 0;
                      c = Q(851, 12) | 0;
                      a = v[31601];
                      v[31601] = 0;
                      if ((a | 0) == 1) {
                       break e;
                      }
                      v[31601] = 0;
                      a = O(1362, c | 0, b | 0) | 0;
                      d = v[31601];
                      v[31601] = 0;
                      if ((d | 0) == 1) {
                       break g;
                      }
                      v[31601] = 0;
                      N(1363, e | 0, a | 0);
                      a = v[31601];
                      v[31601] = 0;
                      if ((a | 0) == 1) {
                       break e;
                      }
                      v[31601] = 0;
                      a = Q(851, 8) | 0;
                      c = v[31601];
                      v[31601] = 0;
                      if ((c | 0) == 1) {
                       break e;
                      }
                      a = mJ(a, 0);
                      v[a >> 2] = 102584;
                      v[31601] = 0;
                      N(1364, e | 0, a | 0);
                      a = v[31601];
                      v[31601] = 0;
                      if ((a | 0) == 1) {
                       break e;
                      }
                      v[31601] = 0;
                      a = Q(851, 8) | 0;
                      c = v[31601];
                      v[31601] = 0;
                      if ((c | 0) == 1) {
                       break e;
                      }
                      a = lJ(a, 0);
                      v[a >> 2] = 102660;
                      v[31601] = 0;
                      N(1365, e | 0, a | 0);
                      a = v[31601];
                      v[31601] = 0;
                      if ((a | 0) == 1) {
                       break e;
                      }
                      return e | 0;
                     }
                     a = S(0) | 0;
                     Bb(c);
                     break d;
                    }
                    a = S(0) | 0;
                    Bb(c);
                    break d;
                   }
                   a = S(0) | 0;
                   Bb(c);
                   break d;
                  }
                  a = S(0) | 0;
                  Bb(c);
                  break d;
                 }
                 a = S(0) | 0;
                 Bb(c);
                 break d;
                }
                a = S(0) | 0;
                Bb(c);
                break d;
               }
               a = S(0) | 0;
               Bb(c);
               break d;
              }
              a = S(0) | 0;
              Bb(c);
              break d;
             }
             a = S(0) | 0;
             Bb(c);
             break d;
            }
            a = S(0) | 0;
            Bb(c);
            break d;
           }
           a = S(0) | 0;
           Bb(c);
           break d;
          }
          a = S(0) | 0;
          Bb(c);
          break d;
         }
         a = S(0) | 0;
         Bb(c);
         break d;
        }
        a = S(0) | 0;
        Bb(c);
        break d;
       }
       a = S(0) | 0;
       Bb(c);
       break d;
      }
      a = M() | 0;
      break c;
     }
     a = S(0) | 0;
    }
    X(a | 0) | 0;
    c = 0;
    while (1) {
     a = v[f >> 2];
     if (nc(a, v[e + 12 >> 2]) >>> 0 <= c >>> 0) {
      v[31601] = 0;
      W(84);
      a = v[31601];
      v[31601] = 0;
      if ((a | 0) != 1) {
       break a;
      }
      a = M() | 0;
      v[31601] = 0;
      W(26);
      c = v[31601];
      v[31601] = 0;
      if ((c | 0) == 1) {
       break b;
      }
      sb(b);
      break c;
     }
     a = v[xb(a, c) >> 2];
     if (a) {
      sm(a);
     }
     c = c + 1 | 0;
     continue;
    }
   }
   oy(f);
   P(a | 0);
   p();
  }
  S(0) | 0;
  Rb();
 }
 p();
}

function Cta(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, q = 0, r = 0, s = 0, y = 0, z = 0, A = 0, C = 0, D = 0, E = 0, F = 0, G = 0, H = 0, I = 0;
 e = eb + -64 | 0;
 eb = e;
 xc(a);
 a: {
  b: {
   if (b >>> 0 <= 2) {
    H = e, I = Yd(a), t[H + 56 | 0] = I;
    Ub(a, 2);
    b = fh(a);
    t[e + 58 | 0] = b;
    t[e + 59 | 0] = b >>> 8;
    b = Qg(a);
    t[e + 60 | 0] = b;
    t[e + 61 | 0] = b >>> 8;
    t[e + 62 | 0] = b >>> 16;
    t[e + 63 | 0] = b >>> 24;
    break b;
   }
   jp(a, e + 56 | 0);
   if (b >>> 0 > 5) {
    break a;
   }
  }
  t[e + 57 | 0] = 0;
 }
 c: {
  y = d + 484344 | 0;
  F = Kd(w[e + 58 | 0] | w[e + 59 | 0] << 8, 1, 1024);
  q = iE(y, F);
  if ((q | 0) == 65535) {
   break c;
  }
  b = Vb(v[d + 484344 >> 2], q);
  h = ld(v[b >> 2], v[v[b + 48 >> 2] + 12 >> 2], 0, 0);
  f = x[d + 480188 >> 1];
  u[e + 12 >> 1] = f - 1;
  u[e + 44 >> 1] = w[e + 56 | 0];
  G = x[Nc(e + 12 | 0, e + 44 | 0) >> 1];
  g = G + 1 | 0;
  b = g & 65535;
  f = b >>> 0 < f >>> 0 ? f : b;
  while (1) if ((b | 0) == (f | 0)) {
   t[c + 13 | 0] = w[e + 57 | 0] >>> 4;
   b = w[c + 12 | 0];
   t[e + 12 | 0] = 0;
   b = (b | 0) != 0;
   C = kw(e + 44 | 0, g, e + 12 | 0);
   d: while (1) {
    if ((l | 0) == (F | 0)) {
     ec(C);
     break c;
    }
    e: {
     f: {
      g = wb(v[C >> 2], 0);
      f = w[g | 0];
      g: {
       if (!f) {
        v[31601] = 0;
        g = Q(197, a | 0) | 0;
        f = v[31601];
        v[31601] = 0;
        if ((f | 0) == 1) {
         break e;
        }
        h = g << 24 >> 24;
        if ((h | 0) < 0) {
         v[31601] = 0;
         g = Q(197, a | 0) | 0;
         f = v[31601];
         v[31601] = 0;
         if ((f | 0) == 1) {
          break e;
         }
         H = wb(v[C >> 2], 0), I = g, t[H | 0] = I;
        }
        t[e + 12 | 0] = 0;
        h: {
         i: {
          g = h & 63;
          if (!g) {
           break i;
          }
          v[31601] = 0;
          k = Q(197, a | 0) | 0;
          f = v[31601];
          v[31601] = 0;
          if ((f | 0) == 1) {
           break h;
          }
          t[e + 12 | 0] = k;
          j: {
           k: {
            switch (g - 1 | 0) {
            case 0:
             t[c + 12 | 0] = 0;
             t[e + 40 | 0] = 1;
             H = c, I = w[cf(e + 40 | 0, e + 12 | 0) | 0], t[H + 14 | 0] = I;
             t[c + 15 | 0] = 0;
             break j;

            case 1:
             if (!k) {
              break i;
             }
             t[c + 15 | 0] = k;
             t[c + 12 | 0] = 1;
             b = w[c + 13 | 0];
             if (!b) {
              break j;
             }
             t[c + 14 | 0] = B(B(b, k), 15);
             break j;

            case 2:
             t[c + 13 | 0] = k >>> 4;
             if (k >>> 0 >= 16) {
              b = w[c + 12 | 0];
              k = 0;
              v[e + 40 >> 2] = 0;
              v[e + 36 >> 2] = 0;
              z = 0;
              if (b) {
               break g;
              }
              break f;
             }
             k = 0;
             t[c + 12 | 0] = 0;
             v[e + 40 >> 2] = 0;
             v[e + 36 >> 2] = 0;
             z = 0;
             if (b & 1) {
              break g;
             }
             break f;

            case 3:
             z = 0;
             v[e + 40 >> 2] = 0;
             v[e + 36 >> 2] = 0;
             if (b & 1) {
              break g;
             }
             break f;

            case 5:
             if (!k) {
              break i;
             }
             b = (w[c + 12 | 0] ? 15 : 14) + c | 0;
             f = w[b | 0];
             t[b | 0] = f >>> 0 >= 256 - k >>> 0 ? -1 : f + k | 0;
             break j;

            case 6:
             break k;

            default:
             break i;
            }
           }
           if (!k) {
            break i;
           }
           b = (w[c + 12 | 0] ? 15 : 14) + c | 0;
           f = w[b | 0];
           t[b | 0] = f >>> 0 <= k + 1 >>> 0 ? 1 : f - k | 0;
          }
          k = 0;
          v[e + 40 >> 2] = 0;
          v[e + 36 >> 2] = 0;
          break g;
         }
         k = 0;
         v[e + 40 >> 2] = 0;
         v[e + 36 >> 2] = 0;
         z = 0;
         if (b & 1) {
          break g;
         }
         break f;
        }
        break e;
       }
       t[g | 0] = f - 1;
       k = 0;
       v[e + 40 >> 2] = 0;
       v[e + 36 >> 2] = 0;
       z = 0;
       if (!(b & 1)) {
        break f;
       }
      }
      f = w[c + 13 | 0];
      b = w[c + 12 | 0];
      if (b) {
       z = 0;
       if (!f) {
        break f;
       }
      }
      l: {
       if (b) {
        v[e + 12 >> 2] = 1;
        v[e + 32 >> 2] = B(f, w[c + 15 | 0]) << 1;
        f = v[Ye(e + 12 | 0, e + 32 | 0) >> 2];
        break l;
       }
       f = B(w[c + 14 | 0], 30) + 30 | 0;
      }
      b = 255;
      g = 0;
      s = 0;
      while (1) {
       m: {
        if (b) {
         h = B(b, f);
         s = (h | 0) / 48 | 0;
         if (h - 1536 >>> 0 >= 10752) {
          break m;
         }
         g = b;
        }
        v[e + 36 >> 2] = s;
        v[e + 40 >> 2] = g;
        Fe(e + 36 | 0, 32, 255);
        z = 1;
        v[e + 12 >> 2] = 1;
        H = c, I = v[Ye(e + 12 | 0, e + 40 | 0) >> 2], t[H + 16 | 0] = I;
        break f;
       }
       b = b - 1 | 0;
       continue;
      }
     }
     D = l - 1 | 0;
     E = 1;
     b = Vb(v[y >> 2], q);
     b = ld(v[b >> 2], v[v[b + 48 >> 2] + 12 >> 2], l, 1);
     while (1) {
      i = E & 65535;
      if (i >>> 0 > G >>> 0) {
       if (z) {
        b = e + 12 | 0;
        ze(Vb(v[y >> 2], q), Uh(ip(We(Ne(b, 17, w[e + 36 | 0]), l), 0)));
        ze(Vb(v[y >> 2], q), Uh(We(Ne(b, 16, w[e + 40 | 0]), l)));
       }
       if (k >>> 0 >= 16) {
        ze(Vb(v[y >> 2], q), z$(We(Ne(e + 12 | 0, 20, k >>> 4 | 224), l)));
       }
       b = k & 15;
       if (b) {
        ze(Vb(v[y >> 2], q), z$(We(Ne(e + 12 | 0, 20, Kd((B(b, w[c + 16 | 0]) >>> 0) / 15 & 255, 1, 15) | 96), l)));
       }
       l = l + 1 | 0;
       b = 0;
       continue d;
      }
      n: {
       o: {
        p: {
         q: {
          g = wb(v[C >> 2], i);
          f = w[g | 0];
          if (!f) {
           v[31601] = 0;
           g = Q(197, a | 0) | 0;
           f = v[31601];
           v[31601] = 0;
           if ((f | 0) == 1) {
            break e;
           }
           h = g << 24 >> 24;
           if ((h | 0) < 0) {
            v[31601] = 0;
            g = Q(197, a | 0) | 0;
            f = v[31601];
            v[31601] = 0;
            if ((f | 0) == 1) {
             break e;
            }
            H = wb(v[C >> 2], i), I = g, t[H | 0] = I;
           }
           s = 1;
           m = h & 255;
           if (m & 64) {
            v[31601] = 0;
            g = Q(197, a | 0) | 0;
            f = v[31601];
            v[31601] = 0;
            if ((f | 0) == 1) {
             break e;
            }
            t[b + 1 | 0] = g;
            s = !g;
           }
           if (!(m & 32)) {
            g = w[b | 0];
            break q;
           }
           v[31601] = 0;
           g = Q(197, a | 0) | 0;
           f = v[31601];
           v[31601] = 0;
           if ((f | 0) == 1) {
            break e;
           }
           t[b | 0] = g;
           if ((g - 1 & 255) >>> 0 <= 107) {
            g = gp(g + 24 & 255);
            t[b | 0] = g;
            H = Xc(v[c >> 2], i), I = g, t[H + 1 | 0] = I;
            break q;
           }
           if ((g + 127 & 255) >>> 0 <= 107) {
            f = gp((g & 127) + 24 | 0);
            H = Xc(v[c >> 2], i), I = f, t[H | 0] = I;
            t[b | 0] = 0;
            break p;
           }
           if ((g | 0) != 255) {
            break q;
           }
           t[b | 0] = 254;
           break o;
          }
          t[g | 0] = f - 1;
          break n;
         }
         if (g & 255) {
          break o;
         }
        }
        if (!w[b + 1 | 0]) {
         break o;
        }
        f = w[Xc(v[c >> 2], i) + 1 | 0];
        t[b + 1 | 0] = 0;
        t[b | 0] = f;
       }
       if (Tc(w[b | 0])) {
        H = Xc(v[c >> 2], i), I = 0, t[H + 5 | 0] = I;
       }
       t[e + 31 | 0] = 0;
       t[e + 30 | 0] = 0;
       if (m & 16) {
        t[b + 2 | 0] = 1;
        v[31601] = 0;
        g = Q(197, a | 0) | 0;
        f = v[31601];
        v[31601] = 0;
        if ((f | 0) == 1) {
         break e;
        }
        t[b + 4 | 0] = g + 2 >>> 2;
       }
       g = 0;
       r = 0;
       A = 0;
       r: {
        if (!(m & 8)) {
         break r;
        }
        v[31601] = 0;
        h = Q(197, a | 0) | 0;
        f = v[31601];
        v[31601] = 0;
        if ((f | 0) == 1) {
         break e;
        }
        v[31601] = 0;
        A = Q(197, a | 0) | 0;
        f = v[31601];
        v[31601] = 0;
        if ((f | 0) == 1) {
         break e;
        }
        s: {
         switch (h - 1 | 0) {
         case 0:
          t[b | 0] = 254;
          break r;

         case 1:
          t[b | 0] = 255;
          break r;

         case 2:
          f = Xc(v[c >> 2], i);
          t[b | 0] = w[f + 1 | 0];
          t[f + 5 | 0] = 0;
          break r;

         case 3:
          f = jw(A, w[c + 16 | 0]);
          A = f ? f | -48 : 0;
          r = f ? 20 : 0;
          if (w[b | 0]) {
           break r;
          }
          f = Xc(v[c >> 2], i);
          t[b | 0] = w[f + 1 | 0];
          t[f + 5 | 0] = 0;
          break r;

         case 4:
          t[e + 12 | 0] = 1;
          H = e, I = jw(A, w[c + 16 | 0]), t[H + 32 | 0] = I;
          A = w[cf(e + 12 | 0, e + 32 | 0) | 0];
          H = Xc(v[c >> 2], i), I = 0, t[H + 5 | 0] = I;
          r = 15;
          break r;

         case 5:
         case 6:
         case 7:
         case 8:
          r = v[c >> 2];
          t: {
           if (!l) {
            break t;
           }
           if ((h | 0) == w[Xc(r, i) + 4 | 0]) {
            break t;
           }
           f = ze(Vb(v[y >> 2], q), zn(ip(We(Ne(e + 12 | 0, 20, (h + 122 | 160) & 255), D), i)));
           r = v[c >> 2];
           if (!f) {
            break t;
           }
           H = Xc(r, i), I = h, t[H + 4 | 0] = I;
          }
          f = Xc(r, i);
          if (!w[b | 0]) {
           t[b | 0] = w[f + 1 | 0];
          }
          t[f + 5 | 0] = 0;
          r = 10;
          break r;

         case 9:
          break s;

         default:
          break r;
         }
        }
        f = Xc(v[c >> 2], i);
        h = w[f + 5 | 0];
        t[f + 5 | 0] = h ^ 1;
        A = h ? -98 : -97;
        r = 20;
       }
       u: {
        v: {
         w: {
          if (!(m & 4)) {
           break w;
          }
          v[31601] = 0;
          n = Q(197, a | 0) | 0;
          f = v[31601];
          v[31601] = 0;
          if ((f | 0) == 1) {
           break e;
          }
          v[31601] = 0;
          j = Q(197, a | 0) | 0;
          f = v[31601];
          v[31601] = 0;
          if ((f | 0) == 1) {
           break e;
          }
          t[e + 31 | 0] = j;
          h = 1;
          g = 1;
          x: {
           switch (n - 1 | 0) {
           case 0:
            hE(e + 12 | 0, j << 24 >> 24 << 3, 128);
            f = w[b | 0];
            if (Tc(f)) {
             H = b, I = gp(f + v[e + 12 >> 2] | 0), t[H | 0] = I;
            }
            t[e + 31 | 0] = w[e + 16 | 0] ^ 128;
            g = 35;
            break w;

           case 1:
            f = jw(j, w[c + 16 | 0]);
            t[e + 31 | 0] = f;
            if (!f) {
             break v;
            }
            t[e + 31 | 0] = f | 208;
            g = 20;
            break u;

           case 3:
           case 4:
            H = e, I = y$(j, w[c + 16 | 0], 1), t[H + 31 | 0] = I;
            g = (n | 0) == 4 ? 2 : 3;
            break u;

           case 5:
            if (!w[b | 0]) {
             H = b, I = w[Xc(v[c >> 2], i) | 0], t[H | 0] = I;
            }
            H = e, I = y$(j, w[c + 16 | 0], 0), t[H + 31 | 0] = I;
            g = 4;
            break u;

           case 6:
            H = b, I = gp(j + 25 | 0), t[H | 0] = I;
            t[e + 31 | 0] = 255;
            g = 4;
            break u;

           case 7:
           case 8:
           case 9:
            y: {
             if (!l) {
              break y;
             }
             if ((n | 0) == w[Xc(v[c >> 2], i) + 2 | 0]) {
              break y;
             }
             if (!ze(Vb(v[y >> 2], q), zn(ip(We(Ne(e + 12 | 0, 20, (n - 8 | 48) & 255), D), i)))) {
              break y;
             }
             H = Xc(v[c >> 2], i), I = n, t[H + 2 | 0] = I;
            }
            H = e, I = gE(j, w[c + 16 | 0]), t[H + 31 | 0] = I;
            g = 5;
            break u;

           case 10:
            H = e, I = x$(j, w[c + 16 | 0]), t[H + 31 | 0] = I;
            g = 18;
            break u;

           case 11:
            f = jw(j, w[c + 16 | 0]);
            t[e + 31 | 0] = f;
            if (f) {
             t[e + 31 | 0] = f | 192;
             g = 20;
             break u;
            }
            t[b | 0] = 254;
            break v;

           case 2:
            break u;

           default:
            break x;
           }
          }
          g = 0;
         }
         h = 0;
         break u;
        }
        g = 0;
       }
       o = 0;
       f = 1;
       z: {
        if (m & 2) {
         v[31601] = 0;
         m = Q(197, a | 0) | 0;
         f = v[31601];
         v[31601] = 0;
         if ((f | 0) == 1) {
          break e;
         }
         v[31601] = 0;
         n = Q(197, a | 0) | 0;
         f = v[31601];
         v[31601] = 0;
         if ((f | 0) == 1) {
          break e;
         }
         t[e + 30 | 0] = n;
         o = 9;
         f = 0;
         j = 0;
         A: {
          switch (m - 1 | 0) {
          case 0:
          case 1:
           j = 1;
           H = e, I = w$(n, w[c + 16 | 0], (m | 0) == 1), t[H + 30 | 0] = I;
           o = 11;
           break z;

          case 2:
           H = e, I = x$(n, w[c + 16 | 0]), t[H + 30 | 0] = I;
           j = 1;
           o = 18;
           break z;

          case 3:
          case 4:
          case 5:
           B: {
            if (!l) {
             break B;
            }
            if ((m | 0) == w[Xc(v[c >> 2], i) + 3 | 0]) {
             break B;
            }
            if (!ze(Vb(v[y >> 2], q), zn(ip(We(Ne(e + 12 | 0, 20, (m - 4 | 64) & 255), D), i)))) {
             break B;
            }
            H = Xc(v[c >> 2], i), I = m, t[H + 3 | 0] = I;
           }
           H = e, I = gE(n, w[c + 16 | 0]), t[H + 30 | 0] = I;
           j = 1;
           o = 8;
           break z;

          case 7:
          case 8:
           H = e, I = w$(n, w[c + 16 | 0], (m | 0) == 8), t[H + 30 | 0] = I;
           j = 1;
           o = 29;
           break z;

          case 9:
           H = e, I = gE(n, w[c + 16 | 0]), t[H + 30 | 0] = I;
           j = 1;
           o = 27;
           break z;

          case 6:
           break z;

          default:
           break A;
          }
         }
         o = 0;
         f = 1;
        }
        j = 0;
       }
       if (h) {
        v$(b, l, x[d + 480188 >> 1], g, e + 31 | 0);
       }
       if (j) {
        v$(b, l, x[d + 480188 >> 1], o, e + 30 | 0);
       }
       C: {
        D: {
         E: {
          F: {
           G: {
            if (!s) {
             break G;
            }
            if (!Tc(w[b | 0])) {
             break G;
            }
            if (!g) {
             break F;
            }
            if (!f | (g | 0) == 4) {
             break G;
            }
            t[e + 30 | 0] = 255;
            o = 4;
           }
           j = b + 2 | 0;
           if (w[b + 2 | 0] != 1) {
            break C;
           }
           if (g) {
            break E;
           }
           t[e + 31 | 0] = w[b + 4 | 0];
           g = 13;
           break D;
          }
          t[e + 31 | 0] = 255;
          j = b + 2 | 0;
          g = 4;
          if (w[b + 2 | 0] != 1) {
           break C;
          }
         }
         if (o) {
          break C;
         }
         t[e + 30 | 0] = w[b + 4 | 0];
         o = 13;
        }
        t[j | 0] = 0;
       }
       h = Mg(e + 12 | 0);
       cm(e + 32 | 0, h, g, w[e + 31 | 0], o, w[e + 30 | 0]);
       H: {
        if (w[j | 0]) {
         break H;
        }
        f = w[e + 14 | 0];
        if (!f) {
         break H;
        }
        t[b + 2 | 0] = f;
        t[b + 4 | 0] = w[e + 16 | 0];
       }
       s = w[e + 15 | 0];
       I: {
        if (r) {
         cm(e + 32 | 0, h, s & 255, w[e + 17 | 0], r, A & 255);
         J: {
          if (w[j | 0]) {
           break J;
          }
          f = w[e + 14 | 0];
          if (!f) {
           break J;
          }
          t[b + 2 | 0] = f;
          t[b + 4 | 0] = w[e + 16 | 0];
         }
         s = w[e + 15 | 0];
         break I;
        }
        if (!(s & 255)) {
         break n;
        }
       }
       t[b + 3 | 0] = s;
       t[b + 5 | 0] = w[e + 17 | 0];
      }
      b = b + 6 | 0;
      E = E + 1 | 0;
      continue;
     }
    }
    break;
   }
   a = M() | 0;
   ec(C);
   P(a | 0);
   p();
  } else {
   t[h + B(b, 6) | 0] = 254;
   b = b + 1 | 0;
   continue;
  }
 }
 eb = e - -64 | 0;
 return q | 0;
}

function aoa(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
 d = eb - 176 | 0;
 eb = d;
 xc(c);
 a: {
  b: {
   c: {
    d: {
     e: {
      f: {
       g: {
        h: {
         i: {
          j: {
           k: {
            l: {
             if (!fp(c, d + 164 | 0) | (w[d + 164 | 0] | w[d + 165 | 0] << 8 | (w[d + 166 | 0] << 16 | w[d + 167 | 0] << 24)) != 1297239878) {
              break l;
             }
             f = w[d + 172 | 0] | w[d + 173 | 0] << 8 | (w[d + 174 | 0] << 16 | w[d + 175 | 0] << 24);
             if ((f | 0) != 1179011393 & (f | 0) != 1128679745) {
              break l;
             }
             e = eb - 32 | 0;
             eb = e;
             h = d + 152 | 0;
             f = Mb(h);
             m: {
              n: {
               o: {
                p: {
                 q: {
                  while (1) {
                   g = v[c + 8 >> 2];
                   i = v[c >> 2];
                   v[31601] = 0;
                   g = T(150, i | 0, g | 0, 8) | 0;
                   i = v[31601];
                   v[31601] = 0;
                   if ((i | 0) == 1) {
                    break o;
                   }
                   if (!g) {
                    break p;
                   }
                   v[31601] = 0;
                   g = e + 4 | 0;
                   N(824, g | 0, c | 0);
                   i = v[31601];
                   v[31601] = 0;
                   if ((i | 0) != 1) {
                    v[31601] = 0;
                    N(825, f | 0, g | 0);
                    i = v[31601];
                    v[31601] = 0;
                    if ((i | 0) == 1) {
                     break q;
                    }
                    Gd(g);
                    continue;
                   }
                   break;
                  }
                  a = M() | 0;
                  break n;
                 }
                 a = M() | 0;
                 Gd(e + 4 | 0);
                 break n;
                }
                eb = e + 32 | 0;
                break m;
               }
               a = M() | 0;
              }
              je(f);
              P(a | 0);
              p();
             }
             v[31601] = 0;
             e = d + 132 | 0;
             R(746, e | 0, h | 0, 1129270605);
             c = v[31601];
             v[31601] = 0;
             if ((c | 0) == 1) {
              break f;
             }
             v[31601] = 0;
             c = O(747, e | 0, d + 114 | 0) | 0;
             f = v[31601];
             v[31601] = 0;
             if ((f | 0) == 1) {
              break i;
             }
             r: {
              if (!c) {
               break r;
              }
              if (!_b(x[d + 116 >> 1] | x[d + 118 >> 1] << 16)) {
               break r;
              }
              if ((Ab(x[d + 114 >> 1]) - 3 & 65535) >>> 0 < 65534) {
               break r;
              }
              if ((Ab(x[d + 120 >> 1]) - 65 & 65535) >>> 0 < 65472) {
               break r;
              }
              t[d + 110 | 0] = 78;
              t[d + 111 | 0] = 79;
              t[d + 112 | 0] = 78;
              t[d + 113 | 0] = 69;
              c = 1;
              if ((w[d + 172 | 0] | w[d + 173 | 0] << 8 | (w[d + 174 | 0] << 16 | w[d + 175 | 0] << 24)) == 1128679745) {
               v[31601] = 0;
               c = O(627, e | 0, d + 110 | 0) | 0;
               e = v[31601];
               v[31601] = 0;
               if ((e | 0) == 1) {
                break h;
               }
               if (!c) {
                break r;
               }
               c = (w[d + 110 | 0] | w[d + 111 | 0] << 8 | (w[d + 112 | 0] << 16 | w[d + 113 | 0] << 24)) != 1936684916;
              }
              v[31601] = 0;
              e = d + 88 | 0;
              R(746, e | 0, d + 152 | 0, 1397968452);
              f = v[31601];
              v[31601] = 0;
              s: {
               t: {
                u: {
                 if ((f | 0) != 1) {
                  v[31601] = 0;
                  l = O(748, e | 0, d + 80 | 0) | 0;
                  e = v[31601];
                  v[31601] = 0;
                  if ((e | 0) == 1) {
                   break j;
                  }
                  if (!l) {
                   break s;
                  }
                  f = (Ab(x[d + 120 >> 1]) - 1 | 0) / 8 | 0;
                  g = f << 3;
                  e = g & 31;
                  h = d + 76 | 0;
                  if ((g & 63) >>> 0 >= 32) {
                   e = 1074268168 >>> e | 0;
                  } else {
                   e = ((1 << e) - 1 & 1074268168) << 32 - e | 538447880 >>> e;
                  }
                  h = Yc(h, (f >>> 0 >= 8 ? 8 : e) & 120, (Ab(x[d + 114 >> 1]) | 0) == 2 ? 2 : 1, c, 0);
                  c = w[d + 110 | 0] | w[d + 111 | 0] << 8 | (w[d + 112 | 0] << 16 | w[d + 113 | 0] << 24);
                  if (!((c | 0) == 842230886 | (c | 0) == 842222662 | (c | 0) == 875981926)) {
                   if ((c | 0) != 875973702) {
                    break u;
                   }
                  }
                  vg(h, 3);
                  break t;
                 }
                 c = M() | 0;
                 break b;
                }
                c = w[d + 110 | 0] | w[d + 111 | 0] << 8 | (w[d + 112 | 0] << 16 | w[d + 113 | 0] << 24);
                if (!((c | 0) != 2002873441 & (c | 0) != 1463897153)) {
                 vg(h, 17);
                 gd(h, 16);
                 break t;
                }
                c = w[d + 110 | 0] | w[d + 111 | 0] << 8 | (w[d + 112 | 0] << 16 | w[d + 113 | 0] << 24);
                if (!((c | 0) != 2002873461 & (c | 0) != 1463897173)) {
                 vg(h, 16);
                 gd(h, 16);
                 break t;
                }
                if ((w[d + 110 | 0] | w[d + 111 | 0] << 8 | (w[d + 112 | 0] << 16 | w[d + 113 | 0] << 24)) != 544694642) {
                 break t;
                }
                vg(h, 1);
               }
               c = v[d + 80 >> 2];
               v[31601] = 0;
               c = T(150, v[d + 88 >> 2], v[d + 96 >> 2], _b(c) | 0) | 0;
               e = v[31601];
               v[31601] = 0;
               if ((e | 0) == 1) {
                break d;
               }
               if (c) {
                c = v[d + 80 >> 2];
                v[31601] = 0;
                O(183, d + 88 | 0, _b(c) | 0) | 0;
                c = v[31601];
                v[31601] = 0;
                if ((c | 0) == 1) {
                 break d;
                }
               }
               Wu(a, b);
               v[31601] = 0;
               g = (B(b, 104) + a | 0) + 484380 | 0;
               N(279, g | 0, 0);
               c = v[31601];
               v[31601] = 0;
               v: {
                w: {
                 x: {
                  y: {
                   z: {
                    A: {
                     B: {
                      C: {
                       D: {
                        E: {
                         if ((c | 0) == 1) {
                          break E;
                         }
                         n = g, o = _b(x[d + 116 >> 1] | x[d + 118 >> 1] << 16), v[n >> 2] = o;
                         c = w[d + 124 | 0] | w[d + 125 | 0] << 8 | (w[d + 126 | 0] << 16 | w[d + 127 | 0] << 24);
                         f = c << 24 | (c & 65280) << 8 | (c >>> 8 & 65280 | c >>> 24);
                         i = 30 - w[d + 123 | 0] | 0;
                         e = 0;
                         while (1) {
                          c = f;
                          if (i & 255) {
                           f = c >>> 1 | 0;
                           i = i - 1 | 0;
                           e = c;
                           continue;
                          }
                          break;
                         }
                         v[g + 24 >> 2] = c + (e & 1);
                         v[31601] = 0;
                         T(215, h | 0, g | 0, d + 88 | 0) | 0;
                         c = v[31601];
                         v[31601] = 0;
                         if ((c | 0) == 1) {
                          break E;
                         }
                         v[31601] = 0;
                         e = d + 56 | 0;
                         f = d + 152 | 0;
                         R(746, e | 0, f | 0, 1296126539);
                         c = v[31601];
                         v[31601] = 0;
                         if ((c | 0) == 1) {
                          break D;
                         }
                         v[31601] = 0;
                         c = Q(172, v[d + 56 >> 2]) | 0;
                         h = v[31601];
                         v[31601] = 0;
                         if ((h | 0) == 1) {
                          break C;
                         }
                         if (!c) {
                          break v;
                         }
                         v[31601] = 0;
                         c = d + 16 | 0;
                         R(746, c | 0, f | 0, 1229869908);
                         f = v[31601];
                         v[31601] = 0;
                         if ((f | 0) == 1) {
                          break B;
                         }
                         v[31601] = 0;
                         f = O(749, c | 0, d + 36 | 0) | 0;
                         h = v[31601];
                         v[31601] = 0;
                         if ((h | 0) == 1) {
                          break A;
                         }
                         tb(c);
                         if (!f) {
                          break v;
                         }
                         v[31601] = 0;
                         f = Q(273, e | 0) | 0;
                         e = v[31601];
                         v[31601] = 0;
                         if ((e | 0) == 1) {
                          break z;
                         }
                         e = Mb(c);
                         v[31601] = 0;
                         N(750, e | 0, f | 0);
                         c = v[31601];
                         v[31601] = 0;
                         if ((c | 0) == 1) {
                          break x;
                         }
                         c = 0;
                         while (1) {
                          if ((c | 0) == (f | 0)) {
                           break y;
                          }
                          v[31601] = 0;
                          h = d + 56 | 0;
                          i = d + 4 | 0;
                          j = O(751, h | 0, i | 0) | 0;
                          k = v[31601];
                          v[31601] = 0;
                          if ((k | 0) == 1) {
                           break x;
                          }
                          if (!j) {
                           break y;
                          }
                          v[31601] = 0;
                          N(752, e | 0, i | 0);
                          i = v[31601];
                          v[31601] = 0;
                          if ((i | 0) == 1) {
                           break x;
                          }
                          v[31601] = 0;
                          O(183, h | 0, w[d + 10 | 0] | 1) | 0;
                          h = v[31601];
                          v[31601] = 0;
                          if ((h | 0) == 1) {
                           break x;
                          }
                          c = c + 1 | 0;
                          continue;
                         }
                        }
                        c = M() | 0;
                        break c;
                       }
                       c = M() | 0;
                       break c;
                      }
                      c = M() | 0;
                      break e;
                     }
                     c = M() | 0;
                     break e;
                    }
                    c = M() | 0;
                    tb(d + 16 | 0);
                    break e;
                   }
                   c = M() | 0;
                   break e;
                  }
                  c = Ab(w[d + 44 | 0] | w[d + 45 | 0] << 8);
                  if (c) {
                   u[g + 34 >> 1] = x[g + 34 >> 1] & 65511 | ((c | 0) == 2) << 4 | 8;
                  }
                  c = Ab(w[d + 50 | 0] | w[d + 51 | 0] << 8);
                  if (c) {
                   u[g + 34 >> 1] = x[g + 34 >> 1] & 65529 | ((c | 0) == 2 ? 4 : 2) | 2;
                  }
                  n = d, o = vb(v[e >> 2]), v[n + 4 >> 2] = o;
                  h = vb(v[e + 4 >> 2]);
                  i = w[d + 46 | 0] | w[d + 47 | 0] << 8;
                  j = w[d + 48 | 0] | w[d + 49 | 0] << 8;
                  k = w[d + 52 | 0] | w[d + 53 | 0] << 8;
                  m = w[d + 54 | 0] | w[d + 55 | 0] << 8;
                  while (1) {
                   c = v[d + 4 >> 2];
                   if (!Hb(c, h)) {
                    break w;
                   }
                   f = Ab(w[c | 0] | w[c + 1 | 0] << 8);
                   if ((f | 0) == (Ab(i) | 0)) {
                    n = g, o = _b(w[c + 2 | 0] | w[c + 3 | 0] << 8 | (w[c + 4 | 0] << 16 | w[c + 5 | 0] << 24)), 
                    v[n + 12 >> 2] = o;
                    f = Ab(w[c | 0] | w[c + 1 | 0] << 8);
                   }
                   if ((Ab(j) | 0) == (f | 0)) {
                    n = g, o = _b(w[c + 2 | 0] | w[c + 3 | 0] << 8 | (w[c + 4 | 0] << 16 | w[c + 5 | 0] << 24)), 
                    v[n + 16 >> 2] = o;
                    f = Ab(w[c | 0] | w[c + 1 | 0] << 8);
                   }
                   if ((Ab(k) | 0) == (f | 0)) {
                    n = g, o = _b(w[c + 2 | 0] | w[c + 3 | 0] << 8 | (w[c + 4 | 0] << 16 | w[c + 5 | 0] << 24)), 
                    v[n + 4 >> 2] = o;
                    f = Ab(w[c | 0] | w[c + 1 | 0] << 8);
                   }
                   if ((f | 0) == (Ab(m) | 0)) {
                    n = g, o = _b(w[c + 2 | 0] | w[c + 3 | 0] << 8 | (w[c + 4 | 0] << 16 | w[c + 5 | 0] << 24)), 
                    v[n + 8 >> 2] = o;
                   }
                   v[d + 4 >> 2] = v[d + 4 >> 2] + 7;
                   continue;
                  }
                 }
                 c = M() | 0;
                 JT(e);
                 break e;
                }
                Sk(g);
                JT(e);
               }
               v[31601] = 0;
               c = d + 16 | 0;
               R(746, c | 0, d + 152 | 0, 1312902469);
               e = v[31601];
               v[31601] = 0;
               if ((e | 0) == 1) {
                break g;
               }
               v[31601] = 0;
               e = Q(172, v[d + 16 >> 2]) | 0;
               f = v[31601];
               v[31601] = 0;
               if ((f | 0) == 1) {
                break k;
               }
               F: {
                if (e) {
                 v[31601] = 0;
                 e = Q(154, v[d + 16 >> 2]) | 0;
                 f = v[31601];
                 v[31601] = 0;
                 if ((f | 0) == 1) {
                  break k;
                 }
                 v[31601] = 0;
                 R(317, c | 0, ((b << 5) + a | 0) + 946304 | 0, e | 0);
                 b = v[31601];
                 v[31601] = 0;
                 if ((b | 0) != 1) {
                  break F;
                 }
                 break k;
                }
                v[31601] = 0;
                c = O(36, d + 4 | 0, 22256) | 0;
                e = v[31601];
                v[31601] = 0;
                if ((e | 0) == 1) {
                 break k;
                }
                zc(((b << 5) + a | 0) + 946304 | 0, c);
                sb(c);
               }
               fC(g, v[a + 480180 >> 2]);
               Hj(g, a);
               tb(d + 16 | 0);
               tb(d + 56 | 0);
              }
              tb(d + 88 | 0);
             }
             tb(d + 132 | 0);
             je(d + 152 | 0);
            }
            eb = d + 176 | 0;
            return l | 0;
           }
           c = M() | 0;
           tb(d + 16 | 0);
           break e;
          }
          c = M() | 0;
          break c;
         }
         c = M() | 0;
         break b;
        }
        c = M() | 0;
        break b;
       }
       c = M() | 0;
       break e;
      }
      c = M() | 0;
      break a;
     }
     tb(d + 56 | 0);
     break c;
    }
    c = M() | 0;
   }
   tb(d + 88 | 0);
  }
  tb(d + 132 | 0);
 }
 je(d + 152 | 0);
 P(c | 0);
 p();
}

function Vpa(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, q = 0, r = 0, s = 0, z = 0, C = 0, D = 0, E = 0, F = 0, G = 0, H = 0, I = 0, J = 0, K = 0, L = 0, N = 0, Q = 0, S = 0, U = 0, V = 0, W = 0, X = 0, Y = 0, Z = 0, _ = 0, $ = 0, aa = 0, ba = 0, ca = 0;
 e = eb - 368 | 0;
 eb = e;
 a: {
  if (!cd(b, 1080)) {
   break a;
  }
  f = e + 364 | 0;
  if (!kr(b, f)) {
   break a;
  }
  k = _X(e + 344 | 0);
  if (!ZX(f, k)) {
   break a;
  }
  d = x[k + 10 >> 1];
  if (!d | d >>> 0 > 127) {
   break a;
  }
  S = 1;
  if ((c | 0) == 64) {
   break a;
  }
  U = 1;
  Cd(a, 1);
  h = x[k + 10 >> 1];
  u[a + 480188 >> 1] = h;
  J = w[k + 14 | 0];
  V = w[k + 13 | 0];
  i = w[k + 12 | 0];
  if (!ne(f, 25242)) {
   U = ne(f, 25247);
  }
  if (w[k + 15 | 0]) {
   Kb(a + 1074312 | 0, 5, 1);
   h = x[a + 480188 >> 1];
  }
  d = e + 364 | 0;
  o = ne(d, 16744);
  m = 1;
  if (!ne(d, 17506)) {
   m = ne(d, 13686);
  }
  D = a + 480188 | 0;
  E = (h & 65535) == 8 & (V | 0) != 0;
  cd(b, 0);
  d = w[k + 16 | 0];
  h = eb - 16 | 0;
  eb = h;
  b: {
   g = e + 324 | 0;
   if (!lx(b, g) | !d) {
    break b;
   }
   jx(h + 8 | 0, g);
   d = 0;
   while (1) {
    if (d >>> 0 >= 20) {
     break b;
    }
    f = v[h + 8 >> 2];
    qg(wb(f, d), wb(f, d | 1));
    d = d + 2 | 0;
    continue;
   }
  }
  eb = h + 16 | 0;
  d = e + 312 | 0;
  bf(d, g, 20, 3);
  f = e + 180 | 0;
  Bc(f, d);
  yb(a + 1298308 | 0, f);
  sb(f);
  u[a + 480190 >> 1] = 31;
  l = a + 946304 | 0;
  Y = a + 484380 | 0;
  s = (i | 0) != 0;
  h = 1;
  f = 0;
  g = o;
  while (1) {
   if ((h | 0) == 32) {
    S = y[k + 4 >> 2] >= f >>> 0;
    if (!S) {
     break a;
    }
   } else {
    d = w[k + 16 | 0];
    z = eb - 16 | 0;
    eb = z;
    c: {
     q = e + 180 | 0;
     if (!SX(b, q) | !d) {
      break c;
     }
     Hv(z + 8 | 0, q);
     d = 0;
     while (1) {
      if (d >>> 0 >= 30) {
       break c;
      }
      i = v[z + 8 >> 2];
      qg(wb(i, d), wb(i, d | 1));
      d = d + 2 | 0;
      continue;
     }
    }
    eb = z + 16 | 0;
    d = B(h, 104) + Y | 0;
    i = ZC(q, d, l + (h << 5) | 0, x[D >> 1] == 4);
    z = v[d >> 2];
    d: {
     if (m) {
      t[d + 37 | 0] = 0 - (w[e + 204 | 0] << 3);
      break d;
     }
     s = z >>> 0 < 65536 & s;
    }
    q = Ab(w[e + 202 | 0] | w[e + 203 | 0] << 8);
    e: {
     if (q) {
      Z = !Ab(w[e + 208 | 0] | w[e + 209 | 0] << 8) | Z;
      break e;
     }
     _ = w[e + 205 | 0] == 64 | _;
    }
    d = g & 1;
    g = 0;
    f: {
     if (!d) {
      break f;
     }
     n = (q << 1) + n | 0;
     d = w[e + 204 | 0];
     g = !d;
     if (d | !q) {
      break f;
     }
     g = w[e + 205 | 0] == 64;
    }
    f = f + i | 0;
    j = j + z | 0;
    h = h + 1 | 0;
    continue;
   }
   break;
  }
  f = w[k + 16 | 0];
  i = eb - 16 | 0;
  eb = i;
  g: {
   d = e + 180 | 0;
   if (!SC(b, d) | !f) {
    break g;
   }
   XC(i + 8 | 0, d);
   d = 0;
   while (1) {
    if (d >>> 0 >= 130) {
     break g;
    }
    f = v[i + 8 >> 2];
    qg(wb(f, d), wb(f, d | 1));
    d = d + 2 | 0;
    continue;
   }
  }
  eb = i + 16 | 0;
  cd(b, x[k + 8 >> 1]);
  f = w[e + 181 | 0];
  d = 128;
  ow(Wb(v[a + 484360 >> 2], w[a + 484376 | 0]), e + 182 | 0, 128);
  l = !f & g;
  g = l ? n : 0;
  i = w[e + 180 | 0];
  h: {
   if (i >>> 0 >= 129) {
    n = w[a + 484376 | 0];
    f = v[a + 484360 >> 2];
    break h;
   }
   n = w[a + 484376 | 0];
   f = v[a + 484360 >> 2];
   if (i) {
    d = i;
    break h;
   }
   i = v[Wb(f, n) >> 2];
   h = 128;
   while (1) {
    d = h;
    if (d >>> 0 < 2) {
     d = 1;
     break h;
    }
    h = d - 1 | 0;
    if (!x[$b(i, h) >> 1]) {
     continue;
    }
    break;
   }
  }
  q = XX(b, Wb(f, n), d & 65535, j, D, g, 0);
  K = 1;
  i: {
   if (!(l & x[D >> 1] == 8)) {
    K = (J | 0) != 0;
    break i;
   }
   v[k >> 2] = 11263;
  }
  j: {
   if (!E) {
    break j;
   }
   f = Wb(v[a + 484360 >> 2], w[a + 484376 | 0]);
   ba = e, ca = vb(v[f >> 2]), v[ba + 312 >> 2] = ca;
   f = vb(v[f + 4 >> 2]);
   while (1) {
    j = v[e + 312 >> 2];
    if (!Hb(j, f)) {
     break j;
    }
    u[j >> 1] = x[j >> 1] >>> 1;
    fe(e + 312 | 0);
    continue;
   }
  }
  $e(Wb(v[a + 484360 >> 2], w[a + 484376 | 0]), w[e + 181 | 0]);
  J = d - 1 | 0;
  d = w[e + 181 | 0];
  k: {
   if ((J & 65535) >>> 0 >= d >>> 0) {
    h = x[D >> 1];
    if ((d | 0) != 120 | (h | 0) != 4) {
     break k;
    }
   }
   $e(Wb(v[a + 484360 >> 2], w[a + 484376 | 0]), 0);
   h = x[a + 480188 >> 1];
  }
  v[a + 480260 >> 2] = 56;
  v[a + 480264 >> 2] = 13696;
  v[a + 480204 >> 2] = 125e4;
  v[a + 480196 >> 2] = 6;
  v[a + 480208 >> 2] = 0;
  ba = a, ca = Xb(256 / ((h & 65535) >>> 0) | 0, 32, 128), v[ba + 480228 >> 2] = ca;
  Th(a, 0);
  t[e + 179 | 0] = 0;
  l: {
   if (s & 1) {
    F = 1;
    i = 1;
    break l;
   }
   F = 1;
   m = 0;
   s = 0;
   j = o;
   m: while (1) {
    i = s & 65535;
    if (i >>> 0 < q >>> 0) {
     C = 0;
     h = 0;
     while (1) if ((h | 0) == 256) {
      s = s + 1 | 0;
      continue m;
     } else {
      f = Mg(e + 312 | 0);
      WX(e + 160 | 0, b, !i & w[k + 16 | 0] != 0);
      d = v[e + 160 >> 2];
      v[e + 172 >> 2] = d;
      v[e + 64 >> 2] = d;
      d = e + 92 | 0;
      dp(d, e - -64 | 0, f);
      d = Ic(d);
      g = PD(w[f | 0]);
      n: {
       o: {
        p: {
         q: {
          l = w[e + 92 | 0];
          if ((l - 7 & 255) >>> 0 < 3) {
           j = 0;
           break q;
          }
          f = w[d | 0];
          if (!((l | 0) != 14 | f >>> 0 <= 1)) {
           j = 0;
           break p;
          }
          if (!((l | 0) != 15 | (f & 255) >>> 0 <= 31)) {
           j = 0;
           break n;
          }
          j = g ? j : 0;
          if ((l | 0) != 13) {
           break q;
          }
          C = C + 1 | 0;
          j = (C & 65535) >>> 0 <= 1 ? j : 0;
          break n;
         }
         if ((l | 0) == 8) {
          break o;
         }
         if ((l | 0) != 14) {
          break n;
         }
         f = w[d | 0];
        }
        if ((f & 240) != 128) {
         break n;
        }
        t[e + 80 | 0] = f << 4;
        ba = e, ca = w[cf(e + 179 | 0, e + 80 | 0) | 0], t[ba + 179 | 0] = ca;
        break n;
       }
       ba = e, ca = w[cf(e + 179 | 0, d) | 0], t[ba + 179 | 0] = ca;
       d = t[d | 0];
       if ((d | 0) >= 0) {
        G = 1;
        break n;
       }
       m = (d | 0) != -92 & d >>> 0 > 4294967183 | m;
      }
      F = g & F;
      h = h + 1 | 0;
      continue;
     }
    }
    break;
   }
   d = G ^ -1;
   G = 0;
   G = (d | m) & 1 ? G : w[e + 179 | 0] > 47;
   i = j & 1;
  }
  cd(b, x[k + 8 >> 1]);
  d = x[a + 480188 >> 1];
  H = a + 484344 | 0;
  s = q + E & 65535;
  Sf(H, s);
  z = E ? 4 : d;
  I = a + 1074312 | 0;
  l = c & 1;
  m = 0;
  j = 0;
  C = 0;
  r: {
   s: {
    t: {
     u: {
      while (1) {
       if ((m | 0) == (s | 0)) {
        break t;
       }
       v: {
        if (E) {
         f = (m & 65534) >>> 1 | 0;
         d = m & 1;
         if (!d) {
          if (!Og(H, f, 64)) {
           break t;
          }
         }
         g = d << 2;
         d = Vb(v[H >> 2], f);
         break v;
        }
        if (!Og(H, m & 65535, 64)) {
         break t;
        }
        g = 0;
        d = Vb(v[H >> 2], m);
       }
       f = 0;
       W = ld(v[d >> 2], v[v[d + 48 >> 2] + 12 >> 2], 0, g);
       if (!l) {
        C = 0;
        L = 0;
        break s;
       }
       d = x[D >> 1];
       t[e + 92 | 0] = 0;
       f = e + 92 | 0;
       N = kw(e + 312 | 0, d, f);
       d = x[D >> 1];
       v[31601] = 0;
       t[e + 92 | 0] = 0;
       Q = T(599, e + 160 | 0, d | 0, f | 0) | 0;
       d = v[31601];
       v[31601] = 0;
       if ((d | 0) != 1) {
        X = 0;
        w: {
         x: while (1) {
          y: {
           if ((X | 0) == 64) {
            break w;
           }
           h = 0;
           f = 0;
           q = 0;
           while (1) {
            if ((h | 0) == (z | 0)) {
             X = X + 1 | 0;
             C = f & q | C;
             W = B(x[D >> 1], 6) + W | 0;
             continue x;
            }
            d = w[k + 16 | 0];
            v[31601] = 0;
            R(600, e + 92 | 0, b | 0, !m & (d | 0) != 0);
            d = v[31601];
            v[31601] = 0;
            if ((d | 0) != 1) {
             d = v[e + 92 >> 2];
             v[e + 156 >> 2] = d;
             v[e + 60 >> 2] = d;
             g = e + 80 | 0;
             r = B(h, 6) + W | 0;
             dp(g, e + 60 | 0, r);
             d = w[e + 80 | 0];
             g = Ic(g);
             n = w[g | 0];
             if (d | n) {
              z: {
               if (!(!V | (d & 255) != 14)) {
                d = 0;
                t[g | 0] = 0;
                t[e + 80 | 0] = 0;
                n = w[g | 0];
                break z;
               }
               if (!V | (d & 255) != 15 | (n & 255) >>> 0 < 32) {
                break z;
               }
               n = 31;
               t[g | 0] = 31;
               d = w[e + 80 | 0];
              }
              Bf(r, d & 255, n & 255);
             }
             d = 1;
             A: {
              B: {
               C: {
                D: {
                 E: {
                  g = w[r + 3 | 0];
                  switch (g - 14 | 0) {
                  case 2:
                   break A;

                  case 0:
                   break D;

                  case 3:
                   break E;

                  default:
                   break C;
                  }
                 }
                 j = w[r + 5 | 0] < 100 | j;
                 q = 1;
                 break B;
                }
                if (!i) {
                 break B;
                }
                t[r + 5 | 0] = 0;
                break B;
               }
               if ((g | 0) == 9 & G) {
                d = w[r + 5 | 0];
                if ((d | 0) == 164) {
                 t[r + 5 | 0] = 145;
                 t[r + 3 | 0] = 20;
                 break B;
                }
                ba = r, ca = Dh(d << 1), t[ba + 5 | 0] = ca;
                break B;
               }
               if ((g | 0) != 19) {
                break B;
               }
               d = w[r + 5 | 0];
               if (d >>> 0 > 15) {
                break B;
               }
               d = !(d & 1);
               g = (d ^ $) & 1;
               $ = g ? d : $;
               L = g + L | 0;
              }
              d = f;
             }
             F: {
              if (!w[r | 0]) {
               g = w[r + 1 | 0];
               if (!g | E) {
                break F;
               }
               f = w[wb(v[N >> 2], h) | 0];
               if (!f | (f | 0) == (g | 0)) {
                break F;
               }
               f = wb(v[Q >> 2], h);
               g = w[f | 0] + 1 | 0;
               t[f | 0] = g;
               if ((g & 255) >>> 0 < 4) {
                break F;
               }
               v[31601] = 0;
               T(266, I | 0, 85, 1) | 0;
               f = v[31601];
               v[31601] = 0;
               if ((f | 0) != 1) {
                break F;
               }
               break y;
              }
              ba = wb(v[Q >> 2], h), ca = 0, t[ba | 0] = ca;
             }
             f = w[r + 1 | 0];
             if (f) {
              ba = wb(v[N >> 2], h), ca = f, t[ba | 0] = ca;
             }
             h = h + 1 | 0;
             f = d;
             continue;
            }
            break;
           }
          }
          break;
         }
         g = M() | 0;
         ec(Q);
         break u;
        }
        ec(Q);
        ec(N);
        m = m + 1 | 0;
        continue;
       }
       break;
      }
      g = M() | 0;
     }
     ec(N);
     break r;
    }
    f = j;
   }
   G: {
    H: {
     I: {
      i = F ^ 1;
      if ((i | Z) & 1) {
       break I;
      }
      d = e + 364 | 0;
      J: {
       if (ne(d, 16744)) {
        break J;
       }
       if (ne(d, 17511)) {
        break J;
       }
       if (!ne(d, 13681)) {
        break I;
       }
      }
      v[a + 480208 >> 2] = v[a + 480208 >> 2] | 2162688;
      d = Kb(Kb(Kb(I, 85, 1), 91, 1), 92, 1);
      K: {
       if (w[e + 179 | 0] > 47) {
        break K;
       }
       d = Kb(d, 84, 1);
       if (w[e + 181 | 0] == 127) {
        break K;
       }
       Kb(d, 83, 1);
      }
      if (!((L | 0) > 6 | K)) {
       break H;
      }
      break G;
     }
     if (!(F & 1)) {
      if (!(o & (w[e + 181 | 0] == 127 & (J & 65535) >>> 0 < 129))) {
       break G;
      }
      v[k >> 2] = 8494;
      break G;
     }
     if ((L | 0) > 6 | K) {
      break G;
     }
    }
    v[a + 480208 >> 2] = v[a + 480208 >> 2] | 8388608;
   }
   if ((o | K) == 1) {
    Kb(I, 89, 1);
   }
   if (U) {
    Kb(I, 84, 1);
   }
   j = 0;
   L: {
    if (!(c & 2)) {
     break L;
    }
    cd(b, x[k + 8 >> 1] + (B(s, z) << 8) | 0);
    g = (i | o ^ 1 | _) & 1;
    h = 1;
    while (1) {
     if ((h | 0) == 32) {
      break L;
     }
     l = B(h, 104) + Y | 0;
     d = v[l >> 2];
     if (d) {
      n = 2;
      if (!U) {
       c = VX(b, 13884);
       n = c ? 10 : 0;
       j = c | j;
       d = v[l >> 2];
      }
      i = Yc(e + 312 | 0, 8, 1, 0, n);
      c = BD(i, d) + v[b + 8 >> 2] | 0;
      if (!g) {
       ba = l, ca = v[ad(l, l + 8 | 0) >> 2], v[ba >> 2] = ca;
      }
      cg(i, l, b);
      cd(b, c);
     }
     h = h + 1 | 0;
     continue;
    }
   }
   M: {
    N: {
     if (!o) {
      if (!((ne(e + 364 | 0, 17511) & f ^ -1 | C) & 1)) {
       break N;
      }
      break M;
     }
     if ((f ^ -1 | C) & 1) {
      break M;
     }
    }
    c = UX(e + 128 | 0, 0);
    b = v[c + 20 >> 2];
    v[e + 48 >> 2] = v[c + 16 >> 2];
    v[e + 52 >> 2] = b;
    b = v[c + 12 >> 2];
    v[e + 40 >> 2] = v[c + 8 >> 2];
    v[e + 44 >> 2] = b;
    b = v[c + 4 >> 2];
    v[e + 32 >> 2] = v[c >> 2];
    v[e + 36 >> 2] = b;
    d = e + 312 | 0;
    Gv(d, a, 0, e + 32 | 0);
    aa = A[v[e + 312 >> 2] >> 3];
    Pi(d);
    if (!(aa >= 480)) {
     break M;
    }
    c = Kb(I, 5, 1);
    f = TX(e + 104 | 0, aa);
    b = v[f + 20 >> 2];
    v[e + 24 >> 2] = v[f + 16 >> 2];
    v[e + 28 >> 2] = b;
    b = v[f + 12 >> 2];
    v[e + 16 >> 2] = v[f + 8 >> 2];
    v[e + 20 >> 2] = b;
    b = v[f + 4 >> 2];
    v[e + 8 >> 2] = v[f >> 2];
    v[e + 12 >> 2] = b;
    Gv(d, a, 0, e + 8 | 0);
    b = w[v[e + 312 >> 2] + 26 | 0];
    Pi(d);
    if (b) {
     ag(c, 5);
     break M;
    }
    v[k >> 2] = 17078;
   }
   f = e + 364 | 0;
   d = f;
   o = fc(d);
   c = d;
   while (1) {
    if ((d | 0) != (o | 0)) {
     b = w[d | 0];
     t[c | 0] = b >>> 0 <= 32 ? 32 : b;
     c = c + 1 | 0;
     d = d + 1 | 0;
     continue;
    }
    break;
   }
   d = e + 92 | 0;
   fg(d, 16831);
   v[31601] = 0;
   o = T(44, e + 68 | 0, f | 0, o | 0) | 0;
   b = v[31601];
   v[31601] = 0;
   O: {
    P: {
     Q: {
      R: {
       S: {
        if ((b | 0) != 1) {
         v[31601] = 0;
         c = e + 80 | 0;
         R(601, c | 0, 1, o | 0);
         b = v[31601];
         v[31601] = 0;
         if ((b | 0) == 1) {
          break S;
         }
         v[31601] = 0;
         f = e + 312 | 0;
         R(139, f | 0, d | 0, c | 0);
         b = v[31601];
         v[31601] = 0;
         if ((b | 0) == 1) {
          break R;
         }
         yb(a + 1298344 | 0, f);
         sb(f);
         sb(c);
         sb(o);
         Db(d);
         b = tc(f, 12386);
         yb(a + 1298356 | 0, b);
         sb(b);
         b = v[k >> 2];
         if (b) {
          Yh(a + 1298368 | 0, b);
         }
         b = e + 312 | 0;
         ba = a, ca = v[Ec(b, 28) >> 2], v[ba + 1298404 >> 2] = ca;
         if (!(j & 1)) {
          break a;
         }
         b = tc(b, 17130);
         v[31601] = 0;
         O(74, a + 1298368 | 0, b | 0) | 0;
         a = v[31601];
         v[31601] = 0;
         if ((a | 0) == 1) {
          break O;
         }
         sb(b);
         break a;
        }
        g = M() | 0;
        break P;
       }
       g = M() | 0;
       break Q;
      }
      g = M() | 0;
      sb(e + 80 | 0);
     }
     sb(o);
    }
    Db(e + 92 | 0);
    break r;
   }
   g = M() | 0;
   sb(b);
  }
  P(g | 0);
  p();
 }
 eb = e + 368 | 0;
 return S | 0;
}

function Lra(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, q = 0, r = 0, s = 0, z = 0, A = 0, C = 0, D = 0, E = 0, F = 0, G = 0, H = 0, I = 0;
 g = eb - 192 | 0;
 eb = g;
 n = $j(b, 13874);
 if (n) {
  if (d) {
   t[d | 0] = 1;
  }
  k = a + 480204 | 0;
  o = a + 480216 | 0;
  q = a + 480220 | 0;
  r = a + 480224 | 0;
  l = a + 1074368 | 0;
  z = a + 480228 | 0;
  A = a + 480232 | 0;
  s = a + 480200 | 0;
  m = a + 480268 | 0;
  C = a + 1298320 | 0;
  D = a + 480280 | 0;
  E = a + 484380 | 0;
  F = a + 480248 | 0;
  G = Uv(a + 1074312 | 0);
  a: {
   b: {
    c: {
     d: {
      e: {
       f: {
        g: {
         h: {
          while (1) {
           if (!Lb(v[b >> 2], v[b + 8 >> 2], 7)) {
            break a;
           }
           e = Qg(b);
           f = fh(b);
           if ((e | 0) == 70791730) {
            Hh(b, 6);
            break a;
           }
           if (!(e & 1616928864) | e & -2139062144) {
            break a;
           }
           if (!Lb(v[b >> 2], v[b + 8 >> 2], f)) {
            break a;
           }
           i = g + 152 | 0;
           ge(i, b, f);
           h = gc(g + 172 | 0, i);
           tb(i);
           i: {
            j: {
             k: {
              l: {
               m: {
                n: {
                 o: {
                  p: {
                   q: {
                    r: {
                     s: {
                      t: {
                       u: {
                        v: {
                         w: {
                          if ((e | 0) != 1127099950) {
                           if ((e | 0) == 1129797166) {
                            break v;
                           }
                           if ((e | 0) == 1130917459) {
                            break o;
                           }
                           if ((e | 0) == 1145525806) {
                            break t;
                           }
                           d = A;
                           if ((e | 0) == 1448301654) {
                            break s;
                           }
                           if ((e | 0) == 1196316499) {
                            break m;
                           }
                           if ((e | 0) == 1213486401) {
                            break p;
                           }
                           if ((e | 0) == 1280530262) {
                            break u;
                           }
                           if ((e | 0) == 1297303086) {
                            break l;
                           }
                           if ((e | 0) == 1347243310) {
                            break w;
                           }
                           if ((e | 0) == 1347244882) {
                            break q;
                           }
                           if ((e | 0) != 1380340804) {
                            if ((e | 0) == 1380986414) {
                             break r;
                            }
                            d = o;
                            if ((e | 0) == 1380991534) {
                             break s;
                            }
                            d = q;
                            if ((e | 0) == 1380994350) {
                             break s;
                            }
                            if ((e | 0) == 1397052739) {
                             break n;
                            }
                            d = z;
                            if ((e | 0) == 1397768494) {
                             break s;
                            }
                            if ((e | 0) == 1414344238) {
                             break k;
                            }
                            if ((e | 0) != 1146367534) {
                             break j;
                            }
                            v[31601] = 0;
                            R(451, h | 0, f | 0, i | 0);
                            d = v[31601];
                            v[31601] = 0;
                            if ((d | 0) == 1) {
                             break i;
                            }
                            v[k >> 2] = B(v[g + 152 >> 2], 1e4) + (y[k >> 2] % 1e4 | 0);
                            break j;
                           }
                           v[31601] = 0;
                           R(451, h | 0, f | 0, g + 152 | 0);
                           d = v[31601];
                           v[31601] = 0;
                           if ((d | 0) != 1) {
                            d = v[k >> 2];
                            v[k >> 2] = d - ((d >>> 0) % 1e4 | 0) + y[g + 152 >> 2] % 1e4;
                            break j;
                           }
                           e = M() | 0;
                           break b;
                          }
                          if (c) {
                           break j;
                          }
                          v[31601] = 0;
                          u[g + 152 >> 1] = 0;
                          R(452, h | 0, f | 0, g + 152 | 0);
                          d = v[31601];
                          v[31601] = 0;
                          if ((d | 0) != 1) {
                           H = a, I = Kd(x[g + 152 >> 1], x[a + 480188 >> 1], 127), u[H + 480188 >> 1] = I;
                           break j;
                          }
                          e = M() | 0;
                          break b;
                         }
                         v[31601] = 0;
                         R(453, h | 0, f | 0, l | 0);
                         d = v[31601];
                         v[31601] = 0;
                         if ((d | 0) != 1) {
                          break j;
                         }
                         break c;
                        }
                        v[31601] = 0;
                        v[g + 152 >> 2] = 0;
                        R(451, h | 0, f | 0, g + 152 | 0);
                        d = v[31601];
                        v[31601] = 0;
                        if ((d | 0) != 1) {
                         v[a + 1074304 >> 2] = v[g + 152 >> 2];
                         break j;
                        }
                        e = M() | 0;
                        break b;
                       }
                       v[31601] = 0;
                       v[g + 152 >> 2] = 0;
                       R(451, h | 0, f | 0, g + 152 | 0);
                       d = v[31601];
                       v[31601] = 0;
                       if ((d | 0) == 1) {
                        break h;
                       }
                       d = v[g + 152 >> 2];
                       if (!d) {
                        break j;
                       }
                       v[a + 1074308 >> 2] = d;
                       break j;
                      }
                      d = s;
                     }
                     v[31601] = 0;
                     R(451, h | 0, f | 0, d | 0);
                     d = v[31601];
                     v[31601] = 0;
                     if ((d | 0) == 1) {
                      break c;
                     }
                     break j;
                    }
                    if (v[a + 480180 >> 2] == 4) {
                     break j;
                    }
                    v[31601] = 0;
                    R(452, h | 0, f | 0, g + 152 | 0);
                    d = v[31601];
                    v[31601] = 0;
                    if ((d | 0) != 1) {
                     $e(Wb(v[a + 484360 >> 2], w[a + 484376 | 0]), x[g + 152 >> 1]);
                     break j;
                    }
                    e = M() | 0;
                    break b;
                   }
                   v[31601] = 0;
                   R(454, h | 0, f | 0, m | 0);
                   d = v[31601];
                   v[31601] = 0;
                   if ((d | 0) == 1) {
                    break c;
                   }
                   if (up(w[m | 0])) {
                    break j;
                   }
                   t[m | 0] = 5;
                   break j;
                  }
                  d = Eb(g + 152 | 0);
                  e = v[h >> 2];
                  v[31601] = 0;
                  e = Q(154, e | 0) | 0;
                  f = v[31601];
                  v[31601] = 0;
                  x: {
                   if ((f | 0) == 1) {
                    break x;
                   }
                   v[31601] = 0;
                   R(455, h | 0, d | 0, e | 0);
                   e = v[31601];
                   v[31601] = 0;
                   if ((e | 0) == 1) {
                    break x;
                   }
                   v[31601] = 0;
                   e = g + 140 | 0;
                   R(258, e | 0, 0, d | 0);
                   f = v[31601];
                   v[31601] = 0;
                   if ((f | 0) == 1) {
                    break x;
                   }
                   yb(C, e);
                   sb(e);
                   sb(d);
                   break j;
                  }
                  e = M() | 0;
                  sb(d);
                  break b;
                 }
                 if (f & 1 | f >>> 0 > 126) {
                  break j;
                 }
                 d = 64;
                 u[g + 152 >> 1] = f >>> 1 | 64;
                 u[g + 140 >> 1] = 127;
                 e = x[Nc(g + 152 | 0, g + 140 | 0) >> 1];
                 i = e >>> 0 <= 64 ? 64 : e;
                 while (1) {
                  if ((d | 0) == (i | 0)) {
                   break j;
                  }
                  v[31601] = 0;
                  e = g + 152 | 0;
                  N(198, e | 0, h | 0);
                  f = v[31601];
                  v[31601] = 0;
                  if ((f | 0) == 1) {
                   break g;
                  }
                  f = w[g + 152 | 0];
                  y: {
                   if ((f | 0) == 255) {
                    break y;
                   }
                   j = w[Ic(e) | 0];
                   e = (d << 5) + D | 0;
                   u[e + 4 >> 1] = 128;
                   u[e + 6 >> 1] = j;
                   j = (f & 128) << 3;
                   v[e >> 2] = j;
                   f = f & 127;
                   if (f >>> 0 < 65) {
                    u[e + 4 >> 1] = f << 2;
                    break y;
                   }
                   if ((f | 0) != 100) {
                    break y;
                   }
                   v[e >> 2] = j | 256;
                  }
                  d = d + 1 | 0;
                  continue;
                 }
                }
                if (f >>> 0 < 3) {
                 break j;
                }
                v[31601] = 0;
                d = Q(189, h | 0) | 0;
                e = v[31601];
                v[31601] = 0;
                if ((e | 0) == 1) {
                 break f;
                }
                if (x[a + 480190 >> 1] <= (d - 1 & 65535) >>> 0) {
                 break j;
                }
                d = (B(d, 104) + E | 0) + 68 | 0;
                f = zZ(d);
                while (1) {
                 if ((d | 0) == (f | 0)) {
                  break j;
                 }
                 e = v[h >> 2];
                 v[31601] = 0;
                 i = T(150, e | 0, v[g + 180 >> 2], 4) | 0;
                 e = v[31601];
                 v[31601] = 0;
                 z: {
                  if ((e | 0) != 1) {
                   e = 268435456;
                   if (!i) {
                    break z;
                   }
                   v[31601] = 0;
                   e = Q(151, h | 0) | 0;
                   i = v[31601];
                   v[31601] = 0;
                   if ((i | 0) != 1) {
                    break z;
                   }
                  }
                  e = M() | 0;
                  break b;
                 }
                 v[d >> 2] = e;
                 d = d + 4 | 0;
                 continue;
                }
               }
               if (f >>> 0 < 3) {
                break j;
               }
               v[31601] = 0;
               f = g + 140 | 0;
               N(456, f | 0, h | 0);
               d = v[31601];
               v[31601] = 0;
               A: {
                B: {
                 C: {
                  D: {
                   if ((d | 0) != 1) {
                    v[31601] = 0;
                    e = g + 152 | 0;
                    R(457, e | 0, v[g + 140 >> 2], v[g + 144 >> 2]);
                    d = v[31601];
                    v[31601] = 0;
                    if ((d | 0) == 1) {
                     break D;
                    }
                    v[31601] = 0;
                    d = O(103, g | 0, e | 0) | 0;
                    i = v[31601];
                    v[31601] = 0;
                    if ((i | 0) == 1) {
                     break C;
                    }
                    sb(e);
                    ec(f);
                    e = v[h >> 2];
                    v[31601] = 0;
                    Q(154, e | 0) | 0;
                    e = v[31601];
                    v[31601] = 0;
                    if ((e | 0) == 1) {
                     break A;
                    }
                    v[31601] = 0;
                    R(458, d | 0, F | 0, d | 0);
                    e = v[31601];
                    v[31601] = 0;
                    if ((e | 0) == 1) {
                     break A;
                    }
                    Ff(d);
                    break j;
                   }
                   e = M() | 0;
                   break b;
                  }
                  e = M() | 0;
                  break B;
                 }
                 e = M() | 0;
                 sb(g + 152 | 0);
                }
                ec(g + 140 | 0);
                break b;
               }
               e = M() | 0;
               Ff(d);
               break b;
              }
              e = 0;
              f = Uv(G);
              E: while (1) {
               d = v[h >> 2];
               v[31601] = 0;
               d = T(150, d | 0, v[g + 180 >> 2], 1) | 0;
               i = v[31601];
               v[31601] = 0;
               if ((i | 0) == 1) {
                break d;
               }
               if (!(e >>> 0 < 122 & d)) {
                break j;
               }
               v[31601] = 0;
               i = Q(197, h | 0) | 0;
               d = v[31601];
               v[31601] = 0;
               if ((d | 0) == 1) {
                break e;
               }
               d = 0;
               while (1) {
                if ((d | 0) == 8) {
                 continue E;
                }
                F: {
                 if (!(i >>> d & 1) | e >>> 0 > 121) {
                  break F;
                 }
                 v[31601] = 0;
                 T(266, f | 0, e | 0, 1) | 0;
                 j = v[31601];
                 v[31601] = 0;
                 if ((j | 0) != 1) {
                  break F;
                 }
                 e = M() | 0;
                 break b;
                }
                e = e + 1 | 0;
                d = d + 1 | 0;
                continue;
               }
              }
             }
             v[31601] = 0;
             R(459, h | 0, f | 0, r | 0);
             d = v[31601];
             v[31601] = 0;
             if ((d | 0) == 1) {
              break c;
             }
            }
            tb(h);
            continue;
           }
           break;
          }
          e = M() | 0;
          break b;
         }
         e = M() | 0;
         break b;
        }
        e = M() | 0;
        break b;
       }
       e = M() | 0;
       break b;
      }
      e = M() | 0;
      break b;
     }
     e = M() | 0;
     break b;
    }
    e = M() | 0;
   }
   tb(h);
   P(e | 0);
   p();
  }
  b = v[a + 8 >> 2];
  Fp(k, B(v[b + 20 >> 2], 1e4), B(v[b + 24 >> 2], 1e4));
  if (w[a + 480224 | 0] >= 3) {
   t[r | 0] = 0;
  }
  if (w[l | 0] >= 6) {
   t[l | 0] = 0;
  }
  wc(s, 256);
  wc(o, 65536);
  wc(q, 65536);
 }
 eb = g + 192 | 0;
 return n | 0;
}

function ioa(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, y = 0, z = 0;
 j = eb - 192 | 0;
 eb = j;
 if (!rv(a)) {
  e = j + 40 | 0;
  aW(e, a);
  f = j + 168 | 0;
  bf(f, e, 128, 2);
  e = j + 180 | 0;
  Bc(e, f);
  zc(b + 492 | 0, e);
  sb(e);
 }
 u[c + 34 >> 1] = x[c + 34 >> 1] & 65489;
 o = j + 180 | 0;
 g = eb - 32 | 0;
 eb = g;
 a: {
  b: {
   switch (w[a + 128 | 0] - 4 | 0) {
   default:
    v[g + 28 >> 2] = 0;
    pn(o, 0, g + 28 | 0);
    break a;

   case 0:
   case 4:
    break b;
   }
  }
  t[g + 28 | 0] = w[a + 129 | 0];
  t[g + 24 | 0] = 100;
  k = g + 24 | 0;
  e = w[Pb(g + 28 | 0, k) | 0];
  t[g + 24 | 0] = w[a + 130 | 0];
  t[g + 20 | 0] = 100;
  l = g + 20 | 0;
  m = w[Pb(k, l) | 0];
  v[g + 28 >> 2] = m;
  c: {
   if (w[a + 140 | 0] & 16) {
    i = Ab(w[a + 150 | 0] | w[a + 151 | 0] << 8);
    h = Ab(w[a + 152 | 0] | w[a + 153 | 0] << 8);
    f = v[c >> 2];
    s = +(f >>> 0) / 6553600;
    e = vr(s * +((i | e << 16) >>> 0));
    v[g + 24 >> 2] = f - e;
    y = g, z = vr(s * +((h | m << 16) >>> 0)), v[y + 20 >> 2] = z;
    y = g, z = v[Gb(k, l) >> 2], v[y + 28 >> 2] = z;
    break c;
   }
   i = v[c >> 2];
   l = v[c + 20 >> 2];
   if (!ke(i, l)) {
    break c;
   }
   f = i >>> 7 | 0;
   e = B(f, (e << 7 >>> 0) / 100 | 0);
   v[g + 24 >> 2] = i - e;
   v[g + 20 >> 2] = B(f, (m << 7 >>> 0) / 100 | 0);
   f = v[Gb(g + 24 | 0, g + 20 | 0) >> 2];
   h = x[c + 34 >> 1];
   i = B(Zd(h), i);
   d: {
    if (h & 1) {
     ac(g + 12 | 0, l, i);
     l = v[g + 12 >> 2];
     i = Zd(x[c + 34 >> 1]);
     h = l + (B(i, e + f | 0) << 1) | 0;
     m = u[l + (B(e, i) << 1) >> 1];
     l = 0 - i << 1;
     while (1) {
      e: {
       f: {
        if (f) {
         i = u[h >> 1] - m | 0;
         k = i >> 31;
         if ((i ^ k) - k >>> 0 >= 1536) {
          break f;
         }
        } else {
         f = 0;
        }
        break e;
       }
       f = f - 1 | 0;
       h = h + l | 0;
       continue;
      }
      break;
     }
     break d;
    }
    ac(g + 4 | 0, l, i);
    l = v[g + 4 >> 2];
    i = Zd(x[c + 34 >> 1]);
    m = 0 - i | 0;
    h = l + B(i, e + f | 0) | 0;
    l = t[l + B(e, i) | 0];
    while (1) {
     g: {
      h: {
       if (f) {
        i = t[h | 0] - l | 0;
        k = i >> 31;
        if ((i ^ k) - k >>> 0 >= 6) {
         break h;
        }
       } else {
        f = 0;
       }
       break g;
      }
      f = f - 1 | 0;
      h = h + m | 0;
      continue;
     }
     break;
    }
   }
   v[g + 28 >> 2] = f;
  }
  pn(o, e, g + 28 | 0);
 }
 eb = g + 32 | 0;
 r = fc(o);
 if (!(!v[r >> 2] | w[a + 128 | 0] != 4)) {
  u[c + 34 >> 1] = x[c + 34 >> 1] | 2;
  f = v[j + 180 >> 2];
  v[c + 4 >> 2] = f;
  v[c + 8 >> 2] = f + v[r >> 2];
 }
 f = j;
 e = w[a + 134 | 0];
 if ((e - 1 & 255) >>> 0 <= 198) {
  t[f + 40 | 0] = e;
  t[f + 168 | 0] = 100;
  e = (w[Pb(f + 40 | 0, f + 168 | 0) | 0] << 7 >>> 0) / 100 | 0;
 } else {
  e = 128;
 }
 t[f + 39 | 0] = e;
 t[j + 40 | 0] = 64;
 e = j + 39 | 0;
 f = j + 40 | 0;
 y = c, z = w[cf(e, f) | 0] >>> 1 | 0, u[y + 32 >> 1] = z;
 t[j + 40 | 0] = 64;
 y = b, z = w[Pb(e, f) | 0], v[y + 4 >> 2] = z;
 v[c + 24 >> 2] = 40460;
 Yl(c, +t[a + 139 | 0] / 12 + +(0 - w[a + 143 | 0] | 0) + +t[a + 138 | 0] / 1536);
 t[b + 34 | 0] = w[a + 142 | 0] & 2 ? 2 : 1;
 if (w[a + 142 | 0] & 2) {
  bk(b, 127, 1);
  ak(b, 0, 1);
 }
 i: {
  if (!ke(v[c >> 2], v[c + 20 >> 2])) {
   break i;
  }
  b = w[a + 140 | 0];
  if (b & 1) {
   b = v[c >> 2];
   g = v[c + 20 >> 2];
   j: {
    if (!ke(b, g) | b >>> 0 < 2) {
     break j;
    }
    k: {
     l: {
      switch (Xk(x[c + 34 >> 1]) - 1 | 0) {
      case 3:
       e = b >>> 1 | 0;
       b = g + (b << 2) | 0;
       f = 0;
       while (1) {
        if ((e | 0) != (f | 0)) {
         Sb(g + (f << 2) | 0, b + ((f ^ -1) << 2) | 0);
         f = f + 1 | 0;
         continue;
        }
        break;
       }
       ;
       break k;

      case 1:
       e = b >>> 1 | 0;
       b = g + (b << 1) | 0;
       f = 0;
       while (1) {
        if ((e | 0) != (f | 0)) {
         DR(g + (f << 1) | 0, b + ((f ^ -1) << 1) | 0);
         f = f + 1 | 0;
         continue;
        }
        break;
       }
       ;
       break k;

      case 0:
       break l;

      default:
       break j;
      }
     }
     e = b + g | 0;
     b = b >>> 1 | 0;
     f = 0;
     while (1) {
      if ((b | 0) != (f | 0)) {
       qg(f + g | 0, e + (f ^ -1) | 0);
       f = f + 1 | 0;
       continue;
      }
      break;
     }
    }
    Hj(c, d);
   }
   b = w[a + 140 | 0];
  }
  if (b & 4) {
   m: {
    f = v[c >> 2];
    g = v[c + 20 >> 2];
    if (!ke(f, g)) {
     break m;
    }
    b = x[c + 34 >> 1];
    f = B(Zd(b), f);
    n: {
     o: {
      switch (In(b) - 1 | 0) {
      case 1:
       e = 0;
       while (1) {
        if ((e | 0) != (f | 0)) {
         b = g + (e << 1) | 0;
         u[b >> 1] = x[b >> 1] ^ -1;
         e = e + 1 | 0;
         continue;
        }
        break;
       }
       ;
       break n;

      case 0:
       break o;

      default:
       break m;
      }
     }
     e = 0;
     while (1) {
      if ((e | 0) != (f | 0)) {
       b = e + g | 0;
       t[b | 0] = w[b | 0] ^ -1;
       e = e + 1 | 0;
       continue;
      }
      break;
     }
    }
    Hj(c, d);
   }
  }
  p = w[a + 170 | 0] != 2 | w[a + 171 | 0] > 100 ? p : w[a + 172 | 0] < 101;
  b = x[c + 34 >> 1];
  if (!(!(p | w[a + 160 | 0] != 0 | w[a + 141 | 0]) | b & 1)) {
   f = qv(v[c >> 2], Zd(b) << 1 & 254);
   if (!f) {
    break i;
   }
   b = f;
   h = v[c >> 2];
   e = x[c + 34 >> 1];
   g = B(Zd(e), h);
   k = v[c + 20 >> 2];
   e = Nk(h, e);
   i = eb - 16 | 0;
   eb = i;
   v[i + 12 >> 2] = g;
   wc(i + 12 | 0, e);
   h = v[i + 12 >> 2];
   while (1) {
    if (h) {
     u[b >> 1] = t[k | 0] << 8;
     k = k + 1 | 0;
     b = b + 2 | 0;
     h = h - 1 | 0;
     continue;
    }
    break;
   }
   eb = i + 16 | 0;
   u[c + 34 >> 1] = x[c + 34 >> 1] | 1;
   _V(c, f, v[c >> 2], d);
   b = x[c + 34 >> 1];
  }
  f = v[c >> 2];
  e = v[c + 20 >> 2];
  p: {
   if (t[a + 141 | 0] >= 0) {
    break p;
   }
   ac(j + 40 | 0, e, B(Zd(b), f));
   q: while (1) {
    if ((0 - t[a + 141 | 0] | 0) <= (q | 0)) {
     f = v[c >> 2];
     e = v[c + 20 >> 2];
     b = x[c + 34 >> 1];
     break p;
    }
    b = v[j + 40 >> 2];
    f = u[b >> 1];
    y = j, z = vb(b), v[y + 168 >> 2] = z;
    b = en(v[j + 40 >> 2], v[j + 44 >> 2]);
    while (1) {
     e = v[j + 168 >> 2];
     if (Hb(e, b)) {
      f = qd(u[e >> 1] - qd(f, 1) | 0, 1);
      u[e >> 1] = f;
      fe(j + 168 | 0);
      continue;
     } else {
      q = q + 1 | 0;
      continue q;
     }
    }
   }
  }
  if (p) {
   ac(j + 40 | 0, e, B(Zd(b), f));
   h = v[j + 44 >> 2];
   b = (h | 0) / 2 | 0;
   e = b;
   f = e >> 31;
   b = w[a + 172 | 0];
   i = w[a + 171 | 0];
   g = b - i | 0;
   k = 0 - (b >>> 0 < i >>> 0) << 24 | g >>> 8;
   b = g << 24;
   e = b + e | 0;
   f = f + k | 0;
   b = Fc(Bua(e, b >>> 0 > e >>> 0 ? f + 1 | 0 : f, h, h >> 31), gb);
   y = j, z = vb(v[j + 40 >> 2]), v[y + 168 >> 2] = z;
   g = b;
   l = b >> 31;
   b = i << 24;
   f = b >> 31;
   i = en(v[j + 40 >> 2], v[j + 44 >> 2]);
   while (1) {
    e = v[j + 168 >> 2];
    if (Hb(e, i)) {
     h = u[e >> 1];
     h = Aua(b, f, h, h >> 31);
     k = gb;
     h = h + 838860800 | 0;
     k = h >>> 0 < 838860800 ? k + 1 | 0 : k;
     y = e, z = Fc(Bua(h, k, 1677721600, 0), gb), u[y >> 1] = z;
     f = f + l | 0;
     b = b + g | 0;
     f = b >>> 0 < g >>> 0 ? f + 1 | 0 : f;
     fe(j + 168 | 0);
     continue;
    }
    break;
   }
   f = v[c >> 2];
   e = v[c + 20 >> 2];
   b = x[c + 34 >> 1];
  }
  if (w[a + 160 | 0]) {
   ac(j + 168 | 0, e, B(Zd(b), f));
   m = w[a + 163 | 0];
   l = w[a + 162 | 0];
   f = 0;
   k = 0;
   if (w[a + 161 | 0] >= 2) {
    i = v[j + 172 >> 2];
    b = (i | 0) / 2 | 0;
    h = b;
    g = b >> 31;
    b = w[a + 164 | 0];
    e = 0 - (b >>> 0 < l >>> 0) | 0;
    b = b - l | 0;
    k = e << 23 | b >>> 9;
    b = b << 23;
    e = b + h | 0;
    k = g + k | 0;
    n = Fc(Bua(e, b >>> 0 > e >>> 0 ? k + 1 | 0 : k, i, i >> 31), gb);
    i = v[j + 172 >> 2];
    b = (i | 0) / 2 | 0;
    h = b;
    g = b >> 31;
    b = w[a + 165 | 0];
    e = 0 - (b >>> 0 < m >>> 0) | 0;
    b = b - m | 0;
    k = e << 23 | b >>> 9;
    b = b << 23;
    e = b + h | 0;
    g = g + k | 0;
    k = Fc(Bua(e, b >>> 0 > e >>> 0 ? g + 1 | 0 : g, i, i >> 31), gb);
   }
   e = m << 23;
   q = l << 23;
   g = w[a + 160 | 0];
   b = vb(v[j + 168 >> 2]);
   v[j + 32 >> 2] = b;
   i = (j + 40 | 0) + ((g & 2) << 2) | 0;
   h = en(v[j + 168 >> 2], v[j + 172 >> 2]);
   p = 0;
   while (1) {
    if (Hb(b, h)) {
     g = (u[b >> 1] >> 1) - p | 0;
     v[j + 48 >> 2] = g;
     m = g;
     g = (q | 0) / 8388608 | 0;
     f = qd(B(m, g), 8) + f | 0;
     v[j + 44 >> 2] = f;
     g = qd(B(f, g), 6) + p | 0;
     p = qd(qd(B(g, (e | 0) / 8388608 | 0), 6) + g | 0, 2);
     v[j + 40 >> 2] = p;
     y = b, z = fd(v[i >> 2]), u[y >> 1] = z;
     e = e + k | 0;
     q = n + q | 0;
     b = v[fe(j + 32 | 0) >> 2];
     continue;
    } else {
     f = v[c >> 2];
     e = v[c + 20 >> 2];
     b = x[c + 34 >> 1];
    }
    break;
   }
  }
  r: {
   if (t[a + 141 | 0] <= 0) {
    break r;
   }
   ac(j + 40 | 0, e, B(Zd(b), f));
   q = 0;
   s: while (1) {
    if (t[a + 141 | 0] <= (q | 0)) {
     f = v[c >> 2];
     e = v[c + 20 >> 2];
     b = x[c + 34 >> 1];
     break r;
    }
    b = v[j + 40 >> 2];
    f = u[b >> 1];
    y = j, z = vb(b), v[y + 168 >> 2] = z;
    b = en(v[j + 40 >> 2], v[j + 44 >> 2]);
    while (1) {
     e = v[j + 168 >> 2];
     if (Hb(e, b)) {
      f = ((u[e >> 1] << 1) + f | 0) / 3 | 0;
      u[e >> 1] = f;
      fe(j + 168 | 0);
      continue;
     } else {
      q = q + 1 | 0;
      continue s;
     }
    }
   }
  }
  f = B(Zd(b), f);
  t: {
   if (b & 1) {
    ac(j + 24 | 0, e, f);
    m = v[j + 28 >> 2];
    b = eb - 16 | 0;
    eb = b;
    k = v[j + 24 >> 2];
    e = vb(k);
    q = en(k, m);
    p = eb - 16 | 0;
    eb = p;
    t[p + 14 | 0] = 0;
    o = eb - 16 | 0;
    eb = o;
    v[o + 12 >> 2] = e;
    Yb(o + 4 | 0, p + 15 | 0, p + 14 | 0);
    l = b + 8 | 0;
    f = o + 12 | 0;
    h = pn(l, e, f);
    u: {
     if (lc(e, q)) {
      break u;
     }
     n = fe(f);
     g = v[n >> 2];
     if (lc(g, q)) {
      break u;
     }
     e = v[h >> 2];
     f = Pl(g, e);
     v[(f ? 0 : 4) + h >> 2] = g;
     f = f ? g : e;
     i = h + 4 | 0;
     while (1) {
      g = fe(n);
      e = v[g >> 2];
      if (!Hb(e, q)) {
       break u;
      }
      g = v[fe(g) >> 2];
      if (lc(g, q)) {
       if (!Pl(e, f)) {
        h = i;
        if (Pl(e, v[i >> 2])) {
         break u;
        }
       }
       v[h >> 2] = e;
       break u;
      }
      v: {
       if (Pl(g, e)) {
        if (Pl(g, f)) {
         v[h >> 2] = g;
         f = g;
        }
        if (Pl(e, v[i >> 2])) {
         continue;
        }
        break v;
       }
       if (Pl(e, f)) {
        v[h >> 2] = e;
        f = e;
       }
       e = g;
       if (Pl(e, v[i >> 2])) {
        continue;
       }
      }
      v[i >> 2] = e;
      continue;
     }
    }
    eb = o + 16 | 0;
    eb = p + 16 | 0;
    v[b + 4 >> 2] = 0 - u[v[b + 8 >> 2] >> 1];
    y = b, z = u[v[fc(l) >> 2] >> 1], v[y >> 2] = z;
    w: {
     g = v[Ye(b + 4 | 0, b) >> 2];
     if ((g | 0) > 32766 | !g) {
      break w;
     }
     e = vb(k);
     v[b + 4 >> 2] = e;
     f = en(k, m);
     while (1) {
      if (!Hb(e, f)) {
       break w;
      }
      u[e >> 1] = (B(u[e >> 1], 32767) | 0) / (g | 0);
      e = v[fe(b + 4 | 0) >> 2];
      continue;
     }
    }
    break t;
   }
   ac(j + 16 | 0, e, f);
   m = v[j + 20 >> 2];
   b = eb - 16 | 0;
   eb = b;
   k = v[j + 16 >> 2];
   e = vb(k);
   q = Ok(k, m);
   p = eb - 16 | 0;
   eb = p;
   t[p + 14 | 0] = 0;
   o = eb - 16 | 0;
   eb = o;
   v[o + 12 >> 2] = e;
   Yb(o + 4 | 0, p + 15 | 0, p + 14 | 0);
   l = b + 8 | 0;
   f = o + 12 | 0;
   h = pn(l, e, f);
   x: {
    if (lc(e, q)) {
     break x;
    }
    n = xe(f);
    g = v[n >> 2];
    if (lc(g, q)) {
     break x;
    }
    e = v[h >> 2];
    f = Ql(g, e);
    v[(f ? 0 : 4) + h >> 2] = g;
    f = f ? g : e;
    i = h + 4 | 0;
    while (1) {
     g = xe(n);
     e = v[g >> 2];
     if (!Hb(e, q)) {
      break x;
     }
     g = v[xe(g) >> 2];
     if (lc(g, q)) {
      if (!Ql(e, f)) {
       h = i;
       if (Ql(e, v[i >> 2])) {
        break x;
       }
      }
      v[h >> 2] = e;
      break x;
     }
     y: {
      if (Ql(g, e)) {
       if (Ql(g, f)) {
        v[h >> 2] = g;
        f = g;
       }
       if (Ql(e, v[i >> 2])) {
        continue;
       }
       break y;
      }
      if (Ql(e, f)) {
       v[h >> 2] = e;
       f = e;
      }
      e = g;
      if (Ql(e, v[i >> 2])) {
       continue;
      }
     }
     v[i >> 2] = e;
     continue;
    }
   }
   eb = o + 16 | 0;
   eb = p + 16 | 0;
   v[b + 4 >> 2] = 0 - t[v[b + 8 >> 2]];
   y = b, z = t[v[fc(l) >> 2]], v[y >> 2] = z;
   z: {
    g = v[Ye(b + 4 | 0, b) >> 2];
    if ((g | 0) > 126 | !g) {
     break z;
    }
    e = vb(k);
    v[b + 4 >> 2] = e;
    f = Ok(k, m);
    while (1) {
     if (!Hb(e, f)) {
      break z;
     }
     t[e | 0] = (B(t[e | 0], 127) | 0) / (g | 0);
     e = v[xe(b + 4 | 0) >> 2];
     continue;
    }
   }
  }
  eb = b + 16 | 0;
  A: {
   if ((w[a + 134 | 0] - 101 & 255) >>> 0 > 98) {
    break A;
   }
   b = x[c + 34 >> 1];
   f = B(v[c >> 2], Zd(b));
   e = v[c + 20 >> 2];
   if (b & 1) {
    v[j + 8 >> 2] = e;
    v[j + 12 >> 2] = (e + (f << 1) | 0) - e >> 1;
    g = v[j + 12 >> 2];
    f = w[a + 134 | 0];
    h = eb - 16 | 0;
    eb = h;
    b = v[j + 8 >> 2];
    e = vb(b);
    v[h + 12 >> 2] = e;
    n = (3276800 - (f << 14) | 0) / 100 | 0;
    f = 0 - n | 0;
    i = 32768 - n | 0;
    b = en(b, g);
    while (1) {
     if (Hb(e, b)) {
      g = u[e >> 1];
      B: {
       if ((g | 0) > (n | 0)) {
        m = i + ((B(n, g - n | 0) | 0) / (i | 0) | 0) | 0;
        break B;
       }
       m = ((B(n, g + n | 0) | 0) / (i | 0) | 0) - i | 0;
       if ((f | 0) > (g | 0)) {
        break B;
       }
       m = (B(g, i) | 0) / (n | 0) | 0;
      }
      y = e, z = fd(m), u[y >> 1] = z;
      e = v[fe(h + 12 | 0) >> 2];
      continue;
     }
     break;
    }
    eb = h + 16 | 0;
    break A;
   }
   b = ul(j, e, e + f | 0);
   h = v[b >> 2];
   g = v[b + 4 >> 2];
   b = w[a + 134 | 0];
   i = eb - 16 | 0;
   eb = i;
   e = vb(h);
   v[i + 12 >> 2] = e;
   l = (3276800 - (b << 14) | 0) / 100 | 0;
   f = 0 - l | 0;
   n = 32768 - l | 0;
   b = Ok(h, g);
   while (1) {
    if (Hb(e, b)) {
     g = t[e | 0] << 8;
     C: {
      if ((g | 0) > (l | 0)) {
       h = n + ((B(l, g - l | 0) | 0) / (n | 0) | 0) | 0;
       break C;
      }
      h = ((B(l, g + l | 0) | 0) / (n | 0) | 0) - n | 0;
      if ((f | 0) > (g | 0)) {
       break C;
      }
      h = (B(g, n) | 0) / (l | 0) | 0;
     }
     y = e, z = bY((h | 0) / 256 | 0), t[y | 0] = z;
     e = v[xe(i + 12 | 0) >> 2];
     continue;
    }
    break;
   }
   eb = i + 16 | 0;
  }
  ZV(c);
  if (w[a + 128 | 0] != 8) {
   break i;
  }
  f = w[a + 131 | 0];
  if (!f) {
   break i;
  }
  b = v[r >> 2];
  if (!b) {
   break i;
  }
  y = xb(c + 68 | 0, 0), z = v[j + 180 >> 2] + B(b, f + 1 | 0) | 0, v[y >> 2] = z;
  h = v[j + 180 >> 2];
  v[c + 12 >> 2] = h;
  v[c + 16 >> 2] = h + v[r >> 2];
  e = v[r >> 2];
  g = w[a + 131 | 0];
  if (e >>> 0 > 268435456 / (g >>> 0) >>> 0) {
   break i;
  }
  b = v[c >> 2];
  f = B(e, g);
  if (b >>> 0 > 268435456 - f >>> 0) {
   break i;
  }
  k = b + f | 0;
  o = Xk(x[c + 34 >> 1]);
  b = qv(k, o);
  if (!b) {
   break i;
  }
  l = h + B(e, g + 1 | 0) | 0;
  v[c >> 2] = k;
  n = v[c + 20 >> 2];
  i = v[r >> 2];
  h = v[j + 180 >> 2];
  g = B(o, i + h | 0);
  m = yc(b, n, g);
  e = B(i, o);
  f = n + B(h, o) | 0;
  a = w[a + 131 | 0];
  b = 0;
  while (1) {
   if ((a | 0) == (b | 0)) {
    yc(m + B(l, o) | 0, g + n | 0, B(o, k - l | 0));
    _V(c, m, k, d);
   } else {
    b = b + 1 | 0;
    yc(m + B(o, h + B(i, b) | 0) | 0, f, e);
    continue;
   }
   break;
  }
 }
 eb = j + 192 | 0;
}

function cka(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0;
 j = eb - 48 | 0;
 eb = j;
 d = v[b >> 2];
 v[31601] = 0;
 e = Q(172, d | 0) | 0;
 d = v[31601];
 v[31601] = 0;
 a: {
  b: {
   c: {
    d: {
     if ((d | 0) == 1) {
      break d;
     }
     e: {
      f: {
       if (e) {
        d = 0;
        g = Mb(j + 36 | 0);
        g: {
         h: {
          i: {
           if (c & 16) {
            break i;
           }
           v[31601] = 0;
           f = (c | 0) != 64;
           h = T(861, g | 0, b | 0, f | 0) | 0;
           e = v[31601];
           v[31601] = 0;
           if ((e | 0) == 1) {
            break e;
           }
           e = 2;
           j: {
            if (h) {
             break j;
            }
            v[31601] = 0;
            h = T(862, g | 0, b | 0, f | 0) | 0;
            e = v[31601];
            v[31601] = 0;
            if ((e | 0) == 1) {
             break e;
            }
            e = 3;
            if (h) {
             break j;
            }
            v[31601] = 0;
            h = T(863, g | 0, b | 0, f | 0) | 0;
            e = v[31601];
            v[31601] = 0;
            if ((e | 0) == 1) {
             break e;
            }
            e = 4;
            if (h) {
             break j;
            }
            h = 0;
            v[31601] = 0;
            i = T(864, g | 0, b | 0, f | 0) | 0;
            f = v[31601];
            v[31601] = 0;
            e = 1;
            if ((f | 0) == 1) {
             break e;
            }
            if (!i) {
             break i;
            }
           }
           if ((c | 0) == 64) {
            e = 1;
            break h;
           }
           h = v[g >> 2];
           if (!lc(h, v[g + 4 >> 2])) {
            ax(b, h + 12 | 0);
           }
           h = e;
          }
          if (c & 32) {
           e = 0;
           break h;
          }
          k: {
           while (1) {
            e = d;
            if ((d | 0) != 576) {
             f = v[d + 29864 >> 2];
             i = (f >> 1) + a | 0;
             d = v[d + 29860 >> 2];
             d = f & 1 ? v[v[i >> 2] + d >> 2] : d;
             v[31601] = 0;
             f = T(d | 0, i | 0, b | 0, c | 0) | 0;
             d = v[31601];
             v[31601] = 0;
             if ((d | 0) == 1) {
              break c;
             }
             d = e + 12 | 0;
             if (!f) {
              continue;
             }
             break k;
            }
            break;
           }
           v[a + 480180 >> 2] = 0;
           v[a + 480184 >> 2] = 0;
          }
          if ((c | 0) == 64) {
           e = (e | 0) != 576;
           d = 0;
           break h;
          }
          if (!(v[a + 480184 >> 2] | !h)) {
           v[a + 480184 >> 2] = h;
          }
          v[31601] = 0;
          d = 1;
          N(800, a + 1298264 | 0, 1);
          h = v[31601];
          v[31601] = 0;
          e = 1;
          if ((h | 0) == 1) {
           break g;
          }
         }
         _R(g);
         if (d) {
          break f;
         }
         break a;
        }
        break c;
       }
       v[31601] = 0;
       N(246, a | 0, 0);
       d = v[31601];
       v[31601] = 0;
       if ((d | 0) == 1) {
        break d;
       }
       v[31601] = 0;
       N(800, a + 1298264 | 0, 1);
       d = v[31601];
       v[31601] = 0;
       if ((d | 0) == 1) {
        break d;
       }
       v[a + 1298408 >> 2] = 0;
       v[a + 1074304 >> 2] = 19989505;
      }
      h = a + 1074992 | 0;
      d = a + 480280 | 0;
      e = 0;
      while (1) {
       if ((e | 0) == 127) {
        h = a + 484380 | 0;
        d = 1;
        while (1) {
         e = d & 65535;
         if (e >>> 0 > x[a + 480190 >> 1]) {
          f = a + 900380 | 0;
          d = 0;
          e = 0;
          l: {
           while (1) {
            h = e & 65535;
            if (h >>> 0 > x[a + 480192 >> 1]) {
             m: {
              u[a + 480192 >> 1] = d;
              d = a + 480204 | 0;
              if (y[a + 480204 >> 2] >= 1e4) {
               break m;
              }
              v[d >> 2] = 125e4;
              break l;
             }
            } else {
             g = v[f + (h << 2) >> 2];
             if (g) {
              h = v[a + 480180 >> 2];
              wc(g, 65536);
              wc(g + 4 | 0, 64);
              wc(g + 8 | 0, 256);
              Gf(g + 28 | 0, 16384);
              Nf(g + 30 | 0, 128);
              Nf(g + 31 | 0, 17);
              if (w[g + 16 | 0] >= 4) {
               t[g + 16 | 0] = 0;
              }
              if (w[g + 17 | 0] >= 5) {
               t[g + 17 | 0] = 0;
              }
              if (w[g + 18 | 0] >= 3) {
               t[g + 18 | 0] = 0;
              }
              Nf(g + 19 | 0, 64);
              Nf(g + 20 | 0, 100);
              i = 224;
              d = t[g + 26 | 0];
              n: {
               if ((d | 0) >= -32) {
                i = 32;
                if ((d | 0) < 33) {
                 break n;
                }
               }
               t[g + 26 | 0] = i;
              }
              Nf(g + 23 | 0, 64);
              Nf(g + 24 | 0, 64);
              hC(g + 48 | 0, 64);
              hC(g + 68 | 0, 64);
              hC(g + 88 | 0, (h | 0) == 4096 ? 255 : 64);
              h = g + 108 | 0;
              i = 0;
              while (1) {
               o: {
                if ((i | 0) == 128) {
                 if (!up(w[g + 14 | 0])) {
                  t[g + 14 | 0] = 5;
                 }
                 if (w[g + 34 | 0] >= 251) {
                  t[g + 34 | 0] = 0;
                 }
                 break o;
                }
                d = wb(h, i);
                if ((w[d | 0] - 121 & 255) >>> 0 <= 135) {
                 t[d | 0] = i + 1;
                }
                i = i + 1 | 0;
                continue;
               }
               break;
              }
              d = e;
             }
             e = e + 1 | 0;
             continue;
            }
            break;
           }
           wc(d, 65535e4);
          }
          if (!v[a + 480196 >> 2]) {
           v[a + 480196 >> 2] = 6;
          }
          h = a + 480216 | 0;
          e = a + 480220 | 0;
          d = v[a + 480216 >> 2];
          if (!(d | w[a + 480224 | 0] != 2)) {
           v[h >> 2] = 1;
           d = 1;
          }
          if (y[a + 480220 >> 2] < d >>> 0) {
           v[e >> 2] = d;
          }
          wc(h, 65536);
          wc(e, 65536);
          wc(a + 480200 | 0, 256);
          p: {
           if (!lc(v[a + 480248 >> 2], v[a + 480252 >> 2])) {
            d = v[h >> 2];
            v[31601] = 0;
            N(865, a + 480248 | 0, d | 0);
            d = v[31601];
            v[31601] = 0;
            if ((d | 0) == 1) {
             break p;
            }
           }
           v[a + 1074416 >> 2] = v[a + 480196 >> 2];
           v[a + 1074420 >> 2] = v[a + 480204 >> 2];
           d = v[a + 480220 >> 2];
           v[a + 1074408 >> 2] = v[a + 480216 >> 2];
           v[a + 1074412 >> 2] = d;
           v[a + 1074456 >> 2] = v[a + 480200 >> 2];
           tB(a + 1074376 | 0);
           u[a + 1074446 >> 1] = 0;
           u[a + 1074448 >> 1] = 0;
           u[a + 1074450 >> 1] = 0;
           u[a + 1074452 >> 1] = 65535;
           v[a + 1074392 >> 2] = -2;
           v[a + 1074384 >> 2] = 0;
           v[a + 1074388 >> 2] = 0;
           v[a + 1074380 >> 2] = 0;
           v[a + 1074424 >> 2] = 0;
           v[a + 1074428 >> 2] = 0;
           v[a + 1074432 >> 2] = 0;
           v[a + 1074396 >> 2] = 0;
           v[a + 1074400 >> 2] = 0;
           if (wn(v[a + 480180 >> 2])) {
            v[31601] = 0;
            O(267, a + 1074312 | 0, 7) | 0;
            d = v[31601];
            v[31601] = 0;
            if ((d | 0) == 1) {
             break p;
            }
           }
           u[a + 480276 >> 1] = 0;
           Cq(a);
           l = j, m = vb(v[a + 484360 >> 2]), v[l + 36 >> 2] = m;
           e = vb(v[a + 484364 >> 2]);
           q: {
            while (1) {
             r: {
              h = v[j + 36 >> 2];
              if (!Hb(h, e)) {
               if (v[a + 480180 >> 2]) {
                break r;
               }
               e = 0;
               break a;
              }
              v[31601] = 0;
              V(866, h | 0);
              d = v[31601];
              v[31601] = 0;
              if ((d | 0) == 1) {
               break q;
              }
              if (_c(v[h >> 2], v[h + 4 >> 2]) >>> 0 <= x[h + 28 >> 1]) {
               $e(h, 0);
              }
              Zq(j + 36 | 0);
              continue;
             }
             break;
            }
            Cu(a + 8 | 0, tr(a));
            if (v[a + 1074308 >> 2]) {
             v[31601] = 0;
             V(867, a | 0);
             d = v[31601];
             v[31601] = 0;
             if ((d | 0) == 1) {
              break p;
             }
            }
            g = Mb(j + 36 | 0);
            s: {
             t: {
              if ((c & 12) != 12) {
               break t;
              }
              h = a + 906300 | 0;
              e = 0;
              u: {
               v: {
                w: {
                 x: {
                  y: {
                   z: {
                    while (1) {
                     if ((e | 0) == 250) {
                      break t;
                     }
                     A: {
                      k = _d(h, e);
                      B: {
                       if (!Li(v[k + 16 >> 2], v[k + 20 >> 2])) {
                        break B;
                       }
                       v[31601] = 0;
                       N(868, k | 0, a | 0);
                       c = v[31601];
                       v[31601] = 0;
                       C: {
                        if ((c | 0) != 1) {
                         f = v[k >> 2];
                         if (!f) {
                          break C;
                         }
                         d = v[k + 148 >> 2];
                         c = v[v[f >> 2] + 56 >> 2];
                         v[31601] = 0;
                         N(c | 0, f | 0, d | 0);
                         c = v[31601];
                         v[31601] = 0;
                         if ((c | 0) != 1) {
                          break B;
                         }
                        }
                        a = M() | 0;
                        break s;
                       }
                       i = vb(v[g >> 2]);
                       c = vb(v[g + 4 >> 2]);
                       f = eb - 16 | 0;
                       eb = f;
                       v[f + 12 >> 2] = i;
                       while (1) {
                        D: {
                         if (!Hb(i, c)) {
                          break D;
                         }
                         d = v[i >> 2];
                         if ((w[d + 4 | 0] | w[d + 5 | 0] << 8 | (w[d + 6 | 0] << 16 | w[d + 7 | 0] << 24)) == (w[k + 20 | 0] | w[k + 21 | 0] << 8 | (w[k + 22 | 0] << 16 | w[k + 23 | 0] << 24))) {
                          d = (w[d | 0] | w[d + 1 | 0] << 8 | (w[d + 2 | 0] << 16 | w[d + 3 | 0] << 24)) == (w[k + 16 | 0] | w[k + 17 | 0] << 8 | (w[k + 18 | 0] << 16 | w[k + 19 | 0] << 24));
                         } else {
                          d = 0;
                         }
                         if (d) {
                          break D;
                         }
                         i = v[Xe(f + 12 | 0) >> 2];
                         continue;
                        }
                        break;
                       }
                       eb = f + 16 | 0;
                       if (Hb(i, vb(v[g + 4 >> 2]))) {
                        break B;
                       }
                       v[31601] = 0;
                       v[j + 24 >> 2] = k + 16;
                       f = j + 24 | 0;
                       N(869, g | 0, f | 0);
                       c = v[31601];
                       v[31601] = 0;
                       if ((c | 0) == 1) {
                        break A;
                       }
                       v[31601] = 0;
                       d = O(1, j + 12 | 0, 18303) | 0;
                       c = v[31601];
                       v[31601] = 0;
                       if ((c | 0) == 1) {
                        break z;
                       }
                       v[31601] = 0;
                       N(870, j | 0, k | 0);
                       c = v[31601];
                       v[31601] = 0;
                       if ((c | 0) == 1) {
                        break y;
                       }
                       v[31601] = 0;
                       R(2, f | 0, d | 0, j | 0);
                       c = v[31601];
                       v[31601] = 0;
                       if ((c | 0) == 1) {
                        break x;
                       }
                       c = v[a + 1298472 >> 2];
                       v[31601] = 0;
                       R(385, c | 0, 2, f | 0);
                       c = v[31601];
                       v[31601] = 0;
                       if ((c | 0) == 1) {
                        break w;
                       }
                       sb(f);
                       sb(j);
                       sb(d);
                      }
                      e = e + 1 | 0;
                      continue;
                     }
                     break;
                    }
                    a = M() | 0;
                    break s;
                   }
                   a = M() | 0;
                   break s;
                  }
                  a = M() | 0;
                  break u;
                 }
                 a = M() | 0;
                 break v;
                }
                a = M() | 0;
                sb(j + 24 | 0);
               }
               sb(j);
              }
              sb(d);
              break s;
             }
             c = w[a + 1074368 | 0];
             v[31601] = 0;
             N(871, a | 0, c | 0);
             a = v[31601];
             v[31601] = 0;
             e = 1;
             if ((a | 0) != 1) {
              uc(g);
              break a;
             }
             a = M() | 0;
            }
            uc(g);
            break b;
           }
           a = M() | 0;
           break b;
          }
          a = M() | 0;
          break b;
         }
         f = h + B(e, 104) | 0;
         E: {
          if (ke(v[f >> 2], v[f + 20 >> 2])) {
           Hj(f, a);
           break E;
          }
          e = x[f + 34 >> 1];
          if (e & 16384) {
           break E;
          }
          v[f >> 2] = 0;
          v[f + 4 >> 2] = 0;
          v[f + 16 >> 2] = 0;
          v[f + 8 >> 2] = 0;
          v[f + 12 >> 2] = 0;
          u[f + 34 >> 1] = e & 49121;
         }
         if (x[f + 32 >> 1] >= 65) {
          u[f + 32 >> 1] = 64;
         }
         F: {
          G: {
           if (!(w[f + 35 | 0] & 2)) {
            break G;
           }
           if (!Ej(v[a + 1298300 >> 2])) {
            break G;
           }
           v[31601] = 0;
           V(872, a | 0);
           e = v[31601];
           v[31601] = 0;
           if ((e | 0) == 1) {
            break F;
           }
          }
          d = d + 1 | 0;
          continue;
         }
         break;
        }
        a = M() | 0;
        break b;
       }
       f = d + (e << 5) | 0;
       Gf(f + 6 | 0, 64);
       if (x[f + 4 >> 1] >= 257) {
        u[f + 4 >> 1] = 128;
       }
       if (w[f + 8 | 0] >= 251) {
        t[f + 8 | 0] = 0;
       }
       Po(h + B(e, 872) | 0, a, e & 65535, 134217728);
       e = e + 1 | 0;
       continue;
      }
     }
     break c;
    }
    a = M() | 0;
    break b;
   }
   a = M() | 0;
   _R(g);
  }
  tb(b);
  P(a | 0);
  p();
 }
 tb(b);
 eb = j + 48 | 0;
 return e | 0;
}

function ipa(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, q = 0, r = 0, s = 0, y = 0, z = 0, A = 0, C = 0, D = 0, E = 0, F = 0;
 d = eb - 288 | 0;
 eb = d;
 xc(b);
 a: {
  b: {
   c: {
    e = d + 192 | 0;
    d: {
     if (!Ev(b, e)) {
      break d;
     }
     if (!mX(e)) {
      break d;
     }
     if (!Lb(v[b >> 2], v[b + 8 >> 2], Ac(lX(e), gb))) {
      break d;
     }
     o = 1;
     if ((c | 0) == 64) {
      break d;
     }
     o = 0;
     if (!cd(b, w[d + 196 | 0])) {
      break d;
     }
     Cd(a, 268435456);
     dg(a);
     v[a + 480208 >> 2] = 4;
     Kb(a + 1074312 | 0, 114, 1);
     e = d + 84 | 0;
     i = tc(e, 15307);
     yb(a + 1298344 | 0, i);
     sb(i);
     i = tc(e, 10282);
     yb(a + 1298356 | 0, i);
     sb(i);
     E = a, F = v[Ec(e, 4) >> 2], v[E + 1298404 >> 2] = F;
     i = d + 16 | 0;
     bf(i, d + 198 | 0, 48, 3);
     Bc(e, i);
     yb(a + 1298308 | 0, e);
     sb(e);
     e = w[d + 246 | 0];
     u[a + 480188 >> 1] = e + 1;
     v[a + 480228 >> 2] = w[d + 249 | 0];
     v[a + 480204 >> 2] = B(w[d + 250 | 0], 1e4);
     v[a + 480196 >> 2] = w[d + 251 | 0];
     i = a + 480280 | 0;
     h = d + 252 | 0;
     while (1) {
      if ((f | 0) == (e | 0)) {
       e: {
        u[a + 480190 >> 1] = w[d + 284 | 0];
        f = w[d + 286 | 0] | w[d + 287 | 0] << 8;
        i = eb - 16 | 0;
        eb = i;
        e = d + 180 | 0;
        v[e >> 2] = 0;
        v[e + 4 >> 2] = 0;
        sc(e + 8 | 0);
        Qd(i + 8 | 0, v[ub(i + 4 | 0, e) >> 2]);
        f: {
         g: {
          if (f) {
           v[31601] = 0;
           N(661, e | 0, f | 0);
           h = v[31601];
           v[31601] = 0;
           if ((h | 0) == 1) {
            break g;
           }
           pD(e, f);
          }
          f = i + 8 | 0;
          Pd(f);
          ah(f);
          eb = i + 16 | 0;
          break f;
         }
         a = M() | 0;
         ah(i + 8 | 0);
         P(a | 0);
         p();
        }
        v[31601] = 0;
        i = e;
        R(656, b | 0, e | 0, w[d + 286 | 0] | w[d + 287 | 0] << 8);
        e = v[31601];
        v[31601] = 0;
        if ((e | 0) == 1) {
         break b;
        }
        z = Mb(d + 168 | 0);
        q = Mb(d + 156 | 0);
        v[31601] = 0;
        T(420, b | 0, z | 0, w[d + 285 | 0]) | 0;
        e = v[31601];
        v[31601] = 0;
        if ((e | 0) == 1) {
         break c;
        }
        v[31601] = 0;
        T(420, b | 0, q | 0, w[d + 284 | 0]) | 0;
        e = v[31601];
        v[31601] = 0;
        if ((e | 0) == 1) {
         break c;
        }
        o = c & 2;
        r = a + 946304 | 0;
        s = a + 484380 | 0;
        m = d + 122 | 0;
        y = d + 90 | 0;
        e = 0;
        h: {
         while (1) {
          f = e;
          if (e >>> 0 >= w[d + 284 | 0]) {
           o = 1;
           if (!(c & 1)) {
            break e;
           }
           v[d + 68 >> 2] = 0;
           Mc(Wb(v[a + 484360 >> 2], w[a + 484376 | 0]));
           E = d, F = vb(v[i >> 2]), v[E + 64 >> 2] = F;
           r = a + 484344 | 0;
           A = vb(v[i + 4 >> 2]);
           break h;
          }
          v[31601] = 0;
          e = f + 1 | 0;
          h = s + B(e, 104) | 0;
          N(279, h | 0, 0);
          g = v[31601];
          v[31601] = 0;
          i: {
           if ((g | 0) != 1) {
            g = xb(v[q >> 2], f);
            g = w[g | 0] | w[g + 1 | 0] << 8 | (w[g + 2 | 0] << 16 | w[g + 3 | 0] << 24);
            if (!g) {
             continue;
            }
            v[31601] = 0;
            g = O(149, b | 0, g | 0) | 0;
            j = v[31601];
            v[31601] = 0;
            j: {
             if ((j | 0) == 1) {
              break j;
             }
             if (!g) {
              continue;
             }
             v[31601] = 0;
             g = O(657, b | 0, d + 84 | 0) | 0;
             j = v[31601];
             v[31601] = 0;
             if ((j | 0) == 1) {
              break j;
             }
             if (!g) {
              continue;
             }
             j = d + 72 | 0;
             Ue(j, 2, y);
             v[31601] = 0;
             g = d + 16 | 0;
             N(218, g | 0, j | 0);
             l = v[31601];
             v[31601] = 0;
             if ((l | 0) == 1) {
              break c;
             }
             zc(r + (e << 5) | 0, g);
             sb(g);
             Ik(j, 2, m);
             v[31601] = 0;
             N(218, g | 0, j | 0);
             j = v[31601];
             v[31601] = 0;
             if ((j | 0) == 1) {
              break c;
             }
             Ae(h + 43 | 0, g);
             sb(g);
             g = w[d + 134 | 0];
             if (g >>> 0 <= 15) {
              u[h + 28 >> 1] = B(g, 17) & 255;
              u[h + 34 >> 1] = x[h + 34 >> 1] | 32;
             }
             t[d + 16 | 0] = w[d + 135 | 0];
             t[d + 72 | 0] = 64;
             E = h, F = w[Pb(d + 16 | 0, d + 72 | 0) | 0], u[E + 32 >> 1] = F;
             v[h + 24 >> 2] = w[d + 137 | 0] | w[d + 138 | 0] << 8;
             g = w[d + 143 | 0] | w[d + 144 | 0] << 8 | (w[d + 145 | 0] << 16 | w[d + 146 | 0] << 24);
             v[h + 4 >> 2] = g;
             j = w[d + 147 | 0] | w[d + 148 | 0] << 8 | (w[d + 149 | 0] << 16 | w[d + 150 | 0] << 24);
             v[h + 8 >> 2] = j;
             l = w[d + 151 | 0] | w[d + 152 | 0] << 8 | (w[d + 153 | 0] << 16 | w[d + 154 | 0] << 24);
             v[h >> 2] = l;
             k = w[d + 136 | 0];
             if (k & 1) {
              j = j >>> 1 | 0;
              v[h + 8 >> 2] = j;
              g = g >>> 1 | 0;
              v[h + 4 >> 2] = g;
              v[h >> 2] = l >>> 1;
             }
             k: {
              if (g >>> 0 >= j >>> 0) {
               break k;
              }
              g = x[h + 34 >> 1];
              u[h + 34 >> 1] = g | 2;
              if (!(k & 2)) {
               break k;
              }
              u[h + 34 >> 1] = g | 6;
             }
             Sk(h);
             if (!o) {
              continue;
             }
             f = xb(v[q >> 2], f);
             f = w[f | 0] | w[f + 1 | 0] << 8 | (w[f + 2 | 0] << 16 | w[f + 3 | 0] << 24);
             v[31601] = 0;
             O(149, b | 0, f + w[d + 88 | 0] | 0) | 0;
             f = v[31601];
             v[31601] = 0;
             if ((f | 0) != 1) {
              break i;
             }
            }
            break c;
           }
           break c;
          }
          f = Yc(d + 16 | 0, t[d + 136 | 0] & 1 ? 16 : 8, 1, 0, 1);
          v[31601] = 0;
          T(215, f | 0, h | 0, b | 0) | 0;
          f = v[31601];
          v[31601] = 0;
          if ((f | 0) != 1) {
           continue;
          }
          break;
         }
         break c;
        }
        while (1) {
         j = v[d + 64 >> 2];
         if (!Hb(j, A)) {
          f = w[a + 484376 | 0];
          h = v[a + 484360 >> 2];
          l: {
           b = v[d + 68 >> 2];
           c = b & 63;
           m: {
            if (!c) {
             break m;
            }
            e = Wb(h, f);
            b = b >>> 6 & 65535;
            if (!Vi(e, b)) {
             break m;
            }
            b = x[$b(v[e >> 2], b) >> 1];
            e = v[r >> 2];
            v[31601] = 0;
            N(658, Vb(e, b) | 0, c | 0);
            b = v[31601];
            v[31601] = 0;
            if ((b | 0) == 1) {
             break l;
            }
            f = w[a + 484376 | 0];
            h = v[a + 484360 >> 2];
           }
           a = Wb(h, f);
           f = vb(v[a >> 2]);
           v[d + 84 >> 2] = f;
           a = vb(v[a + 4 >> 2]);
           e = 65535;
           while (1) {
            if (!Hb(f, a)) {
             break e;
            }
            if (x[f >> 1] == 65535) {
             n: {
              if ((e & 65535) != 65535) {
               break n;
              }
              v[31601] = 0;
              e = O(367, r | 0, 64) | 0;
              b = v[31601];
              v[31601] = 0;
              if ((b | 0) != 1) {
               break n;
              }
              break c;
             }
             u[f >> 1] = e;
            }
            f = v[fe(d + 84 | 0) >> 2];
            continue;
           }
          }
          break c;
         }
         o: {
          c = w[j + 3 | 0];
          if (w[j + 2 | 0] > w[d + 246 | 0] | c >>> 0 >= w[d + 285 | 0]) {
           break o;
          }
          c = xb(v[z >> 2], c);
          c = w[c | 0] | w[c + 1 | 0] << 8 | (w[c + 2 | 0] << 16 | w[c + 3 | 0] << 24);
          v[31601] = 0;
          c = O(149, b | 0, c | 0) | 0;
          e = v[31601];
          v[31601] = 0;
          p: {
           if ((e | 0) != 1) {
            if (!c) {
             break o;
            }
            v[31601] = 0;
            N(659, b | 0, d + 84 | 0);
            c = v[31601];
            v[31601] = 0;
            if ((c | 0) == 1) {
             break c;
            }
            f = w[d + 88 | 0];
            if (!f) {
             break o;
            }
            c = w[j | 0] | w[j + 1 | 0] << 8;
            t[d + 16 | 0] = w[d + 89 | 0];
            t[d + 72 | 0] = w[d + 246 | 0] - w[j + 2 | 0];
            s = w[Pb(d + 16 | 0, d + 72 | 0) | 0];
            v[d + 60 >> 2] = c + f;
            E = d, F = v[ad(d + 68 | 0, d + 60 | 0) >> 2], v[E + 68 >> 2] = F;
            v[d + 40 >> 2] = 0;
            v[d + 44 >> 2] = 0;
            v[d + 32 >> 2] = 0;
            v[d + 36 >> 2] = 0;
            v[d + 24 >> 2] = 0;
            v[d + 28 >> 2] = 0;
            v[d + 16 >> 2] = 0;
            v[d + 20 >> 2] = 0;
            e = c & 63;
            m = c >>> 6 | 0;
            y = 0;
            while (1) {
             if ((f & 255) >>> 0 <= y >>> 0) {
              break o;
             }
             f = Wb(v[a + 484360 >> 2], w[a + 484376 | 0]);
             g = e >>> 0 > 63;
             m = g + m | 0;
             c = m & 65535;
             if (_c(v[f >> 2], v[f + 4 >> 2]) >>> 0 <= c >>> 0) {
              v[31601] = 0;
              N(330, f | 0, m + 1 & 65535);
              f = v[31601];
              v[31601] = 0;
              if ((f | 0) == 1) {
               break p;
              }
              v[31601] = 0;
              h = O(367, r | 0, 64) | 0;
              f = v[31601];
              v[31601] = 0;
              if ((f | 0) == 1) {
               break p;
              }
              f = Wb(v[a + 484360 >> 2], w[a + 484376 | 0]);
              E = $b(v[f >> 2], c), F = h, u[E >> 1] = F;
             }
             k = v[a + 484344 >> 2];
             n = v[a + 484348 >> 2];
             l = x[$b(v[f >> 2], c) >> 1];
             if (!Ie(k, n, l)) {
              break o;
             }
             h = 0;
             c = Vb(k, l);
             k = g ? 0 : e;
             f = ld(v[c >> 2], v[v[c + 48 >> 2] + 12 >> 2], k, w[j + 2 | 0]);
             q: {
              while (1) {
               if ((h | 0) == (s | 0)) {
                c = w[d + 89 | 0];
                if (c >>> 0 <= s >>> 0) {
                 break q;
                }
                v[31601] = 0;
                O(183, b | 0, B(c - s | 0, 5) | 0) | 0;
                c = v[31601];
                v[31601] = 0;
                if ((c | 0) != 1) {
                 break q;
                }
                break c;
               }
               v[31601] = 0;
               c = d + 72 | 0;
               N(660, c | 0, b | 0);
               e = v[31601];
               v[31601] = 0;
               if ((e | 0) != 1) {
                g = Ic(c);
                C = _e(c);
                n = Xi(c);
                D = fc(c);
                e = 0;
                c = w[d + 72 | 0];
                if ((c - 1 & 255) >>> 0 <= 142) {
                 e = (B((c & 240) >>> 4 | 0, 12) + (c & 15) | 0) + 13 | 0;
                 t[(d + 16 | 0) + h | 0] = e;
                }
                t[f | 0] = e;
                c = w[g | 0];
                t[f + 2 | 0] = 1;
                t[f + 1 | 0] = c;
                c = w[C | 0];
                r: {
                 if ((c | 0) != 255) {
                  t[f + 4 | 0] = c;
                  break r;
                 }
                 t[f + 2 | 0] = 0;
                }
                c = w[n | 0];
                s: {
                 if (c >>> 0 > 22) {
                  break s;
                 }
                 t[f + 3 | 0] = w[c + 25344 | 0];
                 g = w[D | 0];
                 t[f + 5 | 0] = g;
                 c = f + 5 | 0;
                 t: {
                  switch (w[n | 0] - 4 | 0) {
                  case 3:
                   t[c | 0] = g & 3 | 64;
                   break s;

                  case 4:
                   t[c | 0] = g & 3 | 48;
                   break s;

                  case 7:
                   e = v[i >> 2];
                   if (nc(e, v[i + 4 >> 2]) >>> 0 <= g >>> 0) {
                    break s;
                   }
                   n = c;
                   c = xb(e, g);
                   c = w[c | 0] | w[c + 1 | 0] << 8;
                   t[n | 0] = c >>> 6;
                   e = Vb(v[a + 484344 >> 2], l);
                   e = ld(v[e >> 2], v[v[e + 48 >> 2] + 12 >> 2], k, x[a + 480188 >> 1] - 1 & 65535);
                   t[e + 5 | 0] = c & 63;
                   t[e + 3 | 0] = 14;
                   break s;

                  case 8:
                   e = c;
                   c = v[d + 60 >> 2];
                   t[e | 0] = c >>> 6;
                   e = Vb(v[a + 484344 >> 2], l);
                   e = ld(v[e >> 2], v[v[e + 48 >> 2] + 12 >> 2], k, x[a + 480188 >> 1] - 1 & 65535);
                   t[e + 5 | 0] = c & 63;
                   t[e + 3 | 0] = 14;
                   break s;

                  case 10:
                   t[c | 0] = g & 15 | 128;
                   break s;

                  case 12:
                   t[d + 15 | 0] = 15;
                   E = c, F = w[Pb(c, d + 15 | 0) | 0] | 208, t[E | 0] = F;
                   break s;

                  case 13:
                   t[d + 15 | 0] = 15;
                   E = c, F = w[Pb(c, d + 15 | 0) | 0] | 192, t[E | 0] = F;
                   break s;

                  case 14:
                   t[d + 15 | 0] = 15;
                   E = c, F = w[Pb(c, d + 15 | 0) | 0] | 224, t[E | 0] = F;
                   break s;

                  case 0:
                  case 16:
                  case 17:
                   if (!(g & 15)) {
                    break s;
                   }
                   e = g & 240;
                   if (!e | (e | 0) == 240) {
                    break s;
                   }
                   t[c | 0] = g | 15;
                   break s;

                  case 9:
                  case 18:
                   break t;

                  default:
                   break s;
                  }
                 }
                 if (e & 255) {
                  break s;
                 }
                 t[f | 0] = w[(d + 16 | 0) + h | 0];
                }
                f = f + 6 | 0;
                h = h + 1 | 0;
                continue;
               }
               break;
              }
              break c;
             }
             e = k + 1 | 0;
             y = y + 1 | 0;
             f = w[d + 88 | 0];
             continue;
            }
           }
           break c;
          }
          break c;
         }
         Xe(d - -64 | 0);
         continue;
        }
       }
      } else {
       u[(i + (f << 5) | 0) + 4 >> 1] = B(w[f + h | 0], 17);
       f = f + 1 | 0;
       continue;
      }
      break;
     }
     uc(q);
     uc(z);
     uc(i);
    }
    eb = d + 288 | 0;
    return o | 0;
   }
   f = M() | 0;
   uc(q);
   uc(z);
   break a;
  }
  f = M() | 0;
 }
 uc(i);
 P(f | 0);
 p();
}

function j7(a, b, c, d, e, f, g, h, i, j, k) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 f = f | 0;
 g = g | 0;
 h = h | 0;
 i = i | 0;
 j = j | 0;
 k = k | 0;
 var l = 0, m = 0, n = 0, o = 0, q = 0, r = 0, s = 0, u = 0, x = 0, y = 0, z = 0, A = 0, B = 0, C = 0, D = 0;
 l = eb - 528 | 0;
 eb = l;
 v[l + 520 >> 2] = k;
 v[l + 524 >> 2] = b;
 a: {
  b: {
   if (ei(a, l + 524 | 0)) {
    v[f >> 2] = v[f >> 2] | 4;
    a = 0;
    break b;
   }
   v[l + 72 >> 2] = 1273;
   b = l + 72 | 0;
   u = Ce(l + 104 | 0, l + 112 | 0, b);
   m = v[u >> 2];
   v[l + 100 >> 2] = m;
   v[l + 96 >> 2] = m + 400;
   x = Eb(b);
   q = Eb(l + 60 | 0);
   n = Eb(l + 48 | 0);
   o = Eb(l + 36 | 0);
   s = Eb(l + 24 | 0);
   b = v[d >> 2];
   v[31601] = 0;
   ja(1283, c | 0, b | 0, l + 92 | 0, l + 88 | 0, l + 84 | 0, x | 0, q | 0, n | 0, o | 0, l + 20 | 0);
   b = v[31601];
   v[31601] = 0;
   if ((b | 0) != 1) {
    v[j >> 2] = v[i >> 2];
    z = e & 512;
    y = v[l + 20 >> 2];
    e = 0;
    while (1) {
     c: {
      d: {
       e: {
        f: {
         g: {
          if ((e | 0) == 4) {
           break g;
          }
          v[31601] = 0;
          b = O(1256, a | 0, l + 524 | 0) | 0;
          c = v[31601];
          v[31601] = 0;
          if ((c | 0) == 1) {
           break a;
          }
          if (b) {
           break g;
          }
          h: {
           i: {
            j: {
             k: {
              l: {
               switch (w[(l + 92 | 0) + e | 0]) {
               case 1:
                if ((e | 0) == 3) {
                 break c;
                }
                b = v[a >> 2];
                v[31601] = 0;
                b = Q(1257, b | 0) | 0;
                c = v[31601];
                v[31601] = 0;
                if ((c | 0) == 1) {
                 break a;
                }
                v[31601] = 0;
                b = T(1284, h | 0, 1, b | 0) | 0;
                c = v[31601];
                v[31601] = 0;
                if ((c | 0) == 1) {
                 break a;
                }
                if (b) {
                 v[31601] = 0;
                 N(1285, l + 12 | 0, a | 0);
                 b = v[31601];
                 v[31601] = 0;
                 if ((b | 0) != 1) {
                  v[31601] = 0;
                  N(35, s | 0, v[l + 12 >> 2]);
                  b = v[31601];
                  v[31601] = 0;
                  if ((b | 0) != 1) {
                   break k;
                  }
                 }
                 break a;
                }
                v[f >> 2] = v[f >> 2] | 4;
                a = 0;
                break d;

               case 4:
                break h;

               case 2:
                break i;

               case 3:
                break j;

               case 0:
                break l;

               default:
                break c;
               }
              }
              if ((e | 0) == 3) {
               break c;
              }
             }
             while (1) {
              v[31601] = 0;
              b = O(1256, a | 0, l + 524 | 0) | 0;
              c = v[31601];
              v[31601] = 0;
              if ((c | 0) == 1) {
               break a;
              }
              if (b) {
               break c;
              }
              b = v[a >> 2];
              v[31601] = 0;
              b = Q(1257, b | 0) | 0;
              c = v[31601];
              v[31601] = 0;
              if ((c | 0) == 1) {
               break a;
              }
              v[31601] = 0;
              b = T(1284, h | 0, 1, b | 0) | 0;
              c = v[31601];
              v[31601] = 0;
              if ((c | 0) == 1) {
               break a;
              }
              if (!b) {
               break c;
              }
              v[31601] = 0;
              N(1285, l + 12 | 0, a | 0);
              b = v[31601];
              v[31601] = 0;
              if ((b | 0) != 1) {
               v[31601] = 0;
               N(35, s | 0, v[l + 12 >> 2]);
               b = v[31601];
               v[31601] = 0;
               if ((b | 0) != 1) {
                continue;
               }
              }
              break;
             }
             break a;
            }
            m: {
             if (!Cb(v[n + 4 >> 2], w[n + 11 | 0])) {
              break m;
             }
             b = v[a >> 2];
             v[31601] = 0;
             b = Q(1257, b | 0) | 0;
             c = v[31601];
             v[31601] = 0;
             if ((c | 0) == 1) {
              break a;
             }
             if (v[Vd(n, 0) >> 2] != (b | 0)) {
              break m;
             }
             v[31601] = 0;
             Q(1259, a | 0) | 0;
             b = v[31601];
             v[31601] = 0;
             if ((b | 0) == 1) {
              break a;
             }
             t[g | 0] = 0;
             r = Cb(v[n + 4 >> 2], w[n + 11 | 0]) >>> 0 > 1 ? n : r;
             break c;
            }
            n: {
             o: {
              k = v[o + 4 >> 2];
              b = w[o + 11 | 0];
              if (Cb(k, b)) {
               b = v[a >> 2];
               v[31601] = 0;
               b = Q(1257, b | 0) | 0;
               c = v[31601];
               v[31601] = 0;
               if ((c | 0) == 1) {
                break a;
               }
               if (v[Vd(o, 0) >> 2] == (b | 0)) {
                break o;
               }
               k = v[o + 4 >> 2];
               b = w[o + 11 | 0];
              }
              c = Cb(v[n + 4 >> 2], w[n + 11 | 0]);
              if (!c) {
               break n;
              }
              if (!Cb(k, b)) {
               break n;
              }
              v[f >> 2] = v[f >> 2] | 4;
              a = 0;
              break d;
             }
             v[31601] = 0;
             Q(1259, a | 0) | 0;
             b = v[31601];
             v[31601] = 0;
             if ((b | 0) == 1) {
              break a;
             }
             t[g | 0] = 1;
             r = Cb(v[o + 4 >> 2], w[o + 11 | 0]) >>> 0 > 1 ? o : r;
             break c;
            }
            b = Cb(k, b);
            if (!(b | c)) {
             break c;
            }
            t[g | 0] = !b;
            break c;
           }
           if (!((e | 0) == 2 & w[l + 95 | 0] != 0 | (e >>> 0 < 2 | r | z))) {
            r = 0;
            break c;
           }
           b = ub(l + 12 | 0, yd(q));
           p: {
            if (!e | w[(e + l | 0) + 91 | 0] > 1) {
             break p;
            }
            q: {
             while (1) {
              c = ll(q);
              d = v[b >> 2];
              if (!Hb(d, c)) {
               break q;
              }
              c = v[d >> 2];
              v[31601] = 0;
              c = T(1284, h | 0, 1, c | 0) | 0;
              d = v[31601];
              v[31601] = 0;
              if ((d | 0) != 1) {
               if (!c) {
                break q;
               }
               Xe(b);
               continue;
              }
              break;
             }
             break a;
            }
            c = yd(q);
            c = Mv(v[b >> 2], c);
            if (Cb(v[s + 4 >> 2], w[s + 11 | 0]) >>> 0 >= c >>> 0) {
             c = Dk(ll(s), 0 - c | 0);
             d = ll(s);
             if (!id(c, yd(q), d - c & -4)) {
              break p;
             }
            }
            C = b, D = v[ub(l + 8 | 0, yd(q)) >> 2], v[C >> 2] = D;
           }
           v[l + 8 >> 2] = v[b >> 2];
           r: {
            while (1) {
             b = ll(q);
             if (!Hb(v[l + 8 >> 2], b)) {
              break r;
             }
             v[31601] = 0;
             b = O(1256, a | 0, l + 524 | 0) | 0;
             c = v[31601];
             v[31601] = 0;
             s: {
              if ((c | 0) == 1) {
               break s;
              }
              if (b) {
               break r;
              }
              b = v[a >> 2];
              v[31601] = 0;
              b = Q(1257, b | 0) | 0;
              c = v[31601];
              v[31601] = 0;
              if ((c | 0) == 1) {
               break s;
              }
              if (v[v[l + 8 >> 2] >> 2] != (b | 0)) {
               break r;
              }
              v[31601] = 0;
              Q(1259, a | 0) | 0;
              b = v[31601];
              v[31601] = 0;
              if ((b | 0) == 1) {
               break a;
              }
              Xe(l + 8 | 0);
              continue;
             }
             break;
            }
            break a;
           }
           if (!z) {
            break c;
           }
           b = ll(q);
           if (!Hb(v[l + 8 >> 2], b)) {
            break c;
           }
           v[f >> 2] = v[f >> 2] | 4;
           a = 0;
           break d;
          }
          b = 0;
          A = v[l + 84 >> 2];
          c = m;
          t: {
           while (1) {
            u: {
             v[31601] = 0;
             d = O(1256, a | 0, l + 524 | 0) | 0;
             k = v[31601];
             v[31601] = 0;
             if ((k | 0) == 1) {
              break u;
             }
             if (d) {
              break t;
             }
             d = v[a >> 2];
             v[31601] = 0;
             k = Q(1257, d | 0) | 0;
             d = v[31601];
             v[31601] = 0;
             if ((d | 0) == 1) {
              break a;
             }
             v[31601] = 0;
             d = T(1284, h | 0, 64, k | 0) | 0;
             B = v[31601];
             v[31601] = 0;
             if ((B | 0) == 1) {
              break a;
             }
             v: {
              if (d) {
               d = v[j >> 2];
               if ((d | 0) == v[l + 520 >> 2]) {
                v[31601] = 0;
                R(1286, i | 0, j | 0, l + 520 | 0);
                d = v[31601];
                v[31601] = 0;
                if ((d | 0) == 1) {
                 break a;
                }
                d = v[j >> 2];
               }
               v[j >> 2] = d + 4;
               v[d >> 2] = k;
               b = b + 1 | 0;
               break v;
              }
              if (!Cb(v[x + 4 >> 2], w[x + 11 | 0]) | !b | (k | 0) != (A | 0)) {
               break t;
              }
              if (v[l + 96 >> 2] == (m | 0)) {
               v[31601] = 0;
               R(1279, u | 0, l + 100 | 0, l + 96 | 0);
               c = v[31601];
               v[31601] = 0;
               if ((c | 0) == 1) {
                break a;
               }
               m = v[l + 100 >> 2];
              }
              c = m + 4 | 0;
              v[l + 100 >> 2] = c;
              v[m >> 2] = b;
              m = c;
              b = 0;
             }
             v[31601] = 0;
             Q(1259, a | 0) | 0;
             d = v[31601];
             v[31601] = 0;
             if ((d | 0) != 1) {
              continue;
             }
            }
            break;
           }
           break a;
          }
          if (!b | v[u >> 2] == (c | 0)) {
           break f;
          }
          if (v[l + 96 >> 2] == (c | 0)) {
           v[31601] = 0;
           R(1279, u | 0, l + 100 | 0, l + 96 | 0);
           c = v[31601];
           v[31601] = 0;
           if ((c | 0) == 1) {
            break a;
           }
           c = v[l + 100 >> 2];
          }
          m = c + 4 | 0;
          v[l + 100 >> 2] = m;
          v[c >> 2] = b;
          break e;
         }
         v[l + 20 >> 2] = y;
         w: {
          if (!r) {
           break w;
          }
          k = 1;
          while (1) {
           if (Cb(v[r + 4 >> 2], w[r + 11 | 0]) >>> 0 <= k >>> 0) {
            break w;
           }
           v[31601] = 0;
           b = O(1256, a | 0, l + 524 | 0) | 0;
           c = v[31601];
           v[31601] = 0;
           x: {
            if ((c | 0) == 1) {
             break x;
            }
            y: {
             if (!b) {
              b = v[a >> 2];
              v[31601] = 0;
              b = Q(1257, b | 0) | 0;
              c = v[31601];
              v[31601] = 0;
              if ((c | 0) == 1) {
               break x;
              }
              if (v[Vd(r, k) >> 2] == (b | 0)) {
               break y;
              }
             }
             v[f >> 2] = v[f >> 2] | 4;
             a = 0;
             break d;
            }
            v[31601] = 0;
            Q(1259, a | 0) | 0;
            b = v[31601];
            v[31601] = 0;
            k = k + 1 | 0;
            if ((b | 0) != 1) {
             continue;
            }
           }
           break;
          }
          break a;
         }
         a = 1;
         b = v[u >> 2];
         if ((b | 0) == (m | 0)) {
          break d;
         }
         a = 0;
         v[l + 12 >> 2] = 0;
         Uf(x, b, m, l + 12 | 0);
         if (v[l + 12 >> 2]) {
          v[f >> 2] = v[f >> 2] | 4;
          break d;
         }
         a = 1;
         break d;
        }
        m = c;
       }
       z: {
        if ((y | 0) <= 0) {
         break z;
        }
        v[31601] = 0;
        b = O(1256, a | 0, l + 524 | 0) | 0;
        c = v[31601];
        v[31601] = 0;
        if ((c | 0) == 1) {
         break a;
        }
        A: {
         if (!b) {
          b = v[a >> 2];
          v[31601] = 0;
          b = Q(1257, b | 0) | 0;
          c = v[31601];
          v[31601] = 0;
          if ((c | 0) == 1) {
           break a;
          }
          if (v[l + 88 >> 2] == (b | 0)) {
           break A;
          }
         }
         v[f >> 2] = v[f >> 2] | 4;
         a = 0;
         break d;
        }
        v[31601] = 0;
        b = Q(1259, a | 0) | 0;
        c = v[31601];
        v[31601] = 0;
        if ((c | 0) == 1) {
         break a;
        }
        while (1) {
         if ((y | 0) <= 0) {
          y = 0;
          break z;
         }
         v[31601] = 0;
         c = O(1256, b | 0, l + 524 | 0) | 0;
         d = v[31601];
         v[31601] = 0;
         B: {
          if ((d | 0) == 1) {
           break B;
          }
          C: {
           if (!c) {
            c = v[b >> 2];
            v[31601] = 0;
            c = Q(1257, c | 0) | 0;
            d = v[31601];
            v[31601] = 0;
            if ((d | 0) == 1) {
             break B;
            }
            v[31601] = 0;
            c = T(1284, h | 0, 64, c | 0) | 0;
            d = v[31601];
            v[31601] = 0;
            if ((d | 0) == 1) {
             break B;
            }
            if (c) {
             break C;
            }
           }
           v[f >> 2] = v[f >> 2] | 4;
           a = 0;
           break d;
          }
          if (v[j >> 2] == v[l + 520 >> 2]) {
           v[31601] = 0;
           R(1286, i | 0, j | 0, l + 520 | 0);
           c = v[31601];
           v[31601] = 0;
           if ((c | 0) == 1) {
            break B;
           }
          }
          c = v[b >> 2];
          v[31601] = 0;
          c = Q(1257, c | 0) | 0;
          d = v[31601];
          v[31601] = 0;
          if ((d | 0) == 1) {
           break B;
          }
          d = v[j >> 2];
          v[j >> 2] = d + 4;
          v[d >> 2] = c;
          v[31601] = 0;
          Q(1259, b | 0) | 0;
          c = v[31601];
          v[31601] = 0;
          y = y - 1 | 0;
          if ((c | 0) != 1) {
           continue;
          }
         }
         break;
        }
        break a;
       }
       if (v[j >> 2] != v[i >> 2]) {
        break c;
       }
       v[f >> 2] = v[f >> 2] | 4;
       a = 0;
      }
      Tb(s);
      Tb(o);
      Tb(n);
      Tb(q);
      sb(x);
      Kc(u);
      break b;
     }
     e = e + 1 | 0;
     continue;
    }
   }
   break a;
  }
  eb = l + 528 | 0;
  return a | 0;
 }
 a = M() | 0;
 Tb(s);
 Tb(o);
 Tb(n);
 Tb(q);
 sb(x);
 Kc(u);
 P(a | 0);
 p();
}

function OO(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0;
 f = eb - 32 | 0;
 eb = f;
 d = Cc(f + 20 | 0, 11600);
 e = nh(c, d);
 sb(d);
 a: {
  b: {
   c: {
    d: {
     e: {
      if (e) {
       qo(a, v[b + 24 >> 2] + 1298356 | 0);
       break e;
      }
      d = Cc(f + 20 | 0, 11005);
      e = nh(c, d);
      sb(d);
      if (e) {
       qo(a, v[b + 24 >> 2] + 1298344 | 0);
       break e;
      }
      d = Cc(f + 20 | 0, 11430);
      e = nh(c, d);
      sb(d);
      if (e) {
       qo(a, v[b + 24 >> 2] + 1298392 | 0);
       break e;
      }
      d = Cc(f + 20 | 0, 10997);
      e = nh(c, d);
      sb(d);
      if (e) {
       qo(a, v[b + 24 >> 2] + 1298380 | 0);
       break e;
      }
      d = f + 20 | 0;
      e = Cc(d, 8243);
      g = nh(c, e);
      sb(e);
      if (g) {
       e = v[v[b + 24 >> 2] + 480184 >> 2];
       c = 0;
       f: {
        g: {
         while (1) {
          b = c;
          if ((b | 0) == 48) {
           break g;
          }
          c = b + 12 | 0;
          if ((e | 0) != v[b + 30960 >> 2]) {
           continue;
          }
          break;
         }
         c = eb - 32 | 0;
         eb = c;
         e = c + 8 | 0;
         Yw(e, v[b + 30968 >> 2]);
         v[31601] = 0;
         b = c + 20 | 0;
         R(123, b | 0, 0, e | 0);
         g = v[31601];
         v[31601] = 0;
         h: {
          i: {
           j: {
            if ((g | 0) != 1) {
             v[31601] = 0;
             N(12, d | 0, b | 0);
             g = v[31601];
             v[31601] = 0;
             if ((g | 0) == 1) {
              break j;
             }
             Tb(b);
             sb(e);
             eb = c + 32 | 0;
             break h;
            }
            a = M() | 0;
            break i;
           }
           a = M() | 0;
           Tb(c + 20 | 0);
          }
          sb(c + 8 | 0);
          P(a | 0);
          p();
         }
         break f;
        }
        Eb(d);
       }
       v[31601] = 0;
       N(1058, a | 0, d | 0);
       a = v[31601];
       v[31601] = 0;
       if ((a | 0) == 1) {
        break d;
       }
       sb(d);
       break e;
      }
      g = f + 20 | 0;
      d = Cc(g, 10982);
      e = nh(c, d);
      sb(d);
      if (e) {
       l = v[v[b + 24 >> 2] + 480184 >> 2];
       c = eb - 48 | 0;
       eb = c;
       h = ng(c + 36 | 0);
       d = Eb(g);
       b = 0;
       while (1) {
        if ((b | 0) != 48) {
         if (v[b + 30960 >> 2] == (l | 0)) {
          v[31601] = 0;
          e = O(1, c + 24 | 0, v[b + 30964 >> 2]) | 0;
          i = v[31601];
          v[31601] = 0;
          k: {
           l: {
            m: {
             n: {
              o: {
               p: {
                if ((i | 0) != 1) {
                 v[31601] = 0;
                 R(887, c + 16 | 0, h | 0, e | 0);
                 i = v[31601];
                 v[31601] = 0;
                 if ((i | 0) == 1) {
                  break n;
                 }
                 if (!w[c + 20 | 0]) {
                  break k;
                 }
                 if (!zd(v[d + 4 >> 2], w[d + 11 | 0])) {
                  v[31601] = 0;
                  i = O(1, c + 4 | 0, 18374) | 0;
                  k = v[31601];
                  v[31601] = 0;
                  if ((k | 0) == 1) {
                   break p;
                  }
                  v[31601] = 0;
                  O(74, d | 0, i | 0) | 0;
                  k = v[31601];
                  v[31601] = 0;
                  if ((k | 0) == 1) {
                   break o;
                  }
                  sb(i);
                 }
                 v[31601] = 0;
                 O(74, d | 0, e | 0) | 0;
                 i = v[31601];
                 v[31601] = 0;
                 if ((i | 0) != 1) {
                  break k;
                 }
                 b = M() | 0;
                 break m;
                }
                b = M() | 0;
                break l;
               }
               b = M() | 0;
               break m;
              }
              b = M() | 0;
              sb(i);
              break m;
             }
             b = M() | 0;
            }
            sb(e);
           }
           sb(d);
           yR(h);
           P(b | 0);
           p();
          }
          sb(e);
         }
         b = b + 12 | 0;
         continue;
        }
        break;
       }
       yR(h);
       eb = c + 48 | 0;
       v[31601] = 0;
       N(1058, a | 0, g | 0);
       a = v[31601];
       v[31601] = 0;
       if ((a | 0) != 1) {
        sb(g);
        break e;
       }
       c = M() | 0;
       sb(f + 20 | 0);
       break a;
      }
      d = Cc(f + 20 | 0, 8309);
      e = nh(c, d);
      sb(d);
      if (e) {
       qo(a, v[b + 24 >> 2] + 1298368 | 0);
       break e;
      }
      d = Cc(f + 20 | 0, 5620);
      e = nh(c, d);
      sb(d);
      if (e) {
       qo(a, v[b + 24 >> 2] + 1298320 | 0);
       break e;
      }
      d = f + 20 | 0;
      e = Cc(d, 12004);
      g = nh(c, e);
      sb(e);
      if (g) {
       ig(d, v[b + 24 >> 2] + 1298308 | 0);
       b = v[b + 24 >> 2];
       v[31601] = 0;
       R(1052, a | 0, b | 0, d | 0);
       a = v[31601];
       v[31601] = 0;
       if ((a | 0) != 1) {
        sb(d);
        break e;
       }
       c = M() | 0;
       sb(f + 20 | 0);
       break a;
      }
      d = Cc(f + 20 | 0, 11373);
      e = nh(c, d);
      sb(d);
      if (e) {
       d = _L(v[b + 24 >> 2]);
       c = v[d + 4 >> 2];
       q: {
        if (!lc(v[d >> 2], c)) {
         e = hw(c);
         d = eb - 32 | 0;
         eb = d;
         v[d + 8 >> 2] = 0;
         v[d + 12 >> 2] = 0;
         v[d + 16 >> 2] = 0;
         v[d >> 2] = 0;
         v[d + 4 >> 2] = 0;
         v[d + 24 >> 2] = 0;
         v[d + 28 >> 2] = 0;
         c = eb - 48 | 0;
         eb = c;
         HF(c + 24 | 0, e, e + 4 | 0, e + 8 | 0, e + 12 | 0, e + 16 | 0, e + 24 | 0);
         HF(c, d, d + 4 | 0, d + 8 | 0, d + 12 | 0, d + 16 | 0, d + 24 | 0);
         e = v[c + 28 >> 2];
         g = v[c + 4 >> 2];
         eb = c + 48 | 0;
         eb = d + 32 | 0;
         if (v[e >> 2] == v[g >> 2] & v[v[c + 24 >> 2] >> 2] == v[v[c >> 2] >> 2] & v[v[c + 32 >> 2] >> 2] == v[v[c + 8 >> 2] >> 2] & v[v[c + 36 >> 2] >> 2] == v[v[c + 12 >> 2] >> 2] & v[v[c + 40 >> 2] >> 2] == v[v[c + 16 >> 2] >> 2]) {
          e = v[c + 44 >> 2];
          g = v[c + 20 >> 2];
          c = v[e >> 2] == v[g >> 2] & v[e + 4 >> 2] == v[g + 4 >> 2];
         } else {
          c = 0;
         }
         if (!c) {
          break q;
         }
        }
        Eb(a);
        break e;
       }
       g = f + 20 | 0;
       b = v[b + 24 >> 2];
       e = hw(v[_L(b) + 4 >> 2]);
       h = v[b + 1298408 >> 2];
       d = eb - 512 | 0;
       eb = d;
       i = v[e + 32 >> 2];
       r: {
        if (i) {
         b = -1;
         j = Ee(+(i >>> 0) / 18.2);
         c = 2147483647;
         s: {
          if (j >= 0x8000000000000000) {
           break s;
          }
          b = 0;
          c = -2147483648;
          if (j <= -0x8000000000000000) {
           break s;
          }
          if (D(j) < 0x8000000000000000) {
           b = ~~j >>> 0;
           if (D(j) >= 1) {
            c = ~~(j > 0 ? F(H(j * 2.3283064365386963e-10), 4294967295) : I((j - +(~~j >>> 0 >>> 0)) * 2.3283064365386963e-10)) >>> 0;
           } else {
            c = 0;
           }
           break s;
          }
          c = -2147483648;
         }
         if ((h | 0) == 1) {
          h = v[e + 28 >> 2];
          v[d + 184 >> 2] = v[e + 24 >> 2];
          v[d + 188 >> 2] = h;
          h = v[e + 20 >> 2];
          v[d + 176 >> 2] = v[e + 16 >> 2];
          v[d + 180 >> 2] = h;
          h = v[e + 12 >> 2];
          v[d + 168 >> 2] = v[e + 8 >> 2];
          v[d + 172 >> 2] = h;
          h = v[e + 4 >> 2];
          v[d + 160 >> 2] = v[e >> 2];
          v[d + 164 >> 2] = h;
          Iu(d + 480 | 0, d + 160 | 0);
          e = v[d + 508 >> 2];
          v[d + 152 >> 2] = v[d + 504 >> 2];
          v[d + 156 >> 2] = e;
          e = v[d + 500 >> 2];
          v[d + 144 >> 2] = v[d + 496 >> 2];
          v[d + 148 >> 2] = e;
          e = v[d + 492 >> 2];
          v[d + 136 >> 2] = v[d + 488 >> 2];
          v[d + 140 >> 2] = e;
          e = v[d + 484 >> 2];
          v[d + 128 >> 2] = v[d + 480 >> 2];
          v[d + 132 >> 2] = e;
          e = d + 448 | 0;
          h = $A(yS(d + 128 | 0), gb);
          c = c + gb | 0;
          i = b;
          b = b + h | 0;
          c = i >>> 0 > b >>> 0 ? c + 1 | 0 : c;
          wS(e, xS(b, c), gb);
          b = v[d + 476 >> 2];
          v[d + 120 >> 2] = v[d + 472 >> 2];
          v[d + 124 >> 2] = b;
          b = v[d + 468 >> 2];
          v[d + 112 >> 2] = v[d + 464 >> 2];
          v[d + 116 >> 2] = b;
          b = v[d + 460 >> 2];
          v[d + 104 >> 2] = v[d + 456 >> 2];
          v[d + 108 >> 2] = b;
          b = v[d + 452 >> 2];
          v[d + 96 >> 2] = v[d + 448 >> 2];
          v[d + 100 >> 2] = b;
          CN(g, d + 96 | 0);
          break r;
         }
         h = v[e + 28 >> 2];
         v[d + 312 >> 2] = v[e + 24 >> 2];
         v[d + 316 >> 2] = h;
         h = v[e + 20 >> 2];
         v[d + 304 >> 2] = v[e + 16 >> 2];
         v[d + 308 >> 2] = h;
         h = v[e + 12 >> 2];
         v[d + 296 >> 2] = v[e + 8 >> 2];
         v[d + 300 >> 2] = h;
         h = v[e + 4 >> 2];
         v[d + 288 >> 2] = v[e >> 2];
         v[d + 292 >> 2] = h;
         Iu(d + 416 | 0, d + 288 | 0);
         e = v[d + 444 >> 2];
         v[d + 280 >> 2] = v[d + 440 >> 2];
         v[d + 284 >> 2] = e;
         e = v[d + 436 >> 2];
         v[d + 272 >> 2] = v[d + 432 >> 2];
         v[d + 276 >> 2] = e;
         e = v[d + 428 >> 2];
         v[d + 264 >> 2] = v[d + 424 >> 2];
         v[d + 268 >> 2] = e;
         e = v[d + 420 >> 2];
         v[d + 256 >> 2] = v[d + 416 >> 2];
         v[d + 260 >> 2] = e;
         e = d + 352 | 0;
         h = $A(yS(d + 256 | 0), gb);
         c = c + gb | 0;
         i = b;
         b = b + h | 0;
         c = i >>> 0 > b >>> 0 ? c + 1 | 0 : c;
         wS(e, xS(b, c), gb);
         b = v[d + 380 >> 2];
         v[d + 248 >> 2] = v[d + 376 >> 2];
         v[d + 252 >> 2] = b;
         b = v[d + 372 >> 2];
         v[d + 240 >> 2] = v[d + 368 >> 2];
         v[d + 244 >> 2] = b;
         b = v[d + 364 >> 2];
         v[d + 232 >> 2] = v[d + 360 >> 2];
         v[d + 236 >> 2] = b;
         b = v[d + 356 >> 2];
         v[d + 224 >> 2] = v[d + 352 >> 2];
         v[d + 228 >> 2] = b;
         Iu(d + 384 | 0, d + 224 | 0);
         b = v[d + 412 >> 2];
         v[d + 216 >> 2] = v[d + 408 >> 2];
         v[d + 220 >> 2] = b;
         b = v[d + 404 >> 2];
         v[d + 208 >> 2] = v[d + 400 >> 2];
         v[d + 212 >> 2] = b;
         b = v[d + 396 >> 2];
         v[d + 200 >> 2] = v[d + 392 >> 2];
         v[d + 204 >> 2] = b;
         b = v[d + 388 >> 2];
         v[d + 192 >> 2] = v[d + 384 >> 2];
         v[d + 196 >> 2] = b;
         FO(g, d + 192 | 0);
         break r;
        }
        if ((h | 0) == 1) {
         b = v[e + 28 >> 2];
         v[d + 56 >> 2] = v[e + 24 >> 2];
         v[d + 60 >> 2] = b;
         b = v[e + 20 >> 2];
         v[d + 48 >> 2] = v[e + 16 >> 2];
         v[d + 52 >> 2] = b;
         b = v[e + 12 >> 2];
         v[d + 40 >> 2] = v[e + 8 >> 2];
         v[d + 44 >> 2] = b;
         b = v[e + 4 >> 2];
         v[d + 32 >> 2] = v[e >> 2];
         v[d + 36 >> 2] = b;
         Iu(d + 320 | 0, d + 32 | 0);
         b = v[d + 348 >> 2];
         v[d + 24 >> 2] = v[d + 344 >> 2];
         v[d + 28 >> 2] = b;
         b = v[d + 340 >> 2];
         v[d + 16 >> 2] = v[d + 336 >> 2];
         v[d + 20 >> 2] = b;
         b = v[d + 332 >> 2];
         v[d + 8 >> 2] = v[d + 328 >> 2];
         v[d + 12 >> 2] = b;
         b = v[d + 324 >> 2];
         v[d >> 2] = v[d + 320 >> 2];
         v[d + 4 >> 2] = b;
         CN(g, d);
         break r;
        }
        b = v[e + 28 >> 2];
        v[d + 88 >> 2] = v[e + 24 >> 2];
        v[d + 92 >> 2] = b;
        b = v[e + 20 >> 2];
        v[d + 80 >> 2] = v[e + 16 >> 2];
        v[d + 84 >> 2] = b;
        b = v[e + 12 >> 2];
        v[d + 72 >> 2] = v[e + 8 >> 2];
        v[d + 76 >> 2] = b;
        b = v[e + 4 >> 2];
        v[d + 64 >> 2] = v[e >> 2];
        v[d + 68 >> 2] = b;
        FO(g, d - -64 | 0);
       }
       eb = d + 512 | 0;
       v[31601] = 0;
       N(1058, a | 0, g | 0);
       a = v[31601];
       v[31601] = 0;
       if ((a | 0) != 1) {
        sb(g);
        break e;
       }
       c = M() | 0;
       sb(f + 20 | 0);
       break a;
      }
      d = f + 20 | 0;
      e = Cc(d, 12273);
      g = nh(c, e);
      sb(e);
      if (g) {
       jV(d, v[b + 24 >> 2] + 1298332 | 0);
       t: {
        if (!zd(v[f + 24 >> 2], w[f + 31 | 0])) {
         break t;
        }
        c = v[v[b + 24 >> 2] + 480180 >> 2];
        u: {
         v: {
          if ((c | 0) == 33554432) {
           break v;
          }
          e = 1;
          if ((c | 0) == 32) {
           break u;
          }
          if ((c | 0) == 16384) {
           break v;
          }
          if ((c | 0) == 16777216) {
           break u;
          }
         }
         e = 2;
        }
        if ((e | 0) != 2) {
         v[31601] = 0;
         c = f + 8 | 0;
         N(1059, c | 0, b | 0);
         e = v[31601];
         v[31601] = 0;
         if ((e | 0) != 1) {
          yb(d, c);
          sb(c);
          break t;
         }
         break b;
        }
        v[31601] = 0;
        c = f + 8 | 0;
        N(1060, c | 0, b | 0);
        d = v[31601];
        v[31601] = 0;
        if ((d | 0) == 1) {
         break b;
        }
        d = yb(f + 20 | 0, c);
        sb(c);
        if (!zd(v[f + 24 >> 2], w[f + 31 | 0])) {
         break t;
        }
        v[31601] = 0;
        N(1059, c | 0, b | 0);
        e = v[31601];
        v[31601] = 0;
        if ((e | 0) == 1) {
         break b;
        }
        yb(d, c);
        sb(c);
       }
       b = v[b + 24 >> 2];
       v[31601] = 0;
       c = a;
       a = f + 20 | 0;
       R(1052, c | 0, b | 0, a | 0);
       b = v[31601];
       v[31601] = 0;
       if ((b | 0) != 1) {
        sb(a);
        break e;
       }
       break b;
      }
      d = f + 20 | 0;
      e = Cc(d, 5472);
      g = nh(c, e);
      sb(e);
      if (g) {
       jV(d, v[b + 24 >> 2] + 1298332 | 0);
       b = v[b + 24 >> 2];
       v[31601] = 0;
       R(1052, a | 0, b | 0, d | 0);
       a = v[31601];
       v[31601] = 0;
       if ((a | 0) != 1) {
        sb(d);
        break e;
       }
       c = M() | 0;
       sb(f + 20 | 0);
       break a;
      }
      i = c;
      c = Cc(f + 20 | 0, 7335);
      d = nh(i, c);
      sb(c);
      if (d) {
       a = Eb(a);
       c = vb(v[b + 68 >> 2]);
       v[f + 20 >> 2] = c;
       d = vb(v[b + 72 >> 2]);
       b = 1;
       while (1) {
        if (!Hb(c, d)) {
         break e;
        }
        if (!(b & 1)) {
         v[31601] = 0;
         O(984, a | 0, 22231) | 0;
         b = v[31601];
         v[31601] = 0;
         if ((b | 0) == 1) {
          break c;
         }
        }
        v[31601] = 0;
        O(837, a | 0, c | 0) | 0;
        b = v[31601];
        v[31601] = 0;
        if ((b | 0) == 1) {
         break c;
        }
        c = v[vm(f + 20 | 0) >> 2];
        b = 0;
        continue;
       }
      }
      Cc(a, 22256);
     }
     eb = f + 32 | 0;
     return;
    }
    c = M() | 0;
    sb(f + 20 | 0);
    break a;
   }
   c = M() | 0;
   sb(a);
   break a;
  }
  c = M() | 0;
  sb(f + 20 | 0);
 }
 P(c | 0);
 p();
}

function Osa(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, q = 0, r = 0, s = 0, y = 0, z = 0;
 e = eb - 256 | 0;
 eb = e;
 xc(b);
 f = eb - 16 | 0;
 eb = f;
 g = e + 99 | 0;
 o_(f + 8 | 0, g);
 i = v[f + 12 >> 2];
 ic(f, v[b >> 2], v[b + 8 >> 2], v[f + 8 >> 2], v[f + 12 >> 2]);
 h = v[f + 4 >> 2];
 if ((h | 0) == (i | 0)) {
  Ub(b, v[f + 12 >> 2]);
 }
 eb = f + 16 | 0;
 f = (i | 0) == (h | 0);
 if (!f) {
  n_(g);
 }
 a: {
  if (!f) {
   break a;
  }
  if (!p_(g)) {
   break a;
  }
  d = 1;
  if ((c | 0) == 64) {
   break a;
  }
  Cd(a, v[((w[e + 215 | 0] | w[e + 216 | 0] << 8) << 2) + 24752 >> 2]);
  v[a + 480208 >> 2] = v[a + 480208 >> 2] | 16777216;
  d = e + 36 | 0;
  f = tc(d, 13171);
  yb(a + 1298344 | 0, f);
  sb(f);
  f = tc(d, 10313);
  yb(a + 1298356 | 0, f);
  sb(f);
  g = eb - 16 | 0;
  eb = g;
  f = e + 4 | 0;
  i = tc(g + 4 | 0, 4389);
  Uc(f, i);
  sb(i);
  eb = g + 16 | 0;
  v[31601] = 0;
  U(229, d | 0, f | 0, w[e + 178 | 0], e + 175 | 0);
  g = v[31601];
  v[31601] = 0;
  b: {
   if ((g | 0) != 1) {
    yb(a + 1298368 | 0, d);
    sb(d);
    Db(f);
    Yh(a + 1298392 | 0, ((w[e + 215 | 0] | w[e + 216 | 0] << 8) << 2) + 24800 | 0);
    Yh(a + 1298380 | 0, v[((w[e + 215 | 0] | w[e + 216 | 0] << 8) << 2) + 24848 >> 2]);
    y = a, z = v[Ec(d, 4) >> 2], v[y + 1298404 >> 2] = z;
    Ue(f, 2, e + 103 | 0);
    Bc(d, f);
    yb(a + 1298308 | 0, d);
    sb(d);
    Ue(f, 2, e + 135 | 0);
    Bc(d, f);
    c: {
     if (!Md(d, 9750)) {
      v[31601] = 0;
      R(258, f | 0, 4, d | 0);
      d = v[31601];
      v[31601] = 0;
      if ((d | 0) == 1) {
       break c;
      }
      yb(a + 1298320 | 0, f);
      sb(f);
     }
     sb(e + 36 | 0);
     u[a + 480188 >> 1] = 32;
     i = a + 480280 | 0;
     h = e + 180 | 0;
     f = 0;
     d: {
      while (1) {
       if ((f | 0) != 32) {
        d = i + (f << 5) | 0;
        Ve(d);
        g = w[f + h | 0];
        e: {
         if (g >>> 0 <= 15) {
          v[e + 36 >> 2] = (g << 4 | 8) & 248;
          v[e + 4 >> 2] = 256;
          y = d, z = v[Bd(e + 36 | 0, e + 4 | 0) >> 2], u[y + 4 >> 1] = z;
          break e;
         }
         if ((g | 0) != 16) {
          if ((g | 0) != 255) {
           break e;
          }
          u[a + 480188 >> 1] = f;
          break d;
         }
         v[d >> 2] = 256;
         u[d + 4 >> 1] = 128;
        }
        f = f + 1 | 0;
        continue;
       }
       break;
      }
      f = x[a + 480188 >> 1];
     }
     d = 0;
     if (!(f & 65535)) {
      break a;
     }
     v[e + 36 >> 2] = w[e + 212 | 0] << 2;
     v[e + 4 >> 2] = 256;
     y = a, z = v[Gb(e + 36 | 0, e + 4 | 0) >> 2], v[y + 480200 >> 2] = z;
     v[a + 480196 >> 2] = w[e + 213 | 0];
     v[a + 480204 >> 2] = B(w[e + 214 | 0], 1e4);
     if (cd(b, w[e + 217 | 0] | w[e + 218 | 0] << 8 | (w[e + 219 | 0] << 16 | w[e + 220 | 0] << 24))) {
      _j(Wb(v[a + 484360 >> 2], w[a + 484376 | 0]), b, w[e + 221 | 0] + 1 | 0, 255, 254);
     }
     if (!cd(b, w[e + 227 | 0] | w[e + 228 | 0] << 8 | (w[e + 229 | 0] << 16 | w[e + 230 | 0] << 24))) {
      break a;
     }
     f = w[e + 235 | 0] + 1 | 0;
     u[a + 480190 >> 1] = f;
     l = a + 946304 | 0;
     k = a + 484380 | 0;
     m = e + 68 | 0;
     i = 1;
     while (1) {
      f: {
       g: {
        j = i & 65535;
        if (j >>> 0 > (f & 65535) >>> 0) {
         break g;
        }
        d = eb - 16 | 0;
        eb = d;
        g = e + 36 | 0;
        ac(d + 8 | 0, g, 62);
        f = v[d + 12 >> 2];
        ic(d, v[b >> 2], v[b + 8 >> 2], v[d + 8 >> 2], v[d + 12 >> 2]);
        h = v[d + 4 >> 2];
        if ((h | 0) == (f | 0)) {
         Ub(b, v[d + 12 >> 2]);
        }
        eb = d + 16 | 0;
        d = (f | 0) == (h | 0);
        if (!d) {
         Qb(g, 0, 62);
        }
        if (!d) {
         break g;
        }
        f = 0;
        d = k + B(j, 104) | 0;
        md(d, 0);
        h = e + 24 | 0;
        Ue(h, 2, g);
        g = e + 4 | 0;
        Bc(g, h);
        zc(l + (j << 5) | 0, g);
        sb(g);
        Ik(h, 2, m);
        Bc(g, h);
        Ae(d + 43 | 0, g);
        sb(g);
        g = w[e + 94 | 0] | w[e + 95 | 0] << 8;
        v[d + 24 >> 2] = g;
        if (!wn(v[a + 480180 >> 2])) {
         break f;
        }
        while (1) {
         if ((f | 0) == 16) {
          break f;
         }
         if ((g | 0) == x[(f << 1) + 24896 >> 1]) {
          t[d + 37 | 0] = f << 4;
          break f;
         } else {
          f = f + 1 | 0;
          continue;
         }
        }
       }
       h: {
        if (!(c & 2)) {
         break h;
        }
        if (!cd(b, w[e + 231 | 0] | w[e + 232 | 0] << 8 | (w[e + 233 | 0] << 16 | w[e + 234 | 0] << 24))) {
         break h;
        }
        f = 1;
        while (1) {
         d = f & 65535;
         if (d >>> 0 > x[a + 480190 >> 1]) {
          break h;
         }
         d = k + B(d, 104) | 0;
         cg(Yc(e + 36 | 0, u[d + 34 >> 1] & 1 ? 16 : 8, 1, 0, 1), d, b);
         f = f + 1 | 0;
         continue;
        }
       }
       o = a + 484344 | 0;
       Sf(o, w[e + 226 | 0] + 1 | 0);
       k = QD(tr(a));
       cd(b, w[e + 222 | 0] | w[e + 223 | 0] << 8 | (w[e + 224 | 0] << 16 | w[e + 225 | 0] << 24));
       s = c & 1;
       h = 0;
       l = 1;
       i: {
        j: {
         k: {
          while (1) {
           if (w[e + 226 | 0] < h >>> 0) {
            if (!(x[a + 480188 >> 1] == 4 & l) | v[a + 480180 >> 2] != 1) {
             break k;
            }
            c = v[a + 480208 >> 2] | 8454144;
            break j;
           }
           l: {
            d = fh(b);
            if (d >>> 0 >= 3) {
             c = e + 4 | 0;
             ge(c, b, d - 2 | 0);
             i = gc(e + 36 | 0, c);
             tb(c);
             m: {
              if (!s) {
               break m;
              }
              c = v[i >> 2];
              v[31601] = 0;
              c = Q(172, c | 0) | 0;
              d = v[31601];
              v[31601] = 0;
              if ((d | 0) == 1) {
               break l;
              }
              if (!c) {
               break m;
              }
              v[31601] = 0;
              c = T(196, o | 0, h & 65535, 64) | 0;
              d = v[31601];
              v[31601] = 0;
              if ((d | 0) == 1) {
               break l;
              }
              j = 0;
              if (!c) {
               break m;
              }
              while (1) {
               if ((j | 0) == 64) {
                break m;
               }
               c = Vb(v[o >> 2], h);
               af(e + 4 | 0, v[c >> 2], v[v[c + 48 >> 2] + 12 >> 2], j);
               n: {
                o: while (1) {
                 v[31601] = 0;
                 c = Q(197, i | 0) | 0;
                 d = v[31601];
                 v[31601] = 0;
                 if ((d | 0) == 1) {
                  break i;
                 }
                 if (!c) {
                  break n;
                 }
                 d = c & 31;
                 if (d >>> 0 >= x[a + 480188 >> 1]) {
                  break n;
                 }
                 f = Xc(v[e + 4 >> 2], d);
                 if (c & 32) {
                  v[31601] = 0;
                  d = e + 24 | 0;
                  N(198, d | 0, i | 0);
                  g = v[31601];
                  v[31601] = 0;
                  if ((g | 0) == 1) {
                   break i;
                  }
                  g = Ic(d);
                  d = w[e + 24 | 0];
                  if (d) {
                   d = (d & 127) - 1 | 0;
                   t[e + 24 | 0] = d;
                   d = (B((d & 240) >>> 4 | 0, 12) + (d & 15) | 0) + 13 | 0;
                   t[f | 0] = d;
                   l = PD(d) & l;
                  }
                  t[f + 1 | 0] = w[g | 0];
                 }
                 if (!(c & 64)) {
                  continue;
                 }
                 t[f + 2 | 0] = 0;
                 t[f + 3 | 0] = 0;
                 m = f + 5 | 0;
                 while (1) {
                  c = v[i >> 2];
                  v[31601] = 0;
                  c = T(150, c | 0, v[e + 44 >> 2], 2) | 0;
                  d = v[31601];
                  v[31601] = 0;
                  if ((d | 0) == 1) {
                   break i;
                  }
                  if (!c) {
                   continue o;
                  }
                  q = w[f + 5 | 0];
                  c = w[f + 3 | 0];
                  v[31601] = 0;
                  d = e + 24 | 0;
                  N(198, d | 0, i | 0);
                  g = v[31601];
                  v[31601] = 0;
                  if ((g | 0) != 1) {
                   g = w[Ic(d) | 0];
                   t[f + 5 | 0] = g;
                   r = w[e + 24 | 0];
                   d = w[(r & 31) + 24928 | 0];
                   t[f + 3 | 0] = d;
                   p: {
                    q: {
                     r: {
                      s: {
                       t: {
                        switch (d - 2 | 0) {
                        case 0:
                        case 1:
                         if (g >>> 0 < 224) {
                          break p;
                         }
                         n = 223;
                         if (v[a + 480180 >> 2] != 1) {
                          break s;
                         }
                         break p;

                        case 11:
                         t[e + 3 | 0] = 64;
                         d = w[Pb(m, e + 3 | 0) | 0];
                         t[m | 0] = d;
                         if (!$v(v[k + 88 >> 2], 1)) {
                          break p;
                         }
                         t[f + 4 | 0] = d;
                         t[f + 2 | 0] = 1;
                         t[f + 5 | 0] = q;
                         t[f + 3 | 0] = c;
                         d = c;
                         break r;

                        case 17:
                         u: {
                          switch (((g & 240) >>> 4 | 0) - 8 | 0) {
                          case 0:
                           t[f + 3 | 0] = 2;
                           t[f + 5 | 0] = g & 15 | 224;
                           break p;

                          case 1:
                           t[f + 3 | 0] = 3;
                           t[f + 5 | 0] = g & 15 | 224;
                           break p;

                          default:
                           break u;
                          }
                         }
                         if (Ti(v[k + 84 >> 2], 19)) {
                          break p;
                         }
                         Lr(f);
                         d = w[f + 3 | 0];
                         break r;

                        case 13:
                         c = v[k + 84 >> 2];
                         if (Ti(c, 15)) {
                          break p;
                         }
                         if (!Ti(c, 19)) {
                          break p;
                         }
                         t[f + 3 | 0] = 19;
                         t[f + 5 | 0] = g & 15 | 144;
                         break p;

                        case 18:
                         n = 145;
                         if ((g | 0) == 1) {
                          break s;
                         }
                         if ((g & 240) == 128) {
                          if (Ti(v[k + 84 >> 2], 20)) {
                           break q;
                          }
                          t[f + 3 | 0] = 19;
                          break p;
                         }
                         t[f + 3 | 0] = 0;
                         break p;

                        case 4:
                        case 5:
                         break t;

                        default:
                         break r;
                        }
                       }
                       n = g & 240;
                       if (!n) {
                        break p;
                       }
                      }
                      t[m | 0] = n;
                     }
                     if ((d & 255) != 20) {
                      break p;
                     }
                    }
                    d = w[f + 5 | 0];
                    if (w[f + 2 | 0] | (d & 240) != 128) {
                     break p;
                    }
                    t[f + 2 | 0] = 2;
                    t[f + 5 | 0] = q;
                    t[f + 3 | 0] = c;
                    t[f + 4 | 0] = (((d & 15) << 6 | 8) >>> 0) / 15;
                   }
                   if (!(r & 32)) {
                    continue o;
                   }
                   continue;
                  }
                  break;
                 }
                 break;
                }
                break i;
               }
               j = j + 1 | 0;
               continue;
              }
             }
             tb(i);
            }
            h = h + 1 | 0;
            continue;
           }
           break;
          }
          break i;
         }
         c = v[a + 480208 >> 2] & -8454145;
        }
        v[a + 480208 >> 2] = c;
        d = 1;
        if (!(w[e + 240 | 0] | w[e + 241 | 0] << 8 | (w[e + 242 | 0] << 16 | w[e + 243 | 0] << 24))) {
         break a;
        }
        if (!cd(b, w[e + 236 | 0] | w[e + 237 | 0] << 8 | (w[e + 238 | 0] << 16 | w[e + 239 | 0] << 24))) {
         break a;
        }
        cE(a + 1298332 | 0, b, w[e + 240 | 0] | w[e + 241 | 0] << 8 | (w[e + 242 | 0] << 16 | w[e + 243 | 0] << 24), 4);
        break a;
       }
       f = M() | 0;
       tb(i);
       break b;
      }
      u[d + 32 >> 1] = 64;
      g = w[e + 81 | 0] | w[e + 82 | 0] << 8 | (w[e + 83 | 0] << 16 | w[e + 84 | 0] << 24);
      v[d >> 2] = g;
      f = w[e + 93 | 0];
      if (f & 2) {
       v[d >> 2] = g >>> 1;
       u[d + 34 >> 1] = x[d + 34 >> 1] | 1;
      }
      v[d + 4 >> 2] = w[e + 85 | 0] | w[e + 86 | 0] << 8 | (w[e + 87 | 0] << 16 | w[e + 88 | 0] << 24);
      v[d + 8 >> 2] = (w[e + 89 | 0] | w[e + 90 | 0] << 8 | (w[e + 91 | 0] << 16 | w[e + 92 | 0] << 24)) - 1;
      if (f & 1) {
       u[d + 34 >> 1] = x[d + 34 >> 1] | 2;
      }
      v: {
       w: {
        if (!(f & 4)) {
         break w;
        }
        g = w[e + 96 | 0];
        if ((g | 0) == 255) {
         break w;
        }
        t[e + 4 | 0] = g;
        t[e + 24 | 0] = 64;
        y = d, z = w[Pb(e + 4 | 0, e + 24 | 0) | 0] << 2, u[y + 30 >> 1] = z;
        break v;
       }
       u[d + 34 >> 1] = x[d + 34 >> 1] | 32768;
      }
      x: {
       if (f & 8) {
        h = x[d + 34 >> 1] | 32;
        u[d + 34 >> 1] = h;
        f = w[e + 97 | 0];
        if (f >>> 0 <= 15) {
         v[e + 24 >> 2] = 256;
         v[e + 4 >> 2] = (f << 4 | 8) & 248;
         g = v[Bd(e + 4 | 0, e + 24 | 0) >> 2];
        } else {
         g = 128;
        }
        u[d + 28 >> 1] = g;
        u[d + 34 >> 1] = h & 65279 | ((f | 0) == 16) << 8;
        break x;
       }
       u[d + 28 >> 1] = 128;
      }
      i = i + 1 | 0;
      f = x[a + 480190 >> 1];
      continue;
     }
    }
    f = M() | 0;
    sb(e + 36 | 0);
    break b;
   }
   f = M() | 0;
   Db(e + 4 | 0);
  }
  P(f | 0);
  p();
 }
 eb = e + 256 | 0;
 return d | 0;
}

function Coa(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, q = 0, r = 0, s = 0;
 d = eb - 224 | 0;
 eb = d;
 xc(b);
 f = d + 160 | 0;
 a: {
  if (!yr(b, f)) {
   break a;
  }
  if (!zW(f)) {
   break a;
  }
  if (!Lb(v[b >> 2], v[b + 8 >> 2], Ac(yW(f), gb))) {
   break a;
  }
  e = 1;
  if ((c | 0) == 64) {
   break a;
  }
  Cd(a, 256);
  h = d + 148 | 0;
  oi(h, 2, f);
  e = d + 56 | 0;
  Bc(e, h);
  yb(a + 1298308 | 0, e);
  sb(e);
  f = w[d + 210 | 0] | w[d + 211 | 0] << 8;
  v[a + 480260 >> 2] = 64;
  v[a + 480264 >> 2] = 32767;
  u[a + 480188 >> 1] = 4;
  u[a + 480190 >> 1] = f;
  Kb(a + 1074312 | 0, 107, 1);
  f = w[d + 203 | 0];
  f = f ? f : 96;
  h = BC(f);
  v[a + 480196 >> 2] = f >>> 4;
  v[a + 480204 >> 2] = h;
  t[d + 56 | 0] = 64;
  r = a, s = w[Pb(d + 202 | 0, e) | 0] << 2, v[r + 480200 >> 2] = s;
  f = a + 480280 | 0;
  e = 0;
  b: {
   c: {
    d: {
     e: {
      f: {
       g: {
        while (1) {
         if ((e | 0) == 4) {
          h: {
           h = Mb(d + 148 | 0);
           m = Mb(d + 136 | 0);
           v[31601] = 0;
           O(149, b | 0, (w[d + 192 | 0] | w[d + 193 | 0] << 8) << 4) | 0;
           e = v[31601];
           v[31601] = 0;
           i: {
            if ((e | 0) == 1) {
             break i;
            }
            v[31601] = 0;
            T(213, b | 0, h | 0, w[d + 208 | 0] | w[d + 209 | 0] << 8) | 0;
            e = v[31601];
            v[31601] = 0;
            if ((e | 0) == 1) {
             break i;
            }
            v[31601] = 0;
            O(149, b | 0, (w[d + 194 | 0] | w[d + 195 | 0] << 8) << 4) | 0;
            e = v[31601];
            v[31601] = 0;
            if ((e | 0) == 1) {
             break i;
            }
            v[31601] = 0;
            T(213, b | 0, m | 0, w[d + 210 | 0] | w[d + 211 | 0] << 8) | 0;
            e = v[31601];
            v[31601] = 0;
            if ((e | 0) == 1) {
             break i;
            }
            v[31601] = 0;
            O(149, b | 0, ((w[d + 196 | 0] | w[d + 197 | 0] << 8) << 4) + 32 | 0) | 0;
            e = v[31601];
            v[31601] = 0;
            if ((e | 0) == 1) {
             break i;
            }
            e = w[a + 484376 | 0];
            f = v[a + 484360 >> 2];
            v[31601] = 0;
            N(330, Wb(f, e) | 0, w[d + 212 | 0] | w[d + 213 | 0] << 8);
            e = v[31601];
            v[31601] = 0;
            if ((e | 0) == 1) {
             break i;
            }
            e = Wb(v[a + 484360 >> 2], w[a + 484376 | 0]);
            r = d, s = vb(v[e >> 2]), v[r + 56 >> 2] = s;
            e = vb(v[e + 4 >> 2]);
            j: {
             while (1) {
              f = v[d + 56 >> 2];
              if (!Hb(f, e)) {
               e = 0;
               if (!BW(Wb(v[a + 484360 >> 2], w[a + 484376 | 0]))) {
                break b;
               }
               j = c & 2;
               n = a + 946304 | 0;
               o = a + 484380 | 0;
               k = d + 57 | 0;
               e = 1;
               break j;
              }
              v[31601] = 0;
              g = Q(197, b | 0) | 0;
              i = v[31601];
              v[31601] = 0;
              k: {
               if ((i | 0) == 1) {
                break k;
               }
               u[f >> 1] = g;
               v[31601] = 0;
               O(183, b | 0, 4) | 0;
               f = v[31601];
               v[31601] = 0;
               if ((f | 0) == 1) {
                break k;
               }
               fe(d + 56 | 0);
               continue;
              }
              break;
             }
             b = M() | 0;
             break c;
            }
            l: {
             m: {
              n: {
               o: {
                while (1) {
                 g = e & 65535;
                 if (g >>> 0 > (w[d + 210 | 0] | w[d + 211 | 0] << 8) >>> 0) {
                  break l;
                 }
                 f = $b(v[m >> 2], g - 1 | 0);
                 f = w[f | 0] | w[f + 1 | 0] << 8;
                 v[31601] = 0;
                 f = O(149, b | 0, f << 4) | 0;
                 i = v[31601];
                 v[31601] = 0;
                 p: {
                  if ((i | 0) != 1) {
                   if (f) {
                    break p;
                   }
                   e = 0;
                   break b;
                  }
                  b = M() | 0;
                  break c;
                 }
                 v[31601] = 0;
                 i = d + 56 | 0;
                 O(697, b | 0, i | 0) | 0;
                 f = v[31601];
                 v[31601] = 0;
                 if ((f | 0) == 1) {
                  break o;
                 }
                 v[31601] = 0;
                 l = o + B(g, 104) | 0;
                 R(698, i | 0, l | 0, 0);
                 f = v[31601];
                 v[31601] = 0;
                 if ((f | 0) == 1) {
                  break o;
                 }
                 q = d + 28 | 0;
                 Ik(q, 2, k);
                 v[31601] = 0;
                 f = d + 40 | 0;
                 N(218, f | 0, q | 0);
                 q = v[31601];
                 v[31601] = 0;
                 if ((q | 0) == 1) {
                  break n;
                 }
                 zc(n + (g << 5) | 0, f);
                 sb(f);
                 q: {
                  r: {
                   if (!j | !(w[d + 72 | 0] | w[d + 73 | 0] << 8 | (w[d + 74 | 0] << 16 | w[d + 75 | 0] << 24))) {
                    break r;
                   }
                   g = NW(i);
                   v[31601] = 0;
                   g = O(149, b | 0, g | 0) | 0;
                   i = v[31601];
                   v[31601] = 0;
                   if ((i | 0) == 1) {
                    break m;
                   }
                   if (!g) {
                    break r;
                   }
                   MW(f, w[d + 86 | 0], w[d + 87 | 0], 1);
                   v[31601] = 0;
                   T(215, f | 0, l | 0, b | 0) | 0;
                   f = v[31601];
                   v[31601] = 0;
                   if ((f | 0) == 1) {
                    break q;
                   }
                  }
                  e = e + 1 | 0;
                  continue;
                 }
                 break;
                }
                b = M() | 0;
                break c;
               }
               b = M() | 0;
               break c;
              }
              b = M() | 0;
              break c;
             }
             b = M() | 0;
             break c;
            }
            t[d + 27 | 0] = 1;
            n = 0;
            e = v[h >> 2];
            s: {
             if (lc(e, v[h + 4 >> 2]) | (w[d + 188 | 0] | w[d + 189 | 0] << 8) == 26) {
              break s;
             }
             f = w[e | 0] | w[e + 1 | 0] << 8;
             e = 0;
             v[31601] = 0;
             f = O(149, b | 0, f << 4) | 0;
             g = v[31601];
             v[31601] = 0;
             if ((g | 0) == 1) {
              break h;
             }
             if (!f) {
              break b;
             }
             v[31601] = 0;
             e = Q(189, b | 0) | 0;
             f = v[31601];
             v[31601] = 0;
             if ((f | 0) == 1) {
              break h;
             }
             if ((w[d + 188 | 0] | w[d + 189 | 0] << 8) != (e | 0)) {
              break s;
             }
             t[d + 27 | 0] = 0;
             n = 1;
            }
            o = c & 1;
            if (o) {
             v[31601] = 0;
             N(223, a + 484344 | 0, w[d + 208 | 0] | w[d + 209 | 0] << 8);
             c = v[31601];
             v[31601] = 0;
             if ((c | 0) == 1) {
              break h;
             }
            }
            i = a + 484344 | 0;
            f = 0;
            while (1) {
             t: {
              if (!o | (w[d + 208 | 0] | w[d + 209 | 0] << 8) >>> 0 <= f >>> 0) {
               break t;
              }
              v[31601] = 0;
              c = T(196, i | 0, f & 65535, 64) | 0;
              e = v[31601];
              v[31601] = 0;
              if ((e | 0) == 1) {
               break g;
              }
              if (!c) {
               break t;
              }
              c = $b(v[h >> 2], f);
              c = w[c | 0] | w[c + 1 | 0] << 8;
              v[31601] = 0;
              c = O(149, b | 0, c << 4) | 0;
              e = v[31601];
              v[31601] = 0;
              if ((e | 0) == 1) {
               break g;
              }
              e = 0;
              if (!c) {
               break b;
              }
              if (n) {
               v[31601] = 0;
               c = Q(189, b | 0) | 0;
               g = v[31601];
               v[31601] = 0;
               if ((g | 0) == 1) {
                break g;
               }
               if (c >>> 0 > 2112) {
                break b;
               }
              }
              u[d + 12 >> 1] = 65535;
              v[d + 28 >> 2] = 63;
              c = Vb(v[i >> 2], f);
              af(d + 40 | 0, v[c >> 2], v[v[c + 48 >> 2] + 12 >> 2], 0);
              u: while (1) {
               c = e;
               while (1) {
                if (c >>> 0 <= 63) {
                 v[31601] = 0;
                 e = Q(197, b | 0) | 0;
                 g = v[31601];
                 v[31601] = 0;
                 if ((g | 0) == 1) {
                  break f;
                 }
                 j = e << 24 >> 24;
                 if (!j) {
                  e = 64;
                  if ((c | 0) == 63) {
                   continue u;
                  }
                  e = Vb(v[i >> 2], f);
                  g = v[e >> 2];
                  j = v[v[e + 48 >> 2] + 12 >> 2];
                  e = c + 1 | 0;
                  af(d + 56 | 0, g, j, e);
                  c = v[d + 60 >> 2];
                  v[d + 40 >> 2] = v[d + 56 >> 2];
                  v[d + 44 >> 2] = c;
                  continue u;
                 }
                 e = Mg(d + 56 | 0);
                 g = j & 31;
                 if (g >>> 0 < x[a + 480188 >> 1]) {
                  e = Xc(v[d + 40 >> 2], g);
                 }
                 k = j & 255;
                 if (k & 32) {
                  v[31601] = 0;
                  g = d + 25 | 0;
                  N(198, g | 0, b | 0);
                  l = v[31601];
                  v[31601] = 0;
                  v: {
                   w: {
                    x: {
                     if ((l | 0) != 1) {
                      l = Ic(g);
                      g = w[d + 25 | 0];
                      if (g >>> 0 > 239) {
                       break x;
                      }
                      g = LW((B(g >>> 4 | 0, 12) + (g & 15) | 0) + 37 | 0);
                      break w;
                     }
                     b = M() | 0;
                     break c;
                    }
                    y: {
                     switch (g - 254 | 0) {
                     case 0:
                      break w;

                     case 1:
                      break y;

                     default:
                      break v;
                     }
                    }
                    g = 0;
                   }
                   t[e | 0] = g;
                  }
                  t[e + 1 | 0] = w[l | 0];
                 }
                 if (k & 64) {
                  v[31601] = 0;
                  g = Q(197, b | 0) | 0;
                  k = v[31601];
                  v[31601] = 0;
                  if ((k | 0) == 1) {
                   break e;
                  }
                  t[d + 25 | 0] = g;
                  t[e + 2 | 0] = 1;
                  t[d + 24 | 0] = 64;
                  r = e, s = w[Pb(d + 25 | 0, d + 24 | 0) | 0], t[r + 4 | 0] = s;
                 }
                 if ((j | 0) >= 0) {
                  continue;
                 }
                 v[31601] = 0;
                 g = d + 25 | 0;
                 N(198, g | 0, b | 0);
                 j = v[31601];
                 v[31601] = 0;
                 if ((j | 0) == 1) {
                  break d;
                 }
                 r = e, s = w[Ic(g) | 0], t[r + 5 | 0] = s;
                 AW(e, w[d + 25 | 0], c, 255, d + 12 | 0, d + 28 | 0);
                 continue;
                }
                break;
               }
               break;
              }
              c = x[d + 12 >> 1];
              if ((c | 0) != 65535) {
               ze(Vb(v[i >> 2], f), zn(We(Ne(d + 56 | 0, 12, c & 255), v[d + 28 >> 2])));
              }
              f = f + 1 | 0;
              continue;
             }
             break;
            }
            v[31601] = 0;
            b = O(1, d + 56 | 0, 6088) | 0;
            c = v[31601];
            v[31601] = 0;
            z: {
             A: {
              B: {
               if ((c | 0) != 1) {
                yb(a + 1298344 | 0, b);
                sb(b);
                v[31601] = 0;
                b = O(1, d + 40 | 0, 5274) | 0;
                c = v[31601];
                v[31601] = 0;
                if ((c | 0) == 1) {
                 break B;
                }
                yb(a + 1298356 | 0, b);
                sb(b);
                b = d + 28 | 0;
                r = a, s = v[Ec(b, 4) >> 2], v[r + 1298404 >> 2] = s;
                v[31601] = 0;
                c = d + 12 | 0;
                N(700, c | 0, 4405);
                e = v[31601];
                v[31601] = 0;
                if ((e | 0) == 1) {
                 break A;
                }
                v[31601] = 0;
                R(209, b | 0, c | 0, d + 27 | 0);
                e = v[31601];
                v[31601] = 0;
                if ((e | 0) == 1) {
                 break z;
                }
                yb(a + 1298368 | 0, b);
                sb(b);
                Db(c);
                e = 1;
                break b;
               }
               b = M() | 0;
               break c;
              }
              b = M() | 0;
              break c;
             }
             b = M() | 0;
             break c;
            }
            b = M() | 0;
            Db(d + 12 | 0);
            break c;
           }
           b = M() | 0;
           break c;
          }
         } else {
          h = f + (e << 5) | 0;
          Ve(h);
          u[h + 4 >> 1] = e & 1 ? 64 : 192;
          e = e + 1 | 0;
          continue;
         }
         break;
        }
        b = M() | 0;
        break c;
       }
       b = M() | 0;
       break c;
      }
      b = M() | 0;
      break c;
     }
     b = M() | 0;
     break c;
    }
    b = M() | 0;
   }
   nd(m);
   nd(h);
   P(b | 0);
   p();
  }
  nd(m);
  nd(h);
 }
 eb = d + 224 | 0;
 return e | 0;
}

function q7(a, b, c, d, e, f, g, h, i, j, k) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 f = f | 0;
 g = g | 0;
 h = h | 0;
 i = i | 0;
 j = j | 0;
 k = k | 0;
 var l = 0, m = 0, n = 0, o = 0, q = 0, r = 0, s = 0, u = 0, x = 0, y = 0, z = 0, A = 0, B = 0, C = 0, D = 0, E = 0;
 l = eb - 528 | 0;
 eb = l;
 v[l + 520 >> 2] = k;
 v[l + 524 >> 2] = b;
 a: {
  b: {
   if (sh(a, l + 524 | 0)) {
    v[f >> 2] = v[f >> 2] | 4;
    a = 0;
    break b;
   }
   v[l + 76 >> 2] = 1273;
   b = l + 76 | 0;
   u = Ce(l + 104 | 0, l + 112 | 0, b);
   m = v[u >> 2];
   v[l + 100 >> 2] = m;
   v[l + 96 >> 2] = m + 400;
   x = Eb(b);
   q = Eb(l - -64 | 0);
   n = Eb(l + 52 | 0);
   o = Eb(l + 40 | 0);
   s = Eb(l + 28 | 0);
   b = v[d >> 2];
   v[31601] = 0;
   ja(1276, c | 0, b | 0, l + 92 | 0, l + 91 | 0, l + 90 | 0, x | 0, q | 0, n | 0, o | 0, l + 24 | 0);
   b = v[31601];
   v[31601] = 0;
   if ((b | 0) != 1) {
    v[j >> 2] = v[i >> 2];
    z = e & 512;
    y = v[l + 24 >> 2];
    A = w[l + 95 | 0];
    B = w[l + 91 | 0];
    C = w[l + 90 | 0];
    d = m;
    e = 0;
    while (1) {
     c: {
      d: {
       e: {
        f: {
         if ((e | 0) == 4) {
          break f;
         }
         v[31601] = 0;
         b = O(1240, a | 0, l + 524 | 0) | 0;
         c = v[31601];
         v[31601] = 0;
         if ((c | 0) == 1) {
          break a;
         }
         if (b) {
          break f;
         }
         b = 0;
         g: {
          h: {
           i: {
            j: {
             k: {
              switch (w[(l + 92 | 0) + e | 0]) {
              case 1:
               if ((e | 0) == 3) {
                break c;
               }
               b = v[a >> 2];
               v[31601] = 0;
               b = Q(1241, b | 0) | 0;
               c = v[31601];
               v[31601] = 0;
               if ((c | 0) == 1) {
                break a;
               }
               if (If(v[h + 8 >> 2], 1, b)) {
                v[31601] = 0;
                N(1277, l + 16 | 0, a | 0);
                b = v[31601];
                v[31601] = 0;
                if ((b | 0) != 1) {
                 v[31601] = 0;
                 N(115, s | 0, t[l + 16 | 0]);
                 b = v[31601];
                 v[31601] = 0;
                 if ((b | 0) != 1) {
                  break j;
                 }
                }
                break a;
               }
               v[f >> 2] = v[f >> 2] | 4;
               a = 0;
               break d;

              case 4:
               break g;

              case 2:
               break h;

              case 3:
               break i;

              case 0:
               break k;

              default:
               break c;
              }
             }
             if ((e | 0) == 3) {
              break c;
             }
            }
            while (1) {
             v[31601] = 0;
             b = O(1240, a | 0, l + 524 | 0) | 0;
             c = v[31601];
             v[31601] = 0;
             if ((c | 0) == 1) {
              break a;
             }
             if (b) {
              break c;
             }
             b = v[a >> 2];
             v[31601] = 0;
             b = Q(1241, b | 0) | 0;
             c = v[31601];
             v[31601] = 0;
             if ((c | 0) == 1) {
              break a;
             }
             if (!If(v[h + 8 >> 2], 1, b)) {
              break c;
             }
             v[31601] = 0;
             N(1277, l + 16 | 0, a | 0);
             b = v[31601];
             v[31601] = 0;
             if ((b | 0) != 1) {
              v[31601] = 0;
              N(115, s | 0, t[l + 16 | 0]);
              b = v[31601];
              v[31601] = 0;
              if ((b | 0) != 1) {
               continue;
              }
             }
             break;
            }
            break a;
           }
           l: {
            if (!Cb(v[n + 4 >> 2], w[n + 11 | 0])) {
             break l;
            }
            b = v[a >> 2];
            v[31601] = 0;
            b = Q(1241, b | 0) | 0;
            c = v[31601];
            v[31601] = 0;
            if ((c | 0) == 1) {
             break a;
            }
            if (w[dc(n, 0) | 0] != (b & 255)) {
             break l;
            }
            v[31601] = 0;
            Q(1243, a | 0) | 0;
            b = v[31601];
            v[31601] = 0;
            if ((b | 0) == 1) {
             break a;
            }
            t[g | 0] = 0;
            r = Cb(v[n + 4 >> 2], w[n + 11 | 0]) >>> 0 > 1 ? n : r;
            break c;
           }
           m: {
            n: {
             k = v[o + 4 >> 2];
             b = w[o + 11 | 0];
             if (Cb(k, b)) {
              b = v[a >> 2];
              v[31601] = 0;
              b = Q(1241, b | 0) | 0;
              c = v[31601];
              v[31601] = 0;
              if ((c | 0) == 1) {
               break a;
              }
              if (w[dc(o, 0) | 0] == (b & 255)) {
               break n;
              }
              k = v[o + 4 >> 2];
              b = w[o + 11 | 0];
             }
             c = Cb(v[n + 4 >> 2], w[n + 11 | 0]);
             if (!c) {
              break m;
             }
             if (!Cb(k, b)) {
              break m;
             }
             v[f >> 2] = v[f >> 2] | 4;
             a = 0;
             break d;
            }
            v[31601] = 0;
            Q(1243, a | 0) | 0;
            b = v[31601];
            v[31601] = 0;
            if ((b | 0) == 1) {
             break a;
            }
            t[g | 0] = 1;
            r = Cb(v[o + 4 >> 2], w[o + 11 | 0]) >>> 0 > 1 ? o : r;
            break c;
           }
           b = Cb(k, b);
           if (!(b | c)) {
            break c;
           }
           t[g | 0] = !b;
           break c;
          }
          if (!(e >>> 0 < 2 | r | ((e | 0) == 2 & (A | 0) != 0 | z))) {
           r = 0;
           break c;
          }
          b = ub(l + 16 | 0, yd(q));
          o: {
           if (!e | w[(e + l | 0) + 91 | 0] > 1) {
            break o;
           }
           while (1) {
            p: {
             c = Cf(q);
             k = v[b >> 2];
             if (!Hb(k, c)) {
              break p;
             }
             if (!If(v[h + 8 >> 2], 1, t[k | 0])) {
              break p;
             }
             xe(b);
             continue;
            }
            break;
           }
           c = yd(q);
           c = yk(v[b >> 2], c);
           if (Cb(v[s + 4 >> 2], w[s + 11 | 0]) >>> 0 >= c >>> 0) {
            if (m0(bD(Cf(s), c), Cf(s), yd(q))) {
             break o;
            }
           }
           D = b, E = v[ub(l + 12 | 0, yd(q)) >> 2], v[D >> 2] = E;
          }
          v[l + 12 >> 2] = v[b >> 2];
          q: {
           while (1) {
            b = Cf(q);
            if (!Hb(v[l + 12 >> 2], b)) {
             break q;
            }
            v[31601] = 0;
            b = O(1240, a | 0, l + 524 | 0) | 0;
            c = v[31601];
            v[31601] = 0;
            r: {
             if ((c | 0) == 1) {
              break r;
             }
             if (b) {
              break q;
             }
             b = v[a >> 2];
             v[31601] = 0;
             b = Q(1241, b | 0) | 0;
             c = v[31601];
             v[31601] = 0;
             if ((c | 0) == 1) {
              break r;
             }
             if (w[v[l + 12 >> 2]] != (b & 255)) {
              break q;
             }
             v[31601] = 0;
             Q(1243, a | 0) | 0;
             b = v[31601];
             v[31601] = 0;
             if ((b | 0) == 1) {
              break a;
             }
             xe(l + 12 | 0);
             continue;
            }
            break;
           }
           break a;
          }
          if (!z) {
           break c;
          }
          b = Cf(q);
          if (!Hb(v[l + 12 >> 2], b)) {
           break c;
          }
          v[f >> 2] = v[f >> 2] | 4;
          a = 0;
          break d;
         }
         s: {
          while (1) {
           t: {
            v[31601] = 0;
            c = O(1240, a | 0, l + 524 | 0) | 0;
            k = v[31601];
            v[31601] = 0;
            if ((k | 0) == 1) {
             break t;
            }
            if (c) {
             break s;
            }
            c = v[a >> 2];
            v[31601] = 0;
            k = Q(1241, c | 0) | 0;
            c = v[31601];
            v[31601] = 0;
            if ((c | 0) == 1) {
             break a;
            }
            u: {
             if (If(v[h + 8 >> 2], 64, k)) {
              c = v[j >> 2];
              if ((c | 0) == v[l + 520 >> 2]) {
               v[31601] = 0;
               R(1278, i | 0, j | 0, l + 520 | 0);
               c = v[31601];
               v[31601] = 0;
               if ((c | 0) == 1) {
                break a;
               }
               c = v[j >> 2];
              }
              v[j >> 2] = c + 1;
              t[c | 0] = k;
              b = b + 1 | 0;
              break u;
             }
             if (!Cb(v[x + 4 >> 2], w[x + 11 | 0]) | !b | (k & 255) != (C | 0)) {
              break s;
             }
             if (v[l + 96 >> 2] == (d | 0)) {
              v[31601] = 0;
              R(1279, u | 0, l + 100 | 0, l + 96 | 0);
              c = v[31601];
              v[31601] = 0;
              if ((c | 0) == 1) {
               break a;
              }
              d = v[l + 100 >> 2];
             }
             m = d + 4 | 0;
             v[l + 100 >> 2] = m;
             v[d >> 2] = b;
             d = m;
             b = 0;
            }
            v[31601] = 0;
            Q(1243, a | 0) | 0;
            c = v[31601];
            v[31601] = 0;
            if ((c | 0) != 1) {
             continue;
            }
           }
           break;
          }
          break a;
         }
         if (!(!b | v[u >> 2] == (m | 0))) {
          if (v[l + 96 >> 2] == (m | 0)) {
           v[31601] = 0;
           R(1279, u | 0, l + 100 | 0, l + 96 | 0);
           c = v[31601];
           v[31601] = 0;
           if ((c | 0) == 1) {
            break a;
           }
           m = v[l + 100 >> 2];
          }
          c = m + 4 | 0;
          v[l + 100 >> 2] = c;
          v[m >> 2] = b;
          m = c;
         }
         if ((y | 0) <= 0) {
          break e;
         }
         v[31601] = 0;
         b = O(1240, a | 0, l + 524 | 0) | 0;
         c = v[31601];
         v[31601] = 0;
         if ((c | 0) == 1) {
          break a;
         }
         v: {
          if (!b) {
           b = v[a >> 2];
           v[31601] = 0;
           b = Q(1241, b | 0) | 0;
           c = v[31601];
           v[31601] = 0;
           if ((c | 0) == 1) {
            break a;
           }
           if ((b & 255) == (B | 0)) {
            break v;
           }
          }
          v[f >> 2] = v[f >> 2] | 4;
          a = 0;
          break d;
         }
         v[31601] = 0;
         b = Q(1243, a | 0) | 0;
         c = v[31601];
         v[31601] = 0;
         if ((c | 0) == 1) {
          break a;
         }
         while (1) {
          if ((y | 0) <= 0) {
           y = 0;
           break e;
          }
          v[31601] = 0;
          c = O(1240, b | 0, l + 524 | 0) | 0;
          d = v[31601];
          v[31601] = 0;
          w: {
           if ((d | 0) == 1) {
            break w;
           }
           x: {
            if (!c) {
             c = v[b >> 2];
             v[31601] = 0;
             c = Q(1241, c | 0) | 0;
             d = v[31601];
             v[31601] = 0;
             if ((d | 0) == 1) {
              break w;
             }
             if (If(v[h + 8 >> 2], 64, c)) {
              break x;
             }
            }
            v[f >> 2] = v[f >> 2] | 4;
            a = 0;
            break d;
           }
           if (v[j >> 2] == v[l + 520 >> 2]) {
            v[31601] = 0;
            R(1278, i | 0, j | 0, l + 520 | 0);
            c = v[31601];
            v[31601] = 0;
            if ((c | 0) == 1) {
             break w;
            }
           }
           c = v[b >> 2];
           v[31601] = 0;
           c = Q(1241, c | 0) | 0;
           d = v[31601];
           v[31601] = 0;
           if ((d | 0) == 1) {
            break w;
           }
           d = v[j >> 2];
           v[j >> 2] = d + 1;
           t[d | 0] = c;
           v[31601] = 0;
           Q(1243, b | 0) | 0;
           c = v[31601];
           v[31601] = 0;
           y = y - 1 | 0;
           if ((c | 0) != 1) {
            continue;
           }
          }
          break;
         }
         break a;
        }
        v[l + 24 >> 2] = y;
        y: {
         if (!r) {
          break y;
         }
         k = 1;
         while (1) {
          if (Cb(v[r + 4 >> 2], w[r + 11 | 0]) >>> 0 <= k >>> 0) {
           break y;
          }
          v[31601] = 0;
          b = O(1240, a | 0, l + 524 | 0) | 0;
          c = v[31601];
          v[31601] = 0;
          z: {
           if ((c | 0) == 1) {
            break z;
           }
           A: {
            if (!b) {
             b = v[a >> 2];
             v[31601] = 0;
             b = Q(1241, b | 0) | 0;
             c = v[31601];
             v[31601] = 0;
             if ((c | 0) == 1) {
              break z;
             }
             if (w[dc(r, k) | 0] == (b & 255)) {
              break A;
             }
            }
            v[f >> 2] = v[f >> 2] | 4;
            a = 0;
            break d;
           }
           v[31601] = 0;
           Q(1243, a | 0) | 0;
           b = v[31601];
           v[31601] = 0;
           k = k + 1 | 0;
           if ((b | 0) != 1) {
            continue;
           }
          }
          break;
         }
         break a;
        }
        a = 1;
        b = v[u >> 2];
        if ((b | 0) == (m | 0)) {
         break d;
        }
        a = 0;
        v[l + 16 >> 2] = 0;
        Uf(x, b, m, l + 16 | 0);
        if (v[l + 16 >> 2]) {
         v[f >> 2] = v[f >> 2] | 4;
         break d;
        }
        a = 1;
        break d;
       }
       d = m;
       if (v[j >> 2] != v[i >> 2]) {
        break c;
       }
       v[f >> 2] = v[f >> 2] | 4;
       a = 0;
      }
      sb(s);
      sb(o);
      sb(n);
      sb(q);
      sb(x);
      Kc(u);
      break b;
     }
     e = e + 1 | 0;
     continue;
    }
   }
   break a;
  }
  eb = l + 528 | 0;
  return a | 0;
 }
 a = M() | 0;
 sb(s);
 sb(o);
 sb(n);
 sb(q);
 sb(x);
 Kc(u);
 P(a | 0);
 p();
}

function Sia(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = C(0), j = 0, k = 0, l = 0;
 d = eb - 304 | 0;
 eb = d;
 e = -1;
 a: {
  b: {
   c: {
    if (!mk(v[(v[v[b >> 2] - 12 >> 2] + b | 0) + 16 >> 2])) {
     f = Im(d + 192 | 0, b);
     v[31601] = 0;
     b = O(461, d + 180 | 0, 14001) | 0;
     e = v[31601];
     v[31601] = 0;
     d: {
      e: {
       f: {
        g: {
         h: {
          i: {
           j: {
            k: {
             l: {
              m: {
               n: {
                o: {
                 p: {
                  q: {
                   r: {
                    s: {
                     t: {
                      u: {
                       v: {
                        w: {
                         x: {
                          y: {
                           z: {
                            A: {
                             if ((e | 0) != 1) {
                              v[31601] = 0;
                              v[d + 160 >> 2] = 83886084;
                              v[d + 164 >> 2] = 0;
                              e = d + 160 | 0;
                              R(462, f | 0, b | 0, e | 0);
                              g = v[31601];
                              v[31601] = 0;
                              if ((g | 0) == 1) {
                               break A;
                              }
                              Db(b);
                              t[d + 179 | 0] = 0;
                              v[31601] = 0;
                              b = O(461, e | 0, 14717) | 0;
                              e = v[31601];
                              v[31601] = 0;
                              if ((e | 0) == 1) {
                               break z;
                              }
                              v[31601] = 0;
                              R(463, f | 0, d + 179 | 0, b | 0);
                              e = v[31601];
                              v[31601] = 0;
                              if ((e | 0) == 1) {
                               break y;
                              }
                              Db(b);
                              c = Ec(d + 156 | 0, w[d + 179 | 0] ? 0 : c);
                              v[31601] = 0;
                              b = O(461, d + 144 | 0, 15833) | 0;
                              e = v[31601];
                              v[31601] = 0;
                              if ((e | 0) == 1) {
                               break x;
                              }
                              e = v[c >> 2];
                              v[31601] = 0;
                              U(922, f | 0, a + 40 | 0, b | 0, e | 0);
                              e = v[31601];
                              v[31601] = 0;
                              if ((e | 0) == 1) {
                               break w;
                              }
                              Db(b);
                              u[d + 142 >> 1] = 65535;
                              v[31601] = 0;
                              b = O(461, d + 128 | 0, 15530) | 0;
                              e = v[31601];
                              v[31601] = 0;
                              if ((e | 0) == 1) {
                               break v;
                              }
                              v[31601] = 0;
                              T(491, f | 0, d + 142 | 0, b | 0) | 0;
                              e = v[31601];
                              v[31601] = 0;
                              if ((e | 0) == 1) {
                               break u;
                              }
                              Db(b);
                              u[d + 126 >> 1] = 0;
                              v[31601] = 0;
                              b = O(461, d + 112 | 0, 15363) | 0;
                              e = v[31601];
                              v[31601] = 0;
                              if ((e | 0) == 1) {
                               break t;
                              }
                              v[31601] = 0;
                              T(491, f | 0, d + 126 | 0, b | 0) | 0;
                              e = v[31601];
                              v[31601] = 0;
                              if ((e | 0) == 1) {
                               break s;
                              }
                              Db(b);
                              u[a >> 1] = x[d + 126 >> 1];
                              v[31601] = 0;
                              b = O(461, d + 100 | 0, 15036) | 0;
                              e = v[31601];
                              v[31601] = 0;
                              if ((e | 0) == 1) {
                               break r;
                              }
                              c = v[c >> 2];
                              v[31601] = 0;
                              U(923, f | 0, a + 52 | 0, b | 0, c | 0);
                              c = v[31601];
                              v[31601] = 0;
                              if ((c | 0) == 1) {
                               break q;
                              }
                              Db(b);
                              v[31601] = 0;
                              b = O(461, d + 88 | 0, 14984) | 0;
                              c = v[31601];
                              v[31601] = 0;
                              if ((c | 0) == 1) {
                               break p;
                              }
                              v[31601] = 0;
                              R(914, f | 0, a + 36 | 0, b | 0);
                              c = v[31601];
                              v[31601] = 0;
                              if ((c | 0) == 1) {
                               break o;
                              }
                              Db(b);
                              v[31601] = 0;
                              b = O(461, d + 76 | 0, 15532) | 0;
                              c = v[31601];
                              v[31601] = 0;
                              if ((c | 0) == 1) {
                               break n;
                              }
                              v[31601] = 0;
                              h = a + 4 | 0;
                              R(924, f | 0, h | 0, b | 0);
                              c = v[31601];
                              v[31601] = 0;
                              if ((c | 0) == 1) {
                               break m;
                              }
                              Db(b);
                              v[31601] = 0;
                              b = O(461, d - -64 | 0, 15365) | 0;
                              c = v[31601];
                              v[31601] = 0;
                              if ((c | 0) == 1) {
                               break l;
                              }
                              v[31601] = 0;
                              c = a + 28 | 0;
                              R(925, f | 0, c | 0, b | 0);
                              e = v[31601];
                              v[31601] = 0;
                              if ((e | 0) == 1) {
                               break k;
                              }
                              Db(b);
                              v[31601] = 0;
                              b = O(461, d + 52 | 0, 15220) | 0;
                              e = v[31601];
                              v[31601] = 0;
                              if ((e | 0) == 1) {
                               break j;
                              }
                              v[31601] = 0;
                              R(925, f | 0, a + 30 | 0, b | 0);
                              e = v[31601];
                              v[31601] = 0;
                              if ((e | 0) == 1) {
                               break i;
                              }
                              Db(b);
                              v[31601] = 0;
                              b = O(461, d + 40 | 0, 15008) | 0;
                              e = v[31601];
                              v[31601] = 0;
                              if ((e | 0) == 1) {
                               break h;
                              }
                              v[31601] = 0;
                              R(926, f | 0, a + 32 | 0, b | 0);
                              e = v[31601];
                              v[31601] = 0;
                              if ((e | 0) == 1) {
                               break g;
                              }
                              Db(b);
                              u[d + 38 >> 1] = 0;
                              v[31601] = 0;
                              b = O(461, d + 24 | 0, 14957) | 0;
                              e = v[31601];
                              v[31601] = 0;
                              if ((e | 0) == 1) {
                               break c;
                              }
                              v[31601] = 0;
                              T(491, f | 0, d + 38 | 0, b | 0) | 0;
                              e = v[31601];
                              v[31601] = 0;
                              if ((e | 0) == 1) {
                               break f;
                              }
                              Db(b);
                              i = QQ(z[a + 32 >> 2]);
                              z[a + 32 >> 2] = i;
                              e = -1;
                              if (!Tm(i)) {
                               break d;
                              }
                              b = vb(v[a + 4 >> 2]);
                              v[d + 20 >> 2] = b;
                              g = vb(v[a + 8 >> 2]);
                              while (1) {
                               if (!Hb(b, g)) {
                                break e;
                               }
                               if (!Tm(z[b >> 2])) {
                                break d;
                               }
                               b = v[Xe(d + 20 | 0) >> 2];
                               continue;
                              }
                             }
                             a = M() | 0;
                             break a;
                            }
                            a = M() | 0;
                            Db(b);
                            break a;
                           }
                           a = M() | 0;
                           break a;
                          }
                          a = M() | 0;
                          Db(b);
                          break a;
                         }
                         a = M() | 0;
                         break a;
                        }
                        a = M() | 0;
                        Db(b);
                        break a;
                       }
                       a = M() | 0;
                       break a;
                      }
                      a = M() | 0;
                      Db(b);
                      break a;
                     }
                     a = M() | 0;
                     break a;
                    }
                    a = M() | 0;
                    Db(b);
                    break a;
                   }
                   a = M() | 0;
                   break a;
                  }
                  a = M() | 0;
                  Db(b);
                  break a;
                 }
                 a = M() | 0;
                 break a;
                }
                a = M() | 0;
                Db(b);
                break a;
               }
               a = M() | 0;
               break a;
              }
              a = M() | 0;
              Db(b);
              break a;
             }
             a = M() | 0;
             break a;
            }
            a = M() | 0;
            Db(b);
            break a;
           }
           a = M() | 0;
           break a;
          }
          a = M() | 0;
          Db(b);
          break a;
         }
         a = M() | 0;
         break a;
        }
        a = M() | 0;
        Db(b);
        break a;
       }
       a = M() | 0;
       Db(b);
       break a;
      }
      if (ol(w[f | 0])) {
       break d;
      }
      b = x[c >> 1];
      if ((b - 301 & 65535) >>> 0 < 64935) {
       break d;
      }
      g = x[a >> 1];
      if (g >>> 0 > 3 | (g | 0) == 2) {
       break d;
      }
      j = u[a + 30 >> 1];
      if ((j | 0) < 0) {
       break d;
      }
      k = d, l = th(v[a + 36 >> 2]), v[k + 20 >> 2] = l;
      v[d + 16 >> 2] = 0;
      k = a, l = v[Yj(d + 20 | 0, d + 16 | 0, 42192) >> 2], v[k + 36 >> 2] = l;
      if (nc(v[a + 4 >> 2], v[a + 8 >> 2]) >>> 0 > 32767) {
       break d;
      }
      B: {
       C: {
        switch (g - 1 | 0) {
        case 2:
         c = u[d + 38 >> 1];
         if ((c | 0) <= 0) {
          break d;
         }
         u[d + 14 >> 1] = j;
         z[d + 20 >> 2] = z[a + 32 >> 2];
         v[31601] = 0;
         u[d + 16 >> 1] = b;
         u[d + 18 >> 1] = (b + c | 0) - 1;
         a = aa(927, a | 0, d + 14 | 0, d + 20 | 0, d + 16 | 0) | 0;
         b = v[31601];
         v[31601] = 0;
         if ((b | 0) != 1) {
          if (a) {
           break B;
          }
          break d;
         }
         a = M() | 0;
         break a;

        case 0:
         g = u[d + 38 >> 1];
         if ((g | 0) <= 0) {
          break d;
         }
         z[d + 20 >> 2] = z[a + 32 >> 2];
         v[31601] = 0;
         u[d + 16 >> 1] = b;
         u[d + 18 >> 1] = (b + g | 0) - 1;
         a = ga(928, a | 0, h | 0, d + 20 | 0, d + 16 | 0, c | 0) | 0;
         b = v[31601];
         v[31601] = 0;
         if ((b | 0) != 1) {
          if (a) {
           break B;
          }
          break d;
         }
         a = M() | 0;
         break a;

        default:
         break C;
        }
       }
       v[31601] = 0;
       V(929, a | 0);
       a = v[31601];
       v[31601] = 0;
       if ((a | 0) == 1) {
        break b;
       }
      }
      e = 1;
     }
     Bh(f);
    }
    eb = d + 304 | 0;
    return e | 0;
   }
   a = M() | 0;
   break a;
  }
  a = M() | 0;
 }
 Bh(f);
 P(a | 0);
 p();
}

function uS(a, b, c, d, e, f, g, h, i) {
 var j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, w = 0, x = 0, z = 0, A = 0, B = 0, C = 0, D = 0, F = 0, G = 0, H = 0, I = 0, J = 0, K = 0, L = 0, M = 0, N = 0, O = 0, P = 0, Q = 0, R = 0, S = 0;
 k = eb - 336 | 0;
 eb = k;
 m = h;
 n = i & 65535;
 o = d;
 p = e & 65535;
 s = (e ^ i) & -2147483648;
 z = i >>> 16 & 32767;
 u = e >>> 16 & 32767;
 a: {
  b: {
   if (z - 32767 >>> 0 > 4294934529 & u - 32767 >>> 0 >= 4294934530) {
    break b;
   }
   j = e & 2147483647;
   if (!(!d & (j | 0) == 2147418112 ? !(b | c) : j >>> 0 < 2147418112)) {
    r = d;
    s = e | 32768;
    break a;
   }
   e = i & 2147483647;
   if (!(!h & (e | 0) == 2147418112 ? !(f | g) : e >>> 0 < 2147418112)) {
    r = h;
    s = i | 32768;
    b = f;
    c = g;
    break a;
   }
   if (!(b | d | (j ^ 2147418112 | c))) {
    if (!(f | h | (e ^ 2147418112 | g))) {
     b = 0;
     c = 0;
     s = 2147450880;
     break a;
    }
    s = s | 2147418112;
    b = 0;
    c = 0;
    break a;
   }
   if (!(f | h | (e ^ 2147418112 | g))) {
    b = 0;
    c = 0;
    break a;
   }
   if (!(b | d | (c | j))) {
    b = !(f | h | (e | g));
    r = b ? 0 : r;
    s = b ? 2147450880 : s;
    b = 0;
    c = 0;
    break a;
   }
   if (!(f | h | (e | g))) {
    s = s | 2147418112;
    b = 0;
    c = 0;
    break a;
   }
   if ((j | 0) == 65535 | j >>> 0 < 65535) {
    d = !(o | p);
    i = d;
    j = d ? b : o;
    d = d << 6;
    i = E(i ? c : p);
    d = d + ((i | 0) == 32 ? E(j) + 32 | 0 : i) | 0;
    _f(k + 320 | 0, b, c, o, p, d - 15 | 0);
    q = 16 - d | 0;
    o = v[k + 328 >> 2];
    p = v[k + 332 >> 2];
    c = v[k + 324 >> 2];
    b = v[k + 320 >> 2];
   }
   if (e >>> 0 > 65535) {
    break b;
   }
   d = !(n | m);
   h = d;
   i = d ? f : m;
   d = d << 6;
   h = E(h ? g : n);
   d = d + ((h | 0) == 32 ? E(i) + 32 | 0 : h) | 0;
   _f(k + 304 | 0, f, g, m, n, d - 15 | 0);
   q = (d + q | 0) - 16 | 0;
   m = v[k + 312 >> 2];
   n = v[k + 316 >> 2];
   f = v[k + 304 >> 2];
   g = v[k + 308 >> 2];
  }
  e = n | 65536;
  A = e;
  B = m;
  d = m;
  j = e << 15 | d >>> 17;
  e = d << 15 | g >>> 17;
  d = e;
  i = 0 - d | 0;
  h = j;
  j = 1963258675 - (j + ((d | 0) != 0) | 0) | 0;
  Lf(k + 288 | 0, d, h, 0, 0, i, j, 0, 0);
  d = v[k + 296 >> 2];
  Lf(k + 272 | 0, 0 - d | 0, 0 - (v[k + 300 >> 2] + ((d | 0) != 0) | 0) | 0, 0, 0, i, j, 0, 0);
  d = v[k + 280 >> 2];
  i = d << 1 | v[k + 276 >> 2] >>> 31;
  d = v[k + 284 >> 2] << 1 | d >>> 31;
  Lf(k + 256 | 0, i, d, 0, 0, e, h, 0, 0);
  j = v[k + 264 >> 2];
  Lf(k + 240 | 0, i, d, 0, 0, 0 - j | 0, 0 - (v[k + 268 >> 2] + ((j | 0) != 0) | 0) | 0, 0, 0);
  i = v[k + 248 >> 2];
  j = i << 1 | v[k + 244 >> 2] >>> 31;
  d = v[k + 252 >> 2] << 1 | i >>> 31;
  Lf(k + 224 | 0, j, d, 0, 0, e, h, 0, 0);
  i = v[k + 232 >> 2];
  Lf(k + 208 | 0, j, d, 0, 0, 0 - i | 0, 0 - (v[k + 236 >> 2] + ((i | 0) != 0) | 0) | 0, 0, 0);
  d = v[k + 216 >> 2];
  i = d << 1 | v[k + 212 >> 2] >>> 31;
  d = v[k + 220 >> 2] << 1 | d >>> 31;
  Lf(k + 192 | 0, i, d, 0, 0, e, h, 0, 0);
  j = v[k + 200 >> 2];
  Lf(k + 176 | 0, i, d, 0, 0, 0 - j | 0, 0 - (v[k + 204 >> 2] + ((j | 0) != 0) | 0) | 0, 0, 0);
  i = e;
  e = v[k + 184 >> 2];
  d = h;
  m = e << 1 | v[k + 180 >> 2] >>> 31;
  h = m - 1 | 0;
  e = (v[k + 188 >> 2] << 1 | e >>> 31) - !m | 0;
  Lf(k + 160 | 0, i, d, 0, 0, h, e, 0, 0);
  d = h;
  Lf(k + 144 | 0, f << 15, g << 15 | f >>> 17, 0, 0, d, e, 0, 0);
  w = k + 112 | 0;
  C = v[k + 168 >> 2];
  h = v[k + 172 >> 2];
  m = v[k + 160 >> 2];
  i = v[k + 152 >> 2];
  l = m + i | 0;
  n = v[k + 164 >> 2];
  j = n + v[k + 156 >> 2] | 0;
  j = i >>> 0 > l >>> 0 ? j + 1 | 0 : j;
  i = j;
  j = (n | 0) == (j | 0) & l >>> 0 < m >>> 0 | j >>> 0 < n >>> 0;
  n = j + C | 0;
  j = j >>> 0 > n >>> 0 ? h + 1 | 0 : h;
  m = !i & l >>> 0 > 1 | (i | 0) != 0;
  h = n + m | 0;
  j = m >>> 0 > h >>> 0 ? j + 1 | 0 : j;
  Lf(w, d, e, 0, 0, 0 - h | 0, 0 - (((h | 0) != 0) + j | 0) | 0, 0, 0);
  Lf(k + 128 | 0, 1 - l | 0, 0 - ((l >>> 0 > 1) + i | 0) | 0, 0, 0, d, e, 0, 0);
  M = (u - z | 0) + q | 0;
  e = v[k + 116 >> 2];
  u = e;
  d = v[k + 112 >> 2];
  j = e << 1 | d >>> 31;
  i = d << 1;
  n = j;
  d = j;
  h = v[k + 140 >> 2];
  x = h;
  e = v[k + 136 >> 2];
  j = h << 1 | e >>> 31;
  l = e << 1 | v[k + 132 >> 2] >>> 31;
  h = l + i | 0;
  d = d + j | 0;
  d = h >>> 0 < l >>> 0 ? d + 1 | 0 : d;
  e = d;
  d = d - (h >>> 0 < 13927) | 0;
  t = d;
  w = d;
  l = 0;
  j = p | 65536;
  N = j;
  O = o;
  d = o;
  j = j << 1 | d >>> 31;
  Q = d << 1;
  R = j;
  H = j;
  d = Aua(t, l, j, 0);
  j = gb;
  D = d;
  F = j;
  J = b << 1;
  d = c << 1 | b >>> 31;
  z = d;
  C = d;
  j = 0;
  q = j;
  m = h - 13927 | 0;
  t = (e | 0) == (t | 0) & m >>> 0 < h >>> 0 | e >>> 0 > t >>> 0;
  e = (e | 0) == (n | 0) & h >>> 0 < i >>> 0 | e >>> 0 < n >>> 0;
  d = v[k + 120 >> 2];
  h = v[k + 124 >> 2] << 1 | d >>> 31;
  d = d << 1 | u >>> 31;
  l = x >>> 31 | 0;
  d = l + d | 0;
  j = h;
  j = d >>> 0 < l >>> 0 ? j + 1 | 0 : j;
  h = d;
  d = d + e | 0;
  j = h >>> 0 > d >>> 0 ? j + 1 | 0 : j;
  e = d;
  d = d + t | 0;
  l = e >>> 0 > d >>> 0 ? j + 1 | 0 : j;
  e = d - 1 | 0;
  G = l - !d | 0;
  x = 0;
  i = Aua(C, q, G, x);
  d = i + D | 0;
  h = gb + F | 0;
  h = d >>> 0 < i >>> 0 ? h + 1 | 0 : h;
  n = (F | 0) == (h | 0) & d >>> 0 < D >>> 0 | h >>> 0 < F >>> 0;
  D = e;
  P = c >>> 31 | 0;
  I = P | o << 1;
  t = 0;
  e = Aua(e, 0, I, t);
  o = e + d | 0;
  j = gb + h | 0;
  l = 0;
  j = e >>> 0 > o >>> 0 ? j + 1 | 0 : j;
  p = j;
  d = (j | 0) == (h | 0) & d >>> 0 > o >>> 0 | h >>> 0 > j >>> 0;
  e = d;
  d = d + n | 0;
  l = e >>> 0 > d >>> 0 ? 1 : l;
  e = Aua(H, q, G, x);
  d = e + d | 0;
  j = gb + l | 0;
  n = d;
  d = d >>> 0 < e >>> 0 ? j + 1 | 0 : j;
  e = Aua(H, q, D, t);
  l = gb;
  h = e;
  e = Aua(I, t, G, x);
  i = h + e | 0;
  j = gb + l | 0;
  j = e >>> 0 > i >>> 0 ? j + 1 | 0 : j;
  e = j;
  j = (l | 0) == (j | 0) & h >>> 0 > i >>> 0 | j >>> 0 < l >>> 0;
  l = n + e | 0;
  d = d + j | 0;
  d = l >>> 0 < e >>> 0 ? d + 1 | 0 : d;
  n = l;
  l = d;
  e = 0;
  d = e + o | 0;
  j = i + p | 0;
  j = d >>> 0 < e >>> 0 ? j + 1 | 0 : j;
  e = j;
  h = (j | 0) == (p | 0) & d >>> 0 < o >>> 0 | j >>> 0 < p >>> 0;
  j = l;
  i = h;
  h = h + n | 0;
  j = i >>> 0 > h >>> 0 ? j + 1 | 0 : j;
  u = h;
  l = j;
  o = d;
  F = m;
  d = Aua(m, 0, I, t);
  i = gb;
  h = d;
  m = Aua(w, r, C, r);
  d = d + m | 0;
  j = gb + i | 0;
  j = d >>> 0 < m >>> 0 ? j + 1 | 0 : j;
  m = (i | 0) == (j | 0) & d >>> 0 < h >>> 0 | i >>> 0 > j >>> 0;
  h = j;
  K = J & -2;
  i = Aua(D, t, K, 0);
  p = i + d | 0;
  j = gb + j | 0;
  j = i >>> 0 > p >>> 0 ? j + 1 | 0 : j;
  i = j;
  d = (j | 0) == (h | 0) & d >>> 0 > p >>> 0 | h >>> 0 > j >>> 0;
  h = 0;
  j = d + m | 0;
  d = (j >>> 0 < d >>> 0 ? 1 : h) + e | 0;
  n = j + o | 0;
  d = n >>> 0 < j >>> 0 ? d + 1 | 0 : d;
  j = l;
  m = d;
  d = (d | 0) == (e | 0) & n >>> 0 < o >>> 0 | d >>> 0 < e >>> 0;
  e = d;
  d = d + u | 0;
  j = e >>> 0 > d >>> 0 ? j + 1 | 0 : j;
  S = d;
  u = j;
  d = Aua(H, q, F, r);
  L = gb;
  H = d;
  e = Aua(G, x, K, r);
  d = d + e | 0;
  j = gb + L | 0;
  j = d >>> 0 < e >>> 0 ? j + 1 | 0 : j;
  o = d;
  l = Aua(w, r, I, t);
  e = d + l | 0;
  h = j;
  d = j + gb | 0;
  d = e >>> 0 < l >>> 0 ? d + 1 | 0 : d;
  q = e;
  j = Aua(C, r, D, t);
  e = e + j | 0;
  l = gb + d | 0;
  l = e >>> 0 < j >>> 0 ? l + 1 | 0 : l;
  G = (d | 0) == (l | 0) & e >>> 0 < q >>> 0 | d >>> 0 > l >>> 0;
  j = (h | 0) == (L | 0) & o >>> 0 < H >>> 0 | h >>> 0 < L >>> 0;
  d = (d | 0) == (h | 0) & o >>> 0 > q >>> 0 | d >>> 0 < h >>> 0;
  d = d + j | 0;
  d = d + G | 0;
  h = l;
  q = h + n | 0;
  j = (d | x) + m | 0;
  j = h >>> 0 > q >>> 0 ? j + 1 | 0 : j;
  o = j;
  d = (m | 0) == (j | 0) & n >>> 0 > q >>> 0 | j >>> 0 < m >>> 0;
  j = u;
  h = d;
  d = d + S | 0;
  j = h >>> 0 > d >>> 0 ? j + 1 | 0 : j;
  x = d;
  m = j;
  d = Aua(w, r, K, r);
  w = gb;
  n = d;
  h = Aua(C, r, F, r);
  d = d + h | 0;
  j = gb + w | 0;
  j = d >>> 0 < h >>> 0 ? j + 1 | 0 : j;
  u = 0;
  h = (j | 0) == (w | 0) & d >>> 0 < n >>> 0 | j >>> 0 < w >>> 0;
  n = j;
  d = j + p | 0;
  j = (h | u) + i | 0;
  j = d >>> 0 < n >>> 0 ? j + 1 | 0 : j;
  i = (i | 0) == (j | 0) & d >>> 0 < p >>> 0 | i >>> 0 > j >>> 0;
  h = j;
  j = e;
  p = 0;
  e = p + d | 0;
  l = h + j | 0;
  j = 0;
  l = e >>> 0 < p >>> 0 ? l + 1 | 0 : l;
  d = (h | 0) == (l | 0) & d >>> 0 > e >>> 0 | h >>> 0 > l >>> 0;
  e = d;
  d = d + i | 0;
  j = (e >>> 0 > d >>> 0 ? 1 : j) + o | 0;
  l = m;
  e = d;
  d = d + q | 0;
  j = e >>> 0 > d >>> 0 ? j + 1 | 0 : j;
  e = j;
  h = (o | 0) == (j | 0) & d >>> 0 < q >>> 0 | j >>> 0 < o >>> 0;
  i = h;
  h = h + x | 0;
  l = i >>> 0 > h >>> 0 ? l + 1 | 0 : l;
  i = l;
  c: {
   if ((l | 0) == 131071 | l >>> 0 < 131071) {
    O = Q | P;
    N = t | R;
    Lf(k + 80 | 0, d, j, h, l, f, g, B, A);
    l = v[k + 84 >> 2];
    q = l;
    j = b << 17;
    o = 0;
    p = v[k + 88 >> 2];
    c = o - p | 0;
    b = v[k + 80 >> 2];
    l = (l | b) != 0;
    m = c - l | 0;
    n = (j - (v[k + 92 >> 2] + (o >>> 0 < p >>> 0) | 0) | 0) - (c >>> 0 < l >>> 0) | 0;
    p = 0 - (((b | 0) != 0) + q | 0) | 0;
    q = M + 16382 | 0;
    o = 0 - b | 0;
    break c;
   }
   d = (e & 1) << 31 | d >>> 1;
   e = h << 31 | e >>> 1;
   h = (i & 1) << 31 | h >>> 1;
   i = i >>> 1 | 0;
   Lf(k + 96 | 0, d, e, h, i, f, g, B, A);
   m = v[k + 100 >> 2];
   z = m;
   n = 0;
   q = v[k + 104 >> 2];
   o = n - q | 0;
   l = v[k + 96 >> 2];
   p = (m | l) != 0;
   m = o - p | 0;
   n = ((b << 16) - (v[k + 108 >> 2] + (n >>> 0 < q >>> 0) | 0) | 0) - (o >>> 0 < p >>> 0) | 0;
   p = 0 - (((l | 0) != 0) + z | 0) | 0;
   J = b;
   z = c;
   q = M + 16383 | 0;
   o = 0 - l | 0;
  }
  if ((q | 0) >= 32767) {
   s = s | 2147418112;
   b = 0;
   c = 0;
   break a;
  }
  d: {
   if ((q | 0) > 0) {
    b = m << 1 | p >>> 31;
    c = n << 1 | m >>> 31;
    m = h;
    n = i & 65535 | q << 16;
    l = p << 1 | o >>> 31;
    h = o << 1;
    break d;
   }
   if ((q | 0) <= -113) {
    b = 0;
    c = 0;
    break a;
   }
   bn(k - -64 | 0, d, e, h, i, 1 - q | 0);
   _f(k + 48 | 0, J, z, O, N, q + 112 | 0);
   d = v[k + 64 >> 2];
   e = v[k + 68 >> 2];
   m = v[k + 72 >> 2];
   n = v[k + 76 >> 2];
   Lf(k + 32 | 0, f, g, B, A, d, e, m, n);
   b = v[k + 40 >> 2];
   c = v[k + 56 >> 2];
   i = v[k + 36 >> 2];
   p = b << 1 | i >>> 31;
   l = c - p | 0;
   p = v[k + 60 >> 2] - ((v[k + 44 >> 2] << 1 | b >>> 31) + (c >>> 0 < p >>> 0) | 0) | 0;
   c = v[k + 52 >> 2];
   q = c;
   b = v[k + 32 >> 2];
   h = i << 1 | b >>> 31;
   o = b << 1;
   b = o;
   j = v[k + 48 >> 2];
   c = (c | 0) == (h | 0) & b >>> 0 > j >>> 0 | c >>> 0 < h >>> 0;
   b = l - c | 0;
   c = p - (c >>> 0 > l >>> 0) | 0;
   l = q - ((j >>> 0 < o >>> 0) + h | 0) | 0;
   h = j - o | 0;
  }
  Lf(k + 16 | 0, f, g, B, A, 3, 0, 0, 0);
  Lf(k, f, g, B, A, 5, 0, 0, 0);
  o = d;
  p = d & 1;
  i = p;
  d = h + i | 0;
  j = 0;
  h = j + l | 0;
  h = d >>> 0 < i >>> 0 ? h + 1 | 0 : h;
  i = d;
  g = (g | 0) == (h | 0) & d >>> 0 > f >>> 0 | g >>> 0 < h >>> 0;
  l = c;
  d = (h | 0) == (j | 0) & d >>> 0 < p >>> 0 | h >>> 0 < j >>> 0;
  f = b + d | 0;
  l = d >>> 0 > f >>> 0 ? l + 1 | 0 : l;
  j = e;
  b = (l | 0) == (A | 0);
  b = b & (f | 0) == (B | 0) ? g : b & f >>> 0 > B >>> 0 | l >>> 0 > A >>> 0;
  c = b;
  b = b + o | 0;
  j = c >>> 0 > b >>> 0 ? j + 1 | 0 : j;
  c = j;
  d = (e | 0) == (j | 0) & b >>> 0 < o >>> 0 | e >>> 0 > j >>> 0;
  j = n;
  e = d;
  d = d + m | 0;
  j = e >>> 0 > d >>> 0 ? j + 1 | 0 : j;
  g = d;
  e = v[k + 20 >> 2];
  m = (e | 0) == (h | 0) & y[k + 16 >> 2] < i >>> 0 | e >>> 0 < h >>> 0;
  e = v[k + 28 >> 2];
  d = v[k + 24 >> 2];
  e = j >>> 0 < 2147418112 & ((d | 0) == (f | 0) & (e | 0) == (l | 0) ? m : (e | 0) == (l | 0) & d >>> 0 < f >>> 0 | e >>> 0 < l >>> 0);
  d = c;
  m = e;
  e = b + e | 0;
  d = m >>> 0 > e >>> 0 ? d + 1 | 0 : d;
  b = (c | 0) == (d | 0) & b >>> 0 > e >>> 0 | c >>> 0 > d >>> 0;
  c = b;
  b = b + g | 0;
  j = c >>> 0 > b >>> 0 ? j + 1 | 0 : j;
  g = b;
  c = v[k + 4 >> 2];
  h = (c | 0) == (h | 0) & y[k >> 2] < i >>> 0 | c >>> 0 < h >>> 0;
  c = v[k + 12 >> 2];
  b = v[k + 8 >> 2];
  b = j >>> 0 < 2147418112 & ((b | 0) == (f | 0) & (c | 0) == (l | 0) ? h : (c | 0) == (l | 0) & b >>> 0 < f >>> 0 | c >>> 0 < l >>> 0);
  c = b;
  b = b + e | 0;
  l = c >>> 0 > b >>> 0 ? d + 1 | 0 : d;
  c = l;
  e = (d | 0) == (l | 0) & b >>> 0 < e >>> 0 | d >>> 0 > l >>> 0;
  d = j;
  f = e;
  e = e + g | 0;
  d = f >>> 0 > e >>> 0 ? d + 1 | 0 : d;
  r = e | r;
  s = d | s;
 }
 v[a >> 2] = b;
 v[a + 4 >> 2] = c;
 v[a + 8 >> 2] = r;
 v[a + 12 >> 2] = s;
 eb = k + 336 | 0;
}

function opa(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, q = 0;
 g = eb - 128 | 0;
 eb = g;
 xc(b);
 a: {
  b: {
   c: {
    d: {
     e: {
      if (!rX(b, 14147)) {
       break e;
      }
      l = Mb(g + 116 | 0);
      j = Mb(g + 104 | 0);
      v[31601] = 0;
      v[g + 96 >> 2] = 0;
      v[g + 100 >> 2] = 0;
      N(246, a | 0, 32768);
      d = v[31601];
      v[31601] = 0;
      if ((d | 0) == 1) {
       break b;
      }
      v[31601] = 0;
      d = O(1, g + 84 | 0, 8169) | 0;
      e = v[31601];
      v[31601] = 0;
      if ((e | 0) == 1) {
       break c;
      }
      yb(a + 1298344 | 0, d);
      sb(d);
      v[31601] = 0;
      d = O(1, g + 72 | 0, 6060) | 0;
      e = v[31601];
      v[31601] = 0;
      if ((e | 0) == 1) {
       break d;
      }
      yb(a + 1298356 | 0, d);
      sb(d);
      o = a, q = v[Ec(g + 44 | 0, 28) >> 2], v[o + 1298404 >> 2] = q;
      k = a + 480280 | 0;
      n = (c | 0) == 64;
      while (1) {
       d = v[b + 8 >> 2];
       e = v[b >> 2];
       v[31601] = 0;
       d = T(150, e | 0, d | 0, 8) | 0;
       e = v[31601];
       v[31601] = 0;
       f: {
        g: {
         h: {
          if ((e | 0) != 1) {
           i: {
            j: {
             k: {
              l: {
               m: {
                n: {
                 if (!d) {
                  break n;
                 }
                 v[31601] = 0;
                 d = O(651, b | 0, g - -64 | 0) | 0;
                 e = v[31601];
                 v[31601] = 0;
                 if ((e | 0) == 1) {
                  break m;
                 }
                 if (!d) {
                  break n;
                 }
                 e = v[g + 68 >> 2];
                 v[31601] = 0;
                 d = g + 24 | 0;
                 R(185, d | 0, b | 0, _b(e) | 0);
                 e = v[31601];
                 v[31601] = 0;
                 if ((e | 0) == 1) {
                  break l;
                 }
                 e = gc(g + 44 | 0, d);
                 tb(d);
                 d = v[e >> 2];
                 v[31601] = 0;
                 d = Q(172, d | 0) | 0;
                 f = v[31601];
                 v[31601] = 0;
                 if ((f | 0) == 1) {
                  break j;
                 }
                 if (d) {
                  break k;
                 }
                 tb(e);
                }
                if (x[a + 480188 >> 1]) {
                 break i;
                }
                i = 0;
                break g;
               }
               a = M() | 0;
               break a;
              }
              a = M() | 0;
              break a;
             }
             o: {
              p: {
               q: {
                r: {
                 s: {
                  t: {
                   u: {
                    d = _b(v[g + 64 >> 2]);
                    if ((d | 0) != 1397769541) {
                     if ((d | 0) == 1346458708) {
                      break t;
                     }
                     if ((d | 0) == 1346522948) {
                      break s;
                     }
                     if ((d | 0) == 1347175758) {
                      break u;
                     }
                     if ((d | 0) != 1396788560) {
                      if ((d | 0) == 1396854596) {
                       break r;
                      }
                      if ((d | 0) == 1397507406) {
                       break f;
                      }
                      if ((d | 0) != 1129140036) {
                       break p;
                      }
                      if (x[a + 480188 >> 1]) {
                       break f;
                      }
                      d = v[e >> 2];
                      v[31601] = 0;
                      d = Q(154, d | 0) | 0;
                      f = v[31601];
                      v[31601] = 0;
                      if ((f | 0) == 1) {
                       break j;
                      }
                      if (d >>> 0 < 8) {
                       break f;
                      }
                      d = 0;
                      v[31601] = 0;
                      N(652, g + 24 | 0, e | 0);
                      f = v[31601];
                      v[31601] = 0;
                      if ((f | 0) == 1) {
                       break j;
                      }
                      while (1) if ((d | 0) == 4) {
                       if (!n) {
                        break f;
                       }
                       i = 1;
                       break o;
                      } else {
                       f = x[a + 480188 >> 1];
                       h = $b(g + 24 | 0, d);
                       v: {
                        if (!Ab(w[h | 0] | w[h + 1 | 0] << 8)) {
                         h = d - 1 | 0;
                         break v;
                        }
                        h = g + 96 | 0;
                        o = wb(h, f), q = 1, t[o | 0] = q;
                        o = wb(h, x[a + 480188 >> 1] + 1 | 0), q = 255, t[o | 0] = q;
                        Ve(k + (x[a + 480188 >> 1] << 5) | 0);
                        h = x[a + 480188 >> 1];
                        f = h + 1 | 0;
                        u[a + 480188 >> 1] = f;
                        m = k + (h << 5) | 0;
                        h = d - 1 | 0;
                        u[m + 4 >> 1] = (h & 65535) >>> 0 < 2 ? 192 : 64;
                       }
                       Ve(k + ((f & 65535) << 5) | 0);
                       f = x[a + 480188 >> 1];
                       u[a + 480188 >> 1] = f + 1;
                       u[(k + (f << 5) | 0) + 4 >> 1] = (h & 65535) >>> 0 < 2 ? 192 : 64;
                       d = d + 1 | 0;
                       continue;
                      }
                     }
                     if (x[a + 480190 >> 1]) {
                      break f;
                     }
                     v[31601] = 0;
                     N(653, e | 0, a | 0);
                     d = v[31601];
                     v[31601] = 0;
                     if ((d | 0) != 1) {
                      break f;
                     }
                     break j;
                    }
                    d = v[e >> 2];
                    v[31601] = 0;
                    d = Q(154, d | 0) | 0;
                    f = v[31601];
                    v[31601] = 0;
                    if ((f | 0) == 1) {
                     break j;
                    }
                    if (d >>> 0 < 2) {
                     break f;
                    }
                    v[31601] = 0;
                    d = Q(273, e | 0) | 0;
                    f = v[31601];
                    v[31601] = 0;
                    if ((f | 0) == 1) {
                     break j;
                    }
                    o = a, q = Kd(d, 1, 255), v[o + 480196 >> 2] = q;
                    break f;
                   }
                   d = v[e >> 2];
                   v[31601] = 0;
                   d = Q(154, d | 0) | 0;
                   f = v[31601];
                   v[31601] = 0;
                   if ((f | 0) == 1) {
                    break j;
                   }
                   if (d >>> 0 < 2) {
                    break f;
                   }
                   v[31601] = 0;
                   i = Q(273, e | 0) | 0;
                   d = v[31601];
                   v[31601] = 0;
                   if ((d | 0) != 1) {
                    break f;
                   }
                   break j;
                  }
                  d = w[a + 484376 | 0];
                  f = v[a + 484360 >> 2];
                  h = v[e >> 2];
                  v[31601] = 0;
                  h = Q(154, h | 0) | 0;
                  m = v[31601];
                  v[31601] = 0;
                  if ((m | 0) == 1) {
                   break j;
                  }
                  v[31601] = 0;
                  $(348, Wb(f, d) | 0, e | 0, h | 0, 255, 254);
                  d = v[31601];
                  v[31601] = 0;
                  if ((d | 0) == 1) {
                   break j;
                  }
                  break f;
                 }
                 d = l;
                 if (Rf(v[d >> 2], v[d + 4 >> 2]) >>> 0 >= 256) {
                  break f;
                 }
                 break q;
                }
                if (Rf(v[j >> 2], v[j + 4 >> 2]) >>> 0 > 3998) {
                 break f;
                }
                d = v[e >> 2];
                v[31601] = 0;
                f = Q(154, d | 0) | 0;
                d = v[31601];
                v[31601] = 0;
                if ((d | 0) == 1) {
                 break j;
                }
                d = j;
                if (!f) {
                 break f;
                }
               }
               v[31601] = 0;
               N(654, d | 0, e | 0);
               d = v[31601];
               v[31601] = 0;
               if ((d | 0) != 1) {
                break f;
               }
               break j;
              }
              if (!(d & -2139062144)) {
               break f;
              }
              i = 0;
             }
             tb(e);
             break g;
            }
            a = M() | 0;
            tb(e);
            break a;
           }
           v[a + 480200 >> 2] = 256;
           v[a + 480204 >> 2] = 125e4;
           v[a + 480260 >> 2] = 452;
           v[a + 480264 >> 2] = 3424;
           v[a + 480228 >> 2] = 48;
           v[a + 480232 >> 2] = 48;
           b = v[a + 484360 >> 2];
           d = w[a + 484376 | 0];
           v[31601] = 0;
           N(330, Wb(b, d) | 0, i & 65535);
           b = v[31601];
           v[31601] = 0;
           if ((b | 0) == 1) {
            break b;
           }
           w: {
            if (!(c & 1)) {
             break w;
            }
            b = v[l + 4 >> 2];
            i = v[l >> 2];
            d = 0;
            v[31601] = 0;
            N(223, a + 484344 | 0, Rf(i, b) & 65535);
            b = v[31601];
            v[31601] = 0;
            if ((b | 0) == 1) {
             break b;
            }
            while (1) {
             k = v[l >> 2];
             b = d & 65535;
             if (Rf(k, v[l + 4 >> 2]) >>> 0 <= b >>> 0) {
              break w;
             }
             v[31601] = 0;
             i = v[g + 100 >> 2];
             e = v[g + 96 >> 2];
             v[g + 16 >> 2] = e;
             v[g + 20 >> 2] = i;
             v[g + 8 >> 2] = e;
             v[g + 12 >> 2] = i;
             U(655, bh(k, b) | 0, b | 0, a | 0, g + 8 | 0);
             b = v[31601];
             v[31601] = 0;
             if ((b | 0) != 1) {
              d = d + 1 | 0;
              continue;
             }
             break;
            }
            a = M() | 0;
            break a;
           }
           e = a + 484380 | 0;
           k = c & 2;
           i = 1;
           d = 1;
           b = 0;
           while (1) {
            if (x[a + 480190 >> 1] <= d >>> 0) {
             break g;
            }
            if (!k | Rf(v[j >> 2], v[j + 4 >> 2]) >>> 0 <= b >>> 0) {
             break g;
            }
            c = e + B(d, 104) | 0;
            xp(c);
            x: {
             if (v[c >> 2]) {
              f = v[bh(v[j >> 2], b) >> 2];
              v[31601] = 0;
              f = Q(154, f | 0) | 0;
              h = v[31601];
              v[31601] = 0;
              if ((h | 0) == 1) {
               break h;
              }
              wc(c, f);
              f = Yc(g + 44 | 0, 8, 1, 1, 0);
              h = v[j >> 2];
              v[31601] = 0;
              T(215, f | 0, c | 0, bh(h, b) | 0) | 0;
              c = v[31601];
              v[31601] = 0;
              if ((c | 0) == 1) {
               break x;
              }
              b = b + 1 | 0;
             }
             d = d + 1 | 0;
             continue;
            }
            break;
           }
           a = M() | 0;
           break a;
          }
          a = M() | 0;
          break a;
         }
         a = M() | 0;
         break a;
        }
        Qc(j);
        Qc(l);
        break e;
       }
       tb(e);
       continue;
      }
     }
     eb = g + 128 | 0;
     return i | 0;
    }
    a = M() | 0;
    break a;
   }
   a = M() | 0;
   break a;
  }
  a = M() | 0;
 }
 Qc(j);
 Qc(l);
 P(a | 0);
 p();
}

function fT(a, b, c, d, e, f) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 f = f | 0;
 var g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = C(0), s = 0, A = 0, D = 0, E = C(0), F = C(0), G = 0, H = 0, I = C(0), J = 0;
 k = eb - 48 | 0;
 eb = k;
 Qj(b + 223848 | 0, Oj(e, Ei(e, Ro(e), 0)) + 1 | 0);
 oe(k + 40 | 0, v[b + 223848 >> 2], v[b + 223852 >> 2]);
 Yb(k + 32 | 0, e, Oj(e, Ei(e, Ro(e), 0)));
 D = v[k + 32 >> 2];
 q = v[k + 36 >> 2];
 i = eb - 16 | 0;
 eb = i;
 s = a + 906300 | 0;
 m = a + 1074312 | 0;
 e = B(c, 872) + b | 0;
 E = C(w[e + 1466 | 0]);
 F = C(f >>> 0);
 g = e + 616 | 0;
 o = v[e + 1272 >> 2];
 p = 1;
 l = 255;
 while (1) {
  if ((n | 0) != (q | 0) & y[k + 44 >> 2] > j >>> 0) {
   h = w[wb(D, n) | 0];
   e = h - 48 | 0;
   a: {
    b: {
     if ((e & 255) >>> 0 <= 9) {
      break b;
     }
     if ((h - 65 & 255) >>> 0 <= 5) {
      e = h - 55 | 0;
      break b;
     }
     c: {
      d: {
       e: {
        switch (h - 97 | 0) {
        case 2:
         f: {
          e = mm(a, b, c, 3, 0) - 1 | 0;
          if ((e & 255) >>> 0 > 249) {
           break f;
          }
          e = v[_d(s, e) >> 2];
          if (!e) {
           break f;
          }
          e = iB(e, 45864, 42920);
          if (!e) {
           break f;
          }
          e = hb[v[v[e >> 2] + 192 >> 2]](e, g, c) | 0;
          h = (e | 0) != 255;
          e = h ? e : 0;
          if (h | !o) {
           break b;
          }
          break c;
         }
         if (o) {
          break c;
         }
         e = 0;
         break b;

        case 21:
         g: {
          if (!Nb(m, 28)) {
           e = 0;
           if (!Nb(m, 1)) {
            break g;
           }
          }
          e = u[g + 776 >> 1];
         }
         h = B(v[g + 752 >> 2], v[g + 748 >> 2]);
         e = B(v[a + 1074456 >> 2], e + v[g + 688 >> 2] | 0);
         e = Xb((Fc(Bua(Aua(h, h >> 31, e, e >> 31), gb, 1048576, 0), gb) | 0) / 2 | 0, 1, 127);
         break d;

        case 20:
         e = B(v[g + 752 >> 2], v[g + 748 >> 2]);
         h = e;
         A = e >> 31;
         e = B(v[a + 1074456 >> 2], v[g + 720 >> 2]);
         e = Xb((Fc(Bua(Aua(h, A, e, e >> 31), gb, 67108864, 0), gb) | 0) / 2 | 0, 1, 127);
         break d;

        case 23:
         v[i >> 2] = v[g + 692 >> 2] / 2;
         v[i + 12 >> 2] = 127;
         e = v[Bd(i, i + 12 | 0) >> 2];
         break d;

        case 24:
         v[i >> 2] = v[g + 684 >> 2] / 2;
         v[i + 12 >> 2] = 127;
         e = v[Bd(i, i + 12 | 0) >> 2];
         break d;

        case 0:
         e = 0;
         if (!o) {
          break d;
         }
         h = x[o + 28 >> 1];
         if (!h) {
          break d;
         }
         e = h - 1 >>> 7 & 127;
         break d;

        case 1:
         e = 0;
         if (!o) {
          break d;
         }
         h = x[o + 28 >> 1];
         if (!h) {
          break d;
         }
         e = h - 1 & 127;
         break d;

        case 14:
         e = v[g + 664 >> 2] >>> 8 | 0;
         break d;

        case 7:
         e = (x[a + 480188 >> 1] <= c >>> 0 ? w[g + 786 | 0] - 1 | 0 : c) & 127;
         break d;

        case 12:
         e = w[g + 88 | 0] >>> 7 | 0;
         break d;

        case 15:
         e = 0;
         if (!o) {
          break d;
         }
         h = w[o + 30 | 0];
         if (!h) {
          break d;
         }
         e = h - 1 & 127;
         break d;

        case 25:
         h: {
          if (!d | t[g + 850 | 0] < 0) {
           break h;
          }
          i: {
           if (j >>> 0 < 3) {
            break i;
           }
           e = v[k + 40 >> 2];
           if (w[wb(e, j - 3 | 0) | 0] != 240) {
            break i;
           }
           if (w[wb(e, j - 2 | 0) | 0] > 239) {
            break h;
           }
          }
          r = Fq(b, E, F);
          j: {
           if (r < C(4294967296) & r >= C(0)) {
            e = ~~r >>> 0;
            break j;
           }
           e = 0;
          }
          t[g + 850 | 0] = e;
          l = 128;
          break d;
         }
         l = (l & 255) == 255 ? f : l;
         e = f;
         break d;

        case 18:
         k: {
          if (!j) {
           e = 0;
           break k;
          }
          h = v[k + 40 >> 2];
          e = j;
          while (1) {
           e = e - 1 | 0;
           A = wb(h, e);
           if (!e) {
            break k;
           }
           if (w[A | 0] != 240) {
            continue;
           }
           break;
          }
         }
         if (j - e >>> 0 < 5) {
          break a;
         }
         A = v[k + 40 >> 2];
         if (w[wb(A, e) | 0] != 240) {
          break a;
         }
         e = e + 5 | 0;
         h = 0;
         while (1) {
          if ((e | 0) != (j | 0)) {
           h = w[wb(A, e) | 0] + h | 0;
           e = e + 1 | 0;
           continue;
          }
          break;
         }
         ;
         e = 0 - h & 127;
         break d;

        case 13:
         break e;

        default:
         break a;
        }
       }
       e = w[g + 799 | 0];
       e = Tc(e) ? e - 1 | 0 : 0;
      }
      h = p ^ -1;
      p = 1;
      j = (h & 1) + j | 0;
      G = wb(v[k + 40 >> 2], j), H = e, t[G | 0] = H;
      j = j + 1 | 0;
      break a;
     }
     e = x[g + 786 >> 1];
     h = w[o + 31 | 0];
     e = (e ? e - 1 | 0 : c) & 15;
     l: {
      if ((h | 0) == 17) {
       break l;
      }
      e = Ij(h) ? h - 1 & 15 : 0;
     }
    }
    h = wb(v[k + 40 >> 2], j);
    t[h | 0] = (p & 1 ? 0 : w[h | 0] << 4) | e;
    p = p ^ 1;
    j = (p & 1) + j | 0;
   }
   n = n + 1 | 0;
   continue;
  } else {
   if (l << 24 >> 24 >= 0) {
    t[g + 850 | 0] = l;
   }
   ac(i, v[k + 40 >> 2], ((p ^ -1) & 1) + j | 0);
   e = v[i + 4 >> 2];
   v[k + 40 >> 2] = v[i >> 2];
   v[k + 44 >> 2] = e;
   eb = i + 16 | 0;
  }
  break;
 }
 o = v[k + 44 >> 2];
 j = 0;
 m: while (1) {
  p = 0;
  while (1) {
   l = p & 255;
   e = j;
   n: {
    o: {
     p: {
      q: {
       while (1) {
        if (y[k + 44 >> 2] <= e >>> 0) {
         break n;
        }
        f = v[k + 40 >> 2];
        g = wb(f, e);
        i = w[g | 0];
        if ((i | 0) == 240) {
         if (o - e >>> 0 >= 4) {
          j = 4;
          if ((w[wb(f, e + 1 | 0) | 0] & 254) == 240) {
           break o;
          }
         }
         j = e;
         r: {
          while (1) {
           j = j + 1 | 0;
           if (o >>> 0 <= j >>> 0) {
            break r;
           }
           if (w[wb(f, j) | 0] != 247) {
            continue;
           }
           break;
          }
          j = (j - e | 0) + 1 | 0;
          if (j) {
           break o;
          }
         }
         G = wb(f, o), H = 247, t[G | 0] = H;
         o = o + 1 | 0;
         j = o - e | 0;
         break p;
        }
        if (i << 24 >> 24 < 0) {
         break q;
        }
        if (l) {
         e = e - 1 | 0;
         G = wb(f, e), H = p, t[G | 0] = H;
         continue;
        }
        break;
       }
       j = j + 1 | 0;
       continue m;
      }
      G = k, H = oV(i), v[G + 20 >> 2] = H;
      v[k + 28 >> 2] = o - e;
      j = v[Gb(k + 20 | 0, k + 28 | 0) >> 2];
     }
     if (!j) {
      break n;
     }
     f = v[k + 40 >> 2];
     g = wb(f, e);
    }
    D = w[g | 0];
    wr(k + 20 | 0, f, v[k + 44 >> 2], e, j);
    f = Yb(k + 12 | 0, v[k + 20 >> 2], v[k + 24 >> 2]);
    g = v[f + 4 >> 2];
    v[k >> 2] = v[f >> 2];
    v[k + 4 >> 2] = g;
    i = eb - 32 | 0;
    eb = i;
    m = v[k + 4 >> 2];
    s: {
     if (!m) {
      break s;
     }
     l = Hd(w[b + 223884 | 0]);
     t: {
      h = v[k >> 2];
      q = wb(h, 0);
      f = w[q | 0] - 250 | 0;
      if (f >>> 0 > 5 | !(1 << f & 37)) {
       break t;
      }
      g = b + 616 | 0;
      n = x[a + 480188 >> 1];
      f = 0;
      while (1) {
       if ((f | 0) == (n | 0)) {
        break t;
       }
       s = g + B(f, 872) | 0;
       t[s + 837 | 0] = 127;
       t[s + 838 | 0] = 0;
       f = f + 1 | 0;
       continue;
      }
     }
     f = (B(c, 872) + b | 0) + 616 | 0;
     u: {
      if ((m | 0) != 4 | w[q | 0] != 240) {
       break u;
      }
      n = w[wb(h, 1) | 0];
      if ((n & 254) != 240) {
       break u;
      }
      m = wb(h, 2);
      g = t[wb(h, 3) | 0];
      q = (n | 0) != 241 & (g | 0) >= 0;
      h = w[m | 0];
      if (!(!q | h)) {
       if (d) {
        g = Ah(Fq(b, C(w[f + 837 | 0]), C((g & 255) >>> 0)));
       }
       t[f + 796 | 0] = 0;
       t[f + 837 | 0] = g;
       g = Kq(a, f, !(v[f + 88 >> 2] & 32768), 256);
       if ((g | 0) < 0 | !(w[f + 89 | 0] & 2)) {
        break s;
       }
       f = v[a + 1298300 >> 2];
       if (l | Dd(f) ^ 1) {
        break s;
       }
       Pq(f, c, g >>> 2 & 255, 1);
       break s;
      }
      m = h << 24 >> 24;
      if (q & (m | 0) == 1) {
       if (d) {
        g = Ah(Fq(b, C(w[f + 838 | 0]), C((g & 255) >>> 0)));
       }
       t[f + 795 | 0] = 0;
       t[f + 838 | 0] = g;
       Kq(a, f, !(v[f + 88 >> 2] & 32768), 256);
       break s;
      }
      if (!((n | 0) == 241 | (m | 0) != 2)) {
       if (g >>> 0 > 31) {
        break s;
       }
       t[f + 845 | 0] = (g & 240) >>> 4;
       Kq(a, f, !(v[f + 88 >> 2] & 32768), 256);
       break s;
      }
      if (!((n | 0) == 241 | (m | 0) != 3)) {
       f = mm(a, b, c, 3, 0) - 1 | 0;
       if ((g | 0) < 0 | (f & 255) >>> 0 > 249) {
        break s;
       }
       t[i + 24 | 0] = f;
       h = _d(a + 906300 | 0, f & 255);
       f = v[h >> 2];
       if (!f) {
        break s;
       }
       r = C(C(((g ^ 127) & 255) >>> 0) / C(127));
       if (l) {
        l = 0;
        g = eb - 16 | 0;
        eb = g;
        G = g, H = Pj(i + 24 | 0), v[G + 4 >> 2] = H;
        f = eb - 16 | 0;
        eb = f;
        n = b + 223860 | 0;
        m = hB(n, f + 12 | 0, w[i + 24 | 0]);
        h = v[m >> 2];
        if (!h) {
         l = eb - 16 | 0;
         eb = l;
         h = fc(n);
         q = Ch(f, Dc(24), Ng(l + 8 | 0, h));
         h = v[q >> 2];
         s = w[v[g + 4 >> 2]];
         v[h + 20 >> 2] = 0;
         t[h + 16 | 0] = s;
         G = fc(q), H = 1, t[G + 4 | 0] = H;
         eb = l + 16 | 0;
         _g(n, v[f + 12 >> 2], m, v[f >> 2]);
         h = me(f);
         Gk(f);
         l = 1;
        }
        Zg(g + 8 | 0, v[ub(f, h) >> 2], l);
        eb = f + 16 | 0;
        f = td(v[g + 8 >> 2]);
        eb = g + 16 | 0;
        z[f + 4 >> 2] = r;
        break s;
       }
       if (!d) {
        Ju(v[f + 20 >> 2], r);
        break s;
       }
       Ju(v[f + 20 >> 2], Fq(b, z[h + 144 >> 2], r));
       break s;
      }
      f = (m | 0) >= 0;
      m = (n | 0) != 241;
      if (f & m) {
       break s;
      }
      n = mm(a, b, c, 3, 0) - 1 | 0;
      if ((g | 0) < 0 | (n & 255) >>> 0 > 249) {
       break s;
      }
      f = v[_d(a + 906300 | 0, n & 255) >> 2];
      if (!f) {
       break s;
      }
      h = m ? h & 127 : h + 128 | 0;
      r = C(C((g & 255) >>> 0) / C(127));
      if (l) {
       G = vT(b + 223872 | 0, NS(i + 24 | 0, n, h)), I = r, z[G >> 2] = I;
       break s;
      }
      g = v[f >> 2];
      if (!d) {
       hb[v[g + 44 >> 2]](f, h, r);
       break s;
      }
      H = f, J = h, I = Fq(b, C(hb[v[g + 48 >> 2]](f, h)), r), G = v[v[f >> 2] + 44 >> 2], 
      hb[G](H | 0, J | 0, C(I));
      break s;
     }
     if (l) {
      break s;
     }
     l = x[a + 480188 >> 1];
     v: {
      if (l >>> 0 > c >>> 0) {
       g = c + 1 | 0;
       break v;
      }
      g = x[f + 786 >> 1];
      if (!g) {
       break s;
      }
     }
     if (w[f + 91 | 0] & 4 | l >>> 0 < (g & 65535) >>> 0) {
      break s;
     }
     f = mm(a, b, c, 3, 0) - 1 | 0;
     if (f >>> 0 > 249) {
      break s;
     }
     f = v[_d(a + 906300 | 0, f) >> 2];
     if (!f) {
      break s;
     }
     g = w[q | 0];
     if ((g | 0) == 240) {
      lf(i + 16 | 0, v[k >> 2], v[k + 4 >> 2]);
      g = v[v[f >> 2] + 72 >> 2];
      l = v[i + 20 >> 2];
      v[i >> 2] = v[i + 16 >> 2];
      v[i + 4 >> 2] = l;
      hb[g | 0](f, i) | 0;
      break s;
     }
     G = i, J = oV(g), v[G + 24 >> 2] = J;
     v[i + 12 >> 2] = m;
     g = i + 24 | 0;
     l = v[Gb(g, i + 12 | 0) >> 2];
     v[i + 24 >> 2] = 0;
     yc(g, h, l);
     hb[v[v[f >> 2] + 68 >> 2]](f, v[i + 24 >> 2]) | 0;
    }
    eb = i + 32 | 0;
    p = D >>> 0 < 240 ? D : p;
    j = e + j | 0;
    continue;
   }
   break;
  }
  break;
 }
 eb = k + 48 | 0;
}

function wpa(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, q = 0, r = 0, s = 0, z = 0, A = 0, C = 0;
 f = eb - 272 | 0;
 eb = f;
 xc(b);
 a: {
  b: {
   c: {
    e = f + 206 | 0;
    if (!B$(b, e)) {
     break c;
    }
    if (!zX(e)) {
     break c;
    }
    if (!Lb(v[b >> 2], v[b + 8 >> 2], Ac(yX(e), gb))) {
     break c;
    }
    d = 1;
    if ((c | 0) == 64) {
     break c;
    }
    Cd(a, 16);
    e = f + 44 | 0;
    oi(e, 2, f + 210 | 0);
    d = f - -64 | 0;
    Bc(d, e);
    yb(a + 1298308 | 0, d);
    sb(d);
    u[a + 480190 >> 1] = w[f + 236 | 0];
    u[a + 480188 >> 1] = w[f + 239 | 0];
    g = tc(d, 8365);
    yb(a + 1298344 | 0, g);
    sb(g);
    g = tc(d, 10129);
    yb(a + 1298356 | 0, g);
    sb(g);
    fg(e, 4211);
    g = w[f + 209 | 0];
    v[f + 24 >> 2] = g >>> 4;
    v[31601] = 0;
    v[f + 12 >> 2] = g & 15;
    U(307, d | 0, e | 0, f + 24 | 0, f + 12 | 0);
    g = v[31601];
    v[31601] = 0;
    if ((g | 0) != 1) {
     yb(a + 1298368 | 0, d);
     sb(d);
     Db(e);
     A = a, C = v[Ec(d, 4) >> 2], v[A + 1298404 >> 2] = C;
     m = a + 946304 | 0;
     o = a + 484380 | 0;
     d = 1;
     while (1) {
      k = d & 65535;
      if (k >>> 0 > x[a + 480190 >> 1]) {
       e = a + 480280 | 0;
       g = f + 240 | 0;
       d = 0;
       while (1) if (x[a + 480188 >> 1] <= d >>> 0) {
        e = f - -64 | 0;
        d = eb - 16 | 0;
        eb = d;
        k = b;
        d: {
         if (!Lb(v[b >> 2], v[b + 8 >> 2], 128)) {
          b = 0;
          while (1) {
           if ((b | 0) != 128) {
            ch(b + e | 0);
            b = b + 1 | 0;
            continue;
           }
           break;
          }
          break d;
         }
         _Y(d + 8 | 0, e);
         rd(d, k, v[d + 8 >> 2], v[d + 12 >> 2]);
        }
        eb = d + 16 | 0;
        Jw(Wb(v[a + 484360 >> 2], w[a + 484376 | 0]), e, w[f + 233 | 0] + 1 | 0, 255, 254);
        b = w[f + 238 | 0];
        d = f + 24 | 0;
        ge(d, k, B(w[f + 230 | 0] | w[f + 231 | 0] << 8, 192));
        m = gc(f + 44 | 0, d);
        tb(d);
        e: {
         q = c & 1;
         if (!q) {
          break e;
         }
         v[31601] = 0;
         N(223, a + 484344 | 0, w[f + 232 | 0] + 1 | 0);
         d = v[31601];
         v[31601] = 0;
         if ((d | 0) != 1) {
          break e;
         }
         break b;
        }
        r = b ? b : 64;
        s = a + 484344 | 0;
        b = 0;
        while (1) {
         f: {
          g: {
           h: {
            if (w[f + 232 | 0] < l >>> 0) {
             if (!(b & z)) {
              break g;
             }
             A = f, C = vb(v[a + 484344 >> 2]), v[A + 12 >> 2] = C;
             j = vb(v[a + 484348 >> 2]);
             break h;
            }
            i: {
             if (q) {
              v[31601] = 0;
              d = T(196, s | 0, l & 65535, r | 0) | 0;
              e = v[31601];
              v[31601] = 0;
              if ((e | 0) == 1) {
               break b;
              }
              n = 0;
              if (d) {
               break i;
              }
             }
             v[31601] = 0;
             O(183, k | 0, 64) | 0;
             d = v[31601];
             v[31601] = 0;
             if ((d | 0) != 1) {
              break f;
             }
             break b;
            }
            while (1) {
             d = n & 65535;
             if (d >>> 0 > 31) {
              break f;
             }
             v[31601] = 0;
             e = Q(189, k | 0) | 0;
             g = v[31601];
             v[31601] = 0;
             if ((g | 0) == 1) {
              break b;
             }
             j: {
              if ((e - 1 & 65535) >>> 0 >= (w[f + 230 | 0] | w[f + 231 | 0] << 8) >>> 0 | d >>> 0 >= x[a + 480188 >> 1]) {
               break j;
              }
              v[31601] = 0;
              O(149, m | 0, B(e, 192) - 192 | 0) | 0;
              e = v[31601];
              v[31601] = 0;
              if ((e | 0) == 1) {
               break b;
              }
              e = 0;
              g = Vb(v[s >> 2], l);
              d = ld(v[g >> 2], v[v[g + 48 >> 2] + 12 >> 2], 0, d);
              while (1) {
               if ((e | 0) == (r | 0)) {
                break j;
               }
               j = b;
               v[31601] = 0;
               b = f + 24 | 0;
               N(548, b | 0, m | 0);
               g = v[31601];
               v[31601] = 0;
               k: {
                l: {
                 m: {
                  n: {
                   o: {
                    if ((g | 0) != 1) {
                     i = Ic(b);
                     g = _e(b);
                     b = w[f + 24 | 0];
                     if (b >>> 0 >= 4) {
                      t[d | 0] = (b >>> 2 | 0) + 37;
                      b = w[f + 24 | 0];
                     }
                     t[d + 1 | 0] = b << 4 & 48 | w[i | 0] >>> 4;
                     b = t[g | 0];
                     h = 0;
                     g = 0;
                     p: {
                      q: {
                       i = w[i | 0] & 15;
                       switch (i - 8 | 0) {
                       case 0:
                        break n;

                       case 2:
                        break p;

                       case 6:
                        break q;

                       default:
                        break o;
                       }
                      }
                      i = 14;
                      if (!(435 >>> ((b + 16 & 240) >>> 4) & 1) | (b | 0) <= -17) {
                       break m;
                      }
                      break n;
                     }
                     g = b & -16;
                     b = g ? g : b;
                     i = 10;
                     break m;
                    }
                    break b;
                   }
                   h = i;
                   g = b;
                  }
                  b = g;
                  i = h;
                  if (!(b | h)) {
                   break l;
                  }
                 }
                 Bf(d, i, b & 255);
                 b = 1;
                 r: {
                  switch (w[d + 3 | 0] - 16 | 0) {
                  case 0:
                   break k;

                  case 1:
                   break r;

                  default:
                   break l;
                  }
                 }
                 z = 1;
                }
                b = j;
               }
               e = e + 1 | 0;
               d = B(x[a + 480188 >> 1], 6) + d | 0;
               continue;
              }
             }
             n = n + 1 | 0;
             continue;
            }
           }
           while (1) {
            s: {
             b = v[f + 12 >> 2];
             if (Hb(b, j)) {
              h = 0;
              t: while (1) {
               if (y[b + 12 >> 2] <= h >>> 0) {
                break s;
               }
               af(f + 24 | 0, v[b >> 2], v[v[b + 48 >> 2] + 12 >> 2], h);
               A = f, C = vb(v[f + 24 >> 2]), v[A + 20 >> 2] = C;
               e = 0;
               i = nw(v[f + 24 >> 2], v[f + 28 >> 2]);
               g = 0;
               while (1) {
                l = v[f + 20 >> 2];
                if (Hb(l, i)) {
                 d = 1;
                 u: {
                  switch (w[l + 3 | 0] - 16 | 0) {
                  case 1:
                   g = 1;

                  default:
                   d = e;
                   break;

                  case 0:
                   break u;
                  }
                 }
                 sg(f + 20 | 0);
                 e = d;
                 continue;
                } else {
                 h = h + 1 | 0;
                 if (!(e & g & 1)) {
                  continue t;
                 }
                 break g;
                }
               }
              }
             }
             i = vb(v[a + 484344 >> 2]);
             v[f + 20 >> 2] = i;
             b = vb(v[a + 484348 >> 2]);
             v: while (1) {
              if (!Hb(i, b)) {
               break g;
              }
              e = 0;
              w: while (1) {
               if (y[i + 12 >> 2] <= e >>> 0) {
                i = v[Sl(f + 20 | 0) >> 2];
                continue v;
               }
               af(f + 12 | 0, v[i >> 2], v[v[i + 48 >> 2] + 12 >> 2], e);
               A = f, C = vb(v[f + 12 >> 2]), v[A + 8 >> 2] = C;
               d = nw(v[f + 12 >> 2], v[f + 16 >> 2]);
               while (1) {
                x: {
                 g = v[f + 8 >> 2];
                 if (Hb(g, d)) {
                  g = w[g + 3 | 0];
                  if ((g & 254) != 16) {
                   break x;
                  }
                  d = (g | 0) == 16;
                  ze(i, We(Ne(f + 24 | 0, d ? 17 : 16, d ? 125 : 6), e));
                 }
                 e = e + 1 | 0;
                 continue w;
                }
                sg(f + 8 | 0);
                continue;
               }
              }
             }
            }
            Sl(f + 12 | 0);
            continue;
           }
          }
          y: {
           b = w[f + 234 | 0] | w[f + 235 | 0] << 8;
           if (!b) {
            break y;
           }
           v[31601] = 0;
           $(316, a + 1298332 | 0, k | 0, b | 0, 39, 1);
           b = v[31601];
           v[31601] = 0;
           if ((b | 0) != 1) {
            break y;
           }
           break b;
          }
          z: {
           if (!(c & 2)) {
            break z;
           }
           d = 1;
           while (1) {
            b = d & 65535;
            if (b >>> 0 > x[a + 480190 >> 1]) {
             break z;
            }
            b = B(b, 104) + o | 0;
            c = Yc(f + 24 | 0, u[b + 34 >> 1] & 1 ? 16 : 8, 1, 0, 1);
            v[31601] = 0;
            T(215, c | 0, b | 0, k | 0) | 0;
            b = v[31601];
            v[31601] = 0;
            if ((b | 0) != 1) {
             d = d + 1 | 0;
             continue;
            }
            break;
           }
           break b;
          }
          v[a + 480260 >> 2] = 64;
          v[a + 480264 >> 2] = 32767;
          tb(m);
          d = 1;
          break c;
         }
         l = l + 1 | 0;
         continue;
        }
       } else {
        h = e + (d << 5) | 0;
        Ve(h);
        u[h + 4 >> 1] = (w[d + g | 0] << 4 | 8) & 248;
        d = d + 1 | 0;
        continue;
       }
      } else {
       h = f - -64 | 0;
       fF(b, h);
       j = eb - 16 | 0;
       eb = j;
       e = B(k, 104) + o | 0;
       md(e, 0);
       u[j + 14 >> 1] = w[h + 35 | 0] << 2;
       u[j + 12 >> 1] = 256;
       A = e, C = x[Nc(j + 14 | 0, j + 12 | 0) >> 1], u[A + 30 >> 1] = C;
       g = w[h + 22 | 0] | w[h + 23 | 0] << 8 | (w[h + 24 | 0] << 16 | w[h + 25 | 0] << 24);
       A: {
        if (g >>> 0 < 3) {
         break A;
        }
        v[e >> 2] = g;
        v[e + 4 >> 2] = w[h + 26 | 0] | w[h + 27 | 0] << 8 | (w[h + 28 | 0] << 16 | w[h + 29 | 0] << 24);
        v[j + 8 >> 2] = w[h + 30 | 0] | w[h + 31 | 0] << 8 | (w[h + 32 | 0] << 16 | w[h + 33 | 0] << 24);
        v[j + 4 >> 2] = 1;
        A = e, C = v[ad(j + 8 | 0, j + 4 | 0) >> 2] - 1 | 0, v[A + 8 >> 2] = C;
        wc(e + 8 | 0, g);
        i = v[e + 8 >> 2];
        g = v[e + 4 >> 2];
        B: {
         if (i >>> 0 <= g + 4 >>> 0) {
          v[e + 4 >> 2] = 0;
          v[e + 8 >> 2] = 0;
          i = 0;
          g = 0;
          break B;
         }
         if (i >>> 0 < 3) {
          break B;
         }
         u[e + 34 >> 1] = x[e + 34 >> 1] | 2;
        }
        n = t[h + 34 | 0];
        t[e + 37 | 0] = n;
        A = e, C = xw(0, n << 4), v[A + 24 >> 2] = C;
        if (!(t[h + 36 | 0] & 1)) {
         break A;
        }
        v[e + 8 >> 2] = i >>> 1;
        v[e + 4 >> 2] = g >>> 1;
        u[e + 34 >> 1] = x[e + 34 >> 1] | 1;
        v[e >> 2] = v[e >> 2] >>> 1;
       }
       eb = j + 16 | 0;
       g = f + 24 | 0;
       Pk(g, 2, h);
       e = f + 44 | 0;
       Bc(e, g);
       zc(m + (k << 5) | 0, e);
       d = d + 1 | 0;
       sb(e);
       continue;
      }
     }
    }
    d = M() | 0;
    Db(f + 44 | 0);
    break a;
   }
   eb = f + 272 | 0;
   return d | 0;
  }
  d = M() | 0;
  tb(m);
 }
 P(d | 0);
 p();
}

function u7(a, b, c, d, e, f, g, h) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 f = f | 0;
 g = g | 0;
 h = h | 0;
 var i = 0, j = 0, k = 0, l = 0;
 h = eb - 48 | 0;
 eb = h;
 v[h + 44 >> 2] = b;
 v[e >> 2] = 0;
 bd(h, v[d + 28 >> 2]);
 v[31601] = 0;
 i = Q(1251, v[h >> 2]) | 0;
 j = v[31601];
 v[31601] = 0;
 a: {
  b: {
   c: {
    d: {
     e: {
      f: {
       g: {
        h: {
         i: {
          j: {
           k: {
            l: {
             m: {
              n: {
               o: {
                p: {
                 q: {
                  r: {
                   s: {
                    t: {
                     u: {
                      v: {
                       w: {
                        x: {
                         y: {
                          z: {
                           A: {
                            if ((j | 0) != 1) {
                             Zb(h);
                             switch (g - 65 | 0) {
                             case 54:
                              break j;

                             case 19:
                              break k;

                             case 18:
                              break l;

                             case 17:
                              break m;

                             case 49:
                              break n;

                             case 47:
                              break o;

                             case 45:
                             case 51:
                              break p;

                             case 12:
                              break q;

                             case 44:
                              break r;

                             case 41:
                              break s;

                             case 8:
                              break t;

                             case 7:
                              break u;

                             case 5:
                              break v;

                             case 3:
                              break w;

                             case 35:
                             case 36:
                              break x;

                             case 34:
                              break y;

                             case 1:
                             case 33:
                             case 39:
                              break z;

                             case 0:
                             case 32:
                              break A;

                             case 2:
                             case 4:
                             case 6:
                             case 9:
                             case 10:
                             case 11:
                             case 13:
                             case 14:
                             case 15:
                             case 16:
                             case 20:
                             case 21:
                             case 22:
                             case 25:
                             case 26:
                             case 27:
                             case 28:
                             case 29:
                             case 30:
                             case 31:
                             case 37:
                             case 38:
                             case 40:
                             case 42:
                             case 43:
                             case 46:
                             case 48:
                             case 50:
                             case 52:
                             case 53:
                              break d;

                             case 24:
                              break f;

                             case 56:
                              break g;

                             case 23:
                              break h;

                             case 55:
                              break i;

                             default:
                              break e;
                             }
                            }
                            a = M() | 0;
                            Zb(h);
                            P(a | 0);
                            p();
                           }
                           gK(a, f + 24 | 0, h + 44 | 0, c, e, i);
                           break b;
                          }
                          fK(a, f + 16 | 0, h + 44 | 0, c, e, i);
                          break b;
                         }
                         b = hb[v[v[a + 8 >> 2] + 12 >> 2]](a + 8 | 0) | 0;
                         g = a;
                         i = v[h + 44 >> 2];
                         a = Jb(b);
                         k = h, l = pk(g, i, c, d, e, f, a, a + (Cb(v[b + 4 >> 2], w[b + 11 | 0]) << 2) | 0), 
                         v[k + 44 >> 2] = l;
                         break b;
                        }
                        a = fj(h + 44 | 0, c, e, i, 2);
                        b = v[e >> 2];
                        B: {
                         if (!(b & 4 | a - 1 >>> 0 > 30)) {
                          v[f + 12 >> 2] = a;
                          break B;
                         }
                         v[e >> 2] = b | 4;
                        }
                        break b;
                       }
                       v[h + 24 >> 2] = 37;
                       v[h + 28 >> 2] = 121;
                       v[h + 16 >> 2] = 100;
                       v[h + 20 >> 2] = 47;
                       v[h + 8 >> 2] = 47;
                       v[h + 12 >> 2] = 37;
                       v[h >> 2] = 37;
                       v[h + 4 >> 2] = 109;
                       k = h, l = pk(a, b, c, d, e, f, h, h + 32 | 0), v[k + 44 >> 2] = l;
                       break b;
                      }
                      v[h + 24 >> 2] = 37;
                      v[h + 28 >> 2] = 100;
                      v[h + 16 >> 2] = 109;
                      v[h + 20 >> 2] = 45;
                      v[h + 8 >> 2] = 45;
                      v[h + 12 >> 2] = 37;
                      v[h >> 2] = 37;
                      v[h + 4 >> 2] = 89;
                      k = h, l = pk(a, b, c, d, e, f, h, h + 32 | 0), v[k + 44 >> 2] = l;
                      break b;
                     }
                     a = fj(h + 44 | 0, c, e, i, 2);
                     b = v[e >> 2];
                     C: {
                      if (!(b & 4 | (a | 0) > 23)) {
                       v[f + 8 >> 2] = a;
                       break C;
                      }
                      v[e >> 2] = b | 4;
                     }
                     break b;
                    }
                    a = fj(h + 44 | 0, c, e, i, 2);
                    b = v[e >> 2];
                    D: {
                     if (!(b & 4 | a - 1 >>> 0 > 11)) {
                      v[f + 8 >> 2] = a;
                      break D;
                     }
                     v[e >> 2] = b | 4;
                    }
                    break b;
                   }
                   a = fj(h + 44 | 0, c, e, i, 3);
                   b = v[e >> 2];
                   E: {
                    if (!(b & 4 | (a | 0) > 365)) {
                     v[f + 28 >> 2] = a;
                     break E;
                    }
                    v[e >> 2] = b | 4;
                   }
                   break b;
                  }
                  a = fj(h + 44 | 0, c, e, i, 2);
                  b = v[e >> 2];
                  a = a - 1 | 0;
                  F: {
                   if (!(b & 4 | a >>> 0 > 11)) {
                    v[f + 16 >> 2] = a;
                    break F;
                   }
                   v[e >> 2] = b | 4;
                  }
                  break b;
                 }
                 a = fj(h + 44 | 0, c, e, i, 2);
                 b = v[e >> 2];
                 G: {
                  if (!(b & 4 | (a | 0) > 59)) {
                   v[f + 4 >> 2] = a;
                   break G;
                  }
                  v[e >> 2] = b | 4;
                 }
                 break b;
                }
                a = h + 44 | 0;
                b = eb - 16 | 0;
                eb = b;
                v[b + 12 >> 2] = c;
                while (1) {
                 H: {
                  if (ei(a, b + 12 | 0)) {
                   break H;
                  }
                  if (!nj(i, 1, ql(v[a >> 2]))) {
                   break H;
                  }
                  io(a);
                  continue;
                 }
                 break;
                }
                if (ei(a, b + 12 | 0)) {
                 v[e >> 2] = v[e >> 2] | 2;
                }
                eb = b + 16 | 0;
                break b;
               }
               b = h + 44 | 0;
               a = hb[v[v[a + 8 >> 2] + 8 >> 2]](a + 8 | 0) | 0;
               I: {
                if ((Cb(v[a + 4 >> 2], w[a + 11 | 0]) | 0) == (0 - Cb(v[a + 16 >> 2], w[a + 23 | 0]) | 0)) {
                 v[e >> 2] = v[e >> 2] | 4;
                 break I;
                }
                c = tt(b, c, a, a + 24 | 0, i, e, 0);
                b = v[f + 8 >> 2];
                if (!((c | 0) != (a | 0) | (b | 0) != 12)) {
                 v[f + 8 >> 2] = 0;
                 break I;
                }
                if (!((c - a | 0) != 12 | (b | 0) > 11)) {
                 v[f + 8 >> 2] = b + 12;
                }
               }
               break b;
              }
              v[h + 40 >> 2] = 112;
              v[h + 32 >> 2] = 32;
              v[h + 36 >> 2] = 37;
              v[h + 24 >> 2] = 37;
              v[h + 28 >> 2] = 83;
              v[h + 16 >> 2] = 77;
              v[h + 20 >> 2] = 58;
              v[h + 8 >> 2] = 58;
              v[h + 12 >> 2] = 37;
              v[h >> 2] = 37;
              v[h + 4 >> 2] = 73;
              k = h, l = pk(a, b, c, d, e, f, h, h + 44 | 0), v[k + 44 >> 2] = l;
              break b;
             }
             v[h + 16 >> 2] = 77;
             v[h + 8 >> 2] = 58;
             v[h + 12 >> 2] = 37;
             v[h >> 2] = 37;
             v[h + 4 >> 2] = 72;
             k = h, l = pk(a, b, c, d, e, f, h, h + 20 | 0), v[k + 44 >> 2] = l;
             break b;
            }
            a = fj(h + 44 | 0, c, e, i, 2);
            b = v[e >> 2];
            J: {
             if (!(b & 4 | (a | 0) > 60)) {
              v[f >> 2] = a;
              break J;
             }
             v[e >> 2] = b | 4;
            }
            break b;
           }
           v[h + 24 >> 2] = 37;
           v[h + 28 >> 2] = 83;
           v[h + 16 >> 2] = 77;
           v[h + 20 >> 2] = 58;
           v[h + 8 >> 2] = 58;
           v[h + 12 >> 2] = 37;
           v[h >> 2] = 37;
           v[h + 4 >> 2] = 72;
           k = h, l = pk(a, b, c, d, e, f, h, h + 32 | 0), v[k + 44 >> 2] = l;
           break b;
          }
          a = fj(h + 44 | 0, c, e, i, 1);
          b = v[e >> 2];
          K: {
           if (!(b & 4 | (a | 0) > 6)) {
            v[f + 24 >> 2] = a;
            break K;
           }
           v[e >> 2] = b | 4;
          }
          break b;
         }
         a = hb[v[v[a >> 2] + 20 >> 2]](a, b, c, d, e, f) | 0;
         break a;
        }
        b = hb[v[v[a + 8 >> 2] + 24 >> 2]](a + 8 | 0) | 0;
        g = a;
        i = v[h + 44 >> 2];
        a = Jb(b);
        k = h, l = pk(g, i, c, d, e, f, a, a + (Cb(v[b + 4 >> 2], w[b + 11 | 0]) << 2) | 0), 
        v[k + 44 >> 2] = l;
        break b;
       }
       eK(f + 20 | 0, h + 44 | 0, c, e, i);
       break b;
      }
      a = fj(h + 44 | 0, c, e, i, 4);
      if (!(w[e | 0] & 4)) {
       v[f + 20 >> 2] = a - 1900;
      }
      break b;
     }
     if ((g | 0) == 37) {
      break c;
     }
    }
    v[e >> 2] = v[e >> 2] | 4;
    break b;
   }
   a = eb - 16 | 0;
   eb = a;
   v[a + 12 >> 2] = c;
   b = 6;
   c = h + 44 | 0;
   d = a + 12 | 0;
   L: {
    M: {
     if (ei(c, d)) {
      break M;
     }
     b = 4;
     if ((ok(i, ql(v[c >> 2])) | 0) != 37) {
      break M;
     }
     b = 2;
     if (!ei(io(c), d)) {
      break L;
     }
    }
    v[e >> 2] = v[e >> 2] | b;
   }
   eb = a + 16 | 0;
  }
  a = v[h + 44 >> 2];
 }
 eb = h + 48 | 0;
 return a | 0;
}

function A7(a, b, c, d, e, f, g, h) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 f = f | 0;
 g = g | 0;
 h = h | 0;
 var i = 0, j = 0, k = 0, l = 0;
 h = eb - 16 | 0;
 eb = h;
 v[h + 12 >> 2] = b;
 v[e >> 2] = 0;
 bd(h, v[d + 28 >> 2]);
 v[31601] = 0;
 i = Q(28, v[h >> 2]) | 0;
 j = v[31601];
 v[31601] = 0;
 a: {
  b: {
   c: {
    d: {
     e: {
      f: {
       g: {
        h: {
         i: {
          j: {
           k: {
            l: {
             m: {
              n: {
               o: {
                p: {
                 q: {
                  r: {
                   s: {
                    t: {
                     u: {
                      v: {
                       w: {
                        x: {
                         y: {
                          z: {
                           A: {
                            if ((j | 0) != 1) {
                             Zb(h);
                             switch (g - 65 | 0) {
                             case 54:
                              break j;

                             case 19:
                              break k;

                             case 18:
                              break l;

                             case 17:
                              break m;

                             case 49:
                              break n;

                             case 47:
                              break o;

                             case 45:
                             case 51:
                              break p;

                             case 12:
                              break q;

                             case 44:
                              break r;

                             case 41:
                              break s;

                             case 8:
                              break t;

                             case 7:
                              break u;

                             case 5:
                              break v;

                             case 3:
                              break w;

                             case 35:
                             case 36:
                              break x;

                             case 34:
                              break y;

                             case 1:
                             case 33:
                             case 39:
                              break z;

                             case 0:
                             case 32:
                              break A;

                             case 2:
                             case 4:
                             case 6:
                             case 9:
                             case 10:
                             case 11:
                             case 13:
                             case 14:
                             case 15:
                             case 16:
                             case 20:
                             case 21:
                             case 22:
                             case 25:
                             case 26:
                             case 27:
                             case 28:
                             case 29:
                             case 30:
                             case 31:
                             case 37:
                             case 38:
                             case 40:
                             case 42:
                             case 43:
                             case 46:
                             case 48:
                             case 50:
                             case 52:
                             case 53:
                              break d;

                             case 24:
                              break f;

                             case 56:
                              break g;

                             case 23:
                              break h;

                             case 55:
                              break i;

                             default:
                              break e;
                             }
                            }
                            a = M() | 0;
                            Zb(h);
                            P(a | 0);
                            p();
                           }
                           kK(a, f + 24 | 0, h + 12 | 0, c, e, i);
                           break b;
                          }
                          jK(a, f + 16 | 0, h + 12 | 0, c, e, i);
                          break b;
                         }
                         b = hb[v[v[a + 8 >> 2] + 12 >> 2]](a + 8 | 0) | 0;
                         g = a;
                         i = v[h + 12 >> 2];
                         a = Jb(b);
                         k = h, l = qk(g, i, c, d, e, f, a, Cb(v[b + 4 >> 2], w[b + 11 | 0]) + a | 0), v[k + 12 >> 2] = l;
                         break b;
                        }
                        a = gj(h + 12 | 0, c, e, i, 2);
                        b = v[e >> 2];
                        B: {
                         if (!(b & 4 | a - 1 >>> 0 > 30)) {
                          v[f + 12 >> 2] = a;
                          break B;
                         }
                         v[e >> 2] = b | 4;
                        }
                        break b;
                       }
                       t[h | 0] = 37;
                       t[h + 1 | 0] = 109;
                       t[h + 2 | 0] = 47;
                       t[h + 3 | 0] = 37;
                       t[h + 4 | 0] = 100;
                       t[h + 5 | 0] = 47;
                       t[h + 6 | 0] = 37;
                       t[h + 7 | 0] = 121;
                       k = h, l = qk(a, b, c, d, e, f, h, h + 8 | 0), v[k + 12 >> 2] = l;
                       break b;
                      }
                      t[h | 0] = 37;
                      t[h + 1 | 0] = 89;
                      t[h + 2 | 0] = 45;
                      t[h + 3 | 0] = 37;
                      t[h + 4 | 0] = 109;
                      t[h + 5 | 0] = 45;
                      t[h + 6 | 0] = 37;
                      t[h + 7 | 0] = 100;
                      k = h, l = qk(a, b, c, d, e, f, h, h + 8 | 0), v[k + 12 >> 2] = l;
                      break b;
                     }
                     a = gj(h + 12 | 0, c, e, i, 2);
                     b = v[e >> 2];
                     C: {
                      if (!(b & 4 | (a | 0) > 23)) {
                       v[f + 8 >> 2] = a;
                       break C;
                      }
                      v[e >> 2] = b | 4;
                     }
                     break b;
                    }
                    a = gj(h + 12 | 0, c, e, i, 2);
                    b = v[e >> 2];
                    D: {
                     if (!(b & 4 | a - 1 >>> 0 > 11)) {
                      v[f + 8 >> 2] = a;
                      break D;
                     }
                     v[e >> 2] = b | 4;
                    }
                    break b;
                   }
                   a = gj(h + 12 | 0, c, e, i, 3);
                   b = v[e >> 2];
                   E: {
                    if (!(b & 4 | (a | 0) > 365)) {
                     v[f + 28 >> 2] = a;
                     break E;
                    }
                    v[e >> 2] = b | 4;
                   }
                   break b;
                  }
                  a = gj(h + 12 | 0, c, e, i, 2);
                  b = v[e >> 2];
                  a = a - 1 | 0;
                  F: {
                   if (!(b & 4 | a >>> 0 > 11)) {
                    v[f + 16 >> 2] = a;
                    break F;
                   }
                   v[e >> 2] = b | 4;
                  }
                  break b;
                 }
                 a = gj(h + 12 | 0, c, e, i, 2);
                 b = v[e >> 2];
                 G: {
                  if (!(b & 4 | (a | 0) > 59)) {
                   v[f + 4 >> 2] = a;
                   break G;
                  }
                  v[e >> 2] = b | 4;
                 }
                 break b;
                }
                a = h + 12 | 0;
                b = eb - 16 | 0;
                eb = b;
                v[b + 12 >> 2] = c;
                while (1) {
                 H: {
                  if (sh(a, b + 12 | 0)) {
                   break H;
                  }
                  c = rl(v[a >> 2]);
                  if (!If(v[i + 8 >> 2], 1, c)) {
                   break H;
                  }
                  Dm(a);
                  continue;
                 }
                 break;
                }
                if (sh(a, b + 12 | 0)) {
                 v[e >> 2] = v[e >> 2] | 2;
                }
                eb = b + 16 | 0;
                break b;
               }
               b = h + 12 | 0;
               a = hb[v[v[a + 8 >> 2] + 8 >> 2]](a + 8 | 0) | 0;
               I: {
                if ((Cb(v[a + 4 >> 2], w[a + 11 | 0]) | 0) == (0 - Cb(v[a + 16 >> 2], w[a + 23 | 0]) | 0)) {
                 v[e >> 2] = v[e >> 2] | 4;
                 break I;
                }
                c = yt(b, c, a, a + 24 | 0, i, e, 0);
                b = v[f + 8 >> 2];
                if (!((c | 0) != (a | 0) | (b | 0) != 12)) {
                 v[f + 8 >> 2] = 0;
                 break I;
                }
                if (!((c - a | 0) != 12 | (b | 0) > 11)) {
                 v[f + 8 >> 2] = b + 12;
                }
               }
               break b;
              }
              t[h + 10 | 0] = 112;
              t[h + 8 | 0] = 32;
              t[h + 9 | 0] = 37;
              t[h | 0] = 37;
              t[h + 1 | 0] = 73;
              t[h + 2 | 0] = 58;
              t[h + 3 | 0] = 37;
              t[h + 4 | 0] = 77;
              t[h + 5 | 0] = 58;
              t[h + 6 | 0] = 37;
              t[h + 7 | 0] = 83;
              k = h, l = qk(a, b, c, d, e, f, h, h + 11 | 0), v[k + 12 >> 2] = l;
              break b;
             }
             t[h + 4 | 0] = 77;
             t[h | 0] = 37;
             t[h + 1 | 0] = 72;
             t[h + 2 | 0] = 58;
             t[h + 3 | 0] = 37;
             k = h, l = qk(a, b, c, d, e, f, h, h + 5 | 0), v[k + 12 >> 2] = l;
             break b;
            }
            a = gj(h + 12 | 0, c, e, i, 2);
            b = v[e >> 2];
            J: {
             if (!(b & 4 | (a | 0) > 60)) {
              v[f >> 2] = a;
              break J;
             }
             v[e >> 2] = b | 4;
            }
            break b;
           }
           t[h | 0] = 37;
           t[h + 1 | 0] = 72;
           t[h + 2 | 0] = 58;
           t[h + 3 | 0] = 37;
           t[h + 4 | 0] = 77;
           t[h + 5 | 0] = 58;
           t[h + 6 | 0] = 37;
           t[h + 7 | 0] = 83;
           k = h, l = qk(a, b, c, d, e, f, h, h + 8 | 0), v[k + 12 >> 2] = l;
           break b;
          }
          a = gj(h + 12 | 0, c, e, i, 1);
          b = v[e >> 2];
          K: {
           if (!(b & 4 | (a | 0) > 6)) {
            v[f + 24 >> 2] = a;
            break K;
           }
           v[e >> 2] = b | 4;
          }
          break b;
         }
         a = hb[v[v[a >> 2] + 20 >> 2]](a, b, c, d, e, f) | 0;
         break a;
        }
        b = hb[v[v[a + 8 >> 2] + 24 >> 2]](a + 8 | 0) | 0;
        g = a;
        i = v[h + 12 >> 2];
        a = Jb(b);
        k = h, l = qk(g, i, c, d, e, f, a, Cb(v[b + 4 >> 2], w[b + 11 | 0]) + a | 0), v[k + 12 >> 2] = l;
        break b;
       }
       iK(f + 20 | 0, h + 12 | 0, c, e, i);
       break b;
      }
      a = gj(h + 12 | 0, c, e, i, 4);
      if (!(w[e | 0] & 4)) {
       v[f + 20 >> 2] = a - 1900;
      }
      break b;
     }
     if ((g | 0) == 37) {
      break c;
     }
    }
    v[e >> 2] = v[e >> 2] | 4;
    break b;
   }
   a = eb - 16 | 0;
   eb = a;
   v[a + 12 >> 2] = c;
   b = 6;
   c = h + 12 | 0;
   d = a + 12 | 0;
   L: {
    M: {
     if (sh(c, d)) {
      break M;
     }
     b = 4;
     if ((kl(i, rl(v[c >> 2])) | 0) != 37) {
      break M;
     }
     b = 2;
     if (!sh(Dm(c), d)) {
      break L;
     }
    }
    v[e >> 2] = v[e >> 2] | b;
   }
   eb = a + 16 | 0;
  }
  a = v[h + 12 >> 2];
 }
 eb = h + 16 | 0;
 return a | 0;
}

function Goa(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, q = 0, r = 0;
 d = eb - 352 | 0;
 eb = d;
 a: {
  b: {
   c: {
    if (!cd(b, 60)) {
     break c;
    }
    e = d + 332 | 0;
    if (!Mp(b, e)) {
     break c;
    }
    f = 15;
    if (zv(e, 15)) {
     break b;
    }
   }
   e = 0;
   if (!cd(b, 124)) {
    break a;
   }
   g = d + 332 | 0;
   if (!Mp(b, g)) {
    break a;
   }
   f = 31;
   if (!zv(g, 31)) {
    break a;
   }
  }
  Cd(a, 536870912);
  u[a + 480190 >> 1] = f;
  xc(b);
  e = 0;
  d: {
   while (1) {
    if (x[a + 480190 >> 1] > e >>> 0) {
     g = op(b);
     v[(d + 208 | 0) + (e << 2) >> 2] = g;
     e = e + 1 | 0;
     if (g >>> 0 <= 131072) {
      continue;
     }
     break d;
    }
    break;
   }
   Ub(b, 20);
   f = 0;
   u[a + 480192 >> 1] = 0;
   u[a + 480188 >> 1] = 4;
   e = w[d + 336 | 0] | w[d + 337 | 0] << 8;
   v[a + 480260 >> 2] = 56;
   v[a + 480264 >> 2] = 13696;
   v[a + 480196 >> 2] = 6;
   q = a, r = Te(1776930 / +(Ab(e) >>> 0) * 1e4), v[q + 480204 >> 2] = r;
   v[a + 480228 >> 2] = 64;
   Th(a, 1);
   n = a + 946304 | 0;
   o = a + 484380 | 0;
   m = 1;
   e: while (1) {
    l = m & 65535;
    if (l >>> 0 <= x[a + 480190 >> 1]) {
     PC(b, d + 52 | 0);
     e = v[((l << 2) + d | 0) + 204 >> 2];
     h = eb - 16 | 0;
     eb = h;
     i = B(l, 104) + o | 0;
     md(i, 1);
     v[i >> 2] = e;
     t[i + 37 | 0] = w[d + 76 | 0] << 4;
     t[h + 15 | 0] = w[d + 77 | 0];
     t[h + 14 | 0] = 64;
     q = i, r = w[Pb(h + 15 | 0, h + 14 | 0) | 0] << 2, u[q + 30 >> 1] = r;
     f: {
      if (!e) {
       break f;
      }
      g = Ab(w[d + 80 | 0] | w[d + 81 | 0] << 8);
      k = Ab(w[d + 78 | 0] | w[d + 79 | 0] << 8);
      v[i + 4 >> 2] = k;
      g = (g << 1) + k | 0;
      v[i + 8 >> 2] = g;
      if (e >>> 0 <= k >>> 0) {
       k = e - 1 | 0;
       v[i + 4 >> 2] = k;
      }
      if (e >>> 0 < g >>> 0) {
       v[i + 8 >> 2] = e;
       g = e;
      }
      if (!(!(g >>> 0 < 4 | g >>> 0 < k >>> 0) & g - k >>> 0 > 3)) {
       v[i + 4 >> 2] = 0;
       v[i + 8 >> 2] = 0;
       break f;
      }
      if (g >>> 0 <= k >>> 0) {
       break f;
      }
      u[i + 34 >> 1] = x[i + 34 >> 1] | 2;
     }
     eb = h + 16 | 0;
     e = 0;
     while (1) if ((e | 0) == 22) {
      if (f >>> 0 >= 128) {
       break d;
      }
      g = d + 184 | 0;
      Pk(g, 3, d + 52 | 0);
      e = d + 196 | 0;
      Bc(e, g);
      zc(n + (l << 5) | 0, e);
      m = m + 1 | 0;
      sb(e);
      continue e;
     } else {
      g = (d + 52 | 0) + e | 0;
      if ((w[g | 0] - 1 & 255) >>> 0 <= 30) {
       t[g | 0] = 32;
       f = f + 1 | 0;
      }
      e = e + 1 | 0;
      continue;
     }
    }
    break;
   }
   m = 1;
   g: {
    h: {
     f = a + 946336 | 0;
     e = Cc(d + 52 | 0, 14036);
     if (!HW(f, e)) {
      v[31601] = 0;
      g = O(36, d + 196 | 0, 14047) | 0;
      i = v[31601];
      v[31601] = 0;
      if ((i | 0) == 1) {
       break h;
      }
      m = HW(f, g);
      sb(g);
     }
     sb(e);
     e = 0;
     g = d + 52 | 0;
     f = SC(b, g);
     if (!f) {
      NC(g);
     }
     if (!f) {
      break a;
     }
     g = w[d + 52 | 0];
     if (!JW(g)) {
      break a;
     }
     e = 1;
     if ((c | 0) == 64) {
      break a;
     }
     e = 0;
     u[d + 50 >> 1] = 0;
     f = d + 54 | 0;
     while (1) if ((e | 0) == (g | 0)) {
      h = Wb(v[a + 484360 >> 2], w[a + 484376 | 0]);
      e = w[d + 53 | 0];
      $e(h, e >>> 0 < g >>> 0 ? e : 0);
      Jw(Wb(v[a + 484360 >> 2], w[a + 484376 | 0]), f, w[d + 52 | 0], 65535, 65535);
      if (x[a + 480190 >> 1] == 31) {
       Ub(b, 4);
      }
      v[d + 44 >> 2] = 0;
      v[d + 40 >> 2] = 0;
      v[d + 36 >> 2] = 0;
      t[d + 35 | 0] = 0;
      n = c & 1;
      if (n) {
       Sf(a + 484344 | 0, x[d + 50 >> 1]);
      }
      l = a + 484344 | 0;
      i = 0;
      while (1) {
       i: {
        j: {
         k: {
          if (x[d + 50 >> 1] <= i >>> 0) {
           if (!(c & 2)) {
            break k;
           }
           e = 1;
           while (1) {
            f = x[a + 480190 >> 1];
            c = e & 65535;
            if (f >>> 0 < c >>> 0) {
             break j;
            }
            c = B(c, 104) + o | 0;
            if (v[c >> 2]) {
             cg(Yc(d + 184 | 0, 8, 1, 0, 0), c, b);
            }
            e = e + 1 | 0;
            continue;
           }
          }
          l: {
           if (n) {
            k = 0;
            if (Og(l, i & 65535, 64)) {
             break l;
            }
           }
           Ub(b, 1024);
           break i;
          }
          m: while (1) {
           if ((k | 0) == 64) {
            break i;
           }
           e = Vb(v[l >> 2], i);
           af(d + 184 | 0, v[e >> 2], v[v[e + 48 >> 2] + 12 >> 2], k);
           e = 0;
           while (1) if ((e | 0) == 4) {
            k = k + 1 | 0;
            continue m;
           } else {
            g = Xc(v[d + 184 >> 2], e);
            f = d + 12 | 0;
            jm(f, b);
            n: {
             o: {
              p: {
               q: {
                if (w[wb(f, 0) | 0] != 255) {
                 break q;
                }
                t[(d + 44 | 0) + e | 0] = 0;
                t[(d + 36 | 0) + e | 0] = 0;
                f = wb(f, 1);
                h = w[f | 0];
                if ((h | 0) == 252 & m) {
                 t[f | 0] = 254;
                 break o;
                }
                switch (h - 252 | 0) {
                case 1:
                 break n;

                case 2:
                 break o;

                case 0:
                 break p;

                default:
                 break q;
                }
               }
               f = v[d + 12 >> 2];
               v[d + 28 >> 2] = f;
               v[d + 8 >> 2] = f;
               f = d + 33 | 0;
               dp(f, d + 8 | 0, g);
               h = Ic(f);
               f = w[g | 0];
               r: {
                if (!f) {
                 break r;
                }
                t[(d + 36 | 0) + e | 0] = 0;
                t[(d + 44 | 0) + e | 0] = f;
                if (f >>> 0 > 48) {
                 break r;
                }
                t[d + 27 | 0] = 8;
                q = d, r = w[cf(d + 35 | 0, d + 27 | 0) | 0], t[q + 35 | 0] = r;
               }
               j = w[d + 33 | 0];
               f = w[h | 0];
               s: {
                if (j | f) {
                 t[g + 5 | 0] = f;
                 t: {
                  u: {
                   v: {
                    switch (j - 1 | 0) {
                    case 0:
                     t[g + 3 | 0] = 1;
                     break n;

                    case 1:
                     if (f >>> 0 >= 16) {
                      t[g + 3 | 0] = 3;
                      t[g + 5 | 0] = (f & 240) >>> 4;
                      break n;
                     }
                     if (!f) {
                      break u;
                     }
                     t[g + 5 | 0] = f;
                     t[g + 3 | 0] = 2;
                     break n;

                    case 2:
                     if (w[(d + 36 | 0) + e | 0]) {
                      break u;
                     }
                     t[g + 5 | 0] = 0;
                     t[g + 3 | 0] = 19;
                     break n;

                    case 3:
                     if (w[(d + 36 | 0) + e | 0]) {
                      break u;
                     }
                     t[g + 5 | 0] = 1;
                     t[g + 3 | 0] = 19;
                     break n;

                    case 4:
                     h = w[g + 1 | 0];
                     if (!h) {
                      break u;
                     }
                     t[d + 27 | 0] = 63;
                     t[d + 26 | 0] = f + (x[(B(h, 104) + o | 0) + 30 >> 1] >>> 2 | 0);
                     f = w[Pb(d + 27 | 0, d + 26 | 0) | 0];
                     t[g + 5 | 0] = f;
                     t[g + 3 | 0] = 13;
                     if (!w[(d + 36 | 0) + e | 0]) {
                      break n;
                     }
                     h = g + 3 | 0;
                     t[g + 4 | 0] = f;
                     t[g + 2 | 0] = 1;
                     break t;

                    case 5:
                     h = g + 3 | 0;
                     j = w[g + 1 | 0];
                     if (!j) {
                      break t;
                     }
                     t[g + 3 | 0] = 13;
                     j = x[(B(j, 104) + o | 0) + 30 >> 1] >>> 2 | 0;
                     f = f >>> 0 <= j >>> 0 ? j - f | 0 : 0;
                     t[g + 5 | 0] = f;
                     if (!w[(d + 36 | 0) + e | 0]) {
                      break n;
                     }
                     t[g + 4 | 0] = f;
                     t[g + 2 | 0] = 1;
                     break t;

                    case 6:
                     h = f & 15;
                     t[(d + 36 | 0) + e | 0] = h;
                     j = w[(d + 44 | 0) + e | 0];
                     f = j - ((f & 240) >>> 4 | 0) | 0;
                     t[(d + 40 | 0) + e | 0] = f;
                     q = g, r = GW(h, f & 255, j), t[q + 5 | 0] = r;
                     t[g + 3 | 0] = 3;
                     break n;

                    case 7:
                     h = f & 15;
                     t[(d + 36 | 0) + e | 0] = h;
                     j = (f & 240) >>> 4 | 0;
                     f = w[(d + 44 | 0) + e | 0];
                     j = j + f | 0;
                     t[(d + 40 | 0) + e | 0] = j;
                     q = g, r = GW(h, f, j & 255), t[q + 5 | 0] = r;
                     t[g + 3 | 0] = 2;
                     break n;

                    case 8:
                     break v;

                    default:
                     break u;
                    }
                   }
                   t[d + 27 | 0] = 8;
                   q = d, r = w[cf(d + 35 | 0, d + 27 | 0) | 0], t[q + 35 | 0] = r;
                  }
                  h = g + 3 | 0;
                 }
                 t[h | 0] = 0;
                 break s;
                }
                if (w[g + 3 | 0]) {
                 break n;
                }
               }
               h = w[(d + 36 | 0) + e | 0];
               if (!h) {
                break n;
               }
               j = (d + 40 | 0) + e | 0;
               f = w[j | 0];
               if (f) {
                t[(d + 44 | 0) + e | 0] = f;
                t[g + 5 | 0] = h;
                t[g | 0] = f;
                t[j | 0] = 0;
               }
               t[g + 3 | 0] = 4;
               break n;
              }
              t[g + 3 | 0] = 14;
              t[d + 35 | 0] = 9;
              break n;
             }
             t[g + 3 | 0] = 13;
            }
            e = e + 1 | 0;
            continue;
           }
          }
         }
         f = x[a + 480190 >> 1];
        }
        w: {
         x: {
          if ((f & 65535) == 15) {
           b = d + 12 | 0;
           fg(b, 4418);
           v[31601] = 0;
           R(209, d + 184 | 0, b | 0, d + 35 | 0);
           c = v[31601];
           v[31601] = 0;
           if ((c | 0) != 1) {
            break x;
           }
           f = M() | 0;
           Db(b);
           break g;
          }
          v[31601] = 0;
          O(1, d + 184 | 0, 12390) | 0;
          b = v[31601];
          v[31601] = 0;
          if ((b | 0) == 1) {
           break w;
          }
         }
         b = d + 184 | 0;
         yb(a + 1298344 | 0, b);
         sb(b);
         if ((f & 65535) == 15) {
          Db(d + 12 | 0);
         }
         Yh(a + 1298356 | 0, x[a + 480190 >> 1] == 15 ? 5282 : 15105);
         q = a, r = v[Ec(d + 184 | 0, 28) >> 2], v[q + 1298404 >> 2] = r;
         e = 1;
         break a;
        }
        f = M() | 0;
        break g;
       }
       i = i + 1 | 0;
       continue;
      }
     } else {
      u[d + 184 >> 1] = w[e + f | 0] + 1;
      q = d, r = x[qe(d + 50 | 0, d + 184 | 0) >> 1], u[q + 50 >> 1] = r;
      e = e + 1 | 0;
      continue;
     }
    }
    f = M() | 0;
    sb(e);
   }
   P(f | 0);
   p();
  }
  e = 0;
 }
 eb = d + 352 | 0;
 return e | 0;
}

function LG(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0;
 d = eb - 144 | 0;
 eb = d;
 a: {
  b: {
   c: {
    d: {
     e: {
      f: {
       g: {
        h: {
         i: {
          j: {
           k: {
            l: {
             m: {
              n: {
               o: {
                p: {
                 q: {
                  r: {
                   s: {
                    t: {
                     u: {
                      v: {
                       w: {
                        x: {
                         y: {
                          z: {
                           A: {
                            B: {
                             C: {
                              D: {
                               E: {
                                if ((b | 0) <= 5) {
                                 h = d + 108 | 0;
                                 vx(h, b);
                                 v[31601] = 0;
                                 e = O(1, d + 96 | 0, 18371) | 0;
                                 b = v[31601];
                                 v[31601] = 0;
                                 if ((b | 0) == 1) {
                                  break E;
                                 }
                                 v[31601] = 0;
                                 i = d + 120 | 0;
                                 R(2, i | 0, h | 0, e | 0);
                                 b = v[31601];
                                 v[31601] = 0;
                                 if ((b | 0) == 1) {
                                  break D;
                                 }
                                 v[31601] = 0;
                                 f = O(3, d + 72 | 0, c | 0) | 0;
                                 b = v[31601];
                                 v[31601] = 0;
                                 if ((b | 0) == 1) {
                                  break C;
                                 }
                                 v[31601] = 0;
                                 g = O(1, d + 60 | 0, 20176) | 0;
                                 b = v[31601];
                                 v[31601] = 0;
                                 if ((b | 0) == 1) {
                                  break B;
                                 }
                                 v[31601] = 0;
                                 c = d + 84 | 0;
                                 R(4, c | 0, f | 0, g | 0);
                                 b = v[31601];
                                 v[31601] = 0;
                                 if ((b | 0) == 1) {
                                  break A;
                                 }
                                 v[31601] = 0;
                                 j = d + 132 | 0;
                                 R(2, j | 0, i | 0, c | 0);
                                 b = v[31601];
                                 v[31601] = 0;
                                 if ((b | 0) == 1) {
                                  break z;
                                 }
                                 sb(c);
                                 sb(g);
                                 sb(f);
                                 sb(i);
                                 sb(e);
                                 sb(h);
                                 b = v[a >> 2];
                                 v[31601] = 0;
                                 N(5, i | 0, (b ? b : 22256) | 0);
                                 b = v[31601];
                                 v[31601] = 0;
                                 if ((b | 0) == 1) {
                                  break t;
                                 }
                                 b = v[a + 4 >> 2];
                                 v[31601] = 0;
                                 N(5, h | 0, (b ? b : 22256) | 0);
                                 b = v[31601];
                                 v[31601] = 0;
                                 if ((b | 0) == 1) {
                                  break s;
                                 }
                                 a = v[a + 8 >> 2];
                                 v[31601] = 0;
                                 v[d + 48 >> 2] = a;
                                 e = d + 48 | 0;
                                 N(6, c | 0, e | 0);
                                 a = v[31601];
                                 v[31601] = 0;
                                 if ((a | 0) == 1) {
                                  break r;
                                 }
                                 v[31601] = 0;
                                 O(7, 496980, 18250) | 0;
                                 a = v[31601];
                                 v[31601] = 0;
                                 if ((a | 0) == 1) {
                                  break q;
                                 }
                                 v[31601] = 0;
                                 N(8, e | 0, i | 0);
                                 a = v[31601];
                                 v[31601] = 0;
                                 if ((a | 0) == 1) {
                                  break p;
                                 }
                                 v[31601] = 0;
                                 O(9, 496980, e | 0) | 0;
                                 a = v[31601];
                                 v[31601] = 0;
                                 if ((a | 0) == 1) {
                                  break o;
                                 }
                                 v[31601] = 0;
                                 O(7, 496980, 17457) | 0;
                                 a = v[31601];
                                 v[31601] = 0;
                                 if ((a | 0) == 1) {
                                  break o;
                                 }
                                 v[31601] = 0;
                                 f = d + 36 | 0;
                                 N(8, f | 0, c | 0);
                                 a = v[31601];
                                 v[31601] = 0;
                                 if ((a | 0) == 1) {
                                  break n;
                                 }
                                 v[31601] = 0;
                                 O(9, 496980, f | 0) | 0;
                                 a = v[31601];
                                 v[31601] = 0;
                                 if ((a | 0) == 1) {
                                  break m;
                                 }
                                 v[31601] = 0;
                                 O(7, 496980, 17455) | 0;
                                 a = v[31601];
                                 v[31601] = 0;
                                 if ((a | 0) == 1) {
                                  break m;
                                 }
                                 v[31601] = 0;
                                 O(7, 496980, 18371) | 0;
                                 a = v[31601];
                                 v[31601] = 0;
                                 if ((a | 0) == 1) {
                                  break m;
                                 }
                                 v[31601] = 0;
                                 g = d + 24 | 0;
                                 N(8, g | 0, j | 0);
                                 a = v[31601];
                                 v[31601] = 0;
                                 if ((a | 0) == 1) {
                                  break l;
                                 }
                                 v[31601] = 0;
                                 O(9, 496980, g | 0) | 0;
                                 a = v[31601];
                                 v[31601] = 0;
                                 if ((a | 0) == 1) {
                                  break k;
                                 }
                                 v[31601] = 0;
                                 O(7, 496980, 13569) | 0;
                                 a = v[31601];
                                 v[31601] = 0;
                                 if ((a | 0) == 1) {
                                  break k;
                                 }
                                 v[31601] = 0;
                                 b = d + 12 | 0;
                                 N(8, b | 0, h | 0);
                                 a = v[31601];
                                 v[31601] = 0;
                                 if ((a | 0) == 1) {
                                  break j;
                                 }
                                 v[31601] = 0;
                                 O(9, 496980, b | 0) | 0;
                                 a = v[31601];
                                 v[31601] = 0;
                                 if ((a | 0) == 1) {
                                  break i;
                                 }
                                 v[31601] = 0;
                                 O(7, 496980, 13567) | 0;
                                 a = v[31601];
                                 v[31601] = 0;
                                 if ((a | 0) == 1) {
                                  break i;
                                 }
                                 v[31601] = 0;
                                 Q(10, 496980) | 0;
                                 a = v[31601];
                                 v[31601] = 0;
                                 if ((a | 0) == 1) {
                                  break i;
                                 }
                                 sb(b);
                                 sb(g);
                                 sb(f);
                                 sb(e);
                                 sb(c);
                                 sb(h);
                                 sb(i);
                                 sb(j);
                                }
                                eb = d + 144 | 0;
                                return;
                               }
                               a = M() | 0;
                               break u;
                              }
                              a = M() | 0;
                              break v;
                             }
                             a = M() | 0;
                             break w;
                            }
                            a = M() | 0;
                            break x;
                           }
                           a = M() | 0;
                           break y;
                          }
                          a = M() | 0;
                          sb(d + 84 | 0);
                         }
                         sb(g);
                        }
                        sb(f);
                       }
                       sb(d + 120 | 0);
                      }
                      sb(e);
                     }
                     sb(d + 108 | 0);
                     break a;
                    }
                    a = M() | 0;
                    break b;
                   }
                   a = M() | 0;
                   break c;
                  }
                  a = M() | 0;
                  break d;
                 }
                 a = M() | 0;
                 break e;
                }
                a = M() | 0;
                break e;
               }
               a = M() | 0;
               break f;
              }
              a = M() | 0;
              break f;
             }
             a = M() | 0;
             break g;
            }
            a = M() | 0;
            break g;
           }
           a = M() | 0;
           break h;
          }
          a = M() | 0;
          break h;
         }
         a = M() | 0;
         sb(d + 12 | 0);
        }
        sb(d + 24 | 0);
       }
       sb(d + 36 | 0);
      }
      sb(d + 48 | 0);
     }
     sb(d + 84 | 0);
    }
    sb(d + 108 | 0);
   }
   sb(d + 120 | 0);
  }
  sb(d + 132 | 0);
 }
 P(a | 0);
 p();
}

function bt(a, b, c, d) {
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
 e = eb - 592 | 0;
 eb = e;
 v[e + 572 >> 2] = 6;
 v[e + 576 >> 2] = 364;
 v[e + 564 >> 2] = 11;
 v[e + 568 >> 2] = 161;
 v[e + 556 >> 2] = 23;
 v[e + 560 >> 2] = 31;
 v[e + 548 >> 2] = 59;
 v[e + 552 >> 2] = 55;
 v[e + 584 >> 2] = 0;
 v[e + 588 >> 2] = 0;
 v[e + 580 >> 2] = -1;
 t[e + 446 | 0] = c;
 t[e + 445 | 0] = 37;
 t[e + 447 | 0] = 0;
 h = e + 448 | 0;
 ea(h | 0, 100, e + 445 | 0, e + 548 | 0, v[b >> 2]) | 0;
 f = e + 32 | 0;
 v[e + 28 >> 2] = f;
 v[e + 16 >> 2] = 0;
 v[e + 20 >> 2] = 0;
 v[e + 12 >> 2] = h;
 h = Bi(f, e + 12 | 0, 100, e + 16 | 0, v[b >> 2]);
 if ((h | 0) != -1) {
  l = b + 484 | 0;
  j = b + 460 | 0;
  i = b + 172 | 0;
  k = b + 4 | 0;
  h = (h << 2) + f | 0;
  g = Eb(a);
  m = (c | 0) != 120;
  a: while (1) {
   b: {
    c: {
     d: {
      e: {
       f: {
        g: {
         h: {
          i: {
           j: {
            k: {
             l: {
              m: {
               n: {
                o: {
                 if ((f | 0) != (h | 0)) {
                  a = v[f >> 2];
                  v[31601] = 0;
                  a = T(1284, d | 0, 1, a | 0) | 0;
                  c = v[31601];
                  v[31601] = 0;
                  if ((c | 0) == 1) {
                   break c;
                  }
                  if (a) {
                   v[31601] = 0;
                   N(35, g | 0, 32);
                   a = v[31601];
                   v[31601] = 0;
                   if ((a | 0) == 1) {
                    break c;
                   }
                   while (1) {
                    f = f + 4 | 0;
                    if ((h | 0) == (f | 0)) {
                     f = h;
                     break b;
                    }
                    a = v[f >> 2];
                    v[31601] = 0;
                    a = T(1284, d | 0, 1, a | 0) | 0;
                    c = v[31601];
                    v[31601] = 0;
                    if ((c | 0) == 1) {
                     break c;
                    }
                    if (a) {
                     continue;
                    }
                    break;
                   }
                   break b;
                  }
                  v[e + 8 >> 2] = f;
                  v[31601] = 0;
                  v[e + 4 >> 2] = 0;
                  a = da(1379, e + 8 | 0, h | 0, k | 0, i | 0, d | 0, e + 4 | 0) | 0;
                  c = v[31601];
                  v[31601] = 0;
                  if ((c | 0) == 1) {
                   break c;
                  }
                  p: {
                   a = a - k | 0;
                   q: {
                    if ((a | 0) <= 167) {
                     v[31601] = 0;
                     N(35, g | 0, 37);
                     c = v[31601];
                     v[31601] = 0;
                     if ((c | 0) == 1) {
                      break c;
                     }
                     v[31601] = 0;
                     N(35, g | 0, ((a | 0) < 84 ? 65 : 97) | 0);
                     a = v[31601];
                     v[31601] = 0;
                     if ((a | 0) != 1) {
                      break q;
                     }
                     break c;
                    }
                    v[31601] = 0;
                    v[e + 8 >> 2] = f;
                    a = da(1379, e + 8 | 0, h | 0, i | 0, j | 0, d | 0, e + 4 | 0) | 0;
                    c = v[31601];
                    v[31601] = 0;
                    if ((c | 0) == 1) {
                     break c;
                    }
                    a = a - i | 0;
                    c = (a | 0) / 12 | 0;
                    if ((a | 0) <= 287) {
                     v[31601] = 0;
                     N(35, g | 0, 37);
                     f = v[31601];
                     v[31601] = 0;
                     if ((f | 0) == 1) {
                      break c;
                     }
                     v[31601] = 0;
                     N(35, g | 0, ((a | 0) < 144 ? 66 : 98) | 0);
                     a = v[31601];
                     v[31601] = 0;
                     if ((a | 0) == 1) {
                      break c;
                     }
                     if (m) {
                      break q;
                     }
                     a = v[Vd(B(c, 12) + i | 0, 0) >> 2];
                     v[31601] = 0;
                     a = T(1284, d | 0, 64, a | 0) | 0;
                     c = v[31601];
                     v[31601] = 0;
                     if ((c | 0) == 1) {
                      break c;
                     }
                     if (!a) {
                      break q;
                     }
                     n = (Jb(g) + (Cb(v[g + 4 >> 2], w[g + 11 | 0]) << 2) | 0) - 4 | 0, o = 109, v[n >> 2] = o;
                     break q;
                    }
                    if ((Cb(v[b + 464 >> 2], w[b + 471 | 0]) | 0) == (0 - Cb(v[b + 476 >> 2], w[b + 483 | 0]) | 0)) {
                     break p;
                    }
                    v[31601] = 0;
                    v[e + 8 >> 2] = f;
                    a = da(1379, e + 8 | 0, h | 0, j | 0, l | 0, d | 0, e + 4 | 0) | 0;
                    c = v[31601];
                    v[31601] = 0;
                    if ((c | 0) == 1) {
                     break c;
                    }
                    if ((a - j | 0) > 23) {
                     break p;
                    }
                    v[31601] = 0;
                    N(35, g | 0, 37);
                    a = v[31601];
                    v[31601] = 0;
                    if ((a | 0) == 1) {
                     break c;
                    }
                    v[31601] = 0;
                    N(35, g | 0, 112);
                    a = v[31601];
                    v[31601] = 0;
                    if ((a | 0) == 1) {
                     break c;
                    }
                   }
                   f = v[e + 8 >> 2];
                   break b;
                  }
                  v[e + 8 >> 2] = f;
                  a = v[f >> 2];
                  v[31601] = 0;
                  a = T(1284, d | 0, 64, a | 0) | 0;
                  c = v[31601];
                  v[31601] = 0;
                  if ((c | 0) == 1) {
                   break c;
                  }
                  if (a) {
                   v[31601] = 0;
                   a = aa(1380, e + 28 | 0, h | 0, e + 4 | 0, d | 0) | 0;
                   c = v[31601];
                   v[31601] = 0;
                   if ((c | 0) == 1) {
                    break c;
                   }
                   r: {
                    s: {
                     switch (a - 6 | 0) {
                     case 2:
                     case 3:
                     case 4:
                      break r;

                     case 0:
                      break e;

                     case 1:
                      break f;

                     case 5:
                      break g;

                     case 6:
                      break h;

                     default:
                      break s;
                     }
                    }
                    t: {
                     switch (a - 55 | 0) {
                     case 0:
                      break k;

                     case 4:
                      break l;

                     case 6:
                      break m;

                     case 1:
                     case 2:
                     case 3:
                     case 5:
                      break r;

                     default:
                      break t;
                     }
                    }
                    if ((a | 0) == 23) {
                     break i;
                    }
                    if ((a | 0) == 31) {
                     break j;
                    }
                    if ((a | 0) == 364) {
                     break n;
                    }
                    if ((a | 0) == 2061) {
                     break o;
                    }
                   }
                   a = v[e + 28 >> 2];
                   while (1) {
                    if ((a | 0) == (f | 0)) {
                     f = a;
                     continue a;
                    }
                    c = v[f >> 2];
                    v[31601] = 0;
                    N(35, g | 0, c | 0);
                    c = v[31601];
                    v[31601] = 0;
                    if ((c | 0) == 1) {
                     break c;
                    }
                    f = f + 4 | 0;
                    continue;
                   }
                  }
                  a = v[f >> 2];
                  v[31601] = 0;
                  a = O(1381, d | 0, a | 0) | 0;
                  c = v[31601];
                  v[31601] = 0;
                  if ((c | 0) == 1) {
                   break c;
                  }
                  u: {
                   if ((a | 0) == 37) {
                    v[31601] = 0;
                    N(35, g | 0, 37);
                    a = v[31601];
                    v[31601] = 0;
                    if ((a | 0) == 1) {
                     break c;
                    }
                    v[31601] = 0;
                    N(35, g | 0, 37);
                    break u;
                   }
                   a = v[f >> 2];
                   v[31601] = 0;
                   N(35, g | 0, a | 0);
                  }
                  a = v[31601];
                  v[31601] = 0;
                  if ((a | 0) == 1) {
                   break c;
                  }
                  f = f + 4 | 0;
                  break b;
                 }
                 eb = e + 592 | 0;
                 return;
                }
                v[31601] = 0;
                N(35, g | 0, 37);
                a = v[31601];
                v[31601] = 0;
                c = 89;
                break d;
               }
               v[31601] = 0;
               N(35, g | 0, 37);
               a = v[31601];
               v[31601] = 0;
               c = 106;
               break d;
              }
              v[31601] = 0;
              N(35, g | 0, 37);
              a = v[31601];
              v[31601] = 0;
              c = 121;
              break d;
             }
             v[31601] = 0;
             N(35, g | 0, 37);
             a = v[31601];
             v[31601] = 0;
             c = 83;
             break d;
            }
            v[31601] = 0;
            N(35, g | 0, 37);
            a = v[31601];
            v[31601] = 0;
            c = 77;
            break d;
           }
           v[31601] = 0;
           N(35, g | 0, 37);
           a = v[31601];
           v[31601] = 0;
           c = 100;
           break d;
          }
          v[31601] = 0;
          N(35, g | 0, 37);
          a = v[31601];
          v[31601] = 0;
          c = 72;
          break d;
         }
         v[31601] = 0;
         N(35, g | 0, 37);
         a = v[31601];
         v[31601] = 0;
         c = 109;
         break d;
        }
        v[31601] = 0;
        N(35, g | 0, 37);
        a = v[31601];
        v[31601] = 0;
        c = 73;
        break d;
       }
       v[31601] = 0;
       N(35, g | 0, 37);
       a = v[31601];
       v[31601] = 0;
       c = 117;
       break d;
      }
      v[31601] = 0;
      N(35, g | 0, 37);
      a = v[31601];
      v[31601] = 0;
      c = 119;
     }
     if ((a | 0) == 1) {
      break c;
     }
     v[31601] = 0;
     N(35, g | 0, c | 0);
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) == 1) {
      break c;
     }
     f = v[e + 28 >> 2];
     continue;
    }
    a = M() | 0;
    Tb(g);
    P(a | 0);
    p();
   }
   v[e + 28 >> 2] = f;
   continue;
  }
 }
 fo(12661);
 p();
}

function Ko(a, b, c, d, e, f) {
 var g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, z = 0, A = 0, C = 0, D = 0, E = 0;
 h = x[a + 480192 >> 1] >= c >>> 0 ? v[((c << 2) + a | 0) + 900380 >> 2] : h;
 r = v[b + 752 >> 2];
 a: {
  j = w[b + 802 | 0];
  b: {
   if (!j) {
    if (Nb(a + 1074312 | 0, 11)) {
     break b;
    }
   }
   g = a + 484380 | 0;
   c: {
    d: {
     if (!h) {
      break d;
     }
     if (!Tc(j)) {
      break d;
     }
     e: {
      j = j - 1 | 0;
      k = $b(h + 236 | 0, j);
      if (x[k >> 1]) {
       break e;
      }
      if (!Nb(a + 1074312 | 0, 43)) {
       break e;
      }
      if (Ij(w[h + 31 | 0])) {
       break e;
      }
      v[b + 656 >> 2] = h;
      return;
     }
     if (w[wb(h + 108 | 0, j) | 0] > 120) {
      break b;
     }
     j = x[k >> 1];
     k = (j - 1 & 65535) >>> 0 < 3999 ? g + B(j, 104) | 0 : 0;
     break c;
    }
    if (!x[a + 480192 >> 1]) {
     k = g + B(c, 104) | 0;
     break c;
    }
    if (j >>> 0 > 250) {
     break b;
    }
    if (!Nb(a + 1074312 | 0, 43)) {
     break c;
    }
    if (h) {
     if (Ij(w[h + 31 | 0])) {
      break c;
     }
    }
    t[b + 803 | 0] = 0;
    v[b + 656 >> 2] = 0;
    return;
   }
   j = v[b + 104 >> 2];
   m = (j | 0) != 0 & (j | 0) != (k | 0);
   i = v[b + 656 >> 2];
   p = !h | v[a + 480180 >> 2] != 16777216 ? p : v[h + 44 >> 2] != 0;
   n = d ^ 1;
   g = (i | 0) != (h | 0);
   if ((n | g | m) == 1) {
    u[b + 774 >> 1] = 0;
   }
   l = !m;
   if (!(l | (g | !(d & p)))) {
    break b;
   }
   f: {
    if (l | n) {
     break f;
    }
    q = a + 1074312 | 0;
    if (!(!Nb(q, 32) | !(w[a + 480208 | 0] & 8))) {
     k = v[b + 8 >> 2] | v[b + 12 >> 2] ? v[b + 104 >> 2] : k;
    }
    j = v[a + 480180 >> 2];
    g: {
     h: {
      i: {
       j: {
        if (!g) {
         if ((h | 0) != 0 & (j & 1048580) != 0 | (j | 0) == 268435456) {
          break h;
         }
         if ((j | 0) != 1) {
          break i;
         }
         break j;
        }
        if ((j | 0) == 1) {
         break j;
        }
        if ((j | 0) == 268435456) {
         break h;
        }
        break i;
       }
       if (Li(v[b + 8 >> 2], v[b + 12 >> 2])) {
        break h;
       }
      }
      if (!Nb(q, 79)) {
       break g;
      }
      if (!Li(v[b + 8 >> 2], v[b + 12 >> 2])) {
       break g;
      }
     }
     o = 1;
    }
    if (!Nb(q, 119) | x[a + 480192 >> 1]) {
     break f;
    }
    t[b + 851 | 0] = w[b + 851 | 0] | 2;
   }
   k: {
    if (!v[b + 16 >> 2] | (l | (g | !x[a + 480192 >> 1]))) {
     break k;
    }
    if (!Nb(a + 1074312 | 0, 87)) {
     break k;
    }
    o = Tc(w[b + 788 | 0]) ^ 1 | o;
   }
   l = (i | 0) != (h | 0);
   l: {
    if (Li(v[b + 8 >> 2], v[b + 12 >> 2]) | !(v[a + 480180 >> 2] & 16777248)) {
     break l;
    }
    if (h) {
     if (Ij(w[h + 31 | 0])) {
      break l;
     }
    }
    l = 1;
   }
   m: {
    n: {
     if (!d | (l | m) != 1) {
      break n;
     }
     if (!Nb(a + 1074312 | 0, 61)) {
      break n;
     }
     g = v[b + 104 >> 2];
     i = v[b + 656 >> 2];
     j = 0;
     if (g | i) {
      break m;
     }
    }
    v[b + 656 >> 2] = h;
    g = k;
    i = h;
    j = l;
   }
   o: {
    p: {
     q: {
      r: {
       if (!e) {
        break r;
       }
       s: {
        if (w[a + 480180 | 0] & 3) {
         if (g) {
          if (ke(v[g >> 2], v[g + 20 >> 2])) {
           break s;
          }
         }
         if (!Aj(i)) {
          break r;
         }
        }
        if (!g) {
         break q;
        }
       }
       if (u[g + 34 >> 1] < 0) {
        break r;
       }
       v[b + 688 >> 2] = x[g + 30 >> 1];
      }
      h = (g | 0) != 0;
      if (!(m & o) | !g) {
       break o;
      }
      if (Nb(a + 1074312 | 0, 85)) {
       u[b + 772 >> 1] = t[g + 37 | 0];
      }
      h = 1;
      if (v[a + 480180 >> 2] != 2) {
       break o;
      }
      if (!ke(v[g >> 2], v[g + 20 >> 2])) {
       break o;
      }
      l = 704;
      k = v[g + 24 >> 2];
      break p;
     }
     l = 688;
     if (!i) {
      h = 0;
      k = 0;
      break p;
     }
     h = 0;
     k = 0;
     if (!w[i + 34 | 0]) {
      break p;
     }
     k = v[b + 688 >> 2];
     if (i) {
      k = v[i + 4 >> 2] << 2;
     }
    }
    v[b + l >> 2] = k;
   }
   if (o) {
    break b;
   }
   t[b + 803 | 0] = 0;
   t: {
    if (!i) {
     break t;
    }
    if (s = (C = Nb(a + 1074312 | 0, 29), D = 1, E = g, E ? C : D), z = 0, A = !w[i + 34 | 0] & (j ^ -1), 
    A ? s : z) {
     break t;
    }
    t[b + 798 | 0] = w[i + 16 | 0];
   }
   k = 64;
   v[b + 752 >> 2] = 64;
   if (g) {
    k = x[g + 32 >> 1];
    v[b + 752 >> 2] = k;
   }
   if (i) {
    v[b + 752 >> 2] = B(v[i + 4 >> 2], k) >>> 6;
   }
   u: {
    if (!(v[a + 480180 >> 2] & 1048580 ? e : 1)) {
     break u;
    }
    if (Nb(a + 1074312 | 0, 48)) {
     break u;
    }
    aT(a, b, i, g);
   }
   v: {
    w: {
     x: {
      if (!f) {
       break x;
      }
      y: {
       z: {
        A: {
         B: {
          C: {
           D: {
            E: {
             F: {
              f = a + 1074312 | 0;
              if (Nb(f, 19)) {
               if (!v[b + 76 >> 2]) {
                e = 1;
                break E;
               }
               if (!(!c | n)) {
                e = (w[a + 480208 | 0] & 8) >>> 3 | 0;
                if (e) {
                 break E;
                }
                break F;
               }
               e = 0;
               if (c) {
                break F;
               }
               break E;
              }
              G: {
               c = v[a + 480180 >> 2] & 17301536;
               e = 1;
               H: {
                if (!d | !c) {
                 break H;
                }
                c = 1;
                e = 1;
                if (w[a + 480208 | 0] & 8) {
                 break H;
                }
                e = 1;
                if (!v[b + 76 >> 2]) {
                 break H;
                }
                if (!(w[b + 89 | 0] & 16)) {
                 break G;
                }
                e = !v[b + 696 >> 2];
               }
               if (j | (!i | !c)) {
                break C;
               }
               if (!e) {
                break y;
               }
               c = v[b + 88 >> 2];
               v[b + 88 >> 2] = c | 2097152;
               if (c & 6144) {
                break B;
               }
               break D;
              }
              if ((j | !i) != 1) {
               break y;
              }
              break z;
             }
             if (d) {
              break E;
             }
             if (!(w[b + 89 | 0] & 24)) {
              e = 0;
              break E;
             }
             e = (w[a + 480208 | 0] & 4) >>> 2 | 0;
            }
            if (j | !v[b + 696 >> 2]) {
             break C;
            }
            if (!e) {
             break z;
            }
            c = v[b + 88 >> 2];
            v[b + 88 >> 2] = c | 2097152;
            if (!i) {
             break A;
            }
            if (c & 2048) {
             break B;
            }
           }
           if (!(w[i + 60 | 0] & 8)) {
            zj(b + 724 | 0);
           }
           if (!(w[i + 80 | 0] & 8)) {
            zj(b + 732 | 0);
           }
           if (w[i + 100 | 0] & 8) {
            break A;
           }
           zj(b + 740 | 0);
           break A;
          }
          if (!e) {
           break z;
          }
          v[b + 88 >> 2] = v[b + 88 >> 2] | 2097152;
          if (!i) {
           break A;
          }
         }
         Xm(b);
        }
        if (Nb(f, 21)) {
         break x;
        }
        t[b + 818 | 0] = 0;
        v[b + 756 >> 2] = 0;
        break x;
       }
       if (!i) {
        break w;
       }
      }
      if (t[i + 60 | 0] & 1) {
       break x;
      }
      if (Nb(f, 32)) {
       zj(b + 724 | 0);
       break x;
      }
      Xm(b);
     }
     c = 0;
     if (g) {
      break v;
     }
     if (!i) {
      break a;
     }
     c = 1;
     if (Ij(w[i + 31 | 0])) {
      break v;
     }
     break a;
    }
    c = 0;
    if (!g) {
     break a;
    }
   }
   I: {
    if (!(!d | (h ^ 1 | v[b + 104 >> 2] != (g | 0)))) {
     e = v[a + 480180 >> 2];
     if (v[b + 76 >> 2] ? e & 16777250 : 0) {
      break b;
     }
     J: {
      K: {
       if ((e | 0) != 4) {
        break K;
       }
       if (!Nb(a + 1074312 | 0, 40) | w[b + 789 | 0]) {
        break K;
       }
       e = v[b + 88 >> 2];
       break J;
      }
      e = v[b + 88 >> 2] & -6145;
     }
     v[b + 88 >> 2] = e & -640;
     break I;
    }
    v[b + 88 >> 2] = v[b + 88 >> 2] & -6145;
    e = a + 1074312 | 0;
    L: {
     M: {
      if (!Nb(e, 18)) {
       h = -640;
       if (j | (v[a + 480180 >> 2] & 16777248 | v[b + 104 >> 2] != (g | 0))) {
        break M;
       }
       break L;
      }
      h = -640;
      if ((j ^ -1) & v[b + 104 >> 2] == (g | 0)) {
       break L;
      }
     }
     h = -768;
    }
    v[b + 88 >> 2] = v[b + 88 >> 2] & h;
    if (!i) {
     break I;
    }
    t[b + 730 | 0] = w[i + 60 | 0];
    t[b + 738 | 0] = w[i + 80 | 0];
    f = w[i + 100 | 0];
    t[b + 746 | 0] = f;
    N: {
     if ((f & 17) != 17) {
      break N;
     }
     if (Nb(e, 36) | w[b + 837 | 0]) {
      break N;
     }
     t[b + 837 | 0] = 127;
    }
    e = w[i + 21 | 0];
    if (ud(e)) {
     s = b, z = Gh(e), t[s + 837 | 0] = z;
    }
    e = w[i + 22 | 0];
    if (!ud(e)) {
     break I;
    }
    s = b, z = Gh(e), t[s + 838 | 0] = z;
   }
   if (c) {
    v[b + 76 >> 2] = 0;
    v[b + 104 >> 2] = 0;
    return;
   }
   O: {
    if (v[b + 76 >> 2] | !d) {
     break O;
    }
    c = a + 1074312 | 0;
    if (!Nb(c, 54)) {
     if (!Nb(c, 39)) {
      break O;
     }
    }
    v[b + 8 >> 2] = 0;
    v[b + 12 >> 2] = 0;
   }
   P: {
    if (w[b + 788 | 0] != 255) {
     break P;
    }
    if (!Nb(a + 1074312 | 0, 100) | !(w[a + 480208 | 0] >>> 2 & m)) {
     break P;
    }
    c = v[b + 104 >> 2];
    if (c) {
     v[b + 88 >> 2] = v[b + 88 >> 2] | x[c + 34 >> 1] & 1023;
    }
    v[b + 752 >> 2] = r;
    v[b + 688 >> 2] = x[g + 30 >> 1];
    if (!(w[g + 34 | 0] & 32)) {
     break b;
    }
    Sq(b, x[g + 28 >> 1], a);
    return;
   }
   v[b + 104 >> 2] = g;
   v[b + 76 >> 2] = v[g >> 2];
   v[b + 80 >> 2] = v[g + 4 >> 2];
   v[b + 84 >> 2] = v[g + 8 >> 2];
   c = a + 1074312 | 0;
   if (!(!Nb(c, 83) | v[b + 80 >> 2])) {
    v[b + 84 >> 2] = v[g >> 2];
   }
   v[b + 88 >> 2] = v[b + 88 >> 2] | x[g + 34 >> 1] & 1023;
   if (Nb(c, 21)) {
    t[b + 818 | 0] = 0;
    v[b + 756 >> 2] = 0;
   }
   Q: {
    R: {
     if (p) {
      v[b + 704 >> 2] = v[g + 24 >> 2];
      t[b + 851 | 0] = w[b + 851 | 0] | 64;
      d = 0;
      break R;
     }
     if (!(m | n)) {
      d = v[a + 480180 >> 2];
      if (d & 5) {
       break Q;
      }
     }
     v[b + 704 >> 2] = v[g + 24 >> 2];
     d = t[g + 37 | 0];
    }
    u[b + 772 >> 1] = d;
    d = v[a + 480180 >> 2];
   }
   if (wn(d)) {
    d = t[g + 36 | 0];
   } else {
    d = 0;
   }
   u[b + 770 >> 1] = d;
   if (!(Nb(c, 69) | v[a + 480180 >> 2] == 1)) {
    v[b + 708 >> 2] = 0;
   }
   v[b + 852 >> 2] = 0;
   h = v[b + 88 >> 2];
   if (h & 8) {
    v[b + 80 >> 2] = v[g + 12 >> 2];
    v[b + 84 >> 2] = v[g + 16 >> 2];
    h = h >>> 2 & 4 | h | 2;
    v[b + 88 >> 2] = h;
   }
   c = v[b + 76 >> 2];
   S: {
    if (!(h & 2)) {
     break S;
    }
    d = v[b + 84 >> 2];
    if (d >>> 0 >= c >>> 0) {
     break S;
    }
    v[b + 76 >> 2] = d;
    c = d;
   }
   if (!(v[a + 480180 >> 2] & 16777248) | y[b + 4 >> 2] < c >>> 0) {
    break b;
   }
   v[b >> 2] = 0;
   v[b + 4 >> 2] = 0;
  }
  return;
 }
 v[b + 752 >> 2] = 0;
 v[b + 104 >> 2] = 0;
}
function v9(a, b, c, d, e, f) {
 a = a | 0;
 b = +b;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 f = f | 0;
 var g = 0, h = 0, i = 0, k = 0, l = 0, m = 0, n = 0, p = 0, q = 0, r = 0, s = 0, u = 0, x = 0, y = 0, z = 0, A = 0, C = 0, E = 0, F = 0;
 p = eb - 560 | 0;
 eb = p;
 v[p + 44 >> 2] = 0;
 o(+b);
 g = j(1) | 0;
 j(0) | 0;
 a: {
  if ((g | 0) < 0) {
   y = 1;
   C = 5296;
   b = -b;
   o(+b);
   g = j(1) | 0;
   j(0) | 0;
   break a;
  }
  if (e & 2048) {
   y = 1;
   C = 5299;
   break a;
  }
  y = e & 1;
  C = y ? 5302 : 5297;
  F = !y;
 }
 b: {
  if ((g & 2146435072) == 2146435072) {
   g = y + 3 | 0;
   Vf(a, 32, c, g, e & -65537);
   Jf(a, C, y);
   d = f & 32;
   Jf(a, b != b ? d ? 9978 : 13848 : d ? 11132 : 14166, 3);
   Vf(a, 32, c, g, e ^ 8192);
   n = (c | 0) < (g | 0) ? g : c;
   break b;
  }
  z = p + 16 | 0;
  c: {
   d: {
    e: {
     b = pL(b, p + 44 | 0);
     b = b + b;
     if (b != 0) {
      g = v[p + 44 >> 2];
      v[p + 44 >> 2] = g - 1;
      A = f | 32;
      if ((A | 0) != 97) {
       break e;
      }
      break c;
     }
     A = f | 32;
     if ((A | 0) == 97) {
      break c;
     }
     k = v[p + 44 >> 2];
     m = (d | 0) < 0 ? 6 : d;
     break d;
    }
    k = g - 29 | 0;
    v[p + 44 >> 2] = k;
    b = b * 268435456;
    m = (d | 0) < 0 ? 6 : d;
   }
   s = (p + 48 | 0) + ((k | 0) >= 0 ? 288 : 0) | 0;
   h = s;
   while (1) {
    if (b < 4294967296 & b >= 0) {
     d = ~~b >>> 0;
    } else {
     d = 0;
    }
    v[h >> 2] = d;
    h = h + 4 | 0;
    b = (b - +(d >>> 0)) * 1e9;
    if (b != 0) {
     continue;
    }
    break;
   }
   f: {
    if ((k | 0) <= 0) {
     d = k;
     g = h;
     i = s;
     break f;
    }
    i = s;
    d = k;
    while (1) {
     l = (d | 0) >= 29 ? 29 : d;
     g = h - 4 | 0;
     g: {
      if (i >>> 0 > g >>> 0) {
       break g;
      }
      q = 0;
      while (1) {
       d = v[g >> 2];
       n = l & 31;
       E = q;
       if ((l & 63) >>> 0 >= 32) {
        q = d << n;
        d = 0;
       } else {
        q = (1 << n) - 1 & d >>> 32 - n;
        d = d << n;
       }
       n = E + d | 0;
       q = q + r | 0;
       q = Cua(n, d >>> 0 > n >>> 0 ? q + 1 | 0 : q, 1e9, 0);
       d = Aua(q, gb, -1e9, 0) + n | 0;
       v[g >> 2] = d;
       g = g - 4 | 0;
       if (i >>> 0 <= g >>> 0) {
        continue;
       }
       break;
      }
      if (!q) {
       break g;
      }
      i = i - 4 | 0;
      v[i >> 2] = q;
     }
     while (1) {
      g = h;
      if (i >>> 0 < g >>> 0) {
       h = g - 4 | 0;
       if (!v[h >> 2]) {
        continue;
       }
      }
      break;
     }
     d = v[p + 44 >> 2] - l | 0;
     v[p + 44 >> 2] = d;
     h = g;
     if ((d | 0) > 0) {
      continue;
     }
     break;
    }
   }
   if ((d | 0) < 0) {
    x = ((m + 25 >>> 0) / 9 | 0) + 1 | 0;
    r = (A | 0) == 102;
    while (1) {
     d = 0 - d | 0;
     n = (d | 0) >= 9 ? 9 : d;
     h: {
      if (g >>> 0 <= i >>> 0) {
       h = !v[i >> 2] << 2;
       break h;
      }
      q = 1e9 >>> n | 0;
      l = -1 << n ^ -1;
      d = 0;
      h = i;
      while (1) {
       E = d;
       d = v[h >> 2];
       v[h >> 2] = E + (d >>> n | 0);
       d = B(q, d & l);
       h = h + 4 | 0;
       if (h >>> 0 < g >>> 0) {
        continue;
       }
       break;
      }
      h = !v[i >> 2] << 2;
      if (!d) {
       break h;
      }
      v[g >> 2] = d;
      g = g + 4 | 0;
     }
     d = n + v[p + 44 >> 2] | 0;
     v[p + 44 >> 2] = d;
     i = h + i | 0;
     h = r ? s : i;
     g = g - h >> 2 > (x | 0) ? h + (x << 2) | 0 : g;
     if ((d | 0) < 0) {
      continue;
     }
     break;
    }
   }
   d = 0;
   i: {
    if (g >>> 0 <= i >>> 0) {
     break i;
    }
    d = B(s - i >> 2, 9);
    h = 10;
    l = v[i >> 2];
    if (l >>> 0 < 10) {
     break i;
    }
    while (1) {
     d = d + 1 | 0;
     h = B(h, 10);
     if (l >>> 0 >= h >>> 0) {
      continue;
     }
     break;
    }
   }
   h = (m - ((A | 0) != 102 ? d : 0) | 0) - ((A | 0) == 103 & (m | 0) != 0) | 0;
   if ((h | 0) < (B(g - s >> 2, 9) - 9 | 0)) {
    q = h + 9216 | 0;
    l = (q | 0) / 9 | 0;
    x = ((p + 48 | 0) + ((k | 0) < 0 ? 4 : 292) | 0) + (l << 2) | 0;
    k = x - 4096 | 0;
    h = 10;
    n = q + B(l, -9) | 0;
    if ((n | 0) <= 7) {
     while (1) {
      h = B(h, 10);
      n = n + 1 | 0;
      if ((n | 0) != 8) {
       continue;
      }
      break;
     }
    }
    r = v[k >> 2];
    q = (r >>> 0) / (h >>> 0) | 0;
    n = B(q, h);
    l = x - 4092 | 0;
    j: {
     if ((n | 0) == (r | 0) & (l | 0) == (g | 0)) {
      break j;
     }
     r = r - n | 0;
     k: {
      if (!(q & 1)) {
       b = 9007199254740992;
       if (!(t[x - 4100 | 0] & 1) | ((h | 0) != 1e9 | i >>> 0 >= k >>> 0)) {
        break k;
       }
      }
      b = 9007199254740994;
     }
     u = (g | 0) == (l | 0) ? 1 : 1.5;
     l = h >>> 1 | 0;
     u = l >>> 0 > r >>> 0 ? .5 : (l | 0) == (r | 0) ? u : 1.5;
     if (!(w[C | 0] != 45 | F)) {
      u = -u;
      b = -b;
     }
     v[k >> 2] = n;
     if (b + u == b) {
      break j;
     }
     d = h + n | 0;
     v[k >> 2] = d;
     if (d >>> 0 >= 1e9) {
      while (1) {
       v[k >> 2] = 0;
       k = k - 4 | 0;
       if (k >>> 0 < i >>> 0) {
        i = i - 4 | 0;
        v[i >> 2] = 0;
       }
       d = v[k >> 2] + 1 | 0;
       v[k >> 2] = d;
       if (d >>> 0 > 999999999) {
        continue;
       }
       break;
      }
     }
     d = B(s - i >> 2, 9);
     h = 10;
     l = v[i >> 2];
     if (l >>> 0 < 10) {
      break j;
     }
     while (1) {
      d = d + 1 | 0;
      h = B(h, 10);
      if (l >>> 0 >= h >>> 0) {
       continue;
      }
      break;
     }
    }
    h = k + 4 | 0;
    g = g >>> 0 > h >>> 0 ? h : g;
   }
   while (1) {
    l = g;
    q = g >>> 0 <= i >>> 0;
    if (!q) {
     g = g - 4 | 0;
     if (!v[g >> 2]) {
      continue;
     }
    }
    break;
   }
   l: {
    if ((A | 0) != 103) {
     k = e & 8;
     break l;
    }
    h = m ? m : 1;
    g = (h | 0) > (d | 0) & (d | 0) > -5;
    m = (g ? d ^ -1 : -1) + h | 0;
    f = (g ? -1 : -2) + f | 0;
    k = e & 8;
    if (k) {
     break l;
    }
    g = -9;
    m: {
     if (q) {
      break m;
     }
     k = v[l - 4 >> 2];
     if (!k) {
      break m;
     }
     n = 10;
     g = 0;
     if ((k >>> 0) % 10 | 0) {
      break m;
     }
     while (1) {
      h = g;
      g = g + 1 | 0;
      n = B(n, 10);
      if (!((k >>> 0) % (n >>> 0) | 0)) {
       continue;
      }
      break;
     }
     g = h ^ -1;
    }
    h = B(l - s >> 2, 9);
    if ((f & -33) == 70) {
     k = 0;
     g = (g + h | 0) - 9 | 0;
     g = (g | 0) > 0 ? g : 0;
     m = (g | 0) > (m | 0) ? m : g;
     break l;
    }
    k = 0;
    g = ((d + h | 0) + g | 0) - 9 | 0;
    g = (g | 0) > 0 ? g : 0;
    m = (g | 0) > (m | 0) ? m : g;
   }
   n = -1;
   q = k | m;
   if (((q ? 2147483645 : 2147483646) | 0) < (m | 0)) {
    break b;
   }
   r = (((q | 0) != 0) + m | 0) + 1 | 0;
   h = f & -33;
   n: {
    if ((h | 0) == 70) {
     if ((r ^ 2147483647) < (d | 0)) {
      break b;
     }
     g = (d | 0) > 0 ? d : 0;
     break n;
    }
    g = d >> 31;
    g = ko((g ^ d) - g | 0, 0, z);
    if ((z - g | 0) <= 1) {
     while (1) {
      g = g - 1 | 0;
      t[g | 0] = 48;
      if ((z - g | 0) < 2) {
       continue;
      }
      break;
     }
    }
    x = g - 2 | 0;
    t[x | 0] = f;
    t[g - 1 | 0] = (d | 0) < 0 ? 45 : 43;
    g = z - x | 0;
    if ((g | 0) > (r ^ 2147483647)) {
     break b;
    }
   }
   d = g + r | 0;
   if ((d | 0) > (y ^ 2147483647)) {
    break b;
   }
   r = d + y | 0;
   Vf(a, 32, c, r, e);
   Jf(a, C, y);
   Vf(a, 48, c, r, e ^ 65536);
   o: {
    p: {
     q: {
      if ((h | 0) == 70) {
       f = p + 16 | 0;
       d = f | 8;
       k = f | 9;
       h = i >>> 0 > s >>> 0 ? s : i;
       i = h;
       while (1) {
        g = ko(v[i >> 2], 0, k);
        r: {
         if ((h | 0) != (i | 0)) {
          if (p + 16 >>> 0 >= g >>> 0) {
           break r;
          }
          while (1) {
           g = g - 1 | 0;
           t[g | 0] = 48;
           if (p + 16 >>> 0 < g >>> 0) {
            continue;
           }
           break;
          }
          break r;
         }
         if ((g | 0) != (k | 0)) {
          break r;
         }
         t[p + 24 | 0] = 48;
         g = d;
        }
        Jf(a, g, k - g | 0);
        i = i + 4 | 0;
        if (s >>> 0 >= i >>> 0) {
         continue;
        }
        break;
       }
       if (q) {
        Jf(a, 16770, 1);
       }
       if ((m | 0) <= 0 | i >>> 0 >= l >>> 0) {
        break q;
       }
       while (1) {
        g = ko(v[i >> 2], 0, k);
        if (g >>> 0 > p + 16 >>> 0) {
         while (1) {
          g = g - 1 | 0;
          t[g | 0] = 48;
          if (p + 16 >>> 0 < g >>> 0) {
           continue;
          }
          break;
         }
        }
        Jf(a, g, (m | 0) >= 9 ? 9 : m);
        g = m - 9 | 0;
        i = i + 4 | 0;
        if (l >>> 0 <= i >>> 0) {
         break p;
        }
        d = (m | 0) > 9;
        m = g;
        if (d) {
         continue;
        }
        break;
       }
       break p;
      }
      s: {
       if ((m | 0) < 0) {
        break s;
       }
       s = i >>> 0 < l >>> 0 ? l : i + 4 | 0;
       f = p + 16 | 0;
       d = f | 8;
       l = f | 9;
       h = i;
       while (1) {
        g = ko(v[h >> 2], 0, l);
        if ((l | 0) == (g | 0)) {
         t[p + 24 | 0] = 48;
         g = d;
        }
        t: {
         if ((h | 0) != (i | 0)) {
          if (p + 16 >>> 0 >= g >>> 0) {
           break t;
          }
          while (1) {
           g = g - 1 | 0;
           t[g | 0] = 48;
           if (p + 16 >>> 0 < g >>> 0) {
            continue;
           }
           break;
          }
          break t;
         }
         Jf(a, g, 1);
         g = g + 1 | 0;
         if (!(k | m)) {
          break t;
         }
         Jf(a, 16770, 1);
        }
        f = l - g | 0;
        Jf(a, g, (f | 0) < (m | 0) ? f : m);
        m = m - f | 0;
        h = h + 4 | 0;
        if (s >>> 0 <= h >>> 0) {
         break s;
        }
        if ((m | 0) >= 0) {
         continue;
        }
        break;
       }
      }
      Vf(a, 48, m + 18 | 0, 18, 0);
      Jf(a, x, z - x | 0);
      break o;
     }
     g = m;
    }
    Vf(a, 48, g + 9 | 0, 9, 0);
   }
   Vf(a, 32, c, r, e ^ 8192);
   n = (c | 0) < (r | 0) ? r : c;
   break b;
  }
  k = (f << 26 >> 31 & 9) + C | 0;
  u: {
   if (d >>> 0 > 11) {
    break u;
   }
   g = 12 - d | 0;
   u = 16;
   while (1) {
    u = u * 16;
    g = g - 1 | 0;
    if (g) {
     continue;
    }
    break;
   }
   if (w[k | 0] == 45) {
    b = -(u + (-b - u));
    break u;
   }
   b = b + u - u;
  }
  s = y | 2;
  i = f & 32;
  h = v[p + 44 >> 2];
  g = h >> 31;
  g = ko((g ^ h) - g | 0, 0, z);
  if ((z | 0) == (g | 0)) {
   t[p + 15 | 0] = 48;
   g = p + 15 | 0;
  }
  m = g - 2 | 0;
  t[m | 0] = f + 15;
  t[g - 1 | 0] = (h | 0) < 0 ? 45 : 43;
  g = e & 8;
  h = p + 16 | 0;
  while (1) {
   f = h;
   if (D(b) < 2147483648) {
    l = ~~b;
   } else {
    l = -2147483648;
   }
   t[h | 0] = i | w[l + 93200 | 0];
   b = (b - +(l | 0)) * 16;
   h = f + 1 | 0;
   if (!(!(g | (d | 0) > 0) & b == 0 | (h - (p + 16 | 0) | 0) != 1)) {
    t[f + 1 | 0] = 46;
    h = f + 2 | 0;
   }
   if (b != 0) {
    continue;
   }
   break;
  }
  n = -1;
  g = z - m | 0;
  f = g + s | 0;
  if ((2147483645 - f | 0) < (d | 0)) {
   break b;
  }
  l = f;
  f = p + 16 | 0;
  i = h - f | 0;
  d = d ? (i - 2 | 0) < (d | 0) ? d + 2 | 0 : i : i;
  h = l + d | 0;
  Vf(a, 32, c, h, e);
  Jf(a, k, s);
  Vf(a, 48, c, h, e ^ 65536);
  Jf(a, f, i);
  Vf(a, 48, d - i | 0, 0, 0);
  Jf(a, m, g);
  Vf(a, 32, c, h, e ^ 8192);
  n = (c | 0) < (h | 0) ? h : c;
 }
 eb = p + 560 | 0;
 return n | 0;
}

function coa(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, q = 0, r = 0;
 e = eb - 112 | 0;
 eb = e;
 xc(c);
 a: {
  b: {
   c: {
    d: {
     if (!fp(c, e + 100 | 0) | (w[e + 100 | 0] | w[e + 101 | 0] << 8 | (w[e + 102 | 0] << 16 | w[e + 103 | 0] << 24)) != 1297239878) {
      break d;
     }
     d = w[e + 108 | 0] | w[e + 109 | 0] << 8 | (w[e + 110 | 0] << 16 | w[e + 111 | 0] << 24);
     if (!((d | 0) == 1482052408 | (d | 0) == 1448293937) & (d | 0) != 1146437965) {
      break d;
     }
     d = eb - 32 | 0;
     eb = d;
     g = e + 88 | 0;
     k = Mb(g);
     e: {
      f: {
       g: {
        h: {
         i: {
          while (1) {
           j = v[c + 8 >> 2];
           f = v[c >> 2];
           v[31601] = 0;
           j = T(150, f | 0, j | 0, 8) | 0;
           f = v[31601];
           v[31601] = 0;
           if ((f | 0) == 1) {
            break g;
           }
           if (!j) {
            break h;
           }
           v[31601] = 0;
           j = d + 4 | 0;
           N(828, j | 0, c | 0);
           f = v[31601];
           v[31601] = 0;
           if ((f | 0) != 1) {
            v[31601] = 0;
            N(829, k | 0, j | 0);
            f = v[31601];
            v[31601] = 0;
            if ((f | 0) == 1) {
             break i;
            }
            Gd(j);
            continue;
           }
           break;
          }
          a = M() | 0;
          break f;
         }
         a = M() | 0;
         Gd(d + 4 | 0);
         break f;
        }
        eb = d + 32 | 0;
        break e;
       }
       a = M() | 0;
      }
      je(k);
      P(a | 0);
      p();
     }
     v[31601] = 0;
     j = Q(168, e + 68 | 0) | 0;
     c = v[31601];
     v[31601] = 0;
     j: {
      k: {
       l: {
        m: {
         n: {
          o: {
           p: {
            if ((c | 0) != 1) {
             k = Yc(e - -64 | 0, 8, 1, 1, 0);
             if ((w[e + 108 | 0] | w[e + 109 | 0] << 8 | (w[e + 110 | 0] << 16 | w[e + 111 | 0] << 24)) != 1146437965) {
              break n;
             }
             v[31601] = 0;
             d = e + 44 | 0;
             R(740, d | 0, g | 0, 1296581714);
             c = v[31601];
             v[31601] = 0;
             if ((c | 0) == 1) {
              break m;
             }
             v[31601] = 0;
             c = e + 24 | 0;
             R(740, c | 0, g | 0, 1296318804);
             g = v[31601];
             v[31601] = 0;
             if ((g | 0) == 1) {
              break l;
             }
             h = jd(j, c);
             tb(c);
             g = 0;
             v[31601] = 0;
             f = Q(741, d | 0) | 0;
             c = v[31601];
             v[31601] = 0;
             if ((c | 0) == 1) {
              break l;
             }
             c = 0;
             if (!f) {
              break o;
             }
             c = v[h >> 2];
             v[31601] = 0;
             h = Q(172, c | 0) | 0;
             c = v[31601];
             v[31601] = 0;
             if ((c | 0) == 1) {
              break l;
             }
             c = 0;
             if (!h) {
              break o;
             }
             v[31601] = 0;
             m = Q(281, d | 0) | 0;
             c = v[31601];
             v[31601] = 0;
             if ((c | 0) == 1) {
              break l;
             }
             v[31601] = 0;
             f = Q(273, d | 0) | 0;
             c = v[31601];
             v[31601] = 0;
             q: {
              if ((c | 0) == 1) {
               break q;
              }
              v[31601] = 0;
              O(183, d | 0, 2) | 0;
              c = v[31601];
              v[31601] = 0;
              if ((c | 0) == 1) {
               break q;
              }
              v[31601] = 0;
              g = Q(281, d | 0) | 0;
              c = v[31601];
              v[31601] = 0;
              if ((c | 0) != 1) {
               break p;
              }
             }
             break l;
            }
            c = M() | 0;
            break a;
           }
           c = 0;
           v[31601] = 0;
           h = e + 24 | 0;
           N(652, h | 0, e + 44 | 0);
           d = v[31601];
           v[31601] = 0;
           if ((d | 0) == 1) {
            break l;
           }
           d = $Z(h);
           i = Ab(x[e + 24 >> 1]);
           if (!i) {
            break o;
           }
           g = (g >>> 0) / (i >>> 0) | 0;
           i = fc(h);
           h = _e(h);
           i = Ab(w[i | 0] | w[i + 1 | 0] << 8);
           if ((i | 0) != (Ab(w[h | 0] | w[h + 1 | 0] << 8) + 1 | 0)) {
            break o;
           }
           if ((i | 0) == 2) {
            wp(k, 2);
           }
           r: {
            if ((f | 0) != 16) {
             if ((f | 0) != 8) {
              break o;
             }
             s: {
              switch (Ab(w[d | 0] | w[d + 1 | 0] << 8) | 0) {
              case 0:
               c = 1;
               vg(k, 1);
               break o;

              case 2:
               vg(k, 17);
               break r;

              case 3:
               break s;

              default:
               break o;
              }
             }
             vg(k, 16);
             break r;
            }
            if (Ab(w[d | 0] | w[d + 1 | 0] << 8)) {
             break o;
            }
            gd(k, 16);
           }
           c = 1;
          }
          tb(e + 44 | 0);
          i = 0;
          d = 0;
          h = 0;
          if (!c) {
           break j;
          }
          break k;
         }
         v[31601] = 0;
         n = e + 44 | 0;
         c = e + 88 | 0;
         R(740, n | 0, c | 0, 1447576658);
         d = v[31601];
         v[31601] = 0;
         t: {
          u: {
           v: {
            if ((d | 0) != 1) {
             v[31601] = 0;
             q = e + 24 | 0;
             R(740, q | 0, c | 0, 1128808782);
             d = v[31601];
             v[31601] = 0;
             if ((d | 0) == 1) {
              break v;
             }
             v[31601] = 0;
             f = e + 4 | 0;
             R(740, f | 0, c | 0, 1112491097);
             c = v[31601];
             v[31601] = 0;
             if ((c | 0) == 1) {
              break u;
             }
             o = jd(j, f);
             tb(f);
             c = v[o >> 2];
             v[31601] = 0;
             d = Q(172, c | 0) | 0;
             c = v[31601];
             v[31601] = 0;
             if ((c | 0) == 1) {
              break u;
             }
             g = 0;
             c = 0;
             l = 0;
             w: {
              if (!d) {
               break w;
              }
              v[31601] = 0;
              d = Q(172, v[e + 44 >> 2]) | 0;
              c = v[31601];
              v[31601] = 0;
              if ((c | 0) == 1) {
               break u;
              }
              c = 0;
              l = 0;
              if (!d) {
               break w;
              }
              v[31601] = 0;
              f = O(742, n | 0, f | 0) | 0;
              c = v[31601];
              v[31601] = 0;
              if ((c | 0) == 1) {
               break u;
              }
              c = 0;
              l = 0;
              if (!f) {
               break w;
              }
              c = w[e + 108 | 0] | w[e + 109 | 0] << 8 | (w[e + 110 | 0] << 16 | w[e + 111 | 0] << 24);
              v[31601] = 0;
              g = Q(281, q | 0) | 0;
              d = v[31601];
              v[31601] = 0;
              if ((d | 0) == 1) {
               break u;
              }
              h = (c | 0) != 1482052408;
              if (h) {
               gd(k, 16);
              }
              if ((g | 0) == 6) {
               wp(k, 3);
              }
              m = _b(v[e + 4 >> 2]);
              d = v[e + 8 >> 2];
              f = v[e + 12 >> 2];
              c = _b(f);
              x: {
               if (c >>> 0 < 33) {
                break x;
               }
               i = _b(d);
               if (i >>> 0 <= c >>> 0) {
                break x;
               }
               d = (i >>> 0) % (c >>> 0) | 0 ? d : f;
              }
              c = v[o >> 2];
              v[31601] = 0;
              i = v[e + 20 >> 2];
              o = x[e + 16 >> 1];
              n = Q(154, c | 0) | 0;
              f = v[31601];
              v[31601] = 0;
              c = 1;
              if ((f | 0) == 1) {
               break u;
              }
              f = h + ((g | 0) == 6) | 0;
              h = m >>> f | 0;
              m = n >>> f | 0;
              i = _b(i);
              g = Ab(o);
              l = _b(d) >>> f | 0;
             }
             d = l;
             tb(e + 24 | 0);
             tb(e + 44 | 0);
             if (c) {
              break k;
             }
             break j;
            }
            c = M() | 0;
            break b;
           }
           c = M() | 0;
           break t;
          }
          c = M() | 0;
          tb(e + 24 | 0);
         }
         tb(e + 44 | 0);
         break b;
        }
        c = M() | 0;
        break b;
       }
       c = M() | 0;
       tb(e + 44 | 0);
       break b;
      }
      Wu(a, b);
      v[31601] = 0;
      c = (B(b, 104) + a | 0) + 484380 | 0;
      N(279, c | 0, 0);
      f = v[31601];
      v[31601] = 0;
      y: {
       if ((f | 0) != 1) {
        v[c + 4 >> 2] = h;
        v[c >> 2] = m;
        d = d + h | 0;
        v[c + 8 >> 2] = d;
        if (!(d >>> 0 <= h + 4 >>> 0 | d >>> 0 > m >>> 0)) {
         u[c + 34 >> 1] = x[c + 34 >> 1] | 2;
        }
        v[c + 24 >> 2] = g >>> 0 < 2 ? 22050 : g;
        d = i + 128 | 0;
        g = d >>> 8 | 0;
        u[c + 30 >> 1] = (d & 16776960) >>> 0 > 65536 ? 256 : g & 65535 ? g : 256;
        fC(c, v[a + 480180 >> 2]);
        v[31601] = 0;
        d = e + 44 | 0;
        R(740, d | 0, e + 88 | 0, 1312902469);
        g = v[31601];
        v[31601] = 0;
        if ((g | 0) == 1) {
         break y;
        }
        v[31601] = 0;
        g = Q(172, v[e + 44 >> 2]) | 0;
        h = v[31601];
        v[31601] = 0;
        if ((h | 0) == 1) {
         break c;
        }
        z: {
         A: {
          if (g) {
           v[31601] = 0;
           g = Q(154, v[e + 44 >> 2]) | 0;
           h = v[31601];
           v[31601] = 0;
           if ((h | 0) == 1) {
            break c;
           }
           v[31601] = 0;
           R(331, d | 0, ((b << 5) + a | 0) + 946304 | 0, g | 0);
           b = v[31601];
           v[31601] = 0;
           if ((b | 0) != 1) {
            break A;
           }
           break c;
          }
          v[31601] = 0;
          d = O(36, e + 24 | 0, 22256) | 0;
          g = v[31601];
          v[31601] = 0;
          if ((g | 0) == 1) {
           break z;
          }
          zc(((b << 5) + a | 0) + 946304 | 0, d);
          sb(d);
         }
         v[31601] = 0;
         T(215, k | 0, c | 0, j | 0) | 0;
         b = v[31601];
         v[31601] = 0;
         r = 1;
         if ((b | 0) == 1) {
          break c;
         }
         Hj(c, a);
         tb(e + 44 | 0);
         break j;
        }
        break c;
       }
       c = M() | 0;
       break b;
      }
      c = M() | 0;
      break b;
     }
     tb(j);
     je(e + 88 | 0);
    }
    eb = e + 112 | 0;
    return r | 0;
   }
   c = M() | 0;
   tb(e + 44 | 0);
  }
  tb(j);
 }
 je(e + 88 | 0);
 P(c | 0);
 p();
}

function Tu(a, b, c, d, e, f, g) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 f = f | 0;
 g = g | 0;
 var h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, z = 0;
 n = eb - 16 | 0;
 eb = n;
 v[n + 12 >> 2] = c;
 a: {
  if ((c | 0) <= 0) {
   break a;
  }
  i = v[b + 104 >> 2];
  b: {
   c: {
    d: {
     e: {
      f: {
       g: {
        h: {
         i: {
          j: {
           j = v[b + 656 >> 2];
           k: {
            if (!(!j | v[a + 480180 >> 2] != 16777216)) {
             l = v[j + 44 >> 2] != 0;
             break k;
            }
            if (!j) {
             break j;
            }
           }
           if ((c | 0) > 128) {
            break i;
           }
           m = c - 1 | 0;
           h = x[$b(j + 236 | 0, m) >> 1];
           l: {
            if ((h - 1 & 65535) >>> 0 <= 3998) {
             i = (B(h, 104) + a | 0) + 484380 | 0;
             break l;
            }
            if (!Nb(a + 1074312 | 0, 43)) {
             break l;
            }
            if (!Aj(v[b + 656 >> 2])) {
             break a;
            }
           }
           m = w[wb(j + 108 | 0, m) | 0];
           v[n + 12 >> 2] = m;
           if (m >>> 0 <= 120) {
            break h;
           }
           c = m;
           break i;
          }
          m = c;
          h = 0;
          if (c >>> 0 < 121) {
           break g;
          }
         }
         m: {
          if (!(v[a + 480180 >> 2] & 16777248 ? (c | 0) != 255 : 0)) {
           Eo(a, b);
           if (d) {
            break m;
           }
           if (!Nb(a + 1074312 | 0, 100) | !(w[a + 480208 | 0] & 4) | !w[b + 789 | 0]) {
            break m;
           }
           v[b + 88 >> 2] = v[b + 88 >> 2] & -6145;
           break m;
          }
          if (!x[a + 480192 >> 1]) {
           break m;
          }
          v[b + 88 >> 2] = v[b + 88 >> 2] | 4096;
         }
         n: {
          if ((c | 0) != 254) {
           break n;
          }
          c = v[b + 88 >> 2];
          if (!(!(c & 512) | v[a + 480180 >> 2] != 2)) {
           v[b + 88 >> 2] = c | 2048;
           break n;
          }
          v[b + 88 >> 2] = c | 2101248;
          o: {
           if (v[a + 480180 >> 2] & 16777248) {
            if (!x[a + 480192 >> 1]) {
             break o;
            }
            if (Nb(a + 1074312 | 0, 50)) {
             break o;
            }
           }
           v[b + 688 >> 2] = 0;
          }
          if (Nb(a + 1074312 | 0, 50)) {
           v[b + 8 >> 2] = 0;
           v[b + 12 >> 2] = 0;
          }
          v[b + 696 >> 2] = 0;
         }
         if (!Nb(a + 1074312 | 0, 20)) {
          break a;
         }
         t[b + 797 | 0] = 0;
         t[b + 802 | 0] = 0;
         break a;
        }
        h = 0;
        if (!l) {
         break g;
        }
        if (d) {
         h = w[b + 797 | 0];
         if (h) {
          break f;
         }
        }
        v[b + 708 >> 2] = 0;
        h = 1;
       }
       if (d) {
        break e;
       }
       if (!(!(v[a + 480180 >> 2] & 1048588) | !i)) {
        u[b + 770 >> 1] = t[i + 36 | 0];
        u[b + 772 >> 1] = t[i + 37 | 0];
        break d;
       }
       if (i) {
        break d;
       }
       i = 0;
       p = 1;
       break c;
      }
      h = B((v[v[j + 44 >> 2] + 36 >> 2] << 16 >> 16) + 1 | 0, (m << 16 >> 16) - (h << 16 >> 16) | 0) - v[b + 852 >> 2] | 0;
      v[b + 708 >> 2] = h;
      v[b + 852 >> 2] = 0 - h;
      h = 1;
     }
     p = !i;
     l = 1;
     if (Li(v[b + 8 >> 2], v[b + 12 >> 2])) {
      break b;
     }
     p: {
      l = a + 1074312 | 0;
      if (!Nb(l, 54)) {
       break p;
      }
      if (Aj(v[b + 656 >> 2])) {
       if (!Nb(l, 117)) {
        break p;
       }
      }
      v[b + 700 >> 2] = 0;
      break a;
     }
     l = (Nb(l, 39) ^ -1) & d;
     break b;
    }
    if (!Nb(a + 1074312 | 0, 24)) {
     break c;
    }
    v[b + 704 >> 2] = v[i + 24 >> 2];
   }
   l = 0;
  }
  q: {
   if (wn(v[a + 480180 >> 2])) {
    v[n + 12 >> 2] = u[b + 770 >> 1] + m;
    Fe(n + 12 | 0, 12, 131);
    break q;
   }
   AX(n + 12 | 0);
  }
  k = a + 1074312 | 0;
  if (Nb(k, 34)) {
   d = c >>> 0 >= 120 ? 120 : c;
  } else {
   d = v[n + 12 >> 2];
  }
  t[b + 797 | 0] = d;
  t[b + 851 | 0] = w[b + 851 | 0] & 183 | 64;
  if (!(v[a + 480180 >> 2] & 16777250 ? 0 : l)) {
   t[b + 803 | 0] = 0;
  }
  o = yh(a, v[n + 12 >> 2], u[b + 772 >> 1], v[b + 704 >> 2]);
  t[b + 831 | 0] = 0;
  if (Nb(k, 48)) {
   aT(a, b, j, i);
  }
  r: {
   if (!Nb(k, 115) | !j) {
    break r;
   }
   d = w[j + 26 | 0];
   if (!d) {
    break r;
   }
   if (!x[b + 784 >> 1]) {
    u[b + 784 >> 1] = x[b + 692 >> 1] + 1;
   }
   $S(b + 692 | 0, c, d, w[j + 27 | 0]);
  }
  s: {
   if (l | e ^ 1) {
    break s;
   }
   v[b + 776 >> 2] = 0;
   v[b + 780 >> 2] = 0;
   if (!j) {
    break s;
   }
   if (Nb(k, 29)) {
    t[b + 798 | 0] = w[j + 16 | 0];
   }
   if (!(w[j + 60 | 0] & 8)) {
    zj(b + 724 | 0);
   }
   if (!(w[j + 80 | 0] & 8)) {
    zj(b + 732 | 0);
   }
   if (!(w[j + 100 | 0] & 8)) {
    zj(b + 740 | 0);
   }
   if (w[j + 20 | 0]) {
    c = ((B(Qu(Do(a)), w[j + 20 | 0]) << 16 >> 16) / 64 | 0) + 1 << 16 >> 16;
    t: {
     if (Nb(k, 28)) {
      d = v[b + 752 >> 2];
      break t;
     }
     d = (v[b + 688 >> 2] + 1 | 0) / 2 | 0;
    }
    u[b + 776 >> 1] = (B(d, c) | 0) / 199;
   }
   u: {
    if (!w[j + 19 | 0]) {
     break u;
    }
    r = b, s = (B(Qu(Do(a)), w[j + 19 | 0]) << 16 >> 16) / 32 | 0, u[r + 778 >> 1] = s;
    if (Nb(k, 28) | x[b + 784 >> 1]) {
     break u;
    }
    u[b + 784 >> 1] = x[b + 692 >> 1] + 1;
   }
   m = w[j + 23 | 0];
   if (m) {
    d = Qu(Do(a));
    c = w[b + 837 | 0];
    t[b + 796 | 0] = c + 1;
    u[b + 780 >> 1] = (B((B(m, d + 1 | 0) << 16 >> 16) / 128 << 16 >> 16, c) + 1 | 0) / 128;
   }
   m = w[j + 24 | 0];
   if (!m) {
    break s;
   }
   d = Qu(Do(a));
   c = w[b + 838 | 0];
   t[b + 795 | 0] = c + 1;
   u[b + 782 >> 1] = (B(c, (B(m, d + 1 | 0) << 16 >> 16) / 128 << 16 >> 16) + 1 | 0) / 128;
  }
  if (p) {
   break a;
  }
  v: {
   w: {
    if (!o) {
     d = 0;
     break w;
    }
    if (!(l & v[b + 700 >> 2] != 0)) {
     v[b + 700 >> 2] = o;
    }
    x: {
     y: {
      if (!h) {
       if (!l) {
        if (Nb(k, 69)) {
         break y;
        }
        if (Nb(k, 46) | v[a + 480180 >> 2] == 1) {
         break y;
        }
       }
       v[b + 708 >> 2] = o;
       t[b + 851 | 0] = w[b + 851 | 0] & 239;
      }
      if (!l) {
       break y;
      }
      if (v[b + 76 >> 2] | w[a + 480180 | 0] & 2) {
       break x;
      }
     }
     v[b + 104 >> 2] = i;
     c = v[i >> 2];
     v[b + 84 >> 2] = c;
     v[b + 76 >> 2] = c;
     v[b + 80 >> 2] = 0;
     v[b >> 2] = 0;
     v[b + 4 >> 2] = 0;
     z: {
      A: {
       B: {
        if (!(w[a + 480210 | 0] & 32)) {
         if (!Nb(k, 96) | w[b + 789 | 0]) {
          break A;
         }
         q = v[b >> 2];
         c = v[b + 76 >> 2];
         break B;
        }
        if (w[b + 789 | 0]) {
         break A;
        }
       }
       v[n + 8 >> 2] = c - 1;
       c = v[Gb(b + 660 | 0, n + 8 | 0) >> 2];
       v[b >> 2] = q;
       v[b + 4 >> 2] = c;
       break z;
      }
      v[b + 660 >> 2] = 0;
     }
     c = x[i + 34 >> 1];
     h = c & 1023;
     d = h | v[b + 88 >> 2] & -525056;
     v[b + 88 >> 2] = d;
     C: {
      D: {
       if (c & 8) {
        v[b + 80 >> 2] = v[i + 12 >> 2];
        c = v[i + 16 >> 2];
        v[b + 88 >> 2] = (h & 16 ? d | 4 : d & -524311) | 2;
        v[b + 84 >> 2] = c;
        if (y[b + 76 >> 2] > c >>> 0) {
         break D;
        }
        break C;
       }
       if (!(h & 2)) {
        break C;
       }
       v[b + 80 >> 2] = v[i + 4 >> 2];
       c = v[i + 8 >> 2];
       v[b + 84 >> 2] = c;
       if (y[b + 76 >> 2] <= c >>> 0) {
        break C;
       }
      }
      v[b + 76 >> 2] = c;
     }
     E: {
      if (!(r = 0, s = Nb(k, 83), z = v[b + 80 >> 2], z ? r : s)) {
       c = v[b + 76 >> 2];
       break E;
      }
      c = v[i >> 2];
      v[b + 84 >> 2] = c;
      v[b + 76 >> 2] = c;
     }
     if (!(!(w[b + 88 | 0] & 128) | !c)) {
      v[b + 4 >> 2] = c - 1;
     }
     F: {
      if (w[b + 822 | 0] > 3) {
       break F;
      }
      c = Nb(k, 21);
      h = v[a + 480180 >> 2];
      G: {
       H: {
        if (!(c | !(h & 16777248))) {
         d = 16;
         if (w[a + 480208 | 0] & 4) {
          break H;
         }
         break G;
        }
        d = 32;
        if ((h | 0) == 16) {
         break G;
        }
       }
       if (h & 67633152) {
        break F;
       }
       d = 0;
      }
      t[b + 819 | 0] = d;
     }
     if (Nb(k, 21) | w[b + 825 | 0] > 3) {
      break x;
     }
     t[b + 820 | 0] = 0;
    }
    d = v[b >> 2];
    if (y[b + 76 >> 2] <= y[b + 4 >> 2]) {
     c = v[b + 80 >> 2];
     v[b >> 2] = d;
     v[b + 4 >> 2] = c;
    }
    d = 0;
    if (!l) {
     break w;
    }
    d = 1;
    if (!(v[a + 480180 >> 2] & 17301536) | (v[b + 696 >> 2] ? 0 : w[b + 89 | 0] & 16)) {
     break w;
    }
    c = 1;
    if (!(w[a + 480208 | 0] & 8)) {
     break v;
    }
    c = 1;
    if (!w[b + 789 | 0]) {
     break v;
    }
   }
   if (!(v[b + 696 >> 2] | (!(v[a + 480180 >> 2] & 17301536) | !(w[b + 89 | 0] & 16)))) {
    Xm(b);
    if (!Nb(k, 21)) {
     t[b + 818 | 0] = 0;
     v[b + 756 >> 2] = 0;
    }
    v[b + 696 >> 2] = 65536;
    v[b + 88 >> 2] = v[b + 88 >> 2] & -4097;
   }
   I: {
    if (!d) {
     i = w[b + 789 | 0];
     break I;
    }
    i = w[b + 789 | 0];
    if (!(w[a + 480208 | 0] & 8)) {
     break I;
    }
    c = 1;
    if (!(i & 255)) {
     break v;
    }
   }
   if (!(i & 255 ? 0 : v[a + 480180 >> 2] & 1048580)) {
    v[b + 696 >> 2] = 65536;
    v[b + 88 >> 2] = v[b + 88 >> 2] & -4097;
   }
   c = d;
  }
  J: {
   if (!(!c | !Nb(k, 40) | (w[b + 789 | 0] ? w[a + 480208 | 0] & 8 : 0))) {
    d = v[b + 88 >> 2] & -4194305;
    break J;
   }
   d = v[b + 88 >> 2] & -4196353;
  }
  v[b + 88 >> 2] = d;
  K: {
   if (c) {
    break K;
   }
   u[b + 842 >> 1] = 65535;
   t[b + 851 | 0] = w[b + 851 | 0] | 2;
   v[b + 88 >> 2] = d & -6324225 | 2097152;
   L: {
    if (Nb(k, 23)) {
     break L;
    }
    if (Nb(k, 22)) {
     break L;
    }
    if (Nb(k, 52)) {
     break L;
    }
    if (Nb(k, 71)) {
     break L;
    }
    t[b + 839 | 0] = 0;
    t[b + 808 | 0] = 0;
   }
   if (e) {
    t[b + 818 | 0] = 0;
    v[b + 756 >> 2] = 0;
   }
   v[b + 20 >> 2] = 0;
   v[b + 24 >> 2] = 0;
   if (!(w[b + 89 | 0] & 2)) {
    break K;
   }
   if (!Dd(v[a + 1298300 >> 2]) | (g | 0) == 65535) {
    break K;
   }
   if (Nb(k, 111)) {
    xk(v[a + 1298300 >> 2], g);
    break K;
   }
   if (!Nb(k, 110)) {
    break K;
   }
   TB(v[a + 1298300 >> 2], g, 0, 1, 0);
  }
  d = v[b + 88 >> 2];
  M: {
   N: {
    O: {
     if (f) {
      v[b + 88 >> 2] = d & -1025;
      break O;
     }
     if (!(d & 1024)) {
      break O;
     }
     if (w[a + 24618 | 0] & 16) {
      break N;
     }
    }
    a = v[b + 104 >> 2];
    if (!(!a | !(w[a + 35 | 0] & 4) | f)) {
     break N;
    }
    a = v[b + 656 >> 2];
    if (!a | (!(w[a + 15 | 0] & 2) | f)) {
     break M;
    }
   }
   v[b + 700 >> 2] = 0;
  }
  if (c) {
   break a;
  }
  u[b + 136 >> 1] = 0;
  v[b + 132 >> 2] = 4194304;
  v[b + 112 >> 2] = 0;
  v[b + 116 >> 2] = 0;
 }
 eb = n + 16 | 0;
}

function hsa(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, q = 0, r = 0, s = 0, z = 0, A = 0, C = 0, D = 0;
 d = eb - 1344 | 0;
 eb = d;
 xc(b);
 f = eb - 16 | 0;
 eb = f;
 e = d + 768 | 0;
 KZ(f + 8 | 0, e);
 l = v[f + 12 >> 2];
 ic(f, v[b >> 2], v[b + 8 >> 2], v[f + 8 >> 2], v[f + 12 >> 2]);
 h = v[f + 4 >> 2];
 if ((h | 0) == (l | 0)) {
  Ub(b, v[f + 12 >> 2]);
 }
 eb = f + 16 | 0;
 f = (h | 0) == (l | 0);
 if (!f) {
  JZ(e);
 }
 a: {
  b: {
   c: {
    if (!f) {
     break c;
    }
    if (!MZ(e)) {
     break c;
    }
    if (!Lb(v[b >> 2], v[b + 8 >> 2], Ac(LZ(w[d + 802 | 0] | w[d + 803 | 0] << 8, w[d + 804 | 0] | w[d + 805 | 0] << 8), gb))) {
     break c;
    }
    z = 1;
    if ((c | 0) == 64) {
     break c;
    }
    l = a + 480280 | 0;
    h = d + 832 | 0;
    s = sc(d + 764 | 0);
    f = 0;
    while (1) {
     z = (j | 0) == 32;
     if (!z) {
      e = l + (j << 5) | 0;
      Ve(e);
      g = h + (j << 4) | 0;
      u[e + 4 >> 1] = ((w[g + 14 | 0] << 8 & 65280) >>> 0) / 255;
      n = d + 496 | 0;
      Ik(n, 1, g);
      k = d + 108 | 0;
      Bc(k, n);
      em(e + 9 | 0, k);
      sb(k);
      d: {
       e: {
        switch (w[g + 15 | 0]) {
        case 0:
         i = f + 1 | 0;
         break d;

        case 1:
         v[e >> 2] = 1024;
         i = j + 1 | 0;
         break d;

        case 2:
         break e;

        default:
         break c;
        }
       }
       v[e >> 2] = 1024;
       e = d + 108 | 0;
       Pc(e, s, j);
       ap(e);
      }
      f = f + 1 | 0;
      j = j + 1 | 0;
      continue;
     }
     break;
    }
    Cd(a, 33554432);
    u[a + 480188 >> 1] = i & 255;
    f = d + 108 | 0;
    e = tc(f, 6808);
    yb(a + 1298344 | 0, e);
    sb(e);
    e = tc(f, 11140);
    yb(a + 1298356 | 0, e);
    sb(e);
    C = a, D = v[Ec(f, 4) >> 2], v[C + 1298404 >> 2] = D;
    f: {
     if (w[d + 847 | 0]) {
      break f;
     }
     j = 1;
     f = 1;
     while (1) {
      if ((j | 0) == 16) {
       while (1) {
        if ((f | 0) == 16) {
         break f;
        }
        e = l + (f << 5) | 0;
        v[e >> 2] = v[e >> 2] & -1025;
        f = f + 1 | 0;
        continue;
       }
      }
      e = j << 4;
      j = j + 1 | 0;
      if (w[(e + h | 0) + 15 | 0] == 1) {
       continue;
      }
      break;
     }
    }
    f = d + 496 | 0;
    Ue(f, 1, d + 768 | 0);
    e = d + 108 | 0;
    Bc(e, f);
    yb(a + 1298308 | 0, e);
    sb(e);
    v[a + 480208 >> 2] = v[a + 480208 >> 2] & -17 | (w[d + 806 | 0] | w[d + 807 | 0] << 8) << 4 & 16;
    v[a + 480196 >> 2] = w[d + 816 | 0];
    v[a + 480204 >> 2] = B(w[d + 817 | 0], 1e4);
    v[a + 480200 >> 2] = w[d + 818 | 0] << 2;
    v[a + 480228 >> 2] = w[d + 819 | 0];
    e = w[d + 804 | 0] | w[d + 805 | 0] << 8;
    u[a + 480190 >> 1] = 0;
    u[a + 480192 >> 1] = e;
    Hw(b, f);
    Qr(Wb(v[a + 484360 >> 2], w[a + 484376 | 0]), f, w[d + 800 | 0] | w[d + 801 | 0] << 8, 65535, 255);
    q = c & 1;
    if (q) {
     Sf(a + 484344 | 0, w[d + 802 | 0] | w[d + 803 | 0] << 8);
    }
    n = a + 484344 | 0;
    l = 0;
    g: {
     while (1) {
      if ((w[d + 802 | 0] | w[d + 803 | 0] << 8) >>> 0 <= l >>> 0) {
       k = c & 2;
       s = a + 946304 | 0;
       n = a + 484380 | 0;
       f = 1;
       l = 0;
       h: while (1) {
        if (x[a + 480192 >> 1] <= (l & 65535) >>> 0) {
         break c;
        }
        l = l + 1 | 0;
        c = CE(a, l & 65535, 0);
        h = !c;
        e = eb - 16 | 0;
        eb = e;
        j = d + 108 | 0;
        ac(e + 8 | 0, j, 384);
        i = v[e + 12 >> 2];
        ic(e, v[b >> 2], v[b + 8 >> 2], v[e + 8 >> 2], v[e + 12 >> 2]);
        g = v[e + 4 >> 2];
        if ((g | 0) == (i | 0)) {
         Ub(b, v[e + 12 >> 2]);
        }
        eb = e + 16 | 0;
        e = (g | 0) == (i | 0);
        if (!e) {
         Qb(j, 0, 384);
        }
        if (!e | h) {
         continue;
        }
        h = f & 65535;
        i = eb - 32 | 0;
        eb = i;
        g = i + 8 | 0;
        Ue(g, 1, j);
        e = i + 20 | 0;
        Bc(e, g);
        zc(c + 492 | 0, e);
        sb(e);
        i: {
         if (!(w[j + 378 | 0] | w[j + 379 | 0] << 8)) {
          break i;
         }
         g = c + 236 | 0;
         m = j + 32 | 0;
         e = 0;
         while (1) {
          v[i + 20 >> 2] = 120;
          v[i + 8 >> 2] = 116;
          if (y[Gb(i + 20 | 0, i + 8 | 0) >> 2] <= e >>> 0) {
           break i;
          }
          C = $b(g, e + 12 | 0), D = h + w[e + m | 0] | 0, u[C >> 1] = D;
          e = e + 1 | 0;
          continue;
         }
        }
        e = w[j + 376 | 0] | w[j + 377 | 0] << 8;
        t[c + 33 | 0] = 1;
        v[c >> 2] = e;
        GD(j, c + 48 | 0, 0);
        GD(j, c + 68 | 0, 1);
        GD(j, c + 88 | 0, 2);
        e = w[c + 100 | 0];
        if (e & 1) {
         t[c + 100 | 0] = e | 16;
        }
        if (!(v[c >> 2] | t[c + 60 | 0] & 1)) {
         v[c >> 2] = 32767;
        }
        eb = i + 32 | 0;
        j = 0;
        while (1) {
         c = w[d + 486 | 0] | w[d + 487 | 0] << 8;
         if (c >>> 0 <= j >>> 0) {
          f = c + f | 0;
          continue h;
         }
         e$(b, d + 44 | 0);
         j: {
          c = f + j | 0;
          g = c & 65535;
          k: {
           if (g >>> 0 >= 4e3) {
            Ub(b, w[d + 60 | 0] | w[d + 61 | 0] << 8 | (w[d + 62 | 0] << 16 | w[d + 63 | 0] << 24));
            break k;
           }
           u[a + 480190 >> 1] = c;
           i = eb - 32 | 0;
           eb = i;
           h = n + B(g, 104) | 0;
           c = h;
           md(c, 0);
           m = i + 8 | 0;
           ck(m, 1, d + 44 | 0);
           e = i + 20 | 0;
           Bc(e, m);
           Ae(c + 43 | 0, e);
           sb(e);
           m = w[d + 60 | 0] | w[d + 61 | 0] << 8 | (w[d + 62 | 0] << 16 | w[d + 63 | 0] << 24);
           v[c >> 2] = m;
           o = w[d + 64 | 0] | w[d + 65 | 0] << 8 | (w[d + 66 | 0] << 16 | w[d + 67 | 0] << 24);
           v[c + 4 >> 2] = o;
           q = w[d + 68 | 0] | w[d + 69 | 0] << 8 | (w[d + 70 | 0] << 16 | w[d + 71 | 0] << 24);
           v[c + 8 >> 2] = q;
           v[c + 24 >> 2] = w[d + 72 | 0] | w[d + 73 | 0] << 8 | (w[d + 74 | 0] << 16 | w[d + 75 | 0] << 24);
           u[c + 30 >> 1] = w[d + 76 | 0] << 2;
           u[c + 28 >> 1] = w[d + 77 | 0];
           e = w[d + 92 | 0];
           if (e & 1) {
            u[c + 34 >> 1] = x[c + 34 >> 1] | 2;
            e = w[d + 92 | 0];
           }
           if (e & 2) {
            u[c + 34 >> 1] = x[c + 34 >> 1] | 4;
            e = w[d + 92 | 0];
           }
           if (e & 4) {
            v[c + 8 >> 2] = q >>> 1;
            v[c + 4 >> 2] = o >>> 1;
            v[c >> 2] = m >>> 1;
            u[c + 34 >> 1] = x[c + 34 >> 1] | 1;
            e = w[d + 92 | 0];
           }
           if (e & 8) {
            u[c + 34 >> 1] = x[c + 34 >> 1] | 32;
           }
           eb = i + 32 | 0;
           c = eb - 16 | 0;
           eb = c;
           Tw(c + 8 | 0, h + 43 | 0);
           e = d + 24 | 0;
           zp(e, v[c + 8 >> 2], v[c + 12 >> 2]);
           eb = c + 16 | 0;
           zc(s + (g << 5) | 0, e);
           sb(e);
           i = w[d + 60 | 0] | w[d + 61 | 0] << 8 | (w[d + 62 | 0] << 16 | w[d + 63 | 0] << 24);
           if (!i) {
            break k;
           }
           c = d + 4 | 0;
           ge(c, b, i);
           i = gc(e, c);
           tb(c);
           if (k) {
            c = Yc(c, u[h + 34 >> 1] & 1 ? 16 : 8, 1, 0, 0);
            v[31601] = 0;
            T(215, c | 0, h | 0, i | 0) | 0;
            c = v[31601];
            v[31601] = 0;
            if ((c | 0) == 1) {
             break j;
            }
           }
           tb(i);
          }
          j = j + 1 | 0;
          continue;
         }
         break;
        }
        break;
       }
       a = M() | 0;
       break a;
      }
      e = fh(b);
      m = fh(b);
      f = d + 44 | 0;
      ge(f, b, e - 4 | 0);
      i = gc(d + 108 | 0, f);
      tb(f);
      l: {
       m: {
        if (!q) {
         break m;
        }
        v[31601] = 0;
        f = T(196, n | 0, l & 65535, m | 0) | 0;
        e = v[31601];
        v[31601] = 0;
        if ((e | 0) == 1) {
         break l;
        }
        if (!f) {
         break m;
        }
        e = 0;
        j = Mg(d + 24 | 0);
        n: while (1) {
         A = e >>> 0 >= m >>> 0;
         while (1) {
          if (A) {
           break m;
          }
          v[31601] = 0;
          h = Q(197, i | 0) | 0;
          f = v[31601];
          v[31601] = 0;
          o: {
           if ((f | 0) != 1) {
            if (h) {
             break o;
            }
            e = e + 1 | 0;
            continue n;
           }
           break b;
          }
          f = j;
          o = h & 31;
          if (o >>> 0 < x[a + 480188 >> 1]) {
           f = Vb(v[n >> 2], l);
           f = ld(v[f >> 2], v[v[f + 48 >> 2] + 12 >> 2], e, o);
          }
          if (h & 32) {
           v[31601] = 0;
           k = d + 44 | 0;
           N(198, k | 0, i | 0);
           g = v[31601];
           v[31601] = 0;
           if ((g | 0) == 1) {
            break b;
           }
           g = w[d + 44 | 0];
           t[f | 0] = g;
           C = f, D = w[Ic(k) | 0], t[C + 1 | 0] = D;
           k = 255;
           p: {
            if ((g | 0) == 160) {
             break p;
            }
            k = 0;
            if ((g | 0) == 255) {
             break p;
            }
            g = (B(g >>> 4 | 0, 12) + (g & 15) | 0) + 13 | 0;
            k = IZ(g) ? g : 0;
           }
           t[f | 0] = k;
          }
          h = h & 192;
          q: {
           if (!h) {
            break q;
           }
           if ((h | 0) == 192) {
            v[31601] = 0;
            h = d + 44 | 0;
            N(357, h | 0, i | 0);
            g = v[31601];
            v[31601] = 0;
            if ((g | 0) != 1) {
             g = Ic(h);
             k = _e(h);
             h = Xi(h);
             r = d + 4 | 0;
             HD(r, w[d + 44 | 0], w[g | 0]);
             g = Ic(r);
             r = d + 494 | 0;
             HD(r, w[k | 0], w[h | 0]);
             cm(d + 492 | 0, f, w[d + 4 | 0], w[g | 0], w[d + 494 | 0], w[Ic(r) | 0]);
             break q;
            }
            break b;
           }
           v[31601] = 0;
           h = d + 44 | 0;
           N(198, h | 0, i | 0);
           g = v[31601];
           v[31601] = 0;
           if ((g | 0) == 1) {
            break g;
           }
           g = d + 4 | 0;
           HD(g, w[d + 44 | 0], w[Ic(h) | 0]);
           g = w[Ic(g) | 0];
           k = w[d + 4 | 0];
           h = (k | 0) == 13;
           t[(h ? 2 : 3) + f | 0] = h ? 1 : k;
           t[(h ? 4 : 5) + f | 0] = g;
          }
          Pc(d + 44 | 0, s, o);
          if (!Fb(v[v[d + 44 >> 2] >> 2], v[d + 48 >> 2])) {
           continue;
          }
          if (!c0(w[f + 3 | 0], w[f + 5 | 0])) {
           continue;
          }
          t[f + 3 | 0] = 0;
          continue;
         }
        }
       }
       tb(i);
       l = l + 1 | 0;
       continue;
      }
      break;
     }
     break b;
    }
    break b;
   }
   eb = d + 1344 | 0;
   return z | 0;
  }
  a = M() | 0;
 }
 tb(i);
 P(a | 0);
 p();
}

function tsa(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, q = 0, r = 0, s = 0, y = 0, z = 0, A = 0;
 g = eb - 32 | 0;
 eb = g;
 a: {
  b: {
   if (!c) {
    break b;
   }
   f = Vh(a, b);
   a = vb(v[d >> 2]);
   v[g + 28 >> 2] = a;
   d = vb(v[d + 4 >> 2]);
   while (1) {
    if (!Hb(a, d)) {
     break b;
    }
    xc(a);
    c: {
     if ((Mk(a) | 0) == (c | 0)) {
      Ub(a, 20);
      d = Mk(a);
      l = ng(g + 16 | 0);
      c = Wl(g + 12 | 0, 0, b ? 32 : 64);
      v[31601] = 0;
      N(402, f | 0, c | 0);
      c = v[31601];
      v[31601] = 0;
      if ((c | 0) == 1) {
       break c;
      }
      o = (b | 0) == 2 ? 4096 : (b | 0) == 1 ? 2048 : 16384;
      c = 24;
      d = d + 24 | 0;
      q = 1;
      m = 1;
      d: {
       while (1) {
        i = o;
        while (1) {
         e = v[a + 8 >> 2];
         h = v[a >> 2];
         v[31601] = 0;
         e = T(150, h | 0, e | 0, 1) | 0;
         h = v[31601];
         v[31601] = 0;
         e: {
          f: {
           g: {
            h: {
             i: {
              j: {
               k: {
                l: {
                 m: {
                  n: {
                   o: {
                    p: {
                     if ((h | 0) != 1) {
                      if (!e) {
                       break d;
                      }
                      e = v[f + 4 >> 2];
                      h = v[f >> 2];
                      j = v[a + 8 >> 2];
                      v[31601] = 0;
                      v[g + 12 >> 2] = j;
                      j = O(403, l | 0, g + 12 | 0) | 0;
                      r = v[31601];
                      v[31601] = 0;
                      if ((r | 0) == 1) {
                       break a;
                      }
                      z = j, A = Rd(h, e), v[z >> 2] = A;
                      v[31601] = 0;
                      e = Q(197, a | 0) | 0;
                      h = v[31601];
                      v[31601] = 0;
                      if ((h | 0) == 1) {
                       break a;
                      }
                      q: {
                       switch (e - 128 | 0) {
                       case 5:
                       case 6:
                       case 9:
                       case 10:
                        break h;

                       case 2:
                        break i;

                       case 1:
                        break j;

                       case 0:
                        break k;

                       case 3:
                       case 4:
                       case 7:
                       case 8:
                        break e;

                       default:
                        break q;
                       }
                      }
                      r: {
                       switch (e | 0) {
                       case 0:
                        break g;

                       case 5:
                        break l;

                       case 4:
                        break m;

                       case 3:
                        break n;

                       case 2:
                        break o;

                       case 1:
                        break p;

                       default:
                        break r;
                       }
                      }
                      s: {
                       switch (e - 160 | 0) {
                       case 5:
                       case 6:
                        break h;

                       case 2:
                        break i;

                       case 1:
                        break j;

                       case 0:
                        break k;

                       case 3:
                       case 4:
                        break e;

                       default:
                        break s;
                       }
                      }
                      switch (e - 192 | 0) {
                      case 2:
                       break i;

                      case 1:
                       break j;

                      case 0:
                       break k;

                      default:
                       break e;
                      }
                     }
                     break a;
                    }
                    if (w[f + 12 | 0] & 4) {
                     break e;
                    }
                    v[31601] = 0;
                    e = Q(273, a | 0) | 0;
                    h = v[31601];
                    v[31601] = 0;
                    t: {
                     if ((h | 0) == 1) {
                      break t;
                     }
                     v[31601] = 0;
                     v[g + 12 >> 2] = e;
                     e = O(403, l | 0, g + 12 | 0) | 0;
                     h = v[31601];
                     v[31601] = 0;
                     if ((h | 0) == 1) {
                      break t;
                     }
                     t[f + 15 | 0] = v[e >> 2];
                     z = f, A = Rd(v[f >> 2], v[f + 4 >> 2]) - 1 | 0, t[z + 16 | 0] = A;
                     t[f + 12 | 0] = w[f + 12 | 0] | 4;
                     break e;
                    }
                    break a;
                   }
                   v[31601] = 0;
                   e = Q(273, a | 0) | 0;
                   h = v[31601];
                   v[31601] = 0;
                   if ((h | 0) == 1) {
                    break a;
                   }
                   u[g + 12 >> 1] = e;
                   u[g + 10 >> 1] = 1;
                   h = g + 12 | 0;
                   j = g + 10 | 0;
                   e = x[qe(h, j) >> 1];
                   i = B(e, B(s << 16 >> 16, m)) + i | 0;
                   u: {
                    if (e >>> 0 < 2) {
                     break u;
                    }
                    z = g, A = $l((e + x[wf(v[f + 4 >> 2]) >> 1] | 0) - 1 | 0), u[z + 12 >> 1] = A;
                    e = Xv(b, i);
                    v[31601] = 0;
                    t[g + 10 | 0] = e;
                    R(404, f | 0, h | 0, j | 0);
                    e = v[31601];
                    v[31601] = 0;
                    if ((e | 0) != 1) {
                     break u;
                    }
                    break a;
                   }
                   z = g, A = $l(x[wf(v[f + 4 >> 2]) >> 1] + 1 | 0), u[z + 12 >> 1] = A;
                   e = Xv(b, i);
                   v[31601] = 0;
                   t[g + 10 | 0] = e;
                   R(404, f | 0, g + 12 | 0, g + 10 | 0);
                   e = v[31601];
                   v[31601] = 0;
                   if ((e | 0) != 1) {
                    break e;
                   }
                   break a;
                  }
                  v[31601] = 0;
                  k = Q(197, a | 0) | 0;
                  e = v[31601];
                  v[31601] = 0;
                  if ((e | 0) == 1) {
                   break a;
                  }
                  y = v[a + 8 >> 2];
                  break e;
                 }
                 v[31601] = 0;
                 e = Q(273, a | 0) | 0;
                 h = v[31601];
                 v[31601] = 0;
                 if ((h | 0) == 1) {
                  break a;
                 }
                 e = c + e | 0;
                 v[g + 12 >> 2] = e;
                 if (!(!(k & 255) | e >>> 0 < y >>> 0)) {
                  k = k - 1 | 0;
                  if (!(k & 255)) {
                   break f;
                  }
                  v[31601] = 0;
                  O(149, a | 0, e | 0) | 0;
                  e = v[31601];
                  v[31601] = 0;
                  if ((e | 0) != 1) {
                   break e;
                  }
                  break a;
                 }
                 if (!(k & 255)) {
                  break f;
                 }
                 v[31601] = 0;
                 e = O(405, l | 0, g + 12 | 0) | 0;
                 h = v[31601];
                 v[31601] = 0;
                 if ((h | 0) == 1) {
                  break a;
                 }
                 t[f + 13 | 0] = v[e >> 2];
                 z = f, A = Rd(v[f >> 2], v[f + 4 >> 2]) - 1 | 0, t[z + 14 | 0] = A;
                 t[f + 12 | 0] = w[f + 12 | 0] | 2;
                 break e;
                }
                q = 0;
                n = 1;
                break e;
               }
               v[31601] = 0;
               i = Q(273, a | 0) | 0;
               e = v[31601];
               v[31601] = 0;
               if ((e | 0) == 1) {
                break a;
               }
               e = Xv(b, i);
               z = wf(v[f + 4 >> 2]), A = e, t[z + 2 | 0] = A;
               break e;
              }
              v[31601] = 0;
              s = Q(406, a | 0) | 0;
              e = v[31601];
              v[31601] = 0;
              if ((e | 0) != 1) {
               break e;
              }
              break a;
             }
             v[31601] = 0;
             e = Q(197, a | 0) | 0;
             m = v[31601];
             v[31601] = 0;
             if ((m | 0) != 1) {
              t[g + 12 | 0] = e;
              t[g + 10 | 0] = 1;
              m = w[cf(g + 12 | 0, g + 10 | 0) | 0];
              break e;
             }
             break a;
            }
            v[31601] = 0;
            O(183, a | 0, 1) | 0;
            e = v[31601];
            v[31601] = 0;
            if ((e | 0) == 1) {
             break a;
            }
            break e;
           }
           n = 1;
           if (c >>> 0 < d >>> 0) {
            break e;
           }
           break d;
          }
          k = 0;
         }
         if (!n | c >>> 0 >= d >>> 0) {
          continue;
         }
         break;
        }
        v[31601] = 0;
        c = O(149, a | 0, d | 0) | 0;
        i = v[31601];
        v[31601] = 0;
        if ((i | 0) == 1) {
         break a;
        }
        if (!c) {
         break d;
        }
        c = v[a + 8 >> 2];
        i = v[a >> 2];
        v[31601] = 0;
        c = T(150, i | 0, c | 0, 2) | 0;
        i = v[31601];
        v[31601] = 0;
        if ((i | 0) == 1) {
         break a;
        }
        if (!c) {
         break d;
        }
        c = v[f + 4 >> 2];
        i = w[f + 12 | 0];
        if (!(i & 4) & q) {
         e = v[f >> 2];
         t[f + 12 | 0] = i | 4;
         i = Rd(e, c) - 1 | 0;
         t[f + 15 | 0] = i;
         t[f + 16 | 0] = i;
        }
        z = g, A = $l(x[wf(c) >> 1] + 1 | 0), u[z + 12 >> 1] = A;
        c = Xv(b, o);
        v[31601] = 0;
        t[g + 10 | 0] = c;
        R(404, f | 0, g + 12 | 0, g + 10 | 0);
        c = v[31601];
        v[31601] = 0;
        if ((c | 0) != 1) {
         n = 1;
         t[f + 17 | 0] = w[f + 16 | 0] + 1;
         c = d;
         continue;
        }
        break;
       }
       break a;
      }
      t[f + 12 | 0] = w[f + 12 | 0] | 1;
      SZ(l);
      break b;
     }
     a = v[Pf(g + 28 | 0) >> 2];
     continue;
    }
    break;
   }
   break a;
  }
  eb = g + 32 | 0;
  return;
 }
 a = M() | 0;
 SZ(l);
 P(a | 0);
 p();
}

function Spa(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, x = 0, y = 0, z = 0;
 d = eb - 1824 | 0;
 eb = d;
 xc(b);
 e = eb - 16 | 0;
 eb = e;
 f = d + 1224 | 0;
 QX(e + 8 | 0, f);
 j = v[e + 12 >> 2];
 ic(e, v[b >> 2], v[b + 8 >> 2], v[e + 8 >> 2], v[e + 12 >> 2]);
 k = v[e + 4 >> 2];
 if ((k | 0) == (j | 0)) {
  Ub(b, v[e + 12 >> 2]);
 }
 eb = e + 16 | 0;
 e = (j | 0) == (k | 0);
 if (!e) {
  PX(f);
 }
 a: {
  if (!e) {
   break a;
  }
  if (!RX(f)) {
   break a;
  }
  if (!WC(b, 16, 0)) {
   break a;
  }
  e = d + 1240 | 0;
  v[d + 1216 >> 2] = w[e | 0] | w[e + 1 | 0] << 8 | (w[e + 2 | 0] << 16 | w[e + 3 | 0] << 24);
  e = w[d + 1228 | 0] | w[d + 1229 | 0] << 8 | (w[d + 1230 | 0] << 16 | w[d + 1231 | 0] << 24);
  v[d + 1200 >> 2] = w[d + 1224 | 0] | w[d + 1225 | 0] << 8 | (w[d + 1226 | 0] << 16 | w[d + 1227 | 0] << 24);
  v[d + 1204 >> 2] = e;
  e = d + 1232 | 0;
  f = w[e | 0] | w[e + 1 | 0] << 8 | (w[e + 2 | 0] << 16 | w[e + 3 | 0] << 24);
  e = w[e + 4 | 0] | w[e + 5 | 0] << 8 | (w[e + 6 | 0] << 16 | w[e + 7 | 0] << 24);
  v[d + 1208 >> 2] = f;
  v[d + 1212 >> 2] = e;
  Cd(a, 1);
  Kb(Kb(ag(a + 1074312 | 0, 83), 84, 1), 85, 1);
  u[a + 480188 >> 1] = 4;
  v[d + 1196 >> 2] = 0;
  u[a + 480190 >> 1] = 15;
  cd(b, 20);
  k = a + 946304 | 0;
  s = a + 484380 | 0;
  m = a + 480188 | 0;
  g = 1;
  j = 1;
  b: {
   while (1) {
    c: {
     if ((g | 0) == 16) {
      e = d + 1064 | 0;
      if (!SC(b, e)) {
       NC(e);
      }
      ow(Wb(v[a + 484360 >> 2], w[a + 484376 | 0]), d + 1066 | 0, 128);
      m = XX(b, Wb(v[a + 484360 >> 2], w[a + 484376 | 0]), w[d + 1064 | 0], i, m, 0, 1);
      if (!(w[d + 1065 | 0] | m >>> 0 > 1)) {
       g = 0;
       if (!w[d + 1064 | 0]) {
        break a;
       }
      }
      e = (m << 10) + i | 0;
      v[d + 1060 >> 2] = e;
      v[d + 24 >> 2] = 65536;
      g = 0;
      if (!Lb(v[b >> 2], v[b + 8 >> 2], e - v[Gb(d + 1060 | 0, d + 24 | 0) >> 2] | 0)) {
       break a;
      }
      g = 1;
      if ((c | 0) == 64) {
       break a;
      }
      g = w[d + 1065 | 0];
      if (!g) {
       t[d + 1065 | 0] = 120;
       g = 120;
      }
      if (id(d + 1200 | 0, 14922, 6)) {
       break c;
      }
      t[d + 1065 | 0] = 120;
      v[a + 480204 >> 2] = 125e4;
      break b;
     }
     e = d + 24 | 0;
     PC(b, e);
     h = e;
     e = B(g, 104) + s | 0;
     f = k + (g << 5) | 0;
     ZC(h, e, f, 1);
     l = v[e >> 2];
     d: {
      if (!w[wb(f, 0) | 0]) {
       break d;
      }
      e: {
       if (id(f, 16772, 3)) {
        if (id(f, 16776, 3)) {
         break e;
        }
       }
       if (w[wb(f, 5) | 0] == 58) {
        break d;
       }
      }
      j = 0;
     }
     f = Ab(w[d + 52 | 0] | w[d + 53 | 0] << 8);
     if (f >>> 0 >= 2) {
      h = Ab(w[d + 50 | 0] | w[d + 51 | 0] << 8);
      v[e + 4 >> 2] = h;
      v[e + 8 >> 2] = h + (f << 1);
      Sk(e);
     }
     f: {
      if (Ab(w[d + 46 | 0] | w[d + 47 | 0] << 8) >>> 0 <= 4999) {
       if (Ab(w[d + 50 | 0] | w[d + 51 | 0] << 8) >>> 0 < 1e4) {
        break f;
       }
      }
      v[d + 1064 >> 2] = 5;
      y = d, z = v[Ye(d + 1196 | 0, d + 1064 | 0) >> 2], v[y + 1196 >> 2] = z;
     }
     i = i + l | 0;
     g = g + 1 | 0;
     continue;
    }
    break;
   }
   v[a + 480204 >> 2] = 125e4;
   if ((g | 0) == 120) {
    break b;
   }
   y = a, z = Te(1773447.5 / (+(240 - g | 0) * 122) * 1e4), v[y + 480204 >> 2] = z;
   if (v[d + 1196 >> 2] >= 2) {
    v[d + 24 >> 2] = j & 1 ? 4 : 5;
    y = d, z = v[Ye(d + 1196 | 0, d + 24 | 0) >> 2], v[y + 1196 >> 2] = z;
    break b;
   }
   v[d + 24 >> 2] = j & 1 ? 1 : 2;
   y = d, z = v[Ye(d + 1196 | 0, d + 24 | 0) >> 2], v[y + 1196 >> 2] = z;
  }
  v[a + 480228 >> 2] = 64;
  v[a + 480260 >> 2] = 452;
  v[a + 480264 >> 2] = 3424;
  v[a + 480208 >> 2] = v[a + 480208 >> 2] | 2097152;
  f = d + 1048 | 0;
  oi(f, 3, d + 1200 | 0);
  e = d + 24 | 0;
  Bc(e, f);
  yb(a + 1298308 | 0, e);
  sb(e);
  Th(a, 0);
  f = j & 1;
  r = v[b + 8 >> 2];
  while (1) {
   g: {
    if (m >>> 0 > (n & 65535) >>> 0) {
     e = Wb(v[a + 484360 >> 2], w[a + 484376 | 0]);
     e = Hb(OC(vb(v[e >> 2]), vb(v[e + 4 >> 2]), n), vb(v[e + 4 >> 2]));
     g = d + 24 | 0;
     OX(b, g);
     h: {
      if (e) {
       p = UC(g, 0) + p | 0;
       if (p >>> 0 > 512) {
        break h;
       }
      }
      j = 0;
      e = v[d + 1196 >> 2];
      i = 0;
      k = 0;
      i: while (1) {
       if ((k | 0) == 64) {
        break g;
       }
       g = 0;
       x = Xd(d + 24 | 0, k);
       while (1) if ((g | 0) == 4) {
        k = k + 1 | 0;
        continue i;
       } else {
        h = xb(x, g);
        o = w[wb(h, 2) | 0] & 15;
        l = w[wb(h, 3) | 0];
        j: {
         if (!(!(i & 255) | (w[h | 0] | w[h + 1 | 0] << 8 | (w[h + 2 | 0] << 16 | w[h + 3 | 0] << 24)))) {
          i = i + 1 | 0;
          if ((i & 255) >>> 0 < 33) {
           break j;
          }
          e = 6;
          v[d + 1196 >> 2] = 6;
          break j;
         }
         i = 0;
        }
        k: {
         l: {
          m: {
           n: {
            switch (o - 1 | 0) {
            case 0:
            case 1:
             if ((e | 0) == 1 & l >>> 0 >= 32) {
              break l;
             }
             h = (o | 0) != 1;
             if (!(h | !l | l >>> 0 > 2)) {
              v[d + 1048 >> 2] = 2;
              e = v[Ye(d + 1196 | 0, d + 1048 | 0) >> 2];
              break m;
             }
             if (h | (l | 0) != 55 & (l | 0) != 71) {
              break k;
             }
             if ((e | 0) <= 2) {
              break l;
             }
             break k;

            case 10:
             e = 6;
             break m;

            case 11:
            case 12:
            case 13:
             v[d + 1048 >> 2] = 2;
             e = v[Ye(d + 1196 | 0, d + 1048 | 0) >> 2];
             v[d + 1196 >> 2] = e;
             if ((o | 0) != 13) {
              break k;
             }
             j = ((k | l) != 0) + j | 0;
             i = 1;
             break k;

            case 14:
             break n;

            default:
             break k;
            }
           }
           v[d + 1048 >> 2] = 3;
           e = v[Ye(d + 1196 | 0, d + 1048 | 0) >> 2];
          }
          v[d + 1196 >> 2] = e;
          break k;
         }
         v[d + 1196 >> 2] = f;
         e = f;
        }
        g = g + 1 | 0;
        continue;
       }
      }
     }
     g = 0;
     break a;
    }
    if (!(v[d + 1196 >> 2] != 6 | m + 32 >>> 0 >= q >>> 0)) {
     v[d + 1196 >> 2] = 5;
    }
    cd(b, r);
    o = c & 1;
    if (o) {
     Sf(a + 484344 | 0, m);
    }
    n = a + 484344 | 0;
    j = 0;
    while (1) if ((j | 0) == (m | 0)) {
     g = 22256;
     e = v[d + 1196 >> 2];
     if (e >>> 0 < 7) {
      g = v[(e << 2) + 25260 >> 2];
     }
     e = d + 24 | 0;
     f = tc(e, 8304);
     yb(a + 1298344 | 0, f);
     sb(f);
     f = tc(e, 10785);
     yb(a + 1298356 | 0, f);
     sb(f);
     Yh(a + 1298368 | 0, g);
     y = a, z = v[Ec(e, 28) >> 2], v[y + 1298404 >> 2] = z;
     g = 1;
     if (!(c & 2)) {
      break a;
     }
     while (1) if ((g | 0) == 16) {
      g = 1;
      break a;
     } else {
      a = B(g, 104) + s | 0;
      Ub(b, v[a + 4 >> 2]);
      c = v[a + 4 >> 2];
      v[a + 4 >> 2] = 0;
      v[a >> 2] = v[a >> 2] - c;
      v[a + 8 >> 2] = v[a + 8 >> 2] - c;
      c = d + 24 | 0;
      Yc(c, 8, 1, 1, 0);
      cg(c, a, b);
      g = g + 1 | 0;
      continue;
     }
    } else {
     OX(b, d + 24 | 0);
     o: {
      if (!o) {
       break o;
      }
      if (!Og(n, j & 65535, 64)) {
       break o;
      }
      k = 0;
      v[d + 20 >> 2] = 0;
      p: while (1) {
       if ((k | 0) == 64) {
        break o;
       }
       e = Vb(v[n >> 2], j);
       af(d + 1048 | 0, v[e >> 2], v[v[e + 48 >> 2] + 12 >> 2], k);
       g = 0;
       q = Xd(d + 24 | 0, k);
       while (1) if ((g | 0) == 4) {
        k = k + 1 | 0;
        continue p;
       } else {
        e = Xc(v[d + 1048 >> 2], g);
        f = xb(q, g);
        f = w[f | 0] | w[f + 1 | 0] << 8 | (w[f + 2 | 0] << 16 | w[f + 3 | 0] << 24);
        v[d + 8 >> 2] = f;
        v[d + 12 >> 2] = f;
        f = d + 18 | 0;
        dp(f, d + 8 | 0, e);
        l = (d + 20 | 0) + g | 0;
        i = w[d + 18 | 0];
        f = Ic(f);
        h = w[f | 0];
        q: {
         r: {
          if (!((i | 0) != 14 ? h : 0)) {
           t[l | 0] = 0;
           if (i | h) {
            break r;
           }
           break q;
          }
          h = w[l | 0];
          if (!h) {
           break r;
          }
          p = h;
          r = h >>> 4 | 0;
          h = h >>> 0 < 16;
          t[e + 4 | 0] = h ? p : r;
          t[e + 2 | 0] = h ? 4 : 3;
         }
         s: {
          t: {
           u: {
            v: {
             w: {
              switch (i - 12 | 0) {
              case 1:
               i = v[d + 1196 >> 2];
               if ((i | 0) != 6) {
                t[d + 18 | 0] = 10;
                break u;
               }
               t[f | 0] = 0;
               break v;

              case 0:
               t[f | 0] = w[f | 0] & 127;
               break v;

              case 2:
               i = w[f | 0];
               if (i >>> 0 <= 1) {
                h = 14;
                if (v[d + 1196 >> 2] > 3) {
                 break t;
                }
               }
               t[d + 18 | 0] = 10;
               t[l | 0] = w[f | 0];
               break v;

              case 3:
               break w;

              default:
               break v;
              }
             }
             t[f | 0] = w[f | 0] & 15;
            }
            i = v[d + 1196 >> 2];
           }
           if ((i | 0) < 2) {
            break s;
           }
           i = w[f | 0];
           h = w[d + 18 | 0];
          }
          Bf(e, h, i & 255);
          break q;
         }
         f = w[f | 0];
         t[e + 5 | 0] = f;
         x: {
          y: {
           z: {
            switch (w[d + 18 | 0]) {
            case 0:
             if (f >>> 0 > 2) {
              break y;
             }
             break;

            case 2:
             break x;

            case 1:
             break y;

            default:
             break z;
            }
           }
           t[e + 3 | 0] = 0;
           break q;
          }
          t[e + 3 | 0] = 1;
          break q;
         }
         i = f & 15;
         if (i) {
          t[e + 5 | 0] = i;
          t[e + 3 | 0] = 2;
          break q;
         }
         if (!f) {
          break q;
         }
         t[e + 3 | 0] = 3;
         t[e + 5 | 0] = (f & 240) >>> 4;
        }
        g = g + 1 | 0;
        continue;
       }
      }
     }
     j = j + 1 | 0;
     continue;
    }
   }
   if ((j - 1 & 255) >>> 0 < 2) {
    v[d + 1196 >> 2] = 6;
   }
   n = n + 1 | 0;
   q = (j & 255) + q | 0;
   continue;
  }
 }
 eb = d + 1824 | 0;
 return g | 0;
}

function Q0(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
 g = eb - 80 | 0;
 eb = g;
 xc(b);
 a: {
  if (!Or(b, 11774)) {
   break a;
  }
  i = g + 69 | 0;
  if (!zw(b, i)) {
   break a;
  }
  if (!NE(w[g + 70 | 0])) {
   break a;
  }
  if (!Lb(v[b >> 2], v[b + 8 >> 2], Ac(ME(i), gb))) {
   break a;
  }
  if (!Ub(b, w[g + 78 | 0] | w[g + 79 | 0] << 8)) {
   break a;
  }
  d = 1;
  if ((c | 0) == 64) {
   break a;
  }
  Cd(a, 4096);
  v[a + 480208 >> 2] = 12;
  u[a + 480188 >> 1] = (w[g + 71 | 0] & 31) + 1;
  u[a + 480190 >> 1] = w[g + 72 | 0];
  Th(a, 1);
  d = g + 20 | 0;
  f = tc(d, 8476);
  yb(a + 1298344 | 0, f);
  sb(f);
  f = tc(d, 7105);
  yb(a + 1298356 | 0, f);
  sb(f);
  f = eb - 16 | 0;
  eb = f;
  e = tc(f + 4 | 0, 4247);
  Uc(g, e);
  sb(e);
  eb = f + 16 | 0;
  v[31601] = 0;
  U(229, d | 0, g | 0, w[g + 70 | 0], i | 0);
  i = v[31601];
  v[31601] = 0;
  b: {
   if ((i | 0) != 1) {
    yb(a + 1298368 | 0, d);
    sb(d);
    Db(g);
    m = a, n = v[Ec(d, 4) >> 2], v[m + 1298404 >> 2] = n;
    d = w[g + 72 | 0];
    i = g + 56 | 0;
    v[i >> 2] = 0;
    v[i + 4 >> 2] = 0;
    Ec(i + 8 | 0, 0);
    if (d) {
     Xr(i, d);
     LF(i, d, 0);
    }
    l = a + 484380 | 0;
    d = 1;
    c: {
     while (1) {
      f = d & 65535;
      if (f >>> 0 > x[a + 480190 >> 1]) {
       v[31601] = 0;
       O(230, b | 0, a + 1298308 | 0) | 0;
       d = v[31601];
       v[31601] = 0;
       d: {
        if ((d | 0) == 1) {
         break d;
        }
        f = a + 946304 | 0;
        d = 1;
        while (1) {
         e = d & 65535;
         if (e >>> 0 > x[a + 480190 >> 1]) {
          f = a + 480280 | 0;
          d = 0;
          e: {
           while (1) {
            if (x[a + 480188 >> 1] <= d >>> 0) {
             d = 0;
             v[31601] = 0;
             f = a + 484344 | 0;
             N(223, f | 0, w[g + 73 | 0] | w[g + 74 | 0] << 8);
             e = v[31601];
             v[31601] = 0;
             if ((e | 0) == 1) {
              break d;
             }
             break e;
            }
            e = f + (d << 5) | 0;
            Ve(e);
            v[31601] = 0;
            N(231, b | 0, e + 9 | 0);
            e = v[31601];
            v[31601] = 0;
            if ((e | 0) != 1) {
             d = d + 1 | 0;
             continue;
            }
            break;
           }
           b = M() | 0;
           break c;
          }
          f: {
           g: {
            h: {
             i: {
              while (1) {
               if ((w[g + 73 | 0] | w[g + 74 | 0] << 8) >>> 0 <= d >>> 0) {
                v[31601] = 0;
                e = Q(189, b | 0) | 0;
                d = v[31601];
                v[31601] = 0;
                if ((d | 0) == 1) {
                 break g;
                }
                if (!e) {
                 break h;
                }
                d = v[b + 8 >> 2];
                f = v[b >> 2];
                v[31601] = 0;
                d = T(150, f | 0, d | 0, e | 0) | 0;
                f = v[31601];
                v[31601] = 0;
                if ((f | 0) == 1) {
                 break g;
                }
                if (d) {
                 break i;
                }
                break h;
               }
               v[31601] = 0;
               e = g + 20 | 0;
               h = O(232, b | 0, e | 0) | 0;
               j = v[31601];
               v[31601] = 0;
               j: {
                if ((j | 0) == 1) {
                 break j;
                }
                v[31601] = 0;
                j = T(196, f | 0, d & 65535, 64) | 0;
                k = v[31601];
                v[31601] = 0;
                if ((k | 0) == 1) {
                 break j;
                }
                if ((h & j) == 1) {
                 h = v[f >> 2];
                 v[31601] = 0;
                 N(233, Vb(h, d) | 0, e | 0);
                 e = v[31601];
                 v[31601] = 0;
                 if ((e | 0) == 1) {
                  break j;
                 }
                }
                d = d + 1 | 0;
                continue;
               }
               break;
              }
              b = M() | 0;
              break c;
             }
             f = Mb(g + 20 | 0);
             v[31601] = 0;
             R(234, b | 0, f | 0, e | 0);
             d = v[31601];
             v[31601] = 0;
             k: {
              if ((d | 0) != 1) {
               d = Eb(g);
               v[31601] = 0;
               N(114, d | 0, e | 0);
               e = v[31601];
               v[31601] = 0;
               l: {
                if ((e | 0) == 1) {
                 break l;
                }
                m = g, n = vb(v[f >> 2]), v[m + 40 >> 2] = n;
                h = vb(v[f + 4 >> 2]);
                while (1) {
                 m: {
                  e = v[g + 40 >> 2];
                  if (!Hb(e, h)) {
                   v[31601] = 0;
                   h = g + 40 | 0;
                   R(235, h | 0, 20, d | 0);
                   e = v[31601];
                   v[31601] = 0;
                   if ((e | 0) == 1) {
                    break m;
                   }
                   e = yb(d, h);
                   sb(h);
                   h = Jb(e);
                   j = w[e + 11 | 0];
                   k = v[e + 4 >> 2];
                   v[31601] = 0;
                   $(236, a + 1298332 | 0, h | 0, Zc(k, j) | 0, 76, 0);
                   h = v[31601];
                   v[31601] = 0;
                   if ((h | 0) == 1) {
                    break l;
                   }
                   sb(e);
                   ec(f);
                   break h;
                  }
                  n: {
                   e = t[e | 0];
                   if ((e | 0) < 0) {
                    j = v[ub(g + 52 | 0, Cf(d)) >> 2];
                    v[31601] = 0;
                    U(237, d | 0, j | 0, e & 127, 32);
                    e = v[31601];
                    v[31601] = 0;
                    if ((e | 0) != 1) {
                     break n;
                    }
                    break l;
                   }
                   v[31601] = 0;
                   N(115, d | 0, e | 0);
                   e = v[31601];
                   v[31601] = 0;
                   if ((e | 0) != 1) {
                    break n;
                   }
                   break l;
                  }
                  xe(g + 40 | 0);
                  continue;
                 }
                 break;
                }
               }
               b = M() | 0;
               sb(d);
               break k;
              }
              b = M() | 0;
             }
             ec(f);
             break c;
            }
            d = w[a + 484376 | 0];
            f = v[a + 484360 >> 2];
            v[31601] = 0;
            R(238, Wb(f, d) | 0, b | 0, w[g + 75 | 0] | w[g + 76 | 0] << 8);
            d = v[31601];
            v[31601] = 0;
            if ((d | 0) == 1) {
             break g;
            }
            e = c & 1;
            d = 0;
            while (1) {
             o: {
              p: {
               if ((w[g + 73 | 0] | w[g + 74 | 0] << 8) >>> 0 > d >>> 0) {
                f = v[b + 8 >> 2];
                h = v[b >> 2];
                v[31601] = 0;
                f = T(150, h | 0, f | 0, 4) | 0;
                h = v[31601];
                v[31601] = 0;
                if ((h | 0) == 1) {
                 break o;
                }
                if (f) {
                 break p;
                }
               }
               if (!(c & 2)) {
                break f;
               }
               d = 1;
               while (1) {
                c = d & 65535;
                if (c >>> 0 > x[a + 480190 >> 1]) {
                 break f;
                }
                f = B(c, 104) + l | 0;
                e = x[f + 34 >> 1];
                Ib(g + 20 | 0, v[i >> 2], c - 1 | 0);
                c = Yc(g, e & 1 ? 16 : 8, 1, 0, Fb(v[v[g + 20 >> 2] >> 2], v[g + 24 >> 2]) ? 6 : 0);
                v[31601] = 0;
                T(215, c | 0, f | 0, b | 0) | 0;
                c = v[31601];
                v[31601] = 0;
                if ((c | 0) != 1) {
                 d = d + 1 | 0;
                 continue;
                }
                break;
               }
               b = M() | 0;
               break c;
              }
              v[31601] = 0;
              f = Q(151, b | 0) | 0;
              h = v[31601];
              v[31601] = 0;
              q: {
               r: {
                if ((h | 0) != 1) {
                 v[31601] = 0;
                 R(185, g | 0, b | 0, f | 0);
                 f = v[31601];
                 v[31601] = 0;
                 if ((f | 0) == 1) {
                  break r;
                 }
                 f = gc(g + 20 | 0, g);
                 tb(g);
                 if (!e) {
                  break q;
                 }
                 h = v[a + 484344 >> 2];
                 if (!Ie(h, v[a + 484348 >> 2], d & 65535)) {
                  break q;
                 }
                 v[31601] = 0;
                 R(239, Vb(h, d) | 0, 0, f | 0);
                 h = v[31601];
                 v[31601] = 0;
                 if ((h | 0) != 1) {
                  break q;
                 }
                 b = M() | 0;
                 tb(f);
                 break c;
                }
                b = M() | 0;
                break c;
               }
               b = M() | 0;
               break c;
              }
              tb(f);
              d = d + 1 | 0;
              continue;
             }
             break;
            }
            b = M() | 0;
            break c;
           }
           b = M() | 0;
           break c;
          }
          tf(i);
          d = 1;
          break a;
         }
         v[31601] = 0;
         O(240, b | 0, f + (e << 5) | 0) | 0;
         e = v[31601];
         v[31601] = 0;
         if ((e | 0) != 1) {
          d = d + 1 | 0;
          continue;
         }
         break;
        }
        b = M() | 0;
        break c;
       }
       b = M() | 0;
       break c;
      }
      v[31601] = 0;
      e = g + 20 | 0;
      N(241, b | 0, e | 0);
      h = v[31601];
      v[31601] = 0;
      s: {
       if ((h | 0) == 1) {
        break s;
       }
       v[31601] = 0;
       N(242, e | 0, B(f, 104) + l | 0);
       e = v[31601];
       v[31601] = 0;
       if ((e | 0) == 1) {
        break s;
       }
       e = w[g + 36 | 0];
       Ib(g, v[i >> 2], f - 1 | 0);
       kf(g, (e & 3) != 0);
       d = d + 1 | 0;
       continue;
      }
      break;
     }
     b = M() | 0;
    }
    tf(i);
    break b;
   }
   b = M() | 0;
   Db(g);
  }
  P(b | 0);
  p();
 }
 eb = g + 80 | 0;
 return d | 0;
}

function Opa(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
 d = eb - 192 | 0;
 eb = d;
 xc(b);
 a: {
  b: {
   c: {
    d: {
     e: {
      f: {
       g: {
        h: {
         i: {
          j: {
           k: {
            g = d + 180 | 0;
            l: {
             if (!fp(b, g)) {
              break l;
             }
             if (!GX(g)) {
              break l;
             }
             g = Xh(d + 160 | 0);
             h = Eb(d + 148 | 0);
             gw(d + 84 | 0);
             v[31601] = 0;
             f = O(616, b | 0, d + 76 | 0) | 0;
             e = v[31601];
             v[31601] = 0;
             if ((e | 0) == 1) {
              break h;
             }
             m: {
              if (!f) {
               break m;
              }
              n = d, o = _b(_b(v[d + 80 >> 2]) - 4 | 0), v[n + 80 >> 2] = o;
              j = (c | 0) != 64;
              while (1) {
               f = _b(_b(v[d + 80 >> 2]) - 8 | 0);
               v[d + 80 >> 2] = f;
               n: {
                if (j) {
                 break n;
                }
                if ((_b(v[d + 76 >> 2]) | 0) != 1347699796) {
                 break n;
                }
                k = 1;
                break m;
               }
               v[31601] = 0;
               e = d + 56 | 0;
               R(185, e | 0, b | 0, _b(f) | 0);
               f = v[31601];
               v[31601] = 0;
               if ((f | 0) == 1) {
                break d;
               }
               f = gc(d, e);
               tb(e);
               e = v[f >> 2];
               v[31601] = 0;
               i = Q(172, e | 0) | 0;
               e = v[31601];
               v[31601] = 0;
               if ((e | 0) == 1) {
                break b;
               }
               o: {
                if (!i) {
                 break o;
                }
                p: {
                 e = _b(v[d + 76 >> 2]);
                 if ((e | 0) != 1129139796) {
                  if ((e | 0) != 1229866575) {
                   if ((e | 0) == 1347699796) {
                    break p;
                   }
                   if ((e | 0) != 1447383635) {
                    break o;
                   }
                   v[31601] = 0;
                   O(183, f | 0, 4) | 0;
                   e = v[31601];
                   v[31601] = 0;
                   if ((e | 0) == 1) {
                    break b;
                   }
                   v[31601] = 0;
                   e = Q(617, f | 0) | 0;
                   l = v[31601];
                   v[31601] = 0;
                   if ((l | 0) == 1) {
                    break b;
                   }
                   if (!e) {
                    break o;
                   }
                   e = _b(v[d + 80 >> 2]);
                   if (e >>> 0 < 7) {
                    break o;
                   }
                   l = v[Ec(d + 52 | 0, 28) >> 2];
                   v[31601] = 0;
                   U(618, f | 0, h | 0, l | 0, e - 6 | 0);
                   e = v[31601];
                   v[31601] = 0;
                   if ((e | 0) == 1) {
                    break b;
                   }
                   break o;
                  }
                  v[31601] = 0;
                  m = O(619, f | 0, d + 84 | 0) | 0;
                  e = v[31601];
                  v[31601] = 0;
                  if ((e | 0) != 1) {
                   break o;
                  }
                  break b;
                 }
                 ax(g, f);
                 break o;
                }
                v[31601] = 0;
                k = T(620, a | 0, f | 0, c | 0) | 0;
                e = v[31601];
                v[31601] = 0;
                if ((e | 0) == 1) {
                 break b;
                }
               }
               tb(f);
               if (i) {
                v[31601] = 0;
                f = O(616, b | 0, d + 76 | 0) | 0;
                e = v[31601];
                v[31601] = 0;
                if ((e | 0) == 1) {
                 break i;
                }
                if (f) {
                 continue;
                }
               }
               break;
              }
              if (zd(v[h + 4 >> 2], w[h + 11 | 0])) {
               v[31601] = 0;
               b = O(1, d + 56 | 0, 14875) | 0;
               c = v[31601];
               v[31601] = 0;
               if ((c | 0) == 1) {
                break g;
               }
               yb(h, b);
               sb(b);
              }
              q: {
               if (!(k & m & 1)) {
                break q;
               }
               b = w[d + 126 | 0] | w[d + 127 | 0] << 8;
               v[31601] = 0;
               b = Ab(b) & 256;
               T(266, a + 1074312 | 0, 5, !b | 0) | 0;
               c = v[31601];
               v[31601] = 0;
               if ((c | 0) == 1) {
                break f;
               }
               c = Ab(w[d + 122 | 0] | w[d + 123 | 0] << 8);
               if (c) {
                u[d >> 1] = 64;
                u[d + 40 >> 1] = c;
                n = a, o = x[Nc(d, d + 40 | 0) >> 1], v[n + 480228 >> 2] = o;
               }
               c = !b;
               b = Ab(w[d + 124 | 0] | w[d + 125 | 0] << 8);
               if (!(c | !b)) {
                v[a + 480204 >> 2] = B(b, 1e4);
               }
               if (w[d + 84 | 0]) {
                b = d + 40 | 0;
                Ue(b, 2, d + 84 | 0);
                v[31601] = 0;
                N(218, d | 0, b | 0);
                b = v[31601];
                v[31601] = 0;
                if ((b | 0) == 1) {
                 break e;
                }
                yb(a + 1298308 | 0, d);
                sb(d);
               }
               c = w[d + 130 | 0] | w[d + 131 | 0] << 8;
               if (!er(c, 1, 12)) {
                break q;
               }
               f = w[d + 128 | 0] | w[d + 129 | 0] << 8;
               if (!er(f, 1, 31)) {
                break q;
               }
               e = w[d + 134 | 0] | w[d + 135 | 0] << 8;
               if (!er(e, 0, 23)) {
                break q;
               }
               i = w[d + 136 | 0] | w[d + 137 | 0] << 8;
               if (!er(i, 0, 59)) {
                break q;
               }
               j = w[d + 138 | 0] | w[d + 139 | 0] << 8;
               if (!er(j, 0, 59)) {
                break q;
               }
               v[a + 1298408 >> 2] = 0;
               b = kp(d);
               n = b, o = Ab(w[d + 132 | 0] | w[d + 133 | 0] << 8) + 1900 | 0, v[n >> 2] = o;
               n = b, o = Ab(c), v[n + 4 >> 2] = o;
               n = b, o = Ab(f), v[n + 8 >> 2] = o;
               n = b, o = Ab(e), v[n + 12 >> 2] = o;
               n = b, o = Ab(i), v[n + 16 >> 2] = o;
               n = b, o = Ab(j), v[n + 24 >> 2] = o;
               v[b + 28 >> 2] = 0;
               v[31601] = 0;
               N(447, a + 1298412 | 0, b | 0);
               b = v[31601];
               v[31601] = 0;
               if ((b | 0) != 1) {
                break q;
               }
               a = M() | 0;
               break a;
              }
              if (k & 1) {
               b = v[g >> 2];
               v[31601] = 0;
               b = Q(172, b | 0) | 0;
               c = v[31601];
               v[31601] = 0;
               if ((c | 0) == 1) {
                break h;
               }
               if (b) {
                b = Eb(d);
                v[31601] = 0;
                R(270, g | 0, b | 0, 32);
                c = v[31601];
                v[31601] = 0;
                if ((c | 0) == 1) {
                 break c;
                }
                if (!Md(b, 13798)) {
                 v[31601] = 0;
                 c = d + 40 | 0;
                 R(258, c | 0, 28, b | 0);
                 f = v[31601];
                 v[31601] = 0;
                 if ((f | 0) == 1) {
                  break c;
                 }
                 yb(a + 1298320 | 0, c);
                 sb(c);
                }
                c = v[g + 8 >> 2];
                f = v[g >> 2];
                v[31601] = 0;
                c = O(621, f | 0, c | 0) | 0;
                f = v[31601];
                v[31601] = 0;
                if ((f | 0) == 1) {
                 break c;
                }
                if (!c) {
                 v[31601] = 0;
                 c = Q(202, g | 0) | 0;
                 f = v[31601];
                 v[31601] = 0;
                 if ((f | 0) == 1) {
                  break c;
                 }
                 v[31601] = 0;
                 $(316, a + 1298332 | 0, g | 0, c | 0, 40, 0);
                 c = v[31601];
                 v[31601] = 0;
                 if ((c | 0) == 1) {
                  break c;
                 }
                }
                sb(b);
               }
               v[31601] = 0;
               b = O(1, d + 40 | 0, 18140) | 0;
               c = v[31601];
               v[31601] = 0;
               if ((c | 0) == 1) {
                break k;
               }
               v[31601] = 0;
               R(489, d | 0, b | 0, h | 0);
               c = v[31601];
               v[31601] = 0;
               if ((c | 0) == 1) {
                break j;
               }
               yb(a + 1298368 | 0, d);
               sb(d);
               sb(b);
              }
              v[a + 480208 >> 2] = v[a + 480208 >> 2] | 2097152;
              v[31601] = 0;
              a = T(266, a + 1074312 | 0, 84, 1) | 0;
              b = v[31601];
              v[31601] = 0;
              if ((b | 0) == 1) {
               break h;
              }
              v[31601] = 0;
              a = T(266, a | 0, 83, 1) | 0;
              b = v[31601];
              v[31601] = 0;
              if ((b | 0) == 1) {
               break h;
              }
              v[31601] = 0;
              O(267, a | 0, 85) | 0;
              a = v[31601];
              v[31601] = 0;
              if ((a | 0) == 1) {
               break h;
              }
             }
             sb(h);
             tb(g);
            }
            eb = d + 192 | 0;
            return k & 1;
           }
           a = M() | 0;
           break a;
          }
          a = M() | 0;
          sb(b);
          break a;
         }
         a = M() | 0;
         break a;
        }
        a = M() | 0;
        break a;
       }
       a = M() | 0;
       break a;
      }
      a = M() | 0;
      break a;
     }
     a = M() | 0;
     break a;
    }
    a = M() | 0;
    break a;
   }
   a = M() | 0;
   sb(b);
   break a;
  }
  a = M() | 0;
  tb(f);
 }
 sb(h);
 tb(g);
 P(a | 0);
 p();
}

function Pna(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, q = 0, r = 0, s = 0, y = 0, z = 0, A = 0, C = 0, D = 0;
 h = eb - 176 | 0;
 eb = h;
 xc(b);
 a: {
  d = h + 128 | 0;
  if (!TD(b, d)) {
   break a;
  }
  if (!GV(d)) {
   break a;
  }
  f = 1;
  if ((c | 0) == 64) {
   break a;
  }
  f = 0;
  if (!Lb(v[b >> 2], v[b + 8 >> 2], Ac(FV(w[h + 175 | 0]), gb))) {
   break a;
  }
  Cd(a, 128);
  f = h + 112 | 0;
  Ue(f, 2, h + 143 | 0);
  d = h + 32 | 0;
  Bc(d, f);
  yb(a + 1298308 | 0, d);
  sb(d);
  v[h + 124 >> 2] = 14896;
  v[h + 120 >> 2] = 14953;
  v[h + 116 >> 2] = 14982;
  v[h + 112 >> 2] = 14981;
  f = tc(d, 8453);
  yb(a + 1298344 | 0, f);
  sb(f);
  f = tc(d, 6056);
  yb(a + 1298356 | 0, f);
  sb(f);
  f = tc(h + 100 | 0, 18152);
  v[31601] = 0;
  R(755, d | 0, f | 0, v[((w[h + 142 | 0] << 2) + h | 0) - 84 >> 2]);
  e = v[31601];
  v[31601] = 0;
  b: {
   if ((e | 0) != 1) {
    yb(a + 1298368 | 0, d);
    sb(d);
    sb(f);
    C = a, D = v[Ec(d, 4) >> 2], v[C + 1298404 >> 2] = D;
    v[a + 480208 >> 2] = 12;
    kE(a + 1298332 | 0, b, w[h + 175 | 0] << 5, 32, 0);
    i = Yd(b);
    u[a + 480190 >> 1] = i;
    m = a + 946304 | 0;
    y = a + 484380 | 0;
    f = 1;
    while (1) {
     j = f & 65535;
     if (j >>> 0 > (i & 65535) >>> 0) {
      _j(Wb(v[a + 484360 >> 2], w[a + 484376 | 0]), b, 256, 255, 254);
      f = 0;
      d = Yd(b);
      if (d >>> 0 >= 127) {
       break a;
      }
      u[a + 480188 >> 1] = d + 1 & 255;
      i = a + 480280 | 0;
      e = Yd(b);
      while (1) if (x[a + 480188 >> 1] <= f >>> 0) {
       n = a + 484344 | 0;
       z = e + 1 | 0;
       Sf(n, z);
       f = 0;
       while (1) {
        d = f & 65535;
        if (d >>> 0 > e >>> 0) {
         c: while (1) {
          r = A & 65535;
          f = x[a + 480188 >> 1];
          if (r >>> 0 >= f >>> 0) {
           d = So(h);
           t[d + 16 | 0] = 0;
           u[d + 14 >> 1] = 0;
           u[d + 12 >> 1] = f;
           v[31601] = 0;
           N(757, d | 0, f | 0);
           f = v[31601];
           v[31601] = 0;
           if ((f | 0) == 1) {
            a = M() | 0;
            tf(d);
            P(a | 0);
            p();
           }
           v[31601] = 0;
           N(756, n | 0, d | 0);
           e = v[31601];
           v[31601] = 0;
           f = 1;
           if ((e | 0) != 1) {
            tf(d);
            if (!(c & 2)) {
             break a;
            }
            while (1) {
             c = f & 65535;
             if (c >>> 0 > x[a + 480190 >> 1]) {
              f = 1;
              break a;
             } else {
              c = B(c, 104) + y | 0;
              cg(Yc(h + 32 | 0, u[c + 34 >> 1] & 1 ? 16 : 8, 1, 0, 0), c, b);
              f = f + 1 | 0;
              continue;
             }
            }
           }
           i = M() | 0;
           tf(d);
           break b;
          }
          l = 0;
          e = Mg(h + 32 | 0);
          d: while (1) {
           e: {
            if ((l | 0) != (z | 0)) {
             if (Lb(v[b >> 2], v[b + 8 >> 2], 5)) {
              break e;
             }
            }
            A = A + 1 | 0;
            continue c;
           }
           i = 0;
           d = Vb(v[n >> 2], l);
           f = ld(v[d >> 2], v[v[d + 48 >> 2] + 12 >> 2], 0, r);
           while (1) {
            f: {
             g: {
              if (i >>> 0 > 63) {
               break g;
              }
              m = w[h + 142 | 0];
              g = eb - 16 | 0;
              eb = g;
              s = 1;
              d = Yd(b);
              if ((d | 0) == 252) {
               s = Yd(b);
               d = Yd(b);
              }
              t[e | 0] = (d - 1 & 255) >>> 0 < 60 ? d + 36 | 0 : 0;
              d = g + 12 | 0;
              jm(d, b);
              j = Ic(d);
              k = _e(d);
              d = Xi(d);
              t[e + 1 | 0] = w[g + 12 | 0];
              o = g + 10 | 0;
              q = w[j | 0];
              DV(o, q & 15, w[k | 0], m);
              j = Ic(o);
              k = g + 8 | 0;
              DV(k, q >>> 4 | 0, w[d | 0], m);
              m = Ic(k);
              k = w[g + 10 | 0];
              o = (k | 0) != 10;
              d = w[g + 8 | 0];
              h: {
               if (!(o | (d | 0) != 10)) {
                j = w[j | 0];
                d = w[m | 0];
                t[e + 3 | 0] = 10;
                j = j | d << 8;
                t[e + 5 | 0] = j >>> 6;
                if (j >>> 0 < 16384) {
                 break h;
                }
                t[e + 2 | 0] = 15;
                t[e + 4 | 0] = d >>> 6;
                break h;
               }
               i: {
                j: {
                 k: {
                  l: {
                   m: {
                    if (!o) {
                     k = w[j | 0];
                     o = k << 2;
                     C = j, D = ri(o), t[C | 0] = D;
                     if (k >>> 0 < 64) {
                      break m;
                     }
                     if (qi(d) >>> 0 >= qi(10) >>> 0) {
                      break l;
                     }
                     t[e + 5 | 0] = o;
                     t[e + 2 | 0] = 15;
                     t[e + 3 | 0] = 10;
                     t[e + 4 | 0] = k >>> 6;
                     break h;
                    }
                    if ((d | 0) == 10) {
                     d = w[m | 0];
                     k = d << 2;
                     C = m, D = ri(k), t[C | 0] = D;
                     if (d >>> 0 < 64) {
                      break m;
                     }
                     if (qi(w[g + 10 | 0]) >>> 0 >= qi(10) >>> 0) {
                      break m;
                     }
                     t[e + 5 | 0] = k;
                     t[e + 2 | 0] = 15;
                     t[e + 3 | 0] = 10;
                     t[e + 4 | 0] = d >>> 6;
                     break h;
                    }
                    if ((d | 0) != (k | 0)) {
                     break m;
                    }
                    t[g + 8 | 0] = 0;
                    break k;
                   }
                   d = w[g + 8 | 0];
                  }
                  if ((d | 0) == 13) {
                   break j;
                  }
                  if (d) {
                   break i;
                  }
                  k = w[g + 10 | 0];
                 }
                 if ((k | 0) == 13) {
                  break i;
                 }
                }
                qg(g + 10 | 0, g + 8 | 0);
                qg(j, m);
               }
               vw(g + 8 | 0, m, g + 10 | 0, j);
               cm(g + 6 | 0, e, w[g + 10 | 0], w[j | 0], w[g + 8 | 0], w[m | 0]);
              }
              eb = g + 16 | 0;
              g = i + s | 0;
              i = g >>> 0 > 64 ? 64 - i | 0 : s;
              if (!i) {
               break g;
              }
              while (1) {
               if (!i) {
                break f;
               }
               d = w[e | 0] | w[e + 1 | 0] << 8 | (w[e + 2 | 0] << 16 | w[e + 3 | 0] << 24);
               t[f | 0] = d;
               t[f + 1 | 0] = d >>> 8;
               t[f + 2 | 0] = d >>> 16;
               t[f + 3 | 0] = d >>> 24;
               d = w[e + 4 | 0] | w[e + 5 | 0] << 8;
               t[f + 4 | 0] = d;
               t[f + 5 | 0] = d >>> 8;
               i = i - 1 | 0;
               f = B(x[a + 480188 >> 1], 6) + f | 0;
               continue;
              }
             }
             l = l + 1 | 0;
             continue d;
            }
            i = g >>> 0 >= 64 ? 64 : g;
            continue;
           }
          }
         }
        }
        f = f + 1 | 0;
        if (Og(n, d, 64)) {
         continue;
        }
        break;
       }
       f = 0;
       break a;
      } else {
       d = i + (f << 5) | 0;
       Ve(d);
       n: {
        if (w[h + 142 | 0] >= 51) {
         q = (Yd(b) << 4 | 8) & 248;
         break n;
        }
        q = f & 1 ? 192 : 64;
       }
       u[d + 4 >> 1] = q;
       f = f + 1 | 0;
       continue;
      }
     } else {
      o: {
       if (w[h + 142 | 0] >= 52) {
        d = h + 32 | 0;
        if (!i$(b, d)) {
         nE(d);
        }
        break o;
       }
       g = h + 32 | 0;
       d = eb - 32 | 0;
       eb = d;
       v[d + 28 >> 2] = 64;
       v[d + 8 >> 2] = 66;
       r = v[b >> 2];
       q = v[b + 8 >> 2];
       e = v[Gb(d + 28 | 0, d + 8 | 0) >> 2];
       if (!Lb(r, q, e)) {
        e = jf(b);
       }
       i = d + 8 | 0;
       lw(i, g);
       l = Yb(d + 16 | 0, v[d + 8 >> 2], e);
       n = v[l >> 2];
       ic(d, v[b >> 2], v[b + 8 >> 2], n, v[l + 4 >> 2]);
       lw(i, g);
       Qb(v[d + 8 >> 2] + e | 0, 0, 66 - e | 0);
       Ub(b, v[d + 28 >> 2]);
       eb = d + 32 | 0;
       d = w[h + 94 | 0] | w[h + 95 | 0] << 8;
       t[h + 96 | 0] = d;
       t[h + 97 | 0] = d >>> 8;
       t[h + 94 | 0] = 171;
       t[h + 95 | 0] = 32;
      }
      i = eb - 32 | 0;
      eb = i;
      g = B(j, 104) + y | 0;
      md(g, 0);
      ep(g);
      l = i + 8 | 0;
      e = h + 32 | 0;
      Ik(l, 2, e + 32 | 0);
      d = i + 20 | 0;
      Bc(d, l);
      Ae(g + 43 | 0, d);
      sb(d);
      l = w[e + 56 | 0] | w[e + 57 | 0] << 8 | (w[e + 58 | 0] << 16 | w[e + 59 | 0] << 24);
      n = w[e + 52 | 0] | w[e + 53 | 0] << 8 | (w[e + 54 | 0] << 16 | w[e + 55 | 0] << 24);
      p: {
       if (l >>> 0 <= n >>> 0) {
        break p;
       }
       v[g >> 2] = l - n;
       v[g + 12 >> 2] = w[e + 44 | 0] | w[e + 45 | 0] << 8 | (w[e + 46 | 0] << 16 | w[e + 47 | 0] << 24);
       v[i + 20 >> 2] = w[e + 48 | 0] | w[e + 49 | 0] << 8 | (w[e + 50 | 0] << 16 | w[e + 51 | 0] << 24);
       C = g, D = v[Gb(d, g) >> 2], v[C + 16 >> 2] = D;
       u[g + 30 >> 1] = w[e + 60 | 0];
       v[g + 24 >> 2] = w[e + 62 | 0] | w[e + 63 | 0] << 8;
       d = w[e + 64 | 0] | w[e + 65 | 0] << 8;
       if (d) {
        Yl(g, +(d << 16 >> 16) / 393216);
       }
       d = w[e + 61 | 0];
       if (d & 8) {
        u[g + 34 >> 1] = x[g + 34 >> 1] | 8;
        d = w[e + 61 | 0];
       }
       if (d & 16) {
        u[g + 34 >> 1] = x[g + 34 >> 1] | 16;
        d = w[e + 61 | 0];
       }
       if (!(d & 4)) {
        break p;
       }
       u[g + 34 >> 1] = x[g + 34 >> 1] | 1;
       v[g + 12 >> 2] = v[g + 12 >> 2] >>> 1;
       v[g + 16 >> 2] = v[g + 16 >> 2] >>> 1;
      }
      eb = i + 32 | 0;
      g = h + 20 | 0;
      Ue(g, 2, e);
      d = h + 100 | 0;
      Bc(d, g);
      zc(m + (j << 5) | 0, d);
      f = f + 1 | 0;
      sb(d);
      i = x[a + 480190 >> 1];
      continue;
     }
    }
   }
   i = M() | 0;
   sb(f);
  }
  P(i | 0);
  p();
 }
 eb = h + 176 | 0;
 return f | 0;
}

function uZ(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
 f = eb - 128 | 0;
 eb = f;
 i = ng(f + 116 | 0);
 a: {
  b: {
   c: {
    if (d) {
     v[31601] = 0;
     R(482, a | 0, i | 0, c | 0);
     c = v[31601];
     v[31601] = 0;
     if ((c | 0) != 1) {
      break c;
     }
     break b;
    }
    v[31601] = 0;
    R(483, a | 0, i | 0, c | 0);
    c = v[31601];
    v[31601] = 0;
    if ((c | 0) == 1) {
     break b;
    }
   }
   n = b + 900380 | 0;
   m = Mb(f + 104 | 0);
   c = 1;
   while (1) {
    d: {
     e: {
      f: {
       g: {
        h: {
         i: {
          j: {
           k: {
            l: {
             m: {
              n: {
               o: {
                p: {
                 q: {
                  r: {
                   s: {
                    g = c & 65535;
                    if (g >>> 0 <= x[b + 480192 >> 1]) {
                     v[31601] = 0;
                     u[f + 102 >> 1] = 0;
                     N(484, a | 0, f + 102 | 0);
                     d = v[31601];
                     v[31601] = 0;
                     t: {
                      u: {
                       v: {
                        w: {
                         if ((d | 0) != 1) {
                          h = eb - 16 | 0;
                          eb = h;
                          l = x[f + 102 >> 1];
                          d = ce(i);
                          e = fc(i);
                          j = eb - 16 | 0;
                          eb = j;
                          while (1) {
                           if (d) {
                            k = _o(x[d + 16 >> 1], l);
                            e = k ? e : d;
                            d = v[(k ? 4 : 0) + d >> 2];
                            continue;
                           }
                           break;
                          }
                          d = v[ub(j + 12 | 0, e) >> 2];
                          eb = j + 16 | 0;
                          x: {
                           if (Hb(d, og(i))) {
                            if (!_o(x[f + 102 >> 1], x[td(d) >> 1])) {
                             break x;
                            }
                           }
                           d = og(i);
                          }
                          d = ub(h + 12 | 0, d);
                          eb = h + 16 | 0;
                          j = (g << 2) + n | 0;
                          if (!v[j >> 2]) {
                           break d;
                          }
                          d = v[d >> 2];
                          if (!Yg(d, Of(i))) {
                           break u;
                          }
                          v[31601] = 0;
                          h = O(3, f + 88 | 0, td(d) + 4 | 0) | 0;
                          d = v[31601];
                          v[31601] = 0;
                          if ((d | 0) == 1) {
                           break t;
                          }
                          v[31601] = 0;
                          d = O(1, f + 76 | 0, 16780) | 0;
                          e = v[31601];
                          v[31601] = 0;
                          if ((e | 0) == 1) {
                           break v;
                          }
                          e = ir(h, d);
                          sb(d);
                          if (e) {
                           break p;
                          }
                          d = v[b + 4 >> 2];
                          v[31601] = 0;
                          d = O(485, d | 0, h | 0) | 0;
                          e = v[31601];
                          v[31601] = 0;
                          if ((e | 0) == 1) {
                           break r;
                          }
                          v[v[j >> 2] + 44 >> 2] = d;
                          if (!v[v[j >> 2] + 44 >> 2]) {
                           break w;
                          }
                          break e;
                         }
                         c = M() | 0;
                         break f;
                        }
                        v[31601] = 0;
                        d = O(1, f - -64 | 0, 13543) | 0;
                        e = v[31601];
                        v[31601] = 0;
                        y: {
                         z: {
                          A: {
                           if ((e | 0) != 1) {
                            B: {
                             if (!ir(h, d)) {
                              v[31601] = 0;
                              e = O(1, f + 52 | 0, 13703) | 0;
                              g = v[31601];
                              v[31601] = 0;
                              if ((g | 0) == 1) {
                               break A;
                              }
                              g = ir(h, e);
                              sb(e);
                              sb(d);
                              if (g) {
                               break B;
                              }
                              break s;
                             }
                             sb(d);
                            }
                            v[31601] = 0;
                            d = Q(486, h | 0) | 0;
                            e = v[31601];
                            v[31601] = 0;
                            if ((e | 0) == 1) {
                             break z;
                            }
                            v[f + 36 >> 2] = d;
                            d = v[b + 4 >> 2];
                            e = f + 36 | 0;
                            g = v[re(f + 48 | 0, e) >> 2];
                            v[31601] = 0;
                            d = O(487, d | 0, g | 0) | 0;
                            g = v[31601];
                            v[31601] = 0;
                            if ((g | 0) == 1) {
                             break y;
                            }
                            lg(e);
                            if (d) {
                             break e;
                            }
                            break s;
                           }
                           c = M() | 0;
                           break g;
                          }
                          c = M() | 0;
                          sb(d);
                          break g;
                         }
                         c = M() | 0;
                         break g;
                        }
                        c = M() | 0;
                        lg(f + 36 | 0);
                        break g;
                       }
                       c = M() | 0;
                       break g;
                      }
                      d = v[j >> 2];
                      if (!d) {
                       break d;
                      }
                      v[d + 44 >> 2] = 0;
                      break d;
                     }
                     c = M() | 0;
                     break f;
                    }
                    Sd(m);
                    sZ(i);
                    eb = f + 128 | 0;
                    return;
                   }
                   d = vb(v[m >> 2]);
                   g = d;
                   e = vb(v[m + 4 >> 2]);
                   while (1) {
                    C: {
                     D: {
                      if ((d | 0) != (e | 0)) {
                       if (!ir(d, h)) {
                        break D;
                       }
                      } else {
                       d = e;
                      }
                      break C;
                     }
                     d = d + 12 | 0;
                     continue;
                    }
                    break;
                   }
                   e = eb - 16 | 0;
                   eb = e;
                   v[e + 12 >> 2] = g;
                   v[e + 12 >> 2] = v[e + 12 >> 2] + B((d - g | 0) / 12 | 0, 12);
                   eb = e + 16 | 0;
                   if (Hb(v[e + 12 >> 2], vb(v[m + 4 >> 2]))) {
                    break p;
                   }
                   v[31601] = 0;
                   N(488, m | 0, h | 0);
                   d = v[31601];
                   v[31601] = 0;
                   if ((d | 0) != 1) {
                    break q;
                   }
                  }
                  c = M() | 0;
                  break g;
                 }
                 v[31601] = 0;
                 d = O(1, f + 12 | 0, 17497) | 0;
                 e = v[31601];
                 v[31601] = 0;
                 if ((e | 0) == 1) {
                  break o;
                 }
                 v[31601] = 0;
                 g = f + 24 | 0;
                 R(489, g | 0, d | 0, h | 0);
                 e = v[31601];
                 v[31601] = 0;
                 if ((e | 0) == 1) {
                  break n;
                 }
                 v[31601] = 0;
                 e = O(1, f | 0, 16356) | 0;
                 l = v[31601];
                 v[31601] = 0;
                 if ((l | 0) == 1) {
                  break m;
                 }
                 v[31601] = 0;
                 l = f + 36 | 0;
                 R(2, l | 0, g | 0, e | 0);
                 k = v[31601];
                 v[31601] = 0;
                 if ((k | 0) == 1) {
                  break l;
                 }
                 k = v[b + 1298472 >> 2];
                 v[31601] = 0;
                 R(385, k | 0, 2, l | 0);
                 k = v[31601];
                 v[31601] = 0;
                 if ((k | 0) == 1) {
                  break k;
                 }
                 sb(l);
                 sb(e);
                 sb(g);
                 sb(d);
                }
                v[v[j >> 2] + 44 >> 2] = 0;
                break e;
               }
               c = M() | 0;
               break g;
              }
              c = M() | 0;
              break h;
             }
             c = M() | 0;
             break i;
            }
            c = M() | 0;
            break j;
           }
           c = M() | 0;
           sb(f + 36 | 0);
          }
          sb(e);
         }
         sb(f + 24 | 0);
        }
        sb(d);
       }
       sb(h);
      }
      Sd(m);
      break a;
     }
     sb(h);
    }
    c = c + 1 | 0;
    continue;
   }
  }
  c = M() | 0;
 }
 sZ(i);
 P(c | 0);
 p();
}

function Hsa(a, b, c, d, e, f, g, h, i) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 f = f | 0;
 g = g | 0;
 h = h | 0;
 i = i | 0;
 var j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, y = 0;
 j = eb - 128 | 0;
 eb = j;
 t[j + 127 | 0] = d;
 a: {
  if (!c | (e | 0) < 0 & c >>> 0 >= 176) {
   break a;
  }
  t[b + 5 | 0] = d;
  t[j + 8 | 0] = 15;
  l = j + 127 | 0;
  p = j + 8 | 0;
  k = p;
  o = w[Pb(l, k) | 0];
  t[j + 8 | 0] = 14;
  l = w[Pb(l, k) | 0];
  v[j + 8 >> 2] = d + 31 >>> 5;
  v[j + 120 >> 2] = 14;
  r = j + 120 | 0;
  n = v[Bd(k, r) >> 2];
  v[j + 8 >> 2] = d + 127 >>> 7;
  v[j + 120 >> 2] = 14;
  q = c & 15;
  k = q << 8 | d;
  p = Bd(p, r);
  b: {
   switch ((c >>> 4 | 0) - 2 | 0) {
   case 0:
    t[b + 2 | 0] = 1;
    v[j + 8 >> 2] = k >>> 2;
    v[j + 120 >> 2] = 64;
    s = b, y = v[Bd(j + 8 | 0, j + 120 | 0) >> 2], t[s + 4 | 0] = y;
    break a;

   case 1:
    t[b + 2 | 0] = 1;
    if (!k) {
     t[b + 4 | 0] = 0;
     break a;
    }
    s = j, y = ND(k) >>> 2 | 0, v[s + 8 >> 2] = y;
    v[j + 120 >> 2] = 64;
    s = b, y = v[Bd(j + 8 | 0, j + 120 | 0) >> 2], t[s + 4 | 0] = y;
    break a;

   case 2:
    t[b + 3 | 0] = 9;
    t[b + 5 | 0] = k >>> 4;
    break a;

   case 3:
    t[b + 3 | 0] = 23;
    t[b + 5 | 0] = k + 1 >>> 5;
    break a;

   case 4:
    t[b + 3 | 0] = 23;
    if (k) {
     a = Dh(ND(k) >>> 5 | 0);
    } else {
     a = 0;
    }
    t[b + 5 | 0] = a;
    break a;

   case 5:
    t[b + 5 | 0] = q;
    t[b + 3 | 0] = 15;
    break a;

   case 6:
    t[b + 3 | 0] = 15;
    if ((e | 0) >= 0) {
     if (w[b + 2 | 0]) {
      break a;
     }
     t[b + 2 | 0] = 2;
     s = b, y = Fc(((q << 6 | 7) >>> 0) / 15 | 0, 0), t[s + 4 | 0] = y;
     break a;
    }
    t[b + 2 | 0] = 1;
    t[b + 5 | 0] = q;
    t[b + 4 | 0] = d + 3 >>> 2;
    break a;

   case 7:
    t[b + 3 | 0] = 10;
    c: {
     if ((e | 0) > 5) {
      break c;
     }
     if (!k) {
      t[b + 5 | 0] = 1;
      break a;
     }
     c = rr(a, f, g);
     if (!c) {
      break c;
     }
     a = mi(a, c);
     c = x[a + 34 >> 1];
     if (c & 1) {
      k = k >>> 1 | 0;
      v[j + 120 >> 2] = k;
     }
     if (!(c & 2)) {
      break c;
     }
     c = v[a >> 2];
     if (c >>> 0 >= k << 8 >>> 0) {
      break c;
     }
     v[j + 120 >> 2] = v[a + 4 >> 2] + 8 >>> 8;
     wc(j + 120 | 0, c - 1 >>> 8 | 0);
     k = v[j + 120 >> 2];
    }
    t[b + 5 | 0] = k;
    if (w[b + 2 | 0] | k >>> 0 < 256) {
     break a;
    }
    t[b + 2 | 0] = 15;
    v[j + 116 >> 2] = k >>> 8;
    _v(j + 8 | 0);
    v[j + 112 >> 2] = 9;
    s = b, y = v[Gb(j + 116 | 0, j + 112 | 0) >> 2], t[s + 4 | 0] = y;
    break a;

   default:
    break b;
   }
  }
  k = v[p >> 2];
  d: {
   switch (c - 160 | 0) {
   default:
    e: {
     switch (c - 1 | 0) {
     case 0:
     case 1:
     case 2:
     case 3:
     case 6:
     case 10:
     case 14:
      Bf(b, c, d);
      f: {
       switch (w[b + 3 | 0] - 16 | 0) {
       case 1:
        v[h >> 2] = B(w[b + 5 | 0], 1e4);
        break a;

       case 0:
        break f;

       default:
        break a;
       }
      }
      a = w[b + 5 | 0];
      if (!a) {
       break a;
      }
      v[i >> 2] = a;
      break a;

     case 4:
      t[b + 3 | 0] = 4;
      if (w[b + 2 | 0]) {
       break a;
      }
      t[b + 4 | 0] = 0;
      t[b + 2 | 0] = 8;
      break a;

     case 5:
      t[b + 3 | 0] = 5;
      if (w[b + 2 | 0]) {
       break a;
      }
      t[b + 4 | 0] = 0;
      t[b + 2 | 0] = 11;
      break a;

     case 7:
      if (!Tc(w[b | 0]) | !d) {
       break a;
      }
      t[b + 3 | 0] = 35;
      t[b + 5 | 0] = (d >>> 1 & 120 | 128) - (d << 3 & 120);
      if (x[a + 480192 >> 1]) {
       break a;
      }
      u[j + 8 >> 1] = 255;
      c = x[Nc(a + 480190 | 0, j + 8 | 0) >> 1];
      u[a + 480192 >> 1] = c;
      e = a + 946304 | 0;
      b = 1;
      while (1) {
       d = b & 65535;
       if (d >>> 0 > (c & 65535) >>> 0) {
        break a;
       }
       c = CE(a, d, d);
       if (c) {
        t[c + 33 | 0] = 2;
        d = e + (d << 5) | 0;
        f = v[d + 4 >> 2];
        v[c + 492 >> 2] = v[d >> 2];
        v[c + 496 >> 2] = f;
        f = v[d + 12 >> 2];
        v[c + 500 >> 2] = v[d + 8 >> 2];
        v[c + 504 >> 2] = f;
        f = v[d + 20 >> 2];
        v[c + 508 >> 2] = v[d + 16 >> 2];
        v[c + 512 >> 2] = f;
        f = v[d + 28 >> 2];
        v[c + 516 >> 2] = v[d + 24 >> 2];
        v[c + 520 >> 2] = f;
        bk(c, 127, 1);
        ak(c, 0, 1);
       }
       b = b + 1 | 0;
       c = x[a + 480192 >> 1];
       continue;
      }
      ;

     case 8:
      t[b + 3 | 0] = 19;
      t[b + 5 | 0] = o | 208;
      break a;

     case 9:
      t[b + 3 | 0] = 25;
      break a;

     case 11:
      if (d >>> 0 > 2) {
       break a;
      }
      t[b + 3 | 0] = 19;
      t[b + 5 | 0] = d | 64;
      break a;

     case 12:
      t[b + 3 | 0] = 14;
      break a;

     case 13:
      if (d >>> 0 > 2) {
       break a;
      }
      t[b + 3 | 0] = 19;
      t[b + 5 | 0] = d | 112;
      break a;

     case 15:
      t[b + 3 | 0] = 1;
      break a;

     case 16:
     case 17:
      t[b + 3 | 0] = 19;
      t[b + 5 | 0] = l | c << 4;
      break a;

     case 18:
      t[b + 3 | 0] = 15;
      break a;

     case 19:
      t[b + 3 | 0] = 11;
      t[b + 5 | 0] = l << 4;
      break a;

     case 20:
      t[b + 5 | 0] = l;
      t[b + 3 | 0] = 11;
      break a;

     case 23:
      t[b + 3 | 0] = 6;
      t[b + 5 | 0] = l << 4;
      break a;

     case 24:
      t[b + 5 | 0] = l;
      t[b + 3 | 0] = 6;
      break a;

     case 27:
      t[b + 3 | 0] = 7;
      t[b + 5 | 0] = l << 4;
      break a;

     case 28:
      break e;

     default:
      break a;
     }
    }
    t[b + 5 | 0] = l;
    t[b + 3 | 0] = 7;
    break a;

   case 0:
    if (!d) {
     break a;
    }
    t[b + 3 | 0] = 24;
    t[b + 5 | 0] = n << 4;
    break a;

   case 1:
    if (!d) {
     break a;
    }
    t[b + 5 | 0] = n;
    t[b + 3 | 0] = 24;
    break a;

   case 4:
    t[b + 3 | 0] = 11;
    t[b + 5 | 0] = l << 4 | 15;
    break a;

   case 5:
    t[b + 3 | 0] = 11;
    t[b + 5 | 0] = l | 240;
    break a;

   case 6:
    if (!d) {
     break a;
    }
    t[b + 3 | 0] = 24;
    t[b + 5 | 0] = n << 4 | 15;
    break a;

   case 7:
    if (!d) {
     break a;
    }
    t[b + 3 | 0] = 24;
    t[b + 5 | 0] = n | 240;
    break a;

   case 8:
    if (!d) {
     break a;
    }
    t[b + 3 | 0] = 16;
    v[i >> 2] = d;
    break a;

   case 9:
    if ((e | 0) > 5) {
     break a;
    }
    a = v[h >> 2];
    if (a >>> 0 < 1e4) {
     break a;
    }
    t[b + 3 | 0] = 17;
    m = 122925 / (+(a >>> 0) / 1e4) + +((d << 1) - 256 | 0);
    s = b, y = Xl(245850 / (m + m)), t[s + 5 | 0] = y;
    break a;

   case 10:
    t[b + 3 | 0] = 19;
    t[b + 5 | 0] = o | 224;
    break a;

   case 12:
    t[b + 3 | 0] = 28;
    t[b + 5 | 0] = o | 16;
    break a;

   case 13:
    t[b + 3 | 0] = 28;
    t[b + 5 | 0] = o | 32;
    break a;

   case 14:
    t[b + 3 | 0] = 29;
    t[b + 5 | 0] = l << 3 & 240;
    break a;

   case 15:
    t[b + 3 | 0] = 29;
    t[b + 5 | 0] = (l & 254) >>> 1;
    break a;

   case 16:
    t[b + 3 | 0] = 18;
    break a;

   case 17:
    t[b + 3 | 0] = 19;
    t[b + 5 | 0] = o | 176;
    break a;

   case 18:
   case 19:
    t[b + 3 | 0] = 20;
    t[b + 5 | 0] = d ? 120 : 119;
    break a;

   case 20:
    t[b + 3 | 0] = 20;
    t[b + 5 | 0] = d ? 125 : 123;
    break a;

   case 21:
    t[b + 3 | 0] = 20;
    t[b + 5 | 0] = d ? 122 : 121;
    break a;

   case 22:
    t[b + 3 | 0] = 20;
    t[b + 5 | 0] = d ? 126 : 123;
    break a;

   case 26:
    t[b + 3 | 0] = 10;
    t[b + 5 | 0] = d + 15 >>> 4;
    break a;

   case 27:
    t[b + 5 | 0] = 1;
    t[b + 3 | 0] = 10;
    break a;

   case 30:
   case 31:
    if (!d | (!g | !f)) {
     break a;
    }
    o = v[h >> 2];
    if (o >>> 0 < 1e4) {
     break a;
    }
    l = v[i >> 2];
    if (!l) {
     break a;
    }
    i = rr(a, f, g);
    if (!i) {
     break a;
    }
    k = mi(a, i);
    n = x[k + 34 >> 1];
    g: {
     if (!(n & 2)) {
      i = v[k >> 2];
      break g;
     }
     i = v[k + 8 >> 2] - ((e | 0) < 6 ? v[k + 4 >> 2] : 0) | 0;
     if (!(n & 4)) {
      break g;
     }
     i = i << ((e | 0) > 5);
    }
    if (!i | (e | 0) < 6 & i >>> 0 < 1024) {
     break a;
    }
    n = v[k + 24 >> 2];
    if (!n) {
     break a;
    }
    h: {
     if (x[a + 480192 >> 1] < g >>> 0) {
      break h;
     }
     a = v[((g << 2) + a | 0) + 900380 >> 2];
     if (!a) {
      break h;
     }
     m = +(w[wb(a + 108 | 0, f - 1 | 0) | 0] - f | 0);
    }
    a = (c | 0) == 190;
    m = zi(m / 12 + (a ? (e | 0) < 6 ? +t[k + 37 | 0] / -1536 : -0 : -0)) * +(n >>> 0);
    if (a) {
     t[b + 3 | 0] = 17;
     a = Xl(m * .5 * (+(B(d, l) >>> 0) * 2.5) / +(i >>> 0));
     t[b + 5 | 0] = a;
     v[h >> 2] = B(a, 1e4);
     break a;
    }
    m = Zv(oM(+(i >>> 0) / m / (+(B(d, l) >>> 0) * 2.5 / (+(o >>> 0) / 1e4))) * 12 + 61, 1, 120);
    i: {
     if (m < 4294967296 & m >= 0) {
      a = ~~m >>> 0;
      break i;
     }
     a = 0;
    }
    c = Tc(w[b | 0]);
    t[b | 0] = a;
    m = (m - H(m)) * 64 + 128;
    j: {
     if (m < 4294967296 & m >= 0) {
      a = ~~m >>> 0;
      break j;
     }
     a = 0;
    }
    t[b + 5 | 0] = a;
    if ((a | 0) != 128) {
     t[b + 3 | 0] = 35;
    }
    if (c) {
     break a;
    }
    if (!w[b + 2 | 0]) {
     t[b + 4 | 0] = 9;
     t[b + 2 | 0] = 11;
     break a;
    }
    t[b + 5 | 0] = 255;
    t[b + 3 | 0] = 4;
    break a;

   case 32:
    a = d >>> 4 | 0;
    if (a - 1 >>> 0 > 1) {
     break a;
    }
    t[b + 3 | 0] = 20;
    t[b + 5 | 0] = a - 99;
    break a;

   case 34:
    t[b + 3 | 0] = 21;
    t[b + 5 | 0] = d << 2;
    break a;

   case 35:
    t[b + 3 | 0] = 21;
    s = b, y = Dh(ND(d << 4) >>> 6 | 0), t[s + 5 | 0] = y;
    break a;

   case 36:
   case 38:
    t[b + 3 | 0] = 22;
    t[b + 5 | 0] = k << 4;
    break a;

   case 37:
   case 39:
    t[b + 5 | 0] = k;
    t[b + 3 | 0] = 22;
    break a;

   case 40:
    t[b + 3 | 0] = 22;
    t[b + 5 | 0] = l << 4 | 15;
    break a;

   case 2:
   case 3:
   case 11:
   case 23:
   case 24:
   case 25:
   case 28:
   case 29:
   case 33:
    break a;

   case 41:
    break d;
   }
  }
  t[b + 3 | 0] = 22;
  t[b + 5 | 0] = l | 240;
 }
 eb = j + 128 | 0;
}

function bH(a, b, c) {
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
 g = eb - 32 | 0;
 eb = g;
 d = v[b + 28 >> 2];
 v[g + 24 >> 2] = v[b + 24 >> 2];
 v[g + 28 >> 2] = d;
 d = v[b + 20 >> 2];
 v[g + 16 >> 2] = v[b + 16 >> 2];
 v[g + 20 >> 2] = d;
 d = v[b + 12 >> 2];
 v[g + 8 >> 2] = v[b + 8 >> 2];
 v[g + 12 >> 2] = d;
 d = v[b + 4 >> 2];
 v[g >> 2] = v[b >> 2];
 v[g + 4 >> 2] = d;
 d = eb - 144 | 0;
 eb = d;
 k = Eb(d + 132 | 0);
 n = Eb(d + 120 | 0);
 v[31601] = 0;
 b = O(1, d + 108 | 0, c | 0) | 0;
 c = v[31601];
 v[31601] = 0;
 a: {
  b: {
   c: {
    if ((c | 0) != 1) {
     c = yb(n, b);
     sb(b);
     if (!v[g >> 2]) {
      break b;
     }
     v[31601] = 0;
     b = d + 96 | 0;
     N(73, b | 0, g | 0);
     e = v[31601];
     v[31601] = 0;
     d: {
      e: {
       f: {
        g: {
         h: {
          i: {
           j: {
            k: {
             l: {
              m: {
               n: {
                o: {
                 p: {
                  q: {
                   if ((e | 0) != 1) {
                    v[31601] = 0;
                    i = O(74, k | 0, b | 0) | 0;
                    e = v[31601];
                    v[31601] = 0;
                    if ((e | 0) == 1) {
                     break q;
                    }
                    sb(b);
                    v[31601] = 0;
                    e = O(1, d + 84 | 0, 16798) | 0;
                    f = v[31601];
                    v[31601] = 0;
                    if ((f | 0) == 1) {
                     break p;
                    }
                    v[31601] = 0;
                    f = d + 72 | 0;
                    N(75, f | 0, g + 4 | 0);
                    h = v[31601];
                    v[31601] = 0;
                    if ((h | 0) == 1) {
                     break o;
                    }
                    v[31601] = 0;
                    R(2, b | 0, e | 0, f | 0);
                    h = v[31601];
                    v[31601] = 0;
                    if ((h | 0) == 1) {
                     break n;
                    }
                    v[31601] = 0;
                    i = O(74, i | 0, b | 0) | 0;
                    h = v[31601];
                    v[31601] = 0;
                    if ((h | 0) == 1) {
                     break m;
                    }
                    sb(b);
                    sb(f);
                    sb(e);
                    v[31601] = 0;
                    e = O(1, f | 0, 16798) | 0;
                    f = v[31601];
                    v[31601] = 0;
                    if ((f | 0) == 1) {
                     break j;
                    }
                    v[31601] = 0;
                    f = d + 60 | 0;
                    N(75, f | 0, g + 8 | 0);
                    h = v[31601];
                    v[31601] = 0;
                    if ((h | 0) == 1) {
                     break i;
                    }
                    v[31601] = 0;
                    R(2, b | 0, e | 0, f | 0);
                    h = v[31601];
                    v[31601] = 0;
                    if ((h | 0) == 1) {
                     break h;
                    }
                    v[31601] = 0;
                    i = O(74, i | 0, b | 0) | 0;
                    h = v[31601];
                    v[31601] = 0;
                    if ((h | 0) == 1) {
                     break g;
                    }
                    sb(b);
                    sb(f);
                    sb(e);
                    e = v[g + 28 >> 2];
                    o = e;
                    b = v[g + 24 >> 2];
                    if (v[g + 12 >> 2] | (v[g + 16 >> 2] | !(e | b))) {
                     break d;
                    }
                    break b;
                   }
                   a = M() | 0;
                   break c;
                  }
                  a = M() | 0;
                  sb(d + 96 | 0);
                  break c;
                 }
                 a = M() | 0;
                 break c;
                }
                a = M() | 0;
                break k;
               }
               a = M() | 0;
               break l;
              }
              a = M() | 0;
              sb(d + 96 | 0);
             }
             sb(d + 72 | 0);
            }
            sb(e);
            break c;
           }
           a = M() | 0;
           break c;
          }
          a = M() | 0;
          break e;
         }
         a = M() | 0;
         break f;
        }
        a = M() | 0;
        sb(d + 96 | 0);
       }
       sb(d + 60 | 0);
      }
      sb(e);
      break c;
     }
     v[31601] = 0;
     e = O(1, d + 96 | 0, 13717) | 0;
     f = v[31601];
     v[31601] = 0;
     r: {
      s: {
       t: {
        u: {
         v: {
          w: {
           x: {
            y: {
             z: {
              A: {
               B: {
                C: {
                 D: {
                  E: {
                   F: {
                    G: {
                     H: {
                      I: {
                       J: {
                        if ((f | 0) != 1) {
                         v[31601] = 0;
                         l = O(74, i | 0, e | 0) | 0;
                         f = v[31601];
                         v[31601] = 0;
                         if ((f | 0) == 1) {
                          break J;
                         }
                         sb(e);
                         v[31601] = 0;
                         f = d + 36 | 0;
                         N(76, f | 0, g + 12 | 0);
                         e = v[31601];
                         v[31601] = 0;
                         if ((e | 0) == 1) {
                          break I;
                         }
                         v[31601] = 0;
                         e = O(1, d + 24 | 0, 14629) | 0;
                         i = v[31601];
                         v[31601] = 0;
                         if ((i | 0) == 1) {
                          break H;
                         }
                         v[31601] = 0;
                         i = d + 48 | 0;
                         R(2, i | 0, f | 0, e | 0);
                         h = v[31601];
                         v[31601] = 0;
                         if ((h | 0) == 1) {
                          break G;
                         }
                         v[31601] = 0;
                         h = d + 12 | 0;
                         N(76, h | 0, g + 16 | 0);
                         j = v[31601];
                         v[31601] = 0;
                         if ((j | 0) == 1) {
                          break F;
                         }
                         v[31601] = 0;
                         j = d + 60 | 0;
                         R(2, j | 0, i | 0, h | 0);
                         m = v[31601];
                         v[31601] = 0;
                         if ((m | 0) == 1) {
                          break E;
                         }
                         v[31601] = 0;
                         l = O(74, l | 0, j | 0) | 0;
                         m = v[31601];
                         v[31601] = 0;
                         if ((m | 0) == 1) {
                          break D;
                         }
                         sb(j);
                         sb(h);
                         sb(i);
                         sb(e);
                         sb(f);
                         if (b | o) {
                          break y;
                         }
                         v[31601] = 0;
                         R(77, a | 0, l | 0, c | 0);
                         a = v[31601];
                         v[31601] = 0;
                         if ((a | 0) == 1) {
                          break x;
                         }
                         break a;
                        }
                        a = M() | 0;
                        break c;
                       }
                       a = M() | 0;
                       sb(e);
                       break c;
                      }
                      a = M() | 0;
                      break c;
                     }
                     a = M() | 0;
                     break z;
                    }
                    a = M() | 0;
                    break A;
                   }
                   a = M() | 0;
                   break B;
                  }
                  a = M() | 0;
                  break C;
                 }
                 a = M() | 0;
                 sb(d + 60 | 0);
                }
                sb(d + 12 | 0);
               }
               sb(d + 48 | 0);
              }
              sb(e);
             }
             sb(d + 36 | 0);
             break c;
            }
            v[31601] = 0;
            b = O(1, d + 48 | 0, 14629) | 0;
            e = v[31601];
            v[31601] = 0;
            if ((e | 0) == 1) {
             break w;
            }
            v[31601] = 0;
            e = d + 36 | 0;
            N(78, e | 0, g + 24 | 0);
            f = v[31601];
            v[31601] = 0;
            if ((f | 0) == 1) {
             break v;
            }
            v[31601] = 0;
            f = d + 60 | 0;
            R(2, f | 0, b | 0, e | 0);
            i = v[31601];
            v[31601] = 0;
            if ((i | 0) == 1) {
             break u;
            }
            v[31601] = 0;
            i = O(74, l | 0, f | 0) | 0;
            h = v[31601];
            v[31601] = 0;
            if ((h | 0) == 1) {
             break t;
            }
            sb(f);
            sb(e);
            sb(b);
            v[31601] = 0;
            O(74, i | 0, c | 0) | 0;
            b = v[31601];
            v[31601] = 0;
            if ((b | 0) != 1) {
             break b;
            }
           }
           a = M() | 0;
           break c;
          }
          a = M() | 0;
          break c;
         }
         a = M() | 0;
         break r;
        }
        a = M() | 0;
        break s;
       }
       a = M() | 0;
       sb(d + 60 | 0);
      }
      sb(d + 36 | 0);
     }
     sb(b);
     break c;
    }
    a = M() | 0;
   }
   sb(n);
   sb(k);
   P(a | 0);
   p();
  }
  Uc(a, k);
 }
 sb(c);
 sb(k);
 eb = d + 144 | 0;
 eb = g + 32 | 0;
}

function pga(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = C(0), f = C(0), g = C(0), h = C(0), i = C(0), j = C(0), k = C(0), l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, u = 0, x = 0, y = C(0), A = C(0), B = 0, D = 0, E = 0, F = C(0), G = C(0), H = 0, I = C(0);
 a: {
  if (!w[a + 5046 | 0]) {
   break a;
  }
  g = z[a + 4268 >> 2];
  PP(a);
  if (z[a + 4268 >> 2] == g) {
   break a;
  }
  Uz(a);
 }
 b: {
  if (!w[a + 5045 | 0]) {
   break b;
  }
  if (!si(a + 44 | 0)) {
   break b;
  }
  n = v[a + 44 >> 2];
  q = Gc(n, 0);
  r = Gc(n, 1);
  n = v[a + 56 >> 2];
  l = Gc(n, 0);
  m = Gc(n, 1);
  c: {
   if (!(!w[a + 5044 | 0] | (!d | w[a + 4264 | 0] & 2))) {
    z[l >> 2] = z[a + 5036 >> 2];
    z[m >> 2] = z[a + 5040 >> 2];
    t[a + 5044 | 0] = 0;
    r = r + 4 | 0;
    q = q + 4 | 0;
    m = m + 4 | 0;
    l = l + 4 | 0;
    p = d - 1 | 0;
    break c;
   }
   p = d;
  }
  s = p;
  u = a + 4888 | 0;
  x = a + 4864 | 0;
  d: {
   while (1) {
    if (!s) {
     break d;
    }
    g = z[q >> 2];
    g = C(C(C(z[a + 5008 >> 2] - g) * z[a + 4276 >> 2]) + g);
    z[a + 5008 >> 2] = g;
    H = Oc(v[a + 4864 >> 2], v[a + 4868 >> 2], v[a + 4880 >> 2]), I = g, z[H >> 2] = I;
    g = z[r >> 2];
    g = C(C(C(z[a + 5012 >> 2] - g) * z[a + 4276 >> 2]) + g);
    z[a + 5012 >> 2] = g;
    H = Oc(v[a + 4888 >> 2], v[a + 4892 >> 2], v[a + 4904 >> 2]), I = g, z[H >> 2] = I;
    g = C(C(C(C(C(hi(x, v[a + 4356 >> 2]) * C(.6800000071525574)) + C(hi(x, v[a + 4360 >> 2]) * C(-.5))) - C(hi(x, v[a + 4364 >> 2]) * C(.6200000047683716))) + C(hi(x, v[a + 4368 >> 2]) * C(-.5))) - C(hi(x, v[a + 4372 >> 2]) * C(.6200000047683716)));
    if (t[a + 4264 | 0] & 1) {
     e = g;
     g = C(z[Oc(v[a + 4816 >> 2], v[a + 4820 >> 2], v[a + 4836 >> 2]) >> 2] + C(e * C(.6180340051651001)));
     H = Oc(v[a + 4816 >> 2], v[a + 4820 >> 2], v[a + 4832 >> 2]), I = C(e - C(g * C(.6180340051651001))), 
     z[H >> 2] = I;
    }
    y = z[a + 4280 >> 2];
    H = a, I = C(hi(x, v[a + 4352 >> 2]) + z[a + 5020 >> 2]), z[H + 5020 >> 2] = I;
    e = C(hi(u, v[a + 4376 >> 2]) + z[a + 5024 >> 2]);
    z[a + 5024 >> 2] = e;
    f = z[a + 5020 >> 2];
    h = C(C(C(z[a + 4980 >> 2] - z[Oc(v[a + 4624 >> 2], v[a + 4628 >> 2], v[a + 4644 >> 2]) >> 2]) * z[a + 4444 >> 2]) + z[Oc(v[a + 4624 >> 2], v[a + 4628 >> 2], v[a + 4644 >> 2]) >> 2]);
    z[a + 4980 >> 2] = h;
    k = C(h * z[a + 4440 >> 2]);
    j = C(e * C(.7070000171661377));
    i = C(f * C(-.7070000171661377));
    f = C(j + i);
    h = z[a + 4272 >> 2];
    e = C(k + C(f * h));
    H = Oc(v[a + 4624 >> 2], v[a + 4628 >> 2], v[a + 4640 >> 2]), I = C(f - C(h * e)), 
    z[H >> 2] = I;
    f = C(C(C(z[a + 4976 >> 2] - z[Oc(v[a + 4600 >> 2], v[a + 4604 >> 2], v[a + 4620 >> 2]) >> 2]) * z[a + 4436 >> 2]) + z[Oc(v[a + 4600 >> 2], v[a + 4604 >> 2], v[a + 4620 >> 2]) >> 2]);
    z[a + 4976 >> 2] = f;
    h = z[a + 4272 >> 2];
    f = C(C(f * z[a + 4432 >> 2]) + C(e * h));
    H = Oc(v[a + 4600 >> 2], v[a + 4604 >> 2], v[a + 4616 >> 2]), I = C(e - C(h * f)), 
    z[H >> 2] = I;
    A = C(C(e * C(-.15000000596046448)) + C(f * C(-.20000000298023224)));
    if (t[a + 4264 | 0] & 1) {
     e = C(C(C(z[a + 4972 >> 2] - z[Oc(v[a + 4576 >> 2], v[a + 4580 >> 2], v[a + 4596 >> 2]) >> 2]) * z[a + 4428 >> 2]) + z[Oc(v[a + 4576 >> 2], v[a + 4580 >> 2], v[a + 4596 >> 2]) >> 2]);
     z[a + 4972 >> 2] = e;
     h = z[a + 4272 >> 2];
     e = C(C(e * z[a + 4424 >> 2]) + C(f * h));
     H = Oc(v[a + 4576 >> 2], v[a + 4580 >> 2], v[a + 4592 >> 2]), I = C(f - C(h * e)), 
     z[H >> 2] = I;
     f = C(C(C(z[a + 4968 >> 2] - z[Oc(v[a + 4552 >> 2], v[a + 4556 >> 2], v[a + 4572 >> 2]) >> 2]) * z[a + 4420 >> 2]) + z[Oc(v[a + 4552 >> 2], v[a + 4556 >> 2], v[a + 4572 >> 2]) >> 2]);
     z[a + 4968 >> 2] = f;
     h = z[a + 4272 >> 2];
     f = C(C(f * z[a + 4416 >> 2]) + C(e * h));
     H = Oc(v[a + 4552 >> 2], v[a + 4556 >> 2], v[a + 4568 >> 2]), I = C(e - C(h * f)), 
     z[H >> 2] = I;
     A = C(C(C(e * C(.3499999940395355)) + A) + C(f * C(-.3799999952316284)));
    }
    H = Oc(v[a + 4912 >> 2], v[a + 4916 >> 2], v[a + 4928 >> 2]), I = f, z[H >> 2] = I;
    e = C(z[Oc(v[a + 4912 >> 2], v[a + 4916 >> 2], v[a + 4932 >> 2]) >> 2] * z[a + 4496 >> 2]);
    z[a + 5028 >> 2] = C(C(z[a + 5028 >> 2] - e) * z[a + 4500 >> 2]) + e;
    e = C(C(C(z[a + 4964 >> 2] - z[Oc(v[a + 4528 >> 2], v[a + 4532 >> 2], v[a + 4548 >> 2]) >> 2]) * z[a + 4412 >> 2]) + z[Oc(v[a + 4528 >> 2], v[a + 4532 >> 2], v[a + 4548 >> 2]) >> 2]);
    z[a + 4964 >> 2] = e;
    f = z[a + 5028 >> 2];
    k = z[a + 4272 >> 2];
    h = C(C(f * k) + C(e * z[a + 4408 >> 2]));
    H = Oc(v[a + 4528 >> 2], v[a + 4532 >> 2], v[a + 4544 >> 2]), I = C(f - C(k * h)), 
    z[H >> 2] = I;
    e = C(C(C(z[a + 4960 >> 2] - z[Oc(v[a + 4504 >> 2], v[a + 4508 >> 2], v[a + 4524 >> 2]) >> 2]) * z[a + 4404 >> 2]) + z[Oc(v[a + 4504 >> 2], v[a + 4508 >> 2], v[a + 4524 >> 2]) >> 2]);
    z[a + 4960 >> 2] = e;
    f = C(e * z[a + 4400 >> 2]);
    e = z[a + 4272 >> 2];
    k = C(f + C(h * e));
    H = Oc(v[a + 4504 >> 2], v[a + 4508 >> 2], v[a + 4520 >> 2]), I = C(h - C(e * k)), 
    z[H >> 2] = I;
    z[a + 5020 >> 2] = k;
    e = C(C(C(C(C(hi(u, v[a + 4380 >> 2]) * C(.7070000171661377)) + C(hi(u, v[a + 4384 >> 2]) * C(-.6000000238418579))) - C(hi(u, v[a + 4388 >> 2]) * C(.5))) + C(hi(u, v[a + 4392 >> 2]) * C(-.6000000238418579))) - C(hi(u, v[a + 4396 >> 2]) * C(.5)));
    if (t[a + 4264 | 0] & 1) {
     f = e;
     e = C(z[Oc(v[a + 4840 >> 2], v[a + 4844 >> 2], v[a + 4860 >> 2]) >> 2] + C(e * C(.6180340051651001)));
     H = Oc(v[a + 4840 >> 2], v[a + 4844 >> 2], v[a + 4856 >> 2]), I = C(f - C(e * C(.6180340051651001))), 
     z[H >> 2] = I;
    }
    F = z[a + 4280 >> 2];
    f = C(C(C(z[a + 5004 >> 2] - z[Oc(v[a + 4768 >> 2], v[a + 4772 >> 2], v[a + 4788 >> 2]) >> 2]) * z[a + 4492 >> 2]) + z[Oc(v[a + 4768 >> 2], v[a + 4772 >> 2], v[a + 4788 >> 2]) >> 2]);
    z[a + 5004 >> 2] = f;
    G = C(f * z[a + 4488 >> 2]);
    f = C(i - j);
    i = z[a + 4272 >> 2];
    j = C(G + C(f * i));
    H = Oc(v[a + 4768 >> 2], v[a + 4772 >> 2], v[a + 4784 >> 2]), I = C(f - C(i * j)), 
    z[H >> 2] = I;
    f = C(C(C(z[a + 5e3 >> 2] - z[Oc(v[a + 4744 >> 2], v[a + 4748 >> 2], v[a + 4764 >> 2]) >> 2]) * z[a + 4484 >> 2]) + z[Oc(v[a + 4744 >> 2], v[a + 4748 >> 2], v[a + 4764 >> 2]) >> 2]);
    z[a + 5e3 >> 2] = f;
    i = z[a + 4272 >> 2];
    f = C(C(f * z[a + 4480 >> 2]) + C(j * i));
    H = Oc(v[a + 4744 >> 2], v[a + 4748 >> 2], v[a + 4760 >> 2]), I = C(j - C(i * f)), 
    z[H >> 2] = I;
    j = C(C(C(h * C(.3799999952316284)) + C(j * C(-.15000000596046448))) + C(f * C(-.20000000298023224)));
    if (t[a + 4264 | 0] & 1) {
     h = C(C(C(z[a + 4996 >> 2] - z[Oc(v[a + 4720 >> 2], v[a + 4724 >> 2], v[a + 4740 >> 2]) >> 2]) * z[a + 4476 >> 2]) + z[Oc(v[a + 4720 >> 2], v[a + 4724 >> 2], v[a + 4740 >> 2]) >> 2]);
     z[a + 4996 >> 2] = h;
     i = z[a + 4272 >> 2];
     h = C(C(h * z[a + 4472 >> 2]) + C(f * i));
     H = Oc(v[a + 4720 >> 2], v[a + 4724 >> 2], v[a + 4736 >> 2]), I = C(f - C(i * h)), 
     z[H >> 2] = I;
     f = C(C(C(z[a + 4992 >> 2] - z[Oc(v[a + 4696 >> 2], v[a + 4700 >> 2], v[a + 4716 >> 2]) >> 2]) * z[a + 4468 >> 2]) + z[Oc(v[a + 4696 >> 2], v[a + 4700 >> 2], v[a + 4716 >> 2]) >> 2]);
     z[a + 4992 >> 2] = f;
     i = z[a + 4272 >> 2];
     f = C(C(f * z[a + 4464 >> 2]) + C(h * i));
     H = Oc(v[a + 4696 >> 2], v[a + 4700 >> 2], v[a + 4712 >> 2]), I = C(h - C(i * f)), 
     z[H >> 2] = I;
     j = C(C(C(h * C(.3499999940395355)) + j) + C(f * C(-.3799999952316284)));
    }
    n = r + 4 | 0;
    p = q + 4 | 0;
    h = C(g * y);
    A = C(A - C(k * C(.3799999952316284)));
    k = C(e * F);
    H = Oc(v[a + 4936 >> 2], v[a + 4940 >> 2], v[a + 4952 >> 2]), I = f, z[H >> 2] = I;
    g = C(z[Oc(v[a + 4936 >> 2], v[a + 4940 >> 2], v[a + 4956 >> 2]) >> 2] * z[a + 4496 >> 2]);
    z[a + 5032 >> 2] = C(C(z[a + 5032 >> 2] - g) * z[a + 4500 >> 2]) + g;
    g = C(C(C(z[a + 4988 >> 2] - z[Oc(v[a + 4672 >> 2], v[a + 4676 >> 2], v[a + 4692 >> 2]) >> 2]) * z[a + 4460 >> 2]) + z[Oc(v[a + 4672 >> 2], v[a + 4676 >> 2], v[a + 4692 >> 2]) >> 2]);
    z[a + 4988 >> 2] = g;
    e = z[a + 5032 >> 2];
    f = z[a + 4272 >> 2];
    g = C(C(e * f) + C(g * z[a + 4456 >> 2]));
    H = Oc(v[a + 4672 >> 2], v[a + 4676 >> 2], v[a + 4688 >> 2]), I = C(e - C(f * g)), 
    z[H >> 2] = I;
    f = z[a + 4284 >> 2];
    e = C(C(C(z[a + 4984 >> 2] - z[Oc(v[a + 4648 >> 2], v[a + 4652 >> 2], v[a + 4668 >> 2]) >> 2]) * z[a + 4452 >> 2]) + z[Oc(v[a + 4648 >> 2], v[a + 4652 >> 2], v[a + 4668 >> 2]) >> 2]);
    z[a + 4984 >> 2] = e;
    y = z[a + 4272 >> 2];
    e = C(C(e * z[a + 4448 >> 2]) + C(g * y));
    H = Oc(v[a + 4648 >> 2], v[a + 4652 >> 2], v[a + 4664 >> 2]), I = C(g - C(y * e)), 
    z[H >> 2] = I;
    z[a + 5024 >> 2] = e;
    e = C(-e);
    y = z[a + 4288 >> 2];
    E = 4504;
    e: {
     f: {
      while (1) {
       if ((E | 0) == 4960) {
        g: {
         e = C(k + C(C(C(e * C(.3799999952316284)) + j) * y));
         g = C(h + C(C(C(g * C(.3799999952316284)) + A) * f));
         if (!(w[a + 4264 | 0] & 2)) {
          break g;
         }
         break f;
        }
       } else {
        o = a + E | 0;
        B = v[o + 16 >> 2];
        D = B - 1 | 0;
        v[o + 16 >> 2] = D;
        if ((B | 0) <= 0) {
         v[o + 16 >> 2] = D + v[o + 12 >> 2];
        }
        D = v[o + 20 >> 2];
        B = D - 1 | 0;
        v[o + 20 >> 2] = B;
        if ((D | 0) <= 0) {
         v[o + 20 >> 2] = B + v[o + 12 >> 2];
        }
        E = E + 24 | 0;
        continue;
       }
       break;
      }
      z[l >> 2] = C(g + z[a + 5036 >> 2]) * C(.5);
      z[m >> 2] = C(e + z[a + 5040 >> 2]) * C(.5);
      z[a + 5040 >> 2] = e;
      z[a + 5036 >> 2] = g;
      if ((s | 0) == 1) {
       break e;
      }
      s = s - 1 | 0;
      m = m + 4 | 0;
      l = l + 4 | 0;
      n = r + 8 | 0;
      p = q + 8 | 0;
     }
     q = p;
     r = n;
     z[l >> 2] = g;
     z[m >> 2] = e;
     s = s - 1 | 0;
     m = m + 4 | 0;
     l = l + 4 | 0;
     continue;
    }
    break;
   }
   t[a + 5044 | 0] = 1;
  }
  p = a;
  a = v[a + 56 >> 2];
  Hi(p, b, c, Gc(a, 0), Gc(a, 1), d);
 }
}

function Dra(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0;
 e = eb - 368 | 0;
 eb = e;
 g = eb - 32 | 0;
 eb = g;
 d = g + 12 | 0;
 xD(d, b);
 Ln(g + 4 | 0, d);
 v[31601] = 0;
 f = e + 216 | 0;
 R(475, f | 0, v[g + 4 >> 2], v[g + 8 >> 2]);
 b = v[31601];
 v[31601] = 0;
 a: {
  if ((b | 0) != 1) {
   Jc(d);
   eb = g + 32 | 0;
   break a;
  }
  a = M() | 0;
  Jc(g + 12 | 0);
  P(a | 0);
  p();
 }
 v[31601] = 0;
 b = e + 104 | 0;
 R(457, b | 0, v[e + 216 >> 2], v[e + 220 >> 2]);
 g = v[31601];
 v[31601] = 0;
 b: {
  c: {
   d: {
    e: {
     f: {
      g: {
       h: {
        i: {
         j: {
          k: {
           l: {
            m: {
             n: {
              o: {
               p: {
                q: {
                 r: {
                  s: {
                   t: {
                    u: {
                     v: {
                      w: {
                       x: {
                        y: {
                         z: {
                          if ((g | 0) != 1) {
                           v[31601] = 0;
                           g = O(103, e + 228 | 0, b | 0) | 0;
                           d = v[31601];
                           v[31601] = 0;
                           if ((d | 0) == 1) {
                            break z;
                           }
                           sb(b);
                           ec(f);
                           if (c >>> 0 < 2189) {
                            break g;
                           }
                           b = Im(b, g);
                           v[31601] = 0;
                           c = O(461, f | 0, 10124) | 0;
                           d = v[31601];
                           v[31601] = 0;
                           if ((d | 0) == 1) {
                            break x;
                           }
                           v[31601] = 0;
                           v[e + 88 >> 2] = 19989505;
                           v[e + 92 >> 2] = 0;
                           d = e + 88 | 0;
                           R(462, b | 0, c | 0, d | 0);
                           f = v[31601];
                           v[31601] = 0;
                           if ((f | 0) == 1) {
                            break w;
                           }
                           Db(c);
                           t[e + 103 | 0] = 0;
                           v[31601] = 0;
                           c = O(461, d | 0, 11047) | 0;
                           d = v[31601];
                           v[31601] = 0;
                           if ((d | 0) == 1) {
                            break v;
                           }
                           v[31601] = 0;
                           R(463, b | 0, e + 103 | 0, c | 0);
                           d = v[31601];
                           v[31601] = 0;
                           if ((d | 0) == 1) {
                            break u;
                           }
                           Db(c);
                           d = Ec(e + 84 | 0, w[e + 103 | 0] ? 0 : v[a + 1298404 >> 2]);
                           f = v[a + 4 >> 2];
                           v[31601] = 0;
                           c = O(461, e + 72 | 0, 15833) | 0;
                           h = v[31601];
                           v[31601] = 0;
                           if ((h | 0) == 1) {
                            break i;
                           }
                           h = v[d >> 2];
                           v[31601] = 0;
                           U(464, b | 0, f | 0, c | 0, h | 0);
                           f = v[31601];
                           v[31601] = 0;
                           if ((f | 0) == 1) {
                            break t;
                           }
                           Db(c);
                           v[31601] = 0;
                           c = O(461, e + 60 | 0, 15530) | 0;
                           f = v[31601];
                           v[31601] = 0;
                           if ((f | 0) == 1) {
                            break s;
                           }
                           d = v[d >> 2];
                           v[31601] = 0;
                           U(465, b | 0, a | 0, c | 0, d | 0);
                           d = v[31601];
                           v[31601] = 0;
                           if ((d | 0) == 1) {
                            break r;
                           }
                           Db(c);
                           v[31601] = 0;
                           c = O(461, e + 48 | 0, 15363) | 0;
                           d = v[31601];
                           v[31601] = 0;
                           if ((d | 0) == 1) {
                            break q;
                           }
                           v[31601] = 0;
                           d = a + 484360 | 0;
                           R(466, b | 0, d | 0, c | 0);
                           f = v[31601];
                           v[31601] = 0;
                           if ((f | 0) == 1) {
                            break p;
                           }
                           Db(c);
                           v[31601] = 0;
                           c = O(461, e + 36 | 0, 25014) | 0;
                           f = v[31601];
                           v[31601] = 0;
                           if ((f | 0) == 1) {
                            break o;
                           }
                           v[31601] = 0;
                           R(467, b | 0, a + 484344 | 0, c | 0);
                           f = v[31601];
                           v[31601] = 0;
                           if ((f | 0) == 1) {
                            break n;
                           }
                           Db(c);
                           f = v[a + 1298404 >> 2];
                           v[31601] = 0;
                           c = O(461, e + 24 | 0, 25020) | 0;
                           h = v[31601];
                           v[31601] = 0;
                           if ((h | 0) == 1) {
                            break m;
                           }
                           v[31601] = 0;
                           U(468, b | 0, d | 0, c | 0, f | 0);
                           d = v[31601];
                           v[31601] = 0;
                           if ((d | 0) == 1) {
                            break l;
                           }
                           Db(c);
                           if (ol(w[b | 0])) {
                            v[31601] = 0;
                            c = O(1, e + 12 | 0, 16307) | 0;
                            d = v[31601];
                            v[31601] = 0;
                            if ((d | 0) == 1) {
                             break k;
                            }
                            a = v[a + 1298472 >> 2];
                            v[31601] = 0;
                            R(385, a | 0, 1, c | 0);
                            a = v[31601];
                            v[31601] = 0;
                            if ((a | 0) == 1) {
                             break j;
                            }
                            sb(c);
                           }
                           Bh(b);
                           break f;
                          }
                          a = M() | 0;
                          break y;
                         }
                         a = M() | 0;
                         sb(e + 104 | 0);
                        }
                        ec(e + 216 | 0);
                        break b;
                       }
                       a = M() | 0;
                       break h;
                      }
                      a = M() | 0;
                      Db(c);
                      break h;
                     }
                     a = M() | 0;
                     break h;
                    }
                    a = M() | 0;
                    Db(c);
                    break h;
                   }
                   a = M() | 0;
                   Db(c);
                   break h;
                  }
                  a = M() | 0;
                  break h;
                 }
                 a = M() | 0;
                 Db(c);
                 break h;
                }
                a = M() | 0;
                break h;
               }
               a = M() | 0;
               Db(c);
               break h;
              }
              a = M() | 0;
              break h;
             }
             a = M() | 0;
             Db(c);
             break h;
            }
            a = M() | 0;
            break h;
           }
           a = M() | 0;
           Db(c);
           break h;
          }
          a = M() | 0;
          break h;
         }
         a = M() | 0;
         sb(c);
         break h;
        }
        a = M() | 0;
       }
       Bh(b);
       break c;
      }
      b = Eb(e + 104 | 0);
      d = v[a + 1298404 >> 2];
      f = v[a + 4 >> 2];
      v[31601] = 0;
      d = aa(469, f | 0, g | 0, b | 0, d | 0) | 0;
      f = v[31601];
      v[31601] = 0;
      if ((f | 0) == 1) {
       break e;
      }
      A: {
       if ((d | 0) != 1) {
        v[31601] = 0;
        c = O(1, e + 216 | 0, 16613) | 0;
        d = v[31601];
        v[31601] = 0;
        B: {
         if ((d | 0) != 1) {
          a = v[a + 1298472 >> 2];
          v[31601] = 0;
          R(385, a | 0, 1, c | 0);
          a = v[31601];
          v[31601] = 0;
          if ((a | 0) == 1) {
           break B;
          }
          sb(c);
          break A;
         }
         a = M() | 0;
         break d;
        }
        a = M() | 0;
        sb(c);
        break d;
       }
       d = v[a + 1298404 >> 2];
       v[31601] = 0;
       U(470, g | 0, a | 0, d | 0, (c | 0) != 2188 | 0);
       a = v[31601];
       v[31601] = 0;
       if ((a | 0) == 1) {
        break e;
       }
      }
      sb(b);
     }
     Ff(g);
     eb = e + 368 | 0;
     return;
    }
    a = M() | 0;
   }
   sb(b);
  }
  Ff(g);
 }
 P(a | 0);
 p();
}

function Lsa(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, q = 0, r = 0, s = 0, y = 0;
 f = eb - 272 | 0;
 eb = f;
 xc(b);
 e = eb - 16 | 0;
 eb = e;
 g = f + 66 | 0;
 i_(e + 8 | 0, g);
 i = v[e + 12 >> 2];
 ic(e, v[b >> 2], v[b + 8 >> 2], v[e + 8 >> 2], v[e + 12 >> 2]);
 h = v[e + 4 >> 2];
 if ((h | 0) == (i | 0)) {
  Ub(b, v[e + 12 >> 2]);
 }
 eb = e + 16 | 0;
 e = (h | 0) == (i | 0);
 if (!e) {
  h_(g);
 }
 a: {
  if (!e) {
   break a;
  }
  if (!k_(g)) {
   break a;
  }
  if (!Lb(v[b >> 2], v[b + 8 >> 2], Ac(j_(g), gb))) {
   break a;
  }
  d = 1;
  if ((c | 0) == 64) {
   break a;
  }
  Cd(a, 16777216);
  dg(a);
  v[a + 480208 >> 2] = v[a + 480208 >> 2] | 16777216;
  d = f + 44 | 0;
  sr(d, 32);
  g = v[f + 56 >> 2];
  e = a + 1074320 | 0;
  v[e >> 2] = v[f + 52 >> 2];
  v[e + 4 >> 2] = g;
  e = v[f + 48 >> 2];
  v[a + 1074312 >> 2] = v[f + 44 >> 2];
  v[a + 1074316 >> 2] = e;
  Kb(a + 1074312 | 0, 114, 1);
  s = a, y = Ab(w[f + 266 | 0] | w[f + 267 | 0] << 8), u[s + 480188 >> 1] = y;
  Th(a, 1);
  e = tc(d, 8541);
  yb(a + 1298368 | 0, e);
  sb(e);
  e = f + 24 | 0;
  fg(e, 3924);
  v[31601] = 0;
  R(370, d | 0, e | 0, w[f + 69 | 0]);
  g = v[31601];
  v[31601] = 0;
  b: {
   c: {
    d: {
     e: {
      if ((g | 0) != 1) {
       yb(a + 1298344 | 0, d);
       sb(d);
       Db(e);
       g = tc(d, 10789);
       yb(a + 1298356 | 0, g);
       sb(g);
       s = a, y = v[Ec(d, 26) >> 2], v[s + 1298404 >> 2] = y;
       Ue(e, 3, f + 70 | 0);
       Bc(d, e);
       yb(a + 1298308 | 0, d);
       sb(d);
       g = f + 102 | 0;
       e = 160;
       while (1) {
        f: {
         d = e;
         if (!d) {
          d = 0;
          break f;
         }
         e = d - 1 | 0;
         if (w[g + e | 0] == 32) {
          continue;
         }
        }
        break;
       }
       g_(a + 1298332 | 0, g, d, 4);
       d = Ab(w[f + 262 | 0] | w[f + 263 | 0] << 8);
       u[a + 480190 >> 1] = d;
       n = a + 946304 | 0;
       o = a + 484380 | 0;
       h = 1;
       while (1) {
        g: {
         e = h & 65535;
         if (e >>> 0 > (d & 65535) >>> 0) {
          $e(Wb(v[a + 484360 >> 2], w[a + 484376 | 0]), Ab(w[f + 270 | 0] | w[f + 271 | 0] << 8));
          d = f + 24 | 0;
          ge(d, b, 512);
          i = gc(f + 44 | 0, d);
          tb(d);
          d = w[a + 484376 | 0];
          e = v[a + 484360 >> 2];
          g = w[f + 268 | 0] | w[f + 269 | 0] << 8;
          v[31601] = 0;
          R(276, Wb(e, d) | 0, i | 0, Ab(g) | 0);
          d = v[31601];
          v[31601] = 0;
          if ((d | 0) != 1) {
           break g;
          }
          d = M() | 0;
          break d;
         }
         d = B(e, 104) + o | 0;
         md(d, 1);
         ep(d);
         A$(b, n + (e << 5) | 0, w[f + 69 | 0] == 1 ? 32 : 28);
         l = 1;
         e = w[f + 69 | 0];
         if (e >>> 0 >= 3) {
          Ub(b, 14);
          e = OD(b);
          if ((e | 0) >= 0) {
           u[d + 34 >> 1] = x[d + 34 >> 1] | 32;
           s = d, y = Ac((((e & 65535) << 8) + 2047 >>> 0) / 4095 | 0, 0), u[s + 28 >> 1] = y;
          }
          e = w[f + 69 | 0];
         }
         if ((e & 255) >>> 0 >= 2) {
          l = Mk(b);
          s = d, y = Mk(b), v[s + 24 >> 2] = y;
         }
         g = f + 44 | 0;
         i = eb - 16 | 0;
         eb = i;
         h: {
          if (!Lb(v[b >> 2], v[b + 8 >> 2], 12)) {
           v[i >> 2] = 0;
           e = g;
           k = 3;
           while (1) {
            if (k) {
             m = w[i | 0] | w[i + 1 | 0] << 8 | (w[i + 2 | 0] << 16 | w[i + 3 | 0] << 24);
             t[e | 0] = m;
             t[e + 1 | 0] = m >>> 8;
             t[e + 2 | 0] = m >>> 16;
             t[e + 3 | 0] = m >>> 24;
             k = k - 1 | 0;
             e = e + 4 | 0;
             continue;
            }
            break;
           }
           break h;
          }
          zr(i + 8 | 0, g);
          rd(i, b, v[i + 8 >> 2], v[i + 12 >> 2]);
         }
         eb = i + 16 | 0;
         i = fc(g);
         e = zb(g);
         k = _b(v[f + 44 >> 2]);
         v[d >> 2] = k;
         g = _b(w[i | 0] | w[i + 1 | 0] << 8 | (w[i + 2 | 0] << 16 | w[i + 3 | 0] << 24));
         v[d + 4 >> 2] = g;
         i = _b(w[e | 0] | w[e + 1 | 0] << 8 | (w[e + 2 | 0] << 16 | w[e + 3 | 0] << 24)) + g | 0;
         v[d + 8 >> 2] = i;
         i: {
          j: {
           if (!g) {
            if (_b(w[e | 0] | w[e + 1 | 0] << 8 | (w[e + 2 | 0] << 16 | w[e + 3 | 0] << 24)) >>> 0 < 3) {
             break j;
            }
           }
           e = x[d + 34 >> 1] | 2;
           break i;
          }
          e = x[d + 34 >> 1] & -3;
         }
         u[d + 34 >> 1] = e;
         if ((l | 0) == 2) {
          v[d + 8 >> 2] = i >>> 1;
          v[d + 4 >> 2] = g >>> 1;
          v[d >> 2] = k >>> 1;
          u[d + 34 >> 1] = e | 1;
         }
         s = d, y = Mk(b), u[s + 30 >> 1] = y;
         e = OD(b);
         if (e) {
          Yl(d, +(e | 0) / 96);
         }
         t[d + 37 | 0] = e << 4;
         h = h + 1 | 0;
         d = x[a + 480190 >> 1];
         continue;
        }
        break;
       }
       d = vb(v[Wb(v[a + 484360 >> 2], w[a + 484376 | 0]) >> 2]);
       g = vb(v[Wb(v[a + 484360 >> 2], w[a + 484376 | 0]) + 4 >> 2]);
       e = eb - 16 | 0;
       eb = e;
       k: {
        if (!Hb(d, g)) {
         break k;
        }
        v[e + 12 >> 2] = d;
        while (1) {
         h = v[fe(e + 12 | 0) >> 2];
         if (!Hb(h, g)) {
          break k;
         }
         d = Wk(x[d >> 1], x[h >> 1]) ? h : d;
         continue;
        }
       }
       eb = e + 16 | 0;
       d = x[d >> 1];
       v[31601] = 0;
       m = a + 484344 | 0;
       q = d + 1 & 65535;
       N(223, m | 0, q | 0);
       d = v[31601];
       v[31601] = 0;
       if ((d | 0) == 1) {
        break e;
       }
       d = w[f + 69 | 0];
       v[f + 20 >> 2] = v[a + 480204 >> 2];
       v[f + 16 >> 2] = v[a + 480196 >> 2];
       n = d >>> 0 < 4 ? 4 : 5;
       r = c & 1;
       e = 0;
       while (1) {
        if ((e | 0) == (q | 0)) {
         if (!(c & 2)) {
          break b;
         }
         d = 1;
         while (1) {
          c = d & 65535;
          if (c >>> 0 > x[a + 480190 >> 1]) {
           break b;
          }
          c = B(c, 104) + o | 0;
          e = Yc(f + 8 | 0, u[c + 34 >> 1] & 1 ? 16 : 8, 1, 1, 0);
          v[31601] = 0;
          T(215, e | 0, c | 0, b | 0) | 0;
          c = v[31601];
          v[31601] = 0;
          if ((c | 0) != 1) {
           d = d + 1 | 0;
           continue;
          }
          break;
         }
         d = M() | 0;
         break d;
        }
        l: {
         if (!r) {
          break l;
         }
         d = w[f + 264 | 0] | w[f + 265 | 0] << 8;
         g = v[b + 8 >> 2];
         h = v[b >> 2];
         l = x[a + 480188 >> 1];
         v[31601] = 0;
         d = T(150, h | 0, g | 0, B(l, B(Ab(d), n)) | 0) | 0;
         g = v[31601];
         v[31601] = 0;
         m: {
          n: {
           if ((g | 0) == 1) {
            break n;
           }
           if (!d) {
            break l;
           }
           d = w[f + 264 | 0] | w[f + 265 | 0] << 8;
           v[31601] = 0;
           d = T(196, m | 0, e & 65535, Ab(d) | 0) | 0;
           g = v[31601];
           v[31601] = 0;
           if ((g | 0) == 1) {
            break n;
           }
           if (!d) {
            break l;
           }
           d = x[a + 480188 >> 1];
           t[f | 0] = 0;
           g = de(f + 8 | 0, 0, f);
           v[31601] = 0;
           k = T(371, f + 24 | 0, d | 0, g | 0) | 0;
           d = v[31601];
           v[31601] = 0;
           if ((d | 0) == 1) {
            break m;
           }
           l = 0;
           o: while (1) {
            if (Ab(w[f + 264 | 0] | w[f + 265 | 0] << 8) >>> 0 <= l >>> 0) {
             nd(k);
             break l;
            }
            d = Vb(v[m >> 2], e);
            af(f + 8 | 0, v[d >> 2], v[v[d + 48 >> 2] + 12 >> 2], l);
            d = 0;
            while (1) {
             if (x[a + 480188 >> 1] <= d >>> 0) {
              l = l + 1 | 0;
              continue o;
             }
             g = Xc(v[f + 8 >> 2], d);
             t[f + 4 | 0] = 0;
             v[31601] = 0;
             v[f >> 2] = 0;
             R(372, b | 0, f | 0, n | 0);
             h = v[31601];
             v[31601] = 0;
             p: {
              if ((h | 0) == 1) {
               break p;
              }
              h = v[k >> 2];
              j = w[f | 0];
              if ((j - 24 & 255) >>> 0 <= 59) {
               j = j + 13 | 0;
               t[g | 0] = j;
               s = $b(h, d), y = j, t[s | 0] = y;
              }
              j = w[f + 1 | 0];
              q: {
               if (!j) {
                h = $b(h, d);
                break q;
               }
               t[g + 1 | 0] = j;
               h = $b(h, d);
               t[h + 1 | 0] = j;
              }
              j = w[h + 1 | 0];
              h = w[h | 0];
              v[31601] = 0;
              xa(373, a | 0, g | 0, w[f + 2 | 0], w[f + 3 | 0], 0 - w[f + 69 | 0] | 0, h | 0, j | 0, f + 20 | 0, f + 16 | 0);
              h = v[31601];
              v[31601] = 0;
              if ((h | 0) == 1) {
               break p;
              }
              h = w[f + 4 | 0];
              if (h) {
               t[g + 2 | 0] = 1;
               t[g + 4 | 0] = h + 1 >>> 2;
              }
              d = d + 1 | 0;
              continue;
             }
             break;
            }
            break;
           }
           d = M() | 0;
           nd(k);
           break d;
          }
          d = M() | 0;
          break d;
         }
         d = M() | 0;
         break d;
        }
        e = e + 1 | 0;
        continue;
       }
      }
      d = M() | 0;
      Db(f + 24 | 0);
      break c;
     }
     d = M() | 0;
    }
    tb(i);
   }
   P(d | 0);
   p();
  }
  tb(i);
  d = 1;
 }
 eb = f + 272 | 0;
 return d | 0;
}

function $s(a, b, c, d) {
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
 e = eb - 160 | 0;
 eb = e;
 v[e + 148 >> 2] = -1;
 v[e + 140 >> 2] = 6;
 v[e + 144 >> 2] = 364;
 v[e + 132 >> 2] = 11;
 v[e + 136 >> 2] = 161;
 v[e + 124 >> 2] = 23;
 v[e + 128 >> 2] = 31;
 v[e + 116 >> 2] = 59;
 v[e + 120 >> 2] = 55;
 v[e + 152 >> 2] = 0;
 v[e + 156 >> 2] = 0;
 t[e + 14 | 0] = c;
 t[e + 13 | 0] = 37;
 t[e + 15 | 0] = 0;
 l = b + 484 | 0;
 j = b + 460 | 0;
 i = b + 172 | 0;
 k = b + 4 | 0;
 f = e + 16 | 0;
 h = f + (ea(f | 0, 100, e + 13 | 0, e + 116 | 0, v[b >> 2]) | 0) | 0;
 v[e + 8 >> 2] = f;
 g = Eb(a);
 m = (c | 0) != 120;
 a: while (1) {
  b: {
   c: {
    d: {
     e: {
      f: {
       g: {
        h: {
         i: {
          j: {
           k: {
            l: {
             m: {
              n: {
               o: {
                if ((f | 0) != (h | 0)) {
                 if (If(v[d + 8 >> 2], 1, t[f | 0])) {
                  v[31601] = 0;
                  N(115, g | 0, 32);
                  a = v[31601];
                  v[31601] = 0;
                  if ((a | 0) == 1) {
                   break c;
                  }
                  a = v[d + 8 >> 2];
                  while (1) {
                   f = f + 1 | 0;
                   if ((h | 0) == (f | 0)) {
                    f = h;
                    break b;
                   }
                   if (If(a, 1, t[f | 0])) {
                    continue;
                   }
                   break;
                  }
                  break b;
                 }
                 v[e + 4 >> 2] = f;
                 v[31601] = 0;
                 v[e >> 2] = 0;
                 a = da(1382, e + 4 | 0, h | 0, k | 0, i | 0, d | 0, e | 0) | 0;
                 c = v[31601];
                 v[31601] = 0;
                 if ((c | 0) == 1) {
                  break c;
                 }
                 p: {
                  a = a - k | 0;
                  q: {
                   if ((a | 0) <= 167) {
                    v[31601] = 0;
                    N(115, g | 0, 37);
                    c = v[31601];
                    v[31601] = 0;
                    if ((c | 0) == 1) {
                     break c;
                    }
                    v[31601] = 0;
                    N(115, g | 0, ((a | 0) < 84 ? 65 : 97) | 0);
                    a = v[31601];
                    v[31601] = 0;
                    if ((a | 0) != 1) {
                     break q;
                    }
                    break c;
                   }
                   v[31601] = 0;
                   v[e + 4 >> 2] = f;
                   a = da(1382, e + 4 | 0, h | 0, i | 0, j | 0, d | 0, e | 0) | 0;
                   c = v[31601];
                   v[31601] = 0;
                   if ((c | 0) == 1) {
                    break c;
                   }
                   a = a - i | 0;
                   c = (a | 0) / 12 | 0;
                   if ((a | 0) <= 287) {
                    v[31601] = 0;
                    N(115, g | 0, 37);
                    f = v[31601];
                    v[31601] = 0;
                    if ((f | 0) == 1) {
                     break c;
                    }
                    v[31601] = 0;
                    N(115, g | 0, ((a | 0) < 144 ? 66 : 98) | 0);
                    a = v[31601];
                    v[31601] = 0;
                    if ((a | 0) == 1) {
                     break c;
                    }
                    if (m) {
                     break q;
                    }
                    if (!If(v[d + 8 >> 2], 64, t[dc(B(c, 12) + i | 0, 0) | 0])) {
                     break q;
                    }
                    n = zz(g), o = 109, t[n | 0] = o;
                    break q;
                   }
                   if ((Cb(v[b + 464 >> 2], w[b + 471 | 0]) | 0) == (0 - Cb(v[b + 476 >> 2], w[b + 483 | 0]) | 0)) {
                    break p;
                   }
                   v[31601] = 0;
                   v[e + 4 >> 2] = f;
                   a = da(1382, e + 4 | 0, h | 0, j | 0, l | 0, d | 0, e | 0) | 0;
                   c = v[31601];
                   v[31601] = 0;
                   if ((c | 0) == 1) {
                    break c;
                   }
                   if ((a - j | 0) > 23) {
                    break p;
                   }
                   v[31601] = 0;
                   N(115, g | 0, 37);
                   a = v[31601];
                   v[31601] = 0;
                   if ((a | 0) == 1) {
                    break c;
                   }
                   v[31601] = 0;
                   N(115, g | 0, 112);
                   a = v[31601];
                   v[31601] = 0;
                   if ((a | 0) == 1) {
                    break c;
                   }
                  }
                  f = v[e + 4 >> 2];
                  break b;
                 }
                 v[e + 4 >> 2] = f;
                 a = t[f | 0];
                 if (If(v[d + 8 >> 2], 64, a)) {
                  v[31601] = 0;
                  a = aa(1383, e + 8 | 0, h | 0, e | 0, d | 0) | 0;
                  c = v[31601];
                  v[31601] = 0;
                  if ((c | 0) == 1) {
                   break c;
                  }
                  r: {
                   s: {
                    switch (a - 6 | 0) {
                    case 2:
                    case 3:
                    case 4:
                     break r;

                    case 0:
                     break e;

                    case 1:
                     break f;

                    case 5:
                     break g;

                    case 6:
                     break h;

                    default:
                     break s;
                    }
                   }
                   t: {
                    switch (a - 55 | 0) {
                    case 0:
                     break k;

                    case 4:
                     break l;

                    case 6:
                     break m;

                    case 1:
                    case 2:
                    case 3:
                    case 5:
                     break r;

                    default:
                     break t;
                    }
                   }
                   if ((a | 0) == 23) {
                    break i;
                   }
                   if ((a | 0) == 31) {
                    break j;
                   }
                   if ((a | 0) == 364) {
                    break n;
                   }
                   if ((a | 0) == 2061) {
                    break o;
                   }
                  }
                  a = v[e + 8 >> 2];
                  while (1) {
                   if ((a | 0) == (f | 0)) {
                    f = a;
                    continue a;
                   }
                   c = t[f | 0];
                   v[31601] = 0;
                   N(115, g | 0, c | 0);
                   c = v[31601];
                   v[31601] = 0;
                   if ((c | 0) == 1) {
                    break c;
                   }
                   f = f + 1 | 0;
                   continue;
                  }
                 }
                 u: {
                  if ((a | 0) == 37) {
                   v[31601] = 0;
                   N(115, g | 0, 37);
                   a = v[31601];
                   v[31601] = 0;
                   if ((a | 0) == 1) {
                    break c;
                   }
                   v[31601] = 0;
                   N(115, g | 0, 37);
                   break u;
                  }
                  v[31601] = 0;
                  N(115, g | 0, a | 0);
                 }
                 a = v[31601];
                 v[31601] = 0;
                 if ((a | 0) == 1) {
                  break c;
                 }
                 f = f + 1 | 0;
                 break b;
                }
                eb = e + 160 | 0;
                return;
               }
               v[31601] = 0;
               N(115, g | 0, 37);
               a = v[31601];
               v[31601] = 0;
               c = 89;
               break d;
              }
              v[31601] = 0;
              N(115, g | 0, 37);
              a = v[31601];
              v[31601] = 0;
              c = 106;
              break d;
             }
             v[31601] = 0;
             N(115, g | 0, 37);
             a = v[31601];
             v[31601] = 0;
             c = 121;
             break d;
            }
            v[31601] = 0;
            N(115, g | 0, 37);
            a = v[31601];
            v[31601] = 0;
            c = 83;
            break d;
           }
           v[31601] = 0;
           N(115, g | 0, 37);
           a = v[31601];
           v[31601] = 0;
           c = 77;
           break d;
          }
          v[31601] = 0;
          N(115, g | 0, 37);
          a = v[31601];
          v[31601] = 0;
          c = 100;
          break d;
         }
         v[31601] = 0;
         N(115, g | 0, 37);
         a = v[31601];
         v[31601] = 0;
         c = 72;
         break d;
        }
        v[31601] = 0;
        N(115, g | 0, 37);
        a = v[31601];
        v[31601] = 0;
        c = 109;
        break d;
       }
       v[31601] = 0;
       N(115, g | 0, 37);
       a = v[31601];
       v[31601] = 0;
       c = 73;
       break d;
      }
      v[31601] = 0;
      N(115, g | 0, 37);
      a = v[31601];
      v[31601] = 0;
      c = 117;
      break d;
     }
     v[31601] = 0;
     N(115, g | 0, 37);
     a = v[31601];
     v[31601] = 0;
     c = 119;
    }
    if ((a | 0) == 1) {
     break c;
    }
    v[31601] = 0;
    N(115, g | 0, c | 0);
    a = v[31601];
    v[31601] = 0;
    if ((a | 0) == 1) {
     break c;
    }
    f = v[e + 8 >> 2];
    continue;
   }
   a = M() | 0;
   sb(g);
   P(a | 0);
   p();
  }
  v[e + 8 >> 2] = f;
  continue;
 }
}

function Mia(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = C(0), m = 0, n = 0, o = 0, q = 0, r = 0;
 d = eb - 80 | 0;
 eb = d;
 h = -1;
 a: {
  b: {
   c: {
    d: {
     if (v[(v[v[b >> 2] - 12 >> 2] + b | 0) + 16 >> 2]) {
      break d;
     }
     $d(d - -64 | 0, b);
     e = v[d + 72 >> 2];
     g = v[d + 76 >> 2];
     f = d + 56 | 0;
     Zk(f);
     b = uj(b, f, 8);
     if ((w[d + 56 | 0] | w[d + 57 | 0] << 8 | (w[d + 58 | 0] << 16 | w[d + 59 | 0] << 24)) != 1414681667 | (w[d + 60 | 0] | w[d + 61 | 0] << 8 | (w[d + 62 | 0] << 16 | w[d + 63 | 0] << 24)) != 776101705) {
      Ci(b, e, g, 0);
      break d;
     }
     u[d + 54 >> 1] = 0;
     mg(b, d + 54 | 0);
     k = u[d + 54 >> 1];
     if ((k - 4 & 65535) >>> 0 < 65534) {
      break d;
     }
     e = d + 46 | 0;
     Zk(e);
     e = uj(b, e, 8);
     if ((w[d + 46 | 0] | w[d + 47 | 0] << 8 | (w[d + 48 | 0] << 16 | w[d + 49 | 0] << 24)) != 1933333571 | (w[d + 50 | 0] | w[d + 51 | 0] << 8 | (w[d + 52 | 0] << 16 | w[d + 53 | 0] << 24)) != 1111389030) {
      break d;
     }
     u[d + 44 >> 1] = 0;
     mg(e, d + 44 | 0);
     g = u[d + 44 >> 1];
     if ((g - 5 & 65535) >>> 0 < 65534) {
      break d;
     }
     e: {
      f: {
       g: {
        h: {
         i: {
          j: {
           if (g >>> 0 <= 3) {
            b = Eb(d - -64 | 0);
            v[31601] = 0;
            f = T(495, e | 0, b | 0, 65535) | 0;
            i = v[31601];
            v[31601] = 0;
            if ((i | 0) == 1) {
             break b;
            }
            if (!f) {
             break i;
            }
            v[31601] = 0;
            f = d + 32 | 0;
            R(496, f | 0, c | 0, b | 0);
            i = v[31601];
            v[31601] = 0;
            if ((i | 0) != 1) {
             break j;
            }
            break b;
           }
           b = Eb(d - -64 | 0);
           v[31601] = 0;
           f = O(498, e | 0, b | 0) | 0;
           i = v[31601];
           v[31601] = 0;
           if ((i | 0) == 1) {
            break c;
           }
           if (!f) {
            break h;
           }
           v[31601] = 0;
           f = d + 32 | 0;
           R(496, f | 0, c | 0, b | 0);
           i = v[31601];
           v[31601] = 0;
           if ((i | 0) == 1) {
            break c;
           }
          }
          yb(a + 40 | 0, f);
          sb(f);
          sb(b);
          u[d + 30 >> 1] = 0;
          mg(e, d + 30 | 0);
          u[d + 28 >> 1] = 0;
          mg(e, d + 28 | 0);
          u[a >> 1] = x[d + 28 >> 1];
          u[d + 26 >> 1] = 0;
          k: {
           if ((g | 0) <= 3) {
            v[d + 64 >> 2] = 0;
            Ek(e, d - -64 | 0);
            b = v[d + 64 >> 2];
            if (b >>> 0 > 65535) {
             break d;
            }
            b = $l(b);
            u[d + 26 >> 1] = b;
            break k;
           }
           mg(e, d + 26 | 0);
           b = x[d + 26 >> 1];
          }
          i = a + 52 | 0;
          m = b & 65535;
          n = (g | 0) > 3;
          b = 0;
          l: {
           m: {
            while (1) {
             if ((b & 65535) >>> 0 >= m >>> 0) {
              break l;
             }
             g = Eb(d - -64 | 0);
             v[31601] = 0;
             u[d + 8 >> 1] = 0;
             N(933, e | 0, d + 8 | 0);
             f = v[31601];
             v[31601] = 0;
             if ((f | 0) == 1) {
              break g;
             }
             n: {
              if (!n) {
               v[31601] = 0;
               f = T(495, e | 0, g | 0, 65535) | 0;
               j = v[31601];
               v[31601] = 0;
               if ((j | 0) == 1) {
                break g;
               }
               if (f) {
                break n;
               }
               break e;
              }
              v[31601] = 0;
              f = O(498, e | 0, g | 0) | 0;
              j = v[31601];
              v[31601] = 0;
              if ((j | 0) == 1) {
               break g;
              }
              if (!f) {
               break e;
              }
             }
             v[31601] = 0;
             f = d + 32 | 0;
             R(496, f | 0, c | 0, g | 0);
             j = v[31601];
             v[31601] = 0;
             if ((j | 0) != 1) {
              v[31601] = 0;
              j = O(930, i | 0, d + 8 | 0) | 0;
              o = v[31601];
              v[31601] = 0;
              if ((o | 0) == 1) {
               break m;
              }
              yb(j, f);
              sb(f);
              sb(g);
              b = b + 1 | 0;
              continue;
             }
             break;
            }
            h = M() | 0;
            break f;
           }
           h = M() | 0;
           sb(d + 32 | 0);
           break f;
          }
          b = d + 32 | 0;
          Zk(b);
          b = uj(e, b, 8);
          if ((w[d + 32 | 0] | w[d + 33 | 0] << 8 | (w[d + 34 | 0] << 16 | w[d + 35 | 0] << 24)) != 1933333571 | (w[d + 36 | 0] | w[d + 37 | 0] << 8 | (w[d + 38 | 0] << 16 | w[d + 39 | 0] << 24)) != 1161720678) {
           break d;
          }
          c = x[a >> 1];
          if (c >>> 0 > 3 | (c | 0) == 2) {
           break d;
          }
          c = a + 4 | 0;
          o: {
           if ((k | 0) <= 2) {
            if (OQ(b, c)) {
             break o;
            }
            break d;
           }
           if (!NQ(b, c)) {
            break d;
           }
          }
          q = d, r = vb(v[a + 4 >> 2]), v[q + 64 >> 2] = r;
          c = vb(v[a + 8 >> 2]);
          while (1) {
           e = v[d + 64 >> 2];
           if (Hb(e, c)) {
            if (!Tm(z[e >> 2])) {
             break d;
            }
            Xe(d - -64 | 0);
            continue;
           }
           break;
          }
          c = a + 16 | 0;
          p: {
           if ((k | 0) <= 2) {
            if (OQ(b, c)) {
             break p;
            }
            break d;
           }
           if (!NQ(b, c)) {
            break d;
           }
          }
          q = d, r = vb(v[a + 16 >> 2]), v[q + 64 >> 2] = r;
          c = vb(v[a + 20 >> 2]);
          while (1) {
           e = v[d + 64 >> 2];
           if (Hb(e, c)) {
            if (!Tm(z[e >> 2])) {
             break d;
            }
            Xe(d - -64 | 0);
            continue;
           }
           break;
          }
          q = a, r = nc(v[a + 16 >> 2], v[a + 20 >> 2]), v[q + 36 >> 2] = r;
          u[d + 24 >> 1] = 0;
          mg(b, d + 24 | 0);
          c = x[d + 24 >> 1];
          u[a + 28 >> 1] = c;
          if ((c - 201 & 65535) >>> 0 < 65135) {
           break d;
          }
          u[d + 22 >> 1] = 0;
          mg(b, d + 22 | 0);
          c = u[d + 22 >> 1];
          u[a + 30 >> 1] = c;
          if ((c | 0) < 0) {
           break d;
          }
          v[d + 16 >> 2] = 0;
          wq(b, d + 16 | 0);
          l = QQ(z[d + 16 >> 2]);
          z[a + 32 >> 2] = l;
          if (!Tm(l)) {
           break d;
          }
          v[d + 8 >> 2] = 0;
          v[d + 12 >> 2] = 0;
          c = eb - 32 | 0;
          eb = c;
          e = d + 8 | 0;
          Yk(c + 16 | 0, e);
          Lm(c + 24 | 0, b, v[c + 16 >> 2], v[c + 20 >> 2]);
          Yk(c + 8 | 0, e);
          eb = c + 32 | 0;
          if (v[d + 8 >> 2] != 1414681667 | v[d + 12 >> 2] != 776298313) {
           break d;
          }
          b = nc(v[a + 4 >> 2], v[a + 8 >> 2]);
          if (b >>> 0 > 32767) {
           break d;
          }
          c = u[a + 30 >> 1];
          e = x[a >> 1];
          if (!(e ? !(z[a + 32 >> 2] <= C(0)) & (c | 0) > 0 : 1)) {
           break d;
          }
          q: {
           switch (e - 1 | 0) {
           case 0:
           case 2:
            if (b >>> 0 < c >>> 0) {
             break d;
            }
            break;

           default:
            break q;
           }
          }
          b = 0;
          c = v[a + 36 >> 2];
          if (c) {
           b = c - 1 | 0;
           v[a + 36 >> 2] = b;
          }
          q = d, r = th(b), v[q + 64 >> 2] = r;
          v[d + 4 >> 2] = 0;
          b = d - -64 | 0;
          q = a, r = v[Yj(b, d + 4 | 0, 42192) >> 2], v[q + 36 >> 2] = r;
          xq(a);
          h = 1;
          if (x[a >> 1] != 3) {
           break d;
          }
          c = u[a + 30 >> 1];
          if ((c - u[a + 28 >> 1] | 0) > (XQ(nc(v[a + 4 >> 2], v[a + 8 >> 2])) | 0)) {
           break d;
          }
          h = a + 32 | 0;
          e = Mb(b);
          b = 0;
          while (1) {
           r: {
            if (c << 16 >> 16 <= (b | 0)) {
             b = x[a + 28 >> 1];
             u[d + 4 >> 1] = b;
             q = d, r = (nc(v[a + 4 >> 2], v[a + 8 >> 2]) + b | 0) - 1 | 0, u[q + 6 >> 1] = r;
             v[31601] = 0;
             u[d + 2 >> 1] = 0;
             ga(928, a | 0, e | 0, h | 0, d + 4 | 0, d + 2 | 0) | 0;
             a = v[31601];
             v[31601] = 0;
             h = 1;
             if ((a | 0) == 1) {
              break r;
             }
             uc(e);
             break d;
            }
            c = u[a + 28 >> 1];
            g = v[a + 4 >> 2];
            v[31601] = 0;
            N(934, e | 0, xb(g, b - c | 0) | 0);
            c = v[31601];
            v[31601] = 0;
            if ((c | 0) != 1) {
             b = b + 1 | 0;
             c = x[a + 30 >> 1];
             continue;
            }
           }
           break;
          }
          h = M() | 0;
          uc(e);
          break a;
         }
         sb(b);
         break d;
        }
        sb(b);
        break d;
       }
       h = M() | 0;
      }
      sb(g);
      break a;
     }
     sb(g);
    }
    eb = d + 80 | 0;
    return h | 0;
   }
   h = M() | 0;
   sb(b);
   break a;
  }
  h = M() | 0;
  sb(b);
 }
 P(h | 0);
 p();
}

function OR(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
 j = eb - 16 | 0;
 eb = j;
 a: {
  b: {
   c: {
    if (!Tc(c) | !d | v[b + 480180 >> 2] != 16777216 | x[b + 480192 >> 1] < d >>> 0) {
     break c;
    }
    d = v[((d << 2) + b | 0) + 900380 >> 2];
    if (!d) {
     break c;
    }
    d = v[d + 44 >> 2];
    if (!d) {
     break c;
    }
    u[j + 14 >> 1] = c - 61;
    b = eb + -64 | 0;
    eb = b;
    d: {
     e: {
      e = u[d + 28 >> 1];
      i = j + 14 | 0;
      c = u[i >> 1];
      if ((e | 0) <= (c | 0)) {
       if ((c | 0) <= (nc(v[d + 4 >> 2], v[d + 8 >> 2]) + e | 0) - 1 << 16 >> 16) {
        break e;
       }
      }
      Eb(a);
      break d;
     }
     f: {
      e = u[d + 30 >> 1];
      if (!e) {
       c = d + 52 | 0;
       d = kA(c, i);
       if (!Yg(d, Of(c))) {
        break f;
       }
       tm(a, td(d) + 4 | 0);
       break d;
      }
      e = jA(c, e);
      u[b + 62 >> 1] = e;
      c = Eb(a);
      g: {
       h: {
        i: {
         j: {
          k: {
           l: {
            m: {
             n: {
              o: {
               p: {
                q: {
                 r: {
                  s: {
                   a = d + 52 | 0;
                   f = kA(a, b + 62 | 0);
                   t: {
                    if (Yg(f, Of(a))) {
                     v[31601] = 0;
                     N(129, c | 0, td(f) + 4 | 0);
                     a = v[31601];
                     v[31601] = 0;
                     if ((a | 0) == 1) {
                      break t;
                     }
                     a = u[d + 30 >> 1];
                     d = u[i >> 1];
                     v[31601] = 0;
                     n = b, o = iA(d, a) + 5 | 0, v[n + 36 >> 2] = o;
                     a = b + 48 | 0;
                     N(126, a | 0, b + 36 | 0);
                     d = v[31601];
                     v[31601] = 0;
                     u: {
                      if ((d | 0) != 1) {
                       v[31601] = 0;
                       O(74, c | 0, a | 0) | 0;
                       d = v[31601];
                       v[31601] = 0;
                       if ((d | 0) == 1) {
                        break u;
                       }
                       sb(a);
                       break d;
                      }
                      a = M() | 0;
                      break g;
                     }
                     a = M() | 0;
                     sb(b + 48 | 0);
                     break g;
                    }
                    if (u[d + 30 >> 1] > 26) {
                     break q;
                    }
                    v[31601] = 0;
                    e = T(541, b + 36 | 0, 1, e + 65 << 24 >> 24) | 0;
                    a = v[31601];
                    v[31601] = 0;
                    if ((a | 0) == 1) {
                     break s;
                    }
                    v[31601] = 0;
                    a = b + 48 | 0;
                    R(601, a | 0, 0, e | 0);
                    f = v[31601];
                    v[31601] = 0;
                    if ((f | 0) == 1) {
                     break r;
                    }
                    f = yb(c, a);
                    sb(a);
                    sb(e);
                    v[31601] = 0;
                    O(127, f | 0, 14629) | 0;
                    a = v[31601];
                    v[31601] = 0;
                    if ((a | 0) != 1) {
                     break p;
                    }
                   }
                   a = M() | 0;
                   break g;
                  }
                  a = M() | 0;
                  break g;
                 }
                 a = M() | 0;
                 sb(e);
                 break g;
                }
                v[31601] = 0;
                g = e << 16 >> 16;
                a = (g | 0) / 16 | 0;
                v[b + 32 >> 2] = e - (a << 4) << 16 >> 16;
                e = b + 36 | 0;
                N(879, e | 0, b + 32 | 0);
                f = v[31601];
                v[31601] = 0;
                if ((f | 0) == 1) {
                 break o;
                }
                v[31601] = 0;
                v[b + 16 >> 2] = (a << 16 >> 16) % 16;
                a = b + 20 | 0;
                N(879, a | 0, b + 16 | 0);
                f = v[31601];
                v[31601] = 0;
                if ((f | 0) == 1) {
                 break n;
                }
                v[31601] = 0;
                f = b + 48 | 0;
                R(2, f | 0, e | 0, a | 0);
                h = v[31601];
                v[31601] = 0;
                if ((h | 0) == 1) {
                 break m;
                }
                k = yb(c, f);
                sb(f);
                sb(a);
                sb(e);
                if ((g | 0) < 256) {
                 break p;
                }
                v[31601] = 0;
                g = b + 4 | 0;
                N(880, g | 0, k | 0);
                a = v[31601];
                v[31601] = 0;
                if ((a | 0) == 1) {
                 break k;
                }
                h = yd(g);
                l = Cf(g);
                m = yd(g);
                a = eb - 16 | 0;
                eb = a;
                v[a + 8 >> 2] = m;
                v[a + 12 >> 2] = h;
                while (1) {
                 if (Hb(h, l)) {
                  n = v[a + 8 >> 2], o = Lq(t[h | 0]), t[n | 0] = o;
                  h = xe(a + 12 | 0);
                  xe(a + 8 | 0);
                  h = v[h >> 2];
                  continue;
                 }
                 break;
                }
                eb = a + 16 | 0;
                Uc(e, g);
                v[31601] = 0;
                R(601, f | 0, 0, e | 0);
                a = v[31601];
                v[31601] = 0;
                if ((a | 0) == 1) {
                 break j;
                }
                yb(k, f);
                sb(f);
                sb(e);
                sb(g);
               }
               a = u[d + 30 >> 1];
               d = u[i >> 1];
               v[31601] = 0;
               n = b, o = iA(d, a) + 5 | 0, v[n + 20 >> 2] = o;
               a = b + 48 | 0;
               N(126, a | 0, b + 20 | 0);
               d = v[31601];
               v[31601] = 0;
               if ((d | 0) == 1) {
                break i;
               }
               v[31601] = 0;
               O(74, c | 0, a | 0) | 0;
               d = v[31601];
               v[31601] = 0;
               if ((d | 0) == 1) {
                break h;
               }
               sb(a);
               break d;
              }
              a = M() | 0;
              break g;
             }
             a = M() | 0;
             break l;
            }
            a = M() | 0;
            sb(b + 20 | 0);
           }
           sb(b + 36 | 0);
           break g;
          }
          a = M() | 0;
          break g;
         }
         a = M() | 0;
         sb(b + 36 | 0);
         sb(b + 4 | 0);
         break g;
        }
        a = M() | 0;
        break g;
       }
       a = M() | 0;
       sb(b + 48 | 0);
      }
      sb(c);
      P(a | 0);
      p();
     }
     f = eb - 16 | 0;
     eb = f;
     e = f + 4 | 0;
     c = eb - 32 | 0;
     eb = c;
     d = rf(c + 20 | 0, 1, 0);
     v: {
      while (1) {
       g = Jb(d);
       ts(c + 12 | 0, g, Cb(v[d + 4 >> 2], w[d + 11 | 0]) + g | 0, u[i >> 1]);
       if (!v[c + 16 >> 2]) {
        break v;
       }
       g = ji(Cb(v[d + 4 >> 2], w[d + 11 | 0]));
       v[31601] = 0;
       N(45, d | 0, g | 0);
       g = v[31601];
       v[31601] = 0;
       if ((g | 0) != 1) {
        continue;
       }
       break;
      }
      break a;
     }
     g = v[c + 12 >> 2];
     i = Jb(d);
     v[31601] = 0;
     N(46, d | 0, g - i | 0);
     g = v[31601];
     v[31601] = 0;
     w: {
      if ((g | 0) != 1) {
       v[31601] = 0;
       N(47, e | 0, d | 0);
       g = v[31601];
       v[31601] = 0;
       if ((g | 0) != 1) {
        break w;
       }
       break a;
      }
      break a;
     }
     sb(d);
     eb = c + 32 | 0;
     Ph(a, e);
     sb(e);
     eb = f + 16 | 0;
    }
    eb = b - -64 | 0;
    break b;
   }
   e = v[b >> 2];
   b = eb - 32 | 0;
   eb = b;
   x: {
    if (Dl(c)) {
     v[b + 16 >> 2] = 4013373;
     v[b + 8 >> 2] = 8289918;
     v[b + 12 >> 2] = 6184542;
     v[b >> 2] = 7553872;
     v[b + 4 >> 2] = 2114384;
     tc(a, (b + (c << 2) | 0) - 1004 | 0);
     break x;
    }
    if (Tc(c)) {
     d = Eb(b);
     v[31601] = 0;
     c = c - 1 | 0;
     f = (c | 0) / 12 | 0;
     c = O(881, d | 0, e + (B(f, -12) + c << 16 >> 16 << 2) | 0) | 0;
     e = v[31601];
     v[31601] = 0;
     y: {
      if ((e | 0) == 1) {
       break y;
      }
      v[31601] = 0;
      c = O(882, c | 0, f + 48 & 255) | 0;
      e = v[31601];
      v[31601] = 0;
      if ((e | 0) == 1) {
       break y;
      }
      v[31601] = 0;
      O(3, a | 0, c | 0) | 0;
      a = v[31601];
      v[31601] = 0;
      if ((a | 0) == 1) {
       break y;
      }
      sb(c);
      break x;
     }
     break a;
    }
    if (!c) {
     tc(a, 16764);
     break x;
    }
    tc(a, 14600);
   }
   eb = b + 32 | 0;
  }
  eb = j + 16 | 0;
  return;
 }
 a = M() | 0;
 sb(d);
 P(a | 0);
 p();
}

function i1(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, q = 0, r = 0;
 g = eb - 864 | 0;
 eb = g;
 xc(b);
 e = eb - 16 | 0;
 eb = e;
 d = g + 92 | 0;
 xF(e + 8 | 0, d);
 h = v[e + 12 >> 2];
 ic(e, v[b >> 2], v[b + 8 >> 2], v[e + 8 >> 2], v[e + 12 >> 2]);
 j = v[e + 4 >> 2];
 if ((j | 0) == (h | 0)) {
  Ub(b, v[e + 12 >> 2]);
 }
 eb = e + 16 | 0;
 e = (h | 0) == (j | 0);
 if (!e) {
  wF(d);
 }
 a: {
  if (!e) {
   break a;
  }
  if (!zF(d)) {
   break a;
  }
  if (!Lb(v[b >> 2], v[b + 8 >> 2], yF(w[g + 607 | 0]))) {
   break a;
  }
  l = 1;
  if ((c | 0) == 64) {
   break a;
  }
  Cd(a, 2);
  v[a + 480204 >> 2] = 15e5;
  v[a + 480208 >> 2] = v[a + 480208 >> 2] | 16777216;
  e = w[g + 606 | 0];
  v[a + 480188 >> 2] = 4194322;
  v[a + 480196 >> 2] = e;
  _j(Wb(v[a + 484360 >> 2], w[a + 484376 | 0]), b, w[g + 607 | 0], 65535, 65535);
  e = Wb(v[a + 484360 >> 2], w[a + 484376 | 0]);
  q = g, r = vb(v[e >> 2]), v[q + 40 >> 2] = r;
  e = vb(v[e + 4 >> 2]);
  b: {
   while (1) {
    d = v[g + 40 >> 2];
    if (Hb(d, e)) {
     if (x[d >> 1] > 127) {
      break b;
     }
     fe(g + 40 | 0);
     continue;
    }
    break;
   }
   dg(a);
   j = a + 946304 | 0;
   m = a + 484380 | 0;
   i = g + 94 | 0;
   while (1) {
    h = l & 65535;
    if (h >>> 0 > x[a + 480190 >> 1]) {
     c: {
      l = 1;
      d: {
       e: {
        f: {
         if (!(c & 1)) {
          break f;
         }
         n = v[b + 8 >> 2];
         h = a + 484344 | 0;
         Sf(h, 128);
         o = g + 608 | 0;
         c = 0;
         j = 0;
         m = 0;
         g: {
          while (1) {
           if ((c | 0) == 128) {
            break g;
           }
           d = g + 16 | 0;
           e = (c << 1) + o | 0;
           uF(d, b, (w[e | 0] | w[e + 1 | 0] << 8) + n | 0, 4674);
           e = gc(g + 40 | 0, d);
           tb(d);
           i = v[e >> 2];
           v[31601] = 0;
           i = Q(172, i | 0) | 0;
           f = v[31601];
           v[31601] = 0;
           if ((f | 0) == 1) {
            break d;
           }
           h: {
            if (!i) {
             break h;
            }
            v[31601] = 0;
            i = T(196, h | 0, c & 65535, 32) | 0;
            f = v[31601];
            v[31601] = 0;
            if ((f | 0) == 1) {
             break d;
            }
            if (!i) {
             break h;
            }
            i = 0;
            k = d;
            d = Vb(v[h >> 2], c);
            af(k, v[d >> 2], v[v[d + 48 >> 2] + 12 >> 2], 0);
            while (1) {
             i: {
              d = v[e >> 2];
              v[31601] = 0;
              d = T(150, d | 0, v[g + 48 >> 2], 1) | 0;
              f = v[31601];
              v[31601] = 0;
              j: {
               k: {
                l: {
                 m: {
                  n: {
                   if ((f | 0) != 1) {
                    if (!d) {
                     break i;
                    }
                    v[31601] = 0;
                    d = Q(197, e | 0) | 0;
                    f = v[31601];
                    v[31601] = 0;
                    if ((f | 0) == 1) {
                     break c;
                    }
                    o: {
                     switch (d - 251 | 0) {
                     case 0:
                      break k;

                     case 1:
                      break l;

                     case 2:
                      break m;

                     case 3:
                      break n;

                     case 4:
                      break o;

                     default:
                      break j;
                     }
                    }
                    v[31601] = 0;
                    d = Q(197, e | 0) | 0;
                    f = v[31601];
                    v[31601] = 0;
                    if ((f | 0) == 1) {
                     break c;
                    }
                    if (!d) {
                     break i;
                    }
                    i = d + i | 0;
                    if (i >>> 0 >= 32) {
                     break i;
                    }
                    d = Vb(v[h >> 2], c);
                    af(g - -64 | 0, v[d >> 2], v[v[d + 48 >> 2] + 12 >> 2], i);
                    d = v[g + 68 >> 2];
                    v[g + 16 >> 2] = v[g + 64 >> 2];
                    v[g + 20 >> 2] = d;
                    continue;
                   }
                   break c;
                  }
                  v[31601] = 0;
                  d = g - -64 | 0;
                  N(198, d | 0, e | 0);
                  f = v[31601];
                  v[31601] = 0;
                  if ((f | 0) == 1) {
                   break c;
                  }
                  k = x[a + 480188 >> 1];
                  f = w[wb(d, 0) | 0];
                  if (k >>> 0 <= f >>> 0) {
                   break e;
                  }
                  d = w[wb(d, 1) | 0];
                  if (d >>> 0 > 63) {
                   break e;
                  }
                  q = Xc(v[g + 16 >> 2], f), r = d + 1 | 0, t[q + 1 | 0] = r;
                  continue;
                 }
                 v[31601] = 0;
                 d = g - -64 | 0;
                 N(198, d | 0, e | 0);
                 f = v[31601];
                 v[31601] = 0;
                 if ((f | 0) == 1) {
                  break c;
                 }
                 k = x[a + 480188 >> 1];
                 f = w[wb(d, 0) | 0];
                 if (k >>> 0 <= f >>> 0) {
                  break e;
                 }
                 d = w[wb(d, 1) | 0];
                 if (d >>> 0 > 63) {
                  break e;
                 }
                 f = Xc(v[g + 16 >> 2], f);
                 t[f + 4 | 0] = d ^ 63;
                 t[f + 2 | 0] = 1;
                 continue;
                }
                v[31601] = 0;
                d = Q(197, e | 0) | 0;
                f = v[31601];
                v[31601] = 0;
                if ((f | 0) != 1) {
                 f = Xc(v[g + 16 >> 2], 0);
                 t[f + 5 | 0] = d;
                 t[f + 3 | 0] = 12;
                 continue;
                }
                break c;
               }
               d = Xc(v[g + 16 >> 2], 0);
               t[d + 5 | 0] = 0;
               t[d + 3 | 0] = 14;
               continue;
              }
              if (d >>> 0 >= x[a + 480188 >> 1]) {
               break e;
              }
              v[31601] = 0;
              f = Q(197, e | 0) | 0;
              k = v[31601];
              v[31601] = 0;
              if ((k | 0) == 1) {
               break c;
              }
              if (f >>> 0 >= 124) {
               break e;
              }
              q = Xc(v[g + 16 >> 2], d), r = (B(f >>> 4 | 0, 12) + (f & 15) | 0) + 13 | 0, t[q | 0] = r;
              m = d | m;
              j = !(d & 1) | j;
              continue;
             }
             break;
            }
            tb(e);
            c = c + 1 | 0;
            continue;
           }
           break;
          }
          tb(e);
         }
         if (!(j & m & 1)) {
          break f;
         }
         c = a + 480280 | 0;
         e = x[a + 480188 >> 1];
         b = 0;
         while (1) {
          if ((b | 0) == (e | 0)) {
           break f;
          }
          u[(c + (b << 5) | 0) + 4 >> 1] = b << 8 & 256;
          b = b + 1 | 0;
          continue;
         }
        }
        Yh(a + 1298344 | 0, 14738);
        Yh(a + 1298356 | 0, 14747);
        Yh(a + 1298368 | 0, 14738);
        q = a, r = v[Ec(g + 40 | 0, 4) >> 2], v[q + 1298404 >> 2] = r;
        break a;
       }
       tb(e);
       break b;
      }
     }
    } else {
     e = g + 81 | 0;
     d = eb - 16 | 0;
     eb = d;
     p: {
      if (!Lb(v[b >> 2], v[b + 8 >> 2], 11)) {
       t[d | 0] = 0;
       Rh(e, 11, d);
       break p;
      }
      Lw(d + 8 | 0, e);
      rd(d, b, v[d + 8 >> 2], v[d + 12 >> 2]);
     }
     eb = d + 16 | 0;
     v[g + 48 >> 2] = 0;
     v[g + 40 >> 2] = 0;
     v[g + 44 >> 2] = 0;
     f = wb(e, 1);
     d = g + 40 | 0;
     q = wb(d, 0), r = w[f | 0], t[q | 0] = r;
     f = wb(e, 6);
     q = wb(d, 1), r = w[f | 0], t[q | 0] = r;
     f = wb(e, 2);
     q = wb(d, 2), r = w[f | 0], t[q | 0] = r;
     f = wb(e, 7);
     q = wb(d, 3), r = w[f | 0], t[q | 0] = r;
     f = wb(e, 3);
     q = wb(d, 4), r = w[f | 0], t[q | 0] = r;
     f = wb(e, 8);
     q = wb(d, 5), r = w[f | 0], t[q | 0] = r;
     f = wb(e, 4);
     q = wb(d, 6), r = w[f | 0], t[q | 0] = r;
     f = wb(e, 9);
     q = wb(d, 7), r = w[f | 0], t[q | 0] = r;
     f = wb(e, 5);
     q = wb(d, 8), r = w[f | 0], t[q | 0] = r;
     f = wb(e, 10);
     q = wb(d, 9), r = w[f | 0], t[q | 0] = r;
     e = wb(e, 0);
     q = wb(d, 10), r = w[e | 0], t[q | 0] = r;
     e = m + B(h, 104) | 0;
     md(e, 2);
     v[g + 8 >> 2] = v[g + 48 >> 2];
     d = v[g + 44 >> 2];
     v[g >> 2] = v[g + 40 >> 2];
     v[g + 4 >> 2] = d;
     Qk(e, 1, g);
     d = g - -64 | 0;
     tF(d, (i + (h << 3) | 0) - 8 | 0);
     e = g + 16 | 0;
     Bc(e, d);
     zc(j + (h << 5) | 0, e);
     l = l + 1 | 0;
     sb(e);
     continue;
    }
    break;
   }
   a = M() | 0;
   tb(e);
   P(a | 0);
   p();
  }
  l = 0;
 }
 eb = g + 864 | 0;
 return l | 0;
}

function Rka(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0;
 e = eb - 96 | 0;
 eb = e;
 h = e + 76 | 0;
 i = a + 140 | 0;
 Tj(h, i, 1296125513);
 v[31601] = 0;
 f = Q(172, v[e + 76 >> 2]) | 0;
 g = v[31601];
 v[31601] = 0;
 a: {
  b: {
   c: {
    d: {
     e: {
      f: {
       g: {
        h: {
         i: {
          j: {
           k: {
            l: {
             m: {
              n: {
               o: {
                p: {
                 if ((g | 0) != 1) {
                  if (f) {
                   f = Eb(e + 28 | 0);
                   v[31601] = 0;
                   g = Q(154, v[e + 76 >> 2]) | 0;
                   j = v[31601];
                   v[31601] = 0;
                   if ((j | 0) == 1) {
                    break p;
                   }
                   v[31601] = 0;
                   R(812, h | 0, f | 0, g | 0);
                   h = v[31601];
                   v[31601] = 0;
                   if ((h | 0) == 1) {
                    break p;
                   }
                   g = x[a + 174 >> 1];
                   v[31601] = 0;
                   h = e - -64 | 0;
                   R(813, h | 0, g | 0, f | 0);
                   g = v[31601];
                   v[31601] = 0;
                   if ((g | 0) == 1) {
                    break o;
                   }
                   v[31601] = 0;
                   g = e + 4 | 0;
                   R(814, g | 0, c | 0, h | 0);
                   c = v[31601];
                   v[31601] = 0;
                   if ((c | 0) == 1) {
                    break n;
                   }
                   zc(d, g);
                   sb(g);
                   sb(h);
                   sb(f);
                  }
                  if (w[a + 176 | 0]) {
                   v[31601] = 0;
                   c = e + 28 | 0;
                   N(815, c | 0, d | 0);
                   f = v[31601];
                   v[31601] = 0;
                   if ((f | 0) == 1) {
                    break e;
                   }
                   Ae(b + 43 | 0, c);
                   sb(c);
                  }
                  v[31601] = 0;
                  c = e + 28 | 0;
                  R(807, c | 0, i | 0, 1413894985);
                  f = v[31601];
                  v[31601] = 0;
                  if ((f | 0) == 1) {
                   break l;
                  }
                  v[31601] = 0;
                  h = Q(816, c | 0) | 0;
                  f = v[31601];
                  v[31601] = 0;
                  if ((f | 0) == 1) {
                   break k;
                  }
                  tb(c);
                  f = a + 40 | 0;
                  xc(f);
                  v[31601] = 0;
                  c = O(817, f | 0, c | 0) | 0;
                  g = v[31601];
                  v[31601] = 0;
                  if ((g | 0) == 1) {
                   break j;
                  }
                  if (c) {
                   q: {
                    if ((w[e + 56 | 0] | w[e + 57 | 0] << 8 | (w[e + 58 | 0] << 16 | w[e + 59 | 0] << 24)) >>> 0 < 2) {
                     break q;
                    }
                    v[31601] = 0;
                    c = e + 4 | 0;
                    g = O(818, f | 0, c | 0) | 0;
                    i = v[31601];
                    v[31601] = 0;
                    if ((i | 0) == 1) {
                     break i;
                    }
                    if (!g) {
                     break q;
                    }
                    sR(c, b + 12 | 0, b + 16 | 0, v[b >> 2], b + 34 | 0, 8, 16, h);
                   }
                   v[31601] = 0;
                   c = e + 4 | 0;
                   f = O(818, f | 0, c | 0) | 0;
                   g = v[31601];
                   v[31601] = 0;
                   if ((g | 0) == 1) {
                    break i;
                   }
                   if (f) {
                    sR(c, b + 4 | 0, b + 8 | 0, v[b >> 2], b + 34 | 0, 2, 4, h);
                   }
                   c = w[e + 40 | 0] | w[e + 41 | 0] << 8 | (w[e + 42 | 0] << 16 | w[e + 43 | 0] << 24);
                   t[b + 42 | 0] = c & 128 ? 0 : c + 1 | 0;
                   Sk(b);
                  }
                  r: {
                   if (w[b + 42 | 0]) {
                    break r;
                   }
                   c = v[a + 60 >> 2];
                   v[31601] = 0;
                   c = O(678, c | 0, 7) | 0;
                   f = v[31601];
                   v[31601] = 0;
                   if ((f | 0) == 1) {
                    break j;
                   }
                   if (!c) {
                    break r;
                   }
                   c = a + 60 | 0;
                   xc(c);
                   v[31601] = 0;
                   c = O(819, c | 0, e + 4 | 0) | 0;
                   f = v[31601];
                   v[31601] = 0;
                   if ((f | 0) == 1) {
                    break d;
                   }
                   if (!c) {
                    break r;
                   }
                   c = t[e + 4 | 0];
                   t[b + 42 | 0] = (c | 0) >= 0 ? c + 1 | 0 : 0;
                  }
                  c = v[a + 120 >> 2];
                  v[31601] = 0;
                  c = Q(172, c | 0) | 0;
                  f = v[31601];
                  v[31601] = 0;
                  if ((f | 0) == 1) {
                   break j;
                  }
                  if (!c) {
                   break f;
                  }
                  v[31601] = 0;
                  g = a + 120 | 0;
                  c = Q(151, g | 0) | 0;
                  f = v[31601];
                  v[31601] = 0;
                  if ((f | 0) == 1) {
                   break c;
                  }
                  v[e + 64 >> 2] = c;
                  wc(e - -64 | 0, 9);
                  f = b + 68 | 0;
                  h = v[e + 64 >> 2];
                  c = 0;
                  while (1) {
                   if ((c | 0) == (h | 0)) {
                    break g;
                   }
                   v[31601] = 0;
                   N(820, g | 0, e + 4 | 0);
                   i = v[31601];
                   v[31601] = 0;
                   if ((i | 0) == 1) {
                    break h;
                   }
                   k = xb(f, c), l = w[e + 8 | 0] | w[e + 9 | 0] << 8 | (w[e + 10 | 0] << 16 | w[e + 11 | 0] << 24), 
                   v[k >> 2] = l;
                   c = c + 1 | 0;
                   continue;
                  }
                 }
                 a = M() | 0;
                 break a;
                }
                a = M() | 0;
                break m;
               }
               a = M() | 0;
               break m;
              }
              a = M() | 0;
              sb(e - -64 | 0);
             }
             sb(f);
             break a;
            }
            a = M() | 0;
            break a;
           }
           a = M() | 0;
           tb(e + 28 | 0);
           break a;
          }
          a = M() | 0;
          break a;
         }
         a = M() | 0;
         break a;
        }
        a = M() | 0;
        break a;
       }
       _z(f + (h << 2) | 0, zZ(f), 41044);
      }
      c = a + 80 | 0;
      xc(c);
      v[31601] = 0;
      f = O(821, c | 0, e + 4 | 0) | 0;
      h = v[31601];
      v[31601] = 0;
      s: {
       if ((h | 0) == 1) {
        break s;
       }
       if (!f) {
        break b;
       }
       if (w[e + 4 | 0] & 32) {
        u[b + 34 >> 1] = x[b + 34 >> 1] | 32;
       }
       u[e + 64 >> 1] = x[e + 8 >> 1];
       u[e + 2 >> 1] = 256;
       k = b, l = x[Nc(e - -64 | 0, e + 2 | 0) >> 1], u[k + 28 >> 1] = l;
       u[e + 64 >> 1] = x[e + 10 >> 1];
       u[e + 2 >> 1] = 256;
       k = b, l = x[Nc(e - -64 | 0, e + 2 | 0) >> 1], u[k + 30 >> 1] = l;
       u[e + 64 >> 1] = x[e + 12 >> 1];
       u[e + 2 >> 1] = 64;
       k = b, l = x[Nc(e - -64 | 0, e + 2 | 0) >> 1], u[k + 32 >> 1] = l;
       t[b + 38 | 0] = w[e + 16 | 0];
       t[b + 39 | 0] = w[e + 17 | 0];
       t[b + 40 | 0] = w[e + 18 | 0];
       t[b + 41 | 0] = w[e + 19 | 0];
       f = v[a + 88 >> 2];
       a = v[a + 80 >> 2];
       v[31601] = 0;
       a = T(150, a | 0, f | 0, 32) | 0;
       f = v[31601];
       v[31601] = 0;
       if ((f | 0) == 1) {
        break s;
       }
       if (!a) {
        break b;
       }
       v[31601] = 0;
       N(822, c | 0, d | 0);
       a = v[31601];
       v[31601] = 0;
       if ((a | 0) == 1) {
        break s;
       }
       v[31601] = 0;
       a = Q(202, c | 0) | 0;
       d = v[31601];
       v[31601] = 0;
       if ((d | 0) == 1) {
        break s;
       }
       v[31601] = 0;
       R(823, c | 0, b + 43 | 0, a | 0);
       a = v[31601];
       v[31601] = 0;
       if ((a | 0) != 1) {
        break b;
       }
      }
      a = M() | 0;
      break a;
     }
     a = M() | 0;
     break a;
    }
    a = M() | 0;
    break a;
   }
   a = M() | 0;
   break a;
  }
  tb(e + 76 | 0);
  eb = e + 96 | 0;
  return;
 }
 tb(e + 76 | 0);
 P(a | 0);
 p();
}

function UL(a, b, c, d, e, f) {
 var g = 0, h = 0, i = C(0), j = 0, k = C(0), l = C(0), m = C(0), n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, v = 0, w = 0, x = 0, y = 0, A = C(0), D = C(0), E = 0, F = 0, G = C(0), H = C(0), I = C(0), J = C(0), K = C(0), L = C(0), M = C(0), N = C(0), O = 0, P = 0;
 F = (d | 0) > 0 ? d : 0;
 while (1) {
  if ((t | 0) != (F | 0)) {
   q = B(t, 2304) + b | 0;
   v = 0;
   s = (c | 0) > 0 ? c : 0;
   h = eb - 128 | 0;
   x = h + 32 | 0;
   g = h + 96 | 0;
   E = h - -64 | 0;
   while (1) {
    if ((s | 0) != (v | 0)) {
     n = q + (v << 2) | 0;
     w = 0;
     j = h;
     p = j;
     o = 0;
     while (1) {
      if ((o | 0) != 8) {
       k = z[B(o ^ 15, 72) + n >> 2];
       y = B(o, 72) + n | 0;
       i = z[y + 1152 >> 2];
       l = C(k + i);
       m = z[y >> 2];
       A = z[B(o ^ 31, 72) + n >> 2];
       D = C(m + A);
       z[p >> 2] = l + D;
       y = B(o, 12);
       k = C(C(k - i) * z[y + 87424 >> 2]);
       i = C(C(m - A) * z[y + 87428 >> 2]);
       z[p + 64 >> 2] = k + i;
       m = C(D - l);
       l = z[y + 87432 >> 2];
       z[p + 32 >> 2] = m * l;
       z[p + 96 >> 2] = l * C(i - k);
       p = p + 4 | 0;
       o = o + 1 | 0;
       continue;
      }
      break;
     }
     while (1) {
      if ((w | 0) != 4) {
       l = z[j + 8 >> 2];
       m = z[j + 20 >> 2];
       i = C(l + m);
       A = z[j + 4 >> 2];
       D = z[j + 24 >> 2];
       G = C(A + D);
       k = C(i + G);
       H = z[j + 12 >> 2];
       I = z[j + 16 >> 2];
       J = C(H + I);
       K = z[j >> 2];
       L = z[j + 28 >> 2];
       M = C(K + L);
       N = C(J + M);
       z[j >> 2] = k + N;
       z[j + 16 >> 2] = C(N - k) * C(.7071067690849304);
       k = C(M - J);
       i = C(C(k + C(G - i)) * C(.7071067690849304));
       z[j + 24 >> 2] = C(k - i) * C(1.3065630197525024);
       z[j + 8 >> 2] = C(k + i) * C(.5411961078643799);
       k = C(K - L);
       i = C(l - m);
       l = C(A - D);
       m = C(C(i + l) * C(.7071067690849304));
       A = C(k + m);
       D = C(C(H - I) + i);
       i = C(l + k);
       l = C(D - C(i * C(.1989123672246933)));
       i = C(C(l * C(.3826834261417389)) + i);
       z[j + 28 >> 2] = C(A - i) * C(2.562915563583374);
       z[j + 4 >> 2] = C(A + i) * C(.509795606136322);
       k = C(k - m);
       i = C(l - C(i * C(.1989123672246933)));
       z[j + 20 >> 2] = C(k + i) * C(.8999761939048767);
       z[j + 12 >> 2] = C(k - i) * C(.601344883441925);
       j = j + 32 | 0;
       w = w + 1 | 0;
       continue;
      }
      break;
     }
     j = 0;
     while (1) {
      if ((j | 0) != 7) {
       o = j << 2;
       z[n >> 2] = z[o + h >> 2];
       k = z[g + o >> 2];
       j = j + 1 | 0;
       p = j << 2;
       i = z[p + g >> 2];
       z[n + 72 >> 2] = C(z[o + E >> 2] + k) + i;
       z[n + 144 >> 2] = z[o + x >> 2] + z[p + x >> 2];
       z[n + 216 >> 2] = i + C(k + z[p + E >> 2]);
       n = n + 288 | 0;
       continue;
      }
      break;
     }
     z[n >> 2] = z[h + 28 >> 2];
     k = z[h + 124 >> 2];
     z[n + 72 >> 2] = z[h + 92 >> 2] + k;
     i = z[h + 60 >> 2];
     z[n + 216 >> 2] = k;
     z[n + 144 >> 2] = i;
     v = v + 1 | 0;
     continue;
    }
    break;
   }
   t = t + 1 | 0;
   continue;
  }
  break;
 }
 E = yc(f, a, 3840);
 y = d << 5;
 t = 0;
 while (1) {
  if ((c | 0) > (t | 0)) {
   j = eb - 32 | 0;
   eb = j;
   f = E + (t << 8) | 0;
   p = (t << 2) + b | 0;
   z[f + 4080 >> 2] = z[p + 1152 >> 2];
   h = d - 1 | 0;
   v = p + B(h, 2304) | 0;
   z[f + 4084 >> 2] = z[v + 1152 >> 2];
   z[f + 4088 >> 2] = z[p >> 2];
   z[f + 4092 >> 2] = z[v >> 2];
   z[f + 4336 >> 2] = z[p + 1156 >> 2];
   z[f + 4340 >> 2] = z[v + 1156 >> 2];
   z[f + 4344 >> 2] = z[p + 4 >> 2];
   z[f + 4348 >> 2] = z[v + 4 >> 2];
   w = (B(t, y) << 1) + e | 0;
   x = w + (h << 1) | 0;
   Tt(x, d, f + 244 | 0);
   h = d << 6;
   Tt(h + x | 0, d, f + 500 | 0);
   Tt(w, d, f + 240 | 0);
   Tt(h + w | 0, d, f + 496 | 0);
   F = f + 3840 | 0;
   o = 14;
   n = 87520;
   while (1) {
    if ((o | 0) >= 0) {
     h = F + (o << 4) | 0;
     f = B(31 - o | 0, 72);
     z[h >> 2] = z[f + p >> 2];
     z[h + 4 >> 2] = z[f + v >> 2];
     f = f | 4;
     z[h + 8 >> 2] = z[f + p >> 2];
     z[h + 12 >> 2] = z[f + v >> 2];
     f = B(o, 72);
     g = f + 76 | 0;
     z[h + 256 >> 2] = z[g + p >> 2];
     z[h + 260 >> 2] = z[g + v >> 2];
     f = f + 72 | 0;
     z[h - 248 >> 2] = z[f + p >> 2];
     z[h - 244 >> 2] = z[f + v >> 2];
     q = h - 3840 | 0;
     k = z[n + 4 >> 2];
     i = z[n >> 2];
     f = 0;
     while (1) {
      if ((f | 0) != 4) {
       g = f << 2;
       l = z[g + h >> 2];
       m = z[g + q >> 2];
       z[g + (j + 16 | 0) >> 2] = C(l * i) - C(k * m);
       z[j + g >> 2] = C(l * k) + C(i * m);
       f = f + 1 | 0;
       continue;
      }
      break;
     }
     q = h - 3584 | 0;
     s = h - 256 | 0;
     k = z[n + 12 >> 2];
     i = z[n + 8 >> 2];
     f = 0;
     while (1) {
      if ((f | 0) != 4) {
       g = f << 2;
       r = g + j | 0;
       l = z[g + s >> 2];
       m = z[g + q >> 2];
       z[r >> 2] = z[r >> 2] + C(C(l * k) + C(i * m));
       g = g + (j + 16 | 0) | 0;
       z[g >> 2] = C(C(m * k) - C(i * l)) + z[g >> 2];
       f = f + 1 | 0;
       continue;
      }
      break;
     }
     q = h - 3328 | 0;
     s = h - 512 | 0;
     k = z[n + 20 >> 2];
     i = z[n + 16 >> 2];
     f = 0;
     while (1) {
      if ((f | 0) != 4) {
       g = f << 2;
       r = g + j | 0;
       l = z[g + s >> 2];
       m = z[g + q >> 2];
       z[r >> 2] = z[r >> 2] + C(C(l * k) + C(i * m));
       g = g + (j + 16 | 0) | 0;
       z[g >> 2] = C(C(l * i) - C(k * m)) + z[g >> 2];
       f = f + 1 | 0;
       continue;
      }
      break;
     }
     q = h - 3072 | 0;
     s = h - 768 | 0;
     k = z[n + 28 >> 2];
     i = z[n + 24 >> 2];
     f = 0;
     while (1) {
      if ((f | 0) != 4) {
       g = f << 2;
       r = g + j | 0;
       l = z[g + s >> 2];
       m = z[g + q >> 2];
       z[r >> 2] = z[r >> 2] + C(C(l * k) + C(i * m));
       g = g + (j + 16 | 0) | 0;
       z[g >> 2] = C(C(m * k) - C(i * l)) + z[g >> 2];
       f = f + 1 | 0;
       continue;
      }
      break;
     }
     q = h - 2816 | 0;
     s = h - 1024 | 0;
     k = z[n + 36 >> 2];
     i = z[n + 32 >> 2];
     f = 0;
     while (1) {
      if ((f | 0) != 4) {
       g = f << 2;
       r = g + j | 0;
       l = z[g + s >> 2];
       m = z[g + q >> 2];
       z[r >> 2] = z[r >> 2] + C(C(l * k) + C(i * m));
       g = g + (j + 16 | 0) | 0;
       z[g >> 2] = C(C(l * i) - C(k * m)) + z[g >> 2];
       f = f + 1 | 0;
       continue;
      }
      break;
     }
     q = h - 2560 | 0;
     s = h - 1280 | 0;
     k = z[n + 44 >> 2];
     i = z[n + 40 >> 2];
     f = 0;
     while (1) {
      if ((f | 0) != 4) {
       g = f << 2;
       r = g + j | 0;
       l = z[g + s >> 2];
       m = z[g + q >> 2];
       z[r >> 2] = z[r >> 2] + C(C(l * k) + C(i * m));
       g = g + (j + 16 | 0) | 0;
       z[g >> 2] = C(C(m * k) - C(i * l)) + z[g >> 2];
       f = f + 1 | 0;
       continue;
      }
      break;
     }
     q = h - 2304 | 0;
     s = h - 1536 | 0;
     k = z[n + 52 >> 2];
     i = z[n + 48 >> 2];
     f = 0;
     while (1) {
      if ((f | 0) != 4) {
       g = f << 2;
       r = g + j | 0;
       l = z[g + s >> 2];
       m = z[g + q >> 2];
       z[r >> 2] = z[r >> 2] + C(C(l * k) + C(i * m));
       g = g + (j + 16 | 0) | 0;
       z[g >> 2] = C(C(l * i) - C(k * m)) + z[g >> 2];
       f = f + 1 | 0;
       continue;
      }
      break;
     }
     g = h - 2048 | 0;
     q = h - 1792 | 0;
     k = z[n + 60 >> 2];
     i = z[n + 56 >> 2];
     f = 0;
     while (1) {
      if ((f | 0) != 4) {
       h = f << 2;
       s = h + j | 0;
       l = z[h + q >> 2];
       m = z[h + g >> 2];
       z[s >> 2] = z[s >> 2] + C(C(l * k) + C(i * m));
       h = h + (j + 16 | 0) | 0;
       z[h >> 2] = C(C(m * k) - C(i * l)) + z[h >> 2];
       f = f + 1 | 0;
       continue;
      }
      break;
     }
     f = B(15 - o | 0, d) << 1;
     O = f + x | 0, P = rj(z[j + 20 >> 2]), u[O >> 1] = P;
     h = B(o + 17 | 0, d) << 1;
     O = h + x | 0, P = rj(z[j + 4 >> 2]), u[O >> 1] = P;
     O = f + w | 0, P = rj(z[j + 16 >> 2]), u[O >> 1] = P;
     O = h + w | 0, P = rj(z[j >> 2]), u[O >> 1] = P;
     f = B(47 - o | 0, d) << 1;
     O = f + x | 0, P = rj(z[j + 28 >> 2]), u[O >> 1] = P;
     h = B(o + 49 | 0, d) << 1;
     O = h + x | 0, P = rj(z[j + 12 >> 2]), u[O >> 1] = P;
     O = f + w | 0, P = rj(z[j + 24 >> 2]), u[O >> 1] = P;
     O = h + w | 0, P = rj(z[j + 8 >> 2]), u[O >> 1] = P;
     o = o - 1 | 0;
     n = n - -64 | 0;
     continue;
    }
    break;
   }
   eb = j + 32 | 0;
   t = t + 2 | 0;
   continue;
  }
  break;
 }
 b = E + (c << 8) | 0;
 a: {
  if ((d | 0) == 1) {
   t = 0;
   while (1) {
    if (t >>> 0 > 959) {
     break a;
    }
    c = t << 2;
    z[c + a >> 2] = z[b + c >> 2];
    t = t + 2 | 0;
    continue;
   }
  }
  yc(a, b, 3840);
 }
}

function Poa(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, q = 0, r = 0, s = 0, y = 0, z = 0;
 d = eb - 736 | 0;
 eb = d;
 xc(b);
 f = eb - 16 | 0;
 eb = f;
 g = d + 128 | 0;
 TW(f + 8 | 0, g);
 e = v[f + 12 >> 2];
 ic(f, v[b >> 2], v[b + 8 >> 2], v[f + 8 >> 2], v[f + 12 >> 2]);
 h = v[f + 4 >> 2];
 if ((h | 0) == (e | 0)) {
  Ub(b, v[f + 12 >> 2]);
 }
 eb = f + 16 | 0;
 f = (e | 0) == (h | 0);
 if (!f) {
  SW(g);
 }
 a: {
  if (!f) {
   break a;
  }
  if (!VW(g)) {
   break a;
  }
  if (!Lb(v[b >> 2], v[b + 8 >> 2], Ac(UW(w[d + 162 | 0] | w[d + 163 | 0] << 8), gb))) {
   break a;
  }
  o = 1;
  if ((c | 0) == 64) {
   break a;
  }
  Cd(a, 262144);
  e = d + 92 | 0;
  Ui(e, 2, g);
  f = d + 12 | 0;
  Bc(f, e);
  yb(a + 1298308 | 0, f);
  sb(f);
  g = tc(f, 8317);
  yb(a + 1298344 | 0, g);
  sb(g);
  g = tc(f, 10125);
  yb(a + 1298356 | 0, g);
  sb(g);
  g = eb - 16 | 0;
  eb = g;
  h = tc(g + 4 | 0, 4193);
  Uc(e, h);
  sb(h);
  eb = g + 16 | 0;
  t[d | 0] = w[d + 158 | 0];
  v[31601] = 0;
  t[d + 115 | 0] = w[d + 157 | 0];
  g = d + 116 | 0;
  N(690, g | 0, d + 115 | 0);
  h = v[31601];
  v[31601] = 0;
  b: {
   c: {
    d: {
     if ((h | 0) != 1) {
      v[31601] = 0;
      U(250, f | 0, e | 0, d | 0, g | 0);
      h = v[31601];
      v[31601] = 0;
      if ((h | 0) != 1) {
       yb(a + 1298368 | 0, f);
       sb(f);
       sb(g);
       Db(e);
       y = a, z = v[Ec(f, 4) >> 2], v[y + 1298404 >> 2] = z;
       v[a + 480208 >> 2] = 12;
       u[a + 480188 >> 1] = w[d + 166 | 0] | w[d + 167 | 0] << 8;
       u[d + 12 >> 1] = w[d + 162 | 0] | w[d + 163 | 0] << 8;
       u[d + 92 >> 1] = 3999;
       y = a, z = x[Nc(f, e) >> 1], u[y + 480190 >> 1] = z;
       x_(Wb(v[a + 484360 >> 2], w[a + 484376 | 0]), d + 224 | 0, w[d + 160 | 0] | w[d + 161 | 0] << 8);
       e = a + 480280 | 0;
       g = d + 192 | 0;
       f = 0;
       while (1) if (x[a + 480188 >> 1] <= f >>> 0) {
        f = d + 12 | 0;
        ge(f, b, B(w[d + 162 | 0] | w[d + 163 | 0] << 8, 80));
        m = c & 2;
        j = a + 946304 | 0;
        o = a + 484380 | 0;
        g = gc(d + 92 | 0, f);
        tb(f);
        n = d + 60 | 0;
        f = 0;
        e: {
         f: {
          while (1) {
           if (x[a + 480190 >> 1] <= f >>> 0) {
            o = 1;
            if (c & 1) {
             break f;
            }
            break b;
           }
           v[31601] = 0;
           h = d + 12 | 0;
           N(691, g | 0, h | 0);
           e = v[31601];
           v[31601] = 0;
           if ((e | 0) == 1) {
            break e;
           }
           Ui(d, 2, n);
           v[31601] = 0;
           e = d + 116 | 0;
           N(218, e | 0, d | 0);
           i = v[31601];
           v[31601] = 0;
           if ((i | 0) == 1) {
            break e;
           }
           f = f + 1 | 0;
           zc(j + (f << 5) | 0, e);
           sb(e);
           v[31601] = 0;
           i = h;
           h = o + B(f, 104) | 0;
           R(692, e | 0, i | 0, h | 0);
           i = v[31601];
           v[31601] = 0;
           g: {
            if ((i | 0) == 1) {
             break g;
            }
            if (!m | !v[h >> 2]) {
             continue;
            }
            v[31601] = 0;
            i = O(149, b | 0, w[d + 30 | 0] | w[d + 31 | 0] << 8 | (w[d + 32 | 0] << 16 | w[d + 33 | 0] << 24)) | 0;
            k = v[31601];
            v[31601] = 0;
            if ((k | 0) == 1) {
             break g;
            }
            if (!i) {
             continue;
            }
            v[31601] = 0;
            T(215, e | 0, h | 0, b | 0) | 0;
            e = v[31601];
            v[31601] = 0;
            if ((e | 0) != 1) {
             continue;
            }
           }
           break;
          }
          break e;
         }
         v[31601] = 0;
         n = a + 484344 | 0;
         N(223, n | 0, w[d + 164 | 0] | w[d + 165 | 0] << 8);
         c = v[31601];
         v[31601] = 0;
         if ((c | 0) == 1) {
          break e;
         }
         r = d + 480 | 0;
         f = 0;
         while (1) {
          if ((w[d + 164 | 0] | w[d + 165 | 0] << 8) >>> 0 <= f >>> 0) {
           break b;
          }
          v[31601] = 0;
          c = T(196, n | 0, f & 65535, 64) | 0;
          e = v[31601];
          v[31601] = 0;
          if ((e | 0) == 1) {
           break e;
          }
          h: {
           if (!c) {
            break h;
           }
           c = (f << 1) + r | 0;
           c = w[c | 0] | w[c + 1 | 0] << 8;
           if (!c) {
            break h;
           }
           v[31601] = 0;
           c = O(149, b | 0, c << 4) | 0;
           e = v[31601];
           v[31601] = 0;
           if ((e | 0) == 1) {
            break e;
           }
           if (!c) {
            break h;
           }
           h = 0;
           c = Vb(v[n >> 2], f);
           m = ld(v[c >> 2], v[v[c + 48 >> 2] + 12 >> 2], 0, 0);
           i: while (1) {
            s = h >>> 0 > 63;
            while (1) {
             if (s) {
              break h;
             }
             c = v[b + 8 >> 2];
             e = v[b >> 2];
             v[31601] = 0;
             c = T(150, e | 0, c | 0, 1) | 0;
             e = v[31601];
             v[31601] = 0;
             j: {
              if ((e | 0) != 1) {
               if (!c) {
                break h;
               }
               v[31601] = 0;
               c = Q(197, b | 0) | 0;
               e = v[31601];
               v[31601] = 0;
               if ((e | 0) == 1) {
                break e;
               }
               j = c << 24 >> 24;
               if (j) {
                break j;
               }
               h = h + 1 | 0;
               m = B(x[a + 480188 >> 1], 6) + m | 0;
               continue i;
              }
              break e;
             }
             u[d + 16 >> 1] = 0;
             v[d + 12 >> 2] = 0;
             c = j & 31;
             i = B(c, 6) + m | 0;
             e = Mg(d + 12 | 0);
             k = c >>> 0 < x[a + 480188 >> 1];
             c = k ? i : e;
             l = j & 255;
             k: {
              if (!(l & 32)) {
               break k;
              }
              v[31601] = 0;
              q = d + 116 | 0;
              N(198, q | 0, b | 0);
              e = v[31601];
              v[31601] = 0;
              if ((e | 0) == 1) {
               break e;
              }
              e = w[d + 116 | 0];
              t[c | 0] = e;
              y = c, z = w[Ic(q) | 0], t[y + 1 | 0] = z;
              l: {
               if (e) {
                if ((e | 0) == 254) {
                 break l;
                }
                if (e >>> 0 < 121) {
                 break k;
                }
               }
               e = 0;
              }
              t[c | 0] = e;
             }
             m: {
              if (!(l & 64)) {
               break m;
              }
              v[31601] = 0;
              e = d + 116 | 0;
              N(198, e | 0, b | 0);
              l = v[31601];
              v[31601] = 0;
              if ((l | 0) == 1) {
               break e;
              }
              l = w[Ic(e) | 0];
              t[c + 5 | 0] = l;
              e = w[d + 116 | 0];
              n: {
               if (e >>> 0 <= 15) {
                Bf(c, e, l);
                break n;
               }
               t[(k ? i : d + 12 | 0) + 3 | 0] = e >>> 0 <= 23 ? w[e + 25351 | 0] : 0;
              }
              e = c + 5 | 0;
              i = k ? i : d + 12 | 0;
              k = w[i + 3 | 0];
              if ((k | 0) != 23) {
               if ((k | 0) != 9) {
                break m;
               }
               t[i + 3 | 0] = 20;
               t[d | 0] = w[e | 0] >>> 3;
               t[d + 115 | 0] = 1;
               y = e, z = w[cf(d, d + 115 | 0) | 0] - 1 & 15 | 128, t[y | 0] = z;
               break m;
              }
              t[d | 0] = 64;
              y = e, z = w[Pb(e, d) | 0] << 1, t[y | 0] = z;
             }
             if ((j | 0) >= 0) {
              continue;
             }
             t[c + 2 | 0] = 1;
             v[31601] = 0;
             e = Q(197, b | 0) | 0;
             j = v[31601];
             v[31601] = 0;
             if ((j | 0) == 1) {
              break e;
             }
             t[c + 4 | 0] = e;
             continue;
            }
           }
          }
          f = f + 1 | 0;
          continue;
         }
        }
        b = M() | 0;
        tb(g);
        break c;
       } else {
        h = e + (f << 5) | 0;
        Ve(h);
        u[h + 4 >> 1] = (w[f + g | 0] << 4 | 4) & 244;
        f = f + 1 | 0;
        continue;
       }
      }
      b = M() | 0;
      sb(d + 116 | 0);
      break d;
     }
     b = M() | 0;
    }
    Db(d + 92 | 0);
   }
   P(b | 0);
   p();
  }
  tb(g);
 }
 eb = d + 736 | 0;
 return o | 0;
}

function zna(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
 e = eb - 176 | 0;
 eb = e;
 a: {
  b: {
   if (Lb(v[c >> 2], v[c + 8 >> 2], 8)) {
    Ub(c, 4);
    while (1) {
     if (Tv(v[c >> 2], v[c + 8 >> 2])) {
      break b;
     }
     n = eb - 288 | 0;
     eb = n;
     f = wU(n + 6 | 0);
     j = eb - 368 | 0;
     eb = j;
     l = yc(f, wU(j + 80 | 0), 282);
     f = 0;
     g = eb - 32 | 0;
     eb = g;
     v[g + 28 >> 2] = 0;
     k = Yb(g + 8 | 0, g + 28 | 0, 4);
     i = v[k >> 2];
     ic(g + 20 | 0, v[c >> 2], v[c + 8 >> 2], i, v[k + 4 >> 2]);
     k = v[g + 24 >> 2] == 4 & v[g + 28 >> 2] == 1399285583;
     if (k) {
      Ub(c, 4);
     }
     eb = g + 32 | 0;
     c: {
      d: {
       e: {
        f: {
         g: {
          if (k) {
           xU(c, 4);
           k = Z$(j + 60 | 0, c);
           v[31601] = 0;
           g = O(788, k | 0, l | 0) | 0;
           i = v[31601];
           v[31601] = 0;
           if ((i | 0) == 1) {
            break g;
           }
           h: {
            if (!g) {
             break h;
            }
            g = v[k + 8 >> 2];
            i = v[k >> 2];
            h = w[l + 26 | 0];
            v[31601] = 0;
            g = T(789, i | 0, g | 0, h | 0) | 0;
            i = v[31601];
            v[31601] = 0;
            if ((i | 0) == 1) {
             break g;
            }
            if (!g) {
             break h;
            }
            g = l + 27 | 0;
            i = 0;
            i: {
             while (1) {
              if (w[l + 26 | 0] <= f >>> 0) {
               h = v[k + 8 >> 2];
               m = v[k >> 2];
               f = 0;
               v[31601] = 0;
               i = i & 65535;
               h = T(789, m | 0, h | 0, i | 0) | 0;
               m = v[31601];
               v[31601] = 0;
               if ((m | 0) == 1) {
                break e;
               }
               if (!h) {
                break h;
               }
               v[31601] = 0;
               N(790, k | 0, i | 0);
               f = v[31601];
               v[31601] = 0;
               if ((f | 0) == 1) {
                break e;
               }
               xU(k, yU(l));
               h = sc(j + 56 | 0);
               f = j + 80 | 0;
               RB(f);
               v[31601] = 0;
               N(791, k | 0, f | 0);
               m = v[31601];
               v[31601] = 0;
               if ((m | 0) != 1) {
                u[j + 102 >> 1] = 0;
                u[j + 104 >> 1] = 0;
                f = uU(h, f, j + 107 | 0);
                h = w[l + 26 | 0];
                v[31601] = 0;
                N(790, k | 0, h | 0);
                h = v[31601];
                v[31601] = 0;
                if ((h | 0) != 1) {
                 break i;
                }
               }
               f = M() | 0;
               break d;
              }
              v[31601] = 0;
              h = Q(792, k | 0) | 0;
              m = v[31601];
              v[31601] = 0;
              if ((m | 0) != 1) {
               t[f + g | 0] = h;
               f = f + 1 | 0;
               i = i + h | 0;
               continue;
              }
              break;
             }
             f = M() | 0;
             break d;
            }
            g = uU(f, g, g + w[l + 26 | 0] | 0);
            v[31601] = 0;
            h = j + 36 | 0;
            R(793, h | 0, k | 0, i | 0);
            f = v[31601];
            v[31601] = 0;
            if ((f | 0) == 1) {
             break f;
            }
            f = 0;
            v[31601] = 0;
            N(574, j + 16 | 0, h | 0);
            i = v[31601];
            v[31601] = 0;
            if ((i | 0) == 1) {
             f = M() | 0;
             tb(h);
             break d;
            }
            m = j + 16 | 0;
            cG(j + 8 | 0, m);
            i = vb(v[j + 8 >> 2]);
            o = Ok(v[j + 8 >> 2], v[j + 12 >> 2]);
            h = eb - 16 | 0;
            eb = h;
            v[h + 12 >> 2] = i;
            while (1) {
             if (Hb(i, o)) {
              sU(g, w[i | 0]);
              i = v[xe(h + 12 | 0) >> 2];
              continue;
             } else {
              eb = h + 16 | 0;
             }
             break;
            }
            Jc(m);
            tb(j + 36 | 0);
            if (v[g >> 2] != (w[l + 22 | 0] | w[l + 23 | 0] << 8 | (w[l + 24 | 0] << 16 | w[l + 25 | 0] << 24))) {
             break h;
            }
            f = yU(l);
            v[31601] = 0;
            N(790, c | 0, f | 0);
            g = v[31601];
            v[31601] = 0;
            f = 1;
            if ((g | 0) == 1) {
             break e;
            }
           }
           tb(k);
          }
          eb = j + 368 | 0;
          break c;
         }
         f = M() | 0;
         break d;
        }
        f = M() | 0;
        break d;
       }
       f = M() | 0;
      }
      tb(k);
      P(f | 0);
      p();
     }
     eb = n + 288 | 0;
     if (f) {
      continue;
     }
     break;
    }
   }
   xc(c);
   cg(b, a, c);
   a = 1;
   break a;
  }
  t[d | 0] = 1;
  xc(c);
  f = Qg(c);
  d = e + 136 | 0;
  ge(d, c, jf(c));
  g = gc(e + 156 | 0, d);
  tb(d);
  c = x[a + 34 >> 1] & -66 | w[b | 0] > 15;
  b = w[b + 1 | 0] != 1;
  c = c | b << 6;
  u[a + 34 >> 1] = c;
  v[a >> 2] = f >>> (c & 1) >>> b;
  v[e + 132 >> 2] = 0;
  v[e + 128 >> 2] = 0;
  v[31601] = 0;
  N(574, d | 0, g | 0);
  b = v[31601];
  v[31601] = 0;
  j: {
   k: {
    l: {
     m: {
      if ((b | 0) != 1) {
       c = Ze(d);
       d = v[e + 136 >> 2];
       j = dD(c, th(d), e + 132 | 0, e + 128 | 0);
       v[31601] = 0;
       b = v[e + 132 >> 2];
       O(183, g | 0, b | 0) | 0;
       f = v[31601];
       v[31601] = 0;
       if ((f | 0) != 1) {
        if (!j) {
         break j;
        }
        Fh(a);
        k = b + c | 0;
        d = d - b | 0;
        b = v[e + 128 >> 2];
        c = 0;
        while (1) {
         n: {
          if (b) {
           if (!d | (b | 0) != 1) {
            break k;
           }
           b = v[a >> 2];
           if (c >>> 0 < b >>> 0) {
            break n;
           }
           break k;
          }
          b = v[a >> 2];
          if (c >>> 0 >= b >>> 0) {
           break k;
          }
         }
         if (!ke(b, v[a + 20 >> 2])) {
          break k;
         }
         v[e + 124 >> 2] = 0;
         v[e + 120 >> 2] = 0;
         b = e + 120 | 0;
         l = kY(j, k, th(d), e + 124 | 0, e + 116 | 0, b);
         v[31601] = 0;
         O(183, g | 0, l | 0) | 0;
         f = v[31601];
         v[31601] = 0;
         if ((f | 0) == 1) {
          break m;
         }
         ti(b, th(v[a >> 2] - c | 0));
         b = v[e + 120 >> 2];
         o: {
          if ((b | 0) <= 0) {
           break o;
          }
          f = v[e + 124 >> 2];
          n = x[a + 34 >> 1];
          if ((Zd(n) | 0) != (f | 0)) {
           break o;
          }
          i = B(c, f);
          h = v[a + 20 >> 2];
          if (n & 1) {
           v[e + 112 >> 2] = b;
           v[e + 100 >> 2] = b;
           v[e - -64 >> 2] = b;
           v[e + 48 >> 2] = b;
           v[e + 96 >> 2] = f;
           v[e + 92 >> 2] = v[e + 116 >> 2];
           v[e + 108 >> 2] = f;
           v[e + 104 >> 2] = h + (i << 1);
           v[31601] = 0;
           f = v[e + 96 >> 2];
           v[e + 40 >> 2] = v[e + 92 >> 2];
           v[e + 44 >> 2] = f;
           f = v[e + 108 >> 2];
           v[e + 56 >> 2] = v[e + 104 >> 2];
           v[e + 60 >> 2] = f;
           N(575, e + 56 | 0, e + 40 | 0);
           f = v[31601];
           v[31601] = 0;
           if ((f | 0) != 1) {
            break o;
           }
           break m;
          }
          v[e + 88 >> 2] = b;
          v[e + 76 >> 2] = b;
          v[e + 32 >> 2] = b;
          v[e + 16 >> 2] = b;
          v[e + 72 >> 2] = f;
          v[e + 68 >> 2] = v[e + 116 >> 2];
          v[e + 84 >> 2] = f;
          v[e + 80 >> 2] = i + h;
          v[31601] = 0;
          f = v[e + 72 >> 2];
          v[e + 8 >> 2] = v[e + 68 >> 2];
          v[e + 12 >> 2] = f;
          f = v[e + 84 >> 2];
          v[e + 24 >> 2] = v[e + 80 >> 2];
          v[e + 28 >> 2] = f;
          N(576, e + 24 | 0, e + 8 | 0);
          f = v[31601];
          v[31601] = 0;
          if ((f | 0) == 1) {
           break m;
          }
         }
         d = d - l | 0;
         k = k + l | 0;
         c = b + c | 0;
         b = jY(j);
         continue;
        }
       }
       break m;
      }
      c = M() | 0;
      break l;
     }
     c = M() | 0;
     Jc(e + 136 | 0);
    }
    tb(g);
    P(c | 0);
    p();
   }
   iY(j);
  }
  Jc(e + 136 | 0);
  tb(g);
  a = (j | 0) != 0;
 }
 eb = e + 176 | 0;
 return a | 0;
}

function Oz(a, b, c, d, e) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 var f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0;
 f = eb - 256 | 0;
 eb = f;
 g = v[b + 4 >> 2];
 a: {
  if (!g) {
   i = v[b >> 2];
   break a;
  }
  i = v[b >> 2];
  h = w[xl(i, g) | 0];
  if ((h | 0) == 33) {
   e = 1;
  } else {
   if ((h | 0) != 63) {
    break a;
   }
   e = 0;
  }
  Kl(f + 96 | 0, i, g, g - 1 | 0);
  g = v[f + 100 >> 2];
  i = v[f + 96 >> 2];
  v[b >> 2] = i;
  v[b + 4 >> 2] = g;
 }
 j = f + 96 | 0;
 he(j);
 h = v[f + 96 >> 2];
 k = f + 236 | 0;
 he(k);
 h = wl(h, v[f + 240 >> 2], b);
 he(j);
 b: {
  c: {
   d: {
    e: {
     if (v[f + 100 >> 2] == (h | 0)) {
      h = oc(f + 248 | 0, 22256);
      a = v[h + 4 >> 2];
      v[f + 8 >> 2] = v[h >> 2];
      v[f + 12 >> 2] = a;
      if (Hc(i, g, f + 8 | 0)) {
       e = cc(8);
       v[31601] = 0;
       c = _h(k, c, d);
       a = v[31601];
       v[31601] = 0;
       f: {
        g: {
         h: {
          if ((a | 0) != 1) {
           v[31601] = 0;
           R(1010, j | 0, 18235, c | 0);
           a = v[31601];
           v[31601] = 0;
           if ((a | 0) == 1) {
            break h;
           }
           rc(e, j);
           a = 0;
           v[31601] = 0;
           R(97, e | 0, 48396, 999);
           b = v[31601];
           v[31601] = 0;
           if ((b | 0) != 1) {
            break b;
           }
           g = M() | 0;
           sb(j);
           break g;
          }
          g = M() | 0;
          break f;
         }
         g = M() | 0;
         a = 1;
        }
        sb(c);
        if (!a) {
         break c;
        }
       }
       jc(e);
       break c;
      }
      if (!e) {
       break e;
      }
      h = cc(8);
      e = v[b >> 2];
      a = v[b + 4 >> 2];
      v[31601] = 0;
      i = _h(f + 212 | 0, e, a);
      a = v[31601];
      v[31601] = 0;
      i: {
       j: {
        k: {
         l: {
          m: {
           n: {
            o: {
             p: {
              q: {
               if ((a | 0) != 1) {
                v[31601] = 0;
                b = f + 224 | 0;
                R(1010, b | 0, 18271, i | 0);
                a = v[31601];
                v[31601] = 0;
                if ((a | 0) == 1) {
                 break q;
                }
                v[31601] = 0;
                e = f + 236 | 0;
                N(1012, e | 0, b | 0);
                b = v[31601];
                v[31601] = 0;
                a = 1;
                if ((b | 0) == 1) {
                 break p;
                }
                v[31601] = 0;
                d = _h(f + 200 | 0, c, d);
                a = v[31601];
                v[31601] = 0;
                if ((a | 0) == 1) {
                 break o;
                }
                v[31601] = 0;
                c = f + 96 | 0;
                R(1014, c | 0, e | 0, d | 0);
                b = v[31601];
                v[31601] = 0;
                a = 1;
                if ((b | 0) == 1) {
                 break n;
                }
                rc(h, c);
                v[31601] = 0;
                R(97, h | 0, 48396, 999);
                a = v[31601];
                v[31601] = 0;
                if ((a | 0) != 1) {
                 break b;
                }
                g = M() | 0;
                sb(c);
                a = 0;
                break m;
               }
               g = M() | 0;
               break i;
              }
              g = M() | 0;
              a = 1;
              break j;
             }
             g = M() | 0;
             break k;
            }
            g = M() | 0;
            a = 1;
            break l;
           }
           g = M() | 0;
          }
          sb(d);
         }
         sb(f + 236 | 0);
        }
        sb(f + 224 | 0);
       }
       sb(i);
       if (!a) {
        break c;
       }
      }
      jc(h);
      break c;
     }
     e = oc(f + 192 | 0, 22256);
     b = v[e + 4 >> 2];
     v[f + 88 >> 2] = v[e >> 2];
     v[f + 92 >> 2] = b;
     if (Hc(i, g, f + 88 | 0)) {
      e = cc(8);
      v[31601] = 0;
      d = _h(f + 236 | 0, c, d);
      a = v[31601];
      v[31601] = 0;
      r: {
       s: {
        t: {
         if ((a | 0) != 1) {
          v[31601] = 0;
          c = f + 96 | 0;
          R(1010, c | 0, 18235, d | 0);
          a = v[31601];
          v[31601] = 0;
          if ((a | 0) == 1) {
           break t;
          }
          rc(e, c);
          a = 0;
          v[31601] = 0;
          R(97, e | 0, 48396, 999);
          b = v[31601];
          v[31601] = 0;
          if ((b | 0) != 1) {
           break b;
          }
          g = M() | 0;
          sb(c);
          break s;
         }
         g = M() | 0;
         break r;
        }
        g = M() | 0;
        a = 1;
       }
       sb(d);
       if (!a) {
        break c;
       }
      }
      jc(e);
      break c;
     }
     e = oc(f + 184 | 0, 12421);
     b = v[e + 4 >> 2];
     v[f + 80 >> 2] = v[e >> 2];
     v[f + 84 >> 2] = b;
     if (Hc(i, g, f + 80 | 0)) {
      e = oc(f + 176 | 0, 5601);
      b = v[e + 4 >> 2];
      v[f + 32 >> 2] = v[e >> 2];
      v[f + 36 >> 2] = b;
      if (Hc(c, d, f + 32 | 0)) {
       v[a + 52 >> 2] = 0;
       break e;
      }
      e = oc(f + 168 | 0, 11285);
      b = v[e + 4 >> 2];
      v[f + 24 >> 2] = v[e >> 2];
      v[f + 28 >> 2] = b;
      if (Hc(c, d, f + 24 | 0)) {
       v[a + 52 >> 2] = 1;
       break e;
      }
      e = oc(f + 160 | 0, 9206);
      b = v[e + 4 >> 2];
      v[f + 16 >> 2] = v[e >> 2];
      v[f + 20 >> 2] = b;
      if (Hc(c, d, f + 16 | 0)) {
       v[a + 52 >> 2] = 2;
       break e;
      }
      e = cc(8);
      v[31601] = 0;
      d = _h(f + 236 | 0, c, d);
      a = v[31601];
      v[31601] = 0;
      u: {
       v: {
        w: {
         if ((a | 0) != 1) {
          v[31601] = 0;
          c = f + 96 | 0;
          R(1010, c | 0, 14606, d | 0);
          a = v[31601];
          v[31601] = 0;
          if ((a | 0) == 1) {
           break w;
          }
          rc(e, c);
          a = 0;
          v[31601] = 0;
          R(97, e | 0, 48396, 999);
          b = v[31601];
          v[31601] = 0;
          if ((b | 0) != 1) {
           break b;
          }
          g = M() | 0;
          sb(c);
          break v;
         }
         g = M() | 0;
         break u;
        }
        g = M() | 0;
        a = 1;
       }
       sb(d);
       if (!a) {
        break c;
       }
      }
      jc(e);
      break c;
     }
     e = oc(f + 152 | 0, 11522);
     b = v[e + 4 >> 2];
     v[f + 72 >> 2] = v[e >> 2];
     v[f + 76 >> 2] = b;
     if (!Hc(i, g, f + 72 | 0)) {
      break e;
     }
     e = oc(f + 144 | 0, 15623);
     b = v[e + 4 >> 2];
     v[f + 64 >> 2] = v[e >> 2];
     v[f + 68 >> 2] = b;
     b = 0;
     x: {
      if (Hc(c, d, f - -64 | 0)) {
       break x;
      }
      e = oc(f + 136 | 0, 15628);
      b = v[e + 4 >> 2];
      v[f + 56 >> 2] = v[e >> 2];
      v[f + 60 >> 2] = b;
      b = 1;
      if (Hc(c, d, f + 56 | 0)) {
       break x;
      }
      e = oc(f + 128 | 0, 12695);
      b = v[e + 4 >> 2];
      v[f + 48 >> 2] = v[e >> 2];
      v[f + 52 >> 2] = b;
      b = 2;
      if (Hc(c, d, f + 48 | 0)) {
       break x;
      }
      e = oc(f + 120 | 0, 9270);
      b = v[e + 4 >> 2];
      v[f + 40 >> 2] = v[e >> 2];
      v[f + 44 >> 2] = b;
      b = 3;
      if (Hc(c, d, f + 40 | 0)) {
       break x;
      }
      c = cc(8);
      v[31601] = 0;
      b = O(36, f + 96 | 0, 11558) | 0;
      a = v[31601];
      v[31601] = 0;
      if ((a | 0) == 1) {
       break d;
      }
      rc(c, b);
      v[31601] = 0;
      R(97, c | 0, 48396, 999);
      a = v[31601];
      v[31601] = 0;
      if ((a | 0) != 1) {
       break b;
      }
      g = M() | 0;
      sb(b);
      break c;
     }
     v[a + 56 >> 2] = b;
     d = v[a + 24 >> 2];
     if (!v[d + 24668 >> 2]) {
      break e;
     }
     c = d + 24664 | 0;
     a = v[c + 4 >> 2];
     v[f + 112 >> 2] = v[c >> 2];
     v[f + 116 >> 2] = a;
     c = d + 24656 | 0;
     a = v[c + 4 >> 2];
     v[f + 104 >> 2] = v[c >> 2];
     v[f + 108 >> 2] = a;
     a = v[d + 24652 >> 2];
     v[f + 96 >> 2] = v[d + 24648 >> 2];
     v[f + 100 >> 2] = a;
     l = f, m = SM(b), v[l + 116 >> 2] = m;
     a = f + 96 | 0;
     if (!Az(a, d + 24648 | 0)) {
      break e;
     }
     MA(d, a);
    }
    eb = f + 256 | 0;
    return;
   }
   g = M() | 0;
   jc(c);
  }
  P(g | 0);
 }
 p();
}

function Jz(a, b, c, d, e, f, g, h, i) {
 var j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, q = 0, r = 0;
 l = eb - 48 | 0;
 eb = l;
 v[l + 44 >> 2] = 0;
 a: {
  if (d | g | h | i) {
   j = g ? l + 44 | 0 : 0;
   b: {
    if (!j) {
     break b;
    }
    k = v[j >> 2];
    if (!k) {
     break b;
    }
    Bb(k);
    v[j >> 2] = 0;
   }
   v[31601] = 0;
   W(84);
   k = v[31601];
   v[31601] = 0;
   c: {
    d: {
     if ((k | 0) == 1) {
      m = Ua(124508, 47360, 47416, 48396, 124696, 124800, 124748, 124640, 124628, 124944, 124912, 124880, 124868, 125092, 0) | 0;
      e: {
       f: {
        n = fb;
        if ((n | 0) == (_(124508) | 0)) {
         k = X(m | 0) | 0;
         v[31601] = 0;
         N(1097, j | 0, k | 0);
         j = v[31601];
         v[31601] = 0;
         k = 277;
         if ((j | 0) == 1) {
          break f;
         }
         break c;
        }
        if ((_(47360) | 0) == (n | 0)) {
         k = X(m | 0) | 0;
         v[31601] = 0;
         N(1097, j | 0, k | 0);
         j = v[31601];
         v[31601] = 0;
         k = 358;
         if ((j | 0) != 1) {
          break c;
         }
         a = M() | 0;
         v[31601] = 0;
         W(26);
         b = v[31601];
         v[31601] = 0;
         if ((b | 0) != 1) {
          break d;
         }
         break e;
        }
        if ((_(47416) | 0) == (n | 0)) {
         k = X(m | 0) | 0;
         v[31601] = 0;
         N(1097, j | 0, k | 0);
         j = v[31601];
         v[31601] = 0;
         k = 359;
         if ((j | 0) != 1) {
          break c;
         }
         a = M() | 0;
         v[31601] = 0;
         W(26);
         b = v[31601];
         v[31601] = 0;
         if ((b | 0) != 1) {
          break d;
         }
         break e;
        }
        if ((_(48396) | 0) == (n | 0)) {
         k = X(m | 0) | 0;
         v[31601] = 0;
         N(1097, j | 0, k | 0);
         j = v[31601];
         v[31601] = 0;
         k = 357;
         if ((j | 0) != 1) {
          break c;
         }
         a = M() | 0;
         v[31601] = 0;
         W(26);
         b = v[31601];
         v[31601] = 0;
         if ((b | 0) != 1) {
          break d;
         }
         break e;
        }
        if ((_(124696) | 0) == (n | 0)) {
         k = X(m | 0) | 0;
         v[31601] = 0;
         N(1097, j | 0, k | 0);
         j = v[31601];
         v[31601] = 0;
         k = 300;
         if ((j | 0) != 1) {
          break c;
         }
         a = M() | 0;
         v[31601] = 0;
         W(26);
         b = v[31601];
         v[31601] = 0;
         if ((b | 0) != 1) {
          break d;
         }
         break e;
        }
        if ((_(124800) | 0) == (n | 0)) {
         k = X(m | 0) | 0;
         v[31601] = 0;
         N(1097, j | 0, k | 0);
         j = v[31601];
         v[31601] = 0;
         k = 299;
         if ((j | 0) != 1) {
          break c;
         }
         a = M() | 0;
         v[31601] = 0;
         W(26);
         b = v[31601];
         v[31601] = 0;
         if ((b | 0) != 1) {
          break d;
         }
         break e;
        }
        if ((_(124748) | 0) == (n | 0)) {
         k = X(m | 0) | 0;
         v[31601] = 0;
         N(1097, j | 0, k | 0);
         j = v[31601];
         v[31601] = 0;
         k = 298;
         if ((j | 0) != 1) {
          break c;
         }
         a = M() | 0;
         v[31601] = 0;
         W(26);
         b = v[31601];
         v[31601] = 0;
         if ((b | 0) != 1) {
          break d;
         }
         break e;
        }
        if ((_(124640) | 0) == (n | 0)) {
         k = X(m | 0) | 0;
         v[31601] = 0;
         N(1097, j | 0, k | 0);
         j = v[31601];
         v[31601] = 0;
         k = 297;
         if ((j | 0) != 1) {
          break c;
         }
         a = M() | 0;
         v[31601] = 0;
         W(26);
         b = v[31601];
         v[31601] = 0;
         if ((b | 0) != 1) {
          break d;
         }
         break e;
        }
        if ((_(124628) | 0) == (n | 0)) {
         k = X(m | 0) | 0;
         v[31601] = 0;
         N(1097, j | 0, k | 0);
         j = v[31601];
         v[31601] = 0;
         k = 296;
         if ((j | 0) != 1) {
          break c;
         }
         a = M() | 0;
         v[31601] = 0;
         W(26);
         b = v[31601];
         v[31601] = 0;
         if ((b | 0) != 1) {
          break d;
         }
         break e;
        }
        if ((_(124944) | 0) == (n | 0)) {
         k = X(m | 0) | 0;
         v[31601] = 0;
         N(1097, j | 0, k | 0);
         j = v[31601];
         v[31601] = 0;
         k = 289;
         if ((j | 0) != 1) {
          break c;
         }
         a = M() | 0;
         v[31601] = 0;
         W(26);
         b = v[31601];
         v[31601] = 0;
         if ((b | 0) != 1) {
          break d;
         }
         break e;
        }
        if ((_(124912) | 0) == (n | 0)) {
         k = X(m | 0) | 0;
         v[31601] = 0;
         N(1097, j | 0, k | 0);
         j = v[31601];
         v[31601] = 0;
         k = 288;
         if ((j | 0) != 1) {
          break c;
         }
         a = M() | 0;
         v[31601] = 0;
         W(26);
         b = v[31601];
         v[31601] = 0;
         if ((b | 0) != 1) {
          break d;
         }
         break e;
        }
        if ((_(124880) | 0) == (n | 0)) {
         k = X(m | 0) | 0;
         v[31601] = 0;
         N(1097, j | 0, k | 0);
         j = v[31601];
         v[31601] = 0;
         k = 287;
         if ((j | 0) != 1) {
          break c;
         }
         a = M() | 0;
         v[31601] = 0;
         W(26);
         b = v[31601];
         v[31601] = 0;
         if ((b | 0) != 1) {
          break d;
         }
         break e;
        }
        if ((_(124868) | 0) == (n | 0)) {
         k = X(m | 0) | 0;
         v[31601] = 0;
         N(1097, j | 0, k | 0);
         j = v[31601];
         v[31601] = 0;
         k = 286;
         if ((j | 0) != 1) {
          break c;
         }
         a = M() | 0;
         v[31601] = 0;
         W(26);
         b = v[31601];
         v[31601] = 0;
         if ((b | 0) != 1) {
          break d;
         }
         break e;
        }
        o = _(125092) | 0;
        k = 257;
        m = X(m | 0) | 0;
        if ((n | 0) != (o | 0)) {
         break c;
        }
        v[31601] = 0;
        N(1097, j | 0, m | 0);
        j = v[31601];
        v[31601] = 0;
        k = 267;
        if ((j | 0) != 1) {
         break c;
        }
        a = M() | 0;
        v[31601] = 0;
        W(26);
        b = v[31601];
        v[31601] = 0;
        if ((b | 0) == 1) {
         break e;
        }
        break d;
       }
       a = M() | 0;
       v[31601] = 0;
       W(26);
       b = v[31601];
       v[31601] = 0;
       if ((b | 0) != 1) {
        break d;
       }
      }
      S(0) | 0;
      Rb();
     }
     p();
    }
    P(a | 0);
    p();
   }
   Y();
   m = !g;
   if (d) {
    j = hb[d | 0](k, e) | 0;
   } else {
    j = 3;
   }
   if (!(m | !(j & 2))) {
    v[g + 16 >> 2] = k;
    m = g;
    g = v[l + 44 >> 2];
    q = m, r = Bg(g ? g : 22256), v[q + 20 >> 2] = r;
   }
   if (h) {
    v[h >> 2] = k;
   }
   g = v[l + 44 >> 2];
   if (i) {
    q = i, r = Bg(g ? g : 22256), v[q >> 2] = r;
    g = v[l + 44 >> 2];
   }
   if (g) {
    Bb(g);
    v[l + 44 >> 2] = 0;
   }
   if (!(j & 1)) {
    break a;
   }
  }
  v[31601] = 0;
  g = l + 32 | 0;
  N(1095, g | 0, a | 0);
  h = v[31601];
  v[31601] = 0;
  g: {
   h: {
    if ((h | 0) != 1) {
     i: {
      if (f) {
       h = v[f + 24 >> 2];
       v[31601] = 0;
       N(1096, h | 0, g | 0);
       g = v[31601];
       v[31601] = 0;
       if ((g | 0) != 1) {
        break i;
       }
       break h;
      }
      g = Jb(l + 32 | 0);
      if (b) {
       v[31601] = 0;
       N(b | 0, g | 0, c | 0);
       g = v[31601];
       v[31601] = 0;
       if ((g | 0) == 1) {
        break h;
       }
       break i;
      }
      lu(g, l);
     }
     sb(l + 32 | 0);
     break a;
    }
    g = S(0) | 0;
    break g;
   }
   g = S(0) | 0;
   sb(l + 32 | 0);
  }
  X(g | 0) | 0;
  v[l + 28 >> 2] = f;
  v[l + 24 >> 2] = e;
  v[l + 20 >> 2] = d;
  v[l + 16 >> 2] = c;
  v[l + 12 >> 2] = b;
  v[l + 8 >> 2] = a ? a : 22256;
  v[l + 4 >> 2] = 254;
  v[l >> 2] = 9174;
  qP(18449, l);
  ku(125448);
  Y();
 }
 eb = l + 48 | 0;
}

function uL(a, b, c, d, e) {
 var f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, w = 0, x = 0, y = 0, z = 0;
 i = eb - 560 | 0;
 eb = i;
 g = c;
 c = (c - 3 | 0) / 24 | 0;
 t = (c | 0) > 0 ? c : 0;
 k = g + B(t, -24) | 0;
 n = v[(e << 2) + 89888 >> 2];
 j = d - 1 | 0;
 if ((n + j | 0) >= 0) {
  g = d + n | 0;
  c = t - j | 0;
  while (1) {
   A[(i + 320 | 0) + (h << 3) >> 3] = (c | 0) < 0 ? 0 : +v[(c << 2) + 89904 >> 2];
   c = c + 1 | 0;
   h = h + 1 | 0;
   if ((g | 0) != (h | 0)) {
    continue;
   }
   break;
  }
 }
 q = k - 24 | 0;
 g = 0;
 h = (n | 0) > 0 ? n : 0;
 m = (d | 0) <= 0;
 while (1) {
  a: {
   if (m) {
    f = 0;
    break a;
   }
   r = g + j | 0;
   c = 0;
   f = 0;
   while (1) {
    f = A[(c << 3) + a >> 3] * A[(i + 320 | 0) + (r - c << 3) >> 3] + f;
    c = c + 1 | 0;
    if ((d | 0) != (c | 0)) {
     continue;
    }
    break;
   }
  }
  A[(g << 3) + i >> 3] = f;
  c = (g | 0) == (h | 0);
  g = g + 1 | 0;
  if (!c) {
   continue;
  }
  break;
 }
 y = 47 - k | 0;
 r = 48 - k | 0;
 u = (k | 0) < 25;
 z = k - 25 | 0;
 g = n;
 while (1) {
  f = A[(g << 3) + i >> 3];
  c = 0;
  h = g;
  o = (g | 0) <= 0;
  if (!o) {
   while (1) {
    m = (i + 480 | 0) + (c << 2) | 0;
    l = f * 5.960464477539063e-8;
    b: {
     if (D(l) < 2147483648) {
      j = ~~l;
      break b;
     }
     j = -2147483648;
    }
    l = +(j | 0);
    f = l * -16777216 + f;
    c: {
     if (D(f) < 2147483648) {
      j = ~~f;
      break c;
     }
     j = -2147483648;
    }
    v[m >> 2] = j;
    h = h - 1 | 0;
    f = A[(h << 3) + i >> 3] + l;
    c = c + 1 | 0;
    if ((g | 0) != (c | 0)) {
     continue;
    }
    break;
   }
  }
  f = nk(f, q);
  f = f + H(f * .125) * -8;
  d: {
   if (D(f) < 2147483648) {
    m = ~~f;
    break d;
   }
   m = -2147483648;
  }
  f = f - +(m | 0);
  e: {
   f: {
    g: {
     h: {
      if (!u) {
       h = (g << 2) + i | 0;
       j = v[h + 476 >> 2];
       c = j >> r;
       s = h;
       h = j - (c << r) | 0;
       v[s + 476 >> 2] = h;
       m = c + m | 0;
       j = h >> y;
       break h;
      }
      if (q) {
       break g;
      }
      j = v[((g << 2) + i | 0) + 476 >> 2] >> 23;
     }
     if ((j | 0) <= 0) {
      break e;
     }
     break f;
    }
    j = 2;
    if (f >= .5) {
     break f;
    }
    j = 0;
    break e;
   }
   c = 0;
   h = 0;
   if (!o) {
    while (1) {
     s = (i + 480 | 0) + (c << 2) | 0;
     o = v[s >> 2];
     w = 16777215;
     i: {
      j: {
       if (h) {
        break j;
       }
       w = 16777216;
       if (o) {
        break j;
       }
       h = 0;
       break i;
      }
      v[s >> 2] = w - o;
      h = 1;
     }
     c = c + 1 | 0;
     if ((g | 0) != (c | 0)) {
      continue;
     }
     break;
    }
   }
   k: {
    if (u) {
     break k;
    }
    c = 8388607;
    l: {
     switch (z | 0) {
     case 1:
      c = 4194303;
      break;

     case 0:
      break l;

     default:
      break k;
     }
    }
    o = (g << 2) + i | 0;
    v[o + 476 >> 2] = v[o + 476 >> 2] & c;
   }
   m = m + 1 | 0;
   if ((j | 0) != 2) {
    break e;
   }
   f = 1 - f;
   j = 2;
   if (!h) {
    break e;
   }
   f = f - nk(1, q);
  }
  m: {
   n: {
    if (f == 0) {
     h = 0;
     c = g;
     if ((c | 0) <= (n | 0)) {
      break m;
     }
     while (1) {
      c = c - 1 | 0;
      h = v[(i + 480 | 0) + (c << 2) >> 2] | h;
      if ((c | 0) > (n | 0)) {
       continue;
      }
      break;
     }
     if (!h) {
      break m;
     }
     k = q;
     while (1) {
      k = k - 24 | 0;
      g = g - 1 | 0;
      if (!v[(i + 480 | 0) + (g << 2) >> 2]) {
       continue;
      }
      break;
     }
     break n;
    }
    f = nk(f, 24 - k | 0);
    o: {
     if (f >= 16777216) {
      d = (i + 480 | 0) + (g << 2) | 0;
      l = f * 5.960464477539063e-8;
      p: {
       if (D(l) < 2147483648) {
        c = ~~l;
        break p;
       }
       c = -2147483648;
      }
      f = +(c | 0) * -16777216 + f;
      q: {
       if (D(f) < 2147483648) {
        a = ~~f;
        break q;
       }
       a = -2147483648;
      }
      v[d >> 2] = a;
      g = g + 1 | 0;
      break o;
     }
     if (D(f) < 2147483648) {
      c = ~~f;
     } else {
      c = -2147483648;
     }
     k = q;
    }
    v[(i + 480 | 0) + (g << 2) >> 2] = c;
   }
   f = nk(1, k);
   if ((g | 0) >= 0) {
    d = g;
    while (1) {
     a = d;
     A[(a << 3) + i >> 3] = f * +v[(i + 480 | 0) + (a << 2) >> 2];
     d = a - 1 | 0;
     f = f * 5.960464477539063e-8;
     if (a) {
      continue;
     }
     break;
    }
    h = g;
    while (1) {
     f = 0;
     c = 0;
     a = g - h | 0;
     d = (a | 0) > (n | 0) ? n : a;
     if ((d | 0) >= 0) {
      while (1) {
       f = A[(c << 3) + 92672 >> 3] * A[(c + h << 3) + i >> 3] + f;
       k = (c | 0) != (d | 0);
       c = c + 1 | 0;
       if (k) {
        continue;
       }
       break;
      }
     }
     A[(i + 160 | 0) + (a << 3) >> 3] = f;
     a = (h | 0) > 0;
     h = h - 1 | 0;
     if (a) {
      continue;
     }
     break;
    }
   }
   r: {
    s: {
     t: {
      switch (e - 1 | 0) {
      case 2:
       u: {
        if ((g | 0) <= 0) {
         break u;
        }
        d = (i + 160 | 0) + (g << 3) | 0;
        f = A[d >> 3];
        c = g;
        while (1) {
         l = f;
         e = i + 160 | 0;
         a = c - 1 | 0;
         h = e + (a << 3) | 0;
         x = A[h >> 3];
         f = x + f;
         A[e + (c << 3) >> 3] = l + (x - f);
         A[h >> 3] = f;
         e = c >>> 0 > 1;
         c = a;
         if (e) {
          continue;
         }
         break;
        }
        if ((g | 0) == 1) {
         break u;
        }
        f = A[d >> 3];
        c = g;
        while (1) {
         l = f;
         d = i + 160 | 0;
         a = c - 1 | 0;
         e = d + (a << 3) | 0;
         p = A[e >> 3];
         f = p + f;
         A[d + (c << 3) >> 3] = l + (p - f);
         A[e >> 3] = f;
         d = c >>> 0 > 2;
         c = a;
         if (d) {
          continue;
         }
         break;
        }
        p = 0;
        while (1) {
         p = p + A[(i + 160 | 0) + (g << 3) >> 3];
         a = (g | 0) > 2;
         g = g - 1 | 0;
         if (a) {
          continue;
         }
         break;
        }
       }
       f = A[i + 160 >> 3];
       if (j) {
        break s;
       }
       A[b >> 3] = f;
       f = A[i + 168 >> 3];
       A[b + 16 >> 3] = p;
       A[b + 8 >> 3] = f;
       break r;

      default:
       f = 0;
       if ((g | 0) >= 0) {
        while (1) {
         a = g;
         g = g - 1 | 0;
         f = f + A[(i + 160 | 0) + (a << 3) >> 3];
         if (a) {
          continue;
         }
         break;
        }
       }
       A[b >> 3] = j ? -f : f;
       break r;

      case 0:
      case 1:
       break t;
      }
     }
     f = 0;
     if ((g | 0) >= 0) {
      d = g;
      while (1) {
       a = d;
       d = a - 1 | 0;
       f = f + A[(i + 160 | 0) + (a << 3) >> 3];
       if (a) {
        continue;
       }
       break;
      }
     }
     A[b >> 3] = j ? -f : f;
     f = A[i + 160 >> 3] - f;
     c = 1;
     if ((g | 0) > 0) {
      while (1) {
       f = f + A[(i + 160 | 0) + (c << 3) >> 3];
       a = (c | 0) != (g | 0);
       c = c + 1 | 0;
       if (a) {
        continue;
       }
       break;
      }
     }
     A[b + 8 >> 3] = j ? -f : f;
     break r;
    }
    A[b >> 3] = -f;
    f = A[i + 168 >> 3];
    A[b + 16 >> 3] = -p;
    A[b + 8 >> 3] = -f;
   }
   eb = i + 560 | 0;
   return m & 7;
  }
  c = 1;
  while (1) {
   h = c;
   c = c + 1 | 0;
   if (!v[(i + 480 | 0) + (n - h << 2) >> 2]) {
    continue;
   }
   break;
  }
  h = g + h | 0;
  while (1) {
   j = d + g | 0;
   g = g + 1 | 0;
   A[(i + 320 | 0) + (j << 3) >> 3] = v[(t + g << 2) + 89904 >> 2];
   c = 0;
   f = 0;
   if ((d | 0) > 0) {
    while (1) {
     f = A[(c << 3) + a >> 3] * A[(i + 320 | 0) + (j - c << 3) >> 3] + f;
     c = c + 1 | 0;
     if ((d | 0) != (c | 0)) {
      continue;
     }
     break;
    }
   }
   A[(g << 3) + i >> 3] = f;
   if ((g | 0) < (h | 0)) {
    continue;
   }
   break;
  }
  g = h;
  continue;
 }
}

function FS(a, b, c, d, e) {
 var f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0;
 i = eb - 16 | 0;
 eb = i;
 a: {
  if (!Tc(d & 255)) {
   break a;
  }
  k = a + 1074992 | 0;
  f = k + B(b, 872) | 0;
  b: {
   j = e;
   e = x[a + 480192 >> 1];
   if (!(j | (!(v[a + 480180 >> 2] & 17825824) | !e))) {
    break b;
   }
   if (Aj(v[f + 656 >> 2])) {
    break b;
   }
   if (!v[f + 76 >> 2]) {
    break a;
   }
   c = v[f + 88 >> 2];
   if (!(v[f + 20 >> 2] | v[f + 24 >> 2]) | c & 1024) {
    break a;
   }
   c: {
    if (!(c & 512)) {
     break c;
    }
    c = v[a + 1298300 >> 2];
    if (!Dd(c)) {
     break c;
    }
    Dj(c, b, 0);
    break a;
   }
   a = fB(a, b);
   if ((a | 0) == 65535) {
    break a;
   }
   a = Gq(k + B(a, 872) | 0, f);
   t[a + 831 | 0] = 0;
   t[a + 805 | 0] = 0;
   u[a + 786 >> 1] = b + 1;
   v[a + 88 >> 2] = v[a + 88 >> 2] & -918529;
   Vo(a + 788 | 0);
   v[a + 696 >> 2] = 0;
   v[a + 88 >> 2] = v[a + 88 >> 2] | 2101248;
   v[f >> 2] = 0;
   v[f + 4 >> 2] = 0;
   v[f + 76 >> 2] = 0;
   v[f + 92 >> 2] = 0;
   v[f + 96 >> 2] = 0;
   v[f + 20 >> 2] = 0;
   v[f + 24 >> 2] = 0;
   break a;
  }
  m = v[f + 104 >> 2];
  c = c >>> 0 <= e >>> 0 ? c : 0;
  h = v[(c ? ((c << 2) + a | 0) + 900380 | 0 : f + 656 | 0) >> 2];
  d: {
   if (!h) {
    break d;
   }
   g = d - 1 | 0;
   c = x[$b(h + 236 | 0, g) >> 1];
   e = a + 1074312 | 0;
   Ib(i + 8 | 0, e, 104);
   e: {
    if (Fb(v[v[i + 8 >> 2] >> 2], v[i + 12 >> 2])) {
     Ib(i, e, 34);
     if (Fb(v[v[i >> 2] >> 2], v[i + 4 >> 2])) {
      break e;
     }
    }
    d = w[wb(h + 108 | 0, g) | 0];
   }
   if ((c - 1 & 65535) >>> 0 <= 3998) {
    m = (B(c, 104) + a | 0) + 484380 | 0;
    break d;
   }
   Ib(i + 8 | 0, e, 43);
   if (!Fb(v[v[i + 8 >> 2] >> 2], v[i + 12 >> 2])) {
    break d;
   }
   if (!Ij(w[h + 31 | 0])) {
    break a;
   }
  }
  if (w[f + 89 | 0] & 4) {
   break a;
  }
  n = a + 1074376 | 0;
  o = b >>> 0 <= 256 ? 256 : b;
  l = a + 1074312 | 0;
  p = b + 1 | 0;
  c = b;
  f: {
   g: {
    while (1) {
     if ((c | 0) == (o | 0)) {
      h: {
       c = 0;
       if (Aj(v[f + 656 >> 2])) {
        break h;
       }
       break g;
      }
     } else {
      g = (b | 0) == (c | 0);
      i: {
       if (!g & x[a + 480188 >> 1] > c >>> 0) {
        break i;
       }
       e = k + B(c, 872) | 0;
       if (!g & x[e + 786 >> 1] != (p | 0)) {
        break i;
       }
       g = v[e + 656 >> 2];
       if (!g) {
        break i;
       }
       j: {
        k: {
         l: {
          m: {
           n: {
            o: {
             p: {
              switch (w[g + 17 | 0] - 1 | 0) {
              case 0:
               if (!d) {
                break i;
               }
               j = (g | 0) == (h | 0) & w[e + 797 | 0] == (d | 0);
               if (!h) {
                break o;
               }
               if (j) {
                break l;
               }
               break i;

              case 1:
               if (!m | v[e + 104 >> 2] != (m | 0)) {
                break i;
               }
               if ((g | 0) == (h | 0)) {
                break j;
               }
               Ib(i + 8 | 0, l, 104);
               if (!Fb(v[v[i + 8 >> 2] >> 2], v[i + 12 >> 2])) {
                break j;
               }
               break i;

              case 3:
               break n;

              case 2:
               break p;

              default:
               break i;
              }
             }
             if (h) {
              break m;
             }
             j = (g | 0) == (h | 0);
            }
            if (j) {
             break j;
            }
            break i;
           }
           if (!h) {
            break i;
           }
           j = w[h + 34 | 0];
           if (!j) {
            break i;
           }
           if ((j | 0) == w[g + 34 | 0]) {
            break k;
           }
           break i;
          }
          if ((g | 0) != (h | 0)) {
           break i;
          }
         }
         if (!w[h + 34 | 0]) {
          break j;
         }
        }
        if (!w[e + 797 | 0] | w[g + 18 | 0] > 2) {
         break j;
        }
        g = w[e + 801 | 0];
        if (!g) {
         break j;
        }
        Wm(a, c & 65535, g | 256, 0);
        t[e + 801 | 0] = 0;
       }
       q: {
        r: {
         switch (w[v[e + 656 >> 2] + 18 | 0]) {
         case 0:
          Eo(a, e);
          v[e + 688 >> 2] = 0;
          if (!(w[e + 89 | 0] & 2)) {
           break q;
          }
          g = v[a + 1298300 >> 2];
          if (!Dd(g)) {
           break q;
          }
          Dj(g, c & 65535, 1);
          break q;

         case 1:
          Eo(a, e);
          if (!(w[e + 89 | 0] & 2)) {
           break q;
          }
          g = v[a + 1298300 >> 2];
          if (!Dd(g)) {
           break q;
          }
          xk(g, c & 65535);
          break q;

         case 2:
          break r;

         default:
          break q;
         }
        }
        g = v[e + 88 >> 2];
        v[e + 88 >> 2] = g | 4096;
        if (!(g & 512)) {
         break q;
        }
        if (!Dd(v[a + 1298300 >> 2])) {
         break q;
        }
        Ib(i + 8 | 0, l, 105);
        if (Fb(v[v[i + 8 >> 2] >> 2], v[i + 12 >> 2])) {
         break q;
        }
        xk(v[a + 1298300 >> 2], c & 65535);
       }
       if (v[e + 688 >> 2]) {
        break i;
       }
       v[e + 696 >> 2] = 0;
       v[e + 88 >> 2] = v[e + 88 >> 2] | 2101248;
      }
      c = c + 1 | 0;
      continue;
     }
     break;
    }
    if (!Tc(w[f + 797 | 0])) {
     break g;
    }
    d = mm(a, n, b, 2, 1) - 1 | 0;
    if ((d & 255) >>> 0 > 249) {
     break g;
    }
    d = v[_d(a + 906300 | 0, d) >> 2];
    if (!d) {
     break g;
    }
    e = 1;
    h = w[f + 801 | 0];
    if (!h) {
     break f;
    }
    c = hb[v[v[d >> 2] + 104 >> 2]](d, h, b) | 0;
    break f;
   }
   e = 0;
  }
  if (!(Li(v[f + 8 >> 2], v[f + 12 >> 2]) | c)) {
   break a;
  }
  s: {
   if (!(c & e)) {
    break s;
   }
   c = w[f + 798 | 0];
   if (c >>> 0 > 3 | (c | 0) == 1) {
    break s;
   }
   Wm(a, b, 255, 0);
   u[f + 800 >> 1] = 0;
  }
  e = fB(a, b);
  if ((e | 0) == 65535) {
   break a;
  }
  c = k + B(e, 872) | 0;
  t: {
   if (!(w[c + 89 | 0] & 2)) {
    break t;
   }
   d = v[a + 1298300 >> 2];
   if (!Dd(d)) {
    break t;
   }
   Dj(d, e, 1);
  }
  d = Gq(c, f);
  h = v[c + 88 >> 2];
  g = h & -917505;
  v[c + 88 >> 2] = g;
  t[d + 831 | 0] = 0;
  k = x[a + 480188 >> 1];
  t[d + 805 | 0] = 0;
  u[d + 786 >> 1] = b >>> 0 < k >>> 0 ? b + 1 | 0 : 0;
  u: {
   v: {
    switch (w[f + 798 | 0]) {
    case 2:
     Eo(a, d);
     if (!(w[c + 89 | 0] & 2)) {
      break u;
     }
     h = v[a + 1298300 >> 2];
     if (!Dd(h)) {
      break u;
     }
     xk(h, b);
     Ib(i + 8 | 0, l, 105);
     if (!Fb(v[v[i + 8 >> 2] >> 2], v[i + 12 >> 2])) {
      break u;
     }
     UB(v[a + 1298300 >> 2], b, e);
     break u;

    case 0:
     v[d + 696 >> 2] = 0;
     v[c + 88 >> 2] = g | 4096;
     if (!(h & 512)) {
      break u;
     }
     a = v[a + 1298300 >> 2];
     if (!Dd(a)) {
      break u;
     }
     Dj(a, b, 1);
     break u;

    case 3:
     v[c + 88 >> 2] = g | 4096;
     if (!(h & 512)) {
      break u;
     }
     if (!Dd(v[a + 1298300 >> 2])) {
      break u;
     }
     Ib(i + 8 | 0, l, 105);
     a = v[a + 1298300 >> 2];
     if (Fb(v[v[i + 8 >> 2] >> 2], v[i + 12 >> 2])) {
      UB(a, b, e);
      break u;
     }
     xk(a, b);
     break u;

    case 1:
     break v;

    default:
     break u;
    }
   }
   if (!(h & 512)) {
    break u;
   }
   a = v[a + 1298300 >> 2];
   if (!Dd(a)) {
    break u;
   }
   UB(a, b, e);
  }
  if (!v[d + 688 >> 2]) {
   v[d + 696 >> 2] = 0;
   v[c + 88 >> 2] = v[c + 88 >> 2] | 2101248;
  }
  v[f >> 2] = 0;
  v[f + 4 >> 2] = 0;
  v[f + 76 >> 2] = 0;
  v[f + 92 >> 2] = 0;
  v[f + 96 >> 2] = 0;
 }
 eb = i + 16 | 0;
}

function Lo(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, q = 0, r = 0, s = 0, y = 0, z = 0, A = 0, C = 0;
 f = eb + -64 | 0;
 eb = f;
 r = OB(v[a + 24 >> 2], w[a + 32 | 0]);
 y = Gj(r);
 c = y;
 e = v[a >> 2];
 d = Td(e, v[a + 4 >> 2]);
 a: {
  if (c >>> 0 > d >>> 0) {
   k = eb - 32 | 0;
   eb = k;
   c = c - d | 0;
   d = v[zb(a) >> 2];
   e = v[a + 4 >> 2];
   b: {
    if (c >>> 0 <= (d - e | 0) / 12 >>> 0) {
     e = eb - 16 | 0;
     eb = e;
     c = wv(e + 4 | 0, a, c);
     d = v[c + 4 >> 2];
     g = v[c + 8 >> 2];
     while (1) {
      if ((d | 0) == (g | 0)) {
       hc(c);
       eb = e + 16 | 0;
      } else {
       ST(d);
       d = d + 12 | 0;
       v[c + 4 >> 2] = d;
       continue;
      }
      break;
     }
     break b;
    }
    d = zb(a);
    d = wm(k + 12 | 0, Qp(a, Td(v[a >> 2], e) + c | 0), Td(v[a >> 2], v[a + 4 >> 2]), d);
    g = eb - 16 | 0;
    eb = g;
    c = lW(g + 4 | 0, d + 8 | 0, c);
    e = v[c >> 2];
    while (1) {
     if (v[c + 4 >> 2] != (e | 0)) {
      ST(e);
      e = v[c >> 2] + 12 | 0;
      v[c >> 2] = e;
      continue;
     }
     break;
    }
    ie(c);
    eb = g + 16 | 0;
    g = eb - 16 | 0;
    eb = g;
    h = zb(a);
    c = ub(g + 12 | 0, v[a + 4 >> 2]);
    i = ub(g + 8 | 0, v[a >> 2]);
    j = ub(g + 4 | 0, v[d + 4 >> 2]);
    e = v[c >> 2];
    i = v[i >> 2];
    c = eb + -64 | 0;
    eb = c;
    j = v[j >> 2];
    v[c + 56 >> 2] = j;
    v[c + 60 >> 2] = e;
    v[c + 52 >> 2] = j;
    h = zg(c + 24 | 0, h, c + 52 | 0, c + 56 | 0);
    v[c + 16 >> 2] = v[h + 8 >> 2];
    j = v[h + 4 >> 2];
    v[c + 8 >> 2] = v[h >> 2];
    v[c + 12 >> 2] = j;
    yg(c + 36 | 0, c + 8 | 0);
    while (1) {
     if (Ed(e, i)) {
      EC(Pp(v[c + 56 >> 2]), $k(e));
      e = ik(c + 60 | 0);
      ik(c + 56 | 0);
      e = v[e >> 2];
      continue;
     }
     break;
    }
    xg(c + 36 | 0);
    j = v[c + 56 >> 2];
    if (!w[c + 48 | 0]) {
     h = eb - 16 | 0;
     eb = h;
     e = ub(h + 12 | 0, v[v[c + 44 >> 2] >> 2]);
     n = v[ub(h + 8 | 0, v[v[c + 40 >> 2] >> 2]) >> 2];
     i = eb - 16 | 0;
     eb = i;
     e = v[e >> 2];
     v[i + 12 >> 2] = e;
     while (1) {
      if (vi(e, n)) {
       tf(Ax(e));
       e = v[vm(i + 12 | 0) >> 2];
       continue;
      }
      break;
     }
     eb = i + 16 | 0;
     eb = h + 16 | 0;
    }
    eb = c - -64 | 0;
    v[d + 4 >> 2] = j;
    Sb(a, d + 4 | 0);
    Sb(a + 4 | 0, d + 8 | 0);
    Sb(zb(a), mc(d));
    v[d >> 2] = v[d + 4 >> 2];
    eb = g + 16 | 0;
    c = v[d + 4 >> 2];
    while (1) {
     e = v[d + 8 >> 2];
     if ((e | 0) != (c | 0)) {
      e = e - 12 | 0;
      v[d + 8 >> 2] = e;
      tf(e);
      continue;
     }
     break;
    }
    c = v[d >> 2];
    if (c) {
     vs(d);
     Bb(c);
    }
   }
   eb = k + 32 | 0;
   break a;
  }
  if (c >>> 0 < d >>> 0) {
   YT(a, e + B(c, 12) | 0);
  }
 }
 if (b) {
  c = a + 12 | 0;
  Mq(c, ce(c));
  A = zb(c), C = 0, v[A >> 2] = C;
  d = c;
  c = fc(c);
  v[d >> 2] = c;
  v[c >> 2] = 0;
  v[a + 28 >> 2] = 0;
 }
 h = Mb(f + 52 | 0);
 c = v[a + 24 >> 2];
 c = _u(v[c + 484344 >> 2], v[c + 484348 >> 2]);
 v[31601] = 0;
 i = T(625, f + 40 | 0, c | 0, 28524) | 0;
 c = v[31601];
 v[31601] = 0;
 c: {
  if ((c | 0) != 1) {
   g = a + 12 | 0;
   while (1) {
    if ((l | 0) == (y | 0)) {
     nd(i);
     ec(h);
     eb = f - -64 | 0;
     return;
    }
    c = v[a + 24 >> 2];
    d = v[c + 484344 >> 2];
    c = v[c + 484348 >> 2];
    j = x[$b(v[r >> 2], l) >> 1];
    d = bU(d, c, j);
    v[f + 36 >> 2] = d;
    c = Ud(v[a >> 2], l);
    d: {
     e: {
      f: {
       if (b) {
        v[31601] = 0;
        t[f + 20 | 0] = 0;
        R(801, c | 0, d | 0, f + 20 | 0);
        d = v[31601];
        v[31601] = 0;
        if ((d | 0) != 1) {
         break f;
        }
        d = M() | 0;
        break e;
       }
       v[31601] = 0;
       N(757, c | 0, d | 0);
       d = v[31601];
       v[31601] = 0;
       if ((d | 0) != 1) {
        break f;
       }
       d = M() | 0;
       break e;
      }
      if (!Vi(r, l & 65535)) {
       break d;
      }
      v[f + 20 >> 2] = b ? 0 : v[c + 4 >> 2];
      c = f + 20 | 0;
      s = v[Gb(c, f + 36 | 0) >> 2];
      n = Of(g);
      d = x[$b(v[i >> 2], j) >> 1];
      if ((d | 0) != 65535) {
       d = $T(g, x[an(c, d, s) >> 1], v[f + 24 >> 2]);
       g: {
        if (Yg(d, Of(g))) {
         c = $T(g, x[an(c, x[$b(v[i >> 2], j) >> 1], v[f + 36 >> 2]) >> 1], v[f + 24 >> 2]);
         break g;
        }
        c = Of(g);
       }
       v[f + 32 >> 2] = d;
       while (1) {
        h: {
         if (!Yg(d, c)) {
          break d;
         }
         e = Mb(f + 20 | 0);
         d = Rn(td(d) + 8 | 0);
         v[31601] = 0;
         N(802, e | 0, d | 0);
         d = v[31601];
         v[31601] = 0;
         if ((d | 0) != 1) {
          d = Ec(f + 12 | 0, n);
          k = an(f + 4 | 0, l, v[td(v[f + 32 >> 2]) + 4 >> 2]);
          d = v[d >> 2];
          v[31601] = 0;
          d = aa(803, g | 0, d | 0, k | 0, e | 0) | 0;
          k = v[31601];
          v[31601] = 0;
          if ((k | 0) == 1) {
           break h;
          }
          v[f + 16 >> 2] = d;
          n = v[$g(f + 16 | 0) >> 2];
          Be(e);
          d = v[$g(f + 32 | 0) >> 2];
          continue;
         }
        }
        break;
       }
       d = M() | 0;
       Be(e);
       break e;
      }
      q = Vb(v[v[a + 24 >> 2] + 484344 >> 2], j);
      c = x[v[v[q + 48 >> 2] + 12 >> 2] + 480188 >> 1];
      v[31601] = 0;
      t[f + 20 | 0] = 0;
      R(778, h | 0, c | 0, f + 20 | 0);
      c = v[31601];
      v[31601] = 0;
      if ((c | 0) != 1) {
       o = v[f + 36 >> 2];
       i: while (1) {
        j: {
         if ((o | 0) == (s | 0)) {
          if (s) {
           break d;
          }
          A = $b(v[i >> 2], j), C = l, u[A >> 1] = C;
          break d;
         }
         c = 1;
         k = 0;
         e = v[v[q + 48 >> 2] + 12 >> 2];
         o = o - 1 | 0;
         d = ld(v[q >> 2], e, o, 0);
         while (1) {
          if (c >>> 0 < 16 & x[e + 480188 >> 1] > k >>> 0) {
           z = wb(v[h >> 2], k);
           e = w[z | 0];
           k: {
            l: {
             m: {
              switch (w[d + 3 | 0] - 19 | 0) {
              case 1:
               m = w[d + 5 | 0];
               if ((m & 240) == 176) {
                break l;
               }
               break k;

              case 0:
               break m;

              default:
               break k;
              }
             }
             m = w[d + 5 | 0];
             if ((m & 240) != 96) {
              break k;
             }
            }
            t[z | 0] = m & 15;
            m = w[wb(v[h >> 2], k) | 0];
            e = m ? m : e;
           }
           d = d + 6 | 0;
           k = k + 1 | 0;
           c = B((e & 255) + 1 | 0, c);
           e = v[v[q + 48 >> 2] + 12 >> 2];
           continue;
          } else {
           n: {
            if (c >>> 0 <= 1) {
             continue i;
            }
            e = Mb(f + 20 | 0);
            v[31601] = 0;
            N(802, e | 0, c | 0);
            c = v[31601];
            v[31601] = 0;
            if ((c | 0) == 1) {
             break n;
            }
            c = Ec(f, n);
            d = an(f + 4 | 0, l, o);
            c = v[c >> 2];
            v[31601] = 0;
            n = aa(803, g | 0, c | 0, d | 0, e | 0) | 0;
            c = v[31601];
            v[31601] = 0;
            if ((c | 0) == 1) {
             break j;
            }
            Be(e);
            continue i;
           }
          }
          break;
         }
        }
        break;
       }
       d = M() | 0;
       Be(e);
       break e;
      }
      d = M() | 0;
     }
     nd(i);
     break c;
    }
    l = l + 1 | 0;
    continue;
   }
  }
  d = M() | 0;
 }
 ec(h);
 P(d | 0);
 p();
}

function Wd(a, b, c, d, e, f, g, h, i) {
 var j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, w = 0, x = 0, y = 0, z = 0, A = 0, B = 0, C = 0, D = 0, F = 0, G = 0, H = 0, I = 0, J = 0, K = 0, L = 0, M = 0, N = 0, O = 0, P = 0, Q = 0, R = 0, S = 0;
 k = eb - 96 | 0;
 eb = k;
 u = i & 65535;
 o = (e ^ i) & -2147483648;
 r = e & 65535;
 z = r;
 R = i >>> 16 & 32767;
 S = e >>> 16 & 32767;
 a: {
  b: {
   if (R - 32767 >>> 0 > 4294934529 & S - 32767 >>> 0 >= 4294934530) {
    break b;
   }
   s = e & 2147483647;
   q = s;
   j = d;
   if (!(!d & (q | 0) == 2147418112 ? !(b | c) : q >>> 0 < 2147418112)) {
    m = d;
    o = e | 32768;
    break a;
   }
   s = i & 2147483647;
   p = s;
   e = h;
   if (!(!e & (p | 0) == 2147418112 ? !(f | g) : p >>> 0 < 2147418112)) {
    m = e;
    o = i | 32768;
    b = f;
    c = g;
    break a;
   }
   if (!(b | j | (q ^ 2147418112 | c))) {
    if (!(e | f | (g | p))) {
     o = 2147450880;
     b = 0;
     c = 0;
     break a;
    }
    o = o | 2147418112;
    b = 0;
    c = 0;
    break a;
   }
   if (!(e | f | (p ^ 2147418112 | g))) {
    e = b | j;
    d = c | q;
    b = 0;
    c = 0;
    if (!(d | e)) {
     o = 2147450880;
     break a;
    }
    o = o | 2147418112;
    break a;
   }
   if (!(b | j | (c | q))) {
    b = 0;
    c = 0;
    break a;
   }
   if (!(e | f | (g | p))) {
    b = 0;
    c = 0;
    break a;
   }
   if ((q | 0) == 65535 | q >>> 0 < 65535) {
    j = !(d | r);
    i = j ? b : d;
    s = j << 6;
    e = E(i) + 32 | 0;
    i = E(j ? c : r);
    i = s + ((i | 0) == 32 ? e : i) | 0;
    _f(k + 80 | 0, b, c, d, r, i - 15 | 0);
    t = 16 - i | 0;
    d = v[k + 88 >> 2];
    z = v[k + 92 >> 2];
    c = v[k + 84 >> 2];
    b = v[k + 80 >> 2];
   }
   if (p >>> 0 > 65535) {
    break b;
   }
   i = !(h | u);
   e = i ? f : h;
   r = i << 6;
   j = E(e) + 32 | 0;
   e = E(i ? g : u);
   e = r + ((e | 0) == 32 ? j : e) | 0;
   _f(k - -64 | 0, f, g, h, u, e - 15 | 0);
   t = (t - e | 0) + 16 | 0;
   h = v[k + 72 >> 2];
   u = v[k + 76 >> 2];
   f = v[k + 64 >> 2];
   g = v[k + 68 >> 2];
  }
  e = f;
  f = g << 15 | f >>> 17;
  i = e << 15;
  e = 0;
  w = i & -32768;
  L = c;
  s = Aua(w, e, c, 0);
  e = gb;
  A = e;
  M = f;
  q = b;
  c = Aua(f, 0, b, 0);
  b = c + s | 0;
  f = gb + e | 0;
  i = b;
  c = b >>> 0 < c >>> 0 ? f + 1 | 0 : f;
  f = b;
  j = 0;
  b = Aua(q, l, w, l);
  p = j + b | 0;
  e = gb + f | 0;
  e = b >>> 0 > p >>> 0 ? e + 1 | 0 : e;
  r = e;
  N = (f | 0) == (e | 0) & j >>> 0 > p >>> 0 | e >>> 0 < f >>> 0;
  O = d;
  x = Aua(w, l, d, 0);
  P = gb;
  b = Aua(L, l, M, l);
  y = b + x | 0;
  j = gb + P | 0;
  j = b >>> 0 > y >>> 0 ? j + 1 | 0 : j;
  b = u << 15 | h >>> 17;
  B = h << 15 | g >>> 17;
  d = Aua(B, 0, q, l);
  C = d + y | 0;
  f = gb + j | 0;
  f = d >>> 0 > C >>> 0 ? f + 1 | 0 : f;
  D = f;
  d = (c | 0) == (A | 0) & i >>> 0 < s >>> 0 | c >>> 0 < A >>> 0;
  F = c + C | 0;
  f = d + f | 0;
  f = c >>> 0 > F >>> 0 ? f + 1 | 0 : f;
  u = f;
  g = F;
  c = f;
  G = z | 65536;
  z = Aua(w, l, G, n);
  Q = gb;
  d = Aua(O, m, M, l);
  H = d + z | 0;
  e = gb + Q | 0;
  e = d >>> 0 > H >>> 0 ? e + 1 | 0 : e;
  i = e;
  I = b | -2147483648;
  b = Aua(I, 0, q, l);
  J = b + H | 0;
  f = gb + e | 0;
  f = b >>> 0 > J >>> 0 ? f + 1 | 0 : f;
  d = Aua(B, m, L, l);
  b = d + J | 0;
  K = f;
  f = f + gb | 0;
  A = b;
  s = b >>> 0 < d >>> 0 ? f + 1 | 0 : f;
  f = b;
  b = 0;
  q = b + g | 0;
  e = c + f | 0;
  e = b >>> 0 > q >>> 0 ? e + 1 | 0 : e;
  w = e;
  f = e;
  b = q + N | 0;
  c = b >>> 0 < q >>> 0 ? f + 1 | 0 : f;
  t = ((S + R | 0) + t | 0) - 16383 | 0;
  d = Aua(I, m, L, l);
  h = gb;
  e = Aua(G, m, M, l);
  g = e + d | 0;
  f = gb + h | 0;
  f = e >>> 0 > g >>> 0 ? f + 1 | 0 : f;
  n = (h | 0) == (f | 0) & d >>> 0 > g >>> 0 | f >>> 0 < h >>> 0;
  h = f;
  e = Aua(B, m, O, m);
  d = e + g | 0;
  f = gb + f | 0;
  f = d >>> 0 < e >>> 0 ? f + 1 | 0 : f;
  e = f;
  g = (f | 0) == (h | 0) & d >>> 0 < g >>> 0 | f >>> 0 < h >>> 0;
  f = 0;
  h = g;
  g = g + n | 0;
  f = h >>> 0 > g >>> 0 ? 1 : f;
  h = g;
  g = Aua(I, m, G, m);
  h = h + g | 0;
  f = gb + f | 0;
  N = h;
  g = g >>> 0 > h >>> 0 ? f + 1 | 0 : f;
  h = d;
  l = e;
  e = (j | 0) == (P | 0) & x >>> 0 > y >>> 0 | j >>> 0 < P >>> 0;
  f = 0;
  j = (j | 0) == (D | 0) & y >>> 0 > C >>> 0 | j >>> 0 > D >>> 0;
  n = j;
  j = e + j | 0;
  e = (n >>> 0 > j >>> 0 ? 1 : f) + l | 0;
  f = g;
  d = d + j | 0;
  e = d >>> 0 < j >>> 0 ? e + 1 | 0 : e;
  n = e;
  x = d;
  d = (e | 0) == (l | 0) & d >>> 0 < h >>> 0 | e >>> 0 < l >>> 0;
  e = d;
  d = d + N | 0;
  f = e >>> 0 > d >>> 0 ? f + 1 | 0 : f;
  j = d;
  h = f;
  e = Aua(B, m, G, m);
  l = gb;
  g = Aua(I, m, O, m);
  d = g + e | 0;
  f = gb + l | 0;
  f = d >>> 0 < g >>> 0 ? f + 1 | 0 : f;
  g = f;
  f = (l | 0) == (f | 0) & d >>> 0 < e >>> 0 | f >>> 0 < l >>> 0;
  y = g + j | 0;
  e = f + h | 0;
  e = g >>> 0 > y >>> 0 ? e + 1 | 0 : e;
  l = y;
  h = e;
  j = d;
  e = 0;
  d = e + x | 0;
  f = j + n | 0;
  f = d >>> 0 < e >>> 0 ? f + 1 | 0 : f;
  e = f;
  g = (n | 0) == (f | 0) & d >>> 0 < x >>> 0 | f >>> 0 < n >>> 0;
  f = h;
  h = g;
  g = g + l | 0;
  f = h >>> 0 > g >>> 0 ? f + 1 | 0 : f;
  x = g;
  g = f;
  h = d;
  j = e;
  e = (s | 0) == (K | 0) & A >>> 0 < J >>> 0 | s >>> 0 < K >>> 0;
  d = (i | 0) == (Q | 0) & z >>> 0 > H >>> 0 | i >>> 0 < Q >>> 0;
  i = (i | 0) == (K | 0) & H >>> 0 > J >>> 0 | i >>> 0 > K >>> 0;
  d = d + i | 0;
  d = d + e | 0;
  n = s;
  i = n + h | 0;
  e = d + j | 0;
  f = g;
  d = i;
  e = d >>> 0 < n >>> 0 ? e + 1 | 0 : e;
  h = (e | 0) == (j | 0) & h >>> 0 > d >>> 0 | e >>> 0 < j >>> 0;
  g = h + x | 0;
  f = h >>> 0 > g >>> 0 ? f + 1 | 0 : f;
  j = g;
  g = f;
  h = d;
  f = 0;
  i = e;
  n = (u | 0) == (w | 0) & q >>> 0 < F >>> 0 | u >>> 0 > w >>> 0;
  l = n;
  n = n + ((u | 0) == (D | 0) & C >>> 0 > F >>> 0 | u >>> 0 < D >>> 0) | 0;
  e = e + (l >>> 0 > n >>> 0 ? 1 : f) | 0;
  f = g;
  d = d + n | 0;
  e = d >>> 0 < n >>> 0 ? e + 1 | 0 : e;
  h = (e | 0) == (i | 0) & d >>> 0 < h >>> 0 | e >>> 0 < i >>> 0;
  g = h;
  h = h + j | 0;
  f = g >>> 0 > h >>> 0 ? f + 1 | 0 : f;
  i = f;
  c: {
   if (f & 65536) {
    t = t + 1 | 0;
    break c;
   }
   j = r >>> 31 | 0;
   g = 0;
   f = i << 1 | h >>> 31;
   h = h << 1 | e >>> 31;
   i = f;
   f = e << 1 | d >>> 31;
   d = d << 1 | c >>> 31;
   e = f;
   f = r << 1 | p >>> 31;
   p = p << 1;
   r = f;
   f = c << 1 | b >>> 31;
   b = b << 1 | j;
   c = f | g;
  }
  if ((t | 0) >= 32767) {
   o = o | 2147418112;
   b = 0;
   c = 0;
   break a;
  }
  d: {
   if ((t | 0) <= 0) {
    g = 1 - t | 0;
    if (g >>> 0 <= 127) {
     f = t + 127 | 0;
     _f(k + 48 | 0, p, r, b, c, f);
     _f(k + 32 | 0, d, e, h, i, f);
     bn(k + 16 | 0, p, r, b, c, g);
     bn(k, d, e, h, i, g);
     p = v[k + 32 >> 2] | v[k + 16 >> 2] | (v[k + 48 >> 2] | v[k + 56 >> 2] | (v[k + 52 >> 2] | v[k + 60 >> 2])) != 0;
     r = v[k + 36 >> 2] | v[k + 20 >> 2];
     b = v[k + 40 >> 2] | v[k + 24 >> 2];
     c = v[k + 44 >> 2] | v[k + 28 >> 2];
     d = v[k >> 2];
     e = v[k + 4 >> 2];
     g = v[k + 8 >> 2];
     f = v[k + 12 >> 2];
     break d;
    }
    b = 0;
    c = 0;
    break a;
   }
   g = h;
   f = i & 65535 | t << 16;
  }
  m = g | m;
  o = f | o;
  if (!(!b & (c | 0) == -2147483648 ? !(p | r) : (c | 0) > 0 | (c | 0) >= 0)) {
   b = d + 1 | 0;
   j = b ? e : e + 1 | 0;
   e = o;
   c = j;
   d = !(j | b);
   m = d + m | 0;
   o = d >>> 0 > m >>> 0 ? e + 1 | 0 : e;
   break a;
  }
  if (b | p | (c ^ -2147483648 | r)) {
   b = d;
   c = e;
   break a;
  }
  f = e;
  b = d & 1;
  c = b;
  b = b + d | 0;
  f = c >>> 0 > b >>> 0 ? f + 1 | 0 : f;
  c = f;
  d = (e | 0) == (f | 0) & b >>> 0 < d >>> 0 | e >>> 0 > f >>> 0;
  f = o;
  m = d + m | 0;
  o = m >>> 0 < d >>> 0 ? f + 1 | 0 : f;
 }
 v[a >> 2] = b;
 v[a + 4 >> 2] = c;
 v[a + 8 >> 2] = m;
 v[a + 12 >> 2] = o;
 eb = k + 96 | 0;
}

function v1(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, q = 0, r = 0, s = 0, u = 0, x = 0, y = 0;
 e = eb - 32 | 0;
 eb = e;
 a: {
  if ((d | 0) <= 0) {
   break a;
  }
  v[e + 8 >> 2] = d;
  v[e + 20 >> 2] = b;
  v[e + 16 >> 2] = 214748364;
  x = e, y = B(v[Gb(e + 20 | 0, e + 16 | 0) >> 2], 20), v[x + 24 >> 2] = y;
  so(c, v[Gb(e + 8 | 0, e + 24 | 0) >> 2]);
  v[e + 12 >> 2] = b;
  v[e + 8 >> 2] = a;
  while (1) {
   b: {
    c: {
     d: {
      e: {
       if ((d | 0) <= 0) {
        break e;
       }
       g = Jh(a, b, i);
       h = Jh(a, b, i + 4 | 0);
       f = Jh(a, b, i + 5 | 0);
       x = e, y = Jh(a, b, i + 6 | 0) << 8 | Jh(a, b, i + 7 | 0), v[x + 28 >> 2] = y;
       o = h << 8 | f;
       u = i + 8 | 0;
       f: {
        g: {
         switch (g | 0) {
         case 0:
          i = 0;
          if (d >>> 0 < o >>> 0) {
           i = cc(8);
           v[31601] = 0;
           a = Q(188, i | 0) | 0;
           b = v[31601];
           v[31601] = 0;
           if ((b | 0) != 1) {
            break f;
           }
           break d;
          }
          while (1) {
           if ((i | 0) != (o | 0)) {
            x = e, y = Jh(a, b, i + u | 0), t[x + 24 | 0] = y;
            ro(c, e + 24 | 0);
            i = i + 1 | 0;
            continue;
           }
           break;
          }
          ;
          s = o;
          break b;

         case 1:
          break g;

         default:
          break e;
         }
        }
        ti(e + 28 | 0, d);
        s = v[e + 28 >> 2];
        q = Jh(a, b, i + 10 | 0);
        t[e + 24 | 0] = q;
        ro(c, e + 24 | 0);
        j = i + 11 | 0;
        o = o + 3 & 65532;
        i = s - 1 | 0;
        h = 0;
        l = 0;
        r = 0;
        n = 0;
        while (1) {
         if ((i | 0) <= 0) {
          break c;
         }
         f = Pg(j, h, 1, e + 8 | 0);
         h: {
          i: {
           j: {
            k: {
             l: {
              if ((l | 0) <= 7) {
               if (f) {
                g = h;
                break i;
               }
               g = h + 1 | 0;
               n = 8;
               break l;
              }
              g = h + 1 | 0;
              m: {
               if (!f) {
                m = e + 8 | 0;
                if (!Pg(j, g, 1, m)) {
                 break i;
                }
                k = 2;
                n: {
                 o: {
                  f = h + 2 | 0;
                  if (!Pg(j, f, 1, m)) {
                   break o;
                  }
                  k = 3;
                  f = h + 3 | 0;
                  if (!Pg(j, f, 1, m)) {
                   break o;
                  }
                  k = Pg(j, f, 3, m);
                  g = h + 6 | 0;
                  break n;
                 }
                 g = f + 1 | 0;
                }
                f = 4;
                p: {
                 q: {
                  r: {
                   h = ((n << 3) + k | 0) - 17 | 0;
                   s: {
                    if ((h | 0) < 0) {
                     a = cc(8);
                     v[31601] = 0;
                     b = Q(188, a | 0) | 0;
                     c = v[31601];
                     v[31601] = 0;
                     if ((c | 0) != 1) {
                      break r;
                     }
                     break s;
                    }
                    if (h >>> 0 < 56) {
                     break p;
                    }
                    a = cc(8);
                    v[31601] = 0;
                    b = Q(188, a | 0) | 0;
                    c = v[31601];
                    v[31601] = 0;
                    if ((c | 0) != 1) {
                     break q;
                    }
                   }
                   b = M() | 0;
                   jc(a);
                   P(b | 0);
                   p();
                  }
                  ca(b | 0, 24440, 162);
                  p();
                 }
                 ca(b | 0, 24440, 162);
                 p();
                }
                n = w[h + 24480 | 0];
                if ((n | 0) != 8) {
                 break k;
                }
                break m;
               }
               f = 4;
               if ((n | 0) != 8) {
                break k;
               }
              }
              n = 8;
              f = 1;
              if ((r | 0) > 19) {
               break k;
              }
             }
             f = 0;
             break j;
            }
            r = r + 8 | 0;
           }
           while (1) {
            if (!((f | 0) < 0 | (i | 0) <= 0)) {
             k = (g | 0) / 8 | 0;
             h = k + j | 0;
             m = Jh(v[e + 8 >> 2], v[e + 12 >> 2], h);
             q = q - qd((Jh(v[e + 8 >> 2], v[e + 12 >> 2], h + 1 | 0) << 8 | m << 16 | Jh(v[e + 8 >> 2], v[e + 12 >> 2], h + 2 | 0)) << (g - (k << 3) | 0) + 8, 32 - n | 0) | 0;
             t[e + 24 | 0] = q;
             ro(c, e + 24 | 0);
             f = f - 1 | 0;
             i = i - 1 | 0;
             g = g + n | 0;
             continue;
            }
            break;
           }
           l = (l | 0) == 31 ? 31 : l + 1 | 0;
           h = g;
           break h;
          }
          t: {
           u: {
            v: {
             f = g + 1 | 0;
             if (!Pg(j, f, 1, e + 8 | 0)) {
              h = 2;
              break v;
             }
             f = g + 2 | 0;
             if (!Pg(j, f, 1, e + 8 | 0)) {
              h = 4;
              break v;
             }
             f = g + 3 | 0;
             if (!Pg(j, f, 1, e + 8 | 0)) {
              h = 6;
              break v;
             }
             f = g + 5 | 0;
             h = e + 8 | 0;
             if (!Pg(j, g + 4 | 0, 1, h)) {
              g = g + 8 | 0;
              f = Pg(j, f, 3, h) + 8 | 0;
              break t;
             }
             g = g + 10 | 0;
             h = 16;
             f = Pg(j, f, 5, e + 8 | 0);
             break u;
            }
            g = f + 2 | 0;
            f = Pg(j, f + 1 | 0, 1, e + 8 | 0);
           }
           f = f + h | 0;
          }
          w: {
           if (Pg(j, g, 1, e + 8 | 0)) {
            k = -256;
            h = 12;
            break w;
           }
           g = g + 1 | 0;
           h = Pg(j, g, 1, e + 8 | 0);
           k = h ? -4352 : 0;
           h = h ? 14 : 8;
          }
          m = g + 1 | 0;
          g = Pg(j, m, h, e + 8 | 0);
          if (f >>> 0 >= 3) {
           l = l - ((f | 0) != 3) | 0;
           l = ((l | 0) <= 1 ? 1 : l) - 1 | 0;
          }
          k = (g ^ -1) + k | 0;
          g = Sc(v[c >> 2], v[c + 4 >> 2]) + k | 0;
          if (g >>> 0 < k >>> 0) {
           h = h + m | 0;
           while (1) {
            if ((f | 0) <= 0 | (i | 0) <= 0) {
             break h;
            }
            q = w[wb(v[c >> 2], g) | 0];
            t[e + 24 | 0] = q;
            ro(c, e + 24 | 0);
            i = i - 1 | 0;
            g = g + 1 | 0;
            f = f - 1 | 0;
            continue;
           }
          }
          i = cc(8);
          v[31601] = 0;
          a = Q(188, i | 0) | 0;
          b = v[31601];
          v[31601] = 0;
          if ((b | 0) == 1) {
           break d;
          }
          ca(a | 0, 24440, 162);
          p();
         }
         r = r - (r >> 3) | 0;
         continue;
        }
       }
       ca(a | 0, 24440, 162);
       p();
      }
      i = lc(v[c >> 2], v[c + 4 >> 2]) ^ 1;
      break a;
     }
     a = M() | 0;
     jc(i);
     P(a | 0);
     p();
    }
    v[e + 28 >> 2] = i;
   }
   d = d - s | 0;
   i = o + u | 0;
   continue;
  }
 }
 eb = e + 32 | 0;
 return i | 0;
}

function Rsa(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, q = 0, r = 0, s = 0, z = 0, A = 0;
 f = eb - 320 | 0;
 eb = f;
 xc(b);
 d = eb - 16 | 0;
 eb = d;
 h = f + 102 | 0;
 s_(d + 8 | 0, h);
 g = v[d + 12 >> 2];
 ic(d, v[b >> 2], v[b + 8 >> 2], v[d + 8 >> 2], v[d + 12 >> 2]);
 i = v[d + 4 >> 2];
 if ((i | 0) == (g | 0)) {
  Ub(b, v[d + 12 >> 2]);
 }
 eb = d + 16 | 0;
 a: {
  b: {
   c: {
    if ((g | 0) != (i | 0)) {
     break c;
    }
    if (!u_(h)) {
     break c;
    }
    if (!Lb(v[b >> 2], v[b + 8 >> 2], Ac(t_(w[f + 318 | 0], w[f + 319 | 0]), gb))) {
     break c;
    }
    e = 1;
    if ((c | 0) == 64) {
     break c;
    }
    Cd(a, 2);
    dg(a);
    v[a + 480188 >> 2] = 524296;
    z = a, A = Te(455e3), v[z + 480204 >> 2] = A;
    Kb(a + 1074312 | 0, 110, 1);
    v[a + 480208 >> 2] = v[a + 480208 >> 2] | 16777216;
    d = f + 72 | 0;
    Ue(d, 2, f + 133 | 0);
    e = f + 88 | 0;
    Bc(e, d);
    yb(a + 1298308 | 0, e);
    j = a + 946304 | 0;
    l = a + 484380 | 0;
    k = a + 480280 | 0;
    sb(e);
    m = f + 165 | 0;
    e = 0;
    d: {
     e: {
      while (1) {
       if ((e | 0) == 8) {
        f: {
         d = Wb(v[a + 484360 >> 2], w[a + 484376 | 0]);
         o = w[f + 318 | 0];
         m = o + 1 | 0;
         _j(d, b, m, 65535, 65535);
         d = Mb(f + 88 | 0);
         v[31601] = 0;
         R(234, b | 0, d | 0, m | 0);
         e = v[31601];
         v[31601] = 0;
         if ((e | 0) == 1) {
          break f;
         }
         z = f, A = vb(v[d >> 2]), v[z + 72 >> 2] = A;
         e = vb(v[d + 4 >> 2]);
         while (1) {
          g = v[f + 72 >> 2];
          q = Hb(g, e);
          if (q) {
           if ((w[g | 0] - 1 & 255) >>> 0 > 7) {
            break d;
           }
           xe(f + 72 | 0);
           continue;
          }
          break;
         }
         z = a, A = w[wb(v[d >> 2], 0) | 0], v[z + 480196 >> 2] = A;
         e = w[f + 317 | 0];
         h = w[f + 319 | 0];
         g = Mb(f + 72 | 0);
         v[31601] = 0;
         n = h + 1 | 0;
         R(234, b | 0, g | 0, n | 0);
         h = v[31601];
         v[31601] = 0;
         g: {
          if ((h | 0) == 1) {
           break g;
          }
          v[31601] = 0;
          h = a + 484344 | 0;
          N(223, h | 0, n | 0);
          i = v[31601];
          v[31601] = 0;
          if ((i | 0) == 1) {
           break g;
          }
          r = e + 1 | 0;
          if (!(c & 1)) {
           break e;
          }
          c = 0;
          while (1) {
           if ((c | 0) == (n | 0)) {
            break e;
           }
           e = w[wb(v[g >> 2], c) | 0];
           v[31601] = 0;
           e = T(196, h | 0, e | 0, r | 0) | 0;
           i = v[31601];
           v[31601] = 0;
           h: {
            if ((i | 0) != 1) {
             if (!e) {
              break e;
             }
             i = 0;
             l = Vb(v[h >> 2], w[wb(v[g >> 2], c) | 0]);
             i: while (1) {
              s = i & 65535;
              if (s >>> 0 > 7) {
               break h;
              }
              i = i + 1 | 0;
              e = 0;
              while (1) {
               if (y[l + 12 >> 2] <= e >>> 0) {
                continue i;
               }
               v[31601] = 0;
               j = Q(197, b | 0) | 0;
               k = v[31601];
               v[31601] = 0;
               j: {
                k: {
                 if ((k | 0) != 1) {
                  j = j << 24 >> 24;
                  if ((j | 0) >= 0) {
                   break k;
                  }
                  e = (j & 127) + e | 0;
                  break j;
                 }
                 break b;
                }
                k = ld(v[l >> 2], v[v[l + 48 >> 2] + 12 >> 2], e, s);
                if ((j | 0) == 1) {
                 t[k | 0] = 254;
                 break j;
                }
                if ((j - 1 & 255) >>> 0 > 96) {
                 break j;
                }
                t[k + 1 | 0] = i;
                t[k | 0] = j + 12;
               }
               e = e + 1 | 0;
               continue;
              }
             }
            }
            break b;
           }
           c = c + 1 | 0;
           continue;
          }
         }
         break b;
        }
       } else {
        h = f + 88 | 0;
        d = m + B(e, 19) | 0;
        SD(h, d);
        g = f + 72 | 0;
        Bc(g, h);
        em((k + (e << 5) | 0) + 9 | 0, g);
        sb(g);
        e = e + 1 | 0;
        i = l + B(e, 104) | 0;
        md(i, 2);
        t[f + 83 | 0] = 0;
        g = w[d + 15 | 0] | w[d + 16 | 0] << 8 | (w[d + 17 | 0] << 16 | w[d + 18 | 0] << 24);
        t[f + 79 | 0] = g;
        t[f + 80 | 0] = g >>> 8;
        t[f + 81 | 0] = g >>> 16;
        t[f + 82 | 0] = g >>> 24;
        g = w[d + 12 | 0] | w[d + 13 | 0] << 8 | (w[d + 14 | 0] << 16 | w[d + 15 | 0] << 24);
        d = w[d + 8 | 0] | w[d + 9 | 0] << 8 | (w[d + 10 | 0] << 16 | w[d + 11 | 0] << 24);
        v[f + 16 >> 2] = v[f + 80 >> 2];
        v[f + 72 >> 2] = d;
        v[f + 76 >> 2] = g;
        d = v[f + 76 >> 2];
        v[f + 8 >> 2] = v[f + 72 >> 2];
        v[f + 12 >> 2] = d;
        Qk(i, 1, f + 8 | 0);
        v[i + 24 >> 2] = 8215;
        d = f + 60 | 0;
        Bc(d, h);
        zc(j + (e << 5) | 0, d);
        sb(d);
        continue;
       }
       break;
      }
      e = M() | 0;
      break a;
     }
     i = o + 1 | 0;
     e = 0;
     while (1) {
      l: {
       if ((e | 0) == (i | 0)) {
        v[31601] = 0;
        b = O(1, f + 60 | 0, 8616) | 0;
        c = v[31601];
        v[31601] = 0;
        if ((c | 0) != 1) {
         break l;
        }
        break b;
       }
       b = Wb(v[a + 484360 >> 2], w[a + 484376 | 0]);
       j = e & 65535;
       m: {
        if (!Vi(b, j)) {
         v[31601] = 0;
         c = O(367, h | 0, r | 0) | 0;
         b = v[31601];
         v[31601] = 0;
         if ((b | 0) == 1) {
          break b;
         }
         if ((c | 0) == 65535) {
          break m;
         }
         b = Wb(v[a + 484360 >> 2], w[a + 484376 | 0]);
         z = $b(v[b >> 2], e), A = c, u[z >> 1] = A;
        }
        b = RD(vb(v[Vb(v[h >> 2], x[$b(v[b >> 2], e) >> 1]) + 4 >> 2]), 1);
        c = w[b + 5 | 0];
        l = w[wb(v[d >> 2], (e + 1 >>> 0) % (m >>> 0) | 0) | 0];
        if ((c | 0) == (l | 0)) {
         break m;
        }
        n: {
         if (w[b + 3 | 0] != 16) {
          break n;
         }
         c = w[a + 484376 | 0];
         k = v[a + 484360 >> 2];
         v[31601] = 0;
         c = O(368, Wb(k, c) | 0, j | 0) | 0;
         j = v[31601];
         v[31601] = 0;
         if ((j | 0) == 1) {
          break b;
         }
         if ((c | 0) == 65535) {
          break n;
         }
         b = RD(vb(v[Vb(v[h >> 2], c) + 4 >> 2]), 1);
        }
        t[b + 5 | 0] = l;
        t[b + 3 | 0] = 16;
       }
       e = e + 1 | 0;
       continue;
      }
      break;
     }
     yb(a + 1298344 | 0, b);
     sb(b);
     v[31601] = 0;
     b = O(1, f + 48 | 0, 6049) | 0;
     c = v[31601];
     v[31601] = 0;
     if ((c | 0) == 1) {
      break b;
     }
     yb(a + 1298356 | 0, b);
     sb(b);
     c = f + 24 | 0;
     oi(c, 2, f + 113 | 0);
     v[31601] = 0;
     b = f + 36 | 0;
     R(369, b | 0, 4, c | 0);
     c = v[31601];
     v[31601] = 0;
     if ((c | 0) == 1) {
      break b;
     }
     yb(a + 1298368 | 0, b);
     sb(b);
     z = a, A = v[Ec(b, 4) >> 2], v[z + 1298404 >> 2] = A;
     ec(g);
    }
    ec(d);
    e = q ^ 1;
   }
   eb = f + 320 | 0;
   return e | 0;
  }
  e = M() | 0;
  ec(g);
 }
 ec(d);
 P(e | 0);
 p();
}

function Rz(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0;
 e = eb - 240 | 0;
 eb = e;
 t[e + 239 | 0] = c;
 g = v[b + 4 >> 2];
 a: {
  if (!g) {
   f = v[b >> 2];
   break a;
  }
  f = v[b >> 2];
  h = w[xl(f, g) | 0];
  if ((h | 0) == 33) {
   d = 1;
  } else {
   if ((h | 0) != 63) {
    break a;
   }
   d = 0;
  }
  Kl(e + 80 | 0, f, g, g - 1 | 0);
  g = v[e + 84 >> 2];
  f = v[e + 80 >> 2];
  v[b >> 2] = f;
  v[b + 4 >> 2] = g;
 }
 h = e + 80 | 0;
 he(h);
 i = v[e + 80 >> 2];
 j = e + 216 | 0;
 he(j);
 i = wl(i, v[e + 220 >> 2], b);
 he(h);
 b: {
  c: {
   d: {
    e: {
     f: {
      g: {
       h: {
        if (v[e + 84 >> 2] == (i | 0)) {
         a = oc(e + 228 | 0, 22256);
         c = v[a + 4 >> 2];
         v[e >> 2] = v[a >> 2];
         v[e + 4 >> 2] = c;
         if (Hc(f, g, e)) {
          g = cc(8);
          v[31601] = 0;
          N(1003, j | 0, e + 239 | 0);
          a = v[31601];
          v[31601] = 0;
          if ((a | 0) == 1) {
           break g;
          }
          v[31601] = 0;
          R(1010, h | 0, 18235, j | 0);
          a = v[31601];
          v[31601] = 0;
          if ((a | 0) == 1) {
           break f;
          }
          rc(g, h);
          f = 0;
          v[31601] = 0;
          R(97, g | 0, 48396, 999);
          a = v[31601];
          v[31601] = 0;
          if ((a | 0) != 1) {
           break b;
          }
          b = M() | 0;
          sb(h);
          break e;
         }
         if (!d) {
          break h;
         }
         g = cc(8);
         a = v[b >> 2];
         b = v[b + 4 >> 2];
         v[31601] = 0;
         a = _h(e + 192 | 0, a, b);
         b = v[31601];
         v[31601] = 0;
         i: {
          j: {
           k: {
            l: {
             m: {
              n: {
               o: {
                p: {
                 if ((b | 0) != 1) {
                  v[31601] = 0;
                  b = e + 204 | 0;
                  R(1010, b | 0, 18271, a | 0);
                  c = v[31601];
                  v[31601] = 0;
                  if ((c | 0) == 1) {
                   break p;
                  }
                  v[31601] = 0;
                  f = e + 216 | 0;
                  N(1012, f | 0, b | 0);
                  b = v[31601];
                  v[31601] = 0;
                  c = 1;
                  if ((b | 0) == 1) {
                   break o;
                  }
                  v[31601] = 0;
                  b = e + 180 | 0;
                  N(1003, b | 0, e + 239 | 0);
                  c = v[31601];
                  v[31601] = 0;
                  if ((c | 0) == 1) {
                   break n;
                  }
                  v[31601] = 0;
                  d = e + 80 | 0;
                  R(1014, d | 0, f | 0, b | 0);
                  b = v[31601];
                  v[31601] = 0;
                  c = 1;
                  if ((b | 0) == 1) {
                   break m;
                  }
                  rc(g, d);
                  v[31601] = 0;
                  R(97, g | 0, 48396, 999);
                  b = v[31601];
                  v[31601] = 0;
                  if ((b | 0) != 1) {
                   break b;
                  }
                  b = M() | 0;
                  sb(d);
                  c = 0;
                  break l;
                 }
                 b = M() | 0;
                 break d;
                }
                b = M() | 0;
                c = 1;
                break i;
               }
               b = M() | 0;
               break j;
              }
              b = M() | 0;
              c = 1;
              break k;
             }
             b = M() | 0;
            }
            sb(e + 180 | 0);
           }
           sb(e + 216 | 0);
          }
          sb(e + 204 | 0);
         }
         sb(a);
         if (c) {
          break d;
         }
         break c;
        }
        b = oc(e + 172 | 0, 22256);
        d = v[b + 4 >> 2];
        v[e + 72 >> 2] = v[b >> 2];
        v[e + 76 >> 2] = d;
        if (Hc(f, g, e + 72 | 0)) {
         g = cc(8);
         v[31601] = 0;
         b = e + 216 | 0;
         N(1003, b | 0, e + 239 | 0);
         a = v[31601];
         v[31601] = 0;
         q: {
          r: {
           if ((a | 0) != 1) {
            v[31601] = 0;
            a = e + 80 | 0;
            R(1010, a | 0, 18235, b | 0);
            b = v[31601];
            v[31601] = 0;
            if ((b | 0) == 1) {
             break r;
            }
            rc(g, a);
            f = 0;
            v[31601] = 0;
            R(97, g | 0, 48396, 999);
            b = v[31601];
            v[31601] = 0;
            if ((b | 0) != 1) {
             break b;
            }
            b = M() | 0;
            sb(a);
            break q;
           }
           b = M() | 0;
           break d;
          }
          b = M() | 0;
          f = 1;
         }
         sb(e + 216 | 0);
         if (f) {
          break d;
         }
         break c;
        }
        b = oc(e + 164 | 0, 7462);
        d = v[b + 4 >> 2];
        v[e + 64 >> 2] = v[b >> 2];
        v[e + 68 >> 2] = d;
        s: {
         if (!Hc(f, g, e - -64 | 0)) {
          b = oc(e + 156 | 0, 7444);
          d = v[b + 4 >> 2];
          v[e + 56 >> 2] = v[b >> 2];
          v[e + 60 >> 2] = d;
          if (!Hc(f, g, e + 56 | 0)) {
           break s;
          }
         }
         t[a + 60 | 0] = c;
         break h;
        }
        b = oc(e + 148 | 0, 6989);
        d = v[b + 4 >> 2];
        v[e + 48 >> 2] = v[b >> 2];
        v[e + 52 >> 2] = d;
        t: {
         if (!Hc(f, g, e + 48 | 0)) {
          b = oc(e + 140 | 0, 6970);
          d = v[b + 4 >> 2];
          v[e + 40 >> 2] = v[b >> 2];
          v[e + 44 >> 2] = d;
          if (!Hc(f, g, e + 40 | 0)) {
           break t;
          }
         }
         t[a + 61 | 0] = c;
         break h;
        }
        b = oc(e + 132 | 0, 7073);
        d = v[b + 4 >> 2];
        v[e + 32 >> 2] = v[b >> 2];
        v[e + 36 >> 2] = d;
        if (Hc(f, g, e + 32 | 0)) {
         t[a + 62 | 0] = c;
         break h;
        }
        b = oc(e + 124 | 0, 6064);
        d = v[b + 4 >> 2];
        v[e + 24 >> 2] = v[b >> 2];
        v[e + 28 >> 2] = d;
        if (Hc(f, g, e + 24 | 0)) {
         t[a + 63 | 0] = c;
         break h;
        }
        b = oc(e + 116 | 0, 7511);
        d = v[b + 4 >> 2];
        v[e + 16 >> 2] = v[b >> 2];
        v[e + 20 >> 2] = d;
        if (Hc(f, g, e + 16 | 0)) {
         t[a + 64 | 0] = c;
         break h;
        }
        b = oc(e + 108 | 0, 13509);
        d = v[b + 4 >> 2];
        v[e + 8 >> 2] = v[b >> 2];
        v[e + 12 >> 2] = d;
        if (!Hc(f, g, e + 8 | 0)) {
         break h;
        }
        b = v[a + 24 >> 2];
        d = b + 24664 | 0;
        f = v[d + 4 >> 2];
        v[e + 96 >> 2] = v[d >> 2];
        v[e + 100 >> 2] = f;
        d = b + 24656 | 0;
        f = v[d + 4 >> 2];
        v[e + 88 >> 2] = v[d >> 2];
        v[e + 92 >> 2] = f;
        d = v[b + 24652 >> 2];
        v[e + 80 >> 2] = v[b + 24648 >> 2];
        v[e + 84 >> 2] = d;
        if (c) {
         a = SM(v[a + 56 >> 2]);
        } else {
         a = 0;
        }
        v[e + 100 >> 2] = a;
        a = e + 80 | 0;
        if (!Az(a, b + 24648 | 0)) {
         break h;
        }
        MA(b, a);
       }
       eb = e + 240 | 0;
       return;
      }
      b = M() | 0;
      break d;
     }
     b = M() | 0;
     f = 1;
    }
    sb(e + 216 | 0);
    if (!f) {
     break c;
    }
   }
   jc(g);
  }
  P(b | 0);
 }
 p();
}

function kua(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, q = 0, r = 0;
 g = eb - 3056 | 0;
 eb = g;
 xc(b);
 e = eb - 16 | 0;
 eb = e;
 f = g + 1102 | 0;
 l0(e + 8 | 0, f);
 j = v[e + 12 >> 2];
 ic(e, v[b >> 2], v[b + 8 >> 2], v[e + 8 >> 2], v[e + 12 >> 2]);
 n = v[e + 4 >> 2];
 if ((n | 0) == (j | 0)) {
  Ub(b, v[e + 12 >> 2]);
 }
 eb = e + 16 | 0;
 e = (j | 0) == (n | 0);
 if (!e) {
  k0(f);
 }
 a: {
  if (!e) {
   break a;
  }
  if (!n0(f)) {
   break a;
  }
  d = 1;
  if ((c | 0) == 64) {
   break a;
  }
  d = 0;
  if (!Lb(v[b >> 2], v[b + 8 >> 2], Ac(1024, 0))) {
   break a;
  }
  j0(b, g + 576 | 0);
  j0(b, g - -64 | 0);
  e = 0;
  while (1) {
   if ((e | 0) != 128) {
    f = e << 2;
    j = v[f + (g + 576 | 0) >> 2];
    if (j >>> 0 > 16777215) {
     break a;
    }
    f = v[f + (g - -64 | 0) >> 2];
    if (f - 4097 >>> 0 < 4294963202) {
     break a;
    }
    e = e + 1 | 0;
    if (um(v[b >> 2], (f + j | 0) + 2978 | 0)) {
     continue;
    }
    break a;
   }
   break;
  }
  Cd(a, 2);
  dg(a);
  d = g + 40 | 0;
  e = tc(d, 13879);
  yb(a + 1298344 | 0, e);
  sb(e);
  e = tc(d, 14734);
  yb(a + 1298356 | 0, e);
  sb(e);
  e = tc(d, 15548);
  yb(a + 1298368 | 0, e);
  sb(e);
  q = a, r = v[Ec(d, 4) >> 2], v[q + 1298404 >> 2] = r;
  d = w[g + 1102 | 0];
  v[a + 480204 >> 2] = 143e4;
  v[a + 480196 >> 2] = d;
  $e(Wb(v[a + 484360 >> 2], w[a + 484376 | 0]), w[g + 1103 | 0]);
  v[a + 480188 >> 2] = 4194317;
  Kb(a + 1074312 | 0, 95, 1);
  v[a + 480208 >> 2] = v[a + 480208 >> 2] | 16777216;
  e = a + 480280 | 0;
  d = 0;
  while (1) {
   if ((d | 0) == 4) {
    b: {
     j = a + 946304 | 0;
     n = a + 484380 | 0;
     l = g + 1520 | 0;
     o = g + 1104 | 0;
     d = 0;
     while (1) {
      c: {
       if ((d | 0) == 32) {
        i = g + 2448 | 0;
        l = g + 2032 | 0;
        e = 0;
        break c;
       }
       e = d + 1 | 0;
       f = n + B(e, 104) | 0;
       md(f, 2);
       h = g + 20 | 0;
       i0(h, o + B(d, 13) | 0);
       i = g + 40 | 0;
       Bc(i, h);
       zc(j + (e << 5) | 0, i);
       sb(i);
       d = l + (d << 4) | 0;
       i = w[d + 4 | 0] | w[d + 5 | 0] << 8 | (w[d + 6 | 0] << 16 | w[d + 7 | 0] << 24);
       v[f >> 2] = i;
       k = i;
       i = w[d + 12 | 0] | w[d + 13 | 0] << 8 | (w[d + 14 | 0] << 16 | w[d + 15 | 0] << 24);
       if (k >>> 0 >= i >>> 0) {
        d = w[d + 8 | 0] | w[d + 9 | 0] << 8 | (w[d + 10 | 0] << 16 | w[d + 11 | 0] << 24);
        u[f + 34 >> 1] = 2;
        v[f + 8 >> 2] = i;
        v[f + 4 >> 2] = d;
       }
       v[f + 24 >> 2] = 8287;
       d = e;
       continue;
      }
      break;
     }
     while (1) {
      if ((e | 0) != 32) {
       f = e + 33 | 0;
       o = n + B(f, 104) | 0;
       md(o, 2);
       h = g + 20 | 0;
       i0(h, l + B(e, 13) | 0);
       d = g + 40 | 0;
       Bc(d, h);
       zc(j + (f << 5) | 0, d);
       sb(d);
       v[g + 48 >> 2] = 0;
       v[g + 40 >> 2] = 0;
       v[g + 44 >> 2] = 0;
       f = i + B(e, 11) | 0;
       h = wb(f, 1);
       q = wb(d, 0), r = w[h | 0], t[q | 0] = r;
       h = wb(f, 6);
       q = wb(d, 1), r = w[h | 0], t[q | 0] = r;
       h = wb(f, 2);
       q = wb(d, 2), r = w[h | 0], t[q | 0] = r;
       h = wb(f, 7);
       q = wb(d, 3), r = w[h | 0], t[q | 0] = r;
       h = wb(f, 3);
       q = wb(d, 4), r = w[h | 0], t[q | 0] = r;
       h = wb(f, 8);
       q = wb(d, 5), r = w[h | 0], t[q | 0] = r;
       h = wb(f, 4);
       q = wb(d, 6), r = w[h | 0], t[q | 0] = r;
       h = wb(f, 9);
       q = wb(d, 7), r = w[h | 0], t[q | 0] = r;
       h = wb(f, 5);
       q = wb(d, 8), r = w[h | 0], t[q | 0] = r;
       h = wb(f, 10);
       q = wb(d, 9), r = w[h | 0], t[q | 0] = r;
       f = wb(f, 0);
       q = wb(d, 10), r = w[f | 0], t[q | 0] = r;
       v[g + 16 >> 2] = v[g + 48 >> 2];
       d = v[g + 44 >> 2];
       v[g + 8 >> 2] = v[g + 40 >> 2];
       v[g + 12 >> 2] = d;
       Qk(o, 1, g + 8 | 0);
       e = e + 1 | 0;
       continue;
      }
      break;
     }
     Qr(Wb(v[a + 484360 >> 2], w[a + 484376 | 0]), g + 2800 | 0, 256, 255, 65535);
     l = a + 484344 | 0;
     Sf(l, 128);
     o = c & 1;
     f = 0;
     while (1) {
      d: {
       e: {
        if ((f | 0) != 128) {
         a = f << 2;
         cd(b, v[a + (g + 576 | 0) >> 2] + 2978 | 0);
         d = g + 20 | 0;
         ge(d, b, v[a + (g - -64 | 0) >> 2]);
         a = gc(g + 40 | 0, d);
         tb(d);
         if (!o) {
          break d;
         }
         v[31601] = 0;
         d = T(196, l | 0, f & 65535, 64) | 0;
         e = v[31601];
         v[31601] = 0;
         if ((e | 0) == 1) {
          break b;
         }
         if (!d) {
          break d;
         }
         d = 0;
         j = Vb(v[l >> 2], f);
         while (1) {
          h = d >>> 0 > 63;
          while (1) {
           if (h) {
            break d;
           }
           e = v[a >> 2];
           v[31601] = 0;
           e = T(150, e | 0, v[g + 48 >> 2], 1) | 0;
           i = v[31601];
           v[31601] = 0;
           f: {
            if ((i | 0) != 1) {
             if (!e) {
              break d;
             }
             v[31601] = 0;
             e = Q(197, a | 0) | 0;
             i = v[31601];
             v[31601] = 0;
             if ((i | 0) == 1) {
              break b;
             }
             if (e >>> 0 > 12) {
              break f;
             }
             i = ld(v[j >> 2], v[v[j + 48 >> 2] + 12 >> 2], d, e);
             v[31601] = 0;
             m = g + 20 | 0;
             N(198, m | 0, a | 0);
             k = v[31601];
             v[31601] = 0;
             if ((k | 0) == 1) {
              break b;
             }
             k = w[g + 20 | 0];
             e = e >>> 0 > 3;
             t[i | 0] = ((k & 15) + (e ? 13 : 37) | 0) + B(k >>> 4 & 7, 12);
             m = Ic(m);
             t[i + 1 | 0] = ((w[m | 0] >>> 4 | 0) + (e ? 33 : 1) | 0) + (w[g + 20 | 0] >>> 3 & 16);
             h0(i, w[m | 0], e);
             continue;
            }
            break b;
           }
           i = e - 32 | 0;
           if ((i & 255) >>> 0 <= 12) {
            i = ld(v[j >> 2], v[v[j + 48 >> 2] + 12 >> 2], d, i & 65535);
            v[31601] = 0;
            m = Q(197, a | 0) | 0;
            k = v[31601];
            v[31601] = 0;
            if ((k | 0) == 1) {
             break b;
            }
            h0(i, m, e >>> 0 > 35);
            continue;
           }
           break;
          }
          if ((e | 0) != 64) {
           if ((e | 0) != 96) {
            break e;
           }
           if (!d) {
            break d;
           }
           q = ld(v[j >> 2], v[v[j + 48 >> 2] + 12 >> 2], d - 1 | 0, 0), r = 14, t[q + 3 | 0] = r;
           break d;
          }
          v[31601] = 0;
          e = Q(197, a | 0) | 0;
          i = v[31601];
          v[31601] = 0;
          if ((i | 0) == 1) {
           break b;
          }
          d = d + e | 0;
          continue;
         }
        }
        d = 1;
        if (!(c & 2)) {
         break a;
        }
        while (1) if ((d | 0) == 33) {
         d = 1;
         break a;
        } else {
         cg(Yc(g + 40 | 0, 8, 1, 0, 1), n + B(d, 104) | 0, b);
         d = d + 1 | 0;
         continue;
        }
       }
       tb(a);
       d = 0;
       break a;
      }
      tb(a);
      f = f + 1 | 0;
      continue;
     }
    }
   } else {
    u[(e + (d << 5) | 0) + 4 >> 1] = d & 1 ? 192 : 64;
    d = d + 1 | 0;
    continue;
   }
   break;
  }
  b = M() | 0;
  tb(a);
  P(b | 0);
  p();
 }
 eb = g + 3056 | 0;
 return d | 0;
}

function wta(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, q = 0, r = 0, s = 0, y = 0, z = 0;
 d = eb - 320 | 0;
 eb = d;
 xc(b);
 a: {
  e = d + 308 | 0;
  if (!fp(b, e)) {
   break a;
  }
  if (!g$(e)) {
   break a;
  }
  if ((w[d + 308 | 0] | w[d + 309 | 0] << 8 | (w[d + 310 | 0] << 16 | w[d + 311 | 0] << 24)) == 1179472708) {
   Ub(b, 4);
  }
  if (!ui(b, d + 300 | 0) | (w[d + 300 | 0] | w[d + 301 | 0] << 8 | (w[d + 302 | 0] << 16 | w[d + 303 | 0] << 24)) != 1196314451) {
   break a;
  }
  i = 1;
  if ((c | 0) == 64) {
   break a;
  }
  f = d + 108 | 0;
  r0(b, f, w[d + 304 | 0] | w[d + 305 | 0] << 8 | (w[d + 306 | 0] << 16 | w[d + 307 | 0] << 24));
  i = 0;
  if ((w[d + 144 | 0] | w[d + 145 | 0] << 8) >>> 0 > 128 | (w[d + 150 | 0] | w[d + 151 | 0] << 8) >>> 0 > 16 | ((w[d + 148 | 0] | w[d + 149 | 0] << 8) >>> 0 > 256 | (w[d + 142 | 0] | w[d + 143 | 0] << 8) >>> 0 > 128)) {
   break a;
  }
  Cd(a, 8192);
  e = d + 24 | 0;
  g = tc(e, 6574);
  yb(a + 1298344 | 0, g);
  sb(g);
  g = tc(e, 10141);
  yb(a + 1298356 | 0, g);
  sb(g);
  y = a, z = v[Ec(e, 4) >> 2], v[y + 1298404 >> 2] = z;
  g = d + 88 | 0;
  Ui(g, 2, f);
  Bc(e, g);
  yb(a + 1298308 | 0, e);
  sb(e);
  u[d + 24 >> 1] = w[d + 150 | 0] | w[d + 151 | 0] << 8;
  u[d + 88 >> 1] = 1;
  f = x[qe(e, g) >> 1];
  u[a + 480188 >> 1] = f;
  v[a + 480196 >> 2] = w[d + 154 | 0];
  v[a + 480204 >> 2] = B(w[d + 155 | 0], 1e4);
  t[d + 24 | 0] = w[d + 152 | 0];
  t[d + 88 | 0] = 64;
  e = w[Pb(e, g) | 0];
  v[a + 480200 >> 2] = e << 2;
  if (!e) {
   v[a + 480200 >> 2] = 256;
  }
  e = w[d + 153 | 0];
  b: {
   if ((e | 0) == 128) {
    v[d + 24 >> 2] = 256 / (f >>> 0);
    v[d + 88 >> 2] = 128;
    e = v[Gb(d + 24 | 0, d + 88 | 0) >> 2];
    break b;
   }
   e = e & 127;
  }
  v[a + 480228 >> 2] = e;
  g = a + 480280 | 0;
  f = d + 156 | 0;
  e = 0;
  while (1) {
   if ((e | 0) == 16) {
    f = Wb(v[a + 484360 >> 2], w[a + 484376 | 0]);
    j = d + 172 | 0;
    g = eb - 16 | 0;
    eb = g;
    v[g + 12 >> 2] = w[d + 144 | 0] | w[d + 145 | 0] << 8;
    e = g + 12 | 0;
    wc(e, 128);
    wc(e, 65535);
    h = x[g + 12 >> 1];
    ug(f, h);
    e = 0;
    while (1) {
     if ((e | 0) == (h | 0)) {
      eb = g + 16 | 0;
     } else {
      i = w[e + j | 0];
      y = Sr(v[f >> 2], v[f + 4 >> 2], e), z = (i | 0) == 255 ? -1 : (i | 0) == 254 ? -2 : i, 
      u[y >> 1] = z;
      e = e + 1 | 0;
      continue;
     }
     break;
    }
    e = w[d + 142 | 0] | w[d + 143 | 0] << 8;
    if (e >>> 0 < (w[d + 144 | 0] | w[d + 145 | 0] << 8) >>> 0) {
     $e(Wb(v[a + 484360 >> 2], w[a + 484376 | 0]), e);
    }
    n = c & 2;
    o = a + 946304 | 0;
    q = a + 484380 | 0;
    m = a + 484344 | 0;
    i = 1;
    r = c & 1;
    s = d + 60 | 0;
    j = 0;
    while (1) {
     if (!ui(b, d + 300 | 0)) {
      break a;
     }
     e = d + 24 | 0;
     ge(e, b, w[d + 304 | 0] | w[d + 305 | 0] << 8 | (w[d + 306 | 0] << 16 | w[d + 307 | 0] << 24));
     c = gc(d + 88 | 0, e);
     tb(e);
     c: {
      d: {
       if (!(!r | (w[d + 300 | 0] | w[d + 301 | 0] << 8 | (w[d + 302 | 0] << 16 | w[d + 303 | 0] << 24)) != 1414807888)) {
        v[31601] = 0;
        k = j & 65535;
        e = T(196, m | 0, k | 0, 64) | 0;
        g = v[31601];
        v[31601] = 0;
        if ((g | 0) == 1) {
         break d;
        }
        if (!e) {
         break c;
        }
        v[31601] = 0;
        O(183, c | 0, 2) | 0;
        e = v[31601];
        v[31601] = 0;
        if ((e | 0) == 1) {
         break d;
        }
        g = 0;
        e: {
         while (1) {
          e = v[c >> 2];
          v[31601] = 0;
          e = T(150, e | 0, v[d + 96 >> 2], 1) | 0;
          f = v[31601];
          v[31601] = 0;
          f: {
           if ((f | 0) != 1) {
            if (!(e & g >>> 0 < 64)) {
             break e;
            }
            v[31601] = 0;
            e = Q(197, c | 0) | 0;
            f = v[31601];
            v[31601] = 0;
            if ((f | 0) == 1) {
             break d;
            }
            h = e << 24 >> 24;
            if (h) {
             break f;
            }
            g = g + 1 | 0;
            continue;
           }
           break d;
          }
          e = d + 24 | 0;
          f = h & 15;
          if (f >>> 0 < x[a + 480188 >> 1]) {
           e = Vb(v[m >> 2], k);
           e = ld(v[e >> 2], v[v[e + 48 >> 2] + 12 >> 2], g, f);
          }
          g: {
           if ((h | 0) >= 0) {
            break g;
           }
           v[31601] = 0;
           f = Q(197, c | 0) | 0;
           l = v[31601];
           v[31601] = 0;
           if ((l | 0) == 1) {
            break d;
           }
           if (!f) {
            break g;
           }
           t[e | 0] = f >>> 0 < 109 ? f + 12 | 0 : f;
          }
          f = h & 255;
          if (f & 64) {
           v[31601] = 0;
           h = Q(197, c | 0) | 0;
           l = v[31601];
           v[31601] = 0;
           if ((l | 0) == 1) {
            break d;
           }
           t[e + 1 | 0] = h;
          }
          if (f & 32) {
           t[e + 2 | 0] = 1;
           v[31601] = 0;
           h = Q(197, c | 0) | 0;
           l = v[31601];
           v[31601] = 0;
           if ((l | 0) == 1) {
            break d;
           }
           t[d + 12 | 0] = h;
           t[d | 0] = 64;
           y = e, z = w[Pb(d + 12 | 0, d) | 0], t[y + 4 | 0] = z;
          }
          if (!(f & 16)) {
           continue;
          }
          v[31601] = 0;
          f = d + 12 | 0;
          N(198, f | 0, c | 0);
          h = v[31601];
          v[31601] = 0;
          if ((h | 0) != 1) {
           Bf(e, w[d + 12 | 0], w[Ic(f) | 0]);
           continue;
          }
          break;
         }
         break d;
        }
        j = j + 1 | 0;
        break c;
       }
       if ((w[d + 300 | 0] | w[d + 301 | 0] << 8 | (w[d + 302 | 0] << 16 | w[d + 303 | 0] << 24)) != 1414745673) {
        break c;
       }
       e = x[a + 480190 >> 1];
       if (!ni(e)) {
        break c;
       }
       e = e + 1 | 0;
       u[a + 480190 >> 1] = e;
       v[31601] = 0;
       g = d + 24 | 0;
       N(324, c | 0, g | 0);
       f = v[31601];
       v[31601] = 0;
       h: {
        if ((f | 0) == 1) {
         break h;
        }
        v[31601] = 0;
        k = B(e & 65535, 104) + q | 0;
        N(325, g | 0, k | 0);
        e = v[31601];
        v[31601] = 0;
        if ((e | 0) == 1) {
         break h;
        }
        Ui(d, 2, s);
        v[31601] = 0;
        e = d + 12 | 0;
        N(218, e | 0, d | 0);
        g = v[31601];
        v[31601] = 0;
        if ((g | 0) == 1) {
         break h;
        }
        zc((x[a + 480190 >> 1] << 5) + o | 0, e);
        sb(e);
        if (!n) {
         break c;
        }
        g = w[d + 37 | 0] | w[d + 38 | 0] << 8;
        f = 2;
        h = Yc(e, 8, 1, 0, 1);
        i: {
         if (!(g & 64)) {
          f = 0;
          if (!(g & 2)) {
           break i;
          }
         }
         vg(h, f);
        }
        if (g & 4) {
         gd(h, 16);
        }
        v[31601] = 0;
        T(215, e | 0, k | 0, c | 0) | 0;
        e = v[31601];
        v[31601] = 0;
        if ((e | 0) != 1) {
         break c;
        }
       }
      }
      a = M() | 0;
      tb(c);
      P(a | 0);
      p();
     }
     tb(c);
     continue;
    }
   }
   i = g + (e << 5) | 0;
   Ve(i);
   j = w[e + f | 0];
   if (j >>> 0 <= 128) {
    u[i + 4 >> 1] = j << 1;
   }
   e = e + 1 | 0;
   continue;
  }
 }
 eb = d + 320 | 0;
 return i | 0;
}

function yy(a) {
 var b = 0, c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0;
 e = eb - 32 | 0;
 eb = e;
 j = a + 32 | 0;
 Pc(e + 8 | 0, j, 11);
 a: {
  b: {
   c: {
    if (Fb(v[v[e + 8 >> 2] >> 2], v[e + 12 >> 2]) | v[a + 8 >> 2]) {
     b = v[a + 76 >> 2] + v[a + 20 >> 2] | 0;
     f = v[a + 16 >> 2];
     c = f + v[a + 72 >> 2] | 0;
     Ci(v[a + 36 >> 2], c, c >>> 0 < f >>> 0 ? b + 1 | 0 : b, 0);
     b = v[a + 36 >> 2];
     if (mk(v[(v[v[b >> 2] - 12 >> 2] + b | 0) + 16 >> 2])) {
      Nh(a, 2, 256);
      break a;
     }
     b = v[a + 104 >> 2];
     c = a + 52 | 0;
     f = v[c >> 2];
     d = ej(f, v[c + 4 >> 2]);
     d: {
      if (b >>> 0 > d >>> 0) {
       n = eb - 32 | 0;
       eb = n;
       f = b - d | 0;
       d = v[zb(c) >> 2];
       g = v[c + 4 >> 2];
       e: {
        if (f >>> 0 <= (d - g | 0) / 24 >>> 0) {
         d = eb - 16 | 0;
         eb = d;
         c = CJ(d + 4 | 0, c, f);
         b = v[c + 4 >> 2];
         f = v[c + 8 >> 2];
         while (1) {
          if ((b | 0) == (f | 0)) {
           hc(c);
           eb = d + 16 | 0;
          } else {
           BJ(b);
           b = b + 24 | 0;
           v[c + 4 >> 2] = b;
           continue;
          }
          break;
         }
         break e;
        }
        b = zb(c);
        d = GJ(n + 12 | 0, IJ(c, ej(v[c >> 2], g) + f | 0), ej(v[c >> 2], v[c + 4 >> 2]), b);
        g = eb - 16 | 0;
        eb = g;
        h = v[d + 8 >> 2];
        b = g + 4 | 0;
        v[b + 8 >> 2] = d + 8;
        v[b >> 2] = h;
        v[b + 4 >> 2] = h + B(f, 24);
        f = v[b >> 2];
        while (1) {
         if (v[b + 4 >> 2] != (f | 0)) {
          BJ(f);
          f = v[b >> 2] + 24 | 0;
          v[b >> 2] = f;
          continue;
         }
         break;
        }
        ie(b);
        eb = g + 16 | 0;
        k = eb - 16 | 0;
        eb = k;
        b = ub(k + 12 | 0, v[c + 4 >> 2]);
        g = ub(k + 8 | 0, v[c >> 2]);
        h = v[ub(k + 4 | 0, v[d + 4 >> 2]) >> 2];
        m = eb - 16 | 0;
        eb = m;
        p = m + 8 | 0;
        f = eb - 32 | 0;
        eb = f;
        ed(f + 24 | 0, v[b >> 2], v[g >> 2]);
        q = f + 16 | 0;
        b = v[f + 24 >> 2];
        r = v[f + 28 >> 2];
        g = eb - 16 | 0;
        eb = g;
        v[g + 8 >> 2] = h;
        v[g + 12 >> 2] = b;
        while (1) {
         if (Ed(b, r)) {
          b = gl(b);
          h = gl(v[g + 8 >> 2]);
          l = x[b + 18 >> 1] | x[b + 20 >> 1] << 16;
          o = x[b + 14 >> 1] | x[b + 16 >> 1] << 16;
          u[h + 14 >> 1] = o;
          u[h + 16 >> 1] = o >>> 16;
          u[h + 18 >> 1] = l;
          u[h + 20 >> 1] = l >>> 16;
          l = v[b + 12 >> 2];
          v[h + 8 >> 2] = v[b + 8 >> 2];
          v[h + 12 >> 2] = l;
          l = v[b + 4 >> 2];
          v[h >> 2] = v[b >> 2];
          v[h + 4 >> 2] = l;
          b = gt(g + 12 | 0);
          gt(g + 8 | 0);
          b = v[b >> 2];
          continue;
         }
         break;
        }
        pc(q, b, g + 8 | 0);
        eb = g + 16 | 0;
        b = v[f + 16 >> 2];
        v[f + 12 >> 2] = v[f + 20 >> 2];
        pc(p, b, f + 12 | 0);
        eb = f + 32 | 0;
        eb = m + 16 | 0;
        v[d + 4 >> 2] = v[m + 12 >> 2];
        Sb(c, d + 4 | 0);
        Sb(c + 4 | 0, d + 8 | 0);
        Sb(zb(c), mc(d));
        v[d >> 2] = v[d + 4 >> 2];
        eb = k + 16 | 0;
        DJ(d);
       }
       eb = n + 32 | 0;
       break d;
      }
      if (b >>> 0 < d >>> 0) {
       Id(c, f + B(b, 24) | 0);
      }
     }
     f = a + 40 | 0;
     so(f, v[a + 104 >> 2] << 2);
     while (1) {
      if (y[a + 104 >> 2] > i >>> 0) {
       c = v[a + 36 >> 2];
       if (mk(v[(v[v[c >> 2] - 12 >> 2] + c | 0) + 16 >> 2])) {
        Nh(a, 2, 1024);
        break a;
       }
       b = x[a + 24 >> 1];
       u[e >> 1] = b;
       if ((b | 0) == 65535) {
        By(c, e);
        b = x[e >> 1];
       }
       c = Sc(v[a + 40 >> 2], v[a + 44 >> 2]);
       d = b & 65535;
       f: {
        if (!d) {
         b = 0;
         break f;
        }
        if (d >>> 0 > (c ^ -1) >>> 0) {
         break f;
        }
        Qj(f, c + d | 0);
        uj(v[a + 36 >> 2], wb(v[a + 40 >> 2], c), d);
       }
       d = vf(v[a + 52 >> 2], i);
       v[d >> 2] = c;
       u[d + 20 >> 1] = b;
       b = e + 8 | 0;
       Pc(b, j, 6);
       if (Fb(v[v[e + 8 >> 2] >> 2], v[e + 12 >> 2])) {
        ml(v[a + 36 >> 2], b);
        b = v[e + 8 >> 2];
        c = v[e + 12 >> 2];
        if (!zy(b, c)) {
         break c;
        }
        d = vf(v[a + 52 >> 2], i);
        v[d + 8 >> 2] = b;
        v[d + 12 >> 2] = c;
       }
       c = v[a + 8 >> 2];
       g: {
        if (c) {
         b = vf(v[a + 52 >> 2], i);
         v[b + 16 >> 2] = c;
         break g;
        }
        Pc(e + 8 | 0, j, 7);
        if (!Fb(v[v[e + 8 >> 2] >> 2], v[e + 12 >> 2])) {
         b = vf(v[a + 52 >> 2], i);
         break g;
        }
        ml(v[a + 36 >> 2], e + 8 | 0);
        c = v[e + 8 >> 2];
        if (!zy(c, v[e + 12 >> 2])) {
         break b;
        }
        b = vf(v[a + 52 >> 2], i);
        v[b + 16 >> 2] = c;
       }
       h: {
        if (v[b + 16 >> 2] == -1) {
         break h;
        }
        Pc(e + 8 | 0, j, 6);
        if (Fb(v[v[e + 8 >> 2] >> 2], v[e + 12 >> 2])) {
         break h;
        }
        i: {
         if (!i) {
          c = 0;
          d = vf(v[a + 52 >> 2], 0);
          b = 0;
          break i;
         }
         d = v[a + 52 >> 2];
         b = vf(d, i - 1 | 0);
         g = v[b + 16 >> 2];
         c = v[b + 8 >> 2] + g | 0;
         b = v[b + 12 >> 2];
         d = vf(d, i);
         b = c >>> 0 < g >>> 0 ? b + 1 | 0 : b;
        }
        v[d + 8 >> 2] = c;
        v[d + 12 >> 2] = b;
       }
       b = e + 8 | 0;
       Pc(b, j, 8);
       if (Fb(v[v[e + 8 >> 2] >> 2], v[e + 12 >> 2])) {
        u[e + 30 >> 1] = 0;
        By(v[a + 36 >> 2], e + 30 | 0);
        Pc(b, j, 9);
        Mm(v[a + 36 >> 2], x[e + 30 >> 1] << Fb(v[v[e + 8 >> 2] >> 2], v[e + 12 >> 2]));
       }
       i = i + 1 | 0;
       continue;
      }
      break;
     }
     $d(e + 8 | 0, v[a + 36 >> 2]);
     b = v[e + 20 >> 2];
     v[a + 80 >> 2] = v[e + 16 >> 2];
     v[a + 84 >> 2] = b;
    }
    d = e + 8 | 0;
    Pc(d, j, 4);
    kf(d, 1);
    f = v[a + 80 >> 2];
    g = v[a + 84 >> 2];
    b = v[a + 96 >> 2];
    h = v[a + 16 >> 2];
    i = b + h | 0;
    k = v[a + 100 >> 2];
    c = k + v[a + 20 >> 2] | 0;
    c = i >>> 0 < h >>> 0 ? c + 1 | 0 : c;
    h = i;
    i = (b | 0) == v[a + 72 >> 2] & (k | 0) == v[a + 76 >> 2];
    b = i ? f : h;
    v[a + 88 >> 2] = b;
    c = i ? g : c;
    v[a + 92 >> 2] = c;
    Ci(v[a + 36 >> 2], b, c, 0);
    Pc(d, j, 6);
    if (Fb(v[v[e + 8 >> 2] >> 2], v[e + 12 >> 2])) {
     break a;
    }
    Pc(e, j, 7);
    if (!(Fb(v[v[e >> 2] >> 2], v[e + 4 >> 2]) | v[a + 8 >> 2])) {
     break a;
    }
    c = v[a + 88 >> 2];
    d = v[a + 16 >> 2];
    b = c - d | 0;
    f = v[a + 92 >> 2] - (v[a + 20 >> 2] + (c >>> 0 < d >>> 0) | 0) | 0;
    j = v[a + 52 >> 2];
    g = v[a + 104 >> 2];
    a = 0;
    while (1) {
     if ((a | 0) == (g | 0)) {
      break a;
     }
     c = vf(j, a);
     d = c;
     h = v[c + 8 >> 2];
     i = h + b | 0;
     c = v[c + 12 >> 2] + f | 0;
     v[d + 8 >> 2] = i;
     v[d + 12 >> 2] = i >>> 0 < h >>> 0 ? c + 1 | 0 : c;
     a = a + 1 | 0;
     continue;
    }
   }
   Nh(a, 2, 2048);
   break a;
  }
  Nh(a, 2, 2048);
 }
 eb = e + 32 | 0;
}

function Tsa(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, q = 0, r = 0, s = 0, y = 0, z = 0, A = 0;
 f = eb - 960 | 0;
 eb = f;
 xc(b);
 d = eb - 16 | 0;
 eb = d;
 e = f + 862 | 0;
 A_(d + 8 | 0, e);
 h = v[d + 12 >> 2];
 ic(d, v[b >> 2], v[b + 8 >> 2], v[d + 8 >> 2], v[d + 12 >> 2]);
 g = v[d + 4 >> 2];
 if ((g | 0) == (h | 0)) {
  Ub(b, v[d + 12 >> 2]);
 }
 eb = d + 16 | 0;
 d = (h | 0) == (g | 0);
 if (!d) {
  z_(e);
 }
 a: {
  if (!d) {
   break a;
  }
  if (!C_(e)) {
   break a;
  }
  if (!Lb(v[b >> 2], v[b + 8 >> 2], Ac(B_(w[f + 909 | 0] | w[f + 910 | 0] << 8), gb))) {
   break a;
  }
  n = 1;
  if ((c | 0) == 64) {
   break a;
  }
  Cd(a, 512);
  v[a + 480228 >> 2] = 32;
  u[a + 480188 >> 1] = 16;
  v[a + 480196 >> 2] = w[f + 937 | 0];
  v[a + 480208 >> 2] = 16;
  v[a + 480200 >> 2] = 256;
  v[a + 480204 >> 2] = 8e5;
  Kb(a + 1074312 | 0, 7, 1);
  d = f + 88 | 0;
  e = tc(d, 8224);
  yb(a + 1298344 | 0, e);
  sb(e);
  e = tc(d, 8912);
  yb(a + 1298356 | 0, e);
  sb(e);
  z = a, A = v[Ec(d, 4) >> 2], v[z + 1298404 >> 2] = A;
  e = f + 12 | 0;
  y_(e, f + 866 | 0);
  Bc(d, e);
  yb(a + 1298308 | 0, d);
  h = a + 480280 | 0;
  sb(d);
  g = f + 938 | 0;
  i = f + 912 | 0;
  d = 0;
  while (1) {
   if ((d | 0) == 16) {
    b: {
     d = w[f + 958 | 0] | w[f + 959 | 0] << 8;
     if (d) {
      kE(a + 1298332 | 0, b, d, 132, 0);
     }
     d = eb - 16 | 0;
     eb = d;
     e = f + 88 | 0;
     ac(d + 8 | 0, e, 771);
     h = v[d + 12 >> 2];
     ic(d, v[b >> 2], v[b + 8 >> 2], v[d + 8 >> 2], v[d + 12 >> 2]);
     g = v[d + 4 >> 2];
     if ((g | 0) == (h | 0)) {
      Ub(b, v[d + 12 >> 2]);
     }
     eb = d + 16 | 0;
     n = (h | 0) == (g | 0);
     if (!n) {
      Qb(e, 0, 771);
     }
     if (!n) {
      break a;
     }
     x_(Wb(v[a + 484360 >> 2], w[a + 484376 | 0]), e, w[f + 345 | 0]);
     $e(Wb(v[a + 484360 >> 2], w[a + 484376 | 0]), w[f + 346 | 0]);
     cd(b, w[f + 909 | 0] | w[f + 910 | 0] << 8);
     k = a + 484344 | 0;
     q = c & 1;
     r = f + 347 | 0;
     e = 0;
     while (1) {
      c: {
       if ((e | 0) == 256) {
        if (!(c & 2)) {
         break a;
        }
        b0(b, f + 60 | 0);
        k = a + 484380 | 0;
        l = a + 946304 | 0;
        d = 0;
        while (1) {
         if ((d | 0) == 64) {
          break a;
         }
         if (!(w[f + 60 + (d >>> 3) | 0] >>> (d & 7) & 1)) {
          d = d + 1 | 0;
          continue;
         }
         c = f + 12 | 0;
         if (!TD(b, c)) {
          break a;
         }
         d = d + 1 | 0;
         u[a + 480190 >> 1] = d;
         Ue(f, 1, c);
         g = f + 68 | 0;
         Bc(g, f);
         zc(l + (x[a + 480190 >> 1] << 5) | 0, g);
         sb(g);
         e = k + B(d, 104) | 0;
         md(e, 0);
         j = w[c + 32 | 0] | w[c + 33 | 0] << 8 | (w[c + 34 | 0] << 16 | w[c + 35 | 0] << 24);
         v[e >> 2] = j;
         h = w[c + 38 | 0] | w[c + 39 | 0] << 8 | (w[c + 40 | 0] << 16 | w[c + 41 | 0] << 24);
         v[e + 4 >> 2] = h;
         i = w[c + 42 | 0] | w[c + 43 | 0] << 8 | (w[c + 44 | 0] << 16 | w[c + 45 | 0] << 24);
         v[e + 24 >> 2] = 16726;
         v[e + 8 >> 2] = i;
         u[e + 30 >> 1] = w[c + 37 | 0] << 4;
         if (t[c + 46 | 0] & 1) {
          i = i >>> 1 | 0;
          v[e + 8 >> 2] = i;
          h = h >>> 1 | 0;
          v[e + 4 >> 2] = h;
          v[e >> 2] = j >>> 1;
         }
         if (!(!(w[c + 47 | 0] & 8) | h >>> 0 >= i >>> 0)) {
          u[e + 34 >> 1] = x[e + 34 >> 1] | 2;
         }
         Yc(g, t[f + 58 | 0] & 1 ? 16 : 8, 1, 0, 0);
         cg(g, e, b);
         continue;
        }
       }
       d: {
        d = (e << 1) + r | 0;
        g = w[d | 0] | w[d + 1 | 0] << 8;
        if (g) {
         h = f + 68 | 0;
         ge(h, b, g);
         i = gc(f + 12 | 0, h);
         tb(h);
         l = ((w[d | 0] | w[d + 1 | 0] << 8) - 2 | 0) / 64 | 0;
         e: {
          if (!q) {
           break e;
          }
          v[31601] = 0;
          d = T(196, k | 0, e & 65535, l | 0) | 0;
          h = v[31601];
          v[31601] = 0;
          if ((h | 0) == 1) {
           break d;
          }
          if (!d) {
           break e;
          }
          v[31601] = 0;
          d = Q(197, i | 0) | 0;
          h = v[31601];
          v[31601] = 0;
          if ((h | 0) == 1) {
           break b;
          }
          v[31601] = 0;
          O(183, i | 0, 1) | 0;
          h = v[31601];
          v[31601] = 0;
          if ((h | 0) == 1) {
           break b;
          }
          s = d ? d >>> 0 >= l - 2 >>> 0 ? -1 : d + 1 | 0 : -1;
          h = 0;
          f: while (1) {
           if ((h | 0) != (l | 0)) {
            d = Vb(v[k >> 2], e);
            af(f + 68 | 0, v[d >> 2], v[v[d + 48 >> 2] + 12 >> 2], h);
            z = f, A = vb(v[f + 68 >> 2]), v[z >> 2] = A;
            y = nw(v[f + 68 >> 2], v[f + 72 >> 2]);
            while (1) {
             d = v[f >> 2];
             if (!Hb(d, y)) {
              h = h + 1 | 0;
              continue f;
             }
             v[31601] = 0;
             g = f + 60 | 0;
             N(357, g | 0, i | 0);
             j = v[31601];
             v[31601] = 0;
             if ((j | 0) == 1) {
              break c;
             }
             m = _e(g);
             j = Xi(g);
             o = w[f + 60 | 0];
             if ((o - 1 & 255) >>> 0 <= 71) {
              t[d | 0] = o + 36;
              z = d, A = w[Ic(g) | 0] + 1 | 0, t[z + 1 | 0] = A;
             }
             if ((w[m | 0] - 1 & 255) >>> 0 <= 15) {
              t[d + 2 | 0] = 1;
              t[d + 4 | 0] = ((w[m | 0] << 6) + -64 >>> 0) / 15;
             }
             m = w[j | 0];
             g = m & 15;
             t[d + 5 | 0] = g;
             g: {
              h: {
               switch ((w[j | 0] >>> 4 | 0) - 1 | 0) {
               case 0:
               case 1:
                t[d + 5 | 0] = m | 240;
                break g;

               case 2:
                t[d + 5 | 0] = g << 2;
                break g;

               case 3:
                t[d + 5 | 0] = (6 / (g + 1 >>> 0) | 0) + 1;
                break g;

               case 5:
               case 6:
                t[d + 5 | 0] = g << 3;
                break g;

               case 9:
                t[d + 2 | 0] = 1;
                t[d + 4 | 0] = (g << 2) + 4;
                break g;

               case 10:
                t[d + 5 | 0] = g | 128;
                break g;

               case 11:
                break h;

               default:
                break g;
               }
              }
              t[d + 5 | 0] = (6 / (g + 1 >>> 0) | 0) + 1 | 13;
             }
             t[d + 3 | 0] = w[(w[j | 0] >>> 4 | 0) + 24736 | 0];
             sg(f);
             continue;
            }
           }
           break;
          }
          ze(Vb(v[k >> 2], e), Uh(We(Ne(f + 68 | 0, 14, 0), s)));
         }
         tb(i);
        }
        e = e + 1 | 0;
        continue;
       }
      }
      break;
     }
    }
   } else {
    e = h + (d << 5) | 0;
    Ve(e);
    v[e >> 2] = !w[d + i | 0] << 10;
    u[e + 4 >> 1] = (w[d + g | 0] << 4 | 8) & 248;
    d = d + 1 | 0;
    continue;
   }
   break;
  }
  a = M() | 0;
  tb(i);
  P(a | 0);
  p();
 }
 eb = f + 960 | 0;
 return n | 0;
}

function fsa(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, q = 0;
 i = eb - 720 | 0;
 eb = i;
 a: {
  b: {
   if (d >>> 0 <= 511) {
    d = eb - 16 | 0;
    eb = d;
    a = i + 46 | 0;
    ac(d + 8 | 0, a, 554);
    e = v[d + 12 >> 2];
    ic(d, v[b >> 2], v[b + 8 >> 2], v[d + 8 >> 2], v[d + 12 >> 2]);
    f = v[d + 4 >> 2];
    if ((f | 0) == (e | 0)) {
     Ub(b, v[d + 12 >> 2]);
    }
    eb = d + 16 | 0;
    b = (e | 0) == (f | 0);
    if (!b) {
     Qb(a, 0, 554);
    }
    if (!b) {
     break b;
    }
    d = eb - 32 | 0;
    eb = d;
    c: {
     if ((w[a | 0] | w[a + 1 | 0] << 8 | (w[a + 2 | 0] << 16 | w[a + 3 | 0] << 24)) != 1229999433) {
      break c;
     }
     e = d + 8 | 0;
     Yr(e, a + 32 | 0);
     b = d + 20 | 0;
     Bc(b, e);
     zc(c + 492 | 0, b);
     sb(b);
     ck(e, 1, a + 4 | 0);
     Bc(b, e);
     zc(c + 524 | 0, b);
     sb(b);
     b = w[a + 24 | 0] | w[a + 25 | 0] << 8;
     v[c + 4 >> 2] = 64;
     v[c + 8 >> 2] = 128;
     v[c >> 2] = b << 6;
     t[c + 16 | 0] = w[a + 26 | 0];
     t[c + 17 | 0] = w[a + 27 | 0];
     f = c + 108 | 0;
     j = c + 236 | 0;
     h = a - -64 | 0;
     b = 0;
     while (1) if ((b | 0) == 120) {
      b = w[c + 60 | 0] & -2 | t[a + 17 | 0] & 1;
      t[c + 60 | 0] = b;
      b = b & -3 | w[a + 17 | 0] & 2;
      t[c + 60 | 0] = b;
      t[c + 60 | 0] = b & 251 | w[a + 17 | 0] & 4;
      t[c + 61 | 0] = w[a + 18 | 0];
      t[c + 62 | 0] = w[a + 19 | 0];
      t[c + 63 | 0] = w[a + 20 | 0];
      t[c + 64 | 0] = w[a + 21 | 0];
      e = c + 48 | 0;
      eh(e, 25);
      f = a + 504 | 0;
      j = c - -64 | 0;
      h = c + 63 | 0;
      g = c + 62 | 0;
      k = c + 61 | 0;
      a = v[c + 48 >> 2];
      b = 0;
      while (1) {
       d: {
        if ((b | 0) != 25) {
         l = xb(a, b);
         m = f + (b << 1) | 0;
         n = w[m | 0];
         u[l >> 1] = n;
         if ((n | 0) != 255) {
          break d;
         }
         eh(e, b);
         a = v[e >> 2];
        }
        b = cf(k, g);
        a = Rd(a, v[c + 52 >> 2]);
        if (a >>> 0 <= w[b | 0]) {
         t[c + 60 | 0] = w[c + 60 | 0] & 253;
        }
        if (a >>> 0 > w[cf(h, j) | 0]) {
         break c;
        }
        t[c + 60 | 0] = w[c + 60 | 0] & 251;
        break c;
       }
       t[l + 2 | 0] = w[m + 1 | 0];
       b = b + 1 | 0;
       continue;
      }
     } else {
      g = h + (b << 1) | 0;
      e = w[g | 0];
      o = $b(j, b), q = w[g + 1 | 0], u[o >> 1] = q;
      o = wb(f, b), q = (e >>> 0 < 120 ? e : b) + 1 | 0, t[o | 0] = q;
      b = b + 1 | 0;
      continue;
     }
    }
    eb = d + 32 | 0;
    break b;
   }
   j = v[b + 8 >> 2];
   d = eb - 32 | 0;
   eb = d;
   v[d + 28 >> 2] = 674;
   v[d + 8 >> 2] = 674;
   e = v[b >> 2];
   g = v[b + 8 >> 2];
   f = v[Gb(d + 28 | 0, d + 8 | 0) >> 2];
   if (!Lb(e, g, f)) {
    f = jf(b);
   }
   h = d + 8 | 0;
   e = i + 46 | 0;
   HZ(h, e);
   g = Yb(d + 16 | 0, v[d + 8 >> 2], f);
   k = v[g >> 2];
   ic(d, v[b >> 2], v[b + 8 >> 2], k, v[g + 4 >> 2]);
   HZ(h, e);
   Qb(v[d + 8 >> 2] + f | 0, 0, 674 - f | 0);
   Ub(b, v[d + 28 >> 2]);
   eb = d + 32 | 0;
   h = v[a + 480180 >> 2];
   a = 0;
   d = eb - 32 | 0;
   eb = d;
   if ((w[e | 0] | w[e + 1 | 0] << 8 | (w[e + 2 | 0] << 16 | w[e + 3 | 0] << 24)) == 1229999433) {
    f = d + 8 | 0;
    Yr(f, e + 32 | 0);
    a = d + 20 | 0;
    Bc(a, f);
    zc(c + 492 | 0, a);
    sb(a);
    ck(f, 1, e + 4 | 0);
    Bc(a, f);
    zc(c + 524 | 0, a);
    sb(a);
    v[c >> 2] = (w[e + 20 | 0] | w[e + 21 | 0] << 8) << 5;
    v[c + 4 >> 2] = w[e + 24 | 0] >>> 1;
    wc(c + 4 | 0, 64);
    g = w[e + 25 | 0] & 127;
    v[c + 8 >> 2] = g >>> 0 > 64 ? 128 : g << 2;
    t[c + 15 | 0] = w[c + 15 | 0] & 254 | ((w[e + 25 | 0] ^ -1) & 128) >>> 7;
    t[d + 20 | 0] = w[e + 26 | 0];
    t[d + 8 | 0] = 100;
    o = c, q = w[Pb(a, f) | 0], t[o + 20 | 0] = q;
    t[d + 20 | 0] = w[e + 27 | 0];
    t[d + 8 | 0] = 64;
    o = c, q = w[Pb(a, f) | 0], t[o + 19 | 0] = q;
    t[c + 16 | 0] = w[e + 17 | 0];
    t[c + 17 | 0] = w[e + 18 | 0];
    t[c + 18 | 0] = w[e + 19 | 0];
    t[c + 26 | 0] = w[e + 22 | 0];
    t[c + 27 | 0] = w[e + 23 | 0];
    a = w[e + 58 | 0];
    bk(c, a & 127, a >>> 7 | 0);
    a = w[e + 59 | 0];
    ak(c, a & 127, a >>> 7 | 0);
    e: {
     f: {
      g: {
       h: {
        i: {
         j: {
          a = w[e + 28 | 0] | w[e + 29 | 0] << 8;
          switch (a - 529 | 0) {
          case 1:
          case 2:
           break h;

          case 0:
          case 3:
           break i;

          default:
           break j;
          }
         }
         if ((a | 0) == 544) {
          break i;
         }
         if ((a | 0) != 514) {
          break h;
         }
        }
        a = w[e + 61 | 0];
        if ((a | 0) == 255) {
         break g;
        }
        if (a >>> 0 <= 128) {
         t[c + 30 | 0] = a;
        }
        a = w[e + 62 | 0] | w[e + 63 | 0] << 8;
        if (a >>> 0 < 129) {
         break f;
        }
        break e;
       }
       a = t[e + 61 | 0];
       if ((a | 0) < 0) {
        break g;
       }
       t[c + 30 | 0] = a + 1;
      }
      a = t[e + 62 | 0];
      a = ((a | 0) >= 0 ? a + 1 | 0 : 0) & 255;
      f = t[e + 63 | 0];
      if ((f | 0) < 0) {
       break f;
      }
      a = ((f & 255) << 7) + a | 0;
     }
     u[c + 28 >> 1] = a;
    }
    a = t[e + 60 | 0];
    t[c + 31 | 0] = a;
    if ((a | 0) < 0) {
     t[c + 31 | 0] = 0;
     t[c + 34 | 0] = a & 127;
    }
    a = 0;
    f = h & 16777216 ? 240 : 25;
    Xw(e + 304 | 0, c + 48 | 0, 0, f);
    Xw(e + 386 | 0, c + 68 | 0, 32, f);
    Xw(e + 468 | 0, c + 88 | 0, 32, f);
    t[c + 100 | 0] = w[c + 100 | 0] & 239 | w[e + 468 | 0] >>> 3 & 16;
    h = c + 108 | 0;
    g = c + 236 | 0;
    k = e - -64 | 0;
    while (1) {
     if ((a | 0) != 120) {
      l = k + (a << 1) | 0;
      f = w[l | 0];
      o = $b(g, a), q = w[l + 1 | 0], u[o >> 1] = q;
      o = wb(h, a), q = (f >>> 0 < 120 ? f : a) + 1 | 0, t[o | 0] = q;
      a = a + 1 | 0;
      continue;
     }
     break;
    }
    a = 554;
   }
   eb = d + 32 | 0;
   d = 0;
   k: {
    if (!a) {
     break k;
    }
    d = w[e + 550 | 0] | w[e + 551 | 0] << 8 | (w[e + 552 | 0] << 16 | w[e + 553 | 0] << 24);
    if (!((d | 0) != 1481920589 & (d | 0) != 1297110104)) {
     d = c + 236 | 0;
     e = e + 554 | 0;
     a = 0;
     while (1) {
      if ((a | 0) != 120) {
       f = $b(d, a);
       u[f >> 1] = x[f >> 1] | w[a + e | 0] << 8;
       a = a + 1 | 0;
       continue;
      }
      break;
     }
     a = 674;
    }
    d = a;
   }
   cd(b, d + j | 0);
   if (!$j(b, 14031)) {
    break b;
   }
   d = i + 4 | 0;
   ge(d, b, Qg(b));
   a = gc(i + 24 | 0, d);
   tb(d);
   b = v[a >> 2];
   v[31601] = 0;
   Q(154, b | 0) | 0;
   b = v[31601];
   v[31601] = 0;
   if ((b | 0) == 1) {
    break a;
   }
   v[31601] = 0;
   b = O(412, a | 0, 13813) | 0;
   d = v[31601];
   v[31601] = 0;
   if ((d | 0) == 1) {
    break a;
   }
   if (b) {
    v[31601] = 0;
    b = Q(197, a | 0) | 0;
    d = v[31601];
    v[31601] = 0;
    if ((d | 0) == 1) {
     break a;
    }
    t[c + 34 | 0] = b >>> 0 <= 250 ? b : 0;
   }
   tb(a);
  }
  eb = i + 720 | 0;
  return;
 }
 b = M() | 0;
 tb(a);
 P(b | 0);
 p();
}

function eja(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0;
 c = eb - 32 | 0;
 eb = c;
 a: {
  b: {
   if (!Hb(v[b >> 2], v[b + 4 >> 2])) {
    break b;
   }
   l = a + 16 | 0;
   m = v[b + 12 >> 2];
   k = x[v[v[b + 48 >> 2] + 12 >> 2] + 480188 >> 1];
   d = k;
   e = eb - 16 | 0;
   eb = e;
   g = c + 20 | 0;
   v[g >> 2] = 0;
   v[g + 4 >> 2] = 0;
   sc(g + 8 | 0);
   Qd(e + 8 | 0, v[ub(e + 4 | 0, g) >> 2]);
   c: {
    d: {
     if (d) {
      v[31601] = 0;
      N(460, g | 0, d | 0);
      f = v[31601];
      v[31601] = 0;
      if ((f | 0) == 1) {
       break d;
      }
      h = eb - 16 | 0;
      eb = h;
      f = Cr(h + 4 | 0, g, d);
      d = v[f + 4 >> 2];
      i = v[f + 8 >> 2];
      while (1) {
       if ((d | 0) == (i | 0)) {
        hc(f);
        eb = h + 16 | 0;
       } else {
        t[d | 0] = 0;
        t[d + 1 | 0] = 0;
        t[d + 2 | 0] = 0;
        t[d + 3 | 0] = 0;
        t[d + 4 | 0] = 0;
        t[d + 5 | 0] = 0;
        Mg(d);
        d = d + 6 | 0;
        v[f + 4 >> 2] = d;
        continue;
       }
       break;
      }
     }
     d = e + 8 | 0;
     Pd(d);
     _l(d);
     eb = e + 16 | 0;
     break c;
    }
    a = M() | 0;
    _l(e + 8 | 0);
    P(a | 0);
    p();
   }
   while (1) {
    e: {
     f: {
      g: {
       h: {
        i: {
         j: {
          k: {
           l: {
            m: {
             n: {
              o: {
               p: {
                q: {
                 r: {
                  s: {
                   if (!(v[v[v[a >> 2] - 12 >> 2] + l >> 2] | j >>> 0 >= m >>> 0)) {
                    v[31601] = 0;
                    t[c + 19 | 0] = 0;
                    O(917, a | 0, c + 19 | 0) | 0;
                    d = v[31601];
                    v[31601] = 0;
                    if ((d | 0) == 1) {
                     break a;
                    }
                    d = t[c + 19 | 0];
                    if (!d) {
                     j = j + 1 | 0;
                     continue;
                    }
                    t[c + 18 | 0] = 0;
                    t: {
                     if ((d | 0) >= 0) {
                      break t;
                     }
                     v[31601] = 0;
                     O(917, a | 0, c + 18 | 0) | 0;
                     e = v[31601];
                     v[31601] = 0;
                     if ((e | 0) != 1) {
                      break t;
                     }
                     break a;
                    }
                    t[c + 17 | 0] = 0;
                    u[c + 12 >> 1] = 0;
                    v[c + 8 >> 2] = 0;
                    u: {
                     d = d & 127;
                     f = (d ? d - 1 | 0 : 0) & 65535;
                     i = f >>> 0 >= k >>> 0;
                     v: {
                      w: {
                       if (!i) {
                        h = ld(v[b >> 2], v[v[b + 48 >> 2] + 12 >> 2], j, f);
                        d = w[c + 18 | 0];
                        if (d & 1) {
                         break w;
                        }
                        e = Xc(v[g >> 2], f);
                        break v;
                       }
                       h = c + 8 | 0;
                       d = w[c + 18 | 0];
                       if (!(d & 1)) {
                        break u;
                       }
                      }
                      v[31601] = 0;
                      O(917, a | 0, c + 17 | 0) | 0;
                      e = v[31601];
                      v[31601] = 0;
                      if ((e | 0) == 1) {
                       break a;
                      }
                      if (i) {
                       break u;
                      }
                      e = Xc(v[g >> 2], f);
                      t[e | 0] = w[c + 17 | 0];
                     }
                     t[h | 0] = w[e | 0];
                     d = w[c + 18 | 0];
                     if (!(d & 2)) {
                      break r;
                     }
                     break s;
                    }
                    if (d & 2) {
                     break s;
                    }
                    break q;
                   }
                   Jk(g);
                   break b;
                  }
                  v[31601] = 0;
                  O(917, a | 0, c + 17 | 0) | 0;
                  e = v[31601];
                  v[31601] = 0;
                  if ((e | 0) == 1) {
                   break a;
                  }
                  if (i) {
                   break q;
                  }
                  e = Xc(v[g >> 2], f);
                  t[e + 1 | 0] = w[c + 17 | 0];
                 }
                 t[h + 1 | 0] = w[e + 1 | 0];
                 if (d & 4) {
                  break p;
                 }
                 break o;
                }
                if (!(d & 4)) {
                 break n;
                }
               }
               v[31601] = 0;
               O(917, a | 0, c + 17 | 0) | 0;
               e = v[31601];
               v[31601] = 0;
               if ((e | 0) == 1) {
                break a;
               }
               if (i) {
                break n;
               }
               e = Xc(v[g >> 2], f);
               t[e + 2 | 0] = w[c + 17 | 0];
              }
              t[h + 2 | 0] = w[e + 2 | 0];
              if (!(d & 8)) {
               break l;
              }
              break m;
             }
             if (!(d & 8)) {
              break k;
             }
            }
            v[31601] = 0;
            O(917, a | 0, c + 17 | 0) | 0;
            e = v[31601];
            v[31601] = 0;
            if ((e | 0) == 1) {
             break a;
            }
            if (i) {
             break k;
            }
            e = Xc(v[g >> 2], f);
            t[e + 4 | 0] = w[c + 17 | 0];
           }
           t[h + 4 | 0] = w[e + 4 | 0];
           if (d & 16) {
            break j;
           }
           break i;
          }
          if (!(d & 16)) {
           break h;
          }
         }
         v[31601] = 0;
         O(917, a | 0, c + 17 | 0) | 0;
         e = v[31601];
         v[31601] = 0;
         if ((e | 0) == 1) {
          break a;
         }
         if (i) {
          break h;
         }
         e = Xc(v[g >> 2], f);
         t[e + 3 | 0] = w[c + 17 | 0];
        }
        t[h + 3 | 0] = w[e + 3 | 0];
        if (!(d & 32)) {
         break f;
        }
        break g;
       }
       if (!(d & 32)) {
        break e;
       }
      }
      v[31601] = 0;
      O(917, a | 0, c + 17 | 0) | 0;
      e = v[31601];
      v[31601] = 0;
      if ((e | 0) == 1) {
       break a;
      }
      if (i) {
       break e;
      }
      e = Xc(v[g >> 2], f);
      t[e + 5 | 0] = w[c + 17 | 0];
     }
     t[h + 5 | 0] = w[e + 5 | 0];
    }
    if (!(d & 64)) {
     continue;
    }
    v[31601] = 0;
    O(917, a | 0, c + 7 | 0) | 0;
    d = v[31601];
    v[31601] = 0;
    if ((d | 0) != 1) {
     v[31601] = 0;
     O(918, a | 0, w[c + 7 | 0]) | 0;
     d = v[31601];
     v[31601] = 0;
     if ((d | 0) != 1) {
      continue;
     }
    }
    break;
   }
   break a;
  }
  eb = c + 32 | 0;
  return;
 }
 a = M() | 0;
 Jk(g);
 P(a | 0);
 p();
}

function Eoa(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, q = 0;
 f = eb - 176 | 0;
 eb = f;
 xc(b);
 d = f + 128 | 0;
 a: {
  if (!TD(b, d)) {
   break a;
  }
  if (!EW(d)) {
   break a;
  }
  if (!Lb(v[b >> 2], v[b + 8 >> 2], Ac(DW(w[f + 159 | 0], w[f + 161 | 0]), gb))) {
   break a;
  }
  e = 1;
  if ((c | 0) == 64) {
   break a;
  }
  Cd(a, 256);
  g = f + 16 | 0;
  oi(g, 2, d);
  d = f + 48 | 0;
  Bc(d, g);
  yb(a + 1298308 | 0, d);
  sb(d);
  e = tc(d, 15326);
  yb(a + 1298344 | 0, e);
  sb(e);
  e = tc(d, 10120);
  yb(a + 1298356 | 0, e);
  sb(e);
  fg(g, 4271);
  v[31601] = 0;
  e = f + 116 | 0;
  N(249, e | 0, f + 159 | 0);
  h = v[31601];
  v[31601] = 0;
  b: {
   c: {
    if ((h | 0) != 1) {
     v[31601] = 0;
     U(699, d | 0, g | 0, f + 158 | 0, e | 0);
     h = v[31601];
     v[31601] = 0;
     if ((h | 0) != 1) {
      yb(a + 1298368 | 0, d);
      sb(d);
      sb(e);
      Db(g);
      o = a, q = v[Ec(d, 4) >> 2], v[o + 1298404 >> 2] = q;
      d = Kb(a + 1074312 | 0, 107, 1);
      v[a + 480260 >> 2] = 64;
      v[a + 480264 >> 2] = 32767;
      v[a + 480188 >> 2] = 2031620;
      Kb(d, 107, 1);
      e = w[f + 160 | 0];
      d = w[f + 159 | 0];
      if (d >>> 0 <= 20) {
       g = ((e & 255) >>> 0) / 10 | 0;
       e = g << 4 | B(g, -10) + e;
      }
      g = (e & 255 ? e : 96) & 255;
      e = BC(g);
      v[a + 480196 >> 2] = g >>> 4;
      v[a + 480204 >> 2] = e;
      if (d >>> 0 >= 11) {
       t[f + 48 | 0] = 64;
       o = a, q = w[Pb(f + 162 | 0, f + 48 | 0) | 0] << 2, v[o + 480200 >> 2] = q;
      }
      d = a + 480280 | 0;
      e = 0;
      while (1) if ((e | 0) == 4) {
       l = a + 946304 | 0;
       m = a + 484380 | 0;
       e = 1;
       while (1) {
        if ((e | 0) != 32) {
         d = f + 16 | 0;
         xr(b, d);
         g = w[f + 28 | 0];
         if (g ? (g | 0) != 46 : 0) {
          break b;
         }
         h = eb - 32 | 0;
         eb = h;
         g = B(e, 104) + m | 0;
         md(g, 0);
         j = h + 8 | 0;
         Ik(j, 2, d);
         i = h + 20 | 0;
         Bc(i, j);
         Ae(g + 43 | 0, i);
         sb(i);
         v[g + 24 >> 2] = w[d + 24 | 0] | w[d + 25 | 0] << 8;
         t[h + 20 | 0] = w[d + 22 | 0];
         t[h + 8 | 0] = 64;
         o = g, q = w[Pb(i, j) | 0] << 2, u[o + 30 >> 1] = q;
         i = w[d + 16 | 0] | w[d + 17 | 0] << 8;
         v[g >> 2] = i;
         j = w[d + 18 | 0] | w[d + 19 | 0] << 8;
         v[g + 4 >> 2] = j;
         k = w[d + 20 | 0] | w[d + 21 | 0] << 8;
         v[g + 8 >> 2] = k;
         d: {
          if (i >>> 0 <= 1) {
           v[g >> 2] = 0;
           break d;
          }
          if ((k | 0) == 65535 | i >>> 0 <= j >>> 0 | j >>> 0 >= k >>> 0) {
           break d;
          }
          u[g + 34 >> 1] = 2;
          o = g, q = v[Gb(g + 8 | 0, g) >> 2], v[o + 8 >> 2] = q;
         }
         eb = h + 32 | 0;
         g = f + 4 | 0;
         Ik(g, 2, d);
         d = f + 116 | 0;
         Bc(d, g);
         zc(l + (e << 5) | 0, d);
         sb(d);
         u[((e << 1) + f | 0) + 46 >> 1] = w[f + 30 | 0] | w[f + 31 | 0] << 8;
         e = e + 1 | 0;
         continue;
        }
        break;
       }
       _j(Wb(v[a + 484360 >> 2], w[a + 484376 | 0]), b, w[f + 159 | 0] ? 128 : 64, 65535, 65535);
       e = 0;
       if (!BW(Wb(v[a + 484360 >> 2], w[a + 484376 | 0]))) {
        break a;
       }
       n = c & 1;
       if (n) {
        Sf(a + 484344 | 0, w[f + 161 | 0]);
       }
       j = a + 484344 | 0;
       h = 0;
       while (1) if (w[f + 161 | 0] <= h >>> 0) {
        e = 1;
        if (!(c & 2)) {
         break a;
        }
        c = Yc(f + 16 | 0, 8, 1, 0, 0);
        while (1) if ((e | 0) == 32) {
         e = 1;
         break a;
        } else {
         a = B(e, 104) + m | 0;
         e: {
          if (!v[a >> 2] | !x[a + 30 >> 1]) {
           break e;
          }
          d = x[((e << 1) + f | 0) + 46 >> 1];
          if (d >>> 0 < 4) {
           break e;
          }
          if (!cd(b, d << 4)) {
           break e;
          }
          cg(c, a, b);
         }
         e = e + 1 | 0;
         continue;
        }
       } else {
        f: {
         g: {
          if (n) {
           if (Og(j, h & 65535, 64)) {
            break g;
           }
          }
          e = 0;
          while (1) {
           if ((e | 0) == 256) {
            break f;
           }
           if ((Yd(b) + 2 & 255) >>> 0 <= 252) {
            Ub(b, 3);
           }
           e = e + 1 | 0;
           continue;
          }
         }
         o = f, q = vb(v[Vb(v[j >> 2], h) >> 2]), v[o + 116 >> 2] = q;
         u[f + 2 >> 1] = 65535;
         v[f + 4 >> 2] = 63;
         i = 0;
         h: while (1) {
          e = 0;
          if ((i | 0) == 64) {
           a = x[f + 2 >> 1];
           if ((a | 0) == 65535) {
            break f;
           }
           ze(Vb(v[j >> 2], h), zn(We(Ne(f + 16 | 0, 12, a & 255), v[f + 4 >> 2])));
           break f;
          }
          while (1) {
           i: {
            j: {
             k: {
              if ((e & 65535) >>> 0 <= 3) {
               d = 0;
               a = 0;
               k = 0;
               l = 0;
               l: {
                m: {
                 n: {
                  o: {
                   g = Yd(b);
                   switch (g - 251 | 0) {
                   case 1:
                    break i;

                   case 0:
                    break m;

                   case 2:
                    break o;

                   default:
                    break n;
                   }
                  }
                  t[v[f + 116 >> 2]] = 254;
                  break i;
                 }
                 d = f + 16 | 0;
                 Tr(d, b);
                 a = w[wb(d, 0) | 0];
                 k = w[wb(d, 1) | 0];
                 l = w[wb(d, 2) | 0];
                 d = 254;
                 if ((g | 0) == 254) {
                  break l;
                 }
                 if (g >>> 0 >= 96) {
                  break k;
                 }
                 d = g;
                }
                d = (B(d >>> 4 | 0, 12) + (d & 15) | 0) + 37 | 0;
               }
               g = d;
               d = v[f + 116 >> 2];
               t[d | 0] = g;
               break j;
              }
              i = i + 1 | 0;
              continue h;
             }
             d = v[f + 116 >> 2];
            }
            t[d + 1 | 0] = (a & 248) >>> 3;
            a = k >>> 1 & 120 | a & 7;
            if (a >>> 0 <= 64) {
             t[d + 4 | 0] = a;
             t[d + 2 | 0] = 1;
            }
            t[d + 5 | 0] = l;
            AW(d, k & 15, i, w[f + 159 | 0], f + 2 | 0, f + 4 | 0);
           }
           e = e + 1 | 0;
           MC(f + 116 | 0);
           continue;
          }
         }
        }
        h = h + 1 | 0;
        continue;
       }
      } else {
       g = d + (e << 5) | 0;
       Ve(g);
       u[g + 4 >> 1] = e & 1 ? 64 : 192;
       e = e + 1 | 0;
       continue;
      }
     }
     e = M() | 0;
     sb(f + 116 | 0);
     break c;
    }
    e = M() | 0;
   }
   Db(f + 16 | 0);
   P(e | 0);
   p();
  }
  e = 0;
 }
 eb = f + 176 | 0;
 return e | 0;
}

function qra(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0;
 g = eb - 192 | 0;
 eb = g;
 l = g + 80 | 0;
 $d(l, b);
 i = v[g + 88 >> 2];
 m = v[g + 92 >> 2];
 e = eb - 32 | 0;
 eb = e;
 v[e + 28 >> 2] = 0;
 Ek(b, e + 28 | 0);
 a: {
  b: {
   c: {
    if (v[e + 28 >> 2] != (Cn(14123) | 0)) {
     break c;
    }
    v[e + 24 >> 2] = 0;
    h = eb - 32 | 0;
    eb = h;
    v[h + 28 >> 2] = 0;
    cy(h + 8 | 0, h + 28 | 0);
    j = h + 20 | 0;
    Lm(j, b, v[h + 8 >> 2], v[h + 12 >> 2]);
    Jm(j, v[h + 28 >> 2]);
    v[e + 24 >> 2] = v[h + 20 >> 2];
    eb = h + 32 | 0;
    h = -1;
    f = v[e + 24 >> 2];
    if (f - 3 >>> 0 < 4294967294) {
     break c;
    }
    d: {
     e: {
      f: {
       if (f >>> 0 <= 1) {
        f = Eb(e + 12 | 0);
        v[31601] = 0;
        j = T(495, b | 0, f | 0, 256) | 0;
        k = v[31601];
        v[31601] = 0;
        if ((k | 0) == 1) {
         break b;
        }
        if (!j) {
         break e;
        }
        v[31601] = 0;
        R(496, e | 0, d | 0, f | 0);
        j = v[31601];
        v[31601] = 0;
        if ((j | 0) != 1) {
         break f;
        }
        break b;
       }
       f = Eb(e + 12 | 0);
       v[31601] = 0;
       j = O(498, b | 0, f | 0) | 0;
       k = v[31601];
       v[31601] = 0;
       if ((k | 0) == 1) {
        break b;
       }
       if (!j) {
        break d;
       }
       v[31601] = 0;
       R(496, e | 0, d | 0, f | 0);
       j = v[31601];
       v[31601] = 0;
       if ((j | 0) == 1) {
        break b;
       }
      }
      yb(c, e);
      sb(e);
      sb(f);
      mg(b, e);
      f = 0;
      v[e + 12 >> 2] = 0;
      Ek(b, e + 12 | 0);
      j = v[e + 12 >> 2];
      if (j >>> 0 > 50) {
       break c;
      }
      g: {
       while (1) {
        if ((f | 0) == (j | 0)) {
         break g;
        }
        f = f + 1 | 0;
        if (MQ(a, b, d)) {
         continue;
        }
        break;
       }
       break c;
      }
      v[e + 12 >> 2] = 0;
      Ek(b, e + 12 | 0);
      h = v[e + 12 >> 2] == (Cn(14161) | 0) ? 1 : -1;
      break c;
     }
     sb(f);
     break c;
    }
    sb(f);
   }
   eb = e + 32 | 0;
   break a;
  }
  a = M() | 0;
  sb(f);
  P(a | 0);
  p();
 }
 h: {
  if (h) {
   break h;
  }
  hg(v[v[b >> 2] - 12 >> 2] + b | 0, 0);
  b = Im(l, Ci(b, i, m, 0));
  v[31601] = 0;
  h = O(461, g + 68 | 0, 14272) | 0;
  i = v[31601];
  v[31601] = 0;
  i: {
   if ((i | 0) != 1) {
    v[31601] = 0;
    v[g + 48 >> 2] = 3;
    v[g + 52 >> 2] = 0;
    i = g + 48 | 0;
    R(462, b | 0, h | 0, i | 0);
    e = v[31601];
    v[31601] = 0;
    if ((e | 0) != 1) {
     Db(h);
     t[g + 67 | 0] = 0;
     v[31601] = 0;
     h = O(461, i | 0, 14717) | 0;
     i = v[31601];
     v[31601] = 0;
     if ((i | 0) != 1) {
      v[31601] = 0;
      R(463, b | 0, g + 67 | 0, h | 0);
      i = v[31601];
      v[31601] = 0;
      if ((i | 0) != 1) {
       Db(h);
       h = Ec(g + 44 | 0, w[g + 67 | 0] ? 0 : d);
       v[31601] = 0;
       d = Q(476, b | 0) | 0;
       i = v[31601];
       v[31601] = 0;
       if ((i | 0) != 1) {
        v[31601] = 0;
        i = Q(477, b | 0) | 0;
        e = v[31601];
        v[31601] = 0;
        if ((e | 0) != 1) {
         v[g + 40 >> 2] = d;
         j: {
          k: {
           l: {
            m: {
             while (1) {
              if (!Hb(d, i)) {
               a = ol(w[b | 0]);
               Bh(b);
               h = a ? -1 : 1;
               break h;
              }
              v[31601] = 0;
              d = O(461, g + 24 | 0, 15833) | 0;
              e = v[31601];
              v[31601] = 0;
              if ((e | 0) == 1) {
               break l;
              }
              e = v[b + 44 >> 2];
              f = v[b + 40 >> 2];
              v[31601] = 0;
              e = aa(478, f | 0, e | 0, v[g + 40 >> 2], d | 0) | 0;
              f = v[31601];
              v[31601] = 0;
              if ((f | 0) == 1) {
               break k;
              }
              Db(d);
              n: {
               o: {
                if (e) {
                 d = v[h >> 2];
                 v[31601] = 0;
                 U(479, b | 0, g + 40 | 0, c | 0, d | 0);
                 d = v[31601];
                 v[31601] = 0;
                 if ((d | 0) != 1) {
                  break o;
                 }
                 break j;
                }
                v[31601] = 0;
                d = O(461, g + 12 | 0, 15530) | 0;
                e = v[31601];
                v[31601] = 0;
                p: {
                 q: {
                  if ((e | 0) != 1) {
                   e = v[b + 44 >> 2];
                   f = v[b + 40 >> 2];
                   v[31601] = 0;
                   e = aa(478, f | 0, e | 0, v[g + 40 >> 2], d | 0) | 0;
                   f = v[31601];
                   v[31601] = 0;
                   if ((f | 0) == 1) {
                    break q;
                   }
                   Db(d);
                   if (!e) {
                    break p;
                   }
                   v[31601] = 0;
                   R(480, b | 0, g + 40 | 0, g + 38 | 0);
                   d = v[31601];
                   v[31601] = 0;
                   if ((d | 0) == 1) {
                    break j;
                   }
                   break o;
                  }
                  a = M() | 0;
                  break i;
                 }
                 a = M() | 0;
                 Db(d);
                 break i;
                }
                v[31601] = 0;
                d = O(461, g | 0, 15363) | 0;
                e = v[31601];
                v[31601] = 0;
                if ((e | 0) == 1) {
                 break n;
                }
                e = v[b + 44 >> 2];
                f = v[b + 40 >> 2];
                v[31601] = 0;
                e = aa(478, f | 0, e | 0, v[g + 40 >> 2], d | 0) | 0;
                f = v[31601];
                v[31601] = 0;
                if ((f | 0) == 1) {
                 break m;
                }
                Db(d);
                if (!e) {
                 break o;
                }
                d = v[h >> 2];
                v[31601] = 0;
                U(481, b | 0, g + 40 | 0, a | 0, d | 0);
                d = v[31601];
                v[31601] = 0;
                if ((d | 0) == 1) {
                 break j;
                }
               }
               gA(g + 40 | 0);
               d = v[g + 40 >> 2];
               continue;
              }
              break;
             }
             a = M() | 0;
             break i;
            }
            a = M() | 0;
            Db(d);
            break i;
           }
           a = M() | 0;
           break i;
          }
          a = M() | 0;
          Db(d);
          break i;
         }
         a = M() | 0;
         break i;
        }
        a = M() | 0;
        break i;
       }
       a = M() | 0;
       break i;
      }
      a = M() | 0;
      Db(h);
      break i;
     }
     a = M() | 0;
     break i;
    }
    a = M() | 0;
    Db(h);
    break i;
   }
   a = M() | 0;
  }
  Bh(b);
  P(a | 0);
  p();
 }
 eb = g + 192 | 0;
 return h | 0;
}

function f1(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0;
 f = eb - 560 | 0;
 eb = f;
 xc(b);
 d = eb - 16 | 0;
 eb = d;
 g = f + 63 | 0;
 nF(d + 8 | 0, g);
 e = v[d + 12 >> 2];
 ic(d, v[b >> 2], v[b + 8 >> 2], v[d + 8 >> 2], v[d + 12 >> 2]);
 h = v[d + 4 >> 2];
 if ((h | 0) == (e | 0)) {
  Ub(b, v[d + 12 >> 2]);
 }
 eb = d + 16 | 0;
 d = (e | 0) == (h | 0);
 if (!d) {
  mF(g);
 }
 a: {
  b: {
   if (!d) {
    break b;
   }
   if (!qF(g)) {
    break b;
   }
   d = 1;
   if ((c | 0) == 64) {
    break a;
   }
   if (!Lb(v[b >> 2], v[b + 8 >> 2], Ac(pF(w[f + 173 | 0], w[f + 174 | 0]), gb))) {
    break b;
   }
   Cd(a, 64);
   v[a + 480204 >> 2] = 78e4;
   v[a + 480260 >> 2] = 112;
   v[a + 480264 >> 2] = 13696;
   v[a + 480196 >> 2] = 4;
   u[a + 480188 >> 1] = 8;
   Kb(a + 1074312 | 0, 7, 1);
   d = f + 36 | 0;
   g = tc(d, 14631);
   yb(a + 1298344 | 0, g);
   sb(g);
   g = tc(d, 14664);
   yb(a + 1298356 | 0, g);
   sb(g);
   Yh(a + 1298368 | 0, (w[f + 63 | 0] | w[f + 64 | 0] << 8) == 26217 ? 14631 : 14659);
   r = a, s = v[Ec(d, 4) >> 2], v[r + 1298404 >> 2] = s;
   e = w[f + 173 | 0];
   u[a + 480190 >> 1] = e;
   l = a + 946304 | 0;
   m = a + 484380 | 0;
   g = 1;
   while (1) {
    h = g & 65535;
    if (h >>> 0 <= e >>> 0) {
     e = eb - 16 | 0;
     eb = e;
     d = f + 36 | 0;
     ac(e + 8 | 0, d, 25);
     j = v[e + 12 >> 2];
     ic(e, v[b >> 2], v[b + 8 >> 2], v[e + 8 >> 2], v[e + 12 >> 2]);
     i = v[e + 4 >> 2];
     if ((i | 0) == (j | 0)) {
      Ub(b, v[e + 12 >> 2]);
     }
     eb = e + 16 | 0;
     if ((i | 0) != (j | 0)) {
      t[d | 0] = 0;
      t[d + 1 | 0] = 0;
      t[d + 2 | 0] = 0;
      t[d + 3 | 0] = 0;
      t[d + 4 | 0] = 0;
      t[d + 5 | 0] = 0;
      t[d + 6 | 0] = 0;
      t[d + 7 | 0] = 0;
      t[d + 24 | 0] = 0;
      t[d + 16 | 0] = 0;
      t[d + 17 | 0] = 0;
      t[d + 18 | 0] = 0;
      t[d + 19 | 0] = 0;
      t[d + 20 | 0] = 0;
      t[d + 21 | 0] = 0;
      t[d + 22 | 0] = 0;
      t[d + 23 | 0] = 0;
      t[d + 8 | 0] = 0;
      t[d + 9 | 0] = 0;
      t[d + 10 | 0] = 0;
      t[d + 11 | 0] = 0;
      t[d + 12 | 0] = 0;
      t[d + 13 | 0] = 0;
      t[d + 14 | 0] = 0;
      t[d + 15 | 0] = 0;
     }
     if ((w[f + 49 | 0] | w[f + 50 | 0] << 8 | (w[f + 51 | 0] << 16 | w[f + 52 | 0] << 24)) >>> 0 > 67108863) {
      break b;
     }
     e = B(h, 104) + m | 0;
     md(e, 0);
     v[e + 24 >> 2] = 8363;
     i = w[d + 13 | 0] | w[d + 14 | 0] << 8 | (w[d + 15 | 0] << 16 | w[d + 16 | 0] << 24);
     v[e >> 2] = i;
     k = w[d + 17 | 0] | w[d + 18 | 0] << 8 | (w[d + 19 | 0] << 16 | w[d + 20 | 0] << 24);
     v[e + 4 >> 2] = k;
     j = w[d + 21 | 0] | w[d + 22 | 0] << 8 | (w[d + 23 | 0] << 16 | w[d + 24 | 0] << 24);
     v[e + 8 >> 2] = j;
     c: {
      if (!(k | i >>> 0 >= j >>> 0)) {
       v[e + 8 >> 2] = 0;
       break c;
      }
      if (j) {
       u[e + 34 >> 1] = 2;
       Sk(e);
      }
     }
     e = f + 12 | 0;
     ck(e, 2, d);
     d = f + 24 | 0;
     Bc(d, e);
     zc(l + (h << 5) | 0, d);
     g = g + 1 | 0;
     sb(d);
     e = x[a + 480190 >> 1];
     continue;
    }
    break;
   }
   g = f + 24 | 0;
   e = f + 65 | 0;
   tg(g, 3, e, 36);
   d = f + 36 | 0;
   Bc(d, g);
   yb(a + 1298308 | 0, d);
   sb(d);
   g = 0;
   lF(a + 1298332 | 0, e, 108, 36, 0);
   Jw(Wb(v[a + 484360 >> 2], w[a + 484376 | 0]), f + 176 | 0, 128, 255, 254);
   d = Wb(v[a + 484360 >> 2], w[a + 484376 | 0]);
   e = w[f + 175 | 0];
   if (x[$b(v[d >> 2], e) >> 1] < w[f + 174 | 0]) {
    $e(d, e);
   }
   d = a + 480280 | 0;
   while (1) if ((g | 0) == 8) {
    j = a + 484344 | 0;
    Sf(j, w[f + 174 | 0]);
    o = c & 1;
    p = f + 304 | 0;
    q = f + 432 | 0;
    h = 0;
    while (1) {
     d: {
      e: {
       if (w[f + 174 | 0] <= h >>> 0) {
        d = 1;
        if (!(c & 2)) {
         break a;
        }
        c = Yc(f + 36 | 0, 8, 1, 0, 1);
        g = 1;
        break e;
       }
       f: {
        if (o) {
         if (Og(j, h & 65535, 64)) {
          break f;
         }
        }
        Ub(b, 1536);
        break d;
       }
       v[f + 24 >> 2] = -1;
       v[f + 28 >> 2] = -1;
       l = 0;
       g: while (1) {
        if ((l | 0) == 64) {
         d = v[j >> 2];
         g = w[h + q | 0];
         if (g >>> 0 < 63) {
          ze(Vb(d, h), Uh(We(Ne(f + 36 | 0, 14, 0), g)));
          d = v[j >> 2];
         }
         ze(Vb(d, h), Uh(Ne(f + 36 | 0, 16, w[h + p | 0])));
         break d;
        }
        g = 0;
        d = Vb(v[j >> 2], h);
        e = ld(v[d >> 2], v[v[d + 48 >> 2] + 12 >> 2], l, 0);
        while (1) {
         if ((g | 0) == 8) {
          l = l + 1 | 0;
          continue g;
         }
         d = f + 36 | 0;
         Tr(d, b);
         i = Ic(d);
         k = _e(d);
         i = w[i | 0];
         d = w[f + 36 | 0];
         if (d >>> 0 <= 253) {
          t[e | 0] = (d >>> 2 | 0) + 37;
          t[e + 1 | 0] = (d << 4 & 48 | i >>> 4) + 1;
          t[(f + 24 | 0) + g | 0] = 255;
          d = w[f + 36 | 0];
         }
         if ((d & 255) != 255) {
          t[e + 2 | 0] = 1;
          t[e + 4 | 0] = (((i & 15) << 6 | 8) >>> 0) / 15;
         }
         d = w[k | 0];
         if ((d | 0) != 255) {
          t[(f + 24 | 0) + g | 0] = d;
         }
         k = (f + 24 | 0) + g | 0;
         h: {
          i: {
           if (!(d & 15) & (d | 0) != 48) {
            break i;
           }
           d = t[k | 0];
           if ((d | 0) == -1) {
            break h;
           }
           i = d & 15;
           t[e + 5 | 0] = i;
           j: {
            if ((d | 0) < 0) {
             break j;
            }
            n = (d & 240) >>> 4 | 0;
            t[e + 3 | 0] = w[n + 24536 | 0];
            k: {
             switch (n - 3 | 0) {
             case 0:
              t[e + 5 | 0] = i | 32;
              break i;

             case 1:
              t[e + 5 | 0] = i | d << 4;
              break h;

             case 2:
              break i;

             case 3:
              break k;

             default:
              break h;
             }
            }
            l: {
             switch (i | 0) {
             case 0:
              t[e + 5 | 0] = 79;
              break h;

             case 1:
              break l;

             default:
              break j;
             }
            }
            t[e + 5 | 0] = 244;
            break h;
           }
           t[e + 3 | 0] = 0;
           break h;
          }
          t[k | 0] = 255;
         }
         e = e + 6 | 0;
         g = g + 1 | 0;
         continue;
        }
       }
      }
      while (1) {
       d = g & 65535;
       if (d >>> 0 <= x[a + 480190 >> 1]) {
        cg(c, B(d, 104) + m | 0, b);
        g = g + 1 | 0;
        continue;
       }
       break;
      }
      d = 1;
      break a;
     }
     h = h + 1 | 0;
     continue;
    }
   } else {
    e = d + (g << 5) | 0;
    Ve(e);
    u[e + 4 >> 1] = g & 1 ? 208 : 48;
    g = g + 1 | 0;
    continue;
   }
  }
  d = 0;
 }
 eb = f + 560 | 0;
 return d | 0;
}

function lk(a, b) {
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, k = 0, m = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0;
 i = 1;
 o(+b);
 e = j(1) | 0;
 a: {
  b: {
   f = j(0) | 0;
   p = e & 2147483647;
   c: {
    if (!(f | p)) {
     break c;
    }
    o(+a);
    c = j(1) | 0;
    g = j(0) | 0;
    if (!g & (c | 0) == 1072693248) {
     break c;
    }
    t = g;
    r = c & 2147483647;
    if (!(!(r >>> 0 > 2146435072 | (r | 0) == 2146435072 & (g | 0) != 0 | p >>> 0 > 2146435072) & (!f | (p | 0) != 2146435072))) {
     return a + b;
    }
    g = 0;
    d: {
     e: {
      f: {
       g: {
        h: {
         q = c;
         if ((c | 0) > 0) {
          q = 1;
         } else {
          q = (q | 0) >= 0;
         }
         i: {
          if (q) {
           break i;
          }
          g = 2;
          if (p >>> 0 > 1128267775) {
           break i;
          }
          g = 0;
          if (p >>> 0 < 1072693248) {
           break i;
          }
          q = p >>> 20 | 0;
          if (p >>> 0 < 1094713344) {
           break h;
          }
          m = 1075 - q | 0;
          q = f >>> m | 0;
          if ((f | 0) != q << m) {
           break i;
          }
          g = 2 - (q & 1) | 0;
         }
         m = g;
         if (f) {
          break f;
         }
         if ((p | 0) != 2146435072) {
          break g;
         }
         if (!(r - 1072693248 | t)) {
          break c;
         }
         if (r >>> 0 < 1072693248) {
          break e;
         }
         return (e | 0) > 0 | (e | 0) >= 0 ? b : 0;
        }
        if (f) {
         break f;
        }
        g = 1043 - q | 0;
        f = p >>> g | 0;
        if ((p | 0) != f << g) {
         break g;
        }
        m = 2 - (f & 1) | 0;
       }
       if ((p | 0) == 1072693248) {
        if ((e | 0) > 0 | (e | 0) >= 0) {
         return a;
        }
        return 1 / a;
       }
       if ((e | 0) == 1073741824) {
        return a * a;
       }
       if ((e | 0) != 1071644672 | (c | 0) < 0) {
        break f;
       }
       return K(a);
      }
      d = D(a);
      if (t) {
       break d;
      }
      j: {
       if ((c | 0) < 0) {
        if ((c | 0) == -2147483648 | (c | 0) == -1074790400 | (c | 0) == -1048576) {
         break j;
        }
        break d;
       }
       if (!c | (c | 0) == 2146435072) {
        break j;
       }
       if ((c | 0) != 1072693248) {
        break d;
       }
      }
      i = (e | 0) < 0 ? 1 / d : d;
      if ((c | 0) > 0 | (c | 0) >= 0) {
       break c;
      }
      if (!(r - 1072693248 | m)) {
       a = i - i;
       return a / a;
      }
      return (m | 0) == 1 ? -i : i;
     }
     return (e | 0) > 0 | (e | 0) >= 0 ? 0 : -b;
    }
    k: {
     if ((c | 0) > 0 | (c | 0) >= 0) {
      break k;
     }
     l: {
      switch (m | 0) {
      case 0:
       a = a - a;
       return a / a;

      case 1:
       break l;

      default:
       break k;
      }
     }
     i = -1;
    }
    m: {
     if (p >>> 0 >= 1105199105) {
      if (p >>> 0 >= 1139802113) {
       if (r >>> 0 <= 1072693247) {
        return (e | 0) < 0 ? Infinity : 0;
       }
       return (e | 0) > 0 ? Infinity : 0;
      }
      if (r >>> 0 <= 1072693246) {
       return (e | 0) < 0 ? i * 1e300 * 1e300 : i * 1e-300 * 1e-300;
      }
      if (r >>> 0 >= 1072693249) {
       return (e | 0) > 0 ? i * 1e300 * 1e300 : i * 1e-300 * 1e-300;
      }
      a = d + -1;
      d = a * 1.9259629911266175e-8 + a * a * (.5 - a * (a * -.25 + .3333333333333333)) * -1.4426950408889634;
      h = d;
      d = a * 1.4426950216293335;
      o(+(h + d));
      c = j(1) | 0;
      j(0) | 0;
      l(0, 0);
      l(1, c | 0);
      a = +n();
      d = h - (a - d);
      break m;
     }
     a = d * 9007199254740992;
     f = r >>> 0 < 1048576;
     d = f ? a : d;
     o(+a);
     c = j(1) | 0;
     j(0) | 0;
     m = f ? c : r;
     g = m & 1048575;
     c = g | 1072693248;
     m = (m >> 20) + (f ? -1076 : -1023) | 0;
     f = 0;
     n: {
      if (g >>> 0 < 235663) {
       break n;
      }
      if (g >>> 0 < 767610) {
       f = 1;
       break n;
      }
      c = g | 1071644672;
      m = m + 1 | 0;
     }
     g = ((f << 18) + (c >>> 1 | 0) | 0) + 537395200 | 0;
     f = f << 3;
     w = A[f + 3536 >> 3];
     o(+d);
     j(1) | 0;
     q = 0;
     l(0, j(0) | q);
     l(1, c | 0);
     k = +n();
     s = A[f + 3520 >> 3];
     h = k - s;
     u = 1 / (s + k);
     d = h * u;
     o(+d);
     c = j(1) | 0;
     j(0) | 0;
     l(0, 0);
     l(1, c | 0);
     a = +n();
     x = a;
     l(0, q | 0);
     l(1, g | 0);
     v = a * a;
     y = h;
     h = +n();
     k = u * (y - a * h - a * (k - (h - s)));
     h = k * (d + a);
     a = d * d;
     s = h + a * a * (a * (a * (a * (a * (a * .20697501780033842 + .23066074577556175) + .272728123808534) + .33333332981837743) + .4285714285785502) + .5999999999999946);
     o(+(v + 3 + s));
     c = j(1) | 0;
     j(0) | 0;
     l(0, 0);
     l(1, c | 0);
     a = +n();
     h = x * a;
     d = k * a + d * (s - (a + -3 - v));
     o(+(h + d));
     c = j(1) | 0;
     j(0) | 0;
     l(0, 0);
     l(1, c | 0);
     a = +n();
     d = w + (a * -7.028461650952758e-9 + (d - (a - h)) * .9617966939259756);
     h = d;
     k = A[f + 3552 >> 3];
     d = a * .9617967009544373;
     s = +(m | 0);
     o(+(k + (h + d) + s));
     c = j(1) | 0;
     j(0) | 0;
     l(0, 0);
     l(1, c | 0);
     a = +n();
     d = h - (a - s - k - d);
    }
    l(0, 0);
    l(1, e | 0);
    k = +n();
    d = (b - k) * a + d * b;
    b = a * k;
    a = d + b;
    o(+a);
    e = j(1) | 0;
    c = j(0) | 0;
    o: {
     if ((e | 0) >= 1083179008) {
      if (c | e - 1083179008) {
       break b;
      }
      if (!(d + 8008566259537294e-32 > a - b)) {
       break o;
      }
      break b;
     }
     if ((e & 2147482624) >>> 0 < 1083231232) {
      break o;
     }
     if (c | e + 1064252416) {
      break a;
     }
     if (!(d <= a - b)) {
      break o;
     }
     break a;
    }
    f = 0;
    g = e & 2147483647;
    if (g >>> 0 >= 1071644673) {
     c = e + (1048576 >>> (g >>> 20 | 0) - 1022 | 0) | 0;
     g = c >>> 20 & 2047;
     f = (c & 1048575 | 1048576) >>> 1043 - g | 0;
     f = (e | 0) < 0 ? 0 - f | 0 : f;
     l(0, 0);
     l(1, c & -1048576 >> g - 1023);
     b = b - +n();
     o(+(d + b));
     e = j(1) | 0;
     j(0) | 0;
    }
    l(0, 0);
    l(1, e | 0);
    a = +n();
    k = a * .6931471824645996;
    d = (d - (a - b)) * .6931471805599453 + a * -1.904654299957768e-9;
    a = k + d;
    b = a * a;
    b = a - b * (b * (b * (b * (b * 4.1381367970572385e-8 + -16533902205465252e-22) + 6613756321437934e-20) + -.0027777777777015593) + .16666666666666602);
    h = a * b / (b + -2);
    b = a;
    a = d - (a - k);
    a = b - (h - (b * a + a)) + 1;
    o(+a);
    e = j(1) | 0;
    c = j(0) | 0;
    e = (f << 20) + e | 0;
    p: {
     if ((e | 0) <= 1048575) {
      a = nk(a, f);
      break p;
     }
     l(0, c | 0);
     l(1, e | 0);
     a = +n();
    }
    i = i * a;
   }
   return i;
  }
  return i * 1e300 * 1e300;
 }
 return i * 1e-300 * 1e-300;
}

function Qz(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = +c;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0;
 e = eb - 160 | 0;
 eb = e;
 A[e + 152 >> 3] = c;
 f = v[b + 4 >> 2];
 a: {
  if (!f) {
   g = v[b >> 2];
   break a;
  }
  g = v[b >> 2];
  h = w[xl(g, f) | 0];
  if ((h | 0) == 33) {
   d = 1;
  } else {
   if ((h | 0) != 63) {
    break a;
   }
   d = 0;
  }
  Kl(e + 128 | 0, g, f, f - 1 | 0);
  f = v[e + 132 >> 2];
  g = v[e + 128 >> 2];
  v[b >> 2] = g;
  v[b + 4 >> 2] = f;
 }
 j = e + 128 | 0;
 he(j);
 h = v[e + 128 >> 2];
 i = e + 116 | 0;
 he(i);
 h = wl(h, v[e + 120 >> 2], b);
 he(j);
 b: {
  c: {
   d: {
    e: {
     if (v[e + 132 >> 2] == (h | 0)) {
      h = oc(e + 144 | 0, 22256);
      a = v[h + 4 >> 2];
      v[e + 8 >> 2] = v[h >> 2];
      v[e + 12 >> 2] = a;
      if (Hc(g, f, e + 8 | 0)) {
       b = cc(8);
       v[31601] = 0;
       N(1007, i | 0, e + 152 | 0);
       a = v[31601];
       v[31601] = 0;
       f: {
        g: {
         h: {
          if ((a | 0) != 1) {
           v[31601] = 0;
           R(1010, j | 0, 18235, i | 0);
           a = v[31601];
           v[31601] = 0;
           if ((a | 0) == 1) {
            break h;
           }
           rc(b, j);
           g = 0;
           v[31601] = 0;
           R(97, b | 0, 48396, 999);
           a = v[31601];
           v[31601] = 0;
           if ((a | 0) != 1) {
            break b;
           }
           f = M() | 0;
           sb(j);
           break g;
          }
          f = M() | 0;
          break f;
         }
         f = M() | 0;
         g = 1;
        }
        sb(e + 116 | 0);
        if (!g) {
         break c;
        }
       }
       jc(b);
       break c;
      }
      if (!d) {
       break e;
      }
      i = cc(8);
      d = v[b >> 2];
      a = v[b + 4 >> 2];
      v[31601] = 0;
      h = _h(e + 92 | 0, d, a);
      a = v[31601];
      v[31601] = 0;
      i: {
       j: {
        k: {
         l: {
          m: {
           n: {
            o: {
             p: {
              q: {
               if ((a | 0) != 1) {
                v[31601] = 0;
                b = e + 104 | 0;
                R(1010, b | 0, 18271, h | 0);
                a = v[31601];
                v[31601] = 0;
                if ((a | 0) == 1) {
                 break q;
                }
                v[31601] = 0;
                d = e + 116 | 0;
                N(1012, d | 0, b | 0);
                b = v[31601];
                v[31601] = 0;
                a = 1;
                if ((b | 0) == 1) {
                 break p;
                }
                v[31601] = 0;
                b = e + 80 | 0;
                N(1007, b | 0, e + 152 | 0);
                a = v[31601];
                v[31601] = 0;
                if ((a | 0) == 1) {
                 break o;
                }
                v[31601] = 0;
                g = e + 128 | 0;
                R(1014, g | 0, d | 0, b | 0);
                b = v[31601];
                v[31601] = 0;
                a = 1;
                if ((b | 0) == 1) {
                 break n;
                }
                rc(i, g);
                v[31601] = 0;
                R(97, i | 0, 48396, 999);
                a = v[31601];
                v[31601] = 0;
                if ((a | 0) != 1) {
                 break b;
                }
                f = M() | 0;
                sb(g);
                a = 0;
                break m;
               }
               f = M() | 0;
               break i;
              }
              f = M() | 0;
              a = 1;
              break j;
             }
             f = M() | 0;
             break k;
            }
            f = M() | 0;
            a = 1;
            break l;
           }
           f = M() | 0;
          }
          sb(e + 80 | 0);
         }
         sb(e + 116 | 0);
        }
        sb(e + 104 | 0);
       }
       sb(h);
       if (!a) {
        break c;
       }
      }
      jc(i);
      break c;
     }
     d = oc(e + 72 | 0, 22256);
     b = v[d + 4 >> 2];
     v[e + 40 >> 2] = v[d >> 2];
     v[e + 44 >> 2] = b;
     if (Hc(g, f, e + 40 | 0)) {
      h = cc(8);
      v[31601] = 0;
      b = e + 116 | 0;
      N(1007, b | 0, e + 152 | 0);
      a = v[31601];
      v[31601] = 0;
      r: {
       s: {
        t: {
         if ((a | 0) != 1) {
          v[31601] = 0;
          d = e + 128 | 0;
          R(1010, d | 0, 18235, b | 0);
          a = v[31601];
          v[31601] = 0;
          if ((a | 0) == 1) {
           break t;
          }
          rc(h, d);
          g = 0;
          v[31601] = 0;
          R(97, h | 0, 48396, 999);
          a = v[31601];
          v[31601] = 0;
          if ((a | 0) != 1) {
           break b;
          }
          f = M() | 0;
          sb(d);
          break s;
         }
         f = M() | 0;
         break r;
        }
        f = M() | 0;
        g = 1;
       }
       sb(e + 116 | 0);
       if (!g) {
        break c;
       }
      }
      jc(h);
      break c;
     }
     d = oc(e - -64 | 0, 7759);
     b = v[d + 4 >> 2];
     v[e + 32 >> 2] = v[d >> 2];
     v[e + 36 >> 2] = b;
     if (Hc(g, f, e + 32 | 0)) {
      if (!Hd(w[a + 28 | 0])) {
       break e;
      }
      if (c <= 0 | c > 4) {
       d = cc(8);
       v[31601] = 0;
       b = O(36, e + 128 | 0, 7854) | 0;
       a = v[31601];
       v[31601] = 0;
       if ((a | 0) == 1) {
        break d;
       }
       rc(d, b);
       v[31601] = 0;
       R(97, d | 0, 48396, 999);
       a = v[31601];
       v[31601] = 0;
       if ((a | 0) != 1) {
        break b;
       }
       f = M() | 0;
       sb(b);
       break c;
      }
      a = v[a + 24 >> 2];
      k = a, l = Te(65536 / c), v[k + 480244 >> 2] = l;
      Cq(a);
      break e;
     }
     d = oc(e + 56 | 0, 7811);
     b = v[d + 4 >> 2];
     v[e + 24 >> 2] = v[d >> 2];
     v[e + 28 >> 2] = b;
     if (Hc(g, f, e + 24 | 0)) {
      if (!Hd(w[a + 28 | 0])) {
       break e;
      }
      if (c <= 0 | c > 4) {
       d = cc(8);
       v[31601] = 0;
       b = O(36, e + 128 | 0, 7875) | 0;
       a = v[31601];
       v[31601] = 0;
       if ((a | 0) != 1) {
        rc(d, b);
        v[31601] = 0;
        R(97, d | 0, 48396, 999);
        a = v[31601];
        v[31601] = 0;
        if ((a | 0) != 1) {
         break b;
        }
        f = M() | 0;
        sb(b);
        break c;
       }
       f = M() | 0;
       jc(d);
       break c;
      }
      a = v[a + 24 >> 2];
      k = a, l = Te(c * 65536), v[k + 480240 >> 2] = l;
      Cq(a);
      break e;
     }
     d = oc(e + 48 | 0, 7829);
     b = v[d + 4 >> 2];
     v[e + 16 >> 2] = v[d >> 2];
     v[e + 20 >> 2] = b;
     if (!Hc(g, f, e + 16 | 0)) {
      break e;
     }
     k = v[a + 24 >> 2], l = Ri(c * 65536), v[k + 480236 >> 2] = l;
    }
    eb = e + 160 | 0;
    return;
   }
   f = M() | 0;
   jc(d);
  }
  P(f | 0);
 }
 p();
}

function tta(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0;
 f = eb - 128 | 0;
 eb = f;
 xc(b);
 a: {
  d = f - -64 | 0;
  if (!yr(b, d)) {
   break a;
  }
  if (!$_(d)) {
   break a;
  }
  if (!Lb(v[b >> 2], v[b + 8 >> 2], __(d))) {
   break a;
  }
  k = 1;
  if ((c | 0) == 64) {
   break a;
  }
  Cd(a, 1);
  v[a + 480208 >> 2] = v[a + 480208 >> 2] | 16777216;
  u[a + 480188 >> 1] = w[f + 109 | 0];
  u[a + 480190 >> 1] = w[f + 110 | 0];
  o = a, p = Ac((((w[f + 113 | 0] << 8 | 48) & 65328) >>> 0) / 100 | 0, 0), v[o + 480200 >> 2] = p;
  e = f + 52 | 0;
  oi(e, 3, f + 69 | 0);
  d = f + 16 | 0;
  Bc(d, e);
  yb(a + 1298308 | 0, d);
  sb(d);
  oi(e, 3, f + 89 | 0);
  Er(d, 4, e);
  yb(a + 1298320 | 0, d);
  e = a + 480280 | 0;
  sb(d);
  d = 0;
  while (1) if (x[a + 480188 >> 1] <= d >>> 0) {
   _j(Wb(v[a + 484360 >> 2], w[a + 484376 | 0]), b, w[f + 111 | 0], 65535, 65535);
   u[f + 50 >> 1] = 0;
   d = Wb(v[a + 484360 >> 2], w[a + 484376 | 0]);
   o = f, p = vb(v[d >> 2]), v[o + 16 >> 2] = p;
   d = vb(v[d + 4 >> 2]);
   while (1) {
    g = v[f + 16 >> 2];
    if (Hb(g, d)) {
     u[f + 52 >> 1] = x[g >> 1];
     o = f, p = x[qe(f + 52 | 0, f + 50 | 0) >> 1], u[o + 50 >> 1] = p;
     fe(f + 16 | 0);
     continue;
    } else {
     d = x[f + 50 >> 1] + 1 | 0;
     u[f + 50 >> 1] = d;
     k = Lb(v[b >> 2], v[b + 8 >> 2], B(B(x[a + 480188 >> 1], d & 65535), 264) + (x[a + 480190 >> 1] << 5) | 0);
     if (!k) {
      break a;
     }
     d = 0;
     while (1) {
      g = x[a + 480188 >> 1];
      if (g >>> 0 <= d >>> 0) {
       Ub(b, B(g, x[f + 50 >> 1] - 1 | 0) << 3);
       j = a + 946304 | 0;
       l = a + 484380 | 0;
       d = 1;
       while (1) {
        i = d & 65535;
        if (i >>> 0 > x[a + 480190 >> 1]) {
         j = a + 484344 | 0;
         Sf(j, x[f + 50 >> 1]);
         m = c & 1;
         g = 0;
         while (1) {
          b: {
           c: {
            if (x[f + 50 >> 1] <= g >>> 0) {
             if (!(c & 2)) {
              break c;
             }
             d = 1;
             while (1) {
              c = d & 65535;
              if (c >>> 0 > y[a + 480228 >> 2]) {
               break c;
              }
              c = B(c, 104) + l | 0;
              cg(Yc(f + 16 | 0, u[c + 34 >> 1] & 1 ? 16 : 8, 1, 0, 0), c, b);
              d = d + 1 | 0;
              continue;
             }
            }
            d: {
             if (m) {
              if (Og(j, g & 65535, 64)) {
               break d;
              }
             }
             Ub(b, x[a + 480188 >> 1] << 8);
             break b;
            }
            d = Vb(v[j >> 2], g);
            o = f, p = vb(v[d >> 2]), v[o + 16 >> 2] = p;
            n = vb(v[d + 4 >> 2]);
            while (1) {
             d = v[f + 16 >> 2];
             if (!Hb(d, n)) {
              break b;
             }
             e = f + 52 | 0;
             jm(e, b);
             e = w[wb(e, 1) | 0];
             if ((e - 1 & 255) >>> 0 <= 167) {
              t[d | 0] = ((e & 254) >>> 1 | 0) + 36;
             }
             h = f + 52 | 0;
             o = d, p = w[wb(h, 0) | 0], t[o + 1 | 0] = p;
             e = w[wb(h, 3) | 0];
             t[d + 5 | 0] = e;
             e: {
              f: {
               i = wb(h, 2);
               h = w[i | 0];
               if ((h | 0) != 19) {
                if ((h | 0) != 8) {
                 break f;
                }
                g: {
                 switch (e >>> 4 | 0) {
                 case 0:
                  t[d + 3 | 0] = 19;
                  t[d + 5 | 0] = e | 128;
                  break e;

                 case 1:
                  t[d + 3 | 0] = 11;
                  t[d + 5 | 0] = e << 4;
                  break e;

                 case 2:
                  t[d + 3 | 0] = 19;
                  t[d + 5 | 0] = e | 160;
                  break e;

                 case 3:
                 case 4:
                  break g;

                 default:
                  break e;
                 }
                }
                t[d + 3 | 0] = 19;
                t[d + 5 | 0] = e - 32;
                break e;
               }
               t[d + 3 | 0] = 9;
               i = e << 1 & 254;
               h = i + 128 | 0;
               h: {
                if (e >>> 0 <= 64) {
                 break h;
                }
                h = 384 - i | 0;
                if (e << 24 >> 24 >= 0) {
                 break h;
                }
                h = 128 - i | 0;
                if (e >>> 0 <= 191) {
                 break h;
                }
                h = i - 128 | 0;
               }
               o = d, p = ri(h), t[o + 5 | 0] = p;
               break e;
              }
              if ((h & 240) == 32) {
               t[d + 2 | 0] = 1;
               t[d + 3 | 0] = 10;
               t[d + 4 | 0] = (w[i | 0] << 2 & 60) + 4;
               break e;
              }
              if ((h - 17 & 255) >>> 0 > 1 & h >>> 0 >= 16) {
               break e;
              }
              Bf(d, h & 15, e);
             }
             sg(f + 16 | 0);
             continue;
            }
           }
           b = f + 16 | 0;
           c = tc(b, 9510);
           yb(a + 1298344 | 0, c);
           sb(c);
           c = tc(b, 10141);
           yb(a + 1298356 | 0, c);
           sb(c);
           o = a, p = v[Ec(b, 4) >> 2], v[o + 1298404 >> 2] = p;
           break a;
          }
          g = g + 1 | 0;
          continue;
         }
        } else {
         e = f + 16 | 0;
         xr(b, e);
         h = eb - 16 | 0;
         eb = h;
         t[h + 15 | 0] = 64;
         g = B(i, 104) + l | 0;
         o = g, p = w[Pb(e + 26 | 0, h + 15 | 0) | 0] << 2, u[o + 30 >> 1] = p;
         t[g + 37 | 0] = w[e + 25 | 0] << 4;
         v[g >> 2] = w[e + 23 | 0] | w[e + 24 | 0] << 8;
         v[g + 4 >> 2] = w[e + 27 | 0] | w[e + 28 | 0] << 8;
         v[g + 8 >> 2] = (w[e + 29 | 0] | w[e + 30 | 0] << 8) + (w[e + 27 | 0] | w[e + 28 | 0] << 8);
         u[g + 34 >> 1] = x[g + 34 >> 1] & 65532 | ((w[e + 29 | 0] | w[e + 30 | 0] << 8) >>> 0 > 2) << 1 | w[e + 22 | 0] == 16;
         eb = h + 16 | 0;
         g = f + 4 | 0;
         Pk(g, 3, e);
         e = f + 52 | 0;
         Bc(e, g);
         zc(j + (i << 5) | 0, e);
         d = d + 1 | 0;
         sb(e);
         continue;
        }
       }
      } else {
       g = f + 4 | 0;
       Z_(g, b);
       h = f + 52 | 0;
       tF(h, g);
       g = f + 16 | 0;
       Bc(g, h);
       em((e + (d << 5) | 0) + 9 | 0, g);
       d = d + 1 | 0;
       sb(g);
       continue;
      }
     }
    }
   }
  } else {
   g = e + (d << 5) | 0;
   Ve(g);
   o = g, p = B(Yd(b) & 15, 17), u[o + 4 >> 1] = p;
   d = d + 1 | 0;
   continue;
  }
 }
 eb = f + 128 | 0;
 return k | 0;
}

function Efa(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0;
 e = eb - 112 | 0;
 eb = e;
 g = v[b + 4 >> 2];
 h = w[b + 11 | 0];
 a: {
  if (zd(g, h)) {
   break a;
  }
  f = w[zz(b) | 0];
  if ((f | 0) == 33) {
   d = 1;
  } else {
   if ((f | 0) != 63) {
    break a;
   }
   d = 0;
  }
  f = e + 100 | 0;
  zx(f, b, 0, Zc(g, h) - 1 | 0);
  yb(b, f);
  sb(f);
 }
 f = e + 100 | 0;
 he(f);
 g = v[e + 100 >> 2];
 he(e + 88 | 0);
 g = TM(g, v[e + 92 >> 2], b);
 he(f);
 b: {
  c: {
   d: {
    e: {
     if ((g | 0) == v[e + 104 >> 2]) {
      if (Md(b, 22256)) {
       a = cc(8);
       v[31601] = 0;
       R(1001, f | 0, 18235, c | 0);
       b = v[31601];
       v[31601] = 0;
       if ((b | 0) == 1) {
        break d;
       }
       rc(a, f);
       v[31601] = 0;
       R(97, a | 0, 48396, 999);
       a = v[31601];
       v[31601] = 0;
       if ((a | 0) != 1) {
        break b;
       }
       b = M() | 0;
       sb(f);
       break c;
      }
      if (!d) {
       break e;
      }
      a = cc(8);
      v[31601] = 0;
      d = e + 76 | 0;
      R(1001, d | 0, 18271, b | 0);
      b = v[31601];
      v[31601] = 0;
      f: {
       g: {
        h: {
         i: {
          j: {
           if ((b | 0) != 1) {
            v[31601] = 0;
            b = e + 88 | 0;
            N(1012, b | 0, d | 0);
            d = v[31601];
            v[31601] = 0;
            if ((d | 0) == 1) {
             break j;
            }
            v[31601] = 0;
            f = e + 100 | 0;
            R(543, f | 0, b | 0, c | 0);
            b = v[31601];
            v[31601] = 0;
            d = 1;
            if ((b | 0) == 1) {
             break i;
            }
            rc(a, f);
            v[31601] = 0;
            R(97, a | 0, 48396, 999);
            b = v[31601];
            v[31601] = 0;
            if ((b | 0) != 1) {
             break b;
            }
            b = M() | 0;
            sb(f);
            d = 0;
            break h;
           }
           b = M() | 0;
           break f;
          }
          b = M() | 0;
          d = 1;
          break g;
         }
         b = M() | 0;
        }
        sb(e + 88 | 0);
       }
       sb(e + 76 | 0);
       if (!d) {
        break c;
       }
      }
      jc(a);
      break c;
     }
     k: {
      switch (v[g + 4 >> 2]) {
      case 0:
       ee(e + 68 | 0, b);
       b = eb - 176 | 0;
       eb = b;
       g = b + 12 | 0;
       Tf(g, c);
       v[31601] = 0;
       f = b + 24 | 0;
       N(124, f | 0, g | 0);
       c = v[31601];
       v[31601] = 0;
       l: {
        m: {
         n: {
          o: {
           p: {
            if ((c | 0) != 1) {
             v[31601] = 0;
             c = O(103, b + 36 | 0, f | 0) | 0;
             h = v[31601];
             v[31601] = 0;
             if ((h | 0) == 1) {
              break p;
             }
             sb(f);
             sb(g);
             g = v[v[c >> 2] - 12 >> 2];
             v[31601] = 0;
             h = ba(104) | 0;
             i = v[31601];
             v[31601] = 0;
             if ((i | 0) == 1) {
              break n;
             }
             v[31601] = 0;
             i = b + 8 | 0;
             R(105, i | 0, c + g | 0, h | 0);
             g = v[31601];
             v[31601] = 0;
             if ((g | 0) == 1) {
              break n;
             }
             Zb(i);
             v[31601] = 0;
             f = O(125, c | 0, f | 0) | 0;
             g = v[31601];
             v[31601] = 0;
             if ((g | 0) == 1) {
              break n;
             }
             c = mk(v[(f + v[v[f >> 2] - 12 >> 2] | 0) + 16 >> 2]);
             g = v[b + 24 >> 2];
             Ff(f);
             eb = b + 176 | 0;
             b = (c ^ -1) & (g | 0) != 0;
             break l;
            }
            a = M() | 0;
            break o;
           }
           a = M() | 0;
           sb(b + 24 | 0);
          }
          sb(b + 12 | 0);
          break m;
         }
         a = M() | 0;
         Ff(c);
        }
        P(a | 0);
        p();
       }
       c = v[e + 72 >> 2];
       v[e >> 2] = v[e + 68 >> 2];
       v[e + 4 >> 2] = c;
       Rz(a, e, b, d);
       break e;

      case 1:
       ee(e + 60 | 0, b);
       b = eb - 176 | 0;
       eb = b;
       g = b + 12 | 0;
       Tf(g, c);
       v[31601] = 0;
       f = b + 24 | 0;
       N(124, f | 0, g | 0);
       c = v[31601];
       v[31601] = 0;
       q: {
        r: {
         s: {
          t: {
           u: {
            if ((c | 0) != 1) {
             v[31601] = 0;
             c = O(103, b + 36 | 0, f | 0) | 0;
             h = v[31601];
             v[31601] = 0;
             if ((h | 0) == 1) {
              break u;
             }
             sb(f);
             sb(g);
             g = v[v[c >> 2] - 12 >> 2];
             v[31601] = 0;
             h = ba(104) | 0;
             i = v[31601];
             v[31601] = 0;
             if ((i | 0) == 1) {
              break s;
             }
             v[31601] = 0;
             i = b + 8 | 0;
             R(105, i | 0, c + g | 0, h | 0);
             g = v[31601];
             v[31601] = 0;
             if ((g | 0) == 1) {
              break s;
             }
             Zb(i);
             v[31601] = 0;
             v[b + 24 >> 2] = 0;
             v[b + 28 >> 2] = 0;
             f = O(1128, c | 0, f | 0) | 0;
             g = v[31601];
             v[31601] = 0;
             if ((g | 0) == 1) {
              break s;
             }
             c = mk(v[(f + v[v[f >> 2] - 12 >> 2] | 0) + 16 >> 2]);
             g = v[b + 24 >> 2];
             h = v[b + 28 >> 2];
             Ff(f);
             eb = b + 176 | 0;
             b = c ? 0 : g;
             c = c ? 0 : h;
             break q;
            }
            a = M() | 0;
            break t;
           }
           a = M() | 0;
           sb(b + 24 | 0);
          }
          sb(b + 12 | 0);
          break r;
         }
         a = M() | 0;
         Ff(c);
        }
        P(a | 0);
        p();
       }
       f = v[e + 64 >> 2];
       v[e + 8 >> 2] = v[e + 60 >> 2];
       v[e + 12 >> 2] = f;
       Pz(a, e + 8 | 0, b, c, d);
       break e;

      case 2:
       ee(e + 52 | 0, b);
       j = YZ(c);
       b = v[e + 56 >> 2];
       v[e + 16 >> 2] = v[e + 52 >> 2];
       v[e + 20 >> 2] = b;
       Qz(a, e + 16 | 0, j, d);
       break e;

      case 3:
       break k;

      default:
       break e;
      }
     }
     ee(e + 44 | 0, b);
     ee(e + 32 | 0, c);
     b = v[e + 48 >> 2];
     v[e + 24 >> 2] = v[e + 44 >> 2];
     v[e + 28 >> 2] = b;
     Oz(a, e + 24 | 0, v[e + 32 >> 2], v[e + 36 >> 2], d);
    }
    eb = e + 112 | 0;
    return;
   }
   b = M() | 0;
   jc(a);
  }
  P(b | 0);
 }
 p();
}

function tka(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, u = 0, y = 0, z = 0, A = 0, D = 0;
 k = eb - 32 | 0;
 eb = k;
 j = v[a + 4 >> 2];
 e = Se(v[a + 8 >> 2], b);
 r = v[e >> 2];
 a: {
  if (r + 1 >>> 0 < 2) {
   break a;
  }
  f = (j + B(b, 872) | 0) + 616 | 0;
  if (!(Li(v[f + 8 >> 2], v[f + 12 >> 2]) | w[e + 4 | 0]) | !v[f + 104 >> 2]) {
   break a;
  }
  i = v[f + 88 >> 2] & 2;
  e = v[(i ? 84 : 76) + f >> 2];
  p = v[f + 84 >> 2];
  g = v[f + 80 >> 2];
  s = Nb(v[a >> 2] + 1074312 | 0, 31);
  h = uf(v[f + 8 >> 2], v[f + 12 >> 2], c);
  l = w[f + 88 | 0] & 128;
  j = l ? 0 - h | 0 : h;
  n = gb;
  l = l ? 0 - (n + ((h | 0) != 0) | 0) | 0 : n;
  h = i;
  n = h ? 0 : 0;
  q = h ? g : 0;
  m = p - g | 0;
  u = m << 1;
  p = e;
  y = (w[f + 746 | 0] & 17) != 1;
  b: {
   c: {
    while (1) {
     if ((o | 0) != (r | 0)) {
      d: {
       if (d >>> 0 > o >>> 0) {
        g = (w[f + 746 | 0] & 17) == 1;
        break d;
       }
       v[v[a + 4 >> 2] + 16 >> 2] = o - d;
       t[f + 851 | 0] = w[f + 851 | 0] & 254 | (d | 0) == (o | 0);
       g = v[a >> 2];
       i = v[a + 4 >> 2];
       e = Vb(v[g + 484344 >> 2], x[i + 70 >> 1]);
       e = ld(v[e >> 2], v[v[e + 48 >> 2] + 12 >> 2], v[i + 48 >> 2], b);
       h = w[e + 3 | 0];
       e: {
        f: {
         switch (w[e + 2 | 0] - 11 | 0) {
         case 0:
          i = k + 8 | 0;
          yB(i, g, h, w[e + 4 | 0], 0);
          i = _e(i);
          Pu(v[a >> 2], v[a + 4 >> 2], b, x[k + 8 >> 1]);
          g = 1;
          if (!w[i | 0]) {
           break e;
          }
          break d;

         case 1:
          rB(g, i, b, w[e + 4 | 0] << 2 & 252, Nb(g + 1074312 | 0, 12));
          break e;

         case 2:
          break f;

         default:
          break e;
         }
        }
        qB(g, i, b, w[e + 4 | 0] << 2 & 252, Nb(g + 1074312 | 0, 12));
       }
       g = 1;
       g: {
        h: {
         i: {
          j: {
           k: {
            switch (h - 2 | 0) {
            default:
             if (h - 38 >>> 0 < 4) {
              break h;
             }
             if ((h | 0) == 19) {
              break j;
             }
             if ((h | 0) != 28) {
              break g;
             }
             e = w[e + 5 | 0];
             g = e & 240;
             if ((g | 0) == 32) {
              break i;
             }
             if ((g | 0) != 16) {
              break g;
             }
             pB(v[a >> 2], f, e & 15);
             break g;

            case 2:
             Pu(v[a >> 2], v[a + 4 >> 2], b, w[e + 5 | 0]);
             break g;

            case 4:
             Pu(v[a >> 2], v[a + 4 >> 2], b, 0);
             break g;

            case 0:
             e = w[e + 5 | 0];
             h = v[a >> 2];
             if (!e & (t[h + 480180 | 0] & 1)) {
              break d;
             }
             rB(h, v[a + 4 >> 2], b, e, 0);
             break g;

            case 1:
             break k;

            case 3:
             break d;
            }
           }
           e = w[e + 5 | 0];
           h = v[a >> 2];
           if (!e & (t[h + 480180 | 0] & 1)) {
            break d;
           }
           qB(h, v[a + 4 >> 2], b, e, 0);
           break g;
          }
          g = w[e + 5 | 0];
          e = g & 15;
          if (!(e | v[v[a >> 2] + 480180 >> 2] & 1048580)) {
           break g;
          }
          g = g & 240;
          if ((g | 0) != 32) {
           if ((g | 0) != 16) {
            break g;
           }
           oB(v[a >> 2], f, e);
           break g;
          }
          nB(v[a >> 2], f, e);
          break g;
         }
         mB(v[a >> 2], f, e & 15);
         break g;
        }
        _S(v[a >> 2], f, w[e + 5 | 0], (h | 0) == 38 | (h | 0) == 40, (h & 254) == 40);
       }
       g = 1;
      }
      v[k + 28 >> 2] = v[f + 700 >> 2];
      if (s) {
       Ou(v[a >> 2], f);
      }
      if (!y) {
       ZS(v[a >> 2], f, k + 28 | 0);
       g = 1;
      }
      if (!s) {
       Ou(v[a >> 2], f);
      }
      v[k + 24 >> 2] = 0;
      YS(f, k + 24 | 0);
      l: {
       if (w[f + 89 | 0] & 2) {
        break l;
       }
       m: {
        if (!g) {
         if (!w[Se(v[a + 8 >> 2], b) + 4 | 0]) {
          break m;
         }
        }
        if (w[f + 851 | 0] & 96) {
         eV(f, C(1), 0, v[a >> 2]);
         j = w[f + 851 | 0];
         t[f + 851 | 0] = (j & 64 ? -65 : -97) & j;
        }
        zB(k + 8 | 0, v[a >> 2], f, v[k + 28 >> 2], 0);
        e = v[k + 12 >> 2];
        j = v[k + 8 >> 2];
        v[f + 8 >> 2] = j;
        v[f + 12 >> 2] = e;
        A = Se(v[a + 8 >> 2], b), D = 0, t[A + 4 | 0] = D;
        e = uf(j, e, c);
        g = w[f + 88 | 0] & 128;
        j = g ? 0 - e | 0 : e;
        h = gb;
        l = g ? 0 - (h + ((e | 0) != 0) | 0) | 0 : h;
       }
       Ob(f, j, l);
       h = v[f >> 2];
       g = v[f + 4 >> 2];
       e = g;
       if ((h >>> 0 < z >>> 0 & (e | 0) <= (p | 0) | (e | 0) < (p | 0)) & ((e | 0) >= (q | 0) & h >>> 0 >= n >>> 0 | (e | 0) > (q | 0) | ((l | 0) > 0 | (l | 0) >= 0))) {
        break l;
       }
       e = v[f + 88 >> 2];
       if (!(e & 2)) {
        break c;
       }
       if (e & 4) {
        i = v[f + 80 >> 2];
        if (h >>> 0 < n >>> 0 & (g | 0) <= (q | 0) | (g | 0) < (q | 0)) {
         v[f + 88 >> 2] = e ^ 128;
         h = gh(0, i << 1, h, g);
         e = gb;
         g = e;
         v[f >> 2] = h;
         v[f + 4 >> 2] = e;
         e = j;
         j = 0 - e | 0;
         l = 0 - (((e | 0) != 0) + l | 0) | 0;
        }
        e = (g - i >>> 0) % (u - Nb(v[a >> 2] + 1074312 | 0, 33) >>> 0) | 0;
        n: {
         if (e >>> 0 < m >>> 0) {
          g = e + v[f + 80 >> 2] | 0;
          break n;
         }
         g = v[f + 84 >> 2] + (m - e | 0) | 0;
        }
        v[f + 4 >> 2] = g;
        g = v[f + 88 >> 2];
        if ((g & 128) >>> 7 ^ e >>> 0 < m >>> 0) {
         break l;
        }
        v[f + 88 >> 2] = g ^ 128;
        e = j;
        j = 0 - e | 0;
        l = 0 - (((e | 0) != 0) + l | 0) | 0;
        break l;
       }
       i = v[f + 84 >> 2];
       if (i + m >>> 0 <= g >>> 0) {
        g = i + ((g - i >>> 0) % (m >>> 0) | 0) | 0;
       }
       while (1) {
        e = g;
        g = e - m | 0;
        if (e >>> 0 >= i >>> 0) {
         continue;
        }
        break;
       }
       v[f >> 2] = h;
       v[f + 4 >> 2] = e;
      }
      o = o + 1 | 0;
      continue;
     }
     break;
    }
    v[v[a + 4 >> 2] + 16 >> 2] = 0;
    break b;
   }
   v[v[a + 4 >> 2] + 16 >> 2] = 0;
   gV(f);
   v[f + 708 >> 2] = 0;
  }
  A = Se(v[a + 8 >> 2], b), D = 0, v[A >> 2] = D;
 }
 eb = k + 32 | 0;
}

function lS(a, b) {
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, q = 0, r = 0, s = 0, t = 0, x = 0, y = 0, z = 0, B = 0, C = 0, E = 0;
 if (b) {
  j = a + 327720 | 0;
  c = eb - 352 | 0;
  eb = c;
  m = c + 340 | 0;
  rU(m, 8);
  v[31601] = 0;
  n = c + 328 | 0;
  ka(794, n | 0, 9);
  k = v[31601];
  v[31601] = 0;
  a: {
   b: {
    c: {
     d: {
      e: {
       f: {
        g: {
         h: {
          i: {
           j: {
            k: {
             l: {
              if ((k | 0) != 1) {
               v[31601] = 0;
               k = O(795, c + 312 | 0, 14) | 0;
               f = v[31601];
               v[31601] = 0;
               if ((f | 0) == 1) {
                break l;
               }
               v[31601] = 0;
               N(796, m | 0, k | 0);
               f = v[31601];
               v[31601] = 0;
               if ((f | 0) == 1) {
                break k;
               }
               v[31601] = 0;
               N(796, n | 0, k | 0);
               f = v[31601];
               v[31601] = 0;
               if ((f | 0) == 1) {
                break k;
               }
               g = c + 240 | 0;
               pU(g, 4900);
               l = c + 168 | 0;
               pU(l, 32e3);
               s = c + 96 | 0;
               iU(s, 8377175819504598e-21, 16754351639009197e-21, 8377175819504598e-21, -1.991112714669597, .9911462233728751);
               v[31601] = 0;
               i = O(797, c + 72 | 0, m | 0) | 0;
               f = v[31601];
               v[31601] = 0;
               if ((f | 0) == 1) {
                break j;
               }
               f = c + 84 | 0;
               bv(f, g, i);
               Be(i);
               v[31601] = 0;
               g = O(797, c + 48 | 0, n | 0) | 0;
               i = v[31601];
               v[31601] = 0;
               if ((i | 0) == 1) {
                break i;
               }
               i = c + 60 | 0;
               bv(i, l, g);
               Be(g);
               v[31601] = 0;
               g = O(797, c + 24 | 0, f | 0) | 0;
               l = v[31601];
               v[31601] = 0;
               if ((l | 0) == 1) {
                break h;
               }
               l = c + 36 | 0;
               bv(l, s, g);
               Be(g);
               v[31601] = 0;
               g = O(797, c | 0, i | 0) | 0;
               o = v[31601];
               v[31601] = 0;
               if ((o | 0) == 1) {
                break g;
               }
               o = c + 12 | 0;
               bv(o, s, g);
               Be(g);
               Oq(f);
               Oq(l);
               Oq(i);
               Oq(o);
               Oq(n);
               Nq(v[c + 84 >> 2], v[c + 88 >> 2], Mo(j, 0));
               Nq(v[c + 36 >> 2], v[c + 40 >> 2], Mo(j, 1));
               Nq(v[c + 60 >> 2], v[c + 64 >> 2], Mo(j, 2));
               Nq(v[c + 12 >> 2], v[c + 16 >> 2], Mo(j, 3));
               Nq(v[c + 328 >> 2], v[c + 332 >> 2], Mo(j, 4));
               Be(o);
               Be(l);
               Be(i);
               Be(f);
               jn(k);
               Be(n);
               Be(m);
               eb = c + 352 | 0;
               break a;
              }
              a = M() | 0;
              break b;
             }
             a = M() | 0;
             break c;
            }
            a = M() | 0;
            break d;
           }
           a = M() | 0;
           break d;
          }
          a = M() | 0;
          break e;
         }
         a = M() | 0;
         break f;
        }
        a = M() | 0;
        Be(c + 36 | 0);
       }
       Be(c + 60 | 0);
      }
      Be(c + 84 | 0);
     }
     jn(k);
    }
    Be(c + 328 | 0);
   }
   Be(c + 340 | 0);
   P(a | 0);
   p();
  }
  CA(a + 131112 | 0, 9.6377, .97);
  CA(a + 196648 | 0, 8.5, .5);
  CA(a + 262184 | 0, 7, .425);
 }
 c = a + 368680 | 0;
 if (!(B = 0, C = vR(c, a), E = b, E ? B : C)) {
  k = a + 24 | 0;
  y = A[a + 8 >> 3];
  m = w[a + 16 | 0];
  j = eb + -64 | 0;
  eb = j;
  m: while (1) {
   if ((r | 0) != 8193) {
    z = +(r - 4096 | 0) * .0001220703125;
    b = 0;
    t = 0;
    while (1) if ((b | 0) == 8) {
     d = 1 / t;
     f = r << 3;
     b = 0;
     while (1) if ((b | 0) == 8) {
      r = r + 1 | 0;
      continue m;
     } else {
      i = k + ((b | f) << 1) | 0;
      h = H(A[j + (b << 3) >> 3] * 32768 * d + .5);
      h = h < -32768 ? -32768 : h > 32768 ? 32768 : h;
      n: {
       if (D(h) < 2147483648) {
        g = ~~h;
        break n;
       }
       g = -2147483648;
      }
      u[i >> 1] = g;
      b = b + 1 | 0;
      continue;
     }
    } else {
     h = y;
     e = 1;
     d = +(b | 0) - z;
     x = d + -3.5;
     if (!(D(x) < 1e-8)) {
      o: {
       p: {
        switch (m | 0) {
        case 0:
         e = hf(d * .8975979010256552) * -.5 + .5;
         break o;

        case 1:
         e = hf(d * .8975979010256552) * -.46 + .54;
         break o;

        case 2:
         e = hf(d * 1.7951958020513104) * .08 + (hf(d * .8975979010256552) * -.5 + .42);
         break o;

        case 3:
         e = hf(d * 1.7951958020513104) * .05677 + (hf(d * .8975979010256552) * -.49364 + .44959);
         break o;

        case 4:
         e = hf(d * 1.7951958020513104) * .07922 + (hf(d * .8975979010256552) * -.49755 + .42323);
         break o;

        case 5:
         e = hf(d * 1.7951958020513104);
         q = hf(d * .8975979010256552);
         e = hf(d * 2.6927937030769655) * -.01168 + (e * .14128 + (q * -.48829 + .35875));
         break o;

        case 6:
         e = hf(d * 1.7951958020513104);
         q = hf(d * .8975979010256552);
         e = hf(d * 2.6927937030769655) * -.00183 + (e * .09392 + (q * -.49703 + .40217));
         break o;

        case 7:
         break p;

        default:
         break o;
        }
       }
       e = hf(d * 1.7951958020513104);
       q = hf(d * .8975979010256552);
       e = hf(d * 2.6927937030769655) * -.00122 + (e * .09831 + (q * -.49804 + .40243));
      }
      d = x * 3.141592653589793;
      h = Oi(d * h) / d;
     }
     h = e * h;
     A[j + (b << 3) >> 3] = h;
     t = t + h;
     b = b + 1 | 0;
     continue;
    }
   }
   break;
  }
  eb = j - -64 | 0;
  b = v[a + 20 >> 2];
  v[c + 16 >> 2] = v[a + 16 >> 2];
  v[c + 20 >> 2] = b;
  b = v[a + 12 >> 2];
  v[c + 8 >> 2] = v[a + 8 >> 2];
  v[c + 12 >> 2] = b;
  b = v[a + 4 >> 2];
  v[c >> 2] = v[a >> 2];
  v[c + 4 >> 2] = b;
 }
}

function Pz(a, b, c, d, e) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 var f = 0, g = 0, h = 0, i = 0, j = 0, k = 0;
 f = eb - 144 | 0;
 eb = f;
 v[f + 136 >> 2] = c;
 v[f + 140 >> 2] = d;
 g = v[b + 4 >> 2];
 a: {
  if (!g) {
   h = v[b >> 2];
   break a;
  }
  h = v[b >> 2];
  i = w[xl(h, g) | 0];
  if ((i | 0) == 33) {
   e = 1;
  } else {
   if ((i | 0) != 63) {
    break a;
   }
   e = 0;
  }
  Kl(f + 112 | 0, h, g, g - 1 | 0);
  g = v[f + 116 >> 2];
  h = v[f + 112 >> 2];
  v[b >> 2] = h;
  v[b + 4 >> 2] = g;
 }
 j = f + 112 | 0;
 he(j);
 i = v[f + 112 >> 2];
 k = f + 100 | 0;
 he(k);
 i = wl(i, v[f + 104 >> 2], b);
 he(j);
 b: {
  c: {
   d: {
    e: {
     f: {
      g: {
       h: {
        if (v[f + 116 >> 2] == (i | 0)) {
         c = oc(f + 128 | 0, 22256);
         a = v[c + 4 >> 2];
         v[f + 8 >> 2] = v[c >> 2];
         v[f + 12 >> 2] = a;
         if (Hc(h, g, f + 8 | 0)) {
          g = cc(8);
          v[31601] = 0;
          N(1005, k | 0, f + 136 | 0);
          a = v[31601];
          v[31601] = 0;
          if ((a | 0) == 1) {
           break g;
          }
          v[31601] = 0;
          R(1010, j | 0, 18235, k | 0);
          a = v[31601];
          v[31601] = 0;
          if ((a | 0) == 1) {
           break f;
          }
          rc(g, j);
          h = 0;
          v[31601] = 0;
          R(97, g | 0, 48396, 999);
          a = v[31601];
          v[31601] = 0;
          if ((a | 0) != 1) {
           break b;
          }
          b = M() | 0;
          sb(j);
          break e;
         }
         if (!e) {
          break h;
         }
         g = cc(8);
         c = v[b >> 2];
         a = v[b + 4 >> 2];
         v[31601] = 0;
         e = _h(f + 76 | 0, c, a);
         a = v[31601];
         v[31601] = 0;
         i: {
          j: {
           k: {
            l: {
             m: {
              n: {
               o: {
                p: {
                 if ((a | 0) != 1) {
                  v[31601] = 0;
                  b = f + 88 | 0;
                  R(1010, b | 0, 18271, e | 0);
                  a = v[31601];
                  v[31601] = 0;
                  if ((a | 0) == 1) {
                   break p;
                  }
                  v[31601] = 0;
                  c = f + 100 | 0;
                  N(1012, c | 0, b | 0);
                  b = v[31601];
                  v[31601] = 0;
                  a = 1;
                  if ((b | 0) == 1) {
                   break o;
                  }
                  v[31601] = 0;
                  b = f - -64 | 0;
                  N(1005, b | 0, f + 136 | 0);
                  a = v[31601];
                  v[31601] = 0;
                  if ((a | 0) == 1) {
                   break n;
                  }
                  v[31601] = 0;
                  d = f + 112 | 0;
                  R(1014, d | 0, c | 0, b | 0);
                  b = v[31601];
                  v[31601] = 0;
                  a = 1;
                  if ((b | 0) == 1) {
                   break m;
                  }
                  rc(g, d);
                  v[31601] = 0;
                  R(97, g | 0, 48396, 999);
                  a = v[31601];
                  v[31601] = 0;
                  if ((a | 0) != 1) {
                   break b;
                  }
                  b = M() | 0;
                  sb(d);
                  a = 0;
                  break l;
                 }
                 b = M() | 0;
                 break d;
                }
                b = M() | 0;
                a = 1;
                break i;
               }
               b = M() | 0;
               break j;
              }
              b = M() | 0;
              a = 1;
              break k;
             }
             b = M() | 0;
            }
            sb(f - -64 | 0);
           }
           sb(f + 100 | 0);
          }
          sb(f + 88 | 0);
         }
         sb(e);
         if (a) {
          break d;
         }
         break c;
        }
        e = oc(f + 56 | 0, 22256);
        b = v[e + 4 >> 2];
        v[f + 32 >> 2] = v[e >> 2];
        v[f + 36 >> 2] = b;
        if (Hc(h, g, f + 32 | 0)) {
         g = cc(8);
         v[31601] = 0;
         b = f + 100 | 0;
         N(1005, b | 0, f + 136 | 0);
         a = v[31601];
         v[31601] = 0;
         q: {
          r: {
           if ((a | 0) != 1) {
            v[31601] = 0;
            c = f + 112 | 0;
            R(1010, c | 0, 18235, b | 0);
            a = v[31601];
            v[31601] = 0;
            if ((a | 0) == 1) {
             break r;
            }
            rc(g, c);
            h = 0;
            v[31601] = 0;
            R(97, g | 0, 48396, 999);
            a = v[31601];
            v[31601] = 0;
            if ((a | 0) != 1) {
             break b;
            }
            b = M() | 0;
            sb(c);
            break q;
           }
           b = M() | 0;
           break d;
          }
          b = M() | 0;
          h = 1;
         }
         sb(f + 100 | 0);
         if (h) {
          break d;
         }
         break c;
        }
        e = oc(f + 48 | 0, 10974);
        b = v[e + 4 >> 2];
        v[f + 24 >> 2] = v[e >> 2];
        v[f + 28 >> 2] = b;
        if (Hc(h, g, f + 24 | 0)) {
         Mz(a, Fc(c, d));
         break h;
        }
        e = oc(f + 40 | 0, 8627);
        b = v[e + 4 >> 2];
        v[f + 16 >> 2] = v[e >> 2];
        v[f + 20 >> 2] = b;
        if (!Hc(h, g, f + 16 | 0)) {
         break h;
        }
        e = v[a + 32 >> 2];
        a = Uu(c, d);
        a = a >>> 0 >= 4 ? 1 : a;
        b = eb - 16 | 0;
        eb = b;
        s: {
         if ((rk(w[e + 140 | 0]) | 0) == (a | 0)) {
          a = e + 120 | 0;
          cu(w[a + 20 | 0]);
          c = eb - 16 | 0;
          eb = c;
          v[c + 12 >> 2] = b + 15;
          d = eb - 16 | 0;
          eb = d;
          v[d + 12 >> 2] = 1145;
          v[d + 8 >> 2] = 1146;
          v[d + 4 >> 2] = 1147;
          v[d >> 2] = 1148;
          hb[v[lq(d, rk(w[a + 20 | 0])) >> 2]](c + 12 | 0, a);
          eb = d + 16 | 0;
          eb = c + 16 | 0;
          break s;
         }
         QM(e, a, RM(e));
        }
        eb = b + 16 | 0;
       }
       eb = f + 144 | 0;
       return;
      }
      b = M() | 0;
      break d;
     }
     b = M() | 0;
     h = 1;
    }
    sb(f + 100 | 0);
    if (!h) {
     break c;
    }
   }
   jc(g);
  }
  P(b | 0);
 }
 p();
}

function qna(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0;
 f = eb - 48 | 0;
 eb = f;
 xc(b);
 o = Yd(b);
 h = 0;
 a: {
  if ((o - 5 & 255) >>> 0 < 253) {
   break a;
  }
  b: {
   if (!Lb(v[b >> 2], v[b + 8 >> 2], 4355)) {
    break b;
   }
   i = 1;
   while (1) {
    if ((i & 65535) >>> 0 <= 256) {
     l = f + 32 | 0;
     jE(b, l);
     if (!rV(l, o)) {
      break b;
     }
     d = e;
     e = 0;
     j = eb - 32 | 0;
     eb = j;
     m = w[l + 11 | 0];
     h = w[l + 9 | 0] | w[l + 10 | 0] << 8;
     t[j + 14 | 0] = 0;
     t[j + 26 | 0] = m;
     u[j + 24 >> 1] = h;
     u[j + 12 >> 1] = 0;
     while (1) {
      if ((e | 0) != 3) {
       h = wb(j + 24 | 0, e);
       q = wb(j + 12 | 0, e), r = w[h | 0], t[q | 0] = r;
       e = e + 1 | 0;
       continue;
      }
      break;
     }
     n = bg(j + 12 | 0);
     m = w[l + 8 | 0];
     h = w[l + 6 | 0] | w[l + 7 | 0] << 8;
     e = 0;
     t[j + 10 | 0] = 0;
     t[j + 18 | 0] = m;
     u[j + 16 >> 1] = h;
     u[j + 8 >> 1] = 0;
     while (1) {
      if ((e | 0) != 3) {
       h = wb(j + 16 | 0, e);
       q = wb(j + 8 | 0, e), r = w[h | 0], t[q | 0] = r;
       e = e + 1 | 0;
       continue;
      }
      break;
     }
     e = bg(j + 8 | 0);
     eb = j + 32 | 0;
     e = e >>> 0 < n >>> 0 ? i : d;
     i = i + 1 | 0;
     continue;
    }
    break;
   }
   if (!(e & 65535)) {
    break b;
   }
   h = 1;
   if ((c | 0) == 64) {
    break a;
   }
   Cd(a, 1);
   u[a + 480190 >> 1] = e;
   v[a + 480228 >> 2] = (o | 0) == 3 ? 192 : 48;
   v[a + 480208 >> 2] = v[a + 480208 >> 2] & -25165825 | 16777216;
   cd(b, 1);
   j = a + 946304 | 0;
   p = a + 484380 | 0;
   l = e + 1 | 0;
   n = l & 65535;
   i = 1;
   while (1) if ((i | 0) == (n | 0)) {
    cd(b, 4097);
    _j(Wb(v[a + 484360 >> 2], w[a + 484376 | 0]), b, 256, 255, 65535);
    d = Yd(b);
    if (d >>> 0 > 31) {
     break b;
    }
    u[a + 480188 >> 1] = d + 1 & 255;
    i = Yd(b);
    d = x[a + 480188 >> 1];
    j = i + 1 | 0;
    h = 0;
    if (!Lb(v[b >> 2], v[b + 8 >> 2], B(B(d, j), 384) + d | 0)) {
     break a;
    }
    e = a + 480280 | 0;
    i = 0;
    while (1) if (x[a + 480188 >> 1] <= i >>> 0) {
     n = a + 484344 | 0;
     Sf(n, j);
     m = c & 1;
     e = 0;
     while (1) {
      c: {
       if ((e | 0) != (j | 0)) {
        d: {
         if (m) {
          if (Og(n, e & 65535, 64)) {
           break d;
          }
         }
         Ub(b, B(x[a + 480188 >> 1], 384));
         break c;
        }
        h = Mg(f + 32 | 0);
        d = Vb(v[n >> 2], e);
        q = f, r = vb(v[d >> 2]), v[q + 16 >> 2] = r;
        i = vb(v[d + 4 >> 2]);
        while (1) {
         k = v[f + 16 >> 2];
         if (!Hb(k, i)) {
          break c;
         }
         d = f + 20 | 0;
         J_(d, b);
         d = w[wb(d, 0) | 0];
         if ((d - 1 & 255) >>> 0 <= 76) {
          t[k | 0] = d + 36;
         }
         d = f + 20 | 0;
         q = k, r = w[wb(d, 1) | 0], t[q + 1 | 0] = r;
         if (!qV(k, w[wb(d, 2) | 0], w[wb(d, 5) | 0], o)) {
          break b;
         }
         if (!qV(h, w[wb(d, 3) | 0], w[wb(d, 4) | 0], o)) {
          break b;
         }
         d = w[f + 35 | 0];
         if (d) {
          cm(f + 14 | 0, k, w[k + 3 | 0], w[k + 5 | 0], d, w[f + 37 | 0]);
         }
         sg(f + 16 | 0);
         continue;
        }
       }
       e: {
        if (!(c & 2)) {
         break e;
        }
        d = l & 65535;
        i = 1;
        while (1) {
         if ((d | 0) == (i | 0)) {
          break e;
         }
         c = p + B(i, 104) | 0;
         cg(Yc(f + 32 | 0, u[c + 34 >> 1] & 1 ? 16 : 8, 1, 0, 0), c, b);
         i = i + 1 | 0;
         continue;
        }
       }
       Yh(a + 1298344 | 0, 14170);
       Yh(a + 1298356 | 0, 11136);
       sf(a + 1298368 | 0);
       q = a, r = v[Ec(f + 32 | 0, 4) >> 2], v[q + 1298404 >> 2] = r;
       h = 1;
       break a;
      }
      e = e + 1 | 0;
      continue;
     }
    } else {
     d = e + (i << 5) | 0;
     Ve(d);
     q = d, r = B(Yd(b), 17), u[q + 4 >> 1] = r;
     i = i + 1 | 0;
     continue;
    }
   } else {
    jE(b, f + 32 | 0);
    e = 0;
    g = eb - 16 | 0;
    eb = g;
    k = p + B(i, 104) | 0;
    md(k, 1);
    h = w[f + 43 | 0];
    d = w[f + 41 | 0] | w[f + 42 | 0] << 8;
    t[g + 6 | 0] = 0;
    t[g + 10 | 0] = h;
    u[g + 8 >> 1] = d;
    u[g + 4 >> 1] = 0;
    while (1) {
     if ((e | 0) != 3) {
      d = wb(g + 8 | 0, e);
      q = wb(g + 4 | 0, e), r = w[d | 0], t[q | 0] = r;
      e = e + 1 | 0;
      continue;
     }
     break;
    }
    m = bg(g + 4 | 0);
    h = w[f + 40 | 0];
    d = w[f + 38 | 0] | w[f + 39 | 0] << 8;
    e = 0;
    t[g + 2 | 0] = 0;
    t[g + 10 | 0] = h;
    u[g + 8 >> 1] = d;
    u[g >> 1] = 0;
    while (1) {
     if ((e | 0) != 3) {
      d = wb(g + 8 | 0, e);
      q = wb(g, e), r = w[d | 0], t[q | 0] = r;
      e = e + 1 | 0;
      continue;
     }
     break;
    }
    q = k, r = m - bg(g) | 0, v[q >> 2] = r;
    h = w[f + 34 | 0];
    d = w[f + 32 | 0] | w[f + 33 | 0] << 8;
    e = 0;
    t[g + 6 | 0] = 0;
    t[g + 10 | 0] = h;
    u[g + 8 >> 1] = d;
    u[g + 4 >> 1] = 0;
    while (1) {
     if ((e | 0) != 3) {
      d = wb(g + 8 | 0, e);
      q = wb(g + 4 | 0, e), r = w[d | 0], t[q | 0] = r;
      e = e + 1 | 0;
      continue;
     }
     break;
    }
    q = k, r = bg(g + 4 | 0) + 1 | 0, v[q + 4 >> 2] = r;
    h = w[f + 37 | 0];
    d = w[f + 35 | 0] | w[f + 36 | 0] << 8;
    e = 0;
    t[g + 6 | 0] = 0;
    t[g + 10 | 0] = h;
    u[g + 8 >> 1] = d;
    u[g + 4 >> 1] = 0;
    while (1) {
     if ((e | 0) != 3) {
      d = wb(g + 8 | 0, e);
      q = wb(g + 4 | 0, e), r = w[d | 0], t[q | 0] = r;
      e = e + 1 | 0;
      continue;
     }
     break;
    }
    q = k, r = bg(g + 4 | 0) + 1 | 0, v[q + 8 >> 2] = r;
    e = w[f + 45 | 0];
    d = e >>> 2 | 0;
    d = x[k + 34 >> 1] & -7 | d & 2 | d & 4;
    u[k + 34 >> 1] = d;
    if (e & 4) {
     u[k + 34 >> 1] = d | 1;
     v[k >> 2] = v[k >> 2] >>> 1;
    }
    u[k + 30 >> 1] = w[f + 44 | 0];
    if ((o | 0) != 2) {
     v[k + 24 >> 2] = w[f + 46 | 0] | w[f + 47 | 0] << 8;
    }
    pV(k);
    eb = g + 16 | 0;
    d = Cc(f + 20 | 0, 22256);
    zc(j + (i << 5) | 0, d);
    sb(d);
    i = i + 1 | 0;
    continue;
   }
  }
  h = 0;
 }
 eb = f + 48 | 0;
 return h | 0;
}

function l_(a, b, c, d, e) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 var f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, q = 0;
 g = eb - 80 | 0;
 eb = g;
 a: {
  b: {
   c: {
    d: {
     e: {
      f: {
       g: {
        if (zd(v[b + 4 >> 2], w[b + 11 | 0])) {
         Eb(a);
         break g;
        }
        k = Mb(g + 68 | 0);
        v[g + 56 >> 2] = 0;
        v[g + 60 >> 2] = 0;
        h = v[c >> 2];
        v[31601] = 0;
        n = Q(38, h | 0) | 0;
        h = v[31601];
        v[31601] = 0;
        if ((h | 0) == 1) {
         break b;
        }
        h = Jb(b);
        i = Cb(v[b + 4 >> 2], w[b + 11 | 0]);
        j = Hk(n);
        f = eb - 16 | 0;
        eb = f;
        v[f + 12 >> 2] = j;
        v[f + 8 >> 2] = 0;
        j = v[Ye(f + 8 | 0, f + 12 | 0) >> 2];
        eb = f + 16 | 0;
        v[31601] = 0;
        N(39, k | 0, B(i, j + 1 | 0) | 0);
        f = v[31601];
        v[31601] = 0;
        if ((f | 0) == 1) {
         break c;
        }
        o = (i << 2) + h | 0;
        i = v[k >> 2];
        m = i + Sc(i, v[k + 4 >> 2]) | 0;
        q = (d | 0) != 2;
        h: {
         while (1) {
          i: {
           j: {
            k: {
             l: {
              if (!q) {
               while (1) {
                v[g + 48 >> 2] = 0;
                v[g + 52 >> 2] = 0;
                v[31601] = 0;
                f = h + 4 | 0;
                j = ya(40, n | 0, g + 56 | 0, h | 0, f | 0, g + 52 | 0, i | 0, m | 0, g + 48 | 0) | 0;
                l = v[31601];
                v[31601] = 0;
                if ((l | 0) == 1) {
                 break f;
                }
                if ((j | 0) != 1) {
                 break l;
                }
                if ((f | 0) != v[g + 52 >> 2]) {
                 l = 1;
                 break k;
                } else {
                 i = v[g + 48 >> 2];
                 h = f;
                 continue;
                }
               }
              }
              v[g + 48 >> 2] = 0;
              v[g + 52 >> 2] = 0;
              v[31601] = 0;
              j = ya(40, n | 0, g + 56 | 0, h | 0, o | 0, g + 52 | 0, i | 0, m | 0, g + 48 | 0) | 0;
              f = v[31601];
              v[31601] = 0;
              if ((f | 0) == 1) {
               break d;
              }
              l = 1;
              if ((j | 0) == 1) {
               break k;
              }
             }
             l = 2;
             f = v[g + 48 >> 2];
             if ((j | 0) != 2 | (m | 0) != (f | 0)) {
              break j;
             }
            }
            h = v[k + 4 >> 2];
            f = v[k >> 2];
            v[31601] = 0;
            N(39, k | 0, Sc(f, h) << 1);
            h = v[31601];
            v[31601] = 0;
            if ((h | 0) == 1) {
             break d;
            }
            h = v[k >> 2];
            f = v[g + 48 >> 2];
            i = h + (f - i | 0) | 0;
            m = Sc(h, v[k + 4 >> 2]) + h | 0;
            j = l;
            break i;
           }
           m: {
            n: {
             o: {
              p: {
               q: {
                switch (d | 0) {
                case 0:
                 if (v[g + 52 >> 2] != (h | 0) | (f | 0) != (i | 0) | (j | 0) != 2) {
                  break p;
                 }
                 v[31601] = 0;
                 t[g + 47 | 0] = 1;
                 h = O(41, g + 8 | 0, 22260) | 0;
                 f = v[31601];
                 v[31601] = 0;
                 r: {
                  s: {
                   t: {
                    if ((f | 0) != 1) {
                     v[31601] = 0;
                     f = g + 20 | 0;
                     R(42, f | 0, h | 0, b | 0);
                     i = v[31601];
                     v[31601] = 0;
                     if ((i | 0) == 1) {
                      break t;
                     }
                     v[31601] = 0;
                     i = g + 32 | 0;
                     $(43, i | 0, f | 0, c | 0, 1, g + 47 | 0);
                     l = v[31601];
                     v[31601] = 0;
                     if ((l | 0) == 1) {
                      break s;
                     }
                     sb(i);
                     Tb(f);
                     Tb(h);
                     if (w[g + 47 | 0]) {
                      break o;
                     }
                     v[31601] = 0;
                     $(43, a | 0, b | 0, c | 0, 2, 0);
                     a = v[31601];
                     v[31601] = 0;
                     if ((a | 0) != 1) {
                      break h;
                     }
                     f = M() | 0;
                     break a;
                    }
                    f = M() | 0;
                    break a;
                   }
                   f = M() | 0;
                   break r;
                  }
                  f = M() | 0;
                  Tb(g + 20 | 0);
                 }
                 Tb(h);
                 break a;

                case 1:
                 break q;

                default:
                 break p;
                }
               }
               t[e | 0] = (j | 0) != 2 | v[g + 52 >> 2] != (h | 0) | (f | 0) != (i | 0);
               Eb(a);
               break h;
              }
              if ((j | 0) == 2) {
               break n;
              }
              break m;
             }
             f = v[g + 48 >> 2];
            }
            v[g + 52 >> 2] = v[g + 52 >> 2] + 4;
            t[f | 0] = 63;
            f = v[g + 48 >> 2] + 1 | 0;
            v[g + 48 >> 2] = f;
           }
           i = f;
          }
          h = v[g + 52 >> 2];
          l = o >>> 0 > h >>> 0;
          if (l & f >>> 0 < m >>> 0 & (j | 0) == 2 | l & (d | 0) == 2) {
           continue;
          }
          break;
         }
         b = v[k >> 2];
         v[31601] = 0;
         T(44, a | 0, b | 0, f | 0) | 0;
         a = v[31601];
         v[31601] = 0;
         if ((a | 0) == 1) {
          break e;
         }
        }
        ec(k);
       }
       eb = g + 80 | 0;
       return;
      }
      f = M() | 0;
      break a;
     }
     f = M() | 0;
     break a;
    }
    f = M() | 0;
    break a;
   }
   f = M() | 0;
   break a;
  }
  f = M() | 0;
 }
 ec(k);
 P(f | 0);
 p();
}

function Lta(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, q = 0, r = 0, s = 0;
 e = eb - 720 | 0;
 eb = e;
 xc(b);
 f = eb - 16 | 0;
 eb = f;
 h = e + 110 | 0;
 H$(f + 8 | 0, h);
 g = v[f + 12 >> 2];
 ic(f, v[b >> 2], v[b + 8 >> 2], v[f + 8 >> 2], v[f + 12 >> 2]);
 i = v[f + 4 >> 2];
 if ((i | 0) == (g | 0)) {
  Ub(b, v[f + 12 >> 2]);
 }
 eb = f + 16 | 0;
 f = (g | 0) == (i | 0);
 if (!f) {
  G$(h);
 }
 a: {
  b: {
   c: {
    d: {
     if (!f) {
      break d;
     }
     if (!I$(h)) {
      break d;
     }
     d = 1;
     if ((c | 0) == 64) {
      break d;
     }
     Cd(a, 67108864);
     dg(a);
     d = w[e + 135 | 0];
     u[a + 480190 >> 1] = 31;
     u[a + 480188 >> 1] = d;
     v[a + 480228 >> 2] = 256 / (d >>> 0);
     d = tc(e, 8179);
     yb(a + 1298344 | 0, d);
     sb(d);
     d = tc(e, 10804);
     yb(a + 1298356 | 0, d);
     sb(d);
     f = e + 84 | 0;
     fg(f, 4174);
     h = w[e + 134 | 0];
     v[e + 64 >> 2] = h >>> 4;
     d = 0;
     v[31601] = 0;
     v[e + 104 >> 2] = h & 15;
     U(307, e | 0, f | 0, e - -64 | 0, e + 104 | 0);
     h = v[31601];
     v[31601] = 0;
     if ((h | 0) == 1) {
      break c;
     }
     yb(a + 1298368 | 0, e);
     sb(e);
     Db(f);
     r = a, s = v[Ec(e, 28) >> 2], v[r + 1298404 >> 2] = s;
     ow(Wb(v[a + 484360 >> 2], w[a + 484376 | 0]), e + 158 | 0, w[e + 157 | 0] + 1 | 0);
     n = a + 484380 | 0;
     m = e + 689 | 0;
     k = e + 658 | 0;
     j = e + 534 | 0;
     l = e + 410 | 0;
     o = e + 286 | 0;
     while (1) {
      e: {
       if ((d | 0) == 31) {
        xE(b, a + 1298308 | 0, 32);
        f = a + 946304 | 0;
        d = 1;
        break e;
       }
       f = d + 1 | 0;
       h = B(f, 104) + n | 0;
       md(h, 1);
       i = d << 2;
       g = i + o | 0;
       r = h, s = _b(w[g | 0] | w[g + 1 | 0] << 8 | (w[g + 2 | 0] << 16 | w[g + 3 | 0] << 24)), 
       v[r >> 2] = s;
       g = i + l | 0;
       g = _b(w[g | 0] | w[g + 1 | 0] << 8 | (w[g + 2 | 0] << 16 | w[g + 3 | 0] << 24));
       v[h + 4 >> 2] = g;
       q = g;
       g = j + i | 0;
       g = _b(w[g | 0] | w[g + 1 | 0] << 8 | (w[g + 2 | 0] << 16 | w[g + 3 | 0] << 24));
       v[h + 8 >> 2] = q + g;
       if (g) {
        u[h + 34 >> 1] = x[h + 34 >> 1] | 2;
       }
       Sk(h);
       t[e | 0] = w[d + k | 0];
       t[e + 84 | 0] = 64;
       r = h, s = w[Pb(e, e + 84 | 0) | 0] << 2, u[r + 30 >> 1] = s;
       t[h + 37 | 0] = w[d + m | 0] << 4;
       d = f;
       continue;
      }
      break;
     }
     while (1) {
      if ((d | 0) != 32) {
       F$(b, f + (d << 5) | 0, 30);
       d = d + 1 | 0;
       continue;
      }
      break;
     }
     m = c & 1;
     if (m) {
      Sf(a + 484344 | 0, w[e + 156 | 0] + 1 | 0);
     }
     i = a + 484344 | 0;
     h = 0;
     f: {
      while (1) {
       if (w[e + 156 | 0] < h >>> 0) {
        d = 1;
        if (!(c & 2)) {
         break d;
        }
        a = Yc(e, 8, 1, 1, 0);
        break f;
       }
       g = Xh(e + 84 | 0);
       g: {
        h: {
         if (w[e + 136 | 0]) {
          v[31601] = 0;
          f = Q(273, b | 0) | 0;
          d = v[31601];
          v[31601] = 0;
          if ((d | 0) == 1) {
           break g;
          }
          v[31601] = 0;
          d = e - -64 | 0;
          R(185, d | 0, b | 0, f | 0);
          f = v[31601];
          v[31601] = 0;
          if ((f | 0) == 1) {
           break g;
          }
          break h;
         }
         f = x[a + 480188 >> 1];
         v[31601] = 0;
         d = e - -64 | 0;
         R(185, d | 0, b | 0, f << 8);
         f = v[31601];
         v[31601] = 0;
         if ((f | 0) == 1) {
          break b;
         }
        }
        f = gc(e, d);
        jd(g, f);
        tb(f);
        tb(d);
        i: {
         if (!m) {
          break i;
         }
         v[31601] = 0;
         d = T(196, i | 0, h & 65535, 64) | 0;
         f = v[31601];
         v[31601] = 0;
         if ((f | 0) == 1) {
          break b;
         }
         if (!d) {
          break i;
         }
         f = 0;
         if (w[e + 136 | 0]) {
          v[31601] = 0;
          N(308, g | 0, e | 0);
          d = v[31601];
          v[31601] = 0;
          if ((d | 0) == 1) {
           break b;
          }
          j: while (1) {
           if ((f | 0) == 64) {
            break i;
           }
           d = Vb(v[i >> 2], h);
           af(e - -64 | 0, v[d >> 2], v[v[d + 48 >> 2] + 12 >> 2], f);
           r = e, s = vb(v[e + 64 >> 2]), v[r + 104 >> 2] = s;
           k = e + f | 0;
           d = 128;
           j = nw(v[e + 64 >> 2], v[e + 68 >> 2]);
           while (1) {
            l = v[e + 104 >> 2];
            if (!Hb(l, j)) {
             f = f + 1 | 0;
             continue j;
            }
            k: {
             if (!(w[k | 0] & d)) {
              break k;
             }
             v[31601] = 0;
             N(309, g | 0, l | 0);
             l = v[31601];
             v[31601] = 0;
             if ((l | 0) != 1) {
              break k;
             }
             break b;
            }
            d = d >>> 1 | 0;
            sg(e + 104 | 0);
            continue;
           }
          }
         }
         l: while (1) {
          d = 0;
          k = f & 65535;
          if (k >>> 0 >= x[a + 480188 >> 1]) {
           break i;
          }
          while (1) {
           if ((d | 0) == 64) {
            f = f + 1 | 0;
            continue l;
           }
           j = Vb(v[i >> 2], h);
           j = ld(v[j >> 2], v[v[j + 48 >> 2] + 12 >> 2], d, k);
           v[31601] = 0;
           N(309, g | 0, j | 0);
           j = v[31601];
           v[31601] = 0;
           if ((j | 0) != 1) {
            d = d + 1 | 0;
            continue;
           }
           break;
          }
          break;
         }
         break b;
        }
        tb(g);
        h = h + 1 | 0;
        continue;
       }
       break;
      }
      break b;
     }
     while (1) {
      if ((d | 0) != 32) {
       cg(a, B(d, 104) + n | 0, b);
       d = d + 1 | 0;
       continue;
      }
      break;
     }
     d = 1;
    }
    eb = e + 720 | 0;
    return d | 0;
   }
   d = M() | 0;
   Db(e + 84 | 0);
   break a;
  }
  d = M() | 0;
  tb(g);
 }
 P(d | 0);
 p();
}

function Paa(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
 d = eb - 144 | 0;
 eb = d;
 i = JM(d + 128 | 0);
 v[i >> 2] = 48604;
 Mb(i + 4 | 0);
 uo(v[a + 24 >> 2], i);
 e = v[a + 24 >> 2];
 f = w[a + 62 | 0];
 g = w[a + 61 | 0];
 h = w[a + 60 | 0];
 b = Ge(d + 108 | 0, b);
 v[31601] = 0;
 k = v[b + 12 >> 2];
 v[d + 8 >> 2] = v[b + 8 >> 2];
 v[d + 12 >> 2] = k;
 v[d + 16 >> 2] = v[b + 16 >> 2];
 k = v[b + 4 >> 2];
 v[d >> 2] = v[b >> 2];
 v[d + 4 >> 2] = k;
 b = h ? 13 : 15;
 b = g ? b & 14 : b;
 b = T(1154, e | 0, d | 0, (f ? b & 3 : b) | 0) | 0;
 e = v[31601];
 v[31601] = 0;
 a: {
  b: {
   c: {
    d: {
     e: {
      if ((e | 0) == 1) {
       break e;
      }
      if (!b) {
       b = cc(8);
       v[31601] = 0;
       c = O(36, d + 96 | 0, 12010) | 0;
       a = v[31601];
       v[31601] = 0;
       if ((a | 0) != 1) {
        rc(b, c);
        v[31601] = 0;
        R(97, b | 0, 48396, 999);
        a = v[31601];
        v[31601] = 0;
        if ((a | 0) != 1) {
         break a;
        }
        a = M() | 0;
        sb(c);
        break b;
       }
       a = M() | 0;
       jc(b);
       break b;
      }
      if (!w[a + 63 | 0]) {
       v[31601] = 0;
       N(1155, a | 0, a + 36 | 0);
       b = v[31601];
       v[31601] = 0;
       if ((b | 0) == 1) {
        break e;
       }
      }
      t[a + 28 | 0] = 1;
      uo(v[a + 24 >> 2], v[a + 4 >> 2]);
      v[31601] = 0;
      N(1156, d + 96 | 0, i | 0);
      b = v[31601];
      v[31601] = 0;
      if ((b | 0) == 1) {
       break c;
      }
      m = d, n = vb(v[d + 96 >> 2]), v[m + 92 >> 2] = n;
      k = a + 68 | 0;
      l = vb(v[d + 100 >> 2]);
      f: {
       g: {
        h: {
         i: {
          j: {
           k: {
            l: {
             m: {
              n: {
               o: {
                p: {
                 q: {
                  r: {
                   while (1) {
                    b = v[d + 92 >> 2];
                    if (!Hb(b, l)) {
                     b = Si(v[c >> 2]);
                     v[d + 80 >> 2] = b;
                     c = Of(c);
                     while (1) {
                      if (!Yg(b, c)) {
                       break d;
                      }
                      v[31601] = 0;
                      e = td(b);
                      b = O(71, d + 20 | 0, e | 0) | 0;
                      f = v[31601];
                      v[31601] = 0;
                      if ((f | 0) == 1) {
                       break h;
                      }
                      v[31601] = 0;
                      U(1011, a | 0, b | 0, e + 12 | 0, 0);
                      e = v[31601];
                      v[31601] = 0;
                      if ((e | 0) == 1) {
                       break g;
                      }
                      sb(b);
                      b = v[$g(d + 80 | 0) >> 2];
                      continue;
                     }
                    }
                    e = v[a + 24 >> 2];
                    f = v[b >> 2];
                    v[31601] = 0;
                    j = b + 4 | 0;
                    R(1157, e | 0, f | 0, j | 0);
                    e = v[31601];
                    v[31601] = 0;
                    if ((e | 0) != 1) {
                     b = v[b >> 2];
                     v[31601] = 0;
                     e = d + 44 | 0;
                     N(1158, e | 0, b | 0);
                     b = v[31601];
                     v[31601] = 0;
                     if ((b | 0) == 1) {
                      break r;
                     }
                     v[31601] = 0;
                     f = d + 56 | 0;
                     N(1058, f | 0, e | 0);
                     b = v[31601];
                     v[31601] = 0;
                     if ((b | 0) == 1) {
                      break q;
                     }
                     v[31601] = 0;
                     b = O(36, d + 32 | 0, 18371) | 0;
                     g = v[31601];
                     v[31601] = 0;
                     if ((g | 0) == 1) {
                      break p;
                     }
                     v[31601] = 0;
                     g = d + 68 | 0;
                     R(1014, g | 0, f | 0, b | 0);
                     h = v[31601];
                     v[31601] = 0;
                     if ((h | 0) == 1) {
                      break o;
                     }
                     v[31601] = 0;
                     h = d + 80 | 0;
                     R(543, h | 0, g | 0, j | 0);
                     j = v[31601];
                     v[31601] = 0;
                     if ((j | 0) == 1) {
                      break n;
                     }
                     v[31601] = 0;
                     N(178, k | 0, h | 0);
                     j = v[31601];
                     v[31601] = 0;
                     if ((j | 0) == 1) {
                      break m;
                     }
                     sb(h);
                     sb(g);
                     sb(b);
                     sb(f);
                     sb(e);
                     Uo(d + 92 | 0);
                     continue;
                    }
                    break;
                   }
                   a = M() | 0;
                   break f;
                  }
                  a = M() | 0;
                  break f;
                 }
                 a = M() | 0;
                 break i;
                }
                a = M() | 0;
                break j;
               }
               a = M() | 0;
               break k;
              }
              a = M() | 0;
              break l;
             }
             a = M() | 0;
             sb(d + 80 | 0);
            }
            sb(d + 68 | 0);
           }
           sb(b);
          }
          sb(d + 56 | 0);
         }
         sb(d + 44 | 0);
         break f;
        }
        a = M() | 0;
        break f;
       }
       a = M() | 0;
       sb(b);
      }
      wz(d + 96 | 0);
      break b;
     }
     a = M() | 0;
     break b;
    }
    wz(d + 96 | 0);
    au(i);
    eb = d + 144 | 0;
    return;
   }
   a = M() | 0;
  }
  au(i);
  P(a | 0);
 }
 p();
}

function bB(a, b, c, d) {
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0;
 g = eb - 16 | 0;
 eb = g;
 e = B(b, 872) + a | 0;
 i = w[e + 1075800 | 0];
 k = a + 1074312 | 0;
 Ib(g + 8 | 0, k, 23);
 h = c & 15;
 e = e + 1074992 | 0;
 a: {
  b: {
   c: {
    d: {
     e: {
      f: {
       g: {
        h: {
         i: {
          if (Fb(v[v[g + 8 >> 2] >> 2], v[g + 12 >> 2])) {
           if (!(v[a + 1074392 >> 2] | !w[e + 788 | 0])) {
            t[e + 808 | 0] = h;
            break i;
           }
           f = w[e + 808 | 0];
           if (f) {
            j = f - 1 | 0;
            t[e + 808 | 0] = j;
            f = 0;
            if (j & 255) {
             break c;
            }
           }
           t[e + 808 | 0] = h;
           f = 1;
           break c;
          }
          Ib(g + 8 | 0, k, 52);
          j = c & 256;
          if (!(!j | !Fb(v[v[g + 8 >> 2] >> 2], v[g + 12 >> 2]))) {
           j = v[a + 480208 >> 2] & 4096;
           if (!j) {
            break e;
           }
           if (w[e + 789 | 0]) {
            i = IZ(w[e + 788 | 0]) ? 1 : i;
           }
           if (w[e + 792 | 0] ? w[e + 790 | 0] == 1 : 0) {
            break b;
           }
           if (h >>> 0 > i >>> 0) {
            break c;
           }
           if (!j) {
            break d;
           }
           if (Tc(w[e + 788 | 0])) {
            break c;
           }
           break d;
          }
          l = v[a + 480180 >> 2];
          if (l & 16777250) {
           if (i) {
            f = (i >>> 0) % ((h >>> 0 <= 1 ? 1 : h) >>> 0) | 0;
           } else {
            f = 1;
           }
           f = !f;
           i = i + 1 | 0;
           break c;
          }
          if ((l | 0) == 16) {
           break g;
          }
          if ((l | 0) != 1) {
           break f;
          }
          f = y[a + 1074392 >> 2] % y[a + 1074416 >> 2] | 0;
          if (!f) {
           if (Tc(w[e + 788 | 0])) {
            break a;
           }
          }
          if (h) {
           break h;
          }
         }
         f = 0;
         break c;
        }
        f = !((f >>> 0) % (h >>> 0) | 0);
        break c;
       }
       f = v[a + 1074392 >> 2] == (h | 0) & (h | 0) != 0;
       break c;
      }
      h = !j | w[e + 790 | 0] != 1 ? h : (w[e + 793 | 0] > 15) + h | 0;
      j: {
       if (v[a + 480208 >> 2] & 4096 ? j : 1) {
        h = h >>> 0 <= 1 ? 1 : h;
        if (!(!v[a + 1074416 >> 2] | j)) {
         f = !(y[a + 1074392 >> 2] % (h >>> 0) | 0);
        }
        i = i + 1 | 0;
        break j;
       }
       i = l & 1048580 ? 0 : i;
      }
      if (!(!(w[e + 788 | 0] | !j ? v[a + 1074392 >> 2] : 1) | (i & 255) >>> 0 < h >>> 0)) {
       f = 1;
      }
      Ib(g + 8 | 0, k, 52);
      if (!Fb(v[v[g + 8 >> 2] >> 2], v[g + 12 >> 2]) | c) {
       break c;
      }
      f = !v[a + 1074392 >> 2];
      break c;
     }
     if (h >>> 0 > i >>> 0) {
      break c;
     }
    }
    i = 0;
    f = 1;
   }
   k: {
    if (v[e + 76 >> 2]) {
     break k;
    }
    Ib(g + 8 | 0, k, 38);
    if (!Fb(v[v[g + 8 >> 2] >> 2], v[g + 12 >> 2])) {
     break k;
    }
    if (!Aj(v[e + 656 >> 2])) {
     break a;
    }
   }
   Ib(g + 8 | 0, k, 106);
   if (p = 0, q = Fb(v[v[g + 8 >> 2] >> 2], v[g + 12 >> 2]), r = v[e + 696 >> 2], r ? p : q) {
    break a;
   }
   if (f) {
    h = v[e + 688 >> 2];
    v[g + 4 >> 2] = h;
    f = c >>> 4 & 15;
    l: {
     if (!f) {
      f = v[e + 88 >> 2];
      break l;
     }
     Ib(g + 8 | 0, k, 52);
     m: {
      if (p = Fb(v[v[g + 8 >> 2] >> 2], v[g + 12 >> 2]), q = 0, r = w[e + 790 | 0] == 1, 
      r ? p : q) {
       break m;
      }
      if (!(16191 >>> f & 1)) {
       v[g + 4 >> 2] = (B(h, t[f + 32032 | 0]) | 0) / 16;
       break m;
      }
      v[g + 4 >> 2] = h + (t[f + 32048 | 0] << 2);
     }
     Fe(g + 4 | 0, 0, 256);
     f = v[e + 88 >> 2] | 2097152;
     v[e + 88 >> 2] = f;
    }
    n = v[e + 700 >> 2];
    h = w[e + 802 | 0];
    j = 0;
    if (f & 512) {
     Ib(g + 8 | 0, k, 108);
     j = Fb(v[v[g + 8 >> 2] >> 2], v[g + 12 >> 2]);
    }
    if (!((j ^ -1) & v[a + 480180 >> 2] == 2 | (!v[e + 76 >> 2] | (h - 1 & 255) >>> 0 > 119))) {
     FS(a, b, 0, h, 1);
    }
    n: {
     if (!(v[a + 480180 >> 2] & 1048580)) {
      l = 0;
      break n;
     }
     l = (c | 0) < 256;
     if ((c | 0) > 255) {
      break n;
     }
     f = w[e + 789 | 0];
     if (!f) {
      break n;
     }
     l = 1;
     Ko(a, e, f, 0, 0, 1);
    }
    Ib(g + 8 | 0, k, 85);
    o: {
     if (!Fb(v[v[g + 8 >> 2] >> 2], v[g + 12 >> 2])) {
      break o;
     }
     f = w[e + 789 | 0];
     if (!f) {
      break o;
     }
     m = x[e + 772 >> 1];
     Ko(a, e, f, 0, 0, 1);
     u[e + 772 >> 1] = m;
    }
    m = v[e + 660 >> 2];
    v[e + 660 >> 2] = 0;
    o = v[e + 88 >> 2];
    Ib(g + 8 | 0, k, 23);
    f = 1;
    p: {
     if (Fb(v[v[g + 8 >> 2] >> 2], v[g + 12 >> 2])) {
      break p;
     }
     f = 0;
     if (v[a + 480180 >> 2] != 2) {
      break p;
     }
     f = (j ^ 1) & v[e + 76 >> 2] != 0;
    }
    Tu(a, e, h, f, l, 0, b);
    if (!w[e + 789 | 0]) {
     v[e + 660 >> 2] = m;
    }
    if (!(!(o & 4096) | v[a + 480180 >> 2] != 4)) {
     v[e + 88 >> 2] = v[e + 88 >> 2] | 4096;
    }
    v[e + 688 >> 2] = v[g + 4 >> 2];
    if (x[a + 480192 >> 1]) {
     t[e + 788 | 0] = h;
     DS(a, b);
    }
    b = v[a + 480180 >> 2];
    if (!(!(b & 16777248) | (w[e + 788 | 0] | !n))) {
     v[e + 700 >> 2] = n;
    }
    if (f) {
     v[e >> 2] = 0;
     v[e + 4 >> 2] = 0;
    }
    b = b & 16777250;
    q: {
     if (d - 11 >>> 0 < 4294967286) {
      break q;
     }
     f = v[e + 104 >> 2];
     if (!f) {
      break q;
     }
     r: {
      if ((d | 0) == 1) {
       h = v[e + 664 >> 2];
       break r;
      }
      h = v[xb(f + 68 | 0, d - 2 | 0) >> 2];
      v[e + 664 >> 2] = h;
     }
     Jo(a, e, h);
    }
    i = b ? i : 0;
   }
   a = g + 8 | 0;
   Ib(a, k, 52);
   b = v[v[g + 8 >> 2] >> 2];
   d = v[g + 12 >> 2];
   Ib(a, k, 23);
   if (Fb(v[v[g + 8 >> 2] >> 2], v[g + 12 >> 2])) {
    break a;
   }
   i = (Fb(b, d) & c >>> 8) + i | 0;
  }
  t[e + 808 | 0] = i;
 }
 eb = g + 16 | 0;
}

function hn(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0;
 e = eb + -64 | 0;
 eb = e;
 h = Mb(a);
 v[31601] = 0;
 a = Q(281, b | 0) | 0;
 d = v[31601];
 v[31601] = 0;
 a: {
  b: {
   c: {
    d: {
     e: {
      if ((d | 0) == 1) {
       break e;
      }
      d = v[b + 8 >> 2];
      c = v[b >> 2];
      v[31601] = 0;
      d = T(150, c | 0, d | 0, a | 0) | 0;
      c = v[31601];
      v[31601] = 0;
      if ((c | 0) == 1) {
       break e;
      }
      if (d) {
       break d;
      }
      v[31601] = 0;
      a = Q(202, b | 0) | 0;
      d = v[31601];
      v[31601] = 0;
      if ((d | 0) == 1) {
       break e;
      }
      v[31601] = 0;
      O(183, b | 0, a | 0) | 0;
      a = v[31601];
      v[31601] = 0;
      if ((a | 0) != 1) {
       break c;
      }
     }
     a = M() | 0;
     break a;
    }
    v[31601] = 0;
    c = e + 24 | 0;
    R(185, c | 0, b | 0, a | 0);
    b = v[31601];
    v[31601] = 0;
    f: {
     g: {
      h: {
       if ((b | 0) != 1) {
        d = gc(e + 44 | 0, c);
        tb(c);
        if (a >>> 0 < 10) {
         break g;
        }
        v[31601] = 0;
        b = Q(735, d | 0) | 0;
        c = v[31601];
        v[31601] = 0;
        if ((c | 0) == 1) {
         break b;
        }
        if (!b) {
         break g;
        }
        v[31601] = 0;
        b = Q(281, d | 0) | 0;
        c = v[31601];
        v[31601] = 0;
        if ((c | 0) == 1) {
         break b;
        }
        v[e + 20 >> 2] = b;
        a = a - 10 | 0;
        wc(e + 20 | 0, a >>> 0 > 25264513 ? -1 : B(a, 170));
        v[31601] = 0;
        c = v[e + 20 >> 2];
        N(287, h | 0, c | 0);
        a = v[31601];
        v[31601] = 0;
        if ((a | 0) != 1) {
         break h;
        }
        break b;
       }
       a = M() | 0;
       break a;
      }
      b = 0;
      i: while (1) {
       f = 0;
       j: {
        k: {
         while (1) {
          if (f) {
           break j;
          }
          a = v[d + 8 >> 2];
          f = v[d >> 2];
          v[31601] = 0;
          a = O(736, f | 0, a | 0) | 0;
          f = v[31601];
          v[31601] = 0;
          l: {
           m: {
            n: {
             o: {
              if ((f | 0) != 1) {
               if (a) {
                break j;
               }
               v[31601] = 0;
               a = Q(533, d | 0) | 0;
               f = v[31601];
               v[31601] = 0;
               if ((f | 0) == 1) {
                break b;
               }
               f = 1;
               switch (a & 255) {
               case 3:
                break l;

               case 2:
                break m;

               case 1:
                break n;

               case 0:
                break o;

               default:
                continue;
               }
              }
              break b;
             }
             v[31601] = 0;
             a = Q(197, d | 0) | 0;
             g = v[31601];
             v[31601] = 0;
             if ((g | 0) == 1) {
              break b;
             }
             if (a >>> 0 > c >>> 0) {
              continue;
             }
             g = v[d + 8 >> 2];
             i = v[d >> 2];
             v[31601] = 0;
             g = T(150, i | 0, g | 0, a | 0) | 0;
             i = v[31601];
             v[31601] = 0;
             if ((i | 0) == 1) {
              break b;
             }
             if (!g) {
              continue;
             }
             oe(e + 24 | 0, v[h >> 2], v[h + 4 >> 2]);
             wr(e + 8 | 0, v[e + 24 >> 2], v[e + 28 >> 2], b, a);
             v[31601] = 0;
             Xn(471, e, d, v[e + 8 >> 2], v[e + 12 >> 2]);
             f = v[31601];
             v[31601] = 0;
             if ((f | 0) != 1) {
              c = c - a | 0;
              b = a + b | 0;
              continue i;
             }
             break b;
            }
            v[31601] = 0;
            a = Q(197, d | 0) | 0;
            g = v[31601];
            v[31601] = 0;
            if ((g | 0) == 1) {
             break b;
            }
            g = a << 2;
            if (g >>> 0 > c >>> 0) {
             continue;
            }
            v[31601] = 0;
            i = O(737, d | 0, e + 16 | 0) | 0;
            j = v[31601];
            v[31601] = 0;
            if ((j | 0) == 1) {
             break b;
            }
            if (!i) {
             continue;
            }
            while (1) {
             if (!(a & 255)) {
              break k;
             }
             f = e + 16 | 0;
             i = fc(f);
             sv(f, i, Pe(vb(v[h >> 2]), b));
             b = b + 4 | 0;
             a = a - 1 | 0;
             continue;
            }
           }
           if (c >>> 0 < 8) {
            continue;
           }
           v[31601] = 0;
           a = e + 16 | 0;
           g = O(737, d | 0, a | 0) | 0;
           i = v[31601];
           v[31601] = 0;
           if ((i | 0) == 1) {
            break b;
           }
           if (!g) {
            continue;
           }
           f = fc(a);
           sv(a, f, Pe(vb(v[h >> 2]), b));
           sv(a, f, Pe(Pe(vb(v[h >> 2]), b), 4));
           c = c - 8 | 0;
           b = b + 8 | 0;
           continue i;
          }
          v[31601] = 0;
          a = Q(197, d | 0) | 0;
          g = v[31601];
          v[31601] = 0;
          if ((g | 0) == 1) {
           break b;
          }
          if (a >>> 0 > c >>> 0) {
           continue;
          }
          break;
         }
         c = c - a | 0;
         b = a + b | 0;
         continue;
        }
        c = c - g | 0;
        continue;
       }
       break;
      }
      if (!c) {
       break f;
      }
      Mb(ec(h));
      break f;
     }
     v[31601] = 0;
     R(333, d | 0, h | 0, a | 0);
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) == 1) {
      break b;
     }
    }
    tb(d);
   }
   eb = e - -64 | 0;
   return;
  }
  a = M() | 0;
  tb(d);
 }
 ec(h);
 P(a | 0);
 p();
}

function zS(a, b, c) {
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
 f = eb - 16 | 0;
 eb = f;
 h = a + 1074992 | 0;
 d = h + B(b, 872) | 0;
 e = c & 15;
 a: {
  b: {
   switch (c - 16 >>> 4 | 0) {
   case 0:
    v[d + 88 >> 2] = v[d + 88 >> 2] & -1048577 | ((e | 0) != 0) << 20;
    break a;

   case 1:
    if (!(w[a + 480209 | 0] & 16)) {
     break a;
    }
    if (Jj(v[d + 656 >> 2])) {
     u[d + 772 >> 1] = e - 8;
     t[d + 851 | 0] = w[d + 851 | 0] | 64;
     break a;
    }
    if (v[a + 480180 >> 2] != 64) {
     b = e << 28 >> 24;
     u[d + 772 >> 1] = b;
     c = x[(e << 1) + 31616 >> 1];
     v[d + 704 >> 2] = c;
     if (!v[d + 700 >> 2]) {
      break a;
     }
     m = d, n = yh(a, w[d + 797 | 0], b, c), v[m + 700 >> 2] = n;
     break a;
    }
    a = v[d + 104 >> 2];
    if (!a) {
     break a;
    }
    v[d + 704 >> 2] = v[a + 24 >> 2] + B(e, 80);
    break a;

   case 2:
    if (v[a + 480180 >> 2] == 2) {
     t[d + 822 | 0] = c & 3;
     break a;
    }
    Ib(f + 8 | 0, a + 1074312 | 0, 21);
    if (Fb(v[v[f + 8 >> 2] >> 2], v[f + 12 >> 2])) {
     t[d + 822 | 0] = e >>> 0 < 4 ? e : 0;
     break a;
    }
    t[d + 822 | 0] = c & 7;
    break a;

   case 3:
    if (v[a + 480180 >> 2] == 2) {
     t[d + 825 | 0] = c & 3;
     break a;
    }
    Ib(f + 8 | 0, a + 1074312 | 0, 21);
    if (Fb(v[v[f + 8 >> 2] >> 2], v[f + 12 >> 2])) {
     t[d + 825 | 0] = e >>> 0 < 4 ? e : 0;
     break a;
    }
    t[d + 825 | 0] = c & 7;
    break a;

   case 4:
    Ib(f + 8 | 0, a + 1074312 | 0, 21);
    if (Fb(v[v[f + 8 >> 2] >> 2], v[f + 12 >> 2])) {
     t[d + 821 | 0] = 0;
     t[d + 828 | 0] = e >>> 0 < 4 ? e : 0;
     break a;
    }
    t[d + 828 | 0] = c & 7;
    break a;

   case 5:
    if (v[a + 1074392 >> 2] | !(w[a + 480209 | 0] & 16)) {
     break a;
    }
    v[a + 1074400 >> 2] = v[a + 1074400 >> 2] + e;
    break a;

   case 6:
    if (!(w[a + 480209 | 0] & 16)) {
     break a;
    }
    if (e >>> 0 <= 2) {
     c = x[a + 480188 >> 1];
     i = c >>> 0 <= 256 ? 256 : c;
     j = a + 906300 | 0;
     k = b + 1 | 0;
     l = e - 1 | 0;
     while (1) {
      if ((c | 0) == (i | 0)) {
       break a;
      }
      d = B(c, 872) + h | 0;
      c: {
       if (x[d + 786 >> 1] != (k | 0)) {
        break c;
       }
       d: {
        e: {
         switch (l | 0) {
         case 0:
          Eo(a, d);
          if (!(w[d + 89 | 0] & 2)) {
           break d;
          }
          e = v[a + 1298300 >> 2];
          if (!Dd(e)) {
           break d;
          }
          xk(e, c & 65535);
          break d;

         case 1:
          e = v[d + 88 >> 2];
          v[d + 88 >> 2] = e | 4096;
          if (!(e & 512)) {
           break d;
          }
          e = v[a + 1298300 >> 2];
          if (!Dd(e)) {
           break d;
          }
          xk(e, c & 65535);
          break d;

         default:
          break e;
         }
        }
        v[d + 696 >> 2] = 0;
        e = v[d + 88 >> 2];
        v[d + 88 >> 2] = e | 4096;
        if (!(e & 512)) {
         break d;
        }
        e = v[a + 1298300 >> 2];
        if (!Dd(e)) {
         break d;
        }
        Dj(e, c & 65535, 1);
       }
       e = v[d + 656 >> 2];
       if (!e) {
        break c;
       }
       g = w[e + 34 | 0];
       if (!g) {
        break c;
       }
       g = v[_d(j, g - 1 | 0) >> 2];
       if (!g) {
        break c;
       }
       hb[v[v[g >> 2] + 96 >> 2]](g, e, w[d + 797 | 0] | 256, 0, b);
      }
      c = c + 1 | 0;
      continue;
     }
    }
    dV(d, e, v[a + 480180 >> 2]);
    break a;

   case 7:
    if (!(w[a + 480209 | 0] & 16)) {
     break a;
    }
    Ym(a, d, e, 4);
    break a;

   case 8:
    b = v[a + 480208 >> 2];
    f: {
     if (!(b & 4096)) {
      break f;
     }
     g: {
      switch (e | 0) {
      case 0:
       v[d + 88 >> 2] = v[d + 88 >> 2] & -257;
       break f;

      case 1:
       v[d + 692 >> 2] = 128;
       v[d + 88 >> 2] = v[d + 88 >> 2] | 256;
       break f;

      case 8:
       v[d + 88 >> 2] = v[d + 88 >> 2] & -25165825 | 16777216;
       break f;

      case 9:
       v[d + 88 >> 2] = v[d + 88 >> 2] & -25165825 | 8388608;
       break f;

      case 10:
       v[a + 480208 >> 2] = b & -16385;
       break f;

      case 11:
       v[a + 480208 >> 2] = b | 16384;
       break f;

      case 12:
       v[a + 480208 >> 2] = b & -8193;
       break f;

      case 13:
       v[a + 480208 >> 2] = b | 8192;
       break f;

      case 14:
       v[d + 88 >> 2] = v[d + 88 >> 2] & -129;
       break f;

      case 15:
       break g;

      default:
       break f;
      }
     }
     h: {
      if (v[d >> 2] | v[d + 4 >> 2]) {
       break h;
      }
      a = v[d + 76 >> 2];
      if (!a) {
       break h;
      }
      if (!(m = Tc(w[d + 788 | 0]), n = 1, o = w[d + 88 | 0] & 2, o ? m : n)) {
       break h;
      }
      v[d >> 2] = -1;
      v[d + 4 >> 2] = a - 1;
     }
     v[d + 88 >> 2] = v[d + 88 >> 2] | 128;
    }
    break a;

   case 9:
    if (!(w[a + 480209 | 0] & 16)) {
     break a;
    }
    t[d + 836 | 0] = e;
    Ib(f + 8 | 0, a + 1074312 | 0, 35);
    if (Fb(v[v[f + 8 >> 2] >> 2], v[f + 12 >> 2])) {
     break a;
    }
    if (!Tc(w[d + 788 | 0])) {
     break a;
    }
    a = e << 16;
    if (a >>> 0 >= y[d + 76 >> 2]) {
     break a;
    }
    v[d + 4 >> 2] = a;
    break a;

   case 10:
    if (!(w[a + 480209 | 0] & 16)) {
     break a;
    }
    wB(a, a + 1074376 | 0, b, e);
    break a;

   case 11:
    i: {
     if (e) {
      break i;
     }
     e = 1;
     c = v[a + 480180 >> 2];
     if (c & 16777248) {
      break i;
     }
     e = 0;
     if ((c | 0) == 2) {
      break a;
     }
    }
    Ib(f + 8 | 0, a + 1074312 | 0, 30);
    eB(a, b, e, Fb(v[v[f + 8 >> 2] >> 2], v[f + 12 >> 2]) | v[a + 480180 >> 2] == 2);
    break a;

   case 14:
    break b;

   default:
    break a;
   }
  }
  if (v[a + 480180 >> 2] == 2) {
   break a;
  }
  t[d + 844 | 0] = e;
 }
 eb = f + 16 | 0;
}

function Bb(a) {
 a = a | 0;
 var b = 0, c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0;
 a: {
  if (!a) {
   break a;
  }
  d = a - 8 | 0;
  b = v[a - 4 >> 2];
  a = b & -8;
  f = d + a | 0;
  b: {
   if (b & 1) {
    break b;
   }
   if (!(b & 2)) {
    break a;
   }
   b = v[d >> 2];
   d = d - b | 0;
   if (d >>> 0 < y[31481]) {
    break a;
   }
   a = a + b | 0;
   c: {
    d: {
     if (v[31482] != (d | 0)) {
      c = v[d + 12 >> 2];
      if (b >>> 0 <= 255) {
       e = b >>> 3 | 0;
       b = v[d + 8 >> 2];
       if ((b | 0) == (c | 0)) {
        i = 125908, j = v[31477] & Dua(-2, e), v[i >> 2] = j;
        break b;
       }
       v[b + 12 >> 2] = c;
       v[c + 8 >> 2] = b;
       break b;
      }
      h = v[d + 24 >> 2];
      if ((c | 0) != (d | 0)) {
       b = v[d + 8 >> 2];
       v[b + 12 >> 2] = c;
       v[c + 8 >> 2] = b;
       break c;
      }
      e = v[d + 20 >> 2];
      if (e) {
       b = d + 20 | 0;
      } else {
       e = v[d + 16 >> 2];
       if (!e) {
        break d;
       }
       b = d + 16 | 0;
      }
      while (1) {
       g = b;
       c = e;
       b = c + 20 | 0;
       e = v[c + 20 >> 2];
       if (e) {
        continue;
       }
       b = c + 16 | 0;
       e = v[c + 16 >> 2];
       if (e) {
        continue;
       }
       break;
      }
      v[g >> 2] = 0;
      break c;
     }
     b = v[f + 4 >> 2];
     if ((b & 3) != 3) {
      break b;
     }
     v[31479] = a;
     v[f + 4 >> 2] = b & -2;
     v[d + 4 >> 2] = a | 1;
     v[f >> 2] = a;
     return;
    }
    c = 0;
   }
   if (!h) {
    break b;
   }
   b = v[d + 28 >> 2];
   e = (b << 2) + 126212 | 0;
   e: {
    if (v[e >> 2] == (d | 0)) {
     v[e >> 2] = c;
     if (c) {
      break e;
     }
     i = 125912, j = v[31478] & Dua(-2, b), v[i >> 2] = j;
     break b;
    }
    v[h + (v[h + 16 >> 2] == (d | 0) ? 16 : 20) >> 2] = c;
    if (!c) {
     break b;
    }
   }
   v[c + 24 >> 2] = h;
   b = v[d + 16 >> 2];
   if (b) {
    v[c + 16 >> 2] = b;
    v[b + 24 >> 2] = c;
   }
   b = v[d + 20 >> 2];
   if (!b) {
    break b;
   }
   v[c + 20 >> 2] = b;
   v[b + 24 >> 2] = c;
  }
  if (d >>> 0 >= f >>> 0) {
   break a;
  }
  b = v[f + 4 >> 2];
  if (!(b & 1)) {
   break a;
  }
  f: {
   g: {
    h: {
     i: {
      if (!(b & 2)) {
       if ((f | 0) == v[31483]) {
        v[31483] = d;
        a = v[31480] + a | 0;
        v[31480] = a;
        v[d + 4 >> 2] = a | 1;
        if (v[31482] != (d | 0)) {
         break a;
        }
        v[31479] = 0;
        v[31482] = 0;
        return;
       }
       if ((f | 0) == v[31482]) {
        v[31482] = d;
        a = v[31479] + a | 0;
        v[31479] = a;
        v[d + 4 >> 2] = a | 1;
        v[a + d >> 2] = a;
        return;
       }
       a = (b & -8) + a | 0;
       c = v[f + 12 >> 2];
       if (b >>> 0 <= 255) {
        e = b >>> 3 | 0;
        b = v[f + 8 >> 2];
        if ((b | 0) == (c | 0)) {
         i = 125908, j = v[31477] & Dua(-2, e), v[i >> 2] = j;
         break g;
        }
        v[b + 12 >> 2] = c;
        v[c + 8 >> 2] = b;
        break g;
       }
       h = v[f + 24 >> 2];
       if ((c | 0) != (f | 0)) {
        b = v[f + 8 >> 2];
        v[b + 12 >> 2] = c;
        v[c + 8 >> 2] = b;
        break h;
       }
       e = v[f + 20 >> 2];
       if (e) {
        b = f + 20 | 0;
       } else {
        e = v[f + 16 >> 2];
        if (!e) {
         break i;
        }
        b = f + 16 | 0;
       }
       while (1) {
        g = b;
        c = e;
        b = c + 20 | 0;
        e = v[c + 20 >> 2];
        if (e) {
         continue;
        }
        b = c + 16 | 0;
        e = v[c + 16 >> 2];
        if (e) {
         continue;
        }
        break;
       }
       v[g >> 2] = 0;
       break h;
      }
      v[f + 4 >> 2] = b & -2;
      v[d + 4 >> 2] = a | 1;
      v[a + d >> 2] = a;
      break f;
     }
     c = 0;
    }
    if (!h) {
     break g;
    }
    b = v[f + 28 >> 2];
    e = (b << 2) + 126212 | 0;
    j: {
     if ((f | 0) == v[e >> 2]) {
      v[e >> 2] = c;
      if (c) {
       break j;
      }
      i = 125912, j = v[31478] & Dua(-2, b), v[i >> 2] = j;
      break g;
     }
     v[h + ((f | 0) == v[h + 16 >> 2] ? 16 : 20) >> 2] = c;
     if (!c) {
      break g;
     }
    }
    v[c + 24 >> 2] = h;
    b = v[f + 16 >> 2];
    if (b) {
     v[c + 16 >> 2] = b;
     v[b + 24 >> 2] = c;
    }
    b = v[f + 20 >> 2];
    if (!b) {
     break g;
    }
    v[c + 20 >> 2] = b;
    v[b + 24 >> 2] = c;
   }
   v[d + 4 >> 2] = a | 1;
   v[a + d >> 2] = a;
   if (v[31482] != (d | 0)) {
    break f;
   }
   v[31479] = a;
   return;
  }
  if (a >>> 0 <= 255) {
   b = (a & -8) + 125948 | 0;
   e = v[31477];
   a = 1 << (a >>> 3);
   k: {
    if (!(e & a)) {
     v[31477] = a | e;
     a = b;
     break k;
    }
    a = v[b + 8 >> 2];
   }
   v[b + 8 >> 2] = d;
   v[a + 12 >> 2] = d;
   v[d + 12 >> 2] = b;
   v[d + 8 >> 2] = a;
   return;
  }
  c = 31;
  if (a >>> 0 <= 16777215) {
   b = E(a >>> 8 | 0);
   c = ((a >>> 38 - b & 1) - (b << 1) | 0) + 62 | 0;
  }
  v[d + 28 >> 2] = c;
  v[d + 16 >> 2] = 0;
  v[d + 20 >> 2] = 0;
  g = (c << 2) + 126212 | 0;
  l: {
   m: {
    b = v[31478];
    e = 1 << c;
    n: {
     if (!(b & e)) {
      v[31478] = b | e;
      c = 24;
      b = g;
      break n;
     }
     c = a << ((c | 0) != 31 ? 25 - (c >>> 1 | 0) | 0 : 0);
     b = v[g >> 2];
     while (1) {
      e = b;
      if ((v[b + 4 >> 2] & -8) == (a | 0)) {
       break m;
      }
      b = c >>> 29 | 0;
      c = c << 1;
      g = ((b & 4) + e | 0) + 16 | 0;
      b = v[g >> 2];
      if (b) {
       continue;
      }
      break;
     }
     c = 24;
     b = e;
    }
    e = d;
    f = d;
    a = 8;
    break l;
   }
   b = v[e + 8 >> 2];
   v[b + 12 >> 2] = d;
   c = 8;
   g = e + 8 | 0;
   f = 0;
   a = 24;
  }
  v[g >> 2] = d;
  v[c + d >> 2] = b;
  v[d + 12 >> 2] = e;
  v[a + d >> 2] = f;
  a = v[31485] - 1 | 0;
  v[31485] = a ? a : -1;
 }
}

function C1(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
 d = eb - 144 | 0;
 eb = d;
 xc(b);
 Lp(a);
 a: {
  f = d + 108 | 0;
  if (!cx(b, f)) {
   break a;
  }
  if (!bG(f)) {
   break a;
  }
  n = v[b + 8 >> 2];
  b: {
   if (!cd(b, w[f + 16 | 0] | w[f + 17 | 0] << 8 | (w[f + 18 | 0] << 16 | w[f + 19 | 0] << 24))) {
    break b;
   }
   while (1) {
    if ((w[f + 12 | 0] | w[f + 13 | 0] << 8 | (w[f + 14 | 0] << 16 | w[f + 15 | 0] << 24)) >>> 0 <= j >>> 0) {
     break b;
    }
    if (!Lb(v[b >> 2], v[b + 8 >> 2], 5)) {
     break b;
    }
    c: {
     if ((w[f + 4 | 0] | w[f + 5 | 0] << 8) >>> 0 >= 64) {
      if ((Ji(b) | 0) <= 0) {
       break c;
      }
     }
     g = 0;
     e = 1;
     while (1) {
      l = Yd(b);
      if (l) {
       m = g >>> 0 > 4;
       h = m & e;
       if (!((e ^ 1) & 1 | m)) {
        h = (Lq(l << 24 >> 24) & 255) == w[g + 13165 | 0];
       }
       e = h;
       g = g + 1 | 0;
       continue;
      }
      break;
     }
     Ub(b, 4);
     i = (g | 0) == 5 & e | i;
    }
    j = j + 1 | 0;
    continue;
   }
  }
  cd(b, n);
  if (!(i & 1)) {
   break a;
  }
  if (!Lb(v[b >> 2], v[b + 8 >> 2], aG(f))) {
   break a;
  }
  if (!c) {
   k = 1;
   break a;
  }
  h = eb - 16 | 0;
  eb = h;
  c = d + 108 | 0;
  cd(b, w[c + 16 | 0] | w[c + 17 | 0] << 8 | (w[c + 18 | 0] << 16 | w[c + 19 | 0] << 24));
  j = d + 96 | 0;
  f = Mb(j);
  e = w[c + 12 | 0] | w[c + 13 | 0] << 8 | (w[c + 14 | 0] << 16 | w[c + 15 | 0] << 24);
  v[31601] = 0;
  N(176, f | 0, e | 0);
  e = v[31601];
  v[31601] = 0;
  d: {
   e: {
    f: {
     if ((e | 0) != 1) {
      e = 0;
      g: {
       h: {
        while (1) {
         if ((w[c + 12 | 0] | w[c + 13 | 0] << 8 | (w[c + 14 | 0] << 16 | w[c + 15 | 0] << 24)) >>> 0 <= e >>> 0) {
          break g;
         }
         g = v[b + 8 >> 2];
         i = v[b >> 2];
         v[31601] = 0;
         g = T(150, i | 0, g | 0, 5) | 0;
         i = v[31601];
         v[31601] = 0;
         if ((i | 0) == 1) {
          break f;
         }
         if (!g) {
          break g;
         }
         i = w[c + 4 | 0] | w[c + 5 | 0] << 8;
         v[31601] = 0;
         g = h + 4 | 0;
         R(177, g | 0, b | 0, i | 0);
         i = v[31601];
         v[31601] = 0;
         if ((i | 0) != 1) {
          v[31601] = 0;
          N(178, f | 0, g | 0);
          i = v[31601];
          v[31601] = 0;
          if ((i | 0) == 1) {
           break h;
          }
          e = e + 1 | 0;
          sb(g);
          continue;
         }
         break;
        }
        a = M() | 0;
        break e;
       }
       a = M() | 0;
       sb(h + 4 | 0);
       break e;
      }
      eb = h + 16 | 0;
      break d;
     }
     a = M() | 0;
     break e;
    }
    a = M() | 0;
   }
   Sd(f);
   P(a | 0);
   p();
  }
  v[31601] = 0;
  U(170, d + 84 | 0, b | 0, c | 0, j | 0);
  c = v[31601];
  v[31601] = 0;
  i: {
   if ((c | 0) != 1) {
    v[31601] = 0;
    O(149, b | 0, w[d + 132 | 0] | w[d + 133 | 0] << 8 | (w[d + 134 | 0] << 16 | w[d + 135 | 0] << 24)) | 0;
    c = v[31601];
    v[31601] = 0;
    j: {
     if ((c | 0) != 1) {
      f = d + 36 | 0;
      k: {
       l: {
        m: {
         n: {
          while (1) {
           o: {
            p: {
             if ((w[d + 128 | 0] | w[d + 129 | 0] << 8 | (w[d + 130 | 0] << 16 | w[d + 131 | 0] << 24)) >>> 0 > k >>> 0) {
              c = v[b + 8 >> 2];
              e = v[b >> 2];
              v[31601] = 0;
              c = T(150, e | 0, c | 0, 8) | 0;
              e = v[31601];
              v[31601] = 0;
              if ((e | 0) == 1) {
               break p;
              }
              if (c) {
               break o;
              }
             }
             k = lc(v[a >> 2], v[a + 4 >> 2]) ^ 1;
             uc(d + 84 | 0);
             Sd(d + 96 | 0);
             break a;
            }
            b = M() | 0;
            break j;
           }
           v[31601] = 0;
           c = d + 60 | 0;
           $(171, c | 0, b | 0, d + 108 | 0, d + 84 | 0, d + 96 | 0);
           e = v[31601];
           v[31601] = 0;
           if ((e | 0) != 1) {
            e = Np(c);
            v[31601] = 0;
            c = Q(172, v[d + 60 >> 2]) | 0;
            h = v[31601];
            v[31601] = 0;
            if ((h | 0) == 1) {
             break n;
            }
            if (c) {
             v[31601] = 0;
             c = Q(173, d + 24 | 0) | 0;
             h = v[31601];
             v[31601] = 0;
             if ((h | 0) == 1) {
              break m;
             }
             e = v[e >> 2];
             q: {
              if ((e | 0) < 0) {
               break q;
              }
              g = v[d + 96 >> 2];
              if (Td(g, v[d + 100 >> 2]) >>> 0 <= e >>> 0) {
               break q;
              }
              v[31601] = 0;
              h = d + 12 | 0;
              N(174, h | 0, Ud(g, e) | 0);
              e = v[31601];
              v[31601] = 0;
              if ((e | 0) == 1) {
               break l;
              }
              yb(c, h);
              sb(h);
             }
             ax(f, d + 60 | 0);
             v[31601] = 0;
             N(175, a | 0, c | 0);
             e = v[31601];
             v[31601] = 0;
             if ((e | 0) == 1) {
              break l;
             }
             Hp(c);
            }
            k = k + 1 | 0;
            tb(d + 60 | 0);
            continue;
           }
           break;
          }
          b = M() | 0;
          break j;
         }
         b = M() | 0;
         break k;
        }
        b = M() | 0;
        break k;
       }
       b = M() | 0;
       Hp(c);
      }
      tb(d + 60 | 0);
      break j;
     }
     b = M() | 0;
    }
    uc(d + 84 | 0);
    break i;
   }
   b = M() | 0;
  }
  Sd(d + 96 | 0);
  P(b | 0);
  p();
 }
 eb = d + 144 | 0;
 return k | 0;
}

function ZL(a, b, c, d, e, f) {
 var g = 0, h = 0, i = 0, j = 0;
 g = eb - 48 | 0;
 eb = g;
 a: {
  b: {
   if (Vt(c)) {
    h = v[b + 484344 >> 2];
    if (Ie(h, v[b + 484348 >> 2], c & 65535)) {
     break b;
    }
   }
   c = a;
   a = Eb(g + 36 | 0);
   b = Eb(g + 24 | 0);
   sj(c, a, b);
   sb(b);
   sb(a);
   break a;
  }
  c = Vb(h, c);
  if (!(v[c + 12 >> 2] > (d | 0) & (d | 0) >= 0)) {
   c = a;
   a = Eb(g + 36 | 0);
   b = Eb(g + 24 | 0);
   sj(c, a, b);
   sb(b);
   sb(a);
   break a;
  }
  if (!(x[b + 480188 >> 1] > e >>> 0 & (e | 0) >= 0)) {
   c = a;
   a = Eb(g + 36 | 0);
   b = Eb(g + 24 | 0);
   sj(c, a, b);
   sb(b);
   sb(a);
   break a;
  }
  if (f >>> 0 >= 6) {
   c = a;
   a = Eb(g + 36 | 0);
   b = Eb(g + 24 | 0);
   sj(c, a, b);
   sb(b);
   sb(a);
   break a;
  }
  c = ld(v[c >> 2], v[v[c + 48 >> 2] + 12 >> 2], d, e & 65535);
  c: {
   d: {
    switch (f - 1 | 0) {
    default:
     e: {
      f: {
       g: {
        h: {
         i: {
          d = w[c | 0];
          if (!Tc(d)) {
           if (!Dl(d)) {
            break i;
           }
          }
          e = g + 24 | 0;
          OR(e, b, d, w[c + 1 | 0]);
          v[31601] = 0;
          N(1058, g + 36 | 0, e | 0);
          b = v[31601];
          v[31601] = 0;
          d = 1;
          if ((b | 0) != 1) {
           break h;
          }
          c = M() | 0;
          break e;
         }
         d = 0;
         v[31601] = 0;
         O(36, g + 36 | 0, 16764) | 0;
         b = v[31601];
         v[31601] = 0;
         if ((b | 0) == 1) {
          break g;
         }
        }
        b = 9968;
        c = w[c | 0];
        if (!Tc(c)) {
         b = Dl(c) ? 10278 : 16764;
        }
        v[31601] = 0;
        b = O(36, g + 12 | 0, b | 0) | 0;
        c = v[31601];
        v[31601] = 0;
        if ((c | 0) == 1) {
         break f;
        }
        c = a;
        a = g + 36 | 0;
        sj(c, a, b);
        sb(b);
        sb(a);
        if (!d) {
         break a;
        }
        sb(g + 24 | 0);
        break a;
       }
       c = M() | 0;
       break c;
      }
      c = M() | 0;
      sb(g + 36 | 0);
      if (!d) {
       break c;
      }
     }
     sb(g + 24 | 0);
     break c;

    case 0:
     b = c + 1 | 0;
     j: {
      if (w[c + 1 | 0]) {
       Jv(g + 36 | 0, b);
       break j;
      }
      Cc(g + 36 | 0, 16769);
     }
     b = w[b | 0];
     v[31601] = 0;
     b = O(36, g + 24 | 0, (b ? 10801 : 16769) | 0) | 0;
     c = v[31601];
     v[31601] = 0;
     if ((c | 0) != 1) {
      c = a;
      a = g + 36 | 0;
      sj(c, a, b);
      sb(b);
      sb(a);
      break a;
     }
     c = M() | 0;
     sb(g + 36 | 0);
     break c;

    case 1:
     k: {
      if (Vg(w[c | 0])) {
       Cc(g + 36 | 0, 18418);
       break k;
      }
      d = w[c + 2 | 0];
      if (d) {
       rf(g + 36 | 0, 1, lR(v[v[b + 8 >> 2] + 88 >> 2], d));
       break k;
      }
      Cc(g + 36 | 0, 18418);
     }
     b = 18418;
     if (!Vg(w[c | 0])) {
      b = w[c + 2 | 0] ? 5505 : 18418;
     }
     v[31601] = 0;
     b = O(36, g + 24 | 0, b | 0) | 0;
     c = v[31601];
     v[31601] = 0;
     if ((c | 0) != 1) {
      c = a;
      a = g + 36 | 0;
      sj(c, a, b);
      sb(b);
      sb(a);
      break a;
     }
     c = M() | 0;
     sb(g + 36 | 0);
     break c;

    case 3:
     b = w[c + 2 | 0];
     l: {
      if (Vg(w[c | 0])) {
       i = g, j = Bj(b, w[c + 4 | 0]) & 255, v[i + 12 >> 2] = j;
       eD(g + 36 | 0, g + 12 | 0);
       break l;
      }
      if (b) {
       Jv(g + 36 | 0, c + 4 | 0);
       break l;
      }
      Cc(g + 36 | 0, 16769);
     }
     b = 5489;
     if (!Vg(w[c | 0])) {
      b = w[c + 2 | 0] ? 5489 : 16769;
     }
     v[31601] = 0;
     b = O(36, g + 24 | 0, b | 0) | 0;
     c = v[31601];
     v[31601] = 0;
     if ((c | 0) != 1) {
      c = a;
      a = g + 36 | 0;
      sj(c, a, b);
      sb(b);
      sb(a);
      break a;
     }
     c = M() | 0;
     sb(g + 36 | 0);
     break c;

    case 2:
     d = w[c + 3 | 0];
     m: {
      if (Vg(w[c | 0])) {
       i = g, j = (Bj(d, w[c + 5 | 0]) & 3840) != 0, t[i + 12 | 0] = j;
       b = eb - 32 | 0;
       eb = b;
       v[b + 12 >> 2] = -1;
       v[b + 16 >> 2] = 0;
       v[b + 4 >> 2] = 0;
       Eb(b + 20 | 0);
       v[31601] = 0;
       v[b + 4 >> 2] = v[b + 4 >> 2] & -1332 | 1058;
       v[b + 8 >> 2] = 1;
       d = b + 4 | 0;
       R(1208, g + 36 | 0, g + 12 | 0, d | 0);
       e = v[31601];
       v[31601] = 0;
       n: {
        if ((e | 0) != 1) {
         Ih(d);
         eb = b + 32 | 0;
         break n;
        }
        a = M() | 0;
        Ih(b + 4 | 0);
        P(a | 0);
        p();
       }
       break m;
      }
      if (d) {
       rf(g + 36 | 0, 1, kR(v[v[b + 8 >> 2] + 84 >> 2], d));
       break m;
      }
      Cc(g + 36 | 0, 16770);
     }
     b = 12375;
     if (!Vg(w[c | 0])) {
      b = w[c + 3 | 0] ? 12375 : 16770;
     }
     v[31601] = 0;
     b = O(36, g + 24 | 0, b | 0) | 0;
     c = v[31601];
     v[31601] = 0;
     if ((c | 0) != 1) {
      c = a;
      a = g + 36 | 0;
      sj(c, a, b);
      sb(b);
      sb(a);
      break a;
     }
     c = M() | 0;
     sb(g + 36 | 0);
     break c;

    case 4:
     break d;
    }
   }
   b = w[c + 3 | 0];
   o: {
    if (Vg(w[c | 0])) {
     i = g, j = Bj(b, w[c + 5 | 0]) & 255, v[i + 12 >> 2] = j;
     eD(g + 36 | 0, g + 12 | 0);
     break o;
    }
    if (b) {
     Jv(g + 36 | 0, c + 5 | 0);
     break o;
    }
    Cc(g + 36 | 0, 16769);
   }
   b = 11162;
   if (!Vg(w[c | 0])) {
    b = w[c + 3 | 0] ? 11162 : 16769;
   }
   v[31601] = 0;
   b = O(36, g + 24 | 0, b | 0) | 0;
   c = v[31601];
   v[31601] = 0;
   if ((c | 0) != 1) {
    c = a;
    a = g + 36 | 0;
    sj(c, a, b);
    sb(b);
    sb(a);
    break a;
   }
   c = M() | 0;
   sb(g + 36 | 0);
  }
  P(c | 0);
  p();
 }
 eb = g + 48 | 0;
}

function cK(a, b, c, d) {
 var e = 0, f = 0, g = 0, h = 0, i = 0;
 e = v[b >> 2];
 a: {
  b: {
   c: {
    d: {
     e: {
      f: {
       g: {
        h: {
         i: {
          j: {
           k: {
            l: {
             if (!d) {
              break l;
             }
             g = v[d >> 2];
             if (!g) {
              break l;
             }
             if (!a) {
              d = c;
              break j;
             }
             v[d >> 2] = 0;
             d = c;
             break k;
            }
            m: {
             if (!v[v[124107] >> 2]) {
              if (!a) {
               break m;
              }
              if (!c) {
               break a;
              }
              g = c;
              while (1) {
               d = t[e | 0];
               if (d) {
                v[a >> 2] = d & 57343;
                a = a + 4 | 0;
                e = e + 1 | 0;
                g = g - 1 | 0;
                if (g) {
                 continue;
                }
                break a;
               }
               break;
              }
              v[a >> 2] = 0;
              v[b >> 2] = 0;
              return c - g | 0;
             }
             d = c;
             if (!a) {
              break i;
             }
             break g;
            }
            return Df(e);
           }
           f = 1;
           break g;
          }
          f = 0;
          break h;
         }
         f = 1;
        }
        while (1) {
         if (!f) {
          f = w[e | 0] >>> 3 | 0;
          if ((f - 16 | f + (g >> 26)) >>> 0 > 7) {
           break f;
          }
          f = e + 1 | 0;
          n: {
           if (!(g & 33554432)) {
            break n;
           }
           if ((w[f | 0] & 192) != 128) {
            e = e - 1 | 0;
            break d;
           }
           f = e + 2 | 0;
           if (!(g & 524288)) {
            break n;
           }
           if ((w[f | 0] & 192) != 128) {
            e = e - 1 | 0;
            break d;
           }
           f = e + 3 | 0;
          }
          e = f;
          d = d - 1 | 0;
          f = 1;
          continue;
         }
         while (1) {
          g = w[e | 0];
          o: {
           if (e & 3 | g - 1 >>> 0 > 126) {
            break o;
           }
           g = v[e >> 2];
           if ((g | g - 16843009) & -2139062144) {
            break o;
           }
           while (1) {
            d = d - 4 | 0;
            g = v[e + 4 >> 2];
            e = e + 4 | 0;
            if (!((g - 16843009 | g) & -2139062144)) {
             continue;
            }
            break;
           }
          }
          f = g & 255;
          if (f - 1 >>> 0 <= 126) {
           d = d - 1 | 0;
           e = e + 1 | 0;
           continue;
          }
          break;
         }
         f = f - 194 | 0;
         if (f >>> 0 > 50) {
          break e;
         }
         e = e + 1 | 0;
         g = v[(f << 2) + 120672 >> 2];
         f = 0;
         continue;
        }
       }
       while (1) {
        if (!f) {
         if (!d) {
          break a;
         }
         while (1) {
          p: {
           f = w[e | 0];
           h = f - 1 | 0;
           q: {
            r: {
             if (h >>> 0 > 126) {
              g = f;
              break r;
             }
             if (e & 3 | d >>> 0 < 5) {
              break q;
             }
             s: {
              while (1) {
               g = v[e >> 2];
               if ((g | g - 16843009) & -2139062144) {
                break s;
               }
               v[a >> 2] = g & 255;
               v[a + 4 >> 2] = w[e + 1 | 0];
               v[a + 8 >> 2] = w[e + 2 | 0];
               v[a + 12 >> 2] = w[e + 3 | 0];
               a = a + 16 | 0;
               e = e + 4 | 0;
               d = d - 4 | 0;
               if (d >>> 0 > 4) {
                continue;
               }
               break;
              }
              g = w[e | 0];
             }
             f = g & 255;
             h = f - 1 | 0;
            }
            if (h >>> 0 > 126) {
             break p;
            }
           }
           v[a >> 2] = f;
           a = a + 4 | 0;
           e = e + 1 | 0;
           d = d - 1 | 0;
           if (d) {
            continue;
           }
           break a;
          }
          break;
         }
         f = f - 194 | 0;
         if (f >>> 0 > 50) {
          break e;
         }
         e = e + 1 | 0;
         g = v[(f << 2) + 120672 >> 2];
         f = 1;
         continue;
        }
        i = w[e | 0];
        f = i >>> 3 | 0;
        if ((f - 16 | f + (g >> 26)) >>> 0 > 7) {
         break f;
        }
        t: {
         u: {
          h = e + 1 | 0;
          f = i - 128 | g << 6;
          v: {
           if ((f | 0) >= 0) {
            break v;
           }
           h = w[h | 0] - 128 | 0;
           if (h >>> 0 > 63) {
            break u;
           }
           i = f << 6;
           f = h | i;
           h = e + 2 | 0;
           if ((i | 0) >= 0) {
            break v;
           }
           h = w[h | 0] - 128 | 0;
           if (h >>> 0 > 63) {
            break u;
           }
           f = h | f << 6;
           h = e + 3 | 0;
          }
          e = h;
          v[a >> 2] = f;
          d = d - 1 | 0;
          a = a + 4 | 0;
          break t;
         }
         v[31476] = 25;
         e = e - 1 | 0;
         break c;
        }
        f = 0;
        continue;
       }
      }
      e = e - 1 | 0;
      if (g) {
       break d;
      }
      g = w[e | 0];
     }
     if (g & 255) {
      break d;
     }
     if (a) {
      v[a >> 2] = 0;
      v[b >> 2] = 0;
     }
     return c - d | 0;
    }
    v[31476] = 25;
    if (!a) {
     break b;
    }
   }
   v[b >> 2] = e;
  }
  return -1;
 }
 v[b >> 2] = e;
 return c;
}

function Qv(a, b) {
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0;
 f = a + b | 0;
 c = v[a + 4 >> 2];
 a: {
  b: {
   if (c & 1) {
    break b;
   }
   if (!(c & 2)) {
    break a;
   }
   c = v[a >> 2];
   b = c + b | 0;
   c: {
    d: {
     e: {
      a = a - c | 0;
      if ((a | 0) != v[31482]) {
       d = v[a + 12 >> 2];
       if (c >>> 0 <= 255) {
        e = v[a + 8 >> 2];
        if ((e | 0) != (d | 0)) {
         break e;
        }
        i = 125908, j = v[31477] & Dua(-2, c >>> 3 | 0), v[i >> 2] = j;
        break b;
       }
       g = v[a + 24 >> 2];
       if ((a | 0) != (d | 0)) {
        c = v[a + 8 >> 2];
        v[c + 12 >> 2] = d;
        v[d + 8 >> 2] = c;
        break c;
       }
       e = v[a + 20 >> 2];
       if (e) {
        c = a + 20 | 0;
       } else {
        e = v[a + 16 >> 2];
        if (!e) {
         break d;
        }
        c = a + 16 | 0;
       }
       while (1) {
        h = c;
        d = e;
        c = d + 20 | 0;
        e = v[d + 20 >> 2];
        if (e) {
         continue;
        }
        c = d + 16 | 0;
        e = v[d + 16 >> 2];
        if (e) {
         continue;
        }
        break;
       }
       v[h >> 2] = 0;
       break c;
      }
      c = v[f + 4 >> 2];
      if ((c & 3) != 3) {
       break b;
      }
      v[31479] = b;
      v[f + 4 >> 2] = c & -2;
      v[a + 4 >> 2] = b | 1;
      v[f >> 2] = b;
      return;
     }
     v[e + 12 >> 2] = d;
     v[d + 8 >> 2] = e;
     break b;
    }
    d = 0;
   }
   if (!g) {
    break b;
   }
   c = v[a + 28 >> 2];
   e = (c << 2) + 126212 | 0;
   f: {
    if (v[e >> 2] == (a | 0)) {
     v[e >> 2] = d;
     if (d) {
      break f;
     }
     i = 125912, j = v[31478] & Dua(-2, c), v[i >> 2] = j;
     break b;
    }
    v[g + (v[g + 16 >> 2] == (a | 0) ? 16 : 20) >> 2] = d;
    if (!d) {
     break b;
    }
   }
   v[d + 24 >> 2] = g;
   c = v[a + 16 >> 2];
   if (c) {
    v[d + 16 >> 2] = c;
    v[c + 24 >> 2] = d;
   }
   c = v[a + 20 >> 2];
   if (!c) {
    break b;
   }
   v[d + 20 >> 2] = c;
   v[c + 24 >> 2] = d;
  }
  g: {
   h: {
    i: {
     j: {
      c = v[f + 4 >> 2];
      if (!(c & 2)) {
       if (v[31483] == (f | 0)) {
        v[31483] = a;
        b = v[31480] + b | 0;
        v[31480] = b;
        v[a + 4 >> 2] = b | 1;
        if (v[31482] != (a | 0)) {
         break a;
        }
        v[31479] = 0;
        v[31482] = 0;
        return;
       }
       if (v[31482] == (f | 0)) {
        v[31482] = a;
        b = v[31479] + b | 0;
        v[31479] = b;
        v[a + 4 >> 2] = b | 1;
        v[a + b >> 2] = b;
        return;
       }
       b = (c & -8) + b | 0;
       d = v[f + 12 >> 2];
       if (c >>> 0 <= 255) {
        e = c >>> 3 | 0;
        c = v[f + 8 >> 2];
        if ((c | 0) == (d | 0)) {
         i = 125908, j = v[31477] & Dua(-2, e), v[i >> 2] = j;
         break h;
        }
        v[c + 12 >> 2] = d;
        v[d + 8 >> 2] = c;
        break h;
       }
       g = v[f + 24 >> 2];
       if ((d | 0) != (f | 0)) {
        c = v[f + 8 >> 2];
        v[c + 12 >> 2] = d;
        v[d + 8 >> 2] = c;
        break i;
       }
       e = v[f + 20 >> 2];
       if (e) {
        c = f + 20 | 0;
       } else {
        e = v[f + 16 >> 2];
        if (!e) {
         break j;
        }
        c = f + 16 | 0;
       }
       while (1) {
        h = c;
        d = e;
        c = d + 20 | 0;
        e = v[d + 20 >> 2];
        if (e) {
         continue;
        }
        c = d + 16 | 0;
        e = v[d + 16 >> 2];
        if (e) {
         continue;
        }
        break;
       }
       v[h >> 2] = 0;
       break i;
      }
      v[f + 4 >> 2] = c & -2;
      v[a + 4 >> 2] = b | 1;
      v[a + b >> 2] = b;
      break g;
     }
     d = 0;
    }
    if (!g) {
     break h;
    }
    c = v[f + 28 >> 2];
    e = (c << 2) + 126212 | 0;
    k: {
     if (v[e >> 2] == (f | 0)) {
      v[e >> 2] = d;
      if (d) {
       break k;
      }
      i = 125912, j = v[31478] & Dua(-2, c), v[i >> 2] = j;
      break h;
     }
     v[g + (v[g + 16 >> 2] == (f | 0) ? 16 : 20) >> 2] = d;
     if (!d) {
      break h;
     }
    }
    v[d + 24 >> 2] = g;
    c = v[f + 16 >> 2];
    if (c) {
     v[d + 16 >> 2] = c;
     v[c + 24 >> 2] = d;
    }
    c = v[f + 20 >> 2];
    if (!c) {
     break h;
    }
    v[d + 20 >> 2] = c;
    v[c + 24 >> 2] = d;
   }
   v[a + 4 >> 2] = b | 1;
   v[a + b >> 2] = b;
   if (v[31482] != (a | 0)) {
    break g;
   }
   v[31479] = b;
   return;
  }
  if (b >>> 0 <= 255) {
   c = (b & -8) + 125948 | 0;
   d = v[31477];
   b = 1 << (b >>> 3);
   l: {
    if (!(d & b)) {
     v[31477] = b | d;
     b = c;
     break l;
    }
    b = v[c + 8 >> 2];
   }
   v[c + 8 >> 2] = a;
   v[b + 12 >> 2] = a;
   v[a + 12 >> 2] = c;
   v[a + 8 >> 2] = b;
   return;
  }
  d = 31;
  if (b >>> 0 <= 16777215) {
   c = E(b >>> 8 | 0);
   d = ((b >>> 38 - c & 1) - (c << 1) | 0) + 62 | 0;
  }
  v[a + 28 >> 2] = d;
  v[a + 16 >> 2] = 0;
  v[a + 20 >> 2] = 0;
  c = (d << 2) + 126212 | 0;
  m: {
   e = v[31478];
   h = 1 << d;
   n: {
    if (!(e & h)) {
     v[31478] = e | h;
     v[c >> 2] = a;
     v[a + 24 >> 2] = c;
     break n;
    }
    d = b << ((d | 0) != 31 ? 25 - (d >>> 1 | 0) | 0 : 0);
    c = v[c >> 2];
    while (1) {
     e = c;
     if ((v[c + 4 >> 2] & -8) == (b | 0)) {
      break m;
     }
     c = d >>> 29 | 0;
     d = d << 1;
     h = e + (c & 4) | 0;
     c = v[h + 16 >> 2];
     if (c) {
      continue;
     }
     break;
    }
    v[h + 16 >> 2] = a;
    v[a + 24 >> 2] = e;
   }
   v[a + 12 >> 2] = a;
   v[a + 8 >> 2] = a;
   return;
  }
  b = v[e + 8 >> 2];
  v[b + 12 >> 2] = a;
  v[e + 8 >> 2] = a;
  v[a + 24 >> 2] = 0;
  v[a + 12 >> 2] = e;
  v[a + 8 >> 2] = b;
 }
}

function koa(a, b, c, d, e) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 var f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, q = 0, r = 0, s = 0, z = 0, A = 0, B = 0, C = 0, D = 0;
 h = eb - 4128 | 0;
 eb = h;
 i = Ab(w[a + 14 | 0] | w[a + 15 | 0] << 8);
 if (!(!i | i >>> 0 > 20 | x[b + 480190 >> 1] <= w[a + 23 | 0])) {
  md(d, 32);
  u[d + 34 >> 1] = 1;
  j = h + 12 | 0;
  g = j;
  i = a + 20 | 0;
  v[g >> 2] = i;
  v[g + 4 >> 2] = (i + 80 | 0) - i >> 2;
  dW(h + 4120 | 0, v[h + 12 >> 2], v[h + 16 >> 2], Ab(w[a + 14 | 0] | w[a + 15 | 0] << 8));
  f = v[h + 4120 >> 2];
  i = w[xb(f, 0) + 3 | 0];
  v[h + 12 >> 2] = 1;
  g = v[ad(mi(b, i + 1 | 0) + 24 | 0, g) >> 2];
  i = v[h + 4124 >> 2];
  dW(j, f, i, c ? i : 1);
  C = h, D = vb(v[h + 12 >> 2]), v[C + 4108 >> 2] = D;
  r = 1 / +(g >>> 0);
  i = eb - 16 | 0;
  eb = i;
  o = v[ub(i + 12 | 0, v[h + 12 >> 2] + (v[h + 16 >> 2] << 2) | 0) >> 2];
  eb = i + 16 | 0;
  f = v[d >> 2];
  q = v[h + 4120 >> 2];
  l = x[b + 480190 >> 1];
  while (1) {
   g = v[h + 4108 >> 2];
   if (Hb(g, o)) {
    i = w[g + 3 | 0];
    a: {
     if (i >>> 0 >= l >>> 0) {
      break a;
     }
     j = t[g + 1 | 0];
     if ((j | 0) < 0) {
      break a;
     }
     g = mi(b, i + 1 | 0);
     i = v[g >> 2];
     f = Te(r * (zi(+((j & 255) - t[xb(q, 0) + 1 | 0] | 0) / -12) * +(i >>> 0) * +y[g + 24 >> 2])) + f | 0;
     v[d >> 2] = f;
    }
    Xe(h + 4108 | 0);
    continue;
   } else {
    b: {
     s = Fh(d);
     if (!s) {
      break b;
     }
     i = (e << 12 >>> 0) / 1e4 | 0;
     g = v[h + 4124 >> 2];
     f = eb - 16 | 0;
     eb = f;
     k = h + 4108 | 0;
     v[k >> 2] = 0;
     v[k + 4 >> 2] = 0;
     sc(k + 8 | 0);
     Qd(f + 8 | 0, v[ub(f + 4 | 0, k) >> 2]);
     c: {
      if (!g) {
       break c;
      }
      v[31601] = 0;
      N(753, k | 0, g | 0);
      e = v[31601];
      v[31601] = 0;
      if ((e | 0) != 1) {
       v[31601] = 0;
       SV(k, g);
       e = v[31601];
       v[31601] = 0;
       if ((e | 0) != 1) {
        break c;
       }
      }
      a = M() | 0;
      xv(f + 8 | 0);
      P(a | 0);
      p();
     }
     e = f + 8 | 0;
     Pd(e);
     xv(e);
     eb = f + 16 | 0;
     o = v[k >> 2];
     z = v[h + 4120 >> 2];
     q = v[h + 4124 >> 2];
     f = 0;
     while (1) {
      if ((f | 0) == (q | 0)) {
       i = b + 24648 | 0;
      } else {
       g = xb(z, f);
       e = cW(o, f);
       l = w[g + 3 | 0];
       d: {
        if (l >>> 0 >= x[b + 480190 >> 1]) {
         break d;
        }
        j = t[g + 1 | 0];
        if ((j | 0) < 0) {
         break d;
        }
        A = 0;
        g = w[g + 2 | 0];
        if ((g + 14 & 255) >>> 0 <= 5) {
         A = t[g + 25150 | 0];
        }
        n = mi(b, l + 1 | 0);
        g = v[n + 24 >> 2];
        B = r * (zi(+(A << 24 >> 24) / 96 + +((j & 255) - t[xb(z, 0) + 1 | 0] | 0) / 12) * +(g >>> 0));
        if (B <= 0) {
         break d;
        }
        l = bW(B);
        v[e + 8 >> 2] = l;
        j = gb;
        v[e + 12 >> 2] = j;
        v[e + 16 >> 2] = v[n + 20 >> 2];
        g = v[n >> 2];
        v[e + 76 >> 2] = g;
        v[e + 88 >> 2] = x[n + 34 >> 1] & 1023;
        e: {
         if (c) {
          v[e + 664 >> 2] = m;
          m = Te(+(g >>> 0) / wC(l, j)) + m | 0;
          g = i;
          break e;
         }
         g = (i >>> 0) / (Ab(w[a + 14 | 0] | w[a + 15 | 0] << 8) >>> 0) | 0;
        }
        v[e + 20 >> 2] = g;
        v[e + 24 >> 2] = g;
       }
       f = f + 1 | 0;
       continue;
      }
      break;
     }
     b = 0;
     while (1) {
      f: {
       a = v[d >> 2];
       if (a >>> 0 > b >>> 0) {
        Qb(h + 12 | 0, 0, 4096);
        v[h + 8 >> 2] = 512;
        v[h + 4 >> 2] = a - b;
        j = v[Gb(h + 8 | 0, h + 4 | 0) >> 2];
        C = h, D = vb(v[k >> 2]), v[C + 8 >> 2] = D;
        c = vb(v[k + 4 >> 2]);
        while (1) {
         f = v[h + 8 >> 2];
         if (!Hb(f, c)) {
          break f;
         }
         g: {
          h: {
           if (!v[f + 16 >> 2]) {
            break h;
           }
           g = v[f + 664 >> 2];
           if (g >>> 0 >= j >>> 0) {
            v[f + 664 >> 2] = g - j;
            break h;
           }
           e = v[f + 88 >> 2];
           v[h + 4 >> 2] = j - g;
           C = h, D = Te((+y[f + 76 >> 2] - wC(v[f >> 2], v[f + 4 >> 2])) / wC(v[f + 8 >> 2], v[f + 12 >> 2])), 
           v[C >> 2] = D;
           a = v[Gb(h + 4 | 0, h) >> 2];
           v[31601] = 0;
           U(v[((e & 1 | (e & 64 ? 18 : 16)) << 2) + 25728 >> 2], f | 0, i | 0, (h + 12 | 0) + (g << 3) | 0, a | 0);
           a = v[31601];
           v[31601] = 0;
           if ((a | 0) == 1) {
            break g;
           }
           v[f + 664 >> 2] = 0;
           if (y[f + 76 >> 2] > y[f + 4 >> 2]) {
            break h;
           }
           v[f + 16 >> 2] = 0;
          }
          v[h + 8 >> 2] = v[h + 8 >> 2] + 872;
          continue;
         }
         break;
        }
        a = M() | 0;
        yv(k);
        P(a | 0);
        p();
       }
       yv(k);
       break b;
      }
      e = v[d + 20 >> 2] + (b << 1) | 0;
      f = h + 12 | 0;
      c = eb - 16 | 0;
      eb = c;
      v[c + 12 >> 2] = j;
      wc(c + 12 | 0, 512);
      m = v[c + 12 >> 2];
      while (1) {
       if (m) {
        a = qd(v[f >> 2] + 2048 | 0, 12);
        a = (a | 0) >= 32767 ? 32767 : a;
        u[e >> 1] = (a | 0) <= -32768 ? -32768 : a;
        f = f + 8 | 0;
        e = e + 2 | 0;
        m = m - 1 | 0;
        continue;
       }
       break;
      }
      eb = c + 16 | 0;
      b = b + j | 0;
      continue;
     }
    }
    f = (s | 0) != 0;
   }
   break;
  }
 }
 eb = h + 4128 | 0;
 return f | 0;
}

function Bna(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, q = 0;
 d = eb + -64 | 0;
 eb = d;
 u[d + 62 >> 1] = c;
 Gf(d + 62 | 0, 32);
 j = Mb(a);
 v[31601] = 0;
 n = x[d + 62 >> 1];
 N(537, j | 0, n | 0);
 a = v[31601];
 v[31601] = 0;
 a: {
  b: {
   if ((a | 0) != 1) {
    o = b + 900380 | 0;
    while (1) {
     c: {
      d: {
       if ((q & 65535) >>> 0 < n >>> 0) {
        f = 1;
        c = x[b + 480190 >> 1];
        a = c + 1 | 0;
        u[d + 60 >> 1] = a;
        if ((a & 65535) >>> 0 < 4e3) {
         break d;
        }
        e: {
         while (1) {
          g = f & 65535;
          if (g >>> 0 > c >>> 0) {
           break e;
          }
          f: {
           e = mi(b, g);
           if (!ke(v[e >> 2], v[e + 20 >> 2])) {
            if (!Hb(OC(vb(v[j >> 2]), vb(v[j + 4 >> 2]), f), vb(v[j + 4 >> 2]))) {
             break f;
            }
            c = x[b + 480190 >> 1];
           }
           f = f + 1 | 0;
           continue;
          }
          break;
         }
         u[d + 60 >> 1] = f;
         a = 1;
         while (1) {
          c = a & 65535;
          if (c >>> 0 > x[b + 480192 >> 1]) {
           a = f;
          } else {
           g: {
            c = v[(c << 2) + o >> 2];
            if (!c) {
             break g;
            }
            c = c + 236 | 0;
            e = ur(c);
            while (1) {
             if ((c | 0) == (e | 0)) {
              break g;
             }
             if ((g | 0) == x[c >> 1]) {
              u[c >> 1] = 0;
             }
             c = c + 2 | 0;
             continue;
            }
           }
           a = a + 1 | 0;
           continue;
          }
          break;
         }
        }
        if ((a & 65535) >>> 0 < 4e3) {
         break d;
        }
        f = So(d + 48 | 0);
        v[31601] = 0;
        a = O(776, b | 0, f | 0) | 0;
        c = v[31601];
        v[31601] = 0;
        if ((c | 0) == 1) {
         break b;
        }
        if (a) {
         v[31601] = 0;
         N(777, b | 0, f | 0);
         c = v[31601];
         v[31601] = 0;
         a = 1;
         if ((c | 0) == 1) {
          break b;
         }
         while (1) {
          c = a & 65535;
          if (c >>> 0 <= x[b + 480192 >> 1]) {
           h: {
            c = v[(c << 2) + o >> 2];
            if (!c) {
             break h;
            }
            c = c + 236 | 0;
            g = ur(c);
            while (1) {
             if ((c | 0) == (g | 0)) {
              break h;
             }
             e = x[c >> 1];
             i: {
              if (e >>> 0 >= y[d + 52 >> 2]) {
               break i;
              }
              Ib(d + 40 | 0, v[f >> 2], e);
              if (Fb(v[v[d + 40 >> 2] >> 2], v[d + 44 >> 2])) {
               break i;
              }
              u[c >> 1] = 0;
             }
             c = c + 2 | 0;
             continue;
            }
           }
           a = a + 1 | 0;
           continue;
          }
          break;
         }
         ln(d + 24 | 0, v[f >> 2]);
         uV(d + 32 | 0, v[d + 24 >> 2], v[d + 28 >> 2], 1);
         $q(d + 16 | 0, v[f >> 2], v[d + 52 >> 2]);
         l = eb - 16 | 0;
         eb = l;
         g = d + 40 | 0;
         e = Yb(l, v[d + 32 >> 2], v[d + 36 >> 2]);
         a = hv(v[d + 16 >> 2], v[d + 20 >> 2], v[d + 32 >> 2], v[d + 36 >> 2]);
         c = eb - 16 | 0;
         eb = c;
         v[c + 12 >> 2] = a;
         h = v[e + 4 >> 2];
         j: {
          if (h) {
           i = 32 - h | 0;
           v[c + 8 >> 2] = i;
           m = v[Gb(c + 8 | 0, c + 12 | 0) >> 2];
           k = -1 << h & -1 >>> i - m;
           i = v[e >> 2];
           k = k & (v[i >> 2] ^ -1);
           if (k) {
            Yb(g, i, zua(k));
            break j;
           }
           if ((a | 0) == (m | 0)) {
            uV(g, i, h, a);
            break j;
           }
           a = a - m | 0;
           v[c + 12 >> 2] = a;
           v[e >> 2] = i + 4;
          }
          while (1) {
           if (a >>> 0 >= 32) {
            h = v[e >> 2];
            i = v[h >> 2];
            if ((i | 0) != -1) {
             Yb(g, h, zua(i ^ -1));
             break j;
            } else {
             v[e >> 2] = h + 4;
             a = a - 32 | 0;
             v[c + 12 >> 2] = a;
             continue;
            }
           }
           break;
          }
          e = v[e >> 2];
          if (!a) {
           Yb(g, e, 0);
           break j;
          }
          h = (v[e >> 2] ^ -1) & -1 >>> 32 - a;
          if (!h) {
           Yb(g, e, a);
           break j;
          }
          Yb(g, e, zua(h));
         }
         eb = c + 16 | 0;
         eb = l + 16 | 0;
         ln(d + 8 | 0, v[f >> 2]);
         a = hv(v[d + 40 >> 2], v[d + 44 >> 2], v[d + 8 >> 2], v[d + 12 >> 2]);
         u[d + 60 >> 1] = a;
         tf(f);
         if ((a & 65535) >>> 0 < 4e3) {
          break d;
         }
         break c;
        }
        tf(f);
       }
       eb = d - -64 | 0;
       return;
      }
      v[31601] = 0;
      N(257, j | 0, d + 60 | 0);
      c = v[31601];
      v[31601] = 0;
      if ((c | 0) != 1) {
       if (x[b + 480190 >> 1] >= (a & 65535) >>> 0) {
        break c;
       }
       u[b + 480190 >> 1] = a;
       break c;
      }
      c = M() | 0;
      break a;
     }
     q = q + 1 | 0;
     continue;
    }
   }
   c = M() | 0;
   break a;
  }
  c = M() | 0;
  tf(f);
 }
 nd(j);
 P(c | 0);
 p();
}

function Tg(a, b, c, d, e, f, g, h, i) {
 var j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0;
 k = eb - 112 | 0;
 eb = k;
 j = i & 2147483647;
 a: {
  b: {
   m = e & 2147483647;
   l = 2147418112;
   n = !(b | c);
   if (!(d | m ? m - l >>> 0 < 2147549184 : n)) {
    r = j - l | 0;
    if (!h & (r | 0) == -2147418112 ? f | g : (r | 0) == -2147418112 & (h | 0) != 0 | r >>> 0 > 2147549184) {
     break b;
    }
   }
   if (!(!d & (m | 0) == 2147418112 ? n : m >>> 0 < 2147418112)) {
    h = d;
    i = e | 32768;
    f = b;
    g = c;
    break a;
   }
   if (!(!h & (j | 0) == 2147418112 ? !(f | g) : j >>> 0 < 2147418112)) {
    i = i | 32768;
    break a;
   }
   if (!(b | d | (m ^ 2147418112 | c))) {
    j = d;
    d = !(b ^ f | d ^ h | (c ^ g | e ^ i ^ -2147483648));
    h = d ? 0 : j;
    i = d ? 2147450880 : e;
    f = d ? 0 : b;
    g = d ? 0 : c;
    break a;
   }
   l = f | h;
   if (!(l | (j ^ 2147418112 | g))) {
    break a;
   }
   if (!(b | d | (c | m))) {
    if (g | j | l) {
     break a;
    }
    f = b & f;
    g = c & g;
    h = d & h;
    i = e & i;
    break a;
   }
   if (f | h | (g | j)) {
    break b;
   }
   f = b;
   g = c;
   h = d;
   i = e;
   break a;
  }
  l = (j | 0) == (m | 0);
  p = l & (d | 0) == (h | 0) ? (c | 0) == (g | 0) & b >>> 0 < f >>> 0 | c >>> 0 < g >>> 0 : l & d >>> 0 < h >>> 0 | j >>> 0 > m >>> 0;
  n = p;
  m = n ? f : b;
  r = n ? g : c;
  l = n ? i : e;
  s = l;
  n = n ? h : d;
  q = l & 65535;
  j = p ? d : h;
  l = p ? e : i;
  d = l;
  l = d >>> 16 & 32767;
  o = s >>> 16 & 32767;
  if (!o) {
   o = !(n | q);
   h = o;
   o = h << 6;
   t = E(h ? m : n) + 32 | 0;
   h = E(h ? r : q);
   o = o + ((h | 0) == 32 ? t : h) | 0;
   _f(k + 96 | 0, m, r, n, q, o - 15 | 0);
   n = v[k + 104 >> 2];
   q = v[k + 108 >> 2];
   r = v[k + 100 >> 2];
   o = 16 - o | 0;
   m = v[k + 96 >> 2];
  }
  f = p ? b : f;
  g = p ? c : g;
  b = j;
  c = d & 65535;
  if (!l) {
   j = !(b | c);
   p = j;
   d = j ? f : b;
   j = j << 6;
   p = E(p ? g : c);
   j = j + ((p | 0) == 32 ? E(d) + 32 | 0 : p) | 0;
   _f(k + 80 | 0, f, g, b, c, j - 15 | 0);
   l = 16 - j | 0;
   f = v[k + 80 >> 2];
   g = v[k + 84 >> 2];
   b = v[k + 88 >> 2];
   c = v[k + 92 >> 2];
  }
  d = c << 3;
  c = b;
  b = d | b >>> 29;
  j = c << 3;
  c = b;
  b = g >>> 29 | j;
  c = c | 524288;
  j = q << 3 | n >>> 29;
  q = n << 3 | r >>> 29;
  p = j;
  h = e ^ i;
  j = g << 3 | f >>> 29;
  d = f << 3;
  c: {
   if ((l | 0) == (o | 0)) {
    break c;
   }
   e = o - l | 0;
   if (e >>> 0 > 127) {
    b = 0;
    c = 0;
    j = 0;
    d = 1;
    break c;
   }
   _f(k - -64 | 0, d, j, b, c, 128 - e | 0);
   bn(k + 48 | 0, d, j, b, c, e);
   b = v[k + 56 >> 2];
   c = v[k + 60 >> 2];
   j = v[k + 52 >> 2];
   d = v[k + 48 >> 2] | (v[k + 64 >> 2] | v[k + 72 >> 2] | (v[k + 68 >> 2] | v[k + 76 >> 2])) != 0;
  }
  n = d;
  l = j;
  p = p | 524288;
  j = r << 3 | m >>> 29;
  m = m << 3;
  d: {
   if ((h | 0) < 0) {
    f = 0;
    g = 0;
    h = 0;
    i = 0;
    if (!(m ^ n | b ^ q | (j ^ l | c ^ p))) {
     break a;
    }
    d = m - n | 0;
    e = j - ((m >>> 0 < n >>> 0) + l | 0) | 0;
    f = q - b | 0;
    g = (j | 0) == (l | 0) & m >>> 0 < n >>> 0 | j >>> 0 < l >>> 0;
    h = f - g | 0;
    b = (p - ((b >>> 0 > q >>> 0) + c | 0) | 0) - (f >>> 0 < g >>> 0) | 0;
    i = b;
    if (b >>> 0 > 524287) {
     break d;
    }
    c = !(b | h);
    g = c;
    i = c ? d : h;
    c = c << 6;
    g = E(g ? e : b);
    c = c + ((g | 0) == 32 ? E(i) + 32 | 0 : g) | 0;
    f = b;
    b = c - 12 | 0;
    _f(k + 32 | 0, d, e, h, f, b);
    o = o - b | 0;
    h = v[k + 40 >> 2];
    i = v[k + 44 >> 2];
    d = v[k + 32 >> 2];
    e = v[k + 36 >> 2];
    break d;
   }
   j = j + l | 0;
   d = m + n | 0;
   e = d >>> 0 < m >>> 0 ? j + 1 | 0 : j;
   f = (l | 0) == (e | 0) & d >>> 0 < n >>> 0 | e >>> 0 < l >>> 0;
   j = c + p | 0;
   b = b + q | 0;
   j = b >>> 0 < q >>> 0 ? j + 1 | 0 : j;
   h = b + f | 0;
   i = h >>> 0 < b >>> 0 ? j + 1 | 0 : j;
   if (!(i & 1048576)) {
    break d;
   }
   d = n & 1 | ((e & 1) << 31 | d >>> 1);
   e = h << 31 | e >>> 1;
   o = o + 1 | 0;
   h = (i & 1) << 31 | h >>> 1;
   i = i >>> 1 | 0;
  }
  f = 0;
  b = s & -2147483648;
  m = b;
  if ((o | 0) >= 32767) {
   h = f;
   i = b | 2147418112;
   g = 0;
   break a;
  }
  l = 0;
  e: {
   if ((o | 0) > 0) {
    l = o;
    break e;
   }
   _f(k + 16 | 0, d, e, h, i, o + 127 | 0);
   bn(k, d, e, h, i, 1 - o | 0);
   d = v[k >> 2] | (v[k + 16 >> 2] | v[k + 24 >> 2] | (v[k + 20 >> 2] | v[k + 28 >> 2])) != 0;
   e = v[k + 4 >> 2];
   h = v[k + 8 >> 2];
   i = v[k + 12 >> 2];
  }
  c = (e & 7) << 29 | d >>> 3;
  b = h << 29 | e >>> 3;
  e = f | ((i & 7) << 29 | h >>> 3);
  f = m | (i >>> 3 & 65535 | l << 16);
  f: {
   g: {
    d = d & 7;
    if ((d | 0) != 4) {
     i = f;
     f = d >>> 0 > 4;
     g = f;
     f = c + f | 0;
     g = g >>> 0 > f >>> 0 ? b + 1 | 0 : b;
     b = (g | 0) == (b | 0) & c >>> 0 > f >>> 0 | b >>> 0 > g >>> 0;
     h = b + e | 0;
     i = b >>> 0 > h >>> 0 ? i + 1 | 0 : i;
     break g;
    }
    j = f;
    d = c & 1;
    f = c + d | 0;
    g = d >>> 0 > f >>> 0 ? b + 1 | 0 : b;
    b = (g | 0) == (b | 0) & c >>> 0 > f >>> 0 | b >>> 0 > g >>> 0;
    h = b + e | 0;
    i = b >>> 0 > h >>> 0 ? j + 1 | 0 : j;
    break f;
   }
   if (!d) {
    break a;
   }
  }
 }
 v[a >> 2] = f;
 v[a + 4 >> 2] = g;
 v[a + 8 >> 2] = h;
 v[a + 12 >> 2] = i;
 eb = k + 112 | 0;
}

function pH() {
 var a = 0, b = 0, c = 0, d = 0;
 if (w[499768]) {
  return v[124941];
 }
 b = wd(501400, 1);
 v[b >> 2] = 95180;
 c = EJ(b + 8 | 0);
 v[31601] = 0;
 d = O(36, b + 152 | 0, 14276) | 0;
 a = v[31601];
 v[31601] = 0;
 a: {
  b: {
   c: {
    if ((a | 0) != 1) {
     Mc(c);
     yJ(501072, 1);
     v[31601] = 0;
     V(1293, b | 0);
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) == 1) {
      break c;
     }
     xJ(501080, 1);
     v[31601] = 0;
     V(1294, b | 0);
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) == 1) {
      break c;
     }
     wJ(501088, 1);
     v[31601] = 0;
     V(1295, b | 0);
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) == 1) {
      break c;
     }
     vJ(501104, 1);
     v[31601] = 0;
     V(1296, b | 0);
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) == 1) {
      break c;
     }
     wd(501112, 1);
     v[125278] = 97124;
     v[31601] = 0;
     V(1297, b | 0);
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) == 1) {
      break c;
     }
     v[31601] = 0;
     W(1298);
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) == 1) {
      break c;
     }
     v[31601] = 0;
     V(1299, b | 0);
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) == 1) {
      break c;
     }
     wd(501136, 1);
     v[125284] = 97272;
     v[31601] = 0;
     V(1300, b | 0);
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) == 1) {
      break c;
     }
     wd(501144, 1);
     v[125286] = 97504;
     v[31601] = 0;
     V(1301, b | 0);
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) == 1) {
      break c;
     }
     wd(501152, 1);
     v[125288] = 97388;
     v[31601] = 0;
     V(1302, b | 0);
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) == 1) {
      break c;
     }
     wd(501160, 1);
     v[125290] = 97620;
     v[31601] = 0;
     V(1303, b | 0);
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) == 1) {
      break c;
     }
     uJ(501168, 1);
     v[31601] = 0;
     V(1304, b | 0);
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) == 1) {
      break c;
     }
     tJ(501192, 1);
     v[31601] = 0;
     V(1305, b | 0);
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) == 1) {
      break c;
     }
     wd(501224, 1);
     v[125306] = 98340;
     v[31601] = 0;
     V(1306, b | 0);
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) == 1) {
      break c;
     }
     wd(501232, 1);
     v[125308] = 98584;
     v[31601] = 0;
     V(1307, b | 0);
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) == 1) {
      break c;
     }
     wd(501240, 1);
     v[125310] = 98796;
     v[31601] = 0;
     V(1308, b | 0);
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) == 1) {
      break c;
     }
     wd(501248, 1);
     v[125312] = 99028;
     v[31601] = 0;
     V(1309, b | 0);
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) == 1) {
      break c;
     }
     sJ(501256, 1);
     v[31601] = 0;
     V(1310, b | 0);
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) == 1) {
      break c;
     }
     rJ(501264, 1);
     v[31601] = 0;
     V(1311, b | 0);
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) == 1) {
      break c;
     }
     qJ(501272, 1);
     v[31601] = 0;
     V(1312, b | 0);
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) == 1) {
      break c;
     }
     pJ(501280, 1);
     v[31601] = 0;
     V(1313, b | 0);
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) == 1) {
      break c;
     }
     wd(501288, 1);
     v[125322] = 101720;
     v[31601] = 0;
     V(1314, b | 0);
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) == 1) {
      break c;
     }
     wd(501296, 1);
     v[125324] = 101884;
     v[31601] = 0;
     V(1315, b | 0);
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) == 1) {
      break c;
     }
     wd(501304, 1);
     v[125326] = 102048;
     v[31601] = 0;
     V(1316, b | 0);
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) == 1) {
      break c;
     }
     wd(501312, 1);
     v[125328] = 102212;
     v[31601] = 0;
     V(1317, b | 0);
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) == 1) {
      break c;
     }
     oJ(501320, 1);
     v[31601] = 0;
     V(1318, b | 0);
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) == 1) {
      break c;
     }
     nJ(501336, 1);
     v[31601] = 0;
     V(1319, b | 0);
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) == 1) {
      break c;
     }
     v[31601] = 0;
     W(1320);
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) == 1) {
      break c;
     }
     v[31601] = 0;
     V(1321, b | 0);
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) == 1) {
      break c;
     }
     v[31601] = 0;
     W(1322);
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) == 1) {
      break c;
     }
     v[31601] = 0;
     V(1323, b | 0);
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) == 1) {
      break c;
     }
     mJ(501384, 1);
     v[31601] = 0;
     V(1324, b | 0);
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) == 1) {
      break c;
     }
     lJ(501392, 1);
     v[31601] = 0;
     V(1325, b | 0);
     b = v[31601];
     v[31601] = 0;
     if ((b | 0) == 1) {
      break c;
     }
     break a;
    }
    b = M() | 0;
    break b;
   }
   b = M() | 0;
   sb(d);
  }
  oy(c);
  P(b | 0);
  p();
 }
 v[124940] = 501400;
 t[499768] = 1;
 v[124941] = 499760;
 return 499760;
}

function zka(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0;
 f = eb - 16 | 0;
 eb = f;
 e = eb - 16 | 0;
 eb = e;
 d = EB(f + 8 | 0);
 a: {
  b: {
   c: {
    d: {
     switch (b - 850 | 0) {
     default:
      e: {
       f: {
        if ((b | 0) != 437) {
         if ((b | 0) == 737) {
          break f;
         }
         if ((b | 0) == 775) {
          break e;
         }
         if ((b | 0) == 1252) {
          break c;
         }
         g: {
          h: {
           if ((b | 0) != 20127) {
            if ((b | 0) == 28591) {
             break h;
            }
            if ((b | 0) == 28605) {
             break g;
            }
            if ((b | 0) != 65001) {
             break b;
            }
            b = mf(e + 8 | 0, 0);
            v[d >> 2] = v[b >> 2];
            t[d + 4 | 0] = w[b + 4 | 0];
            break a;
           }
           b = mf(e + 8 | 0, 1);
           v[d >> 2] = v[b >> 2];
           t[d + 4 | 0] = w[b + 4 | 0];
           break a;
          }
          b = mf(e + 8 | 0, 2);
          v[d >> 2] = v[b >> 2];
          t[d + 4 | 0] = w[b + 4 | 0];
          break a;
         }
         b = mf(e + 8 | 0, 3);
         v[d >> 2] = v[b >> 2];
         t[d + 4 | 0] = w[b + 4 | 0];
         break a;
        }
        b = mf(e + 8 | 0, 4);
        v[d >> 2] = v[b >> 2];
        t[d + 4 | 0] = w[b + 4 | 0];
        break a;
       }
       b = mf(e + 8 | 0, 5);
       v[d >> 2] = v[b >> 2];
       t[d + 4 | 0] = w[b + 4 | 0];
       break a;
      }
      b = mf(e + 8 | 0, 6);
      v[d >> 2] = v[b >> 2];
      t[d + 4 | 0] = w[b + 4 | 0];
      break a;

     case 0:
      b = mf(e + 8 | 0, 7);
      v[d >> 2] = v[b >> 2];
      t[d + 4 | 0] = w[b + 4 | 0];
      break a;

     case 2:
      b = mf(e + 8 | 0, 8);
      v[d >> 2] = v[b >> 2];
      t[d + 4 | 0] = w[b + 4 | 0];
      break a;

     case 5:
      b = mf(e + 8 | 0, 9);
      v[d >> 2] = v[b >> 2];
      t[d + 4 | 0] = w[b + 4 | 0];
      break a;

     case 7:
      b = mf(e + 8 | 0, 10);
      v[d >> 2] = v[b >> 2];
      t[d + 4 | 0] = w[b + 4 | 0];
      break a;

     case 10:
      b = mf(e + 8 | 0, 11);
      v[d >> 2] = v[b >> 2];
      t[d + 4 | 0] = w[b + 4 | 0];
      break a;

     case 11:
      b = mf(e + 8 | 0, 12);
      v[d >> 2] = v[b >> 2];
      t[d + 4 | 0] = w[b + 4 | 0];
      break a;

     case 12:
      b = mf(e + 8 | 0, 13);
      v[d >> 2] = v[b >> 2];
      t[d + 4 | 0] = w[b + 4 | 0];
      break a;

     case 13:
      b = mf(e + 8 | 0, 14);
      v[d >> 2] = v[b >> 2];
      t[d + 4 | 0] = w[b + 4 | 0];
      break a;

     case 14:
      b = mf(e + 8 | 0, 15);
      v[d >> 2] = v[b >> 2];
      t[d + 4 | 0] = w[b + 4 | 0];
      break a;

     case 15:
      b = mf(e + 8 | 0, 16);
      v[d >> 2] = v[b >> 2];
      t[d + 4 | 0] = w[b + 4 | 0];
      break a;

     case 16:
      b = mf(e + 8 | 0, 17);
      v[d >> 2] = v[b >> 2];
      t[d + 4 | 0] = w[b + 4 | 0];
      break a;

     case 19:
      b = mf(e + 8 | 0, 18);
      v[d >> 2] = v[b >> 2];
      t[d + 4 | 0] = w[b + 4 | 0];
      break a;

     case 1:
     case 3:
     case 4:
     case 6:
     case 8:
     case 9:
     case 17:
     case 18:
     case 20:
     case 21:
     case 22:
     case 23:
      break b;

     case 24:
      break d;
     }
    }
    b = mf(e + 8 | 0, 19);
    v[d >> 2] = v[b >> 2];
    t[d + 4 | 0] = w[b + 4 | 0];
    break a;
   }
   b = mf(e + 8 | 0, 20);
   v[d >> 2] = v[b >> 2];
   t[d + 4 | 0] = w[b + 4 | 0];
   break a;
  }
  if (w[d + 4 | 0]) {
   t[d + 4 | 0] = 0;
  }
 }
 eb = e + 16 | 0;
 i: {
  if (Hd(w[f + 12 | 0])) {
   if (!Hd(w[f + 12 | 0])) {
    a = cc(4);
    v[a >> 2] = 0;
    a = Cj(a);
    v[a >> 2] = 120996;
    ca(a | 0, 121032, 839);
    p();
   }
   b = eb - 32 | 0;
   eb = b;
   j: {
    k: {
     l: {
      m: {
       e = v[f + 8 >> 2];
       if (!e) {
        Tf(b + 20 | 0, c);
        c = 0;
        a = Eb(a);
        d = w[b + 31 | 0];
        e = v[b + 24 >> 2];
        v[31601] = 0;
        N(93, a | 0, xh(e, d) | 0);
        d = v[31601];
        v[31601] = 0;
        if ((d | 0) != 1) {
         while (1) {
          if (xh(v[b + 24 >> 2], w[b + 31 | 0]) >>> 0 <= c >>> 0) {
           break m;
          }
          d = w[dc(b + 20 | 0, c) | 0];
          v[31601] = 0;
          N(95, a | 0, d | 0);
          d = v[31601];
          v[31601] = 0;
          if ((d | 0) == 1) {
           break k;
          }
          c = c + 1 | 0;
          continue;
         }
        }
        break k;
       }
       d = b + 8 | 0;
       Tf(d, c);
       v[31601] = 0;
       c = b + 20 | 0;
       R(11, c | 0, e | 0, d | 0);
       e = v[31601];
       v[31601] = 0;
       n: {
        o: {
         if ((e | 0) != 1) {
          v[31601] = 0;
          N(12, a | 0, c | 0);
          a = v[31601];
          v[31601] = 0;
          if ((a | 0) == 1) {
           break o;
          }
          Tb(c);
          sb(d);
          break l;
         }
         c = M() | 0;
         break n;
        }
        c = M() | 0;
        Tb(b + 20 | 0);
       }
       sb(b + 8 | 0);
       break j;
      }
      sb(b + 20 | 0);
     }
     eb = b + 32 | 0;
     break i;
    }
    c = M() | 0;
    sb(a);
    sb(b + 20 | 0);
   }
   P(c | 0);
   p();
  }
  p0(a, 22, c);
 }
 eb = f + 16 | 0;
}

function J0(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0;
 f = eb - 48 | 0;
 eb = f;
 l = f + 29 | 0;
 m = f + 27 | 0;
 n = Mg(f + 42 | 0);
 while (1) {
  a: {
   if (y[a + 12 >> 2] > j >>> 0) {
    af(f + 32 | 0, v[a >> 2], v[v[a + 48 >> 2] + 12 >> 2], j);
    b: while (1) {
     if (!Lb(v[c >> 2], v[c + 8 >> 2], 1)) {
      break a;
     }
     e = Yd(c);
     if ((e | 0) == 255) {
      break a;
     }
     g = n;
     k = e << 24 >> 24;
     e = k & 31;
     if (e >>> 0 < x[v[v[a + 48 >> 2] + 12 >> 2] + 480188 >> 1]) {
      g = Xc(v[f + 32 >> 2], e);
     }
     d = 1;
     if (!(k & 64)) {
      e = Yd(c);
      i = e << 24 >> 24;
      d = 255;
      e = e & 127;
      c: {
       d: {
        if ((e | 0) == 1) {
         break d;
        }
        d = e - 1 | 0;
        if (b ? d >>> 0 <= 120 : 0) {
         break d;
        }
        if ((e - 109 & 255) >>> 0 < 159 | b) {
         break c;
        }
        d = e + 13 | 0;
       }
       t[g | 0] = d;
      }
      q = g, r = Yd(c), t[q + 1 | 0] = r;
      d = (i | 0) < 0;
     }
     i = g + 3 | 0;
     e = g + 5 | 0;
     while (1) {
      e: {
       f: {
        g: {
         if (d & 1) {
          u[f + 28 >> 1] = w[g + 4 | 0] | w[g + 5 | 0] << 8;
          v[f + 24 >> 2] = w[g | 0] | w[g + 1 | 0] << 8 | (w[g + 2 | 0] << 16 | w[g + 3 | 0] << 24);
          d = Yd(c);
          h = d & 63;
          o = d << 24 >> 24;
          if (d & 64) {
           t[g + 4 | 0] = h;
           t[g + 2 | 0] = 1;
           break e;
          }
          d = Yd(c);
          t[e | 0] = d;
          if (h >>> 0 <= 15) {
           Bf(g, h, d);
           h: {
            i: {
             j: {
              d = w[g + 3 | 0];
              switch (d - 9 | 0) {
              case 1:
              case 2:
              case 3:
               break f;

              case 4:
               break i;

              case 0:
               break j;

              default:
               break h;
              }
             }
             t[i | 0] = 9;
             t[e | 0] = B(w[e | 0] & 15, 17);
             break f;
            }
            t[g + 2 | 0] = 1;
            t[g + 3 | 0] = 0;
            v[f + 20 >> 2] = w[g + 5 | 0] + 1 >>> 1;
            v[f + 16 >> 2] = 64;
            q = g, r = v[Bd(f + 20 | 0, f + 16 | 0) >> 2], t[q + 4 | 0] = r;
            break f;
           }
           if ((d | 0) != 19) {
            break f;
           }
           if (w[e | 0] == 128) {
            break g;
           }
           Lr(g);
           break f;
          }
          if (h >>> 0 > 44) {
           break f;
          }
          t[i | 0] = w[h + 24592 | 0];
          k: {
           switch (h - 16 | 0) {
           case 0:
            if (d >>> 0 > 1) {
             break g;
            }
            t[e | 0] = d | 158;
            break f;

           case 1:
           case 2:
            t[f + 20 | 0] = 15;
            q = e, r = w[Pb(f + 20 | 0, e) | 0] | 224, t[q | 0] = r;
            break f;

           case 5:
           case 6:
            v[f + 20 >> 2] = 16;
            v[f + 16 >> 2] = d + 1;
            q = e, r = v[Bd(f + 20 | 0, f + 16 | 0) >> 2] / 2 | 240, t[q | 0] = r;
            break f;

           case 14:
            l: {
             m: {
              n: {
               o: {
                p: {
                 h = d >>> 4 | 0;
                 switch (h - 1 | 0) {
                 case 1:
                  break n;

                 case 0:
                  break o;

                 default:
                  break p;
                 }
                }
                switch (h - 10 | 0) {
                case 1:
                 break l;

                case 0:
                 break m;

                default:
                 break g;
                }
               }
               t[i | 0] = 2;
               t[e | 0] = d | 240;
               break f;
              }
              t[i | 0] = 3;
              t[e | 0] = d | 240;
              break f;
             }
             t[i | 0] = 11;
             t[e | 0] = (d << 3 & 120) + 8 | 15;
             break f;
            }
            t[i | 0] = 11;
            t[e | 0] = (d & 15) + 1 >>> 1 | 240;
            break f;

           case 12:
            break k;

           default:
            break f;
           }
          }
          v[f + 20 >> 2] = d + 1 >>> 1;
          v[f + 16 >> 2] = 64;
          q = e, r = v[Bd(f + 20 | 0, f + 16 | 0) >> 2], t[q | 0] = r;
          break f;
         }
         if ((k | 0) >= 0) {
          continue b;
         }
         break a;
        }
        t[i | 0] = 0;
       }
       vw(i, e, m, l);
       d = w[f + 27 | 0];
       p = qi(d);
       h = w[i | 0];
       if (p >>> 0 <= qi(h) >>> 0) {
        break e;
       }
       if (!w[g + 2 | 0]) {
        uw(f + 14 | 0, h, w[g + 5 | 0], 1);
        h = w[f + 14 | 0];
        t[g + 4 | 0] = w[f + 15 | 0];
        t[g + 2 | 0] = h;
       }
       t[i | 0] = d;
       t[e | 0] = w[f + 29 | 0];
      }
      d = (o | 0) < 0;
      continue;
     }
    }
   }
   eb = f + 48 | 0;
   return;
  }
  j = j + 1 | 0;
  continue;
 }
}

function se(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0;
 a: {
  b: {
   c: {
    switch (b | 0) {
    case 1:
     b = Eb(a);
     d = w[c + 11 | 0];
     e = v[c + 4 >> 2];
     a = 0;
     v[31601] = 0;
     N(114, b | 0, Zc(e, d) | 0);
     d = v[31601];
     v[31601] = 0;
     d: {
      if ((d | 0) != 1) {
       e: {
        while (1) {
         if (Zc(v[c + 4 >> 2], w[c + 11 | 0]) >>> 0 > a >>> 0) {
          d = v[Vd(c, a) >> 2];
          v[31601] = 0;
          N(115, b | 0, (d >>> 0 >= 128 ? 63 : d) << 24 >> 24);
          d = v[31601];
          v[31601] = 0;
          if ((d | 0) == 1) {
           break e;
          }
          a = a + 1 | 0;
          continue;
         }
         break;
        }
        break d;
       }
      }
      break a;
     }
     return;

    case 2:
     b = Eb(a);
     d = w[c + 11 | 0];
     e = v[c + 4 >> 2];
     a = 0;
     v[31601] = 0;
     N(114, b | 0, Zc(e, d) | 0);
     d = v[31601];
     v[31601] = 0;
     f: {
      if ((d | 0) != 1) {
       g: {
        while (1) {
         if (Zc(v[c + 4 >> 2], w[c + 11 | 0]) >>> 0 > a >>> 0) {
          d = v[Vd(c, a) >> 2];
          v[31601] = 0;
          N(115, b | 0, (d >>> 0 >= 256 ? 63 : d) << 24 >> 24);
          d = v[31601];
          v[31601] = 0;
          if ((d | 0) == 1) {
           break g;
          }
          a = a + 1 | 0;
          continue;
         }
         break;
        }
        break f;
       }
      }
      break a;
     }
     return;

    case 3:
     df(a, c, 48832);
     return;

    case 4:
     df(a, c, 49856);
     return;

    case 5:
     df(a, c, 50880);
     return;

    case 6:
     df(a, c, 51904);
     return;

    case 7:
     df(a, c, 52928);
     return;

    case 8:
     df(a, c, 53952);
     return;

    case 9:
     df(a, c, 54976);
     return;

    case 10:
     df(a, c, 56e3);
     return;

    case 11:
     df(a, c, 57024);
     return;

    case 12:
     df(a, c, 58048);
     return;

    case 13:
     df(a, c, 59072);
     return;

    case 14:
     df(a, c, 60096);
     return;

    case 15:
     df(a, c, 61120);
     return;

    case 16:
     df(a, c, 62144);
     return;

    case 17:
     df(a, c, 63168);
     return;

    case 18:
     df(a, c, 64192);
     return;

    case 19:
     df(a, c, 65216);
     return;

    case 20:
     df(a, c, 66240);
     return;

    case 21:
     df(a, c, 67264);
     return;

    case 22:
     df(a, c, 68288);
     return;

    case 23:
     df(a, c, 69312);
     return;

    case 24:
     Dx(a, c, 70336);
     return;

    case 25:
     Dx(a, c, 48832);
     return;

    case 26:
     Dx(a, c, 67264);
     return;

    default:
     a = cc(8);
     v[31601] = 0;
     b = O(16, a | 0, 11106) | 0;
     c = v[31601];
     v[31601] = 0;
     if ((c | 0) != 1) {
      break b;
     }
     b = M() | 0;
     jc(a);
     P(b | 0);
     p();

    case 0:
     break c;
    }
   }
   e = eb - 16 | 0;
   eb = e;
   f = Eb(a);
   h: {
    while (1) {
     i: {
      j: {
       k: {
        if (Zc(v[c + 4 >> 2], w[c + 11 | 0]) >>> 0 > g >>> 0) {
         b = v[Vd(c, g) >> 2];
         if (b >>> 0 >= 2097152) {
          v[31601] = 0;
          N(115, f | 0, 63);
          a = v[31601];
          v[31601] = 0;
          if ((a | 0) != 1) {
           break j;
          }
          break i;
         }
         a = 0;
         while (1) {
          if ((a | 0) == 6) {
           b = 7;
           a = 6;
           break k;
          }
          d = b & 63;
          t[(e + 10 | 0) + a | 0] = d;
          if (b >>> 0 >= 64) {
           a = a + 1 | 0;
           b = b >>> 6 | 0;
           continue;
          }
          break;
         }
         if (a) {
          b = a + 1 | 0;
          if ((b | 0) != 2) {
           break k;
          }
          a = 1;
          b = 2;
          if ((d | 0) != 1) {
           break k;
          }
          a = w[e + 10 | 0] | 64;
         } else {
          a = w[e + 10 | 0];
         }
         v[31601] = 0;
         N(115, f | 0, a << 24 >> 24);
         a = v[31601];
         v[31601] = 0;
         if ((a | 0) != 1) {
          break j;
         }
         break i;
        }
        eb = e + 16 | 0;
        break h;
       }
       i = (2 << a) + 255 << 7 - a;
       d = b - 1 | 0;
       j = d + (e + 10 | 0) | 0;
       a = b;
       while (1) {
        if (!a) {
         break j;
        }
        l: {
         if ((a | 0) == (b | 0)) {
          a = w[j | 0];
          v[31601] = 0;
          N(115, f | 0, (a | i) << 24 >> 24);
          h = v[31601];
          v[31601] = 0;
          a = d;
          break l;
         }
         v[31601] = 0;
         a = a - 1 | 0;
         N(115, f | 0, t[a + (e + 10 | 0) | 0] | -128);
         h = v[31601];
         v[31601] = 0;
        }
        if ((h | 0) != 1) {
         continue;
        }
        break;
       }
       break i;
      }
      g = g + 1 | 0;
      continue;
     }
     break;
    }
    a = M() | 0;
    sb(f);
    P(a | 0);
    p();
   }
   return;
  }
  ca(b | 0, 124640, 17);
  p();
 }
 a = M() | 0;
 sb(b);
 P(a | 0);
 p();
}

function kpa(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, u = 0;
 g = eb - 16 | 0;
 eb = g;
 a: {
  if (!Lb(v[a >> 2], v[a + 8 >> 2], 2)) {
   Og(c + 484344 | 0, b, 64);
   break a;
  }
  m = c + 484344 | 0;
  n = Kd(Mk(a), 1, 1024);
  if (!Og(m, b, n)) {
   break a;
  }
  p = x[c + 480188 >> 1];
  b: while (1) {
   if ((k | 0) == (n | 0)) {
    break a;
   }
   e = Vb(v[m >> 2], b);
   af(g + 8 | 0, v[e >> 2], v[v[e + 48 >> 2] + 12 >> 2], k);
   i = 0;
   while (1) if ((i | 0) == (p | 0)) {
    k = k + 1 | 0;
    continue b;
   } else {
    e = Xc(v[g + 8 >> 2], i);
    q = w[e + 5 | 0];
    l = w[e + 3 | 0];
    h = g + 4 | 0;
    jm(h, a);
    r = _e(h);
    f = Xi(h);
    j = w[g + 4 | 0];
    c: {
     if ((j - 1 & 255) >>> 0 > 35) {
      break c;
     }
     t[e | 0] = j + 48;
     o = w[Ic(h) | 0];
     h = o + 1 | 0;
     t[e + 1 | 0] = h;
     j = h;
     h = h & 255;
     if ((j | 0) != (h | 0) | h >>> 0 > x[c + 480190 >> 1]) {
      break c;
     }
     h = mi(c, h);
     j = wb(d, i);
     if (!(!w[j | 0] | x[h + 30 >> 1] > 255)) {
      t[e + 4 | 0] = 64;
      t[e + 2 | 0] = 1;
     }
     h = v[xb(h + 68 | 0, 0) >> 2];
     if (!(w[j | 0] | h ? w[j | 0] ? (h | 0) == 1 : 0 : 1)) {
      break c;
     }
     t[e + 1 | 0] = o + 101;
    }
    d: {
     e: {
      switch (w[r | 0] - 1 | 0) {
      case 0:
       if (!w[f | 0]) {
        break d;
       }
       t[e + 3 | 0] = 2;
       t[e + 5 | 0] = w[f | 0];
       break d;

      case 1:
       if (!w[f | 0]) {
        break d;
       }
       t[e + 3 | 0] = 3;
       t[e + 5 | 0] = w[f | 0];
       break d;

      case 9:
       if (!w[f | 0]) {
        break d;
       }
       t[e + 3 | 0] = 1;
       f = w[f | 0];
       s = e, u = qX(f >>> 4 | 0) << 4 | f & 15, t[s + 5 | 0] = u;
       break d;

      case 10:
       if (!w[f | 0]) {
        break d;
       }
       t[e + 3 | 0] = 1;
       f = w[f | 0];
       s = e, u = f & 240 | qX(f & 15), t[s + 5 | 0] = u;
       break d;

      case 11:
       if (!w[f | 0]) {
        break d;
       }
       t[e + 3 | 0] = 1;
       t[e + 5 | 0] = w[f | 0];
       break d;

      case 12:
       if (!w[f | 0]) {
        break d;
       }
       t[e + 3 | 0] = 39;
       t[g | 0] = 15;
       s = e, u = w[Pb(g, f) | 0] | 16, t[s + 5 | 0] = u;
       break d;

      case 29:
       if (!w[f | 0]) {
        break d;
       }
       t[e + 3 | 0] = 38;
       t[g | 0] = 15;
       s = e, u = w[Pb(g, f) | 0] | 16, t[s + 5 | 0] = u;
       break d;

      case 20:
       if (!w[f | 0]) {
        break d;
       }
       t[e + 3 | 0] = 39;
       t[g | 0] = 15;
       s = e, u = w[Pb(g, f) | 0] | 80, t[s + 5 | 0] = u;
       break d;

      case 16:
       if (!w[f | 0]) {
        break d;
       }
       t[e + 3 | 0] = 38;
       t[g | 0] = 15;
       s = e, u = w[Pb(g, f) | 0] | 80, t[s + 5 | 0] = u;
       break d;

      case 14:
       t[e + 3 | 0] = 19;
       t[e + 5 | 0] = w[f | 0] != 0;
       break d;

      case 24:
       t[e + 3 | 0] = 12;
       t[e + 5 | 0] = w[f | 0];
       break d;

      case 26:
       Vo(e);
       t[e | 0] = 255;
       break d;

      case 27:
       if (w[f | 0] > 31) {
        break d;
       }
       t[e + 3 | 0] = 16;
       t[e + 5 | 0] = w[f | 0];
       break d;

      case 30:
       break e;

      default:
       break d;
      }
     }
     h = w[f | 0];
     if (h & 15) {
      s = e, u = w[wb(d, i) | 0] ? 22 : 11, t[s + 3 | 0] = u;
      t[e + 5 | 0] = w[f | 0] & 15;
      h = w[f | 0];
     }
     f: {
      g: {
       switch (h >>> 4 | 0) {
       case 4:
        if ((h | 0) != 64) {
         break f;
        }

       case 0:
       case 1:
       case 2:
       case 3:
        if (w[wb(d, i) | 0]) {
         t[e + 3 | 0] = 21;
         t[e + 5 | 0] = w[f | 0];
         break f;
        }
        t[e + 2 | 0] = 1;
        f = w[f | 0];
        t[e + 3 | 0] = 0;
        t[e + 4 | 0] = f;
        break f;

       case 5:
        t[e + 5 | 0] = w[e + 5 | 0] << 4;
        break f;

       case 6:
        t[g | 0] = w[e + 5 | 0];
        t[g + 3 | 0] = 14;
        s = e, u = w[Pb(g, g + 3 | 0) | 0] | 240, t[s + 5 | 0] = u;
        break f;

       case 7:
        t[g | 0] = w[e + 5 | 0];
        t[g + 3 | 0] = 14;
        s = e, u = w[Pb(g, g + 3 | 0) | 0] << 4 | 15, t[s + 5 | 0] = u;
        break f;

       default:
        break g;
       }
      }
      t[e + 3 | 0] = 0;
     }
     if ((w[e + 3 | 0] - 21 & 255) >>> 0 > 1) {
      break d;
     }
     f = Xc(v[g + 8 >> 2], t[wb(d, i) | 0] + i | 0);
     uw(g, w[f + 3 | 0], w[f + 5 | 0], 1);
     if (w[g | 0]) {
      h = x[g >> 1];
      t[f + 2 | 0] = h;
      t[f + 4 | 0] = h >>> 8;
     }
     t[f + 3 | 0] = w[e + 3 | 0];
     t[f + 5 | 0] = w[e + 5 | 0];
    }
    h: {
     if (!l) {
      break h;
     }
     f = w[e + 3 | 0];
     if ((f | 0) == (l | 0)) {
      break h;
     }
     cm(g, e, f, w[e + 5 | 0], l, q);
    }
    i = i + 1 | 0;
    continue;
   }
  }
 }
 eb = g + 16 | 0;
}

function Mna(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, q = 0, r = 0, s = 0, t = 0;
 g = eb - 80 | 0;
 eb = g;
 a: {
  d = v[a + 4 >> 2];
  b: {
   if (d >>> 0 < b >>> 0) {
    q = Ld(g + 72 | 0);
    o = b - d | 0;
    c = iv(a);
    c: {
     if (!(o >>> 0 > c >>> 0 | d >>> 0 > c - o >>> 0)) {
      $q(g + 60 | 0, v[a >> 2], d);
      Yb(q, v[g + 60 >> 2], v[g + 64 >> 2]);
      v[a + 4 >> 2] = v[a + 4 >> 2] + o;
      break c;
     }
     m = So(g + 60 | 0);
     v[31601] = 0;
     b = O(758, a | 0, b | 0) | 0;
     d = v[31601];
     v[31601] = 0;
     if ((d | 0) == 1) {
      break a;
     }
     v[31601] = 0;
     N(759, m | 0, b | 0);
     b = v[31601];
     v[31601] = 0;
     if ((b | 0) == 1) {
      break a;
     }
     v[m + 4 >> 2] = v[a + 4 >> 2] + o;
     ln(g + 44 | 0, v[a >> 2]);
     $q(g + 32 | 0, v[a >> 2], v[a + 4 >> 2]);
     ln(g + 24 | 0, v[m >> 2]);
     b = v[g + 48 >> 2];
     v[g + 8 >> 2] = v[g + 44 >> 2];
     v[g + 12 >> 2] = b;
     d = g + 52 | 0;
     b = v[g + 32 >> 2];
     c = v[g + 36 >> 2];
     f = v[g + 24 >> 2];
     r = eb - 16 | 0;
     eb = r;
     h = v[g + 8 >> 2];
     e = v[g + 28 >> 2];
     i = v[g + 12 >> 2];
     d: {
      if ((e | 0) == (i | 0)) {
       f = Yb(r + 8 | 0, f, e);
       k = eb - 16 | 0;
       eb = k;
       b = hv(b, c, h, e);
       v[k + 12 >> 2] = b;
       c = v[f >> 2];
       e: {
        if ((b | 0) <= 0) {
         break e;
        }
        if (e) {
         i = 32 - e | 0;
         v[k + 8 >> 2] = i;
         j = b;
         b = v[Bd(k + 8 | 0, k + 12 | 0) >> 2];
         v[k + 12 >> 2] = j - b;
         e = -1 << e & -1 >>> i - b;
         v[c >> 2] = v[c >> 2] & (e ^ -1) | e & v[h >> 2];
         b = b + v[f + 4 >> 2] | 0;
         v[f + 4 >> 2] = b & 31;
         c = (b >>> 3 & 536870908) + c | 0;
         v[f >> 2] = c;
         h = h + 4 | 0;
         b = v[k + 12 >> 2];
        }
        e = (b | 0) / 32 | 0;
        WY(h, e, c);
        b = b - (e << 5) | 0;
        v[k + 12 >> 2] = b;
        e = e << 2;
        c = e + v[f >> 2] | 0;
        v[f >> 2] = c;
        if ((b | 0) <= 0) {
         break e;
        }
        b = -1 >>> 32 - b | 0;
        v[c >> 2] = v[c >> 2] & (b ^ -1) | b & v[e + h >> 2];
        v[f + 4 >> 2] = v[k + 12 >> 2];
       }
       Yb(d, c, v[f + 4 >> 2]);
       eb = k + 16 | 0;
       break d;
      }
      k = d;
      e = Yb(r, f, e);
      f = eb - 16 | 0;
      eb = f;
      c = hv(b, c, h, i);
      v[f + 12 >> 2] = c;
      f: {
       if ((c | 0) <= 0) {
        b = v[e + 4 >> 2];
        d = v[e >> 2];
        break f;
       }
       g: {
        if (!i) {
         b = v[e + 4 >> 2];
         break g;
        }
        l = 32 - i | 0;
        v[f + 8 >> 2] = l;
        b = c;
        c = f + 8 | 0;
        d = v[Bd(c, f + 12 | 0) >> 2];
        v[f + 12 >> 2] = b - d;
        b = v[e + 4 >> 2];
        n = v[h >> 2];
        v[f + 8 >> 2] = d;
        s = 32 - b | 0;
        v[f + 4 >> 2] = s;
        j = v[e >> 2];
        t = v[j >> 2];
        c = v[Gb(c, f + 4 | 0) >> 2];
        l = n & (-1 << i & -1 >>> l - d);
        v[j >> 2] = (-1 << b & -1 >>> s - c ^ -1) & t | (b >>> 0 > i >>> 0 ? l << b - i : l >>> i - b | 0);
        n = b + c | 0;
        b = n & 31;
        v[e + 4 >> 2] = b;
        j = j + (n >>> 3 & 536870908) | 0;
        v[e >> 2] = j;
        d = d - c | 0;
        if ((d | 0) > 0) {
         v[j >> 2] = v[j >> 2] & (-1 >>> 32 - d ^ -1) | l >>> c + i;
         v[e + 4 >> 2] = d;
         b = d;
        }
        h = h + 4 | 0;
        c = v[f + 12 >> 2];
       }
       i = 32 - b | 0;
       j = -1 << b;
       l = j ^ -1;
       while (1) {
        if ((c | 0) >= 32) {
         d = v[e >> 2];
         c = v[h >> 2];
         v[d >> 2] = l & v[d >> 2] | c << b;
         v[e >> 2] = d + 4;
         v[d + 4 >> 2] = j & v[d + 4 >> 2] | c >>> i;
         c = v[f + 12 >> 2] - 32 | 0;
         v[f + 12 >> 2] = c;
         h = h + 4 | 0;
         continue;
        }
        break;
       }
       d = v[e >> 2];
       if ((c | 0) <= 0) {
        break f;
       }
       l = v[h >> 2];
       v[f + 8 >> 2] = i;
       n = v[d >> 2];
       h = v[Bd(f + 12 | 0, f + 8 | 0) >> 2];
       j = n & (j & -1 >>> i - h ^ -1);
       i = l & -1 >>> 32 - c;
       v[d >> 2] = j | i << b;
       c = b + h | 0;
       b = c & 31;
       v[e + 4 >> 2] = b;
       d = (c >>> 3 & 536870908) + d | 0;
       v[e >> 2] = d;
       c = v[f + 12 >> 2] - h | 0;
       v[f + 12 >> 2] = c;
       if ((c | 0) <= 0) {
        break f;
       }
       v[d >> 2] = v[d >> 2] & (-1 >>> 32 - c ^ -1) | i >>> h;
       b = v[f + 12 >> 2];
       v[e + 4 >> 2] = b;
      }
      Yb(k, d, b);
      eb = f + 16 | 0;
     }
     eb = r + 16 | 0;
     Yb(q, v[g + 52 >> 2], v[g + 56 >> 2]);
     mC(a, m);
     tf(m);
    }
    a = Yb(g + 16 | 0, v[q >> 2], v[q + 4 >> 2]);
    Vw(v[a >> 2], v[a + 4 >> 2], o, 0);
    break b;
   }
   v[a + 4 >> 2] = b;
  }
  eb = g + 80 | 0;
  return;
 }
 a = M() | 0;
 tf(m);
 P(a | 0);
 p();
}

function ika(a) {
 a = a | 0;
 var b = 0, c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, q = 0, r = 0, s = 0;
 v[a + 24588 >> 2] = 0;
 v[a + 24592 >> 2] = 0;
 v[a + 8 >> 2] = 41936;
 v[a + 4 >> 2] = 0;
 v[a >> 2] = 30480;
 b = a + 24596 | 0;
 v[b >> 2] = 0;
 v[b + 4 >> 2] = 0;
 Tq(a + 24604 | 0);
 qS(a + 24648 | 0, 0);
 v[a + 397448 >> 2] = 0;
 v[a + 397452 >> 2] = 0;
 b = a + 397456 | 0;
 v[b >> 2] = 8;
 v[b + 4 >> 2] = 0;
 v[b + 16 >> 2] = 0;
 v[b + 20 >> 2] = 0;
 t[b + 12 | 0] = 0;
 v[b + 8 >> 2] = 0;
 u[b + 24 >> 1] = 0;
 Qb(b + 28 | 0, 0, 40);
 Qb(b + 68 | 0, 0, 49824);
 Qb(b + 49892 | 0, 0, 32832);
 t[a + 480224 | 0] = 0;
 u[a + 480212 >> 1] = 0;
 v[a + 480204 >> 2] = 0;
 v[a + 480208 >> 2] = 0;
 v[a + 480180 >> 2] = 0;
 v[a + 480184 >> 2] = 0;
 b = a + 480186 | 0;
 u[b >> 1] = 0;
 u[b + 2 >> 1] = 0;
 u[b + 4 >> 1] = 0;
 u[b + 6 >> 1] = 0;
 v[a + 480240 >> 2] = 65536;
 v[a + 480244 >> 2] = 65536;
 f = Mb(a + 480248 | 0);
 v[a + 480272 >> 2] = 0;
 c = 480280;
 while (1) {
  b = a + c | 0;
  t[b + 8 | 0] = 0;
  v[b >> 2] = 0;
  v[b + 4 >> 2] = 4194432;
  kF(b + 9 | 0);
  c = c + 32 | 0;
  if ((c | 0) != 484344) {
   continue;
  }
  break;
 }
 d = Mb(a + 484344 | 0);
 v[d + 12 >> 2] = a;
 v[31601] = 0;
 g = O(847, a + 484360 | 0, a | 0) | 0;
 b = v[31601];
 v[31601] = 0;
 a: {
  b: {
   c: {
    d: {
     e: {
      f: {
       g: {
        h: {
         i: {
          if ((b | 0) != 1) {
           c = 484380;
           while (1) {
            v[31601] = 0;
            Q(708, a + c | 0) | 0;
            b = v[31601];
            v[31601] = 0;
            if ((b | 0) == 1) {
             break i;
            }
            c = c + 104 | 0;
            if ((c | 0) != 900380) {
             continue;
            }
            break;
           }
           v[31601] = 0;
           Q(848, a + 901404 | 0) | 0;
           b = v[31601];
           v[31601] = 0;
           if ((b | 0) == 1) {
            break h;
           }
           e = a + 906300 | 0;
           c = 0;
           while (1) {
            kS(c + e | 0);
            c = c + 160 | 0;
            if ((c | 0) != 4e4) {
             continue;
            }
            break;
           }
           v[a + 946300 >> 2] = 0;
           c = 946304;
           while (1) {
            fv(a + c | 0);
            c = c + 32 | 0;
            if ((c | 0) != 1074304) {
             continue;
            }
            break;
           }
           v[a + 1074304 >> 2] = 0;
           v[a + 1074308 >> 2] = 0;
           ds(a + 1074312 | 0);
           v[31601] = 0;
           W(849);
           b = v[31601];
           v[31601] = 0;
           if ((b | 0) == 1) {
            break g;
           }
           r = a, s = jS(), v[r + 1074328 >> 2] = s;
           b = a + 1074332 | 0;
           v[b + 12 >> 2] = 1065353216;
           aS(b, 4);
           v[31601] = 0;
           c = Q(850, a + 1074376 | 0) | 0;
           b = v[31601];
           v[31601] = 0;
           if ((b | 0) == 1) {
            break g;
           }
           v[31601] = 0;
           h = T(603, a + 1298264 | 0, a | 0, 255) | 0;
           b = v[31601];
           v[31601] = 0;
           if ((b | 0) == 1) {
            break f;
           }
           i = sc(a + 1298300 | 0);
           j = sc(a + 1298304 | 0);
           k = Eb(a + 1298308 | 0);
           l = Eb(a + 1298320 | 0);
           m = Eb(a + 1298332 | 0);
           n = pS(a + 1298344 | 0);
           o = Mb(a + 1298412 | 0);
           t[a + 1298424 | 0] = 0;
           b = a + 1298432 | 0;
           v[b >> 2] = 0;
           v[b + 4 >> 2] = 0;
           v[b + 32 >> 2] = 0;
           v[b + 36 >> 2] = 1072693248;
           v[b + 24 >> 2] = 0;
           v[b + 28 >> 2] = 0;
           v[b + 16 >> 2] = 0;
           v[b + 20 >> 2] = 0;
           v[b + 8 >> 2] = 0;
           v[b + 12 >> 2] = 0;
           v[a + 1298472 >> 2] = 0;
           Dq(a + 12 | 0);
           WA(a + 8204 | 0);
           WA(a + 12300 | 0);
           v[a + 1074408 >> 2] = 4;
           v[a + 1074412 >> 2] = 16;
           v[a + 480216 >> 2] = 4;
           v[a + 480220 >> 2] = 16;
           Qb(a + 900380 | 0, 0, 1024);
           iS(a + 946304 | 0);
           v[31601] = 0;
           b = Q(851, 12) | 0;
           q = v[31601];
           v[31601] = 0;
           if ((q | 0) == 1) {
            break e;
           }
           v[b >> 2] = 0;
           v[b + 4 >> 2] = 0;
           v[b + 8 >> 2] = 0;
           r = a, s = Mb(b), v[r + 4 >> 2] = s;
           return a | 0;
          }
          a = M() | 0;
          break a;
         }
         a = M() | 0;
         break b;
        }
        a = M() | 0;
        break b;
       }
       a = M() | 0;
       break c;
      }
      a = M() | 0;
      break d;
     }
     a = M() | 0;
     oS(o);
     ZA(n);
     sb(m);
     sb(l);
     sb(k);
     YA(j);
     XA(i);
     Su(h);
    }
    lB(c);
   }
   nS(e);
  }
  aC(g);
 }
 fS(d);
 uc(f);
 P(a | 0);
 p();
}

function vja(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
 h = eb - 16 | 0;
 eb = h;
 f = v[a + 8 >> 2];
 e = v[a >> 2];
 v[31601] = 0;
 f = O(621, e | 0, f | 0) | 0;
 e = v[31601];
 v[31601] = 0;
 a: {
  b: {
   if ((e | 0) != 1) {
    if (f) {
     break b;
    }
    v[31601] = 0;
    f = Q(197, a | 0) | 0;
    e = v[31601];
    v[31601] = 0;
    c: {
     if ((e | 0) == 1) {
      break c;
     }
     v[31601] = 0;
     j = d + 484344 | 0;
     k = Kd(f + 1 | 0, 1, 1024);
     f = T(196, j | 0, b | 0, k | 0) | 0;
     e = v[31601];
     v[31601] = 0;
     if ((e | 0) == 1) {
      break c;
     }
     if (!f) {
      break b;
     }
     d = x[d + 480188 >> 1];
     if (!d) {
      break b;
     }
     l = d - 1 | 0;
     d = 0;
     while (1) {
      if (d >>> 0 >= k >>> 0) {
       break b;
      }
      f = v[a + 8 >> 2];
      e = v[a >> 2];
      v[31601] = 0;
      f = T(150, e | 0, f | 0, 1) | 0;
      e = v[31601];
      v[31601] = 0;
      d: {
       if ((e | 0) != 1) {
        if (!f) {
         break b;
        }
        v[31601] = 0;
        i = Q(197, a | 0) | 0;
        e = v[31601];
        v[31601] = 0;
        if ((e | 0) == 1) {
         break a;
        }
        if (i) {
         break d;
        }
        d = d + 1 | 0;
        continue;
       }
       break a;
      }
      e = v[j >> 2];
      u[h + 14 >> 1] = i & 31;
      u[h + 12 >> 1] = l;
      e = Vb(e, b);
      e = ld(v[e >> 2], v[v[e + 48 >> 2] + 12 >> 2], d, x[Nc(h + 14 | 0, h + 12 | 0) >> 1]);
      if (i >>> 0 < 32) {
       continue;
      }
      e: {
       if (i << 24 >> 24 >= 0) {
        break e;
       }
       v[31601] = 0;
       g = Q(197, a | 0) | 0;
       f = v[31601];
       v[31601] = 0;
       if ((f | 0) == 1) {
        break a;
       }
       t[e + 5 | 0] = g;
       v[31601] = 0;
       g = Q(197, a | 0) | 0;
       f = v[31601];
       v[31601] = 0;
       f: {
        g: {
         if ((f | 0) != 1) {
          if (g >>> 0 < 26) {
           break g;
          }
          break f;
         }
         break a;
        }
        f = w[g + 41056 | 0];
        t[e + 3 | 0] = f;
        h: {
         switch (f - 1 | 0) {
         case 0:
          if (!w[e + 5 | 0]) {
           break f;
          }
          break e;

         case 12:
          if (w[e + 2 | 0]) {
           break e;
          }
          t[e + 2 | 0] = 1;
          f = w[e + 5 | 0];
          t[e + 5 | 0] = 0;
          t[e + 3 | 0] = 0;
          m = e, n = Kd(f, 0, 64), t[m + 4 | 0] = n;
          break e;

         case 5:
         case 6:
         case 10:
         case 23:
         case 28:
          f = w[e + 5 | 0] & 240;
          if (!f) {
           break e;
          }
          t[e + 5 | 0] = f;
          break e;

         case 8:
          f = w[e + 5 | 0];
          if (f >>> 0 <= 128) {
           m = e, n = Dh(f << 1), t[m + 5 | 0] = n;
           break e;
          }
          if ((f | 0) != 164) {
           break e;
          }
          t[e + 5 | 0] = 145;
          t[e + 3 | 0] = 20;
          break e;

         case 13:
          f = w[e + 5 | 0];
          t[e + 5 | 0] = B(f >>> 4 | 0, 10) + (f & 15);
          break e;

         case 18:
          Lr(e);
          break e;

         case 16:
          if (w[e + 5 | 0] > 31) {
           break e;
          }
          t[e + 3 | 0] = 16;
          break e;

         case 27:
          break h;

         default:
          break e;
         }
        }
        g = w[e + 5 | 0];
        f = g & 240;
        i: {
         if ((f | 0) == 16) {
          f = 2;
         } else {
          if ((f | 0) != 32) {
           break i;
          }
          f = 3;
         }
         t[e + 3 | 0] = f;
        }
        t[e + 5 | 0] = g & 15 | 224;
        break e;
       }
       t[e + 3 | 0] = 0;
      }
      j: {
       k: {
        if (!(i & 64)) {
         break k;
        }
        v[31601] = 0;
        g = h + 10 | 0;
        N(198, g | 0, a | 0);
        f = v[31601];
        v[31601] = 0;
        if ((f | 0) == 1) {
         break j;
        }
        t[e + 1 | 0] = w[h + 10 | 0];
        g = w[Ic(g) | 0];
        t[e | 0] = g;
        f = 255;
        if ((g | 0) != 128) {
         f = 253;
         if (g >>> 0 < 129) {
          break k;
         }
        }
        t[e | 0] = f;
       }
       if (!(i & 32)) {
        continue;
       }
       t[e + 2 | 0] = 1;
       v[31601] = 0;
       g = Q(197, a | 0) | 0;
       f = v[31601];
       v[31601] = 0;
       if ((f | 0) == 1) {
        break a;
       }
       t[e + 4 | 0] = g;
       if (!c) {
        continue;
       }
       t[e + 4 | 0] = (g << 6 >>> 0) / 127;
       continue;
      }
      break;
     }
     break a;
    }
    break a;
   }
   break a;
  }
  tb(a);
  eb = h + 16 | 0;
  return;
 }
 b = M() | 0;
 tb(a);
 P(b | 0);
 p();
}

function $ca(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, q = 0, r = 0, s = 0, u = 0;
 m = eb - 32 | 0;
 eb = m;
 j = rf(m + 20 | 0, 1, 0);
 a: {
  b: {
   while (1) {
    e = Jb(j);
    i = e + Cb(v[j + 4 >> 2], w[j + 11 | 0]) | 0;
    g = v[b >> 2];
    d = v[b + 4 >> 2];
    if (!((d | 0) >= 0 | (d | 0) > 0 | (e | 0) == (i | 0))) {
     t[e | 0] = 45;
     e = e + 1 | 0;
     g = TN(g, d);
     d = gb;
    }
    k = m + 12 | 0;
    c: {
     d: {
      switch (Dua(c - 2 | 0, 31) | 0) {
      case 4:
       LN(k, e, i, g, d);
       break c;

      case 0:
       f = 64 - fu(g | 1, d) | 0;
       if ((f | 0) <= (i - e | 0)) {
        i = e + f | 0;
        e = i;
        while (1) {
         if (!d & g >>> 0 < 17) {
          while (1) {
           e = e - 1 | 0;
           t[e | 0] = w[(g & 1) + 15472 | 0];
           h = !d & g >>> 0 > 1 | (d | 0) != 0;
           f = d;
           d = d >>> 1 | 0;
           g = (f & 1) << 31 | g >>> 1;
           if (h) {
            continue;
           }
           break;
          }
         } else {
          e = e - 4 | 0;
          Zm((g << 2 & 60) + 78528 | 0, 4, e);
          f = d;
          d = d >>> 4 | 0;
          g = (f & 15) << 28 | g >>> 4;
          continue;
         }
         break;
        }
        f = 0;
       } else {
        f = 61;
       }
       v[k + 4 >> 2] = f;
       v[k >> 2] = i;
       break c;

      case 3:
       f = (66 - fu(g | 1, d) >>> 0) / 3 | 0;
       if ((f | 0) <= (i - e | 0)) {
        i = e + f | 0;
        e = i;
        while (1) {
         if (!d & g >>> 0 < 65) {
          while (1) {
           e = e - 1 | 0;
           t[e | 0] = w[(g & 7) + 14751 | 0];
           h = !d & g >>> 0 > 7 | (d | 0) != 0;
           f = d;
           d = d >>> 3 | 0;
           g = (f & 7) << 29 | g >>> 3;
           if (h) {
            continue;
           }
           break;
          }
         } else {
          e = e - 2 | 0;
          Zm((g << 1 & 126) + 78592 | 0, 2, e);
          f = d;
          d = d >>> 6 | 0;
          g = (f & 63) << 26 | g >>> 6;
          continue;
         }
         break;
        }
        f = 0;
       } else {
        f = 61;
       }
       v[k + 4 >> 2] = f;
       v[k >> 2] = i;
       break c;

      case 7:
       f = 67 - fu(g | 1, d) >>> 2 | 0;
       if ((f | 0) <= (i - e | 0)) {
        i = e + f | 0;
        e = i;
        while (1) {
         if (!d & g >>> 0 < 257) {
          while (1) {
           e = e - 1 | 0;
           t[e | 0] = w[(g & 15) + 11165 | 0];
           h = !d & g >>> 0 > 15 | (d | 0) != 0;
           f = d;
           d = d >>> 4 | 0;
           g = (f & 15) << 28 | g >>> 4;
           if (h) {
            continue;
           }
           break;
          }
         } else {
          e = e - 2 | 0;
          Zm((g << 1 & 510) + 78720 | 0, 2, e);
          f = d;
          d = d >>> 8 | 0;
          g = (f & 255) << 24 | g >>> 8;
          continue;
         }
         break;
        }
        f = 0;
       } else {
        f = 61;
       }
       v[k + 4 >> 2] = f;
       v[k >> 2] = i;
       break c;

      default:
       break d;
      }
     }
     f = g;
     h = d;
     n = B(c, c);
     q = B(n, c);
     r = B(n, n);
     o = 0;
     e: {
      while (1) {
       l = o | 1;
       if (!h & c >>> 0 > f >>> 0) {
        break e;
       }
       l = o | 2;
       if (!h & f >>> 0 < n >>> 0) {
        break e;
       }
       l = o | 3;
       if (!h & f >>> 0 < q >>> 0) {
        break e;
       }
       if (!h & f >>> 0 < r >>> 0) {
        l = o + 4 | 0;
       } else {
        o = o + 4 | 0;
        f = Cua(f, h, r, 0);
        h = gb;
        continue;
       }
       break;
      }
     }
     h = l;
     if ((h | 0) > (i - e | 0)) {
      v[k + 4 >> 2] = 61;
      v[k >> 2] = i;
      break c;
     }
     q = e + h | 0;
     e = q;
     while (1) {
      e = e - 1 | 0;
      h = Cua(g, d, c, 0);
      f = gb;
      s = e, u = w[(g - Aua(h, f, c, 0) | 0) + 4895 | 0], t[s | 0] = u;
      n = !d & c >>> 0 <= g >>> 0 | (d | 0) != 0;
      g = h;
      d = f;
      if (n) {
       continue;
      }
      break;
     }
     v[k + 4 >> 2] = 0;
     v[k >> 2] = q;
    }
    if (!v[m + 16 >> 2]) {
     break b;
    }
    d = ji(Cb(v[j + 4 >> 2], w[j + 11 | 0]));
    v[31601] = 0;
    N(45, j | 0, d | 0);
    d = v[31601];
    v[31601] = 0;
    if ((d | 0) != 1) {
     continue;
    }
    break;
   }
   break a;
  }
  c = v[m + 12 >> 2];
  b = Jb(j);
  v[31601] = 0;
  N(46, j | 0, c - b | 0);
  b = v[31601];
  v[31601] = 0;
  f: {
   if ((b | 0) != 1) {
    v[31601] = 0;
    N(47, a | 0, j | 0);
    a = v[31601];
    v[31601] = 0;
    if ((a | 0) != 1) {
     break f;
    }
    break a;
   }
   break a;
  }
  sb(j);
  eb = m + 32 | 0;
  return;
 }
 a = M() | 0;
 sb(j);
 P(a | 0);
 p();
}

function jP(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0;
 d = eb - 192 | 0;
 eb = d;
 f = v[b + 4 >> 2];
 a: {
  if (!f) {
   break a;
  }
  e = v[b >> 2];
  g = w[xl(e, f) | 0];
  if ((g | 0) == 33) {
   c = 1;
  } else {
   if ((g | 0) != 63) {
    break a;
   }
   c = 0;
  }
  Kl(d + 168 | 0, e, f, f - 1 | 0);
  f = v[d + 172 >> 2];
  e = v[d + 168 >> 2];
  v[b >> 2] = e;
  v[b + 4 >> 2] = f;
 }
 e = d + 168 | 0;
 he(e);
 g = v[d + 168 >> 2];
 he(d + 156 | 0);
 g = wl(g, v[d + 160 >> 2], b);
 he(e);
 b: {
  c: {
   d: {
    e: {
     if ((g | 0) == v[d + 172 >> 2]) {
      a = v[b >> 2];
      g = oc(d + 184 | 0, 22256);
      h = v[g + 4 >> 2];
      v[d >> 2] = v[g >> 2];
      v[d + 4 >> 2] = h;
      if (Hc(a, f, d)) {
       a = cc(8);
       v[31601] = 0;
       c = O(36, e | 0, 10482) | 0;
       b = v[31601];
       v[31601] = 0;
       if ((b | 0) == 1) {
        break d;
       }
       rc(a, c);
       v[31601] = 0;
       R(97, a | 0, 48396, 999);
       a = v[31601];
       v[31601] = 0;
       if ((a | 0) != 1) {
        break b;
       }
       b = M() | 0;
       sb(c);
       break c;
      }
      e = 0;
      if (!c) {
       break e;
      }
      a = cc(8);
      c = v[b + 4 >> 2];
      b = v[b >> 2];
      v[31601] = 0;
      f = _h(d + 156 | 0, b, c);
      b = v[31601];
      v[31601] = 0;
      f: {
       g: {
        h: {
         if ((b | 0) != 1) {
          v[31601] = 0;
          e = d + 168 | 0;
          R(1010, e | 0, 18271, f | 0);
          b = v[31601];
          v[31601] = 0;
          if ((b | 0) == 1) {
           break h;
          }
          rc(a, e);
          c = 0;
          v[31601] = 0;
          R(97, a | 0, 48396, 999);
          b = v[31601];
          v[31601] = 0;
          if ((b | 0) != 1) {
           break b;
          }
          b = M() | 0;
          sb(e);
          break g;
         }
         b = M() | 0;
         break f;
        }
        b = M() | 0;
        c = 1;
       }
       sb(f);
       if (!c) {
        break c;
       }
      }
      jc(a);
      break c;
     }
     if (v[g + 4 >> 2]) {
      a = cc(8);
      v[31601] = 0;
      c = O(36, d + 168 | 0, 11584) | 0;
      b = v[31601];
      v[31601] = 0;
      if ((b | 0) != 1) {
       rc(a, c);
       v[31601] = 0;
       R(97, a | 0, 48396, 999);
       a = v[31601];
       v[31601] = 0;
       if ((a | 0) != 1) {
        break b;
       }
       b = M() | 0;
       sb(c);
       break c;
      }
      b = M() | 0;
      jc(a);
      break c;
     }
     b = v[b >> 2];
     c = oc(d + 148 | 0, 22256);
     e = v[c + 4 >> 2];
     v[d + 72 >> 2] = v[c >> 2];
     v[d + 76 >> 2] = e;
     if (Hc(b, f, d + 72 | 0)) {
      a = cc(8);
      v[31601] = 0;
      c = O(36, d + 168 | 0, 10482) | 0;
      b = v[31601];
      v[31601] = 0;
      if ((b | 0) != 1) {
       rc(a, c);
       v[31601] = 0;
       R(97, a | 0, 48396, 999);
       a = v[31601];
       v[31601] = 0;
       if ((a | 0) != 1) {
        break b;
       }
       b = M() | 0;
       sb(c);
       break c;
      }
      b = M() | 0;
      jc(a);
      break c;
     }
     c = oc(d + 140 | 0, 7462);
     e = v[c + 4 >> 2];
     v[d + 64 >> 2] = v[c >> 2];
     v[d + 68 >> 2] = e;
     i: {
      if (!Hc(b, f, d - -64 | 0)) {
       c = oc(d + 132 | 0, 7444);
       e = v[c + 4 >> 2];
       v[d + 56 >> 2] = v[c >> 2];
       v[d + 60 >> 2] = e;
       if (!Hc(b, f, d + 56 | 0)) {
        break i;
       }
      }
      e = w[a + 60 | 0] != 0;
      break e;
     }
     c = oc(d + 124 | 0, 6989);
     e = v[c + 4 >> 2];
     v[d + 48 >> 2] = v[c >> 2];
     v[d + 52 >> 2] = e;
     j: {
      if (!Hc(b, f, d + 48 | 0)) {
       c = oc(d + 116 | 0, 6970);
       e = v[c + 4 >> 2];
       v[d + 40 >> 2] = v[c >> 2];
       v[d + 44 >> 2] = e;
       if (!Hc(b, f, d + 40 | 0)) {
        break j;
       }
      }
      e = w[a + 61 | 0] != 0;
      break e;
     }
     c = oc(d + 108 | 0, 7073);
     e = v[c + 4 >> 2];
     v[d + 32 >> 2] = v[c >> 2];
     v[d + 36 >> 2] = e;
     if (Hc(b, f, d + 32 | 0)) {
      e = w[a + 62 | 0] != 0;
      break e;
     }
     c = oc(d + 100 | 0, 6064);
     e = v[c + 4 >> 2];
     v[d + 24 >> 2] = v[c >> 2];
     v[d + 28 >> 2] = e;
     if (Hc(b, f, d + 24 | 0)) {
      e = w[a + 63 | 0] != 0;
      break e;
     }
     c = oc(d + 92 | 0, 7511);
     e = v[c + 4 >> 2];
     v[d + 16 >> 2] = v[c >> 2];
     v[d + 20 >> 2] = e;
     if (Hc(b, f, d + 16 | 0)) {
      e = w[a + 64 | 0] != 0;
      break e;
     }
     c = oc(d + 84 | 0, 13509);
     e = v[c + 4 >> 2];
     v[d + 8 >> 2] = v[c >> 2];
     v[d + 12 >> 2] = e;
     e = 0;
     if (!Hc(b, f, d + 8 | 0)) {
      break e;
     }
     e = v[v[a + 24 >> 2] + 24668 >> 2] != 0;
    }
    eb = d + 192 | 0;
    return e | 0;
   }
   b = M() | 0;
   jc(a);
  }
  P(b | 0);
 }
 p();
}

function ila(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0;
 j = eb - 16 | 0;
 eb = j;
 c = Hf(a, c);
 $d(j, v[a + 36 >> 2]);
 a: {
  if (!c) {
   Pc(j, a + 32 | 0, 5);
   f = 0;
   if (Fb(v[v[j >> 2] >> 2], v[j + 4 >> 2])) {
    break a;
   }
  }
  f = eb - 240 | 0;
  eb = f;
  h = Im(f + 128 | 0, v[a + 36 >> 2]);
  v[31601] = 0;
  g = O(461, f + 116 | 0, 26136) | 0;
  e = v[31601];
  v[31601] = 0;
  b: {
   c: {
    d: {
     e: {
      if ((e | 0) != 1) {
       v[31601] = 0;
       v[f + 96 >> 2] = 19989505;
       v[f + 100 >> 2] = 0;
       R(462, h | 0, g | 0, f + 96 | 0);
       e = v[31601];
       v[31601] = 0;
       if ((e | 0) == 1) {
        break e;
       }
       Db(g);
       if (!ol(w[h | 0])) {
        break d;
       }
       break b;
      }
      a = M() | 0;
      break c;
     }
     a = M() | 0;
     Db(g);
     break c;
    }
    t[f + 115 | 0] = 0;
    v[31601] = 0;
    g = O(461, f + 96 | 0, 5505) | 0;
    e = v[31601];
    v[31601] = 0;
    f: {
     g: {
      h: {
       i: {
        j: {
         k: {
          l: {
           m: {
            n: {
             o: {
              p: {
               if ((e | 0) != 1) {
                v[31601] = 0;
                R(463, h | 0, f + 115 | 0, g | 0);
                e = v[31601];
                v[31601] = 0;
                if ((e | 0) == 1) {
                 break p;
                }
                Db(g);
                g = Eb(f + 84 | 0);
                v[31601] = 0;
                e = O(461, f + 72 | 0, 10094) | 0;
                i = v[31601];
                v[31601] = 0;
                if ((i | 0) == 1) {
                 break o;
                }
                v[31601] = 0;
                R(785, h | 0, g | 0, e | 0);
                i = v[31601];
                v[31601] = 0;
                if ((i | 0) == 1) {
                 break n;
                }
                Db(e);
                v[31601] = 0;
                e = f + 60 | 0;
                R(258, e | 0, (w[f + 115 | 0] ? 0 : d) | 0, g | 0);
                d = v[31601];
                v[31601] = 0;
                if ((d | 0) == 1) {
                 break m;
                }
                pp(b, e);
                sb(e);
                u[f + 58 >> 1] = 0;
                v[31601] = 0;
                d = O(461, f + 44 | 0, 10783) | 0;
                e = v[31601];
                v[31601] = 0;
                if ((e | 0) == 1) {
                 break g;
                }
                v[31601] = 0;
                e = f + 58 | 0;
                T(491, h | 0, e | 0, d | 0) | 0;
                i = v[31601];
                v[31601] = 0;
                if ((i | 0) == 1) {
                 break l;
                }
                Db(d);
                Gf(e, 4e3);
                v[31601] = 0;
                d = O(461, f + 32 | 0, 13541) | 0;
                e = v[31601];
                v[31601] = 0;
                if ((e | 0) == 1) {
                 break k;
                }
                i = x[f + 58 >> 1];
                e = v[ub(f + 28 | 0, i) >> 2];
                v[31601] = 0;
                U(786, h | 0, b | 0, d | 0, e | 0);
                e = v[31601];
                v[31601] = 0;
                if ((e | 0) == 1) {
                 break j;
                }
                Db(d);
                u[f + 26 >> 1] = 65535;
                v[31601] = 0;
                d = O(461, f + 12 | 0, 8964) | 0;
                e = v[31601];
                v[31601] = 0;
                if ((e | 0) == 1) {
                 break i;
                }
                v[31601] = 0;
                k = T(491, h | 0, f + 26 | 0, d | 0) | 0;
                e = v[31601];
                v[31601] = 0;
                if ((e | 0) == 1) {
                 break h;
                }
                e = x[f + 26 >> 1];
                Db(d);
                if (e >>> 0 < i >>> 0 & k) {
                 $e(b, e);
                }
                sb(g);
                break b;
               }
               a = M() | 0;
               break c;
              }
              a = M() | 0;
              Db(g);
              break c;
             }
             a = M() | 0;
             break f;
            }
            a = M() | 0;
            Db(e);
            break f;
           }
           a = M() | 0;
           break f;
          }
          a = M() | 0;
          Db(d);
          break f;
         }
         a = M() | 0;
         break f;
        }
        a = M() | 0;
        Db(d);
        break f;
       }
       a = M() | 0;
       break f;
      }
      a = M() | 0;
      Db(d);
      break f;
     }
     a = M() | 0;
    }
    sb(g);
   }
   Bh(h);
   P(a | 0);
   p();
  }
  Bh(h);
  eb = f + 240 | 0;
  f = c;
 }
 ef(a, f);
 eb = j + 16 | 0;
}

function raa(a, b, c) {
 a = a | 0;
 b = +b;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0;
 d = eb - 160 | 0;
 eb = d;
 v[d + 156 >> 2] = c;
 a: {
  b: {
   if (b >= .8) {
    v[31601] = 0;
    c = ba(1193) | 0;
    e = v[31601];
    v[31601] = 0;
    c: {
     d: {
      e: {
       if ((e | 0) != 1) {
        v[d + 72 >> 2] = c;
        v[31601] = 0;
        e = Q(1194, v[d + 156 >> 2]) | 0;
        f = v[31601];
        v[31601] = 0;
        if ((f | 0) == 1) {
         break d;
        }
        v[d + 152 >> 2] = e;
        uo(c, e);
        a = Ge(d + 132 | 0, a);
        v[31601] = 0;
        e = v[a + 12 >> 2];
        v[d + 56 >> 2] = v[a + 8 >> 2];
        v[d + 60 >> 2] = e;
        v[d - -64 >> 2] = v[a + 16 >> 2];
        e = v[a + 4 >> 2];
        v[d + 48 >> 2] = v[a >> 2];
        v[d + 52 >> 2] = e;
        a = T(1154, c | 0, d + 48 | 0, 15) | 0;
        c = v[31601];
        v[31601] = 0;
        if ((c | 0) == 1) {
         break e;
        }
        if (a) {
         v[31601] = 0;
         V(852, v[d + 72 >> 2]);
         a = v[31601];
         v[31601] = 0;
         g = 1;
         if ((a | 0) == 1) {
          break e;
         }
        }
        uh(d + 152 | 0);
        vh(d + 72 | 0);
        break a;
       }
       c = S(0) | 0;
       break b;
      }
      c = S(0) | 0;
      uh(d + 152 | 0);
      break c;
     }
     c = S(0) | 0;
    }
    vh(d + 72 | 0);
    break b;
   }
   if (b >= .6) {
    v[31601] = 0;
    c = ba(1193) | 0;
    e = v[31601];
    v[31601] = 0;
    f: {
     g: {
      h: {
       if ((e | 0) != 1) {
        v[d + 72 >> 2] = c;
        v[31601] = 0;
        e = Q(1194, v[d + 156 >> 2]) | 0;
        f = v[31601];
        v[31601] = 0;
        if ((f | 0) == 1) {
         break g;
        }
        v[d + 152 >> 2] = e;
        uo(c, e);
        a = Ge(d + 112 | 0, a);
        v[31601] = 0;
        e = v[a + 12 >> 2];
        v[d + 32 >> 2] = v[a + 8 >> 2];
        v[d + 36 >> 2] = e;
        v[d + 40 >> 2] = v[a + 16 >> 2];
        e = v[a + 4 >> 2];
        v[d + 24 >> 2] = v[a >> 2];
        v[d + 28 >> 2] = e;
        a = T(1154, c | 0, d + 24 | 0, 2) | 0;
        c = v[31601];
        v[31601] = 0;
        if ((c | 0) == 1) {
         break h;
        }
        if (a) {
         v[31601] = 0;
         V(852, v[d + 72 >> 2]);
         a = v[31601];
         v[31601] = 0;
         g = .8;
         if ((a | 0) == 1) {
          break h;
         }
        }
        uh(d + 152 | 0);
        vh(d + 72 | 0);
        break a;
       }
       c = S(0) | 0;
       break b;
      }
      c = S(0) | 0;
      uh(d + 152 | 0);
      break f;
     }
     c = S(0) | 0;
    }
    vh(d + 72 | 0);
    break b;
   }
   g = .2;
   if (b >= .2) {
    v[31601] = 0;
    c = ba(1193) | 0;
    e = v[31601];
    v[31601] = 0;
    i: {
     j: {
      k: {
       if ((e | 0) != 1) {
        v[d + 72 >> 2] = c;
        v[31601] = 0;
        e = Q(1194, v[d + 156 >> 2]) | 0;
        f = v[31601];
        v[31601] = 0;
        if ((f | 0) == 1) {
         break j;
        }
        v[d + 152 >> 2] = e;
        uo(c, e);
        a = Ge(d + 92 | 0, a);
        v[31601] = 0;
        e = v[a + 12 >> 2];
        v[d + 8 >> 2] = v[a + 8 >> 2];
        v[d + 12 >> 2] = e;
        v[d + 16 >> 2] = v[a + 16 >> 2];
        e = v[a + 4 >> 2];
        v[d >> 2] = v[a >> 2];
        v[d + 4 >> 2] = e;
        a = T(1154, c | 0, d | 0, 64) | 0;
        c = v[31601];
        v[31601] = 0;
        if ((c | 0) == 1) {
         break k;
        }
        g = 0;
        if (a) {
         v[31601] = 0;
         V(852, v[d + 72 >> 2]);
         a = v[31601];
         v[31601] = 0;
         g = .6;
         if ((a | 0) == 1) {
          break k;
         }
        }
        uh(d + 152 | 0);
        vh(d + 72 | 0);
        break a;
       }
       c = S(0) | 0;
       break b;
      }
      c = S(0) | 0;
      uh(d + 152 | 0);
      break i;
     }
     c = S(0) | 0;
    }
    vh(d + 72 | 0);
    break b;
   }
   if (!(b >= .1)) {
    break a;
   }
   v[31601] = 0;
   c = d + 72 | 0;
   R(186, c | 0, a | 0, 2048);
   e = v[31601];
   v[31601] = 0;
   l: {
    if ((e | 0) != 1) {
     e = Ze(c);
     a = v[a >> 2];
     v[31601] = 0;
     f = v[d + 72 >> 2];
     a = Q(154, a | 0) | 0;
     h = v[31601];
     v[31601] = 0;
     if ((h | 0) == 1) {
      break l;
     }
     v[31601] = 0;
     a = aI(1195, 3, 0, e, f, a, 0);
     e = v[31601];
     v[31601] = 0;
     if ((e | 0) == 1) {
      break l;
     }
     g = A[(a << 3) + 79240 >> 3];
     Jc(c);
     break a;
    }
    c = S(0) | 0;
    break b;
   }
   c = S(0) | 0;
   Jc(d + 72 | 0);
  }
  X(c | 0) | 0;
  v[31601] = 0;
  W(26);
  a = v[31601];
  v[31601] = 0;
  g = 0;
  if ((a | 0) != 1) {
   break a;
  }
  a = M() | 0;
  Wc(d + 156 | 0);
  P(a | 0);
  p();
 }
 Wc(d + 156 | 0);
 eb = d + 160 | 0;
 return +g;
}

function Qpa(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, x = 0;
 f = eb - 560 | 0;
 eb = f;
 a: {
  if (!cd(b, 1464)) {
   break a;
  }
  d = f + 556 | 0;
  if (!kr(b, d)) {
   break a;
  }
  Cd(a, 1);
  Kb(Kb(ag(a + 1074312 | 0, 83), 84, 1), 85, 1);
  b: {
   if (ne(d, 25252)) {
    e = f + 32 | 0;
    d = tc(e, 8430);
    yb(a + 1298344 | 0, d);
    sb(d);
    d = tc(e, 14814);
    yb(a + 1298356 | 0, d);
    sb(d);
    d = tc(e, 14879);
    yb(a + 1298368 | 0, d);
    break b;
   }
   if (!ne(f + 556 | 0, 15576)) {
    break a;
   }
   e = f + 32 | 0;
   d = tc(e, 8604);
   yb(a + 1298344 | 0, d);
   sb(d);
   d = tc(e, 12340);
   yb(a + 1298356 | 0, d);
   sb(d);
   d = tc(e, 15493);
   yb(a + 1298368 | 0, d);
  }
  sb(d);
  s = a, x = v[Ec(e, 28) >> 2], v[s + 1298404 >> 2] = x;
  e = 0;
  cd(b, 0);
  AZ(b, a + 1298308 | 0, 20);
  u[a + 480190 >> 1] = 31;
  g = a + 946304 | 0;
  m = a + 484380 | 0;
  d = 1;
  while (1) if ((d | 0) == 32) {
   if (e >>> 0 > 40) {
    break a;
   }
   d = f + 554 | 0;
   Mw(d, b);
   n = Ic(d);
   if (w[f + 554 | 0] > 128) {
    break a;
   }
   e = f + 32 | 0;
   d = eb - 16 | 0;
   eb = d;
   c: {
    if (!Lb(v[b >> 2], v[b + 8 >> 2], 512)) {
     HX(e);
     break c;
    }
    yE(d + 8 | 0, e);
    rd(d, b, v[d + 8 >> 2], v[d + 12 >> 2]);
   }
   eb = d + 16 | 0;
   d = 0;
   e = w[n | 0];
   while (1) {
    o = (d | 0) == 512;
    if (!o) {
     g = (f + 32 | 0) + d | 0;
     d = d + 1 | 0;
     if (e >>> 0 >= w[g | 0]) {
      continue;
     }
     break a;
    }
    break;
   }
   if ((c | 0) == 64) {
    break a;
   }
   v[a + 480260 >> 2] = 56;
   v[a + 480264 >> 2] = 13696;
   v[a + 480204 >> 2] = 125e4;
   v[a + 480196 >> 2] = 6;
   u[a + 480192 >> 1] = 0;
   u[a + 480188 >> 1] = 4;
   v[a + 480228 >> 2] = 64;
   v[a + 480208 >> 2] = v[a + 480208 >> 2] | 18874368;
   Th(a, 0);
   ug(Wb(v[a + 484360 >> 2], w[a + 484376 | 0]), w[f + 554 | 0]);
   l = a + 484344 | 0;
   Sf(l, w[f + 554 | 0]);
   g = 0;
   while (1) if (w[f + 554 | 0] <= g >>> 0) {
    if (!(c & 2)) {
     break a;
    }
    cd(b, (w[n | 0] << 8) + 1468 | 0);
    d = 1;
    while (1) {
     if ((d | 0) == 32) {
      break a;
     }
     a = B(d, 104) + m | 0;
     if (v[a >> 2]) {
      cg(Yc(f + 8 | 0, 8, 1, 0, 0), a, b);
     }
     d = d + 1 | 0;
     continue;
    }
   } else {
    s = $b(v[Wb(v[a + 484360 >> 2], w[a + 484376 | 0]) >> 2], g), x = g, u[s >> 1] = x;
    d: {
     if (!Og(l, g & 65535, 64)) {
      break d;
     }
     r = g << 2;
     i = 0;
     e: while (1) {
      if ((i | 0) == 4) {
       s = f, x = vb(v[Vb(v[l >> 2], g) >> 2]), v[s + 24 >> 2] = x;
       i = 0;
       while (1) {
        if ((i | 0) == 64) {
         break d;
        }
        d = 0;
        f: {
         while (1) {
          if ((d & 65535) >>> 0 >= 4) {
           g: {
            t[f + 30 | 0] = p;
            t[f + 31 | 0] = q;
            d = h & 255;
            if (d) {
             break g;
            }
            h = 0;
            break f;
           }
          } else {
           e = v[f + 24 >> 2];
           h: {
            if ((w[e + 3 | 0] & 254) != 16) {
             break h;
            }
            t[e + 3 | 0] = 16;
            h = 0;
            j = w[e + 5 | 0];
            if (j >>> 0 < 16) {
             break h;
            }
            h = j >>> 4 | 0;
            t[e + 5 | 0] = h;
            k = h;
            e = j & 15;
            h = (e | 0) != (h | 0) & (e | 0) != 0;
            p = h ? k : p;
            q = h ? e : q;
           }
           d = d + 1 | 0;
           MC(f + 24 | 0);
           continue;
          }
          break;
         }
         ze(Vb(v[l >> 2], g), We(Ne(f + 8 | 0, 16, w[(d + f | 0) + 29 | 0]), i));
         h = h + 1 | 0;
         h = (h & 255) == 3 ? 1 : h;
        }
        i = i + 1 | 0;
        continue;
       }
      }
      cd(b, (w[(f + 32 | 0) + (i | r) | 0] << 8) + 1468 | 0);
      e = 0;
      d = Vb(v[l >> 2], g);
      d = ld(v[d >> 2], v[v[d + 48 >> 2] + 12 >> 2], 0, i & 65535);
      while (1) if ((e | 0) == 64) {
       i = i + 1 | 0;
       continue e;
      } else {
       k = f + 8 | 0;
       E$(k, b, d);
       j = w[f + 8 | 0];
       k = w[Ic(k) | 0];
       i: {
        if (!(!(j | k) | (j - 5 & 255) >>> 0 < 5 | (j | 0) == 14 & k >>> 0 > 15)) {
         Bf(d, j, k);
         break i;
        }
        t[d + 3 | 0] = 0;
       }
       d = d + 24 | 0;
       e = e + 1 | 0;
       continue;
      }
     }
    }
    g = g + 1 | 0;
    continue;
   }
  } else {
   i = f + 32 | 0;
   PC(b, i);
   e = ZC(i, B(d, 104) + m | 0, g + (d << 5) | 0, 1) + e | 0;
   d = d + 1 | 0;
   continue;
  }
 }
 eb = f + 560 | 0;
 return o | 0;
}

function eoa(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0;
 d = eb - 112 | 0;
 eb = d;
 a: {
  b: {
   c: {
    d: {
     switch (w[a | 0] - 23 | 0) {
     case 0:
      e = t[a + 1 | 0];
      i = d, j = KD(c, +w[a + 2 | 0] * 1e4 / 240), t[i + 12 | 0] = j;
      v[d + 88 >> 2] = 127;
      v[d + 76 >> 2] = (B(w[a + 3 | 0], 127) >>> 0) / 185;
      i = d, j = v[Bd(d + 88 | 0, d + 76 | 0) >> 2], t[i + 111 | 0] = j;
      e: {
       switch (((e >>> 0) % 5 | 0) - 1 | 0) {
       case 0:
        a = d + 76 | 0;
        qw(a, 15634);
        v[31601] = 0;
        c = d - -64 | 0;
        N(558, c | 0, d + 12 | 0);
        e = v[31601];
        v[31601] = 0;
        f: {
         g: {
          h: {
           i: {
            if ((e | 0) != 1) {
             v[31601] = 0;
             e = d + 52 | 0;
             N(558, e | 0, d + 111 | 0);
             f = v[31601];
             v[31601] = 0;
             if ((f | 0) == 1) {
              break i;
             }
             v[31601] = 0;
             f = d + 88 | 0;
             U(559, f | 0, a | 0, c | 0, e | 0);
             g = v[31601];
             v[31601] = 0;
             if ((g | 0) == 1) {
              break h;
             }
             ee(d + 100 | 0, f);
             qf(b, v[d + 100 >> 2], v[d + 104 >> 2]);
             sb(f);
             sb(e);
             sb(c);
             Db(a);
             break b;
            }
            a = M() | 0;
            break f;
           }
           a = M() | 0;
           break g;
          }
          a = M() | 0;
          sb(d + 52 | 0);
         }
         sb(d - -64 | 0);
        }
        break c;

       case 1:
        a = d + 76 | 0;
        qw(a, 15581);
        v[31601] = 0;
        c = d - -64 | 0;
        N(558, c | 0, d + 12 | 0);
        e = v[31601];
        v[31601] = 0;
        j: {
         k: {
          l: {
           m: {
            if ((e | 0) != 1) {
             v[31601] = 0;
             e = d + 52 | 0;
             N(558, e | 0, d + 111 | 0);
             f = v[31601];
             v[31601] = 0;
             if ((f | 0) == 1) {
              break m;
             }
             v[31601] = 0;
             f = d + 88 | 0;
             U(559, f | 0, a | 0, c | 0, e | 0);
             g = v[31601];
             v[31601] = 0;
             if ((g | 0) == 1) {
              break l;
             }
             ee(d + 44 | 0, f);
             qf(b, v[d + 44 >> 2], v[d + 48 >> 2]);
             sb(f);
             sb(e);
             sb(c);
             Db(a);
             break b;
            }
            a = M() | 0;
            break j;
           }
           a = M() | 0;
           break k;
          }
          a = M() | 0;
          sb(d + 52 | 0);
         }
         sb(d - -64 | 0);
        }
        break c;

       default:
        break e;
       }
      }
      a = oc(d + 36 | 0, 15661);
      qf(b, v[a >> 2], v[a + 4 >> 2]);
      break b;

     case 1:
      break d;

     default:
      break a;
     }
    }
    c = t[a + 1 | 0];
    t[d + 111 | 0] = (c | 0) < 5 ? c : 0;
    c = t[a + 2 | 0];
    t[d + 35 | 0] = (c | 0) < 0 ? 127 : c;
    a = t[a + 3 | 0];
    t[d + 34 | 0] = (a | 0) < 0 ? 127 : a;
    a = eb - 16 | 0;
    eb = a;
    c = d + 76 | 0;
    e = Cc(a + 4 | 0, 4048);
    Uc(c, e);
    sb(e);
    eb = a + 16 | 0;
    v[31601] = 0;
    a = d - -64 | 0;
    N(558, a | 0, d + 111 | 0);
    e = v[31601];
    v[31601] = 0;
    n: {
     o: {
      p: {
       q: {
        r: {
         s: {
          if ((e | 0) != 1) {
           v[31601] = 0;
           e = d + 52 | 0;
           N(558, e | 0, d + 35 | 0);
           f = v[31601];
           v[31601] = 0;
           if ((f | 0) == 1) {
            break s;
           }
           v[31601] = 0;
           f = d + 12 | 0;
           N(558, f | 0, d + 34 | 0);
           g = v[31601];
           v[31601] = 0;
           if ((g | 0) == 1) {
            break r;
           }
           v[31601] = 0;
           g = d + 88 | 0;
           $(739, g | 0, c | 0, a | 0, e | 0, f | 0);
           h = v[31601];
           v[31601] = 0;
           if ((h | 0) == 1) {
            break q;
           }
           ee(d + 24 | 0, g);
           qf(b, v[d + 24 >> 2], v[d + 28 >> 2]);
           sb(g);
           sb(f);
           sb(e);
           sb(a);
           Db(c);
           break b;
          }
          a = M() | 0;
          break n;
         }
         a = M() | 0;
         break o;
        }
        a = M() | 0;
        break p;
       }
       a = M() | 0;
       sb(d + 12 | 0);
      }
      sb(d + 52 | 0);
     }
     sb(d - -64 | 0);
    }
   }
   Db(d + 76 | 0);
   P(a | 0);
   p();
  }
  e = 1;
 }
 eb = d + 112 | 0;
 return e | 0;
}

function PP(a) {
 var b = 0, c = C(0), d = C(0), e = 0, f = C(0), g = C(0), h = C(0), i = 0, j = 0, k = 0, l = C(0), m = 0, n = C(0), o = 0, p = C(0), q = C(0), r = C(0), s = C(0), u = 0, w = C(0);
 k = eb - 16 | 0;
 eb = k;
 b = a + 4208 | 0;
 e = Ak(C(z[xb(b, 12) >> 2] * C(3)));
 v[a + 4264 >> 2] = e;
 d = C(v[v[a + 16 >> 2] + 24620 >> 2] >>> ((e ^ -1) >>> 1 & 1) >>> 0);
 z[a + 4268 >> 2] = d;
 u = a, w = C(C(z[xb(b, 9) >> 2] * C(100)) * C(.0061803399585187435)), z[u + 4272 >> 2] = w;
 u = k, w = De(C(10), C(C(OP(a) + C(C(z[xb(b, 5) >> 2] * C(11e3)) + C(-1e4))) / C(2e3))), 
 z[u + 12 >> 2] = w;
 v[k + 8 >> 2] = 1065353216;
 u = a, w = C(z[Qm(k + 12 | 0, k + 8 | 0) >> 2] * C(.7609999775886536)), z[u + 4280 >> 2] = w;
 c = De(C(10), C(C(C(C(z[xb(b, 1) >> 2] * C(1e4)) + C(-1e4)) / C(100)) / C(10)));
 if (c != C(1)) {
  d = uq(C(C(NP(a) * C(6.2831854820251465)) / d));
  g = C(c + c);
  f = C(c * c);
  c = DB(C(C(C(C(d * g) + C(-2)) + C(K(C(C(C(C(d * C(C(d * f) * C(4))) + C(c * C(8))) - C(f * C(4))) - C(C(d * c) * C(8)))))) / C(g + C(-2))), C(0), C(1));
 } else {
  c = C(0);
 }
 z[a + 4276 >> 2] = c;
 i = eb - 16 | 0;
 eb = i;
 c = z[a + 4268 >> 2];
 b = a + 4208 | 0;
 d = C(z[xb(b, 6) >> 2] * C(.30000001192092896));
 u = i, w = C(z[xb(b, 8) >> 2] * C(.10000000149011612)), z[u + 12 >> 2] = w;
 v[i + 8 >> 2] = 1000593162;
 g = z[Yz(i + 12 | 0, i + 8 | 0) >> 2];
 f = C(c * C(C(d + g) + C(.007000000216066837)));
 a: {
  if (C(D(f)) < C(2147483648)) {
   b = ~~f;
   break a;
  }
  b = -2147483648;
 }
 v[a + 4352 >> 2] = b;
 m = a + 4352 | 0;
 e = 1;
 while (1) {
  if ((e | 0) == 12) {
   u = i, w = C(C(C(C(z[xb(a + 4208 | 0, 10) >> 2] * C(100)) / C(100)) + C(.10000000149011612)) * C(.9090999960899353)), 
   z[u + 12 >> 2] = w;
   v[i + 8 >> 2] = 1065353216;
   m = a + 4292 | 0;
   d = z[Qm(i + 12 | 0, i + 8 | 0) >> 2];
   g = C(c * C(C(d * C(75)) / C(1e3)));
   d = C(c * C(C(d * C(67)) / C(1e3)));
   e = 0;
   while (1) {
    if ((e | 0) == 6) {
     d = C(c * C(.0035299998708069324));
     b: {
      if (C(D(d)) < C(2147483648)) {
       b = ~~d;
       break b;
      }
      b = -2147483648;
     }
     v[a + 4348 >> 2] = b;
     d = C(c * C(.0032500000670552254));
     c: {
      if (C(D(d)) < C(2147483648)) {
       b = ~~d;
       break c;
      }
      b = -2147483648;
     }
     v[a + 4344 >> 2] = b;
     c = C(c * C(.009999999776482582));
     d: {
      if (C(D(c)) < C(2147483648)) {
       b = ~~c;
       break d;
      }
      b = -2147483648;
     }
     v[a + 4340 >> 2] = b;
     b = a + 4504 | 0;
    } else {
     b = m + (e << 2) | 0;
     o = e + o | 0;
     f = De(C(.9300000071525574), C(o | 0));
     h = C(g * f);
     e: {
      if (C(D(h)) < C(2147483648)) {
       j = ~~h;
       break e;
      }
      j = -2147483648;
     }
     v[b + 24 >> 2] = j;
     f = C(d * f);
     f: {
      if (C(D(f)) < C(2147483648)) {
       j = ~~f;
       break f;
      }
      j = -2147483648;
     }
     v[b >> 2] = j;
     e = e + 1 | 0;
     continue;
    }
    break;
   }
   e = 0;
   while (1) {
    if ((e | 0) != 15) {
     RP(b + B(e, 24) | 0, v[m + (e << 2) >> 2]);
     e = e + 1 | 0;
     continue;
    }
    break;
   }
   eb = i + 16 | 0;
  } else {
   j = (m + B(e & 1, 24) | 0) + (e << 1 & -4) | 0;
   f = C(c * C(C(g * z[(e << 2) + 45312 >> 2]) + d));
   g: {
    if (C(D(f)) < C(2147483648)) {
     b = ~~f;
     break g;
    }
    b = -2147483648;
   }
   v[j >> 2] = b;
   e = e + 1 | 0;
   continue;
  }
  break;
 }
 b = eb - 16 | 0;
 eb = b;
 d = Oh(a, 5);
 f = Oh(a, 11);
 c = C(d * Oh(a, 4));
 d = C(C(c * C(.03999999910593033)) + C(C(d * C(.02250000089406967)) + C(0)));
 g = C(f * Oh(a, 10));
 f = C(C(g * C(.03999999910593033)) + C(C(f * C(.02250000089406967)) + C(0)));
 if (t[a + 4264 | 0] & 1) {
  h = Oh(a, 3);
  l = Oh(a, 9);
  h = C(c * h);
  c = C(h * Oh(a, 2));
  d = C(C(c * C(.1444000005722046)) + C(C(h * C(.12250000238418579)) + d));
  h = C(g * l);
  g = C(h * Oh(a, 8));
  f = C(C(g * C(.1444000005722046)) + C(C(h * C(.12250000238418579)) + f));
 }
 Oh(a, 12);
 h = z[a + 4496 >> 2];
 l = Oh(a, 1);
 n = Oh(a, 7);
 q = Oh(a, 0);
 r = Oh(a, 6);
 u = b, w = De(C(10), C(C(OP(a) + C(C(z[xb(a + 4208 | 0, 7) >> 2] * C(12e3)) + C(-1e4))) / C(2e3))), 
 z[u + 12 >> 2] = w;
 v[b + 8 >> 2] = 1065353216;
 p = z[Qm(b + 12 | 0, b + 8 | 0) >> 2];
 s = c;
 c = C(h * h);
 h = C(l * C(s * c));
 l = C(q * h);
 c = C(n * C(g * c));
 g = C(r * c);
 n = C(C(C(l + g) * C(-.5)) + C(1));
 z[a + 4284 >> 2] = p * C(K(C(n / C(C(l * C(.1444000005722046)) + C(C(c * C(.1444000005722046)) + d)))));
 z[a + 4288 >> 2] = p * C(K(C(n / C(C(g * C(.1444000005722046)) + C(C(h * C(.1444000005722046)) + f)))));
 eb = b + 16 | 0;
 t[a + 5046 | 0] = 0;
 eb = k + 16 | 0;
}

function Hda(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0;
 a = Eb(a);
 v[31601] = 0;
 W(84);
 c = v[31601];
 v[31601] = 0;
 a: {
  b: {
   if ((c | 0) == 1) {
    c = Ta(48396, 124508, 125092, 0) | 0;
    d = fb;
    c: {
     d: {
      e: {
       if ((_(48396) | 0) == (d | 0)) {
        c = X(c | 0) | 0;
        v[31601] = 0;
        b = O(984, a | 0, b | 0) | 0;
        d = v[31601];
        v[31601] = 0;
        if ((d | 0) == 1) {
         break e;
        }
        v[31601] = 0;
        b = O(984, b | 0, 18371) | 0;
        d = v[31601];
        v[31601] = 0;
        if ((d | 0) == 1) {
         break e;
        }
        v[31601] = 0;
        d = O(984, b | 0, 18347) | 0;
        b = v[31601];
        v[31601] = 0;
        if ((b | 0) == 1) {
         break e;
        }
        b = hb[v[v[c >> 2] + 8 >> 2]](c) | 0;
        v[31601] = 0;
        O(984, d | 0, (b ? b : 22256) | 0) | 0;
        b = v[31601];
        v[31601] = 0;
        if ((b | 0) == 1) {
         break e;
        }
        v[31601] = 0;
        W(26);
        b = v[31601];
        v[31601] = 0;
        if ((b | 0) != 1) {
         break b;
        }
        b = M() | 0;
        break a;
       }
       f: {
        if ((_(124508) | 0) == (d | 0)) {
         c = X(c | 0) | 0;
         v[31601] = 0;
         b = O(984, a | 0, b | 0) | 0;
         d = v[31601];
         v[31601] = 0;
         if ((d | 0) == 1) {
          break f;
         }
         v[31601] = 0;
         b = O(984, b | 0, 18371) | 0;
         d = v[31601];
         v[31601] = 0;
         if ((d | 0) == 1) {
          break f;
         }
         v[31601] = 0;
         d = O(984, b | 0, 18322) | 0;
         b = v[31601];
         v[31601] = 0;
         if ((b | 0) == 1) {
          break f;
         }
         b = hb[v[v[c >> 2] + 8 >> 2]](c) | 0;
         v[31601] = 0;
         O(984, d | 0, (b ? b : 22256) | 0) | 0;
         b = v[31601];
         v[31601] = 0;
         if ((b | 0) == 1) {
          break f;
         }
         v[31601] = 0;
         W(26);
         b = v[31601];
         v[31601] = 0;
         if ((b | 0) != 1) {
          break b;
         }
         b = M() | 0;
         break a;
        }
        e = _(125092) | 0;
        c = X(c | 0) | 0;
        g: {
         if ((d | 0) == (e | 0)) {
          v[31601] = 0;
          b = O(984, a | 0, b | 0) | 0;
          d = v[31601];
          v[31601] = 0;
          if ((d | 0) == 1) {
           break g;
          }
          v[31601] = 0;
          b = O(984, b | 0, 18371) | 0;
          d = v[31601];
          v[31601] = 0;
          if ((d | 0) == 1) {
           break g;
          }
          v[31601] = 0;
          d = O(984, b | 0, 18338) | 0;
          b = v[31601];
          v[31601] = 0;
          if ((b | 0) == 1) {
           break g;
          }
          b = hb[v[v[c >> 2] + 8 >> 2]](c) | 0;
          v[31601] = 0;
          O(984, d | 0, (b ? b : 22256) | 0) | 0;
          b = v[31601];
          v[31601] = 0;
          if ((b | 0) == 1) {
           break g;
          }
          v[31601] = 0;
          W(26);
          b = v[31601];
          v[31601] = 0;
          if ((b | 0) != 1) {
           break b;
          }
          b = M() | 0;
          break a;
         }
         v[31601] = 0;
         b = O(984, a | 0, b | 0) | 0;
         c = v[31601];
         v[31601] = 0;
         if ((c | 0) == 1) {
          break d;
         }
         v[31601] = 0;
         b = O(984, b | 0, 18371) | 0;
         c = v[31601];
         v[31601] = 0;
         if ((c | 0) == 1) {
          break d;
         }
         v[31601] = 0;
         O(984, b | 0, 13775) | 0;
         b = v[31601];
         v[31601] = 0;
         if ((b | 0) == 1) {
          break d;
         }
         v[31601] = 0;
         W(26);
         b = v[31601];
         v[31601] = 0;
         if ((b | 0) != 1) {
          break b;
         }
         b = M() | 0;
         break a;
        }
        b = M() | 0;
        v[31601] = 0;
        W(26);
        c = v[31601];
        v[31601] = 0;
        if ((c | 0) != 1) {
         break a;
        }
        break c;
       }
       b = M() | 0;
       v[31601] = 0;
       W(26);
       c = v[31601];
       v[31601] = 0;
       if ((c | 0) != 1) {
        break a;
       }
       break c;
      }
      b = M() | 0;
      v[31601] = 0;
      W(26);
      c = v[31601];
      v[31601] = 0;
      if ((c | 0) == 1) {
       break c;
      }
      break a;
     }
     b = M() | 0;
     v[31601] = 0;
     W(26);
     c = v[31601];
     v[31601] = 0;
     if ((c | 0) != 1) {
      break a;
     }
    }
    S(0) | 0;
    Rb();
   }
   p();
  }
  return;
 }
 sb(a);
 P(b | 0);
 p();
}

function oP(a, b, c, d, e, f, g, h, i) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 f = f | 0;
 g = g | 0;
 h = h | 0;
 i = i | 0;
 var j = 0, k = 0, l = 0, m = 0, n = 0;
 j = eb - 80 | 0;
 eb = j;
 a: {
  b: {
   c: {
    d: {
     e: {
      f: {
       k = hr(1, 28);
       if (!k) {
        a = Pm(cc(4));
        v[31601] = 0;
        R(97, a | 0, 124508, 34);
        a = v[31601];
        v[31601] = 0;
        if ((a | 0) != 1) {
         break a;
        }
        break f;
       }
       v[k + 12 >> 2] = f;
       v[k + 8 >> 2] = e;
       v[k + 4 >> 2] = d;
       f = c ? c : 976;
       v[k >> 2] = f;
       c = ng(j + 68 | 0);
       g: {
        h: {
         i: {
          if (!i) {
           break i;
          }
          while (1) {
           e = v[i >> 2];
           if (!e) {
            break i;
           }
           l = v[i + 4 >> 2];
           j: {
            if (l) {
             v[31601] = 0;
             e = O(36, j + 56 | 0, e | 0) | 0;
             m = v[31601];
             v[31601] = 0;
             k: {
              if ((m | 0) != 1) {
               v[31601] = 0;
               m = O(987, c | 0, e | 0) | 0;
               n = v[31601];
               v[31601] = 0;
               if ((n | 0) == 1) {
                break k;
               }
               v[31601] = 0;
               N(272, m | 0, l | 0);
               l = v[31601];
               v[31601] = 0;
               if ((l | 0) == 1) {
                break k;
               }
               break j;
              }
              i = S(0) | 0;
              break g;
             }
             i = S(0) | 0;
             sb(e);
             break g;
            }
            v[31601] = 0;
            e = O(36, j + 44 | 0, e | 0) | 0;
            l = v[31601];
            v[31601] = 0;
            if ((l | 0) == 1) {
             break h;
            }
            ju(c, e);
           }
           sb(e);
           i = i + 8 | 0;
           continue;
          }
         }
         e = v[a + 8 >> 2];
         i = v[a + 4 >> 2];
         l = v[a >> 2];
         v[31601] = 0;
         a = Q(851, 80) | 0;
         m = v[31601];
         v[31601] = 0;
         l: {
          m: {
           n: {
            if ((m | 0) != 1) {
             v[j + 40 >> 2] = e;
             v[j + 36 >> 2] = i;
             v[j + 32 >> 2] = l;
             v[j + 28 >> 2] = b;
             v[31601] = 0;
             b = O(988, f | 0, d | 0) | 0;
             d = v[31601];
             v[31601] = 0;
             if ((d | 0) == 1) {
              break n;
             }
             v[j + 20 >> 2] = b;
             b = j + 20 | 0;
             d = v[re(j + 24 | 0, b) >> 2];
             e = v[j + 40 >> 2];
             v[j + 8 >> 2] = v[j + 36 >> 2];
             v[j + 12 >> 2] = e;
             v[31601] = 0;
             e = v[j + 32 >> 2];
             v[j >> 2] = v[j + 28 >> 2];
             v[j + 4 >> 2] = e;
             d = aa(989, a | 0, j | 0, d | 0, c | 0) | 0;
             e = v[31601];
             v[31601] = 0;
             if ((e | 0) != 1) {
              break l;
             }
             i = S(0) | 0;
             Wc(b);
             break m;
            }
            i = S(0) | 0;
            break g;
           }
           i = S(0) | 0;
          }
          Bb(a);
          break g;
         }
         v[k + 24 >> 2] = d;
         Wc(j + 20 | 0);
         Ll(c);
         i = k;
         break d;
        }
        i = S(0) | 0;
       }
       Ll(c);
       X(i | 0) | 0;
       v[31601] = 0;
       U(982, 15171, k | 0, g | 0, h | 0);
       a = v[31601];
       v[31601] = 0;
       if ((a | 0) != 1) {
        v[31601] = 0;
        W(26);
        a = v[31601];
        v[31601] = 0;
        if ((a | 0) == 1) {
         break f;
        }
        a = v[k + 24 >> 2];
        if (a) {
         Bb(tq(a));
        }
        i = 0;
        v[k + 24 >> 2] = 0;
        a = v[k + 20 >> 2];
        if (a) {
         Bb(a);
         v[k + 20 >> 2] = 0;
        }
        Bb(k);
        break d;
       }
       i = S(0) | 0;
       v[31601] = 0;
       W(26);
       a = v[31601];
       v[31601] = 0;
       if ((a | 0) != 1) {
        break e;
       }
       break b;
      }
      i = S(0) | 0;
     }
     X(i | 0) | 0;
     i = 0;
     v[31601] = 0;
     U(982, 15171, 0, g | 0, h | 0);
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) == 1) {
      break c;
     }
     Y();
    }
    eb = j + 80 | 0;
    return i | 0;
   }
   a = M() | 0;
   v[31601] = 0;
   W(26);
   b = v[31601];
   v[31601] = 0;
   if ((b | 0) == 1) {
    break b;
   }
   P(a | 0);
   p();
  }
  S(0) | 0;
  Rb();
 }
 p();
}

function LR(a, b) {
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = C(0), i = 0, j = 0, k = 0, l = C(0), m = C(0), n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = C(0), w = 0;
 if (b) {
  NA(a);
  c = a + 24596 | 0;
  v[c >> 2] = 0;
  v[c + 4 >> 2] = 0;
  v[a + 24588 >> 2] = 0;
  v[a + 24592 >> 2] = 0;
  QR(a);
 }
 KR(a + 24648 | 0);
 p = v[a + 24620 >> 2];
 f = eb - 144 | 0;
 eb = f;
 d = !b;
 e = a + 397456 | 0;
 c = v[e + 4 >> 2];
 if (c >>> 0 >= 29) {
  v[e + 4 >> 2] = 0;
  c = 0;
 }
 g = B(c, 44) + 45888 | 0;
 if (!((g | 0) == v[e + 8 >> 2] & d)) {
  v[e + 8 >> 2] = g;
  m = C(p >>> 0);
  c = f + 12 | 0;
  d = v[g + 24 >> 2];
  v[c >> 2] = d;
  j = v[g + 16 >> 2];
  v[c + 4 >> 2] = j;
  v[c + 8 >> 2] = v[g + 4 >> 2];
  k = (d | 0) > (j | 0) ? d : j;
  if ((k | 0) <= -601) {
   i = j;
   j = k + 600 | 0;
   v[c + 4 >> 2] = i - j;
   v[c >> 2] = d - j;
  }
  h = C(z[g + 36 >> 2] * C(79.30999755859375));
  a: {
   if (C(D(h)) < C(2147483648)) {
    d = ~~h;
    break a;
   }
   d = -2147483648;
  }
  v[c + 16 >> 2] = d - -8192;
  h = C(C(C(z[g + 32 >> 2] * C(.0036000001709908247)) + C(.15000000596046448)) * C(32767));
  b: {
   if (C(D(h)) < C(2147483648)) {
    d = ~~h;
    break b;
   }
   d = -2147483648;
  }
  v[c + 20 >> 2] = (d | 0) >= 32512 ? 32512 : d;
  j = 0;
  h = z[g + 8 >> 2];
  l = z[g + 20 >> 2];
  l = C((l > C(.10000000149011612) ? C(.10000000149011612) : l) * m);
  c: {
   if (C(D(l)) < C(2147483648)) {
    d = ~~l;
    break c;
   }
   d = -2147483648;
  }
  k = (d | 0) <= 96 ? 96 : d;
  n = (d | 0) > 7500 ? k - 7500 | 0 : 0;
  l = C(z[g + 28 >> 2] * m);
  d: {
   if (C(D(l)) < C(2147483648)) {
    i = ~~l;
    break d;
   }
   i = -2147483648;
  }
  d = n + (i + ((d | 0) < 96 ? d - 96 | 0 : 0) | 0) | 0;
  i = (d | 0) <= 128 ? 128 : d;
  q = (i | 0) >= 3800 ? 3800 : i;
  v[c + 24 >> 2] = q;
  n = (d | 0) < 128 ? d - 128 | 0 : 0;
  h = C(h * m);
  e: {
   if (C(D(h)) < C(2147483648)) {
    o = ~~h;
    break e;
   }
   o = -2147483648;
  }
  i = (o + n | 0) + ((d | 0) > 3800 ? i - 3800 | 0 : 0) | 0;
  v[c + 32 >> 2] = i;
  o = (k | 0) >= 7500 ? 7500 : k;
  n = c + 36 | 0;
  while (1) {
   if ((j | 0) == 8) {
    h = C(i | 0);
    l = C(De(C(.0010000000474974513), (i | 0) < 4721 ? C(1) : C(C(4720) / h)) * C(32768));
    f: {
     if (C(D(l)) < C(2147483648)) {
      d = ~~l;
      break f;
     }
     d = -2147483648;
    }
    v[c + 12 >> 2] = d;
    h = C(z[g + 12 >> 2] * h);
    s = c, t = De(C(.0010000000474974513), h <= C(4720) ? C(1) : C(C(4720) / h)), z[s + 28 >> 2] = t;
   } else {
    d = B(j, 12);
    k = d + n | 0;
    u[k + 6 >> 1] = x[d + 47178 >> 1];
    u[k >> 1] = x[d + 47172 >> 1];
    u[k + 4 >> 1] = x[d + 47176 >> 1];
    u[k + 2 >> 1] = x[d + 47174 >> 1];
    v[k + 8 >> 2] = o + ((B(v[d + 47168 >> 2], q) + 50 | 0) / 100 | 0);
    j = j + 1 | 0;
    continue;
   }
   break;
  }
  v[e + 20 >> 2] = v[f + 44 >> 2];
  r = +m;
  c = DP(FP(v[f + 20 >> 2]), r);
  u[e + 86 >> 1] = c;
  u[e + 84 >> 1] = c;
  c = x[f + 28 >> 1] << 1;
  u[e + 94 >> 1] = c;
  u[e + 92 >> 1] = c;
  j = e + 100 | 0;
  k = f + 48 | 0;
  c = 0;
  while (1) {
   if ((c | 0) == 8) {
    v[e + 49892 >> 2] = v[f + 36 >> 2];
    c = v[f + 16 >> 2];
    if ((c | 0) > -9e3) {
     c = CP(c);
    } else {
     c = 0;
    }
    v[e + 80 >> 2] = c;
    c = v[f + 12 >> 2];
    if ((c | 0) >= -8999) {
     c = CP(c);
    } else {
     c = 0;
    }
    v[e + 49948 >> 2] = c;
    c = v[f + 32 >> 2];
    v[e + 49932 >> 2] = 268464128;
    v[e + 49936 >> 2] = 1879052288;
    c = c >>> 0 >= 32512 ? 32512 : c;
    u[e + 49906 >> 1] = c;
    u[e + 49904 >> 1] = c;
    u[e + 49902 >> 1] = c;
    u[e + 49900 >> 1] = c;
    v[f + 8 >> 2] = v[f + 24 >> 2];
    Fe(f + 8 | 0, 0, 32752);
    c = x[f + 8 >> 1];
    u[e + 49914 >> 1] = c;
    u[e + 49910 >> 1] = 0;
    u[e + 49912 >> 1] = 0;
    u[e + 49908 >> 1] = c;
    m = z[f + 40 >> 2];
    s = f, w = DP(+C(m * m), r), v[s + 4 >> 2] = w;
    Fe(f + 4 | 0, 256, 32512);
    c = x[f + 4 >> 1];
    u[e + 49922 >> 1] = c;
    u[e + 49918 >> 1] = 0;
    u[e + 49920 >> 1] = 0;
    u[e + 49916 >> 1] = c;
   } else {
    d = j + (c << 4) | 0;
    g = k + B(c, 12) | 0;
    i = v[g + 8 >> 2];
    v[d >> 2] = i;
    v[d + 4 >> 2] = i;
    u[d + 8 >> 1] = x[g >> 1];
    u[d + 10 >> 1] = x[g + 6 >> 1];
    u[d + 12 >> 1] = x[g + 4 >> 1];
    u[d + 14 >> 1] = x[g + 2 >> 1];
    c = c + 1 | 0;
    continue;
   }
   break;
  }
 }
 if (b) {
  v[e + 16 >> 2] = 0;
  HP(e, a + 397448 | 0, a + 397452 | 0);
 }
 b = B(p, 5);
 if (b >>> 0 > y[e + 20 >> 2]) {
  v[e + 20 >> 2] = b;
 }
 eb = f + 144 | 0;
 b = v[a + 1298300 >> 2];
 if (Dd(b)) {
  CU(b, v[a + 24620 >> 2]);
 }
}

function vfa(a, b, c, d, e, f, g, h, i) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 f = f | 0;
 g = g | 0;
 h = h | 0;
 i = i | 0;
 var j = 0, k = 0, l = 0, m = 0, n = 0;
 j = eb - 80 | 0;
 eb = j;
 a: {
  b: {
   c: {
    k = hr(1, 32);
    d: {
     e: {
      if (!k) {
       a = Pm(cc(4));
       v[31601] = 0;
       R(97, a | 0, 124508, 34);
       a = v[31601];
       v[31601] = 0;
       if ((a | 0) != 1) {
        break a;
       }
       i = S(0) | 0;
       break e;
      }
      v[k + 12 >> 2] = f;
      v[k + 8 >> 2] = e;
      v[k + 4 >> 2] = d;
      f = c ? c : 976;
      v[k >> 2] = f;
      c = ng(j + 68 | 0);
      f: {
       g: {
        h: {
         if (!i) {
          break h;
         }
         while (1) {
          e = v[i >> 2];
          if (!e) {
           break h;
          }
          l = v[i + 4 >> 2];
          i: {
           if (l) {
            v[31601] = 0;
            e = O(36, j + 56 | 0, e | 0) | 0;
            m = v[31601];
            v[31601] = 0;
            j: {
             if ((m | 0) != 1) {
              v[31601] = 0;
              m = O(987, c | 0, e | 0) | 0;
              n = v[31601];
              v[31601] = 0;
              if ((n | 0) == 1) {
               break j;
              }
              v[31601] = 0;
              N(272, m | 0, l | 0);
              l = v[31601];
              v[31601] = 0;
              if ((l | 0) == 1) {
               break j;
              }
              break i;
             }
             i = S(0) | 0;
             break f;
            }
            i = S(0) | 0;
            sb(e);
            break f;
           }
           v[31601] = 0;
           e = O(36, j + 44 | 0, e | 0) | 0;
           l = v[31601];
           v[31601] = 0;
           if ((l | 0) == 1) {
            break g;
           }
           ju(c, e);
          }
          sb(e);
          i = i + 8 | 0;
          continue;
         }
        }
        e = v[a + 8 >> 2];
        i = v[a + 4 >> 2];
        l = v[a >> 2];
        v[31601] = 0;
        a = Q(851, 104) | 0;
        m = v[31601];
        v[31601] = 0;
        k: {
         l: {
          m: {
           if ((m | 0) != 1) {
            v[j + 40 >> 2] = e;
            v[j + 36 >> 2] = i;
            v[j + 32 >> 2] = l;
            v[j + 28 >> 2] = b;
            v[31601] = 0;
            b = O(988, f | 0, d | 0) | 0;
            d = v[31601];
            v[31601] = 0;
            if ((d | 0) == 1) {
             break m;
            }
            v[j + 20 >> 2] = b;
            d = j + 20 | 0;
            b = v[re(j + 24 | 0, d) >> 2];
            e = v[j + 40 >> 2];
            v[j + 8 >> 2] = v[j + 36 >> 2];
            v[j + 12 >> 2] = e;
            v[31601] = 0;
            e = v[j + 32 >> 2];
            v[j >> 2] = v[j + 28 >> 2];
            v[j + 4 >> 2] = e;
            b = aa(1018, a | 0, j | 0, b | 0, c | 0) | 0;
            e = v[31601];
            v[31601] = 0;
            if ((e | 0) != 1) {
             break k;
            }
            i = S(0) | 0;
            Wc(d);
            break l;
           }
           i = S(0) | 0;
           break f;
          }
          i = S(0) | 0;
         }
         Bb(a);
         break f;
        }
        v[k + 28 >> 2] = b;
        Wc(j + 20 | 0);
        v[k + 24 >> 2] = b + 8;
        Ll(c);
        break d;
       }
       i = S(0) | 0;
      }
      Ll(c);
      X(i | 0) | 0;
      v[31601] = 0;
      U(982, 11340, k | 0, g | 0, h | 0);
      a = v[31601];
      v[31601] = 0;
      if ((a | 0) != 1) {
       v[31601] = 0;
       W(26);
       a = v[31601];
       v[31601] = 0;
       if ((a | 0) != 1) {
        a = v[k + 28 >> 2];
        if (a) {
         hb[v[v[a >> 2] + 4 >> 2]](a);
        }
        v[k + 24 >> 2] = 0;
        v[k + 28 >> 2] = 0;
        a = v[k + 20 >> 2];
        if (a) {
         Bb(a);
         v[k + 20 >> 2] = 0;
        }
        Bb(k);
        k = 0;
        break d;
       }
       i = S(0) | 0;
       break e;
      }
      i = S(0) | 0;
      v[31601] = 0;
      W(26);
      a = v[31601];
      v[31601] = 0;
      if ((a | 0) == 1) {
       break b;
      }
     }
     X(i | 0) | 0;
     k = 0;
     v[31601] = 0;
     U(982, 11340, 0, g | 0, h | 0);
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) == 1) {
      break c;
     }
     Y();
    }
    eb = j + 80 | 0;
    return k | 0;
   }
   a = M() | 0;
   v[31601] = 0;
   W(26);
   b = v[31601];
   v[31601] = 0;
   if ((b | 0) == 1) {
    break b;
   }
   P(a | 0);
   p();
  }
  S(0) | 0;
  Rb();
 }
 p();
}

function Bqa(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
 g = eb - 16 | 0;
 eb = g;
 a: {
  b: {
   if (!c) {
    break b;
   }
   n = g, o = Yd(a), t[n + 8 | 0] = o;
   ro(b, g + 8 | 0);
   j = c - 1 | 0;
   while (1) {
    d = 1;
    if (!j) {
     break a;
    }
    c = e << 1 & 254;
    c: {
     if (c) {
      e = (e & 65535) >>> 0 > 127;
      break c;
     }
     if (!Af(a, g + 8 | 0)) {
      break b;
     }
     c = w[g + 8 | 0];
     e = c >>> 7 | 0;
     c = c << 1 & 254 | 1;
    }
    if (e) {
     d = 1;
     d: {
      while (1) {
       e: {
        e = c << 1 & 254;
        f: {
         if (e) {
          c = (c & 65535) >>> 0 > 127;
          break f;
         }
         if (!Af(a, g + 8 | 0)) {
          break e;
         }
         f = w[g + 8 | 0];
         c = f >>> 7 | 0;
         e = f << 1 & 254 | 1;
        }
        d = gr(d, 1) + c | 0;
        c = e << 1 & 254;
        g: {
         if (c) {
          e = e >>> 0 > 127;
          break g;
         }
         if (!Af(a, g + 8 | 0)) {
          break e;
         }
         c = w[g + 8 | 0];
         e = c >>> 7 | 0;
         c = c << 1 & 254 | 1;
        }
        if (e) {
         continue;
        }
        break d;
       }
       break;
      }
      c = 0;
     }
     h: {
      if ((d | 0) <= 2) {
       i = 0;
       f = d - 2 | 0;
       break h;
      }
      if (!Af(a, g + 8 | 0)) {
       break b;
      }
      f = gr(d - 3 | 0, 8) | w[g + 8 | 0];
      i = ((f | 0) > 1279 ? 2 : 1) + ((f | 0) > 31999) | 0;
      l = f ^ -1;
      f = 0;
     }
     d = c << 1 & 254;
     i: {
      if (d) {
       c = c >>> 0 > 127;
       break i;
      }
      if (!Af(a, g + 8 | 0)) {
       break b;
      }
      e = w[g + 8 | 0];
      c = e >>> 7 | 0;
      d = e << 1 & 254 | 1;
     }
     f = gr(f, 1);
     e = d << 1 & 254;
     j: {
      if (e) {
       h = d >>> 0 > 127;
       break j;
      }
      if (!Af(a, g + 8 | 0)) {
       break b;
      }
      e = w[g + 8 | 0];
      h = e >>> 7 | 0;
      e = e << 1 & 254 | 1;
     }
     d = 1;
     c = gr(c + f | 0, 1) + h | 0;
     if (!c) {
      k: {
       while (1) {
        l: {
         c = e << 1 & 254;
         m: {
          if (c) {
           e = (e & 65535) >>> 0 > 127;
           break m;
          }
          if (!Af(a, g + 8 | 0)) {
           break l;
          }
          c = w[g + 8 | 0];
          e = c >>> 7 | 0;
          c = c << 1 & 254 | 1;
         }
         d = gr(d, 1) + e | 0;
         e = c << 1 & 254;
         n: {
          if (e) {
           c = c >>> 0 > 127;
           break n;
          }
          if (!Af(a, g + 8 | 0)) {
           break l;
          }
          f = w[g + 8 | 0];
          c = f >>> 7 | 0;
          e = f << 1 & 254 | 1;
         }
         if (c) {
          continue;
         }
         break k;
        }
        break;
       }
       e = 0;
      }
      c = d + 2 | 0;
     }
     f = c + i | 0;
     d = 0;
     if (f >>> 0 > j >>> 0 | (f | 0) <= 0 | (l | 0) >= 0) {
      break a;
     }
     c = v[b + 4 >> 2];
     d = 0;
     if ((0 - Sc(v[b >> 2], c) | 0) > (l | 0)) {
      break a;
     }
     c = ub(g + 12 | 0, vb(c));
     t[g + 8 | 0] = 0;
     i = g + 8 | 0;
     m = eb - 32 | 0;
     eb = m;
     d = v[c >> 2];
     c = v[b >> 2];
     h = yk(d, vb(c)) + c | 0;
     c = v[zb(b) >> 2];
     k = v[b + 4 >> 2];
     o: {
      if (f >>> 0 <= c - k >>> 0) {
       c = f;
       d = k - h | 0;
       if (c >>> 0 > d >>> 0) {
        Ap(b, c - d | 0, i);
        c = d;
        if (!c) {
         break o;
        }
       }
       Q_(b, h, k, f + h | 0);
       Rh(h, c, i + (h >>> 0 <= i >>> 0 ? i >>> 0 < y[b + 4 >> 2] ? f : 0 : 0) | 0);
       break o;
      }
      c = zb(b);
      c = on(m + 12 | 0, Tl(b, Sc(v[b >> 2], k) + f | 0), h - v[b >> 2] | 0, c);
      cZ(c, f, i);
      h = P_(b, c, h);
      nn(c);
     }
     vb(h);
     eb = m + 32 | 0;
     n = g, o = Pe(bD(vb(v[b + 4 >> 2]), f), l), v[n + 8 >> 2] = o;
     n = g, o = bD(vb(v[b + 4 >> 2]), f), v[n + 4 >> 2] = o;
     c = f;
     while (1) {
      d = w[gY(g + 8 | 0) | 0];
      n = gY(g + 4 | 0), o = d, t[n | 0] = o;
      d = c >>> 0 > 1;
      c = c - 1 | 0;
      if (d) {
       continue;
      }
      break;
     }
     j = j - f | 0;
     continue;
    }
    f = g + 8 | 0;
    if (!Af(a, f)) {
     break b;
    }
    T_(b, f);
    j = j - 1 | 0;
    e = c;
    continue;
   }
  }
  d = 0;
 }
 eb = g + 16 | 0;
 return d | 0;
}
function gja(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0;
 c = eb - 192 | 0;
 eb = c;
 e = Im(c + 80 | 0, a);
 v[31601] = 0;
 d = O(461, c + 68 | 0, 42175) | 0;
 a = v[31601];
 v[31601] = 0;
 a: {
  b: {
   c: {
    d: {
     e: {
      f: {
       g: {
        h: {
         i: {
          j: {
           k: {
            l: {
             m: {
              n: {
               if ((a | 0) != 1) {
                v[31601] = 0;
                v[c + 56 >> 2] = 19989505;
                v[c + 60 >> 2] = 0;
                a = c + 56 | 0;
                R(462, e | 0, d | 0, a | 0);
                f = v[31601];
                v[31601] = 0;
                if ((f | 0) == 1) {
                 break n;
                }
                Db(d);
                if (ol(w[e | 0])) {
                 break e;
                }
                v[31601] = 0;
                d = O(461, a | 0, 13434) | 0;
                a = v[31601];
                v[31601] = 0;
                if ((a | 0) == 1) {
                 break m;
                }
                v[31601] = 0;
                U(493, e | 0, b | 0, d | 0, 913);
                a = v[31601];
                v[31601] = 0;
                if ((a | 0) == 1) {
                 break l;
                }
                Db(d);
                v[c + 52 >> 2] = 0;
                v[c + 48 >> 2] = 0;
                v[31601] = 0;
                d = O(461, c + 36 | 0, 16749) | 0;
                a = v[31601];
                v[31601] = 0;
                if ((a | 0) == 1) {
                 break k;
                }
                v[31601] = 0;
                R(914, e | 0, c + 52 | 0, d | 0);
                a = v[31601];
                v[31601] = 0;
                if ((a | 0) == 1) {
                 break j;
                }
                Db(d);
                v[31601] = 0;
                d = O(461, c + 24 | 0, 16739) | 0;
                a = v[31601];
                v[31601] = 0;
                if ((a | 0) == 1) {
                 break i;
                }
                v[31601] = 0;
                R(914, e | 0, c + 48 | 0, d | 0);
                a = v[31601];
                v[31601] = 0;
                if ((a | 0) == 1) {
                 break h;
                }
                Db(d);
                a = v[c + 52 >> 2];
                d = v[c + 48 >> 2];
                o: {
                 if (!a | d >>> 0 < a >>> 0) {
                  break o;
                 }
                 f = v[v[v[v[b + 48 >> 2] + 12 >> 2] + 8 >> 2] + 40 >> 2];
                 if (f >>> 0 < a >>> 0 | d >>> 0 > f >>> 0) {
                  break o;
                 }
                 v[b + 20 >> 2] = d;
                 v[b + 16 >> 2] = a;
                }
                d = Mb(c + 12 | 0);
                v[31601] = 0;
                f = O(461, c | 0, 14133) | 0;
                a = v[31601];
                v[31601] = 0;
                if ((a | 0) == 1) {
                 break d;
                }
                v[31601] = 0;
                R(915, e | 0, d | 0, f | 0);
                a = v[31601];
                v[31601] = 0;
                if ((a | 0) == 1) {
                 break g;
                }
                Db(f);
                if (lc(v[d >> 2], v[d + 4 >> 2])) {
                 break f;
                }
                a = v[b + 16 >> 2];
                v[31601] = 0;
                N(865, d | 0, a | 0);
                a = v[31601];
                v[31601] = 0;
                if ((a | 0) != 1) {
                 break f;
                }
                break c;
               }
               a = M() | 0;
               break a;
              }
              a = M() | 0;
              Db(d);
              break a;
             }
             a = M() | 0;
             break a;
            }
            a = M() | 0;
            Db(d);
            break a;
           }
           a = M() | 0;
           break a;
          }
          a = M() | 0;
          Db(d);
          break a;
         }
         a = M() | 0;
         break a;
        }
        a = M() | 0;
        Db(d);
        break a;
       }
       a = M() | 0;
       Db(f);
       break b;
      }
      v[31601] = 0;
      N(916, b | 0, d | 0);
      a = v[31601];
      v[31601] = 0;
      if ((a | 0) == 1) {
       break c;
      }
      uc(d);
     }
     Bh(e);
     eb = c + 192 | 0;
     return;
    }
    a = M() | 0;
    break b;
   }
   a = M() | 0;
  }
  uc(d);
 }
 Bh(e);
 P(a | 0);
 p();
}

function ze(a, b) {
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0;
 h = eb - 16 | 0;
 eb = h;
 e = v[a >> 2];
 a: {
  if (lc(e, v[a + 4 >> 2])) {
   break a;
  }
  f = v[b + 4 >> 2];
  if (f >>> 0 >= y[a + 12 >> 2]) {
   break a;
  }
  i = x[b + 8 >> 1];
  j = v[v[a + 48 >> 2] + 12 >> 2];
  c = x[j + 480188 >> 1];
  if (i >>> 0 >= c >>> 0 & (i | 0) != 65535) {
   break a;
  }
  d = c - 1 | 0;
  c = (i | 0) == 65535;
  l = c ? d : i;
  c = c ? 0 : i;
  e = ld(e, j, f, c);
  g = w[b + 12 | 0];
  k = g & 4;
  b: {
   c: {
    if (g & 2) {
     break c;
    }
    i = w[b + 10 | 0];
    f = e;
    d = c;
    while (1) {
     if ((d & 65535) >>> 0 > (l & 65535) >>> 0) {
      break c;
     }
     d: {
      if (!k) {
       if ((i | 0) != w[f + 3 | 0]) {
        break d;
       }
       break b;
      }
      if ((i | 0) == w[f + 2 | 0]) {
       break b;
      }
     }
     f = f + 6 | 0;
     d = d + 1 | 0;
     continue;
    }
   }
   i = l & 65535;
   d = e;
   f = c;
   while (1) {
    if (i >>> 0 >= (f & 65535) >>> 0) {
     e: {
      if (!k) {
       if (w[d + 3 | 0]) {
        break e;
       }
       t[d + 3 | 0] = w[b + 10 | 0];
       t[d + 5 | 0] = w[b + 11 | 0];
       break b;
      }
      if (w[d + 2 | 0]) {
       break e;
      }
      t[d + 2 | 0] = w[b + 10 | 0];
      t[d + 4 | 0] = w[b + 11 | 0];
      break b;
     }
     d = d + 6 | 0;
     f = f + 1 | 0;
     continue;
    }
    break;
   }
   f: {
    if (!(g & 1)) {
     break f;
    }
    d = v[j + 480180 >> 2] & 2;
    g: {
     h: {
      i: {
       if (!k) {
        while (1) {
         if ((c & 65535) >>> 0 <= (l & 65535) >>> 0) {
          j: {
           k: {
            switch (w[e + 3 | 0] - 9 | 0) {
            case 4:
             if (!$v(v[v[j + 8 >> 2] + 88 >> 2], 1)) {
              break j;
             }
             d = 1;
             t[e + 2 | 0] = 1;
             t[e + 4 | 0] = w[e + 5 | 0];
             t[e + 3 | 0] = w[b + 10 | 0];
             t[e + 5 | 0] = w[b + 11 | 0];
             break a;

            case 0:
             break k;

            default:
             break j;
            }
           }
           l: {
            if (d) {
             f = w[e + 5 | 0];
             if (f >>> 0 > 128) {
              break j;
             }
             t[e + 2 | 0] = 2;
             t[e + 3 | 0] = w[b + 10 | 0];
             a = 1;
             break l;
            }
            t[e + 2 | 0] = 2;
            t[e + 3 | 0] = w[b + 10 | 0];
            f = w[e + 5 | 0];
            a = 2;
           }
           t[e + 4 | 0] = a + (f & 255) >>> a;
           t[e + 5 | 0] = w[b + 11 | 0];
           break b;
          }
          e = e + 6 | 0;
          c = c + 1 | 0;
          continue;
         }
         break;
        }
        if (!k) {
         break i;
        }
       }
       f = w[b + 11 | 0];
       c = 13;
       m: {
        switch (w[b + 10 | 0] - 1 | 0) {
        case 1:
         c = 9;
         f = ri(f << (d ? 1 : 2));
         break;

        case 0:
         break m;

        default:
         break g;
        }
       }
       t[b + 11 | 0] = f;
       t[b + 10 | 0] = c;
       g = g & 254;
       break h;
      }
      t[h + 15 | 0] = 0;
      t[h + 14 | 0] = 0;
      e = b;
      c = w[b + 10 | 0];
      n: {
       if (!(!d | (c | 0) != 9)) {
        c = w[b + 11 | 0];
        if (c >>> 0 > 128) {
         break g;
        }
        d = 2;
        c = c >>> 1 | 0;
        break n;
       }
       f = h + 12 | 0;
       uw(f, c, w[b + 11 | 0], 1);
       c = h + 4 | 0;
       _D(c, h + 15 | 0, h + 14 | 0);
       ZD(c, f);
       g = w[b + 12 | 0];
       d = w[h + 15 | 0];
       if (!d) {
        break g;
       }
       c = w[h + 14 | 0];
      }
      t[e + 11 | 0] = c;
      t[b + 10 | 0] = d;
      g = g & 254;
     }
     t[b + 12 | 0] = g;
    }
    d = 1;
    if (g & 1) {
     break f;
    }
    t[b + 12 | 0] = g ^ 4;
    if (ze(a, b)) {
     break a;
    }
   }
   d = 0;
   o: {
    p: {
     switch (v[b >> 2] - 1 | 0) {
     case 0:
      c = v[b + 4 >> 2] + 1 | 0;
      if (c >>> 0 >= y[a + 12 >> 2]) {
       break a;
      }
      v[b + 4 >> 2] = c;
      break o;

     case 1:
      break p;

     default:
      break a;
     }
    }
    c = v[b + 4 >> 2];
    if (!c) {
     break a;
    }
    v[b + 4 >> 2] = c - 1;
   }
   t[b + 12 | 0] = w[b + 12 | 0] | 1;
   d = ze(a, b);
   break a;
  }
  d = 1;
 }
 eb = h + 16 | 0;
 return d;
}

function MP(a) {
 var b = C(0), c = C(0), d = 0, e = C(0), f = C(0), g = 0, h = 0, i = C(0), k = 0, m = C(0), p = C(0), s = C(0), t = 0, u = 0, w = C(0), x = C(0);
 d = a + 4208 | 0;
 CB(xb(d, 0), z[a + 4272 >> 2]);
 b = C(z[xb(d, 0) >> 2] * C(15920));
 s = De(C(10), C(C(C(z[xb(d, 2) >> 2] + C(-.5)) * C(30)) / C(40)));
 c = C(C(C(b + C(80)) / C(y[v[a + 16 >> 2] + 24620 >> 2])) * C(6.2831854820251465));
 b = bQ(c);
 w = uq(c);
 x = b;
 f = C(C(c * C(C(C(z[xb(d, 1) >> 2] * C(35)) + C(1)) * C(.02888113260269165))) / b);
 m = (l(2, (q(f), j(2)) & -2147483648 | 1056964608), r());
 c = C(D(f));
 k = (q(c), j(2));
 a: {
  if (k >>> 0 <= 1118925334) {
   b: {
    c: {
     d: {
      e: {
       f: {
        g: {
         h = (q(c), j(2));
         d = h & 2147483647;
         if (d >>> 0 >= 1100331076) {
          if (d >>> 0 > 2139095040) {
           break c;
          }
          b = C(-1);
          if ((h | 0) < 0) {
           break b;
          }
          if (d >>> 0 < 1118925336) {
           break g;
          }
          b = C(c * C(17014118346046923e22));
          break b;
         }
         if (d >>> 0 < 1051816473) {
          break e;
         }
         if (d >>> 0 > 1065686417) {
          break g;
         }
         if ((h | 0) >= 0) {
          d = 1;
          e = C(905800061445916e-20);
          b = C(c + C(-.6931381225585938));
          break f;
         }
         d = -1;
         e = C(-905800061445916e-20);
         b = C(c + C(.6931381225585938));
         break f;
        }
        b = C(C(c * C(1.4426950216293335)) + (l(2, (q(c), j(2)) & -2147483648 | 1056964608), 
        r()));
        h: {
         if (C(D(b)) < C(2147483648)) {
          d = ~~b;
          break h;
         }
         d = -2147483648;
        }
        b = C(d | 0);
        e = C(b * C(905800061445916e-20));
        b = C(c + C(b * C(-.6931381225585938)));
       }
       c = C(b - e);
       e = C(C(b - c) - e);
       break d;
      }
      if (d >>> 0 < 855638016) {
       break c;
      }
      d = 0;
     }
     b = C(c * C(.5));
     i = C(c * b);
     p = C(C(i * C(C(i * C(.0015807170420885086)) + C(-.03333321213722229))) + C(1));
     b = C(C(3) - C(p * b));
     p = C(i * C(C(p - b) / C(C(6) - C(c * b))));
     b = C(c - C(C(c * p) - i));
     if (!d) {
      break b;
     }
     e = C(C(C(c * C(p - e)) - e) - i);
     i: {
      switch (d + 1 | 0) {
      case 0:
       b = C(C(C(c - e) * C(.5)) + C(-.5));
       break b;

      case 2:
       b = C(C(e - C(c + C(.5))) * C(-2));
       if (c < C(-.25)) {
        break b;
       }
       b = C(c - e);
       b = C(C(b + b) + C(1));
       break b;

      default:
       break i;
      }
     }
     h = d << 23;
     b = (l(2, h + 1065353216 | 0), r());
     if (d >>> 0 >= 57) {
      c = C(C(c - e) + C(1));
      b = C(((d | 0) == 128 ? C(C(c + c) * C(17014118346046923e22)) : C(c * b)) + C(-1));
      break b;
     }
     i = (l(2, h ^ 1065353216), r());
     c = C((d >>> 0 <= 22 ? C(C(C(1) - i) + C(c - e)) : C(C(c - C(e + i)) + C(1))) * b);
    }
    b = c;
   }
   if (k >>> 0 <= 1065353215) {
    if (k >>> 0 < 964689920) {
     break a;
    }
    f = C(m * C(C(b + b) - C(C(b * b) / C(b + C(1)))));
    break a;
   }
   f = C(m * C(b + C(b / C(b + C(1)))));
   break a;
  }
  m = C(C(m + m) * C(1661534994731145e20));
  b = C(c + C(-162.88958740234375));
  d = az(b) & 2047;
  j: {
   k: {
    if (az(C(88)) >>> 0 > d >>> 0) {
     break k;
    }
    c = C(0);
    if (b == C(-Infinity)) {
     break j;
    }
    c = C(b + b);
    if (az(C(Infinity)) >>> 0 <= d >>> 0) {
     break j;
    }
    if (b > C(88.72283172607422)) {
     c = RG(0);
     break j;
    }
    if (!(b < C(-103.97207641601562))) {
     break k;
    }
    c = zG(0);
    break j;
   }
   g = A[165] * +b;
   t = A[164];
   u = g + t;
   g = g - (u - t);
   g = (A[166] * g + A[167]) * (g * g) + (A[168] * g + 1);
   o(+u);
   j(1) | 0;
   d = j(0) | 0;
   h = d << 15;
   d = ((d & 31) << 3) + 1024 | 0;
   k = v[d >> 2];
   d = v[d + 4 >> 2] + h | 0;
   l(0, k | 0);
   l(1, (k >>> 0 < k >>> 0 ? d + 1 | 0 : d) | 0);
   c = C(g * +n());
  }
  f = C(C(m * c) * C(1661534994731145e20));
 }
 c = C(x * f);
 f = C(c / s);
 b = C(f + C(1));
 z[a + 4236 >> 2] = C(C(1) - f) / b;
 f = C(C(w * C(-2)) / b);
 z[a + 4232 >> 2] = f;
 c = C(c * s);
 z[a + 4228 >> 2] = C(C(1) - c) / b;
 z[a + 4224 >> 2] = f;
 z[a + 4220 >> 2] = C(c + C(1)) / b;
}

function nta(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, q = 0, r = 0, s = 0, z = 0, A = 0;
 d = eb - 1104 | 0;
 eb = d;
 v[d + 1100 >> 2] = c;
 i = eE(d + 40 | 0, b);
 r = Ar(i);
 f = Mb(a);
 v[31601] = 0;
 a = Q(202, b | 0) | 0;
 c = v[31601];
 v[31601] = 0;
 a: {
  if ((c | 0) != 1) {
   v[d + 12 >> 2] = a;
   v[d + 36 >> 2] = 85899345;
   a = d + 12 | 0;
   z = d, A = B(v[Gb(a, d + 36 | 0) >> 2], 50), v[z + 24 >> 2] = A;
   c = d + 24 | 0;
   e = v[Gb(d + 1100 | 0, c) >> 2];
   v[31601] = 0;
   N(328, f | 0, e | 0);
   e = v[31601];
   v[31601] = 0;
   if ((e | 0) != 1) {
    v[31601] = 0;
    h = Q(340, c | 0) | 0;
    c = v[31601];
    v[31601] = 0;
    if ((c | 0) != 1) {
     v[31601] = 0;
     g = O(341, a | 0, 8192) | 0;
     a = v[31601];
     v[31601] = 0;
     b: {
      if ((a | 0) != 1) {
       a = v[h >> 2];
       c = 0;
       while (1) {
        if ((c | 0) != 256) {
         e = xb(a, c);
         t[e + 2 | 0] = c;
         u[e >> 1] = 8192;
         c = c + 1 | 0;
         continue;
        }
        break;
       }
       m = 9;
       c: {
        d: while (1) {
         e = 0;
         n = 257;
         while (1) {
          s = m & 255;
          e: {
           while (1) {
            j = n & 65535;
            while (1) {
             v[31601] = 0;
             o = O(158, i | 0, s | 0) | 0;
             a = v[31601];
             v[31601] = 0;
             if ((a | 0) == 1) {
              break c;
             }
             k = o & 65535;
             if ((k | 0) == 257 | j >>> 0 < k >>> 0) {
              break e;
             }
             if (Sc(v[f >> 2], v[f + 4 >> 2]) >>> 0 >= y[d + 1100 >> 2]) {
              break e;
             }
             if ((k | 0) == 256) {
              m = 9;
              continue d;
             }
             c = j >>> 0 > k >>> 0 ? o : e;
             a = v[h >> 2];
             l = 8192;
             while (1) {
              c = c & 65535;
              a = xb(a, c);
              l = l - 1 | 0;
              q = l & 65535;
              z = wb(v[g >> 2], q), A = w[a + 2 | 0], t[z | 0] = A;
              a = v[h >> 2];
              c = x[xb(a, c) >> 1];
              if (c >>> 0 < 8192) {
               continue;
              }
              break;
             }
             a = ub(d + 8 | 0, vb(v[f + 4 >> 2]));
             c = Pe(vb(v[g >> 2]), q);
             l = vb(v[g + 4 >> 2]);
             a = v[a >> 2];
             v[31601] = 0;
             U(329, f | 0, a | 0, c | 0, l | 0);
             a = v[31601];
             v[31601] = 0;
             if ((a | 0) == 1) {
              break c;
             }
             f: {
              if ((j | 0) != (k | 0)) {
               break f;
              }
              a = v[g >> 2];
              v[31601] = 0;
              N(342, f | 0, wb(a, q) | 0);
              a = v[31601];
              v[31601] = 0;
              if ((a | 0) != 1) {
               break f;
              }
              break c;
             }
             if (j >>> 0 >= 8192) {
              e = o;
              continue;
             }
             if (Sc(v[f >> 2], v[f + 4 >> 2]) >>> 0 >= y[d + 1100 >> 2]) {
              continue;
             }
             break;
            }
            a = w[wb(v[g >> 2], q) | 0];
            c = xb(v[h >> 2], j);
            u[c >> 1] = e;
            t[c + 2 | 0] = a;
            a = n + 1 | 0;
            n = 8192;
            e = o;
            c = a & 65535;
            if ((c | 0) == 8192) {
             continue;
            }
            break;
           }
           m = ((c | 0) == 1 << s) + m | 0;
           n = a;
           continue;
          }
          break;
         }
         break;
        }
        a = Ar(i);
        v[31601] = 0;
        O(149, b | 0, ((a - r | 0) + 3 & -4) + r | 0) | 0;
        a = v[31601];
        v[31601] = 0;
        if ((a | 0) == 1) {
         break c;
        }
        ec(g);
        uc(h);
        tb(i);
        eb = d + 1104 | 0;
        return;
       }
       c = M() | 0;
       ec(g);
       break b;
      }
      c = M() | 0;
     }
     uc(h);
     break a;
    }
    c = M() | 0;
    break a;
   }
   c = M() | 0;
   break a;
  }
  c = M() | 0;
 }
 ec(f);
 tb(i);
 P(c | 0);
 p();
}

function J8(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0;
 d = eb - 336 | 0;
 eb = d;
 e = eb - 16 | 0;
 eb = e;
 v[a + 4 >> 2] = 0;
 t[a | 0] = 0;
 f = a + 40 | 0;
 so(f, 32);
 t[e + 15 | 0] = 0;
 ro(f, e + 15 | 0);
 eb = e + 16 | 0;
 e = v[a + 36 >> 2];
 a: {
  if (v[(v[v[e >> 2] - 12 >> 2] + e | 0) + 16 >> 2]) {
   Nh(a, 2, 16777216);
   break a;
  }
  $d(d + 72 | 0, e);
  e = v[d + 84 >> 2];
  v[a + 16 >> 2] = v[d + 80 >> 2];
  v[a + 20 >> 2] = e;
  v[d + 72 >> 2] = 3;
  f = v[a + 36 >> 2];
  e = 0;
  while (1) {
   if (y[d + 72 >> 2] > e >>> 0) {
    Di(f, d + e | 0);
    e = e + 1 | 0;
    continue;
   }
   break;
  }
  if (id(d, 24336, 3)) {
   Nh(a, 2, 512);
   break a;
  }
  t[d + 335 | 0] = 0;
  Di(v[a + 36 >> 2], d + 335 | 0);
  f = d + 72 | 0;
  Qb(f, 0, 256);
  e = w[d + 335 | 0];
  if (e) {
   uj(v[a + 36 >> 2], f, e);
  }
  f = b;
  b = pl(d, d + 72 | 0, e);
  e = Jy(f, b);
  Db(b);
  if (!e) {
   Nh(a, 2, 4096);
  }
  if (ol(w[a | 0])) {
   break a;
  }
  Di(v[a + 36 >> 2], d + 71 | 0);
  b = w[d + 71 | 0];
  e = b & 3;
  u[a + 24 >> 1] = (e | 0) == 3 ? 4 : e;
  if (kj(b, 6)) {
   Pc(d, a + 32 | 0, 9);
   kf(d, 1);
  }
  v[d + 64 >> 2] = 0;
  qK(v[a + 36 >> 2], d - -64 | 0);
  e = v[d + 64 >> 2];
  t[d + 63 | 0] = 0;
  if (e >>> 0 >= 2) {
   Di(v[a + 36 >> 2], d + 71 | 0);
   f = -1;
   if (!w[d + 71 | 0]) {
    Di(v[a + 36 >> 2], d + 63 | 0);
    f = -2;
   }
   Mm(v[a + 36 >> 2], e + f | 0);
  }
  v[d + 48 >> 2] = 0;
  v[d + 52 >> 2] = 0;
  b: {
   if (!kj(b, 4)) {
    break b;
   }
   ml(v[a + 36 >> 2], d + 48 | 0);
   e = v[d + 52 >> 2];
   f = v[d + 48 >> 2];
   v[a + 64 >> 2] = f;
   v[a + 68 >> 2] = e;
   g = v[c + 4 >> 2];
   if ((g | 0) == (e | 0) & y[c >> 2] >= f >>> 0 | e >>> 0 < g >>> 0) {
    break b;
   }
   Nh(a, 1, 4);
  }
  if (kj(b, 5)) {
   Di(v[a + 36 >> 2], d + 71 | 0);
   Mm(v[a + 36 >> 2], w[d + 71 | 0]);
  }
  c = w[d + 63 | 0];
  c: {
   if (!kj(c, 0)) {
    break c;
   }
   Di(v[a + 36 >> 2], d + 71 | 0);
   e = w[d + 71 | 0];
   e = e & 1 ? -1 : e >>> 1 | 0;
   u[a + 24 >> 1] = e;
   if (e) {
    break c;
   }
   Nh(a, 1, 2);
  }
  v[a + 8 >> 2] = 0;
  f = 1;
  if (kj(c, 1)) {
   qK(v[a + 36 >> 2], a + 8 | 0);
  }
  g = kj(b, 2);
  e = a + 32 | 0;
  Pc(d, e, 6);
  kf(d, g);
  g = kj(b, 3);
  Pc(d, e, 7);
  kf(d, g);
  g = x[a + 24 >> 1];
  Pc(d, e, 5);
  kf(d, (g | 0) != 0);
  b = kj(b, 7);
  Pc(d, e, 8);
  kf(d, b);
  Pc(d, e, 5);
  d: {
   if (Fb(v[v[d >> 2] >> 2], v[d + 4 >> 2])) {
    break d;
   }
   Pc(d + 40 | 0, e, 6);
   if (Fb(v[v[d + 40 >> 2] >> 2], v[d + 44 >> 2])) {
    break d;
   }
   Pc(d + 32 | 0, e, 7);
   if (Fb(v[v[d + 32 >> 2] >> 2], v[d + 36 >> 2])) {
    break d;
   }
   Pc(d + 24 | 0, e, 8);
   f = Fb(v[v[d + 24 >> 2] >> 2], v[d + 28 >> 2]);
  }
  b = d + 16 | 0;
  Pc(b, e, 11);
  kf(b, f);
  Pc(d, e, 11);
  if (kj(c, 2)) {
   u[d + 40 >> 1] = 0;
   By(v[a + 36 >> 2], d + 40 | 0);
   b = v[a + 36 >> 2];
   f = x[d + 40 >> 1];
   Pc(d, e, 9);
   Mm(b, f << Fb(v[v[d >> 2] >> 2], v[d + 4 >> 2]));
  }
  if (kj(c, 3)) {
   Mm(v[a + 36 >> 2], 5);
  }
  ml(v[a + 36 >> 2], d + 48 | 0);
  c = v[d + 52 >> 2];
  f = c;
  b = v[d + 48 >> 2];
  if (!c & b >>> 0 >= 16001 | c) {
   Nh(a, 2, 8192);
   break a;
  }
  v[a + 104 >> 2] = b;
  if (!b) {
   Nh(a, 1, 1);
  }
  Pc(d, e, 11);
  e: {
   if (!Fb(v[v[d >> 2] >> 2], v[d + 4 >> 2])) {
    break e;
   }
   ml(v[a + 36 >> 2], d + 48 | 0);
   c = v[d + 52 >> 2];
   f = c;
   b = v[d + 48 >> 2];
   if (zy(b, c)) {
    break e;
   }
   Nh(a, 2, 2048);
   break a;
  }
  $d(d, v[a + 36 >> 2]);
  g = v[d + 8 >> 2];
  h = v[a + 16 >> 2];
  c = g - h | 0;
  g = v[d + 12 >> 2] - (v[a + 20 >> 2] + (g >>> 0 < h >>> 0) | 0) | 0;
  if ((g | 0) < 0) {
   Nh(a, 2, 16384);
   break a;
  }
  v[a + 96 >> 2] = c;
  v[a + 100 >> 2] = g;
  Pc(d, e, 11);
  c = v[a + 100 >> 2];
  g = b;
  h = v[a + 96 >> 2];
  b = Fb(v[v[d >> 2] >> 2], v[d + 4 >> 2]);
  v[a + 72 >> 2] = b ? g : h;
  v[a + 76 >> 2] = b ? f : c;
  Pc(d, e, 11);
  if (!Fb(v[v[d >> 2] >> 2], v[d + 4 >> 2])) {
   b = v[a + 100 >> 2] + v[a + 20 >> 2] | 0;
   f = v[a + 16 >> 2];
   c = f + v[a + 96 >> 2] | 0;
   v[a + 80 >> 2] = c;
   v[a + 84 >> 2] = c >>> 0 < f >>> 0 ? b + 1 | 0 : b;
  }
  Pc(d, e, 10);
  kf(d, 1);
 }
 eb = d + 336 | 0;
}

function U6(a, b, c, d, e, f, g, h) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 f = f | 0;
 g = g | 0;
 h = h | 0;
 var i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0;
 q = eb - 16 | 0;
 eb = q;
 i = c;
 while (1) {
  a: {
   if ((d | 0) == (i | 0)) {
    i = d;
    break a;
   }
   if (!w[i | 0]) {
    break a;
   }
   i = i + 1 | 0;
   continue;
  }
  break;
 }
 v[h >> 2] = f;
 v[e >> 2] = c;
 while (1) {
  b: {
   c: {
    d: {
     if ((c | 0) == (d | 0) | (f | 0) == (g | 0)) {
      break d;
     }
     k = v[b + 4 >> 2];
     v[q + 8 >> 2] = v[b >> 2];
     v[q + 12 >> 2] = k;
     r = eb - 16 | 0;
     eb = r;
     u = qh(r + 12 | 0, v[a + 8 >> 2]);
     o = i - c | 0;
     l = 0;
     n = eb - 1040 | 0;
     eb = n;
     k = v[e >> 2];
     v[n + 12 >> 2] = k;
     p = f ? f : n + 16 | 0;
     m = f ? g - f >> 2 : 256;
     e: {
      f: {
       g: {
        if (!(!k | !m)) {
         while (1) {
          j = o >>> 2 | 0;
          if (!(o >>> 0 > 131 | j >>> 0 >= m >>> 0)) {
           j = k;
           break f;
          }
          s = cK(p, n + 12 | 0, j >>> 0 < m >>> 0 ? j : m, b);
          j = v[n + 12 >> 2];
          if ((s | 0) == -1) {
           m = 0;
           l = -1;
           break g;
          }
          t = (n + 16 | 0) != (p | 0) ? s : 0;
          m = m - t | 0;
          p = (t << 2) + p | 0;
          o = j ? (k + o | 0) - j | 0 : 0;
          l = l + s | 0;
          if (!j) {
           break g;
          }
          k = j;
          if (m) {
           continue;
          }
          break g;
         }
        }
        j = k;
       }
       if (!j) {
        break e;
       }
      }
      if (!m | !o) {
       break e;
      }
      k = l;
      while (1) {
       h: {
        l = fq(p, j, o, b);
        i: {
         if (l + 2 >>> 0 <= 2) {
          j: {
           switch (l + 1 | 0) {
           case 1:
            v[n + 12 >> 2] = 0;
            break i;

           case 0:
            break e;

           default:
            break j;
           }
          }
          v[b >> 2] = 0;
          break i;
         }
         j = v[n + 12 >> 2] + l | 0;
         v[n + 12 >> 2] = j;
         k = k + 1 | 0;
         m = m - 1 | 0;
         if (m) {
          break h;
         }
        }
        l = k;
        break e;
       }
       p = p + 4 | 0;
       o = o - l | 0;
       l = k;
       if (o) {
        continue;
       }
       break;
      }
     }
     if (f) {
      v[e >> 2] = v[n + 12 >> 2];
     }
     eb = n + 1040 | 0;
     ph(u);
     eb = r + 16 | 0;
     k: {
      l: {
       m: {
        n: {
         if ((l | 0) == -1) {
          while (1) {
           v[h >> 2] = f;
           if (v[e >> 2] == (c | 0)) {
            break d;
           }
           g = 1;
           o: {
            p: {
             q: {
              b = py(f, c, i - c | 0, q + 8 | 0, v[a + 8 >> 2]);
              switch (b + 2 | 0) {
              case 0:
               break l;

              case 2:
               break o;

              case 1:
               break q;

              default:
               break p;
              }
             }
             v[e >> 2] = c;
             break n;
            }
            g = b;
           }
           c = c + g | 0;
           f = v[h >> 2] + 4 | 0;
           continue;
          }
         }
         f = v[h >> 2] + (l << 2) | 0;
         v[h >> 2] = f;
         if ((f | 0) == (g | 0)) {
          break k;
         }
         c = v[e >> 2];
         if ((d | 0) == (i | 0)) {
          i = d;
          continue;
         }
         if (!py(f, c, 1, b, v[a + 8 >> 2])) {
          break m;
         }
        }
        a = 2;
        break c;
       }
       v[h >> 2] = v[h >> 2] + 4;
       c = v[e >> 2] + 1 | 0;
       v[e >> 2] = c;
       i = c;
       while (1) {
        if ((d | 0) == (i | 0)) {
         i = d;
         break b;
        }
        if (!w[i | 0]) {
         break b;
        }
        i = i + 1 | 0;
        continue;
       }
      }
      v[e >> 2] = c;
      a = 1;
      break c;
     }
     c = v[e >> 2];
    }
    a = (c | 0) != (d | 0);
   }
   eb = q + 16 | 0;
   return a | 0;
  }
  f = v[h >> 2];
  continue;
 }
}

function gI(a, b) {
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, k = 0, m = 0, p = 0;
 i = eb - 48 | 0;
 eb = i;
 o(+a);
 e = j(1) | 0;
 d = j(0) | 0;
 a: {
  b: {
   h = e & 2147483647;
   c: {
    if (h >>> 0 <= 1074752122) {
     if ((e & 1048575) == 598523) {
      break c;
     }
     if (h >>> 0 <= 1073928572) {
      if ((e | 0) > 0 | (e | 0) >= 0) {
       a = a + -1.5707963267341256;
       c = a + -6077100506506192e-26;
       A[b >> 3] = c;
       A[b + 8 >> 3] = a - c + -6077100506506192e-26;
       d = 1;
       break a;
      }
      a = a + 1.5707963267341256;
      c = a + 6077100506506192e-26;
      A[b >> 3] = c;
      A[b + 8 >> 3] = a - c + 6077100506506192e-26;
      d = -1;
      break a;
     }
     if ((e | 0) > 0 | (e | 0) >= 0) {
      a = a + -3.1415926534682512;
      c = a + -1.2154201013012384e-10;
      A[b >> 3] = c;
      A[b + 8 >> 3] = a - c + -1.2154201013012384e-10;
      d = 2;
      break a;
     }
     a = a + 3.1415926534682512;
     c = a + 1.2154201013012384e-10;
     A[b >> 3] = c;
     A[b + 8 >> 3] = a - c + 1.2154201013012384e-10;
     d = -2;
     break a;
    }
    if (h >>> 0 <= 1075594811) {
     if (h >>> 0 <= 1075183036) {
      if ((h | 0) == 1074977148) {
       break c;
      }
      if ((e | 0) > 0 | (e | 0) >= 0) {
       a = a + -4.712388980202377;
       c = a + -1.8231301519518578e-10;
       A[b >> 3] = c;
       A[b + 8 >> 3] = a - c + -1.8231301519518578e-10;
       d = 3;
       break a;
      }
      a = a + 4.712388980202377;
      c = a + 1.8231301519518578e-10;
      A[b >> 3] = c;
      A[b + 8 >> 3] = a - c + 1.8231301519518578e-10;
      d = -3;
      break a;
     }
     if ((h | 0) == 1075388923) {
      break c;
     }
     if ((e | 0) > 0 | (e | 0) >= 0) {
      a = a + -6.2831853069365025;
      c = a + -2.430840202602477e-10;
      A[b >> 3] = c;
      A[b + 8 >> 3] = a - c + -2.430840202602477e-10;
      d = 4;
      break a;
     }
     a = a + 6.2831853069365025;
     c = a + 2.430840202602477e-10;
     A[b >> 3] = c;
     A[b + 8 >> 3] = a - c + 2.430840202602477e-10;
     d = -4;
     break a;
    }
    if (h >>> 0 > 1094263290) {
     break b;
    }
   }
   f = a * .6366197723675814 + 6755399441055744 + -6755399441055744;
   c = a + f * -1.5707963267341256;
   g = f * 6077100506506192e-26;
   p = c - g;
   e = p < -.7853981633974483;
   if (D(f) < 2147483648) {
    d = ~~f;
   } else {
    d = -2147483648;
   }
   d: {
    if (e) {
     d = d - 1 | 0;
     f = f + -1;
     g = f * 6077100506506192e-26;
     c = a + f * -1.5707963267341256;
     break d;
    }
    if (!(p > .7853981633974483)) {
     break d;
    }
    d = d + 1 | 0;
    f = f + 1;
    g = f * 6077100506506192e-26;
    c = a + f * -1.5707963267341256;
   }
   a = c - g;
   A[b >> 3] = a;
   o(+a);
   e = j(1) | 0;
   j(0) | 0;
   k = h >>> 20 | 0;
   e: {
    if ((k - (e >>> 20 & 2047) | 0) < 17) {
     break e;
    }
    g = c;
    a = f * 6077100506303966e-26;
    c = c - a;
    g = f * 20222662487959506e-37 - (g - c - a);
    a = c - g;
    A[b >> 3] = a;
    o(+a);
    e = j(1) | 0;
    j(0) | 0;
    if ((k - (e >>> 20 & 2047) | 0) < 50) {
     break e;
    }
    g = c;
    a = f * 20222662487111665e-37;
    c = c - a;
    g = f * 84784276603689e-45 - (g - c - a);
    a = c - g;
    A[b >> 3] = a;
   }
   A[b + 8 >> 3] = c - a - g;
   break a;
  }
  if (h >>> 0 >= 2146435072) {
   a = a - a;
   A[b >> 3] = a;
   A[b + 8 >> 3] = a;
   d = 0;
   break a;
  }
  l(0, d | 0);
  l(1, e & 1048575 | 1096810496);
  a = +n();
  d = 0;
  k = 1;
  while (1) {
   m = (i + 16 | 0) + (d << 3) | 0;
   if (D(a) < 2147483648) {
    d = ~~a;
   } else {
    d = -2147483648;
   }
   c = +(d | 0);
   A[m >> 3] = c;
   a = (a - c) * 16777216;
   d = 1;
   m = k;
   k = 0;
   if (m) {
    continue;
   }
   break;
  }
  A[i + 32 >> 3] = a;
  d = 2;
  while (1) {
   k = d;
   d = d - 1 | 0;
   m = i + 16 | 0;
   if (A[m + (k << 3) >> 3] == 0) {
    continue;
   }
   break;
  }
  d = uL(m, i, (h >>> 20 | 0) - 1046 | 0, k + 1 | 0, 1);
  a = A[i >> 3];
  if ((e | 0) < 0) {
   A[b >> 3] = -a;
   A[b + 8 >> 3] = -A[i + 8 >> 3];
   d = 0 - d | 0;
   break a;
  }
  A[b >> 3] = a;
  A[b + 8 >> 3] = A[i + 8 >> 3];
 }
 eb = i + 48 | 0;
 return d;
}

function nP(a, b, c, d, e, f, g, h, i) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 f = f | 0;
 g = g | 0;
 h = h | 0;
 i = i | 0;
 var j = 0, k = 0, l = 0, m = 0, n = 0;
 k = eb - 48 | 0;
 eb = k;
 a: {
  b: {
   c: {
    d: {
     e: {
      f: {
       j = hr(1, 28);
       if (!j) {
        a = Pm(cc(4));
        v[31601] = 0;
        R(97, a | 0, 124508, 34);
        a = v[31601];
        v[31601] = 0;
        if ((a | 0) != 1) {
         break a;
        }
        break f;
       }
       v[j + 12 >> 2] = f;
       v[j + 8 >> 2] = e;
       v[j + 4 >> 2] = d;
       f = c ? c : 976;
       v[j >> 2] = f;
       c = ng(k + 36 | 0);
       g: {
        h: {
         i: {
          if (!i) {
           break i;
          }
          while (1) {
           e = v[i >> 2];
           if (!e) {
            break i;
           }
           l = v[i + 4 >> 2];
           j: {
            if (l) {
             v[31601] = 0;
             e = O(36, k + 24 | 0, e | 0) | 0;
             m = v[31601];
             v[31601] = 0;
             k: {
              if ((m | 0) != 1) {
               v[31601] = 0;
               m = O(987, c | 0, e | 0) | 0;
               n = v[31601];
               v[31601] = 0;
               if ((n | 0) == 1) {
                break k;
               }
               v[31601] = 0;
               N(272, m | 0, l | 0);
               l = v[31601];
               v[31601] = 0;
               if ((l | 0) == 1) {
                break k;
               }
               break j;
              }
              i = S(0) | 0;
              break g;
             }
             i = S(0) | 0;
             sb(e);
             break g;
            }
            v[31601] = 0;
            e = O(36, k + 12 | 0, e | 0) | 0;
            l = v[31601];
            v[31601] = 0;
            if ((l | 0) == 1) {
             break h;
            }
            ju(c, e);
           }
           sb(e);
           i = i + 8 | 0;
           continue;
          }
         }
         v[31601] = 0;
         e = Q(851, 80) | 0;
         i = v[31601];
         v[31601] = 0;
         l: {
          m: {
           n: {
            if ((i | 0) != 1) {
             v[31601] = 0;
             d = O(988, f | 0, d | 0) | 0;
             f = v[31601];
             v[31601] = 0;
             if ((f | 0) == 1) {
              break n;
             }
             v[k + 4 >> 2] = d;
             d = k + 4 | 0;
             f = v[re(k + 8 | 0, d) >> 2];
             v[31601] = 0;
             a = ga(993, e | 0, a | 0, b | 0, f | 0, c | 0) | 0;
             b = v[31601];
             v[31601] = 0;
             if ((b | 0) != 1) {
              break l;
             }
             i = S(0) | 0;
             Wc(d);
             break m;
            }
            i = S(0) | 0;
            break g;
           }
           i = S(0) | 0;
          }
          Bb(e);
          break g;
         }
         v[j + 24 >> 2] = a;
         Wc(k + 4 | 0);
         Ll(c);
         i = j;
         break d;
        }
        i = S(0) | 0;
       }
       Ll(c);
       X(i | 0) | 0;
       v[31601] = 0;
       U(982, 15070, j | 0, g | 0, h | 0);
       a = v[31601];
       v[31601] = 0;
       if ((a | 0) != 1) {
        v[31601] = 0;
        W(26);
        a = v[31601];
        v[31601] = 0;
        if ((a | 0) == 1) {
         break f;
        }
        a = v[j + 24 >> 2];
        if (a) {
         Bb(tq(a));
        }
        i = 0;
        v[j + 24 >> 2] = 0;
        a = v[j + 20 >> 2];
        if (a) {
         Bb(a);
         v[j + 20 >> 2] = 0;
        }
        Bb(j);
        break d;
       }
       i = S(0) | 0;
       v[31601] = 0;
       W(26);
       a = v[31601];
       v[31601] = 0;
       if ((a | 0) != 1) {
        break e;
       }
       break b;
      }
      i = S(0) | 0;
     }
     X(i | 0) | 0;
     i = 0;
     v[31601] = 0;
     U(982, 15070, 0, g | 0, h | 0);
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) == 1) {
      break c;
     }
     Y();
    }
    eb = k + 48 | 0;
    return i | 0;
   }
   a = M() | 0;
   v[31601] = 0;
   W(26);
   b = v[31601];
   v[31601] = 0;
   if ((b | 0) == 1) {
    break b;
   }
   P(a | 0);
   p();
  }
  S(0) | 0;
  Rb();
 }
 p();
}

function Cra(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = C(0), i = 0, j = C(0);
 e = eb - 96 | 0;
 eb = e;
 d = eb - 16 | 0;
 eb = d;
 c = b + 16 | 0;
 _Y(d + 8 | 0, c);
 g = v[d + 12 >> 2];
 ic(d, v[a >> 2], v[a + 8 >> 2], v[d + 8 >> 2], v[d + 12 >> 2]);
 f = v[d + 4 >> 2];
 if ((f | 0) == (g | 0)) {
  Ub(a, v[d + 12 >> 2]);
 }
 eb = d + 16 | 0;
 if ((f | 0) != (g | 0)) {
  Qb(c, 0, 128);
 }
 t[b + 79 | 0] = 0;
 t[b + 143 | 0] = 0;
 v[b + 152 >> 2] = -2147483648;
 v[b + 156 >> 2] = -2147483648;
 d = e + 56 | 0;
 ge(d, a, Qg(a));
 g = gc(e + 76 | 0, d);
 tb(d);
 v[31601] = 0;
 c = Q(202, g | 0) | 0;
 f = v[31601];
 v[31601] = 0;
 a: {
  b: {
   if ((f | 0) == 1) {
    break b;
   }
   v[31601] = 0;
   N(287, b + 4 | 0, c | 0);
   c = v[31601];
   v[31601] = 0;
   if ((c | 0) == 1) {
    break b;
   }
   oe(e + 48 | 0, v[b + 4 >> 2], v[b + 8 >> 2]);
   v[31601] = 0;
   Xn(471, d, g, v[e + 48 >> 2], v[e + 52 >> 2]);
   c = v[31601];
   v[31601] = 0;
   if ((c | 0) != 1) {
    v[31601] = 0;
    f = Q(151, a | 0) | 0;
    c = v[31601];
    v[31601] = 0;
    c: {
     if ((c | 0) == 1) {
      break c;
     }
     v[31601] = 0;
     c = e + 28 | 0;
     R(185, c | 0, a | 0, f | 0);
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) == 1) {
      break c;
     }
     d = gc(d, c);
     tb(c);
     a = v[d >> 2];
     v[31601] = 0;
     a = Q(172, a | 0) | 0;
     c = v[31601];
     v[31601] = 0;
     d: {
      if ((c | 0) != 1) {
       e: {
        f: {
         g: {
          if (!a) {
           break g;
          }
          while (1) {
           a = v[d + 8 >> 2];
           c = v[d >> 2];
           v[31601] = 0;
           a = T(150, c | 0, a | 0, 5) | 0;
           c = v[31601];
           v[31601] = 0;
           if ((c | 0) == 1) {
            break f;
           }
           if (!a) {
            break g;
           }
           v[31601] = 0;
           O(472, d | 0, e + 24 | 0) | 0;
           a = v[31601];
           v[31601] = 0;
           h: {
            if ((a | 0) != 1) {
             a = 4;
             c = w[e + 24 | 0] | w[e + 25 | 0] << 8 | (w[e + 26 | 0] << 16 | w[e + 27 | 0] << 24);
             if ((c | 0) == 1414682436 | (c | 0) == 1196380752) {
              break h;
             }
             v[31601] = 0;
             a = Q(151, d | 0) | 0;
             c = v[31601];
             v[31601] = 0;
             if ((c | 0) != 1) {
              break h;
             }
             a = M() | 0;
             break d;
            }
            a = M() | 0;
            break d;
           }
           v[31601] = 0;
           f = e + 4 | 0;
           R(185, f | 0, d | 0, a | 0);
           a = v[31601];
           v[31601] = 0;
           i: {
            j: {
             if ((a | 0) != 1) {
              c = gc(e + 28 | 0, f);
              tb(f);
              if ((w[e + 24 | 0] | w[e + 25 | 0] << 8 | (w[e + 26 | 0] << 16 | w[e + 27 | 0] << 24)) != 1414682436) {
               break j;
              }
              v[31601] = 0;
              h = C(wa(473, c | 0));
              a = v[31601];
              v[31601] = 0;
              if ((a | 0) == 1) {
               break e;
              }
              i = b, j = Od(h, C(0)), z[i + 144 >> 2] = j;
              break i;
             }
             a = M() | 0;
             break d;
            }
            if ((w[e + 24 | 0] | w[e + 25 | 0] << 8 | (w[e + 26 | 0] << 16 | w[e + 27 | 0] << 24)) != 1196380752) {
             break i;
            }
            v[31601] = 0;
            a = Q(151, c | 0) | 0;
            f = v[31601];
            v[31601] = 0;
            if ((f | 0) == 1) {
             break e;
            }
            v[b + 148 >> 2] = a;
           }
           tb(c);
           continue;
          }
         }
         tb(d);
         tb(g);
         eb = e + 96 | 0;
         return;
        }
        a = M() | 0;
        break d;
       }
       a = M() | 0;
       tb(c);
       break d;
      }
      a = M() | 0;
     }
     tb(d);
     break a;
    }
    a = M() | 0;
    break a;
   }
   a = M() | 0;
   break a;
  }
  a = M() | 0;
 }
 tb(g);
 P(a | 0);
 p();
}

function rV(a, b) {
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0;
 c = eb - 32 | 0;
 eb = c;
 e = w[a + 13 | 0];
 a: {
  if (e & 227 | (e & 24) == 16) {
   break a;
  }
  e = w[a + 8 | 0];
  f = w[a + 6 | 0] | w[a + 7 | 0] << 8;
  t[c + 22 | 0] = 0;
  t[c + 26 | 0] = e;
  u[c + 24 >> 1] = f;
  u[c + 20 >> 1] = 0;
  while (1) {
   if ((d | 0) != 3) {
    e = wb(c + 24 | 0, d);
    h = wb(c + 20 | 0, d), i = w[e | 0], t[h | 0] = i;
    d = d + 1 | 0;
    continue;
   }
   break;
  }
  e = bg(c + 20 | 0);
  f = w[a + 11 | 0];
  g = w[a + 9 | 0] | w[a + 10 | 0] << 8;
  d = 0;
  t[c + 18 | 0] = 0;
  t[c + 26 | 0] = f;
  u[c + 24 >> 1] = g;
  u[c + 16 >> 1] = 0;
  while (1) {
   if ((d | 0) != 3) {
    f = wb(c + 24 | 0, d);
    h = wb(c + 16 | 0, d), i = w[f | 0], t[h | 0] = i;
    d = d + 1 | 0;
    continue;
   }
   break;
  }
  d = 0;
  if (bg(c + 16 | 0) >>> 0 < e >>> 0) {
   break a;
  }
  e = a + 6 | 0;
  d = a + 9 | 0;
  f = w[d + 2 | 0];
  g = w[d | 0] | w[d + 1 | 0] << 8;
  d = 0;
  t[c + 22 | 0] = 0;
  t[c + 26 | 0] = f;
  u[c + 24 >> 1] = g;
  u[c + 20 >> 1] = 0;
  while (1) {
   if ((d | 0) != 3) {
    f = wb(c + 24 | 0, d);
    h = wb(c + 20 | 0, d), i = w[f | 0], t[h | 0] = i;
    d = d + 1 | 0;
    continue;
   }
   break;
  }
  f = bg(c + 20 | 0);
  g = w[e + 2 | 0];
  e = w[e | 0] | w[e + 1 | 0] << 8;
  d = 0;
  t[c + 18 | 0] = 0;
  t[c + 26 | 0] = g;
  u[c + 24 >> 1] = e;
  u[c + 16 >> 1] = 0;
  while (1) {
   if ((d | 0) != 3) {
    e = wb(c + 24 | 0, d);
    h = wb(c + 16 | 0, d), i = w[e | 0], t[h | 0] = i;
    d = d + 1 | 0;
    continue;
   }
   break;
  }
  e = bg(c + 16 | 0);
  b: {
   if (!((b | 0) == 2 | (e | 0) == (f | 0))) {
    d = 0;
    if ((w[a + 14 | 0] | w[a + 15 | 0] << 8) >>> 0 >= 100) {
     break b;
    }
    break a;
   }
   if ((e | 0) == (f | 0) | (b | 0) != 2) {
    break b;
   }
   d = 0;
   if ((w[a + 14 | 0] | w[a + 15 | 0] << 8) << 16 >> 16 < 0) {
    break a;
   }
  }
  b = w[a + 13 | 0];
  e = f - e | 0;
  if (e & 1) {
   d = 0;
   if (b & 4) {
    break a;
   }
  }
  c: {
   if (b & 8) {
    b = w[a + 5 | 0];
    f = w[a + 3 | 0] | w[a + 4 | 0] << 8;
    d = 0;
    t[c + 22 | 0] = 0;
    u[c + 24 >> 1] = f;
    t[c + 26 | 0] = b;
    u[c + 20 >> 1] = 0;
    while (1) {
     if ((d | 0) != 3) {
      b = wb(c + 24 | 0, d);
      h = wb(c + 20 | 0, d), i = w[b | 0], t[h | 0] = i;
      d = d + 1 | 0;
      continue;
     }
     break;
    }
    if (!bg(c + 20 | 0)) {
     break c;
    }
   }
   b = w[a + 5 | 0];
   f = w[a + 3 | 0] | w[a + 4 | 0] << 8;
   d = 0;
   t[c + 22 | 0] = 0;
   t[c + 26 | 0] = b;
   u[c + 24 >> 1] = f;
   u[c + 20 >> 1] = 0;
   while (1) {
    if ((d | 0) != 3) {
     b = wb(c + 24 | 0, d);
     h = wb(c + 20 | 0, d), i = w[b | 0], t[h | 0] = i;
     d = d + 1 | 0;
     continue;
    }
    break;
   }
   if (bg(c + 20 | 0)) {
    b = a + 3 | 0;
    f = w[b + 2 | 0];
    g = w[b | 0] | w[b + 1 | 0] << 8;
    d = 0;
    t[c + 18 | 0] = 0;
    u[c + 24 >> 1] = g;
    t[c + 26 | 0] = f;
    u[c + 16 >> 1] = 0;
    while (1) {
     if ((d | 0) != 3) {
      f = wb(c + 24 | 0, d);
      h = wb(c + 16 | 0, d), i = w[f | 0], t[h | 0] = i;
      d = d + 1 | 0;
      continue;
     }
     break;
    }
    if (bg(c + 16 | 0) >>> 0 >= e >>> 0) {
     break c;
    }
    e = w[a + 2 | 0];
    a = w[a | 0] | w[a + 1 | 0] << 8;
    d = 0;
    t[c + 14 | 0] = 0;
    u[c + 24 >> 1] = a;
    t[c + 26 | 0] = e;
    u[c + 12 >> 1] = 0;
    while (1) {
     if ((d | 0) != 3) {
      a = wb(c + 24 | 0, d);
      h = wb(c + 12 | 0, d), i = w[a | 0], t[h | 0] = i;
      d = d + 1 | 0;
      continue;
     }
     break;
    }
    a = bg(c + 12 | 0);
    e = w[b + 2 | 0];
    b = w[b | 0] | w[b + 1 | 0] << 8;
    d = 0;
    t[c + 10 | 0] = 0;
    t[c + 26 | 0] = e;
    u[c + 24 >> 1] = b;
    u[c + 8 >> 1] = 0;
    while (1) {
     if ((d | 0) != 3) {
      b = wb(c + 24 | 0, d);
      h = wb(c + 8 | 0, d), i = w[b | 0], t[h | 0] = i;
      d = d + 1 | 0;
      continue;
     }
     break;
    }
    d = 0;
    if (bg(c + 8 | 0) >>> 0 <= a >>> 0) {
     break a;
    }
   }
   d = 1;
   break a;
  }
  d = 0;
 }
 eb = c + 32 | 0;
 return d;
}

function tfa(a, b, c, d, e, f, g, h, i) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 f = f | 0;
 g = g | 0;
 h = h | 0;
 i = i | 0;
 var j = 0, k = 0, l = 0, m = 0, n = 0;
 k = eb - 48 | 0;
 eb = k;
 a: {
  b: {
   c: {
    j = hr(1, 32);
    d: {
     e: {
      if (!j) {
       a = Pm(cc(4));
       v[31601] = 0;
       R(97, a | 0, 124508, 34);
       a = v[31601];
       v[31601] = 0;
       if ((a | 0) != 1) {
        break a;
       }
       i = S(0) | 0;
       break e;
      }
      v[j + 12 >> 2] = f;
      v[j + 8 >> 2] = e;
      v[j + 4 >> 2] = d;
      f = c ? c : 976;
      v[j >> 2] = f;
      c = ng(k + 36 | 0);
      f: {
       g: {
        h: {
         if (!i) {
          break h;
         }
         while (1) {
          e = v[i >> 2];
          if (!e) {
           break h;
          }
          l = v[i + 4 >> 2];
          i: {
           if (l) {
            v[31601] = 0;
            e = O(36, k + 24 | 0, e | 0) | 0;
            m = v[31601];
            v[31601] = 0;
            j: {
             if ((m | 0) != 1) {
              v[31601] = 0;
              m = O(987, c | 0, e | 0) | 0;
              n = v[31601];
              v[31601] = 0;
              if ((n | 0) == 1) {
               break j;
              }
              v[31601] = 0;
              N(272, m | 0, l | 0);
              l = v[31601];
              v[31601] = 0;
              if ((l | 0) == 1) {
               break j;
              }
              break i;
             }
             i = S(0) | 0;
             break f;
            }
            i = S(0) | 0;
            sb(e);
            break f;
           }
           v[31601] = 0;
           e = O(36, k + 12 | 0, e | 0) | 0;
           l = v[31601];
           v[31601] = 0;
           if ((l | 0) == 1) {
            break g;
           }
           ju(c, e);
          }
          sb(e);
          i = i + 8 | 0;
          continue;
         }
        }
        v[31601] = 0;
        e = Q(851, 104) | 0;
        i = v[31601];
        v[31601] = 0;
        k: {
         l: {
          m: {
           if ((i | 0) != 1) {
            v[31601] = 0;
            d = O(988, f | 0, d | 0) | 0;
            f = v[31601];
            v[31601] = 0;
            if ((f | 0) == 1) {
             break m;
            }
            v[k + 4 >> 2] = d;
            d = k + 4 | 0;
            f = v[re(k + 8 | 0, d) >> 2];
            v[31601] = 0;
            a = ga(1019, e | 0, a | 0, b | 0, f | 0, c | 0) | 0;
            b = v[31601];
            v[31601] = 0;
            if ((b | 0) != 1) {
             break k;
            }
            i = S(0) | 0;
            Wc(d);
            break l;
           }
           i = S(0) | 0;
           break f;
          }
          i = S(0) | 0;
         }
         Bb(e);
         break f;
        }
        v[j + 28 >> 2] = a;
        Wc(k + 4 | 0);
        v[j + 24 >> 2] = a + 8;
        Ll(c);
        break d;
       }
       i = S(0) | 0;
      }
      Ll(c);
      X(i | 0) | 0;
      v[31601] = 0;
      U(982, 4973, j | 0, g | 0, h | 0);
      a = v[31601];
      v[31601] = 0;
      if ((a | 0) != 1) {
       v[31601] = 0;
       W(26);
       a = v[31601];
       v[31601] = 0;
       if ((a | 0) != 1) {
        a = v[j + 28 >> 2];
        if (a) {
         hb[v[v[a >> 2] + 4 >> 2]](a);
        }
        v[j + 24 >> 2] = 0;
        v[j + 28 >> 2] = 0;
        a = v[j + 20 >> 2];
        if (a) {
         Bb(a);
         v[j + 20 >> 2] = 0;
        }
        Bb(j);
        j = 0;
        break d;
       }
       i = S(0) | 0;
       break e;
      }
      i = S(0) | 0;
      v[31601] = 0;
      W(26);
      a = v[31601];
      v[31601] = 0;
      if ((a | 0) == 1) {
       break b;
      }
     }
     X(i | 0) | 0;
     j = 0;
     v[31601] = 0;
     U(982, 4973, 0, g | 0, h | 0);
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) == 1) {
      break c;
     }
     Y();
    }
    eb = k + 48 | 0;
    return j | 0;
   }
   a = M() | 0;
   v[31601] = 0;
   W(26);
   b = v[31601];
   v[31601] = 0;
   if ((b | 0) == 1) {
    break b;
   }
   P(a | 0);
   p();
  }
  S(0) | 0;
  Rb();
 }
 p();
}

function tt(a, b, c, d, e, f, g) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 f = f | 0;
 g = g | 0;
 var h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, q = 0, r = 0, s = 0, u = 0;
 i = eb - 128 | 0;
 eb = i;
 v[i + 124 >> 2] = b;
 k = xt(c, d);
 v[i + 4 >> 2] = 1238;
 n = wt(i + 8 | 0, i + 4 | 0);
 j = i + 16 | 0;
 a: {
  b: {
   if (k >>> 0 >= 101) {
    j = Fd(k);
    if (!j) {
     v[31601] = 0;
     W(1239);
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) != 1) {
      break a;
     }
     break b;
    }
    Qe(n, j);
   }
   h = j;
   b = c;
   c: {
    d: {
     while (1) {
      if ((b | 0) == (d | 0)) {
       e: while (1) {
        f: {
         v[31601] = 0;
         h = O(1256, a | 0, i + 124 | 0) | 0;
         b = v[31601];
         v[31601] = 0;
         if ((b | 0) == 1) {
          break f;
         }
         if ((!k | h) == 1) {
          v[31601] = 0;
          b = O(1256, a | 0, i + 124 | 0) | 0;
          a = v[31601];
          v[31601] = 0;
          if ((a | 0) == 1) {
           break c;
          }
          if (!b) {
           break d;
          }
          v[f >> 2] = v[f >> 2] | 2;
          break d;
         }
         b = v[a >> 2];
         v[31601] = 0;
         o = Q(1257, b | 0) | 0;
         b = v[31601];
         v[31601] = 0;
         g: {
          if ((b | 0) != 1) {
           if (g) {
            break g;
           }
           v[31601] = 0;
           o = O(1258, e | 0, o | 0) | 0;
           b = v[31601];
           v[31601] = 0;
           if ((b | 0) != 1) {
            break g;
           }
          }
          break b;
         }
         l = q + 1 | 0;
         s = 0;
         h = j;
         b = c;
         while (1) {
          if ((b | 0) == (d | 0)) {
           q = l;
           if (!s) {
            continue e;
           }
           v[31601] = 0;
           Q(1259, a | 0) | 0;
           b = v[31601];
           v[31601] = 0;
           if ((b | 0) != 1) {
            h = j;
            b = c;
            if (k + m >>> 0 < 2) {
             continue e;
            }
            while (1) {
             if ((b | 0) == (d | 0)) {
              continue e;
             }
             h: {
              if (w[h | 0] != 2) {
               break h;
              }
              if ((Cb(v[b + 4 >> 2], w[b + 11 | 0]) | 0) == (q | 0)) {
               break h;
              }
              t[h | 0] = 0;
              m = m - 1 | 0;
             }
             h = h + 1 | 0;
             b = b + 12 | 0;
             continue;
            }
           }
           break b;
          }
          i: {
           if (w[h | 0] != 1) {
            break i;
           }
           r = v[Vd(b, q) >> 2];
           j: {
            if (g) {
             break j;
            }
            v[31601] = 0;
            r = O(1258, e | 0, r | 0) | 0;
            u = v[31601];
            v[31601] = 0;
            if ((u | 0) != 1) {
             break j;
            }
            break b;
           }
           k: {
            if ((o | 0) == (r | 0)) {
             s = 1;
             if ((Cb(v[b + 4 >> 2], w[b + 11 | 0]) | 0) != (l | 0)) {
              break i;
             }
             t[h | 0] = 2;
             m = m + 1 | 0;
             break k;
            }
            t[h | 0] = 0;
           }
           k = k - 1 | 0;
          }
          h = h + 1 | 0;
          b = b + 12 | 0;
          continue;
         }
        }
        break;
       }
      } else {
       l = zd(v[b + 4 >> 2], w[b + 11 | 0]);
       t[h | 0] = l ? 2 : 1;
       m = m + l | 0;
       k = k - l | 0;
       h = h + 1 | 0;
       b = b + 12 | 0;
       continue;
      }
      break;
     }
     break b;
    }
    l: {
     m: {
      while (1) {
       if ((c | 0) == (d | 0)) {
        break m;
       }
       if (w[j | 0] != 2) {
        j = j + 1 | 0;
        c = c + 12 | 0;
        continue;
       }
       break;
      }
      d = c;
      break l;
     }
     v[f >> 2] = v[f >> 2] | 4;
    }
    Kc(n);
    eb = i + 128 | 0;
    return d | 0;
   }
  }
  a = M() | 0;
  Kc(n);
  P(a | 0);
 }
 p();
}

function yt(a, b, c, d, e, f, g) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 f = f | 0;
 g = g | 0;
 var h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, q = 0, r = 0, s = 0, u = 0;
 i = eb - 128 | 0;
 eb = i;
 v[i + 124 >> 2] = b;
 k = xt(c, d);
 v[i + 4 >> 2] = 1238;
 n = wt(i + 8 | 0, i + 4 | 0);
 j = i + 16 | 0;
 a: {
  b: {
   if (k >>> 0 >= 101) {
    j = Fd(k);
    if (!j) {
     v[31601] = 0;
     W(1239);
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) != 1) {
      break a;
     }
     break b;
    }
    Qe(n, j);
   }
   h = j;
   b = c;
   c: {
    d: {
     while (1) {
      if ((b | 0) == (d | 0)) {
       e: while (1) {
        f: {
         v[31601] = 0;
         h = O(1240, a | 0, i + 124 | 0) | 0;
         b = v[31601];
         v[31601] = 0;
         if ((b | 0) == 1) {
          break f;
         }
         if ((!k | h) == 1) {
          v[31601] = 0;
          b = O(1240, a | 0, i + 124 | 0) | 0;
          a = v[31601];
          v[31601] = 0;
          if ((a | 0) == 1) {
           break c;
          }
          if (!b) {
           break d;
          }
          v[f >> 2] = v[f >> 2] | 2;
          break d;
         }
         b = v[a >> 2];
         v[31601] = 0;
         o = Q(1241, b | 0) | 0;
         b = v[31601];
         v[31601] = 0;
         g: {
          if ((b | 0) != 1) {
           if (g) {
            break g;
           }
           v[31601] = 0;
           o = O(1242, e | 0, o | 0) | 0;
           b = v[31601];
           v[31601] = 0;
           if ((b | 0) != 1) {
            break g;
           }
          }
          break b;
         }
         l = q + 1 | 0;
         s = 0;
         h = j;
         b = c;
         while (1) {
          if ((b | 0) == (d | 0)) {
           q = l;
           if (!s) {
            continue e;
           }
           v[31601] = 0;
           Q(1243, a | 0) | 0;
           b = v[31601];
           v[31601] = 0;
           if ((b | 0) != 1) {
            h = j;
            b = c;
            if (k + m >>> 0 < 2) {
             continue e;
            }
            while (1) {
             if ((b | 0) == (d | 0)) {
              continue e;
             }
             h: {
              if (w[h | 0] != 2) {
               break h;
              }
              if ((Cb(v[b + 4 >> 2], w[b + 11 | 0]) | 0) == (q | 0)) {
               break h;
              }
              t[h | 0] = 0;
              m = m - 1 | 0;
             }
             h = h + 1 | 0;
             b = b + 12 | 0;
             continue;
            }
           }
           break b;
          }
          i: {
           if (w[h | 0] != 1) {
            break i;
           }
           r = t[dc(b, q) | 0];
           j: {
            if (g) {
             break j;
            }
            v[31601] = 0;
            r = O(1242, e | 0, r | 0) | 0;
            u = v[31601];
            v[31601] = 0;
            if ((u | 0) != 1) {
             break j;
            }
            break b;
           }
           k: {
            if ((o | 0) == (r | 0)) {
             s = 1;
             if ((Cb(v[b + 4 >> 2], w[b + 11 | 0]) | 0) != (l | 0)) {
              break i;
             }
             t[h | 0] = 2;
             m = m + 1 | 0;
             break k;
            }
            t[h | 0] = 0;
           }
           k = k - 1 | 0;
          }
          h = h + 1 | 0;
          b = b + 12 | 0;
          continue;
         }
        }
        break;
       }
      } else {
       l = zd(v[b + 4 >> 2], w[b + 11 | 0]);
       t[h | 0] = l ? 2 : 1;
       m = m + l | 0;
       k = k - l | 0;
       h = h + 1 | 0;
       b = b + 12 | 0;
       continue;
      }
      break;
     }
     break b;
    }
    l: {
     m: {
      while (1) {
       if ((c | 0) == (d | 0)) {
        break m;
       }
       if (w[j | 0] != 2) {
        j = j + 1 | 0;
        c = c + 12 | 0;
        continue;
       }
       break;
      }
      d = c;
      break l;
     }
     v[f >> 2] = v[f >> 2] | 4;
    }
    Kc(n);
    eb = i + 128 | 0;
    return d | 0;
   }
  }
  a = M() | 0;
  Kc(n);
  P(a | 0);
 }
 p();
}

function iP(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0;
 d = eb - 112 | 0;
 eb = d;
 f = v[b + 4 >> 2];
 a: {
  if (!f) {
   break a;
  }
  e = v[b >> 2];
  h = w[xl(e, f) | 0];
  if ((h | 0) == 33) {
   c = 1;
  } else {
   if ((h | 0) != 63) {
    break a;
   }
   c = 0;
  }
  Kl(d + 88 | 0, e, f, f - 1 | 0);
  f = v[d + 92 >> 2];
  e = v[d + 88 >> 2];
  v[b >> 2] = e;
  v[b + 4 >> 2] = f;
 }
 e = d + 88 | 0;
 he(e);
 h = v[d + 88 >> 2];
 he(d + 76 | 0);
 h = wl(h, v[d + 80 >> 2], b);
 he(e);
 b: {
  c: {
   d: {
    e: {
     if ((h | 0) == v[d + 92 >> 2]) {
      a = v[b >> 2];
      h = oc(d + 104 | 0, 22256);
      i = v[h + 4 >> 2];
      v[d >> 2] = v[h >> 2];
      v[d + 4 >> 2] = i;
      if (Hc(a, f, d)) {
       a = cc(8);
       v[31601] = 0;
       c = O(36, e | 0, 10482) | 0;
       b = v[31601];
       v[31601] = 0;
       if ((b | 0) == 1) {
        break d;
       }
       rc(a, c);
       v[31601] = 0;
       R(97, a | 0, 48396, 999);
       a = v[31601];
       v[31601] = 0;
       if ((a | 0) != 1) {
        break b;
       }
       b = M() | 0;
       sb(c);
       break c;
      }
      g = 0;
      if (!c) {
       break e;
      }
      c = cc(8);
      a = v[b + 4 >> 2];
      b = v[b >> 2];
      v[31601] = 0;
      f = _h(d + 76 | 0, b, a);
      a = v[31601];
      v[31601] = 0;
      f: {
       g: {
        h: {
         if ((a | 0) != 1) {
          v[31601] = 0;
          e = d + 88 | 0;
          R(1010, e | 0, 18271, f | 0);
          a = v[31601];
          v[31601] = 0;
          if ((a | 0) == 1) {
           break h;
          }
          rc(c, e);
          a = 0;
          v[31601] = 0;
          R(97, c | 0, 48396, 999);
          b = v[31601];
          v[31601] = 0;
          if ((b | 0) != 1) {
           break b;
          }
          b = M() | 0;
          sb(e);
          break g;
         }
         b = M() | 0;
         break f;
        }
        b = M() | 0;
        a = 1;
       }
       sb(f);
       if (!a) {
        break c;
       }
      }
      jc(c);
      break c;
     }
     if (v[h + 4 >> 2] != 2) {
      a = cc(8);
      v[31601] = 0;
      c = O(36, d + 88 | 0, 11584) | 0;
      b = v[31601];
      v[31601] = 0;
      if ((b | 0) != 1) {
       rc(a, c);
       v[31601] = 0;
       R(97, a | 0, 48396, 999);
       a = v[31601];
       v[31601] = 0;
       if ((a | 0) != 1) {
        break b;
       }
       b = M() | 0;
       sb(c);
       break c;
      }
      b = M() | 0;
      jc(a);
      break c;
     }
     b = v[b >> 2];
     c = oc(d + 68 | 0, 22256);
     e = v[c + 4 >> 2];
     v[d + 32 >> 2] = v[c >> 2];
     v[d + 36 >> 2] = e;
     if (Hc(b, f, d + 32 | 0)) {
      a = cc(8);
      v[31601] = 0;
      c = O(36, d + 88 | 0, 10482) | 0;
      b = v[31601];
      v[31601] = 0;
      if ((b | 0) != 1) {
       rc(a, c);
       v[31601] = 0;
       R(97, a | 0, 48396, 999);
       a = v[31601];
       v[31601] = 0;
       if ((a | 0) != 1) {
        break b;
       }
       b = M() | 0;
       sb(c);
       break c;
      }
      b = M() | 0;
      jc(a);
      break c;
     }
     c = oc(d + 60 | 0, 7759);
     e = v[c + 4 >> 2];
     v[d + 24 >> 2] = v[c >> 2];
     v[d + 28 >> 2] = e;
     if (Hc(b, f, d + 24 | 0)) {
      g = 1;
      if (!Hd(w[a + 28 | 0])) {
       break e;
      }
      g = 65536 / +y[v[a + 24 >> 2] + 480244 >> 2];
      break e;
     }
     c = oc(d + 52 | 0, 7811);
     e = v[c + 4 >> 2];
     v[d + 16 >> 2] = v[c >> 2];
     v[d + 20 >> 2] = e;
     if (Hc(b, f, d + 16 | 0)) {
      g = 1;
      if (!Hd(w[a + 28 | 0])) {
       break e;
      }
      g = +y[v[a + 24 >> 2] + 480240 >> 2] * 152587890625e-16;
      break e;
     }
     c = oc(d + 44 | 0, 7829);
     e = v[c + 4 >> 2];
     v[d + 8 >> 2] = v[c >> 2];
     v[d + 12 >> 2] = e;
     g = 0;
     if (!Hc(b, f, d + 8 | 0)) {
      break e;
     }
     g = +y[v[a + 24 >> 2] + 480236 >> 2] * 152587890625e-16;
    }
    eb = d + 112 | 0;
    return +g;
   }
   b = M() | 0;
   jc(a);
  }
  P(b | 0);
 }
 p();
}

function Zu(a, b, c, d, e) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 var f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0;
 i = eb - 16 | 0;
 eb = i;
 g = v[a + 24 >> 2];
 h = OB(g, w[a + 32 | 0]);
 k = v[h >> 2];
 a: {
  if (_c(k, v[h + 4 >> 2]) >>> 0 <= b >>> 0) {
   break a;
  }
  if (bU(v[g + 484344 >> 2], v[g + 484348 >> 2], x[$b(k, b) >> 1]) >>> 0 <= c >>> 0) {
   break a;
  }
  h = v[a >> 2];
  b: {
   if (Td(h, v[a + 4 >> 2]) >>> 0 > b >>> 0) {
    if (y[Ud(h, b) + 4 >> 2] > c >>> 0) {
     break b;
    }
   }
   Lo(a, 0);
   if (Td(v[a >> 2], v[a + 4 >> 2]) >>> 0 <= b >>> 0) {
    break a;
   }
   g = v[a + 24 >> 2];
  }
  ac(i, v[d >> 2], x[g + 480188 >> 1]);
  h = i + 8 | 0;
  l = v[i >> 2];
  d = e ? -2046629010 : -2078137563;
  k = e ? -1352371636 : -873292572;
  e = v[i + 4 >> 2];
  while (1) {
   if (!f & (e | 0) == (j | 0)) {
    v[h >> 2] = d;
    v[h + 4 >> 2] = k;
   } else {
    g = w[cW(l, j) + 841 | 0];
    m = g ^ Aua(d ^ j, f ^ k, 435, 256);
    g = !g;
    d = (q = d, r = Aua(m, gb, 435, 256), s = g, s ? q : r);
    k = g ? k : gb;
    j = j + 1 | 0;
    f = j ? f : f + 1 | 0;
    continue;
   }
   break;
  }
  g = 0;
  d = an(i, b, c);
  f = eb - 16 | 0;
  eb = f;
  k = a + 12 | 0;
  e = k;
  j = TT(x[d >> 1], v[d + 4 >> 2], ce(e), fc(e));
  c: {
   if (Hb(j, og(e))) {
    m = x[d >> 1];
    l = v[d + 4 >> 2];
    d = td(j);
    if (!Ml(m, l, x[d >> 1], v[d + 4 >> 2])) {
     break c;
    }
   }
   j = og(e);
  }
  d = v[ub(f + 12 | 0, j) >> 2];
  eb = f + 16 | 0;
  if (Yg(d, Of(k))) {
   e = td(d);
   g = lc(v[e + 8 >> 2], v[e + 12 >> 2]) ^ 1;
  }
  l = v[h >> 2] != -2078137563 | v[h + 4 >> 2] != -873292572;
  Ib(i, v[Ud(v[a >> 2], b) >> 2], c);
  j = 1;
  o = Fb(v[v[i >> 2] >> 2], v[i + 4 >> 2]) ^ 1;
  e = g | l;
  if (!(o | e)) {
   break a;
  }
  d: {
   e: {
    f: {
     g: {
      if (g) {
       n = td(d);
       d = vb(v[n + 8 >> 2]);
       m = d;
       e = vb(v[n + 12 >> 2]);
       f = v[h >> 2];
       p = v[h + 4 >> 2];
       while (1) {
        h: {
         i: {
          if ((d | 0) != (e | 0)) {
           if (!ao(v[d >> 2], v[d + 4 >> 2], f, p)) {
            break i;
           }
          } else {
           d = e;
          }
          break h;
         }
         d = d + 8 | 0;
         continue;
        }
        break;
       }
       e = eb - 16 | 0;
       eb = e;
       v[e + 12 >> 2] = m;
       v[e + 12 >> 2] = v[e + 12 >> 2] + (d - m & -8);
       eb = e + 16 | 0;
       if (Hb(v[e + 12 >> 2], vb(v[n + 12 >> 2]))) {
        break a;
       }
       if (!l) {
        break e;
       }
       break g;
      }
      if (l) {
       break g;
      }
      if (!e) {
       break d;
      }
      break f;
     }
     v[a + 28 >> 2] = v[a + 28 >> 2] + 1;
    }
    if (g | o) {
     break e;
    }
    d = QT(k, an(i, b, c));
    j: {
     if (y[d + 4 >> 2] < y[zb(d) >> 2]) {
      e = eb - 16 | 0;
      eb = e;
      d = PT(e + 4 | 0, d);
      NT(v[d + 4 >> 2]);
      v[d + 4 >> 2] = v[d + 4 >> 2] + 8;
      hc(d);
      eb = e + 16 | 0;
      break j;
     }
     f = eb - 32 | 0;
     eb = f;
     e = zb(d);
     e = js(f + 12 | 0, ks(d, hh(v[d >> 2], v[d + 4 >> 2]) + 1 | 0), hh(v[d >> 2], v[d + 4 >> 2]), e);
     NT(v[e + 8 >> 2]);
     v[e + 8 >> 2] = v[e + 8 >> 2] + 8;
     NB(d, e);
     is(e);
     eb = f + 32 | 0;
    }
   }
   d = QT(k, an(i, b, c));
   k: {
    if (y[d + 4 >> 2] < y[zb(d) >> 2]) {
     e = eb - 16 | 0;
     eb = e;
     d = PT(e + 4 | 0, d);
     OT(v[d + 4 >> 2], v[h >> 2], v[h + 4 >> 2]);
     v[d + 4 >> 2] = v[d + 4 >> 2] + 8;
     hc(d);
     eb = e + 16 | 0;
     break k;
    }
    f = eb - 32 | 0;
    eb = f;
    e = zb(d);
    e = js(f + 12 | 0, ks(d, hh(v[d >> 2], v[d + 4 >> 2]) + 1 | 0), hh(v[d >> 2], v[d + 4 >> 2]), e);
    OT(v[e + 8 >> 2], v[h >> 2], v[h + 4 >> 2]);
    v[e + 8 >> 2] = v[e + 8 >> 2] + 8;
    NB(d, e);
    is(e);
    eb = f + 32 | 0;
   }
  }
  Ib(i, v[Ud(v[a >> 2], b) >> 2], c);
  kf(i, 1);
  j = 0;
 }
 eb = i + 16 | 0;
 return j | 0;
}

function _na(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0;
 k = eb - 16 | 0;
 eb = k;
 e = v[b >> 2];
 d = Lg(e, v[b + 4 >> 2]);
 a: {
  if (d >>> 0 < c >>> 0) {
   n = eb - 32 | 0;
   eb = n;
   d = c - d | 0;
   f = v[zb(b) >> 2];
   e = v[b + 4 >> 2];
   b: {
    if (d >>> 0 <= f - e >> 5 >>> 0) {
     h = eb - 16 | 0;
     eb = h;
     e = nC(h + 4 | 0, b, d);
     d = v[e + 4 >> 2];
     g = v[e + 8 >> 2];
     while (1) {
      if ((d | 0) == (g | 0)) {
       hc(e);
       eb = h + 16 | 0;
      } else {
       HV(d);
       d = d + 32 | 0;
       v[e + 4 >> 2] = d;
       continue;
      }
      break;
     }
     break b;
    }
    h = zb(b);
    h = jv(n + 12 | 0, Wq(b, Lg(v[b >> 2], e) + d | 0), Lg(v[b >> 2], v[b + 4 >> 2]), h);
    g = eb - 16 | 0;
    eb = g;
    d = IV(g + 4 | 0, h + 8 | 0, d);
    e = v[d >> 2];
    while (1) {
     if (v[d + 4 >> 2] != (e | 0)) {
      HV(e);
      e = v[d >> 2] + 32 | 0;
      v[d >> 2] = e;
      continue;
     }
     break;
    }
    ie(d);
    eb = g + 16 | 0;
    l = eb - 16 | 0;
    eb = l;
    d = ub(l + 12 | 0, v[b + 4 >> 2]);
    e = ub(l + 8 | 0, v[b >> 2]);
    f = v[ub(l + 4 | 0, v[h + 4 >> 2]) >> 2];
    m = eb - 16 | 0;
    eb = m;
    o = m + 8 | 0;
    g = eb - 32 | 0;
    eb = g;
    ed(g + 24 | 0, v[d >> 2], v[e >> 2]);
    p = g + 16 | 0;
    d = v[g + 24 >> 2];
    q = v[g + 28 >> 2];
    j = eb - 16 | 0;
    eb = j;
    v[j + 8 >> 2] = f;
    v[j + 12 >> 2] = d;
    while (1) {
     if (Ed(d, q)) {
      d = dn(d);
      e = dn(v[j + 8 >> 2]);
      f = w[d + 28 | 0] | w[d + 29 | 0] << 8 | (w[d + 30 | 0] << 16 | w[d + 31 | 0] << 24);
      i = w[d + 24 | 0] | w[d + 25 | 0] << 8 | (w[d + 26 | 0] << 16 | w[d + 27 | 0] << 24);
      t[e + 24 | 0] = i;
      t[e + 25 | 0] = i >>> 8;
      t[e + 26 | 0] = i >>> 16;
      t[e + 27 | 0] = i >>> 24;
      t[e + 28 | 0] = f;
      t[e + 29 | 0] = f >>> 8;
      t[e + 30 | 0] = f >>> 16;
      t[e + 31 | 0] = f >>> 24;
      f = w[d + 20 | 0] | w[d + 21 | 0] << 8 | (w[d + 22 | 0] << 16 | w[d + 23 | 0] << 24);
      i = w[d + 16 | 0] | w[d + 17 | 0] << 8 | (w[d + 18 | 0] << 16 | w[d + 19 | 0] << 24);
      t[e + 16 | 0] = i;
      t[e + 17 | 0] = i >>> 8;
      t[e + 18 | 0] = i >>> 16;
      t[e + 19 | 0] = i >>> 24;
      t[e + 20 | 0] = f;
      t[e + 21 | 0] = f >>> 8;
      t[e + 22 | 0] = f >>> 16;
      t[e + 23 | 0] = f >>> 24;
      f = w[d + 12 | 0] | w[d + 13 | 0] << 8 | (w[d + 14 | 0] << 16 | w[d + 15 | 0] << 24);
      i = w[d + 8 | 0] | w[d + 9 | 0] << 8 | (w[d + 10 | 0] << 16 | w[d + 11 | 0] << 24);
      t[e + 8 | 0] = i;
      t[e + 9 | 0] = i >>> 8;
      t[e + 10 | 0] = i >>> 16;
      t[e + 11 | 0] = i >>> 24;
      t[e + 12 | 0] = f;
      t[e + 13 | 0] = f >>> 8;
      t[e + 14 | 0] = f >>> 16;
      t[e + 15 | 0] = f >>> 24;
      f = w[d + 4 | 0] | w[d + 5 | 0] << 8 | (w[d + 6 | 0] << 16 | w[d + 7 | 0] << 24);
      d = w[d | 0] | w[d + 1 | 0] << 8 | (w[d + 2 | 0] << 16 | w[d + 3 | 0] << 24);
      t[e | 0] = d;
      t[e + 1 | 0] = d >>> 8;
      t[e + 2 | 0] = d >>> 16;
      t[e + 3 | 0] = d >>> 24;
      t[e + 4 | 0] = f;
      t[e + 5 | 0] = f >>> 8;
      t[e + 6 | 0] = f >>> 16;
      t[e + 7 | 0] = f >>> 24;
      d = To(j + 12 | 0);
      To(j + 8 | 0);
      d = v[d >> 2];
      continue;
     }
     break;
    }
    pc(p, d, j + 8 | 0);
    eb = j + 16 | 0;
    d = v[g + 16 >> 2];
    v[g + 12 >> 2] = v[g + 20 >> 2];
    pc(o, d, g + 12 | 0);
    eb = g + 32 | 0;
    eb = m + 16 | 0;
    v[h + 4 >> 2] = v[m + 12 >> 2];
    Sb(b, h + 4 | 0);
    Sb(b + 4 | 0, h + 8 | 0);
    Sb(zb(b), mc(h));
    v[h >> 2] = v[h + 4 >> 2];
    eb = l + 16 | 0;
    KV(h);
   }
   eb = n + 32 | 0;
   break a;
  }
  if (c >>> 0 < d >>> 0) {
   Id(b, e + (c << 5) | 0);
  }
 }
 if (Lb(v[a >> 2], v[a + 8 >> 2], c << 5)) {
  c = v[b >> 2];
  ac(k + 8 | 0, c, Lg(c, v[b + 4 >> 2]) << 5);
  rd(k, a, v[k + 8 >> 2], v[k + 12 >> 2]);
 }
 eb = k + 16 | 0;
}

function Jfa(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0;
 d = eb - 96 | 0;
 eb = d;
 f = 1;
 g = v[c + 4 >> 2];
 h = w[c + 11 | 0];
 a: {
  if (zd(g, h)) {
   break a;
  }
  e = w[zz(c) | 0];
  if ((e | 0) != 33) {
   if ((e | 0) != 63) {
    break a;
   }
   f = 0;
  }
  e = d + 84 | 0;
  zx(e, c, 0, Zc(g, h) - 1 | 0);
  yb(c, e);
  sb(e);
 }
 e = d + 84 | 0;
 he(e);
 g = v[d + 84 >> 2];
 he(d + 72 | 0);
 g = TM(g, v[d + 76 >> 2], c);
 he(e);
 b: {
  c: {
   d: {
    e: {
     f: {
      if ((g | 0) == v[d + 88 >> 2]) {
       if (Md(c, 22256)) {
        a = cc(8);
        v[31601] = 0;
        b = O(36, e | 0, 10482) | 0;
        c = v[31601];
        v[31601] = 0;
        if ((c | 0) == 1) {
         break d;
        }
        rc(a, b);
        v[31601] = 0;
        R(97, a | 0, 48396, 999);
        a = v[31601];
        v[31601] = 0;
        if ((a | 0) != 1) {
         break b;
        }
        c = M() | 0;
        sb(b);
        break c;
       }
       if (!f) {
        break f;
       }
       a = cc(8);
       v[31601] = 0;
       b = d + 84 | 0;
       R(1001, b | 0, 18271, c | 0);
       c = v[31601];
       v[31601] = 0;
       if ((c | 0) != 1) {
        rc(a, b);
        v[31601] = 0;
        R(97, a | 0, 48396, 999);
        a = v[31601];
        v[31601] = 0;
        if ((a | 0) != 1) {
         break b;
        }
        c = M() | 0;
        sb(b);
        break c;
       }
       c = M() | 0;
       jc(a);
       break c;
      }
      e = Eb(d + 84 | 0);
      g: {
       h: {
        i: {
         j: {
          switch (v[g + 4 >> 2]) {
          case 0:
           ee(d - -64 | 0, c);
           v[31601] = 0;
           c = v[d + 68 >> 2];
           v[d + 8 >> 2] = v[d + 64 >> 2];
           v[d + 12 >> 2] = c;
           b = T(1002, b | 0, d + 8 | 0, f | 0) | 0;
           c = v[31601];
           v[31601] = 0;
           if ((c | 0) != 1) {
            v[31601] = 0;
            t[d + 72 | 0] = b;
            N(1003, a | 0, d + 72 | 0);
            a = v[31601];
            v[31601] = 0;
            if ((a | 0) != 1) {
             break g;
            }
           }
           break i;

          case 1:
           ee(d + 56 | 0, c);
           v[31601] = 0;
           c = v[d + 60 >> 2];
           v[d + 16 >> 2] = v[d + 56 >> 2];
           v[d + 20 >> 2] = c;
           b = bI(b, d + 16 | 0, f);
           c = gb;
           f = v[31601];
           v[31601] = 0;
           if ((f | 0) != 1) {
            v[31601] = 0;
            v[d + 72 >> 2] = b;
            v[d + 76 >> 2] = c;
            N(1005, a | 0, d + 72 | 0);
            a = v[31601];
            v[31601] = 0;
            if ((a | 0) != 1) {
             break g;
            }
           }
           break i;

          case 2:
           ee(d + 48 | 0, c);
           v[31601] = 0;
           c = v[d + 52 >> 2];
           v[d + 24 >> 2] = v[d + 48 >> 2];
           v[d + 28 >> 2] = c;
           i = +na(1006, b | 0, d + 24 | 0, f | 0);
           b = v[31601];
           v[31601] = 0;
           if ((b | 0) != 1) {
            v[31601] = 0;
            A[d + 72 >> 3] = i;
            N(1007, a | 0, d + 72 | 0);
            a = v[31601];
            v[31601] = 0;
            if ((a | 0) != 1) {
             break g;
            }
           }
           break i;

          case 3:
           break j;

          default:
           break h;
          }
         }
         ee(d + 40 | 0, c);
         v[31601] = 0;
         c = v[d + 44 >> 2];
         v[d + 32 >> 2] = v[d + 40 >> 2];
         v[d + 36 >> 2] = c;
         U(1008, a | 0, b | 0, d + 32 | 0, f | 0);
         a = v[31601];
         v[31601] = 0;
         if ((a | 0) != 1) {
          break g;
         }
        }
        c = M() | 0;
        sb(e);
        break c;
       }
       Uc(a, e);
      }
      sb(e);
      break e;
     }
     Eb(a);
    }
    eb = d + 96 | 0;
    return;
   }
   c = M() | 0;
   jc(a);
  }
  P(c | 0);
 }
 p();
}

function d1(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0;
 e = eb - 368 | 0;
 eb = e;
 xc(b);
 d = eb - 16 | 0;
 eb = d;
 g = e + 330 | 0;
 hF(d + 8 | 0, g);
 h = v[d + 12 >> 2];
 ic(d, v[b >> 2], v[b + 8 >> 2], v[d + 8 >> 2], v[d + 12 >> 2]);
 i = v[d + 4 >> 2];
 if ((i | 0) == (h | 0)) {
  Ub(b, v[d + 12 >> 2]);
 }
 eb = d + 16 | 0;
 d = (h | 0) == (i | 0);
 if (!d) {
  gF(g);
 }
 a: {
  if (!d) {
   break a;
  }
  if (!jF(g)) {
   break a;
  }
  if (!Lb(v[b >> 2], v[b + 8 >> 2], Ac(iF(w[e + 365 | 0]), gb))) {
   break a;
  }
  f = 1;
  if ((c | 0) == 64) {
   break a;
  }
  Cd(a, 2097152);
  dg(a);
  Th(a, 1);
  u[a + 480188 >> 1] = 8;
  v[a + 480196 >> 2] = w[e + 362 | 0];
  v[a + 480204 >> 2] = B(w[e + 363 | 0], 1e4);
  u[a + 480190 >> 1] = w[e + 364 | 0];
  d = w[e + 367 | 0];
  if (d >>> 0 < w[e + 366 | 0]) {
   $e(Wb(v[a + 484360 >> 2], w[a + 484376 | 0]), d);
  }
  d = e - -64 | 0;
  f = tc(d, 6554);
  yb(a + 1298344 | 0, f);
  sb(f);
  f = tc(d, 11148);
  yb(a + 1298356 | 0, f);
  sb(f);
  o = a, p = v[Ec(d, 4) >> 2], v[o + 1298404 >> 2] = p;
  Hw(b, d);
  Qr(Wb(v[a + 484360 >> 2], w[a + 484376 | 0]), d, w[e + 366 | 0], 65535, 65535);
  l = a + 946304 | 0;
  i = a + 484380 | 0;
  f = 1;
  while (1) {
   j = f & 65535;
   if (j >>> 0 > x[a + 480190 >> 1]) {
    Ub(b, B(64 - w[e + 364 | 0] | 0, 37));
    h = a + 484344 | 0;
    Sf(h, w[e + 365 | 0]);
    j = c & 1;
    f = 0;
    while (1) {
     b: {
      c: {
       if (w[e + 365 | 0] <= f >>> 0) {
        if (!(c & 2)) {
         break c;
        }
        c = Yc(e + 24 | 0, 8, 1, 0, 0);
        f = 1;
        while (1) {
         d = f & 65535;
         if (d >>> 0 > x[a + 480190 >> 1]) {
          break c;
         }
         cg(c, i + B(d, 104) | 0, b);
         f = f + 1 | 0;
         continue;
        }
       }
       d: {
        if (j) {
         if (Og(h, f & 65535, 64)) {
          break d;
         }
        }
        Ub(b, 2048);
        break b;
       }
       d = Vb(v[h >> 2], f);
       o = e, p = vb(v[d >> 2]), v[o + 24 >> 2] = p;
       l = vb(v[d + 4 >> 2]);
       while (1) {
        d = v[e + 24 >> 2];
        if (!Hb(d, l)) {
         break b;
        }
        g = e + 12 | 0;
        jm(g, b);
        k = Ic(g);
        n = _e(g);
        g = Xi(g);
        m = w[e + 12 | 0];
        if ((m - 1 & 255) >>> 0 <= 106) {
         t[d | 0] = m + 13;
        }
        t[d + 1 | 0] = w[k | 0];
        Bf(d, w[n | 0], w[g | 0]);
        sg(e + 24 | 0);
        continue;
       }
      }
      f = 1;
      break a;
     }
     f = f + 1 | 0;
     continue;
    }
   } else {
    d = e + 24 | 0;
    fF(b, d);
    h = eb - 16 | 0;
    eb = h;
    g = i + B(j, 104) | 0;
    md(g, 0);
    t[g + 37 | 0] = w[d + 22 | 0] << 4;
    t[h + 15 | 0] = w[d + 23 | 0];
    t[h + 14 | 0] = 64;
    o = g, p = w[Pb(h + 15 | 0, h + 14 | 0) | 0] << 2, u[o + 30 >> 1] = p;
    t[g + 36 | 0] = w[d + 24 | 0];
    v[g >> 2] = w[d + 25 | 0] | w[d + 26 | 0] << 8 | (w[d + 27 | 0] << 16 | w[d + 28 | 0] << 24);
    k = w[d + 33 | 0] | w[d + 34 | 0] << 8 | (w[d + 35 | 0] << 16 | w[d + 36 | 0] << 24);
    if (!(k >>> 0 < 3 | k + (w[d + 29 | 0] | w[d + 30 | 0] << 8 | (w[d + 31 | 0] << 16 | w[d + 32 | 0] << 24)) >>> 0 > (w[d + 25 | 0] | w[d + 26 | 0] << 8 | (w[d + 27 | 0] << 16 | w[d + 28 | 0] << 24)) >>> 0)) {
     u[g + 34 >> 1] = x[g + 34 >> 1] | 2;
     v[g + 4 >> 2] = w[d + 29 | 0] | w[d + 30 | 0] << 8 | (w[d + 31 | 0] << 16 | w[d + 32 | 0] << 24);
     v[g + 8 >> 2] = (w[d + 33 | 0] | w[d + 34 | 0] << 8 | (w[d + 35 | 0] << 16 | w[d + 36 | 0] << 24)) + (w[d + 29 | 0] | w[d + 30 | 0] << 8 | (w[d + 31 | 0] << 16 | w[d + 32 | 0] << 24));
    }
    eb = h + 16 | 0;
    Pk(e, 2, d);
    d = e + 12 | 0;
    Bc(d, e);
    zc(l + (j << 5) | 0, d);
    f = f + 1 | 0;
    sb(d);
    continue;
   }
  }
 }
 eb = e + 368 | 0;
 return f | 0;
}

function F1(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, q = 0, r = 0;
 d = eb - 112 | 0;
 eb = d;
 xc(b);
 Lp(a);
 f = d + 104 | 0;
 a: {
  if (!ui(b, f)) {
   break a;
  }
  if (!eG(f)) {
   break a;
  }
  b: {
   if (!c) {
    break b;
   }
   if (!Lb(v[b >> 2], v[b + 8 >> 2], 4)) {
    break a;
   }
   tx(a);
   q = d, r = sx(), v[q + 84 >> 2] = r;
   c = d + 84 | 0;
   rx(bj(v[a + 4 >> 2]) + 32 | 0, c);
   os(c);
   l = v[bj(v[a + 4 >> 2]) + 32 >> 2];
   c = Kh(v[b >> 2]);
   if (c & 1) {
    break a;
   }
   e = c - 4 | 0;
   cd(b, e);
   f = eb - 16 | 0;
   eb = f;
   c = f + 13 | 0;
   ex(c, b);
   i = w[wb(c, 0) | 0];
   j = w[wb(c, 1) | 0];
   c = wb(c, 2);
   eb = f + 16 | 0;
   i = w[c | 0] | (j << 8 | i << 16);
   if (!i) {
    break a;
   }
   v[31601] = 0;
   N(39, l | 0, i | 0);
   c = v[31601];
   v[31601] = 0;
   c: {
    if ((c | 0) == 1) {
     b = S(124508) | 0;
     if ((fb | 0) != (_(124508) | 0)) {
      break c;
     }
     X(b | 0) | 0;
     Y();
     break a;
    }
    cd(b, 4);
    k = d + 84 | 0;
    dG(k, b, e);
    Ln(d - -64 | 0, k);
    lf(d + 76 | 0, v[d + 64 >> 2], v[d + 68 >> 2]);
    c = v[d + 80 >> 2];
    j = v[l >> 2];
    e = eb - 32 | 0;
    eb = e;
    b = v[d + 76 >> 2];
    q = e, r = w[wb(b, 0) | 0], t[q + 28 | 0] = r;
    q = e, r = w[wb(b, 1) | 0], t[q + 29 | 0] = r;
    q = e, r = w[wb(b, 2) | 0], t[q + 30 | 0] = r;
    q = e, r = w[wb(b, 3) | 0], t[q + 31 | 0] = r;
    f = ds(e + 12 | 0);
    c = b + c | 0;
    v[f + 12 >> 2] = c - 4;
    v[f + 8 >> 2] = b;
    hk(f, w[c - 1 | 0]);
    m = j - 1 | 0;
    c = i;
    d: while (1) {
     e: {
      f: {
       g: {
        if (!c) {
         break g;
        }
        if (hk(f, 1)) {
         break f;
        }
        b = 1;
        while (1) {
         g = hk(f, 2);
         b = g + b | 0;
         if ((g | 0) == 3) {
          continue;
         }
         break;
        }
        v[e + 8 >> 2] = b;
        wc(e + 8 | 0, c);
        b = 0;
        g = v[e + 8 >> 2];
        while (1) if ((b | 0) == (g | 0)) {
         if (!c) {
          break g;
         }
         break f;
        } else {
         c = c - 1 | 0;
         q = j + c | 0, r = hk(f, 8), t[q | 0] = r;
         b = b + 1 | 0;
         continue;
        }
       }
       eb = e + 32 | 0;
       break e;
      }
      g = hk(f, 2);
      b = g + 2 | 0;
      v[e + 8 >> 2] = b;
      h: {
       if ((g | 0) == 3) {
        i: {
         if (!hk(f, 1)) {
          b = 5;
          g = 7;
          break i;
         }
         g = w[wb(e + 28 | 0, 3) | 0];
        }
        g = hk(f, g);
        while (1) {
         h = hk(f, 3);
         b = h + b | 0;
         if ((h | 0) == 7) {
          continue;
         }
         break;
        }
        v[e + 8 >> 2] = b;
        break h;
       }
       g = hk(f, w[wb(e + 28 | 0, g) | 0]);
      }
      wc(e + 8 | 0, c);
      b = 0;
      n = v[e + 8 >> 2];
      while (1) {
       if ((b | 0) == (n | 0)) {
        continue d;
       }
       o = c + m | 0;
       h = c + g | 0;
       if (i >>> 0 > h >>> 0) {
        h = w[j + h | 0];
       } else {
        h = 0;
       }
       t[o | 0] = h;
       b = b + 1 | 0;
       c = c - 1 | 0;
       continue;
      }
     }
     break;
    }
    oe(d + 24 | 0, v[l >> 2], v[l + 4 >> 2]);
    lf(d + 32 | 0, v[d + 24 >> 2], v[d + 28 >> 2]);
    b = Ld(d + 16 | 0);
    v[31601] = 0;
    c = v[b + 4 >> 2];
    v[d + 8 >> 2] = v[b >> 2];
    v[d + 12 >> 2] = c;
    b = gg(160, d + 44 | 0, v[d + 32 >> 2], v[d + 36 >> 2], d + 8 | 0);
    c = v[31601];
    v[31601] = 0;
    if ((c | 0) != 1) {
     jd(bj(v[a + 4 >> 2]) + 12 | 0, b);
     tb(b);
     Jc(k);
     break b;
    }
    b = M() | 0;
    Jc(d + 84 | 0);
   }
   P(b | 0);
   p();
  }
  k = 1;
 }
 eb = d + 112 | 0;
 return k | 0;
}

function Jja(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0;
 c = eb - 96 | 0;
 eb = c;
 Tj(c + 76 | 0, b, 1413829443);
 v[31601] = 0;
 b = Q(172, v[c + 76 >> 2]) | 0;
 d = v[31601];
 v[31601] = 0;
 a: {
  b: {
   c: {
    if ((d | 0) == 1) {
     break c;
    }
    if (!b) {
     v[31601] = 0;
     d = c + 56 | 0;
     R(807, d | 0, a + 140 | 0, 1413894985);
     a = v[31601];
     v[31601] = 0;
     d: {
      e: {
       f: {
        g: {
         h: {
          i: {
           j: {
            k: {
             l: {
              m: {
               if ((a | 0) != 1) {
                v[31601] = 0;
                a = O(890, d | 0, 13691) | 0;
                b = v[31601];
                v[31601] = 0;
                if ((b | 0) == 1) {
                 break e;
                }
                b = 28591;
                if (a) {
                 b = Eb(c + 44 | 0);
                 v[31601] = 0;
                 a = Q(202, d | 0) | 0;
                 e = v[31601];
                 v[31601] = 0;
                 if ((e | 0) == 1) {
                  break m;
                 }
                 v[31601] = 0;
                 R(270, d | 0, b | 0, a | 0);
                 a = v[31601];
                 v[31601] = 0;
                 if ((a | 0) == 1) {
                  break m;
                 }
                 v[31601] = 0;
                 d = O(71, c + 20 | 0, b | 0) | 0;
                 a = v[31601];
                 v[31601] = 0;
                 if ((a | 0) == 1) {
                  break l;
                 }
                 v[31601] = 0;
                 e = c + 8 | 0;
                 V(891, e | 0);
                 a = v[31601];
                 v[31601] = 0;
                 if ((a | 0) == 1) {
                  break k;
                 }
                 v[31601] = 0;
                 a = c + 32 | 0;
                 R(892, a | 0, d | 0, e | 0);
                 f = v[31601];
                 v[31601] = 0;
                 if ((f | 0) == 1) {
                  break j;
                 }
                 f = yb(b, a);
                 sb(a);
                 sb(e);
                 sb(d);
                 v[31601] = 0;
                 R(258, a | 0, 2, f | 0);
                 d = v[31601];
                 v[31601] = 0;
                 if ((d | 0) == 1) {
                  break h;
                 }
                 v[31601] = 0;
                 d = Q(772, a | 0) | 0;
                 e = v[31601];
                 v[31601] = 0;
                 if ((e | 0) == 1) {
                  break g;
                 }
                 sb(a);
                 sb(f);
                 b = d - 1 >>> 0 < 19398657 ? 1252 : 28591;
                }
                tb(c + 56 | 0);
                break a;
               }
               a = M() | 0;
               break b;
              }
              a = M() | 0;
              break f;
             }
             a = M() | 0;
             break f;
            }
            a = M() | 0;
            break i;
           }
           a = M() | 0;
           sb(c + 8 | 0);
          }
          sb(d);
          break f;
         }
         a = M() | 0;
         break f;
        }
        a = M() | 0;
        sb(c + 32 | 0);
       }
       sb(b);
       break d;
      }
      a = M() | 0;
     }
     tb(c + 56 | 0);
     break b;
    }
    v[31601] = 0;
    a = T(150, v[c + 76 >> 2], v[c + 84 >> 2], 2) | 0;
    b = v[31601];
    v[31601] = 0;
    if ((b | 0) == 1) {
     break c;
    }
    b = 28591;
    if (!a) {
     break a;
    }
    v[31601] = 0;
    b = Q(189, c + 76 | 0) | 0;
    a = v[31601];
    v[31601] = 0;
    if ((a | 0) != 1) {
     break a;
    }
    a = M() | 0;
    break b;
   }
   a = M() | 0;
  }
  tb(c + 76 | 0);
  P(a | 0);
  p();
 }
 tb(c + 76 | 0);
 eb = c + 96 | 0;
 return b | 0;
}

function D4(a) {
 a = a | 0;
 var b = 0, c = 0, d = 0;
 a = a + 12 | 0;
 d = a + 508 | 0;
 c = Cb(v[a + 512 >> 2], w[a + 519 | 0]);
 while (1) {
  a: {
   if ((b | 0) == (c | 0)) {
    b = c;
    break a;
   }
   if (v[Vd(d, b) >> 2] == 37) {
    break a;
   }
   b = b + 1 | 0;
   continue;
  }
  break;
 }
 b: {
  c: {
   d: {
    e: {
     f: {
      a = v[Vd(d, b + 1 | 0) >> 2];
      if ((a | 0) != 121) {
       if ((a | 0) == 100) {
        break f;
       }
       if ((a | 0) == 109) {
        break e;
       }
       if ((a | 0) != 89) {
        break c;
       }
      }
      b = b + 2 | 0;
      a = b >>> 0 < c >>> 0 ? c : b;
      while (1) {
       g: {
        if (b >>> 0 < c >>> 0) {
         if (v[Vd(d, b) >> 2] != 37) {
          break g;
         }
         a = b;
        }
        if ((a | 0) == (c | 0)) {
         break c;
        }
        b = v[Vd(d, a + 1 | 0) >> 2];
        if ((b | 0) == 100) {
         break d;
        }
        if ((b | 0) != 109) {
         break c;
        }
        b = a + 2 | 0;
        a = b >>> 0 < c >>> 0 ? c : b;
        while (1) {
         h: {
          if (b >>> 0 < c >>> 0) {
           if (v[Vd(d, b) >> 2] != 37) {
            break h;
           }
           a = b;
          }
          if ((a | 0) == (c | 0)) {
           break c;
          }
          b = 3;
          if (v[Vd(d, a + 1 | 0) >> 2] != 100) {
           break c;
          }
          break b;
         }
         b = b + 1 | 0;
         continue;
        }
       }
       b = b + 1 | 0;
       continue;
      }
     }
     b = b + 2 | 0;
     a = b >>> 0 < c >>> 0 ? c : b;
     while (1) {
      i: {
       if (b >>> 0 < c >>> 0) {
        if (v[Vd(d, b) >> 2] != 37) {
         break i;
        }
        a = b;
       }
       if ((a | 0) == (c | 0)) {
        break c;
       }
       if (v[Vd(d, a + 1 | 0) >> 2] != 109) {
        break c;
       }
       b = a + 2 | 0;
       a = b >>> 0 < c >>> 0 ? c : b;
       while (1) {
        j: {
         if (b >>> 0 < c >>> 0) {
          if (v[Vd(d, b) >> 2] != 37) {
           break j;
          }
          a = b;
         }
         if ((a | 0) == (c | 0)) {
          break c;
         }
         b = 1;
         a = a + 1 | 0;
         if (v[Vd(d, a) >> 2] == 121) {
          break b;
         }
         if (v[Vd(d, a) >> 2] == 89) {
          break b;
         }
         break c;
        }
        b = b + 1 | 0;
        continue;
       }
      }
      b = b + 1 | 0;
      continue;
     }
    }
    b = b + 2 | 0;
    a = b >>> 0 < c >>> 0 ? c : b;
    while (1) {
     k: {
      if (b >>> 0 < c >>> 0) {
       if (v[Vd(d, b) >> 2] != 37) {
        break k;
       }
       a = b;
      }
      if ((a | 0) == (c | 0)) {
       break c;
      }
      if (v[Vd(d, a + 1 | 0) >> 2] != 100) {
       break c;
      }
      b = a + 2 | 0;
      a = b >>> 0 < c >>> 0 ? c : b;
      while (1) {
       l: {
        if (b >>> 0 < c >>> 0) {
         if (v[Vd(d, b) >> 2] != 37) {
          break l;
         }
         a = b;
        }
        if ((a | 0) == (c | 0)) {
         break c;
        }
        b = 2;
        a = a + 1 | 0;
        if (v[Vd(d, a) >> 2] == 121) {
         break b;
        }
        if (v[Vd(d, a) >> 2] != 89) {
         break c;
        }
        break b;
       }
       b = b + 1 | 0;
       continue;
      }
     }
     b = b + 1 | 0;
     continue;
    }
   }
   b = a + 2 | 0;
   a = b >>> 0 < c >>> 0 ? c : b;
   while (1) {
    m: {
     if (b >>> 0 < c >>> 0) {
      if (v[Vd(d, b) >> 2] != 37) {
       break m;
      }
      a = b;
     }
     if ((a | 0) == (c | 0)) {
      break c;
     }
     b = 4;
     if (v[Vd(d, a + 1 | 0) >> 2] != 109) {
      break c;
     }
     break b;
    }
    b = b + 1 | 0;
    continue;
   }
  }
  b = 0;
 }
 return b | 0;
}

function BR(a, b, c, d, e, f, g, h, i) {
 var j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0;
 j = eb - 128 | 0;
 eb = j;
 a: {
  b: {
   c: {
    if (!fn(f, g, h, i, 0, 0, 0, 0)) {
     break c;
    }
    k = i & 65535;
    n = i >>> 16 & 32767;
    d: {
     e: {
      if ((n | 0) != 32767) {
       l = 4;
       if (n) {
        break e;
       }
       l = f | h | (g | k) ? 3 : 2;
       break d;
      }
      l = !(f | h | (g | k));
     }
    }
    s = e >>> 16 | 0;
    o = s & 32767;
    if ((o | 0) == 32767) {
     break c;
    }
    if (l) {
     break b;
    }
   }
   Wd(j + 16 | 0, b, c, d, e, f, g, h, i);
   b = v[j + 16 >> 2];
   d = v[j + 20 >> 2];
   e = v[j + 24 >> 2];
   c = v[j + 28 >> 2];
   uS(j, b, d, e, c, b, d, e, c);
   d = v[j + 8 >> 2];
   e = v[j + 12 >> 2];
   h = v[j >> 2];
   i = v[j + 4 >> 2];
   break a;
  }
  l = d;
  p = e & 2147483647;
  k = p;
  n = h;
  m = i & 2147483647;
  if ((fn(b, c, l, k, f, g, h, m) | 0) <= 0) {
   if (fn(b, c, l, k, f, g, h, m)) {
    h = b;
    i = c;
    break a;
   }
   Wd(j + 112 | 0, b, c, d, e, 0, 0, 0, 0);
   d = v[j + 120 >> 2];
   e = v[j + 124 >> 2];
   h = v[j + 112 >> 2];
   i = v[j + 116 >> 2];
   break a;
  }
  q = i >>> 16 & 32767;
  if (o) {
   i = c;
   h = b;
  } else {
   Wd(j + 96 | 0, b, c, l, p, 0, 0, 0, 1081540608);
   l = v[j + 104 >> 2];
   h = v[j + 108 >> 2];
   p = h;
   o = (h >>> 16 | 0) - 120 | 0;
   i = v[j + 100 >> 2];
   h = v[j + 96 >> 2];
  }
  if (!q) {
   Wd(j + 80 | 0, f, g, n, m, 0, 0, 0, 1081540608);
   n = v[j + 88 >> 2];
   f = v[j + 92 >> 2];
   m = f;
   q = (f >>> 16 | 0) - 120 | 0;
   g = v[j + 84 >> 2];
   f = v[j + 80 >> 2];
  }
  r = n;
  t = m & 65535 | 65536;
  p = p & 65535 | 65536;
  if ((o | 0) > (q | 0)) {
   while (1) {
    m = l - r | 0;
    k = (g | 0) == (i | 0) & f >>> 0 > h >>> 0 | g >>> 0 > i >>> 0;
    n = m - k | 0;
    k = (p - ((l >>> 0 < r >>> 0) + t | 0) | 0) - (k >>> 0 > m >>> 0) | 0;
    f: {
     if ((k | 0) >= 0 | (k | 0) > 0) {
      l = h;
      h = h - f | 0;
      i = i - ((f >>> 0 > l >>> 0) + g | 0) | 0;
      if (!(h | n | (i | k))) {
       Wd(j + 32 | 0, b, c, d, e, 0, 0, 0, 0);
       d = v[j + 40 >> 2];
       e = v[j + 44 >> 2];
       h = v[j + 32 >> 2];
       i = v[j + 36 >> 2];
       break a;
      }
      k = k << 1 | n >>> 31;
      l = n << 1 | i >>> 31;
      break f;
     }
     k = p << 1 | l >>> 31;
     l = l << 1 | i >>> 31;
    }
    p = k;
    k = i << 1 | h >>> 31;
    h = h << 1;
    i = k;
    o = o - 1 | 0;
    if ((o | 0) > (q | 0)) {
     continue;
    }
    break;
   }
   o = q;
  }
  m = l - r | 0;
  k = (g | 0) == (i | 0) & f >>> 0 > h >>> 0 | g >>> 0 > i >>> 0;
  n = m - k | 0;
  k = (p - ((l >>> 0 < r >>> 0) + t | 0) | 0) - (k >>> 0 > m >>> 0) | 0;
  m = k;
  g: {
   if ((k | 0) < 0) {
    n = l;
    m = p;
    break g;
   }
   l = h;
   h = h - f | 0;
   i = i - ((f >>> 0 > l >>> 0) + g | 0) | 0;
   if (h | n | (i | m)) {
    break g;
   }
   Wd(j + 48 | 0, b, c, d, e, 0, 0, 0, 0);
   d = v[j + 56 >> 2];
   e = v[j + 60 >> 2];
   h = v[j + 48 >> 2];
   i = v[j + 52 >> 2];
   break a;
  }
  if ((m | 0) == 65535 | m >>> 0 < 65535) {
   while (1) {
    b = i >>> 31 | 0;
    o = o - 1 | 0;
    p = i << 1 | h >>> 31;
    h = h << 1;
    i = p;
    c = b;
    b = m << 1 | n >>> 31;
    n = c | n << 1;
    m = b;
    if (b >>> 0 < 65536) {
     continue;
    }
    break;
   }
  }
  b = s & 32768;
  if ((o | 0) <= 0) {
   Wd(j - -64 | 0, h, i, n, m & 65535 | (b | o + 120) << 16, 0, 0, 0, 1065811968);
   d = v[j + 72 >> 2];
   e = v[j + 76 >> 2];
   h = v[j + 64 >> 2];
   i = v[j + 68 >> 2];
   break a;
  }
  d = n;
  e = m & 65535 | (b | o) << 16;
 }
 v[a >> 2] = h;
 v[a + 4 >> 2] = i;
 v[a + 8 >> 2] = d;
 v[a + 12 >> 2] = e;
 eb = j + 128 | 0;
}

function wS(a, b, c) {
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
 h = eb - 48 | 0;
 eb = h;
 j = eb - 16 | 0;
 eb = j;
 v[j >> 2] = b;
 v[j + 4 >> 2] = c;
 g = eb - 16 | 0;
 eb = g;
 e = eb - 16 | 0;
 eb = e;
 d = ub(e + 12 | 0, Bua(v[j >> 2], v[j + 4 >> 2], 500654080, 20));
 eb = e + 16 | 0;
 e = eb - 16 | 0;
 eb = e;
 k = v[d >> 2];
 f = sS(e + 8 | 0, k);
 eb = e + 16 | 0;
 e = v[j >> 2];
 d = v[f >> 2];
 i = v[j + 4 >> 2];
 f = v[f + 4 >> 2];
 if (((d | 0) != (e | 0) | (f | 0) != (i | 0) ? e >>> 0 > d >>> 0 & (i | 0) >= (f | 0) | (f | 0) < (i | 0) ? -1 : 1 : 0) << 24 >> 24 > 0) {
  d = v[ub(g + 12 | 0, 1) >> 2];
  e = eb - 16 | 0;
  eb = e;
  k = v[ub(e + 12 | 0, k - d | 0) >> 2];
  eb = e + 16 | 0;
 }
 eb = g + 16 | 0;
 l = v[ub(j + 12 | 0, k) >> 2];
 eb = j + 16 | 0;
 k = eb - 16 | 0;
 eb = k;
 j = eb - 16 | 0;
 eb = j;
 d = l + 719468 | 0;
 e = (((l | 0) > -719469 ? d : l + 573372 | 0) | 0) / 146097 | 0;
 i = B(e, -146097) + d | 0;
 d = ((i >>> 0) / 36524 | 0) + i - (((i >>> 0) / 146096 | 0) + ((i >>> 0) / 1460 | 0)) | 0;
 f = (d >>> 0) / 365 | 0;
 i = ((i - ((d >>> 0) / 1460 | 0) | 0) + ((d >>> 0) / 36500 | 0) | 0) + B(f, -365) | 0;
 d = B(i, 5) + 2 | 0;
 g = (d >>> 0) / 153 | 0;
 d = g + (d >>> 0 < 1530 ? 3 : -9) | 0;
 f = Kw(j + 14 | 0, (f + B(e, 400) | 0) + (d >>> 0 < 3) | 0);
 e = kq(j + 13 | 0, d);
 d = kq(j + 12 | 0, (i - ((B(g, 153) + 2 >>> 0) / 5 | 0) | 0) + 1 | 0);
 rS(k + 12 | 0, x[f >> 1], e, d);
 eb = j + 16 | 0;
 d = v[k + 12 >> 2];
 u[h + 44 >> 1] = d;
 u[h + 46 >> 1] = d >>> 16;
 eb = k + 16 | 0;
 f = eb - 16 | 0;
 eb = f;
 e = sS(f, l);
 d = v[e >> 2];
 c = we(f + 8 | 0, b - d | 0, c - (v[e + 4 >> 2] + (b >>> 0 < d >>> 0) | 0) | 0);
 b = v[c >> 2];
 eb = f + 16 | 0;
 i = eb - 16 | 0;
 eb = i;
 c = v[c + 4 >> 2];
 d = _A(i + 8 | 0, 0);
 m = h, n = ud(tS(b, c, v[d >> 2], v[d + 4 >> 2])), t[m + 8 | 0] = n;
 f = eb - 16 | 0;
 eb = f;
 e = we(f + 8 | 0, 0, 0);
 d = v[e >> 2];
 eb = f + 16 | 0;
 if (tS(b, c, d, v[e + 4 >> 2]) << 24 >> 24 < 0) {
  d = eb - 16 | 0;
  eb = d;
  c = we(d + 8 | 0, 0 - b | 0, 0 - (((b | 0) != 0) + c | 0) | 0);
  b = v[c >> 2];
  eb = d + 16 | 0;
  c = v[c + 4 >> 2];
 }
 d = eb - 16 | 0;
 eb = d;
 e = v[ub(d + 12 | 0, Bua(b, c, -694967296, 0)) >> 2];
 eb = d + 16 | 0;
 v[h + 12 >> 2] = e;
 g = eb - 16 | 0;
 eb = g;
 f = eb - 16 | 0;
 eb = f;
 d = we(f + 8 | 0, Aua(e, e >> 31, -694967296, 0), gb);
 e = v[d >> 2];
 d = v[d + 4 >> 2];
 eb = f + 16 | 0;
 v[g >> 2] = e;
 v[g + 4 >> 2] = d;
 d = v[g >> 2];
 b = we(g + 8 | 0, b - d | 0, c - (v[g + 4 >> 2] + (b >>> 0 < d >>> 0) | 0) | 0);
 f = v[b >> 2];
 b = v[b + 4 >> 2];
 d = b;
 eb = g + 16 | 0;
 c = eb - 16 | 0;
 eb = c;
 b = v[ub(c + 12 | 0, Bua(f, b, 6e7, 0)) >> 2];
 eb = c + 16 | 0;
 v[h + 16 >> 2] = b;
 g = eb - 16 | 0;
 eb = g;
 e = eb - 16 | 0;
 eb = e;
 b = we(e + 8 | 0, Aua(b, b >> 31, 6e7, 0), gb);
 c = v[b >> 2];
 b = v[b + 4 >> 2];
 eb = e + 16 | 0;
 v[g >> 2] = c;
 v[g + 4 >> 2] = b;
 b = v[g >> 2];
 b = we(g + 8 | 0, f - b | 0, d - (v[g + 4 >> 2] + (b >>> 0 > f >>> 0) | 0) | 0);
 f = v[b >> 2];
 b = v[b + 4 >> 2];
 d = b;
 eb = g + 16 | 0;
 c = $A(f, b);
 v[h + 24 >> 2] = c;
 b = gb;
 v[h + 28 >> 2] = b;
 e = eb - 16 | 0;
 eb = e;
 c = Hu(e, c, b);
 b = v[c >> 2];
 c = we(e + 8 | 0, f - b | 0, d - (v[c + 4 >> 2] + (b >>> 0 > f >>> 0) | 0) | 0);
 b = v[c >> 2];
 eb = e + 16 | 0;
 m = h, n = VQ(b, v[c + 4 >> 2]), v[m + 32 >> 2] = n;
 v[h + 36 >> 2] = gb;
 eb = i + 16 | 0;
 b = vS(a);
 v[b >> 2] = x[h + 44 >> 1] << 16 >> 16;
 m = b, n = yf(w[h + 46 | 0]), v[m + 4 >> 2] = n;
 m = b, n = yf(w[h + 47 | 0]), v[m + 8 >> 2] = n;
 v[b + 12 >> 2] = v[h + 12 >> 2];
 v[b + 16 >> 2] = v[h + 16 >> 2];
 a = v[h + 28 >> 2];
 v[b + 24 >> 2] = v[h + 24 >> 2];
 v[b + 28 >> 2] = a;
 eb = h + 48 | 0;
}

function h4(a) {
 a = a | 0;
 var b = 0, c = 0, d = 0;
 a = a + 12 | 0;
 d = a + 508 | 0;
 c = Cb(v[a + 512 >> 2], w[a + 519 | 0]);
 while (1) {
  a: {
   if ((b | 0) == (c | 0)) {
    b = c;
    break a;
   }
   if (w[dc(d, b) | 0] == 37) {
    break a;
   }
   b = b + 1 | 0;
   continue;
  }
  break;
 }
 b: {
  c: {
   d: {
    e: {
     f: {
      a = w[dc(d, b + 1 | 0) | 0];
      if ((a | 0) != 121) {
       if ((a | 0) == 100) {
        break f;
       }
       if ((a | 0) == 109) {
        break e;
       }
       if ((a | 0) != 89) {
        break c;
       }
      }
      b = b + 2 | 0;
      a = b >>> 0 < c >>> 0 ? c : b;
      while (1) {
       g: {
        if (b >>> 0 < c >>> 0) {
         if (w[dc(d, b) | 0] != 37) {
          break g;
         }
         a = b;
        }
        if ((a | 0) == (c | 0)) {
         break c;
        }
        b = w[dc(d, a + 1 | 0) | 0];
        if ((b | 0) == 100) {
         break d;
        }
        if ((b | 0) != 109) {
         break c;
        }
        b = a + 2 | 0;
        a = b >>> 0 < c >>> 0 ? c : b;
        while (1) {
         h: {
          if (b >>> 0 < c >>> 0) {
           if (w[dc(d, b) | 0] != 37) {
            break h;
           }
           a = b;
          }
          if ((a | 0) == (c | 0)) {
           break c;
          }
          b = 3;
          if (w[dc(d, a + 1 | 0) | 0] != 100) {
           break c;
          }
          break b;
         }
         b = b + 1 | 0;
         continue;
        }
       }
       b = b + 1 | 0;
       continue;
      }
     }
     b = b + 2 | 0;
     a = b >>> 0 < c >>> 0 ? c : b;
     while (1) {
      i: {
       if (b >>> 0 < c >>> 0) {
        if (w[dc(d, b) | 0] != 37) {
         break i;
        }
        a = b;
       }
       if ((a | 0) == (c | 0)) {
        break c;
       }
       if (w[dc(d, a + 1 | 0) | 0] != 109) {
        break c;
       }
       b = a + 2 | 0;
       a = b >>> 0 < c >>> 0 ? c : b;
       while (1) {
        j: {
         if (b >>> 0 < c >>> 0) {
          if (w[dc(d, b) | 0] != 37) {
           break j;
          }
          a = b;
         }
         if ((a | 0) == (c | 0)) {
          break c;
         }
         b = 1;
         a = a + 1 | 0;
         if (w[dc(d, a) | 0] == 121) {
          break b;
         }
         if (w[dc(d, a) | 0] == 89) {
          break b;
         }
         break c;
        }
        b = b + 1 | 0;
        continue;
       }
      }
      b = b + 1 | 0;
      continue;
     }
    }
    b = b + 2 | 0;
    a = b >>> 0 < c >>> 0 ? c : b;
    while (1) {
     k: {
      if (b >>> 0 < c >>> 0) {
       if (w[dc(d, b) | 0] != 37) {
        break k;
       }
       a = b;
      }
      if ((a | 0) == (c | 0)) {
       break c;
      }
      if (w[dc(d, a + 1 | 0) | 0] != 100) {
       break c;
      }
      b = a + 2 | 0;
      a = b >>> 0 < c >>> 0 ? c : b;
      while (1) {
       l: {
        if (b >>> 0 < c >>> 0) {
         if (w[dc(d, b) | 0] != 37) {
          break l;
         }
         a = b;
        }
        if ((a | 0) == (c | 0)) {
         break c;
        }
        b = 2;
        a = a + 1 | 0;
        if (w[dc(d, a) | 0] == 121) {
         break b;
        }
        if (w[dc(d, a) | 0] != 89) {
         break c;
        }
        break b;
       }
       b = b + 1 | 0;
       continue;
      }
     }
     b = b + 1 | 0;
     continue;
    }
   }
   b = a + 2 | 0;
   a = b >>> 0 < c >>> 0 ? c : b;
   while (1) {
    m: {
     if (b >>> 0 < c >>> 0) {
      if (w[dc(d, b) | 0] != 37) {
       break m;
      }
      a = b;
     }
     if ((a | 0) == (c | 0)) {
      break c;
     }
     b = 4;
     if (w[dc(d, a + 1 | 0) | 0] != 109) {
      break c;
     }
     break b;
    }
    b = b + 1 | 0;
    continue;
   }
  }
  b = 0;
 }
 return b | 0;
}

function gP(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0;
 e = eb - 96 | 0;
 eb = e;
 f = v[c + 4 >> 2];
 a: {
  if (!f) {
   g = v[c >> 2];
   break a;
  }
  g = v[c >> 2];
  h = w[xl(g, f) | 0];
  if ((h | 0) == 33) {
   d = 1;
  } else {
   if ((h | 0) != 63) {
    break a;
   }
   d = 0;
  }
  Kl(e + 72 | 0, g, f, f - 1 | 0);
  f = v[e + 76 >> 2];
  g = v[e + 72 >> 2];
  v[c >> 2] = g;
  v[c + 4 >> 2] = f;
 }
 i = e + 72 | 0;
 he(i);
 h = v[e + 72 >> 2];
 he(e + 60 | 0);
 h = wl(h, v[e + 64 >> 2], c);
 he(i);
 b: {
  c: {
   d: {
    e: {
     if (v[e + 76 >> 2] == (h | 0)) {
      h = oc(e + 88 | 0, 22256);
      b = v[h + 4 >> 2];
      v[e >> 2] = v[h >> 2];
      v[e + 4 >> 2] = b;
      if (Hc(g, f, e)) {
       c = cc(8);
       v[31601] = 0;
       b = O(36, i | 0, 10482) | 0;
       a = v[31601];
       v[31601] = 0;
       if ((a | 0) == 1) {
        break d;
       }
       rc(c, b);
       v[31601] = 0;
       R(97, c | 0, 48396, 999);
       a = v[31601];
       v[31601] = 0;
       if ((a | 0) != 1) {
        break b;
       }
       f = M() | 0;
       sb(b);
       break c;
      }
      if (d) {
       g = cc(8);
       b = v[c >> 2];
       a = v[c + 4 >> 2];
       v[31601] = 0;
       d = _h(e + 60 | 0, b, a);
       a = v[31601];
       v[31601] = 0;
       f: {
        g: {
         h: {
          if ((a | 0) != 1) {
           v[31601] = 0;
           b = e + 72 | 0;
           R(1010, b | 0, 18271, d | 0);
           a = v[31601];
           v[31601] = 0;
           if ((a | 0) == 1) {
            break h;
           }
           rc(g, b);
           c = 0;
           v[31601] = 0;
           R(97, g | 0, 48396, 999);
           a = v[31601];
           v[31601] = 0;
           if ((a | 0) != 1) {
            break b;
           }
           f = M() | 0;
           sb(b);
           break g;
          }
          f = M() | 0;
          break f;
         }
         f = M() | 0;
         c = 1;
        }
        sb(d);
        if (!c) {
         break c;
        }
       }
       jc(g);
       break c;
      }
      Eb(a);
      break e;
     }
     d = oc(e + 52 | 0, 22256);
     c = v[d + 4 >> 2];
     v[e + 24 >> 2] = v[d >> 2];
     v[e + 28 >> 2] = c;
     if (Hc(g, f, e + 24 | 0)) {
      c = cc(8);
      v[31601] = 0;
      b = O(36, e + 72 | 0, 10482) | 0;
      a = v[31601];
      v[31601] = 0;
      if ((a | 0) != 1) {
       rc(c, b);
       v[31601] = 0;
       R(97, c | 0, 48396, 999);
       a = v[31601];
       v[31601] = 0;
       if ((a | 0) != 1) {
        break b;
       }
       f = M() | 0;
       sb(b);
       break c;
      }
      f = M() | 0;
      jc(c);
      break c;
     }
     d = oc(e + 44 | 0, 12421);
     c = v[d + 4 >> 2];
     v[e + 16 >> 2] = v[d >> 2];
     v[e + 20 >> 2] = c;
     if (Hc(g, f, e + 16 | 0)) {
      i: {
       switch (v[b + 52 >> 2]) {
       case 0:
        Cc(a, 5601);
        break e;

       case 1:
        Cc(a, 11285);
        break e;

       case 2:
        Cc(a, 9206);
        break e;

       default:
        break i;
       }
      }
      Eb(a);
      break e;
     }
     d = oc(e + 36 | 0, 11522);
     c = v[d + 4 >> 2];
     v[e + 8 >> 2] = v[d >> 2];
     v[e + 12 >> 2] = c;
     if (Hc(g, f, e + 8 | 0)) {
      j: {
       switch (v[b + 56 >> 2]) {
       case 0:
        Cc(a, 15623);
        break e;

       case 1:
        Cc(a, 15628);
        break e;

       case 2:
        Cc(a, 12695);
        break e;

       case 3:
        Cc(a, 9270);
        break e;

       default:
        break j;
       }
      }
      Eb(a);
      break e;
     }
     Eb(a);
    }
    eb = e + 96 | 0;
    return;
   }
   f = M() | 0;
   jc(c);
  }
  P(f | 0);
 }
 p();
}

function Ena(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
 h = eb - 48 | 0;
 eb = h;
 k = c + 484344 | 0;
 Sf(k, w[b + 70 | 0] | w[b + 71 | 0] << 8);
 a: {
  b: {
   while (1) {
    if ((w[b + 70 | 0] | w[b + 71 | 0] << 8) >>> 0 <= j >>> 0) {
     break b;
    }
    f = v[a + 8 >> 2];
    e = Qg(a);
    Ub(a, 1);
    c: {
     if ((w[b + 58 | 0] | w[b + 59 | 0] << 8) == 258) {
      c = Yd(a) + 1 | 0;
      break c;
     }
     c = fh(a);
    }
    d = fh(a);
    cd(a, e + f | 0);
    e = h + 8 | 0;
    ge(e, a, d);
    f = gc(h + 28 | 0, e);
    tb(e);
    v[31601] = 0;
    c = T(196, k | 0, j & 65535, (c ? c >>> 0 >= 1024 ? 1024 : c : 64) | 0) | 0;
    e = v[31601];
    v[31601] = 0;
    if ((e | 0) != 1) {
     d: {
      if (!(c & (d | 0) != 0)) {
       break d;
      }
      c = Vb(v[k >> 2], j);
      m = h, n = vb(v[c >> 2]), v[m + 8 >> 2] = n;
      l = vb(v[c + 4 >> 2]);
      while (1) {
       c = v[h + 8 >> 2];
       if (!Hb(c, l)) {
        break d;
       }
       v[31601] = 0;
       d = Q(197, f | 0) | 0;
       e = v[31601];
       v[31601] = 0;
       e: {
        f: {
         g: {
          if ((e | 0) != 1) {
           e = d << 24 >> 24;
           if ((e | 0) >= 0) {
            break g;
           }
           if (e & 1) {
            v[31601] = 0;
            d = Q(197, f | 0) | 0;
            i = v[31601];
            v[31601] = 0;
            if ((i | 0) == 1) {
             break a;
            }
            t[c | 0] = d;
           }
           d = e & 255;
           if (e & 2) {
            break f;
           }
           break e;
          }
          break a;
         }
         t[c | 0] = e;
         d = 255;
        }
        v[31601] = 0;
        e = Q(197, f | 0) | 0;
        i = v[31601];
        v[31601] = 0;
        if ((i | 0) == 1) {
         break a;
        }
        t[c + 1 | 0] = e;
       }
       i = 0;
       e = 0;
       if (d & 4) {
        v[31601] = 0;
        e = Q(197, f | 0) | 0;
        g = v[31601];
        v[31601] = 0;
        if ((g | 0) == 1) {
         break a;
        }
       }
       if (d & 8) {
        v[31601] = 0;
        i = Q(197, f | 0) | 0;
        g = v[31601];
        v[31601] = 0;
        if ((g | 0) == 1) {
         break a;
        }
       }
       if (d & 16) {
        v[31601] = 0;
        d = Q(197, f | 0) | 0;
        g = v[31601];
        v[31601] = 0;
        if ((g | 0) == 1) {
         break a;
        }
        t[c + 5 | 0] = d;
       }
       h: {
        i: {
         d = w[c | 0];
         if (!d) {
          break i;
         }
         g = 255;
         if ((d | 0) == 97) {
          break h;
         }
         if (d >>> 0 > 96) {
          break i;
         }
         g = d + 12 | 0;
         break h;
        }
        g = 0;
       }
       t[c | 0] = g;
       d = w[c + 5 | 0];
       j: {
        if ((d | i) & 255) {
         Bf(c, i, d);
         break j;
        }
        t[c + 3 | 0] = 0;
       }
       if (w[c + 1 | 0] == 255) {
        t[c + 1 | 0] = 0;
       }
       d = e - 16 | 0;
       k: {
        if ((d & 255) >>> 0 <= 64) {
         t[c + 4 | 0] = d;
         t[c + 2 | 0] = 1;
         break k;
        }
        if (e >>> 0 < 96) {
         break k;
        }
        d = e & 15;
        t[c + 4 | 0] = d;
        e = e - 96 >>> 4 | 0;
        t[c + 2 | 0] = w[e + 25470 | 0];
        if ((e | 0) != 6) {
         break k;
        }
        t[c + 4 | 0] = d << 2;
       }
       sg(h + 8 | 0);
       continue;
      }
     }
     tb(f);
     j = j + 1 | 0;
     continue;
    }
    break;
   }
   break a;
  }
  eb = h + 48 | 0;
  return;
 }
 a = M() | 0;
 tb(f);
 P(a | 0);
 p();
}

function hP(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0;
 d = eb - 96 | 0;
 eb = d;
 g = v[b + 4 >> 2];
 a: {
  if (!g) {
   break a;
  }
  e = v[b >> 2];
  f = w[xl(e, g) | 0];
  if ((f | 0) == 33) {
   c = 1;
  } else {
   if ((f | 0) != 63) {
    break a;
   }
   c = 0;
  }
  Kl(d + 72 | 0, e, g, g - 1 | 0);
  g = v[d + 76 >> 2];
  e = v[d + 72 >> 2];
  v[b >> 2] = e;
  v[b + 4 >> 2] = g;
 }
 e = d + 72 | 0;
 he(e);
 f = v[d + 72 >> 2];
 he(d + 60 | 0);
 f = wl(f, v[d + 64 >> 2], b);
 he(e);
 b: {
  c: {
   d: {
    e: {
     if ((f | 0) == v[d + 76 >> 2]) {
      a = v[b >> 2];
      f = oc(d + 88 | 0, 22256);
      h = v[f + 4 >> 2];
      v[d >> 2] = v[f >> 2];
      v[d + 4 >> 2] = h;
      if (Hc(a, g, d)) {
       a = cc(8);
       v[31601] = 0;
       c = O(36, e | 0, 10482) | 0;
       b = v[31601];
       v[31601] = 0;
       if ((b | 0) == 1) {
        break d;
       }
       rc(a, c);
       v[31601] = 0;
       R(97, a | 0, 48396, 999);
       a = v[31601];
       v[31601] = 0;
       if ((a | 0) != 1) {
        break b;
       }
       b = M() | 0;
       sb(c);
       break c;
      }
      e = 0;
      f = 0;
      if (!c) {
       break e;
      }
      a = cc(8);
      c = v[b + 4 >> 2];
      b = v[b >> 2];
      v[31601] = 0;
      e = _h(d + 60 | 0, b, c);
      b = v[31601];
      v[31601] = 0;
      f: {
       g: {
        h: {
         if ((b | 0) != 1) {
          v[31601] = 0;
          g = d + 72 | 0;
          R(1010, g | 0, 18271, e | 0);
          b = v[31601];
          v[31601] = 0;
          if ((b | 0) == 1) {
           break h;
          }
          rc(a, g);
          c = 0;
          v[31601] = 0;
          R(97, a | 0, 48396, 999);
          b = v[31601];
          v[31601] = 0;
          if ((b | 0) != 1) {
           break b;
          }
          b = M() | 0;
          sb(g);
          break g;
         }
         b = M() | 0;
         break f;
        }
        b = M() | 0;
        c = 1;
       }
       sb(e);
       if (!c) {
        break c;
       }
      }
      jc(a);
      break c;
     }
     if (v[f + 4 >> 2] != 1) {
      a = cc(8);
      v[31601] = 0;
      c = O(36, d + 72 | 0, 11584) | 0;
      b = v[31601];
      v[31601] = 0;
      if ((b | 0) != 1) {
       rc(a, c);
       v[31601] = 0;
       R(97, a | 0, 48396, 999);
       a = v[31601];
       v[31601] = 0;
       if ((a | 0) != 1) {
        break b;
       }
       b = M() | 0;
       sb(c);
       break c;
      }
      b = M() | 0;
      jc(a);
      break c;
     }
     b = v[b >> 2];
     c = oc(d + 52 | 0, 22256);
     e = v[c + 4 >> 2];
     v[d + 24 >> 2] = v[c >> 2];
     v[d + 28 >> 2] = e;
     if (Hc(b, g, d + 24 | 0)) {
      a = cc(8);
      v[31601] = 0;
      c = O(36, d + 72 | 0, 10482) | 0;
      b = v[31601];
      v[31601] = 0;
      if ((b | 0) != 1) {
       rc(a, c);
       v[31601] = 0;
       R(97, a | 0, 48396, 999);
       a = v[31601];
       v[31601] = 0;
       if ((a | 0) != 1) {
        break b;
       }
       b = M() | 0;
       sb(c);
       break c;
      }
      b = M() | 0;
      jc(a);
      break c;
     }
     c = oc(d + 44 | 0, 10974);
     e = v[c + 4 >> 2];
     v[d + 16 >> 2] = v[c >> 2];
     v[d + 20 >> 2] = e;
     if (Hc(b, g, d + 16 | 0)) {
      e = v[a + 8 >> 2];
      f = e >> 31;
      break e;
     }
     c = oc(d + 36 | 0, 8627);
     e = v[c + 4 >> 2];
     v[d + 8 >> 2] = v[c >> 2];
     v[d + 12 >> 2] = e;
     e = 0;
     f = 0;
     if (!Hc(b, g, d + 8 | 0)) {
      break e;
     }
     e = rk(w[v[a + 32 >> 2] + 140 | 0]);
     f = 0;
    }
    eb = d + 96 | 0;
    gb = f;
    return e | 0;
   }
   b = M() | 0;
   jc(a);
  }
  P(b | 0);
 }
 p();
}

function Vv(a, b) {
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
 if (!a) {
  return Fd(b);
 }
 if (b >>> 0 >= 4294967232) {
  v[31476] = 48;
  return 0;
 }
 f = b >>> 0 < 11 ? 16 : b + 11 & -8;
 i = a - 8 | 0;
 j = v[i + 4 >> 2];
 e = j & -8;
 a: {
  if (!(j & 3)) {
   if (f >>> 0 < 256) {
    break a;
   }
   if (e >>> 0 >= f + 4 >>> 0) {
    c = i;
    if (e - f >>> 0 <= v[31597] << 1 >>> 0) {
     break a;
    }
   }
   c = 0;
   break a;
  }
  g = e + i | 0;
  b: {
   if (e >>> 0 >= f >>> 0) {
    d = e - f | 0;
    if (d >>> 0 < 16) {
     break b;
    }
    v[i + 4 >> 2] = j & 1 | f | 2;
    c = f + i | 0;
    v[c + 4 >> 2] = d | 3;
    v[g + 4 >> 2] = v[g + 4 >> 2] | 1;
    Qv(c, d);
    break b;
   }
   if (v[31483] == (g | 0)) {
    e = e + v[31480] | 0;
    if (e >>> 0 <= f >>> 0) {
     break a;
    }
    v[i + 4 >> 2] = j & 1 | f | 2;
    d = f + i | 0;
    c = e - f | 0;
    v[d + 4 >> 2] = c | 1;
    v[31480] = c;
    v[31483] = d;
    break b;
   }
   if (v[31482] == (g | 0)) {
    e = e + v[31479] | 0;
    if (e >>> 0 < f >>> 0) {
     break a;
    }
    c = e - f | 0;
    c: {
     if (c >>> 0 >= 16) {
      v[i + 4 >> 2] = j & 1 | f | 2;
      d = f + i | 0;
      v[d + 4 >> 2] = c | 1;
      e = e + i | 0;
      v[e >> 2] = c;
      v[e + 4 >> 2] = v[e + 4 >> 2] & -2;
      break c;
     }
     v[i + 4 >> 2] = e | j & 1 | 2;
     c = e + i | 0;
     v[c + 4 >> 2] = v[c + 4 >> 2] | 1;
     c = 0;
    }
    v[31482] = d;
    v[31479] = c;
    break b;
   }
   d = v[g + 4 >> 2];
   if (d & 2) {
    break a;
   }
   k = e + (d & -8) | 0;
   if (k >>> 0 < f >>> 0) {
    break a;
   }
   m = k - f | 0;
   h = v[g + 12 >> 2];
   d: {
    if (d >>> 0 <= 255) {
     c = v[g + 8 >> 2];
     if ((c | 0) == (h | 0)) {
      n = 125908, o = v[31477] & Dua(-2, d >>> 3 | 0), v[n >> 2] = o;
      break d;
     }
     v[c + 12 >> 2] = h;
     v[h + 8 >> 2] = c;
     break d;
    }
    l = v[g + 24 >> 2];
    e: {
     if ((g | 0) != (h | 0)) {
      c = v[g + 8 >> 2];
      v[c + 12 >> 2] = h;
      v[h + 8 >> 2] = c;
      break e;
     }
     f: {
      c = v[g + 20 >> 2];
      if (c) {
       d = g + 20 | 0;
      } else {
       c = v[g + 16 >> 2];
       if (!c) {
        break f;
       }
       d = g + 16 | 0;
      }
      while (1) {
       e = d;
       h = c;
       d = c + 20 | 0;
       c = v[c + 20 >> 2];
       if (c) {
        continue;
       }
       d = h + 16 | 0;
       c = v[h + 16 >> 2];
       if (c) {
        continue;
       }
       break;
      }
      v[e >> 2] = 0;
      break e;
     }
     h = 0;
    }
    if (!l) {
     break d;
    }
    d = v[g + 28 >> 2];
    c = (d << 2) + 126212 | 0;
    g: {
     if (v[c >> 2] == (g | 0)) {
      v[c >> 2] = h;
      if (h) {
       break g;
      }
      n = 125912, o = v[31478] & Dua(-2, d), v[n >> 2] = o;
      break d;
     }
     v[(v[l + 16 >> 2] == (g | 0) ? 16 : 20) + l >> 2] = h;
     if (!h) {
      break d;
     }
    }
    v[h + 24 >> 2] = l;
    c = v[g + 16 >> 2];
    if (c) {
     v[h + 16 >> 2] = c;
     v[c + 24 >> 2] = h;
    }
    c = v[g + 20 >> 2];
    if (!c) {
     break d;
    }
    v[h + 20 >> 2] = c;
    v[c + 24 >> 2] = h;
   }
   if (m >>> 0 <= 15) {
    v[i + 4 >> 2] = j & 1 | k | 2;
    c = i + k | 0;
    v[c + 4 >> 2] = v[c + 4 >> 2] | 1;
    break b;
   }
   v[i + 4 >> 2] = j & 1 | f | 2;
   d = f + i | 0;
   v[d + 4 >> 2] = m | 3;
   c = i + k | 0;
   v[c + 4 >> 2] = v[c + 4 >> 2] | 1;
   Qv(d, m);
  }
  c = i;
 }
 if (c) {
  return c + 8 | 0;
 }
 d = Fd(b);
 if (!d) {
  return 0;
 }
 c = v[a - 4 >> 2];
 c = (c & 3 ? -4 : -8) + (c & -8) | 0;
 yc(d, a, b >>> 0 > c >>> 0 ? c : b);
 Bb(a);
 return d;
}

function CX(a, b) {
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0;
 f = eb - 16 | 0;
 eb = f;
 t[a | 0] = 0;
 c = w[b | 0];
 if (c) {
  t[a | 0] = c >>> 0 > 96 ? -1 : c + 12 | 0;
 }
 t[a + 1 | 0] = w[b + 1 | 0];
 c = w[b + 2 | 0];
 d = c - 16 | 0;
 a: {
  b: {
   if ((d & 255) >>> 0 <= 128) {
    t[a + 2 | 0] = 1;
    c = (d & 254) >>> 1 | 0;
    break b;
   }
   c: {
    switch ((c + 96 & 240) >>> 4 | 0) {
    case 0:
     t[a + 2 | 0] = 4;
     c = c & 15;
     break b;

    case 1:
     t[a + 2 | 0] = 3;
     c = c & 15;
     break b;

    case 2:
     t[a + 2 | 0] = 6;
     c = c & 15;
     break b;

    case 3:
     break c;

    default:
     break a;
    }
   }
   t[a + 2 | 0] = 5;
   c = c & 15;
  }
  t[a + 4 | 0] = c;
 }
 c = w[b + 6 | 0];
 e = w[b + 4 | 0];
 d = w[b + 5 | 0];
 d: {
  if (!(c | (e | d))) {
   break d;
  }
  e: {
   f: {
    g: {
     h: {
      i: {
       j: {
        switch (e | 0) {
        default:
         k: {
          switch (e - 29 | 0) {
          case 7:
           break f;

          case 5:
           break g;

          case 3:
           break h;

          case 0:
           break i;

          case 1:
          case 2:
          case 4:
          case 6:
           break d;

          default:
           break k;
          }
         }
         if ((e | 0) == 128) {
          break e;
         }
         if ((e | 0) != 157) {
          break d;
         }
         t[a + 2 | 0] = 15;
         t[a + 3 | 0] = 20;
         t[a + 4 | 0] = c >>> 3;
         t[f + 15 | 0] = 15;
         h = a, i = w[Pb(b + 5 | 0, f + 15 | 0) | 0] | 208, t[h + 5 | 0] = i;
         break d;

        case 0:
         Bf(a, c, d);
         g = w[b + 6 | 0] == 15;
         break d;

        case 1:
         t[a + 3 | 0] = 2;
         h = a, i = Dh(c << 4 | (d & 240) >>> 4), t[h + 5 | 0] = i;
         break d;

        case 2:
         t[a + 3 | 0] = 3;
         h = a, i = Dh(c << 4 | (d & 240) >>> 4), t[h + 5 | 0] = i;
         break d;

        case 3:
         t[a + 3 | 0] = 4;
         h = a, i = Dh(c << 4 | (d & 240) >>> 4), t[h + 5 | 0] = i;
         break d;

        case 4:
         t[a + 3 | 0] = 5;
         t[a + 5 | 0] = c & 240 | (d & 240) >>> 4;
         break d;

        case 8:
         if (d) {
          t[a + 5 | 0] = d;
          t[a + 3 | 0] = 9;
          break d;
         }
         if ((c - 1 & 255) >>> 0 > 1) {
          break d;
         }
         t[a + 5 | 0] = 145;
         t[a + 3 | 0] = 20;
         break d;

        case 12:
         t[a + 3 | 0] = 13;
         t[a + 5 | 0] = c >>> 1;
         break d;

        case 15:
         if (c) {
          t[a + 5 | 0] = c;
          t[a + 3 | 0] = 17;
          break d;
         }
         t[a + 3 | 0] = 16;
         t[a + 5 | 0] = d & 15;
         break d;

        case 16:
         break j;

        case 5:
        case 6:
        case 7:
        case 9:
        case 10:
        case 11:
        case 13:
        case 14:
         break d;
        }
       }
       CD(a, c, d, 1);
       g = (w[a + 3 | 0] & 254) == 16;
       break d;
      }
      t[a + 5 | 0] = d;
      t[a + 3 | 0] = 18;
      break d;
     }
     t[a + 3 | 0] = 31;
     t[a + 5 | 0] = c >>> 1;
     break d;
    }
    t[a + 3 | 0] = 31;
    t[a + 5 | 0] = c >>> 1 & 120;
    break d;
   }
   t[a + 5 | 0] = 159;
   t[a + 3 | 0] = 20;
   break d;
  }
  t[a + 3 | 0] = 21;
  t[a + 5 | 0] = c >>> 2;
 }
 b = w[b + 3 | 0];
 l: {
  if (!b) {
   break l;
  }
  m: {
   if (!w[a + 3 | 0]) {
    t[a + 3 | 0] = 9;
    c = 5;
    break m;
   }
   if (w[a + 2 | 0]) {
    break l;
   }
   t[a + 2 | 0] = 2;
   b = b >>> 2 | 0;
   c = 4;
  }
  t[c + a | 0] = b;
 }
 eb = f + 16 | 0;
 return g;
}

function zla(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, u = 0, w = 0, x = 0, y = 0, z = 0, A = 0, C = 0, D = 0, E = 0, F = 0, G = 0, H = 0, I = 0;
 e = eb - 48 | 0;
 eb = e;
 A = v[a + 16 >> 2];
 C = Fg(b + 327720 | 0, v[b + 20 >> 2], (v[a + 88 >> 2] & 16384) >>> 14 | 0);
 q = v[a + 8 >> 2];
 r = v[a + 12 >> 2];
 b = v[a >> 2];
 k = v[a + 4 >> 2];
 s = v[a + 128 >> 2];
 if (s) {
  u = Gg(q, r, s);
  w = gb;
  g = v[a + 76 >> 2];
  eg(b, k, uf(q, r, d), gb);
  x = gb >>> 0 > g >>> 0 ? d : 0;
 }
 j = a + 112 | 0;
 v[e + 24 >> 2] = v[a + 44 >> 2];
 v[e + 28 >> 2] = v[a + 48 >> 2];
 v[e + 32 >> 2] = v[a + 52 >> 2];
 v[e + 36 >> 2] = v[a + 56 >> 2];
 o = v[a + 40 >> 2];
 p = v[a + 36 >> 2];
 v[e + 8 >> 2] = b;
 v[e + 12 >> 2] = k;
 D = e + 24 | 0;
 while (1) {
  if (d) {
   d = d - 1 | 0;
   h = v[e + 12 >> 2];
   b = v[e + 8 >> 2];
   v[e + 40 >> 2] = b;
   v[e + 44 >> 2] = 0;
   x = x - 1 | 0;
   g = x;
   u = g ? u : 0;
   w = g ? w : 0;
   k = (((h & 2147483647) << 1 | b >>> 31) & -2) + A | 0;
   h = s;
   a: {
    b: while (1) {
     c: {
      if ((h | 0) <= 0) {
       Ob(j, v[a + 120 >> 2], v[a + 124 >> 2]);
       g = v[a + 116 >> 2];
       if (!g) {
        break a;
       }
       b = v[e + 40 >> 2];
       h = ((v[e + 44 >> 2] & 2147483647) << 1 | b >>> 31) & -2;
       i = 0;
       b = 0;
       break c;
      }
      b = v[e + 40 >> 2];
      g = ((v[e + 44 >> 2] & 2147483647) << 1 | b >>> 31) & -2;
      b = 0;
      i = 0;
      while (1) if ((b | 0) == 2) {
       be(j, i >>> 3 << 16 >> 16);
       ae(j, 4);
       Ob(e + 40 | 0, u, w);
       h = h - 1 | 0;
       continue b;
      } else {
       i = (t[k + (b | g) | 0] << 8) + i | 0;
       b = b + 1 | 0;
       continue;
      }
     }
     break;
    }
    while (1) {
     if ((b | 0) != 2) {
      i = (t[k + (b | h) | 0] << 8) + i | 0;
      b = b + 1 | 0;
      continue;
     }
     break;
    }
    be(j, i >>> 3 << 16 >> 16);
    ae(j, g);
    v[j >> 2] = v[j >> 2];
    v[j + 4 >> 2] = 0;
   }
   b = Eg(j, C);
   v[e + 4 >> 2] = b;
   v[e >> 2] = b;
   E = v[a + 72 >> 2];
   i = v[a + 68 >> 2];
   F = i >> 31;
   k = v[a + 64 >> 2];
   G = k >> 31;
   g = v[a + 60 >> 2];
   H = g >> 31;
   b = 0;
   while (1) {
    if ((b | 0) != 2) {
     y = (b << 2) + e | 0;
     f = v[y >> 2];
     h = (b << 3) + D | 0;
     I = v[h + 4 >> 2];
     l = v[h >> 2];
     v[h + 4 >> 2] = l;
     z = f << 8;
     f = z;
     f = Aua(f, f >> 31, g, H);
     m = gb;
     n = f;
     f = Xb(l, -16777216, 16776704);
     f = Aua(k, G, f, f >> 31);
     l = n + f | 0;
     n = gb + m | 0;
     n = f >>> 0 > l >>> 0 ? n + 1 | 0 : n;
     f = Xb(I, -16777216, 16776704);
     m = Aua(i, F, f, f >> 31);
     l = m + l | 0;
     f = gb + n | 0;
     f = l >>> 0 < m >>> 0 ? f + 1 | 0 : f;
     m = l + 8388608 | 0;
     f = m >>> 0 < 8388608 ? f + 1 | 0 : f;
     f = Rc(m, f, 24);
     v[h >> 2] = f - (E & z);
     v[y >> 2] = (f | 0) / 256;
     b = b + 1 | 0;
     continue;
    }
    break;
   }
   b = v[a + 32 >> 2];
   p = v[a + 28 >> 2] + p | 0;
   v[c >> 2] = v[c >> 2] + B(v[e >> 2], p >> 12);
   o = b + o | 0;
   v[c + 4 >> 2] = v[c + 4 >> 2] + B(v[e + 4 >> 2], o >> 12);
   Ob(e + 8 | 0, q, r);
   c = c + 8 | 0;
   continue;
  }
  break;
 }
 b = v[e + 12 >> 2];
 v[a >> 2] = v[e + 8 >> 2];
 v[a + 4 >> 2] = b;
 v[a + 40 >> 2] = o;
 v[a + 20 >> 2] = p >> 12;
 v[a + 36 >> 2] = p;
 v[a + 24 >> 2] = o >> 12;
 v[a + 44 >> 2] = v[e + 24 >> 2];
 v[a + 48 >> 2] = v[e + 28 >> 2];
 v[a + 52 >> 2] = v[e + 32 >> 2];
 v[a + 56 >> 2] = v[e + 36 >> 2];
 eb = e + 48 | 0;
}

function Yta(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
 l = eb - 32 | 0;
 eb = l;
 d = b;
 b = v[a >> 2];
 b = (lp(d, vb(b)) << 1) + b | 0;
 e = v[a + 4 >> 2];
 a: {
  b: {
   if (e >>> 0 < y[zb(a) >> 2]) {
    if ((b | 0) != (e | 0)) {
     break b;
    }
    d = eb - 16 | 0;
    eb = d;
    a = aj(d + 4 | 0, a, 1);
    _i(v[a + 4 >> 2], w[c | 0] | w[c + 1 | 0] << 8);
    v[a + 4 >> 2] = v[a + 4 >> 2] + 2;
    hc(a);
    eb = d + 16 | 0;
    break a;
   }
   d = zb(a);
   g = dk(l + 12 | 0, ek(a, _c(v[a >> 2], e) + 1 | 0), b - v[a >> 2] >> 1, d);
   v[31601] = 0;
   N(294, g | 0, c | 0);
   c = v[31601];
   v[31601] = 0;
   if ((c | 0) != 1) {
    h = eb - 16 | 0;
    eb = h;
    c = v[g + 4 >> 2];
    j = zb(a);
    d = ub(h + 12 | 0, b);
    f = ub(h + 8 | 0, v[a >> 2]);
    i = ub(h + 4 | 0, v[g + 4 >> 2]);
    e = v[d >> 2];
    m = v[f >> 2];
    d = eb + -64 | 0;
    eb = d;
    f = v[i >> 2];
    v[d + 56 >> 2] = f;
    v[d + 60 >> 2] = e;
    v[d + 52 >> 2] = f;
    f = zg(d + 24 | 0, j, d + 52 | 0, d + 56 | 0);
    v[d + 16 >> 2] = v[f + 8 >> 2];
    i = v[f + 4 >> 2];
    v[d + 8 >> 2] = v[f >> 2];
    v[d + 12 >> 2] = i;
    yg(d + 36 | 0, d + 8 | 0);
    while (1) {
     if (Ed(e, m)) {
      f = eb - 16 | 0;
      eb = f;
      v[f + 12 >> 2] = v[d + 56 >> 2];
      Q$(f + 12 | 0, -1);
      eb = f + 16 | 0;
      k = v[f + 12 >> 2];
      e = Fn(e);
      _i(k, w[e | 0] | w[e + 1 | 0] << 8);
      e = Uk(d + 60 | 0);
      Uk(d + 56 | 0);
      e = v[e >> 2];
      continue;
     }
     break;
    }
    e = d + 36 | 0;
    xg(e);
    f = v[d + 56 >> 2];
    R$(e);
    eb = d - -64 | 0;
    v[g + 4 >> 2] = f;
    f = v[a + 4 >> 2];
    d = eb - 48 | 0;
    eb = d;
    e = v[g + 8 >> 2];
    v[d + 44 >> 2] = e;
    v[d + 40 >> 2] = e;
    e = zg(d + 12 | 0, j, d + 40 | 0, d + 44 | 0);
    v[d + 8 >> 2] = v[e + 8 >> 2];
    j = v[e + 4 >> 2];
    v[d >> 2] = v[e >> 2];
    v[d + 4 >> 2] = j;
    yg(d + 24 | 0, d);
    while (1) {
     if ((b | 0) != (f | 0)) {
      _i(v[d + 44 >> 2], w[b | 0] | w[b + 1 | 0] << 8);
      v[d + 44 >> 2] = v[d + 44 >> 2] + 2;
      b = b + 2 | 0;
      continue;
     }
     break;
    }
    b = d + 24 | 0;
    xg(b);
    e = v[d + 44 >> 2];
    R$(b);
    eb = d + 48 | 0;
    v[g + 8 >> 2] = e;
    Sb(a, g + 4 | 0);
    Sb(a + 4 | 0, g + 8 | 0);
    Sb(zb(a), mc(g));
    v[g >> 2] = v[g + 4 >> 2];
    eb = h + 16 | 0;
    b = c;
    $i(g);
    break a;
   }
   a = M() | 0;
   $i(g);
   P(a | 0);
   p();
  }
  j = eb - 16 | 0;
  eb = j;
  h = v[a + 4 >> 2];
  g = (h - (b + 2 | 0) | 0) + b | 0;
  i = aj(j + 4 | 0, a, e - g >> 1);
  f = v[i + 4 >> 2];
  d = g;
  while (1) {
   if (d >>> 0 >= e >>> 0) {
    hc(i);
    f = eb - 16 | 0;
    eb = f;
    i = f + 8 | 0;
    d = h;
    h = eb - 32 | 0;
    eb = h;
    ed(h + 24 | 0, b, g);
    m = h + 16 | 0;
    n = v[h + 24 >> 2];
    g = eb - 16 | 0;
    eb = g;
    k = v[h + 28 >> 2];
    e = k;
    while (1) {
     if ((e | 0) != (n | 0)) {
      e = e - 2 | 0;
      d = P$(d - 2 | 0, e);
      continue;
     }
     break;
    }
    v[g + 12 >> 2] = d;
    pc(m, k, g + 12 | 0);
    eb = g + 16 | 0;
    d = v[h + 16 >> 2];
    v[h + 12 >> 2] = v[h + 20 >> 2];
    pc(i, d, h + 12 | 0);
    eb = h + 32 | 0;
    eb = f + 16 | 0;
    eb = j + 16 | 0;
   } else {
    _i(f, w[d | 0] | w[d + 1 | 0] << 8);
    f = f + 2 | 0;
    v[i + 4 >> 2] = f;
    d = d + 2 | 0;
    continue;
   }
   break;
  }
  a = (b >>> 0 <= c >>> 0 ? (y[a + 4 >> 2] > c >>> 0) << 1 : 0) + c | 0;
  c = w[a | 0];
  t[b + 1 | 0] = w[a + 1 | 0];
  t[b | 0] = c;
 }
 vb(b);
 eb = l + 32 | 0;
}

function EO(a, b, c) {
 a = a | 0;
 b = C(b);
 c = c | 0;
 var d = 0, e = C(0), f = C(0), g = C(0), h = C(0), i = C(0), k = C(0), m = 0, n = 0, o = 0;
 d = eb - 16 | 0;
 eb = d;
 a: {
  b: {
   c: {
    d: {
     switch (c - 1 | 0) {
     case 0:
      a = (q(b), j(2));
      e: {
       f: {
        g: {
         if ((a | 0) <= 8388607) {
          e = C(C(-1) / C(b * b));
          if (b == C(0)) {
           break e;
          }
          e = C(C(b - b) / C(0));
          if ((a | 0) < 0) {
           break e;
          }
          a = (q(C(b * C(33554432))), j(2));
          c = -152;
          break g;
         }
         if (a >>> 0 > 2139095039) {
          break f;
         }
         c = -127;
         b = C(0);
         if ((a | 0) == 1065353216) {
          break f;
         }
        }
        a = a + 4913933 | 0;
        k = C((a >>> 23 | 0) + c | 0);
        b = C((l(2, (a & 8388607) + 1060439283 | 0), r()) + C(-1));
        f = C(b * C(b * C(.5)));
        g = C(b / C(b + C(2)));
        h = C(g * g);
        i = C(h * h);
        e = b;
        b = (l(2, (q(C(b - f)), j(2)) & -4096), r());
        f = C(C(g * C(f + C(C(h * C(C(i * C(.2849878668785095)) + C(.6666666269302368))) + C(i * C(C(i * C(.24279078841209412)) + C(.40000972151756287)))))) + C(C(e - b) - f));
        b = C(C(k * C(.3010292053222656)) + C(C(b * C(.434326171875)) + C(C(f * C(.434326171875)) + C(C(k * C(7.903415166765626e-7)) + C(C(f + b) * C(-3168997136526741e-20))))));
       }
       e = b;
      }
      b = C(e * C(2e3));
      if (!(C(D(b)) < C(2147483648))) {
       break c;
      }
      a = ~~b;
      break b;

     case 1:
      a = (B(v[a + 24604 >> 2], 100) | 0) / 128 | 0;
      break b;

     case 2:
      c = eb - 16 | 0;
      eb = c;
      h: {
       i: {
        j: {
         k: {
          a = w[a + 24648 | 0];
          if (a >>> 0 >= 6) {
           a = cc(8);
           v[31601] = 0;
           c = O(36, c + 4 | 0, 5123) | 0;
           d = v[31601];
           v[31601] = 0;
           if ((d | 0) == 1) {
            break k;
           }
           rc(a, c);
           v[31601] = 0;
           R(97, a | 0, 48396, 999);
           a = v[31601];
           v[31601] = 0;
           if ((a | 0) != 1) {
            break i;
           }
           d = M() | 0;
           sb(c);
           break j;
          }
          eb = c + 16 | 0;
          a = v[(a << 2) + 79256 >> 2];
          break h;
         }
         d = M() | 0;
         jc(a);
        }
        P(d | 0);
       }
       p();
      }
      break b;

     case 3:
      v[d + 4 >> 2] = 0;
      m = v[a + 24640 >> 2];
      c = eb - 80 | 0;
      eb = c;
      a = v[a + 24636 >> 2];
      v[c + 40 >> 2] = a;
      v[c >> 2] = m;
      n = c + 40 | 0;
      o = v[Ye(n, c) >> 2];
      l: {
       if ((a | 0) == v[Tq(n) + 32 >> 2]) {
        a = -1;
        if (v[Tq(c) + 36 >> 2] == (m | 0)) {
         break l;
        }
       }
       a = 0;
       if ((o | 0) <= 0) {
        break l;
       }
       a = (o + 500 >>> 0) / 1e3 | 0;
      }
      v[d + 4 >> 2] = a;
      eb = c + 80 | 0;
      a = v[d + 4 >> 2];
      break b;

     default:
      break d;
     }
    }
    c = cc(8);
    v[31601] = 0;
    d = O(36, d + 4 | 0, 10385) | 0;
    a = v[31601];
    v[31601] = 0;
    m: {
     if ((a | 0) != 1) {
      rc(c, d);
      v[31601] = 0;
      R(97, c | 0, 48396, 999);
      a = v[31601];
      v[31601] = 0;
      if ((a | 0) != 1) {
       break a;
      }
      a = M() | 0;
      sb(d);
      break m;
     }
     a = M() | 0;
     jc(c);
    }
    P(a | 0);
    p();
   }
   a = -2147483648;
  }
  eb = d + 16 | 0;
  return a | 0;
 }
 p();
}

function Bu(a, b, c) {
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0;
 f = eb - 128 | 0;
 eb = f;
 a: {
  b: {
   c: {
    d: {
     e: {
      f: {
       g: {
        if (!c) {
         break g;
        }
        d = v[c + 4 >> 2];
        if (!d & y[c >> 2] >= y[b + 4 >> 2] | d) {
         break g;
        }
        a = cc(8);
        v[31601] = 0;
        b = O(51, a | 0, 22256) | 0;
        c = v[31601];
        v[31601] = 0;
        if ((c | 0) != 1) {
         break f;
        }
        e = M() | 0;
        jc(a);
        break a;
       }
       if (!v[b >> 2]) {
        a = cc(8);
        v[31601] = 0;
        b = Q(854, a | 0) | 0;
        c = v[31601];
        v[31601] = 0;
        if ((c | 0) != 1) {
         break e;
        }
        e = M() | 0;
        jc(a);
        break a;
       }
       d = v[b >> 2];
       k = v[b + 4 >> 2];
       b = eb - 16 | 0;
       eb = b;
       lf(b + 8 | 0, d, k);
       h = v[b + 8 >> 2];
       d = f + 108 | 0;
       AG(d, h, v[b + 12 >> 2]);
       v[d + 12 >> 2] = 0;
       eb = b + 16 | 0;
       h: {
        i: {
         if (a & 2) {
          b = Kn(f + 88 | 0, d);
          v[31601] = 0;
          g = Q(855, b | 0) | 0;
          i = v[31601];
          v[31601] = 0;
          b = 1;
          if ((i | 0) == 1) {
           break h;
          }
          if ((g | 0) == 1) {
           break i;
          }
          b = Kn(f + 68 | 0, d);
          v[31601] = 0;
          i = Q(856, b | 0) | 0;
          h = v[31601];
          v[31601] = 0;
          b = 1;
          if ((h | 0) == 1) {
           break d;
          }
          if ((i | 0) == 1) {
           break i;
          }
          b = Kn(f + 48 | 0, d);
          v[31601] = 0;
          h = O(857, b | 0, c | 0) | 0;
          j = v[31601];
          v[31601] = 0;
          b = 1;
          if ((j | 0) == 1) {
           break c;
          }
          if ((h | 0) == 1) {
           break i;
          }
          b = Kn(f + 28 | 0, d);
          v[31601] = 0;
          j = O(858, b | 0, c | 0) | 0;
          l = v[31601];
          v[31601] = 0;
          b = 1;
          if ((l | 0) == 1) {
           break b;
          }
          if ((j | 0) == 1) {
           break i;
          }
          g = 0 - ((g | 0) == -1 | (i | 0) == -1 | (h | 0) == -1 | (j | 0) == -1) | 0;
         }
         j: {
          if (!(a & 1)) {
           break j;
          }
          while (1) {
           if ((e | 0) == 576) {
            break j;
           }
           a = v[e + 29856 >> 2];
           if (a) {
            b = Kn(f + 8 | 0, d);
            v[31601] = 0;
            a = O(a | 0, b | 0, c | 0) | 0;
            b = v[31601];
            v[31601] = 0;
            if ((b | 0) == 1) {
             e = M() | 0;
             break a;
            }
            b = 1;
            if ((a | 0) == 1) {
             break i;
            }
            g = (a | 0) == -1 ? -1 : g;
           }
           e = e + 12 | 0;
           continue;
          }
         }
         a = k;
         if (c) {
          b = 0;
          if ((g | 0) != -1) {
           break i;
          }
          b = Ac(v[c >> 2], v[c + 4 >> 2]) >>> 0 > a >>> 0 ? -1 : 0;
          break i;
         }
         b = 0;
         if ((g | 0) != -1) {
          break i;
         }
         b = a >>> 0 > 2047 ? 1 : -1;
        }
        eb = f + 128 | 0;
        return b;
       }
       e = M() | 0;
       break a;
      }
      ca(b | 0, 124800, 17);
      p();
     }
     ca(b | 0, 124696, 17);
     p();
    }
    e = M() | 0;
    break a;
   }
   e = M() | 0;
   break a;
  }
  e = M() | 0;
 }
 P(e | 0);
 p();
}

function a7(a, b, c, d, e, f, g, h, i) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 f = f | 0;
 g = g | 0;
 h = h | 0;
 i = i | 0;
 var j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, q = 0, r = 0;
 a = eb - 1056 | 0;
 eb = a;
 v[a + 16 >> 2] = f;
 v[a + 20 >> 2] = g;
 v[a + 24 >> 2] = h;
 v[a + 28 >> 2] = i;
 k = a + 944 | 0;
 v[a + 940 >> 2] = k;
 j = sy(k, 100, 11182, a + 16 | 0);
 v[a + 48 >> 2] = 1238;
 l = a + 48 | 0;
 o = Ce(a + 520 | 0, 0, l);
 v[a + 48 >> 2] = 1238;
 l = Ce(a + 512 | 0, 0, l);
 a: {
  b: {
   c: {
    d: {
     if (j >>> 0 < 100) {
      h = a + 528 | 0;
      break d;
     }
     j = Nd();
     v[a >> 2] = f;
     v[a + 4 >> 2] = g;
     v[a + 8 >> 2] = h;
     v[a + 12 >> 2] = i;
     j = hj(a + 940 | 0, j, 11182, a);
     if ((j | 0) != -1) {
      k = v[a + 940 >> 2];
      Qe(o, k);
      Qe(l, Fd(j << 2));
      h = v[l >> 2];
      if (!Ej(h)) {
       break d;
      }
     }
     v[31601] = 0;
     W(1239);
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) != 1) {
      break a;
     }
     j = M() | 0;
     break c;
    }
    bd(a + 508 | 0, v[d + 28 >> 2]);
    v[31601] = 0;
    r = Q(1251, v[a + 508 >> 2]) | 0;
    f = v[31601];
    v[31601] = 0;
    e: {
     f: {
      g: {
       h: {
        i: {
         j: {
          if ((f | 0) == 1) {
           break j;
          }
          v[31601] = 0;
          U(1262, r | 0, k | 0, j + k | 0, h | 0);
          f = v[31601];
          v[31601] = 0;
          if ((f | 0) == 1) {
           break j;
          }
          q = (j | 0) > 0 ? w[v[a + 940 >> 2]] == 45 : q;
          i = Eb(a + 484 | 0);
          f = Eb(a + 472 | 0);
          g = Eb(a + 460 | 0);
          v[31601] = 0;
          ja(1291, c | 0, q | 0, v[a + 508 >> 2], a + 504 | 0, a + 500 | 0, a + 496 | 0, i | 0, f | 0, g | 0, a + 456 | 0);
          c = v[31601];
          v[31601] = 0;
          if ((c | 0) == 1) {
           break i;
          }
          v[a + 36 >> 2] = 1238;
          c = Ce(a + 40 | 0, 0, a + 36 | 0);
          k = a + 48 | 0;
          n = v[a + 456 >> 2];
          k: {
           if ((n | 0) < (j | 0)) {
            m = ((Cb(v[g + 4 >> 2], w[g + 11 | 0]) + (j - n << 1) | 0) + Cb(v[f + 4 >> 2], w[f + 11 | 0]) | 0) + 1 | 0;
            break k;
           }
           m = (Cb(v[g + 4 >> 2], w[g + 11 | 0]) + Cb(v[f + 4 >> 2], w[f + 11 | 0]) | 0) + 2 | 0;
          }
          m = m + n | 0;
          if (m >>> 0 < 101) {
           break h;
          }
          Qe(c, Fd(m << 2));
          k = v[c >> 2];
          if (k) {
           break h;
          }
          v[31601] = 0;
          W(1239);
          b = v[31601];
          v[31601] = 0;
          if ((b | 0) != 1) {
           break a;
          }
          break g;
         }
         j = M() | 0;
         break e;
        }
        j = M() | 0;
        break f;
       }
       m = v[d + 4 >> 2];
       v[31601] = 0;
       la(1292, k | 0, a + 36 | 0, a + 32 | 0, m | 0, h | 0, (j << 2) + h | 0, r | 0, q | 0, a + 504 | 0, v[a + 500 >> 2], v[a + 496 >> 2], i | 0, f | 0, g | 0, n | 0);
       h = v[31601];
       v[31601] = 0;
       if ((h | 0) != 1) {
        v[31601] = 0;
        b = da(1272, b | 0, k | 0, v[a + 36 >> 2], v[a + 32 >> 2], d | 0, e | 0) | 0;
        d = v[31601];
        v[31601] = 0;
        if ((d | 0) != 1) {
         break b;
        }
       }
      }
      j = M() | 0;
      Kc(c);
     }
     Tb(g);
     Tb(f);
     sb(i);
    }
    Zb(a + 508 | 0);
   }
   Kc(l);
   Kc(o);
   P(j | 0);
   p();
  }
  Kc(c);
  Tb(g);
  Tb(f);
  sb(i);
  Zb(a + 508 | 0);
  Kc(l);
  Kc(o);
  eb = a + 1056 | 0;
  return b | 0;
 }
 p();
}

function I7(a, b, c, d, e, f, g) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 f = f | 0;
 g = g | 0;
 var h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, q = 0, r = 0;
 j = eb - 16 | 0;
 eb = j;
 k = Sy(v[g >> 2]);
 o = Fy(v[g >> 2]);
 rh(j + 4 | 0, o);
 v[f >> 2] = d;
 a: {
  b: {
   c: {
    i = a;
    g = w[i | 0];
    switch (g - 43 | 0) {
    case 0:
    case 2:
     break c;

    default:
     break b;
    }
   }
   v[31601] = 0;
   g = O(1269, k | 0, g << 24 >> 24) | 0;
   i = v[31601];
   v[31601] = 0;
   if ((i | 0) == 1) {
    break a;
   }
   i = v[f >> 2];
   v[f >> 2] = i + 4;
   v[i >> 2] = g;
   i = a + 1 | 0;
  }
  d: {
   g = i;
   if (!((c - g | 0) <= 1 | w[g | 0] != 48 | (w[g + 1 | 0] | 32) != 120)) {
    v[31601] = 0;
    i = O(1269, k | 0, 48) | 0;
    h = v[31601];
    v[31601] = 0;
    if ((h | 0) == 1) {
     break a;
    }
    h = v[f >> 2];
    v[f >> 2] = h + 4;
    v[h >> 2] = i;
    i = t[g + 1 | 0];
    v[31601] = 0;
    i = O(1269, k | 0, i | 0) | 0;
    h = v[31601];
    v[31601] = 0;
    if ((h | 0) == 1) {
     break a;
    }
    h = v[f >> 2];
    v[f >> 2] = h + 4;
    v[h >> 2] = i;
    i = g + 2 | 0;
    g = i;
    while (1) {
     if (c >>> 0 <= g >>> 0) {
      break d;
     }
     h = t[g | 0];
     Nd();
     if (!_n(h)) {
      break d;
     }
     g = g + 1 | 0;
     continue;
    }
   }
   while (1) {
    if (c >>> 0 <= g >>> 0) {
     break d;
    }
    h = t[g | 0];
    Nd();
    if (!Zn(h)) {
     break d;
    }
    g = g + 1 | 0;
    continue;
   }
  }
  e: {
   if (zd(v[j + 8 >> 2], w[j + 15 | 0])) {
    h = v[f >> 2];
    v[31601] = 0;
    U(1262, k | 0, i | 0, g | 0, h | 0);
    h = v[31601];
    v[31601] = 0;
    if ((h | 0) == 1) {
     break a;
    }
    v[f >> 2] = v[f >> 2] + (g - i << 2);
    break e;
   }
   Bm(i, g);
   v[31601] = 0;
   r = Q(1260, o | 0) | 0;
   h = v[31601];
   v[31601] = 0;
   if ((h | 0) == 1) {
    break a;
   }
   h = i;
   while (1) {
    if (g >>> 0 <= h >>> 0) {
     vt((i - a << 2) + d | 0, v[f >> 2]);
     break e;
    }
    f: {
     if (t[dc(j + 4 | 0, l) | 0] <= 0) {
      break f;
     }
     if (t[dc(j + 4 | 0, l) | 0] != (m | 0)) {
      break f;
     }
     m = v[f >> 2];
     v[f >> 2] = m + 4;
     v[m >> 2] = r;
     l = (Cb(v[j + 8 >> 2], w[j + 15 | 0]) - 1 >>> 0 > l >>> 0) + l | 0;
     m = 0;
    }
    q = t[h | 0];
    v[31601] = 0;
    q = O(1269, k | 0, q | 0) | 0;
    n = v[31601];
    v[31601] = 0;
    if ((n | 0) != 1) {
     n = v[f >> 2];
     v[f >> 2] = n + 4;
     v[n >> 2] = q;
     h = h + 1 | 0;
     m = m + 1 | 0;
     continue;
    }
    break;
   }
   break a;
  }
  g: {
   while (1) {
    if (c >>> 0 > g >>> 0) {
     i = t[g | 0];
     if ((i | 0) == 46) {
      v[31601] = 0;
      i = Q(1263, o | 0) | 0;
      h = v[31601];
      v[31601] = 0;
      if ((h | 0) == 1) {
       break a;
      }
      l = v[f >> 2];
      h = l + 4 | 0;
      v[f >> 2] = h;
      v[l >> 2] = i;
      g = g + 1 | 0;
      break g;
     }
     v[31601] = 0;
     i = O(1269, k | 0, i | 0) | 0;
     h = v[31601];
     v[31601] = 0;
     if ((h | 0) == 1) {
      break a;
     }
     h = v[f >> 2];
     v[f >> 2] = h + 4;
     v[h >> 2] = i;
     g = g + 1 | 0;
     continue;
    }
    break;
   }
   h = v[f >> 2];
  }
  v[31601] = 0;
  U(1262, k | 0, g | 0, c | 0, h | 0);
  i = v[31601];
  v[31601] = 0;
  if ((i | 0) == 1) {
   break a;
  }
  i = f;
  f = v[f >> 2] + (c - g << 2) | 0;
  v[i >> 2] = f;
  v[e >> 2] = (b | 0) == (c | 0) ? f : (b - a << 2) + d | 0;
  sb(j + 4 | 0);
  eb = j + 16 | 0;
  return;
 }
 a = M() | 0;
 sb(j + 4 | 0);
 P(a | 0);
 p();
}

function e7(a, b, c, d, e, f, g, h, i) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 f = f | 0;
 g = g | 0;
 h = h | 0;
 i = i | 0;
 var j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, q = 0, r = 0;
 a = eb - 448 | 0;
 eb = a;
 v[a + 16 >> 2] = f;
 v[a + 20 >> 2] = g;
 v[a + 24 >> 2] = h;
 v[a + 28 >> 2] = i;
 k = a + 336 | 0;
 v[a + 332 >> 2] = k;
 j = sy(k, 100, 11182, a + 16 | 0);
 v[a + 48 >> 2] = 1238;
 l = a + 48 | 0;
 o = Ce(a + 216 | 0, 0, l);
 v[a + 48 >> 2] = 1238;
 l = Ce(a + 208 | 0, 0, l);
 a: {
  b: {
   c: {
    d: {
     if (j >>> 0 < 100) {
      h = a + 224 | 0;
      break d;
     }
     j = Nd();
     v[a >> 2] = f;
     v[a + 4 >> 2] = g;
     v[a + 8 >> 2] = h;
     v[a + 12 >> 2] = i;
     j = hj(a + 332 | 0, j, 11182, a);
     if ((j | 0) != -1) {
      k = v[a + 332 >> 2];
      Qe(o, k);
      Qe(l, Fd(j));
      h = v[l >> 2];
      if (!Ej(h)) {
       break d;
      }
     }
     v[31601] = 0;
     W(1239);
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) != 1) {
      break a;
     }
     j = M() | 0;
     break c;
    }
    bd(a + 204 | 0, v[d + 28 >> 2]);
    v[31601] = 0;
    r = Q(28, v[a + 204 >> 2]) | 0;
    f = v[31601];
    v[31601] = 0;
    e: {
     f: {
      g: {
       h: {
        i: {
         j: {
          if ((f | 0) == 1) {
           break j;
          }
          v[31601] = 0;
          U(1248, r | 0, k | 0, j + k | 0, h | 0);
          f = v[31601];
          v[31601] = 0;
          if ((f | 0) == 1) {
           break j;
          }
          q = (j | 0) > 0 ? w[v[a + 332 >> 2]] == 45 : q;
          i = Eb(a + 184 | 0);
          f = Eb(a + 172 | 0);
          g = Eb(a + 160 | 0);
          v[31601] = 0;
          ja(1289, c | 0, q | 0, v[a + 204 >> 2], a + 200 | 0, a + 199 | 0, a + 198 | 0, i | 0, f | 0, g | 0, a + 156 | 0);
          c = v[31601];
          v[31601] = 0;
          if ((c | 0) == 1) {
           break i;
          }
          v[a + 36 >> 2] = 1238;
          c = Ce(a + 40 | 0, 0, a + 36 | 0);
          k = a + 48 | 0;
          n = v[a + 156 >> 2];
          k: {
           if ((n | 0) < (j | 0)) {
            m = ((Cb(v[g + 4 >> 2], w[g + 11 | 0]) + (j - n << 1) | 0) + Cb(v[f + 4 >> 2], w[f + 11 | 0]) | 0) + 1 | 0;
            break k;
           }
           m = (Cb(v[g + 4 >> 2], w[g + 11 | 0]) + Cb(v[f + 4 >> 2], w[f + 11 | 0]) | 0) + 2 | 0;
          }
          m = m + n | 0;
          if (m >>> 0 < 101) {
           break h;
          }
          Qe(c, Fd(m));
          k = v[c >> 2];
          if (k) {
           break h;
          }
          v[31601] = 0;
          W(1239);
          b = v[31601];
          v[31601] = 0;
          if ((b | 0) != 1) {
           break a;
          }
          break g;
         }
         j = M() | 0;
         break e;
        }
        j = M() | 0;
        break f;
       }
       m = v[d + 4 >> 2];
       v[31601] = 0;
       la(1290, k | 0, a + 36 | 0, a + 32 | 0, m | 0, h | 0, h + j | 0, r | 0, q | 0, a + 200 | 0, t[a + 199 | 0], t[a + 198 | 0], i | 0, f | 0, g | 0, n | 0);
       h = v[31601];
       v[31601] = 0;
       if ((h | 0) != 1) {
        v[31601] = 0;
        b = da(23, b | 0, k | 0, v[a + 36 >> 2], v[a + 32 >> 2], d | 0, e | 0) | 0;
        d = v[31601];
        v[31601] = 0;
        if ((d | 0) != 1) {
         break b;
        }
       }
      }
      j = M() | 0;
      Kc(c);
     }
     sb(g);
     sb(f);
     sb(i);
    }
    Zb(a + 204 | 0);
   }
   Kc(l);
   Kc(o);
   P(j | 0);
   p();
  }
  Kc(c);
  sb(g);
  sb(f);
  sb(i);
  Zb(a + 204 | 0);
  Kc(l);
  Kc(o);
  eb = a + 448 | 0;
  return b | 0;
 }
 p();
}

function Hi(a, b, c, d, e, f) {
 var g = 0, h = 0, i = 0, j = C(0), k = C(0), l = 0, m = 0, n = C(0), o = C(0), p = C(0), q = 0, r = C(0);
 m = hb[v[v[a >> 2] + 140 >> 2]](a) | 0;
 g = v[a + 20 >> 2];
 h = m ? h : w[g + 25 | 0];
 j = z[g + 144 >> 2];
 k = C(1);
 if (!(hb[v[v[a >> 2] + 140 >> 2]](a) | 0)) {
  k = z[v[a + 20 >> 2] + 144 >> 2];
 }
 j = C(C(1) - j);
 a: {
  if ((hb[v[v[a >> 2] + 156 >> 2]](a) | 0) <= 0) {
   break a;
  }
  if (!oQ(w[v[a + 20 >> 2] + 24 | 0])) {
   break a;
  }
  j = C(C(j + j) + C(-1));
  k = C(-j);
 }
 n = z[a + 4196 >> 2];
 k = C(k * n);
 j = C(j * n);
 g = 0;
 l = v[a + 44 >> 2];
 m = Gc(l, 0);
 l = Gc(l, 1);
 b: {
  c: {
   d: {
    e: {
     f: {
      g: {
       h: {
        h = h & 255;
        switch (h | 0) {
        case 0:
         break h;

        case 5:
         break c;

        case 4:
         break d;

        case 3:
         break e;

        case 2:
         break f;

        case 1:
         break g;

        default:
         break b;
        }
       }
       while (1) {
        if ((f | 0) == (h | 0)) {
         break b;
        }
        g = h << 2;
        i = g + b | 0;
        z[i >> 2] = z[i >> 2] + C(C(z[d + g >> 2] * j) + C(k * z[g + m >> 2]));
        i = c + g | 0;
        z[i >> 2] = z[i >> 2] + C(C(z[e + g >> 2] * j) + C(k * z[g + l >> 2]));
        h = h + 1 | 0;
        continue;
       }
      }
      while (1) {
       if ((f | 0) == (g | 0)) {
        break b;
       }
       h = g << 2;
       i = h + b | 0;
       z[i >> 2] = z[i >> 2] + C(z[h + m >> 2] - C(z[d + h >> 2] * j));
       i = c + h | 0;
       z[i >> 2] = z[i >> 2] + C(z[h + l >> 2] - C(z[e + h >> 2] * j));
       g = g + 1 | 0;
       continue;
      }
     }
     while (1) {
      if ((f | 0) == (g | 0)) {
       break b;
      }
      h = g << 2;
      i = h + b | 0;
      z[i >> 2] = z[i >> 2] + C(z[d + h >> 2] - C(z[h + m >> 2] * k));
      i = c + h | 0;
      z[i >> 2] = z[i >> 2] + C(z[e + h >> 2] - C(z[h + l >> 2] * k));
      g = g + 1 | 0;
      continue;
     }
    }
    while (1) {
     if ((f | 0) == (g | 0)) {
      break b;
     }
     h = g << 2;
     i = h + b | 0;
     z[i >> 2] = z[i >> 2] - C(z[d + h >> 2] - C(z[h + m >> 2] * j));
     i = c + h | 0;
     z[i >> 2] = z[i >> 2] - C(z[e + h >> 2] - C(z[h + l >> 2] * j));
     g = g + 1 | 0;
     continue;
    }
   }
   while (1) {
    if ((f | 0) == (g | 0)) {
     break b;
    }
    h = g << 2;
    i = h + b | 0;
    k = z[i >> 2];
    q = i;
    r = k;
    n = z[h + m >> 2];
    i = c + h | 0;
    o = z[i >> 2];
    p = z[h + l >> 2];
    k = C(C(C(C(k + n) + o) + p) * C(.5));
    z[q >> 2] = r - C(C(k + C(k - C(z[d + h >> 2] * j))) - n);
    z[i >> 2] = o - C(C(k + C(k - C(z[e + h >> 2] * j))) - p);
    g = g + 1 | 0;
    continue;
   }
  }
  g = oQ(w[v[a + 20 >> 2] + 24 | 0]);
  j = g ? C(j * C(.5)) : j;
  k = g ? C(k * C(.5)) : k;
  h = 0;
  while (1) {
   if ((f | 0) == (h | 0)) {
    break b;
   }
   g = h << 2;
   i = g + b | 0;
   n = C(z[d + g >> 2] - z[g + m >> 2]);
   o = C(z[g + l >> 2] - z[e + g >> 2]);
   z[i >> 2] = z[i >> 2] + C(C(j * n) + C(k * o));
   g = c + g | 0;
   z[g >> 2] = z[g >> 2] + C(C(k * n) + C(j * o));
   h = h + 1 | 0;
   continue;
  }
 }
 i: {
  if (!((w[v[a + 20 >> 2] + 24 | 0] & 4) >>> 2 | 0)) {
   break i;
  }
  if (hb[v[v[a >> 2] + 140 >> 2]](a) | 0) {
   break i;
  }
  g = 0;
  while (1) {
   if ((f | 0) == (g | 0)) {
    break i;
   }
   a = g << 2;
   d = a + b | 0;
   z[d >> 2] = z[a + m >> 2] + z[d >> 2];
   d = a + c | 0;
   z[d >> 2] = z[a + l >> 2] + z[d >> 2];
   g = g + 1 | 0;
   continue;
  }
 }
}

function qha(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = C(0), g = C(0), h = C(0), i = 0, j = 0, k = C(0), l = 0, m = 0, n = C(0), o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, x = C(0), y = 0, A = 0, B = 0, E = 0, F = 0, G = 0, H = C(0), I = 0, J = 0, K = 0, L = 0, M = 0, N = C(0), O = 0, P = C(0);
 a: {
  if (!v[a + 4316 >> 2]) {
   break a;
  }
  if (!si(a + 44 | 0)) {
   break a;
  }
  F = a + 4300 | 0;
  G = a + 4288 | 0;
  I = a + 4264 | 0;
  J = a + 4276 | 0;
  e = v[a + 44 >> 2];
  r = Gc(e, 0);
  s = Gc(e, 1);
  e = v[a + 56 >> 2];
  t = Gc(e, 0);
  u = Gc(e, 1);
  K = hb[v[v[a >> 2] + 196 >> 2]](a) | 0;
  x = C(C(hb[v[v[a >> 2] + 204 >> 2]](a)) / C(100));
  H = C(hb[v[v[a >> 2] + 192 >> 2]](a));
  y = hb[v[v[a >> 2] + 216 >> 2]](a) | 0;
  L = y & 1;
  o = v[a + 4324 >> 2];
  l = v[a + 4320 >> 2];
  m = v[a + 4328 >> 2];
  j = v[a + 4312 >> 2];
  M = v[a + 4276 >> 2];
  p = v[a + 4264 >> 2];
  A = v[a + 4256 >> 2];
  B = w[a + 4260 | 0];
  E = d;
  while (1) {
   if (E) {
    h = z[s >> 2];
    k = z[r >> 2];
    i = v[a + 4316 >> 2];
    e = xo(i, j + A | 0);
    i = xo(i, j);
    b: {
     if (B) {
      O = xb(G, m), P = k, z[O >> 2] = P;
      O = xb(F, m), P = h, z[O >> 2] = P;
      q = xb(p, e);
      O = xb(p, i), P = C(C(z[q >> 2] * x) + k), z[O >> 2] = P;
      g = C(C(z[xb(M, e) >> 2] * x) + h);
      e = J;
      break b;
     }
     g = C(C(z[xb(p, e) >> 2] * x) + C(C(k + h) * C(.5)));
     e = I;
    }
    O = xb(v[e >> 2], i), P = g, z[O >> 2] = P;
    c: {
     if (K) {
      f = z[a + 4244 >> 2];
      g = C(f + z[a + 4236 >> 2]);
      z[a + 4236 >> 2] = g;
      f = C(f + z[a + 4240 >> 2]);
      z[a + 4240 >> 2] = f;
      if (g > C(1)) {
       g = C(g + C(-2));
       z[a + 4236 >> 2] = g;
      }
      if (f > C(1)) {
       f = C(f + C(-2));
       z[a + 4240 >> 2] = f;
      }
      g = C(D(g));
      g = C(C(g + g) + C(-1));
      f = C(D(f));
      f = C(C(f + f) + C(-1));
      break c;
     }
     f = z[a + 4240 >> 2];
     n = z[a + 4244 >> 2];
     g = C(C(f * n) + z[a + 4236 >> 2]);
     z[a + 4236 >> 2] = g;
     f = C(f - C(g * n));
     z[a + 4240 >> 2] = f;
    }
    if (B) {
     e = (m + 2 | 0) % 3 | 0;
     k = z[xb(G, e) >> 2];
     h = z[xb(F, e) >> 2];
    }
    e = v[a + 4316 >> 2];
    i = xb(p, xo(e, j + l | 0));
    q = e;
    e = j + 4096 | 0;
    N = z[xb(p, xo(q, e + l | 0)) >> 2];
    n = z[i >> 2];
    z[t >> 2] = C(C(C(C(C(N - n) * C(C(l & 4095) * C(.000244140625))) + n) - k) * H) + k;
    l = v[(B ? 4276 : 4264) + a >> 2];
    i = v[a + 4316 >> 2];
    q = xb(l, xo(i, j + o | 0));
    n = z[xb(l, xo(i, e + o | 0)) >> 2];
    k = z[q >> 2];
    z[u >> 2] = C(C(C(C(C(n - k) * C(C(o & 4095) * C(.000244140625))) + k) - h) * H) + h;
    m = ((m | 0) <= 0 ? m + 3 | 0 : m) - 1 | 0;
    v[a + 4328 >> 2] = m;
    j = (((j | 0) <= 0 ? v[a + 4316 >> 2] << 12 : 0) + j | 0) - 4096 | 0;
    v[a + 4312 >> 2] = j;
    h = L ? f : g;
    f = z[a + 4248 >> 2];
    h = C(h * f);
    d: {
     if (C(D(h)) < C(2147483648)) {
      e = ~~h;
      break d;
     }
     e = -2147483648;
    }
    o = (y >>> 0 > 1 ? e : 0 - e | 0) + A | 0;
    v[a + 4324 >> 2] = o;
    s = s + 4 | 0;
    r = r + 4 | 0;
    g = C(g * f);
    e: {
     if (C(D(g)) < C(2147483648)) {
      e = ~~g;
      break e;
     }
     e = -2147483648;
    }
    l = (y >>> 0 < 4 ? e : 0 - e | 0) + A | 0;
    v[a + 4320 >> 2] = l;
    E = E - 1 | 0;
    u = u + 4 | 0;
    t = t + 4 | 0;
    continue;
   } else {
    e = a;
    a = v[a + 56 >> 2];
    Hi(e, b, c, Gc(a, 0), Gc(a, 1), d);
   }
   break;
  }
 }
}

function TI(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0;
 c = eb - 80 | 0;
 eb = c;
 a: {
  b: {
   c: {
    d: {
     e: {
      f: {
       g: {
        h: {
         i: {
          j: {
           if (!b) {
            tc(a, 9750);
            break j;
           }
           f = b >>> 24 | 0;
           if (!(b & 65535)) {
            d = eb - 16 | 0;
            eb = d;
            g = c + 68 | 0;
            e = tc(d + 4 | 0, 4399);
            Uc(g, e);
            sb(e);
            eb = d + 16 | 0;
            v[31601] = 0;
            v[c + 24 >> 2] = f;
            f = c + 56 | 0;
            N(87, f | 0, c + 24 | 0);
            d = v[31601];
            v[31601] = 0;
            k: {
             l: {
              m: {
               n: {
                if ((d | 0) != 1) {
                 v[31601] = 0;
                 v[c + 8 >> 2] = b >>> 16 & 255;
                 b = c + 44 | 0;
                 N(88, b | 0, c + 8 | 0);
                 d = v[31601];
                 v[31601] = 0;
                 if ((d | 0) == 1) {
                  break n;
                 }
                 v[31601] = 0;
                 U(89, a | 0, g | 0, f | 0, b | 0);
                 a = v[31601];
                 v[31601] = 0;
                 if ((a | 0) == 1) {
                  break m;
                 }
                 sb(b);
                 sb(f);
                 Db(g);
                 break j;
                }
                b = M() | 0;
                break k;
               }
               b = M() | 0;
               break l;
              }
              b = M() | 0;
              sb(c + 44 | 0);
             }
             sb(c + 56 | 0);
            }
            break a;
           }
           d = eb - 16 | 0;
           eb = d;
           g = c + 68 | 0;
           e = tc(d + 4 | 0, 4123);
           Uc(g, e);
           sb(e);
           eb = d + 16 | 0;
           v[31601] = 0;
           v[c + 40 >> 2] = f;
           f = c + 56 | 0;
           N(87, f | 0, c + 40 | 0);
           d = v[31601];
           v[31601] = 0;
           if ((d | 0) == 1) {
            break i;
           }
           v[31601] = 0;
           v[c + 36 >> 2] = b >>> 16 & 255;
           d = c + 44 | 0;
           N(88, d | 0, c + 36 | 0);
           e = v[31601];
           v[31601] = 0;
           if ((e | 0) == 1) {
            break h;
           }
           v[31601] = 0;
           v[c + 20 >> 2] = b >>> 8 & 255;
           e = c + 24 | 0;
           N(88, e | 0, c + 20 | 0);
           h = v[31601];
           v[31601] = 0;
           if ((h | 0) == 1) {
            break g;
           }
           v[31601] = 0;
           v[c + 4 >> 2] = b & 255;
           b = c + 8 | 0;
           N(88, b | 0, c + 4 | 0);
           h = v[31601];
           v[31601] = 0;
           if ((h | 0) == 1) {
            break f;
           }
           v[31601] = 0;
           ia(90, a | 0, g | 0, f | 0, d | 0, e | 0, b | 0);
           a = v[31601];
           v[31601] = 0;
           if ((a | 0) == 1) {
            break e;
           }
           sb(b);
           sb(e);
           sb(d);
           sb(f);
           Db(g);
          }
          eb = c + 80 | 0;
          return;
         }
         b = M() | 0;
         break a;
        }
        b = M() | 0;
        break b;
       }
       b = M() | 0;
       break c;
      }
      b = M() | 0;
      break d;
     }
     b = M() | 0;
     sb(c + 8 | 0);
    }
    sb(c + 24 | 0);
   }
   sb(c + 44 | 0);
  }
  sb(c + 56 | 0);
 }
 Db(c + 68 | 0);
 P(b | 0);
 p();
}

function S7(a, b, c, d, e, f, g) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 f = f | 0;
 g = g | 0;
 var h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, q = 0, r = 0;
 j = eb - 16 | 0;
 eb = j;
 k = Fw(v[g >> 2]);
 o = My(v[g >> 2]);
 rh(j + 4 | 0, o);
 v[f >> 2] = d;
 a: {
  b: {
   c: {
    h = a;
    g = w[h | 0];
    switch (g - 43 | 0) {
    case 0:
    case 2:
     break c;

    default:
     break b;
    }
   }
   v[31601] = 0;
   g = O(29, k | 0, g << 24 >> 24) | 0;
   h = v[31601];
   v[31601] = 0;
   if ((h | 0) == 1) {
    break a;
   }
   h = v[f >> 2];
   v[f >> 2] = h + 1;
   t[h | 0] = g;
   h = a + 1 | 0;
  }
  d: {
   g = h;
   if (!((c - g | 0) <= 1 | w[g | 0] != 48 | (w[g + 1 | 0] | 32) != 120)) {
    v[31601] = 0;
    h = O(29, k | 0, 48) | 0;
    i = v[31601];
    v[31601] = 0;
    if ((i | 0) == 1) {
     break a;
    }
    i = v[f >> 2];
    v[f >> 2] = i + 1;
    t[i | 0] = h;
    h = t[g + 1 | 0];
    v[31601] = 0;
    h = O(29, k | 0, h | 0) | 0;
    i = v[31601];
    v[31601] = 0;
    if ((i | 0) == 1) {
     break a;
    }
    i = v[f >> 2];
    v[f >> 2] = i + 1;
    t[i | 0] = h;
    h = g + 2 | 0;
    g = h;
    while (1) {
     if (c >>> 0 <= g >>> 0) {
      break d;
     }
     i = t[g | 0];
     Nd();
     if (!_n(i)) {
      break d;
     }
     g = g + 1 | 0;
     continue;
    }
   }
   while (1) {
    if (c >>> 0 <= g >>> 0) {
     break d;
    }
    i = t[g | 0];
    Nd();
    if (!Zn(i)) {
     break d;
    }
    g = g + 1 | 0;
    continue;
   }
  }
  e: {
   if (zd(v[j + 8 >> 2], w[j + 15 | 0])) {
    i = v[f >> 2];
    v[31601] = 0;
    U(1248, k | 0, h | 0, g | 0, i | 0);
    i = v[31601];
    v[31601] = 0;
    if ((i | 0) == 1) {
     break a;
    }
    v[f >> 2] = v[f >> 2] + (g - h | 0);
    break e;
   }
   Bm(h, g);
   v[31601] = 0;
   r = Q(1246, o | 0) | 0;
   i = v[31601];
   v[31601] = 0;
   if ((i | 0) == 1) {
    break a;
   }
   i = h;
   while (1) {
    if (g >>> 0 <= i >>> 0) {
     Bm((h - a | 0) + d | 0, v[f >> 2]);
     break e;
    }
    f: {
     if (t[dc(j + 4 | 0, m) | 0] <= 0) {
      break f;
     }
     if (t[dc(j + 4 | 0, m) | 0] != (l | 0)) {
      break f;
     }
     l = v[f >> 2];
     v[f >> 2] = l + 1;
     t[l | 0] = r;
     m = (Cb(v[j + 8 >> 2], w[j + 15 | 0]) - 1 >>> 0 > m >>> 0) + m | 0;
     l = 0;
    }
    q = t[i | 0];
    v[31601] = 0;
    q = O(29, k | 0, q | 0) | 0;
    n = v[31601];
    v[31601] = 0;
    if ((n | 0) != 1) {
     n = v[f >> 2];
     v[f >> 2] = n + 1;
     t[n | 0] = q;
     i = i + 1 | 0;
     l = l + 1 | 0;
     continue;
    }
    break;
   }
   break a;
  }
  while (1) {
   g: {
    if (c >>> 0 > g >>> 0) {
     h = t[g | 0];
     if ((h | 0) != 46) {
      break g;
     }
     v[31601] = 0;
     h = Q(1249, o | 0) | 0;
     i = v[31601];
     v[31601] = 0;
     if ((i | 0) == 1) {
      break a;
     }
     i = v[f >> 2];
     v[f >> 2] = i + 1;
     t[i | 0] = h;
     g = g + 1 | 0;
    }
    h = v[f >> 2];
    v[31601] = 0;
    U(1248, k | 0, g | 0, c | 0, h | 0);
    h = v[31601];
    v[31601] = 0;
    if ((h | 0) == 1) {
     break a;
    }
    h = f;
    f = v[f >> 2] + (c - g | 0) | 0;
    v[h >> 2] = f;
    v[e >> 2] = (b | 0) == (c | 0) ? f : (b - a | 0) + d | 0;
    sb(j + 4 | 0);
    eb = j + 16 | 0;
    return;
   }
   v[31601] = 0;
   h = O(29, k | 0, h | 0) | 0;
   i = v[31601];
   v[31601] = 0;
   if ((i | 0) == 1) {
    break a;
   }
   i = v[f >> 2];
   v[f >> 2] = i + 1;
   t[i | 0] = h;
   g = g + 1 | 0;
   continue;
  }
 }
 a = M() | 0;
 sb(j + 4 | 0);
 P(a | 0);
 p();
}

function _oa(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0;
 if (v[a + 4 >> 2] != v[zb(a) >> 2]) {
  e = eb - 16 | 0;
  eb = e;
  c = e + 4 | 0;
  v[c >> 2] = a;
  a = v[a + 4 >> 2];
  v[c + 4 >> 2] = a;
  v[c + 8 >> 2] = a + 56;
  a = v[c + 4 >> 2];
  v[31601] = 0;
  N(682, a | 0, b | 0);
  a = v[31601];
  v[31601] = 0;
  a: {
   if ((a | 0) != 1) {
    v[c + 4 >> 2] = v[c + 4 >> 2] + 56;
    hc(c);
    eb = e + 16 | 0;
    break a;
   }
   a = M() | 0;
   hc(c);
   P(a | 0);
   p();
  }
  return;
 }
 k = eb - 32 | 0;
 eb = k;
 i = zb(a);
 c = k + 12 | 0;
 d = Cv(v[a >> 2], v[a + 4 >> 2]) + 1 | 0;
 h = eb - 16 | 0;
 eb = h;
 v[h + 12 >> 2] = d;
 f = eb - 16 | 0;
 eb = f;
 v[f + 12 >> 2] = 76695844;
 v[f + 8 >> 2] = 2147483647;
 e = v[Gb(f + 12 | 0, f + 8 | 0) >> 2];
 eb = f + 16 | 0;
 b: {
  if (e >>> 0 >= d >>> 0) {
   d = dX(a);
   if (d >>> 0 < e >>> 1 >>> 0) {
    v[h + 8 >> 2] = d << 1;
    e = v[ad(h + 8 | 0, h + 12 | 0) >> 2];
   }
   eb = h + 16 | 0;
   break b;
  }
  dd();
  p();
 }
 f = Cv(v[a >> 2], v[a + 4 >> 2]);
 h = eb - 16 | 0;
 eb = h;
 Kg(c + 12 | 0, i);
 c: {
  if (!e) {
   i = 0;
   e = 0;
   break c;
  }
  if (e >>> 0 >= 76695845) {
   Sj();
   p();
  }
  d = Dc(B(e, 56));
  v[h + 12 >> 2] = e;
  v[h + 8 >> 2] = d;
  i = v[h + 12 >> 2];
  e = v[h + 8 >> 2];
 }
 v[c >> 2] = e;
 d = e + B(f, 56) | 0;
 v[c + 8 >> 2] = d;
 v[c + 4 >> 2] = d;
 l = mc(c), m = e + B(i, 56) | 0, v[l >> 2] = m;
 eb = h + 16 | 0;
 e = v[c + 8 >> 2];
 v[31601] = 0;
 N(682, e | 0, b | 0);
 b = v[31601];
 v[31601] = 0;
 d: {
  if ((b | 0) != 1) {
   v[c + 8 >> 2] = v[c + 8 >> 2] + 56;
   h = eb - 16 | 0;
   eb = h;
   f = zb(a);
   d = ub(h + 12 | 0, v[a + 4 >> 2]);
   e = ub(h + 8 | 0, v[a >> 2]);
   b = ub(h + 4 | 0, v[c + 4 >> 2]);
   i = v[d >> 2];
   e = v[e >> 2];
   g = eb + -64 | 0;
   eb = g;
   b = v[b >> 2];
   v[g + 56 >> 2] = b;
   v[g + 60 >> 2] = i;
   v[g + 52 >> 2] = b;
   d = zg(g + 24 | 0, f, g + 52 | 0, g + 56 | 0);
   v[g + 16 >> 2] = v[d + 8 >> 2];
   b = v[d + 4 >> 2];
   v[g + 8 >> 2] = v[d >> 2];
   v[g + 12 >> 2] = b;
   yg(g + 36 | 0, g + 8 | 0);
   while (1) {
    if (Ed(i, e)) {
     b = aX(v[g + 56 >> 2]);
     f = eX(i);
     d = Rl(b, f);
     Rl(d + 12 | 0, f + 12 | 0);
     EC(d + 24 | 0, f + 24 | 0);
     u[d + 52 >> 1] = x[f + 52 >> 1];
     b = v[f + 48 >> 2];
     v[d + 44 >> 2] = v[f + 44 >> 2];
     v[d + 48 >> 2] = b;
     b = v[f + 40 >> 2];
     v[d + 36 >> 2] = v[f + 36 >> 2];
     v[d + 40 >> 2] = b;
     b = bX(g + 60 | 0);
     bX(g + 56 | 0);
     i = v[b >> 2];
     continue;
    }
    break;
   }
   xg(g + 36 | 0);
   d = v[g + 56 >> 2];
   if (!w[g + 48 | 0]) {
    i = eb - 16 | 0;
    eb = i;
    b = ub(i + 12 | 0, v[v[g + 44 >> 2] >> 2]);
    e = v[ub(i + 8 | 0, v[v[g + 40 >> 2] >> 2]) >> 2];
    f = eb - 16 | 0;
    eb = f;
    b = v[b >> 2];
    v[f + 12 >> 2] = b;
    while (1) {
     if (vi(b, e)) {
      j = eb - 16 | 0;
      eb = j;
      v[j + 12 >> 2] = b;
      v[j + 12 >> 2] = v[j + 12 >> 2] + 56;
      eb = j + 16 | 0;
      ar(aX(v[j + 12 >> 2]));
      b = f + 12 | 0;
      v[b >> 2] = v[b >> 2] + 56;
      b = v[b >> 2];
      continue;
     }
     break;
    }
    eb = f + 16 | 0;
    eb = i + 16 | 0;
   }
   eb = g - -64 | 0;
   v[c + 4 >> 2] = d;
   Sb(a, c + 4 | 0);
   Sb(a + 4 | 0, c + 8 | 0);
   Sb(zb(a), mc(c));
   v[c >> 2] = v[c + 4 >> 2];
   eb = h + 16 | 0;
   cX(c);
   eb = k + 32 | 0;
   break d;
  }
  a = M() | 0;
  cX(c);
  P(a | 0);
  p();
 }
}

function Qka(a, b, c, d, e) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 var f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, q = 0, r = 0, s = 0, x = 0, y = 0, z = 0, A = 0, C = 0;
 f = eb - 48 | 0;
 eb = f;
 a: {
  b: {
   c: {
    d: {
     e: {
      f: {
       g: {
        if (!a) {
         break g;
        }
        l = e << 2;
        if (l >>> 0 > d >>> 0) {
         break g;
        }
        x = l - 4 | 0;
        o = B(b, e);
        y = o - 8 | 0;
        h: while (1) {
         b = v[c + 8 >> 2];
         g = v[c >> 2];
         v[31601] = 0;
         b = T(150, g | 0, b | 0, l | 0) | 0;
         g = v[31601];
         v[31601] = 0;
         if ((g | 0) == 1) {
          break b;
         }
         if (!(n >>> 0 < o >>> 0 & b)) {
          break g;
         }
         v[31601] = 0;
         b = f + 8 | 0;
         R(185, b | 0, c | 0, d | 0);
         g = v[31601];
         v[31601] = 0;
         if ((g | 0) == 1) {
          break c;
         }
         g = gc(f + 28 | 0, b);
         tb(b);
         v[31601] = 0;
         N(574, b | 0, g | 0);
         j = v[31601];
         v[31601] = 0;
         if ((j | 0) == 1) {
          break e;
         }
         z = Ze(b);
         q = v[f + 8 >> 2];
         A = q - 4 | 0;
         j = 0;
         while (1) {
          if ((e | 0) == (j | 0)) {
           Jc(f + 8 | 0);
           tb(g);
           n = (q - l << 1) + n | 0;
           continue h;
          }
          v[31601] = 0;
          h = Q(567, g | 0) | 0;
          b = v[31601];
          v[31601] = 0;
          if ((b | 0) != 1) {
           v[31601] = 0;
           b = Q(197, g | 0) | 0;
           k = v[31601];
           v[31601] = 0;
           if ((k | 0) == 1) {
            break f;
           }
           v[f >> 2] = b;
           Fe(f, 0, 89);
           v[31601] = 0;
           O(183, g | 0, 1) | 0;
           b = v[31601];
           v[31601] = 0;
           if ((b | 0) == 1) {
            break f;
           }
           k = j + n | 0;
           b = e + j << 2;
           i: while (1) {
            j: {
             if (k >>> 0 > y >>> 0) {
              break j;
             }
             m = 0;
             if (b >>> 0 > A >>> 0) {
              break j;
             }
             while (1) if ((m | 0) == 8) {
              b = b + x | 0;
              continue i;
             } else {
              r = v[f >> 2];
              i = w[b + z | 0];
              s = m & 1;
              i = s ? i >>> 4 | 0 : i & 15;
              v[f >> 2] = r + t[(i & 7) + 28568 | 0];
              C = h;
              h = u[(r << 1) + 28576 >> 1];
              h = (((0 - (i & 1) & h >> 2) + (h >> 3) | 0) + (i << 30 >> 31 & h >> 1) | 0) + (h & i << 29 >> 31) | 0;
              v[f + 4 >> 2] = C + (i >>> 0 < 8 ? h : 0 - h | 0);
              Fe(f, 0, 88);
              Fe(f + 4 | 0, -32768, 32767);
              h = v[f + 4 >> 2];
              u[(k << 1) + a >> 1] = h;
              m = m + 1 | 0;
              k = e + k | 0;
              b = b + s | 0;
              continue;
             }
            }
            break;
           }
           j = j + 1 | 0;
           continue;
          }
          break;
         }
         break;
        }
        break f;
       }
       tb(c);
       eb = f + 48 | 0;
       return;
      }
      b = M() | 0;
      Jc(f + 8 | 0);
      break d;
     }
     b = M() | 0;
    }
    tb(g);
    break a;
   }
   b = M() | 0;
   break a;
  }
  b = M() | 0;
 }
 tb(c);
 P(b | 0);
 p();
}

function rra(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, q = 0;
 g = eb - 16 | 0;
 eb = g;
 j = Hf(a, c);
 $d(g, v[a + 36 >> 2]);
 k = a;
 a: {
  if (!j) {
   Pc(g, a + 32 | 0, 5);
   c = 0;
   if (Fb(v[v[g >> 2] >> 2], v[g + 4 >> 2])) {
    break a;
   }
  }
  e = eb - 192 | 0;
  eb = e;
  f = Im(e + 80 | 0, v[a + 36 >> 2]);
  v[31601] = 0;
  a = O(461, e + 68 | 0, 26143) | 0;
  c = v[31601];
  v[31601] = 0;
  b: {
   c: {
    d: {
     e: {
      if ((c | 0) != 1) {
       v[31601] = 0;
       v[e + 8 >> 2] = 19989505;
       v[e + 12 >> 2] = 0;
       R(462, f | 0, a | 0, e + 8 | 0);
       c = v[31601];
       v[31601] = 0;
       if ((c | 0) == 1) {
        break e;
       }
       Db(a);
       if (!ol(w[f | 0])) {
        break d;
       }
       break b;
      }
      c = M() | 0;
      break c;
     }
     c = M() | 0;
     Db(a);
     break c;
    }
    t[e + 67 | 0] = 0;
    t[e + 66 | 0] = 0;
    v[31601] = 0;
    a = O(461, e + 52 | 0, 10094) | 0;
    c = v[31601];
    v[31601] = 0;
    f: {
     g: {
      h: {
       i: {
        if ((c | 0) != 1) {
         v[31601] = 0;
         c = e + 67 | 0;
         R(503, f | 0, c | 0, a | 0);
         h = v[31601];
         v[31601] = 0;
         if ((h | 0) == 1) {
          break i;
         }
         Db(a);
         if (!w[e + 67 | 0]) {
          break b;
         }
         Nf(c, 50);
         v[31601] = 0;
         a = O(461, e + 40 | 0, 13288) | 0;
         c = v[31601];
         v[31601] = 0;
         if ((c | 0) == 1) {
          break f;
         }
         v[31601] = 0;
         R(503, f | 0, e + 66 | 0, a | 0);
         c = v[31601];
         v[31601] = 0;
         if ((c | 0) == 1) {
          break g;
         }
         Db(a);
         a = v[b >> 2];
         c = Fj(a, v[b + 4 >> 2]);
         h = w[e + 67 | 0];
         if (c >>> 0 < h >>> 0) {
          a = cC(e + 8 | 0, v[b + 12 >> 2]);
          v[31601] = 0;
          R(504, b | 0, h | 0, a | 0);
          c = v[31601];
          v[31601] = 0;
          if ((c | 0) == 1) {
           break h;
          }
          zk(a);
          a = v[b >> 2];
         }
         l = x[Lj(a, 0) + 28 >> 1];
         c = 0;
         j: {
          while (1) {
           a = c & 255;
           if (a >>> 0 >= h >>> 0) {
            a = w[e + 66 | 0];
            o = b, q = Fj(v[b >> 2], v[b + 4 >> 2]) >>> 0 > a >>> 0 ? a : 0, t[o + 16 | 0] = q;
            break b;
           }
           $e(Lj(v[b >> 2], a), l);
           m = v[b >> 2];
           v[31601] = 0;
           i = e + 8 | 0;
           N(505, i | 0, c | 0);
           n = v[31601];
           v[31601] = 0;
           if ((n | 0) != 1) {
            v[31601] = 0;
            U(506, f | 0, Lj(m, a) | 0, i | 0, d | 0);
            a = v[31601];
            v[31601] = 0;
            if ((a | 0) == 1) {
             break j;
            }
            c = c + 1 | 0;
            Db(i);
            continue;
           }
           break;
          }
          c = M() | 0;
          break c;
         }
         c = M() | 0;
         Db(e + 8 | 0);
         break c;
        }
        c = M() | 0;
        break c;
       }
       c = M() | 0;
       Db(a);
       break c;
      }
      c = M() | 0;
      zk(a);
      break c;
     }
     c = M() | 0;
     Db(a);
     break c;
    }
    c = M() | 0;
   }
   Bh(f);
   P(c | 0);
   p();
  }
  Bh(f);
  eb = e + 192 | 0;
  c = j;
 }
 ef(k, c);
 eb = g + 16 | 0;
}

function Dla(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, u = 0, w = 0, x = 0, y = 0, z = 0, A = 0, C = 0, D = 0, E = 0, F = 0, G = 0, H = 0, I = 0;
 e = eb - 48 | 0;
 eb = e;
 y = v[a + 16 >> 2];
 z = Fg(b + 327720 | 0, v[b + 20 >> 2], (v[a + 88 >> 2] & 16384) >>> 14 | 0);
 o = v[a + 8 >> 2];
 p = v[a + 12 >> 2];
 b = v[a >> 2];
 k = v[a + 4 >> 2];
 q = v[a + 128 >> 2];
 if (q) {
  r = Gg(o, p, q);
  s = gb;
  g = v[a + 76 >> 2];
  eg(b, k, uf(o, p, d), gb);
  u = gb >>> 0 > g >>> 0 ? d : 0;
 }
 j = a + 112 | 0;
 v[e + 24 >> 2] = v[a + 44 >> 2];
 v[e + 28 >> 2] = v[a + 48 >> 2];
 v[e + 32 >> 2] = v[a + 52 >> 2];
 v[e + 36 >> 2] = v[a + 56 >> 2];
 A = v[a + 24 >> 2];
 C = v[a + 20 >> 2];
 v[e + 8 >> 2] = b;
 v[e + 12 >> 2] = k;
 D = e + 24 | 0;
 while (1) {
  if (d) {
   d = d - 1 | 0;
   h = v[e + 12 >> 2];
   b = v[e + 8 >> 2];
   v[e + 40 >> 2] = b;
   v[e + 44 >> 2] = 0;
   u = u - 1 | 0;
   g = u;
   r = g ? r : 0;
   s = g ? s : 0;
   k = (((h & 2147483647) << 1 | b >>> 31) & -2) + y | 0;
   h = q;
   a: {
    b: while (1) {
     c: {
      if ((h | 0) <= 0) {
       Ob(j, v[a + 120 >> 2], v[a + 124 >> 2]);
       g = v[a + 116 >> 2];
       if (!g) {
        break a;
       }
       b = v[e + 40 >> 2];
       h = ((v[e + 44 >> 2] & 2147483647) << 1 | b >>> 31) & -2;
       i = 0;
       b = 0;
       break c;
      }
      b = v[e + 40 >> 2];
      g = ((v[e + 44 >> 2] & 2147483647) << 1 | b >>> 31) & -2;
      b = 0;
      i = 0;
      while (1) if ((b | 0) == 2) {
       be(j, i >>> 3 << 16 >> 16);
       ae(j, 4);
       Ob(e + 40 | 0, r, s);
       h = h - 1 | 0;
       continue b;
      } else {
       i = (t[k + (b | g) | 0] << 8) + i | 0;
       b = b + 1 | 0;
       continue;
      }
     }
     break;
    }
    while (1) {
     if ((b | 0) != 2) {
      i = (t[k + (b | h) | 0] << 8) + i | 0;
      b = b + 1 | 0;
      continue;
     }
     break;
    }
    be(j, i >>> 3 << 16 >> 16);
    ae(j, g);
    v[j >> 2] = v[j >> 2];
    v[j + 4 >> 2] = 0;
   }
   b = Eg(j, z);
   v[e + 4 >> 2] = b;
   v[e >> 2] = b;
   E = v[a + 72 >> 2];
   i = v[a + 68 >> 2];
   F = i >> 31;
   k = v[a + 64 >> 2];
   G = k >> 31;
   g = v[a + 60 >> 2];
   H = g >> 31;
   b = 0;
   while (1) {
    if ((b | 0) != 2) {
     w = (b << 2) + e | 0;
     f = v[w >> 2];
     h = (b << 3) + D | 0;
     I = v[h + 4 >> 2];
     l = v[h >> 2];
     v[h + 4 >> 2] = l;
     x = f << 8;
     f = x;
     f = Aua(f, f >> 31, g, H);
     m = gb;
     n = f;
     f = Xb(l, -16777216, 16776704);
     f = Aua(k, G, f, f >> 31);
     l = n + f | 0;
     n = gb + m | 0;
     n = f >>> 0 > l >>> 0 ? n + 1 | 0 : n;
     f = Xb(I, -16777216, 16776704);
     m = Aua(i, F, f, f >> 31);
     l = m + l | 0;
     f = gb + n | 0;
     f = l >>> 0 < m >>> 0 ? f + 1 | 0 : f;
     m = l + 8388608 | 0;
     f = m >>> 0 < 8388608 ? f + 1 | 0 : f;
     f = Rc(m, f, 24);
     v[h >> 2] = f - (E & x);
     v[w >> 2] = (f | 0) / 256;
     b = b + 1 | 0;
     continue;
    }
    break;
   }
   v[c >> 2] = v[c >> 2] + B(v[e >> 2], C);
   v[c + 4 >> 2] = v[c + 4 >> 2] + B(v[e + 4 >> 2], A);
   Ob(e + 8 | 0, o, p);
   c = c + 8 | 0;
   continue;
  }
  break;
 }
 b = v[e + 12 >> 2];
 v[a >> 2] = v[e + 8 >> 2];
 v[a + 4 >> 2] = b;
 v[a + 44 >> 2] = v[e + 24 >> 2];
 v[a + 48 >> 2] = v[e + 28 >> 2];
 v[a + 52 >> 2] = v[e + 32 >> 2];
 v[a + 56 >> 2] = v[e + 36 >> 2];
 eb = e + 48 | 0;
}

function Yna(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0;
 j = eb - 16 | 0;
 eb = j;
 e = v[b >> 2];
 d = Ck(e, v[b + 4 >> 2]);
 a: {
  if (d >>> 0 < c >>> 0) {
   n = eb - 32 | 0;
   eb = n;
   e = c - d | 0;
   d = v[zb(b) >> 2];
   f = v[b + 4 >> 2];
   b: {
    if (e >>> 0 <= d - f >> 4 >>> 0) {
     f = eb - 16 | 0;
     eb = f;
     e = kv(f + 4 | 0, b, e);
     d = v[e + 4 >> 2];
     g = v[e + 8 >> 2];
     while (1) {
      if ((d | 0) == (g | 0)) {
       hc(e);
       eb = f + 16 | 0;
      } else {
       Dr(d);
       d = d + 16 | 0;
       v[e + 4 >> 2] = d;
       continue;
      }
      break;
     }
     break b;
    }
    d = zb(b);
    f = MV(n + 12 | 0, NV(b, Ck(v[b >> 2], f) + e | 0), Ck(v[b >> 2], v[b + 4 >> 2]), d);
    g = eb - 16 | 0;
    eb = g;
    h = v[f + 8 >> 2];
    d = g + 4 | 0;
    v[d + 8 >> 2] = f + 8;
    v[d >> 2] = h;
    v[d + 4 >> 2] = h + (e << 4);
    e = v[d >> 2];
    while (1) {
     if (v[d + 4 >> 2] != (e | 0)) {
      Dr(e);
      e = v[d >> 2] + 16 | 0;
      v[d >> 2] = e;
      continue;
     }
     break;
    }
    ie(d);
    eb = g + 16 | 0;
    k = eb - 16 | 0;
    eb = k;
    d = ub(k + 12 | 0, v[b + 4 >> 2]);
    e = ub(k + 8 | 0, v[b >> 2]);
    i = v[ub(k + 4 | 0, v[f + 4 >> 2]) >> 2];
    l = eb - 16 | 0;
    eb = l;
    o = l + 8 | 0;
    g = eb - 32 | 0;
    eb = g;
    ed(g + 24 | 0, v[d >> 2], v[e >> 2]);
    p = g + 16 | 0;
    d = v[g + 24 >> 2];
    q = v[g + 28 >> 2];
    h = eb - 16 | 0;
    eb = h;
    v[h + 8 >> 2] = i;
    v[h + 12 >> 2] = d;
    while (1) {
     if (Ed(d, q)) {
      e = oC(d);
      d = oC(v[h + 8 >> 2]);
      i = w[e + 12 | 0] | w[e + 13 | 0] << 8 | (w[e + 14 | 0] << 16 | w[e + 15 | 0] << 24);
      m = w[e + 8 | 0] | w[e + 9 | 0] << 8 | (w[e + 10 | 0] << 16 | w[e + 11 | 0] << 24);
      t[d + 8 | 0] = m;
      t[d + 9 | 0] = m >>> 8;
      t[d + 10 | 0] = m >>> 16;
      t[d + 11 | 0] = m >>> 24;
      t[d + 12 | 0] = i;
      t[d + 13 | 0] = i >>> 8;
      t[d + 14 | 0] = i >>> 16;
      t[d + 15 | 0] = i >>> 24;
      i = w[e + 4 | 0] | w[e + 5 | 0] << 8 | (w[e + 6 | 0] << 16 | w[e + 7 | 0] << 24);
      e = w[e | 0] | w[e + 1 | 0] << 8 | (w[e + 2 | 0] << 16 | w[e + 3 | 0] << 24);
      t[d | 0] = e;
      t[d + 1 | 0] = e >>> 8;
      t[d + 2 | 0] = e >>> 16;
      t[d + 3 | 0] = e >>> 24;
      t[d + 4 | 0] = i;
      t[d + 5 | 0] = i >>> 8;
      t[d + 6 | 0] = i >>> 16;
      t[d + 7 | 0] = i >>> 24;
      d = Xq(h + 12 | 0);
      Xq(h + 8 | 0);
      d = v[d >> 2];
      continue;
     }
     break;
    }
    pc(p, d, h + 8 | 0);
    eb = h + 16 | 0;
    d = v[g + 16 >> 2];
    v[g + 12 >> 2] = v[g + 20 >> 2];
    pc(o, d, g + 12 | 0);
    eb = g + 32 | 0;
    eb = l + 16 | 0;
    v[f + 4 >> 2] = v[l + 12 >> 2];
    Sb(b, f + 4 | 0);
    Sb(b + 4 | 0, f + 8 | 0);
    Sb(zb(b), mc(f));
    v[f >> 2] = v[f + 4 >> 2];
    eb = k + 16 | 0;
    d = v[f + 4 >> 2];
    e = v[f + 8 >> 2];
    while (1) {
     if ((d | 0) != (e | 0)) {
      e = e - 16 | 0;
      v[f + 8 >> 2] = e;
      continue;
     }
     break;
    }
    d = v[f >> 2];
    if (d) {
     vs(f);
     Bb(d);
    }
   }
   eb = n + 32 | 0;
   break a;
  }
  if (c >>> 0 < d >>> 0) {
   Id(b, e + (c << 4) | 0);
  }
 }
 if (Lb(v[a >> 2], v[a + 8 >> 2], c << 4)) {
  c = v[b >> 2];
  ac(j + 8 | 0, c, Ck(c, v[b + 4 >> 2]) << 4);
  rd(j, a, v[j + 8 >> 2], v[j + 12 >> 2]);
 }
 eb = j + 16 | 0;
}

function lU(a, b) {
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, w = 0, x = 0, y = 0;
 c = eb - 176 | 0;
 eb = c;
 i = 1;
 p = 2;
 d = v[a + 12 >> 2];
 q = 1 << d;
 m = q;
 a: while (1) {
  if (d >>> 0 >= p >>> 0) {
   m = m >>> 2 | 0;
   w = B(i, 3);
   x = i << 1;
   h = 0;
   b: while (1) {
    if ((h | 0) == (m | 0)) {
     p = p + 2 | 0;
     i = i << 2;
     d = v[a + 12 >> 2];
     continue a;
    }
    d = v[a >> 2];
    e = Xd(d, h << 1);
    uR(c + 160 | 0, A[e >> 3], A[e + 8 >> 3]);
    d = Xd(d, h);
    uR(c + 144 | 0, A[d >> 3], A[d + 8 >> 3]);
    Ki(c + 128 | 0, A[c + 144 >> 3], A[c + 152 >> 3], A[c + 160 >> 3], A[c + 168 >> 3]);
    d = h << p;
    e = i + d | 0;
    y = d >>> 0 > e >>> 0 ? d : e;
    while (1) if ((d | 0) == (y | 0)) {
     h = h + 1 | 0;
     continue b;
    } else {
     f = v[b >> 2];
     e = Xd(f, d);
     g = e + 8 | 0;
     j = v[g + 4 >> 2];
     v[c + 120 >> 2] = v[g >> 2];
     v[c + 124 >> 2] = j;
     g = v[e + 4 >> 2];
     v[c + 112 >> 2] = v[e >> 2];
     v[c + 116 >> 2] = g;
     k = d + i | 0;
     g = Xd(f, k);
     n = A[g + 8 >> 3];
     o = A[g >> 3];
     r = d + x | 0;
     g = Xd(f, r);
     j = v[g + 12 >> 2];
     v[c + 104 >> 2] = v[g + 8 >> 2];
     v[c + 108 >> 2] = j;
     j = v[g + 4 >> 2];
     v[c + 96 >> 2] = v[g >> 2];
     v[c + 100 >> 2] = j;
     s = d + w | 0;
     f = Xd(f, s);
     t = A[f + 8 >> 3];
     u = A[f >> 3];
     g = c + 80 | 0;
     f = c + 112 | 0;
     Bl(g, f, o, n);
     j = c - -64 | 0;
     xj(j, f, o, n);
     l = c + 96 | 0;
     Bl(c + 48 | 0, l, u, t);
     f = c + 16 | 0;
     xj(f, l, u, t);
     Ki(c + 32 | 0, 0, 1, A[c + 16 >> 3], A[c + 24 >> 3]);
     Bl(f, g, A[c + 48 >> 3], A[c + 56 >> 3]);
     l = v[c + 28 >> 2];
     v[e + 8 >> 2] = v[c + 24 >> 2];
     v[e + 12 >> 2] = l;
     l = v[c + 20 >> 2];
     v[e >> 2] = v[c + 16 >> 2];
     v[e + 4 >> 2] = l;
     Bl(c, j, A[c + 32 >> 3], A[c + 40 >> 3]);
     Ki(f, A[c + 160 >> 3], A[c + 168 >> 3], A[c >> 3], A[c + 8 >> 3]);
     e = Xd(v[b >> 2], k);
     k = v[c + 28 >> 2];
     v[e + 8 >> 2] = v[c + 24 >> 2];
     v[e + 12 >> 2] = k;
     k = v[c + 20 >> 2];
     v[e >> 2] = v[c + 16 >> 2];
     v[e + 4 >> 2] = k;
     xj(c, g, A[c + 48 >> 3], A[c + 56 >> 3]);
     Ki(f, A[c + 144 >> 3], A[c + 152 >> 3], A[c >> 3], A[c + 8 >> 3]);
     e = Xd(v[b >> 2], r);
     g = v[c + 28 >> 2];
     v[e + 8 >> 2] = v[c + 24 >> 2];
     v[e + 12 >> 2] = g;
     g = v[c + 20 >> 2];
     v[e >> 2] = v[c + 16 >> 2];
     v[e + 4 >> 2] = g;
     xj(c, j, A[c + 32 >> 3], A[c + 40 >> 3]);
     Ki(f, A[c + 128 >> 3], A[c + 136 >> 3], A[c >> 3], A[c + 8 >> 3]);
     e = Xd(v[b >> 2], s);
     f = v[c + 28 >> 2];
     v[e + 8 >> 2] = v[c + 24 >> 2];
     v[e + 12 >> 2] = f;
     f = v[c + 20 >> 2];
     v[e >> 2] = v[c + 16 >> 2];
     v[e + 4 >> 2] = f;
     d = d + 1 | 0;
     continue;
    }
   }
  }
  break;
 }
 c: {
  if (!(d & 1)) {
   break c;
  }
  i = q >>> 1 | 0;
  d = 0;
  while (1) {
   if ((d | 0) == (i | 0)) {
    break c;
   }
   h = v[b >> 2];
   a = Xd(h, d + i | 0);
   m = Xd(h, d);
   n = A[a >> 3];
   o = A[a + 8 >> 3];
   xj(c + 160 | 0, m, n, o);
   h = v[c + 172 >> 2];
   v[a + 8 >> 2] = v[c + 168 >> 2];
   v[a + 12 >> 2] = h;
   h = v[c + 164 >> 2];
   v[a >> 2] = v[c + 160 >> 2];
   v[a + 4 >> 2] = h;
   AA(Xd(v[b >> 2], d), n, o);
   d = d + 1 | 0;
   continue;
  }
 }
 eb = c + 176 | 0;
}

function uw(a, b, c, d) {
 var e = 0, f = 0;
 e = eb - 16 | 0;
 eb = e;
 t[e + 15 | 0] = c;
 a: {
  b: {
   c: {
    d: {
     e: {
      switch (b - 2 | 0) {
      case 11:
       t[e + 14 | 0] = 64;
       de(a, 1, Pb(e + 15 | 0, e + 14 | 0));
       break a;

      case 0:
       if (!(c & 3 | c >>> 0 > 223 ? d : 1)) {
        break b;
       }
       t[e + 14 | 0] = c >>> 2;
       de(a, 12, e + 14 | 0);
       break a;

      case 1:
       if (!(c & 3 | c >>> 0 > 223 ? d : 1)) {
        break b;
       }
       t[e + 14 | 0] = c >>> 2;
       de(a, 13, e + 14 | 0);
       break a;

      case 2:
       if (c >>> 0 >= 240) {
        t[e + 14 | 0] = 9;
        de(a, 11, e + 14 | 0);
        break a;
       }
       b = 0;
       while (1) {
        if ((b | 0) == 10) {
         break b;
        }
        f = w[b + 42112 | 0];
        f: {
         if (d) {
          if (c >>> 0 > f >>> 0) {
           break f;
          }
          break d;
         }
         if ((c | 0) == (f | 0)) {
          break d;
         }
        }
        b = b + 1 | 0;
        continue;
       }
       ;

      case 3:
       g: {
        if (d) {
         t[e + 14 | 0] = c & 15;
         t[e + 13 | 0] = 9;
         c = w[Pb(e + 14 | 0, e + 13 | 0) | 0];
         break g;
        }
        if (c >>> 0 > 15 | (c & 14) >>> 0 > 9) {
         break b;
        }
       }
       t[e + 14 | 0] = c & 15;
       de(a, 8, e + 14 | 0);
       break a;

      case 24:
       h: {
        if (d) {
         t[e + 15 | 0] = 0;
         break h;
        }
        if (c) {
         break b;
        }
       }
       de(a, 8, e + 15 | 0);
       break a;

      case 7:
       t[e + 15 | 0] = (c | 0) == 255 ? 64 : c >>> 2 | 0;
       de(a, 2, e + 15 | 0);
       break a;

      case 9:
       if (!c) {
        break b;
       }
       b = c & 15;
       if (!b) {
        t[e + 14 | 0] = c >>> 4;
        de(a, 3, e + 14 | 0);
        break a;
       }
       d = c & 240;
       if (!d) {
        de(a, 4, e + 15 | 0);
        break a;
       }
       if ((b | 0) == 15) {
        t[e + 14 | 0] = c >>> 4;
        de(a, 5, e + 14 | 0);
        break a;
       }
       if ((d | 0) != 240) {
        break b;
       }
       t[e + 14 | 0] = c & 15;
       de(a, 6, e + 14 | 0);
       break a;

      case 18:
       if ((c & 240) != 128) {
        break b;
       }
       t[e + 14 | 0] = c << 2 | 2;
       de(a, 2, e + 14 | 0);
       break a;

      case 17:
       i: {
        switch ((c >>> 4 | 0) - 8 | 0) {
        case 0:
         t[e + 14 | 0] = c << 2 & 60 | 2;
         de(a, 2, e + 14 | 0);
         break a;

        case 2:
         t[e + 14 | 0] = c & 15;
         de(a, 5, e + 14 | 0);
         break a;

        case 3:
         break i;

        default:
         break b;
        }
       }
       t[e + 14 | 0] = c & 15;
       de(a, 6, e + 14 | 0);
       break a;

      case 4:
      case 5:
      case 6:
      case 8:
      case 10:
      case 12:
      case 13:
      case 14:
      case 15:
      case 16:
      case 19:
      case 20:
      case 21:
      case 22:
      case 23:
       break b;

      default:
       break e;
      }
     }
     if ((b | 0) == 46) {
      break c;
     }
     break b;
    }
    t[e + 14 | 0] = b;
    de(a, 11, e + 14 | 0);
    break a;
   }
   if (d ? 0 : c & 3) {
    break b;
   }
   t[e + 14 | 0] = c + 3 >>> 2;
   de(a, 1, e + 14 | 0);
   break a;
  }
  t[e + 14 | 0] = 0;
  de(a, 0, e + 14 | 0);
 }
 eb = e + 16 | 0;
}

function Sja(a) {
 a = a | 0;
 var b = 0, c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0;
 c = eb - 32 | 0;
 eb = c;
 a: {
  b: {
   c: {
    d: {
     e: {
      f: {
       if (Dd(v[a + 24 >> 2])) {
        break f;
       }
       i = Zc(v[a + 8 >> 2], w[a + 15 | 0]);
       f = eb - 16 | 0;
       eb = f;
       h = f + 8 | 0;
       v[h >> 2] = -1;
       v[h + 4 >> 2] = -1;
       v[31601] = 0;
       g = $H(65);
       d = v[31601];
       v[31601] = 0;
       b = gb;
       if ((d | 0) == 1) {
        S(0) | 0;
        Rb();
        p();
       }
       e = eb - 16 | 0;
       eb = e;
       d = we(e + 8 | 0, Aua(g, b, 1e3, 0), gb);
       b = v[d >> 2];
       eb = e + 16 | 0;
       j = f, k = qA(b, v[d + 4 >> 2]), v[j >> 2] = k;
       v[f + 4 >> 2] = gb;
       e = YQ(h, f, zb(f));
       v[31601] = 0;
       g = $H(66);
       d = v[31601];
       v[31601] = 0;
       b = gb;
       if ((d | 0) == 1) {
        S(0) | 0;
        Rb();
        p();
       }
       h = a + 24 | 0;
       j = f, k = qA(VQ(g, b), gb), v[j >> 2] = k;
       v[f + 4 >> 2] = gb;
       b = YQ(e, f, zb(f));
       g = v[b >> 2];
       b = v[b + 4 >> 2];
       eb = f + 16 | 0;
       if (i) {
        e = Mb(c + 20 | 0);
        v[31601] = 0;
        v[c + 8 >> 2] = b;
        d = c + 8 | 0;
        N(59, e | 0, d | 0);
        b = v[31601];
        v[31601] = 0;
        if ((b | 0) == 1) {
         break c;
        }
        v[31601] = 0;
        v[c + 8 >> 2] = g;
        N(59, e | 0, d | 0);
        b = v[31601];
        v[31601] = 0;
        if ((b | 0) == 1) {
         break d;
        }
        d = a + 4 | 0;
        g = 0;
        g: {
         while (1) {
          if (Zc(v[a + 8 >> 2], w[a + 15 | 0]) >>> 0 <= g >>> 0) {
           b = vb(v[e >> 2]);
           a = vb(v[e + 4 >> 2]);
           v[31601] = 0;
           d = T(60, c + 8 | 0, b | 0, a | 0) | 0;
           a = v[31601];
           v[31601] = 0;
           if ((a | 0) != 1) {
            break g;
           }
           a = M() | 0;
           break b;
          }
          b = w[dc(d, g) | 0];
          v[31601] = 0;
          v[c + 8 >> 2] = b;
          N(59, e | 0, c + 8 | 0);
          b = v[31601];
          v[31601] = 0;
          if ((b | 0) != 1) {
           g = g + 1 | 0;
           continue;
          }
          break;
         }
         a = M() | 0;
         break b;
        }
        v[31601] = 0;
        b = Q(61, d | 0) | 0;
        a = v[31601];
        v[31601] = 0;
        if ((a | 0) != 1) {
         v[c + 4 >> 2] = b;
         a = c + 4 | 0;
         wA(h, a);
         El(a);
         Vm(d);
         uc(e);
         break f;
        }
        a = M() | 0;
        Vm(d);
        break b;
       }
       gb = g;
       v[c + 8 >> 2] = b;
       v[c + 12 >> 2] = gb;
       b = Mb(c + 20 | 0);
       v[31601] = 0;
       R(64, b | 0, c + 8 | 0, c + 16 | 0);
       a = v[31601];
       v[31601] = 0;
       if ((a | 0) == 1) {
        a = M() | 0;
        uc(b);
        P(a | 0);
        p();
       }
       v[31601] = 0;
       d = Q(61, b | 0) | 0;
       a = v[31601];
       v[31601] = 0;
       if ((a | 0) == 1) {
        break e;
       }
       v[c + 4 >> 2] = d;
       a = c + 4 | 0;
       wA(h, a);
       El(a);
       Vm(b);
      }
      eb = c + 32 | 0;
      return;
     }
     a = M() | 0;
     Vm(b);
     break a;
    }
    a = M() | 0;
    break b;
   }
   a = M() | 0;
  }
  uc(e);
 }
 P(a | 0);
 p();
}

function cma(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, w = 0, x = 0, y = 0, z = 0, A = 0, C = 0, D = 0, E = 0, F = 0, G = 0, H = 0, I = 0, J = 0;
 f = eb - 48 | 0;
 eb = f;
 h = v[a + 8 >> 2];
 q = h;
 i = v[a + 12 >> 2];
 j = i;
 a: {
  b: {
   if ((j | 0) <= 1 & h >>> 0 <= 805306368 | (j | 0) <= 0) {
    i = 131112;
    h = j;
    if ((j | 0) > -2) {
     e = 1;
    } else {
     e = (h | 0) >= -2 & q >>> 0 >= 3489660928;
    }
    if (e) {
     break a;
    }
    i = 262184;
    if ((j | 0) == -2 & q >>> 0 < 2147483648 | j >>> 0 < 4294967294) {
     break a;
    }
    break b;
   }
   i = 262184;
   if ((j | 0) == 1 & q >>> 0 > 2147483648 | j >>> 0 > 1) {
    break a;
   }
  }
  i = 196648;
 }
 z = v[a + 16 >> 2];
 v[f + 32 >> 2] = v[a + 44 >> 2];
 v[f + 36 >> 2] = v[a + 48 >> 2];
 v[f + 40 >> 2] = v[a + 52 >> 2];
 v[f + 44 >> 2] = v[a + 56 >> 2];
 m = v[a + 40 >> 2];
 n = v[a + 36 >> 2];
 h = v[a + 4 >> 2];
 v[f + 16 >> 2] = v[a >> 2];
 v[f + 20 >> 2] = h;
 A = b + i | 0;
 C = f + 32 | 0;
 D = v[a + 32 >> 2];
 E = v[a + 28 >> 2];
 F = v[a + 72 >> 2];
 y = v[a + 68 >> 2];
 G = y >> 31;
 i = v[a + 64 >> 2];
 H = i >> 31;
 h = v[a + 60 >> 2];
 I = h >> 31;
 while (1) {
  if (d) {
   b = v[f + 16 >> 2];
   r = ((((v[f + 20 >> 2] & 2147483647) << 1 | b >>> 31) & 2147483646) << 1) + z | 0;
   b = (b >>> 16 & 65520) + A | 0;
   J = u[b + 14 >> 1];
   l = u[b + 12 >> 1];
   s = u[b + 10 >> 1];
   x = u[b + 8 >> 1];
   g = u[b + 6 >> 1];
   t = u[b + 4 >> 1];
   k = u[b + 2 >> 1];
   e = u[b >> 1];
   o = 0;
   b = 0;
   while (1) {
    if ((b | 0) != 2) {
     w = b << 1;
     p = w + r | 0;
     v[(f + 8 | 0) + (b << 2) >> 2] = (((((((B(u[r + (w | -8) >> 1], k) + B(u[r + (w | -12) >> 1], e) | 0) + B(u[r + (w | -4) >> 1], t) | 0) + B(u[p >> 1], g) | 0) + B(u[p + 4 >> 1], x) | 0) + B(u[p + 8 >> 1], s) | 0) + B(l, u[p + 12 >> 1]) | 0) + B(J, u[p + 16 >> 1]) | 0) / 32768;
     b = b + 1 | 0;
     continue;
    }
    break;
   }
   while (1) {
    if ((o | 0) != 2) {
     s = (f + 8 | 0) + (o << 2) | 0;
     e = v[s >> 2];
     b = (o << 3) + C | 0;
     x = v[b + 4 >> 2];
     g = v[b >> 2];
     v[b + 4 >> 2] = g;
     t = e << 8;
     e = t;
     e = Aua(e, e >> 31, h, I);
     k = gb;
     l = e;
     e = Xb(g, -16777216, 16776704);
     e = Aua(i, H, e, e >> 31);
     g = l + e | 0;
     l = gb + k | 0;
     l = e >>> 0 > g >>> 0 ? l + 1 | 0 : l;
     e = Xb(x, -16777216, 16776704);
     k = Aua(y, G, e, e >> 31);
     g = k + g | 0;
     e = gb + l | 0;
     e = g >>> 0 < k >>> 0 ? e + 1 | 0 : e;
     k = g + 8388608 | 0;
     e = k >>> 0 < 8388608 ? e + 1 | 0 : e;
     e = Rc(k, e, 24);
     v[b >> 2] = e - (t & F);
     v[s >> 2] = (e | 0) / 256;
     o = o + 1 | 0;
     continue;
    }
    break;
   }
   n = n + E | 0;
   v[c >> 2] = v[c >> 2] + B(v[f + 8 >> 2], n >> 12);
   m = m + D | 0;
   v[c + 4 >> 2] = v[c + 4 >> 2] + B(v[f + 12 >> 2], m >> 12);
   Ob(f + 16 | 0, q, j);
   c = c + 8 | 0;
   d = d - 1 | 0;
   continue;
  }
  break;
 }
 b = v[f + 20 >> 2];
 v[a >> 2] = v[f + 16 >> 2];
 v[a + 4 >> 2] = b;
 v[a + 40 >> 2] = m;
 v[a + 20 >> 2] = n >> 12;
 v[a + 36 >> 2] = n;
 v[a + 24 >> 2] = m >> 12;
 v[a + 44 >> 2] = v[f + 32 >> 2];
 v[a + 48 >> 2] = v[f + 36 >> 2];
 v[a + 52 >> 2] = v[f + 40 >> 2];
 v[a + 56 >> 2] = v[f + 44 >> 2];
 eb = f + 48 | 0;
}

function Kna(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, q = 0, r = 0;
 h = eb - 32 | 0;
 eb = h;
 a: {
  b: {
   if (iv(a) >>> 0 < b >>> 0) {
    if ((b | 0) < 0) {
     break b;
    }
    j = So(h + 20 | 0);
    v[31601] = 0;
    N(760, j | 0, b | 0);
    b = v[31601];
    v[31601] = 0;
    if ((b | 0) == 1) {
     break a;
    }
    ln(h + 12 | 0, v[a >> 2]);
    $q(h + 4 | 0, v[a >> 2], v[a + 4 >> 2]);
    g = v[h + 12 >> 2];
    f = v[h + 16 >> 2];
    k = eb - 48 | 0;
    eb = k;
    b = v[j + 4 >> 2];
    c = b + v[a + 4 >> 2] | 0;
    v[j + 4 >> 2] = c;
    c: {
     d: {
      if (!b) {
       i = c - 1 | 0;
       break d;
      }
      i = c - 1 | 0;
      if ((i ^ b - 1) >>> 0 < 32) {
       break c;
      }
     }
     v[v[j >> 2] + ((c >>> 0 >= 33 ? i >>> 5 | 0 : 0) << 2) >> 2] = 0;
    }
    c = Yb(k + 40 | 0, g, f);
    g = Yb(k + 32 | 0, v[h + 4 >> 2], v[h + 8 >> 2]);
    yp(k + 24 | 0, v[j >> 2], b);
    i = eb - 32 | 0;
    eb = i;
    b = Yb(i + 24 | 0, v[c >> 2], v[c + 4 >> 2]);
    c = Yb(i + 16 | 0, v[g >> 2], v[g + 4 >> 2]);
    m = Yb(i + 8 | 0, v[k + 24 >> 2], v[k + 28 >> 2]);
    g = eb - 32 | 0;
    eb = g;
    q = k + 8 | 0;
    f = Yb(g + 24 | 0, v[b >> 2], v[b + 4 >> 2]);
    c = Yb(g + 16 | 0, v[c >> 2], v[c + 4 >> 2]);
    m = Yb(g + 8 | 0, v[m >> 2], v[m + 4 >> 2]);
    b = eb - 128 | 0;
    eb = b;
    e = Yb(b + 104 | 0, v[f >> 2], v[f + 4 >> 2]);
    c = Yb(b + 96 | 0, v[c >> 2], v[c + 4 >> 2]);
    d = eb - 16 | 0;
    eb = d;
    e = Yb(d + 8 | 0, v[e >> 2], v[e + 4 >> 2]);
    l = Yb(d, v[c >> 2], v[c + 4 >> 2]);
    c = eb - 32 | 0;
    eb = c;
    e = Yb(c + 16 | 0, v[e >> 2], v[e + 4 >> 2]);
    kn(c + 24 | 0, v[e >> 2], v[e + 4 >> 2]);
    e = c + 8 | 0;
    l = Yb(c, v[l >> 2], v[l + 4 >> 2]);
    kn(e, v[l >> 2], v[l + 4 >> 2]);
    BV(b + 112 | 0, v[c + 24 >> 2], v[c + 28 >> 2], e);
    eb = c + 32 | 0;
    eb = d + 16 | 0;
    e = Yb(b + 72 | 0, v[b + 112 >> 2], v[b + 116 >> 2]);
    l = Yb(b - -64 | 0, v[b + 120 >> 2], v[b + 124 >> 2]);
    d = b + 56 | 0;
    c = Yb(b + 48 | 0, v[m >> 2], v[m + 4 >> 2]);
    kn(d, v[c >> 2], v[c + 4 >> 2]);
    r = b + 80 | 0;
    c = eb - 16 | 0;
    eb = c;
    while (1) {
     n = v[e >> 2];
     o = v[e + 4 >> 2];
     if (ZW(n, o, v[l >> 2], v[l + 4 >> 2])) {
      Ot(c + 8 | 0, n, o);
      Ot(c, v[d >> 2], v[d + 4 >> 2]);
      kf(c, Fb(v[v[c + 8 >> 2] >> 2], v[c + 12 >> 2]));
      Av(e);
      Av(d);
      continue;
     }
     break;
    }
    CV(r, n, o, d);
    eb = c + 16 | 0;
    f = Yb(b + 32 | 0, v[f >> 2], v[f + 4 >> 2]);
    d = Yb(b + 24 | 0, v[b + 80 >> 2], v[b + 84 >> 2]);
    c = eb - 16 | 0;
    eb = c;
    e = Yb(c + 8 | 0, v[f >> 2], v[f + 4 >> 2]);
    d = Yb(c, v[d >> 2], v[d + 4 >> 2]);
    f = eb - 16 | 0;
    eb = f;
    Yb(f + 8 | 0, v[e >> 2], v[e + 4 >> 2]);
    d = Yb(f, v[d >> 2], v[d + 4 >> 2]);
    kn(b + 40 | 0, v[d >> 2], v[d + 4 >> 2]);
    eb = f + 16 | 0;
    eb = c + 16 | 0;
    Yb(b + 8 | 0, v[m >> 2], v[m + 4 >> 2]);
    c = b + 16 | 0;
    f = Yb(b, v[b + 88 >> 2], v[b + 92 >> 2]);
    kn(c, v[f >> 2], v[f + 4 >> 2]);
    CV(q, v[b + 40 >> 2], v[b + 44 >> 2], c);
    eb = b + 128 | 0;
    eb = g + 32 | 0;
    eb = i + 32 | 0;
    eb = k + 48 | 0;
    mC(a, j);
    tf(j);
   }
   eb = h + 32 | 0;
   return;
  }
  dd();
  p();
 }
 a = M() | 0;
 tf(j);
 P(a | 0);
 p();
}

function aga(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = C(0), f = 0, g = 0, h = 0, i = C(0), j = 0, k = 0, l = C(0), m = C(0), n = C(0), o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, w = 0, x = 0, y = 0, A = C(0), B = 0, D = 0, E = 0, F = 0, G = C(0), H = 0, I = 0, J = 0, K = 0, L = 0, M = 0, N = C(0), O = C(0), P = C(0), Q = C(0), R = C(0), S = 0, T = C(0);
 if (si(a + 44 | 0)) {
  f = v[a + 44 >> 2];
  B = Gc(f, 0);
  D = Gc(f, 1);
  f = v[a + 56 >> 2];
  E = Gc(f, 0);
  F = Gc(f, 1);
  t = v[a + 4296 >> 2];
  g = t + 1 | 0;
  k = a + 4304 | 0;
  f = a + 4272 | 0;
  u = g + v[xb(f, 0) >> 2] & 4095;
  o = k + (u << 4) | 0;
  w = g + v[xb(f, 1) >> 2] & 4095;
  p = ((w << 4) + k | 0) + 4 | 0;
  x = g + v[xb(f, 2) >> 2] & 4095;
  q = ((x << 4) + k | 0) + 8 | 0;
  y = g + v[xb(f, 3) >> 2] & 4095;
  r = ((y << 4) + k | 0) + 12 | 0;
  I = a + 78032 | 0;
  g = a + 4232 | 0;
  J = a + 69840 | 0;
  h = v[xb(f, 4) >> 2];
  s = v[a + 4300 >> 2];
  h = h + s | 0;
  j = v[xb(f, 5) >> 2] + s | 0;
  f = d;
  while (1) {
   if (f) {
    N = z[r >> 2];
    O = z[q >> 2];
    P = z[p >> 2];
    Q = z[o >> 2];
    A = z[D >> 2];
    R = z[B >> 2];
    u = u - 1 & 4095;
    o = (u << 4) + k | 0;
    e = z[o >> 2];
    K = h & 1023;
    h = (K << 3) + J | 0;
    i = z[h + 4 >> 2];
    r = s << 3;
    q = r + J | 0;
    w = w - 1 & 4095;
    p = ((w << 4) + k | 0) + 4 | 0;
    l = z[p >> 2];
    m = l;
    n = C(l * C(.6180340051651001));
    G = z[h >> 2];
    l = z[xb(g, 0) >> 2];
    n = C(n + C(G * l));
    z[q + 4 >> 2] = m + C(n * C(-.6180340051651001));
    m = e;
    e = C(C(i * l) + C(e * C(-.6180340051651001)));
    z[q >> 2] = m + C(e * C(.6180340051651001));
    z[o >> 2] = n;
    z[p >> 2] = e;
    x = x - 1 & 4095;
    H = (x << 4) + k | 0;
    q = H + 8 | 0;
    e = z[q >> 2];
    L = j & 1023;
    j = (L << 3) + I | 0;
    l = z[j + 4 >> 2];
    M = r + I | 0;
    y = y - 1 & 4095;
    h = (y << 4) + k | 0;
    r = h + 12 | 0;
    i = z[r >> 2];
    m = i;
    G = z[j >> 2];
    n = z[xb(g, 1) >> 2];
    i = C(C(i * C(.6180340051651001)) + C(G * n));
    z[M + 4 >> 2] = m + C(i * C(-.6180340051651001));
    m = e;
    e = C(C(l * n) + C(e * C(-.6180340051651001)));
    z[M >> 2] = m + C(e * C(.6180340051651001));
    z[H + 8 >> 2] = i;
    z[h + 12 >> 2] = e;
    e = C(R + C(1.0000000031710769e-30));
    z[E >> 2] = i + C(C(e * z[a + 4224 >> 2]) + z[o >> 2]);
    i = C(A + C(1.0000000031710769e-30));
    z[F >> 2] = C(C(i * z[a + 4224 >> 2]) + z[p >> 2]) + z[h + 12 >> 2];
    j = (t << 4) + k | 0;
    l = e;
    e = z[a + 4228 >> 2];
    A = C(l * e);
    S = j, T = C(A + C(C(z[o >> 2] * z[xb(g, 2) >> 2]) + C(Q * z[xb(g, 3) >> 2]))), 
    z[S >> 2] = T;
    e = C(i * e);
    S = j, T = C(e + C(C(z[p >> 2] * z[xb(g, 4) >> 2]) + C(P * z[xb(g, 5) >> 2]))), 
    z[S + 4 >> 2] = T;
    S = j, T = C(C(C(z[H + 8 >> 2] * z[xb(g, 6) >> 2]) + C(O * z[xb(g, 7) >> 2])) - e), 
    z[S + 8 >> 2] = T;
    S = j, T = C(A + C(C(z[h + 12 >> 2] * z[xb(g, 8) >> 2]) + C(N * z[xb(g, 9) >> 2]))), 
    z[S + 12 >> 2] = T;
    f = f - 1 | 0;
    F = F + 4 | 0;
    E = E + 4 | 0;
    D = D + 4 | 0;
    B = B + 4 | 0;
    j = L - 1 | 0;
    h = K - 1 | 0;
    s = s - 1 & 1023;
    t = t - 1 & 4095;
    continue;
   } else {
    v[a + 4300 >> 2] = s;
    v[a + 4296 >> 2] = t;
    f = a;
    a = v[a + 56 >> 2];
    Hi(f, b, c, Gc(a, 0), Gc(a, 1), d);
   }
   break;
  }
 }
}

function yla(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, w = 0, x = 0, y = 0, z = 0, A = 0, C = 0, D = 0, E = 0, F = 0, G = 0, H = 0, I = 0;
 e = eb - 48 | 0;
 eb = e;
 A = v[a + 16 >> 2];
 C = Fg(b + 327720 | 0, v[b + 20 >> 2], (v[a + 88 >> 2] & 16384) >>> 14 | 0);
 p = v[a + 8 >> 2];
 q = v[a + 12 >> 2];
 b = v[a >> 2];
 h = v[a + 4 >> 2];
 r = v[a + 128 >> 2];
 if (r) {
  s = Gg(p, q, r);
  t = gb;
  i = v[a + 76 >> 2];
  eg(b, h, uf(p, q, d), gb);
  w = gb >>> 0 > i >>> 0 ? d : 0;
 }
 j = a + 112 | 0;
 v[e + 24 >> 2] = v[a + 44 >> 2];
 v[e + 28 >> 2] = v[a + 48 >> 2];
 v[e + 32 >> 2] = v[a + 52 >> 2];
 v[e + 36 >> 2] = v[a + 56 >> 2];
 n = v[a + 40 >> 2];
 o = v[a + 36 >> 2];
 v[e + 8 >> 2] = b;
 v[e + 12 >> 2] = h;
 D = e + 24 | 0;
 a: while (1) {
  if (d) {
   d = d - 1 | 0;
   g = v[e + 12 >> 2];
   b = v[e + 8 >> 2];
   v[e + 40 >> 2] = b;
   v[e + 44 >> 2] = 0;
   w = w - 1 | 0;
   i = w;
   s = i ? s : 0;
   t = i ? t : 0;
   h = ((((g & 2147483647) << 1 | b >>> 31) & 2147483646) << 1) + A | 0;
   b = r;
   while (1) if ((b | 0) <= 0) {
    Ob(j, v[a + 120 >> 2], v[a + 124 >> 2]);
    i = v[a + 116 >> 2];
    if (i) {
     b = v[e + 40 >> 2];
     b = (v[e + 44 >> 2] & 2147483647) << 1 | b >>> 31;
     be(j, (u[((b & 2147483646) << 1) + h >> 1] + u[h + (b << 1 | 2) >> 1] | 0) / 8 << 16 >> 16);
     ae(j, i);
     v[j >> 2] = v[j >> 2];
     v[j + 4 >> 2] = 0;
    }
    b = Eg(j, C);
    v[e + 4 >> 2] = b;
    v[e >> 2] = b;
    E = v[a + 72 >> 2];
    x = v[a + 68 >> 2];
    F = x >> 31;
    h = v[a + 64 >> 2];
    G = h >> 31;
    i = v[a + 60 >> 2];
    H = i >> 31;
    b = 0;
    while (1) {
     if ((b | 0) != 2) {
      y = (b << 2) + e | 0;
      f = v[y >> 2];
      g = (b << 3) + D | 0;
      I = v[g + 4 >> 2];
      k = v[g >> 2];
      v[g + 4 >> 2] = k;
      z = f << 8;
      f = z;
      f = Aua(f, f >> 31, i, H);
      l = gb;
      m = f;
      f = Xb(k, -16777216, 16776704);
      f = Aua(h, G, f, f >> 31);
      k = m + f | 0;
      m = gb + l | 0;
      m = f >>> 0 > k >>> 0 ? m + 1 | 0 : m;
      f = Xb(I, -16777216, 16776704);
      l = Aua(x, F, f, f >> 31);
      k = l + k | 0;
      f = gb + m | 0;
      f = k >>> 0 < l >>> 0 ? f + 1 | 0 : f;
      l = k + 8388608 | 0;
      f = l >>> 0 < 8388608 ? f + 1 | 0 : f;
      f = Rc(l, f, 24);
      v[g >> 2] = f - (E & z);
      v[y >> 2] = (f | 0) / 256;
      b = b + 1 | 0;
      continue;
     }
     break;
    }
    b = v[a + 32 >> 2];
    o = v[a + 28 >> 2] + o | 0;
    v[c >> 2] = v[c >> 2] + B(v[e >> 2], o >> 12);
    n = b + n | 0;
    v[c + 4 >> 2] = v[c + 4 >> 2] + B(v[e + 4 >> 2], n >> 12);
    Ob(e + 8 | 0, p, q);
    c = c + 8 | 0;
    continue a;
   } else {
    g = v[e + 40 >> 2];
    g = (v[e + 44 >> 2] & 2147483647) << 1 | g >>> 31;
    be(j, (u[((g & 2147483646) << 1) + h >> 1] + u[h + (g << 1 | 2) >> 1] | 0) / 8 << 16 >> 16);
    ae(j, 4);
    Ob(e + 40 | 0, s, t);
    b = b - 1 | 0;
    continue;
   }
  }
  break;
 }
 b = v[e + 12 >> 2];
 v[a >> 2] = v[e + 8 >> 2];
 v[a + 4 >> 2] = b;
 v[a + 40 >> 2] = n;
 v[a + 20 >> 2] = o >> 12;
 v[a + 36 >> 2] = o;
 v[a + 24 >> 2] = n >> 12;
 v[a + 44 >> 2] = v[e + 24 >> 2];
 v[a + 48 >> 2] = v[e + 28 >> 2];
 v[a + 52 >> 2] = v[e + 32 >> 2];
 v[a + 56 >> 2] = v[e + 36 >> 2];
 eb = e + 48 | 0;
}

function BO(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0;
 d = eb - 32 | 0;
 eb = d;
 g = Mb(a);
 a: {
  b: {
   c: {
    a = v[b + 36 >> 2];
    c = v[b + 40 >> 2];
    d: {
     if (Hb(a, c)) {
      sc(d + 28 | 0);
      break d;
     }
     v[31601] = 0;
     a = d + 16 | 0;
     N(1071, a | 0, b | 0);
     c = v[31601];
     v[31601] = 0;
     if ((c | 0) == 1) {
      break b;
     }
     v[31601] = 0;
     c = Q(1055, a | 0) | 0;
     e = v[31601];
     v[31601] = 0;
     if ((e | 0) == 1) {
      break c;
     }
     v[d + 28 >> 2] = c;
     nf(a);
     c = v[b + 40 >> 2];
     a = v[b + 36 >> 2];
    }
    e: {
     if (Hb(a, c)) {
      c = b + 36 | 0;
      break e;
     }
     c = v[d + 28 >> 2];
     a = v[c >> 2];
    }
    e = v[c + 4 >> 2];
    v[31601] = 0;
    N(176, g | 0, ej(a, e) | 0);
    a = v[31601];
    v[31601] = 0;
    f: {
     if ((a | 0) != 1) {
      a = vb(v[c >> 2]);
      v[d + 12 >> 2] = a;
      h = vb(v[c + 4 >> 2]);
      g: {
       h: {
        i: {
         j: {
          k: {
           while (1) {
            if (!Hb(a, h)) {
             vl(d + 28 | 0);
             eb = d + 32 | 0;
             return;
            }
            c = w[a + 16 | 0];
            e = v[v[b + 24 >> 2] + 484360 >> 2];
            v[31601] = 0;
            e = Lj(e, c);
            N(1072, d | 0, e | 0);
            c = v[31601];
            v[31601] = 0;
            if ((c | 0) == 1) {
             break g;
            }
            v[31601] = 0;
            c = d + 16 | 0;
            N(1058, c | 0, d | 0);
            f = v[31601];
            v[31601] = 0;
            if ((f | 0) != 1) {
             v[31601] = 0;
             N(178, g | 0, c | 0);
             f = v[31601];
             v[31601] = 0;
             if ((f | 0) == 1) {
              break k;
             }
             sb(c);
             sb(d);
             f = $k(v[g + 4 >> 2]);
             l: {
              if (!zd(v[f + 4 >> 2], w[f + 11 | 0])) {
               break l;
              }
              a = v[a + 12 >> 2];
              if (!Vi(e, a & 255)) {
               break l;
              }
              f = v[b + 24 >> 2];
              i = v[f + 1298404 >> 2];
              a = x[$b(v[e >> 2], a) >> 1];
              e = v[f + 484344 >> 2];
              v[31601] = 0;
              N(1065, d | 0, Vb(e, a) | 0);
              a = v[31601];
              v[31601] = 0;
              if ((a | 0) == 1) {
               break i;
              }
              v[31601] = 0;
              R(1073, c | 0, i | 0, d | 0);
              a = v[31601];
              v[31601] = 0;
              if ((a | 0) == 1) {
               break h;
              }
              yb($k(v[g + 4 >> 2]), c);
              sb(c);
              sb(d);
             }
             a = v[gA(d + 12 | 0) >> 2];
             continue;
            }
            break;
           }
           a = M() | 0;
           break j;
          }
          a = M() | 0;
          sb(d + 16 | 0);
         }
         sb(d);
         break f;
        }
        a = M() | 0;
        break f;
       }
       a = M() | 0;
       sb(d);
       break f;
      }
      a = M() | 0;
      break f;
     }
     a = M() | 0;
    }
    vl(d + 28 | 0);
    break a;
   }
   a = M() | 0;
   nf(d + 16 | 0);
   break a;
  }
  a = M() | 0;
 }
 Sd(g);
 P(a | 0);
 p();
}

function dma(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, w = 0, x = 0, y = 0, z = 0, A = 0, C = 0, D = 0, E = 0, F = 0, G = 0, H = 0, I = 0, J = 0;
 f = eb - 48 | 0;
 eb = f;
 g = v[a + 8 >> 2];
 q = g;
 j = v[a + 12 >> 2];
 l = j;
 a: {
  b: {
   if ((l | 0) <= 1 & g >>> 0 <= 805306368 | (l | 0) <= 0) {
    j = 131112;
    g = l;
    if ((g | 0) > -2) {
     e = 1;
    } else {
     e = (g | 0) >= -2 & q >>> 0 >= 3489660928;
    }
    if (e) {
     break a;
    }
    j = 262184;
    if ((l | 0) == -2 & q >>> 0 < 2147483648 | l >>> 0 < 4294967294) {
     break a;
    }
    break b;
   }
   j = 262184;
   if ((l | 0) == 1 & q >>> 0 > 2147483648 | l >>> 0 > 1) {
    break a;
   }
  }
  j = 196648;
 }
 z = v[a + 16 >> 2];
 v[f + 32 >> 2] = v[a + 44 >> 2];
 v[f + 36 >> 2] = v[a + 48 >> 2];
 v[f + 40 >> 2] = v[a + 52 >> 2];
 v[f + 44 >> 2] = v[a + 56 >> 2];
 n = v[a + 40 >> 2];
 o = v[a + 36 >> 2];
 g = v[a + 4 >> 2];
 v[f + 16 >> 2] = v[a >> 2];
 v[f + 20 >> 2] = g;
 A = b + j | 0;
 C = f + 32 | 0;
 D = v[a + 32 >> 2];
 E = v[a + 28 >> 2];
 F = v[a + 72 >> 2];
 x = v[a + 68 >> 2];
 G = x >> 31;
 y = v[a + 64 >> 2];
 H = y >> 31;
 j = v[a + 60 >> 2];
 I = j >> 31;
 while (1) {
  if (d) {
   b = v[f + 16 >> 2];
   J = (((v[f + 20 >> 2] & 2147483647) << 1 | b >>> 31) & -2) + z | 0;
   b = (b >>> 16 & 65520) + A | 0;
   m = u[b + 14 >> 1];
   r = u[b + 12 >> 1];
   w = u[b + 10 >> 1];
   h = u[b + 8 >> 1];
   s = u[b + 6 >> 1];
   k = u[b + 4 >> 1];
   e = u[b + 2 >> 1];
   g = u[b >> 1];
   b = 0;
   p = 0;
   while (1) {
    if ((p | 0) != 2) {
     i = p + J | 0;
     v[(f + 8 | 0) + (p << 2) >> 2] = (((((((B(t[i - 4 | 0], e) + B(t[i - 6 | 0], g) | 0) + B(t[i - 2 | 0], k) | 0) + B(t[i | 0], s) | 0) + B(t[i + 2 | 0], h) | 0) + B(t[i + 4 | 0], w) | 0) + B(r, t[i + 6 | 0]) | 0) + B(m, t[i + 8 | 0]) << 8) / 32768;
     p = p + 1 | 0;
     continue;
    }
    break;
   }
   while (1) {
    if ((b | 0) != 2) {
     r = (f + 8 | 0) + (b << 2) | 0;
     e = v[r >> 2];
     g = (b << 3) + C | 0;
     w = v[g + 4 >> 2];
     h = v[g >> 2];
     v[g + 4 >> 2] = h;
     s = e << 8;
     e = s;
     e = Aua(e, e >> 31, j, I);
     k = gb;
     i = e;
     e = Xb(h, -16777216, 16776704);
     e = Aua(y, H, e, e >> 31);
     h = i + e | 0;
     m = gb + k | 0;
     m = e >>> 0 > h >>> 0 ? m + 1 | 0 : m;
     e = Xb(w, -16777216, 16776704);
     k = Aua(x, G, e, e >> 31);
     h = k + h | 0;
     e = gb + m | 0;
     e = h >>> 0 < k >>> 0 ? e + 1 | 0 : e;
     k = h + 8388608 | 0;
     e = k >>> 0 < 8388608 ? e + 1 | 0 : e;
     e = Rc(k, e, 24);
     v[g >> 2] = e - (s & F);
     v[r >> 2] = (e | 0) / 256;
     b = b + 1 | 0;
     continue;
    }
    break;
   }
   o = o + E | 0;
   v[c >> 2] = v[c >> 2] + B(v[f + 8 >> 2], o >> 12);
   n = n + D | 0;
   v[c + 4 >> 2] = v[c + 4 >> 2] + B(v[f + 12 >> 2], n >> 12);
   Ob(f + 16 | 0, q, l);
   c = c + 8 | 0;
   d = d - 1 | 0;
   continue;
  }
  break;
 }
 b = v[f + 20 >> 2];
 v[a >> 2] = v[f + 16 >> 2];
 v[a + 4 >> 2] = b;
 v[a + 40 >> 2] = n;
 v[a + 20 >> 2] = o >> 12;
 v[a + 36 >> 2] = o;
 v[a + 24 >> 2] = n >> 12;
 v[a + 44 >> 2] = v[f + 32 >> 2];
 v[a + 48 >> 2] = v[f + 36 >> 2];
 v[a + 52 >> 2] = v[f + 40 >> 2];
 v[a + 56 >> 2] = v[f + 44 >> 2];
 eb = f + 48 | 0;
}

function mU(a, b) {
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, w = 0, x = 0, y = 0, z = 0;
 c = eb - 176 | 0;
 eb = c;
 e = v[a + 12 >> 2];
 j = 1 << e;
 a: {
  if (!(e & 1)) {
   h = j >>> 2 | 0;
   l = 1;
   break a;
  }
  l = j >>> 1 | 0;
  e = 0;
  while (1) {
   if ((e | 0) == (l | 0)) {
    h = j >>> 3 | 0;
    l = 2;
    e = v[a + 12 >> 2];
   } else {
    i = v[b >> 2];
    h = Xd(i, e + l | 0);
    d = Xd(i, e);
    o = A[h >> 3];
    p = A[h + 8 >> 3];
    xj(c + 160 | 0, d, o, p);
    i = v[c + 172 >> 2];
    v[h + 8 >> 2] = v[c + 168 >> 2];
    v[h + 12 >> 2] = i;
    i = v[c + 164 >> 2];
    v[h >> 2] = v[c + 160 >> 2];
    v[h + 4 >> 2] = i;
    AA(Xd(v[b >> 2], e), o, p);
    e = e + 1 | 0;
    continue;
   }
   break;
  }
 }
 i = e & -2;
 b: while (1) {
  if (i) {
   x = B(h, 3);
   y = h << 1;
   j = 0;
   c: while (1) {
    if ((j | 0) == (l | 0)) {
     i = i - 2 | 0;
     h = h >>> 2 | 0;
     l = l << 2;
     continue b;
    }
    d = v[a >> 2];
    e = Xd(d, j << 1);
    d = Xd(d, j);
    o = A[d >> 3];
    p = A[d + 8 >> 3];
    r = A[e >> 3];
    s = A[e + 8 >> 3];
    Ki(c + 160 | 0, o, p, r, s);
    e = j << i;
    d = h + e | 0;
    z = d >>> 0 < e >>> 0 ? e : d;
    while (1) if ((e | 0) == (z | 0)) {
     j = j + 1 | 0;
     continue c;
    } else {
     f = v[b >> 2];
     d = Xd(f, e);
     g = v[d + 12 >> 2];
     v[c + 152 >> 2] = v[d + 8 >> 2];
     v[c + 156 >> 2] = g;
     g = v[d + 4 >> 2];
     v[c + 144 >> 2] = v[d >> 2];
     v[c + 148 >> 2] = g;
     g = c + 128 | 0;
     t = e + h | 0;
     k = Xd(f, t);
     Ki(g, r, s, A[k >> 3], A[k + 8 >> 3]);
     u = e + y | 0;
     k = Xd(f, u);
     Ki(c + 112 | 0, o, p, A[k >> 3], A[k + 8 >> 3]);
     m = A[c + 160 >> 3];
     n = A[c + 168 >> 3];
     w = e + x | 0;
     f = Xd(f, w);
     Ki(c + 96 | 0, m, n, A[f >> 3], A[f + 8 >> 3]);
     k = c + 80 | 0;
     f = c + 144 | 0;
     m = A[c + 112 >> 3];
     n = A[c + 120 >> 3];
     Bl(k, f, m, n);
     q = c - -64 | 0;
     xj(q, f, m, n);
     m = A[c + 96 >> 3];
     n = A[c + 104 >> 3];
     Bl(c + 48 | 0, g, m, n);
     f = c + 16 | 0;
     Nl(f, -0, -1);
     xj(c, g, m, n);
     Ki(c + 32 | 0, A[c + 16 >> 3], A[c + 24 >> 3], A[c >> 3], A[c + 8 >> 3]);
     Bl(f, k, A[c + 48 >> 3], A[c + 56 >> 3]);
     g = v[c + 28 >> 2];
     v[d + 8 >> 2] = v[c + 24 >> 2];
     v[d + 12 >> 2] = g;
     g = v[c + 20 >> 2];
     v[d >> 2] = v[c + 16 >> 2];
     v[d + 4 >> 2] = g;
     xj(f, k, A[c + 48 >> 3], A[c + 56 >> 3]);
     d = Xd(v[b >> 2], t);
     g = v[c + 28 >> 2];
     v[d + 8 >> 2] = v[c + 24 >> 2];
     v[d + 12 >> 2] = g;
     g = v[c + 20 >> 2];
     v[d >> 2] = v[c + 16 >> 2];
     v[d + 4 >> 2] = g;
     Bl(f, q, A[c + 32 >> 3], A[c + 40 >> 3]);
     d = Xd(v[b >> 2], u);
     g = v[c + 28 >> 2];
     v[d + 8 >> 2] = v[c + 24 >> 2];
     v[d + 12 >> 2] = g;
     g = v[c + 20 >> 2];
     v[d >> 2] = v[c + 16 >> 2];
     v[d + 4 >> 2] = g;
     xj(f, q, A[c + 32 >> 3], A[c + 40 >> 3]);
     d = Xd(v[b >> 2], w);
     f = v[c + 28 >> 2];
     v[d + 8 >> 2] = v[c + 24 >> 2];
     v[d + 12 >> 2] = f;
     f = v[c + 20 >> 2];
     v[d >> 2] = v[c + 16 >> 2];
     v[d + 4 >> 2] = f;
     e = e + 1 | 0;
     continue;
    }
   }
  }
  break;
 }
 eb = c + 176 | 0;
}

function Sta(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0;
 h = Eb(a);
 a = w[b + 11 | 0];
 g = v[b + 4 >> 2];
 v[31601] = 0;
 k = xh(g, a);
 N(110, h | 0, k | 0);
 a = v[31601];
 v[31601] = 0;
 a: {
  b: {
   if ((a | 0) != 1) {
    g = 0;
    a = 0;
    c: {
     while (1) {
      d: {
       if ((a | 0) == (k | 0)) {
        if (l & m | f) {
         break d;
        }
        return;
       }
       e = w[dc(b, a) | 0];
       e: {
        f: {
         g: {
          switch (f | 0) {
          case 0:
           f = 1;
           h: {
            switch (e - 123 | 0) {
            case 2:
             break h;

            case 0:
             break e;

            default:
             break f;
            }
           }
           f = 3;
           break e;

          case 1:
           i: {
            switch (e - 123 | 0) {
            case 2:
             m = 1;
             e = g + 1 | 0;
             f = 0;
             if (d >>> 0 <= g >>> 0) {
              g = e;
              break e;
             }
             v[31601] = 0;
             N(302, h | 0, Ud(c, g) | 0);
             j = v[31601];
             v[31601] = 0;
             g = e;
             if ((j | 0) != 1) {
              break e;
             }
             a = M() | 0;
             break b;

            case 0:
             break f;

            default:
             break i;
            }
           }
           f = -1;
           e = e - 48 & 255;
           if (e >>> 0 > 9) {
            break e;
           }
           l = 1;
           f = 2;
           i = e;
           break e;

          case 2:
           f = -1;
           j: {
            switch (e - 123 | 0) {
            case 2:
             f = 0;
             if (d >>> 0 <= i >>> 0) {
              break e;
             }
             v[31601] = 0;
             N(302, h | 0, Ud(c, i) | 0);
             e = v[31601];
             v[31601] = 0;
             if ((e | 0) != 1) {
              break e;
             }
             a = M() | 0;
             break b;

            case 0:
             break e;

            default:
             break j;
            }
           }
           e = e - 48 & 255;
           if (e >>> 0 > 9) {
            break e;
           }
           i = e + B(i, 10) | 0;
           l = 1;
           f = 2;
           break e;

          case 3:
           break g;

          default:
           break e;
          }
         }
         j = (e | 0) != 125;
         f = -1;
         e = 125;
         if (j) {
          break e;
         }
        }
        f = 0;
        v[31601] = 0;
        N(111, h | 0, e << 24 >> 24);
        e = v[31601];
        v[31601] = 0;
        if ((e | 0) == 1) {
         break c;
        }
       }
       a = a + 1 | 0;
       continue;
      }
      break;
     }
     b = cc(8);
     v[31601] = 0;
     a = Q(96, b | 0) | 0;
     c = v[31601];
     v[31601] = 0;
     if ((c | 0) != 1) {
      v[31601] = 0;
      R(97, a | 0, 40148, 17);
      a = v[31601];
      v[31601] = 0;
      if ((a | 0) != 1) {
       break a;
      }
      a = M() | 0;
      break b;
     }
     a = M() | 0;
     jc(b);
     break b;
    }
    a = M() | 0;
    break b;
   }
   a = M() | 0;
  }
  sb(h);
  P(a | 0);
 }
 p();
}

function T3(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0;
 h = Eb(a);
 a = w[b + 11 | 0];
 g = v[b + 4 >> 2];
 v[31601] = 0;
 k = xh(g, a);
 N(93, h | 0, k | 0);
 a = v[31601];
 v[31601] = 0;
 a: {
  b: {
   if ((a | 0) != 1) {
    g = 0;
    a = 0;
    c: {
     while (1) {
      d: {
       if ((a | 0) == (k | 0)) {
        if (l & m | f) {
         break d;
        }
        return;
       }
       e = w[dc(b, a) | 0];
       e: {
        f: {
         g: {
          switch (f | 0) {
          case 0:
           f = 1;
           h: {
            switch (e - 123 | 0) {
            case 2:
             break h;

            case 0:
             break e;

            default:
             break f;
            }
           }
           f = 3;
           break e;

          case 1:
           i: {
            switch (e - 123 | 0) {
            case 2:
             m = 1;
             e = g + 1 | 0;
             f = 0;
             if (d >>> 0 <= g >>> 0) {
              g = e;
              break e;
             }
             v[31601] = 0;
             N(94, h | 0, Ud(c, g) | 0);
             j = v[31601];
             v[31601] = 0;
             g = e;
             if ((j | 0) != 1) {
              break e;
             }
             a = M() | 0;
             break b;

            case 0:
             break f;

            default:
             break i;
            }
           }
           f = -1;
           e = e - 48 | 0;
           if ((e & 255) >>> 0 > 9) {
            break e;
           }
           l = 1;
           f = 2;
           i = e;
           break e;

          case 2:
           f = -1;
           j: {
            switch (e - 123 | 0) {
            case 2:
             f = 0;
             if (d >>> 0 <= i >>> 0) {
              break e;
             }
             v[31601] = 0;
             N(94, h | 0, Ud(c, i) | 0);
             e = v[31601];
             v[31601] = 0;
             if ((e | 0) != 1) {
              break e;
             }
             a = M() | 0;
             break b;

            case 0:
             break e;

            default:
             break j;
            }
           }
           if ((e - 48 & 255) >>> 0 > 9) {
            break e;
           }
           i = (B(i, 10) + e | 0) - 48 | 0;
           l = 1;
           f = 2;
           break e;

          case 3:
           break g;

          default:
           break e;
          }
         }
         j = (e | 0) != 125;
         f = -1;
         e = 125;
         if (j) {
          break e;
         }
        }
        f = 0;
        v[31601] = 0;
        N(95, h | 0, e | 0);
        e = v[31601];
        v[31601] = 0;
        if ((e | 0) == 1) {
         break c;
        }
       }
       a = a + 1 | 0;
       continue;
      }
      break;
     }
     b = cc(8);
     v[31601] = 0;
     a = Q(96, b | 0) | 0;
     c = v[31601];
     v[31601] = 0;
     if ((c | 0) != 1) {
      v[31601] = 0;
      R(97, a | 0, 40148, 17);
      a = v[31601];
      v[31601] = 0;
      if ((a | 0) != 1) {
       break a;
      }
      a = M() | 0;
      break b;
     }
     a = M() | 0;
     jc(b);
     break b;
    }
    a = M() | 0;
    break b;
   }
   a = M() | 0;
  }
  sb(h);
  P(a | 0);
 }
 p();
}

function hW(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0;
 c = v[a >> 2];
 e = Qh(c, v[a + 4 >> 2]);
 if (e >>> 0 < b >>> 0) {
  h = eb - 32 | 0;
  eb = h;
  g = b - e | 0;
  b = v[zb(a) >> 2];
  c = v[a + 4 >> 2];
  a: {
   if (g >>> 0 <= b - c >> 8 >>> 0) {
    e = eb - 16 | 0;
    eb = e;
    b = e + 4 | 0;
    v[b >> 2] = a;
    a = v[a + 4 >> 2];
    v[b + 4 >> 2] = a;
    v[b + 8 >> 2] = a + (g << 8);
    a = v[b + 4 >> 2];
    c = v[b + 8 >> 2];
    while (1) {
     if ((a | 0) == (c | 0)) {
      hc(b);
      eb = e + 16 | 0;
     } else {
      OV(a);
      a = a + 256 | 0;
      v[b + 4 >> 2] = a;
      continue;
     }
     break;
    }
    break a;
   }
   i = zb(a);
   e = h + 12 | 0;
   f = Qh(v[a >> 2], c) + g | 0;
   c = eb - 16 | 0;
   eb = c;
   v[c + 12 >> 2] = f;
   d = eb - 16 | 0;
   eb = d;
   v[d + 12 >> 2] = 16777215;
   v[d + 8 >> 2] = 2147483647;
   b = v[Gb(d + 12 | 0, d + 8 | 0) >> 2];
   eb = d + 16 | 0;
   b: {
    if (b >>> 0 >= f >>> 0) {
     d = pC(a);
     if (d >>> 0 < b >>> 1 >>> 0) {
      v[c + 8 >> 2] = d << 1;
      b = v[ad(c + 8 | 0, c + 12 | 0) >> 2];
     }
     eb = c + 16 | 0;
     break b;
    }
    dd();
    p();
   }
   f = Qh(v[a >> 2], v[a + 4 >> 2]);
   d = eb - 16 | 0;
   eb = d;
   Kg(e + 12 | 0, i);
   c: {
    if (!b) {
     c = 0;
     b = 0;
     break c;
    }
    if (b >>> 0 >= 16777216) {
     Sj();
     p();
    }
    c = Dc(b << 8);
    v[d + 12 >> 2] = b;
    v[d + 8 >> 2] = c;
    c = v[d + 8 >> 2];
    b = v[d + 12 >> 2];
   }
   v[e >> 2] = c;
   f = c + (f << 8) | 0;
   v[e + 8 >> 2] = f;
   v[e + 4 >> 2] = f;
   l = mc(e), m = c + (b << 8) | 0, v[l >> 2] = m;
   eb = d + 16 | 0;
   d = eb - 16 | 0;
   eb = d;
   b = v[e + 8 >> 2];
   c = d + 4 | 0;
   v[c + 8 >> 2] = e + 8;
   v[c >> 2] = b;
   v[c + 4 >> 2] = b + (g << 8);
   b = v[c >> 2];
   while (1) {
    if (v[c + 4 >> 2] != (b | 0)) {
     OV(b);
     b = v[c >> 2] + 256 | 0;
     v[c >> 2] = b;
     continue;
    }
    break;
   }
   ie(c);
   eb = d + 16 | 0;
   g = eb - 16 | 0;
   eb = g;
   c = ub(g + 12 | 0, v[a + 4 >> 2]);
   d = ub(g + 8 | 0, v[a >> 2]);
   i = v[ub(g + 4 | 0, v[e + 4 >> 2]) >> 2];
   f = eb - 16 | 0;
   eb = f;
   b = eb - 32 | 0;
   eb = b;
   ed(b + 24 | 0, v[c >> 2], v[d >> 2]);
   j = b + 16 | 0;
   d = v[b + 24 >> 2];
   k = v[b + 28 >> 2];
   c = eb - 16 | 0;
   eb = c;
   v[c + 8 >> 2] = i;
   v[c + 12 >> 2] = d;
   while (1) {
    if (Ed(d, k)) {
     d = QV(d);
     yc(QV(v[c + 8 >> 2]), d, 256);
     d = PV(c + 12 | 0);
     PV(c + 8 | 0);
     d = v[d >> 2];
     continue;
    }
    break;
   }
   pc(j, d, c + 8 | 0);
   eb = c + 16 | 0;
   c = v[b + 16 >> 2];
   v[b + 12 >> 2] = v[b + 20 >> 2];
   pc(f + 8 | 0, c, b + 12 | 0);
   eb = b + 32 | 0;
   eb = f + 16 | 0;
   v[e + 4 >> 2] = v[f + 12 >> 2];
   Sb(a, e + 4 | 0);
   Sb(a + 4 | 0, e + 8 | 0);
   Sb(zb(a), mc(e));
   v[e >> 2] = v[e + 4 >> 2];
   eb = g + 16 | 0;
   b = v[e + 4 >> 2];
   a = v[e + 8 >> 2];
   while (1) {
    if ((a | 0) != (b | 0)) {
     a = a - 256 | 0;
     v[e + 8 >> 2] = a;
     continue;
    }
    break;
   }
   a = v[e >> 2];
   if (a) {
    mc(e);
    Bb(a);
   }
  }
  eb = h + 32 | 0;
  return;
 }
 if (b >>> 0 < e >>> 0) {
  Id(a, c + (b << 8) | 0);
 }
}

function Uqa(a) {
 a = a | 0;
 var b = 0, c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0;
 e = v[a >> 2];
 b = Pv(e, v[a + 4 >> 2]);
 if (b >>> 0 <= 63) {
  h = eb - 32 | 0;
  eb = h;
  g = 64 - b | 0;
  b = v[zb(a) >> 2];
  c = v[a + 4 >> 2];
  a: {
   if (g >>> 0 <= (b - c | 0) / 33 >>> 0) {
    e = eb - 16 | 0;
    eb = e;
    b = e + 4 | 0;
    v[b >> 2] = a;
    a = v[a + 4 >> 2];
    v[b + 4 >> 2] = a;
    v[b + 8 >> 2] = a + B(g, 33);
    c = v[b + 4 >> 2];
    a = v[b + 8 >> 2];
    while (1) {
     if ((a | 0) == (c | 0)) {
      hc(b);
      eb = e + 16 | 0;
     } else {
      JY(c);
      c = c + 33 | 0;
      v[b + 4 >> 2] = c;
      continue;
     }
     break;
    }
    break a;
   }
   i = zb(a);
   e = h + 12 | 0;
   f = Pv(v[a >> 2], c) + g | 0;
   c = eb - 16 | 0;
   eb = c;
   v[c + 12 >> 2] = f;
   d = eb - 16 | 0;
   eb = d;
   v[d + 12 >> 2] = 130150524;
   v[d + 8 >> 2] = 2147483647;
   b = v[Gb(d + 12 | 0, d + 8 | 0) >> 2];
   eb = d + 16 | 0;
   b: {
    if (b >>> 0 >= f >>> 0) {
     d = MY(a);
     if (d >>> 0 < b >>> 1 >>> 0) {
      v[c + 8 >> 2] = d << 1;
      b = v[ad(c + 8 | 0, c + 12 | 0) >> 2];
     }
     eb = c + 16 | 0;
     break b;
    }
    dd();
    p();
   }
   f = Pv(v[a >> 2], v[a + 4 >> 2]);
   d = eb - 16 | 0;
   eb = d;
   Kg(e + 12 | 0, i);
   c: {
    if (!b) {
     c = 0;
     b = 0;
     break c;
    }
    if (b >>> 0 >= 130150525) {
     Sj();
     p();
    }
    c = Dc(B(b, 33));
    v[d + 12 >> 2] = b;
    v[d + 8 >> 2] = c;
    c = v[d + 12 >> 2];
    b = v[d + 8 >> 2];
   }
   v[e >> 2] = b;
   f = b + B(f, 33) | 0;
   v[e + 8 >> 2] = f;
   v[e + 4 >> 2] = f;
   l = mc(e), m = b + B(c, 33) | 0, v[l >> 2] = m;
   eb = d + 16 | 0;
   d = eb - 16 | 0;
   eb = d;
   c = v[e + 8 >> 2];
   b = d + 4 | 0;
   v[b + 8 >> 2] = e + 8;
   v[b >> 2] = c;
   v[b + 4 >> 2] = c + B(g, 33);
   c = v[b >> 2];
   while (1) {
    if (v[b + 4 >> 2] != (c | 0)) {
     JY(c);
     c = v[b >> 2] + 33 | 0;
     v[b >> 2] = c;
     continue;
    }
    break;
   }
   ie(b);
   eb = d + 16 | 0;
   g = eb - 16 | 0;
   eb = g;
   b = ub(g + 12 | 0, v[a + 4 >> 2]);
   d = ub(g + 8 | 0, v[a >> 2]);
   i = v[ub(g + 4 | 0, v[e + 4 >> 2]) >> 2];
   f = eb - 16 | 0;
   eb = f;
   c = eb - 32 | 0;
   eb = c;
   ed(c + 24 | 0, v[b >> 2], v[d >> 2]);
   j = c + 16 | 0;
   b = v[c + 24 >> 2];
   k = v[c + 28 >> 2];
   d = eb - 16 | 0;
   eb = d;
   v[d + 8 >> 2] = i;
   v[d + 12 >> 2] = b;
   while (1) {
    if (Ed(b, k)) {
     b = LY(b);
     yc(LY(v[d + 8 >> 2]), b, 33);
     b = KY(d + 12 | 0);
     KY(d + 8 | 0);
     b = v[b >> 2];
     continue;
    }
    break;
   }
   pc(j, b, d + 8 | 0);
   eb = d + 16 | 0;
   b = v[c + 16 >> 2];
   v[c + 12 >> 2] = v[c + 20 >> 2];
   pc(f + 8 | 0, b, c + 12 | 0);
   eb = c + 32 | 0;
   eb = f + 16 | 0;
   v[e + 4 >> 2] = v[f + 12 >> 2];
   Sb(a, e + 4 | 0);
   Sb(a + 4 | 0, e + 8 | 0);
   Sb(zb(a), mc(e));
   v[e >> 2] = v[e + 4 >> 2];
   eb = g + 16 | 0;
   b = v[e + 4 >> 2];
   a = v[e + 8 >> 2];
   while (1) {
    if ((a | 0) != (b | 0)) {
     a = a - 33 | 0;
     v[e + 8 >> 2] = a;
     continue;
    }
    break;
   }
   a = v[e >> 2];
   if (a) {
    mc(e);
    Bb(a);
   }
  }
  eb = h + 32 | 0;
  return;
 }
 if ((b | 0) != 64) {
  Id(a, e + 2112 | 0);
 }
}

function Lz(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = C(0);
 e = eb - 48 | 0;
 eb = e;
 a: {
  b: {
   c: {
    d: {
     e: {
      switch (b - 1 | 0) {
      case 1:
       b = (c << 7) / 100 | 0;
       d = v[a + 24 >> 2];
       if ((b | 0) == v[d + 24604 >> 2]) {
        break d;
       }
       a = e + 8 | 0;
       yc(a, d + 24604 | 0, 40);
       v[e + 8 >> 2] = b;
       OA(d, a);
       break d;

      case 2:
       f = v[a + 24 >> 2];
       d = f + 24664 | 0;
       b = v[d + 4 >> 2];
       v[e + 24 >> 2] = v[d >> 2];
       v[e + 28 >> 2] = b;
       d = f + 24656 | 0;
       b = v[d + 4 >> 2];
       v[e + 16 >> 2] = v[d >> 2];
       v[e + 20 >> 2] = b;
       b = v[f + 24652 >> 2];
       v[e + 8 >> 2] = v[f + 24648 >> 2];
       v[e + 12 >> 2] = b;
       d = eb - 16 | 0;
       eb = d;
       b = 3;
       f: {
        g: {
         h: {
          if (!c | (c | 0) > 7) {
           break h;
          }
          b = 2;
          if ((c | 0) > 2) {
           break h;
          }
          b = 1;
          if ((c | 0) == 2) {
           break h;
          }
          b = 0;
          if ((c | 0) > 0) {
           break h;
          }
          c = cc(8);
          v[31601] = 0;
          b = O(36, d + 4 | 0, 10830) | 0;
          a = v[31601];
          v[31601] = 0;
          i: {
           if ((a | 0) != 1) {
            rc(c, b);
            v[31601] = 0;
            R(97, c | 0, 48396, 999);
            a = v[31601];
            v[31601] = 0;
            if ((a | 0) != 1) {
             break g;
            }
            a = M() | 0;
            sb(b);
            break i;
           }
           a = M() | 0;
           jc(c);
          }
          P(a | 0);
          p();
         }
         eb = d + 16 | 0;
         break f;
        }
        p();
       }
       t[e + 8 | 0] = b;
       b = e + 8 | 0;
       a = v[a + 24 >> 2];
       if (!Az(b, a + 24648 | 0)) {
        break d;
       }
       MA(a, b);
       break d;

      case 3:
       f = e + 8 | 0;
       d = v[a + 24 >> 2];
       yc(f, d + 24604 | 0, 40);
       b = eb - 48 | 0;
       eb = b;
       j: {
        if ((c | 0) == -1) {
         du(f, v[Tq(b + 8 | 0) + 32 >> 2]);
         No(f, v[Tq(b + 8 | 0) + 36 >> 2]);
         break j;
        }
        if ((c | 0) <= 0) {
         du(f, 0);
         No(f, 0);
         break j;
        }
        a = B(c, 1e3);
        du(f, a);
        No(f, a);
       }
       eb = b + 48 | 0;
       if (v[d + 24636 >> 2] == v[e + 40 >> 2] & v[d + 24640 >> 2] == v[e + 44 >> 2]) {
        break d;
       }
       OA(d, e + 8 | 0);
       break d;

      default:
       d = cc(8);
       v[31601] = 0;
       c = O(36, e + 8 | 0, 10385) | 0;
       a = v[31601];
       v[31601] = 0;
       if ((a | 0) == 1) {
        break c;
       }
       rc(d, c);
       v[31601] = 0;
       R(97, d | 0, 48396, 999);
       a = v[31601];
       v[31601] = 0;
       if ((a | 0) != 1) {
        break a;
       }
       b = M() | 0;
       sb(c);
       break b;

      case 0:
       break e;
      }
     }
     g = a, h = De(C(10), C(C(C(c | 0) * C(.0010000000474974513)) * C(.5))), z[g + 48 >> 2] = h;
    }
    eb = e + 48 | 0;
    return;
   }
   b = M() | 0;
   jc(d);
  }
  P(b | 0);
 }
 p();
}

function _6(a, b, c, d, e, f, g, h, i, j, k, l, m, n, o) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 f = f | 0;
 g = g | 0;
 h = h | 0;
 i = i | 0;
 j = j | 0;
 k = k | 0;
 l = l | 0;
 m = m | 0;
 n = n | 0;
 o = o | 0;
 var p = 0, q = 0, r = 0, s = 0, u = 0, x = 0, y = 0, z = 0, A = 0, B = 0, C = 0;
 v[c >> 2] = a;
 y = h ? 4 : 0;
 z = d & 512;
 while (1) {
  if ((x | 0) == 4) {
   if (Cb(v[n + 4 >> 2], w[n + 11 | 0]) >>> 0 > 1) {
    B = c, C = KJ(Dk(yd(n), 1), ll(n), v[c >> 2]), v[B >> 2] = C;
   }
   d = d & 176;
   if ((d | 0) != 16) {
    if ((d | 0) == 32) {
     a = v[c >> 2];
    }
    v[b >> 2] = a;
   }
  } else {
   a: {
    b: {
     switch (w[i + x | 0]) {
     case 0:
      v[b >> 2] = v[c >> 2];
      break a;

     case 1:
      v[b >> 2] = v[c >> 2];
      h = Bt(g, 32);
      p = v[c >> 2];
      v[c >> 2] = p + 4;
      v[p >> 2] = h;
      break a;

     case 3:
      if (zd(v[n + 4 >> 2], w[n + 11 | 0])) {
       break a;
      }
      h = v[Vd(n, 0) >> 2];
      p = v[c >> 2];
      v[c >> 2] = p + 4;
      v[p >> 2] = h;
      break a;

     case 2:
      if (zd(v[m + 4 >> 2], w[m + 11 | 0]) | !z) {
       break a;
      }
      B = c, C = KJ(yd(m), ll(m), v[c >> 2]), v[B >> 2] = C;
      break a;

     case 4:
      break b;

     default:
      break a;
     }
    }
    A = v[c >> 2];
    e = e + y | 0;
    h = e;
    while (1) {
     c: {
      if (f >>> 0 <= h >>> 0) {
       break c;
      }
      if (!nj(g, 64, v[h >> 2])) {
       break c;
      }
      h = h + 4 | 0;
      continue;
     }
     break;
    }
    if ((o | 0) > 0) {
     p = v[c >> 2];
     q = o;
     while (1) {
      if (!(!q | e >>> 0 >= h >>> 0)) {
       q = q - 1 | 0;
       h = h - 4 | 0;
       s = v[h >> 2];
       r = p + 4 | 0;
       v[c >> 2] = r;
       v[p >> 2] = s;
       p = r;
       continue;
      }
      break;
     }
     d: {
      if (!q) {
       s = 0;
       break d;
      }
      s = Bt(g, 48);
      p = v[c >> 2];
     }
     while (1) {
      r = p + 4 | 0;
      if ((q | 0) > 0) {
       v[p >> 2] = s;
       q = q - 1 | 0;
       p = r;
       continue;
      }
      break;
     }
     v[c >> 2] = r;
     v[p >> 2] = j;
    }
    e: {
     if ((e | 0) == (h | 0)) {
      p = Bt(g, 48);
      q = v[c >> 2];
      h = q + 4 | 0;
      v[c >> 2] = h;
      v[q >> 2] = p;
      break e;
     }
     s = -1;
     if (!zd(v[l + 4 >> 2], w[l + 11 | 0])) {
      s = t[dc(l, 0) | 0];
     }
     q = 0;
     u = 0;
     while (1) {
      if ((e | 0) != (h | 0)) {
       r = v[c >> 2];
       f: {
        if ((q | 0) != (s | 0)) {
         p = r;
         r = q;
         break f;
        }
        p = r + 4 | 0;
        v[c >> 2] = p;
        v[r >> 2] = k;
        r = 0;
        u = u + 1 | 0;
        if (Cb(v[l + 4 >> 2], w[l + 11 | 0]) >>> 0 <= u >>> 0) {
         s = q;
         break f;
        }
        s = -1;
        if (w[dc(l, u) | 0] == 127) {
         break f;
        }
        s = t[dc(l, u) | 0];
       }
       h = h - 4 | 0;
       q = v[h >> 2];
       v[c >> 2] = p + 4;
       v[p >> 2] = q;
       q = r + 1 | 0;
       continue;
      }
      break;
     }
     h = v[c >> 2];
    }
    vt(A, h);
   }
   x = x + 1 | 0;
   continue;
  }
  break;
 }
}

function gma(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, w = 0, x = 0, y = 0, z = 0, A = 0, C = 0, D = 0, E = 0, F = 0, G = 0, H = 0;
 f = eb - 48 | 0;
 eb = f;
 h = v[a + 8 >> 2];
 o = h;
 i = v[a + 12 >> 2];
 j = i;
 a: {
  b: {
   if ((j | 0) <= 1 & h >>> 0 <= 805306368 | (j | 0) <= 0) {
    i = 131112;
    h = j;
    if ((j | 0) > -2) {
     e = 1;
    } else {
     e = (h | 0) >= -2 & o >>> 0 >= 3489660928;
    }
    if (e) {
     break a;
    }
    i = 262184;
    if ((j | 0) == -2 & o >>> 0 < 2147483648 | j >>> 0 < 4294967294) {
     break a;
    }
    break b;
   }
   i = 262184;
   if ((j | 0) == 1 & o >>> 0 > 2147483648 | j >>> 0 > 1) {
    break a;
   }
  }
  i = 196648;
 }
 x = v[a + 16 >> 2];
 v[f + 32 >> 2] = v[a + 44 >> 2];
 v[f + 36 >> 2] = v[a + 48 >> 2];
 v[f + 40 >> 2] = v[a + 52 >> 2];
 v[f + 44 >> 2] = v[a + 56 >> 2];
 y = v[a + 24 >> 2];
 z = v[a + 20 >> 2];
 h = v[a + 4 >> 2];
 v[f + 16 >> 2] = v[a >> 2];
 v[f + 20 >> 2] = h;
 A = b + i | 0;
 C = f + 32 | 0;
 D = v[a + 72 >> 2];
 w = v[a + 68 >> 2];
 E = w >> 31;
 i = v[a + 64 >> 2];
 F = i >> 31;
 h = v[a + 60 >> 2];
 G = h >> 31;
 while (1) {
  if (d) {
   b = v[f + 16 >> 2];
   p = ((((v[f + 20 >> 2] & 2147483647) << 1 | b >>> 31) & 2147483646) << 1) + x | 0;
   b = (b >>> 16 & 65520) + A | 0;
   H = u[b + 14 >> 1];
   l = u[b + 12 >> 1];
   q = u[b + 10 >> 1];
   t = u[b + 8 >> 1];
   g = u[b + 6 >> 1];
   r = u[b + 4 >> 1];
   k = u[b + 2 >> 1];
   e = u[b >> 1];
   m = 0;
   b = 0;
   while (1) {
    if ((b | 0) != 2) {
     s = b << 1;
     n = s + p | 0;
     v[(f + 8 | 0) + (b << 2) >> 2] = (((((((B(u[p + (s | -8) >> 1], k) + B(u[p + (s | -12) >> 1], e) | 0) + B(u[p + (s | -4) >> 1], r) | 0) + B(u[n >> 1], g) | 0) + B(u[n + 4 >> 1], t) | 0) + B(u[n + 8 >> 1], q) | 0) + B(l, u[n + 12 >> 1]) | 0) + B(H, u[n + 16 >> 1]) | 0) / 32768;
     b = b + 1 | 0;
     continue;
    }
    break;
   }
   while (1) {
    if ((m | 0) != 2) {
     q = (f + 8 | 0) + (m << 2) | 0;
     e = v[q >> 2];
     b = (m << 3) + C | 0;
     t = v[b + 4 >> 2];
     g = v[b >> 2];
     v[b + 4 >> 2] = g;
     r = e << 8;
     e = r;
     e = Aua(e, e >> 31, h, G);
     k = gb;
     l = e;
     e = Xb(g, -16777216, 16776704);
     e = Aua(i, F, e, e >> 31);
     g = l + e | 0;
     l = gb + k | 0;
     l = e >>> 0 > g >>> 0 ? l + 1 | 0 : l;
     e = Xb(t, -16777216, 16776704);
     k = Aua(w, E, e, e >> 31);
     g = k + g | 0;
     e = gb + l | 0;
     e = g >>> 0 < k >>> 0 ? e + 1 | 0 : e;
     k = g + 8388608 | 0;
     e = k >>> 0 < 8388608 ? e + 1 | 0 : e;
     e = Rc(k, e, 24);
     v[b >> 2] = e - (r & D);
     v[q >> 2] = (e | 0) / 256;
     m = m + 1 | 0;
     continue;
    }
    break;
   }
   v[c >> 2] = v[c >> 2] + B(v[f + 8 >> 2], z);
   v[c + 4 >> 2] = v[c + 4 >> 2] + B(v[f + 12 >> 2], y);
   Ob(f + 16 | 0, o, j);
   c = c + 8 | 0;
   d = d - 1 | 0;
   continue;
  }
  break;
 }
 b = v[f + 20 >> 2];
 v[a >> 2] = v[f + 16 >> 2];
 v[a + 4 >> 2] = b;
 v[a + 44 >> 2] = v[f + 32 >> 2];
 v[a + 48 >> 2] = v[f + 36 >> 2];
 v[a + 52 >> 2] = v[f + 40 >> 2];
 v[a + 56 >> 2] = v[f + 44 >> 2];
 eb = f + 48 | 0;
}

function Uz(a) {
 a = a | 0;
 var b = 0, c = 0, d = C(0), e = 0;
 Qb(a + 4960 | 0, 0, 76);
 t[a + 5044 | 0] = 0;
 v[a + 5036 >> 2] = 0;
 v[a + 5040 >> 2] = 0;
 b = v[a + 4292 >> 2];
 d = z[a + 4268 >> 2];
 v[31601] = 0;
 e = a + 4504 | 0;
 if (d < C(4294967296) & d >= C(0)) {
  c = ~~d >>> 0;
 } else {
  c = 0;
 }
 $(972, e | 0, 67, 5, c | 0, b | 0);
 b = v[31601];
 v[31601] = 0;
 a: {
  if ((b | 0) == 1) {
   break a;
  }
  b = v[a + 4296 >> 2];
  v[31601] = 0;
  $(972, a + 4528 | 0, 62, 5, c | 0, b | 0);
  b = v[31601];
  v[31601] = 0;
  if ((b | 0) == 1) {
   break a;
  }
  b = v[a + 4300 >> 2];
  v[31601] = 0;
  $(972, a + 4552 | 0, 53, 5, c | 0, b | 0);
  b = v[31601];
  v[31601] = 0;
  if ((b | 0) == 1) {
   break a;
  }
  b = v[a + 4304 >> 2];
  v[31601] = 0;
  $(972, a + 4576 | 0, 43, 5, c | 0, b | 0);
  b = v[31601];
  v[31601] = 0;
  if ((b | 0) == 1) {
   break a;
  }
  b = v[a + 4308 >> 2];
  v[31601] = 0;
  $(972, a + 4600 | 0, 32, 5, c | 0, b | 0);
  b = v[31601];
  v[31601] = 0;
  if ((b | 0) == 1) {
   break a;
  }
  b = v[a + 4312 >> 2];
  v[31601] = 0;
  $(972, a + 4624 | 0, 22, 5, c | 0, b | 0);
  b = v[31601];
  v[31601] = 0;
  if ((b | 0) == 1) {
   break a;
  }
  b = v[a + 4316 >> 2];
  v[31601] = 0;
  $(972, a + 4648 | 0, 75, 5, c | 0, b | 0);
  b = v[31601];
  v[31601] = 0;
  if ((b | 0) == 1) {
   break a;
  }
  b = v[a + 4320 >> 2];
  v[31601] = 0;
  $(972, a + 4672 | 0, 69, 5, c | 0, b | 0);
  b = v[31601];
  v[31601] = 0;
  if ((b | 0) == 1) {
   break a;
  }
  b = v[a + 4324 >> 2];
  v[31601] = 0;
  $(972, a + 4696 | 0, 60, 5, c | 0, b | 0);
  b = v[31601];
  v[31601] = 0;
  if ((b | 0) == 1) {
   break a;
  }
  b = v[a + 4328 >> 2];
  v[31601] = 0;
  $(972, a + 4720 | 0, 48, 5, c | 0, b | 0);
  b = v[31601];
  v[31601] = 0;
  if ((b | 0) == 1) {
   break a;
  }
  b = v[a + 4332 >> 2];
  v[31601] = 0;
  $(972, a + 4744 | 0, 36, 5, c | 0, b | 0);
  b = v[31601];
  v[31601] = 0;
  if ((b | 0) == 1) {
   break a;
  }
  b = v[a + 4336 >> 2];
  v[31601] = 0;
  $(972, a + 4768 | 0, 25, 5, c | 0, b | 0);
  b = v[31601];
  v[31601] = 0;
  if ((b | 0) == 1) {
   break a;
  }
  v[31601] = 0;
  $(972, a + 4792 | 0, 0, 0, 0, 0);
  b = v[31601];
  v[31601] = 0;
  if ((b | 0) == 1) {
   break a;
  }
  b = v[a + 4344 >> 2];
  v[31601] = 0;
  $(972, a + 4816 | 0, 3, 0, c | 0, b | 0);
  b = v[31601];
  v[31601] = 0;
  if ((b | 0) == 1) {
   break a;
  }
  b = v[a + 4348 >> 2];
  v[31601] = 0;
  $(972, a + 4840 | 0, 3, 0, c | 0, b | 0);
  b = v[31601];
  v[31601] = 0;
  if ((b | 0) == 1) {
   break a;
  }
  v[31601] = 0;
  $(972, a + 4864 | 0, 407, 1, c | 0, 0);
  b = v[31601];
  v[31601] = 0;
  if ((b | 0) == 1) {
   break a;
  }
  v[31601] = 0;
  $(972, a + 4888 | 0, 400, 1, c | 0, 0);
  b = v[31601];
  v[31601] = 0;
  if ((b | 0) == 1) {
   break a;
  }
  v[31601] = 0;
  $(972, a + 4912 | 0, 10, 0, c | 0, -1);
  b = v[31601];
  v[31601] = 0;
  if ((b | 0) == 1) {
   break a;
  }
  v[31601] = 0;
  $(972, a + 4936 | 0, 10, 0, c | 0, -1);
  c = v[31601];
  v[31601] = 0;
  if ((c | 0) == 1) {
   break a;
  }
  t[a + 5045 | 0] = 1;
  return;
 }
 c = S(124508) | 0;
 if ((fb | 0) == (_(124508) | 0)) {
  X(c | 0) | 0;
  t[a + 5045 | 0] = 0;
  Y();
  return;
 }
 P(c | 0);
 p();
}

function Cla(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, w = 0, x = 0, y = 0, z = 0, A = 0, C = 0, D = 0, E = 0, F = 0, G = 0, H = 0, I = 0;
 e = eb - 48 | 0;
 eb = e;
 y = v[a + 16 >> 2];
 z = Fg(b + 327720 | 0, v[b + 20 >> 2], (v[a + 88 >> 2] & 16384) >>> 14 | 0);
 n = v[a + 8 >> 2];
 o = v[a + 12 >> 2];
 b = v[a >> 2];
 h = v[a + 4 >> 2];
 p = v[a + 128 >> 2];
 if (p) {
  q = Gg(n, o, p);
  r = gb;
  i = v[a + 76 >> 2];
  eg(b, h, uf(n, o, d), gb);
  s = gb >>> 0 > i >>> 0 ? d : 0;
 }
 j = a + 112 | 0;
 v[e + 24 >> 2] = v[a + 44 >> 2];
 v[e + 28 >> 2] = v[a + 48 >> 2];
 v[e + 32 >> 2] = v[a + 52 >> 2];
 v[e + 36 >> 2] = v[a + 56 >> 2];
 A = v[a + 24 >> 2];
 C = v[a + 20 >> 2];
 v[e + 8 >> 2] = b;
 v[e + 12 >> 2] = h;
 D = e + 24 | 0;
 a: while (1) {
  if (d) {
   d = d - 1 | 0;
   g = v[e + 12 >> 2];
   b = v[e + 8 >> 2];
   v[e + 40 >> 2] = b;
   v[e + 44 >> 2] = 0;
   s = s - 1 | 0;
   i = s;
   q = i ? q : 0;
   r = i ? r : 0;
   h = ((((g & 2147483647) << 1 | b >>> 31) & 2147483646) << 1) + y | 0;
   b = p;
   while (1) if ((b | 0) <= 0) {
    Ob(j, v[a + 120 >> 2], v[a + 124 >> 2]);
    i = v[a + 116 >> 2];
    if (i) {
     b = v[e + 40 >> 2];
     b = (v[e + 44 >> 2] & 2147483647) << 1 | b >>> 31;
     be(j, (u[((b & 2147483646) << 1) + h >> 1] + u[h + (b << 1 | 2) >> 1] | 0) / 8 << 16 >> 16);
     ae(j, i);
     v[j >> 2] = v[j >> 2];
     v[j + 4 >> 2] = 0;
    }
    b = Eg(j, z);
    v[e + 4 >> 2] = b;
    v[e >> 2] = b;
    E = v[a + 72 >> 2];
    t = v[a + 68 >> 2];
    F = t >> 31;
    h = v[a + 64 >> 2];
    G = h >> 31;
    i = v[a + 60 >> 2];
    H = i >> 31;
    b = 0;
    while (1) {
     if ((b | 0) != 2) {
      w = (b << 2) + e | 0;
      f = v[w >> 2];
      g = (b << 3) + D | 0;
      I = v[g + 4 >> 2];
      k = v[g >> 2];
      v[g + 4 >> 2] = k;
      x = f << 8;
      f = x;
      f = Aua(f, f >> 31, i, H);
      l = gb;
      m = f;
      f = Xb(k, -16777216, 16776704);
      f = Aua(h, G, f, f >> 31);
      k = m + f | 0;
      m = gb + l | 0;
      m = f >>> 0 > k >>> 0 ? m + 1 | 0 : m;
      f = Xb(I, -16777216, 16776704);
      l = Aua(t, F, f, f >> 31);
      k = l + k | 0;
      f = gb + m | 0;
      f = k >>> 0 < l >>> 0 ? f + 1 | 0 : f;
      l = k + 8388608 | 0;
      f = l >>> 0 < 8388608 ? f + 1 | 0 : f;
      f = Rc(l, f, 24);
      v[g >> 2] = f - (E & x);
      v[w >> 2] = (f | 0) / 256;
      b = b + 1 | 0;
      continue;
     }
     break;
    }
    v[c >> 2] = v[c >> 2] + B(v[e >> 2], C);
    v[c + 4 >> 2] = v[c + 4 >> 2] + B(v[e + 4 >> 2], A);
    Ob(e + 8 | 0, n, o);
    c = c + 8 | 0;
    continue a;
   } else {
    g = v[e + 40 >> 2];
    g = (v[e + 44 >> 2] & 2147483647) << 1 | g >>> 31;
    be(j, (u[((g & 2147483646) << 1) + h >> 1] + u[h + (g << 1 | 2) >> 1] | 0) / 8 << 16 >> 16);
    ae(j, 4);
    Ob(e + 40 | 0, q, r);
    b = b - 1 | 0;
    continue;
   }
  }
  break;
 }
 b = v[e + 12 >> 2];
 v[a >> 2] = v[e + 8 >> 2];
 v[a + 4 >> 2] = b;
 v[a + 44 >> 2] = v[e + 24 >> 2];
 v[a + 48 >> 2] = v[e + 28 >> 2];
 v[a + 52 >> 2] = v[e + 32 >> 2];
 v[a + 56 >> 2] = v[e + 36 >> 2];
 eb = e + 48 | 0;
}

function V6(a, b, c, d, e, f, g, h) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 f = f | 0;
 g = g | 0;
 h = h | 0;
 var i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0;
 n = eb - 16 | 0;
 eb = n;
 b = c;
 while (1) {
  a: {
   if ((b | 0) == (d | 0)) {
    b = d;
    break a;
   }
   if (!v[b >> 2]) {
    break a;
   }
   b = b + 4 | 0;
   continue;
  }
  break;
 }
 v[h >> 2] = f;
 v[e >> 2] = c;
 while (1) {
  b: {
   c: {
    if (!((c | 0) == (d | 0) | (f | 0) == (g | 0))) {
     q = 1;
     r = eb - 16 | 0;
     eb = r;
     s = qh(r + 12 | 0, v[a + 8 >> 2]);
     i = f;
     j = g - f | 0;
     m = 0;
     o = eb - 16 | 0;
     eb = o;
     k = v[e >> 2];
     p = b - c >> 2;
     d: {
      if (!k | !p) {
       break d;
      }
      j = f ? j : 0;
      while (1) {
       l = It(j >>> 0 < 4 ? o + 12 | 0 : i, v[k >> 2]);
       if ((l | 0) == -1) {
        m = -1;
        break d;
       }
       if (i) {
        if (j >>> 0 <= 3) {
         if (j >>> 0 < l >>> 0) {
          break d;
         }
         yc(i, o + 12 | 0, l);
        }
        j = j - l | 0;
        i = i + l | 0;
       } else {
        i = 0;
       }
       if (!v[k >> 2]) {
        k = 0;
        break d;
       }
       m = m + l | 0;
       k = k + 4 | 0;
       p = p - 1 | 0;
       if (p) {
        continue;
       }
       break;
      }
     }
     if (i) {
      v[e >> 2] = k;
     }
     eb = o + 16 | 0;
     ph(s);
     eb = r + 16 | 0;
     e: {
      f: {
       g: {
        h: {
         switch (m + 1 | 0) {
         case 0:
          v[h >> 2] = f;
          while (1) {
           i: {
            if (v[e >> 2] == (c | 0)) {
             break i;
            }
            b = qy(f, v[c >> 2], v[a + 8 >> 2]);
            if ((b | 0) == -1) {
             break i;
            }
            f = b + v[h >> 2] | 0;
            v[h >> 2] = f;
            c = c + 4 | 0;
            continue;
           }
           break;
          }
          ;
          v[e >> 2] = c;
          break g;

         case 1:
          break c;

         default:
          break h;
         }
        }
        f = v[h >> 2] + m | 0;
        v[h >> 2] = f;
        if ((f | 0) == (g | 0)) {
         break e;
        }
        if ((b | 0) == (d | 0)) {
         c = v[e >> 2];
         b = d;
         continue;
        }
        b = qy(n + 12 | 0, 0, v[a + 8 >> 2]);
        if ((b | 0) != -1) {
         break f;
        }
       }
       q = 2;
       break c;
      }
      c = n + 12 | 0;
      if (g - v[h >> 2] >>> 0 < b >>> 0) {
       break c;
      }
      while (1) {
       if (b) {
        f = w[c | 0];
        i = v[h >> 2];
        v[h >> 2] = i + 1;
        t[i | 0] = f;
        b = b - 1 | 0;
        c = c + 1 | 0;
        continue;
       }
       break;
      }
      c = v[e >> 2] + 4 | 0;
      v[e >> 2] = c;
      b = c;
      while (1) {
       if ((b | 0) == (d | 0)) {
        b = d;
        break b;
       }
       if (!v[b >> 2]) {
        break b;
       }
       b = b + 4 | 0;
       continue;
      }
     }
     c = v[e >> 2];
    }
    q = (c | 0) != (d | 0);
   }
   eb = n + 16 | 0;
   return q | 0;
  }
  f = v[h >> 2];
  continue;
 }
}

function hma(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, w = 0, x = 0, y = 0, z = 0, A = 0, C = 0, D = 0, E = 0, F = 0, G = 0, H = 0;
 f = eb - 48 | 0;
 eb = f;
 g = v[a + 8 >> 2];
 o = g;
 j = v[a + 12 >> 2];
 l = j;
 a: {
  b: {
   if ((l | 0) <= 1 & g >>> 0 <= 805306368 | (l | 0) <= 0) {
    j = 131112;
    g = l;
    if ((g | 0) > -2) {
     e = 1;
    } else {
     e = (g | 0) >= -2 & o >>> 0 >= 3489660928;
    }
    if (e) {
     break a;
    }
    j = 262184;
    if ((l | 0) == -2 & o >>> 0 < 2147483648 | l >>> 0 < 4294967294) {
     break a;
    }
    break b;
   }
   j = 262184;
   if ((l | 0) == 1 & o >>> 0 > 2147483648 | l >>> 0 > 1) {
    break a;
   }
  }
  j = 196648;
 }
 x = v[a + 16 >> 2];
 v[f + 32 >> 2] = v[a + 44 >> 2];
 v[f + 36 >> 2] = v[a + 48 >> 2];
 v[f + 40 >> 2] = v[a + 52 >> 2];
 v[f + 44 >> 2] = v[a + 56 >> 2];
 y = v[a + 24 >> 2];
 z = v[a + 20 >> 2];
 g = v[a + 4 >> 2];
 v[f + 16 >> 2] = v[a >> 2];
 v[f + 20 >> 2] = g;
 A = b + j | 0;
 C = f + 32 | 0;
 D = v[a + 72 >> 2];
 s = v[a + 68 >> 2];
 E = s >> 31;
 w = v[a + 64 >> 2];
 F = w >> 31;
 j = v[a + 60 >> 2];
 G = j >> 31;
 while (1) {
  if (d) {
   b = v[f + 16 >> 2];
   H = (((v[f + 20 >> 2] & 2147483647) << 1 | b >>> 31) & -2) + x | 0;
   b = (b >>> 16 & 65520) + A | 0;
   m = u[b + 14 >> 1];
   p = u[b + 12 >> 1];
   r = u[b + 10 >> 1];
   h = u[b + 8 >> 1];
   q = u[b + 6 >> 1];
   k = u[b + 4 >> 1];
   e = u[b + 2 >> 1];
   g = u[b >> 1];
   b = 0;
   n = 0;
   while (1) {
    if ((n | 0) != 2) {
     i = n + H | 0;
     v[(f + 8 | 0) + (n << 2) >> 2] = (((((((B(t[i - 4 | 0], e) + B(t[i - 6 | 0], g) | 0) + B(t[i - 2 | 0], k) | 0) + B(t[i | 0], q) | 0) + B(t[i + 2 | 0], h) | 0) + B(t[i + 4 | 0], r) | 0) + B(p, t[i + 6 | 0]) | 0) + B(m, t[i + 8 | 0]) << 8) / 32768;
     n = n + 1 | 0;
     continue;
    }
    break;
   }
   while (1) {
    if ((b | 0) != 2) {
     p = (f + 8 | 0) + (b << 2) | 0;
     e = v[p >> 2];
     g = (b << 3) + C | 0;
     r = v[g + 4 >> 2];
     h = v[g >> 2];
     v[g + 4 >> 2] = h;
     q = e << 8;
     e = q;
     e = Aua(e, e >> 31, j, G);
     k = gb;
     i = e;
     e = Xb(h, -16777216, 16776704);
     e = Aua(w, F, e, e >> 31);
     h = i + e | 0;
     m = gb + k | 0;
     m = e >>> 0 > h >>> 0 ? m + 1 | 0 : m;
     e = Xb(r, -16777216, 16776704);
     k = Aua(s, E, e, e >> 31);
     h = k + h | 0;
     e = gb + m | 0;
     e = h >>> 0 < k >>> 0 ? e + 1 | 0 : e;
     k = h + 8388608 | 0;
     e = k >>> 0 < 8388608 ? e + 1 | 0 : e;
     e = Rc(k, e, 24);
     v[g >> 2] = e - (q & D);
     v[p >> 2] = (e | 0) / 256;
     b = b + 1 | 0;
     continue;
    }
    break;
   }
   v[c >> 2] = v[c >> 2] + B(v[f + 8 >> 2], z);
   v[c + 4 >> 2] = v[c + 4 >> 2] + B(v[f + 12 >> 2], y);
   Ob(f + 16 | 0, o, l);
   c = c + 8 | 0;
   d = d - 1 | 0;
   continue;
  }
  break;
 }
 b = v[f + 20 >> 2];
 v[a >> 2] = v[f + 16 >> 2];
 v[a + 4 >> 2] = b;
 v[a + 44 >> 2] = v[f + 32 >> 2];
 v[a + 48 >> 2] = v[f + 36 >> 2];
 v[a + 52 >> 2] = v[f + 40 >> 2];
 v[a + 56 >> 2] = v[f + 44 >> 2];
 eb = f + 48 | 0;
}

function zh(a, b, c, d, e) {
 var f = 0, g = 0, h = 0;
 if (!b) {
  c = eb - 16 | 0;
  eb = c;
  a: {
   if ((d | 0) == 189) {
    t[a + 3843 | 0] = e >>> 7;
    t[a + 3844 | 0] = e >>> 6 & 1;
    break a;
   }
   b = d & 224;
   if (!b) {
    if ((d | 0) != 260) {
     break a;
    }
    h = a + 16 | 0;
    a = 0;
    b = 1;
    while (1) {
     if ((a | 0) == 6) {
      break a;
     }
     d = h + B(a >>> 0 < 3 ? a : a + 6 | 0, 44) | 0;
     f = d + 132 | 0;
     g = b & e;
     b: {
      if (g) {
       No(d, f);
       break b;
      }
      No(d, 0);
     }
     t[f + 40 | 0] = !g;
     a = a + 1 | 0;
     b = b << 1 & 510;
     continue;
    }
   }
   if (b - 160 >>> 0 <= 32) {
    b = d & 15;
    if (b >>> 0 > 8) {
     break a;
    }
    a = B(d & 256 ? b + 9 | 0 : b, 44) + a | 0;
    v[c + 8 >> 2] = a + 16;
    b = v[a + 52 >> 2];
    v[c + 12 >> 2] = b;
    f = b ? 2 : 1;
    c: {
     b = d & 240;
     if ((b | 0) != 160) {
      if ((b | 0) == 192) {
       break c;
      }
      if ((b | 0) != 176) {
       break a;
      }
      h = e & 3;
      g = e >>> 2 & 7;
      a = 0;
      d = (e & 32) != 0;
      while (1) {
       if ((a | 0) == (f | 0)) {
        break a;
       }
       b = v[(c + 8 | 0) + (a << 2) >> 2];
       DU(v[b >> 2], d);
       DU(v[b + 4 >> 2], d);
       u[b + 22 >> 1] = g;
       WB(b);
       FU(b);
       t[b + 21 | 0] = h;
       WB(b);
       FU(b);
       a = a + 1 | 0;
       continue;
      }
     }
     a = 0;
     while (1) {
      if ((a | 0) == (f | 0)) {
       break a;
      }
      b = v[(c + 8 | 0) + (a << 2) >> 2];
      u[b + 20 >> 1] = x[b + 20 >> 1] & 768 | e & 255;
      WB(b);
      a = a + 1 | 0;
      continue;
     }
    }
    t[a + 58 | 0] = (e & 32) >>> 5;
    t[a + 57 | 0] = (e & 16) >>> 4;
    b = e >>> 1 & 7;
    u[a + 46 >> 1] = b ? 9 - b | 0 : 0;
    u[a + 48 >> 1] = e & 1;
    break a;
   }
   if ((b | 0) != 224 & b >>> 0 >= 129 | -4144960 >>> d & 1) {
    break a;
   }
   f = a;
   a = t[(d & 31) + 27328 | 0];
   a = (f + B(d & 256 ? a + 18 | 0 : a, 84) | 0) + 808 | 0;
   d: {
    switch (b - 32 >>> 5 | 0) {
    case 0:
     t[a + 79 | 0] = e >>> 7;
     t[a + 80 | 0] = (e & 64) >>> 6;
     t[a + 78 | 0] = (e & 32) >>> 5;
     t[a + 77 | 0] = (e & 16) >>> 4;
     Oo(a);
     b = eb - 32 | 0;
     v[b + 24 >> 2] = 1572888;
     v[b + 28 >> 2] = 1966110;
     v[b + 16 >> 2] = 1179664;
     v[b + 20 >> 2] = 1310740;
     v[b + 8 >> 2] = 655368;
     v[b + 12 >> 2] = 917516;
     v[b >> 2] = 131073;
     v[b + 4 >> 2] = 393220;
     u[a + 14 >> 1] = x[b + ((e & 15) << 1) >> 1];
     break a;

    case 1:
     u[a + 68 >> 1] = w[(e >>> 6 | 0) + 22241 | 0];
     EU(a);
     u[a + 22 >> 1] = (e & 63) << 2;
     break a;

    case 2:
     u[a + 24 >> 1] = e >>> 4;
     Oo(a);
     u[a + 26 >> 1] = e & 15;
     Oo(a);
     break a;

    case 3:
     b = e >>> 4 | 0;
     u[a + 28 >> 1] = b >>> 0 >= 15 ? 496 : b << 4;
     u[a + 30 >> 1] = e & 15;
     Oo(a);
     break a;

    case 6:
     break d;

    default:
     break a;
    }
   }
   u[a + 12 >> 1] = e & 7;
  }
  eb = c + 16 | 0;
  return;
 }
 hb[v[v[b >> 2] >> 2]](b, c, d, e);
}

function k7(a, b, c, d, e, f, g) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 f = f | 0;
 g = g | 0;
 var h = 0, i = 0, j = 0, k = 0, l = 0, m = 0;
 a = eb - 624 | 0;
 eb = a;
 v[a + 616 >> 2] = c;
 v[a + 620 >> 2] = b;
 v[a + 16 >> 2] = 1273;
 b = a + 16 | 0;
 h = Ce(a + 200 | 0, a + 208 | 0, b);
 i = a + 192 | 0;
 bd(i, v[e + 28 >> 2]);
 v[31601] = 0;
 j = Q(1251, v[a + 192 >> 2]) | 0;
 k = v[31601];
 v[31601] = 0;
 a: {
  b: {
   c: {
    d: {
     e: {
      f: {
       g: {
        if ((k | 0) != 1) {
         t[a + 191 | 0] = 0;
         e = v[e + 4 >> 2];
         v[31601] = 0;
         c = ma(1282, a + 620 | 0, c | 0, d | 0, i | 0, e | 0, f | 0, a + 191 | 0, j | 0, h | 0, a + 196 | 0, a + 608 | 0) | 0;
         d = v[31601];
         v[31601] = 0;
         if ((d | 0) == 1) {
          break d;
         }
         if (!c) {
          break e;
         }
         t[a + 190 | 0] = 0;
         t[a + 188 | 0] = 56;
         t[a + 189 | 0] = 57;
         t[a + 180 | 0] = 48;
         t[a + 181 | 0] = 49;
         t[a + 182 | 0] = 50;
         t[a + 183 | 0] = 51;
         t[a + 184 | 0] = 52;
         t[a + 185 | 0] = 53;
         t[a + 186 | 0] = 54;
         t[a + 187 | 0] = 55;
         v[31601] = 0;
         U(1262, j | 0, a + 180 | 0, a + 190 | 0, a + 128 | 0);
         c = v[31601];
         v[31601] = 0;
         if ((c | 0) == 1) {
          break g;
         }
         v[a + 4 >> 2] = 1238;
         d = Ce(a + 8 | 0, 0, a + 4 | 0);
         e = b;
         b = v[a + 196 >> 2];
         c = b - v[h >> 2] | 0;
         if ((c | 0) < 393) {
          break f;
         }
         Qe(d, Fd((c >>> 2 | 0) + 2 | 0));
         e = v[d >> 2];
         if (e) {
          break f;
         }
         v[31601] = 0;
         W(1239);
         b = v[31601];
         v[31601] = 0;
         if ((b | 0) == 1) {
          break c;
         }
         break a;
        }
        c = M() | 0;
        break b;
       }
       c = M() | 0;
       break b;
      }
      if (w[a + 191 | 0]) {
       t[e | 0] = 45;
       e = e + 1 | 0;
      }
      c = v[h >> 2];
      while (1) {
       if (b >>> 0 <= c >>> 0) {
        t[e | 0] = 0;
        v[a >> 2] = g;
        if ((SJ(a + 16 | 0, a) | 0) != 1) {
         v[31601] = 0;
         V(1275, 8e3);
         b = v[31601];
         v[31601] = 0;
         if ((b | 0) != 1) {
          break a;
         }
         break c;
        }
        Kc(d);
       } else {
        b = a + 128 | 0;
        l = e, m = w[(a + 180 | 0) + (Ey(b, b + 40 | 0, v[c >> 2]) - b >> 2) | 0], t[l | 0] = m;
        e = e + 1 | 0;
        c = c + 4 | 0;
        b = v[a + 196 >> 2];
        continue;
       }
       break;
      }
     }
     v[31601] = 0;
     b = O(1256, a + 620 | 0, a + 616 | 0) | 0;
     c = v[31601];
     v[31601] = 0;
     if ((c | 0) == 1) {
      break d;
     }
     if (b) {
      v[f >> 2] = v[f >> 2] | 2;
     }
     b = v[a + 620 >> 2];
     Zb(a + 192 | 0);
     Kc(h);
     eb = a + 624 | 0;
     return b | 0;
    }
    c = M() | 0;
    break b;
   }
   c = M() | 0;
   Kc(d);
  }
  Zb(a + 192 | 0);
  Kc(h);
  P(c | 0);
  p();
 }
 p();
}

function r7(a, b, c, d, e, f, g) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 f = f | 0;
 g = g | 0;
 var h = 0, i = 0, j = 0, k = 0, l = 0, m = 0;
 a = eb - 272 | 0;
 eb = a;
 v[a + 264 >> 2] = c;
 v[a + 268 >> 2] = b;
 v[a + 16 >> 2] = 1273;
 b = a + 16 | 0;
 h = Ce(a + 152 | 0, a + 160 | 0, b);
 j = a + 144 | 0;
 bd(j, v[e + 28 >> 2]);
 v[31601] = 0;
 i = Q(28, v[a + 144 >> 2]) | 0;
 k = v[31601];
 v[31601] = 0;
 a: {
  b: {
   c: {
    d: {
     e: {
      f: {
       g: {
        if ((k | 0) != 1) {
         t[a + 143 | 0] = 0;
         e = v[e + 4 >> 2];
         v[31601] = 0;
         c = ma(1274, a + 268 | 0, c | 0, d | 0, j | 0, e | 0, f | 0, a + 143 | 0, i | 0, h | 0, a + 148 | 0, a + 260 | 0) | 0;
         d = v[31601];
         v[31601] = 0;
         if ((d | 0) == 1) {
          break d;
         }
         if (!c) {
          break e;
         }
         t[a + 142 | 0] = 0;
         t[a + 140 | 0] = 56;
         t[a + 141 | 0] = 57;
         t[a + 132 | 0] = 48;
         t[a + 133 | 0] = 49;
         t[a + 134 | 0] = 50;
         t[a + 135 | 0] = 51;
         t[a + 136 | 0] = 52;
         t[a + 137 | 0] = 53;
         t[a + 138 | 0] = 54;
         t[a + 139 | 0] = 55;
         v[31601] = 0;
         U(1248, i | 0, a + 132 | 0, a + 142 | 0, a + 122 | 0);
         c = v[31601];
         v[31601] = 0;
         if ((c | 0) == 1) {
          break g;
         }
         v[a + 4 >> 2] = 1238;
         d = Ce(a + 8 | 0, 0, a + 4 | 0);
         e = b;
         b = v[a + 148 >> 2];
         c = b - v[h >> 2] | 0;
         if ((c | 0) < 99) {
          break f;
         }
         Qe(d, Fd(c + 2 | 0));
         e = v[d >> 2];
         if (e) {
          break f;
         }
         v[31601] = 0;
         W(1239);
         b = v[31601];
         v[31601] = 0;
         if ((b | 0) == 1) {
          break c;
         }
         break a;
        }
        c = M() | 0;
        break b;
       }
       c = M() | 0;
       break b;
      }
      if (w[a + 143 | 0]) {
       t[e | 0] = 45;
       e = e + 1 | 0;
      }
      c = v[h >> 2];
      while (1) {
       if (b >>> 0 <= c >>> 0) {
        t[e | 0] = 0;
        v[a >> 2] = g;
        if ((SJ(a + 16 | 0, a) | 0) != 1) {
         v[31601] = 0;
         V(1275, 8e3);
         b = v[31601];
         v[31601] = 0;
         if ((b | 0) != 1) {
          break a;
         }
         break c;
        }
        Kc(d);
       } else {
        b = a + 122 | 0;
        i = _Z(b);
        l = e, m = w[((Ei(b, i, w[c | 0]) - a | 0) + a | 0) + 10 | 0], t[l | 0] = m;
        e = e + 1 | 0;
        c = c + 1 | 0;
        b = v[a + 148 >> 2];
        continue;
       }
       break;
      }
     }
     v[31601] = 0;
     b = O(1240, a + 268 | 0, a + 264 | 0) | 0;
     c = v[31601];
     v[31601] = 0;
     if ((c | 0) == 1) {
      break d;
     }
     if (b) {
      v[f >> 2] = v[f >> 2] | 2;
     }
     b = v[a + 268 >> 2];
     Zb(a + 144 | 0);
     Kc(h);
     eb = a + 272 | 0;
     return b | 0;
    }
    c = M() | 0;
    break b;
   }
   c = M() | 0;
   Kc(d);
  }
  Zb(a + 144 | 0);
  Kc(h);
  P(c | 0);
  p();
 }
 p();
}

function c7(a, b, c, d, e, f, g, h, i, j, k, l, m, n, o) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 f = f | 0;
 g = g | 0;
 h = h | 0;
 i = i | 0;
 j = j | 0;
 k = k | 0;
 l = l | 0;
 m = m | 0;
 n = n | 0;
 o = o | 0;
 var p = 0, q = 0, r = 0, s = 0, u = 0, x = 0, y = 0, z = 0, A = 0, B = 0, C = 0;
 v[c >> 2] = a;
 z = d & 512;
 while (1) {
  if ((x | 0) == 4) {
   if (Cb(v[n + 4 >> 2], w[n + 11 | 0]) >>> 0 > 1) {
    B = c, C = LJ(Pe(yd(n), 1), Cf(n), v[c >> 2]), v[B >> 2] = C;
   }
   d = d & 176;
   if ((d | 0) != 16) {
    if ((d | 0) == 32) {
     a = v[c >> 2];
    }
    v[b >> 2] = a;
   }
  } else {
   a: {
    b: {
     switch (w[i + x | 0]) {
     case 0:
      v[b >> 2] = v[c >> 2];
      break a;

     case 1:
      v[b >> 2] = v[c >> 2];
      p = im(g, 32);
      q = v[c >> 2];
      v[c >> 2] = q + 1;
      t[q | 0] = p;
      break a;

     case 3:
      if (zd(v[n + 4 >> 2], w[n + 11 | 0])) {
       break a;
      }
      p = w[dc(n, 0) | 0];
      q = v[c >> 2];
      v[c >> 2] = q + 1;
      t[q | 0] = p;
      break a;

     case 2:
      if (zd(v[m + 4 >> 2], w[m + 11 | 0]) | !z) {
       break a;
      }
      B = c, C = LJ(yd(m), Cf(m), v[c >> 2]), v[B >> 2] = C;
      break a;

     case 4:
      break b;

     default:
      break a;
     }
    }
    p = v[g + 8 >> 2];
    A = v[c >> 2];
    e = e + h | 0;
    r = e;
    while (1) {
     c: {
      if (f >>> 0 <= r >>> 0) {
       break c;
      }
      if (!If(p, 64, t[r | 0])) {
       break c;
      }
      r = r + 1 | 0;
      continue;
     }
     break;
    }
    p = o;
    if ((p | 0) > 0) {
     while (1) {
      if (!(!p | e >>> 0 >= r >>> 0)) {
       p = p - 1 | 0;
       r = r - 1 | 0;
       q = w[r | 0];
       s = v[c >> 2];
       v[c >> 2] = s + 1;
       t[s | 0] = q;
       continue;
      }
      break;
     }
     if (p) {
      q = im(g, 48);
     } else {
      q = 0;
     }
     while (1) {
      s = v[c >> 2];
      v[c >> 2] = s + 1;
      if ((p | 0) > 0) {
       t[s | 0] = q;
       p = p - 1 | 0;
       continue;
      }
      break;
     }
     t[s | 0] = j;
    }
    d: {
     if ((e | 0) == (r | 0)) {
      p = im(g, 48);
      q = v[c >> 2];
      v[c >> 2] = q + 1;
      t[q | 0] = p;
      break d;
     }
     q = -1;
     if (!zd(v[l + 4 >> 2], w[l + 11 | 0])) {
      q = t[dc(l, 0) | 0];
     }
     p = 0;
     u = 0;
     while (1) {
      if ((e | 0) == (r | 0)) {
       break d;
      }
      e: {
       if ((p | 0) != (q | 0)) {
        s = p;
        break e;
       }
       q = v[c >> 2];
       v[c >> 2] = q + 1;
       t[q | 0] = k;
       s = 0;
       u = u + 1 | 0;
       if (Cb(v[l + 4 >> 2], w[l + 11 | 0]) >>> 0 <= u >>> 0) {
        q = p;
        break e;
       }
       q = -1;
       if (w[dc(l, u) | 0] == 127) {
        break e;
       }
       q = t[dc(l, u) | 0];
      }
      r = r - 1 | 0;
      p = w[r | 0];
      y = v[c >> 2];
      v[c >> 2] = y + 1;
      t[y | 0] = p;
      p = s + 1 | 0;
      continue;
     }
    }
    Bm(A, v[c >> 2]);
   }
   x = x + 1 | 0;
   continue;
  }
  break;
 }
}

function aV(a, b) {
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0;
 a: {
  b: {
   d = b;
   e = v[b >> 2];
   if (e) {
    if (!v[b + 4 >> 2]) {
     break b;
    }
    d = WZ(b);
    e = v[d >> 2];
    if (e) {
     break b;
    }
   }
   e = v[d + 4 >> 2];
   if (e) {
    break b;
   }
   e = 0;
   g = 1;
   break a;
  }
  v[e + 8 >> 2] = v[d + 8 >> 2];
  g = 0;
 }
 c = v[d + 8 >> 2];
 c: {
  d: {
   if (li(d)) {
    v[c >> 2] = e;
    if ((a | 0) == (d | 0)) {
     a = e;
     c = 0;
     break c;
    }
    c = c + 4 | 0;
    break d;
   }
   v[c + 4 >> 2] = e;
  }
  c = v[c >> 2];
 }
 h = !w[d + 12 | 0];
 if ((b | 0) != (d | 0)) {
  f = v[b + 8 >> 2];
  v[d + 8 >> 2] = f;
  i = f + (li(b) ? 0 : 4) | 0, j = d, v[i >> 2] = j;
  f = v[b >> 2];
  v[d >> 2] = f;
  vn(f, d);
  f = v[b + 4 >> 2];
  v[d + 4 >> 2] = f;
  if (f) {
   vn(f, d);
  }
  t[d + 12 | 0] = w[b + 12 | 0];
  a = (a | 0) == (b | 0) ? d : a;
 }
 if (!(h | !a)) {
  if (g) {
   while (1) {
    b = w[c + 12 | 0];
    e: {
     f: {
      if (!li(c)) {
       if (!b) {
        t[c + 12 | 0] = 1;
        b = v[c + 8 >> 2];
        t[b + 12 | 0] = 0;
        pr(b);
        b = v[c >> 2];
        a = (b | 0) == (a | 0) ? c : a;
        c = v[b + 4 >> 2];
       }
       b = v[c >> 2];
       g: {
        if (!(w[b + 12 | 0] ? 0 : b)) {
         b = v[c + 4 >> 2];
         if (w[b + 12 | 0] ? 0 : b) {
          break g;
         }
         t[c + 12 | 0] = 0;
         b = v[c + 8 >> 2];
         if ((b | 0) != (a | 0)) {
          if (w[b + 12 | 0]) {
           break f;
          }
          a = b;
         }
         t[a + 12 | 0] = 1;
         return;
        }
        a = v[c + 4 >> 2];
        if (w[a + 12 | 0] ? 0 : a) {
         break g;
        }
        t[b + 12 | 0] = 1;
        t[c + 12 | 0] = 0;
        nr(c);
        c = v[c + 8 >> 2];
       }
       a = v[c + 8 >> 2];
       t[c + 12 | 0] = w[a + 12 | 0];
       t[a + 12 | 0] = 1;
       t[v[c + 4 >> 2] + 12 | 0] = 1;
       pr(a);
       return;
      }
      if (!b) {
       t[c + 12 | 0] = 1;
       b = v[c + 8 >> 2];
       t[b + 12 | 0] = 0;
       nr(b);
       b = v[c + 4 >> 2];
       a = (b | 0) == (a | 0) ? c : a;
       c = v[b >> 2];
      }
      d = v[c >> 2];
      h: {
       if (w[d + 12 | 0] ? 0 : d) {
        break h;
       }
       b = v[c + 4 >> 2];
       if (!(w[b + 12 | 0] ? 0 : b)) {
        t[c + 12 | 0] = 0;
        b = v[c + 8 >> 2];
        if (!((a | 0) != (b | 0) ? w[b + 12 | 0] : 0)) {
         t[b + 12 | 0] = 1;
         return;
        }
        b = v[b + 8 >> 2] + (li(b) ? 4 : 0) | 0;
        break e;
       }
       if (w[d + 12 | 0] ? 0 : d) {
        break h;
       }
       t[b + 12 | 0] = 1;
       t[c + 12 | 0] = 0;
       pr(c);
       c = v[c + 8 >> 2];
       d = v[c >> 2];
      }
      a = v[c + 8 >> 2];
      t[c + 12 | 0] = w[a + 12 | 0];
      t[a + 12 | 0] = 1;
      t[d + 12 | 0] = 1;
      nr(a);
      return;
     }
     b = v[b + 8 >> 2] + (li(b) ? 4 : 0) | 0;
    }
    c = v[b >> 2];
    continue;
   }
  }
  t[e + 12 | 0] = 1;
 }
}

function Zia(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0;
 e = v[a >> 2];
 d = fm(e, v[a + 4 >> 2]);
 if (d >>> 0 < b >>> 0) {
  i = eb - 32 | 0;
  eb = i;
  a: {
   b: {
    h = b - d | 0;
    b = v[zb(a) >> 2];
    e = v[a + 4 >> 2];
    c: {
     if (h >>> 0 <= (b - e | 0) / 52 >>> 0) {
      rA(a, h, c);
      break c;
     }
     f = zb(a);
     d = cR(a, fm(v[a >> 2], e) + h | 0);
     g = fm(v[a >> 2], v[a + 4 >> 2]);
     e = eb - 16 | 0;
     eb = e;
     b = i + 12 | 0;
     Kg(b + 12 | 0, f);
     d: {
      if (!d) {
       f = 0;
       d = 0;
       break d;
      }
      bR(e + 8 | 0, d);
      f = v[e + 12 >> 2];
      d = v[e + 8 >> 2];
     }
     v[b >> 2] = d;
     g = d + B(g, 52) | 0;
     v[b + 8 >> 2] = g;
     v[b + 4 >> 2] = g;
     l = mc(b), m = d + B(f, 52) | 0, v[l >> 2] = m;
     eb = e + 16 | 0;
     v[31601] = 0;
     R(921, b | 0, h | 0, c | 0);
     c = v[31601];
     v[31601] = 0;
     if ((c | 0) == 1) {
      break b;
     }
     h = eb - 16 | 0;
     eb = h;
     e = zb(a);
     c = ub(h + 12 | 0, v[a + 4 >> 2]);
     d = ub(h + 8 | 0, v[a >> 2]);
     f = ub(h + 4 | 0, v[b + 4 >> 2]);
     c = v[c >> 2];
     g = v[d >> 2];
     d = eb + -64 | 0;
     eb = d;
     f = v[f >> 2];
     v[d + 56 >> 2] = f;
     v[d + 60 >> 2] = c;
     v[d + 52 >> 2] = f;
     e = zg(d + 24 | 0, e, d + 52 | 0, d + 56 | 0);
     v[d + 16 >> 2] = v[e + 8 >> 2];
     f = v[e + 4 >> 2];
     v[d + 8 >> 2] = v[e >> 2];
     v[d + 12 >> 2] = f;
     yg(d + 36 | 0, d + 8 | 0);
     while (1) {
      if (Ed(c, g)) {
       c = c - 52 | 0;
       e = Rl(_Q(v[d + 56 >> 2]), c);
       v[e + 20 >> 2] = v[c + 20 >> 2];
       f = v[c + 16 >> 2];
       v[e + 12 >> 2] = v[c + 12 >> 2];
       v[e + 16 >> 2] = f;
       kW(e + 24 | 0, c + 24 | 0);
       Uc(e + 36 | 0, c + 36 | 0);
       v[e + 48 >> 2] = v[c + 48 >> 2];
       c = $Q(d + 60 | 0);
       $Q(d + 56 | 0);
       c = v[c >> 2];
       continue;
      }
      break;
     }
     xg(d + 36 | 0);
     j = v[d + 56 >> 2];
     if (!w[d + 48 | 0]) {
      f = eb - 16 | 0;
      eb = f;
      c = ub(f + 12 | 0, v[v[d + 44 >> 2] >> 2]);
      k = v[ub(f + 8 | 0, v[v[d + 40 >> 2] >> 2]) >> 2];
      g = eb - 16 | 0;
      eb = g;
      c = v[c >> 2];
      v[g + 12 >> 2] = c;
      while (1) {
       if (vi(c, k)) {
        e = eb - 16 | 0;
        eb = e;
        v[e + 12 >> 2] = c;
        v[e + 12 >> 2] = v[e + 12 >> 2] + 52;
        eb = e + 16 | 0;
        uk(_Q(v[e + 12 >> 2]));
        c = v[Sl(g + 12 | 0) >> 2];
        continue;
       }
       break;
      }
      eb = g + 16 | 0;
      eb = f + 16 | 0;
     }
     eb = d - -64 | 0;
     v[b + 4 >> 2] = j;
     Sb(a, b + 4 | 0);
     Sb(a + 4 | 0, b + 8 | 0);
     Sb(zb(a), mc(b));
     v[b >> 2] = v[b + 4 >> 2];
     eb = h + 16 | 0;
     aR(b);
    }
    eb = i + 32 | 0;
    break a;
   }
   a = M() | 0;
   aR(b);
   P(a | 0);
   p();
  }
  return;
 }
 if (b >>> 0 < d >>> 0) {
  dR(a, e + B(b, 52) | 0);
 }
}

function Pu(a, b, c, d) {
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0;
 c = B(c, 872) + b | 0;
 v[c + 704 >> 2] = v[c + 704 >> 2] | 524288;
 c = c + 616 | 0;
 a: {
  b: {
   if (!(w[a + 480208 | 0] & 8)) {
    if (Nb(a + 1074312 | 0, 15) | v[a + 480180 >> 2] == 268435456) {
     break b;
    }
    break a;
   }
   if (v[a + 480180 >> 2] != 268435456) {
    break a;
   }
  }
  d = d ? d : w[c + 811 | 0];
  t[c + 811 | 0] = d;
  t[c + 812 | 0] = d;
 }
 if (d) {
  u[c + 768 >> 1] = d;
 }
 c: {
  g = v[c + 656 >> 2];
  if (Jj(g)) {
   a = x[c + 768 >> 1];
   if (!a) {
    break c;
   }
   d = v[b + 16 >> 2];
   e = d ? v[c + 856 >> 2] : e;
   h = 0 - a | 0;
   f = a;
   a = v[c + 708 >> 2];
   i = (+(d >>> 0) + 1) * +(((a | 0) < 0 ? h : f) | 0) / +y[b + 40 >> 2];
   d: {
    if (D(i) < 2147483648) {
     d = ~~i;
     break d;
    }
    d = -2147483648;
   }
   v[c + 856 >> 2] = d;
   if (w[c + 90 | 0] & 16) {
    d = B(v[v[g + 44 >> 2] + 36 >> 2] + 1 | 0, d);
    v[c + 856 >> 2] = d;
   }
   b = d - e | 0;
   d = b >> 31;
   e = a >> 31;
   if ((e ^ a) - e >>> 0 <= (b ^ d) - d >>> 0) {
    if (!a) {
     break c;
    }
    v[c + 708 >> 2] = 0;
    v[c + 852 >> 2] = a + v[c + 852 >> 2];
    t[c + 851 | 0] = w[c + 851 | 0] | 64;
    return 0;
   }
   v[c + 708 >> 2] = a - b;
   v[c + 852 >> 2] = b + v[c + 852 >> 2];
   t[c + 851 | 0] = w[c + 851 | 0] | 64;
   break c;
  }
  g = a + 1074312 | 0;
  e: {
   if (!(!Nb(g, 118) | !(w[c + 89 | 0] & 2))) {
    d = 0;
    if (Tc(w[c + 788 | 0])) {
     break e;
    }
   }
   e = 1;
   f: {
    if (!(t[c + 851 | 0] & 1)) {
     break f;
    }
    d = v[a + 480180 >> 2];
    if (d & 524352) {
     break f;
    }
    if (v[b + 40 >> 2] == 1) {
     if (Nb(g, 6)) {
      break f;
     }
     d = v[a + 480180 >> 2];
    }
    e = 0;
    if ((d | 0) != 8) {
     break f;
    }
    e = (w[a + 480208 | 0] & 2) >>> 1 | 0;
   }
   d = v[a + 480180 >> 2];
   b = x[c + 768 >> 1];
   if (!((d | 0) != 268435456 | b >>> 0 < 240)) {
    e = t[c + 851 | 0] & 1;
    b = b - 240 | 0;
   }
   d = b << ((d | 0) == 64 ? 1 : 2);
   g: {
    if (!v[c + 700 >> 2] | !(v[c + 708 >> 2] != 0 & e)) {
     break g;
    }
    b = c + 700 | 0;
    f = yj(a) ? d : 0 - d | 0;
    h = v[c + 708 >> 2];
    j = v[c + 700 >> 2];
    if (!(!(w[c + 851 | 0] & 16) & (h | 0) <= (j | 0))) {
     vk(a, c, b, f, 1);
     f = v[c + 708 >> 2];
     if ((f | 0) >= v[c + 700 >> 2]) {
      break g;
     }
     v[b >> 2] = f;
     break g;
    }
    if ((h | 0) >= (j | 0)) {
     break g;
    }
    vk(a, c, b, 0 - f | 0, 1);
    h = v[c + 700 >> 2];
    f = v[c + 708 >> 2];
    h: {
     if ((h | 0) < (f | 0)) {
      v[b >> 2] = f;
      break h;
     }
     if ((f | 0) != (h | 0)) {
      break g;
     }
    }
    if (!Nb(g, 112)) {
     break g;
    }
    t[c + 851 | 0] = w[c + 851 | 0] | 16;
   }
   i: {
    if (v[c + 700 >> 2] != v[c + 708 >> 2]) {
     break i;
    }
    if (!Nb(g, 25) & v[a + 480180 >> 2] != 1) {
     break i;
    }
    v[c + 708 >> 2] = 0;
   }
   d = e ? d : 0;
  }
  return d;
 }
 return 0;
}

function Dg(a, b, c, d, e) {
 var f = 0, g = 0, h = 0, i = 0, j = 0, k = 0;
 i = v[a + 8 >> 2] + (B(x[a + 14 >> 1], (w[a + 80 | 0] ? c : 0) + b | 0) >>> 1 | 0) | 0;
 v[a + 8 >> 2] = i;
 g = w[a + 79 | 0] ? x[v[a >> 2] + 3836 >> 1] : g;
 c = x[a + 20 >> 1];
 h = x[a + 22 >> 1];
 k = x[a + 70 >> 1];
 a: {
  b: {
   c: {
    d: {
     switch (v[a + 16 >> 2]) {
     case 1:
      b = x[v[a >> 2] + 3832 >> 1];
      f = c + (b & x[a + 46 >> 1] ? 0 : x[a + 26 >> 1] ? x[a + 48 >> 1] >>> x[v[a + 52 >> 2] + ((b >>> x[a + 44 >> 1] & 7) << 1) >> 1] | 0 : 0) | 0;
      u[a + 20 >> 1] = f;
      b = 2;
      j = x[a + 28 >> 1];
      if ((j | 0) <= f << 16 >> 16) {
       break c;
      }
      break b;

     case 2:
      if (w[a + 78 | 0]) {
       break b;
      }

     case 3:
      b = 0;
      f = x[v[a >> 2] + 3832 >> 1];
      f = c + (f & x[a + 58 >> 1] ? 0 : x[a + 30 >> 1] ? x[a + 60 >> 1] >>> x[v[a + 64 >> 2] + ((f >>> x[a + 56 >> 1] & 7) << 1) >> 1] | 0 : 0) | 0;
      u[a + 20 >> 1] = f;
      if (f << 16 >> 16 < 511) {
       break b;
      }
      v[a + 16 >> 2] = -1;
      u[a + 20 >> 1] = 511;
      v[a + 72 >> 2] = 0;
      break a;

     default:
      b = 0;
      v[a + 72 >> 2] = 0;
      break a;

     case 0:
      break d;
     }
    }
    b = 1;
    f = x[v[a >> 2] + 3832 >> 1];
    f = c + (f & x[a + 34 >> 1] ? 0 : x[a + 24 >> 1] ? B((c ^ -1) << 16 >> 16, x[a + 36 >> 1] >>> x[v[a + 40 >> 2] + ((f >>> x[a + 32 >> 1] & 7) << 1) >> 1] | 0) >>> 3 | 0 : 0) | 0;
    u[a + 20 >> 1] = f;
    if (f << 16 >> 16 > 0) {
     break b;
    }
   }
   v[a + 16 >> 2] = b;
   u[a + 20 >> 1] = j;
  }
  h = ((c + h | 0) + k | 0) + g << 3;
  if (e) {
   d = (u[a + 74 >> 1] + u[a + 72 >> 1] >> e) + d | 0;
  }
  d = (i >>> 10 | 0) + d | 0;
  c = d & 255;
  b = d & 65535;
  e: {
   f: {
    switch (x[a + 12 >> 1]) {
    case 0:
     g = (b & 512) >>> 9 | 0;
     b = x[((b & 256 ? c ^ 255 : c) << 1) + 26736 >> 1];
     break e;

    case 1:
     g = 0;
     b = x[((b & 512 ? 0 : b & 256 ? c ^ 255 : c) << 1) + 26736 >> 1];
     break e;

    case 2:
     g = 0;
     b = x[((b & 256 ? c ^ 255 : c) << 1) + 26736 >> 1];
     break e;

    case 3:
     g = 0;
     b = x[((b & 256 ? 0 : c) << 1) + 26736 >> 1];
     break e;

    case 4:
     g = 0;
     if (b & 512) {
      b = 0;
     } else {
      g = (d & 256) >>> 8 | 0;
      b = (c << 1 ^ b << 24 >> 31) & 254;
     }
     b = x[(b << 1) + 26736 >> 1];
     break e;

    case 5:
     g = 0;
     if (b & 512) {
      b = 0;
     } else {
      c = c << 1 & 254;
      b = b & 128 ? c ^ 255 : c;
     }
     b = x[(b << 1) + 26736 >> 1];
     break e;

    case 6:
     g = (d & 512) >>> 9 | 0;
     b = 0;
     break e;

    default:
     break f;
    }
   }
   c = d << 3 & 4088;
   g = (b & 512) >>> 9 | 0;
   b = g ? c ^ 4088 : c;
  }
  u[a + 74 >> 1] = x[a + 72 >> 1];
  c = a;
  a = b + h & 65535;
  a = a >>> 0 >= 8191 ? 8191 : a;
  b = 0 - (g & 1) ^ x[((a & 255) << 1) + 26224 >> 1] + 1024 >>> (a >>> 8) << 1;
  u[c + 72 >> 1] = b;
 }
 return b << 16 >> 16;
}

function JO(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0;
 e = eb + -64 | 0;
 eb = e;
 g = Mb(a);
 a = 0;
 c = v[b + 24 >> 2];
 h = Gj(Wb(v[c + 484360 >> 2], w[c + 484376 | 0]));
 v[31601] = 0;
 N(176, g | 0, h | 0);
 c = v[31601];
 v[31601] = 0;
 a: {
  if ((c | 0) != 1) {
   while (1) {
    b: {
     if ((a | 0) != (h | 0)) {
      c = v[b + 24 >> 2];
      f = v[c + 484344 >> 2];
      d = v[c + 484348 >> 2];
      c = x[$b(v[Wb(v[c + 484360 >> 2], w[c + 484376 | 0]) >> 2], a) >> 1];
      if (An(f, d, c)) {
       v[31601] = 0;
       d = e + 40 | 0;
       N(1065, d | 0, Vb(f, c) | 0);
       c = v[31601];
       v[31601] = 0;
       c: {
        d: {
         e: {
          if ((c | 0) != 1) {
           f = v[b + 24 >> 2];
           v[31601] = 0;
           c = e + 52 | 0;
           R(1052, c | 0, f | 0, d | 0);
           f = v[31601];
           v[31601] = 0;
           if ((f | 0) == 1) {
            break e;
           }
           v[31601] = 0;
           N(178, g | 0, c | 0);
           f = v[31601];
           v[31601] = 0;
           if ((f | 0) == 1) {
            break d;
           }
           sb(c);
           sb(d);
           break b;
          }
          a = M() | 0;
          break a;
         }
         a = M() | 0;
         break c;
        }
        a = M() | 0;
        sb(e + 52 | 0);
       }
       sb(e + 40 | 0);
       break a;
      }
      f: {
       switch (c - 65534 | 0) {
       case 0:
        v[31601] = 0;
        c = O(36, e + 28 | 0, 9240) | 0;
        d = v[31601];
        v[31601] = 0;
        g: {
         if ((d | 0) != 1) {
          v[31601] = 0;
          N(178, g | 0, c | 0);
          d = v[31601];
          v[31601] = 0;
          if ((d | 0) == 1) {
           break g;
          }
          sb(c);
          break b;
         }
         a = M() | 0;
         break a;
        }
        a = M() | 0;
        sb(c);
        break a;

       case 1:
        v[31601] = 0;
        c = O(36, e + 16 | 0, 9202) | 0;
        d = v[31601];
        v[31601] = 0;
        h: {
         if ((d | 0) != 1) {
          v[31601] = 0;
          N(178, g | 0, c | 0);
          d = v[31601];
          v[31601] = 0;
          if ((d | 0) == 1) {
           break h;
          }
          sb(c);
          break b;
         }
         a = M() | 0;
         break a;
        }
        a = M() | 0;
        sb(c);
        break a;

       default:
        break f;
       }
      }
      v[31601] = 0;
      c = O(36, e + 4 | 0, 14600) | 0;
      d = v[31601];
      v[31601] = 0;
      i: {
       if ((d | 0) != 1) {
        v[31601] = 0;
        N(178, g | 0, c | 0);
        d = v[31601];
        v[31601] = 0;
        if ((d | 0) == 1) {
         break i;
        }
        sb(c);
        break b;
       }
       a = M() | 0;
       break a;
      }
      a = M() | 0;
      sb(c);
      break a;
     }
     eb = e - -64 | 0;
     return;
    }
    a = a + 1 | 0;
    continue;
   }
  }
  a = M() | 0;
 }
 Sd(g);
 P(a | 0);
 p();
}

function AH(a, b, c) {
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0;
 d = eb - 432 | 0;
 eb = d;
 a: {
  f = _s(d + 428 | 0, b);
  e = v[f >> 2];
  b: {
   if (!Dd(e)) {
    v[31601] = 0;
    b = O(36, d + 416 | 0, b | 0) | 0;
    a = v[31601];
    v[31601] = 0;
    c: {
     d: {
      e: {
       if ((a | 0) != 1) {
        v[31601] = 0;
        a = d + 16 | 0;
        R(1010, a | 0, 17680, b | 0);
        c = v[31601];
        v[31601] = 0;
        if ((c | 0) == 1) {
         break e;
        }
        v[31601] = 0;
        V(1366, a | 0);
        a = v[31601];
        v[31601] = 0;
        if ((a | 0) == 1) {
         break d;
        }
        break a;
       }
       a = M() | 0;
       break b;
      }
      a = M() | 0;
      break c;
     }
     a = M() | 0;
     sb(d + 16 | 0);
    }
    sb(b);
    break b;
   }
   Zs(e);
   if (!_p(a + 8 | 0, 22256, v[f >> 2])) {
    v[a + 8 >> 2] = 2147483647;
   }
   if (!_p(a + 12 | 0, 22256, v[f >> 2])) {
    v[a + 12 >> 2] = 2147483647;
   }
   v[31601] = 0;
   N(272, a + 16 | 0, 22256);
   b = v[31601];
   v[31601] = 0;
   f: {
    g: {
     if ((b | 0) != 1) {
      v[d + 8 >> 2] = 0;
      v[d + 12 >> 2] = 0;
      v[d + 4 >> 2] = 22256;
      e = Bi(d + 16 | 0, d + 4 | 0, 100, d + 8 | 0, v[f >> 2]);
      if ((e | 0) == -1) {
       v[31601] = 0;
       V(1275, 12661);
       a = v[31601];
       v[31601] = 0;
       if ((a | 0) != 1) {
        break a;
       }
       a = M() | 0;
       break b;
      }
      v[31601] = 0;
      b = d + 16 | 0;
      e = T(1373, a + 28 | 0, b | 0, b + (e << 2) | 0) | 0;
      g = v[31601];
      v[31601] = 0;
      if ((g | 0) == 1) {
       break f;
      }
      v[a + 64 >> 2] = 0;
      v[d + 4 >> 2] = 22256;
      v[d + 8 >> 2] = 0;
      v[d + 12 >> 2] = 0;
      h: {
       g = d + 4 | 0;
       i = d + 8 | 0;
       h = Bi(b, g, 100, i, v[f >> 2]);
       if ((h | 0) != -1) {
        v[31601] = 0;
        T(1373, a + 40 | 0, b | 0, b + (h << 2) | 0) | 0;
        h = v[31601];
        v[31601] = 0;
        if ((h | 0) == 1) {
         break f;
        }
        v[d + 4 >> 2] = 22256;
        v[d + 8 >> 2] = 0;
        v[d + 12 >> 2] = 0;
        b = Bi(b, g, 100, i, v[f >> 2]);
        if ((b | 0) != -1) {
         break h;
        }
       }
       v[31601] = 0;
       V(1275, 12661);
       a = v[31601];
       v[31601] = 0;
       if ((a | 0) != 1) {
        break a;
       }
       break f;
      }
      v[31601] = 0;
      g = d + 16 | 0;
      T(1373, a + 52 | 0, g | 0, g + (b << 2) | 0) | 0;
      b = v[31601];
      v[31601] = 0;
      if ((b | 0) == 1) {
       break f;
      }
      v[31601] = 0;
      b = O(1374, d + 416 | 0, e | 0) | 0;
      e = v[31601];
      v[31601] = 0;
      if ((e | 0) != 1) {
       break g;
      }
      a = M() | 0;
      break b;
     }
     a = M() | 0;
     break b;
    }
    ai(a + 68 | 0, c);
    ai(a + 72 | 0, c);
    Tb(b);
    el(f);
    eb = d + 432 | 0;
    return;
   }
   a = M() | 0;
  }
  el(f);
  P(a | 0);
  p();
 }
 p();
}

function U0(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0;
 f = eb - 16 | 0;
 eb = f;
 xc(c);
 while (1) {
  a: {
   if (!Lb(v[c >> 2], v[c + 8 >> 2], 3)) {
    break a;
   }
   e = f + 13 | 0;
   Tr(e, c);
   h = Ic(e);
   e = _e(e);
   d = w[f + 13 | 0];
   if (d >>> 0 >= y[a + 12 >> 2]) {
    break a;
   }
   g = ld(v[a >> 2], v[v[a + 48 >> 2] + 12 >> 2], d, b);
   d = w[h | 0];
   if (d >>> 0 <= 126) {
    if (!(d | w[e | 0])) {
     t[g | 0] = 254;
     continue;
    }
    t[g | 0] = d + 1;
    if (w[e | 0] == 255) {
     continue;
    }
    t[g + 2 | 0] = 1;
    t[g + 4 | 0] = w[e | 0];
    continue;
   }
   b: {
    switch (d - 127 | 0) {
    case 1:
     t[g + 1 | 0] = w[e | 0] + 1;
     continue;

    case 0:
     continue;

    default:
     break b;
    }
   }
   d = t[e | 0];
   t[f + 12 | 0] = d;
   e = 0;
   i = w[h | 0];
   j = i & 127;
   if (j >>> 0 <= 23) {
    e = w[j + 24576 | 0];
   }
   c: {
    d: {
     e: {
      f: {
       g: {
        switch (j - 2 | 0) {
        case 0:
        case 8:
        case 9:
         if ((d | 0) >= 0) {
          break f;
         }
         d = 0 - d & 15;
         break e;

        case 1:
         t[f + 8 | 0] = 64;
         d = w[Pb(f + 12 | 0, f + 8 | 0) | 0];
         if (w[g + 2 | 0] > 1) {
          break e;
         }
         t[g + 2 | 0] = 1;
         e = 4;
         break c;

        case 2:
         h = 3;
         if ((d | 0) >= 0) {
          break d;
         }
         d = 0 - d & 127;
         break e;

        case 15:
         if (!d) {
          continue;
         }
         if ((d | 0) < 0) {
          d = 0 - d | -16;
          break e;
         }
         d = d << 4 | 15;
         break e;

        case 16:
        case 20:
         if (!d) {
          continue;
         }
         e = (d | 0) >= 0;
         if (!e) {
          d = 0 - d & 15;
          t[f + 12 | 0] = d;
          i = w[h | 0];
         }
         h = e ? 3 : 2;
         d = ((i | 0) == 22 ? -32 : -16) | d;
         t[f + 12 | 0] = d;
         break d;

        case 17:
         d = d & 15 | -48;
         break e;

        case 18:
         d = d & 15 | -64;
         break e;

        case 21:
         break g;

        default:
         break e;
        }
       }
       if ((d | 0) == 100) {
        d = 164;
        t[f + 12 | 0] = 164;
        break e;
       }
       v[f + 8 >> 2] = d - -64;
       v[f + 4 >> 2] = 0;
       v[f >> 2] = 128;
       d = v[Yj(f + 8 | 0, f + 4 | 0, f) >> 2];
       if (!w[g + 3 | 0]) {
        break e;
       }
       h: {
        switch (w[g + 2 | 0]) {
        case 0:
        case 2:
         break h;

        default:
         continue;
        }
       }
       t[g + 2 | 0] = 2;
       d = (d & 254) >>> 1 | 0;
       e = 4;
       break c;
      }
      d = d << 4;
     }
     h = e;
     if (!e) {
      continue;
     }
    }
    t[g + 3 | 0] = h;
    e = 5;
   }
   t[e + g | 0] = d;
   continue;
  }
  break;
 }
 eb = f + 16 | 0;
}

function FD(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, q = 0;
 l = eb - 16 | 0;
 eb = l;
 a: {
  if (b & 4) {
   break a;
  }
  e = w[a + 14 | 0];
  b: {
   if (e >>> 0 >= w[a + 15 | 0]) {
    break b;
   }
   c = w[a + 12 | 0];
   if (!(c & 2)) {
    break b;
   }
   t[a + 12 | 0] = c & 251;
  }
  if (!(w[a + 12 | 0] & 2) | e >>> 0 <= w[a + 13 | 0]) {
   break a;
  }
  c = v[a >> 2];
  d = v[a + 4 >> 2];
  if (Rd(c, d) >>> 0 <= e >>> 0) {
   break a;
  }
  c = x[Oc(c, d, e) >> 1];
  d = Oc(v[a >> 2], v[a + 4 >> 2], w[a + 14 | 0] - 1 | 0);
  e = w[a + 14 | 0];
  if (x[d >> 1] < (c - 1 | 0)) {
   e = x[Oc(v[a >> 2], v[a + 4 >> 2], e) >> 1] - 1 & 65535;
   c = Rq(a, e, 64, 64);
   d = ub(l + 12 | 0, Dk(vb(v[a >> 2]), w[a + 14 | 0]));
   h = Wl(l + 8 | 0, e, c & 255);
   n = eb - 32 | 0;
   eb = n;
   e = v[a >> 2];
   e = (Mv(v[d >> 2], vb(e)) << 2) + e | 0;
   f = v[a + 4 >> 2];
   c: {
    d: {
     if (f >>> 0 < y[zb(a) >> 2]) {
      if ((e | 0) != (f | 0)) {
       break d;
      }
      NY(a, h);
      break c;
     }
     c = zb(a);
     d = Yf(n + 12 | 0, Kf(a, nc(v[a >> 2], f) + 1 | 0), e - v[a >> 2] >> 2, c);
     v[31601] = 0;
     N(779, d | 0, h | 0);
     c = v[31601];
     v[31601] = 0;
     if ((c | 0) != 1) {
      f = eb - 16 | 0;
      eb = f;
      c = v[d + 4 >> 2];
      h = ub(f + 12 | 0, e);
      g = ub(f + 8 | 0, v[a >> 2]);
      j = ub(f + 4 | 0, v[d + 4 >> 2]);
      o = d, q = MF(v[h >> 2], v[g >> 2], v[j >> 2]), v[o + 4 >> 2] = q;
      o = d, q = pY(e, v[a + 4 >> 2], v[d + 8 >> 2]), v[o + 8 >> 2] = q;
      Sb(a, d + 4 | 0);
      Sb(a + 4 | 0, d + 8 | 0);
      Sb(zb(a), mc(d));
      v[d >> 2] = v[d + 4 >> 2];
      eb = f + 16 | 0;
      e = c;
      Xf(d);
      break c;
     }
     a = M() | 0;
     Xf(d);
     P(a | 0);
     p();
    }
    j = eb - 16 | 0;
    eb = j;
    k = v[a + 4 >> 2];
    d = (k - (e + 4 | 0) | 0) + e | 0;
    i = wh(j + 4 | 0, a, f - d >> 2);
    g = v[i + 4 >> 2];
    c = d;
    while (1) {
     if (c >>> 0 >= f >>> 0) {
      hc(i);
      f = eb - 16 | 0;
      eb = f;
      c = eb - 32 | 0;
      eb = c;
      ed(c + 24 | 0, e, d);
      d = eb - 16 | 0;
      eb = d;
      m = k;
      g = v[c + 28 >> 2];
      i = v[c + 24 >> 2];
      k = g - i | 0;
      m = m - k | 0;
      v[d + 12 >> 2] = m;
      rY(m, i, k >> 2);
      pc(c + 16 | 0, g, d + 12 | 0);
      eb = d + 16 | 0;
      d = v[c + 16 >> 2];
      v[c + 12 >> 2] = v[c + 20 >> 2];
      pc(f + 8 | 0, d, c + 12 | 0);
      eb = c + 32 | 0;
      eb = f + 16 | 0;
      eb = j + 16 | 0;
     } else {
      bp(g, x[c >> 1] | x[c + 2 >> 1] << 16);
      g = g + 4 | 0;
      v[i + 4 >> 2] = g;
      c = c + 4 | 0;
      continue;
     }
     break;
    }
    t[e + 2 | 0] = w[h + 2 | 0];
    u[e >> 1] = x[h >> 1];
   }
   vb(e);
   eb = n + 32 | 0;
   break a;
  }
  t[a + 14 | 0] = e - 1;
 }
 if ((b | 0) != 16777216) {
  t[a + 17 | 0] = 255;
 }
 eb = l + 16 | 0;
}

function vk(a, b, c, d, e) {
 var f = 0, g = 0, h = 0, i = 0, j = 0, k = 0;
 i = eb - 16 | 0;
 eb = i;
 a: {
  if (!d) {
   break a;
  }
  g = v[c >> 2];
  if (!g) {
   break a;
  }
  b: {
   c: {
    d: {
     e: {
      f = v[a + 480180 >> 2];
      if ((f | 0) != 512) {
       if ((f | 0) != 64) {
        break e;
       }
       f = B(d, 20) + g | 0;
       break d;
      }
      f = ((B(d, 36318) | 0) / 1024 | 0) + g | 0;
      break d;
     }
     f: {
      g: {
       if (w[a + 480208 | 0] & 16) {
        if ((f | 0) == 4) {
         break g;
        }
        f = d >> 31;
        v[i + 12 >> 2] = (f ^ d) - f;
        wc(i + 12 | 0, 1020);
        h = v[i + 12 >> 2];
        f = c;
        h: {
         if ((d | 0) > 0) {
          if (h >>> 0 <= 15) {
           h = v[(h << 2) + (Nb(a + 1074312 | 0, 7) ? 35344 : 35408) >> 2];
           break h;
          }
          h = v[(h & -4) + (Nb(a + 1074312 | 0, 7) ? 35472 : 36496) >> 2];
          break h;
         }
         if (h >>> 0 <= 15) {
          h = v[(h << 2) + (Nb(a + 1074312 | 0, 7) ? 35408 : 35344) >> 2];
          break h;
         }
         h = v[(h & -4) + (Nb(a + 1074312 | 0, 7) ? 36496 : 35472) >> 2];
        }
        j = Aua(h, h >> 31, g, g >> 31);
        h = gb;
        j = j + 32768 | 0;
        h = j >>> 0 < 32768 ? h + 1 | 0 : h;
        k = f;
        f = Fc(Bua(j, h, 65536, 0), gb);
        v[k >> 2] = f;
        if ((g | 0) != (f | 0)) {
         break c;
        }
        f = Nb(a + 1074312 | 0, 7);
        g = v[c >> 2];
        if (!((d | 0) > 0 ^ f)) {
         f = 2147483647;
         d = 1;
         if ((g | 0) == 2147483647) {
          break c;
         }
         break f;
        }
        d = -1;
        if ((g | 0) >= 2) {
         break f;
        }
        f = g;
        break c;
       }
       f = Nb(a + 1074312 | 0, 7);
       g = v[c >> 2];
       if (!f) {
        break g;
       }
       if ((d | 0) < 0) {
        f = Aua(g, 0, 14317456, 0);
        h = gb;
        g = Aua(g, 0, 0 - d | 0, 0);
        d = gb;
        g = g + 14317456 | 0;
        d = g >>> 0 < 14317456 ? d + 1 | 0 : d;
        f = OS(Cua(f, h, g, d), gb);
        break d;
       }
       d = Aua(g, g >> 31, d, 0);
       f = gb;
       if ((f | 0) >= 0 & d >>> 0 >= 14317456 | (f | 0) > 0) {
        if (e) {
         v[c >> 2] = 2147483647;
         break a;
        }
        v[c >> 2] = 0;
        v[b + 696 >> 2] = 0;
        v[b + 88 >> 2] = v[b + 88 >> 2] | 2101248;
        break a;
       }
       d = OS(Cua(Aua(g, 0, 14317456, 0), gb, 14317456 - d | 0, 0 - (f + (d >>> 0 > 14317456) | 0) | 0), gb);
       v[c >> 2] = d;
       if ((d | 0) <= 0) {
        break b;
       }
       break a;
      }
      f = g - d | 0;
      break d;
     }
     f = d + g | 0;
    }
    v[c >> 2] = f;
   }
   if ((f | 0) > 0) {
    break a;
   }
  }
  v[c >> 2] = 1;
  if (v[a + 480180 >> 2] != 2 | e) {
   break a;
  }
  v[b + 696 >> 2] = 0;
  v[b + 88 >> 2] = v[b + 88 >> 2] | 2101248;
 }
 eb = i + 16 | 0;
}

function Ola(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, w = 0, x = 0, y = 0, z = 0, A = 0, C = 0, D = 0, E = 0, F = 0, G = 0, H = 0, I = 0, J = 0;
 f = eb - 48 | 0;
 eb = f;
 y = v[a + 16 >> 2];
 v[f + 32 >> 2] = v[a + 44 >> 2];
 v[f + 36 >> 2] = v[a + 48 >> 2];
 v[f + 40 >> 2] = v[a + 52 >> 2];
 v[f + 44 >> 2] = v[a + 56 >> 2];
 k = v[a + 40 >> 2];
 l = v[a + 36 >> 2];
 i = v[a + 4 >> 2];
 v[f + 16 >> 2] = v[a >> 2];
 v[f + 20 >> 2] = i;
 z = b + 24 | 0;
 A = f + 32 | 0;
 C = v[a + 32 >> 2];
 D = v[a + 28 >> 2];
 E = v[a + 72 >> 2];
 t = v[a + 68 >> 2];
 F = t >> 31;
 w = v[a + 64 >> 2];
 G = w >> 31;
 x = v[a + 60 >> 2];
 H = x >> 31;
 I = v[a + 8 >> 2];
 J = v[a + 12 >> 2];
 while (1) {
  if (d) {
   b = v[f + 16 >> 2];
   o = ((((v[f + 20 >> 2] & 2147483647) << 1 | b >>> 31) & 2147483646) << 1) + y | 0;
   b = (((b >>> 16 | 0) + 4 & 131064) << 1) + z | 0;
   j = u[b + 14 >> 1];
   p = u[b + 12 >> 1];
   s = u[b + 10 >> 1];
   g = u[b + 8 >> 1];
   q = u[b + 6 >> 1];
   h = u[b + 4 >> 1];
   e = u[b + 2 >> 1];
   i = u[b >> 1];
   b = 0;
   m = 0;
   while (1) {
    if ((m | 0) != 2) {
     r = m << 1;
     n = r + o | 0;
     v[(f + 8 | 0) + (m << 2) >> 2] = (((((B(u[n + 8 >> 1], s) + B(u[n + 4 >> 1], g) | 0) + B(u[n + 12 >> 1], p) | 0) + B(j, u[n + 16 >> 1]) | 0) / 2 | 0) + ((((B(u[o + (r | -8) >> 1], e) + B(u[o + (r | -12) >> 1], i) | 0) + B(u[o + (r | -4) >> 1], h) | 0) + B(u[n >> 1], q) | 0) / 2 | 0) | 0) / 16384;
     m = m + 1 | 0;
     continue;
    }
    break;
   }
   while (1) {
    if ((b | 0) != 2) {
     p = (f + 8 | 0) + (b << 2) | 0;
     e = v[p >> 2];
     i = (b << 3) + A | 0;
     s = v[i + 4 >> 2];
     g = v[i >> 2];
     v[i + 4 >> 2] = g;
     q = e << 8;
     e = q;
     e = Aua(e, e >> 31, x, H);
     h = gb;
     j = e;
     e = Xb(g, -16777216, 16776704);
     e = Aua(w, G, e, e >> 31);
     g = j + e | 0;
     j = gb + h | 0;
     j = e >>> 0 > g >>> 0 ? j + 1 | 0 : j;
     e = Xb(s, -16777216, 16776704);
     h = Aua(t, F, e, e >> 31);
     g = h + g | 0;
     e = gb + j | 0;
     e = g >>> 0 < h >>> 0 ? e + 1 | 0 : e;
     h = g + 8388608 | 0;
     e = h >>> 0 < 8388608 ? e + 1 | 0 : e;
     e = Rc(h, e, 24);
     v[i >> 2] = e - (q & E);
     v[p >> 2] = (e | 0) / 256;
     b = b + 1 | 0;
     continue;
    }
    break;
   }
   l = l + D | 0;
   v[c >> 2] = v[c >> 2] + B(v[f + 8 >> 2], l >> 12);
   k = k + C | 0;
   v[c + 4 >> 2] = v[c + 4 >> 2] + B(v[f + 12 >> 2], k >> 12);
   Ob(f + 16 | 0, I, J);
   c = c + 8 | 0;
   d = d - 1 | 0;
   continue;
  }
  break;
 }
 b = v[f + 20 >> 2];
 v[a >> 2] = v[f + 16 >> 2];
 v[a + 4 >> 2] = b;
 v[a + 40 >> 2] = k;
 v[a + 20 >> 2] = l >> 12;
 v[a + 36 >> 2] = l;
 v[a + 24 >> 2] = k >> 12;
 v[a + 44 >> 2] = v[f + 32 >> 2];
 v[a + 48 >> 2] = v[f + 36 >> 2];
 v[a + 52 >> 2] = v[f + 40 >> 2];
 v[a + 56 >> 2] = v[f + 44 >> 2];
 eb = f + 48 | 0;
}

function IR(a, b, c, d) {
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0;
 g = eb - 16 | 0;
 eb = g;
 f = B(b, 872) + a | 0;
 e = f + 1074992 | 0;
 a: {
  b: {
   f = v[f + 1075080 >> 2];
   if (f & 131072) {
    f = v[a + 480180 >> 2];
    j = 1;
    c: {
     d: {
      e: {
       h = v[a + 480208 >> 2];
       if (h & 4096) {
        if (!(f & 16777248)) {
         break e;
        }
        j = !(h & 4);
       }
       if ((f | 0) != 64) {
        break d;
       }
       break b;
      }
      if ((f | 0) == 64) {
       break b;
      }
      h = a + 480180 | 0;
      j = 0;
      break c;
     }
     h = a + 480180 | 0;
     if (!j) {
      break c;
     }
     Ib(g + 8 | 0, a + 1074312 | 0, 21);
     if (!Fb(v[v[g + 8 >> 2] >> 2], v[g + 12 >> 2])) {
      break c;
     }
     t[e + 819 | 0] = w[e + 819 | 0] + (w[e + 823 | 0] << 2);
    }
    f = LA(a, w[e + 822 | 0], w[e + 819 | 0]);
    f: {
     if (Jj(v[e + 656 >> 2])) {
      z[d >> 2] = z[d >> 2] + C(C(C(B(w[e + 824 | 0], f) | 0) * C(.05000000074505806)) / C(7680));
      b = w[e + 851 | 0];
      t[e + 851 | 0] = b & 159 | 64;
      if (v[a + 1074416 >> 2] != (v[a + 1074392 >> 2] + 1 | 0)) {
       break f;
      }
      t[e + 851 | 0] = b | 96;
      break f;
     }
     d = v[a + 480208 >> 2];
     if ((d & 2101248) == 2101248) {
      break a;
     }
     i = v[h >> 2];
     if (d & 4096 ? i & 67633152 : 0) {
      break a;
     }
     if (i & 5) {
      f = (w[e + 822 | 0] & 3) == 1 ? 0 - f | 0 : f;
     }
     k = a + 1074312 | 0;
     Ib(g + 8 | 0, k, 21);
     i = v[a + 480208 >> 2];
     g: {
      if (Fb(v[v[g + 8 >> 2] >> 2], v[g + 12 >> 2])) {
       d = i & 4;
       f = d ? f : 0 - f | 0;
       d = d ? 5 : 6;
       break g;
      }
      d = 5;
      h: {
       if (i & 131072) {
        break h;
       }
       h = v[h >> 2];
       d = 8;
       if ((h | 0) == 1024) {
        break h;
       }
       d = 7;
       if (h & 524304) {
        break h;
       }
       d = h & 16777248 ? i & 4 ? 6 : 7 : 6;
      }
      Ib(g + 8 | 0, k, 80);
      if (!Fb(v[v[g + 8 >> 2] >> 2], v[g + 12 >> 2])) {
       break g;
      }
      d = w[e + 791 | 0] == 26 ? d + 2 | 0 : d;
     }
     d = 0 - ((B(w[e + 824 | 0], f) | 0) / (1 << d) | 0) | 0;
     vk(a, e, c, d, 0);
     f = v[e + 656 >> 2];
     c = Eq(a, v[e + 88 >> 2], f);
     if (!c) {
      break f;
     }
     hb[v[v[c >> 2] + 92 >> 2]](c, d, (f ? w[f + 33 | 0] : 2) << 24 >> 24, b);
    }
    if (!j) {
     break a;
    }
    Ib(g + 8 | 0, a + 1074312 | 0, 21);
    if (Fb(v[v[g + 8 >> 2] >> 2], v[g + 12 >> 2])) {
     break a;
    }
    t[e + 819 | 0] = w[e + 819 | 0] + w[e + 823 | 0];
    break a;
   }
   if (!(w[e + 670 | 0] & 2)) {
    break a;
   }
   a = Eq(a, f, v[e + 656 >> 2]);
   if (!a) {
    break a;
   }
   hb[v[v[a >> 2] + 92 >> 2]](a, 0, 0, b);
   break a;
  }
  a = w[e + 819 | 0];
  if (a & 1) {
   v[c >> 2] = v[c >> 2] + B(w[e + 824 | 0], 167);
  }
  t[e + 819 | 0] = a + 1;
 }
 eb = g + 16 | 0;
}

function aJ(a, b, c, d, e, f, g, h) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 f = f | 0;
 g = g | 0;
 h = h | 0;
 var i = 0, j = 0, k = 0;
 a = eb - 16 | 0;
 eb = a;
 v[a + 12 >> 2] = c;
 v[a + 8 >> 2] = f;
 v[a + 12 >> 2] = c;
 v[a + 8 >> 2] = f;
 a: {
  b: {
   c: {
    while (1) {
     c = v[a + 12 >> 2];
     if (!(c >>> 0 >= d >>> 0 | f >>> 0 >= g >>> 0)) {
      i = t[c | 0];
      j = i & 255;
      d: {
       if ((i | 0) >= 0) {
        u[f >> 1] = j;
        b = c + 1 | 0;
        break d;
       }
       b = 2;
       if (i >>> 0 < 4294967234) {
        break b;
       }
       if (i >>> 0 <= 4294967263) {
        if ((d - c | 0) < 2) {
         break c;
        }
        i = w[c + 1 | 0];
        if ((i & 192) != 128) {
         break a;
        }
        u[f >> 1] = i & 63 | j << 6 & 1984;
        b = c + 2 | 0;
        break d;
       }
       if (i >>> 0 <= 4294967279) {
        if ((d - c | 0) < 3) {
         break c;
        }
        k = w[c + 2 | 0];
        i = w[c + 1 | 0];
        e: {
         f: {
          if ((j | 0) != 237) {
           if ((j | 0) != 224) {
            break f;
           }
           if ((i & 224) == 160) {
            break e;
           }
           break a;
          }
          if ((i & 224) == 128) {
           break e;
          }
          break a;
         }
         if ((i & 192) != 128) {
          break a;
         }
        }
        if ((k & 192) != 128) {
         break a;
        }
        u[f >> 1] = k & 63 | ((i & 63) << 6 | j << 12);
        b = c + 3 | 0;
        break d;
       }
       if (i >>> 0 > 4294967284) {
        break b;
       }
       b = 1;
       if ((d - c | 0) < 4) {
        break a;
       }
       k = w[c + 3 | 0];
       i = w[c + 2 | 0];
       c = w[c + 1 | 0];
       g: {
        h: {
         switch (j - 240 | 0) {
         case 0:
          if ((c + 112 & 255) >>> 0 >= 48) {
           break b;
          }
          break g;

         case 4:
          if ((c & 240) != 128) {
           break b;
          }
          break g;

         default:
          break h;
         }
        }
        if ((c & 192) != 128) {
         break b;
        }
       }
       if ((i & 192) != 128 | (k & 192) != 128) {
        break b;
       }
       if ((g - f | 0) < 4) {
        break a;
       }
       b = 2;
       j = j & 7;
       if ((c << 12 & 196608 | j << 18) >>> 0 > 1114111) {
        break a;
       }
       b = c << 2;
       u[f >> 1] = (i >>> 4 & 3 | (b & 192 | j << 8 | b & 60)) + 16320 | 55296;
       v[a + 8 >> 2] = f + 2;
       u[f + 2 >> 1] = i << 6 & 960 | k & 63 | 56320;
       b = v[a + 12 >> 2] + 4 | 0;
      }
      v[a + 12 >> 2] = b;
      f = v[a + 8 >> 2] + 2 | 0;
      v[a + 8 >> 2] = f;
      continue;
     }
     break;
    }
    b = c >>> 0 < d >>> 0;
    break a;
   }
   b = 1;
   break a;
  }
  b = 2;
 }
 v[e >> 2] = v[a + 12 >> 2];
 v[h >> 2] = v[a + 8 >> 2];
 eb = a + 16 | 0;
 return b | 0;
}

function Pla(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, w = 0, x = 0, y = 0, z = 0, A = 0, C = 0, D = 0, E = 0, F = 0, G = 0, H = 0, I = 0, J = 0;
 f = eb - 48 | 0;
 eb = f;
 y = v[a + 16 >> 2];
 v[f + 32 >> 2] = v[a + 44 >> 2];
 v[f + 36 >> 2] = v[a + 48 >> 2];
 v[f + 40 >> 2] = v[a + 52 >> 2];
 v[f + 44 >> 2] = v[a + 56 >> 2];
 k = v[a + 40 >> 2];
 l = v[a + 36 >> 2];
 q = v[a + 4 >> 2];
 v[f + 16 >> 2] = v[a >> 2];
 v[f + 20 >> 2] = q;
 z = b + 24 | 0;
 A = f + 32 | 0;
 C = v[a + 32 >> 2];
 D = v[a + 28 >> 2];
 E = v[a + 72 >> 2];
 s = v[a + 68 >> 2];
 F = s >> 31;
 w = v[a + 64 >> 2];
 G = w >> 31;
 x = v[a + 60 >> 2];
 H = x >> 31;
 q = v[a + 8 >> 2];
 I = v[a + 12 >> 2];
 while (1) {
  if (d) {
   b = v[f + 16 >> 2];
   J = (((v[f + 20 >> 2] & 2147483647) << 1 | b >>> 31) & -2) + y | 0;
   b = (((b >>> 16 | 0) + 4 & 131064) << 1) + z | 0;
   j = u[b + 10 >> 1] << 8;
   o = u[b + 8 >> 1] << 8;
   r = u[b + 12 >> 1] << 8;
   g = u[b + 14 >> 1] << 8;
   p = u[b + 2 >> 1] << 8;
   i = u[b >> 1] << 8;
   e = u[b + 4 >> 1] << 8;
   b = u[b + 6 >> 1] << 8;
   m = 0;
   n = 0;
   while (1) {
    if ((n | 0) != 2) {
     h = n + J | 0;
     v[(f + 8 | 0) + (n << 2) >> 2] = ((((B(j, t[h + 4 | 0]) + B(o, t[h + 2 | 0]) | 0) + B(t[h + 6 | 0], r) | 0) + B(t[h + 8 | 0], g) >> 1) + (((B(t[h - 4 | 0], p) + B(t[h - 6 | 0], i) | 0) + B(t[h - 2 | 0], e) | 0) + B(t[h | 0], b) >> 1) | 0) / 16384;
     n = n + 1 | 0;
     continue;
    }
    break;
   }
   while (1) {
    if ((m | 0) != 2) {
     o = (f + 8 | 0) + (m << 2) | 0;
     e = v[o >> 2];
     b = (m << 3) + A | 0;
     r = v[b + 4 >> 2];
     g = v[b >> 2];
     v[b + 4 >> 2] = g;
     p = e << 8;
     e = p;
     e = Aua(e, e >> 31, x, H);
     i = gb;
     h = e;
     e = Xb(g, -16777216, 16776704);
     e = Aua(w, G, e, e >> 31);
     g = h + e | 0;
     j = gb + i | 0;
     j = e >>> 0 > g >>> 0 ? j + 1 | 0 : j;
     e = Xb(r, -16777216, 16776704);
     i = Aua(s, F, e, e >> 31);
     g = i + g | 0;
     e = gb + j | 0;
     e = g >>> 0 < i >>> 0 ? e + 1 | 0 : e;
     i = g + 8388608 | 0;
     e = i >>> 0 < 8388608 ? e + 1 | 0 : e;
     e = Rc(i, e, 24);
     v[b >> 2] = e - (p & E);
     v[o >> 2] = (e | 0) / 256;
     m = m + 1 | 0;
     continue;
    }
    break;
   }
   l = l + D | 0;
   v[c >> 2] = v[c >> 2] + B(v[f + 8 >> 2], l >> 12);
   k = k + C | 0;
   v[c + 4 >> 2] = v[c + 4 >> 2] + B(v[f + 12 >> 2], k >> 12);
   Ob(f + 16 | 0, q, I);
   c = c + 8 | 0;
   d = d - 1 | 0;
   continue;
  }
  break;
 }
 b = v[f + 20 >> 2];
 v[a >> 2] = v[f + 16 >> 2];
 v[a + 4 >> 2] = b;
 v[a + 40 >> 2] = k;
 v[a + 20 >> 2] = l >> 12;
 v[a + 36 >> 2] = l;
 v[a + 24 >> 2] = k >> 12;
 v[a + 44 >> 2] = v[f + 32 >> 2];
 v[a + 48 >> 2] = v[f + 36 >> 2];
 v[a + 52 >> 2] = v[f + 40 >> 2];
 v[a + 56 >> 2] = v[f + 44 >> 2];
 eb = f + 48 | 0;
}

function A1(a, b, c, d, e) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 var f = 0, g = 0, h = 0, i = 0, j = 0, k = 0;
 f = eb - 48 | 0;
 eb = f;
 g = Ji(b) ^ -1;
 a: {
  if (nc(v[d >> 2], v[d + 4 >> 2]) >>> 0 <= g >>> 0) {
   yu(a);
   break a;
  }
  Ji(b);
  if ((w[c + 4 | 0] | w[c + 5 | 0] << 8) >>> 0 >= 60) {
   Ub(b, 4);
  }
  j = f, k = Ji(b), v[j + 44 >> 2] = k;
  Ub(b, 4);
  h = Ji(b);
  i = Ji(b);
  if (!((h | 0) > 0 & (i | 0) > 36)) {
   yu(a);
   break a;
  }
  if (!Md(Ud(v[e >> 2], v[xb(v[d >> 2], g) >> 2]), 13165)) {
   yu(a);
   break a;
  }
  e = f + 4 | 0;
  uF(e, b, i, h);
  d = gc(f + 24 | 0, e);
  tb(e);
  b = v[d >> 2];
  v[31601] = 0;
  b = Q(172, b | 0) | 0;
  e = v[31601];
  v[31601] = 0;
  b: {
   if ((e | 0) == 1) {
    break b;
   }
   c: {
    d: {
     if (!b) {
      v[31601] = 0;
      Q(182, a | 0) | 0;
      a = v[31601];
      v[31601] = 0;
      if ((a | 0) != 1) {
       break d;
      }
      break b;
     }
     b = w[c + 4 | 0] | w[c + 5 | 0] << 8;
     if (b >>> 0 <= 39) {
      v[31601] = 0;
      O(183, d | 0, 8) | 0;
      b = v[31601];
      v[31601] = 0;
      if ((b | 0) == 1) {
       break b;
      }
      b = w[c + 4 | 0] | w[c + 5 | 0] << 8;
     }
     if ((b & 65535) >>> 0 <= 59) {
      v[31601] = 0;
      O(183, d | 0, 16) | 0;
      b = v[31601];
      v[31601] = 0;
      if ((b | 0) == 1) {
       break b;
      }
     }
     v[31601] = 0;
     Q(184, d | 0) | 0;
     b = v[31601];
     v[31601] = 0;
     if ((b | 0) == 1) {
      break b;
     }
     e: {
      f: {
       b = w[c + 4 | 0] | w[c + 5 | 0] << 8;
       g: {
        if (b >>> 0 >= 120) {
         v[31601] = 0;
         Q(184, d | 0) | 0;
         c = v[31601];
         v[31601] = 0;
         b = 8;
         break g;
        }
        h: {
         if (b >>> 0 >= 100) {
          v[31601] = 0;
          O(183, d | 0, 4) | 0;
          b = v[31601];
          v[31601] = 0;
          if ((b | 0) == 1) {
           break b;
          }
          break h;
         }
         if (b >>> 0 < 62) {
          break f;
         }
        }
        v[31601] = 0;
        Q(184, d | 0) | 0;
        c = v[31601];
        v[31601] = 0;
        b = 4;
       }
       if ((c | 0) == 1) {
        break b;
       }
       v[31601] = 0;
       O(183, d | 0, b | 0) | 0;
       break e;
      }
      v[31601] = 0;
      Q(184, d | 0) | 0;
     }
     b = v[31601];
     v[31601] = 0;
     if ((b | 0) == 1) {
      break b;
     }
     v[31601] = 0;
     c = Q(184, d | 0) | 0;
     b = v[31601];
     v[31601] = 0;
     if ((b | 0) == 1) {
      break c;
     }
     v[31601] = 0;
     b = f + 4 | 0;
     R(185, b | 0, d | 0, c | 0);
     c = v[31601];
     v[31601] = 0;
     if ((c | 0) == 1) {
      break c;
     }
     j = gc(a, b), k = v[f + 44 >> 2], v[j + 20 >> 2] = k;
     tb(b);
    }
    tb(d);
    break a;
   }
  }
  a = M() | 0;
  tb(d);
  P(a | 0);
  p();
 }
 eb = f + 48 | 0;
}

function H7(a, b, c, d, e, f, g, h) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 f = f | 0;
 g = g | 0;
 h = h | 0;
 var i = 0, j = 0, k = 0, l = 0, m = 0;
 m = b;
 i = eb - 416 | 0;
 eb = i;
 t[i + 412 | 0] = 0;
 t[i + 413 | 0] = 0;
 t[i + 414 | 0] = 0;
 t[i + 415 | 0] = 0;
 t[i + 409 | 0] = 0;
 t[i + 410 | 0] = 0;
 t[i + 411 | 0] = 0;
 t[i + 412 | 0] = 0;
 t[i + 408 | 0] = 37;
 l = qt(i + 409 | 0, 13905, v[c + 4 >> 2]);
 b = i + 368 | 0;
 v[i + 364 >> 2] = b;
 a = Nd();
 a: {
  if (l) {
   j = v[c + 8 >> 2];
   k = i - -64 | 0;
   v[k >> 2] = g;
   v[k + 4 >> 2] = h;
   v[i + 56 >> 2] = e;
   v[i + 60 >> 2] = f;
   v[i + 48 >> 2] = j;
   j = oh(b, 30, a, i + 408 | 0, i + 48 | 0);
   break a;
  }
  v[i + 80 >> 2] = e;
  v[i + 84 >> 2] = f;
  v[i + 88 >> 2] = g;
  v[i + 92 >> 2] = h;
  j = oh(i + 368 | 0, 30, a, i + 408 | 0, i + 80 | 0);
 }
 v[i + 128 >> 2] = 1238;
 k = Ce(i + 356 | 0, 0, i + 128 | 0);
 b = i + 368 | 0;
 a = b;
 b: {
  c: {
   d: {
    e: {
     if ((j | 0) >= 30) {
      a = Nd();
      f: {
       if (l) {
        j = v[c + 8 >> 2];
        v[i + 16 >> 2] = g;
        v[i + 20 >> 2] = h;
        v[i + 8 >> 2] = e;
        v[i + 12 >> 2] = f;
        v[i >> 2] = j;
        j = hj(i + 364 | 0, a, i + 408 | 0, i);
        break f;
       }
       v[i + 32 >> 2] = e;
       v[i + 36 >> 2] = f;
       v[i + 40 >> 2] = g;
       v[i + 44 >> 2] = h;
       j = hj(i + 364 | 0, a, i + 408 | 0, i + 32 | 0);
      }
      if ((j | 0) == -1) {
       v[31601] = 0;
       W(1239);
       a = v[31601];
       v[31601] = 0;
       if ((a | 0) == 1) {
        break d;
       }
       break e;
      }
      a = v[i + 364 >> 2];
      Qe(k, a);
     }
     f = a + j | 0;
     g = ij(a, f, v[c + 4 >> 2]);
     v[i + 116 >> 2] = 1238;
     e = Ce(i + 120 | 0, 0, i + 116 | 0);
     g: {
      h: {
       if ((i + 368 | 0) == (a | 0)) {
        j = i + 128 | 0;
        break h;
       }
       j = Fd(j << 3);
       if (!j) {
        v[31601] = 0;
        W(1239);
        a = v[31601];
        v[31601] = 0;
        if ((a | 0) != 1) {
         break e;
        }
        a = M() | 0;
        break g;
       }
       Qe(e, j);
       b = a;
      }
      a = i + 108 | 0;
      bd(a, v[c + 28 >> 2]);
      v[31601] = 0;
      fa(1271, b | 0, g | 0, f | 0, j | 0, i + 116 | 0, i + 112 | 0, a | 0);
      b = v[31601];
      v[31601] = 0;
      i: {
       if ((b | 0) != 1) {
        Zb(a);
        v[31601] = 0;
        a = da(1272, m | 0, j | 0, v[i + 116 >> 2], v[i + 112 >> 2], c | 0, d | 0) | 0;
        b = v[31601];
        v[31601] = 0;
        if ((b | 0) == 1) {
         break i;
        }
        Kc(e);
        Kc(k);
        eb = i + 416 | 0;
        break b;
       }
       a = M() | 0;
       Zb(i + 108 | 0);
       break g;
      }
      a = M() | 0;
     }
     Kc(e);
     break c;
    }
    p();
   }
   a = M() | 0;
  }
  Kc(k);
  P(a | 0);
  p();
 }
 return a | 0;
}

function pe(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0;
 a: {
  b: {
   c: {
    switch (b | 0) {
    case 1:
     b = Eb(a);
     d = w[c + 11 | 0];
     e = v[c + 4 >> 2];
     a = 0;
     v[31601] = 0;
     N(53, b | 0, Zc(e, d) | 0);
     d = v[31601];
     v[31601] = 0;
     d: {
      if ((d | 0) != 1) {
       e: {
        while (1) {
         if (Zc(v[c + 4 >> 2], w[c + 11 | 0]) >>> 0 > a >>> 0) {
          d = t[dc(c, a) | 0];
          v[31601] = 0;
          N(35, b | 0, ((d | 0) < 0 ? 65533 : d & 255) | 0);
          d = v[31601];
          v[31601] = 0;
          if ((d | 0) == 1) {
           break e;
          }
          a = a + 1 | 0;
          continue;
         }
         break;
        }
        break d;
       }
      }
      break a;
     }
     return;

    case 2:
     b = Eb(a);
     d = w[c + 11 | 0];
     e = v[c + 4 >> 2];
     a = 0;
     v[31601] = 0;
     N(53, b | 0, Zc(e, d) | 0);
     d = v[31601];
     v[31601] = 0;
     f: {
      if ((d | 0) != 1) {
       while (1) {
        if (Zc(v[c + 4 >> 2], w[c + 11 | 0]) >>> 0 <= a >>> 0) {
         break f;
        }
        d = w[dc(c, a) | 0];
        v[31601] = 0;
        N(35, b | 0, d | 0);
        d = v[31601];
        v[31601] = 0;
        if ((d | 0) != 1) {
         a = a + 1 | 0;
         continue;
        }
        break;
       }
      }
      break a;
     }
     return;

    case 3:
     gf(a, c, 48832);
     return;

    case 4:
     gf(a, c, 49856);
     return;

    case 5:
     gf(a, c, 50880);
     return;

    case 6:
     gf(a, c, 51904);
     return;

    case 7:
     gf(a, c, 52928);
     return;

    case 8:
     gf(a, c, 53952);
     return;

    case 9:
     gf(a, c, 54976);
     return;

    case 10:
     gf(a, c, 56e3);
     return;

    case 11:
     gf(a, c, 57024);
     return;

    case 12:
     gf(a, c, 58048);
     return;

    case 13:
     gf(a, c, 59072);
     return;

    case 14:
     gf(a, c, 60096);
     return;

    case 15:
     gf(a, c, 61120);
     return;

    case 16:
     gf(a, c, 62144);
     return;

    case 17:
     gf(a, c, 63168);
     return;

    case 18:
     gf(a, c, 64192);
     return;

    case 19:
     gf(a, c, 65216);
     return;

    case 20:
     gf(a, c, 66240);
     return;

    case 21:
     gf(a, c, 67264);
     return;

    case 22:
     gf(a, c, 68288);
     return;

    case 23:
     gf(a, c, 69312);
     return;

    case 24:
     aB(a, c, 70336);
     return;

    case 25:
     aB(a, c, 48832);
     return;

    case 26:
     aB(a, c, 67264);
     return;

    default:
     a = cc(8);
     v[31601] = 0;
     b = O(16, a | 0, 11106) | 0;
     c = v[31601];
     v[31601] = 0;
     if ((c | 0) != 1) {
      break b;
     }
     b = M() | 0;
     jc(a);
     P(b | 0);
     p();

    case 0:
     break c;
    }
   }
   r_(a, c);
   return;
  }
  ca(b | 0, 124640, 17);
  p();
 }
 a = M() | 0;
 Tb(b);
 P(a | 0);
 p();
}

function R7(a, b, c, d, e, f, g, h) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 f = f | 0;
 g = g | 0;
 h = h | 0;
 var i = 0, j = 0, k = 0, l = 0, m = 0;
 m = b;
 i = eb - 256 | 0;
 eb = i;
 t[i + 252 | 0] = 0;
 t[i + 253 | 0] = 0;
 t[i + 254 | 0] = 0;
 t[i + 255 | 0] = 0;
 t[i + 249 | 0] = 0;
 t[i + 250 | 0] = 0;
 t[i + 251 | 0] = 0;
 t[i + 252 | 0] = 0;
 t[i + 248 | 0] = 37;
 l = qt(i + 249 | 0, 13905, v[c + 4 >> 2]);
 b = i + 208 | 0;
 v[i + 204 >> 2] = b;
 a = Nd();
 a: {
  if (l) {
   j = v[c + 8 >> 2];
   k = i - -64 | 0;
   v[k >> 2] = g;
   v[k + 4 >> 2] = h;
   v[i + 56 >> 2] = e;
   v[i + 60 >> 2] = f;
   v[i + 48 >> 2] = j;
   j = oh(b, 30, a, i + 248 | 0, i + 48 | 0);
   break a;
  }
  v[i + 80 >> 2] = e;
  v[i + 84 >> 2] = f;
  v[i + 88 >> 2] = g;
  v[i + 92 >> 2] = h;
  j = oh(i + 208 | 0, 30, a, i + 248 | 0, i + 80 | 0);
 }
 v[i + 128 >> 2] = 1238;
 k = Ce(i + 196 | 0, 0, i + 128 | 0);
 b = i + 208 | 0;
 a = b;
 b: {
  c: {
   d: {
    e: {
     if ((j | 0) >= 30) {
      a = Nd();
      f: {
       if (l) {
        j = v[c + 8 >> 2];
        v[i + 16 >> 2] = g;
        v[i + 20 >> 2] = h;
        v[i + 8 >> 2] = e;
        v[i + 12 >> 2] = f;
        v[i >> 2] = j;
        j = hj(i + 204 | 0, a, i + 248 | 0, i);
        break f;
       }
       v[i + 32 >> 2] = e;
       v[i + 36 >> 2] = f;
       v[i + 40 >> 2] = g;
       v[i + 44 >> 2] = h;
       j = hj(i + 204 | 0, a, i + 248 | 0, i + 32 | 0);
      }
      if ((j | 0) == -1) {
       v[31601] = 0;
       W(1239);
       a = v[31601];
       v[31601] = 0;
       if ((a | 0) == 1) {
        break d;
       }
       break e;
      }
      a = v[i + 204 >> 2];
      Qe(k, a);
     }
     f = a + j | 0;
     g = ij(a, f, v[c + 4 >> 2]);
     v[i + 116 >> 2] = 1238;
     e = Ce(i + 120 | 0, 0, i + 116 | 0);
     g: {
      h: {
       if ((i + 208 | 0) == (a | 0)) {
        j = i + 128 | 0;
        break h;
       }
       j = Fd(j << 1);
       if (!j) {
        v[31601] = 0;
        W(1239);
        a = v[31601];
        v[31601] = 0;
        if ((a | 0) != 1) {
         break e;
        }
        a = M() | 0;
        break g;
       }
       Qe(e, j);
       b = a;
      }
      a = i + 108 | 0;
      bd(a, v[c + 28 >> 2]);
      v[31601] = 0;
      fa(1266, b | 0, g | 0, f | 0, j | 0, i + 116 | 0, i + 112 | 0, a | 0);
      b = v[31601];
      v[31601] = 0;
      i: {
       if ((b | 0) != 1) {
        Zb(a);
        v[31601] = 0;
        a = da(23, m | 0, j | 0, v[i + 116 >> 2], v[i + 112 >> 2], c | 0, d | 0) | 0;
        b = v[31601];
        v[31601] = 0;
        if ((b | 0) == 1) {
         break i;
        }
        Kc(e);
        Kc(k);
        eb = i + 256 | 0;
        break b;
       }
       a = M() | 0;
       Zb(i + 108 | 0);
       break g;
      }
      a = M() | 0;
     }
     Kc(e);
     break c;
    }
    p();
   }
   a = M() | 0;
  }
  Kc(k);
  P(a | 0);
  p();
 }
 return a | 0;
}

function t1(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0;
 g = eb - 1088 | 0;
 eb = g;
 e = Xh(a);
 Qb(e + 20 | 0, 0, 1040);
 v[e + 1064 >> 2] = 0;
 v[e + 1068 >> 2] = 0;
 v[e + 1060 >> 2] = c;
 t[e + 1084 | 0] = d;
 a = e + 1072 | 0;
 v[a >> 2] = 0;
 v[a + 4 >> 2] = 0;
 v[e + 1080 >> 2] = 0;
 i = e + 1064 | 0;
 a = c;
 d = 0;
 a: {
  b: {
   c: while (1) {
    if (Zd(x[a + 34 >> 1]) >>> 0 <= d >>> 0) {
     break a;
    }
    v[e + 1064 >> 2] = 0;
    v[e + 1068 >> 2] = 0;
    a = 0;
    while (1) {
     d: {
      e: {
       f: {
        g: {
         h: {
          i: {
           j: {
            if (y[c >> 2] <= a >>> 0) {
             break j;
            }
            a = v[b + 8 >> 2];
            f = v[b >> 2];
            v[31601] = 0;
            a = T(150, f | 0, a | 0, 2) | 0;
            f = v[31601];
            v[31601] = 0;
            if ((f | 0) == 1) {
             break i;
            }
            if (!a) {
             break j;
            }
            v[31601] = 0;
            a = Q(189, b | 0) | 0;
            f = v[31601];
            v[31601] = 0;
            if ((f | 0) == 1) {
             break h;
            }
            if (!a) {
             break e;
            }
            v[31601] = 0;
            f = g + 8 | 0;
            R(185, f | 0, b | 0, a | 0);
            a = v[31601];
            v[31601] = 0;
            if ((a | 0) == 1) {
             break g;
            }
            a = ns(g + 28 | 0, f);
            h = jd(e, a);
            yc(h + 20 | 0, a + 20 | 0, 1040);
            tb(a);
            tb(f);
            v[e + 1076 >> 2] = 0;
            v[e + 1080 >> 2] = 0;
            f = v[e + 1060 >> 2];
            a = v[f + 20 >> 2];
            if (In(x[f + 34 >> 1]) >>> 0 >= 2) {
             v[31601] = 0;
             N(190, h | 0, a + (d << 1) | 0);
             a = v[31601];
             v[31601] = 0;
             if ((a | 0) != 1) {
              break e;
             }
             break f;
            }
            v[31601] = 0;
            N(191, h | 0, a + d | 0);
            a = v[31601];
            v[31601] = 0;
            if ((a | 0) == 1) {
             break f;
            }
            break e;
           }
           d = d + 1 | 0;
           a = v[e + 1060 >> 2];
           continue c;
          }
          a = M() | 0;
          break b;
         }
         a = M() | 0;
         break b;
        }
        a = M() | 0;
        break b;
       }
       a = S(28784) | 0;
       if ((fb | 0) != (_(28784) | 0)) {
        break b;
       }
       X(a | 0) | 0;
       v[31601] = 0;
       W(26);
       a = v[31601];
       v[31601] = 0;
       if ((a | 0) == 1) {
        break d;
       }
      }
      a = v[i >> 2];
      continue;
     }
     break;
    }
    break;
   }
   a = M() | 0;
  }
  tb(e);
  P(a | 0);
  p();
 }
 eb = g + 1088 | 0;
 return e | 0;
}

function esa(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0;
 d = eb + -64 | 0;
 eb = d;
 b = b & 4095;
 u[d + 62 >> 1] = b;
 a: {
  b: {
   c: {
    d: {
     if (b >>> 0 >= 81) {
      e = ((b | 0) == 4095 ? c : b - 80 | 0) + 734016 | 0;
      c = Aua(e, e >> 31, 1e4, 0);
      b = gb;
      c = c + 14780 | 0;
      b = c >>> 0 < 14780 ? b + 1 | 0 : b;
      b = Bua(c, b, 3652425, 0);
      c = (((e + ((b | 0) / -4 | 0) | 0) + B(b, -365) | 0) + ((b | 0) / 100 | 0) | 0) + ((b | 0) / -400 | 0) | 0;
      if ((c | 0) < 0) {
       b = b - 1 | 0;
       c = (((e + ((b | 0) / -4 | 0) | 0) + B(b, -365) | 0) + ((b | 0) / 100 | 0) | 0) + ((b | 0) / -400 | 0) | 0;
      }
      e = eb - 16 | 0;
      eb = e;
      h = d + 48 | 0;
      f = tc(e + 4 | 0, 4451);
      Uc(h, f);
      sb(f);
      eb = e + 16 | 0;
      v[31601] = 0;
      f = (B(c, 100) + 52 | 0) / 3060 | 0;
      e = f + 2 | 0;
      g = (e | 0) / 12 | 0;
      v[d + 32 >> 2] = g + b;
      b = d + 36 | 0;
      N(73, b | 0, d + 32 | 0);
      i = v[31601];
      v[31601] = 0;
      e: {
       f: {
        g: {
         h: {
          i: {
           j: {
            if ((i | 0) != 1) {
             v[31601] = 0;
             v[d + 16 >> 2] = (e + B(g, -12) | 0) + 1;
             e = d + 20 | 0;
             N(76, e | 0, d + 16 | 0);
             g = v[31601];
             v[31601] = 0;
             if ((g | 0) == 1) {
              break j;
             }
             v[31601] = 0;
             v[d >> 2] = (((B(f, 306) + 5 | 0) / -10 | 0) + c | 0) + 1;
             c = d + 4 | 0;
             N(76, c | 0, d | 0);
             f = v[31601];
             v[31601] = 0;
             if ((f | 0) == 1) {
              break i;
             }
             v[31601] = 0;
             $(413, a | 0, h | 0, b | 0, e | 0, c | 0);
             a = v[31601];
             v[31601] = 0;
             if ((a | 0) == 1) {
              break h;
             }
             sb(c);
             sb(e);
             sb(b);
             Db(h);
             break d;
            }
            b = M() | 0;
            break e;
           }
           b = M() | 0;
           break f;
          }
          b = M() | 0;
          break g;
         }
         b = M() | 0;
         sb(d + 4 | 0);
        }
        sb(d + 20 | 0);
       }
       sb(d + 36 | 0);
      }
      break a;
     }
     b = d + 48 | 0;
     fg(b, 4431);
     v[31601] = 0;
     c = d + 36 | 0;
     N(414, c | 0, d + 62 | 0);
     e = v[31601];
     v[31601] = 0;
     if ((e | 0) == 1) {
      break c;
     }
     v[31601] = 0;
     R(139, a | 0, b | 0, c | 0);
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) == 1) {
      break b;
     }
     sb(c);
     Db(b);
    }
    eb = d - -64 | 0;
    return;
   }
   b = M() | 0;
   break a;
  }
  b = M() | 0;
  sb(d + 36 | 0);
 }
 Db(d + 48 | 0);
 P(b | 0);
 p();
}

function xQ(a, b, c) {
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0;
 l = eb - 16 | 0;
 eb = l;
 a: {
  if ((b | 0) == (c | 0)) {
   break a;
  }
  v[l + 12 >> 2] = -1953789045;
  _z(b, c, l + 12 | 0);
  e = c - b | 0;
  c = e >> 2;
  v[l + 8 >> 2] = c;
  i = nc(v[a >> 2], v[a + 4 >> 2]);
  j = i + 1 | 0;
  v[l + 4 >> 2] = j;
  m = v[ad(l + 4 | 0, l + 8 | 0) >> 2];
  f = v[b >> 2] ^ v[(b + e | 0) - 4 >> 2];
  d = 11;
  b: {
   if (c >>> 0 > 622) {
    break b;
   }
   d = 7;
   if (c >>> 0 > 67) {
    break b;
   }
   d = 5;
   if (c >>> 0 > 38) {
    break b;
   }
   d = 3;
   if (c >>> 0 > 6) {
    break b;
   }
   d = c - 1 >>> 1 | 0;
  }
  e = c - d >>> 1 | 0;
  h = (e << 2) + b | 0;
  g = v[h >> 2];
  f = B(qu(f ^ g), 1664525);
  v[h >> 2] = f + g;
  h = d + e | 0;
  d = (h << 2) + b | 0;
  g = d;
  k = v[d >> 2];
  d = f + i | 0;
  v[g >> 2] = k + d;
  v[b >> 2] = d;
  g = j >>> 0 <= 1 ? 1 : j;
  d = c - 1 | 0;
  e = (e >>> 0) % (c >>> 0) | 0;
  f = (h >>> 0) % (c >>> 0) | 0;
  k = v[a >> 2];
  i = 1;
  a = 0;
  while (1) if ((i | 0) == (g | 0)) {
   while (1) if (j >>> 0 >= m >>> 0) {
    j = c + m | 0;
    i = j >>> 0 < m >>> 0 ? m : j;
    while (1) {
     if ((i | 0) == (m | 0)) {
      break a;
     }
     d = d + 1 | 0;
     d = (c | 0) != (d | 0) ? d : 0;
     e = e + 1 | 0;
     e = (c | 0) != (e | 0) ? e : 0;
     g = (e << 2) + b | 0;
     k = v[g >> 2];
     a = a + 1 | 0;
     a = (a | 0) != (c | 0) ? a : 0;
     h = (a << 2) + b | 0;
     j = B(qu(v[(d << 2) + b >> 2] + (k + v[h >> 2] | 0) | 0), 1566083941);
     v[g >> 2] = j ^ k;
     f = f + 1 | 0;
     f = (c | 0) != (f | 0) ? f : 0;
     g = (f << 2) + b | 0;
     j = j - a | 0;
     v[g >> 2] = j ^ v[g >> 2];
     v[h >> 2] = j;
     m = m + 1 | 0;
     continue;
    }
   } else {
    e = e + 1 | 0;
    e = (c | 0) != (e | 0) ? e : 0;
    g = (e << 2) + b | 0;
    k = v[g >> 2];
    a = a + 1 | 0;
    a = (a | 0) != (c | 0) ? a : 0;
    h = (a << 2) + b | 0;
    d = d + 1 | 0;
    d = (c | 0) != (d | 0) ? d : 0;
    i = B(qu(k ^ (v[h >> 2] ^ v[(d << 2) + b >> 2])), 1664525);
    v[g >> 2] = i + k;
    f = f + 1 | 0;
    f = (c | 0) != (f | 0) ? f : 0;
    g = (f << 2) + b | 0;
    i = a + i | 0;
    v[g >> 2] = i + v[g >> 2];
    v[h >> 2] = i;
    j = j + 1 | 0;
    continue;
   }
  } else {
   e = e + 1 | 0;
   e = (c | 0) != (e | 0) ? e : 0;
   n = (e << 2) + b | 0;
   o = v[n >> 2];
   a = a + 1 | 0;
   a = (a | 0) != (c | 0) ? a : 0;
   p = (a << 2) + b | 0;
   d = d + 1 | 0;
   d = (c | 0) != (d | 0) ? d : 0;
   h = B(qu(o ^ (v[p >> 2] ^ v[(d << 2) + b >> 2])), 1664525);
   v[n >> 2] = h + o;
   h = v[xb(k, i - 1 | 0) >> 2] + (a + h | 0) | 0;
   f = f + 1 | 0;
   f = (c | 0) != (f | 0) ? f : 0;
   n = (f << 2) + b | 0;
   v[n >> 2] = h + v[n >> 2];
   v[p >> 2] = h;
   i = i + 1 | 0;
   continue;
  }
 }
 eb = l + 16 | 0;
}

function Mha(a) {
 a = a | 0;
 var b = 0, c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0;
 c = eb + -64 | 0;
 eb = c;
 g = Mb(a);
 v[31601] = 0;
 V(953, g | 0);
 a = v[31601];
 v[31601] = 0;
 a: {
  if ((a | 0) != 1) {
   b: {
    c: {
     d: {
      e: {
       f: {
        g: {
         h: {
          i: {
           j: {
            while (1) {
             if ((b | 0) == 312) {
              eb = c - -64 | 0;
              return g | 0;
             }
             k: {
              h = Au(44);
              if (h) {
               v[31601] = 0;
               d = O(36, c + 36 | 0, v[b + 42948 >> 2]) | 0;
               a = v[31601];
               v[31601] = 0;
               if ((a | 0) == 1) {
                break k;
               }
               a = v[b + 42944 >> 2];
               v[31601] = 0;
               i = c + 48 | 0;
               N(954, i | 0, d | 0);
               e = v[31601];
               v[31601] = 0;
               if ((e | 0) == 1) {
                break j;
               }
               v[31601] = 0;
               e = O(36, c + 12 | 0, v[b + 42952 >> 2]) | 0;
               f = v[31601];
               v[31601] = 0;
               if ((f | 0) == 1) {
                break i;
               }
               v[31601] = 0;
               f = c + 24 | 0;
               N(954, f | 0, e | 0);
               j = v[31601];
               v[31601] = 0;
               if ((j | 0) == 1) {
                break h;
               }
               v[31601] = 0;
               a = aa(955, h | 0, a | 0, i | 0, f | 0) | 0;
               j = v[31601];
               v[31601] = 0;
               if ((j | 0) == 1) {
                break g;
               }
               Db(f);
               sb(e);
               Db(i);
               sb(d);
               v[c + 60 >> 2] = a;
               v[31601] = 0;
               N(956, g | 0, c + 60 | 0);
               d = v[31601];
               v[31601] = 0;
               if ((d | 0) == 1) {
                break b;
               }
               t[a + 40 | 0] = w[b + 42964 | 0];
               d = b + 42956 | 0;
               e = v[d + 4 >> 2];
               v[a + 32 >> 2] = v[d >> 2];
               v[a + 36 >> 2] = e;
               t[a + 41 | 0] = w[a + 41 | 0] & 253 | w[b + 42965 | 0] << 1;
              }
              b = b + 24 | 0;
              continue;
             }
             break;
            }
            b = M() | 0;
            break c;
           }
           b = M() | 0;
           break d;
          }
          b = M() | 0;
          break e;
         }
         b = M() | 0;
         break f;
        }
        b = M() | 0;
        Db(c + 24 | 0);
       }
       sb(e);
      }
      Db(c + 48 | 0);
     }
     sb(d);
    }
    Bb(h);
    break a;
   }
   b = M() | 0;
   break a;
  }
  b = M() | 0;
 }
 uc(g);
 P(b | 0);
 p();
}

function n4(a, b, c, d, e, f) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 f = f | 0;
 var g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, q = 0, r = 0, s = 0, u = 0;
 k = eb - 128 | 0;
 eb = k;
 j = xt(c, d);
 v[k + 4 >> 2] = 1238;
 n = wt(k + 8 | 0, k + 4 | 0);
 i = k + 16 | 0;
 a: {
  b: {
   c: {
    if (j >>> 0 >= 101) {
     i = Fd(j);
     if (!i) {
      v[31601] = 0;
      W(1239);
      a = v[31601];
      v[31601] = 0;
      if ((a | 0) != 1) {
       break c;
      }
      break a;
     }
     Qe(n, i);
    }
    h = i;
    g = c;
    while (1) if ((d | 0) == (g | 0)) {
     d: while (1) {
      g = v[a >> 2];
      h = (g | 0) == (b | 0);
      if (j ? h : 1) {
       if (h) {
        v[f >> 2] = v[f >> 2] | 2;
       }
       break b;
      }
      g = v[g >> 2];
      v[31601] = 0;
      s = O(1258, e | 0, g | 0) | 0;
      g = v[31601];
      v[31601] = 0;
      if ((g | 0) == 1) {
       break a;
      }
      l = o + 1 | 0;
      r = 0;
      h = i;
      g = c;
      while (1) {
       if ((d | 0) == (g | 0)) {
        o = l;
        if (!r) {
         continue d;
        }
        v[a >> 2] = v[a >> 2] + 4;
        h = i;
        g = c;
        if (j + m >>> 0 < 2) {
         continue d;
        }
        while (1) {
         if ((d | 0) == (g | 0)) {
          continue d;
         }
         e: {
          if (w[h | 0] != 2) {
           break e;
          }
          if ((Cb(v[g + 4 >> 2], w[g + 11 | 0]) | 0) == (o | 0)) {
           break e;
          }
          t[h | 0] = 0;
          m = m - 1 | 0;
         }
         h = h + 1 | 0;
         g = g + 12 | 0;
         continue;
        }
       }
       f: {
        if (w[h | 0] != 1) {
         break f;
        }
        q = v[Vd(g, o) >> 2];
        v[31601] = 0;
        q = O(1258, e | 0, q | 0) | 0;
        u = v[31601];
        v[31601] = 0;
        if ((u | 0) == 1) {
         break a;
        }
        g: {
         if ((q | 0) == (s | 0)) {
          r = 1;
          if ((Cb(v[g + 4 >> 2], w[g + 11 | 0]) | 0) != (l | 0)) {
           break f;
          }
          t[h | 0] = 2;
          m = m + 1 | 0;
          break g;
         }
         t[h | 0] = 0;
        }
        j = j - 1 | 0;
       }
       h = h + 1 | 0;
       g = g + 12 | 0;
       continue;
      }
     }
    } else {
     l = zd(v[g + 4 >> 2], w[g + 11 | 0]);
     t[h | 0] = l ? 2 : 1;
     m = m + l | 0;
     j = j - l | 0;
     h = h + 1 | 0;
     g = g + 12 | 0;
     continue;
    }
   }
   p();
  }
  h: {
   i: {
    while (1) {
     if ((c | 0) == (d | 0)) {
      break i;
     }
     if (w[i | 0] != 2) {
      i = i + 1 | 0;
      c = c + 12 | 0;
      continue;
     }
     break;
    }
    d = c;
    break h;
   }
   v[f >> 2] = v[f >> 2] | 4;
  }
  Kc(n);
  eb = k + 128 | 0;
  return d | 0;
 }
 a = M() | 0;
 Kc(n);
 P(a | 0);
 p();
}

function c4(a, b, c, d, e, f) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 f = f | 0;
 var g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, q = 0, r = 0, s = 0, u = 0;
 k = eb - 128 | 0;
 eb = k;
 j = xt(c, d);
 v[k + 4 >> 2] = 1238;
 n = wt(k + 8 | 0, k + 4 | 0);
 i = k + 16 | 0;
 a: {
  b: {
   c: {
    if (j >>> 0 >= 101) {
     i = Fd(j);
     if (!i) {
      v[31601] = 0;
      W(1239);
      a = v[31601];
      v[31601] = 0;
      if ((a | 0) != 1) {
       break c;
      }
      break a;
     }
     Qe(n, i);
    }
    h = i;
    g = c;
    while (1) if ((d | 0) == (g | 0)) {
     d: while (1) {
      g = v[a >> 2];
      h = (g | 0) == (b | 0);
      if (j ? h : 1) {
       if (h) {
        v[f >> 2] = v[f >> 2] | 2;
       }
       break b;
      }
      g = t[g | 0];
      v[31601] = 0;
      s = O(1242, e | 0, g | 0) | 0;
      g = v[31601];
      v[31601] = 0;
      if ((g | 0) == 1) {
       break a;
      }
      l = o + 1 | 0;
      r = 0;
      h = i;
      g = c;
      while (1) {
       if ((d | 0) == (g | 0)) {
        o = l;
        if (!r) {
         continue d;
        }
        v[a >> 2] = v[a >> 2] + 1;
        h = i;
        g = c;
        if (j + m >>> 0 < 2) {
         continue d;
        }
        while (1) {
         if ((d | 0) == (g | 0)) {
          continue d;
         }
         e: {
          if (w[h | 0] != 2) {
           break e;
          }
          if ((Cb(v[g + 4 >> 2], w[g + 11 | 0]) | 0) == (o | 0)) {
           break e;
          }
          t[h | 0] = 0;
          m = m - 1 | 0;
         }
         h = h + 1 | 0;
         g = g + 12 | 0;
         continue;
        }
       }
       f: {
        if (w[h | 0] != 1) {
         break f;
        }
        q = t[dc(g, o) | 0];
        v[31601] = 0;
        q = O(1242, e | 0, q | 0) | 0;
        u = v[31601];
        v[31601] = 0;
        if ((u | 0) == 1) {
         break a;
        }
        g: {
         if ((q | 0) == (s | 0)) {
          r = 1;
          if ((Cb(v[g + 4 >> 2], w[g + 11 | 0]) | 0) != (l | 0)) {
           break f;
          }
          t[h | 0] = 2;
          m = m + 1 | 0;
          break g;
         }
         t[h | 0] = 0;
        }
        j = j - 1 | 0;
       }
       h = h + 1 | 0;
       g = g + 12 | 0;
       continue;
      }
     }
    } else {
     l = zd(v[g + 4 >> 2], w[g + 11 | 0]);
     t[h | 0] = l ? 2 : 1;
     m = m + l | 0;
     j = j - l | 0;
     h = h + 1 | 0;
     g = g + 12 | 0;
     continue;
    }
   }
   p();
  }
  h: {
   i: {
    while (1) {
     if ((c | 0) == (d | 0)) {
      break i;
     }
     if (w[i | 0] != 2) {
      i = i + 1 | 0;
      c = c + 12 | 0;
      continue;
     }
     break;
    }
    d = c;
    break h;
   }
   v[f >> 2] = v[f >> 2] | 4;
  }
  Kc(n);
  eb = k + 128 | 0;
  return d | 0;
 }
 a = M() | 0;
 Kc(n);
 P(a | 0);
 p();
}

function _7(a, b, c, d, e, f) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 f = f | 0;
 var g = 0, h = 0;
 a = eb - 320 | 0;
 eb = a;
 v[a + 312 >> 2] = c;
 v[a + 316 >> 2] = b;
 h = Eb(a + 196 | 0);
 g = a + 16 | 0;
 bd(g, v[d + 28 >> 2]);
 v[31601] = 0;
 b = Q(1251, v[a + 16 >> 2]) | 0;
 c = v[31601];
 v[31601] = 0;
 a: {
  b: {
   if ((c | 0) == 1) {
    break b;
   }
   v[31601] = 0;
   U(1262, b | 0, 95136, 95162, a + 208 | 0);
   b = v[31601];
   v[31601] = 0;
   if ((b | 0) == 1) {
    break b;
   }
   Zb(g);
   c = Eb(a + 184 | 0);
   b = Lc(c);
   v[31601] = 0;
   N(46, c | 0, b | 0);
   b = v[31601];
   v[31601] = 0;
   if ((b | 0) != 1) {
    c: {
     b = dc(c, 0);
     v[a + 180 >> 2] = b;
     v[a + 12 >> 2] = g;
     v[a + 8 >> 2] = 0;
     while (1) {
      d: {
       v[31601] = 0;
       g = O(1256, a + 316 | 0, a + 312 | 0) | 0;
       d = v[31601];
       v[31601] = 0;
       if ((d | 0) == 1) {
        break d;
       }
       d = v[a + 180 >> 2];
       e: {
        if (!g) {
         g = d;
         d = Cb(v[c + 4 >> 2], w[c + 11 | 0]);
         if ((g | 0) == (d + b | 0)) {
          v[31601] = 0;
          N(46, c | 0, d << 1);
          b = v[31601];
          v[31601] = 0;
          if ((b | 0) == 1) {
           break c;
          }
          b = Lc(c);
          v[31601] = 0;
          N(46, c | 0, b | 0);
          b = v[31601];
          v[31601] = 0;
          if ((b | 0) == 1) {
           break c;
          }
          b = dc(c, 0);
          v[a + 180 >> 2] = d + b;
         }
         v[31601] = 0;
         d = Q(1257, v[a + 316 >> 2]) | 0;
         g = v[31601];
         v[31601] = 0;
         if ((g | 0) == 1) {
          break d;
         }
         if (!bo(d, 16, b, a + 180 | 0, a + 8 | 0, 0, v[h + 4 >> 2], w[h + 11 | 0], a + 16 | 0, a + 12 | 0, a + 208 | 0)) {
          break e;
         }
         d = v[a + 180 >> 2];
        }
        v[31601] = 0;
        N(46, c | 0, d - b | 0);
        b = v[31601];
        v[31601] = 0;
        if ((b | 0) == 1) {
         break d;
        }
        b = Jb(c);
        d = Nd();
        v[a >> 2] = f;
        if ((rK(b, d, a) | 0) != 1) {
         v[e >> 2] = 4;
        }
        v[31601] = 0;
        b = O(1256, a + 316 | 0, a + 312 | 0) | 0;
        d = v[31601];
        v[31601] = 0;
        if ((d | 0) == 1) {
         break d;
        }
        if (b) {
         v[e >> 2] = v[e >> 2] | 2;
        }
        b = v[a + 316 >> 2];
        sb(c);
        sb(h);
        eb = a + 320 | 0;
        return b | 0;
       }
       v[31601] = 0;
       Q(1259, a + 316 | 0) | 0;
       d = v[31601];
       v[31601] = 0;
       if ((d | 0) != 1) {
        continue;
       }
      }
      break;
     }
    }
   }
   b = M() | 0;
   sb(c);
   break a;
  }
  b = M() | 0;
  Zb(a + 16 | 0);
 }
 sb(h);
 P(b | 0);
 p();
}

function h8(a, b, c, d, e, f) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 f = f | 0;
 var g = 0, h = 0;
 a = eb - 256 | 0;
 eb = a;
 v[a + 248 >> 2] = c;
 v[a + 252 >> 2] = b;
 h = Eb(a + 196 | 0);
 g = a + 16 | 0;
 bd(g, v[d + 28 >> 2]);
 v[31601] = 0;
 b = Q(28, v[a + 16 >> 2]) | 0;
 c = v[31601];
 v[31601] = 0;
 a: {
  b: {
   if ((c | 0) == 1) {
    break b;
   }
   v[31601] = 0;
   U(1248, b | 0, 95136, 95162, a + 208 | 0);
   b = v[31601];
   v[31601] = 0;
   if ((b | 0) == 1) {
    break b;
   }
   Zb(g);
   c = Eb(a + 184 | 0);
   b = Lc(c);
   v[31601] = 0;
   N(46, c | 0, b | 0);
   b = v[31601];
   v[31601] = 0;
   if ((b | 0) != 1) {
    c: {
     b = dc(c, 0);
     v[a + 180 >> 2] = b;
     v[a + 12 >> 2] = g;
     v[a + 8 >> 2] = 0;
     while (1) {
      d: {
       v[31601] = 0;
       g = O(1240, a + 252 | 0, a + 248 | 0) | 0;
       d = v[31601];
       v[31601] = 0;
       if ((d | 0) == 1) {
        break d;
       }
       d = v[a + 180 >> 2];
       e: {
        if (!g) {
         g = d;
         d = Cb(v[c + 4 >> 2], w[c + 11 | 0]);
         if ((g | 0) == (d + b | 0)) {
          v[31601] = 0;
          N(46, c | 0, d << 1);
          b = v[31601];
          v[31601] = 0;
          if ((b | 0) == 1) {
           break c;
          }
          b = Lc(c);
          v[31601] = 0;
          N(46, c | 0, b | 0);
          b = v[31601];
          v[31601] = 0;
          if ((b | 0) == 1) {
           break c;
          }
          b = dc(c, 0);
          v[a + 180 >> 2] = d + b;
         }
         v[31601] = 0;
         d = Q(1241, v[a + 252 >> 2]) | 0;
         g = v[31601];
         v[31601] = 0;
         if ((g | 0) == 1) {
          break d;
         }
         if (!co(d, 16, b, a + 180 | 0, a + 8 | 0, 0, v[h + 4 >> 2], w[h + 11 | 0], a + 16 | 0, a + 12 | 0, a + 208 | 0)) {
          break e;
         }
         d = v[a + 180 >> 2];
        }
        v[31601] = 0;
        N(46, c | 0, d - b | 0);
        b = v[31601];
        v[31601] = 0;
        if ((b | 0) == 1) {
         break d;
        }
        b = Jb(c);
        d = Nd();
        v[a >> 2] = f;
        if ((rK(b, d, a) | 0) != 1) {
         v[e >> 2] = 4;
        }
        v[31601] = 0;
        b = O(1240, a + 252 | 0, a + 248 | 0) | 0;
        d = v[31601];
        v[31601] = 0;
        if ((d | 0) == 1) {
         break d;
        }
        if (b) {
         v[e >> 2] = v[e >> 2] | 2;
        }
        b = v[a + 252 >> 2];
        sb(c);
        sb(h);
        eb = a + 256 | 0;
        return b | 0;
       }
       v[31601] = 0;
       Q(1243, a + 252 | 0) | 0;
       d = v[31601];
       v[31601] = 0;
       if ((d | 0) != 1) {
        continue;
       }
      }
      break;
     }
    }
   }
   b = M() | 0;
   sb(c);
   break a;
  }
  b = M() | 0;
  Zb(a + 16 | 0);
 }
 sb(h);
 P(b | 0);
 p();
}

function F4(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0;
 c = eb - 576 | 0;
 eb = c;
 Qb(c + 532 | 0, 0, 44);
 v[c + 24 >> 2] = 0;
 v[c + 28 >> 2] = 0;
 l = a + 4 | 0;
 while (1) {
  a: {
   if ((d | 0) == 7) {
    l = a + 172 | 0;
    d = 0;
    while (1) {
     b: {
      if ((d | 0) == 12) {
       v[c + 540 >> 2] = 1;
       d = c + 432 | 0;
       ea(d | 0, 100, 9262, c + 532 | 0, v[a >> 2]) | 0;
       v[c + 24 >> 2] = 0;
       v[c + 28 >> 2] = 0;
       v[c + 20 >> 2] = d;
       e = Bi(c + 32 | 0, c + 20 | 0, 100, c + 24 | 0, v[a >> 2]);
       if ((e | 0) != -1) {
        break b;
       }
       break a;
      }
      v[c + 548 >> 2] = d;
      e = c + 432 | 0;
      g = c + 532 | 0;
      ea(e | 0, 100, 14278, g | 0, v[a >> 2]) | 0;
      v[c + 24 >> 2] = 0;
      v[c + 28 >> 2] = 0;
      v[c + 8 >> 2] = e;
      f = c + 32 | 0;
      h = c + 8 | 0;
      i = c + 24 | 0;
      j = Bi(f, h, 100, i, v[a >> 2]);
      if (j + 1 >>> 0 <= 1) {
       break a;
      }
      k = l + B(d, 12) | 0;
      Am(k, f, f + (j << 2) | 0);
      ea(e | 0, 100, 13333, g | 0, v[a >> 2]) | 0;
      v[c + 24 >> 2] = 0;
      v[c + 28 >> 2] = 0;
      v[c + 8 >> 2] = e;
      e = Bi(f, h, 100, i, v[a >> 2]);
      if (e + 1 >>> 0 <= 1) {
       break a;
      }
      Am(k + 144 | 0, f, (e << 2) + f | 0);
      d = d + 1 | 0;
      continue;
     }
     break;
    }
    d = c + 32 | 0;
    Am(a + 460 | 0, d, d + (e << 2) | 0);
    v[c + 540 >> 2] = 13;
    e = c + 432 | 0;
    ea(e | 0, 100, 9262, c + 532 | 0, v[a >> 2]) | 0;
    v[c + 24 >> 2] = 0;
    v[c + 28 >> 2] = 0;
    v[c + 20 >> 2] = e;
    e = Bi(d, c + 20 | 0, 100, c + 24 | 0, v[a >> 2]);
    if ((e | 0) != -1) {
     Am(a + 472 | 0, d, (e << 2) + d | 0);
     d = c + 8 | 0;
     bt(d, a, 99, b);
     mh(a + 484 | 0, d);
     Tb(d);
     bt(d, a, 114, b);
     mh(a + 496 | 0, d);
     Tb(d);
     bt(d, a, 120, b);
     mh(a + 508 | 0, d);
     Tb(c + 8 | 0);
     bt(d, a, 88, b);
     mh(a + 520 | 0, d);
     Tb(c + 8 | 0);
     eb = c + 576 | 0;
     return;
    }
    break a;
   }
   v[c + 556 >> 2] = d;
   e = c + 432 | 0;
   g = c + 532 | 0;
   ea(e | 0, 100, 14291, g | 0, v[a >> 2]) | 0;
   v[c + 24 >> 2] = 0;
   v[c + 28 >> 2] = 0;
   v[c + 8 >> 2] = e;
   f = c + 32 | 0;
   h = c + 8 | 0;
   i = c + 24 | 0;
   j = Bi(f, h, 100, i, v[a >> 2]);
   if (j + 1 >>> 0 > 1) {
    k = l + B(d, 12) | 0;
    Am(k, f, f + (j << 2) | 0);
    ea(e | 0, 100, 13540, g | 0, v[a >> 2]) | 0;
    v[c + 24 >> 2] = 0;
    v[c + 28 >> 2] = 0;
    v[c + 8 >> 2] = e;
    e = Bi(f, h, 100, i, v[a >> 2]);
    if (e + 1 >>> 0 <= 1) {
     break a;
    }
    Am(k + 84 | 0, f, (e << 2) + f | 0);
    d = d + 1 | 0;
    continue;
   }
  }
  break;
 }
 fo(12661);
 p();
}

function Sla(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, w = 0, x = 0, y = 0, z = 0, A = 0, C = 0, D = 0, E = 0, F = 0, G = 0, H = 0;
 f = eb - 48 | 0;
 eb = f;
 w = v[a + 16 >> 2];
 v[f + 32 >> 2] = v[a + 44 >> 2];
 v[f + 36 >> 2] = v[a + 48 >> 2];
 v[f + 40 >> 2] = v[a + 52 >> 2];
 v[f + 44 >> 2] = v[a + 56 >> 2];
 x = v[a + 24 >> 2];
 y = v[a + 20 >> 2];
 i = v[a + 4 >> 2];
 v[f + 16 >> 2] = v[a >> 2];
 v[f + 20 >> 2] = i;
 z = b + 24 | 0;
 A = f + 32 | 0;
 C = v[a + 72 >> 2];
 r = v[a + 68 >> 2];
 D = r >> 31;
 s = v[a + 64 >> 2];
 E = s >> 31;
 t = v[a + 60 >> 2];
 F = t >> 31;
 G = v[a + 8 >> 2];
 H = v[a + 12 >> 2];
 while (1) {
  if (d) {
   b = v[f + 16 >> 2];
   m = ((((v[f + 20 >> 2] & 2147483647) << 1 | b >>> 31) & 2147483646) << 1) + w | 0;
   b = (((b >>> 16 | 0) + 4 & 131064) << 1) + z | 0;
   j = u[b + 14 >> 1];
   n = u[b + 12 >> 1];
   q = u[b + 10 >> 1];
   g = u[b + 8 >> 1];
   o = u[b + 6 >> 1];
   h = u[b + 4 >> 1];
   e = u[b + 2 >> 1];
   i = u[b >> 1];
   b = 0;
   k = 0;
   while (1) {
    if ((k | 0) != 2) {
     p = k << 1;
     l = p + m | 0;
     v[(f + 8 | 0) + (k << 2) >> 2] = (((((B(u[l + 8 >> 1], q) + B(u[l + 4 >> 1], g) | 0) + B(u[l + 12 >> 1], n) | 0) + B(j, u[l + 16 >> 1]) | 0) / 2 | 0) + ((((B(u[m + (p | -8) >> 1], e) + B(u[m + (p | -12) >> 1], i) | 0) + B(u[m + (p | -4) >> 1], h) | 0) + B(u[l >> 1], o) | 0) / 2 | 0) | 0) / 16384;
     k = k + 1 | 0;
     continue;
    }
    break;
   }
   while (1) {
    if ((b | 0) != 2) {
     n = (f + 8 | 0) + (b << 2) | 0;
     e = v[n >> 2];
     i = (b << 3) + A | 0;
     q = v[i + 4 >> 2];
     g = v[i >> 2];
     v[i + 4 >> 2] = g;
     o = e << 8;
     e = o;
     e = Aua(e, e >> 31, t, F);
     h = gb;
     j = e;
     e = Xb(g, -16777216, 16776704);
     e = Aua(s, E, e, e >> 31);
     g = j + e | 0;
     j = gb + h | 0;
     j = e >>> 0 > g >>> 0 ? j + 1 | 0 : j;
     e = Xb(q, -16777216, 16776704);
     h = Aua(r, D, e, e >> 31);
     g = h + g | 0;
     e = gb + j | 0;
     e = g >>> 0 < h >>> 0 ? e + 1 | 0 : e;
     h = g + 8388608 | 0;
     e = h >>> 0 < 8388608 ? e + 1 | 0 : e;
     e = Rc(h, e, 24);
     v[i >> 2] = e - (o & C);
     v[n >> 2] = (e | 0) / 256;
     b = b + 1 | 0;
     continue;
    }
    break;
   }
   v[c >> 2] = v[c >> 2] + B(v[f + 8 >> 2], y);
   v[c + 4 >> 2] = v[c + 4 >> 2] + B(v[f + 12 >> 2], x);
   Ob(f + 16 | 0, G, H);
   c = c + 8 | 0;
   d = d - 1 | 0;
   continue;
  }
  break;
 }
 b = v[f + 20 >> 2];
 v[a >> 2] = v[f + 16 >> 2];
 v[a + 4 >> 2] = b;
 v[a + 44 >> 2] = v[f + 32 >> 2];
 v[a + 48 >> 2] = v[f + 36 >> 2];
 v[a + 52 >> 2] = v[f + 40 >> 2];
 v[a + 56 >> 2] = v[f + 44 >> 2];
 eb = f + 48 | 0;
}

function vI(a, b) {
 var c = 0, d = 0, e = 0, f = 0, g = 0;
 a: {
  b: {
   c: {
    d: {
     e: {
      f: {
       c = v[a + 4 >> 2];
       g: {
        if ((c | 0) != v[a + 104 >> 2]) {
         v[a + 4 >> 2] = c + 1;
         c = w[c | 0];
         break g;
        }
        c = sd(a);
       }
       switch (c - 43 | 0) {
       case 0:
       case 2:
        break f;

       default:
        break e;
       }
      }
      d = (c | 0) == 45;
      f = !b;
      c = v[a + 4 >> 2];
      h: {
       if ((c | 0) != v[a + 104 >> 2]) {
        v[a + 4 >> 2] = c + 1;
        c = w[c | 0];
        break h;
       }
       c = sd(a);
      }
      b = c - 58 | 0;
      if (f | b >>> 0 > 4294967285) {
       break d;
      }
      b = v[a + 116 >> 2];
      if ((b | 0) > 0) {
       b = 1;
      } else {
       b = (b | 0) >= 0;
      }
      if (b) {
       break c;
      }
      break a;
     }
     b = c - 58 | 0;
    }
    f = d;
    if (b >>> 0 <= 4294967285) {
     if (v[a + 116 >> 2] < 0) {
      break a;
     }
     break b;
    }
    i: {
     if (c - 48 >>> 0 >= 10) {
      break i;
     }
     while (1) {
      e = (B(e, 10) + c | 0) - 48 | 0;
      d = (e | 0) < 214748364;
      c = v[a + 4 >> 2];
      j: {
       if ((c | 0) != v[a + 104 >> 2]) {
        v[a + 4 >> 2] = c + 1;
        c = w[c | 0];
        break j;
       }
       c = sd(a);
      }
      b = c - 48 | 0;
      if (d & b >>> 0 <= 9) {
       continue;
      }
      break;
     }
     g = e >> 31;
     if (b >>> 0 >= 10) {
      break i;
     }
     while (1) {
      b = c;
      c = Aua(e, g, 10, 0);
      d = b + c | 0;
      b = gb;
      e = d - 48 | 0;
      d = (c >>> 0 > d >>> 0 ? b + 1 | 0 : b) - (d >>> 0 < 48) | 0;
      g = d;
      d = e >>> 0 < 2061584302 & (d | 0) <= 21474836 | (d | 0) < 21474836;
      c = v[a + 4 >> 2];
      k: {
       if ((c | 0) != v[a + 104 >> 2]) {
        v[a + 4 >> 2] = c + 1;
        c = w[c | 0];
        break k;
       }
       c = sd(a);
      }
      b = c - 48 | 0;
      if (d & b >>> 0 <= 9) {
       continue;
      }
      break;
     }
     if (b >>> 0 >= 10) {
      break i;
     }
     while (1) {
      b = v[a + 4 >> 2];
      l: {
       if ((b | 0) != v[a + 104 >> 2]) {
        v[a + 4 >> 2] = b + 1;
        b = w[b | 0];
        break l;
       }
       b = sd(a);
      }
      if (b - 48 >>> 0 < 10) {
       continue;
      }
      break;
     }
    }
    b = v[a + 116 >> 2];
    if ((b | 0) > 0) {
     b = 1;
    } else {
     b = (b | 0) >= 0;
    }
    if (b) {
     v[a + 4 >> 2] = v[a + 4 >> 2] - 1;
    }
    gb = f ? 0 - (((e | 0) != 0) + g | 0) | 0 : g;
    return f ? 0 - e | 0 : e;
   }
   v[a + 4 >> 2] = v[a + 4 >> 2] - 1;
  }
  v[a + 4 >> 2] = v[a + 4 >> 2] - 1;
 }
 gb = -2147483648;
 return 0;
}

function Zsa(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, q = 0;
 h = eb - 288 | 0;
 eb = h;
 sf(b);
 a: {
  if (!Lb(v[a >> 2], v[a + 8 >> 2], 1)) {
   break a;
  }
  while (1) {
   i = h + 32 | 0;
   ul(h + 8 | 0, i, ur(i));
   ic(h + 20 | 0, v[a >> 2], v[a + 8 >> 2], v[h + 8 >> 2], v[h + 12 >> 2]);
   v[h + 28 >> 2] = v[h + 24 >> 2];
   o = h, q = c - Zc(v[b + 4 >> 2], w[b + 11 | 0]) | 0, v[o + 4 >> 2] = q;
   d = v[Gb(h + 28 | 0, h + 4 | 0) >> 2];
   if (!d) {
    break a;
   }
   m = d + i | 0;
   k = Ei(i, m, 0);
   d = v[ub(h, Cf(b)) >> 2];
   f = Oj(i, k);
   l = eb - 16 | 0;
   eb = l;
   j = yk(d, yd(b));
   b: {
    c: {
     d: {
      if (!f) {
       yd(b);
       break d;
      }
      if (!G_(b, i)) {
       d = i;
       e = Cb(v[b + 4 >> 2], w[b + 11 | 0]);
       g = Lc(b);
       e: {
        if (g - e >>> 0 >= f >>> 0) {
         g = Jb(b);
         if ((e | 0) == (j | 0)) {
          break e;
         }
         n = g + j | 0;
         Mi(n + f | 0, n, e - j | 0);
         break e;
        }
        $m(b, g, (e + f | 0) - g | 0, e, j, 0, f);
        g = v[b >> 2];
       }
       f = e + f | 0;
       kg(b, f);
       gd(f + g | 0, 0);
       f = g + j | 0;
       while (1) {
        if ((d | 0) != (k | 0)) {
         gd(f, w[d | 0]);
         d = d + 1 | 0;
         f = f + 1 | 0;
         continue;
        }
        break;
       }
       Pe(yd(b), j);
       break d;
      }
      d = i;
      e = l + 4 | 0;
      xx(e);
      f: {
       while (1) {
        if ((d | 0) == (k | 0)) {
         break f;
        }
        g = t[d | 0];
        v[31601] = 0;
        N(115, e | 0, g | 0);
        g = v[31601];
        v[31601] = 0;
        if ((g | 0) != 1) {
         d = d + 1 | 0;
         continue;
        }
        break;
       }
       X(S(0) | 0) | 0;
       if (ud(w[e + 11 | 0])) {
        Bb(v[e >> 2]);
       }
       v[31601] = 0;
       W(84);
       a = v[31601];
       v[31601] = 0;
       g: {
        if ((a | 0) == 1) {
         a = M() | 0;
         v[31601] = 0;
         W(26);
         b = v[31601];
         v[31601] = 0;
         if ((b | 0) != 1) {
          break g;
         }
         S(0) | 0;
         Rb();
        }
        p();
       }
       P(a | 0);
       p();
      }
      d = yd(e);
      g = Cf(e);
      v[31601] = 0;
      ga(364, b | 0, f | 0, j | 0, d | 0, g | 0) | 0;
      d = v[31601];
      v[31601] = 0;
      if ((d | 0) == 1) {
       break c;
      }
      sb(e);
     }
     eb = l + 16 | 0;
     break b;
    }
    a = M() | 0;
    sb(e);
    P(a | 0);
    p();
   }
   Ub(a, k - i | 0);
   if (k >>> 0 >= m >>> 0) {
    continue;
   }
   break;
  }
  Ub(a, 1);
 }
 eb = h + 288 | 0;
}

function qU(a, b, c, d, e) {
 var f = 0, g = 0, h = 0, i = 0, j = 0, k = 0;
 a: {
  b: {
   switch (Dua(e - 2 | 0, 31) | 0) {
   case 4:
    FB(a, b, c, d);
    return;

   case 0:
    e = 32 - E(d | 1) | 0;
    if ((e | 0) <= (c - b | 0)) {
     c = b + e | 0;
     b = c;
     while (1) {
      if (d >>> 0 < 17) {
       while (1) {
        b = b - 1 | 0;
        t[b | 0] = w[(d & 1) + 15472 | 0];
        e = d >>> 0 > 1;
        d = d >>> 1 | 0;
        if (e) {
         continue;
        }
        break;
       }
      } else {
       b = b - 4 | 0;
       Zm((d << 2 & 60) + 78528 | 0, 4, b);
       d = d >>> 4 | 0;
       continue;
      }
      break;
     }
     b = 0;
    } else {
     b = 61;
    }
    v[a + 4 >> 2] = b;
    break a;

   case 3:
    e = (34 - E(d | 1) >>> 0) / 3 | 0;
    if ((e | 0) <= (c - b | 0)) {
     c = b + e | 0;
     b = c;
     while (1) {
      if (d >>> 0 < 65) {
       while (1) {
        b = b - 1 | 0;
        t[b | 0] = w[(d & 7) + 14751 | 0];
        e = d >>> 0 > 7;
        d = d >>> 3 | 0;
        if (e) {
         continue;
        }
        break;
       }
      } else {
       b = b - 2 | 0;
       Zm((d << 1 & 126) + 78592 | 0, 2, b);
       d = d >>> 6 | 0;
       continue;
      }
      break;
     }
     b = 0;
    } else {
     b = 61;
    }
    v[a + 4 >> 2] = b;
    break a;

   case 7:
    e = 35 - E(d | 1) >>> 2 | 0;
    if ((e | 0) <= (c - b | 0)) {
     c = b + e | 0;
     b = c;
     while (1) {
      if (d >>> 0 < 257) {
       while (1) {
        b = b - 1 | 0;
        t[b | 0] = w[(d & 15) + 11165 | 0];
        e = d >>> 0 > 15;
        d = d >>> 4 | 0;
        if (e) {
         continue;
        }
        break;
       }
      } else {
       b = b - 2 | 0;
       Zm((d << 1 & 510) + 78720 | 0, 2, b);
       d = d >>> 8 | 0;
       continue;
      }
      break;
     }
     b = 0;
    } else {
     b = 61;
    }
    v[a + 4 >> 2] = b;
    break a;

   default:
    break b;
   }
  }
  g = d;
  i = B(e, e);
  k = B(i, e);
  j = B(i, i);
  c: {
   while (1) {
    h = f | 1;
    if (e >>> 0 > g >>> 0) {
     break c;
    }
    h = f | 2;
    if (g >>> 0 < i >>> 0) {
     break c;
    }
    h = f | 3;
    if (g >>> 0 < k >>> 0) {
     break c;
    }
    if (g >>> 0 < j >>> 0) {
     h = f + 4 | 0;
    } else {
     f = f + 4 | 0;
     g = (g >>> 0) / (j >>> 0) | 0;
     continue;
    }
    break;
   }
  }
  f = h;
  if ((f | 0) > (c - b | 0)) {
   v[a + 4 >> 2] = 61;
   break a;
  }
  f = b + f | 0;
  c = f;
  while (1) {
   c = c - 1 | 0;
   b = (d >>> 0) / (e >>> 0) | 0;
   t[c | 0] = w[(d - B(b, e) | 0) + 4895 | 0];
   g = d >>> 0 >= e >>> 0;
   d = b;
   if (g) {
    continue;
   }
   break;
  }
  v[a + 4 >> 2] = 0;
  v[a >> 2] = f;
  return;
 }
 v[a >> 2] = c;
}

function tna(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
 e = eb - 32 | 0;
 eb = e;
 c = x[a + 480190 >> 1];
 t[e + 20 | 0] = 0;
 j = c + 1 | 0;
 c = e + 20 | 0;
 aU(b, j, c);
 if (x[a + 480192 >> 1]) {
  g = Mb(c);
  n = e, o = vb(v[a + 484344 >> 2]), v[n + 16 >> 2] = o;
  m = a + 900380 | 0;
  j = vb(v[a + 484348 >> 2]);
  while (1) {
   h = v[e + 16 >> 2];
   if (Hb(h, j)) {
    a: {
     if (!Hb(v[h >> 2], v[h + 4 >> 2])) {
      break a;
     }
     c = x[a + 480188 >> 1];
     v[31601] = 0;
     t[e + 4 | 0] = 0;
     R(778, g | 0, c | 0, e + 4 | 0);
     c = v[31601];
     v[31601] = 0;
     if ((c | 0) != 1) {
      n = e, o = vb(v[h >> 2]), v[n + 12 >> 2] = o;
      k = 0;
      b: while (1) {
       f = 0;
       if (y[h + 12 >> 2] <= k >>> 0) {
        break a;
       }
       while (1) if (x[a + 480188 >> 1] <= f >>> 0) {
        k = k + 1 | 0;
        continue b;
       } else {
        c: {
         c = v[e + 12 >> 2];
         if (!Tc(w[c | 0])) {
          break c;
         }
         d: {
          e: {
           c = w[c + 1 | 0];
           if (c) {
            d = x[a + 480192 >> 1];
            break e;
           }
           d = x[a + 480192 >> 1];
           c = w[wb(v[g >> 2], f) | 0];
           if (c) {
            break e;
           }
           c = 1;
           break d;
          }
          n = wb(v[g >> 2], f), o = c, t[n | 0] = o;
          d = d & 65535;
          i = d >>> 0 < c >>> 0;
          d = i ? d : c;
          c = i ? 1 : c;
         }
         i = d & 65535;
         while (1) {
          d = c & 65535;
          if (d >>> 0 > i >>> 0) {
           break c;
          }
          d = v[(d << 2) + m >> 2];
          f: {
           if (!d) {
            break f;
           }
           d = x[$b(d + 236 | 0, w[v[e + 12 >> 2]] - 1 | 0) >> 1];
           if (d >>> 0 > x[a + 480190 >> 1]) {
            break f;
           }
           l = e + 4 | 0;
           Ib(l, v[b >> 2], d);
           kf(l, 1);
          }
          c = c + 1 | 0;
          continue;
         }
        }
        f = f + 1 | 0;
        MC(e + 12 | 0);
        continue;
       }
      }
     }
     a = M() | 0;
     ec(g);
     P(a | 0);
     p();
    }
    Sl(e + 16 | 0);
    continue;
   } else {
    f = a + 484380 | 0;
    c = x[a + 480190 >> 1];
    d = 0;
    while (1) {
     if (c) {
      Ib(e + 4 | 0, v[b >> 2], c);
      if (!Fb(v[v[e + 4 >> 2] >> 2], v[e + 8 >> 2])) {
       a = f + B(c, 104) | 0;
       d = ke(v[a >> 2], v[a + 20 >> 2]) + d | 0;
      }
      c = c - 1 | 0;
      continue;
     } else {
      ec(g);
     }
     break;
    }
   }
   break;
  }
 }
 eb = e + 32 | 0;
 return d & 65535;
}

function una(a) {
 a = a | 0;
 var b = 0, c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0;
 e = eb - 32 | 0;
 eb = e;
 u[e + 30 >> 1] = 254;
 d = Gj(a);
 c = eb - 16 | 0;
 eb = c;
 f = e + 16 | 0;
 v[f >> 2] = 0;
 v[f + 4 >> 2] = 0;
 sc(f + 8 | 0);
 Qd(c + 8 | 0, v[ub(c + 4 | 0, f) >> 2]);
 a: {
  b: {
   if (d) {
    v[31601] = 0;
    N(640, f | 0, d | 0);
    g = v[31601];
    v[31601] = 0;
    if ((g | 0) == 1) {
     break b;
    }
    QE(f, d);
   }
   g = c + 8 | 0;
   Pd(g);
   Rj(g);
   eb = c + 16 | 0;
   break a;
  }
  a = M() | 0;
  Rj(c + 8 | 0);
  P(a | 0);
  p();
 }
 c = v[a >> 2];
 g = v[f >> 2];
 while (1) {
  if ((b | 0) == (d | 0)) {
   c: {
    if (!(h & 65535)) {
     break c;
    }
    c = vb(c);
    d = vb(v[a + 4 >> 2]);
    b = eb - 16 | 0;
    eb = b;
    c = OC(c, d, x[e + 30 >> 1]);
    v[b + 12 >> 2] = c;
    if (Hb(c, d)) {
     v[b + 8 >> 2] = c;
     while (1) {
      c = v[fe(b + 8 | 0) >> 2];
      if (Hb(c, d)) {
       c = x[c >> 1];
       if ((c | 0) == x[e + 30 >> 1]) {
        continue;
       }
       u[v[b + 12 >> 2] >> 1] = c;
       fe(b + 12 | 0);
       continue;
      }
      break;
     }
     c = v[b + 12 >> 2];
    }
    eb = b + 16 | 0;
    b = ub(e + 12 | 0, c);
    c = v[ub(e + 8 | 0, vb(v[a + 4 >> 2])) >> 2];
    d = v[b >> 2];
    b = v[a >> 2];
    b = (lp(d, vb(b)) << 1) + b | 0;
    if (Hb(d, c)) {
     Id(a, bC(b + (lp(c, d) << 1) | 0, v[a + 4 >> 2], b));
    }
    vb(b);
    b = vb(v[a >> 2]);
    v[e + 4 >> 2] = b;
    d = vb(v[a + 4 >> 2]);
    while (1) {
     if (Hb(b, d)) {
      d: {
       c = v[a + 24 >> 2];
       h = v[c + 484344 >> 2];
       b = x[b >> 1];
       if (!Ie(h, v[c + 484348 >> 2], b)) {
        break d;
       }
       b = Vb(h, b);
       k = e, l = vb(v[b >> 2]), v[k >> 2] = l;
       h = vb(v[b + 4 >> 2]);
       g = v[f + 4 >> 2];
       c = v[f >> 2];
       while (1) {
        b = v[e >> 2];
        if (!Hb(b, h)) {
         break d;
        }
        e: {
         if (w[b + 3 | 0] != 12) {
          break e;
         }
         j = _c(c, g);
         i = w[b + 5 | 0];
         if (j >>> 0 <= i >>> 0) {
          break e;
         }
         k = b, l = w[$b(c, i) | 0], t[k + 5 | 0] = l;
        }
        sg(e);
        continue;
       }
      }
      b = v[fe(e + 4 | 0) >> 2];
      continue;
     } else {
      b = v[f >> 2];
      d = _c(b, v[f + 4 >> 2]);
      c = x[a + 28 >> 1];
      if (d >>> 0 <= c >>> 0) {
       break c;
      }
      k = a, l = x[$b(b, c) >> 1], u[k + 28 >> 1] = l;
     }
     break;
    }
   }
  } else {
   k = $b(g, b), l = b - h | 0, u[k >> 1] = l;
   h = (x[$b(c, b) >> 1] == 254) + h | 0;
   b = b + 1 | 0;
   continue;
  }
  break;
 }
 nd(f);
 eb = e + 32 | 0;
}

function Tla(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, w = 0, x = 0, y = 0, z = 0, A = 0, C = 0, D = 0, E = 0, F = 0, G = 0, H = 0;
 f = eb - 48 | 0;
 eb = f;
 w = v[a + 16 >> 2];
 v[f + 32 >> 2] = v[a + 44 >> 2];
 v[f + 36 >> 2] = v[a + 48 >> 2];
 v[f + 40 >> 2] = v[a + 52 >> 2];
 v[f + 44 >> 2] = v[a + 56 >> 2];
 x = v[a + 24 >> 2];
 y = v[a + 20 >> 2];
 o = v[a + 4 >> 2];
 v[f + 16 >> 2] = v[a >> 2];
 v[f + 20 >> 2] = o;
 z = b + 24 | 0;
 A = f + 32 | 0;
 C = v[a + 72 >> 2];
 q = v[a + 68 >> 2];
 D = q >> 31;
 r = v[a + 64 >> 2];
 E = r >> 31;
 s = v[a + 60 >> 2];
 F = s >> 31;
 o = v[a + 8 >> 2];
 G = v[a + 12 >> 2];
 while (1) {
  if (d) {
   b = v[f + 16 >> 2];
   H = (((v[f + 20 >> 2] & 2147483647) << 1 | b >>> 31) & -2) + w | 0;
   b = (((b >>> 16 | 0) + 4 & 131064) << 1) + z | 0;
   j = u[b + 10 >> 1] << 8;
   m = u[b + 8 >> 1] << 8;
   p = u[b + 12 >> 1] << 8;
   g = u[b + 14 >> 1] << 8;
   n = u[b + 2 >> 1] << 8;
   i = u[b >> 1] << 8;
   e = u[b + 4 >> 1] << 8;
   b = u[b + 6 >> 1] << 8;
   k = 0;
   l = 0;
   while (1) {
    if ((l | 0) != 2) {
     h = l + H | 0;
     v[(f + 8 | 0) + (l << 2) >> 2] = ((((B(j, t[h + 4 | 0]) + B(m, t[h + 2 | 0]) | 0) + B(t[h + 6 | 0], p) | 0) + B(t[h + 8 | 0], g) >> 1) + (((B(t[h - 4 | 0], n) + B(t[h - 6 | 0], i) | 0) + B(t[h - 2 | 0], e) | 0) + B(t[h | 0], b) >> 1) | 0) / 16384;
     l = l + 1 | 0;
     continue;
    }
    break;
   }
   while (1) {
    if ((k | 0) != 2) {
     m = (f + 8 | 0) + (k << 2) | 0;
     e = v[m >> 2];
     b = (k << 3) + A | 0;
     p = v[b + 4 >> 2];
     g = v[b >> 2];
     v[b + 4 >> 2] = g;
     n = e << 8;
     e = n;
     e = Aua(e, e >> 31, s, F);
     i = gb;
     h = e;
     e = Xb(g, -16777216, 16776704);
     e = Aua(r, E, e, e >> 31);
     g = h + e | 0;
     j = gb + i | 0;
     j = e >>> 0 > g >>> 0 ? j + 1 | 0 : j;
     e = Xb(p, -16777216, 16776704);
     i = Aua(q, D, e, e >> 31);
     g = i + g | 0;
     e = gb + j | 0;
     e = g >>> 0 < i >>> 0 ? e + 1 | 0 : e;
     i = g + 8388608 | 0;
     e = i >>> 0 < 8388608 ? e + 1 | 0 : e;
     e = Rc(i, e, 24);
     v[b >> 2] = e - (n & C);
     v[m >> 2] = (e | 0) / 256;
     k = k + 1 | 0;
     continue;
    }
    break;
   }
   v[c >> 2] = v[c >> 2] + B(v[f + 8 >> 2], y);
   v[c + 4 >> 2] = v[c + 4 >> 2] + B(v[f + 12 >> 2], x);
   Ob(f + 16 | 0, o, G);
   c = c + 8 | 0;
   d = d - 1 | 0;
   continue;
  }
  break;
 }
 b = v[f + 20 >> 2];
 v[a >> 2] = v[f + 16 >> 2];
 v[a + 4 >> 2] = b;
 v[a + 44 >> 2] = v[f + 32 >> 2];
 v[a + 48 >> 2] = v[f + 36 >> 2];
 v[a + 52 >> 2] = v[f + 40 >> 2];
 v[a + 56 >> 2] = v[f + 44 >> 2];
 eb = f + 48 | 0;
}

function $7(a, b, c, d, e, f) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 f = f | 0;
 var g = 0, h = 0, i = 0;
 d = v[d + 28 >> 2];
 a = eb - 384 | 0;
 eb = a;
 v[a + 376 >> 2] = c;
 v[a + 380 >> 2] = b;
 Dy(a + 220 | 0, d, a + 240 | 0, a + 236 | 0, a + 232 | 0);
 d = Eb(a + 208 | 0);
 b = Lc(d);
 v[31601] = 0;
 N(46, d | 0, b | 0);
 b = v[31601];
 v[31601] = 0;
 a: {
  b: {
   c: {
    if ((b | 0) != 1) {
     c = dc(d, 0);
     v[a + 204 >> 2] = c;
     v[a + 28 >> 2] = a + 32;
     v[a + 24 >> 2] = 0;
     t[a + 23 | 0] = 1;
     t[a + 22 | 0] = 69;
     h = v[a + 232 >> 2];
     i = v[a + 236 >> 2];
     while (1) {
      d: {
       v[31601] = 0;
       b = O(1256, a + 380 | 0, a + 376 | 0) | 0;
       g = v[31601];
       v[31601] = 0;
       if ((g | 0) == 1) {
        break d;
       }
       if (b) {
        break c;
       }
       g = v[a + 204 >> 2];
       b = Cb(v[d + 4 >> 2], w[d + 11 | 0]);
       if ((g | 0) == (b + c | 0)) {
        v[31601] = 0;
        N(46, d | 0, b << 1);
        c = v[31601];
        v[31601] = 0;
        if ((c | 0) == 1) {
         break b;
        }
        c = Lc(d);
        v[31601] = 0;
        N(46, d | 0, c | 0);
        c = v[31601];
        v[31601] = 0;
        if ((c | 0) == 1) {
         break b;
        }
        c = dc(d, 0);
        v[a + 204 >> 2] = b + c;
       }
       v[31601] = 0;
       b = Q(1257, v[a + 380 >> 2]) | 0;
       g = v[31601];
       v[31601] = 0;
       if ((g | 0) == 1) {
        break d;
       }
       if (Cy(b, a + 23 | 0, a + 22 | 0, c, a + 204 | 0, i, h, a + 220 | 0, a + 32 | 0, a + 28 | 0, a + 24 | 0, a + 240 | 0)) {
        break c;
       }
       v[31601] = 0;
       Q(1259, a + 380 | 0) | 0;
       b = v[31601];
       v[31601] = 0;
       if ((b | 0) != 1) {
        continue;
       }
      }
      break;
     }
     break b;
    }
    break b;
   }
   e: {
    if (!Cb(v[a + 224 >> 2], w[a + 231 | 0]) | !w[a + 23 | 0]) {
     break e;
    }
    b = v[a + 28 >> 2];
    if ((b - (a + 32 | 0) | 0) > 159) {
     break e;
    }
    v[a + 28 >> 2] = b + 4;
    v[b >> 2] = v[a + 24 >> 2];
   }
   sK(a, c, v[a + 204 >> 2], e);
   b = v[a >> 2];
   c = v[a + 4 >> 2];
   h = v[a + 12 >> 2];
   v[f + 8 >> 2] = v[a + 8 >> 2];
   v[f + 12 >> 2] = h;
   v[f >> 2] = b;
   v[f + 4 >> 2] = c;
   Uf(a + 220 | 0, a + 32 | 0, v[a + 28 >> 2], e);
   v[31601] = 0;
   b = O(1256, a + 380 | 0, a + 376 | 0) | 0;
   c = v[31601];
   v[31601] = 0;
   if ((c | 0) != 1) {
    if (b) {
     v[e >> 2] = v[e >> 2] | 2;
    }
    b = v[a + 380 >> 2];
    sb(d);
    sb(a + 220 | 0);
    eb = a + 384 | 0;
    break a;
   }
  }
  b = M() | 0;
  sb(d);
  sb(a + 220 | 0);
  P(b | 0);
  p();
 }
 return b | 0;
}

function i8(a, b, c, d, e, f) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 f = f | 0;
 var g = 0, h = 0, i = 0;
 d = v[d + 28 >> 2];
 a = eb - 272 | 0;
 eb = a;
 v[a + 264 >> 2] = c;
 v[a + 268 >> 2] = b;
 Hy(a + 208 | 0, d, a + 224 | 0, a + 223 | 0, a + 222 | 0);
 d = Eb(a + 196 | 0);
 b = Lc(d);
 v[31601] = 0;
 N(46, d | 0, b | 0);
 b = v[31601];
 v[31601] = 0;
 a: {
  b: {
   c: {
    if ((b | 0) != 1) {
     c = dc(d, 0);
     v[a + 192 >> 2] = c;
     v[a + 28 >> 2] = a + 32;
     v[a + 24 >> 2] = 0;
     t[a + 23 | 0] = 1;
     t[a + 22 | 0] = 69;
     h = t[a + 222 | 0];
     i = t[a + 223 | 0];
     while (1) {
      d: {
       v[31601] = 0;
       b = O(1240, a + 268 | 0, a + 264 | 0) | 0;
       g = v[31601];
       v[31601] = 0;
       if ((g | 0) == 1) {
        break d;
       }
       if (b) {
        break c;
       }
       g = v[a + 192 >> 2];
       b = Cb(v[d + 4 >> 2], w[d + 11 | 0]);
       if ((g | 0) == (b + c | 0)) {
        v[31601] = 0;
        N(46, d | 0, b << 1);
        c = v[31601];
        v[31601] = 0;
        if ((c | 0) == 1) {
         break b;
        }
        c = Lc(d);
        v[31601] = 0;
        N(46, d | 0, c | 0);
        c = v[31601];
        v[31601] = 0;
        if ((c | 0) == 1) {
         break b;
        }
        c = dc(d, 0);
        v[a + 192 >> 2] = b + c;
       }
       v[31601] = 0;
       b = Q(1241, v[a + 268 >> 2]) | 0;
       g = v[31601];
       v[31601] = 0;
       if ((g | 0) == 1) {
        break d;
       }
       if (Gy(b, a + 23 | 0, a + 22 | 0, c, a + 192 | 0, i, h, a + 208 | 0, a + 32 | 0, a + 28 | 0, a + 24 | 0, a + 224 | 0)) {
        break c;
       }
       v[31601] = 0;
       Q(1243, a + 268 | 0) | 0;
       b = v[31601];
       v[31601] = 0;
       if ((b | 0) != 1) {
        continue;
       }
      }
      break;
     }
     break b;
    }
    break b;
   }
   e: {
    if (!Cb(v[a + 212 >> 2], w[a + 219 | 0]) | !w[a + 23 | 0]) {
     break e;
    }
    b = v[a + 28 >> 2];
    if ((b - (a + 32 | 0) | 0) > 159) {
     break e;
    }
    v[a + 28 >> 2] = b + 4;
    v[b >> 2] = v[a + 24 >> 2];
   }
   sK(a, c, v[a + 192 >> 2], e);
   b = v[a >> 2];
   c = v[a + 4 >> 2];
   h = v[a + 12 >> 2];
   v[f + 8 >> 2] = v[a + 8 >> 2];
   v[f + 12 >> 2] = h;
   v[f >> 2] = b;
   v[f + 4 >> 2] = c;
   Uf(a + 208 | 0, a + 32 | 0, v[a + 28 >> 2], e);
   v[31601] = 0;
   b = O(1240, a + 268 | 0, a + 264 | 0) | 0;
   c = v[31601];
   v[31601] = 0;
   if ((c | 0) != 1) {
    if (b) {
     v[e >> 2] = v[e >> 2] | 2;
    }
    b = v[a + 268 >> 2];
    sb(d);
    sb(a + 208 | 0);
    eb = a + 272 | 0;
    break a;
   }
  }
  b = M() | 0;
  sb(d);
  sb(a + 208 | 0);
  P(b | 0);
  p();
 }
 return b | 0;
}

function EP() {
 var a = 0, b = 0, c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
 e = eb - 240 | 0;
 eb = e;
 if (!w[126568]) {
  if (!w[126440]) {
   b = eb - 16 | 0;
   eb = b;
   Eb(126416);
   v[31607] = 0;
   t[126432] = 0;
   v[31609] = 0;
   v[31601] = 0;
   a = ba(55) | 0;
   c = v[31601];
   v[31601] = 0;
   a: {
    b: {
     c: {
      d: {
       e: {
        f: {
         if ((c | 0) != 1) {
          v[b + 12 >> 2] = a;
          a = b + 12 | 0;
          IA(126428, me(a));
          El(a);
          t[126432] = 0;
          break f;
         }
         a = sa(124508, 125092) | 0;
         c = fb;
         if ((_(124508) | 0) == (c | 0)) {
          X(a | 0) | 0;
          v[31601] = 0;
          W(56);
          b = v[31601];
          v[31601] = 0;
          if ((b | 0) == 1) {
           break d;
          }
          p();
         }
         if ((_(125092) | 0) != (c | 0)) {
          break c;
         }
         X(a | 0) | 0;
         v[31601] = 0;
         t[126432] = 0;
         W(26);
         a = v[31601];
         v[31601] = 0;
         if ((a | 0) == 1) {
          a = M() | 0;
          break c;
         }
         if (w[126432]) {
          break e;
         }
        }
        v[31601] = 0;
        V(57, 126412);
        a = v[31601];
        v[31601] = 0;
        if ((a | 0) != 1) {
         break e;
        }
        a = M() | 0;
        break c;
       }
       eb = b + 16 | 0;
       break a;
      }
      a = M() | 0;
      v[31601] = 0;
      W(26);
      b = v[31601];
      v[31601] = 0;
      if ((b | 0) == 1) {
       break b;
      }
     }
     El(126436);
     El(126428);
     sb(126416);
     P(a | 0);
     p();
    }
    S(0) | 0;
    Rb();
    p();
   }
   t[126440] = 1;
  }
  c = eb + -64 | 0;
  eb = c;
  b = c + 16 | 0;
  g = eb - 16 | 0;
  eb = g;
  h = lP(g + 8 | 0);
  j = e + 120 | 0;
  l = c + 4 | 0;
  while (1) {
   if ((i | 0) == 12) {
    eb = g + 16 | 0;
   } else {
    f = eb - 48 | 0;
    eb = f;
    a = v[h + 4 >> 2];
    d = v[h >> 2];
    g: {
     if ((a | 0) == (d | 0)) {
      break g;
     }
     a = (a - d | 0) + 1 | 0;
     if (!a) {
      a = eP(fP(f + 12 | 0, 32));
      break g;
     }
     d = E(a);
     d = fP(f + 12 | 0, (a << d & 2147483647 ? 32 : 31) - d | 0);
     while (1) {
      k = eP(d);
      if (a >>> 0 <= k >>> 0) {
       continue;
      }
      break;
     }
     a = v[h >> 2] + k | 0;
    }
    eb = f + 48 | 0;
    m = xb(b, i), n = a, v[m >> 2] = n;
    i = i + 1 | 0;
    continue;
   }
   break;
  }
  b = uP(l, b, yP(b));
  pP(j, b);
  Vm(b);
  eb = c - -64 | 0;
  yc(126448, yc(e, j, 120), 116);
  t[126568] = 1;
 }
 eb = e + 240 | 0;
}

function tma(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, w = 0, x = 0, y = 0, z = 0, A = 0, C = 0, D = 0, E = 0;
 b = eb - 48 | 0;
 eb = b;
 s = v[a + 16 >> 2];
 v[b + 32 >> 2] = v[a + 44 >> 2];
 v[b + 36 >> 2] = v[a + 48 >> 2];
 v[b + 40 >> 2] = v[a + 52 >> 2];
 v[b + 44 >> 2] = v[a + 56 >> 2];
 j = v[a + 40 >> 2];
 k = v[a + 36 >> 2];
 f = v[a + 4 >> 2];
 v[b + 16 >> 2] = v[a >> 2];
 v[b + 20 >> 2] = f;
 t = b + 32 | 0;
 w = v[a + 32 >> 2];
 x = v[a + 28 >> 2];
 y = v[a + 72 >> 2];
 p = v[a + 68 >> 2];
 z = p >> 31;
 q = v[a + 64 >> 2];
 A = q >> 31;
 r = v[a + 60 >> 2];
 C = r >> 31;
 D = v[a + 8 >> 2];
 E = v[a + 12 >> 2];
 while (1) {
  if (d) {
   f = v[b + 16 >> 2];
   l = ((((v[b + 20 >> 2] & 2147483647) << 1 | f >>> 31) & 2147483646) << 1) + s | 0;
   f = f >>> 21 & 2040;
   h = u[f + 38054 >> 1];
   o = u[f + 38052 >> 1];
   i = u[f + 38050 >> 1];
   e = u[f + 38048 >> 1];
   m = 0;
   g = 0;
   while (1) {
    if ((g | 0) != 2) {
     f = g << 1;
     n = l + f | 0;
     v[(b + 8 | 0) + (g << 2) >> 2] = (((B(u[n >> 1], i) + B(u[l + (f | -4) >> 1], e) | 0) + B(o, u[n + 4 >> 1]) | 0) + B(h, u[n + 8 >> 1]) | 0) / 16384;
     g = g + 1 | 0;
     continue;
    }
    break;
   }
   while (1) {
    if ((m | 0) != 2) {
     l = (b + 8 | 0) + (m << 2) | 0;
     e = v[l >> 2];
     f = (m << 3) + t | 0;
     n = v[f + 4 >> 2];
     h = v[f >> 2];
     v[f + 4 >> 2] = h;
     o = e << 8;
     e = o;
     e = Aua(e, e >> 31, r, C);
     i = gb;
     g = e;
     e = Xb(h, -16777216, 16776704);
     e = Aua(q, A, e, e >> 31);
     h = g + e | 0;
     g = gb + i | 0;
     g = e >>> 0 > h >>> 0 ? g + 1 | 0 : g;
     e = Xb(n, -16777216, 16776704);
     i = Aua(p, z, e, e >> 31);
     h = i + h | 0;
     e = gb + g | 0;
     e = h >>> 0 < i >>> 0 ? e + 1 | 0 : e;
     i = h + 8388608 | 0;
     e = i >>> 0 < 8388608 ? e + 1 | 0 : e;
     e = Rc(i, e, 24);
     v[f >> 2] = e - (o & y);
     v[l >> 2] = (e | 0) / 256;
     m = m + 1 | 0;
     continue;
    }
    break;
   }
   k = k + x | 0;
   v[c >> 2] = v[c >> 2] + B(v[b + 8 >> 2], k >> 12);
   j = j + w | 0;
   v[c + 4 >> 2] = v[c + 4 >> 2] + B(v[b + 12 >> 2], j >> 12);
   Ob(b + 16 | 0, D, E);
   c = c + 8 | 0;
   d = d - 1 | 0;
   continue;
  }
  break;
 }
 c = v[b + 20 >> 2];
 v[a >> 2] = v[b + 16 >> 2];
 v[a + 4 >> 2] = c;
 v[a + 40 >> 2] = j;
 v[a + 20 >> 2] = k >> 12;
 v[a + 36 >> 2] = k;
 v[a + 24 >> 2] = j >> 12;
 v[a + 44 >> 2] = v[b + 32 >> 2];
 v[a + 48 >> 2] = v[b + 36 >> 2];
 v[a + 52 >> 2] = v[b + 40 >> 2];
 v[a + 56 >> 2] = v[b + 44 >> 2];
 eb = b + 48 | 0;
}

function Z6(a, b, c, d, e, f) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 f = f | 0;
 var g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
 a = eb - 480 | 0;
 eb = a;
 bd(a + 476 | 0, v[d + 28 >> 2]);
 v[31601] = 0;
 n = Q(1251, v[a + 476 >> 2]) | 0;
 g = v[31601];
 v[31601] = 0;
 a: {
  b: {
   c: {
    d: {
     e: {
      if ((g | 0) != 1) {
       if (Cb(v[f + 4 >> 2], w[f + 11 | 0])) {
        g = v[Vd(f, 0) >> 2];
        v[31601] = 0;
        h = O(1269, n | 0, 45) | 0;
        j = v[31601];
        v[31601] = 0;
        if ((j | 0) == 1) {
         break e;
        }
        o = (g | 0) == (h | 0);
       }
       j = Eb(a + 452 | 0);
       g = Eb(a + 440 | 0);
       h = Eb(a + 428 | 0);
       v[31601] = 0;
       ja(1291, c | 0, o | 0, v[a + 476 >> 2], a + 472 | 0, a + 468 | 0, a + 464 | 0, j | 0, g | 0, h | 0, a + 424 | 0);
       c = v[31601];
       v[31601] = 0;
       if ((c | 0) == 1) {
        break d;
       }
       v[a + 4 >> 2] = 1238;
       c = Ce(a + 8 | 0, 0, a + 4 | 0);
       k = a + 16 | 0;
       l = Cb(v[f + 4 >> 2], w[f + 11 | 0]);
       m = v[a + 424 >> 2];
       f: {
        if ((l | 0) > (m | 0)) {
         i = ((Cb(v[h + 4 >> 2], w[h + 11 | 0]) + (l - m << 1) | 0) + Cb(v[g + 4 >> 2], w[g + 11 | 0]) | 0) + 1 | 0;
         break f;
        }
        i = (Cb(v[h + 4 >> 2], w[h + 11 | 0]) + Cb(v[g + 4 >> 2], w[g + 11 | 0]) | 0) + 2 | 0;
       }
       g: {
        i = i + m | 0;
        if (i >>> 0 >= 101) {
         Qe(c, Fd(i << 2));
         k = v[c >> 2];
         if (!k) {
          break g;
         }
         l = Cb(v[f + 4 >> 2], w[f + 11 | 0]);
        }
        i = v[d + 4 >> 2];
        f = Jb(f);
        v[31601] = 0;
        la(1292, k | 0, a + 4 | 0, a | 0, i | 0, f | 0, f + (l << 2) | 0, n | 0, o | 0, a + 472 | 0, v[a + 468 >> 2], v[a + 464 >> 2], j | 0, g | 0, h | 0, m | 0);
        f = v[31601];
        v[31601] = 0;
        if ((f | 0) == 1) {
         break c;
        }
        v[31601] = 0;
        b = da(1272, b | 0, k | 0, v[a + 4 >> 2], v[a >> 2], d | 0, e | 0) | 0;
        d = v[31601];
        v[31601] = 0;
        if ((d | 0) == 1) {
         break c;
        }
        Kc(c);
        Tb(h);
        Tb(g);
        sb(j);
        Zb(a + 476 | 0);
        eb = a + 480 | 0;
        return b | 0;
       }
       v[31601] = 0;
       W(1239);
       b = v[31601];
       v[31601] = 0;
       if ((b | 0) == 1) {
        break c;
       }
       p();
      }
      f = M() | 0;
      break a;
     }
     f = M() | 0;
     break a;
    }
    f = M() | 0;
    break b;
   }
   f = M() | 0;
   Kc(c);
  }
  Tb(h);
  Tb(g);
  sb(j);
 }
 Zb(a + 476 | 0);
 P(f | 0);
 p();
}

function CU(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0;
 h = eb - 16 | 0;
 eb = h;
 c = v[a >> 2];
 a: {
  if (Ej(c)) {
   i = eb - 16 | 0;
   eb = i;
   f = Dc(3848);
   c = 16;
   while (1) {
    d = c + f | 0;
    v[d + 16 >> 2] = 0;
    v[d + 20 >> 2] = 0;
    v[d + 36 >> 2] = 0;
    t[d + 42 | 0] = 1;
    u[d + 40 >> 1] = 257;
    v[d + 24 >> 2] = 0;
    v[d + 28 >> 2] = 0;
    u[d + 32 >> 1] = 0;
    d = 808;
    c = c + 44 | 0;
    if ((c | 0) != 808) {
     continue;
    }
    break;
   }
   while (1) {
    c = d + f | 0;
    v[c >> 2] = 0;
    v[c + 4 >> 2] = 0;
    v[c + 68 >> 2] = 0;
    v[c + 72 >> 2] = 0;
    v[c + 24 >> 2] = 0;
    v[c + 28 >> 2] = 0;
    u[c + 20 >> 1] = 511;
    v[c + 16 >> 2] = -1;
    u[c + 14 >> 1] = 1;
    u[c + 6 >> 1] = 0;
    u[c + 8 >> 1] = 0;
    u[c + 10 >> 1] = 0;
    u[c + 12 >> 1] = 0;
    t[c + 73 | 0] = 0;
    t[c + 74 | 0] = 0;
    t[c + 75 | 0] = 0;
    t[c + 76 | 0] = 0;
    t[c + 77 | 0] = 0;
    t[c + 78 | 0] = 0;
    t[c + 79 | 0] = 0;
    t[c + 80 | 0] = 0;
    d = d + 84 | 0;
    if ((d | 0) != 3832) {
     continue;
    }
    break;
   }
   d = 0;
   c = 0;
   v[f + 3832 >> 2] = 0;
   v[f + 3836 >> 2] = 0;
   e = f + 3837 | 0;
   t[e | 0] = 0;
   t[e + 1 | 0] = 0;
   t[e + 2 | 0] = 0;
   t[e + 3 | 0] = 0;
   t[e + 4 | 0] = 0;
   t[e + 5 | 0] = 0;
   t[e + 6 | 0] = 0;
   t[e + 7 | 0] = 0;
   e = f + 808 | 0;
   while (1) {
    if ((d | 0) == 36) {
     k = f + 16 | 0;
     d = 0;
     while (1) {
      if ((c | 0) == 18) {
       b: {
        c = 0;
        while (1) if ((d | 0) == 18) {
         while (1) {
          if ((c | 0) == 36) {
           break b;
          }
          Oo(B(c, 84) + e | 0);
          c = c + 1 | 0;
          continue;
         }
        } else {
         g = B(d, 44) + k | 0;
         l = v[(d << 2) + 27248 >> 2];
         c: {
          if (!(!(1 << d & 3591) | d >>> 0 > 11)) {
           j = g;
           g = B(l, 84) + e | 0;
           HU(j, g, g + 252 | 0, g + 504 | 0, g + 756 | 0);
           break c;
          }
          j = g;
          g = B(l, 84) + e | 0;
          HU(j, g, g + 252 | 0, 0, 0);
         }
         d = d + 1 | 0;
         continue;
        }
       }
      } else {
       v[(B(c, 44) + k | 0) + 16 >> 2] = f;
       c = c + 1 | 0;
       continue;
      }
      break;
     }
     GU(f, b);
    } else {
     xd(B(d, 84) + e | 0, f);
     d = d + 1 | 0;
     continue;
    }
    break;
   }
   b = v[xf(i + 12 | 0, f) >> 2];
   eb = i + 16 | 0;
   v[h + 12 >> 2] = b;
   b = h + 12 | 0;
   wA(a, b);
   El(b);
   break a;
  }
  GU(c, b);
 }
 BU(a);
 eb = h + 16 | 0;
}

function b7(a, b, c, d, e, f) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 f = f | 0;
 var g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
 a = eb - 176 | 0;
 eb = a;
 bd(a + 172 | 0, v[d + 28 >> 2]);
 v[31601] = 0;
 n = Q(28, v[a + 172 >> 2]) | 0;
 g = v[31601];
 v[31601] = 0;
 a: {
  b: {
   c: {
    d: {
     e: {
      if ((g | 0) != 1) {
       if (Cb(v[f + 4 >> 2], w[f + 11 | 0])) {
        g = w[dc(f, 0) | 0];
        v[31601] = 0;
        h = O(29, n | 0, 45) | 0;
        j = v[31601];
        v[31601] = 0;
        if ((j | 0) == 1) {
         break e;
        }
        o = (h & 255) == (g | 0);
       }
       j = Eb(a + 152 | 0);
       g = Eb(a + 140 | 0);
       h = Eb(a + 128 | 0);
       v[31601] = 0;
       ja(1289, c | 0, o | 0, v[a + 172 >> 2], a + 168 | 0, a + 167 | 0, a + 166 | 0, j | 0, g | 0, h | 0, a + 124 | 0);
       c = v[31601];
       v[31601] = 0;
       if ((c | 0) == 1) {
        break d;
       }
       v[a + 4 >> 2] = 1238;
       c = Ce(a + 8 | 0, 0, a + 4 | 0);
       k = a + 16 | 0;
       l = Cb(v[f + 4 >> 2], w[f + 11 | 0]);
       m = v[a + 124 >> 2];
       f: {
        if ((l | 0) > (m | 0)) {
         i = ((Cb(v[h + 4 >> 2], w[h + 11 | 0]) + (l - m << 1) | 0) + Cb(v[g + 4 >> 2], w[g + 11 | 0]) | 0) + 1 | 0;
         break f;
        }
        i = (Cb(v[h + 4 >> 2], w[h + 11 | 0]) + Cb(v[g + 4 >> 2], w[g + 11 | 0]) | 0) + 2 | 0;
       }
       g: {
        i = i + m | 0;
        if (i >>> 0 >= 101) {
         Qe(c, Fd(i));
         k = v[c >> 2];
         if (!k) {
          break g;
         }
         l = Cb(v[f + 4 >> 2], w[f + 11 | 0]);
        }
        i = v[d + 4 >> 2];
        f = Jb(f);
        v[31601] = 0;
        la(1290, k | 0, a + 4 | 0, a | 0, i | 0, f | 0, f + l | 0, n | 0, o | 0, a + 168 | 0, t[a + 167 | 0], t[a + 166 | 0], j | 0, g | 0, h | 0, m | 0);
        f = v[31601];
        v[31601] = 0;
        if ((f | 0) == 1) {
         break c;
        }
        v[31601] = 0;
        b = da(23, b | 0, k | 0, v[a + 4 >> 2], v[a >> 2], d | 0, e | 0) | 0;
        d = v[31601];
        v[31601] = 0;
        if ((d | 0) == 1) {
         break c;
        }
        Kc(c);
        sb(h);
        sb(g);
        sb(j);
        Zb(a + 172 | 0);
        eb = a + 176 | 0;
        return b | 0;
       }
       v[31601] = 0;
       W(1239);
       b = v[31601];
       v[31601] = 0;
       if ((b | 0) == 1) {
        break c;
       }
       p();
      }
      f = M() | 0;
      break a;
     }
     f = M() | 0;
     break a;
    }
    f = M() | 0;
    break b;
   }
   f = M() | 0;
   Kc(c);
  }
  sb(h);
  sb(g);
  sb(j);
 }
 Zb(a + 172 | 0);
 P(f | 0);
 p();
}

function uma(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, w = 0, x = 0, y = 0, z = 0, A = 0, C = 0, D = 0, E = 0, F = 0;
 b = eb - 48 | 0;
 eb = b;
 s = v[a + 16 >> 2];
 v[b + 32 >> 2] = v[a + 44 >> 2];
 v[b + 36 >> 2] = v[a + 48 >> 2];
 v[b + 40 >> 2] = v[a + 52 >> 2];
 v[b + 44 >> 2] = v[a + 56 >> 2];
 l = v[a + 40 >> 2];
 m = v[a + 36 >> 2];
 f = v[a + 4 >> 2];
 v[b + 16 >> 2] = v[a >> 2];
 v[b + 20 >> 2] = f;
 w = b + 32 | 0;
 x = v[a + 32 >> 2];
 y = v[a + 28 >> 2];
 z = v[a + 72 >> 2];
 p = v[a + 68 >> 2];
 A = p >> 31;
 q = v[a + 64 >> 2];
 C = q >> 31;
 r = v[a + 60 >> 2];
 D = r >> 31;
 E = v[a + 8 >> 2];
 F = v[a + 12 >> 2];
 while (1) {
  if (d) {
   f = v[b + 16 >> 2];
   g = (((v[b + 20 >> 2] & 2147483647) << 1 | f >>> 31) & -2) + s | 0;
   f = f >>> 21 & 2040;
   o = u[f + 38050 >> 1] << 8;
   h = u[f + 38048 >> 1] << 8;
   e = u[f + 38052 >> 1] << 8;
   f = u[f + 38054 >> 1] << 8;
   n = 0;
   i = 0;
   while (1) {
    if ((i | 0) != 2) {
     j = g + i | 0;
     v[(b + 8 | 0) + (i << 2) >> 2] = (((B(o, t[j | 0]) + B(h, t[j - 2 | 0]) | 0) + B(t[j + 2 | 0], e) | 0) + B(t[j + 4 | 0], f) | 0) / 16384;
     i = i + 1 | 0;
     continue;
    }
    break;
   }
   while (1) {
    if ((n | 0) != 2) {
     i = (b + 8 | 0) + (n << 2) | 0;
     e = v[i >> 2];
     f = (n << 3) + w | 0;
     j = v[f + 4 >> 2];
     g = v[f >> 2];
     v[f + 4 >> 2] = g;
     o = e << 8;
     e = o;
     e = Aua(e, e >> 31, r, D);
     h = gb;
     k = e;
     e = Xb(g, -16777216, 16776704);
     e = Aua(q, C, e, e >> 31);
     g = k + e | 0;
     k = gb + h | 0;
     k = e >>> 0 > g >>> 0 ? k + 1 | 0 : k;
     e = Xb(j, -16777216, 16776704);
     h = Aua(p, A, e, e >> 31);
     g = h + g | 0;
     e = gb + k | 0;
     e = g >>> 0 < h >>> 0 ? e + 1 | 0 : e;
     h = g + 8388608 | 0;
     e = h >>> 0 < 8388608 ? e + 1 | 0 : e;
     e = Rc(h, e, 24);
     v[f >> 2] = e - (o & z);
     v[i >> 2] = (e | 0) / 256;
     n = n + 1 | 0;
     continue;
    }
    break;
   }
   m = m + y | 0;
   v[c >> 2] = v[c >> 2] + B(v[b + 8 >> 2], m >> 12);
   l = l + x | 0;
   v[c + 4 >> 2] = v[c + 4 >> 2] + B(v[b + 12 >> 2], l >> 12);
   Ob(b + 16 | 0, E, F);
   c = c + 8 | 0;
   d = d - 1 | 0;
   continue;
  }
  break;
 }
 c = v[b + 20 >> 2];
 v[a >> 2] = v[b + 16 >> 2];
 v[a + 4 >> 2] = c;
 v[a + 40 >> 2] = l;
 v[a + 20 >> 2] = m >> 12;
 v[a + 36 >> 2] = m;
 v[a + 24 >> 2] = l >> 12;
 v[a + 44 >> 2] = v[b + 32 >> 2];
 v[a + 48 >> 2] = v[b + 36 >> 2];
 v[a + 52 >> 2] = v[b + 40 >> 2];
 v[a + 56 >> 2] = v[b + 44 >> 2];
 eb = b + 48 | 0;
}

function DS(a, b) {
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0;
 c = eb - 16 | 0;
 eb = c;
 d = B(b, 872) + a | 0;
 a: {
  if (v[d + 1075080 >> 2] & 134218752) {
   break a;
  }
  e = d + 1074992 | 0;
  h = v[e + 656 >> 2];
  if (!Aj(h) | w[h + 15 | 0] & 2) {
   break a;
  }
  d = mm(a, a + 1074376 | 0, b, 2, 1) - 1 | 0;
  if ((d & 255) >>> 0 > 249) {
   break a;
  }
  i = v[_d(a + 906300 | 0, d) >> 2];
  if (!i) {
   break a;
  }
  d = w[e + 788 | 0];
  b: {
   if (w[e + 790 | 0] == 1) {
    t[c + 8 | 0] = 64;
    f = w[Pb(e + 792 | 0, c + 8 | 0) | 0];
    break b;
   }
   g = w[e + 791 | 0];
   if ((g | 0) != 46) {
    f = 255;
    if ((g | 0) != 13) {
     break b;
    }
    t[c + 8 | 0] = 64;
    f = w[Pb(e + 793 | 0, c + 8 | 0) | 0];
    break b;
   }
   f = w[e + 793 | 0] + 3 >>> 2 | 0;
  }
  j = a + 1074312 | 0;
  Ib(c + 8 | 0, j, 2);
  if (Fb(v[v[c + 8 >> 2] >> 2], v[c + 12 >> 2])) {
   if (d) {
    if (Tc(d)) {
     d = w[wb(h + 108 | 0, d - 1 | 0) | 0];
    }
    Wm(a, b, d, x[e + 688 >> 1]);
    break a;
   }
   if ((f | 0) == 255) {
    break a;
   }
   hb[v[v[i >> 2] + 76 >> 2]](i, 39, f, b);
   break a;
  }
  k = v[h + 4 >> 2];
  c: {
   if (!d) {
    break c;
   }
   g = w[h + 35 | 0] ? k << 2 : v[e + 688 >> 2];
   l = u[e + 776 >> 1];
   Ib(c + 8 | 0, j, 28);
   m = c, n = g + (Fb(v[v[c + 8 >> 2] >> 2], v[c + 12 >> 2]) ? l << 2 : l) | 0, v[m + 4 >> 2] = n;
   Fe(c + 4 | 0, 0, 256);
   g = d;
   if (Tc(d)) {
    g = w[wb(h + 108 | 0, d - 1 | 0) | 0];
   }
   Ib(c + 8 | 0, j, 117);
   if (!Fb(v[v[c + 8 >> 2] >> 2], v[c + 12 >> 2])) {
    if (Il(w[e + 790 | 0], w[e + 791 | 0])) {
     break c;
    }
   }
   Wm(a, b, g & 255, x[c + 4 >> 1]);
  }
  a = w[h + 35 | 0];
  Ib(c + 8 | 0, j, 101);
  a = (a | 0) == 1;
  g = (f | 0) != 255;
  if (!Fb(v[v[c + 8 >> 2] >> 2], v[c + 12 >> 2])) {
   d = Tc(d);
  }
  if (((d ? a : g) | 0) != 1) {
   break a;
  }
  d: {
   switch (w[h + 36 | 0]) {
   case 1:
    a = v[i + 20 >> 2];
    if ((f | 0) != 255) {
     Ju(a, C(C(C(f << 1) / C(-127)) + C(1)));
     break a;
    }
    Ju(a, C(C(C(k << 1 >>> 0) / C(-127)) + C(1)));
    break a;

   case 0:
    break d;

   default:
    break a;
   }
  }
  if ((f | 0) != 255) {
   t[c + 8 | 0] = 127;
   t[c + 4 | 0] = f << 1;
   n = i, o = 7, p = w[Pb(c + 8 | 0, c + 4 | 0) | 0], q = b, m = v[v[i >> 2] + 76 >> 2], 
   hb[m](n | 0, o | 0, p | 0, q | 0);
   break a;
  }
  v[c + 8 >> 2] = 127;
  v[c + 4 >> 2] = k << 1;
  q = i, p = 7, o = w[Gb(c + 8 | 0, c + 4 | 0) | 0], n = b, m = v[v[i >> 2] + 76 >> 2], 
  hb[m](q | 0, p | 0, o | 0, n | 0);
 }
 eb = c + 16 | 0;
}

function xoa(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0;
 c = v[a >> 2];
 d = Td(c, v[a + 4 >> 2]);
 if (d >>> 0 < b >>> 0) {
  i = eb - 32 | 0;
  eb = i;
  b = b - d | 0;
  d = v[zb(a) >> 2];
  c = v[a + 4 >> 2];
  a: {
   if (b >>> 0 <= (d - c | 0) / 12 >>> 0) {
    d = eb - 16 | 0;
    eb = d;
    b = wv(d + 4 | 0, a, b);
    a = v[b + 4 >> 2];
    c = v[b + 8 >> 2];
    while (1) {
     if ((a | 0) == (c | 0)) {
      hc(b);
      eb = d + 16 | 0;
     } else {
      mW(a);
      a = a + 12 | 0;
      v[b + 4 >> 2] = a;
      continue;
     }
     break;
    }
    break a;
   }
   d = zb(a);
   d = wm(i + 12 | 0, Qp(a, Td(v[a >> 2], c) + b | 0), Td(v[a >> 2], v[a + 4 >> 2]), d);
   f = eb - 16 | 0;
   eb = f;
   b = lW(f + 4 | 0, d + 8 | 0, b);
   c = v[b >> 2];
   while (1) {
    if (v[b + 4 >> 2] != (c | 0)) {
     mW(c);
     c = v[b >> 2] + 12 | 0;
     v[b >> 2] = c;
     continue;
    }
    break;
   }
   ie(b);
   eb = f + 16 | 0;
   f = eb - 16 | 0;
   eb = f;
   e = zb(a);
   b = ub(f + 12 | 0, v[a + 4 >> 2]);
   g = ub(f + 8 | 0, v[a >> 2]);
   h = ub(f + 4 | 0, v[d + 4 >> 2]);
   c = v[b >> 2];
   g = v[g >> 2];
   b = eb + -64 | 0;
   eb = b;
   h = v[h >> 2];
   v[b + 56 >> 2] = h;
   v[b + 60 >> 2] = c;
   v[b + 52 >> 2] = h;
   e = zg(b + 24 | 0, e, b + 52 | 0, b + 56 | 0);
   v[b + 16 >> 2] = v[e + 8 >> 2];
   h = v[e + 4 >> 2];
   v[b + 8 >> 2] = v[e >> 2];
   v[b + 12 >> 2] = h;
   yg(b + 36 | 0, b + 8 | 0);
   while (1) {
    if (Ed(c, g)) {
     kW(Pp(v[b + 56 >> 2]), $k(c));
     c = ik(b + 60 | 0);
     ik(b + 56 | 0);
     c = v[c >> 2];
     continue;
    }
    break;
   }
   xg(b + 36 | 0);
   h = v[b + 56 >> 2];
   if (!w[b + 48 | 0]) {
    e = eb - 16 | 0;
    eb = e;
    c = ub(e + 12 | 0, v[v[b + 44 >> 2] >> 2]);
    j = v[ub(e + 8 | 0, v[v[b + 40 >> 2] >> 2]) >> 2];
    g = eb - 16 | 0;
    eb = g;
    c = v[c >> 2];
    v[g + 12 >> 2] = c;
    while (1) {
     if (vi(c, j)) {
      zC(Ax(c));
      c = v[vm(g + 12 | 0) >> 2];
      continue;
     }
     break;
    }
    eb = g + 16 | 0;
    eb = e + 16 | 0;
   }
   eb = b - -64 | 0;
   v[d + 4 >> 2] = h;
   Sb(a, d + 4 | 0);
   Sb(a + 4 | 0, d + 8 | 0);
   Sb(zb(a), mc(d));
   v[d >> 2] = v[d + 4 >> 2];
   eb = f + 16 | 0;
   a = v[d + 4 >> 2];
   while (1) {
    b = v[d + 8 >> 2];
    if ((b | 0) != (a | 0)) {
     b = b - 12 | 0;
     v[d + 8 >> 2] = b;
     zC(b);
     continue;
    }
    break;
   }
   a = v[d >> 2];
   if (a) {
    vs(d);
    Bb(a);
   }
  }
  eb = i + 32 | 0;
  return;
 }
 if (b >>> 0 < d >>> 0) {
  nW(a, c + B(b, 12) | 0);
 }
}

function ala(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, k = 0, l = 0, m = 0, n = 0, p = 0, q = 0, r = 0, s = 0;
 g = eb - 32 | 0;
 eb = g;
 e = oU(g + 20 | 0, 1 << v[b + 12 >> 2]);
 f = v[e >> 2];
 while (1) {
  d = v[a >> 2];
  if (hh(d, v[a + 4 >> 2]) >>> 0 > c >>> 0) {
   d = Se(d, c);
   nU(Xd(f, c), A[d >> 3]);
   c = c + 1 | 0;
   continue;
  }
  break;
 }
 mU(b, e);
 c = vb(v[e >> 2]);
 v[g >> 2] = c;
 q = vb(v[e + 4 >> 2]);
 while (1) {
  if (Hb(c, q)) {
   h = eb - 32 | 0;
   eb = h;
   p = D(A[c + 8 >> 3]);
   k = D(A[c >> 3]);
   o(+k);
   n = j(1) | 0;
   f = j(0) | 0;
   o(+p);
   l = j(1) | 0;
   d = j(0) | 0;
   l = (l | 0) == (n | 0) & d >>> 0 > f >>> 0 | l >>> 0 > n >>> 0;
   i = l ? k : p;
   o(+i);
   d = j(1) | 0;
   f = j(0) | 0;
   n = d >>> 20 | 0;
   a: {
    if ((n | 0) == 2047) {
     break a;
    }
    m = l ? p : k;
    b: {
     if (!(d | f)) {
      break b;
     }
     o(+m);
     d = j(1) | 0;
     j(0) | 0;
     d = d >>> 20 | 0;
     if ((d | 0) == 2047) {
      break b;
     }
     if ((d - n | 0) >= 65) {
      i = k + p;
      break a;
     }
     c: {
      if (d >>> 0 >= 1534) {
       i = i * 190109156629516e-225;
       m = m * 190109156629516e-225;
       k = 5.260135901548374e210;
       break c;
      }
      k = 1;
      if (n >>> 0 > 572) {
       break c;
      }
      i = i * 5.260135901548374e210;
      m = m * 5.260135901548374e210;
      k = 190109156629516e-225;
     }
     zL(h + 24 | 0, h + 16 | 0, m);
     zL(h + 8 | 0, h, i);
     i = k * K(A[h >> 3] + A[h + 16 >> 3] + A[h + 8 >> 3] + A[h + 24 >> 3]);
     break a;
    }
    i = m;
   }
   eb = h + 32 | 0;
   nU(c, mq(i));
   c = v[Uo(g) >> 2];
   continue;
  }
  break;
 }
 lU(b, e);
 kU(e);
 l = v[e >> 2];
 f = Ck(l, v[e + 4 >> 2]) >>> 1 | 0;
 d = f >>> 0 <= 1 ? 1 : f;
 c = 1;
 while (1) {
  if ((c | 0) != (d | 0)) {
   QB(Xd(l, c), 2);
   QB(Xd(l, c + f | 0), 0);
   c = c + 1 | 0;
   continue;
  }
  break;
 }
 mU(b, e);
 c = vb(v[e >> 2]);
 v[g + 16 >> 2] = c;
 f = vb(v[e + 4 >> 2]);
 while (1) {
  if (Hb(c, f)) {
   jU(g, A[c >> 3], A[c + 8 >> 3]);
   d = v[g + 12 >> 2];
   v[c + 8 >> 2] = v[g + 8 >> 2];
   v[c + 12 >> 2] = d;
   d = v[g + 4 >> 2];
   v[c >> 2] = v[g >> 2];
   v[c + 4 >> 2] = d;
   c = v[Uo(g + 16 | 0) >> 2];
   continue;
  }
  break;
 }
 lU(b, e);
 kU(e);
 f = v[a >> 2];
 d = hh(f, v[a + 4 >> 2]);
 b = v[e >> 2];
 c = 0;
 while (1) {
  if ((c | 0) == (d | 0)) {
   jn(e);
   eb = g + 32 | 0;
  } else {
   a = Xd(b, c);
   r = Se(f, c), s = A[a >> 3], A[r >> 3] = s;
   c = c + 1 | 0;
   continue;
  }
  break;
 }
}

function bJ(a, b, c, d, e, f, g, h) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 f = f | 0;
 g = g | 0;
 h = h | 0;
 var i = 0;
 a = eb - 16 | 0;
 eb = a;
 v[a + 12 >> 2] = c;
 v[a + 8 >> 2] = f;
 v[a + 12 >> 2] = c;
 v[a + 8 >> 2] = f;
 c = v[a + 12 >> 2];
 a: {
  while (1) {
   if (c >>> 0 >= d >>> 0) {
    f = 0;
    break a;
   }
   b: {
    b = x[c >> 1];
    c: {
     if (b >>> 0 <= 127) {
      f = 1;
      c = v[a + 8 >> 2];
      if ((g - c | 0) <= 0) {
       break a;
      }
      v[a + 8 >> 2] = c + 1;
      t[c | 0] = b;
      break c;
     }
     if (b >>> 0 <= 2047) {
      c = v[a + 8 >> 2];
      if ((g - c | 0) < 2) {
       break b;
      }
      v[a + 8 >> 2] = c + 1;
      t[c | 0] = b >>> 6 | 192;
      c = v[a + 8 >> 2];
      v[a + 8 >> 2] = c + 1;
      t[c | 0] = b & 63 | 128;
      break c;
     }
     if (b >>> 0 <= 55295) {
      c = v[a + 8 >> 2];
      if ((g - c | 0) < 3) {
       break b;
      }
      v[a + 8 >> 2] = c + 1;
      t[c | 0] = b >>> 12 | 224;
      c = v[a + 8 >> 2];
      v[a + 8 >> 2] = c + 1;
      t[c | 0] = b >>> 6 & 63 | 128;
      c = v[a + 8 >> 2];
      v[a + 8 >> 2] = c + 1;
      t[c | 0] = b & 63 | 128;
      break c;
     }
     d: {
      e: {
       if (b >>> 0 <= 56319) {
        f = 1;
        if ((d - c | 0) < 4) {
         break a;
        }
        i = x[c + 2 >> 1];
        if ((i & 64512) != 56320) {
         break e;
        }
        if ((g - v[a + 8 >> 2] | 0) < 4) {
         break a;
        }
        v[a + 12 >> 2] = c + 2;
        c = v[a + 8 >> 2];
        v[a + 8 >> 2] = c + 1;
        f = c;
        c = (b >>> 6 & 15) + 1 | 0;
        t[f | 0] = c >>> 2 | 240;
        f = v[a + 8 >> 2];
        v[a + 8 >> 2] = f + 1;
        t[f | 0] = c << 4 & 48 | b >>> 2 & 15 | 128;
        c = v[a + 8 >> 2];
        v[a + 8 >> 2] = c + 1;
        t[c | 0] = i >>> 6 & 15 | b << 4 & 48 | 128;
        b = v[a + 8 >> 2];
        v[a + 8 >> 2] = b + 1;
        t[b | 0] = i & 63 | 128;
        break c;
       }
       if (b >>> 0 >= 57344) {
        break d;
       }
      }
      f = 2;
      break a;
     }
     c = v[a + 8 >> 2];
     if ((g - c | 0) < 3) {
      break b;
     }
     v[a + 8 >> 2] = c + 1;
     t[c | 0] = b >>> 12 | 224;
     c = v[a + 8 >> 2];
     v[a + 8 >> 2] = c + 1;
     t[c | 0] = b >>> 6 & 191;
     c = v[a + 8 >> 2];
     v[a + 8 >> 2] = c + 1;
     t[c | 0] = b & 63 | 128;
    }
    c = v[a + 12 >> 2] + 2 | 0;
    v[a + 12 >> 2] = c;
    continue;
   }
   break;
  }
  f = 1;
 }
 v[e >> 2] = v[a + 12 >> 2];
 v[h >> 2] = v[a + 8 >> 2];
 eb = a + 16 | 0;
 return f | 0;
}

function b8(a, b, c, d, e, f) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 f = f | 0;
 var g = 0, h = 0, i = 0, j = 0, k = C(0);
 d = v[d + 28 >> 2];
 a = eb - 368 | 0;
 eb = a;
 v[a + 360 >> 2] = c;
 v[a + 364 >> 2] = b;
 Dy(a + 204 | 0, d, a + 224 | 0, a + 220 | 0, a + 216 | 0);
 d = Eb(a + 192 | 0);
 b = Lc(d);
 v[31601] = 0;
 N(46, d | 0, b | 0);
 b = v[31601];
 v[31601] = 0;
 a: {
  b: {
   c: {
    if ((b | 0) != 1) {
     c = dc(d, 0);
     v[a + 188 >> 2] = c;
     v[a + 12 >> 2] = a + 16;
     v[a + 8 >> 2] = 0;
     t[a + 7 | 0] = 1;
     t[a + 6 | 0] = 69;
     h = v[a + 216 >> 2];
     i = v[a + 220 >> 2];
     while (1) {
      d: {
       v[31601] = 0;
       b = O(1256, a + 364 | 0, a + 360 | 0) | 0;
       g = v[31601];
       v[31601] = 0;
       if ((g | 0) == 1) {
        break d;
       }
       if (b) {
        break c;
       }
       g = v[a + 188 >> 2];
       b = Cb(v[d + 4 >> 2], w[d + 11 | 0]);
       if ((g | 0) == (b + c | 0)) {
        v[31601] = 0;
        N(46, d | 0, b << 1);
        c = v[31601];
        v[31601] = 0;
        if ((c | 0) == 1) {
         break b;
        }
        c = Lc(d);
        v[31601] = 0;
        N(46, d | 0, c | 0);
        c = v[31601];
        v[31601] = 0;
        if ((c | 0) == 1) {
         break b;
        }
        c = dc(d, 0);
        v[a + 188 >> 2] = b + c;
       }
       v[31601] = 0;
       b = Q(1257, v[a + 364 >> 2]) | 0;
       g = v[31601];
       v[31601] = 0;
       if ((g | 0) == 1) {
        break d;
       }
       if (Cy(b, a + 7 | 0, a + 6 | 0, c, a + 188 | 0, i, h, a + 204 | 0, a + 16 | 0, a + 12 | 0, a + 8 | 0, a + 224 | 0)) {
        break c;
       }
       v[31601] = 0;
       Q(1259, a + 364 | 0) | 0;
       b = v[31601];
       v[31601] = 0;
       if ((b | 0) != 1) {
        continue;
       }
      }
      break;
     }
     break b;
    }
    break b;
   }
   e: {
    if (!Cb(v[a + 208 >> 2], w[a + 215 | 0]) | !w[a + 7 | 0]) {
     break e;
    }
    b = v[a + 12 >> 2];
    if ((b - (a + 16 | 0) | 0) > 159) {
     break e;
    }
    v[a + 12 >> 2] = b + 4;
    v[b >> 2] = v[a + 8 >> 2];
   }
   j = f, k = vK(c, v[a + 188 >> 2], e), z[j >> 2] = k;
   Uf(a + 204 | 0, a + 16 | 0, v[a + 12 >> 2], e);
   v[31601] = 0;
   b = O(1256, a + 364 | 0, a + 360 | 0) | 0;
   c = v[31601];
   v[31601] = 0;
   if ((c | 0) != 1) {
    if (b) {
     v[e >> 2] = v[e >> 2] | 2;
    }
    b = v[a + 364 >> 2];
    sb(d);
    sb(a + 204 | 0);
    eb = a + 368 | 0;
    break a;
   }
  }
  b = M() | 0;
  sb(d);
  sb(a + 204 | 0);
  P(b | 0);
  p();
 }
 return b | 0;
}

function k8(a, b, c, d, e, f) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 f = f | 0;
 var g = 0, h = 0, i = 0, j = 0, k = C(0);
 d = v[d + 28 >> 2];
 a = eb - 256 | 0;
 eb = a;
 v[a + 248 >> 2] = c;
 v[a + 252 >> 2] = b;
 Hy(a + 192 | 0, d, a + 208 | 0, a + 207 | 0, a + 206 | 0);
 d = Eb(a + 180 | 0);
 b = Lc(d);
 v[31601] = 0;
 N(46, d | 0, b | 0);
 b = v[31601];
 v[31601] = 0;
 a: {
  b: {
   c: {
    if ((b | 0) != 1) {
     c = dc(d, 0);
     v[a + 176 >> 2] = c;
     v[a + 12 >> 2] = a + 16;
     v[a + 8 >> 2] = 0;
     t[a + 7 | 0] = 1;
     t[a + 6 | 0] = 69;
     h = t[a + 206 | 0];
     i = t[a + 207 | 0];
     while (1) {
      d: {
       v[31601] = 0;
       b = O(1240, a + 252 | 0, a + 248 | 0) | 0;
       g = v[31601];
       v[31601] = 0;
       if ((g | 0) == 1) {
        break d;
       }
       if (b) {
        break c;
       }
       g = v[a + 176 >> 2];
       b = Cb(v[d + 4 >> 2], w[d + 11 | 0]);
       if ((g | 0) == (b + c | 0)) {
        v[31601] = 0;
        N(46, d | 0, b << 1);
        c = v[31601];
        v[31601] = 0;
        if ((c | 0) == 1) {
         break b;
        }
        c = Lc(d);
        v[31601] = 0;
        N(46, d | 0, c | 0);
        c = v[31601];
        v[31601] = 0;
        if ((c | 0) == 1) {
         break b;
        }
        c = dc(d, 0);
        v[a + 176 >> 2] = b + c;
       }
       v[31601] = 0;
       b = Q(1241, v[a + 252 >> 2]) | 0;
       g = v[31601];
       v[31601] = 0;
       if ((g | 0) == 1) {
        break d;
       }
       if (Gy(b, a + 7 | 0, a + 6 | 0, c, a + 176 | 0, i, h, a + 192 | 0, a + 16 | 0, a + 12 | 0, a + 8 | 0, a + 208 | 0)) {
        break c;
       }
       v[31601] = 0;
       Q(1243, a + 252 | 0) | 0;
       b = v[31601];
       v[31601] = 0;
       if ((b | 0) != 1) {
        continue;
       }
      }
      break;
     }
     break b;
    }
    break b;
   }
   e: {
    if (!Cb(v[a + 196 >> 2], w[a + 203 | 0]) | !w[a + 7 | 0]) {
     break e;
    }
    b = v[a + 12 >> 2];
    if ((b - (a + 16 | 0) | 0) > 159) {
     break e;
    }
    v[a + 12 >> 2] = b + 4;
    v[b >> 2] = v[a + 8 >> 2];
   }
   j = f, k = vK(c, v[a + 176 >> 2], e), z[j >> 2] = k;
   Uf(a + 192 | 0, a + 16 | 0, v[a + 12 >> 2], e);
   v[31601] = 0;
   b = O(1240, a + 252 | 0, a + 248 | 0) | 0;
   c = v[31601];
   v[31601] = 0;
   if ((c | 0) != 1) {
    if (b) {
     v[e >> 2] = v[e >> 2] | 2;
    }
    b = v[a + 252 >> 2];
    sb(d);
    sb(a + 192 | 0);
    eb = a + 256 | 0;
    break a;
   }
  }
  b = M() | 0;
  sb(d);
  sb(a + 192 | 0);
  P(b | 0);
  p();
 }
 return b | 0;
}

function a8(a, b, c, d, e, f) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 f = f | 0;
 var g = 0, h = 0, i = 0, j = 0, k = 0;
 d = v[d + 28 >> 2];
 a = eb - 368 | 0;
 eb = a;
 v[a + 360 >> 2] = c;
 v[a + 364 >> 2] = b;
 Dy(a + 204 | 0, d, a + 224 | 0, a + 220 | 0, a + 216 | 0);
 d = Eb(a + 192 | 0);
 b = Lc(d);
 v[31601] = 0;
 N(46, d | 0, b | 0);
 b = v[31601];
 v[31601] = 0;
 a: {
  b: {
   c: {
    if ((b | 0) != 1) {
     c = dc(d, 0);
     v[a + 188 >> 2] = c;
     v[a + 12 >> 2] = a + 16;
     v[a + 8 >> 2] = 0;
     t[a + 7 | 0] = 1;
     t[a + 6 | 0] = 69;
     h = v[a + 216 >> 2];
     i = v[a + 220 >> 2];
     while (1) {
      d: {
       v[31601] = 0;
       b = O(1256, a + 364 | 0, a + 360 | 0) | 0;
       g = v[31601];
       v[31601] = 0;
       if ((g | 0) == 1) {
        break d;
       }
       if (b) {
        break c;
       }
       g = v[a + 188 >> 2];
       b = Cb(v[d + 4 >> 2], w[d + 11 | 0]);
       if ((g | 0) == (b + c | 0)) {
        v[31601] = 0;
        N(46, d | 0, b << 1);
        c = v[31601];
        v[31601] = 0;
        if ((c | 0) == 1) {
         break b;
        }
        c = Lc(d);
        v[31601] = 0;
        N(46, d | 0, c | 0);
        c = v[31601];
        v[31601] = 0;
        if ((c | 0) == 1) {
         break b;
        }
        c = dc(d, 0);
        v[a + 188 >> 2] = b + c;
       }
       v[31601] = 0;
       b = Q(1257, v[a + 364 >> 2]) | 0;
       g = v[31601];
       v[31601] = 0;
       if ((g | 0) == 1) {
        break d;
       }
       if (Cy(b, a + 7 | 0, a + 6 | 0, c, a + 188 | 0, i, h, a + 204 | 0, a + 16 | 0, a + 12 | 0, a + 8 | 0, a + 224 | 0)) {
        break c;
       }
       v[31601] = 0;
       Q(1259, a + 364 | 0) | 0;
       b = v[31601];
       v[31601] = 0;
       if ((b | 0) != 1) {
        continue;
       }
      }
      break;
     }
     break b;
    }
    break b;
   }
   e: {
    if (!Cb(v[a + 208 >> 2], w[a + 215 | 0]) | !w[a + 7 | 0]) {
     break e;
    }
    b = v[a + 12 >> 2];
    if ((b - (a + 16 | 0) | 0) > 159) {
     break e;
    }
    v[a + 12 >> 2] = b + 4;
    v[b >> 2] = v[a + 8 >> 2];
   }
   j = f, k = tK(c, v[a + 188 >> 2], e), A[j >> 3] = k;
   Uf(a + 204 | 0, a + 16 | 0, v[a + 12 >> 2], e);
   v[31601] = 0;
   b = O(1256, a + 364 | 0, a + 360 | 0) | 0;
   c = v[31601];
   v[31601] = 0;
   if ((c | 0) != 1) {
    if (b) {
     v[e >> 2] = v[e >> 2] | 2;
    }
    b = v[a + 364 >> 2];
    sb(d);
    sb(a + 204 | 0);
    eb = a + 368 | 0;
    break a;
   }
  }
  b = M() | 0;
  sb(d);
  sb(a + 204 | 0);
  P(b | 0);
  p();
 }
 return b | 0;
}

function j8(a, b, c, d, e, f) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 f = f | 0;
 var g = 0, h = 0, i = 0, j = 0, k = 0;
 d = v[d + 28 >> 2];
 a = eb - 256 | 0;
 eb = a;
 v[a + 248 >> 2] = c;
 v[a + 252 >> 2] = b;
 Hy(a + 192 | 0, d, a + 208 | 0, a + 207 | 0, a + 206 | 0);
 d = Eb(a + 180 | 0);
 b = Lc(d);
 v[31601] = 0;
 N(46, d | 0, b | 0);
 b = v[31601];
 v[31601] = 0;
 a: {
  b: {
   c: {
    if ((b | 0) != 1) {
     c = dc(d, 0);
     v[a + 176 >> 2] = c;
     v[a + 12 >> 2] = a + 16;
     v[a + 8 >> 2] = 0;
     t[a + 7 | 0] = 1;
     t[a + 6 | 0] = 69;
     h = t[a + 206 | 0];
     i = t[a + 207 | 0];
     while (1) {
      d: {
       v[31601] = 0;
       b = O(1240, a + 252 | 0, a + 248 | 0) | 0;
       g = v[31601];
       v[31601] = 0;
       if ((g | 0) == 1) {
        break d;
       }
       if (b) {
        break c;
       }
       g = v[a + 176 >> 2];
       b = Cb(v[d + 4 >> 2], w[d + 11 | 0]);
       if ((g | 0) == (b + c | 0)) {
        v[31601] = 0;
        N(46, d | 0, b << 1);
        c = v[31601];
        v[31601] = 0;
        if ((c | 0) == 1) {
         break b;
        }
        c = Lc(d);
        v[31601] = 0;
        N(46, d | 0, c | 0);
        c = v[31601];
        v[31601] = 0;
        if ((c | 0) == 1) {
         break b;
        }
        c = dc(d, 0);
        v[a + 176 >> 2] = b + c;
       }
       v[31601] = 0;
       b = Q(1241, v[a + 252 >> 2]) | 0;
       g = v[31601];
       v[31601] = 0;
       if ((g | 0) == 1) {
        break d;
       }
       if (Gy(b, a + 7 | 0, a + 6 | 0, c, a + 176 | 0, i, h, a + 192 | 0, a + 16 | 0, a + 12 | 0, a + 8 | 0, a + 208 | 0)) {
        break c;
       }
       v[31601] = 0;
       Q(1243, a + 252 | 0) | 0;
       b = v[31601];
       v[31601] = 0;
       if ((b | 0) != 1) {
        continue;
       }
      }
      break;
     }
     break b;
    }
    break b;
   }
   e: {
    if (!Cb(v[a + 196 >> 2], w[a + 203 | 0]) | !w[a + 7 | 0]) {
     break e;
    }
    b = v[a + 12 >> 2];
    if ((b - (a + 16 | 0) | 0) > 159) {
     break e;
    }
    v[a + 12 >> 2] = b + 4;
    v[b >> 2] = v[a + 8 >> 2];
   }
   j = f, k = tK(c, v[a + 176 >> 2], e), A[j >> 3] = k;
   Uf(a + 192 | 0, a + 16 | 0, v[a + 12 >> 2], e);
   v[31601] = 0;
   b = O(1240, a + 252 | 0, a + 248 | 0) | 0;
   c = v[31601];
   v[31601] = 0;
   if ((c | 0) != 1) {
    if (b) {
     v[e >> 2] = v[e >> 2] | 2;
    }
    b = v[a + 252 >> 2];
    sb(d);
    sb(a + 192 | 0);
    eb = a + 256 | 0;
    break a;
   }
  }
  b = M() | 0;
  sb(d);
  sb(a + 192 | 0);
  P(b | 0);
  p();
 }
 return b | 0;
}

function cc(a) {
 var b = 0, c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0;
 h = EY(a + 24 | 0);
 a = h;
 i = a >>> 0 <= 1 ? 1 : a;
 a = i;
 f = eb - 16 | 0;
 eb = f;
 c = a + 15 & -16;
 a = a >>> 0 < c >>> 0 ? c : a;
 if (!(a & 15)) {
  if (a >>> 0 > 4294967216) {
   a = 48;
  } else {
   a: {
    if (a >>> 0 >= 4294967216) {
     v[31476] = 48;
     b = 0;
     break a;
    }
    c = a >>> 0 < 11 ? 16 : a + 11 & -8;
    a = Fd(c + 28 | 0);
    b = 0;
    if (!a) {
     break a;
    }
    b = a - 8 | 0;
    b: {
     if (!(a & 15)) {
      a = b;
      break b;
     }
     g = a - 4 | 0;
     j = v[g >> 2];
     a = (a + 15 & -16) - 8 | 0;
     a = (a - b >>> 0 <= 15 ? 16 : 0) + a | 0;
     d = a - b | 0;
     e = (j & -8) - d | 0;
     if (!(j & 3)) {
      b = v[b >> 2];
      v[a + 4 >> 2] = e;
      v[a >> 2] = b + d;
      break b;
     }
     v[a + 4 >> 2] = e | v[a + 4 >> 2] & 1 | 2;
     e = a + e | 0;
     v[e + 4 >> 2] = v[e + 4 >> 2] | 1;
     v[g >> 2] = d | v[g >> 2] & 1 | 2;
     e = b + d | 0;
     v[e + 4 >> 2] = v[e + 4 >> 2] | 1;
     Qv(b, d);
    }
    b = v[a + 4 >> 2];
    c: {
     if (!(b & 3)) {
      break c;
     }
     d = b & -8;
     if (d >>> 0 <= c + 16 >>> 0) {
      break c;
     }
     v[a + 4 >> 2] = c | b & 1 | 2;
     b = a + c | 0;
     c = d - c | 0;
     v[b + 4 >> 2] = c | 3;
     d = a + d | 0;
     v[d + 4 >> 2] = v[d + 4 >> 2] | 1;
     Qv(b, c);
    }
    b = a + 8 | 0;
   }
   if (b) {
    v[f + 12 >> 2] = b;
    a = 0;
   } else {
    a = 48;
   }
  }
  b = a ? 0 : v[f + 12 >> 2];
 }
 eb = f + 16 | 0;
 a = b;
 if (!a) {
  d: {
   b = 0;
   a = v[125424];
   if (!a) {
    v[125424] = 501724;
    u[250863] = 125;
    k = 501724, l = Xx(502224), u[k >> 1] = l;
    a = v[125424];
   }
   c = (i + 3 >>> 2 | 0) + 1 | 0;
   while (1) {
    e: {
     if (!a | (a | 0) == 502224) {
      a = 0;
     } else {
      d = x[a + 2 >> 1];
      f = c + (c >>> 0 < d >>> 0 ? d - c & 3 : 0) | 0;
      if (d >>> 0 > f >>> 0) {
       b = d - f | 0;
       u[a + 2 >> 1] = b;
       a = ((b & 65535) << 2) + a | 0;
       u[a + 2 >> 1] = f;
       u[a >> 1] = 0;
       a = a + 4 | 0;
       break d;
      }
      if (c >>> 0 > d >>> 0) {
       break e;
      }
      c = x[a >> 1];
      f: {
       if (!b) {
        k = 501696, l = Yx(c), v[k >> 2] = l;
        break f;
       }
       u[b >> 1] = c;
      }
      u[a >> 1] = 0;
      a = a + 4 | 0;
     }
     break d;
    }
    b = a;
    a = Yx(x[a >> 1]);
    continue;
   }
  }
 }
 if (!a) {
  Rb();
  p();
 }
 return MR(Qb(a, 0, h));
}

function J7(a, b, c, d, e) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = +e;
 var f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0;
 k = b;
 f = eb - 368 | 0;
 eb = f;
 t[f + 364 | 0] = 0;
 t[f + 365 | 0] = 0;
 t[f + 366 | 0] = 0;
 t[f + 367 | 0] = 0;
 t[f + 361 | 0] = 0;
 t[f + 362 | 0] = 0;
 t[f + 363 | 0] = 0;
 t[f + 364 | 0] = 0;
 t[f + 360 | 0] = 37;
 h = qt(f + 361 | 0, 22256, v[c + 4 >> 2]);
 b = f + 320 | 0;
 v[f + 316 >> 2] = b;
 a = Nd();
 a: {
  if (h) {
   g = v[c + 8 >> 2];
   A[f + 40 >> 3] = e;
   v[f + 32 >> 2] = g;
   g = oh(b, 30, a, f + 360 | 0, f + 32 | 0);
   break a;
  }
  A[f + 48 >> 3] = e;
  g = oh(f + 320 | 0, 30, a, f + 360 | 0, f + 48 | 0);
 }
 v[f + 80 >> 2] = 1238;
 i = Ce(f + 308 | 0, 0, f + 80 | 0);
 b = f + 320 | 0;
 a = b;
 b: {
  c: {
   d: {
    e: {
     if ((g | 0) >= 30) {
      a = Nd();
      f: {
       if (h) {
        g = v[c + 8 >> 2];
        A[f + 8 >> 3] = e;
        v[f >> 2] = g;
        g = hj(f + 316 | 0, a, f + 360 | 0, f);
        break f;
       }
       A[f + 16 >> 3] = e;
       g = hj(f + 316 | 0, a, f + 360 | 0, f + 16 | 0);
      }
      if ((g | 0) == -1) {
       v[31601] = 0;
       W(1239);
       a = v[31601];
       v[31601] = 0;
       if ((a | 0) == 1) {
        break d;
       }
       break e;
      }
      a = v[f + 316 >> 2];
      Qe(i, a);
     }
     j = a + g | 0;
     l = ij(a, j, v[c + 4 >> 2]);
     v[f + 68 >> 2] = 1238;
     h = Ce(f + 72 | 0, 0, f + 68 | 0);
     g: {
      h: {
       if ((f + 320 | 0) == (a | 0)) {
        g = f + 80 | 0;
        break h;
       }
       g = Fd(g << 3);
       if (!g) {
        v[31601] = 0;
        W(1239);
        a = v[31601];
        v[31601] = 0;
        if ((a | 0) != 1) {
         break e;
        }
        a = M() | 0;
        break g;
       }
       Qe(h, g);
       b = a;
      }
      a = f + 60 | 0;
      bd(a, v[c + 28 >> 2]);
      v[31601] = 0;
      fa(1271, b | 0, l | 0, j | 0, g | 0, f + 68 | 0, f - -64 | 0, a | 0);
      b = v[31601];
      v[31601] = 0;
      i: {
       if ((b | 0) != 1) {
        Zb(a);
        v[31601] = 0;
        a = da(1272, k | 0, g | 0, v[f + 68 >> 2], v[f + 64 >> 2], c | 0, d | 0) | 0;
        b = v[31601];
        v[31601] = 0;
        if ((b | 0) == 1) {
         break i;
        }
        Kc(h);
        Kc(i);
        eb = f + 368 | 0;
        break b;
       }
       a = M() | 0;
       Zb(f + 60 | 0);
       break g;
      }
      a = M() | 0;
     }
     Kc(h);
     break c;
    }
    p();
   }
   a = M() | 0;
  }
  Kc(i);
  P(a | 0);
  p();
 }
 return a | 0;
}

function T7(a, b, c, d, e) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = +e;
 var f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0;
 k = b;
 f = eb - 208 | 0;
 eb = f;
 t[f + 204 | 0] = 0;
 t[f + 205 | 0] = 0;
 t[f + 206 | 0] = 0;
 t[f + 207 | 0] = 0;
 t[f + 201 | 0] = 0;
 t[f + 202 | 0] = 0;
 t[f + 203 | 0] = 0;
 t[f + 204 | 0] = 0;
 t[f + 200 | 0] = 37;
 h = qt(f + 201 | 0, 22256, v[c + 4 >> 2]);
 b = f + 160 | 0;
 v[f + 156 >> 2] = b;
 a = Nd();
 a: {
  if (h) {
   g = v[c + 8 >> 2];
   A[f + 40 >> 3] = e;
   v[f + 32 >> 2] = g;
   g = oh(b, 30, a, f + 200 | 0, f + 32 | 0);
   break a;
  }
  A[f + 48 >> 3] = e;
  g = oh(f + 160 | 0, 30, a, f + 200 | 0, f + 48 | 0);
 }
 v[f + 80 >> 2] = 1238;
 i = Ce(f + 148 | 0, 0, f + 80 | 0);
 b = f + 160 | 0;
 a = b;
 b: {
  c: {
   d: {
    e: {
     if ((g | 0) >= 30) {
      a = Nd();
      f: {
       if (h) {
        g = v[c + 8 >> 2];
        A[f + 8 >> 3] = e;
        v[f >> 2] = g;
        g = hj(f + 156 | 0, a, f + 200 | 0, f);
        break f;
       }
       A[f + 16 >> 3] = e;
       g = hj(f + 156 | 0, a, f + 200 | 0, f + 16 | 0);
      }
      if ((g | 0) == -1) {
       v[31601] = 0;
       W(1239);
       a = v[31601];
       v[31601] = 0;
       if ((a | 0) == 1) {
        break d;
       }
       break e;
      }
      a = v[f + 156 >> 2];
      Qe(i, a);
     }
     j = a + g | 0;
     l = ij(a, j, v[c + 4 >> 2]);
     v[f + 68 >> 2] = 1238;
     h = Ce(f + 72 | 0, 0, f + 68 | 0);
     g: {
      h: {
       if ((f + 160 | 0) == (a | 0)) {
        g = f + 80 | 0;
        break h;
       }
       g = Fd(g << 1);
       if (!g) {
        v[31601] = 0;
        W(1239);
        a = v[31601];
        v[31601] = 0;
        if ((a | 0) != 1) {
         break e;
        }
        a = M() | 0;
        break g;
       }
       Qe(h, g);
       b = a;
      }
      a = f + 60 | 0;
      bd(a, v[c + 28 >> 2]);
      v[31601] = 0;
      fa(1266, b | 0, l | 0, j | 0, g | 0, f + 68 | 0, f - -64 | 0, a | 0);
      b = v[31601];
      v[31601] = 0;
      i: {
       if ((b | 0) != 1) {
        Zb(a);
        v[31601] = 0;
        a = da(23, k | 0, g | 0, v[f + 68 >> 2], v[f + 64 >> 2], c | 0, d | 0) | 0;
        b = v[31601];
        v[31601] = 0;
        if ((b | 0) == 1) {
         break i;
        }
        Kc(h);
        Kc(i);
        eb = f + 208 | 0;
        break b;
       }
       a = M() | 0;
       Zb(f + 60 | 0);
       break g;
      }
      a = M() | 0;
     }
     Kc(h);
     break c;
    }
    p();
   }
   a = M() | 0;
  }
  Kc(i);
  P(a | 0);
  p();
 }
 return a | 0;
}

function sra(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0;
 e = eb - 16 | 0;
 eb = e;
 i = Hf(a, c);
 $d(e, v[a + 36 >> 2]);
 j = a;
 a: {
  if (!i) {
   Pc(e, a + 32 | 0, 5);
   c = 0;
   if (Fb(v[v[e >> 2] >> 2], v[e + 4 >> 2])) {
    break a;
   }
  }
  d = eb - 160 | 0;
  eb = d;
  f = Im(d + 48 | 0, v[a + 36 >> 2]);
  v[31601] = 0;
  a = O(461, d + 36 | 0, 42180) | 0;
  c = v[31601];
  v[31601] = 0;
  b: {
   c: {
    d: {
     e: {
      if ((c | 0) != 1) {
       v[31601] = 0;
       v[d + 16 >> 2] = 19989505;
       v[d + 20 >> 2] = 0;
       R(462, f | 0, a | 0, d + 16 | 0);
       c = v[31601];
       v[31601] = 0;
       if ((c | 0) == 1) {
        break e;
       }
       Db(a);
       if (!ol(w[f | 0])) {
        break d;
       }
       break b;
      }
      c = M() | 0;
      break c;
     }
     c = M() | 0;
     Db(a);
     break c;
    }
    l = d, m = Xj(v[b >> 2], v[b + 4 >> 2]), u[l + 34 >> 1] = m;
    u[d + 32 >> 1] = 65535;
    v[31601] = 0;
    a = O(461, d + 16 | 0, 10105) | 0;
    c = v[31601];
    v[31601] = 0;
    f: {
     if ((c | 0) != 1) {
      v[31601] = 0;
      c = T(491, f | 0, d + 32 | 0, a | 0) | 0;
      g = v[31601];
      v[31601] = 0;
      if ((g | 0) == 1) {
       break f;
      }
      Db(a);
      if (c) {
       u[d + 34 >> 1] = x[d + 32 >> 1];
      }
      Gf(d + 34 | 0, 4e3);
      a = x[d + 34 >> 1];
      g: {
       if (Xj(v[b >> 2], v[b + 4 >> 2]) >>> 0 >= a >>> 0) {
        break g;
       }
       v[31601] = 0;
       N(223, b | 0, a | 0);
       c = v[31601];
       v[31601] = 0;
       if ((c | 0) != 1) {
        break g;
       }
       c = M() | 0;
       break c;
      }
      c = 0;
      h: {
       while (1) {
        if ((a | 0) == (c | 0)) {
         break b;
        }
        h = v[b >> 2];
        v[31601] = 0;
        g = d + 4 | 0;
        N(492, g | 0, c | 0);
        k = v[31601];
        v[31601] = 0;
        if ((k | 0) != 1) {
         v[31601] = 0;
         U(493, f | 0, Vb(h, c) | 0, g | 0, 494);
         h = v[31601];
         v[31601] = 0;
         if ((h | 0) == 1) {
          break h;
         }
         c = c + 1 | 0;
         Db(g);
         continue;
        }
        break;
       }
       c = M() | 0;
       break c;
      }
      c = M() | 0;
      Db(d + 4 | 0);
      break c;
     }
     c = M() | 0;
     break c;
    }
    c = M() | 0;
    Db(a);
   }
   Bh(f);
   P(c | 0);
   p();
  }
  Bh(f);
  eb = d + 160 | 0;
  c = i;
 }
 ef(j, c);
 eb = e + 16 | 0;
}

function Cua(a, b, c, d) {
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0;
 a: {
  b: {
   c: {
    d: {
     e: {
      f: {
       g: {
        h: {
         i: {
          j: {
           k: {
            if (b) {
             if (!c) {
              break k;
             }
             if (!d) {
              break j;
             }
             e = E(d) - E(b) | 0;
             if (e >>> 0 <= 31) {
              break i;
             }
             break c;
            }
            if ((d | 0) == 1 | d >>> 0 > 1) {
             break c;
            }
            gb = 0;
            a = (a >>> 0) / (c >>> 0) | 0;
            break a;
           }
           if (!a) {
            break h;
           }
           if (!d | d - 1 & d) {
            break g;
           }
           a = b >>> zua(d) | 0;
           gb = 0;
           break a;
          }
          if (!(c - 1 & c)) {
           break f;
          }
          h = (E(c) + 33 | 0) - E(b) | 0;
          g = 0 - h | 0;
          break d;
         }
         h = e + 1 | 0;
         g = 63 - e | 0;
         break d;
        }
        gb = 0;
        a = (b >>> 0) / (d >>> 0) | 0;
        break a;
       }
       e = E(d) - E(b) | 0;
       if (e >>> 0 < 31) {
        break e;
       }
       break c;
      }
      if ((c | 0) == 1) {
       break b;
      }
      d = zua(c);
      c = d & 31;
      if ((d & 63) >>> 0 >= 32) {
       a = b >>> c | 0;
      } else {
       e = b >>> c | 0;
       a = ((1 << c) - 1 & b) << 32 - c | a >>> c;
      }
      gb = e;
      break a;
     }
     h = e + 1 | 0;
     g = 63 - e | 0;
    }
    e = h & 63;
    f = e & 31;
    if (e >>> 0 >= 32) {
     e = 0;
     i = b >>> f | 0;
    } else {
     e = b >>> f | 0;
     i = ((1 << f) - 1 & b) << 32 - f | a >>> f;
    }
    g = g & 63;
    f = g & 31;
    if (g >>> 0 >= 32) {
     b = a << f;
     a = 0;
    } else {
     b = (1 << f) - 1 & a >>> 32 - f | b << f;
     a = a << f;
    }
    if (h) {
     f = d - 1 | 0;
     g = c - 1 | 0;
     m = (g | 0) != -1 ? f + 1 | 0 : f;
     while (1) {
      j = e << 1 | i >>> 31;
      e = i << 1 | b >>> 31;
      f = m - (j + (e >>> 0 > g >>> 0) | 0) >> 31;
      k = c & f;
      i = e - k | 0;
      e = j - ((d & f) + (e >>> 0 < k >>> 0) | 0) | 0;
      b = b << 1 | a >>> 31;
      a = l | a << 1;
      l = f & 1;
      h = h - 1 | 0;
      if (h) {
       continue;
      }
      break;
     }
    }
    gb = b << 1 | a >>> 31;
    a = l | a << 1;
    break a;
   }
   a = 0;
   b = 0;
  }
  gb = b;
 }
 return a;
}

function dJ(a, b, c, d, e, f, g, h) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 f = f | 0;
 g = g | 0;
 h = h | 0;
 var i = 0, j = 0, k = 0, l = 0, m = 0;
 a = eb - 16 | 0;
 eb = a;
 v[a + 12 >> 2] = c;
 v[a + 8 >> 2] = f;
 v[a + 12 >> 2] = c;
 v[a + 8 >> 2] = f;
 a: {
  b: {
   while (1) {
    b = v[a + 12 >> 2];
    if (!(d >>> 0 <= b >>> 0 | f >>> 0 >= g >>> 0)) {
     i = t[b | 0];
     c = i & 255;
     c: {
      if ((i | 0) >= 0) {
       i = 1;
       break c;
      }
      k = 2;
      if (i >>> 0 < 4294967234) {
       break a;
      }
      if (i >>> 0 <= 4294967263) {
       if ((d - b | 0) < 2) {
        break b;
       }
       i = w[b + 1 | 0];
       if ((i & 192) != 128) {
        break a;
       }
       c = i & 63 | c << 6 & 1984;
       i = 2;
       break c;
      }
      if (i >>> 0 <= 4294967279) {
       if ((d - b | 0) < 3) {
        break b;
       }
       j = w[b + 2 | 0];
       i = w[b + 1 | 0];
       d: {
        e: {
         if ((c | 0) != 237) {
          if ((c | 0) != 224) {
           break e;
          }
          if ((i & 224) == 160) {
           break d;
          }
          break a;
         }
         if ((i & 224) == 128) {
          break d;
         }
         break a;
        }
        if ((i & 192) != 128) {
         break a;
        }
       }
       if ((j & 192) != 128) {
        break a;
       }
       c = j & 63 | (c << 12 & 61440 | (i & 63) << 6);
       i = 3;
       break c;
      }
      if (i >>> 0 > 4294967284) {
       break a;
      }
      if ((d - b | 0) < 4) {
       break b;
      }
      l = w[b + 3 | 0];
      m = w[b + 2 | 0];
      j = w[b + 1 | 0];
      f: {
       g: {
        switch (c - 240 | 0) {
        case 0:
         if ((j + 112 & 255) >>> 0 < 48) {
          break f;
         }
         break a;

        case 4:
         if ((j & 240) == 128) {
          break f;
         }
         break a;

        default:
         break g;
        }
       }
       if ((j & 192) != 128) {
        break a;
       }
      }
      if ((m & 192) != 128 | (l & 192) != 128) {
       break a;
      }
      i = 4;
      c = l & 63 | (m << 6 & 4032 | (c << 18 & 1835008 | (j & 63) << 12));
      if (c >>> 0 > 1114111) {
       break a;
      }
     }
     v[f >> 2] = c;
     v[a + 12 >> 2] = b + i;
     f = v[a + 8 >> 2] + 4 | 0;
     v[a + 8 >> 2] = f;
     continue;
    }
    break;
   }
   k = b >>> 0 < d >>> 0;
   break a;
  }
  k = 1;
 }
 v[e >> 2] = v[a + 12 >> 2];
 v[h >> 2] = v[a + 8 >> 2];
 eb = a + 16 | 0;
 return k | 0;
}

function goa(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0;
 f = eb - 16 | 0;
 eb = f;
 k = f, l = Pj(b), v[k + 4 >> 2] = l;
 e = eb - 16 | 0;
 eb = e;
 h = a;
 c = ce(a);
 a: {
  if (c) {
   g = fc(a);
   while (1) {
    a = c;
    c = a + 14 | 0;
    if (nv(b, c)) {
     g = a;
     c = v[a >> 2];
     if (c) {
      continue;
     }
     break a;
    }
    if (!nv(c, b)) {
     break a;
    }
    g = a + 4 | 0;
    c = v[a + 4 >> 2];
    if (c) {
     continue;
    }
    break;
   }
   break a;
  }
  a = fc(h);
  g = a;
 }
 v[e + 12 >> 2] = a;
 b = v[g >> 2];
 if (!b) {
  i = eb - 16 | 0;
  eb = i;
  a = fc(h);
  j = Ch(e, Dc(48), Ng(i + 8 | 0, a));
  a = v[j >> 2];
  b = v[f + 4 >> 2];
  c = w[b + 4 | 0] | w[b + 5 | 0] << 8 | (w[b + 6 | 0] << 16 | w[b + 7 | 0] << 24);
  d = w[b | 0] | w[b + 1 | 0] << 8 | (w[b + 2 | 0] << 16 | w[b + 3 | 0] << 24);
  t[a + 14 | 0] = d;
  t[a + 15 | 0] = d >>> 8;
  t[a + 16 | 0] = d >>> 16;
  t[a + 17 | 0] = d >>> 24;
  t[a + 18 | 0] = c;
  t[a + 19 | 0] = c >>> 8;
  t[a + 20 | 0] = c >>> 16;
  t[a + 21 | 0] = c >>> 24;
  c = w[b + 28 | 0] | w[b + 29 | 0] << 8 | (w[b + 30 | 0] << 16 | w[b + 31 | 0] << 24);
  d = w[b + 24 | 0] | w[b + 25 | 0] << 8 | (w[b + 26 | 0] << 16 | w[b + 27 | 0] << 24);
  t[a + 38 | 0] = d;
  t[a + 39 | 0] = d >>> 8;
  t[a + 40 | 0] = d >>> 16;
  t[a + 41 | 0] = d >>> 24;
  t[a + 42 | 0] = c;
  t[a + 43 | 0] = c >>> 8;
  t[a + 44 | 0] = c >>> 16;
  t[a + 45 | 0] = c >>> 24;
  c = w[b + 20 | 0] | w[b + 21 | 0] << 8 | (w[b + 22 | 0] << 16 | w[b + 23 | 0] << 24);
  d = w[b + 16 | 0] | w[b + 17 | 0] << 8 | (w[b + 18 | 0] << 16 | w[b + 19 | 0] << 24);
  t[a + 30 | 0] = d;
  t[a + 31 | 0] = d >>> 8;
  t[a + 32 | 0] = d >>> 16;
  t[a + 33 | 0] = d >>> 24;
  t[a + 34 | 0] = c;
  t[a + 35 | 0] = c >>> 8;
  t[a + 36 | 0] = c >>> 16;
  t[a + 37 | 0] = c >>> 24;
  c = w[b + 12 | 0] | w[b + 13 | 0] << 8 | (w[b + 14 | 0] << 16 | w[b + 15 | 0] << 24);
  b = w[b + 8 | 0] | w[b + 9 | 0] << 8 | (w[b + 10 | 0] << 16 | w[b + 11 | 0] << 24);
  t[a + 22 | 0] = b;
  t[a + 23 | 0] = b >>> 8;
  t[a + 24 | 0] = b >>> 16;
  t[a + 25 | 0] = b >>> 24;
  t[a + 26 | 0] = c;
  t[a + 27 | 0] = c >>> 8;
  t[a + 28 | 0] = c >>> 16;
  t[a + 29 | 0] = c >>> 24;
  u[a + 46 >> 1] = 0;
  k = fc(j), l = 1, t[k + 4 | 0] = l;
  eb = i + 16 | 0;
  _g(h, v[e + 12 >> 2], g, v[e >> 2]);
  b = me(e);
  Gk(e);
  d = 1;
 }
 Zg(f + 8 | 0, v[ub(e, b) >> 2], d);
 eb = e + 16 | 0;
 a = cp(v[f + 8 >> 2]);
 eb = f + 16 | 0;
 return a + 32 | 0;
}

function Bga(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = C(0), q = C(0), r = 0, s = 0, t = 0, u = C(0), w = 0;
 i = eb - 16 | 0;
 eb = i;
 if (si(a + 44 | 0)) {
  n = v[a + 44 >> 2];
  j = Gc(n, 0);
  k = Gc(n, 1);
  n = v[a + 56 >> 2];
  t = Gc(n, 0);
  n = Gc(n, 1);
  u = z[xb(a + 4208 | 0, 1) >> 2];
  v[i + 12 >> 2] = d;
  s = v[a + 4220 >> 2];
  q = C(C(1) / C(s >>> 0));
  w = v[a + 4216 >> 2];
  o = d;
  f = n;
  g = t;
  while (1) {
   if (o) {
    h = v[a + 4224 >> 2];
    a: {
     if (s >>> 0 > h >>> 0) {
      v[i + 8 >> 2] = s - h;
      r = v[Gb(i + 12 | 0, i + 8 | 0) >> 2];
      m = 0;
      b: {
       if (u < C(1)) {
        l = h + r | 0;
        e = h >>> 0 > l >>> 0 ? h : l;
        while (1) {
         if ((h | 0) == (e | 0)) {
          break b;
         }
         p = C(h >>> 0);
         z[g >> 2] = q * C(z[j >> 2] * p);
         z[f >> 2] = q * C(z[k >> 2] * p);
         h = h + 1 | 0;
         f = f + 4 | 0;
         k = k + 4 | 0;
         g = g + 4 | 0;
         j = j + 4 | 0;
         continue;
        }
       }
       while (1) {
        if ((m | 0) != (r | 0)) {
         z[g >> 2] = z[j >> 2];
         z[f >> 2] = z[k >> 2];
         m = m + 1 | 0;
         f = f + 4 | 0;
         k = k + 4 | 0;
         g = g + 4 | 0;
         j = j + 4 | 0;
         continue;
        }
        break;
       }
       l = h + r | 0;
      }
      o = o - r | 0;
      v[i + 12 >> 2] = o;
      break a;
     }
     m = w - h | 0;
     v[i + 4 >> 2] = m;
     l = v[Gb(i + 12 | 0, i + 4 | 0) >> 2];
     e = 0;
     c: {
      if (u < C(1)) {
       e = m - l | 0;
       while (1) {
        if (e >>> 0 >= m >>> 0) {
         break c;
        }
        p = C(m >>> 0);
        z[g >> 2] = q * C(z[j >> 2] * p);
        z[f >> 2] = q * C(z[k >> 2] * p);
        m = m - 1 | 0;
        f = f + 4 | 0;
        k = k + 4 | 0;
        g = g + 4 | 0;
        j = j + 4 | 0;
        continue;
       }
      }
      while (1) {
       if ((e | 0) != (l | 0)) {
        v[g >> 2] = 0;
        v[f >> 2] = 0;
        e = e + 1 | 0;
        f = f + 4 | 0;
        g = g + 4 | 0;
        continue;
       }
       break;
      }
      e = l << 2;
      k = e + k | 0;
      j = j + e | 0;
     }
     o = o - l | 0;
     v[i + 12 >> 2] = o;
     e = h + l | 0;
     l = e >>> 0 < w >>> 0 ? e : 0;
    }
    v[a + 4224 >> 2] = l;
    continue;
   } else {
    Hi(a, b, c, t, n, d);
   }
   break;
  }
 }
 eb = i + 16 | 0;
}

function Jma(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, w = 0, x = 0, y = 0, z = 0, A = 0, C = 0, D = 0, E = 0;
 b = eb - 48 | 0;
 eb = b;
 r = v[a + 16 >> 2];
 v[b + 32 >> 2] = v[a + 44 >> 2];
 v[b + 36 >> 2] = v[a + 48 >> 2];
 v[b + 40 >> 2] = v[a + 52 >> 2];
 v[b + 44 >> 2] = v[a + 56 >> 2];
 j = v[a + 40 >> 2];
 k = v[a + 36 >> 2];
 g = v[a + 4 >> 2];
 v[b + 16 >> 2] = v[a >> 2];
 v[b + 20 >> 2] = g;
 s = b + 32 | 0;
 t = v[a + 32 >> 2];
 w = v[a + 28 >> 2];
 x = v[a + 72 >> 2];
 n = v[a + 68 >> 2];
 y = n >> 31;
 o = v[a + 64 >> 2];
 z = o >> 31;
 p = v[a + 60 >> 2];
 A = p >> 31;
 C = v[a + 8 >> 2];
 D = v[a + 12 >> 2];
 while (1) {
  if (d) {
   e = v[b + 16 >> 2];
   h = e >>> 18 | 0;
   e = ((((v[b + 20 >> 2] & 2147483647) << 1 | e >>> 31) & 2147483646) << 1) + r | 0;
   l = 0;
   f = 0;
   while (1) {
    if ((f | 0) != 2) {
     g = e + (f << 1) | 0;
     m = u[g >> 1];
     v[(b + 8 | 0) + (f << 2) >> 2] = m + ((B(h, u[g + 4 >> 1] - m | 0) | 0) / 16384 | 0);
     f = f + 1 | 0;
     continue;
    }
    break;
   }
   while (1) {
    if ((l | 0) != 2) {
     q = (b + 8 | 0) + (l << 2) | 0;
     e = v[q >> 2];
     g = (l << 3) + s | 0;
     E = v[g + 4 >> 2];
     f = v[g >> 2];
     v[g + 4 >> 2] = f;
     m = e << 8;
     e = m;
     e = Aua(e, e >> 31, p, A);
     h = gb;
     i = e;
     e = Xb(f, -16777216, 16776704);
     e = Aua(o, z, e, e >> 31);
     f = i + e | 0;
     i = gb + h | 0;
     i = e >>> 0 > f >>> 0 ? i + 1 | 0 : i;
     e = Xb(E, -16777216, 16776704);
     h = Aua(n, y, e, e >> 31);
     f = h + f | 0;
     e = gb + i | 0;
     e = f >>> 0 < h >>> 0 ? e + 1 | 0 : e;
     h = f + 8388608 | 0;
     e = h >>> 0 < 8388608 ? e + 1 | 0 : e;
     e = Rc(h, e, 24);
     v[g >> 2] = e - (m & x);
     v[q >> 2] = (e | 0) / 256;
     l = l + 1 | 0;
     continue;
    }
    break;
   }
   k = k + w | 0;
   v[c >> 2] = v[c >> 2] + B(v[b + 8 >> 2], k >> 12);
   j = j + t | 0;
   v[c + 4 >> 2] = v[c + 4 >> 2] + B(v[b + 12 >> 2], j >> 12);
   Ob(b + 16 | 0, C, D);
   c = c + 8 | 0;
   d = d - 1 | 0;
   continue;
  }
  break;
 }
 c = v[b + 20 >> 2];
 v[a >> 2] = v[b + 16 >> 2];
 v[a + 4 >> 2] = c;
 v[a + 40 >> 2] = j;
 v[a + 20 >> 2] = k >> 12;
 v[a + 36 >> 2] = k;
 v[a + 24 >> 2] = j >> 12;
 v[a + 44 >> 2] = v[b + 32 >> 2];
 v[a + 48 >> 2] = v[b + 36 >> 2];
 v[a + 52 >> 2] = v[b + 40 >> 2];
 v[a + 56 >> 2] = v[b + 44 >> 2];
 eb = b + 48 | 0;
}

function e8(a, b, c, d, e, f) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 f = f | 0;
 var g = 0, h = 0, i = 0, j = 0, k = 0;
 a = eb - 336 | 0;
 eb = a;
 v[a + 328 >> 2] = c;
 v[a + 332 >> 2] = b;
 b = mj(v[d + 4 >> 2]);
 i = cq(v[d + 28 >> 2], a + 208 | 0);
 bq(a + 196 | 0, v[d + 28 >> 2], a + 324 | 0);
 d = Eb(a + 184 | 0);
 c = Lc(d);
 v[31601] = 0;
 N(46, d | 0, c | 0);
 c = v[31601];
 v[31601] = 0;
 a: {
  b: {
   c: {
    if ((c | 0) != 1) {
     c = dc(d, 0);
     v[a + 180 >> 2] = c;
     v[a + 12 >> 2] = a + 16;
     v[a + 8 >> 2] = 0;
     while (1) {
      d: {
       v[31601] = 0;
       g = O(1256, a + 332 | 0, a + 328 | 0) | 0;
       h = v[31601];
       v[31601] = 0;
       if ((h | 0) == 1) {
        break d;
       }
       if (g) {
        break c;
       }
       h = v[a + 180 >> 2];
       g = Cb(v[d + 4 >> 2], w[d + 11 | 0]);
       if ((h | 0) == (g + c | 0)) {
        v[31601] = 0;
        N(46, d | 0, g << 1);
        c = v[31601];
        v[31601] = 0;
        if ((c | 0) == 1) {
         break b;
        }
        c = Lc(d);
        v[31601] = 0;
        N(46, d | 0, c | 0);
        c = v[31601];
        v[31601] = 0;
        if ((c | 0) == 1) {
         break b;
        }
        c = dc(d, 0);
        v[a + 180 >> 2] = g + c;
       }
       v[31601] = 0;
       g = Q(1257, v[a + 332 >> 2]) | 0;
       h = v[31601];
       v[31601] = 0;
       if ((h | 0) == 1) {
        break d;
       }
       if (bo(g, b, c, a + 180 | 0, a + 8 | 0, v[a + 324 >> 2], v[a + 200 >> 2], w[a + 207 | 0], a + 16 | 0, a + 12 | 0, i)) {
        break c;
       }
       v[31601] = 0;
       Q(1259, a + 332 | 0) | 0;
       g = v[31601];
       v[31601] = 0;
       if ((g | 0) != 1) {
        continue;
       }
      }
      break;
     }
     break b;
    }
    break b;
   }
   e: {
    if (!Cb(v[a + 200 >> 2], w[a + 207 | 0])) {
     break e;
    }
    g = v[a + 12 >> 2];
    if ((g - (a + 16 | 0) | 0) > 159) {
     break e;
    }
    v[a + 12 >> 2] = g + 4;
    v[g >> 2] = v[a + 8 >> 2];
   }
   j = f, k = AK(c, v[a + 180 >> 2], e, b), v[j >> 2] = k;
   v[f + 4 >> 2] = gb;
   Uf(a + 196 | 0, a + 16 | 0, v[a + 12 >> 2], e);
   v[31601] = 0;
   b = O(1256, a + 332 | 0, a + 328 | 0) | 0;
   c = v[31601];
   v[31601] = 0;
   if ((c | 0) != 1) {
    if (b) {
     v[e >> 2] = v[e >> 2] | 2;
    }
    b = v[a + 332 >> 2];
    sb(d);
    sb(a + 196 | 0);
    eb = a + 336 | 0;
    break a;
   }
  }
  b = M() | 0;
  sb(d);
  sb(a + 196 | 0);
  P(b | 0);
  p();
 }
 return b | 0;
}

function c8(a, b, c, d, e, f) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 f = f | 0;
 var g = 0, h = 0, i = 0, j = 0, k = 0;
 a = eb - 336 | 0;
 eb = a;
 v[a + 328 >> 2] = c;
 v[a + 332 >> 2] = b;
 b = mj(v[d + 4 >> 2]);
 i = cq(v[d + 28 >> 2], a + 208 | 0);
 bq(a + 196 | 0, v[d + 28 >> 2], a + 324 | 0);
 d = Eb(a + 184 | 0);
 c = Lc(d);
 v[31601] = 0;
 N(46, d | 0, c | 0);
 c = v[31601];
 v[31601] = 0;
 a: {
  b: {
   c: {
    if ((c | 0) != 1) {
     c = dc(d, 0);
     v[a + 180 >> 2] = c;
     v[a + 12 >> 2] = a + 16;
     v[a + 8 >> 2] = 0;
     while (1) {
      d: {
       v[31601] = 0;
       g = O(1256, a + 332 | 0, a + 328 | 0) | 0;
       h = v[31601];
       v[31601] = 0;
       if ((h | 0) == 1) {
        break d;
       }
       if (g) {
        break c;
       }
       h = v[a + 180 >> 2];
       g = Cb(v[d + 4 >> 2], w[d + 11 | 0]);
       if ((h | 0) == (g + c | 0)) {
        v[31601] = 0;
        N(46, d | 0, g << 1);
        c = v[31601];
        v[31601] = 0;
        if ((c | 0) == 1) {
         break b;
        }
        c = Lc(d);
        v[31601] = 0;
        N(46, d | 0, c | 0);
        c = v[31601];
        v[31601] = 0;
        if ((c | 0) == 1) {
         break b;
        }
        c = dc(d, 0);
        v[a + 180 >> 2] = g + c;
       }
       v[31601] = 0;
       g = Q(1257, v[a + 332 >> 2]) | 0;
       h = v[31601];
       v[31601] = 0;
       if ((h | 0) == 1) {
        break d;
       }
       if (bo(g, b, c, a + 180 | 0, a + 8 | 0, v[a + 324 >> 2], v[a + 200 >> 2], w[a + 207 | 0], a + 16 | 0, a + 12 | 0, i)) {
        break c;
       }
       v[31601] = 0;
       Q(1259, a + 332 | 0) | 0;
       g = v[31601];
       v[31601] = 0;
       if ((g | 0) != 1) {
        continue;
       }
      }
      break;
     }
     break b;
    }
    break b;
   }
   e: {
    if (!Cb(v[a + 200 >> 2], w[a + 207 | 0])) {
     break e;
    }
    g = v[a + 12 >> 2];
    if ((g - (a + 16 | 0) | 0) > 159) {
     break e;
    }
    v[a + 12 >> 2] = g + 4;
    v[g >> 2] = v[a + 8 >> 2];
   }
   j = f, k = wK(c, v[a + 180 >> 2], e, b), v[j >> 2] = k;
   v[f + 4 >> 2] = gb;
   Uf(a + 196 | 0, a + 16 | 0, v[a + 12 >> 2], e);
   v[31601] = 0;
   b = O(1256, a + 332 | 0, a + 328 | 0) | 0;
   c = v[31601];
   v[31601] = 0;
   if ((c | 0) != 1) {
    if (b) {
     v[e >> 2] = v[e >> 2] | 2;
    }
    b = v[a + 332 >> 2];
    sb(d);
    sb(a + 196 | 0);
    eb = a + 336 | 0;
    break a;
   }
  }
  b = M() | 0;
  sb(d);
  sb(a + 196 | 0);
  P(b | 0);
  p();
 }
 return b | 0;
}

function ema(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, w = 0, x = 0, y = 0, z = 0, A = 0, C = 0;
 h = eb - 16 | 0;
 eb = h;
 f = v[a + 8 >> 2];
 m = f;
 e = v[a + 12 >> 2];
 j = e;
 a: {
  b: {
   if ((e | 0) <= 1 & f >>> 0 <= 805306368 | (e | 0) <= 0) {
    i = 131112;
    f = e;
    if ((e | 0) > -2) {
     e = 1;
    } else {
     e = (f | 0) >= -2 & m >>> 0 >= 3489660928;
    }
    if (e) {
     break a;
    }
    i = 262184;
    if ((j | 0) == -2 & m >>> 0 < 2147483648 | j >>> 0 < 4294967294) {
     break a;
    }
    break b;
   }
   i = 262184;
   if ((j | 0) == 1 & m >>> 0 > 2147483648 | j >>> 0 > 1) {
    break a;
   }
  }
  i = 196648;
 }
 s = v[a + 16 >> 2];
 k = v[a + 40 >> 2];
 l = v[a + 36 >> 2];
 f = v[a + 48 >> 2];
 e = v[a + 44 >> 2];
 n = v[a + 4 >> 2];
 v[h + 8 >> 2] = v[a >> 2];
 v[h + 12 >> 2] = n;
 t = b + i | 0;
 w = v[a + 32 >> 2];
 x = v[a + 28 >> 2];
 y = v[a + 72 >> 2];
 r = v[a + 68 >> 2];
 z = r >> 31;
 i = v[a + 64 >> 2];
 A = i >> 31;
 n = v[a + 60 >> 2];
 C = n >> 31;
 while (1) {
  b = e;
  if (d) {
   e = Xb(e, -16777216, 16776704);
   o = Aua(i, A, e, e >> 31);
   p = gb;
   e = v[h + 8 >> 2];
   g = (v[h + 12 >> 2] << 1) + s | 0;
   e = (e >>> 16 & 65520) + t | 0;
   g = (((((((B(u[g - 4 >> 1], u[e + 2 >> 1]) + B(u[g - 6 >> 1], u[e >> 1]) | 0) + B(u[g - 2 >> 1], u[e + 4 >> 1]) | 0) + B(u[g >> 1], u[e + 6 >> 1]) | 0) + B(u[g + 2 >> 1], u[e + 8 >> 1]) | 0) + B(u[g + 4 >> 1], u[e + 10 >> 1]) | 0) + B(u[g + 6 >> 1], u[e + 12 >> 1]) | 0) + B(u[g + 8 >> 1], u[e + 14 >> 1]) | 0) / 32768 << 8;
   e = g;
   e = Aua(e, e >> 31, n, C);
   o = e + o | 0;
   q = gb + p | 0;
   q = e >>> 0 > o >>> 0 ? q + 1 | 0 : q;
   f = Xb(f, -16777216, 16776704);
   e = Aua(r, z, f, f >> 31);
   p = e + o | 0;
   f = gb + q | 0;
   f = e >>> 0 > p >>> 0 ? f + 1 | 0 : f;
   e = p + 8388608 | 0;
   f = e >>> 0 < 8388608 ? f + 1 | 0 : f;
   e = Rc(e, f, 24);
   f = (e | 0) / 256 | 0;
   l = l + x | 0;
   v[c >> 2] = B(f, l >> 12) + v[c >> 2];
   k = k + w | 0;
   v[c + 4 >> 2] = v[c + 4 >> 2] + B(f, k >> 12);
   Ob(h + 8 | 0, m, j);
   e = e - (g & y) | 0;
   c = c + 8 | 0;
   d = d - 1 | 0;
   f = b;
   continue;
  }
  break;
 }
 c = v[h + 12 >> 2];
 v[a >> 2] = v[h + 8 >> 2];
 v[a + 4 >> 2] = c;
 v[a + 40 >> 2] = k;
 v[a + 20 >> 2] = l >> 12;
 v[a + 36 >> 2] = l;
 v[a + 48 >> 2] = f;
 v[a + 44 >> 2] = b;
 v[a + 24 >> 2] = k >> 12;
 eb = h + 16 | 0;
}

function Kma(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, u = 0, w = 0, x = 0, y = 0, z = 0, A = 0, C = 0, D = 0, E = 0;
 b = eb - 48 | 0;
 eb = b;
 r = v[a + 16 >> 2];
 v[b + 32 >> 2] = v[a + 44 >> 2];
 v[b + 36 >> 2] = v[a + 48 >> 2];
 v[b + 40 >> 2] = v[a + 52 >> 2];
 v[b + 44 >> 2] = v[a + 56 >> 2];
 j = v[a + 40 >> 2];
 k = v[a + 36 >> 2];
 g = v[a + 4 >> 2];
 v[b + 16 >> 2] = v[a >> 2];
 v[b + 20 >> 2] = g;
 s = b + 32 | 0;
 u = v[a + 32 >> 2];
 w = v[a + 28 >> 2];
 x = v[a + 72 >> 2];
 n = v[a + 68 >> 2];
 y = n >> 31;
 o = v[a + 64 >> 2];
 z = o >> 31;
 p = v[a + 60 >> 2];
 A = p >> 31;
 C = v[a + 8 >> 2];
 D = v[a + 12 >> 2];
 while (1) {
  if (d) {
   e = v[b + 16 >> 2];
   h = e >>> 10 & 4194048;
   e = (((v[b + 20 >> 2] & 2147483647) << 1 | e >>> 31) & -2) + r | 0;
   l = 0;
   f = 0;
   while (1) {
    if ((f | 0) != 2) {
     g = e + f | 0;
     m = t[g | 0];
     v[(b + 8 | 0) + (f << 2) >> 2] = ((B(h, t[g + 2 | 0] - m | 0) | 0) / 16384 | 0) + (m << 8);
     f = f + 1 | 0;
     continue;
    }
    break;
   }
   while (1) {
    if ((l | 0) != 2) {
     q = (b + 8 | 0) + (l << 2) | 0;
     e = v[q >> 2];
     g = (l << 3) + s | 0;
     E = v[g + 4 >> 2];
     f = v[g >> 2];
     v[g + 4 >> 2] = f;
     m = e << 8;
     e = m;
     e = Aua(e, e >> 31, p, A);
     h = gb;
     i = e;
     e = Xb(f, -16777216, 16776704);
     e = Aua(o, z, e, e >> 31);
     f = i + e | 0;
     i = gb + h | 0;
     i = e >>> 0 > f >>> 0 ? i + 1 | 0 : i;
     e = Xb(E, -16777216, 16776704);
     h = Aua(n, y, e, e >> 31);
     f = h + f | 0;
     e = gb + i | 0;
     e = f >>> 0 < h >>> 0 ? e + 1 | 0 : e;
     h = f + 8388608 | 0;
     e = h >>> 0 < 8388608 ? e + 1 | 0 : e;
     e = Rc(h, e, 24);
     v[g >> 2] = e - (m & x);
     v[q >> 2] = (e | 0) / 256;
     l = l + 1 | 0;
     continue;
    }
    break;
   }
   k = k + w | 0;
   v[c >> 2] = v[c >> 2] + B(v[b + 8 >> 2], k >> 12);
   j = j + u | 0;
   v[c + 4 >> 2] = v[c + 4 >> 2] + B(v[b + 12 >> 2], j >> 12);
   Ob(b + 16 | 0, C, D);
   c = c + 8 | 0;
   d = d - 1 | 0;
   continue;
  }
  break;
 }
 c = v[b + 20 >> 2];
 v[a >> 2] = v[b + 16 >> 2];
 v[a + 4 >> 2] = c;
 v[a + 40 >> 2] = j;
 v[a + 20 >> 2] = k >> 12;
 v[a + 36 >> 2] = k;
 v[a + 24 >> 2] = j >> 12;
 v[a + 44 >> 2] = v[b + 32 >> 2];
 v[a + 48 >> 2] = v[b + 36 >> 2];
 v[a + 52 >> 2] = v[b + 40 >> 2];
 v[a + 56 >> 2] = v[b + 44 >> 2];
 eb = b + 48 | 0;
}

function fma(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, w = 0, x = 0, y = 0, z = 0, A = 0, C = 0;
 h = eb - 16 | 0;
 eb = h;
 e = v[a + 8 >> 2];
 m = e;
 f = v[a + 12 >> 2];
 j = f;
 a: {
  b: {
   if ((f | 0) <= 1 & e >>> 0 <= 805306368 | (f | 0) <= 0) {
    i = 131112;
    e = f;
    if ((e | 0) > -2) {
     e = 1;
    } else {
     e = (e | 0) >= -2 & m >>> 0 >= 3489660928;
    }
    if (e) {
     break a;
    }
    i = 262184;
    if ((j | 0) == -2 & m >>> 0 < 2147483648 | j >>> 0 < 4294967294) {
     break a;
    }
    break b;
   }
   i = 262184;
   if ((j | 0) == 1 & m >>> 0 > 2147483648 | j >>> 0 > 1) {
    break a;
   }
  }
  i = 196648;
 }
 r = v[a + 16 >> 2];
 k = v[a + 40 >> 2];
 l = v[a + 36 >> 2];
 e = v[a + 48 >> 2];
 f = v[a + 44 >> 2];
 n = v[a + 4 >> 2];
 v[h + 8 >> 2] = v[a >> 2];
 v[h + 12 >> 2] = n;
 s = b + i | 0;
 w = v[a + 32 >> 2];
 x = v[a + 28 >> 2];
 y = v[a + 72 >> 2];
 p = v[a + 68 >> 2];
 z = p >> 31;
 i = v[a + 64 >> 2];
 A = i >> 31;
 n = v[a + 60 >> 2];
 C = n >> 31;
 while (1) {
  b = f;
  if (d) {
   f = Xb(f, -16777216, 16776704);
   g = Aua(i, A, f, f >> 31);
   f = gb;
   e = Xb(e, -16777216, 16776704);
   e = Aua(p, z, e, e >> 31);
   g = e + g | 0;
   f = gb + f | 0;
   f = e >>> 0 > g >>> 0 ? f + 1 | 0 : f;
   e = v[h + 8 >> 2];
   o = g;
   g = v[h + 12 >> 2] + r | 0;
   e = (e >>> 16 & 65520) + s | 0;
   q = (((((((B(t[g - 2 | 0], u[e + 2 >> 1]) + B(t[g - 3 | 0], u[e >> 1]) | 0) + B(t[g - 1 | 0], u[e + 4 >> 1]) | 0) + B(t[g | 0], u[e + 6 >> 1]) | 0) + B(t[g + 1 | 0], u[e + 8 >> 1]) | 0) + B(t[g + 2 | 0], u[e + 10 >> 1]) | 0) + B(t[g + 3 | 0], u[e + 12 >> 1]) | 0) + B(t[g + 4 | 0], u[e + 14 >> 1]) << 8) / 32768 << 8;
   e = q;
   g = Aua(e, e >> 31, n, C);
   o = o + g | 0;
   e = gb + f | 0;
   e = g >>> 0 > o >>> 0 ? e + 1 | 0 : e;
   f = o + 8388608 | 0;
   e = f >>> 0 < 8388608 ? e + 1 | 0 : e;
   f = Rc(f, e, 24);
   e = (f | 0) / 256 | 0;
   l = l + x | 0;
   v[c >> 2] = B(e, l >> 12) + v[c >> 2];
   k = k + w | 0;
   v[c + 4 >> 2] = v[c + 4 >> 2] + B(k >> 12, e);
   Ob(h + 8 | 0, m, j);
   f = f - (y & q) | 0;
   c = c + 8 | 0;
   d = d - 1 | 0;
   e = b;
   continue;
  }
  break;
 }
 c = v[h + 12 >> 2];
 v[a >> 2] = v[h + 8 >> 2];
 v[a + 4 >> 2] = c;
 v[a + 40 >> 2] = k;
 v[a + 20 >> 2] = l >> 12;
 v[a + 36 >> 2] = l;
 v[a + 48 >> 2] = e;
 v[a + 44 >> 2] = b;
 v[a + 24 >> 2] = k >> 12;
 eb = h + 16 | 0;
}

function mK(a, b, c, d, e, f) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 f = f | 0;
 var g = 0, h = 0, i = 0, j = 0, k = 0;
 a = eb - 336 | 0;
 eb = a;
 v[a + 328 >> 2] = c;
 v[a + 332 >> 2] = b;
 b = mj(v[d + 4 >> 2]);
 i = cq(v[d + 28 >> 2], a + 208 | 0);
 bq(a + 196 | 0, v[d + 28 >> 2], a + 324 | 0);
 d = Eb(a + 184 | 0);
 c = Lc(d);
 v[31601] = 0;
 N(46, d | 0, c | 0);
 c = v[31601];
 v[31601] = 0;
 a: {
  b: {
   c: {
    if ((c | 0) != 1) {
     c = dc(d, 0);
     v[a + 180 >> 2] = c;
     v[a + 12 >> 2] = a + 16;
     v[a + 8 >> 2] = 0;
     while (1) {
      d: {
       v[31601] = 0;
       g = O(1256, a + 332 | 0, a + 328 | 0) | 0;
       h = v[31601];
       v[31601] = 0;
       if ((h | 0) == 1) {
        break d;
       }
       if (g) {
        break c;
       }
       h = v[a + 180 >> 2];
       g = Cb(v[d + 4 >> 2], w[d + 11 | 0]);
       if ((h | 0) == (g + c | 0)) {
        v[31601] = 0;
        N(46, d | 0, g << 1);
        c = v[31601];
        v[31601] = 0;
        if ((c | 0) == 1) {
         break b;
        }
        c = Lc(d);
        v[31601] = 0;
        N(46, d | 0, c | 0);
        c = v[31601];
        v[31601] = 0;
        if ((c | 0) == 1) {
         break b;
        }
        c = dc(d, 0);
        v[a + 180 >> 2] = g + c;
       }
       v[31601] = 0;
       g = Q(1257, v[a + 332 >> 2]) | 0;
       h = v[31601];
       v[31601] = 0;
       if ((h | 0) == 1) {
        break d;
       }
       if (bo(g, b, c, a + 180 | 0, a + 8 | 0, v[a + 324 >> 2], v[a + 200 >> 2], w[a + 207 | 0], a + 16 | 0, a + 12 | 0, i)) {
        break c;
       }
       v[31601] = 0;
       Q(1259, a + 332 | 0) | 0;
       g = v[31601];
       v[31601] = 0;
       if ((g | 0) != 1) {
        continue;
       }
      }
      break;
     }
     break b;
    }
    break b;
   }
   e: {
    if (!Cb(v[a + 200 >> 2], w[a + 207 | 0])) {
     break e;
    }
    g = v[a + 12 >> 2];
    if ((g - (a + 16 | 0) | 0) > 159) {
     break e;
    }
    v[a + 12 >> 2] = g + 4;
    v[g >> 2] = v[a + 8 >> 2];
   }
   j = f, k = xK(c, v[a + 180 >> 2], e, b), v[j >> 2] = k;
   Uf(a + 196 | 0, a + 16 | 0, v[a + 12 >> 2], e);
   v[31601] = 0;
   b = O(1256, a + 332 | 0, a + 328 | 0) | 0;
   c = v[31601];
   v[31601] = 0;
   if ((c | 0) != 1) {
    if (b) {
     v[e >> 2] = v[e >> 2] | 2;
    }
    b = v[a + 332 >> 2];
    sb(d);
    sb(a + 196 | 0);
    eb = a + 336 | 0;
    break a;
   }
  }
  b = M() | 0;
  sb(d);
  sb(a + 196 | 0);
  P(b | 0);
  p();
 }
 return b | 0;
}

function f8(a, b, c, d, e, f) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 f = f | 0;
 var g = 0, h = 0, i = 0, j = 0, k = 0;
 a = eb - 336 | 0;
 eb = a;
 v[a + 328 >> 2] = c;
 v[a + 332 >> 2] = b;
 b = mj(v[d + 4 >> 2]);
 i = cq(v[d + 28 >> 2], a + 208 | 0);
 bq(a + 196 | 0, v[d + 28 >> 2], a + 324 | 0);
 d = Eb(a + 184 | 0);
 c = Lc(d);
 v[31601] = 0;
 N(46, d | 0, c | 0);
 c = v[31601];
 v[31601] = 0;
 a: {
  b: {
   c: {
    if ((c | 0) != 1) {
     c = dc(d, 0);
     v[a + 180 >> 2] = c;
     v[a + 12 >> 2] = a + 16;
     v[a + 8 >> 2] = 0;
     while (1) {
      d: {
       v[31601] = 0;
       g = O(1256, a + 332 | 0, a + 328 | 0) | 0;
       h = v[31601];
       v[31601] = 0;
       if ((h | 0) == 1) {
        break d;
       }
       if (g) {
        break c;
       }
       h = v[a + 180 >> 2];
       g = Cb(v[d + 4 >> 2], w[d + 11 | 0]);
       if ((h | 0) == (g + c | 0)) {
        v[31601] = 0;
        N(46, d | 0, g << 1);
        c = v[31601];
        v[31601] = 0;
        if ((c | 0) == 1) {
         break b;
        }
        c = Lc(d);
        v[31601] = 0;
        N(46, d | 0, c | 0);
        c = v[31601];
        v[31601] = 0;
        if ((c | 0) == 1) {
         break b;
        }
        c = dc(d, 0);
        v[a + 180 >> 2] = g + c;
       }
       v[31601] = 0;
       g = Q(1257, v[a + 332 >> 2]) | 0;
       h = v[31601];
       v[31601] = 0;
       if ((h | 0) == 1) {
        break d;
       }
       if (bo(g, b, c, a + 180 | 0, a + 8 | 0, v[a + 324 >> 2], v[a + 200 >> 2], w[a + 207 | 0], a + 16 | 0, a + 12 | 0, i)) {
        break c;
       }
       v[31601] = 0;
       Q(1259, a + 332 | 0) | 0;
       g = v[31601];
       v[31601] = 0;
       if ((g | 0) != 1) {
        continue;
       }
      }
      break;
     }
     break b;
    }
    break b;
   }
   e: {
    if (!Cb(v[a + 200 >> 2], w[a + 207 | 0])) {
     break e;
    }
    g = v[a + 12 >> 2];
    if ((g - (a + 16 | 0) | 0) > 159) {
     break e;
    }
    v[a + 12 >> 2] = g + 4;
    v[g >> 2] = v[a + 8 >> 2];
   }
   j = f, k = DK(c, v[a + 180 >> 2], e, b), v[j >> 2] = k;
   Uf(a + 196 | 0, a + 16 | 0, v[a + 12 >> 2], e);
   v[31601] = 0;
   b = O(1256, a + 332 | 0, a + 328 | 0) | 0;
   c = v[31601];
   v[31601] = 0;
   if ((c | 0) != 1) {
    if (b) {
     v[e >> 2] = v[e >> 2] | 2;
    }
    b = v[a + 332 >> 2];
    sb(d);
    sb(a + 196 | 0);
    eb = a + 336 | 0;
    break a;
   }
  }
  b = M() | 0;
  sb(d);
  sb(a + 196 | 0);
  P(b | 0);
  p();
 }
 return b | 0;
}

function d8(a, b, c, d, e, f) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 f = f | 0;
 var g = 0, h = 0, i = 0, j = 0, k = 0;
 a = eb - 336 | 0;
 eb = a;
 v[a + 328 >> 2] = c;
 v[a + 332 >> 2] = b;
 b = mj(v[d + 4 >> 2]);
 i = cq(v[d + 28 >> 2], a + 208 | 0);
 bq(a + 196 | 0, v[d + 28 >> 2], a + 324 | 0);
 d = Eb(a + 184 | 0);
 c = Lc(d);
 v[31601] = 0;
 N(46, d | 0, c | 0);
 c = v[31601];
 v[31601] = 0;
 a: {
  b: {
   c: {
    if ((c | 0) != 1) {
     c = dc(d, 0);
     v[a + 180 >> 2] = c;
     v[a + 12 >> 2] = a + 16;
     v[a + 8 >> 2] = 0;
     while (1) {
      d: {
       v[31601] = 0;
       g = O(1256, a + 332 | 0, a + 328 | 0) | 0;
       h = v[31601];
       v[31601] = 0;
       if ((h | 0) == 1) {
        break d;
       }
       if (g) {
        break c;
       }
       h = v[a + 180 >> 2];
       g = Cb(v[d + 4 >> 2], w[d + 11 | 0]);
       if ((h | 0) == (g + c | 0)) {
        v[31601] = 0;
        N(46, d | 0, g << 1);
        c = v[31601];
        v[31601] = 0;
        if ((c | 0) == 1) {
         break b;
        }
        c = Lc(d);
        v[31601] = 0;
        N(46, d | 0, c | 0);
        c = v[31601];
        v[31601] = 0;
        if ((c | 0) == 1) {
         break b;
        }
        c = dc(d, 0);
        v[a + 180 >> 2] = g + c;
       }
       v[31601] = 0;
       g = Q(1257, v[a + 332 >> 2]) | 0;
       h = v[31601];
       v[31601] = 0;
       if ((h | 0) == 1) {
        break d;
       }
       if (bo(g, b, c, a + 180 | 0, a + 8 | 0, v[a + 324 >> 2], v[a + 200 >> 2], w[a + 207 | 0], a + 16 | 0, a + 12 | 0, i)) {
        break c;
       }
       v[31601] = 0;
       Q(1259, a + 332 | 0) | 0;
       g = v[31601];
       v[31601] = 0;
       if ((g | 0) != 1) {
        continue;
       }
      }
      break;
     }
     break b;
    }
    break b;
   }
   e: {
    if (!Cb(v[a + 200 >> 2], w[a + 207 | 0])) {
     break e;
    }
    g = v[a + 12 >> 2];
    if ((g - (a + 16 | 0) | 0) > 159) {
     break e;
    }
    v[a + 12 >> 2] = g + 4;
    v[g >> 2] = v[a + 8 >> 2];
   }
   j = f, k = zK(c, v[a + 180 >> 2], e, b), u[j >> 1] = k;
   Uf(a + 196 | 0, a + 16 | 0, v[a + 12 >> 2], e);
   v[31601] = 0;
   b = O(1256, a + 332 | 0, a + 328 | 0) | 0;
   c = v[31601];
   v[31601] = 0;
   if ((c | 0) != 1) {
    if (b) {
     v[e >> 2] = v[e >> 2] | 2;
    }
    b = v[a + 332 >> 2];
    sb(d);
    sb(a + 196 | 0);
    eb = a + 336 | 0;
    break a;
   }
  }
  b = M() | 0;
  sb(d);
  sb(a + 196 | 0);
  P(b | 0);
  p();
 }
 return b | 0;
}

function Ala(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, w = 0, x = 0, y = 0, z = 0, A = 0;
 g = eb - 16 | 0;
 eb = g;
 t = v[a + 16 >> 2];
 w = Fg(b + 327720 | 0, v[b + 20 >> 2], (v[a + 88 >> 2] & 16384) >>> 14 | 0);
 m = v[a + 8 >> 2];
 n = v[a + 12 >> 2];
 h = v[a >> 2];
 e = v[a + 4 >> 2];
 o = v[a + 128 >> 2];
 if (o) {
  p = Gg(m, n, o);
  q = gb;
  b = v[a + 76 >> 2];
  eg(h, e, uf(m, n, d), gb);
  r = gb >>> 0 > b >>> 0 ? d : 0;
 }
 i = a + 112 | 0;
 k = v[a + 40 >> 2];
 l = v[a + 36 >> 2];
 f = v[a + 48 >> 2];
 b = v[a + 44 >> 2];
 v[g >> 2] = h;
 v[g + 4 >> 2] = e;
 a: while (1) {
  b: {
   s = b;
   if (!d) {
    break b;
   }
   d = d - 1 | 0;
   v[g + 8 >> 2] = h;
   v[g + 12 >> 2] = 0;
   r = r - 1 | 0;
   b = r;
   p = b ? p : 0;
   q = b ? q : 0;
   h = (e << 1) + t | 0;
   b = o;
   while (1) if ((b | 0) <= 0) {
    Ob(i, v[a + 120 >> 2], v[a + 124 >> 2]);
    b = v[a + 116 >> 2];
    if (b) {
     be(i, u[h + (v[g + 12 >> 2] << 1) >> 1] / 4 << 16 >> 16);
     ae(i, b);
     v[i >> 2] = v[i >> 2];
     v[i + 4 >> 2] = 0;
    }
    x = v[a + 72 >> 2];
    y = v[a + 32 >> 2];
    l = v[a + 28 >> 2] + l | 0;
    h = Eg(i, w) << 8;
    b = h;
    j = b >> 31;
    b = v[a + 60 >> 2];
    b = Aua(h, j, b, b >> 31);
    z = gb;
    e = b;
    b = v[a + 64 >> 2];
    j = b;
    A = b >> 31;
    b = Xb(s, -16777216, 16776704);
    j = Aua(j, A, b, b >> 31);
    e = e + j | 0;
    b = gb + z | 0;
    b = e >>> 0 < j >>> 0 ? b + 1 | 0 : b;
    j = e;
    e = v[a + 68 >> 2];
    f = Xb(f, -16777216, 16776704);
    e = Aua(e, e >> 31, f, f >> 31);
    f = j + e | 0;
    b = gb + b | 0;
    b = e >>> 0 > f >>> 0 ? b + 1 | 0 : b;
    f = f + 8388608 | 0;
    b = f >>> 0 < 8388608 ? b + 1 | 0 : b;
    b = Rc(f, b, 24);
    f = (b | 0) / 256 | 0;
    v[c >> 2] = B(l >> 12, f) + v[c >> 2];
    k = k + y | 0;
    v[c + 4 >> 2] = v[c + 4 >> 2] + B(k >> 12, f);
    Ob(g, m, n);
    b = b - (h & x) | 0;
    c = c + 8 | 0;
    h = v[g >> 2];
    e = v[g + 4 >> 2];
    f = s;
    continue a;
   } else {
    be(i, u[h + (v[g + 12 >> 2] << 1) >> 1] / 4 << 16 >> 16);
    ae(i, 4);
    Ob(g + 8 | 0, p, q);
    b = b - 1 | 0;
    continue;
   }
  }
  break;
 }
 v[a >> 2] = h;
 v[a + 4 >> 2] = e;
 v[a + 40 >> 2] = k;
 v[a + 20 >> 2] = l >> 12;
 v[a + 36 >> 2] = l;
 v[a + 48 >> 2] = f;
 v[a + 44 >> 2] = s;
 v[a + 24 >> 2] = k >> 12;
 eb = g + 16 | 0;
}

function n8(a, b, c, d, e, f) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 f = f | 0;
 var g = 0, h = 0, i = 0, j = 0;
 g = v[d + 4 >> 2];
 d = v[d + 28 >> 2];
 a = eb - 224 | 0;
 eb = a;
 v[a + 216 >> 2] = c;
 v[a + 220 >> 2] = b;
 b = mj(g);
 dq(a + 200 | 0, d, a + 215 | 0);
 d = Eb(a + 188 | 0);
 c = Lc(d);
 v[31601] = 0;
 N(46, d | 0, c | 0);
 c = v[31601];
 v[31601] = 0;
 a: {
  b: {
   c: {
    if ((c | 0) != 1) {
     c = dc(d, 0);
     v[a + 184 >> 2] = c;
     v[a + 12 >> 2] = a + 16;
     v[a + 8 >> 2] = 0;
     while (1) {
      d: {
       v[31601] = 0;
       g = O(1240, a + 220 | 0, a + 216 | 0) | 0;
       h = v[31601];
       v[31601] = 0;
       if ((h | 0) == 1) {
        break d;
       }
       if (g) {
        break c;
       }
       h = v[a + 184 >> 2];
       g = Cb(v[d + 4 >> 2], w[d + 11 | 0]);
       if ((h | 0) == (g + c | 0)) {
        v[31601] = 0;
        N(46, d | 0, g << 1);
        c = v[31601];
        v[31601] = 0;
        if ((c | 0) == 1) {
         break b;
        }
        c = Lc(d);
        v[31601] = 0;
        N(46, d | 0, c | 0);
        c = v[31601];
        v[31601] = 0;
        if ((c | 0) == 1) {
         break b;
        }
        c = dc(d, 0);
        v[a + 184 >> 2] = g + c;
       }
       v[31601] = 0;
       g = Q(1241, v[a + 220 >> 2]) | 0;
       h = v[31601];
       v[31601] = 0;
       if ((h | 0) == 1) {
        break d;
       }
       if (co(g, b, c, a + 184 | 0, a + 8 | 0, t[a + 215 | 0], v[a + 204 >> 2], w[a + 211 | 0], a + 16 | 0, a + 12 | 0, 95136)) {
        break c;
       }
       v[31601] = 0;
       Q(1243, a + 220 | 0) | 0;
       g = v[31601];
       v[31601] = 0;
       if ((g | 0) != 1) {
        continue;
       }
      }
      break;
     }
     break b;
    }
    break b;
   }
   e: {
    if (!Cb(v[a + 204 >> 2], w[a + 211 | 0])) {
     break e;
    }
    g = v[a + 12 >> 2];
    if ((g - (a + 16 | 0) | 0) > 159) {
     break e;
    }
    v[a + 12 >> 2] = g + 4;
    v[g >> 2] = v[a + 8 >> 2];
   }
   i = f, j = AK(c, v[a + 184 >> 2], e, b), v[i >> 2] = j;
   v[f + 4 >> 2] = gb;
   Uf(a + 200 | 0, a + 16 | 0, v[a + 12 >> 2], e);
   v[31601] = 0;
   b = O(1240, a + 220 | 0, a + 216 | 0) | 0;
   c = v[31601];
   v[31601] = 0;
   if ((c | 0) != 1) {
    if (b) {
     v[e >> 2] = v[e >> 2] | 2;
    }
    b = v[a + 220 >> 2];
    sb(d);
    sb(a + 200 | 0);
    eb = a + 224 | 0;
    break a;
   }
  }
  b = M() | 0;
  sb(d);
  sb(a + 200 | 0);
  P(b | 0);
  p();
 }
 return b | 0;
}

function l8(a, b, c, d, e, f) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 f = f | 0;
 var g = 0, h = 0, i = 0, j = 0;
 g = v[d + 4 >> 2];
 d = v[d + 28 >> 2];
 a = eb - 224 | 0;
 eb = a;
 v[a + 216 >> 2] = c;
 v[a + 220 >> 2] = b;
 b = mj(g);
 dq(a + 200 | 0, d, a + 215 | 0);
 d = Eb(a + 188 | 0);
 c = Lc(d);
 v[31601] = 0;
 N(46, d | 0, c | 0);
 c = v[31601];
 v[31601] = 0;
 a: {
  b: {
   c: {
    if ((c | 0) != 1) {
     c = dc(d, 0);
     v[a + 184 >> 2] = c;
     v[a + 12 >> 2] = a + 16;
     v[a + 8 >> 2] = 0;
     while (1) {
      d: {
       v[31601] = 0;
       g = O(1240, a + 220 | 0, a + 216 | 0) | 0;
       h = v[31601];
       v[31601] = 0;
       if ((h | 0) == 1) {
        break d;
       }
       if (g) {
        break c;
       }
       h = v[a + 184 >> 2];
       g = Cb(v[d + 4 >> 2], w[d + 11 | 0]);
       if ((h | 0) == (g + c | 0)) {
        v[31601] = 0;
        N(46, d | 0, g << 1);
        c = v[31601];
        v[31601] = 0;
        if ((c | 0) == 1) {
         break b;
        }
        c = Lc(d);
        v[31601] = 0;
        N(46, d | 0, c | 0);
        c = v[31601];
        v[31601] = 0;
        if ((c | 0) == 1) {
         break b;
        }
        c = dc(d, 0);
        v[a + 184 >> 2] = g + c;
       }
       v[31601] = 0;
       g = Q(1241, v[a + 220 >> 2]) | 0;
       h = v[31601];
       v[31601] = 0;
       if ((h | 0) == 1) {
        break d;
       }
       if (co(g, b, c, a + 184 | 0, a + 8 | 0, t[a + 215 | 0], v[a + 204 >> 2], w[a + 211 | 0], a + 16 | 0, a + 12 | 0, 95136)) {
        break c;
       }
       v[31601] = 0;
       Q(1243, a + 220 | 0) | 0;
       g = v[31601];
       v[31601] = 0;
       if ((g | 0) != 1) {
        continue;
       }
      }
      break;
     }
     break b;
    }
    break b;
   }
   e: {
    if (!Cb(v[a + 204 >> 2], w[a + 211 | 0])) {
     break e;
    }
    g = v[a + 12 >> 2];
    if ((g - (a + 16 | 0) | 0) > 159) {
     break e;
    }
    v[a + 12 >> 2] = g + 4;
    v[g >> 2] = v[a + 8 >> 2];
   }
   i = f, j = wK(c, v[a + 184 >> 2], e, b), v[i >> 2] = j;
   v[f + 4 >> 2] = gb;
   Uf(a + 200 | 0, a + 16 | 0, v[a + 12 >> 2], e);
   v[31601] = 0;
   b = O(1240, a + 220 | 0, a + 216 | 0) | 0;
   c = v[31601];
   v[31601] = 0;
   if ((c | 0) != 1) {
    if (b) {
     v[e >> 2] = v[e >> 2] | 2;
    }
    b = v[a + 220 >> 2];
    sb(d);
    sb(a + 200 | 0);
    eb = a + 224 | 0;
    break a;
   }
  }
  b = M() | 0;
  sb(d);
  sb(a + 200 | 0);
  P(b | 0);
  p();
 }
 return b | 0;
}

function xma(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, w = 0, x = 0, y = 0, z = 0, A = 0, C = 0;
 b = eb - 48 | 0;
 eb = b;
 q = v[a + 16 >> 2];
 v[b + 32 >> 2] = v[a + 44 >> 2];
 v[b + 36 >> 2] = v[a + 48 >> 2];
 v[b + 40 >> 2] = v[a + 52 >> 2];
 v[b + 44 >> 2] = v[a + 56 >> 2];
 r = v[a + 24 >> 2];
 s = v[a + 20 >> 2];
 f = v[a + 4 >> 2];
 v[b + 16 >> 2] = v[a >> 2];
 v[b + 20 >> 2] = f;
 t = b + 32 | 0;
 w = v[a + 72 >> 2];
 n = v[a + 68 >> 2];
 x = n >> 31;
 o = v[a + 64 >> 2];
 y = o >> 31;
 p = v[a + 60 >> 2];
 z = p >> 31;
 A = v[a + 8 >> 2];
 C = v[a + 12 >> 2];
 while (1) {
  if (d) {
   f = v[b + 16 >> 2];
   j = ((((v[b + 20 >> 2] & 2147483647) << 1 | f >>> 31) & 2147483646) << 1) + q | 0;
   f = f >>> 21 & 2040;
   h = u[f + 38054 >> 1];
   m = u[f + 38052 >> 1];
   i = u[f + 38050 >> 1];
   e = u[f + 38048 >> 1];
   k = 0;
   g = 0;
   while (1) {
    if ((g | 0) != 2) {
     f = g << 1;
     l = j + f | 0;
     v[(b + 8 | 0) + (g << 2) >> 2] = (((B(u[l >> 1], i) + B(u[j + (f | -4) >> 1], e) | 0) + B(m, u[l + 4 >> 1]) | 0) + B(h, u[l + 8 >> 1]) | 0) / 16384;
     g = g + 1 | 0;
     continue;
    }
    break;
   }
   while (1) {
    if ((k | 0) != 2) {
     j = (b + 8 | 0) + (k << 2) | 0;
     e = v[j >> 2];
     f = (k << 3) + t | 0;
     l = v[f + 4 >> 2];
     h = v[f >> 2];
     v[f + 4 >> 2] = h;
     m = e << 8;
     e = m;
     e = Aua(e, e >> 31, p, z);
     i = gb;
     g = e;
     e = Xb(h, -16777216, 16776704);
     e = Aua(o, y, e, e >> 31);
     h = g + e | 0;
     g = gb + i | 0;
     g = e >>> 0 > h >>> 0 ? g + 1 | 0 : g;
     e = Xb(l, -16777216, 16776704);
     i = Aua(n, x, e, e >> 31);
     h = i + h | 0;
     e = gb + g | 0;
     e = h >>> 0 < i >>> 0 ? e + 1 | 0 : e;
     i = h + 8388608 | 0;
     e = i >>> 0 < 8388608 ? e + 1 | 0 : e;
     e = Rc(i, e, 24);
     v[f >> 2] = e - (m & w);
     v[j >> 2] = (e | 0) / 256;
     k = k + 1 | 0;
     continue;
    }
    break;
   }
   v[c >> 2] = v[c >> 2] + B(v[b + 8 >> 2], s);
   v[c + 4 >> 2] = v[c + 4 >> 2] + B(v[b + 12 >> 2], r);
   Ob(b + 16 | 0, A, C);
   c = c + 8 | 0;
   d = d - 1 | 0;
   continue;
  }
  break;
 }
 c = v[b + 20 >> 2];
 v[a >> 2] = v[b + 16 >> 2];
 v[a + 4 >> 2] = c;
 v[a + 44 >> 2] = v[b + 32 >> 2];
 v[a + 48 >> 2] = v[b + 36 >> 2];
 v[a + 52 >> 2] = v[b + 40 >> 2];
 v[a + 56 >> 2] = v[b + 44 >> 2];
 eb = b + 48 | 0;
}

function yK(a, b, c, d, e, f) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 f = f | 0;
 var g = 0, h = 0, i = 0, j = 0;
 g = v[d + 4 >> 2];
 d = v[d + 28 >> 2];
 a = eb - 224 | 0;
 eb = a;
 v[a + 216 >> 2] = c;
 v[a + 220 >> 2] = b;
 b = mj(g);
 dq(a + 200 | 0, d, a + 215 | 0);
 d = Eb(a + 188 | 0);
 c = Lc(d);
 v[31601] = 0;
 N(46, d | 0, c | 0);
 c = v[31601];
 v[31601] = 0;
 a: {
  b: {
   c: {
    if ((c | 0) != 1) {
     c = dc(d, 0);
     v[a + 184 >> 2] = c;
     v[a + 12 >> 2] = a + 16;
     v[a + 8 >> 2] = 0;
     while (1) {
      d: {
       v[31601] = 0;
       g = O(1240, a + 220 | 0, a + 216 | 0) | 0;
       h = v[31601];
       v[31601] = 0;
       if ((h | 0) == 1) {
        break d;
       }
       if (g) {
        break c;
       }
       h = v[a + 184 >> 2];
       g = Cb(v[d + 4 >> 2], w[d + 11 | 0]);
       if ((h | 0) == (g + c | 0)) {
        v[31601] = 0;
        N(46, d | 0, g << 1);
        c = v[31601];
        v[31601] = 0;
        if ((c | 0) == 1) {
         break b;
        }
        c = Lc(d);
        v[31601] = 0;
        N(46, d | 0, c | 0);
        c = v[31601];
        v[31601] = 0;
        if ((c | 0) == 1) {
         break b;
        }
        c = dc(d, 0);
        v[a + 184 >> 2] = g + c;
       }
       v[31601] = 0;
       g = Q(1241, v[a + 220 >> 2]) | 0;
       h = v[31601];
       v[31601] = 0;
       if ((h | 0) == 1) {
        break d;
       }
       if (co(g, b, c, a + 184 | 0, a + 8 | 0, t[a + 215 | 0], v[a + 204 >> 2], w[a + 211 | 0], a + 16 | 0, a + 12 | 0, 95136)) {
        break c;
       }
       v[31601] = 0;
       Q(1243, a + 220 | 0) | 0;
       g = v[31601];
       v[31601] = 0;
       if ((g | 0) != 1) {
        continue;
       }
      }
      break;
     }
     break b;
    }
    break b;
   }
   e: {
    if (!Cb(v[a + 204 >> 2], w[a + 211 | 0])) {
     break e;
    }
    g = v[a + 12 >> 2];
    if ((g - (a + 16 | 0) | 0) > 159) {
     break e;
    }
    v[a + 12 >> 2] = g + 4;
    v[g >> 2] = v[a + 8 >> 2];
   }
   i = f, j = xK(c, v[a + 184 >> 2], e, b), v[i >> 2] = j;
   Uf(a + 200 | 0, a + 16 | 0, v[a + 12 >> 2], e);
   v[31601] = 0;
   b = O(1240, a + 220 | 0, a + 216 | 0) | 0;
   c = v[31601];
   v[31601] = 0;
   if ((c | 0) != 1) {
    if (b) {
     v[e >> 2] = v[e >> 2] | 2;
    }
    b = v[a + 220 >> 2];
    sb(d);
    sb(a + 200 | 0);
    eb = a + 224 | 0;
    break a;
   }
  }
  b = M() | 0;
  sb(d);
  sb(a + 200 | 0);
  P(b | 0);
  p();
 }
 return b | 0;
}

function o8(a, b, c, d, e, f) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 f = f | 0;
 var g = 0, h = 0, i = 0, j = 0;
 g = v[d + 4 >> 2];
 d = v[d + 28 >> 2];
 a = eb - 224 | 0;
 eb = a;
 v[a + 216 >> 2] = c;
 v[a + 220 >> 2] = b;
 b = mj(g);
 dq(a + 200 | 0, d, a + 215 | 0);
 d = Eb(a + 188 | 0);
 c = Lc(d);
 v[31601] = 0;
 N(46, d | 0, c | 0);
 c = v[31601];
 v[31601] = 0;
 a: {
  b: {
   c: {
    if ((c | 0) != 1) {
     c = dc(d, 0);
     v[a + 184 >> 2] = c;
     v[a + 12 >> 2] = a + 16;
     v[a + 8 >> 2] = 0;
     while (1) {
      d: {
       v[31601] = 0;
       g = O(1240, a + 220 | 0, a + 216 | 0) | 0;
       h = v[31601];
       v[31601] = 0;
       if ((h | 0) == 1) {
        break d;
       }
       if (g) {
        break c;
       }
       h = v[a + 184 >> 2];
       g = Cb(v[d + 4 >> 2], w[d + 11 | 0]);
       if ((h | 0) == (g + c | 0)) {
        v[31601] = 0;
        N(46, d | 0, g << 1);
        c = v[31601];
        v[31601] = 0;
        if ((c | 0) == 1) {
         break b;
        }
        c = Lc(d);
        v[31601] = 0;
        N(46, d | 0, c | 0);
        c = v[31601];
        v[31601] = 0;
        if ((c | 0) == 1) {
         break b;
        }
        c = dc(d, 0);
        v[a + 184 >> 2] = g + c;
       }
       v[31601] = 0;
       g = Q(1241, v[a + 220 >> 2]) | 0;
       h = v[31601];
       v[31601] = 0;
       if ((h | 0) == 1) {
        break d;
       }
       if (co(g, b, c, a + 184 | 0, a + 8 | 0, t[a + 215 | 0], v[a + 204 >> 2], w[a + 211 | 0], a + 16 | 0, a + 12 | 0, 95136)) {
        break c;
       }
       v[31601] = 0;
       Q(1243, a + 220 | 0) | 0;
       g = v[31601];
       v[31601] = 0;
       if ((g | 0) != 1) {
        continue;
       }
      }
      break;
     }
     break b;
    }
    break b;
   }
   e: {
    if (!Cb(v[a + 204 >> 2], w[a + 211 | 0])) {
     break e;
    }
    g = v[a + 12 >> 2];
    if ((g - (a + 16 | 0) | 0) > 159) {
     break e;
    }
    v[a + 12 >> 2] = g + 4;
    v[g >> 2] = v[a + 8 >> 2];
   }
   i = f, j = DK(c, v[a + 184 >> 2], e, b), v[i >> 2] = j;
   Uf(a + 200 | 0, a + 16 | 0, v[a + 12 >> 2], e);
   v[31601] = 0;
   b = O(1240, a + 220 | 0, a + 216 | 0) | 0;
   c = v[31601];
   v[31601] = 0;
   if ((c | 0) != 1) {
    if (b) {
     v[e >> 2] = v[e >> 2] | 2;
    }
    b = v[a + 220 >> 2];
    sb(d);
    sb(a + 200 | 0);
    eb = a + 224 | 0;
    break a;
   }
  }
  b = M() | 0;
  sb(d);
  sb(a + 200 | 0);
  P(b | 0);
  p();
 }
 return b | 0;
}

function m8(a, b, c, d, e, f) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 f = f | 0;
 var g = 0, h = 0, i = 0, j = 0;
 g = v[d + 4 >> 2];
 d = v[d + 28 >> 2];
 a = eb - 224 | 0;
 eb = a;
 v[a + 216 >> 2] = c;
 v[a + 220 >> 2] = b;
 b = mj(g);
 dq(a + 200 | 0, d, a + 215 | 0);
 d = Eb(a + 188 | 0);
 c = Lc(d);
 v[31601] = 0;
 N(46, d | 0, c | 0);
 c = v[31601];
 v[31601] = 0;
 a: {
  b: {
   c: {
    if ((c | 0) != 1) {
     c = dc(d, 0);
     v[a + 184 >> 2] = c;
     v[a + 12 >> 2] = a + 16;
     v[a + 8 >> 2] = 0;
     while (1) {
      d: {
       v[31601] = 0;
       g = O(1240, a + 220 | 0, a + 216 | 0) | 0;
       h = v[31601];
       v[31601] = 0;
       if ((h | 0) == 1) {
        break d;
       }
       if (g) {
        break c;
       }
       h = v[a + 184 >> 2];
       g = Cb(v[d + 4 >> 2], w[d + 11 | 0]);
       if ((h | 0) == (g + c | 0)) {
        v[31601] = 0;
        N(46, d | 0, g << 1);
        c = v[31601];
        v[31601] = 0;
        if ((c | 0) == 1) {
         break b;
        }
        c = Lc(d);
        v[31601] = 0;
        N(46, d | 0, c | 0);
        c = v[31601];
        v[31601] = 0;
        if ((c | 0) == 1) {
         break b;
        }
        c = dc(d, 0);
        v[a + 184 >> 2] = g + c;
       }
       v[31601] = 0;
       g = Q(1241, v[a + 220 >> 2]) | 0;
       h = v[31601];
       v[31601] = 0;
       if ((h | 0) == 1) {
        break d;
       }
       if (co(g, b, c, a + 184 | 0, a + 8 | 0, t[a + 215 | 0], v[a + 204 >> 2], w[a + 211 | 0], a + 16 | 0, a + 12 | 0, 95136)) {
        break c;
       }
       v[31601] = 0;
       Q(1243, a + 220 | 0) | 0;
       g = v[31601];
       v[31601] = 0;
       if ((g | 0) != 1) {
        continue;
       }
      }
      break;
     }
     break b;
    }
    break b;
   }
   e: {
    if (!Cb(v[a + 204 >> 2], w[a + 211 | 0])) {
     break e;
    }
    g = v[a + 12 >> 2];
    if ((g - (a + 16 | 0) | 0) > 159) {
     break e;
    }
    v[a + 12 >> 2] = g + 4;
    v[g >> 2] = v[a + 8 >> 2];
   }
   i = f, j = zK(c, v[a + 184 >> 2], e, b), u[i >> 1] = j;
   Uf(a + 200 | 0, a + 16 | 0, v[a + 12 >> 2], e);
   v[31601] = 0;
   b = O(1240, a + 220 | 0, a + 216 | 0) | 0;
   c = v[31601];
   v[31601] = 0;
   if ((c | 0) != 1) {
    if (b) {
     v[e >> 2] = v[e >> 2] | 2;
    }
    b = v[a + 220 >> 2];
    sb(d);
    sb(a + 200 | 0);
    eb = a + 224 | 0;
    break a;
   }
  }
  b = M() | 0;
  sb(d);
  sb(a + 200 | 0);
  P(b | 0);
  p();
 }
 return b | 0;
}

function Sra(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0;
 d = eb - 48 | 0;
 eb = d;
 l = b + 8 | 0;
 m = b + 906300 | 0;
 while (1) {
  a: {
   b: {
    c: {
     if (Lb(v[c >> 2], v[c + 8 >> 2], 9)) {
      kr(c, d + 43 | 0);
      f = Qg(c);
      d: {
       e = w[d + 43 | 0] | w[d + 44 | 0] << 8 | (w[d + 45 | 0] << 16 | w[d + 46 | 0] << 24);
       if (!((e | 0) == 1229999433 | (e | 0) == 1397771593 | ((e | 0) == 1297110104 | (e | 0) == 1297110099))) {
        if (Lb(v[c >> 2], v[c + 8 >> 2], f)) {
         break d;
        }
       }
       t[d + 47 | 0] = j;
       Hh(c, 8);
       break c;
      }
      ge(d, c, f);
      f = gc(d + 20 | 0, d);
      tb(d);
      e: {
       if ((w[d + 43 | 0] | w[d + 44 | 0] << 8 | (w[d + 45 | 0] << 16 | w[d + 46 | 0] << 24)) == 1481001027) {
        g = 480280;
        while (1) {
         if ((g | 0) == 484344) {
          g = 1;
          break a;
         }
         v[31601] = 0;
         e = Q(151, f | 0) | 0;
         h = v[31601];
         v[31601] = 0;
         if ((h | 0) == 1) {
          break e;
         }
         t[g + l | 0] = e;
         g = g + 32 | 0;
         continue;
        }
       }
       if (w[d + 43 | 0] != 70) {
        break b;
       }
       h = w[d + 44 | 0];
       k = (h | 0) == 88;
       f: {
        if (!k) {
         if ((h - 48 & 255) >>> 0 > 9) {
          break b;
         }
         e = t[d + 45 | 0];
         if ((e | 0) > 47) {
          break f;
         }
         break b;
        }
        e = t[d + 45 | 0];
        if ((e | 0) < 48) {
         break b;
        }
       }
       if (e >>> 0 > 57) {
        break b;
       }
       i = t[d + 46 | 0];
       if ((i | 0) < 48 | (i | 0) > 57) {
        break b;
       }
       g = 1;
       e = ((i & 255) + (k ? -528 : B(h, 100) - 5328 | 0) | 0) + B(e & 255, 10) & 65535;
       if (e >>> 0 > 249) {
        break a;
       }
       v[31601] = 0;
       N(450, f | 0, _d(m, e) | 0);
       e = v[31601];
       v[31601] = 0;
       if ((e | 0) != 1) {
        break a;
       }
      }
      a = M() | 0;
      tb(f);
      P(a | 0);
      p();
     }
     t[d + 47 | 0] = j;
    }
    AD(a, g, d + 47 | 0);
    eb = d + 48 | 0;
    return;
   }
   if ((w[d + 43 | 0] | w[d + 44 | 0] << 8 | (w[d + 45 | 0] << 16 | w[d + 46 | 0] << 24)) != 1430540109) {
    break a;
   }
   v[b + 1074308 >> 2] = 0;
   j = 1;
  }
  tb(f);
  continue;
 }
}

function yma(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, w = 0, x = 0, y = 0, z = 0, A = 0, C = 0, D = 0;
 b = eb - 48 | 0;
 eb = b;
 q = v[a + 16 >> 2];
 v[b + 32 >> 2] = v[a + 44 >> 2];
 v[b + 36 >> 2] = v[a + 48 >> 2];
 v[b + 40 >> 2] = v[a + 52 >> 2];
 v[b + 44 >> 2] = v[a + 56 >> 2];
 r = v[a + 24 >> 2];
 s = v[a + 20 >> 2];
 f = v[a + 4 >> 2];
 v[b + 16 >> 2] = v[a >> 2];
 v[b + 20 >> 2] = f;
 w = b + 32 | 0;
 x = v[a + 72 >> 2];
 n = v[a + 68 >> 2];
 y = n >> 31;
 o = v[a + 64 >> 2];
 z = o >> 31;
 p = v[a + 60 >> 2];
 A = p >> 31;
 C = v[a + 8 >> 2];
 D = v[a + 12 >> 2];
 while (1) {
  if (d) {
   f = v[b + 16 >> 2];
   g = (((v[b + 20 >> 2] & 2147483647) << 1 | f >>> 31) & -2) + q | 0;
   f = f >>> 21 & 2040;
   m = u[f + 38050 >> 1] << 8;
   h = u[f + 38048 >> 1] << 8;
   e = u[f + 38052 >> 1] << 8;
   f = u[f + 38054 >> 1] << 8;
   l = 0;
   i = 0;
   while (1) {
    if ((i | 0) != 2) {
     j = g + i | 0;
     v[(b + 8 | 0) + (i << 2) >> 2] = (((B(m, t[j | 0]) + B(h, t[j - 2 | 0]) | 0) + B(t[j + 2 | 0], e) | 0) + B(t[j + 4 | 0], f) | 0) / 16384;
     i = i + 1 | 0;
     continue;
    }
    break;
   }
   while (1) {
    if ((l | 0) != 2) {
     i = (b + 8 | 0) + (l << 2) | 0;
     e = v[i >> 2];
     f = (l << 3) + w | 0;
     j = v[f + 4 >> 2];
     g = v[f >> 2];
     v[f + 4 >> 2] = g;
     m = e << 8;
     e = m;
     e = Aua(e, e >> 31, p, A);
     h = gb;
     k = e;
     e = Xb(g, -16777216, 16776704);
     e = Aua(o, z, e, e >> 31);
     g = k + e | 0;
     k = gb + h | 0;
     k = e >>> 0 > g >>> 0 ? k + 1 | 0 : k;
     e = Xb(j, -16777216, 16776704);
     h = Aua(n, y, e, e >> 31);
     g = h + g | 0;
     e = gb + k | 0;
     e = g >>> 0 < h >>> 0 ? e + 1 | 0 : e;
     h = g + 8388608 | 0;
     e = h >>> 0 < 8388608 ? e + 1 | 0 : e;
     e = Rc(h, e, 24);
     v[f >> 2] = e - (m & x);
     v[i >> 2] = (e | 0) / 256;
     l = l + 1 | 0;
     continue;
    }
    break;
   }
   v[c >> 2] = v[c >> 2] + B(v[b + 8 >> 2], s);
   v[c + 4 >> 2] = v[c + 4 >> 2] + B(v[b + 12 >> 2], r);
   Ob(b + 16 | 0, C, D);
   c = c + 8 | 0;
   d = d - 1 | 0;
   continue;
  }
  break;
 }
 c = v[b + 20 >> 2];
 v[a >> 2] = v[b + 16 >> 2];
 v[a + 4 >> 2] = c;
 v[a + 44 >> 2] = v[b + 32 >> 2];
 v[a + 48 >> 2] = v[b + 36 >> 2];
 v[a + 52 >> 2] = v[b + 40 >> 2];
 v[a + 56 >> 2] = v[b + 44 >> 2];
 eb = b + 48 | 0;
}

function YE(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
 h = eb - 16 | 0;
 eb = h;
 d = v[b >> 2];
 e = _c(d, v[b + 4 >> 2]);
 a: {
  if (e >>> 0 < c >>> 0) {
   l = eb - 32 | 0;
   eb = l;
   d = c - e | 0;
   e = v[zb(b) >> 2];
   f = v[b + 4 >> 2];
   b: {
    if (d >>> 0 <= e - f >> 1 >>> 0) {
     f = eb - 16 | 0;
     eb = f;
     d = aj(f + 4 | 0, b, d);
     e = v[d + 4 >> 2];
     g = v[d + 8 >> 2];
     while (1) {
      if ((e | 0) == (g | 0)) {
       hc(d);
       eb = f + 16 | 0;
      } else {
       rp(e);
       e = e + 2 | 0;
       v[d + 4 >> 2] = e;
       continue;
      }
      break;
     }
     break b;
    }
    e = zb(b);
    e = dk(l + 12 | 0, ek(b, _c(v[b >> 2], f) + d | 0), _c(v[b >> 2], v[b + 4 >> 2]), e);
    g = eb - 16 | 0;
    eb = g;
    d = Bp(g + 4 | 0, e + 8 | 0, d);
    f = v[d >> 2];
    while (1) {
     if (v[d + 4 >> 2] != (f | 0)) {
      rp(f);
      f = v[d >> 2] + 2 | 0;
      v[d >> 2] = f;
      continue;
     }
     break;
    }
    ie(d);
    eb = g + 16 | 0;
    i = eb - 16 | 0;
    eb = i;
    f = ub(i + 12 | 0, v[b + 4 >> 2]);
    g = ub(i + 8 | 0, v[b >> 2]);
    j = v[ub(i + 4 | 0, v[e + 4 >> 2]) >> 2];
    k = eb - 16 | 0;
    eb = k;
    m = k + 8 | 0;
    d = eb - 32 | 0;
    eb = d;
    ed(d + 24 | 0, v[f >> 2], v[g >> 2]);
    n = d + 16 | 0;
    g = v[d + 24 >> 2];
    o = v[d + 28 >> 2];
    f = eb - 16 | 0;
    eb = f;
    v[f + 8 >> 2] = j;
    v[f + 12 >> 2] = g;
    while (1) {
     if (Ed(g, o)) {
      g = Fn(g);
      j = Fn(v[f + 8 >> 2]);
      g = w[g | 0] | w[g + 1 | 0] << 8;
      t[j | 0] = g;
      t[j + 1 | 0] = g >>> 8;
      g = Uk(f + 12 | 0);
      Uk(f + 8 | 0);
      g = v[g >> 2];
      continue;
     }
     break;
    }
    pc(n, g, f + 8 | 0);
    eb = f + 16 | 0;
    f = v[d + 16 >> 2];
    v[d + 12 >> 2] = v[d + 20 >> 2];
    pc(m, f, d + 12 | 0);
    eb = d + 32 | 0;
    eb = k + 16 | 0;
    v[e + 4 >> 2] = v[k + 12 >> 2];
    Sb(b, e + 4 | 0);
    Sb(b + 4 | 0, e + 8 | 0);
    Sb(zb(b), mc(e));
    v[e >> 2] = v[e + 4 >> 2];
    eb = i + 16 | 0;
    $i(e);
   }
   eb = l + 32 | 0;
   break a;
  }
  if (c >>> 0 < e >>> 0) {
   Id(b, d + (c << 1) | 0);
  }
 }
 c = Lb(v[a >> 2], v[a + 8 >> 2], c << 1);
 if (c) {
  e = v[b >> 2];
  ac(h + 8 | 0, e, _c(e, v[b + 4 >> 2]) << 1);
  rd(h, a, v[h + 8 >> 2], v[h + 12 >> 2]);
 }
 eb = h + 16 | 0;
 return c | 0;
}

function Hj(a, b) {
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0;
 a: {
  if (!ke(v[a >> 2], v[a + 20 >> 2])) {
   break a;
  }
  Sk(a);
  b: {
   switch (In(x[a + 34 >> 1]) - 1 | 0) {
   case 1:
    h = eb - 48 | 0;
    eb = h;
    g = v[a + 20 >> 2];
    d = v[a >> 2];
    c = Zd(x[a + 34 >> 1]);
    e = g + (B(d, c) << 1) | 0;
    while (1) {
     c: {
      d: {
       if ((f | 0) != 16) {
        j = e + (B(c, f) << 1) | 0;
        k = g + (B(c, f ^ -1) << 1) | 0;
        d = 0;
        break d;
       }
       f = e + (c << 5) | 0;
       d = x[a + 34 >> 1];
       if (d & 2) {
        e = v[a + 4 >> 2];
        i = v[a + 8 >> 2] - e | 0;
        $U(h + 28 | 0, f, g + (B(c, e) << 1) | 0, i, c, (d & 4) >>> 2 | 0, Nb(b + 1074312 | 0, 33));
        d = x[a + 34 >> 1];
       }
       if (d & 8) {
        e = v[a + 16 >> 2];
        a = v[a + 12 >> 2];
        e = e - a | 0;
        $U(h + 8 | 0, f + (c << 7) | 0, g + (B(a, c) << 1) | 0, e, c, (d & 16) >>> 4 | 0, Nb(b + 1074312 | 0, 33));
       }
       eb = h + 48 | 0;
       break c;
      }
      while (1) {
       if ((c | 0) != (d | 0)) {
        i = d << 1;
        u[i + j >> 1] = x[e + (d - c << 1) >> 1];
        u[i + k >> 1] = x[g + i >> 1];
        d = d + 1 | 0;
        continue;
       }
       break;
      }
      f = f + 1 | 0;
      continue;
     }
     break;
    }
    ;
    return;

   case 0:
    break b;

   default:
    break a;
   }
  }
  h = eb - 48 | 0;
  eb = h;
  g = v[a + 20 >> 2];
  c = v[a >> 2];
  d = Zd(x[a + 34 >> 1]);
  e = g + B(c, d) | 0;
  while (1) {
   e: {
    f: {
     if ((f | 0) != 16) {
      i = e + B(d, f) | 0;
      j = g + B(d, f ^ -1) | 0;
      c = 0;
      break f;
     }
     f = e + (d << 4) | 0;
     c = x[a + 34 >> 1];
     if (c & 2) {
      e = v[a + 4 >> 2];
      i = v[a + 8 >> 2] - e | 0;
      _U(h + 28 | 0, f, g + B(d, e) | 0, i, d, (c & 4) >>> 2 | 0, Nb(b + 1074312 | 0, 33));
      c = x[a + 34 >> 1];
     }
     if (c & 8) {
      e = v[a + 16 >> 2];
      a = v[a + 12 >> 2];
      e = e - a | 0;
      _U(h + 8 | 0, f + (d << 6) | 0, g + B(a, d) | 0, e, d, (c & 16) >>> 4 | 0, Nb(b + 1074312 | 0, 33));
     }
     eb = h + 48 | 0;
     break e;
    }
    while (1) {
     if ((c | 0) != (d | 0)) {
      t[c + i | 0] = w[e + (c - d | 0) | 0];
      t[c + j | 0] = w[c + g | 0];
      c = c + 1 | 0;
      continue;
     }
     break;
    }
    f = f + 1 | 0;
    continue;
   }
   break;
  }
 }
}

function Bla(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, u = 0, w = 0, x = 0, y = 0, z = 0, A = 0;
 g = eb - 16 | 0;
 eb = g;
 u = v[a + 16 >> 2];
 w = Fg(b + 327720 | 0, v[b + 20 >> 2], (v[a + 88 >> 2] & 16384) >>> 14 | 0);
 m = v[a + 8 >> 2];
 n = v[a + 12 >> 2];
 h = v[a >> 2];
 e = v[a + 4 >> 2];
 o = v[a + 128 >> 2];
 if (o) {
  p = Gg(m, n, o);
  q = gb;
  b = v[a + 76 >> 2];
  eg(h, e, uf(m, n, d), gb);
  r = gb >>> 0 > b >>> 0 ? d : 0;
 }
 i = a + 112 | 0;
 k = v[a + 40 >> 2];
 l = v[a + 36 >> 2];
 f = v[a + 48 >> 2];
 b = v[a + 44 >> 2];
 v[g >> 2] = h;
 v[g + 4 >> 2] = e;
 a: while (1) {
  b: {
   s = b;
   if (!d) {
    break b;
   }
   d = d - 1 | 0;
   v[g + 8 >> 2] = h;
   v[g + 12 >> 2] = 0;
   r = r - 1 | 0;
   b = r;
   p = b ? p : 0;
   q = b ? q : 0;
   h = e + u | 0;
   b = o;
   while (1) if ((b | 0) <= 0) {
    Ob(i, v[a + 120 >> 2], v[a + 124 >> 2]);
    b = v[a + 116 >> 2];
    if (b) {
     be(i, t[h + v[g + 12 >> 2] | 0] << 6);
     ae(i, b);
     v[i >> 2] = v[i >> 2];
     v[i + 4 >> 2] = 0;
    }
    x = v[a + 72 >> 2];
    y = v[a + 32 >> 2];
    l = v[a + 28 >> 2] + l | 0;
    h = Eg(i, w) << 8;
    b = h;
    j = b >> 31;
    b = v[a + 60 >> 2];
    b = Aua(h, j, b, b >> 31);
    z = gb;
    e = b;
    b = v[a + 64 >> 2];
    j = b;
    A = b >> 31;
    b = Xb(s, -16777216, 16776704);
    j = Aua(j, A, b, b >> 31);
    e = e + j | 0;
    b = gb + z | 0;
    b = e >>> 0 < j >>> 0 ? b + 1 | 0 : b;
    j = e;
    e = v[a + 68 >> 2];
    f = Xb(f, -16777216, 16776704);
    e = Aua(e, e >> 31, f, f >> 31);
    f = j + e | 0;
    b = gb + b | 0;
    b = e >>> 0 > f >>> 0 ? b + 1 | 0 : b;
    f = f + 8388608 | 0;
    b = f >>> 0 < 8388608 ? b + 1 | 0 : b;
    b = Rc(f, b, 24);
    f = (b | 0) / 256 | 0;
    v[c >> 2] = B(l >> 12, f) + v[c >> 2];
    k = k + y | 0;
    v[c + 4 >> 2] = v[c + 4 >> 2] + B(k >> 12, f);
    Ob(g, m, n);
    b = b - (h & x) | 0;
    c = c + 8 | 0;
    h = v[g >> 2];
    e = v[g + 4 >> 2];
    f = s;
    continue a;
   } else {
    be(i, t[h + v[g + 12 >> 2] | 0] << 6);
    ae(i, 4);
    Ob(g + 8 | 0, p, q);
    b = b - 1 | 0;
    continue;
   }
  }
  break;
 }
 v[a >> 2] = h;
 v[a + 4 >> 2] = e;
 v[a + 40 >> 2] = k;
 v[a + 20 >> 2] = l >> 12;
 v[a + 36 >> 2] = l;
 v[a + 48 >> 2] = f;
 v[a + 44 >> 2] = s;
 v[a + 24 >> 2] = k >> 12;
 eb = g + 16 | 0;
}

function Nna(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0;
 g = eb - 48 | 0;
 eb = g;
 c = vb(v[a >> 2]);
 v[g + 44 >> 2] = c;
 k = vb(v[a + 4 >> 2]);
 while (1) {
  if (Hb(c, k)) {
   i = g + 24 | 0;
   a = vb(v[c >> 2]);
   l = vb(v[c + 4 >> 2]);
   c = $W(g + 4 | 0, b);
   t[c + 16 | 0] = w[b + 16 | 0];
   v[c + 12 >> 2] = v[b + 12 >> 2];
   h = eb - 16 | 0;
   eb = h;
   v[h + 12 >> 2] = a;
   while (1) {
    if (Hb(a, l)) {
     f = eb - 16 | 0;
     eb = f;
     if (!(w[a + 5 | 0] | w[a + 3 | 0] != 4)) {
      e = f + 8 | 0;
      Ib(e, v[c >> 2], x[c + 14 >> 1]);
      kf(e, 0);
      t[a + 3 | 0] = 0;
     }
     e = w[a + 2 | 0];
     if (!(w[a + 4 | 0] | (e | 0) != 11)) {
      d = f + 8 | 0;
      Ib(d, v[c >> 2], x[c + 14 >> 1]);
      kf(d, 0);
      t[a + 2 | 0] = 0;
      e = 0;
     }
     a: {
      b: {
       if (!w[a | 0]) {
        Ib(f + 8 | 0, v[c >> 2], x[c + 14 >> 1]);
        e = w[a + 2 | 0];
        d = w[a + 3 | 0];
        if (!Fb(v[v[f + 8 >> 2] >> 2], v[f + 12 >> 2])) {
         break b;
        }
        if (!((e | 0) == 11 | d)) {
         t[a + 5 | 0] = 0;
         d = 4;
         t[a + 3 | 0] = 4;
         break a;
        }
        if ((d | 0) == 4 | e) {
         break a;
        }
        t[a + 4 | 0] = 0;
        t[a + 2 | 0] = 11;
        break a;
       }
       d = w[a + 3 | 0];
      }
      j = f + 8 | 0;
      Ib(j, v[c >> 2], x[c + 14 >> 1]);
      kf(j, (d | 0) == 4 | (e | 0) == 11);
      d = w[a + 3 | 0];
     }
     c: {
      d: {
       e: {
        if (!(!w[c + 16 | 0] | d)) {
         t[a + 3 | 0] = 17;
         d = 125;
         e = 0;
         break e;
        }
        e = 0;
        f: {
         switch (d - 16 | 0) {
         case 1:
          break d;

         case 0:
          break f;

         default:
          break c;
         }
        }
        if (w[a + 5 | 0]) {
         break c;
        }
        d = 6;
        e = 1;
       }
       t[a + 5 | 0] = d;
      }
      t[c + 16 | 0] = e;
     }
     a = x[c + 14 >> 1] + 1 | 0;
     u[c + 14 >> 1] = x[c + 12 >> 1] > (a & 65535) >>> 0 ? a : 0;
     eb = f + 16 | 0;
     a = v[sg(h + 12 | 0) >> 2];
     continue;
    }
    break;
   }
   a = EC(i, c);
   t[a + 16 | 0] = w[c + 16 | 0];
   v[a + 12 >> 2] = v[c + 12 >> 2];
   eb = h + 16 | 0;
   tf(i);
   tf(c);
   c = v[Sl(g + 44 | 0) >> 2];
   continue;
  } else {
   eb = g + 48 | 0;
  }
  break;
 }
}

function sG(a, b) {
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0;
 c = v[a >> 2];
 e = hh(c, v[a + 4 >> 2]);
 if (e >>> 0 < b >>> 0) {
  j = eb - 32 | 0;
  eb = j;
  c = b - e | 0;
  b = v[zb(a) >> 2];
  d = v[a + 4 >> 2];
  a: {
   if (c >>> 0 <= b - d >> 3 >>> 0) {
    e = eb - 16 | 0;
    eb = e;
    b = hs(e + 4 | 0, a, c);
    a = v[b + 4 >> 2];
    c = v[b + 8 >> 2];
    while (1) {
     if ((a | 0) == (c | 0)) {
      hc(b);
      eb = e + 16 | 0;
     } else {
      Zk(a);
      a = a + 8 | 0;
      v[b + 4 >> 2] = a;
      continue;
     }
     break;
    }
    break a;
   }
   b = zb(a);
   e = js(j + 12 | 0, ks(a, hh(v[a >> 2], d) + c | 0), hh(v[a >> 2], v[a + 4 >> 2]), b);
   d = eb - 16 | 0;
   eb = d;
   f = v[e + 8 >> 2];
   b = d + 4 | 0;
   v[b + 8 >> 2] = e + 8;
   v[b >> 2] = f;
   v[b + 4 >> 2] = f + (c << 3);
   c = v[b >> 2];
   while (1) {
    if (v[b + 4 >> 2] != (c | 0)) {
     Zk(c);
     c = v[b >> 2] + 8 | 0;
     v[b >> 2] = c;
     continue;
    }
    break;
   }
   ie(b);
   eb = d + 16 | 0;
   h = eb - 16 | 0;
   eb = h;
   b = ub(h + 12 | 0, v[a + 4 >> 2]);
   d = ub(h + 8 | 0, v[a >> 2]);
   g = v[ub(h + 4 | 0, v[e + 4 >> 2]) >> 2];
   i = eb - 16 | 0;
   eb = i;
   c = eb - 32 | 0;
   eb = c;
   ed(c + 24 | 0, v[b >> 2], v[d >> 2]);
   k = c + 16 | 0;
   b = v[c + 24 >> 2];
   l = v[c + 28 >> 2];
   f = eb - 16 | 0;
   eb = f;
   v[f + 8 >> 2] = g;
   v[f + 12 >> 2] = b;
   while (1) {
    if (Ed(b, l)) {
     d = Ip(b);
     g = Ip(v[f + 8 >> 2]);
     b = w[d + 4 | 0] | w[d + 5 | 0] << 8 | (w[d + 6 | 0] << 16 | w[d + 7 | 0] << 24);
     d = w[d | 0] | w[d + 1 | 0] << 8 | (w[d + 2 | 0] << 16 | w[d + 3 | 0] << 24);
     t[g | 0] = d;
     t[g + 1 | 0] = d >>> 8;
     t[g + 2 | 0] = d >>> 16;
     t[g + 3 | 0] = d >>> 24;
     t[g + 4 | 0] = b;
     t[g + 5 | 0] = b >>> 8;
     t[g + 6 | 0] = b >>> 16;
     t[g + 7 | 0] = b >>> 24;
     b = gs(f + 12 | 0);
     gs(f + 8 | 0);
     b = v[b >> 2];
     continue;
    }
    break;
   }
   pc(k, b, f + 8 | 0);
   eb = f + 16 | 0;
   b = v[c + 16 >> 2];
   v[c + 12 >> 2] = v[c + 20 >> 2];
   pc(i + 8 | 0, b, c + 12 | 0);
   eb = c + 32 | 0;
   eb = i + 16 | 0;
   v[e + 4 >> 2] = v[i + 12 >> 2];
   Sb(a, e + 4 | 0);
   Sb(a + 4 | 0, e + 8 | 0);
   Sb(zb(a), mc(e));
   v[e >> 2] = v[e + 4 >> 2];
   eb = h + 16 | 0;
   is(e);
  }
  eb = j + 32 | 0;
  return;
 }
 if (b >>> 0 < e >>> 0) {
  Id(a, c + (b << 3) | 0);
 }
}

function joa(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, z = 0;
 i = eb - 16 | 0;
 eb = i;
 md(d, 32);
 h = i + 8 | 0;
 $V(h, w[a + 24 | 0] | w[a + 25 | 0] << 8 | (w[a + 26 | 0] << 16 | w[a + 27 | 0] << 24), w[a + 28 | 0] | w[a + 29 | 0] << 8 | (w[a + 30 | 0] << 16 | w[a + 31 | 0] << 24), v[b >> 2]);
 h = fc(h);
 $V(i, w[a + 40 | 0] | w[a + 41 | 0] << 8 | (w[a + 42 | 0] << 16 | w[a + 43 | 0] << 24), w[a + 44 | 0] | w[a + 45 | 0] << 8 | (w[a + 46 | 0] << 16 | w[a + 47 | 0] << 24), v[c >> 2]);
 a = 0;
 a: {
  h = v[h >> 2];
  if (h - 838861 >>> 0 < 4294128436) {
   break a;
  }
  e = v[fc(i) >> 2];
  v[d >> 2] = B(h, 320);
  u[d + 34 >> 1] = 1;
  if (!Fh(d)) {
   break a;
  }
  k = h << 2;
  f = +(k >>> 0);
  o = +(e >>> 0) / f;
  p = +(h >>> 0) / f;
  q = 1 / +y[d >> 2];
  r = +y[i >> 2];
  s = +y[i + 8 >> 2];
  h = 0;
  b: while (1) {
   if ((h | 0) == (k | 0)) {
    a = 1;
    break a;
   }
   l = +(h >>> 0);
   m = 0;
   n = 0;
   e = v[b + 20 >> 2];
   if (ke(v[b >> 2], e)) {
    f = l * p + s;
    c: {
     if (f < 4294967296 & f >= 0) {
      g = ~~f >>> 0;
      break c;
     }
     g = 0;
    }
    a = g;
    f = f - +(a >>> 0);
    j = x[b + 34 >> 1];
    a = Zd(j);
    g = B(g, a);
    d: {
     if (j & 1) {
      e = e + (g << 1) | 0;
      a = x[e + (a << 1) >> 1];
      e = x[e >> 1];
      break d;
     }
     g = e + g | 0;
     e = w[g | 0] << 8;
     a = w[a + g | 0] << 8;
    }
    n = +(e << 16 >> 16) * (1 - f) + f * +(a << 16 >> 16);
   }
   e = v[c + 20 >> 2];
   if (ke(v[c >> 2], e)) {
    f = l * o + r;
    e: {
     if (f < 4294967296 & f >= 0) {
      g = ~~f >>> 0;
      break e;
     }
     g = 0;
    }
    a = g;
    f = f - +(a >>> 0);
    j = x[c + 34 >> 1];
    a = Zd(j);
    g = B(g, a);
    f: {
     if (j & 1) {
      e = e + (g << 1) | 0;
      a = x[e + (a << 1) >> 1];
      e = x[e >> 1];
      break f;
     }
     g = e + g | 0;
     e = w[g | 0] << 8;
     a = w[a + g | 0] << 8;
    }
    m = +(e << 16 >> 16) * (1 - f) + f * +(a << 16 >> 16);
   }
   e = 0;
   a = h;
   while (1) if ((e | 0) == 80) {
    h = h + 1 | 0;
    continue b;
   } else {
    f = q * +(a >>> 0);
    t = v[d + 20 >> 2] + (a << 1) | 0, z = vC(n * (1 - f) + m * f), u[t >> 1] = z;
    a = a + k | 0;
    e = e + 1 | 0;
    continue;
   }
  }
 }
 eb = i + 16 | 0;
 return a | 0;
}

function ija(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0;
 m = eb - 32 | 0;
 eb = m;
 e = b;
 b = v[a >> 2];
 h = B(xu(e, vb(b)), 6) + b | 0;
 a: {
  if (!c) {
   break a;
  }
  b = v[zb(a) >> 2];
  i = v[a + 4 >> 2];
  if ((b - i | 0) / 6 >>> 0 >= c >>> 0) {
   b = c;
   e = (i - h | 0) / 6 | 0;
   if (e >>> 0 < c >>> 0) {
    yD(a, c - e | 0, d);
    b = e;
    if ((h | 0) == (i | 0)) {
     break a;
    }
   }
   n = eb - 16 | 0;
   eb = n;
   o = v[a + 4 >> 2];
   g = (o - (B(c, 6) + h | 0) | 0) + h | 0;
   f = Cr(n + 4 | 0, a, (i - g | 0) / 6 | 0);
   k = v[f + 4 >> 2];
   e = g;
   while (1) {
    if (e >>> 0 >= i >>> 0) {
     hc(f);
     i = eb - 16 | 0;
     eb = i;
     j = eb - 32 | 0;
     eb = j;
     ed(j + 24 | 0, h, g);
     l = eb - 16 | 0;
     eb = l;
     k = v[j + 28 >> 2];
     f = v[j + 24 >> 2];
     g = (k - f | 0) / 6 | 0;
     e = o + B(g, -6) | 0;
     v[l + 12 >> 2] = e;
     iR(e, f, g);
     pc(j + 16 | 0, k, l + 12 | 0);
     eb = l + 16 | 0;
     e = v[j + 16 >> 2];
     v[j + 12 >> 2] = v[j + 20 >> 2];
     pc(i + 8 | 0, e, j + 12 | 0);
     eb = j + 32 | 0;
     eb = i + 16 | 0;
     eb = n + 16 | 0;
    } else {
     tD(k, e);
     k = k + 6 | 0;
     v[f + 4 >> 2] = k;
     e = e + 6 | 0;
     continue;
    }
    break;
   }
   e = h;
   c = B(e >>> 0 <= d >>> 0 ? y[a + 4 >> 2] > d >>> 0 ? c : 0 : 0, 6) + d | 0;
   while (1) {
    if (b) {
     a = w[c | 0] | w[c + 1 | 0] << 8 | (w[c + 2 | 0] << 16 | w[c + 3 | 0] << 24);
     t[e | 0] = a;
     t[e + 1 | 0] = a >>> 8;
     t[e + 2 | 0] = a >>> 16;
     t[e + 3 | 0] = a >>> 24;
     a = w[c + 4 | 0] | w[c + 5 | 0] << 8;
     t[e + 4 | 0] = a;
     t[e + 5 | 0] = a >>> 8;
     b = b - 1 | 0;
     e = e + 6 | 0;
     continue;
    }
    break;
   }
   break a;
  }
  b = zb(a);
  f = jZ(m + 12 | 0, uD(a, Fk(v[a >> 2], i) + c | 0), (h - v[a >> 2] | 0) / 6 | 0, b);
  iZ(f, c, d);
  g = eb - 16 | 0;
  eb = g;
  b = v[f + 4 >> 2];
  e = ub(g + 12 | 0, h);
  d = ub(g + 8 | 0, v[a >> 2]);
  c = ub(g + 4 | 0, v[f + 4 >> 2]);
  p = f, q = fZ(v[e >> 2], v[d >> 2], v[c >> 2]), v[p + 4 >> 2] = q;
  p = f, q = hR(h, v[a + 4 >> 2], v[f + 8 >> 2]), v[p + 8 >> 2] = q;
  Sb(a, f + 4 | 0);
  Sb(a + 4 | 0, f + 8 | 0);
  Sb(zb(a), mc(f));
  v[f >> 2] = v[f + 4 >> 2];
  eb = g + 16 | 0;
  h = b;
  hZ(f);
 }
 vb(h);
 eb = m + 32 | 0;
}

function _ja(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0;
 i = eb - 16 | 0;
 eb = i;
 d = v[b + 1298304 >> 2];
 if (!Dd(d)) {
  c = eb - 16 | 0;
  eb = c;
  d = Dc(12);
  v[31601] = 0;
  g = Q(950, d | 0) | 0;
  e = v[31601];
  v[31601] = 0;
  a: {
   if ((e | 0) != 1) {
    d = xf(c + 12 | 0, g);
    eb = c + 16 | 0;
    c = v[d >> 2];
    break a;
   }
   a = M() | 0;
   Bb(d);
   P(a | 0);
   p();
  }
  v[i + 12 >> 2] = c;
  c = b + 1298304 | 0;
  d = i + 12 | 0;
  hS(c, me(d));
  YA(d);
  d = v[c >> 2];
 }
 g = eb - 32 | 0;
 eb = g;
 c = g + 8 | 0;
 XR(c, a);
 v[31601] = 0;
 N(951, g + 20 | 0, c | 0);
 e = v[31601];
 v[31601] = 0;
 b: {
  c: {
   if ((e | 0) != 1) {
    sb(c);
    e = vb(v[d >> 2]);
    v[g + 4 >> 2] = e;
    l = vb(v[d + 4 >> 2]);
    d = 0;
    while (1) {
     d: {
      if (!Hb(e, l)) {
       e: {
        if (!d) {
         break e;
        }
        f = v[d + 4 >> 2];
        if (!f) {
         break e;
        }
        v[31601] = 0;
        b = T(f | 0, d | 0, b | 0, a | 0) | 0;
        f = v[31601];
        v[31601] = 0;
        if ((f | 0) == 1) {
         break d;
        }
        if (b) {
         f = v[d >> 2];
         v[b + 4 >> 2] = f;
         if (f) {
          v[f + 8 >> 2] = b;
         }
         v[d >> 2] = b;
        }
        v[a >> 2] = b;
       }
       sb(g + 20 | 0);
       eb = g + 32 | 0;
       break b;
      }
      j = 0;
      c = v[e >> 2];
      if (v[c + 32 >> 2] == v[a + 16 >> 2]) {
       j = v[c + 36 >> 2] == v[a + 20 >> 2];
      }
      v[31601] = 0;
      k = g + 8 | 0;
      N(952, k | 0, c + 8 | 0);
      c = v[31601];
      v[31601] = 0;
      if ((c | 0) != 1) {
       h = eb - 16 | 0;
       eb = h;
       ee(h + 8 | 0, k);
       ee(h, g + 20 | 0);
       c = zR(v[h + 8 >> 2], v[h + 12 >> 2], v[h >> 2], v[h + 4 >> 2]);
       eb = h + 16 | 0;
       sb(k);
       f: {
        if (!(!j | (c | 0) != 0)) {
         d = v[e >> 2];
         f = 3;
         break f;
        }
        if ((f | 0) < 2 & j) {
         d = v[e >> 2];
         f = 2;
         break f;
        }
        c = !c & (f | 0) <= 0;
        d = c ? v[e >> 2] : d;
        f = c ? 1 : f;
       }
       e = v[Xe(g + 4 | 0) >> 2];
       continue;
      }
     }
     break;
    }
    e = M() | 0;
    sb(g + 20 | 0);
    break c;
   }
   e = M() | 0;
   sb(g + 8 | 0);
  }
  P(e | 0);
  p();
 }
 eb = i + 16 | 0;
}

function N7(a, b, c, d, e, f, g) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 f = f | 0;
 g = g | 0;
 var h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
 k = eb - 16 | 0;
 eb = k;
 l = Sy(v[g >> 2]);
 g = Fy(v[g >> 2]);
 rh(k + 4 | 0, g);
 a: {
  b: {
   if (zd(v[k + 8 >> 2], w[k + 15 | 0])) {
    v[31601] = 0;
    U(1262, l | 0, a | 0, c | 0, d | 0);
    g = v[31601];
    v[31601] = 0;
    if ((g | 0) == 1) {
     break b;
    }
    g = (c - a << 2) + d | 0;
    v[f >> 2] = g;
    break a;
   }
   v[f >> 2] = d;
   c: {
    d: {
     j = a;
     h = w[j | 0];
     switch (h - 43 | 0) {
     case 0:
     case 2:
      break d;

     default:
      break c;
     }
    }
    v[31601] = 0;
    j = O(1269, l | 0, h << 24 >> 24) | 0;
    h = v[31601];
    v[31601] = 0;
    if ((h | 0) == 1) {
     break b;
    }
    h = v[f >> 2];
    v[f >> 2] = h + 4;
    v[h >> 2] = j;
    j = a + 1 | 0;
   }
   if (!(w[j | 0] != 48 | (c - j | 0) < 2 | (w[j + 1 | 0] | 32) != 120)) {
    v[31601] = 0;
    h = O(1269, l | 0, 48) | 0;
    i = v[31601];
    v[31601] = 0;
    if ((i | 0) == 1) {
     break b;
    }
    i = v[f >> 2];
    v[f >> 2] = i + 4;
    v[i >> 2] = h;
    h = t[j + 1 | 0];
    v[31601] = 0;
    h = O(1269, l | 0, h | 0) | 0;
    i = v[31601];
    v[31601] = 0;
    if ((i | 0) == 1) {
     break b;
    }
    i = v[f >> 2];
    v[f >> 2] = i + 4;
    v[i >> 2] = h;
    j = j + 2 | 0;
   }
   Bm(j, c);
   i = 0;
   v[31601] = 0;
   o = Q(1260, g | 0) | 0;
   g = v[31601];
   v[31601] = 0;
   if ((g | 0) == 1) {
    break b;
   }
   h = 0;
   g = j;
   while (1) {
    if (c >>> 0 <= g >>> 0) {
     vt((j - a << 2) + d | 0, v[f >> 2]);
     g = v[f >> 2];
     break a;
    }
    e: {
     if (!w[dc(k + 4 | 0, h) | 0]) {
      break e;
     }
     if (t[dc(k + 4 | 0, h) | 0] != (i | 0)) {
      break e;
     }
     i = v[f >> 2];
     v[f >> 2] = i + 4;
     v[i >> 2] = o;
     h = (Cb(v[k + 8 >> 2], w[k + 15 | 0]) - 1 >>> 0 > h >>> 0) + h | 0;
     i = 0;
    }
    n = t[g | 0];
    v[31601] = 0;
    n = O(1269, l | 0, n | 0) | 0;
    m = v[31601];
    v[31601] = 0;
    if ((m | 0) != 1) {
     m = v[f >> 2];
     v[f >> 2] = m + 4;
     v[m >> 2] = n;
     g = g + 1 | 0;
     i = i + 1 | 0;
     continue;
    }
    break;
   }
  }
  a = M() | 0;
  sb(k + 4 | 0);
  P(a | 0);
  p();
 }
 v[e >> 2] = (b | 0) == (c | 0) ? g : (b - a << 2) + d | 0;
 sb(k + 4 | 0);
 eb = k + 16 | 0;
}

function b3(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0;
 d = eb - 2096 | 0;
 eb = d;
 wu(d + 48 | 0);
 a: {
  b: {
   c: {
    if (Ep(v[(v[v[c >> 2] - 12 >> 2] + c | 0) + 16 >> 2])) {
     a = cc(8);
     v[31601] = 0;
     c = O(36, d + 36 | 0, 10453) | 0;
     b = v[31601];
     v[31601] = 0;
     if ((b | 0) != 1) {
      rc(a, c);
      v[31601] = 0;
      R(97, a | 0, 48396, 999);
      a = v[31601];
      v[31601] = 0;
      if ((a | 0) != 1) {
       break b;
      }
      b = M() | 0;
      sb(c);
      break c;
     }
     b = M() | 0;
     jc(a);
     break c;
    }
    g = iM(c);
    if (g) {
     b = fM(c);
    } else {
     b = 0;
    }
    v[d + 24 >> 2] = b;
    v[d + 28 >> 2] = 0;
    h = c + 16 | 0;
    b = 2048;
    d: {
     while (1) {
      e: {
       if (!b) {
        break e;
       }
       if (!hM(v[v[v[c >> 2] - 12 >> 2] + h >> 2])) {
        break e;
       }
       e = v[v[v[uj(c, (d + 48 | 0) + f | 0, b) >> 2] - 12 >> 2] + h >> 2];
       if (Ep(e)) {
        a = cc(8);
        v[31601] = 0;
        c = O(36, d + 36 | 0, 10453) | 0;
        b = v[31601];
        v[31601] = 0;
        if ((b | 0) == 1) {
         break d;
        }
        rc(a, c);
        v[31601] = 0;
        R(97, a | 0, 48396, 999);
        a = v[31601];
        v[31601] = 0;
        if ((a | 0) != 1) {
         break b;
        }
        b = M() | 0;
        sb(c);
        break c;
       }
       f: {
        if (TF(e)) {
         break f;
        }
        if (!mk(e)) {
         break f;
        }
        a = cc(8);
        v[31601] = 0;
        c = O(36, d + 36 | 0, 10453) | 0;
        b = v[31601];
        v[31601] = 0;
        if ((b | 0) != 1) {
         rc(a, c);
         v[31601] = 0;
         R(97, a | 0, 48396, 999);
         a = v[31601];
         v[31601] = 0;
         if ((a | 0) != 1) {
          break b;
         }
         b = M() | 0;
         sb(c);
         break c;
        }
        b = M() | 0;
        jc(a);
        break c;
       }
       e = v[c + 4 >> 2];
       b = b - e | 0;
       f = e + f | 0;
       continue;
      }
      break;
     }
     b = Yb(d + 16 | 0, d + 48 | 0, f);
     c = v[b + 4 >> 2];
     v[d + 8 >> 2] = v[b >> 2];
     v[d + 12 >> 2] = c;
     a = Bu(a, d + 8 | 0, g ? d + 24 | 0 : 0);
     eb = d + 2096 | 0;
     break a;
    }
    b = M() | 0;
    jc(a);
   }
   P(b | 0);
  }
  p();
 }
 return a | 0;
}

function X7(a, b, c, d, e, f, g) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 f = f | 0;
 g = g | 0;
 var h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
 k = eb - 16 | 0;
 eb = k;
 l = Fw(v[g >> 2]);
 g = My(v[g >> 2]);
 rh(k + 4 | 0, g);
 a: {
  b: {
   if (zd(v[k + 8 >> 2], w[k + 15 | 0])) {
    v[31601] = 0;
    U(1248, l | 0, a | 0, c | 0, d | 0);
    g = v[31601];
    v[31601] = 0;
    if ((g | 0) == 1) {
     break b;
    }
    g = (c - a | 0) + d | 0;
    v[f >> 2] = g;
    break a;
   }
   v[f >> 2] = d;
   c: {
    d: {
     j = a;
     h = w[j | 0];
     switch (h - 43 | 0) {
     case 0:
     case 2:
      break d;

     default:
      break c;
     }
    }
    v[31601] = 0;
    j = O(29, l | 0, h << 24 >> 24) | 0;
    h = v[31601];
    v[31601] = 0;
    if ((h | 0) == 1) {
     break b;
    }
    h = v[f >> 2];
    v[f >> 2] = h + 1;
    t[h | 0] = j;
    j = a + 1 | 0;
   }
   if (!(w[j | 0] != 48 | (c - j | 0) < 2 | (w[j + 1 | 0] | 32) != 120)) {
    v[31601] = 0;
    h = O(29, l | 0, 48) | 0;
    i = v[31601];
    v[31601] = 0;
    if ((i | 0) == 1) {
     break b;
    }
    i = v[f >> 2];
    v[f >> 2] = i + 1;
    t[i | 0] = h;
    h = t[j + 1 | 0];
    v[31601] = 0;
    h = O(29, l | 0, h | 0) | 0;
    i = v[31601];
    v[31601] = 0;
    if ((i | 0) == 1) {
     break b;
    }
    i = v[f >> 2];
    v[f >> 2] = i + 1;
    t[i | 0] = h;
    j = j + 2 | 0;
   }
   Bm(j, c);
   i = 0;
   v[31601] = 0;
   o = Q(1246, g | 0) | 0;
   g = v[31601];
   v[31601] = 0;
   if ((g | 0) == 1) {
    break b;
   }
   h = 0;
   g = j;
   while (1) {
    if (c >>> 0 <= g >>> 0) {
     Bm((j - a | 0) + d | 0, v[f >> 2]);
     g = v[f >> 2];
     break a;
    }
    e: {
     if (!w[dc(k + 4 | 0, h) | 0]) {
      break e;
     }
     if (t[dc(k + 4 | 0, h) | 0] != (i | 0)) {
      break e;
     }
     i = v[f >> 2];
     v[f >> 2] = i + 1;
     t[i | 0] = o;
     h = (Cb(v[k + 8 >> 2], w[k + 15 | 0]) - 1 >>> 0 > h >>> 0) + h | 0;
     i = 0;
    }
    n = t[g | 0];
    v[31601] = 0;
    n = O(29, l | 0, n | 0) | 0;
    m = v[31601];
    v[31601] = 0;
    if ((m | 0) != 1) {
     m = v[f >> 2];
     v[f >> 2] = m + 1;
     t[m | 0] = n;
     g = g + 1 | 0;
     i = i + 1 | 0;
     continue;
    }
    break;
   }
  }
  a = M() | 0;
  sb(k + 4 | 0);
  P(a | 0);
  p();
 }
 v[e >> 2] = (b | 0) == (c | 0) ? g : (b - a | 0) + d | 0;
 sb(k + 4 | 0);
 eb = k + 16 | 0;
}

function KA(a, b, c) {
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0;
 i = HR(b, c);
 a: {
  if (!v[b + 656 >> 2] | !(t[i + 6 | 0] & 1)) {
   break a;
  }
  e = v[i >> 2];
  j = a + 1074312 | 0;
  f = Nb(j, 31);
  d = Nw(v[b + 656 >> 2], c);
  if (lc(v[d >> 2], v[d + 4 >> 2])) {
   break a;
  }
  f = (f ^ 1) + e | 0;
  g = Nb(j, 31);
  e = w[d + 12 | 0];
  b: {
   c: {
    if (!g) {
     d: {
      if (!(e & 2)) {
       break d;
      }
      h = w[d + 14 | 0];
      k = !(v[a + 480180 >> 2] & 1048580) + x[xb(v[d >> 2], h) >> 1] | 0;
      g = 0;
      if (!(!(w[b + 89 | 0] & 8) | (!(e & 4) | (h | 0) != w[d + 16 | 0]))) {
       g = Nb(j, 70);
      }
      if (g | (f | 0) != (k | 0)) {
       break d;
      }
      f = x[xb(v[d >> 2], w[d + 13 | 0]) >> 1];
     }
     if (!(!(w[d + 12 | 0] & 4) | w[b + 89 | 0] & 8)) {
      a = v[d >> 2];
      if ((x[xb(a, w[d + 16 | 0]) >> 1] + 1 | 0) != (f | 0)) {
       break b;
      }
      f = x[xb(a, w[d + 15 | 0]) >> 1];
      if (!Nb(j, 93) | (c | 0) != 1 | w[b + 89 | 0] & 8) {
       break b;
      }
      t[i + 6 | 0] = w[i + 6 | 0] & 254;
      break b;
     }
     h = 0;
     e = x[wf(v[d + 4 >> 2]) >> 1];
     if (f >>> 0 > e >>> 0) {
      break c;
     }
     break b;
    }
    e: {
     f: {
      if (!(!(e & 4) | w[b + 669 | 0] & 8)) {
       if (x[i + 4 >> 1] == 65535) {
        break f;
       }
       if (Nb(j, 97)) {
        break f;
       }
       e = w[d + 12 | 0];
      }
      if (e & 2) {
       g = v[d >> 2];
       e = x[xb(g, w[d + 13 | 0]) >> 1];
       h = 1;
       g = x[xb(g, w[d + 14 | 0]) >> 1] + 1 | 0;
       break e;
      }
      e = x[wf(v[d + 4 >> 2]) >> 1];
      h = f >>> 0 <= e >>> 0;
      g = e;
      break e;
     }
     g = v[d >> 2];
     e = x[xb(g, w[d + 15 | 0]) >> 1];
     h = 1;
     g = x[xb(g, w[d + 16 | 0]) >> 1] + 1 | 0;
    }
    e = f >>> 0 < g >>> 0 ? f : e;
   }
   g: {
    if (c | h) {
     break g;
    }
    f = v[a + 480180 >> 2];
    c = v[b + 88 >> 2];
    if (!(!(f & 16777248) & (!(c & 2048) | (f | 0) == 16384))) {
     c = c | 4096;
     v[b + 88 >> 2] = c;
    }
    if (w[wf(v[d + 4 >> 2]) + 2 | 0] | !(x[b + 786 >> 1] | v[a + 480180 >> 2] & 16777248)) {
     break g;
    }
    v[b + 696 >> 2] = 0;
    v[b + 720 >> 2] = 0;
    v[b + 680 >> 2] = 0;
    v[b + 88 >> 2] = c | 4096;
   }
   f = e;
  }
  l = i, m = Nb(j, 31) + f | 0, v[l >> 2] = m;
 }
}

function s3(a, b, c, d, e) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 var f = 0, g = 0, h = 0;
 if (kh(a, v[b + 8 >> 2], e)) {
  Vx(b, c, d);
  return;
 }
 a: {
  if (kh(a, v[b >> 2], e)) {
   if (!(v[b + 16 >> 2] != (c | 0) & v[b + 20 >> 2] != (c | 0))) {
    if ((d | 0) != 1) {
     break a;
    }
    v[b + 32 >> 2] = 1;
    return;
   }
   v[b + 32 >> 2] = d;
   b: {
    if (v[b + 44 >> 2] == 4) {
     break b;
    }
    f = a + 16 | 0;
    h = f + (v[a + 12 >> 2] << 3) | 0;
    d = 0;
    c: {
     while (1) {
      d: {
       if (f >>> 0 >= h >>> 0) {
        break d;
       }
       u[b + 52 >> 1] = 0;
       Sx(v[f >> 2], v[f + 4 >> 2], b, c, c, 1, e);
       if (w[b + 54 | 0]) {
        break d;
       }
       e: {
        if (!w[b + 53 | 0]) {
         break e;
        }
        if (w[b + 52 | 0]) {
         if (v[b + 24 >> 2] != 1) {
          d = 1;
          g = 1;
          if (w[a + 8 | 0] & 2) {
           break e;
          }
         }
         v[b + 44 >> 2] = 3;
         return;
        }
        d = 1;
        if (!(t[a + 8 | 0] & 1)) {
         break c;
        }
       }
       f = f + 8 | 0;
       continue;
      }
      break;
     }
     v[b + 44 >> 2] = d ? 3 : 4;
     if (!g) {
      break b;
     }
     break a;
    }
    v[b + 44 >> 2] = 3;
    if (g) {
     break a;
    }
   }
   v[b + 20 >> 2] = c;
   v[b + 40 >> 2] = v[b + 40 >> 2] + 1;
   if (v[b + 36 >> 2] != 1 | v[b + 24 >> 2] != 2) {
    break a;
   }
   t[b + 54 | 0] = 1;
   return;
  }
  f = v[a + 12 >> 2];
  g = a + 16 | 0;
  Ps(v[g >> 2], v[a + 20 >> 2], b, c, d, e);
  if ((f | 0) < 2) {
   break a;
  }
  g = g + (f << 3) | 0;
  f = a + 24 | 0;
  a = v[a + 8 >> 2];
  if (!(!(a & 2) & v[b + 36 >> 2] != 1)) {
   while (1) {
    if (w[b + 54 | 0]) {
     break a;
    }
    Ps(v[f >> 2], v[f + 4 >> 2], b, c, d, e);
    f = f + 8 | 0;
    if (g >>> 0 > f >>> 0) {
     continue;
    }
    break;
   }
   break a;
  }
  if (!(a & 1)) {
   while (1) {
    if (w[b + 54 | 0] | v[b + 36 >> 2] == 1) {
     break a;
    }
    Ps(v[f >> 2], v[f + 4 >> 2], b, c, d, e);
    f = f + 8 | 0;
    if (g >>> 0 > f >>> 0) {
     continue;
    }
    break a;
   }
  }
  while (1) {
   if (w[b + 54 | 0] | v[b + 36 >> 2] == 1 & v[b + 24 >> 2] == 1) {
    break a;
   }
   Ps(v[f >> 2], v[f + 4 >> 2], b, c, d, e);
   f = f + 8 | 0;
   if (g >>> 0 > f >>> 0) {
    continue;
   }
   break;
  }
 }
}

function _ma(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, w = 0, x = 0, y = 0, z = 0, A = 0, C = 0, D = 0, E = 0, F = 0, G = 0;
 b = eb - 48 | 0;
 eb = b;
 s = v[a + 16 >> 2];
 m = jg(1, 2);
 f = gb;
 t = f;
 Ob(a, m, f);
 v[b + 32 >> 2] = v[a + 44 >> 2];
 v[b + 36 >> 2] = v[a + 48 >> 2];
 v[b + 40 >> 2] = v[a + 52 >> 2];
 v[b + 44 >> 2] = v[a + 56 >> 2];
 j = v[a + 40 >> 2];
 k = v[a + 36 >> 2];
 f = v[a + 4 >> 2];
 v[b + 16 >> 2] = v[a >> 2];
 v[b + 20 >> 2] = f;
 w = b + 32 | 0;
 x = v[a + 32 >> 2];
 y = v[a + 28 >> 2];
 z = v[a + 72 >> 2];
 n = v[a + 68 >> 2];
 A = n >> 31;
 o = v[a + 64 >> 2];
 C = o >> 31;
 p = v[a + 60 >> 2];
 D = p >> 31;
 E = v[a + 8 >> 2];
 F = v[a + 12 >> 2];
 while (1) {
  if (d) {
   d = d - 1 | 0;
   f = v[b + 16 >> 2];
   f = ((((v[b + 20 >> 2] & 2147483647) << 1 | f >>> 31) & 2147483646) << 1) + s | 0;
   v[b + 8 >> 2] = u[f >> 1];
   v[b + 12 >> 2] = u[f + 2 >> 1];
   l = 0;
   while (1) {
    if ((l | 0) != 2) {
     q = (b + 8 | 0) + (l << 2) | 0;
     e = v[q >> 2];
     f = (l << 3) + w | 0;
     G = v[f + 4 >> 2];
     g = v[f >> 2];
     v[f + 4 >> 2] = g;
     r = e << 8;
     e = r;
     e = Aua(e, e >> 31, p, D);
     h = gb;
     i = e;
     e = Xb(g, -16777216, 16776704);
     e = Aua(o, C, e, e >> 31);
     g = i + e | 0;
     i = gb + h | 0;
     i = e >>> 0 > g >>> 0 ? i + 1 | 0 : i;
     e = Xb(G, -16777216, 16776704);
     h = Aua(n, A, e, e >> 31);
     g = h + g | 0;
     e = gb + i | 0;
     e = g >>> 0 < h >>> 0 ? e + 1 | 0 : e;
     h = g + 8388608 | 0;
     e = h >>> 0 < 8388608 ? e + 1 | 0 : e;
     e = Rc(h, e, 24);
     v[f >> 2] = e - (z & r);
     v[q >> 2] = (e | 0) / 256;
     l = l + 1 | 0;
     continue;
    }
    break;
   }
   k = k + y | 0;
   v[c >> 2] = v[c >> 2] + B(v[b + 8 >> 2], k >> 12);
   j = j + x | 0;
   v[c + 4 >> 2] = v[c + 4 >> 2] + B(v[b + 12 >> 2], j >> 12);
   Ob(b + 16 | 0, E, F);
   c = c + 8 | 0;
   continue;
  }
  break;
 }
 c = v[b + 20 >> 2];
 v[a >> 2] = v[b + 16 >> 2];
 v[a + 4 >> 2] = c;
 v[a + 40 >> 2] = j;
 v[a + 20 >> 2] = k >> 12;
 v[a + 36 >> 2] = k;
 v[a + 24 >> 2] = j >> 12;
 v[a + 44 >> 2] = v[b + 32 >> 2];
 v[a + 48 >> 2] = v[b + 36 >> 2];
 v[a + 52 >> 2] = v[b + 40 >> 2];
 v[a + 56 >> 2] = v[b + 44 >> 2];
 Hg(a, m, t);
 eb = b + 48 | 0;
}

function $ma(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, u = 0, w = 0, x = 0, y = 0, z = 0, A = 0, C = 0, D = 0, E = 0, F = 0, G = 0;
 b = eb - 48 | 0;
 eb = b;
 s = v[a + 16 >> 2];
 m = jg(1, 2);
 f = gb;
 u = f;
 Ob(a, m, f);
 v[b + 32 >> 2] = v[a + 44 >> 2];
 v[b + 36 >> 2] = v[a + 48 >> 2];
 v[b + 40 >> 2] = v[a + 52 >> 2];
 v[b + 44 >> 2] = v[a + 56 >> 2];
 j = v[a + 40 >> 2];
 k = v[a + 36 >> 2];
 f = v[a + 4 >> 2];
 v[b + 16 >> 2] = v[a >> 2];
 v[b + 20 >> 2] = f;
 w = b + 32 | 0;
 x = v[a + 32 >> 2];
 y = v[a + 28 >> 2];
 z = v[a + 72 >> 2];
 n = v[a + 68 >> 2];
 A = n >> 31;
 o = v[a + 64 >> 2];
 C = o >> 31;
 p = v[a + 60 >> 2];
 D = p >> 31;
 E = v[a + 8 >> 2];
 F = v[a + 12 >> 2];
 while (1) {
  if (d) {
   d = d - 1 | 0;
   f = v[b + 16 >> 2];
   f = (((v[b + 20 >> 2] & 2147483647) << 1 | f >>> 31) & -2) + s | 0;
   v[b + 8 >> 2] = t[f | 0] << 8;
   v[b + 12 >> 2] = t[f + 1 | 0] << 8;
   l = 0;
   while (1) {
    if ((l | 0) != 2) {
     q = (b + 8 | 0) + (l << 2) | 0;
     e = v[q >> 2];
     f = (l << 3) + w | 0;
     G = v[f + 4 >> 2];
     g = v[f >> 2];
     v[f + 4 >> 2] = g;
     r = e << 8;
     e = r;
     e = Aua(e, e >> 31, p, D);
     h = gb;
     i = e;
     e = Xb(g, -16777216, 16776704);
     e = Aua(o, C, e, e >> 31);
     g = i + e | 0;
     i = gb + h | 0;
     i = e >>> 0 > g >>> 0 ? i + 1 | 0 : i;
     e = Xb(G, -16777216, 16776704);
     h = Aua(n, A, e, e >> 31);
     g = h + g | 0;
     e = gb + i | 0;
     e = g >>> 0 < h >>> 0 ? e + 1 | 0 : e;
     h = g + 8388608 | 0;
     e = h >>> 0 < 8388608 ? e + 1 | 0 : e;
     e = Rc(h, e, 24);
     v[f >> 2] = e - (z & r);
     v[q >> 2] = (e | 0) / 256;
     l = l + 1 | 0;
     continue;
    }
    break;
   }
   k = k + y | 0;
   v[c >> 2] = v[c >> 2] + B(v[b + 8 >> 2], k >> 12);
   j = j + x | 0;
   v[c + 4 >> 2] = v[c + 4 >> 2] + B(v[b + 12 >> 2], j >> 12);
   Ob(b + 16 | 0, E, F);
   c = c + 8 | 0;
   continue;
  }
  break;
 }
 c = v[b + 20 >> 2];
 v[a >> 2] = v[b + 16 >> 2];
 v[a + 4 >> 2] = c;
 v[a + 40 >> 2] = j;
 v[a + 20 >> 2] = k >> 12;
 v[a + 36 >> 2] = k;
 v[a + 24 >> 2] = j >> 12;
 v[a + 44 >> 2] = v[b + 32 >> 2];
 v[a + 48 >> 2] = v[b + 36 >> 2];
 v[a + 52 >> 2] = v[b + 40 >> 2];
 v[a + 56 >> 2] = v[b + 44 >> 2];
 Hg(a, m, u);
 eb = b + 48 | 0;
}

function SB(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
 a: {
  e = a;
  b: {
   c: {
    h = a + 62 | 0;
    f = wb(h, b);
    a = t[f | 0];
    if ((a | 0) == -1) {
     break c;
    }
    if ((a | 0) >= 0) {
     break b;
    }
    a = a & 127;
    d = $b(e + 26 | 0, a);
    g = x[d >> 1];
    if ((g | 0) != 65535 & (b | 0) != (g | 0)) {
     break c;
    }
    u[d >> 1] = b;
    t[f | 0] = a;
    break b;
   }
   l = e + 8 | 0;
   i = e + 26 | 0;
   d = 255;
   a = 0;
   g = 255;
   d: {
    while (1) {
     if ((a | 0) == 18) {
      break d;
     }
     j = $b(i, a);
     k = x[j >> 1];
     if ((k | 0) != 65535) {
      if (!(w[wb(l, a) | 0] & 32)) {
       g = t[wb(h, k) | 0] < 0 ? a : g;
       d = a;
      }
      a = a + 1 | 0;
      continue;
     }
     break;
    }
    u[j >> 1] = b;
    t[f | 0] = a;
    break b;
   }
   if ((d & 255) != 255) {
    a = (g & 255) == 255 ? d : g;
    d = $b(i, a & 255);
    m = wb(h, x[d >> 1]), n = 255, t[m | 0] = n;
    u[d >> 1] = b;
    t[f | 0] = a;
   }
   a = Ol(e, b);
  }
  g = a & 255;
  if ((g | 0) == 255) {
   break a;
  }
  if (Ej(v[e >> 2])) {
   break a;
  }
  d = Ud(e + 318 | 0, g);
  a = w[c + 8 | 0] | w[c + 9 | 0] << 8 | (w[c + 10 | 0] << 16 | w[c + 11 | 0] << 24);
  t[d + 8 | 0] = a;
  t[d + 9 | 0] = a >>> 8;
  t[d + 10 | 0] = a >>> 16;
  t[d + 11 | 0] = a >>> 24;
  a = w[c + 4 | 0] | w[c + 5 | 0] << 8 | (w[c + 6 | 0] << 16 | w[c + 7 | 0] << 24);
  f = w[c | 0] | w[c + 1 | 0] << 8 | (w[c + 2 | 0] << 16 | w[c + 3 | 0] << 24);
  t[d | 0] = f;
  t[d + 1 | 0] = f >>> 8;
  t[d + 2 | 0] = f >>> 16;
  t[d + 3 | 0] = f >>> 24;
  t[d + 4 | 0] = a;
  t[d + 5 | 0] = a >>> 8;
  t[d + 6 | 0] = a >>> 16;
  t[d + 7 | 0] = a >>> 24;
  f = AU(g);
  h = f + 3 | 0;
  a = 0;
  while (1) {
   if ((a | 0) == 2) {
    zh(v[e >> 2], v[e + 4 >> 2], b, cv(g) | 192, w[wb(c, 10) | 0]);
   } else {
    d = a ? h : f;
    zh(v[e >> 2], v[e + 4 >> 2], b, (d | 32) & 65535, w[wb(c, a) | 0]);
    zh(v[e >> 2], v[e + 4 >> 2], b, (d | 64) & 65535, w[wb(c, a | 2) | 0]);
    zh(v[e >> 2], v[e + 4 >> 2], b, (d | 96) & 65535, w[wb(c, a | 4) | 0]);
    zh(v[e >> 2], v[e + 4 >> 2], b, (d | 128) & 65535, w[wb(c, a | 6) | 0]);
    zh(v[e >> 2], v[e + 4 >> 2], b, (d | 224) & 65535, w[wb(c, a | 8) | 0]);
    a = a + 1 | 0;
    continue;
   }
   break;
  }
 }
}

function ZX(a, b) {
 var c = 0;
 a: {
  b: {
   c: {
    if (ne(a, 16744)) {
     break c;
    }
    if (ne(a, 17511)) {
     break c;
    }
    if (ne(a, 13681)) {
     break c;
    }
    if (ne(a, 13761)) {
     break c;
    }
    if (!ne(a, 14243)) {
     break b;
    }
   }
   u[b + 10 >> 1] = 4;
   v[b >> 2] = 12036;
   break a;
  }
  d: {
   e: {
    if (ne(a, 17506)) {
     break e;
    }
    if (ne(a, 13686)) {
     break e;
    }
    if (!ne(a, 16734)) {
     break d;
    }
   }
   t[b + 15 | 0] = 1;
   t[b + 12 | 0] = 1;
   v[b >> 2] = 8391;
   u[b + 10 >> 1] = 4;
   break a;
  }
  f: {
   if (!ne(a, 14281)) {
    if (!ne(a, 14286)) {
     break f;
    }
   }
   u[b + 10 >> 1] = 8;
   v[b >> 2] = 8169;
   break a;
  }
  g: {
   if (!ne(a, 15370)) {
    if (!ne(a, 15375)) {
     break g;
    }
   }
   v[b >> 2] = 17098;
   u[b + 10 >> 1] = t[a + 2 | 0] - 48;
   break a;
  }
  h: {
   if (!ne(a, 25242)) {
    if (!ne(a, 25247)) {
     break h;
    }
   }
   v[b + 4 >> 2] = 1;
   v[b >> 2] = 16904;
   u[b + 10 >> 1] = w[a | 0] == 56 ? 8 : 4;
   break a;
  }
  if (!(id(a, 15537, 3) | (w[a + 3 | 0] - 52 & 255) >>> 0 > 4)) {
   v[b >> 2] = 8509;
   a = t[a + 3 | 0];
   u[b + 8 >> 1] = 1088;
   u[b + 10 >> 1] = a - 48;
   break a;
  }
  i: {
   j: {
    if (id(a, 13699, 3)) {
     if (id(a, 13818, 3)) {
      break j;
     }
    }
    if ((w[a + 3 | 0] - 52 & 255) >>> 0 > 5) {
     break j;
    }
    t[b + 15 | 0] = 1;
    t[b + 13 | 0] = 1;
    v[b >> 2] = 8268;
    break i;
   }
   k: {
    if ((w[a | 0] - 49 & 255) >>> 0 > 8) {
     break k;
    }
    if (!id(a + 1 | 0, 13839, 3)) {
     t[b + 14 | 0] = 1;
     v[b >> 2] = 8573;
     u[b + 10 >> 1] = t[a | 0] - 48;
     break a;
    }
    c = w[a + 2 | 0] | w[a + 3 | 0] << 8;
    if ((c | 0) != 18499 & (c | 0) != 20035 | (w[a + 1 | 0] - 48 & 255) >>> 0 > 9) {
     break k;
    }
    t[b + 14 | 0] = 1;
    v[b >> 2] = 8573;
    u[b + 10 >> 1] = (t[a + 1 | 0] + B(t[a | 0], 10) | 0) - 528;
    break a;
   }
   if (!(id(a, 13572, 3) | (w[a + 3 | 0] - 49 & 255) >>> 0 > 8)) {
    v[b >> 2] = 8418;
    break i;
   }
   if (ne(a, 13911)) {
    t[b + 16 | 0] = 1;
    u[b + 10 >> 1] = 4;
    break a;
   }
   if (ne(a, 14238)) {
    t[b + 14 | 0] = 1;
    v[b >> 2] = 8573;
    u[b + 10 >> 1] = 8;
    a = 1;
   } else {
    a = 0;
   }
   return a;
  }
  u[b + 10 >> 1] = t[a + 3 | 0] - 48;
 }
 return 1;
}

function Kq(a, b, c, d) {
 var e = C(0), f = C(0), g = C(0), h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = C(0), p = 0;
 h = eb - 16 | 0;
 eb = h;
 v[h + 12 >> 2] = u[b + 780 >> 1] + w[b + 837 | 0];
 v[h + 8 >> 2] = u[b + 782 >> 1] + (w[b + 838 | 0] & 127);
 Fe(h + 12 | 0, 0, 127);
 Fe(h + 8 | 0, 0, 127);
 k = a + 1074312 | 0;
 j = Nb(k, 1);
 i = v[h + 8 >> 2];
 l = v[h + 12 >> 2];
 if (!j) {
  t[b + 838 | 0] = i;
  t[b + 837 | 0] = l;
  v[b + 780 >> 2] = 0;
 }
 m = B(d + 256 | 0, l);
 j = (m | 0) / 256 | 0;
 a: {
  if (!(i | !Nb(k, 36) | (m | 0) < 65024)) {
   j = -1;
   if (!(w[b + 851 | 0] & 2)) {
    break a;
   }
   v[b + 88 >> 2] = v[b + 88 >> 2] & -32769;
   break a;
  }
  v[b + 88 >> 2] = v[b + 88 >> 2] | 32768;
  e = De(C(10), C(C(0 - i | 0) * C(.00937500037252903)));
  i = eb - 16 | 0;
  eb = i;
  g = C(B(d + 256 | 0, l) >>> 0);
  b: {
   if (v[a + 480180 >> 2] != 33554432) {
    f = C(110);
    g = C(C(g / (w[a + 480209 | 0] & 128 ? C(10240) : C(12288))) + C(.25));
    break b;
   }
   f = C(125);
   g = C(C(g * C(6)) / C(65024));
  }
  n = i, o = C(De(C(2), g) * f), z[n + 12 >> 2] = o;
  d = i + 12 | 0;
  zT(d, C(120), C(2e4));
  CB(d, C(C(y[a + 24620 >> 2]) * C(.5)));
  eb = i + 16 | 0;
  g = C(z[i + 12 >> 2] * C(6.2831854820251465));
  c: {
   if (!(!Nb(k, 36) | w[a + 480209 | 0] & 128)) {
    f = C(C(y[a + 24620 >> 2]) / g);
    g = C(C(C(e * f) + e) + C(-1));
    e = C(f * f);
    break c;
   }
   f = C(e + e);
   e = C(g / C(y[a + 24620 >> 2]));
   z[h + 4 >> 2] = C(C(1) - f) * e;
   CB(h + 4 | 0, C(2));
   g = C(C(f - z[h + 4 >> 2]) / e);
   e = C(C(1) / C(e * e));
  }
  f = C(e + C(g + C(1)));
  g = C(C(e + C(e + g)) / f);
  e = C(C(-e) / f);
  f = C(C(1) / f);
  d: {
   if (w[b + 845 | 0] == 1) {
    n = b, p = Jl(C(C(C(1) - f) * C(16777216))), v[n + 60 >> 2] = p;
    n = b, p = Jl(C(g * C(16777216))), v[n + 64 >> 2] = p;
    n = b, p = Jl(C(e * C(16777216))), v[n + 68 >> 2] = p;
    a = -1;
    break d;
   }
   d = Jl(C(f * C(16777216)));
   v[b + 60 >> 2] = d;
   n = b, p = Jl(C(g * C(16777216))), v[n + 64 >> 2] = p;
   n = b, p = Jl(C(e * C(16777216))), v[n + 68 >> 2] = p;
   a = 0;
   if (d) {
    break d;
   }
   v[b + 60 >> 2] = 1;
  }
  v[b + 72 >> 2] = a;
  if (!c) {
   break a;
  }
  v[b + 44 >> 2] = 0;
  v[b + 48 >> 2] = 0;
  v[b + 52 >> 2] = 0;
  v[b + 56 >> 2] = 0;
 }
 eb = h + 16 | 0;
 return j;
}

function iz(a) {
 var b = 0, c = 0, d = 0, e = 0, f = 0, g = 0, h = 0;
 Je(v[a + 80 >> 2], v[a + 20 >> 2]);
 while (1) {
  c = v[a + 28 >> 2];
  if ((b | 0) < v[a + 24 >> 2]) {
   Je(v[a + 80 >> 2], v[c + (b << 2) >> 2]);
   b = b + 1 | 0;
   continue;
  }
  break;
 }
 Je(v[a + 80 >> 2], c);
 a: {
  if (!v[a + 396 >> 2]) {
   break a;
  }
  while (1) {
   if (v[a + 264 >> 2] <= (e | 0)) {
    break a;
   }
   d = v[a + 396 >> 2] + B(e, 24) | 0;
   c = v[d + 16 >> 2];
   if (c) {
    b = 0;
    while (1) {
     if ((b | 0) < v[(v[a + 124 >> 2] + B(w[d + 13 | 0], 2096) | 0) + 4 >> 2]) {
      Je(v[a + 80 >> 2], v[(b << 2) + c >> 2]);
      b = b + 1 | 0;
      c = v[d + 16 >> 2];
      continue;
     }
     break;
    }
    Je(v[a + 80 >> 2], c);
   }
   Je(v[a + 80 >> 2], v[d + 20 >> 2]);
   e = e + 1 | 0;
   continue;
  }
 }
 b = v[a + 124 >> 2];
 if (b) {
  c = 0;
  while (1) {
   if ((c | 0) < v[a + 120 >> 2]) {
    b = B(c, 2096) + b | 0;
    Je(v[a + 80 >> 2], v[b + 8 >> 2]);
    Je(v[a + 80 >> 2], v[b + 28 >> 2]);
    Je(v[a + 80 >> 2], v[b + 32 >> 2]);
    Je(v[a + 80 >> 2], v[b + 2084 >> 2]);
    b = v[b + 2088 >> 2];
    Je(v[a + 80 >> 2], b ? b - 4 | 0 : 0);
    c = c + 1 | 0;
    b = v[a + 124 >> 2];
    continue;
   }
   break;
  }
  Je(v[a + 80 >> 2], b);
 }
 Je(v[a + 80 >> 2], v[a + 260 >> 2]);
 Je(v[a + 80 >> 2], v[a + 396 >> 2]);
 c = v[a + 404 >> 2];
 if (c) {
  b = 0;
  while (1) {
   if ((b | 0) < v[a + 400 >> 2]) {
    Je(v[a + 80 >> 2], v[(B(b, 40) + c | 0) + 4 >> 2]);
    b = b + 1 | 0;
    c = v[a + 404 >> 2];
    continue;
   }
   break;
  }
  Je(v[a + 80 >> 2], c);
 }
 e = a + 996 | 0;
 d = a + 928 | 0;
 f = a + 800 | 0;
 b = 0;
 while (1) {
  if (b >>> 0 <= 15 & v[a + 4 >> 2] > (b | 0)) {
   c = b << 2;
   Je(v[a + 80 >> 2], v[c + f >> 2]);
   Je(v[a + 80 >> 2], v[c + d >> 2]);
   Je(v[a + 80 >> 2], v[c + e >> 2]);
   b = b + 1 | 0;
   continue;
  } else {
   e = a + 1100 | 0;
   d = a + 1092 | 0;
   f = a + 1084 | 0;
   g = a + 1076 | 0;
   h = a + 1068 | 0;
   c = 0;
   while (1) {
    if ((c | 0) != 2) {
     b = c << 2;
     Je(v[a + 80 >> 2], v[b + h >> 2]);
     Je(v[a + 80 >> 2], v[b + g >> 2]);
     Je(v[a + 80 >> 2], v[b + f >> 2]);
     Je(v[a + 80 >> 2], v[b + d >> 2]);
     Je(v[a + 80 >> 2], v[b + e >> 2]);
     c = c + 1 | 0;
     continue;
    }
    break;
   }
  }
  break;
 }
}

function wM(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, q = 0, r = 0, s = 0, t = 0, w = 0, x = 0;
 c = eb + -64 | 0;
 eb = c;
 d = v[a >> 2];
 a = v[d >> 2];
 f = v[a + 4 >> 2];
 v[c + 40 >> 2] = v[a + 20 >> 2];
 g = v[a + 16 >> 2];
 v[c + 32 >> 2] = v[a + 12 >> 2];
 v[c + 36 >> 2] = g;
 Wf(c + 48 | 0, c + 32 | 0, f);
 a = v[d + 4 >> 2];
 f = v[a + 8 >> 2];
 g = v[a + 4 >> 2];
 d = v[c + 60 >> 2];
 v[c + 24 >> 2] = v[c + 56 >> 2];
 v[c + 28 >> 2] = d;
 d = v[c + 52 >> 2];
 v[c + 16 >> 2] = v[c + 48 >> 2];
 v[c + 20 >> 2] = d;
 v[c + 8 >> 2] = v[a + 8 >> 2];
 d = v[a + 4 >> 2];
 v[c >> 2] = v[a >> 2];
 v[c + 4 >> 2] = d;
 a = eb - 32 | 0;
 eb = a;
 a: {
  b: {
   c: {
    d: {
     k = v[c + 4 >> 2];
     if (k >>> 0 >= g >>> 0) {
      l = v[c + 20 >> 2];
      if (l >>> 0 < g >>> 0) {
       break d;
      }
      if (f >>> 0 > y[c + 8 >> 2]) {
       break c;
      }
      m = v[c + 28 >> 2];
      if (f >>> 0 > v[c + 24 >> 2] - m >>> 0) {
       break b;
      }
      n = b + 12 | 0;
      o = v[c + 16 >> 2];
      q = v[c >> 2];
      e: while (1) {
       if ((f | 0) == (h | 0)) {
        break a;
       }
       r = (B(h, k) << 3) + q | 0;
       s = (B(h + m | 0, l) << 1) + o | 0;
       d = 0;
       while (1) if ((d | 0) == (g | 0)) {
        h = h + 1 | 0;
        continue e;
       } else {
        e = xb(v[b >> 2], d);
        i = Ee(Ig(A[(d << 3) + r >> 3]) * 134217728);
        j = e;
        e = (v[e >> 2] >> 1) + un(i) | 0;
        t = e;
        e = $t(n) + e & -4096;
        v[j >> 2] = t - e;
        A[a + 24 >> 3] = +(e | 0) * 7.450580596923828e-9;
        v[a + 16 >> 2] = 0;
        v[a + 20 >> 2] = -1074790400;
        v[a + 8 >> 2] = 0;
        v[a + 12 >> 2] = 1072693248;
        j = (d << 1) + s | 0;
        i = Ee(A[Xg(a + 24 | 0, a + 16 | 0, a + 8 | 0) >> 3] * 32768);
        f: {
         if (D(i) < 2147483648) {
          e = ~~i;
          break f;
         }
         e = -2147483648;
        }
        w = j, x = fd(e), u[w >> 1] = x;
        d = d + 1 | 0;
        continue;
       }
      }
     }
     Z(7244, 9045, 77, 8725);
     p();
    }
    Z(7209, 9045, 78, 8725);
    p();
   }
   Z(5897, 9045, 79, 8725);
   p();
  }
  Z(5867, 9045, 80, 8725);
  p();
 }
 eb = a + 32 | 0;
 eb = c - -64 | 0;
}

function KL(a, b, c, d, e, f, g, h) {
 var i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = C(0), q = 0, r = 0;
 a: {
  if (w[b + 21 | 0]) {
   q = B(d, g);
   r = b + 36 | 0;
   j = v[e >> 2];
   l = v[f >> 2];
   m = v[b >> 2];
   b: {
    while (1) {
     if ((h | 0) > 0) {
      if (v[a + 1396 >> 2] <= 9) {
       tl(a);
      }
      g = v[a + 1392 >> 2];
      k = u[((g & 1023) << 1) + r >> 1];
      c: {
       if ((k | 0) >= 0) {
        i = g;
        k = k & 65535;
        g = w[k + v[b + 8 >> 2] | 0];
        v[a + 1392 >> 2] = i >>> g;
        g = v[a + 1396 >> 2] - g | 0;
        v[a + 1396 >> 2] = (g | 0) > 0 ? g : 0;
        k = (g | 0) < 0 ? -1 : k;
        break c;
       }
       k = Gm(a, b);
      }
      if ((k | 0) >= v[b + 2092 >> 2] ? w[b + 23 | 0] : 0) {
       break a;
      }
      if ((k | 0) < 0) {
       if (!w[a + 1376 | 0]) {
        b = 0;
        if (v[a + 1384 >> 2]) {
         break b;
        }
       }
       bc(a, 21);
       return 0;
      } else {
       g = 0;
       n = B(d, l);
       m = ((m + n | 0) + j | 0) > (q | 0) ? (q - n | 0) + j | 0 : m;
       n = (m | 0) > 0 ? m : 0;
       k = B(k, v[b >> 2]);
       o = C(0);
       d: {
        if (w[b + 22 | 0]) {
         while (1) {
          if ((g | 0) == (n | 0)) {
           break d;
          }
          o = C(o + z[(v[b + 28 >> 2] + (k << 2) | 0) + (g << 2) >> 2]);
          i = v[(j << 2) + c >> 2];
          if (i) {
           i = i + (l << 2) | 0;
           z[i >> 2] = o + z[i >> 2];
          }
          j = j + 1 | 0;
          i = (j | 0) == (d | 0);
          j = i ? 0 : j;
          g = g + 1 | 0;
          l = i + l | 0;
          continue;
         }
        }
        while (1) {
         if ((g | 0) == (n | 0)) {
          break d;
         }
         i = v[(j << 2) + c >> 2];
         if (i) {
          i = i + (l << 2) | 0;
          z[i >> 2] = z[i >> 2] + C(z[(v[b + 28 >> 2] + (k << 2) | 0) + (g << 2) >> 2] + C(0));
         }
         j = j + 1 | 0;
         i = (j | 0) == (d | 0);
         j = i ? 0 : j;
         g = g + 1 | 0;
         l = i + l | 0;
         continue;
        }
       }
       h = h - m | 0;
       continue;
      }
     }
     break;
    }
    v[e >> 2] = j;
    v[f >> 2] = l;
    b = 1;
   }
   return b;
  }
  bc(a, 21);
  return 0;
 }
 Z(7552, 13258, 1887, 6586);
 p();
}

function Lr(a) {
 var b = 0, c = 0, d = 0, e = 0;
 c = eb - 16 | 0;
 eb = c;
 a: {
  if (w[a + 3 | 0] != 19) {
   break a;
  }
  t[a + 3 | 0] = 20;
  b: {
   c: {
    d: {
     e: {
      f: {
       g: {
        h: {
         i: {
          j: {
           k: {
            l: {
             m: {
              n: {
               b = w[a + 5 | 0];
               switch (b >>> 4 | 0) {
               case 4:
                break j;

               case 3:
                break k;

               case 2:
                break l;

               case 1:
                break m;

               case 0:
                break n;

               case 13:
                break b;

               case 12:
                break c;

               case 11:
                break d;

               case 10:
                break e;

               case 9:
                break f;

               case 7:
                break g;

               case 6:
                break h;

               case 5:
                break i;

               default:
                break a;
               }
              }
              t[a + 3 | 0] = 0;
              break a;
             }
             t[a + 3 | 0] = 2;
             t[a + 5 | 0] = b | 240;
             break a;
            }
            t[a + 3 | 0] = 3;
            t[a + 5 | 0] = b | 240;
            break a;
           }
           t[a + 5 | 0] = b & 15 | 16;
           break a;
          }
          t[a + 5 | 0] = b & 3 | 48;
          break a;
         }
         t[a + 5 | 0] = b & 223 ^ 120;
         break a;
        }
        t[a + 5 | 0] = b & 15 | 176;
        break a;
       }
       t[a + 5 | 0] = b & 3 | 64;
       break a;
      }
      t[a + 3 | 0] = 15;
      t[a + 5 | 0] = b & 15;
      break a;
     }
     if (b & 15) {
      t[a + 3 | 0] = 11;
      t[a + 5 | 0] = b << 4 | 15;
      break a;
     }
     t[a + 3 | 0] = 0;
     break a;
    }
    b = b & 15;
    if (b) {
     t[a + 3 | 0] = 11;
     v[c + 12 >> 2] = b;
     v[c + 8 >> 2] = 14;
     d = a, e = w[Bd(c + 12 | 0, c + 8 | 0) | 0] | 240, t[d + 5 | 0] = e;
     break a;
    }
    t[a + 3 | 0] = 0;
    break a;
   }
   if ((b | 0) != 192) {
    break a;
   }
   t[a | 0] = 254;
   t[a + 3 | 0] = 0;
   break a;
  }
  if ((b | 0) != 208) {
   break a;
  }
  t[a + 3 | 0] = 0;
 }
 eb = c + 16 | 0;
}

function Ela(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, w = 0, x = 0, y = 0, z = 0, A = 0;
 g = eb - 16 | 0;
 eb = g;
 r = v[a + 16 >> 2];
 s = Fg(b + 327720 | 0, v[b + 20 >> 2], (v[a + 88 >> 2] & 16384) >>> 14 | 0);
 k = v[a + 8 >> 2];
 l = v[a + 12 >> 2];
 h = v[a >> 2];
 e = v[a + 4 >> 2];
 m = v[a + 128 >> 2];
 if (m) {
  n = Gg(k, l, m);
  o = gb;
  b = v[a + 76 >> 2];
  eg(h, e, uf(k, l, d), gb);
  p = gb >>> 0 > b >>> 0 ? d : 0;
 }
 i = a + 112 | 0;
 t = v[a + 24 >> 2];
 w = v[a + 20 >> 2];
 f = v[a + 48 >> 2];
 b = v[a + 44 >> 2];
 v[g >> 2] = h;
 v[g + 4 >> 2] = e;
 a: while (1) {
  b: {
   q = b;
   if (!d) {
    break b;
   }
   d = d - 1 | 0;
   v[g + 8 >> 2] = h;
   v[g + 12 >> 2] = 0;
   p = p - 1 | 0;
   b = p;
   n = b ? n : 0;
   o = b ? o : 0;
   h = (e << 1) + r | 0;
   b = m;
   while (1) if ((b | 0) <= 0) {
    Ob(i, v[a + 120 >> 2], v[a + 124 >> 2]);
    b = v[a + 116 >> 2];
    if (b) {
     be(i, u[h + (v[g + 12 >> 2] << 1) >> 1] / 4 << 16 >> 16);
     ae(i, b);
     v[i >> 2] = v[i >> 2];
     v[i + 4 >> 2] = 0;
    }
    x = v[a + 72 >> 2];
    y = v[c >> 2];
    h = Eg(i, s) << 8;
    b = h;
    j = b >> 31;
    b = v[a + 60 >> 2];
    b = Aua(h, j, b, b >> 31);
    z = gb;
    e = b;
    b = v[a + 64 >> 2];
    j = b;
    A = b >> 31;
    b = Xb(q, -16777216, 16776704);
    j = Aua(j, A, b, b >> 31);
    e = e + j | 0;
    b = gb + z | 0;
    b = e >>> 0 < j >>> 0 ? b + 1 | 0 : b;
    j = e;
    e = v[a + 68 >> 2];
    f = Xb(f, -16777216, 16776704);
    e = Aua(e, e >> 31, f, f >> 31);
    f = j + e | 0;
    b = gb + b | 0;
    b = e >>> 0 > f >>> 0 ? b + 1 | 0 : b;
    f = f + 8388608 | 0;
    b = f >>> 0 < 8388608 ? b + 1 | 0 : b;
    b = Rc(f, b, 24);
    f = (b | 0) / 256 | 0;
    v[c >> 2] = B(f, w) + y;
    v[c + 4 >> 2] = v[c + 4 >> 2] + B(f, t);
    Ob(g, k, l);
    b = b - (h & x) | 0;
    c = c + 8 | 0;
    h = v[g >> 2];
    e = v[g + 4 >> 2];
    f = q;
    continue a;
   } else {
    be(i, u[h + (v[g + 12 >> 2] << 1) >> 1] / 4 << 16 >> 16);
    ae(i, 4);
    Ob(g + 8 | 0, n, o);
    b = b - 1 | 0;
    continue;
   }
  }
  break;
 }
 v[a >> 2] = h;
 v[a + 4 >> 2] = e;
 v[a + 48 >> 2] = f;
 v[a + 44 >> 2] = q;
 eb = g + 16 | 0;
}

function Nma(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, w = 0, x = 0, y = 0, z = 0, A = 0, C = 0;
 b = eb - 48 | 0;
 eb = b;
 p = v[a + 16 >> 2];
 v[b + 32 >> 2] = v[a + 44 >> 2];
 v[b + 36 >> 2] = v[a + 48 >> 2];
 v[b + 40 >> 2] = v[a + 52 >> 2];
 v[b + 44 >> 2] = v[a + 56 >> 2];
 q = v[a + 24 >> 2];
 r = v[a + 20 >> 2];
 g = v[a + 4 >> 2];
 v[b + 16 >> 2] = v[a >> 2];
 v[b + 20 >> 2] = g;
 s = b + 32 | 0;
 t = v[a + 72 >> 2];
 l = v[a + 68 >> 2];
 w = l >> 31;
 m = v[a + 64 >> 2];
 x = m >> 31;
 n = v[a + 60 >> 2];
 y = n >> 31;
 z = v[a + 8 >> 2];
 A = v[a + 12 >> 2];
 while (1) {
  if (d) {
   e = v[b + 16 >> 2];
   h = e >>> 18 | 0;
   e = ((((v[b + 20 >> 2] & 2147483647) << 1 | e >>> 31) & 2147483646) << 1) + p | 0;
   j = 0;
   f = 0;
   while (1) {
    if ((f | 0) != 2) {
     g = e + (f << 1) | 0;
     k = u[g >> 1];
     v[(b + 8 | 0) + (f << 2) >> 2] = k + ((B(h, u[g + 4 >> 1] - k | 0) | 0) / 16384 | 0);
     f = f + 1 | 0;
     continue;
    }
    break;
   }
   while (1) {
    if ((j | 0) != 2) {
     o = (b + 8 | 0) + (j << 2) | 0;
     e = v[o >> 2];
     g = (j << 3) + s | 0;
     C = v[g + 4 >> 2];
     f = v[g >> 2];
     v[g + 4 >> 2] = f;
     k = e << 8;
     e = k;
     e = Aua(e, e >> 31, n, y);
     h = gb;
     i = e;
     e = Xb(f, -16777216, 16776704);
     e = Aua(m, x, e, e >> 31);
     f = i + e | 0;
     i = gb + h | 0;
     i = e >>> 0 > f >>> 0 ? i + 1 | 0 : i;
     e = Xb(C, -16777216, 16776704);
     h = Aua(l, w, e, e >> 31);
     f = h + f | 0;
     e = gb + i | 0;
     e = f >>> 0 < h >>> 0 ? e + 1 | 0 : e;
     h = f + 8388608 | 0;
     e = h >>> 0 < 8388608 ? e + 1 | 0 : e;
     e = Rc(h, e, 24);
     v[g >> 2] = e - (k & t);
     v[o >> 2] = (e | 0) / 256;
     j = j + 1 | 0;
     continue;
    }
    break;
   }
   v[c >> 2] = v[c >> 2] + B(v[b + 8 >> 2], r);
   v[c + 4 >> 2] = v[c + 4 >> 2] + B(v[b + 12 >> 2], q);
   Ob(b + 16 | 0, z, A);
   c = c + 8 | 0;
   d = d - 1 | 0;
   continue;
  }
  break;
 }
 c = v[b + 20 >> 2];
 v[a >> 2] = v[b + 16 >> 2];
 v[a + 4 >> 2] = c;
 v[a + 44 >> 2] = v[b + 32 >> 2];
 v[a + 48 >> 2] = v[b + 36 >> 2];
 v[a + 52 >> 2] = v[b + 40 >> 2];
 v[a + 56 >> 2] = v[b + 44 >> 2];
 eb = b + 48 | 0;
}

function $W(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
 f = eb - 16 | 0;
 eb = f;
 v[a >> 2] = 0;
 v[a + 4 >> 2] = 0;
 Ec(a + 8 | 0, 0);
 d = v[b + 4 >> 2];
 if (d) {
  Xr(a, d);
  ln(f + 8 | 0, v[b >> 2]);
  $q(f, v[b >> 2], v[b + 4 >> 2]);
  d = v[f + 8 >> 2];
  k = v[f + 12 >> 2];
  e = v[f >> 2];
  l = v[f + 4 >> 2];
  j = eb - 32 | 0;
  eb = j;
  c = v[b + 4 >> 2];
  b = v[a + 4 >> 2];
  c = c + b | 0;
  v[a + 4 >> 2] = c;
  a: {
   b: {
    if (!b) {
     g = c - 1 | 0;
     break b;
    }
    g = c - 1 | 0;
    if ((g ^ b - 1) >>> 0 > 31) {
     break b;
    }
    h = v[a >> 2];
    break a;
   }
   h = v[a >> 2];
   v[h + ((c >>> 0 >= 33 ? g >>> 5 | 0 : 0) << 2) >> 2] = 0;
  }
  yp(j + 24 | 0, h, b);
  h = eb - 16 | 0;
  eb = h;
  b = Yb(h + 8 | 0, v[j + 24 >> 2], v[j + 28 >> 2]);
  m = eb - 16 | 0;
  eb = m;
  n = j + 8 | 0;
  g = Yb(m + 8 | 0, v[b >> 2], v[b + 4 >> 2]);
  b = eb - 96 | 0;
  eb = b;
  c = eb - 16 | 0;
  eb = c;
  mr(c + 8 | 0, d, k);
  mr(c, e, l);
  d = v[c + 12 >> 2];
  v[b + 80 >> 2] = v[c + 8 >> 2];
  v[b + 84 >> 2] = d;
  d = v[c + 4 >> 2];
  v[b + 88 >> 2] = v[c >> 2];
  v[b + 92 >> 2] = d;
  eb = c + 16 | 0;
  d = v[b + 84 >> 2];
  v[b + 56 >> 2] = v[b + 80 >> 2];
  v[b + 60 >> 2] = d;
  k = v[b + 88 >> 2];
  l = v[b + 92 >> 2];
  d = b + 48 | 0;
  e = Yb(b + 40 | 0, v[g >> 2], v[g + 4 >> 2]);
  kn(d, v[e >> 2], v[e + 4 >> 2]);
  e = v[b + 60 >> 2];
  v[b >> 2] = v[b + 56 >> 2];
  v[b + 4 >> 2] = e;
  o = b - -64 | 0;
  e = eb - 16 | 0;
  eb = e;
  while (1) {
   i = v[b + 4 >> 2];
   if (ZW(v[b >> 2], i, k, l)) {
    c = eb - 16 | 0;
    eb = c;
    i = Yb(c + 8 | 0, v[b >> 2], 1 << i);
    i = Fb(v[v[i >> 2] >> 2], v[i + 4 >> 2]);
    eb = c + 16 | 0;
    c = e + 8 | 0;
    Ot(c, v[d >> 2], v[d + 4 >> 2]);
    kf(c, i);
    Av(b);
    Av(d);
    continue;
   }
   break;
  }
  _W(o, v[b >> 2], v[b + 4 >> 2], d);
  eb = e + 16 | 0;
  mr(b + 32 | 0, v[b + 64 >> 2], v[b + 68 >> 2]);
  Yb(b + 16 | 0, v[g >> 2], v[g + 4 >> 2]);
  d = b + 24 | 0;
  e = Yb(b + 8 | 0, v[b + 72 >> 2], v[b + 76 >> 2]);
  kn(d, v[e >> 2], v[e + 4 >> 2]);
  _W(n, v[b + 32 >> 2], v[b + 36 >> 2], d);
  eb = b + 96 | 0;
  eb = m + 16 | 0;
  eb = h + 16 | 0;
  eb = j + 32 | 0;
 }
 eb = f + 16 | 0;
 return a | 0;
}

function ima(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, w = 0, x = 0, y = 0, z = 0;
 h = eb - 16 | 0;
 eb = h;
 f = v[a + 8 >> 2];
 k = f;
 e = v[a + 12 >> 2];
 j = e;
 a: {
  b: {
   if ((e | 0) <= 1 & f >>> 0 <= 805306368 | (e | 0) <= 0) {
    i = 131112;
    f = e;
    if ((e | 0) > -2) {
     e = 1;
    } else {
     e = (f | 0) >= -2 & k >>> 0 >= 3489660928;
    }
    if (e) {
     break a;
    }
    i = 262184;
    if ((j | 0) == -2 & k >>> 0 < 2147483648 | j >>> 0 < 4294967294) {
     break a;
    }
    break b;
   }
   i = 262184;
   if ((j | 0) == 1 & k >>> 0 > 2147483648 | j >>> 0 > 1) {
    break a;
   }
  }
  i = 196648;
 }
 q = v[a + 16 >> 2];
 r = v[a + 24 >> 2];
 s = v[a + 20 >> 2];
 f = v[a + 48 >> 2];
 e = v[a + 44 >> 2];
 l = v[a + 4 >> 2];
 v[h + 8 >> 2] = v[a >> 2];
 v[h + 12 >> 2] = l;
 t = b + i | 0;
 w = v[a + 72 >> 2];
 p = v[a + 68 >> 2];
 x = p >> 31;
 i = v[a + 64 >> 2];
 y = i >> 31;
 l = v[a + 60 >> 2];
 z = l >> 31;
 while (1) {
  b = e;
  if (d) {
   e = Xb(e, -16777216, 16776704);
   m = Aua(i, y, e, e >> 31);
   n = gb;
   e = v[h + 8 >> 2];
   g = (v[h + 12 >> 2] << 1) + q | 0;
   e = (e >>> 16 & 65520) + t | 0;
   g = (((((((B(u[g - 4 >> 1], u[e + 2 >> 1]) + B(u[g - 6 >> 1], u[e >> 1]) | 0) + B(u[g - 2 >> 1], u[e + 4 >> 1]) | 0) + B(u[g >> 1], u[e + 6 >> 1]) | 0) + B(u[g + 2 >> 1], u[e + 8 >> 1]) | 0) + B(u[g + 4 >> 1], u[e + 10 >> 1]) | 0) + B(u[g + 6 >> 1], u[e + 12 >> 1]) | 0) + B(u[g + 8 >> 1], u[e + 14 >> 1]) | 0) / 32768 << 8;
   e = g;
   e = Aua(e, e >> 31, l, z);
   m = e + m | 0;
   o = gb + n | 0;
   o = e >>> 0 > m >>> 0 ? o + 1 | 0 : o;
   f = Xb(f, -16777216, 16776704);
   e = Aua(p, x, f, f >> 31);
   n = e + m | 0;
   f = gb + o | 0;
   f = e >>> 0 > n >>> 0 ? f + 1 | 0 : f;
   e = n + 8388608 | 0;
   f = e >>> 0 < 8388608 ? f + 1 | 0 : f;
   e = Rc(e, f, 24);
   f = (e | 0) / 256 | 0;
   v[c >> 2] = B(f, s) + v[c >> 2];
   v[c + 4 >> 2] = v[c + 4 >> 2] + B(f, r);
   Ob(h + 8 | 0, k, j);
   e = e - (g & w) | 0;
   c = c + 8 | 0;
   d = d - 1 | 0;
   f = b;
   continue;
  }
  break;
 }
 c = v[h + 12 >> 2];
 v[a >> 2] = v[h + 8 >> 2];
 v[a + 4 >> 2] = c;
 v[a + 48 >> 2] = f;
 v[a + 44 >> 2] = b;
 eb = h + 16 | 0;
}

function nO(a, b) {
 a = a | 0;
 b = +b;
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0;
 e = eb + -64 | 0;
 eb = e;
 a: {
  b: {
   c: {
    d: {
     g = v[a + 36 >> 2];
     c = v[a + 40 >> 2];
     e: {
      if (Hb(g, c)) {
       sc(e + 60 | 0);
       break e;
      }
      f = e + 24 | 0;
      vo(f, a);
      v[31601] = 0;
      c = Q(1055, f | 0) | 0;
      d = v[31601];
      v[31601] = 0;
      if ((d | 0) == 1) {
       break d;
      }
      v[e + 60 >> 2] = c;
      nf(f);
      c = v[a + 40 >> 2];
      g = v[a + 36 >> 2];
     }
     f = (k = a + 36 | 0, l = v[e + 60 >> 2], m = Hb(g, c), m ? k : l);
     d = v[a + 8 >> 2];
     if ((d | 0) == -1) {
      c = v[f + 4 >> 2];
      d = gl(c);
      g = 0;
      h = v[f >> 2];
      f = ej(h, c);
      while (1) {
       if ((f | 0) == (g | 0)) {
        c = d;
        break c;
       }
       c = vf(h, g);
       j = i + A[c >> 3];
       if (j > b) {
        break c;
       }
       g = g + 1 | 0;
       i = j;
       continue;
      }
     }
     c = vf(v[f >> 2], d);
     break b;
    }
    g = M() | 0;
    nf(e + 24 | 0);
    break a;
   }
   b = b - i;
  }
  f = x[c + 12 >> 1];
  d = v[a + 24 >> 2];
  v[31601] = 0;
  N(1089, d | 0, f | 0);
  d = v[31601];
  v[31601] = 0;
  if ((d | 0) != 1) {
   f: {
    h = v[a + 24 >> 2];
    f = w[a + 64 | 0];
    c = NR(TX(e + 24 | 0, b), w[c + 16 | 0], x[c + 12 >> 1], v[c + 8 >> 2]);
    v[31601] = 0;
    d = v[c + 12 >> 2];
    v[e + 8 >> 2] = v[c + 8 >> 2];
    v[e + 12 >> 2] = d;
    d = v[c + 20 >> 2];
    v[e + 16 >> 2] = v[c + 16 >> 2];
    v[e + 20 >> 2] = d;
    d = v[c + 4 >> 2];
    v[e >> 2] = v[c >> 2];
    v[e + 4 >> 2] = d;
    c = e + 48 | 0;
    U(1090, c | 0, h | 0, (f ? 7 : 1) | 0, e | 0);
    d = v[31601];
    v[31601] = 0;
    if ((d | 0) == 1) {
     break f;
    }
    h = dn(v[e + 52 >> 2]);
    f = t[h + 26 | 0] & 1;
    d = v[(f ? h + 8 | 0 : h + 12 | 0) >> 2];
    f = x[(f ? h + 20 | 0 : h + 22 | 0) >> 1];
    b = A[h >> 3];
    Pi(c);
    c = v[a + 24 >> 2];
    u[c + 1074450 >> 1] = f;
    u[c + 1074448 >> 1] = f;
    v[c + 1074428 >> 2] = d;
    v[c + 1074392 >> 2] = -2;
    b = i + b;
    A[a + 16 >> 3] = b;
    vl(e + 60 | 0);
    eb = e - -64 | 0;
    return +b;
   }
  }
  g = M() | 0;
  vl(e + 60 | 0);
 }
 P(g | 0);
 p();
}

function tqa(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0;
 e = eb - 16 | 0;
 eb = e;
 h = a + 4 | 0;
 a: {
  if ((c | 0) != 4) {
   g = b + 236 | 0;
   i = b + 108 | 0;
   while (1) {
    if ((d | 0) == 120) {
     break a;
    }
    f = (d << 2) + h | 0;
    j = wb(i, d), k = w[f | 0] + 1 | 0, t[j | 0] = k;
    j = $b(g, d), k = (w[f + 2 | 0] | w[f + 3 | 0] << 8) + 1 | 0, u[j >> 1] = k;
    d = d + 1 | 0;
    continue;
   }
  }
  f = b + 236 | 0;
  while (1) {
   if ((d | 0) == 96) {
    break a;
   }
   g = (d << 2) + h | 0;
   j = $b(f, d + 12 | 0), k = (w[g + 2 | 0] | w[g + 3 | 0] << 8) + 1 | 0, u[j >> 1] = k;
   d = d + 1 | 0;
   continue;
  }
 }
 aD(a + 484 | 0, b + 48 | 0, 0, c);
 aD(a + 590 | 0, b + 68 | 0, 0, c);
 aD(a + 696 | 0, b + 88 | 0, 5, c);
 v[b >> 2] = w[a + 806 | 0] | w[a + 807 | 0] << 8;
 d = t[a + 808 | 0];
 b: {
  if ((d | 0) < 0) {
   t[b + 34 | 0] = d - 127;
   break b;
  }
  if (d >>> 0 > 16) {
   break b;
  }
  if (t[a | 0] & 1) {
   t[b + 31 | 0] = d + 1;
   break b;
  }
  if (!d) {
   break b;
  }
  t[b + 31 | 0] = d + 1;
 }
 if (w[b + 31 | 0]) {
  c: {
   d: {
    if ((c | 0) == 4) {
     d = w[a + 810 | 0];
     break d;
    }
    d = t[a + 809 | 0];
    if ((d | 0) >= 0) {
     u[b + 28 >> 1] = d + 1 & 255;
    }
    d = t[a + 810 | 0];
    if ((d | 0) < 0) {
     break c;
    }
   }
   t[b + 30 | 0] = d + 1;
  }
  t[b + 33 | 0] = w[a + 811 | 0];
 }
 if ((c | 0) == 32) {
  t[e + 15 | 0] = w[a + 812 | 0];
  t[e + 14 | 0] = 128;
  j = b, k = w[Pb(e + 15 | 0, e + 14 | 0) | 0] >>> 1 | 0, v[j + 4 >> 2] = k;
 }
 c = w[a + 813 | 0] | w[a + 814 | 0] << 8;
 if (c >>> 0 <= 256) {
  v[b + 8 >> 2] = c;
  t[b + 15 | 0] = w[b + 15 | 0] | 1;
 }
 t[b + 16 | 0] = w[a + 815 | 0];
 t[b + 26 | 0] = w[a + 816 | 0];
 t[b + 27 | 0] = w[a + 817 | 0];
 t[b + 17 | 0] = w[a + 818 | 0];
 t[b + 18 | 0] = w[a + 819 | 0];
 u[e + 12 >> 1] = w[a + 820 | 0] | w[a + 821 | 0] << 8;
 u[e + 10 >> 1] = 100;
 j = b, k = w[Nc(e + 12 | 0, e + 10 | 0) | 0], t[j + 20 | 0] = k;
 u[e + 8 >> 1] = w[a + 822 | 0] | w[a + 823 | 0] << 8;
 u[e + 6 >> 1] = 256;
 j = b, k = x[Nc(e + 8 | 0, e + 6 | 0) >> 1] >>> 2 | 0, t[j + 19 | 0] = k;
 c = w[a + 824 | 0];
 bk(b, c & 127, c >>> 7 | 0);
 a = w[a + 825 | 0];
 ak(b, a & 127, a >>> 7 | 0);
 eb = e + 16 | 0;
}

function Pma(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, u = 0, w = 0, x = 0, y = 0, z = 0, A = 0, C = 0;
 b = eb - 48 | 0;
 eb = b;
 p = v[a + 16 >> 2];
 v[b + 32 >> 2] = v[a + 44 >> 2];
 v[b + 36 >> 2] = v[a + 48 >> 2];
 v[b + 40 >> 2] = v[a + 52 >> 2];
 v[b + 44 >> 2] = v[a + 56 >> 2];
 q = v[a + 24 >> 2];
 r = v[a + 20 >> 2];
 g = v[a + 4 >> 2];
 v[b + 16 >> 2] = v[a >> 2];
 v[b + 20 >> 2] = g;
 s = b + 32 | 0;
 u = v[a + 72 >> 2];
 l = v[a + 68 >> 2];
 w = l >> 31;
 m = v[a + 64 >> 2];
 x = m >> 31;
 n = v[a + 60 >> 2];
 y = n >> 31;
 z = v[a + 8 >> 2];
 A = v[a + 12 >> 2];
 while (1) {
  if (d) {
   e = v[b + 16 >> 2];
   h = e >>> 10 & 4194048;
   e = (((v[b + 20 >> 2] & 2147483647) << 1 | e >>> 31) & -2) + p | 0;
   j = 0;
   f = 0;
   while (1) {
    if ((f | 0) != 2) {
     g = e + f | 0;
     k = t[g | 0];
     v[(b + 8 | 0) + (f << 2) >> 2] = ((B(h, t[g + 2 | 0] - k | 0) | 0) / 16384 | 0) + (k << 8);
     f = f + 1 | 0;
     continue;
    }
    break;
   }
   while (1) {
    if ((j | 0) != 2) {
     o = (b + 8 | 0) + (j << 2) | 0;
     e = v[o >> 2];
     g = (j << 3) + s | 0;
     C = v[g + 4 >> 2];
     f = v[g >> 2];
     v[g + 4 >> 2] = f;
     k = e << 8;
     e = k;
     e = Aua(e, e >> 31, n, y);
     h = gb;
     i = e;
     e = Xb(f, -16777216, 16776704);
     e = Aua(m, x, e, e >> 31);
     f = i + e | 0;
     i = gb + h | 0;
     i = e >>> 0 > f >>> 0 ? i + 1 | 0 : i;
     e = Xb(C, -16777216, 16776704);
     h = Aua(l, w, e, e >> 31);
     f = h + f | 0;
     e = gb + i | 0;
     e = f >>> 0 < h >>> 0 ? e + 1 | 0 : e;
     h = f + 8388608 | 0;
     e = h >>> 0 < 8388608 ? e + 1 | 0 : e;
     e = Rc(h, e, 24);
     v[g >> 2] = e - (k & u);
     v[o >> 2] = (e | 0) / 256;
     j = j + 1 | 0;
     continue;
    }
    break;
   }
   v[c >> 2] = v[c >> 2] + B(v[b + 8 >> 2], r);
   v[c + 4 >> 2] = v[c + 4 >> 2] + B(v[b + 12 >> 2], q);
   Ob(b + 16 | 0, z, A);
   c = c + 8 | 0;
   d = d - 1 | 0;
   continue;
  }
  break;
 }
 c = v[b + 20 >> 2];
 v[a >> 2] = v[b + 16 >> 2];
 v[a + 4 >> 2] = c;
 v[a + 44 >> 2] = v[b + 32 >> 2];
 v[a + 48 >> 2] = v[b + 36 >> 2];
 v[a + 52 >> 2] = v[b + 40 >> 2];
 v[a + 56 >> 2] = v[b + 44 >> 2];
 eb = b + 48 | 0;
}

function lN(a, b, c, d, e) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = +d;
 e = +e;
 var f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0;
 i = eb - 16 | 0;
 eb = i;
 g = v[a + 32 >> 2];
 f = qq(g);
 if (!f) {
  f = pq(g);
 }
 a: {
  b: {
   c: {
    if (b >>> 0 >= f >>> 0) {
     b = cc(8);
     v[31601] = 0;
     c = O(36, i + 4 | 0, 6e3) | 0;
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) == 1) {
      break c;
     }
     rc(b, c);
     v[31601] = 0;
     R(97, b | 0, 48396, 999);
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) != 1) {
      break a;
     }
     a = M() | 0;
     sb(c);
     break b;
    }
    if (c >>> 0 >= 120) {
     b = cc(8);
     v[31601] = 0;
     c = O(36, i + 4 | 0, 11318) | 0;
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) != 1) {
      rc(b, c);
      v[31601] = 0;
      R(97, b | 0, 48396, 999);
      a = v[31601];
      v[31601] = 0;
      if ((a | 0) != 1) {
       break a;
      }
      a = M() | 0;
      sb(c);
      break b;
     }
     a = M() | 0;
     jc(b);
     break b;
    }
    f = fB(g, 65535);
    j = (f | 0) == 65535 ? 255 : f;
    u[i + 4 >> 1] = j;
    f = g + B(j, 872) | 0;
    h = f + 1074992 | 0;
    Po(h, g, 65535, 1024);
    c = c + 1 | 0;
    t[f + 1075794 | 0] = c;
    t[f + 1075791 | 0] = c;
    u[f + 1075778 >> 1] = 0;
    Xm(h);
    Ko(v[a + 32 >> 2], h, b + 1 | 0, 0, 1, 1);
    v[f + 1075688 >> 2] = 65536;
    Tu(v[a + 32 >> 2], h, c, 0, 1, 1, 65535);
    l = f + 1075684 | 0, m = Ri(Zv(e * 128, -128, 128) + 128), v[l >> 2] = m;
    l = f + 1075680 | 0, m = Ri(Zv(d * 256, 0, 256)), v[l >> 2] = m;
    d: {
     b = v[a + 32 >> 2];
     h = b + 1074478 | 0;
     c = h;
     c = c + (x[b + 480212 >> 1] << 1) | 0;
     g = x[i + 4 >> 1];
     b = NX(h, c, g);
     if ((b | 0) == (c | 0)) {
      break d;
     }
     f = b;
     while (1) {
      while (1) {
       f = f + 2 | 0;
       if ((f | 0) == (c | 0)) {
        c = b;
        break d;
       }
       k = x[f >> 1];
       if ((k | 0) == (g | 0)) {
        continue;
       }
       break;
      }
      u[b >> 1] = k;
      b = b + 2 | 0;
      g = x[i + 4 >> 1];
      continue;
     }
    }
    l = v[a + 32 >> 2], m = LT(h, c), u[l + 480212 >> 1] = m;
    eb = i + 16 | 0;
    return j | 0;
   }
   a = M() | 0;
   jc(b);
  }
  P(a | 0);
 }
 p();
}

function kma(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, w = 0, x = 0, y = 0, z = 0;
 h = eb - 16 | 0;
 eb = h;
 e = v[a + 8 >> 2];
 k = e;
 f = v[a + 12 >> 2];
 j = f;
 a: {
  b: {
   if ((f | 0) <= 1 & e >>> 0 <= 805306368 | (f | 0) <= 0) {
    i = 131112;
    e = f;
    if ((e | 0) > -2) {
     e = 1;
    } else {
     e = (e | 0) >= -2 & k >>> 0 >= 3489660928;
    }
    if (e) {
     break a;
    }
    i = 262184;
    if ((j | 0) == -2 & k >>> 0 < 2147483648 | j >>> 0 < 4294967294) {
     break a;
    }
    break b;
   }
   i = 262184;
   if ((j | 0) == 1 & k >>> 0 > 2147483648 | j >>> 0 > 1) {
    break a;
   }
  }
  i = 196648;
 }
 p = v[a + 16 >> 2];
 q = v[a + 24 >> 2];
 r = v[a + 20 >> 2];
 e = v[a + 48 >> 2];
 f = v[a + 44 >> 2];
 l = v[a + 4 >> 2];
 v[h + 8 >> 2] = v[a >> 2];
 v[h + 12 >> 2] = l;
 s = b + i | 0;
 w = v[a + 72 >> 2];
 n = v[a + 68 >> 2];
 x = n >> 31;
 i = v[a + 64 >> 2];
 y = i >> 31;
 l = v[a + 60 >> 2];
 z = l >> 31;
 while (1) {
  b = f;
  if (d) {
   f = Xb(f, -16777216, 16776704);
   g = Aua(i, y, f, f >> 31);
   f = gb;
   e = Xb(e, -16777216, 16776704);
   e = Aua(n, x, e, e >> 31);
   g = e + g | 0;
   f = gb + f | 0;
   f = e >>> 0 > g >>> 0 ? f + 1 | 0 : f;
   e = v[h + 8 >> 2];
   m = g;
   g = v[h + 12 >> 2] + p | 0;
   e = (e >>> 16 & 65520) + s | 0;
   o = (((((((B(t[g - 2 | 0], u[e + 2 >> 1]) + B(t[g - 3 | 0], u[e >> 1]) | 0) + B(t[g - 1 | 0], u[e + 4 >> 1]) | 0) + B(t[g | 0], u[e + 6 >> 1]) | 0) + B(t[g + 1 | 0], u[e + 8 >> 1]) | 0) + B(t[g + 2 | 0], u[e + 10 >> 1]) | 0) + B(t[g + 3 | 0], u[e + 12 >> 1]) | 0) + B(t[g + 4 | 0], u[e + 14 >> 1]) << 8) / 32768 << 8;
   e = o;
   g = Aua(e, e >> 31, l, z);
   m = m + g | 0;
   e = gb + f | 0;
   e = g >>> 0 > m >>> 0 ? e + 1 | 0 : e;
   f = m + 8388608 | 0;
   e = f >>> 0 < 8388608 ? e + 1 | 0 : e;
   f = Rc(f, e, 24);
   e = (f | 0) / 256 | 0;
   v[c >> 2] = B(e, r) + v[c >> 2];
   v[c + 4 >> 2] = v[c + 4 >> 2] + B(e, q);
   Ob(h + 8 | 0, k, j);
   f = f - (w & o) | 0;
   c = c + 8 | 0;
   d = d - 1 | 0;
   e = b;
   continue;
  }
  break;
 }
 c = v[h + 12 >> 2];
 v[a >> 2] = v[h + 8 >> 2];
 v[a + 4 >> 2] = c;
 v[a + 48 >> 2] = e;
 v[a + 44 >> 2] = b;
 eb = h + 16 | 0;
}

function CM(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, q = 0, r = 0, s = 0, t = 0;
 c = eb + -64 | 0;
 eb = c;
 d = v[a >> 2];
 a = v[d >> 2];
 f = v[a + 4 >> 2];
 v[c + 40 >> 2] = v[a + 20 >> 2];
 g = v[a + 16 >> 2];
 v[c + 32 >> 2] = v[a + 12 >> 2];
 v[c + 36 >> 2] = g;
 Wf(c + 48 | 0, c + 32 | 0, f);
 a = v[d + 4 >> 2];
 f = v[a + 8 >> 2];
 g = v[a + 4 >> 2];
 d = v[c + 60 >> 2];
 v[c + 24 >> 2] = v[c + 56 >> 2];
 v[c + 28 >> 2] = d;
 d = v[c + 52 >> 2];
 v[c + 16 >> 2] = v[c + 48 >> 2];
 v[c + 20 >> 2] = d;
 v[c + 8 >> 2] = v[a + 8 >> 2];
 d = v[a + 4 >> 2];
 v[c >> 2] = v[a >> 2];
 v[c + 4 >> 2] = d;
 a = eb - 32 | 0;
 eb = a;
 a: {
  b: {
   c: {
    d: {
     k = v[c + 4 >> 2];
     if (k >>> 0 >= g >>> 0) {
      if (y[c + 20 >> 2] < g >>> 0) {
       break d;
      }
      if (f >>> 0 > y[c + 8 >> 2]) {
       break c;
      }
      l = v[c + 28 >> 2];
      if (f >>> 0 > v[c + 24 >> 2] - l >>> 0) {
       break b;
      }
      m = b + 12 | 0;
      n = v[c + 16 >> 2];
      o = v[c >> 2];
      e: while (1) {
       if ((f | 0) == (h | 0)) {
        break a;
       }
       q = (B(h, k) << 3) + o | 0;
       d = 0;
       while (1) if ((d | 0) == (g | 0)) {
        h = h + 1 | 0;
        continue e;
       } else {
        e = xb(v[b >> 2], d);
        i = Ee(Ig(A[(d << 3) + q >> 3]) * 134217728);
        j = e;
        e = (v[e >> 2] >> 1) + un(i) | 0;
        r = e;
        e = $t(m) + e & -4096;
        v[j >> 2] = r - e;
        A[a + 24 >> 3] = +(e | 0) * 7.450580596923828e-9;
        v[a + 16 >> 2] = 0;
        v[a + 20 >> 2] = -1074790400;
        v[a + 8 >> 2] = 0;
        v[a + 12 >> 2] = 1072693248;
        j = (d << 2) + n | 0;
        i = Ee(A[Xg(a + 24 | 0, a + 16 | 0, a + 8 | 0) >> 3] * 32768);
        f: {
         if (D(i) < 2147483648) {
          e = ~~i;
          break f;
         }
         e = -2147483648;
        }
        s = (v[j >> 2] + (l << 1) | 0) + (h << 1) | 0, t = fd(e), u[s >> 1] = t;
        d = d + 1 | 0;
        continue;
       }
      }
     }
     Z(7244, 9045, 77, 8725);
     p();
    }
    Z(7209, 9045, 78, 8725);
    p();
   }
   Z(5897, 9045, 79, 8725);
   p();
  }
  Z(5867, 9045, 80, 8725);
  p();
 }
 eb = a + 32 | 0;
 eb = c - -64 | 0;
}

function Ioa(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0;
 e = eb - 48 | 0;
 eb = e;
 md(b, 2);
 f = e + 24 | 0;
 Ik(f, 2, a + 1 | 0);
 d = e + 36 | 0;
 Bc(d, f);
 Ae(b + 43 | 0, d);
 sb(d);
 a: {
  b: {
   c: {
    d: {
     switch (w[a | 0]) {
     case 0:
      f = v[b + 4 >> 2];
      d = v[b + 8 >> 2];
      break c;

     case 2:
      break b;

     case 1:
      break d;

     default:
      break a;
     }
    }
    d = w[a + 16 | 0] | w[a + 17 | 0] << 8 | (w[a + 18 | 0] << 16 | w[a + 19 | 0] << 24);
    v[b >> 2] = d;
    v[e + 36 >> 2] = w[a + 20 | 0] | w[a + 21 | 0] << 8 | (w[a + 22 | 0] << 16 | w[a + 23 | 0] << 24);
    v[e + 24 >> 2] = d - 1;
    d = e + 36 | 0;
    f = v[Gb(d, e + 24 | 0) >> 2];
    v[b + 4 >> 2] = f;
    v[e + 36 >> 2] = w[a + 24 | 0] | w[a + 25 | 0] << 8 | (w[a + 26 | 0] << 16 | w[a + 27 | 0] << 24);
    d = v[Gb(d, b) >> 2];
    v[b + 8 >> 2] = d;
    u[b + 34 >> 1] = x[b + 34 >> 1] & 65533 | w[a + 31 | 0] << 1 & 2;
   }
   if (d >>> 0 > f >>> 0 & d >>> 0 >= 2) {
    break a;
   }
   u[b + 34 >> 1] = 0;
   v[b + 4 >> 2] = 0;
   v[b + 8 >> 2] = 0;
   break a;
  }
  f = e + 24 | 0;
  lh(f, a + 16 | 0);
  d = v[e + 24 >> 2];
  v[e + 36 >> 2] = w[d | 0] | w[d + 1 | 0] << 8 | (w[d + 2 | 0] << 16 | w[d + 3 | 0] << 24);
  lh(f, a + 20 | 0);
  d = v[e + 24 >> 2];
  v[e + 40 >> 2] = w[d | 0] | w[d + 1 | 0] << 8 | (w[d + 2 | 0] << 16 | w[d + 3 | 0] << 24);
  lh(f, a + 24 | 0);
  d = v[e + 24 >> 2];
  d = w[d | 0] | w[d + 1 | 0] << 8 | (w[d + 2 | 0] << 16 | w[d + 3 | 0] << 24);
  v[e + 44 >> 2] = d;
  v[e + 16 >> 2] = d;
  d = v[e + 40 >> 2];
  v[e + 8 >> 2] = v[e + 36 >> 2];
  v[e + 12 >> 2] = d;
  Qk(b, 1, e + 8 | 0);
 }
 t[e + 36 | 0] = w[a + 28 | 0];
 t[e + 24 | 0] = 64;
 g = b, h = w[Pb(e + 36 | 0, e + 24 | 0) | 0] << 2, u[g + 30 >> 1] = h;
 d = w[a + 32 | 0] | w[a + 33 | 0] << 8 | (w[a + 34 | 0] << 16 | w[a + 35 | 0] << 24);
 v[b + 24 >> 2] = d;
 b = b + 24 | 0;
 e: {
  if (!c) {
   break e;
  }
  if (w[a | 0] == 2) {
   d = d & 65535;
   v[b >> 2] = d;
   break e;
  }
  if (y[b >> 2] >= 65536) {
   v[b >> 2] = 65535;
  }
  d = v[b >> 2];
 }
 f: {
  g: {
   if (!d) {
    a = 8363;
    break g;
   }
   a = 1024;
   if (d >>> 0 > 1023) {
    break f;
   }
  }
  v[b >> 2] = a;
 }
 eb = e + 48 | 0;
}

function kka(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0;
 l = eb - 16 | 0;
 eb = l;
 v[l + 12 >> 2] = b;
 q = Of(a);
 while (1) {
  if (Yg(b, c)) {
   e = v[ub(l + 8 | 0, q) >> 2];
   j = td(b);
   o = eb - 16 | 0;
   eb = o;
   p = 0;
   m = eb - 16 | 0;
   eb = m;
   h = eb - 32 | 0;
   eb = h;
   f = h + 28 | 0;
   d = h + 24 | 0;
   k = eb - 16 | 0;
   eb = k;
   a: {
    b: {
     b = e;
     if (!lc(b, v[ub(k + 12 | 0, og(a)) >> 2])) {
      e = w[j | 0];
      i = v[j + 4 >> 2];
      g = td(b);
      n = w[g | 0];
      g = v[g + 4 >> 2];
      if (!Ao(e, i, n, g)) {
       break b;
      }
     }
     v[k + 12 >> 2] = b;
     c: {
      if (!lc(b, v[ub(k + 8 | 0, vb(v[a >> 2])) >> 2])) {
       d = v[MB(k + 12 | 0) >> 2];
       e = td(d);
       g = w[e | 0];
       n = v[e + 4 >> 2];
       e = w[j | 0];
       i = v[j + 4 >> 2];
       if (Ao(g, n, e, i)) {
        break c;
       }
       b = gB(a, f, e, i);
       break a;
      }
      d = b;
     }
     if (!v[b >> 2]) {
      v[f >> 2] = b;
      break a;
     }
     v[f >> 2] = d;
     b = d + 4 | 0;
     break a;
    }
    if (Ao(n, g, e, i)) {
     d: {
      d = KB(b);
      if (!lc(d, v[ub(k + 12 | 0, og(a)) >> 2])) {
       e = w[j | 0];
       i = v[j + 4 >> 2];
       g = td(d);
       if (!Ao(e, i, w[g | 0], v[g + 4 >> 2])) {
        break d;
       }
      }
      if (!v[b + 4 >> 2]) {
       v[f >> 2] = b;
       b = b + 4 | 0;
       break a;
      }
      v[f >> 2] = d;
      b = d;
      break a;
     }
     b = gB(a, f, e, i);
     break a;
    }
    v[f >> 2] = b;
    v[d >> 2] = b;
    b = d;
   }
   eb = k + 16 | 0;
   d = v[b >> 2];
   if (!d) {
    d = eb - 16 | 0;
    eb = d;
    f = fc(a);
    e = h + 12 | 0;
    f = Ch(e, Dc(28), Ng(d + 8 | 0, f));
    yC(v[f >> 2] + 16 | 0, j);
    r = fc(f), s = 1, t[r + 4 | 0] = s;
    eb = d + 16 | 0;
    _g(a, v[h + 28 >> 2], b, v[h + 12 >> 2]);
    d = me(e);
    Gk(e);
    p = 1;
   }
   Zg(m + 8 | 0, v[ub(h + 12 | 0, d) >> 2], p);
   eb = h + 32 | 0;
   eb = m + 16 | 0;
   ub(o + 12 | 0, v[m + 8 >> 2]);
   eb = o + 16 | 0;
   b = v[$g(l + 12 | 0) >> 2];
   continue;
  } else {
   eb = l + 16 | 0;
  }
  break;
 }
}

function Fla(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, u = 0, w = 0, x = 0, y = 0, z = 0, A = 0;
 g = eb - 16 | 0;
 eb = g;
 r = v[a + 16 >> 2];
 s = Fg(b + 327720 | 0, v[b + 20 >> 2], (v[a + 88 >> 2] & 16384) >>> 14 | 0);
 k = v[a + 8 >> 2];
 l = v[a + 12 >> 2];
 h = v[a >> 2];
 e = v[a + 4 >> 2];
 m = v[a + 128 >> 2];
 if (m) {
  n = Gg(k, l, m);
  o = gb;
  b = v[a + 76 >> 2];
  eg(h, e, uf(k, l, d), gb);
  p = gb >>> 0 > b >>> 0 ? d : 0;
 }
 i = a + 112 | 0;
 u = v[a + 24 >> 2];
 w = v[a + 20 >> 2];
 f = v[a + 48 >> 2];
 b = v[a + 44 >> 2];
 v[g >> 2] = h;
 v[g + 4 >> 2] = e;
 a: while (1) {
  b: {
   q = b;
   if (!d) {
    break b;
   }
   d = d - 1 | 0;
   v[g + 8 >> 2] = h;
   v[g + 12 >> 2] = 0;
   p = p - 1 | 0;
   b = p;
   n = b ? n : 0;
   o = b ? o : 0;
   h = e + r | 0;
   b = m;
   while (1) if ((b | 0) <= 0) {
    Ob(i, v[a + 120 >> 2], v[a + 124 >> 2]);
    b = v[a + 116 >> 2];
    if (b) {
     be(i, t[h + v[g + 12 >> 2] | 0] << 6);
     ae(i, b);
     v[i >> 2] = v[i >> 2];
     v[i + 4 >> 2] = 0;
    }
    x = v[a + 72 >> 2];
    y = v[c >> 2];
    h = Eg(i, s) << 8;
    b = h;
    j = b >> 31;
    b = v[a + 60 >> 2];
    b = Aua(h, j, b, b >> 31);
    z = gb;
    e = b;
    b = v[a + 64 >> 2];
    j = b;
    A = b >> 31;
    b = Xb(q, -16777216, 16776704);
    j = Aua(j, A, b, b >> 31);
    e = e + j | 0;
    b = gb + z | 0;
    b = e >>> 0 < j >>> 0 ? b + 1 | 0 : b;
    j = e;
    e = v[a + 68 >> 2];
    f = Xb(f, -16777216, 16776704);
    e = Aua(e, e >> 31, f, f >> 31);
    f = j + e | 0;
    b = gb + b | 0;
    b = e >>> 0 > f >>> 0 ? b + 1 | 0 : b;
    f = f + 8388608 | 0;
    b = f >>> 0 < 8388608 ? b + 1 | 0 : b;
    b = Rc(f, b, 24);
    f = (b | 0) / 256 | 0;
    v[c >> 2] = B(f, w) + y;
    v[c + 4 >> 2] = v[c + 4 >> 2] + B(f, u);
    Ob(g, k, l);
    b = b - (h & x) | 0;
    c = c + 8 | 0;
    h = v[g >> 2];
    e = v[g + 4 >> 2];
    f = q;
    continue a;
   } else {
    be(i, t[h + v[g + 12 >> 2] | 0] << 6);
    ae(i, 4);
    Ob(g + 8 | 0, n, o);
    b = b - 1 | 0;
    continue;
   }
  }
  break;
 }
 v[a >> 2] = h;
 v[a + 4 >> 2] = e;
 v[a + 48 >> 2] = f;
 v[a + 44 >> 2] = q;
 eb = g + 16 | 0;
}

function mta(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, q = 0;
 d = eb - 1072 | 0;
 eb = d;
 v[d + 1068 >> 2] = c;
 o = d, q = Yd(b), t[o + 8 | 0] = q;
 t[d + 4 | 0] = 1;
 c = d + 8 | 0;
 e = d + 4 | 0;
 h = w[cf(c, e) | 0];
 f = eE(c, b);
 l = Ar(f);
 v[31601] = 0;
 c = Q(202, b | 0) | 0;
 g = v[31601];
 v[31601] = 0;
 a: {
  if ((g | 0) != 1) {
   v[d + 4 >> 2] = c;
   v[d >> 2] = 536870911;
   wc(d + 1068 | 0, v[Gb(e, d) >> 2] << 3);
   v[31601] = 0;
   m = v[d + 1068 >> 2];
   k = O(341, a | 0, m | 0) | 0;
   a = v[31601];
   v[31601] = 0;
   if ((a | 0) != 1) {
    v[31601] = 0;
    c = 8;
    i = O(158, f | 0, 8) | 0;
    a = v[31601];
    v[31601] = 0;
    b: {
     if ((a | 0) != 1) {
      c: {
       o = wb(v[k >> 2], 0), q = i, t[o | 0] = q;
       g = 1;
       a = h;
       while (1) {
        c = c & 255;
        n = c >>> 0 <= 9 ? 9 : c;
        e = a;
        d: {
         e: {
          while (1) {
           if (g >>> 0 >= m >>> 0) {
            break d;
           }
           v[31601] = 0;
           j = O(158, f | 0, c | 0) | 0;
           a = v[31601];
           v[31601] = 0;
           if ((a | 0) != 1) {
            if (j) {
             break e;
            }
            if ((c | 0) == (n | 0)) {
             break d;
            }
            c = c + 1 | 0;
            e = h;
            continue;
           }
           break;
          }
          break c;
         }
         a = j >>> 1 | 0;
         i = (j & 1 ? 0 - a | 0 : a) + i | 0;
         o = wb(v[k >> 2], g), q = i, t[o | 0] = q;
         g = g + 1 | 0;
         a = h;
         if (j >>> c - 1 | 0) {
          continue;
         }
         a = e - 1 | 0;
         e = a & 255;
         a = e ? a : h;
         c = c - (!e & (c & 255) >>> 0 > 1) | 0;
         continue;
        }
        break;
       }
       a = Ar(f);
       v[31601] = 0;
       O(149, b | 0, ((a - l | 0) + 3 & -4) + l | 0) | 0;
       a = v[31601];
       v[31601] = 0;
       if ((a | 0) != 1) {
        break b;
       }
      }
     }
     c = M() | 0;
     ec(k);
     break a;
    }
    tb(f);
    eb = d + 1072 | 0;
    return;
   }
   c = M() | 0;
   break a;
  }
  c = M() | 0;
 }
 tb(f);
 P(c | 0);
 p();
}

function Hla(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, u = 0;
 f = eb - 16 | 0;
 eb = f;
 s = v[a + 16 >> 2];
 u = Fg(b + 327720 | 0, v[b + 20 >> 2], (v[a + 88 >> 2] & 16384) >>> 14 | 0);
 k = v[a + 8 >> 2];
 l = v[a + 12 >> 2];
 b = v[a >> 2];
 g = v[a + 4 >> 2];
 m = v[a + 128 >> 2];
 if (m) {
  n = Gg(k, l, m);
  o = gb;
  h = v[a + 76 >> 2];
  eg(b, g, uf(k, l, d), gb);
  p = gb >>> 0 > h >>> 0 ? d : 0;
 }
 h = a + 112 | 0;
 i = v[a + 40 >> 2];
 j = v[a + 36 >> 2];
 v[f >> 2] = b;
 v[f + 4 >> 2] = g;
 while (1) {
  if (d) {
   d = d - 1 | 0;
   v[f + 8 >> 2] = b;
   v[f + 12 >> 2] = 0;
   p = p - 1 | 0;
   e = p;
   n = e ? n : 0;
   o = e ? o : 0;
   r = (((g & 2147483647) << 1 | b >>> 31) & -2) + s | 0;
   g = m;
   a: {
    b: while (1) {
     c: {
      if ((g | 0) <= 0) {
       Ob(h, v[a + 120 >> 2], v[a + 124 >> 2]);
       g = v[a + 116 >> 2];
       if (!g) {
        break a;
       }
       e = v[f + 8 >> 2];
       q = ((v[f + 12 >> 2] & 2147483647) << 1 | e >>> 31) & -2;
       e = 0;
       b = 0;
       break c;
      }
      e = v[f + 8 >> 2];
      q = ((v[f + 12 >> 2] & 2147483647) << 1 | e >>> 31) & -2;
      b = 0;
      e = 0;
      while (1) if ((b | 0) == 2) {
       be(h, e >>> 3 << 16 >> 16);
       ae(h, 4);
       Ob(f + 8 | 0, n, o);
       g = g - 1 | 0;
       continue b;
      } else {
       e = (t[(b | q) + r | 0] << 8) + e | 0;
       b = b + 1 | 0;
       continue;
      }
     }
     break;
    }
    while (1) {
     if ((b | 0) != 2) {
      e = (t[(b | q) + r | 0] << 8) + e | 0;
      b = b + 1 | 0;
      continue;
     }
     break;
    }
    be(h, e >>> 3 << 16 >> 16);
    ae(h, g);
    v[h >> 2] = v[h >> 2];
    v[h + 4 >> 2] = 0;
   }
   g = v[a + 32 >> 2];
   e = v[c >> 2];
   b = Eg(h, u);
   j = v[a + 28 >> 2] + j | 0;
   v[c >> 2] = B(b, j >> 12) + e;
   i = g + i | 0;
   v[c + 4 >> 2] = v[c + 4 >> 2] + B(b, i >> 12);
   Ob(f, k, l);
   c = c + 8 | 0;
   b = v[f >> 2];
   g = v[f + 4 >> 2];
   continue;
  }
  break;
 }
 v[a >> 2] = b;
 v[a + 4 >> 2] = g;
 v[a + 40 >> 2] = i;
 v[a + 20 >> 2] = j >> 12;
 v[a + 36 >> 2] = j;
 v[a + 24 >> 2] = i >> 12;
 eb = f + 16 | 0;
}

function SA(a, b) {
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, v = 0, w = 0, x = 0, y = 0, z = 0, A = 0;
 h = 89;
 i = 92;
 j = 91;
 k = 85;
 l = 84;
 m = 83;
 n = 5;
 o = 118;
 p = 113;
 q = 111;
 r = 107;
 s = 106;
 t = 96;
 c = 88;
 u = 82;
 v = 80;
 w = 78;
 x = 79;
 y = 77;
 z = 57;
 A = 47;
 d = 10;
 e = 8;
 f = 7;
 a = ds(a);
 a: {
  b: {
   c: {
    d: {
     switch (b - 1 | 0) {
     default:
      c = (b | 0) == 16777216;
      if (!c & (b | 0) != 32) {
       break c;
      }
      Kb(Kb(Kb(Kb(Kb(Kb(Kb(Kb(Kb(Kb(Kb(Kb(Kb(Kb(Kb(Kb(Kb(Kb(Kb(Kb(Kb(Kb(Kb(Kb(Kb(Kb(Kb(Kb(Kb(Kb(Kb(Kb(Kb(Kb(Kb(Kb(Kb(Kb(Kb(Kb(Kb(Kb(Kb(Kb(Kb(Kb(Kb(Kb(Kb(Kb(Kb(Kb(Kb(a, 0, 1), 7, 1), 8, 1), 9, 1), 10, 1), 11, 1), 12, 1), 13, 1), 14, 1), 15, 1), 16, 1), 17, 1), 18, 1), 19, 1), 20, 1), 21, 1), 22, 1), 23, 1), 24, 1), 25, 1), 26, 1), 27, 1), 28, 1), 29, 1), 30, 1), 31, 1), 32, 1), 33, 1), 34, 1), 35, 1), 36, 1), 37, 1), 38, 1), 39, 1), 40, 1), 41, 1), 42, 1), 43, 1), 44, 1), 45, 1), 46, 1), 47, 1), 48, 1), 103, 1), 50, 1), 87, 1), 88, 1), 100, 1), 102, 1), 104, 1), 115, 1), 119, 1), 120, 1);
      if (!c) {
       break a;
      }
      d = 111;
      e = 105;
      f = 99;
      break b;

     case 3:
      Kb(Kb(Kb(Kb(Kb(Kb(Kb(Kb(Kb(Kb(Kb(Kb(Kb(Kb(Kb(Kb(Kb(Kb(Kb(Kb(Kb(Kb(Kb(a, 0, 1), 4, 1), 8, 1), 9, 1), 10, 1), 17, 1), 40, 1), 51, 1), 52, 1), 53, 1), 54, 1), 55, 1), 56, 1), 57, 1), 58, 1), 59, 1), 60, 1), 61, 1), 62, 1), 63, 1), 64, 1), 65, 1), 66, 1);
      o = 112;
      p = 98;
      q = 93;
      r = 90;
      s = 89;
      t = 88;
      c = 86;
      u = 76;
      v = 75;
      w = 74;
      x = 73;
      y = 72;
      z = 71;
      A = 70;
      d = 69;
      e = 68;
      g = 67;

     case 1:
      Kb(Kb(Kb(Kb(Kb(Kb(Kb(Kb(Kb(a, g, 1), e, 1), d, 1), A, 1), z, 1), y, 1), x, 1), w, 1), v, 1);
      n = u;
      m = c;
      l = t;
      k = s;
      j = r;
      i = q;
      c = p;
      h = o;
      break;

     case 2:
      break c;

     case 0:
      break d;
     }
    }
    Kb(Kb(Kb(Kb(a, n, 1), m, 1), l, 1), k, 1);
    g = j;
    f = i;
    e = c;
    d = h;
   }
   Kb(a, g, 1);
  }
  Kb(Kb(Kb(a, f, 1), e, 1), d, 1);
 }
}

function Aaa(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, q = 0, r = 0, s = 0, t = 0, w = 0;
 c = eb + -64 | 0;
 eb = c;
 d = v[a >> 2];
 a = v[d >> 2];
 e = v[a + 4 >> 2];
 v[c + 40 >> 2] = v[a + 20 >> 2];
 f = v[a + 16 >> 2];
 v[c + 32 >> 2] = v[a + 12 >> 2];
 v[c + 36 >> 2] = f;
 Wf(c + 48 | 0, c + 32 | 0, e);
 a = v[d + 4 >> 2];
 e = v[a + 8 >> 2];
 f = v[a + 4 >> 2];
 d = v[c + 60 >> 2];
 v[c + 24 >> 2] = v[c + 56 >> 2];
 v[c + 28 >> 2] = d;
 d = v[c + 52 >> 2];
 v[c + 16 >> 2] = v[c + 48 >> 2];
 v[c + 20 >> 2] = d;
 v[c + 8 >> 2] = v[a + 8 >> 2];
 d = v[a + 4 >> 2];
 v[c >> 2] = v[a >> 2];
 v[c + 4 >> 2] = d;
 a = eb - 32 | 0;
 eb = a;
 a: {
  b: {
   c: {
    d: {
     g = v[c + 4 >> 2];
     if (g >>> 0 >= f >>> 0) {
      h = v[c + 20 >> 2];
      if (h >>> 0 < f >>> 0) {
       break d;
      }
      if (e >>> 0 > y[c + 8 >> 2]) {
       break c;
      }
      i = v[c + 28 >> 2];
      if (e >>> 0 > v[c + 24 >> 2] - i >>> 0) {
       break b;
      }
      l = b + 12 | 0;
      m = v[c + 16 >> 2];
      n = v[c >> 2];
      b = 0;
      e: while (1) {
       if ((b | 0) == (e | 0)) {
        break a;
       }
       o = (B(b, g) << 3) + n | 0;
       q = (B(b + i | 0, h) << 1) + m | 0;
       d = 0;
       while (1) if ((d | 0) == (f | 0)) {
        b = b + 1 | 0;
        continue e;
       } else {
        s = a, t = +(un(Ee(Ig(A[(d << 3) + o >> 3]) * 134217728)) + qd(_t(l), 21) | 0) * 7.450580596923828e-9, 
        A[s + 24 >> 3] = t;
        v[a + 16 >> 2] = 0;
        v[a + 20 >> 2] = -1074790400;
        v[a + 8 >> 2] = 0;
        v[a + 12 >> 2] = 1072693248;
        r = (d << 1) + q | 0;
        j = Ee(A[Xg(a + 24 | 0, a + 16 | 0, a + 8 | 0) >> 3] * 32768);
        f: {
         if (D(j) < 2147483648) {
          k = ~~j;
          break f;
         }
         k = -2147483648;
        }
        s = r, w = fd(k), u[s >> 1] = w;
        d = d + 1 | 0;
        continue;
       }
      }
     }
     Z(7244, 9045, 77, 8725);
     p();
    }
    Z(7209, 9045, 78, 8725);
    p();
   }
   Z(5897, 9045, 79, 8725);
   p();
  }
  Z(5867, 9045, 80, 8725);
  p();
 }
 eb = a + 32 | 0;
 eb = c - -64 | 0;
}

function zB(a, b, c, d, e) {
 var f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0;
 h = eb - 16 | 0;
 eb = h;
 f = v[c + 656 >> 2];
 a: {
  if (!Jj(f)) {
   i = v[c + 704 >> 2];
   f = eb - 16 | 0;
   eb = f;
   v[f + 12 >> 2] = d;
   g = 0;
   b: {
    if (!d) {
     break b;
    }
    j = v[b + 480180 >> 2];
    if (j & 20) {
     e = b + 1074312 | 0;
     d = Nb(e, 73) ? d & 65535 : d;
     if (w[b + 480208 | 0] & 16) {
      e = Nb(e, 73) ? 14 - ((9983 - d >>> 0) / 768 | 0) & 31 : ((d >>> 0) / 768 | 0) + 2 | 0;
      g = v[((d >>> 0) % 768 << 2) + 32272 >> 2] << 6 >>> e | 0;
      break b;
     }
     g = 229079296 / ((d >>> 0 <= 1 ? 1 : d) >>> 0) | 0;
     break b;
    }
    g = 227001280 / (d >>> 0) | 0;
    if (wn(j)) {
     break b;
    }
    g = (d + i << 4) - 133808 | 0;
    if ((j | 0) == 64) {
     break b;
    }
    wc(f + 12 | 0, 16777215);
    if (j & 17408) {
     g = Ac(Cua(Aua(i ? i : 8363, 0, 3506176, 0), gb, (v[f + 12 >> 2] << 8) + e | 0, 0), gb);
     break b;
    }
    if (yj(b)) {
     d = v[f + 12 >> 2];
     i = d >>> 24 | 0;
     j = d << 8;
     d = j + e | 0;
     e = i + (e >> 31) | 0;
     g = ((d >>> 0 < j >>> 0 ? e + 1 | 0 : e) & 15) << 28 | d >>> 4;
     break b;
    }
    if (w[b + 480208 | 0] & 16) {
     g = Ac(Cua(Aua(i ? i : 8363, 0, 7012352, 0), gb, (v[f + 12 >> 2] << 8) + e | 0, 0), gb);
     break b;
    }
    g = Ac(Cua(-1485242368, 13, (v[f + 12 >> 2] << 8) + e | 0, 0), gb);
   }
   e = g;
   eb = f + 16 | 0;
   f = v[c + 656 >> 2];
   break a;
  }
  e = v[c + 700 >> 2];
 }
 v[h + 12 >> 2] = e;
 c = u[c + 774 >> 1];
 c: {
  if (!c) {
   break c;
  }
  c = f ? B(t[f + 33 | 0], c) : c;
  if (!c) {
   break c;
  }
  e = Te(zi(+(c | 0) / 393216) * +(e >>> 0));
  v[h + 12 >> 2] = e;
 }
 d: {
  if (!f) {
   break d;
  }
  c = v[f + 40 >> 2];
  if (!c) {
   break d;
  }
  d = (c | 0) / 2 | 0;
  f = v[b + 1074420 >> 2];
  e = Aua(f, f >> 31, e, e >> 31);
  f = d + e | 0;
  d = gb + (d >> 31) | 0;
  k = h, l = Fc(Bua(f, e >>> 0 > f >>> 0 ? d + 1 | 0 : d, c, c >> 31), gb), v[k + 12 >> 2] = l;
 }
 wc(h + 12 | 0, 2147483647);
 c = v[h + 12 >> 2];
 b = jg(c, v[b + 24620 >> 2] << 4);
 v[a + 8 >> 2] = c;
 v[a >> 2] = b;
 v[a + 4 >> 2] = gb;
 eb = h + 16 | 0;
}

function De(a, b) {
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = C(0), i = 0, k = 0;
 d = (q(b), j(2));
 c = fI(d);
 a: {
  b: {
   c: {
    d: {
     e = (q(a), j(2));
     e: {
      if (e - 2139095040 >>> 0 >= 2164260864) {
       if (c) {
        break e;
       }
       break c;
      }
      if (!c) {
       break d;
      }
     }
     h = C(1);
     if ((e | 0) == 1065353216) {
      break b;
     }
     c = d << 1;
     if (!c) {
      break b;
     }
     i = c >>> 0 < 4278190081;
     c = e << 1;
     a = C(a + b);
     if (!(i & c >>> 0 <= 4278190080)) {
      break a;
     }
     if ((c | 0) == 2130706432) {
      break b;
     }
     a = (d | 0) < 0 ^ c >>> 0 < 2130706432 ? C(0) : C(b * b);
     break a;
    }
    if (fI(e)) {
     h = C(a * a);
     if ((e | 0) < 0) {
      h = (eI(d) | 0) == 1 ? C(-h) : h;
     }
     if ((d | 0) >= 0) {
      break b;
     }
     a = Lx(C(C(1) / h));
     break a;
    }
    if ((e | 0) < 0) {
     c = eI(d);
     if (!c) {
      a = ZI(a);
      break a;
     }
     e = (q(a), j(2)) & 2147483647;
     i = ((c | 0) == 1) << 16;
    }
    if (e >>> 0 > 8388607) {
     break c;
    }
    e = ((q(C(a * C(8388608))), j(2)) & 2147483647) - 192937984 | 0;
   }
   d = e - 1060306944 | 0;
   c = d >>> 15 & 240;
   f = +(l(2, e - (d & -8388608) | 0), r()) * A[c + 125136 >> 3] + -1;
   g = f * f;
   f = ((f * .288457581109214 + -.36092606229713164) * (g * g) + ((f * .480898481472577 + -.7213474675006291) * g + (f * 1.4426950408774342 + (A[c + 125144 >> 3] + +(d >> 23))))) * +b;
   o(+f);
   c = j(1) | 0;
   j(0) | 0;
   f: {
    c = c & 2147450880;
    if ((c | 0) == 1079967744 | c >>> 0 < 1079967744) {
     break f;
    }
    if (f > 127.99999995700433) {
     a = RG(i);
     break a;
    }
    if (!(f <= -150)) {
     break f;
    }
    a = zG(i);
    break a;
   }
   k = f;
   g = A[160];
   f = g + f;
   g = k - (f - g);
   g = (A[161] * g + A[162]) * (g * g) + (A[163] * g + 1);
   o(+f);
   j(1) | 0;
   e = j(0) | 0;
   d = i + e | 0;
   i = d << 15;
   d = ((e & 31) << 3) + 1024 | 0;
   c = v[d >> 2];
   d = v[d + 4 >> 2] + i | 0;
   l(0, c | 0);
   l(1, (c >>> 0 > c >>> 0 ? d + 1 | 0 : d) | 0);
   h = C(g * +n());
  }
  a = h;
 }
 return a;
}

function yS(a) {
 var b = 0, c = 0, d = 0, e = 0, f = 0, g = 0, h = 0;
 f = eb - 48 | 0;
 eb = f;
 b = Kw(f + 30 | 0, v[a >> 2]);
 c = kq(f + 29 | 0, v[a + 4 >> 2]);
 tY(f + 32 | 0, x[b >> 1], c);
 c = kq(f + 28 | 0, v[a + 8 >> 2]);
 d = x[f + 32 >> 1];
 b = eb - 16 | 0;
 eb = b;
 t[b + 15 | 0] = w[f + 34 | 0];
 rS(f + 36 | 0, d, b + 15 | 0, c);
 eb = b + 16 | 0;
 c = eb - 16 | 0;
 eb = c;
 d = eb - 16 | 0;
 eb = d;
 h = x[f + 36 >> 1] << 16 >> 16;
 g = w[f + 38 | 0];
 b = yf(g);
 e = yf(2);
 g = yf(g);
 b = h - (((b | 0) != (e | 0) ? b >>> 0 < e >>> 0 ? -1 : 1 : 0) << 24 >> 24 <= 0) | 0;
 e = (((b | 0) < 0 ? b - 399 | 0 : b) | 0) / 400 | 0;
 b = B(e, -400) + b | 0;
 b = v[ub(d + 12 | 0, ((((yf(w[f + 39 | 0]) + B(e, 146097) | 0) + ((B(g + (g >>> 0 > 2 ? -3 : 9) | 0, 153) + 2 >>> 0) / 5 | 0) + (b >>> 2) | 0) + B(b, 365) | 0) - ((b >>> 0) / 100 | 0) | 0) - 719469 | 0) >> 2];
 eb = d + 16 | 0;
 e = v[ub(c + 12 | 0, b) >> 2];
 eb = c + 16 | 0;
 g = ub(f + 24 | 0, v[a + 12 >> 2]);
 c = eb - 16 | 0;
 eb = c;
 b = eb - 16 | 0;
 eb = b;
 d = eb - 16 | 0;
 eb = d;
 e = v[ub(d + 12 | 0, B(e, 24)) >> 2];
 eb = d + 16 | 0;
 v[b + 8 >> 2] = e;
 d = v[ub(b + 12 | 0, v[g >> 2] + v[b + 8 >> 2] | 0) >> 2];
 eb = b + 16 | 0;
 e = v[ub(c + 12 | 0, d) >> 2];
 eb = c + 16 | 0;
 g = ub(f + 20 | 0, v[a + 16 >> 2]);
 c = eb - 16 | 0;
 eb = c;
 b = eb - 16 | 0;
 eb = b;
 d = eb - 16 | 0;
 eb = d;
 e = v[ub(d + 12 | 0, B(e, 60)) >> 2];
 eb = d + 16 | 0;
 v[b + 8 >> 2] = e;
 d = v[ub(b + 12 | 0, v[g >> 2] + v[b + 8 >> 2] | 0) >> 2];
 eb = b + 16 | 0;
 b = v[ub(c + 12 | 0, d) >> 2];
 eb = c + 16 | 0;
 c = we(f + 8 | 0, v[a + 24 >> 2], v[a + 28 >> 2]);
 d = eb - 16 | 0;
 eb = d;
 a = eb - 16 | 0;
 eb = a;
 e = eb - 16 | 0;
 eb = e;
 b = we(e + 8 | 0, Aua(b, b >> 31, 60, 0), gb);
 g = v[b >> 2];
 b = v[b + 4 >> 2];
 eb = e + 16 | 0;
 v[a >> 2] = g;
 v[a + 4 >> 2] = b;
 b = v[a >> 2];
 e = b + v[c >> 2] | 0;
 c = v[c + 4 >> 2] + v[a + 4 >> 2] | 0;
 b = we(a + 8 | 0, e, b >>> 0 > e >>> 0 ? c + 1 | 0 : c);
 c = v[b >> 2];
 eb = a + 16 | 0;
 a = we(d + 8 | 0, c, v[b + 4 >> 2]);
 b = v[a >> 2];
 eb = d + 16 | 0;
 a = Hu(f + 40 | 0, b, v[a + 4 >> 2]);
 b = v[a >> 2];
 eb = f + 48 | 0;
 gb = v[a + 4 >> 2];
 return b;
}

function cna(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, w = 0, x = 0, y = 0, z = 0, A = 0, C = 0, D = 0, E = 0;
 b = eb - 48 | 0;
 eb = b;
 q = v[a + 16 >> 2];
 k = jg(1, 2);
 f = gb;
 r = f;
 Ob(a, k, f);
 v[b + 32 >> 2] = v[a + 44 >> 2];
 v[b + 36 >> 2] = v[a + 48 >> 2];
 v[b + 40 >> 2] = v[a + 52 >> 2];
 v[b + 44 >> 2] = v[a + 56 >> 2];
 s = v[a + 24 >> 2];
 t = v[a + 20 >> 2];
 f = v[a + 4 >> 2];
 v[b + 16 >> 2] = v[a >> 2];
 v[b + 20 >> 2] = f;
 w = b + 32 | 0;
 x = v[a + 72 >> 2];
 l = v[a + 68 >> 2];
 y = l >> 31;
 m = v[a + 64 >> 2];
 z = m >> 31;
 n = v[a + 60 >> 2];
 A = n >> 31;
 C = v[a + 8 >> 2];
 D = v[a + 12 >> 2];
 while (1) {
  if (d) {
   d = d - 1 | 0;
   f = v[b + 16 >> 2];
   f = ((((v[b + 20 >> 2] & 2147483647) << 1 | f >>> 31) & 2147483646) << 1) + q | 0;
   v[b + 8 >> 2] = u[f >> 1];
   v[b + 12 >> 2] = u[f + 2 >> 1];
   j = 0;
   while (1) {
    if ((j | 0) != 2) {
     o = (b + 8 | 0) + (j << 2) | 0;
     e = v[o >> 2];
     f = (j << 3) + w | 0;
     E = v[f + 4 >> 2];
     g = v[f >> 2];
     v[f + 4 >> 2] = g;
     p = e << 8;
     e = p;
     e = Aua(e, e >> 31, n, A);
     h = gb;
     i = e;
     e = Xb(g, -16777216, 16776704);
     e = Aua(m, z, e, e >> 31);
     g = i + e | 0;
     i = gb + h | 0;
     i = e >>> 0 > g >>> 0 ? i + 1 | 0 : i;
     e = Xb(E, -16777216, 16776704);
     h = Aua(l, y, e, e >> 31);
     g = h + g | 0;
     e = gb + i | 0;
     e = g >>> 0 < h >>> 0 ? e + 1 | 0 : e;
     h = g + 8388608 | 0;
     e = h >>> 0 < 8388608 ? e + 1 | 0 : e;
     e = Rc(h, e, 24);
     v[f >> 2] = e - (x & p);
     v[o >> 2] = (e | 0) / 256;
     j = j + 1 | 0;
     continue;
    }
    break;
   }
   v[c >> 2] = v[c >> 2] + B(v[b + 8 >> 2], t);
   v[c + 4 >> 2] = v[c + 4 >> 2] + B(v[b + 12 >> 2], s);
   Ob(b + 16 | 0, C, D);
   c = c + 8 | 0;
   continue;
  }
  break;
 }
 c = v[b + 20 >> 2];
 v[a >> 2] = v[b + 16 >> 2];
 v[a + 4 >> 2] = c;
 v[a + 44 >> 2] = v[b + 32 >> 2];
 v[a + 48 >> 2] = v[b + 36 >> 2];
 v[a + 52 >> 2] = v[b + 40 >> 2];
 v[a + 56 >> 2] = v[b + 44 >> 2];
 Hg(a, k, r);
 eb = b + 48 | 0;
}

function dna(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, u = 0, w = 0, x = 0, y = 0, z = 0, A = 0, C = 0, D = 0, E = 0;
 b = eb - 48 | 0;
 eb = b;
 q = v[a + 16 >> 2];
 k = jg(1, 2);
 f = gb;
 r = f;
 Ob(a, k, f);
 v[b + 32 >> 2] = v[a + 44 >> 2];
 v[b + 36 >> 2] = v[a + 48 >> 2];
 v[b + 40 >> 2] = v[a + 52 >> 2];
 v[b + 44 >> 2] = v[a + 56 >> 2];
 s = v[a + 24 >> 2];
 u = v[a + 20 >> 2];
 f = v[a + 4 >> 2];
 v[b + 16 >> 2] = v[a >> 2];
 v[b + 20 >> 2] = f;
 w = b + 32 | 0;
 x = v[a + 72 >> 2];
 l = v[a + 68 >> 2];
 y = l >> 31;
 m = v[a + 64 >> 2];
 z = m >> 31;
 n = v[a + 60 >> 2];
 A = n >> 31;
 C = v[a + 8 >> 2];
 D = v[a + 12 >> 2];
 while (1) {
  if (d) {
   d = d - 1 | 0;
   f = v[b + 16 >> 2];
   f = (((v[b + 20 >> 2] & 2147483647) << 1 | f >>> 31) & -2) + q | 0;
   v[b + 8 >> 2] = t[f | 0] << 8;
   v[b + 12 >> 2] = t[f + 1 | 0] << 8;
   j = 0;
   while (1) {
    if ((j | 0) != 2) {
     o = (b + 8 | 0) + (j << 2) | 0;
     e = v[o >> 2];
     f = (j << 3) + w | 0;
     E = v[f + 4 >> 2];
     g = v[f >> 2];
     v[f + 4 >> 2] = g;
     p = e << 8;
     e = p;
     e = Aua(e, e >> 31, n, A);
     h = gb;
     i = e;
     e = Xb(g, -16777216, 16776704);
     e = Aua(m, z, e, e >> 31);
     g = i + e | 0;
     i = gb + h | 0;
     i = e >>> 0 > g >>> 0 ? i + 1 | 0 : i;
     e = Xb(E, -16777216, 16776704);
     h = Aua(l, y, e, e >> 31);
     g = h + g | 0;
     e = gb + i | 0;
     e = g >>> 0 < h >>> 0 ? e + 1 | 0 : e;
     h = g + 8388608 | 0;
     e = h >>> 0 < 8388608 ? e + 1 | 0 : e;
     e = Rc(h, e, 24);
     v[f >> 2] = e - (x & p);
     v[o >> 2] = (e | 0) / 256;
     j = j + 1 | 0;
     continue;
    }
    break;
   }
   v[c >> 2] = v[c >> 2] + B(v[b + 8 >> 2], u);
   v[c + 4 >> 2] = v[c + 4 >> 2] + B(v[b + 12 >> 2], s);
   Ob(b + 16 | 0, C, D);
   c = c + 8 | 0;
   continue;
  }
  break;
 }
 c = v[b + 20 >> 2];
 v[a >> 2] = v[b + 16 >> 2];
 v[a + 4 >> 2] = c;
 v[a + 44 >> 2] = v[b + 32 >> 2];
 v[a + 48 >> 2] = v[b + 36 >> 2];
 v[a + 52 >> 2] = v[b + 40 >> 2];
 v[a + 56 >> 2] = v[b + 44 >> 2];
 Hg(a, k, r);
 eb = b + 48 | 0;
}

function XP(a) {
 var b = C(0), c = C(0), d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, k = C(0), l = 0, m = C(0);
 d = eb - 16 | 0;
 eb = d;
 f = a + 4208 | 0;
 c = Wz(z[xb(f, 2) >> 2]);
 b = C(y[v[a + 16 >> 2] + 24620 >> 2]);
 z[d + 12 >> 2] = c / b;
 v[d + 8 >> 2] = 1056964608;
 c = uq(C(z[Qm(d + 12 | 0, d + 8 | 0) >> 2] * C(6.2831854820251465)));
 c = C(K(C(C(C(c + c) + C(3)) / C(5))));
 z[a + 4236 >> 2] = c;
 z[a + 4240 >> 2] = K(C(C(1) - C(c * c)));
 c = C(C(z[xb(f, 1) >> 2] * C(29)) + C(2));
 a: {
  if (c < C(4294967296) & c >= C(0)) {
   i = ~~c >>> 0;
   break a;
  }
  i = 0;
 }
 t[a + 4272 | 0] = i;
 e = i;
 while (1) {
  if (e & 255) {
   g = g + 1 | 0;
   e = (e & 254) >>> 1 | 0;
   continue;
  }
  break;
 }
 t[a + 4273 | 0] = g;
 k = De(C(10), C(C(C(z[a + 4208 >> 2] * C(60)) + C(-60)) / C(20)));
 l = d, m = C(Wz(z[xb(f, 3) >> 2]) / b), z[l + 12 >> 2] = m;
 v[d + 8 >> 2] = 1056964608;
 c = z[Qm(d + 12 | 0, d + 8 | 0) >> 2];
 l = d, m = C(Wz(z[xb(f, 4) >> 2]) / b), z[l + 12 >> 2] = m;
 v[d + 8 >> 2] = 1056964608;
 b = C(C(z[Qm(d + 12 | 0, d + 8 | 0) >> 2] * C(6.2831854820251465)) * C(.5));
 g = eb - 16 | 0;
 eb = g;
 f = (q(b), j(2));
 e = f & 2147483647;
 b: {
  if (e >>> 0 <= 1061752794) {
   if (e >>> 0 < 964689920) {
    break b;
   }
   b = lo(+b, 0);
   break b;
  }
  if (e >>> 0 <= 1081824209) {
   h = +b;
   if (e >>> 0 <= 1075235811) {
    b = lo(((f | 0) < 0 ? 1.5707963267948966 : -1.5707963267948966) + h, 1);
    break b;
   }
   b = lo(((f | 0) < 0 ? 3.141592653589793 : -3.141592653589793) + h, 0);
   break b;
  }
  if (e >>> 0 <= 1088565717) {
   h = +b;
   if (e >>> 0 <= 1085271519) {
    b = lo(((f | 0) < 0 ? 4.71238898038469 : -4.71238898038469) + h, 1);
    break b;
   }
   b = lo(((f | 0) < 0 ? 6.283185307179586 : -6.283185307179586) + h, 0);
   break b;
  }
  if (e >>> 0 >= 2139095040) {
   b = C(b - b);
   break b;
  }
  e = _y(b, g + 8 | 0);
  b = lo(A[g + 8 >> 3], e & 1);
 }
 eb = g + 16 | 0;
 b = C(C(C(1) - b) / C(b + C(1)));
 z[a + 4268 >> 2] = b;
 c = uq(C(c * C(6.2831854820251465)));
 z[a + 4264 >> 2] = -c;
 z[a + 4260 >> 2] = C(C(k * C(K(C(C(1) - C(c * c))))) * C(K(C(C(1) - C(b * b))))) * z[(i << 2) + 43968 >> 2];
 eb = d + 16 | 0;
}

function QY(a, b, c) {
 var d = 0, e = 0, f = 0, g = 0;
 d = eb - 16 | 0;
 eb = d;
 t[d + 15 | 0] = c;
 a: {
  if (b >>> 0 >= 22) {
   t[d + 14 | 0] = 0;
   de(a, 0, d + 14 | 0);
   break a;
  }
  e = w[b + 25040 | 0];
  b: {
   c: {
    switch (b - 8 | 0) {
    case 0:
     t[d + 15 | 0] = c << 1;
     break b;

    case 4:
     t[d + 15 | 0] = c + 1 >>> 1;
     break b;

    case 5:
     t[d + 15 | 0] = B(c >>> 4 | 0, 10) + (c & 15);
     break b;

    case 6:
     d: {
      switch ((c >>> 4 | 0) - 1 | 0) {
      default:
       e = 0;
       break b;

      case 0:
       t[d + 13 | 0] = c & 15;
       t[d + 12 | 0] = 14;
       f = d, g = w[Pb(d + 13 | 0, d + 12 | 0) | 0] << 4 | 15, t[f + 15 | 0] = g;
       e = 29;
       break b;

      case 1:
       t[d + 11 | 0] = c & 15;
       t[d + 10 | 0] = 14;
       f = d, g = w[Pb(d + 11 | 0, d + 10 | 0) | 0] | 240, t[f + 15 | 0] = g;
       e = 29;
       break b;

      case 3:
       t[d + 15 | 0] = c & 15 | 48;
       break b;

      case 4:
       t[d + 15 | 0] = c << 4 ^ 128;
       e = 35;
       break b;

      case 5:
       t[d + 15 | 0] = c & 15 | 176;
       break b;

      case 6:
       t[d + 15 | 0] = c & 15 | 64;
       break b;

      case 8:
       e = 15;
       t[d + 15 | 0] = c & 15;
       break b;

      case 9:
       t[d + 15 | 0] = (c << 3 & 120) + 8 & 240;
       e = 24;
       break b;

      case 10:
       t[d + 15 | 0] = (c & 15) + 1 >>> 1;
       e = 24;
       break b;

      case 14:
       break d;

      case 11:
      case 12:
      case 13:
       break b;
      }
     }
     e = 10;
     break b;

    case 8:
     if (c >>> 0 <= 223) {
      b = c >>> 2 | 0;
      t[d + 15 | 0] = (b >>> 0 >= 15 ? 15 : b) << 4;
      break b;
     }
     if (c >>> 0 <= 239) {
      t[d + 15 | 0] = c << 2 & 48 | 15;
      break b;
     }
     t[d + 15 | 0] = c << 4 | 15;
     break b;

    case 9:
     break c;

    default:
     break b;
    }
   }
   if (c >>> 0 <= 223) {
    b = c >>> 2 | 0;
    t[d + 15 | 0] = b >>> 0 >= 15 ? 15 : b;
    break b;
   }
   if (c >>> 0 > 239) {
    break b;
   }
   t[d + 15 | 0] = c >>> 2 & 3 | 240;
  }
  de(a, e, d + 15 | 0);
 }
 eb = d + 16 | 0;
}

function Jaa(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, q = 0, r = 0, s = 0;
 c = eb + -64 | 0;
 eb = c;
 d = v[a >> 2];
 a = v[d >> 2];
 e = v[a + 4 >> 2];
 v[c + 40 >> 2] = v[a + 20 >> 2];
 f = v[a + 16 >> 2];
 v[c + 32 >> 2] = v[a + 12 >> 2];
 v[c + 36 >> 2] = f;
 Wf(c + 48 | 0, c + 32 | 0, e);
 a = v[d + 4 >> 2];
 e = v[a + 8 >> 2];
 f = v[a + 4 >> 2];
 d = v[c + 60 >> 2];
 v[c + 24 >> 2] = v[c + 56 >> 2];
 v[c + 28 >> 2] = d;
 d = v[c + 52 >> 2];
 v[c + 16 >> 2] = v[c + 48 >> 2];
 v[c + 20 >> 2] = d;
 v[c + 8 >> 2] = v[a + 8 >> 2];
 d = v[a + 4 >> 2];
 v[c >> 2] = v[a >> 2];
 v[c + 4 >> 2] = d;
 a = eb - 32 | 0;
 eb = a;
 a: {
  b: {
   c: {
    d: {
     g = v[c + 4 >> 2];
     if (g >>> 0 >= f >>> 0) {
      if (y[c + 20 >> 2] < f >>> 0) {
       break d;
      }
      if (e >>> 0 > y[c + 8 >> 2]) {
       break c;
      }
      h = v[c + 28 >> 2];
      if (e >>> 0 > v[c + 24 >> 2] - h >>> 0) {
       break b;
      }
      k = b + 12 | 0;
      l = v[c + 16 >> 2];
      m = v[c >> 2];
      b = 0;
      e: while (1) {
       if ((b | 0) == (e | 0)) {
        break a;
       }
       n = (B(b, g) << 3) + m | 0;
       d = 0;
       while (1) if ((d | 0) == (f | 0)) {
        b = b + 1 | 0;
        continue e;
       } else {
        q = a, r = +(un(Ee(Ig(A[(d << 3) + n >> 3]) * 134217728)) + qd(_t(k), 21) | 0) * 7.450580596923828e-9, 
        A[q + 24 >> 3] = r;
        v[a + 16 >> 2] = 0;
        v[a + 20 >> 2] = -1074790400;
        v[a + 8 >> 2] = 0;
        v[a + 12 >> 2] = 1072693248;
        o = (d << 2) + l | 0;
        i = Ee(A[Xg(a + 24 | 0, a + 16 | 0, a + 8 | 0) >> 3] * 32768);
        f: {
         if (D(i) < 2147483648) {
          j = ~~i;
          break f;
         }
         j = -2147483648;
        }
        q = (v[o >> 2] + (h << 1) | 0) + (b << 1) | 0, s = fd(j), u[q >> 1] = s;
        d = d + 1 | 0;
        continue;
       }
      }
     }
     Z(7244, 9045, 77, 8725);
     p();
    }
    Z(7209, 9045, 78, 8725);
    p();
   }
   Z(5897, 9045, 79, 8725);
   p();
  }
  Z(5867, 9045, 80, 8725);
  p();
 }
 eb = a + 32 | 0;
 eb = c - -64 | 0;
}

function Bc(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0;
 a: {
  c = v[b >> 2];
  f = eb - 48 | 0;
  eb = f;
  e = v[b + 4 >> 2];
  b = w[b + 8 | 0];
  d = e - (((b | 0) == 1 | (b | 0) == 4) & (e | 0) != 0) | 0;
  e = Eb(a);
  b: {
   c: {
    d: {
     e: {
      f: {
       g: {
        h: {
         if ((b - 1 & 255) >>> 0 <= 1) {
          a = Ei(c, c + d | 0, 0);
          v[31601] = 0;
          T(70, e | 0, c | 0, a | 0) | 0;
          a = v[31601];
          v[31601] = 0;
          if ((a | 0) != 1) {
           break h;
          }
          a = M() | 0;
          break b;
         }
         if ((b - 3 & 255) >>> 0 > 1) {
          break h;
         }
         v[31601] = 0;
         b = T(70, e | 0, c | 0, c + d | 0) | 0;
         a = v[31601];
         v[31601] = 0;
         if ((a | 0) == 1) {
          break g;
         }
         c = yd(b);
         d = Cf(b);
         g = yd(b);
         a = eb - 16 | 0;
         eb = a;
         v[a + 8 >> 2] = g;
         v[a + 12 >> 2] = c;
         while (1) {
          if (Hb(c, d)) {
           c = t[c | 0];
           t[v[a + 8 >> 2]] = c ? c : 32;
           c = xe(a + 12 | 0);
           xe(a + 8 | 0);
           c = v[c >> 2];
           continue;
          }
          break;
         }
         eb = a + 16 | 0;
         v[31601] = 0;
         c = O(71, f + 24 | 0, b | 0) | 0;
         a = v[31601];
         v[31601] = 0;
         if ((a | 0) == 1) {
          break f;
         }
         v[31601] = 0;
         d = O(36, f + 12 | 0, 18418) | 0;
         a = v[31601];
         v[31601] = 0;
         if ((a | 0) == 1) {
          break e;
         }
         v[31601] = 0;
         a = f + 36 | 0;
         R(72, a | 0, c | 0, d | 0);
         g = v[31601];
         v[31601] = 0;
         if ((g | 0) == 1) {
          break d;
         }
         yb(b, a);
         sb(a);
         sb(d);
         sb(c);
        }
        eb = f + 48 | 0;
        break a;
       }
       a = M() | 0;
       break b;
      }
      a = M() | 0;
      break b;
     }
     a = M() | 0;
     break c;
    }
    a = M() | 0;
    sb(d);
   }
   sb(c);
  }
  sb(e);
  P(a | 0);
  p();
 }
}

function Xka(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0;
 l = eb - 16 | 0;
 eb = l;
 j = eb - 32 | 0;
 eb = j;
 f = j + 28 | 0;
 e = j + 24 | 0;
 k = c;
 g = eb - 16 | 0;
 eb = g;
 a: {
  b: {
   c = b;
   if (!lc(b, v[ub(g + 12 | 0, og(a)) >> 2])) {
    b = x[k >> 1];
    h = v[k + 4 >> 2];
    i = td(c);
    m = x[i >> 1];
    i = v[i + 4 >> 2];
    if (!Ml(b, h, m, i)) {
     break b;
    }
   }
   v[g + 12 >> 2] = c;
   c: {
    if (!lc(c, v[ub(g + 8 | 0, vb(v[a >> 2])) >> 2])) {
     b = v[MB(g + 12 | 0) >> 2];
     e = td(b);
     i = x[e >> 1];
     m = v[e + 4 >> 2];
     e = x[k >> 1];
     h = v[k + 4 >> 2];
     if (Ml(i, m, e, h)) {
      break c;
     }
     c = LB(a, f, e, h);
     break a;
    }
    b = c;
   }
   if (!v[c >> 2]) {
    v[f >> 2] = c;
    break a;
   }
   v[f >> 2] = b;
   c = b + 4 | 0;
   break a;
  }
  if (Ml(m, i, b, h)) {
   d: {
    b = KB(c);
    if (!lc(b, v[ub(g + 12 | 0, og(a)) >> 2])) {
     e = x[k >> 1];
     h = v[k + 4 >> 2];
     i = td(b);
     if (!Ml(e, h, x[i >> 1], v[i + 4 >> 2])) {
      break d;
     }
    }
    if (!v[c + 4 >> 2]) {
     v[f >> 2] = c;
     c = c + 4 | 0;
     break a;
    }
    v[f >> 2] = b;
    c = b;
    break a;
   }
   c = LB(a, f, e, h);
   break a;
  }
  v[f >> 2] = c;
  v[e >> 2] = c;
  c = e;
 }
 eb = g + 16 | 0;
 b = v[c >> 2];
 if (!b) {
  b = eb - 16 | 0;
  eb = b;
  f = fc(a);
  e = j + 12 | 0;
  g = Ch(e, Dc(36), Ng(b + 8 | 0, f));
  f = v[g >> 2] + 16 | 0;
  h = v[k + 4 >> 2];
  v[f >> 2] = v[k >> 2];
  v[f + 4 >> 2] = h;
  Rl(f + 8 | 0, d);
  o = fc(g), p = 1, t[o + 4 | 0] = p;
  eb = b + 16 | 0;
  _g(a, v[j + 28 >> 2], c, v[j + 12 >> 2]);
  b = me(e);
  WT(e);
  n = 1;
 }
 a = l + 4 | 0;
 Zg(a, v[ub(j + 12 | 0, b) >> 2], n);
 eb = j + 32 | 0;
 if (!w[fc(a) | 0]) {
  a = td(v[l + 4 >> 2]) + 8 | 0;
  VT(a);
  v[a >> 2] = v[d >> 2];
  v[a + 4 >> 2] = v[d + 4 >> 2];
  b = zb(d);
  o = zb(a), p = v[b >> 2], v[o >> 2] = p;
  v[b >> 2] = 0;
  v[d >> 2] = 0;
  v[d + 4 >> 2] = 0;
 }
 a = ub(l + 12 | 0, v[l + 4 >> 2]);
 eb = l + 16 | 0;
 return v[a >> 2];
}

function mua(a, b, c, d, e) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 var f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
 g = eb - 32 | 0;
 eb = g;
 t[g + 16 | 0] = 0;
 m = o0(g + 20 | 0, d, g + 16 | 0);
 f = v[m >> 2];
 v[g + 16 >> 2] = d;
 h = d;
 while (1) {
  if (!(!b | !h)) {
   a: {
    i = b - 1 | 0;
    k = w[a | 0];
    if (!(!i | (k | 0) != (e & 255))) {
     v[g + 12 >> 2] = w[a + 1 | 0];
     i = a + 2 | 0;
     j = Gb(g + 12 | 0, g + 16 | 0);
     b: {
      k = b - 2 | 0;
      if (!k) {
       break b;
      }
      j = v[j >> 2];
      if (!(j & 255)) {
       break b;
      }
      i = w[i | 0];
      while (1) {
       if (!(j & 255)) {
        break a;
       }
       t[f | 0] = i;
       h = v[g + 16 >> 2] - 1 | 0;
       v[g + 16 >> 2] = h;
       f = f + 1 | 0;
       j = j - 1 | 0;
       continue;
      }
     }
     t[f | 0] = e;
     h = v[g + 16 >> 2] - 1 | 0;
     v[g + 16 >> 2] = h;
     f = f + 1 | 0;
     b = k;
     a = i;
     continue;
    }
    a = a + 1 | 0;
    t[f | 0] = k;
    h = v[g + 16 >> 2] - 1 | 0;
    v[g + 16 >> 2] = h;
    f = f + 1 | 0;
    b = i;
    continue;
   }
   b = b - 3 | 0;
   a = a + 3 | 0;
   continue;
  }
  break;
 }
 e = d - h | 0;
 a = v[m >> 2];
 k = 0;
 f = 128;
 b = 0;
 i = 0;
 c: while (1) {
  if ((e | 0) == (i | 0)) {
   while (1) {
    if (e) {
     d = k << 24 >> 24;
     b = t[c | 0];
     a = 128;
     d: {
      if ((b | 0) == -128) {
       break d;
      }
      a = b;
      if ((b | 0) >= 0) {
       break d;
      }
      a = 0 - (b & 127) | 0;
     }
     k = d - (a & 255) | 0;
     t[c | 0] = k;
     e = e - 1 | 0;
     c = c + 1 | 0;
     continue;
    }
    break;
   }
   ec(m);
   eb = g + 32 | 0;
   return;
  }
  n = w[a | 0];
  h = 0;
  j = 0;
  while (1) if ((j & 65535) >>> 0 >= 8) {
   f = f & 65535;
   f = (f << 8 | f) >>> h & 255;
   i = i + 1 | 0;
   a = a + 1 | 0;
   continue c;
  } else {
   l = b + c | 0;
   t[l | 0] = w[l | 0] | B(f & n, 257) >>> (h - j & 7);
   b = b + 1 | 0;
   l = b >>> 0 >= d >>> 0;
   b = l ? 0 : b;
   j = j + 1 | 0;
   h = h + l | 0;
   f = (f << 8 | f) >>> 1 & 255;
   continue;
  }
 }
}

function oI(a, b, c, d, e) {
 var f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0;
 l = eb - 16 | 0;
 eb = l;
 g = w[a | 0];
 a: {
  if (!g) {
   f = a;
   break a;
  }
  f = a;
  b: {
   while (1) {
    if (!dl(g << 24 >> 24)) {
     break b;
    }
    g = w[f + 1 | 0];
    f = f + 1 | 0;
    if (g) {
     continue;
    }
    break;
   }
   break a;
  }
  c: {
   h = g & 255;
   switch (h - 43 | 0) {
   case 0:
   case 2:
    break c;

   default:
    break a;
   }
  }
  j = (h | 0) == 45 ? -1 : 0;
  f = f + 1 | 0;
 }
 d: {
  if (!((c | 16) != 16 | w[f | 0] != 48)) {
   n = 1;
   if ((w[f + 1 | 0] & 223) == 88) {
    f = f + 2 | 0;
    m = 16;
    break d;
   }
   f = f + 1 | 0;
   m = c ? c : 8;
   break d;
  }
  m = c ? c : 10;
 }
 c = 0;
 while (1) {
  e: {
   h = w[f | 0];
   g = h - 48 | 0;
   f: {
    if ((g & 255) >>> 0 < 10) {
     break f;
    }
    if ((h - 97 & 255) >>> 0 <= 25) {
     g = h - 87 | 0;
     break f;
    }
    if ((h - 65 & 255) >>> 0 > 25) {
     break e;
    }
    g = h - 55 | 0;
   }
   g = g & 255;
   if ((g | 0) >= (m | 0)) {
    break e;
   }
   Lf(l, m, 0, 0, 0, k, i, 0, 0);
   h = 1;
   g: {
    if (v[l + 8 >> 2] | v[l + 12 >> 2]) {
     break g;
    }
    o = Aua(k, i, m, 0);
    p = gb;
    if ((p | 0) == -1 & (g ^ -1) >>> 0 < o >>> 0) {
     break g;
    }
    i = p;
    k = g + o | 0;
    i = k >>> 0 < g >>> 0 ? i + 1 | 0 : i;
    n = 1;
    h = c;
   }
   f = f + 1 | 0;
   c = h;
   continue;
  }
  break;
 }
 if (b) {
  v[b >> 2] = n ? f : a;
 }
 h: {
  i: {
   j: {
    if (c) {
     v[31476] = 68;
     a = d & 1;
     j = a ? 0 : j;
     k = d;
     i = e;
     break j;
    }
    if ((e | 0) == (i | 0) & d >>> 0 > k >>> 0 | e >>> 0 > i >>> 0) {
     break i;
    }
    a = d & 1;
   }
   if (!(a | j)) {
    v[31476] = 68;
    a = d;
    d = a - 1 | 0;
    e = e - !a | 0;
    break h;
   }
   if ((e | 0) == (i | 0) & d >>> 0 >= k >>> 0 | e >>> 0 > i >>> 0) {
    break i;
   }
   v[31476] = 68;
   break h;
  }
  a = j ^ k;
  d = a - j | 0;
  b = j >> 31;
  e = (b ^ i) - ((a >>> 0 < j >>> 0) + b | 0) | 0;
 }
 eb = l + 16 | 0;
 gb = e;
 return d;
}

function EL(a, b, c) {
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = C(0), k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = C(0);
 d = (b << 2) + a | 0;
 h = d + 1068 | 0;
 k = c << 1 & -4;
 p = h, q = te(a, k), v[p >> 2] = q;
 g = d + 1076 | 0;
 p = g, q = te(a, k), v[p >> 2] = q;
 i = te(a, c & -4);
 v[d + 1084 >> 2] = i;
 a: {
  h = v[h >> 2];
  if (!h) {
   break a;
  }
  g = v[g >> 2];
  if (!g | !i) {
   break a;
  }
  d = c >> 2;
  o = (d | 0) > 0 ? d : 0;
  j = C(c | 0);
  d = 0;
  while (1) {
   if ((e | 0) == (o | 0)) {
    d = 0;
    e = c >> 3;
    h = (e | 0) > 0 ? e : 0;
    e = 0;
    while (1) {
     if ((d | 0) != (h | 0)) {
      g = e | 1;
      f = +C(C(C(g << 1) * C(3.1415927410125732)) / j);
      p = i + (e << 2) | 0, r = C(hf(f)), z[p >> 2] = r;
      p = i + (g << 2) | 0, r = C(-C(Oi(f))), z[p >> 2] = r;
      e = e + 2 | 0;
      d = d + 1 | 0;
      continue;
     }
     break;
    }
   } else {
    l = d << 2;
    f = +C(C(C(e << 2) * C(3.1415927410125732)) / j);
    p = h + l | 0, r = C(hf(f)), z[p >> 2] = r;
    m = d | 1;
    n = m << 2;
    p = h + n | 0, r = C(-C(Oi(f))), z[p >> 2] = r;
    f = +C(C(C(C(m | 0) * C(3.1415927410125732)) / j) * C(.5));
    p = g + l | 0, r = C(C(hf(f)) * C(.5)), z[p >> 2] = r;
    p = g + n | 0, r = C(C(Oi(f)) * C(.5)), z[p >> 2] = r;
    d = d + 2 | 0;
    e = e + 1 | 0;
    continue;
   }
   break;
  }
  i = (b << 2) + a | 0;
  d = te(a, k);
  v[i + 1092 >> 2] = d;
  if (!d) {
   break a;
  }
  b = 0;
  e = c >> 1;
  k = (e | 0) > 0 ? e : 0;
  f = +(e | 0);
  while (1) {
   if ((b | 0) != (k | 0)) {
    j = C(Oi((+(b | 0) + .5) / f * .5 * 3.1415927410125732));
    p = d + (b << 2) | 0, r = C(Oi(+C(j * j) * 1.5707963705062866)), z[p >> 2] = r;
    b = b + 1 | 0;
    continue;
   }
   break;
  }
  b = te(a, c >> 2 & -2);
  v[i + 1100 >> 2] = b;
  if (!b) {
   break a;
  }
  a = 0;
  d = c >> 3;
  d = (d | 0) > 0 ? d : 0;
  c = 36 - Hm(c) | 0;
  while (1) {
   if ((a | 0) != (d | 0)) {
    p = b + (a << 1) | 0, q = Fm(a) >>> c << 2, u[p >> 1] = q;
    a = a + 1 | 0;
    continue;
   }
   break;
  }
  return 1;
 }
 bc(a, 3);
 return 0;
}

function Lla(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, u = 0;
 e = eb - 16 | 0;
 eb = e;
 q = v[a + 16 >> 2];
 r = Fg(b + 327720 | 0, v[b + 20 >> 2], (v[a + 88 >> 2] & 16384) >>> 14 | 0);
 i = v[a + 8 >> 2];
 j = v[a + 12 >> 2];
 b = v[a >> 2];
 g = v[a + 4 >> 2];
 k = v[a + 128 >> 2];
 if (k) {
  l = Gg(i, j, k);
  m = gb;
  h = v[a + 76 >> 2];
  eg(b, g, uf(i, j, d), gb);
  n = gb >>> 0 > h >>> 0 ? d : 0;
 }
 h = a + 112 | 0;
 s = v[a + 24 >> 2];
 u = v[a + 20 >> 2];
 v[e >> 2] = b;
 v[e + 4 >> 2] = g;
 while (1) {
  if (d) {
   g = v[e + 4 >> 2];
   b = v[e >> 2];
   v[e + 8 >> 2] = b;
   v[e + 12 >> 2] = 0;
   n = n - 1 | 0;
   f = n;
   l = f ? l : 0;
   m = f ? m : 0;
   d = d - 1 | 0;
   p = (((g & 2147483647) << 1 | b >>> 31) & -2) + q | 0;
   g = k;
   a: {
    b: while (1) {
     c: {
      if ((g | 0) <= 0) {
       Ob(h, v[a + 120 >> 2], v[a + 124 >> 2]);
       g = v[a + 116 >> 2];
       if (!g) {
        break a;
       }
       f = v[e + 8 >> 2];
       o = ((v[e + 12 >> 2] & 2147483647) << 1 | f >>> 31) & -2;
       f = 0;
       b = 0;
       break c;
      }
      f = v[e + 8 >> 2];
      o = ((v[e + 12 >> 2] & 2147483647) << 1 | f >>> 31) & -2;
      b = 0;
      f = 0;
      while (1) if ((b | 0) == 2) {
       be(h, f >>> 3 << 16 >> 16);
       ae(h, 4);
       Ob(e + 8 | 0, l, m);
       g = g - 1 | 0;
       continue b;
      } else {
       f = (t[(b | o) + p | 0] << 8) + f | 0;
       b = b + 1 | 0;
       continue;
      }
     }
     break;
    }
    while (1) {
     if ((b | 0) != 2) {
      f = (t[(b | o) + p | 0] << 8) + f | 0;
      b = b + 1 | 0;
      continue;
     }
     break;
    }
    be(h, f >>> 3 << 16 >> 16);
    ae(h, g);
    v[h >> 2] = v[h >> 2];
    v[h + 4 >> 2] = 0;
   }
   f = v[c >> 2];
   b = Eg(h, r);
   v[c >> 2] = f + B(b, u);
   v[c + 4 >> 2] = v[c + 4 >> 2] + B(b, s);
   Ob(e, i, j);
   c = c + 8 | 0;
   continue;
  }
  break;
 }
 b = v[e + 4 >> 2];
 v[a >> 2] = v[e >> 2];
 v[a + 4 >> 2] = b;
 eb = e + 16 | 0;
}

function IE() {
 var a = 0, b = 0, c = 0;
 if (!w[497500]) {
  a = eb - 16 | 0;
  eb = a;
  Pt(497148);
  v[124299] = -1;
  v[124297] = 497204;
  v[124295] = 125600;
  v[124287] = 94348;
  t[497200] = 0;
  b = a + 12 | 0;
  bd(b, v[124288]);
  c = v[v[124287] + 8 >> 2];
  v[31601] = 0;
  N(c | 0, 497148, b | 0);
  c = v[31601];
  v[31601] = 0;
  a: {
   if ((c | 0) != 1) {
    Zb(b);
    eb = a + 16 | 0;
    break a;
   }
   b = M() | 0;
   Zb(a + 12 | 0);
   go(497148);
   P(b | 0);
   p();
  }
  Ut(496476);
  v[124119] = 94480;
  v[124117] = 94460;
  v[124118] = 0;
  oo(496476, 497148);
  SK(497212, 125744, 497260);
  Py(496644, 497212);
  SK(497268, 125448, 497316);
  Py(496812, 497268);
  Py(496980, v[v[v[124203] - 12 >> 2] + 496836 >> 2]);
  RK(v[v[124117] - 12 >> 2] + 496468 | 0);
  OK(v[v[124203] - 12 >> 2] + 496812 | 0);
  RK(v[v[124203] - 12 >> 2] + 496812 | 0);
  a = eb - 16 | 0;
  eb = a;
  aL(497324);
  v[124343] = -1;
  v[124341] = 497380;
  v[124339] = 125600;
  v[124331] = 94740;
  t[497376] = 0;
  b = a + 12 | 0;
  bd(b, v[124332]);
  c = v[v[124331] + 8 >> 2];
  v[31601] = 0;
  N(c | 0, 497324, b | 0);
  c = v[31601];
  v[31601] = 0;
  b: {
   if ((c | 0) != 1) {
    Zb(b);
    eb = a + 16 | 0;
    break b;
   }
   b = M() | 0;
   Zb(a + 12 | 0);
   Dt(497324);
   P(b | 0);
   p();
  }
  NK(496564);
  v[124141] = 94872;
  v[124139] = 94852;
  v[124140] = 0;
  oo(496564, 497324);
  QK(497388, 125744, 497436);
  Oy(496728, 497388);
  QK(497444, 125448, 497492);
  Oy(496896, 497444);
  Oy(497064, v[v[v[124224] - 12 >> 2] + 496920 >> 2]);
  PK(v[v[124139] - 12 >> 2] + 496556 | 0);
  OK(v[v[124224] - 12 >> 2] + 496896 | 0);
  PK(v[v[124224] - 12 >> 2] + 496896 | 0);
  t[497500] = 1;
 }
 a = eb - 16 | 0;
 eb = a;
 c: {
  if (ab(a + 12 | 0, a + 8 | 0) | 0) {
   break c;
  }
  b = Fd((v[a + 12 >> 2] << 2) + 4 | 0);
  v[125406] = b;
  if (!b) {
   break c;
  }
  b = Fd(v[a + 8 >> 2]);
  if (b) {
   c = v[125406];
   v[c + (v[a + 12 >> 2] << 2) >> 2] = 0;
   if (!($a(c | 0, b | 0) | 0)) {
    break c;
   }
  }
  v[125406] = 0;
 }
 eb = a + 16 | 0;
 v[124089] = 42;
 v[124107] = 501660;
}

function HD(a, b, c) {
 var d = 0, e = 0, f = 0, g = 0;
 d = eb - 16 | 0;
 eb = d;
 t[d + 15 | 0] = c;
 e = a;
 a: {
  b: {
   c: {
    switch (b - 14 | 0) {
    case 0:
     b = 14;
     if (!c) {
      break b;
     }
     d: {
      if ((c | 0) != 15) {
       if ((c | 0) != 240) {
        break d;
       }
       t[d + 15 | 0] = 239;
       break b;
      }
      t[d + 15 | 0] = 254;
      break b;
     }
     if (c >>> 0 >= 16) {
      t[d + 15 | 0] = c | 15;
      break b;
     }
     t[d + 15 | 0] = c | 240;
     break b;

    case 1:
     t[d + 15 | 0] = c ^ 128;
     b = 15;
     break b;

    case 6:
    case 7:
     if (c >>> 0 >= 16) {
      t[d + 15 | 0] = c >>> 4 | 240;
      break b;
     }
     t[d + 15 | 0] = c | 224;
     break b;

    case 8:
     t[d + 15 | 0] = ((c ^ -1) & 254) >>> 1;
     b = 22;
     break b;

    case 9:
     t[d + 15 | 0] = c & 15 | 128;
     b = 23;
     break b;

    case 17:
     f = d, g = Dh(c << 1), t[f + 15 | 0] = g;
     b = 31;
     break b;

    case 19:
     a = 32;
     b = 33;
     e: {
      f: {
       switch (c >>> 4 | 0) {
       default:
        b = 0;
        break b;

       case 8:
        a = 64;
        break e;

       case 10:
        a = 176;
        break e;

       case 11:
        a = 224;
        break e;

       case 12:
       case 13:
        b = c ? 33 : 0;
        break b;

       case 14:
        g: {
         switch (c & 15) {
         case 0:
          t[d + 15 | 0] = 119;
          break b;

         case 1:
          t[d + 15 | 0] = 119;
          break b;

         case 2:
          t[d + 15 | 0] = 121;
          break b;

         case 3:
          break g;

         default:
          break b;
         }
        }
        t[d + 15 | 0] = 123;
        break b;

       case 3:
        break e;

       case 5:
        break f;

       case 0:
        break b;
       }
      }
      a = 48;
     }
     t[d + 15 | 0] = c & 15 | a;
     break b;

    default:
     break c;
    }
   }
   a = 0;
   if (b >>> 0 > 35) {
    break a;
   }
  }
  a = w[b + 24976 | 0];
 }
 de(e, a, d + 15 | 0);
 eb = d + 16 | 0;
}

function lka(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0;
 i = eb - 16 | 0;
 eb = i;
 v[i + 12 >> 2] = b;
 o = Of(a);
 while (1) {
  if (Yg(b, c)) {
   e = v[ub(i + 8 | 0, o) >> 2];
   j = td(b);
   m = eb - 16 | 0;
   eb = m;
   n = 0;
   k = eb - 16 | 0;
   eb = k;
   g = eb - 32 | 0;
   eb = g;
   f = g + 28 | 0;
   d = g + 24 | 0;
   h = eb - 16 | 0;
   eb = h;
   a: {
    b: {
     b = e;
     if (!lc(b, v[ub(h + 12 | 0, og(a)) >> 2])) {
      e = w[j | 0];
      l = w[td(b) | 0];
      if (!Bo(e, l)) {
       break b;
      }
     }
     v[h + 12 >> 2] = b;
     c: {
      if (!lc(b, v[ub(h + 8 | 0, vb(v[a >> 2])) >> 2])) {
       d = v[MB(h + 12 | 0) >> 2];
       l = w[td(d) | 0];
       e = w[j | 0];
       if (Bo(l, e)) {
        break c;
       }
       b = hB(a, f, e);
       break a;
      }
      d = b;
     }
     if (!v[b >> 2]) {
      v[f >> 2] = b;
      break a;
     }
     v[f >> 2] = d;
     b = d + 4 | 0;
     break a;
    }
    if (Bo(l, e)) {
     d: {
      d = KB(b);
      if (!lc(d, v[ub(h + 12 | 0, og(a)) >> 2])) {
       e = w[j | 0];
       if (!Bo(e, w[td(d) | 0])) {
        break d;
       }
      }
      if (!v[b + 4 >> 2]) {
       v[f >> 2] = b;
       b = b + 4 | 0;
       break a;
      }
      v[f >> 2] = d;
      b = d;
      break a;
     }
     b = hB(a, f, e);
     break a;
    }
    v[f >> 2] = b;
    v[d >> 2] = b;
    b = d;
   }
   eb = h + 16 | 0;
   d = v[b >> 2];
   if (!d) {
    d = eb - 16 | 0;
    eb = d;
    f = fc(a);
    e = g + 12 | 0;
    f = Ch(e, Dc(24), Ng(d + 8 | 0, f));
    IS(v[f >> 2] + 16 | 0, v[j >> 2], v[j + 4 >> 2]);
    p = fc(f), q = 1, t[p + 4 | 0] = q;
    eb = d + 16 | 0;
    _g(a, v[g + 28 >> 2], b, v[g + 12 >> 2]);
    d = me(e);
    Gk(e);
    n = 1;
   }
   Zg(k + 8 | 0, v[ub(g + 12 | 0, d) >> 2], n);
   eb = g + 32 | 0;
   eb = k + 16 | 0;
   ub(m + 12 | 0, v[k + 8 >> 2]);
   eb = m + 16 | 0;
   b = v[$g(i + 12 | 0) >> 2];
   continue;
  } else {
   eb = i + 16 | 0;
  }
  break;
 }
}

function NO(a) {
 a = a | 0;
 var b = 0, c = 0, d = 0, e = 0;
 e = eb - 160 | 0;
 eb = e;
 d = Cc(e + 4 | 0, 11600);
 v[31601] = 0;
 b = d + 12 | 0;
 O(36, b | 0, 11005) | 0;
 c = v[31601];
 v[31601] = 0;
 a: {
  if ((c | 0) == 1) {
   break a;
  }
  v[31601] = 0;
  b = d + 24 | 0;
  O(36, b | 0, 11430) | 0;
  c = v[31601];
  v[31601] = 0;
  if ((c | 0) == 1) {
   break a;
  }
  v[31601] = 0;
  b = d + 36 | 0;
  O(36, b | 0, 10997) | 0;
  c = v[31601];
  v[31601] = 0;
  if ((c | 0) == 1) {
   break a;
  }
  v[31601] = 0;
  b = d + 48 | 0;
  O(36, b | 0, 8243) | 0;
  c = v[31601];
  v[31601] = 0;
  if ((c | 0) == 1) {
   break a;
  }
  v[31601] = 0;
  b = d + 60 | 0;
  O(36, b | 0, 10982) | 0;
  c = v[31601];
  v[31601] = 0;
  if ((c | 0) == 1) {
   break a;
  }
  v[31601] = 0;
  b = d + 72 | 0;
  O(36, b | 0, 8309) | 0;
  c = v[31601];
  v[31601] = 0;
  if ((c | 0) == 1) {
   break a;
  }
  v[31601] = 0;
  b = d + 84 | 0;
  O(36, b | 0, 5620) | 0;
  c = v[31601];
  v[31601] = 0;
  if ((c | 0) == 1) {
   break a;
  }
  v[31601] = 0;
  b = d + 96 | 0;
  O(36, b | 0, 12004) | 0;
  c = v[31601];
  v[31601] = 0;
  if ((c | 0) == 1) {
   break a;
  }
  v[31601] = 0;
  b = d + 108 | 0;
  O(36, b | 0, 11373) | 0;
  c = v[31601];
  v[31601] = 0;
  if ((c | 0) == 1) {
   break a;
  }
  v[31601] = 0;
  b = d + 120 | 0;
  O(36, b | 0, 12273) | 0;
  c = v[31601];
  v[31601] = 0;
  if ((c | 0) == 1) {
   break a;
  }
  v[31601] = 0;
  b = d + 132 | 0;
  O(36, b | 0, 5472) | 0;
  c = v[31601];
  v[31601] = 0;
  if ((c | 0) == 1) {
   break a;
  }
  v[31601] = 0;
  b = d + 144 | 0;
  O(36, b | 0, 7335) | 0;
  c = v[31601];
  v[31601] = 0;
  if ((c | 0) == 1) {
   break a;
  }
  v[31601] = 0;
  T(1062, a | 0, d | 0, 13) | 0;
  a = v[31601];
  v[31601] = 0;
  if ((a | 0) != 1) {
   b = d + 156 | 0;
   while (1) {
    b = sb(b - 12 | 0);
    if ((d | 0) != (b | 0)) {
     continue;
    }
    break;
   }
   eb = e + 160 | 0;
   return;
  }
  b = d + 156 | 0;
 }
 a = M() | 0;
 while (1) {
  b = sb(b - 12 | 0);
  if ((d | 0) != (b | 0)) {
   continue;
  }
  break;
 }
 P(a | 0);
 p();
}

function Uia(a, b, c, d, e) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 var f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = C(0), m = 0, n = 0, o = C(0);
 g = u[d >> 1];
 h = u[d + 2 >> 1];
 a: {
  if ((g | 0) > (h | 0)) {
   break a;
  }
  k = v[b >> 2];
  i = nc(k, v[b + 4 >> 2]);
  if (!i) {
   break a;
  }
  j = u[e >> 1];
  if ((g | 0) > (j | 0) | (h | 0) < (j | 0) | (i - 1 & 65535) >>> 0 > (h - j & 65535) >>> 0 | y[a + 36 >> 2] > 65535) {
   break a;
  }
  b: {
   while (1) {
    if ((f | 0) == (i | 0)) {
     break b;
    }
    j = xb(k, f);
    f = f + 1 | 0;
    if (!(z[j >> 2] < C(0))) {
     continue;
    }
    break;
   }
   return 0;
  }
  f = 0;
  l = z[c >> 2];
  if (l <= C(0)) {
   break a;
  }
  u[a + 28 >> 1] = g;
  u[a >> 1] = 1;
  m = a, n = XQ(i), u[m + 30 >> 1] = n;
  z[a + 32 >> 2] = D(l);
  Al(a + 4 | 0, (h - g | 0) + 1 | 0);
  c = vb(v[b >> 2]);
  h = vb(v[b + 4 >> 2]);
  f = Dk(vb(v[a + 4 >> 2]), u[e >> 1] - u[d >> 1] | 0);
  g = eb - 16 | 0;
  eb = g;
  b = eb - 32 | 0;
  eb = b;
  ed(b + 24 | 0, c, h);
  cD(b + 16 | 0, v[b + 24 >> 2], v[b + 28 >> 2], f);
  c = mA(c, v[b + 16 >> 2]);
  m = b, n = WQ(f, v[b + 20 >> 2]), v[m + 12 >> 2] = n;
  pc(g + 8 | 0, c, b + 12 | 0);
  eb = b + 32 | 0;
  eb = g + 16 | 0;
  c = v[a + 4 >> 2];
  g = u[a + 30 >> 1];
  h = u[a + 28 >> 1];
  b = u[e >> 1];
  f = b;
  while (1) {
   if ((b & 65535) != 32768 & (f | 0) > (h | 0)) {
    f = f - 1 | 0;
    b = f - h | 0;
    i = xb(c, b + g | 0);
    m = xb(c, b), o = C(z[i >> 2] / z[a + 32 >> 2]), z[m >> 2] = o;
    b = u[e >> 1];
    continue;
   } else {
    c = u[a + 30 >> 1];
    e = u[a + 28 >> 1];
    h = c + e | 0;
    f = g;
    g = b << 16 >> 16;
    f = f + g | 0;
    b = v[a + 4 >> 2];
    d = u[d + 2 >> 1];
    c = (g | 0) <= (32767 - c | 0);
    while (1) {
     if (c & (d | 0) >= (f | 0)) {
      g = xb(b, f - h | 0);
      m = xb(b, f - e | 0), o = C(z[a + 32 >> 2] * z[g >> 2]), z[m >> 2] = o;
      f = f + 1 | 0;
      continue;
     } else {
      xq(a);
     }
     break;
    }
   }
   break;
  }
  f = 1;
 }
 return f | 0;
}

function lT(a, b, c, d) {
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0;
 e = v[b + 64 >> 2];
 a: {
  b: {
   g = v[b + 60 >> 2];
   f = x[b + 68 >> 1];
   if (!((g | 0) == -1 & (f | 0) == 65535)) {
    c: {
     d: {
      if ((e | 0) == -1) {
       break d;
      }
      e = a + 1074312 | 0;
      if (Nb(e, 68)) {
       break d;
      }
      f = (f | 0) != 65535;
      if (h = Nb(e, 103), i = 0, j = f, j ? h : i) {
       break c;
      }
      if (h = Nb(e, 49), i = 0, j = f, j ? h : i) {
       break c;
      }
      e = v[b + 64 >> 2];
      break b;
     }
     if ((f | 0) != 65535) {
      break c;
     }
     u[b + 68 >> 1] = x[b + 72 >> 1] + 1;
    }
    if ((g | 0) == -1) {
     v[b + 60 >> 2] = 0;
    }
    f = _c(v[c >> 2], v[c + 4 >> 2]);
    e = x[b + 68 >> 1];
    if (f >>> 0 <= e >>> 0) {
     e = x[c + 28 >> 1];
     u[b + 68 >> 1] = e;
    }
    e: {
     if (x[b + 72 >> 1] == (e & 65535)) {
      break e;
     }
     c = a + 1074312 | 0;
     if (Nb(c, 26)) {
      break e;
     }
     if (Nb(c, 68) | v[a + 480180 >> 2] == 1) {
      break e;
     }
     c = b + 616 | 0;
     f = x[a + 480188 >> 1];
     e = 0;
     while (1) {
      if ((e | 0) == (f | 0)) {
       break e;
      }
      t[(c + B(e, 872) | 0) + 841 | 0] = 0;
      e = e + 1 | 0;
      continue;
     }
    }
    v[b + 52 >> 2] = v[b + 60 >> 2];
    if (d) {
     e = 1;
     if (w[a + 480208 | 0] & 32) {
      break a;
     }
    }
    u[b + 74 >> 1] = x[b + 68 >> 1];
    return 1;
   }
   if ((e | 0) != -1) {
    break b;
   }
   e = 0;
   break a;
  }
  v[b + 52 >> 2] = e;
  u[b + 74 >> 1] = x[b + 72 >> 1];
  f: {
   if (!v[b + 20 >> 2]) {
    break f;
   }
   c = v[a + 480180 >> 2];
   if ((c | 0) == 32) {
    if (Nb(a + 1074312 | 0, 103)) {
     break f;
    }
    c = v[a + 480180 >> 2];
   }
   if ((c | 0) == 2) {
    break f;
   }
   v[b + 52 >> 2] = v[b + 52 >> 2] + 1;
  }
  e = 0;
  if (y[b + 64 >> 2] < y[Vb(v[a + 484344 >> 2], x[b + 70 >> 1]) + 12 >> 2]) {
   break a;
  }
  v[b + 52 >> 2] = 0;
  u[b + 74 >> 1] = x[b + 74 >> 1] + 1;
  return 0;
 }
 return e;
}

function UR(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0;
 e = eb - 16 | 0;
 eb = e;
 c = Wb(v[a + 484360 >> 2], w[a + 484376 | 0]);
 d = _c(v[c >> 2], v[c + 4 >> 2]);
 a: {
  while (1) {
   f = b & 65535;
   if (f >>> 0 >= d >>> 0) {
    break a;
   }
   if (!Vi(c, f)) {
    b = b + 1 | 0;
    continue;
   }
   break;
  }
  f = a + 1074312 | 0;
  d = 1074992;
  b: {
   while (1) {
    c: {
     if ((d | 0) == 1298224) {
      TR(a);
      if (b & 65535) {
       break c;
      }
      b = 0;
      c = a + 1074992 | 0;
      while (1) {
       if ((b | 0) == 256) {
        Lo(a + 1298264 | 0, 1);
        v[a + 1074456 >> 2] = v[a + 480200 >> 2];
        v[a + 1074416 >> 2] = v[a + 480196 >> 2];
        v[a + 1074420 >> 2] = v[a + 480204 >> 2];
        v[a + 480208 >> 2] = v[a + 480208 >> 2] & -769;
        tB(a + 1074376 | 0);
        u[a + 1074450 >> 1] = 0;
        v[a + 1074392 >> 2] = -2;
        v[a + 1074428 >> 2] = 0;
        v[a + 1074432 >> 2] = 0;
        v[a + 1074396 >> 2] = 0;
        v[a + 1074400 >> 2] = 0;
        v[a + 1074376 >> 2] = 0;
        v[a + 1074380 >> 2] = 0;
       } else {
        Po(c + B(b, 872) | 0, a, b & 65535, 134217728);
        b = b + 1 | 0;
        continue;
       }
       break;
      }
      break b;
     }
     c = a + d | 0;
     t[c + 797 | 0] = 0;
     v[c + 700 >> 2] = 0;
     t[c + 841 | 0] = 0;
     t[c + 805 | 0] = 0;
     v[c + 708 >> 2] = 0;
     t[c + 821 | 0] = 0;
     v[c + 764 >> 2] = 0;
     t[c + 819 | 0] = 0;
     t[c + 820 | 0] = 0;
     Ib(e + 8 | 0, f, 23);
     if (Fb(v[v[e + 8 >> 2] >> 2], v[e + 12 >> 2])) {
      t[c + 807 | 0] = 1;
      t[c + 808 | 0] = 0;
     }
     t[c + 839 | 0] = 0;
     d = d + 872 | 0;
     continue;
    }
    break;
   }
   u[a + 1074450 >> 1] = b;
   u[a + 1074446 >> 1] = 0;
   v[a + 1074424 >> 2] = 0;
   v[a + 1074428 >> 2] = 0;
   v[a + 1074392 >> 2] = -2;
   v[a + 1074432 >> 2] = 0;
   v[a + 1074396 >> 2] = 0;
   v[a + 1074400 >> 2] = 0;
   v[a + 1074380 >> 2] = 0;
  }
  v[a + 480208 >> 2] = v[a + 480208 >> 2] & -769;
 }
 eb = e + 16 | 0;
}

function Qla(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, w = 0, x = 0, y = 0, z = 0, A = 0;
 h = eb - 16 | 0;
 eb = h;
 i = v[a + 40 >> 2];
 j = v[a + 36 >> 2];
 e = v[a + 48 >> 2];
 f = v[a + 44 >> 2];
 q = v[a + 16 >> 2];
 l = v[a + 4 >> 2];
 v[h + 8 >> 2] = v[a >> 2];
 v[h + 12 >> 2] = l;
 r = b + 24 | 0;
 s = v[a + 32 >> 2];
 t = v[a + 28 >> 2];
 w = v[a + 72 >> 2];
 m = v[a + 68 >> 2];
 x = m >> 31;
 n = v[a + 64 >> 2];
 y = n >> 31;
 o = v[a + 60 >> 2];
 z = o >> 31;
 l = v[a + 8 >> 2];
 A = v[a + 12 >> 2];
 while (1) {
  b = f;
  if (d) {
   f = Xb(f, -16777216, 16776704);
   g = Aua(n, y, f, f >> 31);
   f = gb;
   e = Xb(e, -16777216, 16776704);
   e = Aua(m, x, e, e >> 31);
   g = e + g | 0;
   f = gb + f | 0;
   f = e >>> 0 > g >>> 0 ? f + 1 | 0 : f;
   e = v[h + 8 >> 2];
   k = g;
   g = (v[h + 12 >> 2] << 1) + q | 0;
   e = (((e >>> 16 | 0) + 4 & 131064) << 1) + r | 0;
   p = (((((B(u[g + 4 >> 1], u[e + 10 >> 1]) + B(u[g + 2 >> 1], u[e + 8 >> 1]) | 0) + B(u[g + 6 >> 1], u[e + 12 >> 1]) | 0) + B(u[g + 8 >> 1], u[e + 14 >> 1]) | 0) / 2 | 0) + ((((B(u[g - 4 >> 1], u[e + 2 >> 1]) + B(u[g - 6 >> 1], u[e >> 1]) | 0) + B(u[g - 2 >> 1], u[e + 4 >> 1]) | 0) + B(u[g >> 1], u[e + 6 >> 1]) | 0) / 2 | 0) | 0) / 16384 << 8;
   e = p;
   g = Aua(e, e >> 31, o, z);
   k = k + g | 0;
   e = gb + f | 0;
   e = g >>> 0 > k >>> 0 ? e + 1 | 0 : e;
   f = k + 8388608 | 0;
   e = f >>> 0 < 8388608 ? e + 1 | 0 : e;
   f = Rc(f, e, 24);
   e = (f | 0) / 256 | 0;
   j = j + t | 0;
   v[c >> 2] = B(e, j >> 12) + v[c >> 2];
   i = i + s | 0;
   v[c + 4 >> 2] = v[c + 4 >> 2] + B(i >> 12, e);
   Ob(h + 8 | 0, l, A);
   f = f - (w & p) | 0;
   c = c + 8 | 0;
   d = d - 1 | 0;
   e = b;
   continue;
  }
  break;
 }
 c = v[h + 12 >> 2];
 v[a >> 2] = v[h + 8 >> 2];
 v[a + 4 >> 2] = c;
 v[a + 40 >> 2] = i;
 v[a + 20 >> 2] = j >> 12;
 v[a + 36 >> 2] = j;
 v[a + 48 >> 2] = e;
 v[a + 44 >> 2] = b;
 v[a + 24 >> 2] = i >> 12;
 eb = h + 16 | 0;
}

function zaa(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, q = 0, r = 0, s = 0;
 b = eb + -64 | 0;
 eb = b;
 c = v[a >> 2];
 a = v[c >> 2];
 d = v[a + 4 >> 2];
 v[b + 40 >> 2] = v[a + 20 >> 2];
 e = v[a + 16 >> 2];
 v[b + 32 >> 2] = v[a + 12 >> 2];
 v[b + 36 >> 2] = e;
 Wf(b + 48 | 0, b + 32 | 0, d);
 a = v[c + 4 >> 2];
 d = v[a + 8 >> 2];
 e = v[a + 4 >> 2];
 c = v[b + 60 >> 2];
 v[b + 24 >> 2] = v[b + 56 >> 2];
 v[b + 28 >> 2] = c;
 c = v[b + 52 >> 2];
 v[b + 16 >> 2] = v[b + 48 >> 2];
 v[b + 20 >> 2] = c;
 v[b + 8 >> 2] = v[a + 8 >> 2];
 c = v[a + 4 >> 2];
 v[b >> 2] = v[a >> 2];
 v[b + 4 >> 2] = c;
 a = eb - 32 | 0;
 eb = a;
 a: {
  b: {
   c: {
    d: {
     g = v[b + 4 >> 2];
     if (g >>> 0 >= e >>> 0) {
      h = v[b + 20 >> 2];
      if (h >>> 0 < e >>> 0) {
       break d;
      }
      if (d >>> 0 > y[b + 8 >> 2]) {
       break c;
      }
      i = v[b + 28 >> 2];
      if (d >>> 0 > v[b + 24 >> 2] - i >>> 0) {
       break b;
      }
      l = v[b + 16 >> 2];
      m = v[b >> 2];
      e: while (1) {
       if ((d | 0) == (f | 0)) {
        break a;
       }
       n = (B(f, g) << 3) + m | 0;
       o = (B(f + i | 0, h) << 1) + l | 0;
       c = 0;
       while (1) if ((c | 0) == (e | 0)) {
        f = f + 1 | 0;
        continue e;
       } else {
        A[a + 24 >> 3] = A[(c << 3) + n >> 3];
        v[a + 16 >> 2] = 0;
        v[a + 20 >> 2] = -1074790400;
        v[a + 8 >> 2] = 0;
        v[a + 12 >> 2] = 1072693248;
        q = (c << 1) + o | 0;
        j = Ee(A[Xg(a + 24 | 0, a + 16 | 0, a + 8 | 0) >> 3] * 32768);
        f: {
         if (D(j) < 2147483648) {
          k = ~~j;
          break f;
         }
         k = -2147483648;
        }
        r = q, s = fd(k), u[r >> 1] = s;
        c = c + 1 | 0;
        continue;
       }
      }
     }
     Z(7244, 9045, 77, 8725);
     p();
    }
    Z(7209, 9045, 78, 8725);
    p();
   }
   Z(5897, 9045, 79, 8725);
   p();
  }
  Z(5867, 9045, 80, 8725);
  p();
 }
 eb = a + 32 | 0;
 eb = b - -64 | 0;
}

function vo(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0;
 c = eb - 80 | 0;
 eb = c;
 g = Mb(a);
 a = v[b + 24 >> 2];
 a: {
  b: {
   if (Fj(v[a + 484360 >> 2], v[a + 484364 >> 2])) {
    c: {
     d: {
      e: while (1) {
       if (Fj(v[a + 484360 >> 2], v[a + 484364 >> 2]) >>> 0 <= f >>> 0) {
        break d;
       }
       d = NR(UX(c + 40 | 0, 1), f & 255, 0, 0);
       v[31601] = 0;
       e = v[d + 12 >> 2];
       v[c + 16 >> 2] = v[d + 8 >> 2];
       v[c + 20 >> 2] = e;
       e = v[d + 20 >> 2];
       v[c + 24 >> 2] = v[d + 16 >> 2];
       v[c + 28 >> 2] = e;
       e = v[d + 4 >> 2];
       v[c + 8 >> 2] = v[d >> 2];
       v[c + 12 >> 2] = e;
       U(1090, c + 68 | 0, a | 0, 0, c + 8 | 0);
       a = v[31601];
       v[31601] = 0;
       if ((a | 0) == 1) {
        break c;
       }
       j = c, k = vb(v[c + 68 >> 2]), v[j + 36 >> 2] = k;
       d = vb(v[c + 72 >> 2]);
       while (1) {
        a = v[c + 36 >> 2];
        if (!Hb(a, d)) {
         f = f + 1 | 0;
         Pi(c + 68 | 0);
         a = v[b + 24 >> 2];
         continue e;
        }
        h = A[a >> 3];
        e = v[a + 16 >> 2];
        i = x[a + 24 >> 1];
        a = c + 40 | 0;
        v[a + 16 >> 2] = f;
        v[a + 12 >> 2] = i;
        v[a + 8 >> 2] = e;
        A[a >> 3] = h;
        v[31601] = 0;
        N(1125, g | 0, a | 0);
        a = v[31601];
        v[31601] = 0;
        if ((a | 0) != 1) {
         Zq(c + 36 | 0);
         continue;
        }
        break;
       }
       break;
      }
      a = M() | 0;
      Pi(c + 68 | 0);
      break b;
     }
     eb = c + 80 | 0;
     return;
    }
    a = M() | 0;
    break b;
   }
   b = cc(8);
   v[31601] = 0;
   d = O(36, c + 40 | 0, 7310) | 0;
   a = v[31601];
   v[31601] = 0;
   if ((a | 0) != 1) {
    rc(b, d);
    v[31601] = 0;
    R(97, b | 0, 48396, 999);
    a = v[31601];
    v[31601] = 0;
    if ((a | 0) != 1) {
     break a;
    }
    a = M() | 0;
    sb(d);
    break b;
   }
   a = M() | 0;
   jc(b);
  }
  nf(g);
  P(a | 0);
 }
 p();
}

function g7(a, b, c, d, e, f, g) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 f = f | 0;
 g = g | 0;
 var h = 0, i = 0, j = 0, k = 0;
 a = eb - 448 | 0;
 eb = a;
 v[a + 440 >> 2] = c;
 v[a + 444 >> 2] = b;
 v[a + 20 >> 2] = 1273;
 i = a + 20 | 0;
 b = Ce(a + 24 | 0, a + 32 | 0, i);
 j = a + 16 | 0;
 bd(j, v[e + 28 >> 2]);
 v[31601] = 0;
 h = Q(1251, v[a + 16 >> 2]) | 0;
 k = v[31601];
 v[31601] = 0;
 if ((k | 0) != 1) {
  a: {
   t[a + 15 | 0] = 0;
   e = v[e + 4 >> 2];
   v[31601] = 0;
   c = ma(1282, a + 444 | 0, c | 0, d | 0, j | 0, e | 0, f | 0, a + 15 | 0, h | 0, b | 0, i | 0, a + 432 | 0) | 0;
   d = v[31601];
   v[31601] = 0;
   if ((d | 0) == 1) {
    break a;
   }
   b: {
    c: {
     if (!c) {
      break c;
     }
     d: {
      if (ud(w[g + 11 | 0])) {
       xd(v[g >> 2], 0);
       Ad(g, 0);
       break d;
      }
      xd(g, 0);
      Me(g, 0);
     }
     if (w[a + 15 | 0]) {
      v[31601] = 0;
      c = O(1269, h | 0, 45) | 0;
      d = v[31601];
      v[31601] = 0;
      if ((d | 0) == 1) {
       break a;
      }
      v[31601] = 0;
      N(35, g | 0, c | 0);
      c = v[31601];
      v[31601] = 0;
      if ((c | 0) == 1) {
       break a;
      }
     }
     v[31601] = 0;
     d = O(1269, h | 0, 48) | 0;
     c = v[31601];
     v[31601] = 0;
     if ((c | 0) == 1) {
      break b;
     }
     e = v[a + 20 >> 2];
     h = e - 4 | 0;
     c = v[b >> 2];
     while (1) {
      if (!((d | 0) != v[c >> 2] | c >>> 0 >= h >>> 0)) {
       c = c + 4 | 0;
       continue;
      }
      break;
     }
     v[31601] = 0;
     T(1287, g | 0, c | 0, e | 0) | 0;
     c = v[31601];
     v[31601] = 0;
     if ((c | 0) != 1) {
      break c;
     }
     break a;
    }
    v[31601] = 0;
    c = O(1256, a + 444 | 0, a + 440 | 0) | 0;
    d = v[31601];
    v[31601] = 0;
    if ((d | 0) == 1) {
     break a;
    }
    if (c) {
     v[f >> 2] = v[f >> 2] | 2;
    }
    c = v[a + 444 >> 2];
    Zb(a + 16 | 0);
    Kc(b);
    eb = a + 448 | 0;
    return c | 0;
   }
  }
 }
 c = M() | 0;
 Zb(a + 16 | 0);
 Kc(b);
 P(c | 0);
 p();
}

function lma(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, w = 0, x = 0, y = 0, z = 0;
 e = eb - 16 | 0;
 eb = e;
 g = v[a + 12 >> 2];
 i = v[a + 8 >> 2];
 a: {
  b: {
   if ((g | 0) <= 1 & i >>> 0 <= 805306368 | (g | 0) <= 0) {
    f = 131112;
    if ((g | 0) >= -2 & i >>> 0 >= 3489660928 | (g | 0) > -2) {
     break a;
    }
    f = 262184;
    if ((g | 0) == -2 & i >>> 0 < 2147483648 | g >>> 0 < 4294967294) {
     break a;
    }
    break b;
   }
   f = 262184;
   if ((g | 0) == 1 & i >>> 0 > 2147483648 | g >>> 0 > 1) {
    break a;
   }
  }
  f = 196648;
 }
 m = v[a + 16 >> 2];
 j = v[a + 40 >> 2];
 k = v[a + 36 >> 2];
 h = v[a + 4 >> 2];
 v[e + 8 >> 2] = v[a >> 2];
 v[e + 12 >> 2] = h;
 n = b + f | 0;
 o = v[a + 32 >> 2];
 p = v[a + 28 >> 2];
 while (1) {
  if (d) {
   b = v[e + 8 >> 2];
   h = ((((v[e + 12 >> 2] & 2147483647) << 1 | b >>> 31) & 2147483646) << 1) + m | 0;
   b = (b >>> 16 & 65520) + n | 0;
   q = u[b + 14 >> 1];
   r = u[b + 12 >> 1];
   s = u[b + 10 >> 1];
   t = u[b + 8 >> 1];
   w = u[b + 6 >> 1];
   x = u[b + 4 >> 1];
   y = u[b + 2 >> 1];
   z = u[b >> 1];
   b = 0;
   while (1) {
    if ((b | 0) != 2) {
     l = b << 1;
     f = l + h | 0;
     v[(b << 2) + e >> 2] = (((((((B(u[(l | -8) + h >> 1], y) + B(u[(l | -12) + h >> 1], z) | 0) + B(u[(l | -4) + h >> 1], x) | 0) + B(u[f >> 1], w) | 0) + B(u[f + 4 >> 1], t) | 0) + B(u[f + 8 >> 1], s) | 0) + B(u[f + 12 >> 1], r) | 0) + B(u[f + 16 >> 1], q) | 0) / 32768;
     b = b + 1 | 0;
     continue;
    }
    break;
   }
   k = k + p | 0;
   v[c >> 2] = v[c >> 2] + B(v[e >> 2], k >> 12);
   j = j + o | 0;
   v[c + 4 >> 2] = v[c + 4 >> 2] + B(v[e + 4 >> 2], j >> 12);
   Ob(e + 8 | 0, i, g);
   c = c + 8 | 0;
   d = d - 1 | 0;
   continue;
  }
  break;
 }
 b = v[e + 12 >> 2];
 v[a >> 2] = v[e + 8 >> 2];
 v[a + 4 >> 2] = b;
 v[a + 40 >> 2] = j;
 v[a + 20 >> 2] = k >> 12;
 v[a + 36 >> 2] = k;
 v[a + 24 >> 2] = j >> 12;
 eb = e + 16 | 0;
}

function Rla(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, w = 0, x = 0, y = 0, z = 0, A = 0, C = 0;
 h = eb - 16 | 0;
 eb = h;
 i = v[a + 40 >> 2];
 j = v[a + 36 >> 2];
 e = v[a + 48 >> 2];
 f = v[a + 44 >> 2];
 q = v[a + 16 >> 2];
 l = v[a + 4 >> 2];
 v[h + 8 >> 2] = v[a >> 2];
 v[h + 12 >> 2] = l;
 r = b + 24 | 0;
 s = v[a + 32 >> 2];
 w = v[a + 28 >> 2];
 x = v[a + 72 >> 2];
 m = v[a + 68 >> 2];
 y = m >> 31;
 n = v[a + 64 >> 2];
 z = n >> 31;
 o = v[a + 60 >> 2];
 A = o >> 31;
 l = v[a + 8 >> 2];
 C = v[a + 12 >> 2];
 while (1) {
  b = f;
  if (d) {
   f = Xb(f, -16777216, 16776704);
   g = Aua(n, z, f, f >> 31);
   f = gb;
   e = Xb(e, -16777216, 16776704);
   e = Aua(m, y, e, e >> 31);
   g = e + g | 0;
   f = gb + f | 0;
   f = e >>> 0 > g >>> 0 ? f + 1 | 0 : f;
   e = v[h + 8 >> 2];
   k = g;
   g = v[h + 12 >> 2] + q | 0;
   e = (((e >>> 16 | 0) + 4 & 131064) << 1) + r | 0;
   p = ((((B(t[g + 2 | 0], u[e + 10 >> 1]) + B(t[g + 1 | 0], u[e + 8 >> 1]) | 0) + B(t[g + 3 | 0], u[e + 12 >> 1]) | 0) + B(t[g + 4 | 0], u[e + 14 >> 1]) << 8 >> 1) + (((B(t[g - 2 | 0], u[e + 2 >> 1]) + B(t[g - 3 | 0], u[e >> 1]) | 0) + B(t[g - 1 | 0], u[e + 4 >> 1]) | 0) + B(t[g | 0], u[e + 6 >> 1]) << 8 >> 1) | 0) / 16384 << 8;
   e = p;
   g = Aua(e, e >> 31, o, A);
   k = k + g | 0;
   e = gb + f | 0;
   e = g >>> 0 > k >>> 0 ? e + 1 | 0 : e;
   f = k + 8388608 | 0;
   e = f >>> 0 < 8388608 ? e + 1 | 0 : e;
   f = Rc(f, e, 24);
   e = (f | 0) / 256 | 0;
   j = j + w | 0;
   v[c >> 2] = B(e, j >> 12) + v[c >> 2];
   i = i + s | 0;
   v[c + 4 >> 2] = v[c + 4 >> 2] + B(i >> 12, e);
   Ob(h + 8 | 0, l, C);
   f = f - (x & p) | 0;
   c = c + 8 | 0;
   d = d - 1 | 0;
   e = b;
   continue;
  }
  break;
 }
 c = v[h + 12 >> 2];
 v[a >> 2] = v[h + 8 >> 2];
 v[a + 4 >> 2] = c;
 v[a + 40 >> 2] = i;
 v[a + 20 >> 2] = j >> 12;
 v[a + 36 >> 2] = j;
 v[a + 48 >> 2] = e;
 v[a + 44 >> 2] = b;
 v[a + 24 >> 2] = i >> 12;
 eb = h + 16 | 0;
}

function yh(a, b, c, d) {
 var e = 0, f = 0, g = 0, h = 0, i = 0;
 f = eb - 16 | 0;
 eb = f;
 v[f + 12 >> 2] = d;
 e = 0;
 a: {
  if (b - 251 >>> 0 < 4294967046) {
   break a;
  }
  e = b - 1 | 0;
  g = v[a + 480180 >> 2];
  if (!wn(g)) {
   if (g & 17408) {
    a = ((e & 255) >>> 0) / 12 | 0;
    e = x[((B(a, -12) + e & 255) << 1) + 31584 >> 1] << 4 >>> a | 0;
    break a;
   }
   if (!d) {
    v[f + 12 >> 2] = 8363;
    d = 8363;
   }
   if (yj(a)) {
    a = ((e & 255) >>> 0) / 12 | 0;
    b = Aua(v[(B(a, -12) + e << 6 & 960) + 35472 >> 2] << a, 0, d, 0);
    a = gb;
    c = a >>> 21 | 0;
    h = f, i = Ac((a & 2097151) << 11 | b >>> 21, c), v[h + 8 >> 2] = i;
    wc(f + 8 | 0, 2147483647);
    e = v[f + 8 >> 2];
    break a;
   }
   if (w[a + 480208 | 0] & 16) {
    a = e & 255;
    e = x[((a >>> 0) % 12 << 1) + 31584 >> 1] << 5 >>> (a >>> 0) / 12 | 0;
    break a;
   }
   a = ((e & 255) >>> 0) / 12 | 0;
   wc(f + 12 | 0, -1 >>> a | 0);
   e = Ac(Cua(Aua(x[((B(a, -12) + e & 255) << 1) + 31584 >> 1], 0, 267616, 0), gb, v[f + 12 >> 2] << a, 0), gb);
   break a;
  }
  if (g & 20) {
   d = e >>> 0 > 12;
   if ((g | 0) == 16) {
    b = c << 4;
   } else {
    b = Nb(a + 1074312 | 0, 76) ? c & -8 : c;
   }
   c = d ? e : 12;
   if (w[a + 480208 | 0] & 16) {
    a = ((b | 0) / -2 | 0) - (c << 6) | 0;
    e = ((a | 0) <= -8447 ? -8447 : a) + 8448 | 0;
    break a;
   }
   a = c - 12 | 0;
   c = ((a & 255) >>> 0) / 12 | 0;
   d = ((b | 0) / 16 | 0) + (B(c, -12) + a << 3 & 248) | 0;
   v[f + 4 >> 2] = d + 8;
   Fe(f + 4 | 0, 0, 103);
   a = b >> 31;
   b = (a ^ b) - a & 15;
   a = d + (a | 1) | 0;
   a = (a | 0) <= -8 ? -8 : a;
   e = B(b, x[(((a | 0) >= 95 ? 95 : a) << 1) + 32080 >> 1]) + B(x[(v[f + 4 >> 2] << 1) + 32064 >> 1], 16 - b | 0) << 1 >>> c | 0;
   break a;
  }
  if (!(!(c & 240 | e >>> 0 < 24) & e >>> 0 < 108)) {
   a = ((e & 255) >>> 0) / 12 | 0;
   e = x[(B(c >>> 4 & 15, 12) + (B(a, -12) + e & 255) << 1) + 31184 >> 1] << 5 >>> a | 0;
   break a;
  }
  e = x[(b << 1) + 30958 >> 1] << 2;
 }
 eb = f + 16 | 0;
 return e;
}

function Iaa(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, q = 0;
 b = eb + -64 | 0;
 eb = b;
 c = v[a >> 2];
 a = v[c >> 2];
 d = v[a + 4 >> 2];
 v[b + 40 >> 2] = v[a + 20 >> 2];
 e = v[a + 16 >> 2];
 v[b + 32 >> 2] = v[a + 12 >> 2];
 v[b + 36 >> 2] = e;
 Wf(b + 48 | 0, b + 32 | 0, d);
 a = v[c + 4 >> 2];
 d = v[a + 8 >> 2];
 e = v[a + 4 >> 2];
 c = v[b + 60 >> 2];
 v[b + 24 >> 2] = v[b + 56 >> 2];
 v[b + 28 >> 2] = c;
 c = v[b + 52 >> 2];
 v[b + 16 >> 2] = v[b + 48 >> 2];
 v[b + 20 >> 2] = c;
 v[b + 8 >> 2] = v[a + 8 >> 2];
 c = v[a + 4 >> 2];
 v[b >> 2] = v[a >> 2];
 v[b + 4 >> 2] = c;
 a = eb - 32 | 0;
 eb = a;
 a: {
  b: {
   c: {
    d: {
     g = v[b + 4 >> 2];
     if (g >>> 0 >= e >>> 0) {
      if (y[b + 20 >> 2] < e >>> 0) {
       break d;
      }
      if (d >>> 0 > y[b + 8 >> 2]) {
       break c;
      }
      h = v[b + 28 >> 2];
      if (d >>> 0 > v[b + 24 >> 2] - h >>> 0) {
       break b;
      }
      k = v[b + 16 >> 2];
      l = v[b >> 2];
      e: while (1) {
       if ((d | 0) == (f | 0)) {
        break a;
       }
       m = (B(f, g) << 3) + l | 0;
       c = 0;
       while (1) if ((c | 0) == (e | 0)) {
        f = f + 1 | 0;
        continue e;
       } else {
        A[a + 24 >> 3] = A[(c << 3) + m >> 3];
        v[a + 16 >> 2] = 0;
        v[a + 20 >> 2] = -1074790400;
        v[a + 8 >> 2] = 0;
        v[a + 12 >> 2] = 1072693248;
        n = (c << 2) + k | 0;
        i = Ee(A[Xg(a + 24 | 0, a + 16 | 0, a + 8 | 0) >> 3] * 32768);
        f: {
         if (D(i) < 2147483648) {
          j = ~~i;
          break f;
         }
         j = -2147483648;
        }
        o = (v[n >> 2] + (h << 1) | 0) + (f << 1) | 0, q = fd(j), u[o >> 1] = q;
        c = c + 1 | 0;
        continue;
       }
      }
     }
     Z(7244, 9045, 77, 8725);
     p();
    }
    Z(7209, 9045, 78, 8725);
    p();
   }
   Z(5897, 9045, 79, 8725);
   p();
  }
  Z(5867, 9045, 80, 8725);
  p();
 }
 eb = a + 32 | 0;
 eb = b - -64 | 0;
}

function g8(a, b, c, d, e, f) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 f = f | 0;
 var g = 0;
 g = eb - 32 | 0;
 eb = g;
 v[g + 28 >> 2] = b;
 a: {
  b: {
   if (!(t[d + 4 | 0] & 1)) {
    v[g >> 2] = -1;
    b = hb[v[v[a >> 2] + 16 >> 2]](a, b, c, d, e, g) | 0;
    c: {
     switch (v[g >> 2]) {
     case 1:
      t[f | 0] = 1;
      break a;

     case 0:
      break b;

     default:
      break c;
     }
    }
    t[f | 0] = 1;
    v[e >> 2] = 4;
    break a;
   }
   bd(g, v[d + 28 >> 2]);
   v[31601] = 0;
   b = Q(1251, v[g >> 2]) | 0;
   a = v[31601];
   v[31601] = 0;
   d: {
    e: {
     f: {
      g: {
       if ((a | 0) != 1) {
        Zb(g);
        bd(g, v[d + 28 >> 2]);
        v[31601] = 0;
        a = Q(1252, v[g >> 2]) | 0;
        d = v[31601];
        v[31601] = 0;
        if ((d | 0) == 1) {
         break g;
        }
        Zb(g);
        v[31601] = 0;
        N(1253, g | 0, a | 0);
        d = v[31601];
        v[31601] = 0;
        if ((d | 0) == 1) {
         b = M() | 0;
         break d;
        }
        v[31601] = 0;
        N(1254, g | 12, a | 0);
        a = v[31601];
        v[31601] = 0;
        if ((a | 0) == 1) {
         break f;
        }
        v[31601] = 0;
        d = g + 24 | 0;
        a = ra(1255, g + 28 | 0, c | 0, g | 0, d | 0, b | 0, e | 0, 1) | 0;
        b = v[31601];
        v[31601] = 0;
        if ((b | 0) == 1) {
         break e;
        }
        t[f | 0] = (a | 0) == (g | 0);
        b = v[g + 28 >> 2];
        while (1) {
         d = Tb(d - 12 | 0);
         if ((g | 0) != (d | 0)) {
          continue;
         }
         break;
        }
        break a;
       }
       b = M() | 0;
       Zb(g);
       break d;
      }
      b = M() | 0;
      Zb(g);
      break d;
     }
     b = M() | 0;
     Tb(g);
     break d;
    }
    b = M() | 0;
    while (1) {
     d = Tb(d - 12 | 0);
     if ((g | 0) != (d | 0)) {
      continue;
     }
     break;
    }
   }
   P(b | 0);
   p();
  }
  t[f | 0] = 0;
 }
 eb = g + 32 | 0;
 return b | 0;
}

function Mz(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0;
 d = eb - 16 | 0;
 eb = d;
 a: {
  b: {
   c: {
    d: {
     e: {
      f: {
       g: {
        e = v[a + 36 >> 2];
        c = v[a + 40 >> 2];
        h: {
         if (Hb(e, c)) {
          sc(d + 12 | 0);
          break h;
         }
         vo(d, a);
         v[31601] = 0;
         c = Q(1055, d | 0) | 0;
         e = v[31601];
         v[31601] = 0;
         if ((e | 0) == 1) {
          break g;
         }
         v[d + 12 >> 2] = c;
         nf(d);
         c = v[a + 40 >> 2];
         e = v[a + 36 >> 2];
        }
        e = (h = a + 36 | 0, i = v[d + 12 >> 2], j = Hb(e, c), j ? h : i);
        if ((b | 0) == -1) {
         f = v[e >> 2];
         c = 0;
         g = 4194304;
         break e;
        }
        if ((b | 0) >= 0) {
         c = b;
         f = v[e >> 2];
         if ((ej(f, v[e + 4 >> 2]) | 0) > (b | 0)) {
          break e;
         }
        }
        b = cc(8);
        v[31601] = 0;
        c = O(36, d | 0, 10966) | 0;
        a = v[31601];
        v[31601] = 0;
        if ((a | 0) == 1) {
         break f;
        }
        rc(b, c);
        v[31601] = 0;
        R(97, b | 0, 48396, 999);
        a = v[31601];
        v[31601] = 0;
        if ((a | 0) != 1) {
         break b;
        }
        a = M() | 0;
        sb(c);
        break d;
       }
       a = M() | 0;
       nf(d);
       break c;
      }
      a = M() | 0;
      jc(b);
      break d;
     }
     v[a + 8 >> 2] = b;
     b = v[a + 24 >> 2];
     v[b + 480208 >> 2] = v[b + 480208 >> 2] & -4194305 | g;
     Vj(b + 484360 | 0, w[vf(f, c) + 16 | 0]);
     b = vf(v[e >> 2], c);
     c = v[b + 8 >> 2];
     b = v[b + 12 >> 2];
     v[31601] = 0;
     +na(1087, a | 0, b | 0, c | 0);
     b = v[31601];
     v[31601] = 0;
     if ((b | 0) != 1) {
      break a;
     }
     a = M() | 0;
    }
    vl(d + 12 | 0);
   }
   P(a | 0);
  }
  p();
 }
 v[a + 16 >> 2] = 0;
 v[a + 20 >> 2] = 0;
 vl(d + 12 | 0);
 eb = d + 16 | 0;
}

function r8(a, b, c, d, e, f) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 f = f | 0;
 var g = 0;
 g = eb - 32 | 0;
 eb = g;
 v[g + 28 >> 2] = b;
 a: {
  b: {
   if (!(t[d + 4 | 0] & 1)) {
    v[g >> 2] = -1;
    b = hb[v[v[a >> 2] + 16 >> 2]](a, b, c, d, e, g) | 0;
    c: {
     switch (v[g >> 2]) {
     case 1:
      t[f | 0] = 1;
      break a;

     case 0:
      break b;

     default:
      break c;
     }
    }
    t[f | 0] = 1;
    v[e >> 2] = 4;
    break a;
   }
   bd(g, v[d + 28 >> 2]);
   v[31601] = 0;
   b = Q(28, v[g >> 2]) | 0;
   a = v[31601];
   v[31601] = 0;
   d: {
    e: {
     f: {
      g: {
       if ((a | 0) != 1) {
        Zb(g);
        bd(g, v[d + 28 >> 2]);
        v[31601] = 0;
        a = Q(1234, v[g >> 2]) | 0;
        d = v[31601];
        v[31601] = 0;
        if ((d | 0) == 1) {
         break g;
        }
        Zb(g);
        v[31601] = 0;
        N(1235, g | 0, a | 0);
        d = v[31601];
        v[31601] = 0;
        if ((d | 0) == 1) {
         b = M() | 0;
         break d;
        }
        v[31601] = 0;
        N(1236, g | 12, a | 0);
        a = v[31601];
        v[31601] = 0;
        if ((a | 0) == 1) {
         break f;
        }
        v[31601] = 0;
        d = g + 24 | 0;
        a = ra(1237, g + 28 | 0, c | 0, g | 0, d | 0, b | 0, e | 0, 1) | 0;
        b = v[31601];
        v[31601] = 0;
        if ((b | 0) == 1) {
         break e;
        }
        t[f | 0] = (a | 0) == (g | 0);
        b = v[g + 28 >> 2];
        while (1) {
         d = sb(d - 12 | 0);
         if ((g | 0) != (d | 0)) {
          continue;
         }
         break;
        }
        break a;
       }
       b = M() | 0;
       Zb(g);
       break d;
      }
      b = M() | 0;
      Zb(g);
      break d;
     }
     b = M() | 0;
     sb(g);
     break d;
    }
    b = M() | 0;
    while (1) {
     d = sb(d - 12 | 0);
     if ((g | 0) != (d | 0)) {
      continue;
     }
     break;
    }
   }
   P(b | 0);
   p();
  }
  t[f | 0] = 0;
 }
 eb = g + 32 | 0;
 return b | 0;
}

function LK(a, b) {
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0;
 d = eb - 32 | 0;
 eb = d;
 a: {
  if (w[a + 52 | 0]) {
   f = v[a + 48 >> 2];
   if (!b) {
    break a;
   }
   t[a + 52 | 0] = 0;
   v[a + 48 >> 2] = -1;
   break a;
  }
  if (w[a + 53 | 0]) {
   f = -1;
   c = v[a + 32 >> 2];
   b: {
    if (v[c + 76 >> 2] < 0) {
     c = HK(c);
     break b;
    }
    c = HK(c);
   }
   if ((c | 0) != -1) {
    v[d + 24 >> 2] = c;
   }
   if ((c | 0) == -1) {
    break a;
   }
   c = v[d + 24 >> 2];
   c: {
    if (!b) {
     if (KK(c, v[a + 32 >> 2])) {
      break c;
     }
     break a;
    }
    v[a + 48 >> 2] = c;
   }
   f = c;
   break a;
  }
  v[d + 24 >> 2] = 1;
  e = v[Ye(d + 24 | 0, a + 44 | 0) >> 2];
  g = (e | 0) > 0 ? e : 0;
  while (1) {
   if ((g | 0) != (h | 0)) {
    f = -1;
    c = dr(v[a + 32 >> 2]);
    if ((c | 0) == -1) {
     break a;
    }
    t[(d + 24 | 0) + h | 0] = c;
    h = h + 1 | 0;
    continue;
   }
   break;
  }
  k = d + 24 | 0;
  d: {
   while (1) {
    e: {
     i = v[a + 40 >> 2];
     c = v[i >> 2];
     h = v[i + 4 >> 2];
     f = -1;
     g = d + 24 | 0;
     j = g + e | 0;
     f: {
      switch (YK(v[a + 36 >> 2], i, g, j, d + 16 | 0, d + 20 | 0, k, d + 12 | 0) - 1 | 0) {
      case 1:
       break a;

      case 2:
       break e;

      case 0:
       break f;

      default:
       break d;
      }
     }
     g = v[a + 40 >> 2];
     v[g >> 2] = c;
     v[g + 4 >> 2] = h;
     if ((e | 0) == 8) {
      break a;
     }
     c = dr(v[a + 32 >> 2]);
     if ((c | 0) == -1) {
      break a;
     }
     t[j | 0] = c;
     e = e + 1 | 0;
     continue;
    }
    break;
   }
   v[d + 20 >> 2] = t[d + 24 | 0];
  }
  g: {
   if (!b) {
    while (1) {
     if ((e | 0) <= 0) {
      break g;
     }
     e = e - 1 | 0;
     if ((eo(t[e + (d + 24 | 0) | 0], v[a + 32 >> 2]) | 0) != -1) {
      continue;
     }
     break a;
    }
   }
   f = v[d + 20 >> 2];
   v[a + 48 >> 2] = f;
   break a;
  }
  f = v[d + 20 >> 2];
 }
 eb = d + 32 | 0;
 return f;
}

function fba(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0;
 if (y[a + 4 >> 2] < y[zb(a) >> 2]) {
  c = eb - 16 | 0;
  eb = c;
  a = kv(c + 4 | 0, a, 1);
  Bz(v[a + 4 >> 2], b);
  v[a + 4 >> 2] = v[a + 4 >> 2] + 16;
  hc(a);
  eb = c + 16 | 0;
  return;
 }
 i = eb - 32 | 0;
 eb = i;
 c = zb(a);
 d = MV(i + 12 | 0, NV(a, Ck(v[a >> 2], v[a + 4 >> 2]) + 1 | 0), Ck(v[a >> 2], v[a + 4 >> 2]), c);
 Bz(v[d + 8 >> 2], b);
 v[d + 8 >> 2] = v[d + 8 >> 2] + 16;
 h = eb - 16 | 0;
 eb = h;
 e = zb(a);
 b = ub(h + 12 | 0, v[a + 4 >> 2]);
 c = ub(h + 8 | 0, v[a >> 2]);
 f = ub(h + 4 | 0, v[d + 4 >> 2]);
 b = v[b >> 2];
 g = v[c >> 2];
 c = eb + -64 | 0;
 eb = c;
 f = v[f >> 2];
 v[c + 56 >> 2] = f;
 v[c + 60 >> 2] = b;
 v[c + 52 >> 2] = f;
 e = zg(c + 24 | 0, e, c + 52 | 0, c + 56 | 0);
 v[c + 16 >> 2] = v[e + 8 >> 2];
 f = v[e + 4 >> 2];
 v[c + 8 >> 2] = v[e >> 2];
 v[c + 12 >> 2] = f;
 yg(c + 36 | 0, c + 8 | 0);
 while (1) {
  if (Ed(b, g)) {
   Bz(Cz(v[c + 56 >> 2]), oC(b));
   b = Xq(c + 60 | 0);
   Xq(c + 56 | 0);
   b = v[b >> 2];
   continue;
  }
  break;
 }
 xg(c + 36 | 0);
 j = v[c + 56 >> 2];
 if (!w[c + 48 | 0]) {
  f = eb - 16 | 0;
  eb = f;
  b = ub(f + 12 | 0, v[v[c + 44 >> 2] >> 2]);
  k = v[ub(f + 8 | 0, v[v[c + 40 >> 2] >> 2]) >> 2];
  g = eb - 16 | 0;
  eb = g;
  b = v[b >> 2];
  v[g + 12 >> 2] = b;
  while (1) {
   if (vi(b, k)) {
    e = eb - 16 | 0;
    eb = e;
    v[e + 12 >> 2] = b;
    v[e + 12 >> 2] = v[e + 12 >> 2] + 16;
    eb = e + 16 | 0;
    Nj(Cz(v[e + 12 >> 2]));
    b = v[Uo(g + 12 | 0) >> 2];
    continue;
   }
   break;
  }
  eb = g + 16 | 0;
  eb = f + 16 | 0;
 }
 eb = c - -64 | 0;
 v[d + 4 >> 2] = j;
 Sb(a, d + 4 | 0);
 Sb(a + 4 | 0, d + 8 | 0);
 Sb(zb(a), mc(d));
 v[d >> 2] = v[d + 4 >> 2];
 eb = h + 16 | 0;
 a = v[d + 4 >> 2];
 while (1) {
  b = v[d + 8 >> 2];
  if ((b | 0) != (a | 0)) {
   b = b - 16 | 0;
   v[d + 8 >> 2] = b;
   Nj(b);
   continue;
  }
  break;
 }
 a = v[d >> 2];
 if (a) {
  vs(d);
  Bb(a);
 }
 eb = i + 32 | 0;
}

function n1(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0;
 d = eb - 32 | 0;
 eb = d;
 if ((w[a | 0] | w[a + 1 | 0] << 8 | (w[a + 2 | 0] << 16 | w[a + 3 | 0] << 24)) == 1397771593) {
  md(b, 32);
  xp(b);
  c = d + 8 | 0;
  ck(c, 1, a + 4 | 0);
  e = d + 20 | 0;
  Bc(e, c);
  Ae(b + 43 | 0, e);
  sb(e);
  u[b + 30 >> 1] = w[a + 19 | 0] << 2;
  Gf(b + 30 | 0, 256);
  u[b + 32 >> 1] = w[a + 17 | 0];
  Gf(b + 32 | 0, 64);
  u[b + 28 >> 1] = (w[a + 47 | 0] & 127) << 2;
  Gf(b + 28 | 0, 256);
  if (t[a + 47 | 0] < 0) {
   u[b + 34 >> 1] = x[b + 34 >> 1] | 32;
  }
  c = w[a + 18 | 0];
  if (c & 16) {
   u[b + 34 >> 1] = x[b + 34 >> 1] | 2;
   c = w[a + 18 | 0];
  }
  if (c & 32) {
   u[b + 34 >> 1] = x[b + 34 >> 1] | 8;
   c = w[a + 18 | 0];
  }
  if (c & 64) {
   u[b + 34 >> 1] = x[b + 34 >> 1] | 4;
   c = w[a + 18 | 0];
  }
  if (c << 24 >> 24 < 0) {
   u[b + 34 >> 1] = x[b + 34 >> 1] | 16;
  }
  c = w[a + 60 | 0] | w[a + 61 | 0] << 8 | (w[a + 62 | 0] << 16 | w[a + 63 | 0] << 24);
  v[b + 24 >> 2] = c ? c >>> 0 <= 256 ? 256 : c : 8363;
  v[b >> 2] = w[a + 48 | 0] | w[a + 49 | 0] << 8 | (w[a + 50 | 0] << 16 | w[a + 51 | 0] << 24);
  v[b + 4 >> 2] = w[a + 52 | 0] | w[a + 53 | 0] << 8 | (w[a + 54 | 0] << 16 | w[a + 55 | 0] << 24);
  v[b + 8 >> 2] = w[a + 56 | 0] | w[a + 57 | 0] << 8 | (w[a + 58 | 0] << 16 | w[a + 59 | 0] << 24);
  v[b + 12 >> 2] = w[a + 64 | 0] | w[a + 65 | 0] << 8 | (w[a + 66 | 0] << 16 | w[a + 67 | 0] << 24);
  v[b + 16 >> 2] = w[a + 68 | 0] | w[a + 69 | 0] << 8 | (w[a + 70 | 0] << 16 | w[a + 71 | 0] << 24);
  Sk(b);
  t[b + 38 | 0] = w[(w[a + 79 | 0] & 7) + 38032 | 0];
  t[b + 41 | 0] = w[a + 76 | 0];
  t[b + 40 | 0] = w[a + 77 | 0] & 127;
  t[b + 39 | 0] = w[a + 78 | 0];
  c = w[a + 46 | 0];
  a: {
   if ((c | 0) == 64) {
    c = 512;
   } else {
    if ((c | 0) != 128) {
     break a;
    }
    c = 16384;
   }
   u[b + 34 >> 1] = c | x[b + 34 >> 1];
  }
  c = w[a + 72 | 0] | w[a + 73 | 0] << 8 | (w[a + 74 | 0] << 16 | w[a + 75 | 0] << 24);
 }
 eb = d + 32 | 0;
 return c | 0;
}

function Cia(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0;
 if (y[a + 4 >> 2] < y[zb(a) >> 2]) {
  c = eb - 16 | 0;
  eb = c;
  a = lC(c + 4 | 0, a);
  fA(v[a + 4 >> 2], b);
  v[a + 4 >> 2] = v[a + 4 >> 2] + 4;
  hc(a);
  eb = c + 16 | 0;
  return;
 }
 i = eb - 32 | 0;
 eb = i;
 c = zb(a);
 d = Yf(i + 12 | 0, Kf(a, nc(v[a >> 2], v[a + 4 >> 2]) + 1 | 0), nc(v[a >> 2], v[a + 4 >> 2]), c);
 fA(v[d + 8 >> 2], b);
 v[d + 8 >> 2] = v[d + 8 >> 2] + 4;
 h = eb - 16 | 0;
 eb = h;
 e = zb(a);
 b = ub(h + 12 | 0, v[a + 4 >> 2]);
 c = ub(h + 8 | 0, v[a >> 2]);
 f = ub(h + 4 | 0, v[d + 4 >> 2]);
 b = v[b >> 2];
 g = v[c >> 2];
 c = eb + -64 | 0;
 eb = c;
 f = v[f >> 2];
 v[c + 56 >> 2] = f;
 v[c + 60 >> 2] = b;
 v[c + 52 >> 2] = f;
 e = zg(c + 24 | 0, e, c + 52 | 0, c + 56 | 0);
 v[c + 16 >> 2] = v[e + 8 >> 2];
 f = v[e + 4 >> 2];
 v[c + 8 >> 2] = v[e >> 2];
 v[c + 12 >> 2] = f;
 yg(c + 36 | 0, c + 8 | 0);
 while (1) {
  if (Ed(b, g)) {
   fA(KQ(v[c + 56 >> 2]), wf(b));
   b = vj(c + 60 | 0);
   vj(c + 56 | 0);
   b = v[b >> 2];
   continue;
  }
  break;
 }
 xg(c + 36 | 0);
 j = v[c + 56 >> 2];
 if (!w[c + 48 | 0]) {
  f = eb - 16 | 0;
  eb = f;
  b = ub(f + 12 | 0, v[v[c + 44 >> 2] >> 2]);
  k = v[ub(f + 8 | 0, v[v[c + 40 >> 2] >> 2]) >> 2];
  g = eb - 16 | 0;
  eb = g;
  b = v[b >> 2];
  v[g + 12 >> 2] = b;
  while (1) {
   if (vi(b, k)) {
    e = eb - 16 | 0;
    eb = e;
    v[e + 12 >> 2] = b;
    v[e + 12 >> 2] = v[e + 12 >> 2] + 4;
    eb = e + 16 | 0;
    lg(KQ(v[e + 12 >> 2]));
    b = v[Xe(g + 12 | 0) >> 2];
    continue;
   }
   break;
  }
  eb = g + 16 | 0;
  eb = f + 16 | 0;
 }
 eb = c - -64 | 0;
 v[d + 4 >> 2] = j;
 Sb(a, d + 4 | 0);
 Sb(a + 4 | 0, d + 8 | 0);
 Sb(zb(a), mc(d));
 v[d >> 2] = v[d + 4 >> 2];
 eb = h + 16 | 0;
 a = v[d + 4 >> 2];
 while (1) {
  b = v[d + 8 >> 2];
  if ((b | 0) != (a | 0)) {
   b = b - 4 | 0;
   v[d + 8 >> 2] = b;
   lg(b);
   continue;
  }
  break;
 }
 a = v[d >> 2];
 if (a) {
  Vz(d);
  Bb(a);
 }
 eb = i + 32 | 0;
}

function u2(a) {
 a = a | 0;
 var b = 0, c = 0, d = 0, e = 0, f = 0;
 c = eb - 48 | 0;
 eb = c;
 f = Eb(a);
 v[31601] = 0;
 a = ba(117) | 0;
 b = v[31601];
 v[31601] = 0;
 a: {
  b: {
   if ((b | 0) == 1) {
    break b;
   }
   c: {
    d: {
     if (!a) {
      break d;
     }
     v[31601] = 0;
     b = O(1, c + 24 | 0, 8963) | 0;
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) == 1) {
      break c;
     }
     v[31601] = 0;
     a = ba(117) | 0;
     d = v[31601];
     v[31601] = 0;
     e: {
      f: {
       g: {
        h: {
         if ((d | 0) == 1) {
          break h;
         }
         v[31601] = 0;
         v[c + 8 >> 2] = a;
         a = c + 12 | 0;
         N(126, a | 0, c + 8 | 0);
         d = v[31601];
         v[31601] = 0;
         if ((d | 0) == 1) {
          break h;
         }
         v[31601] = 0;
         d = c + 36 | 0;
         R(2, d | 0, b | 0, a | 0);
         e = v[31601];
         v[31601] = 0;
         if ((e | 0) == 1) {
          break g;
         }
         e = yb(f, d);
         sb(d);
         sb(a);
         sb(b);
         v[31601] = 0;
         a = ba(119) | 0;
         b = v[31601];
         v[31601] = 0;
         if ((b | 0) == 1) {
          break b;
         }
         if (!a) {
          break e;
         }
         v[31601] = 0;
         O(127, e | 0, 17514) | 0;
         a = v[31601];
         v[31601] = 0;
         if ((a | 0) != 1) {
          break e;
         }
         break b;
        }
        a = M() | 0;
        break f;
       }
       a = M() | 0;
       sb(c + 12 | 0);
      }
      sb(b);
      break a;
     }
     v[31601] = 0;
     a = ba(118) | 0;
     b = v[31601];
     v[31601] = 0;
     if ((b | 0) == 1) {
      break b;
     }
     if (!a) {
      break d;
     }
     v[31601] = 0;
     O(127, e | 0, 16800) | 0;
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) == 1) {
      break b;
     }
    }
    eb = c + 48 | 0;
    return;
   }
   a = M() | 0;
   break a;
  }
  a = M() | 0;
 }
 sb(f);
 P(a | 0);
 p();
}

function Cd(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0;
 e = eb - 80 | 0;
 eb = e;
 v[a + 480180 >> 2] = b;
 c = tr(a);
 sr(e + 12 | 0, c);
 f = v[e + 24 >> 2];
 d = a + 1074320 | 0;
 v[d >> 2] = v[e + 20 >> 2];
 v[d + 4 >> 2] = f;
 d = v[e + 16 >> 2];
 v[a + 1074312 >> 2] = v[e + 12 >> 2];
 v[a + 1074316 >> 2] = d;
 if (!((b | 0) == 32 | (c | 0) != 32)) {
  ag(a + 1074312 | 0, 120);
 }
 Cu(a + 8 | 0, c);
 c = a + 900380 | 0;
 b = 1;
 while (1) {
  d = b & 65535;
  if (d >>> 0 > x[a + 480192 >> 1]) {
   v[a + 480184 >> 2] = 0;
   v[a + 480188 >> 2] = 0;
   v[a + 480236 >> 2] = 65536;
   v[a + 480228 >> 2] = 48;
   v[a + 480232 >> 2] = 48;
   t[a + 480268 | 0] = 5;
   v[a + 480260 >> 2] = 16;
   v[a + 480264 >> 2] = 32767;
   v[a + 480204 >> 2] = 125e4;
   v[a + 480208 >> 2] = 0;
   v[a + 480196 >> 2] = 6;
   v[a + 480200 >> 2] = 256;
   v[a + 1074304 >> 2] = 0;
   v[a + 1074308 >> 2] = 0;
   u[a + 480192 >> 1] = 0;
   TA(a, 4);
   d = eb + -64 | 0;
   eb = d;
   b = a + 484344 | 0;
   Fu(b);
   f = fm(v[b >> 2], v[b + 4 >> 2]);
   c = sA(d + 12 | 0, b);
   v[31601] = 0;
   R(853, b | 0, f | 0, c | 0);
   b = v[31601];
   v[31601] = 0;
   a: {
    if ((b | 0) != 1) {
     uk(c);
     eb = d - -64 | 0;
     break a;
    }
    a = M() | 0;
    uk(c);
    P(a | 0);
    p();
   }
   OU(a + 484360 | 0);
   sf(a + 1298308 | 0);
   sf(a + 1298320 | 0);
   sf(a + 1298332 | 0);
   b = e + 12 | 0;
   Qb(b, 0, 68);
   b = pS(b);
   c = yb(a + 1298344 | 0, b);
   yb(c + 12 | 0, b + 12 | 0);
   yb(c + 24 | 0, b + 24 | 0);
   yb(c + 36 | 0, b + 36 | 0);
   yb(c + 48 | 0, b + 48 | 0);
   d = v[b + 64 >> 2];
   v[c + 60 >> 2] = v[b + 60 >> 2];
   v[c + 64 >> 2] = d;
   ZA(b);
   Mc(a + 1298412 | 0);
   Mc(a + 480248 | 0);
   if (v[a + 480180 >> 2] & 738230281) {
    v[a + 480208 >> 2] = v[a + 480208 >> 2] | 8388608;
   }
   eb = e + 80 | 0;
   return;
  }
  d = c + (d << 2) | 0;
  f = v[d >> 2];
  if (f) {
   Bb(Nv(f));
  }
  v[d >> 2] = 0;
  b = b + 1 | 0;
  continue;
 }
}

function qk(a, b, c, d, e, f, g, h) {
 var i = 0, j = 0, k = 0, l = 0, m = 0;
 i = eb - 16 | 0;
 eb = i;
 v[i + 8 >> 2] = c;
 v[i + 12 >> 2] = b;
 b = i + 4 | 0;
 bd(b, v[d + 28 >> 2]);
 c = 0;
 v[31601] = 0;
 j = Q(28, v[i + 4 >> 2]) | 0;
 k = v[31601];
 v[31601] = 0;
 if ((k | 0) != 1) {
  Zb(b);
  v[e >> 2] = 0;
  a: {
   while (1) {
    if ((g | 0) == (h | 0) | c) {
     break a;
    }
    b: {
     if (sh(i + 12 | 0, i + 8 | 0)) {
      break b;
     }
     c: {
      if ((kl(j, t[g | 0]) | 0) == 37) {
       if ((g + 1 | 0) == (h | 0)) {
        break b;
       }
       c = kl(j, t[g + 1 | 0]);
       d: {
        if (!((c | 0) == 69 | (c & 255) == 48)) {
         b = 0;
         k = 1;
         break d;
        }
        if ((g + 2 | 0) == (h | 0)) {
         break b;
        }
        b = c;
        c = kl(j, t[g + 2 | 0]);
        k = 2;
       }
       l = i, m = hb[v[v[a >> 2] + 36 >> 2]](a, v[i + 12 >> 2], v[i + 8 >> 2], d, e, f, c, b) | 0, 
       v[l + 12 >> 2] = m;
       g = (g + k | 0) + 1 | 0;
       break c;
      }
      b = v[j + 8 >> 2];
      if (If(b, 1, t[g | 0])) {
       while (1) {
        e: {
         g = g + 1 | 0;
         if ((h | 0) == (g | 0)) {
          g = h;
          break e;
         }
         if (If(b, 1, t[g | 0])) {
          continue;
         }
        }
        break;
       }
       while (1) {
        b = i + 12 | 0;
        if (sh(b, i + 8 | 0)) {
         break c;
        }
        c = rl(v[i + 12 >> 2]);
        if (!If(v[j + 8 >> 2], 1, c)) {
         break c;
        }
        Dm(b);
        continue;
       }
      }
      if ((Ky(j, rl(v[i + 12 >> 2])) | 0) == (Ky(j, t[g | 0]) | 0)) {
       g = g + 1 | 0;
       Dm(i + 12 | 0);
       break c;
      }
      v[e >> 2] = 4;
     }
     c = v[e >> 2];
     continue;
    }
    break;
   }
   v[e >> 2] = 4;
  }
  if (sh(i + 12 | 0, i + 8 | 0)) {
   v[e >> 2] = v[e >> 2] | 2;
  }
  eb = i + 16 | 0;
  return v[i + 12 >> 2];
 }
 a = M() | 0;
 Zb(i + 4 | 0);
 P(a | 0);
 p();
}

function $ta(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
 f = eb - 144 | 0;
 eb = f;
 v[31601] = 0;
 l = Q(273, a | 0) | 0;
 e = v[31601];
 v[31601] = 0;
 if ((e | 0) != 1) {
  m = c + 900380 | 0;
  n = f + 16 | 0;
  while (1) {
   a: {
    if ((j & 65535) >>> 0 >= l >>> 0) {
     tb(a);
     eb = f + 144 | 0;
     return;
    }
    v[31601] = 0;
    N(292, a | 0, f + 8 | 0);
    e = v[31601];
    v[31601] = 0;
    if ((e | 0) != 1) {
     b: {
      e = Ab(x[f + 8 >> 1]);
      if ((e - 1 & 65535) >>> 0 >= x[c + 480192 >> 1]) {
       break b;
      }
      e = v[(e << 2) + m >> 2];
      if (!e) {
       break b;
      }
      e = Vh(e, b);
      g = w[f + 11 | 0];
      c: {
       if (!g) {
        break c;
       }
       h = w[f + 10 | 0];
       if (h & 1) {
        t[e + 12 | 0] = w[e + 12 | 0] | 1;
       }
       if (h & 2) {
        t[e + 12 | 0] = w[e + 12 | 0] | 4;
       }
       if (!(h & 4)) {
        break c;
       }
       t[e + 12 | 0] = w[e + 12 | 0] | 2;
      }
      t[f + 4 | 0] = g;
      t[f + 7 | 0] = 31;
      h = w[Pb(f + 4 | 0, f + 7 | 0) | 0];
      v[31601] = 0;
      h = h + 1 & 255;
      N(293, e | 0, h | 0);
      g = v[31601];
      v[31601] = 0;
      if ((g | 0) == 1) {
       break a;
      }
      t[e + 13 | 0] = w[f + 13 | 0];
      t[e + 14 | 0] = w[f + 14 | 0];
      g = w[f + 12 | 0];
      t[e + 15 | 0] = g;
      t[e + 16 | 0] = g;
      g = v[e >> 2];
      e = 0;
      while (1) {
       if ((e | 0) == (h | 0)) {
        break b;
       }
       i = (e << 2) + n | 0;
       o = Ab(x[i >> 1]);
       k = xb(g, e);
       u[k >> 1] = o;
       i = Ab(x[i + 2 >> 1]);
       u[f + 4 >> 1] = d ? i + 128 >>> 2 | 0 : i;
       Gf(f + 4 | 0, 64);
       t[k + 2 | 0] = w[f + 4 | 0];
       e = e + 1 | 0;
       continue;
      }
     }
     j = j + 1 | 0;
     continue;
    }
   }
   break;
  }
 }
 b = M() | 0;
 tb(a);
 P(b | 0);
 p();
}

function eY(a, b, c, d, e) {
 var f = 0, g = 0;
 f = eb - 16 | 0;
 eb = f;
 g = x[c >> 1];
 a: {
  if ((d & 255) >>> 0 <= 4) {
   while (1) {
    d = g << 1;
    u[c >> 1] = d;
    t[b | 0] = (d & 65534) >>> 0 > 255;
    d = w[c | 0];
    u[c >> 1] = d;
    if (!d) {
     if (!Af(a, f + 15 | 0)) {
      break a;
     }
     d = w[f + 15 | 0];
     u[c >> 1] = d << 1 | 1;
     t[b | 0] = d >>> 7;
     u[c >> 1] = w[c | 0];
    }
    u[e >> 1] = t[b | 0] + (x[e >> 1] << 1);
    d = x[c >> 1] << 1;
    u[c >> 1] = d;
    t[b | 0] = (d & 65534) >>> 0 > 255;
    d = w[c | 0];
    u[c >> 1] = d;
    if (!d) {
     if (!Af(a, f + 14 | 0)) {
      break a;
     }
     d = w[f + 14 | 0];
     u[c >> 1] = d << 1 | 1;
     t[b | 0] = d >>> 7;
     u[c >> 1] = w[c | 0];
    }
    u[e >> 1] = t[b | 0] + (x[e >> 1] << 1);
    d = x[c >> 1] << 1;
    u[c >> 1] = d;
    t[b | 0] = (d & 65534) >>> 0 > 255;
    g = w[c | 0];
    u[c >> 1] = g;
    if (!g) {
     if (!Af(a, f + 13 | 0)) {
      break a;
     }
     d = w[f + 13 | 0];
     u[c >> 1] = d << 1 | 1;
     t[b | 0] = d >>> 7;
     g = w[c | 0];
     u[c >> 1] = g;
     if (w[b | 0]) {
      continue;
     }
     break a;
    }
    if (w[b | 0]) {
     continue;
    }
    break a;
   }
  }
  while (1) {
   d = g << 1;
   u[c >> 1] = d;
   t[b | 0] = (d & 65534) >>> 0 > 255;
   d = w[c | 0];
   u[c >> 1] = d;
   if (!d) {
    if (!Af(a, f + 12 | 0)) {
     break a;
    }
    d = w[f + 12 | 0];
    u[c >> 1] = d << 1 | 1;
    t[b | 0] = d >>> 7;
    u[c >> 1] = w[c | 0];
   }
   u[e >> 1] = t[b | 0] + (x[e >> 1] << 1);
   d = x[c >> 1] << 1;
   u[c >> 1] = d;
   t[b | 0] = (d & 65534) >>> 0 > 255;
   g = w[c | 0];
   u[c >> 1] = g;
   if (!g) {
    if (!Af(a, f + 11 | 0)) {
     break a;
    }
    d = w[f + 11 | 0];
    u[c >> 1] = d << 1 | 1;
    t[b | 0] = d >>> 7;
    g = w[c | 0];
    u[c >> 1] = g;
    if (w[b | 0]) {
     continue;
    }
    break a;
   }
   if (w[b | 0]) {
    continue;
   }
   break;
  }
 }
 eb = f + 16 | 0;
}

function Gha(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0;
 a: {
  f = b;
  c = eb - 16 | 0;
  eb = c;
  d = Eb(a);
  while (1) {
   b: {
    c: {
     d: {
      if (Zc(v[f + 4 >> 2], w[f + 11 | 0]) >>> 0 > g >>> 0) {
       b = v[Vd(f, g) >> 2];
       if (b >>> 0 >= 2097152) {
        v[31601] = 0;
        N(962, d | 0, 63);
        a = v[31601];
        v[31601] = 0;
        if ((a | 0) != 1) {
         break c;
        }
        break b;
       }
       a = 0;
       while (1) {
        if ((a | 0) == 6) {
         b = 7;
         a = 6;
         break d;
        }
        e = b & 63;
        t[(c + 10 | 0) + a | 0] = e;
        if (b >>> 0 >= 64) {
         a = a + 1 | 0;
         b = b >>> 6 | 0;
         continue;
        }
        break;
       }
       if (a) {
        b = a + 1 | 0;
        if ((b | 0) != 2) {
         break d;
        }
        a = 1;
        b = 2;
        if ((e | 0) != 1) {
         break d;
        }
        a = w[c + 10 | 0] | 64;
       } else {
        a = w[c + 10 | 0];
       }
       v[31601] = 0;
       N(962, d | 0, a << 24 >> 24);
       a = v[31601];
       v[31601] = 0;
       if ((a | 0) != 1) {
        break c;
       }
       break b;
      }
      eb = c + 16 | 0;
      break a;
     }
     i = (2 << a) + 255 << 7 - a;
     e = b - 1 | 0;
     j = e + (c + 10 | 0) | 0;
     a = b;
     while (1) {
      if (!a) {
       break c;
      }
      e: {
       if ((a | 0) == (b | 0)) {
        a = w[j | 0];
        v[31601] = 0;
        N(962, d | 0, (a | i) << 24 >> 24);
        h = v[31601];
        v[31601] = 0;
        a = e;
        break e;
       }
       v[31601] = 0;
       a = a - 1 | 0;
       N(962, d | 0, t[a + (c + 10 | 0) | 0] | -128);
       h = v[31601];
       v[31601] = 0;
      }
      if ((h | 0) != 1) {
       continue;
      }
      break;
     }
     break b;
    }
    g = g + 1 | 0;
    continue;
   }
   break;
  }
  a = M() | 0;
  sb(d);
  P(a | 0);
  p();
 }
}

function Qha(a) {
 a = a | 0;
 var b = 0, c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = C(0), j = 0, k = 0;
 c = eb - 32 | 0;
 eb = c;
 a: {
  b = v[a + 20 >> 2];
  b: {
   if (!b) {
    break b;
   }
   v[b + 148 >> 2] = -1;
   j = c, k = hb[v[v[a >> 2] + 40 >> 2]](a) | 0, v[j + 16 >> 2] = k;
   v[c + 8 >> 2] = 1073741822;
   b = c + 16 | 0;
   d = c + 8 | 0;
   g = v[Gb(b, d) >> 2];
   e = g << 2;
   if (!e) {
    break b;
   }
   h = v[a + 20 >> 2];
   v[31601] = 0;
   N(287, h + 4 | 0, e + 4 | 0);
   e = v[31601];
   v[31601] = 0;
   c: {
    d: {
     if ((e | 0) != 1) {
      e = d;
      d = v[a + 20 >> 2];
      oe(e, v[d + 4 >> 2], v[d + 8 >> 2]);
      v[c >> 2] = 0;
      v[c + 4 >> 2] = 0;
      d = v[c + 12 >> 2];
      v[b >> 2] = v[c + 8 >> 2];
      v[b + 4 >> 2] = d;
      d = v[c + 4 >> 2];
      v[b + 8 >> 2] = v[c >> 2];
      v[b + 12 >> 2] = d;
      d = eb - 16 | 0;
      eb = d;
      v[d + 12 >> 2] = 0;
      pQ(b, d + 12 | 0);
      eb = d + 16 | 0;
      b = v[v[a >> 2] + 184 >> 2];
      v[31601] = 0;
      N(b | 0, a | 0, -1);
      b = v[31601];
      v[31601] = 0;
      if ((b | 0) == 1) {
       break d;
      }
      while (1) {
       if ((f | 0) == (g | 0)) {
        b = v[v[a >> 2] + 188 >> 2];
        v[31601] = 0;
        V(b | 0, a | 0);
        b = v[31601];
        v[31601] = 0;
        if ((b | 0) != 1) {
         break b;
        }
        break d;
       }
       b = v[v[a >> 2] + 48 >> 2];
       v[31601] = 0;
       i = C(Za(b | 0, a | 0, f | 0));
       b = v[31601];
       v[31601] = 0;
       if ((b | 0) != 1) {
        z[c + 8 >> 2] = i;
        f = f + 1 | 0;
        pQ(c + 16 | 0, c + 8 | 0);
        continue;
       }
       break;
      }
      b = S(124508) | 0;
      break c;
     }
     b = S(124508) | 0;
     break c;
    }
    b = S(124508) | 0;
   }
   if ((fb | 0) != (_(124508) | 0)) {
    break a;
   }
   X(b | 0) | 0;
   Mc(v[a + 20 >> 2] + 4 | 0);
   Y();
  }
  eb = c + 32 | 0;
  return;
 }
 P(b | 0);
 p();
}

function tr(a) {
 var b = 0, c = 0, d = 0, e = 0, f = 0;
 e = eb - 16 | 0;
 eb = e;
 a: {
  b: {
   c: {
    d: {
     e: {
      f: {
       g: {
        h: {
         b = v[a + 480180 >> 2];
         switch (b - 1 | 0) {
         case 7:
          break e;

         case 0:
         case 1:
         case 3:
          break f;

         case 2:
         case 4:
         case 5:
         case 6:
          break g;

         default:
          break h;
         }
        }
        if ((b | 0) == 16) {
         break b;
        }
        if ((b | 0) == 32) {
         break f;
        }
        if ((b | 0) == 64 | (b | 0) == 256 | ((b | 0) == 512 | (b | 0) == 2048) | (b | 0) == 8192) {
         break b;
        }
        if ((b | 0) == 65536) {
         break d;
        }
        d = 1;
        if ((b | 0) == 2097152) {
         break a;
        }
        if ((b | 0) == 4194304) {
         break c;
        }
        if ((b | 0) == 536870912 | (b | 0) == 67108864 | (b | 0) == 134217728) {
         break a;
        }
        d = b;
        if ((b | 0) == 16777216) {
         break a;
        }
       }
       d = 32;
       break a;
      }
      d = b;
      break a;
     }
     d = 4;
     if (x[a + 480192 >> 1]) {
      break a;
     }
     c = vb(v[a + 484344 >> 2]);
     v[e + 12 >> 2] = c;
     a = vb(v[a + 484348 >> 2]);
     while (1) {
      if (!Hb(c, a)) {
       d = 1;
       break a;
      }
      if (!(!Hb(v[c >> 2], v[c + 4 >> 2]) | v[c + 12 >> 2] == 64)) {
       break a;
      }
      c = v[Sl(e + 12 | 0) >> 2];
      continue;
     }
    }
    d = 16777216;
    break a;
   }
   d = 32;
   f = x[a + 480188 >> 1];
   if (f >>> 0 > 16) {
    break a;
   }
   b = a + 480280 | 0;
   while (1) {
    if ((c | 0) == (f | 0)) {
     break b;
    }
    a = b + (c << 5) | 0;
    if (t[a + 1 | 0] & 1) {
     break a;
    }
    c = c + 1 | 0;
    if (x[a + 6 >> 1] == 64) {
     continue;
    }
    break;
   }
   break a;
  }
  d = 2;
 }
 eb = e + 16 | 0;
 return d;
}

function mma(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, w = 0, x = 0, y = 0, z = 0;
 f = eb - 16 | 0;
 eb = f;
 g = v[a + 12 >> 2];
 h = v[a + 8 >> 2];
 a: {
  b: {
   if ((g | 0) <= 1 & h >>> 0 <= 805306368 | (g | 0) <= 0) {
    e = 131112;
    if ((g | 0) >= -2 & h >>> 0 >= 3489660928 | (g | 0) > -2) {
     break a;
    }
    e = 262184;
    if ((g | 0) == -2 & h >>> 0 < 2147483648 | g >>> 0 < 4294967294) {
     break a;
    }
    break b;
   }
   e = 262184;
   if ((g | 0) == 1 & h >>> 0 > 2147483648 | g >>> 0 > 1) {
    break a;
   }
  }
  e = 196648;
 }
 l = v[a + 16 >> 2];
 i = v[a + 40 >> 2];
 j = v[a + 36 >> 2];
 k = v[a + 4 >> 2];
 v[f + 8 >> 2] = v[a >> 2];
 v[f + 12 >> 2] = k;
 k = b + e | 0;
 m = v[a + 32 >> 2];
 n = v[a + 28 >> 2];
 while (1) {
  if (d) {
   b = v[f + 8 >> 2];
   o = (((v[f + 12 >> 2] & 2147483647) << 1 | b >>> 31) & -2) + l | 0;
   b = (b >>> 16 & 65520) + k | 0;
   p = u[b + 14 >> 1];
   q = u[b + 12 >> 1];
   r = u[b + 10 >> 1];
   s = u[b + 8 >> 1];
   w = u[b + 6 >> 1];
   x = u[b + 4 >> 1];
   y = u[b + 2 >> 1];
   z = u[b >> 1];
   b = 0;
   while (1) {
    if ((b | 0) != 2) {
     e = b + o | 0;
     v[(b << 2) + f >> 2] = (((((((B(t[e - 4 | 0], y) + B(t[e - 6 | 0], z) | 0) + B(t[e - 2 | 0], x) | 0) + B(t[e | 0], w) | 0) + B(t[e + 2 | 0], s) | 0) + B(t[e + 4 | 0], r) | 0) + B(t[e + 6 | 0], q) | 0) + B(t[e + 8 | 0], p) << 8) / 32768;
     b = b + 1 | 0;
     continue;
    }
    break;
   }
   j = j + n | 0;
   v[c >> 2] = v[c >> 2] + B(v[f >> 2], j >> 12);
   i = i + m | 0;
   v[c + 4 >> 2] = v[c + 4 >> 2] + B(v[f + 4 >> 2], i >> 12);
   Ob(f + 8 | 0, h, g);
   c = c + 8 | 0;
   d = d - 1 | 0;
   continue;
  }
  break;
 }
 b = v[f + 12 >> 2];
 v[a >> 2] = v[f + 8 >> 2];
 v[a + 4 >> 2] = b;
 v[a + 40 >> 2] = i;
 v[a + 20 >> 2] = j >> 12;
 v[a + 36 >> 2] = j;
 v[a + 24 >> 2] = i >> 12;
 eb = f + 16 | 0;
}

function FL(a, b, c) {
 var d = 0, e = 0, f = 0, g = 0, h = 0;
 g = a;
 d = eb - 208 | 0;
 eb = d;
 v[d + 8 >> 2] = 1;
 v[d + 12 >> 2] = 0;
 h = b << 2;
 a: {
  if (!h) {
   break a;
  }
  v[d + 16 >> 2] = 4;
  v[d + 20 >> 2] = 4;
  b = 4;
  f = 4;
  e = 2;
  while (1) {
   a = b;
   b = (b + f | 0) + 4 | 0;
   v[(d + 16 | 0) + (e << 2) >> 2] = b;
   e = e + 1 | 0;
   f = a;
   if (b >>> 0 < h >>> 0) {
    continue;
   }
   break;
  }
  a = (g + h | 0) - 4 | 0;
  b: {
   if (a >>> 0 <= g >>> 0) {
    e = 1;
    b = 1;
    a = 0;
    break b;
   }
   e = 1;
   b = 1;
   while (1) {
    c: {
     if ((e & 3) == 3) {
      bz(g, c, b, d + 16 | 0);
      Nt(d + 8 | 0, 2);
      b = b + 2 | 0;
      break c;
     }
     h = d + 16 | 0;
     f = b - 1 | 0;
     d: {
      if (y[h + (f << 2) >> 2] >= a - g >>> 0) {
       Mt(g, c, e, v[d + 12 >> 2], b, 0, h);
       break d;
      }
      bz(g, c, b, d + 16 | 0);
     }
     if ((b | 0) == 1) {
      Lt(d + 8 | 0, 1);
      b = 0;
      break c;
     }
     Lt(d + 8 | 0, f);
     b = 1;
    }
    e = v[d + 8 >> 2] | 1;
    v[d + 8 >> 2] = e;
    g = g + 4 | 0;
    if (a >>> 0 > g >>> 0) {
     continue;
    }
    break;
   }
   a = v[d + 12 >> 2];
  }
  Mt(g, c, e, a, b, 0, d + 16 | 0);
  f = v[d + 12 >> 2];
  e = v[d + 8 >> 2];
  if (!(f | ((b | 0) != 1 | (e | 0) != 1))) {
   break a;
  }
  while (1) {
   e: {
    if ((b | 0) <= 1) {
     a = yL(e, f);
     Nt(d + 8 | 0, a);
     a = a + b | 0;
     break e;
    }
    f = d + 8 | 0;
    Lt(f, 2);
    v[d + 8 >> 2] = v[d + 8 >> 2] ^ 7;
    Nt(f, 1);
    h = g - 4 | 0;
    e = d + 16 | 0;
    a = b - 2 | 0;
    Mt(h - v[e + (a << 2) >> 2] | 0, c, v[d + 8 >> 2], v[d + 12 >> 2], b - 1 | 0, 1, e);
    Lt(f, 1);
    b = v[d + 8 >> 2] | 1;
    v[d + 8 >> 2] = b;
    Mt(h, c, b, v[d + 12 >> 2], a, 1, e);
   }
   b = a;
   g = g - 4 | 0;
   f = v[d + 12 >> 2];
   e = v[d + 8 >> 2];
   if (f | ((b | 0) != 1 | (e | 0) != 1)) {
    continue;
   }
   break;
  }
 }
 eb = d + 208 | 0;
}

function VK(a, b) {
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, q = 0, r = 0, s = 0, u = 0;
 n = eb - 1040 | 0;
 eb = n;
 r = v[31476];
 a: {
  b: {
   j = n + 16 | 0;
   q = x[((b >>> 0 <= 153 ? b : 0) << 1) + 123392 >> 1] + 121472 | 0;
   d = v[v[124107] + 20 >> 2];
   if (d) {
    k = v[d + 4 >> 2];
    d = v[d >> 2];
    e = v[d >> 2] + 1794895138 | 0;
    f = zm(v[d + 8 >> 2], e);
    g = zm(v[d + 12 >> 2], e);
    h = zm(v[d + 16 >> 2], e);
    c: {
     if (k >>> 2 >>> 0 <= f >>> 0) {
      break c;
     }
     l = k - (f << 2) | 0;
     if ((g | h) & 3 | (l >>> 0 <= g >>> 0 | h >>> 0 >= l >>> 0)) {
      break c;
     }
     s = h >>> 2 | 0;
     u = d + (g & -4) | 0;
     g = 0;
     while (1) {
      h = f >>> 1 | 0;
      l = h + g | 0;
      m = (l << 3) + u | 0;
      i = zm(v[m >> 2], e);
      m = zm(v[m + 4 >> 2], e);
      if (m >>> 0 >= k >>> 0 | i >>> 0 >= k - m >>> 0) {
       break c;
      }
      o = i;
      i = d + m | 0;
      if (w[o + i | 0]) {
       break c;
      }
      i = gi(q, i);
      if (!i) {
       g = (d + (s << 2) | 0) + (l << 3) | 0;
       f = zm(v[g >> 2], e);
       e = zm(v[g + 4 >> 2], e);
       if (e >>> 0 >= k >>> 0 | f >>> 0 >= k - e >>> 0) {
        break c;
       }
       c = d + e | 0;
       c = w[c + f | 0] ? 0 : c;
       break c;
      }
      if ((f | 0) == 1) {
       break c;
      }
      o = h;
      f = f - h | 0;
      h = (i | 0) < 0;
      f = h ? o : f;
      g = h ? g : l;
      continue;
     }
    }
   }
   c = c ? c : q;
   d = Df(c);
   d: {
    if (d >>> 0 >= 1024) {
     yc(j, c, 1023);
     t[j + 1023 | 0] = 0;
     c = 68;
     break d;
    }
    yc(j, c, d + 1 | 0);
    c = 0;
   }
   if (c) {
    if ((c | 0) != 28) {
     break b;
    }
    c = 22256;
   } else {
    c = j;
   }
   break a;
  }
  ua();
  p();
 }
 if (!w[c | 0]) {
  v[n >> 2] = b;
  sy(j, 1024, 13075, n);
  c = j;
 }
 v[31476] = r;
 Cc(a, c);
 eb = n + 1040 | 0;
}

function p1(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0;
 a: {
  f = b;
  c = eb - 16 | 0;
  eb = c;
  d = Eb(a);
  while (1) {
   b: {
    c: {
     d: {
      if (Zc(v[f + 4 >> 2], w[f + 11 | 0]) >>> 0 > g >>> 0) {
       b = v[Vd(f, g) >> 2];
       if (b >>> 0 >= 2097152) {
        v[31601] = 0;
        N(50, d | 0, 63);
        a = v[31601];
        v[31601] = 0;
        if ((a | 0) != 1) {
         break c;
        }
        break b;
       }
       a = 0;
       while (1) {
        if ((a | 0) == 6) {
         b = 7;
         a = 6;
         break d;
        }
        e = b & 63;
        t[(c + 10 | 0) + a | 0] = e;
        if (b >>> 0 >= 64) {
         a = a + 1 | 0;
         b = b >>> 6 | 0;
         continue;
        }
        break;
       }
       if (a) {
        b = a + 1 | 0;
        if ((b | 0) != 2) {
         break d;
        }
        a = 1;
        b = 2;
        if ((e | 0) != 1) {
         break d;
        }
        a = w[c + 10 | 0] | 64;
       } else {
        a = w[c + 10 | 0];
       }
       v[31601] = 0;
       N(50, d | 0, a & 255);
       a = v[31601];
       v[31601] = 0;
       if ((a | 0) != 1) {
        break c;
       }
       break b;
      }
      eb = c + 16 | 0;
      break a;
     }
     e = b - 1 | 0;
     i = e + (c + 10 | 0) | 0;
     j = (2 << a) + 255 << 7 - a & 255;
     a = b;
     while (1) {
      if (!a) {
       break c;
      }
      e: {
       if ((a | 0) == (b | 0)) {
        a = w[i | 0];
        v[31601] = 0;
        N(50, d | 0, a | j);
        h = v[31601];
        v[31601] = 0;
        a = e;
        break e;
       }
       v[31601] = 0;
       a = a - 1 | 0;
       N(50, d | 0, w[a + (c + 10 | 0) | 0] | 128);
       h = v[31601];
       v[31601] = 0;
      }
      if ((h | 0) != 1) {
       continue;
      }
      break;
     }
     break b;
    }
    g = g + 1 | 0;
    continue;
   }
   break;
  }
  a = M() | 0;
  sb(d);
  P(a | 0);
  p();
 }
}

function pk(a, b, c, d, e, f, g, h) {
 var i = 0, j = 0, k = 0, l = 0, m = 0;
 i = eb - 16 | 0;
 eb = i;
 v[i + 8 >> 2] = c;
 v[i + 12 >> 2] = b;
 c = i + 4 | 0;
 bd(c, v[d + 28 >> 2]);
 b = 0;
 v[31601] = 0;
 j = Q(1251, v[i + 4 >> 2]) | 0;
 k = v[31601];
 v[31601] = 0;
 if ((k | 0) != 1) {
  Zb(c);
  v[e >> 2] = 0;
  a: {
   while (1) {
    if ((g | 0) == (h | 0) | b) {
     break a;
    }
    b: {
     if (ei(i + 12 | 0, i + 8 | 0)) {
      break b;
     }
     c: {
      if ((ok(j, v[g >> 2]) | 0) == 37) {
       if ((g + 4 | 0) == (h | 0)) {
        break b;
       }
       b = ok(j, v[g + 4 >> 2]);
       d: {
        if (!((b | 0) == 69 | (b & 255) == 48)) {
         c = 0;
         k = 4;
         break d;
        }
        if ((g + 8 | 0) == (h | 0)) {
         break b;
        }
        c = b;
        b = ok(j, v[g + 8 >> 2]);
        k = 8;
       }
       l = i, m = hb[v[v[a >> 2] + 36 >> 2]](a, v[i + 12 >> 2], v[i + 8 >> 2], d, e, f, b, c) | 0, 
       v[l + 12 >> 2] = m;
       g = (g + k | 0) + 4 | 0;
       break c;
      }
      if (nj(j, 1, v[g >> 2])) {
       while (1) {
        e: {
         g = g + 4 | 0;
         if ((h | 0) == (g | 0)) {
          g = h;
          break e;
         }
         if (nj(j, 1, v[g >> 2])) {
          continue;
         }
        }
        break;
       }
       while (1) {
        b = i + 12 | 0;
        if (ei(b, i + 8 | 0)) {
         break c;
        }
        if (!nj(j, 1, ql(v[i + 12 >> 2]))) {
         break c;
        }
        io(b);
        continue;
       }
      }
      if ((im(j, ql(v[i + 12 >> 2])) | 0) == (im(j, v[g >> 2]) | 0)) {
       g = g + 4 | 0;
       io(i + 12 | 0);
       break c;
      }
      v[e >> 2] = 4;
     }
     b = v[e >> 2];
     continue;
    }
    break;
   }
   v[e >> 2] = 4;
  }
  if (ei(i + 12 | 0, i + 8 | 0)) {
   v[e >> 2] = v[e >> 2] | 2;
  }
  eb = i + 16 | 0;
  return v[i + 12 >> 2];
 }
 a = M() | 0;
 Zb(i + 4 | 0);
 P(a | 0);
 p();
}

function JK(a, b) {
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0;
 c = eb - 32 | 0;
 eb = c;
 a: {
  if (w[a + 52 | 0]) {
   f = v[a + 48 >> 2];
   if (!b) {
    break a;
   }
   t[a + 52 | 0] = 0;
   v[a + 48 >> 2] = -1;
   break a;
  }
  if (w[a + 53 | 0]) {
   f = -1;
   d = dr(v[a + 32 >> 2]);
   if ((d | 0) != -1) {
    t[c + 24 | 0] = d;
   }
   if ((d | 0) == -1) {
    break a;
   }
   d = yf(t[c + 24 | 0]);
   b: {
    if (!b) {
     if (IK(d, v[a + 32 >> 2])) {
      break b;
     }
     break a;
    }
    v[a + 48 >> 2] = d;
   }
   f = d;
   break a;
  }
  v[c + 24 >> 2] = 1;
  e = v[Ye(c + 24 | 0, a + 44 | 0) >> 2];
  g = (e | 0) > 0 ? e : 0;
  while (1) {
   if ((g | 0) != (h | 0)) {
    f = -1;
    d = dr(v[a + 32 >> 2]);
    if ((d | 0) == -1) {
     break a;
    }
    t[(c + 24 | 0) + h | 0] = d;
    h = h + 1 | 0;
    continue;
   }
   break;
  }
  k = c + 24 | 0;
  c: {
   while (1) {
    d: {
     i = v[a + 40 >> 2];
     d = v[i >> 2];
     h = v[i + 4 >> 2];
     f = -1;
     g = c + 24 | 0;
     j = g + e | 0;
     e: {
      switch (YK(v[a + 36 >> 2], i, g, j, c + 16 | 0, c + 23 | 0, k, c + 12 | 0) - 1 | 0) {
      case 1:
       break a;

      case 2:
       break d;

      case 0:
       break e;

      default:
       break c;
      }
     }
     g = v[a + 40 >> 2];
     v[g >> 2] = d;
     v[g + 4 >> 2] = h;
     if ((e | 0) == 8) {
      break a;
     }
     d = dr(v[a + 32 >> 2]);
     if ((d | 0) == -1) {
      break a;
     }
     t[j | 0] = d;
     e = e + 1 | 0;
     continue;
    }
    break;
   }
   t[c + 23 | 0] = w[c + 24 | 0];
  }
  f: {
   if (!b) {
    while (1) {
     if ((e | 0) <= 0) {
      break f;
     }
     e = e - 1 | 0;
     if ((eo(yf(t[e + (c + 24 | 0) | 0]), v[a + 32 >> 2]) | 0) != -1) {
      continue;
     }
     break a;
    }
   }
   f = yf(t[c + 23 | 0]);
   v[a + 48 >> 2] = f;
   break a;
  }
  f = yf(t[c + 23 | 0]);
 }
 eb = c + 32 | 0;
 return f;
}

function oqa(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
 f = eb - 16 | 0;
 eb = f;
 u[f + 12 >> 1] = 0;
 v[f + 8 >> 2] = 0;
 j = 8;
 n = B(c, d) << 1;
 a: while (1) {
  if ((d | 0) != (l | 0)) {
   i = (l << 1) + b | 0;
   o = n + i | 0;
   while (1) {
    b: {
     c: {
      if (i >>> 0 < o >>> 0) {
       u[f + 6 >> 1] = 0;
       eY(a, f + 15 | 0, f + 12 | 0, j, f + 6 | 0);
       g = x[f + 6 >> 1];
       e = x[f + 12 >> 1];
       c = j;
       while (1) {
        if (c & 255) {
         h = e << 1;
         e = h & 254;
         d: {
          if (e) {
           h = (h & 65534) >>> 0 > 255;
           break d;
          }
          if (!Af(a, f + 5 | 0)) {
           break c;
          }
          e = w[f + 5 | 0];
          h = e >>> 7 | 0;
          e = e << 1 & 254 | 1;
         }
         c = c - 1 | 0;
         g = g << 1 | h;
         continue;
        }
        break;
       }
       u[f + 12 >> 1] = e;
       break b;
      }
      l = l + 1 | 0;
      continue a;
     }
     u[f + 12 >> 1] = 0;
    }
    c = 1;
    h = g & 65535;
    e: {
     if (h >>> 0 < 4) {
      break e;
     }
     e = 15;
     while (1) {
      c = e;
      m = e & 255;
      if (m >>> 0 < 2) {
       break e;
      }
      e = e - 1 | 0;
      if (!(h & 1 << m)) {
       continue;
      }
      break;
     }
    }
    e = g & 1;
    t[f + 15 | 0] = e;
    g = e - 1 ^ (g & 65534) >>> 1;
    e = g + x[f + 8 >> 1] | 0;
    u[f + 6 >> 1] = e;
    u[i >> 1] = e;
    v[f + 8 >> 2] = ((g >> 1) - (k << 16 >> 16) | 0) + (e << 16 >> 16 << 1);
    i = (d << 1) + i | 0;
    j = (c + j & 254) >>> 1 | 0;
    c = -32768;
    k = v[f + 8 >> 2];
    f: {
     if ((k | 0) >= -32768) {
      c = 32767;
      if ((k | 0) < 32768) {
       break f;
      }
     }
     v[f + 8 >> 2] = c;
    }
    k = e;
    continue;
   }
  }
  break;
 }
 eb = f + 16 | 0;
}

function m7(a, b, c, d, e, f, g) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 f = f | 0;
 g = g | 0;
 var h = 0, i = 0, j = 0, k = 0;
 a = eb - 144 | 0;
 eb = a;
 v[a + 136 >> 2] = c;
 v[a + 140 >> 2] = b;
 v[a + 20 >> 2] = 1273;
 i = a + 20 | 0;
 b = Ce(a + 24 | 0, a + 32 | 0, i);
 j = a + 16 | 0;
 bd(j, v[e + 28 >> 2]);
 v[31601] = 0;
 h = Q(28, v[a + 16 >> 2]) | 0;
 k = v[31601];
 v[31601] = 0;
 if ((k | 0) != 1) {
  a: {
   t[a + 15 | 0] = 0;
   e = v[e + 4 >> 2];
   v[31601] = 0;
   c = ma(1274, a + 140 | 0, c | 0, d | 0, j | 0, e | 0, f | 0, a + 15 | 0, h | 0, b | 0, i | 0, a + 132 | 0) | 0;
   d = v[31601];
   v[31601] = 0;
   if ((d | 0) == 1) {
    break a;
   }
   b: {
    c: {
     if (!c) {
      break c;
     }
     sf(g);
     if (w[a + 15 | 0]) {
      v[31601] = 0;
      c = O(29, h | 0, 45) | 0;
      d = v[31601];
      v[31601] = 0;
      if ((d | 0) == 1) {
       break a;
      }
      v[31601] = 0;
      N(115, g | 0, c | 0);
      c = v[31601];
      v[31601] = 0;
      if ((c | 0) == 1) {
       break a;
      }
     }
     v[31601] = 0;
     d = O(29, h | 0, 48) | 0;
     c = v[31601];
     v[31601] = 0;
     if ((c | 0) == 1) {
      break b;
     }
     e = v[a + 20 >> 2];
     h = e - 1 | 0;
     c = v[b >> 2];
     d = d & 255;
     while (1) {
      if (!((d | 0) != w[c | 0] | c >>> 0 >= h >>> 0)) {
       c = c + 1 | 0;
       continue;
      }
      break;
     }
     v[31601] = 0;
     T(1280, g | 0, c | 0, e | 0) | 0;
     c = v[31601];
     v[31601] = 0;
     if ((c | 0) != 1) {
      break c;
     }
     break a;
    }
    v[31601] = 0;
    c = O(1240, a + 140 | 0, a + 136 | 0) | 0;
    d = v[31601];
    v[31601] = 0;
    if ((d | 0) == 1) {
     break a;
    }
    if (c) {
     v[f >> 2] = v[f >> 2] | 2;
    }
    c = v[a + 140 >> 2];
    Zb(a + 16 | 0);
    Kc(b);
    eb = a + 144 | 0;
    return c | 0;
   }
  }
 }
 c = M() | 0;
 Zb(a + 16 | 0);
 Kc(b);
 P(c | 0);
 p();
}

function Jo(a, b, c) {
 var d = 0, e = 0, f = 0, g = 0;
 f = a + 1074312 | 0;
 d = Nb(f, 96);
 v[b + 660 >> 2] = (d ? 0 : v[b + 660 >> 2]) + c;
 e = v[a + 480180 >> 2];
 d = v[b + 84 >> 2];
 if (!(!(e & 18) | d >>> 0 > c >>> 0 | (!(w[b + 88 | 0] & 2) | !d))) {
  g = c;
  c = v[b + 80 >> 2];
  c = ((g - c >>> 0) % (d - c >>> 0) | 0) + c | 0;
 }
 c = c >>> (v[b + 88 >> 2] & (e | 0) == 16384) | 0;
 a: {
  b: {
   if (!Tc(w[b + 788 | 0])) {
    if (!Nb(f, 114)) {
     break b;
    }
   }
   d = v[b + 656 >> 2];
   c: {
    if (!d) {
     break c;
    }
    e = w[b + 788 | 0];
    if (!Tc(e)) {
     break c;
    }
    if ((x[$b(d + 236 | 0, e - 1 | 0) >> 1] - 1 & 65535) >>> 0 >= x[a + 480190 >> 1]) {
     break a;
    }
   }
   if (w[a + 480210 | 0] & 32) {
    d = c;
    c = v[b + 660 >> 2];
    v[b + 660 >> 2] = d + c;
   }
   v[b >> 2] = 0;
   v[b + 4 >> 2] = c;
   if ((!(w[b + 88 | 0] & 2) | y[b + 84 >> 2] > c >>> 0) & y[b + 76 >> 2] > c >>> 0) {
    break a;
   }
   d: {
    if (!Nb(f, 57)) {
     c = v[a + 480180 >> 2];
     if ((c | 0) != 16) {
      break d;
     }
    }
    v[b + 700 >> 2] = 0;
    v[b + 88 >> 2] = v[b + 88 >> 2] | 2097152;
    return;
   }
   if (!(c & 1048581)) {
    if (Nb(f, 27)) {
     if (w[a + 480208 | 0] & 4) {
      c = v[b + 76 >> 2];
      v[b >> 2] = 0;
      v[b + 4 >> 2] = c;
      return;
     }
     v[b >> 2] = 0;
     v[b + 4 >> 2] = 0;
     return;
    }
    c = v[b + 80 >> 2];
    d = 0;
    v[b >> 2] = d;
    v[b + 4 >> 2] = c;
    if (!(w[a + 480208 | 0] & 4)) {
     break a;
    }
    a = v[b + 76 >> 2];
    if (a >>> 0 < 5) {
     break a;
    }
    v[b >> 2] = d;
    v[b + 4 >> 2] = a - 2;
    return;
   }
   if (!(w[b + 88 | 0] & 2) | (c | 0) != 1) {
    break a;
   }
   a = v[b + 80 >> 2];
   v[b >> 2] = 0;
   v[b + 4 >> 2] = a;
   return;
  }
  if (!(v[a + 480180 >> 2] & 268582928) | y[b + 76 >> 2] <= c >>> 0) {
   break a;
  }
  v[b >> 2] = 0;
  v[b + 4 >> 2] = c;
 }
}

function bia(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0;
 h = eb - 16 | 0;
 eb = h;
 if (!w[a + 4242 | 0]) {
  $z(a);
  a: {
   if (!w[a + 4240 | 0]) {
    break a;
   }
   e = QA(v[a + 16 >> 2]);
   if (e == A[a + 4288 >> 3]) {
    break a;
   }
   A[a + 4288 >> 3] = e;
   ru(a);
  }
  f = a + 4256 | 0;
  b: {
   if (w[a + 4244 | 0]) {
    if (A[f >> 3] > 1) {
     v[f >> 2] = 0;
     v[f + 4 >> 2] = 1072693248;
    }
    break b;
   }
   i = (v[a + 4232 >> 2] & -2) != 4;
   e = A[f >> 3];
   c: {
    if (D(e) < 2147483648) {
     g = ~~e;
     break c;
    }
    g = -2147483648;
   }
   if (!(i | (g | 0) <= 0)) {
    Zz(a);
    e = A[a + 4256 >> 3];
   }
   A[f >> 3] = e - +(g | 0);
  }
  e = 0;
  d: {
   e: {
    switch (v[a + 4232 >> 2]) {
    case 0:
     e = Oi(A[f >> 3] * 6.283185307179586);
     break d;

    case 1:
     e = D(A[f >> 3] + -.5) * -4 + 1;
     break d;

    case 2:
     e = A[f >> 3];
     e = e + e + -1;
     break d;

    case 3:
     e = A[f >> 3] < .5 ? -1 : 1;
     break d;

    case 4:
     e = A[a + 4272 >> 3];
     break d;

    case 5:
     break e;

    default:
     break d;
    }
   }
   e = A[a + 4256 >> 3];
   e = e * (e * e) * (e * (e * 6 + -15) + 10);
   e = A[a + 4280 >> 3] * e + A[a + 4272 >> 3] * (1 - e);
  }
  A[h + 8 >> 3] = (w[a + 4241 | 0] ? -e : e) * +z[a + 4220 >> 2] + +z[a + 4224 >> 2];
  AT(h + 8 | 0, 1);
  g = wj(a);
  f: {
   if (!g) {
    break f;
   }
   f = v[a + 4236 >> 2];
   if (w[a + 4243 | 0]) {
    k = g, l = (f >>> 8 & 15 | 176) & 191 | (f & 127) << 8 | Xl(A[h + 8 >> 3] * 127) << 16, 
    j = v[v[g >> 2] + 68 >> 2], hb[j](k | 0, l | 0) | 0;
    break f;
   }
   hb[v[v[g >> 2] + 44 >> 2]](g, f, C(A[h + 8 >> 3]));
  }
  A[a + 4256 >> 3] = A[a + 4264 >> 3] * +(d >>> 0) + A[a + 4256 >> 3];
 }
 g = a;
 a = v[a + 44 >> 2];
 Hi(g, b, c, Gc(a, 0), Gc(a, 1), d);
 eb = h + 16 | 0;
}

function Gla(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0;
 e = eb - 16 | 0;
 eb = e;
 q = v[a + 16 >> 2];
 r = Fg(b + 327720 | 0, v[b + 20 >> 2], (v[a + 88 >> 2] & 16384) >>> 14 | 0);
 l = v[a + 8 >> 2];
 m = v[a + 12 >> 2];
 b = v[a >> 2];
 f = v[a + 4 >> 2];
 n = v[a + 128 >> 2];
 if (n) {
  o = Gg(l, m, n);
  p = gb;
  g = v[a + 76 >> 2];
  eg(b, f, uf(l, m, d), gb);
  k = gb >>> 0 > g >>> 0 ? d : 0;
 }
 g = a + 112 | 0;
 i = v[a + 40 >> 2];
 j = v[a + 36 >> 2];
 v[e >> 2] = b;
 v[e + 4 >> 2] = f;
 a: while (1) {
  if (d) {
   d = d - 1 | 0;
   v[e + 8 >> 2] = b;
   v[e + 12 >> 2] = 0;
   k = k - 1 | 0;
   o = k ? o : 0;
   p = k ? p : 0;
   f = ((((f & 2147483647) << 1 | b >>> 31) & 2147483646) << 1) + q | 0;
   b = n;
   while (1) if ((b | 0) <= 0) {
    Ob(g, v[a + 120 >> 2], v[a + 124 >> 2]);
    b = v[a + 116 >> 2];
    if (b) {
     h = v[e + 8 >> 2];
     h = (v[e + 12 >> 2] & 2147483647) << 1 | h >>> 31;
     be(g, (u[((h & 2147483646) << 1) + f >> 1] + u[f + (h << 1 | 2) >> 1] | 0) / 8 << 16 >> 16);
     ae(g, b);
     v[g >> 2] = v[g >> 2];
     v[g + 4 >> 2] = 0;
    }
    f = v[a + 32 >> 2];
    h = v[c >> 2];
    b = Eg(g, r);
    j = v[a + 28 >> 2] + j | 0;
    v[c >> 2] = B(b, j >> 12) + h;
    i = f + i | 0;
    v[c + 4 >> 2] = v[c + 4 >> 2] + B(b, i >> 12);
    Ob(e, l, m);
    c = c + 8 | 0;
    b = v[e >> 2];
    f = v[e + 4 >> 2];
    continue a;
   } else {
    h = v[e + 8 >> 2];
    h = (v[e + 12 >> 2] & 2147483647) << 1 | h >>> 31;
    be(g, (u[((h & 2147483646) << 1) + f >> 1] + u[f + (h << 1 | 2) >> 1] | 0) / 8 << 16 >> 16);
    ae(g, 4);
    Ob(e + 8 | 0, o, p);
    b = b - 1 | 0;
    continue;
   }
  }
  break;
 }
 v[a >> 2] = b;
 v[a + 4 >> 2] = f;
 v[a + 40 >> 2] = i;
 v[a + 20 >> 2] = j >> 12;
 v[a + 36 >> 2] = j;
 v[a + 24 >> 2] = i >> 12;
 eb = e + 16 | 0;
}

function kqa(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0;
 g = eb - 48 | 0;
 eb = g;
 u[a >> 1] = 0;
 u[a + 2 >> 1] = 0;
 u[a + 4 >> 1] = 0;
 v[g + 44 >> 2] = 0;
 d = g + 44 | 0;
 c = eb - 16 | 0;
 eb = c;
 a: {
  if (!Lb(v[b >> 2], v[b + 8 >> 2], 4)) {
   rD(d);
   break a;
  }
  lh(c + 8 | 0, d);
  rd(c, b, v[c + 8 >> 2], v[c + 12 >> 2]);
 }
 eb = c + 16 | 0;
 b: {
  if (!kV(d)) {
   break b;
  }
  e = w[g + 46 | 0];
  f = w[g + 47 | 0];
  d = w[g + 45 | 0];
  t[a + 4 | 0] = 1;
  h = d >>> 3 & 3;
  c = (h | 0) != 3;
  d = (d ^ -1) >>> 1 & 3;
  f = f >>> 0 < 192;
  u[a + 2 >> 1] = x[(B(c, 6) + (d << 1) | 0) + 25704 >> 1] << f;
  i = B(B(w[(d + B(c, 3) | 0) + 25480 | 0], x[((B(c, 90) + B(d, 30) | 0) + (e >>> 3 & 30) | 0) + 25488 >> 1]), 1e3);
  e = e >>> 1 | 0;
  e = ((i >>> 0) / x[(B(h, 6) + (e & 6) | 0) + 25680 >> 1] | 0) + (e & 1) << (!d << 1);
  u[a >> 1] = e;
  d = w[(f | c << 1) + 25716 | 0];
  if (d + 8 >>> 0 > (e & 65535) >>> 0) {
   break b;
  }
  e = Qb(g, 0, 36);
  c = eb - 32 | 0;
  eb = c;
  v[c + 28 >> 2] = d + 4;
  v[c + 8 >> 2] = 36;
  h = v[b >> 2];
  i = v[b + 8 >> 2];
  f = v[Gb(c + 28 | 0, c + 8 | 0) >> 2];
  if (!Lb(h, i, f)) {
   f = jf(b);
  }
  h = c + 8 | 0;
  bs(h, e);
  i = Yb(c + 16 | 0, v[c + 8 >> 2], f);
  ic(c, v[b >> 2], v[b + 8 >> 2], v[i >> 2], v[i + 4 >> 2]);
  bs(h, e);
  Qb(v[c + 8 >> 2] + f | 0, 0, 36 - f | 0);
  Ub(b, v[c + 28 >> 2]);
  eb = c + 32 | 0;
  b = 2;
  c = d >>> 0 <= 2 ? 2 : d;
  while (1) {
   if ((b | 0) != (c | 0)) {
    f = b + e | 0;
    b = b + 1 | 0;
    if (!w[f | 0]) {
     continue;
    }
    break b;
   }
   break;
  }
  b = d + e | 0;
  if ((w[b | 0] | w[b + 1 | 0] << 8 | (w[b + 2 | 0] << 16 | w[b + 3 | 0] << 24)) == 1868983881) {
   b = 1;
  } else {
   b = (w[b | 0] | w[b + 1 | 0] << 8 | (w[b + 2 | 0] << 16 | w[b + 3 | 0] << 24)) == 1735289176;
  }
  t[a + 5 | 0] = b;
 }
 eb = g + 48 | 0;
 return a | 0;
}

function n0(a) {
 var b = 0, c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0;
 d = eb - 16 | 0;
 eb = d;
 a: {
  if ((w[a | 0] - 16 & 255) >>> 0 < 241) {
   break a;
  }
  c = 1698;
  while (1) {
   if ((c | 0) == 1954) {
    h = a + 1346 | 0;
    i = a + 930 | 0;
    j = a + 418 | 0;
    k = a + 2 | 0;
    c = 0;
    a = 0;
    while (1) {
     if ((c | 0) == 32) {
      l = a;
      break a;
     }
     e = B(c, 13);
     if (w[mc(e + k | 0) | 0]) {
      break a;
     }
     b = (c << 4) + j | 0;
     if (w[b | 0] | w[b + 1 | 0] << 8 | (w[b + 2 | 0] << 16 | w[b + 3 | 0] << 24)) {
      break a;
     }
     f = w[b + 4 | 0] | w[b + 5 | 0] << 8 | (w[b + 6 | 0] << 16 | w[b + 7 | 0] << 24);
     if (f >>> 0 > 1048575) {
      break a;
     }
     if (w[mc(e + i | 0) | 0]) {
      break a;
     }
     e = B(c, 11) + h | 0;
     if (w[wb(e, 0) | 0] > 15) {
      break a;
     }
     if (w[wb(e, 5) | 0] > 3) {
      break a;
     }
     if (w[wb(e, 10) | 0] > 3) {
      break a;
     }
     b: {
      c: {
       d: {
        if (f) {
         g = w[b + 12 | 0] | w[b + 13 | 0] << 8 | (w[b + 14 | 0] << 16 | w[b + 15 | 0] << 24);
         if (g >>> 0 <= 1048574) {
          if (f >>> 0 < g >>> 0 | (w[b + 8 | 0] | w[b + 9 | 0] << 8 | (w[b + 10 | 0] << 16 | w[b + 11 | 0] << 24)) >>> 0 > g >>> 0) {
           break a;
          }
         }
         if (a | f) {
          break c;
         }
         break d;
        }
        if (a) {
         break c;
        }
       }
       t[d + 7 | 0] = 0;
       t[d + 8 | 0] = 0;
       t[d + 9 | 0] = 0;
       t[d + 10 | 0] = 0;
       v[d >> 2] = 0;
       v[d + 4 >> 2] = 0;
       a = 0;
       if (m0(e, e + 11 | 0, d)) {
        break b;
       }
      }
      a = 1;
     }
     c = c + 1 | 0;
     continue;
    }
   }
   b = a + c | 0;
   c = c + 1 | 0;
   if (t[b | 0] > -2) {
    continue;
   }
   break;
  }
 }
 eb = d + 16 | 0;
 return l & 1;
}

function qqa(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0;
 e = eb - 16 | 0;
 eb = e;
 md(b, 0);
 xp(b);
 f = w[a | 0] | w[a + 1 | 0] << 8 | (w[a + 2 | 0] << 16 | w[a + 3 | 0] << 24);
 a: {
  if (c & 34) {
   if (d) {
    v[b + 24 >> 2] = f;
    break a;
   }
   g = b, h = Te(zi(+(f + 1408 | 0) / 1536) * 8363), v[g + 24 >> 2] = h;
   break a;
  }
  t[b + 37 | 0] = (c | 0) == 16 ? f : f ^ 128;
  t[b + 36 | 0] = w[a + 4 | 0];
 }
 t[e + 15 | 0] = w[a + 5 | 0];
 t[e + 14 | 0] = 64;
 g = b, h = w[Pb(e + 15 | 0, e + 14 | 0) | 0] << 2, u[g + 30 >> 1] = h;
 d = w[a + 6 | 0] | w[a + 7 | 0] << 8;
 if (d >>> 0 <= 256) {
  u[b + 28 >> 1] = d;
  u[b + 34 >> 1] = x[b + 34 >> 1] | 32;
 }
 v[b >> 2] = w[a + 8 | 0] | w[a + 9 | 0] << 8 | (w[a + 10 | 0] << 16 | w[a + 11 | 0] << 24);
 v[b + 4 >> 2] = w[a + 12 | 0] | w[a + 13 | 0] << 8 | (w[a + 14 | 0] << 16 | w[a + 15 | 0] << 24);
 v[b + 8 >> 2] = w[a + 16 | 0] | w[a + 17 | 0] << 8 | (w[a + 18 | 0] << 16 | w[a + 19 | 0] << 24);
 d = w[a + 20 | 0] | w[a + 21 | 0] << 8;
 if (d & 16) {
  u[b + 34 >> 1] = x[b + 34 >> 1] | 2;
  d = w[a + 20 | 0] | w[a + 21 | 0] << 8;
 }
 if (d & 32) {
  u[b + 34 >> 1] = x[b + 34 >> 1] | 4;
  d = w[a + 20 | 0] | w[a + 21 | 0] << 8;
 }
 if (d & 256) {
  u[b + 34 >> 1] = x[b + 34 >> 1] | 8;
  d = w[a + 20 | 0] | w[a + 21 | 0] << 8;
 }
 if (d & 512) {
  u[b + 34 >> 1] = x[b + 34 >> 1] | 16;
 }
 t[b + 38 | 0] = w[(w[a + 22 | 0] & 7) + 38032 | 0];
 t[b + 39 | 0] = w[a + 23 | 0];
 t[b + 40 | 0] = w[a + 24 | 0];
 t[b + 41 | 0] = w[a + 25 | 0];
 if ((c | 0) == 32) {
  t[e + 13 | 0] = w[a + 26 | 0];
  t[e + 12 | 0] = 64;
  g = b, h = w[Pb(e + 13 | 0, e + 12 | 0) | 0], u[g + 32 >> 1] = h;
 }
 v[b + 12 >> 2] = w[a + 27 | 0] | w[a + 28 | 0] << 8 | (w[a + 29 | 0] << 16 | w[a + 30 | 0] << 24);
 v[b + 16 >> 2] = w[a + 31 | 0] | w[a + 32 | 0] << 8 | (w[a + 33 | 0] << 16 | w[a + 34 | 0] << 24);
 eb = e + 16 | 0;
}

function iM(a) {
 a = a | 0;
 var b = 0, c = 0, d = 0, e = 0, f = 0, g = 0;
 f = eb - 16 | 0;
 eb = f;
 d = f + 8 | 0;
 yz(d, a);
 b = eb - 96 | 0;
 eb = b;
 a = v[d + 4 >> 2];
 hg(v[v[a >> 2] - 12 >> 2] + a | 0, 0);
 $d(b + 80 | 0, v[d + 4 >> 2]);
 a: {
  b: {
   e = v[d + 4 >> 2];
   a = v[v[e >> 2] - 12 >> 2] + e | 0;
   if (!mk(v[a + 16 >> 2])) {
    c = $h(b - -64 | 0, -1, -1);
    if (!ao(v[b + 88 >> 2], v[b + 92 >> 2], v[c + 8 >> 2], v[c + 12 >> 2])) {
     break b;
    }
   }
   hg(a, 0);
   break a;
  }
  Ci(e, 0, 0, 0);
  c = v[d + 4 >> 2];
  a = v[v[c >> 2] - 12 >> 2] + c | 0;
  if (mk(v[a + 16 >> 2])) {
   hg(a, 0);
   c = v[d + 4 >> 2];
   a = v[b + 92 >> 2];
   v[b + 8 >> 2] = v[b + 88 >> 2];
   v[b + 12 >> 2] = a;
   a = v[b + 84 >> 2];
   v[b >> 2] = v[b + 80 >> 2];
   v[b + 4 >> 2] = a;
   Sm(c, b);
   a = v[d + 4 >> 2];
   hg(v[v[a >> 2] - 12 >> 2] + a | 0, 0);
   break a;
  }
  Ci(c, 0, 0, 2);
  c = v[d + 4 >> 2];
  a = v[v[c >> 2] - 12 >> 2] + c | 0;
  if (mk(v[a + 16 >> 2])) {
   hg(a, 0);
   c = v[d + 4 >> 2];
   a = v[b + 92 >> 2];
   v[b + 24 >> 2] = v[b + 88 >> 2];
   v[b + 28 >> 2] = a;
   a = v[b + 84 >> 2];
   v[b + 16 >> 2] = v[b + 80 >> 2];
   v[b + 20 >> 2] = a;
   Sm(c, b + 16 | 0);
   a = v[d + 4 >> 2];
   hg(v[v[a >> 2] - 12 >> 2] + a | 0, 0);
   break a;
  }
  $d(b - -64 | 0, c);
  e = v[d + 4 >> 2];
  a = e + v[v[e >> 2] - 12 >> 2] | 0;
  c: {
   if (!mk(v[a + 16 >> 2])) {
    c = $h(b + 48 | 0, -1, -1);
    g = 1;
    if (!ao(v[b + 72 >> 2], v[b + 76 >> 2], v[c + 8 >> 2], v[c + 12 >> 2])) {
     break c;
    }
   }
   hg(a, 0);
   e = v[d + 4 >> 2];
   g = 0;
  }
  a = v[b + 92 >> 2];
  v[b + 40 >> 2] = v[b + 88 >> 2];
  v[b + 44 >> 2] = a;
  a = v[b + 84 >> 2];
  v[b + 32 >> 2] = v[b + 80 >> 2];
  v[b + 36 >> 2] = a;
  Sm(e, b + 32 | 0);
  a = v[d + 4 >> 2];
  hg(v[v[a >> 2] - 12 >> 2] + a | 0, 0);
 }
 eb = b + 96 | 0;
 eb = f + 16 | 0;
 return g | 0;
}

function lqa(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
 f = eb - 16 | 0;
 eb = f;
 u[f + 12 >> 1] = 0;
 v[f + 8 >> 2] = 0;
 n = B(c, d);
 k = 4;
 a: while (1) {
  if ((d | 0) != (l | 0)) {
   i = b + l | 0;
   o = n + i | 0;
   while (1) {
    b: {
     c: {
      if (i >>> 0 < o >>> 0) {
       t[f + 7 | 0] = 0;
       dY(a, f + 15 | 0, f + 12 | 0, f + 7 | 0);
       g = w[f + 7 | 0];
       e = x[f + 12 >> 1];
       c = k;
       while (1) {
        if (c & 255) {
         h = e << 1;
         e = h & 254;
         d: {
          if (e) {
           h = (h & 65534) >>> 0 > 255;
           break d;
          }
          if (!Af(a, f + 6 | 0)) {
           break c;
          }
          e = w[f + 6 | 0];
          h = e >>> 7 | 0;
          e = e << 1 & 254 | 1;
         }
         c = c - 1 | 0;
         g = g << 1 | h;
         continue;
        }
        break;
       }
       u[f + 12 >> 1] = e;
       break b;
      }
      l = l + 1 | 0;
      continue a;
     }
     u[f + 12 >> 1] = 0;
    }
    c = 1;
    h = g & 255;
    e: {
     if (h >>> 0 < 4) {
      break e;
     }
     e = 7;
     while (1) {
      c = e;
      m = e & 255;
      if (m >>> 0 < 2) {
       break e;
      }
      e = e - 1 | 0;
      if (!(h & 1 << m)) {
       continue;
      }
      break;
     }
    }
    e = g & 1;
    t[f + 15 | 0] = e;
    g = e - 1 ^ (g & 254) >>> 1;
    e = g + w[f + 8 | 0] | 0;
    t[f + 7 | 0] = e;
    t[i | 0] = e;
    v[f + 8 >> 2] = ((g >> 1) - (j << 24 >> 24) | 0) + (e << 24 >> 24 << 1);
    i = d + i | 0;
    k = (c + k & 254) >>> 1 | 0;
    c = -128;
    j = v[f + 8 >> 2];
    f: {
     if ((j | 0) >= -128) {
      c = 127;
      if ((j | 0) < 128) {
       break f;
      }
     }
     v[f + 8 >> 2] = c;
    }
    j = e;
    continue;
   }
  }
  break;
 }
 eb = f + 16 | 0;
}

function BM(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, q = 0;
 c = eb + -64 | 0;
 eb = c;
 d = v[a >> 2];
 a = v[d >> 2];
 f = v[a + 4 >> 2];
 v[c + 40 >> 2] = v[a + 20 >> 2];
 g = v[a + 16 >> 2];
 v[c + 32 >> 2] = v[a + 12 >> 2];
 v[c + 36 >> 2] = g;
 Wf(c + 48 | 0, c + 32 | 0, f);
 a = v[d + 4 >> 2];
 f = v[a + 8 >> 2];
 g = v[a + 4 >> 2];
 d = v[c + 60 >> 2];
 v[c + 24 >> 2] = v[c + 56 >> 2];
 v[c + 28 >> 2] = d;
 d = v[c + 52 >> 2];
 v[c + 16 >> 2] = v[c + 48 >> 2];
 v[c + 20 >> 2] = d;
 v[c + 8 >> 2] = v[a + 8 >> 2];
 d = v[a + 4 >> 2];
 v[c >> 2] = v[a >> 2];
 v[c + 4 >> 2] = d;
 a: {
  b: {
   c: {
    d: {
     i = v[c + 4 >> 2];
     if (i >>> 0 >= g >>> 0) {
      if (y[c + 20 >> 2] < g >>> 0) {
       break d;
      }
      if (f >>> 0 > y[c + 8 >> 2]) {
       break c;
      }
      j = v[c + 28 >> 2];
      if (f >>> 0 > v[c + 24 >> 2] - j >>> 0) {
       break b;
      }
      l = b + 12 | 0;
      m = v[c + 16 >> 2];
      n = v[c >> 2];
      a = 0;
      e: while (1) {
       if ((a | 0) == (f | 0)) {
        break a;
       }
       o = (B(a, i) << 2) + n | 0;
       d = 0;
       while (1) if ((d | 0) == (g | 0)) {
        a = a + 1 | 0;
        continue e;
       } else {
        e = xb(v[b >> 2], d);
        h = e;
        k = d << 2;
        e = v[k + o >> 2] + (v[e >> 2] >> 1) | 0;
        q = e;
        e = $t(l) + e & -4096;
        v[h >> 2] = q - e;
        h = (v[m + k >> 2] + (j << 1) | 0) + (a << 1) | 0;
        e = qd(e | 2048, 12);
        e = (e | 0) >= 32767 ? 32767 : e;
        u[h >> 1] = (e | 0) <= -32768 ? -32768 : e;
        d = d + 1 | 0;
        continue;
       }
      }
     }
     Z(7244, 9045, 33, 8758);
     p();
    }
    Z(7209, 9045, 34, 8758);
    p();
   }
   Z(5897, 9045, 35, 8758);
   p();
  }
  Z(5867, 9045, 36, 8758);
  p();
 }
 eb = c - -64 | 0;
}

function vM(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, q = 0, r = 0;
 c = eb + -64 | 0;
 eb = c;
 f = v[a >> 2];
 a = v[f >> 2];
 g = v[a + 4 >> 2];
 v[c + 40 >> 2] = v[a + 20 >> 2];
 e = v[a + 16 >> 2];
 v[c + 32 >> 2] = v[a + 12 >> 2];
 v[c + 36 >> 2] = e;
 Wf(c + 48 | 0, c + 32 | 0, g);
 a = v[f + 4 >> 2];
 f = v[a + 8 >> 2];
 g = v[a + 4 >> 2];
 e = v[c + 60 >> 2];
 v[c + 24 >> 2] = v[c + 56 >> 2];
 v[c + 28 >> 2] = e;
 e = v[c + 52 >> 2];
 v[c + 16 >> 2] = v[c + 48 >> 2];
 v[c + 20 >> 2] = e;
 v[c + 8 >> 2] = v[a + 8 >> 2];
 e = v[a + 4 >> 2];
 v[c >> 2] = v[a >> 2];
 v[c + 4 >> 2] = e;
 a: {
  b: {
   c: {
    d: {
     e = v[c + 4 >> 2];
     if (g >>> 0 <= e >>> 0) {
      i = v[c + 20 >> 2];
      if (g >>> 0 > i >>> 0) {
       break d;
      }
      if (f >>> 0 > y[c + 8 >> 2]) {
       break c;
      }
      j = v[c + 28 >> 2];
      if (f >>> 0 > v[c + 24 >> 2] - j >>> 0) {
       break b;
      }
      k = b + 12 | 0;
      l = v[c + 16 >> 2];
      m = v[c >> 2];
      e: while (1) {
       if ((f | 0) == (h | 0)) {
        break a;
       }
       n = (B(e, h) << 2) + m | 0;
       o = (B(h + j | 0, i) << 1) + l | 0;
       a = 0;
       while (1) if ((a | 0) == (g | 0)) {
        h = h + 1 | 0;
        continue e;
       } else {
        d = xb(v[b >> 2], a);
        q = d;
        d = v[(a << 2) + n >> 2] + (v[d >> 2] >> 1) | 0;
        r = d;
        d = $t(k) + d & -4096;
        v[q >> 2] = r - d;
        d = qd(d | 2048, 12);
        d = (d | 0) >= 32767 ? 32767 : d;
        u[(a << 1) + o >> 1] = (d | 0) <= -32768 ? -32768 : d;
        a = a + 1 | 0;
        continue;
       }
      }
     }
     Z(7244, 9045, 33, 8758);
     p();
    }
    Z(7209, 9045, 34, 8758);
    p();
   }
   Z(5897, 9045, 35, 8758);
   p();
  }
  Z(5867, 9045, 36, 8758);
  p();
 }
 eb = c - -64 | 0;
}

function CD(a, b, c, d) {
 t[a + 5 | 0] = c;
 a: {
  b: {
   switch ((b | 64) + -64 | 0) {
   case 0:
    t[a + 3 | 0] = c ? 37 : 0;
    return;

   case 1:
    t[a + 3 | 0] = 16;
    return;

   case 2:
    t[a + 3 | 0] = 12;
    return;

   case 3:
    t[a + 3 | 0] = 14;
    if (d) {
     break a;
    }
    t[a + 5 | 0] = B(c >>> 4 | 0, 10) + (c & 15);
    return;

   case 4:
    t[a + 3 | 0] = 11;
    return;

   case 5:
    t[a + 3 | 0] = 3;
    return;

   case 6:
    t[a + 3 | 0] = 2;
    return;

   case 7:
    t[a + 3 | 0] = 4;
    return;

   case 8:
    t[a + 3 | 0] = 5;
    return;

   case 9:
    t[a + 3 | 0] = 18;
    return;

   case 10:
    t[a + 3 | 0] = 1;
    return;

   case 11:
    t[a + 3 | 0] = 7;
    return;

   case 12:
    t[a + 3 | 0] = 6;
    return;

   case 13:
    t[a + 3 | 0] = 21;
    return;

   case 14:
    t[a + 3 | 0] = 22;
    return;

   case 15:
    t[a + 3 | 0] = 10;
    return;

   case 16:
    t[a + 3 | 0] = 29;
    return;

   case 17:
    t[a + 3 | 0] = 15;
    return;

   case 18:
    t[a + 3 | 0] = 8;
    return;

   case 19:
    t[a + 3 | 0] = 20;
    return;

   case 20:
    t[a + 3 | 0] = 17;
    return;

   case 21:
    t[a + 3 | 0] = 26;
    return;

   case 22:
    t[a + 3 | 0] = 23;
    return;

   case 23:
    t[a + 3 | 0] = 24;
    return;

   case 24:
    t[a + 3 | 0] = 9;
    return;

   case 25:
    t[a + 3 | 0] = 27;
    return;

   case 26:
    t[a + 3 | 0] = 31;
    return;

   case 28:
    t[a + 3 | 0] = d ? 32 : 31;
    return;

   case 29:
    t[a + 3 | 0] = d ? 33 : 0;
    return;

   case 27:
    t[a + 3 | 0] = d ? 34 : 0;
    return;

   case 30:
    t[a + 3 | 0] = d ? 35 : 0;
    return;

   case 31:
    t[a + 3 | 0] = d ? 36 : 0;
    return;

   case 50:
    t[a + 3 | 0] = d ? 25 : 0;
    return;

   case 51:
    t[a + 3 | 0] = d ? 30 : 0;
    return;

   default:
    break b;
   }
  }
  t[a + 3 | 0] = 0;
 }
}

function qfa(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0;
 v[31601] = 0;
 V(1020, a | 0);
 e = v[31601];
 v[31601] = 0;
 a: {
  b: {
   c: {
    d: {
     e: {
      if ((e | 0) == 1) {
       break e;
      }
      v[31601] = 0;
      V(996, b | 0);
      e = v[31601];
      v[31601] = 0;
      if ((e | 0) == 1) {
       break e;
      }
      e = 0;
      v[31601] = 0;
      V(1021, c | 0);
      f = v[31601];
      v[31601] = 0;
      if ((f | 0) == 1) {
       break e;
      }
      a = Qb(c, 0, d);
      if (!w[b | 0]) {
       break b;
      }
      if (gi(b, 47264) | (d | 0) != 8) {
       break d;
      }
      v[a + 4 >> 2] = 1022;
      v[a >> 2] = 1023;
      break c;
     }
     X(S(0) | 0) | 0;
     v[31601] = 0;
     U(982, 12344, a | 0, 0, 0);
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) == 1) {
      break a;
     }
     Y();
     return 0;
    }
    if (!(gi(b, 47276) | (d | 0) != 64)) {
     v[a + 60 >> 2] = 1024;
     v[a + 56 >> 2] = 1025;
     v[a + 52 >> 2] = 1026;
     v[a + 48 >> 2] = 1027;
     v[a + 44 >> 2] = 1028;
     v[a + 40 >> 2] = 1029;
     v[a + 36 >> 2] = 1030;
     v[a + 32 >> 2] = 1031;
     v[a + 28 >> 2] = 1032;
     v[a + 24 >> 2] = 1033;
     v[a + 20 >> 2] = 1034;
     v[a + 16 >> 2] = 1035;
     v[a + 12 >> 2] = 1036;
     v[a + 8 >> 2] = 1037;
     v[a + 4 >> 2] = 1038;
     v[a >> 2] = 1039;
     break c;
    }
    if (!(gi(b, 47288) | (d | 0) != 24)) {
     v[a + 20 >> 2] = 1040;
     v[a + 16 >> 2] = 1041;
     v[a + 12 >> 2] = 1042;
     v[a + 8 >> 2] = 1043;
     v[a + 4 >> 2] = 1044;
     v[a >> 2] = 1045;
     break c;
    }
    if (gi(b, 47301) | (d | 0) != 4) {
     break b;
    }
    v[a >> 2] = 1046;
   }
   e = 1;
  }
  return e | 0;
 }
 a = M() | 0;
 v[31601] = 0;
 W(26);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  P(a | 0);
  p();
 }
 S(0) | 0;
 Rb();
 p();
}

function yha(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = C(0), g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = C(0), n = 0, o = 0, p = C(0), q = C(0), r = C(0), s = C(0), t = C(0), u = 0, x = 0, y = 0, A = C(0);
 h = v[a + 44 >> 2];
 g = Gc(h, 0);
 h = Gc(h, 1);
 j = v[a + 56 >> 2];
 n = Gc(j, 0);
 j = Gc(j, 1);
 e = nc(v[a + 4208 >> 2], v[a + 4212 >> 2]);
 o = B(v[v[a + 16 >> 2] + 1074404 >> 2], w[a + 4233 | 0]);
 k = o << 1;
 if (e >>> 0 < k >>> 0) {
  Al(a + 4208 | 0, k);
 }
 l = w[a + 4232 | 0];
 a: {
  if (l) {
   e = v[a + 4220 >> 2];
   k = v[a + 4208 >> 2];
   u = l - 1 | 0;
   l = 0;
   while (1) {
    if ((d | 0) == (l | 0)) {
     break a;
    }
    r = z[h >> 2];
    e = e >>> 0 < o >>> 0 ? e : 0;
    i = e - o | 0;
    i = ((i | 0) < 0 ? e : i) << 1;
    x = xb(k, i);
    f = z[xb(k, i | 1) >> 2];
    s = z[g >> 2];
    t = z[x >> 2];
    p = C(s + t);
    z[n >> 2] = p;
    q = C(r + f);
    z[j >> 2] = q;
    f = C(0);
    m = C(0);
    b: {
     c: {
      switch (u | 0) {
      case 0:
       f = z[a + 4224 >> 2];
       m = C(q * f);
       f = C(p * f);
       break b;

      case 1:
      case 2:
       f = z[a + 4224 >> 2];
       m = C(p * f);
       f = C(q * f);
       break b;

      case 3:
       break c;

      default:
       break b;
      }
     }
     f = C(C(C(C(s + r) * C(.5)) + t) * z[a + 4224 >> 2]);
     m = f;
    }
    j = j + 4 | 0;
    n = n + 4 | 0;
    h = h + 4 | 0;
    g = g + 4 | 0;
    i = e << 1;
    y = xb(k, i), A = C(D(f)) < C(10000000195414814e-40) ? C(0) : f, z[y >> 2] = A;
    y = xb(k, i | 1), A = C(D(m)) < C(10000000195414814e-40) ? C(0) : m, z[y >> 2] = A;
    e = e + 1 | 0;
    v[a + 4220 >> 2] = e;
    l = l + 1 | 0;
    continue;
   }
  }
  e = g;
  g = d << 2;
  fD(e, e + g | 0, n);
  fD(h, h + g | 0, j);
 }
 g = a;
 a = v[a + 56 >> 2];
 Hi(g, b, c, Gc(a, 0), Gc(a, 1), d);
}

function yta(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0;
 g = eb - 2608 | 0;
 eb = g;
 d = eE(g + 4 | 0, a);
 v[d + 1060 >> 2] = 0;
 v[d + 1064 >> 2] = 0;
 a = 1068;
 while (1) {
  e = a + d | 0;
  t[e + 4 | 0] = 0;
  u[e >> 1] = 0;
  u[e + 2 >> 1] = 0;
  a = a + 6 | 0;
  if ((a | 0) != 2604) {
   continue;
  }
  break;
 }
 v[31601] = 0;
 V(323, d | 0);
 a = v[31601];
 v[31601] = 0;
 a: {
  b: {
   if ((a | 0) != 1) {
    if ((u[d + 1068 >> 1] | u[d + 1070 >> 1]) < 0) {
     break a;
    }
    e = d + 1068 | 0;
    c: {
     while (1) {
      if ((c | 0) == (h | 0)) {
       break a;
      }
      v[31601] = 0;
      k = O(158, d | 0, 1) | 0;
      a = v[31601];
      v[31601] = 0;
      if ((a | 0) == 1) {
       break c;
      }
      a = 0;
      d: {
       while (1) {
        v[31601] = 0;
        f = O(158, d | 0, 1) | 0;
        l = v[31601];
        v[31601] = 0;
        if ((l | 0) == 1) {
         break d;
        }
        a = e + B(a, 6) | 0;
        a = u[(f ? a + 2 | 0 : a) >> 1];
        e: {
         if ((a | 0) > 255) {
          break e;
         }
         f = e + B(a, 6) | 0;
         i = w[f + 4 | 0];
         if (u[f >> 1] < 0) {
          break e;
         }
         if (u[f + 2 >> 1] >= 0) {
          continue;
         }
        }
        break;
       }
       i = (k ? -1 : 0) ^ i;
       j = (i & 255) + j | 0;
       t[b + h | 0] = j;
       h = h + 1 | 0;
       continue;
      }
      break;
     }
     a = S(28784) | 0;
     break b;
    }
    a = S(28784) | 0;
    break b;
   }
   a = S(28784) | 0;
  }
  if ((fb | 0) == (_(28784) | 0)) {
   X(a | 0) | 0;
   v[31601] = 0;
   W(26);
   a = v[31601];
   v[31601] = 0;
   if ((a | 0) != 1) {
    break a;
   }
   a = M() | 0;
  }
  tb(d);
  P(a | 0);
  p();
 }
 a = Ar(d);
 tb(d);
 eb = g + 2608 | 0;
 return a | 0;
}

function Ula(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, w = 0, x = 0, y = 0;
 h = eb - 16 | 0;
 eb = h;
 o = v[a + 24 >> 2];
 p = v[a + 20 >> 2];
 e = v[a + 48 >> 2];
 f = v[a + 44 >> 2];
 q = v[a + 16 >> 2];
 j = v[a + 4 >> 2];
 v[h + 8 >> 2] = v[a >> 2];
 v[h + 12 >> 2] = j;
 r = b + 24 | 0;
 s = v[a + 72 >> 2];
 k = v[a + 68 >> 2];
 t = k >> 31;
 l = v[a + 64 >> 2];
 w = l >> 31;
 m = v[a + 60 >> 2];
 x = m >> 31;
 j = v[a + 8 >> 2];
 y = v[a + 12 >> 2];
 while (1) {
  b = f;
  if (d) {
   f = Xb(f, -16777216, 16776704);
   g = Aua(l, w, f, f >> 31);
   f = gb;
   e = Xb(e, -16777216, 16776704);
   e = Aua(k, t, e, e >> 31);
   g = e + g | 0;
   f = gb + f | 0;
   f = e >>> 0 > g >>> 0 ? f + 1 | 0 : f;
   e = v[h + 8 >> 2];
   i = g;
   g = (v[h + 12 >> 2] << 1) + q | 0;
   e = (((e >>> 16 | 0) + 4 & 131064) << 1) + r | 0;
   n = (((((B(u[g + 4 >> 1], u[e + 10 >> 1]) + B(u[g + 2 >> 1], u[e + 8 >> 1]) | 0) + B(u[g + 6 >> 1], u[e + 12 >> 1]) | 0) + B(u[g + 8 >> 1], u[e + 14 >> 1]) | 0) / 2 | 0) + ((((B(u[g - 4 >> 1], u[e + 2 >> 1]) + B(u[g - 6 >> 1], u[e >> 1]) | 0) + B(u[g - 2 >> 1], u[e + 4 >> 1]) | 0) + B(u[g >> 1], u[e + 6 >> 1]) | 0) / 2 | 0) | 0) / 16384 << 8;
   e = n;
   g = Aua(e, e >> 31, m, x);
   i = i + g | 0;
   e = gb + f | 0;
   e = g >>> 0 > i >>> 0 ? e + 1 | 0 : e;
   f = i + 8388608 | 0;
   e = f >>> 0 < 8388608 ? e + 1 | 0 : e;
   f = Rc(f, e, 24);
   e = (f | 0) / 256 | 0;
   v[c >> 2] = B(e, p) + v[c >> 2];
   v[c + 4 >> 2] = v[c + 4 >> 2] + B(e, o);
   Ob(h + 8 | 0, j, y);
   f = f - (s & n) | 0;
   c = c + 8 | 0;
   d = d - 1 | 0;
   e = b;
   continue;
  }
  break;
 }
 c = v[h + 12 >> 2];
 v[a >> 2] = v[h + 8 >> 2];
 v[a + 4 >> 2] = c;
 v[a + 48 >> 2] = e;
 v[a + 44 >> 2] = b;
 eb = h + 16 | 0;
}

function fC(a, b) {
 var c = 0, d = 0, e = 0, f = 0, g = 0;
 d = eb - 32 | 0;
 eb = d;
 u[a + 34 >> 1] = x[a + 34 >> 1] & 65407;
 if (b & 5) {
  if ((b | 0) == 1) {
   e = Aua(v[a + 24 >> 2], 0, 8363, 0);
   c = gb;
   e = e + 4143 | 0;
   c = e >>> 0 < 4143 ? c + 1 | 0 : c;
   f = a, g = Ac(Cua(e, c, 8287, 0), gb), v[f + 24 >> 2] = g;
  }
  pV(a);
 }
 if (b & 3) {
  u[a + 38 >> 1] = 0;
  u[a + 40 >> 1] = 0;
  t[a + 36 | 0] = 0;
  u[a + 34 >> 1] = x[a + 34 >> 1] & 65499;
 }
 if (b & 7) {
  u[a + 32 >> 1] = 64;
  c = x[a + 34 >> 1];
  if (c & 8) {
   e = v[a + 16 >> 2];
   v[a + 4 >> 2] = v[a + 12 >> 2];
   v[a + 8 >> 2] = e;
   c = c & 16 ? c | 6 : c & 65513 | 2;
  }
  v[a + 12 >> 2] = 0;
  v[a + 16 >> 2] = 0;
  u[a + 34 >> 1] = c & 65511;
 }
 a: {
  if (!(b & 4)) {
   break a;
  }
  c = x[a + 34 >> 1];
  if (!(c & 32)) {
   u[a + 28 >> 1] = 128;
   u[a + 34 >> 1] = c | 32;
  }
  Nf(a + 40 | 0, 15);
  Nf(a + 41 | 0, 63);
  if (!w[a + 41 | 0]) {
   break a;
  }
  e = w[a + 40 | 0];
  if (!e) {
   break a;
  }
  c = w[a + 39 | 0];
  if (c) {
   c = ri(Ac(((e << 8 | c >>> 1) >>> 0) / (c >>> 0) | 0, 0));
  } else {
   c = 255;
  }
  t[a + 39 | 0] = c;
 }
 b: {
  c: {
   if ((b | 0) != 4) {
    if ((b | 0) == 16777216) {
     break b;
    }
    if ((b | 0) != 32 | w[a + 38 | 0] != 2) {
     break c;
    }
    t[a + 38 | 0] = 3;
    break c;
   }
   if (w[a + 38 | 0] != 4) {
    break c;
   }
   t[a + 38 | 0] = 0;
  }
  u[a + 34 >> 1] = x[a + 34 >> 1] & 49151;
 }
 d: {
  if (!(!(w[a + 35 | 0] & 2) | b & 16777218)) {
   v[d + 24 >> 2] = 0;
   v[d + 8 >> 2] = 0;
   v[d + 16 >> 2] = 0;
   v[d + 20 >> 2] = 0;
   v[d >> 2] = 0;
   v[d + 4 >> 2] = 0;
   Qk(a, 0, d);
   break d;
  }
  if (!(w[a + 35 | 0] & 2) | (b | 0) != 2) {
   break d;
  }
  a = a + 68 | 0;
  b = wb(a, 8);
  t[b | 0] = w[b | 0] & 3;
  a = wb(a, 9);
  t[a | 0] = w[a | 0] & 3;
 }
 eb = d + 32 | 0;
}

function w1(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0;
 d = eb - 96 | 0;
 eb = d;
 xc(b);
 Lp(a);
 e = d + 60 | 0;
 a: {
  if (!cx(b, e)) {
   break a;
  }
  if (!YF(e)) {
   break a;
  }
  b: {
   if (!c) {
    break b;
   }
   if (!Lb(v[b >> 2], v[b + 8 >> 2], _b(w[d + 64 | 0] | w[d + 65 | 0] << 8 | (w[d + 66 | 0] << 16 | w[d + 67 | 0] << 24)) - 28 | 0)) {
    break a;
   }
   tx(a);
   g = d, h = sx(), v[g + 40 >> 2] = h;
   c = d + 40 | 0;
   rx(bj(v[a + 4 >> 2]) + 32 | 0, c);
   os(c);
   e = v[bj(v[a + 4 >> 2]) + 32 >> 2];
   f = w[d + 64 | 0] | w[d + 65 | 0] << 8 | (w[d + 66 | 0] << 16 | w[d + 67 | 0] << 24);
   v[31601] = 0;
   R(186, c | 0, b | 0, _b(f) - 28 | 0);
   b = v[31601];
   v[31601] = 0;
   c: {
    d: {
     if ((b | 0) != 1) {
      Ln(d + 32 | 0, c);
      b = w[d + 72 | 0] | w[d + 73 | 0] << 8 | (w[d + 74 | 0] << 16 | w[d + 75 | 0] << 24);
      v[31601] = 0;
      b = aa(187, v[d + 32 >> 2], v[d + 36 >> 2], e | 0, _b(b) | 0) | 0;
      f = v[31601];
      v[31601] = 0;
      if ((f | 0) == 1) {
       break d;
      }
      Jc(c);
      f = 0;
      if (!b) {
       break a;
      }
      oe(d + 16 | 0, v[e >> 2], v[e + 4 >> 2]);
      lf(d + 24 | 0, v[d + 16 >> 2], v[d + 20 >> 2]);
      b = Ld(d + 8 | 0);
      e = v[b + 4 >> 2];
      v[d >> 2] = v[b >> 2];
      v[d + 4 >> 2] = e;
      b = qx(c, v[d + 24 >> 2], v[d + 28 >> 2], d);
      jd(bj(v[a + 4 >> 2]) + 12 | 0, b);
      tb(b);
      break b;
     }
     a = sa(124508, 24440) | 0;
     b = fb;
     break c;
    }
    a = sa(124508, 24440) | 0;
    b = fb;
    Jc(d + 40 | 0);
   }
   e: {
    if ((_(124508) | 0) == (b | 0)) {
     break e;
    }
    if ((_(24440) | 0) == (b | 0)) {
     break e;
    }
    P(a | 0);
    p();
   }
   X(a | 0) | 0;
   Y();
   f = 0;
   break a;
  }
  f = 1;
 }
 eb = d + 96 | 0;
 return f | 0;
}

function d0(a, b, c) {
 var d = 0, e = 0;
 e = eb - 16 | 0;
 eb = e;
 t[e + 15 | 0] = c;
 a: {
  if (b >>> 0 > 35) {
   break a;
  }
  b: {
   c: {
    d: {
     e: {
      f: {
       g: {
        h: {
         d = w[b + 24656 | 0];
         switch (d - 6 | 0) {
         case 2:
         case 3:
         case 4:
         case 6:
         case 7:
         case 9:
         case 10:
         case 12:
          break a;

         case 11:
          break c;

         case 13:
          break d;

         case 0:
         case 1:
         case 5:
          break f;

         case 8:
          break g;

         default:
          break h;
         }
        }
        if ((d | 0) == 31) {
         break b;
        }
        if ((d | 0) == 23) {
         break e;
        }
        if ((d | 0) != 1) {
         break a;
        }
        d = (c | 0) != 0;
        break a;
       }
       t[e + 15 | 0] = B(c >>> 4 | 0, 10) + (c & 15);
       d = 14;
       break a;
      }
      b = c & 240;
      if (!b | (b | 0) == 240 | (c & 15) == 15) {
       break a;
      }
      t[e + 15 | 0] = b;
      break a;
     }
     if (c >>> 0 <= 64) {
      t[e + 15 | 0] = c << 1;
      d = 23;
      break a;
     }
     t[e + 15 | 0] = 128;
     d = 23;
     break a;
    }
    d = 19;
    i: {
     switch (c - 48 >>> 4 | 0) {
     case 0:
      t[e + 15 | 0] = 159;
      d = 20;
      break a;

     case 1:
      t[e + 15 | 0] = 192;
      d = 20;
      break a;

     case 2:
      if (c & 14) {
       break a;
      }
      t[e + 15 | 0] = ((c | 0) != 80) << 6;
      d = 21;
      break a;

     case 4:
      break i;

     default:
      break a;
     }
    }
    t[e + 15 | 0] = c & 15 | 160;
    d = 20;
    break a;
   }
   d = c >>> 0 < 32 ? 16 : 17;
   break a;
  }
  t[e + 15 | 0] = (b << 5 | c >>> 3) ^ 128;
  d = 31;
 }
 de(a, d, e + 15 | 0);
 eb = e + 16 | 0;
}

function S9(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0;
 f = eb - 32 | 0;
 eb = f;
 l = v[d >> 2];
 i = v[d + 4 >> 2];
 v[f + 28 >> 2] = i;
 o = b + 36 | 0;
 d = l;
 while (1) {
  a: {
   if (!i) {
    break a;
   }
   h = 0;
   e = eb - 32 | 0;
   eb = e;
   k = b + 36 | 0;
   g = b + 228 | 0;
   j = c & -4096;
   b: {
    c: {
     while (1) {
      if ((h | 0) == 16) {
       break c;
      }
      i = v[xb(g, h) >> 2];
      m = Ud(k, i);
      if (!((j | 0) == v[m >> 2] ? w[m + 8 | 0] : 0)) {
       h = h + 1 | 0;
       continue;
      }
      break;
     }
     h = g + (h << 2) | 0;
     dM(g, h, h + 4 | 0);
     p = xb(g, 0), q = i, v[p >> 2] = q;
     break b;
    }
    i = v[xb(g, 15) >> 2];
    dM(g, b + 288 | 0, b + 292 | 0);
    p = xb(g, 0), q = i, v[p >> 2] = q;
    g = Ud(k, i);
    v[g >> 2] = j;
    pz(e + 16 | 0, v[b + 24 >> 2], i);
    h = v[v[b >> 2] + 44 >> 2];
    k = v[e + 20 >> 2];
    v[e + 8 >> 2] = v[e + 16 >> 2];
    v[e + 12 >> 2] = k;
    hb[h | 0](e + 24 | 0, b, j, e + 8 | 0);
    v[g + 4 >> 2] = v[e + 28 >> 2];
    t[g + 8 | 0] = 1;
   }
   eb = e + 32 | 0;
   e = Ud(o, i);
   g = c - v[e >> 2] | 0;
   v[f + 12 >> 2] = 4096 - g;
   h = f + 12 | 0;
   p = f, q = v[Gb(h, f + 28 | 0) >> 2], v[p + 24 >> 2] = q;
   e = v[e + 4 >> 2];
   j = e - g | 0;
   v[f + 20 >> 2] = e >>> 0 >= j >>> 0 ? j : 0;
   e = v[Gb(f + 24 | 0, f + 20 | 0) >> 2];
   pz(h, v[b + 24 >> 2], i);
   h = v[f + 12 >> 2];
   pz(f + 4 | 0, v[b + 24 >> 2], i);
   wk(g + h | 0, e + (g + v[f + 4 >> 2] | 0) | 0, d);
   i = v[f + 28 >> 2] - e | 0;
   v[f + 28 >> 2] = i;
   n = e + n | 0;
   if (e >>> 0 < y[f + 24 >> 2]) {
    break a;
   }
   c = c + e | 0;
   d = d + e | 0;
   continue;
  }
  break;
 }
 ac(a, l, n);
 eb = f + 32 | 0;
}

function pma(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, w = 0, x = 0;
 e = eb - 16 | 0;
 eb = e;
 g = v[a + 12 >> 2];
 i = v[a + 8 >> 2];
 a: {
  b: {
   if ((g | 0) <= 1 & i >>> 0 <= 805306368 | (g | 0) <= 0) {
    f = 131112;
    if ((g | 0) >= -2 & i >>> 0 >= 3489660928 | (g | 0) > -2) {
     break a;
    }
    f = 262184;
    if ((g | 0) == -2 & i >>> 0 < 2147483648 | g >>> 0 < 4294967294) {
     break a;
    }
    break b;
   }
   f = 262184;
   if ((g | 0) == 1 & i >>> 0 > 2147483648 | g >>> 0 > 1) {
    break a;
   }
  }
  f = 196648;
 }
 k = v[a + 16 >> 2];
 l = v[a + 24 >> 2];
 m = v[a + 20 >> 2];
 h = v[a + 4 >> 2];
 v[e + 8 >> 2] = v[a >> 2];
 v[e + 12 >> 2] = h;
 n = b + f | 0;
 while (1) {
  if (d) {
   b = v[e + 8 >> 2];
   h = ((((v[e + 12 >> 2] & 2147483647) << 1 | b >>> 31) & 2147483646) << 1) + k | 0;
   b = (b >>> 16 & 65520) + n | 0;
   o = u[b + 14 >> 1];
   p = u[b + 12 >> 1];
   q = u[b + 10 >> 1];
   r = u[b + 8 >> 1];
   s = u[b + 6 >> 1];
   t = u[b + 4 >> 1];
   w = u[b + 2 >> 1];
   x = u[b >> 1];
   b = 0;
   while (1) {
    if ((b | 0) != 2) {
     j = b << 1;
     f = j + h | 0;
     v[(b << 2) + e >> 2] = (((((((B(u[(j | -8) + h >> 1], w) + B(u[(j | -12) + h >> 1], x) | 0) + B(u[(j | -4) + h >> 1], t) | 0) + B(u[f >> 1], s) | 0) + B(u[f + 4 >> 1], r) | 0) + B(u[f + 8 >> 1], q) | 0) + B(u[f + 12 >> 1], p) | 0) + B(u[f + 16 >> 1], o) | 0) / 32768;
     b = b + 1 | 0;
     continue;
    }
    break;
   }
   v[c >> 2] = v[c >> 2] + B(v[e >> 2], m);
   v[c + 4 >> 2] = v[c + 4 >> 2] + B(v[e + 4 >> 2], l);
   Ob(e + 8 | 0, i, g);
   c = c + 8 | 0;
   d = d - 1 | 0;
   continue;
  }
  break;
 }
 b = v[e + 12 >> 2];
 v[a >> 2] = v[e + 8 >> 2];
 v[a + 4 >> 2] = b;
 eb = e + 16 | 0;
}

function vka(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0;
 if (v[a + 4 >> 2] != v[zb(a) >> 2]) {
  d = eb - 16 | 0;
  eb = d;
  c = d + 4 | 0;
  v[c >> 2] = a;
  a = v[a + 4 >> 2];
  v[c + 4 >> 2] = a;
  v[c + 8 >> 2] = a + 32;
  HS(v[c + 4 >> 2], b);
  v[c + 4 >> 2] = v[c + 4 >> 2] + 32;
  hc(c);
  eb = d + 16 | 0;
  return;
 }
 j = eb - 32 | 0;
 eb = j;
 c = zb(a);
 c = jv(j + 12 | 0, Wq(a, Lg(v[a >> 2], v[a + 4 >> 2]) + 1 | 0), Lg(v[a >> 2], v[a + 4 >> 2]), c);
 HS(v[c + 8 >> 2], b);
 v[c + 8 >> 2] = v[c + 8 >> 2] + 32;
 h = eb - 16 | 0;
 eb = h;
 b = ub(h + 12 | 0, v[a + 4 >> 2]);
 e = ub(h + 8 | 0, v[a >> 2]);
 f = v[ub(h + 4 | 0, v[c + 4 >> 2]) >> 2];
 i = eb - 16 | 0;
 eb = i;
 d = eb - 32 | 0;
 eb = d;
 ed(d + 24 | 0, v[b >> 2], v[e >> 2]);
 k = d + 16 | 0;
 b = v[d + 24 >> 2];
 l = v[d + 28 >> 2];
 g = eb - 16 | 0;
 eb = g;
 v[g + 8 >> 2] = f;
 v[g + 12 >> 2] = b;
 while (1) {
  if (Ed(b, l)) {
   b = dn(b);
   e = dn(v[g + 8 >> 2]);
   f = w[b + 23 | 0] | w[b + 24 | 0] << 8 | (w[b + 25 | 0] << 16 | w[b + 26 | 0] << 24);
   t[e + 23 | 0] = f;
   t[e + 24 | 0] = f >>> 8;
   t[e + 25 | 0] = f >>> 16;
   t[e + 26 | 0] = f >>> 24;
   f = v[b + 20 >> 2];
   v[e + 16 >> 2] = v[b + 16 >> 2];
   v[e + 20 >> 2] = f;
   f = v[b + 12 >> 2];
   v[e + 8 >> 2] = v[b + 8 >> 2];
   v[e + 12 >> 2] = f;
   f = v[b + 4 >> 2];
   v[e >> 2] = v[b >> 2];
   v[e + 4 >> 2] = f;
   b = To(g + 12 | 0);
   To(g + 8 | 0);
   b = v[b >> 2];
   continue;
  }
  break;
 }
 pc(k, b, g + 8 | 0);
 eb = g + 16 | 0;
 b = v[d + 16 >> 2];
 v[d + 12 >> 2] = v[d + 20 >> 2];
 pc(i + 8 | 0, b, d + 12 | 0);
 eb = d + 32 | 0;
 eb = i + 16 | 0;
 v[c + 4 >> 2] = v[i + 12 >> 2];
 Sb(a, c + 4 | 0);
 Sb(a + 4 | 0, c + 8 | 0);
 Sb(zb(a), mc(c));
 v[c >> 2] = v[c + 4 >> 2];
 eb = h + 16 | 0;
 KV(c);
 eb = j + 32 | 0;
}

function vma(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, w = 0, x = 0, y = 0, z = 0, A = 0;
 g = eb - 16 | 0;
 eb = g;
 i = v[a + 40 >> 2];
 j = v[a + 36 >> 2];
 f = v[a + 48 >> 2];
 e = v[a + 44 >> 2];
 q = v[a + 16 >> 2];
 b = v[a + 4 >> 2];
 v[g + 8 >> 2] = v[a >> 2];
 v[g + 12 >> 2] = b;
 r = v[a + 32 >> 2];
 s = v[a + 28 >> 2];
 t = v[a + 72 >> 2];
 n = v[a + 68 >> 2];
 w = n >> 31;
 o = v[a + 64 >> 2];
 x = o >> 31;
 p = v[a + 60 >> 2];
 y = p >> 31;
 z = v[a + 8 >> 2];
 A = v[a + 12 >> 2];
 while (1) {
  b = e;
  if (d) {
   e = Xb(e, -16777216, 16776704);
   k = Aua(o, x, e, e >> 31);
   l = gb;
   e = v[g + 8 >> 2];
   h = (v[g + 12 >> 2] << 1) + q | 0;
   e = e >>> 21 & 2040;
   h = (((B(u[h >> 1], u[e + 38050 >> 1]) + B(u[h - 2 >> 1], u[e + 38048 >> 1]) | 0) + B(u[h + 2 >> 1], u[e + 38052 >> 1]) | 0) + B(u[h + 4 >> 1], u[e + 38054 >> 1]) | 0) / 16384 << 8;
   e = h;
   e = Aua(e, e >> 31, p, y);
   k = e + k | 0;
   m = gb + l | 0;
   m = e >>> 0 > k >>> 0 ? m + 1 | 0 : m;
   f = Xb(f, -16777216, 16776704);
   e = Aua(n, w, f, f >> 31);
   l = e + k | 0;
   f = gb + m | 0;
   f = e >>> 0 > l >>> 0 ? f + 1 | 0 : f;
   e = l + 8388608 | 0;
   f = e >>> 0 < 8388608 ? f + 1 | 0 : f;
   e = Rc(e, f, 24);
   f = (e | 0) / 256 | 0;
   j = j + s | 0;
   v[c >> 2] = B(f, j >> 12) + v[c >> 2];
   i = i + r | 0;
   v[c + 4 >> 2] = v[c + 4 >> 2] + B(f, i >> 12);
   Ob(g + 8 | 0, z, A);
   e = e - (h & t) | 0;
   c = c + 8 | 0;
   d = d - 1 | 0;
   f = b;
   continue;
  }
  break;
 }
 c = v[g + 12 >> 2];
 v[a >> 2] = v[g + 8 >> 2];
 v[a + 4 >> 2] = c;
 v[a + 40 >> 2] = i;
 v[a + 20 >> 2] = j >> 12;
 v[a + 36 >> 2] = j;
 v[a + 48 >> 2] = f;
 v[a + 44 >> 2] = b;
 v[a + 24 >> 2] = i >> 12;
 eb = g + 16 | 0;
}

function eJ(a, b, c, d, e, f, g, h) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 f = f | 0;
 g = g | 0;
 h = h | 0;
 a = eb - 16 | 0;
 eb = a;
 v[a + 12 >> 2] = c;
 v[a + 8 >> 2] = f;
 v[a + 12 >> 2] = c;
 v[a + 8 >> 2] = f;
 b = v[a + 12 >> 2];
 a: {
  while (1) {
   if (b >>> 0 >= d >>> 0) {
    c = 0;
    break a;
   }
   c = 2;
   b = v[b >> 2];
   if (b >>> 0 > 1114111 | (b & -2048) == 55296) {
    break a;
   }
   b: {
    c: {
     if (b >>> 0 <= 127) {
      c = 1;
      f = v[a + 8 >> 2];
      if ((g - f | 0) <= 0) {
       break a;
      }
      v[a + 8 >> 2] = f + 1;
      t[f | 0] = b;
      break c;
     }
     if (b >>> 0 <= 2047) {
      c = v[a + 8 >> 2];
      if ((g - c | 0) < 2) {
       break b;
      }
      v[a + 8 >> 2] = c + 1;
      t[c | 0] = b >>> 6 | 192;
      c = v[a + 8 >> 2];
      v[a + 8 >> 2] = c + 1;
      t[c | 0] = b & 63 | 128;
      break c;
     }
     c = v[a + 8 >> 2];
     f = g - c | 0;
     if (b >>> 0 <= 65535) {
      if ((f | 0) < 3) {
       break b;
      }
      v[a + 8 >> 2] = c + 1;
      t[c | 0] = b >>> 12 | 224;
      c = v[a + 8 >> 2];
      v[a + 8 >> 2] = c + 1;
      t[c | 0] = b >>> 6 & 63 | 128;
      c = v[a + 8 >> 2];
      v[a + 8 >> 2] = c + 1;
      t[c | 0] = b & 63 | 128;
      break c;
     }
     if ((f | 0) < 4) {
      break b;
     }
     v[a + 8 >> 2] = c + 1;
     t[c | 0] = b >>> 18 | 240;
     c = v[a + 8 >> 2];
     v[a + 8 >> 2] = c + 1;
     t[c | 0] = b >>> 12 & 63 | 128;
     c = v[a + 8 >> 2];
     v[a + 8 >> 2] = c + 1;
     t[c | 0] = b >>> 6 & 63 | 128;
     c = v[a + 8 >> 2];
     v[a + 8 >> 2] = c + 1;
     t[c | 0] = b & 63 | 128;
    }
    b = v[a + 12 >> 2] + 4 | 0;
    v[a + 12 >> 2] = b;
    continue;
   }
   break;
  }
  c = 1;
 }
 v[e >> 2] = v[a + 12 >> 2];
 v[h >> 2] = v[a + 8 >> 2];
 eb = a + 16 | 0;
 return c | 0;
}

function Vla(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, w = 0, x = 0, y = 0, z = 0;
 h = eb - 16 | 0;
 eb = h;
 o = v[a + 24 >> 2];
 p = v[a + 20 >> 2];
 e = v[a + 48 >> 2];
 f = v[a + 44 >> 2];
 q = v[a + 16 >> 2];
 j = v[a + 4 >> 2];
 v[h + 8 >> 2] = v[a >> 2];
 v[h + 12 >> 2] = j;
 r = b + 24 | 0;
 s = v[a + 72 >> 2];
 k = v[a + 68 >> 2];
 w = k >> 31;
 l = v[a + 64 >> 2];
 x = l >> 31;
 m = v[a + 60 >> 2];
 y = m >> 31;
 j = v[a + 8 >> 2];
 z = v[a + 12 >> 2];
 while (1) {
  b = f;
  if (d) {
   f = Xb(f, -16777216, 16776704);
   g = Aua(l, x, f, f >> 31);
   f = gb;
   e = Xb(e, -16777216, 16776704);
   e = Aua(k, w, e, e >> 31);
   g = e + g | 0;
   f = gb + f | 0;
   f = e >>> 0 > g >>> 0 ? f + 1 | 0 : f;
   e = v[h + 8 >> 2];
   i = g;
   g = v[h + 12 >> 2] + q | 0;
   e = (((e >>> 16 | 0) + 4 & 131064) << 1) + r | 0;
   n = ((((B(t[g + 2 | 0], u[e + 10 >> 1]) + B(t[g + 1 | 0], u[e + 8 >> 1]) | 0) + B(t[g + 3 | 0], u[e + 12 >> 1]) | 0) + B(t[g + 4 | 0], u[e + 14 >> 1]) << 8 >> 1) + (((B(t[g - 2 | 0], u[e + 2 >> 1]) + B(t[g - 3 | 0], u[e >> 1]) | 0) + B(t[g - 1 | 0], u[e + 4 >> 1]) | 0) + B(t[g | 0], u[e + 6 >> 1]) << 8 >> 1) | 0) / 16384 << 8;
   e = n;
   g = Aua(e, e >> 31, m, y);
   i = i + g | 0;
   e = gb + f | 0;
   e = g >>> 0 > i >>> 0 ? e + 1 | 0 : e;
   f = i + 8388608 | 0;
   e = f >>> 0 < 8388608 ? e + 1 | 0 : e;
   f = Rc(f, e, 24);
   e = (f | 0) / 256 | 0;
   v[c >> 2] = B(e, p) + v[c >> 2];
   v[c + 4 >> 2] = v[c + 4 >> 2] + B(e, o);
   Ob(h + 8 | 0, j, z);
   f = f - (s & n) | 0;
   c = c + 8 | 0;
   d = d - 1 | 0;
   e = b;
   continue;
  }
  break;
 }
 c = v[h + 12 >> 2];
 v[a >> 2] = v[h + 8 >> 2];
 v[a + 4 >> 2] = c;
 v[a + 48 >> 2] = e;
 v[a + 44 >> 2] = b;
 eb = h + 16 | 0;
}

function NL(a) {
 var b = 0, c = 0, d = 0, e = 0, f = 0, g = 0, h = 0;
 b = v[a + 32 >> 2];
 a: {
  b: {
   c: {
    d = v[a + 1380 >> 2];
    if ((d | 0) == -1) {
     c = 1;
     break c;
    }
    f = v[a + 1116 >> 2];
    e = (d | 0) > (f | 0) ? d : f;
    g = a + 1120 | 0;
    c = d;
    while (1) {
     d: {
      if ((c | 0) != (e | 0)) {
       h = w[c + g | 0];
       b = h + b | 0;
       if ((h | 0) == 255) {
        break d;
       }
       e = c;
      }
      if (y[a + 40 >> 2] < b >>> 0) {
       bc(a, 1);
       break b;
      }
      c = (e | 0) == -1 | (e | 0) == (f | 0);
      break c;
     }
     c = c + 1 | 0;
     continue;
    }
   }
   d = (d | 0) != -1;
   while (1) {
    e = 1;
    if (!(c & 1)) {
     break a;
    }
    e = v[a + 40 >> 2];
    if (e >>> 0 <= b + 26 >>> 0) {
     bc(a, 1);
     break b;
    }
    if ((w[b | 0] | w[b + 1 | 0] << 8 | (w[b + 2 | 0] << 16 | w[b + 3 | 0] << 24)) != (w[125436] | w[125437] << 8 | (w[125438] << 16 | w[125439] << 24))) {
     bc(a, 21);
     break b;
    }
    if (w[b + 4 | 0]) {
     bc(a, 21);
     break b;
    }
    e: {
     if (!d) {
      if (!v[a + 992 >> 2] | !(t[b + 5 | 0] & 1)) {
       break e;
      }
      bc(a, 21);
      break b;
     }
     if (t[b + 5 | 0] & 1) {
      break e;
     }
     bc(a, 21);
     break b;
    }
    c = 0;
    f = b + 27 | 0;
    d = w[b + 26 | 0];
    b = f + d | 0;
    if (e >>> 0 < b >>> 0) {
     bc(a, 1);
     break b;
    }
    while (1) {
     f: {
      if ((c | 0) == (d | 0)) {
       c = d;
       break f;
      }
      g = w[c + f | 0];
      b = g + b | 0;
      if ((g | 0) != 255) {
       break f;
      }
      c = c + 1 | 0;
      continue;
     }
     break;
    }
    c = (c | 0) == (d | 0);
    d = 1;
    if (b >>> 0 <= e >>> 0) {
     continue;
    }
    break;
   }
   bc(a, 1);
  }
  e = 0;
 }
 return e;
}

function wma(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, w = 0, x = 0, y = 0, z = 0, A = 0;
 h = eb - 16 | 0;
 eb = h;
 i = v[a + 40 >> 2];
 j = v[a + 36 >> 2];
 e = v[a + 48 >> 2];
 f = v[a + 44 >> 2];
 p = v[a + 16 >> 2];
 b = v[a + 4 >> 2];
 v[h + 8 >> 2] = v[a >> 2];
 v[h + 12 >> 2] = b;
 q = v[a + 32 >> 2];
 r = v[a + 28 >> 2];
 s = v[a + 72 >> 2];
 l = v[a + 68 >> 2];
 w = l >> 31;
 m = v[a + 64 >> 2];
 x = m >> 31;
 n = v[a + 60 >> 2];
 y = n >> 31;
 z = v[a + 8 >> 2];
 A = v[a + 12 >> 2];
 while (1) {
  b = f;
  if (d) {
   f = Xb(f, -16777216, 16776704);
   g = Aua(m, x, f, f >> 31);
   f = gb;
   e = Xb(e, -16777216, 16776704);
   e = Aua(l, w, e, e >> 31);
   g = e + g | 0;
   f = gb + f | 0;
   f = e >>> 0 > g >>> 0 ? f + 1 | 0 : f;
   e = v[h + 8 >> 2];
   k = g;
   g = v[h + 12 >> 2] + p | 0;
   e = e >>> 21 & 2040;
   o = (((B(t[g | 0], u[e + 38050 >> 1]) + B(t[g - 1 | 0], u[e + 38048 >> 1]) | 0) + B(t[g + 1 | 0], u[e + 38052 >> 1]) | 0) + B(t[g + 2 | 0], u[e + 38054 >> 1]) << 8) / 16384 << 8;
   e = o;
   g = Aua(e, e >> 31, n, y);
   k = k + g | 0;
   e = gb + f | 0;
   e = g >>> 0 > k >>> 0 ? e + 1 | 0 : e;
   f = k + 8388608 | 0;
   e = f >>> 0 < 8388608 ? e + 1 | 0 : e;
   f = Rc(f, e, 24);
   e = (f | 0) / 256 | 0;
   j = j + r | 0;
   v[c >> 2] = B(e, j >> 12) + v[c >> 2];
   i = i + q | 0;
   v[c + 4 >> 2] = v[c + 4 >> 2] + B(i >> 12, e);
   Ob(h + 8 | 0, z, A);
   f = f - (s & o) | 0;
   c = c + 8 | 0;
   d = d - 1 | 0;
   e = b;
   continue;
  }
  break;
 }
 c = v[h + 12 >> 2];
 v[a >> 2] = v[h + 8 >> 2];
 v[a + 4 >> 2] = c;
 v[a + 40 >> 2] = i;
 v[a + 20 >> 2] = j >> 12;
 v[a + 36 >> 2] = j;
 v[a + 48 >> 2] = e;
 v[a + 44 >> 2] = b;
 v[a + 24 >> 2] = i >> 12;
 eb = h + 16 | 0;
}

function D1(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
 h = eb - 32 | 0;
 eb = h;
 e = Kn(h + 12 | 0, a);
 i = eb - 48 | 0;
 eb = i;
 j = -1;
 c = i + 12 | 0;
 a: {
  if (!ZF(e, c)) {
   break a;
  }
  j = 0;
  if (!bG(c)) {
   break a;
  }
  k = Df(13165);
  if (k) {
   o = v[e + 12 >> 2];
   b: {
    if (!Ul(e, w[c + 16 | 0] | w[c + 17 | 0] << 8 | (w[c + 18 | 0] << 16 | w[c + 19 | 0] << 24))) {
     break b;
    }
    while (1) {
     if ((w[c + 12 | 0] | w[c + 13 | 0] << 8 | (w[c + 14 | 0] << 16 | w[c + 15 | 0] << 24)) >>> 0 <= l >>> 0) {
      break b;
     }
     if (!ih(e, 5)) {
      break b;
     }
     c: {
      if ((w[c + 4 | 0] | w[c + 5 | 0] << 8) >>> 0 >= 64) {
       a = Kr(e);
       d = a & 63;
       g = a << 24 >> 24;
       d: {
        if (!(a & 64)) {
         break d;
        }
        a = 6;
        while (1) {
         f = Kr(e);
         d = (f & 127) << a | d;
         if (f << 24 >> 24 >= 0) {
          break d;
         }
         f = a >>> 0 < 25;
         a = a + 7 | 0;
         if (f) {
          continue;
         }
         break;
        }
       }
       if ((((g | 0) < 0 ? (d | 0) < 0 ? -2147483648 : 0 - d | 0 : d) | 0) <= 0) {
        break c;
       }
      }
      d = 0;
      a = 1;
      while (1) {
       f = Kr(e);
       if (f) {
        m = d >>> 0 >= k >>> 0;
        g = m & a;
        if (!((a ^ 1) & 1 | m)) {
         g = (Lq(f << 24 >> 24) & 255) == w[d + 13165 | 0];
        }
        a = g;
        d = d + 1 | 0;
        continue;
       }
       break;
      }
      hd(e, 4);
      n = (d | 0) == (k | 0) & a | n;
     }
     l = l + 1 | 0;
     continue;
    }
   }
   Ul(e, o);
  }
  if (!(n & 1)) {
   break a;
  }
  j = ve(e, b, aG(c), 0);
 }
 eb = i + 48 | 0;
 eb = h + 32 | 0;
 return j | 0;
}

function Yqa(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0;
 e = Pv(c, d);
 d = b & 63;
 if (e >>> 0 > d >>> 0) {
  c = RY(c, d);
  d = 0;
  g = eb - 16 | 0;
  eb = g;
  t[a + 12 | 0] = 0;
  Mc(a);
  e = eb - 32 | 0;
  eb = e;
  a: {
   b: {
    if (Ug(a) >>> 0 <= 14) {
     if (th(1073741823) >>> 0 <= 14) {
      break b;
     }
     f = zb(a);
     f = Yf(e + 12 | 0, 15, nc(v[a >> 2], v[a + 4 >> 2]), f);
     Zr(a, f);
     Xf(f);
    }
    eb = e + 32 | 0;
    break a;
   }
   dd();
   p();
  }
  j = c + 1 | 0;
  h = 0 - w[c + 1 | 0] | 0;
  while (1) {
   c: {
    if ((d | 0) == 15) {
     break c;
    }
    e = (d << 1) + j | 0;
    f = w[e | 0];
    if (!f) {
     break c;
    }
    t[g + 11 | 0] = 64;
    h = f + (h << 16 >> 16) | 0;
    f = Wl(g + 12 | 0, h & 65535, w[Pb(e + 1 | 0, g + 11 | 0) | 0]);
    d: {
     if (y[a + 4 >> 2] < y[zb(a) >> 2]) {
      NY(a, f);
      break d;
     }
     i = eb - 32 | 0;
     eb = i;
     e = zb(a);
     e = Yf(i + 12 | 0, Kf(a, nc(v[a >> 2], v[a + 4 >> 2]) + 1 | 0), nc(v[a >> 2], v[a + 4 >> 2]), e);
     bp(v[e + 8 >> 2], x[f >> 1] | x[f + 2 >> 1] << 16);
     v[e + 8 >> 2] = v[e + 8 >> 2] + 4;
     Zr(a, e);
     Xf(e);
     eb = i + 32 | 0;
    }
    d = d + 1 | 0;
    continue;
   }
   break;
  }
  d = w[c + 32 | 0];
  t[a + 14 | 0] = d >>> 4;
  t[a + 13 | 0] = d & 15;
  c = w[c + 31 | 0];
  d = c & 15;
  t[a + 15 | 0] = d;
  t[a + 16 | 0] = d;
  if (c & 16) {
   t[a + 12 | 0] = w[a + 12 | 0] | 4;
  }
  if (c & 32) {
   t[a + 12 | 0] = w[a + 12 | 0] | 2;
  }
  eb = g + 16 | 0;
 }
 e: {
  f: {
   if (b << 24 >> 24 >= 0) {
    b = a + 12 | 0;
    break f;
   }
   b = a + 12 | 0;
   if (lc(v[a >> 2], v[a + 4 >> 2])) {
    break f;
   }
   a = w[a + 12 | 0] | 1;
   break e;
  }
  a = w[b | 0] & -2;
 }
 t[b | 0] = a;
}

function cA(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = C(0);
 c = eb - 48 | 0;
 eb = c;
 a: {
  b = v[a + 20 >> 2];
  b: {
   if (!b) {
    break b;
   }
   d = v[b + 4 >> 2];
   b = v[b + 8 >> 2];
   if (Sc(d, b) >>> 0 < 4) {
    break b;
   }
   oe(c + 16 | 0, d, b);
   b = Ld(c + 8 | 0);
   d = v[b + 4 >> 2];
   v[c >> 2] = v[b >> 2];
   v[c + 4 >> 2] = d;
   d = X_(c + 28 | 0, v[c + 16 >> 2], v[c + 20 >> 2], c);
   v[31601] = 0;
   b = Q(151, d | 0) | 0;
   f = v[31601];
   v[31601] = 0;
   c: {
    if ((f | 0) != 1) {
     if (b) {
      break c;
     }
     b = v[v[a >> 2] + 40 >> 2];
     v[31601] = 0;
     f = Q(b | 0, a | 0) | 0;
     b = v[31601];
     v[31601] = 0;
     if ((b | 0) == 1) {
      break a;
     }
     b = v[a + 20 >> 2];
     if (Sc(v[b + 4 >> 2], v[b + 8 >> 2]) - 4 >>> 0 < f << 2 >>> 0) {
      break c;
     }
     e = v[v[a >> 2] + 176 >> 2];
     b = 0;
     v[31601] = 0;
     N(e | 0, a | 0, -1);
     e = v[31601];
     v[31601] = 0;
     if ((e | 0) == 1) {
      break a;
     }
     while (1) {
      if ((b | 0) == (f | 0)) {
       b = v[v[a >> 2] + 180 >> 2];
       v[31601] = 0;
       V(b | 0, a | 0);
       a = v[31601];
       v[31601] = 0;
       if ((a | 0) != 1) {
        break c;
       }
       break a;
      }
      v[31601] = 0;
      g = C(wa(473, d | 0));
      e = v[31601];
      v[31601] = 0;
      d: {
       if ((e | 0) == 1) {
        break d;
       }
       e = v[v[a >> 2] + 44 >> 2];
       v[31601] = 0;
       va(e | 0, a | 0, b | 0, C(Tm(g) ? g : C(0)));
       e = v[31601];
       v[31601] = 0;
       if ((e | 0) == 1) {
        break d;
       }
       b = b + 1 | 0;
       continue;
      }
      break;
     }
     break a;
    }
    break a;
   }
   tb(d);
  }
  eb = c + 48 | 0;
  return;
 }
 a = M() | 0;
 tb(d);
 P(a | 0);
 p();
}

function QM(a, b, c) {
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0;
 e = eb - 16 | 0;
 eb = e;
 v[e + 12 >> 2] = c;
 a: {
  b: {
   if (!b) {
    a = a + 120 | 0;
    to(a);
    c = v[e + 12 >> 2];
    b = eb - 16 | 0;
    eb = b;
    v[a >> 2] = 0;
    v[a + 4 >> 2] = 0;
    sc(a + 8 | 0);
    Qd(b + 8 | 0, v[ub(b + 4 | 0, a) >> 2]);
    c: {
     if (c) {
      v[31601] = 0;
      N(1140, a | 0, c | 0);
      d = v[31601];
      v[31601] = 0;
      if ((d | 0) == 1) {
       break a;
      }
      MM(a, c);
     }
     c = b + 8 | 0;
     Pd(c);
     Wi(c);
     eb = b + 16 | 0;
     break c;
    }
    t[a + 20 | 0] = 0;
    break b;
   }
   d = eb - 16 | 0;
   eb = d;
   v[d + 12 >> 2] = c;
   d: {
    if ((b | 0) == 1) {
     b = a + 120 | 0;
     to(b);
     h = xz(b, a, v[d + 12 >> 2]), i = 1, t[h + 20 | 0] = i;
     break d;
    }
    f = eb - 16 | 0;
    eb = f;
    v[f + 12 >> 2] = c;
    e: {
     if ((b | 0) == 2) {
      a = a + 120 | 0;
      to(a);
      c = v[f + 12 >> 2];
      b = eb - 16 | 0;
      eb = b;
      v[a >> 2] = 0;
      v[a + 4 >> 2] = 0;
      sc(a + 8 | 0);
      Qd(b + 8 | 0, v[ub(b + 4 | 0, a) >> 2]);
      f: {
       if (c) {
        v[31601] = 0;
        N(1139, a | 0, c | 0);
        g = v[31601];
        v[31601] = 0;
        if ((g | 0) == 1) {
         break a;
        }
        MM(a, c);
       }
       c = b + 8 | 0;
       Pd(c);
       Wi(c);
       eb = b + 16 | 0;
       break f;
      }
      Ld(a + 12 | 0);
      t[a + 20 | 0] = 2;
      break e;
     }
     b = eb - 16 | 0;
     eb = b;
     v[b + 12 >> 2] = c;
     c = a + 120 | 0;
     to(c);
     h = xz(c, a, v[b + 12 >> 2]), i = 3, t[h + 20 | 0] = i;
     eb = b + 16 | 0;
    }
    eb = f + 16 | 0;
   }
   eb = d + 16 | 0;
  }
  eb = e + 16 | 0;
  return;
 }
 a = M() | 0;
 Wi(b + 8 | 0);
 P(a | 0);
 p();
}

function Vaa(a, b) {
 a = a | 0;
 b = +b;
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0;
 d = eb - 16 | 0;
 eb = d;
 v[31601] = 0;
 f = O(21, d + 8 | 0, a | 0) | 0;
 c = v[31601];
 v[31601] = 0;
 a: {
  b: {
   c: {
    if ((c | 0) != 1) {
     d: {
      if (!Hd(w[f | 0])) {
       break d;
      }
      c = d + 4 | 0;
      bd(c, v[(v[v[a >> 2] - 12 >> 2] + a | 0) + 28 >> 2]);
      v[31601] = 0;
      g = Q(1131, v[d + 4 >> 2]) | 0;
      e = v[31601];
      v[31601] = 0;
      e: {
       f: {
        if ((e | 0) != 1) {
         Zb(c);
         c = qp(d, a);
         e = v[v[a >> 2] - 12 >> 2];
         v[31601] = 0;
         e = a + e | 0;
         h = Q(22, e | 0) | 0;
         i = v[31601];
         v[31601] = 0;
         if ((i | 0) == 1) {
          break f;
         }
         c = v[c >> 2];
         v[31601] = 0;
         c = Qa(1132, g | 0, c | 0, e | 0, h | 0, +b) | 0;
         g = v[31601];
         v[31601] = 0;
         if ((g | 0) == 1) {
          break f;
         }
         if (c) {
          break d;
         }
         c = v[v[a >> 2] - 12 >> 2];
         v[31601] = 0;
         N(24, a + c | 0, 5);
         c = v[31601];
         v[31601] = 0;
         if ((c | 0) != 1) {
          break d;
         }
         c = S(0) | 0;
         break e;
        }
        c = S(0) | 0;
        Zb(d + 4 | 0);
        break e;
       }
       c = S(0) | 0;
      }
      dm(f);
      break c;
     }
     dm(f);
     break b;
    }
    c = S(0) | 0;
   }
   X(c | 0) | 0;
   c = v[v[a >> 2] - 12 >> 2];
   v[31601] = 0;
   V(25, a + c | 0);
   c = v[31601];
   v[31601] = 0;
   if ((c | 0) == 1) {
    break a;
   }
   Y();
  }
  eb = d + 16 | 0;
  return a | 0;
 }
 a = M() | 0;
 v[31601] = 0;
 W(26);
 d = v[31601];
 v[31601] = 0;
 if ((d | 0) != 1) {
  P(a | 0);
  p();
 }
 S(0) | 0;
 Rb();
 p();
}

function Cy(a, b, c, d, e, f, g, h, i, j, k, l) {
 var m = 0, n = 0;
 a: {
  b: {
   if ((a | 0) == (f | 0)) {
    if (!w[b | 0]) {
     break a;
    }
    f = 0;
    t[b | 0] = 0;
    a = v[e >> 2];
    v[e >> 2] = a + 1;
    t[a | 0] = 46;
    if (!Cb(v[h + 4 >> 2], w[h + 11 | 0])) {
     break b;
    }
    a = v[j >> 2];
    if ((a - i | 0) > 159) {
     break b;
    }
    b = v[k >> 2];
    v[j >> 2] = a + 4;
    v[a >> 2] = b;
    return 0;
   }
   c: {
    if ((a | 0) != (g | 0)) {
     break c;
    }
    if (!Cb(v[h + 4 >> 2], w[h + 11 | 0])) {
     break c;
    }
    if (!w[b | 0]) {
     break a;
    }
    f = 0;
    a = v[j >> 2];
    if ((a - i | 0) > 159) {
     break b;
    }
    b = v[k >> 2];
    v[j >> 2] = a + 4;
    v[a >> 2] = b;
    v[k >> 2] = 0;
    return 0;
   }
   f = -1;
   l = Ey(l, l + 128 | 0, a) - l | 0;
   g = l >> 2;
   if ((g | 0) > 31) {
    break b;
   }
   a = t[g + 95136 | 0];
   d: {
    e: {
     f = l & -5;
     if ((f | 0) != 88) {
      if ((f | 0) != 96) {
       break e;
      }
      b = v[e >> 2];
      if ((b | 0) != (d | 0)) {
       f = -1;
       if ((nl(t[b - 1 | 0]) | 0) != (nl(t[c | 0]) | 0)) {
        break b;
       }
      }
      v[e >> 2] = b + 1;
      t[b | 0] = a;
      return 0;
     }
     t[c | 0] = 80;
     break d;
    }
    d = nl(a);
    if ((d | 0) != t[c | 0]) {
     break d;
    }
    m = c, n = ut(d), t[m | 0] = n;
    if (!w[b | 0]) {
     break d;
    }
    t[b | 0] = 0;
    if (!Cb(v[h + 4 >> 2], w[h + 11 | 0])) {
     break d;
    }
    b = v[j >> 2];
    if ((b - i | 0) > 159) {
     break d;
    }
    c = v[k >> 2];
    v[j >> 2] = b + 4;
    v[b >> 2] = c;
   }
   b = v[e >> 2];
   v[e >> 2] = b + 1;
   t[b | 0] = a;
   f = 0;
   if ((g | 0) > 21) {
    break b;
   }
   v[k >> 2] = v[k >> 2] + 1;
  }
  return f;
 }
 return -1;
}

function vsa(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0;
 md(b, 32);
 ep(b);
 f = b, g = ye((w[a + 50 | 0] | w[a + 51 | 0] << 8) << 16 >> 16) >>> 2 | 0, u[f + 32 >> 1] = g;
 if ((ye((w[a + 32 | 0] | w[a + 33 | 0] << 8) << 16 >> 16) | 0) > 0) {
  u[b + 34 >> 1] = x[b + 34 >> 1] | 32;
  c = ye((w[a + 32 | 0] | w[a + 33 | 0] << 8) << 16 >> 16);
  e = c >>> 24 | 0;
  d = (c << 8 & -256) + 2047 | 0;
  c = e & 255;
  f = b, g = Ac(Cua(d, d >>> 0 < 2047 ? c + 1 | 0 : c, 4095, 0), gb), u[f + 28 >> 1] = g;
 }
 c = _b(w[a + 38 | 0] | w[a + 39 | 0] << 8 | (w[a + 40 | 0] << 16 | w[a + 41 | 0] << 24));
 v[b >> 2] = c;
 d = _b(w[a + 42 | 0] | w[a + 43 | 0] << 8 | (w[a + 44 | 0] << 16 | w[a + 45 | 0] << 24));
 v[b + 4 >> 2] = d;
 e = _b(w[a + 42 | 0] | w[a + 43 | 0] << 8 | (w[a + 44 | 0] << 16 | w[a + 45 | 0] << 24)) + _b(w[a + 46 | 0] | w[a + 47 | 0] << 8 | (w[a + 48 | 0] << 16 | w[a + 49 | 0] << 24)) | 0;
 v[b + 8 >> 2] = e;
 if ((Ab(w[a + 34 | 0] | w[a + 35 | 0] << 8) | 0) == 16) {
  v[b + 8 >> 2] = e >>> 1;
  v[b + 4 >> 2] = d >>> 1;
  v[b >> 2] = c >>> 1;
 }
 a: {
  b: {
   c: {
    if (_b(w[a + 42 | 0] | w[a + 43 | 0] << 8 | (w[a + 44 | 0] << 16 | w[a + 45 | 0] << 24))) {
     c = x[b + 34 >> 1];
     break c;
    }
    c = x[b + 34 >> 1];
    if (_b(w[a + 46 | 0] | w[a + 47 | 0] << 8 | (w[a + 48 | 0] << 16 | w[a + 49 | 0] << 24)) >>> 0 < 3) {
     break b;
    }
   }
   c = c | 2;
   break a;
  }
  c = c & 65533;
 }
 u[b + 34 >> 1] = c;
 f = b, g = c & 65531 | Ab(w[a + 30 | 0] | w[a + 31 | 0] << 8) << 1 & 4, u[f + 34 >> 1] = g;
 f = b, g = Ab(w[a + 36 | 0] | w[a + 37 | 0] << 8) << 1, v[f + 24 >> 2] = g;
 c = ye((w[a + 52 | 0] | w[a + 53 | 0] << 8) << 16 >> 16);
 if (c) {
  Yl(b, +(c | 0) / 96);
  c = ye((w[a + 52 | 0] | w[a + 53 | 0] << 8) << 16 >> 16);
 }
 t[b + 37 | 0] = c << 4;
}

function JL(a, b, c, d, e) {
 var f = C(0), g = 0, h = C(0), i = 0, j = C(0), k = C(0);
 if (!(a & 3)) {
  c = (c << 2) + b | 0;
  d = c + (d << 2) | 0;
  a = a >> 2;
  while (1) {
   if ((a | 0) > 0) {
    b = d - 4 | 0;
    h = z[b >> 2];
    j = z[c >> 2];
    k = z[d >> 2];
    z[c >> 2] = j + k;
    g = c - 4 | 0;
    f = z[g >> 2];
    z[g >> 2] = f + z[b >> 2];
    j = C(j - k);
    f = C(f - h);
    z[d >> 2] = C(j * z[e >> 2]) - C(z[e + 4 >> 2] * f);
    z[b >> 2] = C(f * z[e >> 2]) + C(j * z[e + 4 >> 2]);
    b = d - 12 | 0;
    j = z[b >> 2];
    g = c - 8 | 0;
    f = z[g >> 2];
    i = g;
    g = d - 8 | 0;
    k = z[g >> 2];
    z[i >> 2] = f + k;
    i = c - 12 | 0;
    h = z[i >> 2];
    z[i >> 2] = h + z[b >> 2];
    f = C(f - k);
    h = C(h - j);
    z[g >> 2] = C(f * z[e + 32 >> 2]) - C(z[e + 36 >> 2] * h);
    z[b >> 2] = C(h * z[e + 32 >> 2]) + C(f * z[e + 36 >> 2]);
    b = d - 20 | 0;
    j = z[b >> 2];
    g = c - 16 | 0;
    f = z[g >> 2];
    i = g;
    g = d - 16 | 0;
    k = z[g >> 2];
    z[i >> 2] = f + k;
    i = c - 20 | 0;
    h = z[i >> 2];
    z[i >> 2] = h + z[b >> 2];
    f = C(f - k);
    h = C(h - j);
    z[g >> 2] = C(f * z[e + 64 >> 2]) - C(z[e + 68 >> 2] * h);
    z[b >> 2] = C(h * z[e + 64 >> 2]) + C(f * z[e + 68 >> 2]);
    b = d - 28 | 0;
    j = z[b >> 2];
    g = c - 24 | 0;
    f = z[g >> 2];
    i = g;
    g = d - 24 | 0;
    k = z[g >> 2];
    z[i >> 2] = f + k;
    i = c - 28 | 0;
    h = z[i >> 2];
    z[i >> 2] = h + z[b >> 2];
    f = C(f - k);
    h = C(h - j);
    z[g >> 2] = C(f * z[e + 96 >> 2]) - C(z[e + 100 >> 2] * h);
    z[b >> 2] = C(h * z[e + 96 >> 2]) + C(f * z[e + 100 >> 2]);
    a = a - 1 | 0;
    d = d - 32 | 0;
    c = c - 32 | 0;
    e = e + 128 | 0;
    continue;
   }
   break;
  }
  return;
 }
 Z(15822, 13258, 2423, 9211);
 p();
}

function $I(a, b, c, d, e) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 var f = 0, g = 0, h = 0, i = 0;
 b = 0;
 a = c;
 while (1) {
  a: {
   if (a >>> 0 >= d >>> 0 | b >>> 0 >= e >>> 0) {
    break a;
   }
   g = 1;
   f = t[a | 0];
   b: {
    if ((f | 0) >= 0) {
     break b;
    }
    if (f >>> 0 < 4294967234) {
     break a;
    }
    if (f >>> 0 <= 4294967263) {
     if ((d - a | 0) < 2) {
      break a;
     }
     g = 2;
     if ((w[a + 1 | 0] & 192) != 128) {
      break a;
     }
     break b;
    }
    g = f & 255;
    if (f >>> 0 <= 4294967279) {
     if ((d - a | 0) < 3) {
      break a;
     }
     h = w[a + 2 | 0];
     f = w[a + 1 | 0];
     c: {
      d: {
       if ((g | 0) != 237) {
        if ((g | 0) != 224) {
         break d;
        }
        if ((f & 224) == 160) {
         break c;
        }
        break a;
       }
       if ((f & 224) != 128) {
        break a;
       }
       break c;
      }
      if ((f & 192) != 128) {
       break a;
      }
     }
     g = 3;
     if ((h & 192) != 128) {
      break a;
     }
     break b;
    }
    if ((d - a | 0) < 4 | f >>> 0 > 4294967284 | e - b >>> 0 < 2) {
     break a;
    }
    h = w[a + 3 | 0];
    i = w[a + 2 | 0];
    f = w[a + 1 | 0];
    e: {
     f: {
      switch (g - 240 | 0) {
      case 0:
       if ((f + 112 & 255) >>> 0 >= 48) {
        break a;
       }
       break e;

      case 4:
       if ((f & 240) != 128) {
        break a;
       }
       break e;

      default:
       break f;
      }
     }
     if ((f & 192) != 128) {
      break a;
     }
    }
    if ((i & 192) != 128 | (h & 192) != 128 | (g << 18 & 1835008 | (f & 48) << 12) >>> 0 > 1114111) {
     break a;
    }
    b = b + 1 | 0;
    g = 4;
   }
   b = b + 1 | 0;
   a = a + g | 0;
   continue;
  }
  break;
 }
 return a - c | 0;
}

function OW(a) {
 a = a | 0;
 var b = 0, c = 0, d = 0, e = 0, f = 0, g = 0, h = 0;
 c = eb - 80 | 0;
 eb = c;
 v[c + 72 >> 2] = 0;
 v[c + 76 >> 2] = 0;
 b = c - -64 | 0;
 v[b >> 2] = 0;
 v[b + 4 >> 2] = 0;
 v[c + 56 >> 2] = 0;
 v[c + 60 >> 2] = 0;
 v[c + 48 >> 2] = 0;
 v[c + 52 >> 2] = 0;
 jC(a, nV(a), c + 48 | 0);
 b = oc(c + 40 | 0, 14192);
 qf(Oe(a, 0), v[b >> 2], v[b + 4 >> 2]);
 b = oc(c + 32 | 0, 14275);
 qf(Oe(a, 1), v[b >> 2], v[b + 4 >> 2]);
 b = oc(c + 24 | 0, 5496);
 qf(Oe(a, 3), v[b >> 2], v[b + 4 >> 2]);
 b = oc(c + 16 | 0, 15733);
 qf(Oe(a, 4), v[b >> 2], v[b + 4 >> 2]);
 b = oc(c + 8 | 0, 9265);
 qf(Oe(a, 8), v[b >> 2], v[b + 4 >> 2]);
 d = Oe(a + 288 | 0, 0);
 b = eb - 16 | 0;
 eb = b;
 e = d;
 d = oc(b + 8 | 0, 4932);
 qf(e, v[d >> 2], v[d + 4 >> 2]);
 eb = b + 16 | 0;
 d = a + 800 | 0;
 b = 0;
 a = eb + -64 | 0;
 eb = a;
 a: {
  b: {
   while (1) {
    if ((b | 0) == 128) {
     break a;
    }
    v[a + 60 >> 2] = b << 3;
    c: {
     d: {
      if (b >>> 0 <= 15) {
       e = a + 28 | 0;
       qw(e, 4084);
       v[31601] = 0;
       g = a + 16 | 0;
       N(289, g | 0, a + 60 | 0);
       f = v[31601];
       v[31601] = 0;
       if ((f | 0) == 1) {
        break c;
       }
       v[31601] = 0;
       f = a + 40 | 0;
       R(290, f | 0, e | 0, g | 0);
       h = v[31601];
       v[31601] = 0;
       if ((h | 0) != 1) {
        ee(a + 52 | 0, f);
        qf(Oe(d, b), v[a + 52 >> 2], v[a + 56 >> 2]);
        sb(f);
        sb(g);
        Db(e);
        break d;
       }
       b = M() | 0;
       sb(a + 16 | 0);
       break b;
      }
      e = oc(a + 8 | 0, 22256);
      qf(Oe(d, b), v[e >> 2], v[a + 12 >> 2]);
     }
     b = b + 1 | 0;
     continue;
    }
    break;
   }
   b = M() | 0;
  }
  Db(a + 28 | 0);
  P(b | 0);
  p();
 }
 eb = a - -64 | 0;
 eb = c + 80 | 0;
}

function ula(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
 g = eb - 16 | 0;
 eb = g;
 v[g + 12 >> 2] = 1;
 a: {
  if (Yo(a)) {
   c = v[a >> 2];
   m = Lg(c, v[a + 4 >> 2]);
   v[g + 8 >> 2] = m;
   j = v[Gb(g + 12 | 0, g + 8 | 0) >> 2];
   while (1) {
    if (j) {
     j = j - 1 | 0;
     if ((b | 0) != (c | 0)) {
      d = vb(v[b >> 2]);
      f = d;
      e = vb(v[b + 4 >> 2]);
      k = e;
      d = qE(d, e);
      h = eb - 16 | 0;
      eb = h;
      b: {
       if (Gn(c) >>> 0 >= d >>> 0) {
        l = v[c >> 2];
        i = _c(l, v[c + 4 >> 2]);
        if (i >>> 0 < d >>> 0) {
         e = eb - 16 | 0;
         eb = e;
         v[e + 12 >> 2] = f;
         JX(e + 12 | 0, i);
         eb = e + 16 | 0;
         i = f;
         f = v[e + 12 >> 2];
         XU(i, f, l);
         ev(c, f, k, d - _c(v[c >> 2], v[c + 4 >> 2]) | 0);
         break b;
        }
        WU(h + 8 | 0, f, k, l);
        Id(c, v[h + 12 >> 2]);
        break b;
       }
       VU(c);
       KC(c, ek(c, d));
       ev(c, f, k, d);
      }
      eb = h + 16 | 0;
      rs(c + 12 | 0, b + 12 | 0);
      u[c + 28 >> 1] = x[b + 28 >> 1];
     }
     c = c + 32 | 0;
     continue;
    }
    break;
   }
   if (!m) {
    _B(a, 1, b);
    break a;
   }
   LU(a, v[a >> 2] + 32 | 0);
   break a;
  }
  if (v[a >> 2]) {
   NU(a);
   c = v[a >> 2];
   Yo(a);
   Bb(c);
   n = zb(a), o = 0, v[n >> 2] = o;
   v[a >> 2] = 0;
   v[a + 4 >> 2] = 0;
  }
  d = Wq(a, 1);
  c = eb - 16 | 0;
  eb = c;
  if (th(134217727) >>> 0 < d >>> 0) {
   dd();
   p();
  }
  JV(c + 8 | 0, d);
  d = v[c + 8 >> 2];
  v[a + 4 >> 2] = d;
  v[a >> 2] = d;
  n = zb(a), o = d + (v[c + 12 >> 2] << 5) | 0, v[n >> 2] = o;
  eb = c + 16 | 0;
  _B(a, 1, b);
 }
 eb = g + 16 | 0;
}

function cJ(a, b, c, d, e) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 var f = 0, g = 0, h = 0, i = 0;
 a = c;
 while (1) {
  a: {
   if (e >>> 0 <= i >>> 0 | a >>> 0 >= d >>> 0) {
    break a;
   }
   f = 1;
   b = t[a | 0];
   b: {
    if ((b | 0) >= 0) {
     break b;
    }
    if (b >>> 0 < 4294967234) {
     break a;
    }
    if (b >>> 0 <= 4294967263) {
     if ((d - a | 0) < 2) {
      break a;
     }
     f = 2;
     if ((w[a + 1 | 0] & 192) != 128) {
      break a;
     }
     break b;
    }
    g = b & 255;
    if (b >>> 0 <= 4294967279) {
     if ((d - a | 0) < 3) {
      break a;
     }
     h = w[a + 2 | 0];
     b = w[a + 1 | 0];
     c: {
      d: {
       if ((g | 0) != 237) {
        if ((g | 0) != 224) {
         break d;
        }
        if ((b & 224) == 160) {
         break c;
        }
        break a;
       }
       if ((b & 224) != 128) {
        break a;
       }
       break c;
      }
      if ((b & 192) != 128) {
       break a;
      }
     }
     f = 3;
     if ((h & 192) != 128) {
      break a;
     }
     break b;
    }
    if ((d - a | 0) < 4 | b >>> 0 > 4294967284) {
     break a;
    }
    f = w[a + 3 | 0];
    h = w[a + 2 | 0];
    b = w[a + 1 | 0];
    e: {
     f: {
      switch (g - 240 | 0) {
      case 0:
       if ((b + 112 & 255) >>> 0 >= 48) {
        break a;
       }
       break e;

      case 4:
       if ((b & 240) != 128) {
        break a;
       }
       break e;

      default:
       break f;
      }
     }
     if ((b & 192) != 128) {
      break a;
     }
    }
    if ((h & 192) != 128 | (f & 192) != 128) {
     break a;
    }
    f = 4;
    if ((g << 18 & 1835008 | (b & 48) << 12) >>> 0 > 1114111) {
     break a;
    }
   }
   i = i + 1 | 0;
   a = a + f | 0;
   continue;
  }
  break;
 }
 return a - c | 0;
}

function Haa(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
 c = eb + -64 | 0;
 eb = c;
 f = v[a >> 2];
 a = v[f >> 2];
 g = v[a + 4 >> 2];
 v[c + 40 >> 2] = v[a + 20 >> 2];
 d = v[a + 16 >> 2];
 v[c + 32 >> 2] = v[a + 12 >> 2];
 v[c + 36 >> 2] = d;
 Wf(c + 48 | 0, c + 32 | 0, g);
 a = v[f + 4 >> 2];
 f = v[a + 8 >> 2];
 g = v[a + 4 >> 2];
 d = v[c + 60 >> 2];
 v[c + 24 >> 2] = v[c + 56 >> 2];
 v[c + 28 >> 2] = d;
 d = v[c + 52 >> 2];
 v[c + 16 >> 2] = v[c + 48 >> 2];
 v[c + 20 >> 2] = d;
 v[c + 8 >> 2] = v[a + 8 >> 2];
 d = v[a + 4 >> 2];
 v[c >> 2] = v[a >> 2];
 v[c + 4 >> 2] = d;
 a: {
  b: {
   c: {
    d: {
     d = v[c + 4 >> 2];
     if (g >>> 0 <= d >>> 0) {
      if (g >>> 0 > y[c + 20 >> 2]) {
       break d;
      }
      if (f >>> 0 > y[c + 8 >> 2]) {
       break c;
      }
      h = v[c + 28 >> 2];
      if (f >>> 0 > v[c + 24 >> 2] - h >>> 0) {
       break b;
      }
      i = b + 12 | 0;
      j = v[c + 16 >> 2];
      k = v[c >> 2];
      b = 0;
      e: while (1) {
       if ((b | 0) == (f | 0)) {
        break a;
       }
       l = (B(b, d) << 2) + k | 0;
       a = 0;
       while (1) if ((a | 0) == (g | 0)) {
        b = b + 1 | 0;
        continue e;
       } else {
        e = a << 2;
        m = v[e + l >> 2];
        n = _t(i);
        o = (v[e + j >> 2] + (h << 1) | 0) + (b << 1) | 0;
        e = qd((qd(n, 21) + m | 0) + 2048 | 0, 12);
        e = (e | 0) >= 32767 ? 32767 : e;
        u[o >> 1] = (e | 0) <= -32768 ? -32768 : e;
        a = a + 1 | 0;
        continue;
       }
      }
     }
     Z(7244, 9045, 33, 8758);
     p();
    }
    Z(7209, 9045, 34, 8758);
    p();
   }
   Z(5897, 9045, 35, 8758);
   p();
  }
  Z(5867, 9045, 36, 8758);
  p();
 }
 eb = c - -64 | 0;
}

function Wn(a, b, c, d) {
 var e = 0, f = 0;
 f = eb - 16 | 0;
 eb = f;
 v[31601] = 0;
 V(995, a | 0);
 e = v[31601];
 v[31601] = 0;
 a: {
  b: {
   c: {
    d: {
     e: {
      f: {
       g: {
        h: {
         i: {
          if ((e | 0) != 1) {
           e = v[a + 24 >> 2];
           v[31601] = 0;
           N(d | 0, f + 4 | 0, e | 0);
           d = v[31601];
           v[31601] = 0;
           if ((d | 0) == 1) {
            break i;
           }
           d = v[f + 4 >> 2];
           e = Td(d, v[f + 8 >> 2]);
           if (e >>> 0 < 2147483647) {
            break h;
           }
           d = cc(8);
           v[31601] = 0;
           b = O(1050, d | 0, 7429) | 0;
           e = v[31601];
           v[31601] = 0;
           if ((e | 0) == 1) {
            break g;
           }
           v[31601] = 0;
           R(97, b | 0, 124868, 162);
           b = v[31601];
           v[31601] = 0;
           if ((b | 0) != 1) {
            break b;
           }
           b = S(0) | 0;
           break f;
          }
          b = S(0) | 0;
          break e;
         }
         b = S(0) | 0;
         break e;
        }
        j: {
         if (b >>> 0 >= e >>> 0) {
          b = Bg(22256);
          break j;
         }
         b = Bg(Jb(Ud(d, b)));
        }
        Sd(f + 4 | 0);
        break d;
       }
       b = S(0) | 0;
       jc(d);
      }
      Sd(f + 4 | 0);
     }
     X(b | 0) | 0;
     b = 0;
     v[31601] = 0;
     U(982, c | 0, a | 0, 0, 0);
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) == 1) {
      break c;
     }
     Y();
    }
    eb = f + 16 | 0;
    return b;
   }
   a = M() | 0;
   v[31601] = 0;
   W(26);
   b = v[31601];
   v[31601] = 0;
   if ((b | 0) != 1) {
    break a;
   }
   S(0) | 0;
   Rb();
  }
  p();
 }
 P(a | 0);
 p();
}

function Waa(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0;
 g = eb - 16 | 0;
 eb = g;
 h = g + 4 | 0;
 f = eb - 160 | 0;
 eb = f;
 d = f + 24 | 0;
 c = d + 56 | 0;
 e = Ut(c);
 v[d >> 2] = 93868;
 v[e >> 2] = 93888;
 v[d + 56 >> 2] = 93928;
 v[d >> 2] = 93908;
 i = c;
 c = d + 4 | 0;
 oo(i, c);
 v[d >> 2] = 93868;
 v[e >> 2] = 93888;
 c = Pt(c);
 v[c >> 2] = 93352;
 Eb(c + 32 | 0);
 v[c + 44 >> 2] = 0;
 v[c + 48 >> 2] = 16;
 j = v[v[d >> 2] - 12 >> 2];
 v[31601] = 0;
 i = ba(104) | 0;
 c = v[31601];
 v[31601] = 0;
 a: {
  b: {
   c: {
    d: {
     e: {
      f: {
       if ((c | 0) == 1) {
        break f;
       }
       v[31601] = 0;
       e = f + 20 | 0;
       R(105, e | 0, d + j | 0, i | 0);
       c = v[31601];
       v[31601] = 0;
       if ((c | 0) == 1) {
        break f;
       }
       Zb(e);
       c = eb - 16 | 0;
       eb = c;
       v[c + 12 >> 2] = 17;
       eb = c + 16 | 0;
       vn(d + v[v[d >> 2] - 12 >> 2] | 0, v[c + 12 >> 2]);
       k = A[b >> 3];
       v[31601] = 0;
       e = Ra(1129, d | 0, +k) | 0;
       b = v[31601];
       v[31601] = 0;
       if ((b | 0) == 1) {
        break e;
       }
       v[31601] = 0;
       c = f + 8 | 0;
       N(1130, c | 0, e | 0);
       b = v[31601];
       v[31601] = 0;
       if ((b | 0) == 1) {
        break d;
       }
       v[31601] = 0;
       N(303, h | 0, c | 0);
       b = v[31601];
       v[31601] = 0;
       if ((b | 0) == 1) {
        break c;
       }
       sb(c);
       gq(e);
       eb = f + 160 | 0;
       break a;
      }
      a = M() | 0;
      break b;
     }
     a = M() | 0;
     break b;
    }
    a = M() | 0;
    break b;
   }
   a = M() | 0;
   sb(f + 8 | 0);
  }
  gq(d);
  P(a | 0);
  p();
 }
 Ph(a, h);
 sb(h);
 eb = g + 16 | 0;
}

function Gy(a, b, c, d, e, f, g, h, i, j, k, l) {
 var m = 0, n = 0;
 a: {
  b: {
   if ((a | 0) == (f | 0)) {
    if (!w[b | 0]) {
     break a;
    }
    f = 0;
    t[b | 0] = 0;
    a = v[e >> 2];
    v[e >> 2] = a + 1;
    t[a | 0] = 46;
    if (!Cb(v[h + 4 >> 2], w[h + 11 | 0])) {
     break b;
    }
    a = v[j >> 2];
    if ((a - i | 0) > 159) {
     break b;
    }
    b = v[k >> 2];
    v[j >> 2] = a + 4;
    v[a >> 2] = b;
    return 0;
   }
   c: {
    if ((a | 0) != (g | 0)) {
     break c;
    }
    if (!Cb(v[h + 4 >> 2], w[h + 11 | 0])) {
     break c;
    }
    if (!w[b | 0]) {
     break a;
    }
    f = 0;
    a = v[j >> 2];
    if ((a - i | 0) > 159) {
     break b;
    }
    b = v[k >> 2];
    v[j >> 2] = a + 4;
    v[a >> 2] = b;
    v[k >> 2] = 0;
    return 0;
   }
   f = -1;
   a = Ei(l, l + 32 | 0, a) - l | 0;
   if ((a | 0) > 31) {
    break b;
   }
   g = t[a + 95136 | 0];
   d: {
    e: {
     switch ((a & -2) - 22 | 0) {
     case 2:
      a = v[e >> 2];
      if ((a | 0) != (d | 0)) {
       if ((nl(t[a - 1 | 0]) | 0) != (nl(t[c | 0]) | 0)) {
        break b;
       }
      }
      v[e >> 2] = a + 1;
      t[a | 0] = g;
      return 0;

     case 0:
      t[c | 0] = 80;
      break d;

     default:
      break e;
     }
    }
    d = nl(g);
    if ((d | 0) != t[c | 0]) {
     break d;
    }
    m = c, n = ut(d), t[m | 0] = n;
    if (!w[b | 0]) {
     break d;
    }
    t[b | 0] = 0;
    if (!Cb(v[h + 4 >> 2], w[h + 11 | 0])) {
     break d;
    }
    b = v[j >> 2];
    if ((b - i | 0) > 159) {
     break d;
    }
    c = v[k >> 2];
    v[j >> 2] = b + 4;
    v[b >> 2] = c;
   }
   b = v[e >> 2];
   v[e >> 2] = b + 1;
   t[b | 0] = g;
   f = 0;
   if ((a | 0) > 21) {
    break b;
   }
   v[k >> 2] = v[k >> 2] + 1;
  }
  return f;
 }
 return -1;
}

function Mm(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0;
 e = eb - 16 | 0;
 eb = e;
 v[a + 4 >> 2] = 0;
 if (Hd(w[Em(e + 15 | 0, a, 1) | 0])) {
  a: {
   b: {
    c: {
     if ((b | 0) == 2147483647) {
      b = a + 24 | 0;
      while (1) {
       c = v[b + v[v[a >> 2] - 12 >> 2] >> 2];
       v[31601] = 0;
       c = Q(83, c | 0) | 0;
       d = v[31601];
       v[31601] = 0;
       d: {
        if ((d | 0) != 1) {
         if (!lc(c, -1)) {
          break d;
         }
         break b;
        }
        break c;
       }
       v[a + 4 >> 2] = v[a + 4 >> 2] + 1;
       continue;
      }
     }
     if (v[a + 4 >> 2] >= (b | 0)) {
      break a;
     }
     c = a + 24 | 0;
     e: {
      while (1) {
       d = v[c + v[v[a >> 2] - 12 >> 2] >> 2];
       v[31601] = 0;
       d = Q(83, d | 0) | 0;
       f = v[31601];
       v[31601] = 0;
       if ((f | 0) == 1) {
        break e;
       }
       if (lc(d, -1)) {
        break b;
       }
       d = v[a + 4 >> 2] + 1 | 0;
       v[a + 4 >> 2] = d;
       if ((b | 0) > (d | 0)) {
        continue;
       }
       break;
      }
      c = 0;
      break a;
     }
    }
    X(S(0) | 0) | 0;
    c = 1;
    Cm(v[v[a >> 2] - 12 >> 2] + a | 0, 1);
    f: {
     g: {
      if (v[(v[v[a >> 2] - 12 >> 2] + a | 0) + 20 >> 2] & 1) {
       v[31601] = 0;
       W(84);
       a = v[31601];
       v[31601] = 0;
       if ((a | 0) != 1) {
        break f;
       }
       a = M() | 0;
       v[31601] = 0;
       W(26);
       b = v[31601];
       v[31601] = 0;
       if ((b | 0) == 1) {
        break g;
       }
       P(a | 0);
       p();
      }
      Y();
      break a;
     }
     S(0) | 0;
     Rb();
    }
    p();
   }
   c = 2;
  }
  Wj(v[v[a >> 2] - 12 >> 2] + a | 0, c);
 }
 eb = e + 16 | 0;
 return a | 0;
}

function qma(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, w = 0, x = 0;
 f = eb - 16 | 0;
 eb = f;
 g = v[a + 12 >> 2];
 h = v[a + 8 >> 2];
 a: {
  b: {
   if ((g | 0) <= 1 & h >>> 0 <= 805306368 | (g | 0) <= 0) {
    e = 131112;
    if ((g | 0) >= -2 & h >>> 0 >= 3489660928 | (g | 0) > -2) {
     break a;
    }
    e = 262184;
    if ((g | 0) == -2 & h >>> 0 < 2147483648 | g >>> 0 < 4294967294) {
     break a;
    }
    break b;
   }
   e = 262184;
   if ((g | 0) == 1 & h >>> 0 > 2147483648 | g >>> 0 > 1) {
    break a;
   }
  }
  e = 196648;
 }
 j = v[a + 16 >> 2];
 k = v[a + 24 >> 2];
 l = v[a + 20 >> 2];
 i = v[a + 4 >> 2];
 v[f + 8 >> 2] = v[a >> 2];
 v[f + 12 >> 2] = i;
 i = b + e | 0;
 while (1) {
  if (d) {
   b = v[f + 8 >> 2];
   m = (((v[f + 12 >> 2] & 2147483647) << 1 | b >>> 31) & -2) + j | 0;
   b = (b >>> 16 & 65520) + i | 0;
   n = u[b + 14 >> 1];
   o = u[b + 12 >> 1];
   p = u[b + 10 >> 1];
   q = u[b + 8 >> 1];
   r = u[b + 6 >> 1];
   s = u[b + 4 >> 1];
   w = u[b + 2 >> 1];
   x = u[b >> 1];
   b = 0;
   while (1) {
    if ((b | 0) != 2) {
     e = b + m | 0;
     v[(b << 2) + f >> 2] = (((((((B(t[e - 4 | 0], w) + B(t[e - 6 | 0], x) | 0) + B(t[e - 2 | 0], s) | 0) + B(t[e | 0], r) | 0) + B(t[e + 2 | 0], q) | 0) + B(t[e + 4 | 0], p) | 0) + B(t[e + 6 | 0], o) | 0) + B(t[e + 8 | 0], n) << 8) / 32768;
     b = b + 1 | 0;
     continue;
    }
    break;
   }
   v[c >> 2] = v[c >> 2] + B(v[f >> 2], l);
   v[c + 4 >> 2] = v[c + 4 >> 2] + B(v[f + 4 >> 2], k);
   Ob(f + 8 | 0, h, g);
   c = c + 8 | 0;
   d = d - 1 | 0;
   continue;
  }
  break;
 }
 b = v[f + 12 >> 2];
 v[a >> 2] = v[f + 8 >> 2];
 v[a + 4 >> 2] = b;
 eb = f + 16 | 0;
}

function $P(a) {
 var b = 0, c = C(0), d = 0, e = 0, f = 0, g = C(0), h = 0, i = 0, k = C(0), m = 0, n = 0, o = C(0);
 d = eb - 16 | 0;
 eb = d;
 b = v[v[a + 16 >> 2] + 24620 >> 2];
 e = a + 4208 | 0;
 n = a, o = De(C(10), C(C(C(z[xb(e, 0) >> 2] * C(120)) + C(-60)) / C(20))), z[n + 4232 >> 2] = o;
 k = C(C(b >>> 0) / C(1e3));
 n = a, o = De(C(10), C(C(-1) / C(k * C(C(z[xb(e, 1) >> 2] * C(499.989990234375)) + C(.009999999776482582))))), 
 z[n + 4236 >> 2] = o;
 n = a, o = De(C(10), C(C(-1) / C(k * C(C(z[xb(e, 2) >> 2] * C(2950)) + C(50))))), 
 z[n + 4240 >> 2] = o;
 v[d + 12 >> 2] = 1325400064;
 c = C(De(C(10), C(C(C(z[xb(e, 3) >> 2] * C(60)) + C(-60)) / C(20))) * C(2147483648));
 b = (q(c), j(2));
 g = C(0);
 a: {
  if ((b | 0) == 1065353216) {
   break a;
  }
  b: {
   if (b - 2139095040 >>> 0 <= 2164260863) {
    f = b << 1;
    if (!f) {
     g = C(Lx(C(-1)) / C(0));
     break a;
    }
    if ((b | 0) == 2139095040) {
     break b;
    }
    if (!(f >>> 0 < 4278190080 & (b | 0) >= 0)) {
     g = ZI(c);
     break a;
    }
    b = (q(C(c * C(8388608))), j(2)) - 192937984 | 0;
   }
   f = b - 1060306944 | 0;
   h = f >>> 15 & 240;
   i = +(l(2, b - (f & -8388608) | 0), r()) * A[h + 3568 >> 3] + -1;
   m = i * i;
   c = C((A[479] * m + (A[480] * i + A[481])) * m + (+(f >> 23) * A[478] + A[h + 3576 >> 3] + i));
  }
  g = c;
 }
 z[d + 8 >> 2] = C(C(g * C(67108864)) / C(.6931471824645996)) + C(67108864);
 n = a, o = C(z[Qm(d + 12 | 0, d + 8 | 0) >> 2] * C(4.656612873077393e-10)), z[n + 4244 >> 2] = o;
 n = a, o = C(C(C(-1) / C(C(z[xb(e, 4) >> 2] * C(99)) + C(1))) + C(1)), z[n + 4248 >> 2] = o;
 c = C(C(C(z[xb(e, 5) >> 2] * C(4)) * k) + C(2));
 c: {
  if (C(D(c)) < C(2147483648)) {
   h = ~~c;
   break c;
  }
  h = -2147483648;
 }
 v[a + 4252 >> 2] = h;
 eb = d + 16 | 0;
}

function BH(a, b, c) {
 var d = 0, e = 0, f = 0;
 e = eb - 32 | 0;
 eb = e;
 a: {
  f = _s(e + 28 | 0, b);
  d = v[f >> 2];
  if (!Dd(d)) {
   v[31601] = 0;
   b = O(36, e + 4 | 0, b | 0) | 0;
   a = v[31601];
   v[31601] = 0;
   b: {
    c: {
     d: {
      if ((a | 0) != 1) {
       v[31601] = 0;
       a = e + 16 | 0;
       R(1010, a | 0, 17680, b | 0);
       c = v[31601];
       v[31601] = 0;
       if ((c | 0) == 1) {
        break d;
       }
       v[31601] = 0;
       V(1366, a | 0);
       a = v[31601];
       v[31601] = 0;
       if ((a | 0) == 1) {
        break c;
       }
       p();
      }
      a = M() | 0;
      break a;
     }
     a = M() | 0;
     break b;
    }
    a = M() | 0;
    sb(e + 16 | 0);
   }
   sb(b);
   break a;
  }
  Zs(d);
  if (!Ys(a + 8 | 0, 22256, v[f >> 2])) {
   t[a + 8 | 0] = 127;
  }
  if (!Ys(a + 9 | 0, 22256, v[f >> 2])) {
   t[a + 9 | 0] = 127;
  }
  v[31601] = 0;
  N(272, a + 12 | 0, 22256);
  b = v[31601];
  v[31601] = 0;
  e: {
   f: {
    if ((b | 0) == 1) {
     break f;
    }
    v[31601] = 0;
    b = a + 24 | 0;
    N(272, b | 0, 22256);
    d = v[31601];
    v[31601] = 0;
    if ((d | 0) == 1) {
     break f;
    }
    v[a + 60 >> 2] = 0;
    v[31601] = 0;
    N(272, a + 36 | 0, 22256);
    d = v[31601];
    v[31601] = 0;
    if ((d | 0) == 1) {
     break f;
    }
    v[31601] = 0;
    N(272, a + 48 | 0, 22256);
    d = v[31601];
    v[31601] = 0;
    if ((d | 0) == 1) {
     break f;
    }
    v[31601] = 0;
    b = O(71, e + 16 | 0, b | 0) | 0;
    d = v[31601];
    v[31601] = 0;
    if ((d | 0) != 1) {
     break e;
    }
    a = M() | 0;
    break a;
   }
   a = M() | 0;
   break a;
  }
  ai(a - -64 | 0, c);
  ai(a + 68 | 0, c);
  sb(b);
  el(f);
  eb = e + 32 | 0;
  return;
 }
 el(f);
 P(a | 0);
 p();
}

function Kla(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0;
 e = eb - 16 | 0;
 eb = e;
 o = v[a + 16 >> 2];
 p = Fg(b + 327720 | 0, v[b + 20 >> 2], (v[a + 88 >> 2] & 16384) >>> 14 | 0);
 j = v[a + 8 >> 2];
 k = v[a + 12 >> 2];
 b = v[a >> 2];
 f = v[a + 4 >> 2];
 l = v[a + 128 >> 2];
 if (l) {
  m = Gg(j, k, l);
  n = gb;
  g = v[a + 76 >> 2];
  eg(b, f, uf(j, k, d), gb);
  i = gb >>> 0 > g >>> 0 ? d : 0;
 }
 g = a + 112 | 0;
 q = v[a + 24 >> 2];
 r = v[a + 20 >> 2];
 v[e >> 2] = b;
 v[e + 4 >> 2] = f;
 a: while (1) {
  if (d) {
   f = v[e + 4 >> 2];
   b = v[e >> 2];
   v[e + 8 >> 2] = b;
   v[e + 12 >> 2] = 0;
   i = i - 1 | 0;
   m = i ? m : 0;
   n = i ? n : 0;
   d = d - 1 | 0;
   f = ((((f & 2147483647) << 1 | b >>> 31) & 2147483646) << 1) + o | 0;
   b = l;
   while (1) if ((b | 0) <= 0) {
    Ob(g, v[a + 120 >> 2], v[a + 124 >> 2]);
    b = v[a + 116 >> 2];
    if (b) {
     h = v[e + 8 >> 2];
     h = (v[e + 12 >> 2] & 2147483647) << 1 | h >>> 31;
     be(g, (u[((h & 2147483646) << 1) + f >> 1] + u[(h << 1 | 2) + f >> 1] | 0) / 8 << 16 >> 16);
     ae(g, b);
     v[g >> 2] = v[g >> 2];
     v[g + 4 >> 2] = 0;
    }
    f = v[c >> 2];
    b = Eg(g, p);
    v[c >> 2] = f + B(b, r);
    v[c + 4 >> 2] = v[c + 4 >> 2] + B(b, q);
    Ob(e, j, k);
    c = c + 8 | 0;
    continue a;
   } else {
    h = v[e + 8 >> 2];
    h = (v[e + 12 >> 2] & 2147483647) << 1 | h >>> 31;
    be(g, (u[((h & 2147483646) << 1) + f >> 1] + u[(h << 1 | 2) + f >> 1] | 0) / 8 << 16 >> 16);
    ae(g, 4);
    Ob(e + 8 | 0, m, n);
    b = b - 1 | 0;
    continue;
   }
  }
  break;
 }
 b = v[e + 4 >> 2];
 v[a >> 2] = v[e >> 2];
 v[a + 4 >> 2] = b;
 eb = e + 16 | 0;
}

function Uta(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0;
 g = eb - 32 | 0;
 eb = g;
 i = a + 8 | 0;
 c = v[a + 8 >> 2];
 h = mc(a);
 a: {
  if ((c | 0) != v[h >> 2]) {
   break a;
  }
  k = a + 4 | 0;
  d = v[a + 4 >> 2];
  e = v[a >> 2];
  if (d >>> 0 > e >>> 0) {
   f = eb - 16 | 0;
   eb = f;
   l = f + 8 | 0;
   a = eb - 32 | 0;
   eb = a;
   ed(a + 24 | 0, d, c);
   m = a + 16 | 0;
   c = v[a + 24 >> 2];
   h = v[a + 28 >> 2];
   j = ((d - e >> 1) + 1 | 0) / -2 << 1;
   d = d + j | 0;
   e = eb - 16 | 0;
   eb = e;
   while (1) {
    if ((c | 0) != (h | 0)) {
     d = P$(d, c) + 2 | 0;
     c = c + 2 | 0;
     continue;
    }
    break;
   }
   v[e + 12 >> 2] = d;
   pc(m, h, e + 12 | 0);
   eb = e + 16 | 0;
   c = v[a + 16 >> 2];
   v[a + 12 >> 2] = v[a + 20 >> 2];
   pc(l, c, a + 12 | 0);
   eb = a + 32 | 0;
   eb = f + 16 | 0;
   c = v[f + 12 >> 2];
   v[i >> 2] = c;
   v[k >> 2] = v[k >> 2] + j;
   break a;
  }
  v[g + 8 >> 2] = c - e;
  v[g + 28 >> 2] = 1;
  d = g + 8 | 0;
  c = v[ad(d, g + 28 | 0) >> 2];
  c = dk(d, c, c >>> 2 | 0, v[a + 16 >> 2]);
  d = ub(g + 4 | 0, v[a + 4 >> 2]);
  f = ub(g, v[a + 8 >> 2]);
  d = v[d >> 2];
  e = qE(d, v[f >> 2]);
  f = eb - 16 | 0;
  eb = f;
  v[f + 12 >> 2] = d;
  e = Bp(f, c + 8 | 0, e);
  d = v[e >> 2];
  while (1) {
   if (v[e + 4 >> 2] != (d | 0)) {
    j = d;
    d = v[f + 12 >> 2];
    _i(j, w[d | 0] | w[d + 1 | 0] << 8);
    d = v[e >> 2] + 2 | 0;
    v[e >> 2] = d;
    fe(f + 12 | 0);
    continue;
   }
   break;
  }
  ie(e);
  eb = f + 16 | 0;
  Sb(a, c);
  Sb(k, c + 4 | 0);
  Sb(i, c + 8 | 0);
  Sb(h, mc(c));
  $i(c);
  c = v[a + 8 >> 2];
 }
 _i(c, w[b | 0] | w[b + 1 | 0] << 8);
 v[i >> 2] = v[i >> 2] + 2;
 eb = g + 32 | 0;
}

function iS(a) {
 var b = 0, c = 0, d = 0, e = 0, f = 0, g = 0;
 while (1) {
  if ((f | 0) != 128e3) {
   g = eb - 32 | 0;
   eb = g;
   b = fv(g);
   d = w[b + 4 | 0] | w[b + 5 | 0] << 8 | (w[b + 6 | 0] << 16 | w[b + 7 | 0] << 24);
   c = a + f | 0;
   e = w[b | 0] | w[b + 1 | 0] << 8 | (w[b + 2 | 0] << 16 | w[b + 3 | 0] << 24);
   t[c | 0] = e;
   t[c + 1 | 0] = e >>> 8;
   t[c + 2 | 0] = e >>> 16;
   t[c + 3 | 0] = e >>> 24;
   t[c + 4 | 0] = d;
   t[c + 5 | 0] = d >>> 8;
   t[c + 6 | 0] = d >>> 16;
   t[c + 7 | 0] = d >>> 24;
   d = w[b + 28 | 0] | w[b + 29 | 0] << 8 | (w[b + 30 | 0] << 16 | w[b + 31 | 0] << 24);
   e = w[b + 24 | 0] | w[b + 25 | 0] << 8 | (w[b + 26 | 0] << 16 | w[b + 27 | 0] << 24);
   t[c + 24 | 0] = e;
   t[c + 25 | 0] = e >>> 8;
   t[c + 26 | 0] = e >>> 16;
   t[c + 27 | 0] = e >>> 24;
   t[c + 28 | 0] = d;
   t[c + 29 | 0] = d >>> 8;
   t[c + 30 | 0] = d >>> 16;
   t[c + 31 | 0] = d >>> 24;
   d = w[b + 20 | 0] | w[b + 21 | 0] << 8 | (w[b + 22 | 0] << 16 | w[b + 23 | 0] << 24);
   e = w[b + 16 | 0] | w[b + 17 | 0] << 8 | (w[b + 18 | 0] << 16 | w[b + 19 | 0] << 24);
   t[c + 16 | 0] = e;
   t[c + 17 | 0] = e >>> 8;
   t[c + 18 | 0] = e >>> 16;
   t[c + 19 | 0] = e >>> 24;
   t[c + 20 | 0] = d;
   t[c + 21 | 0] = d >>> 8;
   t[c + 22 | 0] = d >>> 16;
   t[c + 23 | 0] = d >>> 24;
   d = w[b + 12 | 0] | w[b + 13 | 0] << 8 | (w[b + 14 | 0] << 16 | w[b + 15 | 0] << 24);
   b = w[b + 8 | 0] | w[b + 9 | 0] << 8 | (w[b + 10 | 0] << 16 | w[b + 11 | 0] << 24);
   t[c + 8 | 0] = b;
   t[c + 9 | 0] = b >>> 8;
   t[c + 10 | 0] = b >>> 16;
   t[c + 11 | 0] = b >>> 24;
   t[c + 12 | 0] = d;
   t[c + 13 | 0] = d >>> 8;
   t[c + 14 | 0] = d >>> 16;
   t[c + 15 | 0] = d >>> 24;
   eb = g + 32 | 0;
   f = f + 32 | 0;
   continue;
  }
  break;
 }
}

function g_(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0;
 g = b - 1 | 0;
 while (1) {
  a: {
   if (!c) {
    c = 0;
    break a;
   }
   if (w[c + g | 0]) {
    break a;
   }
   c = c - 1 | 0;
   continue;
  }
  break;
 }
 b: {
  if ((d | 0) != 4) {
   break b;
  }
  g = 0;
  while (1) {
   if ((c | 0) == (e | 0)) {
    if ((f | 0) == (g | 0)) {
     d = 2;
     if ((f | 0) == (h | 0)) {
      break b;
     }
    }
    if (f) {
     d = 0;
     if (!g) {
      break b;
     }
    }
    d = f ? 3 : g ? 1 : 3;
   } else {
    c: {
     d: {
      e: {
       d = b + e | 0;
       i = w[d | 0];
       switch (i - 10 | 0) {
       case 0:
        break d;

       case 3:
        break e;

       default:
        break c;
       }
      }
      f = f + 1 | 0;
      break c;
     }
     g = g + 1 | 0;
    }
    if (e) {
     h = ((i | 0) == 10 & w[d - 1 | 0] == 13) + h | 0;
    }
    e = e + 1 | 0;
    continue;
   }
   break;
  }
 }
 f = 0;
 g = (d | 0) == 2;
 e = 0;
 while (1) {
  if (c >>> 0 > e >>> 0) {
   e = ((g & w[b + e | 0] == 13) + e | 0) + 1 | 0;
   f = f + 1 | 0;
   continue;
  }
  break;
 }
 sf(a);
 zs(a, f);
 g = (d | 0) == 1 ? 32 : 13;
 h = d & -3 ? 13 : 32;
 d = (d | 0) == 2;
 e = 0;
 while (1) {
  if (c >>> 0 > e >>> 0) {
   f: {
    g: {
     h: {
      i: {
       f = w[b + e | 0];
       switch (f - 10 | 0) {
       case 1:
       case 2:
        break f;

       case 0:
        break g;

       case 3:
        break h;

       default:
        break i;
       }
      }
      if (f) {
       break f;
      }
      f = 32;
      break f;
     }
     e = d + e | 0;
     f = g;
     break f;
    }
    f = h;
   }
   Rp(a, f << 24 >> 24);
   e = e + 1 | 0;
   continue;
  }
  break;
 }
}

function Mma(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, u = 0, w = 0, x = 0, y = 0, z = 0;
 h = eb - 16 | 0;
 eb = h;
 j = v[a + 40 >> 2];
 k = v[a + 36 >> 2];
 f = v[a + 48 >> 2];
 e = v[a + 44 >> 2];
 o = v[a + 16 >> 2];
 b = v[a + 4 >> 2];
 v[h + 8 >> 2] = v[a >> 2];
 v[h + 12 >> 2] = b;
 p = v[a + 32 >> 2];
 q = v[a + 28 >> 2];
 r = v[a + 72 >> 2];
 l = v[a + 68 >> 2];
 s = l >> 31;
 m = v[a + 64 >> 2];
 u = m >> 31;
 n = v[a + 60 >> 2];
 w = n >> 31;
 x = v[a + 8 >> 2];
 y = v[a + 12 >> 2];
 while (1) {
  b = e;
  if (d) {
   e = Xb(e, -16777216, 16776704);
   e = Aua(m, u, e, e >> 31);
   i = gb;
   g = e;
   f = Xb(f, -16777216, 16776704);
   e = Aua(l, s, f, f >> 31);
   g = g + e | 0;
   f = gb + i | 0;
   f = e >>> 0 > g >>> 0 ? f + 1 | 0 : f;
   z = g;
   e = v[h + 8 >> 2];
   i = e >>> 10 & 4194048;
   e = v[h + 12 >> 2] + o | 0;
   g = t[e | 0];
   i = ((B(t[e + 1 | 0] - g | 0, i) | 0) / 16384 << 8) + (g << 16) | 0;
   e = i;
   e = Aua(e, e >> 31, n, w);
   g = e + z | 0;
   f = gb + f | 0;
   f = e >>> 0 > g >>> 0 ? f + 1 | 0 : f;
   e = g + 8388608 | 0;
   f = e >>> 0 < 8388608 ? f + 1 | 0 : f;
   e = Rc(e, f, 24);
   f = (e | 0) / 256 | 0;
   k = k + q | 0;
   v[c >> 2] = B(f, k >> 12) + v[c >> 2];
   j = j + p | 0;
   v[c + 4 >> 2] = v[c + 4 >> 2] + B(j >> 12, f);
   Ob(h + 8 | 0, x, y);
   e = e - (i & r) | 0;
   c = c + 8 | 0;
   d = d - 1 | 0;
   f = b;
   continue;
  }
  break;
 }
 c = v[h + 12 >> 2];
 v[a >> 2] = v[h + 8 >> 2];
 v[a + 4 >> 2] = c;
 v[a + 40 >> 2] = j;
 v[a + 20 >> 2] = k >> 12;
 v[a + 36 >> 2] = k;
 v[a + 48 >> 2] = f;
 v[a + 44 >> 2] = b;
 v[a + 24 >> 2] = j >> 12;
 eb = h + 16 | 0;
}

function DV(a, b, c, d) {
 var e = 0, f = 0;
 e = eb - 16 | 0;
 eb = e;
 t[e + 15 | 0] = c;
 f = b & 15;
 b = w[f + 25408 | 0];
 a: {
  b: {
   switch (f | 0) {
   case 0:
    b = c ? d >>> 0 >= 51 ? b : 0 : 0;
    break a;

   case 5:
    c: {
     d: {
      f = c & 15;
      e: {
       if (!((f | 0) != 2 & (c & 240) != 32)) {
        c = 159;
        t[e + 15 | 0] = 159;
        b = 20;
        break e;
       }
       if ((f | 0) == 12) {
        break d;
       }
      }
      if (d >>> 0 < 51) {
       break a;
      }
      if ((c & 240) == 192) {
       break c;
      }
      break a;
     }
     if (d >>> 0 < 51) {
      break a;
     }
    }
    t[e + 15 | 0] = 0;
    b = 25;
    break a;

   case 7:
    b = d >>> 0 >= 52 ? b : 0;
    break a;

   case 10:
    c = c & 240;
    if (!c) {
     break a;
    }
    t[e + 15 | 0] = c;
    break a;

   case 11:
    t[e + 15 | 0] = B(c & 15, 17);
    break a;

   case 13:
    t[e + 15 | 0] = B(c >>> 4 | 0, 10) + (c & 15);
    break a;

   case 14:
    f: {
     switch ((c >>> 4 | 0) - 1 | 0) {
     case 0:
      t[e + 15 | 0] = c | 240;
      b = 2;
      break a;

     case 1:
      t[e + 15 | 0] = c | 240;
      b = 3;
      break a;

     case 7:
      if (d >>> 0 < 52) {
       break a;
      }
      t[e + 15 | 0] = c & 15 | 96;

     case 11:
     case 12:
      b = 20;
      break a;

     case 8:
      b = 15;
      t[e + 15 | 0] = c & 15;
      break a;

     case 9:
      t[e + 15 | 0] = c << 4 | 15;
      b = 11;
      break a;

     case 10:
      break f;

     default:
      break a;
     }
    }
    t[e + 15 | 0] = c | 240;
    b = 11;
    break a;

   case 15:
    break b;

   default:
    break a;
   }
  }
  b = c >>> 0 > 47 ? 17 : b;
 }
 de(a, b, e + 15 | 0);
 eb = e + 16 | 0;
}

function yaa(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
 c = eb + -64 | 0;
 eb = c;
 e = v[a >> 2];
 a = v[e >> 2];
 f = v[a + 4 >> 2];
 v[c + 40 >> 2] = v[a + 20 >> 2];
 d = v[a + 16 >> 2];
 v[c + 32 >> 2] = v[a + 12 >> 2];
 v[c + 36 >> 2] = d;
 Wf(c + 48 | 0, c + 32 | 0, f);
 a = v[e + 4 >> 2];
 e = v[a + 8 >> 2];
 f = v[a + 4 >> 2];
 d = v[c + 60 >> 2];
 v[c + 24 >> 2] = v[c + 56 >> 2];
 v[c + 28 >> 2] = d;
 d = v[c + 52 >> 2];
 v[c + 16 >> 2] = v[c + 48 >> 2];
 v[c + 20 >> 2] = d;
 v[c + 8 >> 2] = v[a + 8 >> 2];
 d = v[a + 4 >> 2];
 v[c >> 2] = v[a >> 2];
 v[c + 4 >> 2] = d;
 a: {
  b: {
   c: {
    d: {
     d = v[c + 4 >> 2];
     if (f >>> 0 <= d >>> 0) {
      h = v[c + 20 >> 2];
      if (f >>> 0 > h >>> 0) {
       break d;
      }
      if (e >>> 0 > y[c + 8 >> 2]) {
       break c;
      }
      i = v[c + 28 >> 2];
      if (e >>> 0 > v[c + 24 >> 2] - i >>> 0) {
       break b;
      }
      j = b + 12 | 0;
      k = v[c + 16 >> 2];
      l = v[c >> 2];
      b = 0;
      e: while (1) {
       if ((b | 0) == (e | 0)) {
        break a;
       }
       m = (B(b, d) << 2) + l | 0;
       n = (B(b + i | 0, h) << 1) + k | 0;
       a = 0;
       while (1) if ((a | 0) == (f | 0)) {
        b = b + 1 | 0;
        continue e;
       } else {
        g = qd((v[(a << 2) + m >> 2] + qd(_t(j), 21) | 0) + 2048 | 0, 12);
        g = (g | 0) >= 32767 ? 32767 : g;
        u[(a << 1) + n >> 1] = (g | 0) <= -32768 ? -32768 : g;
        a = a + 1 | 0;
        continue;
       }
      }
     }
     Z(7244, 9045, 33, 8758);
     p();
    }
    Z(7209, 9045, 34, 8758);
    p();
   }
   Z(5897, 9045, 35, 8758);
   p();
  }
  Z(5867, 9045, 36, 8758);
  p();
 }
 eb = c - -64 | 0;
}

function dha(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = C(0), f = 0, g = C(0), h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = C(0), t = 0, u = 0, w = 0, x = 0, y = 0, A = C(0);
 a: {
  j = v[a + 4272 >> 2];
  if (!j) {
   break a;
  }
  if (!si(a + 44 | 0)) {
   break a;
  }
  f = v[a + 44 >> 2];
  l = Gc(f, 0);
  m = Gc(f, 1);
  u = v[a + 4252 >> 2] - 1 | 0;
  i = v[a + 4268 >> 2];
  k = v[a + 4256 >> 2];
  n = d;
  f = v[a + 56 >> 2];
  q = Gc(f, 0);
  o = q;
  r = Gc(f, 1);
  p = r;
  while (1) {
   if (n) {
    e = z[m >> 2];
    f = i << 1;
    h = xb(k, f);
    g = z[l >> 2];
    z[h >> 2] = g;
    y = xb(k, f | 1), A = e, z[y >> 2] = A;
    s = z[a + 4276 >> 2];
    e = C(C(D(_P(C(C(C(D(g)) + C(D(e))) * C(536870912)), 31, 5))) * C(4.656612873077393e-10));
    e = C(C(C(s - e) * z[(e >= s ? 4236 : 4240) + a >> 2]) + e);
    z[a + 4276 >> 2] = e;
    g = z[a + 4244 >> 2];
    e = C(C(C(C(g - (e < g ? g : e)) * z[a + 4248 >> 2]) + C(.9999998807907104)) * C(2147483648));
    b: {
     if (e < C(4294967296) & e >= C(0)) {
      f = ~~e >>> 0;
      break b;
     }
     f = 0;
    }
    t = ((((i << 12) + u | 0) + j | 0) / 4096 | 0) % (j | 0) << 1;
    g = z[xb(k, t) >> 2];
    h = f << 5;
    w = h;
    x = h | -2147483648;
    h = f >>> 0 < 67108864;
    e = C(z[a + 4232 >> 2] * C(C((h ? w : x) >>> (h ? 31 : 32 - (f >>> 26 | 0) | 0) >>> 0) * C(4.656612873077393e-10)));
    z[o >> 2] = g * e;
    y = p, A = C(z[xb(k, t | 1) >> 2] * e), z[y >> 2] = A;
    i = ((i ? 0 : j) + i | 0) - 1 | 0;
    v[a + 4268 >> 2] = i;
    n = n - 1 | 0;
    p = p + 4 | 0;
    o = o + 4 | 0;
    m = m + 4 | 0;
    l = l + 4 | 0;
    continue;
   } else {
    Hi(a, b, c, q, r, d);
   }
   break;
  }
 }
}

function Ida(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0;
 b = eb - 2144 | 0;
 eb = b;
 wu(b + 96 | 0);
 a: {
  b: {
   c: {
    f = v[c + 4 >> 2];
    if (!f) {
     a = cc(8);
     v[31601] = 0;
     b = O(36, b + 80 | 0, 10453) | 0;
     c = v[31601];
     v[31601] = 0;
     if ((c | 0) == 1) {
      break c;
     }
     rc(a, b);
     v[31601] = 0;
     R(97, a | 0, 48396, 999);
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) != 1) {
      break a;
     }
     d = M() | 0;
     sb(b);
     break b;
    }
    g = v[c >> 2];
    d = v[c + 12 >> 2];
    c = v[c + 8 >> 2];
    v[b + 72 >> 2] = c;
    v[b + 76 >> 2] = d;
    e = v[b + 76 >> 2];
    v[b + 32 >> 2] = v[b + 72 >> 2];
    v[b + 36 >> 2] = e;
    v[b + 68 >> 2] = f;
    v[b + 64 >> 2] = g;
    e = v[b + 68 >> 2];
    v[b + 24 >> 2] = v[b + 64 >> 2];
    v[b + 28 >> 2] = e;
    h = sM(b + 24 | 0);
    if (h) {
     v[b + 56 >> 2] = c;
     v[b + 60 >> 2] = d;
     c = v[b + 60 >> 2];
     v[b + 16 >> 2] = v[b + 56 >> 2];
     v[b + 20 >> 2] = c;
     v[b + 52 >> 2] = f;
     v[b + 48 >> 2] = g;
     c = v[b + 52 >> 2];
     v[b + 8 >> 2] = v[b + 48 >> 2];
     v[b + 12 >> 2] = c;
     c = kM(b + 8 | 0);
    } else {
     c = 0;
    }
    v[b + 80 >> 2] = c;
    v[b + 84 >> 2] = 0;
    d = 0;
    c = 2048;
    while (1) {
     if (c) {
      e = hb[f | 0](g, (b + 96 | 0) + d | 0, c) | 0;
      c = c - e | 0;
      d = d + e | 0;
      if (e) {
       continue;
      }
     }
     break;
    }
    c = Yb(b + 40 | 0, b + 96 | 0, d);
    d = v[c + 4 >> 2];
    v[b >> 2] = v[c >> 2];
    v[b + 4 >> 2] = d;
    a = Bu(a, b, h ? b + 80 | 0 : 0);
    eb = b + 2144 | 0;
    return a | 0;
   }
   d = M() | 0;
   jc(a);
  }
  P(d | 0);
 }
 p();
}

function eP(a) {
 var b = 0, c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0;
 g = eb - 16 | 0;
 eb = g;
 b = v[a >> 2];
 ub(g + 12 | 0, b);
 a: {
  b: {
   c: {
    d: {
     e: {
      if (Dd(v[b + 16 >> 2])) {
       while (1) {
        if (c >>> 0 > 31) {
         break e;
        }
        v[31601] = 0;
        d = ba(69) | 0;
        e = v[31601];
        v[31601] = 0;
        if ((e | 0) != 1) {
         f = d | f;
         c = c + 32 | 0;
         continue;
        }
        break;
       }
       c = S(125092) | 0;
       if ((fb | 0) != (_(125092) | 0)) {
        break c;
       }
       X(c | 0) | 0;
       t[b + 20 | 0] = 0;
       v[31601] = 0;
       V(57, b | 0);
       c = v[31601];
       v[31601] = 0;
       if ((c | 0) == 1) {
        break d;
       }
       Y();
       break e;
      }
      t[b + 20 | 0] = 0;
     }
     if (!w[b + 20 | 0]) {
      d = v[b + 24 >> 2];
      b = 0;
      c = 1;
      while (1) {
       if (c) {
        c = 0;
        b = v[d + 2496 >> 2];
        e = (b << 2) + d | 0;
        i = v[((b + 397 >>> 0) % 624 << 2) + d >> 2];
        h = (b + 1 >>> 0) % 624 | 0;
        b = v[(h << 2) + d >> 2];
        b = i ^ (b & 2147483647 | v[e >> 2] & -2147483648) >>> 1 ^ 0 - (b & 1) & -1727483681;
        v[e >> 2] = b;
        v[d + 2496 >> 2] = h;
        b = b ^ b >>> 11;
        b = b << 7 & -1658038656 ^ b;
        b = b << 15 & -272236544 ^ b;
        b = b >>> 18 ^ b;
        continue;
       }
       break;
      }
      f = b ^ f;
     }
     eb = g + 16 | 0;
     break a;
    }
    c = M() | 0;
    v[31601] = 0;
    W(26);
    a = v[31601];
    v[31601] = 0;
    if ((a | 0) == 1) {
     break b;
    }
   }
   P(c | 0);
   p();
  }
  S(0) | 0;
  Rb();
  p();
 }
 return v[a + 28 >> 2] & f;
}

function eV(a, b, c, d) {
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = C(0), l = 0, m = 0, n = 0;
 if (Jj(v[a + 656 >> 2])) {
  e = w[a + 797 | 0];
  e = (l = e, m = w[a + 799 | 0], n = Tc(e), n ? l : m);
  f = Nb(d + 1074312 | 0, 34);
  d = v[a + 656 >> 2];
  a: {
   if (!f) {
    break a;
   }
   f = e & 255;
   if (!f | f >>> 0 > 120) {
    break a;
   }
   e = w[wb(d + 108 | 0, f - 1 | 0) | 0];
  }
  k = C(C(v[a + 704 >> 2]) * b);
  d = v[d + 44 >> 2];
  g = ((e & 255) + c | 0) - 61 << 16 >> 16;
  b: {
   c: {
    c = v[a + 852 >> 2] + u[a + 772 >> 1] | 0;
    if (c) {
     h = v[d + 36 >> 2];
     if (h) {
      break c;
     }
    }
    b = Um(d, c + g << 16 >> 16);
    break b;
   }
   j = h + 1 | 0;
   i = iA(c, j);
   e = jA(c, j);
   b = C(1);
   f = u[d + 28 >> 1];
   c = g + i << 16 >> 16;
   d: {
    if ((f | 0) > (c | 0)) {
     break d;
    }
    g = v[d + 4 >> 2];
    if ((c | 0) > (nc(g, v[d + 8 >> 2]) + f | 0) - 1 << 16 >> 16) {
     break d;
    }
    if (!e) {
     b = z[xb(g, c - f | 0) >> 2];
     break b;
    }
    e: {
     f: {
      g: {
       switch (x[d >> 1] - 1 | 0) {
       case 2:
        h = v[d + 16 >> 2];
        if (!nc(h, v[d + 20 >> 2])) {
         break f;
        }
        b = z[xb(h, e - 1 | 0) >> 2];
        break e;

       case 0:
        break g;

       default:
        break f;
       }
      }
      i = v[d + 16 >> 2];
      if (!nc(i, v[d + 20 >> 2])) {
       break f;
      }
      b = z[xb(i, (e + B(h, nA(c, x[d + 30 >> 1]) << 16 >> 16) | 0) - 1 | 0) >> 2];
      break e;
     }
     b = De(C(Um(d, c + 1 << 16 >> 16) / Um(d, c)), C(C(e | 0) / C(j | 0)));
    }
    b = C(b * z[xb(g, c - f | 0) >> 2]);
   }
  }
  l = a, m = Ak(C(C(k * b) * C(16))), v[l + 700 >> 2] = m;
 }
}

function yia(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0;
 d = v[a >> 2];
 c = fk(d, v[a + 4 >> 2]);
 if (c >>> 0 < b >>> 0) {
  h = eb - 32 | 0;
  eb = h;
  f = b - c | 0;
  d = v[zb(a) >> 2];
  b = v[a + 4 >> 2];
  a: {
   if (f >>> 0 <= d - b >> 11 >>> 0) {
    c = eb - 16 | 0;
    eb = c;
    b = c + 4 | 0;
    v[b >> 2] = a;
    a = v[a + 4 >> 2];
    v[b + 4 >> 2] = a;
    v[b + 8 >> 2] = a + (f << 11);
    a = v[b + 4 >> 2];
    d = v[b + 8 >> 2];
    while (1) {
     if ((a | 0) == (d | 0)) {
      hc(b);
      eb = c + 16 | 0;
     } else {
      wu(a);
      a = a + 2048 | 0;
      v[b + 4 >> 2] = a;
      continue;
     }
     break;
    }
    break a;
   }
   g = zb(a);
   i = h + 12 | 0;
   e = fk(v[a >> 2], b) + f | 0;
   c = eb - 16 | 0;
   eb = c;
   v[c + 12 >> 2] = e;
   d = eb - 16 | 0;
   eb = d;
   v[d + 12 >> 2] = 2097151;
   v[d + 8 >> 2] = 2147483647;
   b = v[Gb(d + 12 | 0, d + 8 | 0) >> 2];
   eb = d + 16 | 0;
   b: {
    if (b >>> 0 >= e >>> 0) {
     d = eA(a);
     if (d >>> 0 < b >>> 1 >>> 0) {
      v[c + 8 >> 2] = d << 1;
      b = v[ad(c + 8 | 0, c + 12 | 0) >> 2];
     }
     eb = c + 16 | 0;
     break b;
    }
    dd();
    p();
   }
   d = GQ(i, b, fk(v[a >> 2], v[a + 4 >> 2]), g);
   c = d;
   e = eb - 16 | 0;
   eb = e;
   g = v[c + 8 >> 2];
   b = e + 4 | 0;
   v[b + 8 >> 2] = c + 8;
   v[b >> 2] = g;
   v[b + 4 >> 2] = g + (f << 11);
   c = v[b >> 2];
   while (1) {
    if (v[b + 4 >> 2] != (c | 0)) {
     wu(c);
     c = v[b >> 2] + 2048 | 0;
     v[b >> 2] = c;
     continue;
    }
    break;
   }
   ie(b);
   eb = e + 16 | 0;
   FQ(a, d);
   EQ(d);
  }
  eb = h + 32 | 0;
  return;
 }
 if (b >>> 0 < c >>> 0) {
  Id(a, d + (b << 11) | 0);
 }
}

function Lma(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, w = 0, x = 0, y = 0, z = 0;
 h = eb - 16 | 0;
 eb = h;
 i = v[a + 40 >> 2];
 j = v[a + 36 >> 2];
 e = v[a + 48 >> 2];
 f = v[a + 44 >> 2];
 p = v[a + 16 >> 2];
 b = v[a + 4 >> 2];
 v[h + 8 >> 2] = v[a >> 2];
 v[h + 12 >> 2] = b;
 q = v[a + 32 >> 2];
 r = v[a + 28 >> 2];
 s = v[a + 72 >> 2];
 m = v[a + 68 >> 2];
 t = m >> 31;
 n = v[a + 64 >> 2];
 w = n >> 31;
 o = v[a + 60 >> 2];
 x = o >> 31;
 y = v[a + 8 >> 2];
 z = v[a + 12 >> 2];
 while (1) {
  b = f;
  if (d) {
   f = Xb(f, -16777216, 16776704);
   g = Aua(n, w, f, f >> 31);
   f = gb;
   e = Xb(e, -16777216, 16776704);
   e = Aua(m, t, e, e >> 31);
   g = e + g | 0;
   f = gb + f | 0;
   f = e >>> 0 > g >>> 0 ? f + 1 | 0 : f;
   l = g;
   g = (v[h + 12 >> 2] << 1) + p | 0;
   k = u[g >> 1];
   k = k + ((B(u[g + 2 >> 1] - k | 0, v[h + 8 >> 2] >>> 18 | 0) | 0) / 16384 | 0) << 8;
   e = k;
   g = Aua(e, e >> 31, o, x);
   l = g + l | 0;
   e = gb + f | 0;
   e = g >>> 0 > l >>> 0 ? e + 1 | 0 : e;
   f = l + 8388608 | 0;
   e = f >>> 0 < 8388608 ? e + 1 | 0 : e;
   f = Rc(f, e, 24);
   e = (f | 0) / 256 | 0;
   j = j + r | 0;
   v[c >> 2] = B(e, j >> 12) + v[c >> 2];
   i = i + q | 0;
   v[c + 4 >> 2] = v[c + 4 >> 2] + B(i >> 12, e);
   Ob(h + 8 | 0, y, z);
   f = f - (k & s) | 0;
   c = c + 8 | 0;
   d = d - 1 | 0;
   e = b;
   continue;
  }
  break;
 }
 c = v[h + 12 >> 2];
 v[a >> 2] = v[h + 8 >> 2];
 v[a + 4 >> 2] = c;
 v[a + 40 >> 2] = i;
 v[a + 20 >> 2] = j >> 12;
 v[a + 36 >> 2] = j;
 v[a + 48 >> 2] = e;
 v[a + 44 >> 2] = b;
 v[a + 24 >> 2] = i >> 12;
 eb = h + 16 | 0;
}

function by(a) {
 var b = 0, c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0;
 b = a;
 a: {
  if (b & 3) {
   while (1) {
    c = w[b | 0];
    if (!c | (c | 0) == 61) {
     break a;
    }
    b = b + 1 | 0;
    if (b & 3) {
     continue;
    }
    break;
   }
  }
  c = v[b >> 2];
  b: {
   if ((c ^ -1) & c - 16843009 & -2139062144) {
    break b;
   }
   while (1) {
    if ((c ^ 1027423549) - 16843009 & (c ^ -1) & -2139062144) {
     break b;
    }
    c = v[b + 4 >> 2];
    b = b + 4 | 0;
    if (!(c - 16843009 & (c ^ -1) & -2139062144)) {
     continue;
    }
    break;
   }
  }
  while (1) {
   c = b;
   d = w[b | 0];
   if ((d | 0) != 61) {
    b = b + 1 | 0;
    if (d) {
     continue;
    }
   }
   break;
  }
  b = c;
 }
 if ((a | 0) == (b | 0)) {
  return 0;
 }
 f = b - a | 0;
 c: {
  if (w[f + a | 0]) {
   break c;
  }
  e = v[125406];
  if (!e) {
   break c;
  }
  b = v[e >> 2];
  if (!b) {
   break c;
  }
  while (1) {
   d: {
    g = a;
    c = b;
    h = f;
    d = 0;
    e: {
     if (!f) {
      break e;
     }
     d = w[a | 0];
     if (d) {
      f: {
       while (1) {
        i = w[c | 0];
        if ((i | 0) != (d | 0) | !i) {
         break f;
        }
        h = h - 1 | 0;
        if (!h) {
         break f;
        }
        c = c + 1 | 0;
        d = w[g + 1 | 0];
        g = g + 1 | 0;
        if (d) {
         continue;
        }
        break;
       }
       d = 0;
      }
     } else {
      d = 0;
     }
     d = d - w[c | 0] | 0;
    }
    if (!d) {
     b = b + f | 0;
     if (w[b | 0] == 61) {
      break d;
     }
    }
    b = v[e + 4 >> 2];
    e = e + 4 | 0;
    if (b) {
     continue;
    }
    break c;
   }
   break;
  }
  j = b + 1 | 0;
 }
 return j;
}

function ana(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, w = 0, x = 0, y = 0, z = 0, A = 0, C = 0, D = 0;
 g = eb - 16 | 0;
 eb = g;
 r = v[a + 16 >> 2];
 l = jg(1, 2);
 b = gb;
 s = b;
 Ob(a, l, b);
 i = v[a + 40 >> 2];
 j = v[a + 36 >> 2];
 f = v[a + 48 >> 2];
 e = v[a + 44 >> 2];
 b = v[a + 4 >> 2];
 v[g + 8 >> 2] = v[a >> 2];
 v[g + 12 >> 2] = b;
 t = v[a + 32 >> 2];
 w = v[a + 28 >> 2];
 x = v[a + 72 >> 2];
 m = v[a + 68 >> 2];
 y = m >> 31;
 n = v[a + 64 >> 2];
 z = n >> 31;
 o = v[a + 60 >> 2];
 A = o >> 31;
 C = v[a + 8 >> 2];
 D = v[a + 12 >> 2];
 while (1) {
  b = e;
  if (d) {
   p = u[(v[g + 12 >> 2] << 1) + r >> 1] << 8;
   e = p;
   e = Aua(e, e >> 31, o, A);
   k = gb;
   h = e;
   e = Xb(b, -16777216, 16776704);
   e = Aua(n, z, e, e >> 31);
   q = h + e | 0;
   h = gb + k | 0;
   h = e >>> 0 > q >>> 0 ? h + 1 | 0 : h;
   f = Xb(f, -16777216, 16776704);
   e = Aua(m, y, f, f >> 31);
   k = e + q | 0;
   f = gb + h | 0;
   f = e >>> 0 > k >>> 0 ? f + 1 | 0 : f;
   e = k + 8388608 | 0;
   f = e >>> 0 < 8388608 ? f + 1 | 0 : f;
   e = Rc(e, f, 24);
   f = (e | 0) / 256 | 0;
   j = j + w | 0;
   v[c >> 2] = B(f, j >> 12) + v[c >> 2];
   i = i + t | 0;
   v[c + 4 >> 2] = v[c + 4 >> 2] + B(i >> 12, f);
   Ob(g + 8 | 0, C, D);
   e = e - (x & p) | 0;
   c = c + 8 | 0;
   d = d - 1 | 0;
   f = b;
   continue;
  }
  break;
 }
 c = v[g + 12 >> 2];
 v[a >> 2] = v[g + 8 >> 2];
 v[a + 4 >> 2] = c;
 v[a + 40 >> 2] = i;
 v[a + 20 >> 2] = j >> 12;
 v[a + 36 >> 2] = j;
 v[a + 48 >> 2] = f;
 v[a + 44 >> 2] = b;
 v[a + 24 >> 2] = i >> 12;
 Hg(a, l, s);
 eb = g + 16 | 0;
}

function hq(a, b, c, d, e, f) {
 var g = C(0), h = 0, i = C(0), j = 0, k = C(0), l = C(0);
 c = (c << 2) + b | 0;
 d = c + (d << 2) | 0;
 a = a >> 2;
 b = f << 2;
 while (1) {
  if ((a | 0) > 0) {
   f = d - 4 | 0;
   i = z[f >> 2];
   k = z[c >> 2];
   l = z[d >> 2];
   z[c >> 2] = k + l;
   h = c - 4 | 0;
   g = z[h >> 2];
   z[h >> 2] = g + z[f >> 2];
   k = C(k - l);
   g = C(g - i);
   z[d >> 2] = C(k * z[e >> 2]) - C(z[e + 4 >> 2] * g);
   z[f >> 2] = C(g * z[e >> 2]) + C(k * z[e + 4 >> 2]);
   f = d - 12 | 0;
   k = z[f >> 2];
   h = c - 8 | 0;
   g = z[h >> 2];
   j = h;
   h = d - 8 | 0;
   l = z[h >> 2];
   z[j >> 2] = g + l;
   j = c - 12 | 0;
   i = z[j >> 2];
   z[j >> 2] = i + z[f >> 2];
   g = C(g - l);
   e = b + e | 0;
   i = C(i - k);
   z[h >> 2] = C(g * z[e >> 2]) - C(z[e + 4 >> 2] * i);
   z[f >> 2] = C(i * z[e >> 2]) + C(g * z[e + 4 >> 2]);
   f = d - 20 | 0;
   k = z[f >> 2];
   h = c - 16 | 0;
   g = z[h >> 2];
   j = h;
   h = d - 16 | 0;
   l = z[h >> 2];
   z[j >> 2] = g + l;
   j = c - 20 | 0;
   i = z[j >> 2];
   z[j >> 2] = i + z[f >> 2];
   g = C(g - l);
   e = b + e | 0;
   i = C(i - k);
   z[h >> 2] = C(g * z[e >> 2]) - C(z[e + 4 >> 2] * i);
   z[f >> 2] = C(i * z[e >> 2]) + C(g * z[e + 4 >> 2]);
   f = d - 28 | 0;
   k = z[f >> 2];
   h = c - 24 | 0;
   g = z[h >> 2];
   j = h;
   h = d - 24 | 0;
   l = z[h >> 2];
   z[j >> 2] = g + l;
   j = c - 28 | 0;
   i = z[j >> 2];
   z[j >> 2] = i + z[f >> 2];
   g = C(g - l);
   e = b + e | 0;
   i = C(i - k);
   z[h >> 2] = C(g * z[e >> 2]) - C(z[e + 4 >> 2] * i);
   z[f >> 2] = C(i * z[e >> 2]) + C(g * z[e + 4 >> 2]);
   e = b + e | 0;
   a = a - 1 | 0;
   d = d - 32 | 0;
   c = c - 32 | 0;
   continue;
  }
  break;
 }
}

function xaa(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0;
 c = eb + -64 | 0;
 eb = c;
 b = v[a >> 2];
 a = v[b >> 2];
 d = v[a + 4 >> 2];
 v[c + 40 >> 2] = v[a + 20 >> 2];
 e = v[a + 16 >> 2];
 v[c + 32 >> 2] = v[a + 12 >> 2];
 v[c + 36 >> 2] = e;
 Wf(c + 48 | 0, c + 32 | 0, d);
 a = v[b + 4 >> 2];
 d = v[a + 8 >> 2];
 e = v[a + 4 >> 2];
 b = v[c + 60 >> 2];
 v[c + 24 >> 2] = v[c + 56 >> 2];
 v[c + 28 >> 2] = b;
 b = v[c + 52 >> 2];
 v[c + 16 >> 2] = v[c + 48 >> 2];
 v[c + 20 >> 2] = b;
 v[c + 8 >> 2] = v[a + 8 >> 2];
 b = v[a + 4 >> 2];
 v[c >> 2] = v[a >> 2];
 v[c + 4 >> 2] = b;
 a: {
  b: {
   c: {
    d: {
     g = v[c + 4 >> 2];
     if (g >>> 0 >= e >>> 0) {
      h = v[c + 20 >> 2];
      if (h >>> 0 < e >>> 0) {
       break d;
      }
      if (d >>> 0 > y[c + 8 >> 2]) {
       break c;
      }
      i = v[c + 28 >> 2];
      if (d >>> 0 > v[c + 24 >> 2] - i >>> 0) {
       break b;
      }
      j = v[c + 16 >> 2];
      k = v[c >> 2];
      b = 0;
      e: while (1) {
       if ((b | 0) == (d | 0)) {
        break a;
       }
       l = (B(b, g) << 2) + k | 0;
       m = (B(b + i | 0, h) << 1) + j | 0;
       a = 0;
       while (1) if ((a | 0) == (e | 0)) {
        b = b + 1 | 0;
        continue e;
       } else {
        f = qd(v[(a << 2) + l >> 2] + 2048 | 0, 12);
        f = (f | 0) >= 32767 ? 32767 : f;
        u[(a << 1) + m >> 1] = (f | 0) <= -32768 ? -32768 : f;
        a = a + 1 | 0;
        continue;
       }
      }
     }
     Z(7244, 9045, 33, 8758);
     p();
    }
    Z(7209, 9045, 34, 8758);
    p();
   }
   Z(5897, 9045, 35, 8758);
   p();
  }
  Z(5867, 9045, 36, 8758);
  p();
 }
 eb = c - -64 | 0;
}

function bna(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, u = 0, w = 0, x = 0, y = 0, z = 0, A = 0, C = 0, D = 0;
 g = eb - 16 | 0;
 eb = g;
 r = v[a + 16 >> 2];
 l = jg(1, 2);
 b = gb;
 s = b;
 Ob(a, l, b);
 i = v[a + 40 >> 2];
 j = v[a + 36 >> 2];
 f = v[a + 48 >> 2];
 e = v[a + 44 >> 2];
 b = v[a + 4 >> 2];
 v[g + 8 >> 2] = v[a >> 2];
 v[g + 12 >> 2] = b;
 u = v[a + 32 >> 2];
 w = v[a + 28 >> 2];
 x = v[a + 72 >> 2];
 m = v[a + 68 >> 2];
 y = m >> 31;
 n = v[a + 64 >> 2];
 z = n >> 31;
 o = v[a + 60 >> 2];
 A = o >> 31;
 C = v[a + 8 >> 2];
 D = v[a + 12 >> 2];
 while (1) {
  b = e;
  if (d) {
   p = t[v[g + 12 >> 2] + r | 0] << 16;
   e = p;
   e = Aua(e, e >> 31, o, A);
   k = gb;
   h = e;
   e = Xb(b, -16777216, 16776704);
   e = Aua(n, z, e, e >> 31);
   q = h + e | 0;
   h = gb + k | 0;
   h = e >>> 0 > q >>> 0 ? h + 1 | 0 : h;
   f = Xb(f, -16777216, 16776704);
   e = Aua(m, y, f, f >> 31);
   k = e + q | 0;
   f = gb + h | 0;
   f = e >>> 0 > k >>> 0 ? f + 1 | 0 : f;
   e = k + 8388608 | 0;
   f = e >>> 0 < 8388608 ? f + 1 | 0 : f;
   e = Rc(e, f, 24);
   f = (e | 0) / 256 | 0;
   j = j + w | 0;
   v[c >> 2] = B(f, j >> 12) + v[c >> 2];
   i = i + u | 0;
   v[c + 4 >> 2] = v[c + 4 >> 2] + B(i >> 12, f);
   Ob(g + 8 | 0, C, D);
   e = e - (x & p) | 0;
   c = c + 8 | 0;
   d = d - 1 | 0;
   f = b;
   continue;
  }
  break;
 }
 c = v[g + 12 >> 2];
 v[a >> 2] = v[g + 8 >> 2];
 v[a + 4 >> 2] = c;
 v[a + 40 >> 2] = i;
 v[a + 20 >> 2] = j >> 12;
 v[a + 36 >> 2] = j;
 v[a + 48 >> 2] = f;
 v[a + 44 >> 2] = b;
 v[a + 24 >> 2] = i >> 12;
 Hg(a, l, s);
 eb = g + 16 | 0;
}

function xA(a, b, c) {
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0;
 e = eb - 16 | 0;
 eb = e;
 d = w[a + 2 | 0];
 if (!(!d | (d | 0) == 255)) {
  v[e + 12 >> 2] = d + 1;
  v[e + 8 >> 2] = 10;
  eh(b, v[Bd(e + 12 | 0, e + 8 | 0) >> 2]);
  i = w[a + 3 | 0];
  t[b + 15 | 0] = i;
  t[b + 16 | 0] = i;
  j = w[a + 4 | 0];
  t[b + 13 | 0] = j;
  l = w[a + 5 | 0];
  t[b + 14 | 0] = l;
  g = 511;
  d = 0;
  a: {
   b: {
    switch (c - 1 | 0) {
    case 1:
     d = 4096;
     g = 128;
     break a;

    case 0:
     break b;

    default:
     break a;
    }
   }
   d = 32768;
   g = 1024;
  }
  o = a + 6 | 0;
  p = g >>> 1 | d;
  c = v[b >> 2];
  k = Rd(c, v[b + 4 >> 2]);
  d = 0;
  while (1) {
   if ((d | 0) == (k | 0)) {
    c = w[b + 12 | 0] & -2 | t[a | 0] & 1;
    t[b + 12 | 0] = c;
    c = c & -5 | (w[a | 0] | w[a + 1 | 0] << 8) << 1 & (k >>> 0 >= i >>> 0) << 2;
    t[b + 12 | 0] = c;
    t[b + 12 | 0] = c & 253 | (w[a | 0] | w[a + 1 | 0] << 8) >>> 1 & (j >>> 0 <= l >>> 0 ? (k >>> 0 >= j >>> 0) << 1 : 0);
   } else {
    m = xb(c, d);
    h = (d << 2) + o | 0;
    f = (w[h | 0] | w[h + 1 | 0] << 8) >>> 4 | 0;
    u[m >> 1] = f;
    c: {
     if (d) {
      n = x[xb(c, d - 1 | 0) >> 1];
      if (f >>> 0 >= n >>> 0) {
       break c;
      }
      f = n + 1 | 0;
     } else {
      f = 0;
     }
     q = xb(c, d), r = f, u[q >> 1] = r;
    }
    v[e + 12 >> 2] = (((w[h + 2 | 0] | w[h + 3 | 0] << 8) << 16 >> 16) + p | 0) / (g | 0);
    v[e + 8 >> 2] = 0;
    v[e + 4 >> 2] = 64;
    q = m, r = v[Yj(e + 12 | 0, e + 8 | 0, e + 4 | 0) >> 2], t[q + 2 | 0] = r;
    d = d + 1 | 0;
    continue;
   }
   break;
  }
 }
 eb = e + 16 | 0;
}

function iga(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = C(0), l = 0, m = 0, n = 0, o = 0, p = 0, q = C(0), r = C(0), s = 0, t = 0, u = 0, w = C(0), x = C(0), y = C(0), A = C(0), B = C(0), D = C(0), E = C(0);
 g = eb - 16 | 0;
 eb = g;
 if (si(a + 44 | 0)) {
  f = v[a + 44 >> 2];
  e = Gc(f, 0);
  v[g + 8 >> 2] = e;
  f = Gc(f, 1);
  v[g + 12 >> 2] = f;
  i = v[a + 56 >> 2];
  l = Gc(i, 0);
  v[g >> 2] = l;
  m = Gc(i, 1);
  v[g + 4 >> 2] = m;
  a: {
   if (z[xb(a + 4208 | 0, 2) >> 2] != C(.5)) {
    s = a + 4264 | 0;
    t = a + 4256 | 0;
    u = a + 4248 | 0;
    n = a + 4240 | 0;
    f = d;
    b: while (1) {
     i = 0;
     if (!f) {
      break a;
     }
     while (1) if ((i | 0) == 2) {
      f = f - 1 | 0;
      continue b;
     } else {
      e = i << 2;
      j = e + (g + 8 | 0) | 0;
      h = v[j >> 2];
      v[j >> 2] = h + 4;
      j = e + s | 0;
      w = z[j >> 2];
      o = e + u | 0;
      x = z[o >> 2];
      p = e + t | 0;
      k = z[p >> 2];
      q = z[h >> 2];
      y = z[a + 4236 >> 2];
      A = z[a + 4232 >> 2];
      B = z[a + 4228 >> 2];
      D = z[a + 4220 >> 2];
      E = z[a + 4224 >> 2];
      h = e + n | 0;
      r = z[h >> 2];
      z[o >> 2] = r;
      z[h >> 2] = q;
      z[j >> 2] = k;
      k = C(C(C(C(B * x) + C(C(D * q) + C(E * r))) - C(A * k)) - C(y * w));
      z[p >> 2] = k;
      h = e + g | 0;
      e = v[h >> 2];
      v[h >> 2] = e + 4;
      z[e >> 2] = k;
      i = i + 1 | 0;
      continue;
     }
    }
   }
   n = e;
   e = d << 2;
   yc(l, n, e);
   yc(m, f, e);
   f = v[a + 56 >> 2];
   l = Gc(f, 0);
   m = Gc(f, 1);
  }
  Hi(a, b, c, l, m, d);
 }
 eb = g + 16 | 0;
}

function Gaa(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0;
 c = eb + -64 | 0;
 eb = c;
 b = v[a >> 2];
 a = v[b >> 2];
 e = v[a + 4 >> 2];
 v[c + 40 >> 2] = v[a + 20 >> 2];
 f = v[a + 16 >> 2];
 v[c + 32 >> 2] = v[a + 12 >> 2];
 v[c + 36 >> 2] = f;
 Wf(c + 48 | 0, c + 32 | 0, e);
 a = v[b + 4 >> 2];
 e = v[a + 8 >> 2];
 f = v[a + 4 >> 2];
 b = v[c + 60 >> 2];
 v[c + 24 >> 2] = v[c + 56 >> 2];
 v[c + 28 >> 2] = b;
 b = v[c + 52 >> 2];
 v[c + 16 >> 2] = v[c + 48 >> 2];
 v[c + 20 >> 2] = b;
 v[c + 8 >> 2] = v[a + 8 >> 2];
 b = v[a + 4 >> 2];
 v[c >> 2] = v[a >> 2];
 v[c + 4 >> 2] = b;
 a: {
  b: {
   c: {
    d: {
     g = v[c + 4 >> 2];
     if (g >>> 0 >= f >>> 0) {
      if (y[c + 20 >> 2] < f >>> 0) {
       break d;
      }
      if (e >>> 0 > y[c + 8 >> 2]) {
       break c;
      }
      h = v[c + 28 >> 2];
      if (e >>> 0 > v[c + 24 >> 2] - h >>> 0) {
       break b;
      }
      i = v[c + 16 >> 2];
      j = v[c >> 2];
      b = 0;
      e: while (1) {
       if ((b | 0) == (e | 0)) {
        break a;
       }
       k = (B(b, g) << 2) + j | 0;
       a = 0;
       while (1) if ((a | 0) == (f | 0)) {
        b = b + 1 | 0;
        continue e;
       } else {
        d = a << 2;
        l = (v[d + i >> 2] + (h << 1) | 0) + (b << 1) | 0;
        d = qd(v[d + k >> 2] + 2048 | 0, 12);
        d = (d | 0) >= 32767 ? 32767 : d;
        u[l >> 1] = (d | 0) <= -32768 ? -32768 : d;
        a = a + 1 | 0;
        continue;
       }
      }
     }
     Z(7244, 9045, 33, 8758);
     p();
    }
    Z(7209, 9045, 34, 8758);
    p();
   }
   Z(5897, 9045, 35, 8758);
   p();
  }
  Z(5867, 9045, 36, 8758);
  p();
 }
 eb = c - -64 | 0;
}

function sQ(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = C(0);
 c = eb - 80 | 0;
 eb = c;
 d = v[b >> 2];
 b = v[b + 4 >> 2];
 e = Ld(c + 52 | 0);
 f = v[e + 4 >> 2];
 v[c + 8 >> 2] = v[e >> 2];
 v[c + 12 >> 2] = f;
 b = qx(c + 60 | 0, d, b, c + 8 | 0);
 v[31601] = 0;
 d = Q(202, b | 0) | 0;
 e = v[31601];
 v[31601] = 0;
 a: {
  if ((e | 0) == 1) {
   break a;
  }
  v[31601] = 0;
  d = T(948, b | 0, c + 19 | 0, d | 0) | 0;
  e = v[31601];
  v[31601] = 0;
  if ((e | 0) == 1) {
   break a;
  }
  if (!(!d | (w[c + 23 | 0] | w[c + 24 | 0] << 8 | (w[c + 25 | 0] << 16 | w[c + 26 | 0] << 24) | (w[c + 19 | 0] | w[c + 20 | 0] << 8 | (w[c + 21 | 0] << 16 | w[c + 22 | 0] << 24)) != 542066252))) {
   g = a, h = Od((l(2, w[c + 27 | 0] | w[c + 28 | 0] << 8 | (w[c + 29 | 0] << 16 | w[c + 30 | 0] << 24)), 
   r()), C(0)), z[g + 4220 >> 2] = h;
   g = a, h = Od((l(2, w[c + 31 | 0] | w[c + 32 | 0] << 8 | (w[c + 33 | 0] << 16 | w[c + 34 | 0] << 24)), 
   r()), C(0)), z[g + 4224 >> 2] = h;
   g = a, h = Od((l(2, w[c + 35 | 0] | w[c + 36 | 0] << 8 | (w[c + 37 | 0] << 16 | w[c + 38 | 0] << 24)), 
   r()), C(0)), z[g + 4228 >> 2] = h;
   d = w[c + 39 | 0] | w[c + 40 | 0] << 8 | (w[c + 41 | 0] << 16 | w[c + 42 | 0] << 24);
   if (d >>> 0 <= 5) {
    v[a + 4232 >> 2] = d;
   }
   v[a + 4236 >> 2] = w[c + 43 | 0] | w[c + 44 | 0] << 8 | (w[c + 45 | 0] << 16 | w[c + 46 | 0] << 24);
   t[a + 4240 | 0] = w[c + 47 | 0] != 0;
   t[a + 4241 | 0] = w[c + 48 | 0] != 0;
   t[a + 4242 | 0] = w[c + 49 | 0] != 0;
   t[a + 4243 | 0] = w[c + 50 | 0] != 0;
   t[a + 4244 | 0] = w[c + 51 | 0] != 0;
   su(a);
  }
  tb(b);
  eb = c + 80 | 0;
  return;
 }
 a = M() | 0;
 tb(b);
 P(a | 0);
 p();
}

function rz(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = C(0);
 c = eb + -64 | 0;
 eb = c;
 b = v[a >> 2];
 a = v[b >> 2];
 d = v[a + 4 >> 2];
 v[c + 40 >> 2] = v[a + 20 >> 2];
 e = v[a + 16 >> 2];
 v[c + 32 >> 2] = v[a + 12 >> 2];
 v[c + 36 >> 2] = e;
 Wf(c + 48 | 0, c + 32 | 0, d);
 a = v[b + 4 >> 2];
 d = v[a + 8 >> 2];
 e = v[a + 4 >> 2];
 b = v[c + 60 >> 2];
 v[c + 24 >> 2] = v[c + 56 >> 2];
 v[c + 28 >> 2] = b;
 b = v[c + 52 >> 2];
 v[c + 16 >> 2] = v[c + 48 >> 2];
 v[c + 20 >> 2] = b;
 v[c + 8 >> 2] = v[a + 8 >> 2];
 b = v[a + 4 >> 2];
 v[c >> 2] = v[a >> 2];
 v[c + 4 >> 2] = b;
 a: {
  b: {
   c: {
    d: {
     f = v[c + 4 >> 2];
     if (f >>> 0 >= e >>> 0) {
      g = v[c + 20 >> 2];
      if (g >>> 0 < e >>> 0) {
       break d;
      }
      if (d >>> 0 > y[c + 8 >> 2]) {
       break c;
      }
      h = v[c + 28 >> 2];
      if (d >>> 0 > v[c + 24 >> 2] - h >>> 0) {
       break b;
      }
      i = v[c + 16 >> 2];
      j = v[c >> 2];
      b = 0;
      e: while (1) {
       if ((b | 0) == (d | 0)) {
        break a;
       }
       k = (B(b, f) << 3) + j | 0;
       l = (B(b + h | 0, g) << 2) + i | 0;
       a = 0;
       while (1) if ((a | 0) == (e | 0)) {
        b = b + 1 | 0;
        continue e;
       } else {
        m = (a << 2) + l | 0, n = C(+(un(Ee(Ig(A[(a << 3) + k >> 3]) * 134217728)) | 0) * 7.450580596923828e-9), 
        z[m >> 2] = n;
        a = a + 1 | 0;
        continue;
       }
      }
     }
     Z(7244, 9045, 77, 8725);
     p();
    }
    Z(7209, 9045, 78, 8725);
    p();
   }
   Z(5897, 9045, 79, 8725);
   p();
  }
  Z(5867, 9045, 80, 8725);
  p();
 }
 eb = c - -64 | 0;
}

function Nqa(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
 d = eb - 432 | 0;
 eb = d;
 xc(b);
 kD(b, d + 380 | 0, d + 300 | 0, d + 16 | 0);
 k = d, l = Dh((m = w[d + 431 | 0] + 1 | 0, n = 1, o = _b(w[d + 412 | 0] | w[d + 413 | 0] << 8 | (w[d + 414 | 0] << 16 | w[d + 415 | 0] << 24)), 
 o ? m : n)), t[k + 12 | 0] = l;
 i = w[Pb(25168, d + 12 | 0) | 0];
 t[d + 15 | 0] = i;
 u[d + 12 >> 1] = 4;
 a: {
  b: {
   while (1) {
    if ((h & 255) >>> 0 >= i >>> 0) {
     break b;
    }
    e = Ab(x[d + 16 >> 1]) << 16 >> 16;
    if (!((e | 0) < 0 | w[d + 299 | 0] > 63)) {
     e = e & 65535;
     f = 0;
     while (1) {
      if ((f | 0) == (e | 0)) {
       c: {
        e = g;
        g = _b(v[d + 300 >> 2]);
        if (e >>> 0 < g >>> 0) {
         if (cd(b, g)) {
          break c;
         }
        }
        t[d + 15 | 0] = h + 1;
        break b;
       }
      } else {
       d: {
        if (!cd(b, _b(w[d + 396 | 0] | w[d + 397 | 0] << 8 | (w[d + 398 | 0] << 16 | w[d + 399 | 0] << 24)) + (f << 2) | 0)) {
         break d;
        }
        if (!cd(b, op(b))) {
         break d;
        }
        e: {
         if (!c) {
          j = Yd(b);
          break e;
         }
         j = Mk(b);
        }
        u[d + 10 >> 1] = j;
        k = d, l = x[qe(d + 12 | 0, d + 10 | 0) >> 1], u[k + 12 >> 1] = l;
       }
       f = f + 1 | 0;
       continue;
      }
      break;
     }
     g = _b(v[d + 300 >> 2]);
     kD(b, d + 380 | 0, d + 300 | 0, d + 16 | 0);
     h = h + 1 | 0;
     continue;
    }
    break;
   }
   Ww(a);
   break a;
  }
  tY(a, x[d + 12 >> 1], d + 15 | 0);
 }
 eb = d + 432 | 0;
}

function sT(a, b) {
 var c = 0, d = 0, e = 0, f = 0;
 d = eb - 16 | 0;
 eb = d;
 c = v[a + 24620 >> 2];
 a: {
  b: {
   switch (w[a + 480224 | 0] - 1 | 0) {
   default:
    v[d + 12 >> 2] = 1;
    v[d + 8 >> 2] = v[b + 44 >> 2] << 1;
    c = Aua(c, c >> 31, 5e4, 0);
    e = gb;
    b = v[ad(d + 12 | 0, d + 8 | 0) >> 2];
    c = Fc(Bua(c, e, b, b >> 31), gb);
    break a;

   case 0:
    v[d + 12 >> 2] = 1;
    v[d + 8 >> 2] = v[b + 44 >> 2];
    c = Aua(c, c >> 31, 1e4, 0);
    e = gb;
    b = v[ad(d + 12 | 0, d + 8 | 0) >> 2];
    c = Fc(Bua(c, e, b, b >> 31), gb);
    break a;

   case 1:
    break b;
   }
  }
  f = 60 / (+y[b + 44 >> 2] / 1e4 * (+(Aua(v[b + 32 >> 2], 0, v[b + 40 >> 2], 0) >>> 0) + +(gb >>> 0) * 4294967296)) * +(c >>> 0);
  c: {
   d: {
    c = v[a + 484344 >> 2];
    e = x[b + 70 >> 1];
    if (!Ie(c, v[a + 484348 >> 2], e)) {
     break d;
    }
    c = Vb(c, e);
    if (!Hb(v[c + 24 >> 2], v[c + 28 >> 2])) {
     break d;
    }
    c = MR(c);
    break c;
   }
   c = a + 480248 | 0;
  }
  e = v[c >> 2];
  c = v[c + 4 >> 2];
  if (!lc(e, c)) {
   f = f * +y[xb(e, y[b + 48 >> 2] % (nc(e, c) >>> 0) | 0) >> 2] * 5.960464477539063e-8;
  }
  e: {
   if (D(f) < 2147483648) {
    c = ~~f;
    break e;
   }
   c = -2147483648;
  }
  f = A[b + 8 >> 3] + (f - +(c >>> 0));
  A[b + 8 >> 3] = f;
  if (f >= 1) {
   A[b + 8 >> 3] = f + -1;
   c = c + 1 | 0;
   break a;
  }
  if (!(A[a + 1074384 >> 3] <= -1)) {
   break a;
  }
  A[b + 8 >> 3] = f + 1;
  c = c - 1 | 0;
 }
 b = Aua(v[a + 480244 >> 2], 0, c, 0);
 a = gb;
 b = b + 32768 | 0;
 a = b >>> 0 < 32768 ? a + 1 | 0 : a;
 a = Ac((a & 65535) << 16 | b >>> 16, a >>> 16 | 0);
 eb = d + 16 | 0;
 return a >>> 0 <= 1 ? 1 : a;
}

function jC(a, b, c) {
 var d = 0, e = 0;
 b = b - a >> 5;
 while (1) {
  if ((b | 0) > 0) {
   d = w[c + 4 | 0] | w[c + 5 | 0] << 8 | (w[c + 6 | 0] << 16 | w[c + 7 | 0] << 24);
   e = w[c | 0] | w[c + 1 | 0] << 8 | (w[c + 2 | 0] << 16 | w[c + 3 | 0] << 24);
   t[a | 0] = e;
   t[a + 1 | 0] = e >>> 8;
   t[a + 2 | 0] = e >>> 16;
   t[a + 3 | 0] = e >>> 24;
   t[a + 4 | 0] = d;
   t[a + 5 | 0] = d >>> 8;
   t[a + 6 | 0] = d >>> 16;
   t[a + 7 | 0] = d >>> 24;
   d = w[c + 28 | 0] | w[c + 29 | 0] << 8 | (w[c + 30 | 0] << 16 | w[c + 31 | 0] << 24);
   e = w[c + 24 | 0] | w[c + 25 | 0] << 8 | (w[c + 26 | 0] << 16 | w[c + 27 | 0] << 24);
   t[a + 24 | 0] = e;
   t[a + 25 | 0] = e >>> 8;
   t[a + 26 | 0] = e >>> 16;
   t[a + 27 | 0] = e >>> 24;
   t[a + 28 | 0] = d;
   t[a + 29 | 0] = d >>> 8;
   t[a + 30 | 0] = d >>> 16;
   t[a + 31 | 0] = d >>> 24;
   d = w[c + 20 | 0] | w[c + 21 | 0] << 8 | (w[c + 22 | 0] << 16 | w[c + 23 | 0] << 24);
   e = w[c + 16 | 0] | w[c + 17 | 0] << 8 | (w[c + 18 | 0] << 16 | w[c + 19 | 0] << 24);
   t[a + 16 | 0] = e;
   t[a + 17 | 0] = e >>> 8;
   t[a + 18 | 0] = e >>> 16;
   t[a + 19 | 0] = e >>> 24;
   t[a + 20 | 0] = d;
   t[a + 21 | 0] = d >>> 8;
   t[a + 22 | 0] = d >>> 16;
   t[a + 23 | 0] = d >>> 24;
   d = w[c + 12 | 0] | w[c + 13 | 0] << 8 | (w[c + 14 | 0] << 16 | w[c + 15 | 0] << 24);
   e = w[c + 8 | 0] | w[c + 9 | 0] << 8 | (w[c + 10 | 0] << 16 | w[c + 11 | 0] << 24);
   t[a + 8 | 0] = e;
   t[a + 9 | 0] = e >>> 8;
   t[a + 10 | 0] = e >>> 16;
   t[a + 11 | 0] = e >>> 24;
   t[a + 12 | 0] = d;
   t[a + 13 | 0] = d >>> 8;
   t[a + 14 | 0] = d >>> 16;
   t[a + 15 | 0] = d >>> 24;
   b = b - 1 | 0;
   a = a + 32 | 0;
   continue;
  }
  break;
 }
}

function Mfa(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0;
 e = eb - 80 | 0;
 eb = e;
 v[e + 76 >> 2] = c;
 c = e + 76 | 0;
 a = re(a, c);
 g = sc(a + 4 | 0);
 h = sc(a + 24 | 0);
 i = sc(a + 32 | 0);
 j = Mb(a + 36 | 0);
 v[a + 56 >> 2] = 3;
 k = Mb(a + 68 | 0);
 v[31601] = 0;
 N(990, a | 0, d | 0);
 f = v[31601];
 v[31601] = 0;
 a: {
  b: {
   c: {
    d: {
     if ((f | 0) != 1) {
      f = v[b >> 2];
      l = v[b + 4 >> 2];
      m = v[b + 12 >> 2];
      v[e + 48 >> 2] = v[b + 8 >> 2];
      v[e + 52 >> 2] = m;
      v[e + 40 >> 2] = f;
      v[e + 44 >> 2] = l;
      b = Ld(e + 32 | 0);
      f = v[e + 52 >> 2];
      v[e + 24 >> 2] = v[e + 48 >> 2];
      v[e + 28 >> 2] = f;
      v[31601] = 0;
      f = v[e + 44 >> 2];
      v[e + 16 >> 2] = v[e + 40 >> 2];
      v[e + 20 >> 2] = f;
      f = v[b + 4 >> 2];
      v[e + 8 >> 2] = v[b >> 2];
      v[e + 12 >> 2] = f;
      b = e + 56 | 0;
      R(979, b | 0, e + 16 | 0, e + 8 | 0);
      f = v[31601];
      v[31601] = 0;
      if ((f | 0) == 1) {
       break d;
      }
      v[31601] = 0;
      R(991, a | 0, b | 0, d | 0);
      d = v[31601];
      v[31601] = 0;
      if ((d | 0) == 1) {
       break c;
      }
      tb(b);
      v[31601] = 0;
      V(992, a | 0);
      b = v[31601];
      v[31601] = 0;
      if ((b | 0) == 1) {
       break b;
      }
      Wc(c);
      eb = e + 80 | 0;
      return a | 0;
     }
     d = M() | 0;
     break a;
    }
    d = M() | 0;
    break a;
   }
   d = M() | 0;
   tb(e + 56 | 0);
   break a;
  }
  d = M() | 0;
 }
 Sd(k);
 nf(j);
 yl(i);
 vh(h);
 uh(g);
 Wc(a);
 Wc(e + 76 | 0);
 P(d | 0);
 p();
}

function Gm(a, b) {
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0;
 tl(a);
 a: {
  b: {
   c: {
    f = v[b + 32 >> 2];
    d: {
     if (!f) {
      e = v[b + 2084 >> 2];
      if (e) {
       break d;
      }
      break b;
     }
     c = v[b + 4 >> 2];
     if ((c | 0) < 9) {
      break c;
     }
     e = v[b + 2084 >> 2];
     if (!e) {
      break c;
     }
    }
    h = v[a + 1392 >> 2];
    j = Fm(h);
    d = v[b + 2092 >> 2];
    c = 0;
    while (1) {
     if ((d | 0) >= 2) {
      f = d >>> 1 | 0;
      i = f + c | 0;
      g = y[(i << 2) + e >> 2] > j >>> 0;
      d = g ? f : d - f | 0;
      c = g ? c : i;
      continue;
     }
     break;
    }
    d = v[a + 1396 >> 2];
    c = w[b + 23 | 0] ? c : v[v[b + 2088 >> 2] + (c << 2) >> 2];
    b = w[c + v[b + 8 >> 2] | 0];
    e: {
     if ((d | 0) < (b | 0)) {
      c = -1;
      b = 0;
      break e;
     }
     v[a + 1392 >> 2] = h >>> b;
     b = d - b | 0;
    }
    v[a + 1396 >> 2] = b;
    return c;
   }
   if (w[b + 23 | 0]) {
    break a;
   }
   e = (c | 0) > 0 ? c : 0;
   while (1) {
    if ((d | 0) != (e | 0)) {
     f: {
      c = w[v[b + 8 >> 2] + d | 0];
      if ((c | 0) == 255) {
       break f;
      }
      g = v[a + 1392 >> 2];
      if (v[f + (d << 2) >> 2] != (g & (-1 << c ^ -1))) {
       break f;
      }
      e = v[a + 1396 >> 2];
      if ((e | 0) >= (c | 0)) {
       v[a + 1392 >> 2] = g >>> c;
       v[a + 1396 >> 2] = e - w[v[b + 8 >> 2] + d | 0];
       return d;
      }
      v[a + 1396 >> 2] = 0;
      break b;
     }
     d = d + 1 | 0;
     continue;
    }
    break;
   }
   bc(a, 21);
   v[a + 1396 >> 2] = 0;
  }
  return -1;
 }
 Z(11378, 13258, 1705, 5445);
 p();
}

function osa(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
 e = eb - 16 | 0;
 eb = e;
 d = Vh(b, c);
 n = e, o = Ab(w[a | 0] | w[a + 1 | 0] << 8), u[n + 14 >> 1] = o;
 u[e + 12 >> 1] = 64;
 eh(d, x[Nc(e + 14 | 0, e + 12 | 0) >> 1]);
 n = d, o = Ab(w[a + 14 | 0] | w[a + 15 | 0] << 8), t[n + 13 | 0] = o;
 n = d, o = Ab(w[a + 16 | 0] | w[a + 17 | 0] << 8), t[n + 14 | 0] = o;
 n = d, o = Ab(w[a + 20 | 0] | w[a + 21 | 0] << 8), t[n + 15 | 0] = o;
 n = d, o = Ab(w[a + 22 | 0] | w[a + 23 | 0] << 8), t[n + 16 | 0] = o;
 h = v[d >> 2];
 f = v[d + 4 >> 2];
 b = w[d + 12 | 0] & -2 | lc(h, f) ^ 1;
 t[d + 12 | 0] = b;
 b = b & -3 | Ab(w[a + 12 | 0] | w[a + 13 | 0] << 8) >>> 3 & 2;
 t[d + 12 | 0] = b;
 n = d, o = b & 251 | Ab(w[a + 12 | 0] | w[a + 13 | 0] << 8) >>> 3 & 4, t[n + 12 | 0] = o;
 b = 4096;
 a: {
  b: {
   switch (c - 1 | 0) {
   case 0:
    i = -128;
    b = 127;
    break a;

   case 1:
    break b;

   default:
    break a;
   }
  }
  i = -1616;
  b = 1616;
 }
 l = a + 26 | 0;
 d = b - i | 0;
 j = d >>> 1 | 0;
 m = Rd(h, f);
 b = 0;
 while (1) {
  if (b >>> 0 >= m >>> 0) {
   eb = e + 16 | 0;
  } else {
   c = xb(h, b);
   u[c >> 1] = k;
   g = l + (b << 2) | 0;
   a = ye((w[g + 2 | 0] | w[g + 3 | 0] << 8) << 16 >> 16) + i | 0;
   f = a;
   a = a >> 31 << 6 | a >>> 26;
   f = j + (f << 6) | 0;
   a = f >>> 0 < j >>> 0 ? a + 1 | 0 : a;
   n = c, o = Dh(Fc(Bua(f, a, d, 0), gb)), t[n + 2 | 0] = o;
   n = e, o = Ab(w[g | 0] | w[g + 1 | 0] << 8), u[n + 10 >> 1] = o;
   u[e + 8 >> 1] = 1;
   b = b + 1 | 0;
   k = x[qe(e + 10 | 0, e + 8 | 0) >> 1] + k | 0;
   continue;
  }
  break;
 }
}

function Wla(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, w = 0, x = 0, y = 0, z = 0;
 e = eb - 16 | 0;
 eb = e;
 f = v[a + 40 >> 2];
 g = v[a + 36 >> 2];
 l = v[a + 16 >> 2];
 k = v[a + 4 >> 2];
 v[e + 8 >> 2] = v[a >> 2];
 v[e + 12 >> 2] = k;
 m = b + 24 | 0;
 n = v[a + 32 >> 2];
 o = v[a + 28 >> 2];
 k = v[a + 8 >> 2];
 p = v[a + 12 >> 2];
 while (1) {
  if (d) {
   b = v[e + 8 >> 2];
   i = ((((v[e + 12 >> 2] & 2147483647) << 1 | b >>> 31) & 2147483646) << 1) + l | 0;
   b = (((b >>> 16 | 0) + 4 & 131064) << 1) + m | 0;
   q = u[b + 14 >> 1];
   r = u[b + 12 >> 1];
   s = u[b + 10 >> 1];
   t = u[b + 8 >> 1];
   w = u[b + 6 >> 1];
   x = u[b + 4 >> 1];
   y = u[b + 2 >> 1];
   z = u[b >> 1];
   b = 0;
   while (1) {
    if ((b | 0) != 2) {
     j = b << 1;
     h = j + i | 0;
     v[(b << 2) + e >> 2] = (((((B(u[h + 8 >> 1], s) + B(u[h + 4 >> 1], t) | 0) + B(u[h + 12 >> 1], r) | 0) + B(u[h + 16 >> 1], q) | 0) / 2 | 0) + ((((B(u[(j | -8) + i >> 1], y) + B(u[(j | -12) + i >> 1], z) | 0) + B(u[(j | -4) + i >> 1], x) | 0) + B(u[h >> 1], w) | 0) / 2 | 0) | 0) / 16384;
     b = b + 1 | 0;
     continue;
    }
    break;
   }
   g = g + o | 0;
   v[c >> 2] = v[c >> 2] + B(v[e >> 2], g >> 12);
   f = f + n | 0;
   v[c + 4 >> 2] = v[c + 4 >> 2] + B(v[e + 4 >> 2], f >> 12);
   Ob(e + 8 | 0, k, p);
   c = c + 8 | 0;
   d = d - 1 | 0;
   continue;
  }
  break;
 }
 b = v[e + 12 >> 2];
 v[a >> 2] = v[e + 8 >> 2];
 v[a + 4 >> 2] = b;
 v[a + 40 >> 2] = f;
 v[a + 20 >> 2] = g >> 12;
 v[a + 36 >> 2] = g;
 v[a + 24 >> 2] = f >> 12;
 eb = e + 16 | 0;
}

function tz(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = C(0);
 c = eb + -64 | 0;
 eb = c;
 b = v[a >> 2];
 a = v[b >> 2];
 d = v[a + 4 >> 2];
 v[c + 40 >> 2] = v[a + 20 >> 2];
 e = v[a + 16 >> 2];
 v[c + 32 >> 2] = v[a + 12 >> 2];
 v[c + 36 >> 2] = e;
 Wf(c + 48 | 0, c + 32 | 0, d);
 a = v[b + 4 >> 2];
 d = v[a + 8 >> 2];
 e = v[a + 4 >> 2];
 b = v[c + 60 >> 2];
 v[c + 24 >> 2] = v[c + 56 >> 2];
 v[c + 28 >> 2] = b;
 b = v[c + 52 >> 2];
 v[c + 16 >> 2] = v[c + 48 >> 2];
 v[c + 20 >> 2] = b;
 v[c + 8 >> 2] = v[a + 8 >> 2];
 b = v[a + 4 >> 2];
 v[c >> 2] = v[a >> 2];
 v[c + 4 >> 2] = b;
 a: {
  b: {
   c: {
    d: {
     f = v[c + 4 >> 2];
     if (f >>> 0 >= e >>> 0) {
      if (y[c + 20 >> 2] < e >>> 0) {
       break d;
      }
      if (d >>> 0 > y[c + 8 >> 2]) {
       break c;
      }
      g = v[c + 28 >> 2];
      if (d >>> 0 > v[c + 24 >> 2] - g >>> 0) {
       break b;
      }
      h = v[c + 16 >> 2];
      i = v[c >> 2];
      b = 0;
      e: while (1) {
       if ((b | 0) == (d | 0)) {
        break a;
       }
       j = (B(b, f) << 3) + i | 0;
       a = 0;
       while (1) if ((a | 0) == (e | 0)) {
        b = b + 1 | 0;
        continue e;
       } else {
        k = Ee(Ig(A[(a << 3) + j >> 3]) * 134217728);
        l = (v[(a << 2) + h >> 2] + (g << 2) | 0) + (b << 2) | 0, m = C(+(un(k) | 0) * 7.450580596923828e-9), 
        z[l >> 2] = m;
        a = a + 1 | 0;
        continue;
       }
      }
     }
     Z(7244, 9045, 77, 8725);
     p();
    }
    Z(7209, 9045, 78, 8725);
    p();
   }
   Z(5897, 9045, 79, 8725);
   p();
  }
  Z(5867, 9045, 80, 8725);
  p();
 }
 eb = c - -64 | 0;
}

function xq(a) {
 a = a | 0;
 var b = 0, c = 0, d = 0, e = 0, f = C(0), g = C(0), h = 0, i = 0, j = 0, k = 0, l = 0, m = C(0), n = 0, o = C(0);
 b = v[a + 36 >> 2];
 if (!b) {
  Mc(a + 16 | 0);
  return;
 }
 a: {
  b: {
   switch (x[a >> 1]) {
   case 3:
    c = a + 16 | 0;
    if (b >>> 0 >= 1001) {
     Mc(c);
     return;
    }
    Al(c, b);
    b = v[a + 36 >> 2] + 1 | 0;
    c = b >>> 0 <= 1 ? 1 : b;
    e = u[a + 28 >> 1];
    g = De(C(Um(a, e + 1 << 16 >> 16) / Um(a, e)), C(C(1) / C(b >>> 0)));
    a = v[a + 16 >> 2];
    b = 1;
    while (1) {
     if ((b | 0) == (c | 0)) {
      break a;
     }
     f = De(g, C(b >>> 0));
     n = xb(a, b - 1 | 0), o = f, z[n >> 2] = o;
     b = b + 1 | 0;
     continue;
    }
    ;

   case 1:
    c = a + 16 | 0;
    e = x[a + 30 >> 1];
    if (e >>> 0 > 1e3 / (b >>> 0) >>> 0) {
     Mc(c);
     return;
    }
    Al(c, B(b, e));
    h = x[a + 30 >> 1];
    j = nA(u[a + 28 >> 1], h);
    i = v[a + 36 >> 2];
    g = C(C(1) / C(i + 1 >>> 0));
    c = 0;
    c: while (1) {
     if (e >>> 0 <= (c & 65535) >>> 0) {
      break a;
     }
     b = 1;
     d = nA(c + j << 16 >> 16, h);
     f = Um(a, d + 1 << 16 >> 16);
     d = d << 16 >> 16;
     f = De(C(f / Um(a, d)), g);
     k = B(d, v[a + 36 >> 2]);
     l = v[a + 16 >> 2];
     while (1) {
      d = b & 65535;
      if (d >>> 0 > i >>> 0) {
       c = c + 1 | 0;
       continue c;
      } else {
       m = De(f, C(d >>> 0));
       n = xb(l, (d + k | 0) - 1 | 0), o = m, z[n >> 2] = o;
       b = b + 1 | 0;
       continue;
      }
     }
    }
    ;

   case 0:
    Mc(a + 16 | 0);
    return;

   default:
    break b;
   }
  }
  Mc(a + 16 | 0);
  v[a + 36 >> 2] = 0;
 }
}

function Po(a, b, c, d) {
 var e = 0, f = 0;
 e = b + 1074312 | 0;
 f = Nb(e, 120);
 t[a + 797 | 0] = f;
 t[a + 802 | 0] = f;
 u[a + 800 >> 1] = 0;
 t[a + 803 | 0] = 0;
 t[a + 804 | 0] = 0;
 t[a + 841 | 0] = 0;
 t[a + 805 | 0] = 0;
 v[a + 708 >> 2] = 0;
 v[a + 656 >> 2] = 0;
 v[a + 104 >> 2] = 0;
 v[a + 764 >> 2] = 0;
 v[a + 696 >> 2] = 0;
 v[a + 668 >> 2] = 0;
 v[a + 88 >> 2] = v[a + 88 >> 2] | 6144;
 if (Nb(e, 23)) {
  t[a + 807 | 0] = 1;
  t[a + 808 | 0] = 0;
 }
 t[a + 846 | 0] = 0;
 t[a + 839 | 0] = 0;
 u[a + 774 >> 1] = 0;
 t[a + 850 | 0] = 255;
 v[a + 660 >> 2] = 0;
 t[a + 851 | 0] = w[a + 851 | 0] & 224;
 Vo(a + 788 | 0);
 v[a + 84 >> 2] = 0;
 v[a + 76 >> 2] = 0;
 v[a + 80 >> 2] = 0;
 v[a + 700 >> 2] = 0;
 v[a + 656 >> 2] = 0;
 v[a + 104 >> 2] = 0;
 v[a + 92 >> 2] = 0;
 v[a + 96 >> 2] = 0;
 v[a >> 2] = 0;
 v[a + 4 >> 2] = 0;
 v[a + 8 >> 2] = 0;
 v[a + 12 >> 2] = 0;
 t[a + 845 | 0] = 0;
 t[a + 838 | 0] = 0;
 t[a + 821 | 0] = 0;
 v[a + 688 >> 2] = 0;
 v[a + 672 >> 2] = 0;
 v[a + 676 >> 2] = 0;
 u[a + 836 >> 1] = 32512;
 t[a + 819 | 0] = 0;
 t[a + 820 | 0] = 0;
 u[a + 842 >> 1] = 0;
 v[a + 28 >> 2] = 0;
 v[a + 32 >> 2] = 0;
 v[a + 20 >> 2] = 0;
 v[a + 24 >> 2] = 0;
 v[a + 852 >> 2] = 0;
 v[a + 856 >> 2] = 0;
 t[a + 851 | 0] = w[a + 851 | 0] & 159;
 a: {
  if (c >>> 0 <= 126) {
   b = (c << 5) + b | 0;
   c = v[b + 480280 >> 2];
   v[a + 88 >> 2] = c;
   v[a + 692 >> 2] = x[b + 480284 >> 1];
   v[a + 748 >> 2] = x[b + 480286 >> 1];
   if (!(c & 1024)) {
    break a;
   }
   v[a + 88 >> 2] = c & -1025 | d;
   break a;
  }
  v[a + 748 >> 2] = 64;
  v[a + 692 >> 2] = 128;
  v[a + 88 >> 2] = 0;
 }
 u[a + 784 >> 1] = 0;
 t[a + 795 | 0] = 0;
 t[a + 796 | 0] = 0;
}

function lra(a) {
 a = a | 0;
 var b = 0, c = 0, d = 0, e = 0, f = 0;
 e = eb - 16 | 0;
 eb = e;
 b = eb - 16 | 0;
 eb = b;
 v[b + 4 >> 2] = 1073741824;
 u[b + 10 >> 1] = 12;
 c = Dc(64);
 v[31601] = 0;
 d = Q(874, c | 0) | 0;
 f = v[31601];
 v[31601] = 0;
 a: {
  b: {
   c: {
    if ((f | 0) != 1) {
     c = xf(b, d);
     d = v[c >> 2];
     v[31601] = 0;
     N(875, d | 0, a | 0);
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) == 1) {
      break c;
     }
     a = v[c >> 2];
     v[31601] = 0;
     a = T(876, a | 0, b + 10 | 0, b + 4 | 0) | 0;
     d = v[31601];
     v[31601] = 0;
     if ((d | 0) == 1) {
      break c;
     }
     d: {
      if (!a) {
       sc(b + 12 | 0);
       break d;
      }
      a = v[c >> 2];
      v[31601] = 0;
      N(877, a | 0, 15);
      a = v[31601];
      v[31601] = 0;
      if ((a | 0) == 1) {
       break c;
      }
      re(b + 12 | 0, c);
     }
     lg(c);
     eb = b + 16 | 0;
     b = v[b + 12 >> 2];
     break a;
    }
    a = M() | 0;
    Bb(c);
    break b;
   }
   a = M() | 0;
   lg(c);
  }
  P(a | 0);
  p();
 }
 v[e + 12 >> 2] = b;
 a = 0;
 e: {
  f: {
   g: {
    while (1) {
     if ((a | 0) == 12) {
      break e;
     }
     v[31601] = 0;
     c = O(1, e | 0, (a << 2) + 30480 | 0) | 0;
     d = v[31601];
     v[31601] = 0;
     if ((d | 0) != 1) {
      v[31601] = 0;
      R(499, b | 0, a | 0, c | 0);
      d = v[31601];
      v[31601] = 0;
      if ((d | 0) == 1) {
       break g;
      }
      sb(c);
      a = a + 1 | 0;
      continue;
     }
     break;
    }
    a = M() | 0;
    break f;
   }
   a = M() | 0;
   sb(c);
  }
  lg(e + 12 | 0);
  P(a | 0);
  p();
 }
 eb = e + 16 | 0;
 return b | 0;
}

function Ila(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0;
 e = eb - 16 | 0;
 eb = e;
 p = v[a + 16 >> 2];
 q = Fg(b + 327720 | 0, v[b + 20 >> 2], (v[a + 88 >> 2] & 16384) >>> 14 | 0);
 j = v[a + 8 >> 2];
 k = v[a + 12 >> 2];
 b = v[a >> 2];
 g = v[a + 4 >> 2];
 l = v[a + 128 >> 2];
 if (l) {
  m = Gg(j, k, l);
  n = gb;
  f = v[a + 76 >> 2];
  eg(b, g, uf(j, k, d), gb);
  o = gb >>> 0 > f >>> 0 ? d : 0;
 }
 f = a + 112 | 0;
 h = v[a + 40 >> 2];
 i = v[a + 36 >> 2];
 v[e >> 2] = b;
 v[e + 4 >> 2] = g;
 a: while (1) {
  if (d) {
   d = d - 1 | 0;
   v[e + 8 >> 2] = b;
   v[e + 12 >> 2] = 0;
   o = o - 1 | 0;
   b = o;
   m = b ? m : 0;
   n = b ? n : 0;
   g = (g << 1) + p | 0;
   b = l;
   while (1) if ((b | 0) <= 0) {
    Ob(f, v[a + 120 >> 2], v[a + 124 >> 2]);
    b = v[a + 116 >> 2];
    if (b) {
     be(f, u[g + (v[e + 12 >> 2] << 1) >> 1] / 4 << 16 >> 16);
     ae(f, b);
     v[f >> 2] = v[f >> 2];
     v[f + 4 >> 2] = 0;
    }
    g = v[a + 32 >> 2];
    r = v[c >> 2];
    b = Eg(f, q);
    i = v[a + 28 >> 2] + i | 0;
    v[c >> 2] = B(b, i >> 12) + r;
    h = g + h | 0;
    v[c + 4 >> 2] = v[c + 4 >> 2] + B(b, h >> 12);
    Ob(e, j, k);
    c = c + 8 | 0;
    b = v[e >> 2];
    g = v[e + 4 >> 2];
    continue a;
   } else {
    be(f, u[g + (v[e + 12 >> 2] << 1) >> 1] / 4 << 16 >> 16);
    ae(f, 4);
    Ob(e + 8 | 0, m, n);
    b = b - 1 | 0;
    continue;
   }
  }
  break;
 }
 v[a >> 2] = b;
 v[a + 4 >> 2] = g;
 v[a + 40 >> 2] = h;
 v[a + 20 >> 2] = i >> 12;
 v[a + 36 >> 2] = i;
 v[a + 24 >> 2] = h >> 12;
 eb = e + 16 | 0;
}

function nqa(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
 e = eb - 16 | 0;
 eb = e;
 t[e + 15 | 0] = 0;
 u[e + 12 >> 1] = 0;
 j = 8;
 n = B(c, d) << 1;
 a: while (1) {
  if ((d | 0) != (k | 0)) {
   h = (k << 1) + b | 0;
   o = n + h | 0;
   while (1) {
    b: {
     c: {
      if (h >>> 0 < o >>> 0) {
       u[e + 10 >> 1] = 0;
       eY(a, e + 15 | 0, e + 12 | 0, j, e + 10 | 0);
       i = x[e + 10 >> 1];
       f = x[e + 12 >> 1];
       c = j;
       while (1) {
        if (c & 255) {
         g = f << 1;
         f = g & 254;
         d: {
          if (f) {
           g = (g & 65534) >>> 0 > 255;
           break d;
          }
          if (!Af(a, e + 9 | 0)) {
           break c;
          }
          f = w[e + 9 | 0];
          g = f >>> 7 | 0;
          f = f << 1 & 254 | 1;
         }
         c = c - 1 | 0;
         i = i << 1 | g;
         continue;
        }
        break;
       }
       u[e + 12 >> 1] = f;
       break b;
      }
      k = k + 1 | 0;
      continue a;
     }
     u[e + 12 >> 1] = 0;
    }
    c = 1;
    g = i & 65535;
    e: {
     if (g >>> 0 < 4) {
      break e;
     }
     f = 15;
     while (1) {
      c = f;
      m = f & 255;
      if (m >>> 0 < 2) {
       break e;
      }
      f = f - 1 | 0;
      if (!(g & 1 << m)) {
       continue;
      }
      break;
     }
    }
    f = i & 1;
    t[e + 15 | 0] = f;
    l = (f - 1 ^ (i & 65534) >>> 1) + l | 0;
    u[e + 10 >> 1] = l;
    u[h >> 1] = l;
    h = (d << 1) + h | 0;
    j = (c + j & 254) >>> 1 | 0;
    continue;
   }
  }
  break;
 }
 eb = e + 16 | 0;
}

function zma(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, w = 0, x = 0, y = 0;
 g = eb - 16 | 0;
 eb = g;
 o = v[a + 24 >> 2];
 p = v[a + 20 >> 2];
 f = v[a + 48 >> 2];
 e = v[a + 44 >> 2];
 q = v[a + 16 >> 2];
 b = v[a + 4 >> 2];
 v[g + 8 >> 2] = v[a >> 2];
 v[g + 12 >> 2] = b;
 r = v[a + 72 >> 2];
 l = v[a + 68 >> 2];
 s = l >> 31;
 m = v[a + 64 >> 2];
 t = m >> 31;
 n = v[a + 60 >> 2];
 w = n >> 31;
 x = v[a + 8 >> 2];
 y = v[a + 12 >> 2];
 while (1) {
  b = e;
  if (d) {
   e = Xb(e, -16777216, 16776704);
   i = Aua(m, t, e, e >> 31);
   j = gb;
   e = v[g + 8 >> 2];
   h = (v[g + 12 >> 2] << 1) + q | 0;
   e = e >>> 21 & 2040;
   h = (((B(u[h >> 1], u[e + 38050 >> 1]) + B(u[h - 2 >> 1], u[e + 38048 >> 1]) | 0) + B(u[h + 2 >> 1], u[e + 38052 >> 1]) | 0) + B(u[h + 4 >> 1], u[e + 38054 >> 1]) | 0) / 16384 << 8;
   e = h;
   e = Aua(e, e >> 31, n, w);
   i = e + i | 0;
   k = gb + j | 0;
   k = e >>> 0 > i >>> 0 ? k + 1 | 0 : k;
   f = Xb(f, -16777216, 16776704);
   e = Aua(l, s, f, f >> 31);
   j = e + i | 0;
   f = gb + k | 0;
   f = e >>> 0 > j >>> 0 ? f + 1 | 0 : f;
   e = j + 8388608 | 0;
   f = e >>> 0 < 8388608 ? f + 1 | 0 : f;
   e = Rc(e, f, 24);
   f = (e | 0) / 256 | 0;
   v[c >> 2] = B(f, p) + v[c >> 2];
   v[c + 4 >> 2] = v[c + 4 >> 2] + B(f, o);
   Ob(g + 8 | 0, x, y);
   e = e - (h & r) | 0;
   c = c + 8 | 0;
   d = d - 1 | 0;
   f = b;
   continue;
  }
  break;
 }
 c = v[g + 12 >> 2];
 v[a >> 2] = v[g + 8 >> 2];
 v[a + 4 >> 2] = c;
 v[a + 48 >> 2] = f;
 v[a + 44 >> 2] = b;
 eb = g + 16 | 0;
}

function nma(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
 f = eb - 16 | 0;
 eb = f;
 g = v[a + 12 >> 2];
 h = v[a + 8 >> 2];
 a: {
  b: {
   if ((g | 0) <= 1 & h >>> 0 <= 805306368 | (g | 0) <= 0) {
    e = 131112;
    if ((g | 0) >= -2 & h >>> 0 >= 3489660928 | (g | 0) > -2) {
     break a;
    }
    e = 262184;
    if ((g | 0) == -2 & h >>> 0 < 2147483648 | g >>> 0 < 4294967294) {
     break a;
    }
    break b;
   }
   e = 262184;
   if ((g | 0) == 1 & h >>> 0 > 2147483648 | g >>> 0 > 1) {
    break a;
   }
  }
  e = 196648;
 }
 l = v[a + 16 >> 2];
 i = v[a + 40 >> 2];
 j = v[a + 36 >> 2];
 k = v[a + 4 >> 2];
 v[f + 8 >> 2] = v[a >> 2];
 v[f + 12 >> 2] = k;
 k = b + e | 0;
 m = v[a + 32 >> 2];
 n = v[a + 28 >> 2];
 while (1) {
  if (d) {
   b = v[f + 8 >> 2];
   e = (v[f + 12 >> 2] << 1) + l | 0;
   b = (b >>> 16 & 65520) + k | 0;
   b = (((((((B(u[e - 4 >> 1], u[b + 2 >> 1]) + B(u[e - 6 >> 1], u[b >> 1]) | 0) + B(u[e - 2 >> 1], u[b + 4 >> 1]) | 0) + B(u[e >> 1], u[b + 6 >> 1]) | 0) + B(u[e + 2 >> 1], u[b + 8 >> 1]) | 0) + B(u[e + 4 >> 1], u[b + 10 >> 1]) | 0) + B(u[e + 6 >> 1], u[b + 12 >> 1]) | 0) + B(u[e + 8 >> 1], u[b + 14 >> 1]) | 0) / 32768 | 0;
   j = j + n | 0;
   v[c >> 2] = v[c >> 2] + B(b, j >> 12);
   i = i + m | 0;
   v[c + 4 >> 2] = v[c + 4 >> 2] + B(b, i >> 12);
   Ob(f + 8 | 0, h, g);
   c = c + 8 | 0;
   d = d - 1 | 0;
   continue;
  }
  break;
 }
 b = v[f + 12 >> 2];
 v[a >> 2] = v[f + 8 >> 2];
 v[a + 4 >> 2] = b;
 v[a + 40 >> 2] = i;
 v[a + 20 >> 2] = j >> 12;
 v[a + 36 >> 2] = j;
 v[a + 24 >> 2] = i >> 12;
 eb = f + 16 | 0;
}

function zi(a) {
 var b = 0, c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0;
 f = oj(a) & 2047;
 c = oj(5551115123125783e-32);
 a: {
  if (f - c >>> 0 >= oj(512) - c >>> 0) {
   if (c >>> 0 > f >>> 0) {
    return a + 1;
   }
   o(+a);
   c = j(1) | 0;
   e = j(0) | 0;
   b: {
    if (oj(1024) >>> 0 > f >>> 0) {
     break b;
    }
    b = 0;
    if (!e & (c | 0) == -1048576) {
     break a;
    }
    if (oj(Infinity) >>> 0 <= f >>> 0) {
     return a + 1;
    }
    if ((c | 0) > 0 | (c | 0) >= 0) {
     return Os(3105036184601418e216);
    }
    if (c >>> 0 < 3230714880) {
     break b;
    }
    return Os(12882297539194267e-247);
   }
   c = c << 1 | e >>> 31;
   f = !(e << 1) & (c | 0) == -2129002496 | c >>> 0 < 2165964800 ? f : 0;
  }
  b = A[177];
  g = b + a;
  a = a - (g - b);
  b = a * a;
  h = b * b * (a * A[182] + A[181]);
  b = b * (a * A[180] + A[179]);
  a = a * A[178];
  o(+g);
  j(1) | 0;
  c = j(0) | 0;
  d = c << 4 & 2032;
  a = h + (b + (a + A[d + 1464 >> 3]));
  d = d + 1472 | 0;
  e = 0 + v[d >> 2] | 0;
  d = v[d + 4 >> 2] + (c << 13) | 0;
  d = e >>> 0 < i >>> 0 ? d + 1 | 0 : d;
  if (!f) {
   c: {
    if (!(c & -2147483648)) {
     l(0, e | 0);
     l(1, d + -1048576 | 0);
     b = +n();
     a = b * a + b;
     a = a + a;
     break c;
    }
    l(0, e | 0);
    l(1, d + 1071644672 | 0);
    b = +n();
    g = b * a;
    a = g + b;
    if (a < 1) {
     hK(CK() * 22250738585072014e-324);
     h = a + 1;
     a = h + (g + (b - a) + (a + (1 - h))) + -1;
     a = a == 0 ? 0 : a;
    }
    a = a * 22250738585072014e-324;
   }
   return a;
  }
  l(0, e | 0);
  l(1, d | 0);
  b = +n();
  b = b * a + b;
 }
 return b;
}

function Ama(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, w = 0, x = 0, y = 0;
 h = eb - 16 | 0;
 eb = h;
 n = v[a + 24 >> 2];
 o = v[a + 20 >> 2];
 e = v[a + 48 >> 2];
 f = v[a + 44 >> 2];
 p = v[a + 16 >> 2];
 b = v[a + 4 >> 2];
 v[h + 8 >> 2] = v[a >> 2];
 v[h + 12 >> 2] = b;
 q = v[a + 72 >> 2];
 j = v[a + 68 >> 2];
 r = j >> 31;
 k = v[a + 64 >> 2];
 s = k >> 31;
 l = v[a + 60 >> 2];
 w = l >> 31;
 x = v[a + 8 >> 2];
 y = v[a + 12 >> 2];
 while (1) {
  b = f;
  if (d) {
   f = Xb(f, -16777216, 16776704);
   g = Aua(k, s, f, f >> 31);
   f = gb;
   e = Xb(e, -16777216, 16776704);
   e = Aua(j, r, e, e >> 31);
   g = e + g | 0;
   f = gb + f | 0;
   f = e >>> 0 > g >>> 0 ? f + 1 | 0 : f;
   e = v[h + 8 >> 2];
   i = g;
   g = v[h + 12 >> 2] + p | 0;
   e = e >>> 21 & 2040;
   m = (((B(t[g | 0], u[e + 38050 >> 1]) + B(t[g - 1 | 0], u[e + 38048 >> 1]) | 0) + B(t[g + 1 | 0], u[e + 38052 >> 1]) | 0) + B(t[g + 2 | 0], u[e + 38054 >> 1]) << 8) / 16384 << 8;
   e = m;
   g = Aua(e, e >> 31, l, w);
   i = i + g | 0;
   e = gb + f | 0;
   e = g >>> 0 > i >>> 0 ? e + 1 | 0 : e;
   f = i + 8388608 | 0;
   e = f >>> 0 < 8388608 ? e + 1 | 0 : e;
   f = Rc(f, e, 24);
   e = (f | 0) / 256 | 0;
   v[c >> 2] = B(e, o) + v[c >> 2];
   v[c + 4 >> 2] = v[c + 4 >> 2] + B(e, n);
   Ob(h + 8 | 0, x, y);
   f = f - (q & m) | 0;
   c = c + 8 | 0;
   d = d - 1 | 0;
   e = b;
   continue;
  }
  break;
 }
 c = v[h + 12 >> 2];
 v[a >> 2] = v[h + 8 >> 2];
 v[a + 4 >> 2] = c;
 v[a + 48 >> 2] = e;
 v[a + 44 >> 2] = b;
 eb = h + 16 | 0;
}

function Hf(a, b) {
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0;
 d = eb - 32 | 0;
 eb = d;
 c = v[a + 36 >> 2];
 hg(v[v[c >> 2] - 12 >> 2] + c | 0, 0);
 c = a + 32 | 0;
 Pc(d + 12 | 0, c, 4);
 if (!Fb(v[v[d + 12 >> 2] >> 2], v[d + 16 >> 2])) {
  yy(a);
 }
 a: {
  if (!v[a + 8 >> 2]) {
   break a;
  }
  Pc(d + 12 | 0, c, 6);
  if (Fb(v[v[d + 12 >> 2] >> 2], v[d + 16 >> 2])) {
   break a;
  }
  Pc(d + 24 | 0, c, 7);
  if (Fb(v[v[d + 24 >> 2] >> 2], v[d + 28 >> 2])) {
   break a;
  }
  f = v[a + 36 >> 2];
  e = v[a + 92 >> 2];
  g = B(v[a + 28 >> 2], v[a + 8 >> 2]);
  h = g;
  g = g + v[a + 88 >> 2] | 0;
  e = h >>> 0 > g >>> 0 ? e + 1 | 0 : e;
  Ci(f, g, e, 0);
 }
 Pc(d + 12 | 0, c, 5);
 c = 0;
 b: {
  if (!Fb(v[v[d + 12 >> 2] >> 2], v[d + 16 >> 2])) {
   break b;
  }
  e = ej(v[a + 52 >> 2], v[a + 56 >> 2]);
  while (1) {
   if ((e | 0) == (i | 0)) {
    break b;
   }
   c: {
    g = (v[a + 108 >> 2] + i >>> 0) % (e >>> 0) | 0;
    f = vf(v[a + 52 >> 2], g);
    h = v[f >> 2];
    j = v[a + 40 >> 2];
    if (h >>> 0 >= Sc(j, v[a + 44 >> 2]) >>> 0) {
     break c;
    }
    f = pl(d + 12 | 0, wb(j, h), x[f + 20 >> 1]);
    h = Jy(b, f);
    Db(f);
    if (!h) {
     break c;
    }
    b = g + 1 | 0;
    v[a + 108 >> 2] = (b | 0) != (e | 0) ? b : 0;
    c = vf(v[a + 52 >> 2], g);
    b = v[c + 8 >> 2];
    e = v[c + 12 >> 2];
    if (!(b | e)) {
     break b;
    }
    f = v[a + 16 >> 2];
    c = f + b | 0;
    b = v[a + 20 >> 2] + e | 0;
    Ci(v[a + 36 >> 2], c, c >>> 0 < f >>> 0 ? b + 1 | 0 : b, 0);
    c = vf(v[a + 52 >> 2], g);
    break b;
   }
   i = i + 1 | 0;
   continue;
  }
 }
 eb = d + 32 | 0;
 return c;
}

function Zoa(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0;
 c = eb - 16 | 0;
 eb = c;
 d = c + 11 | 0;
 fX(a, d);
 if ((w[c + 11 | 0] | w[c + 12 | 0] << 8 | (w[c + 13 | 0] << 16 | w[c + 14 | 0] << 24)) == 1414807888) {
  fX(a, d);
  t[b | 0] = 1;
  b = 0;
 } else {
  b = 1;
 }
 a = eb - 176 | 0;
 eb = a;
 e = a + 12 | 0;
 Yw(e, (c + 11 | 0) + b | 0);
 v[31601] = 0;
 d = a + 24 | 0;
 N(124, d | 0, e | 0);
 b = v[31601];
 v[31601] = 0;
 a: {
  b: {
   c: {
    d: {
     e: {
      if ((b | 0) != 1) {
       v[31601] = 0;
       b = O(103, a + 36 | 0, d | 0) | 0;
       g = v[31601];
       v[31601] = 0;
       if ((g | 0) == 1) {
        break e;
       }
       sb(d);
       sb(e);
       e = v[v[b >> 2] - 12 >> 2];
       v[31601] = 0;
       g = ba(104) | 0;
       f = v[31601];
       v[31601] = 0;
       if ((f | 0) == 1) {
        break c;
       }
       v[31601] = 0;
       f = a + 8 | 0;
       R(105, f | 0, b + e | 0, g | 0);
       e = v[31601];
       v[31601] = 0;
       if ((e | 0) == 1) {
        break c;
       }
       Zb(f);
       v[31601] = 0;
       u[a + 24 >> 1] = 0;
       d = O(685, b | 0, d | 0) | 0;
       e = v[31601];
       v[31601] = 0;
       if ((e | 0) == 1) {
        break c;
       }
       b = mk(v[(d + v[v[d >> 2] - 12 >> 2] | 0) + 16 >> 2]);
       e = x[a + 24 >> 1];
       Ff(d);
       eb = a + 176 | 0;
       a = (b ? 0 : e) & 65535;
       break a;
      }
      c = M() | 0;
      break d;
     }
     c = M() | 0;
     sb(a + 24 | 0);
    }
    sb(a + 12 | 0);
    break b;
   }
   c = M() | 0;
   Ff(b);
  }
  P(c | 0);
  p();
 }
 eb = c + 16 | 0;
 return a | 0;
}

function oma(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
 f = eb - 16 | 0;
 eb = f;
 g = v[a + 12 >> 2];
 h = v[a + 8 >> 2];
 a: {
  b: {
   if ((g | 0) <= 1 & h >>> 0 <= 805306368 | (g | 0) <= 0) {
    e = 131112;
    if ((g | 0) >= -2 & h >>> 0 >= 3489660928 | (g | 0) > -2) {
     break a;
    }
    e = 262184;
    if ((g | 0) == -2 & h >>> 0 < 2147483648 | g >>> 0 < 4294967294) {
     break a;
    }
    break b;
   }
   e = 262184;
   if ((g | 0) == 1 & h >>> 0 > 2147483648 | g >>> 0 > 1) {
    break a;
   }
  }
  e = 196648;
 }
 l = v[a + 16 >> 2];
 i = v[a + 40 >> 2];
 j = v[a + 36 >> 2];
 k = v[a + 4 >> 2];
 v[f + 8 >> 2] = v[a >> 2];
 v[f + 12 >> 2] = k;
 k = b + e | 0;
 m = v[a + 32 >> 2];
 n = v[a + 28 >> 2];
 while (1) {
  if (d) {
   b = v[f + 8 >> 2];
   e = v[f + 12 >> 2] + l | 0;
   b = (b >>> 16 & 65520) + k | 0;
   b = (((((((B(t[e - 2 | 0], u[b + 2 >> 1]) + B(t[e - 3 | 0], u[b >> 1]) | 0) + B(t[e - 1 | 0], u[b + 4 >> 1]) | 0) + B(t[e | 0], u[b + 6 >> 1]) | 0) + B(t[e + 1 | 0], u[b + 8 >> 1]) | 0) + B(t[e + 2 | 0], u[b + 10 >> 1]) | 0) + B(t[e + 3 | 0], u[b + 12 >> 1]) | 0) + B(t[e + 4 | 0], u[b + 14 >> 1]) << 8) / 32768 | 0;
   j = j + n | 0;
   v[c >> 2] = v[c >> 2] + B(b, j >> 12);
   i = i + m | 0;
   v[c + 4 >> 2] = v[c + 4 >> 2] + B(b, i >> 12);
   Ob(f + 8 | 0, h, g);
   c = c + 8 | 0;
   d = d - 1 | 0;
   continue;
  }
  break;
 }
 b = v[f + 12 >> 2];
 v[a >> 2] = v[f + 8 >> 2];
 v[a + 4 >> 2] = b;
 v[a + 40 >> 2] = i;
 v[a + 20 >> 2] = j >> 12;
 v[a + 36 >> 2] = j;
 v[a + 24 >> 2] = i >> 12;
 eb = f + 16 | 0;
}

function Xt(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0;
 c = eb + -64 | 0;
 eb = c;
 b = v[a >> 2];
 a = v[b >> 2];
 d = v[a + 4 >> 2];
 v[c + 40 >> 2] = v[a + 20 >> 2];
 e = v[a + 16 >> 2];
 v[c + 32 >> 2] = v[a + 12 >> 2];
 v[c + 36 >> 2] = e;
 Wf(c + 48 | 0, c + 32 | 0, d);
 a = v[b + 4 >> 2];
 d = v[a + 8 >> 2];
 e = v[a + 4 >> 2];
 b = v[c + 60 >> 2];
 v[c + 24 >> 2] = v[c + 56 >> 2];
 v[c + 28 >> 2] = b;
 b = v[c + 52 >> 2];
 v[c + 16 >> 2] = v[c + 48 >> 2];
 v[c + 20 >> 2] = b;
 v[c + 8 >> 2] = v[a + 8 >> 2];
 b = v[a + 4 >> 2];
 v[c >> 2] = v[a >> 2];
 v[c + 4 >> 2] = b;
 a: {
  b: {
   c: {
    d: {
     f = v[c + 4 >> 2];
     if (f >>> 0 >= e >>> 0) {
      g = v[c + 20 >> 2];
      if (g >>> 0 < e >>> 0) {
       break d;
      }
      if (d >>> 0 > y[c + 8 >> 2]) {
       break c;
      }
      h = v[c + 28 >> 2];
      if (d >>> 0 > v[c + 24 >> 2] - h >>> 0) {
       break b;
      }
      j = v[c + 16 >> 2];
      k = v[c >> 2];
      b = 0;
      e: while (1) {
       if ((b | 0) == (d | 0)) {
        break a;
       }
       l = (B(b, f) << 2) + k | 0;
       m = (B(b + h | 0, g) << 2) + j | 0;
       a = 0;
       while (1) if ((a | 0) == (e | 0)) {
        b = b + 1 | 0;
        continue e;
       } else {
        i = a << 2;
        z[i + m >> 2] = C(v[l + i >> 2]) * C(7.450580596923828e-9);
        a = a + 1 | 0;
        continue;
       }
      }
     }
     Z(7244, 9045, 33, 8758);
     p();
    }
    Z(7209, 9045, 34, 8758);
    p();
   }
   Z(5897, 9045, 35, 8758);
   p();
  }
  Z(5867, 9045, 36, 8758);
  p();
 }
 eb = c - -64 | 0;
}

function nja(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0;
 d = eb - 16 | 0;
 eb = d;
 md(c, 0);
 u[d + 14 >> 1] = w[a + 36 | 0] | w[a + 37 | 0] << 8;
 u[d + 12 >> 1] = 32767;
 g = c, h = (x[Nc(d + 14 | 0, d + 12 | 0) >> 1] << 8 >>> 0) / 32767 | 0, u[g + 28 >> 1] = h;
 u[d + 10 >> 1] = w[a + 38 | 0] | w[a + 39 | 0] << 8;
 u[d + 8 >> 1] = 32767;
 g = c, h = (x[Nc(d + 10 | 0, d + 8 | 0) >> 1] << 8 >>> 0) / 32767 | 0, u[g + 30 >> 1] = h;
 u[c + 32 >> 1] = 64;
 v[c >> 2] = w[a + 44 | 0] | w[a + 45 | 0] << 8 | (w[a + 46 | 0] << 16 | w[a + 47 | 0] << 24);
 v[c + 4 >> 2] = w[a + 48 | 0] | w[a + 49 | 0] << 8 | (w[a + 50 | 0] << 16 | w[a + 51 | 0] << 24);
 v[c + 8 >> 2] = w[a + 52 | 0] | w[a + 53 | 0] << 8 | (w[a + 54 | 0] << 16 | w[a + 55 | 0] << 24);
 v[c + 24 >> 2] = w[a + 56 | 0] | w[a + 57 | 0] << 8 | (w[a + 58 | 0] << 16 | w[a + 59 | 0] << 24);
 e = w[b + 166 | 0];
 if (e >>> 0 <= 4) {
  t[c + 38 | 0] = w[e + 41082 | 0];
 }
 e = w[b + 167 | 0] | w[b + 168 | 0] << 8;
 t[c + 39 | 0] = e;
 f = (w[b + 171 | 0] | w[b + 172 | 0] << 8) >>> 4 | 0;
 t[c + 41 | 0] = f;
 b = (w[b + 169 | 0] | w[b + 170 | 0] << 8) >>> 2 | 0;
 t[c + 40 | 0] = b;
 if ((b | f) & 255) {
  t[c + 39 | 0] = e ^ -1;
 }
 b = w[a + 40 | 0] | w[a + 41 | 0] << 8;
 if (b & 4) {
  u[c + 34 >> 1] = x[c + 34 >> 1] | 1;
  b = w[a + 40 | 0] | w[a + 41 | 0] << 8;
 }
 if (b & 8) {
  u[c + 34 >> 1] = x[c + 34 >> 1] | 2;
  b = w[a + 40 | 0] | w[a + 41 | 0] << 8;
 }
 if (b & 16) {
  u[c + 34 >> 1] = x[c + 34 >> 1] | 4;
  b = w[a + 40 | 0] | w[a + 41 | 0] << 8;
 }
 if (b & 32) {
  u[c + 34 >> 1] = x[c + 34 >> 1] | 32;
 }
 eb = d + 16 | 0;
}

function Xla(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, w = 0, x = 0, y = 0, z = 0;
 e = eb - 16 | 0;
 eb = e;
 g = v[a + 40 >> 2];
 h = v[a + 36 >> 2];
 k = v[a + 16 >> 2];
 j = v[a + 4 >> 2];
 v[e + 8 >> 2] = v[a >> 2];
 v[e + 12 >> 2] = j;
 l = b + 24 | 0;
 m = v[a + 32 >> 2];
 n = v[a + 28 >> 2];
 j = v[a + 8 >> 2];
 o = v[a + 12 >> 2];
 while (1) {
  if (d) {
   b = v[e + 8 >> 2];
   p = (((v[e + 12 >> 2] & 2147483647) << 1 | b >>> 31) & -2) + k | 0;
   b = (((b >>> 16 | 0) + 4 & 131064) << 1) + l | 0;
   q = u[b + 10 >> 1] << 8;
   r = u[b + 8 >> 1] << 8;
   s = u[b + 12 >> 1] << 8;
   w = u[b + 14 >> 1] << 8;
   x = u[b + 2 >> 1] << 8;
   y = u[b >> 1] << 8;
   z = u[b + 4 >> 1] << 8;
   b = u[b + 6 >> 1] << 8;
   i = 0;
   while (1) {
    if ((i | 0) != 2) {
     f = i + p | 0;
     v[(i << 2) + e >> 2] = ((((B(t[f + 4 | 0], q) + B(t[f + 2 | 0], r) | 0) + B(t[f + 6 | 0], s) | 0) + B(t[f + 8 | 0], w) >> 1) + (((B(t[f - 4 | 0], x) + B(t[f - 6 | 0], y) | 0) + B(t[f - 2 | 0], z) | 0) + B(t[f | 0], b) >> 1) | 0) / 16384;
     i = i + 1 | 0;
     continue;
    }
    break;
   }
   h = h + n | 0;
   v[c >> 2] = v[c >> 2] + B(v[e >> 2], h >> 12);
   g = g + m | 0;
   v[c + 4 >> 2] = v[c + 4 >> 2] + B(v[e + 4 >> 2], g >> 12);
   Ob(e + 8 | 0, j, o);
   c = c + 8 | 0;
   d = d - 1 | 0;
   continue;
  }
  break;
 }
 b = v[e + 12 >> 2];
 v[a >> 2] = v[e + 8 >> 2];
 v[a + 4 >> 2] = b;
 v[a + 40 >> 2] = g;
 v[a + 20 >> 2] = h >> 12;
 v[a + 36 >> 2] = h;
 v[a + 24 >> 2] = g >> 12;
 eb = e + 16 | 0;
}

function Ffa(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0;
 e = eb - 32 | 0;
 eb = e;
 v[31601] = 0;
 V(995, a | 0);
 d = v[31601];
 v[31601] = 0;
 a: {
  b: {
   c: {
    d: {
     e: {
      f: {
       g: {
        if ((d | 0) == 1) {
         break g;
        }
        v[31601] = 0;
        V(996, b | 0);
        d = v[31601];
        v[31601] = 0;
        if ((d | 0) == 1) {
         break g;
        }
        v[31601] = 0;
        V(996, c | 0);
        d = v[31601];
        v[31601] = 0;
        if ((d | 0) == 1) {
         break g;
        }
        f = v[a + 24 >> 2];
        v[31601] = 0;
        d = O(36, e + 20 | 0, b | 0) | 0;
        b = v[31601];
        v[31601] = 0;
        if ((b | 0) == 1) {
         break g;
        }
        v[31601] = 0;
        c = O(36, e + 8 | 0, c | 0) | 0;
        b = v[31601];
        v[31601] = 0;
        if ((b | 0) == 1) {
         break f;
        }
        v[31601] = 0;
        U(1011, f | 0, d | 0, c | 0, 1);
        b = v[31601];
        v[31601] = 0;
        if ((b | 0) == 1) {
         break e;
        }
        sb(c);
        sb(d);
        b = 1;
        break b;
       }
       b = S(0) | 0;
       break c;
      }
      b = S(0) | 0;
      break d;
     }
     b = S(0) | 0;
     sb(c);
    }
    sb(d);
   }
   X(b | 0) | 0;
   b = 0;
   v[31601] = 0;
   U(982, 6409, a | 0, 0, 0);
   a = v[31601];
   v[31601] = 0;
   if ((a | 0) == 1) {
    break a;
   }
   Y();
  }
  eb = e + 32 | 0;
  return b | 0;
 }
 a = M() | 0;
 v[31601] = 0;
 W(26);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  P(a | 0);
  p();
 }
 S(0) | 0;
 Rb();
 p();
}

function mqa(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
 e = eb - 16 | 0;
 eb = e;
 t[e + 15 | 0] = 0;
 u[e + 12 >> 1] = 0;
 n = B(c, d);
 j = 4;
 a: while (1) {
  if ((d | 0) != (k | 0)) {
   h = b + k | 0;
   o = n + h | 0;
   while (1) {
    b: {
     c: {
      if (h >>> 0 < o >>> 0) {
       t[e + 11 | 0] = 0;
       dY(a, e + 15 | 0, e + 12 | 0, e + 11 | 0);
       i = w[e + 11 | 0];
       f = x[e + 12 >> 1];
       c = j;
       while (1) {
        if (c & 255) {
         g = f << 1;
         f = g & 254;
         d: {
          if (f) {
           g = (g & 65534) >>> 0 > 255;
           break d;
          }
          if (!Af(a, e + 10 | 0)) {
           break c;
          }
          f = w[e + 10 | 0];
          g = f >>> 7 | 0;
          f = f << 1 & 254 | 1;
         }
         c = c - 1 | 0;
         i = i << 1 | g;
         continue;
        }
        break;
       }
       u[e + 12 >> 1] = f;
       break b;
      }
      k = k + 1 | 0;
      continue a;
     }
     u[e + 12 >> 1] = 0;
    }
    c = 1;
    g = i & 255;
    e: {
     if (g >>> 0 < 4) {
      break e;
     }
     f = 7;
     while (1) {
      c = f;
      m = f & 255;
      if (m >>> 0 < 2) {
       break e;
      }
      f = f - 1 | 0;
      if (!(g & 1 << m)) {
       continue;
      }
      break;
     }
    }
    f = i & 1;
    t[e + 15 | 0] = f;
    l = (f - 1 ^ (i & 254) >>> 1) + l | 0;
    t[e + 11 | 0] = l;
    t[h | 0] = l;
    h = d + h | 0;
    j = (c + j & 254) >>> 1 | 0;
    continue;
   }
  }
  break;
 }
 eb = e + 16 | 0;
}

function Fx(a, b, c, d) {
 var e = 0, f = 0, g = 0, h = 0;
 g = eb - 32 | 0;
 eb = g;
 e = d & 2147483647;
 h = e;
 f = e - 1006698496 | 0;
 e = e - 1140785152 | 0;
 a: {
  if ((f | 0) == (e | 0) & 0 | e >>> 0 > f >>> 0) {
   e = c << 4 | b >>> 28;
   c = d << 4 | c >>> 28;
   b = b & 268435455;
   if ((b | 0) == 134217728 & (a | 0) != 0 | b >>> 0 > 134217728) {
    f = c + 1073741824 | 0;
    e = e + 1 | 0;
    f = e ? f : f + 1 | 0;
    break a;
   }
   f = c + 1073741824 | 0;
   if (a | (b | 0) != 134217728) {
    break a;
   }
   a = e & 1;
   e = a + e | 0;
   f = a >>> 0 > e >>> 0 ? f + 1 | 0 : f;
   break a;
  }
  if (!(!c & (h | 0) == 2147418112 ? !(a | b) : h >>> 0 < 2147418112)) {
   a = d << 4 | c >>> 28;
   e = c << 4 | b >>> 28;
   f = a & 524287 | 2146959360;
   break a;
  }
  e = 0;
  f = 2146435072;
  if (h >>> 0 > 1140785151) {
   break a;
  }
  f = 0;
  h = h >>> 16 | 0;
  if (h >>> 0 < 15249) {
   break a;
  }
  e = d & 65535 | 65536;
  _f(g + 16 | 0, a, b, c, e, h - 15233 | 0);
  bn(g, a, b, c, e, 15361 - h | 0);
  b = v[g + 8 >> 2];
  e = b << 4;
  b = v[g + 12 >> 2] << 4 | b >>> 28;
  c = v[g >> 2];
  f = v[g + 4 >> 2];
  h = f;
  e = f >>> 28 | e;
  f = b;
  a = h & 268435455;
  b = c | (v[g + 16 >> 2] | v[g + 24 >> 2] | (v[g + 20 >> 2] | v[g + 28 >> 2])) != 0;
  if ((a | 0) == 134217728 & (b | 0) != 0 | a >>> 0 > 134217728) {
   e = e + 1 | 0;
   f = e ? f : f + 1 | 0;
   break a;
  }
  if (b | (a | 0) != 134217728) {
   break a;
  }
  a = e;
  e = e + (e & 1) | 0;
  f = a >>> 0 > e >>> 0 ? f + 1 | 0 : f;
 }
 eb = g + 32 | 0;
 l(0, e | 0);
 l(1, d & -2147483648 | f);
 return +n();
}

function Jla(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0;
 e = eb - 16 | 0;
 eb = e;
 p = v[a + 16 >> 2];
 q = Fg(b + 327720 | 0, v[b + 20 >> 2], (v[a + 88 >> 2] & 16384) >>> 14 | 0);
 j = v[a + 8 >> 2];
 k = v[a + 12 >> 2];
 b = v[a >> 2];
 g = v[a + 4 >> 2];
 l = v[a + 128 >> 2];
 if (l) {
  m = Gg(j, k, l);
  n = gb;
  f = v[a + 76 >> 2];
  eg(b, g, uf(j, k, d), gb);
  o = gb >>> 0 > f >>> 0 ? d : 0;
 }
 f = a + 112 | 0;
 h = v[a + 40 >> 2];
 i = v[a + 36 >> 2];
 v[e >> 2] = b;
 v[e + 4 >> 2] = g;
 a: while (1) {
  if (d) {
   d = d - 1 | 0;
   v[e + 8 >> 2] = b;
   v[e + 12 >> 2] = 0;
   o = o - 1 | 0;
   b = o;
   m = b ? m : 0;
   n = b ? n : 0;
   g = g + p | 0;
   b = l;
   while (1) if ((b | 0) <= 0) {
    Ob(f, v[a + 120 >> 2], v[a + 124 >> 2]);
    b = v[a + 116 >> 2];
    if (b) {
     be(f, t[g + v[e + 12 >> 2] | 0] << 6);
     ae(f, b);
     v[f >> 2] = v[f >> 2];
     v[f + 4 >> 2] = 0;
    }
    g = v[a + 32 >> 2];
    r = v[c >> 2];
    b = Eg(f, q);
    i = v[a + 28 >> 2] + i | 0;
    v[c >> 2] = B(b, i >> 12) + r;
    h = g + h | 0;
    v[c + 4 >> 2] = v[c + 4 >> 2] + B(b, h >> 12);
    Ob(e, j, k);
    c = c + 8 | 0;
    b = v[e >> 2];
    g = v[e + 4 >> 2];
    continue a;
   } else {
    be(f, t[g + v[e + 12 >> 2] | 0] << 6);
    ae(f, 4);
    Ob(e + 8 | 0, m, n);
    b = b - 1 | 0;
    continue;
   }
  }
  break;
 }
 v[a >> 2] = b;
 v[a + 4 >> 2] = g;
 v[a + 40 >> 2] = h;
 v[a + 20 >> 2] = i >> 12;
 v[a + 36 >> 2] = i;
 v[a + 24 >> 2] = h >> 12;
 eb = e + 16 | 0;
}

function bba(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0;
 if (y[a + 4 >> 2] < y[zb(a) >> 2]) {
  d = eb - 16 | 0;
  eb = d;
  c = d + 4 | 0;
  v[c >> 2] = a;
  a = v[a + 4 >> 2];
  v[c + 4 >> 2] = a;
  v[c + 8 >> 2] = a + 24;
  _M(v[c + 4 >> 2], b);
  v[c + 4 >> 2] = v[c + 4 >> 2] + 24;
  hc(c);
  eb = d + 16 | 0;
  return;
 }
 i = eb - 32 | 0;
 eb = i;
 c = zb(a);
 c = GJ(i + 12 | 0, IJ(a, ej(v[a >> 2], v[a + 4 >> 2]) + 1 | 0), ej(v[a >> 2], v[a + 4 >> 2]), c);
 _M(v[c + 8 >> 2], b);
 v[c + 8 >> 2] = v[c + 8 >> 2] + 24;
 g = eb - 16 | 0;
 eb = g;
 d = ub(g + 12 | 0, v[a + 4 >> 2]);
 e = ub(g + 8 | 0, v[a >> 2]);
 f = v[ub(g + 4 | 0, v[c + 4 >> 2]) >> 2];
 h = eb - 16 | 0;
 eb = h;
 b = eb - 32 | 0;
 eb = b;
 ed(b + 24 | 0, v[d >> 2], v[e >> 2]);
 k = b + 16 | 0;
 e = v[b + 24 >> 2];
 l = v[b + 28 >> 2];
 d = eb - 16 | 0;
 eb = d;
 v[d + 8 >> 2] = f;
 v[d + 12 >> 2] = e;
 while (1) {
  if (Ed(e, l)) {
   e = gl(e);
   f = gl(v[d + 8 >> 2]);
   v[f + 16 >> 2] = v[e + 16 >> 2];
   j = v[e + 12 >> 2];
   v[f + 8 >> 2] = v[e + 8 >> 2];
   v[f + 12 >> 2] = j;
   j = v[e + 4 >> 2];
   v[f >> 2] = v[e >> 2];
   v[f + 4 >> 2] = j;
   e = gt(d + 12 | 0);
   gt(d + 8 | 0);
   e = v[e >> 2];
   continue;
  }
  break;
 }
 pc(k, e, d + 8 | 0);
 eb = d + 16 | 0;
 d = v[b + 16 >> 2];
 v[b + 12 >> 2] = v[b + 20 >> 2];
 pc(h + 8 | 0, d, b + 12 | 0);
 eb = b + 32 | 0;
 eb = h + 16 | 0;
 v[c + 4 >> 2] = v[h + 12 >> 2];
 Sb(a, c + 4 | 0);
 Sb(a + 4 | 0, c + 8 | 0);
 Sb(zb(a), mc(c));
 v[c >> 2] = v[c + 4 >> 2];
 eb = g + 16 | 0;
 DJ(c);
 eb = i + 32 | 0;
}

function Raa(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0;
 d = eb + -64 | 0;
 eb = d;
 a = v[a + 4 >> 2];
 g = d + 16 | 0;
 vx(g, b);
 v[31601] = 0;
 b = O(1, d + 4 | 0, 18371) | 0;
 e = v[31601];
 v[31601] = 0;
 a: {
  b: {
   c: {
    d: {
     e: {
      f: {
       g: {
        h: {
         if ((e | 0) != 1) {
          v[31601] = 0;
          e = d + 28 | 0;
          R(2, e | 0, g | 0, b | 0);
          f = v[31601];
          v[31601] = 0;
          if ((f | 0) == 1) {
           break h;
          }
          v[31601] = 0;
          f = d + 40 | 0;
          R(489, f | 0, e | 0, c | 0);
          c = v[31601];
          v[31601] = 0;
          if ((c | 0) == 1) {
           break g;
          }
          v[31601] = 0;
          c = d + 52 | 0;
          N(1058, c | 0, f | 0);
          h = v[31601];
          v[31601] = 0;
          if ((h | 0) == 1) {
           break f;
          }
          h = v[v[a >> 2] + 8 >> 2];
          v[31601] = 0;
          N(h | 0, a | 0, c | 0);
          a = v[31601];
          v[31601] = 0;
          if ((a | 0) == 1) {
           break e;
          }
          sb(c);
          sb(f);
          sb(e);
          sb(b);
          sb(g);
          eb = d - -64 | 0;
          return;
         }
         a = M() | 0;
         break a;
        }
        a = M() | 0;
        break b;
       }
       a = M() | 0;
       break c;
      }
      a = M() | 0;
      break d;
     }
     a = M() | 0;
     sb(d + 52 | 0);
    }
    sb(d + 40 | 0);
   }
   sb(d + 28 | 0);
  }
  sb(b);
 }
 sb(d + 16 | 0);
 P(a | 0);
 p();
}

function Yt(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0;
 c = eb + -64 | 0;
 eb = c;
 b = v[a >> 2];
 a = v[b >> 2];
 d = v[a + 4 >> 2];
 v[c + 40 >> 2] = v[a + 20 >> 2];
 e = v[a + 16 >> 2];
 v[c + 32 >> 2] = v[a + 12 >> 2];
 v[c + 36 >> 2] = e;
 Wf(c + 48 | 0, c + 32 | 0, d);
 a = v[b + 4 >> 2];
 d = v[a + 8 >> 2];
 e = v[a + 4 >> 2];
 b = v[c + 60 >> 2];
 v[c + 24 >> 2] = v[c + 56 >> 2];
 v[c + 28 >> 2] = b;
 b = v[c + 52 >> 2];
 v[c + 16 >> 2] = v[c + 48 >> 2];
 v[c + 20 >> 2] = b;
 v[c + 8 >> 2] = v[a + 8 >> 2];
 b = v[a + 4 >> 2];
 v[c >> 2] = v[a >> 2];
 v[c + 4 >> 2] = b;
 a: {
  b: {
   c: {
    d: {
     f = v[c + 4 >> 2];
     if (f >>> 0 >= e >>> 0) {
      if (y[c + 20 >> 2] < e >>> 0) {
       break d;
      }
      if (d >>> 0 > y[c + 8 >> 2]) {
       break c;
      }
      g = v[c + 28 >> 2];
      if (d >>> 0 > v[c + 24 >> 2] - g >>> 0) {
       break b;
      }
      i = v[c + 16 >> 2];
      j = v[c >> 2];
      b = 0;
      e: while (1) {
       if ((b | 0) == (d | 0)) {
        break a;
       }
       k = (B(b, f) << 2) + j | 0;
       a = 0;
       while (1) if ((a | 0) == (e | 0)) {
        b = b + 1 | 0;
        continue e;
       } else {
        h = a << 2;
        z[(v[h + i >> 2] + (g << 2) | 0) + (b << 2) >> 2] = C(v[k + h >> 2]) * C(7.450580596923828e-9);
        a = a + 1 | 0;
        continue;
       }
      }
     }
     Z(7244, 9045, 33, 8758);
     p();
    }
    Z(7209, 9045, 34, 8758);
    p();
   }
   Z(5897, 9045, 35, 8758);
   p();
  }
  Z(5867, 9045, 36, 8758);
  p();
 }
 eb = c - -64 | 0;
}

function uaa(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0;
 c = eb + -64 | 0;
 eb = c;
 b = v[a >> 2];
 a = v[b >> 2];
 d = v[a + 4 >> 2];
 v[c + 40 >> 2] = v[a + 20 >> 2];
 e = v[a + 16 >> 2];
 v[c + 32 >> 2] = v[a + 12 >> 2];
 v[c + 36 >> 2] = e;
 Wf(c + 48 | 0, c + 32 | 0, d);
 a = v[b + 4 >> 2];
 d = v[a + 8 >> 2];
 e = v[a + 4 >> 2];
 b = v[c + 60 >> 2];
 v[c + 24 >> 2] = v[c + 56 >> 2];
 v[c + 28 >> 2] = b;
 b = v[c + 52 >> 2];
 v[c + 16 >> 2] = v[c + 48 >> 2];
 v[c + 20 >> 2] = b;
 v[c + 8 >> 2] = v[a + 8 >> 2];
 b = v[a + 4 >> 2];
 v[c >> 2] = v[a >> 2];
 v[c + 4 >> 2] = b;
 a: {
  b: {
   c: {
    d: {
     f = v[c + 4 >> 2];
     if (f >>> 0 >= e >>> 0) {
      g = v[c + 20 >> 2];
      if (g >>> 0 < e >>> 0) {
       break d;
      }
      if (d >>> 0 > y[c + 8 >> 2]) {
       break c;
      }
      h = v[c + 28 >> 2];
      if (d >>> 0 > v[c + 24 >> 2] - h >>> 0) {
       break b;
      }
      i = v[c + 16 >> 2];
      j = v[c >> 2];
      b = 0;
      e: while (1) {
       if ((b | 0) == (d | 0)) {
        break a;
       }
       k = (B(b, f) << 3) + j | 0;
       l = (B(b + h | 0, g) << 2) + i | 0;
       a = 0;
       while (1) if ((a | 0) == (e | 0)) {
        b = b + 1 | 0;
        continue e;
       } else {
        z[(a << 2) + l >> 2] = A[(a << 3) + k >> 3];
        a = a + 1 | 0;
        continue;
       }
      }
     }
     Z(7244, 9045, 77, 8725);
     p();
    }
    Z(7209, 9045, 78, 8725);
    p();
   }
   Z(5897, 9045, 79, 8725);
   p();
  }
  Z(5867, 9045, 80, 8725);
  p();
 }
 eb = c - -64 | 0;
}

function h3(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0;
 d = eb - 16 | 0;
 eb = d;
 f = Mb(a);
 a = 0;
 a: {
  b: {
   c: {
    while (1) {
     if ((Rx(b, c, a) | 0) == -1) {
      break b;
     }
     g = Rx(b, c, a);
     v[31601] = 0;
     e = d + 4 | 0;
     U(100, e | 0, b | 0, a | 0, g - a | 0);
     g = v[31601];
     v[31601] = 0;
     if ((g | 0) != 1) {
      v[31601] = 0;
      N(101, f | 0, e | 0);
      g = v[31601];
      v[31601] = 0;
      if ((g | 0) == 1) {
       break c;
      }
      sb(e);
      a = Rx(b, c, a) + Zc(v[c + 4 >> 2], w[c + 11 | 0]) | 0;
      continue;
     }
     break;
    }
    a = M() | 0;
    break a;
   }
   a = M() | 0;
   sb(d + 4 | 0);
   break a;
  }
  d: {
   e: {
    f: {
     g: {
      if (lc(v[f >> 2], v[f + 4 >> 2])) {
       v[31601] = 0;
       c = d + 4 | 0;
       U(100, c | 0, b | 0, a | 0, -1);
       e = v[31601];
       v[31601] = 0;
       if ((e | 0) == 1) {
        break f;
       }
       e = Zc(v[d + 8 >> 2], w[d + 15 | 0]);
       sb(c);
       if (!e) {
        break g;
       }
      }
      v[31601] = 0;
      c = d + 4 | 0;
      U(100, c | 0, b | 0, a | 0, -1);
      a = v[31601];
      v[31601] = 0;
      if ((a | 0) == 1) {
       break e;
      }
      v[31601] = 0;
      N(101, f | 0, c | 0);
      a = v[31601];
      v[31601] = 0;
      if ((a | 0) == 1) {
       break d;
      }
      sb(c);
     }
     eb = d + 16 | 0;
     return;
    }
    a = M() | 0;
    break a;
   }
   a = M() | 0;
   break a;
  }
  a = M() | 0;
  sb(d + 4 | 0);
 }
 Sd(f);
 P(a | 0);
 p();
}

function Qja(a) {
 a = a | 0;
 var b = 0, c = 0, d = 0, e = 0, f = 0, g = 0, h = 0;
 b = eb - 48 | 0;
 eb = b;
 e = Mb(a);
 a = 0;
 a: {
  while (1) {
   b: {
    if ((a | 0) == 432) {
     a = 0;
     break b;
    }
    c = a + 30532 | 0;
    g = oc(b + 40 | 0, v[c >> 2]);
    d = v[b + 44 >> 2];
    c: {
     if (!d) {
      break c;
     }
     f = v[e + 4 >> 2];
     if (!lc(v[e >> 2], f)) {
      g = v[g >> 2];
      f = oc(b + 32 | 0, v[wf(f) >> 2]);
      h = v[f + 4 >> 2];
      v[b + 8 >> 2] = v[f >> 2];
      v[b + 12 >> 2] = h;
      if (Hc(g, d, b + 8 | 0)) {
       break c;
      }
     }
     v[31601] = 0;
     N(885, e | 0, c | 0);
     c = v[31601];
     v[31601] = 0;
     if ((c | 0) == 1) {
      break a;
     }
    }
    a = a + 8 | 0;
    continue;
   }
   break;
  }
  d: {
   while (1) {
    if ((a | 0) == 48) {
     break d;
    }
    c = oc(b + 40 | 0, v[a + 30968 >> 2]);
    e: {
     g = v[b + 44 >> 2];
     f: {
      if (!g) {
       break f;
      }
      d = v[e + 4 >> 2];
      if (!lc(v[e >> 2], d)) {
       f = v[c >> 2];
       d = oc(b + 24 | 0, v[wf(d) >> 2]);
       h = v[d + 4 >> 2];
       v[b >> 2] = v[d >> 2];
       v[b + 4 >> 2] = h;
       if (Hc(f, g, b)) {
        break f;
       }
      }
      c = v[c >> 2];
      v[31601] = 0;
      v[b + 20 >> 2] = c;
      N(886, e | 0, b + 20 | 0);
      c = v[31601];
      v[31601] = 0;
      if ((c | 0) == 1) {
       break e;
      }
     }
     a = a + 12 | 0;
     continue;
    }
    break;
   }
   break a;
  }
  eb = b + 48 | 0;
  return;
 }
 a = M() | 0;
 uc(e);
 P(a | 0);
 p();
}

function F2() {
 var a = 0, b = 0, c = 0, d = 0;
 d = eb - 32 | 0;
 eb = d;
 a: {
  a = Cc(d + 20 | 0, 14962);
  if (!Zc(v[a + 4 >> 2], w[a + 11 | 0])) {
   break a;
  }
  b: {
   if ((Sg(a, 14629) | 0) != -1) {
    b = Sg(a, 14629);
    v[31601] = 0;
    c = d + 8 | 0;
    U(121, c | 0, a | 0, b + 1 | 0, -1);
    b = v[31601];
    v[31601] = 0;
    if ((b | 0) == 1) {
     break b;
    }
    yb(a, c);
    sb(c);
   }
   if ((Sg(a, 16798) | 0) != -1) {
    b = Sg(a, 16798);
    v[31601] = 0;
    c = d + 8 | 0;
    U(121, c | 0, a | 0, b + 1 | 0, -1);
    b = v[31601];
    v[31601] = 0;
    if ((b | 0) == 1) {
     break b;
    }
    yb(a, c);
    sb(c);
   }
   if ((Sg(a, 13898) | 0) != -1) {
    b = Sg(a, 13898);
    v[31601] = 0;
    c = d + 8 | 0;
    U(121, c | 0, a | 0, 0, b | 0);
    b = v[31601];
    v[31601] = 0;
    if ((b | 0) == 1) {
     break b;
    }
    yb(a, c);
    sb(c);
   }
   if ((Sg(a, 13773) | 0) != -1) {
    b = Sg(a, 13773);
    v[31601] = 0;
    c = d + 8 | 0;
    U(121, c | 0, a | 0, 0, b | 0);
    b = v[31601];
    v[31601] = 0;
    if ((b | 0) == 1) {
     break b;
    }
    yb(a, c);
    sb(c);
   }
   if ((Sg(a, 13816) | 0) != -1) {
    b = Sg(a, 13816);
    v[31601] = 0;
    c = d + 8 | 0;
    U(121, c | 0, a | 0, 0, b | 0);
    b = v[31601];
    v[31601] = 0;
    if ((b | 0) == 1) {
     break b;
    }
    yb(a, c);
    sb(c);
   }
   v[31601] = 0;
   c = Q(122, a | 0) | 0;
   b = v[31601];
   v[31601] = 0;
   if ((b | 0) != 1) {
    break a;
   }
  }
  d = M() | 0;
  sb(a);
  P(d | 0);
  p();
 }
 sb(a);
 eb = d + 32 | 0;
 return c | 0;
}

function sK(a, b, c, d) {
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
 i = eb - 32 | 0;
 eb = i;
 a: {
  b: {
   c: {
    if ((b | 0) != (c | 0)) {
     k = v[31476];
     v[31476] = 0;
     g = eb - 16 | 0;
     eb = g;
     Nd();
     f = eb - 16 | 0;
     eb = f;
     e = eb - 16 | 0;
     eb = e;
     _x(e, b, i + 28 | 0, 2);
     h = v[e >> 2];
     j = v[e + 4 >> 2];
     b = f;
     f = v[e + 12 >> 2];
     v[b + 8 >> 2] = v[e + 8 >> 2];
     v[b + 12 >> 2] = f;
     v[b >> 2] = h;
     v[b + 4 >> 2] = j;
     eb = e + 16 | 0;
     f = v[b >> 2];
     h = v[b + 4 >> 2];
     e = g;
     g = v[b + 12 >> 2];
     v[e + 8 >> 2] = v[b + 8 >> 2];
     v[e + 12 >> 2] = g;
     v[e >> 2] = f;
     v[e + 4 >> 2] = h;
     eb = b + 16 | 0;
     g = v[e >> 2];
     f = v[e + 4 >> 2];
     h = v[e + 12 >> 2];
     b = i;
     v[b + 16 >> 2] = v[e + 8 >> 2];
     v[b + 20 >> 2] = h;
     v[b + 8 >> 2] = g;
     v[b + 12 >> 2] = f;
     eb = e + 16 | 0;
     e = v[b + 16 >> 2];
     f = v[b + 20 >> 2];
     g = v[b + 8 >> 2];
     h = v[b + 12 >> 2];
     j = v[31476];
     if (!j) {
      break c;
     }
     if (v[b + 28 >> 2] != (c | 0)) {
      break b;
     }
     l = g;
     m = h;
     n = e;
     o = f;
     if ((j | 0) != 68) {
      break a;
     }
     break b;
    }
    v[d >> 2] = 4;
    break a;
   }
   v[31476] = k;
   if (v[i + 28 >> 2] == (c | 0)) {
    break a;
   }
  }
  v[d >> 2] = 4;
  g = l;
  h = m;
  e = n;
  f = o;
 }
 v[a >> 2] = g;
 v[a + 4 >> 2] = h;
 v[a + 8 >> 2] = e;
 v[a + 12 >> 2] = f;
 eb = i + 32 | 0;
}

function TH(a, b, c) {
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0;
 d = eb - 32 | 0;
 eb = d;
 v[31601] = 0;
 V(995, a | 0);
 e = v[31601];
 v[31601] = 0;
 a: {
  b: {
   c: {
    if ((e | 0) != 1) {
     e = Eb(d + 20 | 0);
     v[31601] = 0;
     V(c | 0, d + 8 | 0);
     c = v[31601];
     v[31601] = 0;
     d: {
      e: {
       if ((c | 0) != 1) {
        h = d, i = vb(v[d + 8 >> 2]), v[h + 4 >> 2] = i;
        f = 1;
        while (1) {
         g = vb(v[d + 12 >> 2]);
         c = v[d + 4 >> 2];
         if (!Hb(c, g)) {
          c = Bg(Jb(e));
          Sd(d + 8 | 0);
          sb(e);
          break b;
         }
         if (!f) {
          v[31601] = 0;
          O(984, e | 0, 14604) | 0;
          c = v[31601];
          v[31601] = 0;
          if ((c | 0) == 1) {
           break e;
          }
          c = v[d + 4 >> 2];
         }
         v[31601] = 0;
         O(837, e | 0, c | 0) | 0;
         c = v[31601];
         v[31601] = 0;
         if ((c | 0) == 1) {
          break e;
         }
         vm(d + 4 | 0);
         f = 0;
         continue;
        }
       }
       c = S(0) | 0;
       break d;
      }
      c = S(0) | 0;
      Sd(d + 8 | 0);
     }
     sb(e);
     break c;
    }
    c = S(0) | 0;
   }
   X(c | 0) | 0;
   c = 0;
   v[31601] = 0;
   U(982, b | 0, a | 0, 0, 0);
   a = v[31601];
   v[31601] = 0;
   if ((a | 0) == 1) {
    break a;
   }
   Y();
  }
  eb = d + 32 | 0;
  return c;
 }
 a = M() | 0;
 v[31601] = 0;
 W(26);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) == 1) {
  S(0) | 0;
  Rb();
  p();
 }
 P(a | 0);
 p();
}

function Nja(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0;
 d = eb - 32 | 0;
 eb = d;
 e = Eb(d + 20 | 0);
 a: {
  b: {
   c: {
    if (c >>> 0 <= 63) {
     break c;
    }
    v[31601] = 0;
    c = Q(184, b | 0) | 0;
    f = v[31601];
    v[31601] = 0;
    d: {
     if ((f | 0) != 1) {
      v[d + 16 >> 2] = c;
      if ((c | 0) > 0) {
       break d;
      }
      v[31601] = 0;
      O(36, a | 0, 22256) | 0;
      a = v[31601];
      v[31601] = 0;
      if ((a | 0) != 1) {
       break b;
      }
     }
     break a;
    }
    v[31601] = 0;
    c = Q(202, b | 0) | 0;
    f = v[31601];
    v[31601] = 0;
    if ((f | 0) != 1) {
     g = d, h = th(c), v[g + 12 >> 2] = h;
     c = v[Bd(d + 16 | 0, d + 12 | 0) >> 2];
     v[31601] = 0;
     N(114, e | 0, c | 0);
     c = v[31601];
     v[31601] = 0;
     if ((c | 0) != 1) {
      break c;
     }
    }
    break a;
   }
   e: {
    while (1) {
     f: {
      v[31601] = 0;
      c = Q(197, b | 0) | 0;
      f = v[31601];
      v[31601] = 0;
      if ((f | 0) == 1) {
       break f;
      }
      if (!c) {
       break e;
      }
      v[31601] = 0;
      T(889, e | 0, 1, ((c - 65 & 255) >>> 0 < 26 ? c | 32 : c) << 24 >> 24) | 0;
      c = v[31601];
      v[31601] = 0;
      if ((c | 0) != 1) {
       continue;
      }
     }
     break;
    }
    break a;
   }
   v[31601] = 0;
   O(183, b | 0, 4) | 0;
   b = v[31601];
   v[31601] = 0;
   if ((b | 0) == 1) {
    break a;
   }
   Uc(a, e);
  }
  sb(e);
  eb = d + 32 | 0;
  return;
 }
 a = M() | 0;
 sb(e);
 P(a | 0);
 p();
}

function r_(a, b) {
 var c = 0, d = 0, e = 0, f = 0, g = 0;
 e = eb - 16 | 0;
 eb = e;
 d = Eb(a);
 a = yd(b);
 v[e + 12 >> 2] = a;
 f = Cf(b);
 b = 0;
 a: {
  while (1) {
   b: {
    if (!Hb(a, f)) {
     if (!b) {
      break b;
     }
     v[31601] = 0;
     N(35, d | 0, 65533);
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) != 1) {
      break b;
     }
     break a;
    }
    a = w[a | 0];
    c: {
     d: {
      if (!b) {
       if (a << 24 >> 24 >= 0) {
        b = 0;
        v[31601] = 0;
        N(35, d | 0, a | 0);
        a = v[31601];
        v[31601] = 0;
        if ((a | 0) != 1) {
         break c;
        }
        break a;
       }
       if ((a & 224) == 192) {
        c = a & 31;
        b = 1;
        break c;
       }
       if ((a & 240) == 224) {
        c = a & 15;
        b = 2;
        break c;
       }
       c = 65533;
       if ((a & 248) != 240) {
        break d;
       }
       c = a & 7;
       b = 3;
       break c;
      }
      if ((a & 192) != 128) {
       c = 0;
       v[31601] = 0;
       N(35, d | 0, 65533);
       g = v[31601];
       v[31601] = 0;
       b = 0;
       if ((g | 0) == 1) {
        break a;
       }
      }
      c = a & 63 | c << 6;
      b = b - 1 | 0;
      if (b) {
       break c;
      }
     }
     b = 0;
     v[31601] = 0;
     N(35, d | 0, c | 0);
     a = v[31601];
     v[31601] = 0;
     c = 0;
     if ((a | 0) == 1) {
      break a;
     }
    }
    a = v[xe(e + 12 | 0) >> 2];
    continue;
   }
   break;
  }
  eb = e + 16 | 0;
  return;
 }
 a = M() | 0;
 Tb(d);
 P(a | 0);
 p();
}

function Rma(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, u = 0, w = 0, x = 0;
 h = eb - 16 | 0;
 eb = h;
 m = v[a + 24 >> 2];
 n = v[a + 20 >> 2];
 f = v[a + 48 >> 2];
 e = v[a + 44 >> 2];
 o = v[a + 16 >> 2];
 b = v[a + 4 >> 2];
 v[h + 8 >> 2] = v[a >> 2];
 v[h + 12 >> 2] = b;
 p = v[a + 72 >> 2];
 j = v[a + 68 >> 2];
 q = j >> 31;
 k = v[a + 64 >> 2];
 r = k >> 31;
 l = v[a + 60 >> 2];
 s = l >> 31;
 u = v[a + 8 >> 2];
 w = v[a + 12 >> 2];
 while (1) {
  b = e;
  if (d) {
   e = Xb(e, -16777216, 16776704);
   e = Aua(k, r, e, e >> 31);
   i = gb;
   g = e;
   f = Xb(f, -16777216, 16776704);
   e = Aua(j, q, f, f >> 31);
   g = g + e | 0;
   f = gb + i | 0;
   f = e >>> 0 > g >>> 0 ? f + 1 | 0 : f;
   x = g;
   e = v[h + 8 >> 2];
   i = e >>> 10 & 4194048;
   e = v[h + 12 >> 2] + o | 0;
   g = t[e | 0];
   i = ((B(t[e + 1 | 0] - g | 0, i) | 0) / 16384 << 8) + (g << 16) | 0;
   e = i;
   e = Aua(e, e >> 31, l, s);
   g = e + x | 0;
   f = gb + f | 0;
   f = e >>> 0 > g >>> 0 ? f + 1 | 0 : f;
   e = g + 8388608 | 0;
   f = e >>> 0 < 8388608 ? f + 1 | 0 : f;
   e = Rc(e, f, 24);
   f = (e | 0) / 256 | 0;
   v[c >> 2] = B(f, n) + v[c >> 2];
   v[c + 4 >> 2] = v[c + 4 >> 2] + B(f, m);
   Ob(h + 8 | 0, u, w);
   e = e - (i & p) | 0;
   c = c + 8 | 0;
   d = d - 1 | 0;
   f = b;
   continue;
  }
  break;
 }
 c = v[h + 12 >> 2];
 v[a >> 2] = v[h + 8 >> 2];
 v[a + 4 >> 2] = c;
 v[a + 48 >> 2] = f;
 v[a + 44 >> 2] = b;
 eb = h + 16 | 0;
}

function Qga(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = C(0), n = 0, o = 0, p = 0, q = 0, r = 0, s = C(0), t = C(0), u = C(0), x = 0, y = C(0), A = 0, B = 0, E = 0, F = 0, G = 0, H = C(0);
 g = eb - 16 | 0;
 eb = g;
 l = v[a + 4240 >> 2];
 a: {
  if (!l) {
   break a;
  }
  if (!si(a + 44 | 0)) {
   break a;
  }
  m = z[a + 4220 >> 2];
  e = v[a + 44 >> 2];
  F = g, G = Gc(e, 0), v[F + 8 >> 2] = G;
  F = g, G = Gc(e, 1), v[F + 12 >> 2] = G;
  e = v[a + 56 >> 2];
  n = Gc(e, 0);
  v[g >> 2] = n;
  o = Gc(e, 1);
  v[g + 4 >> 2] = o;
  x = a + 4248 | 0;
  y = C(C(1) - m);
  p = v[a + 4208 >> 2];
  A = w[a + 4264 | 0];
  e = d;
  b: while (1) {
   if (e) {
    k = v[a + 4244 >> 2];
    B = k << 1;
    f = 0;
    while (1) if ((f | 0) == 2) {
     f = k + 1 | 0;
     v[a + 4244 >> 2] = (f | 0) != (l | 0) ? f : 0;
     e = e - 1 | 0;
     continue b;
    } else {
     h = (f ^ A) & 255;
     j = v[(h << 2) + x >> 2];
     E = v[a + 4240 >> 2];
     q = f << 2;
     r = q + (g + 8 | 0) | 0;
     i = v[r >> 2];
     v[r >> 2] = i + 4;
     j = k - j | 0;
     s = z[xb(p, h | (j >> 31 & E) + j << 1) >> 2];
     t = z[i >> 2];
     u = C(C(s * z[a + 4224 >> 2]) + C(t * z[a + 4260 >> 2]));
     F = xb(p, f | B), H = C(D(u)) < C(10000000195414814e-40) ? C(0) : u, z[F >> 2] = H;
     h = g + q | 0;
     i = v[h >> 2];
     v[h >> 2] = i + 4;
     z[i >> 2] = C(t * y) + C(m * s);
     f = f + 1 | 0;
     continue;
    }
   }
   break;
  }
  Hi(a, b, c, n, o, d);
 }
 eb = g + 16 | 0;
}

function FK(a, b) {
 var c = 0, d = 0, e = 0, f = 0, g = 0;
 e = eb - 16 | 0;
 eb = e;
 g = v[124107];
 if (v[b + 72 >> 2] <= 0) {
  Ny(b);
 }
 v[124107] = v[b + 136 >> 2];
 a: {
  b: {
   c: {
    if (a >>> 0 <= 127) {
     d: {
      if (v[b + 80 >> 2] == (a | 0)) {
       break d;
      }
      c = v[b + 20 >> 2];
      if ((c | 0) == v[b + 16 >> 2]) {
       break d;
      }
      v[b + 20 >> 2] = c + 1;
      t[c | 0] = a;
      break a;
     }
     d = eb - 16 | 0;
     eb = d;
     t[d + 15 | 0] = a;
     c = v[b + 16 >> 2];
     e: {
      if (!c) {
       c = -1;
       if (Uw(b)) {
        break e;
       }
       c = v[b + 16 >> 2];
      }
      f: {
       f = v[b + 20 >> 2];
       if ((c | 0) == (f | 0)) {
        break f;
       }
       c = a & 255;
       if ((c | 0) == v[b + 80 >> 2]) {
        break f;
       }
       v[b + 20 >> 2] = f + 1;
       t[f | 0] = a;
       break e;
      }
      c = -1;
      if ((hb[v[b + 36 >> 2]](b, d + 15 | 0, 1) | 0) != 1) {
       break e;
      }
      c = w[d + 15 | 0];
     }
     eb = d + 16 | 0;
     a = c;
     break c;
    }
    c = v[b + 20 >> 2];
    if (y[b + 16 >> 2] > c + 4 >>> 0) {
     c = Kt(c, a);
     if ((c | 0) < 0) {
      break b;
     }
     v[b + 20 >> 2] = c + v[b + 20 >> 2];
     break c;
    }
    d = e + 12 | 0;
    c = Kt(d, a);
    if ((c | 0) < 0) {
     break b;
    }
    if (Rr(d, c, b) >>> 0 < c >>> 0) {
     break b;
    }
   }
   if ((a | 0) != -1) {
    break a;
   }
  }
  v[b >> 2] = v[b >> 2] | 32;
  a = -1;
 }
 v[124107] = g;
 eb = e + 16 | 0;
 return a;
}

function Daa(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0;
 c = eb + -64 | 0;
 eb = c;
 b = v[a >> 2];
 a = v[b >> 2];
 d = v[a + 4 >> 2];
 v[c + 40 >> 2] = v[a + 20 >> 2];
 e = v[a + 16 >> 2];
 v[c + 32 >> 2] = v[a + 12 >> 2];
 v[c + 36 >> 2] = e;
 Wf(c + 48 | 0, c + 32 | 0, d);
 a = v[b + 4 >> 2];
 d = v[a + 8 >> 2];
 e = v[a + 4 >> 2];
 b = v[c + 60 >> 2];
 v[c + 24 >> 2] = v[c + 56 >> 2];
 v[c + 28 >> 2] = b;
 b = v[c + 52 >> 2];
 v[c + 16 >> 2] = v[c + 48 >> 2];
 v[c + 20 >> 2] = b;
 v[c + 8 >> 2] = v[a + 8 >> 2];
 b = v[a + 4 >> 2];
 v[c >> 2] = v[a >> 2];
 v[c + 4 >> 2] = b;
 a: {
  b: {
   c: {
    d: {
     f = v[c + 4 >> 2];
     if (f >>> 0 >= e >>> 0) {
      if (y[c + 20 >> 2] < e >>> 0) {
       break d;
      }
      if (d >>> 0 > y[c + 8 >> 2]) {
       break c;
      }
      g = v[c + 28 >> 2];
      if (d >>> 0 > v[c + 24 >> 2] - g >>> 0) {
       break b;
      }
      h = v[c + 16 >> 2];
      i = v[c >> 2];
      b = 0;
      e: while (1) {
       if ((b | 0) == (d | 0)) {
        break a;
       }
       j = (B(b, f) << 3) + i | 0;
       a = 0;
       while (1) if ((a | 0) == (e | 0)) {
        b = b + 1 | 0;
        continue e;
       } else {
        z[(v[(a << 2) + h >> 2] + (g << 2) | 0) + (b << 2) >> 2] = A[(a << 3) + j >> 3];
        a = a + 1 | 0;
        continue;
       }
      }
     }
     Z(7244, 9045, 77, 8725);
     p();
    }
    Z(7209, 9045, 78, 8725);
    p();
   }
   Z(5897, 9045, 79, 8725);
   p();
  }
  Z(5867, 9045, 80, 8725);
  p();
 }
 eb = c - -64 | 0;
}

function dV(a, b, c) {
 a: {
  b: {
   c: {
    d: {
     e: {
      f: {
       g: {
        h: {
         i: {
          j: {
           k: {
            l: {
             b = b & 15;
             switch (b - 3 | 0) {
             case 2:
              break j;

             case 1:
              break k;

             case 0:
              break l;

             case 10:
             case 11:
              break b;

             case 9:
              break c;

             case 8:
              break d;

             case 7:
              break e;

             case 6:
              break f;

             case 5:
              break g;

             case 4:
              break h;

             case 3:
              break i;

             default:
              break a;
             }
            }
            t[a + 798 | 0] = 0;
            return;
           }
           t[a + 798 | 0] = 1;
           return;
          }
          t[a + 798 | 0] = 2;
          return;
         }
         t[a + 798 | 0] = 3;
         return;
        }
        t[a + 730 | 0] = w[a + 730 | 0] & 254;
        return;
       }
       t[a + 730 | 0] = w[a + 730 | 0] | 1;
       return;
      }
      t[a + 738 | 0] = w[a + 738 | 0] & 254;
      return;
     }
     t[a + 738 | 0] = w[a + 738 | 0] | 1;
     return;
    }
    t[a + 746 | 0] = w[a + 746 | 0] & 254;
    return;
   }
   t[a + 746 | 0] = w[a + 746 | 0] | 1;
   return;
  }
  if ((c | 0) != 16777216) {
   break a;
  }
  c = a;
  a = w[a + 746 | 0];
  t[c + 746 | 0] = (b | 0) == 13 ? a & 238 | 1 : a | 17;
 }
}

function Bf(a, b, c) {
 t[a + 5 | 0] = c;
 a: {
  switch (b | 0) {
  case 0:
   t[a + 3 | 0] = (c | 0) != 0;
   return;

  case 1:
   t[a + 3 | 0] = 2;
   return;

  case 2:
   t[a + 3 | 0] = 3;
   return;

  case 3:
   t[a + 3 | 0] = 4;
   return;

  case 4:
   t[a + 3 | 0] = 5;
   return;

  case 5:
   t[a + 3 | 0] = 6;
   return;

  case 6:
   t[a + 3 | 0] = 7;
   return;

  case 7:
   t[a + 3 | 0] = 8;
   return;

  case 8:
   t[a + 3 | 0] = 9;
   return;

  case 9:
   t[a + 3 | 0] = 10;
   return;

  case 10:
   t[a + 3 | 0] = 11;
   return;

  case 11:
   t[a + 3 | 0] = 12;
   return;

  case 12:
   t[a + 3 | 0] = 13;
   return;

  case 13:
   t[a + 3 | 0] = 14;
   t[a + 5 | 0] = B(c >>> 4 | 0, 10) + (c & 15);
   return;

  case 14:
   t[a + 3 | 0] = 19;
   return;

  case 15:
   if (c >>> 0 <= 31) {
    t[a + 3 | 0] = 16;
    return;
   }
   t[a + 3 | 0] = 17;
   return;

  case 16:
   t[a + 3 | 0] = 23;
   return;

  case 17:
   t[a + 3 | 0] = 24;
   return;

  case 20:
   t[a + 3 | 0] = 25;
   return;

  case 21:
   t[a + 3 | 0] = 30;
   return;

  case 25:
   t[a + 3 | 0] = 29;
   return;

  case 27:
   t[a + 3 | 0] = 15;
   return;

  case 29:
   t[a + 3 | 0] = 18;
   return;

  case 32:
   t[a + 3 | 0] = 37;
   return;

  case 33:
   t[a + 3 | 0] = 28;
   return;

  case 34:
   t[a + 3 | 0] = 27;
   return;

  case 35:
   t[a + 3 | 0] = 31;
   return;

  case 36:
   t[a + 3 | 0] = 32;
   return;

  case 37:
   t[a + 3 | 0] = 32;
   return;

  case 38:
   t[a + 3 | 0] = 34;
   return;

  default:
   break a;
  }
 }
 t[a + 3 | 0] = 0;
}

function Qia(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
 f = eb - 16 | 0;
 eb = f;
 l = Hf(a, c);
 $d(f, v[a + 36 >> 2]);
 m = a;
 a: {
  if (!l) {
   Pc(f, a + 32 | 0, 5);
   c = 0;
   if (Fb(v[v[f >> 2] >> 2], v[f + 4 >> 2])) {
    break a;
   }
  }
  e = eb - 48 | 0;
  eb = e;
  j = v[a + 36 >> 2];
  ml(j, e + 40 | 0);
  h = v[e + 44 >> 2];
  if (!h & y[e + 40 >> 2] >= 257 | h) {
   v[e + 40 >> 2] = 256;
   v[e + 44 >> 2] = 0;
  }
  h = v[e + 40 >> 2];
  n = v[e + 44 >> 2];
  c = 0;
  b: {
   c: {
    d: {
     e: {
      while (1) {
       if (!n & c >>> 0 >= h >>> 0) {
        break b;
       }
       i = e + 38 | 0;
       mg(j, i);
       a = Eb(e + 24 | 0);
       v[31601] = 0;
       O(498, j | 0, a | 0) | 0;
       g = v[31601];
       v[31601] = 0;
       if ((g | 0) != 1) {
        v[31601] = 0;
        g = e + 12 | 0;
        R(496, g | 0, d | 0, a | 0);
        k = v[31601];
        v[31601] = 0;
        if ((k | 0) == 1) {
         break e;
        }
        v[31601] = 0;
        i = O(930, b | 0, i | 0) | 0;
        k = v[31601];
        v[31601] = 0;
        if ((k | 0) == 1) {
         break d;
        }
        yb(i, g);
        sb(g);
        sb(a);
        c = c + 1 | 0;
        continue;
       }
       break;
      }
      c = M() | 0;
      break c;
     }
     c = M() | 0;
     break c;
    }
    c = M() | 0;
    sb(e + 12 | 0);
   }
   sb(a);
   P(c | 0);
   p();
  }
  eb = e + 48 | 0;
  c = l;
 }
 ef(m, c);
 eb = f + 16 | 0;
}

function bta(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0;
 e = eb - 16 | 0;
 eb = e;
 md(b, 32);
 g = b, h = _b(w[a + 4 | 0] | w[a + 5 | 0] << 8 | (w[a + 6 | 0] << 16 | w[a + 7 | 0] << 24)), 
 v[g >> 2] = h;
 f = _b(w[a + 10 | 0] | w[a + 11 | 0] << 8 | (w[a + 12 | 0] << 16 | w[a + 13 | 0] << 24));
 v[b + 4 >> 2] = f;
 g = b, h = _b(w[a + 14 | 0] | w[a + 15 | 0] << 8 | (w[a + 16 | 0] << 16 | w[a + 17 | 0] << 24)) + f | 0, 
 v[g + 8 >> 2] = h;
 if (!(d ? 0 : c)) {
  c = _b(w[a + 46 | 0] | w[a + 47 | 0] << 8 | (w[a + 48 | 0] << 16 | w[a + 49 | 0] << 24));
 }
 v[b + 24 >> 2] = c;
 c = w[a + 8 | 0] << 28 >> 24;
 a: {
  if ((d | 0) != 841887798) {
   break a;
  }
  d = Ab(w[a + 42 | 0] | w[a + 43 | 0] << 8);
  if (!d | (d | 0) == 48) {
   break a;
  }
  c = (c - (d << 7) | 0) + 6144 | 0;
 }
 Yl(b, +(c | 0) * .0006510416666666666);
 t[e + 15 | 0] = w[a + 9 | 0];
 t[e + 14 | 0] = 64;
 g = b, h = w[Pb(e + 15 | 0, e + 14 | 0) | 0] << 2, u[g + 30 >> 1] = h;
 c = v[b + 4 >> 2];
 d = v[b + 8 >> 2];
 if (t[a + 40 | 0] & 1) {
  d = d >>> 1 | 0;
  v[b + 8 >> 2] = d;
  c = c >>> 1 | 0;
  v[b + 4 >> 2] = c;
  u[b + 34 >> 1] = x[b + 34 >> 1] | 64;
  v[b >> 2] = v[b >> 2] >>> 1;
 }
 if (w[a + 41 | 0] >= 9) {
  d = d >>> 1 | 0;
  v[b + 8 >> 2] = d;
  c = c >>> 1 | 0;
  v[b + 4 >> 2] = c;
  u[b + 34 >> 1] = x[b + 34 >> 1] | 1;
  v[b >> 2] = v[b >> 2] >>> 1;
 }
 b: {
  if (c + 1 >>> 0 < d >>> 0) {
   u[b + 34 >> 1] = x[b + 34 >> 1] | 2;
   break b;
  }
  v[b + 4 >> 2] = 0;
  v[b + 8 >> 2] = 0;
 }
 eb = e + 16 | 0;
}

function tra(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0;
 f = eb - 16 | 0;
 eb = f;
 c = Hf(a, c);
 $d(f, v[a + 36 >> 2]);
 j = a;
 a: {
  if (!c) {
   Pc(f, a + 32 | 0, 5);
   d = 0;
   if (Fb(v[v[f >> 2] >> 2], v[f + 4 >> 2])) {
    break a;
   }
  }
  d = eb - 32 | 0;
  eb = d;
  h = v[a + 36 >> 2];
  e = d + 30 | 0;
  mg(h, e);
  b: {
   c: {
    d: {
     e: {
      a = x[d + 30 >> 1];
      if (a >>> 0 >= 4001) {
       k = v[b + 12 >> 2];
       a = eb - 16 | 0;
       eb = a;
       g = d + 4 | 0;
       i = tc(a + 4 | 0, 15958);
       Uc(g, i);
       sb(i);
       eb = a + 16 | 0;
       v[31601] = 0;
       a = d + 16 | 0;
       R(490, a | 0, g | 0, e | 0);
       e = v[31601];
       v[31601] = 0;
       if ((e | 0) == 1) {
        break e;
       }
       e = v[k + 1298472 >> 2];
       v[31601] = 0;
       R(385, e | 0, 2, a | 0);
       e = v[31601];
       v[31601] = 0;
       if ((e | 0) == 1) {
        break d;
       }
       sb(a);
       Db(g);
       a = 4e3;
      }
      ug(Lj(v[b >> 2], 0), a);
      a = Lj(v[b >> 2], 0);
      b = vb(v[a >> 2]);
      v[d + 16 >> 2] = b;
      a = vb(v[a + 4 >> 2]);
      break b;
     }
     b = M() | 0;
     break c;
    }
    b = M() | 0;
    sb(d + 16 | 0);
   }
   Db(d + 4 | 0);
   P(b | 0);
   p();
  }
  while (1) {
   if (Hb(b, a)) {
    mg(h, d + 4 | 0);
    u[b >> 1] = x[d + 4 >> 1];
    b = v[fe(d + 16 | 0) >> 2];
    continue;
   }
   break;
  }
  eb = d + 32 | 0;
  d = c;
 }
 ef(j, d);
 eb = f + 16 | 0;
}

function iB(a, b, c) {
 var d = 0, e = 0, f = 0;
 d = eb - 112 | 0;
 eb = d;
 f = v[a >> 2];
 e = v[f - 4 >> 2];
 f = v[f - 8 >> 2];
 v[d + 76 >> 2] = 0;
 v[d + 80 >> 2] = 0;
 v[d + 84 >> 2] = 0;
 v[d + 88 >> 2] = 0;
 v[d + 92 >> 2] = 0;
 v[d + 96 >> 2] = 0;
 v[d + 100 >> 2] = 0;
 v[d + 104 >> 2] = 0;
 t[d + 107 | 0] = 0;
 t[d + 108 | 0] = 0;
 t[d + 109 | 0] = 0;
 t[d + 110 | 0] = 0;
 v[d + 68 >> 2] = 0;
 v[d + 72 >> 2] = 0;
 v[d + 64 >> 2] = b;
 v[d + 60 >> 2] = a;
 v[d + 56 >> 2] = c;
 a: {
  if (kh(e, c, 0)) {
   a = f ? 0 : a;
   break a;
  }
  b = a + f | 0;
  if ((b | 0) <= (a | 0)) {
   v[d + 44 >> 2] = 0;
   v[d + 48 >> 2] = 0;
   t[d + 51 | 0] = 0;
   t[d + 52 | 0] = 0;
   t[d + 53 | 0] = 0;
   t[d + 54 | 0] = 0;
   v[d + 20 >> 2] = 0;
   v[d + 24 >> 2] = 0;
   v[d + 28 >> 2] = 0;
   v[d + 32 >> 2] = 0;
   v[d + 36 >> 2] = 0;
   v[d + 40 >> 2] = 0;
   v[d + 12 >> 2] = 0;
   v[d + 16 >> 2] = 0;
   v[d + 8 >> 2] = c;
   v[d + 4 >> 2] = a;
   v[d >> 2] = e;
   v[d + 48 >> 2] = 1;
   hb[v[v[e >> 2] + 20 >> 2]](e, d, b, b, 1, 0);
   if (v[d + 24 >> 2]) {
    break a;
   }
  }
  a = 0;
  hb[v[v[e >> 2] + 24 >> 2]](e, d + 56 | 0, b, 1, 0);
  b: {
   switch (v[d + 92 >> 2]) {
   case 0:
    a = v[d + 96 >> 2] == 1 ? v[d + 84 >> 2] == 1 ? v[d + 88 >> 2] == 1 ? v[d + 76 >> 2] : 0 : 0 : 0;
    break a;

   case 1:
    break b;

   default:
    break a;
   }
  }
  if (v[d + 80 >> 2] != 1) {
   if (v[d + 96 >> 2] | v[d + 84 >> 2] != 1 | v[d + 88 >> 2] != 1) {
    break a;
   }
  }
  a = v[d + 72 >> 2];
 }
 eb = d + 112 | 0;
 return a;
}

function Vw(a, b, c, d) {
 var e = 0, f = 0, g = 0, h = 0;
 g = eb - 16 | 0;
 eb = g;
 a: {
  if (!c) {
   break a;
  }
  if (d) {
   b = Yb(g + 8 | 0, a, b);
   a = eb - 16 | 0;
   eb = a;
   v[a + 12 >> 2] = c;
   d = v[b + 4 >> 2];
   b: {
    if (!d) {
     d = v[b >> 2];
     break b;
    }
    c = 32 - d | 0;
    v[a + 8 >> 2] = c;
    e = v[b >> 2];
    h = c;
    c = v[Gb(a + 8 | 0, a + 12 | 0) >> 2];
    v[e >> 2] = -1 << d & -1 >>> h - c | v[e >> 2];
    c = v[a + 12 >> 2] - c | 0;
    v[a + 12 >> 2] = c;
    d = e + 4 | 0;
    v[b >> 2] = d;
   }
   v[a + 4 >> 2] = -1;
   e = d;
   d = c >>> 5 | 0;
   JF(e, d, a + 4 | 0);
   e = v[a + 12 >> 2];
   c = c & -32;
   f = e - c | 0;
   v[a + 12 >> 2] = f;
   if ((c | 0) != (e | 0)) {
    c = b;
    b = v[b >> 2] + (d << 2) | 0;
    v[c >> 2] = b;
    v[b >> 2] = v[b >> 2] | -1 >>> 32 - f;
   }
   eb = a + 16 | 0;
   break a;
  }
  b = Yb(g, a, b);
  a = eb - 16 | 0;
  eb = a;
  v[a + 12 >> 2] = c;
  d = v[b + 4 >> 2];
  c: {
   if (!d) {
    d = v[b >> 2];
    break c;
   }
   e = 32 - d | 0;
   v[a + 8 >> 2] = e;
   c = v[b >> 2];
   f = v[c >> 2];
   h = e;
   e = v[Gb(a + 8 | 0, a + 12 | 0) >> 2];
   v[c >> 2] = (-1 << d & -1 >>> h - e ^ -1) & f;
   f = v[a + 12 >> 2];
   d = c + 4 | 0;
   v[b >> 2] = d;
   c = f - e | 0;
  }
  e = d;
  d = c >>> 5 | 0;
  IF(e, d);
  c = c & 31;
  v[a + 12 >> 2] = c;
  if (c) {
   e = b;
   b = v[b >> 2] + (d << 2) | 0;
   v[e >> 2] = b;
   v[b >> 2] = v[b >> 2] & (-1 >>> 32 - c ^ -1);
  }
  eb = a + 16 | 0;
 }
 eb = g + 16 | 0;
}

function CE(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0;
 f = eb - 560 | 0;
 eb = f;
 u[f + 558 >> 1] = b;
 a: {
  if ((b - 256 & 65535) >>> 0 < 65281) {
   break a;
  }
  e = ((b << 2) + a | 0) + 900380 | 0;
  b = v[e >> 2];
  b: {
   if (b) {
    c = cV(f, c);
    d = v[c + 4 >> 2];
    v[b >> 2] = v[c >> 2];
    v[b + 4 >> 2] = d;
    d = w[c + 11 | 0] | w[c + 12 | 0] << 8 | (w[c + 13 | 0] << 16 | w[c + 14 | 0] << 24);
    e = w[c + 7 | 0] | w[c + 8 | 0] << 8 | (w[c + 9 | 0] << 16 | w[c + 10 | 0] << 24);
    t[b + 7 | 0] = e;
    t[b + 8 | 0] = e >>> 8;
    t[b + 9 | 0] = e >>> 16;
    t[b + 10 | 0] = e >>> 24;
    t[b + 11 | 0] = d;
    t[b + 12 | 0] = d >>> 8;
    t[b + 13 | 0] = d >>> 16;
    t[b + 14 | 0] = d >>> 24;
    t[b + 15 | 0] = w[c + 15 | 0];
    d = v[c + 44 >> 2];
    v[b + 40 >> 2] = v[c + 40 >> 2];
    v[b + 44 >> 2] = d;
    d = v[c + 36 >> 2];
    v[b + 32 >> 2] = v[c + 32 >> 2];
    v[b + 36 >> 2] = d;
    d = v[c + 28 >> 2];
    v[b + 24 >> 2] = v[c + 24 >> 2];
    v[b + 28 >> 2] = d;
    d = v[c + 20 >> 2];
    v[b + 16 >> 2] = v[c + 16 >> 2];
    v[b + 20 >> 2] = d;
    PA(b + 48 | 0, c + 48 | 0);
    PA(b + 68 | 0, c + 68 | 0);
    PA(b + 88 | 0, c + 88 | 0);
    yc(b + 108 | 0, c + 108 | 0, 448);
    d = b;
    Nv(c);
    break b;
   }
   b = Au(556);
   if (!b) {
    v[e >> 2] = 0;
    break a;
   }
   d = cV(b, c);
   v[e >> 2] = d;
  }
  g = a, h = x[qe(a + 480192 | 0, f + 558 | 0) >> 1], u[g + 480192 >> 1] = h;
 }
 eb = f + 560 | 0;
 return d | 0;
}

function Qma(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, w = 0, x = 0;
 h = eb - 16 | 0;
 eb = h;
 n = v[a + 24 >> 2];
 o = v[a + 20 >> 2];
 e = v[a + 48 >> 2];
 f = v[a + 44 >> 2];
 p = v[a + 16 >> 2];
 b = v[a + 4 >> 2];
 v[h + 8 >> 2] = v[a >> 2];
 v[h + 12 >> 2] = b;
 q = v[a + 72 >> 2];
 k = v[a + 68 >> 2];
 r = k >> 31;
 l = v[a + 64 >> 2];
 s = l >> 31;
 m = v[a + 60 >> 2];
 t = m >> 31;
 w = v[a + 8 >> 2];
 x = v[a + 12 >> 2];
 while (1) {
  b = f;
  if (d) {
   f = Xb(f, -16777216, 16776704);
   g = Aua(l, s, f, f >> 31);
   f = gb;
   e = Xb(e, -16777216, 16776704);
   e = Aua(k, r, e, e >> 31);
   g = e + g | 0;
   f = gb + f | 0;
   f = e >>> 0 > g >>> 0 ? f + 1 | 0 : f;
   j = g;
   g = (v[h + 12 >> 2] << 1) + p | 0;
   i = u[g >> 1];
   i = i + ((B(u[g + 2 >> 1] - i | 0, v[h + 8 >> 2] >>> 18 | 0) | 0) / 16384 | 0) << 8;
   e = i;
   g = Aua(e, e >> 31, m, t);
   j = g + j | 0;
   e = gb + f | 0;
   e = g >>> 0 > j >>> 0 ? e + 1 | 0 : e;
   f = j + 8388608 | 0;
   e = f >>> 0 < 8388608 ? e + 1 | 0 : e;
   f = Rc(f, e, 24);
   e = (f | 0) / 256 | 0;
   v[c >> 2] = B(e, o) + v[c >> 2];
   v[c + 4 >> 2] = v[c + 4 >> 2] + B(e, n);
   Ob(h + 8 | 0, w, x);
   f = f - (i & q) | 0;
   c = c + 8 | 0;
   d = d - 1 | 0;
   e = b;
   continue;
  }
  break;
 }
 c = v[h + 12 >> 2];
 v[a >> 2] = v[h + 8 >> 2];
 v[a + 4 >> 2] = c;
 v[a + 48 >> 2] = e;
 v[a + 44 >> 2] = b;
 eb = h + 16 | 0;
}

function Qt(a) {
 var b = 0, c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0;
 a: {
  b: {
   e = oj(a) & 2047;
   d = oj(5551115123125783e-32);
   if (e - d >>> 0 < oj(512) - d >>> 0) {
    h = e;
    break b;
   }
   if (d >>> 0 > e >>> 0) {
    return a + 1;
   }
   if (oj(1024) >>> 0 > e >>> 0) {
    break b;
   }
   o(+a);
   d = j(1) | 0;
   b = 0;
   if (!(j(0) | 0) & (d | 0) == -1048576) {
    break a;
   }
   if (oj(Infinity) >>> 0 <= e >>> 0) {
    return a + 1;
   }
   if ((d | 0) < 0) {
    return Os(12882297539194267e-247);
   }
   return Os(3105036184601418e216);
  }
  b = A[170];
  f = A[169] * a + b;
  b = f - b;
  a = b * A[172] + (b * A[171] + a);
  b = a * a;
  g = b * b * (a * A[176] + A[175]);
  b = b * (a * A[174] + A[173]);
  o(+f);
  j(1) | 0;
  e = j(0) | 0;
  c = e << 4 & 2032;
  a = g + (b + (A[c + 1464 >> 3] + a));
  c = c + 1472 | 0;
  d = 0 + v[c >> 2] | 0;
  c = v[c + 4 >> 2] + (e << 13) | 0;
  c = d >>> 0 < i >>> 0 ? c + 1 | 0 : c;
  if (!h) {
   c: {
    if (!(e & -2147483648)) {
     l(0, d | 0);
     l(1, c - 1058013184 | 0);
     b = +n();
     a = (b * a + b) * 5486124068793689e288;
     break c;
    }
    l(0, d | 0);
    l(1, c + 1071644672 | 0);
    b = +n();
    f = b * a;
    a = f + b;
    if (a < 1) {
     hK(CK() * 22250738585072014e-324);
     g = a + 1;
     a = g + (f + (b - a) + (a + (1 - g))) + -1;
     a = a == 0 ? 0 : a;
    }
    a = a * 22250738585072014e-324;
   }
   return a;
  }
  l(0, d | 0);
  l(1, c | 0);
  b = +n();
  b = b * a + b;
 }
 return b;
}

function ena(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, w = 0, x = 0, y = 0, z = 0, A = 0;
 g = eb - 16 | 0;
 eb = g;
 p = v[a + 16 >> 2];
 j = jg(1, 2);
 b = gb;
 q = b;
 Ob(a, j, b);
 r = v[a + 24 >> 2];
 s = v[a + 20 >> 2];
 f = v[a + 48 >> 2];
 e = v[a + 44 >> 2];
 b = v[a + 4 >> 2];
 v[g + 8 >> 2] = v[a >> 2];
 v[g + 12 >> 2] = b;
 t = v[a + 72 >> 2];
 k = v[a + 68 >> 2];
 w = k >> 31;
 l = v[a + 64 >> 2];
 x = l >> 31;
 m = v[a + 60 >> 2];
 y = m >> 31;
 z = v[a + 8 >> 2];
 A = v[a + 12 >> 2];
 while (1) {
  b = e;
  if (d) {
   n = u[(v[g + 12 >> 2] << 1) + p >> 1] << 8;
   e = n;
   e = Aua(e, e >> 31, m, y);
   i = gb;
   h = e;
   e = Xb(b, -16777216, 16776704);
   e = Aua(l, x, e, e >> 31);
   o = h + e | 0;
   h = gb + i | 0;
   h = e >>> 0 > o >>> 0 ? h + 1 | 0 : h;
   f = Xb(f, -16777216, 16776704);
   e = Aua(k, w, f, f >> 31);
   i = e + o | 0;
   f = gb + h | 0;
   f = e >>> 0 > i >>> 0 ? f + 1 | 0 : f;
   e = i + 8388608 | 0;
   f = e >>> 0 < 8388608 ? f + 1 | 0 : f;
   e = Rc(e, f, 24);
   f = (e | 0) / 256 | 0;
   v[c >> 2] = B(f, s) + v[c >> 2];
   v[c + 4 >> 2] = v[c + 4 >> 2] + B(f, r);
   Ob(g + 8 | 0, z, A);
   e = e - (t & n) | 0;
   c = c + 8 | 0;
   d = d - 1 | 0;
   f = b;
   continue;
  }
  break;
 }
 c = v[g + 12 >> 2];
 v[a >> 2] = v[g + 8 >> 2];
 v[a + 4 >> 2] = c;
 v[a + 48 >> 2] = f;
 v[a + 44 >> 2] = b;
 Hg(a, j, q);
 eb = g + 16 | 0;
}

function fna(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, u = 0, w = 0, x = 0, y = 0, z = 0, A = 0;
 g = eb - 16 | 0;
 eb = g;
 p = v[a + 16 >> 2];
 j = jg(1, 2);
 b = gb;
 q = b;
 Ob(a, j, b);
 r = v[a + 24 >> 2];
 s = v[a + 20 >> 2];
 f = v[a + 48 >> 2];
 e = v[a + 44 >> 2];
 b = v[a + 4 >> 2];
 v[g + 8 >> 2] = v[a >> 2];
 v[g + 12 >> 2] = b;
 u = v[a + 72 >> 2];
 k = v[a + 68 >> 2];
 w = k >> 31;
 l = v[a + 64 >> 2];
 x = l >> 31;
 m = v[a + 60 >> 2];
 y = m >> 31;
 z = v[a + 8 >> 2];
 A = v[a + 12 >> 2];
 while (1) {
  b = e;
  if (d) {
   n = t[v[g + 12 >> 2] + p | 0] << 16;
   e = n;
   e = Aua(e, e >> 31, m, y);
   i = gb;
   h = e;
   e = Xb(b, -16777216, 16776704);
   e = Aua(l, x, e, e >> 31);
   o = h + e | 0;
   h = gb + i | 0;
   h = e >>> 0 > o >>> 0 ? h + 1 | 0 : h;
   f = Xb(f, -16777216, 16776704);
   e = Aua(k, w, f, f >> 31);
   i = e + o | 0;
   f = gb + h | 0;
   f = e >>> 0 > i >>> 0 ? f + 1 | 0 : f;
   e = i + 8388608 | 0;
   f = e >>> 0 < 8388608 ? f + 1 | 0 : f;
   e = Rc(e, f, 24);
   f = (e | 0) / 256 | 0;
   v[c >> 2] = B(f, s) + v[c >> 2];
   v[c + 4 >> 2] = v[c + 4 >> 2] + B(f, r);
   Ob(g + 8 | 0, z, A);
   e = e - (u & n) | 0;
   c = c + 8 | 0;
   d = d - 1 | 0;
   f = b;
   continue;
  }
  break;
 }
 c = v[g + 12 >> 2];
 v[a >> 2] = v[g + 8 >> 2];
 v[a + 4 >> 2] = c;
 v[a + 48 >> 2] = f;
 v[a + 44 >> 2] = b;
 Hg(a, j, q);
 eb = g + 16 | 0;
}

function doa(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0;
 e = eb - 16 | 0;
 eb = e;
 u[e + 12 >> 1] = c;
 u[e + 14 >> 1] = b;
 u[e + 10 >> 1] = d;
 g = x[v[v[a + 24 >> 2] + 8 >> 2] + 12 >> 1];
 a: {
  if (g >>> 0 <= b >>> 0) {
   break a;
  }
  if (!c | Gj(a) >>> 0 >= g >>> 0) {
   break a;
  }
  Gf(e + 12 | 0, g - b & 65535);
  k = e, l = am(v[a >> 2], v[a + 4 >> 2]), u[k + 8 >> 1] = l;
  d = x[e + 12 >> 1];
  wY(a, d + x[qe(e + 14 | 0, e + 8 | 0) >> 1] | 0);
  f = e + 4 | 0;
  c = a;
  a = v[a >> 2];
  if (_c(a, v[c + 4 >> 2]) >>> 0 < b >>> 0) {
   ug(c, b);
   a = v[c >> 2];
  }
  a = ub(f, LX(vb(a), b));
  h = e + 10 | 0;
  j = eb - 32 | 0;
  eb = j;
  b = v[a >> 2];
  a = v[c >> 2];
  f = (lp(b, vb(a)) << 1) + a | 0;
  a = d;
  b: {
   if (!a) {
    break b;
   }
   b = v[zb(c) >> 2];
   i = v[c + 4 >> 2];
   if (a >>> 0 <= b - i >> 1 >>> 0) {
    b = a;
    d = i - f >> 1;
    if (d >>> 0 < a >>> 0) {
     tp(c, a - d | 0, h);
     b = d;
     if ((f | 0) == (i | 0)) {
      break b;
     }
    }
    QU(c, f, i, (a << 1) + f | 0);
    Kv(f, b, ((f >>> 0 <= h >>> 0 ? y[c + 4 >> 2] > h >>> 0 ? a : 0 : 0) << 1) + h | 0);
    break b;
   }
   b = zb(c);
   b = dk(j + 12 | 0, ek(c, _c(v[c >> 2], i) + a | 0), f - v[c >> 2] >> 1, b);
   rF(b, a, h);
   f = PU(c, b, f);
   $i(b);
  }
  vb(f);
  eb = j + 32 | 0;
  if (_c(v[c >> 2], v[c + 4 >> 2]) >>> 0 <= g >>> 0) {
   break a;
  }
  ug(c, g);
 }
 eb = e + 16 | 0;
}

function sia(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = C(0), j = 0, k = 0, l = 0, m = 0, n = C(0), o = C(0), p = C(0), q = C(0), r = 0, s = 0, t = 0, u = C(0), w = C(0), x = C(0), y = C(0), A = 0, B = 0, E = 0, F = C(0);
 r = v[a + 4220 >> 2];
 if (r) {
  f = v[a + 44 >> 2];
  k = Gc(f, 0);
  l = Gc(f, 1);
  g = v[a + 56 >> 2];
  s = Gc(g, 0);
  j = v[a + 4208 >> 2];
  A = v[a + 4228 >> 2];
  f = d;
  t = Gc(g, 1);
  m = t;
  g = s;
  while (1) {
   if (f) {
    h = v[a + 4224 >> 2];
    e = h - A | 0;
    e = (v[a + 4220 >> 2] & e >> 31) + e << 1;
    B = xb(j, e);
    n = z[xb(j, e | 1) >> 2];
    u = z[a + 4244 >> 2];
    o = z[B >> 2];
    w = z[a + 4252 >> 2];
    p = z[l >> 2];
    x = z[a + 4248 >> 2];
    q = z[k >> 2];
    y = z[a + 4256 >> 2];
    i = C(C(n * u) + C(C(o * w) + C(C(p * x) + C(q * y))));
    e = h << 1;
    E = xb(j, e), F = C(D(i)) < C(10000000195414814e-40) ? C(0) : i, z[E >> 2] = F;
    i = C(C(o * u) + C(C(n * w) + C(C(q * x) + C(p * y))));
    E = xb(j, e | 1), F = C(D(i)) < C(10000000195414814e-40) ? C(0) : i, z[E >> 2] = F;
    h = h + 1 | 0;
    v[a + 4224 >> 2] = (h | 0) != (r | 0) ? h : 0;
    z[g >> 2] = C(q * z[a + 4240 >> 2]) + C(o * z[a + 4236 >> 2]);
    z[m >> 2] = C(p * z[a + 4240 >> 2]) + C(n * z[a + 4236 >> 2]);
    f = f - 1 | 0;
    m = m + 4 | 0;
    g = g + 4 | 0;
    l = l + 4 | 0;
    k = k + 4 | 0;
    continue;
   } else {
    Hi(a, b, c, s, t, d);
   }
   break;
  }
 }
}

function RL(a, b, c, d) {
 var e = 0, f = C(0), g = 0, h = C(0), i = 0, j = 0, k = 0, l = C(0), m = C(0), n = C(0), o = 0;
 e = eb - 96 | 0;
 eb = e;
 o = (d | 0) > 0 ? d : 0;
 while (1) {
  if ((j | 0) != (o | 0)) {
   z[e + 48 >> 2] = -z[a >> 2];
   z[e >> 2] = z[a + 68 >> 2];
   d = 0;
   while (1) {
    if ((d | 0) != 4) {
     i = d << 3;
     k = i + (e + 48 | 0) | 0;
     g = (d << 4) + a | 0;
     h = z[g + 4 >> 2];
     f = z[g + 8 >> 2];
     z[k + 4 >> 2] = h + f;
     z[(8 - (d << 1) << 2) + e >> 2] = h - f;
     h = z[g + 16 >> 2];
     f = z[g + 12 >> 2];
     z[(i ^ 28) + e >> 2] = h - f;
     z[k + 8 >> 2] = -C(h + f);
     d = d + 1 | 0;
     continue;
    }
    break;
   }
   QL(e + 48 | 0);
   QL(e);
   z[e + 4 >> 2] = -z[e + 4 >> 2];
   z[e + 12 >> 2] = -z[e + 12 >> 2];
   z[e + 20 >> 2] = -z[e + 20 >> 2];
   z[e + 28 >> 2] = -z[e + 28 >> 2];
   g = 0;
   while (1) {
    if ((g | 0) != 9) {
     d = g << 2;
     i = d + b | 0;
     h = z[i >> 2];
     f = z[d + (e + 48 | 0) >> 2];
     l = z[d + 87312 >> 2];
     m = z[d + 87348 >> 2];
     n = z[d + e >> 2];
     z[i >> 2] = C(f * l) - C(m * n);
     i = a + d | 0;
     d = c + d | 0;
     f = C(C(f * m) + C(n * l));
     z[i >> 2] = C(h * z[d >> 2]) - C(z[d + 36 >> 2] * f);
     z[(17 - g << 2) + a >> 2] = C(h * z[d + 36 >> 2]) + C(f * z[d >> 2]);
     g = g + 1 | 0;
     continue;
    }
    break;
   }
   b = b + 36 | 0;
   a = a + 72 | 0;
   j = j + 1 | 0;
   continue;
  }
  break;
 }
 eb = e + 96 | 0;
}

function Cs(a, b, c) {
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0;
 d = eb - 32 | 0;
 eb = d;
 v[d + 28 >> 2] = 0;
 a: {
  b: {
   c: {
    if (Hd(w[Em(d + 27 | 0, a, 0) | 0])) {
     g = d + 20 | 0;
     bd(g, v[(v[v[a >> 2] - 12 >> 2] + a | 0) + 28 >> 2]);
     v[31601] = 0;
     h = Q(1222, v[d + 20 >> 2]) | 0;
     e = v[31601];
     v[31601] = 0;
     d: {
      e: {
       if ((e | 0) == 1) {
        break e;
       }
       e = qp(d + 16 | 0, a);
       f = sc(d + 12 | 0);
       i = v[v[a >> 2] - 12 >> 2];
       f = v[f >> 2];
       e = v[e >> 2];
       v[31601] = 0;
       ia(c | 0, h | 0, e | 0, f | 0, a + i | 0, d + 28 | 0, b | 0);
       b = v[31601];
       v[31601] = 0;
       if ((b | 0) == 1) {
        break e;
       }
       Zb(g);
       break d;
      }
      b = S(0) | 0;
      Zb(d + 20 | 0);
      X(b | 0) | 0;
      b = v[d + 28 >> 2] | 1;
      v[d + 28 >> 2] = b;
      Cm(v[v[a >> 2] - 12 >> 2] + a | 0, b);
      if (v[(v[v[a >> 2] - 12 >> 2] + a | 0) + 20 >> 2] & 1) {
       v[31601] = 0;
       W(84);
       a = v[31601];
       v[31601] = 0;
       if ((a | 0) != 1) {
        break b;
       }
       a = M() | 0;
       v[31601] = 0;
       W(26);
       b = v[31601];
       v[31601] = 0;
       if ((b | 0) == 1) {
        break c;
       }
       P(a | 0);
       p();
      }
      Y();
     }
     Wj(v[v[a >> 2] - 12 >> 2] + a | 0, v[d + 28 >> 2]);
    }
    eb = d + 32 | 0;
    break a;
   }
   S(0) | 0;
   Rb();
  }
  p();
 }
 return a;
}

function ZC(a, b, c, d) {
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
 i = eb - 32 | 0;
 eb = i;
 g = eb - 16 | 0;
 eb = g;
 md(b, 1);
 k = Ab(w[a + 22 | 0] | w[a + 23 | 0] << 8);
 h = k << 1;
 v[b >> 2] = h;
 t[b + 37 | 0] = w[a + 24 | 0] << 4;
 t[g + 15 | 0] = w[a + 25 | 0];
 t[g + 14 | 0] = 64;
 m = b, n = w[Pb(g + 15 | 0, g + 14 | 0) | 0] << 2, u[m + 30 >> 1] = n;
 f = Ab(w[a + 26 | 0] | w[a + 27 | 0] << 8);
 e = f << 1;
 l = Ab(w[a + 28 | 0] | w[a + 29 | 0] << 8);
 j = l << 1;
 e = l >>> 0 >= 2 ? e + j >>> 0 <= h >>> 0 ? e : f + j >>> 0 > h >>> 0 ? e : f : e;
 a: {
  b: {
   switch (k | 0) {
   case 1:
    v[b >> 2] = 0;
    break a;

   case 0:
    break a;

   default:
    break b;
   }
  }
  v[b + 4 >> 2] = e;
  f = e + j | 0;
  v[b + 8 >> 2] = f;
  if (e >>> 0 >= h >>> 0) {
   e = h - 1 | 0;
   v[b + 4 >> 2] = e;
  }
  if (!(!(f >>> 0 < 4 | e >>> 0 > f >>> 0) & f - e >>> 0 > 3)) {
   v[b + 4 >> 2] = 0;
   v[b + 8 >> 2] = 0;
   f = 0;
   e = 0;
  }
  if (!(f >>> 0 > 8 | f >>> 0 >= h >>> 0 | (!d | e))) {
   v[b + 8 >> 2] = 0;
   break a;
  }
  if (e >>> 0 >= f >>> 0) {
   break a;
  }
  u[b + 34 >> 1] = x[b + 34 >> 1] | 2;
 }
 eb = g + 16 | 0;
 d = i + 8 | 0;
 Pk(d, 3, a);
 b = i + 20 | 0;
 Bc(b, d);
 c = zc(c, b);
 sb(b);
 d = 0;
 while (1) {
  if ((d | 0) != 32) {
   b = c + d | 0;
   if ((w[b | 0] - 1 & 255) >>> 0 <= 30) {
    t[b | 0] = 32;
   }
   d = d + 1 | 0;
   continue;
  }
  break;
 }
 a = $C(a);
 eb = i + 32 | 0;
 return a;
}

function _la(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, t = 0, w = 0, x = 0;
 e = eb - 16 | 0;
 eb = e;
 j = v[a + 24 >> 2];
 k = v[a + 20 >> 2];
 l = v[a + 16 >> 2];
 i = v[a + 4 >> 2];
 v[e + 8 >> 2] = v[a >> 2];
 v[e + 12 >> 2] = i;
 m = b + 24 | 0;
 i = v[a + 8 >> 2];
 n = v[a + 12 >> 2];
 while (1) {
  if (d) {
   b = v[e + 8 >> 2];
   g = ((((v[e + 12 >> 2] & 2147483647) << 1 | b >>> 31) & 2147483646) << 1) + l | 0;
   b = (((b >>> 16 | 0) + 4 & 131064) << 1) + m | 0;
   o = u[b + 14 >> 1];
   p = u[b + 12 >> 1];
   q = u[b + 10 >> 1];
   r = u[b + 8 >> 1];
   s = u[b + 6 >> 1];
   t = u[b + 4 >> 1];
   w = u[b + 2 >> 1];
   x = u[b >> 1];
   b = 0;
   while (1) {
    if ((b | 0) != 2) {
     h = b << 1;
     f = h + g | 0;
     v[(b << 2) + e >> 2] = (((((B(u[f + 8 >> 1], q) + B(u[f + 4 >> 1], r) | 0) + B(u[f + 12 >> 1], p) | 0) + B(u[f + 16 >> 1], o) | 0) / 2 | 0) + ((((B(u[(h | -8) + g >> 1], w) + B(u[(h | -12) + g >> 1], x) | 0) + B(u[(h | -4) + g >> 1], t) | 0) + B(u[f >> 1], s) | 0) / 2 | 0) | 0) / 16384;
     b = b + 1 | 0;
     continue;
    }
    break;
   }
   v[c >> 2] = v[c >> 2] + B(v[e >> 2], k);
   v[c + 4 >> 2] = v[c + 4 >> 2] + B(v[e + 4 >> 2], j);
   Ob(e + 8 | 0, i, n);
   c = c + 8 | 0;
   d = d - 1 | 0;
   continue;
  }
  break;
 }
 b = v[e + 12 >> 2];
 v[a >> 2] = v[e + 8 >> 2];
 v[a + 4 >> 2] = b;
 eb = e + 16 | 0;
}

function cB(a, b, c, d) {
 var e = 0, f = 0, g = 0, h = 0;
 a: {
  if (!d) {
   break a;
  }
  if (c) {
   t[b + 815 | 0] = c;
   break a;
  }
  c = w[b + 815 | 0];
 }
 f = v[a + 480180 >> 2];
 d = f & 1048580;
 c = d ? c & 240 ? c & -16 : c : c;
 b: {
  c: {
   d: {
    if (!d) {
     d = c & 240;
     e: {
      f: {
       g: {
        h: {
         e = c & 15;
         if ((e | 0) == 15) {
          a = v[a + 480208 >> 2] & 4096;
          if (!d) {
           break h;
          }
          if (!a) {
           break b;
          }
          c = 0 - (d >>> 2 | 0) | 0;
          break d;
         }
         a = v[a + 480208 >> 2] & 4096;
         if (!e | (d | 0) != 240) {
          break g;
         }
         if (!a) {
          break b;
         }
         c = e << 2;
         break c;
        }
        d = 0;
        if (!a) {
         break f;
        }
        break b;
       }
       if (a) {
        break b;
       }
       if (!e) {
        break e;
       }
      }
      c = e << 2;
      if (!d | !(f & 16777248)) {
       break c;
      }
      break b;
     }
     c = 0 - ((c & 255) >>> 2 | 0) | 0;
     break d;
    }
    if (w[a + 480209 | 0] & 16) {
     break b;
    }
    d = c & 240;
    c = d ? d >>> 2 | 0 : 0 - ((c & 255) << 2) | 0;
    if (!Nb(a + 1074312 | 0, 56)) {
     break d;
    }
    c = c >> 2;
   }
   if (!c) {
    break b;
   }
  }
  a = v[b + 692 >> 2];
  u[b + 784 >> 1] = 0;
  g = b, h = Xb(a + c | 0, 0, 256), v[g + 692 >> 2] = h;
 }
}

function Mla(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0;
 e = eb - 16 | 0;
 eb = e;
 n = v[a + 16 >> 2];
 o = Fg(b + 327720 | 0, v[b + 20 >> 2], (v[a + 88 >> 2] & 16384) >>> 14 | 0);
 i = v[a + 8 >> 2];
 j = v[a + 12 >> 2];
 b = v[a >> 2];
 g = v[a + 4 >> 2];
 k = v[a + 128 >> 2];
 if (k) {
  l = Gg(i, j, k);
  m = gb;
  f = v[a + 76 >> 2];
  eg(b, g, uf(i, j, d), gb);
  h = gb >>> 0 > f >>> 0 ? d : 0;
 }
 f = a + 112 | 0;
 p = v[a + 24 >> 2];
 q = v[a + 20 >> 2];
 v[e >> 2] = b;
 v[e + 4 >> 2] = g;
 a: while (1) {
  if (d) {
   g = v[e + 4 >> 2];
   v[e + 8 >> 2] = v[e >> 2];
   v[e + 12 >> 2] = 0;
   h = h - 1 | 0;
   l = h ? l : 0;
   m = h ? m : 0;
   d = d - 1 | 0;
   g = (g << 1) + n | 0;
   b = k;
   while (1) if ((b | 0) <= 0) {
    Ob(f, v[a + 120 >> 2], v[a + 124 >> 2]);
    b = v[a + 116 >> 2];
    if (b) {
     be(f, u[(v[e + 12 >> 2] << 1) + g >> 1] / 4 << 16 >> 16);
     ae(f, b);
     v[f >> 2] = v[f >> 2];
     v[f + 4 >> 2] = 0;
    }
    g = v[c >> 2];
    b = Eg(f, o);
    v[c >> 2] = g + B(b, q);
    v[c + 4 >> 2] = v[c + 4 >> 2] + B(b, p);
    Ob(e, i, j);
    c = c + 8 | 0;
    continue a;
   } else {
    be(f, u[(v[e + 12 >> 2] << 1) + g >> 1] / 4 << 16 >> 16);
    ae(f, 4);
    Ob(e + 8 | 0, l, m);
    b = b - 1 | 0;
    continue;
   }
  }
  break;
 }
 b = v[e + 4 >> 2];
 v[a >> 2] = v[e >> 2];
 v[a + 4 >> 2] = b;
 eb = e + 16 | 0;
}

function CF(a, b, c) {
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0;
 e = eb - 16 | 0;
 eb = e;
 v[31601] = 0;
 f = O(21, e + 8 | 0, a | 0) | 0;
 d = v[31601];
 v[31601] = 0;
 a: {
  b: {
   c: {
    if ((d | 0) != 1) {
     d: {
      e: {
       if (!Hd(w[f | 0])) {
        break e;
       }
       g = qp(e + 4 | 0, a);
       d = v[v[a >> 2] - 12 >> 2] + a | 0;
       h = v[d + 4 >> 2];
       v[31601] = 0;
       i = Q(22, d | 0) | 0;
       j = v[31601];
       v[31601] = 0;
       if ((j | 0) == 1) {
        break d;
       }
       g = v[g >> 2];
       v[31601] = 0;
       c = b + c | 0;
       b = da(23, g | 0, b | 0, ((h & 176) == 32 ? c : b) | 0, c | 0, d | 0, i | 0) | 0;
       c = v[31601];
       v[31601] = 0;
       if ((c | 0) == 1) {
        break d;
       }
       if (b) {
        break e;
       }
       b = v[v[a >> 2] - 12 >> 2];
       v[31601] = 0;
       N(24, a + b | 0, 5);
       b = v[31601];
       v[31601] = 0;
       if ((b | 0) != 1) {
        break e;
       }
       break d;
      }
      dm(f);
      break b;
     }
     b = S(0) | 0;
     dm(f);
     break c;
    }
    b = S(0) | 0;
   }
   X(b | 0) | 0;
   b = v[v[a >> 2] - 12 >> 2];
   v[31601] = 0;
   V(25, a + b | 0);
   b = v[31601];
   v[31601] = 0;
   if ((b | 0) == 1) {
    break a;
   }
   Y();
  }
  eb = e + 16 | 0;
  return a;
 }
 a = M() | 0;
 v[31601] = 0;
 W(26);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) == 1) {
  S(0) | 0;
  Rb();
  p();
 }
 P(a | 0);
 p();
}

function Cna(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0;
 g = eb - 32 | 0;
 eb = g;
 e = eb - 16 | 0;
 eb = e;
 c = a + 33 | 0;
 v[b >> 2] = w[c + 206 | 0] | w[c + 207 | 0] << 8;
 rR(c, b + 48 | 0, w[c + 192 | 0], w[c + 200 | 0], w[c + 194 | 0], w[c + 195 | 0], w[c + 196 | 0], 0);
 rR(c, b + 68 | 0, w[c + 193 | 0], w[c + 201 | 0], w[c + 197 | 0], w[c + 198 | 0], w[c + 199 | 0], 1);
 f = b + 236 | 0;
 while (1) {
  if ((d | 0) == 96) {
   if (w[c + 208 | 0]) {
    t[b + 31 | 0] = w[c + 209 | 0] + 1;
    f = w[b + 31 | 0];
    a: {
     b: {
      if (!f) {
       d = 1;
       break b;
      }
      d = 16;
      if (f >>> 0 < 17) {
       break a;
      }
     }
     t[b + 31 | 0] = d;
    }
    u[e + 14 >> 1] = w[c + 210 | 0] | w[c + 211 | 0] << 8;
    u[e + 12 >> 1] = 127;
    i = b, j = w[Nc(e + 14 | 0, e + 12 | 0) | 0] + 1 | 0, t[i + 30 | 0] = j;
   }
   t[b + 33 | 0] = w[c + 212 | 0];
   eb = e + 16 | 0;
  } else {
   i = $b(f, d + 12 | 0), j = w[c + d | 0], u[i >> 1] = j;
   d = d + 1 | 0;
   continue;
  }
  break;
 }
 d = b + 236 | 0;
 while (1) {
  if ((h | 0) != 96) {
   f = $b(d, h + 12 | 0);
   e = w[c + h | 0];
   u[f >> 1] = e >>> 0 < (w[a + 27 | 0] | w[a + 28 | 0] << 8) >>> 0 ? e : 0;
   h = h + 1 | 0;
   continue;
  }
  break;
 }
 d = g + 8 | 0;
 Pk(d, 3, a + 4 | 0);
 c = g + 20 | 0;
 Bc(c, d);
 zc(b + 492 | 0, c);
 sb(c);
 if (!w[a + 241 | 0]) {
  t[b + 30 | 0] = w[a + 26 | 0];
 }
 eb = g + 32 | 0;
}

function $6(a, b, c, d, e, f, g, h, i, j) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 f = f | 0;
 g = g | 0;
 h = h | 0;
 i = i | 0;
 j = j | 0;
 var k = 0, l = 0, m = 0;
 k = eb - 16 | 0;
 eb = k;
 a: {
  if (a) {
   a = NJ(c);
   b: {
    if (b) {
     b = k + 4 | 0;
     jl(b, a);
     c = v[k + 4 >> 2];
     t[d | 0] = c;
     t[d + 1 | 0] = c >>> 8;
     t[d + 2 | 0] = c >>> 16;
     t[d + 3 | 0] = c >>> 24;
     il(b, a);
     break b;
    }
    b = k + 4 | 0;
    kt(b, a);
    c = v[k + 4 >> 2];
    t[d | 0] = c;
    t[d + 1 | 0] = c >>> 8;
    t[d + 2 | 0] = c >>> 16;
    t[d + 3 | 0] = c >>> 24;
    ci(b, a);
   }
   mh(i, b);
   Tb(b);
   l = e, m = jj(a), v[l >> 2] = m;
   l = f, m = lj(a), v[l >> 2] = m;
   b = k + 4 | 0;
   rh(b, a);
   yb(g, b);
   sb(b);
   di(b, a);
   mh(h, b);
   Tb(b);
   a = Hk(a);
   break a;
  }
  a = MJ(c);
  c: {
   if (b) {
    b = k + 4 | 0;
    jl(b, a);
    c = v[k + 4 >> 2];
    t[d | 0] = c;
    t[d + 1 | 0] = c >>> 8;
    t[d + 2 | 0] = c >>> 16;
    t[d + 3 | 0] = c >>> 24;
    il(b, a);
    break c;
   }
   b = k + 4 | 0;
   kt(b, a);
   c = v[k + 4 >> 2];
   t[d | 0] = c;
   t[d + 1 | 0] = c >>> 8;
   t[d + 2 | 0] = c >>> 16;
   t[d + 3 | 0] = c >>> 24;
   ci(b, a);
  }
  mh(i, b);
  Tb(b);
  l = e, m = jj(a), v[l >> 2] = m;
  l = f, m = lj(a), v[l >> 2] = m;
  b = k + 4 | 0;
  rh(b, a);
  yb(g, b);
  sb(b);
  di(b, a);
  mh(h, b);
  Tb(b);
  a = Hk(a);
 }
 v[j >> 2] = a;
 eb = k + 16 | 0;
}

function MQ(a, b, c) {
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0;
 e = eb - 16 | 0;
 eb = e;
 if (!(nc(v[a >> 2], v[a + 4 >> 2]) >>> 0 > 511 | v[(v[v[b >> 2] - 12 >> 2] + b | 0) + 16 >> 2])) {
  d = eb - 16 | 0;
  eb = d;
  f = Dc(64);
  v[31601] = 0;
  g = Q(874, f | 0) | 0;
  h = v[31601];
  v[31601] = 0;
  a: {
   b: {
    if ((h | 0) != 1) {
     f = xf(d + 8 | 0, g);
     g = v[f >> 2];
     v[31601] = 0;
     g = T(937, g | 0, b | 0, c | 0) | 0;
     h = v[31601];
     v[31601] = 0;
     c: {
      d: {
       if ((h | 0) != 1) {
        if ((g | 0) == 1) {
         break d;
        }
        sc(d + 12 | 0);
        break c;
       }
       a = M() | 0;
       lg(f);
       break b;
      }
      re(d + 12 | 0, f);
     }
     lg(f);
     eb = d + 16 | 0;
     d = v[d + 12 >> 2];
     break a;
    }
    a = M() | 0;
    Bb(f);
   }
   P(a | 0);
   p();
  }
  v[e + 12 >> 2] = d;
  e: {
   f: {
    if (!Dd(d)) {
     v[31601] = 0;
     b = O(935, b | 0, c | 0) | 0;
     c = v[31601];
     v[31601] = 0;
     if ((c | 0) == 1) {
      break f;
     }
     v[e + 8 >> 2] = b;
     b = e + 8 | 0;
     rZ(e + 12 | 0, me(b));
     lg(b);
     d = v[e + 12 >> 2];
    }
    if (!Dd(d)) {
     break e;
    }
    v[31601] = 0;
    N(500, a | 0, e + 12 | 0);
    a = v[31601];
    v[31601] = 0;
    i = d;
    if ((a | 0) != 1) {
     break e;
    }
   }
   a = M() | 0;
   lg(e + 12 | 0);
   P(a | 0);
   p();
  }
  lg(e + 12 | 0);
 }
 eb = e + 16 | 0;
 return i;
}

function d7(a, b, c, d, e, f, g, h, i, j) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 f = f | 0;
 g = g | 0;
 h = h | 0;
 i = i | 0;
 j = j | 0;
 var k = 0, l = 0, m = 0;
 k = eb - 16 | 0;
 eb = k;
 a: {
  if (a) {
   a = QJ(c);
   b: {
    if (b) {
     b = k + 4 | 0;
     jl(b, a);
     c = v[k + 4 >> 2];
     t[d | 0] = c;
     t[d + 1 | 0] = c >>> 8;
     t[d + 2 | 0] = c >>> 16;
     t[d + 3 | 0] = c >>> 24;
     il(b, a);
     break b;
    }
    b = k + 4 | 0;
    kt(b, a);
    c = v[k + 4 >> 2];
    t[d | 0] = c;
    t[d + 1 | 0] = c >>> 8;
    t[d + 2 | 0] = c >>> 16;
    t[d + 3 | 0] = c >>> 24;
    ci(b, a);
   }
   yb(i, b);
   sb(b);
   l = e, m = jj(a), t[l | 0] = m;
   l = f, m = lj(a), t[l | 0] = m;
   b = k + 4 | 0;
   rh(b, a);
   yb(g, b);
   sb(b);
   di(b, a);
   yb(h, b);
   sb(b);
   a = Hk(a);
   break a;
  }
  a = PJ(c);
  c: {
   if (b) {
    b = k + 4 | 0;
    jl(b, a);
    c = v[k + 4 >> 2];
    t[d | 0] = c;
    t[d + 1 | 0] = c >>> 8;
    t[d + 2 | 0] = c >>> 16;
    t[d + 3 | 0] = c >>> 24;
    il(b, a);
    break c;
   }
   b = k + 4 | 0;
   kt(b, a);
   c = v[k + 4 >> 2];
   t[d | 0] = c;
   t[d + 1 | 0] = c >>> 8;
   t[d + 2 | 0] = c >>> 16;
   t[d + 3 | 0] = c >>> 24;
   ci(b, a);
  }
  yb(i, b);
  sb(b);
  l = e, m = jj(a), t[l | 0] = m;
  l = f, m = lj(a), t[l | 0] = m;
  b = k + 4 | 0;
  rh(b, a);
  yb(g, b);
  sb(b);
  di(b, a);
  yb(h, b);
  sb(b);
  a = Hk(a);
 }
 v[j >> 2] = a;
 eb = k + 16 | 0;
}

function rma(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0;
 f = eb - 16 | 0;
 eb = f;
 g = v[a + 12 >> 2];
 h = v[a + 8 >> 2];
 a: {
  b: {
   if ((g | 0) <= 1 & h >>> 0 <= 805306368 | (g | 0) <= 0) {
    e = 131112;
    if ((g | 0) >= -2 & h >>> 0 >= 3489660928 | (g | 0) > -2) {
     break a;
    }
    e = 262184;
    if ((g | 0) == -2 & h >>> 0 < 2147483648 | g >>> 0 < 4294967294) {
     break a;
    }
    break b;
   }
   e = 262184;
   if ((g | 0) == 1 & h >>> 0 > 2147483648 | g >>> 0 > 1) {
    break a;
   }
  }
  e = 196648;
 }
 j = v[a + 16 >> 2];
 k = v[a + 24 >> 2];
 l = v[a + 20 >> 2];
 i = v[a + 4 >> 2];
 v[f + 8 >> 2] = v[a >> 2];
 v[f + 12 >> 2] = i;
 i = b + e | 0;
 while (1) {
  if (d) {
   b = v[f + 8 >> 2];
   e = (v[f + 12 >> 2] << 1) + j | 0;
   b = (b >>> 16 & 65520) + i | 0;
   b = (((((((B(u[e - 4 >> 1], u[b + 2 >> 1]) + B(u[e - 6 >> 1], u[b >> 1]) | 0) + B(u[e - 2 >> 1], u[b + 4 >> 1]) | 0) + B(u[e >> 1], u[b + 6 >> 1]) | 0) + B(u[e + 2 >> 1], u[b + 8 >> 1]) | 0) + B(u[e + 4 >> 1], u[b + 10 >> 1]) | 0) + B(u[e + 6 >> 1], u[b + 12 >> 1]) | 0) + B(u[e + 8 >> 1], u[b + 14 >> 1]) | 0) / 32768 | 0;
   v[c >> 2] = v[c >> 2] + B(b, l);
   v[c + 4 >> 2] = v[c + 4 >> 2] + B(b, k);
   Ob(f + 8 | 0, h, g);
   c = c + 8 | 0;
   d = d - 1 | 0;
   continue;
  }
  break;
 }
 b = v[f + 12 >> 2];
 v[a >> 2] = v[f + 8 >> 2];
 v[a + 4 >> 2] = b;
 eb = f + 16 | 0;
}

function Dx(a, b, c) {
 var d = 0, e = 0, f = 0, g = 0;
 d = Eb(a);
 a = w[b + 11 | 0];
 e = v[b + 4 >> 2];
 v[31601] = 0;
 N(114, d | 0, Zc(e, a) | 0);
 a = v[31601];
 v[31601] = 0;
 if ((a | 0) != 1) {
  a: {
   while (1) {
    if (Zc(v[b + 4 >> 2], w[b + 11 | 0]) >>> 0 > f >>> 0) {
     a = 32;
     e = v[Vd(b, f) >> 2];
     g = (e & -32) == 128;
     b: {
      while (1) {
       c: {
        if ((a | 0) == 256) {
         a = 0;
         break c;
        }
        if ((e | 0) != v[(a << 2) + c >> 2] | g) {
         a = a + 1 | 0;
         continue;
        } else {
         v[31601] = 0;
         N(115, d | 0, a << 24 >> 24);
         a = v[31601];
         v[31601] = 0;
         if ((a | 0) != 1) {
          break b;
         }
         break a;
        }
       }
       break;
      }
      d: {
       while (1) {
        if ((a | 0) == 32) {
         break d;
        }
        if ((e | 0) != v[(a << 2) + c >> 2]) {
         a = a + 1 | 0;
         continue;
        }
        break;
       }
       v[31601] = 0;
       N(115, d | 0, a << 24 >> 24);
       a = v[31601];
       v[31601] = 0;
       if ((a | 0) != 1) {
        break b;
       }
       break a;
      }
      v[31601] = 0;
      N(115, d | 0, 63);
      a = v[31601];
      v[31601] = 0;
      if ((a | 0) != 1) {
       break b;
      }
      break a;
     }
     f = f + 1 | 0;
     continue;
    }
    break;
   }
   return;
  }
 }
 a = M() | 0;
 sb(d);
 P(a | 0);
 p();
}

function zsa(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0;
 md(b, 32);
 ep(b);
 f = b, g = Ab(w[a + 40 | 0] | w[a + 41 | 0] << 8) >>> 2 | 0, u[f + 32 >> 1] = g;
 d = x[b + 34 >> 1];
 if ((ye((w[a + 38 | 0] | w[a + 39 | 0] << 8) << 16 >> 16) | 0) > 0) {
  d = d | 32;
  u[b + 34 >> 1] = d;
  c = ye((w[a + 38 | 0] | w[a + 39 | 0] << 8) << 16 >> 16);
  e = (c << 8 & -256) + 2047 | 0;
  c = c >>> 24 | 0;
  f = b, g = Ac(Cua(e, e >>> 0 < 2047 ? c + 1 | 0 : c, 4095, 0), gb), u[f + 28 >> 1] = g;
 }
 f = b, g = _b(w[a + 58 | 0] | w[a + 59 | 0] << 8 | (w[a + 60 | 0] << 16 | w[a + 61 | 0] << 24)), 
 v[f >> 2] = g;
 f = b, g = _b(w[a + 62 | 0] | w[a + 63 | 0] << 8 | (w[a + 64 | 0] << 16 | w[a + 65 | 0] << 24)), 
 v[f + 4 >> 2] = g;
 f = b, g = _b(w[a + 62 | 0] | w[a + 63 | 0] << 8 | (w[a + 64 | 0] << 16 | w[a + 65 | 0] << 24)) + _b(w[a + 66 | 0] | w[a + 67 | 0] << 8 | (w[a + 68 | 0] << 16 | w[a + 69 | 0] << 24)) | 0, 
 v[f + 8 >> 2] = g;
 c = d & -3 | ((Ab(w[a + 44 | 0] | w[a + 45 | 0] << 8) | 0) != 0) << 1;
 u[b + 34 >> 1] = c;
 f = b, g = c & 65531 | Ab(w[a + 44 | 0] | w[a + 45 | 0] << 8) << 1 & 4, u[f + 34 >> 1] = g;
 f = b, g = _b(w[a + 54 | 0] | w[a + 55 | 0] << 8 | (w[a + 56 | 0] << 16 | w[a + 57 | 0] << 24)) << 1, 
 v[f + 24 >> 2] = g;
 c = ye((w[a + 42 | 0] | w[a + 43 | 0] << 8) << 16 >> 16);
 if (c) {
  Yl(b, +(c | 0) / 96);
  c = ye((w[a + 42 | 0] | w[a + 43 | 0] << 8) << 16 >> 16);
 }
 t[b + 37 | 0] = c << 4;
}

function sma(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0;
 f = eb - 16 | 0;
 eb = f;
 g = v[a + 12 >> 2];
 h = v[a + 8 >> 2];
 a: {
  b: {
   if ((g | 0) <= 1 & h >>> 0 <= 805306368 | (g | 0) <= 0) {
    e = 131112;
    if ((g | 0) >= -2 & h >>> 0 >= 3489660928 | (g | 0) > -2) {
     break a;
    }
    e = 262184;
    if ((g | 0) == -2 & h >>> 0 < 2147483648 | g >>> 0 < 4294967294) {
     break a;
    }
    break b;
   }
   e = 262184;
   if ((g | 0) == 1 & h >>> 0 > 2147483648 | g >>> 0 > 1) {
    break a;
   }
  }
  e = 196648;
 }
 j = v[a + 16 >> 2];
 k = v[a + 24 >> 2];
 l = v[a + 20 >> 2];
 i = v[a + 4 >> 2];
 v[f + 8 >> 2] = v[a >> 2];
 v[f + 12 >> 2] = i;
 i = b + e | 0;
 while (1) {
  if (d) {
   b = v[f + 8 >> 2];
   e = v[f + 12 >> 2] + j | 0;
   b = (b >>> 16 & 65520) + i | 0;
   b = (((((((B(t[e - 2 | 0], u[b + 2 >> 1]) + B(t[e - 3 | 0], u[b >> 1]) | 0) + B(t[e - 1 | 0], u[b + 4 >> 1]) | 0) + B(t[e | 0], u[b + 6 >> 1]) | 0) + B(t[e + 1 | 0], u[b + 8 >> 1]) | 0) + B(t[e + 2 | 0], u[b + 10 >> 1]) | 0) + B(t[e + 3 | 0], u[b + 12 >> 1]) | 0) + B(t[e + 4 | 0], u[b + 14 >> 1]) << 8) / 32768 | 0;
   v[c >> 2] = v[c >> 2] + B(b, l);
   v[c + 4 >> 2] = v[c + 4 >> 2] + B(b, k);
   Ob(f + 8 | 0, h, g);
   c = c + 8 | 0;
   d = d - 1 | 0;
   continue;
  }
  break;
 }
 b = v[f + 12 >> 2];
 v[a >> 2] = v[f + 8 >> 2];
 v[a + 4 >> 2] = b;
 eb = f + 16 | 0;
}

function KH(a, b, c, d, e, f, g, h) {
 var i = 0, j = 0, k = C(0);
 i = eb - 96 | 0;
 eb = i;
 NA(v[a + 24 >> 2]);
 t[v[a + 24 >> 2] + 1298424 | 0] = v[a + 52 >> 2] != 0;
 v[i + 92 >> 2] = f;
 v[i + 88 >> 2] = e;
 v[i + 84 >> 2] = d;
 v[i + 80 >> 2] = c;
 a: {
  d = i + 80 | 0;
  c = 0;
  while (1) {
   b: {
    if ((c | 0) != 4) {
     if (v[(c << 2) + d >> 2]) {
      break b;
     }
    } else {
     c = 4;
    }
    break a;
   }
   c = c + 1 | 0;
   continue;
  }
 }
 v[i + 44 >> 2] = b;
 v[i + 40 >> 2] = c;
 v[i + 36 >> 2] = d;
 e = v[a + 32 >> 2];
 k = z[a + 48 >> 2];
 v[i + 8 >> 2] = b;
 c = v[i + 40 >> 2];
 v[i >> 2] = v[i + 36 >> 2];
 v[i + 4 >> 2] = c;
 d = eb - 16 | 0;
 eb = d;
 v[d + 8 >> 2] = v[i + 8 >> 2];
 c = v[i + 4 >> 2];
 v[d >> 2] = v[i >> 2];
 v[d + 4 >> 2] = c;
 c = FM(i + 48 | 0);
 v[c + 8 >> 2] = e;
 v[c + 4 >> 2] = 0;
 v[c >> 2] = h;
 e = v[d + 4 >> 2];
 v[c + 12 >> 2] = v[d >> 2];
 v[c + 16 >> 2] = e;
 v[c + 20 >> 2] = v[d + 8 >> 2];
 A[c + 24 >> 3] = k;
 v[c >> 2] = g;
 eb = d + 16 | 0;
 while (1) {
  if (b) {
   d = v[a + 24 >> 2];
   v[i + 24 >> 2] = b;
   v[i + 28 >> 2] = 0;
   v[i + 16 >> 2] = 134217727;
   v[i + 20 >> 2] = 0;
   d = GM(d, v[Wr(i + 24 | 0, i + 16 | 0) >> 2], c);
   j = d + j | 0;
   b = b - d | 0;
   if (d) {
    continue;
   }
  }
  break;
 }
 if (!(v[a + 52 >> 2] != 1 | j)) {
  a = v[a + 24 >> 2];
  v[a + 480208 >> 2] = v[a + 480208 >> 2] & -513;
 }
 eb = i + 96 | 0;
 return j;
}

function U4(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0;
 e = nJ(a, 0);
 f = eb - 16 | 0;
 eb = f;
 c = 4;
 a = UI(e + 12 | 0, b);
 while (1) {
  Eb(a + c | 0);
  d = 172;
  c = c + 12 | 0;
  if ((c | 0) != 172) {
   continue;
  }
  break;
 }
 while (1) {
  Eb(a + d | 0);
  c = 460;
  d = d + 12 | 0;
  if ((d | 0) != 460) {
   continue;
  }
  break;
 }
 while (1) {
  Eb(a + c | 0);
  c = c + 12 | 0;
  if ((c | 0) != 484) {
   continue;
  }
  break;
 }
 c = Eb(a + 484 | 0);
 d = Eb(a + 496 | 0);
 h = Eb(a + 508 | 0);
 i = Eb(a + 520 | 0);
 v[31601] = 0;
 b = O(1377, f + 4 | 0, b | 0) | 0;
 g = v[31601];
 v[31601] = 0;
 a: {
  b: {
   c: {
    if ((g | 0) != 1) {
     v[31601] = 0;
     N(1378, a | 0, b | 0);
     g = v[31601];
     v[31601] = 0;
     if ((g | 0) == 1) {
      break c;
     }
     dt(b);
     eb = f + 16 | 0;
     break a;
    }
    e = M() | 0;
    break b;
   }
   e = M() | 0;
   dt(b);
  }
  Tb(i);
  Tb(h);
  Tb(d);
  Tb(c);
  d = 484;
  while (1) {
   d = d - 12 | 0;
   Tb(a + d | 0);
   c = 460;
   if ((d | 0) != 460) {
    continue;
   }
   break;
  }
  while (1) {
   c = c - 12 | 0;
   Tb(a + c | 0);
   d = 172;
   if ((c | 0) != 172) {
    continue;
   }
   break;
  }
  while (1) {
   d = d - 12 | 0;
   Tb(a + d | 0);
   if ((d | 0) != 4) {
    continue;
   }
   break;
  }
  ct(a);
  P(e | 0);
  p();
 }
 v[e + 8 >> 2] = 100100;
 v[e >> 2] = 100024;
 return e | 0;
}

function W4(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0;
 e = oJ(a, 0);
 f = eb - 32 | 0;
 eb = f;
 c = 4;
 a = UI(e + 12 | 0, b);
 while (1) {
  Eb(a + c | 0);
  d = 172;
  c = c + 12 | 0;
  if ((c | 0) != 172) {
   continue;
  }
  break;
 }
 while (1) {
  Eb(a + d | 0);
  c = 460;
  d = d + 12 | 0;
  if ((d | 0) != 460) {
   continue;
  }
  break;
 }
 while (1) {
  Eb(a + c | 0);
  c = c + 12 | 0;
  if ((c | 0) != 484) {
   continue;
  }
  break;
 }
 c = Eb(a + 484 | 0);
 d = Eb(a + 496 | 0);
 h = Eb(a + 508 | 0);
 i = Eb(a + 520 | 0);
 v[31601] = 0;
 b = O(1375, f + 12 | 0, b | 0) | 0;
 g = v[31601];
 v[31601] = 0;
 a: {
  b: {
   c: {
    if ((g | 0) != 1) {
     v[31601] = 0;
     N(1376, a | 0, b | 0);
     g = v[31601];
     v[31601] = 0;
     if ((g | 0) == 1) {
      break c;
     }
     at(b);
     eb = f + 32 | 0;
     break a;
    }
    e = M() | 0;
    break b;
   }
   e = M() | 0;
   at(b);
  }
  sb(i);
  sb(h);
  sb(d);
  sb(c);
  d = 484;
  while (1) {
   d = d - 12 | 0;
   sb(a + d | 0);
   c = 460;
   if ((d | 0) != 460) {
    continue;
   }
   break;
  }
  while (1) {
   c = c - 12 | 0;
   sb(a + c | 0);
   d = 172;
   if ((c | 0) != 172) {
    continue;
   }
   break;
  }
  while (1) {
   d = d - 12 | 0;
   sb(a + d | 0);
   if ((d | 0) != 4) {
    continue;
   }
   break;
  }
  ct(a);
  P(e | 0);
  p();
 }
 v[e + 8 >> 2] = 99804;
 v[e >> 2] = 99728;
 return e | 0;
}

function Nla(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0;
 e = eb - 16 | 0;
 eb = e;
 n = v[a + 16 >> 2];
 o = Fg(b + 327720 | 0, v[b + 20 >> 2], (v[a + 88 >> 2] & 16384) >>> 14 | 0);
 i = v[a + 8 >> 2];
 j = v[a + 12 >> 2];
 b = v[a >> 2];
 g = v[a + 4 >> 2];
 k = v[a + 128 >> 2];
 if (k) {
  l = Gg(i, j, k);
  m = gb;
  f = v[a + 76 >> 2];
  eg(b, g, uf(i, j, d), gb);
  h = gb >>> 0 > f >>> 0 ? d : 0;
 }
 f = a + 112 | 0;
 p = v[a + 24 >> 2];
 q = v[a + 20 >> 2];
 v[e >> 2] = b;
 v[e + 4 >> 2] = g;
 a: while (1) {
  if (d) {
   g = v[e + 4 >> 2];
   v[e + 8 >> 2] = v[e >> 2];
   v[e + 12 >> 2] = 0;
   h = h - 1 | 0;
   l = h ? l : 0;
   m = h ? m : 0;
   d = d - 1 | 0;
   g = g + n | 0;
   b = k;
   while (1) if ((b | 0) <= 0) {
    Ob(f, v[a + 120 >> 2], v[a + 124 >> 2]);
    b = v[a + 116 >> 2];
    if (b) {
     be(f, t[v[e + 12 >> 2] + g | 0] << 6);
     ae(f, b);
     v[f >> 2] = v[f >> 2];
     v[f + 4 >> 2] = 0;
    }
    g = v[c >> 2];
    b = Eg(f, o);
    v[c >> 2] = g + B(b, q);
    v[c + 4 >> 2] = v[c + 4 >> 2] + B(b, p);
    Ob(e, i, j);
    c = c + 8 | 0;
    continue a;
   } else {
    be(f, t[v[e + 12 >> 2] + g | 0] << 6);
    ae(f, 4);
    Ob(e + 8 | 0, l, m);
    b = b - 1 | 0;
    continue;
   }
  }
  break;
 }
 b = v[e + 4 >> 2];
 v[a >> 2] = v[e >> 2];
 v[a + 4 >> 2] = b;
 eb = e + 16 | 0;
}

function Yga(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = C(0), g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = C(0), o = C(0), p = 0, q = 0, r = 0, s = 0, t = 0, u = 0, x = 0;
 h = eb - 16 | 0;
 eb = h;
 if (si(a + 44 | 0)) {
  g = v[a + 44 >> 2];
  u = h, x = Gc(g, 0), v[u + 8 >> 2] = x;
  u = h, x = Gc(g, 1), v[u + 12 >> 2] = x;
  g = v[a + 56 >> 2];
  l = Gc(g, 0);
  v[h >> 2] = l;
  m = Gc(g, 1);
  v[h + 4 >> 2] = m;
  p = a + 4252 | 0;
  q = a + 4244 | 0;
  r = a + 4228 | 0;
  s = w[a + 4273 | 0];
  t = w[a + 4272 | 0];
  g = d;
  while (1) {
   k = 0;
   if (g) {
    while (1) {
     if ((k | 0) != 2) {
      i = k << 2;
      j = i + (h + 8 | 0) | 0;
      e = v[j >> 2];
      v[j >> 2] = e + 4;
      f = C(z[e >> 2] * z[a + 4240 >> 2]);
      e = i + r | 0;
      f = C(f + C(z[e >> 2] * z[a + 4236 >> 2]));
      z[e >> 2] = f;
      f = _P(C(f * C(1073741824)), t, s);
      e = i + q | 0;
      j = i + p | 0;
      n = z[j >> 2];
      o = z[a + 4264 >> 2];
      f = C(C(C(f * z[a + 4260 >> 2]) - C(z[a + 4268 >> 2] * z[e >> 2])) - C(n * o));
      z[e >> 2] = C(f * o) + n;
      z[j >> 2] = f;
      e = h + i | 0;
      i = v[e >> 2];
      v[e >> 2] = i + 4;
      z[i >> 2] = f * C(9.313225746154785e-10);
      k = k + 1 | 0;
      continue;
     }
     break;
    }
    g = g - 1 | 0;
    continue;
   } else {
    Hi(a, b, c, l, m, d);
   }
   break;
  }
 }
 eb = h + 16 | 0;
}

function $la(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0, w = 0, x = 0;
 e = eb - 16 | 0;
 eb = e;
 i = v[a + 24 >> 2];
 j = v[a + 20 >> 2];
 k = v[a + 16 >> 2];
 h = v[a + 4 >> 2];
 v[e + 8 >> 2] = v[a >> 2];
 v[e + 12 >> 2] = h;
 l = b + 24 | 0;
 h = v[a + 8 >> 2];
 m = v[a + 12 >> 2];
 while (1) {
  if (d) {
   b = v[e + 8 >> 2];
   n = (((v[e + 12 >> 2] & 2147483647) << 1 | b >>> 31) & -2) + k | 0;
   b = (((b >>> 16 | 0) + 4 & 131064) << 1) + l | 0;
   o = u[b + 10 >> 1] << 8;
   p = u[b + 8 >> 1] << 8;
   q = u[b + 12 >> 1] << 8;
   r = u[b + 14 >> 1] << 8;
   s = u[b + 2 >> 1] << 8;
   w = u[b >> 1] << 8;
   x = u[b + 4 >> 1] << 8;
   b = u[b + 6 >> 1] << 8;
   g = 0;
   while (1) {
    if ((g | 0) != 2) {
     f = g + n | 0;
     v[(g << 2) + e >> 2] = ((((B(t[f + 4 | 0], o) + B(t[f + 2 | 0], p) | 0) + B(t[f + 6 | 0], q) | 0) + B(t[f + 8 | 0], r) >> 1) + (((B(t[f - 4 | 0], s) + B(t[f - 6 | 0], w) | 0) + B(t[f - 2 | 0], x) | 0) + B(t[f | 0], b) >> 1) | 0) / 16384;
     g = g + 1 | 0;
     continue;
    }
    break;
   }
   v[c >> 2] = v[c >> 2] + B(v[e >> 2], j);
   v[c + 4 >> 2] = v[c + 4 >> 2] + B(v[e + 4 >> 2], i);
   Ob(e + 8 | 0, h, m);
   c = c + 8 | 0;
   d = d - 1 | 0;
   continue;
  }
  break;
 }
 b = v[e + 12 >> 2];
 v[a >> 2] = v[e + 8 >> 2];
 v[a + 4 >> 2] = b;
 eb = e + 16 | 0;
}

function C2(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0;
 c = eb - 32 | 0;
 eb = c;
 v[c + 28 >> 2] = 0;
 if (Hd(w[Em(c + 27 | 0, a, 0) | 0])) {
  bd(c + 16 | 0, v[(v[v[a >> 2] - 12 >> 2] + a | 0) + 28 >> 2]);
  v[31601] = 0;
  e = Q(1222, v[c + 16 >> 2]) | 0;
  d = v[31601];
  v[31601] = 0;
  a: {
   b: {
    if ((d | 0) != 1) {
     d = qp(c + 12 | 0, a);
     f = sc(c + 8 | 0);
     g = v[v[a >> 2] - 12 >> 2];
     f = v[f >> 2];
     d = v[d >> 2];
     v[31601] = 0;
     ia(1224, e | 0, d | 0, f | 0, a + g | 0, c + 28 | 0, c + 20 | 0);
     e = v[31601];
     v[31601] = 0;
     if ((e | 0) != 1) {
      break b;
     }
    }
    b = S(0) | 0;
    Zb(c + 16 | 0);
    X(b | 0) | 0;
    b = v[c + 28 >> 2] | 1;
    v[c + 28 >> 2] = b;
    Cm(v[v[a >> 2] - 12 >> 2] + a | 0, b);
    c: {
     d: {
      if (v[(v[v[a >> 2] - 12 >> 2] + a | 0) + 20 >> 2] & 1) {
       v[31601] = 0;
       W(84);
       a = v[31601];
       v[31601] = 0;
       if ((a | 0) != 1) {
        break c;
       }
       a = M() | 0;
       v[31601] = 0;
       W(26);
       b = v[31601];
       v[31601] = 0;
       if ((b | 0) == 1) {
        break d;
       }
       P(a | 0);
       p();
      }
      Y();
      break a;
     }
     S(0) | 0;
     Rb();
    }
    p();
   }
   Zb(c + 16 | 0);
   v[b >> 2] = v[c + 20 >> 2];
  }
  Wj(v[v[a >> 2] - 12 >> 2] + a | 0, v[c + 28 >> 2]);
 }
 eb = c + 32 | 0;
 return a | 0;
}

function Jea(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0;
 h = eb - 16 | 0;
 eb = h;
 g = Jb(b);
 e = Cb(v[b + 4 >> 2], w[b + 11 | 0]);
 i = Jb(c);
 f = Cb(v[c + 4 >> 2], w[c + 11 | 0]);
 d = e + g | 0;
 e = -1;
 a: {
  while (1) {
   if ((d | 0) == (g | 0)) {
    break a;
   }
   d = d - 1 | 0;
   if (sq(i, f, w[d | 0])) {
    continue;
   }
   break;
  }
  e = d - g | 0;
 }
 b: {
  c: {
   if ((e | 0) != -1) {
    f = ub(h + 12 | 0, Pe(Pe(yd(b), e), 1));
    c = ub(h + 8 | 0, Cf(b));
    $r(b, v[f >> 2], v[c >> 2]);
    break c;
   }
   if (!Zc(v[b + 4 >> 2], w[b + 11 | 0])) {
    break c;
   }
   i = Jb(b);
   e = Cb(v[b + 4 >> 2], w[b + 11 | 0]);
   f = Jb(c);
   d = Cb(v[c + 4 >> 2], w[c + 11 | 0]);
   if (!e | !d) {
    c = -1;
   } else {
    c = i;
    e = e + c | 0;
    j = d + f | 0;
    while (1) {
     d: {
      d = f;
      e: {
       if ((c | 0) != (e | 0)) {
        while (1) {
         if ((d | 0) == (j | 0)) {
          break e;
         }
         g = t[d | 0];
         d = d + 1 | 0;
         if (!lc(t[c | 0], g)) {
          continue;
         }
         break;
        }
       } else {
        c = e;
       }
       break d;
      }
      c = c + 1 | 0;
      continue;
     }
     break;
    }
    c = (c | 0) == (e | 0) ? -1 : c - i | 0;
   }
   if (c) {
    break c;
   }
   Eb(a);
   break b;
  }
  Uc(a, b);
 }
 eb = h + 16 | 0;
}

function f2(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0;
 h = eb - 16 | 0;
 eb = h;
 g = Jb(b);
 e = Cb(v[b + 4 >> 2], w[b + 11 | 0]);
 i = Jb(c);
 f = Cb(v[c + 4 >> 2], w[c + 11 | 0]);
 d = e + g | 0;
 e = -1;
 a: {
  while (1) {
   if ((d | 0) == (g | 0)) {
    break a;
   }
   d = d - 1 | 0;
   if (Du(i, f, w[d | 0])) {
    continue;
   }
   break;
  }
  e = d - g | 0;
 }
 b: {
  c: {
   if ((e | 0) != -1) {
    f = ub(h + 12 | 0, Pe(Pe(yd(b), e), 1));
    c = ub(h + 8 | 0, Cf(b));
    $r(b, v[f >> 2], v[c >> 2]);
    break c;
   }
   if (!Zc(v[b + 4 >> 2], w[b + 11 | 0])) {
    break c;
   }
   i = Jb(b);
   e = Cb(v[b + 4 >> 2], w[b + 11 | 0]);
   f = Jb(c);
   d = Cb(v[c + 4 >> 2], w[c + 11 | 0]);
   if (!e | !d) {
    c = -1;
   } else {
    c = i;
    e = e + c | 0;
    j = d + f | 0;
    while (1) {
     d: {
      d = f;
      e: {
       if ((c | 0) != (e | 0)) {
        while (1) {
         if ((d | 0) == (j | 0)) {
          break e;
         }
         g = w[d | 0];
         d = d + 1 | 0;
         if (!lc(w[c | 0], g)) {
          continue;
         }
         break;
        }
       } else {
        c = e;
       }
       break d;
      }
      c = c + 1 | 0;
      continue;
     }
     break;
    }
    c = (c | 0) == (e | 0) ? -1 : c - i | 0;
   }
   if (c) {
    break c;
   }
   Eb(a);
   break b;
  }
  Uc(a, b);
 }
 eb = h + 16 | 0;
}

function qB(a, b, c, d, e) {
 var f = 0, g = 0, h = 0;
 f = (B(c, 872) + b | 0) + 616 | 0;
 a: {
  if (d) {
   if (!Nb(a + 1074312 | 0, 90)) {
    t[f + 811 | 0] = d;
   }
   t[f + 812 | 0] = d;
   break a;
  }
  d = w[f + 812 | 0];
 }
 g = v[a + 480180 >> 2];
 if (!e) {
  h = Ku(g);
 }
 b: {
  if ((g | 0) != 268435456) {
   if ((g | 0) != 16777216) {
    break b;
   }
   g = v[f + 656 >> 2];
   if (!g | !v[g + 44 >> 2]) {
    break b;
   }
   a = d & 255;
   if (!(a >>> 0 < 240 | e)) {
    RS(b, c, 240 - a | 0);
    return;
   }
   if (!(a >>> 0 < 224 | e)) {
    QS(f, 224 - a | 0);
    return;
   }
   PS(f, 0 - a | 0);
   return;
  }
  v[f + 708 >> 2] = 65535;
 }
 b = d & 255;
 c: {
  d: {
   if (!(b >>> 0 > 223 & h)) {
    break d;
   }
   e: {
    c = b & 15;
    if (!c) {
     break e;
    }
    d = d & 240;
    if ((d | 0) != 224) {
     if ((d | 0) != 240) {
      break e;
     }
     nB(a, f, c);
     return;
    }
    if (v[a + 480180 >> 2] == 524288) {
     break d;
    }
    mB(a, f, c);
    return;
   }
   if (v[a + 480180 >> 2] != 524288) {
    break c;
   }
  }
  f: {
   if (!(t[f + 851 | 0] & 1)) {
    break f;
   }
   if (v[a + 1074416 >> 2] == 1) {
    if (Nb(a + 1074312 | 0, 6)) {
     break f;
    }
   }
   c = v[a + 480180 >> 2];
   if (c & 32832) {
    break f;
   }
   if (!(w[a + 480208 | 0] & 2) | (c | 0) != 8) {
    break c;
   }
  }
  vk(a, f, f + 700 | 0, 0 - (b << 2) | 0, 0);
 }
}

function RX(a) {
 var b = 0, c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0;
 while (1) {
  if ((c | 0) != 20) {
   g = b;
   b = t[a + c | 0];
   b = g + ((b & 255) != 0 & (b | 0) < 32) | 0;
   c = c + 1 | 0;
   continue;
  }
  break;
 }
 d = b;
 a: {
  if (b >>> 0 > 5) {
   break a;
  }
  f = a + 20 | 0;
  while (1) {
   if ((h | 0) != 15) {
    e = B(h, 30) + f | 0;
    c = 0;
    b = 0;
    while (1) {
     if ((c | 0) != 22) {
      g = b;
      b = t[c + e | 0];
      b = g + ((b & 255) != 0 & (b | 0) < 32) | 0;
      c = c + 1 | 0;
      continue;
     }
     break;
    }
    d = b + d | 0;
    if (d >>> 0 > 48) {
     break a;
    }
    c = w[e + 25 | 0];
    if (w[e + 24 | 0] | c >>> 0 > 64) {
     break a;
    }
    b = Ab(w[e + 22 | 0] | w[e + 23 | 0] << 8);
    if (b >>> 0 > 32768) {
     break a;
    }
    h = h + 1 | 0;
    i = c | i;
    j = b + j | 0;
    continue;
   }
   break;
  }
  if (!j | !(i & 255)) {
   break a;
  }
  d = w[a + 470 | 0];
  if (d >>> 0 > 128) {
   break a;
  }
  b = w[a + 471 | 0];
  if (b >>> 0 > 220) {
   break a;
  }
  a = a + 472 | 0;
  f = RC(a);
  b: {
   if ((a | 0) == (f | 0)) {
    break b;
   }
   c = a;
   while (1) {
    c = c + 1 | 0;
    if ((f | 0) == (c | 0)) {
     break b;
    }
    a = Zt(w[a | 0], w[c | 0]) ? c : a;
    continue;
   }
  }
  a = w[a | 0];
  if (a >>> 0 > 63) {
   break a;
  }
  k = (b | (a | d)) != 0;
 }
 return k;
}

function df(a, b, c) {
 var d = 0, e = 0, f = 0;
 d = Eb(a);
 a = w[b + 11 | 0];
 e = v[b + 4 >> 2];
 v[31601] = 0;
 N(114, d | 0, Zc(e, a) | 0);
 a = v[31601];
 v[31601] = 0;
 if ((a | 0) != 1) {
  a: {
   while (1) {
    if (Zc(v[b + 4 >> 2], w[b + 11 | 0]) >>> 0 > f >>> 0) {
     e = v[Vd(b, f) >> 2];
     a = 32;
     b: {
      while (1) {
       c: {
        if ((a | 0) == 256) {
         a = 0;
         break c;
        }
        if ((e | 0) == v[(a << 2) + c >> 2]) {
         v[31601] = 0;
         N(115, d | 0, a << 24 >> 24);
         a = v[31601];
         v[31601] = 0;
         if ((a | 0) != 1) {
          break b;
         }
         break a;
        } else {
         a = a + 1 | 0;
         continue;
        }
       }
       break;
      }
      d: {
       while (1) {
        if ((a | 0) == 32) {
         break d;
        }
        if ((e | 0) != v[(a << 2) + c >> 2]) {
         a = a + 1 | 0;
         continue;
        }
        break;
       }
       v[31601] = 0;
       N(115, d | 0, a << 24 >> 24);
       a = v[31601];
       v[31601] = 0;
       if ((a | 0) != 1) {
        break b;
       }
       break a;
      }
      v[31601] = 0;
      N(115, d | 0, 63);
      a = v[31601];
      v[31601] = 0;
      if ((a | 0) != 1) {
       break b;
      }
      break a;
     }
     f = f + 1 | 0;
     continue;
    }
    break;
   }
   return;
  }
 }
 a = M() | 0;
 sb(d);
 P(a | 0);
 p();
}

function kG(a, b) {
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0;
 h = eb - 16 | 0;
 eb = h;
 d = zb(a);
 c = ub(h + 12 | 0, v[a + 4 >> 2]);
 g = ub(h + 8 | 0, v[a >> 2]);
 f = ub(h + 4 | 0, v[b + 4 >> 2]);
 e = v[c >> 2];
 g = v[g >> 2];
 c = eb + -64 | 0;
 eb = c;
 f = v[f >> 2];
 v[c + 56 >> 2] = f;
 v[c + 60 >> 2] = e;
 v[c + 52 >> 2] = f;
 d = zg(c + 24 | 0, d, c + 52 | 0, c + 56 | 0);
 v[c + 16 >> 2] = v[d + 8 >> 2];
 f = v[d + 4 >> 2];
 v[c + 8 >> 2] = v[d >> 2];
 v[c + 12 >> 2] = f;
 yg(c + 36 | 0, c + 8 | 0);
 while (1) {
  if (Ed(e, g)) {
   gx(iG(v[c + 56 >> 2]), bj(e));
   e = jG(c + 60 | 0);
   jG(c + 56 | 0);
   e = v[e >> 2];
   continue;
  }
  break;
 }
 xg(c + 36 | 0);
 i = v[c + 56 >> 2];
 if (!w[c + 48 | 0]) {
  g = eb - 16 | 0;
  eb = g;
  d = ub(g + 12 | 0, v[v[c + 44 >> 2] >> 2]);
  j = v[ub(g + 8 | 0, v[v[c + 40 >> 2] >> 2]) >> 2];
  e = eb - 16 | 0;
  eb = e;
  f = v[d >> 2];
  v[e + 12 >> 2] = f;
  while (1) {
   if (vi(f, j)) {
    d = eb - 16 | 0;
    eb = d;
    v[d + 12 >> 2] = f;
    v[d + 12 >> 2] = v[d + 12 >> 2] + 36;
    eb = d + 16 | 0;
    Hp(iG(v[d + 12 >> 2]));
    v[e + 12 >> 2] = v[e + 12 >> 2] + 36;
    f = v[e + 12 >> 2];
    continue;
   }
   break;
  }
  eb = e + 16 | 0;
  eb = g + 16 | 0;
 }
 eb = c - -64 | 0;
 v[b + 4 >> 2] = i;
 Sb(a, b + 4 | 0);
 Sb(a + 4 | 0, b + 8 | 0);
 Sb(zb(a), mc(b));
 v[b >> 2] = v[b + 4 >> 2];
 eb = h + 16 | 0;
}

function zia(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0;
 a: {
  b: {
   if ((fk(v[a >> 2], v[a + 4 >> 2]) | 0) == 2) {
    if ((fk(v[a + 12 >> 2], v[a + 16 >> 2]) | 0) == (b | 0)) {
     break b;
    }
   }
   v[31601] = 0;
   N(942, a | 0, 2);
   c = v[31601];
   v[31601] = 0;
   c: {
    if ((c | 0) == 1) {
     break c;
    }
    v[31601] = 0;
    N(942, a + 12 | 0, b | 0);
    c = v[31601];
    v[31601] = 0;
    if ((c | 0) == 1) {
     break c;
    }
    v[31601] = 0;
    N(943, a + 24 | 0, 2);
    c = v[31601];
    v[31601] = 0;
    if ((c | 0) == 1) {
     break c;
    }
    v[31601] = 0;
    N(943, a + 36 | 0, b | 0);
    c = v[31601];
    v[31601] = 0;
    if ((c | 0) == 1) {
     break c;
    }
    c = a;
    while (1) if ((d | 0) == 2) {
     a = 0;
     while (1) {
      if ((a | 0) == (b | 0)) {
       break b;
      }
      d = as(v[c + 12 >> 2], a);
      f = xb(v[c + 36 >> 2], a), g = d, v[f >> 2] = g;
      a = a + 1 | 0;
      continue;
     }
    } else {
     e = as(v[a >> 2], d);
     f = xb(v[a + 24 >> 2], d), g = e, v[f >> 2] = g;
     d = d + 1 | 0;
     continue;
    }
   }
   b = S(124508) | 0;
   if ((fb | 0) != (_(124508) | 0)) {
    break a;
   }
   X(b | 0) | 0;
   Mc(a);
   IQ(a);
   b = a + 12 | 0;
   Mc(b);
   IQ(b);
   b = a + 24 | 0;
   Mc(b);
   HQ(b);
   a = a + 36 | 0;
   Mc(a);
   HQ(a);
   Y();
  }
  return;
 }
 P(b | 0);
 p();
}

function uka(a) {
 a = a | 0;
 var b = 0, c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0;
 f = eb - 16 | 0;
 eb = f;
 b = v[a + 4 >> 2];
 if (Hd(w[b + 223884 | 0])) {
  yT(b + 223860 | 0);
  b = v[a + 4 >> 2];
 }
 v[a + 24 >> 2] = 0;
 v[a + 28 >> 2] = 0;
 v[b >> 2] = 0;
 c = v[a >> 2];
 v[b + 40 >> 2] = v[c + 480196 >> 2];
 v[b + 44 >> 2] = v[c + 480204 >> 2];
 v[b + 80 >> 2] = v[c + 480200 >> 2];
 c = x[c + 480188 >> 1];
 v[f + 8 >> 2] = 0;
 v[f + 12 >> 2] = 0;
 d = f + 8 | 0;
 u[d + 4 >> 1] = 65280;
 v[d >> 2] = 0;
 e = eb - 16 | 0;
 eb = e;
 v[e + 12 >> 2] = c;
 b = a + 8 | 0;
 a: {
  if (Rn(b) >>> 0 >= c >>> 0) {
   g = v[b >> 2];
   h = hh(g, v[b + 4 >> 2]);
   v[e + 8 >> 2] = h;
   i = v[Gb(e + 12 | 0, e + 8 | 0) >> 2];
   while (1) {
    if (i) {
     v[g >> 2] = v[d >> 2];
     u[g + 4 >> 1] = x[d + 4 >> 1];
     i = i - 1 | 0;
     g = g + 8 | 0;
     continue;
    }
    break;
   }
   if (c >>> 0 > h >>> 0) {
    KS(b, c - h | 0, d);
    break a;
   }
   Id(b, v[b >> 2] + (c << 3) | 0);
   break a;
  }
  VT(b);
  gU(b, ks(b, c));
  KS(b, c, d);
 }
 eb = e + 16 | 0;
 b = 0;
 while (1) {
  c = v[a >> 2];
  if (x[c + 480188 >> 1] <= b >>> 0) {
   eb = f + 16 | 0;
  } else {
   d = B(b, 872);
   Po((d + v[a + 4 >> 2] | 0) + 616 | 0, c, b & 65535, 134217728);
   c = d + v[a + 4 >> 2] | 0;
   u[c + 1432 >> 1] = 0;
   t[c + 1415 | 0] = 0;
   b = b + 1 | 0;
   continue;
  }
  break;
 }
}

function Fo(a, b, c, d, e) {
 var f = 0, g = 0, h = 0, i = 0, j = 0, k = 0;
 h = eb - 16 | 0;
 eb = h;
 if (e) {
  v[e >> 2] = 0;
 }
 a: {
  i = v[a + 484344 >> 2];
  if (!Ie(i, v[a + 484348 >> 2], b)) {
   break a;
  }
  g = Vb(i, b);
  k = v[v[g + 48 >> 2] + 12 >> 2];
  b = ld(v[g >> 2], k, c, d);
  f = w[b + 5 | 0];
  b: {
   c: {
    d: {
     e: {
      j = w[b + 3 | 0];
      switch (j - 10 | 0) {
      case 1:
      case 3:
      case 5:
      case 6:
       break a;

      case 0:
       break c;

      case 2:
      case 4:
      case 7:
       break d;

      default:
       break e;
      }
     }
     if (j - 35 >>> 0 >= 2) {
      break a;
     }
    }
    v[h + 12 >> 2] = 1;
    i = 0;
    if ((j | 0) != 17) {
     break b;
    }
    i = v[a + 480180 >> 2] == 4;
    break b;
   }
   v[h + 12 >> 2] = 2;
   i = 0;
  }
  v[h + 8 >> 2] = v[g + 12 >> 2] + (c ^ -1);
  d = 0;
  a = v[Gb(h + 8 | 0, h + 12 | 0) >> 2];
  c = a;
  while (1) {
   f: {
    if (c) {
     b = B(x[k + 480188 >> 1], 6) + b | 0;
     if (w[b + 3 | 0] == 34) {
      break f;
     }
     a = d;
    }
    f = (j - 37 & 255) >>> 0 < 254 ? f : a ? f : f << 8;
    if (!e) {
     break a;
    }
    v[e >> 2] = a;
    break a;
   }
   g = f << 8;
   f = w[b + 5 | 0] | (i ? f >>> 0 > 31 ? f >>> 0 < 256 ? g + -8192 | 0 : g : g : g);
   d = d + 1 | 0;
   c = c - 1 | 0;
   continue;
  }
 }
 eb = h + 16 | 0;
 return f;
}

function B1(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0;
 g = eb - 16 | 0;
 eb = g;
 cd(b, w[c + 32 | 0] | w[c + 33 | 0] << 8 | (w[c + 34 | 0] << 16 | w[c + 35 | 0] << 24));
 h = Mb(a);
 a = w[c + 28 | 0] | w[c + 29 | 0] << 8 | (w[c + 30 | 0] << 16 | w[c + 31 | 0] << 24);
 v[31601] = 0;
 N(179, h | 0, a | 0);
 a = v[31601];
 v[31601] = 0;
 if ((a | 0) != 1) {
  a: {
   a = 0;
   while (1) {
    b: {
     if ((w[c + 28 | 0] | w[c + 29 | 0] << 8 | (w[c + 30 | 0] << 16 | w[c + 31 | 0] << 24)) >>> 0 <= a >>> 0) {
      break b;
     }
     e = v[b + 8 >> 2];
     f = v[b >> 2];
     v[31601] = 0;
     e = T(150, f | 0, e | 0, 4) | 0;
     f = v[31601];
     v[31601] = 0;
     if ((f | 0) == 1) {
      break a;
     }
     if (!e) {
      break b;
     }
     e = w[c + 4 | 0] | w[c + 5 | 0] << 8;
     v[31601] = 0;
     e = O(180, b | 0, e | 0) | 0;
     f = v[31601];
     v[31601] = 0;
     c: {
      if ((f | 0) != 1) {
       v[g + 12 >> 2] = e;
       if (Td(v[d >> 2], v[d + 4 >> 2]) >>> 0 <= e >>> 0) {
        break c;
       }
       v[31601] = 0;
       N(181, h | 0, g + 12 | 0);
       e = v[31601];
       v[31601] = 0;
       if ((e | 0) != 1) {
        break c;
       }
      }
      break a;
     }
     a = a + 1 | 0;
     continue;
    }
    break;
   }
   eb = g + 16 | 0;
   return;
  }
 }
 a = M() | 0;
 uc(h);
 P(a | 0);
 p();
}

function rB(a, b, c, d, e) {
 var f = 0, g = 0, h = 0;
 f = (B(c, 872) + b | 0) + 616 | 0;
 a: {
  if (d) {
   if (!Nb(a + 1074312 | 0, 90)) {
    t[f + 812 | 0] = d;
   }
   t[f + 811 | 0] = d;
   break a;
  }
  d = w[f + 811 | 0];
 }
 g = v[a + 480180 >> 2];
 if (!e) {
  h = Ku(g);
 }
 b: {
  if ((g | 0) != 268435456) {
   if ((g | 0) != 16777216) {
    break b;
   }
   g = v[f + 656 >> 2];
   if (!g | !v[g + 44 >> 2]) {
    break b;
   }
   a = d & 255;
   if (!(a >>> 0 < 240 | e)) {
    RS(b, c, a - 240 | 0);
    return;
   }
   if (!(a >>> 0 < 224 | e)) {
    QS(f, a - 224 | 0);
    return;
   }
   PS(f, a);
   return;
  }
  v[f + 708 >> 2] = 1;
 }
 b = d & 255;
 c: {
  d: {
   if (!(b >>> 0 > 223 & h)) {
    break d;
   }
   e: {
    c = b & 15;
    if (!c) {
     break e;
    }
    d = d & 240;
    if ((d | 0) != 224) {
     if ((d | 0) != 240) {
      break e;
     }
     oB(a, f, c);
     return;
    }
    if (v[a + 480180 >> 2] == 524288) {
     break d;
    }
    pB(a, f, c);
    return;
   }
   if (v[a + 480180 >> 2] != 524288) {
    break c;
   }
  }
  f: {
   if (!(t[f + 851 | 0] & 1)) {
    break f;
   }
   if (v[a + 1074416 >> 2] == 1) {
    if (Nb(a + 1074312 | 0, 6)) {
     break f;
    }
   }
   c = v[a + 480180 >> 2];
   if (c & 32832) {
    break f;
   }
   if (!(w[a + 480208 | 0] & 2) | (c | 0) != 8) {
    break c;
   }
  }
  vk(a, f, f + 700 | 0, b << 2, 0);
 }
}

function YZ(a) {
 a = a | 0;
 var b = 0, c = 0, d = 0, e = 0, f = 0, g = 0;
 c = eb - 176 | 0;
 eb = c;
 d = c + 12 | 0;
 Tf(d, a);
 v[31601] = 0;
 b = c + 24 | 0;
 N(124, b | 0, d | 0);
 a = v[31601];
 v[31601] = 0;
 a: {
  b: {
   c: {
    d: {
     e: {
      if ((a | 0) != 1) {
       v[31601] = 0;
       a = O(103, c + 36 | 0, b | 0) | 0;
       f = v[31601];
       v[31601] = 0;
       if ((f | 0) == 1) {
        break e;
       }
       sb(b);
       sb(d);
       d = v[v[a >> 2] - 12 >> 2];
       v[31601] = 0;
       f = ba(104) | 0;
       e = v[31601];
       v[31601] = 0;
       if ((e | 0) == 1) {
        break c;
       }
       v[31601] = 0;
       e = c + 8 | 0;
       R(105, e | 0, a + d | 0, f | 0);
       d = v[31601];
       v[31601] = 0;
       if ((d | 0) == 1) {
        break c;
       }
       Zb(e);
       v[31601] = 0;
       v[c + 24 >> 2] = 0;
       v[c + 28 >> 2] = 0;
       b = O(409, a | 0, b | 0) | 0;
       d = v[31601];
       v[31601] = 0;
       if ((d | 0) == 1) {
        break c;
       }
       a = mk(v[(b + v[v[b >> 2] - 12 >> 2] | 0) + 16 >> 2]);
       g = A[c + 24 >> 3];
       Ff(b);
       eb = c + 176 | 0;
       g = a ? 0 : g;
       break a;
      }
      b = M() | 0;
      break d;
     }
     b = M() | 0;
     sb(c + 24 | 0);
    }
    sb(c + 12 | 0);
    break b;
   }
   b = M() | 0;
   Ff(a);
  }
  P(b | 0);
  p();
 }
 return +g;
}

function Pca(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0;
 e = eb + -64 | 0;
 eb = e;
 v[e + 60 >> 2] = c;
 a = re(a, e + 60 | 0);
 c = sc(a + 4 | 0);
 g = sc(a + 24 | 0);
 h = sc(a + 32 | 0);
 i = Mb(a + 36 | 0);
 v[a + 56 >> 2] = 3;
 j = Mb(a + 68 | 0);
 v[31601] = 0;
 N(990, a | 0, d | 0);
 f = v[31601];
 v[31601] = 0;
 a: {
  b: {
   c: {
    d: {
     if ((f | 0) != 1) {
      oe(e + 24 | 0, v[b >> 2], v[b + 4 >> 2]);
      lf(e + 32 | 0, v[e + 24 >> 2], v[e + 28 >> 2]);
      b = Ld(e + 16 | 0);
      v[31601] = 0;
      f = v[b + 4 >> 2];
      v[e + 8 >> 2] = v[b >> 2];
      v[e + 12 >> 2] = f;
      b = e + 40 | 0;
      Ms(994, b, v[e + 32 >> 2], v[e + 36 >> 2], e + 8 | 0);
      f = v[31601];
      v[31601] = 0;
      if ((f | 0) == 1) {
       break d;
      }
      v[31601] = 0;
      R(991, a | 0, b | 0, d | 0);
      d = v[31601];
      v[31601] = 0;
      if ((d | 0) == 1) {
       break c;
      }
      tb(b);
      v[31601] = 0;
      V(992, a | 0);
      b = v[31601];
      v[31601] = 0;
      if ((b | 0) != 1) {
       break a;
      }
     }
     d = M() | 0;
     break b;
    }
    d = M() | 0;
    break b;
   }
   d = M() | 0;
   tb(e + 40 | 0);
  }
  Sd(j);
  nf(i);
  yl(h);
  vh(g);
  uh(c);
  Wc(a);
  Wc(e + 60 | 0);
  P(d | 0);
  p();
 }
 Wc(e + 60 | 0);
 eb = e - -64 | 0;
 return a | 0;
}

function OG(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 a: {
  b: {
   switch (b | 0) {
   case 0:
    pe(a, 0, c);
    break a;

   case 1:
    pe(a, 1, c);
    break a;

   case 2:
    pe(a, 2, c);
    break a;

   case 3:
    pe(a, 3, c);
    break a;

   case 4:
    pe(a, 4, c);
    break a;

   case 5:
    pe(a, 5, c);
    break a;

   case 6:
    pe(a, 6, c);
    break a;

   case 7:
    pe(a, 7, c);
    break a;

   case 8:
    pe(a, 8, c);
    break a;

   case 9:
    pe(a, 9, c);
    break a;

   case 10:
    pe(a, 10, c);
    break a;

   case 11:
    pe(a, 11, c);
    break a;

   case 12:
    pe(a, 12, c);
    break a;

   case 13:
    pe(a, 13, c);
    break a;

   case 14:
    pe(a, 14, c);
    break a;

   case 15:
    pe(a, 15, c);
    break a;

   case 16:
    pe(a, 16, c);
    break a;

   case 17:
    pe(a, 17, c);
    break a;

   case 18:
    pe(a, 18, c);
    break a;

   case 19:
    pe(a, 19, c);
    break a;

   case 20:
    NG(a, 71360, c);
    break a;

   case 21:
    NG(a, 72384, c);
    break a;

   case 22:
    pe(a, 20, c);
    break a;

   case 23:
    pe(a, 21, c);
    break a;

   case 24:
    pe(a, 22, c);
    break a;

   case 25:
    pe(a, 23, c);
    break a;

   case 26:
    pe(a, 24, c);
    break a;

   case 27:
    pe(a, 25, c);
    break a;

   case 28:
    pe(a, 26, c);
    break a;

   default:
    break b;
   }
  }
  Eb(a);
 }
}

function E0(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 a: {
  b: {
   switch (b | 0) {
   case 0:
    se(a, 0, c);
    break a;

   case 1:
    se(a, 1, c);
    break a;

   case 2:
    se(a, 2, c);
    break a;

   case 3:
    se(a, 3, c);
    break a;

   case 4:
    se(a, 4, c);
    break a;

   case 5:
    se(a, 5, c);
    break a;

   case 6:
    se(a, 6, c);
    break a;

   case 7:
    se(a, 7, c);
    break a;

   case 8:
    se(a, 8, c);
    break a;

   case 9:
    se(a, 9, c);
    break a;

   case 10:
    se(a, 10, c);
    break a;

   case 11:
    se(a, 11, c);
    break a;

   case 12:
    se(a, 12, c);
    break a;

   case 13:
    se(a, 13, c);
    break a;

   case 14:
    se(a, 14, c);
    break a;

   case 15:
    se(a, 15, c);
    break a;

   case 16:
    se(a, 16, c);
    break a;

   case 17:
    se(a, 17, c);
    break a;

   case 18:
    se(a, 18, c);
    break a;

   case 19:
    se(a, 19, c);
    break a;

   case 20:
    D0(a, 71360, c);
    break a;

   case 21:
    D0(a, 72384, c);
    break a;

   case 22:
    se(a, 20, c);
    break a;

   case 23:
    se(a, 21, c);
    break a;

   case 24:
    se(a, 22, c);
    break a;

   case 25:
    se(a, 23, c);
    break a;

   case 26:
    se(a, 24, c);
    break a;

   case 27:
    se(a, 25, c);
    break a;

   case 28:
    se(a, 26, c);
    break a;

   default:
    break b;
   }
  }
  Eb(a);
 }
}

function Rq(a, b, c, d) {
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0;
 h = eb - 16 | 0;
 eb = h;
 a: {
  e = v[a >> 2];
  f = v[a + 4 >> 2];
  if (lc(e, f)) {
   break a;
  }
  i = Rd(e, f) - 1 | 0;
  while (1) {
   b: {
    if (Rd(e, f) - 1 >>> 0 > g >>> 0) {
     j = Oc(e, f, g);
     f = v[a + 4 >> 2];
     e = v[a >> 2];
     if (x[j >> 1] < (b | 0)) {
      break b;
     }
     i = g;
    }
    g = x[Oc(e, f, i) >> 1];
    f = 0;
    v[h + 12 >> 2] = 0;
    c: {
     if ((b | 0) >= (g | 0)) {
      k = h, l = (w[Oc(v[a >> 2], v[a + 4 >> 2], i) + 2 | 0] << 16 >>> 0) / (d >>> 0) | 0, 
      v[k + 12 >> 2] = l;
      break c;
     }
     e = 0;
     if (i) {
      e = i - 1 | 0;
      f = (w[Oc(v[a >> 2], v[a + 4 >> 2], e) + 2 | 0] << 16 >>> 0) / (d >>> 0) | 0;
      v[h + 12 >> 2] = f;
      e = x[Oc(v[a >> 2], v[a + 4 >> 2], e) >> 1];
     }
     if ((b | 0) <= (e | 0) | e >>> 0 >= g >>> 0) {
      break c;
     }
     a = ((w[Oc(v[a >> 2], v[a + 4 >> 2], i) + 2 | 0] << 16 >>> 0) / (d >>> 0) | 0) - f | 0;
     d = a;
     i = a >> 31;
     a = b - e | 0;
     b = Aua(d, i, a, a >> 31);
     a = g - e | 0;
     k = h, l = Fc(Bua(b, gb, a, a >> 31), gb) + f | 0, v[k + 12 >> 2] = l;
    }
    Fe(h + 12 | 0, 0, 65536);
    g = (B(v[h + 12 >> 2], c) + 32768 | 0) / 65536 | 0;
    break a;
   }
   g = g + 1 | 0;
   continue;
  }
 }
 eb = h + 16 | 0;
 return g;
}

function Sca(a, b, c, d, e) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 var f = 0, g = 0, h = 0, i = 0, j = 0, k = 0;
 f = eb + -64 | 0;
 eb = f;
 v[f + 60 >> 2] = d;
 a = re(a, f + 60 | 0);
 d = sc(a + 4 | 0);
 g = sc(a + 24 | 0);
 h = sc(a + 32 | 0);
 i = Mb(a + 36 | 0);
 v[a + 56 >> 2] = 3;
 j = Mb(a + 68 | 0);
 v[31601] = 0;
 N(990, a | 0, e | 0);
 k = v[31601];
 v[31601] = 0;
 a: {
  b: {
   c: {
    d: {
     if ((k | 0) != 1) {
      ac(f + 24 | 0, b, c);
      lf(f + 32 | 0, v[f + 24 >> 2], v[f + 28 >> 2]);
      b = Ld(f + 16 | 0);
      v[31601] = 0;
      c = v[b + 4 >> 2];
      v[f + 8 >> 2] = v[b >> 2];
      v[f + 12 >> 2] = c;
      b = f + 40 | 0;
      Ms(994, b, v[f + 32 >> 2], v[f + 36 >> 2], f + 8 | 0);
      c = v[31601];
      v[31601] = 0;
      if ((c | 0) == 1) {
       break d;
      }
      v[31601] = 0;
      R(991, a | 0, b | 0, e | 0);
      c = v[31601];
      v[31601] = 0;
      if ((c | 0) == 1) {
       break c;
      }
      tb(b);
      v[31601] = 0;
      V(992, a | 0);
      b = v[31601];
      v[31601] = 0;
      if ((b | 0) != 1) {
       break a;
      }
     }
     e = M() | 0;
     break b;
    }
    e = M() | 0;
    break b;
   }
   e = M() | 0;
   tb(f + 40 | 0);
  }
  Sd(j);
  nf(i);
  yl(h);
  vh(g);
  uh(d);
  Wc(a);
  Wc(f + 60 | 0);
  P(e | 0);
  p();
 }
 Wc(f + 60 | 0);
 eb = f - -64 | 0;
 return a | 0;
}

function qaa(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0;
 d = eb - 96 | 0;
 eb = d;
 v[31601] = 0;
 e = v[b + 12 >> 2];
 v[d + 40 >> 2] = v[b + 8 >> 2];
 v[d + 44 >> 2] = e;
 e = v[b + 4 >> 2];
 v[d + 32 >> 2] = v[b >> 2];
 v[d + 36 >> 2] = e;
 e = Q(1196, d + 32 | 0) | 0;
 f = v[31601];
 v[31601] = 0;
 if ((f | 0) != 1) {
  a: {
   b: {
    if (e) {
     v[31601] = 0;
     e = d + 72 | 0;
     N(1197, e | 0, b | 0);
     b = v[31601];
     v[31601] = 0;
     if ((b | 0) != 1) {
      b = d + 80 | 0;
      Jp(b, e);
      f = Ef(d + 88 | 0, b);
      g = Ef(d - -64 | 0, c);
      h = v[f + 4 >> 2];
      v[d + 8 >> 2] = v[f >> 2];
      v[d + 12 >> 2] = h;
      f = v[g + 4 >> 2];
      v[d >> 2] = v[g >> 2];
      v[d + 4 >> 2] = f;
      Kp(a, d + 8 | 0, d);
      break b;
     }
     break a;
    }
    v[31601] = 0;
    e = d + 72 | 0;
    N(1198, e | 0, b | 0);
    b = v[31601];
    v[31601] = 0;
    if ((b | 0) == 1) {
     break a;
    }
    b = d + 80 | 0;
    Jp(b, e);
    f = Ef(d + 56 | 0, b);
    g = Ef(d + 48 | 0, c);
    h = v[f + 4 >> 2];
    v[d + 24 >> 2] = v[f >> 2];
    v[d + 28 >> 2] = h;
    f = v[g + 4 >> 2];
    v[d + 16 >> 2] = v[g >> 2];
    v[d + 20 >> 2] = f;
    Kp(a, d + 24 | 0, d + 16 | 0);
   }
   le(b);
   le(e);
   le(c);
   eb = d + 96 | 0;
   return;
  }
 }
 a = M() | 0;
 le(c);
 P(a | 0);
 p();
}

function Bma(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0, s = 0;
 b = eb - 16 | 0;
 eb = b;
 f = v[a + 40 >> 2];
 g = v[a + 36 >> 2];
 k = v[a + 16 >> 2];
 e = v[a + 4 >> 2];
 v[b + 8 >> 2] = v[a >> 2];
 v[b + 12 >> 2] = e;
 l = v[a + 32 >> 2];
 m = v[a + 28 >> 2];
 n = v[a + 8 >> 2];
 o = v[a + 12 >> 2];
 while (1) {
  if (d) {
   e = v[b + 8 >> 2];
   j = ((((v[b + 12 >> 2] & 2147483647) << 1 | e >>> 31) & 2147483646) << 1) + k | 0;
   e = e >>> 21 & 2040;
   p = u[e + 38054 >> 1];
   q = u[e + 38052 >> 1];
   r = u[e + 38050 >> 1];
   s = u[e + 38048 >> 1];
   h = 0;
   while (1) {
    if ((h | 0) != 2) {
     e = h << 1;
     i = e + j | 0;
     v[(h << 2) + b >> 2] = (((B(u[i >> 1], r) + B(u[(e | -4) + j >> 1], s) | 0) + B(u[i + 4 >> 1], q) | 0) + B(u[i + 8 >> 1], p) | 0) / 16384;
     h = h + 1 | 0;
     continue;
    }
    break;
   }
   g = g + m | 0;
   v[c >> 2] = v[c >> 2] + B(v[b >> 2], g >> 12);
   f = f + l | 0;
   v[c + 4 >> 2] = v[c + 4 >> 2] + B(v[b + 4 >> 2], f >> 12);
   Ob(b + 8 | 0, n, o);
   c = c + 8 | 0;
   d = d - 1 | 0;
   continue;
  }
  break;
 }
 c = v[b + 12 >> 2];
 v[a >> 2] = v[b + 8 >> 2];
 v[a + 4 >> 2] = c;
 v[a + 40 >> 2] = f;
 v[a + 20 >> 2] = g >> 12;
 v[a + 36 >> 2] = g;
 v[a + 24 >> 2] = f >> 12;
 eb = b + 16 | 0;
}

function UD(a, b) {
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0;
 h = eb - 16 | 0;
 eb = h;
 e = zb(a);
 c = ub(h + 12 | 0, v[a + 4 >> 2]);
 g = ub(h + 8 | 0, v[a >> 2]);
 f = ub(h + 4 | 0, v[b + 4 >> 2]);
 d = v[c >> 2];
 g = v[g >> 2];
 c = eb + -64 | 0;
 eb = c;
 f = v[f >> 2];
 v[c + 56 >> 2] = f;
 v[c + 60 >> 2] = d;
 v[c + 52 >> 2] = f;
 e = zg(c + 24 | 0, e, c + 52 | 0, c + 56 | 0);
 v[c + 16 >> 2] = v[e + 8 >> 2];
 f = v[e + 4 >> 2];
 v[c + 8 >> 2] = v[e >> 2];
 v[c + 12 >> 2] = f;
 yg(c + 36 | 0, c + 8 | 0);
 while (1) {
  if (Ed(d, g)) {
   XD(D_(v[c + 56 >> 2]), d - 20 | 0);
   d = E_(c + 60 | 0);
   E_(c + 56 | 0);
   d = v[d >> 2];
   continue;
  }
  break;
 }
 xg(c + 36 | 0);
 i = v[c + 56 >> 2];
 if (!w[c + 48 | 0]) {
  g = eb - 16 | 0;
  eb = g;
  d = ub(g + 12 | 0, v[v[c + 44 >> 2] >> 2]);
  j = v[ub(g + 8 | 0, v[v[c + 40 >> 2] >> 2]) >> 2];
  f = eb - 16 | 0;
  eb = f;
  d = v[d >> 2];
  v[f + 12 >> 2] = d;
  while (1) {
   if (vi(d, j)) {
    e = eb - 16 | 0;
    eb = e;
    v[e + 12 >> 2] = d;
    v[e + 12 >> 2] = v[e + 12 >> 2] + 20;
    eb = e + 16 | 0;
    tb(D_(v[e + 12 >> 2]));
    d = v[Pf(f + 12 | 0) >> 2];
    continue;
   }
   break;
  }
  eb = f + 16 | 0;
  eb = g + 16 | 0;
 }
 eb = c - -64 | 0;
 v[b + 4 >> 2] = i;
 Sb(a, b + 4 | 0);
 Sb(a + 4 | 0, b + 8 | 0);
 Sb(zb(a), mc(b));
 v[b >> 2] = v[b + 4 >> 2];
 eb = h + 16 | 0;
}

function XG(a, b, c, d) {
 var e = 0, f = 0, g = 0, h = 0;
 g = eb - 32 | 0;
 eb = g;
 f = d & 2147483647;
 e = f - 1065418752 | 0;
 h = f - 1082064896 | 0;
 a: {
  if ((e | 0) == (h | 0) & 0 | e >>> 0 < h >>> 0) {
   f = (d & 33554431) << 7 | c >>> 25;
   e = 0;
   h = e;
   c = c & 33554431;
   if (!(!e & (c | 0) == 16777216 ? !(a | b) : !e & c >>> 0 < 16777216)) {
    e = f + 1073741825 | 0;
    break a;
   }
   e = f + 1073741824 | 0;
   if (c ^ 16777216 | a | (b | h)) {
    break a;
   }
   e = (f & 1) + e | 0;
   break a;
  }
  if (!(!c & (f | 0) == 2147418112 ? !(a | b) : f >>> 0 < 2147418112)) {
   e = ((d & 33554431) << 7 | c >>> 25) & 4194303 | 2143289344;
   break a;
  }
  e = 2139095040;
  if (f >>> 0 > 1082064895) {
   break a;
  }
  e = 0;
  f = f >>> 16 | 0;
  if (f >>> 0 < 16145) {
   break a;
  }
  e = d & 65535 | 65536;
  _f(g + 16 | 0, a, b, c, e, f - 16129 | 0);
  bn(g, a, b, c, e, 16257 - f | 0);
  a = v[g + 8 >> 2];
  e = (v[g + 12 >> 2] & 33554431) << 7 | a >>> 25;
  c = v[g >> 2] | (v[g + 16 >> 2] | v[g + 24 >> 2] | (v[g + 20 >> 2] | v[g + 28 >> 2])) != 0;
  f = v[g + 4 >> 2];
  b = 0;
  a = a & 33554431;
  if (!(!b & (a | 0) == 16777216 ? !(c | f) : !b & a >>> 0 < 16777216)) {
   e = e + 1 | 0;
   break a;
  }
  if (a ^ 16777216 | c | (b | f)) {
   break a;
  }
  e = (e & 1) + e | 0;
 }
 eb = g + 32 | 0;
 return l(2, d & -2147483648 | e), r();
}

function HO(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0;
 e = eb - 32 | 0;
 eb = e;
 g = Mb(a);
 a = 0;
 c = v[b + 24 >> 2];
 c = _u(v[c + 484344 >> 2], v[c + 484348 >> 2]);
 v[31601] = 0;
 N(176, g | 0, c | 0);
 c = v[31601];
 v[31601] = 0;
 a: {
  if ((c | 0) != 1) {
   b: {
    c: {
     d: {
      e: {
       while (1) {
        c = v[b + 24 >> 2];
        d = v[c + 484344 >> 2];
        if (_u(d, v[c + 484348 >> 2]) >>> 0 <= a >>> 0) {
         break b;
        }
        v[31601] = 0;
        c = e + 8 | 0;
        N(1065, c | 0, Vb(d, a) | 0);
        d = v[31601];
        v[31601] = 0;
        if ((d | 0) != 1) {
         f = v[b + 24 >> 2];
         v[31601] = 0;
         d = e + 20 | 0;
         R(1052, d | 0, f | 0, c | 0);
         f = v[31601];
         v[31601] = 0;
         if ((f | 0) == 1) {
          break e;
         }
         v[31601] = 0;
         N(178, g | 0, d | 0);
         f = v[31601];
         v[31601] = 0;
         if ((f | 0) == 1) {
          break d;
         }
         a = a + 1 | 0;
         sb(d);
         sb(c);
         continue;
        }
        break;
       }
       a = M() | 0;
       break a;
      }
      a = M() | 0;
      break c;
     }
     a = M() | 0;
     sb(e + 20 | 0);
    }
    sb(e + 8 | 0);
    break a;
   }
   eb = e + 32 | 0;
   return;
  }
  a = M() | 0;
 }
 Sd(g);
 P(a | 0);
 p();
}

function oO(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0;
 e = eb + -64 | 0;
 eb = e;
 a: {
  b: {
   if ((b | 0) >= 0) {
    d = v[a + 24 >> 2];
    if (Gj(Wb(v[d + 484360 >> 2], w[d + 484376 | 0])) >>> 0 > b >>> 0) {
     break b;
    }
   }
   a = a + 16 | 0;
   break a;
  }
  d = 0;
  c: {
   f = v[a + 24 >> 2];
   g = v[f + 484344 >> 2];
   i = v[f + 484348 >> 2];
   h = x[$b(v[Wb(v[f + 484360 >> 2], w[f + 484376 | 0]) >> 2], b) >> 1];
   if (!An(g, i, h)) {
    break c;
   }
   if ((c | 0) >= 0) {
    d = c;
    if ((d | 0) < v[Vb(g, h) + 12 >> 2]) {
     break c;
    }
   }
   a = a + 16 | 0;
   break a;
  }
  u[f + 1074448 >> 1] = b;
  c = f;
  f = b & 65535;
  UR(c, f);
  c = v[a + 24 >> 2];
  v[c + 1074392 >> 2] = -2;
  v[c + 1074428 >> 2] = d;
  g = w[a + 64 | 0];
  b = e + 24 | 0;
  u[b + 4 >> 1] = 0;
  t[b + 6 | 0] = 255;
  v[b + 16 >> 2] = 2;
  v[b >> 2] = 0;
  u[b + 12 >> 1] = f;
  v[b + 8 >> 2] = d;
  d = v[b + 20 >> 2];
  v[e + 16 >> 2] = v[b + 16 >> 2];
  v[e + 20 >> 2] = d;
  d = v[b + 12 >> 2];
  v[e + 8 >> 2] = v[b + 8 >> 2];
  v[e + 12 >> 2] = d;
  d = v[b + 4 >> 2];
  v[e >> 2] = v[b >> 2];
  v[e + 4 >> 2] = d;
  b = e + 52 | 0;
  Gv(b, c, g ? 7 : 1, e);
  j = a, k = A[dn(v[e + 56 >> 2]) >> 3], A[j + 16 >> 3] = k;
  Pi(b);
  a = a + 16 | 0;
 }
 eb = e - -64 | 0;
 return +A[a >> 3];
}

function KU(a, b) {
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0;
 h = eb - 16 | 0;
 eb = h;
 e = zb(a);
 c = ub(h + 12 | 0, v[a + 4 >> 2]);
 g = ub(h + 8 | 0, v[a >> 2]);
 f = ub(h + 4 | 0, v[b + 4 >> 2]);
 d = v[c >> 2];
 g = v[g >> 2];
 c = eb + -64 | 0;
 eb = c;
 f = v[f >> 2];
 v[c + 56 >> 2] = f;
 v[c + 60 >> 2] = d;
 v[c + 52 >> 2] = f;
 e = zg(c + 24 | 0, e, c + 52 | 0, c + 56 | 0);
 v[c + 16 >> 2] = v[e + 8 >> 2];
 f = v[e + 4 >> 2];
 v[c + 8 >> 2] = v[e >> 2];
 v[c + 12 >> 2] = f;
 yg(c + 36 | 0, c + 8 | 0);
 while (1) {
  if (Ed(d, g)) {
   YB(JU(v[c + 56 >> 2]), dn(d));
   d = To(c + 60 | 0);
   To(c + 56 | 0);
   d = v[d >> 2];
   continue;
  }
  break;
 }
 xg(c + 36 | 0);
 i = v[c + 56 >> 2];
 if (!w[c + 48 | 0]) {
  g = eb - 16 | 0;
  eb = g;
  d = ub(g + 12 | 0, v[v[c + 44 >> 2] >> 2]);
  j = v[ub(g + 8 | 0, v[v[c + 40 >> 2] >> 2]) >> 2];
  f = eb - 16 | 0;
  eb = f;
  d = v[d >> 2];
  v[f + 12 >> 2] = d;
  while (1) {
   if (vi(d, j)) {
    e = eb - 16 | 0;
    eb = e;
    v[e + 12 >> 2] = d;
    v[e + 12 >> 2] = v[e + 12 >> 2] + 32;
    eb = e + 16 | 0;
    zk(JU(v[e + 12 >> 2]));
    d = v[Zq(f + 12 | 0) >> 2];
    continue;
   }
   break;
  }
  eb = f + 16 | 0;
  eb = g + 16 | 0;
 }
 eb = c - -64 | 0;
 v[b + 4 >> 2] = i;
 Sb(a, b + 4 | 0);
 Sb(a + 4 | 0, b + 8 | 0);
 Sb(zb(a), mc(b));
 v[b >> 2] = v[b + 4 >> 2];
 eb = h + 16 | 0;
}

function S2(a) {
 a = a | 0;
 var b = 0, c = 0, d = 0, e = 0, f = 0;
 d = eb - 176 | 0;
 eb = d;
 b = d + 12 | 0;
 Rk(b, a);
 v[31601] = 0;
 c = d + 24 | 0;
 N(102, c | 0, b | 0);
 a = v[31601];
 v[31601] = 0;
 a: {
  b: {
   c: {
    d: {
     if ((a | 0) != 1) {
      v[31601] = 0;
      a = O(103, d + 36 | 0, c | 0) | 0;
      f = v[31601];
      v[31601] = 0;
      if ((f | 0) == 1) {
       break d;
      }
      sb(c);
      sb(b);
      b = v[v[a >> 2] - 12 >> 2];
      v[31601] = 0;
      f = ba(104) | 0;
      e = v[31601];
      v[31601] = 0;
      if ((e | 0) == 1) {
       break b;
      }
      v[31601] = 0;
      e = d + 8 | 0;
      R(105, e | 0, a + b | 0, f | 0);
      b = v[31601];
      v[31601] = 0;
      if ((b | 0) == 1) {
       break b;
      }
      Zb(e);
      b = a + v[v[a >> 2] - 12 >> 2] | 0;
      v[b + 4 >> 2] = v[b + 4 >> 2] & -75;
      v[b + 4 >> 2] = v[b + 4 >> 2] | 8;
      v[31601] = 0;
      c = O(106, a | 0, c | 0) | 0;
      b = v[31601];
      v[31601] = 0;
      if ((b | 0) == 1) {
       break b;
      }
      a = mk(v[(c + v[v[c >> 2] - 12 >> 2] | 0) + 16 >> 2]);
      b = v[d + 24 >> 2];
      Ff(c);
      eb = d + 176 | 0;
      return (a ? 0 : b) | 0;
     }
     c = M() | 0;
     break c;
    }
    c = M() | 0;
    sb(d + 24 | 0);
   }
   sb(d + 12 | 0);
   break a;
  }
  c = M() | 0;
  Ff(a);
 }
 P(c | 0);
 p();
}

function AP(a, b, c, d, e, f, g, h, i) {
 a = a | 0;
 b = b | 0;
 c = +c;
 d = d | 0;
 e = e | 0;
 f = f | 0;
 g = g | 0;
 h = h | 0;
 i = i | 0;
 var j = 0, k = 0, l = 0;
 j = eb - 48 | 0;
 eb = j;
 k = v[a + 4 >> 2];
 l = v[a >> 2];
 a = v[a + 8 >> 2];
 v[j + 32 >> 2] = b;
 v[j + 44 >> 2] = a;
 v[j + 36 >> 2] = l;
 v[j + 40 >> 2] = k;
 v[31601] = 0;
 a = O(975, (d ? d : 976) | 0, e | 0) | 0;
 b = v[31601];
 v[31601] = 0;
 a: {
  b: {
   c: {
    d: {
     if ((b | 0) != 1) {
      v[j + 24 >> 2] = a;
      a = j + 24 | 0;
      b = v[re(j + 28 | 0, a) >> 2];
      k = v[j + 44 >> 2];
      v[j + 16 >> 2] = v[j + 40 >> 2];
      v[j + 20 >> 2] = k;
      v[31601] = 0;
      k = v[j + 36 >> 2];
      v[j + 8 >> 2] = v[j + 32 >> 2];
      v[j + 12 >> 2] = k;
      c = +oa(977, j + 8 | 0, +c, b | 0);
      b = v[31601];
      v[31601] = 0;
      if ((b | 0) == 1) {
       break d;
      }
      Wc(a);
      break b;
     }
     a = S(0) | 0;
     break c;
    }
    a = S(0) | 0;
    Wc(j + 24 | 0);
   }
   X(a | 0) | 0;
   v[31601] = 0;
   fa(978, 15038, d | 0, e | 0, f | 0, g | 0, h | 0, i | 0);
   a = v[31601];
   v[31601] = 0;
   if ((a | 0) == 1) {
    break a;
   }
   Y();
   c = 0;
  }
  eb = j + 48 | 0;
  return +c;
 }
 a = M() | 0;
 v[31601] = 0;
 W(26);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  P(a | 0);
  p();
 }
 S(0) | 0;
 Rb();
 p();
}

function XX(a, b, c, d, e, f, g) {
 var h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
 o = v[b >> 2];
 while (1) {
  if ((i | 0) == 128) {
   ug(b, c);
   c = v[a + 8 >> 2];
   d = c + d | 0;
   i = x[e >> 1];
   a: {
    b: {
     c: {
      if (!f) {
       break c;
      }
      j = f;
      f = h & 65535;
      if ((c + (j + (f << 11) | 0) | 0) != (Kh(v[a >> 2]) & -2)) {
       break c;
      }
      cd(a, c + (f << 10) | 0);
      if (!WC(a, 16, 1)) {
       break b;
      }
      u[e >> 1] = 8;
      break b;
     }
     if ((h & 65535) == (k & 65535)) {
      h = k;
      break a;
     }
     f = k << 8 & 16776960;
     if (!g) {
      if ((Kh(v[a >> 2]) | 0) != (d + B(f, i) | 0)) {
       break a;
      }
     }
     cd(a, c + B(f, x[e >> 1]) | 0);
     h = WC(a, 64, 1) ? h : k;
    }
    cd(a, c);
   }
   c = l & 65535;
   d: {
    if (c >>> 0 > (h & 65535) >>> 0) {
     if ((d + (B(c, x[e >> 1]) << 8) | 0) == (Kh(v[a >> 2]) | 0)) {
      break d;
     }
    }
    if (c >>> 0 >= 255) {
     VC(b, 254, 65534);
     VC(b, 255, 65535);
    }
    l = h;
   }
   a = l & 65535;
  } else {
   j = x[$b(o, i) >> 1];
   m = j + 1 | 0;
   n = (h & 65535) >>> 0 > j >>> 0 | j >>> 0 > 127;
   k = n ? k : c >>> 0 > i >>> 0 ? m : k;
   l = (l & 65535) >>> 0 > j >>> 0 ? l : m;
   h = n ? h : m;
   i = i + 1 | 0;
   continue;
  }
  break;
 }
 return a;
}

function ora(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0;
 d = eb - 32 | 0;
 eb = d;
 v[d + 28 >> 2] = 0;
 Ek(a, d + 28 | 0);
 a: {
  b: {
   i = v[d + 28 >> 2];
   c: {
    if (i >>> 0 > 500) {
     break c;
    }
    d: {
     e: {
      while (1) {
       if ((f | 0) == (i | 0)) {
        break c;
       }
       h = Eb(d + 16 | 0);
       v[31601] = 0;
       u[d + 14 >> 1] = 0;
       g = T(495, a | 0, h | 0, 255) | 0;
       e = v[31601];
       v[31601] = 0;
       if ((e | 0) == 1) {
        break b;
       }
       if (!g) {
        break d;
       }
       v[31601] = 0;
       g = d + 14 | 0;
       N(484, a | 0, g | 0);
       e = v[31601];
       v[31601] = 0;
       if ((e | 0) == 1) {
        break b;
       }
       v[31601] = 0;
       R(496, d | 0, c | 0, h | 0);
       e = v[31601];
       v[31601] = 0;
       if ((e | 0) != 1) {
        v[31601] = 0;
        g = O(497, b | 0, g | 0) | 0;
        e = v[31601];
        v[31601] = 0;
        if ((e | 0) == 1) {
         break e;
        }
        yb(g, d);
        sb(d);
        sb(h);
        f = f + 1 | 0;
        continue;
       }
       break;
      }
      f = M() | 0;
      break a;
     }
     f = M() | 0;
     sb(d);
     break a;
    }
    sb(h);
   }
   eb = d + 32 | 0;
   return;
  }
  f = M() | 0;
 }
 sb(h);
 P(f | 0);
 p();
}

function D2(a) {
 a = a | 0;
 var b = 0, c = 0, d = 0, e = 0, f = 0;
 d = eb - 176 | 0;
 eb = d;
 c = d + 12 | 0;
 Tf(c, a);
 v[31601] = 0;
 b = d + 24 | 0;
 N(124, b | 0, c | 0);
 a = v[31601];
 v[31601] = 0;
 a: {
  b: {
   c: {
    d: {
     e: {
      if ((a | 0) != 1) {
       v[31601] = 0;
       a = O(103, d + 36 | 0, b | 0) | 0;
       f = v[31601];
       v[31601] = 0;
       if ((f | 0) == 1) {
        break e;
       }
       sb(b);
       sb(c);
       c = v[v[a >> 2] - 12 >> 2];
       v[31601] = 0;
       f = ba(104) | 0;
       e = v[31601];
       v[31601] = 0;
       if ((e | 0) == 1) {
        break c;
       }
       v[31601] = 0;
       e = d + 8 | 0;
       R(105, e | 0, a + c | 0, f | 0);
       c = v[31601];
       v[31601] = 0;
       if ((c | 0) == 1) {
        break c;
       }
       Zb(e);
       v[31601] = 0;
       v[d + 24 >> 2] = 0;
       b = O(125, a | 0, b | 0) | 0;
       c = v[31601];
       v[31601] = 0;
       if ((c | 0) == 1) {
        break c;
       }
       a = mk(v[(b + v[v[b >> 2] - 12 >> 2] | 0) + 16 >> 2]);
       c = v[d + 24 >> 2];
       Ff(b);
       eb = d + 176 | 0;
       a = a ? 0 : c;
       break a;
      }
      b = M() | 0;
      break d;
     }
     b = M() | 0;
     sb(d + 24 | 0);
    }
    sb(d + 12 | 0);
    break b;
   }
   b = M() | 0;
   Ff(a);
  }
  P(b | 0);
  p();
 }
 return a | 0;
}

function zs(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0;
 d = eb - 16 | 0;
 eb = d;
 v[d + 12 >> 2] = b;
 if (b >>> 0 < 2147483632) {
  a: {
   if (Lc(a) >>> 0 >= b >>> 0) {
    break a;
   }
   k = d, l = Cb(v[a + 4 >> 2], w[a + 11 | 0]), v[k + 8 >> 2] = l;
   b = Eh(v[ad(d + 12 | 0, d + 8 | 0) >> 2]);
   if ((Lc(a) | 0) == (b | 0)) {
    break a;
   }
   e = eb - 16 | 0;
   eb = e;
   f = Cb(v[a + 4 >> 2], w[a + 11 | 0]);
   b: {
    c: {
     h = Kk(b);
     d: {
      if (h) {
       i = 1;
       j = b + 1 | 0;
       g = v[a >> 2];
       b = a;
       c = f;
       break d;
      }
      c = b + 1 | 0;
      e: {
       if (Lc(a) >>> 0 < b >>> 0) {
        pg(e + 8 | 0, c);
        break e;
       }
       v[31601] = 0;
       N(116, e + 8 | 0, c | 0);
       b = v[31601];
       v[31601] = 0;
       if ((b | 0) == 1) {
        break c;
       }
      }
      j = v[e + 12 >> 2];
      b = v[e + 8 >> 2];
      c = w[a + 11 | 0];
      i = ud(c);
      g = Jb(a);
      c = Cb(v[a + 4 >> 2], c);
     }
     b = Cg(b, g, c + 1 | 0);
     if (i) {
      Bb(g);
     }
     if (!h) {
      of(a, j);
      Ad(a, f);
      xd(a, b);
      break b;
     }
     Me(a, f);
     break b;
    }
    X(S(0) | 0) | 0;
    Y();
   }
   eb = e + 16 | 0;
  }
  eb = d + 16 | 0;
  return;
 }
 pf();
 p();
}

function eU(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0;
 d = eb - 16 | 0;
 eb = d;
 v[d + 12 >> 2] = b;
 if (b >>> 0 < 2147483632) {
  a: {
   if (Lc(a) >>> 0 >= b >>> 0) {
    break a;
   }
   k = d, l = Cb(v[a + 4 >> 2], w[a + 11 | 0]), v[k + 8 >> 2] = l;
   b = Eh(v[ad(d + 12 | 0, d + 8 | 0) >> 2]);
   if ((Lc(a) | 0) == (b | 0)) {
    break a;
   }
   e = eb - 16 | 0;
   eb = e;
   f = Cb(v[a + 4 >> 2], w[a + 11 | 0]);
   b: {
    c: {
     h = Kk(b);
     d: {
      if (h) {
       i = 1;
       j = b + 1 | 0;
       g = v[a >> 2];
       b = a;
       c = f;
       break d;
      }
      c = b + 1 | 0;
      e: {
       if (Lc(a) >>> 0 < b >>> 0) {
        pg(e + 8 | 0, c);
        break e;
       }
       v[31601] = 0;
       N(52, e + 8 | 0, c | 0);
       b = v[31601];
       v[31601] = 0;
       if ((b | 0) == 1) {
        break c;
       }
      }
      j = v[e + 12 >> 2];
      b = v[e + 8 >> 2];
      c = w[a + 11 | 0];
      i = ud(c);
      g = Jb(a);
      c = Cb(v[a + 4 >> 2], c);
     }
     b = Wg(b, g, c + 1 | 0);
     if (i) {
      Bb(g);
     }
     if (!h) {
      of(a, j);
      Ad(a, f);
      xd(a, b);
      break b;
     }
     Me(a, f);
     break b;
    }
    X(S(0) | 0) | 0;
    Y();
   }
   eb = e + 16 | 0;
  }
  eb = d + 16 | 0;
  return;
 }
 pf();
 p();
}

function fB(a, b) {
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0;
 d = x[a + 480188 >> 1];
 h = d >>> 0 <= 256 ? 256 : d;
 g = a + 1074992 | 0;
 f = v[a + 1298300 >> 2];
 a = d;
 a: {
  while (1) {
   if ((a | 0) != (h | 0)) {
    e = B(a, 872) + g | 0;
    if (!v[e + 76 >> 2]) {
     if (!Aj(v[e + 656 >> 2]) | w[e + 89 | 0] & 24) {
      break a;
     }
    }
    if (w[e + 89 | 0] & 2) {
     if (!Dd(f)) {
      break a;
     }
     if (!GS(f, a & 65535)) {
      break a;
     }
    }
    a = a + 1 | 0;
    continue;
   }
   break;
  }
  e = 8388608;
  if (b >>> 0 <= 255) {
   b = B(b, 872) + g | 0;
   if (!v[b + 696 >> 2]) {
    a = 65535;
    if (v[b + 76 >> 2]) {
     break a;
    }
   }
   e = v[b + 688 >> 2] | v[b + 680 >> 2] << 9;
  }
  b = 0;
  a = 65535;
  while (1) {
   if ((d | 0) == (h | 0)) {
    break a;
   }
   c = B(d, 872) + g | 0;
   if (!(v[c + 696 >> 2] ? 0 : v[c + 76 >> 2])) {
    f = (v[c + 688 >> 2] | v[c + 680 >> 2] << 9) >>> (v[c + 88 >> 2] >>> 1 & 1) | 0;
    b: {
     c: {
      if (f >>> 0 < e >>> 0) {
       c = v[c + 724 >> 2];
       break c;
      }
      if ((e | 0) != (f | 0)) {
       break b;
      }
      c = v[c + 724 >> 2];
      if (c >>> 0 <= b >>> 0) {
       break b;
      }
     }
     e = f;
     a = d;
     b = c;
    }
    d = d + 1 | 0;
    continue;
   }
   break;
  }
  a = d;
 }
 return a & 65535;
}

function nra(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0;
 d = eb - 32 | 0;
 eb = d;
 u[d + 30 >> 1] = 0;
 mg(a, d + 30 | 0);
 a: {
  b: {
   i = x[d + 30 >> 1];
   c: {
    if (i >>> 0 > 500) {
     break c;
    }
    d: {
     e: {
      while (1) {
       if ((f | 0) == (i | 0)) {
        break c;
       }
       h = Eb(d + 16 | 0);
       v[31601] = 0;
       u[d + 14 >> 1] = 0;
       g = O(498, a | 0, h | 0) | 0;
       e = v[31601];
       v[31601] = 0;
       if ((e | 0) == 1) {
        break b;
       }
       if (!g) {
        break d;
       }
       v[31601] = 0;
       g = d + 14 | 0;
       N(484, a | 0, g | 0);
       e = v[31601];
       v[31601] = 0;
       if ((e | 0) == 1) {
        break b;
       }
       v[31601] = 0;
       R(496, d | 0, c | 0, h | 0);
       e = v[31601];
       v[31601] = 0;
       if ((e | 0) != 1) {
        v[31601] = 0;
        g = O(497, b | 0, g | 0) | 0;
        e = v[31601];
        v[31601] = 0;
        if ((e | 0) == 1) {
         break e;
        }
        yb(g, d);
        sb(d);
        sb(h);
        f = f + 1 | 0;
        continue;
       }
       break;
      }
      f = M() | 0;
      break a;
     }
     f = M() | 0;
     sb(d);
     break a;
    }
    sb(h);
   }
   eb = d + 32 | 0;
   return;
  }
  f = M() | 0;
 }
 sb(h);
 P(f | 0);
 p();
}

function qua(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0;
 e = eb - 16 | 0;
 eb = e;
 md(b, 0);
 v[b >> 2] = w[a | 0] | w[a + 1 | 0] << 8 | (w[a + 2 | 0] << 16 | w[a + 3 | 0] << 24);
 c = Nr(a + 4 | 0, a);
 d = w[c | 0] | w[c + 1 | 0] << 8 | (w[c + 2 | 0] << 16 | w[c + 3 | 0] << 24);
 v[b + 4 >> 2] = d;
 c = Nr(a + 8 | 0, a);
 f = w[c | 0] | w[c + 1 | 0] << 8 | (w[c + 2 | 0] << 16 | w[c + 3 | 0] << 24);
 v[b + 8 >> 2] = f;
 c = (w[a + 15 | 0] | w[a + 16 | 0] << 8) << 1;
 v[b + 24 >> 2] = c;
 c = w[a + 15 | 0] | w[a + 16 | 0] << 8 ? c : 16726;
 v[b + 24 >> 2] = c;
 g = b, h = (B(xw(t[a + 17 | 0], w[a + 14 | 0] << 28 >> 24), c) >>> 0) / 8363 | 0, 
 v[g + 24 >> 2] = h;
 t[e + 15 | 0] = w[a + 18 | 0];
 t[e + 14 | 0] = 127;
 g = b, h = (((w[Pb(e + 15 | 0, e + 14 | 0) | 0] << 8 | 64) & 65344) >>> 0) / 127 | 0, 
 u[g + 30 >> 1] = h;
 c = w[a + 14 | 0];
 if (c >>> 0 >= 16) {
  u[b + 34 >> 1] = 32;
  u[b + 28 >> 1] = c & 240;
 }
 c = w[a + 19 | 0];
 if (c & 4) {
  u[b + 34 >> 1] = x[b + 34 >> 1] | 1;
  c = w[a + 19 | 0];
 }
 a: {
  if (!(c & 8) | d >>> 0 >= f >>> 0) {
   break a;
  }
  f = x[b + 34 >> 1];
  d = f | 2;
  u[b + 34 >> 1] = d;
  c = w[a + 19 | 0];
  if (c & 16) {
   d = f | 6;
   u[b + 34 >> 1] = d;
   c = w[a + 19 | 0];
  }
  if (!(c & 64)) {
   break a;
  }
  u[b + 34 >> 1] = d | 128;
 }
 eb = e + 16 | 0;
}

function kk(a) {
 var b = 0, c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0;
 d = eb - 32 | 0;
 eb = d;
 a: {
  b: {
   while (1) {
    f = d + 8 | 0;
    e = c << 2;
    h = f + e | 0;
    g = 1 << c & 2147483647;
    if (g | 1) {
     e = rI(c, g ? a : 22256);
    } else {
     e = v[e >> 2];
    }
    v[h >> 2] = e;
    if ((e | 0) == -1) {
     break b;
    }
    c = c + 1 | 0;
    if ((c | 0) != 6) {
     continue;
    }
    break;
   }
   if (!sI(0)) {
    b = 104872;
    if (!id(f, 104872, 24)) {
     break a;
    }
    b = 104896;
    if (!id(f, 104896, 24)) {
     break a;
    }
    c = 0;
    if (!w[501616]) {
     while (1) {
      i = (c << 2) + 501568 | 0, j = rI(c, 22256), v[i >> 2] = j;
      c = c + 1 | 0;
      if ((c | 0) != 6) {
       continue;
      }
      break;
     }
     t[501616] = 1;
     v[125398] = v[125392];
    }
    b = 501568;
    a = d + 8 | 0;
    if (!id(a, 501568, 24)) {
     break a;
    }
    b = 501592;
    if (!id(a, 501592, 24)) {
     break a;
    }
    b = Fd(24);
    if (!b) {
     break b;
    }
   }
   a = v[d + 12 >> 2];
   v[b >> 2] = v[d + 8 >> 2];
   v[b + 4 >> 2] = a;
   a = v[d + 28 >> 2];
   v[b + 16 >> 2] = v[d + 24 >> 2];
   v[b + 20 >> 2] = a;
   a = v[d + 20 >> 2];
   v[b + 8 >> 2] = v[d + 16 >> 2];
   v[b + 12 >> 2] = a;
   break a;
  }
  b = 0;
 }
 eb = d + 32 | 0;
 return b;
}

function Cma(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0, r = 0;
 b = eb - 16 | 0;
 eb = b;
 f = v[a + 40 >> 2];
 g = v[a + 36 >> 2];
 j = v[a + 16 >> 2];
 e = v[a + 4 >> 2];
 v[b + 8 >> 2] = v[a >> 2];
 v[b + 12 >> 2] = e;
 k = v[a + 32 >> 2];
 l = v[a + 28 >> 2];
 m = v[a + 8 >> 2];
 n = v[a + 12 >> 2];
 while (1) {
  if (d) {
   e = v[b + 8 >> 2];
   o = (((v[b + 12 >> 2] & 2147483647) << 1 | e >>> 31) & -2) + j | 0;
   e = e >>> 21 & 2040;
   p = u[e + 38050 >> 1] << 8;
   q = u[e + 38048 >> 1] << 8;
   r = u[e + 38052 >> 1] << 8;
   e = u[e + 38054 >> 1] << 8;
   h = 0;
   while (1) {
    if ((h | 0) != 2) {
     i = h + o | 0;
     v[(h << 2) + b >> 2] = (((B(t[i | 0], p) + B(t[i - 2 | 0], q) | 0) + B(t[i + 2 | 0], r) | 0) + B(t[i + 4 | 0], e) | 0) / 16384;
     h = h + 1 | 0;
     continue;
    }
    break;
   }
   g = g + l | 0;
   v[c >> 2] = v[c >> 2] + B(v[b >> 2], g >> 12);
   f = f + k | 0;
   v[c + 4 >> 2] = v[c + 4 >> 2] + B(v[b + 4 >> 2], f >> 12);
   Ob(b + 8 | 0, m, n);
   c = c + 8 | 0;
   d = d - 1 | 0;
   continue;
  }
  break;
 }
 c = v[b + 12 >> 2];
 v[a >> 2] = v[b + 8 >> 2];
 v[a + 4 >> 2] = c;
 v[a + 40 >> 2] = f;
 v[a + 20 >> 2] = g >> 12;
 v[a + 36 >> 2] = g;
 v[a + 24 >> 2] = f >> 12;
 eb = b + 16 | 0;
}

function _V(a, b, c, d) {
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0;
 g = eb - 16 | 0;
 eb = g;
 n = v[a + 20 >> 2];
 h = x[a + 34 >> 1] & 65;
 v[g + 12 >> 2] = h;
 v[g + 8 >> 2] = h ^ 65;
 h = b;
 i = 1074992;
 k = yj(d);
 while (1) {
  if ((i | 0) != 1298224) {
   e = d + i | 0;
   if (v[e + 104 >> 2] == (a | 0)) {
    if (v[e + 16 >> 2]) {
     v[e + 16 >> 2] = h;
    }
    if (y[e + 4 >> 2] > c >>> 0) {
     v[e >> 2] = 0;
     v[e + 4 >> 2] = 0;
    }
    b = a;
    if (v[e + 76 >> 2]) {
     wc(e + 76 | 0, c);
     b = v[e + 104 >> 2];
    }
    f = v[e + 88 >> 2];
    b = UF(f, b);
    j = v[(b ? 12 : 4) + a >> 2];
    v[e + 84 >> 2] = v[(b ? 16 : 8) + a >> 2];
    v[e + 80 >> 2] = j;
    b = f | v[g + 12 >> 2];
    v[e + 88 >> 2] = b;
    v[e + 88 >> 2] = b & (v[g + 8 >> 2] ^ -1);
    f = v[e + 704 >> 2];
    b = v[a + 24 >> 2];
    a: {
     if (!f | !b) {
      break a;
     }
     if (wn(v[d + 480180 >> 2])) {
      break a;
     }
     j = Aua(v[e + 700 >> 2], 0, k ? b : f, 0);
     f = k ? f : b;
     l = j + (f >>> 1 | 0) | 0;
     m = gb;
     o = e, p = Ac(Cua(l, j >>> 0 > l >>> 0 ? m + 1 | 0 : m, f, 0), gb), v[o + 700 >> 2] = p;
    }
    v[e + 704 >> 2] = b;
   }
   i = i + 872 | 0;
   continue;
  }
  break;
 }
 v[a >> 2] = c;
 v[a + 20 >> 2] = h;
 eC(n);
 eb = g + 16 | 0;
}

function sd(a) {
 var b = 0, c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0;
 b = v[a + 112 >> 2];
 d = v[a + 116 >> 2];
 i = !!(b | d);
 h = b;
 e = v[a + 4 >> 2];
 f = v[a + 44 >> 2];
 b = e - f | 0;
 g = b;
 c = b + v[a + 120 >> 2] | 0;
 b = v[a + 124 >> 2] + (b >> 31) | 0;
 a: {
  b = c >>> 0 < g >>> 0 ? b + 1 | 0 : b;
  if (!(((b | 0) >= (d | 0) & c >>> 0 >= h >>> 0 | (b | 0) > (d | 0)) & i)) {
   i = zt(a);
   if ((i | 0) >= 0) {
    break a;
   }
   e = v[a + 4 >> 2];
   f = v[a + 44 >> 2];
  }
  v[a + 112 >> 2] = -1;
  v[a + 116 >> 2] = -1;
  v[a + 104 >> 2] = e;
  g = c;
  c = f - e | 0;
  d = g + c | 0;
  b = (c >> 31) + b | 0;
  v[a + 120 >> 2] = d;
  v[a + 124 >> 2] = c >>> 0 > d >>> 0 ? b + 1 | 0 : b;
  return -1;
 }
 d = c + 1 | 0;
 b = d ? b : b + 1 | 0;
 h = v[a + 4 >> 2];
 f = v[a + 8 >> 2];
 c = v[a + 116 >> 2];
 g = c;
 e = v[a + 112 >> 2];
 b: {
  if (!(c | e)) {
   break b;
  }
  c = e - d | 0;
  e = g - (b + (d >>> 0 > e >>> 0) | 0) | 0;
  j = f - h | 0;
  g = j >> 31;
  if ((e | 0) >= (g | 0) & c >>> 0 >= j >>> 0 | (e | 0) > (g | 0)) {
   break b;
  }
  f = c + h | 0;
 }
 v[a + 104 >> 2] = f;
 c = v[a + 44 >> 2];
 f = c - h | 0;
 d = f + d | 0;
 b = (f >> 31) + b | 0;
 v[a + 120 >> 2] = d;
 v[a + 124 >> 2] = d >>> 0 < f >>> 0 ? b + 1 | 0 : b;
 if (c >>> 0 >= h >>> 0) {
  t[h - 1 | 0] = i;
 }
 return i;
}

function hka(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0;
 d = eb - 16 | 0;
 eb = d;
 v[d + 12 >> 2] = b;
 if (b >>> 0 < 1073741808) {
  a: {
   if (sn(a) >>> 0 >= b >>> 0) {
    break a;
   }
   k = d, l = Cb(v[a + 4 >> 2], w[a + 11 | 0]), v[k + 8 >> 2] = l;
   b = rn(v[ad(d + 12 | 0, d + 8 | 0) >> 2]);
   if ((sn(a) | 0) == (b | 0)) {
    break a;
   }
   e = eb - 16 | 0;
   eb = e;
   i = 1;
   f = b + 1 | 0;
   c = sn(a);
   g = Cb(v[a + 4 >> 2], w[a + 11 | 0]);
   b: {
    c: {
     j = fr(b);
     d: {
      if (j) {
       h = v[a >> 2];
       b = a;
       c = g;
       break d;
      }
      e: {
       if (b >>> 0 > c >>> 0) {
        Mj(e + 8 | 0, f);
        break e;
       }
       v[31601] = 0;
       N(54, e + 8 | 0, f | 0);
       b = v[31601];
       v[31601] = 0;
       if ((b | 0) == 1) {
        break c;
       }
      }
      f = v[e + 12 >> 2];
      b = v[e + 8 >> 2];
      c = w[a + 11 | 0];
      i = ud(c);
      h = Jb(a);
      c = Cb(v[a + 4 >> 2], c);
     }
     b = Qi(b, h, c + 1 | 0);
     if (i) {
      Bb(h);
     }
     if (!j) {
      of(a, f);
      Ad(a, g);
      xd(a, b);
      break b;
     }
     Me(a, g);
     break b;
    }
    X(S(0) | 0) | 0;
    Y();
   }
   eb = e + 16 | 0;
  }
  eb = d + 16 | 0;
  return;
 }
 pf();
 p();
}

function hja(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0;
 e = eb - 32 | 0;
 eb = e;
 c = x[v[v[a + 48 >> 2] + 12 >> 2] + 480188 >> 1];
 a: {
  if (!b) {
   break a;
  }
  c = B(b, c);
  b: {
   if (v[a + 12 >> 2] != (b | 0)) {
    break b;
   }
   if ((Fk(v[a >> 2], v[a + 4 >> 2]) | 0) != (c | 0)) {
    break b;
   }
   b = eb - 16 | 0;
   eb = b;
   d = vb(v[a >> 2]);
   a = vb(v[a + 4 >> 2]);
   u[b + 12 >> 1] = 0;
   v[b + 8 >> 2] = 0;
   f = xu(a, d);
   c = eb - 16 | 0;
   eb = c;
   v[c + 12 >> 2] = d;
   while (1) {
    if ((f | 0) > 0) {
     a = v[c + 12 >> 2];
     d = w[b + 8 | 0] | w[b + 9 | 0] << 8 | (w[b + 10 | 0] << 16 | w[b + 11 | 0] << 24);
     t[a | 0] = d;
     t[a + 1 | 0] = d >>> 8;
     t[a + 2 | 0] = d >>> 16;
     t[a + 3 | 0] = d >>> 24;
     d = w[b + 12 | 0] | w[b + 13 | 0] << 8;
     t[a + 4 | 0] = d;
     t[a + 5 | 0] = d >>> 8;
     f = f - 1 | 0;
     sg(c + 12 | 0);
     continue;
    }
    break;
   }
   eb = c + 16 | 0;
   eb = b + 16 | 0;
   break a;
  }
  u[e + 16 >> 1] = 0;
  v[e + 12 >> 2] = 0;
  c = CZ(e + 20 | 0, c, e + 12 | 0);
  gR(a);
  v[a >> 2] = v[c >> 2];
  v[a + 4 >> 2] = v[c + 4 >> 2];
  f = zb(c);
  g = zb(a), h = v[f >> 2], v[g >> 2] = h;
  v[f >> 2] = 0;
  v[c >> 2] = 0;
  v[c + 4 >> 2] = 0;
  Jk(c);
  v[a + 12 >> 2] = b;
 }
 eb = e + 32 | 0;
}

function $ka(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
 v[a >> 2] = 0;
 v[a + 4 >> 2] = 0;
 sc(a + 8 | 0);
 c = v[b + 4 >> 2];
 f = c;
 d = v[b >> 2];
 b = hh(d, c);
 c = eb - 16 | 0;
 eb = c;
 Qd(c + 8 | 0, v[ub(c + 4 | 0, a) >> 2]);
 a: {
  b: {
   if (b) {
    v[31601] = 0;
    N(798, a | 0, b | 0);
    e = v[31601];
    v[31601] = 0;
    if ((e | 0) == 1) {
     break b;
    }
    g = eb - 16 | 0;
    eb = g;
    h = hs(g + 4 | 0, a, b);
    i = v[h + 4 >> 2];
    e = eb - 16 | 0;
    eb = e;
    ed(e + 8 | 0, d, f);
    f = eb - 16 | 0;
    eb = f;
    n = f + 8 | 0;
    b = eb - 32 | 0;
    eb = b;
    ed(b + 24 | 0, v[e + 8 >> 2], v[e + 12 >> 2]);
    d = eb - 16 | 0;
    eb = d;
    j = v[b + 28 >> 2];
    k = v[b + 24 >> 2];
    l = j - k | 0;
    m = l >> 3;
    if (m) {
     fl(i, k, m << 3);
    }
    v[d + 12 >> 2] = i + l;
    pc(b + 16 | 0, j, d + 12 | 0);
    eb = d + 16 | 0;
    d = v[b + 16 >> 2];
    v[b + 12 >> 2] = v[b + 20 >> 2];
    pc(n, d, b + 12 | 0);
    eb = b + 32 | 0;
    eb = f + 16 | 0;
    eb = e + 16 | 0;
    v[h + 4 >> 2] = v[f + 12 >> 2];
    hc(h);
    eb = g + 16 | 0;
   }
   b = c + 8 | 0;
   Pd(b);
   $u(b);
   eb = c + 16 | 0;
   break a;
  }
  a = M() | 0;
  $u(c + 8 | 0);
  P(a | 0);
  p();
 }
 return a | 0;
}

function Eo(a, b) {
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0;
 c = v[b + 88 >> 2];
 d = c | 2048;
 v[b + 88 >> 2] = d;
 f = v[b + 656 >> 2];
 if (!(!f | t[b + 730 | 0] & 1)) {
  d = c | 6144;
  v[b + 88 >> 2] = d;
 }
 a: {
  if (!v[b + 76 >> 2]) {
   break a;
  }
  b: {
   if (!(d & 8) | c & 2048) {
    break b;
   }
   c = v[b + 104 >> 2];
   if (!c) {
    break b;
   }
   e = x[c + 34 >> 1];
   if (e & 2) {
    d = (e & 4 ? d | 4 : d & -135) | 2;
    v[b + 88 >> 2] = d;
    e = v[c >> 2];
    v[b + 76 >> 2] = e;
    g = v[c + 4 >> 2];
    v[b + 80 >> 2] = g;
    c = v[c + 8 >> 2];
    v[b + 84 >> 2] = c;
    if (c >>> 0 < e >>> 0) {
     v[b + 76 >> 2] = c;
     h = c;
    } else {
     h = e;
    }
    e = v[b + 4 >> 2];
    if (h >>> 0 >= e >>> 0) {
     break b;
    }
    v[b >> 2] = 0;
    v[b + 4 >> 2] = ((e - g >>> 0) % (c - g >>> 0) | 0) + g;
    break b;
   }
   d = d & -135;
   v[b + 88 >> 2] = d;
   v[b + 76 >> 2] = v[c >> 2];
  }
  if (!f) {
   break a;
  }
  if (!(!(w[f + 60 | 0] & 2 | v[a + 480180 >> 2] & 1064964) | !v[f >> 2])) {
   v[b + 88 >> 2] = d | 4096;
  }
  if (w[f + 65 | 0] == 255 | x[b + 728 >> 1] != 65535) {
   break a;
  }
  i = b, j = fd(Rq(f + 48 | 0, v[b + 724 >> 2], 256, 64)), u[i + 728 >> 1] = j;
  i = b, j = x[xb(v[f + 48 >> 2], w[f + 65 | 0]) >> 1], v[i + 724 >> 2] = j;
 }
}

function mpa(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0;
 c = eb + -64 | 0;
 eb = c;
 j = c, k = jf(a) >>> 5 | 0, u[j + 32 >> 1] = k;
 u[c + 20 >> 1] = 3999;
 d = x[Nc(c + 32 | 0, c + 20 | 0) >> 1];
 u[b + 480190 >> 1] = d;
 i = b + 946304 | 0;
 g = 1;
 while (1) {
  f = g & 65535;
  if (f >>> 0 <= d >>> 0) {
   d = mi(b, f);
   e = c + 32 | 0;
   xr(a, e);
   md(d, 0);
   h = c + 8 | 0;
   oi(h, 2, e);
   e = c + 20 | 0;
   Bc(e, h);
   zc((f << 5) + i | 0, e);
   sb(e);
   v[d + 24 >> 2] = 8287;
   j = c, k = Ab(w[c + 60 | 0] | w[c + 61 | 0] << 8), u[j + 20 >> 1] = k;
   u[c + 8 >> 1] = 64;
   j = d, k = x[Nc(e, h) >> 1] << 2, u[j + 30 >> 1] = k;
   j = d, k = _b(w[c + 52 | 0] | w[c + 53 | 0] << 8 | (w[c + 54 | 0] << 16 | w[c + 55 | 0] << 24)) & -2, 
   v[j >> 2] = k;
   e = Ab(w[c + 62 | 0] | w[c + 63 | 0] << 8);
   j = xb(d + 68 | 0, 0), k = e, v[j >> 2] = k;
   e = Ab(w[c + 56 | 0] | w[c + 57 | 0] << 8);
   f = Ab(w[c + 58 | 0] | w[c + 59 | 0] << 8);
   a: {
    if (f >>> 0 < 2) {
     break a;
    }
    f = e + f << 1;
    if (f >>> 0 > y[d >> 2]) {
     break a;
    }
    v[d + 16 >> 2] = f;
    v[d + 12 >> 2] = e << 1;
    u[d + 34 >> 1] = x[d + 34 >> 1] | 8;
   }
   g = g + 1 | 0;
   d = x[b + 480190 >> 1];
   continue;
  }
  break;
 }
 eb = c - -64 | 0;
}

function Rfa() {
 var a = 0, b = 0, c = 0, d = 0, e = 0, f = 0, g = 0;
 b = eb - 32 | 0;
 eb = b;
 c = Eb(b + 20 | 0);
 v[31601] = 0;
 V(983, b + 8 | 0);
 a = v[31601];
 v[31601] = 0;
 a: {
  b: {
   c: {
    d: {
     if ((a | 0) != 1) {
      f = b, g = vb(v[b + 8 >> 2]), v[f + 4 >> 2] = g;
      d = 1;
      while (1) {
       e = vb(v[b + 12 >> 2]);
       a = v[b + 4 >> 2];
       if (!Hb(a, e)) {
        a = Bg(Jb(c));
        Sd(b + 8 | 0);
        sb(c);
        break b;
       }
       if (!d) {
        v[31601] = 0;
        O(984, c | 0, 14604) | 0;
        a = v[31601];
        v[31601] = 0;
        if ((a | 0) == 1) {
         break d;
        }
        a = v[b + 4 >> 2];
       }
       v[31601] = 0;
       O(837, c | 0, a | 0) | 0;
       a = v[31601];
       v[31601] = 0;
       if ((a | 0) == 1) {
        break d;
       }
       vm(b + 4 | 0);
       d = 0;
       continue;
      }
     }
     a = S(0) | 0;
     break c;
    }
    a = S(0) | 0;
    Sd(b + 8 | 0);
   }
   sb(c);
   X(a | 0) | 0;
   a = 0;
   v[31601] = 0;
   U(982, 7040, 0, 0, 0);
   c = v[31601];
   v[31601] = 0;
   if ((c | 0) == 1) {
    break a;
   }
   Y();
  }
  eb = b + 32 | 0;
  return a | 0;
 }
 b = M() | 0;
 v[31601] = 0;
 W(26);
 a = v[31601];
 v[31601] = 0;
 if ((a | 0) == 1) {
  S(0) | 0;
  Rb();
  p();
 }
 P(b | 0);
 p();
}

function Qqa(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0;
 if (y[a + 4 >> 2] < y[zb(a) >> 2]) {
  c = eb - 16 | 0;
  eb = c;
  a = N$(c + 4 | 0, a);
  nD(v[a + 4 >> 2], b);
  v[a + 4 >> 2] = v[a + 4 >> 2] + 28;
  hc(a);
  eb = c + 16 | 0;
  return;
 }
 h = eb - 32 | 0;
 eb = h;
 c = zb(a);
 c = L$(h + 12 | 0, M$(a, Hr(v[a >> 2], v[a + 4 >> 2]) + 1 | 0), Hr(v[a >> 2], v[a + 4 >> 2]), c);
 nD(v[c + 8 >> 2], b);
 v[c + 8 >> 2] = v[c + 8 >> 2] + 28;
 g = eb - 16 | 0;
 eb = g;
 e = zb(a);
 b = ub(g + 12 | 0, v[a + 4 >> 2]);
 i = ub(g + 8 | 0, v[a >> 2]);
 f = ub(g + 4 | 0, v[c + 4 >> 2]);
 d = v[b >> 2];
 i = v[i >> 2];
 b = eb + -64 | 0;
 eb = b;
 f = v[f >> 2];
 v[b + 56 >> 2] = f;
 v[b + 60 >> 2] = d;
 v[b + 52 >> 2] = f;
 e = zg(b + 24 | 0, e, b + 52 | 0, b + 56 | 0);
 v[b + 16 >> 2] = v[e + 8 >> 2];
 f = v[e + 4 >> 2];
 v[b + 8 >> 2] = v[e >> 2];
 v[b + 12 >> 2] = f;
 yg(b + 36 | 0, b + 8 | 0);
 while (1) {
  if (Ed(d, i)) {
   nD(oE(v[b + 56 >> 2]), Fr(d));
   d = pw(b + 60 | 0);
   pw(b + 56 | 0);
   d = v[d >> 2];
   continue;
  }
  break;
 }
 d = b + 36 | 0;
 xg(d);
 e = v[b + 56 >> 2];
 J$(d);
 eb = b - -64 | 0;
 v[c + 4 >> 2] = e;
 Sb(a, c + 4 | 0);
 Sb(a + 4 | 0, c + 8 | 0);
 Sb(zb(a), mc(c));
 v[c >> 2] = v[c + 4 >> 2];
 eb = g + 16 | 0;
 K$(c);
 eb = h + 32 | 0;
}

function Uj(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0;
 if (y[a + 4 >> 2] < y[zb(a) >> 2]) {
  c = eb - 16 | 0;
  eb = c;
  a = N$(c + 4 | 0, a);
  pE(v[a + 4 >> 2], b);
  v[a + 4 >> 2] = v[a + 4 >> 2] + 28;
  hc(a);
  eb = c + 16 | 0;
  return;
 }
 h = eb - 32 | 0;
 eb = h;
 c = zb(a);
 c = L$(h + 12 | 0, M$(a, Hr(v[a >> 2], v[a + 4 >> 2]) + 1 | 0), Hr(v[a >> 2], v[a + 4 >> 2]), c);
 pE(v[c + 8 >> 2], b);
 v[c + 8 >> 2] = v[c + 8 >> 2] + 28;
 g = eb - 16 | 0;
 eb = g;
 e = zb(a);
 b = ub(g + 12 | 0, v[a + 4 >> 2]);
 i = ub(g + 8 | 0, v[a >> 2]);
 f = ub(g + 4 | 0, v[c + 4 >> 2]);
 d = v[b >> 2];
 i = v[i >> 2];
 b = eb + -64 | 0;
 eb = b;
 f = v[f >> 2];
 v[b + 56 >> 2] = f;
 v[b + 60 >> 2] = d;
 v[b + 52 >> 2] = f;
 e = zg(b + 24 | 0, e, b + 52 | 0, b + 56 | 0);
 v[b + 16 >> 2] = v[e + 8 >> 2];
 f = v[e + 4 >> 2];
 v[b + 8 >> 2] = v[e >> 2];
 v[b + 12 >> 2] = f;
 yg(b + 36 | 0, b + 8 | 0);
 while (1) {
  if (Ed(d, i)) {
   pE(oE(v[b + 56 >> 2]), Fr(d));
   d = pw(b + 60 | 0);
   pw(b + 56 | 0);
   d = v[d >> 2];
   continue;
  }
  break;
 }
 d = b + 36 | 0;
 xg(d);
 e = v[b + 56 >> 2];
 J$(d);
 eb = b - -64 | 0;
 v[c + 4 >> 2] = e;
 Sb(a, c + 4 | 0);
 Sb(a + 4 | 0, c + 8 | 0);
 Sb(zb(a), mc(c));
 v[c >> 2] = v[c + 4 >> 2];
 eb = g + 16 | 0;
 K$(c);
 eb = h + 32 | 0;
}

function Pha(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = C(0);
 c = eb - 4112 | 0;
 eb = c;
 h = hb[v[v[a >> 2] + 120 >> 2]](a) | 0;
 if (!h) {
  hb[v[v[a >> 2] + 124 >> 2]](a);
 }
 v[c + 12 >> 2] = 0;
 f = eb - 16 | 0;
 eb = f;
 while (1) {
  d = v[a + 44 >> 2];
  if (fk(d, v[a + 48 >> 2]) >>> 0 <= e >>> 0) {
   eb = f + 16 | 0;
  } else {
   v[f + 12 >> 2] = 0;
   d = as(d, e);
   g = (d + 2048 | 0) - d >> 2;
   while (1) {
    if ((g | 0) > 0) {
     z[d >> 2] = z[f + 12 >> 2];
     g = g - 1 | 0;
     d = d + 4 | 0;
     continue;
    }
    break;
   }
   e = e + 1 | 0;
   continue;
  }
  break;
 }
 d = c + 2064 | 0;
 a: while (1) {
  if (b) {
   v[c + 8 >> 2] = b;
   wc(c + 8 | 0, 512);
   e = c + 16 | 0;
   WA(e);
   f = v[c + 8 >> 2];
   hb[v[v[a >> 2] + 60 >> 2]](a, e, d, f);
   e = 0;
   while (1) if ((e | 0) == (f | 0)) {
    b = b - f | 0;
    continue a;
   } else {
    g = e << 2;
    z[c + 4 >> 2] = D(z[g + (c + 16 | 0) >> 2]);
    i = c, j = z[Yz(c + 12 | 0, c + 4 | 0) >> 2], z[i + 12 >> 2] = j;
    z[c + 4 >> 2] = D(z[d + g >> 2]);
    i = c, j = z[Yz(c + 12 | 0, c + 4 | 0) >> 2], z[i + 12 >> 2] = j;
    e = e + 1 | 0;
    continue;
   }
  }
  break;
 }
 if (!h) {
  hb[v[v[a >> 2] + 128 >> 2]](a);
 }
 eb = c + 4112 | 0;
 return C(z[c + 12 >> 2]);
}

function sja(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0;
 md(c, 0);
 u[c + 28 >> 1] = w[a + 36 | 0] << 2;
 d = w[a + 37 | 0];
 u[c + 32 >> 1] = 64;
 u[c + 30 >> 1] = d << 2;
 v[c >> 2] = w[a + 40 | 0] | w[a + 41 | 0] << 8 | (w[a + 42 | 0] << 16 | w[a + 43 | 0] << 24);
 v[c + 4 >> 2] = w[a + 44 | 0] | w[a + 45 | 0] << 8 | (w[a + 46 | 0] << 16 | w[a + 47 | 0] << 24);
 v[c + 8 >> 2] = w[a + 48 | 0] | w[a + 49 | 0] << 8 | (w[a + 50 | 0] << 16 | w[a + 51 | 0] << 24);
 v[c + 24 >> 2] = w[a + 52 | 0] | w[a + 53 | 0] << 8 | (w[a + 54 | 0] << 16 | w[a + 55 | 0] << 24);
 d = w[b + 151 | 0];
 if (d >>> 0 <= 4) {
  t[c + 38 | 0] = w[d + 41082 | 0];
 }
 d = w[b + 152 | 0] | w[b + 153 | 0] << 8;
 t[c + 39 | 0] = d;
 e = (w[b + 156 | 0] | w[b + 157 | 0] << 8) >>> 4 | 0;
 t[c + 41 | 0] = e;
 b = (w[b + 154 | 0] | w[b + 155 | 0] << 8) >>> 2 | 0;
 t[c + 40 | 0] = b;
 if ((b | e) & 255) {
  t[c + 39 | 0] = d ^ -1;
 }
 b = w[a + 38 | 0] | w[a + 39 | 0] << 8;
 if (b & 4) {
  u[c + 34 >> 1] = x[c + 34 >> 1] | 1;
  b = w[a + 38 | 0] | w[a + 39 | 0] << 8;
 }
 if (b & 8) {
  u[c + 34 >> 1] = x[c + 34 >> 1] | 2;
  b = w[a + 38 | 0] | w[a + 39 | 0] << 8;
 }
 if (b & 16) {
  u[c + 34 >> 1] = x[c + 34 >> 1] | 4;
  b = w[a + 38 | 0] | w[a + 39 | 0] << 8;
 }
 if (b & 32) {
  u[c + 34 >> 1] = x[c + 34 >> 1] | 32;
 }
}

function PO(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0;
 e = eb - 32 | 0;
 eb = e;
 g = Mb(a);
 a = x[v[b + 24 >> 2] + 480192 >> 1];
 v[31601] = 0;
 N(176, g | 0, a | 0);
 c = v[31601];
 v[31601] = 0;
 a = 1;
 a: {
  if ((c | 0) != 1) {
   b: {
    c: {
     d: {
      e: {
       while (1) {
        d = a & 65535;
        c = v[b + 24 >> 2];
        if (d >>> 0 > x[c + 480192 >> 1]) {
         break b;
        }
        c = RR(c, d);
        v[31601] = 0;
        c = O(36, e + 8 | 0, c | 0) | 0;
        d = v[31601];
        v[31601] = 0;
        if ((d | 0) != 1) {
         f = v[b + 24 >> 2];
         v[31601] = 0;
         d = e + 20 | 0;
         R(1052, d | 0, f | 0, c | 0);
         f = v[31601];
         v[31601] = 0;
         if ((f | 0) == 1) {
          break e;
         }
         v[31601] = 0;
         N(178, g | 0, d | 0);
         f = v[31601];
         v[31601] = 0;
         if ((f | 0) == 1) {
          break d;
         }
         sb(d);
         sb(c);
         a = a + 1 | 0;
         continue;
        }
        break;
       }
       a = M() | 0;
       break a;
      }
      a = M() | 0;
      break c;
     }
     a = M() | 0;
     sb(e + 20 | 0);
    }
    sb(c);
    break a;
   }
   eb = e + 32 | 0;
   return;
  }
  a = M() | 0;
 }
 Sd(g);
 P(a | 0);
 p();
}

function pN(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0;
 f = eb - 16 | 0;
 eb = f;
 a: {
  b: {
   c: {
    d: {
     e: {
      if ((b | 0) >= 0) {
       d = v[a + 32 >> 2];
       if ((wo(d) | 0) > (b | 0)) {
        break e;
       }
      }
      a = cc(8);
      v[31601] = 0;
      b = O(36, f + 4 | 0, 10735) | 0;
      c = v[31601];
      v[31601] = 0;
      if ((c | 0) == 1) {
       break d;
      }
      rc(a, b);
      v[31601] = 0;
      R(97, a | 0, 48396, 999);
      a = v[31601];
      v[31601] = 0;
      if ((a | 0) != 1) {
       break b;
      }
      c = M() | 0;
      sb(b);
      break c;
     }
     e = (d + (b << 5) | 0) + 480280 | 0;
     g = c ? 134218752 : 0;
     v[e >> 2] = g | v[e >> 2] & -134218753;
     c = (d + B(b, 872) | 0) + 1075080 | 0;
     v[c >> 2] = v[c >> 2] & -134218753 | g;
     c = x[d + 480188 >> 1];
     d = c >>> 0 <= 256 ? 256 : c;
     b = b + 1 | 0;
     e = v[a + 32 >> 2] + 1074992 | 0;
     while (1) {
      if ((c | 0) == (d | 0)) {
       break a;
      }
      a = e + B(c, 872) | 0;
      if ((b | 0) == x[a + 786 >> 1]) {
       v[a + 88 >> 2] = v[a + 88 >> 2] & -134218753 | g;
      }
      c = c + 1 | 0;
      continue;
     }
    }
    c = M() | 0;
    jc(a);
   }
   P(c | 0);
  }
  p();
 }
 eb = f + 16 | 0;
}

function CO(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0;
 e = eb - 32 | 0;
 eb = e;
 g = Mb(a);
 a = x[v[b + 24 >> 2] + 480190 >> 1];
 v[31601] = 0;
 N(176, g | 0, a | 0);
 c = v[31601];
 v[31601] = 0;
 a = 1;
 a: {
  if ((c | 0) != 1) {
   b: {
    c: {
     d: {
      e: {
       while (1) {
        d = a & 65535;
        c = v[b + 24 >> 2];
        if (d >>> 0 > x[c + 480190 >> 1]) {
         break b;
        }
        v[31601] = 0;
        c = O(36, e + 8 | 0, SR(c, d) | 0) | 0;
        d = v[31601];
        v[31601] = 0;
        if ((d | 0) != 1) {
         f = v[b + 24 >> 2];
         v[31601] = 0;
         d = e + 20 | 0;
         R(1052, d | 0, f | 0, c | 0);
         f = v[31601];
         v[31601] = 0;
         if ((f | 0) == 1) {
          break e;
         }
         v[31601] = 0;
         N(178, g | 0, d | 0);
         f = v[31601];
         v[31601] = 0;
         if ((f | 0) == 1) {
          break d;
         }
         sb(d);
         sb(c);
         a = a + 1 | 0;
         continue;
        }
        break;
       }
       a = M() | 0;
       break a;
      }
      a = M() | 0;
      break c;
     }
     a = M() | 0;
     sb(e + 20 | 0);
    }
    sb(c);
    break a;
   }
   eb = e + 32 | 0;
   return;
  }
  a = M() | 0;
 }
 Sd(g);
 P(a | 0);
 p();
}

function Jka(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0;
 g = eb - 80 | 0;
 eb = g;
 e = Qf(g + 52 | 0);
 v[31601] = 0;
 d = O(830, b | 0, e | 0) | 0;
 c = v[31601];
 v[31601] = 0;
 a: {
  b: {
   c: {
    if ((c | 0) != 1) {
     if (d) {
      break c;
     }
     v[a >> 2] = 0;
     v[a + 4 >> 2] = 0;
     v[a + 24 >> 2] = 0;
     v[a + 16 >> 2] = 0;
     v[a + 20 >> 2] = 0;
     v[a + 8 >> 2] = 0;
     v[a + 12 >> 2] = 0;
     v[31601] = 0;
     Q(831, a | 0) | 0;
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) != 1) {
      break b;
     }
    }
    break a;
   }
   c = v[e + 4 >> 2];
   f = v[e >> 2];
   v[31601] = 0;
   d = g + 12 | 0;
   c = _b(c);
   d: {
    if (!c) {
     h = -1;
     if ((_b(f) | 0) == 1112491097) {
      break d;
     }
    }
    h = c;
   }
   c = h;
   R(185, d | 0, b | 0, c | 0);
   f = v[31601];
   v[31601] = 0;
   if ((f | 0) == 1) {
    break a;
   }
   f = gc(g + 32 | 0, d);
   jd(e + 8 | 0, f);
   tb(f);
   tb(d);
   e: {
    d = c & 1;
    if (!d) {
     break e;
    }
    v[31601] = 0;
    O(183, b | 0, 2 - d | 0) | 0;
    b = v[31601];
    v[31601] = 0;
    if ((b | 0) != 1) {
     break e;
    }
    break a;
   }
   Lk(a, e);
  }
  Gd(e);
  eb = g + 80 | 0;
  return;
 }
 a = M() | 0;
 Gd(e);
 P(a | 0);
 p();
}

function k4(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0;
 d = eb - 160 | 0;
 eb = d;
 Qb(d + 116 | 0, 0, 44);
 h = a + 4 | 0;
 while (1) {
  if ((c | 0) == 7) {
   a: {
    h = a + 172 | 0;
    c = 0;
    while (1) {
     if ((c | 0) == 12) {
      break a;
     }
     v[d + 132 >> 2] = c;
     e = d + 16 | 0;
     f = d + 116 | 0;
     ea(e | 0, 100, 14278, f | 0, v[a >> 2]) | 0;
     g = h + B(c, 12) | 0;
     kd(g, e);
     ea(e | 0, 100, 13333, f | 0, v[a >> 2]) | 0;
     kd(g + 144 | 0, e);
     c = c + 1 | 0;
     continue;
    }
   }
  } else {
   v[d + 140 >> 2] = c;
   e = d + 16 | 0;
   f = d + 116 | 0;
   ea(e | 0, 100, 14291, f | 0, v[a >> 2]) | 0;
   g = h + B(c, 12) | 0;
   kd(g, e);
   ea(e | 0, 100, 13540, f | 0, v[a >> 2]) | 0;
   kd(g + 84 | 0, e);
   c = c + 1 | 0;
   continue;
  }
  break;
 }
 v[d + 124 >> 2] = 1;
 c = d + 16 | 0;
 e = d + 116 | 0;
 ea(c | 0, 100, 9262, e | 0, v[a >> 2]) | 0;
 kd(a + 460 | 0, c);
 v[d + 124 >> 2] = 13;
 ea(c | 0, 100, 9262, e | 0, v[a >> 2]) | 0;
 kd(a + 472 | 0, c);
 c = d + 4 | 0;
 $s(c, a, 99, b);
 yb(a + 484 | 0, c);
 sb(c);
 $s(c, a, 114, b);
 yb(a + 496 | 0, c);
 sb(c);
 $s(c, a, 120, b);
 yb(a + 508 | 0, c);
 sb(d + 4 | 0);
 $s(c, a, 88, b);
 yb(a + 520 | 0, c);
 sb(d + 4 | 0);
 eb = d + 160 | 0;
}

function TB(a, b, c, d, e) {
 var f = 0, g = 0, h = 0, i = 0, j = 0;
 h = eb - 16 | 0;
 eb = h;
 i = Ol(a, b);
 a: {
  if ((i | 0) == 255) {
   break a;
  }
  if (Ej(v[a >> 2])) {
   break a;
  }
  b: {
   if (c >>> 0 > 6208431) {
    j = 7168;
    c = 1023;
    break b;
   }
   f = 7;
   c: {
    if (c >>> 0 > 3104215) {
     break c;
    }
    f = 6;
    if (c >>> 0 > 1552107) {
     break c;
    }
    f = 5;
    if (c >>> 0 > 776053) {
     break c;
    }
    f = 4;
    if (c >>> 0 > 388026) {
     break c;
    }
    f = 3;
    if (c >>> 0 > 194013) {
     break c;
    }
    f = 2;
    if (c >>> 0 > 97006) {
     break c;
    }
    f = c >>> 0 > 48503;
   }
   j = f << 10;
   f = 20 - f | 0;
   g = f & 31;
   if ((f & 63) >>> 0 >= 32) {
    f = c << g;
    c = 0;
   } else {
    f = (1 << g) - 1 & c >>> 32 - g;
    c = c << g;
   }
   g = c + 24858e3 | 0;
   c = f;
   c = Ac(Cua(g, g >>> 0 < 24858e3 ? c + 1 | 0 : c, 49716e3, 0), gb);
  }
  if (e) {
   u[h + 14 >> 1] = (b & 3) + c;
   u[h + 12 >> 1] = 1023;
   c = x[Nc(h + 14 | 0, h + 12 | 0) >> 1];
  }
  e = cv(i);
  f = wb(a + 8 | 0, i);
  t[f | 0] = (c | j) >>> 8 | (d ? 0 : 32);
  zh(v[a >> 2], v[a + 4 >> 2], b, e | 160, c & 255);
  zh(v[a >> 2], v[a + 4 >> 2], b, e | 176, w[f | 0]);
  t[a + 534 | 0] = 1;
 }
 eb = h + 16 | 0;
}

function oM(a) {
 var b = 0, c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, k = 0, m = 0, p = 0, q = 0;
 o(+a);
 b = j(1) | 0;
 e = j(0) | 0;
 a: {
  b: {
   c: {
    if (!(((b | 0) > 0 | (b | 0) >= 0) & b >>> 0 > 1048575)) {
     if (a == 0) {
      return -1 / (a * a);
     }
     if ((b | 0) > 0 | (b | 0) >= 0) {
      break c;
     }
     return (a - a) / 0;
    }
    if (b >>> 0 > 2146435071) {
     break a;
    }
    c = 1072693248;
    k = -1023;
    if ((b | 0) != 1072693248) {
     c = b;
     break b;
    }
    if (e) {
     break b;
    }
    return 0;
   }
   o(+(a * 0x40000000000000));
   b = j(1) | 0;
   e = j(0) | 0;
   c = b;
   k = -1077;
  }
  l(0, e | 0);
  c = c + 614242 | 0;
  l(1, (c & 1048575) + 1072079006 | 0);
  d = +n() + -1;
  f = d * (d * .5);
  g = d / (d + 2);
  h = g * g;
  a = h * h;
  o(+(d - f));
  b = j(1) | 0;
  j(0) | 0;
  l(0, 0);
  l(1, b | 0);
  i = +n();
  m = i * 1.4426950407214463;
  p = +((c >>> 20 | 0) + k | 0);
  q = m + p;
  a = g * (f + (a * (a * (a * .15313837699209373 + .22222198432149784) + .3999999999940942) + h * (a * (a * (a * .14798198605116586 + .1818357216161805) + .2857142874366239) + .6666666666666735))) + (d - i - f);
  a = q + (m + (p - q) + ((a + i) * 1.6751713164886512e-10 + a * 1.4426950407214463));
 }
 return a;
}

function rI(a, b) {
 var c = 0, d = 0, e = 0;
 a: {
  if (w[b | 0]) {
   break a;
  }
  b = by(13900);
  if (w[b | 0] ? b : 0) {
   break a;
  }
  b = by(B(a, 12) + 104928 | 0);
  if (w[b | 0] ? b : 0) {
   break a;
  }
  b = by(14156);
  if (w[b | 0] ? b : 0) {
   break a;
  }
  b = 14726;
 }
 b: {
  while (1) {
   d = w[b + c | 0];
   if (!(!d | (d | 0) == 47)) {
    d = 23;
    c = c + 1 | 0;
    if ((c | 0) != 23) {
     continue;
    }
    break b;
   }
   break;
  }
  d = c;
 }
 e = 14726;
 c: {
  d: {
   c = w[b | 0];
   e: {
    f: {
     if (!(w[b + d | 0] | (c | 0) == 46)) {
      e = b;
      if ((c | 0) != 67) {
       break f;
      }
     }
     if (!w[e + 1 | 0]) {
      break e;
     }
    }
    if (!gi(e, 14726)) {
     break e;
    }
    if (gi(e, 13638)) {
     break d;
    }
   }
   if (!a) {
    c = 105e3;
    if (w[e + 1 | 0] == 46) {
     break c;
    }
   }
   return 0;
  }
  c = v[125405];
  if (c) {
   while (1) {
    if (!gi(e, c + 8 | 0)) {
     break c;
    }
    c = v[c + 32 >> 2];
    if (c) {
     continue;
    }
    break;
   }
  }
  c = Fd(36);
  if (c) {
   v[c + 4 >> 2] = 20;
   v[c >> 2] = 95104;
   b = c + 8 | 0;
   yc(b, e, d);
   t[b + d | 0] = 0;
   v[c + 32 >> 2] = v[125405];
   v[125405] = c;
  }
  c = a | c ? c : 105e3;
 }
 return c;
}

function fq(a, b, c, d) {
 var e = 0, f = 0, g = 0, h = 0;
 g = d ? d : 497504;
 d = v[g >> 2];
 a: {
  b: {
   c: {
    if (!b) {
     if (d) {
      break c;
     }
     return 0;
    }
    e = -2;
    if (!c) {
     break b;
    }
    d: {
     if (d) {
      e = c;
      break d;
     }
     d = w[b | 0];
     f = d << 24 >> 24;
     if ((f | 0) >= 0) {
      if (a) {
       v[a >> 2] = d;
      }
      return (f | 0) != 0;
     }
     if (!v[v[124107] >> 2]) {
      e = 1;
      if (!a) {
       break b;
      }
      v[a >> 2] = f & 57343;
      return 1;
     }
     d = d - 194 | 0;
     if (d >>> 0 > 50) {
      break c;
     }
     d = v[(d << 2) + 120672 >> 2];
     e = c - 1 | 0;
     if (!e) {
      break a;
     }
     b = b + 1 | 0;
    }
    f = w[b | 0];
    h = f >>> 3 | 0;
    if ((h - 16 | (d >> 26) + h) >>> 0 > 7) {
     break c;
    }
    while (1) {
     e = e - 1 | 0;
     d = f - 128 | d << 6;
     if ((d | 0) >= 0) {
      v[g >> 2] = 0;
      if (a) {
       v[a >> 2] = d;
      }
      return c - e | 0;
     }
     if (!e) {
      break a;
     }
     b = b + 1 | 0;
     f = w[b | 0];
     if ((f & 192) == 128) {
      continue;
     }
     break;
    }
   }
   v[g >> 2] = 0;
   v[31476] = 25;
   e = -1;
  }
  return e;
 }
 v[g >> 2] = d;
 return -2;
}

function Z8(a, b, c, d, e, f) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 f = f | 0;
 var g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
 h = v[b + 44 >> 2];
 i = v[b + 24 >> 2];
 if (h >>> 0 < i >>> 0) {
  v[b + 44 >> 2] = i;
  h = i;
 }
 m = -1;
 n = -1;
 o = f & 24;
 a: {
  if (!o | (e | 0) == 1 & (o | 0) == 24) {
   break a;
  }
  if (h) {
   j = h - Jb(b + 32 | 0) | 0;
   k = j >> 31;
  }
  b: {
   c: {
    switch (e | 0) {
    case 1:
     if (f & 8) {
      g = v[b + 12 >> 2] - v[b + 8 >> 2] | 0;
      l = g >> 31;
      break b;
     }
     g = i - v[b + 20 >> 2] | 0;
     l = g >> 31;
     break b;

    case 0:
     break b;

    case 2:
     break c;

    default:
     break a;
    }
   }
   g = j;
   l = k;
  }
  d = d + l | 0;
  c = c + g | 0;
  d = g >>> 0 > c >>> 0 ? d + 1 | 0 : d;
  if ((d | 0) < 0 | (c >>> 0 > j >>> 0 & (d | 0) >= (k | 0) | (d | 0) > (k | 0))) {
   break a;
  }
  e = f & 8;
  d: {
   if (!(c | d)) {
    break d;
   }
   if (v[b + 12 >> 2] ? 0 : e) {
    break a;
   }
   if (!(f & 16)) {
    break d;
   }
   if (!i) {
    break a;
   }
  }
  if (e) {
   e = v[b + 8 >> 2];
   Un(b, e, c + e | 0, h);
  }
  if (f & 16) {
   Ex(b, v[b + 20 >> 2], v[b + 28 >> 2]);
   As(b, c);
  }
  m = c;
  n = d;
 }
 $h(a, m, n);
}

function HT(a, b) {
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0;
 g = eb - 16 | 0;
 eb = g;
 c = ub(g + 12 | 0, v[a + 4 >> 2]);
 d = ub(g + 8 | 0, v[a >> 2]);
 e = v[ub(g + 4 | 0, v[b + 4 >> 2]) >> 2];
 h = eb - 16 | 0;
 eb = h;
 j = h + 8 | 0;
 f = eb - 32 | 0;
 eb = f;
 ed(f + 24 | 0, v[c >> 2], v[d >> 2]);
 k = f + 16 | 0;
 c = v[f + 24 >> 2];
 l = v[f + 28 >> 2];
 d = eb - 16 | 0;
 eb = d;
 v[d + 8 >> 2] = e;
 v[d + 12 >> 2] = c;
 while (1) {
  if (Ed(c, l)) {
   c = ET(c);
   e = ET(v[d + 8 >> 2]);
   i = w[c + 3 | 0] | w[c + 4 | 0] << 8 | (w[c + 5 | 0] << 16 | w[c + 6 | 0] << 24);
   t[e + 3 | 0] = i;
   t[e + 4 | 0] = i >>> 8;
   t[e + 5 | 0] = i >>> 16;
   t[e + 6 | 0] = i >>> 24;
   c = w[c | 0] | w[c + 1 | 0] << 8 | (w[c + 2 | 0] << 16 | w[c + 3 | 0] << 24);
   t[e | 0] = c;
   t[e + 1 | 0] = c >>> 8;
   t[e + 2 | 0] = c >>> 16;
   t[e + 3 | 0] = c >>> 24;
   c = DT(d + 12 | 0);
   DT(d + 8 | 0);
   c = v[c >> 2];
   continue;
  }
  break;
 }
 pc(k, c, d + 8 | 0);
 eb = d + 16 | 0;
 c = v[f + 16 >> 2];
 v[f + 12 >> 2] = v[f + 20 >> 2];
 pc(j, c, f + 12 | 0);
 eb = f + 32 | 0;
 eb = h + 16 | 0;
 v[b + 4 >> 2] = v[h + 12 >> 2];
 Sb(a, b + 4 | 0);
 Sb(a + 4 | 0, b + 8 | 0);
 Sb(zb(a), mc(b));
 v[b >> 2] = v[b + 4 >> 2];
 eb = g + 16 | 0;
}

function x9(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0;
 d = eb - 32 | 0;
 eb = d;
 e = v[a + 28 >> 2];
 v[d + 16 >> 2] = e;
 f = v[a + 20 >> 2];
 v[d + 28 >> 2] = c;
 v[d + 24 >> 2] = b;
 b = f - e | 0;
 v[d + 20 >> 2] = b;
 f = b + c | 0;
 i = 2;
 b = d + 16 | 0;
 a: {
  while (1) {
   b: {
    c: {
     d: {
      if (!$y(za(v[a + 60 >> 2], b | 0, i | 0, d + 12 | 0) | 0)) {
       g = v[d + 12 >> 2];
       if ((g | 0) == (f | 0)) {
        break d;
       }
       if ((g | 0) >= 0) {
        break c;
       }
       break b;
      }
      if ((f | 0) != -1) {
       break b;
      }
     }
     b = v[a + 44 >> 2];
     v[a + 28 >> 2] = b;
     v[a + 20 >> 2] = b;
     v[a + 16 >> 2] = b + v[a + 48 >> 2];
     a = c;
     break a;
    }
    h = v[b + 4 >> 2];
    j = h >>> 0 < g >>> 0;
    e = (j << 3) + b | 0;
    h = g - (j ? h : 0) | 0;
    v[e >> 2] = h + v[e >> 2];
    b = (j ? 12 : 4) + b | 0;
    v[b >> 2] = v[b >> 2] - h;
    f = f - g | 0;
    i = i - j | 0;
    b = e;
    continue;
   }
   break;
  }
  v[a + 28 >> 2] = 0;
  v[a + 16 >> 2] = 0;
  v[a + 20 >> 2] = 0;
  v[a >> 2] = v[a >> 2] | 32;
  a = 0;
  if ((i | 0) == 2) {
   break a;
  }
  a = c - v[b + 4 >> 2] | 0;
 }
 eb = d + 32 | 0;
 return a | 0;
}

function Yla(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
 e = eb - 16 | 0;
 eb = e;
 g = v[a + 40 >> 2];
 h = v[a + 36 >> 2];
 j = v[a + 16 >> 2];
 i = v[a + 4 >> 2];
 v[e + 8 >> 2] = v[a >> 2];
 v[e + 12 >> 2] = i;
 k = b + 24 | 0;
 l = v[a + 32 >> 2];
 m = v[a + 28 >> 2];
 i = v[a + 8 >> 2];
 n = v[a + 12 >> 2];
 while (1) {
  if (d) {
   b = v[e + 8 >> 2];
   f = (v[e + 12 >> 2] << 1) + j | 0;
   b = (((b >>> 16 | 0) + 4 & 131064) << 1) + k | 0;
   b = (((((B(u[f + 4 >> 1], u[b + 10 >> 1]) + B(u[f + 2 >> 1], u[b + 8 >> 1]) | 0) + B(u[f + 6 >> 1], u[b + 12 >> 1]) | 0) + B(u[f + 8 >> 1], u[b + 14 >> 1]) | 0) / 2 | 0) + ((((B(u[f - 4 >> 1], u[b + 2 >> 1]) + B(u[f - 6 >> 1], u[b >> 1]) | 0) + B(u[f - 2 >> 1], u[b + 4 >> 1]) | 0) + B(u[f >> 1], u[b + 6 >> 1]) | 0) / 2 | 0) | 0) / 16384 | 0;
   h = h + m | 0;
   v[c >> 2] = v[c >> 2] + B(b, h >> 12);
   g = g + l | 0;
   v[c + 4 >> 2] = v[c + 4 >> 2] + B(b, g >> 12);
   Ob(e + 8 | 0, i, n);
   c = c + 8 | 0;
   d = d - 1 | 0;
   continue;
  }
  break;
 }
 b = v[e + 12 >> 2];
 v[a >> 2] = v[e + 8 >> 2];
 v[a + 4 >> 2] = b;
 v[a + 40 >> 2] = g;
 v[a + 20 >> 2] = h >> 12;
 v[a + 36 >> 2] = h;
 v[a + 24 >> 2] = g >> 12;
 eb = e + 16 | 0;
}

function X3(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0;
 c = eb - 32 | 0;
 eb = c;
 a: {
  b: {
   c: {
    if (gi(b, 14276)) {
     d = _s(c + 28 | 0, b);
     e = v[d >> 2];
     if (!Dd(e)) {
      v[31601] = 0;
      b = O(36, c + 4 | 0, b | 0) | 0;
      a = v[31601];
      v[31601] = 0;
      if ((a | 0) == 1) {
       break c;
      }
      v[31601] = 0;
      a = c + 16 | 0;
      R(1010, a | 0, 17790, b | 0);
      e = v[31601];
      v[31601] = 0;
      d: {
       e: {
        if ((e | 0) != 1) {
         v[31601] = 0;
         V(1366, a | 0);
         a = v[31601];
         v[31601] = 0;
         if ((a | 0) == 1) {
          break e;
         }
         p();
        }
        a = M() | 0;
        break d;
       }
       a = M() | 0;
       sb(c + 16 | 0);
      }
      sb(b);
      break a;
     }
     Zs(e);
     if (!Ys(a + 8 | 0, 16770, v[d >> 2])) {
      t[a + 8 | 0] = t[a + 8 | 0];
     }
     if (!Ys(a + 9 | 0, 22256, v[d >> 2])) {
      t[a + 9 | 0] = t[a + 9 | 0];
     }
     v[31601] = 0;
     N(272, a + 12 | 0, 22256);
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) == 1) {
      break b;
     }
     el(d);
    }
    eb = c + 32 | 0;
    return;
   }
   a = M() | 0;
   break a;
  }
  a = M() | 0;
 }
 el(d);
 P(a | 0);
 p();
}

function PQ(a, b, c) {
 var d = 0, e = 0, f = 0, g = 0, h = 0;
 a: {
  f = eb - 48 | 0;
  eb = f;
  d = Eb(f + 36 | 0);
  v[31601] = 0;
  N(931, b | 0, f + 24 | 0);
  g = v[31601];
  v[31601] = 0;
  if ((g | 0) != 1) {
   b: {
    g = v[f + 28 >> 2];
    e = v[f + 24 >> 2];
    sf(d);
    v[31601] = 0;
    g = !g & e >>> 0 >= 255 | g ? 255 : e;
    N(46, d | 0, g | 0);
    e = v[31601];
    v[31601] = 0;
    if ((e | 0) == 1) {
     break b;
    }
    c: {
     while (1) {
      if ((g | 0) == (h | 0)) {
       b = U$(Jb(d), Cb(v[d + 4 >> 2], w[d + 11 | 0]));
       if ((b | 0) == -1) {
        break c;
       }
       v[31601] = 0;
       N(46, d | 0, b | 0);
       b = v[31601];
       v[31601] = 0;
       if ((b | 0) != 1) {
        break c;
       }
       break b;
      }
      e = dc(d, h);
      v[31601] = 0;
      O(932, b | 0, e | 0) | 0;
      e = v[31601];
      v[31601] = 0;
      if ((e | 0) != 1) {
       h = h + 1 | 0;
       continue;
      }
      break;
     }
     break b;
    }
    v[31601] = 0;
    b = f + 12 | 0;
    R(496, b | 0, a | 0, d | 0);
    a = v[31601];
    v[31601] = 0;
    if ((a | 0) == 1) {
     break b;
    }
    yb(c, b);
    sb(b);
    sb(d);
    eb = f + 48 | 0;
    break a;
   }
  }
  a = M() | 0;
  sb(d);
  P(a | 0);
  p();
 }
}

function jka(a) {
 a = a | 0;
 var b = 0, c = 0, d = 0, e = 0, f = 0, g = 0;
 b = eb - 880 | 0;
 eb = b;
 c = Qb(a, 0, 76);
 v[c + 84 >> 2] = 0;
 v[c + 88 >> 2] = 0;
 v[c + 80 >> 2] = 256;
 u[c + 76 >> 1] = 65535;
 v[c + 92 >> 2] = 0;
 v[c + 96 >> 2] = 0;
 t[c + 100 | 0] = 1;
 a = 616;
 while (1) {
  RV(a + c | 0);
  a = a + 872 | 0;
  if ((a | 0) != 223848) {
   continue;
  }
  break;
 }
 e = Mb(c + 223848 | 0);
 g = jB(c + 223860 | 0);
 f = b + 8 | 0;
 Qb(f, 0, 108);
 sC(b + 120 | 0, 48e3);
 Qb(b + 664 | 0, 0, 72);
 t[b + 754 | 0] = 0;
 u[b + 752 >> 1] = 65535;
 v[b + 748 >> 2] = 0;
 t[b + 746 | 0] = 0;
 u[b + 744 >> 1] = 65535;
 v[b + 740 >> 2] = 0;
 t[b + 738 | 0] = 0;
 u[b + 736 >> 1] = 65535;
 Qb(b + 756 | 0, 0, 103);
 v[b + 868 >> 2] = 0;
 v[b + 872 >> 2] = 0;
 t[b + 875 | 0] = 0;
 t[b + 876 | 0] = 0;
 t[b + 877 | 0] = 0;
 t[b + 878 | 0] = 0;
 v[b + 860 >> 2] = 0;
 v[b + 864 >> 2] = 0;
 t[b + 859 | 0] = w[b + 859 | 0] & 128;
 a = c + 616 | 0;
 d = ((a + 223232 | 0) - a | 0) / 872 | 0;
 while (1) {
  if ((d | 0) > 0) {
   d = d - 1 | 0;
   a = Gq(a, f) + 872 | 0;
   continue;
  }
  break;
 }
 v[31601] = 0;
 N(552, e | 0, 32);
 a = v[31601];
 v[31601] = 0;
 if ((a | 0) != 1) {
  eb = b + 880 | 0;
  return c | 0;
 }
 a = M() | 0;
 Hq(g);
 ec(e);
 P(a | 0);
 p();
}

function ola(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0;
 f = eb - 16 | 0;
 eb = f;
 c = Hf(a, c);
 $d(f, v[a + 36 >> 2]);
 i = a;
 a: {
  if (!c) {
   Pc(f, a + 32 | 0, 5);
   d = 0;
   if (Fb(v[v[f >> 2] >> 2], v[f + 4 >> 2])) {
    break a;
   }
  }
  g = v[a + 36 >> 2];
  a = eb - 16 | 0;
  eb = a;
  v[a + 12 >> 2] = 0;
  AN(g, a + 12 | 0, 1);
  e = v[a + 12 >> 2];
  d = e >>> 2 & 3;
  t[a + 11 | 0] = d;
  if (d) {
   t[a + 4 | 0] = 3;
   h = a + 4 | 0;
   d = w[Pb(h, a + 11 | 0) | 0];
   t[a + 4 | 0] = 0;
   t[a | 0] = 0;
   t[a + 10 | 0] = 0;
   b: {
    if (!d) {
     break b;
    }
    Di(g, h);
    if ((d | 0) == 1) {
     break b;
    }
    Di(g, a);
    if (d >>> 0 < 3) {
     break b;
    }
    Di(g, a + 10 | 0);
    j = w[a + 10 | 0] << 24;
   }
   e = e & 255 | (w[a + 4 | 0] << 8 | w[a | 0] << 16 | j);
  }
  d = e >>> 4 | 0;
  v[a + 4 >> 2] = d;
  v[a >> 2] = 1e6;
  iC(b, v[Gb(a + 4 | 0, a) >> 2]);
  e = 0;
  while (1) {
   h = Cb(v[b + 4 >> 2], w[b + 11 | 0]);
   if (h >>> 0 <= e >>> 0) {
    if ((d | 0) != (h | 0)) {
     Mm(g, d - h | 0);
    }
    eb = a + 16 | 0;
   } else {
    uj(g, dc(b, e), 1);
    e = e + 1 | 0;
    continue;
   }
   break;
  }
  d = c;
 }
 ef(i, d);
 eb = f + 16 | 0;
}

function Og(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0;
 f = eb + -64 | 0;
 eb = f;
 a: {
  b: {
   if ((b | 0) == 65535 | c - 1025 >>> 0 < 4294966272) {
    break b;
   }
   d = v[a >> 2];
   e = v[a + 4 >> 2];
   if (Ie(d, e, b)) {
    break b;
   }
   c: {
    d: {
     if (fm(d, e) >>> 0 <= b >>> 0) {
      d = sA(f + 12 | 0, a);
      v[31601] = 0;
      R(199, a | 0, b + 1 | 0, d | 0);
      e = v[31601];
      v[31601] = 0;
      if ((e | 0) == 1) {
       break d;
      }
      uk(d);
      d = v[a >> 2];
     }
     v[31601] = 0;
     N(200, Zi(d, b) | 0, c | 0);
     c = v[31601];
     v[31601] = 0;
     e: {
      if ((c | 0) != 1) {
       c = Zi(v[a >> 2], b);
       v[c + 16 >> 2] = 0;
       v[c + 20 >> 2] = 0;
       c = v[a >> 2];
       v[31601] = 0;
       V(201, Zi(c, b) | 0);
       c = v[31601];
       v[31601] = 0;
       if ((c | 0) != 1) {
        break e;
       }
      }
      b = S(124508) | 0;
      a = fb;
      break c;
     }
     a = Zi(v[a >> 2], b);
     g = Hb(v[a >> 2], v[a + 4 >> 2]);
     break b;
    }
    b = S(124508) | 0;
    a = fb;
    uk(d);
   }
   if ((_(124508) | 0) != (a | 0)) {
    break a;
   }
   X(b | 0) | 0;
   Y();
  }
  eb = f - -64 | 0;
  return g | 0;
 }
 P(b | 0);
 p();
}

function Nca(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0;
 e = eb - 48 | 0;
 eb = e;
 v[e + 44 >> 2] = c;
 a = re(a, e + 44 | 0);
 f = sc(a + 4 | 0);
 g = sc(a + 24 | 0);
 h = sc(a + 32 | 0);
 i = Mb(a + 36 | 0);
 v[a + 56 >> 2] = 3;
 j = Mb(a + 68 | 0);
 v[31601] = 0;
 N(990, a | 0, d | 0);
 c = v[31601];
 v[31601] = 0;
 a: {
  b: {
   c: {
    d: {
     if ((c | 0) != 1) {
      c = Ld(e + 16 | 0);
      v[31601] = 0;
      k = v[c + 4 >> 2];
      v[e + 8 >> 2] = v[c >> 2];
      v[e + 12 >> 2] = k;
      c = e + 24 | 0;
      R(1114, c | 0, b | 0, e + 8 | 0);
      b = v[31601];
      v[31601] = 0;
      if ((b | 0) == 1) {
       break d;
      }
      v[31601] = 0;
      R(991, a | 0, c | 0, d | 0);
      b = v[31601];
      v[31601] = 0;
      if ((b | 0) == 1) {
       break c;
      }
      tb(c);
      v[31601] = 0;
      V(992, a | 0);
      b = v[31601];
      v[31601] = 0;
      if ((b | 0) != 1) {
       break a;
      }
     }
     d = M() | 0;
     break b;
    }
    d = M() | 0;
    break b;
   }
   d = M() | 0;
   tb(e + 24 | 0);
  }
  Sd(j);
  nf(i);
  yl(h);
  vh(g);
  uh(f);
  Wc(a);
  Wc(e + 44 | 0);
  P(d | 0);
  p();
 }
 Wc(e + 44 | 0);
 eb = e + 48 | 0;
 return a | 0;
}

function NH(a, b, c, d, e) {
 var f = 0, g = 0, h = 0, i = 0, j = 0, k = 0;
 f = eb - 48 | 0;
 eb = f;
 v[f + 44 >> 2] = c;
 a = re(a, f + 44 | 0);
 c = sc(a + 4 | 0);
 h = sc(a + 24 | 0);
 i = sc(a + 32 | 0);
 j = Mb(a + 36 | 0);
 v[a + 56 >> 2] = 3;
 k = Mb(a + 68 | 0);
 v[31601] = 0;
 N(990, a | 0, d | 0);
 g = v[31601];
 v[31601] = 0;
 a: {
  b: {
   c: {
    d: {
     if ((g | 0) != 1) {
      oe(f + 16 | 0, v[b >> 2], v[b + 4 >> 2]);
      b = Ld(f + 8 | 0);
      v[31601] = 0;
      g = v[b + 4 >> 2];
      v[f >> 2] = v[b >> 2];
      v[f + 4 >> 2] = g;
      b = f + 24 | 0;
      Ms(e, b, v[f + 16 >> 2], v[f + 20 >> 2], f);
      e = v[31601];
      v[31601] = 0;
      if ((e | 0) == 1) {
       break d;
      }
      v[31601] = 0;
      R(991, a | 0, b | 0, d | 0);
      d = v[31601];
      v[31601] = 0;
      if ((d | 0) == 1) {
       break c;
      }
      tb(b);
      v[31601] = 0;
      V(992, a | 0);
      b = v[31601];
      v[31601] = 0;
      if ((b | 0) != 1) {
       break a;
      }
     }
     d = M() | 0;
     break b;
    }
    d = M() | 0;
    break b;
   }
   d = M() | 0;
   tb(f + 24 | 0);
  }
  Sd(k);
  nf(j);
  yl(i);
  vh(h);
  uh(c);
  Wc(a);
  Wc(f + 44 | 0);
  P(d | 0);
  p();
 }
 Wc(f + 44 | 0);
 eb = f + 48 | 0;
 return a;
}

function zl(a, b, c) {
 var d = 0, e = 0, f = 0, g = 0;
 e = eb - 48 | 0;
 eb = e;
 d = v[a + 24 >> 2];
 g = v[d + 24620 >> 2];
 a: {
  if (!((g | 0) != (b | 0) | v[d + 24624 >> 2] != (c | 0))) {
   if (w[a + 29 | 0]) {
    break a;
   }
   LR(d, 1);
   break a;
  }
  f = e + 8 | 0;
  yc(f, d + 24604 | 0, 40);
  v[e + 28 >> 2] = c;
  v[e + 24 >> 2] = b;
  c = v[e + 44 >> 2];
  du(f, v[e + 40 >> 2]);
  No(f, c);
  OA(d, f);
  if ((b | 0) == (g | 0)) {
   break a;
  }
  c = v[a + 24 >> 2] + 906300 | 0;
  d = tk(c);
  while (1) {
   if ((c | 0) != (d | 0)) {
    b = v[c >> 2];
    b: {
     if (!b) {
      break b;
     }
     if (!(hb[v[v[b >> 2] + 120 >> 2]](b) | 0)) {
      break b;
     }
     hb[v[v[b >> 2] + 112 >> 2]](b, 0);
     hb[v[v[b >> 2] + 100 >> 2]](b);
     hb[v[v[b >> 2] + 128 >> 2]](b);
    }
    c = c + 160 | 0;
    continue;
   }
   break;
  }
  c = v[a + 24 >> 2] + 906300 | 0;
  d = tk(c);
  while (1) {
   if ((c | 0) != (d | 0)) {
    b = v[c >> 2];
    c: {
     if (!b) {
      break c;
     }
     if (hb[v[v[b >> 2] + 120 >> 2]](b) | 0) {
      break c;
     }
     hb[v[v[b >> 2] + 112 >> 2]](b, 1);
     hb[v[v[b >> 2] + 124 >> 2]](b);
    }
    c = c + 160 | 0;
    continue;
   }
   break;
  }
 }
 t[a + 29 | 0] = 1;
 eb = e + 48 | 0;
}

function Rpa(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0;
 b = eb - 528 | 0;
 eb = b;
 e = -1;
 a: {
  if (!ih(a, 1468)) {
   break a;
  }
  Ul(a, 1464);
  c = b + 524 | 0;
  $X(a, c);
  if (!ne(c, 25252)) {
   e = 0;
   if (!ne(c, 15576)) {
    break a;
   }
  }
  Ul(a, 20);
  c = 1;
  b: {
   while (1) {
    if ((c & 65535) >>> 0 > 31) {
     break b;
    }
    e = YX(a, b);
    if (!e) {
     IX(b);
    }
    if (e) {
     c = c + 1 | 0;
     d = $C(b) + d | 0;
     continue;
    }
    break;
   }
   e = -1;
   break a;
  }
  e = 0;
  if (d >>> 0 > 40) {
   break a;
  }
  d = b + 522 | 0;
  c = eb - 16 | 0;
  eb = c;
  c: {
   if (!ih(a, 2)) {
    t[c | 0] = 0;
    sF(d, c);
    break c;
   }
   Cp(c + 8 | 0, d);
   _C(c, a, v[c + 8 >> 2], v[c + 12 >> 2]);
  }
  eb = c + 16 | 0;
  if (w[b + 522 | 0] > 128) {
   break a;
  }
  d = Ic(d);
  c = eb - 16 | 0;
  eb = c;
  d: {
   if (!ih(a, 512)) {
    HX(b);
    break d;
   }
   yE(c + 8 | 0, b);
   _C(c, a, v[c + 8 >> 2], v[c + 12 >> 2]);
  }
  eb = c + 16 | 0;
  c = 0;
  e = 1;
  a = w[d | 0];
  while (1) {
   if ((c | 0) == 512) {
    break a;
   }
   d = b + c | 0;
   c = c + 1 | 0;
   if (a >>> 0 >= w[d | 0]) {
    continue;
   }
   break;
  }
  e = 0;
 }
 eb = b + 528 | 0;
 return e | 0;
}

function XH(a, b, c, d) {
 var e = 0, f = 0, g = 0;
 f = eb - 32 | 0;
 eb = f;
 v[31601] = 0;
 V(995, a | 0);
 e = v[31601];
 v[31601] = 0;
 a: {
  b: {
   c: {
    d: {
     e: {
      f: {
       if ((e | 0) == 1) {
        break f;
       }
       v[31601] = 0;
       V(996, b | 0);
       e = v[31601];
       v[31601] = 0;
       if ((e | 0) == 1) {
        break f;
       }
       g = v[a + 24 >> 2];
       v[31601] = 0;
       e = O(36, f + 8 | 0, b | 0) | 0;
       b = v[31601];
       v[31601] = 0;
       if ((b | 0) == 1) {
        break e;
       }
       v[31601] = 0;
       b = d;
       d = f + 20 | 0;
       R(b | 0, d | 0, g | 0, e | 0);
       b = v[31601];
       v[31601] = 0;
       if ((b | 0) == 1) {
        break d;
       }
       b = Bg(Jb(d));
       sb(d);
       sb(e);
       break b;
      }
      b = S(0) | 0;
      break c;
     }
     b = S(0) | 0;
     break c;
    }
    b = S(0) | 0;
    sb(e);
   }
   X(b | 0) | 0;
   b = 0;
   v[31601] = 0;
   U(982, c | 0, a | 0, 0, 0);
   a = v[31601];
   v[31601] = 0;
   if ((a | 0) == 1) {
    break a;
   }
   Y();
  }
  eb = f + 32 | 0;
  return b;
 }
 a = M() | 0;
 v[31601] = 0;
 W(26);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  P(a | 0);
  p();
 }
 S(0) | 0;
 Rb();
 p();
}

function KP(a) {
 var b = 0, c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = C(0), k = 0, l = C(0), m = 0, n = 0, o = 0, p = C(0);
 d = a + 4208 | 0;
 j = C(C(z[xb(d, 2) >> 2] * C(2999.9990234375)) + C(.0010000000474974513));
 l = C(z[xb(d, 3) >> 2] * C(.9980000257492065));
 f = -3e3 / (+y[v[a + 16 >> 2] + 24620 >> 2] * +j);
 h = a + 4272 | 0;
 c = lk(10, f * +y[xb(h, 4) >> 2]);
 d = a + 4232 | 0;
 o = xb(d, 0), p = C(c), z[o >> 2] = p;
 c = lk(10, f * +y[xb(h, 5) >> 2]);
 o = xb(d, 1), p = C(c), z[o >> 2] = p;
 m = f * (1 / +C(l + C(.0010000000474974513)) + -1);
 c = 0;
 while (1) {
  if ((e | 0) == 4) {
   e = a + 4208 | 0;
   f = lk(10, +IP(z[xb(e, 0) >> 2]) * .05);
   b = 4 / K(c) * f;
   c = lk(10, +IP(z[xb(e, 1) >> 2]) * .1);
   z[a + 4228 >> 2] = b * K(c);
   z[a + 4224 >> 2] = f * K(1 - c);
  } else {
   g = xb(h, e);
   k = e >>> 1 | 0;
   n = v[xb(h, k | 4) >> 2];
   g = v[g >> 2];
   i = lk(10, m * +(n + g >>> 0));
   b = lk(10, f * +(g >>> 0));
   j = z[xb(d, k) >> 2];
   g = e << 1;
   i = (1 - i) * .5;
   o = xb(d, g + 2 | 0), p = C(b * (1 - i)), z[o >> 2] = p;
   o = xb(d, g + 3 | 0), p = C(b * i), z[o >> 2] = p;
   b = b * +j;
   b = b * (b * (b * (b + 1) + 1) + 1) + 1;
   c = b * b + c;
   e = e + 1 | 0;
   continue;
  }
  break;
 }
}

function BD(a, b) {
 var c = 0, d = 0;
 a: {
  b: {
   c: {
    d: {
     e: {
      f: {
       g: {
        h: {
         d = w[a + 3 | 0];
         switch (d | 0) {
         case 9:
          break d;

         case 10:
          break e;

         case 16:
         case 17:
          break g;

         case 0:
         case 1:
         case 2:
         case 3:
         case 11:
         case 12:
         case 13:
         case 14:
         case 15:
          break h;

         default:
          break a;
         }
        }
        if (!w[a | 0]) {
         break a;
        }
        switch (d | 0) {
        case 9:
         break d;

        case 10:
         break e;

        case 0:
        case 1:
        case 2:
        case 3:
        case 11:
        case 12:
        case 13:
        case 14:
        case 15:
         break f;

        case 16:
        case 17:
         break g;

        default:
         break c;
        }
       }
       c = 8;
       break c;
      }
      c = w[a | 0];
      if (!(c & 7)) {
       break c;
      }
     }
     c = b + 1 >>> 1 | 0;
     b = ((d | 0) == 10) << 4;
     break b;
    }
    c = 16;
   }
   c = B(c >>> 3 | 0, b);
   b = ((d | 0) == 10) << 4;
  }
  c = b + B(jr(w[a + 1 | 0]), c) | 0;
 }
 return c;
}

function Sm(a, b) {
 var c = 0, d = 0, e = 0, f = 0;
 c = eb + -64 | 0;
 eb = c;
 d = v[v[a >> 2] - 12 >> 2] + a | 0;
 e = v[d + 16 >> 2] & -3;
 hg(d, e);
 a: {
  b: {
   if (Hd(w[Em(c + 63 | 0, a, 1) | 0])) {
    d = v[(v[v[a >> 2] - 12 >> 2] + a | 0) + 24 >> 2];
    v[31601] = 0;
    f = v[b + 12 >> 2];
    v[c + 16 >> 2] = v[b + 8 >> 2];
    v[c + 20 >> 2] = f;
    f = v[b + 4 >> 2];
    v[c + 8 >> 2] = v[b >> 2];
    v[c + 12 >> 2] = f;
    R(936, c + 40 | 0, d | 0, c + 8 | 0);
    b = v[31601];
    v[31601] = 0;
    c: {
     if ((b | 0) != 1) {
      b = $h(c + 24 | 0, -1, -1);
      b = ao(v[c + 48 >> 2], v[c + 52 >> 2], v[b + 8 >> 2], v[b + 12 >> 2]) ? e | 4 : e;
      break c;
     }
     X(S(0) | 0) | 0;
     b = e | 1;
     Cm(v[v[a >> 2] - 12 >> 2] + a | 0, b);
     if (v[(v[v[a >> 2] - 12 >> 2] + a | 0) + 20 >> 2] & 1) {
      v[31601] = 0;
      W(84);
      a = v[31601];
      v[31601] = 0;
      if ((a | 0) != 1) {
       break a;
      }
      a = M() | 0;
      v[31601] = 0;
      W(26);
      b = v[31601];
      v[31601] = 0;
      if ((b | 0) == 1) {
       break b;
      }
      P(a | 0);
      p();
     }
     Y();
    }
    Wj(v[v[a >> 2] - 12 >> 2] + a | 0, b);
   }
   eb = c - -64 | 0;
   return;
  }
  S(0) | 0;
  Rb();
 }
 p();
}

function rR(a, b, c, d, e, f, g, h) {
 var i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
 j = eb - 16 | 0;
 eb = j;
 t[j + 15 | 0] = c;
 t[j + 14 | 0] = 12;
 eh(b, w[Pb(j + 15 | 0, j + 14 | 0) | 0]);
 n = (h ? 144 : 96) + a | 0;
 c = 0;
 a = v[b >> 2];
 l = v[b + 4 >> 2];
 o = Rd(a, l);
 while (1) {
  if ((c | 0) == (o | 0)) {
   c = 0;
   t[b + 12 | 0] = 0;
   a: {
    if (!(d & 1)) {
     break a;
    }
    if (lc(a, l)) {
     break a;
    }
    c = 1;
    t[b + 12 | 0] = 1;
   }
   if (e >>> 0 <= 11) {
    if (d & 2) {
     c = c | 4;
     t[b + 12 | 0] = c;
    }
    t[b + 15 | 0] = e;
    t[b + 16 | 0] = e;
   }
   if (!(g >>> 0 > 11 | f >>> 0 > g >>> 0)) {
    if (d & 4) {
     t[b + 12 | 0] = c | 2;
    }
    t[b + 14 | 0] = g;
    t[b + 13 | 0] = f;
   }
   eb = j + 16 | 0;
  } else {
   h = xb(a, c);
   k = (c << 2) + n | 0;
   i = w[k | 0] | w[k + 1 | 0] << 8;
   u[h >> 1] = i;
   t[h + 2 | 0] = w[k + 2 | 0];
   b: {
    if (!c) {
     break b;
    }
    k = xb(a, c - 1 | 0);
    m = x[k >> 1];
    if (i >>> 0 > 255 | i >>> 0 >= m >>> 0) {
     break b;
    }
    i = i | m & 65280;
    u[h >> 1] = i;
    if (x[k >> 1] <= (i & 65535) >>> 0) {
     break b;
    }
    u[h >> 1] = i + 256;
   }
   c = c + 1 | 0;
   continue;
  }
  break;
 }
}

function Zla(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
 e = eb - 16 | 0;
 eb = e;
 g = v[a + 40 >> 2];
 h = v[a + 36 >> 2];
 j = v[a + 16 >> 2];
 i = v[a + 4 >> 2];
 v[e + 8 >> 2] = v[a >> 2];
 v[e + 12 >> 2] = i;
 k = b + 24 | 0;
 l = v[a + 32 >> 2];
 m = v[a + 28 >> 2];
 i = v[a + 8 >> 2];
 n = v[a + 12 >> 2];
 while (1) {
  if (d) {
   b = v[e + 8 >> 2];
   f = v[e + 12 >> 2] + j | 0;
   b = (((b >>> 16 | 0) + 4 & 131064) << 1) + k | 0;
   b = ((((B(t[f + 2 | 0], u[b + 10 >> 1]) + B(t[f + 1 | 0], u[b + 8 >> 1]) | 0) + B(t[f + 3 | 0], u[b + 12 >> 1]) | 0) + B(t[f + 4 | 0], u[b + 14 >> 1]) << 8 >> 1) + (((B(t[f - 2 | 0], u[b + 2 >> 1]) + B(t[f - 3 | 0], u[b >> 1]) | 0) + B(t[f - 1 | 0], u[b + 4 >> 1]) | 0) + B(t[f | 0], u[b + 6 >> 1]) << 8 >> 1) | 0) / 16384 | 0;
   h = h + m | 0;
   v[c >> 2] = v[c >> 2] + B(b, h >> 12);
   g = g + l | 0;
   v[c + 4 >> 2] = v[c + 4 >> 2] + B(b, g >> 12);
   Ob(e + 8 | 0, i, n);
   c = c + 8 | 0;
   d = d - 1 | 0;
   continue;
  }
  break;
 }
 b = v[e + 12 >> 2];
 v[a >> 2] = v[e + 8 >> 2];
 v[a + 4 >> 2] = b;
 v[a + 40 >> 2] = g;
 v[a + 20 >> 2] = h >> 12;
 v[a + 36 >> 2] = h;
 v[a + 24 >> 2] = g >> 12;
 eb = e + 16 | 0;
}

function sr(a, b) {
 var c = 0;
 c = eb - 16 | 0;
 eb = c;
 a = ds(a);
 a: {
  b: {
   c: {
    switch (b - 1 | 0) {
    default:
     if ((b | 0) != 16777216) {
      break b;
     }
     Kb(Kb(Kb(Kb(Kb(Kb(Kb(Kb(Kb(Kb(Kb(Kb(Kb(Kb(Kb(Kb(Kb(Kb(Kb(Kb(Kb(Kb(Kb(Kb(Kb(Kb(Kb(Kb(Kb(Kb(Kb(a, 7, 1), 9, 1), 10, 1), 13, 1), 15, 1), 16, 1), 17, 1), 18, 1), 20, 1), 21, 1), 24, 1), 25, 1), 26, 1), 28, 1), 30, 1), 31, 1), 33, 1), 34, 1), 39, 1), 41, 1), 44, 1), 46, 1), 45, 1), 47, 1), 48, 1), 50, 1), 99, 1), 102, 1), 104, 1), 105, 1), 115, 1);
     break a;

    case 1:
     SA(c, 2);
     b = v[c + 12 >> 2];
     v[a + 8 >> 2] = v[c + 8 >> 2];
     v[a + 12 >> 2] = b;
     b = v[c + 4 >> 2];
     v[a >> 2] = v[c >> 2];
     v[a + 4 >> 2] = b;
     ag(a, 107);
     break a;

    case 3:
     SA(c, 4);
     b = v[c + 12 >> 2];
     v[a + 8 >> 2] = v[c + 8 >> 2];
     v[a + 12 >> 2] = b;
     b = v[c + 4 >> 2];
     v[a >> 2] = v[c >> 2];
     v[a + 4 >> 2] = b;
     ag(a, 4);
     break a;

    case 2:
     break b;

    case 0:
     break c;
    }
   }
   Kb(a, 88, 1);
   break a;
  }
  SA(c, b);
  b = v[c + 12 >> 2];
  v[a + 8 >> 2] = v[c + 8 >> 2];
  v[a + 12 >> 2] = b;
  b = v[c + 4 >> 2];
  v[a >> 2] = v[c >> 2];
  v[a + 4 >> 2] = b;
 }
 eb = c + 16 | 0;
}

function hoa(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0;
 e = eb - 16 | 0;
 eb = e;
 v[a >> 2] = 0;
 v[a + 4 >> 2] = 0;
 sc(a + 8 | 0);
 Qd(e + 8 | 0, v[ub(e + 4 | 0, a) >> 2]);
 a: {
  if (b) {
   v[31601] = 0;
   N(738, a | 0, b | 0);
   c = v[31601];
   v[31601] = 0;
   if ((c | 0) == 1) {
    break a;
   }
   f = eb - 16 | 0;
   eb = f;
   d = f + 4 | 0;
   v[d >> 2] = a;
   c = v[a + 4 >> 2];
   v[d + 4 >> 2] = c;
   v[d + 8 >> 2] = c + B(b, 36);
   b = v[d + 4 >> 2];
   g = v[d + 8 >> 2];
   while (1) {
    if ((b | 0) == (g | 0)) {
     hc(d);
     eb = f + 16 | 0;
    } else {
     c = Qb(b, 0, 36);
     v[c >> 2] = 0;
     v[c + 4 >> 2] = 0;
     u[c + 22 >> 1] = 0;
     u[c + 24 >> 1] = 0;
     u[c + 26 >> 1] = 0;
     u[c + 28 >> 1] = 0;
     t[c + 21 | 0] = 64;
     t[c + 19 | 0] = 64;
     t[c + 20 | 0] = 100;
     t[c + 15 | 0] = 0;
     t[c + 16 | 0] = 0;
     t[c + 17 | 0] = 0;
     t[c + 18 | 0] = 0;
     v[c + 8 >> 2] = 0;
     v[c + 12 >> 2] = 0;
     u[c + 30 >> 1] = 0;
     u[c + 32 >> 1] = 0;
     b = b + 36 | 0;
     v[d + 4 >> 2] = b;
     continue;
    }
    break;
   }
  }
  b = e + 8 | 0;
  Pd(b);
  YV(b);
  eb = e + 16 | 0;
  return a | 0;
 }
 a = M() | 0;
 YV(e + 8 | 0);
 P(a | 0);
 p();
}

function YH(a, b, c, d, e, f) {
 var g = 0, h = 0, i = 0, j = 0, k = 0, l = 0;
 g = eb - 48 | 0;
 eb = g;
 v[g + 44 >> 2] = d;
 a = re(a, g + 44 | 0);
 d = sc(a + 4 | 0);
 h = sc(a + 24 | 0);
 i = sc(a + 32 | 0);
 j = Mb(a + 36 | 0);
 v[a + 56 >> 2] = 3;
 k = Mb(a + 68 | 0);
 v[31601] = 0;
 N(990, a | 0, e | 0);
 l = v[31601];
 v[31601] = 0;
 a: {
  b: {
   c: {
    d: {
     if ((l | 0) != 1) {
      ac(g + 16 | 0, b, c);
      b = Ld(g + 8 | 0);
      v[31601] = 0;
      c = v[b + 4 >> 2];
      v[g >> 2] = v[b >> 2];
      v[g + 4 >> 2] = c;
      b = g + 24 | 0;
      Ms(f, b, v[g + 16 >> 2], v[g + 20 >> 2], g);
      c = v[31601];
      v[31601] = 0;
      if ((c | 0) == 1) {
       break d;
      }
      v[31601] = 0;
      R(991, a | 0, b | 0, e | 0);
      c = v[31601];
      v[31601] = 0;
      if ((c | 0) == 1) {
       break c;
      }
      tb(b);
      v[31601] = 0;
      V(992, a | 0);
      b = v[31601];
      v[31601] = 0;
      if ((b | 0) != 1) {
       break a;
      }
     }
     e = M() | 0;
     break b;
    }
    e = M() | 0;
    break b;
   }
   e = M() | 0;
   tb(g + 24 | 0);
  }
  Sd(k);
  nf(j);
  yl(i);
  vh(h);
  uh(d);
  Wc(a);
  Wc(g + 44 | 0);
  P(e | 0);
  p();
 }
 Wc(g + 44 | 0);
 eb = g + 48 | 0;
 return a;
}

function Xaa(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0;
 g = eb - 16 | 0;
 eb = g;
 h = g + 4 | 0;
 e = eb - 32 | 0;
 eb = e;
 d = rf(e + 20 | 0, 1, 0);
 a: {
  b: {
   c: {
    while (1) {
     c = Jb(d);
     j = Cb(v[d + 4 >> 2], w[d + 11 | 0]) + c | 0;
     i = v[b >> 2];
     k = e + 12 | 0;
     f = v[b + 4 >> 2];
     if (!((c | 0) == (j | 0) | ((f | 0) >= 0 | (f | 0) > 0))) {
      t[c | 0] = 45;
      i = TN(i, f);
      f = gb;
      c = c + 1 | 0;
     }
     LN(k, c, j, i, f);
     if (!v[e + 16 >> 2]) {
      break c;
     }
     c = ji(Cb(v[d + 4 >> 2], w[d + 11 | 0]));
     v[31601] = 0;
     N(45, d | 0, c | 0);
     c = v[31601];
     v[31601] = 0;
     if ((c | 0) != 1) {
      continue;
     }
     break;
    }
    break b;
   }
   b = v[e + 12 >> 2];
   c = Jb(d);
   v[31601] = 0;
   N(46, d | 0, b - c | 0);
   b = v[31601];
   v[31601] = 0;
   d: {
    if ((b | 0) != 1) {
     v[31601] = 0;
     N(303, h | 0, d | 0);
     b = v[31601];
     v[31601] = 0;
     if ((b | 0) != 1) {
      break d;
     }
     break b;
    }
    break b;
   }
   sb(d);
   eb = e + 32 | 0;
   break a;
  }
  a = M() | 0;
  sb(d);
  P(a | 0);
  p();
 }
 Ph(a, h);
 sb(h);
 eb = g + 16 | 0;
}

function oG(a) {
 a = a | 0;
 var b = 0, c = 0, d = 0, e = 0;
 b = oF(v[(v[v[a >> 2] - 12 >> 2] + a | 0) + 28 >> 2], 10);
 d = eb - 16 | 0;
 eb = d;
 v[31601] = 0;
 c = O(21, d + 8 | 0, a | 0) | 0;
 e = v[31601];
 v[31601] = 0;
 a: {
  b: {
   c: {
    d: {
     if ((e | 0) != 1) {
      e: {
       if (!Hd(w[c | 0])) {
        break e;
       }
       e = qp(d + 4 | 0, a);
       v[31601] = 0;
       b = O(30, e | 0, b | 0) | 0;
       e = v[31601];
       v[31601] = 0;
       if ((e | 0) != 1) {
        if (v[b >> 2]) {
         break e;
        }
        b = v[v[a >> 2] - 12 >> 2];
        v[31601] = 0;
        N(24, a + b | 0, 1);
        b = v[31601];
        v[31601] = 0;
        if ((b | 0) != 1) {
         break e;
        }
       }
       b = S(0) | 0;
       dm(c);
       break d;
      }
      dm(c);
      break c;
     }
     b = S(0) | 0;
    }
    X(b | 0) | 0;
    c = v[v[a >> 2] - 12 >> 2];
    v[31601] = 0;
    V(25, a + c | 0);
    c = v[31601];
    v[31601] = 0;
    if ((c | 0) == 1) {
     break b;
    }
    Y();
   }
   eb = d + 16 | 0;
   break a;
  }
  a = M() | 0;
  v[31601] = 0;
  W(26);
  d = v[31601];
  v[31601] = 0;
  if ((d | 0) != 1) {
   P(a | 0);
   p();
  }
  S(0) | 0;
  Rb();
  p();
 }
 return sp(a) | 0;
}

function K9(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0;
 d = eb - 32 | 0;
 eb = d;
 h = Eb(a);
 f = Eb(d + 20 | 0);
 a = 1;
 a: {
  b: {
   c: {
    while (1) {
     e = a & 65535;
     c = v[b + 24 >> 2];
     if (e >>> 0 > x[c + 480192 >> 1]) {
      if (!(i & 1)) {
       break c;
      }
      v[31601] = 0;
      N(247, h | 0, f | 0);
      a = v[31601];
      v[31601] = 0;
      if ((a | 0) != 1) {
       break c;
      }
      a = M() | 0;
      break a;
     }
     c = RR(c, e);
     v[31601] = 0;
     c = O(36, d + 8 | 0, c | 0) | 0;
     e = v[31601];
     v[31601] = 0;
     if ((e | 0) == 1) {
      break b;
     }
     e = zd(v[d + 12 >> 2], w[d + 19 | 0]);
     v[31601] = 0;
     g = O(837, f | 0, c | 0) | 0;
     j = v[31601];
     v[31601] = 0;
     d: {
      if ((j | 0) == 1) {
       break d;
      }
      v[31601] = 0;
      O(984, g | 0, 22231) | 0;
      g = v[31601];
      v[31601] = 0;
      if ((g | 0) == 1) {
       break d;
      }
      i = e ^ 1 | i;
      sb(c);
      a = a + 1 | 0;
      continue;
     }
     break;
    }
    a = M() | 0;
    sb(c);
    break a;
   }
   sb(f);
   eb = d + 32 | 0;
   return;
  }
  a = M() | 0;
 }
 sb(f);
 sb(h);
 P(a | 0);
 p();
}

function OX(a, b) {
 var c = 0, d = 0, e = 0;
 c = eb - 32 | 0;
 eb = c;
 a: {
  if (!Lb(v[a >> 2], v[a + 8 >> 2], 1024)) {
   v[c + 24 >> 2] = 0;
   v[c + 28 >> 2] = 0;
   v[c + 16 >> 2] = 0;
   v[c + 20 >> 2] = 0;
   a = 64;
   while (1) {
    if (a) {
     d = w[c + 20 | 0] | w[c + 21 | 0] << 8 | (w[c + 22 | 0] << 16 | w[c + 23 | 0] << 24);
     e = w[c + 16 | 0] | w[c + 17 | 0] << 8 | (w[c + 18 | 0] << 16 | w[c + 19 | 0] << 24);
     t[b | 0] = e;
     t[b + 1 | 0] = e >>> 8;
     t[b + 2 | 0] = e >>> 16;
     t[b + 3 | 0] = e >>> 24;
     t[b + 4 | 0] = d;
     t[b + 5 | 0] = d >>> 8;
     t[b + 6 | 0] = d >>> 16;
     t[b + 7 | 0] = d >>> 24;
     d = w[c + 28 | 0] | w[c + 29 | 0] << 8 | (w[c + 30 | 0] << 16 | w[c + 31 | 0] << 24);
     e = w[c + 24 | 0] | w[c + 25 | 0] << 8 | (w[c + 26 | 0] << 16 | w[c + 27 | 0] << 24);
     t[b + 8 | 0] = e;
     t[b + 9 | 0] = e >>> 8;
     t[b + 10 | 0] = e >>> 16;
     t[b + 11 | 0] = e >>> 24;
     t[b + 12 | 0] = d;
     t[b + 13 | 0] = d >>> 8;
     t[b + 14 | 0] = d >>> 16;
     t[b + 15 | 0] = d >>> 24;
     a = a - 1 | 0;
     b = b + 16 | 0;
     continue;
    }
    break;
   }
   break a;
  }
  TC(c + 8 | 0, b);
  rd(c + 16 | 0, a, v[c + 8 >> 2], v[c + 12 >> 2]);
 }
 eb = c + 32 | 0;
}

function wB(a, b, c, d) {
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0;
 a: {
  f = a + 1074312 | 0;
  if (h = Nb(f, 77), i = 0, j = v[(B(c, 872) + b | 0) + 704 >> 2] & 134218752, j ? h : i) {
   break a;
  }
  g = b + 616 | 0;
  c = g + B(v[a + 480180 >> 2] != 2 ? c : 0, 872) | 0;
  if (!d) {
   v[c + 764 >> 2] = v[b + 48 >> 2];
   return;
  }
  e = w[c + 841 | 0];
  b: {
   if (e) {
    d = e - 1 | 0;
    t[c + 841 | 0] = d;
    if (d & 255) {
     break b;
    }
    if (!Nb(f, 16) & v[a + 480180 >> 2] != 2) {
     break a;
    }
    v[c + 764 >> 2] = v[b + 48 >> 2] + 1;
    return;
   }
   c: {
    if (Nb(f, 17) | w[a + 480180 | 0] & 3) {
     break c;
    }
    e = 0;
    a = x[a + 480188 >> 1];
    while (1) {
     if (a >>> 0 <= (e & 65535) >>> 0) {
      break c;
     }
     if (w[g + 841 | 0] ? (c | 0) != (g | 0) : 0) {
      break a;
     }
     g = g + 872 | 0;
     e = e + 1 | 0;
     continue;
    }
   }
   t[c + 841 | 0] = d;
  }
  a = v[c + 764 >> 2];
  v[b + 56 >> 2] = a;
  if ((a | 0) == -1) {
   break a;
  }
  d: {
   if (v[b + 60 >> 2] == -1) {
    break d;
   }
   if (!Nb(f, 68)) {
    break d;
   }
   v[b + 60 >> 2] = a;
  }
  v[b + 64 >> 2] = a;
  if (!Nb(f, 103)) {
   break a;
  }
  u[b + 68 >> 1] = 65535;
 }
}

function pT(a, b, c, d, e) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 var f = 0, g = 0, h = 0;
 f = eb - 112 | 0;
 eb = f;
 v[f + 108 >> 2] = 0;
 e = Fo(a, e & 65535, d, c, f + 108 | 0);
 c = w[b + 790 | 0];
 if (!v[f + 108 >> 2]) {
  d = (c | 0) == 15;
  h = d & !w[b + 792 | 0];
  e = e << 8;
  a: {
   if (e) {
    v[b + 664 >> 2] = e;
    break a;
   }
   e = 0;
   if (d) {
    break a;
   }
   e = v[b + 664 >> 2];
  }
  h = h ? 0 : w[b + 836 | 0] << 16;
 }
 if ((c | 0) == 15) {
  c = w[b + 792 | 0];
  b: {
   if (!c) {
    c = v[b + 76 >> 2];
    v[f + 4 >> 2] = 1;
    g = v[ad(f + 4 | 0, f + 108 | 0) >> 2] << 3;
    e = Aua(c, 0, e, 0);
    d = (256 << g >>> 1 | 0) + e | 0;
    c = gb;
    c = d >>> 0 < e >>> 0 ? c + 1 | 0 : c;
    e = g + 8 | 0;
    g = d;
    d = e & 31;
    if ((e & 63) >>> 0 >= 32) {
     e = 0;
     c = c >>> d | 0;
    } else {
     e = c >>> d | 0;
     c = ((1 << d) - 1 & c) << 32 - d | g >>> d;
    }
    e = Ac(c, e);
    break b;
   }
   _v(f + 4 | 0);
   if (c >>> 0 > 9) {
    break b;
   }
   c = v[b + 104 >> 2];
   if (!c) {
    break b;
   }
   e = v[xb(c + 68 | 0, w[b + 792 | 0] - 1 | 0) >> 2] + e | 0;
  }
  v[b + 664 >> 2] = e;
 }
 Jo(a, b, e + h | 0);
 eb = f + 112 | 0;
}

function Bx(a, b) {
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0;
 h = eb - 16 | 0;
 eb = h;
 e = zb(a);
 c = ub(h + 12 | 0, v[a + 4 >> 2]);
 f = ub(h + 8 | 0, v[a >> 2]);
 g = ub(h + 4 | 0, v[b + 4 >> 2]);
 d = v[c >> 2];
 f = v[f >> 2];
 c = eb + -64 | 0;
 eb = c;
 g = v[g >> 2];
 v[c + 56 >> 2] = g;
 v[c + 60 >> 2] = d;
 v[c + 52 >> 2] = g;
 e = zg(c + 24 | 0, e, c + 52 | 0, c + 56 | 0);
 v[c + 16 >> 2] = v[e + 8 >> 2];
 g = v[e + 4 >> 2];
 v[c + 8 >> 2] = v[e >> 2];
 v[c + 12 >> 2] = g;
 yg(c + 36 | 0, c + 8 | 0);
 while (1) {
  if (Ed(d, f)) {
   xs(Pp(v[c + 56 >> 2]), $k(d));
   d = ik(c + 60 | 0);
   ik(c + 56 | 0);
   d = v[d >> 2];
   continue;
  }
  break;
 }
 xg(c + 36 | 0);
 g = v[c + 56 >> 2];
 if (!w[c + 48 | 0]) {
  e = eb - 16 | 0;
  eb = e;
  d = ub(e + 12 | 0, v[v[c + 44 >> 2] >> 2]);
  i = v[ub(e + 8 | 0, v[v[c + 40 >> 2] >> 2]) >> 2];
  f = eb - 16 | 0;
  eb = f;
  d = v[d >> 2];
  v[f + 12 >> 2] = d;
  while (1) {
   if (vi(d, i)) {
    Db(Ax(d));
    d = v[vm(f + 12 | 0) >> 2];
    continue;
   }
   break;
  }
  eb = f + 16 | 0;
  eb = e + 16 | 0;
 }
 eb = c - -64 | 0;
 v[b + 4 >> 2] = g;
 Sb(a, b + 4 | 0);
 Sb(a + 4 | 0, b + 8 | 0);
 Sb(zb(a), mc(b));
 v[b >> 2] = v[b + 4 >> 2];
 eb = h + 16 | 0;
}

function J9(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0;
 c = eb - 32 | 0;
 eb = c;
 h = Eb(a);
 f = Eb(c + 20 | 0);
 a = 1;
 a: {
  b: {
   c: {
    while (1) {
     d = a & 65535;
     e = v[b + 24 >> 2];
     if (d >>> 0 > x[e + 480190 >> 1]) {
      if (!(i & 1)) {
       break c;
      }
      v[31601] = 0;
      N(247, h | 0, f | 0);
      a = v[31601];
      v[31601] = 0;
      if ((a | 0) != 1) {
       break c;
      }
      a = M() | 0;
      break a;
     }
     v[31601] = 0;
     e = O(36, c + 8 | 0, SR(e, d) | 0) | 0;
     d = v[31601];
     v[31601] = 0;
     if ((d | 0) == 1) {
      break b;
     }
     d = zd(v[c + 12 >> 2], w[c + 19 | 0]);
     v[31601] = 0;
     g = O(837, f | 0, e | 0) | 0;
     j = v[31601];
     v[31601] = 0;
     d: {
      if ((j | 0) == 1) {
       break d;
      }
      v[31601] = 0;
      O(984, g | 0, 22231) | 0;
      g = v[31601];
      v[31601] = 0;
      if ((g | 0) == 1) {
       break d;
      }
      i = d ^ 1 | i;
      sb(e);
      a = a + 1 | 0;
      continue;
     }
     break;
    }
    a = M() | 0;
    sb(e);
    break a;
   }
   sb(f);
   eb = c + 32 | 0;
   return;
  }
  a = M() | 0;
 }
 sb(f);
 sb(h);
 P(a | 0);
 p();
}

function Cq(a) {
 var b = 0, c = 0, d = 0, e = 0, f = 0, g = 0, h = 0;
 c = eb - 16 | 0;
 eb = c;
 b = v[a + 24620 >> 2];
 a: {
  b: {
   switch (w[a + 480224 | 0] - 1 | 0) {
   default:
    v[c + 8 >> 2] = 1;
    v[c >> 2] = v[a + 1074420 >> 2] << 1;
    e = Aua(b, b >> 31, 5e4, 0);
    d = gb;
    b = v[ad(c + 8 | 0, c) >> 2];
    b = Fc(Bua(e, d, b, b >> 31), gb);
    break a;

   case 1:
    v[c + 8 >> 2] = 1;
    v[c + 12 >> 2] = 0;
    g = c, h = Aua(v[a + 1074420 >> 2], 0, Aua(v[a + 1074408 >> 2], 0, v[a + 1074416 >> 2], 0), gb), 
    v[g >> 2] = h;
    v[c + 4 >> 2] = gb;
    b = Aua(b, 0, 6e5, 0);
    d = c + 8 | 0;
    e = b;
    f = gb;
    b = Rw(v[d >> 2], v[d + 4 >> 2], v[c >> 2], v[c + 4 >> 2]) ? c : d;
    b = Cua(e, f, v[b >> 2], v[b + 4 >> 2]);
    break a;

   case 0:
    break b;
   }
  }
  v[c + 8 >> 2] = 1;
  v[c >> 2] = v[a + 1074420 >> 2];
  e = Aua(b, b >> 31, 1e4, 0);
  d = gb;
  b = v[ad(c + 8 | 0, c) >> 2];
  b = Fc(Bua(e, d, b, b >> 31), gb);
 }
 v[a + 1074404 >> 2] = b;
 d = v[a + 480244 >> 2];
 d = Aua(d, d >> 31, b, b >> 31);
 b = gb;
 d = d + 32768 | 0;
 b = d >>> 0 < 32768 ? b + 1 | 0 : b;
 e = a;
 a = Fc(Bua(d, b, 65536, 0), gb);
 v[e + 1074404 >> 2] = a >>> 0 <= 1 ? 1 : a;
 eb = c + 16 | 0;
}

function xla(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0;
 g = eb - 32 | 0;
 eb = g;
 h = a + 8 | 0;
 c = v[a + 8 >> 2];
 j = mc(a);
 a: {
  if ((c | 0) != v[j >> 2]) {
   break a;
  }
  i = a + 4 | 0;
  d = v[a + 4 >> 2];
  e = v[a >> 2];
  if (d >>> 0 > e >>> 0) {
   a = ((d - e >> 2) + 1 | 0) / -2 << 2;
   c = Lv(d, c, a + d | 0);
   v[h >> 2] = c;
   v[i >> 2] = a + v[i >> 2];
   break a;
  }
  v[g + 8 >> 2] = c - e >> 1;
  v[g + 28 >> 2] = 1;
  d = g + 8 | 0;
  c = v[ad(d, g + 28 | 0) >> 2];
  c = Yf(d, c, c >>> 2 | 0, v[a + 16 >> 2]);
  d = ub(g + 4 | 0, v[a + 4 >> 2]);
  f = v[ub(g, v[a + 8 >> 2]) >> 2];
  e = v[d >> 2];
  f = Mv(f, e);
  d = eb - 16 | 0;
  eb = d;
  v[d + 12 >> 2] = e;
  e = En(d, c + 8 | 0, f);
  f = v[e >> 2];
  while (1) {
   if (v[e + 4 >> 2] != (f | 0)) {
    k = f;
    f = v[d + 12 >> 2];
    bp(k, x[f >> 1] | x[f + 2 >> 1] << 16);
    f = v[e >> 2] + 4 | 0;
    v[e >> 2] = f;
    Xe(d + 12 | 0);
    continue;
   }
   break;
  }
  ie(e);
  eb = d + 16 | 0;
  Sb(a, c);
  Sb(i, c + 4 | 0);
  Sb(h, c + 8 | 0);
  Sb(j, mc(c));
  Xf(c);
  c = v[a + 8 >> 2];
 }
 bp(c, x[b >> 1] | x[b + 2 >> 1] << 16);
 v[h >> 2] = v[h >> 2] + 4;
 eb = g + 32 | 0;
}

function Tka(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0;
 i = eb - 16 | 0;
 eb = i;
 e = v[ub(i + 12 | 0, vb(v[a + 4 >> 2])) >> 2];
 f = LT(b, c);
 h = eb - 32 | 0;
 eb = h;
 d = e;
 e = v[a >> 2];
 e = (lp(d, vb(e)) << 1) + e | 0;
 a: {
  if ((f | 0) <= 0) {
   break a;
  }
  d = v[zb(a) >> 2];
  g = v[a + 4 >> 2];
  if ((f | 0) <= d - g >> 1) {
   d = eb - 16 | 0;
   eb = d;
   v[d + 12 >> 2] = b;
   KT(d + 12 | 0, f);
   j = v[d + 12 >> 2];
   eb = d + 16 | 0;
   d = g - e >> 1;
   if ((d | 0) < (f | 0)) {
    v[h + 12 >> 2] = b;
    KT(h + 12 | 0, d);
    j = v[h + 12 >> 2];
    ev(a, j, c, f - d | 0);
    if ((d | 0) <= 0) {
     break a;
    }
   }
   QU(a, e, g, (f << 1) + e | 0);
   bC(b, j, e);
   break a;
  }
  c = zb(a);
  d = dk(h + 12 | 0, ek(a, _c(v[a >> 2], g) + f | 0), e - v[a >> 2] >> 1, c);
  g = eb - 16 | 0;
  eb = g;
  c = Bp(g + 4 | 0, d + 8 | 0, f);
  f = v[c >> 2];
  while (1) {
   if (v[c + 4 >> 2] != (f | 0)) {
    km(f, x[b >> 1]);
    f = v[c >> 2] + 2 | 0;
    v[c >> 2] = f;
    b = b + 2 | 0;
    continue;
   }
   break;
  }
  ie(c);
  eb = g + 16 | 0;
  e = PU(a, d, e);
  $i(d);
 }
 vb(e);
 eb = h + 32 | 0;
 eb = i + 16 | 0;
 return a | 0;
}

function HK(a) {
 var b = 0, c = 0, d = 0, e = 0, f = 0;
 f = v[124107];
 if (v[a + 72 >> 2] <= 0) {
  Ny(a);
 }
 v[124107] = v[a + 136 >> 2];
 c = eb - 32 | 0;
 eb = c;
 a: {
  b: {
   c: {
    b = v[a + 4 >> 2];
    d = v[a + 8 >> 2];
    if ((b | 0) == (d | 0)) {
     break c;
    }
    b = GK(c + 28 | 0, b, d - b | 0);
    if ((b | 0) == -1) {
     break c;
    }
    v[a + 4 >> 2] = !b + (b + v[a + 4 >> 2] | 0);
    break b;
   }
   v[c + 16 >> 2] = 0;
   v[c + 20 >> 2] = 0;
   b = 0;
   while (1) {
    d = b;
    d: {
     b = v[a + 4 >> 2];
     if ((b | 0) != v[a + 8 >> 2]) {
      v[a + 4 >> 2] = b + 1;
      t[c + 15 | 0] = w[b | 0];
      break d;
     }
     b = zt(a);
     t[c + 15 | 0] = b;
     if ((b | 0) >= 0) {
      break d;
     }
     b = -1;
     if (!(d & 1)) {
      break a;
     }
     v[a >> 2] = v[a >> 2] | 32;
     v[31476] = 25;
     break a;
    }
    b = 1;
    e = fq(c + 28 | 0, c + 15 | 0, 1, c + 16 | 0);
    if ((e | 0) == -2) {
     continue;
    }
    break;
   }
   b = -1;
   if ((e | 0) != -1) {
    break b;
   }
   if (!(d & 1)) {
    break a;
   }
   v[a >> 2] = v[a >> 2] | 32;
   eo(w[c + 15 | 0], a);
   break a;
  }
  b = v[c + 28 >> 2];
 }
 eb = c + 32 | 0;
 v[124107] = f;
 return b;
}

function _9(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0;
 d = eb - 80 | 0;
 eb = d;
 v[31601] = 0;
 f = Q(1200, b | 0) | 0;
 e = v[31601];
 v[31601] = 0;
 if ((e | 0) != 1) {
  a: {
   b: {
    if (f) {
     v[31601] = 0;
     f = d + 56 | 0;
     N(1201, f | 0, b | 0);
     b = v[31601];
     v[31601] = 0;
     if ((b | 0) != 1) {
      b = d - -64 | 0;
      Jp(b, f);
      e = Ef(d + 72 | 0, b);
      g = Ef(d + 48 | 0, c);
      h = v[e + 4 >> 2];
      v[d + 8 >> 2] = v[e >> 2];
      v[d + 12 >> 2] = h;
      e = v[g + 4 >> 2];
      v[d >> 2] = v[g >> 2];
      v[d + 4 >> 2] = e;
      Kp(a, d + 8 | 0, d);
      break b;
     }
     break a;
    }
    v[31601] = 0;
    f = d + 56 | 0;
    N(1202, f | 0, b | 0);
    b = v[31601];
    v[31601] = 0;
    if ((b | 0) == 1) {
     break a;
    }
    b = d - -64 | 0;
    Jp(b, f);
    e = Ef(d + 40 | 0, b);
    g = Ef(d + 32 | 0, c);
    h = v[e + 4 >> 2];
    v[d + 24 >> 2] = v[e >> 2];
    v[d + 28 >> 2] = h;
    e = v[g + 4 >> 2];
    v[d + 16 >> 2] = v[g >> 2];
    v[d + 20 >> 2] = e;
    Kp(a, d + 24 | 0, d + 16 | 0);
   }
   le(b);
   le(f);
   le(c);
   eb = d + 80 | 0;
   return;
  }
 }
 a = M() | 0;
 le(c);
 P(a | 0);
 p();
}

function $aa(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0;
 d = eb - 16 | 0;
 eb = d;
 j = d, k = ZM(), v[j + 12 >> 2] = k;
 h = a + 24 | 0;
 f = d + 12 | 0;
 XM(h, me(f));
 vh(f);
 u[a + 28 >> 1] = 0;
 EP();
 g = eb - 16 | 0;
 eb = g;
 i = Dc(144);
 v[31601] = 0;
 c = O(1127, i | 0, 4) | 0;
 e = v[31601];
 v[31601] = 0;
 a: {
  if ((e | 0) != 1) {
   e = xf(g + 12 | 0, c);
   eb = g + 16 | 0;
   e = v[e >> 2];
   break a;
  }
  a = M() | 0;
  Bb(i);
  P(a | 0);
  p();
 }
 v[d + 12 >> 2] = e;
 VM(a + 32 | 0, me(f));
 yl(f);
 j = d, k = YM(v[a >> 2]), v[j + 12 >> 2] = k;
 UM(a + 4 | 0, me(f));
 uh(f);
 uo(v[h >> 2], v[a + 4 >> 2]);
 t[a + 64 | 0] = 1;
 v[a + 60 >> 2] = 0;
 v[a + 48 >> 2] = 1065353216;
 v[a + 52 >> 2] = 0;
 v[a + 16 >> 2] = 0;
 v[a + 20 >> 2] = 0;
 v[a + 8 >> 2] = 0;
 c = Si(v[b >> 2]);
 v[d + 12 >> 2] = c;
 e = Of(b);
 b: {
  while (1) {
   if (!Yg(c, e)) {
    break b;
   }
   b = td(c);
   c = ig(d, b);
   v[31601] = 0;
   U(1011, a | 0, c | 0, b + 12 | 0, 0);
   b = v[31601];
   v[31601] = 0;
   if ((b | 0) != 1) {
    sb(c);
    c = v[$g(d + 12 | 0) >> 2];
    continue;
   }
   break;
  }
  a = M() | 0;
  sb(c);
  P(a | 0);
  p();
 }
 eb = d + 16 | 0;
}

function aD(a, b, c, d) {
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0;
 f = eb - 16 | 0;
 eb = f;
 e = w[a | 0];
 if (e & 1) {
  t[b + 12 | 0] = w[b + 12 | 0] | 1;
  e = w[a | 0];
 }
 if (e & 2) {
  t[b + 12 | 0] = w[b + 12 | 0] | 4;
  e = w[a | 0];
 }
 if (e & 4) {
  t[b + 12 | 0] = w[b + 12 | 0] | 2;
  e = w[a | 0];
 }
 if (e & 16) {
  t[b + 12 | 0] = w[b + 12 | 0] | 16;
  e = w[a | 0];
 }
 if (e & 32) {
  t[b + 12 | 0] = w[b + 12 | 0] | 8;
 }
 t[f + 15 | 0] = w[a + 1 | 0];
 t[f + 14 | 0] = 25;
 eh(b, w[Pb(f + 15 | 0, f + 14 | 0) | 0]);
 e = w[a + 2 | 0];
 t[b + 15 | 0] = e;
 t[b + 16 | 0] = (d | 0) == 4 ? e : w[a + 3 | 0];
 t[b + 13 | 0] = w[a + 4 | 0];
 t[b + 14 | 0] = w[a + 5 | 0];
 e = a + 6 | 0;
 h = v[b >> 2];
 d = Rd(h, v[b + 4 >> 2]);
 b = 0;
 while (1) {
  if ((b | 0) != (d | 0)) {
   i = xb(h, b);
   g = e + (b << 2) | 0;
   a = w[g | 0] | w[g + 1 | 0] << 8;
   u[i >> 1] = a;
   a: {
    if (!b) {
     break a;
    }
    j = a;
    a = x[xb(h, b - 1 | 0) >> 1];
    if (j >>> 0 >= a >>> 0) {
     break a;
    }
    u[i >> 1] = a + 1;
   }
   k = i, l = Xb((w[g + 2 | 0] | w[g + 3 | 0] << 8) << 16 >> 16 >> c, 0, 64), t[k + 2 | 0] = l;
   b = b + 1 | 0;
   continue;
  }
  break;
 }
 eb = f + 16 | 0;
}

function co(a, b, c, d, e, f, g, h, i, j, k) {
 var l = 0, m = 0, n = 0;
 a: {
  b: {
   l = v[d >> 2];
   if ((l | 0) != (c | 0)) {
    break b;
   }
   m = 43;
   n = a & 255;
   if ((n | 0) != w[k + 24 | 0]) {
    m = 45;
    if (w[k + 25 | 0] != (n | 0)) {
     break b;
    }
   }
   v[d >> 2] = c + 1;
   t[c | 0] = m;
   break a;
  }
  c: {
   if (!(!Cb(g, h) | (a | 0) != (f | 0))) {
    h = 0;
    a = v[j >> 2];
    if ((a - i | 0) > 159) {
     break c;
    }
    b = v[e >> 2];
    v[j >> 2] = a + 4;
    v[a >> 2] = b;
    break a;
   }
   h = -1;
   a = Ei(k, k + 26 | 0, a) - k | 0;
   if ((a | 0) > 23) {
    break c;
   }
   d: {
    e: {
     switch (b - 8 | 0) {
     case 0:
     case 2:
      if ((a | 0) < (b | 0)) {
       break d;
      }
      break c;

     case 1:
      break d;

     default:
      break e;
     }
    }
    if ((b | 0) != 16 | (a | 0) < 22) {
     break d;
    }
    if ((c | 0) == (l | 0) | (l - c | 0) > 2 | w[l - 1 | 0] != 48) {
     break c;
    }
    v[e >> 2] = 0;
    v[d >> 2] = l + 1;
    t[l | 0] = w[a + 95136 | 0];
    return 0;
   }
   v[d >> 2] = l + 1;
   t[l | 0] = w[a + 95136 | 0];
   v[e >> 2] = v[e >> 2] + 1;
   h = 0;
  }
  return h;
 }
 v[e >> 2] = 0;
 return 0;
}

function uQ(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0;
 c = eb - 16 | 0;
 eb = c;
 e = v[b + 4220 >> 2];
 f = v[b + 4224 >> 2];
 g = v[b + 4228 >> 2];
 h = v[b + 4232 >> 2];
 i = v[b + 4240 >> 2];
 j = v[b + 4236 >> 2];
 k = w[b + 4244 | 0];
 Qj(b + 4208 | 0, 33);
 d = v[b + 4208 >> 2];
 t[d + 32 | 0] = k;
 t[d + 24 | 0] = j;
 t[d + 25 | 0] = j >>> 8;
 t[d + 26 | 0] = j >>> 16;
 t[d + 27 | 0] = j >>> 24;
 t[d + 28 | 0] = i;
 t[d + 29 | 0] = i >>> 8;
 t[d + 30 | 0] = i >>> 16;
 t[d + 31 | 0] = i >>> 24;
 t[d + 16 | 0] = g;
 t[d + 17 | 0] = g >>> 8;
 t[d + 18 | 0] = g >>> 16;
 t[d + 19 | 0] = g >>> 24;
 t[d + 20 | 0] = h;
 t[d + 21 | 0] = h >>> 8;
 t[d + 22 | 0] = h >>> 16;
 t[d + 23 | 0] = h >>> 24;
 t[d + 8 | 0] = e;
 t[d + 9 | 0] = e >>> 8;
 t[d + 10 | 0] = e >>> 16;
 t[d + 11 | 0] = e >>> 24;
 t[d + 12 | 0] = f;
 t[d + 13 | 0] = f >>> 8;
 t[d + 14 | 0] = f >>> 16;
 t[d + 15 | 0] = f >>> 24;
 t[d | 0] = 76;
 t[d + 1 | 0] = 70;
 t[d + 2 | 0] = 79;
 t[d + 3 | 0] = 32;
 t[d + 4 | 0] = 0;
 t[d + 5 | 0] = 0;
 t[d + 6 | 0] = 0;
 t[d + 7 | 0] = 0;
 oe(c + 8 | 0, v[b + 4208 >> 2], v[b + 4212 >> 2]);
 Yb(a, v[c + 8 >> 2], v[c + 12 >> 2]);
 eb = c + 16 | 0;
}

function qL(a, b, c, d) {
 a: {
  switch (b - 9 | 0) {
  case 0:
   b = v[c >> 2];
   v[c >> 2] = b + 4;
   v[a >> 2] = v[b >> 2];
   return;

  case 6:
   b = v[c >> 2];
   v[c >> 2] = b + 4;
   b = u[b >> 1];
   v[a >> 2] = b;
   v[a + 4 >> 2] = b >> 31;
   return;

  case 7:
   b = v[c >> 2];
   v[c >> 2] = b + 4;
   v[a >> 2] = x[b >> 1];
   v[a + 4 >> 2] = 0;
   return;

  case 8:
   b = v[c >> 2];
   v[c >> 2] = b + 4;
   b = t[b | 0];
   v[a >> 2] = b;
   v[a + 4 >> 2] = b >> 31;
   return;

  case 9:
   b = v[c >> 2];
   v[c >> 2] = b + 4;
   v[a >> 2] = w[b | 0];
   v[a + 4 >> 2] = 0;
   return;

  case 16:
   b = v[c >> 2] + 7 & -8;
   v[c >> 2] = b + 8;
   A[a >> 3] = A[b >> 3];
   return;

  case 17:
   hb[d | 0](a, c);

  default:
   return;

  case 1:
  case 4:
  case 14:
   b = v[c >> 2];
   v[c >> 2] = b + 4;
   b = v[b >> 2];
   v[a >> 2] = b;
   v[a + 4 >> 2] = b >> 31;
   return;

  case 2:
  case 5:
  case 11:
  case 15:
   b = v[c >> 2];
   v[c >> 2] = b + 4;
   v[a >> 2] = v[b >> 2];
   v[a + 4 >> 2] = 0;
   return;

  case 3:
  case 10:
  case 12:
  case 13:
   break a;
  }
 }
 b = v[c >> 2] + 7 & -8;
 v[c >> 2] = b + 8;
 c = v[b + 4 >> 2];
 v[a >> 2] = v[b >> 2];
 v[a + 4 >> 2] = c;
}

function bo(a, b, c, d, e, f, g, h, i, j, k) {
 var l = 0, m = 0;
 a: {
  b: {
   l = v[d >> 2];
   if ((l | 0) != (c | 0)) {
    break b;
   }
   m = 43;
   if (v[k + 96 >> 2] != (a | 0)) {
    m = 45;
    if (v[k + 100 >> 2] != (a | 0)) {
     break b;
    }
   }
   v[d >> 2] = c + 1;
   t[c | 0] = m;
   break a;
  }
  c: {
   if (!(!Cb(g, h) | (a | 0) != (f | 0))) {
    h = 0;
    a = v[j >> 2];
    if ((a - i | 0) > 159) {
     break c;
    }
    b = v[e >> 2];
    v[j >> 2] = a + 4;
    v[a >> 2] = b;
    break a;
   }
   h = -1;
   a = Ey(k, k + 104 | 0, a) - k >> 2;
   if ((a | 0) > 23) {
    break c;
   }
   d: {
    e: {
     switch (b - 8 | 0) {
     case 0:
     case 2:
      if ((a | 0) < (b | 0)) {
       break d;
      }
      break c;

     case 1:
      break d;

     default:
      break e;
     }
    }
    if ((b | 0) != 16 | (a | 0) < 22) {
     break d;
    }
    if ((c | 0) == (l | 0) | (l - c | 0) > 2 | w[l - 1 | 0] != 48) {
     break c;
    }
    v[e >> 2] = 0;
    v[d >> 2] = l + 1;
    t[l | 0] = w[a + 95136 | 0];
    return 0;
   }
   v[d >> 2] = l + 1;
   t[l | 0] = w[a + 95136 | 0];
   v[e >> 2] = v[e >> 2] + 1;
   h = 0;
  }
  return h;
 }
 v[e >> 2] = 0;
 return 0;
}

function Sma(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0;
 b = eb - 16 | 0;
 eb = b;
 f = v[a + 40 >> 2];
 g = v[a + 36 >> 2];
 k = v[a + 16 >> 2];
 h = v[a + 4 >> 2];
 v[b + 8 >> 2] = v[a >> 2];
 v[b + 12 >> 2] = h;
 l = v[a + 32 >> 2];
 m = v[a + 28 >> 2];
 h = v[a + 8 >> 2];
 n = v[a + 12 >> 2];
 while (1) {
  if (d) {
   e = v[b + 8 >> 2];
   o = e >>> 18 | 0;
   p = ((((v[b + 12 >> 2] & 2147483647) << 1 | e >>> 31) & 2147483646) << 1) + k | 0;
   e = 0;
   while (1) {
    if ((e | 0) != 2) {
     i = (e << 1) + p | 0;
     j = u[i >> 1];
     v[(e << 2) + b >> 2] = j + ((B(u[i + 4 >> 1] - j | 0, o) | 0) / 16384 | 0);
     e = e + 1 | 0;
     continue;
    }
    break;
   }
   g = g + m | 0;
   v[c >> 2] = v[c >> 2] + B(v[b >> 2], g >> 12);
   f = f + l | 0;
   v[c + 4 >> 2] = v[c + 4 >> 2] + B(v[b + 4 >> 2], f >> 12);
   Ob(b + 8 | 0, h, n);
   c = c + 8 | 0;
   d = d - 1 | 0;
   continue;
  }
  break;
 }
 c = v[b + 12 >> 2];
 v[a >> 2] = v[b + 8 >> 2];
 v[a + 4 >> 2] = c;
 v[a + 40 >> 2] = f;
 v[a + 20 >> 2] = g >> 12;
 v[a + 36 >> 2] = g;
 v[a + 24 >> 2] = f >> 12;
 eb = b + 16 | 0;
}

function _8(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0;
 f = eb - 16 | 0;
 eb = f;
 a: {
  b: {
   if (!lc(b, -1)) {
    i = v[a + 8 >> 2];
    j = v[a + 12 >> 2];
    d = v[a + 24 >> 2];
    if ((d | 0) == v[a + 28 >> 2]) {
     c = -1;
     if (!(w[a + 48 | 0] & 16)) {
      break a;
     }
     k = v[a + 44 >> 2];
     h = v[a + 20 >> 2];
     v[31601] = 0;
     g = a + 32 | 0;
     N(115, g | 0, 0);
     e = v[31601];
     v[31601] = 0;
     if ((e | 0) == 1) {
      break b;
     }
     e = Lc(g);
     v[31601] = 0;
     N(46, g | 0, e | 0);
     e = v[31601];
     v[31601] = 0;
     if ((e | 0) == 1) {
      break b;
     }
     c = Jb(g);
     Ex(a, c, Cb(v[a + 36 >> 2], w[a + 43 | 0]) + c | 0);
     As(a, d - h | 0);
     v[a + 44 >> 2] = v[a + 20 >> 2] + (k - h | 0);
     d = v[a + 24 >> 2];
    }
    v[f + 12 >> 2] = d + 1;
    d = v[ad(f + 12 | 0, a + 44 | 0) >> 2];
    v[a + 44 >> 2] = d;
    if (w[a + 48 | 0] & 8) {
     c = Jb(a + 32 | 0);
     Un(a, c, c + (j - i | 0) | 0, d);
    }
    c = fL(a, b << 24 >> 24);
    break a;
   }
   c = Ry(b);
   break a;
  }
  X(S(0) | 0) | 0;
  Y();
 }
 eb = f + 16 | 0;
 return c | 0;
}

function sp(a) {
 var b = 0, c = 0, d = 0, e = 0;
 d = eb - 16 | 0;
 eb = d;
 a: {
  b: {
   if (!v[(v[v[a >> 2] - 12 >> 2] + a | 0) + 24 >> 2]) {
    break b;
   }
   v[31601] = 0;
   c = O(21, d + 8 | 0, a | 0) | 0;
   b = v[31601];
   v[31601] = 0;
   c: {
    if ((b | 0) != 1) {
     d: {
      if (!Hd(w[c | 0])) {
       break d;
      }
      b = v[(v[v[a >> 2] - 12 >> 2] + a | 0) + 24 >> 2];
      v[31601] = 0;
      b = Q(31, b | 0) | 0;
      e = v[31601];
      v[31601] = 0;
      if ((e | 0) != 1) {
       if ((b | 0) != -1) {
        break d;
       }
       b = v[v[a >> 2] - 12 >> 2];
       v[31601] = 0;
       N(24, a + b | 0, 1);
       b = v[31601];
       v[31601] = 0;
       if ((b | 0) != 1) {
        break d;
       }
      }
      b = S(0) | 0;
      dm(c);
      break c;
     }
     dm(c);
     break b;
    }
    b = S(0) | 0;
   }
   X(b | 0) | 0;
   c = v[v[a >> 2] - 12 >> 2];
   v[31601] = 0;
   V(25, a + c | 0);
   c = v[31601];
   v[31601] = 0;
   if ((c | 0) == 1) {
    break a;
   }
   Y();
  }
  eb = d + 16 | 0;
  return a;
 }
 a = M() | 0;
 v[31601] = 0;
 W(26);
 c = v[31601];
 v[31601] = 0;
 if ((c | 0) != 1) {
  P(a | 0);
  p();
 }
 S(0) | 0;
 Rb();
 p();
}

function Hka(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0;
 e = eb - 80 | 0;
 eb = e;
 d = Qf(e + 52 | 0);
 v[31601] = 0;
 g = O(834, b | 0, d | 0) | 0;
 f = v[31601];
 v[31601] = 0;
 a: {
  b: {
   c: {
    if ((f | 0) != 1) {
     if (g) {
      break c;
     }
     v[a >> 2] = 0;
     v[a + 4 >> 2] = 0;
     v[a + 24 >> 2] = 0;
     v[a + 16 >> 2] = 0;
     v[a + 20 >> 2] = 0;
     v[a + 8 >> 2] = 0;
     v[a + 12 >> 2] = 0;
     v[31601] = 0;
     Q(835, a | 0) | 0;
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) != 1) {
      break b;
     }
    }
    break a;
   }
   g = v[d + 4 >> 2];
   v[31601] = 0;
   f = e + 12 | 0;
   R(185, f | 0, b | 0, g | 0);
   h = v[31601];
   v[31601] = 0;
   if ((h | 0) == 1) {
    break a;
   }
   h = gc(e + 32 | 0, f);
   jd(d + 8 | 0, h);
   tb(h);
   tb(f);
   d: {
    if (c >>> 0 < 2) {
     break d;
    }
    c = g & 1;
    if (!c) {
     break d;
    }
    v[31601] = 0;
    O(183, b | 0, 2 - c | 0) | 0;
    b = v[31601];
    v[31601] = 0;
    if ((b | 0) != 1) {
     break d;
    }
    break a;
   }
   Lk(a, d);
  }
  Gd(d);
  eb = e + 80 | 0;
  return;
 }
 a = M() | 0;
 Gd(d);
 P(a | 0);
 p();
}

function Y3(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0;
 c = eb - 32 | 0;
 eb = c;
 a: {
  b: {
   if (gi(b, 14276)) {
    d = _s(c + 28 | 0, b);
    e = v[d >> 2];
    if (!Dd(e)) {
     v[31601] = 0;
     b = O(36, c + 4 | 0, b | 0) | 0;
     a = v[31601];
     v[31601] = 0;
     c: {
      d: {
       e: {
        if ((a | 0) != 1) {
         v[31601] = 0;
         a = c + 16 | 0;
         R(1010, a | 0, 17723, b | 0);
         e = v[31601];
         v[31601] = 0;
         if ((e | 0) == 1) {
          break e;
         }
         v[31601] = 0;
         V(1366, a | 0);
         a = v[31601];
         v[31601] = 0;
         if ((a | 0) == 1) {
          break d;
         }
         p();
        }
        a = M() | 0;
        break a;
       }
       a = M() | 0;
       break c;
      }
      a = M() | 0;
      sb(c + 16 | 0);
     }
     sb(b);
     break a;
    }
    Zs(e);
    _p(a + 8 | 0, 16770, v[d >> 2]);
    _p(a + 12 | 0, 22256, v[d >> 2]);
    v[31601] = 0;
    N(272, a + 16 | 0, 22256);
    a = v[31601];
    v[31601] = 0;
    if ((a | 0) == 1) {
     break b;
    }
    el(d);
   }
   eb = c + 32 | 0;
   return;
  }
  a = M() | 0;
 }
 el(d);
 P(a | 0);
 p();
}

function Tma(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0;
 b = eb - 16 | 0;
 eb = b;
 f = v[a + 40 >> 2];
 g = v[a + 36 >> 2];
 k = v[a + 16 >> 2];
 h = v[a + 4 >> 2];
 v[b + 8 >> 2] = v[a >> 2];
 v[b + 12 >> 2] = h;
 l = v[a + 32 >> 2];
 m = v[a + 28 >> 2];
 h = v[a + 8 >> 2];
 n = v[a + 12 >> 2];
 while (1) {
  if (d) {
   e = v[b + 8 >> 2];
   o = e >>> 10 & 4194048;
   p = (((v[b + 12 >> 2] & 2147483647) << 1 | e >>> 31) & -2) + k | 0;
   e = 0;
   while (1) {
    if ((e | 0) != 2) {
     i = e + p | 0;
     j = t[i | 0];
     v[(e << 2) + b >> 2] = ((B(t[i + 2 | 0] - j | 0, o) | 0) / 16384 | 0) + (j << 8);
     e = e + 1 | 0;
     continue;
    }
    break;
   }
   g = g + m | 0;
   v[c >> 2] = v[c >> 2] + B(v[b >> 2], g >> 12);
   f = f + l | 0;
   v[c + 4 >> 2] = v[c + 4 >> 2] + B(v[b + 4 >> 2], f >> 12);
   Ob(b + 8 | 0, h, n);
   c = c + 8 | 0;
   d = d - 1 | 0;
   continue;
  }
  break;
 }
 c = v[b + 12 >> 2];
 v[a >> 2] = v[b + 8 >> 2];
 v[a + 4 >> 2] = c;
 v[a + 40 >> 2] = f;
 v[a + 20 >> 2] = g >> 12;
 v[a + 36 >> 2] = g;
 v[a + 24 >> 2] = f >> 12;
 eb = b + 16 | 0;
}

function ZS(a, b, c) {
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0;
 e = eb - 16 | 0;
 eb = e;
 i = -1;
 a: {
  if (!JA(a, b, 2)) {
   break a;
  }
  f = v[b + 656 >> 2];
  d = a + 1074312 | 0;
  g = Nb(d, 31);
  h = v[b + 740 >> 2];
  if (h ? 0 : g) {
   break a;
  }
  h = h - Nb(d, 31) | 0;
  g = v[a + 480180 >> 2];
  d = (g | 0) == 4096;
  j = f + 88 | 0;
  f = d ? 64 : (g | 0) == 16384 ? 192 : 512;
  d = Rq(j, h, f, d ? 255 : 64) - (f >>> 1 | 0) | 0;
  if (w[b + 746 | 0] & 16) {
   i = Kq(a, b, !(v[b + 88 >> 2] & 32768), d);
   break a;
  }
  if (Jj(v[b + 656 >> 2])) {
   if ((d | 0) == u[b + 772 >> 1]) {
    break a;
   }
   k = b, l = fd(d), u[k + 772 >> 1] = l;
   t[b + 851 | 0] = w[b + 851 | 0] | 64;
   break a;
  }
  a = yj(a);
  v[e + 12 >> 2] = d;
  b: {
   if ((d | 0) < 0) {
    v[e + 12 >> 2] = 0 - d;
    ti(e + 12 | 0, 255);
    a = (v[e + 12 >> 2] << 2) + (a ? 36496 : 35472) | 0;
    break b;
   }
   ti(e + 12 | 0, 255);
   a = (v[e + 12 >> 2] << 2) + (a ? 35472 : 36496) | 0;
  }
  a = v[a >> 2];
  b = a;
  d = a >> 31;
  a = v[c >> 2];
  k = c, l = Fc(Bua(Aua(b, d, a, a >> 31), gb, 65536, 0), gb), v[k >> 2] = l;
 }
 eb = e + 16 | 0;
 return i;
}

function wga(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0;
 b = Ii(a, b, c, d);
 v[b + 4260 >> 2] = 0;
 v[b >> 2] = 45116;
 d = 4504;
 while (1) {
  Mb(b + d | 0);
  d = d + 24 | 0;
  if ((d | 0) != 4960) {
   continue;
  }
  break;
 }
 t[b + 5046 | 0] = 1;
 u[b + 5044 >> 1] = 0;
 a = b + 4208 | 0;
 e = xb(a, 0), f = 1063675494, v[e >> 2] = f;
 e = xb(a, 1), f = 1065185444, v[e >> 2] = f;
 e = xb(a, 2), f = 0, v[e >> 2] = f;
 e = xb(a, 3), f = 1032805417, v[e >> 2] = f;
 e = xb(a, 4), f = 1053079357, v[e >> 2] = f;
 e = xb(a, 5), f = 1059859440, v[e >> 2] = f;
 e = xb(a, 6), f = 1047457519, v[e >> 2] = f;
 e = xb(a, 7), f = 1062836634, v[e >> 2] = f;
 e = xb(a, 8), f = 1038174126, v[e >> 2] = f;
 e = xb(a, 9), f = 1065353216, v[e >> 2] = f;
 e = xb(a, 10), f = 1065353216, v[e >> 2] = f;
 e = xb(a, 11), f = 1048525618, v[e >> 2] = f;
 e = xb(a, 12), f = 1059760811, v[e >> 2] = f;
 v[31601] = 0;
 N(940, b + 44 | 0, 2);
 a = v[31601];
 v[31601] = 0;
 if ((a | 0) == 1) {
  a = M() | 0;
  d = 4960;
  while (1) {
   d = d - 24 | 0;
   uc(b + d | 0);
   if ((d | 0) != 4504) {
    continue;
   }
   break;
  }
  Zf(b);
  P(a | 0);
  p();
 }
 return b | 0;
}

function rN(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = +c;
 var d = 0, e = 0, f = 0;
 d = eb - 16 | 0;
 eb = d;
 a: {
  b: {
   c: {
    d: {
     if ((b | 0) >= 0) {
      a = v[a + 32 >> 2];
      if ((wo(a) | 0) > (b | 0)) {
       break d;
      }
     }
     a = cc(8);
     v[31601] = 0;
     d = O(36, d + 4 | 0, 10735) | 0;
     b = v[31601];
     v[31601] = 0;
     if ((b | 0) == 1) {
      break c;
     }
     rc(a, d);
     v[31601] = 0;
     R(97, a | 0, 48396, 999);
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) != 1) {
      break a;
     }
     b = M() | 0;
     sb(d);
     break b;
    }
    if (c < 0 | c > 1) {
     a = cc(8);
     v[31601] = 0;
     d = O(36, d + 4 | 0, 11752) | 0;
     b = v[31601];
     v[31601] = 0;
     if ((b | 0) != 1) {
      rc(a, d);
      v[31601] = 0;
      R(97, a | 0, 48396, 999);
      a = v[31601];
      v[31601] = 0;
      if ((a | 0) != 1) {
       break a;
      }
      b = M() | 0;
      sb(d);
      break b;
     }
     b = M() | 0;
     jc(a);
     break b;
    }
    e = (a + B(b, 872) | 0) + 1075740 | 0, f = Ri(c * 64), v[e >> 2] = f;
    eb = d + 16 | 0;
    return;
   }
   b = M() | 0;
   jc(a);
  }
  P(b | 0);
 }
 p();
}

function Qra(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0;
 g = b;
 c = eb - 48 | 0;
 eb = c;
 d = a;
 a: {
  if (Tv(v[d >> 2], v[d + 8 >> 2])) {
   v[g >> 2] = 0;
   break a;
  }
  bZ(c + 16 | 0, c + 32 | 0);
  ic(c + 24 | 0, v[d >> 2], v[d + 8 >> 2], v[c + 16 >> 2], v[c + 20 >> 2]);
  h = v[c + 28 >> 2];
  i = w[c + 32 | 0];
  f = i & 127;
  v[g >> 2] = f;
  a = f;
  b = 0;
  while (1) {
   if (a) {
    b = b + 1 | 0;
    a = a >>> 1 | 0;
    continue;
   }
   break;
  }
  a = b;
  e = 1;
  while (1) {
   b = (B(h, 7) + a | 0) + B(e, -7) | 0;
   b: {
    while (1) {
     if (i << 24 >> 24 >= 0 | e >>> 0 >= h >>> 0) {
      break b;
     }
     j = c + 32 | 0;
     i = w[j + e | 0];
     f = i & 127 | f << 7;
     v[g >> 2] = f;
     a = a + 7 | 0;
     e = e + 1 | 0;
     if ((h | 0) != (e | 0)) {
      continue;
     }
     break;
    }
    Ub(d, h);
    bZ(c + 8 | 0, j);
    ic(c + 24 | 0, v[d >> 2], v[d + 8 >> 2], v[c + 8 >> 2], v[c + 12 >> 2]);
    h = v[c + 28 >> 2];
    f = v[g >> 2];
    e = 0;
    a = b;
    continue;
   }
   break;
  }
  Ub(d, e);
  if (a >>> 0 < 33) {
   break a;
  }
  v[g >> 2] = -1;
 }
 eb = c + 48 | 0;
}

function z8(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0;
 c = eb - 32 | 0;
 eb = c;
 a: {
  if (lc(b, -1)) {
   e = b;
   if (w[a + 52 | 0]) {
    break a;
   }
   e = v[a + 48 >> 2];
   f = a, g = lc(e, -1) ^ 1, t[f + 52 | 0] = g;
   break a;
  }
  b: {
   e = w[a + 52 | 0];
   if (!(!w[a + 53 | 0] | !e)) {
    e = -1;
    if (!IK(v[a + 48 >> 2], v[a + 32 >> 2])) {
     break a;
    }
    break b;
   }
   if (!e) {
    break b;
   }
   t[c + 19 | 0] = v[a + 48 >> 2] << 24 >> 24;
   e = -1;
   c: {
    d: {
     d = c + 20 | 0;
     switch (or(v[a + 36 >> 2], v[a + 40 >> 2], c + 19 | 0, d, c + 12 | 0, c + 24 | 0, c + 32 | 0, d) - 1 | 0) {
     case 0:
     case 1:
      break a;

     case 2:
      break d;

     default:
      break c;
     }
    }
    d = v[a + 48 >> 2];
    v[c + 20 >> 2] = c + 25;
    t[c + 24 | 0] = d;
   }
   while (1) {
    d = v[c + 20 >> 2];
    if (d >>> 0 <= c + 24 >>> 0) {
     break b;
    }
    d = d - 1 | 0;
    v[c + 20 >> 2] = d;
    if ((eo(t[d | 0], v[a + 32 >> 2]) | 0) != -1) {
     continue;
    }
    break;
   }
   break a;
  }
  t[a + 52 | 0] = 1;
  v[a + 48 >> 2] = b;
  e = b;
 }
 eb = c + 32 | 0;
 return e | 0;
}

function D8(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0;
 c = eb - 32 | 0;
 eb = c;
 a: {
  b: {
   c: {
    if (lc(b, -1)) {
     break c;
    }
    e = b << 24 >> 24;
    t[c + 23 | 0] = e;
    if (w[a + 44 | 0]) {
     d = -1;
     f = v[a + 32 >> 2];
     a = eb - 16 | 0;
     eb = a;
     t[a + 15 | 0] = e;
     e = gm(a + 15 | 0, 1, 1, f);
     eb = a + 16 | 0;
     if ((e | 0) == 1) {
      break c;
     }
     break a;
    }
    f = c + 24 | 0;
    v[c + 16 >> 2] = f;
    h = c + 32 | 0;
    d = c + 23 | 0;
    while (1) {
     e = or(v[a + 36 >> 2], v[a + 40 >> 2], d, f, c + 12 | 0, c + 24 | 0, h, c + 16 | 0);
     if (v[c + 12 >> 2] == (d | 0)) {
      break b;
     }
     if ((e | 0) == 3) {
      if ((gm(d, 1, 1, v[a + 32 >> 2]) | 0) == 1) {
       break c;
      }
      break b;
     }
     if (e >>> 0 > 1) {
      break b;
     }
     g = c + 24 | 0;
     d = v[c + 16 >> 2] - g | 0;
     if ((gm(g, 1, d, v[a + 32 >> 2]) | 0) != (d | 0)) {
      break b;
     }
     d = v[c + 12 >> 2];
     if ((e | 0) == 1) {
      continue;
     }
     break;
    }
   }
   d = Ry(b);
   break a;
  }
  d = -1;
 }
 eb = c + 32 | 0;
 return d | 0;
}

function Fma(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0;
 b = eb - 16 | 0;
 eb = b;
 i = v[a + 24 >> 2];
 j = v[a + 20 >> 2];
 k = v[a + 16 >> 2];
 e = v[a + 4 >> 2];
 v[b + 8 >> 2] = v[a >> 2];
 v[b + 12 >> 2] = e;
 l = v[a + 8 >> 2];
 m = v[a + 12 >> 2];
 while (1) {
  if (d) {
   e = v[b + 8 >> 2];
   h = ((((v[b + 12 >> 2] & 2147483647) << 1 | e >>> 31) & 2147483646) << 1) + k | 0;
   e = e >>> 21 & 2040;
   n = u[e + 38054 >> 1];
   o = u[e + 38052 >> 1];
   p = u[e + 38050 >> 1];
   q = u[e + 38048 >> 1];
   f = 0;
   while (1) {
    if ((f | 0) != 2) {
     e = f << 1;
     g = e + h | 0;
     v[(f << 2) + b >> 2] = (((B(u[g >> 1], p) + B(u[(e | -4) + h >> 1], q) | 0) + B(u[g + 4 >> 1], o) | 0) + B(u[g + 8 >> 1], n) | 0) / 16384;
     f = f + 1 | 0;
     continue;
    }
    break;
   }
   v[c >> 2] = v[c >> 2] + B(v[b >> 2], j);
   v[c + 4 >> 2] = v[c + 4 >> 2] + B(v[b + 4 >> 2], i);
   Ob(b + 8 | 0, l, m);
   c = c + 8 | 0;
   d = d - 1 | 0;
   continue;
  }
  break;
 }
 c = v[b + 12 >> 2];
 v[a >> 2] = v[b + 8 >> 2];
 v[a + 4 >> 2] = c;
 eb = b + 16 | 0;
}

function _S(a, b, c, d, e) {
 var f = 0, g = 0, h = 0, i = 0;
 a: {
  b: {
   c: {
    if (t[b + 851 | 0] & 1) {
     f = w[b + 848 | 0];
     g = c & 240;
     if (g) {
      f = f & 15 | g;
      t[b + 848 | 0] = f;
     }
     c = c & 15;
     if (c) {
      f = c | f & -16;
      t[b + 848 | 0] = f;
     }
     t[b + 849 | 0] = (f & 240) >>> 4;
     if (v[a + 480180 >> 2] != 32768) {
      break a;
     }
     break c;
    }
    if (v[a + 480180 >> 2] == 32768) {
     break c;
    }
    c = w[b + 849 | 0] - 1 | 0;
    t[b + 849 | 0] = c;
    if (c & 255) {
     break a;
    }
    f = w[b + 848 | 0];
    break b;
   }
   f = w[b + 848 | 0];
   if ((f & 240) == 16) {
    break b;
   }
   if (!(w[a + 480209 | 0] & 16)) {
    break a;
   }
  }
  t[b + 849 | 0] = (f & 240) >>> 4;
  c = f & 15;
  c = d ? c : 0 - c | 0;
  d = v[b + 656 >> 2];
  d: {
   if (Jj(d)) {
    v[b + 852 >> 2] = v[b + 852 >> 2] + B(c, v[v[d + 44 >> 2] + 36 >> 2]);
    break d;
   }
   h = b, i = yh(a, Lu(a, v[b + 700 >> 2], u[b + 772 >> 1], v[b + 704 >> 2]) + c | 0, u[b + 772 >> 1], v[b + 704 >> 2]), 
   v[h + 700 >> 2] = i;
  }
  if (!e) {
   break a;
  }
  v[b >> 2] = 0;
  v[b + 4 >> 2] = 0;
 }
}

function Hoa(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0;
 e = eb - 160 | 0;
 eb = e;
 b = -1;
 a: {
  if (!um(a, 80)) {
   break a;
  }
  b: {
   c: {
    if (!Ul(a, 60)) {
     break c;
    }
    d = e + 140 | 0;
    if (!KW(a, d)) {
     break c;
    }
    c = 15;
    if (zv(d, 15)) {
     break b;
    }
   }
   if (!um(a, 144)) {
    break a;
   }
   b = 0;
   if (!Ul(a, 124)) {
    break a;
   }
   d = e + 140 | 0;
   if (!KW(a, d)) {
    break a;
   }
   c = 31;
   if (!zv(d, 31)) {
    break a;
   }
  }
  uE(a);
  b = 0;
  d: {
   while (1) {
    if ((b & 65535) >>> 0 >= c >>> 0) {
     break d;
    }
    b = b + 1 | 0;
    if (IW(a) >>> 0 <= 131072) {
     continue;
    }
    break;
   }
   b = 0;
   break a;
  }
  b = -1;
  if (!hd(a, B(c, 30) | 20)) {
   break a;
  }
  c = eb - 16 | 0;
  eb = c;
  f = e + 10 | 0;
  XC(c + 8 | 0, f);
  d = v[c + 12 >> 2];
  pd(c, a, v[c + 8 >> 2], v[c + 12 >> 2]);
  g = v[c + 4 >> 2];
  if ((d | 0) == (g | 0)) {
   hd(a, v[c + 12 >> 2]);
  }
  eb = c + 16 | 0;
  a = (d | 0) == (g | 0);
  if (!a) {
   NC(f);
  }
  if (!a) {
   break a;
  }
  b = JW(w[e + 10 | 0]);
 }
 eb = e + 160 | 0;
 return b | 0;
}

function foa(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0;
 e = eb - 16 | 0;
 eb = e;
 i = e, j = Pj(b), v[i + 4 >> 2] = j;
 d = eb - 16 | 0;
 eb = d;
 h = a;
 c = ce(a);
 a: {
  if (c) {
   f = fc(a);
   while (1) {
    a = c;
    c = a + 13 | 0;
    if (pv(b, c)) {
     f = a;
     c = v[a >> 2];
     if (c) {
      continue;
     }
     break a;
    }
    if (!pv(c, b)) {
     break a;
    }
    f = a + 4 | 0;
    c = v[a + 4 >> 2];
    if (c) {
     continue;
    }
    break;
   }
   break a;
  }
  a = fc(h);
  f = a;
 }
 v[d + 12 >> 2] = a;
 b = v[f >> 2];
 if (!b) {
  c = eb - 16 | 0;
  eb = c;
  a = fc(h);
  g = Ch(d, Dc(20), Ng(c + 8 | 0, a));
  b = v[g >> 2];
  a = v[e + 4 >> 2];
  a = w[a | 0] | w[a + 1 | 0] << 8 | (w[a + 2 | 0] << 16 | w[a + 3 | 0] << 24);
  t[b + 17 | 0] = 0;
  t[b + 13 | 0] = a;
  t[b + 14 | 0] = a >>> 8;
  t[b + 15 | 0] = a >>> 16;
  t[b + 16 | 0] = a >>> 24;
  i = fc(g), j = 1, t[i + 4 | 0] = j;
  eb = c + 16 | 0;
  _g(h, v[d + 12 >> 2], f, v[d >> 2]);
  b = me(d);
  Gk(d);
  g = 1;
 }
 Zg(e + 8 | 0, v[ub(d, b) >> 2], g);
 eb = d + 16 | 0;
 eb = e + 16 | 0;
 return v[e + 8 >> 2] + 17 | 0;
}

function uq(a) {
 var b = C(0), c = 0, d = 0, e = 0, f = 0;
 f = eb - 16 | 0;
 eb = f;
 e = (q(a), j(2));
 c = e & 2147483647;
 a: {
  if (c >>> 0 <= 1061752794) {
   b = C(1);
   if (c >>> 0 < 964689920) {
    break a;
   }
   b = xi(+a);
   break a;
  }
  if (c >>> 0 <= 1081824209) {
   if (c >>> 0 >= 1075235812) {
    b = C(-xi(((e | 0) < 0 ? 3.141592653589793 : -3.141592653589793) + +a));
    break a;
   }
   d = +a;
   if ((e | 0) < 0) {
    b = yi(d + 1.5707963267948966);
    break a;
   }
   b = yi(1.5707963267948966 - d);
   break a;
  }
  if (c >>> 0 <= 1088565717) {
   if (c >>> 0 >= 1085271520) {
    b = xi(((e | 0) < 0 ? 6.283185307179586 : -6.283185307179586) + +a);
    break a;
   }
   if ((e | 0) < 0) {
    b = yi(-4.71238898038469 - +a);
    break a;
   }
   b = yi(+a + -4.71238898038469);
   break a;
  }
  b = C(a - a);
  if (c >>> 0 >= 2139095040) {
   break a;
  }
  c = _y(a, f + 8 | 0);
  d = A[f + 8 >> 3];
  b: {
   switch (c & 3) {
   case 0:
    b = xi(d);
    break a;

   case 1:
    b = yi(-d);
    break a;

   case 2:
    b = C(-xi(d));
    break a;

   default:
    break b;
   }
  }
  b = yi(d);
 }
 a = b;
 eb = f + 16 | 0;
 return a;
}

function Vra(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0;
 c = v[a >> 2];
 d = Br(c, v[a + 4 >> 2]);
 if (d >>> 0 < b >>> 0) {
  f = eb - 32 | 0;
  eb = f;
  c = b - d | 0;
  b = v[zb(a) >> 2];
  e = v[a + 4 >> 2];
  a: {
   if (c >>> 0 <= (b - e | 0) / 40 >>> 0) {
    d = eb - 16 | 0;
    eb = d;
    b = q$(d + 4 | 0, a, c);
    a = v[b + 4 >> 2];
    c = v[b + 8 >> 2];
    while (1) {
     if ((a | 0) == (c | 0)) {
      hc(b);
      eb = d + 16 | 0;
     } else {
      ZY(a);
      a = a + 40 | 0;
      v[b + 4 >> 2] = a;
      continue;
     }
     break;
    }
    break a;
   }
   b = zb(a);
   d = n$(f + 12 | 0, o$(a, Br(v[a >> 2], e) + c | 0), Br(v[a >> 2], v[a + 4 >> 2]), b);
   e = eb - 16 | 0;
   eb = e;
   g = v[d + 8 >> 2];
   b = e + 4 | 0;
   v[b + 8 >> 2] = d + 8;
   v[b >> 2] = g;
   v[b + 4 >> 2] = B(c, 40) + g;
   c = v[b >> 2];
   while (1) {
    if (v[b + 4 >> 2] != (c | 0)) {
     ZY(c);
     c = v[b >> 2] + 40 | 0;
     v[b >> 2] = c;
     continue;
    }
    break;
   }
   ie(b);
   eb = e + 16 | 0;
   m$(a, d);
   l$(d);
  }
  eb = f + 32 | 0;
  return;
 }
 if (b >>> 0 < d >>> 0) {
  Id(a, c + B(b, 40) | 0);
 }
}

function Mt(a, b, c, d, e, f, g) {
 var h = 0, i = 0, j = 0, k = 0, l = 0, m = 0;
 h = eb - 240 | 0;
 eb = h;
 v[h + 236 >> 2] = d;
 v[h + 232 >> 2] = c;
 v[h >> 2] = a;
 m = !f;
 a: {
  b: {
   c: {
    d: {
     if ((c | 0) != 1) {
      i = a;
      j = 1;
      break d;
     }
     i = a;
     j = 1;
     if (d) {
      break d;
     }
     f = a;
     break c;
    }
    while (1) {
     k = (e << 2) + g | 0;
     f = i - v[k >> 2] | 0;
     if ((mo(f, a, b) | 0) <= 0) {
      f = i;
      break c;
     }
     l = m ^ -1;
     m = 1;
     e: {
      if (!((l | (e | 0) < 2) & 1)) {
       k = v[k - 8 >> 2];
       l = i - 4 | 0;
       if ((mo(l, f, b) | 0) >= 0) {
        break e;
       }
       if ((mo(l - k | 0, f, b) | 0) >= 0) {
        break e;
       }
      }
      v[(j << 2) + h >> 2] = f;
      c = yL(c, d);
      Nt(h + 232 | 0, c);
      j = j + 1 | 0;
      e = c + e | 0;
      i = f;
      d = v[h + 236 >> 2];
      c = v[h + 232 >> 2];
      if (d | (c | 0) != 1) {
       continue;
      }
      break b;
     }
     break;
    }
    f = i;
    break b;
   }
   if (!m) {
    break a;
   }
  }
  xL(h, j);
  bz(f, b, e, g);
 }
 eb = h + 240 | 0;
}

function G8(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0;
 c = eb - 32 | 0;
 eb = c;
 a: {
  if (jo(b)) {
   e = b;
   if (w[a + 52 | 0]) {
    break a;
   }
   e = v[a + 48 >> 2];
   f = a, g = jo(e) ^ 1, t[f + 52 | 0] = g;
   break a;
  }
  b: {
   e = w[a + 52 | 0];
   if (!(!w[a + 53 | 0] | !e)) {
    e = -1;
    if (!KK(v[a + 48 >> 2], v[a + 32 >> 2])) {
     break a;
    }
    break b;
   }
   if (!e) {
    break b;
   }
   v[c + 16 >> 2] = v[a + 48 >> 2];
   e = -1;
   c: {
    d: {
     d = c + 20 | 0;
     switch (or(v[a + 36 >> 2], v[a + 40 >> 2], c + 16 | 0, d, c + 12 | 0, c + 24 | 0, c + 32 | 0, d) - 1 | 0) {
     case 0:
     case 1:
      break a;

     case 2:
      break d;

     default:
      break c;
     }
    }
    d = v[a + 48 >> 2];
    v[c + 20 >> 2] = c + 25;
    t[c + 24 | 0] = d;
   }
   while (1) {
    d = v[c + 20 >> 2];
    if (d >>> 0 <= c + 24 >>> 0) {
     break b;
    }
    d = d - 1 | 0;
    v[c + 20 >> 2] = d;
    if ((eo(t[d | 0], v[a + 32 >> 2]) | 0) != -1) {
     continue;
    }
    break;
   }
   break a;
  }
  t[a + 52 | 0] = 1;
  v[a + 48 >> 2] = b;
  e = b;
 }
 eb = c + 32 | 0;
 return e | 0;
}

function L8(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0;
 c = eb - 32 | 0;
 eb = c;
 a: {
  b: {
   c: {
    if (jo(b)) {
     break c;
    }
    v[c + 20 >> 2] = b;
    if (w[a + 44 | 0]) {
     d = -1;
     a = v[a + 32 >> 2];
     d: {
      if (v[a + 76 >> 2] < 0) {
       a = FK(b, a);
       break d;
      }
      a = FK(b, a);
     }
     if ((a | 0) != -1) {
      break c;
     }
     break a;
    }
    f = c + 24 | 0;
    v[c + 16 >> 2] = f;
    h = c + 32 | 0;
    d = c + 20 | 0;
    while (1) {
     e = or(v[a + 36 >> 2], v[a + 40 >> 2], d, f, c + 12 | 0, c + 24 | 0, h, c + 16 | 0);
     if (v[c + 12 >> 2] == (d | 0)) {
      break b;
     }
     if ((e | 0) == 3) {
      if ((gm(d, 1, 1, v[a + 32 >> 2]) | 0) == 1) {
       break c;
      }
      break b;
     }
     if (e >>> 0 > 1) {
      break b;
     }
     g = c + 24 | 0;
     d = v[c + 16 >> 2] - g | 0;
     if ((gm(g, 1, d, v[a + 32 >> 2]) | 0) != (d | 0)) {
      break b;
     }
     d = v[c + 12 >> 2];
     if ((e | 0) == 1) {
      continue;
     }
     break;
    }
   }
   d = jo(b) ? 0 : b;
   break a;
  }
  d = -1;
 }
 eb = c + 32 | 0;
 return d | 0;
}

function iqa(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = C(0), g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
 c = eb - 16 | 0;
 eb = c;
 a: {
  b: {
   d = v[b + 8 >> 2];
   if ((d | 0) == v[a + 8 >> 2]) {
    e = v[b + 4 >> 2];
    if ((e | 0) != v[a + 4 >> 2]) {
     break b;
    }
    v[c + 12 >> 2] = d;
    v[c + 8 >> 2] = d;
    d = v[Gb(c + 12 | 0, c + 8 | 0) >> 2];
    v[c + 12 >> 2] = e;
    v[c + 8 >> 2] = e;
    h = v[Gb(c + 12 | 0, c + 8 | 0) >> 2];
    i = v[a >> 2];
    j = v[b >> 2];
    b = 0;
    c: while (1) {
     if ((b | 0) == (d | 0)) {
      break a;
     }
     k = (B(b, e) << 1) + i | 0;
     a = 0;
     while (1) if ((a | 0) == (h | 0)) {
      b = b + 1 | 0;
      continue c;
     } else {
      l = (a << 1) + k | 0;
      f = ki(C(Od(z[v[(a << 2) + j >> 2] + (b << 2) >> 2], C(-1)) * C(32768)));
      d: {
       if (C(D(f)) < C(2147483648)) {
        g = ~~f;
        break d;
       }
       g = -2147483648;
      }
      m = l, n = fd(g), u[m >> 1] = n;
      a = a + 1 | 0;
      continue;
     }
    }
   }
   Z(17351, 8983, 27, 9525);
   p();
  }
  Z(17301, 8983, 28, 9525);
  p();
 }
 eb = c + 16 | 0;
}

function Eka(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0;
 g = eb - 16 | 0;
 eb = g;
 e = Jb(b);
 d = Cb(v[b + 4 >> 2], w[b + 11 | 0]);
 i = Jb(c);
 j = Cb(v[c + 4 >> 2], w[c + 11 | 0]);
 f = -1;
 a: {
  if (!d) {
   break a;
  }
  h = d + e | 0;
  d = e;
  while (1) {
   if ((d | 0) == (h | 0)) {
    break a;
   }
   if (sq(i, j, w[d | 0])) {
    d = d + 1 | 0;
    continue;
   }
   break;
  }
  f = d - e | 0;
 }
 b: {
  c: {
   if ((f | 0) != -1) {
    c = ub(g + 12 | 0, yd(b));
    d = ub(g + 8 | 0, Pe(yd(b), f));
    $r(b, v[c >> 2], v[d >> 2]);
    break c;
   }
   f = Zc(v[b + 4 >> 2], w[b + 11 | 0]);
   if (!f) {
    break c;
   }
   e = Jb(b);
   i = Cb(v[b + 4 >> 2], w[b + 11 | 0]);
   j = Jb(c);
   d = -1;
   h = Cb(v[c + 4 >> 2], w[c + 11 | 0]);
   if (h) {
    c = e + i | 0;
    d: {
     while (1) {
      if ((c | 0) == (e | 0)) {
       break d;
      }
      c = c - 1 | 0;
      if (!sq(j, h, w[c | 0])) {
       continue;
      }
      break;
     }
     d = c - e | 0;
    }
   }
   if ((f - 1 | 0) != (d | 0)) {
    break c;
   }
   Eb(a);
   break b;
  }
  Uc(a, b);
 }
 eb = g + 16 | 0;
}

function n2(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0;
 g = eb - 16 | 0;
 eb = g;
 e = Jb(b);
 d = Cb(v[b + 4 >> 2], w[b + 11 | 0]);
 i = Jb(c);
 j = Cb(v[c + 4 >> 2], w[c + 11 | 0]);
 f = -1;
 a: {
  if (!d) {
   break a;
  }
  h = d + e | 0;
  d = e;
  while (1) {
   if ((d | 0) == (h | 0)) {
    break a;
   }
   if (Du(i, j, w[d | 0])) {
    d = d + 1 | 0;
    continue;
   }
   break;
  }
  f = d - e | 0;
 }
 b: {
  c: {
   if ((f | 0) != -1) {
    c = ub(g + 12 | 0, yd(b));
    d = ub(g + 8 | 0, Pe(yd(b), f));
    $r(b, v[c >> 2], v[d >> 2]);
    break c;
   }
   f = Zc(v[b + 4 >> 2], w[b + 11 | 0]);
   if (!f) {
    break c;
   }
   e = Jb(b);
   i = Cb(v[b + 4 >> 2], w[b + 11 | 0]);
   j = Jb(c);
   d = -1;
   h = Cb(v[c + 4 >> 2], w[c + 11 | 0]);
   if (h) {
    c = e + i | 0;
    d: {
     while (1) {
      if ((c | 0) == (e | 0)) {
       break d;
      }
      c = c - 1 | 0;
      if (!Du(j, h, w[c | 0])) {
       continue;
      }
      break;
     }
     d = c - e | 0;
    }
   }
   if ((f - 1 | 0) != (d | 0)) {
    break c;
   }
   Eb(a);
   break b;
  }
  Uc(a, b);
 }
 eb = g + 16 | 0;
}

function bQ(a) {
 var b = 0, c = 0, d = 0, e = 0;
 e = eb - 16 | 0;
 eb = e;
 d = (q(a), j(2));
 c = d & 2147483647;
 a: {
  if (c >>> 0 <= 1061752794) {
   if (c >>> 0 < 964689920) {
    break a;
   }
   a = yi(+a);
   break a;
  }
  if (c >>> 0 <= 1081824209) {
   b = +a;
   if (c >>> 0 <= 1075235811) {
    if ((d | 0) < 0) {
     a = C(-xi(b + 1.5707963267948966));
     break a;
    }
    a = xi(b + -1.5707963267948966);
    break a;
   }
   a = yi(-(((d | 0) >= 0 ? -3.141592653589793 : 3.141592653589793) + b));
   break a;
  }
  if (c >>> 0 <= 1088565717) {
   if (c >>> 0 <= 1085271519) {
    b = +a;
    if ((d | 0) < 0) {
     a = xi(b + 4.71238898038469);
     break a;
    }
    a = C(-xi(b + -4.71238898038469));
    break a;
   }
   a = yi(((d | 0) < 0 ? 6.283185307179586 : -6.283185307179586) + +a);
   break a;
  }
  if (c >>> 0 >= 2139095040) {
   a = C(a - a);
   break a;
  }
  c = _y(a, e + 8 | 0);
  b = A[e + 8 >> 3];
  b: {
   switch (c & 3) {
   case 0:
    a = yi(b);
    break a;

   case 1:
    a = xi(b);
    break a;

   case 2:
    a = yi(-b);
    break a;

   default:
    break b;
   }
  }
  a = C(-xi(b));
 }
 eb = e + 16 | 0;
 return a;
}

function Noa(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0;
 f = eb - 32 | 0;
 eb = f;
 md(c, 2);
 t[f + 20 | 0] = w[b + 13 | 0];
 t[f + 8 | 0] = 64;
 d = f + 20 | 0;
 e = f + 8 | 0;
 i = c, j = w[Pb(d, e) | 0] << 2, u[i + 30 >> 1] = j;
 v[c + 24 >> 2] = (w[b + 14 | 0] | w[b + 15 | 0] << 8) << 1;
 Ik(e, 2, b + 1 | 0);
 Bc(d, e);
 Ae(c + 43 | 0, d);
 sb(d);
 d = Yc(a, 8, 1, 0, 2);
 a: {
  if ((w[b | 0] & 3) != 1) {
   break a;
  }
  g = w[b + 22 | 0] | w[b + 23 | 0] << 8 | (w[b + 24 | 0] << 16 | w[b + 25 | 0] << 24);
  v[c >> 2] = g;
  e = w[b + 26 | 0] | w[b + 27 | 0] << 8 | (w[b + 28 | 0] << 16 | w[b + 29 | 0] << 24);
  v[c + 4 >> 2] = e;
  a = w[b + 30 | 0] | w[b + 31 | 0] << 8 | (w[b + 32 | 0] << 16 | w[b + 33 | 0] << 24);
  h = a - (a >>> 0 > e >>> 0) | 0;
  v[c + 8 >> 2] = h;
  a = w[b | 0];
  if (a & 4) {
   u[c + 34 >> 1] = x[c + 34 >> 1] | 2;
   a = w[b | 0];
  }
  if (a & 8) {
   u[c + 34 >> 1] = x[c + 34 >> 1] | 4;
   a = w[b | 0];
  }
  if (!(a & 16)) {
   break a;
  }
  gd(d, 16);
  vg(d, 9);
  v[c + 8 >> 2] = h >>> 1;
  v[c + 4 >> 2] = e >>> 1;
  v[c >> 2] = g >>> 1;
 }
 eb = f + 32 | 0;
}

function GK(a, b, c) {
 var d = 0, e = 0;
 if (!b) {
  return 0;
 }
 a: {
  b: {
   if (!c) {
    break b;
   }
   d = w[b | 0];
   e = d << 24 >> 24;
   if ((e | 0) >= 0) {
    if (a) {
     v[a >> 2] = d;
    }
    return (e | 0) != 0;
   }
   if (!v[v[124107] >> 2]) {
    b = 1;
    if (!a) {
     break a;
    }
    v[a >> 2] = e & 57343;
    return 1;
   }
   d = d - 194 | 0;
   if (d >>> 0 > 50) {
    break b;
   }
   d = v[(d << 2) + 120672 >> 2];
   if (d << B(c, 6) - 6 < 0 & c >>> 0 <= 3) {
    break b;
   }
   c = w[b + 1 | 0];
   e = c >>> 3 | 0;
   if ((e - 16 | e + (d >> 26)) >>> 0 > 7) {
    break b;
   }
   c = c - 128 | d << 6;
   if ((c | 0) >= 0) {
    b = 2;
    if (!a) {
     break a;
    }
    v[a >> 2] = c;
    return 2;
   }
   d = w[b + 2 | 0] - 128 | 0;
   if (d >>> 0 > 63) {
    break b;
   }
   e = d;
   d = c << 6;
   c = e | d;
   if ((d | 0) >= 0) {
    b = 3;
    if (!a) {
     break a;
    }
    v[a >> 2] = c;
    return 3;
   }
   d = w[b + 3 | 0] - 128 | 0;
   if (d >>> 0 > 63) {
    break b;
   }
   b = 4;
   if (!a) {
    break a;
   }
   v[a >> 2] = d | c << 6;
   return 4;
  }
  v[31476] = 25;
  b = -1;
 }
 return b;
}

function Bfa(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0;
 d = eb - 32 | 0;
 eb = d;
 v[31601] = 0;
 V(995, a | 0);
 e = v[31601];
 v[31601] = 0;
 a: {
  b: {
   c: {
    if ((e | 0) == 1) {
     break c;
    }
    v[31601] = 0;
    V(996, b | 0);
    e = v[31601];
    v[31601] = 0;
    if ((e | 0) == 1) {
     break c;
    }
    v[31601] = 0;
    V(996, c | 0);
    f = v[31601];
    v[31601] = 0;
    e = 1;
    if ((f | 0) == 1) {
     break c;
    }
    f = v[a + 24 >> 2];
    b = oc(d + 24 | 0, b);
    c = oc(d + 16 | 0, c);
    g = v[c >> 2];
    c = v[c + 4 >> 2];
    v[31601] = 0;
    h = v[b + 4 >> 2];
    v[d + 8 >> 2] = v[b >> 2];
    v[d + 12 >> 2] = h;
    Ns(1017, f, d + 8 | 0, g, c, 1);
    b = v[31601];
    v[31601] = 0;
    if ((b | 0) != 1) {
     break b;
    }
   }
   X(S(0) | 0) | 0;
   v[31601] = 0;
   U(982, 5507, a | 0, 0, 0);
   a = v[31601];
   v[31601] = 0;
   if ((a | 0) == 1) {
    break a;
   }
   Y();
   e = 0;
  }
  eb = d + 32 | 0;
  return e | 0;
 }
 a = M() | 0;
 v[31601] = 0;
 W(26);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  P(a | 0);
  p();
 }
 S(0) | 0;
 Rb();
 p();
}

function gka(a) {
 a = a | 0;
 var b = 0, c = 0, d = 0;
 b = 1074992;
 while (1) {
  if ((b | 0) == 1298224) {
   Fu(a + 484344 | 0);
   sf(a + 1298308 | 0);
   sf(a + 1298320 | 0);
   sf(a + 1298332 | 0);
   Mc(a + 1298412 | 0);
   c = 484380;
   while (1) {
    a: {
     b = 900380;
     if ((c | 0) == 900380) {
      while (1) {
       if ((b | 0) == 901404) {
        b = a + 906300 | 0;
        c = tk(b);
        while (1) {
         if ((b | 0) == (c | 0)) {
          break a;
         }
         a0(b);
         b = b + 160 | 0;
         continue;
        }
       }
       c = a + b | 0;
       d = v[c >> 2];
       if (d) {
        Bb(Nv(d));
       }
       v[c >> 2] = 0;
       b = b + 4 | 0;
       continue;
      }
     } else {
      mn(a + c | 0);
      c = c + 104 | 0;
      continue;
     }
    }
    break;
   }
   v[a + 480180 >> 2] = 0;
   v[a + 480184 >> 2] = 0;
   a = a + 480186 | 0;
   u[a >> 1] = 0;
   u[a + 2 >> 1] = 0;
   u[a + 4 >> 1] = 0;
   u[a + 6 >> 1] = 0;
  } else {
   c = a + b | 0;
   v[c + 104 >> 2] = 0;
   v[c + 656 >> 2] = 0;
   v[c + 76 >> 2] = 0;
   v[c + 16 >> 2] = 0;
   b = b + 872 | 0;
   continue;
  }
  break;
 }
}

function Io(a, b, c) {
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0;
 a: {
  if (c) {
   t[b + 809 | 0] = c;
   break a;
  }
  c = w[b + 809 | 0];
 }
 e = v[a + 480180 >> 2];
 d = e & 202376205 ? c & 240 ? c & -16 : c : c;
 c = v[b + 688 >> 2];
 b: {
  if (e & 69206029) {
   break b;
  }
  g = d & 255;
  f = d & 15;
  if ((f | 0) == 15) {
   if (g >>> 0 >= 16) {
    Ho(a, b, (d & 240) >>> 4 | 0, 0);
    return;
   }
   if (!(t[b + 851 | 0] & 1)) {
    break b;
   }
   c = w[a + 480208 | 0] & 2 ? c : c - 60 | 0;
   break b;
  }
  if ((g & 240) != 240) {
   break b;
  }
  if (f) {
   Go(a, b, f, 0);
   return;
  }
  if (!(t[b + 851 | 0] & 1)) {
   break b;
  }
  c = w[a + 480208 | 0] & 2 ? c : c + 60 | 0;
 }
 c: {
  if (!(!(t[b + 851 | 0] & 1) | w[a + 480208 | 0] & 2) & (v[a + 1074416 >> 2] != 1 | (e | 0) != 524288)) {
   break c;
  }
  a = d & 15;
  d: {
   if (a) {
    if ((d & 255) >>> 0 > 15 ? e & 16777248 : 0) {
     break c;
    }
    c = c - (a << 2) | 0;
    break d;
   }
   c = ((d & 255) >>> 2 | 0) + c | 0;
  }
  if ((e | 0) != 1) {
   break c;
  }
  v[b + 88 >> 2] = v[b + 88 >> 2] | 2097152;
 }
 h = b, i = Xb(c, 0, 256), v[h + 688 >> 2] = i;
}

function tI(a, b, c, d, e, f) {
 var g = 0;
 g = eb - 80 | 0;
 eb = g;
 a: {
  if ((f | 0) >= 16384) {
   Wd(g + 32 | 0, b, c, d, e, 0, 0, 0, 2147352576);
   d = v[g + 40 >> 2];
   e = v[g + 44 >> 2];
   b = v[g + 32 >> 2];
   c = v[g + 36 >> 2];
   if (f >>> 0 < 32767) {
    f = f - 16383 | 0;
    break a;
   }
   Wd(g + 16 | 0, b, c, d, e, 0, 0, 0, 2147352576);
   f = ((f | 0) >= 49149 ? 49149 : f) - 32766 | 0;
   d = v[g + 24 >> 2];
   e = v[g + 28 >> 2];
   b = v[g + 16 >> 2];
   c = v[g + 20 >> 2];
   break a;
  }
  if ((f | 0) > -16383) {
   break a;
  }
  Wd(g - -64 | 0, b, c, d, e, 0, 0, 0, 7471104);
  d = v[g + 72 >> 2];
  e = v[g + 76 >> 2];
  b = v[g + 64 >> 2];
  c = v[g + 68 >> 2];
  if (f >>> 0 > 4294934644) {
   f = f + 16269 | 0;
   break a;
  }
  Wd(g + 48 | 0, b, c, d, e, 0, 0, 0, 7471104);
  f = ((f | 0) <= -48920 ? -48920 : f) + 32538 | 0;
  d = v[g + 56 >> 2];
  e = v[g + 60 >> 2];
  b = v[g + 48 >> 2];
  c = v[g + 52 >> 2];
 }
 Wd(g, b, c, d, e, 0, 0, 0, f + 16383 << 16);
 b = v[g + 12 >> 2];
 v[a + 8 >> 2] = v[g + 8 >> 2];
 v[a + 12 >> 2] = b;
 b = v[g + 4 >> 2];
 v[a >> 2] = v[g >> 2];
 v[a + 4 >> 2] = b;
 eb = g + 80 | 0;
}

function Gma(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0;
 b = eb - 16 | 0;
 eb = b;
 h = v[a + 24 >> 2];
 i = v[a + 20 >> 2];
 j = v[a + 16 >> 2];
 e = v[a + 4 >> 2];
 v[b + 8 >> 2] = v[a >> 2];
 v[b + 12 >> 2] = e;
 k = v[a + 8 >> 2];
 l = v[a + 12 >> 2];
 while (1) {
  if (d) {
   e = v[b + 8 >> 2];
   m = (((v[b + 12 >> 2] & 2147483647) << 1 | e >>> 31) & -2) + j | 0;
   e = e >>> 21 & 2040;
   n = u[e + 38050 >> 1] << 8;
   o = u[e + 38048 >> 1] << 8;
   p = u[e + 38052 >> 1] << 8;
   e = u[e + 38054 >> 1] << 8;
   f = 0;
   while (1) {
    if ((f | 0) != 2) {
     g = f + m | 0;
     v[(f << 2) + b >> 2] = (((B(t[g | 0], n) + B(t[g - 2 | 0], o) | 0) + B(t[g + 2 | 0], p) | 0) + B(t[g + 4 | 0], e) | 0) / 16384;
     f = f + 1 | 0;
     continue;
    }
    break;
   }
   v[c >> 2] = v[c >> 2] + B(v[b >> 2], i);
   v[c + 4 >> 2] = v[c + 4 >> 2] + B(v[b + 4 >> 2], h);
   Ob(b + 8 | 0, k, l);
   c = c + 8 | 0;
   d = d - 1 | 0;
   continue;
  }
  break;
 }
 c = v[b + 12 >> 2];
 v[a >> 2] = v[b + 8 >> 2];
 v[a + 4 >> 2] = c;
 eb = b + 16 | 0;
}

function mq(a) {
 var b = 0, c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, k = 0, m = 0;
 o(+a);
 b = j(1) | 0;
 e = j(0) | 0;
 a: {
  b: {
   c: {
    if (!(((b | 0) > 0 | (b | 0) >= 0) & b >>> 0 > 1048575)) {
     if (a == 0) {
      return -1 / (a * a);
     }
     if ((b | 0) > 0 | (b | 0) >= 0) {
      break c;
     }
     return (a - a) / 0;
    }
    if (b >>> 0 > 2146435071) {
     break a;
    }
    f = 1072693248;
    g = -1023;
    if ((b | 0) != 1072693248) {
     f = b;
     break b;
    }
    if (e) {
     break b;
    }
    return 0;
   }
   o(+(a * 0x40000000000000));
   b = j(1) | 0;
   e = j(0) | 0;
   f = b;
   g = -1077;
  }
  b = f + 614242 | 0;
  h = +((b >>> 20 | 0) + g | 0);
  d = h * .6931471803691238;
  l(0, e | 0);
  l(1, (b & 1048575) + 1072079006 | 0);
  a = +n() + -1;
  c = a / (a + 2);
  i = d;
  k = a;
  m = c;
  d = a * (a * .5);
  c = c * c;
  a = c * c;
  a = i + (k + (m * (d + (a * (a * (a * .15313837699209373 + .22222198432149784) + .3999999999940942) + c * (a * (a * (a * .14798198605116586 + .1818357216161805) + .2857142874366239) + .6666666666666735))) + h * 1.9082149292705877e-10 - d));
 }
 return a;
}

function aS(a, b) {
 var c = C(0), d = C(0), e = C(0);
 a: {
  b: {
   c: {
    switch (b | 0) {
    case 0:
     Bq(a, C(1));
     sk(a, C(3.725290298461914e-9));
     Aq(a, C(268435456));
     zq(a, 0);
     break b;

    case 1:
     Bq(a, C(32));
     sk(a, C(4.656612873077393e-10));
     Aq(a, C(2147483648));
     zq(a, 0);
     break b;

    case 2:
     Bq(a, C(2));
     sk(a, C(7.450580596923828e-9));
     Aq(a, C(134217728));
     zq(a, 1);
     break b;

    default:
     Bq(a, C(1));
     sk(a, C(7.450580596923828e-9));
     Aq(a, C(134217728));
     zq(a, 1);
     HA(a, 0);
     GA(a, 1);
     FA(a, 1);
     d = C(256);
     c = C(128);
     e = C(128);
     b = 0;
     break a;

    case 4:
    case 5:
     break c;
    }
   }
   Bq(a, C(.75));
   sk(a, C(7.450580596923828e-9));
   Aq(a, C(134217728));
   zq(a, 1);
   HA(a, 0);
   b = (b | 0) == 4;
   GA(a, b ? 2 : 3);
   FA(a, 1);
   d = C(256);
   c = b ? C(256) : C(192);
   e = c;
   b = 1;
   break a;
  }
  HA(a, 1);
  GA(a, 0);
  FA(a, 0);
  d = C(128);
  e = C(100);
  c = C(256);
  b = 4;
 }
 z[a + 16 >> 2] = c;
 z[a + 20 >> 2] = e;
 z[a + 24 >> 2] = d;
 v[a + 28 >> 2] = b;
}

function Tz(a, b) {
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0;
 c = eb - 16 | 0;
 eb = c;
 v[c >> 2] = a;
 v[c + 4 >> 2] = b;
 v[c + 8 >> 2] = a;
 v[c + 12 >> 2] = b;
 b = eb + -64 | 0;
 eb = b;
 a: {
  if (!v[c + 4 >> 2]) {
   break a;
  }
  a = v[c >> 2];
  h = v[c + 4 >> 2];
  while (1) {
   if ((e | 0) == 432) {
    while (1) {
     e = (g | 0) != 48;
     if ((g | 0) == 48) {
      break a;
     }
     v[b + 40 >> 2] = a;
     v[b + 44 >> 2] = h;
     f = oc(b + 32 | 0, v[g + 30968 >> 2]);
     d = v[b + 44 >> 2];
     v[b + 8 >> 2] = v[b + 40 >> 2];
     v[b + 12 >> 2] = d;
     d = v[f + 4 >> 2];
     v[b >> 2] = v[f >> 2];
     v[b + 4 >> 2] = d;
     g = g + 12 | 0;
     if (!AR(b + 8 | 0, b)) {
      continue;
     }
     break a;
    }
   }
   v[b + 56 >> 2] = a;
   v[b + 60 >> 2] = h;
   f = oc(b + 48 | 0, v[e + 30532 >> 2]);
   d = v[b + 60 >> 2];
   v[b + 24 >> 2] = v[b + 56 >> 2];
   v[b + 28 >> 2] = d;
   d = v[f + 4 >> 2];
   v[b + 16 >> 2] = v[f >> 2];
   v[b + 20 >> 2] = d;
   e = e + 8 | 0;
   if (!AR(b + 24 | 0, b + 16 | 0)) {
    continue;
   }
   break;
  }
  e = 1;
 }
 eb = b - -64 | 0;
 eb = c + 16 | 0;
 return e;
}

function rU(a, b) {
 a = a | 0;
 b = +b;
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
 j = av(b);
 e = eb - 16 | 0;
 eb = e;
 v[a >> 2] = 0;
 v[a + 4 >> 2] = 0;
 sc(a + 8 | 0);
 h = e + 8 | 0;
 Qd(h, v[ub(e + 4 | 0, a) >> 2]);
 v[31601] = 0;
 N(798, a | 0, 2048);
 d = v[31601];
 v[31601] = 0;
 a: {
  if ((d | 0) != 1) {
   i = eb - 16 | 0;
   eb = i;
   g = hs(i + 4 | 0, a, 2048);
   d = v[g + 4 >> 2];
   k = v[g + 8 >> 2];
   while (1) {
    if ((d | 0) == (k | 0)) {
     hc(g);
     eb = i + 16 | 0;
    } else {
     v[d >> 2] = 0;
     v[d + 4 >> 2] = 0;
     d = d + 8 | 0;
     v[g + 4 >> 2] = d;
     continue;
    }
    break;
   }
   Pd(h);
   $u(h);
   eb = e + 16 | 0;
   break a;
  }
  a = M() | 0;
  $u(e + 8 | 0);
  P(a | 0);
  p();
 }
 while (1) {
  b: {
   c = 1;
   if ((f | 0) != 1024) {
    if ((f | 0) == 2048) {
     break b;
    }
    c = +(f - 1024 | 0);
    l = av(K(c * c * -9.5367431640625e-7 + 1) * b);
    c = c * .0372006759294457;
    c = l * Oi(c) / (j * c);
   }
   m = Se(v[a >> 2], f), n = c * .011841342921061943, A[m >> 3] = n;
   f = f + 1 | 0;
   continue;
  }
  break;
 }
}

function Lka(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0;
 f = eb - 80 | 0;
 eb = f;
 d = Qf(f + 52 | 0);
 v[31601] = 0;
 c = O(826, b | 0, d | 0) | 0;
 e = v[31601];
 v[31601] = 0;
 a: {
  b: {
   c: {
    if ((e | 0) != 1) {
     if (c) {
      break c;
     }
     v[a >> 2] = 0;
     v[a + 4 >> 2] = 0;
     v[a + 24 >> 2] = 0;
     v[a + 16 >> 2] = 0;
     v[a + 20 >> 2] = 0;
     v[a + 8 >> 2] = 0;
     v[a + 12 >> 2] = 0;
     v[31601] = 0;
     Q(827, a | 0) | 0;
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) != 1) {
      break b;
     }
    }
    break a;
   }
   e = v[d + 4 >> 2];
   v[31601] = 0;
   c = f + 12 | 0;
   e = _b(e);
   R(185, c | 0, b | 0, e | 0);
   g = v[31601];
   v[31601] = 0;
   if ((g | 0) == 1) {
    break a;
   }
   g = gc(f + 32 | 0, c);
   jd(d + 8 | 0, g);
   tb(g);
   tb(c);
   d: {
    c = e & 1;
    if (!c) {
     break d;
    }
    v[31601] = 0;
    O(183, b | 0, 2 - c | 0) | 0;
    b = v[31601];
    v[31601] = 0;
    if ((b | 0) != 1) {
     break d;
    }
    break a;
   }
   Lk(a, d);
  }
  Gd(d);
  eb = f + 80 | 0;
  return;
 }
 a = M() | 0;
 Gd(d);
 P(a | 0);
 p();
}

function hqa(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = C(0), g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
 c = eb - 16 | 0;
 eb = c;
 a: {
  b: {
   d = v[b + 8 >> 2];
   if ((d | 0) == v[a + 8 >> 2]) {
    e = v[b + 4 >> 2];
    if ((e | 0) != v[a + 4 >> 2]) {
     break b;
    }
    v[c + 12 >> 2] = d;
    v[c + 8 >> 2] = d;
    d = v[Gb(c + 12 | 0, c + 8 | 0) >> 2];
    v[c + 12 >> 2] = e;
    v[c + 8 >> 2] = e;
    h = v[Gb(c + 12 | 0, c + 8 | 0) >> 2];
    i = v[a >> 2];
    j = v[b >> 2];
    b = 0;
    c: while (1) {
     if ((b | 0) == (d | 0)) {
      break a;
     }
     k = B(b, e) + i | 0;
     a = 0;
     while (1) if ((a | 0) == (h | 0)) {
      b = b + 1 | 0;
      continue c;
     } else {
      l = a + k | 0;
      f = ki(C(Od(z[v[(a << 2) + j >> 2] + (b << 2) >> 2], C(-1)) * C(128)));
      d: {
       if (C(D(f)) < C(2147483648)) {
        g = ~~f;
        break d;
       }
       g = -2147483648;
      }
      m = l, n = bY(g), t[m | 0] = n;
      a = a + 1 | 0;
      continue;
     }
    }
   }
   Z(17351, 8983, 27, 9525);
   p();
  }
  Z(17301, 8983, 28, 9525);
  p();
 }
 eb = c + 16 | 0;
}

function mja(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0;
 e = eb - 80 | 0;
 eb = e;
 d = Qf(e + 52 | 0);
 v[31601] = 0;
 g = O(910, b | 0, d | 0) | 0;
 f = v[31601];
 v[31601] = 0;
 a: {
  b: {
   c: {
    if ((f | 0) != 1) {
     if (g) {
      break c;
     }
     v[a >> 2] = 0;
     v[a + 4 >> 2] = 0;
     v[a + 24 >> 2] = 0;
     v[a + 16 >> 2] = 0;
     v[a + 20 >> 2] = 0;
     v[a + 8 >> 2] = 0;
     v[a + 12 >> 2] = 0;
     v[31601] = 0;
     Q(911, a | 0) | 0;
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) != 1) {
      break b;
     }
    }
    break a;
   }
   g = v[d + 4 >> 2];
   v[31601] = 0;
   f = e + 12 | 0;
   R(185, f | 0, b | 0, g | 0);
   h = v[31601];
   v[31601] = 0;
   if ((h | 0) == 1) {
    break a;
   }
   h = gc(e + 32 | 0, f);
   jd(d + 8 | 0, h);
   tb(h);
   tb(f);
   d: {
    if (!(g & 1) | c >>> 0 < 2) {
     break d;
    }
    v[31601] = 0;
    O(183, b | 0, 1) | 0;
    b = v[31601];
    v[31601] = 0;
    if ((b | 0) != 1) {
     break d;
    }
    break a;
   }
   Lk(a, d);
  }
  Gd(d);
  eb = e + 80 | 0;
  return;
 }
 a = M() | 0;
 Gd(d);
 P(a | 0);
 p();
}

function $ia(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0;
 a: {
  v[a >> 2] = 0;
  v[a + 4 >> 2] = 0;
  sc(a + 8 | 0);
  c = v[b >> 2];
  e = c;
  d = v[b + 4 >> 2];
  f = d;
  d = Fk(c, d);
  c = eb - 16 | 0;
  eb = c;
  Qd(c + 8 | 0, v[ub(c + 4 | 0, a) >> 2]);
  b: {
   c: {
    if (d) {
     v[31601] = 0;
     N(460, a | 0, d | 0);
     g = v[31601];
     v[31601] = 0;
     if ((g | 0) == 1) {
      break c;
     }
     tA(a, e, f, d);
    }
    d = c + 8 | 0;
    Pd(d);
    _l(d);
    eb = c + 16 | 0;
    break b;
   }
   a = M() | 0;
   _l(c + 8 | 0);
   P(a | 0);
   p();
  }
  v[a + 20 >> 2] = v[b + 20 >> 2];
  c = v[b + 16 >> 2];
  v[a + 12 >> 2] = v[b + 12 >> 2];
  v[a + 16 >> 2] = c;
  v[31601] = 0;
  c = O(920, a + 24 | 0, b + 24 | 0) | 0;
  d = v[31601];
  v[31601] = 0;
  d: {
   e: {
    if ((d | 0) != 1) {
     v[31601] = 0;
     O(71, a + 36 | 0, b + 36 | 0) | 0;
     d = v[31601];
     v[31601] = 0;
     if ((d | 0) == 1) {
      break e;
     }
     v[a + 48 >> 2] = v[b + 48 >> 2];
     break a;
    }
    b = M() | 0;
    break d;
   }
   b = M() | 0;
   uc(c);
  }
  Jk(a);
  P(b | 0);
  p();
 }
}

function Jna(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0;
 g = eb - 16 | 0;
 eb = g;
 a: {
  if (!(c & 1024)) {
   break a;
  }
  i = g, j = yd(b), v[i + 12 >> 2] = j;
  c = Zc(v[b + 4 >> 2], w[b + 11 | 0]);
  b: {
   if (!c) {
    break b;
   }
   if (w[dc(b, 0) | 0] != 43) {
    if (w[dc(b, 0) | 0] != 45) {
     break b;
    }
   }
   d = d + 1 | 0;
   hV(g + 12 | 0);
  }
  if (c >>> 0 >= d >>> 0) {
   break a;
  }
  e = v[ub(g + 8 | 0, v[g + 12 >> 2]) >> 2];
  c = d - Zc(v[b + 4 >> 2], w[b + 11 | 0]) | 0;
  c: {
   e = yk(e, yd(b));
   d = Cb(v[b + 4 >> 2], w[b + 11 | 0]);
   if (e >>> 0 <= d >>> 0) {
    if (c) {
     f = Lc(b);
     d: {
      if (c >>> 0 <= f - d >>> 0) {
       f = Jb(b);
       if ((d | 0) == (e | 0)) {
        break d;
       }
       h = e + f | 0;
       Mi(c + h | 0, h, d - e | 0);
       break d;
      }
      VB(b, f, (c + d | 0) - f | 0, d, e, c);
      f = v[b >> 2];
     }
     Zl(e + f | 0, c, 48);
     c = c + d | 0;
     kg(b, c);
     gd(c + f | 0, 0);
    }
    break c;
   }
   cn();
   p();
  }
  yd(b);
 }
 Uc(a, b);
 eb = g + 16 | 0;
}

function jsa(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0;
 d = eb - 80 | 0;
 eb = d;
 e = Qf(d + 52 | 0);
 v[31601] = 0;
 c = O(410, b | 0, e | 0) | 0;
 f = v[31601];
 v[31601] = 0;
 a: {
  b: {
   c: {
    d: {
     if ((f | 0) != 1) {
      if (c) {
       break d;
      }
      v[a >> 2] = 0;
      v[a + 4 >> 2] = 0;
      v[a + 24 >> 2] = 0;
      v[a + 16 >> 2] = 0;
      v[a + 20 >> 2] = 0;
      v[a + 8 >> 2] = 0;
      v[a + 12 >> 2] = 0;
      v[31601] = 0;
      Q(411, a | 0) | 0;
      a = v[31601];
      v[31601] = 0;
      if ((a | 0) != 1) {
       break a;
      }
     }
     break c;
    }
    c = eb - 16 | 0;
    eb = c;
    g = c, h = _b(v[e + 4 >> 2]), v[g + 12 >> 2] = h;
    v[c + 8 >> 2] = 8;
    f = ad(c + 12 | 0, c + 8 | 0);
    eb = c + 16 | 0;
    c = v[f >> 2] - 8 | 0;
    v[31601] = 0;
    R(185, d + 12 | 0, b | 0, c | 0);
    b = v[31601];
    v[31601] = 0;
    if ((b | 0) != 1) {
     break b;
    }
   }
   a = M() | 0;
   Gd(e);
   P(a | 0);
   p();
  }
  b = d + 12 | 0;
  c = gc(d + 32 | 0, b);
  jd(e + 8 | 0, c);
  tb(c);
  tb(b);
  Lk(a, e);
 }
 Gd(e);
 eb = d + 80 | 0;
}

function JH(a, b, c, d, e, f) {
 var g = 0, h = 0, i = C(0), j = 0;
 g = eb - 80 | 0;
 eb = g;
 NA(v[a + 24 >> 2]);
 t[v[a + 24 >> 2] + 1298424 | 0] = v[a + 52 >> 2] != 0;
 v[g + 44 >> 2] = b;
 v[g + 40 >> 2] = c;
 v[g + 36 >> 2] = d;
 i = z[a + 48 >> 2];
 j = v[a + 32 >> 2];
 v[g + 8 >> 2] = b;
 c = v[g + 40 >> 2];
 v[g >> 2] = v[g + 36 >> 2];
 v[g + 4 >> 2] = c;
 d = eb - 16 | 0;
 eb = d;
 v[d + 8 >> 2] = v[g + 8 >> 2];
 c = v[g + 4 >> 2];
 v[d >> 2] = v[g >> 2];
 v[d + 4 >> 2] = c;
 c = FM(g + 48 | 0);
 v[c + 8 >> 2] = j;
 v[c + 4 >> 2] = 0;
 v[c >> 2] = f;
 f = v[d + 4 >> 2];
 v[c + 12 >> 2] = v[d >> 2];
 v[c + 16 >> 2] = f;
 v[c + 20 >> 2] = v[d + 8 >> 2];
 A[c + 24 >> 3] = i;
 v[c >> 2] = e;
 eb = d + 16 | 0;
 while (1) {
  if (b) {
   d = v[a + 24 >> 2];
   v[g + 24 >> 2] = b;
   v[g + 28 >> 2] = 0;
   v[g + 16 >> 2] = 134217727;
   v[g + 20 >> 2] = 0;
   d = GM(d, v[Wr(g + 24 | 0, g + 16 | 0) >> 2], c);
   h = d + h | 0;
   b = b - d | 0;
   if (d) {
    continue;
   }
  }
  break;
 }
 if (!(v[a + 52 >> 2] != 1 | h)) {
  a = v[a + 24 >> 2];
  v[a + 480208 >> 2] = v[a + 480208 >> 2] & -513;
 }
 eb = g + 80 | 0;
 return h;
}

function yja(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0;
 a: {
  g = eb - 32 | 0;
  eb = g;
  a = Mb(a);
  b: {
   c: {
    d: {
     e: {
      while (1) {
       e = v[b + 8 >> 2];
       f = v[b >> 2];
       v[31601] = 0;
       e = T(150, f | 0, e | 0, 8) | 0;
       f = v[31601];
       v[31601] = 0;
       if ((f | 0) == 1) {
        break c;
       }
       if (e) {
        v[31601] = 0;
        e = g + 4 | 0;
        R(908, e | 0, b | 0, c | 0);
        f = v[31601];
        v[31601] = 0;
        if ((f | 0) == 1) {
         break e;
        }
        v[31601] = 0;
        N(909, a | 0, e | 0);
        f = v[31601];
        v[31601] = 0;
        if ((f | 0) == 1) {
         break d;
        }
        Gd(e);
        f = e;
        e = Fr(v[a + 4 >> 2]);
        pi(f, v[e >> 2], v[e + 4 >> 2]);
        if (v[g + 4 >> 2] != (d | 0)) {
         continue;
        }
       }
       break;
      }
      eb = g + 32 | 0;
      break a;
     }
     b = M() | 0;
     break b;
    }
    b = M() | 0;
    Gd(g + 4 | 0);
    break b;
   }
   b = M() | 0;
  }
  je(a);
  P(b | 0);
  p();
 }
}

function Em(a, b, c) {
 var d = 0, e = 0, f = 0, g = 0;
 f = eb - 16 | 0;
 eb = f;
 t[a | 0] = 0;
 a: {
  d = v[b >> 2];
  e = v[d - 12 >> 2] + b | 0;
  b: {
   if (!v[e + 16 >> 2]) {
    e = v[e + 72 >> 2];
    if (e) {
     sp(e);
     d = v[b >> 2];
    }
    c: {
     if (c) {
      break c;
     }
     c = v[d - 12 >> 2] + b | 0;
     if (!(w[c + 5 | 0] & 16)) {
      break c;
     }
     d = f + 12 | 0;
     bd(d, v[c + 28 >> 2]);
     v[31601] = 0;
     e = Q(28, v[f + 12 >> 2]) | 0;
     c = v[31601];
     v[31601] = 0;
     if ((c | 0) == 1) {
      break a;
     }
     Zb(d);
     c = qp(f + 8 | 0, b);
     d = sc(f + 4 | 0);
     while (1) {
      d: {
       if (sh(c, d)) {
        break d;
       }
       g = rl(v[c >> 2]);
       if (!If(v[e + 8 >> 2], 1, g)) {
        break d;
       }
       Dm(c);
       continue;
      }
      break;
     }
     if (sh(c, d)) {
      Wj(v[v[b >> 2] - 12 >> 2] + b | 0, 6);
     }
     d = v[b >> 2];
    }
    t[a | 0] = !v[(v[d - 12 >> 2] + b | 0) + 16 >> 2];
    break b;
   }
   Wj(e, 4);
  }
  eb = f + 16 | 0;
  return a;
 }
 a = M() | 0;
 Zb(f + 12 | 0);
 P(a | 0);
 p();
}

function Ki(a, b, c, d, e) {
 var f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
 j = c * d;
 k = b * e;
 h = j + k;
 l = b * d;
 m = c * e;
 i = l - m;
 a: {
  if (!Ni(i)) {
   break a;
  }
  if (!Ni(h)) {
   break a;
  }
  f = zf(b);
  g = zf(c);
  n = f | g;
  b: {
   if ((n | 0) != 1) {
    break b;
   }
   b = ii(f ? 1 : 0, b);
   c = ii(g ? 1 : 0, c);
   if (Ni(d)) {
    d = ii(0, d);
   }
   if (!Ni(e)) {
    break b;
   }
   e = ii(0, e);
  }
  f = zf(d);
  g = zf(e);
  c: {
   if (f | g) {
    d = ii(f ? 1 : 0, d);
    e = ii(g ? 1 : 0, e);
    if (Ni(b)) {
     b = ii(0, b);
    }
    if (!Ni(c)) {
     break c;
    }
    c = ii(0, c);
    break c;
   }
   if (n) {
    break c;
   }
   d: {
    if (zf(l)) {
     break d;
    }
    if (zf(m)) {
     break d;
    }
    if (zf(k)) {
     break d;
    }
    if (!zf(j)) {
     break a;
    }
   }
   if (Ni(b)) {
    b = ii(0, b);
   }
   if (Ni(c)) {
    c = ii(0, c);
   }
   if (Ni(d)) {
    d = ii(0, d);
   }
   if (!Ni(e)) {
    break c;
   }
   e = ii(0, e);
  }
  h = (b * e + d * c) * Infinity;
  i = (b * d - e * c) * Infinity;
 }
 Nl(a, i, h);
}

function rT(a, b) {
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0;
 f = -1;
 a: {
  if (!(w[b + 851 | 0] & 2)) {
   break a;
  }
  d = !(w[a + 480209 | 0] & 32);
  b: {
   c: {
    d: {
     c = v[b + 656 >> 2];
     e: {
      if (c) {
       e = w[c + 22 | 0];
       if (ud(e)) {
        g = b, h = Gh(e), t[g + 838 | 0] = h;
        d = 1;
       }
       e = w[c + 21 | 0];
       f: {
        if (ud(e)) {
         g = b, h = Gh(e), t[g + 837 | 0] = h;
         break f;
        }
        if (!d) {
         break d;
        }
       }
       d = 1;
       c = w[c + 25 | 0];
       if ((c | 0) == 255) {
        break e;
       }
       t[b + 845 | 0] = c;
       break e;
      }
      v[b + 776 >> 2] = 0;
      v[b + 780 >> 2] = 0;
     }
     c = b + 837 | 0;
     if (w[b + 837 | 0] >= 127) {
      break c;
     }
     if (d) {
      break b;
     }
     break a;
    }
    if (w[b + 837 | 0] < 127) {
     break a;
    }
    d = 0;
    c = b + 837 | 0;
   }
   if (!d | !Nb(a + 1074312 | 0, 36)) {
    break a;
   }
  }
  f = Kq(a, b, 1, 256);
  if ((f | 0) < 0) {
   break a;
  }
  f = w[c | 0] >>> 1 | 0;
 }
 return f;
}

function wna(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0;
 g = eb - 16 | 0;
 eb = g;
 md(b, 4);
 u[b + 30 >> 1] = w[a + 12 | 0] << 2;
 Gf(b + 30 | 0, 256);
 e = w[a + 15 | 0];
 u[b + 34 >> 1] = 32;
 u[b + 28 >> 1] = e;
 t[b + 37 | 0] = w[a + 13 | 0];
 t[b + 36 | 0] = w[a + 16 | 0];
 f = w[a | 0] | w[a + 1 | 0] << 8 | (w[a + 2 | 0] << 16 | w[a + 3 | 0] << 24);
 v[b >> 2] = f;
 c = w[a + 4 | 0] | w[a + 5 | 0] << 8 | (w[a + 6 | 0] << 16 | w[a + 7 | 0] << 24);
 v[b + 4 >> 2] = c;
 d = (w[a + 8 | 0] | w[a + 9 | 0] << 8 | (w[a + 10 | 0] << 16 | w[a + 11 | 0] << 24)) + c | 0;
 v[b + 8 >> 2] = d;
 e = w[a + 14 | 0];
 if (e & 16) {
  d = d >>> 1 | 0;
  v[b + 8 >> 2] = d;
  c = c >>> 1 | 0;
  v[b + 4 >> 2] = c;
  f = f >>> 1 | 0;
  v[b >> 2] = f;
  e = w[a + 14 | 0];
 }
 if (e & 32) {
  d = d >>> 1 | 0;
  v[b + 8 >> 2] = d;
  c = c >>> 1 | 0;
  v[b + 4 >> 2] = c;
  v[b >> 2] = f >>> 1;
  e = w[a + 14 | 0];
 }
 if (!(!(e & 3) | c >>> 0 >= d >>> 0)) {
  u[b + 34 >> 1] = 34;
  u[b + 34 >> 1] = w[a + 14 | 0] & 2 ? 38 : 34;
 }
 a = Cc(g + 4 | 0, 22256);
 Ae(b + 43 | 0, a);
 sb(a);
 eb = g + 16 | 0;
}

function RA(a) {
 var b = 0, c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0;
 e = eb - 16 | 0;
 eb = e;
 b = v[a >> 2];
 if (!lc(b, v[a + 4 >> 2])) {
  b = vb(b);
  v[e + 12 >> 2] = b;
  f = vb(v[a + 4 >> 2]);
  while (1) {
   if (Hb(b, f)) {
    Fp(b, 4194304, 67108864);
    b = v[b >> 2];
    d = b + d | 0;
    c = b >>> 0 > d >>> 0 ? c + 1 | 0 : c;
    b = v[Xe(e + 12 | 0) >> 2];
    continue;
   } else {
    b = v[a >> 2];
    f = nc(b, v[a + 4 >> 2]);
    b = vb(b);
    v[e + 8 >> 2] = b;
    g = f << 24;
    d = Cua(d, c, f, 0);
    h = ((gb & 1) << 31 | d >>> 1) & 2147483647;
    i = vb(v[a + 4 >> 2]);
    while (1) {
     if (Hb(b, i)) {
      f = b;
      b = v[b >> 2];
      c = b >>> 8 | 0;
      b = h + (b << 24) | 0;
      c = c + j | 0;
      c = Ac(Cua(b, b >>> 0 < h >>> 0 ? c + 1 | 0 : c, d, j), gb);
      v[f >> 2] = c;
      g = g - c | 0;
      b = v[Xe(e + 8 | 0) >> 2];
      continue;
     } else {
      c = v[a >> 2];
      if (!nc(c, v[a + 4 >> 2])) {
       Iw();
       p();
      }
      v[c >> 2] = v[c >> 2] + g;
     }
     break;
    }
   }
   break;
  }
 }
 eb = e + 16 | 0;
}

function UQ(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = C(0), j = C(0), k = 0, l = C(0);
 g = eb - 16 | 0;
 eb = g;
 e = u[d >> 1];
 f = u[d + 2 >> 1];
 if (!(!x[b >> 1] | (e | 0) > (f | 0) | (!(z[c >> 2] > C(0)) | (f - e | 0) > 32766))) {
  u[a >> 1] = 3;
  f = a + 4 | 0;
  Mc(f);
  u[a + 28 >> 1] = 65472;
  v[g + 12 >> 2] = 1065353216;
  ZQ(f, g + 12 | 0);
  v[a + 32 >> 2] = 0;
  u[a + 30 >> 1] = 0;
  Mc(a + 16 | 0);
  h = u[d >> 1];
  u[a + 28 >> 1] = h;
  e = eb - 16 | 0;
  eb = e;
  u[e + 14 >> 1] = x[b >> 1];
  u[e + 12 >> 1] = 32767;
  b = u[Nc(e + 14 | 0, e + 12 | 0) >> 1];
  eb = e + 16 | 0;
  u[a + 30 >> 1] = b;
  i = C(D(z[c >> 2]));
  z[a + 32 >> 2] = i;
  i = De(i, C(C(1) / C(b | 0)));
  Al(f, (u[d + 2 >> 1] - h | 0) + 1 | 0);
  b = v[a + 4 >> 2];
  c = u[a + 28 >> 1];
  e = u[d + 2 >> 1];
  d = u[d >> 1];
  while (1) {
   if ((d | 0) > (e | 0)) {
    xq(a);
   } else {
    j = De(i, C(d | 0));
    k = xb(b, d - c | 0), l = j, z[k >> 2] = l;
    d = d + 1 | 0;
    continue;
   }
   break;
  }
  h = 1;
 }
 eb = g + 16 | 0;
 return h | 0;
}

function Dsa(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0;
 a: {
  e = eb - 32 | 0;
  eb = e;
  a = Mb(a);
  b: {
   c: {
    d: {
     e: {
      while (1) {
       c = v[b + 8 >> 2];
       d = v[b >> 2];
       v[31601] = 0;
       c = T(150, d | 0, c | 0, 8) | 0;
       d = v[31601];
       v[31601] = 0;
       if ((d | 0) == 1) {
        break c;
       }
       if (c) {
        v[31601] = 0;
        c = e + 4 | 0;
        N(407, c | 0, b | 0);
        d = v[31601];
        v[31601] = 0;
        if ((d | 0) == 1) {
         break e;
        }
        v[31601] = 0;
        N(408, a | 0, c | 0);
        d = v[31601];
        v[31601] = 0;
        if ((d | 0) == 1) {
         break d;
        }
        Gd(c);
        d = c;
        c = Fr(v[a + 4 >> 2]);
        pi(d, v[c >> 2], v[c + 4 >> 2]);
        if ((_b(v[e + 4 >> 2]) | 0) != 1162757187) {
         continue;
        }
       }
       break;
      }
      eb = e + 32 | 0;
      break a;
     }
     b = M() | 0;
     break b;
    }
    b = M() | 0;
    Gd(e + 4 | 0);
    break b;
   }
   b = M() | 0;
  }
  je(a);
  P(b | 0);
  p();
 }
}

function Dta(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0;
 c = eb - 16 | 0;
 eb = c;
 v[a >> 2] = 0;
 v[a + 4 >> 2] = 0;
 sc(a + 8 | 0);
 Qd(c + 8 | 0, v[ub(c + 4 | 0, a) >> 2]);
 a: {
  b: {
   if (b) {
    v[31601] = 0;
    N(321, a | 0, b | 0);
    d = v[31601];
    v[31601] = 0;
    if ((d | 0) == 1) {
     break b;
    }
    e = eb - 16 | 0;
    eb = e;
    d = Cr(e + 4 | 0, a, b);
    b = v[d + 4 >> 2];
    f = v[d + 8 >> 2];
    while (1) {
     if ((b | 0) == (f | 0)) {
      hc(d);
      eb = e + 16 | 0;
     } else {
      t[b | 0] = 0;
      t[b + 1 | 0] = 0;
      t[b + 2 | 0] = 0;
      t[b + 3 | 0] = 0;
      t[b + 4 | 0] = 0;
      t[b + 5 | 0] = 0;
      t[b + 4 | 0] = 6;
      t[b + 5 | 0] = 0;
      t[b | 0] = 0;
      t[b + 1 | 0] = 0;
      t[b + 2 | 0] = 8;
      t[b + 3 | 0] = 4;
      b = b + 6 | 0;
      v[d + 4 >> 2] = b;
      continue;
     }
     break;
    }
   }
   b = c + 8 | 0;
   Pd(b);
   _l(b);
   eb = c + 16 | 0;
   break a;
  }
  a = M() | 0;
  _l(c + 8 | 0);
  P(a | 0);
  p();
 }
 t[a + 16 | 0] = 6;
 v[a + 12 >> 2] = 2015363072;
 return a | 0;
}

function _aa(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
 f = eb + -64 | 0;
 eb = f;
 d = f + 16 | 0;
 h = eb - 16 | 0;
 eb = h;
 i = lP(h + 8 | 0);
 l = f + 4 | 0;
 while (1) {
  if ((j | 0) == 12) {
   eb = h + 16 | 0;
  } else {
   g = eb + -64 | 0;
   eb = g;
   c = v[i + 4 >> 2];
   e = v[i >> 2];
   a: {
    if ((c | 0) == (e | 0)) {
     break a;
    }
    c = (c - e | 0) + 1 | 0;
    if (!c) {
     c = HM(IM(g + 8 | 0, 32));
     break a;
    }
    e = E(c);
    e = IM(g + 8 | 0, (c << e & 2147483647 ? 32 : 31) - e | 0);
    while (1) {
     k = HM(e);
     if (c >>> 0 <= k >>> 0) {
      continue;
     }
     break;
    }
    c = v[i >> 2] + k | 0;
   }
   eb = g - -64 | 0;
   m = xb(d, j), n = c, v[m >> 2] = n;
   j = j + 1 | 0;
   continue;
  }
  break;
 }
 d = uP(l, d, yP(d));
 pP(a, d);
 Vm(d);
 eb = f - -64 | 0;
 d = xz(a + 120 | 0, a, b);
 t[d + 20 | 0] = 1;
 v[31601] = 0;
 N(1149, a | 0, b | 0);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) == 1) {
  a = M() | 0;
  to(d);
  P(a | 0);
  p();
 }
 return a | 0;
}

function q3(a, b, c, d, e, f) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 f = f | 0;
 var g = 0, h = 0, i = 0, j = 0, k = 0, l = 0;
 if (kh(a, v[b + 8 >> 2], f)) {
  Wx(b, c, d, e);
  return;
 }
 h = w[b + 53 | 0];
 g = v[a + 12 >> 2];
 t[b + 53 | 0] = 0;
 i = w[b + 52 | 0];
 t[b + 52 | 0] = 0;
 j = a + 16 | 0;
 Sx(v[j >> 2], v[a + 20 >> 2], b, c, d, e, f);
 k = w[b + 52 | 0];
 i = (i | k) != 0;
 l = w[b + 53 | 0];
 h = (h | l) != 0;
 a: {
  if ((g | 0) < 2) {
   break a;
  }
  j = j + (g << 3) | 0;
  g = a + 24 | 0;
  while (1) {
   if (w[b + 54 | 0]) {
    break a;
   }
   b: {
    if (k) {
     if (v[b + 24 >> 2] == 1) {
      break a;
     }
     if (w[a + 8 | 0] & 2) {
      break b;
     }
     break a;
    }
    if (!l) {
     break b;
    }
    if (!(t[a + 8 | 0] & 1)) {
     break a;
    }
   }
   u[b + 52 >> 1] = 0;
   Sx(v[g >> 2], v[g + 4 >> 2], b, c, d, e, f);
   l = w[b + 53 | 0];
   h = (l | h) != 0;
   k = w[b + 52 | 0];
   i = (k | i) != 0;
   g = g + 8 | 0;
   if (j >>> 0 > g >>> 0) {
    continue;
   }
   break;
  }
 }
 t[b + 53 | 0] = h;
 t[b + 52 | 0] = i;
}

function x4(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0;
 e = b & 512;
 f = b & 256;
 g = b & 128;
 h = b & 64;
 i = b & 32;
 j = b & 16;
 k = b & 8;
 l = b & 4;
 m = b & 2;
 b = b & 1;
 a: {
  while (1) {
   if ((c | 0) == (d | 0)) {
    break a;
   }
   a = v[c >> 2];
   b: {
    c: {
     if (b) {
      if (Xs(a)) {
       break c;
      }
     }
     if (m) {
      if (Ws(a)) {
       break c;
      }
     }
     if (l) {
      if (Vs(a)) {
       break c;
      }
     }
     if (k) {
      if (Us(a)) {
       break c;
      }
     }
     if (j) {
      if (Ts(a)) {
       break c;
      }
     }
     if (i) {
      if (Ss(a)) {
       break c;
      }
     }
     if (h) {
      if (Zn(a)) {
       break c;
      }
     }
     if (g) {
      if (Rs(a)) {
       break c;
      }
     }
     if (f) {
      if (_n(a)) {
       break c;
      }
     }
     if (!e) {
      break b;
     }
     if (!Qs(a)) {
      break b;
     }
    }
    c = c + 4 | 0;
    continue;
   }
   break;
  }
  d = c;
 }
 return d | 0;
}

function us(a) {
 var b = 0, c = 0, d = 0, e = 0;
 b = eb - 32 | 0;
 eb = b;
 c = b + 8 | 0;
 Cc(c, 15380);
 v[31601] = 0;
 d = b + 20 | 0;
 R(123, d | 0, 1, c | 0);
 e = v[31601];
 v[31601] = 0;
 a: {
  b: {
   c: {
    if ((e | 0) != 1) {
     v[31601] = 0;
     N(12, a | 0, d | 0);
     e = v[31601];
     v[31601] = 0;
     if ((e | 0) == 1) {
      break c;
     }
     Tb(d);
     sb(c);
     eb = b + 32 | 0;
     break a;
    }
    a = M() | 0;
    break b;
   }
   a = M() | 0;
   Tb(b + 20 | 0);
  }
  sb(b + 8 | 0);
  P(a | 0);
  p();
 }
 v[31601] = 0;
 b = ba(117) | 0;
 c = v[31601];
 v[31601] = 0;
 d: {
  if ((c | 0) == 1) {
   break d;
  }
  v[a + 12 >> 2] = b;
  v[31601] = 0;
  b = ba(118) | 0;
  c = v[31601];
  v[31601] = 0;
  if ((c | 0) == 1) {
   break d;
  }
  t[a + 16 | 0] = b;
  v[31601] = 0;
  b = ba(119) | 0;
  c = v[31601];
  v[31601] = 0;
  if ((c | 0) == 1) {
   break d;
  }
  t[a + 18 | 0] = 0;
  t[a + 17 | 0] = b;
  v[31601] = 0;
  V(120, a + 20 | 0);
  b = v[31601];
  v[31601] = 0;
  if ((b | 0) == 1) {
   break d;
  }
  return;
 }
 b = M() | 0;
 sb(a);
 P(b | 0);
 p();
}

function aP(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0;
 d = eb - 32 | 0;
 eb = d;
 g = Mb(a);
 a = 0;
 a: {
  b: {
   c: {
    d: {
     e: {
      while (1) {
       c = v[b + 24 >> 2];
       if (x[c + 480188 >> 1] <= a >>> 0) {
        break a;
       }
       v[31601] = 0;
       f = d + 8 | 0;
       N(1051, f | 0, (c + (a << 5) | 0) + 480289 | 0);
       c = v[31601];
       v[31601] = 0;
       if ((c | 0) != 1) {
        e = v[b + 24 >> 2];
        v[31601] = 0;
        c = d + 20 | 0;
        R(1052, c | 0, e | 0, f | 0);
        e = v[31601];
        v[31601] = 0;
        if ((e | 0) == 1) {
         break e;
        }
        v[31601] = 0;
        N(178, g | 0, c | 0);
        e = v[31601];
        v[31601] = 0;
        if ((e | 0) == 1) {
         break d;
        }
        a = a + 1 | 0;
        sb(c);
        sb(f);
        continue;
       }
       break;
      }
      a = M() | 0;
      break b;
     }
     a = M() | 0;
     break c;
    }
    a = M() | 0;
    sb(d + 20 | 0);
   }
   sb(d + 8 | 0);
  }
  Sd(g);
  P(a | 0);
  p();
 }
 eb = d + 32 | 0;
}

function cpa(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0;
 a: {
  e = eb - 32 | 0;
  eb = e;
  a = Mb(a);
  b: {
   c: {
    d: {
     e: {
      while (1) {
       c = v[b + 8 >> 2];
       d = v[b >> 2];
       v[31601] = 0;
       c = T(150, d | 0, c | 0, 8) | 0;
       d = v[31601];
       v[31601] = 0;
       if ((d | 0) == 1) {
        break c;
       }
       if (c) {
        v[31601] = 0;
        c = e + 4 | 0;
        N(680, c | 0, b | 0);
        d = v[31601];
        v[31601] = 0;
        if ((d | 0) == 1) {
         break e;
        }
        v[31601] = 0;
        N(681, a | 0, c | 0);
        d = v[31601];
        v[31601] = 0;
        if ((d | 0) == 1) {
         break d;
        }
        Gd(c);
        d = c;
        c = Fr(v[a + 4 >> 2]);
        pi(d, v[c >> 2], v[c + 4 >> 2]);
        if (v[e + 4 >> 2] != 1413891155) {
         continue;
        }
       }
       break;
      }
      eb = e + 32 | 0;
      break a;
     }
     b = M() | 0;
     break b;
    }
    b = M() | 0;
    Gd(e + 4 | 0);
    break b;
   }
   b = M() | 0;
  }
  je(a);
  P(b | 0);
  p();
 }
}

function Pja(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0;
 g = eb - 16 | 0;
 eb = g;
 f = c;
 e = eb - 16 | 0;
 eb = e;
 h = b;
 d = ce(b);
 a: {
  if (d) {
   c = fc(b);
   while (1) {
    b = d;
    d = b + 16 | 0;
    if (xR(f, d)) {
     c = b;
     d = v[b >> 2];
     if (d) {
      continue;
     }
     break a;
    }
    if (!xR(d, f)) {
     break a;
    }
    c = b + 4 | 0;
    d = v[b + 4 >> 2];
    if (d) {
     continue;
    }
    break;
   }
   break a;
  }
  b = fc(h);
  c = b;
 }
 v[e + 12 >> 2] = b;
 b = v[c >> 2];
 if (!b) {
  b = eb - 16 | 0;
  eb = b;
  d = fc(h);
  d = Ch(e, Dc(28), Ng(b + 8 | 0, d));
  i = v[d >> 2];
  v[31601] = 0;
  N(888, i + 16 | 0, f | 0);
  f = v[31601];
  v[31601] = 0;
  b: {
   if ((f | 0) != 1) {
    j = fc(d), k = 1, t[j + 4 | 0] = k;
    eb = b + 16 | 0;
    break b;
   }
   a = M() | 0;
   wR(d);
   P(a | 0);
   p();
  }
  _g(h, v[e + 12 >> 2], c, v[e >> 2]);
  b = me(e);
  wR(e);
  i = 1;
 }
 c = g + 8 | 0;
 Zg(c, v[ub(e, b) >> 2], i);
 eb = e + 16 | 0;
 bV(a, c);
 eb = g + 16 | 0;
}

function _y(a, b) {
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0;
 e = eb - 16 | 0;
 eb = e;
 g = (q(a), j(2));
 c = g & 2147483647;
 a: {
  if (c >>> 0 <= 1305022426) {
   h = +a;
   f = h * .6366197723675814 + 6755399441055744 + -6755399441055744;
   d = h + f * -1.5707963109016418 + f * -1.5893254773528196e-8;
   A[b >> 3] = d;
   g = d < -.7853981852531433;
   if (D(f) < 2147483648) {
    c = ~~f;
   } else {
    c = -2147483648;
   }
   if (g) {
    d = f + -1;
    A[b >> 3] = h + d * -1.5707963109016418 + d * -1.5893254773528196e-8;
    c = c - 1 | 0;
    break a;
   }
   if (!(d > .7853981852531433)) {
    break a;
   }
   d = f + 1;
   A[b >> 3] = h + d * -1.5707963109016418 + d * -1.5893254773528196e-8;
   c = c + 1 | 0;
   break a;
  }
  if (c >>> 0 >= 2139095040) {
   A[b >> 3] = C(a - a);
   c = 0;
   break a;
  }
  i = c;
  c = (c >>> 23 | 0) - 150 | 0;
  A[e + 8 >> 3] = (l(2, i - (c << 23) | 0), r());
  c = uL(e + 8 | 0, e, c, 1, 0);
  d = A[e >> 3];
  if ((g | 0) < 0) {
   A[b >> 3] = -d;
   c = 0 - c | 0;
   break a;
  }
  A[b >> 3] = d;
 }
 eb = e + 16 | 0;
 return c;
}

function Nfa(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0;
 e = eb - 16 | 0;
 eb = e;
 i = e, j = Pj(b), v[i + 4 >> 2] = j;
 c = eb - 16 | 0;
 eb = c;
 g = a;
 d = ce(a);
 a: {
  if (d) {
   f = fc(a);
   while (1) {
    a = d;
    d = a + 16 | 0;
    if (Vu(b, d)) {
     f = a;
     d = v[a >> 2];
     if (d) {
      continue;
     }
     break a;
    }
    if (!Vu(d, b)) {
     break a;
    }
    f = a + 4 | 0;
    d = v[a + 4 >> 2];
    if (d) {
     continue;
    }
    break;
   }
   break a;
  }
  a = fc(g);
  f = a;
 }
 v[c + 12 >> 2] = a;
 b = v[f >> 2];
 if (!b) {
  a = eb - 16 | 0;
  eb = a;
  b = fc(g);
  b = Ch(c, Dc(40), Ng(a + 8 | 0, b));
  Eb(Uc(v[b >> 2] + 16 | 0, v[e + 4 >> 2]) + 12 | 0);
  i = fc(b), j = 1, t[i + 4 | 0] = j;
  eb = a + 16 | 0;
  _g(g, v[c + 12 >> 2], f, v[c >> 2]);
  b = me(c);
  a = v[c >> 2];
  v[c >> 2] = 0;
  if (a) {
   if (w[fc(c) + 4 | 0]) {
    _m(a + 16 | 0);
   }
   Bb(a);
  }
  h = 1;
 }
 Zg(e + 8 | 0, v[ub(c, b) >> 2], h);
 eb = c + 16 | 0;
 a = td(v[e + 8 >> 2]);
 eb = e + 16 | 0;
 return a + 12 | 0;
}

function F0(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0;
 e = eb - 16 | 0;
 eb = e;
 md(b, 0);
 v[b >> 2] = w[a | 0] | w[a + 1 | 0] << 8 | (w[a + 2 | 0] << 16 | w[a + 3 | 0] << 24);
 c = Nr(a + 4 | 0, a);
 f = w[c | 0] | w[c + 1 | 0] << 8 | (w[c + 2 | 0] << 16 | w[c + 3 | 0] << 24);
 v[b + 4 >> 2] = f;
 c = Nr(a + 8 | 0, a);
 c = w[c | 0] | w[c + 1 | 0] << 8 | (w[c + 2 | 0] << 16 | w[c + 3 | 0] << 24);
 v[b + 8 >> 2] = c;
 t[e + 15 | 0] = 127;
 t[e + 14 | 0] = w[a + 15 | 0];
 g = b, h = (((w[Pb(e + 15 | 0, e + 14 | 0) | 0] << 8 | 64) & 65344) >>> 0) / 127 | 0, 
 u[g + 30 >> 1] = h;
 d = w[a + 12 | 0];
 if (d >>> 0 >= 16) {
  u[b + 34 >> 1] = 32;
  u[b + 28 >> 1] = d & 240;
 }
 d = (w[a + 13 | 0] | w[a + 14 | 0] << 8) << 1;
 v[b + 24 >> 2] = d;
 d = w[a + 13 | 0] | w[a + 14 | 0] << 8 ? d : 16726;
 v[b + 24 >> 2] = d;
 g = b, h = (B(xw(0, w[a + 12 | 0] << 28 >> 24), d) >>> 0) / 8363 | 0, v[g + 24 >> 2] = h;
 if (c >>> 0 > f >>> 0) {
  u[b + 34 >> 1] = x[b + 34 >> 1] | 2;
 }
 if (w[a + 16 | 0] & 132) {
  u[b + 34 >> 1] = x[b + 34 >> 1] | 1;
 }
 eb = e + 16 | 0;
}

function Ii(a, b, c, d) {
 var e = 0, f = 0, g = 0;
 v[a + 20 >> 2] = d;
 v[a + 16 >> 2] = c;
 v[a + 12 >> 2] = b;
 v[a + 4 >> 2] = 0;
 v[a + 8 >> 2] = 0;
 v[a >> 2] = 42680;
 c = a + 24 | 0;
 v[c >> 2] = 0;
 v[c + 4 >> 2] = 0;
 v[c + 16 >> 2] = 0;
 v[c + 8 >> 2] = 0;
 v[c + 12 >> 2] = 0;
 b = Mb(a + 44 | 0);
 d = Mb(b + 12 | 0);
 e = Mb(b + 24 | 0);
 f = Mb(b + 36 | 0);
 v[31601] = 0;
 N(940, b | 0, 0);
 g = v[31601];
 v[31601] = 0;
 if ((g | 0) == 1) {
  a = M() | 0;
  uc(f);
  uc(e);
  pu(d);
  pu(b);
  P(a | 0);
  p();
 }
 u[a + 4204 >> 1] = 0;
 v[a + 4196 >> 2] = 1065353216;
 v[a + 4200 >> 2] = 0;
 d = v[a + 16 >> 2];
 v[d + 946300 >> 2] = v[d + 946300 >> 2] + 1;
 v[31601] = 0;
 d = Q(941, a + 92 | 0) | 0;
 e = v[31601];
 v[31601] = 0;
 a: {
  if ((e | 0) != 1) {
   b = a + 4200 | 0;
   v[c >> 2] = d;
   c = v[a + 16 >> 2] + 906300 | 0;
   d = w[a + 4200 | 0];
   e = v[a + 20 >> 2];
   while (1) {
    if ((_d(c, d) | 0) == (e | 0) | d >>> 0 > 248) {
     break a;
    }
    d = d + 1 | 0;
    t[b | 0] = d;
    continue;
   }
  }
  a = M() | 0;
  qQ(b);
  P(a | 0);
  p();
 }
 return a;
}

function Ci(a, b, c, d) {
 var e = 0, f = 0, g = 0;
 e = eb - 48 | 0;
 eb = e;
 f = v[v[a >> 2] - 12 >> 2] + a | 0;
 g = v[f + 16 >> 2] & -3;
 hg(f, g);
 a: {
  b: {
   if (Hd(w[Em(e + 47 | 0, a, 1) | 0])) {
    f = v[(v[v[a >> 2] - 12 >> 2] + a | 0) + 24 >> 2];
    v[31601] = 0;
    Ns(86, e + 24 | 0, f, b, c, d);
    b = v[31601];
    v[31601] = 0;
    c: {
     if ((b | 0) != 1) {
      b = $h(e + 8 | 0, -1, -1);
      d = ao(v[e + 32 >> 2], v[e + 36 >> 2], v[b + 8 >> 2], v[b + 12 >> 2]) ? g | 4 : g;
      break c;
     }
     X(S(0) | 0) | 0;
     d = g | 1;
     Cm(v[v[a >> 2] - 12 >> 2] + a | 0, d);
     if (v[(v[v[a >> 2] - 12 >> 2] + a | 0) + 20 >> 2] & 1) {
      v[31601] = 0;
      W(84);
      a = v[31601];
      v[31601] = 0;
      if ((a | 0) != 1) {
       break a;
      }
      a = M() | 0;
      v[31601] = 0;
      W(26);
      b = v[31601];
      v[31601] = 0;
      if ((b | 0) == 1) {
       break b;
      }
      P(a | 0);
      p();
     }
     Y();
    }
    Wj(v[v[a >> 2] - 12 >> 2] + a | 0, d);
   }
   eb = e + 48 | 0;
   return a;
  }
  S(0) | 0;
  Rb();
 }
 p();
}

function nv(a, b) {
 var c = 0, d = 0, e = 0;
 e = eb - 48 | 0;
 eb = e;
 d = e + 28 | 0;
 TV(d, a + 8 | 0, a + 10 | 0, a + 12 | 0, a + 16 | 0, a + 14 | 0);
 a = e + 8 | 0;
 TV(a, b + 8 | 0, b + 10 | 0, b + 12 | 0, b + 16 | 0, b + 14 | 0);
 b = v[d >> 2];
 c = w[b | 0] | w[b + 1 | 0] << 8;
 b = v[a >> 2];
 b = mv(c, w[b | 0] | w[b + 1 | 0] << 8);
 a: {
  if (!Kj(b)) {
   break a;
  }
  b = v[d + 4 >> 2];
  c = w[b | 0] | w[b + 1 | 0] << 8;
  b = v[a + 4 >> 2];
  b = mv(c, w[b | 0] | w[b + 1 | 0] << 8);
  if (!Kj(b)) {
   break a;
  }
  b = v[d + 8 >> 2];
  c = w[b | 0] | w[b + 1 | 0] << 8;
  b = v[a + 8 >> 2];
  b = mv(c, w[b | 0] | w[b + 1 | 0] << 8);
  if (!Kj(b)) {
   break a;
  }
  b = v[a + 12 >> 2];
  b = (w[b | 0] | w[b + 1 | 0] << 8) << 16 >> 16;
  c = v[d + 12 >> 2];
  c = ye((w[c | 0] | w[c + 1 | 0] << 8) << 16 >> 16);
  b = ye(b);
  b = (b | 0) != (c | 0) ? (c | 0) < (b | 0) ? -1 : 1 : 0;
  if (!Kj(b)) {
   break a;
  }
  b = v[d + 16 >> 2];
  a = v[a + 16 >> 2];
  b = mv(w[b | 0] | w[b + 1 | 0] << 8, w[a | 0] | w[a + 1 | 0] << 8);
 }
 a = ud(b);
 eb = e + 48 | 0;
 return a;
}

function j4(a, b, c, d, e, f) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 f = f | 0;
 var g = 0, h = 0;
 a: {
  g = eb + -64 | 0;
  eb = g;
  h = g + 16 | 0;
  $n(h, c);
  v[31601] = 0;
  c = g + 28 | 0;
  N(91, c | 0, d | 0);
  d = v[31601];
  v[31601] = 0;
  b: {
   c: {
    d: {
     if ((d | 0) == 1) {
      break d;
     }
     v[31601] = 0;
     c = g + 40 | 0;
     N(91, c | 0, e | 0);
     d = v[31601];
     v[31601] = 0;
     if ((d | 0) == 1) {
      break d;
     }
     v[31601] = 0;
     c = g + 52 | 0;
     N(91, c | 0, f | 0);
     d = v[31601];
     v[31601] = 0;
     if ((d | 0) == 1) {
      break d;
     }
     cy(g + 8 | 0, h);
     v[31601] = 0;
     U(92, a | 0, b | 0, v[g + 8 >> 2], v[g + 12 >> 2]);
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) == 1) {
      break c;
     }
     yI(h);
     eb = g - -64 | 0;
     break a;
    }
    a = M() | 0;
    while (1) {
     c = sb(c - 12 | 0);
     if ((c | 0) != (g + 16 | 0)) {
      continue;
     }
     break;
    }
    break b;
   }
   a = M() | 0;
   yI(g + 16 | 0);
  }
  P(a | 0);
  p();
 }
}
function QL(a) {
 var b = C(0), c = C(0), d = C(0), e = C(0), f = C(0), g = C(0), h = C(0), i = C(0), j = C(0), k = C(0), l = C(0), m = C(0), n = C(0), o = C(0);
 f = z[a >> 2];
 i = z[a + 24 >> 2];
 c = C(f - i);
 d = z[a + 16 >> 2];
 b = z[a + 32 >> 2];
 g = z[a + 8 >> 2];
 e = C(d + C(b - g));
 z[a + 16 >> 2] = c + e;
 j = C(c - C(e * C(.5)));
 c = z[a + 4 >> 2];
 e = z[a + 20 >> 2];
 h = z[a + 28 >> 2];
 k = C(C(C(c - e) - h) * C(.8660253882408142));
 z[a + 4 >> 2] = j + k;
 l = C(C(d - b) * C(.1736481785774231));
 f = C(f + C(i * C(.5)));
 i = C(C(g + b) * C(.7660444378852844));
 m = C(l + C(f - i));
 n = C(C(c + e) * C(.9848077297210693));
 b = C(z[a + 12 >> 2] * C(.8660253882408142));
 c = C(C(c + h) * C(.6427876353263855));
 o = C(C(n - b) - c);
 z[a + 12 >> 2] = m + o;
 z[a + 20 >> 2] = m - o;
 z[a + 28 >> 2] = j - k;
 d = C(C(g + d) * C(.9396926164627075));
 g = C(C(f + d) - l);
 e = C(C(e - h) * C(.3420201539993286));
 h = C(C(e - b) - n);
 z[a + 32 >> 2] = g + h;
 d = C(C(f - d) + i);
 b = C(C(b + e) - c);
 z[a + 24 >> 2] = d + b;
 z[a + 8 >> 2] = d - b;
 z[a >> 2] = g - h;
}

function p7(a, b, c, d, e, f, g, h, i, j) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 f = f | 0;
 g = g | 0;
 h = h | 0;
 i = i | 0;
 j = j | 0;
 var k = 0, l = 0, m = 0, n = 0;
 k = eb - 16 | 0;
 eb = k;
 l = j;
 a: {
  if (a) {
   a = k + 4 | 0;
   b = QJ(b);
   jl(a, b);
   j = v[k + 4 >> 2];
   t[c | 0] = j;
   t[c + 1 | 0] = j >>> 8;
   t[c + 2 | 0] = j >>> 16;
   t[c + 3 | 0] = j >>> 24;
   il(a, b);
   yb(i, a);
   sb(a);
   ci(a, b);
   yb(h, a);
   sb(a);
   m = d, n = jj(b), t[m | 0] = n;
   m = e, n = lj(b), t[m | 0] = n;
   rh(a, b);
   yb(f, a);
   sb(k + 4 | 0);
   di(a, b);
   yb(g, a);
   sb(k + 4 | 0);
   a = Hk(b);
   break a;
  }
  a = k + 4 | 0;
  b = PJ(b);
  jl(a, b);
  j = v[k + 4 >> 2];
  t[c | 0] = j;
  t[c + 1 | 0] = j >>> 8;
  t[c + 2 | 0] = j >>> 16;
  t[c + 3 | 0] = j >>> 24;
  il(a, b);
  yb(i, a);
  sb(a);
  ci(a, b);
  yb(h, a);
  sb(a);
  m = d, n = jj(b), t[m | 0] = n;
  m = e, n = lj(b), t[m | 0] = n;
  rh(a, b);
  yb(f, a);
  sb(k + 4 | 0);
  di(a, b);
  yb(g, a);
  sb(k + 4 | 0);
  a = Hk(b);
 }
 v[l >> 2] = a;
 eb = k + 16 | 0;
}

function VY(a, b) {
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0;
 g = eb - 16 | 0;
 eb = g;
 d = ub(g + 12 | 0, v[a + 4 >> 2]);
 c = ub(g + 8 | 0, v[a >> 2]);
 f = v[ub(g + 4 | 0, v[b + 4 >> 2]) >> 2];
 h = eb - 16 | 0;
 eb = h;
 i = h + 8 | 0;
 e = eb - 32 | 0;
 eb = e;
 ed(e + 24 | 0, v[d >> 2], v[c >> 2]);
 j = e + 16 | 0;
 c = v[e + 24 >> 2];
 k = v[e + 28 >> 2];
 d = eb - 16 | 0;
 eb = d;
 v[d + 8 >> 2] = f;
 v[d + 12 >> 2] = c;
 while (1) {
  if (Ed(c, k)) {
   c = wf(c);
   f = wf(v[d + 8 >> 2]);
   c = w[c | 0] | w[c + 1 | 0] << 8 | (w[c + 2 | 0] << 16 | w[c + 3 | 0] << 24);
   t[f | 0] = c;
   t[f + 1 | 0] = c >>> 8;
   t[f + 2 | 0] = c >>> 16;
   t[f + 3 | 0] = c >>> 24;
   c = vj(d + 12 | 0);
   vj(d + 8 | 0);
   c = v[c >> 2];
   continue;
  }
  break;
 }
 pc(j, c, d + 8 | 0);
 eb = d + 16 | 0;
 d = v[e + 16 >> 2];
 v[e + 12 >> 2] = v[e + 20 >> 2];
 pc(i, d, e + 12 | 0);
 eb = e + 32 | 0;
 eb = h + 16 | 0;
 v[b + 4 >> 2] = v[h + 12 >> 2];
 Sb(a, b + 4 | 0);
 Sb(a + 4 | 0, b + 8 | 0);
 Sb(zb(a), mc(b));
 v[b >> 2] = v[b + 4 >> 2];
 eb = g + 16 | 0;
}

function s7(a, b, c, d, e, f, g) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 f = f | 0;
 g = g | 0;
 var h = 0, i = 0;
 h = eb - 416 | 0;
 eb = h;
 d = h + 416 | 0;
 v[h + 12 >> 2] = d;
 c = eb - 144 | 0;
 eb = c;
 v[c + 28 >> 2] = c + 132;
 i = c + 32 | 0;
 dK(v[a + 8 >> 2], i, c + 28 | 0, e, f, g);
 v[c + 16 >> 2] = 0;
 v[c + 20 >> 2] = 0;
 v[c + 12 >> 2] = i;
 e = h + 16 | 0;
 f = nc(e, v[h + 12 >> 2]);
 a = Bi(e, c + 12 | 0, f, c + 16 | 0, v[a + 8 >> 2]);
 if ((a | 0) == -1) {
  fo(12661);
  p();
 }
 v[h + 12 >> 2] = e + (a << 2);
 eb = c + 144 | 0;
 f = eb - 16 | 0;
 eb = f;
 i = f + 8 | 0;
 a = eb - 32 | 0;
 eb = a;
 ed(a + 24 | 0, e, v[h + 12 >> 2]);
 h = a + 16 | 0;
 e = v[a + 24 >> 2];
 g = v[a + 28 >> 2];
 c = eb - 16 | 0;
 eb = c;
 v[c + 12 >> 2] = b;
 while (1) {
  if ((e | 0) != (g | 0)) {
   ZK(c + 12 | 0, v[e >> 2]);
   e = e + 4 | 0;
   continue;
  }
  break;
 }
 pc(h, g, c + 12 | 0);
 eb = c + 16 | 0;
 b = v[a + 16 >> 2];
 v[a + 12 >> 2] = v[a + 20 >> 2];
 pc(i, b, a + 12 | 0);
 eb = a + 32 | 0;
 eb = f + 16 | 0;
 eb = d;
 return v[f + 12 >> 2];
}

function HC(a, b, c, d, e, f) {
 var g = 0, h = 0, i = 0, j = 0;
 g = eb - 16 | 0;
 eb = g;
 h = v[a >> 2];
 a: {
  if (Sc(h, v[a + 4 >> 2]) >>> 0 <= b >>> 0) {
   break a;
  }
  b: {
   c: {
    switch (c | 0) {
    case 0:
     if ((d | 0) >= 0) {
      i = wb(h, b), j = d ^ 128, t[i | 0] = j;
     }
     c = g + 8 | 0;
     Ib(c, v[a + 24 >> 2], b);
     kf(c, 0);
     break b;

    case 2:
     i = wb(h, b), j = 128, t[i | 0] = j;
     c = g + 8 | 0;
     Ib(c, v[a + 24 >> 2], b);
     kf(c, 1);
     break b;

    case 4:
     break c;

    default:
     break b;
    }
   }
   i = wb(h, b), j = 128, t[i | 0] = j;
   c = g + 8 | 0;
   Ib(c, v[a + 24 >> 2], b);
   kf(c, 0);
  }
  if (w[e | 0]) {
   break a;
  }
  c = v[f + 4 >> 2];
  if (lc(v[f >> 2], c)) {
   break a;
  }
  c = eX(c);
  if (w[wb(v[c >> 2], b) | 0] == w[wb(v[a >> 2], b) | 0]) {
   Ib(g + 8 | 0, v[c + 24 >> 2], b);
   c = Fb(v[v[g + 8 >> 2] >> 2], v[g + 12 >> 2]);
   Ib(g, v[a + 24 >> 2], b);
   if ((Fb(v[v[g >> 2] >> 2], v[g + 4 >> 2]) | 0) == (c | 0)) {
    break a;
   }
  }
  t[e | 0] = 1;
 }
 eb = g + 16 | 0;
}

function Fha(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0;
 a: {
  b: {
   c = w[a + 11 | 0];
   c: {
    d: {
     if (ud(c)) {
      c = v[a + 4 >> 2];
      d = Yi(v[a + 8 >> 2]) - 1 | 0;
      if ((c | 0) == (d | 0)) {
       break d;
      }
      break c;
     }
     d = 10;
     c = Gh(c);
     if ((c | 0) != 10) {
      break b;
     }
    }
    c = eb - 16 | 0;
    eb = c;
    e: {
     if ((d | 0) != 2147483631) {
      f = Jb(a);
      e = c + 4 | 0;
      if (d >>> 0 <= 1073741798) {
       v[c + 12 >> 2] = d << 1;
       v[c + 4 >> 2] = d + 1;
       g = Eh(v[ad(e, c + 12 | 0) >> 2]) + 1 | 0;
      } else {
       g = 2147483631;
      }
      pg(e, g);
      e = v[c + 4 >> 2];
      if (d) {
       Cg(e, f, d);
      }
      if ((d | 0) != 10) {
       Bb(f);
      }
      xd(a, e);
      of(a, v[c + 8 >> 2]);
      eb = c + 16 | 0;
      break e;
     }
     pf();
     p();
    }
    Ad(a, d);
    c = d;
   }
   d = v[a >> 2];
   Ad(a, c + 1 | 0);
   break a;
  }
  Me(a, c + 1 | 0);
  d = a;
 }
 a = c + d | 0;
 gd(a, b);
 gd(a + 1 | 0, 0);
}

function ama(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0;
 e = eb - 16 | 0;
 eb = e;
 h = v[a + 24 >> 2];
 i = v[a + 20 >> 2];
 j = v[a + 16 >> 2];
 g = v[a + 4 >> 2];
 v[e + 8 >> 2] = v[a >> 2];
 v[e + 12 >> 2] = g;
 k = b + 24 | 0;
 g = v[a + 8 >> 2];
 l = v[a + 12 >> 2];
 while (1) {
  if (d) {
   b = v[e + 8 >> 2];
   f = (v[e + 12 >> 2] << 1) + j | 0;
   b = (((b >>> 16 | 0) + 4 & 131064) << 1) + k | 0;
   b = (((((B(u[f + 4 >> 1], u[b + 10 >> 1]) + B(u[f + 2 >> 1], u[b + 8 >> 1]) | 0) + B(u[f + 6 >> 1], u[b + 12 >> 1]) | 0) + B(u[f + 8 >> 1], u[b + 14 >> 1]) | 0) / 2 | 0) + ((((B(u[f - 4 >> 1], u[b + 2 >> 1]) + B(u[f - 6 >> 1], u[b >> 1]) | 0) + B(u[f - 2 >> 1], u[b + 4 >> 1]) | 0) + B(u[f >> 1], u[b + 6 >> 1]) | 0) / 2 | 0) | 0) / 16384 | 0;
   v[c >> 2] = v[c >> 2] + B(b, i);
   v[c + 4 >> 2] = v[c + 4 >> 2] + B(b, h);
   Ob(e + 8 | 0, g, l);
   c = c + 8 | 0;
   d = d - 1 | 0;
   continue;
  }
  break;
 }
 b = v[e + 12 >> 2];
 v[a >> 2] = v[e + 8 >> 2];
 v[a + 4 >> 2] = b;
 eb = e + 16 | 0;
}

function Xw(a, b, c, d) {
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0;
 f = eb - 16 | 0;
 eb = f;
 t[f + 15 | 0] = d;
 t[b + 12 | 0] = w[b + 12 | 0] & 240 | w[a | 0] & 15;
 i = a + 1 | 0;
 e = f + 15 | 0;
 eh(b, w[Pb(i, e) | 0]);
 g = w[Pb(a + 2 | 0, e) | 0];
 t[b + 13 | 0] = g;
 k = b, l = Kd(w[a + 3 | 0], g, d), t[k + 14 | 0] = l;
 e = w[Pb(a + 4 | 0, e) | 0];
 t[b + 15 | 0] = e;
 k = b, l = Kd(w[a + 5 | 0], e, d), t[k + 16 | 0] = l;
 g = a + 6 | 0;
 e = v[b >> 2];
 b = 0;
 while (1) {
  t[f + 14 | 0] = 25;
  if (b >>> 0 < w[Pb(f + 14 | 0, i) | 0]) {
   d = B(b, 3) + g | 0;
   h = Xb(w[d | 0] + c << 24 >> 24, 0, 64);
   a = xb(e, b);
   t[a + 2 | 0] = h;
   d = w[d + 1 | 0] | w[d + 2 | 0] << 8;
   u[a >> 1] = d;
   a: {
    if (!b) {
     break a;
    }
    h = xb(e, b - 1 | 0);
    j = x[h >> 1];
    if (d >>> 0 > 255 | d >>> 0 >= j >>> 0) {
     break a;
    }
    d = d | j & 65280;
    u[a >> 1] = d;
    if (x[h >> 1] <= (d & 65535) >>> 0) {
     break a;
    }
    u[a >> 1] = d + 256;
   }
   b = b + 1 | 0;
   continue;
  }
  break;
 }
 eb = f + 16 | 0;
}

function tL(a, b, c, d, e) {
 var f = 0, g = 0, h = 0, i = 0;
 f = eb - 208 | 0;
 eb = f;
 v[f + 204 >> 2] = c;
 c = f + 160 | 0;
 Qb(c, 0, 40);
 v[f + 200 >> 2] = v[f + 204 >> 2];
 a: {
  if ((sL(0, b, f + 200 | 0, f + 80 | 0, c, d, e) | 0) < 0) {
   e = -1;
   break a;
  }
  i = v[a + 76 >> 2] < 0;
  g = v[a >> 2];
  v[a >> 2] = g & -33;
  b: {
   c: {
    d: {
     if (!v[a + 48 >> 2]) {
      v[a + 48 >> 2] = 80;
      v[a + 28 >> 2] = 0;
      v[a + 16 >> 2] = 0;
      v[a + 20 >> 2] = 0;
      h = v[a + 44 >> 2];
      v[a + 44 >> 2] = f;
      break d;
     }
     if (v[a + 16 >> 2]) {
      break c;
     }
    }
    c = -1;
    if (Uw(a)) {
     break b;
    }
   }
   c = sL(a, b, f + 200 | 0, f + 80 | 0, f + 160 | 0, d, e);
  }
  if (h) {
   hb[v[a + 36 >> 2]](a, 0, 0) | 0;
   v[a + 48 >> 2] = 0;
   v[a + 44 >> 2] = h;
   v[a + 28 >> 2] = 0;
   b = v[a + 20 >> 2];
   v[a + 16 >> 2] = 0;
   v[a + 20 >> 2] = 0;
   c = b ? c : -1;
  }
  b = a;
  a = v[a >> 2];
  v[b >> 2] = a | g & 32;
  e = a & 32 ? -1 : c;
  if (i) {
   break a;
  }
 }
 eb = f + 208 | 0;
 return e;
}

function sua(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0;
 d = eb - 208 | 0;
 eb = d;
 s0(c, a);
 r0(c, d + 16 | 0, B(w[a + 4 | 0], 3));
 a: {
  if (w[a + 4 | 0] < 2) {
   break a;
  }
  c = eb - 16 | 0;
  eb = c;
  v[c + 12 >> 2] = 64;
  v[c + 8 >> 2] = 255;
  e = w[Gb(c + 12 | 0, c + 8 | 0) | 0];
  eb = c + 16 | 0;
  t[d + 12 | 0] = e;
  eh(b, w[Pb(a + 4 | 0, d + 12 | 0) | 0]);
  t[b + 13 | 0] = w[a + 2 | 0];
  t[b + 14 | 0] = w[a + 3 | 0];
  a = w[a + 1 | 0];
  t[b + 15 | 0] = a;
  t[b + 16 | 0] = a;
  e = v[b >> 2];
  f = Rd(e, v[b + 4 >> 2]);
  a = 0;
  while (1) {
   if ((a | 0) == (f | 0)) {
    break a;
   }
   b: {
    if (!a) {
     b = w[d + 18 | 0];
     c = xb(e, 0);
     break b;
    }
    g = x[xb(e, a - 1 | 0) >> 1];
    v[d + 12 >> 2] = 1;
    b = (d + 16 | 0) + B(a, 3) | 0;
    v[d + 8 >> 2] = (t[b + 1 | 0] & 1) << 8 | w[b | 0];
    h = Ye(d + 12 | 0, d + 8 | 0);
    c = xb(e, a);
    u[c >> 1] = x[h >> 1] + g;
    b = w[b + 2 | 0];
   }
   t[c + 2 | 0] = b;
   a = a + 1 | 0;
   continue;
  }
 }
 eb = d + 208 | 0;
}

function bG(a) {
 var b = 0, c = 0, d = 0, e = 0, f = 0, g = 0;
 a: {
  if ((w[a | 0] | w[a + 1 | 0] << 8 | (w[a + 2 | 0] << 16 | w[a + 3 | 0] << 24)) != -1641380927) {
   break a;
  }
  b = w[a + 16 | 0] | w[a + 17 | 0] << 8 | (w[a + 18 | 0] << 16 | w[a + 19 | 0] << 24);
  if (b >>> 0 < 36) {
   break a;
  }
  c = w[a + 24 | 0] | w[a + 25 | 0] << 8 | (w[a + 26 | 0] << 16 | w[a + 27 | 0] << 24);
  if (c >>> 0 < 36) {
   break a;
  }
  d = w[a + 32 | 0] | w[a + 33 | 0] << 8 | (w[a + 34 | 0] << 16 | w[a + 35 | 0] << 24);
  if (d >>> 0 < 36) {
   break a;
  }
  e = w[a + 12 | 0] | w[a + 13 | 0] << 8 | (w[a + 14 | 0] << 16 | w[a + 15 | 0] << 24);
  if (e - 1 >>> 0 > 858993458) {
   break a;
  }
  f = w[a + 20 | 0] | w[a + 21 | 0] << 8 | (w[a + 22 | 0] << 16 | w[a + 23 | 0] << 24);
  if (f - 1 >>> 0 > 536870910) {
   break a;
  }
  a = w[a + 28 | 0] | w[a + 29 | 0] << 8 | (w[a + 30 | 0] << 16 | w[a + 31 | 0] << 24);
  if (B(e, -5) - 1 >>> 0 < b >>> 0 | a - 1 >>> 0 > 1073741822 | (f << 3 ^ -1) >>> 0 < c >>> 0) {
   break a;
  }
  g = (a << 2 ^ -1) >>> 0 >= d >>> 0;
 }
 return g;
}

function i7(a, b, c, d, e, f, g, h, i, j) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 f = f | 0;
 g = g | 0;
 h = h | 0;
 i = i | 0;
 j = j | 0;
 var k = 0, l = 0, m = 0, n = 0;
 k = eb - 16 | 0;
 eb = k;
 l = j;
 a: {
  if (a) {
   a = k + 4 | 0;
   b = NJ(b);
   jl(a, b);
   j = v[k + 4 >> 2];
   t[c | 0] = j;
   t[c + 1 | 0] = j >>> 8;
   t[c + 2 | 0] = j >>> 16;
   t[c + 3 | 0] = j >>> 24;
   il(a, b);
   mh(i, a);
   Tb(a);
   ci(a, b);
   mh(h, a);
   Tb(a);
   m = d, n = jj(b), v[m >> 2] = n;
   m = e, n = lj(b), v[m >> 2] = n;
   rh(a, b);
   yb(f, a);
   sb(a);
   di(a, b);
   mh(g, a);
   Tb(k + 4 | 0);
   a = Hk(b);
   break a;
  }
  a = k + 4 | 0;
  b = MJ(b);
  jl(a, b);
  j = v[k + 4 >> 2];
  t[c | 0] = j;
  t[c + 1 | 0] = j >>> 8;
  t[c + 2 | 0] = j >>> 16;
  t[c + 3 | 0] = j >>> 24;
  il(a, b);
  mh(i, a);
  Tb(a);
  ci(a, b);
  mh(h, a);
  Tb(a);
  m = d, n = jj(b), v[m >> 2] = n;
  m = e, n = lj(b), v[m >> 2] = n;
  rh(a, b);
  yb(f, a);
  sb(a);
  di(a, b);
  mh(g, a);
  Tb(k + 4 | 0);
  a = Hk(b);
 }
 v[l >> 2] = a;
 eb = k + 16 | 0;
}

function P7(a, b, c, d, e) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 var f = 0, g = 0, h = 0;
 f = eb - 32 | 0;
 eb = f;
 v[f + 28 >> 2] = b;
 a: {
  if (!(t[c + 4 | 0] & 1)) {
   c = hb[v[v[a >> 2] + 24 >> 2]](a, b, c, d, e) | 0;
   break a;
  }
  a = f + 16 | 0;
  bd(a, v[c + 28 >> 2]);
  v[31601] = 0;
  b = Q(1252, v[f + 16 >> 2]) | 0;
  c = v[31601];
  v[31601] = 0;
  b: {
   if ((c | 0) != 1) {
    Zb(a);
    c: {
     if (e) {
      di(a, b);
      break c;
     }
     ci(f + 16 | 0, b);
    }
    g = f, h = yd(f + 16 | 0), v[g + 12 >> 2] = h;
    while (1) {
     a = f + 16 | 0;
     b = ll(a);
     c = v[f + 12 >> 2];
     if (!Hb(c, b)) {
      c = v[f + 28 >> 2];
      Tb(a);
      break a;
     }
     a = v[c >> 2];
     v[31601] = 0;
     O(1267, f + 28 | 0, a | 0) | 0;
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) != 1) {
      Xe(f + 12 | 0);
      continue;
     }
     break;
    }
    c = M() | 0;
    Tb(f + 16 | 0);
    break b;
   }
   c = M() | 0;
   Zb(f + 16 | 0);
  }
  P(c | 0);
  p();
 }
 eb = f + 32 | 0;
 return c | 0;
}

function $d(a, b) {
 var c = 0, d = 0, e = 0;
 c = eb - 32 | 0;
 eb = c;
 a = $h(a, -1, -1);
 a: {
  b: {
   if (Hd(w[Em(c + 31 | 0, b, 1) | 0])) {
    d = v[(v[v[b >> 2] - 12 >> 2] + b | 0) + 24 >> 2];
    v[31601] = 0;
    Ns(86, c + 8 | 0, d, 0, 0, 1);
    d = v[31601];
    v[31601] = 0;
    c: {
     if ((d | 0) != 1) {
      d = v[c + 12 >> 2];
      v[a >> 2] = v[c + 8 >> 2];
      v[a + 4 >> 2] = d;
      d = v[c + 20 >> 2];
      v[a + 8 >> 2] = v[c + 16 >> 2];
      v[a + 12 >> 2] = d;
      break c;
     }
     X(S(0) | 0) | 0;
     e = 1;
     Cm(v[v[b >> 2] - 12 >> 2] + b | 0, 1);
     if (v[(v[v[b >> 2] - 12 >> 2] + b | 0) + 20 >> 2] & 1) {
      v[31601] = 0;
      W(84);
      a = v[31601];
      v[31601] = 0;
      if ((a | 0) != 1) {
       break a;
      }
      a = M() | 0;
      v[31601] = 0;
      W(26);
      b = v[31601];
      v[31601] = 0;
      if ((b | 0) == 1) {
       break b;
      }
      P(a | 0);
      p();
     }
     Y();
    }
    Wj(v[v[b >> 2] - 12 >> 2] + b | 0, e);
   }
   eb = c + 32 | 0;
   return;
  }
  S(0) | 0;
  Rb();
 }
 p();
}

function Z7(a, b, c, d, e) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 var f = 0, g = 0, h = 0;
 f = eb - 32 | 0;
 eb = f;
 v[f + 28 >> 2] = b;
 a: {
  if (!(t[c + 4 | 0] & 1)) {
   c = hb[v[v[a >> 2] + 24 >> 2]](a, b, c, d, e) | 0;
   break a;
  }
  a = f + 16 | 0;
  bd(a, v[c + 28 >> 2]);
  v[31601] = 0;
  b = Q(1234, v[f + 16 >> 2]) | 0;
  c = v[31601];
  v[31601] = 0;
  b: {
   if ((c | 0) != 1) {
    Zb(a);
    c: {
     if (e) {
      di(a, b);
      break c;
     }
     ci(f + 16 | 0, b);
    }
    g = f, h = yd(f + 16 | 0), v[g + 12 >> 2] = h;
    while (1) {
     a = f + 16 | 0;
     b = Cf(a);
     c = v[f + 12 >> 2];
     if (!Hb(c, b)) {
      c = v[f + 28 >> 2];
      sb(a);
      break a;
     }
     a = t[c | 0];
     v[31601] = 0;
     O(30, f + 28 | 0, a | 0) | 0;
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) != 1) {
      xe(f + 12 | 0);
      continue;
     }
     break;
    }
    c = M() | 0;
    sb(f + 16 | 0);
    break b;
   }
   c = M() | 0;
   Zb(f + 16 | 0);
  }
  P(c | 0);
  p();
 }
 eb = f + 32 | 0;
 return c | 0;
}

function Ufa(a) {
 a = a | 0;
 var b = 0;
 b = 8016;
 a: {
  b: {
   c: {
    switch (a - 277 | 0) {
    default:
     if ((a | 0) == 357) {
      break b;
     }
     d: {
      if ((a | 0) != 257) {
       if ((a | 0) == 267) {
        break d;
       }
       if (a) {
        break a;
       }
       b = 22256;
       break a;
      }
      b = 8049;
      break a;
     }
     b = 18166;
     break a;

    case 0:
     b = 5011;
     break a;

    case 9:
     b = 8072;
     break a;

    case 10:
     b = 8086;
     break a;

    case 11:
     b = 5388;
     break a;

    case 12:
     b = 5408;
     break a;

    case 19:
     b = 8098;
     break a;

    case 20:
     b = 8030;
     break a;

    case 21:
     b = 12898;
     break a;

    case 22:
     b = 12221;
     break a;

    case 1:
    case 2:
    case 3:
    case 4:
    case 5:
    case 6:
    case 7:
    case 8:
    case 13:
    case 14:
    case 15:
    case 16:
    case 17:
    case 18:
     break a;

    case 23:
     break c;
    }
   }
   b = 6019;
   break a;
  }
  b = 7983;
 }
 return Bg(b) | 0;
}

function eh(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0;
 d = v[a >> 2];
 c = nc(d, v[a + 4 >> 2]);
 if (c >>> 0 < b >>> 0) {
  e = eb - 32 | 0;
  eb = e;
  b = b - c | 0;
  c = v[zb(a) >> 2];
  d = v[a + 4 >> 2];
  a: {
   if (b >>> 0 <= c - d >> 2 >>> 0) {
    c = eb - 16 | 0;
    eb = c;
    b = wh(c + 4 | 0, a, b);
    a = v[b + 4 >> 2];
    d = v[b + 8 >> 2];
    while (1) {
     if ((a | 0) == (d | 0)) {
      hc(b);
      eb = c + 16 | 0;
     } else {
      Ww(a);
      a = a + 4 | 0;
      v[b + 4 >> 2] = a;
      continue;
     }
     break;
    }
    break a;
   }
   c = zb(a);
   c = Yf(e + 12 | 0, Kf(a, nc(v[a >> 2], d) + b | 0), nc(v[a >> 2], v[a + 4 >> 2]), c);
   f = eb - 16 | 0;
   eb = f;
   b = En(f + 4 | 0, c + 8 | 0, b);
   d = v[b >> 2];
   while (1) {
    if (v[b + 4 >> 2] != (d | 0)) {
     Ww(d);
     d = v[b >> 2] + 4 | 0;
     v[b >> 2] = d;
     continue;
    }
    break;
   }
   ie(b);
   eb = f + 16 | 0;
   Zr(a, c);
   Xf(c);
  }
  eb = e + 32 | 0;
  return;
 }
 if (b >>> 0 < c >>> 0) {
  Id(a, d + (b << 2) | 0);
 }
}

function pta(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0;
 e = U_(c, d);
 g = eb - 32 | 0;
 eb = g;
 f = b;
 b = v[a >> 2];
 b = yk(f, vb(b)) + b | 0;
 a: {
  if ((e | 0) <= 0) {
   break a;
  }
  h = v[zb(a) >> 2];
  f = v[a + 4 >> 2];
  if ((e | 0) <= (h - f | 0)) {
   i = g, j = S_(c, e), v[i + 12 >> 2] = j;
   h = f - b | 0;
   if ((e | 0) > (h | 0)) {
    v[g + 12 >> 2] = c;
    R_(g + 12 | 0, h);
    xn(a, v[g + 12 >> 2], d, e - h | 0);
    if ((h | 0) <= 0) {
     break a;
    }
   }
   Q_(a, b, f, b + e | 0);
   dw(c, v[g + 12 >> 2], b);
   break a;
  }
  d = zb(a);
  f = on(g + 12 | 0, Tl(a, Sc(v[a >> 2], f) + e | 0), b - v[a >> 2] | 0, d);
  d = eb - 16 | 0;
  eb = d;
  v[d + 12 >> 2] = c;
  c = CC(d, f + 8 | 0, e);
  e = v[c >> 2];
  while (1) {
   if (v[c + 4 >> 2] != (e | 0)) {
    po(e, w[v[d + 12 >> 2]]);
    e = v[c >> 2] + 1 | 0;
    v[c >> 2] = e;
    xe(d + 12 | 0);
    continue;
   }
   break;
  }
  ie(c);
  eb = d + 16 | 0;
  b = P_(a, f, b);
  nn(f);
 }
 vb(b);
 eb = g + 32 | 0;
}

function _k(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0;
 e = eb - 16 | 0;
 eb = e;
 f = a + 36 | 0;
 c = v[a + 32 >> 2];
 a: {
  b: {
   while (1) {
    if ((b | 0) <= (c | 0)) {
     break b;
    }
    c: {
     d = v[a + 20 >> 2];
     if (d >>> 0 >= y[a + 24 >> 2]) {
      ul(e, f, xG(f));
      rd(e + 8 | 0, a, v[e >> 2], v[e + 4 >> 2]);
      c = v[e + 12 >> 2];
      v[a + 24 >> 2] = c;
      v[a + 20 >> 2] = 0;
      if (!c) {
       break c;
      }
      d = 0;
      c = v[a + 32 >> 2];
     }
     v[a + 20 >> 2] = d + 1;
     g = w[d + f | 0];
     d = c + 8 | 0;
     v[a + 32 >> 2] = d;
     v[a + 28 >> 2] = v[a + 28 >> 2] | g << c;
     c = d;
     continue;
    }
    break;
   }
   a = cc(8);
   v[31601] = 0;
   b = Q(161, a | 0) | 0;
   c = v[31601];
   v[31601] = 0;
   if ((c | 0) != 1) {
    break a;
   }
   b = M() | 0;
   jc(a);
   P(b | 0);
   p();
  }
  v[a + 32 >> 2] = c - b;
  d = a;
  a = v[a + 28 >> 2];
  v[d + 28 >> 2] = a >>> b;
  eb = e + 16 | 0;
  return a & (-1 << b ^ -1);
 }
 ca(b | 0, 28784, 162);
 p();
}

function Dma(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0;
 b = eb - 16 | 0;
 eb = b;
 f = v[a + 40 >> 2];
 g = v[a + 36 >> 2];
 i = v[a + 16 >> 2];
 e = v[a + 4 >> 2];
 v[b + 8 >> 2] = v[a >> 2];
 v[b + 12 >> 2] = e;
 j = v[a + 32 >> 2];
 k = v[a + 28 >> 2];
 l = v[a + 8 >> 2];
 m = v[a + 12 >> 2];
 while (1) {
  if (d) {
   e = v[b + 8 >> 2];
   h = (v[b + 12 >> 2] << 1) + i | 0;
   e = e >>> 21 & 2040;
   e = (((B(u[h >> 1], u[e + 38050 >> 1]) + B(u[h - 2 >> 1], u[e + 38048 >> 1]) | 0) + B(u[h + 2 >> 1], u[e + 38052 >> 1]) | 0) + B(u[h + 4 >> 1], u[e + 38054 >> 1]) | 0) / 16384 | 0;
   g = g + k | 0;
   v[c >> 2] = v[c >> 2] + B(e, g >> 12);
   f = f + j | 0;
   v[c + 4 >> 2] = v[c + 4 >> 2] + B(e, f >> 12);
   Ob(b + 8 | 0, l, m);
   c = c + 8 | 0;
   d = d - 1 | 0;
   continue;
  }
  break;
 }
 c = v[b + 12 >> 2];
 v[a >> 2] = v[b + 8 >> 2];
 v[a + 4 >> 2] = c;
 v[a + 40 >> 2] = f;
 v[a + 20 >> 2] = g >> 12;
 v[a + 36 >> 2] = g;
 v[a + 24 >> 2] = f >> 12;
 eb = b + 16 | 0;
}

function bma(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0;
 e = eb - 16 | 0;
 eb = e;
 h = v[a + 24 >> 2];
 i = v[a + 20 >> 2];
 j = v[a + 16 >> 2];
 g = v[a + 4 >> 2];
 v[e + 8 >> 2] = v[a >> 2];
 v[e + 12 >> 2] = g;
 k = b + 24 | 0;
 g = v[a + 8 >> 2];
 l = v[a + 12 >> 2];
 while (1) {
  if (d) {
   b = v[e + 8 >> 2];
   f = v[e + 12 >> 2] + j | 0;
   b = (((b >>> 16 | 0) + 4 & 131064) << 1) + k | 0;
   b = ((((B(t[f + 2 | 0], u[b + 10 >> 1]) + B(t[f + 1 | 0], u[b + 8 >> 1]) | 0) + B(t[f + 3 | 0], u[b + 12 >> 1]) | 0) + B(t[f + 4 | 0], u[b + 14 >> 1]) << 8 >> 1) + (((B(t[f - 2 | 0], u[b + 2 >> 1]) + B(t[f - 3 | 0], u[b >> 1]) | 0) + B(t[f - 1 | 0], u[b + 4 >> 1]) | 0) + B(t[f | 0], u[b + 6 >> 1]) << 8 >> 1) | 0) / 16384 | 0;
   v[c >> 2] = v[c >> 2] + B(b, i);
   v[c + 4 >> 2] = v[c + 4 >> 2] + B(b, h);
   Ob(e + 8 | 0, g, l);
   c = c + 8 | 0;
   d = d - 1 | 0;
   continue;
  }
  break;
 }
 b = v[e + 12 >> 2];
 v[a >> 2] = v[e + 8 >> 2];
 v[a + 4 >> 2] = b;
 eb = e + 16 | 0;
}

function XM(a, b) {
 var c = 0, d = 0, e = 0, f = 0, g = 0;
 c = v[a >> 2];
 v[a >> 2] = b;
 if (c) {
  v[31601] = 0;
  V(852, c | 0);
  a = v[31601];
  v[31601] = 0;
  a: {
   if ((a | 0) != 1) {
    d = v[c + 4 >> 2];
    if (d) {
     e = eb - 16 | 0;
     eb = e;
     f = ub(e + 12 | 0, d);
     a = v[f >> 2];
     if (v[a >> 2]) {
      g = v[a >> 2];
      b = v[a + 4 >> 2];
      while (1) {
       if ((b | 0) != (g | 0)) {
        b = b - 4 | 0;
        lg(b);
        continue;
       }
       break;
      }
      v[a + 4 >> 2] = g;
      a = v[f >> 2];
      b = v[a >> 2];
      Ug(a);
      Bb(b);
     }
     eb = e + 16 | 0;
     Bb(d);
    }
    v[c + 4 >> 2] = 0;
    oS(c + 1298412 | 0);
    ZA(c + 1298344 | 0);
    sb(c + 1298332 | 0);
    sb(c + 1298320 | 0);
    sb(c + 1298308 | 0);
    YA(c + 1298304 | 0);
    XA(c + 1298300 | 0);
    Su(c + 1298264 | 0);
    lB(c + 1074376 | 0);
    nS(c + 906300 | 0);
    aC(c + 484360 | 0);
    fS(c + 484344 | 0);
    uc(c + 480248 | 0);
    break a;
   }
   S(0) | 0;
   Rb();
   p();
  }
  Bb(c);
 }
}

function Ema(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0;
 b = eb - 16 | 0;
 eb = b;
 f = v[a + 40 >> 2];
 g = v[a + 36 >> 2];
 i = v[a + 16 >> 2];
 e = v[a + 4 >> 2];
 v[b + 8 >> 2] = v[a >> 2];
 v[b + 12 >> 2] = e;
 j = v[a + 32 >> 2];
 k = v[a + 28 >> 2];
 l = v[a + 8 >> 2];
 m = v[a + 12 >> 2];
 while (1) {
  if (d) {
   e = v[b + 8 >> 2];
   h = v[b + 12 >> 2] + i | 0;
   e = e >>> 21 & 2040;
   e = (((B(t[h | 0], u[e + 38050 >> 1]) + B(t[h - 1 | 0], u[e + 38048 >> 1]) | 0) + B(t[h + 1 | 0], u[e + 38052 >> 1]) | 0) + B(t[h + 2 | 0], u[e + 38054 >> 1]) << 8) / 16384 | 0;
   g = g + k | 0;
   v[c >> 2] = v[c >> 2] + B(e, g >> 12);
   f = f + j | 0;
   v[c + 4 >> 2] = v[c + 4 >> 2] + B(e, f >> 12);
   Ob(b + 8 | 0, l, m);
   c = c + 8 | 0;
   d = d - 1 | 0;
   continue;
  }
  break;
 }
 c = v[b + 12 >> 2];
 v[a >> 2] = v[b + 8 >> 2];
 v[a + 4 >> 2] = c;
 v[a + 40 >> 2] = f;
 v[a + 20 >> 2] = g >> 12;
 v[a + 36 >> 2] = g;
 v[a + 24 >> 2] = f >> 12;
 eb = b + 16 | 0;
}

function Fqa(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0;
 e = eb - 16 | 0;
 eb = e;
 i = e, j = Pj(b), v[i + 4 >> 2] = j;
 f = x[b >> 1];
 d = eb - 16 | 0;
 eb = d;
 g = a;
 c = ce(a);
 a: {
  if (c) {
   b = fc(a);
   while (1) {
    a = c;
    c = x[a + 14 >> 1];
    if (_o(f, c)) {
     b = a;
     c = v[a >> 2];
     if (c) {
      continue;
     }
     break a;
    }
    if (!_o(c, f)) {
     break a;
    }
    b = a + 4 | 0;
    c = v[a + 4 >> 2];
    if (c) {
     continue;
    }
    break;
   }
   break a;
  }
  a = fc(g);
  b = a;
 }
 v[d + 12 >> 2] = a;
 a = v[b >> 2];
 if (!a) {
  a = eb - 16 | 0;
  eb = a;
  c = fc(g);
  f = Ch(d, Dc(20), Ng(a + 8 | 0, c));
  c = v[f >> 2];
  h = x[v[e + 4 >> 2] >> 1];
  u[c + 16 >> 1] = 0;
  u[c + 14 >> 1] = h;
  i = fc(f), j = 1, t[i + 4 | 0] = j;
  eb = a + 16 | 0;
  _g(g, v[d + 12 >> 2], b, v[d >> 2]);
  a = me(d);
  Gk(d);
  h = 1;
 }
 Zg(e + 8 | 0, v[ub(d, a) >> 2], h);
 eb = d + 16 | 0;
 a = cp(v[e + 8 >> 2]);
 eb = e + 16 | 0;
 return a + 2 | 0;
}

function qF(a) {
 var b = 0, c = 0, d = 0, e = 0, f = 0, g = 0;
 a: {
  b = w[a | 0] | w[a + 1 | 0] << 8;
  b: {
   if ((b | 0) != 26217) {
    if ((b | 0) != 20042) {
     break a;
    }
    if (w[a + 110 | 0] <= 64) {
     break b;
    }
    break a;
   }
   if (w[a + 110 | 0] > 64) {
    break a;
   }
  }
  if (t[a + 112 | 0] < 0 | w[a + 111 | 0] > 128) {
   break a;
  }
  b = 2;
  while (1) {
   if ((b | 0) == 110) {
    d = a + 369 | 0;
    e = a + 241 | 0;
    a = a + 113 | 0;
    b = 0;
    while (1) {
     c = (b | 0) == 128;
     if (c) {
      break a;
     }
     f = t[a + b | 0];
     if ((f | 0) < -2) {
      break a;
     }
     g = w[b + e | 0];
     if (!g & (f | 0) >= 0 | g >>> 0 > 15) {
      break a;
     }
     f = b + d | 0;
     b = b + 1 | 0;
     if (w[f | 0] < 64) {
      continue;
     }
     break;
    }
    break a;
   }
   e = (w[a + b | 0] - 32 & 255) >>> 0 < 225;
   d = c + 1 | 0;
   if (e | (d & 255) >>> 0 <= 40) {
    c = e ? c : d;
    b = b + 1 | 0;
    continue;
   } else {
    return 0;
   }
  }
 }
 return c;
}

function _g(a, b, c, d) {
 var e = 0, f = 0;
 v[d + 8 >> 2] = b;
 v[d >> 2] = 0;
 v[d + 4 >> 2] = 0;
 v[c >> 2] = d;
 b = v[v[a >> 2] >> 2];
 if (b) {
  v[a >> 2] = b;
  d = v[c >> 2];
 }
 f = v[fc(a) >> 2];
 t[d + 12 | 0] = (f | 0) == (d | 0);
 while (1) {
  a: {
   if ((d | 0) == (f | 0)) {
    break a;
   }
   c = v[d + 8 >> 2];
   if (w[c + 12 | 0]) {
    break a;
   }
   b = v[c + 8 >> 2];
   b: {
    if (li(c)) {
     e = v[b + 4 >> 2];
     if (!(!e | w[e + 12 | 0])) {
      break b;
     }
     if (!li(d)) {
      pr(c);
      c = v[c + 8 >> 2];
     }
     t[c + 12 | 0] = 1;
     b = v[c + 8 >> 2];
     t[b + 12 | 0] = 0;
     nr(b);
     break a;
    }
    e = v[b >> 2];
    if (!(!e | w[e + 12 | 0])) {
     break b;
    }
    if (li(d)) {
     nr(c);
     c = v[c + 8 >> 2];
    }
    t[c + 12 | 0] = 1;
    b = v[c + 8 >> 2];
    t[b + 12 | 0] = 0;
    pr(b);
    break a;
   }
   t[c + 12 | 0] = 1;
   t[b + 12 | 0] = (b | 0) == (f | 0);
   t[e + 12 | 0] = 1;
   d = b;
   continue;
  }
  break;
 }
 a = zb(a);
 v[a >> 2] = v[a >> 2] + 1;
}

function VZ(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0;
 e = eb - 16 | 0;
 eb = e;
 i = e, j = Pj(b), v[i + 4 >> 2] = j;
 f = v[b >> 2];
 d = eb - 16 | 0;
 eb = d;
 g = a;
 c = ce(a);
 a: {
  if (c) {
   b = fc(a);
   while (1) {
    a = c;
    c = v[a + 16 >> 2];
    if (rE(f, c)) {
     b = a;
     c = v[a >> 2];
     if (c) {
      continue;
     }
     break a;
    }
    if (!rE(c, f)) {
     break a;
    }
    b = a + 4 | 0;
    c = v[a + 4 >> 2];
    if (c) {
     continue;
    }
    break;
   }
   break a;
  }
  a = fc(g);
  b = a;
 }
 v[d + 12 >> 2] = a;
 a = v[b >> 2];
 if (!a) {
  a = eb - 16 | 0;
  eb = a;
  c = fc(g);
  f = Ch(d, Dc(24), Ng(a + 8 | 0, c));
  c = v[f >> 2];
  h = v[v[e + 4 >> 2] >> 2];
  v[c + 20 >> 2] = 0;
  v[c + 16 >> 2] = h;
  i = fc(f), j = 1, t[i + 4 | 0] = j;
  eb = a + 16 | 0;
  _g(g, v[d + 12 >> 2], b, v[d >> 2]);
  a = me(d);
  Gk(d);
  h = 1;
 }
 Zg(e + 8 | 0, v[ub(d, a) >> 2], h);
 eb = d + 16 | 0;
 a = td(v[e + 8 >> 2]);
 eb = e + 16 | 0;
 return a + 4 | 0;
}

function gpa(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0;
 e = eb - 32 | 0;
 eb = e;
 a: {
  c = v[a + 12 >> 2];
  b: {
   if ((c | 0) == (b | 0)) {
    break b;
   }
   f = b >>> 0 > c >>> 0;
   c = B(x[v[v[a + 48 >> 2] + 12 >> 2] + 480188 >> 1], f ? b - c | 0 : c - b | 0);
   d = vb(v[a + 4 >> 2]);
   c: {
    if (f) {
     d = ub(e + 28 | 0, d);
     u[e + 24 >> 1] = 0;
     v[e + 20 >> 2] = 0;
     d = v[d >> 2];
     v[31601] = 0;
     U(662, a | 0, d | 0, c | 0, e + 20 | 0);
     c = v[31601];
     v[31601] = 0;
     if ((c | 0) != 1) {
      break c;
     }
     a = S(124508) | 0;
     if ((fb | 0) != (_(124508) | 0)) {
      break a;
     }
     X(a | 0) | 0;
     Y();
     break b;
    }
    c = ub(e + 16 | 0, RD(d, c));
    d = v[ub(e + 12 | 0, vb(v[a + 4 >> 2])) >> 2];
    f = v[c >> 2];
    c = v[a >> 2];
    c = B(xu(f, vb(c)), 6) + c | 0;
    if (Hb(f, d)) {
     Id(a, vA(c + B(xu(d, f), 6) | 0, v[a + 4 >> 2], c));
    }
    vb(c);
   }
   v[a + 12 >> 2] = b;
  }
  eb = e + 32 | 0;
  return;
 }
 P(a | 0);
 p();
}

function _H(a, b, c, d, e) {
 var f = 0, g = 0, h = 0, i = 0;
 g = eb - 16 | 0;
 eb = g;
 h = Eb(a);
 a = 0;
 a: {
  b: {
   c: {
    d: {
     while (1) {
      f = v[b >> 2];
      if (Td(f, v[b + 4 >> 2]) >>> 0 <= a >>> 0) {
       break c;
      }
      e: {
       if (!a) {
        f = Ud(f, 0);
        break e;
       }
       v[31601] = 0;
       O(d | 0, h | 0, c | 0) | 0;
       f = v[31601];
       v[31601] = 0;
       if ((f | 0) == 1) {
        break b;
       }
       f = Ud(v[b >> 2], a);
      }
      v[31601] = 0;
      i = g + 4 | 0;
      N(e | 0, i | 0, f | 0);
      f = v[31601];
      v[31601] = 0;
      if ((f | 0) != 1) {
       v[31601] = 0;
       O(d | 0, h | 0, i | 0) | 0;
       f = v[31601];
       v[31601] = 0;
       if ((f | 0) == 1) {
        break d;
       }
       a = a + 1 | 0;
       sb(i);
       continue;
      }
      break;
     }
     a = M() | 0;
     break a;
    }
    a = M() | 0;
    sb(g + 4 | 0);
    break a;
   }
   eb = g + 16 | 0;
   return;
  }
  a = M() | 0;
 }
 sb(h);
 P(a | 0);
 p();
}

function c3(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0;
 f = c;
 c = eb - 16 | 0;
 eb = c;
 v[31601] = 0;
 V(995, a | 0);
 e = v[31601];
 v[31601] = 0;
 a: {
  b: {
   c: {
    d: {
     if ((e | 0) == 1) {
      break d;
     }
     v[31601] = 0;
     V(996, b | 0);
     e = v[31601];
     v[31601] = 0;
     if ((e | 0) == 1) {
      break d;
     }
     e = v[a + 24 >> 2];
     b = oc(c + 8 | 0, b);
     v[31601] = 0;
     g = v[b + 4 >> 2];
     v[c >> 2] = v[b >> 2];
     v[c + 4 >> 2] = g;
     Ns(1016, e, c, f, d, 1);
     d = v[31601];
     v[31601] = 0;
     b = 1;
     if ((d | 0) != 1) {
      break c;
     }
    }
    X(S(0) | 0) | 0;
    v[31601] = 0;
    U(982, 8642, a | 0, 0, 0);
    a = v[31601];
    v[31601] = 0;
    if ((a | 0) == 1) {
     break b;
    }
    Y();
    b = 0;
   }
   eb = c + 16 | 0;
   break a;
  }
  a = M() | 0;
  v[31601] = 0;
  W(26);
  b = v[31601];
  v[31601] = 0;
  if ((b | 0) != 1) {
   P(a | 0);
   p();
  }
  S(0) | 0;
  Rb();
  p();
 }
 return b | 0;
}

function pQ(a, b) {
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0;
 e = eb - 16 | 0;
 eb = e;
 lh(e + 8 | 0, b);
 f = eb - 16 | 0;
 eb = f;
 lf(f + 8 | 0, v[e + 8 >> 2], v[e + 12 >> 2]);
 g = v[f + 8 >> 2];
 b = v[f + 12 >> 2];
 h = eb - 16 | 0;
 eb = h;
 l = h, m = vb(a), v[l + 12 >> 2] = m;
 a = b;
 b = eb - 16 | 0;
 eb = b;
 i = v[h + 12 >> 2];
 c = i;
 d = v[c + 8 >> 2];
 c = v[c + 12 >> 2];
 a: {
  if ((c | 0) < 0) {
   break a;
  }
  j = v[i + 4 >> 2];
  k = d >>> 0 > j >>> 0;
  if (k & !c | c) {
   break a;
  }
  v[b + 8 >> 2] = j - d;
  v[b + 12 >> 2] = 0 - (c + k | 0);
  v[b >> 2] = a;
  v[b + 4 >> 2] = 0;
  c = q0(b + 8 | 0, b);
  if ((Uu(v[c >> 2], v[c + 4 >> 2]) | 0) != (a | 0)) {
   break a;
  }
  wk(g, a + g | 0, d + v[i >> 2] | 0);
  d = v[h + 12 >> 2];
  g = d;
  c = v[d + 8 >> 2];
  d = v[d + 12 >> 2];
  i = a;
  a = a + c | 0;
  d = i >>> 0 > a >>> 0 ? d + 1 | 0 : d;
  v[g + 8 >> 2] = a;
  v[g + 12 >> 2] = d;
 }
 eb = b + 16 | 0;
 eb = h + 16 | 0;
 eb = f + 16 | 0;
 eb = e + 16 | 0;
}

function X0(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0;
 c = eb - 32 | 0;
 eb = c;
 md(b, 0);
 e = c + 16 | 0;
 f = rf(e, 1, t[a + 1 | 0]);
 Ae(b + 43 | 0, f);
 sb(f);
 v[b >> 2] = w[a + 6 | 0] | w[a + 7 | 0] << 8 | (w[a + 8 | 0] << 16 | w[a + 9 | 0] << 24);
 v[b + 24 >> 2] = w[a + 10 | 0] | w[a + 11 | 0] << 8;
 t[c + 16 | 0] = w[a + 12 | 0];
 t[c + 12 | 0] = 64;
 g = b, h = w[Pb(e, c + 12 | 0) | 0] << 2, u[g + 30 >> 1] = h;
 v[b + 4 >> 2] = w[a + 13 | 0] | w[a + 14 | 0] << 8 | (w[a + 15 | 0] << 16 | w[a + 16 | 0] << 24);
 e = w[a + 19 | 0];
 f = w[a + 17 | 0] | w[a + 18 | 0] << 8;
 t[c + 14 | 0] = 0;
 t[c + 18 | 0] = e;
 u[c + 16 >> 1] = f;
 u[c + 12 >> 1] = 0;
 while (1) {
  if ((d | 0) != 3) {
   e = wb(c + 16 | 0, d);
   g = wb(c + 12 | 0, d), h = w[e | 0], t[g | 0] = h;
   d = d + 1 | 0;
   continue;
  }
  break;
 }
 d = bg(c + 12 | 0);
 v[b + 8 >> 2] = d;
 if (!(!w[a | 0] | d >>> 0 <= v[b + 4 >> 2] + 2 >>> 0 | d >>> 0 > y[b >> 2])) {
  u[b + 34 >> 1] = x[b + 34 >> 1] | 2;
 }
 eb = c + 32 | 0;
}

function lF(a, b, c, d, e) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 var f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
 f = eb - 16 | 0;
 eb = f;
 v[f + 8 >> 2] = e;
 v[f + 12 >> 2] = d;
 sf(a);
 zs(a, c);
 d = 0;
 e = 0;
 a: while (1) {
  if (c >>> 0 > d >>> 0) {
   i = c - d | 0;
   v[f + 4 >> 2] = i;
   g = v[Gb(f + 12 | 0, f + 4 | 0) >> 2];
   h = g + e | 0;
   l = e >>> 0 > h >>> 0 ? e : h;
   j = ys(Jt(a, b + d | 0, g), 1, 13);
   while (1) if ((e | 0) == (l | 0)) {
    v[f + 4 >> 2] = i - g;
    e = h + 1 | 0;
    d = v[Gb(f + 8 | 0, f + 4 | 0) >> 2] + (d + g | 0) | 0;
    continue a;
   } else {
    b: {
     c: {
      d: {
       k = w[dc(j, e) | 0];
       switch (k - 10 | 0) {
       case 1:
       case 2:
        break b;

       case 0:
       case 3:
        break c;

       default:
        break d;
       }
      }
      if (k) {
       break b;
      }
     }
     m = dc(j, e), n = 32, t[m | 0] = n;
    }
    e = e + 1 | 0;
    continue;
   }
  }
  break;
 }
 eb = f + 16 | 0;
}

function Qsa(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0;
 g = eb - 16 | 0;
 eb = g;
 c = 65535;
 e = v[a >> 2];
 a: {
  if (_c(e, v[a + 4 >> 2]) >>> 0 <= b >>> 0) {
   break a;
  }
  e = x[$b(e, b) >> 1];
  b: {
   if (!Vi(a, b)) {
    break b;
   }
   c = v[a + 24 >> 2];
   d = vb(v[c + 484360 >> 2]);
   v[g + 12 >> 2] = d;
   h = vb(v[c + 484364 >> 2]);
   while (1) {
    if (!Hb(d, h)) {
     break b;
    }
    f = 0;
    i = am(v[d >> 2], v[d + 4 >> 2]);
    while (1) {
     if ((f | 0) != (i | 0)) {
      c: {
       if (!((a | 0) != (d | 0) | (b | 0) != (f | 0)) | (e | 0) != x[$b(v[d >> 2], f) >> 1]) {
        break c;
       }
       c = BX(v[a + 24 >> 2] + 484344 | 0, e);
       if ((c | 0) == 65535) {
        break c;
       }
       j = $b(v[a >> 2], b), k = c, u[j >> 1] = k;
       break a;
      }
      f = f + 1 | 0;
      continue;
     }
     break;
    }
    d = v[Zq(g + 12 | 0) >> 2];
    continue;
   }
  }
  c = e;
 }
 eb = g + 16 | 0;
 return c & 65535;
}

function qH(a, b, c) {
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0;
 g = eb - 16 | 0;
 eb = g;
 e = g + 4 | 0;
 t[e + 8 | 0] = 1;
 v[e + 4 >> 2] = c;
 v[e >> 2] = a;
 h = w[e + 8 | 0];
 a = v[e >> 2];
 i = v[e + 4 >> 2];
 j = Jb(b);
 b = Cb(v[b + 4 >> 2], w[b + 11 | 0]);
 d = eb - 16 | 0;
 eb = d;
 v[d + 8 >> 2] = b;
 v[d + 12 >> 2] = i;
 b = a;
 e = v[Gb(d + 12 | 0, d + 8 | 0) >> 2];
 f = e;
 while (1) {
  a: {
   if (!f) {
    f = 0;
    break a;
   }
   c = w[j | 0];
   t[b | 0] = c;
   if (!c) {
    break a;
   }
   j = j + 1 | 0;
   b = b + 1 | 0;
   f = f - 1 | 0;
   continue;
  }
  break;
 }
 b: {
  if ((h - 1 & 255) >>> 0 <= 1) {
   t[d + 7 | 0] = 0;
   Om(b, ((b + i | 0) - e | 0) + f | 0, d + 7 | 0);
   break b;
  }
  if ((h - 3 & 255) >>> 0 > 1) {
   break b;
  }
  t[d + 6 | 0] = 32;
  Om(b, ((b + i | 0) - e | 0) + f | 0, d + 6 | 0);
 }
 c: {
  switch (h - 1 | 0) {
  case 0:
  case 3:
   t[(v[d + 12 >> 2] + a | 0) - 1 | 0] = 0;
   break;

  default:
   break c;
  }
 }
 eb = d + 16 | 0;
 eb = g + 16 | 0;
}

function d3(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0;
 d = eb - 16 | 0;
 eb = d;
 v[31601] = 0;
 V(995, a | 0);
 c = v[31601];
 v[31601] = 0;
 a: {
  b: {
   c: {
    d: {
     if ((c | 0) == 1) {
      break d;
     }
     v[31601] = 0;
     V(996, b | 0);
     c = v[31601];
     v[31601] = 0;
     if ((c | 0) == 1) {
      break d;
     }
     c = v[a + 24 >> 2];
     b = oc(d + 8 | 0, b);
     v[31601] = 0;
     e = v[b + 4 >> 2];
     v[d >> 2] = v[b >> 2];
     v[d + 4 >> 2] = e;
     b = bI(c, d, 1);
     e = v[31601];
     v[31601] = 0;
     c = gb;
     if ((e | 0) != 1) {
      break c;
     }
    }
    X(S(0) | 0) | 0;
    v[31601] = 0;
    U(982, 8673, a | 0, 0, 0);
    a = v[31601];
    v[31601] = 0;
    if ((a | 0) == 1) {
     break b;
    }
    Y();
    b = 0;
    c = 0;
   }
   eb = d + 16 | 0;
   a = c;
   break a;
  }
  a = M() | 0;
  v[31601] = 0;
  W(26);
  b = v[31601];
  v[31601] = 0;
  if ((b | 0) != 1) {
   P(a | 0);
   p();
  }
  S(0) | 0;
  Rb();
  p();
 }
 fb = a;
 return b | 0;
}

function _qa(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0;
 e = eb - 48 | 0;
 eb = e;
 c = v[a + 8 >> 2];
 d = v[a >> 2];
 v[31601] = 0;
 c = T(150, d | 0, c | 0, 1) | 0;
 d = v[31601];
 v[31601] = 0;
 a: {
  if ((d | 0) == 1) {
   break a;
  }
  b: {
   if (!c) {
    break b;
   }
   v[31601] = 0;
   V(516, b | 0);
   c = v[31601];
   v[31601] = 0;
   if ((c | 0) == 1) {
    break a;
   }
   v[31601] = 0;
   c = Q(197, a | 0) | 0;
   d = v[31601];
   v[31601] = 0;
   c: {
    if ((d | 0) != 1) {
     while (1) {
      if (!(c & 255)) {
       break b;
      }
      v[31601] = 0;
      d = e + 15 | 0;
      f = O(517, a | 0, d | 0) | 0;
      g = v[31601];
      v[31601] = 0;
      if ((g | 0) == 1) {
       break c;
      }
      g = f;
      f = w[e + 15 | 0];
      if (g & f >>> 0 < 64) {
       yc(RY(v[b >> 2], f), d, 33);
      }
      c = c - 1 | 0;
      continue;
     }
    }
    break a;
   }
   break a;
  }
  tb(a);
  eb = e + 48 | 0;
  return;
 }
 b = M() | 0;
 tb(a);
 P(b | 0);
 p();
}

function fn(a, b, c, d, e, f, g, h) {
 var i = 0, j = 0, k = 0, l = 0;
 j = 1;
 i = d & 2147483647;
 k = i;
 l = (i | 0) == 2147418112;
 a: {
  if (l & !c ? a | b : l & (c | 0) != 0 | i >>> 0 > 2147418112) {
   break a;
  }
  i = h & 2147483647;
  if (!g & (i | 0) == 2147418112 ? e | f : (i | 0) == 2147418112 & (g | 0) != 0 | i >>> 0 > 2147418112) {
   break a;
  }
  if (!(a | e | (c | g) | (b | f | (i | k)))) {
   return 0;
  }
  j = d & h;
  if ((j | 0) > 0) {
   k = 1;
  } else {
   k = (j | 0) >= 0;
  }
  if (k) {
   j = -1;
   if ((c | 0) == (g | 0) & (d | 0) == (h | 0) ? (b | 0) == (f | 0) & a >>> 0 < e >>> 0 | b >>> 0 < f >>> 0 : c >>> 0 < g >>> 0 & (d | 0) <= (h | 0) | (d | 0) < (h | 0)) {
    break a;
   }
   return (a ^ e | c ^ g | (b ^ f | d ^ h)) != 0;
  }
  j = -1;
  if ((c | 0) == (g | 0) & (d | 0) == (h | 0) ? (b | 0) == (f | 0) & a >>> 0 > e >>> 0 | b >>> 0 > f >>> 0 : c >>> 0 > g >>> 0 & (d | 0) >= (h | 0) | (d | 0) > (h | 0)) {
   break a;
  }
  j = (a ^ e | c ^ g | (b ^ f | d ^ h)) != 0;
 }
 return j;
}

function y4(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0;
 e = b & 512;
 f = b & 256;
 g = b & 128;
 h = b & 64;
 i = b & 32;
 j = b & 16;
 k = b & 8;
 l = b & 4;
 m = b & 2;
 b = b & 1;
 a: {
  while (1) {
   if ((c | 0) == (d | 0)) {
    break a;
   }
   a = v[c >> 2];
   b: {
    if (b) {
     if (Xs(a)) {
      break b;
     }
    }
    if (m) {
     if (Ws(a)) {
      break b;
     }
    }
    if (l) {
     if (Vs(a)) {
      break b;
     }
    }
    if (k) {
     if (Us(a)) {
      break b;
     }
    }
    if (j) {
     if (Ts(a)) {
      break b;
     }
    }
    if (i) {
     if (Ss(a)) {
      break b;
     }
    }
    if (h) {
     if (Zn(a)) {
      break b;
     }
    }
    if (g) {
     if (Rs(a)) {
      break b;
     }
    }
    if (f) {
     if (_n(a)) {
      break b;
     }
    }
    if (e) {
     if (Qs(a)) {
      break b;
     }
    }
    c = c + 4 | 0;
    continue;
   }
   break;
  }
  d = c;
 }
 return d | 0;
}

function xz(a, b, c) {
 var d = 0, e = 0, f = 0, g = 0;
 e = eb - 16 | 0;
 eb = e;
 v[a >> 2] = 0;
 v[a + 4 >> 2] = 0;
 sc(a + 8 | 0);
 Qd(e + 8 | 0, v[ub(e + 4 | 0, a) >> 2]);
 a: {
  b: {
   if (c) {
    v[31601] = 0;
    N(1138, a | 0, c | 0);
    d = v[31601];
    v[31601] = 0;
    if ((d | 0) == 1) {
     break b;
    }
    f = eb - 16 | 0;
    eb = f;
    d = wh(f + 4 | 0, a, c);
    c = v[d + 4 >> 2];
    g = v[d + 8 >> 2];
    while (1) {
     if ((c | 0) == (g | 0)) {
      hc(d);
      eb = f + 16 | 0;
     } else {
      v[c >> 2] = 0;
      sc(c);
      c = c + 4 | 0;
      v[d + 4 >> 2] = c;
      continue;
     }
     break;
    }
   }
   c = e + 8 | 0;
   Pd(c);
   ah(c);
   eb = e + 16 | 0;
   break a;
  }
  a = M() | 0;
  ah(e + 8 | 0);
  P(a | 0);
  p();
 }
 e = a;
 a = 0;
 c = 0;
 d = eb - 16 | 0;
 eb = d;
 f = d + 12 | 0;
 while (1) {
  if (a >>> 0 < 32) {
   a = a + 48 | 0;
   c = dS(b);
   continue;
  }
  break;
 }
 v[f >> 2] = c;
 Co(f);
 eb = d + 16 | 0;
 v[e + 12 >> 2] = v[f >> 2];
 return e;
}

function qW(a, b) {
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0;
 f = eb - 16 | 0;
 eb = f;
 d = ub(f + 12 | 0, v[a + 4 >> 2]);
 c = ub(f + 8 | 0, v[a >> 2]);
 g = v[ub(f + 4 | 0, v[b + 4 >> 2]) >> 2];
 h = eb - 16 | 0;
 eb = h;
 i = h + 8 | 0;
 e = eb - 32 | 0;
 eb = e;
 ed(e + 24 | 0, v[d >> 2], v[c >> 2]);
 j = e + 16 | 0;
 c = v[e + 24 >> 2];
 k = v[e + 28 >> 2];
 d = eb - 16 | 0;
 eb = d;
 v[d + 8 >> 2] = g;
 v[d + 12 >> 2] = c;
 while (1) {
  if (Ed(c, k)) {
   c = $k(c);
   g = $k(v[d + 8 >> 2]);
   v[g + 8 >> 2] = v[c + 8 >> 2];
   l = v[c + 4 >> 2];
   v[g >> 2] = v[c >> 2];
   v[g + 4 >> 2] = l;
   c = ik(d + 12 | 0);
   ik(d + 8 | 0);
   c = v[c >> 2];
   continue;
  }
  break;
 }
 pc(j, c, d + 8 | 0);
 eb = d + 16 | 0;
 d = v[e + 16 >> 2];
 v[e + 12 >> 2] = v[e + 20 >> 2];
 pc(i, d, e + 12 | 0);
 eb = e + 32 | 0;
 eb = h + 16 | 0;
 v[b + 4 >> 2] = v[h + 12 >> 2];
 Sb(a, b + 4 | 0);
 Sb(a + 4 | 0, b + 8 | 0);
 Sb(zb(a), mc(b));
 v[b >> 2] = v[b + 4 >> 2];
 eb = f + 16 | 0;
}

function bla(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0;
 c = eb + -64 | 0;
 eb = c;
 f = oU(a, 1 << b - 1);
 v[f + 12 >> 2] = b;
 l(0, 1413754136 - 0 | 0);
 l(1, -1072094725 - ((b << 20) + (d >>> 0 > 1413754136) | 0) | 0);
 h = +n();
 a = 1;
 g = 1 << b >>> 2 | 0;
 b = g;
 while (1) {
  if (b) {
   e = v[10049];
   d = c + 32 | 0;
   v[d + 8 >> 2] = v[10048];
   v[d + 12 >> 2] = e;
   e = v[10047];
   v[d >> 2] = v[10046];
   v[d + 4 >> 2] = e;
   QB(d, h * +(b >>> 0));
   jU(c + 48 | 0, A[c + 32 >> 3], A[c + 40 >> 3]);
   d = Xd(v[f >> 2], a);
   e = v[c + 60 >> 2];
   v[d + 8 >> 2] = v[c + 56 >> 2];
   v[d + 12 >> 2] = e;
   e = v[c + 52 >> 2];
   v[d >> 2] = v[c + 48 >> 2];
   v[d + 4 >> 2] = e;
   b = b >>> 1 | 0;
   a = a << 1;
   continue;
  }
  break;
 }
 a = Nl(c + 16 | 0, 1, 0);
 b = v[a + 12 >> 2];
 v[c + 8 >> 2] = v[a + 8 >> 2];
 v[c + 12 >> 2] = b;
 b = v[a + 4 >> 2];
 v[c >> 2] = v[a >> 2];
 v[c + 4 >> 2] = b;
 BA(f, 0, g, c);
 eb = c - -64 | 0;
 return f | 0;
}

function GD(a, b, c) {
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0;
 e = eb - 16 | 0;
 eb = e;
 d = (c << 3) + a | 0;
 f = w[d + 356 | 0];
 t[b + 12 | 0] = w[b + 12 | 0] & 248 | f & 1 | f << 1 & 4 | f >>> 1 & 2;
 eh(b, Kd(w[d + 352 | 0], 2, 16));
 t[b + 13 | 0] = w[d + 354 | 0];
 t[b + 14 | 0] = w[d + 355 | 0];
 d = w[d + 353 | 0];
 t[b + 15 | 0] = d;
 t[b + 16 | 0] = d;
 d = 0;
 u[e + 14 >> 1] = 0;
 f = ((c | 0) != 0) << 1;
 h = v[b >> 2];
 j = Rd(h, v[b + 4 >> 2]);
 k = (a + 160 | 0) + (c << 6) | 0;
 c = (c | 0) == 2 ? 255 : 0;
 while (1) {
  if ((d | 0) == (j | 0)) {
   FD(b, 32);
   eb = e + 16 | 0;
  } else {
   a = k + (d << 2) | 0;
   u[e + 12 >> 1] = w[a | 0] | w[a + 1 | 0] << 8;
   g = qe(e + 14 | 0, e + 12 | 0);
   i = xb(h, d);
   g = x[g >> 1];
   u[i >> 1] = g;
   u[e + 14 >> 1] = g + 1;
   t[e + 11 | 0] = (c ^ w[a + 2 | 0]) >>> f;
   t[e + 10 | 0] = 64;
   l = i, m = w[Pb(e + 11 | 0, e + 10 | 0) | 0], t[l + 2 | 0] = m;
   d = d + 1 | 0;
   continue;
  }
  break;
 }
}

function s1(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0;
 c = eb - 16 | 0;
 eb = c;
 v[c + 12 >> 2] = v[v[a + 1060 >> 2] >> 2] - v[a + 1064 >> 2];
 v[c + 8 >> 2] = 16384;
 d = v[Gb(c + 12 | 0, c + 8 | 0) >> 2];
 v[a + 1072 >> 2] = d;
 v[c + 4 >> 2] = 17;
 while (1) {
  a: {
   if (!d) {
    break a;
   }
   e = v[c + 4 >> 2];
   if ((e | 0) > 17) {
    break a;
   }
   f = 1 << e - 1;
   d = _k(a, e);
   b: {
    c: {
     d: {
      if ((e | 0) <= 6) {
       if ((d | 0) != (f | 0)) {
        break d;
       }
       _r(c + 4 | 0, _k(a, 4));
       break b;
      }
      if (e >>> 0 > 16) {
       break c;
      }
      e = f - 8 | 0;
      if ((e | 0) > (d | 0) | (d | 0) > (f + 7 | 0)) {
       break d;
      }
      _r(c + 4 | 0, d - e | 0);
      break b;
     }
     PF(a, d, f, b);
     break b;
    }
    e = d & (f ^ -1);
    if (d & f) {
     v[c + 4 >> 2] = e + 1;
     break b;
    }
    PF(a, e, 0, b);
   }
   d = v[a + 1072 >> 2];
   continue;
  }
  break;
 }
 eb = c + 16 | 0;
}

function gna(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
 b = eb - 16 | 0;
 eb = b;
 k = v[a + 16 >> 2];
 i = jg(1, 2);
 e = gb;
 l = e;
 Ob(a, i, e);
 f = v[a + 40 >> 2];
 g = v[a + 36 >> 2];
 e = v[a + 4 >> 2];
 v[b + 8 >> 2] = v[a >> 2];
 v[b + 12 >> 2] = e;
 m = v[a + 32 >> 2];
 n = v[a + 28 >> 2];
 e = v[a + 8 >> 2];
 o = v[a + 12 >> 2];
 while (1) {
  if (d) {
   h = v[b + 8 >> 2];
   j = ((((v[b + 12 >> 2] & 2147483647) << 1 | h >>> 31) & 2147483646) << 1) + k | 0;
   h = u[j + 2 >> 1];
   g = g + n | 0;
   v[c >> 2] = v[c >> 2] + B(u[j >> 1], g >> 12);
   f = f + m | 0;
   v[c + 4 >> 2] = v[c + 4 >> 2] + B(f >> 12, h);
   Ob(b + 8 | 0, e, o);
   c = c + 8 | 0;
   d = d - 1 | 0;
   continue;
  }
  break;
 }
 c = v[b + 12 >> 2];
 v[a >> 2] = v[b + 8 >> 2];
 v[a + 4 >> 2] = c;
 v[a + 40 >> 2] = f;
 v[a + 20 >> 2] = g >> 12;
 v[a + 36 >> 2] = g;
 v[a + 24 >> 2] = f >> 12;
 Hg(a, i, l);
 eb = b + 16 | 0;
}

function br(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0;
 f = eb - 16 | 0;
 eb = f;
 g = f + 4 | 0;
 e = eb - 32 | 0;
 eb = e;
 c = rf(e + 20 | 0, 1, 0);
 a: {
  b: {
   c: {
    while (1) {
     d = Jb(c);
     ts(e + 12 | 0, d, Cb(v[c + 4 >> 2], w[c + 11 | 0]) + d | 0, v[b >> 2]);
     if (!v[e + 16 >> 2]) {
      break c;
     }
     d = ji(Cb(v[c + 4 >> 2], w[c + 11 | 0]));
     v[31601] = 0;
     N(45, c | 0, d | 0);
     d = v[31601];
     v[31601] = 0;
     if ((d | 0) != 1) {
      continue;
     }
     break;
    }
    break b;
   }
   b = v[e + 12 >> 2];
   d = Jb(c);
   v[31601] = 0;
   N(46, c | 0, b - d | 0);
   b = v[31601];
   v[31601] = 0;
   d: {
    if ((b | 0) != 1) {
     v[31601] = 0;
     N(303, g | 0, c | 0);
     b = v[31601];
     v[31601] = 0;
     if ((b | 0) != 1) {
      break d;
     }
     break b;
    }
    break b;
   }
   sb(c);
   eb = e + 32 | 0;
   break a;
  }
  a = M() | 0;
  sb(c);
  P(a | 0);
  p();
 }
 Ph(a, g);
 sb(g);
 eb = f + 16 | 0;
}

function Yaa(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0;
 f = eb - 16 | 0;
 eb = f;
 g = f + 4 | 0;
 e = eb - 32 | 0;
 eb = e;
 c = rf(e + 20 | 0, 1, 0);
 a: {
  b: {
   c: {
    while (1) {
     d = Jb(c);
     ts(e + 12 | 0, d, Cb(v[c + 4 >> 2], w[c + 11 | 0]) + d | 0, w[b | 0]);
     if (!v[e + 16 >> 2]) {
      break c;
     }
     d = ji(Cb(v[c + 4 >> 2], w[c + 11 | 0]));
     v[31601] = 0;
     N(45, c | 0, d | 0);
     d = v[31601];
     v[31601] = 0;
     if ((d | 0) != 1) {
      continue;
     }
     break;
    }
    break b;
   }
   b = v[e + 12 >> 2];
   d = Jb(c);
   v[31601] = 0;
   N(46, c | 0, b - d | 0);
   b = v[31601];
   v[31601] = 0;
   d: {
    if ((b | 0) != 1) {
     v[31601] = 0;
     N(303, g | 0, c | 0);
     b = v[31601];
     v[31601] = 0;
     if ((b | 0) != 1) {
      break d;
     }
     break b;
    }
    break b;
   }
   sb(c);
   eb = e + 32 | 0;
   break a;
  }
  a = M() | 0;
  sb(c);
  P(a | 0);
  p();
 }
 Ph(a, g);
 sb(g);
 eb = f + 16 | 0;
}

function ES(a, b) {
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0;
 d = eb - 16 | 0;
 eb = d;
 a: {
  if (v[a + 480180 >> 2] != 1) {
   break a;
  }
  c = w[b + 846 | 0];
  if (!c) {
   break a;
  }
  e = v[b + 104 >> 2];
  if (!e) {
   break a;
  }
  if (!ke(v[e >> 2], v[e + 20 >> 2])) {
   break a;
  }
  f = x[e + 34 >> 1];
  if (!(f & 10)) {
   break a;
  }
  c = w[b + 847 | 0] + w[(c & 15) + 31568 | 0] | 0;
  t[b + 847 | 0] = c;
  if (c << 24 >> 24 >= 0) {
   break a;
  }
  t[b + 847 | 0] = 0;
  h = f & 2;
  c = v[(h ? 4 : 12) + e >> 2];
  g = b;
  b = v[b + 760 >> 2] + 1 | 0;
  b = b >>> 0 < v[(h ? 8 : 16) + e >> 2] - c >>> 0 ? b : 0;
  v[g + 760 >> 2] = b;
  g = v[e + 20 >> 2];
  c = b + c | 0;
  b = Xk(f);
  ac(d + 8 | 0, g + B(c, b) | 0, b);
  b = vb(v[d + 8 >> 2]);
  v[d + 4 >> 2] = b;
  f = Ok(v[d + 8 >> 2], v[d + 12 >> 2]);
  while (1) {
   if (Hb(b, f)) {
    t[b | 0] = w[b | 0] ^ -1;
    b = v[xe(d + 4 | 0) >> 2];
    continue;
   } else {
    Hj(e, a);
   }
   break;
  }
 }
 eb = d + 16 | 0;
}

function uoa(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0;
 d = eb - 16 | 0;
 eb = d;
 v[a >> 2] = 0;
 v[a + 4 >> 2] = 0;
 sc(a + 8 | 0);
 Qd(d + 8 | 0, v[ub(d + 4 | 0, a) >> 2]);
 a: {
  if (b) {
   v[31601] = 0;
   N(709, a | 0, b | 0);
   c = v[31601];
   v[31601] = 0;
   if ((c | 0) == 1) {
    break a;
   }
   f = eb - 16 | 0;
   eb = f;
   c = f + 4 | 0;
   v[c >> 2] = a;
   e = v[a + 4 >> 2];
   v[c + 4 >> 2] = e;
   v[c + 8 >> 2] = e + B(b, 9);
   b = v[c + 4 >> 2];
   e = v[c + 8 >> 2];
   while (1) {
    if ((b | 0) == (e | 0)) {
     hc(c);
     eb = f + 16 | 0;
    } else {
     t[b | 0] = 0;
     t[b + 1 | 0] = 0;
     t[b + 2 | 0] = 0;
     t[b + 3 | 0] = 0;
     t[b + 4 | 0] = 0;
     t[b + 5 | 0] = 0;
     t[b + 6 | 0] = 0;
     t[b + 7 | 0] = 0;
     t[b + 8 | 0] = 0;
     b = b + 9 | 0;
     v[c + 4 >> 2] = b;
     continue;
    }
    break;
   }
  }
  b = d + 8 | 0;
  Pd(b);
  xv(b);
  eb = d + 16 | 0;
  return a | 0;
 }
 a = M() | 0;
 xv(d + 8 | 0);
 P(a | 0);
 p();
}

function Wv(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0;
 f = eb - 16 | 0;
 eb = f;
 g = f + 4 | 0;
 e = eb - 32 | 0;
 eb = e;
 c = rf(e + 20 | 0, 1, 0);
 a: {
  b: {
   c: {
    while (1) {
     d = Jb(c);
     Aw(e + 12 | 0, d, Cb(v[c + 4 >> 2], w[c + 11 | 0]) + d | 0, x[b >> 1]);
     if (!v[e + 16 >> 2]) {
      break c;
     }
     d = ji(Cb(v[c + 4 >> 2], w[c + 11 | 0]));
     v[31601] = 0;
     N(45, c | 0, d | 0);
     d = v[31601];
     v[31601] = 0;
     if ((d | 0) != 1) {
      continue;
     }
     break;
    }
    break b;
   }
   b = v[e + 12 >> 2];
   d = Jb(c);
   v[31601] = 0;
   N(46, c | 0, b - d | 0);
   b = v[31601];
   v[31601] = 0;
   d: {
    if ((b | 0) != 1) {
     v[31601] = 0;
     N(47, g | 0, c | 0);
     b = v[31601];
     v[31601] = 0;
     if ((b | 0) != 1) {
      break d;
     }
     break b;
    }
    break b;
   }
   sb(c);
   eb = e + 32 | 0;
   break a;
  }
  a = M() | 0;
  sb(c);
  P(a | 0);
  p();
 }
 Ph(a, g);
 sb(g);
 eb = f + 16 | 0;
}

function Op(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0;
 f = eb - 16 | 0;
 eb = f;
 g = f + 4 | 0;
 e = eb - 32 | 0;
 eb = e;
 c = rf(e + 20 | 0, 1, 0);
 a: {
  b: {
   c: {
    while (1) {
     d = Jb(c);
     ts(e + 12 | 0, d, Cb(v[c + 4 >> 2], w[c + 11 | 0]) + d | 0, v[b >> 2]);
     if (!v[e + 16 >> 2]) {
      break c;
     }
     d = ji(Cb(v[c + 4 >> 2], w[c + 11 | 0]));
     v[31601] = 0;
     N(45, c | 0, d | 0);
     d = v[31601];
     v[31601] = 0;
     if ((d | 0) != 1) {
      continue;
     }
     break;
    }
    break b;
   }
   b = v[e + 12 >> 2];
   d = Jb(c);
   v[31601] = 0;
   N(46, c | 0, b - d | 0);
   b = v[31601];
   v[31601] = 0;
   d: {
    if ((b | 0) != 1) {
     v[31601] = 0;
     N(47, g | 0, c | 0);
     b = v[31601];
     v[31601] = 0;
     if ((b | 0) != 1) {
      break d;
     }
     break b;
    }
    break b;
   }
   sb(c);
   eb = e + 32 | 0;
   break a;
  }
  a = M() | 0;
  sb(c);
  P(a | 0);
  p();
 }
 Ph(a, g);
 sb(g);
 eb = f + 16 | 0;
}

function I_(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0;
 f = eb - 16 | 0;
 eb = f;
 g = f + 4 | 0;
 e = eb - 32 | 0;
 eb = e;
 c = rf(e + 20 | 0, 1, 0);
 a: {
  b: {
   c: {
    while (1) {
     d = Jb(c);
     Aw(e + 12 | 0, d, Cb(v[c + 4 >> 2], w[c + 11 | 0]) + d | 0, v[b >> 2]);
     if (!v[e + 16 >> 2]) {
      break c;
     }
     d = ji(Cb(v[c + 4 >> 2], w[c + 11 | 0]));
     v[31601] = 0;
     N(45, c | 0, d | 0);
     d = v[31601];
     v[31601] = 0;
     if ((d | 0) != 1) {
      continue;
     }
     break;
    }
    break b;
   }
   b = v[e + 12 >> 2];
   d = Jb(c);
   v[31601] = 0;
   N(46, c | 0, b - d | 0);
   b = v[31601];
   v[31601] = 0;
   d: {
    if ((b | 0) != 1) {
     v[31601] = 0;
     N(47, g | 0, c | 0);
     b = v[31601];
     v[31601] = 0;
     if ((b | 0) != 1) {
      break d;
     }
     break b;
    }
    break b;
   }
   sb(c);
   eb = e + 32 | 0;
   break a;
  }
  a = M() | 0;
  sb(c);
  P(a | 0);
  p();
 }
 Ph(a, g);
 sb(g);
 eb = f + 16 | 0;
}

function Ds(a, b, c, d) {
 var e = 0, f = 0, g = 0, h = 0;
 e = eb - 80 | 0;
 eb = e;
 f = v[c >> 2];
 g = e + 52 | 0;
 jH(g, c, 71);
 v[31601] = 0;
 c = e + 4 | 0;
 R(d | 0, c | 0, b | 0, (f & 2 ? 16 : 10) | 0);
 b = v[31601];
 v[31601] = 0;
 a: {
  b: {
   c: {
    d: {
     if ((b | 0) != 1) {
      b = e + 16 | 0;
      EV(b, c, v[e + 52 >> 2]);
      v[31601] = 0;
      d = e + 28 | 0;
      U(299, d | 0, b | 0, v[e + 52 >> 2], v[e + 56 >> 2]);
      f = v[31601];
      v[31601] = 0;
      if ((f | 0) == 1) {
       break d;
      }
      v[31601] = 0;
      f = e + 40 | 0;
      R(300, f | 0, d | 0, g | 0);
      h = v[31601];
      v[31601] = 0;
      if ((h | 0) == 1) {
       break c;
      }
      Ph(a, f);
      sb(f);
      sb(d);
      sb(b);
      sb(c);
      Ih(g);
      eb = e + 80 | 0;
      return;
     }
     c = M() | 0;
     break a;
    }
    c = M() | 0;
    break b;
   }
   c = M() | 0;
   sb(e + 28 | 0);
  }
  sb(e + 16 | 0);
  sb(e + 4 | 0);
 }
 Ih(e + 52 | 0);
 P(c | 0);
 p();
}

function r1(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0;
 c = eb - 16 | 0;
 eb = c;
 v[c + 12 >> 2] = v[v[a + 1060 >> 2] >> 2] - v[a + 1064 >> 2];
 v[c + 8 >> 2] = 32768;
 d = v[Gb(c + 12 | 0, c + 8 | 0) >> 2];
 v[a + 1072 >> 2] = d;
 v[c + 4 >> 2] = 9;
 while (1) {
  a: {
   if (!d) {
    break a;
   }
   e = v[c + 4 >> 2];
   if ((e | 0) > 9) {
    break a;
   }
   f = 1 << e - 1;
   d = _k(a, e);
   b: {
    c: {
     d: {
      if ((e | 0) <= 6) {
       if ((d | 0) != (f | 0)) {
        break d;
       }
       _r(c + 4 | 0, _k(a, 3));
       break b;
      }
      if (e >>> 0 > 8) {
       break c;
      }
      e = f - 4 | 0;
      if ((e | 0) > (d | 0) | (d | 0) > (f + 3 | 0)) {
       break d;
      }
      _r(c + 4 | 0, d - e | 0);
      break b;
     }
     OF(a, d, f, b);
     break b;
    }
    e = d & (f ^ -1);
    if (d & f) {
     v[c + 4 >> 2] = e + 1;
     break b;
    }
    OF(a, e, 0, b);
   }
   d = v[a + 1072 >> 2];
   continue;
  }
  break;
 }
 eb = c + 16 | 0;
}

function oha(a) {
 a = a | 0;
 var b = 0, c = 0, d = 0;
 c = eb - 16 | 0;
 eb = c;
 b = v[v[a + 16 >> 2] + 24620 >> 2];
 b = Fc(Bua(Aua(b, b >> 31, 3840, 0), gb, 1e3, 0), gb);
 v[a + 4316 >> 2] = b;
 v[31601] = 0;
 v[c + 12 >> 2] = 0;
 d = b;
 b = c + 12 | 0;
 R(946, a + 4264 | 0, d | 0, b | 0);
 d = v[31601];
 v[31601] = 0;
 a: {
  b: {
   c: {
    if ((d | 0) != 1) {
     d: {
      if (!w[a + 4260 | 0]) {
       break d;
      }
      d = v[a + 4316 >> 2];
      v[31601] = 0;
      v[c + 12 >> 2] = 0;
      R(946, a + 4276 | 0, d | 0, b | 0);
      b = v[31601];
      v[31601] = 0;
      if ((b | 0) != 1) {
       break d;
      }
      b = S(124508) | 0;
      break c;
     }
     v[c + 12 >> 2] = 0;
     b = c + 12 | 0;
     gQ(a + 4288 | 0, b);
     v[c + 12 >> 2] = 0;
     gQ(a + 4300 | 0, b);
     break b;
    }
    b = S(124508) | 0;
   }
   if ((fb | 0) != (_(124508) | 0)) {
    break a;
   }
   X(b | 0) | 0;
   v[a + 4316 >> 2] = 0;
   Y();
  }
  eb = c + 16 | 0;
  return;
 }
 P(b | 0);
 p();
}

function dka(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0;
 b = (b - a | 0) / 160 | 0;
 while (1) {
  if ((b | 0) > 0) {
   b = b - 1 | 0;
   v[a >> 2] = v[c >> 2];
   d = a + 4 | 0;
   if ((d | 0) != (c + 4 | 0)) {
    f = v[c + 4 >> 2];
    h = v[c + 8 >> 2];
    g = Oj(f, h);
    i = eb - 16 | 0;
    eb = i;
    a: {
     if ($o(d) >>> 0 >= g >>> 0) {
      j = v[d >> 2];
      k = Sc(j, v[d + 4 >> 2]);
      if (k >>> 0 < g >>> 0) {
       e = eb - 16 | 0;
       eb = e;
       v[e + 12 >> 2] = f;
       v[e + 12 >> 2] = v[e + 12 >> 2] + k;
       eb = e + 16 | 0;
       e = v[e + 12 >> 2];
       wk(f, e, j);
       xn(d, e, h, g - Sc(v[d >> 2], v[d + 4 >> 2]) | 0);
       break a;
      }
      $B(i + 8 | 0, f, h, j);
      Id(d, v[i + 12 >> 2]);
      break a;
     }
     ew(d);
     Tk(d, Tl(d, g));
     xn(d, f, h, g);
    }
    eb = i + 16 | 0;
   }
   yc(a + 16 | 0, c + 16 | 0, 144);
   a = a + 160 | 0;
   continue;
  }
  break;
 }
}

function hna(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
 b = eb - 16 | 0;
 eb = b;
 k = v[a + 16 >> 2];
 i = jg(1, 2);
 e = gb;
 l = e;
 Ob(a, i, e);
 f = v[a + 40 >> 2];
 g = v[a + 36 >> 2];
 e = v[a + 4 >> 2];
 v[b + 8 >> 2] = v[a >> 2];
 v[b + 12 >> 2] = e;
 m = v[a + 32 >> 2];
 n = v[a + 28 >> 2];
 e = v[a + 8 >> 2];
 o = v[a + 12 >> 2];
 while (1) {
  if (d) {
   h = v[b + 8 >> 2];
   j = (((v[b + 12 >> 2] & 2147483647) << 1 | h >>> 31) & -2) + k | 0;
   h = t[j + 1 | 0];
   g = g + n | 0;
   v[c >> 2] = v[c >> 2] + (B(t[j | 0], g >> 12) << 8);
   f = f + m | 0;
   v[c + 4 >> 2] = v[c + 4 >> 2] + (B(f >> 12, h) << 8);
   Ob(b + 8 | 0, e, o);
   c = c + 8 | 0;
   d = d - 1 | 0;
   continue;
  }
  break;
 }
 c = v[b + 12 >> 2];
 v[a >> 2] = v[b + 8 >> 2];
 v[a + 4 >> 2] = c;
 v[a + 40 >> 2] = f;
 v[a + 20 >> 2] = g >> 12;
 v[a + 36 >> 2] = g;
 v[a + 24 >> 2] = f >> 12;
 Hg(a, i, l);
 eb = b + 16 | 0;
}

function cm(a, b, c, d, e, f) {
 var g = 0;
 g = eb - 16 | 0;
 eb = g;
 t[g + 14 | 0] = d;
 t[g + 15 | 0] = c;
 t[g + 13 | 0] = e;
 t[g + 12 | 0] = f;
 d = 0;
 a: {
  b: {
   while (1) {
    c = d & 255;
    if (c >>> 0 > 3) {
     break b;
    }
    e = w[g + 15 | 0];
    uw(g + 10 | 0, e, w[g + 14 | 0], c >>> 0 > 1);
    if (!(w[g + 10 | 0] | !e)) {
     d = d + 1 | 0;
     qg(g + 15 | 0, g + 13 | 0);
     qg(g + 14 | 0, g + 12 | 0);
     continue;
    }
    break;
   }
   c = x[g + 10 >> 1];
   t[b + 2 | 0] = c;
   t[b + 4 | 0] = c >>> 8;
   c = w[g + 13 | 0];
   t[b + 5 | 0] = w[g + 12 | 0];
   t[b + 3 | 0] = c;
   t[g + 9 | 0] = 0;
   de(a, 0, g + 9 | 0);
   break a;
  }
  d = w[g + 15 | 0];
  e = qi(d);
  c = w[g + 13 | 0];
  if (e >>> 0 > qi(c) >>> 0) {
   qg(g + 15 | 0, g + 13 | 0);
   qg(g + 14 | 0, g + 12 | 0);
   d = w[g + 15 | 0];
   c = w[g + 13 | 0];
  }
  t[b + 4 | 0] = 0;
  t[b + 2 | 0] = 0;
  t[b + 5 | 0] = w[g + 12 | 0];
  t[b + 3 | 0] = c;
  de(a, d, g + 14 | 0);
 }
 eb = g + 16 | 0;
}

function Wp(a, b, c, d) {
 var e = 0, f = 0, g = 0, h = 0;
 e = eb - 80 | 0;
 eb = e;
 f = v[c >> 2];
 g = e + 52 | 0;
 jH(g, c, 3);
 v[31601] = 0;
 c = e + 4 | 0;
 R(d | 0, c | 0, b | 0, (f & 2 ? 16 : 10) | 0);
 b = v[31601];
 v[31601] = 0;
 a: {
  b: {
   c: {
    d: {
     if ((b | 0) != 1) {
      b = e + 16 | 0;
      EV(b, c, v[e + 52 >> 2]);
      v[31601] = 0;
      d = e + 28 | 0;
      U(19, d | 0, b | 0, v[e + 52 >> 2], v[e + 56 >> 2]);
      f = v[31601];
      v[31601] = 0;
      if ((f | 0) == 1) {
       break d;
      }
      v[31601] = 0;
      f = e + 40 | 0;
      R(20, f | 0, d | 0, g | 0);
      h = v[31601];
      v[31601] = 0;
      if ((h | 0) == 1) {
       break c;
      }
      Ph(a, f);
      sb(f);
      sb(d);
      sb(b);
      sb(c);
      Ih(g);
      eb = e + 80 | 0;
      return;
     }
     c = M() | 0;
     break a;
    }
    c = M() | 0;
    break b;
   }
   c = M() | 0;
   sb(e + 28 | 0);
  }
  sb(e + 16 | 0);
  sb(e + 4 | 0);
 }
 Ih(e + 52 | 0);
 P(c | 0);
 p();
}

function FY(a) {
 var b = 0, c = 0, d = 0, e = 0, f = 0;
 b = eb - 32 | 0;
 eb = b;
 e = b, f = _b(w[a + 8 | 0] | w[a + 9 | 0] << 8 | (w[a + 10 | 0] << 16 | w[a + 11 | 0] << 24)) + 788 | 0, 
 v[e >> 2] = f;
 v[b + 4 >> 2] = 0;
 e = b, f = _b(w[a + 16 | 0] | w[a + 17 | 0] << 8 | (w[a + 18 | 0] << 16 | w[a + 19 | 0] << 24)), 
 v[e + 8 >> 2] = f;
 v[b + 12 >> 2] = 0;
 c = _b(w[a + 24 | 0] | w[a + 25 | 0] << 8 | (w[a + 26 | 0] << 16 | w[a + 27 | 0] << 24));
 v[b + 16 >> 2] = c ? c : 52;
 v[b + 20 >> 2] = 0;
 e = b, f = _b(w[a + 32 | 0] | w[a + 33 | 0] << 8 | (w[a + 34 | 0] << 16 | w[a + 35 | 0] << 24)) + 80 | 0, 
 v[e + 24 >> 2] = f;
 v[b + 28 >> 2] = 0;
 a = b;
 d = Se(a, 4);
 a: {
  if ((a | 0) == (d | 0)) {
   break a;
  }
  c = a;
  while (1) {
   c = c + 8 | 0;
   if ((d | 0) == (c | 0)) {
    break a;
   }
   a = Rw(v[a >> 2], v[a + 4 >> 2], v[c >> 2], v[c + 4 >> 2]) ? c : a;
   continue;
  }
 }
 eb = b + 32 | 0;
 c = v[a >> 2];
 b = c - 52 | 0;
 gb = v[a + 4 >> 2] - (c >>> 0 < 52) | 0;
 return b;
}

function i6(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0;
 c = v[a >> 2];
 d = nc(c, v[a + 4 >> 2]);
 if (d >>> 0 < b >>> 0) {
  h = eb - 32 | 0;
  eb = h;
  e = b - d | 0;
  b = v[zb(a) >> 2];
  c = v[a + 4 >> 2];
  a: {
   if (e >>> 0 <= b - c >> 2 >>> 0) {
    Vq(a, e);
    break a;
   }
   f = it(a);
   d = Kf(a, nc(v[a >> 2], c) + e | 0);
   g = nc(v[a >> 2], v[a + 4 >> 2]);
   c = eb - 16 | 0;
   eb = c;
   b = h + 12 | 0;
   Kg(b + 12 | 0, f);
   b: {
    if (!d) {
     f = 0;
     d = 0;
     break b;
    }
    iJ(c + 8 | 0, v[b + 16 >> 2], d);
    f = v[c + 12 >> 2];
    d = v[c + 8 >> 2];
   }
   v[b >> 2] = d;
   g = d + (g << 2) | 0;
   v[b + 8 >> 2] = g;
   v[b + 4 >> 2] = g;
   i = mc(b), j = d + (f << 2) | 0, v[i >> 2] = j;
   eb = c + 16 | 0;
   lA(b, e);
   Rm(a, b);
   UP(b);
   a = v[b >> 2];
   if (a) {
    ny(v[b + 16 >> 2], a, Vz(b));
   }
  }
  eb = h + 32 | 0;
  return;
 }
 if (b >>> 0 < d >>> 0) {
  Id(a, c + (b << 2) | 0);
 }
}

function Wma(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
 b = eb - 16 | 0;
 eb = b;
 i = v[a + 24 >> 2];
 j = v[a + 20 >> 2];
 k = v[a + 16 >> 2];
 f = v[a + 4 >> 2];
 v[b + 8 >> 2] = v[a >> 2];
 v[b + 12 >> 2] = f;
 f = v[a + 8 >> 2];
 l = v[a + 12 >> 2];
 while (1) {
  if (d) {
   e = v[b + 8 >> 2];
   m = e >>> 18 | 0;
   n = ((((v[b + 12 >> 2] & 2147483647) << 1 | e >>> 31) & 2147483646) << 1) + k | 0;
   e = 0;
   while (1) {
    if ((e | 0) != 2) {
     g = (e << 1) + n | 0;
     h = u[g >> 1];
     v[(e << 2) + b >> 2] = h + ((B(u[g + 4 >> 1] - h | 0, m) | 0) / 16384 | 0);
     e = e + 1 | 0;
     continue;
    }
    break;
   }
   v[c >> 2] = v[c >> 2] + B(v[b >> 2], j);
   v[c + 4 >> 2] = v[c + 4 >> 2] + B(v[b + 4 >> 2], i);
   Ob(b + 8 | 0, f, l);
   c = c + 8 | 0;
   d = d - 1 | 0;
   continue;
  }
  break;
 }
 c = v[b + 12 >> 2];
 v[a >> 2] = v[b + 8 >> 2];
 v[a + 4 >> 2] = c;
 eb = b + 16 | 0;
}

function nN(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0;
 d = eb - 16 | 0;
 eb = d;
 a: {
  b: {
   c: {
    a = v[a + 32 >> 2];
    e = qq(a);
    d: {
     if (!e) {
      if (pq(a) >>> 0 <= b >>> 0) {
       break d;
      }
      a = mi(a, b + 1 & 65535);
      u[a + 34 >> 1] = x[a + 34 >> 1] & 64511 | (c ? 1024 : 0);
      break b;
     }
     if (b >>> 0 < e >>> 0) {
      break c;
     }
    }
    a = cc(8);
    v[31601] = 0;
    b = O(36, d + 4 | 0, 6e3) | 0;
    c = v[31601];
    v[31601] = 0;
    e: {
     if ((c | 0) != 1) {
      rc(a, b);
      v[31601] = 0;
      R(97, a | 0, 48396, 999);
      a = v[31601];
      v[31601] = 0;
      if ((a | 0) != 1) {
       break a;
      }
      c = M() | 0;
      sb(b);
      break e;
     }
     c = M() | 0;
     jc(a);
    }
    P(c | 0);
    p();
   }
   a = v[(a + (b << 2) | 0) + 900384 >> 2];
   if (!a) {
    break b;
   }
   t[a + 15 | 0] = w[a + 15 | 0] & 253 | (c ? 2 : 0);
  }
  eb = d + 16 | 0;
  return;
 }
 p();
}

function DK(a, b, c, d) {
 var e = 0, f = 0, g = 0, h = 0;
 e = eb - 16 | 0;
 eb = e;
 a: {
  b: {
   if ((a | 0) != (b | 0)) {
    c: {
     h = v[31476];
     v[31476] = 0;
     Nd();
     f = BK(a, e + 12 | 0, d);
     a = f;
     d = gb;
     d: {
      g = v[31476];
      if (g) {
       if (v[e + 12 >> 2] != (b | 0)) {
        break c;
       }
       if ((g | 0) != 68) {
        break d;
       }
       v[c >> 2] = 4;
       a = 2147483647;
       if (!!f & (d | 0) >= 0 | (d | 0) > 0) {
        break a;
       }
       break b;
      }
      v[31476] = h;
      if (v[e + 12 >> 2] == (b | 0)) {
       break d;
      }
      break c;
     }
     if ((d | 0) < 0 & a >>> 0 <= 2147483647 | (d | 0) < -1) {
      v[c >> 2] = 4;
      break b;
     }
     if ((d | 0) >= 0 & a >>> 0 >= 2147483648 | (d | 0) > 0) {
      v[c >> 2] = 4;
      a = 2147483647;
      break a;
     }
     break a;
    }
   }
   v[c >> 2] = 4;
   a = 0;
   break a;
  }
  a = -2147483648;
 }
 eb = e + 16 | 0;
 return a;
}

function _fa(a, b, c) {
 a = a | 0;
 b = +b;
 c = c | 0;
 var d = 0, e = 0, f = 0;
 d = eb - 80 | 0;
 eb = d;
 v[d + 76 >> 2] = c;
 c = v[a >> 2];
 e = v[a + 4 >> 2];
 f = v[a + 12 >> 2];
 v[d + 48 >> 2] = v[a + 8 >> 2];
 v[d + 52 >> 2] = f;
 v[d + 40 >> 2] = c;
 v[d + 44 >> 2] = e;
 a = Ld(d + 32 | 0);
 c = v[d + 52 >> 2];
 v[d + 16 >> 2] = v[d + 48 >> 2];
 v[d + 20 >> 2] = c;
 v[31601] = 0;
 c = v[d + 44 >> 2];
 v[d + 8 >> 2] = v[d + 40 >> 2];
 v[d + 12 >> 2] = c;
 c = v[a + 4 >> 2];
 v[d >> 2] = v[a >> 2];
 v[d + 4 >> 2] = c;
 a = d + 56 | 0;
 R(979, a | 0, d + 8 | 0, d | 0);
 c = v[31601];
 v[31601] = 0;
 a: {
  b: {
   if ((c | 0) != 1) {
    c = d + 76 | 0;
    e = v[re(d + 28 | 0, c) >> 2];
    v[31601] = 0;
    b = +oa(980, a | 0, +b, e | 0);
    e = v[31601];
    v[31601] = 0;
    if ((e | 0) == 1) {
     break b;
    }
    tb(a);
    Wc(c);
    eb = d + 80 | 0;
    return +b;
   }
   a = M() | 0;
   break a;
  }
  a = M() | 0;
  tb(d + 56 | 0);
 }
 Wc(d + 76 | 0);
 P(a | 0);
 p();
}

function Roa(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0;
 d = eb - 32 | 0;
 eb = d;
 md(b, 0);
 f = d + 8 | 0;
 ck(f, 1, a);
 c = d + 20 | 0;
 Bc(c, f);
 Ae(b + 43 | 0, c);
 sb(c);
 v[b >> 2] = w[a + 48 | 0] | w[a + 49 | 0] << 8 | (w[a + 50 | 0] << 16 | w[a + 51 | 0] << 24);
 v[b + 4 >> 2] = w[a + 52 | 0] | w[a + 53 | 0] << 8 | (w[a + 54 | 0] << 16 | w[a + 55 | 0] << 24);
 v[b + 8 >> 2] = w[a + 56 | 0] | w[a + 57 | 0] << 8 | (w[a + 58 | 0] << 16 | w[a + 59 | 0] << 24);
 v[b + 24 >> 2] = w[a + 62 | 0] | w[a + 63 | 0] << 8;
 Yl(b, +((w[a + 60 | 0] ^ 8) - 120 | 0) / 192);
 t[d + 20 | 0] = w[a + 61 | 0];
 t[d + 8 | 0] = 64;
 g = b, h = w[Pb(c, f) | 0] << 2, u[g + 30 >> 1] = h;
 u[b + 34 >> 1] = 0;
 c = w[a + 47 | 0];
 if (c & 4) {
  u[b + 34 >> 1] = 1;
  v[b >> 2] = v[b >> 2] >>> 1;
  e = 1;
  c = w[a + 47 | 0];
 }
 if (c & 32) {
  e = e | 4;
  u[b + 34 >> 1] = e;
  c = w[a + 47 | 0];
 }
 if (c << 24 >> 24 < 0) {
  u[b + 34 >> 1] = e | 2;
 }
 eb = d + 32 | 0;
}
function Gfa(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0;
 d = eb - 32 | 0;
 eb = d;
 v[31601] = 0;
 V(995, a | 0);
 c = v[31601];
 v[31601] = 0;
 a: {
  b: {
   c: {
    if ((c | 0) == 1) {
     break c;
    }
    v[31601] = 0;
    V(996, b | 0);
    c = v[31601];
    v[31601] = 0;
    if ((c | 0) == 1) {
     break c;
    }
    e = v[a + 24 >> 2];
    b = oc(d + 12 | 0, b);
    v[31601] = 0;
    c = v[b + 4 >> 2];
    v[d >> 2] = v[b >> 2];
    v[d + 4 >> 2] = c;
    c = d + 20 | 0;
    U(1008, c | 0, e | 0, d | 0, 1);
    b = v[31601];
    v[31601] = 0;
    if ((b | 0) == 1) {
     break c;
    }
    b = Bg(Jb(c));
    sb(c);
    break b;
   }
   X(S(0) | 0) | 0;
   b = 0;
   v[31601] = 0;
   U(982, 5535, a | 0, 0, 0);
   a = v[31601];
   v[31601] = 0;
   if ((a | 0) == 1) {
    break a;
   }
   Y();
  }
  eb = d + 32 | 0;
  return b | 0;
 }
 a = M() | 0;
 v[31601] = 0;
 W(26);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  P(a | 0);
  p();
 }
 S(0) | 0;
 Rb();
 p();
}

function Xma(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
 b = eb - 16 | 0;
 eb = b;
 i = v[a + 24 >> 2];
 j = v[a + 20 >> 2];
 k = v[a + 16 >> 2];
 f = v[a + 4 >> 2];
 v[b + 8 >> 2] = v[a >> 2];
 v[b + 12 >> 2] = f;
 f = v[a + 8 >> 2];
 l = v[a + 12 >> 2];
 while (1) {
  if (d) {
   e = v[b + 8 >> 2];
   m = e >>> 10 & 4194048;
   n = (((v[b + 12 >> 2] & 2147483647) << 1 | e >>> 31) & -2) + k | 0;
   e = 0;
   while (1) {
    if ((e | 0) != 2) {
     g = e + n | 0;
     h = t[g | 0];
     v[(e << 2) + b >> 2] = ((B(t[g + 2 | 0] - h | 0, m) | 0) / 16384 | 0) + (h << 8);
     e = e + 1 | 0;
     continue;
    }
    break;
   }
   v[c >> 2] = v[c >> 2] + B(v[b >> 2], j);
   v[c + 4 >> 2] = v[c + 4 >> 2] + B(v[b + 4 >> 2], i);
   Ob(b + 8 | 0, f, l);
   c = c + 8 | 0;
   d = d - 1 | 0;
   continue;
  }
  break;
 }
 c = v[b + 12 >> 2];
 v[a >> 2] = v[b + 8 >> 2];
 v[a + 4 >> 2] = c;
 eb = b + 16 | 0;
}

function qpa(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0;
 d = eb - 80 | 0;
 eb = d;
 e = Qf(d + 52 | 0);
 v[31601] = 0;
 c = O(649, b | 0, e | 0) | 0;
 f = v[31601];
 v[31601] = 0;
 a: {
  b: {
   c: {
    d: {
     if ((f | 0) != 1) {
      if (c) {
       break d;
      }
      v[a >> 2] = 0;
      v[a + 4 >> 2] = 0;
      v[a + 24 >> 2] = 0;
      v[a + 16 >> 2] = 0;
      v[a + 20 >> 2] = 0;
      v[a + 8 >> 2] = 0;
      v[a + 12 >> 2] = 0;
      v[31601] = 0;
      Q(650, a | 0) | 0;
      a = v[31601];
      v[31601] = 0;
      if ((a | 0) != 1) {
       break a;
      }
     }
     break c;
    }
    c = v[e + 4 >> 2];
    v[31601] = 0;
    R(185, d + 12 | 0, b | 0, (c >>> 0 >= 9 ? c - 8 | 0 : 0) | 0);
    b = v[31601];
    v[31601] = 0;
    if ((b | 0) != 1) {
     break b;
    }
   }
   a = M() | 0;
   Gd(e);
   P(a | 0);
   p();
  }
  b = d + 12 | 0;
  c = gc(d + 32 | 0, b);
  jd(e + 8 | 0, c);
  tb(c);
  tb(b);
  Lk(a, e);
 }
 Gd(e);
 eb = d + 80 | 0;
}

function e3(a, b, c, d, e, f, g, h, i, j) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 f = f | 0;
 g = g | 0;
 h = h | 0;
 i = i | 0;
 j = j | 0;
 var k = 0, l = 0, m = 0;
 k = eb - 32 | 0;
 eb = k;
 m = v[c >> 2];
 l = v[c + 8 >> 2];
 c = v[c + 4 >> 2];
 v[k + 8 >> 2] = c;
 v[k + 12 >> 2] = l;
 v[k + 24 >> 2] = c;
 v[k + 28 >> 2] = l;
 v[k + 20 >> 2] = m;
 v[k + 16 >> 2] = d;
 v[31601] = 0;
 c = v[k + 20 >> 2];
 v[k >> 2] = v[k + 16 >> 2];
 v[k + 4 >> 2] = c;
 a = Ha(1093, a | 0, b | 0, k | 0) | 0;
 b = v[31601];
 v[31601] = 0;
 a: {
  b: {
   if ((b | 0) == 1) {
    X(S(0) | 0) | 0;
    v[31601] = 0;
    fa(978, 10415, e | 0, f | 0, g | 0, h | 0, i | 0, j | 0);
    a = v[31601];
    v[31601] = 0;
    if ((a | 0) == 1) {
     break b;
    }
    Y();
    a = -255;
   }
   eb = k + 32 | 0;
   break a;
  }
  b = M() | 0;
  v[31601] = 0;
  W(26);
  a = v[31601];
  v[31601] = 0;
  if ((a | 0) != 1) {
   P(b | 0);
   p();
  }
  S(0) | 0;
  Rb();
  p();
 }
 return a | 0;
}

function NB(a, b) {
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0;
 f = eb - 16 | 0;
 eb = f;
 c = ub(f + 12 | 0, v[a + 4 >> 2]);
 d = ub(f + 8 | 0, v[a >> 2]);
 g = v[ub(f + 4 | 0, v[b + 4 >> 2]) >> 2];
 h = eb - 16 | 0;
 eb = h;
 i = h + 8 | 0;
 e = eb - 32 | 0;
 eb = e;
 ed(e + 24 | 0, v[c >> 2], v[d >> 2]);
 j = e + 16 | 0;
 d = v[e + 24 >> 2];
 k = v[e + 28 >> 2];
 c = eb - 16 | 0;
 eb = c;
 v[c + 8 >> 2] = g;
 v[c + 12 >> 2] = d;
 while (1) {
  if (Ed(d, k)) {
   d = Ip(d);
   g = Ip(v[c + 8 >> 2]);
   l = v[d + 4 >> 2];
   v[g >> 2] = v[d >> 2];
   v[g + 4 >> 2] = l;
   d = gs(c + 12 | 0);
   gs(c + 8 | 0);
   d = v[d >> 2];
   continue;
  }
  break;
 }
 pc(j, d, c + 8 | 0);
 eb = c + 16 | 0;
 c = v[e + 16 >> 2];
 v[e + 12 >> 2] = v[e + 20 >> 2];
 pc(i, c, e + 12 | 0);
 eb = e + 32 | 0;
 eb = h + 16 | 0;
 v[b + 4 >> 2] = v[h + 12 >> 2];
 Sb(a, b + 4 | 0);
 Sb(a + 4 | 0, b + 8 | 0);
 Sb(zb(a), mc(b));
 v[b >> 2] = v[b + 4 >> 2];
 eb = f + 16 | 0;
}

function Bw(a, b) {
 var c = 0, d = 0, e = 0, f = 0, g = 0;
 f = eb - 16 | 0;
 eb = f;
 g = f + 4 | 0;
 e = eb - 32 | 0;
 eb = e;
 c = rf(e + 20 | 0, 1, 0);
 a: {
  b: {
   c: {
    while (1) {
     d = Jb(c);
     Aw(e + 12 | 0, d, Cb(v[c + 4 >> 2], w[c + 11 | 0]) + d | 0, w[b | 0]);
     if (!v[e + 16 >> 2]) {
      break c;
     }
     d = ji(Cb(v[c + 4 >> 2], w[c + 11 | 0]));
     v[31601] = 0;
     N(45, c | 0, d | 0);
     d = v[31601];
     v[31601] = 0;
     if ((d | 0) != 1) {
      continue;
     }
     break;
    }
    break b;
   }
   b = v[e + 12 >> 2];
   d = Jb(c);
   v[31601] = 0;
   N(46, c | 0, b - d | 0);
   b = v[31601];
   v[31601] = 0;
   d: {
    if ((b | 0) != 1) {
     v[31601] = 0;
     N(47, g | 0, c | 0);
     b = v[31601];
     v[31601] = 0;
     if ((b | 0) != 1) {
      break d;
     }
     break b;
    }
    break b;
   }
   sb(c);
   eb = e + 32 | 0;
   break a;
  }
  a = M() | 0;
  sb(c);
  P(a | 0);
  p();
 }
 Ph(a, g);
 sb(g);
 eb = f + 16 | 0;
}

function Rqa(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0;
 d = eb - 80 | 0;
 eb = d;
 c = Qf(d + 52 | 0);
 v[31601] = 0;
 e = O(521, b | 0, c | 0) | 0;
 f = v[31601];
 v[31601] = 0;
 a: {
  b: {
   c: {
    d: {
     if ((f | 0) != 1) {
      if (e) {
       break d;
      }
      v[a >> 2] = 0;
      v[a + 4 >> 2] = 0;
      v[a + 24 >> 2] = 0;
      v[a + 16 >> 2] = 0;
      v[a + 20 >> 2] = 0;
      v[a + 8 >> 2] = 0;
      v[a + 12 >> 2] = 0;
      v[31601] = 0;
      Q(522, a | 0) | 0;
      a = v[31601];
      v[31601] = 0;
      if ((a | 0) != 1) {
       break a;
      }
     }
     break c;
    }
    e = x[c + 2 >> 1] | x[c + 4 >> 1] << 16;
    v[31601] = 0;
    R(185, d + 12 | 0, b | 0, e | 0);
    b = v[31601];
    v[31601] = 0;
    if ((b | 0) != 1) {
     break b;
    }
   }
   a = M() | 0;
   Gd(c);
   P(a | 0);
   p();
  }
  b = d + 12 | 0;
  e = gc(d + 32 | 0, b);
  jd(c + 8 | 0, e);
  tb(e);
  tb(b);
  HY(a, c);
 }
 Gd(c);
 eb = d + 80 | 0;
}

function Nia(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0;
 e = eb - 16 | 0;
 eb = e;
 h = Hf(a, c);
 $d(e, v[a + 36 >> 2]);
 a: {
  b: {
   if (!h) {
    Pc(e, a + 32 | 0, 5);
    c = -1;
    if (!Fb(v[v[e >> 2] >> 2], v[e + 4 >> 2])) {
     break b;
    }
    break a;
   }
   c = v[h + 16 >> 2];
  }
  f = v[a + 36 >> 2];
  c: {
   if (!((c | 0) != 4 & (c | 0) != -1)) {
    d = eb - 16 | 0;
    eb = d;
    v[d + 12 >> 2] = 0;
    wq(f, d + 12 | 0);
    z[b >> 2] = z[d + 12 >> 2];
    break c;
   }
   d = eb - 16 | 0;
   eb = d;
   v[d + 12 >> 2] = c;
   v[d + 8 >> 2] = 4;
   c = v[Gb(d + 12 | 0, d + 8 | 0) >> 2];
   g = eb - 16 | 0;
   eb = g;
   yz(g + 8 | 0, f);
   f = v[g + 12 >> 2];
   if (ft(-1, 2147483647, c, 0) ^ 1) {
    i = ft(c, 0, 0, -2147483648) ^ 1;
   } else {
    i = 0;
   }
   if (i) {
    Ci(f, c, 0, 1);
   }
   eb = g + 16 | 0;
   v[b >> 2] = 0;
  }
  eb = d + 16 | 0;
  d = h;
 }
 ef(a, d);
 eb = e + 16 | 0;
}

function aja(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0;
 f = eb - 16 | 0;
 eb = f;
 v[f + 12 >> 2] = b;
 a: {
  if (Eu(a) >>> 0 >= b >>> 0) {
   e = v[a >> 2];
   g = fm(e, v[a + 4 >> 2]);
   v[f + 8 >> 2] = g;
   d = v[Gb(f + 12 | 0, f + 8 | 0) >> 2];
   while (1) {
    if (d) {
     d = d - 1 | 0;
     e = fR(e, c) + 52 | 0;
     continue;
    }
    break;
   }
   if (b >>> 0 > g >>> 0) {
    rA(a, b - g | 0, c);
    break a;
   }
   dR(a, v[a >> 2] + B(b, 52) | 0);
   break a;
  }
  if (v[a >> 2]) {
   Fu(a);
   d = v[a >> 2];
   Eu(a);
   Bb(d);
   h = zb(a), i = 0, v[h >> 2] = i;
   v[a >> 2] = 0;
   v[a + 4 >> 2] = 0;
  }
  e = cR(a, b);
  d = eb - 16 | 0;
  eb = d;
  if (th(82595524) >>> 0 < e >>> 0) {
   dd();
   p();
  }
  bR(d + 8 | 0, e);
  e = v[d + 8 >> 2];
  v[a + 4 >> 2] = e;
  v[a >> 2] = e;
  h = zb(a), i = e + B(v[d + 12 >> 2], 52) | 0, v[h >> 2] = i;
  eb = d + 16 | 0;
  rA(a, b, c);
 }
 eb = f + 16 | 0;
}

function Oh(a, b) {
 var c = C(0), d = C(0), e = C(0), f = C(0), g = C(0), h = 0;
 f = NP(a);
 h = a + 4208 | 0;
 c = C(C(z[xb(h, 4) >> 2] * C(1.899999976158142)) + C(.10000000149011612));
 g = z[a + 4268 >> 2];
 d = De(C(10), C(C(C(C(C(v[((b << 2) + a | 0) + 4292 >> 2]) / g) * C(-60)) / C(C(z[xb(h, 3) >> 2] * C(19.899999618530273)) + C(.10000000149011612))) / C(20)));
 c = C(C(De(d, C(C(2) - C(C(2) / c))) + C(-1)) / C(C(1) - uq(c > C(1) ? C(3.1415927410125732) : C(f * C(C(6.2831854820251465) / g)))));
 a: {
  if (c == C(0)) {
   break a;
  }
  if (!Tm(c)) {
   break a;
  }
  g = C(c + c);
  f = C(C(-2) - g);
  c = C(C(f * f) + C(C(c * c) * C(-4)));
  if (c > C(0)) {
   e = C(K(c));
  }
  c = C(C(e - f) / g);
  if (C(D(c)) > C(1)) {
   c = C(C(C(-f) - e) / g);
  }
  e = $f(c);
 }
 b = (b << 3) + a | 0;
 z[b + 4404 >> 2] = e;
 z[b + 4400 >> 2] = d;
 c = z[a + 4272 >> 2];
 c = C(c * c);
 e = C(C(1) - c);
 d = C(d * d);
 return C(C(C(e * C(d / C(C(1) - C(c * d)))) * e) + c);
}

function v$(a, b, c, d, e) {
 var f = 0, g = 0, h = 0, i = 0;
 a: {
  if (!d) {
   break a;
  }
  f = w[e | 0];
  if (!f) {
   break a;
  }
  g = 2240 >>> d & d >>> 0 < 12;
  i = B(c, -6);
  h = (d - 2 & 255) >>> 0 > 2;
  while (1) {
   if (!b) {
    break a;
   }
   a = a + i | 0;
   c = w[a + 3 | 0];
   b: {
    c: {
     if (!((c - 2 & 255) >>> 0 > 2 | h)) {
      c = 1;
      if (w[a + 5 | 0] < 224) {
       break c;
      }
      break a;
     }
     c = !(1 << c & 2240) | (!g | c >>> 0 > 11) ? (c | 0) == (d | 0) : 1;
     if (h) {
      break b;
     }
    }
    if ((w[a + 2 | 0] - 11 & 255) >>> 0 > 2) {
     break b;
    }
    if (w[a + 4 | 0]) {
     break a;
    }
   }
   if (!(w[a + 4 | 0] ? !g | (w[a + 2 | 0] - 3 & 255) >>> 0 > 3 : 1)) {
    break a;
   }
   b = b - 1 | 0;
   if (!c) {
    continue;
   }
   c = w[a + 5 | 0];
   if (c ? (c | 0) != (f | 0) : 0) {
    break a;
   }
   if ((c | 0) != (f | 0)) {
    continue;
   }
   break;
  }
  t[e | 0] = 0;
 }
}

function xr(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0;
 c = eb - 16 | 0;
 eb = c;
 PE(c + 8 | 0, b);
 d = v[c + 12 >> 2];
 ic(c, v[a >> 2], v[a + 8 >> 2], v[c + 8 >> 2], v[c + 12 >> 2]);
 e = v[c + 4 >> 2];
 if ((e | 0) == (d | 0)) {
  Ub(a, v[c + 12 >> 2]);
 }
 eb = c + 16 | 0;
 if ((d | 0) != (e | 0)) {
  t[b | 0] = 0;
  t[b + 1 | 0] = 0;
  t[b + 2 | 0] = 0;
  t[b + 3 | 0] = 0;
  t[b + 4 | 0] = 0;
  t[b + 5 | 0] = 0;
  t[b + 6 | 0] = 0;
  t[b + 7 | 0] = 0;
  t[b + 24 | 0] = 0;
  t[b + 25 | 0] = 0;
  t[b + 26 | 0] = 0;
  t[b + 27 | 0] = 0;
  t[b + 28 | 0] = 0;
  t[b + 29 | 0] = 0;
  t[b + 30 | 0] = 0;
  t[b + 31 | 0] = 0;
  t[b + 16 | 0] = 0;
  t[b + 17 | 0] = 0;
  t[b + 18 | 0] = 0;
  t[b + 19 | 0] = 0;
  t[b + 20 | 0] = 0;
  t[b + 21 | 0] = 0;
  t[b + 22 | 0] = 0;
  t[b + 23 | 0] = 0;
  t[b + 8 | 0] = 0;
  t[b + 9 | 0] = 0;
  t[b + 10 | 0] = 0;
  t[b + 11 | 0] = 0;
  t[b + 12 | 0] = 0;
  t[b + 13 | 0] = 0;
  t[b + 14 | 0] = 0;
  t[b + 15 | 0] = 0;
 }
}

function wla(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0;
 f = eb - 16 | 0;
 eb = f;
 h = x[c >> 1];
 i = c;
 e = eb - 16 | 0;
 eb = e;
 g = b;
 d = ce(b);
 a: {
  if (d) {
   c = fc(b);
   while (1) {
    b = d;
    d = x[b + 14 >> 1];
    if (Wk(h, d)) {
     c = b;
     d = v[b >> 2];
     if (d) {
      continue;
     }
     break a;
    }
    if (!Wk(d, h)) {
     break a;
    }
    c = b + 4 | 0;
    d = v[b + 4 >> 2];
    if (d) {
     continue;
    }
    break;
   }
   break a;
  }
  b = fc(g);
  c = b;
 }
 v[e + 12 >> 2] = b;
 b = v[c >> 2];
 if (!b) {
  b = eb - 16 | 0;
  eb = b;
  d = fc(g);
  d = Ch(e, Dc(16), Ng(b + 8 | 0, d));
  km(v[d >> 2] + 14 | 0, x[i >> 1]);
  k = fc(d), l = 1, t[k + 4 | 0] = l;
  eb = b + 16 | 0;
  _g(g, v[e + 12 >> 2], c, v[e >> 2]);
  b = me(e);
  Gk(e);
  j = 1;
 }
 c = f + 8 | 0;
 Zg(c, v[ub(e, b) >> 2], j);
 eb = e + 16 | 0;
 bV(a, c);
 eb = f + 16 | 0;
}

function Dfa(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0;
 d = eb - 16 | 0;
 eb = d;
 v[31601] = 0;
 V(995, a | 0);
 e = v[31601];
 v[31601] = 0;
 a: {
  b: {
   c: {
    if ((e | 0) == 1) {
     break c;
    }
    v[31601] = 0;
    V(996, b | 0);
    e = v[31601];
    v[31601] = 0;
    if ((e | 0) == 1) {
     break c;
    }
    e = v[a + 24 >> 2];
    b = oc(d + 8 | 0, b);
    v[31601] = 0;
    f = v[b + 4 >> 2];
    v[d >> 2] = v[b >> 2];
    v[d + 4 >> 2] = f;
    U(1013, e | 0, d | 0, (c | 0) != 0 | 0, 1);
    c = v[31601];
    v[31601] = 0;
    b = 1;
    if ((c | 0) != 1) {
     break b;
    }
   }
   X(S(0) | 0) | 0;
   v[31601] = 0;
   U(982, 10005, a | 0, 0, 0);
   a = v[31601];
   v[31601] = 0;
   if ((a | 0) == 1) {
    break a;
   }
   Y();
   b = 0;
  }
  eb = d + 16 | 0;
  return b | 0;
 }
 a = M() | 0;
 v[31601] = 0;
 W(26);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  P(a | 0);
  p();
 }
 S(0) | 0;
 Rb();
 p();
}

function uj(a, b, c) {
 var d = 0, e = 0;
 e = eb - 16 | 0;
 eb = e;
 v[a + 4 >> 2] = 0;
 d = 4;
 a: {
  b: {
   c: {
    if (!Hd(w[Em(e + 15 | 0, a, 1) | 0])) {
     break c;
    }
    d = v[(v[v[a >> 2] - 12 >> 2] + a | 0) + 24 >> 2];
    v[31601] = 0;
    b = T(85, d | 0, b | 0, c | 0) | 0;
    d = v[31601];
    v[31601] = 0;
    if ((d | 0) != 1) {
     v[a + 4 >> 2] = b;
     d = (b | 0) != (c | 0) ? 6 : 0;
     break c;
    }
    X(S(0) | 0) | 0;
    d = 1;
    Cm(v[v[a >> 2] - 12 >> 2] + a | 0, 1);
    if (v[(v[v[a >> 2] - 12 >> 2] + a | 0) + 20 >> 2] & 1) {
     v[31601] = 0;
     W(84);
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) != 1) {
      break a;
     }
     a = M() | 0;
     v[31601] = 0;
     W(26);
     b = v[31601];
     v[31601] = 0;
     if ((b | 0) == 1) {
      break b;
     }
     P(a | 0);
     p();
    }
    Y();
   }
   Wj(v[v[a >> 2] - 12 >> 2] + a | 0, d);
   eb = e + 16 | 0;
   return a;
  }
  S(0) | 0;
  Rb();
 }
 p();
}

function nR(a, b, c, d, e, f, g) {
 var h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0;
 h = eb - 16 | 0;
 eb = h;
 t[h + 15 | 0] = b;
 t[h + 14 | 0] = 10;
 eh(g, w[Pb(h + 15 | 0, h + 14 | 0) | 0]);
 t[g + 15 | 0] = c;
 t[g + 16 | 0] = c;
 t[g + 14 | 0] = e;
 t[g + 13 | 0] = d;
 j = v[g >> 2];
 k = Rd(j, v[g + 4 >> 2]);
 b = 0;
 while (1) {
  if ((b | 0) != (k | 0)) {
   m = xb(j, b);
   l = B(b, 3) + f | 0;
   i = (w[l | 0] | w[l + 1 | 0] << 8) >>> 4 | 0;
   u[m >> 1] = i;
   a: {
    if (b) {
     n = x[xb(j, b - 1 | 0) >> 1];
     if (i >>> 0 >= n >>> 0) {
      break a;
     }
     i = n + 1 | 0;
    } else {
     i = 0;
    }
    o = xb(j, b), p = i, u[o >> 1] = p;
   }
   o = m, p = Kd(w[l + 2 | 0], 0, 64), t[o + 2 | 0] = p;
   b = b + 1 | 0;
   continue;
  }
  break;
 }
 t[g + 12 | 0] = a >>> 1 & (d >>> 0 <= e >>> 0 ? (d >>> 0 <= k >>> 0) << 1 : 0) | (a << 1 & (c >>> 0 <= k >>> 0) << 2 | (w[g + 12 | 0] & 248 | a & 1));
 eb = h + 16 | 0;
}

function pI(a, b) {
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0;
 a: {
  if (a >>> 0 > 131071) {
   break a;
  }
  g = a & 255;
  c = (g >>> 0) / 3 | 0;
  f = v[((B(c, -3) + a & 255) << 2) + 108200 >> 2];
  e = c;
  c = a >>> 8 | 0;
  d = v[(((B(f, w[(e + B(w[c + 109584 | 0], 86) | 0) + 109584 | 0]) >>> 11 >>> 0) % 6 | 0) + w[c + 112256 | 0] << 2) + 108224 >> 2];
  c = d >> 8;
  d = d & 255;
  if (d >>> 0 <= 1) {
   return (c & 0 - (b ^ d)) + a | 0;
  }
  d = c & 255;
  if (!d) {
   break a;
  }
  c = c >>> 8 | 0;
  while (1) {
   h = d >>> 1 | 0;
   e = h + c | 0;
   f = (e << 1) + 109184 | 0;
   i = w[f | 0];
   if ((i | 0) == (g | 0)) {
    c = v[(w[f + 1 | 0] << 2) + 108224 >> 2];
    d = c & 255;
    if (d >>> 0 <= 1) {
     return (0 - (b ^ d) & c >> 8) + a | 0;
    }
    return (b ? -1 : 1) + a | 0;
   }
   f = e;
   e = g >>> 0 < i >>> 0;
   c = e ? c : f;
   d = e ? h : d - h | 0;
   if (d) {
    continue;
   }
   break;
  }
 }
 return a;
}

function YU(a, b) {
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0, p = 0, q = 0;
 k = b ? 33 : 32;
 c = w[a + 16 | 0];
 l = c ? -1 : 1;
 m = c ? 1 : -1;
 e = v[a + 8 >> 2] - 1 | 0;
 n = c ? e - (w[a + 17 | 0] != 0 & (e | 0) != 0) | 0 : 0;
 f = v[a + 12 >> 2];
 o = (f | 0) > 0 ? f : 0;
 p = c ? 0 : e;
 h = v[a >> 2] + B(f, 62) | 0;
 d = b ? 1 : -1;
 q = B(f, d) << 1;
 c = e;
 a: while (1) {
  if ((i | 0) != (k | 0)) {
   g = v[a + 4 >> 2] + (B(c, f) << 1) | 0;
   b = 0;
   while (1) if ((b | 0) == (o | 0)) {
    b: {
     if ((c | 0) == (e | 0)) {
      b = n;
      g = l;
      if ((d | 0) > 0) {
       break b;
      }
     }
     b = c + d | 0;
     c = !c & (d | 0) < 0;
     b = c ? p : b;
     g = c ? m : d;
    }
    h = h + q | 0;
    i = i + 1 | 0;
    c = b;
    d = g;
    continue a;
   } else {
    j = b << 1;
    u[j + h >> 1] = x[g + j >> 1];
    b = b + 1 | 0;
    continue;
   }
  }
  break;
 }
}

function Uoa(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0;
 c = eb - 80 | 0;
 eb = c;
 d = Qf(c + 52 | 0);
 v[31601] = 0;
 e = O(686, b | 0, d | 0) | 0;
 f = v[31601];
 v[31601] = 0;
 a: {
  b: {
   c: {
    d: {
     if ((f | 0) != 1) {
      if (e) {
       break d;
      }
      v[a >> 2] = 0;
      v[a + 4 >> 2] = 0;
      v[a + 24 >> 2] = 0;
      v[a + 16 >> 2] = 0;
      v[a + 20 >> 2] = 0;
      v[a + 8 >> 2] = 0;
      v[a + 12 >> 2] = 0;
      v[31601] = 0;
      Q(687, a | 0) | 0;
      a = v[31601];
      v[31601] = 0;
      if ((a | 0) != 1) {
       break a;
      }
     }
     break c;
    }
    e = v[d + 4 >> 2];
    v[31601] = 0;
    R(185, c + 12 | 0, b | 0, e | 0);
    b = v[31601];
    v[31601] = 0;
    if ((b | 0) != 1) {
     break b;
    }
   }
   a = M() | 0;
   Gd(d);
   P(a | 0);
   p();
  }
  b = c + 12 | 0;
  e = gc(c + 32 | 0, b);
  jd(d + 8 | 0, e);
  tb(e);
  tb(b);
  Lk(a, d);
 }
 Gd(d);
 eb = c + 80 | 0;
}

function Vc(a) {
 var b = 0, c = 0, d = 0;
 d = eb - 16 | 0;
 eb = d;
 b = d + 4 | 0;
 v[b + 8 >> 2] = 0;
 v[b + 4 >> 2] = 1244;
 v[b >> 2] = a;
 c = eb - 16 | 0;
 eb = c;
 if (v[a >> 2] != -1) {
  a: {
   b = ub(c + 8 | 0, xf(c + 12 | 0, b));
   while (1) {
    if (v[a >> 2] == 1) {
     continue;
    }
    break;
   }
   b: {
    if (!v[a >> 2]) {
     xd(a, 1);
     b = v[v[b >> 2] >> 2];
     v[31601] = 0;
     V(1245, b | 0);
     b = v[31601];
     v[31601] = 0;
     if ((b | 0) == 1) {
      break b;
     }
     v[a >> 2] = -1;
    }
    break a;
   }
   X(S(0) | 0) | 0;
   xd(a, 0);
   v[31601] = 0;
   W(84);
   a = v[31601];
   v[31601] = 0;
   c: {
    if ((a | 0) == 1) {
     a = M() | 0;
     v[31601] = 0;
     W(26);
     b = v[31601];
     v[31601] = 0;
     if ((b | 0) != 1) {
      break c;
     }
     S(0) | 0;
     Rb();
    }
    p();
   }
   P(a | 0);
   p();
  }
 }
 eb = c + 16 | 0;
 eb = d + 16 | 0;
 return v[a + 4 >> 2] - 1 | 0;
}

function oA(a, b) {
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = C(0);
 f = eb - 16 | 0;
 eb = f;
 c = ub(f + 12 | 0, v[a + 4 >> 2]);
 d = ub(f + 8 | 0, v[a >> 2]);
 h = v[ub(f + 4 | 0, v[b + 4 >> 2]) >> 2];
 g = eb - 16 | 0;
 eb = g;
 i = g + 8 | 0;
 e = eb - 32 | 0;
 eb = e;
 ed(e + 24 | 0, v[c >> 2], v[d >> 2]);
 j = e + 16 | 0;
 d = v[e + 24 >> 2];
 k = v[e + 28 >> 2];
 c = eb - 16 | 0;
 eb = c;
 v[c + 8 >> 2] = h;
 v[c + 12 >> 2] = d;
 while (1) {
  if (Ed(d, k)) {
   d = wf(d);
   l = wf(v[c + 8 >> 2]), m = z[d >> 2], z[l >> 2] = m;
   d = vj(c + 12 | 0);
   vj(c + 8 | 0);
   d = v[d >> 2];
   continue;
  }
  break;
 }
 pc(j, d, c + 8 | 0);
 eb = c + 16 | 0;
 c = v[e + 16 >> 2];
 v[e + 12 >> 2] = v[e + 20 >> 2];
 pc(i, c, e + 12 | 0);
 eb = e + 32 | 0;
 eb = g + 16 | 0;
 v[b + 4 >> 2] = v[g + 12 >> 2];
 Sb(a, b + 4 | 0);
 Sb(a + 4 | 0, b + 8 | 0);
 Sb(zb(a), mc(b));
 v[b >> 2] = v[b + 4 >> 2];
 eb = f + 16 | 0;
}

function ZR(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0;
 e = eb - 16 | 0;
 eb = e;
 v[e + 12 >> 2] = 16777216;
 h = e + 12 | 0;
 d = v[a >> 2];
 c = nc(d, v[a + 4 >> 2]);
 a: {
  if (c >>> 0 < b >>> 0) {
   f = eb - 32 | 0;
   eb = f;
   b = b - c | 0;
   c = v[zb(a) >> 2];
   d = v[a + 4 >> 2];
   b: {
    if (b >>> 0 <= c - d >> 2 >>> 0) {
     XE(a, b, h);
     break b;
    }
    c = zb(a);
    c = Yf(f + 12 | 0, Kf(a, nc(v[a >> 2], d) + b | 0), nc(v[a >> 2], v[a + 4 >> 2]), c);
    g = eb - 16 | 0;
    eb = g;
    b = En(g + 4 | 0, c + 8 | 0, b);
    d = v[b >> 2];
    while (1) {
     if (v[b + 4 >> 2] != (d | 0)) {
      vq(d, v[h >> 2]);
      d = v[b >> 2] + 4 | 0;
      v[b >> 2] = d;
      continue;
     }
     break;
    }
    ie(b);
    eb = g + 16 | 0;
    Rm(a, c);
    Xf(c);
   }
   eb = f + 32 | 0;
   break a;
  }
  if (b >>> 0 < c >>> 0) {
   Id(a, d + (b << 2) | 0);
  }
 }
 RA(a);
 eb = e + 16 | 0;
}

function Rm(a, b) {
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0;
 f = eb - 16 | 0;
 eb = f;
 c = ub(f + 12 | 0, v[a + 4 >> 2]);
 d = ub(f + 8 | 0, v[a >> 2]);
 h = v[ub(f + 4 | 0, v[b + 4 >> 2]) >> 2];
 g = eb - 16 | 0;
 eb = g;
 i = g + 8 | 0;
 e = eb - 32 | 0;
 eb = e;
 ed(e + 24 | 0, v[c >> 2], v[d >> 2]);
 j = e + 16 | 0;
 d = v[e + 24 >> 2];
 k = v[e + 28 >> 2];
 c = eb - 16 | 0;
 eb = c;
 v[c + 8 >> 2] = h;
 v[c + 12 >> 2] = d;
 while (1) {
  if (Ed(d, k)) {
   d = wf(d);
   l = wf(v[c + 8 >> 2]), m = v[d >> 2], v[l >> 2] = m;
   d = vj(c + 12 | 0);
   vj(c + 8 | 0);
   d = v[d >> 2];
   continue;
  }
  break;
 }
 pc(j, d, c + 8 | 0);
 eb = c + 16 | 0;
 c = v[e + 16 >> 2];
 v[e + 12 >> 2] = v[e + 20 >> 2];
 pc(i, c, e + 12 | 0);
 eb = e + 32 | 0;
 eb = g + 16 | 0;
 v[b + 4 >> 2] = v[g + 12 >> 2];
 Sb(a, b + 4 | 0);
 Sb(a + 4 | 0, b + 8 | 0);
 Sb(zb(a), mc(b));
 v[b >> 2] = v[b + 4 >> 2];
 eb = f + 16 | 0;
}

function ML(a) {
 var b = 0, c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0;
 if (ff(a)) {
  bc(a, 31);
  return 0;
 }
 h = a, i = ff(a), t[h + 1375 | 0] = i;
 d = qj(a);
 b = qj(a);
 qj(a);
 h = a, i = qj(a), v[h + 1112 >> 2] = i;
 qj(a);
 c = ff(a);
 v[a + 1116 >> 2] = c;
 e = a + 1120 | 0;
 if (!fz(a, e, c)) {
  bc(a, 10);
  return 0;
 }
 v[a + 1404 >> 2] = -2;
 a: {
  if ((b & d) == -1) {
   break a;
  }
  b = v[a + 1116 >> 2];
  while (1) {
   if ((b | 0) <= 0) {
    break a;
   }
   b = b - 1 | 0;
   if (w[e + b | 0] == 255) {
    continue;
   }
   break;
  }
  v[a + 1408 >> 2] = d;
  v[a + 1404 >> 2] = b;
 }
 if (w[a + 1377 | 0]) {
  b = 0;
  f = v[a + 1116 >> 2];
  g = (f | 0) > 0 ? f : 0;
  c = 0;
  while (1) {
   if ((b | 0) != (g | 0)) {
    c = w[b + e | 0] + c | 0;
    b = b + 1 | 0;
    continue;
   }
   break;
  }
  v[a + 64 >> 2] = d;
  v[a + 60 >> 2] = (v[a + 56 >> 2] + (c + f | 0) | 0) + 27;
 }
 v[a + 1380 >> 2] = 0;
 return 1;
}

function Cfa(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = +c;
 var d = 0, e = 0, f = 0;
 e = eb - 16 | 0;
 eb = e;
 v[31601] = 0;
 V(995, a | 0);
 d = v[31601];
 v[31601] = 0;
 a: {
  b: {
   c: {
    if ((d | 0) == 1) {
     break c;
    }
    v[31601] = 0;
    V(996, b | 0);
    d = v[31601];
    v[31601] = 0;
    if ((d | 0) == 1) {
     break c;
    }
    d = v[a + 24 >> 2];
    b = oc(e + 8 | 0, b);
    v[31601] = 0;
    f = v[b + 4 >> 2];
    v[e >> 2] = v[b >> 2];
    v[e + 4 >> 2] = f;
    Ya(1015, d | 0, e | 0, +c, 1);
    d = v[31601];
    v[31601] = 0;
    b = 1;
    if ((d | 0) != 1) {
     break b;
    }
   }
   X(S(0) | 0) | 0;
   v[31601] = 0;
   U(982, 5926, a | 0, 0, 0);
   a = v[31601];
   v[31601] = 0;
   if ((a | 0) == 1) {
    break a;
   }
   Y();
   b = 0;
  }
  eb = e + 16 | 0;
  return b | 0;
 }
 a = M() | 0;
 v[31601] = 0;
 W(26);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  P(a | 0);
  p();
 }
 S(0) | 0;
 Rb();
 p();
}

function mN(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0;
 d = eb - 16 | 0;
 eb = d;
 a: {
  b: {
   c: {
    a = v[a + 32 >> 2];
    c = qq(a);
    d: {
     if (!c) {
      if (pq(a) >>> 0 <= b >>> 0) {
       break d;
      }
      c = (w[mi(a, b + 1 & 65535) + 35 | 0] & 4) >>> 2 | 0;
      break b;
     }
     if (b >>> 0 < c >>> 0) {
      break c;
     }
    }
    a = cc(8);
    v[31601] = 0;
    b = O(36, d + 4 | 0, 6e3) | 0;
    c = v[31601];
    v[31601] = 0;
    e: {
     if ((c | 0) != 1) {
      rc(a, b);
      v[31601] = 0;
      R(97, a | 0, 48396, 999);
      a = v[31601];
      v[31601] = 0;
      if ((a | 0) != 1) {
       break a;
      }
      c = M() | 0;
      sb(b);
      break e;
     }
     c = M() | 0;
     jc(a);
    }
    P(c | 0);
    p();
   }
   a = v[(a + (b << 2) | 0) + 900384 >> 2];
   c = 1;
   if (!a) {
    break b;
   }
   c = (w[a + 15 | 0] & 2) >>> 1 | 0;
  }
  eb = d + 16 | 0;
  return c | 0;
 }
 p();
}

function ZG(a, b, c, d, e) {
 var f = 0, g = 0, h = 0;
 a: {
  g = eb - 32 | 0;
  eb = g;
  h = Mb(a);
  b: {
   c: {
    d: {
     e: {
      while (1) {
       a = v[b + 8 >> 2];
       f = v[b >> 2];
       v[31601] = 0;
       a = T(150, f | 0, a | 0, 8) | 0;
       f = v[31601];
       v[31601] = 0;
       if ((f | 0) == 1) {
        break c;
       }
       if (!a) {
        break d;
       }
       v[31601] = 0;
       a = g + 4 | 0;
       R(e | 0, a | 0, b | 0, c | 0);
       f = v[31601];
       v[31601] = 0;
       if ((f | 0) != 1) {
        v[31601] = 0;
        N(d | 0, h | 0, a | 0);
        f = v[31601];
        v[31601] = 0;
        if ((f | 0) == 1) {
         break e;
        }
        Gd(a);
        continue;
       }
       break;
      }
      a = M() | 0;
      break b;
     }
     a = M() | 0;
     Gd(g + 4 | 0);
     break b;
    }
    eb = g + 32 | 0;
    break a;
   }
   a = M() | 0;
  }
  je(h);
  P(a | 0);
  p();
 }
}

function Vp(a, b, c, d, e) {
 var f = 0, g = 0, h = 0;
 a: {
  g = eb - 32 | 0;
  eb = g;
  h = Mb(a);
  b: {
   c: {
    d: {
     e: {
      while (1) {
       a = v[b + 8 >> 2];
       f = v[b >> 2];
       v[31601] = 0;
       a = T(150, f | 0, a | 0, e | 0) | 0;
       f = v[31601];
       v[31601] = 0;
       if ((f | 0) == 1) {
        break c;
       }
       if (!a) {
        break d;
       }
       v[31601] = 0;
       a = g + 4 | 0;
       N(d | 0, a | 0, b | 0);
       f = v[31601];
       v[31601] = 0;
       if ((f | 0) != 1) {
        v[31601] = 0;
        N(c | 0, h | 0, a | 0);
        f = v[31601];
        v[31601] = 0;
        if ((f | 0) == 1) {
         break e;
        }
        Gd(a);
        continue;
       }
       break;
      }
      a = M() | 0;
      break b;
     }
     a = M() | 0;
     Gd(g + 4 | 0);
     break b;
    }
    eb = g + 32 | 0;
    break a;
   }
   a = M() | 0;
  }
  je(h);
  P(a | 0);
  p();
 }
}

function Vma(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0;
 b = eb - 16 | 0;
 eb = b;
 e = v[a + 40 >> 2];
 f = v[a + 36 >> 2];
 j = v[a + 16 >> 2];
 h = v[a + 4 >> 2];
 v[b + 8 >> 2] = v[a >> 2];
 v[b + 12 >> 2] = h;
 k = v[a + 32 >> 2];
 l = v[a + 28 >> 2];
 h = v[a + 8 >> 2];
 m = v[a + 12 >> 2];
 while (1) {
  if (d) {
   i = v[b + 12 >> 2] + j | 0;
   g = t[i | 0];
   g = ((B(t[i + 1 | 0] - g | 0, v[b + 8 >> 2] >>> 10 & 4194048) | 0) / 16384 | 0) + (g << 8) | 0;
   f = f + l | 0;
   v[c >> 2] = v[c >> 2] + B(g, f >> 12);
   e = e + k | 0;
   v[c + 4 >> 2] = v[c + 4 >> 2] + B(g, e >> 12);
   Ob(b + 8 | 0, h, m);
   c = c + 8 | 0;
   d = d - 1 | 0;
   continue;
  }
  break;
 }
 c = v[b + 12 >> 2];
 v[a >> 2] = v[b + 8 >> 2];
 v[a + 4 >> 2] = c;
 v[a + 40 >> 2] = e;
 v[a + 20 >> 2] = f >> 12;
 v[a + 36 >> 2] = f;
 v[a + 24 >> 2] = e >> 12;
 eb = b + 16 | 0;
}

function zK(a, b, c, d) {
 var e = 0, f = 0, g = 0, h = 0;
 e = eb - 16 | 0;
 eb = e;
 a: {
  b: {
   if ((a | 0) != (b | 0)) {
    c: {
     d: {
      f = w[a | 0];
      if ((f | 0) != 45) {
       break d;
      }
      a = a + 1 | 0;
      if ((b | 0) != (a | 0)) {
       break d;
      }
      break c;
     }
     h = v[31476];
     v[31476] = 0;
     Nd();
     a = Iy(a, e + 12 | 0, d);
     d = gb;
     g = v[31476];
     e: {
      if (g) {
       if (v[e + 12 >> 2] != (b | 0)) {
        break c;
       }
       if (!d & a >>> 0 > 65535 | d | (g | 0) == 68) {
        break e;
       }
       break b;
      }
      v[31476] = h;
      if (v[e + 12 >> 2] != (b | 0)) {
       break c;
      }
      if (!d & a >>> 0 < 65536) {
       break b;
      }
     }
     v[c >> 2] = 4;
     a = 65535;
     break a;
    }
   }
   v[c >> 2] = 4;
   a = 0;
   break a;
  }
  a = (f | 0) == 45 ? 0 - a | 0 : a;
 }
 eb = e + 16 | 0;
 return a & 65535;
}

function oH(a, b, c, d) {
 var e = 0, f = 0, g = 0;
 e = eb - 80 | 0;
 eb = e;
 f = Qf(e + 52 | 0);
 v[31601] = 0;
 d = O(d | 0, b | 0, f | 0) | 0;
 g = v[31601];
 v[31601] = 0;
 a: {
  b: {
   c: {
    d: {
     if ((g | 0) != 1) {
      if (d) {
       break d;
      }
      v[a >> 2] = 0;
      v[a + 4 >> 2] = 0;
      v[a + 24 >> 2] = 0;
      v[a + 16 >> 2] = 0;
      v[a + 20 >> 2] = 0;
      v[a + 8 >> 2] = 0;
      v[a + 12 >> 2] = 0;
      v[31601] = 0;
      Q(c | 0, a | 0) | 0;
      a = v[31601];
      v[31601] = 0;
      if ((a | 0) != 1) {
       break a;
      }
     }
     break c;
    }
    c = v[f + 4 >> 2];
    v[31601] = 0;
    R(185, e + 12 | 0, b | 0, _b(c) | 0);
    b = v[31601];
    v[31601] = 0;
    if ((b | 0) != 1) {
     break b;
    }
   }
   a = M() | 0;
   Gd(f);
   P(a | 0);
   p();
  }
  b = e + 12 | 0;
  c = gc(e + 32 | 0, b);
  jd(f + 8 | 0, c);
  tb(c);
  tb(b);
  Lk(a, f);
 }
 Gd(f);
 eb = e + 80 | 0;
}

function Uma(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0;
 b = eb - 16 | 0;
 eb = b;
 f = v[a + 40 >> 2];
 g = v[a + 36 >> 2];
 i = v[a + 16 >> 2];
 e = v[a + 4 >> 2];
 v[b + 8 >> 2] = v[a >> 2];
 v[b + 12 >> 2] = e;
 j = v[a + 32 >> 2];
 k = v[a + 28 >> 2];
 l = v[a + 8 >> 2];
 m = v[a + 12 >> 2];
 while (1) {
  if (d) {
   e = (v[b + 12 >> 2] << 1) + i | 0;
   h = u[e >> 1];
   e = h + ((B(u[e + 2 >> 1] - h | 0, v[b + 8 >> 2] >>> 18 | 0) | 0) / 16384 | 0) | 0;
   g = g + k | 0;
   v[c >> 2] = v[c >> 2] + B(e, g >> 12);
   f = f + j | 0;
   v[c + 4 >> 2] = v[c + 4 >> 2] + B(e, f >> 12);
   Ob(b + 8 | 0, l, m);
   c = c + 8 | 0;
   d = d - 1 | 0;
   continue;
  }
  break;
 }
 c = v[b + 12 >> 2];
 v[a >> 2] = v[b + 8 >> 2];
 v[a + 4 >> 2] = c;
 v[a + 40 >> 2] = f;
 v[a + 20 >> 2] = g >> 12;
 v[a + 36 >> 2] = g;
 v[a + 24 >> 2] = f >> 12;
 eb = b + 16 | 0;
}

function bn(a, b, c, d, e, f) {
 var g = 0, h = 0, i = 0, j = 0;
 a: {
  if (f & 64) {
   c = f + -64 | 0;
   b = c & 31;
   if ((c & 63) >>> 0 >= 32) {
    c = 0;
    b = e >>> b | 0;
   } else {
    c = e >>> b | 0;
    b = ((1 << b) - 1 & e) << 32 - b | d >>> b;
   }
   d = 0;
   e = 0;
   break a;
  }
  if (!f) {
   break a;
  }
  i = d;
  h = 64 - f | 0;
  g = h & 31;
  if ((h & 63) >>> 0 >= 32) {
   h = d << g;
   j = 0;
  } else {
   h = (1 << g) - 1 & i >>> 32 - g | e << g;
   j = i << g;
  }
  i = b;
  b = f & 31;
  if ((f & 63) >>> 0 >= 32) {
   g = 0;
   b = c >>> b | 0;
  } else {
   g = c >>> b | 0;
   b = ((1 << b) - 1 & c) << 32 - b | i >>> b;
  }
  b = j | b;
  c = g | h;
  g = d;
  d = f & 31;
  if ((f & 63) >>> 0 >= 32) {
   h = 0;
   d = e >>> d | 0;
  } else {
   h = e >>> d | 0;
   d = ((1 << d) - 1 & e) << 32 - d | g >>> d;
  }
  e = h;
 }
 v[a >> 2] = b;
 v[a + 4 >> 2] = c;
 v[a + 8 >> 2] = d;
 v[a + 12 >> 2] = e;
}

function AS(a, b, c) {
 var d = 0, e = 0, f = 0, g = 0;
 d = eb - 16 | 0;
 eb = d;
 a: {
  if (b) {
   t[c | 0] = b;
   break a;
  }
  b = w[c | 0];
 }
 c = b & 240;
 e = v[a + 480180 >> 2];
 b = e & 1048580 ? c ? c : b : b;
 c = b & 15;
 b = b & 255;
 b: {
  c: {
   d: {
    if (!((c | 0) != 15 | b >>> 0 < 16)) {
     if (!(w[a + 480209 | 0] & 16)) {
      break b;
     }
     b = b >>> 3 & 30;
     break d;
    }
    f = v[a + 480208 >> 2] & 4096;
    g = b & 240;
    if (!(!c | (g | 0) != 240)) {
     if (!f) {
      break b;
     }
     b = 0 - (c << 1) | 0;
     break c;
    }
    if (f) {
     break b;
    }
    if (g) {
     if (e & 59314208 ? c : 0) {
      break b;
     }
     b = b >>> 3 & 30;
     break d;
    }
    b = 0 - (b << 1) | 0;
   }
   if (!b) {
    break b;
   }
  }
  v[d + 12 >> 2] = v[a + 1074456 >> 2] + (b << !(e & 59314208));
  Fe(d + 12 | 0, 0, 256);
  v[a + 1074456 >> 2] = v[d + 12 >> 2];
 }
 eb = d + 16 | 0;
}

function f7(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0;
 g = eb - 16 | 0;
 eb = g;
 e = Cb(v[a + 4 >> 2], w[a + 11 | 0]);
 d = sn(a);
 f = Rd(b, c);
 a: {
  if (!f) {
   break a;
  }
  b: {
   h = Jb(a);
   if (!F_(h, ((Cb(v[a + 4 >> 2], w[a + 11 | 0]) << 2) + h | 0) + 4 | 0, b)) {
    if (d - e >>> 0 < f >>> 0) {
     rC(a, d, (e - d | 0) + f | 0, e, e, 0);
    }
    d = Jb(a) + (e << 2) | 0;
    while (1) {
     if ((b | 0) == (c | 0)) {
      break b;
     }
     xd(d, v[b >> 2]);
     b = b + 4 | 0;
     d = d + 4 | 0;
     continue;
    }
   }
   b = eq(g + 4 | 0, b, c);
   c = Jb(b);
   e = w[b + 11 | 0];
   d = v[b + 4 >> 2];
   v[31601] = 0;
   T(1288, a | 0, c | 0, Cb(d, e) | 0) | 0;
   c = v[31601];
   v[31601] = 0;
   if ((c | 0) != 1) {
    Tb(b);
    break a;
   }
   a = M() | 0;
   Tb(b);
   P(a | 0);
   p();
  }
  xd(d, 0);
  kg(a, e + f | 0);
 }
 eb = g + 16 | 0;
 return a | 0;
}

function AL(a, b) {
 var c = 0, d = 0, e = 0, f = 0, g = 0;
 if (!w[496320]) {
  f = 496321, g = Pa() | 0, t[f | 0] = g;
  t[496320] = 1;
 }
 a: {
  b: {
   c: {
    d: {
     switch (a | 0) {
     case 0:
      break b;

     case 1:
     case 4:
      break d;

     default:
      break c;
     }
    }
    if (!w[496321]) {
     break c;
    }
    d = +Fa();
    break a;
   }
   v[31476] = 28;
   return -1;
  }
  d = +Wa();
 }
 c = d / 1e3;
 e: {
  if (D(c) < 0x8000000000000000) {
   e = ~~c >>> 0;
   if (D(c) >= 1) {
    a = ~~(c > 0 ? F(H(c * 2.3283064365386963e-10), 4294967295) : I((c - +(~~c >>> 0 >>> 0)) * 2.3283064365386963e-10)) >>> 0;
   } else {
    a = 0;
   }
   break e;
  }
  a = -2147483648;
 }
 v[b >> 2] = e;
 v[b + 4 >> 2] = a;
 c = (d - (+(Aua(e, a, 1e3, 0) >>> 0) + +(gb | 0) * 4294967296)) * 1e3 * 1e3;
 f: {
  if (D(c) < 2147483648) {
   a = ~~c;
   break f;
  }
  a = -2147483648;
 }
 v[b + 8 >> 2] = a;
 return 0;
}

function Hfa(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0;
 c = eb - 16 | 0;
 eb = c;
 v[31601] = 0;
 V(995, a | 0);
 d = v[31601];
 v[31601] = 0;
 a: {
  b: {
   c: {
    if ((d | 0) == 1) {
     break c;
    }
    v[31601] = 0;
    V(996, b | 0);
    d = v[31601];
    v[31601] = 0;
    if ((d | 0) == 1) {
     break c;
    }
    d = v[a + 24 >> 2];
    b = oc(c + 8 | 0, b);
    v[31601] = 0;
    f = v[b + 4 >> 2];
    v[c >> 2] = v[b >> 2];
    v[c + 4 >> 2] = f;
    e = +na(1006, d | 0, c | 0, 1);
    b = v[31601];
    v[31601] = 0;
    if ((b | 0) != 1) {
     break b;
    }
   }
   X(S(0) | 0) | 0;
   v[31601] = 0;
   U(982, 5963, a | 0, 0, 0);
   a = v[31601];
   v[31601] = 0;
   if ((a | 0) == 1) {
    break a;
   }
   Y();
   e = 0;
  }
  eb = c + 16 | 0;
  return +e;
 }
 a = M() | 0;
 v[31601] = 0;
 W(26);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  P(a | 0);
  p();
 }
 S(0) | 0;
 Rb();
 p();
}

function Ifa(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0;
 d = eb - 16 | 0;
 eb = d;
 v[31601] = 0;
 V(995, a | 0);
 c = v[31601];
 v[31601] = 0;
 a: {
  b: {
   c: {
    if ((c | 0) == 1) {
     break c;
    }
    v[31601] = 0;
    V(996, b | 0);
    c = v[31601];
    v[31601] = 0;
    if ((c | 0) == 1) {
     break c;
    }
    c = v[a + 24 >> 2];
    b = oc(d + 8 | 0, b);
    v[31601] = 0;
    e = v[b + 4 >> 2];
    v[d >> 2] = v[b >> 2];
    v[d + 4 >> 2] = e;
    b = T(1002, c | 0, d | 0, 1) | 0;
    c = v[31601];
    v[31601] = 0;
    if ((c | 0) != 1) {
     break b;
    }
   }
   X(S(0) | 0) | 0;
   v[31601] = 0;
   U(982, 10036, a | 0, 0, 0);
   a = v[31601];
   v[31601] = 0;
   if ((a | 0) == 1) {
    break a;
   }
   Y();
   b = 0;
  }
  eb = d + 16 | 0;
  return b | 0;
 }
 a = M() | 0;
 v[31601] = 0;
 W(26);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  P(a | 0);
  p();
 }
 S(0) | 0;
 Rb();
 p();
}

function Js(a, b, c, d, e, f) {
 var g = 0, h = 0, i = 0;
 g = eb - 16 | 0;
 eb = g;
 a = fO(a);
 v[a + 8 >> 2] = 0;
 v[a >> 2] = 47596;
 v[31601] = 0;
 i = Q(851, 104) | 0;
 h = v[31601];
 v[31601] = 0;
 a: {
  b: {
   c: {
    d: {
     if ((h | 0) != 1) {
      v[31601] = 0;
      d = Q(1098, d | 0) | 0;
      h = v[31601];
      v[31601] = 0;
      if ((h | 0) == 1) {
       break d;
      }
      v[g + 8 >> 2] = d;
      d = g + 8 | 0;
      h = v[re(g + 12 | 0, d) >> 2];
      v[31601] = 0;
      b = ga(f | 0, i | 0, b | 0, c | 0, h | 0, e | 0) | 0;
      c = v[31601];
      v[31601] = 0;
      if ((c | 0) == 1) {
       break c;
      }
      v[a + 8 >> 2] = b;
      Wc(d);
      b = v[a + 8 >> 2];
      Ad(a, b ? b + 8 | 0 : 0);
      eb = g + 16 | 0;
      return a;
     }
     b = M() | 0;
     break a;
    }
    b = M() | 0;
    break b;
   }
   b = M() | 0;
   Wc(g + 8 | 0);
  }
  Bb(i);
 }
 Nm(a);
 P(b | 0);
 p();
}

function Tna(a, b, c, d, e) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 var f = 0, g = 0;
 a: {
  f = eb - 48 | 0;
  eb = f;
  g = f + 12 | 0;
  Gr(g, c);
  v[31601] = 0;
  c = f + 24 | 0;
  N(596, c | 0, d | 0);
  d = v[31601];
  v[31601] = 0;
  b: {
   c: {
    d: {
     if ((d | 0) == 1) {
      break d;
     }
     v[31601] = 0;
     c = f + 36 | 0;
     N(596, c | 0, e | 0);
     d = v[31601];
     v[31601] = 0;
     if ((d | 0) == 1) {
      break d;
     }
     wx(f + 4 | 0, g);
     v[31601] = 0;
     U(301, a | 0, b | 0, v[f + 4 >> 2], v[f + 8 >> 2]);
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) == 1) {
      break c;
     }
     Sn(g);
     eb = f + 48 | 0;
     break a;
    }
    a = M() | 0;
    while (1) {
     c = sb(c - 12 | 0);
     if ((c | 0) != (f + 12 | 0)) {
      continue;
     }
     break;
    }
    break b;
   }
   a = M() | 0;
   Sn(f + 12 | 0);
  }
  P(a | 0);
  p();
 }
}

function v2(a, b, c, d, e) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 var f = 0, g = 0;
 a: {
  f = eb - 48 | 0;
  eb = f;
  g = f + 12 | 0;
  Op(g, c);
  v[31601] = 0;
  c = f + 24 | 0;
  N(133, c | 0, d | 0);
  d = v[31601];
  v[31601] = 0;
  b: {
   c: {
    d: {
     if ((d | 0) == 1) {
      break d;
     }
     v[31601] = 0;
     c = f + 36 | 0;
     N(133, c | 0, e | 0);
     d = v[31601];
     v[31601] = 0;
     if ((d | 0) == 1) {
      break d;
     }
     wx(f + 4 | 0, g);
     v[31601] = 0;
     U(92, a | 0, b | 0, v[f + 4 >> 2], v[f + 8 >> 2]);
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) == 1) {
      break c;
     }
     Sn(g);
     eb = f + 48 | 0;
     break a;
    }
    a = M() | 0;
    while (1) {
     c = sb(c - 12 | 0);
     if ((c | 0) != (f + 12 | 0)) {
      continue;
     }
     break;
    }
    break b;
   }
   a = M() | 0;
   Sn(f + 12 | 0);
  }
  P(a | 0);
  p();
 }
}

function Dy(a, b, c, d, e) {
 var f = 0, g = 0, h = 0;
 f = eb - 16 | 0;
 eb = f;
 h = f + 12 | 0;
 bd(h, b);
 v[31601] = 0;
 b = Q(1251, v[f + 12 >> 2]) | 0;
 g = v[31601];
 v[31601] = 0;
 a: {
  if ((g | 0) == 1) {
   break a;
  }
  v[31601] = 0;
  U(1262, b | 0, 95136, 95168, c | 0);
  b = v[31601];
  v[31601] = 0;
  if ((b | 0) == 1) {
   break a;
  }
  v[31601] = 0;
  b = Q(1252, v[f + 12 >> 2]) | 0;
  c = v[31601];
  v[31601] = 0;
  if ((c | 0) == 1) {
   break a;
  }
  v[31601] = 0;
  c = Q(1263, b | 0) | 0;
  g = v[31601];
  v[31601] = 0;
  if ((g | 0) == 1) {
   break a;
  }
  v[d >> 2] = c;
  v[31601] = 0;
  c = Q(1260, b | 0) | 0;
  d = v[31601];
  v[31601] = 0;
  if ((d | 0) == 1) {
   break a;
  }
  v[e >> 2] = c;
  v[31601] = 0;
  N(1261, a | 0, b | 0);
  a = v[31601];
  v[31601] = 0;
  if ((a | 0) == 1) {
   break a;
  }
  Zb(h);
  eb = f + 16 | 0;
  return;
 }
 a = M() | 0;
 Zb(f + 12 | 0);
 P(a | 0);
 p();
}

function AW(a, b, c, d, e, f) {
 b = w[(b & 15) + 25376 | 0];
 t[a + 3 | 0] = b;
 a: {
  b: {
   switch (b - 11 | 0) {
   case 0:
    b = w[a + 5 | 0] & 15;
    if (!b) {
     break a;
    }
    t[a + 5 | 0] = b;
    return;

   case 3:
    b = w[a + 5 | 0];
    b = B(b & 240, 10) | b & 15;
    t[a + 5 | 0] = b;
    d = b & 255;
    b = x[e >> 1];
    if (!(d | (b | 0) == 65535)) {
     t[a + 5 | 0] = b;
     t[a + 3 | 0] = 12;
     u[e >> 1] = 65535;
    }
    wc(f, c);
    return;

   case 1:
    u[e >> 1] = w[a + 5 | 0];
    v[f >> 2] = 63;
    t[a + 3 | 0] = 0;
    return;

   case 5:
    b = w[a + 5 | 0];
    if (d >>> 0 <= 20) {
     c = ((b & 255) >>> 0) / 10 | 0;
     b = c << 4 | B(c, -10) + b;
     t[a + 5 | 0] = b;
    }
    if (b & 255) {
     break a;
    }
    t[a + 3 | 0] = 0;
    return;

   case 7:
    break a;

   default:
    break b;
   }
  }
  if (w[a + 5 | 0]) {
   break a;
  }
  t[a + 3 | 0] = 0;
 }
}

function ZU(a, b) {
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0;
 i = b ? 33 : 32;
 c = v[a + 8 >> 2] - 1 | 0;
 e = v[a + 12 >> 2];
 f = v[a >> 2] + B(e, 31) | 0;
 g = b ? 1 : -1;
 d = g;
 a: while (1) {
  b: {
   b = 0;
   if ((h | 0) == (i | 0)) {
    break b;
   }
   while (1) if ((b | 0) >= (e | 0)) {
    b = v[a + 8 >> 2] - 1 | 0;
    c: {
     if (!((b | 0) != (c | 0) | (d | 0) <= 0)) {
      if (!w[a + 16 | 0]) {
       d = 1;
       c = 0;
       break c;
      }
      d = -1;
      c = c - (w[a + 17 | 0] != 0 & (c | 0) != 0) | 0;
      break c;
     }
     if (!((d | 0) >= 0 | c)) {
      c = w[a + 16 | 0];
      d = c ? 1 : -1;
      c = c ? 0 : b;
      break c;
     }
     c = c + d | 0;
    }
    f = B(e, g) + f | 0;
    h = h + 1 | 0;
    continue a;
   } else {
    t[b + f | 0] = w[(v[a + 4 >> 2] + B(c, e) | 0) + b | 0];
    b = b + 1 | 0;
    e = v[a + 12 >> 2];
    continue;
   }
  }
  break;
 }
}

function zo(a, b, c, d) {
 var e = 0, f = 0;
 e = eb - 16 | 0;
 eb = e;
 a: {
  b: {
   c: {
    if (!d) {
     break c;
    }
    f = c >> 31;
    d = f;
    d = (d ^ c) - d | 0;
    if (d >>> 0 < 224) {
     break c;
    }
    Ib(e + 8 | 0, a + 1074312 | 0, 3);
    if (Fb(v[v[e + 8 >> 2] >> 2], v[e + 12 >> 2])) {
     break c;
    }
    if (!(t[(B(b, 872) + a | 0) + 1075843 | 0] & 1)) {
     break a;
    }
    c = B(d & 15, (c | 0) != 0 | f);
    c = d >>> 0 > 239 ? c << 2 : c;
    break b;
   }
   if (t[(B(b, 872) + a | 0) + 1075843 | 0] & 1) {
    Ib(e + 8 | 0, a + 1074312 | 0, 3);
    if (!Fb(v[v[e + 8 >> 2] >> 2], v[e + 12 >> 2])) {
     break a;
    }
   }
   c = c << 2;
  }
  if (!c) {
   break a;
  }
  f = B(b, 872) + a | 0;
  d = v[f + 1075648 >> 2];
  a = Eq(a, v[f + 1075080 >> 2], d);
  if (!a) {
   break a;
  }
  hb[v[v[a >> 2] + 84 >> 2]](a, c, (d ? w[d + 33 | 0] : 13) << 24 >> 24, b);
 }
 eb = e + 16 | 0;
}

function Hy(a, b, c, d, e) {
 var f = 0, g = 0, h = 0;
 f = eb - 16 | 0;
 eb = f;
 h = f + 12 | 0;
 bd(h, b);
 v[31601] = 0;
 b = Q(28, v[f + 12 >> 2]) | 0;
 g = v[31601];
 v[31601] = 0;
 a: {
  if ((g | 0) == 1) {
   break a;
  }
  v[31601] = 0;
  U(1248, b | 0, 95136, 95168, c | 0);
  b = v[31601];
  v[31601] = 0;
  if ((b | 0) == 1) {
   break a;
  }
  v[31601] = 0;
  b = Q(1234, v[f + 12 >> 2]) | 0;
  c = v[31601];
  v[31601] = 0;
  if ((c | 0) == 1) {
   break a;
  }
  v[31601] = 0;
  c = Q(1249, b | 0) | 0;
  g = v[31601];
  v[31601] = 0;
  if ((g | 0) == 1) {
   break a;
  }
  t[d | 0] = c;
  v[31601] = 0;
  c = Q(1246, b | 0) | 0;
  d = v[31601];
  v[31601] = 0;
  if ((d | 0) == 1) {
   break a;
  }
  t[e | 0] = c;
  v[31601] = 0;
  N(1247, a | 0, b | 0);
  a = v[31601];
  v[31601] = 0;
  if ((a | 0) == 1) {
   break a;
  }
  Zb(h);
  eb = f + 16 | 0;
  return;
 }
 a = M() | 0;
 Zb(f + 12 | 0);
 P(a | 0);
 p();
}

function Is(a, b, c, d, e) {
 var f = 0, g = 0, h = 0;
 f = eb - 16 | 0;
 eb = f;
 a = fO(a);
 v[a + 8 >> 2] = 0;
 v[a >> 2] = 47596;
 v[31601] = 0;
 h = Q(851, 104) | 0;
 g = v[31601];
 v[31601] = 0;
 a: {
  b: {
   c: {
    d: {
     if ((g | 0) != 1) {
      v[31601] = 0;
      c = Q(1098, c | 0) | 0;
      g = v[31601];
      v[31601] = 0;
      if ((g | 0) == 1) {
       break d;
      }
      v[f + 8 >> 2] = c;
      c = f + 8 | 0;
      g = v[re(f + 12 | 0, c) >> 2];
      v[31601] = 0;
      b = aa(e | 0, h | 0, b | 0, g | 0, d | 0) | 0;
      d = v[31601];
      v[31601] = 0;
      if ((d | 0) == 1) {
       break c;
      }
      v[a + 8 >> 2] = b;
      Wc(c);
      b = v[a + 8 >> 2];
      Ad(a, b ? b + 8 | 0 : 0);
      eb = f + 16 | 0;
      return a;
     }
     b = M() | 0;
     break a;
    }
    b = M() | 0;
    break b;
   }
   b = M() | 0;
   Wc(f + 8 | 0);
  }
  Bb(h);
 }
 Nm(a);
 P(b | 0);
 p();
}

function _f(a, b, c, d, e, f) {
 var g = 0, h = 0, i = 0;
 a: {
  if (f & 64) {
   e = f + -64 | 0;
   f = b;
   d = e & 31;
   if ((e & 63) >>> 0 >= 32) {
    e = f << d;
    d = 0;
   } else {
    e = (1 << d) - 1 & f >>> 32 - d | c << d;
    d = f << d;
   }
   b = 0;
   c = 0;
   break a;
  }
  if (!f) {
   break a;
  }
  h = d;
  g = f & 31;
  if ((f & 63) >>> 0 >= 32) {
   i = d << g;
   h = 0;
  } else {
   i = (1 << g) - 1 & h >>> 32 - g | e << g;
   h = h << g;
  }
  g = b;
  e = 64 - f | 0;
  d = e & 31;
  if ((e & 63) >>> 0 >= 32) {
   e = 0;
   d = c >>> d | 0;
  } else {
   e = c >>> d | 0;
   d = ((1 << d) - 1 & c) << 32 - d | g >>> d;
  }
  d = h | d;
  e = e | i;
  h = b;
  g = f & 31;
  if ((f & 63) >>> 0 >= 32) {
   i = b << g;
   b = 0;
  } else {
   i = (1 << g) - 1 & h >>> 32 - g | c << g;
   b = h << g;
  }
  c = i;
 }
 v[a >> 2] = b;
 v[a + 4 >> 2] = c;
 v[a + 8 >> 2] = d;
 v[a + 12 >> 2] = e;
}

function Nz(a, b, c) {
 var d = 0, e = 0;
 d = (c | 0) != 0;
 a: {
  b: {
   c: {
    if (!(a & 3) | !c) {
     break c;
    }
    e = b & 255;
    while (1) {
     if ((e | 0) == w[a | 0]) {
      break b;
     }
     c = c - 1 | 0;
     d = (c | 0) != 0;
     a = a + 1 | 0;
     if (!(a & 3)) {
      break c;
     }
     if (c) {
      continue;
     }
     break;
    }
   }
   if (!d) {
    break a;
   }
   d = b & 255;
   if (!((d | 0) == w[a | 0] | c >>> 0 < 4)) {
    d = B(d, 16843009);
    while (1) {
     e = d ^ v[a >> 2];
     if ((e ^ -1) & e - 16843009 & -2139062144) {
      break b;
     }
     a = a + 4 | 0;
     c = c - 4 | 0;
     if (c >>> 0 > 3) {
      continue;
     }
     break;
    }
   }
   if (!c) {
    break a;
   }
  }
  b = b & 255;
  while (1) {
   if ((b | 0) == w[a | 0]) {
    return a;
   }
   a = a + 1 | 0;
   c = c - 1 | 0;
   if (c) {
    continue;
   }
   break;
  }
 }
 return 0;
}

function FQ(a, b) {
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0;
 f = eb - 16 | 0;
 eb = f;
 c = ub(f + 12 | 0, v[a + 4 >> 2]);
 d = ub(f + 8 | 0, v[a >> 2]);
 h = v[ub(f + 4 | 0, v[b + 4 >> 2]) >> 2];
 g = eb - 16 | 0;
 eb = g;
 i = g + 8 | 0;
 e = eb - 32 | 0;
 eb = e;
 ed(e + 24 | 0, v[c >> 2], v[d >> 2]);
 j = e + 16 | 0;
 d = v[e + 24 >> 2];
 k = v[e + 28 >> 2];
 c = eb - 16 | 0;
 eb = c;
 v[c + 8 >> 2] = h;
 v[c + 12 >> 2] = d;
 while (1) {
  if (Ed(d, k)) {
   d = DQ(d);
   yc(DQ(v[c + 8 >> 2]), d, 2048);
   d = CQ(c + 12 | 0);
   CQ(c + 8 | 0);
   d = v[d >> 2];
   continue;
  }
  break;
 }
 pc(j, d, c + 8 | 0);
 eb = c + 16 | 0;
 c = v[e + 16 >> 2];
 v[e + 12 >> 2] = v[e + 20 >> 2];
 pc(i, c, e + 12 | 0);
 eb = e + 32 | 0;
 eb = g + 16 | 0;
 v[b + 4 >> 2] = v[g + 12 >> 2];
 Sb(a, b + 4 | 0);
 Sb(a + 4 | 0, b + 8 | 0);
 Sb(zb(a), mc(b));
 v[b >> 2] = v[b + 4 >> 2];
 eb = f + 16 | 0;
}

function m$(a, b) {
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0;
 f = eb - 16 | 0;
 eb = f;
 c = ub(f + 12 | 0, v[a + 4 >> 2]);
 d = ub(f + 8 | 0, v[a >> 2]);
 h = v[ub(f + 4 | 0, v[b + 4 >> 2]) >> 2];
 g = eb - 16 | 0;
 eb = g;
 i = g + 8 | 0;
 e = eb - 32 | 0;
 eb = e;
 ed(e + 24 | 0, v[c >> 2], v[d >> 2]);
 j = e + 16 | 0;
 d = v[e + 24 >> 2];
 k = v[e + 28 >> 2];
 c = eb - 16 | 0;
 eb = c;
 v[c + 8 >> 2] = h;
 v[c + 12 >> 2] = d;
 while (1) {
  if (Ed(d, k)) {
   d = hw(d);
   yc(hw(v[c + 8 >> 2]), d, 36);
   d = j$(c + 12 | 0);
   j$(c + 8 | 0);
   d = v[d >> 2];
   continue;
  }
  break;
 }
 pc(j, d, c + 8 | 0);
 eb = c + 16 | 0;
 c = v[e + 16 >> 2];
 v[e + 12 >> 2] = v[e + 20 >> 2];
 pc(i, c, e + 12 | 0);
 eb = e + 32 | 0;
 eb = g + 16 | 0;
 v[b + 4 >> 2] = v[g + 12 >> 2];
 Sb(a, b + 4 | 0);
 Sb(a + 4 | 0, b + 8 | 0);
 Sb(zb(a), mc(b));
 v[b >> 2] = v[b + 4 >> 2];
 eb = f + 16 | 0;
}

function aG(a) {
 var b = 0, c = 0, d = 0;
 b = eb - 16 | 0;
 eb = b;
 v[b + 4 >> 2] = B(w[a + 12 | 0] | w[a + 13 | 0] << 8 | (w[a + 14 | 0] << 16 | w[a + 15 | 0] << 24), 5) + (w[a + 16 | 0] | w[a + 17 | 0] << 8 | (w[a + 18 | 0] << 16 | w[a + 19 | 0] << 24));
 v[b + 8 >> 2] = (w[a + 24 | 0] | w[a + 25 | 0] << 8 | (w[a + 26 | 0] << 16 | w[a + 27 | 0] << 24)) + ((w[a + 20 | 0] | w[a + 21 | 0] << 8 | (w[a + 22 | 0] << 16 | w[a + 23 | 0] << 24)) << 3);
 v[b + 12 >> 2] = (w[a + 32 | 0] | w[a + 33 | 0] << 8 | (w[a + 34 | 0] << 16 | w[a + 35 | 0] << 24)) + ((w[a + 28 | 0] | w[a + 29 | 0] << 8 | (w[a + 30 | 0] << 16 | w[a + 31 | 0] << 24)) << 2);
 a = b + 4 | 0;
 d = xb(a, 3);
 a: {
  if ((a | 0) == (d | 0)) {
   break a;
  }
  c = a;
  while (1) {
   c = c + 4 | 0;
   if ((d | 0) == (c | 0)) {
    break a;
   }
   a = qn(v[a >> 2], v[c >> 2]) ? c : a;
   continue;
  }
 }
 eb = b + 16 | 0;
 return v[a >> 2] - 36 | 0;
}

function Ym(a, b, c, d) {
 var e = 0;
 a: {
  e = a + 1074312 | 0;
  if (Nb(e, 84)) {
   break a;
  }
  b: {
   if (w[a + 480209 | 0] & 64) {
    break b;
   }
   if ((d | 0) != 8) {
    if (!Nb(e, 10)) {
     break b;
    }
   }
   v[b + 88 >> 2] = v[b + 88 >> 2] & -257;
  }
  c: {
   d: {
    e: {
     switch (d - 4 | 0) {
     case 0:
      c = ((c << 8 | 8) >>> 0) / 15 | 0;
      break d;

     case 2:
      c = (c >>> 0 >= 64 ? 64 : c) << 2;
      break d;

     default:
      break e;
     }
    }
    if (!(v[a + 480180 >> 2] & 2107410)) {
     break d;
    }
    if (c >>> 0 <= 128) {
     c = c << 1;
     break d;
    }
    if ((c | 0) != 164) {
     break c;
    }
    v[b + 88 >> 2] = v[b + 88 >> 2] | 256;
    c = 128;
   }
   v[b + 692 >> 2] = c;
  }
  u[b + 784 >> 1] = 0;
  v[b + 88 >> 2] = v[b + 88 >> 2] | 2097152;
  if (!Nb(e, 10)) {
   break a;
  }
  t[b + 831 | 0] = 0;
  u[b + 778 >> 1] = 0;
 }
}

function wK(a, b, c, d) {
 var e = 0, f = 0, g = 0, h = 0;
 e = eb - 16 | 0;
 eb = e;
 a: {
  if ((a | 0) != (b | 0)) {
   b: {
    c: {
     f = w[a | 0];
     if ((f | 0) != 45) {
      break c;
     }
     a = a + 1 | 0;
     if ((b | 0) != (a | 0)) {
      break c;
     }
     break b;
    }
    h = v[31476];
    v[31476] = 0;
    Nd();
    a = Iy(a, e + 12 | 0, d);
    d = gb;
    d: {
     g = v[31476];
     if (g) {
      if (v[e + 12 >> 2] != (b | 0)) {
       break b;
      }
      if ((g | 0) != 68) {
       break d;
      }
      v[c >> 2] = 4;
      a = -1;
      b = -1;
      break a;
     }
     v[31476] = h;
     if (v[e + 12 >> 2] == (b | 0)) {
      break d;
     }
     break b;
    }
    b = a;
    c = (f | 0) == 45;
    a = c ? 0 - b | 0 : b;
    b = c ? 0 - (d + ((b | 0) != 0) | 0) | 0 : d;
    break a;
   }
  }
  v[c >> 2] = 4;
  a = 0;
  b = 0;
 }
 eb = e + 16 | 0;
 gb = b;
 return a;
}

function ina(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
 b = eb - 16 | 0;
 eb = b;
 j = v[a + 16 >> 2];
 h = jg(1, 2);
 e = gb;
 k = e;
 Ob(a, h, e);
 f = v[a + 40 >> 2];
 g = v[a + 36 >> 2];
 e = v[a + 4 >> 2];
 v[b + 8 >> 2] = v[a >> 2];
 v[b + 12 >> 2] = e;
 l = v[a + 32 >> 2];
 m = v[a + 28 >> 2];
 e = v[a + 8 >> 2];
 n = v[a + 12 >> 2];
 while (1) {
  if (d) {
   i = u[(v[b + 12 >> 2] << 1) + j >> 1];
   g = g + m | 0;
   v[c >> 2] = v[c >> 2] + B(i, g >> 12);
   f = f + l | 0;
   v[c + 4 >> 2] = v[c + 4 >> 2] + B(f >> 12, i);
   Ob(b + 8 | 0, e, n);
   c = c + 8 | 0;
   d = d - 1 | 0;
   continue;
  }
  break;
 }
 c = v[b + 12 >> 2];
 v[a >> 2] = v[b + 8 >> 2];
 v[a + 4 >> 2] = c;
 v[a + 40 >> 2] = f;
 v[a + 20 >> 2] = g >> 12;
 v[a + 36 >> 2] = g;
 v[a + 24 >> 2] = f >> 12;
 Hg(a, h, k);
 eb = b + 16 | 0;
}

function hC(a, b) {
 var c = 0, d = 0, e = 0, f = 0, g = 0;
 d = eb - 16 | 0;
 eb = d;
 c = v[a >> 2];
 a: {
  if (!lc(c, v[a + 4 >> 2])) {
   u[c >> 1] = 0;
   Nf(c + 2 | 0, b);
   f = d, g = Dk(vb(v[a >> 2]), 1), v[f + 12 >> 2] = g;
   while (1) {
    e = vb(v[a + 4 >> 2]);
    c = v[d + 12 >> 2];
    if (Hb(c, e)) {
     f = c, g = x[qe(c, Dk(c, -1)) >> 1], u[f >> 1] = g;
     Nf(c + 2 | 0, b);
     gW(d + 12 | 0);
     continue;
    } else {
     Nf(a + 14 | 0, Rd(v[a >> 2], v[a + 4 >> 2]) - 1 & 255);
     Nf(a + 13 | 0, w[a + 14 | 0]);
     Nf(a + 16 | 0, Rd(v[a >> 2], v[a + 4 >> 2]) - 1 & 255);
     Nf(a + 15 | 0, w[a + 16 | 0]);
     if (w[a + 17 | 0] == 255) {
      break a;
     }
     Nf(a + 17 | 0, Rd(v[a >> 2], v[a + 4 >> 2]) - 1 & 255);
     break a;
    }
   }
  }
  t[a + 17 | 0] = 255;
  t[a + 13 | 0] = 0;
  t[a + 14 | 0] = 0;
  t[a + 15 | 0] = 0;
  t[a + 16 | 0] = 0;
 }
 eb = d + 16 | 0;
}

function jna(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0;
 b = eb - 16 | 0;
 eb = b;
 j = v[a + 16 >> 2];
 h = jg(1, 2);
 e = gb;
 k = e;
 Ob(a, h, e);
 f = v[a + 40 >> 2];
 g = v[a + 36 >> 2];
 e = v[a + 4 >> 2];
 v[b + 8 >> 2] = v[a >> 2];
 v[b + 12 >> 2] = e;
 l = v[a + 32 >> 2];
 m = v[a + 28 >> 2];
 e = v[a + 8 >> 2];
 n = v[a + 12 >> 2];
 while (1) {
  if (d) {
   i = t[v[b + 12 >> 2] + j | 0] << 8;
   g = g + m | 0;
   v[c >> 2] = v[c >> 2] + B(i, g >> 12);
   f = f + l | 0;
   v[c + 4 >> 2] = v[c + 4 >> 2] + B(f >> 12, i);
   Ob(b + 8 | 0, e, n);
   c = c + 8 | 0;
   d = d - 1 | 0;
   continue;
  }
  break;
 }
 c = v[b + 12 >> 2];
 v[a >> 2] = v[b + 8 >> 2];
 v[a + 4 >> 2] = c;
 v[a + 40 >> 2] = f;
 v[a + 20 >> 2] = g >> 12;
 v[a + 36 >> 2] = g;
 v[a + 24 >> 2] = f >> 12;
 Hg(a, h, k);
 eb = b + 16 | 0;
}

function qs(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0;
 d = eb - 16 | 0;
 eb = d;
 a = Eb(a);
 a: {
  b: {
   c: {
    switch (b - 1 | 0) {
    default:
     v[31601] = 0;
     b = O(1, d + 4 | 0, 15888) | 0;
     c = v[31601];
     v[31601] = 0;
     if ((c | 0) == 1) {
      break a;
     }
     break b;

    case 0:
     v[31601] = 0;
     b = O(1, d + 4 | 0, 15913) | 0;
     c = v[31601];
     v[31601] = 0;
     if ((c | 0) != 1) {
      break b;
     }
     break a;

    case 1:
     v[31601] = 0;
     b = O(1, d + 4 | 0, 15861) | 0;
     c = v[31601];
     v[31601] = 0;
     if ((c | 0) != 1) {
      break b;
     }
     break a;

    case 2:
     break c;
    }
   }
   v[31601] = 0;
   b = O(1, d + 4 | 0, 15835) | 0;
   c = v[31601];
   v[31601] = 0;
   if ((c | 0) == 1) {
    break a;
   }
  }
  yb(a, b);
  sb(b);
  eb = d + 16 | 0;
  return;
 }
 b = M() | 0;
 sb(a);
 P(b | 0);
 p();
}

function Ija(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0;
 d = eb - 48 | 0;
 eb = d;
 c = d + 28 | 0;
 Tj(c, b, 1819307379);
 jd(a + 40 | 0, c);
 tb(c);
 Tj(c, b, 1953721961);
 jd(a + 60 | 0, c);
 tb(c);
 Tj(c, b, 543520099);
 jd(a + 120 | 0, c);
 tb(c);
 Tj(c, b, 1414744396);
 v[31601] = 0;
 e = O(412, c | 0, 13830) | 0;
 f = v[31601];
 v[31601] = 0;
 a: {
  if ((f | 0) != 1) {
   b: {
    if (e) {
     v[31601] = 0;
     e = d + 8 | 0;
     R(806, e | 0, c | 0, 2);
     c = v[31601];
     v[31601] = 0;
     if ((c | 0) == 1) {
      break b;
     }
     Dv(a + 140 | 0, e);
     je(e);
    }
    v[31601] = 0;
    R(807, d + 8 | 0, b | 0, 1634890872);
    b = v[31601];
    v[31601] = 0;
    if ((b | 0) != 1) {
     break a;
    }
   }
  }
  a = M() | 0;
  tb(d + 28 | 0);
  P(a | 0);
  p();
 }
 b = a + 80 | 0;
 a = d + 8 | 0;
 jd(b, a);
 tb(a);
 tb(d + 28 | 0);
 eb = d + 48 | 0;
}

function px(a, b, c, d) {
 var e = 0, f = 0, g = 0, h = 0;
 e = eb - 48 | 0;
 eb = e;
 f = v[b >> 2];
 g = hb[v[v[f >> 2] + 36 >> 2]](f, c, d) | 0;
 a: {
  if (!g) {
   Xh(a);
   break a;
  }
  om(e + 32 | 0, v[b >> 2], v[b + 4 >> 2]);
  b = v[e + 36 >> 2];
  v[e + 16 >> 2] = v[e + 32 >> 2];
  v[e + 20 >> 2] = b;
  b = eb - 16 | 0;
  eb = b;
  d = e + 16 | 0;
  f = om(b + 8 | 0, v[d >> 2], v[d + 4 >> 2]);
  v[31601] = 0;
  h = v[f + 4 >> 2];
  v[b >> 2] = v[f >> 2];
  v[b + 4 >> 2] = h;
  U(166, e + 40 | 0, b | 0, c | 0, g | 0);
  c = v[31601];
  v[31601] = 0;
  b: {
   if ((c | 0) != 1) {
    le(d);
    eb = b + 16 | 0;
    break b;
   }
   a = M() | 0;
   le(d);
   P(a | 0);
   p();
  }
  b = Ld(e + 24 | 0);
  c = v[e + 44 >> 2];
  v[e + 8 >> 2] = v[e + 40 >> 2];
  v[e + 12 >> 2] = c;
  c = v[b + 4 >> 2];
  v[e >> 2] = v[b >> 2];
  v[e + 4 >> 2] = c;
  Kp(a, e + 8 | 0, e);
 }
 eb = e + 48 | 0;
}

function cV(a, b) {
 var c = 0, d = 0;
 t[a + 15 | 0] = 0;
 t[a + 16 | 0] = 0;
 t[a + 17 | 0] = 0;
 t[a + 18 | 0] = 0;
 t[a + 19 | 0] = 0;
 t[a + 20 | 0] = 0;
 t[a + 21 | 0] = 0;
 t[a + 22 | 0] = 0;
 t[a + 14 | 0] = 5;
 u[a + 12 >> 1] = 0;
 v[a + 8 >> 2] = 128;
 v[a >> 2] = 256;
 v[a + 4 >> 2] = 64;
 v[a + 28 >> 2] = 0;
 t[a + 27 | 0] = 60;
 v[a + 40 >> 2] = 0;
 v[a + 44 >> 2] = 0;
 t[a + 33 | 0] = 2;
 t[a + 34 | 0] = 0;
 t[a + 35 | 0] = 0;
 t[a + 36 | 0] = 2;
 t[a + 23 | 0] = 0;
 t[a + 24 | 0] = 0;
 t[a + 25 | 0] = 255;
 t[a + 26 | 0] = 0;
 t[a + 32 | 0] = 0;
 gC(a + 48 | 0);
 gC(a + 68 | 0);
 gC(a + 88 | 0);
 fv(a + 492 | 0);
 fv(a + 524 | 0);
 bk(a, 0, 0);
 ak(a, 0, 0);
 v[a + 40 >> 2] = 0;
 v[a + 44 >> 2] = 0;
 Ov(a, b);
 b = a + 108 | 0;
 d = RC(b);
 c = 1;
 while (1) {
  if ((b | 0) != (d | 0)) {
   t[b | 0] = c;
   c = c + 1 | 0;
   b = b + 1 | 0;
   continue;
  }
  break;
 }
 return a;
}

function Tfa(a) {
 a = a | 0;
 var b = 0, c = 0, d = 0;
 b = eb - 32 | 0;
 eb = b;
 a: {
  b: {
   if (!a) {
    a = Bg(22256);
    break b;
   }
   v[31601] = 0;
   c = O(36, b + 8 | 0, a | 0) | 0;
   a = v[31601];
   v[31601] = 0;
   c: {
    d: {
     if ((a | 0) != 1) {
      v[31601] = 0;
      d = b + 20 | 0;
      N(981, d | 0, c | 0);
      a = v[31601];
      v[31601] = 0;
      if ((a | 0) == 1) {
       break d;
      }
      a = Bg(Jb(d));
      sb(d);
      sb(c);
      break b;
     }
     a = S(0) | 0;
     break c;
    }
    a = S(0) | 0;
    sb(c);
   }
   X(a | 0) | 0;
   a = 0;
   v[31601] = 0;
   U(982, 11015, 0, 0, 0);
   c = v[31601];
   v[31601] = 0;
   if ((c | 0) == 1) {
    break a;
   }
   Y();
  }
  eb = b + 32 | 0;
  return a | 0;
 }
 a = M() | 0;
 v[31601] = 0;
 W(26);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  P(a | 0);
  p();
 }
 S(0) | 0;
 Rb();
 p();
}

function xK(a, b, c, d) {
 var e = 0, f = 0, g = 0, h = 0;
 e = eb - 16 | 0;
 eb = e;
 a: {
  b: {
   if ((a | 0) != (b | 0)) {
    c: {
     d: {
      f = w[a | 0];
      if ((f | 0) != 45) {
       break d;
      }
      a = a + 1 | 0;
      if ((b | 0) != (a | 0)) {
       break d;
      }
      break c;
     }
     h = v[31476];
     v[31476] = 0;
     Nd();
     a = Iy(a, e + 12 | 0, d);
     d = gb;
     g = v[31476];
     e: {
      if (g) {
       if (v[e + 12 >> 2] != (b | 0)) {
        break c;
       }
       if ((g | 0) == 68 | d) {
        break e;
       }
       break b;
      }
      v[31476] = h;
      if (v[e + 12 >> 2] != (b | 0)) {
       break c;
      }
      if (!d) {
       break b;
      }
     }
     v[c >> 2] = 4;
     a = -1;
     break a;
    }
   }
   v[c >> 2] = 4;
   a = 0;
   break a;
  }
  a = (f | 0) == 45 ? 0 - a | 0 : a;
 }
 eb = e + 16 | 0;
 return a;
}

function B2(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0;
 d = eb - 32 | 0;
 eb = d;
 a: {
  b: {
   c: {
    d: {
     if (g = zd(v[b + 4 >> 2], w[b + 11 | 0]), h = 1, i = v[b + 12 >> 2], i ? g : h) {
      Eb(a);
      break d;
     }
     c = Cb(v[b + 4 >> 2], w[b + 11 | 0]);
     e = d + 20 | 0;
     f = es(14294);
     Zl(Wg(Wg(Jb(Iz(e, c + f | 0)), Jb(b), c) + c | 0, 14294, f) + f | 0, 1, 0);
     v[31601] = 0;
     c = d + 8 | 0;
     N(126, c | 0, b + 12 | 0);
     b = v[31601];
     v[31601] = 0;
     if ((b | 0) == 1) {
      break c;
     }
     v[31601] = 0;
     R(2, a | 0, e | 0, c | 0);
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) == 1) {
      break b;
     }
     sb(c);
     sb(e);
    }
    eb = d + 32 | 0;
    return;
   }
   b = M() | 0;
   break a;
  }
  b = M() | 0;
  sb(d + 8 | 0);
 }
 sb(d + 20 | 0);
 P(b | 0);
 p();
}

function w3(a, b, c, d, e) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 if (kh(a, v[b + 8 >> 2], e)) {
  Vx(b, c, d);
  return;
 }
 a: {
  if (kh(a, v[b >> 2], e)) {
   if (!(v[b + 16 >> 2] != (c | 0) & v[b + 20 >> 2] != (c | 0))) {
    if ((d | 0) != 1) {
     break a;
    }
    v[b + 32 >> 2] = 1;
    return;
   }
   v[b + 32 >> 2] = d;
   b: {
    if (v[b + 44 >> 2] == 4) {
     break b;
    }
    u[b + 52 >> 1] = 0;
    a = v[a + 8 >> 2];
    hb[v[v[a >> 2] + 20 >> 2]](a, b, c, c, 1, e);
    if (w[b + 53 | 0]) {
     v[b + 44 >> 2] = 3;
     if (!w[b + 52 | 0]) {
      break b;
     }
     break a;
    }
    v[b + 44 >> 2] = 4;
   }
   v[b + 20 >> 2] = c;
   v[b + 40 >> 2] = v[b + 40 >> 2] + 1;
   if (v[b + 36 >> 2] != 1 | v[b + 24 >> 2] != 2) {
    break a;
   }
   t[b + 54 | 0] = 1;
   return;
  }
  a = v[a + 8 >> 2];
  hb[v[v[a >> 2] + 24 >> 2]](a, b, c, d, e);
 }
}

function $O(a) {
 a = a | 0;
 var b = 0, c = 0, d = 0, e = 0;
 c = eb - 32 | 0;
 eb = c;
 e = Mb(a);
 he(c + 24 | 0);
 a = 0;
 b = v[c + 28 >> 2];
 d = v[c + 24 >> 2];
 v[31601] = 0;
 N(176, e | 0, XL(d, b) | 0);
 b = v[31601];
 v[31601] = 0;
 a: {
  if ((b | 0) != 1) {
   b: {
    while (1) {
     b = v[c + 24 >> 2];
     if ((XL(b, v[c + 28 >> 2]) | 0) <= (a | 0)) {
      eb = c + 32 | 0;
      return;
     }
     b = v[b + (a << 3) >> 2];
     v[31601] = 0;
     b = O(36, c + 12 | 0, b | 0) | 0;
     d = v[31601];
     v[31601] = 0;
     if ((d | 0) != 1) {
      v[31601] = 0;
      N(178, e | 0, b | 0);
      d = v[31601];
      v[31601] = 0;
      if ((d | 0) == 1) {
       break b;
      }
      sb(b);
      a = a + 1 | 0;
      continue;
     }
     break;
    }
    a = M() | 0;
    break a;
   }
   a = M() | 0;
   sb(b);
   break a;
  }
  a = M() | 0;
 }
 Sd(e);
 P(a | 0);
 p();
}

function Hra(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0;
 e = v[a >> 2];
 d = Fk(e, v[a + 4 >> 2]);
 if (d >>> 0 < b >>> 0) {
  e = eb - 32 | 0;
  eb = e;
  d = b - d | 0;
  b = v[zb(a) >> 2];
  f = v[a + 4 >> 2];
  a: {
   if (d >>> 0 <= (b - f | 0) / 6 >>> 0) {
    yD(a, d, c);
    break a;
   }
   b = zb(a);
   b = jZ(e + 12 | 0, uD(a, Fk(v[a >> 2], f) + d | 0), Fk(v[a >> 2], v[a + 4 >> 2]), b);
   iZ(b, d, c);
   c = eb - 16 | 0;
   eb = c;
   d = ub(c + 12 | 0, v[a + 4 >> 2]);
   f = ub(c + 8 | 0, v[a >> 2]);
   g = ub(c + 4 | 0, v[b + 4 >> 2]);
   h = b, i = fZ(v[d >> 2], v[f >> 2], v[g >> 2]), v[h + 4 >> 2] = i;
   Sb(a, b + 4 | 0);
   Sb(a + 4 | 0, b + 8 | 0);
   Sb(zb(a), mc(b));
   v[b >> 2] = v[b + 4 >> 2];
   eb = c + 16 | 0;
   hZ(b);
  }
  eb = e + 32 | 0;
  return;
 }
 if (b >>> 0 < d >>> 0) {
  Id(a, e + B(b, 6) | 0);
 }
}

function fZ(a, b, c) {
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0;
 e = eb - 16 | 0;
 eb = e;
 g = e + 8 | 0;
 d = eb - 32 | 0;
 eb = d;
 ed(d + 24 | 0, a, b);
 h = d + 16 | 0;
 b = v[d + 24 >> 2];
 i = v[d + 28 >> 2];
 a = eb - 16 | 0;
 eb = a;
 v[a + 8 >> 2] = c;
 v[a + 12 >> 2] = b;
 while (1) {
  if (Ed(b, i)) {
   b = eZ(b);
   c = eZ(v[a + 8 >> 2]);
   f = w[b + 4 | 0] | w[b + 5 | 0] << 8;
   t[c + 4 | 0] = f;
   t[c + 5 | 0] = f >>> 8;
   b = w[b | 0] | w[b + 1 | 0] << 8 | (w[b + 2 | 0] << 16 | w[b + 3 | 0] << 24);
   t[c | 0] = b;
   t[c + 1 | 0] = b >>> 8;
   t[c + 2 | 0] = b >>> 16;
   t[c + 3 | 0] = b >>> 24;
   b = dZ(a + 12 | 0);
   dZ(a + 8 | 0);
   b = v[b >> 2];
   continue;
  }
  break;
 }
 pc(h, b, a + 8 | 0);
 eb = a + 16 | 0;
 a = v[d + 16 >> 2];
 v[d + 12 >> 2] = v[d + 20 >> 2];
 pc(g, a, d + 12 | 0);
 eb = d + 32 | 0;
 eb = e + 16 | 0;
 return v[e + 12 >> 2];
}

function HM(a) {
 var b = 0, c = 0, d = 0, e = 0, f = 0;
 while (1) {
  d = v[a + 16 >> 2];
  if (d >>> 0 <= e >>> 0) {
   while (1) {
    if (!(y[a + 12 >> 2] <= d >>> 0)) {
     while (1) {
      f = UA(v[a >> 2]);
      e = gb;
      c = v[a + 36 >> 2];
      if ((e | 0) == (c | 0) & y[a + 32 >> 2] <= f >>> 0 | e >>> 0 > c >>> 0) {
       continue;
      }
      break;
     }
     c = b;
     b = v[a + 8 >> 2];
     b = (f & v[a + 48 >> 2]) + (b >>> 0 < 31 ? c << b + 1 : 0) | 0;
     d = d + 1 | 0;
     continue;
    }
    break;
   }
  } else {
   while (1) {
    f = UA(v[a >> 2]);
    d = gb;
    c = v[a + 28 >> 2];
    if ((d | 0) == (c | 0) & y[a + 24 >> 2] <= f >>> 0 | d >>> 0 > c >>> 0) {
     continue;
    }
    break;
   }
   c = b;
   b = v[a + 8 >> 2];
   b = (f & v[a + 40 >> 2]) + (b >>> 0 < 32 ? c << b : 0) | 0;
   e = e + 1 | 0;
   continue;
  }
  break;
 }
 return b;
}

function QO(a) {
 a = a | 0;
 var b = 0, c = 0, d = 0, e = 0, f = 0, g = 0, h = 0;
 b = eb - 16 | 0;
 eb = b;
 a: {
  c = v[a + 36 >> 2];
  d = v[a + 40 >> 2];
  b: {
   if (Hb(c, d)) {
    sc(b + 12 | 0);
    break b;
   }
   vo(b, a);
   v[31601] = 0;
   c = Q(1055, b | 0) | 0;
   d = v[31601];
   v[31601] = 0;
   if ((d | 0) == 1) {
    break a;
   }
   v[b + 12 >> 2] = c;
   nf(b);
   d = v[a + 40 >> 2];
   c = v[a + 36 >> 2];
  }
  c = (f = a + 36 | 0, g = v[b + 12 >> 2], h = Hb(c, d), h ? f : g);
  a = v[a + 8 >> 2];
  c: {
   if ((a | 0) == -1) {
    a = vb(v[c >> 2]);
    v[b >> 2] = a;
    c = vb(v[c + 4 >> 2]);
    while (1) {
     if (!Hb(a, c)) {
      break c;
     }
     e = e + A[a >> 3];
     a = v[gA(b) >> 2];
     continue;
    }
   }
   e = A[vf(v[c >> 2], a) >> 3];
  }
  vl(b + 12 | 0);
  eb = b + 16 | 0;
  return +e;
 }
 a = M() | 0;
 nf(b);
 P(a | 0);
 p();
}

function eka(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0;
 e = eb - 208 | 0;
 eb = e;
 u[a + 480212 >> 1] = 0;
 v[a + 480240 >> 2] = 65536;
 v[a + 480244 >> 2] = 65536;
 iS(a + 946304 | 0);
 f = a + 906300 | 0;
 g = tk(f);
 d = e + 48 | 0;
 Qb(d, 0, 160);
 d = kS(d);
 v[31601] = 0;
 R(859, f | 0, g | 0, d | 0);
 f = v[31601];
 v[31601] = 0;
 a: {
  if ((f | 0) != 1) {
   VA(d);
   d = Ge(e + 28 | 0, b);
   v[31601] = 0;
   f = v[d + 12 >> 2];
   v[e + 16 >> 2] = v[d + 8 >> 2];
   v[e + 20 >> 2] = f;
   v[e + 24 >> 2] = v[d + 16 >> 2];
   f = v[d + 4 >> 2];
   v[e + 8 >> 2] = v[d >> 2];
   v[e + 12 >> 2] = f;
   a = T(860, a | 0, e + 8 | 0, c | 0) | 0;
   c = v[31601];
   v[31601] = 0;
   if ((c | 0) == 1) {
    a = M() | 0;
    break a;
   }
   tb(b);
   eb = e + 208 | 0;
   return a | 0;
  }
  a = M() | 0;
  VA(d);
 }
 tb(b);
 P(a | 0);
 p();
}

function WF(a, b) {
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0;
 e = eb - 16 | 0;
 eb = e;
 f = v[b + 16 >> 2];
 v[a + 4 >> 2] = 0;
 v[a >> 2] = f;
 a: {
  if (!f) {
   break a;
  }
  c = b + 80 | 0;
  d = v[b + 84 >> 2];
  if (d >>> 0 <= 15) {
   d = v[c >> 2];
  } else {
   v[e + 12 >> 2] = d - 16;
   d = v[ad(c, e + 12 | 0) >> 2];
  }
  v[a + 8 >> 2] = d;
  c = v[b + 88 >> 2];
  if (!(c & 2)) {
   break a;
  }
  d = c;
  c = v[b + 104 >> 2];
  b: {
   c: {
    if (!UF(d, c)) {
     d = v[b + 84 >> 2];
     break c;
    }
    d = v[b + 84 >> 2];
    if (v[b + 80 >> 2] != v[c + 12 >> 2]) {
     break c;
    }
    b = 1;
    if (v[c + 16 >> 2] == (d | 0)) {
     break b;
    }
   }
   b = 0;
   if (v[c + 8 >> 2] != (d | 0)) {
    break a;
   }
  }
  g = a, h = B((v[c >> 2] - d | 0) + (b ? 112 : 48) | 0, Xk(x[c + 34 >> 1])) + f | 0, 
  v[g + 4 >> 2] = h;
 }
 eb = e + 16 | 0;
}

function jz(a, b, c) {
 var d = 0, e = 0, f = C(0), g = C(0), h = C(0), i = C(0), j = 0, k = C(0), l = C(0), m = C(0);
 e = eb - 32 | 0;
 eb = e;
 g = z[a + 24 >> 2];
 f = z[a + 12 >> 2];
 h = z[a + 48 >> 2];
 i = z[a + 36 >> 2];
 OL(C(-z[a >> 2]), C(g + f), C(h + i), e + 20 | 0);
 OL(z[a + 60 >> 2], C(h - i), C(g - f), e + 8 | 0);
 z[e + 12 >> 2] = -z[e + 12 >> 2];
 a = 0;
 while (1) {
  if ((a | 0) != 3) {
   d = a << 2;
   j = d + c | 0;
   g = z[j >> 2];
   f = z[d + (e + 20 | 0) >> 2];
   h = z[d + 87392 >> 2];
   i = z[d + 87404 >> 2];
   k = z[d + (e + 8 | 0) >> 2];
   z[j >> 2] = C(f * h) - C(i * k);
   j = b + d | 0;
   l = z[(0 - a << 2) + 87400 >> 2];
   d = 5 - a << 2;
   m = z[d + 87392 >> 2];
   f = C(C(f * i) + C(k * h));
   z[j >> 2] = C(g * l) - C(m * f);
   z[b + d >> 2] = C(g * m) + C(f * l);
   a = a + 1 | 0;
   continue;
  }
  break;
 }
 eb = e + 32 | 0;
}

function asa(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0;
 e = eb - 32 | 0;
 eb = e;
 d = rf(e + 20 | 0, 1, 0);
 a: {
  b: {
   while (1) {
    f = Jb(d);
    kC(e + 12 | 0, f, Cb(v[d + 4 >> 2], w[d + 11 | 0]) + f | 0, x[b >> 1], c);
    if (!v[e + 16 >> 2]) {
     break b;
    }
    f = ji(Cb(v[d + 4 >> 2], w[d + 11 | 0]));
    v[31601] = 0;
    N(45, d | 0, f | 0);
    f = v[31601];
    v[31601] = 0;
    if ((f | 0) != 1) {
     continue;
    }
    break;
   }
   break a;
  }
  b = v[e + 12 >> 2];
  c = Jb(d);
  v[31601] = 0;
  N(46, d | 0, b - c | 0);
  b = v[31601];
  v[31601] = 0;
  c: {
   if ((b | 0) != 1) {
    v[31601] = 0;
    N(47, a | 0, d | 0);
    a = v[31601];
    v[31601] = 0;
    if ((a | 0) != 1) {
     break c;
    }
    break a;
   }
   break a;
  }
  sb(d);
  eb = e + 32 | 0;
  return;
 }
 a = M() | 0;
 sb(d);
 P(a | 0);
 p();
}

function Wpa(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0;
 d = eb + -64 | 0;
 eb = d;
 b = -1;
 a: {
  if (!um(a, 1084)) {
   break a;
  }
  Ul(a, 1080);
  c = d + 60 | 0;
  $X(a, c);
  f = _X(d + 40 | 0);
  b = 0;
  if (!ZX(c, f)) {
   break a;
  }
  Ul(a, 20);
  b = 1;
  while (1) {
   if ((b & 65535) >>> 0 >= 32) {
    b = y[f + 4 >> 2] >= h >>> 0;
   } else {
    c = w[f + 16 | 0];
    e = eb - 16 | 0;
    eb = e;
    b: {
     g = d + 10 | 0;
     if (!YX(a, g) | !c) {
      break b;
     }
     Hv(e + 8 | 0, g);
     c = 0;
     while (1) {
      if (c >>> 0 >= 30) {
       break b;
      }
      i = v[e + 8 >> 2];
      qg(wb(i, c), wb(i, c | 1));
      c = c + 2 | 0;
      continue;
     }
    }
    eb = e + 16 | 0;
    b = b + 1 | 0;
    h = $C(g) + h | 0;
    continue;
   }
   break;
  }
 }
 eb = d - -64 | 0;
 return b | 0;
}

function Mka(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0;
 if (v[a + 4 >> 2] != v[zb(a) >> 2]) {
  d = eb - 16 | 0;
  eb = d;
  c = d + 4 | 0;
  v[c >> 2] = a;
  a = v[a + 4 >> 2];
  v[c + 4 >> 2] = a;
  v[c + 8 >> 2] = a + 7;
  FT(v[c + 4 >> 2], b);
  v[c + 4 >> 2] = v[c + 4 >> 2] + 7;
  hc(c);
  eb = d + 16 | 0;
  return;
 }
 f = eb - 32 | 0;
 eb = f;
 g = zb(a);
 h = f + 12 | 0;
 e = HB(v[a >> 2], v[a + 4 >> 2]) + 1 | 0;
 c = eb - 16 | 0;
 eb = c;
 v[c + 12 >> 2] = e;
 a: {
  d = th(613566756);
  if (e >>> 0 <= d >>> 0) {
   e = IB(a);
   if (e >>> 0 < d >>> 1 >>> 0) {
    v[c + 8 >> 2] = e << 1;
    d = v[ad(c + 8 | 0, c + 12 | 0) >> 2];
   }
   eb = c + 16 | 0;
   break a;
  }
  dd();
  p();
 }
 c = IT(h, d, HB(v[a >> 2], v[a + 4 >> 2]), g);
 FT(v[c + 8 >> 2], b);
 v[c + 8 >> 2] = v[c + 8 >> 2] + 7;
 HT(a, c);
 GT(c);
 eb = f + 32 | 0;
}

function E9(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0;
 e = eb - 32 | 0;
 eb = e;
 d = rf(e + 20 | 0, 1, 0);
 a: {
  b: {
   while (1) {
    f = Jb(d);
    EN(e + 12 | 0, f, Cb(v[d + 4 >> 2], w[d + 11 | 0]) + f | 0, w[b | 0], c);
    if (!v[e + 16 >> 2]) {
     break b;
    }
    f = ji(Cb(v[d + 4 >> 2], w[d + 11 | 0]));
    v[31601] = 0;
    N(45, d | 0, f | 0);
    f = v[31601];
    v[31601] = 0;
    if ((f | 0) != 1) {
     continue;
    }
    break;
   }
   break a;
  }
  b = v[e + 12 >> 2];
  c = Jb(d);
  v[31601] = 0;
  N(46, d | 0, b - c | 0);
  b = v[31601];
  v[31601] = 0;
  c: {
   if ((b | 0) != 1) {
    v[31601] = 0;
    N(303, a | 0, d | 0);
    a = v[31601];
    v[31601] = 0;
    if ((a | 0) != 1) {
     break c;
    }
    break a;
   }
   break a;
  }
  sb(d);
  eb = e + 32 | 0;
  return;
 }
 a = M() | 0;
 sb(d);
 P(a | 0);
 p();
}

function eH(a, b, c, d, e, f) {
 var g = 0, h = 0;
 a: {
  g = eb - 48 | 0;
  eb = g;
  h = g + 12 | 0;
  $n(h, c);
  v[31601] = 0;
  c = g + 24 | 0;
  N(f | 0, c | 0, d | 0);
  d = v[31601];
  v[31601] = 0;
  b: {
   c: {
    d: {
     if ((d | 0) == 1) {
      break d;
     }
     v[31601] = 0;
     c = g + 36 | 0;
     N(91, c | 0, e | 0);
     d = v[31601];
     v[31601] = 0;
     if ((d | 0) == 1) {
      break d;
     }
     wx(g + 4 | 0, h);
     v[31601] = 0;
     U(92, a | 0, b | 0, v[g + 4 >> 2], v[g + 8 >> 2]);
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) == 1) {
      break c;
     }
     Sn(h);
     eb = g + 48 | 0;
     break a;
    }
    a = M() | 0;
    while (1) {
     c = sb(c - 12 | 0);
     if ((c | 0) != (g + 12 | 0)) {
      continue;
     }
     break;
    }
    break b;
   }
   a = M() | 0;
   Sn(g + 12 | 0);
  }
  P(a | 0);
  p();
 }
}

function Tpa(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0;
 b = eb - 608 | 0;
 eb = b;
 c = eb - 16 | 0;
 eb = c;
 d = b + 8 | 0;
 QX(c + 8 | 0, d);
 e = v[c + 12 >> 2];
 pd(c, a, v[c + 8 >> 2], v[c + 12 >> 2]);
 f = v[c + 4 >> 2];
 if ((f | 0) == (e | 0)) {
  hd(a, v[c + 12 >> 2]);
 }
 eb = c + 16 | 0;
 e = (e | 0) == (f | 0);
 if (!e) {
  PX(d);
 }
 c = -1;
 a: {
  if (!e) {
   break a;
  }
  c = 0;
  if (!RX(d)) {
   break a;
  }
  c = -1;
  if (!ih(a, 1024)) {
   break a;
  }
  c = 0;
  e = eb - 1024 | 0;
  eb = e;
  d = eb - 16 | 0;
  eb = d;
  TC(d + 8 | 0, e);
  f = v[d + 12 >> 2];
  pd(d, a, v[d + 8 >> 2], v[d + 12 >> 2]);
  g = v[d + 4 >> 2];
  if ((f | 0) == (g | 0)) {
   hd(a, v[d + 12 >> 2]);
  }
  eb = d + 16 | 0;
  if ((f | 0) == (g | 0)) {
   c = UC(e, 0) >>> 0 < 17;
  }
  eb = e + 1024 | 0;
 }
 eb = b + 608 | 0;
 return c | 0;
}

function c1(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0;
 b = eb - 16 | 0;
 eb = b;
 c = -1;
 d = b + 12 | 0;
 a: {
  if (!eF(a, d)) {
   break a;
  }
  b: {
   if (dF(d)) {
    if (hd(a, 32)) {
     break b;
    }
    break a;
   }
   c = 0;
   if (!cF(b + 12 | 0)) {
    break a;
   }
  }
  e = b + 7 | 0;
  d = bF(w[b + 15 | 0]);
  c = eb - 32 | 0;
  eb = c;
  v[c + 28 >> 2] = d;
  v[c + 8 >> 2] = 5;
  d = v[Gb(c + 28 | 0, c + 8 | 0) >> 2];
  if (!ih(a, d)) {
   d = (hb[v[v[a >> 2] + 24 >> 2]](a) | 0) - v[a + 12 >> 2] | 0;
  }
  f = c + 8 | 0;
  Zj(f, e);
  g = Yb(c + 16 | 0, v[c + 8 >> 2], d);
  pd(c, a, v[g >> 2], v[g + 4 >> 2]);
  Zj(f, e);
  Qb(v[c + 8 >> 2] + d | 0, 0, 5 - d | 0);
  hd(a, v[c + 28 >> 2]);
  eb = c + 32 | 0;
  if (!d) {
   c = -1;
   break a;
  }
  c = aF(b + 7 | 0, w[b + 15 | 0]);
 }
 eb = b + 16 | 0;
 return c | 0;
}

function pt(a, b, c, d, e, f) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 f = f | 0;
 var g = 0, h = 0, i = 0, j = 0;
 i = eb - 16 | 0;
 eb = i;
 a: {
  b: {
   if (!a) {
    break b;
   }
   g = v[e + 12 >> 2];
   h = c - b >> 2;
   if ((h | 0) > 0) {
    if ((np(a, b, h) | 0) != (h | 0)) {
     break b;
    }
   }
   b = d - b >> 2;
   b = (b | 0) < (g | 0) ? g - b | 0 : 0;
   if ((b | 0) > 0) {
    f = Ay(i + 4 | 0, b, f);
    g = Jb(f);
    v[31601] = 0;
    g = T(1270, a | 0, g | 0, b | 0) | 0;
    h = v[31601];
    v[31601] = 0;
    if ((h | 0) == 1) {
     break a;
    }
    Tb(f);
    if ((b | 0) != (g | 0)) {
     break b;
    }
   }
   b = d - c >> 2;
   if ((b | 0) > 0) {
    if ((np(a, c, b) | 0) != (b | 0)) {
     break b;
    }
   }
   uE(e);
   j = a;
  }
  eb = i + 16 | 0;
  return j | 0;
 }
 a = M() | 0;
 Tb(f);
 P(a | 0);
 p();
}

function hN(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = +c;
 var d = 0, e = 0, f = 0;
 d = eb - 32 | 0;
 eb = d;
 A[d + 24 >> 3] = c;
 a: {
  b: {
   c: {
    if (b >>> 0 >= 256) {
     b = cc(8);
     v[31601] = 0;
     d = O(36, d + 8 | 0, 10735) | 0;
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) == 1) {
      break c;
     }
     rc(b, d);
     v[31601] = 0;
     R(97, b | 0, 48396, 999);
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) != 1) {
      break a;
     }
     a = M() | 0;
     sb(d);
     break b;
    }
    a = v[a + 32 >> 2];
    v[d + 8 >> 2] = 0;
    v[d + 12 >> 2] = -1074790400;
    v[d >> 2] = 0;
    v[d + 4 >> 2] = 1072693248;
    e = (B(b, 872) + a | 0) + 1075684 | 0, f = Ri(A[Xg(d + 24 | 0, d + 8 | 0, d) >> 3] * 128 + 128), 
    v[e >> 2] = f;
    eb = d + 32 | 0;
    return;
   }
   a = M() | 0;
   jc(b);
  }
  P(a | 0);
 }
 p();
}

function Hma(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0;
 b = eb - 16 | 0;
 eb = b;
 g = v[a + 24 >> 2];
 h = v[a + 20 >> 2];
 i = v[a + 16 >> 2];
 e = v[a + 4 >> 2];
 v[b + 8 >> 2] = v[a >> 2];
 v[b + 12 >> 2] = e;
 j = v[a + 8 >> 2];
 k = v[a + 12 >> 2];
 while (1) {
  if (d) {
   e = v[b + 8 >> 2];
   f = (v[b + 12 >> 2] << 1) + i | 0;
   e = e >>> 21 & 2040;
   e = (((B(u[f >> 1], u[e + 38050 >> 1]) + B(u[f - 2 >> 1], u[e + 38048 >> 1]) | 0) + B(u[f + 2 >> 1], u[e + 38052 >> 1]) | 0) + B(u[f + 4 >> 1], u[e + 38054 >> 1]) | 0) / 16384 | 0;
   v[c >> 2] = v[c >> 2] + B(e, h);
   v[c + 4 >> 2] = v[c + 4 >> 2] + B(e, g);
   Ob(b + 8 | 0, j, k);
   c = c + 8 | 0;
   d = d - 1 | 0;
   continue;
  }
  break;
 }
 c = v[b + 12 >> 2];
 v[a >> 2] = v[b + 8 >> 2];
 v[a + 4 >> 2] = c;
 eb = b + 16 | 0;
}

function ER(a, b, c, d) {
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0;
 a: {
  if ((c | 0) < 2) {
   break a;
  }
  i = c - 2 >>> 1 | 0;
  e = d - a | 0;
  if ((i | 0) < e >> 1) {
   break a;
  }
  g = e + 1 | 0;
  f = (g << 1) + a | 0;
  e = e + 2 | 0;
  if ((e | 0) < (c | 0)) {
   h = e;
   e = Cl(b, x[f >> 1], x[f + 2 >> 1]);
   g = e ? h : g;
   f = e ? f + 2 | 0 : f;
  }
  if (Cl(b, x[f >> 1], x[d >> 1])) {
   break a;
  }
  j = x[d >> 1];
  while (1) {
   b: {
    e = d;
    d = f;
    u[e >> 1] = x[f >> 1];
    if ((g | 0) > (i | 0)) {
     break b;
    }
    e = g << 1;
    g = e | 1;
    f = (g << 1) + a | 0;
    e = e + 2 | 0;
    if ((e | 0) < (c | 0)) {
     h = e;
     e = Cl(b, x[f >> 1], x[f + 2 >> 1]);
     g = e ? h : g;
     f = e ? f + 2 | 0 : f;
    }
    if (!Cl(b, x[f >> 1], j)) {
     continue;
    }
   }
   break;
  }
  u[d >> 1] = j;
 }
}

function vQ(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = C(c);
 var d = 0, e = 0, f = 0;
 $z(a);
 c = Od(c, C(0));
 a: {
  switch (b | 0) {
  case 0:
   z[a + 4220 >> 2] = c;
   return;

  case 1:
   z[a + 4224 >> 2] = c;
   return;

  case 2:
   z[a + 4228 >> 2] = c;
   su(a);
   return;

  case 3:
   t[a + 4240 | 0] = c >= C(.5);
   su(a);
   return;

  case 4:
   b = eb - 16 | 0;
   eb = b;
   e = b, f = Jl(C(c * C(32))), v[e + 12 >> 2] = f;
   v[b + 8 >> 2] = 0;
   v[b + 4 >> 2] = 5;
   d = Yj(b + 12 | 0, b + 8 | 0, b + 4 | 0);
   eb = b + 16 | 0;
   v[a + 4232 >> 2] = v[d >> 2];
   return;

  case 5:
   t[a + 4241 | 0] = c >= C(.5);
   return;

  case 6:
   t[a + 4242 | 0] = c >= C(.5);
   return;

  case 7:
   t[a + 4244 | 0] = c >= C(.5);
   return;

  case 8:
   if (c == C(0)) {
    Zz(a);
   }
   A[a + 4256 >> 3] = c;
   break;

  default:
   break a;
  }
 }
}

function Ota(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0;
 d = eb - 16 | 0;
 eb = d;
 a: {
  g = v[c + 12 >> 2];
  if (!g) {
   break a;
  }
  e = ig(d + 4 | 0, c + 16 | 0);
  f = Zc(v[b + 4 >> 2], w[b + 11 | 0]);
  h = f - 1 | 0;
  c = 0;
  while (1) {
   if ((c | 0) == (f | 0)) {
    sb(e);
    break a;
   }
   b: {
    c: {
     if (!c | (c >>> 0) % (g >>> 0)) {
      break c;
     }
     if ((c | 0) == (h | 0)) {
      if (w[dc(b, 0) | 0] == 43) {
       break c;
      }
      if (w[dc(b, 0) | 0] == 45) {
       break c;
      }
     }
     v[31601] = 0;
     T(304, b | 0, f - c | 0, e | 0) | 0;
     i = v[31601];
     v[31601] = 0;
     if ((i | 0) == 1) {
      break b;
     }
    }
    c = c + 1 | 0;
    continue;
   }
   break;
  }
  a = M() | 0;
  sb(e);
  P(a | 0);
  p();
 }
 Uc(a, b);
 eb = d + 16 | 0;
}

function Ina(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0;
 d = eb - 16 | 0;
 eb = d;
 a: {
  g = v[c + 12 >> 2];
  if (!g) {
   break a;
  }
  e = tm(d + 4 | 0, c + 16 | 0);
  f = Zc(v[b + 4 >> 2], w[b + 11 | 0]);
  h = f - 1 | 0;
  c = 0;
  while (1) {
   if ((c | 0) == (f | 0)) {
    sb(e);
    break a;
   }
   b: {
    c: {
     if (!c | (c >>> 0) % (g >>> 0)) {
      break c;
     }
     if ((c | 0) == (h | 0)) {
      if (w[dc(b, 0) | 0] == 43) {
       break c;
      }
      if (w[dc(b, 0) | 0] == 45) {
       break c;
      }
     }
     v[31601] = 0;
     T(48, b | 0, f - c | 0, e | 0) | 0;
     i = v[31601];
     v[31601] = 0;
     if ((i | 0) == 1) {
      break b;
     }
    }
    c = c + 1 | 0;
    continue;
   }
   break;
  }
  a = M() | 0;
  sb(e);
  P(a | 0);
  p();
 }
 Uc(a, b);
 eb = d + 16 | 0;
}

function tw(a, b, c, d, e, f) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 f = f | 0;
 var g = 0, h = 0, i = 0, j = 0;
 i = eb - 16 | 0;
 eb = i;
 a: {
  b: {
   if (!a) {
    break b;
   }
   g = v[e + 12 >> 2];
   h = c - b | 0;
   if ((h | 0) > 0) {
    if ((np(a, b, h) | 0) != (h | 0)) {
     break b;
    }
   }
   b = d - b | 0;
   b = (b | 0) < (g | 0) ? g - b | 0 : 0;
   if ((b | 0) > 0) {
    f = rf(i + 4 | 0, b, f);
    g = Jb(f);
    v[31601] = 0;
    g = T(32, a | 0, g | 0, b | 0) | 0;
    h = v[31601];
    v[31601] = 0;
    if ((h | 0) == 1) {
     break a;
    }
    sb(f);
    if ((b | 0) != (g | 0)) {
     break b;
    }
   }
   b = d - c | 0;
   if ((b | 0) > 0) {
    if ((np(a, c, b) | 0) != (b | 0)) {
     break b;
    }
   }
   uE(e);
   j = a;
  }
  eb = i + 16 | 0;
  return j | 0;
 }
 a = M() | 0;
 sb(f);
 P(a | 0);
 p();
}

function Yu(a, b, c) {
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0;
 i = OB(v[a + 24 >> 2], w[a + 32 | 0]);
 g = Gj(i);
 j = 65535;
 a: {
  while (1) {
   if ((d | 0) == (g | 0)) {
    d = g;
    a = -1;
    break a;
   }
   b: {
    c: {
     if (!Vi(i, d & 65535)) {
      break c;
     }
     e = v[a >> 2];
     if (Td(e, v[a + 4 >> 2]) >>> 0 <= d >>> 0) {
      break b;
     }
     f = 0;
     h = Ud(e, d);
     while (1) {
      d: {
       e = v[h + 4 >> 2];
       if (e >>> 0 > f >>> 0) {
        if (!FC(v[h >> 2], f)) {
         break d;
        }
        e = v[h + 4 >> 2];
       }
       if ((f | 0) == (e | 0)) {
        break b;
       }
       break c;
      }
      f = f + 1 | 0;
      continue;
     }
    }
    d = d + 1 | 0;
    continue;
   }
   break;
  }
  j = d;
  a = 0;
 }
 u[b >> 1] = j;
 v[c >> 2] = a;
 return d >>> 0 < g >>> 0;
}

function zW(a) {
 var b = 0, c = 0;
 a: {
  if ((w[a + 60 | 0] | w[a + 61 | 0] << 8 | (w[a + 62 | 0] << 16 | w[a + 63 | 0] << 24)) != 1297236819) {
   break a;
  }
  b = w[a + 28 | 0] | w[a + 29 | 0] << 8;
  b: {
   if (b >>> 0 <= 63) {
    if ((b | 0) == 26) {
     break b;
    }
    break a;
   }
   if (b >>> 0 > 2112) {
    break a;
   }
  }
  b = w[a + 42 | 0];
  if (b >>> 0 > 64 & (b | 0) != 88 | (w[a + 48 | 0] | w[a + 49 | 0] << 8) >>> 0 > 64 | (w[a + 50 | 0] | w[a + 51 | 0] << 8) >>> 0 > 96) {
   break a;
  }
  b = w[a + 52 | 0] | w[a + 53 | 0] << 8;
  if (b >>> 0 > 129 & (b | 0) != 257 | (w[a + 30 | 0] | w[a + 31 | 0] << 8) | (w[a + 38 | 0] | w[a + 39 | 0] << 8 | (w[a + 40 | 0] << 16 | w[a + 41 | 0] << 24) | (w[a + 44 | 0] | w[a + 45 | 0] << 8 | (w[a + 46 | 0] << 16 | w[a + 47 | 0] << 24)) != 1)) {
   break a;
  }
  c = CW(a + 20 | 0);
 }
 return c;
}

function Ima(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0;
 b = eb - 16 | 0;
 eb = b;
 g = v[a + 24 >> 2];
 h = v[a + 20 >> 2];
 i = v[a + 16 >> 2];
 e = v[a + 4 >> 2];
 v[b + 8 >> 2] = v[a >> 2];
 v[b + 12 >> 2] = e;
 j = v[a + 8 >> 2];
 k = v[a + 12 >> 2];
 while (1) {
  if (d) {
   e = v[b + 8 >> 2];
   f = v[b + 12 >> 2] + i | 0;
   e = e >>> 21 & 2040;
   e = (((B(t[f | 0], u[e + 38050 >> 1]) + B(t[f - 1 | 0], u[e + 38048 >> 1]) | 0) + B(t[f + 1 | 0], u[e + 38052 >> 1]) | 0) + B(t[f + 2 | 0], u[e + 38054 >> 1]) << 8) / 16384 | 0;
   v[c >> 2] = v[c >> 2] + B(e, h);
   v[c + 4 >> 2] = v[c + 4 >> 2] + B(e, g);
   Ob(b + 8 | 0, j, k);
   c = c + 8 | 0;
   d = d - 1 | 0;
   continue;
  }
  break;
 }
 c = v[b + 12 >> 2];
 v[a >> 2] = v[b + 8 >> 2];
 v[a + 4 >> 2] = c;
 eb = b + 16 | 0;
}

function V0(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0;
 e = eb - 32 | 0;
 eb = e;
 md(b, 0);
 f = e + 8 | 0;
 ck(f, 1, a + 33 | 0);
 d = e + 20 | 0;
 Bc(d, f);
 Ae(b + 43 | 0, d);
 sb(d);
 g = w[a + 50 | 0] | w[a + 51 | 0] << 8 | (w[a + 52 | 0] << 16 | w[a + 53 | 0] << 24);
 v[b >> 2] = g;
 v[b + 24 >> 2] = w[a + 54 | 0] | w[a + 55 | 0] << 8;
 t[e + 20 | 0] = w[a + 56 | 0];
 t[e + 8 | 0] = 64;
 h = b, i = w[Pb(d, f) | 0] << 2, u[h + 30 >> 1] = i;
 d = w[a + 57 | 0] | w[a + 58 | 0] << 8 | (w[a + 59 | 0] << 16 | w[a + 60 | 0] << 24);
 v[b + 4 >> 2] = d;
 f = w[a + 61 | 0] | w[a + 62 | 0] << 8 | (w[a + 63 | 0] << 16 | w[a + 64 | 0] << 24);
 c = c ? d ? g : f : f;
 v[b + 8 >> 2] = c;
 if (!(!w[a | 0] | c >>> 0 <= d + 2 >>> 0 | c >>> 0 > g >>> 0)) {
  u[b + 34 >> 1] = x[b + 34 >> 1] | 2;
 }
 eb = e + 32 | 0;
}

function Uv(a) {
 var b = 0, c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0;
 g = eb - 16 | 0;
 eb = g;
 v[g + 12 >> 2] = 0;
 v[g + 8 >> 2] = a;
 h = eb - 16 | 0;
 eb = h;
 c = Yb(h + 8 | 0, v[g + 8 >> 2], v[g + 12 >> 2]);
 f = eb - 16 | 0;
 eb = f;
 b = 122;
 v[f + 12 >> 2] = 122;
 d = v[c + 4 >> 2];
 a: {
  if (!d) {
   d = v[c >> 2];
   break a;
  }
  e = 32 - d | 0;
  v[f + 8 >> 2] = e;
  b = v[c >> 2];
  i = v[b >> 2];
  j = e;
  e = v[Gb(f + 8 | 0, f + 12 | 0) >> 2];
  v[b >> 2] = (-1 << d & -1 >>> j - e ^ -1) & i;
  i = v[f + 12 >> 2];
  d = b + 4 | 0;
  v[c >> 2] = d;
  b = i - e | 0;
 }
 e = d;
 d = b >>> 5 | 0;
 IF(e, d);
 b = b & 31;
 v[f + 12 >> 2] = b;
 if (b) {
  e = c;
  c = v[c >> 2] + (d << 2) | 0;
  v[e >> 2] = c;
  v[c >> 2] = v[c >> 2] & (-1 >>> 32 - b ^ -1);
 }
 eb = f + 16 | 0;
 eb = h + 16 | 0;
 eb = g + 16 | 0;
 return a;
}

function l7(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0;
 g = eb - 16 | 0;
 eb = g;
 e = Cb(v[a + 4 >> 2], w[a + 11 | 0]);
 d = Lc(a);
 f = Oj(b, c);
 a: {
  if (!f) {
   break a;
  }
  b: {
   if (!G_(a, b)) {
    if (d - e >>> 0 < f >>> 0) {
     $m(a, d, (e - d | 0) + f | 0, e, e, 0, 0);
    }
    d = Jb(a) + e | 0;
    while (1) {
     if ((b | 0) == (c | 0)) {
      break b;
     }
     gd(d, w[b | 0]);
     b = b + 1 | 0;
     d = d + 1 | 0;
     continue;
    }
   }
   b = Vl(g + 4 | 0, b, c);
   c = Jb(b);
   e = w[b + 11 | 0];
   d = v[b + 4 >> 2];
   v[31601] = 0;
   T(1281, a | 0, c | 0, Cb(d, e) | 0) | 0;
   c = v[31601];
   v[31601] = 0;
   if ((c | 0) != 1) {
    sb(b);
    break a;
   }
   a = M() | 0;
   sb(b);
   P(a | 0);
   p();
  }
  gd(d, 0);
  kg(a, e + f | 0);
 }
 eb = g + 16 | 0;
 return a | 0;
}

function xX(a) {
 var b = 0, c = 0, d = 0;
 a: {
  if ((w[a | 0] | w[a + 1 | 0] << 8 | (w[a + 2 | 0] << 16 | w[a + 3 | 0] << 24)) != 1196314451) {
   break a;
  }
  b = w[a + 4 | 0] | w[a + 5 | 0] << 8 | (w[a + 6 | 0] << 16 | w[a + 7 | 0] << 24);
  if (b >>> 0 < 1108 | ((b - 1108 | 0) != (w[a + 1104 | 0] | w[a + 1105 | 0] << 8 | (w[a + 1106 | 0] << 16 | w[a + 1107 | 0] << 24)) | b >>> 0 > 262144) | (w[a + 1094 | 0] | w[a + 1095 | 0] << 8 | (w[a + 1096 | 0] | w[a + 1097 | 0] << 8 | (w[a + 1098 | 0] << 16 | w[a + 1099 | 0] << 24)) - 5 >>> 0 < 4294967292)) {
   break a;
  }
  if (!Fv(a + 8 | 0)) {
   break a;
  }
  b = 40;
  while (1) {
   d = (b | 0) == 1094;
   if (d) {
    break a;
   }
   c = a + b | 0;
   if (w[c + 32 | 0] > 15 | w[c + 33 | 0] > 64) {
    break a;
   }
   b = b + 34 | 0;
   if (Fv(c)) {
    continue;
   }
   break;
  }
 }
 return d;
}

function Bpa(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0;
 c = eb - 16 | 0;
 eb = c;
 ac(c + 8 | 0, b, 26);
 d = v[c + 12 >> 2];
 ic(c, v[a >> 2], v[a + 8 >> 2], v[c + 8 >> 2], v[c + 12 >> 2]);
 e = v[c + 4 >> 2];
 if ((e | 0) == (d | 0)) {
  Ub(a, v[c + 12 >> 2]);
 }
 eb = c + 16 | 0;
 if ((d | 0) != (e | 0)) {
  t[b | 0] = 0;
  t[b + 1 | 0] = 0;
  t[b + 2 | 0] = 0;
  t[b + 3 | 0] = 0;
  t[b + 4 | 0] = 0;
  t[b + 5 | 0] = 0;
  t[b + 6 | 0] = 0;
  t[b + 7 | 0] = 0;
  t[b + 24 | 0] = 0;
  t[b + 25 | 0] = 0;
  t[b + 16 | 0] = 0;
  t[b + 17 | 0] = 0;
  t[b + 18 | 0] = 0;
  t[b + 19 | 0] = 0;
  t[b + 20 | 0] = 0;
  t[b + 21 | 0] = 0;
  t[b + 22 | 0] = 0;
  t[b + 23 | 0] = 0;
  t[b + 8 | 0] = 0;
  t[b + 9 | 0] = 0;
  t[b + 10 | 0] = 0;
  t[b + 11 | 0] = 0;
  t[b + 12 | 0] = 0;
  t[b + 13 | 0] = 0;
  t[b + 14 | 0] = 0;
  t[b + 15 | 0] = 0;
 }
}

function Bta(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0;
 md(b, 0);
 g = w[a | 0] | w[a + 1 | 0] << 8 | (w[a + 2 | 0] << 16 | w[a + 3 | 0] << 24);
 v[b >> 2] = g;
 e = w[a + 4 | 0] | w[a + 5 | 0] << 8 | (w[a + 6 | 0] << 16 | w[a + 7 | 0] << 24);
 v[b + 12 >> 2] = e;
 f = w[a + 8 | 0] | w[a + 9 | 0] << 8 | (w[a + 10 | 0] << 16 | w[a + 11 | 0] << 24);
 v[b + 16 >> 2] = f;
 c = w[a + 12 | 0] | w[a + 13 | 0] << 8;
 u[b + 32 >> 1] = 64;
 v[b + 24 >> 2] = c;
 c = w[a + 14 | 0];
 u[b + 30 >> 1] = c ? c + 1 | 0 : 256;
 d = x[b + 34 >> 1] & 32767 | !w[a + 14 | 0] << 15;
 u[b + 34 >> 1] = d;
 c = w[a + 15 | 0];
 if (!(!(c & 1) | e >>> 0 >= f >>> 0)) {
  d = d | 8;
  u[b + 34 >> 1] = d;
  c = w[a + 15 | 0];
 }
 if (c & 2) {
  v[b + 16 >> 2] = f >>> 1;
  v[b + 12 >> 2] = e >>> 1;
  v[b >> 2] = g >>> 1;
  u[b + 34 >> 1] = d | 1;
 }
}

function hra(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0;
 e = eb - 16 | 0;
 eb = e;
 i = e, j = Pj(b), v[i + 4 >> 2] = j;
 g = x[b >> 1];
 c = eb - 16 | 0;
 eb = c;
 f = a;
 d = ce(a);
 a: {
  if (d) {
   b = fc(a);
   while (1) {
    a = d;
    d = x[a + 16 >> 1];
    if (_o(g, d)) {
     b = a;
     d = v[a >> 2];
     if (d) {
      continue;
     }
     break a;
    }
    if (!_o(d, g)) {
     break a;
    }
    b = a + 4 | 0;
    d = v[a + 4 >> 2];
    if (d) {
     continue;
    }
    break;
   }
   break a;
  }
  a = fc(f);
  b = a;
 }
 v[c + 12 >> 2] = a;
 a = v[b >> 2];
 if (!a) {
  nZ(c, f, e + 4 | 0);
  _g(f, v[c + 12 >> 2], b, v[c >> 2]);
  a = me(c);
  mZ(c);
  h = 1;
 }
 Zg(e + 8 | 0, v[ub(c, a) >> 2], h);
 eb = c + 16 | 0;
 a = td(v[e + 8 >> 2]);
 eb = e + 16 | 0;
 return a + 4 | 0;
}

function iH(a, b, c, d) {
 var e = 0, f = 0, g = 0;
 f = eb - 32 | 0;
 eb = f;
 e = rf(f + 20 | 0, 1, 0);
 a: {
  b: {
   while (1) {
    g = Jb(e);
    kC(f + 12 | 0, g, Cb(v[e + 4 >> 2], w[e + 11 | 0]) + g | 0, v[b >> 2], c);
    if (!v[f + 16 >> 2]) {
     break b;
    }
    g = ji(Cb(v[e + 4 >> 2], w[e + 11 | 0]));
    v[31601] = 0;
    N(45, e | 0, g | 0);
    g = v[31601];
    v[31601] = 0;
    if ((g | 0) != 1) {
     continue;
    }
    break;
   }
   break a;
  }
  b = v[f + 12 >> 2];
  c = Jb(e);
  v[31601] = 0;
  N(46, e | 0, b - c | 0);
  b = v[31601];
  v[31601] = 0;
  c: {
   if ((b | 0) != 1) {
    v[31601] = 0;
    N(d | 0, a | 0, e | 0);
    a = v[31601];
    v[31601] = 0;
    if ((a | 0) != 1) {
     break c;
    }
    break a;
   }
   break a;
  }
  sb(e);
  eb = f + 32 | 0;
  return;
 }
 a = M() | 0;
 sb(e);
 P(a | 0);
 p();
}

function TQ(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0;
 e = eb - 16 | 0;
 eb = e;
 i = e, j = Pj(b), v[i + 4 >> 2] = j;
 g = x[b >> 1];
 c = eb - 16 | 0;
 eb = c;
 f = a;
 d = ce(a);
 a: {
  if (d) {
   b = fc(a);
   while (1) {
    a = d;
    d = x[a + 16 >> 1];
    if (Yq(g, d)) {
     b = a;
     d = v[a >> 2];
     if (d) {
      continue;
     }
     break a;
    }
    if (!Yq(d, g)) {
     break a;
    }
    b = a + 4 | 0;
    d = v[a + 4 >> 2];
    if (d) {
     continue;
    }
    break;
   }
   break a;
  }
  a = fc(f);
  b = a;
 }
 v[c + 12 >> 2] = a;
 a = v[b >> 2];
 if (!a) {
  nZ(c, f, e + 4 | 0);
  _g(f, v[c + 12 >> 2], b, v[c >> 2]);
  a = me(c);
  mZ(c);
  h = 1;
 }
 Zg(e + 8 | 0, v[ub(c, a) >> 2], h);
 eb = c + 16 | 0;
 a = td(v[e + 8 >> 2]);
 eb = e + 16 | 0;
 return a + 4 | 0;
}

function $G(a, b, c, d) {
 var e = 0, f = 0, g = 0;
 f = eb - 32 | 0;
 eb = f;
 e = rf(f + 20 | 0, 1, 0);
 a: {
  b: {
   while (1) {
    g = Jb(e);
    EN(f + 12 | 0, g, Cb(v[e + 4 >> 2], w[e + 11 | 0]) + g | 0, v[b >> 2], c);
    if (!v[f + 16 >> 2]) {
     break b;
    }
    g = ji(Cb(v[e + 4 >> 2], w[e + 11 | 0]));
    v[31601] = 0;
    N(45, e | 0, g | 0);
    g = v[31601];
    v[31601] = 0;
    if ((g | 0) != 1) {
     continue;
    }
    break;
   }
   break a;
  }
  b = v[f + 12 >> 2];
  c = Jb(e);
  v[31601] = 0;
  N(46, e | 0, b - c | 0);
  b = v[31601];
  v[31601] = 0;
  c: {
   if ((b | 0) != 1) {
    v[31601] = 0;
    N(d | 0, a | 0, e | 0);
    a = v[31601];
    v[31601] = 0;
    if ((a | 0) != 1) {
     break c;
    }
    break a;
   }
   break a;
  }
  sb(e);
  eb = f + 32 | 0;
  return;
 }
 a = M() | 0;
 sb(e);
 P(a | 0);
 p();
}

function tH(a, b, c, d) {
 var e = 0, f = 0, g = 0;
 f = eb - 32 | 0;
 eb = f;
 e = rf(f + 20 | 0, 1, 0);
 a: {
  b: {
   while (1) {
    g = Jb(e);
    kC(f + 12 | 0, g, Cb(v[e + 4 >> 2], w[e + 11 | 0]) + g | 0, w[b | 0], c);
    if (!v[f + 16 >> 2]) {
     break b;
    }
    g = ji(Cb(v[e + 4 >> 2], w[e + 11 | 0]));
    v[31601] = 0;
    N(45, e | 0, g | 0);
    g = v[31601];
    v[31601] = 0;
    if ((g | 0) != 1) {
     continue;
    }
    break;
   }
   break a;
  }
  b = v[f + 12 >> 2];
  c = Jb(e);
  v[31601] = 0;
  N(46, e | 0, b - c | 0);
  b = v[31601];
  v[31601] = 0;
  c: {
   if ((b | 0) != 1) {
    v[31601] = 0;
    N(d | 0, a | 0, e | 0);
    a = v[31601];
    v[31601] = 0;
    if ((a | 0) != 1) {
     break c;
    }
    break a;
   }
   break a;
  }
  sb(e);
  eb = f + 32 | 0;
  return;
 }
 a = M() | 0;
 sb(e);
 P(a | 0);
 p();
}

function tla(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0;
 a: {
  v[a >> 2] = 0;
  v[a + 4 >> 2] = 0;
  sc(a + 8 | 0);
  c = v[b >> 2];
  e = c;
  d = v[b + 4 >> 2];
  f = d;
  d = _c(c, d);
  c = eb - 16 | 0;
  eb = c;
  Qd(c + 8 | 0, v[ub(c + 4 | 0, a) >> 2]);
  b: {
   c: {
    if (d) {
     v[31601] = 0;
     N(640, a | 0, d | 0);
     g = v[31601];
     v[31601] = 0;
     if ((g | 0) == 1) {
      break c;
     }
     ev(a, e, f, d);
    }
    d = c + 8 | 0;
    Pd(d);
    Rj(d);
    eb = c + 16 | 0;
    break b;
   }
   a = M() | 0;
   Rj(c + 8 | 0);
   P(a | 0);
   p();
  }
  v[31601] = 0;
  O(3, a + 12 | 0, b + 12 | 0) | 0;
  c = v[31601];
  v[31601] = 0;
  if ((c | 0) != 1) {
   v[a + 24 >> 2] = v[b + 24 >> 2];
   u[a + 28 >> 1] = x[b + 28 >> 1];
   break a;
  }
  b = M() | 0;
  nd(a);
  P(b | 0);
  p();
 }
}

function cj(a, b) {
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0;
 e = eb - 16 | 0;
 eb = e;
 o(+b);
 g = j(1) | 0;
 c = j(0) | 0;
 d = g & 2147483647;
 f = d + -1048576 | 0;
 a: {
  if ((f | 0) == 2145386495 | f >>> 0 < 2145386495) {
   h = c << 28;
   c = (d & 15) << 28 | c >>> 4;
   d = (d >>> 4 | 0) + 1006632960 | 0;
   break a;
  }
  if ((d | 0) == 2146435072 | d >>> 0 > 2146435072) {
   h = c << 28;
   c = (g & 15) << 28 | c >>> 4;
   d = g >>> 4 | 2147418112;
   break a;
  }
  if (!(c | d)) {
   c = 0;
   d = 0;
   break a;
  }
  f = c;
  c = d ? E(d) : E(c) + 32 | 0;
  _f(e, f, d, 0, 0, c + 49 | 0);
  i = v[e >> 2];
  h = v[e + 4 >> 2];
  f = 15372 - c << 16;
  c = v[e + 8 >> 2];
  d = f | v[e + 12 >> 2] ^ 65536;
 }
 v[a >> 2] = i;
 v[a + 4 >> 2] = h;
 v[a + 8 >> 2] = c;
 v[a + 12 >> 2] = g & -2147483648 | d;
 eb = e + 16 | 0;
}

function rX(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0;
 c = eb - 32 | 0;
 eb = c;
 a: {
  if (!w[b + 8 | 0]) {
   while (1) {
    if ((d | 0) == 8) {
     v[c + 24 >> 2] = 0;
     v[c + 28 >> 2] = 0;
     d = Yb(c + 8 | 0, c + 24 | 0, 8);
     e = v[d >> 2];
     ic(c + 16 | 0, v[a >> 2], v[a + 8 >> 2], e, v[d + 4 >> 2]);
     d = 0;
     if (!(v[c + 24 >> 2] != (w[b | 0] | w[b + 1 | 0] << 8 | (w[b + 2 | 0] << 16 | w[b + 3 | 0] << 24)) | v[c + 28 >> 2] != (w[b + 4 | 0] | w[b + 5 | 0] << 8 | (w[b + 6 | 0] << 16 | w[b + 7 | 0] << 24)) | v[c + 20 >> 2] != 8)) {
      Ub(a, 8);
      d = 1;
     }
     eb = c + 32 | 0;
     break a;
    }
    e = b + d | 0;
    d = d + 1 | 0;
    if (w[e | 0]) {
     continue;
    }
    break;
   }
   Z(17480, 9079, 601, 13222);
   p();
  }
  Z(17459, 9079, 599, 13222);
  p();
 }
 return d | 0;
}

function dp(a, b, c) {
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0;
 g = eb - 16 | 0;
 eb = g;
 h = wb(b, 0);
 f = (w[h | 0] & 15) << 8 | w[wb(b, 1) | 0];
 d = 0;
 a: {
  if (!f) {
   break a;
  }
  d = 0;
  if ((f | 0) == 4095) {
   break a;
  }
  while (1) {
   d = 108;
   if ((e | 0) == 84) {
    break a;
   }
   b: {
    i = e << 1;
    d = x[i + 31008 >> 1];
    if (d >>> 0 <= f >>> 0) {
     if (!e | (f | 0) == (d | 0) | (x[i + 31006 >> 1] - f | 0) >= (f - d | 0)) {
      break b;
     }
     d = e + 24 | 0;
     break a;
    }
    e = e + 1 | 0;
    continue;
   }
   break;
  }
  d = e + 25 | 0;
 }
 t[c | 0] = d;
 e = wb(b, 2);
 d = w[e | 0];
 f = w[h | 0];
 t[c + 3 | 0] = 0;
 t[c + 1 | 0] = f & 16 | d >>> 4;
 c = w[e | 0];
 j = g, k = w[wb(b, 3) | 0], t[j + 15 | 0] = k;
 de(a, c & 15, g + 15 | 0);
 eb = g + 16 | 0;
}

function iba(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0;
 e = eb - 16 | 0;
 eb = e;
 ed(e + 8 | 0, b, c);
 c = v[e + 8 >> 2];
 f = v[e + 12 >> 2];
 b = eb - 48 | 0;
 eb = b;
 v[b + 44 >> 2] = d;
 v[b + 40 >> 2] = d;
 a = zg(b + 12 | 0, a, b + 40 | 0, b + 44 | 0);
 v[b + 8 >> 2] = v[a + 8 >> 2];
 d = v[a + 4 >> 2];
 v[b >> 2] = v[a >> 2];
 v[b + 4 >> 2] = d;
 yg(b + 24 | 0, b);
 a: {
  while (1) {
   if ((c | 0) == (f | 0)) {
    break a;
   }
   v[31601] = 0;
   N(1123, v[b + 44 >> 2], c | 0);
   a = v[31601];
   v[31601] = 0;
   if ((a | 0) != 1) {
    v[b + 44 >> 2] = v[b + 44 >> 2] + 16;
    c = c + 16 | 0;
    continue;
   }
   break;
  }
  a = M() | 0;
  aN(b + 24 | 0);
  P(a | 0);
  p();
 }
 a = b + 24 | 0;
 xg(a);
 c = v[b + 44 >> 2];
 aN(a);
 eb = b + 48 | 0;
 eb = e + 16 | 0;
 return c | 0;
}

function dY(a, b, c, d) {
 var e = 0, f = 0;
 f = eb - 16 | 0;
 eb = f;
 e = x[c >> 1];
 while (1) {
  a: {
   e = e << 1;
   u[c >> 1] = e;
   t[b | 0] = (e & 65534) >>> 0 > 255;
   e = w[c | 0];
   u[c >> 1] = e;
   if (!e) {
    if (!Af(a, f + 15 | 0)) {
     break a;
    }
    e = w[f + 15 | 0];
    u[c >> 1] = e << 1 | 1;
    t[b | 0] = e >>> 7;
    u[c >> 1] = w[c | 0];
   }
   t[d | 0] = w[b | 0] + (w[d | 0] << 1);
   e = x[c >> 1] << 1;
   u[c >> 1] = e;
   t[b | 0] = (e & 65534) >>> 0 > 255;
   e = w[c | 0];
   u[c >> 1] = e;
   if (!e) {
    if (!Af(a, f + 14 | 0)) {
     break a;
    }
    e = w[f + 14 | 0];
    u[c >> 1] = e << 1 | 1;
    t[b | 0] = e >>> 7;
    e = w[c | 0];
    u[c >> 1] = e;
    if (w[b | 0]) {
     continue;
    }
    break a;
   }
   if (w[b | 0]) {
    continue;
   }
  }
  break;
 }
 eb = f + 16 | 0;
}

function M9(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0;
 e = eb - 16 | 0;
 eb = e;
 ed(e + 8 | 0, b, c);
 c = v[e + 8 >> 2];
 f = v[e + 12 >> 2];
 b = eb - 48 | 0;
 eb = b;
 v[b + 44 >> 2] = d;
 v[b + 40 >> 2] = d;
 a = zg(b + 12 | 0, a, b + 40 | 0, b + 44 | 0);
 v[b + 8 >> 2] = v[a + 8 >> 2];
 d = v[a + 4 >> 2];
 v[b >> 2] = v[a >> 2];
 v[b + 4 >> 2] = d;
 yg(b + 24 | 0, b);
 a: {
  while (1) {
   if ((c | 0) == (f | 0)) {
    break a;
   }
   v[31601] = 0;
   N(1207, v[b + 44 >> 2], c | 0);
   a = v[31601];
   v[31601] = 0;
   if ((a | 0) != 1) {
    v[b + 44 >> 2] = v[b + 44 >> 2] + 12;
    c = c + 12 | 0;
    continue;
   }
   break;
  }
  a = M() | 0;
  $L(b + 24 | 0);
  P(a | 0);
  p();
 }
 a = b + 24 | 0;
 xg(a);
 c = v[b + 44 >> 2];
 $L(a);
 eb = b + 48 | 0;
 eb = e + 16 | 0;
 return c | 0;
}

function kQ(a, b, c, d, e) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 var f = 0, g = 0;
 a = Ii(a, b, c, d);
 t[a + 4260 | 0] = e;
 v[a >> 2] = 44652;
 c = Mb(a + 4264 | 0);
 d = Mb(a + 4276 | 0);
 v[a + 4328 >> 2] = 0;
 b = a + 4320 | 0;
 v[b >> 2] = 0;
 v[b + 4 >> 2] = 0;
 v[a + 4312 >> 2] = 0;
 v[a + 4316 >> 2] = 0;
 b = a + 4208 | 0;
 f = xb(b, 0), g = 1056964608, v[f >> 2] = g;
 f = xb(b, 1), g = 1036831949, v[f >> 2] = g;
 f = xb(b, 2), g = 1038174126, v[f >> 2] = g;
 f = xb(b, 3), g = 1065353216, v[f >> 2] = g;
 f = xb(b, 4), g = 1061158912, v[f >> 2] = g;
 f = xb(b, 5), g = 1059082943, v[f >> 2] = g;
 f = xb(b, 6), g = 1061997773, v[f >> 2] = g;
 v[31601] = 0;
 N(940, a + 44 | 0, 2);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  return a | 0;
 }
 b = M() | 0;
 uc(d);
 uc(c);
 Zf(a);
 P(b | 0);
 p();
}

function Pia(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = C(0);
 e = eb - 16 | 0;
 eb = e;
 f = Hf(a, c);
 $d(e, v[a + 36 >> 2]);
 h = a;
 a: {
  if (!f) {
   Pc(e, a + 32 | 0, 5);
   c = 0;
   if (Fb(v[v[e >> 2] >> 2], v[e + 4 >> 2])) {
    break a;
   }
  }
  c = 0;
  d = eb - 16 | 0;
  eb = d;
  g = v[a + 36 >> 2];
  ml(g, d + 8 | 0);
  i = d, j = Ac(v[d + 8 >> 2], v[d + 12 >> 2]), v[i + 4 >> 2] = j;
  v[d >> 2] = 256;
  Al(b, v[Gb(d + 4 | 0, d) >> 2]);
  a = v[b >> 2];
  while (1) {
   if (nc(a, v[b + 4 >> 2]) >>> 0 <= c >>> 0) {
    eb = d + 16 | 0;
   } else {
    v[d + 4 >> 2] = 0;
    wq(g, d + 4 | 0);
    a = v[b >> 2];
    i = xb(a, c), k = z[d + 4 >> 2], z[i >> 2] = k;
    c = c + 1 | 0;
    continue;
   }
   break;
  }
  c = f;
 }
 ef(h, c);
 eb = e + 16 | 0;
}

function jra(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0;
 if (v[a + 4 >> 2] != v[zb(a) >> 2]) {
  c = eb - 16 | 0;
  eb = c;
  a = Cx(c + 4 | 0, a);
  d = v[a + 4 >> 2];
  v[31601] = 0;
  N(501, d | 0, b | 0);
  b = v[31601];
  v[31601] = 0;
  a: {
   if ((b | 0) != 1) {
    v[a + 4 >> 2] = v[a + 4 >> 2] + 12;
    hc(a);
    eb = c + 16 | 0;
    break a;
   }
   b = M() | 0;
   hc(a);
   P(b | 0);
   p();
  }
  return;
 }
 d = eb - 32 | 0;
 eb = d;
 c = zb(a);
 c = wm(d + 12 | 0, Qp(a, Td(v[a >> 2], v[a + 4 >> 2]) + 1 | 0), Td(v[a >> 2], v[a + 4 >> 2]), c);
 e = v[c + 8 >> 2];
 v[31601] = 0;
 N(501, e | 0, b | 0);
 b = v[31601];
 v[31601] = 0;
 b: {
  if ((b | 0) != 1) {
   v[c + 8 >> 2] = v[c + 8 >> 2] + 12;
   Bx(a, c);
   ws(c);
   eb = d + 32 | 0;
   break b;
  }
  a = M() | 0;
  ws(c);
  P(a | 0);
  p();
 }
}

function EH(a, b, c, d, e, f) {
 var g = 0, h = 0, i = 0;
 g = eb - 256 | 0;
 eb = g;
 t[g + 252 | 0] = 0;
 t[g + 253 | 0] = 0;
 t[g + 254 | 0] = 0;
 t[g + 255 | 0] = 0;
 t[g + 249 | 0] = 0;
 t[g + 250 | 0] = 0;
 t[g + 251 | 0] = 0;
 t[g + 252 | 0] = 0;
 t[g + 248 | 0] = 37;
 st(g + 249 | 0, 10616, f, v[b + 4 >> 2]);
 f = Nd();
 v[g >> 2] = d;
 v[g + 4 >> 2] = e;
 d = g + 224 | 0;
 e = oh(d, 24, f, g + 248 | 0, g) + d | 0;
 h = ij(d, e, v[b + 4 >> 2]);
 f = g + 20 | 0;
 bd(f, v[b + 28 >> 2]);
 v[31601] = 0;
 i = d;
 d = g + 32 | 0;
 fa(1268, i | 0, h | 0, e | 0, d | 0, g + 28 | 0, g + 24 | 0, f | 0);
 e = v[31601];
 v[31601] = 0;
 a: {
  if ((e | 0) != 1) {
   Zb(f);
   a = pt(a, d, v[g + 28 >> 2], v[g + 24 >> 2], b, c);
   eb = g + 256 | 0;
   break a;
  }
  a = M() | 0;
  Zb(g + 20 | 0);
  P(a | 0);
  p();
 }
 return a;
}

function GH(a, b, c, d, e, f) {
 var g = 0, h = 0, i = 0;
 g = eb - 112 | 0;
 eb = g;
 t[g + 108 | 0] = 0;
 t[g + 109 | 0] = 0;
 t[g + 110 | 0] = 0;
 t[g + 111 | 0] = 0;
 t[g + 105 | 0] = 0;
 t[g + 106 | 0] = 0;
 t[g + 107 | 0] = 0;
 t[g + 108 | 0] = 0;
 t[g + 104 | 0] = 37;
 st(g + 105 | 0, 10616, f, v[b + 4 >> 2]);
 f = Nd();
 v[g >> 2] = d;
 v[g + 4 >> 2] = e;
 d = g + 80 | 0;
 e = oh(d, 24, f, g + 104 | 0, g) + d | 0;
 h = ij(d, e, v[b + 4 >> 2]);
 f = g + 20 | 0;
 bd(f, v[b + 28 >> 2]);
 v[31601] = 0;
 i = d;
 d = g + 32 | 0;
 fa(1264, i | 0, h | 0, e | 0, d | 0, g + 28 | 0, g + 24 | 0, f | 0);
 e = v[31601];
 v[31601] = 0;
 a: {
  if ((e | 0) != 1) {
   Zb(f);
   a = tw(a, d, v[g + 28 >> 2], v[g + 24 >> 2], b, c);
   eb = g + 112 | 0;
   break a;
  }
  a = M() | 0;
  Zb(g + 20 | 0);
  P(a | 0);
  p();
 }
 return a;
}

function rs(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0;
 if ((a | 0) != (b | 0)) {
  if (!ud(w[a + 11 | 0])) {
   c = w[b + 11 | 0];
   if (!ud(c)) {
    d = v[b + 4 >> 2];
    v[a >> 2] = v[b >> 2];
    v[a + 4 >> 2] = d;
    v[a + 8 >> 2] = v[b + 8 >> 2];
    return;
   }
   d = Jb(b);
   b = Cb(v[b + 4 >> 2], c);
   a: {
    if (b >>> 0 <= 10) {
     Me(a, b);
     gd(Wg(a, d, b) + b | 0, 0);
     break a;
    }
    e = a;
    a = Gh(w[a + 11 | 0]);
    Uq(e, 10, b - 10 | 0, a, 0, a, b, d);
   }
   return;
  }
  d = Jb(b);
  b = Cb(v[b + 4 >> 2], w[b + 11 | 0]);
  c = Yi(v[a + 8 >> 2]);
  b: {
   if (b >>> 0 < c >>> 0) {
    c = v[a >> 2];
    Ad(a, b);
    gd(Wg(c, d, b) + b | 0, 0);
    break b;
   }
   e = a;
   a = v[a + 4 >> 2];
   Uq(e, c - 1 | 0, (b - c | 0) + 1 | 0, a, 0, a, b, d);
  }
 }
}

function EE(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0;
 if ((a | 0) != (b | 0)) {
  if (!ud(w[a + 11 | 0])) {
   c = w[b + 11 | 0];
   if (!ud(c)) {
    d = v[b + 4 >> 2];
    v[a >> 2] = v[b >> 2];
    v[a + 4 >> 2] = d;
    v[a + 8 >> 2] = v[b + 8 >> 2];
    return;
   }
   d = Jb(b);
   b = Cb(v[b + 4 >> 2], c);
   a: {
    if (b >>> 0 <= 10) {
     Me(a, b);
     gd(Cg(a, d, b) + b | 0, 0);
     break a;
    }
    e = a;
    a = Gh(w[a + 11 | 0]);
    Zp(e, 10, b - 10 | 0, a, 0, a, b, d);
   }
   return;
  }
  d = Jb(b);
  b = Cb(v[b + 4 >> 2], w[b + 11 | 0]);
  c = Yi(v[a + 8 >> 2]);
  b: {
   if (b >>> 0 < c >>> 0) {
    c = v[a >> 2];
    Ad(a, b);
    gd(Cg(c, d, b) + b | 0, 0);
    break b;
   }
   e = a;
   a = v[a + 4 >> 2];
   Zp(e, c - 1 | 0, (b - c | 0) + 1 | 0, a, 0, a, b, d);
  }
 }
}

function VH(a, b, c, d, e, f, g, h) {
 var i = 0, j = 0, k = 0;
 i = eb - 16 | 0;
 eb = i;
 v[31601] = 0;
 V(995, a | 0);
 j = v[31601];
 v[31601] = 0;
 a: {
  b: {
   if ((j | 0) != 1) {
    c: {
     j = v[a + 24 >> 2];
     v[31601] = 0;
     k = h;
     h = i + 4 | 0;
     fa(k | 0, h | 0, j | 0, b | 0, c | 0, d | 0, e | 0, (f | 0) != 0 | 0);
     b = v[31601];
     v[31601] = 0;
     if ((b | 0) == 1) {
      break c;
     }
     b = Bg(Jb(h));
     sb(h);
     break b;
    }
   }
   X(S(0) | 0) | 0;
   b = 0;
   v[31601] = 0;
   U(982, g | 0, a | 0, 0, 0);
   a = v[31601];
   v[31601] = 0;
   if ((a | 0) == 1) {
    break a;
   }
   Y();
  }
  eb = i + 16 | 0;
  return b;
 }
 a = M() | 0;
 v[31601] = 0;
 W(26);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  P(a | 0);
  p();
 }
 S(0) | 0;
 Rb();
 p();
}

function Laa(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
 c = eb - 16 | 0;
 eb = c;
 a: {
  d = Ri(A[a + 24 >> 3] * 65536);
  if ((d | 0) == 65536) {
   break a;
  }
  j = d >> 31;
  k = v[b >> 2];
  h = v[b + 4 >> 2];
  l = v[b + 8 >> 2];
  b: while (1) {
   if ((g | 0) == (l | 0)) {
    break a;
   }
   m = (B(g, h) << 2) + k | 0;
   e = 0;
   while (1) if ((e | 0) == (h | 0)) {
    g = g + 1 | 0;
    continue b;
   } else {
    i = (e << 2) + m | 0;
    f = v[i >> 2];
    f = Bua(Aua(f, f >> 31, d, j), gb, 65536, 0);
    n = i, o = Fc(f, gb), v[n >> 2] = o;
    e = e + 1 | 0;
    continue;
   }
  }
 }
 v[c + 8 >> 2] = v[b + 8 >> 2];
 d = v[b + 4 >> 2];
 v[c >> 2] = v[b >> 2];
 v[c + 4 >> 2] = d;
 EM(a, c);
 eb = c + 16 | 0;
}

function Caa(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, o = 0;
 c = eb - 16 | 0;
 eb = c;
 a: {
  d = Ri(A[a + 24 >> 3] * 65536);
  if ((d | 0) == 65536) {
   break a;
  }
  j = d >> 31;
  k = v[b >> 2];
  h = v[b + 4 >> 2];
  l = v[b + 8 >> 2];
  b: while (1) {
   if ((g | 0) == (l | 0)) {
    break a;
   }
   m = (B(g, h) << 2) + k | 0;
   e = 0;
   while (1) if ((e | 0) == (h | 0)) {
    g = g + 1 | 0;
    continue b;
   } else {
    i = (e << 2) + m | 0;
    f = v[i >> 2];
    f = Bua(Aua(f, f >> 31, d, j), gb, 65536, 0);
    n = i, o = Fc(f, gb), v[n >> 2] = o;
    e = e + 1 | 0;
    continue;
   }
  }
 }
 v[c + 8 >> 2] = v[b + 8 >> 2];
 d = v[b + 4 >> 2];
 v[c >> 2] = v[b >> 2];
 v[c + 4 >> 2] = d;
 yM(a, c);
 eb = c + 16 | 0;
}

function ku(a) {
 var b = 0, c = 0, d = 0, e = 0;
 a: {
  while (1) {
   if (!a) {
    b = 0;
    if (v[31472]) {
     b = ku(v[31472]);
    }
    if (!v[31398]) {
     break a;
    }
    c = b | c;
    a = v[31398];
    continue;
   }
   break;
  }
  d = v[a + 76 >> 2] < 0;
  b: {
   c: {
    if (v[a + 20 >> 2] == v[a + 28 >> 2]) {
     break c;
    }
    hb[v[a + 36 >> 2]](a, 0, 0) | 0;
    if (v[a + 20 >> 2]) {
     break c;
    }
    b = -1;
    if (!d) {
     break b;
    }
    break a;
   }
   b = v[a + 8 >> 2];
   e = v[a + 4 >> 2];
   if ((b | 0) != (e | 0)) {
    b = e - b | 0;
    hb[v[a + 40 >> 2]](a, b, b >> 31, 1) | 0;
   }
   b = 0;
   v[a + 28 >> 2] = 0;
   v[a + 16 >> 2] = 0;
   v[a + 20 >> 2] = 0;
   v[a + 4 >> 2] = 0;
   v[a + 8 >> 2] = 0;
   if (d) {
    break a;
   }
  }
 }
 return b | c;
}

function vta(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0;
 c = eb - 32 | 0;
 eb = c;
 md(b, 0);
 e = c + 8 | 0;
 ck(e, 1, a);
 d = c + 20 | 0;
 Bc(d, e);
 Ae(b + 43 | 0, d);
 sb(d);
 v[b + 24 >> 2] = w[a + 32 | 0] | w[a + 33 | 0] << 8 | (w[a + 34 | 0] << 16 | w[a + 35 | 0] << 24);
 u[b + 34 >> 1] = x[b + 34 >> 1] & 65533 | (w[a + 13 | 0] | w[a + 14 | 0] << 8) << 1 & 2;
 v[b >> 2] = w[a + 16 | 0] | w[a + 17 | 0] << 8 | (w[a + 18 | 0] << 16 | w[a + 19 | 0] << 24);
 v[b + 4 >> 2] = w[a + 20 | 0] | w[a + 21 | 0] << 8 | (w[a + 22 | 0] << 16 | w[a + 23 | 0] << 24);
 v[b + 8 >> 2] = w[a + 24 | 0] | w[a + 25 | 0] << 8 | (w[a + 26 | 0] << 16 | w[a + 27 | 0] << 24);
 t[c + 20 | 0] = w[a + 15 | 0];
 t[c + 8 | 0] = 64;
 f = b, g = w[Pb(d, e) | 0] << 2, u[f + 30 >> 1] = g;
 eb = c + 32 | 0;
}

function tja(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0;
 d = eb - 32 | 0;
 eb = d;
 e = d + 8 | 0;
 Ui(e, 2, a + 2 | 0);
 f = d + 20 | 0;
 Bc(f, e);
 zc(b + 492 | 0, f);
 e = b + 236 | 0;
 g = c + 1 | 0;
 h = a + 31 | 0;
 sb(f);
 c = 0;
 while (1) {
  if ((c | 0) == 120) {
   v[b >> 2] = (w[a + 223 | 0] | w[a + 224 | 0] << 8) << 5;
   a = a + 158 | 0;
   nR(w[a | 0] & 15, w[a + 1 | 0] & 15, w[a + 2 | 0] & 15, w[a + 3 | 0] & 15, w[a + 4 | 0] & 15, a + 5 | 0, b + 48 | 0);
   nR(w[a | 0] >>> 4 | 0, w[a + 1 | 0] >>> 4 | 0, w[a + 2 | 0] >>> 4 | 0, w[a + 3 | 0] >>> 4 | 0, w[a + 4 | 0] >>> 4 | 0, a + 35 | 0, b + 68 | 0);
   eb = d + 32 | 0;
  } else {
   i = $b(e, c), j = w[c + h | 0] + g | 0, u[i >> 1] = j;
   c = c + 1 | 0;
   continue;
  }
  break;
 }
}

function qc(a, b) {
 var c = 0, d = 0, e = 0;
 c = v[a + 1396 >> 2];
 if ((c | 0) >= 0) {
  a: {
   b: {
    if ((b | 0) <= (c | 0)) {
     break b;
    }
    if (b >>> 0 > 24) {
     return qc(a, 24) + (qc(a, b - 24 | 0) << 24) | 0;
    }
    if (!c) {
     v[a + 1392 >> 2] = 0;
    }
    while (1) {
     if ((b | 0) <= (c | 0)) {
      break b;
     }
     c = -1;
     e = St(a);
     d = 0;
     if ((e | 0) == -1) {
      break a;
     }
     d = v[a + 1396 >> 2];
     c = d + 8 | 0;
     v[a + 1396 >> 2] = c;
     v[a + 1392 >> 2] = v[a + 1392 >> 2] + (e << d);
     continue;
    }
   }
   if ((b | 0) > (c | 0)) {
    Z(10077, 13258, 1632, 6865);
    p();
   }
   d = v[a + 1392 >> 2];
   v[a + 1392 >> 2] = d >>> b;
   c = c - b | 0;
   d = d & (-1 << b ^ -1);
  }
  v[a + 1396 >> 2] = c;
 }
 return d;
}

function UH(a, b, c, d, e, f, g) {
 var h = 0, i = 0, j = 0;
 h = eb - 16 | 0;
 eb = h;
 v[31601] = 0;
 V(995, a | 0);
 i = v[31601];
 v[31601] = 0;
 a: {
  b: {
   if ((i | 0) != 1) {
    c: {
     i = v[v[a + 24 >> 2] + 24 >> 2];
     v[31601] = 0;
     j = g;
     g = h + 4 | 0;
     ia(j | 0, g | 0, i | 0, b | 0, c | 0, d | 0, e | 0);
     b = v[31601];
     v[31601] = 0;
     if ((b | 0) == 1) {
      break c;
     }
     b = Bg(Jb(g));
     sb(g);
     break b;
    }
   }
   X(S(0) | 0) | 0;
   b = 0;
   v[31601] = 0;
   U(982, f | 0, a | 0, 0, 0);
   a = v[31601];
   v[31601] = 0;
   if ((a | 0) == 1) {
    break a;
   }
   Y();
  }
  eb = h + 16 | 0;
  return b;
 }
 a = M() | 0;
 v[31601] = 0;
 W(26);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  P(a | 0);
  p();
 }
 S(0) | 0;
 Rb();
 p();
}

function Or(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0;
 c = eb - 32 | 0;
 eb = c;
 a: {
  if (!w[b + 7 | 0]) {
   while (1) {
    if ((d | 0) == 7) {
     d = 0;
     t[c + 27 | 0] = 0;
     t[c + 28 | 0] = 0;
     t[c + 29 | 0] = 0;
     t[c + 30 | 0] = 0;
     v[c + 24 >> 2] = 0;
     e = c + 24 | 0;
     f = Yb(c + 8 | 0, e, 7);
     ic(c + 16 | 0, v[a >> 2], v[a + 8 >> 2], v[f >> 2], v[f + 4 >> 2]);
     b: {
      if (v[c + 20 >> 2] != 7) {
       break b;
      }
      if (id(e, b, 7)) {
       break b;
      }
      Ub(a, 7);
      d = 1;
     }
     eb = c + 32 | 0;
     break a;
    }
    e = b + d | 0;
    d = d + 1 | 0;
    if (w[e | 0]) {
     continue;
    }
    break;
   }
   Z(17480, 9079, 601, 13222);
   p();
  }
  Z(17459, 9079, 599, 13222);
  p();
 }
 return d | 0;
}

function Oo(a) {
 var b = 0, c = 0, d = 0, e = 0;
 d = x[v[a + 4 >> 2] + 28 >> 1] >>> (!w[a + 77 | 0] << 1) | 0;
 b = ((d & 3) << 4) + 26160 | 0;
 v[a + 40 >> 2] = b;
 e = x[a + 24 >> 1];
 d = d >>> 2 | 0;
 c = e + d | 0;
 u[a + 36 >> 1] = c >>> 0 < 12 ? 1 : 1 << c - 12;
 c = 12 - c | 0;
 c = c >>> 0 <= 12 ? c : 0;
 u[a + 32 >> 1] = c;
 u[a + 34 >> 1] = -1 << c ^ -1;
 if ((e | 0) == 15) {
  u[a + 36 >> 1] = 4095;
 }
 v[a + 52 >> 2] = b;
 v[a + 64 >> 2] = b;
 b = d + x[a + 26 >> 1] | 0;
 u[a + 48 >> 1] = b >>> 0 < 12 ? 1 : 1 << b - 12;
 b = 12 - b | 0;
 c = b >>> 0 <= 12 ? b : 0;
 u[a + 44 >> 1] = c;
 b = d + x[a + 30 >> 1] | 0;
 u[a + 60 >> 1] = b >>> 0 < 12 ? 1 : 1 << b - 12;
 b = 12 - b | 0;
 b = b >>> 0 <= 12 ? b : 0;
 u[a + 56 >> 1] = b;
 u[a + 46 >> 1] = -1 << c ^ -1;
 u[a + 58 >> 1] = -1 << b ^ -1;
}

function zD(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0;
 f = c;
 c = 0;
 a: {
  if (!b) {
   break a;
  }
  if (!Lb(v[a >> 2], v[a + 8 >> 2], b)) {
   break a;
  }
  if (b >>> 0 <= 3) {
   c = eb - 16 | 0;
   eb = c;
   if (Lb(v[a >> 2], v[a + 8 >> 2], b)) {
    while (1) {
     if ((d | 0) == 4) {
      Jm(c + 4 | 0, v[c + 12 >> 2]);
      d = v[c + 4 >> 2];
     } else {
      t[c + 11 | 0] = 0;
      b: {
       if (b >>> 0 > d >>> 0) {
        dh(a, c + 11 | 0);
        e = t[c + 11 | 0];
        g = e >>> 31 | 0;
        break b;
       }
       e = 0 - g | 0;
      }
      t[(c + 12 | 0) + d | 0] = e;
      d = d + 1 | 0;
      continue;
     }
     break;
    }
   }
   eb = c + 16 | 0;
   c = d;
   break a;
  }
  c = Qg(a);
  Ub(a, b - 4 | 0);
 }
 t[f | 0] = c;
}

function QU(a, b, c, d) {
 var e = 0, f = 0, g = 0, h = 0;
 h = eb - 16 | 0;
 eb = h;
 g = v[a + 4 >> 2];
 e = (g - d | 0) + b | 0;
 f = aj(h + 4 | 0, a, c - e >> 1);
 d = v[f + 4 >> 2];
 a = e;
 while (1) {
  if (a >>> 0 >= c >>> 0) {
   hc(f);
   c = eb - 16 | 0;
   eb = c;
   a = eb - 32 | 0;
   eb = a;
   ed(a + 24 | 0, b, e);
   b = eb - 16 | 0;
   eb = b;
   d = v[a + 28 >> 2];
   e = v[a + 24 >> 2];
   f = d - e | 0;
   g = g - f | 0;
   v[b + 12 >> 2] = g;
   TU(g, e, f >> 1);
   pc(a + 16 | 0, d, b + 12 | 0);
   eb = b + 16 | 0;
   b = v[a + 16 >> 2];
   v[a + 12 >> 2] = v[a + 20 >> 2];
   pc(c + 8 | 0, b, a + 12 | 0);
   eb = a + 32 | 0;
   eb = c + 16 | 0;
   eb = h + 16 | 0;
  } else {
   km(d, x[a >> 1]);
   d = d + 2 | 0;
   v[f + 4 >> 2] = d;
   a = a + 2 | 0;
   continue;
  }
  break;
 }
}

function LN(a, b, c, d, e) {
 var f = 0, g = 0, h = 0, i = 0, j = 0;
 f = c - b | 0;
 a: {
  if ((f | 0) <= 19) {
   i = B(64 - fu(d | 1, e) | 0, 1233) >>> 12 | 0;
   j = (i << 3) + 121312 | 0;
   g = f;
   f = v[j + 4 >> 2];
   h = 61;
   if ((g | 0) < (((e | 0) == (f | 0) & d >>> 0 >= y[j >> 2] | e >>> 0 > f >>> 0) + i | 0)) {
    break a;
   }
  }
  b: {
   if (!e) {
    c = BB(b, d);
    break b;
   }
   if ((e | 0) == 2 & d >>> 0 >= 1410065408 | e >>> 0 > 2) {
    c = Cua(d, e, 1410065408, 2);
    f = Aua(c, gb, -1410065408, -3);
    e = e + gb | 0;
    g = d;
    d = d + f | 0;
    e = g >>> 0 > d >>> 0 ? e + 1 | 0 : e;
    b = BB(b, c);
   }
   c = Cua(d, e, 1e8, 0);
   e = gb;
   b = Gl(b, c);
   c = Aua(c, e, -1e8, 0) + d | 0;
   c = Ru(b, c);
  }
  h = 0;
 }
 v[a + 4 >> 2] = h;
 v[a >> 2] = c;
}

function eT(a, b) {
 var c = 0, d = 0, e = 0, f = 0, g = 0;
 a: {
  if (w[b + 791 | 0] != 27) {
   a = t[b + 831 | 0];
   break a;
  }
  e = a + 1074312 | 0;
  c = Nb(e, 21);
  d = a;
  a = w[b + 821 | 0];
  a = LA(d, w[b + 828 | 0], c ? a : a + 16 >>> 2 | 0);
  b: {
   if (!(!Nb(e, 45) | w[b + 828 | 0] != 3)) {
    c = w[b + 821 | 0];
    c: {
     if (!(!c | c >>> 0 >= w[b + 829 | 0])) {
      a = w[b + 832 | 0];
      d = c + 1 | 0;
      break c;
     }
     t[b + 832 | 0] = a;
     d = 1;
    }
    t[b + 821 | 0] = d;
    a = a << 24 >> 24;
    break b;
   }
   t[b + 821 | 0] = w[b + 821 | 0] + w[b + 829 | 0];
  }
  if (!Nb(e, 47)) {
   break a;
  }
  t[b + 831 | 0] = a;
 }
 if (a) {
  f = b, g = Xb(v[b + 684 >> 2] + ((B(w[b + 830 | 0], a) + 2 | 0) / 8 | 0) | 0, 0, 256), 
  v[f + 684 >> 2] = g;
 }
}

function FH(a, b, c, d, e) {
 var f = 0, g = 0, h = 0, i = 0;
 f = eb - 144 | 0;
 eb = f;
 t[f + 140 | 0] = 0;
 t[f + 141 | 0] = 0;
 t[f + 142 | 0] = 0;
 t[f + 143 | 0] = 0;
 t[f + 137 | 0] = 0;
 t[f + 138 | 0] = 0;
 t[f + 139 | 0] = 0;
 t[f + 140 | 0] = 0;
 t[f + 136 | 0] = 37;
 st(f + 137 | 0, 10783, e, v[b + 4 >> 2]);
 e = Nd();
 v[f >> 2] = d;
 d = f + 123 | 0;
 e = oh(d, 13, e, f + 136 | 0, f) + d | 0;
 h = ij(d, e, v[b + 4 >> 2]);
 g = f + 4 | 0;
 bd(g, v[b + 28 >> 2]);
 v[31601] = 0;
 i = d;
 d = f + 16 | 0;
 fa(1268, i | 0, h | 0, e | 0, d | 0, f + 12 | 0, f + 8 | 0, g | 0);
 e = v[31601];
 v[31601] = 0;
 a: {
  if ((e | 0) != 1) {
   Zb(g);
   a = pt(a, d, v[f + 12 >> 2], v[f + 8 >> 2], b, c);
   eb = f + 144 | 0;
   break a;
  }
  a = M() | 0;
  Zb(f + 4 | 0);
  P(a | 0);
  p();
 }
 return a;
}

function Rx(a, b, c) {
 var d = 0, e = 0, f = 0, g = 0;
 e = Jb(a);
 a = Cb(v[a + 4 >> 2], w[a + 11 | 0]);
 d = Jb(b);
 b = Cb(v[b + 4 >> 2], w[b + 11 | 0]);
 a: {
  if (a >>> 0 >= c >>> 0) {
   if (!b) {
    break a;
   }
   c = c + e | 0;
   a = a + e | 0;
   b = b + d | 0;
   b: {
    if ((b | 0) == (d | 0)) {
     break b;
    }
    c: {
     b = b - d | 0;
     if ((b | 0) > (a - c | 0)) {
      break c;
     }
     g = w[d | 0];
     while (1) {
      f = a - c | 0;
      if ((f | 0) < (b | 0)) {
       break c;
      }
      c = Du(c, (f - b | 0) + 1 | 0, g);
      if (!c) {
       break c;
      }
      if (!TG(c, d, b)) {
       break b;
      }
      c = c + 1 | 0;
      continue;
     }
    }
    c = a;
   }
   c = (a | 0) == (c | 0) ? -1 : c - e | 0;
  } else {
   c = -1;
  }
 }
 return c;
}

function Tt(a, b, c) {
 var d = 0, e = 0;
 d = a, e = rj(C(C(z[c + 1792 >> 2] * C(75038)) + C(C(C(z[c + 2048 >> 2] - z[c + 1536 >> 2]) * C(37489)) + C(C(C(z[c + 1280 >> 2] + z[c + 2304 >> 2]) * C(6574)) + C(C(C(z[c + 2560 >> 2] - z[c + 1024 >> 2]) * C(5153)) + C(C(C(z[c + 768 >> 2] + z[c + 2816 >> 2]) * C(2037)) + C(C(C(z[c + 3072 >> 2] - z[c + 512 >> 2]) * C(459)) + C(C(C(z[c + 256 >> 2] + z[c + 3328 >> 2]) * C(213)) + C(C(z[c + 3584 >> 2] - z[c >> 2]) * C(29)))))))))), 
 u[d >> 1] = e;
 d = (b << 5) + a | 0, e = rj(C(C(z[c + 8 >> 2] * C(-5)) + C(C(z[c + 520 >> 2] * C(146)) + C(C(z[c + 1032 >> 2] * C(-45)) + C(C(z[c + 1544 >> 2] * C(-9975)) + C(C(z[c + 2056 >> 2] * C(64019)) + C(C(z[c + 2568 >> 2] * C(9727)) + C(C(z[c + 3080 >> 2] * C(1567)) + C(z[c + 3592 >> 2] * C(104)))))))))), 
 u[d >> 1] = e;
}

function BB(a, b) {
 var c = 0;
 if (b >>> 0 <= 999999) {
  if (b >>> 0 <= 9999) {
   if (b >>> 0 <= 99) {
    if (b >>> 0 <= 9) {
     return Iq(a, b);
    }
    return Gl(a, b);
   }
   if (b >>> 0 <= 999) {
    c = a;
    a = (b >>> 0) / 100 | 0;
    return Gl(Iq(c, a), B(a, -100) + b | 0);
   }
   return xB(a, b);
  }
  if (b >>> 0 <= 99999) {
   c = a;
   a = (b >>> 0) / 1e4 | 0;
   return xB(Iq(c, a), B(a, -1e4) + b | 0);
  }
  return uB(a, b);
 }
 if (b >>> 0 <= 99999999) {
  if (b >>> 0 <= 9999999) {
   c = a;
   a = (b >>> 0) / 1e6 | 0;
   return uB(Iq(c, a), B(a, -1e6) + b | 0);
  }
  return Ru(a, b);
 }
 if (b >>> 0 <= 999999999) {
  c = a;
  a = (b >>> 0) / 1e8 | 0;
  return Ru(Iq(c, a), B(a, -1e8) + b | 0);
 }
 c = a;
 a = (b >>> 0) / 1e8 | 0;
 return Ru(Gl(c, a), B(a, -1e8) + b | 0);
}

function Q_(a, b, c, d) {
 var e = 0, f = 0, g = 0, h = 0;
 h = eb - 16 | 0;
 eb = h;
 g = v[a + 4 >> 2];
 e = (g - d | 0) + b | 0;
 f = Xo(h + 4 | 0, a, c - e | 0);
 d = v[f + 4 >> 2];
 a = e;
 while (1) {
  if (a >>> 0 >= c >>> 0) {
   hc(f);
   c = eb - 16 | 0;
   eb = c;
   a = eb - 32 | 0;
   eb = a;
   ed(a + 24 | 0, b, e);
   b = eb - 16 | 0;
   eb = b;
   d = v[a + 28 >> 2];
   e = v[a + 24 >> 2];
   f = d - e | 0;
   g = g - f | 0;
   v[b + 12 >> 2] = g;
   dC(g, e, f);
   pc(a + 16 | 0, d, b + 12 | 0);
   eb = b + 16 | 0;
   b = v[a + 16 >> 2];
   v[a + 12 >> 2] = v[a + 20 >> 2];
   pc(c + 8 | 0, b, a + 12 | 0);
   eb = a + 32 | 0;
   eb = c + 16 | 0;
   eb = h + 16 | 0;
  } else {
   po(d, w[a | 0]);
   d = d + 1 | 0;
   v[f + 4 >> 2] = d;
   a = a + 1 | 0;
   continue;
  }
  break;
 }
}

function kna(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0;
 b = eb - 16 | 0;
 eb = b;
 h = v[a + 16 >> 2];
 g = jg(1, 2);
 e = gb;
 i = e;
 Ob(a, g, e);
 j = v[a + 24 >> 2];
 k = v[a + 20 >> 2];
 f = v[a + 4 >> 2];
 e = v[a >> 2];
 v[b + 8 >> 2] = e;
 v[b + 12 >> 2] = f;
 l = v[a + 8 >> 2];
 m = v[a + 12 >> 2];
 while (1) {
  if (d) {
   f = ((((f & 2147483647) << 1 | e >>> 31) & 2147483646) << 1) + h | 0;
   e = u[f + 2 >> 1];
   v[c >> 2] = v[c >> 2] + B(u[f >> 1], k);
   v[c + 4 >> 2] = v[c + 4 >> 2] + B(e, j);
   Ob(b + 8 | 0, l, m);
   c = c + 8 | 0;
   d = d - 1 | 0;
   e = v[b + 8 >> 2];
   f = v[b + 12 >> 2];
   continue;
  }
  break;
 }
 v[a >> 2] = e;
 v[a + 4 >> 2] = f;
 Hg(a, g, i);
 eb = b + 16 | 0;
}

function zra(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0;
 c = eb - 32 | 0;
 eb = c;
 d = c + 12 | 0;
 f = Mb(d + 8 | 0);
 v[31601] = 0;
 e = Q(202, b | 0) | 0;
 g = v[31601];
 v[31601] = 0;
 a: {
  b: {
   if ((g | 0) == 1) {
    break b;
   }
   v[31601] = 0;
   R(169, d | 0, b | 0, e | 0);
   e = v[31601];
   v[31601] = 0;
   if ((e | 0) == 1) {
    break b;
   }
   e = v[d >> 2];
   v[31601] = 0;
   O(183, b | 0, e | 0) | 0;
   b = v[31601];
   v[31601] = 0;
   if ((b | 0) != 1) {
    break a;
   }
  }
  a = M() | 0;
  ec(f);
  P(a | 0);
  p();
 }
 Ln(c + 4 | 0, d);
 v[31601] = 0;
 R(475, a | 0, v[c + 4 >> 2], v[c + 8 >> 2]);
 a = v[31601];
 v[31601] = 0;
 if ((a | 0) != 1) {
  Jc(d);
  eb = c + 32 | 0;
  return;
 }
 a = M() | 0;
 Jc(c + 12 | 0);
 P(a | 0);
 p();
}

function yua(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0;
 d = eb - 16 | 0;
 eb = d;
 a: {
  b: {
   if (!ih(a, 7)) {
    break b;
   }
   c = 0;
   if (!OE(a, 18420)) {
    break a;
   }
   if (!ih(a, 1)) {
    break b;
   }
   c = -1;
   if (!hd(a, Kr(a))) {
    break a;
   }
   c = eb - 16 | 0;
   eb = c;
   f = d + 9 | 0;
   Jr(c + 8 | 0, f);
   e = v[c + 12 >> 2];
   pd(c, a, v[c + 8 >> 2], v[c + 12 >> 2]);
   g = v[c + 4 >> 2];
   if ((g | 0) == (e | 0)) {
    hd(a, v[c + 12 >> 2]);
   }
   eb = c + 16 | 0;
   e = (e | 0) == (g | 0);
   if (!e) {
    FE(f);
   }
   c = -1;
   if (!e) {
    break a;
   }
   c = 0;
   if (!w0(w[d + 9 | 0], w[d + 10 | 0])) {
    break a;
   }
   c = ve(a, b, v0(f), gb);
   break a;
  }
  c = -1;
 }
 eb = d + 16 | 0;
 return c | 0;
}

function h1(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0;
 e = eb - 16 | 0;
 eb = e;
 c = e + 12 | 0;
 f = eb - 16 | 0;
 eb = f;
 h = Dc(168);
 v[31601] = 0;
 g = O(36, f + 4 | 0, 22256) | 0;
 d = v[31601];
 v[31601] = 0;
 a: {
  b: {
   c: {
    if ((d | 0) != 1) {
     v[31601] = 0;
     d = T(37, h | 0, g | 0, 0) | 0;
     i = v[31601];
     v[31601] = 0;
     if ((i | 0) == 1) {
      break c;
     }
     sb(g);
     v[c >> 2] = d;
     nm(d);
     eb = f + 16 | 0;
     break a;
    }
    a = M() | 0;
    break b;
   }
   a = M() | 0;
   sb(g);
  }
  Bb(h);
  P(a | 0);
  p();
 }
 v[31601] = 0;
 R(27, a | 0, c | 0, b | 0);
 a = v[31601];
 v[31601] = 0;
 if ((a | 0) != 1) {
  Zb(c);
  eb = e + 16 | 0;
  return;
 }
 a = M() | 0;
 Zb(c);
 P(a | 0);
 p();
}

function Iha(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0;
 d = eb - 16 | 0;
 eb = d;
 e = d + 4 | 0;
 c = eb - 32 | 0;
 eb = c;
 f = c + 8 | 0;
 Tf(f, b);
 v[31601] = 0;
 b = c + 20 | 0;
 R(11, b | 0, 0, f | 0);
 g = v[31601];
 v[31601] = 0;
 a: {
  b: {
   c: {
    if ((g | 0) != 1) {
     v[31601] = 0;
     N(961, e | 0, b | 0);
     g = v[31601];
     v[31601] = 0;
     if ((g | 0) == 1) {
      break c;
     }
     Tb(b);
     sb(f);
     eb = c + 32 | 0;
     break a;
    }
    a = M() | 0;
    break b;
   }
   a = M() | 0;
   Tb(c + 20 | 0);
  }
  sb(c + 8 | 0);
  P(a | 0);
  p();
 }
 v[31601] = 0;
 O(959, a | 0, e | 0) | 0;
 a = v[31601];
 v[31601] = 0;
 if ((a | 0) != 1) {
  sb(e);
  eb = d + 16 | 0;
  return;
 }
 a = M() | 0;
 sb(d + 4 | 0);
 P(a | 0);
 p();
}

function ZQ(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0;
 d = v[a >> 2];
 c = nc(d, v[a + 4 >> 2]);
 if (c >>> 0 <= 127) {
  f = eb - 32 | 0;
  eb = f;
  c = 128 - c | 0;
  e = v[zb(a) >> 2];
  d = v[a + 4 >> 2];
  a: {
   if (c >>> 0 <= e - d >> 2 >>> 0) {
    pA(a, c, b);
    break a;
   }
   e = zb(a);
   d = Yf(f + 12 | 0, Kf(a, nc(v[a >> 2], d) + c | 0), nc(v[a >> 2], v[a + 4 >> 2]), e);
   g = eb - 16 | 0;
   eb = g;
   c = En(g + 4 | 0, d + 8 | 0, c);
   e = v[c >> 2];
   while (1) {
    if (v[c + 4 >> 2] != (e | 0)) {
     sk(e, z[b >> 2]);
     e = v[c >> 2] + 4 | 0;
     v[c >> 2] = e;
     continue;
    }
    break;
   }
   ie(c);
   eb = g + 16 | 0;
   oA(a, d);
   Xf(d);
  }
  eb = f + 32 | 0;
  return;
 }
 if ((c | 0) != 128) {
  Id(a, d + 512 | 0);
 }
}

function lna(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0, m = 0;
 b = eb - 16 | 0;
 eb = b;
 h = v[a + 16 >> 2];
 g = jg(1, 2);
 e = gb;
 i = e;
 Ob(a, g, e);
 j = v[a + 24 >> 2];
 k = v[a + 20 >> 2];
 f = v[a + 4 >> 2];
 e = v[a >> 2];
 v[b + 8 >> 2] = e;
 v[b + 12 >> 2] = f;
 l = v[a + 8 >> 2];
 m = v[a + 12 >> 2];
 while (1) {
  if (d) {
   f = (((f & 2147483647) << 1 | e >>> 31) & -2) + h | 0;
   e = t[f + 1 | 0];
   v[c >> 2] = v[c >> 2] + (B(t[f | 0], k) << 8);
   v[c + 4 >> 2] = v[c + 4 >> 2] + (B(e, j) << 8);
   Ob(b + 8 | 0, l, m);
   c = c + 8 | 0;
   d = d - 1 | 0;
   e = v[b + 8 >> 2];
   f = v[b + 12 >> 2];
   continue;
  }
  break;
 }
 v[a >> 2] = e;
 v[a + 4 >> 2] = f;
 Hg(a, g, i);
 eb = b + 16 | 0;
}

function Yoa(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0;
 e = eb - 32 | 0;
 eb = e;
 md(b, 0);
 d = e + 8 | 0;
 SD(d, a + 1 | 0);
 c = e + 20 | 0;
 Bc(c, d);
 Ae(b + 43 | 0, c);
 sb(c);
 v[b + 24 >> 2] = w[a + 73 | 0] | w[a + 74 | 0] << 8 | (w[a + 75 | 0] << 16 | w[a + 76 | 0] << 24);
 c = w[a + 54 | 0] | w[a + 55 | 0] << 8 | (w[a + 56 | 0] << 16 | w[a + 57 | 0] << 24);
 v[b >> 2] = c;
 v[b + 4 >> 2] = w[a + 58 | 0] | w[a + 59 | 0] << 8 | (w[a + 60 | 0] << 16 | w[a + 61 | 0] << 24);
 d = w[a + 62 | 0] | w[a + 63 | 0] << 8 | (w[a + 64 | 0] << 16 | w[a + 65 | 0] << 24);
 if (d) {
  v[b + 8 >> 2] = d + 1;
 }
 u[b + 30 >> 1] = (w[a + 68 | 0] << 1) + 2;
 u[b + 34 >> 1] = x[b + 34 >> 1] & 65533 | w[a | 0] >>> 6 & 2;
 wc(b + 8 | 0, c);
 wc(b + 4 | 0, v[b + 8 >> 2]);
 eb = e + 32 | 0;
}

function HH(a, b, c, d, e) {
 var f = 0, g = 0, h = 0, i = 0;
 f = eb + -64 | 0;
 eb = f;
 t[f + 60 | 0] = 0;
 t[f + 61 | 0] = 0;
 t[f + 62 | 0] = 0;
 t[f + 63 | 0] = 0;
 t[f + 57 | 0] = 0;
 t[f + 58 | 0] = 0;
 t[f + 59 | 0] = 0;
 t[f + 60 | 0] = 0;
 t[f + 56 | 0] = 37;
 st(f + 57 | 0, 10783, e, v[b + 4 >> 2]);
 e = Nd();
 v[f >> 2] = d;
 d = f + 43 | 0;
 e = oh(d, 13, e, f + 56 | 0, f) + d | 0;
 h = ij(d, e, v[b + 4 >> 2]);
 g = f + 4 | 0;
 bd(g, v[b + 28 >> 2]);
 v[31601] = 0;
 i = d;
 d = f + 16 | 0;
 fa(1264, i | 0, h | 0, e | 0, d | 0, f + 12 | 0, f + 8 | 0, g | 0);
 e = v[31601];
 v[31601] = 0;
 a: {
  if ((e | 0) != 1) {
   Zb(g);
   a = tw(a, d, v[f + 12 >> 2], v[f + 8 >> 2], b, c);
   eb = f - -64 | 0;
   break a;
  }
  a = M() | 0;
  Zb(f + 4 | 0);
  P(a | 0);
  p();
 }
 return a;
}

function dm(a) {
 var b = 0, c = 0;
 a: {
  b = v[a + 4 >> 2];
  b = v[v[b >> 2] - 12 >> 2] + b | 0;
  b: {
   if (!v[b + 24 >> 2] | v[b + 16 >> 2] | !(w[b + 5 | 0] & 32)) {
    break b;
   }
   if ((cb() | 0) > 0) {
    break b;
   }
   b = v[a + 4 >> 2];
   b = v[(v[v[b >> 2] - 12 >> 2] + b | 0) + 24 >> 2];
   v[31601] = 0;
   b = Q(31, b | 0) | 0;
   c = v[31601];
   v[31601] = 0;
   if ((c | 0) != 1) {
    if ((b | 0) != -1) {
     break b;
    }
    a = v[a + 4 >> 2];
    b = v[v[a >> 2] - 12 >> 2];
    v[31601] = 0;
    N(24, a + b | 0, 1);
    a = v[31601];
    v[31601] = 0;
    if ((a | 0) != 1) {
     break b;
    }
   }
   X(S(0) | 0) | 0;
   v[31601] = 0;
   W(26);
   a = v[31601];
   v[31601] = 0;
   if ((a | 0) == 1) {
    break a;
   }
  }
  return;
 }
 S(0) | 0;
 Rb();
 p();
}

function qV(a, b, c, d) {
 var e = 0, f = 0, g = 0;
 a: {
  b: {
   if (!((c | 0) == 255 | (b | 0) != 11)) {
    e = c + 1 | 0;
    f = 11;
    break b;
   }
   if ((b & 254) == 16) {
    e = c & 15 | b << 4 | -128;
    f = 14;
    break b;
   }
   if ((b | 0) == 18) {
    break b;
   }
   e = c;
   f = b;
   if (b >>> 0 > 18) {
    break a;
   }
  }
  Bf(a, f, e & 255);
  b = w[a + 3 | 0];
  c: {
   d: {
    if (!((d | 0) != 4 | (b | 0) != 13)) {
     b = w[a + 5 | 0];
     if (b & 3 ? (b | 0) != 255 : 0) {
      break d;
     }
     t[a + 5 | 0] = b + 3 >>> 2;
     return 1;
    }
    if ((b & 255) != 13) {
     break c;
    }
   }
   b = 46;
   t[a + 3 | 0] = 46;
  }
  g = 1;
  if ((d | 0) == 4 | (b & 255) != 17 | w[a + 5 | 0] != 32) {
   break a;
  }
  t[a + 3 | 0] = 16;
 }
 return g;
}

function cS(a) {
 var b = 0, c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0;
 g = v[a + 104 >> 2];
 d = (g << 3) + a | 0;
 b = ((g + 7 >>> 0) % 12 << 3) + a | 0;
 f = v[b >> 2];
 e = v[b + 4 >> 2];
 b = v[a + 100 >> 2];
 j = b;
 h = v[a + 96 >> 2];
 a: {
  if (!(b | h)) {
   c = v[d + 4 >> 2];
   b = v[d >> 2];
   i = (c | 0) == (e | 0) & b >>> 0 > f >>> 0 | e >>> 0 < c >>> 0;
   break a;
  }
  c = v[d + 4 >> 2];
  b = v[d >> 2];
  i = !(e | f) | ((c | 0) == (e | 0) & b >>> 0 >= f >>> 0 | e >>> 0 < c >>> 0);
 }
 c = c + j | 0;
 b = b + h | 0;
 c = b >>> 0 < h >>> 0 ? c + 1 | 0 : c;
 v[d >> 2] = f - b;
 v[d + 4 >> 2] = e - (c + (b >>> 0 > f >>> 0) | 0) & 65535;
 v[a + 104 >> 2] = (g + 1 >>> 0) % 12;
 v[a + 96 >> 2] = i;
 v[a + 100 >> 2] = 0;
 gb = v[d + 4 >> 2];
 return v[d >> 2];
}

function BA(a, b, c, d) {
 var e = 0, f = 0, g = 0, h = 0;
 e = eb - 48 | 0;
 eb = e;
 a: {
  if (!c) {
   b = Xd(v[a >> 2], b);
   a = v[d + 12 >> 2];
   v[b + 8 >> 2] = v[d + 8 >> 2];
   v[b + 12 >> 2] = a;
   a = v[d + 4 >> 2];
   v[b >> 2] = v[d >> 2];
   v[b + 4 >> 2] = a;
   break a;
  }
  f = v[d + 12 >> 2];
  v[e + 24 >> 2] = v[d + 8 >> 2];
  v[e + 28 >> 2] = f;
  f = v[d + 4 >> 2];
  v[e + 16 >> 2] = v[d >> 2];
  v[e + 20 >> 2] = f;
  f = c >>> 1 | 0;
  BA(a, b, f, e + 16 | 0);
  g = A[d >> 3];
  h = A[d + 8 >> 3];
  d = Xd(v[a >> 2], c);
  Ki(e + 32 | 0, g, h, A[d >> 3], A[d + 8 >> 3]);
  d = v[e + 44 >> 2];
  v[e + 8 >> 2] = v[e + 40 >> 2];
  v[e + 12 >> 2] = d;
  d = v[e + 36 >> 2];
  v[e >> 2] = v[e + 32 >> 2];
  v[e + 4 >> 2] = d;
  BA(a, b | c, f, e);
 }
 eb = e + 48 | 0;
}

function ml(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0;
 e = eb - 16 | 0;
 eb = e;
 v[b >> 2] = 0;
 v[b + 4 >> 2] = 0;
 t[e + 15 | 0] = 0;
 fi(a, e + 15 | 0);
 c = w[e + 15 | 0];
 f = (c & 252) >>> 2 | 0;
 i = -1 << (c & 3) ^ -1;
 while (1) {
  v[b >> 2] = f;
  v[b + 4 >> 2] = d;
  if (!h & (g | 0) == (i | 0)) {
   eb = e + 16 | 0;
  } else {
   t[e + 15 | 0] = 0;
   fi(a, e + 15 | 0);
   d = v[b >> 2];
   j = v[b + 4 >> 2];
   f = w[e + 15 | 0];
   c = h;
   g = g + 1 | 0;
   h = g ? c : c + 1 | 0;
   k = d;
   c = (g << 3) - 2 | 0;
   d = c & 31;
   if ((c & 63) >>> 0 >= 32) {
    c = f << d;
    d = 0;
   } else {
    c = (1 << d) - 1 & f >>> 32 - d;
    d = f << d;
   }
   f = k | d;
   d = c | j;
   continue;
  }
  break;
 }
}

function tx(a) {
 var b = 0, c = 0, d = 0;
 if (y[a + 4 >> 2] < y[zb(a) >> 2]) {
  b = eb - 16 | 0;
  eb = b;
  a = nG(b + 4 | 0, a);
  c = v[a + 4 >> 2];
  v[31601] = 0;
  V(164, c | 0);
  c = v[31601];
  v[31601] = 0;
  a: {
   if ((c | 0) != 1) {
    v[a + 4 >> 2] = v[a + 4 >> 2] + 36;
    hc(a);
    eb = b + 16 | 0;
    break a;
   }
   b = M() | 0;
   hc(a);
   P(b | 0);
   p();
  }
  return;
 }
 c = eb - 32 | 0;
 eb = c;
 b = zb(a);
 b = lG(c + 12 | 0, mG(a, fs(v[a >> 2], v[a + 4 >> 2]) + 1 | 0), fs(v[a >> 2], v[a + 4 >> 2]), b);
 d = v[b + 8 >> 2];
 v[31601] = 0;
 V(164, d | 0);
 d = v[31601];
 v[31601] = 0;
 b: {
  if ((d | 0) != 1) {
   v[b + 8 >> 2] = v[b + 8 >> 2] + 36;
   kG(a, b);
   ix(b);
   eb = c + 32 | 0;
   break b;
  }
  a = M() | 0;
  ix(b);
  P(a | 0);
  p();
 }
}

function Y0(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0;
 d = eb - 32 | 0;
 eb = d;
 md(b, 0);
 e = d + 8 | 0;
 ck(e, 1, a + 33 | 0);
 c = d + 20 | 0;
 Bc(c, e);
 Ae(b + 43 | 0, c);
 sb(c);
 f = w[a + 50 | 0] | w[a + 51 | 0] << 8;
 v[b >> 2] = f;
 v[b + 24 >> 2] = w[a + 52 | 0] | w[a + 53 | 0] << 8;
 t[d + 20 | 0] = w[a + 54 | 0];
 t[d + 8 | 0] = 64;
 g = b, h = w[Pb(c, e) | 0] << 2, u[g + 30 >> 1] = h;
 e = w[a + 55 | 0] | w[a + 56 | 0] << 8;
 v[b + 4 >> 2] = e;
 c = w[a + 57 | 0] | w[a + 58 | 0] << 8;
 v[b + 8 >> 2] = c;
 a: {
  if ((c | 0) == 65535) {
   v[b + 4 >> 2] = 0;
   v[b + 8 >> 2] = 0;
   break a;
  }
  if (!w[a | 0] | c >>> 0 <= e + 2 >>> 0 | c >>> 0 > f >>> 0) {
   break a;
  }
  u[b + 34 >> 1] = x[b + 34 >> 1] | 2;
 }
 eb = d + 32 | 0;
}

function hS(a, b) {
 var c = 0, d = 0, e = 0, f = 0;
 c = v[a >> 2];
 v[a >> 2] = b;
 if (c) {
  b = eb - 16 | 0;
  eb = b;
  d = vb(v[c >> 2]);
  v[b + 12 >> 2] = d;
  f = vb(v[c + 4 >> 2]);
  while (1) {
   a: {
    b: {
     if (Hb(d, f)) {
      while (1) {
       a = v[d >> 2];
       e = v[a >> 2];
       if (!e) {
        break b;
       }
       nQ(a, e);
       a = v[v[e >> 2] + 8 >> 2];
       v[31601] = 0;
       V(a | 0, e | 0);
       a = v[31601];
       v[31601] = 0;
       if ((a | 0) != 1) {
        continue;
       }
       break;
      }
      S(0) | 0;
      Rb();
      p();
     }
     a = uc(c);
     eb = b + 16 | 0;
     break a;
    }
    Db(a + 20 | 0);
    Db(a + 8 | 0);
    Bb(a);
    d = v[Xe(b + 12 | 0) >> 2];
    continue;
   }
   break;
  }
  Bb(a);
 }
}

function ZE(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0;
 d = v[a >> 2];
 c = _c(d, v[a + 4 >> 2]);
 if (c >>> 0 < b >>> 0) {
  e = eb - 32 | 0;
  eb = e;
  b = b - c | 0;
  c = v[zb(a) >> 2];
  d = v[a + 4 >> 2];
  a: {
   if (b >>> 0 <= c - d >> 1 >>> 0) {
    QE(a, b);
    break a;
   }
   c = zb(a);
   c = dk(e + 12 | 0, ek(a, _c(v[a >> 2], d) + b | 0), _c(v[a >> 2], v[a + 4 >> 2]), c);
   f = eb - 16 | 0;
   eb = f;
   b = Bp(f + 4 | 0, c + 8 | 0, b);
   d = v[b >> 2];
   while (1) {
    if (v[b + 4 >> 2] != (d | 0)) {
     _w(d);
     d = v[b >> 2] + 2 | 0;
     v[b >> 2] = d;
     continue;
    }
    break;
   }
   ie(b);
   eb = f + 16 | 0;
   Ur(a, c);
   $i(c);
  }
  eb = e + 32 | 0;
  return;
 }
 if (b >>> 0 < c >>> 0) {
  Id(a, d + (b << 1) | 0);
 }
}

function S8(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0;
 d = eb - 32 | 0;
 eb = d;
 v[d + 16 >> 2] = b;
 e = v[a + 48 >> 2];
 v[d + 20 >> 2] = c - ((e | 0) != 0);
 g = v[a + 44 >> 2];
 v[d + 28 >> 2] = e;
 v[d + 24 >> 2] = g;
 a: {
  b: {
   if ($y(bb(v[a + 60 >> 2], d + 16 | 0, 2, d + 12 | 0) | 0)) {
    b = 32;
   } else {
    e = v[d + 12 >> 2];
    if ((e | 0) > 0) {
     break b;
    }
    b = e ? 32 : 16;
   }
   v[a >> 2] = b | v[a >> 2];
   break a;
  }
  f = e;
  g = v[d + 20 >> 2];
  if (g >>> 0 >= e >>> 0) {
   break a;
  }
  f = v[a + 44 >> 2];
  v[a + 4 >> 2] = f;
  v[a + 8 >> 2] = f + (e - g | 0);
  if (v[a + 48 >> 2]) {
   v[a + 4 >> 2] = f + 1;
   t[(b + c | 0) - 1 | 0] = w[f | 0];
  }
  f = c;
 }
 eb = d + 32 | 0;
 return f | 0;
}

function It(a, b) {
 a: {
  if (a) {
   if (b >>> 0 <= 127) {
    break a;
   }
   b: {
    if (!v[v[124107] >> 2]) {
     if ((b & -128) == 57216) {
      break a;
     }
     break b;
    }
    if (b >>> 0 <= 2047) {
     t[a + 1 | 0] = b & 63 | 128;
     t[a | 0] = b >>> 6 | 192;
     return 2;
    }
    if (!((b & -8192) != 57344 & b >>> 0 >= 55296)) {
     t[a + 2 | 0] = b & 63 | 128;
     t[a | 0] = b >>> 12 | 224;
     t[a + 1 | 0] = b >>> 6 & 63 | 128;
     return 3;
    }
    if (b - 65536 >>> 0 <= 1048575) {
     t[a + 3 | 0] = b & 63 | 128;
     t[a | 0] = b >>> 18 | 240;
     t[a + 2 | 0] = b >>> 6 & 63 | 128;
     t[a + 1 | 0] = b >>> 12 & 63 | 128;
     return 4;
    }
   }
   v[31476] = 25;
   a = -1;
  } else {
   a = 1;
  }
  return a;
 }
 t[a | 0] = b;
 return 1;
}

function sla(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0;
 e = v[a >> 2];
 d = Lg(e, v[a + 4 >> 2]);
 if (d >>> 0 < b >>> 0) {
  e = eb - 32 | 0;
  eb = e;
  a: {
   b: {
    d = b - d | 0;
    b = v[zb(a) >> 2];
    f = v[a + 4 >> 2];
    c: {
     if (d >>> 0 <= b - f >> 5 >>> 0) {
      _B(a, d, c);
      break c;
     }
     b = zb(a);
     b = jv(e + 12 | 0, Wq(a, Lg(v[a >> 2], f) + d | 0), Lg(v[a >> 2], v[a + 4 >> 2]), b);
     v[31601] = 0;
     R(784, b | 0, d | 0, c | 0);
     c = v[31601];
     v[31601] = 0;
     if ((c | 0) == 1) {
      break b;
     }
     KU(a, b);
     ZB(b);
    }
    eb = e + 32 | 0;
    break a;
   }
   a = M() | 0;
   ZB(b);
   P(a | 0);
   p();
  }
  return;
 }
 if (b >>> 0 < d >>> 0) {
  LU(a, e + (b << 5) | 0);
 }
}

function PR(a, b) {
 var c = 0, d = 0, e = 0, f = 0;
 c = eb - 32 | 0;
 eb = c;
 a: {
  f = b - 1 & 65535;
  if (f >>> 0 > 3998) {
   break a;
  }
  b = B(b, 104) + a | 0;
  d = b + 484380 | 0;
  if (!ke(v[d >> 2], v[b + 484400 >> 2])) {
   break a;
  }
  b = 1074992;
  while (1) {
   if ((b | 0) == 1298224) {
    mn(d);
    v[d >> 2] = 0;
    u[d + 34 >> 1] = x[d + 34 >> 1] & 65470;
    v[c + 24 >> 2] = 0;
    v[c + 8 >> 2] = 0;
    v[c + 16 >> 2] = 0;
    v[c + 20 >> 2] = 0;
    v[c >> 2] = 0;
    v[c + 4 >> 2] = 0;
    Qk(d, 0, c);
    break a;
   }
   e = a + b | 0;
   if (v[e + 104 >> 2] == (d | 0)) {
    v[e + 76 >> 2] = 0;
    v[e >> 2] = 0;
    v[e + 4 >> 2] = 0;
    v[e + 16 >> 2] = 0;
   }
   b = b + 872 | 0;
   continue;
  }
 }
 eb = c + 32 | 0;
 return f >>> 0 < 3999;
}

function jc(a) {
 var b = 0, c = 0, d = 0, e = 0, f = 0, g = 0, h = 0;
 a: {
  d = gl(a);
  a = d;
  if (a >>> 0 < 502224 & a >>> 0 >= 501712) {
   b = a - 4 | 0;
   e = v[125424];
   c = e;
   while (1) {
    a = c;
    if (!(!a | (a | 0) == 502224)) {
     if ((jI(a) | 0) == (b | 0)) {
      u[a + 2 >> 1] = x[d - 2 >> 1] + x[a + 2 >> 1];
      break a;
     }
     if ((jI(b) | 0) == (a | 0)) {
      c = d - 2 | 0;
      u[c >> 1] = x[a + 2 >> 1] + x[c >> 1];
      if (!f) {
       v[125424] = b;
       u[b >> 1] = x[a >> 1];
       break a;
      }
      g = f, h = Xx(b), u[g >> 1] = h;
      break a;
     } else {
      c = Yx(x[a >> 1]);
      f = a;
      continue;
     }
    }
    break;
   }
   g = b, h = Xx(e), u[g >> 1] = h;
   v[125424] = b;
   break a;
  }
  Bb(d);
 }
}

function Jsa(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0;
 d = eb - 16 | 0;
 eb = d;
 v[a >> 2] = 0;
 v[a + 4 >> 2] = 0;
 sc(a + 8 | 0);
 Qd(d + 8 | 0, v[ub(d + 4 | 0, a) >> 2]);
 a: {
  if (b) {
   v[31601] = 0;
   N(374, a | 0, b | 0);
   e = v[31601];
   v[31601] = 0;
   if ((e | 0) == 1) {
    break a;
   }
   f = eb - 16 | 0;
   eb = f;
   e = aj(f + 4 | 0, a, b);
   b = v[e + 4 >> 2];
   g = v[e + 8 >> 2];
   while (1) {
    if ((b | 0) == (g | 0)) {
     hc(e);
     eb = f + 16 | 0;
    } else {
     _i(b, w[c | 0] | w[c + 1 | 0] << 8);
     b = b + 2 | 0;
     v[e + 4 >> 2] = b;
     continue;
    }
    break;
   }
  }
  b = d + 8 | 0;
  Pd(b);
  Rj(b);
  eb = d + 16 | 0;
  return a | 0;
 }
 a = M() | 0;
 Rj(d + 8 | 0);
 P(a | 0);
 p();
}

function zF(a) {
 var b = 0, c = 0, d = 0, e = 0, f = 0;
 a: {
  if ((w[a | 0] | w[a + 1 | 0] << 8) != 26215 | (w[a + 514 | 0] - 16 & 255) >>> 0 < 241 | w[a + 515 | 0] > 128) {
   break a;
  }
  b = 2;
  while (1) {
   if ((b | 0) == 514) {
    c = 516;
    b = -1;
    while (1) {
     f = (c | 0) == 772;
     if (f) {
      break a;
     }
     d = b;
     b = a + c | 0;
     b = w[b | 0] | w[b + 1 | 0] << 8;
     e = (d | 0) < (b | 0);
     c = c + 2 | 0;
     if (e) {
      continue;
     }
     break;
    }
    break a;
   }
   c = a + b | 0;
   e = zb(c);
   while (1) {
    if ((c | 0) != (e | 0)) {
     d = w[c | 0];
     c = c + 1 | 0;
     if (d >>> 0 > 31) {
      continue;
     }
     break a;
    }
    break;
   }
   b = b + 8 | 0;
   continue;
  }
 }
 return f;
}

function iea(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = C(0);
 v[31601] = 0;
 V(995, a | 0);
 d = v[31601];
 v[31601] = 0;
 a: {
  if ((d | 0) == 1) {
   break a;
  }
  v[31601] = 0;
  V(1067, c | 0);
  d = v[31601];
  v[31601] = 0;
  if ((d | 0) == 1) {
   break a;
  }
  d = v[a + 24 >> 2];
  e = z[d + 48 >> 2];
  d = v[d + 24 >> 2];
  v[31601] = 0;
  b = Xa(1068, d | 0, C(e), b | 0) | 0;
  d = v[31601];
  v[31601] = 0;
  if ((d | 0) == 1) {
   break a;
  }
  v[c >> 2] = b;
  return 1;
 }
 X(S(0) | 0) | 0;
 v[31601] = 0;
 U(982, 10353, a | 0, 0, 0);
 a = v[31601];
 v[31601] = 0;
 if ((a | 0) != 1) {
  Y();
  return 0;
 }
 a = M() | 0;
 v[31601] = 0;
 W(26);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  P(a | 0);
  p();
 }
 S(0) | 0;
 Rb();
 p();
}

function t7(a, b, c, d, e, f, g) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 f = f | 0;
 g = g | 0;
 var h = 0, i = 0;
 c = eb - 128 | 0;
 eb = c;
 v[c + 12 >> 2] = c + 116;
 d = c + 16 | 0;
 dK(v[a + 8 >> 2], d, c + 12 | 0, e, f, g);
 f = eb - 16 | 0;
 eb = f;
 h = f + 8 | 0;
 a = eb - 32 | 0;
 eb = a;
 ed(a + 24 | 0, d, v[c + 12 >> 2]);
 i = a + 16 | 0;
 e = v[a + 24 >> 2];
 g = v[a + 28 >> 2];
 d = eb - 16 | 0;
 eb = d;
 v[d + 12 >> 2] = b;
 while (1) {
  if ((e | 0) != (g | 0)) {
   cL(d + 12 | 0, t[e | 0]);
   e = e + 1 | 0;
   continue;
  }
  break;
 }
 pc(i, g, d + 12 | 0);
 eb = d + 16 | 0;
 b = v[a + 16 >> 2];
 v[a + 12 >> 2] = v[a + 20 >> 2];
 pc(h, b, a + 12 | 0);
 eb = a + 32 | 0;
 eb = f + 16 | 0;
 eb = c + 128 | 0;
 return v[f + 12 >> 2];
}

function V3(a, b, c, d, e) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 var f = 0, g = 0;
 f = eb - 32 | 0;
 eb = f;
 g = eq(f + 20 | 0, b, c);
 v[31601] = 0;
 e = T(1384, f + 8 | 0, d | 0, e | 0) | 0;
 a = v[31601];
 v[31601] = 0;
 if ((a | 0) != 1) {
  c = Jb(g);
  d = Jb(e);
  a = v[d >> 2];
  b = v[c >> 2];
  a: {
   if (!a | !b | (a | 0) != (b | 0)) {
    break a;
   }
   while (1) {
    a = v[d + 4 >> 2];
    b = v[c + 4 >> 2];
    if (!a | !b) {
     break a;
    }
    d = d + 4 | 0;
    c = c + 4 | 0;
    if ((a | 0) == (b | 0)) {
     continue;
    }
    break;
   }
  }
  Tb(e);
  Tb(g);
  eb = f + 32 | 0;
  a = (a | 0) > (b | 0) ? -1 : (a | 0) < (b | 0);
  return ((a | 0) < 0 ? -1 : (a | 0) != 0) | 0;
 }
 a = M() | 0;
 Tb(g);
 P(a | 0);
 p();
}

function Qj(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0;
 d = v[a >> 2];
 c = Sc(d, v[a + 4 >> 2]);
 if (c >>> 0 < b >>> 0) {
  e = eb - 32 | 0;
  eb = e;
  b = b - c | 0;
  c = v[zb(a) >> 2];
  d = v[a + 4 >> 2];
  a: {
   if (b >>> 0 <= c - d >>> 0) {
    KX(a, b);
    break a;
   }
   c = zb(a);
   c = on(e + 12 | 0, Tl(a, Sc(v[a >> 2], d) + b | 0), Sc(v[a >> 2], v[a + 4 >> 2]), c);
   f = eb - 16 | 0;
   eb = f;
   b = CC(f + 4 | 0, c + 8 | 0, b);
   d = v[b >> 2];
   while (1) {
    if (v[b + 4 >> 2] != (d | 0)) {
     oX(d);
     d = v[b >> 2] + 1 | 0;
     v[b >> 2] = d;
     continue;
    }
    break;
   }
   ie(b);
   eb = f + 16 | 0;
   cr(a, c);
   nn(c);
  }
  eb = e + 32 | 0;
  return;
 }
 if (b >>> 0 < c >>> 0) {
  Id(a, b + d | 0);
 }
}

function ara(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0;
 d = vb(v[b >> 2]);
 h = vb(v[b + 4 >> 2]);
 g = eb - 16 | 0;
 eb = g;
 v[g + 12 >> 2] = d;
 while (1) {
  a: {
   if (!Hb(d, h)) {
    break a;
   }
   e = eb - 16 | 0;
   eb = e;
   f = w[d | 0] | w[d + 1 | 0] << 8 | (w[d + 2 | 0] << 16 | w[d + 3 | 0] << 24);
   t[e + 10 | 0] = f;
   t[e + 11 | 0] = f >>> 8;
   t[e + 12 | 0] = f >>> 16;
   t[e + 13 | 0] = f >>> 24;
   f = w[d + 4 | 0] | w[d + 5 | 0] << 8;
   t[e + 14 | 0] = f;
   t[e + 15 | 0] = f >>> 8;
   eb = e + 16 | 0;
   if (x[e + 10 >> 1] == (c | 0)) {
    break a;
   }
   d = v[bm(g + 12 | 0) >> 2];
   continue;
  }
  break;
 }
 eb = g + 16 | 0;
 if (lc(d, vb(v[b + 4 >> 2]))) {
  Xh(a);
  return;
 }
 mp(a, d);
}

function jO(a, b) {
 var c = 0;
 a: {
  b: {
   if ((a ^ b) & 3) {
    c = w[b | 0];
    break b;
   }
   if (b & 3) {
    while (1) {
     c = w[b | 0];
     t[a | 0] = c;
     if (!c) {
      break a;
     }
     a = a + 1 | 0;
     b = b + 1 | 0;
     if (b & 3) {
      continue;
     }
     break;
    }
   }
   c = v[b >> 2];
   if ((c ^ -1) & c - 16843009 & -2139062144) {
    break b;
   }
   while (1) {
    v[a >> 2] = c;
    c = v[b + 4 >> 2];
    a = a + 4 | 0;
    b = b + 4 | 0;
    if (!(c - 16843009 & (c ^ -1) & -2139062144)) {
     continue;
    }
    break;
   }
  }
  t[a | 0] = c;
  if (!(c & 255)) {
   break a;
  }
  while (1) {
   c = w[b + 1 | 0];
   t[a + 1 | 0] = c;
   a = a + 1 | 0;
   b = b + 1 | 0;
   if (c) {
    continue;
   }
   break;
  }
 }
}

function e9(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0;
 e = eb - 16 | 0;
 eb = e;
 while (1) {
  a: {
   if ((c | 0) <= (g | 0)) {
    break a;
   }
   d = v[a + 12 >> 2];
   f = v[a + 16 >> 2];
   b: {
    if (d >>> 0 < f >>> 0) {
     v[e + 12 >> 2] = 2147483647;
     v[e + 8 >> 2] = f - d >> 2;
     v[e + 4 >> 2] = c - g;
     f = d;
     d = v[Bd(e + 12 | 0, Bd(e + 8 | 0, e + 4 | 0)) >> 2];
     b = Qi(b, f, d);
     f = d << 2;
     v[a + 12 >> 2] = f + v[a + 12 >> 2];
     b = b + f | 0;
     break b;
    }
    d = hb[v[v[a >> 2] + 40 >> 2]](a) | 0;
    if ((d | 0) == -1) {
     break a;
    }
    v[b >> 2] = d;
    d = 1;
    b = b + 4 | 0;
   }
   g = d + g | 0;
   continue;
  }
  break;
 }
 eb = e + 16 | 0;
 return g | 0;
}

function zha(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0;
 b = eb - 16 | 0;
 eb = b;
 d = v[a + 20 >> 2];
 c = v[d + 4 >> 2];
 a: {
  if (!((Sc(c, v[d + 8 >> 2]) | 0) != 7 | (w[c | 0] | w[c + 1 | 0] << 8 | (w[c + 2 | 0] << 16 | w[c + 3 | 0] << 24)) != 1869112133)) {
   d = vb(c);
   g = vb(v[v[a + 20 >> 2] + 8 >> 2]);
   Jr(b + 8 | 0, a + 4228 | 0);
   f = vb(v[b + 8 >> 2]);
   e = eb - 16 | 0;
   eb = e;
   c = eb - 32 | 0;
   eb = c;
   ed(c + 24 | 0, d, g);
   dv(c + 16 | 0, v[c + 24 >> 2], v[c + 28 >> 2], f);
   d = N_(d, v[c + 16 >> 2]);
   h = c, i = $D(f, v[c + 20 >> 2]), v[h + 12 >> 2] = i;
   pc(e + 8 | 0, d, c + 12 | 0);
   eb = c + 32 | 0;
   eb = e + 16 | 0;
   break a;
  }
  cA(a, a);
 }
 nu(a);
 eb = b + 16 | 0;
}

function ooa(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0;
 d = eb - 4096 | 0;
 eb = d;
 hn(a, b);
 while (1) {
  if (Sc(v[a >> 2], v[a + 4 >> 2]) >>> 12 >>> 0 > f >>> 0) {
   g = f << 12;
   b = 0;
   c = 0;
   e = 0;
   while (1) {
    if ((c | 0) != 2048) {
     h = wb(v[a >> 2], c | g);
     i = wb(d, c << 1 | 1);
     e = w[h | 0] + e | 0;
     t[i | 0] = e;
     c = c + 1 | 0;
     continue;
    }
    break;
   }
   while (1) {
    if ((b | 0) != 2048) {
     c = wb(v[a >> 2], b | g | 2048);
     h = wb(d, b << 1);
     e = w[c | 0] + e | 0;
     t[h | 0] = e;
     b = b + 1 | 0;
     continue;
    }
    break;
   }
   sv(d, xC(d), Pe(vb(v[a >> 2]), g));
   f = f + 1 | 0;
   continue;
  }
  break;
 }
 eb = d + 4096 | 0;
}

function nI(a, b, c, d, e, f, g, h) {
 var i = 0, j = 0, k = 0;
 i = eb - 16 | 0;
 eb = i;
 if (1073741806 - b >>> 0 >= c >>> 0) {
  k = Jb(a);
  j = i + 4 | 0;
  if (b >>> 0 <= 536870886) {
   v[i + 12 >> 2] = b << 1;
   v[i + 4 >> 2] = b + c;
   c = rn(v[ad(j, i + 12 | 0) >> 2]) + 1 | 0;
  } else {
   c = 1073741807;
  }
  Mj(j, c);
  c = v[i + 4 >> 2];
  if (e) {
   Qi(c, k, e);
  }
  if (g) {
   Qi(c + (e << 2) | 0, h, g);
  }
  j = e + f | 0;
  h = d - j | 0;
  if ((d | 0) != (j | 0)) {
   d = e << 2;
   Qi((d + c | 0) + (g << 2) | 0, (d + k | 0) + (f << 2) | 0, h);
  }
  if ((b | 0) != 1) {
   Bb(k);
  }
  xd(a, c);
  of(a, v[i + 8 >> 2]);
  b = a;
  a = h + (e + g | 0) | 0;
  Ad(b, a);
  xd(c + (a << 2) | 0, 0);
  eb = i + 16 | 0;
  return;
 }
 pf();
 p();
}

function xO(a, b, c, d, e, f, g) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 f = f | 0;
 g = g | 0;
 var h = 0;
 h = eb - 16 | 0;
 eb = h;
 a: {
  b: {
   c: {
    if (g ? !f | (!d | !e) : 1) {
     a = cc(8);
     v[31601] = 0;
     b = O(36, h + 4 | 0, 8200) | 0;
     c = v[31601];
     v[31601] = 0;
     if ((c | 0) == 1) {
      break c;
     }
     rc(a, b);
     v[31601] = 0;
     R(97, a | 0, 48396, 999);
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) != 1) {
      break a;
     }
     d = M() | 0;
     sb(b);
     break b;
    }
    zl(a, b, 4);
    c = uz(a, c, d, e, f, g);
    A[a + 16 >> 3] = A[a + 16 >> 3] + +(c >>> 0) / +(b | 0);
    eb = h + 16 | 0;
    return c | 0;
   }
   d = M() | 0;
   jc(a);
  }
  P(d | 0);
 }
 p();
}

function qO(a, b, c, d, e, f, g) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 f = f | 0;
 g = g | 0;
 var h = 0;
 h = eb - 16 | 0;
 eb = h;
 a: {
  b: {
   c: {
    if (g ? !f | (!d | !e) : 1) {
     a = cc(8);
     v[31601] = 0;
     b = O(36, h + 4 | 0, 8200) | 0;
     c = v[31601];
     v[31601] = 0;
     if ((c | 0) == 1) {
      break c;
     }
     rc(a, b);
     v[31601] = 0;
     R(97, a | 0, 48396, 999);
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) != 1) {
      break a;
     }
     d = M() | 0;
     sb(b);
     break b;
    }
    zl(a, b, 4);
    c = vz(a, c, d, e, f, g);
    A[a + 16 >> 3] = A[a + 16 >> 3] + +(c >>> 0) / +(b | 0);
    eb = h + 16 | 0;
    return c | 0;
   }
   d = M() | 0;
   jc(a);
  }
  P(d | 0);
 }
 p();
}

function Xqa(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0;
 d = v[a >> 2];
 c = Rf(d, v[a + 4 >> 2]);
 if (c >>> 0 < b >>> 0) {
  d = eb - 32 | 0;
  eb = d;
  a: {
   b: {
    c = b - c | 0;
    b = v[zb(a) >> 2];
    e = v[a + 4 >> 2];
    c: {
     if (c >>> 0 <= (b - e | 0) / 20 >>> 0) {
      WE(a, c);
      break c;
     }
     b = zb(a);
     b = VD(d + 12 | 0, WD(a, Rf(v[a >> 2], e) + c | 0), Rf(v[a >> 2], v[a + 4 >> 2]), b);
     v[31601] = 0;
     N(520, b | 0, c | 0);
     c = v[31601];
     v[31601] = 0;
     if ((c | 0) == 1) {
      break b;
     }
     UD(a, b);
     bw(b);
    }
    eb = d + 32 | 0;
    break a;
   }
   a = M() | 0;
   bw(b);
   P(a | 0);
   p();
  }
  return;
 }
 if (b >>> 0 < c >>> 0) {
  SE(a, d + B(b, 20) | 0);
 }
}

function ve(a, b, c, d) {
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0;
 e = eb - 16 | 0;
 eb = e;
 f = Kh(a);
 a: {
  b: {
   if (!b) {
    i = e, j = Kh(a), v[i + 8 >> 2] = j;
    v[e + 12 >> 2] = 0;
    break b;
   }
   g = v[b >> 2];
   b = v[b + 4 >> 2];
   h = b;
   v[e + 8 >> 2] = g;
   v[e + 12 >> 2] = b;
   a = v[a + 12 >> 2];
   v[e >> 2] = 2048;
   v[e + 4 >> 2] = 0;
   b = a + c | 0;
   d = a >>> 0 > b >>> 0 ? d + 1 | 0 : d;
   a = Wr(e + 8 | 0, e);
   c = v[a >> 2];
   a = v[a + 4 >> 2];
   if (!a & c >>> 0 > f >>> 0 | a) {
    a = -1;
    if (!d & b >>> 0 <= f >>> 0) {
     break b;
    }
    break a;
   }
   a = 0;
   if ((d | 0) == (h | 0) & b >>> 0 > g >>> 0 | d >>> 0 > h >>> 0) {
    break a;
   }
  }
  a = 1;
 }
 eb = e + 16 | 0;
 return a;
}

function taa(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0;
 f = eb - 16 | 0;
 eb = f;
 d = eb - 32 | 0;
 eb = d;
 ed(d + 24 | 0, a, b);
 h = d + 16 | 0;
 e = v[d + 24 >> 2];
 g = v[d + 28 >> 2];
 b = eb - 16 | 0;
 eb = b;
 v[b + 12 >> 2] = c;
 a: {
  while (1) {
   if ((e | 0) == (g | 0)) {
    break a;
   }
   c = Cc(b, v[e >> 2]);
   v[31601] = 0;
   O(1192, b + 12 | 0, c | 0) | 0;
   i = v[31601];
   v[31601] = 0;
   if ((i | 0) != 1) {
    sb(c);
    e = e + 4 | 0;
    continue;
   }
   break;
  }
  a = M() | 0;
  sb(c);
  P(a | 0);
  p();
 }
 pc(h, g, b + 12 | 0);
 eb = b + 16 | 0;
 b = v[d + 16 >> 2];
 v[d + 12 >> 2] = v[d + 20 >> 2];
 pc(f + 8 | 0, mA(a, b), d + 12 | 0);
 eb = d + 32 | 0;
 eb = f + 16 | 0;
}

function kta(a) {
 a = a | 0;
 var b = 0, c = 0, d = 0, e = 0, f = 0, g = 0;
 d = eb - 16 | 0;
 eb = d;
 v[a >> 2] = 0;
 v[a + 4 >> 2] = 0;
 sc(a + 8 | 0);
 f = d + 8 | 0;
 Qd(f, v[ub(d + 4 | 0, a) >> 2]);
 v[31601] = 0;
 V(344, a | 0);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  g = eb - 16 | 0;
  eb = g;
  b = g + 4 | 0;
  v[b >> 2] = a;
  e = v[a + 4 >> 2];
  v[b + 4 >> 2] = e;
  v[b + 8 >> 2] = e + 32768;
  c = v[b + 4 >> 2];
  e = v[b + 8 >> 2];
  while (1) {
   if ((c | 0) == (e | 0)) {
    hc(b);
    eb = g + 16 | 0;
   } else {
    u[c >> 1] = 0;
    u[c + 2 >> 1] = 0;
    c = c + 4 | 0;
    v[b + 4 >> 2] = c;
    continue;
   }
   break;
  }
  Pd(f);
  ah(f);
  eb = d + 16 | 0;
  return a | 0;
 }
 a = M() | 0;
 ah(d + 8 | 0);
 P(a | 0);
 p();
}

function Qk(a, b, c) {
 var d = 0;
 d = x[a + 34 >> 1];
 if (!b) {
  if (d & 512) {
   xp(a);
   d = x[a + 34 >> 1];
  }
  u[a + 34 >> 1] = d & 65023;
  return;
 }
 v[a >> 2] = 4;
 u[a + 34 >> 1] = d & 64958 | 512;
 Fh(a);
 b = w[c + 8 | 0] | w[c + 9 | 0] << 8 | (w[c + 10 | 0] << 16 | w[c + 11 | 0] << 24);
 t[a + 76 | 0] = b;
 t[a + 77 | 0] = b >>> 8;
 t[a + 78 | 0] = b >>> 16;
 t[a + 79 | 0] = b >>> 24;
 b = w[c + 4 | 0] | w[c + 5 | 0] << 8 | (w[c + 6 | 0] << 16 | w[c + 7 | 0] << 24);
 c = w[c | 0] | w[c + 1 | 0] << 8 | (w[c + 2 | 0] << 16 | w[c + 3 | 0] << 24);
 t[a + 68 | 0] = c;
 t[a + 69 | 0] = c >>> 8;
 t[a + 70 | 0] = c >>> 16;
 t[a + 71 | 0] = c >>> 24;
 t[a + 72 | 0] = b;
 t[a + 73 | 0] = b >>> 8;
 t[a + 74 | 0] = b >>> 16;
 t[a + 75 | 0] = b >>> 24;
}

function Fia(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0;
 f = eb - 48 | 0;
 eb = f;
 d = v[a + 36 >> 2];
 hg(v[v[d >> 2] - 12 >> 2] + d | 0, 0);
 d = v[b >> 2];
 g = v[d + 8 >> 2];
 e = v[d + 12 >> 2];
 if (g | e) {
  h = v[a + 36 >> 2];
  e = v[a + 20 >> 2] + e | 0;
  d = v[a + 16 >> 2];
  g = g + d | 0;
  e = $h(f + 32 | 0, g, d >>> 0 > g >>> 0 ? e + 1 | 0 : e);
  d = v[e + 12 >> 2];
  v[f + 8 >> 2] = v[e + 8 >> 2];
  v[f + 12 >> 2] = d;
  d = v[e + 4 >> 2];
  v[f >> 2] = v[e >> 2];
  v[f + 4 >> 2] = d;
  Sm(h, f);
 }
 d = f + 16 | 0;
 $d(d, v[a + 36 >> 2]);
 XB(v[a + 36 >> 2], c, v[v[b >> 2] + 16 >> 2]);
 c = v[b >> 2];
 b = pl(d, wb(v[a + 40 >> 2], v[c >> 2]), x[c + 20 >> 1]);
 ef(a, c);
 Db(b);
 eb = f + 48 | 0;
}

function YY(a, b) {
 var c = 0, d = 0, e = 0, f = 0;
 d = v[a >> 2];
 c = nc(d, v[a + 4 >> 2]);
 if (c >>> 0 < b >>> 0) {
  e = eb - 32 | 0;
  eb = e;
  b = b - c | 0;
  c = v[zb(a) >> 2];
  d = v[a + 4 >> 2];
  a: {
   if (b >>> 0 <= c - d >> 2 >>> 0) {
    pD(a, b);
    break a;
   }
   c = zb(a);
   c = Yf(e + 12 | 0, Kf(a, nc(v[a >> 2], d) + b | 0), nc(v[a >> 2], v[a + 4 >> 2]), c);
   f = eb - 16 | 0;
   eb = f;
   b = En(f + 4 | 0, c + 8 | 0, b);
   d = v[b >> 2];
   while (1) {
    if (v[b + 4 >> 2] != (d | 0)) {
     Bn(d);
     d = v[b >> 2] + 4 | 0;
     v[b >> 2] = d;
     continue;
    }
    break;
   }
   ie(b);
   eb = f + 16 | 0;
   VY(a, c);
   Xf(c);
  }
  eb = e + 32 | 0;
  return;
 }
 if (b >>> 0 < c >>> 0) {
  Id(a, d + (b << 2) | 0);
 }
}

function q9(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0;
 e = eb - 16 | 0;
 eb = e;
 while (1) {
  a: {
   if ((c | 0) <= (f | 0)) {
    break a;
   }
   g = v[a + 16 >> 2];
   d = v[a + 12 >> 2];
   b: {
    if (g >>> 0 > d >>> 0) {
     v[e + 12 >> 2] = 2147483647;
     v[e + 8 >> 2] = g - d;
     v[e + 4 >> 2] = c - f;
     g = d;
     d = v[Bd(e + 12 | 0, Bd(e + 8 | 0, e + 4 | 0)) >> 2];
     b = Cg(b, g, d);
     v[a + 12 >> 2] = v[a + 12 >> 2] + d;
     b = b + d | 0;
     break b;
    }
    d = hb[v[v[a >> 2] + 40 >> 2]](a) | 0;
    if ((d | 0) == -1) {
     break a;
    }
    t[b | 0] = d << 24 >> 24;
    d = 1;
    b = b + 1 | 0;
   }
   f = d + f | 0;
   continue;
  }
  break;
 }
 eb = e + 16 | 0;
 return f | 0;
}

function R9(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0;
 g = eb - 32 | 0;
 eb = g;
 e = v[b + 292 >> 2];
 hg(v[v[e >> 2] - 12 >> 2] + e | 0, 0);
 $d(g + 16 | 0, v[b + 292 >> 2]);
 f = $h(g, -1, -1);
 e = v[g + 24 >> 2];
 h = v[g + 28 >> 2];
 a: {
  if (!ao(e, h, v[f + 8 >> 2], v[f + 12 >> 2])) {
   b: {
    if ((c | 0) != (e | 0) | h) {
     break b;
    }
    break a;
   }
  }
  Ci(v[b + 292 >> 2], c, 0, 0);
 }
 e = v[d >> 2];
 d = v[d + 4 >> 2];
 c = 0;
 while (1) {
  if (d) {
   f = v[b + 292 >> 2];
   h = th(d);
   uj(f, c + e | 0, h);
   f = v[v[b + 292 >> 2] + 4 >> 2];
   d = d - f | 0;
   c = c + f | 0;
   if ((f | 0) == (h | 0)) {
    continue;
   }
  }
  break;
 }
 ac(a, e, c);
 eb = g + 32 | 0;
}

function OE(a, b) {
 var c = 0, d = 0, e = 0, f = 0;
 c = eb - 32 | 0;
 eb = c;
 a: {
  if (!w[b + 7 | 0]) {
   while (1) {
    if ((d | 0) == 7) {
     d = 0;
     t[c + 27 | 0] = 0;
     t[c + 28 | 0] = 0;
     t[c + 29 | 0] = 0;
     t[c + 30 | 0] = 0;
     v[c + 24 >> 2] = 0;
     e = c + 24 | 0;
     f = Yb(c + 8 | 0, e, 7);
     pd(c + 16 | 0, a, v[f >> 2], v[f + 4 >> 2]);
     b: {
      if (v[c + 20 >> 2] != 7) {
       break b;
      }
      if (id(e, b, 7)) {
       break b;
      }
      hd(a, 7);
      d = 1;
     }
     eb = c + 32 | 0;
     break a;
    }
    e = b + d | 0;
    d = d + 1 | 0;
    if (w[e | 0]) {
     continue;
    }
    break;
   }
   Z(17480, 9079, 601, 13222);
   p();
  }
  Z(17459, 9079, 599, 13222);
  p();
 }
 return d;
}

function Gia(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0;
 g = eb - 48 | 0;
 eb = g;
 e = v[a + 36 >> 2];
 hg(v[v[e >> 2] - 12 >> 2] + e | 0, 0);
 e = v[b >> 2];
 h = v[e + 8 >> 2];
 f = v[e + 12 >> 2];
 if (h | f) {
  i = v[a + 36 >> 2];
  f = v[a + 20 >> 2] + f | 0;
  e = v[a + 16 >> 2];
  h = h + e | 0;
  f = $h(g + 32 | 0, h, e >>> 0 > h >>> 0 ? f + 1 | 0 : f);
  e = v[f + 12 >> 2];
  v[g + 8 >> 2] = v[f + 8 >> 2];
  v[g + 12 >> 2] = e;
  e = v[f + 4 >> 2];
  v[g >> 2] = v[f >> 2];
  v[g + 4 >> 2] = e;
  Sm(i, g);
 }
 e = g + 16 | 0;
 $d(e, v[a + 36 >> 2]);
 PQ(d, v[a + 36 >> 2], c);
 c = v[b >> 2];
 b = pl(e, wb(v[a + 40 >> 2], v[c >> 2]), x[c + 20 >> 1]);
 ef(a, c);
 Db(b);
 eb = g + 48 | 0;
}

function Eia(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0;
 g = eb - 48 | 0;
 eb = g;
 e = v[a + 36 >> 2];
 hg(v[v[e >> 2] - 12 >> 2] + e | 0, 0);
 e = v[b >> 2];
 h = v[e + 8 >> 2];
 f = v[e + 12 >> 2];
 if (h | f) {
  i = v[a + 36 >> 2];
  f = v[a + 20 >> 2] + f | 0;
  e = v[a + 16 >> 2];
  h = h + e | 0;
  f = $h(g + 32 | 0, h, e >>> 0 > h >>> 0 ? f + 1 | 0 : f);
  e = v[f + 12 >> 2];
  v[g + 8 >> 2] = v[f + 8 >> 2];
  v[g + 12 >> 2] = e;
  e = v[f + 4 >> 2];
  v[g >> 2] = v[f >> 2];
  v[g + 4 >> 2] = e;
  Sm(i, g);
 }
 e = g + 16 | 0;
 $d(e, v[a + 36 >> 2]);
 MQ(c, v[a + 36 >> 2], d);
 c = v[b >> 2];
 b = pl(e, wb(v[a + 40 >> 2], v[c >> 2]), x[c + 20 >> 1]);
 ef(a, c);
 Db(b);
 eb = g + 48 | 0;
}

function v5(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0;
 if ((a | 0) != (b | 0)) {
  c = v[b >> 2];
  d = v[b + 4 >> 2];
  b = Rd(c, d);
  e = eb - 16 | 0;
  eb = e;
  a: {
   if (Ug(a) >>> 0 >= b >>> 0) {
    f = v[a >> 2];
    g = nc(f, v[a + 4 >> 2]);
    if (b >>> 0 > g >>> 0) {
     h = c;
     c = gD(c, g);
     uA(h, c, f);
     yq(a, c, d, b - nc(v[a >> 2], v[a + 4 >> 2]) | 0);
     break a;
    }
    Iv(e + 8 | 0, c, d, f);
    Id(a, v[e + 12 >> 2]);
    break a;
   }
   if (v[a >> 2]) {
    Mc(a);
    ny(it(a), v[a >> 2], Ug(a));
    i = zb(a), j = 0, v[i >> 2] = j;
    v[a >> 2] = 0;
    v[a + 4 >> 2] = 0;
   }
   AJ(a, Kf(a, b));
   yq(a, c, d, b);
  }
  eb = e + 16 | 0;
 }
 return a | 0;
}

function Rr(a, b, c) {
 var d = 0, e = 0, f = 0;
 d = v[c + 16 >> 2];
 a: {
  if (!d) {
   if (Uw(c)) {
    break a;
   }
   d = v[c + 16 >> 2];
  }
  e = v[c + 20 >> 2];
  if (d - e >>> 0 < b >>> 0) {
   return hb[v[c + 36 >> 2]](c, a, b) | 0;
  }
  b: {
   c: {
    if (!b | v[c + 80 >> 2] < 0) {
     break c;
    }
    d = b;
    while (1) {
     f = a + d | 0;
     if (w[f - 1 | 0] != 10) {
      d = d - 1 | 0;
      if (d) {
       continue;
      }
      break c;
     }
     break;
    }
    e = hb[v[c + 36 >> 2]](c, a, d) | 0;
    if (e >>> 0 < d >>> 0) {
     break a;
    }
    b = b - d | 0;
    e = v[c + 20 >> 2];
    break b;
   }
   f = a;
   d = 0;
  }
  yc(e, f, b);
  v[c + 20 >> 2] = v[c + 20 >> 2] + b;
  e = b + d | 0;
 }
 return e;
}

function Zma(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0;
 b = eb - 16 | 0;
 eb = b;
 h = v[a + 24 >> 2];
 i = v[a + 20 >> 2];
 j = v[a + 16 >> 2];
 f = v[a + 4 >> 2];
 v[b + 8 >> 2] = v[a >> 2];
 v[b + 12 >> 2] = f;
 f = v[a + 8 >> 2];
 k = v[a + 12 >> 2];
 while (1) {
  if (d) {
   g = v[b + 12 >> 2] + j | 0;
   e = t[g | 0];
   e = ((B(t[g + 1 | 0] - e | 0, v[b + 8 >> 2] >>> 10 & 4194048) | 0) / 16384 | 0) + (e << 8) | 0;
   v[c >> 2] = v[c >> 2] + B(e, i);
   v[c + 4 >> 2] = v[c + 4 >> 2] + B(e, h);
   Ob(b + 8 | 0, f, k);
   c = c + 8 | 0;
   d = d - 1 | 0;
   continue;
  }
  break;
 }
 c = v[b + 12 >> 2];
 v[a >> 2] = v[b + 8 >> 2];
 v[a + 4 >> 2] = c;
 eb = b + 16 | 0;
}

function qoa(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0;
 c = eb + -64 | 0;
 eb = c;
 hn(c + 52 | 0, b);
 oe(c + 24 | 0, v[c + 52 >> 2], v[c + 56 >> 2]);
 b = Ld(c + 16 | 0);
 v[31601] = 0;
 d = v[b + 4 >> 2];
 v[c + 8 >> 2] = v[b >> 2];
 v[c + 12 >> 2] = d;
 b = gg(160, c + 32 | 0, v[c + 24 >> 2], v[c + 28 >> 2], c + 8 | 0);
 d = v[31601];
 v[31601] = 0;
 a: {
  if ((d | 0) != 1) {
   d = Mb(a);
   a = v[c + 56 >> 2];
   e = v[c + 52 >> 2];
   v[31601] = 0;
   R(731, b | 0, d | 0, Sc(e, a) >>> 5 | 0);
   a = v[31601];
   v[31601] = 0;
   if ((a | 0) == 1) {
    a = M() | 0;
    Pi(d);
    tb(b);
    break a;
   }
   tb(b);
   ec(c + 52 | 0);
   eb = c - -64 | 0;
   return;
  }
  a = M() | 0;
 }
 ec(c + 52 | 0);
 P(a | 0);
 p();
}

function noa(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0;
 c = eb + -64 | 0;
 eb = c;
 hn(c + 52 | 0, b);
 oe(c + 24 | 0, v[c + 52 >> 2], v[c + 56 >> 2]);
 b = Ld(c + 16 | 0);
 v[31601] = 0;
 d = v[b + 4 >> 2];
 v[c + 8 >> 2] = v[b >> 2];
 v[c + 12 >> 2] = d;
 b = gg(160, c + 32 | 0, v[c + 24 >> 2], v[c + 28 >> 2], c + 8 | 0);
 d = v[31601];
 v[31601] = 0;
 a: {
  if ((d | 0) != 1) {
   d = Mb(a);
   a = v[c + 56 >> 2];
   e = v[c + 52 >> 2];
   v[31601] = 0;
   R(732, b | 0, d | 0, Sc(e, a) >>> 2 | 0);
   a = v[31601];
   v[31601] = 0;
   if ((a | 0) == 1) {
    a = M() | 0;
    uc(d);
    tb(b);
    break a;
   }
   tb(b);
   ec(c + 52 | 0);
   eb = c - -64 | 0;
   return;
  }
  a = M() | 0;
 }
 ec(c + 52 | 0);
 P(a | 0);
 p();
}

function moa(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0;
 c = eb + -64 | 0;
 eb = c;
 hn(c + 52 | 0, b);
 oe(c + 24 | 0, v[c + 52 >> 2], v[c + 56 >> 2]);
 b = Ld(c + 16 | 0);
 v[31601] = 0;
 d = v[b + 4 >> 2];
 v[c + 8 >> 2] = v[b >> 2];
 v[c + 12 >> 2] = d;
 b = gg(160, c + 32 | 0, v[c + 24 >> 2], v[c + 28 >> 2], c + 8 | 0);
 d = v[31601];
 v[31601] = 0;
 a: {
  if ((d | 0) != 1) {
   d = Mb(a);
   a = v[c + 56 >> 2];
   e = v[c + 52 >> 2];
   v[31601] = 0;
   R(733, b | 0, d | 0, Sc(e, a) >>> 8 | 0);
   a = v[31601];
   v[31601] = 0;
   if ((a | 0) == 1) {
    a = M() | 0;
    uv(d);
    tb(b);
    break a;
   }
   tb(b);
   ec(c + 52 | 0);
   eb = c - -64 | 0;
   return;
  }
  a = M() | 0;
 }
 ec(c + 52 | 0);
 P(a | 0);
 p();
}

function loa(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0;
 c = eb + -64 | 0;
 eb = c;
 hn(c + 52 | 0, b);
 oe(c + 24 | 0, v[c + 52 >> 2], v[c + 56 >> 2]);
 b = Ld(c + 16 | 0);
 v[31601] = 0;
 d = v[b + 4 >> 2];
 v[c + 8 >> 2] = v[b >> 2];
 v[c + 12 >> 2] = d;
 b = gg(160, c + 32 | 0, v[c + 24 >> 2], v[c + 28 >> 2], c + 8 | 0);
 d = v[31601];
 v[31601] = 0;
 a: {
  if ((d | 0) != 1) {
   d = Mb(a);
   a = v[c + 56 >> 2];
   e = v[c + 52 >> 2];
   v[31601] = 0;
   R(734, b | 0, d | 0, Sc(e, a) >>> 4 | 0);
   a = v[31601];
   v[31601] = 0;
   if ((a | 0) == 1) {
    a = M() | 0;
    jn(d);
    tb(b);
    break a;
   }
   tb(b);
   ec(c + 52 | 0);
   eb = c - -64 | 0;
   return;
  }
  a = M() | 0;
 }
 ec(c + 52 | 0);
 P(a | 0);
 p();
}

function Yma(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0;
 b = eb - 16 | 0;
 eb = b;
 g = v[a + 24 >> 2];
 h = v[a + 20 >> 2];
 i = v[a + 16 >> 2];
 e = v[a + 4 >> 2];
 v[b + 8 >> 2] = v[a >> 2];
 v[b + 12 >> 2] = e;
 j = v[a + 8 >> 2];
 k = v[a + 12 >> 2];
 while (1) {
  if (d) {
   e = (v[b + 12 >> 2] << 1) + i | 0;
   f = u[e >> 1];
   e = f + ((B(u[e + 2 >> 1] - f | 0, v[b + 8 >> 2] >>> 18 | 0) | 0) / 16384 | 0) | 0;
   v[c >> 2] = v[c >> 2] + B(e, h);
   v[c + 4 >> 2] = v[c + 4 >> 2] + B(e, g);
   Ob(b + 8 | 0, j, k);
   c = c + 8 | 0;
   d = d - 1 | 0;
   continue;
  }
  break;
 }
 c = v[b + 12 >> 2];
 v[a >> 2] = v[b + 8 >> 2];
 v[a + 4 >> 2] = c;
 eb = b + 16 | 0;
}

function xV(a, b, c, d, e) {
 var f = 0, g = 0, h = 0;
 h = -1;
 g = d & 2147483647;
 f = (g | 0) == 2147418112;
 a: {
  if (f & !c ? a | b : f & (c | 0) != 0 | g >>> 0 > 2147418112) {
   break a;
  }
  f = e & 2147483647;
  if (((f | 0) == 2147418112 & 0 | f >>> 0 > 2147418112) & (f | 0) != 2147418112) {
   break a;
  }
  if (!(a | c | (f | g | b))) {
   return 0;
  }
  f = d & e;
  if ((f | 0) > 0) {
   f = 1;
  } else {
   f = (f | 0) >= 0;
  }
  if (f) {
   if (((c | 0) != 0 | (d | 0) != (e | 0)) & (d | 0) < (e | 0)) {
    break a;
   }
   return (a | c | (d ^ e | b)) != 0;
  }
  if (!c & (d | 0) == (e | 0) ? a | b : (c | 0) != 0 & (d | 0) >= (e | 0) | (d | 0) > (e | 0)) {
   break a;
  }
  h = (a | c | (d ^ e | b)) != 0;
 }
 return h;
}

function vT(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0;
 d = eb - 16 | 0;
 eb = d;
 j = d, k = Pj(b), v[j + 4 >> 2] = k;
 c = eb - 16 | 0;
 eb = c;
 g = gB(a, c + 12 | 0, w[b | 0], v[b + 4 >> 2]);
 b = v[g >> 2];
 if (!b) {
  e = eb - 16 | 0;
  eb = e;
  b = fc(a);
  h = Ch(c, Dc(28), Ng(e + 8 | 0, b));
  b = v[h >> 2];
  f = v[d + 4 >> 2];
  i = v[f >> 2];
  f = v[f + 4 >> 2];
  v[b + 24 >> 2] = 0;
  v[b + 16 >> 2] = i;
  v[b + 20 >> 2] = f;
  j = fc(h), k = 1, t[j + 4 | 0] = k;
  eb = e + 16 | 0;
  _g(a, v[c + 12 >> 2], g, v[c >> 2]);
  b = me(c);
  Gk(c);
  e = 1;
 }
 Zg(d + 8 | 0, v[ub(c, b) >> 2], e);
 eb = c + 16 | 0;
 a = td(v[d + 8 >> 2]);
 eb = d + 16 | 0;
 return a + 8 | 0;
}

function L0(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0;
 a: {
  d = eb - 32 | 0;
  eb = d;
  b: {
   c: {
    d: {
     e: {
      if ((b | 0) == 4) {
       Tf(a, c);
       break e;
      }
      e = d + 8 | 0;
      Tf(e, c);
      v[31601] = 0;
      c = d + 20 | 0;
      R(123, c | 0, b | 0, e | 0);
      b = v[31601];
      v[31601] = 0;
      if ((b | 0) == 1) {
       break d;
      }
      v[31601] = 0;
      R(244, a | 0, 4, c | 0);
      a = v[31601];
      v[31601] = 0;
      if ((a | 0) == 1) {
       break c;
      }
      Tb(c);
      sb(e);
     }
     eb = d + 32 | 0;
     break a;
    }
    a = M() | 0;
    break b;
   }
   a = M() | 0;
   Tb(d + 20 | 0);
  }
  sb(d + 8 | 0);
  P(a | 0);
  p();
 }
}

function Lf(a, b, c, d, e, f, g, h, i) {
 var j = 0, k = 0, l = 0, m = 0;
 i = Aua(b, c, h, i);
 h = gb;
 e = Aua(d, e, f, g);
 i = e + i | 0;
 d = gb + h | 0;
 h = e >>> 0 > i >>> 0 ? d + 1 | 0 : d;
 j = g;
 e = 0;
 k = c;
 d = 0;
 c = Aua(g, e, c, d);
 g = c + i | 0;
 i = gb + h | 0;
 l = g;
 c = c >>> 0 > g >>> 0 ? i + 1 | 0 : i;
 g = Aua(f, 0, b, 0);
 h = gb;
 i = 0;
 d = Aua(f, i, k, d);
 h = h + d | 0;
 f = gb + i | 0;
 f = d >>> 0 > h >>> 0 ? f + 1 | 0 : f;
 i = f + l | 0;
 d = c;
 f = f >>> 0 > i >>> 0 ? d + 1 | 0 : d;
 b = Aua(b, m, j, e) + h | 0;
 e = gb;
 e = b >>> 0 < h >>> 0 ? e + 1 | 0 : e;
 h = e + i | 0;
 i = f;
 v[a + 8 >> 2] = h;
 v[a + 12 >> 2] = e >>> 0 > h >>> 0 ? i + 1 | 0 : i;
 v[a >> 2] = g;
 v[a + 4 >> 2] = b;
}

function rna(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0;
 b = eb - 16 | 0;
 eb = b;
 d = -1;
 a: {
  if (!ih(a, 1)) {
   break a;
  }
  e = Kr(a);
  if ((e - 5 & 255) >>> 0 >= 253) {
   while (1) {
    if ((f | 0) == 127) {
     d = 1;
     break a;
    }
    c = eb - 16 | 0;
    eb = c;
    fE(c + 8 | 0, b);
    g = v[c + 12 >> 2];
    pd(c, a, v[c + 8 >> 2], v[c + 12 >> 2]);
    h = v[c + 4 >> 2];
    if ((h | 0) == (g | 0)) {
     hd(a, v[c + 12 >> 2]);
    }
    eb = c + 16 | 0;
    c = (g | 0) == (h | 0);
    if (!c) {
     Dr(b);
    }
    if (!c) {
     break a;
    }
    f = f + 1 | 0;
    if (rV(b, e)) {
     continue;
    }
    break;
   }
  }
  d = 0;
 }
 eb = b + 16 | 0;
 return d | 0;
}

function Yja(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0;
 e = eb - 16 | 0;
 eb = e;
 d = u[a + 30 >> 1];
 if (d) {
  b = jA(b << 16 >> 16, d);
 }
 u[e + 14 >> 1] = b;
 a = a + 52 | 0;
 a: {
  if (!zd(v[c + 4 >> 2], w[c + 11 | 0])) {
   rs(TQ(a, e + 14 | 0), c);
   break a;
  }
  b = kA(a, e + 14 | 0);
  if (!Yg(b, Of(a))) {
   break a;
  }
  c = eb - 16 | 0;
  eb = c;
  b = v[ub(c + 8 | 0, b) >> 2];
  d = eb - 16 | 0;
  eb = d;
  f = $g(ub(d + 12 | 0, b));
  if ((b | 0) == v[a >> 2]) {
   v[a >> 2] = v[f >> 2];
  }
  g = zb(a);
  v[g >> 2] = v[g >> 2] - 1;
  aV(v[fc(a) >> 2], b);
  a = v[f >> 2];
  eb = d + 16 | 0;
  Nj(td(b));
  Bb(b);
  ub(c + 12 | 0, a);
  eb = c + 16 | 0;
 }
 eb = e + 16 | 0;
}

function oN(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0;
 c = eb - 16 | 0;
 eb = c;
 a: {
  b: {
   c: {
    d: {
     if ((b | 0) >= 0) {
      a = v[a + 32 >> 2];
      if ((wo(a) | 0) > (b | 0)) {
       break d;
      }
     }
     b = cc(8);
     v[31601] = 0;
     c = O(36, c + 4 | 0, 10735) | 0;
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) == 1) {
      break c;
     }
     rc(b, c);
     v[31601] = 0;
     R(97, b | 0, 48396, 999);
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) != 1) {
      break a;
     }
     a = M() | 0;
     sb(c);
     break b;
    }
    eb = c + 16 | 0;
    return (v[(a + B(b, 872) | 0) + 1075080 >> 2] & 134218752) != 0 | 0;
   }
   a = M() | 0;
   jc(b);
  }
  P(a | 0);
 }
 p();
}

function gz(a) {
 var b = 0, c = 0, d = 0;
 a: {
  b: {
   if (!v[a + 1384 >> 2]) {
    b = v[a + 1380 >> 2];
    if ((b | 0) == -1) {
     v[a + 1388 >> 2] = v[a + 1116 >> 2] - 1;
     if (!Rt(a)) {
      v[a + 1384 >> 2] = 1;
      return 0;
     }
     if (!(t[a + 1375 | 0] & 1)) {
      break b;
     }
     b = v[a + 1380 >> 2];
    }
    d = b + 1 | 0;
    v[a + 1380 >> 2] = d;
    c = w[(a + b | 0) + 1120 | 0];
    if ((c | 0) != 255) {
     v[a + 1388 >> 2] = b;
     v[a + 1384 >> 2] = 1;
    }
    if (v[a + 1116 >> 2] <= (d | 0)) {
     v[a + 1380 >> 2] = -1;
    }
    if (w[a + 1376 | 0]) {
     break a;
    }
    t[a + 1376 | 0] = c;
   }
   return c;
  }
  bc(a, 32);
  return 0;
 }
 Z(15783, 13258, 1564, 6036);
 p();
}

function KK(a, b) {
 var c = 0, d = 0, e = 0, f = 0, g = 0;
 e = eb - 16 | 0;
 eb = e;
 g = v[124107];
 if (v[b + 72 >> 2] <= 0) {
  Ny(b);
 }
 v[124107] = v[b + 136 >> 2];
 c = -1;
 if (v[b + 4 >> 2]) {
  d = 0;
 } else {
  At(b);
  d = !v[b + 4 >> 2];
 }
 a: {
  if (d | (a | 0) == -1) {
   break a;
  }
  d = It(e + 12 | 0, a);
  if ((d | 0) < 0) {
   break a;
  }
  f = v[b + 4 >> 2];
  if (f >>> 0 < (v[b + 44 >> 2] + d | 0) - 8 >>> 0) {
   break a;
  }
  b: {
   if (a >>> 0 <= 127) {
    c = f - 1 | 0;
    v[b + 4 >> 2] = c;
    t[c | 0] = a;
    break b;
   }
   c = f - d | 0;
   v[b + 4 >> 2] = c;
   yc(c, e + 12 | 0, d);
  }
  v[b >> 2] = v[b >> 2] & -17;
  c = a;
 }
 v[124107] = g;
 eb = e + 16 | 0;
 return (c | 0) != -1;
}

function z2(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0;
 a = Eb(a);
 a: {
  if (w[b + 16 | 0]) {
   v[31601] = 0;
   O(127, a | 0, 4945) | 0;
   c = v[31601];
   v[31601] = 0;
   if ((c | 0) == 1) {
    break a;
   }
  }
  if (w[b + 17 | 0]) {
   v[31601] = 0;
   O(127, a | 0, 12608) | 0;
   c = v[31601];
   v[31601] = 0;
   if ((c | 0) == 1) {
    break a;
   }
  }
  if (zd(v[a + 4 >> 2], w[a + 11 | 0])) {
   v[31601] = 0;
   O(127, a | 0, 10067) | 0;
   c = v[31601];
   v[31601] = 0;
   if ((c | 0) == 1) {
    break a;
   }
  }
  if (w[b + 18 | 0]) {
   v[31601] = 0;
   O(127, a | 0, 11127) | 0;
   b = v[31601];
   v[31601] = 0;
   if ((b | 0) == 1) {
    break a;
   }
  }
  return;
 }
 b = M() | 0;
 sb(a);
 P(b | 0);
 p();
}

function nsa(a, b, c, d, e, f) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 f = f | 0;
 var g = 0, h = 0, i = 0, j = 0;
 g = eb - 16 | 0;
 eb = g;
 a: {
  if (x[a + 480192 >> 1] < b >>> 0) {
   break a;
  }
  b = v[((b << 2) + a | 0) + 900380 >> 2];
  if (!b) {
   break a;
  }
  h = g + 4 | 0;
  ZZ(h, b);
  b = vb(v[g + 4 >> 2]);
  v[g >> 2] = b;
  i = a + 484380 | 0;
  h = og(h);
  j = x[a + 480190 >> 1];
  while (1) {
   if (!Hb(b, h)) {
    Yv(g + 4 | 0);
    break a;
   }
   a = x[cp(b) >> 1];
   if (a >>> 0 <= j >>> 0) {
    a = B(a, 104) + i | 0;
    t[a + 41 | 0] = f;
    t[a + 38 | 0] = c;
    t[a + 40 | 0] = e;
    t[a + 39 | 0] = d;
   }
   b = v[$g(g) >> 2];
   continue;
  }
 }
 eb = g + 16 | 0;
}

function wO(a, b, c, d, e) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 var f = 0;
 f = eb - 16 | 0;
 eb = f;
 a: {
  b: {
   c: {
    if (!(e ? d : 0)) {
     a = cc(8);
     v[31601] = 0;
     b = O(36, f + 4 | 0, 8200) | 0;
     c = v[31601];
     v[31601] = 0;
     if ((c | 0) == 1) {
      break c;
     }
     rc(a, b);
     v[31601] = 0;
     R(97, a | 0, 48396, 999);
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) != 1) {
      break a;
     }
     e = M() | 0;
     sb(b);
     break b;
    }
    zl(a, b, 2);
    c = uz(a, c, d, e, 0, 0);
    A[a + 16 >> 3] = A[a + 16 >> 3] + +(c >>> 0) / +(b | 0);
    eb = f + 16 | 0;
    return c | 0;
   }
   e = M() | 0;
   jc(a);
  }
  P(e | 0);
 }
 p();
}

function pO(a, b, c, d, e) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 var f = 0;
 f = eb - 16 | 0;
 eb = f;
 a: {
  b: {
   c: {
    if (!(e ? d : 0)) {
     a = cc(8);
     v[31601] = 0;
     b = O(36, f + 4 | 0, 8200) | 0;
     c = v[31601];
     v[31601] = 0;
     if ((c | 0) == 1) {
      break c;
     }
     rc(a, b);
     v[31601] = 0;
     R(97, a | 0, 48396, 999);
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) != 1) {
      break a;
     }
     e = M() | 0;
     sb(b);
     break b;
    }
    zl(a, b, 2);
    c = vz(a, c, d, e, 0, 0);
    A[a + 16 >> 3] = A[a + 16 >> 3] + +(c >>> 0) / +(b | 0);
    eb = f + 16 | 0;
    return c | 0;
   }
   e = M() | 0;
   jc(a);
  }
  P(e | 0);
 }
 p();
}

function Zp(a, b, c, d, e, f, g, h) {
 var i = 0, j = 0, k = 0;
 i = eb - 16 | 0;
 eb = i;
 if (2147483630 - b >>> 0 >= c >>> 0) {
  k = Jb(a);
  j = i + 4 | 0;
  if (b >>> 0 <= 1073741798) {
   v[i + 12 >> 2] = b << 1;
   v[i + 4 >> 2] = b + c;
   c = Eh(v[ad(j, i + 12 | 0) >> 2]) + 1 | 0;
  } else {
   c = 2147483631;
  }
  pg(j, c);
  c = v[i + 4 >> 2];
  if (e) {
   Cg(c, k, e);
  }
  if (g) {
   Cg(c + e | 0, h, g);
  }
  j = e + f | 0;
  h = d - j | 0;
  if ((d | 0) != (j | 0)) {
   Cg((c + e | 0) + g | 0, (e + k | 0) + f | 0, h);
  }
  if ((b | 0) != 10) {
   Bb(k);
  }
  xd(a, c);
  of(a, v[i + 8 >> 2]);
  b = a;
  a = h + (e + g | 0) | 0;
  Ad(b, a);
  gd(a + c | 0, 0);
  eb = i + 16 | 0;
  return;
 }
 pf();
 p();
}

function Uq(a, b, c, d, e, f, g, h) {
 var i = 0, j = 0, k = 0;
 i = eb - 16 | 0;
 eb = i;
 if (2147483630 - b >>> 0 >= c >>> 0) {
  k = Jb(a);
  j = i + 4 | 0;
  if (b >>> 0 <= 1073741798) {
   v[i + 12 >> 2] = b << 1;
   v[i + 4 >> 2] = b + c;
   c = Eh(v[ad(j, i + 12 | 0) >> 2]) + 1 | 0;
  } else {
   c = 2147483631;
  }
  pg(j, c);
  c = v[i + 4 >> 2];
  if (e) {
   Wg(c, k, e);
  }
  if (g) {
   Wg(c + e | 0, h, g);
  }
  j = e + f | 0;
  h = d - j | 0;
  if ((d | 0) != (j | 0)) {
   Wg((c + e | 0) + g | 0, (e + k | 0) + f | 0, h);
  }
  if ((b | 0) != 10) {
   Bb(k);
  }
  xd(a, c);
  of(a, v[i + 8 >> 2]);
  b = a;
  a = h + (e + g | 0) | 0;
  Ad(b, a);
  gd(a + c | 0, 0);
  eb = i + 16 | 0;
  return;
 }
 pf();
 p();
}

function ug(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0;
 d = eb - 16 | 0;
 eb = d;
 u[d + 12 >> 1] = 65535;
 u[d + 14 >> 1] = b;
 f = d + 12 | 0;
 b = x[Nc(41324, d + 14 | 0) >> 1];
 e = v[a >> 2];
 c = _c(e, v[a + 4 >> 2]);
 a: {
  if (b >>> 0 > c >>> 0) {
   e = eb - 32 | 0;
   eb = e;
   b = b - c | 0;
   c = v[zb(a) >> 2];
   g = v[a + 4 >> 2];
   b: {
    if (b >>> 0 <= c - g >> 1 >>> 0) {
     tp(a, b, f);
     break b;
    }
    c = zb(a);
    c = dk(e + 12 | 0, ek(a, _c(v[a >> 2], g) + b | 0), _c(v[a >> 2], v[a + 4 >> 2]), c);
    rF(c, b, f);
    Ur(a, c);
    $i(c);
   }
   eb = e + 32 | 0;
   break a;
  }
  if (b >>> 0 < c >>> 0) {
   Id(a, e + (b << 1) | 0);
  }
 }
 eb = d + 16 | 0;
}

function g3(a, b, c, d, e, f, g, h, i, j, k, l) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 f = f | 0;
 g = g | 0;
 h = h | 0;
 i = i | 0;
 j = j | 0;
 k = k | 0;
 l = l | 0;
 var m = 0;
 v[31601] = 0;
 m = a;
 a = 0;
 a = aI(1092, m | a, b, c, d, a | e, f);
 b = v[31601];
 v[31601] = 0;
 a: {
  b: {
   if ((b | 0) == 1) {
    X(S(0) | 0) | 0;
    v[31601] = 0;
    fa(978, 8843, g | 0, h | 0, i | 0, j | 0, k | 0, l | 0);
    a = v[31601];
    v[31601] = 0;
    if ((a | 0) == 1) {
     break b;
    }
    Y();
    a = -255;
   }
   break a;
  }
  a = M() | 0;
  v[31601] = 0;
  W(26);
  b = v[31601];
  v[31601] = 0;
  if ((b | 0) != 1) {
   P(a | 0);
   p();
  }
  S(0) | 0;
  Rb();
  p();
 }
 return a | 0;
}

function aU(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0;
 d = eb - 32 | 0;
 eb = d;
 v[a + 4 >> 2] = 0;
 a: {
  if (b) {
   b: {
    if (iv(a) >>> 0 >= b >>> 0) {
     v[a + 4 >> 2] = b;
     break b;
    }
    e = So(d + 20 | 0);
    v[31601] = 0;
    f = O(758, a | 0, b | 0) | 0;
    g = v[31601];
    v[31601] = 0;
    if ((g | 0) == 1) {
     break a;
    }
    v[31601] = 0;
    N(759, e | 0, f | 0);
    f = v[31601];
    v[31601] = 0;
    if ((f | 0) == 1) {
     break a;
    }
    v[e + 4 >> 2] = b;
    mC(a, e);
    tf(e);
   }
   ln(d + 12 | 0, v[a >> 2]);
   Vw(v[d + 12 >> 2], v[d + 16 >> 2], b, w[c | 0]);
  }
  eb = d + 32 | 0;
  return;
 }
 a = M() | 0;
 tf(e);
 P(a | 0);
 p();
}

function a0(a) {
 a = a | 0;
 var b = 0, c = 0, d = 0;
 b = v[a >> 2];
 if (b) {
  nQ(v[b + 12 >> 2], b);
  b = v[a >> 2];
  hb[v[v[b >> 2] + 8 >> 2]](b);
  v[a >> 2] = 0;
 }
 a = a + 4 | 0;
 Mc(a);
 b = eb - 32 | 0;
 eb = b;
 a: {
  b: {
   d = $o(a);
   c = Sc(v[a >> 2], v[a + 4 >> 2]);
   c: {
    if (d >>> 0 <= c >>> 0) {
     break c;
    }
    v[31601] = 0;
    c = aa(949, b + 12 | 0, c | 0, c | 0, zb(a) | 0) | 0;
    d = v[31601];
    v[31601] = 0;
    if ((d | 0) != 1) {
     cr(a, c);
     nn(c);
     break c;
    }
    X(S(0) | 0) | 0;
    v[31601] = 0;
    W(26);
    a = v[31601];
    v[31601] = 0;
    if ((a | 0) == 1) {
     break b;
    }
   }
   eb = b + 32 | 0;
   break a;
  }
  S(0) | 0;
  Rb();
  p();
 }
}

function qta(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0;
 e = eb - 16 | 0;
 eb = e;
 a: {
  f = Yd(a);
  b: {
   if (f >>> 0 > 1) {
    break b;
   }
   c: {
    if (f) {
     v[31601] = 0;
     d = e + 4 | 0;
     R(334, d | 0, a | 0, c | 0);
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) != 1) {
      yn(b, d);
      ec(d);
      break c;
     }
     a = S(28784) | 0;
     if ((fb | 0) != (_(28784) | 0)) {
      break a;
     }
     X(a | 0) | 0;
     Y();
     d = 0;
     break b;
    }
    if (!Lb(v[a >> 2], v[a + 8 >> 2], c)) {
     break b;
    }
    yw(a, b, c);
   }
   d = Sc(v[b >> 2], v[b + 4 >> 2]) >>> 0 >= c >>> 0;
  }
  eb = e + 16 | 0;
  return d | 0;
 }
 P(a | 0);
 p();
}

function lfa(a, b, c, d, e) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = +d;
 e = +e;
 var f = 0, g = 0;
 v[31601] = 0;
 V(1020, a | 0);
 f = v[31601];
 v[31601] = 0;
 a: {
  b: {
   if ((f | 0) != 1) {
    f = v[a + 28 >> 2];
    g = v[v[f >> 2] + 72 >> 2];
    v[31601] = 0;
    b = Sa(g | 0, f | 0, b | 0, c | 0, +d, +e) | 0;
    c = v[31601];
    v[31601] = 0;
    if ((c | 0) != 1) {
     break b;
    }
   }
   X(S(0) | 0) | 0;
   v[31601] = 0;
   U(982, 11298, a | 0, 0, 0);
   a = v[31601];
   v[31601] = 0;
   if ((a | 0) == 1) {
    break a;
   }
   Y();
   b = -1;
  }
  return b | 0;
 }
 a = M() | 0;
 v[31601] = 0;
 W(26);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  P(a | 0);
  p();
 }
 S(0) | 0;
 Rb();
 p();
}

function l3(a) {
 a = a | 0;
 var b = 0, c = 0, d = 0, e = 0;
 c = eb - 32 | 0;
 eb = c;
 b = tc(c + 8 | 0, 16770);
 v[31601] = 0;
 R(98, c + 20 | 0, a | 0, b | 0);
 a = v[31601];
 v[31601] = 0;
 a: {
  if ((a | 0) != 1) {
   sb(b);
   a = 0;
   b = 0;
   while (1) {
    d = v[c + 20 >> 2];
    if (!(b >>> 0 <= 3 & Td(d, v[c + 24 >> 2]) >>> 0 > b >>> 0)) {
     Sd(c + 20 | 0);
     eb = c + 32 | 0;
     return a | 0;
    }
    v[31601] = 0;
    d = Q(99, Ud(d, b) | 0) | 0;
    e = v[31601];
    v[31601] = 0;
    if ((e | 0) != 1) {
     a = (d & 255) << (b << 3 ^ 24) | a;
     b = b + 1 | 0;
     continue;
    }
    break;
   }
   a = M() | 0;
   Sd(c + 20 | 0);
   break a;
  }
  a = M() | 0;
  sb(b);
 }
 P(a | 0);
 p();
}

function b4(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0;
 e = v[a >> 2];
 f = 6;
 a: {
  b: {
   if ((e | 0) == (b | 0)) {
    break b;
   }
   e = t[e | 0];
   f = 4;
   if (!If(v[d + 8 >> 2], 64, e)) {
    break b;
   }
   f = 4;
   g = kl(d, e);
   while (1) {
    c: {
     e = v[a >> 2] + 1 | 0;
     v[a >> 2] = e;
     g = g - 48 | 0;
     if ((b | 0) == (e | 0) | f >>> 0 < 2) {
      break c;
     }
     e = t[e | 0];
     if (!If(v[d + 8 >> 2], 64, e)) {
      break a;
     }
     f = f - 1 | 0;
     g = kl(d, e) + B(g, 10) | 0;
     continue;
    }
    break;
   }
   if ((b | 0) != (e | 0)) {
    break a;
   }
   f = 2;
  }
  v[c >> 2] = f | v[c >> 2];
 }
 return g | 0;
}

function Xoa(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0;
 d = eb - 32 | 0;
 eb = d;
 md(b, 0);
 e = d + 8 | 0;
 SD(e, a + 1 | 0);
 c = d + 20 | 0;
 Bc(c, e);
 Ae(b + 43 | 0, c);
 sb(c);
 v[b + 24 >> 2] = w[a + 78 | 0] | w[a + 79 | 0] << 8;
 c = w[a + 58 | 0] | w[a + 59 | 0] << 8 | (w[a + 60 | 0] << 16 | w[a + 61 | 0] << 24);
 v[b >> 2] = c;
 v[b + 4 >> 2] = w[a + 62 | 0] | w[a + 63 | 0] << 8 | (w[a + 64 | 0] << 16 | w[a + 65 | 0] << 24);
 v[b + 8 >> 2] = w[a + 66 | 0] | w[a + 67 | 0] << 8 | (w[a + 68 | 0] << 16 | w[a + 69 | 0] << 24);
 u[b + 30 >> 1] = (w[a + 73 | 0] << 1) + 2;
 u[b + 34 >> 1] = x[b + 34 >> 1] & 65533 | w[a | 0] >>> 6 & 2;
 wc(b + 8 | 0, c);
 wc(b + 4 | 0, v[b + 8 >> 2]);
 eb = d + 32 | 0;
}

function Faa(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = C(0), j = 0, k = 0;
 c = eb - 16 | 0;
 eb = c;
 d = v[a + 4 >> 2];
 v[c + 8 >> 2] = v[b + 8 >> 2];
 e = v[b + 4 >> 2];
 v[c >> 2] = v[b >> 2];
 v[c + 4 >> 2] = e;
 AM(a, c);
 a: {
  g = A[a + 24 >> 3];
  if (g == 1) {
   break a;
  }
  i = C(g);
  e = v[b + 4 >> 2];
  j = v[b + 8 >> 2];
  d = d << 2;
  b: while (1) {
   if ((f | 0) == (j | 0)) {
    break a;
   }
   k = v[a + 12 >> 2];
   b = 0;
   while (1) if ((b | 0) == (e | 0)) {
    f = f + 1 | 0;
    continue b;
   } else {
    h = (d + v[(b << 2) + k >> 2] | 0) + (f << 2) | 0;
    z[h >> 2] = z[h >> 2] * i;
    b = b + 1 | 0;
    continue;
   }
  }
 }
 eb = c + 16 | 0;
}

function $na(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0;
 c = eb - 16 | 0;
 eb = c;
 d = Yc(c + 12 | 0, 16, 1, 1, 0);
 v[c + 8 >> 2] = 0;
 md(a, 0);
 xc(b);
 a: {
  b: {
   if (Or(b, 13822)) {
    cd(b, 12);
    if (!op(b)) {
     wp(d, 2);
    }
    cd(b, 24);
    break b;
   }
   if ($j(b, 13709)) {
    xc(b);
    v[c + 8 >> 2] = 4;
    e = 1;
    break a;
   }
   gd(d, 8);
  }
  e = 0;
 }
 f = a, g = (jf(b) >>> 0) / (B(w[d | 0], jr(w[d + 1 | 0])) >>> 3 >>> 0) | 0, v[f >> 2] = g;
 b = cg(d, a, b);
 if (!(!b | !e)) {
  d = v[a + 20 >> 2];
  f = c, g = Nk(v[a >> 2], x[a + 34 >> 1]), v[f + 4 >> 2] = g;
  Qb(d, 0, v[Gb(c + 8 | 0, c + 4 | 0) >> 2]);
 }
 eb = c + 16 | 0;
 return (b | 0) != 0 | 0;
}

function wra(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0;
 e = eb - 16 | 0;
 eb = e;
 c = Hf(a, c);
 $d(e, v[a + 36 >> 2]);
 a: {
  b: {
   if (!c) {
    Pc(e, a + 32 | 0, 5);
    d = -1;
    if (!Fb(v[v[e >> 2] >> 2], v[e + 4 >> 2])) {
     break b;
    }
    break a;
   }
   d = v[c + 16 >> 2];
  }
  f = v[a + 36 >> 2];
  c: {
   d: {
    switch (d + 1 | 0) {
    case 0:
    case 2:
     d = eb - 32 | 0;
     eb = d;
     t[d + 31 | 0] = 0;
     tj(d + 8 | 0, d + 31 | 0);
     Lm(d + 20 | 0, f, v[d + 8 >> 2], v[d + 12 >> 2]);
     t[b | 0] = w[d + 31 | 0];
     eb = d + 32 | 0;
     break c;

    default:
     break d;
    }
   }
   lZ(f, b, d);
  }
  f = c;
 }
 ef(a, f);
 eb = e + 16 | 0;
}

function waa(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = C(0), j = 0, k = 0;
 c = eb - 16 | 0;
 eb = c;
 h = v[a + 4 >> 2];
 v[c + 8 >> 2] = v[b + 8 >> 2];
 d = v[b + 4 >> 2];
 v[c >> 2] = v[b >> 2];
 v[c + 4 >> 2] = d;
 uM(a, c);
 a: {
  f = A[a + 24 >> 3];
  if (f == 1) {
   break a;
  }
  i = C(f);
  d = v[b + 4 >> 2];
  j = v[b + 8 >> 2];
  b: while (1) {
   if ((e | 0) == (j | 0)) {
    break a;
   }
   k = v[a + 12 >> 2] + (B(v[a + 16 >> 2], e + h | 0) << 2) | 0;
   b = 0;
   while (1) if ((b | 0) == (d | 0)) {
    e = e + 1 | 0;
    continue b;
   } else {
    g = (b << 2) + k | 0;
    z[g >> 2] = z[g >> 2] * i;
    b = b + 1 | 0;
    continue;
   }
  }
 }
 eb = c + 16 | 0;
}

function qN(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0;
 c = eb - 16 | 0;
 eb = c;
 a: {
  b: {
   c: {
    d: {
     if ((b | 0) >= 0) {
      a = v[a + 32 >> 2];
      if ((wo(a) | 0) > (b | 0)) {
       break d;
      }
     }
     b = cc(8);
     v[31601] = 0;
     c = O(36, c + 4 | 0, 10735) | 0;
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) == 1) {
      break c;
     }
     rc(b, c);
     v[31601] = 0;
     R(97, b | 0, 48396, 999);
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) != 1) {
      break a;
     }
     a = M() | 0;
     sb(c);
     break b;
    }
    eb = c + 16 | 0;
    return +(+v[(a + B(b, 872) | 0) + 1075740 >> 2] * .015625);
   }
   a = M() | 0;
   jc(b);
  }
  P(a | 0);
 }
 p();
}

function h$(a) {
 a = a | 0;
 var b = 0, c = 0, d = 0, e = 0, f = 0, g = 0, h = 0;
 c = a + 1068 | 0;
 b = v[a + 1064 >> 2];
 a: {
  while (1) {
   if ((b | 0) > 255) {
    break a;
   }
   g = B(b, 6) + c | 0, h = _k(a, 7), t[g + 4 | 0] = h;
   e = _k(a, 1);
   f = _k(a, 1);
   d = v[a + 1060 >> 2];
   if ((d | 0) > 255) {
    break a;
   }
   b = v[a + 1064 >> 2] + 1 | 0;
   v[a + 1060 >> 2] = b;
   v[a + 1064 >> 2] = b;
   b: {
    if (e) {
     u[B(d, 6) + c >> 1] = b;
     h$(a);
     b = v[a + 1064 >> 2];
     break b;
    }
    u[B(d, 6) + c >> 1] = 65535;
   }
   v[a + 1060 >> 2] = b;
   if (f) {
    u[(B(d, 6) + c | 0) + 2 >> 1] = b;
    continue;
   }
   break;
  }
  u[(B(d, 6) + c | 0) + 2 >> 1] = 65535;
 }
}

function $fa(a) {
 a = a | 0;
 var b = 0, c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0;
 t[a + 4202 | 0] = 1;
 c = Ak(C(C(y[v[a + 16 >> 2] + 24620 >> 2]) * C(.04500000178813934)));
 d = Ak(C(C(c >>> 0) * C(1.1892070770263672)));
 e = Ak(C(C(d >>> 0) * C(1.1892070770263672)));
 h = Ak(C(C(e >>> 0) * C(1.1892070770263672)));
 f = Ak(C(C(c + e >>> 0) * C(.11546666920185089)));
 g = Ak(C(C(d + h >>> 0) * C(.11546666920185089)));
 b = a + 4272 | 0;
 i = xb(b, 0), j = c - f | 0, v[i >> 2] = j;
 i = xb(b, 1), j = e - f | 0, v[i >> 2] = j;
 i = xb(b, 2), j = d - g | 0, v[i >> 2] = j;
 i = xb(b, 3), j = h - g | 0, v[i >> 2] = j;
 i = xb(b, 4), j = f, v[i >> 2] = j;
 i = xb(b, 5), j = g, v[i >> 2] = j;
 KP(a);
 JP(a);
}

function s9() {
 var a = 0, b = 0, c = 0, d = 0, e = 0, f = 0;
 c = eb - 48 | 0;
 eb = c;
 if (AL(1, c + 24 | 0)) {
  Ht(v[31476], 12779);
  p();
 }
 b = we(c + 16 | 0, v[c + 24 >> 2], v[c + 28 >> 2]);
 f = _A(c + 8 | 0, v[c + 32 >> 2]);
 d = eb - 16 | 0;
 eb = d;
 e = eb - 16 | 0;
 eb = e;
 a = we(e + 8 | 0, Aua(v[b >> 2], v[b + 4 >> 2], 1e9, 0), gb);
 b = v[a >> 2];
 a = v[a + 4 >> 2];
 eb = e + 16 | 0;
 v[d >> 2] = b;
 v[d + 4 >> 2] = a;
 a = v[d >> 2];
 e = a + v[f >> 2] | 0;
 f = v[f + 4 >> 2] + v[d + 4 >> 2] | 0;
 b = we(d + 8 | 0, e, a >>> 0 > e >>> 0 ? f + 1 | 0 : f);
 a = v[b >> 2];
 eb = d + 16 | 0;
 b = we(c + 40 | 0, a, v[b + 4 >> 2]);
 a = v[b >> 2];
 eb = c + 48 | 0;
 gb = v[b + 4 >> 2];
 return a | 0;
}

function o9(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0;
 e = eb - 16 | 0;
 eb = e;
 while (1) {
  a: {
   if ((c | 0) <= (f | 0)) {
    break a;
   }
   g = v[a + 28 >> 2];
   d = v[a + 24 >> 2];
   if (g >>> 0 <= d >>> 0) {
    if (((i = a, j = yf(t[b | 0]), h = v[v[a >> 2] + 52 >> 2], hb[h](i | 0, j | 0) | 0) | 0) == -1) {
     break a;
    }
    f = f + 1 | 0;
    b = b + 1 | 0;
   } else {
    v[e + 12 >> 2] = g - d;
    v[e + 8 >> 2] = c - f;
    g = d;
    d = v[Bd(e + 12 | 0, e + 8 | 0) >> 2];
    Cg(g, b, d);
    v[a + 24 >> 2] = d + v[a + 24 >> 2];
    f = f + d | 0;
    b = b + d | 0;
   }
   continue;
  }
  break;
 }
 eb = e + 16 | 0;
 return f | 0;
}

function oU(a, b) {
 var c = 0, d = 0, e = 0, f = 0;
 c = eb - 16 | 0;
 eb = c;
 v[a >> 2] = 0;
 v[a + 4 >> 2] = 0;
 sc(a + 8 | 0);
 Qd(c + 8 | 0, v[ub(c + 4 | 0, a) >> 2]);
 a: {
  if (b) {
   v[31601] = 0;
   N(799, a | 0, b | 0);
   d = v[31601];
   v[31601] = 0;
   if ((d | 0) == 1) {
    break a;
   }
   e = eb - 16 | 0;
   eb = e;
   d = kv(e + 4 | 0, a, b);
   b = v[d + 4 >> 2];
   f = v[d + 8 >> 2];
   while (1) {
    if ((b | 0) == (f | 0)) {
     hc(d);
     eb = e + 16 | 0;
    } else {
     Nl(b, 0, 0);
     b = b + 16 | 0;
     v[d + 4 >> 2] = b;
     continue;
    }
    break;
   }
  }
  b = c + 8 | 0;
  Pd(b);
  dU(b);
  eb = c + 16 | 0;
  return a;
 }
 a = M() | 0;
 dU(c + 8 | 0);
 P(a | 0);
 p();
}

function N0(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0;
 c = eb - 16 | 0;
 eb = c;
 v[c + 12 >> 2] = -1;
 if (dh(a, c + 11 | 0)) {
  v[c + 4 >> 2] = w[c + 11 | 0];
  g = v[Gb(c + 4 | 0, c + 12 | 0) >> 2];
  d = eb + -64 | 0;
  eb = d;
  f = d + 44 | 0;
  rg(f, a, g);
  h = v[d + 44 >> 2];
  a = d + 20 | 0;
  tg(a, 3, Ze(f), h);
  v[31601] = 0;
  e = d + 32 | 0;
  N(218, e | 0, a | 0);
  a = v[31601];
  v[31601] = 0;
  a: {
   if ((a | 0) != 1) {
    a = d + 12 | 0;
    Yb(a, b, 11);
    lm(a, e);
    sb(e);
    Jc(f);
    eb = d - -64 | 0;
    e = !g | (h | 0) != 0;
    break a;
   }
   a = M() | 0;
   Jc(d + 44 | 0);
   P(a | 0);
   p();
  }
 }
 eb = c + 16 | 0;
 return e | 0;
}

function sR(a, b, c, d, e, f, g, h) {
 var i = 0, j = 0;
 i = eb - 16 | 0;
 eb = i;
 v[i + 12 >> 2] = d;
 a: {
  if (!(w[a + 12 | 0] | w[a + 13 | 0] << 8 | (w[a + 14 | 0] << 16 | w[a + 15 | 0] << 24))) {
   break a;
  }
  v[i + 8 >> 2] = w[a + 8 | 0] | w[a + 9 | 0] << 8 | (w[a + 10 | 0] << 16 | w[a + 11 | 0] << 24);
  j = b;
  b = v[Gb(i + 8 | 0, i + 12 | 0) >> 2];
  v[j >> 2] = b;
  b = Kd(w[a + 12 | 0] | w[a + 13 | 0] << 8 | (w[a + 14 | 0] << 16 | w[a + 15 | 0] << 24), b, d);
  v[c >> 2] = ((h ^ 1) & b >>> 0 < d >>> 0) + b;
  b = x[e >> 1] | f;
  u[e >> 1] = b;
  if ((w[a + 4 | 0] | w[a + 5 | 0] << 8 | (w[a + 6 | 0] << 16 | w[a + 7 | 0] << 24)) != 1) {
   break a;
  }
  u[e >> 1] = b | g;
 }
 eb = i + 16 | 0;
}

function ofa(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0;
 v[31601] = 0;
 V(1020, a | 0);
 e = v[31601];
 v[31601] = 0;
 a: {
  b: {
   if ((e | 0) != 1) {
    e = v[a + 28 >> 2];
    f = v[v[e >> 2] + 12 >> 2];
    v[31601] = 0;
    b = aa(f | 0, e | 0, b | 0, c | 0, d | 0) | 0;
    c = v[31601];
    v[31601] = 0;
    if ((c | 0) != 1) {
     break b;
    }
   }
   X(S(0) | 0) | 0;
   v[31601] = 0;
   U(982, 11443, a | 0, 0, 0);
   a = v[31601];
   v[31601] = 0;
   if ((a | 0) == 1) {
    break a;
   }
   Y();
   b = -1;
  }
  return b | 0;
 }
 a = M() | 0;
 v[31601] = 0;
 W(26);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  P(a | 0);
  p();
 }
 S(0) | 0;
 Rb();
 p();
}

function nfa(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0;
 v[31601] = 0;
 V(1020, a | 0);
 e = v[31601];
 v[31601] = 0;
 a: {
  b: {
   if ((e | 0) != 1) {
    e = v[a + 28 >> 2];
    f = v[v[e >> 2] + 8 >> 2];
    v[31601] = 0;
    b = aa(f | 0, e | 0, b | 0, c | 0, d | 0) | 0;
    c = v[31601];
    v[31601] = 0;
    if ((c | 0) != 1) {
     break b;
    }
   }
   X(S(0) | 0) | 0;
   v[31601] = 0;
   U(982, 11479, a | 0, 0, 0);
   a = v[31601];
   v[31601] = 0;
   if ((a | 0) == 1) {
    break a;
   }
   Y();
   b = -1;
  }
  return b | 0;
 }
 a = M() | 0;
 v[31601] = 0;
 W(26);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  P(a | 0);
  p();
 }
 S(0) | 0;
 Rb();
 p();
}

function vK(a, b, c) {
 var d = 0, e = 0, f = C(0), g = 0, h = C(0);
 e = eb - 16 | 0;
 eb = e;
 a: {
  b: {
   c: {
    if ((a | 0) != (b | 0)) {
     g = v[31476];
     v[31476] = 0;
     Nd();
     d = eb - 16 | 0;
     eb = d;
     _x(d, a, e + 12 | 0, 0);
     f = XG(v[d >> 2], v[d + 4 >> 2], v[d + 8 >> 2], v[d + 12 >> 2]);
     eb = d + 16 | 0;
     a = v[31476];
     if (!a) {
      break c;
     }
     if (v[e + 12 >> 2] != (b | 0)) {
      break b;
     }
     h = f;
     if ((a | 0) != 68) {
      break a;
     }
     break b;
    }
    v[c >> 2] = 4;
    break a;
   }
   v[31476] = g;
   if (v[e + 12 >> 2] == (b | 0)) {
    break a;
   }
  }
  v[c >> 2] = 4;
  f = h;
 }
 eb = e + 16 | 0;
 return f;
}

function mna(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0;
 b = eb - 16 | 0;
 eb = b;
 h = v[a + 16 >> 2];
 f = jg(1, 2);
 e = gb;
 i = e;
 Ob(a, f, e);
 j = v[a + 24 >> 2];
 k = v[a + 20 >> 2];
 e = v[a + 4 >> 2];
 v[b + 8 >> 2] = v[a >> 2];
 v[b + 12 >> 2] = e;
 e = v[a + 8 >> 2];
 l = v[a + 12 >> 2];
 while (1) {
  if (d) {
   g = u[(v[b + 12 >> 2] << 1) + h >> 1];
   v[c >> 2] = v[c >> 2] + B(g, k);
   v[c + 4 >> 2] = v[c + 4 >> 2] + B(j, g);
   Ob(b + 8 | 0, e, l);
   c = c + 8 | 0;
   d = d - 1 | 0;
   continue;
  }
  break;
 }
 c = v[b + 12 >> 2];
 v[a >> 2] = v[b + 8 >> 2];
 v[a + 4 >> 2] = c;
 Hg(a, f, i);
 eb = b + 16 | 0;
}

function ufa(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0;
 e = eb - 32 | 0;
 eb = e;
 v[e + 28 >> 2] = c;
 c = e + 28 | 0;
 f = v[re(e + 24 | 0, c) >> 2];
 v[31601] = 0;
 g = v[b + 12 >> 2];
 v[e + 16 >> 2] = v[b + 8 >> 2];
 v[e + 20 >> 2] = g;
 g = v[b + 4 >> 2];
 v[e + 8 >> 2] = v[b >> 2];
 v[e + 12 >> 2] = g;
 aa(989, a + 8 | 0, e + 8 | 0, f | 0, d | 0) | 0;
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  a = Gz(a);
  b = Fz(a + 88 | 0);
  d = Ez(a + 92 | 0);
  f = Dz(a + 96 | 0);
  v[a >> 2] = 47676;
  v[b >> 2] = 47792;
  v[d >> 2] = 47872;
  v[f >> 2] = 47912;
  Wc(c);
  eb = e + 32 | 0;
  return a | 0;
 }
 a = M() | 0;
 Wc(e + 28 | 0);
 P(a | 0);
 p();
}

function VX(a, b) {
 var c = 0, d = 0, e = 0, f = 0;
 c = eb - 32 | 0;
 eb = c;
 a: {
  if (!w[b + 5 | 0]) {
   while (1) {
    if ((d | 0) == 5) {
     d = 0;
     t[c + 28 | 0] = 0;
     v[c + 24 >> 2] = 0;
     e = c + 24 | 0;
     f = Yb(c + 8 | 0, e, 5);
     ic(c + 16 | 0, v[a >> 2], v[a + 8 >> 2], v[f >> 2], v[f + 4 >> 2]);
     b: {
      if (v[c + 20 >> 2] != 5) {
       break b;
      }
      if (id(e, b, 5)) {
       break b;
      }
      Ub(a, 5);
      d = 1;
     }
     eb = c + 32 | 0;
     break a;
    }
    e = b + d | 0;
    d = d + 1 | 0;
    if (w[e | 0]) {
     continue;
    }
    break;
   }
   Z(17480, 9079, 601, 13222);
   p();
  }
  Z(17459, 9079, 599, 13222);
  p();
 }
 return d;
}

function nna(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0, l = 0;
 b = eb - 16 | 0;
 eb = b;
 h = v[a + 16 >> 2];
 f = jg(1, 2);
 e = gb;
 i = e;
 Ob(a, f, e);
 j = v[a + 24 >> 2];
 k = v[a + 20 >> 2];
 e = v[a + 4 >> 2];
 v[b + 8 >> 2] = v[a >> 2];
 v[b + 12 >> 2] = e;
 e = v[a + 8 >> 2];
 l = v[a + 12 >> 2];
 while (1) {
  if (d) {
   g = t[v[b + 12 >> 2] + h | 0] << 8;
   v[c >> 2] = v[c >> 2] + B(g, k);
   v[c + 4 >> 2] = v[c + 4 >> 2] + B(j, g);
   Ob(b + 8 | 0, e, l);
   c = c + 8 | 0;
   d = d - 1 | 0;
   continue;
  }
  break;
 }
 c = v[b + 12 >> 2];
 v[a >> 2] = v[b + 8 >> 2];
 v[a + 4 >> 2] = c;
 Hg(a, f, i);
 eb = b + 16 | 0;
}

function QT(a, b) {
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0;
 e = eb - 16 | 0;
 eb = e;
 j = e, k = Pj(b), v[j + 4 >> 2] = k;
 c = eb - 16 | 0;
 eb = c;
 f = LB(a, c + 12 | 0, x[b >> 1], v[b + 4 >> 2]);
 b = v[f >> 2];
 if (!b) {
  b = eb - 16 | 0;
  eb = b;
  d = fc(a);
  g = Ch(c, Dc(36), Ng(b + 8 | 0, d));
  d = v[g >> 2] + 16 | 0;
  h = v[e + 4 >> 2];
  i = v[h + 4 >> 2];
  v[d >> 2] = v[h >> 2];
  v[d + 4 >> 2] = i;
  Mb(d + 8 | 0);
  j = fc(g), k = 1, t[j + 4 | 0] = k;
  eb = b + 16 | 0;
  _g(a, v[c + 12 >> 2], f, v[c >> 2]);
  b = me(c);
  WT(c);
  d = 1;
 }
 Zg(e + 8 | 0, v[ub(c, b) >> 2], d);
 eb = c + 16 | 0;
 a = td(v[e + 8 >> 2]);
 eb = e + 16 | 0;
 return a + 8 | 0;
}

function $j(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0;
 c = eb - 32 | 0;
 eb = c;
 a: {
  if (!w[b + 4 | 0]) {
   while (1) {
    if ((d | 0) == 4) {
     d = 0;
     v[c + 28 >> 2] = 0;
     e = Yb(c + 8 | 0, c + 28 | 0, 4);
     ic(c + 20 | 0, v[a >> 2], v[a + 8 >> 2], v[e >> 2], v[e + 4 >> 2]);
     if (!(v[c + 24 >> 2] != 4 | v[c + 28 >> 2] != (w[b | 0] | w[b + 1 | 0] << 8 | (w[b + 2 | 0] << 16 | w[b + 3 | 0] << 24)))) {
      Ub(a, 4);
      d = 1;
     }
     eb = c + 32 | 0;
     break a;
    }
    e = b + d | 0;
    d = d + 1 | 0;
    if (w[e | 0]) {
     continue;
    }
    break;
   }
   Z(17480, 9079, 601, 13222);
   p();
  }
  Z(17459, 9079, 599, 13222);
  p();
 }
 return d | 0;
}

function jfa(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0;
 v[31601] = 0;
 V(1020, a | 0);
 d = v[31601];
 v[31601] = 0;
 e = 1;
 a: {
  b: {
   if ((d | 0) != 1) {
    d = v[a + 28 >> 2];
    f = v[v[d >> 2] + 64 >> 2];
    v[31601] = 0;
    R(f | 0, d | 0, b | 0, (c | 0) != 0 | 0);
    b = v[31601];
    v[31601] = 0;
    if ((b | 0) != 1) {
     break b;
    }
   }
   X(S(0) | 0) | 0;
   v[31601] = 0;
   U(982, 6695, a | 0, 0, 0);
   a = v[31601];
   v[31601] = 0;
   if ((a | 0) == 1) {
    break a;
   }
   Y();
   e = 0;
  }
  return e | 0;
 }
 a = M() | 0;
 v[31601] = 0;
 W(26);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  P(a | 0);
  p();
 }
 S(0) | 0;
 Rb();
 p();
}

function hfa(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0;
 v[31601] = 0;
 V(1020, a | 0);
 d = v[31601];
 v[31601] = 0;
 e = 1;
 a: {
  b: {
   if ((d | 0) != 1) {
    d = v[a + 28 >> 2];
    f = v[v[d >> 2] + 56 >> 2];
    v[31601] = 0;
    R(f | 0, d | 0, b | 0, (c | 0) != 0 | 0);
    b = v[31601];
    v[31601] = 0;
    if ((b | 0) != 1) {
     break b;
    }
   }
   X(S(0) | 0) | 0;
   v[31601] = 0;
   U(982, 6749, a | 0, 0, 0);
   a = v[31601];
   v[31601] = 0;
   if ((a | 0) == 1) {
    break a;
   }
   Y();
   e = 0;
  }
  return e | 0;
 }
 a = M() | 0;
 v[31601] = 0;
 W(26);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  P(a | 0);
  p();
 }
 S(0) | 0;
 Rb();
 p();
}

function tK(a, b, c) {
 var d = 0, e = 0, f = 0, g = 0, h = 0;
 e = eb - 16 | 0;
 eb = e;
 a: {
  b: {
   c: {
    if ((a | 0) != (b | 0)) {
     g = v[31476];
     v[31476] = 0;
     Nd();
     d = eb - 16 | 0;
     eb = d;
     _x(d, a, e + 12 | 0, 1);
     f = Fx(v[d >> 2], v[d + 4 >> 2], v[d + 8 >> 2], v[d + 12 >> 2]);
     eb = d + 16 | 0;
     a = v[31476];
     if (!a) {
      break c;
     }
     if (v[e + 12 >> 2] != (b | 0)) {
      break b;
     }
     h = f;
     if ((a | 0) != 68) {
      break a;
     }
     break b;
    }
    v[c >> 2] = 4;
    break a;
   }
   v[31476] = g;
   if (v[e + 12 >> 2] == (b | 0)) {
    break a;
   }
  }
  v[c >> 2] = 4;
  f = h;
 }
 eb = e + 16 | 0;
 return f;
}

function iu(a, b, c, d, e) {
 var f = 0, g = 0;
 a: {
  if (!Vt(b)) {
   break a;
  }
  f = v[a + 484344 >> 2];
  if (!Ie(f, v[a + 484348 >> 2], b & 65535)) {
   break a;
  }
  b = Vb(f, b);
  if (v[b + 12 >> 2] <= (c | 0) | e >>> 0 > 5 | x[a + 480188 >> 1] <= d >>> 0 | (c | d) < 0) {
   break a;
  }
  b = ld(v[b >> 2], v[v[b + 48 >> 2] + 12 >> 2], c, d & 65535);
  b: {
   c: {
    switch (e - 1 | 0) {
    case 0:
     b = b + 1 | 0;
     break b;

    case 1:
     b = b + 2 | 0;
     break b;

    case 2:
     b = b + 3 | 0;
     break b;

    case 3:
     b = b + 4 | 0;
     break b;

    case 4:
     break c;

    default:
     break b;
    }
   }
   b = b + 5 | 0;
  }
  g = w[b | 0];
 }
 return g;
}

function _j(a, b, c, d, e) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 var f = 0, g = 0, h = 0;
 f = eb - 16 | 0;
 eb = f;
 v[f + 12 >> 2] = c;
 a: {
  if (!Lb(v[b >> 2], v[b + 8 >> 2], c)) {
   break a;
  }
  wc(f + 12 | 0, 65535);
  ug(a, x[f + 12 >> 1]);
  c = vb(v[a >> 2]);
  v[f + 4 >> 2] = c;
  h = vb(v[a + 4 >> 2]);
  while (1) {
   if (!Hb(c, h)) {
    break a;
   }
   a = f + 11 | 0;
   if (!dh(b, a)) {
    ch(a);
   }
   a = w[f + 11 | 0];
   u[c >> 1] = a;
   g = 65535;
   b: {
    if ((a | 0) != (d | 0)) {
     g = 65534;
     if ((a | 0) != (e | 0)) {
      break b;
     }
    }
    u[c >> 1] = g;
   }
   c = v[fe(f + 4 | 0) >> 2];
   continue;
  }
 }
 eb = f + 16 | 0;
}

function yO(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0;
 e = eb - 16 | 0;
 eb = e;
 a: {
  b: {
   c: {
    if (!d) {
     a = cc(8);
     v[31601] = 0;
     c = O(36, e + 4 | 0, 8200) | 0;
     b = v[31601];
     v[31601] = 0;
     if ((b | 0) == 1) {
      break c;
     }
     rc(a, c);
     v[31601] = 0;
     R(97, a | 0, 48396, 999);
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) != 1) {
      break a;
     }
     b = M() | 0;
     sb(c);
     break b;
    }
    zl(a, b, 1);
    c = uz(a, c, d, 0, 0, 0);
    A[a + 16 >> 3] = A[a + 16 >> 3] + +(c >>> 0) / +(b | 0);
    eb = e + 16 | 0;
    return c | 0;
   }
   b = M() | 0;
   jc(a);
  }
  P(b | 0);
 }
 p();
}

function rO(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0;
 e = eb - 16 | 0;
 eb = e;
 a: {
  b: {
   c: {
    if (!d) {
     a = cc(8);
     v[31601] = 0;
     c = O(36, e + 4 | 0, 8200) | 0;
     b = v[31601];
     v[31601] = 0;
     if ((b | 0) == 1) {
      break c;
     }
     rc(a, c);
     v[31601] = 0;
     R(97, a | 0, 48396, 999);
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) != 1) {
      break a;
     }
     b = M() | 0;
     sb(c);
     break b;
    }
    zl(a, b, 1);
    c = vz(a, c, d, 0, 0, 0);
    A[a + 16 >> 3] = A[a + 16 >> 3] + +(c >>> 0) / +(b | 0);
    eb = e + 16 | 0;
    return c | 0;
   }
   b = M() | 0;
   jc(a);
  }
  P(b | 0);
 }
 p();
}

function m4(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0;
 e = v[a >> 2];
 f = 6;
 a: {
  b: {
   if ((e | 0) == (b | 0)) {
    break b;
   }
   e = v[e >> 2];
   f = 4;
   if (!nj(d, 64, e)) {
    break b;
   }
   g = ok(d, e);
   f = 4;
   while (1) {
    c: {
     e = v[a >> 2] + 4 | 0;
     v[a >> 2] = e;
     g = g - 48 | 0;
     if ((b | 0) == (e | 0) | f >>> 0 < 2) {
      break c;
     }
     e = v[e >> 2];
     if (!nj(d, 64, e)) {
      break a;
     }
     f = f - 1 | 0;
     g = ok(d, e) + B(g, 10) | 0;
     continue;
    }
    break;
   }
   if ((b | 0) != (e | 0)) {
    break a;
   }
   f = 2;
  }
  v[c >> 2] = f | v[c >> 2];
 }
 return g | 0;
}

function ju(a, b) {
 var c = 0, d = 0, e = 0, f = 0, g = 0;
 e = eb - 16 | 0;
 eb = e;
 c = ce(a);
 d = fc(a);
 f = eb - 16 | 0;
 eb = f;
 while (1) {
  if (c) {
   g = Vu(c + 16 | 0, b);
   d = g ? d : c;
   c = v[(g ? 4 : 0) + c >> 2];
   continue;
  }
  break;
 }
 c = v[ub(f + 12 | 0, d) >> 2];
 eb = f + 16 | 0;
 a: {
  if (Hb(c, og(a))) {
   if (!Vu(b, td(c))) {
    break a;
   }
  }
  c = og(a);
 }
 if (!lc(c, og(a))) {
  b = v[ub(e + 12 | 0, c) >> 2];
  c = eb - 16 | 0;
  eb = c;
  d = $g(ub(c + 12 | 0, b));
  if ((b | 0) == v[a >> 2]) {
   v[a >> 2] = v[d >> 2];
  }
  d = zb(a);
  v[d >> 2] = v[d >> 2] - 1;
  aV(v[fc(a) >> 2], b);
  eb = c + 16 | 0;
  _m(td(b));
  Bb(b);
 }
 eb = e + 16 | 0;
}

function pja(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0;
 e = eb - 32 | 0;
 eb = e;
 d = e + 8 | 0;
 Ue(d, 2, a + 6 | 0);
 f = e + 20 | 0;
 Bc(f, d);
 zc(b + 492 | 0, f);
 d = b + 236 | 0;
 g = c + 1 | 0;
 h = a + 38 | 0;
 sb(f);
 c = 0;
 while (1) {
  if ((c | 0) == 128) {
   v[b >> 2] = (w[a + 226 | 0] | w[a + 227 | 0] << 8) << 5;
   xA(a + 180 | 0, b + 48 | 0, 0);
   xA(a + 228 | 0, b + 88 | 0, 2);
   xA(a + 276 | 0, b + 68 | 0, 1);
   if (!(w[a + 324 | 0] | w[a + 325 | 0] << 8)) {
    Qb(d, 0, 256);
   }
   eb = e + 32 | 0;
  } else {
   i = $b(d, c), j = w[c + h | 0] + g | 0, u[i >> 1] = j;
   c = c + 1 | 0;
   continue;
  }
  break;
 }
}

function jia(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0;
 a = Ii(a, b, c, d);
 v[a >> 2] = 42444;
 b = Mb(a + 4208 | 0);
 v[a + 4236 >> 2] = -1;
 v[a + 4240 >> 2] = 0;
 v[a + 4228 >> 2] = 1049926264;
 v[a + 4232 >> 2] = 0;
 v[a + 4220 >> 2] = 1056964608;
 v[a + 4224 >> 2] = 1056964608;
 t[a + 4244 | 0] = 0;
 Qb(a + 4248 | 0, 0, 48);
 v[31601] = 0;
 W(849);
 c = v[31601];
 v[31601] = 0;
 a: {
  if ((c | 0) == 1) {
   break a;
  }
  e = a, f = jS(), v[e + 4296 >> 2] = f;
  su(a);
  ru(a);
  v[31601] = 0;
  N(940, a + 44 | 0, 2);
  c = v[31601];
  v[31601] = 0;
  if ((c | 0) == 1) {
   break a;
  }
  return a | 0;
 }
 c = M() | 0;
 ec(b);
 Zf(a);
 P(c | 0);
 p();
}

function gj(a, b, c, d, e) {
 var f = 0, g = 0, h = 0;
 f = eb - 16 | 0;
 eb = f;
 v[f + 12 >> 2] = b;
 b = 0;
 g = 6;
 a: {
  b: {
   if (sh(a, f + 12 | 0)) {
    break b;
   }
   h = rl(v[a >> 2]);
   g = 4;
   if (!If(v[d + 8 >> 2], 64, h)) {
    break b;
   }
   b = kl(d, h);
   while (1) {
    c: {
     b = b - 48 | 0;
     h = Dm(a);
     if (sh(h, f + 12 | 0) | (e | 0) < 2) {
      break c;
     }
     g = rl(v[h >> 2]);
     if (!If(v[d + 8 >> 2], 64, g)) {
      break a;
     }
     e = e - 1 | 0;
     b = kl(d, g) + B(b, 10) | 0;
     continue;
    }
    break;
   }
   g = 2;
   if (!sh(h, f + 12 | 0)) {
    break a;
   }
  }
  v[c >> 2] = v[c >> 2] | g;
 }
 eb = f + 16 | 0;
 return b;
}

function oaa(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0;
 f = eb - 16 | 0;
 eb = f;
 e = f + 4 | 0;
 v[e + 4 >> 2] = 1;
 h = e, i = Dc(56), v[h + 8 >> 2] = i;
 c = qm(v[e + 8 >> 2]);
 v[c >> 2] = 77200;
 g = mc(c);
 c = eb - 16 | 0;
 eb = c;
 d = v[b + 12 >> 2];
 v[c + 8 >> 2] = v[b + 8 >> 2];
 v[c + 12 >> 2] = d;
 d = v[b + 4 >> 2];
 v[c >> 2] = v[b >> 2];
 v[c + 4 >> 2] = d;
 d = rM(g);
 v[d >> 2] = 77364;
 b = v[c + 4 >> 2];
 v[d + 24 >> 2] = v[c >> 2];
 v[d + 28 >> 2] = b;
 b = v[c + 12 >> 2];
 v[d + 32 >> 2] = v[c + 8 >> 2];
 v[d + 36 >> 2] = b;
 t[d + 40 | 0] = 0;
 eb = c + 16 | 0;
 b = a;
 a = Qn(e);
 Pn(b, mc(a), a);
 rm(e);
 eb = f + 16 | 0;
}

function apa(a) {
 a = a | 0;
 var b = 0, c = 0, d = 0;
 b = eb - 16 | 0;
 eb = b;
 t[b + 15 | 0] = 128;
 a = kw(a, 127, b + 15 | 0);
 v[31601] = 0;
 t[b + 14 | 0] = 64;
 d = T(599, a + 12 | 0, 127, b + 14 | 0) | 0;
 c = v[31601];
 v[31601] = 0;
 a: {
  b: {
   if ((c | 0) != 1) {
    v[31601] = 0;
    t[b + 13 | 0] = 0;
    O(679, a + 24 | 0, b + 13 | 0) | 0;
    c = v[31601];
    v[31601] = 0;
    if ((c | 0) == 1) {
     break b;
    }
    v[a + 44 >> 2] = 0;
    v[a + 48 >> 2] = 0;
    v[a + 36 >> 2] = -1;
    v[a + 40 >> 2] = 108855296;
    u[a + 52 >> 1] = 0;
    eb = b + 16 | 0;
    return a | 0;
   }
   b = M() | 0;
   break a;
  }
  b = M() | 0;
  ec(d);
 }
 ec(a);
 P(b | 0);
 p();
}

function ffa(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = +c;
 var d = 0, e = 0, f = 0;
 v[31601] = 0;
 V(1020, a | 0);
 d = v[31601];
 v[31601] = 0;
 e = 1;
 a: {
  b: {
   if ((d | 0) != 1) {
    d = v[a + 28 >> 2];
    f = v[v[d >> 2] + 48 >> 2];
    v[31601] = 0;
    qa(f | 0, d | 0, b | 0, +c);
    b = v[31601];
    v[31601] = 0;
    if ((b | 0) != 1) {
     break b;
    }
   }
   X(S(0) | 0) | 0;
   v[31601] = 0;
   U(982, 11678, a | 0, 0, 0);
   a = v[31601];
   v[31601] = 0;
   if ((a | 0) == 1) {
    break a;
   }
   Y();
   e = 0;
  }
  return e | 0;
 }
 a = M() | 0;
 v[31601] = 0;
 W(26);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  P(a | 0);
  p();
 }
 S(0) | 0;
 Rb();
 p();
}

function Xea(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = +c;
 var d = 0, e = 0, f = 0;
 v[31601] = 0;
 V(1020, a | 0);
 d = v[31601];
 v[31601] = 0;
 e = 1;
 a: {
  b: {
   if ((d | 0) != 1) {
    d = v[a + 28 >> 2];
    f = v[v[d >> 2] + 96 >> 2];
    v[31601] = 0;
    qa(f | 0, d | 0, b | 0, +c);
    b = v[31601];
    v[31601] = 0;
    if ((b | 0) != 1) {
     break b;
    }
   }
   X(S(0) | 0) | 0;
   v[31601] = 0;
   U(982, 11616, a | 0, 0, 0);
   a = v[31601];
   v[31601] = 0;
   if ((a | 0) == 1) {
    break a;
   }
   Y();
   e = 0;
  }
  return e | 0;
 }
 a = M() | 0;
 v[31601] = 0;
 W(26);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  P(a | 0);
  p();
 }
 S(0) | 0;
 Rb();
 p();
}

function Vea(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = +c;
 var d = 0, e = 0, f = 0;
 v[31601] = 0;
 V(1020, a | 0);
 d = v[31601];
 v[31601] = 0;
 e = 1;
 a: {
  b: {
   if ((d | 0) != 1) {
    d = v[a + 28 >> 2];
    f = v[v[d >> 2] + 88 >> 2];
    v[31601] = 0;
    qa(f | 0, d | 0, b | 0, +c);
    b = v[31601];
    v[31601] = 0;
    if ((b | 0) != 1) {
     break b;
    }
   }
   X(S(0) | 0) | 0;
   v[31601] = 0;
   U(982, 11066, a | 0, 0, 0);
   a = v[31601];
   v[31601] = 0;
   if ((a | 0) == 1) {
    break a;
   }
   Y();
   e = 0;
  }
  return e | 0;
 }
 a = M() | 0;
 v[31601] = 0;
 W(26);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  P(a | 0);
  p();
 }
 S(0) | 0;
 Rb();
 p();
}

function qo(a, b) {
 var c = 0, d = 0, e = 0;
 c = eb - 16 | 0;
 eb = c;
 Rk(c + 4 | 0, b);
 b = 0;
 a = Eb(a);
 d = w[c + 15 | 0];
 e = v[c + 8 >> 2];
 v[31601] = 0;
 N(110, a | 0, xh(e, d) | 0);
 d = v[31601];
 v[31601] = 0;
 if ((d | 0) != 1) {
  a: {
   b: {
    while (1) {
     if (xh(v[c + 8 >> 2], w[c + 15 | 0]) >>> 0 <= b >>> 0) {
      break b;
     }
     d = t[dc(c + 4 | 0, b) | 0];
     v[31601] = 0;
     N(111, a | 0, d | 0);
     d = v[31601];
     v[31601] = 0;
     if ((d | 0) != 1) {
      b = b + 1 | 0;
      continue;
     }
     break;
    }
    break a;
   }
   sb(c + 4 | 0);
   eb = c + 16 | 0;
   return;
  }
 }
 b = M() | 0;
 sb(a);
 sb(c + 4 | 0);
 P(b | 0);
 p();
}

function Wsa(a, b, c, d, e) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 var f = 0, g = 0, h = 0, i = 0;
 h = eb - 16 | 0;
 eb = h;
 v[h + 12 >> 2] = d;
 g = Cb(v[a + 4 >> 2], w[a + 11 | 0]);
 f = Lc(a);
 a: {
  if (f - g >>> 0 >= b >>> 0) {
   f = Jb(a);
   if ((c | 0) == (g | 0)) {
    break a;
   }
   i = c + f | 0;
   Mi(i + b | 0, i, g - c | 0);
   break a;
  }
  $m(a, f, (b + g | 0) - f | 0, g, c, 0, b);
  f = v[a >> 2];
 }
 b = b + g | 0;
 kg(a, b);
 gd(b + f | 0, 0);
 b = c + f | 0;
 while (1) {
  if (Hb(d, e)) {
   gd(b, w[d | 0]);
   b = b + 1 | 0;
   d = v[xe(h + 12 | 0) >> 2];
   continue;
  }
  break;
 }
 a = Pe(yd(a), c);
 eb = h + 16 | 0;
 return a | 0;
}

function $M(a, b) {
 var c = 0, d = 0, e = 0;
 c = eb - 16 | 0;
 eb = c;
 Tf(c + 4 | 0, b);
 b = 0;
 a = Eb(a);
 d = w[c + 15 | 0];
 e = v[c + 8 >> 2];
 v[31601] = 0;
 N(93, a | 0, xh(e, d) | 0);
 d = v[31601];
 v[31601] = 0;
 if ((d | 0) != 1) {
  a: {
   b: {
    while (1) {
     if (xh(v[c + 8 >> 2], w[c + 15 | 0]) >>> 0 <= b >>> 0) {
      break b;
     }
     d = w[dc(c + 4 | 0, b) | 0];
     v[31601] = 0;
     N(95, a | 0, d | 0);
     d = v[31601];
     v[31601] = 0;
     if ((d | 0) != 1) {
      b = b + 1 | 0;
      continue;
     }
     break;
    }
    break a;
   }
   sb(c + 4 | 0);
   eb = c + 16 | 0;
   return;
  }
 }
 b = M() | 0;
 sb(a);
 sb(c + 4 | 0);
 P(b | 0);
 p();
}

function z4(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0;
 while (1) {
  if ((b | 0) != (c | 0)) {
   a = v[b >> 2];
   a: {
    b: {
     if (a >>> 0 <= 127) {
      a = v[(a << 2) + 95312 >> 2];
      break b;
     }
     e = (Xs(a) | 0) != 0;
     e = Ws(a) ? e | 2 : e;
     e = Vs(a) ? e | 4 : e;
     e = Us(a) ? e | 8 : e;
     e = Ts(a) ? e | 16 : e;
     e = Ss(a) ? e | 32 : e;
     e = Zn(a) ? e | 64 : e;
     e = Rs(a) ? e | 128 : e;
     e = _n(a) ? e | 256 : e;
     v[d >> 2] = e;
     if (!Qs(a)) {
      break a;
     }
     a = e | 512;
    }
    v[d >> 2] = a;
   }
   d = d + 4 | 0;
   b = b + 4 | 0;
   continue;
  }
  break;
 }
 return c | 0;
}

function yW(a) {
 var b = 0, c = 0, d = 0;
 b = eb - 16 | 0;
 eb = b;
 v[b + 4 >> 2] = ((w[a + 48 | 0] | w[a + 49 | 0] << 8) << 1) + ((w[a + 32 | 0] | w[a + 33 | 0] << 8) << 4);
 v[b + 8 >> 2] = ((w[a + 50 | 0] | w[a + 51 | 0] << 8) << 1) + ((w[a + 34 | 0] | w[a + 35 | 0] << 8) << 4);
 v[b + 12 >> 2] = (B(w[a + 52 | 0] | w[a + 53 | 0] << 8, 5) + ((w[a + 36 | 0] | w[a + 37 | 0] << 8) << 4) | 0) + 32;
 a = b + 4 | 0;
 d = xb(a, 3);
 a: {
  if ((a | 0) == (d | 0)) {
   break a;
  }
  c = a;
  while (1) {
   c = c + 4 | 0;
   if ((d | 0) == (c | 0)) {
    break a;
   }
   a = _q(v[a >> 2], v[c >> 2]) ? c : a;
   continue;
  }
 }
 eb = b + 16 | 0;
 a = v[a >> 2];
 gb = a >> 31;
 return a;
}

function jma(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0;
 f = Jb(c);
 c = Cb(v[c + 4 >> 2], w[c + 11 | 0]);
 a: {
  d = Cb(v[a + 4 >> 2], w[a + 11 | 0]);
  if (d >>> 0 >= b >>> 0) {
   e = Lc(a);
   if (c >>> 0 <= e - d >>> 0) {
    if (!c) {
     break a;
    }
    e = Jb(a);
    h = e + b | 0;
    if ((b | 0) != (d | 0)) {
     g = b + e | 0;
     Mi(c + g | 0, g, d - b | 0);
     f = (f >>> 0 >= g >>> 0 ? d + e >>> 0 > f >>> 0 ? c : 0 : 0) + f | 0;
    }
    Mi(h, f, c);
    b = c + d | 0;
    kg(a, b);
    gd(b + e | 0, 0);
    break a;
   }
   Uq(a, e, (c + d | 0) - e | 0, d, b, 0, c, f);
   break a;
  }
  cn();
  p();
 }
 return a | 0;
}

function fN(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = +c;
 var d = 0, e = 0, f = 0;
 d = eb - 16 | 0;
 eb = d;
 a: {
  b: {
   c: {
    if (b >>> 0 >= 256) {
     b = cc(8);
     v[31601] = 0;
     d = O(36, d + 4 | 0, 10735) | 0;
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) == 1) {
      break c;
     }
     rc(b, d);
     v[31601] = 0;
     R(97, b | 0, 48396, 999);
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) != 1) {
      break a;
     }
     a = M() | 0;
     sb(d);
     break b;
    }
    e = (v[a + 32 >> 2] + B(b, 872) | 0) + 1075766 | 0, f = vC(c * 32768), u[e >> 1] = f;
    eb = d + 16 | 0;
    return;
   }
   a = M() | 0;
   jc(b);
  }
  P(a | 0);
 }
 p();
}

function rja(a) {
 a = a | 0;
 var b = 0, c = 0, d = 0, e = 0;
 e = eb - 16 | 0;
 eb = e;
 b = Dc(2500);
 c = eb - 2496 | 0;
 eb = c;
 xQ(a, c, c + 2496 | 0);
 a = 0;
 while (1) {
  if ((a | 0) == 624) {
   v[b + 2496 >> 2] = 0;
   a: {
    if (v[b >> 2] < 0) {
     break a;
    }
    a = 1;
    while (1) {
     if ((a | 0) != 624) {
      d = a << 2;
      a = a + 1 | 0;
      if (!v[b + d >> 2]) {
       continue;
      }
      break a;
     }
     break;
    }
    v[b >> 2] = -2147483648;
   }
   eb = c + 2496 | 0;
  } else {
   d = a << 2;
   v[d + b >> 2] = v[c + d >> 2];
   a = a + 1 | 0;
   continue;
  }
  break;
 }
 a = xf(e + 12 | 0, b);
 eb = e + 16 | 0;
 return v[a >> 2];
}

function pda(a, b, c) {
 a = a | 0;
 b = +b;
 c = c | 0;
 var d = 0, e = 0;
 d = eb - 48 | 0;
 eb = d;
 v[d + 44 >> 2] = c;
 c = Ld(d + 16 | 0);
 v[31601] = 0;
 e = v[c + 4 >> 2];
 v[d >> 2] = v[c >> 2];
 v[d + 4 >> 2] = e;
 c = d + 24 | 0;
 R(1114, c | 0, a | 0, d | 0);
 a = v[31601];
 v[31601] = 0;
 a: {
  b: {
   if ((a | 0) != 1) {
    a = d + 44 | 0;
    e = v[re(d + 12 | 0, a) >> 2];
    v[31601] = 0;
    b = +oa(980, c | 0, +b, e | 0);
    e = v[31601];
    v[31601] = 0;
    if ((e | 0) == 1) {
     break b;
    }
    tb(c);
    Wc(a);
    eb = d + 48 | 0;
    return +b;
   }
   c = M() | 0;
   break a;
  }
  c = M() | 0;
  tb(d + 24 | 0);
 }
 Wc(d + 44 | 0);
 P(c | 0);
 p();
}

function sna(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0;
 d = eb - 16 | 0;
 eb = d;
 a: {
  c = v[b + 4 >> 2];
  if (!c) {
   break a;
  }
  u[d >> 1] = x[a + 480190 >> 1];
  u[d + 14 >> 1] = c - 1;
  f = a + 946304 | 0;
  c = x[Nc(d, d + 14 | 0) >> 1];
  while (1) {
   if (!c) {
    break a;
   }
   b: {
    if (FC(v[b >> 2], c)) {
     break b;
    }
    if (PR(a, c & 65535)) {
     e = Cc(d, 22256);
     zc((c << 5) + f | 0, e);
     sb(e);
    }
    if ((c | 0) == 1) {
     break b;
    }
    e = x[a + 480190 >> 1];
    if ((e | 0) != (c | 0)) {
     break b;
    }
    u[a + 480190 >> 1] = e - 1;
   }
   c = c - 1 | 0;
   continue;
  }
 }
 eb = d + 16 | 0;
}

function Woa(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0;
 a: {
  a = DC(a, b);
  v[31601] = 0;
  c = O(683, a + 12 | 0, b + 12 | 0) | 0;
  d = v[31601];
  v[31601] = 0;
  b: {
   c: {
    if ((d | 0) != 1) {
     v[31601] = 0;
     O(684, a + 24 | 0, b + 24 | 0) | 0;
     d = v[31601];
     v[31601] = 0;
     if ((d | 0) == 1) {
      break c;
     }
     c = v[b + 40 >> 2];
     v[a + 36 >> 2] = v[b + 36 >> 2];
     v[a + 40 >> 2] = c;
     u[a + 52 >> 1] = x[b + 52 >> 1];
     c = v[b + 48 >> 2];
     v[a + 44 >> 2] = v[b + 44 >> 2];
     v[a + 48 >> 2] = c;
     break a;
    }
    b = M() | 0;
    break b;
   }
   b = M() | 0;
   ec(c);
  }
  ec(a);
  P(b | 0);
  p();
 }
}

function IL(a) {
 var b = 0, c = C(0), d = C(0), e = C(0), f = C(0), g = C(0), h = C(0), i = 0, j = 0, k = 0, l = C(0), m = C(0), n = C(0), o = C(0), p = 0;
 c = z[a >> 2];
 i = a - 16 | 0;
 d = z[i >> 2];
 e = C(c + d);
 b = a - 8 | 0;
 f = z[b >> 2];
 j = a - 24 | 0;
 g = z[j >> 2];
 h = C(f + g);
 z[a >> 2] = e + h;
 z[b >> 2] = e - h;
 b = a - 12 | 0;
 h = z[b >> 2];
 k = a - 28 | 0;
 l = z[k >> 2];
 e = C(h + l);
 p = b;
 b = a - 4 | 0;
 m = z[b >> 2];
 a = a - 20 | 0;
 n = z[a >> 2];
 o = C(m + n);
 z[p >> 2] = o - e;
 f = C(f - g);
 g = C(m - n);
 z[k >> 2] = f + g;
 c = C(c - d);
 d = C(h - l);
 z[i >> 2] = c + d;
 z[j >> 2] = c - d;
 z[b >> 2] = e + o;
 z[a >> 2] = g - f;
}

function Sg(a, b) {
 var c = 0, d = 0, e = 0, f = 0, g = 0;
 e = Jb(a);
 d = Cb(v[a + 4 >> 2], w[a + 11 | 0]);
 c = Df(b);
 a = 0;
 a: {
  if (!c) {
   break a;
  }
  a = e;
  d = d + a | 0;
  c = b + c | 0;
  b: {
   if ((c | 0) == (b | 0)) {
    break b;
   }
   c: {
    c = c - b | 0;
    if ((c | 0) > (d - a | 0)) {
     break c;
    }
    g = w[b | 0];
    while (1) {
     f = d - a | 0;
     if ((c | 0) > (f | 0)) {
      break c;
     }
     a = sq(a, (f - c | 0) + 1 | 0, g);
     if (!a) {
      break c;
     }
     if (!ot(a, b, c)) {
      break b;
     }
     a = a + 1 | 0;
     continue;
    }
   }
   a = d;
  }
  a = (a | 0) == (d | 0) ? -1 : a - e | 0;
 }
 return a;
}

function nba(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0;
 c = eb - 16 | 0;
 eb = c;
 Qo(c + 4 | 0, b);
 b = 0;
 a = Eb(a);
 d = w[c + 15 | 0];
 e = v[c + 8 >> 2];
 v[31601] = 0;
 N(110, a | 0, xh(e, d) | 0);
 d = v[31601];
 v[31601] = 0;
 if ((d | 0) != 1) {
  a: {
   while (1) {
    if (xh(v[c + 8 >> 2], w[c + 15 | 0]) >>> 0 > b >>> 0) {
     d = t[dc(c + 4 | 0, b) | 0];
     v[31601] = 0;
     N(111, a | 0, d | 0);
     d = v[31601];
     v[31601] = 0;
     if ((d | 0) == 1) {
      break a;
     }
     b = b + 1 | 0;
     continue;
    }
    break;
   }
   sb(c + 4 | 0);
   eb = c + 16 | 0;
   return;
  }
 }
 b = M() | 0;
 sb(a);
 sb(c + 4 | 0);
 P(b | 0);
 p();
}

function c9(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0;
 f = eb - 16 | 0;
 eb = f;
 while (1) {
  a: {
   if ((c | 0) <= (g | 0)) {
    break a;
   }
   d = v[a + 24 >> 2];
   e = v[a + 28 >> 2];
   if (d >>> 0 >= e >>> 0) {
    if ((hb[v[v[a >> 2] + 52 >> 2]](a, v[b >> 2]) | 0) == -1) {
     break a;
    }
    g = g + 1 | 0;
    b = b + 4 | 0;
   } else {
    v[f + 12 >> 2] = e - d >> 2;
    v[f + 8 >> 2] = c - g;
    e = d;
    d = v[Bd(f + 12 | 0, f + 8 | 0) >> 2];
    Qi(e, b, d);
    e = d << 2;
    v[a + 24 >> 2] = e + v[a + 24 >> 2];
    g = g + d | 0;
    b = b + e | 0;
   }
   continue;
  }
  break;
 }
 eb = f + 16 | 0;
 return g | 0;
}

function Gx(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0;
 c = eb - 16 | 0;
 eb = c;
 Rk(c + 4 | 0, b);
 b = 0;
 a = Eb(a);
 d = w[c + 15 | 0];
 e = v[c + 8 >> 2];
 v[31601] = 0;
 N(110, a | 0, xh(e, d) | 0);
 d = v[31601];
 v[31601] = 0;
 if ((d | 0) != 1) {
  a: {
   while (1) {
    if (xh(v[c + 8 >> 2], w[c + 15 | 0]) >>> 0 > b >>> 0) {
     d = t[dc(c + 4 | 0, b) | 0];
     v[31601] = 0;
     N(111, a | 0, d | 0);
     d = v[31601];
     v[31601] = 0;
     if ((d | 0) == 1) {
      break a;
     }
     b = b + 1 | 0;
     continue;
    }
    break;
   }
   sb(c + 4 | 0);
   eb = c + 16 | 0;
   return;
  }
 }
 b = M() | 0;
 sb(a);
 sb(c + 4 | 0);
 P(b | 0);
 p();
}

function MZ(a) {
 var b = 0, c = 0, d = 0, e = 0;
 a: {
  if ((w[a + 60 | 0] | w[a + 61 | 0] << 8 | (w[a + 62 | 0] << 16 | w[a + 63 | 0] << 24)) != 808537417 | (w[a + 32 | 0] | w[a + 33 | 0] << 8) >>> 0 > 256 | (w[a + 49 | 0] < 32 | (w[a + 36 | 0] | w[a + 37 | 0] << 8) >>> 0 > 255)) {
   break a;
  }
  if (t[a + 51 | 0] < 4 | w[a + 50 | 0] > 64) {
   break a;
  }
  d = a + 15 | 0;
  a = 64;
  while (1) {
   if ((a | 0) == 576) {
    e = b;
    break a;
   }
   c = 1;
   b: {
    switch (w[a + d | 0]) {
    case 2:
     c = b;
     break;

    case 0:
    case 1:
     break b;

    default:
     break a;
    }
   }
   a = a + 16 | 0;
   b = c;
   continue;
  }
 }
 return e & 1;
}

function xN(a, b) {
 a = a | 0;
 b = +b;
 var c = 0, d = 0, e = 0, f = 0;
 c = eb - 16 | 0;
 eb = c;
 a: {
  b: {
   c: {
    if (b <= 0 | b > 4) {
     a = cc(8);
     v[31601] = 0;
     c = O(36, c + 4 | 0, 7854) | 0;
     d = v[31601];
     v[31601] = 0;
     if ((d | 0) == 1) {
      break c;
     }
     rc(a, c);
     v[31601] = 0;
     R(97, a | 0, 48396, 999);
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) != 1) {
      break a;
     }
     d = M() | 0;
     sb(c);
     break b;
    }
    a = v[a + 32 >> 2];
    e = a, f = Te(65536 / b), v[e + 480244 >> 2] = f;
    Cq(a);
    eb = c + 16 | 0;
    return;
   }
   d = M() | 0;
   jc(a);
  }
  P(d | 0);
 }
 p();
}

function vN(a, b) {
 a = a | 0;
 b = +b;
 var c = 0, d = 0, e = 0, f = 0;
 c = eb - 16 | 0;
 eb = c;
 a: {
  b: {
   c: {
    if (b <= 0 | b > 4) {
     a = cc(8);
     v[31601] = 0;
     c = O(36, c + 4 | 0, 7875) | 0;
     d = v[31601];
     v[31601] = 0;
     if ((d | 0) == 1) {
      break c;
     }
     rc(a, c);
     v[31601] = 0;
     R(97, a | 0, 48396, 999);
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) != 1) {
      break a;
     }
     d = M() | 0;
     sb(c);
     break b;
    }
    a = v[a + 32 >> 2];
    e = a, f = Te(b * 65536), v[e + 480240 >> 2] = f;
    Cq(a);
    eb = c + 16 | 0;
    return;
   }
   d = M() | 0;
   jc(a);
  }
  P(d | 0);
 }
 p();
}

function mfa(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0;
 v[31601] = 0;
 V(1020, a | 0);
 c = v[31601];
 v[31601] = 0;
 d = 1;
 a: {
  b: {
   if ((c | 0) != 1) {
    c = v[a + 28 >> 2];
    e = v[v[c >> 2] + 76 >> 2];
    v[31601] = 0;
    N(e | 0, c | 0, b | 0);
    b = v[31601];
    v[31601] = 0;
    if ((b | 0) != 1) {
     break b;
    }
   }
   X(S(0) | 0) | 0;
   v[31601] = 0;
   U(982, 11308, a | 0, 0, 0);
   a = v[31601];
   v[31601] = 0;
   if ((a | 0) == 1) {
    break a;
   }
   Y();
   d = 0;
  }
  return d | 0;
 }
 a = M() | 0;
 v[31601] = 0;
 W(26);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  P(a | 0);
  p();
 }
 S(0) | 0;
 Rb();
 p();
}

function Zea(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0;
 v[31601] = 0;
 V(1020, a | 0);
 c = v[31601];
 v[31601] = 0;
 d = 1;
 a: {
  b: {
   if ((c | 0) != 1) {
    c = v[a + 28 >> 2];
    e = v[v[c >> 2] + 16 >> 2];
    v[31601] = 0;
    N(e | 0, c | 0, b | 0);
    b = v[31601];
    v[31601] = 0;
    if ((b | 0) != 1) {
     break b;
    }
   }
   X(S(0) | 0) | 0;
   v[31601] = 0;
   U(982, 12847, a | 0, 0, 0);
   a = v[31601];
   v[31601] = 0;
   if ((a | 0) == 1) {
    break a;
   }
   Y();
   d = 0;
  }
  return d | 0;
 }
 a = M() | 0;
 v[31601] = 0;
 W(26);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  P(a | 0);
  p();
 }
 S(0) | 0;
 Rb();
 p();
}

function Uea(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0;
 v[31601] = 0;
 V(1020, a | 0);
 c = v[31601];
 v[31601] = 0;
 d = 1;
 a: {
  b: {
   if ((c | 0) != 1) {
    c = v[a + 28 >> 2];
    e = v[v[c >> 2] + 84 >> 2];
    v[31601] = 0;
    N(e | 0, c | 0, b | 0);
    b = v[31601];
    v[31601] = 0;
    if ((b | 0) != 1) {
     break b;
    }
   }
   X(S(0) | 0) | 0;
   v[31601] = 0;
   U(982, 12330, a | 0, 0, 0);
   a = v[31601];
   v[31601] = 0;
   if ((a | 0) == 1) {
    break a;
   }
   Y();
   d = 0;
  }
  return d | 0;
 }
 a = M() | 0;
 v[31601] = 0;
 W(26);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  P(a | 0);
  p();
 }
 S(0) | 0;
 Rb();
 p();
}

function Tea(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0;
 v[31601] = 0;
 V(1020, a | 0);
 c = v[31601];
 v[31601] = 0;
 d = 1;
 a: {
  b: {
   if ((c | 0) != 1) {
    c = v[a + 28 >> 2];
    e = v[v[c >> 2] + 80 >> 2];
    v[31601] = 0;
    N(e | 0, c | 0, b | 0);
    b = v[31601];
    v[31601] = 0;
    if ((b | 0) != 1) {
     break b;
    }
   }
   X(S(0) | 0) | 0;
   v[31601] = 0;
   U(982, 11152, a | 0, 0, 0);
   a = v[31601];
   v[31601] = 0;
   if ((a | 0) == 1) {
    break a;
   }
   Y();
   d = 0;
  }
  return d | 0;
 }
 a = M() | 0;
 v[31601] = 0;
 W(26);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  P(a | 0);
  p();
 }
 S(0) | 0;
 Rb();
 p();
}

function G7(a, b, c, d, e) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 var f = 0, g = 0, h = 0, i = 0, j = 0, k = 0;
 a = eb - 208 | 0;
 eb = a;
 g = Nd();
 v[a >> 2] = e;
 e = a + 176 | 0;
 h = oh(e, 20, g, 9262, a);
 g = h + e | 0;
 i = ij(e, g, v[c + 4 >> 2]);
 f = a + 12 | 0;
 bd(f, v[c + 28 >> 2]);
 v[31601] = 0;
 j = Q(1251, v[a + 12 >> 2]) | 0;
 k = v[31601];
 v[31601] = 0;
 if ((k | 0) != 1) {
  Zb(f);
  f = e;
  e = a + 16 | 0;
  nK(j, f, g, e);
  f = b;
  b = e + (h << 2) | 0;
  b = pt(f, e, (g | 0) == (i | 0) ? b : ((i - a << 2) + a | 0) - 688 | 0, b, c, d);
  eb = a + 208 | 0;
  return b | 0;
 }
 b = M() | 0;
 Zb(a + 12 | 0);
 P(b | 0);
 p();
}

function $m(a, b, c, d, e, f, g) {
 var h = 0, i = 0, j = 0;
 h = eb - 16 | 0;
 eb = h;
 a: {
  if (2147483631 - b >>> 0 >= c >>> 0) {
   j = Jb(a);
   i = h + 4 | 0;
   if (b >>> 0 <= 1073741798) {
    v[h + 12 >> 2] = b << 1;
    v[h + 4 >> 2] = b + c;
    c = Eh(v[ad(i, h + 12 | 0) >> 2]) + 1 | 0;
   } else {
    c = 2147483631;
   }
   pg(i, c);
   c = v[h + 4 >> 2];
   if (e) {
    Cg(c, j, e);
   }
   i = e + f | 0;
   if ((i | 0) != (d | 0)) {
    Cg((c + e | 0) + g | 0, (e + j | 0) + f | 0, d - i | 0);
   }
   if ((b | 0) != 10) {
    Bb(j);
   }
   xd(a, c);
   of(a, v[h + 8 >> 2]);
   eb = h + 16 | 0;
   break a;
  }
  pf();
  p();
 }
 Ad(a, (d - f | 0) + g | 0);
}

function fj(a, b, c, d, e) {
 var f = 0, g = 0, h = 0;
 f = eb - 16 | 0;
 eb = f;
 v[f + 12 >> 2] = b;
 b = 0;
 g = 6;
 a: {
  b: {
   if (ei(a, f + 12 | 0)) {
    break b;
   }
   g = 4;
   h = ql(v[a >> 2]);
   if (!nj(d, 64, h)) {
    break b;
   }
   b = ok(d, h);
   while (1) {
    c: {
     b = b - 48 | 0;
     h = io(a);
     if (ei(h, f + 12 | 0) | (e | 0) < 2) {
      break c;
     }
     g = ql(v[h >> 2]);
     if (!nj(d, 64, g)) {
      break a;
     }
     e = e - 1 | 0;
     b = ok(d, g) + B(b, 10) | 0;
     continue;
    }
    break;
   }
   g = 2;
   if (!ei(h, f + 12 | 0)) {
    break a;
   }
  }
  v[c >> 2] = v[c >> 2] | g;
 }
 eb = f + 16 | 0;
 return b;
}

function f3(a, b, c, d, e, f, g, h, i, j) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 f = f | 0;
 g = g | 0;
 h = h | 0;
 i = i | 0;
 j = j | 0;
 v[31601] = 0;
 a = Ga(1094, a | 0, b | 0, c | 0, d | 0) | 0;
 b = v[31601];
 v[31601] = 0;
 a: {
  b: {
   if ((b | 0) == 1) {
    X(S(0) | 0) | 0;
    v[31601] = 0;
    fa(978, 11192, e | 0, f | 0, g | 0, h | 0, i | 0, j | 0);
    a = v[31601];
    v[31601] = 0;
    if ((a | 0) == 1) {
     break b;
    }
    Y();
    a = -255;
   }
   break a;
  }
  a = M() | 0;
  v[31601] = 0;
  W(26);
  b = v[31601];
  v[31601] = 0;
  if ((b | 0) != 1) {
   P(a | 0);
   p();
  }
  S(0) | 0;
  Rb();
  p();
 }
 return a | 0;
}

function _ea(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0;
 v[31601] = 0;
 V(1020, a | 0);
 c = v[31601];
 v[31601] = 0;
 d = 1;
 a: {
  b: {
   if ((c | 0) != 1) {
    c = v[a + 28 >> 2];
    e = v[v[c >> 2] + 20 >> 2];
    v[31601] = 0;
    N(e | 0, c | 0, b | 0);
    b = v[31601];
    v[31601] = 0;
    if ((b | 0) != 1) {
     break b;
    }
   }
   X(S(0) | 0) | 0;
   v[31601] = 0;
   U(982, 9312, a | 0, 0, 0);
   a = v[31601];
   v[31601] = 0;
   if ((a | 0) == 1) {
    break a;
   }
   Y();
   d = 0;
  }
  return d | 0;
 }
 a = M() | 0;
 v[31601] = 0;
 W(26);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  P(a | 0);
  p();
 }
 S(0) | 0;
 Rb();
 p();
}

function rC(a, b, c, d, e, f) {
 var g = 0, h = 0, i = 0;
 g = eb - 16 | 0;
 eb = g;
 a: {
  if (1073741807 - b >>> 0 >= c >>> 0) {
   i = Jb(a);
   h = g + 4 | 0;
   if (b >>> 0 <= 536870886) {
    v[g + 12 >> 2] = b << 1;
    v[g + 4 >> 2] = b + c;
    c = rn(v[ad(h, g + 12 | 0) >> 2]) + 1 | 0;
   } else {
    c = 1073741807;
   }
   Mj(h, c);
   c = v[g + 4 >> 2];
   if (e) {
    Qi(c, i, e);
   }
   h = e + f | 0;
   if ((h | 0) != (d | 0)) {
    e = e << 2;
    Qi(e + c | 0, (e + i | 0) + (f << 2) | 0, d - h | 0);
   }
   if ((b | 0) != 1) {
    Bb(i);
   }
   xd(a, c);
   of(a, v[g + 8 >> 2]);
   eb = g + 16 | 0;
   break a;
  }
  pf();
  p();
 }
 Ad(a, d - f | 0);
}

function faa(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0;
 e = qm(a);
 v[e >> 2] = 76700;
 d = mc(e);
 a = eb - 16 | 0;
 eb = a;
 c = v[b + 12 >> 2];
 v[a + 8 >> 2] = v[b + 8 >> 2];
 v[a + 12 >> 2] = c;
 c = v[b + 4 >> 2];
 v[a >> 2] = v[b >> 2];
 v[a + 4 >> 2] = c;
 b = eb - 16 | 0;
 eb = b;
 c = v[a + 12 >> 2];
 v[b + 8 >> 2] = v[a + 8 >> 2];
 v[b + 12 >> 2] = c;
 c = v[a + 4 >> 2];
 v[b >> 2] = v[a >> 2];
 v[b + 4 >> 2] = c;
 d = jM(d, kM(b));
 v[d >> 2] = 76864;
 c = v[a + 4 >> 2];
 v[d + 24 >> 2] = v[a >> 2];
 v[d + 28 >> 2] = c;
 c = v[a + 12 >> 2];
 v[d + 32 >> 2] = v[a + 8 >> 2];
 v[d + 36 >> 2] = c;
 eb = b + 16 | 0;
 eb = a + 16 | 0;
 return e | 0;
}

function bv(a, b, c) {
 var d = 0, e = 0, f = 0, g = 0, h = 0;
 e = eb - 16 | 0;
 eb = e;
 v[b + 40 >> 2] = 0;
 v[b + 44 >> 2] = 0;
 f = b - -64 | 0;
 v[f >> 2] = 0;
 v[f + 4 >> 2] = 0;
 v[b + 56 >> 2] = 0;
 v[b + 60 >> 2] = 0;
 v[b + 48 >> 2] = 0;
 v[b + 52 >> 2] = 0;
 while (1) {
  if ((d | 0) == 1e4) {
   a: {
    d = vb(v[c >> 2]);
    v[e + 12 >> 2] = d;
    f = vb(v[c + 4 >> 2]);
    while (1) {
     if (!Hb(d, f)) {
      break a;
     }
     g = d, h = hU(b, A[d >> 3]), A[g >> 3] = h;
     d = v[PB(e + 12 | 0) >> 2];
     continue;
    }
   }
  } else {
   hU(b, A[Se(v[c >> 2], 0) >> 3]);
   d = d + 1 | 0;
   continue;
  }
  break;
 }
 Rl(a, c);
 eb = e + 16 | 0;
}

function nB(a, b, c) {
 var d = 0;
 d = v[a + 480180 >> 2];
 a: {
  if ((d | 0) != 1048576) {
   if ((d | 0) != 4) {
    break a;
   }
   d = w[b + 813 | 0];
   if (c) {
    t[b + 813 | 0] = d & 240 | c & 15;
    break a;
   }
   c = d & 15;
   break a;
  }
  if (c) {
   t[b + 813 | 0] = c;
   break a;
  }
  c = w[b + 813 | 0];
 }
 b: {
  if (!(t[b + 851 | 0] & 1) | !v[b + 700 >> 2]) {
   break b;
  }
  c = c & 255;
  if (!c) {
   break b;
  }
  vk(a, b, b + 700 | 0, 0 - (c << 2) | 0, 0);
  if (v[b + 700 >> 2] < 65536) {
   break b;
  }
  if (Nb(a + 1074312 | 0, 7) | (v[a + 480180 >> 2] != 4 ? w[a + 480208 | 0] & 16 : 0)) {
   break b;
  }
  v[b + 700 >> 2] = 65535;
 }
}

function Yea(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0;
 v[31601] = 0;
 V(1020, a | 0);
 c = v[31601];
 v[31601] = 0;
 a: {
  b: {
   if ((c | 0) != 1) {
    c = v[a + 28 >> 2];
    e = v[v[c >> 2] + 100 >> 2];
    v[31601] = 0;
    d = +pa(e | 0, c | 0, b | 0);
    b = v[31601];
    v[31601] = 0;
    if ((b | 0) != 1) {
     break b;
    }
   }
   X(S(0) | 0) | 0;
   v[31601] = 0;
   U(982, 11634, a | 0, 0, 0);
   a = v[31601];
   v[31601] = 0;
   if ((a | 0) == 1) {
    break a;
   }
   Y();
   d = 0;
  }
  return +d;
 }
 a = M() | 0;
 v[31601] = 0;
 W(26);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  P(a | 0);
  p();
 }
 S(0) | 0;
 Rb();
 p();
}

function Sea(a, b) {
 a = a | 0;
 b = +b;
 var c = 0, d = 0, e = 0;
 v[31601] = 0;
 V(1020, a | 0);
 c = v[31601];
 v[31601] = 0;
 d = 1;
 a: {
  b: {
   if ((c | 0) != 1) {
    c = v[a + 28 >> 2];
    e = v[v[c >> 2] + 104 >> 2];
    v[31601] = 0;
    ka(e | 0, c | 0, +b);
    c = v[31601];
    v[31601] = 0;
    if ((c | 0) != 1) {
     break b;
    }
   }
   X(S(0) | 0) | 0;
   v[31601] = 0;
   U(982, 15118, a | 0, 0, 0);
   a = v[31601];
   v[31601] = 0;
   if ((a | 0) == 1) {
    break a;
   }
   Y();
   d = 0;
  }
  return d | 0;
 }
 a = M() | 0;
 v[31601] = 0;
 W(26);
 d = v[31601];
 v[31601] = 0;
 if ((d | 0) != 1) {
  P(a | 0);
  p();
 }
 S(0) | 0;
 Rb();
 p();
}

function MF(a, b, c) {
 var d = 0, e = 0, f = 0, g = 0, h = 0;
 e = eb - 16 | 0;
 eb = e;
 f = e + 8 | 0;
 d = eb - 32 | 0;
 eb = d;
 ed(d + 24 | 0, a, b);
 g = d + 16 | 0;
 b = v[d + 24 >> 2];
 h = v[d + 28 >> 2];
 a = eb - 16 | 0;
 eb = a;
 v[a + 8 >> 2] = c;
 v[a + 12 >> 2] = b;
 while (1) {
  if (Ed(b, h)) {
   b = wf(b);
   c = wf(v[a + 8 >> 2]);
   t[c + 2 | 0] = w[b + 2 | 0];
   u[c >> 1] = x[b >> 1];
   b = vj(a + 12 | 0);
   vj(a + 8 | 0);
   b = v[b >> 2];
   continue;
  }
  break;
 }
 pc(g, b, a + 8 | 0);
 eb = a + 16 | 0;
 a = v[d + 16 >> 2];
 v[d + 12 >> 2] = v[d + 20 >> 2];
 pc(f, a, d + 12 | 0);
 eb = d + 32 | 0;
 eb = e + 16 | 0;
 return v[e + 12 >> 2];
}

function gfa(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0;
 v[31601] = 0;
 V(1020, a | 0);
 c = v[31601];
 v[31601] = 0;
 a: {
  b: {
   if ((c | 0) != 1) {
    c = v[a + 28 >> 2];
    e = v[v[c >> 2] + 52 >> 2];
    v[31601] = 0;
    d = +pa(e | 0, c | 0, b | 0);
    b = v[31601];
    v[31601] = 0;
    if ((b | 0) != 1) {
     break b;
    }
   }
   X(S(0) | 0) | 0;
   v[31601] = 0;
   U(982, 11697, a | 0, 0, 0);
   a = v[31601];
   v[31601] = 0;
   if ((a | 0) == 1) {
    break a;
   }
   Y();
   d = 0;
  }
  return +d;
 }
 a = M() | 0;
 v[31601] = 0;
 W(26);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  P(a | 0);
  p();
 }
 S(0) | 0;
 Rb();
 p();
}

function dfa(a, b) {
 a = a | 0;
 b = +b;
 var c = 0, d = 0, e = 0;
 v[31601] = 0;
 V(1020, a | 0);
 c = v[31601];
 v[31601] = 0;
 d = 1;
 a: {
  b: {
   if ((c | 0) != 1) {
    c = v[a + 28 >> 2];
    e = v[v[c >> 2] + 40 >> 2];
    v[31601] = 0;
    ka(e | 0, c | 0, +b);
    c = v[31601];
    v[31601] = 0;
    if ((c | 0) != 1) {
     break b;
    }
   }
   X(S(0) | 0) | 0;
   v[31601] = 0;
   U(982, 11716, a | 0, 0, 0);
   a = v[31601];
   v[31601] = 0;
   if ((a | 0) == 1) {
    break a;
   }
   Y();
   d = 0;
  }
  return d | 0;
 }
 a = M() | 0;
 v[31601] = 0;
 W(26);
 d = v[31601];
 v[31601] = 0;
 if ((d | 0) != 1) {
  P(a | 0);
  p();
 }
 S(0) | 0;
 Rb();
 p();
}

function Wea(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0;
 v[31601] = 0;
 V(1020, a | 0);
 c = v[31601];
 v[31601] = 0;
 a: {
  b: {
   if ((c | 0) != 1) {
    c = v[a + 28 >> 2];
    e = v[v[c >> 2] + 92 >> 2];
    v[31601] = 0;
    d = +pa(e | 0, c | 0, b | 0);
    b = v[31601];
    v[31601] = 0;
    if ((b | 0) != 1) {
     break b;
    }
   }
   X(S(0) | 0) | 0;
   v[31601] = 0;
   U(982, 11086, a | 0, 0, 0);
   a = v[31601];
   v[31601] = 0;
   if ((a | 0) == 1) {
    break a;
   }
   Y();
   d = 0;
  }
  return +d;
 }
 a = M() | 0;
 v[31601] = 0;
 W(26);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  P(a | 0);
  p();
 }
 S(0) | 0;
 Rb();
 p();
}

function bfa(a, b) {
 a = a | 0;
 b = +b;
 var c = 0, d = 0, e = 0;
 v[31601] = 0;
 V(1020, a | 0);
 c = v[31601];
 v[31601] = 0;
 d = 1;
 a: {
  b: {
   if ((c | 0) != 1) {
    c = v[a + 28 >> 2];
    e = v[v[c >> 2] + 32 >> 2];
    v[31601] = 0;
    ka(e | 0, c | 0, +b);
    c = v[31601];
    v[31601] = 0;
    if ((c | 0) != 1) {
     break b;
    }
   }
   X(S(0) | 0) | 0;
   v[31601] = 0;
   U(982, 7777, a | 0, 0, 0);
   a = v[31601];
   v[31601] = 0;
   if ((a | 0) == 1) {
    break a;
   }
   Y();
   d = 0;
  }
  return d | 0;
 }
 a = M() | 0;
 v[31601] = 0;
 W(26);
 d = v[31601];
 v[31601] = 0;
 if ((d | 0) != 1) {
  P(a | 0);
  p();
 }
 S(0) | 0;
 Rb();
 p();
}

function $ea(a, b) {
 a = a | 0;
 b = +b;
 var c = 0, d = 0, e = 0;
 v[31601] = 0;
 V(1020, a | 0);
 c = v[31601];
 v[31601] = 0;
 d = 1;
 a: {
  b: {
   if ((c | 0) != 1) {
    c = v[a + 28 >> 2];
    e = v[v[c >> 2] + 24 >> 2];
    v[31601] = 0;
    ka(e | 0, c | 0, +b);
    c = v[31601];
    v[31601] = 0;
    if ((c | 0) != 1) {
     break b;
    }
   }
   X(S(0) | 0) | 0;
   v[31601] = 0;
   U(982, 7725, a | 0, 0, 0);
   a = v[31601];
   v[31601] = 0;
   if ((a | 0) == 1) {
    break a;
   }
   Y();
   d = 0;
  }
  return d | 0;
 }
 a = M() | 0;
 v[31601] = 0;
 W(26);
 d = v[31601];
 v[31601] = 0;
 if ((d | 0) != 1) {
  P(a | 0);
  p();
 }
 S(0) | 0;
 Rb();
 p();
}

function kfa(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0;
 v[31601] = 0;
 V(1020, a | 0);
 c = v[31601];
 v[31601] = 0;
 a: {
  b: {
   if ((c | 0) != 1) {
    c = v[a + 28 >> 2];
    d = v[v[c >> 2] + 68 >> 2];
    v[31601] = 0;
    b = O(d | 0, c | 0, b | 0) | 0;
    c = v[31601];
    v[31601] = 0;
    if ((c | 0) != 1) {
     break b;
    }
   }
   X(S(0) | 0) | 0;
   v[31601] = 0;
   U(982, 6722, a | 0, 0, 0);
   a = v[31601];
   v[31601] = 0;
   if ((a | 0) == 1) {
    break a;
   }
   Y();
   b = -1;
  }
  return b | 0;
 }
 a = M() | 0;
 v[31601] = 0;
 W(26);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  P(a | 0);
  p();
 }
 S(0) | 0;
 Rb();
 p();
}

function kN(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0;
 c = eb - 16 | 0;
 eb = c;
 a: {
  b: {
   c: {
    if (b >>> 0 >= 256) {
     b = cc(8);
     v[31601] = 0;
     c = O(36, c + 4 | 0, 10735) | 0;
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) == 1) {
      break c;
     }
     rc(b, c);
     v[31601] = 0;
     R(97, b | 0, 48396, 999);
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) != 1) {
      break a;
     }
     a = M() | 0;
     sb(c);
     break b;
    }
    a = v[a + 32 >> 2] + B(b, 872) | 0;
    v[a + 1075008 >> 2] = 0;
    v[a + 1075068 >> 2] = 0;
    eb = c + 16 | 0;
    return;
   }
   a = M() | 0;
   jc(b);
  }
  P(a | 0);
 }
 p();
}

function ifa(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0;
 v[31601] = 0;
 V(1020, a | 0);
 c = v[31601];
 v[31601] = 0;
 a: {
  b: {
   if ((c | 0) != 1) {
    c = v[a + 28 >> 2];
    d = v[v[c >> 2] + 60 >> 2];
    v[31601] = 0;
    b = O(d | 0, c | 0, b | 0) | 0;
    c = v[31601];
    v[31601] = 0;
    if ((c | 0) != 1) {
     break b;
    }
   }
   X(S(0) | 0) | 0;
   v[31601] = 0;
   U(982, 6773, a | 0, 0, 0);
   a = v[31601];
   v[31601] = 0;
   if ((a | 0) == 1) {
    break a;
   }
   Y();
   b = -1;
  }
  return b | 0;
 }
 a = M() | 0;
 v[31601] = 0;
 W(26);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  P(a | 0);
  p();
 }
 S(0) | 0;
 Rb();
 p();
}

function vaa(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0;
 c = eb - 16 | 0;
 eb = c;
 a: {
  if (A[a + 24 >> 3] == 1) {
   break a;
  }
  h = v[b >> 2];
  f = v[b + 4 >> 2];
  i = v[b + 8 >> 2];
  b: while (1) {
   if ((e | 0) == (i | 0)) {
    break a;
   }
   j = (B(e, f) << 3) + h | 0;
   d = 0;
   while (1) if ((d | 0) == (f | 0)) {
    e = e + 1 | 0;
    continue b;
   } else {
    g = (d << 3) + j | 0;
    A[g >> 3] = A[a + 24 >> 3] * A[g >> 3];
    d = d + 1 | 0;
    continue;
   }
  }
 }
 v[c + 8 >> 2] = v[b + 8 >> 2];
 d = v[b + 4 >> 2];
 v[c >> 2] = v[b >> 2];
 v[c + 4 >> 2] = d;
 tM(a, c);
 eb = c + 16 | 0;
}

function Kaa(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0;
 c = eb - 16 | 0;
 eb = c;
 a: {
  if (A[a + 24 >> 3] == 1) {
   break a;
  }
  h = v[b >> 2];
  f = v[b + 4 >> 2];
  i = v[b + 8 >> 2];
  b: while (1) {
   if ((e | 0) == (i | 0)) {
    break a;
   }
   j = (B(e, f) << 3) + h | 0;
   d = 0;
   while (1) if ((d | 0) == (f | 0)) {
    e = e + 1 | 0;
    continue b;
   } else {
    g = (d << 3) + j | 0;
    A[g >> 3] = A[a + 24 >> 3] * A[g >> 3];
    d = d + 1 | 0;
    continue;
   }
  }
 }
 v[c + 8 >> 2] = v[b + 8 >> 2];
 d = v[b + 4 >> 2];
 v[c >> 2] = v[b >> 2];
 v[c + 4 >> 2] = d;
 DM(a, c);
 eb = c + 16 | 0;
}

function Eaa(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0;
 c = eb - 16 | 0;
 eb = c;
 a: {
  if (A[a + 24 >> 3] == 1) {
   break a;
  }
  h = v[b >> 2];
  f = v[b + 4 >> 2];
  i = v[b + 8 >> 2];
  b: while (1) {
   if ((e | 0) == (i | 0)) {
    break a;
   }
   j = (B(e, f) << 3) + h | 0;
   d = 0;
   while (1) if ((d | 0) == (f | 0)) {
    e = e + 1 | 0;
    continue b;
   } else {
    g = (d << 3) + j | 0;
    A[g >> 3] = A[a + 24 >> 3] * A[g >> 3];
    d = d + 1 | 0;
    continue;
   }
  }
 }
 v[c + 8 >> 2] = v[b + 8 >> 2];
 d = v[b + 4 >> 2];
 v[c >> 2] = v[b >> 2];
 v[c + 4 >> 2] = d;
 zM(a, c);
 eb = c + 16 | 0;
}

function Baa(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0;
 c = eb - 16 | 0;
 eb = c;
 a: {
  if (A[a + 24 >> 3] == 1) {
   break a;
  }
  h = v[b >> 2];
  f = v[b + 4 >> 2];
  i = v[b + 8 >> 2];
  b: while (1) {
   if ((e | 0) == (i | 0)) {
    break a;
   }
   j = (B(e, f) << 3) + h | 0;
   d = 0;
   while (1) if ((d | 0) == (f | 0)) {
    e = e + 1 | 0;
    continue b;
   } else {
    g = (d << 3) + j | 0;
    A[g >> 3] = A[a + 24 >> 3] * A[g >> 3];
    d = d + 1 | 0;
    continue;
   }
  }
 }
 v[c + 8 >> 2] = v[b + 8 >> 2];
 d = v[b + 4 >> 2];
 v[c >> 2] = v[b >> 2];
 v[c + 4 >> 2] = d;
 xM(a, c);
 eb = c + 16 | 0;
}

function baa(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0;
 e = eb - 32 | 0;
 eb = e;
 a: {
  if (w[b + 8 | 0]) {
   f = v[b + 12 >> 2];
   h = e, i = Sc(f, v[b + 16 >> 2]) - c | 0, v[h + 28 >> 2] = i;
   v[e + 24 >> 2] = v[d + 4 >> 2];
   g = v[Gb(e + 28 | 0, e + 24 | 0) >> 2];
   f = Pe(vb(f), c);
   c = Pe(Pe(vb(v[b + 12 >> 2]), c), g);
   b = v[d >> 2];
   dw(f, c, b);
   ac(a, b, g);
   break a;
  }
  g = v[d + 4 >> 2];
  d = v[d >> 2];
  v[e + 16 >> 2] = d;
  v[e + 20 >> 2] = g;
  f = v[v[b >> 2] + 40 >> 2];
  v[e + 8 >> 2] = d;
  v[e + 12 >> 2] = g;
  hb[f | 0](a, b, c, e + 8 | 0);
 }
 eb = e + 32 | 0;
}

function mB(a, b, c) {
 var d = 0;
 d = v[a + 480180 >> 2];
 a: {
  if ((d | 0) != 1048576) {
   if ((d | 0) != 4) {
    break a;
   }
   d = w[b + 814 | 0];
   if (c) {
    t[b + 814 | 0] = d & 240 | c & 15;
    break a;
   }
   c = d & 15;
   break a;
  }
  if (c) {
   t[b + 813 | 0] = c;
   break a;
  }
  c = w[b + 813 | 0];
 }
 b: {
  if (!(t[b + 851 | 0] & 1) | !v[b + 700 >> 2]) {
   break b;
  }
  c = c & 255;
  if (!c) {
   break b;
  }
  vk(a, b, b + 700 | 0, 0 - c | 0, 0);
  if (v[b + 700 >> 2] < 65536) {
   break b;
  }
  if (Nb(a + 1074312 | 0, 7) | (v[a + 480180 >> 2] != 4 ? w[a + 480208 | 0] & 16 : 0)) {
   break b;
  }
  v[b + 700 >> 2] = 65535;
 }
}

function Ita(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0;
 d = eb - 16 | 0;
 eb = d;
 c = d + 14 | 0;
 E$(c, a, b);
 Bf(b, w[d + 14 | 0], w[Ic(c) | 0]);
 a = w[b + 3 | 0];
 a: {
  if ((a | 0) != 9) {
   if ((a | 0) != 19) {
    break a;
   }
   a = w[b + 5 | 0];
   c = a & 240;
   if ((c | 0) != 128) {
    if ((c | 0) != 64) {
     if ((c | 0) != 48) {
      break a;
     }
     t[b + 3 | 0] = 45;
     t[b + 5 | 0] = a & 15;
     break a;
    }
    if ((a | 0) != 64) {
     break a;
    }
    t[b + 3 | 0] = 0;
    t[b | 0] = 254;
    break a;
   }
   t[b + 3 | 0] = 20;
   t[b + 5 | 0] = a & 15 | 160;
   break a;
  }
  t[b + 3 | 0] = 0;
 }
 eb = d + 16 | 0;
}

function IM(a, b) {
 var c = 0, d = 0;
 v[a + 4 >> 2] = b;
 v[a >> 2] = 126448;
 v[a + 24 >> 2] = 0;
 v[a + 28 >> 2] = 65536;
 v[a + 8 >> 2] = b;
 v[a + 32 >> 2] = 0;
 v[a + 36 >> 2] = 65536;
 c = (b | 0) != 0;
 v[a + 12 >> 2] = c;
 v[a + 16 >> 2] = c;
 d = b ^ 63;
 c = d & 31;
 if ((d & 63) >>> 0 >= 32) {
  d = 0;
  c = -1 >>> c | 0;
 } else {
  d = -1 >>> c | 0;
  c = d | (1 << c) - 1 << 32 - c;
 }
 v[a + 48 >> 2] = c;
 v[a + 52 >> 2] = d;
 d = 64 - b | 0;
 c = d & 31;
 if ((d & 63) >>> 0 >= 32) {
  d = 0;
  c = -1 >>> c | 0;
 } else {
  d = -1 >>> c | 0;
  c = d | (1 << c) - 1 << 32 - c;
 }
 v[a + 40 >> 2] = b ? c : 0;
 v[a + 44 >> 2] = b ? d : 0;
 return a;
}

function Q7(a, b, c, d, e) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 var f = 0, g = 0, h = 0, i = 0, j = 0, k = 0;
 a = eb - 96 | 0;
 eb = a;
 g = Nd();
 v[a >> 2] = e;
 e = a - -64 | 0;
 h = oh(e, 20, g, 9262, a);
 g = h + e | 0;
 i = ij(e, g, v[c + 4 >> 2]);
 f = a + 12 | 0;
 bd(f, v[c + 28 >> 2]);
 v[31601] = 0;
 j = Q(28, v[a + 12 >> 2]) | 0;
 k = v[31601];
 v[31601] = 0;
 if ((k | 0) != 1) {
  Zb(f);
  f = e;
  e = a + 16 | 0;
  uK(j, f, g, e);
  f = b;
  b = e + h | 0;
  b = tw(f, e, (g | 0) == (i | 0) ? b : ((i - a | 0) + a | 0) - 48 | 0, b, c, d);
  eb = a + 96 | 0;
  return b | 0;
 }
 b = M() | 0;
 Zb(a + 12 | 0);
 P(b | 0);
 p();
}

function ZH(a, b, c) {
 a = Eb(a);
 v[31601] = 0;
 N(c | 0, a | 0, 4);
 c = v[31601];
 v[31601] = 0;
 a: {
  b: {
   if ((c | 0) == 1) {
    break b;
   }
   v[31601] = 0;
   N(b | 0, a | 0, 32);
   c = v[31601];
   v[31601] = 0;
   if ((c | 0) == 1) {
    break b;
   }
   v[31601] = 0;
   N(b | 0, a | 0, 10);
   c = v[31601];
   v[31601] = 0;
   if ((c | 0) == 1) {
    break b;
   }
   v[31601] = 0;
   N(b | 0, a | 0, 13);
   c = v[31601];
   v[31601] = 0;
   if ((c | 0) == 1) {
    break b;
   }
   v[31601] = 0;
   N(b | 0, a | 0, 9);
   b = v[31601];
   v[31601] = 0;
   if ((b | 0) != 1) {
    break a;
   }
  }
  b = M() | 0;
  sb(a);
  P(b | 0);
  p();
 }
}

function QH(a, b, c, d, e) {
 var f = 0;
 f = eb - 16 | 0;
 eb = f;
 a: {
  b: {
   c: {
    if (!d) {
     a = cc(8);
     v[31601] = 0;
     c = O(36, f + 4 | 0, 8200) | 0;
     b = v[31601];
     v[31601] = 0;
     if ((b | 0) == 1) {
      break c;
     }
     rc(a, c);
     v[31601] = 0;
     R(97, a | 0, 48396, 999);
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) != 1) {
      break a;
     }
     b = M() | 0;
     sb(c);
     break b;
    }
    zl(a, b, e);
    c = JH(a, c, e, d, 75904, 76676);
    A[a + 16 >> 3] = A[a + 16 >> 3] + +(c >>> 0) / +(b | 0);
    eb = f + 16 | 0;
    return c;
   }
   b = M() | 0;
   jc(a);
  }
  P(b | 0);
 }
 p();
}

function PH(a, b, c, d, e) {
 var f = 0;
 f = eb - 16 | 0;
 eb = f;
 a: {
  b: {
   c: {
    if (!d) {
     a = cc(8);
     v[31601] = 0;
     c = O(36, f + 4 | 0, 8200) | 0;
     b = v[31601];
     v[31601] = 0;
     if ((b | 0) == 1) {
      break c;
     }
     rc(a, c);
     v[31601] = 0;
     R(97, a | 0, 48396, 999);
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) != 1) {
      break a;
     }
     b = M() | 0;
     sb(c);
     break b;
    }
    zl(a, b, e);
    c = JH(a, c, e, d, 75108, 75880);
    A[a + 16 >> 3] = A[a + 16 >> 3] + +(c >>> 0) / +(b | 0);
    eb = f + 16 | 0;
    return c;
   }
   b = M() | 0;
   jc(a);
  }
  P(b | 0);
 }
 p();
}

function Dia(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0;
 d = eb - 16 | 0;
 eb = d;
 c = Dc(64);
 v[31601] = 0;
 e = Q(874, c | 0) | 0;
 f = v[31601];
 v[31601] = 0;
 a: {
  if ((f | 0) != 1) {
   c = xf(d + 8 | 0, e);
   e = v[c >> 2];
   v[31601] = 0;
   a = T(938, e | 0, a | 0, b | 0) | 0;
   b = v[31601];
   v[31601] = 0;
   b: {
    c: {
     if ((b | 0) != 1) {
      if ((a | 0) == 1) {
       break c;
      }
      sc(d + 12 | 0);
      break b;
     }
     a = M() | 0;
     lg(c);
     break a;
    }
    re(d + 12 | 0, c);
   }
   lg(c);
   eb = d + 16 | 0;
   return v[d + 12 >> 2];
  }
  a = M() | 0;
  Bb(c);
 }
 P(a | 0);
 p();
}

function HL(a, b) {
 var c = 0, d = 0, e = 0;
 if (!w[b + 21 | 0]) {
  bc(a, 21);
  return -1;
 }
 if (v[a + 1396 >> 2] <= 9) {
  tl(a);
 }
 d = v[a + 1392 >> 2];
 c = u[(((d & 1023) << 1) + b | 0) + 36 >> 1];
 a: {
  if ((c | 0) >= 0) {
   e = d;
   d = c & 65535;
   c = w[d + v[b + 8 >> 2] | 0];
   v[a + 1392 >> 2] = e >>> c;
   c = v[a + 1396 >> 2] - c | 0;
   v[a + 1396 >> 2] = (c | 0) > 0 ? c : 0;
   c = (c | 0) < 0 ? -1 : d;
   break a;
  }
  c = Gm(a, b);
 }
 if (!((c | 0) >= v[b + 2092 >> 2] ? w[b + 23 | 0] : 0)) {
  if (!(!(v[a + 1384 >> 2] ? w[a + 1376 | 0] : 1) | (c | 0) >= 0)) {
   bc(a, 21);
  }
  return c;
 }
 Z(7566, 13258, 1793, 5750);
 p();
}

function g6(a) {
 a = a | 0;
 if (w[499896]) {
  return v[124973];
 }
 if (!w[500992]) {
  t[500992] = 1;
 }
 vd(500704, 103692);
 vd(500716, 103724);
 vd(500728, 103760);
 vd(500740, 103784);
 vd(500752, 103808);
 vd(500764, 103824);
 vd(500776, 103844);
 vd(500788, 103864);
 vd(500800, 103892);
 vd(500812, 103932);
 vd(500824, 103964);
 vd(500836, 104e3);
 vd(500848, 104036);
 vd(500860, 104052);
 vd(500872, 104068);
 vd(500884, 104084);
 vd(500896, 103808);
 vd(500908, 104100);
 vd(500920, 104116);
 vd(500932, 104132);
 vd(500944, 104148);
 vd(500956, 104164);
 vd(500968, 104180);
 vd(500980, 104196);
 t[499896] = 1;
 v[124973] = 500704;
 return 500704;
}

function Uka(a) {
 a = a | 0;
 var b = 0, c = 0, d = 0, e = 0, f = 0, g = 0;
 c = eb - 16 | 0;
 eb = c;
 v[a >> 2] = 0;
 v[a + 4 >> 2] = 0;
 sc(a + 8 | 0);
 e = c + 8 | 0;
 Qd(e, v[ub(c + 4 | 0, a) >> 2]);
 v[31601] = 0;
 V(804, a | 0);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  f = eb - 16 | 0;
  eb = f;
  d = aj(f + 4 | 0, a, 2304);
  b = v[d + 4 >> 2];
  g = v[d + 8 >> 2];
  while (1) {
   if ((b | 0) == (g | 0)) {
    hc(d);
    eb = f + 16 | 0;
   } else {
    _w(b);
    b = b + 2 | 0;
    v[d + 4 >> 2] = b;
    continue;
   }
   break;
  }
  Pd(e);
  Rj(e);
  eb = c + 16 | 0;
  return a | 0;
 }
 a = M() | 0;
 Rj(c + 8 | 0);
 P(a | 0);
 p();
}

function NF(a, b, c) {
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0;
 e = eb - 16 | 0;
 eb = e;
 f = e + 8 | 0;
 d = eb - 32 | 0;
 eb = d;
 ed(d + 24 | 0, a, b);
 g = d + 16 | 0;
 b = v[d + 24 >> 2];
 h = v[d + 28 >> 2];
 a = eb - 16 | 0;
 eb = a;
 v[a + 8 >> 2] = c;
 v[a + 12 >> 2] = b;
 while (1) {
  if (Ed(b, h)) {
   b = Fn(b);
   i = Fn(v[a + 8 >> 2]), j = x[b >> 1], u[i >> 1] = j;
   b = Uk(a + 12 | 0);
   Uk(a + 8 | 0);
   b = v[b >> 2];
   continue;
  }
  break;
 }
 pc(g, b, a + 8 | 0);
 eb = a + 16 | 0;
 a = v[d + 16 >> 2];
 v[d + 12 >> 2] = v[d + 20 >> 2];
 pc(f, a, d + 12 | 0);
 eb = d + 32 | 0;
 eb = e + 16 | 0;
 return v[e + 12 >> 2];
}

function qt(a, b, c) {
 var d = 0, e = 0;
 if (c & 2048) {
  t[a | 0] = 43;
  a = a + 1 | 0;
 }
 if (c & 1024) {
  t[a | 0] = 35;
  a = a + 1 | 0;
 }
 d = c & 260;
 if ((d | 0) != 260) {
  t[a | 0] = 46;
  t[a + 1 | 0] = 42;
  a = a + 2 | 0;
 }
 c = c & 16384;
 while (1) {
  e = w[b | 0];
  if (e) {
   t[a | 0] = e;
   a = a + 1 | 0;
   b = b + 1 | 0;
   continue;
  }
  break;
 }
 a: {
  b: {
   if ((d | 0) != 256) {
    if ((d | 0) != 4) {
     break b;
    }
    b = c ? 70 : 102;
    break a;
   }
   b = c ? 69 : 101;
   break a;
  }
  b = c ? 65 : 97;
  if ((d | 0) == 260) {
   break a;
  }
  b = c ? 71 : 103;
 }
 t[a | 0] = b;
 return (d | 0) != 260;
}

function SH(a, b, c, d, e, f, g, h, i) {
 var j = 0;
 v[31601] = 0;
 V(995, a | 0);
 j = v[31601];
 v[31601] = 0;
 a: {
  b: {
   if ((j | 0) != 1) {
    j = v[a + 24 >> 2];
    v[31601] = 0;
    b = ra(i | 0, j | 0, b | 0, c | 0, d | 0, e | 0, f | 0, g | 0) | 0;
    c = v[31601];
    v[31601] = 0;
    if ((c | 0) != 1) {
     break b;
    }
   }
   X(S(0) | 0) | 0;
   v[31601] = 0;
   U(982, h | 0, a | 0, 0, 0);
   a = v[31601];
   v[31601] = 0;
   if ((a | 0) == 1) {
    break a;
   }
   Y();
   b = 0;
  }
  return b;
 }
 a = M() | 0;
 v[31601] = 0;
 W(26);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  P(a | 0);
  p();
 }
 S(0) | 0;
 Rb();
 p();
}

function Kda(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0;
 v[31601] = 0;
 V(995, a | 0);
 d = v[31601];
 v[31601] = 0;
 e = 1;
 a: {
  b: {
   if ((d | 0) != 1) {
    d = v[a + 24 >> 2];
    v[31601] = 0;
    R(1091, d | 0, b | 0, c | 0);
    b = v[31601];
    v[31601] = 0;
    if ((b | 0) != 1) {
     break b;
    }
   }
   X(S(0) | 0) | 0;
   v[31601] = 0;
   U(982, 10321, a | 0, 0, 0);
   a = v[31601];
   v[31601] = 0;
   if ((a | 0) == 1) {
    break a;
   }
   Y();
   e = 0;
  }
  return e | 0;
 }
 a = M() | 0;
 v[31601] = 0;
 W(26);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  P(a | 0);
  p();
 }
 S(0) | 0;
 Rb();
 p();
}

function dN(a, b) {
 a = a | 0;
 b = +b;
 var c = 0, d = 0, e = 0, f = 0;
 c = eb - 16 | 0;
 eb = c;
 a: {
  b: {
   c: {
    if (b < 32 | b > 512) {
     a = cc(8);
     v[31601] = 0;
     c = O(36, c + 4 | 0, 9363) | 0;
     d = v[31601];
     v[31601] = 0;
     if ((d | 0) == 1) {
      break c;
     }
     rc(a, c);
     v[31601] = 0;
     R(97, a | 0, 48396, 999);
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) != 1) {
      break a;
     }
     d = M() | 0;
     sb(c);
     break b;
    }
    e = v[a + 32 >> 2], f = Te(b * 1e4), v[e + 1074420 >> 2] = f;
    eb = c + 16 | 0;
    return;
   }
   d = M() | 0;
   jc(a);
  }
  P(d | 0);
 }
 p();
}

function PW(a, b, c) {
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0;
 e = eb - 16 | 0;
 eb = e;
 f = e + 8 | 0;
 d = eb - 32 | 0;
 eb = d;
 ed(d + 24 | 0, a, b);
 g = d + 16 | 0;
 b = v[d + 24 >> 2];
 h = v[d + 28 >> 2];
 a = eb - 16 | 0;
 eb = a;
 v[a + 8 >> 2] = c;
 v[a + 12 >> 2] = b;
 while (1) {
  if (Ed(b, h)) {
   b = uW(b);
   i = uW(v[a + 8 >> 2]), j = w[b | 0], t[i | 0] = j;
   b = sW(a + 12 | 0);
   sW(a + 8 | 0);
   b = v[b >> 2];
   continue;
  }
  break;
 }
 pc(g, b, a + 8 | 0);
 eb = a + 16 | 0;
 a = v[d + 16 >> 2];
 v[d + 12 >> 2] = v[d + 20 >> 2];
 pc(f, a, d + 12 | 0);
 eb = d + 32 | 0;
 eb = e + 16 | 0;
 return v[e + 12 >> 2];
}

function W1(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0;
 g = eb - 16 | 0;
 eb = g;
 f = g + 4 | 0;
 v[f + 4 >> 2] = 1;
 j = f, k = Dc(32), v[j + 8 >> 2] = k;
 e = qm(v[f + 8 >> 2]);
 v[e >> 2] = 41336;
 h = mc(e);
 e = eb - 16 | 0;
 eb = e;
 b = om(e + 8 | 0, v[b >> 2], v[b + 4 >> 2]);
 d = v[d >> 2];
 c = v[c >> 2];
 i = v[b + 4 >> 2];
 v[e >> 2] = v[b >> 2];
 v[e + 4 >> 2] = i;
 b = On(h);
 v[b >> 2] = 41472;
 om(b + 4 | 0, v[e >> 2], v[e + 4 >> 2]);
 v[b + 16 >> 2] = d;
 v[b + 12 >> 2] = c;
 le(e);
 eb = e + 16 | 0;
 b = a;
 a = Qn(f);
 Pn(b, mc(a), a);
 rm(f);
 eb = g + 16 | 0;
}

function tN(a, b) {
 a = a | 0;
 b = +b;
 var c = 0, d = 0, e = 0, f = 0;
 c = eb - 16 | 0;
 eb = c;
 a: {
  b: {
   c: {
    if (b < 0 | b > 1) {
     a = cc(8);
     v[31601] = 0;
     c = O(36, c + 4 | 0, 11752) | 0;
     d = v[31601];
     v[31601] = 0;
     if ((d | 0) == 1) {
      break c;
     }
     rc(a, c);
     v[31601] = 0;
     R(97, a | 0, 48396, 999);
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) != 1) {
      break a;
     }
     d = M() | 0;
     sb(c);
     break b;
    }
    e = v[a + 32 >> 2], f = Te(b * 256), v[e + 1074456 >> 2] = f;
    eb = c + 16 | 0;
    return;
   }
   d = M() | 0;
   jc(a);
  }
  P(d | 0);
 }
 p();
}

function UK(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0;
 d = eb - 32 | 0;
 eb = d;
 e = Cc(d + 8 | 0, c);
 v[31601] = 0;
 c = d + 20 | 0;
 R(1229, c | 0, b | 0, e | 0);
 f = v[31601];
 v[31601] = 0;
 a: {
  b: {
   if ((f | 0) != 1) {
    v[31601] = 0;
    a = O(1230, a | 0, c | 0) | 0;
    f = v[31601];
    v[31601] = 0;
    if ((f | 0) == 1) {
     break b;
    }
    sb(c);
    sb(e);
    v[a >> 2] = 123780;
    c = v[b + 4 >> 2];
    v[a + 8 >> 2] = v[b >> 2];
    v[a + 12 >> 2] = c;
    eb = d + 32 | 0;
    return a | 0;
   }
   c = M() | 0;
   break a;
  }
  c = M() | 0;
  sb(d + 20 | 0);
 }
 sb(e);
 P(c | 0);
 p();
}

function Nda(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0;
 v[31601] = 0;
 V(995, a | 0);
 d = v[31601];
 v[31601] = 0;
 a: {
  b: {
   if ((d | 0) != 1) {
    d = v[a + 24 >> 2];
    v[31601] = 0;
    e = +na(1087, d | 0, b | 0, c | 0);
    b = v[31601];
    v[31601] = 0;
    if ((b | 0) != 1) {
     break b;
    }
   }
   X(S(0) | 0) | 0;
   v[31601] = 0;
   U(982, 5350, a | 0, 0, 0);
   a = v[31601];
   v[31601] = 0;
   if ((a | 0) == 1) {
    break a;
   }
   Y();
   e = 0;
  }
  return +e;
 }
 a = M() | 0;
 v[31601] = 0;
 W(26);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  P(a | 0);
  p();
 }
 S(0) | 0;
 Rb();
 p();
}

function ppa(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0;
 c = eb - 16 | 0;
 eb = c;
 b = -1;
 a: {
  if (!ih(a, 8)) {
   break a;
  }
  b = eb - 32 | 0;
  eb = b;
  v[b + 24 >> 2] = 0;
  v[b + 28 >> 2] = 0;
  d = Yb(b + 8 | 0, b + 24 | 0, 8);
  pd(b + 16 | 0, a, v[d >> 2], v[d + 4 >> 2]);
  d = v[b + 24 >> 2] == 1096043343 & v[b + 28 >> 2] == 1196314451 & v[b + 20 >> 2] == 8;
  if (d) {
   hd(a, 8);
  }
  eb = b + 32 | 0;
  b = 0;
  if (!d) {
   break a;
  }
  b = -1;
  if (!gk(a, c + 8 | 0)) {
   break a;
  }
  b = 0;
  if (!_b(v[c + 12 >> 2])) {
   break a;
  }
  b = !(_b(v[c + 8 >> 2]) & -2139062144);
 }
 eb = c + 16 | 0;
 return b | 0;
}

function gN(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0;
 c = eb - 16 | 0;
 eb = c;
 a: {
  b: {
   c: {
    if (b >>> 0 >= 256) {
     b = cc(8);
     v[31601] = 0;
     c = O(36, c + 4 | 0, 10735) | 0;
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) == 1) {
      break c;
     }
     rc(b, c);
     v[31601] = 0;
     R(97, b | 0, 48396, 999);
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) != 1) {
      break a;
     }
     a = M() | 0;
     sb(c);
     break b;
    }
    eb = c + 16 | 0;
    return +(+(v[(v[a + 32 >> 2] + B(b, 872) | 0) + 1075684 >> 2] - 128 | 0) * .0078125);
   }
   a = M() | 0;
   jc(b);
  }
  P(a | 0);
 }
 p();
}

function efa(a) {
 a = a | 0;
 var b = 0, c = 0, d = 0;
 v[31601] = 0;
 V(1020, a | 0);
 b = v[31601];
 v[31601] = 0;
 a: {
  b: {
   if ((b | 0) != 1) {
    b = v[a + 28 >> 2];
    d = v[v[b >> 2] + 44 >> 2];
    v[31601] = 0;
    c = +ha(d | 0, b | 0);
    b = v[31601];
    v[31601] = 0;
    if ((b | 0) != 1) {
     break b;
    }
   }
   X(S(0) | 0) | 0;
   v[31601] = 0;
   U(982, 11734, a | 0, 0, 0);
   a = v[31601];
   v[31601] = 0;
   if ((a | 0) == 1) {
    break a;
   }
   Y();
   c = 0;
  }
  return +c;
 }
 a = M() | 0;
 v[31601] = 0;
 W(26);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  P(a | 0);
  p();
 }
 S(0) | 0;
 Rb();
 p();
}

function cfa(a) {
 a = a | 0;
 var b = 0, c = 0, d = 0;
 v[31601] = 0;
 V(1020, a | 0);
 b = v[31601];
 v[31601] = 0;
 a: {
  b: {
   if ((b | 0) != 1) {
    b = v[a + 28 >> 2];
    d = v[v[b >> 2] + 36 >> 2];
    v[31601] = 0;
    c = +ha(d | 0, b | 0);
    b = v[31601];
    v[31601] = 0;
    if ((b | 0) != 1) {
     break b;
    }
   }
   X(S(0) | 0) | 0;
   v[31601] = 0;
   U(982, 7794, a | 0, 0, 0);
   a = v[31601];
   v[31601] = 0;
   if ((a | 0) == 1) {
    break a;
   }
   Y();
   c = 0;
  }
  return +c;
 }
 a = M() | 0;
 v[31601] = 0;
 W(26);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  P(a | 0);
  p();
 }
 S(0) | 0;
 Rb();
 p();
}

function afa(a) {
 a = a | 0;
 var b = 0, c = 0, d = 0;
 v[31601] = 0;
 V(1020, a | 0);
 b = v[31601];
 v[31601] = 0;
 a: {
  b: {
   if ((b | 0) != 1) {
    b = v[a + 28 >> 2];
    d = v[v[b >> 2] + 28 >> 2];
    v[31601] = 0;
    c = +ha(d | 0, b | 0);
    b = v[31601];
    v[31601] = 0;
    if ((b | 0) != 1) {
     break b;
    }
   }
   X(S(0) | 0) | 0;
   v[31601] = 0;
   U(982, 7742, a | 0, 0, 0);
   a = v[31601];
   v[31601] = 0;
   if ((a | 0) == 1) {
    break a;
   }
   Y();
   c = 0;
  }
  return +c;
 }
 a = M() | 0;
 v[31601] = 0;
 W(26);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  P(a | 0);
  p();
 }
 S(0) | 0;
 Rb();
 p();
}

function TA(a, b) {
 a = a | 0;
 b = b | 0;
 var c = C(0), d = 0, e = 0, f = 0;
 t[a + 1074368 | 0] = b;
 aS(a + 1074332 | 0, b);
 a = a + 906300 | 0;
 f = tk(a);
 while (1) {
  if ((a | 0) != (f | 0)) {
   b = v[a >> 2];
   if (b) {
    c = C(1);
    d = v[b + 20 >> 2];
    if (d) {
     c = C(C(w[d + 26 | 0]) * C(.10000000149011612));
    }
    c = c < C(.10000000149011612) ? C(1) : c;
    if (hb[v[v[b >> 2] + 140 >> 2]](b) | 0) {
     d = v[b + 16 >> 2];
     e = d + 1074332 | 0;
     c = C(C(c / z[e + 8 >> 2]) * C(C(y[d + 480232 >> 2]) / z[e + 20 >> 2]));
    }
    z[b + 4196 >> 2] = c;
   }
   a = a + 160 | 0;
   continue;
  }
  break;
 }
}

function ata(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0;
 c = eb - 16 | 0;
 eb = c;
 ac(c + 8 | 0, b, 15);
 d = v[c + 12 >> 2];
 ic(c, v[a >> 2], v[a + 8 >> 2], v[c + 8 >> 2], v[c + 12 >> 2]);
 e = v[c + 4 >> 2];
 if ((e | 0) == (d | 0)) {
  Ub(a, v[c + 12 >> 2]);
 }
 eb = c + 16 | 0;
 if ((d | 0) != (e | 0)) {
  t[b | 0] = 0;
  t[b + 1 | 0] = 0;
  t[b + 2 | 0] = 0;
  t[b + 3 | 0] = 0;
  t[b + 4 | 0] = 0;
  t[b + 5 | 0] = 0;
  t[b + 6 | 0] = 0;
  t[b + 7 | 0] = 0;
  t[b + 7 | 0] = 0;
  t[b + 8 | 0] = 0;
  t[b + 9 | 0] = 0;
  t[b + 10 | 0] = 0;
  t[b + 11 | 0] = 0;
  t[b + 12 | 0] = 0;
  t[b + 13 | 0] = 0;
  t[b + 14 | 0] = 0;
 }
}

function Wx(a, b, c, d) {
 t[a + 53 | 0] = 1;
 a: {
  if (v[a + 4 >> 2] != (c | 0)) {
   break a;
  }
  t[a + 52 | 0] = 1;
  c = v[a + 16 >> 2];
  b: {
   if (!c) {
    v[a + 36 >> 2] = 1;
    v[a + 24 >> 2] = d;
    v[a + 16 >> 2] = b;
    if ((d | 0) != 1) {
     break a;
    }
    if (v[a + 48 >> 2] == 1) {
     break b;
    }
    break a;
   }
   if ((b | 0) == (c | 0)) {
    c = v[a + 24 >> 2];
    if ((c | 0) == 2) {
     v[a + 24 >> 2] = d;
     c = d;
    }
    if (v[a + 48 >> 2] != 1) {
     break a;
    }
    if ((c | 0) == 1) {
     break b;
    }
    break a;
   }
   v[a + 36 >> 2] = v[a + 36 >> 2] + 1;
  }
  t[a + 54 | 0] = 1;
 }
}

function eN(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0;
 c = eb - 16 | 0;
 eb = c;
 a: {
  b: {
   c: {
    if (b >>> 0 >= 256) {
     b = cc(8);
     v[31601] = 0;
     c = O(36, c + 4 | 0, 10735) | 0;
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) == 1) {
      break c;
     }
     rc(b, c);
     v[31601] = 0;
     R(97, b | 0, 48396, 999);
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) != 1) {
      break a;
     }
     a = M() | 0;
     sb(c);
     break b;
    }
    eb = c + 16 | 0;
    return +(+u[(v[a + 32 >> 2] + B(b, 872) | 0) + 1075766 >> 1] * 30517578125e-15);
   }
   a = M() | 0;
   jc(b);
  }
  P(a | 0);
 }
 p();
}

function Zqa(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0;
 c = eb - 16 | 0;
 eb = c;
 ac(c + 8 | 0, b, 14);
 d = v[c + 12 >> 2];
 ic(c, v[a >> 2], v[a + 8 >> 2], v[c + 8 >> 2], v[c + 12 >> 2]);
 e = v[c + 4 >> 2];
 if ((e | 0) == (d | 0)) {
  Ub(a, v[c + 12 >> 2]);
 }
 eb = c + 16 | 0;
 if ((d | 0) != (e | 0)) {
  t[b | 0] = 0;
  t[b + 1 | 0] = 0;
  t[b + 2 | 0] = 0;
  t[b + 3 | 0] = 0;
  t[b + 4 | 0] = 0;
  t[b + 5 | 0] = 0;
  t[b + 6 | 0] = 0;
  t[b + 7 | 0] = 0;
  t[b + 6 | 0] = 0;
  t[b + 7 | 0] = 0;
  t[b + 8 | 0] = 0;
  t[b + 9 | 0] = 0;
  t[b + 10 | 0] = 0;
  t[b + 11 | 0] = 0;
  t[b + 12 | 0] = 0;
  t[b + 13 | 0] = 0;
 }
}

function $r(a, b, c) {
 var d = 0, e = 0, f = 0, g = 0;
 a: {
  d = yk(b, yd(a));
  b = yk(c, b);
  if (Cb(v[a + 4 >> 2], w[a + 11 | 0]) >>> 0 >= d >>> 0) {
   if ((b | 0) == -1) {
    RT(a, d);
    break a;
   }
   c = a;
   e = eb - 16 | 0;
   eb = e;
   v[e + 12 >> 2] = b;
   if (b) {
    f = Cb(v[a + 4 >> 2], w[a + 11 | 0]);
    g = Jb(a);
    b = f - d | 0;
    v[e + 8 >> 2] = b;
    a = v[Gb(e + 12 | 0, e + 8 | 0) >> 2];
    b: {
     if ((b | 0) == (a | 0)) {
      a = b;
      break b;
     }
     d = d + g | 0;
     Mi(d, a + d | 0, b - a | 0);
    }
    Xu(c, g, f - a | 0);
   }
   eb = e + 16 | 0;
   break a;
  }
  cn();
  p();
 }
}

function Fna(a) {
 a = a | 0;
 var b = 0, c = 0, d = 0, e = 0, f = 0, g = 0;
 b = eb - 16 | 0;
 eb = b;
 u[b + 12 >> 1] = 0;
 u[b + 14 >> 1] = 1;
 Gf(b + 14 | 0, x[v[v[a + 24 >> 2] + 8 >> 2] + 12 >> 1]);
 e = b + 12 | 0;
 d = eb - 16 | 0;
 eb = d;
 c = x[b + 14 >> 1];
 v[d + 12 >> 2] = c;
 a: {
  if (Gn(a) >>> 0 >= c >>> 0) {
   g = v[a >> 2];
   f = _c(g, v[a + 4 >> 2]);
   v[d + 8 >> 2] = f;
   Kv(g, v[Gb(d + 12 | 0, d + 8 | 0) >> 2], e);
   if (c >>> 0 > f >>> 0) {
    tp(a, c - f | 0, e);
    break a;
   }
   Id(a, v[a >> 2] + (c << 1) | 0);
   break a;
  }
  VU(a);
  KC(a, ek(a, c));
  tp(a, c, e);
 }
 eb = d + 16 | 0;
 eb = b + 16 | 0;
}
function Ox(a, b, c, d, e, f) {
 var g = 0, h = 0, i = 0;
 g = eb - 16 | 0;
 eb = g;
 v[a + 4 >> 2] = 0;
 v[a >> 2] = 47556;
 i = Dc(80);
 v[31601] = 0;
 d = Q(1098, d | 0) | 0;
 h = v[31601];
 v[31601] = 0;
 a: {
  b: {
   if ((h | 0) != 1) {
    v[g + 8 >> 2] = d;
    d = g + 8 | 0;
    h = v[re(g + 12 | 0, d) >> 2];
    v[31601] = 0;
    b = ga(f | 0, i | 0, b | 0, c - b | 0, h | 0, e | 0) | 0;
    c = v[31601];
    v[31601] = 0;
    if ((c | 0) == 1) {
     break b;
    }
    v[a + 4 >> 2] = b;
    Wc(d);
    eb = g + 16 | 0;
    return a;
   }
   a = M() | 0;
   break a;
  }
  a = M() | 0;
  Wc(g + 8 | 0);
 }
 Bb(i);
 P(a | 0);
 p();
}

function aB(a, b, c) {
 var d = 0, e = 0, f = 0;
 f = Eb(a);
 d = w[b + 11 | 0];
 e = v[b + 4 >> 2];
 a = 0;
 v[31601] = 0;
 N(53, f | 0, Zc(e, d) | 0);
 d = v[31601];
 v[31601] = 0;
 if ((d | 0) != 1) {
  a: {
   while (1) {
    if (Zc(v[b + 4 >> 2], w[b + 11 | 0]) >>> 0 > a >>> 0) {
     d = 65533;
     e = t[dc(b, a) | 0];
     if ((e | 0) >= -96) {
      d = v[((e & 255) << 2) + c >> 2];
     }
     v[31601] = 0;
     N(35, f | 0, d | 0);
     d = v[31601];
     v[31601] = 0;
     if ((d | 0) == 1) {
      break a;
     }
     a = a + 1 | 0;
     continue;
    }
    break;
   }
   return;
  }
 }
 a = M() | 0;
 Tb(f);
 P(a | 0);
 p();
}

function K_(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0;
 d = eb - 32 | 0;
 eb = d;
 e = Mb(a);
 a = vb(v[b >> 2]);
 v[d + 28 >> 2] = a;
 f = vb(v[b + 4 >> 2]);
 a: {
  while (1) {
   if (Hb(a, f)) {
    b = d + 8 | 0;
    pi(b, v[a >> 2], v[a + 4 >> 2]);
    if ((_b(v[d + 8 >> 2]) | 0) == (c | 0)) {
     mp(b, a);
     v[31601] = 0;
     N(360, e | 0, b | 0);
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) == 1) {
      break a;
     }
     tb(b);
    }
    a = v[bm(d + 28 | 0) >> 2];
    continue;
   }
   break;
  }
  eb = d + 32 | 0;
  return;
 }
 a = M() | 0;
 tb(d + 8 | 0);
 Qc(e);
 P(a | 0);
 p();
}

function AK(a, b, c, d) {
 var e = 0, f = 0, g = 0;
 e = eb - 16 | 0;
 eb = e;
 a: {
  if ((a | 0) != (b | 0)) {
   g = v[31476];
   v[31476] = 0;
   Nd();
   a = BK(a, e + 12 | 0, d);
   d = gb;
   f = v[31476];
   b: {
    if (f) {
     if (v[e + 12 >> 2] != (b | 0)) {
      break b;
     }
     if ((f | 0) != 68) {
      break a;
     }
     v[c >> 2] = 4;
     b = !!a & (d | 0) >= 0 | (d | 0) > 0;
     a = b ? -1 : 0;
     d = b ? 2147483647 : -2147483648;
     break a;
    }
    v[31476] = g;
    if (v[e + 12 >> 2] == (b | 0)) {
     break a;
    }
   }
  }
  v[c >> 2] = 4;
  a = 0;
  d = 0;
 }
 eb = e + 16 | 0;
 gb = d;
 return a;
}

function qz(a, b, c) {
 var d = 0, e = 0;
 d = eb - 32 | 0;
 eb = d;
 a: {
  if (w[a + 20 | 0]) {
   break a;
  }
  b = b + c | 0;
  b = b >>> 0 < c >>> 0 ? -1 : b;
  c = v[a + 16 >> 2];
  if (b >>> 0 <= c >>> 0) {
   break a;
  }
  b = mM(b, 4096);
  lM(a, b - c | 0);
  c = v[a + 16 >> 2];
  b = Yb(d + 16 | 0, wb(v[a + 4 >> 2], c), b - c | 0);
  c = v[v[a >> 2] + 44 >> 2];
  e = v[b + 4 >> 2];
  v[d + 8 >> 2] = v[b >> 2];
  v[d + 12 >> 2] = e;
  hb[c | 0](d + 24 | 0, a, d + 8 | 0);
  v[a + 16 >> 2] = v[a + 16 >> 2] + v[d + 28 >> 2];
  if (!(hb[v[v[a >> 2] + 40 >> 2]](a) | 0)) {
   break a;
  }
  t[a + 20 | 0] = 1;
 }
 eb = d + 32 | 0;
}

function tm(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0;
 if (!ud(w[b + 11 | 0])) {
  c = v[b + 4 >> 2];
  v[a >> 2] = v[b >> 2];
  v[a + 4 >> 2] = c;
  v[a + 8 >> 2] = v[b + 8 >> 2];
  return a | 0;
 }
 c = a;
 f = v[b >> 2];
 e = eb - 16 | 0;
 eb = e;
 a: {
  b: {
   d = v[b + 4 >> 2];
   c: {
    if (Kk(d)) {
     Me(a, d);
     break c;
    }
    if (d >>> 0 >= 2147483632) {
     break b;
    }
    pg(e + 8 | 0, Eh(d) + 1 | 0);
    b = v[e + 8 >> 2];
    xd(c, b);
    of(c, v[e + 12 >> 2]);
    Ad(c, d);
    c = b;
   }
   Wg(c, f, d + 1 | 0);
   eb = e + 16 | 0;
   break a;
  }
  pf();
  p();
 }
 return a | 0;
}

function ig(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0;
 if (!ud(w[b + 11 | 0])) {
  c = v[b + 4 >> 2];
  v[a >> 2] = v[b >> 2];
  v[a + 4 >> 2] = c;
  v[a + 8 >> 2] = v[b + 8 >> 2];
  return a | 0;
 }
 c = a;
 f = v[b >> 2];
 e = eb - 16 | 0;
 eb = e;
 a: {
  b: {
   d = v[b + 4 >> 2];
   c: {
    if (Kk(d)) {
     Me(a, d);
     break c;
    }
    if (d >>> 0 >= 2147483632) {
     break b;
    }
    pg(e + 8 | 0, Eh(d) + 1 | 0);
    b = v[e + 8 >> 2];
    xd(c, b);
    of(c, v[e + 12 >> 2]);
    Ad(c, d);
    c = b;
   }
   Cg(c, f, d + 1 | 0);
   eb = e + 16 | 0;
   break a;
  }
  pf();
  p();
 }
 return a | 0;
}

function aq(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0;
 if (!ud(w[b + 11 | 0])) {
  c = v[b + 4 >> 2];
  v[a >> 2] = v[b >> 2];
  v[a + 4 >> 2] = c;
  v[a + 8 >> 2] = v[b + 8 >> 2];
  return a | 0;
 }
 c = a;
 f = v[b >> 2];
 e = eb - 16 | 0;
 eb = e;
 a: {
  b: {
   d = v[b + 4 >> 2];
   c: {
    if (fr(d)) {
     Me(a, d);
     break c;
    }
    if (d >>> 0 >= 1073741808) {
     break b;
    }
    Mj(e + 8 | 0, rn(d) + 1 | 0);
    b = v[e + 8 >> 2];
    xd(c, b);
    of(c, v[e + 12 >> 2]);
    Ad(c, d);
    c = b;
   }
   Qi(c, f, d + 1 | 0);
   eb = e + 16 | 0;
   break a;
  }
  pf();
  p();
 }
 return a | 0;
}

function RH(a, b, c, d, e, f, g) {
 var h = 0;
 v[31601] = 0;
 V(995, a | 0);
 h = v[31601];
 v[31601] = 0;
 a: {
  b: {
   if ((h | 0) != 1) {
    h = v[a + 24 >> 2];
    v[31601] = 0;
    b = ga(g | 0, h | 0, b | 0, c | 0, d | 0, e | 0) | 0;
    c = v[31601];
    v[31601] = 0;
    if ((c | 0) != 1) {
     break b;
    }
   }
   X(S(0) | 0) | 0;
   v[31601] = 0;
   U(982, f | 0, a | 0, 0, 0);
   a = v[31601];
   v[31601] = 0;
   if ((a | 0) == 1) {
    break a;
   }
   Y();
   b = 0;
  }
  return b;
 }
 a = M() | 0;
 v[31601] = 0;
 W(26);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  P(a | 0);
  p();
 }
 S(0) | 0;
 Rb();
 p();
}

function R0(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0;
 e = eb - 16 | 0;
 eb = e;
 c = -1;
 a: {
  if (!ih(a, 7)) {
   break a;
  }
  c = 0;
  if (!OE(a, 11774)) {
   break a;
  }
  c = eb - 16 | 0;
  eb = c;
  f = e + 5 | 0;
  Lw(c + 8 | 0, f);
  d = v[c + 12 >> 2];
  pd(c, a, v[c + 8 >> 2], v[c + 12 >> 2]);
  g = v[c + 4 >> 2];
  if ((g | 0) == (d | 0)) {
   hd(a, v[c + 12 >> 2]);
  }
  eb = c + 16 | 0;
  d = (d | 0) == (g | 0);
  if (!d) {
   LE(f);
  }
  c = -1;
  if (!d) {
   break a;
  }
  c = 0;
  if (!NE(w[e + 6 | 0])) {
   break a;
  }
  c = ve(a, b, ME(f), gb);
 }
 eb = e + 16 | 0;
 return c | 0;
}

function MH(a, b, c) {
 var d = 0;
 d = eb - 16 | 0;
 eb = d;
 a: {
  b: {
   c: {
    if (b >>> 0 >= 256) {
     b = cc(8);
     v[31601] = 0;
     c = O(36, d + 4 | 0, 10735) | 0;
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) == 1) {
      break c;
     }
     rc(b, c);
     v[31601] = 0;
     R(97, b | 0, 48396, 999);
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) != 1) {
      break a;
     }
     a = M() | 0;
     sb(c);
     break b;
    }
    a = (v[a + 32 >> 2] + B(b, 872) | 0) + 1075080 | 0;
    v[a >> 2] = v[a >> 2] | c;
    eb = d + 16 | 0;
    return;
   }
   a = M() | 0;
   jc(b);
  }
  P(a | 0);
 }
 p();
}

function KO(a) {
 a = a | 0;
 var b = 0, c = 0, d = 0;
 b = eb - 16 | 0;
 eb = b;
 a: {
  c = v[a + 36 >> 2];
  d = v[a + 40 >> 2];
  b: {
   if (Hb(c, d)) {
    sc(b + 12 | 0);
    break b;
   }
   vo(b, a);
   v[31601] = 0;
   c = Q(1055, b | 0) | 0;
   d = v[31601];
   v[31601] = 0;
   if ((d | 0) == 1) {
    break a;
   }
   v[b + 12 >> 2] = c;
   nf(b);
   d = v[a + 40 >> 2];
   c = v[a + 36 >> 2];
  }
  c: {
   if (Hb(c, d)) {
    a = a + 36 | 0;
    break c;
   }
   a = v[b + 12 >> 2];
   c = v[a >> 2];
  }
  a = ej(c, v[a + 4 >> 2]);
  vl(b + 12 | 0);
  eb = b + 16 | 0;
  return a | 0;
 }
 a = M() | 0;
 nf(b);
 P(a | 0);
 p();
}

function IX(a) {
 t[a | 0] = 0;
 t[a + 1 | 0] = 0;
 t[a + 2 | 0] = 0;
 t[a + 3 | 0] = 0;
 t[a + 4 | 0] = 0;
 t[a + 5 | 0] = 0;
 t[a + 6 | 0] = 0;
 t[a + 7 | 0] = 0;
 t[a + 22 | 0] = 0;
 t[a + 23 | 0] = 0;
 t[a + 24 | 0] = 0;
 t[a + 25 | 0] = 0;
 t[a + 26 | 0] = 0;
 t[a + 27 | 0] = 0;
 t[a + 28 | 0] = 0;
 t[a + 29 | 0] = 0;
 t[a + 16 | 0] = 0;
 t[a + 17 | 0] = 0;
 t[a + 18 | 0] = 0;
 t[a + 19 | 0] = 0;
 t[a + 20 | 0] = 0;
 t[a + 21 | 0] = 0;
 t[a + 22 | 0] = 0;
 t[a + 23 | 0] = 0;
 t[a + 8 | 0] = 0;
 t[a + 9 | 0] = 0;
 t[a + 10 | 0] = 0;
 t[a + 11 | 0] = 0;
 t[a + 12 | 0] = 0;
 t[a + 13 | 0] = 0;
 t[a + 14 | 0] = 0;
 t[a + 15 | 0] = 0;
}

function HV(a) {
 t[a | 0] = 0;
 t[a + 1 | 0] = 0;
 t[a + 2 | 0] = 0;
 t[a + 3 | 0] = 0;
 t[a + 4 | 0] = 0;
 t[a + 5 | 0] = 0;
 t[a + 6 | 0] = 0;
 t[a + 7 | 0] = 0;
 t[a + 24 | 0] = 0;
 t[a + 25 | 0] = 0;
 t[a + 26 | 0] = 0;
 t[a + 27 | 0] = 0;
 t[a + 28 | 0] = 0;
 t[a + 29 | 0] = 0;
 t[a + 30 | 0] = 0;
 t[a + 31 | 0] = 0;
 t[a + 16 | 0] = 0;
 t[a + 17 | 0] = 0;
 t[a + 18 | 0] = 0;
 t[a + 19 | 0] = 0;
 t[a + 20 | 0] = 0;
 t[a + 21 | 0] = 0;
 t[a + 22 | 0] = 0;
 t[a + 23 | 0] = 0;
 t[a + 8 | 0] = 0;
 t[a + 9 | 0] = 0;
 t[a + 10 | 0] = 0;
 t[a + 11 | 0] = 0;
 t[a + 12 | 0] = 0;
 t[a + 13 | 0] = 0;
 t[a + 14 | 0] = 0;
 t[a + 15 | 0] = 0;
}

function Gs(a, b, c, d, e, f) {
 var g = 0, h = 0, i = 0;
 g = eb - 16 | 0;
 eb = g;
 v[a + 4 >> 2] = 0;
 v[a >> 2] = 47556;
 i = Dc(80);
 v[31601] = 0;
 d = Q(1098, d | 0) | 0;
 h = v[31601];
 v[31601] = 0;
 a: {
  b: {
   if ((h | 0) != 1) {
    v[g + 8 >> 2] = d;
    d = g + 8 | 0;
    h = v[re(g + 12 | 0, d) >> 2];
    v[31601] = 0;
    b = ga(f | 0, i | 0, b | 0, c | 0, h | 0, e | 0) | 0;
    c = v[31601];
    v[31601] = 0;
    if ((c | 0) == 1) {
     break b;
    }
    v[a + 4 >> 2] = b;
    Wc(d);
    eb = g + 16 | 0;
    return a;
   }
   a = M() | 0;
   break a;
  }
  a = M() | 0;
  Wc(g + 8 | 0);
 }
 Bb(i);
 P(a | 0);
 p();
}

function LA(a, b, c) {
 if (Nb(a + 1074312 | 0, 21)) {
  c = c & 255;
  a: {
   switch ((b & 3) - 1 | 0) {
   default:
    return t[c + 31776 | 0];

   case 0:
    return 64 - (c + 1 >>> 1 | 0) | 0;

   case 1:
    return (c >>> 0 < 128) << 6;

   case 2:
    break a;
   }
  }
  return GR(Do(a)) + -64 | 0;
 }
 if (x[a + 480182 >> 1] & 1032) {
  return t[(c >>> 1 & 31) + 30432 | 0];
 }
 a = c & 63;
 b: {
  switch ((b & 3) - 1 | 0) {
  default:
   return t[a + 31648 | 0];

  case 0:
   return (a >>> 0 >= 32 ? 255 : 0) - (a << 2) | 0;

  case 1:
   return a >>> 0 < 32 ? 127 : -127;

  case 2:
   break b;
  }
 }
 return t[a + 31712 | 0];
}

function n5(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0;
 c = Jb(b);
 b = eb - 32 | 0;
 eb = b;
 a = wd(a, 0);
 v[a >> 2] = 96464;
 d = kk(c);
 v[a + 8 >> 2] = d;
 if (!d) {
  a = Cc(b + 8 | 0, c);
  v[31601] = 0;
  c = b + 20 | 0;
  R(1010, c | 0, 17516, a | 0);
  d = v[31601];
  v[31601] = 0;
  a: {
   b: {
    if ((d | 0) != 1) {
     v[31601] = 0;
     V(1366, c | 0);
     c = v[31601];
     v[31601] = 0;
     if ((c | 0) == 1) {
      break b;
     }
     p();
    }
    c = M() | 0;
    break a;
   }
   c = M() | 0;
   sb(b + 20 | 0);
  }
  sb(a);
  P(c | 0);
  p();
 }
 eb = b + 32 | 0;
 v[a >> 2] = 102840;
 return a | 0;
}

function VB(a, b, c, d, e, f) {
 var g = 0, h = 0, i = 0;
 g = eb - 16 | 0;
 eb = g;
 a: {
  if (2147483631 - b >>> 0 >= c >>> 0) {
   h = Jb(a);
   i = g + 4 | 0;
   if (b >>> 0 <= 1073741798) {
    v[g + 12 >> 2] = b << 1;
    v[g + 4 >> 2] = b + c;
    c = Eh(v[ad(i, g + 12 | 0) >> 2]) + 1 | 0;
   } else {
    c = 2147483631;
   }
   pg(i, c);
   c = v[g + 4 >> 2];
   if (e) {
    Wg(c, h, e);
   }
   if ((d | 0) != (e | 0)) {
    Wg((c + e | 0) + f | 0, e + h | 0, d - e | 0);
   }
   if ((b | 0) != 10) {
    Bb(h);
   }
   xd(a, c);
   of(a, v[g + 8 >> 2]);
   eb = g + 16 | 0;
   break a;
  }
  pf();
  p();
 }
 Ad(a, d + f | 0);
}

function Qda(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0;
 v[31601] = 0;
 V(995, a | 0);
 c = v[31601];
 v[31601] = 0;
 d = 1;
 a: {
  b: {
   if ((c | 0) != 1) {
    c = v[a + 24 >> 2];
    v[31601] = 0;
    N(1086, c | 0, b | 0);
    b = v[31601];
    v[31601] = 0;
    if ((b | 0) != 1) {
     break b;
    }
   }
   X(S(0) | 0) | 0;
   v[31601] = 0;
   U(982, 10900, a | 0, 0, 0);
   a = v[31601];
   v[31601] = 0;
   if ((a | 0) == 1) {
    break a;
   }
   Y();
   d = 0;
  }
  return d | 0;
 }
 a = M() | 0;
 v[31601] = 0;
 W(26);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  P(a | 0);
  p();
 }
 S(0) | 0;
 Rb();
 p();
}

function yN(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0;
 c = eb - 16 | 0;
 eb = c;
 a: {
  b: {
   c: {
    if (b - 513 >>> 0 <= 4294966814) {
     b = cc(8);
     v[31601] = 0;
     c = O(36, c + 4 | 0, 9363) | 0;
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) == 1) {
      break c;
     }
     rc(b, c);
     v[31601] = 0;
     R(97, b | 0, 48396, 999);
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) != 1) {
      break a;
     }
     a = M() | 0;
     sb(c);
     break b;
    }
    v[v[a + 32 >> 2] + 1074420 >> 2] = B(b, 1e4);
    eb = c + 16 | 0;
    return;
   }
   a = M() | 0;
   jc(b);
  }
  P(a | 0);
 }
 p();
}

function kba(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0;
 v[a >> 2] = 0;
 v[a + 4 >> 2] = 0;
 sc(a + 8 | 0);
 c = v[b + 4 >> 2];
 d = c;
 b = v[b + 8 >> 2];
 e = b;
 c = Ck(c, b);
 b = eb - 16 | 0;
 eb = b;
 Qd(b + 8 | 0, v[ub(b + 4 | 0, a) >> 2]);
 a: {
  if (!c) {
   break a;
  }
  v[31601] = 0;
  N(1120, a | 0, c | 0);
  f = v[31601];
  v[31601] = 0;
  if ((f | 0) != 1) {
   v[31601] = 0;
   U(1121, a | 0, d | 0, e | 0, c | 0);
   a = v[31601];
   v[31601] = 0;
   if ((a | 0) != 1) {
    break a;
   }
  }
  a = M() | 0;
  cN(b + 8 | 0);
  P(a | 0);
  p();
 }
 a = b + 8 | 0;
 Pd(a);
 cN(a);
 eb = b + 16 | 0;
}

function Xv(a, b) {
 var c = 0;
 c = eb - 16 | 0;
 eb = c;
 v[c + 12 >> 2] = b;
 a: {
  b: {
   switch (a | 0) {
   case 0:
    a = b >> 31 << 6 | b >>> 26;
    b = b << 6;
    a = Fc(Bua(b - -8192 | 0, a - ((b >>> 0 < 4294959104) - 1 | 0) | 0, 16384, 0), gb);
    break a;

   case 1:
    a = b >> 31 << 6 | b >>> 26;
    b = (b << 6) + 2048 | 0;
    a = b >>> 0 < 2048 ? a + 1 | 0 : a;
    a = Fc(Bua(b, a, 4096, 0), gb);
    break a;

   default:
    break b;
   }
  }
  v[c + 8 >> 2] = 1;
  a = Ri(oM(8192 / +v[Ye(c + 12 | 0, c + 8 | 0) >> 2]) * 24 + 8);
 }
 eb = c + 16 | 0;
 return ((a | 0) >= 0 ? a >>> 0 >= 64 ? 64 : a : 0) & 255;
}

function dB(a, b, c) {
 var d = 0, e = 0, f = 0, g = 0, h = 0;
 d = eb - 16 | 0;
 eb = d;
 g = Pu(a, a + 1074376 | 0, b, c);
 a: {
  if (!g) {
   break a;
  }
  Ib(d + 8 | 0, a + 1074312 | 0, 117);
  if (Fb(v[v[d + 8 >> 2] >> 2], v[d + 12 >> 2])) {
   break a;
  }
  f = (B(b, 872) + a | 0) + 1074992 | 0;
  e = v[f + 656 >> 2];
  if (!e) {
   break a;
  }
  h = t[e + 33 | 0];
  if (!h) {
   break a;
  }
  c = Eq(a, v[f + 88 >> 2], e);
  if (!c) {
   break a;
  }
  a = w[f + 799 | 0];
  if (!(!e | (!a | a >>> 0 > 128))) {
   a = w[wb(e + 108 | 0, a - 1 | 0) | 0];
  }
  hb[v[v[c >> 2] + 88 >> 2]](c, g, a, h, b);
 }
 eb = d + 16 | 0;
}

function IC(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0;
 d = eb - 32 | 0;
 eb = d;
 e = Mb(a);
 a = vb(v[b >> 2]);
 v[d + 28 >> 2] = a;
 f = vb(v[b + 4 >> 2]);
 a: {
  while (1) {
   if (Hb(a, f)) {
    b = d + 8 | 0;
    pi(b, v[a >> 2], v[a + 4 >> 2]);
    if (v[d + 8 >> 2] == (c | 0)) {
     mp(b, a);
     v[31601] = 0;
     N(360, e | 0, b | 0);
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) == 1) {
      break a;
     }
     tb(b);
    }
    a = v[bm(d + 28 | 0) >> 2];
    continue;
   }
   break;
  }
  eb = d + 32 | 0;
  return;
 }
 a = M() | 0;
 tb(d + 8 | 0);
 Qc(e);
 P(a | 0);
 p();
}

function E1(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0;
 d = eb - 16 | 0;
 eb = d;
 v[a >> 2] = 0;
 v[a + 4 >> 2] = 0;
 if (!Lb(v[b >> 2], v[b + 8 >> 2], c)) {
  c = jf(b);
 }
 v[a >> 2] = c;
 c = v[b >> 2];
 a: {
  if (hb[v[v[c >> 2] + 16 >> 2]](c) | 0) {
   c = a;
   a = v[b >> 2];
   e = c, f = (hb[v[v[a >> 2] + 20 >> 2]](a) | 0) + v[b + 8 >> 2] | 0, v[e + 4 >> 2] = f;
   break a;
  }
  Qj(a + 8 | 0, v[a >> 2]);
  c = v[a + 8 >> 2];
  a = v[a + 12 >> 2];
  if (lc(c, a)) {
   break a;
  }
  oe(d + 8 | 0, c, a);
  ic(d, v[b >> 2], v[b + 8 >> 2], v[d + 8 >> 2], v[d + 12 >> 2]);
 }
 eb = d + 16 | 0;
}

function zN(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0;
 c = eb - 16 | 0;
 eb = c;
 a: {
  b: {
   c: {
    if (b - 65536 >>> 0 <= 4294901760) {
     b = cc(8);
     v[31601] = 0;
     c = O(36, c + 4 | 0, 5848) | 0;
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) == 1) {
      break c;
     }
     rc(b, c);
     v[31601] = 0;
     R(97, b | 0, 48396, 999);
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) != 1) {
      break a;
     }
     a = M() | 0;
     sb(c);
     break b;
    }
    v[v[a + 32 >> 2] + 1074416 >> 2] = b;
    eb = c + 16 | 0;
    return;
   }
   a = M() | 0;
   jc(b);
  }
  P(a | 0);
 }
 p();
}

function xna(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0;
 if (y[a + 4 >> 2] < y[zb(a) >> 2]) {
  c = eb - 16 | 0;
  eb = c;
  a = lC(c + 4 | 0, a);
  Jm(v[a + 4 >> 2], w[b | 0] | w[b + 1 | 0] << 8 | (w[b + 2 | 0] << 16 | w[b + 3 | 0] << 24));
  v[a + 4 >> 2] = v[a + 4 >> 2] + 4;
  hc(a);
  eb = c + 16 | 0;
  return;
 }
 d = eb - 32 | 0;
 eb = d;
 c = zb(a);
 c = Yf(d + 12 | 0, Kf(a, nc(v[a >> 2], v[a + 4 >> 2]) + 1 | 0), nc(v[a >> 2], v[a + 4 >> 2]), c);
 Jm(v[c + 8 >> 2], w[b | 0] | w[b + 1 | 0] << 8 | (w[b + 2 | 0] << 16 | w[b + 3 | 0] << 24));
 v[c + 8 >> 2] = v[c + 8 >> 2] + 4;
 VY(a, c);
 Xf(c);
 eb = d + 32 | 0;
}

function XI(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0;
 d = eb - 16 | 0;
 eb = d;
 a = wJ(a, c);
 v[a >> 2] = 96344;
 c = kk(Jb(b));
 v[a + 16 >> 2] = c;
 a: {
  b: {
   c: {
    if (!c) {
     v[31601] = 0;
     c = d + 4 | 0;
     R(1001, c | 0, 17977, b | 0);
     b = v[31601];
     v[31601] = 0;
     if ((b | 0) == 1) {
      break c;
     }
     v[31601] = 0;
     V(1366, c | 0);
     b = v[31601];
     v[31601] = 0;
     if ((b | 0) != 1) {
      break a;
     }
     b = M() | 0;
     sb(c);
     break b;
    }
    eb = d + 16 | 0;
    return a | 0;
   }
   b = M() | 0;
  }
  et(a);
  P(b | 0);
 }
 p();
}

function Vn(a, b, c, d, e, f) {
 var g = 0;
 v[31601] = 0;
 V(995, a | 0);
 g = v[31601];
 v[31601] = 0;
 a: {
  b: {
   if ((g | 0) != 1) {
    g = v[a + 24 >> 2];
    v[31601] = 0;
    b = aa(f | 0, g | 0, b | 0, c | 0, d | 0) | 0;
    c = v[31601];
    v[31601] = 0;
    if ((c | 0) != 1) {
     break b;
    }
   }
   X(S(0) | 0) | 0;
   v[31601] = 0;
   U(982, e | 0, a | 0, 0, 0);
   a = v[31601];
   v[31601] = 0;
   if ((a | 0) == 1) {
    break a;
   }
   Y();
   b = 0;
  }
  return b;
 }
 a = M() | 0;
 v[31601] = 0;
 W(26);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  P(a | 0);
  p();
 }
 S(0) | 0;
 Rb();
 p();
}

function Fs(a, b, c, d, e) {
 var f = 0, g = 0, h = 0;
 f = eb - 16 | 0;
 eb = f;
 v[a + 4 >> 2] = 0;
 v[a >> 2] = 47556;
 h = Dc(80);
 v[31601] = 0;
 c = Q(1098, c | 0) | 0;
 g = v[31601];
 v[31601] = 0;
 a: {
  b: {
   if ((g | 0) != 1) {
    v[f + 8 >> 2] = c;
    c = f + 8 | 0;
    g = v[re(f + 12 | 0, c) >> 2];
    v[31601] = 0;
    b = aa(e | 0, h | 0, b | 0, g | 0, d | 0) | 0;
    d = v[31601];
    v[31601] = 0;
    if ((d | 0) == 1) {
     break b;
    }
    v[a + 4 >> 2] = b;
    Wc(c);
    eb = f + 16 | 0;
    return a;
   }
   a = M() | 0;
   break a;
  }
  a = M() | 0;
  Wc(f + 8 | 0);
 }
 Bb(h);
 P(a | 0);
 p();
}

function vra(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0;
 f = eb - 16 | 0;
 eb = f;
 c = Hf(a, c);
 $d(f, v[a + 36 >> 2]);
 a: {
  if (!c) {
   Pc(f, a + 32 | 0, 5);
   e = 0;
   if (Fb(v[v[f >> 2] >> 2], v[f + 4 >> 2])) {
    break a;
   }
  }
  h = v[a + 36 >> 2];
  g = eb - 16 | 0;
  eb = g;
  e = Eb(g + 4 | 0);
  v[31601] = 0;
  aa(469, b | 0, h | 0, e | 0, d | 0) | 0;
  b = v[31601];
  v[31601] = 0;
  b: {
   if ((b | 0) != 1) {
    sb(e);
    eb = g + 16 | 0;
    break b;
   }
   a = M() | 0;
   sb(e);
   P(a | 0);
   p();
  }
  e = c;
 }
 ef(a, e);
 eb = f + 16 | 0;
}

function Uf(a, b, c, d) {
 var e = 0, f = 0, g = 0;
 a: {
  if (!Cb(v[a + 4 >> 2], w[a + 11 | 0]) | (c - b | 0) < 5) {
   break a;
  }
  vt(b, c);
  e = c - 4 | 0;
  c = Jb(a);
  g = c + Cb(v[a + 4 >> 2], w[a + 11 | 0]) | 0;
  b: {
   while (1) {
    c: {
     a = w[c | 0];
     f = a - 127 | 0;
     if (b >>> 0 >= e >>> 0) {
      break c;
     }
     if ((a | 0) != v[b >> 2] & (f & 255) >>> 0 >= 130) {
      break b;
     }
     b = b + 4 | 0;
     c = ((g - c | 0) > 1) + c | 0;
     continue;
    }
    break;
   }
   if ((f & 255) >>> 0 < 130 | a >>> 0 > v[e >> 2] - 1 >>> 0) {
    break a;
   }
  }
  v[d >> 2] = 4;
 }
}

function P0(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0;
 a: {
  e = eb - 32 | 0;
  eb = e;
  f = e + 8 | 0;
  GE(f, c);
  c = w[d | 0];
  v[31601] = 0;
  N(243, e + 20 | 0, c | 0);
  c = v[31601];
  v[31601] = 0;
  b: {
   c: {
    if ((c | 0) != 1) {
     jk(e, f);
     v[31601] = 0;
     U(92, a | 0, b | 0, v[e >> 2], v[e + 4 >> 2]);
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) == 1) {
      break c;
     }
     Ag(f);
     eb = e + 32 | 0;
     break a;
    }
    a = M() | 0;
    sb(e + 8 | 0);
    break b;
   }
   a = M() | 0;
   Ag(e + 8 | 0);
  }
  P(a | 0);
  p();
 }
}

function jV(a, b) {
 var c = 0, d = 0, e = 0;
 c = eb - 16 | 0;
 eb = c;
 d = Eb(a);
 a = w[b + 11 | 0];
 e = v[b + 4 >> 2];
 v[31601] = 0;
 N(114, d | 0, Zc(e, a) | 0);
 a = v[31601];
 v[31601] = 0;
 a: {
  if ((a | 0) != 1) {
   a = yd(b);
   v[c + 12 >> 2] = a;
   b = Cf(b);
   while (1) {
    if (!Hb(a, b)) {
     break a;
    }
    a = w[a | 0];
    v[31601] = 0;
    N(115, d | 0, ((a | 0) == 13 ? 10 : a) << 24 >> 24);
    a = v[31601];
    v[31601] = 0;
    if ((a | 0) != 1) {
     a = v[xe(c + 12 | 0) >> 2];
     continue;
    }
    break;
   }
  }
  a = M() | 0;
  sb(d);
  P(a | 0);
  p();
 }
 eb = c + 16 | 0;
}

function $5(a) {
 a = a | 0;
 if (w[499888]) {
  return v[124971];
 }
 if (!w[500688]) {
  t[500688] = 1;
 }
 kd(500400, 5034);
 kd(500412, 5025);
 kd(500424, 10875);
 kd(500436, 10619);
 kd(500448, 5261);
 kd(500460, 11652);
 kd(500472, 5118);
 kd(500484, 5609);
 kd(500496, 8886);
 kd(500508, 8869);
 kd(500520, 8877);
 kd(500532, 8896);
 kd(500544, 10073);
 kd(500556, 13314);
 kd(500568, 8959);
 kd(500580, 7714);
 kd(500592, 5261);
 kd(500604, 9762);
 kd(500616, 10478);
 kd(500628, 10887);
 kd(500640, 9249);
 kd(500652, 6463);
 kd(500664, 5492);
 kd(500676, 13232);
 t[499888] = 1;
 v[124971] = 500400;
 return 500400;
}

function R6(a, b, c, d, e) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 var f = 0, g = 0, h = 0, i = 0, j = 0, k = 0;
 while (1) {
  a: {
   if ((c | 0) == (d | 0) | e >>> 0 <= h >>> 0) {
    break a;
   }
   f = 1;
   g = eb - 16 | 0;
   eb = g;
   k = qh(g + 12 | 0, v[a + 8 >> 2]);
   i = fq(0, c, d - c | 0, b ? b : 501684);
   ph(k);
   eb = g + 16 | 0;
   b: {
    switch (i + 2 | 0) {
    default:
     f = i;
     break;

    case 0:
    case 1:
     break a;

    case 2:
     break b;
    }
   }
   h = h + 1 | 0;
   j = f + j | 0;
   c = c + f | 0;
   continue;
  }
  break;
 }
 return j | 0;
}

function Mda(a, b) {
 a = a | 0;
 b = +b;
 var c = 0;
 v[31601] = 0;
 V(995, a | 0);
 c = v[31601];
 v[31601] = 0;
 a: {
  b: {
   if ((c | 0) != 1) {
    c = v[a + 24 >> 2];
    v[31601] = 0;
    b = +Va(1088, c | 0, +b);
    c = v[31601];
    v[31601] = 0;
    if ((c | 0) != 1) {
     break b;
    }
   }
   X(S(0) | 0) | 0;
   v[31601] = 0;
   U(982, 7606, a | 0, 0, 0);
   a = v[31601];
   v[31601] = 0;
   if ((a | 0) == 1) {
    break a;
   }
   Y();
   b = 0;
  }
  return +b;
 }
 a = M() | 0;
 v[31601] = 0;
 W(26);
 c = v[31601];
 v[31601] = 0;
 if ((c | 0) != 1) {
  P(a | 0);
  p();
 }
 S(0) | 0;
 Rb();
 p();
}

function Oma(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0;
 d = Eb(a);
 c = w[b + 11 | 0];
 e = v[b + 4 >> 2];
 a = 0;
 v[31601] = 0;
 N(49, d | 0, Zc(e, c) | 0);
 c = v[31601];
 v[31601] = 0;
 if ((c | 0) != 1) {
  a: {
   b: {
    while (1) {
     if (Zc(v[b + 4 >> 2], w[b + 11 | 0]) >>> 0 <= a >>> 0) {
      break b;
     }
     c = t[dc(b, a) | 0];
     v[31601] = 0;
     N(50, d | 0, yf(yf(c)) | 0);
     c = v[31601];
     v[31601] = 0;
     if ((c | 0) != 1) {
      a = a + 1 | 0;
      continue;
     }
     break;
    }
    break a;
   }
   return;
  }
 }
 a = M() | 0;
 sb(d);
 P(a | 0);
 p();
}

function dba(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0;
 a: {
  d = v[b + 1298404 >> 2];
  b = eb - 32 | 0;
  eb = b;
  e = b + 8 | 0;
  Tf(e, c);
  v[31601] = 0;
  c = b + 20 | 0;
  R(502, c | 0, d | 0, e | 0);
  d = v[31601];
  v[31601] = 0;
  b: {
   c: {
    if ((d | 0) != 1) {
     v[31601] = 0;
     R(244, a | 0, 0, c | 0);
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) == 1) {
      break c;
     }
     Tb(c);
     sb(e);
     eb = b + 32 | 0;
     break a;
    }
    a = M() | 0;
    break b;
   }
   a = M() | 0;
   Tb(b + 20 | 0);
  }
  sb(b + 8 | 0);
  P(a | 0);
  p();
 }
}

function pea(a) {
 a = a | 0;
 var b = 0, c = 0;
 v[31601] = 0;
 V(995, a | 0);
 b = v[31601];
 v[31601] = 0;
 a: {
  b: {
   if ((b | 0) != 1) {
    b = v[a + 24 >> 2];
    v[31601] = 0;
    b = Q(1063, b | 0) | 0;
    c = v[31601];
    v[31601] = 0;
    if ((c | 0) != 1) {
     break b;
    }
   }
   X(S(0) | 0) | 0;
   v[31601] = 0;
   U(982, 7278, a | 0, 0, 0);
   a = v[31601];
   v[31601] = 0;
   if ((a | 0) == 1) {
    break a;
   }
   Y();
   b = 0;
  }
  return b | 0;
 }
 a = M() | 0;
 v[31601] = 0;
 W(26);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  P(a | 0);
  p();
 }
 S(0) | 0;
 Rb();
 p();
}

function OQ(a, b) {
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = C(0);
 c = eb - 16 | 0;
 eb = c;
 d = 0;
 a: {
  if (v[(v[v[a >> 2] - 12 >> 2] + a | 0) + 16 >> 2]) {
   break a;
  }
  v[c + 12 >> 2] = 0;
  Ek(a, c + 12 | 0);
  e = v[c + 12 >> 2];
  d = 0;
  if (e >>> 0 > 65535) {
   break a;
  }
  Al(b, e);
  while (1) {
   if ((f | 0) == (e | 0)) {
    d = !v[(v[v[a >> 2] - 12 >> 2] + a | 0) + 16 >> 2];
   } else {
    v[c + 8 >> 2] = 0;
    wq(a, c + 8 | 0);
    g = xb(v[b >> 2], f), h = z[c + 8 >> 2], z[g >> 2] = h;
    f = f + 1 | 0;
    continue;
   }
   break;
  }
 }
 a = d;
 eb = c + 16 | 0;
 return a;
}

function Ho(a, b, c, d) {
 a: {
  if (v[a + 480180 >> 2] == 4) {
   if (c) {
    t[b + 810 | 0] = w[b + 810 | 0] & 15 | c << 4;
    break a;
   }
   c = w[b + 810 | 0] >>> 4 | 0;
   break a;
  }
  if (d) {
   if (c) {
    t[b + 834 | 0] = c;
    break a;
   }
   c = w[b + 834 | 0];
   break a;
  }
  if (c) {
   t[b + 810 | 0] = c;
   break a;
  }
  c = w[b + 810 | 0];
 }
 b: {
  if (!(t[b + 851 | 0] & 1)) {
   break b;
  }
  c = v[b + 688 >> 2] + ((c & 255) << 2) | 0;
  v[b + 688 >> 2] = (c | 0) >= 256 ? 256 : c;
  if (!(t[a + 480180 | 0] & 1)) {
   break b;
  }
  v[b + 88 >> 2] = v[b + 88 >> 2] | 2097152;
 }
}

function JE(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0;
 b = yk(b, yd(a));
 a: {
  f = Cb(v[a + 4 >> 2], w[a + 11 | 0]);
  if (b >>> 0 <= f >>> 0) {
   if (c) {
    e = Lc(a);
    b: {
     if (e - f >>> 0 >= c >>> 0) {
      e = Jb(a);
      if ((b | 0) == (f | 0)) {
       break b;
      }
      g = b + e | 0;
      Mi(g + c | 0, g, f - b | 0);
      break b;
     }
     $m(a, e, (c + f | 0) - e | 0, f, b, 0, c);
     e = v[a >> 2];
    }
    Zl(b + e | 0, c, d);
    b = c + f | 0;
    kg(a, b);
    gd(b + e | 0, 0);
   }
   break a;
  }
  cn();
  p();
 }
 yd(a);
}

function I2(a) {
 a = a | 0;
 var b = 0, c = 0, d = 0, e = 0;
 v[a + 44 >> 2] = 0;
 e = a + 32 | 0;
 c = Jb(e);
 b = Cb(v[a + 36 >> 2], w[a + 43 | 0]);
 d = v[a + 48 >> 2];
 if (d & 8) {
  d = b + c | 0;
  v[a + 44 >> 2] = d;
  Un(a, c, c, d);
  d = v[a + 48 >> 2];
 }
 a: {
  if (!(d & 16)) {
   break a;
  }
  v[a + 44 >> 2] = b + c;
  iC(e, Lc(e));
  Ex(a, c, Cb(v[a + 36 >> 2], w[a + 43 | 0]) + c | 0);
  if (!(w[a + 48 | 0] & 3)) {
   break a;
  }
  while (1) {
   if ((b | 0) < 0) {
    As(a, 2147483647);
    b = b - 2147483647 | 0;
    continue;
   }
   break;
  }
  if (!b) {
   break a;
  }
  As(a, b);
 }
}

function e_(a) {
 var b = 0, c = 0;
 a: {
  if (id(a, 15216, 3)) {
   break a;
  }
  c = w[a + 3 | 0];
  if (c >>> 0 > 9) {
   break a;
  }
  if ((Ab(w[a + 202 | 0] | w[a + 203 | 0] << 8) - 1e4 & 65535) >>> 0 < 57516) {
   break a;
  }
  b = 1;
  b: {
   if (c >>> 0 > 5) {
    break b;
   }
   if (!Ab(w[a + 228 | 0] | w[a + 229 | 0] << 8)) {
    break a;
   }
   if (!Ab(w[a + 230 | 0] | w[a + 231 | 0] << 8)) {
    break a;
   }
   b = 0;
   if (Ab(w[a + 232 | 0] | w[a + 233 | 0] << 8) >>> 0 > 4095) {
    break b;
   }
   b = Ab(w[a + 234 | 0] | w[a + 235 | 0] << 8) >>> 0 < 100;
  }
  return b;
 }
 return 0;
}

function U9(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0;
 d = qm(a);
 v[d >> 2] = 77620;
 a = jM(mc(d), fM(b));
 v[a >> 2] = 77952;
 v[31601] = 0;
 O(341, a + 24 | 0, 65536) | 0;
 c = v[31601];
 v[31601] = 0;
 a: {
  if ((c | 0) != 1) {
   c = 36;
   Qb(a + 36 | 0, 0, 192);
   while (1) {
    e = a + c | 0;
    v[e >> 2] = 0;
    v[e + 4 >> 2] = 0;
    t[e + 8 | 0] = 0;
    c = c + 12 | 0;
    if ((c | 0) != 228) {
     continue;
    }
    break;
   }
   Qb(a + 228 | 0, 0, 64);
   break a;
  }
  b = M() | 0;
  Wt(a);
  P(b | 0);
  p();
 }
 v[a + 292 >> 2] = b;
 v[a >> 2] = 77764;
 return d | 0;
}

function AF(a, b) {
 var c = 0, d = 0, e = 0, f = 0;
 c = eb - 16 | 0;
 eb = c;
 a: {
  if (b >>> 0 < 3) {
   if (!b) {
    break a;
   }
   if (!Lb(v[a >> 2], v[a + 8 >> 2], b)) {
    break a;
   }
   while (1) if ((d | 0) == 2) {
    _i(c + 10 | 0, x[c + 14 >> 1]);
    d = x[c + 10 >> 1];
    break a;
   } else {
    t[c + 13 | 0] = 0;
    f = (c + 14 | 0) + d | 0;
    if (b >>> 0 > d >>> 0) {
     dh(a, c + 13 | 0);
     e = w[c + 13 | 0];
    } else {
     e = 0;
    }
    t[f | 0] = e;
    d = d + 1 | 0;
    continue;
   }
  }
  Z(11235, 9079, 324, 14199);
  p();
 }
 eb = c + 16 | 0;
 return d & 65535;
}

function xqa(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0;
 a: {
  e = eb - 32 | 0;
  eb = e;
  f = e + 8 | 0;
  Gr(f, c);
  v[31601] = 0;
  N(596, e + 20 | 0, d | 0);
  c = v[31601];
  v[31601] = 0;
  b: {
   c: {
    if ((c | 0) != 1) {
     jk(e, f);
     v[31601] = 0;
     U(301, a | 0, b | 0, v[e >> 2], v[e + 4 >> 2]);
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) == 1) {
      break c;
     }
     Ag(f);
     eb = e + 32 | 0;
     break a;
    }
    a = M() | 0;
    sb(e + 8 | 0);
    break b;
   }
   a = M() | 0;
   Ag(e + 8 | 0);
  }
  P(a | 0);
  p();
 }
}

function hf(a) {
 var b = 0, c = 0, d = 0;
 d = eb - 16 | 0;
 eb = d;
 o(+a);
 c = j(1) | 0;
 j(0) | 0;
 c = c & 2147483647;
 a: {
  if (c >>> 0 <= 1072243195) {
   b = 1;
   if (c >>> 0 < 1044816030) {
    break a;
   }
   b = Xp(a, 0);
   break a;
  }
  b = a - a;
  if (c >>> 0 >= 2146435072) {
   break a;
  }
  c = gI(a, d);
  a = A[d + 8 >> 3];
  b = A[d >> 3];
  b: {
   switch (c & 3) {
   case 0:
    b = Xp(b, a);
    break a;

   case 1:
    b = -Yp(b, a, 1);
    break a;

   case 2:
    b = -Xp(b, a);
    break a;

   default:
    break b;
   }
  }
  b = Yp(b, a, 1);
 }
 eb = d + 16 | 0;
 return b;
}

function yea(a) {
 a = a | 0;
 var b = 0, c = 0;
 v[31601] = 0;
 V(995, a | 0);
 b = v[31601];
 v[31601] = 0;
 a: {
  b: {
   if ((b | 0) != 1) {
    b = v[a + 24 >> 2];
    v[31601] = 0;
    c = +ha(1054, b | 0);
    b = v[31601];
    v[31601] = 0;
    if ((b | 0) != 1) {
     break b;
    }
   }
   X(S(0) | 0) | 0;
   v[31601] = 0;
   U(982, 7678, a | 0, 0, 0);
   a = v[31601];
   v[31601] = 0;
   if ((a | 0) == 1) {
    break a;
   }
   Y();
   c = 0;
  }
  return +c;
 }
 a = M() | 0;
 v[31601] = 0;
 W(26);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  P(a | 0);
  p();
 }
 S(0) | 0;
 Rb();
 p();
}

function GY(a) {
 var b = 0;
 a: {
  if (id(a, 14260, 3) | (w[a + 3 | 0] - 52 & 255) >>> 0 < 252) {
   break a;
  }
  if (_b(w[a + 8 | 0] | w[a + 9 | 0] << 8 | (w[a + 10 | 0] << 16 | w[a + 11 | 0] << 24)) + 788 >>> 0 < 840) {
   break a;
  }
  if (_b(w[a + 16 | 0] | w[a + 17 | 0] << 8 | (w[a + 18 | 0] << 16 | w[a + 19 | 0] << 24)) >>> 0 < 52) {
   break a;
  }
  if (_b(w[a + 24 | 0] | w[a + 25 | 0] << 8 | (w[a + 26 | 0] << 16 | w[a + 27 | 0] << 24)) - 1 >>> 0 < 51) {
   break a;
  }
  b = _b(w[a + 32 | 0] | w[a + 33 | 0] << 8 | (w[a + 34 | 0] << 16 | w[a + 35 | 0] << 24)) >>> 0 < 4294967216;
 }
 return b;
}

function ysa(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0;
 a: {
  e = eb - 32 | 0;
  eb = e;
  f = e + 8 | 0;
  OZ(f, c);
  v[31601] = 0;
  N(91, e + 20 | 0, d | 0);
  c = v[31601];
  v[31601] = 0;
  b: {
   c: {
    if ((c | 0) != 1) {
     jk(e, f);
     v[31601] = 0;
     U(92, a | 0, b | 0, v[e >> 2], v[e + 4 >> 2]);
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) == 1) {
      break c;
     }
     Ag(f);
     eb = e + 32 | 0;
     break a;
    }
    a = M() | 0;
    sb(e + 8 | 0);
    break b;
   }
   a = M() | 0;
   Ag(e + 8 | 0);
  }
  P(a | 0);
  p();
 }
}

function uia(a) {
 a = a | 0;
 var b = 0, c = 0;
 b = v[a + 20 >> 2];
 v[b + 148 >> 2] = -1;
 v[31601] = 0;
 N(287, b + 4 | 0, 8);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  b = v[a + 4264 >> 2];
  c = v[v[a + 20 >> 2] + 4 >> 2];
  a = v[a + 4260 >> 2];
  t[c | 0] = a;
  t[c + 1 | 0] = a >>> 8;
  t[c + 2 | 0] = a >>> 16;
  t[c + 3 | 0] = a >>> 24;
  t[c + 4 | 0] = b;
  t[c + 5 | 0] = b >>> 8;
  t[c + 6 | 0] = b >>> 16;
  t[c + 7 | 0] = b >>> 24;
  return;
 }
 b = S(124508) | 0;
 if ((fb | 0) == (_(124508) | 0)) {
  X(b | 0) | 0;
  Mc(v[a + 20 >> 2] + 4 | 0);
  Y();
  return;
 }
 P(b | 0);
 p();
}

function r4(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0;
 a: {
  e = eb - 32 | 0;
  eb = e;
  f = e + 8 | 0;
  $n(f, c);
  v[31601] = 0;
  N(91, e + 20 | 0, d | 0);
  c = v[31601];
  v[31601] = 0;
  b: {
   c: {
    if ((c | 0) != 1) {
     jk(e, f);
     v[31601] = 0;
     U(92, a | 0, b | 0, v[e >> 2], v[e + 4 >> 2]);
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) == 1) {
      break c;
     }
     Ag(f);
     eb = e + 32 | 0;
     break a;
    }
    a = M() | 0;
    sb(e + 8 | 0);
    break b;
   }
   a = M() | 0;
   Ag(e + 8 | 0);
  }
  P(a | 0);
  p();
 }
}

function DE(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0;
 a: {
  e = eb - 32 | 0;
  eb = e;
  f = e + 8 | 0;
  Bw(f, c);
  v[31601] = 0;
  N(91, e + 20 | 0, d | 0);
  c = v[31601];
  v[31601] = 0;
  b: {
   c: {
    if ((c | 0) != 1) {
     jk(e, f);
     v[31601] = 0;
     U(92, a | 0, b | 0, v[e >> 2], v[e + 4 >> 2]);
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) == 1) {
      break c;
     }
     Ag(f);
     eb = e + 32 | 0;
     break a;
    }
    a = M() | 0;
    sb(e + 8 | 0);
    break b;
   }
   a = M() | 0;
   Ag(e + 8 | 0);
  }
  P(a | 0);
  p();
 }
}

function kM(a) {
 var b = 0, c = 0, d = 0, e = 0, f = 0, g = 0;
 a: {
  b = v[a >> 2];
  b: {
   if (!b) {
    break b;
   }
   c = v[a + 8 >> 2];
   if (!c) {
    break b;
   }
   d = v[a + 12 >> 2];
   if (!d) {
    break b;
   }
   a = hb[d | 0](b) | 0;
   e = gb;
   if ((e | 0) < 0) {
    break b;
   }
   if ((hb[c | 0](b, 0, 0, 0) | 0) < 0) {
    break a;
   }
   if ((hb[c | 0](b, 0, 0, 2) | 0) < 0) {
    break a;
   }
   d = hb[d | 0](b) | 0;
   f = gb;
   hb[c | 0](b, a, e, 0) | 0;
   if ((f | 0) < 0) {
    break b;
   }
   g = Uu(d, f);
  }
  return g;
 }
 hb[c | 0](b, a, e, 0) | 0;
 return 0;
}

function jha(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0;
 a = Ii(a, b, c, d);
 v[a >> 2] = 43524;
 c = Mb(a + 4256 | 0);
 b = a + 4208 | 0;
 e = xb(b, 0), f = 1056964608, v[e >> 2] = f;
 e = xb(b, 1), f = 1017370378, v[e >> 2] = f;
 e = xb(b, 2), f = 1028670828, v[e >> 2] = f;
 e = xb(b, 3), f = 1059760811, v[e >> 2] = f;
 e = xb(b, 4), f = 1017370378, v[e >> 2] = f;
 e = xb(b, 5), f = 1065353216, v[e >> 2] = f;
 v[31601] = 0;
 N(940, a + 44 | 0, 2);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  return a | 0;
 }
 b = M() | 0;
 uc(c);
 Zf(a);
 P(b | 0);
 p();
}

function Oi(a) {
 var b = 0, c = 0, d = 0;
 c = eb - 16 | 0;
 eb = c;
 o(+a);
 b = j(1) | 0;
 j(0) | 0;
 b = b & 2147483647;
 a: {
  if (b >>> 0 <= 1072243195) {
   if (b >>> 0 < 1045430272) {
    break a;
   }
   a = Yp(a, 0, 0);
   break a;
  }
  if (b >>> 0 >= 2146435072) {
   a = a - a;
   break a;
  }
  b = gI(a, c);
  a = A[c + 8 >> 3];
  d = A[c >> 3];
  b: {
   switch (b & 3) {
   case 0:
    a = Yp(d, a, 1);
    break a;

   case 1:
    a = Xp(d, a);
    break a;

   case 2:
    a = -Yp(d, a, 1);
    break a;

   default:
    break b;
   }
  }
  a = -Xp(d, a);
 }
 eb = c + 16 | 0;
 return a;
}

function BF(a, b) {
 var c = 0, d = 0, e = 0, f = 0;
 c = eb - 16 | 0;
 eb = c;
 a: {
  if (b >>> 0 < 5) {
   if (!b) {
    break a;
   }
   if (!Lb(v[a >> 2], v[a + 8 >> 2], b)) {
    break a;
   }
   while (1) if ((d | 0) == 4) {
    Jm(c + 4 | 0, v[c + 12 >> 2]);
    d = v[c + 4 >> 2];
    break a;
   } else {
    t[c + 11 | 0] = 0;
    f = (c + 12 | 0) + d | 0;
    if (b >>> 0 > d >>> 0) {
     dh(a, c + 11 | 0);
     e = w[c + 11 | 0];
    } else {
     e = 0;
    }
    t[f | 0] = e;
    d = d + 1 | 0;
    continue;
   }
  }
  Z(11235, 9079, 324, 14199);
  p();
 }
 eb = c + 16 | 0;
 return d;
}

function Fsa(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0;
 d = eb - 240 | 0;
 eb = d;
 c = eb - 16 | 0;
 eb = c;
 f = d + 4 | 0;
 c_(c + 8 | 0, f);
 e = v[c + 12 >> 2];
 pd(c, a, v[c + 8 >> 2], v[c + 12 >> 2]);
 g = v[c + 4 >> 2];
 if ((g | 0) == (e | 0)) {
  hd(a, v[c + 12 >> 2]);
 }
 eb = c + 16 | 0;
 e = (e | 0) == (g | 0);
 if (!e) {
  b_(f);
 }
 c = -1;
 a: {
  if (!e) {
   break a;
  }
  c = 0;
  if (!e_(f)) {
   break a;
  }
  c = ve(a, b, d_(w[d + 8 | 0] | w[d + 9 | 0] << 8 | (w[d + 10 | 0] << 16 | w[d + 11 | 0] << 24)), gb);
 }
 eb = d + 240 | 0;
 return c | 0;
}

function JR(a, b) {
 var c = 0, d = 0, e = 0, f = 0;
 a: {
  if (x[a + 480188 >> 1] <= b >>> 0) {
   break a;
  }
  b: {
   c: {
    c = (B(b, 872) + a | 0) + 1074992 | 0;
    d = w[c + 791 | 0];
    switch (d - 31 | 0) {
    case 1:
     break b;

    case 0:
     break c;

    default:
     break a;
    }
   }
   if (!(w[a + 480209 | 0] & 16)) {
    break a;
   }
  }
  e = a + 1074376 | 0;
  f = (d | 0) == 32;
  d = t[c + 793 | 0];
  d: {
   if ((d | 0) >= 0) {
    c = Oe(a + 901692 | 0, w[c + 844 | 0]);
    break d;
   }
   c = Oe(a + 902204 | 0, d & 127);
  }
  fT(a, e, b, f, c, d & 255);
 }
}

function Go(a, b, c, d) {
 a: {
  if (v[a + 480180 >> 2] == 4) {
   d = w[b + 810 | 0];
   if (c) {
    t[b + 810 | 0] = d & 240 | c;
    break a;
   }
   c = d & 15;
   break a;
  }
  if (d) {
   if (c) {
    t[b + 834 | 0] = c;
    break a;
   }
   c = w[b + 834 | 0];
   break a;
  }
  if (c) {
   t[b + 810 | 0] = c;
   break a;
  }
  c = w[b + 810 | 0];
 }
 b: {
  if (!(t[b + 851 | 0] & 1)) {
   break b;
  }
  c = v[b + 688 >> 2] - ((c & 255) << 2) | 0;
  v[b + 688 >> 2] = (c | 0) > 0 ? c : 0;
  if (!(t[a + 480180 | 0] & 1)) {
   break b;
  }
  v[b + 88 >> 2] = v[b + 88 >> 2] | 2097152;
 }
}

function qv(a, b) {
 var c = 0, d = 0;
 if (a - 268435457 >>> 0 >= 4026531840) {
  a = a + 208 | 0;
  c = B(a, b);
  Aua(b, 0, a, 0);
  a = gb ? 0 : c;
 } else {
  a = 0;
 }
 a: {
  if (!a) {
   break a;
  }
  v[31601] = 0;
  b = Q(780, a | 0) | 0;
  c = v[31601];
  v[31601] = 0;
  b: {
   c: {
    if ((c | 0) == 1) {
     X(S(0) | 0) | 0;
     v[31601] = 0;
     W(26);
     c = v[31601];
     v[31601] = 0;
     b = 0;
     if ((c | 0) == 1) {
      break c;
     }
    }
    break b;
   }
   S(0) | 0;
   Rb();
   p();
  }
  if (!b) {
   break a;
  }
  d = Qb(b, 0, a) - -64 | 0;
 }
 return d;
}

function pla(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0;
 a: {
  d = eb - 32 | 0;
  eb = d;
  e = d + 8 | 0;
  Wv(e, c);
  v[31601] = 0;
  N(474, d + 20 | 0, 41580);
  c = v[31601];
  v[31601] = 0;
  b: {
   c: {
    if ((c | 0) != 1) {
     jk(d, e);
     v[31601] = 0;
     U(92, a | 0, b | 0, v[d >> 2], v[d + 4 >> 2]);
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) == 1) {
      break c;
     }
     Ag(e);
     eb = d + 32 | 0;
     break a;
    }
    a = M() | 0;
    sb(d + 8 | 0);
    break b;
   }
   a = M() | 0;
   Ag(d + 8 | 0);
  }
  P(a | 0);
  p();
 }
}

function rfa(a) {
 a = a | 0;
 var b = 0;
 v[31601] = 0;
 V(1020, a | 0);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  v[a + 24 >> 2] = 0;
  b = v[a + 28 >> 2];
  if (b) {
   hb[v[v[b >> 2] + 4 >> 2]](b);
  }
  v[a + 28 >> 2] = 0;
  b = v[a + 20 >> 2];
  if (b) {
   Bb(b);
   v[a + 20 >> 2] = 0;
  }
  Bb(a);
  return;
 }
 X(S(0) | 0) | 0;
 v[31601] = 0;
 U(982, 5051, a | 0, 0, 0);
 a = v[31601];
 v[31601] = 0;
 if ((a | 0) != 1) {
  Y();
  return;
 }
 a = M() | 0;
 v[31601] = 0;
 W(26);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  P(a | 0);
  p();
 }
 S(0) | 0;
 Rb();
 p();
}

function zR(a, b, c, d) {
 var e = 0, f = 0, g = 0, h = 0;
 e = eb - 16 | 0;
 eb = e;
 a: {
  b: {
   while (1) {
    v[e + 12 >> 2] = b;
    v[e + 8 >> 2] = d;
    if (y[Gb(e + 12 | 0, e + 8 | 0) >> 2] <= f >>> 0) {
     break b;
    }
    g = Lq(t[wb(a, f) | 0]);
    h = Lq(t[wb(c, f) | 0]);
    if ((g | 0) != (h | 0)) {
     a = g >>> 0 < h >>> 0 ? -1 : 1;
     break a;
    }
    f = f + 1 | 0;
    if (g) {
     continue;
    }
    break;
   }
   a = 0;
   break a;
  }
  a = 0;
  if ((b | 0) == (d | 0)) {
   break a;
  }
  a = b >>> 0 < d >>> 0 ? -1 : 1;
 }
 eb = e + 16 | 0;
 return a;
}

function vw(a, b, c, d) {
 var e = 0, f = 0;
 a: {
  e = w[a | 0];
  f = w[c | 0];
  b: {
   if (!(w[d | 0] | ((e | 0) != 11 | (f - 5 & 255) >>> 0 > 1))) {
    t[a | 0] = (f | 0) == 5 ? 7 : 6;
    break b;
   }
   if (!(w[b | 0] | ((f | 0) != 11 | (e - 5 & 255) >>> 0 > 1))) {
    t[a | 0] = (e | 0) == 5 ? 7 : 6;
    t[b | 0] = w[d | 0];
    break b;
   }
   if (!((e | 0) != 10 | (f | 0) != 20 | w[d | 0] != 159)) {
    t[a | 0] = 42;
    break b;
   }
   if ((f | 0) != 10 | (e | 0) != 20 | w[b | 0] != 159) {
    break a;
   }
   t[a | 0] = 42;
   t[b | 0] = w[d | 0];
  }
  t[c | 0] = 0;
 }
}

function V$(a, b) {
 var c = 0, d = 0;
 b = !v[a + 24 >> 2] | b;
 v[a + 16 >> 2] = b;
 if (b & v[a + 20 >> 2]) {
  a = eb - 16 | 0;
  eb = a;
  c = cc(16);
  b = eb - 16 | 0;
  eb = b;
  if (!w[496464]) {
   t[496464] = 1;
  }
  Yb(b + 8 | 0, 1, 125596);
  d = v[b + 12 >> 2];
  v[a + 8 >> 2] = v[b + 8 >> 2];
  v[a + 12 >> 2] = d;
  eb = b + 16 | 0;
  b = v[a + 12 >> 2];
  a = v[a + 8 >> 2];
  v[31601] = 0;
  a = Ba(1231, c | 0, 8943, a | 0, b | 0) | 0;
  b = v[31601];
  v[31601] = 0;
  if ((b | 0) != 1) {
   ca(a | 0, 94284, 1232);
   p();
  }
  a = M() | 0;
  jc(c);
  P(a | 0);
  p();
 }
}

function Gja(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0;
 a: {
  d = eb - 32 | 0;
  eb = d;
  e = d + 8 | 0;
  Qo(e, c);
  v[31601] = 0;
  c = d + 20 | 0;
  N(14, c | 0, e | 0);
  f = v[31601];
  v[31601] = 0;
  b: {
   c: {
    if ((f | 0) != 1) {
     v[31601] = 0;
     R(840, a | 0, b | 0, c | 0);
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) == 1) {
      break c;
     }
     Tb(c);
     sb(e);
     eb = d + 32 | 0;
     break a;
    }
    a = M() | 0;
    break b;
   }
   a = M() | 0;
   Tb(d + 20 | 0);
  }
  sb(d + 8 | 0);
  P(a | 0);
  p();
 }
}

function xT(a, b, c, d, e) {
 var f = 0, g = 0, h = 0, i = 0, j = 0;
 f = eb - 16 | 0;
 eb = f;
 i = v[d + 20 >> 2];
 h = v[d + 52 >> 2];
 g = !h | e;
 t[f + 15 | 0] = g;
 a: {
  if (!g | (b | 0) != 2) {
   break a;
  }
  g = c & 65535;
  j = d + 616 | 0;
  c = 0;
  while (1) {
   if ((c | 0) == (g | 0)) {
    break a;
   }
   v[(B(c, 872) + j | 0) + 764 >> 2] = 0;
   c = c + 1 | 0;
   continue;
  }
 }
 v[d + 24 >> 2] = 0;
 v[d + 16 >> 2] = 0;
 v[d + 20 >> 2] = 0;
 v[d + 48 >> 2] = h;
 u[d + 72 >> 1] = x[d + 74 >> 1];
 de(a, i >>> 0 > 1 & e & (b | 0) == 1, f + 15 | 0);
 eb = f + 16 | 0;
}

function t9() {
 var a = 0, b = 0, c = 0, d = 0, e = 0, f = 0;
 b = eb - 48 | 0;
 eb = b;
 if (AL(0, b + 24 | 0)) {
  Ht(v[31476], 12742);
  p();
 }
 a = we(b + 16 | 0, v[b + 24 >> 2], v[b + 28 >> 2]);
 d = _A(b + 8 | 0, v[b + 32 >> 2] / 1e3 | 0);
 c = eb - 16 | 0;
 eb = c;
 a = Hu(c, v[a >> 2], v[a + 4 >> 2]);
 e = v[a >> 2];
 f = e + v[d >> 2] | 0;
 a = v[d + 4 >> 2] + v[a + 4 >> 2] | 0;
 a = we(c + 8 | 0, f, f >>> 0 < e >>> 0 ? a + 1 | 0 : a);
 d = v[a >> 2];
 eb = c + 16 | 0;
 c = we(b + 40 | 0, d, v[a + 4 >> 2]);
 a = v[c >> 2];
 eb = b + 48 | 0;
 gb = v[c + 4 >> 2];
 return a | 0;
}

function eq(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0;
 d = a;
 e = Rd(b, c);
 f = eb - 16 | 0;
 eb = f;
 a: {
  if (e >>> 0 < 1073741808) {
   b: {
    if (fr(e)) {
     Me(d, e);
     break b;
    }
    Mj(f + 8 | 0, rn(e) + 1 | 0);
    g = v[f + 8 >> 2];
    xd(d, g);
    of(d, v[f + 12 >> 2]);
    Ad(d, e);
    d = g;
   }
   while (1) {
    if ((b | 0) != (c | 0)) {
     xd(d, v[b >> 2]);
     d = d + 4 | 0;
     b = b + 4 | 0;
     continue;
    }
    break;
   }
   xd(d, 0);
   eb = f + 16 | 0;
   break a;
  }
  pf();
  p();
 }
 return a | 0;
}

function Vl(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0;
 d = a;
 e = Oj(b, c);
 f = eb - 16 | 0;
 eb = f;
 a: {
  if (e >>> 0 < 2147483632) {
   b: {
    if (Kk(e)) {
     Me(d, e);
     break b;
    }
    pg(f + 8 | 0, Eh(e) + 1 | 0);
    g = v[f + 8 >> 2];
    xd(d, g);
    of(d, v[f + 12 >> 2]);
    Ad(d, e);
    d = g;
   }
   while (1) {
    if ((b | 0) != (c | 0)) {
     gd(d, w[b | 0]);
     d = d + 1 | 0;
     b = b + 1 | 0;
     continue;
    }
    break;
   }
   gd(d, 0);
   eb = f + 16 | 0;
   break a;
  }
  pf();
  p();
 }
 return a | 0;
}

function tu(a) {
 var b = 0, c = 0, d = 0;
 b = w[a + 4266 | 0];
 z[a + 4236 >> 2] = C(b >>> 0) * C(.00390625);
 z[a + 4240 >> 2] = C(256 - b | 0) * C(.00390625);
 c = w[a + 4267 | 0];
 b = w[a + 4265 | 0];
 z[a + 4244 >> 2] = C(B(c, b) | 0) * C(152587890625e-16);
 d = c | -256;
 z[a + 4256 >> 2] = C(B(d, b | -256) | 0) * C(152587890625e-16);
 z[a + 4252 >> 2] = C(B(b, d) | 0) * C(152587890625e-16);
 z[a + 4248 >> 2] = C(B(256 - b | 0, c) | 0) * C(152587890625e-16);
 b = a;
 c = v[a + 4232 >> 2];
 a = w[a + 4264 | 0];
 v[b + 4228 >> 2] = (B(c, (a ? a : -89) & 255) + 250 >>> 0) / 500;
}

function MK(a) {
 a = a | 0;
 var b = 0, c = 0, d = 0, e = 0, f = 0, g = 0;
 b = eb - 16 | 0;
 eb = b;
 e = b + 16 | 0;
 a: {
  while (1) {
   d = v[a + 36 >> 2];
   c = b + 8 | 0;
   f = hb[v[v[d >> 2] + 20 >> 2]](d, v[a + 40 >> 2], c, e, b + 4 | 0) | 0;
   d = -1;
   g = c;
   c = v[b + 4 >> 2] - c | 0;
   if ((gm(g, 1, c, v[a + 32 >> 2]) | 0) != (c | 0)) {
    break a;
   }
   b: {
    switch (f - 1 | 0) {
    case 1:
     break a;

    case 0:
     continue;

    default:
     break b;
    }
   }
   break;
  }
  d = ku(v[a + 32 >> 2]) ? -1 : 0;
 }
 eb = b + 16 | 0;
 return d | 0;
}

function H9(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0;
 a: {
  d = eb - 32 | 0;
  eb = d;
  e = d + 8 | 0;
  Qo(e, c);
  v[31601] = 0;
  c = d + 20 | 0;
  R(502, c | 0, b | 0, e | 0);
  b = v[31601];
  v[31601] = 0;
  b: {
   c: {
    if ((b | 0) != 1) {
     v[31601] = 0;
     R(244, a | 0, 0, c | 0);
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) == 1) {
      break c;
     }
     Tb(c);
     sb(e);
     eb = d + 32 | 0;
     break a;
    }
    a = M() | 0;
    break b;
   }
   a = M() | 0;
   Tb(d + 20 | 0);
  }
  sb(d + 8 | 0);
  P(a | 0);
  p();
 }
}

function sM(a) {
 a = a | 0;
 var b = 0, c = 0, d = 0, e = 0, f = 0;
 c = v[a >> 2];
 a: {
  if (!c) {
   break a;
  }
  d = v[a + 8 >> 2];
  if (!d) {
   break a;
  }
  e = v[a + 12 >> 2];
  if (!e) {
   break a;
  }
  a = hb[e | 0](c) | 0;
  f = gb;
  if ((f | 0) < 0) {
   break a;
  }
  b = 0;
  b: {
   if ((hb[d | 0](c, 0, 0, 0) | 0) < 0) {
    break b;
   }
   b = 0;
   if ((hb[d | 0](c, 0, 0, 2) | 0) < 0) {
    break b;
   }
   hb[e | 0](c) | 0;
   b = gb;
   if ((b | 0) > 0) {
    b = 1;
   } else {
    b = (b | 0) >= 0;
   }
  }
  hb[d | 0](c, a, f, 0) | 0;
 }
 return b | 0;
}

function Qaa(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0;
 c = eb - 16 | 0;
 eb = c;
 a: {
  b: {
   if ((rk(w[a + 140 | 0]) | 0) != 1) {
    break b;
   }
   if ((RM(a) | 0) != (b | 0)) {
    break b;
   }
   d = a + 120 | 0;
   cu(w[d + 20 | 0]);
   b = eb - 16 | 0;
   eb = b;
   v[b + 12 >> 2] = c + 15;
   a = eb - 16 | 0;
   eb = a;
   v[a + 12 >> 2] = 1150;
   v[a + 8 >> 2] = 1151;
   v[a + 4 >> 2] = 1152;
   v[a >> 2] = 1153;
   hb[v[lq(a, rk(w[d + 20 | 0])) >> 2]](b + 12 | 0, d);
   eb = a + 16 | 0;
   eb = b + 16 | 0;
   break a;
  }
  QM(a, 1, b);
 }
 eb = c + 16 | 0;
}

function Pta(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0;
 e = eb - 16 | 0;
 eb = e;
 a: {
  if (!(c & 1024)) {
   break a;
  }
  f = e, g = yd(b), v[f + 12 >> 2] = g;
  c = Zc(v[b + 4 >> 2], w[b + 11 | 0]);
  b: {
   if (!c) {
    break b;
   }
   if (w[dc(b, 0) | 0] != 43) {
    if (w[dc(b, 0) | 0] != 45) {
     break b;
    }
   }
   d = d + 1 | 0;
   hV(e + 12 | 0);
  }
  if (c >>> 0 >= d >>> 0) {
   break a;
  }
  JE(b, v[ub(e + 8 | 0, v[e + 12 >> 2]) >> 2], d - Zc(v[b + 4 >> 2], w[b + 11 | 0]) | 0, 48);
 }
 Uc(a, b);
 eb = e + 16 | 0;
}

function P9(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0;
 d = eb - 16 | 0;
 eb = d;
 v[a >> 2] = 0;
 v[a + 4 >> 2] = 0;
 sc(a + 8 | 0);
 Qd(d + 8 | 0, v[ub(d + 4 | 0, a) >> 2]);
 a: {
  if (!c) {
   break a;
  }
  v[31601] = 0;
  N(1204, a | 0, c | 0);
  e = v[31601];
  v[31601] = 0;
  if ((e | 0) != 1) {
   v[31601] = 0;
   U(1205, a | 0, b | 0, Ud(b, c) | 0, c | 0);
   b = v[31601];
   v[31601] = 0;
   if ((b | 0) != 1) {
    break a;
   }
  }
  a = M() | 0;
  aM(d + 8 | 0);
  P(a | 0);
  p();
 }
 b = d + 8 | 0;
 Pd(b);
 aM(b);
 eb = d + 16 | 0;
 return a | 0;
}

function N3(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0;
 e = v[a + 84 >> 2];
 f = v[e >> 2];
 d = v[e + 4 >> 2];
 h = v[a + 28 >> 2];
 g = v[a + 20 >> 2] - h | 0;
 g = d >>> 0 < g >>> 0 ? d : g;
 if (g) {
  yc(f, h, g);
  f = g + v[e >> 2] | 0;
  v[e >> 2] = f;
  d = v[e + 4 >> 2] - g | 0;
  v[e + 4 >> 2] = d;
 }
 d = c >>> 0 > d >>> 0 ? d : c;
 if (d) {
  yc(f, b, d);
  f = d + v[e >> 2] | 0;
  v[e >> 2] = f;
  v[e + 4 >> 2] = v[e + 4 >> 2] - d;
 }
 t[f | 0] = 0;
 b = v[a + 44 >> 2];
 v[a + 28 >> 2] = b;
 v[a + 20 >> 2] = b;
 return c | 0;
}

function wfa(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0;
 v[31601] = 0;
 V(995, a | 0);
 c = v[31601];
 v[31601] = 0;
 a: {
  b: {
   if ((c | 0) != 1) {
    v[a + 16 >> 2] = b;
    b = v[a + 20 >> 2];
    if (!b) {
     break b;
    }
    Bb(b);
    v[a + 20 >> 2] = 0;
    return;
   }
   X(S(0) | 0) | 0;
   v[31601] = 0;
   U(982, 5660, a | 0, 0, 0);
   a = v[31601];
   v[31601] = 0;
   if ((a | 0) == 1) {
    break a;
   }
   Y();
  }
  return;
 }
 a = M() | 0;
 v[31601] = 0;
 W(26);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  P(a | 0);
  p();
 }
 S(0) | 0;
 Rb();
 p();
}

function Upa(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0;
 a: {
  d = eb - 32 | 0;
  eb = d;
  e = d + 8 | 0;
  Qo(e, c);
  v[31601] = 0;
  c = d + 20 | 0;
  R(123, c | 0, b | 0, e | 0);
  b = v[31601];
  v[31601] = 0;
  b: {
   c: {
    if ((b | 0) != 1) {
     v[31601] = 0;
     N(12, a | 0, c | 0);
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) == 1) {
      break c;
     }
     Tb(c);
     sb(e);
     eb = d + 32 | 0;
     break a;
    }
    a = M() | 0;
    break b;
   }
   a = M() | 0;
   Tb(d + 20 | 0);
  }
  sb(d + 8 | 0);
  P(a | 0);
  p();
 }
}

function Gqa(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0;
 a: {
  d = eb - 32 | 0;
  eb = d;
  e = d + 8 | 0;
  zp(e, b, c);
  v[31601] = 0;
  b = d + 20 | 0;
  R(123, b | 0, 28, e | 0);
  c = v[31601];
  v[31601] = 0;
  b: {
   c: {
    if ((c | 0) != 1) {
     v[31601] = 0;
     N(12, a | 0, b | 0);
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) == 1) {
      break c;
     }
     Tb(b);
     sb(e);
     eb = d + 32 | 0;
     break a;
    }
    a = M() | 0;
    break b;
   }
   a = M() | 0;
   Tb(d + 20 | 0);
  }
  sb(d + 8 | 0);
  P(a | 0);
  p();
 }
}

function tZ(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0;
 a: {
  d = eb - 32 | 0;
  eb = d;
  e = d + 8 | 0;
  Tf(e, c);
  v[31601] = 0;
  c = d + 20 | 0;
  R(502, c | 0, b | 0, e | 0);
  b = v[31601];
  v[31601] = 0;
  b: {
   c: {
    if ((b | 0) != 1) {
     v[31601] = 0;
     N(12, a | 0, c | 0);
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) == 1) {
      break c;
     }
     Tb(c);
     sb(e);
     eb = d + 32 | 0;
     break a;
    }
    a = M() | 0;
    break b;
   }
   a = M() | 0;
   Tb(d + 20 | 0);
  }
  sb(d + 8 | 0);
  P(a | 0);
  p();
 }
}

function YW(a) {
 var b = 0, c = 0;
 a: {
  if ((w[a | 0] | w[a + 1 | 0] << 8 | (w[a + 2 | 0] << 16 | w[a + 3 | 0] << 24)) != -28486832 | w[a + 63 | 0] != 26) {
   break a;
  }
  b = w[a + 65 | 0];
  if (w[a + 66 | 0] | (b | 0) != 16 & (b | 0) != 1 | (w[a + 64 | 0] & 3 | (w[a + 78 | 0] | w[a + 79 | 0] << 8) >>> 0 > 127)) {
   break a;
  }
  if ((w[a + 80 | 0] | w[a + 81 | 0] << 8) >>> 0 > 127) {
   break a;
  }
  b = a + 80 | 0;
  a = a + 78 | 0;
  a = Wk(w[a | 0] | w[a + 1 | 0] << 8, w[b | 0] | w[b + 1 | 0] << 8) ? b : a;
  c = (w[a | 0] | w[a + 1 | 0] << 8) != 0;
 }
 return c;
}

function vpa(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0;
 d = eb - 1120 | 0;
 eb = d;
 c = eb - 16 | 0;
 eb = c;
 e = d + 12 | 0;
 vX(c + 8 | 0, e);
 f = v[c + 12 >> 2];
 pd(c, a, v[c + 8 >> 2], v[c + 12 >> 2]);
 g = v[c + 4 >> 2];
 if ((g | 0) == (f | 0)) {
  hd(a, v[c + 12 >> 2]);
 }
 eb = c + 16 | 0;
 c = -1;
 a: {
  if ((f | 0) != (g | 0)) {
   break a;
  }
  c = 0;
  if (!xX(e)) {
   break a;
  }
  c = ve(a, b, wX(w[d + 1116 | 0] | w[d + 1117 | 0] << 8 | (w[d + 1118 | 0] << 16 | w[d + 1119 | 0] << 24)), gb);
 }
 eb = d + 1120 | 0;
 return c | 0;
}

function Hm(a) {
 if ((a | 0) >= 0) {
  if (a >>> 0 <= 16383) {
   if (a >>> 0 <= 15) {
    return t[a + 88832 | 0];
   }
   if (a >>> 0 <= 511) {
    return t[(a >>> 5 | 0) + 88832 | 0] + 5 | 0;
   }
   return t[(a >>> 10 | 0) + 88832 | 0] + 10 | 0;
  }
  if (a >>> 0 <= 16777215) {
   if (a >>> 0 <= 524287) {
    return t[(a >>> 15 | 0) + 88832 | 0] + 15 | 0;
   }
   return t[(a >>> 20 | 0) + 88832 | 0] + 20 | 0;
  }
  if (a >>> 0 <= 536870911) {
   return t[(a >>> 25 | 0) + 88832 | 0] + 25 | 0;
  }
  a = t[(a >>> 30 | 0) + 88832 | 0] + 30 | 0;
 } else {
  a = 0;
 }
 return a;
}

function XR(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0;
 a: {
  c = eb - 32 | 0;
  eb = c;
  d = c + 8 | 0;
  VR(d, b + 80 | 0);
  v[31601] = 0;
  b = c + 20 | 0;
  R(123, b | 0, 0, d | 0);
  e = v[31601];
  v[31601] = 0;
  b: {
   c: {
    if ((e | 0) != 1) {
     v[31601] = 0;
     N(12, a | 0, b | 0);
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) == 1) {
      break c;
     }
     Tb(b);
     sb(d);
     eb = c + 32 | 0;
     break a;
    }
    a = M() | 0;
    break b;
   }
   a = M() | 0;
   Tb(c + 20 | 0);
  }
  sb(c + 8 | 0);
  P(a | 0);
  p();
 }
}

function _ia(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0;
 v[a >> 2] = 0;
 v[a + 4 >> 2] = 0;
 sc(a + 8 | 0);
 c = v[b >> 2];
 d = c;
 b = v[b + 4 >> 2];
 e = b;
 c = nc(c, b);
 b = eb - 16 | 0;
 eb = b;
 Qd(b + 8 | 0, v[ub(b + 4 | 0, a) >> 2]);
 a: {
  b: {
   if (c) {
    v[31601] = 0;
    N(225, a | 0, c | 0);
    f = v[31601];
    v[31601] = 0;
    if ((f | 0) == 1) {
     break b;
    }
    yq(a, d, e, c);
   }
   c = b + 8 | 0;
   Pd(c);
   ah(c);
   eb = b + 16 | 0;
   break a;
  }
  a = M() | 0;
  ah(b + 8 | 0);
  P(a | 0);
  p();
 }
 return a | 0;
}

function S$(a, b, c, d) {
 var e = 0, f = 0, g = 0, h = 0;
 e = Cb(v[a + 4 >> 2], w[a + 11 | 0]);
 if (e >>> 0 >= b >>> 0) {
  f = Lc(a);
  a: {
   if (f - e >>> 0 >= d >>> 0) {
    if (!d) {
     break a;
    }
    f = Jb(a);
    h = f + b | 0;
    if ((b | 0) != (e | 0)) {
     g = b + f | 0;
     Mi(g + d | 0, g, e - b | 0);
     c = (c >>> 0 >= g >>> 0 ? e + f >>> 0 > c >>> 0 ? d : 0 : 0) + c | 0;
    }
    Mi(h, c, d);
    b = d + e | 0;
    kg(a, b);
    gd(b + f | 0, 0);
    return a;
   }
   Zp(a, f, (d + e | 0) - f | 0, e, b, 0, d, c);
  }
  return a;
 }
 cn();
 p();
}

function DC(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0;
 v[a >> 2] = 0;
 v[a + 4 >> 2] = 0;
 sc(a + 8 | 0);
 c = v[b >> 2];
 d = c;
 b = v[b + 4 >> 2];
 e = b;
 c = Sc(c, b);
 b = eb - 16 | 0;
 eb = b;
 Qd(b + 8 | 0, v[ub(b + 4 | 0, a) >> 2]);
 a: {
  b: {
   if (c) {
    v[31601] = 0;
    N(322, a | 0, c | 0);
    f = v[31601];
    v[31601] = 0;
    if ((f | 0) == 1) {
     break b;
    }
    xn(a, d, e, c);
   }
   c = b + 8 | 0;
   Pd(c);
   Wi(c);
   eb = b + 16 | 0;
   break a;
  }
  a = M() | 0;
  Wi(b + 8 | 0);
  P(a | 0);
  p();
 }
 return a | 0;
}

function eR(a, b) {
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0;
 if ((a | 0) != (b | 0)) {
  c = v[b >> 2];
  d = v[b + 4 >> 2];
  b = Rd(c, d);
  e = eb - 16 | 0;
  eb = e;
  a: {
   if (Ug(a) >>> 0 >= b >>> 0) {
    f = v[a >> 2];
    g = nc(f, v[a + 4 >> 2]);
    if (b >>> 0 > g >>> 0) {
     h = c;
     c = gD(c, g);
     uA(h, c, f);
     yq(a, c, d, b - nc(v[a >> 2], v[a + 4 >> 2]) | 0);
     break a;
    }
    Iv(e + 8 | 0, c, d, f);
    Id(a, v[e + 12 >> 2]);
    break a;
   }
   qr(a);
   hm(a, Kf(a, b));
   yq(a, c, d, b);
  }
  eb = e + 16 | 0;
 }
 return a;
}

function Lha(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0;
 a: {
  c = eb - 32 | 0;
  eb = c;
  d = c + 8 | 0;
  Tf(d, b);
  v[31601] = 0;
  b = c + 20 | 0;
  N(957, b | 0, d | 0);
  e = v[31601];
  v[31601] = 0;
  b: {
   c: {
    if ((e | 0) != 1) {
     v[31601] = 0;
     R(958, a | 0, 0, b | 0);
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) == 1) {
      break c;
     }
     Tb(b);
     sb(d);
     eb = c + 32 | 0;
     break a;
    }
    a = M() | 0;
    break b;
   }
   a = M() | 0;
   Tb(c + 20 | 0);
  }
  sb(c + 8 | 0);
  P(a | 0);
  p();
 }
}

function z1(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0;
 a: {
  c = eb - 32 | 0;
  eb = c;
  d = c + 8 | 0;
  Tf(d, b);
  v[31601] = 0;
  b = c + 20 | 0;
  R(123, b | 0, 22, d | 0);
  e = v[31601];
  v[31601] = 0;
  b: {
   c: {
    if ((e | 0) != 1) {
     v[31601] = 0;
     N(12, a | 0, b | 0);
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) == 1) {
      break c;
     }
     Tb(b);
     sb(d);
     eb = c + 32 | 0;
     break a;
    }
    a = M() | 0;
    break b;
   }
   a = M() | 0;
   Tb(c + 20 | 0);
  }
  sb(c + 8 | 0);
  P(a | 0);
  p();
 }
}

function msa(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0;
 c = eb - 16 | 0;
 eb = c;
 v[c + 12 >> 2] = 1;
 a: {
  if (Ug(a)) {
   d = v[a >> 2];
   f = nc(d, v[a + 4 >> 2]);
   v[c + 8 >> 2] = f;
   e = v[Gb(c + 12 | 0, c + 8 | 0) >> 2];
   while (1) {
    if (e) {
     u[d >> 1] = x[b >> 1];
     t[d + 2 | 0] = w[b + 2 | 0];
     e = e - 1 | 0;
     d = d + 4 | 0;
     continue;
    }
    break;
   }
   if (!f) {
    TZ(a, b);
    break a;
   }
   Id(a, v[a >> 2] + 4 | 0);
   break a;
  }
  qr(a);
  hm(a, Kf(a, 1));
  TZ(a, b);
 }
 eb = c + 16 | 0;
}

function jja(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0;
 a: {
  c = eb - 32 | 0;
  eb = c;
  d = c + 8 | 0;
  Rk(d, b);
  v[31601] = 0;
  b = c + 20 | 0;
  N(14, b | 0, d | 0);
  e = v[31601];
  v[31601] = 0;
  b: {
   c: {
    if ((e | 0) != 1) {
     v[31601] = 0;
     R(244, a | 0, 0, b | 0);
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) == 1) {
      break c;
     }
     Tb(b);
     sb(d);
     eb = c + 32 | 0;
     break a;
    }
    a = M() | 0;
    break b;
   }
   a = M() | 0;
   Tb(c + 20 | 0);
  }
  sb(c + 8 | 0);
  P(a | 0);
  p();
 }
}

function bz(a, b, c, d) {
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0;
 g = eb - 240 | 0;
 eb = g;
 v[g >> 2] = a;
 h = 1;
 a: {
  if ((c | 0) < 2) {
   break a;
  }
  e = a;
  while (1) {
   e = e - 4 | 0;
   i = c - 2 | 0;
   f = e - v[(i << 2) + d >> 2] | 0;
   if ((mo(a, f, b) | 0) >= 0) {
    if ((mo(a, e, b) | 0) >= 0) {
     break a;
    }
   }
   j = f;
   f = (mo(f, e, b) | 0) >= 0;
   e = f ? j : e;
   v[(h << 2) + g >> 2] = e;
   h = h + 1 | 0;
   c = f ? c - 1 | 0 : i;
   if ((c | 0) > 1) {
    continue;
   }
   break;
  }
 }
 xL(g, h);
 eb = g + 240 | 0;
}

function Cja(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0;
 a: {
  c = eb - 32 | 0;
  eb = c;
  d = c + 8 | 0;
  Qo(d, b);
  v[31601] = 0;
  b = c + 20 | 0;
  N(14, b | 0, d | 0);
  e = v[31601];
  v[31601] = 0;
  b: {
   c: {
    if ((e | 0) != 1) {
     v[31601] = 0;
     R(244, a | 0, 0, b | 0);
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) == 1) {
      break c;
     }
     Tb(b);
     sb(d);
     eb = c + 32 | 0;
     break a;
    }
    a = M() | 0;
    break b;
   }
   a = M() | 0;
   Tb(c + 20 | 0);
  }
  sb(c + 8 | 0);
  P(a | 0);
  p();
 }
}

function y3(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0;
 d = eb + -64 | 0;
 eb = d;
 e = 1;
 a: {
  if (kh(a, b, 0)) {
   break a;
  }
  e = 0;
  if (!b) {
   break a;
  }
  b = iB(b, 124116, 124164);
  e = 0;
  if (!b) {
   break a;
  }
  Qb(d + 12 | 0, 0, 52);
  v[d + 56 >> 2] = 1;
  v[d + 20 >> 2] = -1;
  v[d + 16 >> 2] = a;
  v[d + 8 >> 2] = b;
  hb[v[v[b >> 2] + 28 >> 2]](b, d + 8 | 0, v[c >> 2], 1);
  a = v[d + 32 >> 2];
  if ((a | 0) == 1) {
   v[c >> 2] = v[d + 24 >> 2];
  }
  e = (a | 0) == 1;
 }
 a = e;
 eb = d - -64 | 0;
 return a | 0;
}

function gf(a, b, c) {
 var d = 0, e = 0, f = 0;
 e = Eb(a);
 d = w[b + 11 | 0];
 f = v[b + 4 >> 2];
 a = 0;
 v[31601] = 0;
 N(53, e | 0, Zc(f, d) | 0);
 d = v[31601];
 v[31601] = 0;
 if ((d | 0) != 1) {
  a: {
   while (1) {
    if (Zc(v[b + 4 >> 2], w[b + 11 | 0]) >>> 0 > a >>> 0) {
     d = v[(w[dc(b, a) | 0] << 2) + c >> 2];
     v[31601] = 0;
     N(35, e | 0, d | 0);
     d = v[31601];
     v[31601] = 0;
     if ((d | 0) == 1) {
      break a;
     }
     a = a + 1 | 0;
     continue;
    }
    break;
   }
   return;
  }
 }
 a = M() | 0;
 Tb(e);
 P(a | 0);
 p();
}

function zfa(a) {
 a = a | 0;
 var b = 0;
 v[31601] = 0;
 V(995, a | 0);
 b = v[31601];
 v[31601] = 0;
 a: {
  b: {
   if ((b | 0) != 1) {
    v[a + 16 >> 2] = 0;
    b = v[a + 20 >> 2];
    if (!b) {
     break b;
    }
    Bb(b);
    v[a + 20 >> 2] = 0;
    return;
   }
   X(S(0) | 0) | 0;
   v[31601] = 0;
   U(982, 8916, a | 0, 0, 0);
   a = v[31601];
   v[31601] = 0;
   if ((a | 0) == 1) {
    break a;
   }
   Y();
  }
  return;
 }
 a = M() | 0;
 v[31601] = 0;
 W(26);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  P(a | 0);
  p();
 }
 S(0) | 0;
 Rb();
 p();
}

function isa(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0;
 d = eb - 576 | 0;
 eb = d;
 c = eb - 16 | 0;
 eb = c;
 KZ(c + 8 | 0, d);
 e = v[c + 12 >> 2];
 pd(c, a, v[c + 8 >> 2], v[c + 12 >> 2]);
 f = v[c + 4 >> 2];
 if ((f | 0) == (e | 0)) {
  hd(a, v[c + 12 >> 2]);
 }
 eb = c + 16 | 0;
 e = (e | 0) == (f | 0);
 if (!e) {
  JZ(d);
 }
 c = -1;
 a: {
  if (!e) {
   break a;
  }
  c = 0;
  if (!MZ(d)) {
   break a;
  }
  c = ve(a, b, LZ(w[d + 34 | 0] | w[d + 35 | 0] << 8, w[d + 36 | 0] | w[d + 37 | 0] << 8), gb);
 }
 eb = d + 576 | 0;
 return c | 0;
}

function sP(a) {
 a = a | 0;
 var b = 0, c = 0, d = 0, e = 0, f = 0;
 b = eb - 16 | 0;
 eb = b;
 a = Mb(a);
 v[31601] = 0;
 c = b + 4 | 0;
 V(985, c | 0);
 d = v[31601];
 v[31601] = 0;
 a: {
  b: {
   if ((d | 0) != 1) {
    d = vb(v[b + 4 >> 2]);
    e = vb(v[b + 8 >> 2]);
    f = v[ub(b, a) >> 2];
    v[31601] = 0;
    R(986, d | 0, e | 0, f | 0);
    d = v[31601];
    v[31601] = 0;
    if ((d | 0) == 1) {
     break b;
    }
    uc(c);
    eb = b + 16 | 0;
    return;
   }
   c = M() | 0;
   break a;
  }
  c = M() | 0;
  uc(b + 4 | 0);
 }
 Sd(a);
 P(c | 0);
 p();
}
function E2(a) {
 a = a | 0;
 var b = 0, c = 0, d = 0, e = 0;
 a: {
  b = eb - 32 | 0;
  eb = b;
  c = b + 8 | 0;
  Cc(c, 13576);
  v[31601] = 0;
  d = b + 20 | 0;
  R(123, d | 0, 1, c | 0);
  e = v[31601];
  v[31601] = 0;
  b: {
   c: {
    if ((e | 0) != 1) {
     v[31601] = 0;
     N(12, a | 0, d | 0);
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) == 1) {
      break c;
     }
     Tb(d);
     sb(c);
     eb = b + 32 | 0;
     break a;
    }
    a = M() | 0;
    break b;
   }
   a = M() | 0;
   Tb(b + 20 | 0);
  }
  sb(b + 8 | 0);
  P(a | 0);
  p();
 }
}

function nH(a, b, c, d, e) {
 var f = 0, g = 0;
 a: {
  f = eb - 32 | 0;
  eb = f;
  g = f + 8 | 0;
  Op(g, c);
  v[31601] = 0;
  N(e | 0, f + 20 | 0, d | 0);
  c = v[31601];
  v[31601] = 0;
  b: {
   c: {
    if ((c | 0) != 1) {
     jk(f, g);
     v[31601] = 0;
     U(92, a | 0, b | 0, v[f >> 2], v[f + 4 >> 2]);
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) == 1) {
      break c;
     }
     Ag(g);
     eb = f + 32 | 0;
     break a;
    }
    a = M() | 0;
    sb(f + 8 | 0);
    break b;
   }
   a = M() | 0;
   Ag(f + 8 | 0);
  }
  P(a | 0);
  p();
 }
}

function gH(a, b, c, d, e) {
 var f = 0, g = 0;
 a: {
  f = eb - 32 | 0;
  eb = f;
  g = f + 8 | 0;
  I_(g, c);
  v[31601] = 0;
  N(e | 0, f + 20 | 0, d | 0);
  c = v[31601];
  v[31601] = 0;
  b: {
   c: {
    if ((c | 0) != 1) {
     jk(f, g);
     v[31601] = 0;
     U(92, a | 0, b | 0, v[f >> 2], v[f + 4 >> 2]);
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) == 1) {
      break c;
     }
     Ag(g);
     eb = f + 32 | 0;
     break a;
    }
    a = M() | 0;
    sb(f + 8 | 0);
    break b;
   }
   a = M() | 0;
   Ag(f + 8 | 0);
  }
  P(a | 0);
  p();
 }
}

function wka(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0;
 v[a >> 2] = b;
 c = eb - 16 | 0;
 eb = c;
 d = Dc(223888);
 v[31601] = 0;
 b = O(841, d | 0, b + 1074376 | 0) | 0;
 e = v[31601];
 v[31601] = 0;
 a: {
  if ((e | 0) != 1) {
   b = xf(c + 12 | 0, b);
   eb = c + 16 | 0;
   b = v[b >> 2];
   break a;
  }
  a = M() | 0;
  Bb(d);
  P(a | 0);
  p();
 }
 v[a + 4 >> 2] = b;
 b = Mb(a + 8 | 0);
 v[31601] = 0;
 V(606, a | 0);
 c = v[31601];
 v[31601] = 0;
 if ((c | 0) != 1) {
  return a | 0;
 }
 c = M() | 0;
 Be(b);
 WS(a + 4 | 0);
 P(c | 0);
 p();
}

function pv(a, b) {
 var c = 0, d = 0;
 c = eb - 32 | 0;
 eb = c;
 d = c + 16 | 0;
 UV(d, a, a + 1 | 0, a + 2 | 0, a + 3 | 0);
 UV(c, b, b + 1 | 0, b + 2 | 0, b + 3 | 0);
 a = ov(w[v[d >> 2]], w[v[c >> 2]]);
 a: {
  if (!Kj(a)) {
   break a;
  }
  a = w[v[d + 4 >> 2]];
  b = w[v[c + 4 >> 2]];
  a = (a | 0) != (b | 0) ? a << 24 >> 24 < b << 24 >> 24 ? -1 : 1 : 0;
  if (!Kj(a)) {
   break a;
  }
  a = ov(w[v[d + 8 >> 2]], w[v[c + 8 >> 2]]);
  if (!Kj(a)) {
   break a;
  }
  a = ov(w[v[d + 12 >> 2]], w[v[c + 12 >> 2]]);
 }
 a = ud(a);
 eb = c + 32 | 0;
 return a;
}

function bq(a, b, c) {
 var d = 0, e = 0, f = 0, g = 0;
 d = eb - 16 | 0;
 eb = d;
 f = d + 12 | 0;
 bd(f, b);
 v[31601] = 0;
 b = Q(1252, v[d + 12 >> 2]) | 0;
 e = v[31601];
 v[31601] = 0;
 a: {
  if ((e | 0) == 1) {
   break a;
  }
  v[31601] = 0;
  e = Q(1260, b | 0) | 0;
  g = v[31601];
  v[31601] = 0;
  if ((g | 0) == 1) {
   break a;
  }
  v[c >> 2] = e;
  v[31601] = 0;
  N(1261, a | 0, b | 0);
  a = v[31601];
  v[31601] = 0;
  if ((a | 0) == 1) {
   break a;
  }
  Zb(f);
  eb = d + 16 | 0;
  return;
 }
 a = M() | 0;
 Zb(d + 12 | 0);
 P(a | 0);
 p();
}

function RB(a) {
 t[a | 0] = 0;
 t[a + 1 | 0] = 0;
 t[a + 2 | 0] = 0;
 t[a + 3 | 0] = 0;
 t[a + 4 | 0] = 0;
 t[a + 5 | 0] = 0;
 t[a + 6 | 0] = 0;
 t[a + 7 | 0] = 0;
 t[a + 23 | 0] = 0;
 t[a + 24 | 0] = 0;
 t[a + 25 | 0] = 0;
 t[a + 26 | 0] = 0;
 t[a + 16 | 0] = 0;
 t[a + 17 | 0] = 0;
 t[a + 18 | 0] = 0;
 t[a + 19 | 0] = 0;
 t[a + 20 | 0] = 0;
 t[a + 21 | 0] = 0;
 t[a + 22 | 0] = 0;
 t[a + 23 | 0] = 0;
 t[a + 8 | 0] = 0;
 t[a + 9 | 0] = 0;
 t[a + 10 | 0] = 0;
 t[a + 11 | 0] = 0;
 t[a + 12 | 0] = 0;
 t[a + 13 | 0] = 0;
 t[a + 14 | 0] = 0;
 t[a + 15 | 0] = 0;
}

function Gj(a) {
 var b = 0, c = 0, d = 0, e = 0, f = 0;
 b = v[a + 4 >> 2];
 if (lc(v[a >> 2], b)) {
  a = 0;
 } else {
  b = Si(b);
  e = Si(v[a >> 2]);
  c = eb - 16 | 0;
  eb = c;
  v[c + 12 >> 2] = b;
  while (1) {
   a: {
    if (!Yg(b, e)) {
     break a;
    }
    d = eb - 16 | 0;
    eb = d;
    v[d + 12 >> 2] = b;
    f = Uk(d + 12 | 0);
    eb = d + 16 | 0;
    if (x[v[f >> 2] >> 1] != 65535) {
     break a;
    }
    b = v[Uk(c + 12 | 0) >> 2];
    continue;
   }
   break;
  }
  eb = c + 16 | 0;
  a = qE(vb(v[a >> 2]), b);
 }
 return a & 65535;
}

function dq(a, b, c) {
 var d = 0, e = 0, f = 0, g = 0;
 d = eb - 16 | 0;
 eb = d;
 f = d + 12 | 0;
 bd(f, b);
 v[31601] = 0;
 b = Q(1234, v[d + 12 >> 2]) | 0;
 e = v[31601];
 v[31601] = 0;
 a: {
  if ((e | 0) == 1) {
   break a;
  }
  v[31601] = 0;
  e = Q(1246, b | 0) | 0;
  g = v[31601];
  v[31601] = 0;
  if ((g | 0) == 1) {
   break a;
  }
  t[c | 0] = e;
  v[31601] = 0;
  N(1247, a | 0, b | 0);
  a = v[31601];
  v[31601] = 0;
  if ((a | 0) == 1) {
   break a;
  }
  Zb(f);
  eb = d + 16 | 0;
  return;
 }
 a = M() | 0;
 Zb(d + 12 | 0);
 P(a | 0);
 p();
}

function Uga(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 a = Ii(a, b, c, d);
 v[a >> 2] = 44144;
 b = Mb(a + 4208 | 0);
 v[a + 4240 >> 2] = 0;
 v[a + 4244 >> 2] = 0;
 c = v[c + 24620 >> 2];
 v[a + 4260 >> 2] = 0;
 v[a + 4256 >> 2] = c;
 v[a + 4236 >> 2] = 0;
 v[a + 4228 >> 2] = 1048550822;
 v[a + 4232 >> 2] = 1048550822;
 v[a + 4220 >> 2] = 1056964608;
 v[a + 4224 >> 2] = 1056964608;
 v[31601] = 0;
 N(940, a + 44 | 0, 2);
 c = v[31601];
 v[31601] = 0;
 if ((c | 0) != 1) {
  return a | 0;
 }
 c = M() | 0;
 uc(b);
 Zf(a);
 P(c | 0);
 p();
}

function T6(a, b, c, d, e) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 var f = 0, g = 0;
 g = eb - 16 | 0;
 eb = g;
 v[e >> 2] = c;
 b = g + 12 | 0;
 a = qy(b, 0, v[a + 8 >> 2]);
 f = 2;
 a: {
  if (a + 1 >>> 0 < 2) {
   break a;
  }
  c = a - 1 | 0;
  f = 1;
  if (c >>> 0 > d - v[e >> 2] >>> 0) {
   break a;
  }
  while (1) {
   if (c) {
    a = w[b | 0];
    d = v[e >> 2];
    v[e >> 2] = d + 1;
    t[d | 0] = a;
    c = c - 1 | 0;
    b = b + 1 | 0;
    continue;
   }
   break;
  }
  f = 0;
 }
 a = f;
 eb = g + 16 | 0;
 return a | 0;
}

function Usa(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0;
 d = eb - 112 | 0;
 eb = d;
 c = eb - 16 | 0;
 eb = c;
 f = d + 14 | 0;
 A_(c + 8 | 0, f);
 e = v[c + 12 >> 2];
 pd(c, a, v[c + 8 >> 2], v[c + 12 >> 2]);
 g = v[c + 4 >> 2];
 if ((g | 0) == (e | 0)) {
  hd(a, v[c + 12 >> 2]);
 }
 eb = c + 16 | 0;
 e = (e | 0) == (g | 0);
 if (!e) {
  z_(f);
 }
 c = -1;
 a: {
  if (!e) {
   break a;
  }
  c = 0;
  if (!C_(f)) {
   break a;
  }
  c = ve(a, b, B_(w[d + 61 | 0] | w[d + 62 | 0] << 8), gb);
 }
 eb = d + 112 | 0;
 return c | 0;
}

function Ir(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0;
 d = vb(v[b >> 2]);
 g = vb(v[b + 4 >> 2]);
 e = eb - 16 | 0;
 eb = e;
 v[e + 12 >> 2] = d;
 while (1) {
  a: {
   if (!Hb(d, g)) {
    break a;
   }
   f = eb - 16 | 0;
   eb = f;
   pi(f + 8 | 0, v[d >> 2], v[d + 4 >> 2]);
   h = _b(v[f + 8 >> 2]);
   eb = f + 16 | 0;
   if ((c | 0) == (h | 0)) {
    break a;
   }
   d = v[bm(e + 12 | 0) >> 2];
   continue;
  }
  break;
 }
 eb = e + 16 | 0;
 if (lc(d, vb(v[b + 4 >> 2]))) {
  Xh(a);
  return;
 }
 mp(a, d);
}

function Xia(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0;
 e = eb - 16 | 0;
 eb = e;
 f = v[a + 8 >> 2];
 d = e + 4 | 0;
 v[d + 8 >> 2] = a + 8;
 v[d >> 2] = f;
 v[d + 4 >> 2] = B(b, 52) + f;
 b = v[d >> 2];
 a: {
  while (1) {
   if (v[d + 4 >> 2] == (b | 0)) {
    break a;
   }
   v[31601] = 0;
   N(919, b | 0, c | 0);
   a = v[31601];
   v[31601] = 0;
   if ((a | 0) != 1) {
    b = v[d >> 2] + 52 | 0;
    v[d >> 2] = b;
    continue;
   }
   break;
  }
  a = M() | 0;
  ie(d);
  P(a | 0);
  p();
 }
 ie(d);
 eb = e + 16 | 0;
}

function P1(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0;
 e = eb - 32 | 0;
 eb = e;
 f = v[b + 16 >> 2];
 a: {
  if (f >>> 0 <= c >>> 0) {
   ac(a, v[d >> 2], 0);
   break a;
  }
  g = v[b + 12 >> 2];
  b = v[b + 4 >> 2];
  v[e + 20 >> 2] = v[d + 4 >> 2];
  v[e + 16 >> 2] = f - c;
  ac(e + 24 | 0, v[d >> 2], v[Gb(e + 20 | 0, e + 16 | 0) >> 2]);
  d = v[v[b >> 2] + 28 >> 2];
  f = v[e + 28 >> 2];
  v[e + 8 >> 2] = v[e + 24 >> 2];
  v[e + 12 >> 2] = f;
  hb[d | 0](a, b, c + g | 0, e + 8 | 0);
 }
 eb = e + 32 | 0;
}

function mla(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0;
 e = eb - 32 | 0;
 eb = e;
 v[e + 28 >> 2] = d;
 c = Hf(a, c);
 d = e + 8 | 0;
 $d(d, v[a + 36 >> 2]);
 f = a;
 a: {
  if (!c) {
   Pc(d, a + 32 | 0, 5);
   d = 0;
   if (Fb(v[v[e + 8 >> 2] >> 2], v[e + 12 >> 2])) {
    break a;
   }
  }
  d = v[a + 36 >> 2];
  a = 0;
  ZE(b, v[e + 28 >> 2]);
  while (1) {
   if (y[e + 28 >> 2] > a >>> 0) {
    IU(d, $b(v[b >> 2], a));
    a = a + 1 | 0;
    continue;
   }
   break;
  }
  d = c;
 }
 ef(f, d);
 eb = e + 32 | 0;
}

function lH(a, b, c, d) {
 var e = 0, f = 0;
 a: {
  e = eb - 32 | 0;
  eb = e;
  f = e + 8 | 0;
  Bc(f, c);
  v[31601] = 0;
  c = e + 20 | 0;
  R(d | 0, c | 0, b | 0, f | 0);
  b = v[31601];
  v[31601] = 0;
  b: {
   c: {
    if ((b | 0) != 1) {
     v[31601] = 0;
     N(12, a | 0, c | 0);
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) == 1) {
      break c;
     }
     Tb(c);
     sb(f);
     eb = e + 32 | 0;
     break a;
    }
    a = M() | 0;
    break b;
   }
   a = M() | 0;
   Tb(e + 20 | 0);
  }
  sb(e + 8 | 0);
  P(a | 0);
  p();
 }
}

function g1(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0;
 d = eb - 512 | 0;
 eb = d;
 c = eb - 16 | 0;
 eb = c;
 f = d + 15 | 0;
 nF(c + 8 | 0, f);
 e = v[c + 12 >> 2];
 pd(c, a, v[c + 8 >> 2], v[c + 12 >> 2]);
 g = v[c + 4 >> 2];
 if ((g | 0) == (e | 0)) {
  hd(a, v[c + 12 >> 2]);
 }
 eb = c + 16 | 0;
 e = (e | 0) == (g | 0);
 if (!e) {
  mF(f);
 }
 c = -1;
 a: {
  if (!e) {
   break a;
  }
  c = 0;
  if (!qF(f)) {
   break a;
  }
  c = ve(a, b, pF(w[d + 125 | 0], w[d + 126 | 0]), gb);
 }
 eb = d + 512 | 0;
 return c | 0;
}

function RJ(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0;
 d = eb - 16 | 0;
 eb = d;
 i = v[b >> 2];
 h = v[a >> 2];
 e = v[fc(a) >> 2] == 1273;
 f = v[c >> 2];
 g = f - h | 0;
 f = g >>> 0 >= 2147483647 ? -1 : (h | 0) == (f | 0) ? 4 : g << 1;
 g = Vv(e ? 0 : h, f);
 if (g) {
  if (!e) {
   me(a);
  }
  v[d + 4 >> 2] = 1238;
  e = Ce(d + 8 | 0, g, d + 4 | 0);
  a = OJ(a, e);
  Kc(e);
  v[b >> 2] = v[a >> 2] + (i - h | 0);
  v[c >> 2] = v[a >> 2] + (f & -4);
  eb = d + 16 | 0;
  return;
 }
 Ly();
 p();
}

function Afa(a) {
 a = a | 0;
 var b = 0;
 v[31601] = 0;
 V(995, a | 0);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  b = v[a + 24 >> 2];
  if (b) {
   Bb(tq(b));
  }
  v[a + 24 >> 2] = 0;
  b = v[a + 20 >> 2];
  if (b) {
   Bb(b);
   v[a + 20 >> 2] = 0;
  }
  Bb(a);
  return;
 }
 X(S(0) | 0) | 0;
 v[31601] = 0;
 U(982, 5078, a | 0, 0, 0);
 a = v[31601];
 v[31601] = 0;
 if ((a | 0) != 1) {
  Y();
  return;
 }
 a = M() | 0;
 v[31601] = 0;
 W(26);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  P(a | 0);
  p();
 }
 S(0) | 0;
 Rb();
 p();
}

function $c(a, b, c) {
 var d = 0, e = 0, f = 0, g = 0, h = 0;
 d = eb - 16 | 0;
 eb = d;
 nm(b);
 e = a + 8 | 0;
 f = xf(d + 12 | 0, b);
 a: {
  b = v[a + 8 >> 2];
  if (nc(b, v[a + 12 >> 2]) >>> 0 <= c >>> 0) {
   v[31601] = 0;
   N(1327, e | 0, c + 1 | 0);
   a = v[31601];
   v[31601] = 0;
   if ((a | 0) == 1) {
    break a;
   }
   b = v[e >> 2];
  }
  a = xb(b, c);
  b = v[a >> 2];
  if (b) {
   sm(b);
   a = xb(v[e >> 2], c);
  }
  g = a, h = me(f), v[g >> 2] = h;
  jJ(f);
  eb = d + 16 | 0;
  return;
 }
 a = M() | 0;
 jJ(f);
 P(a | 0);
 p();
}

function Zja(a) {
 a = a | 0;
 var b = 0, c = 0, d = 0, e = 0, f = 0;
 c = eb - 16 | 0;
 eb = c;
 if (!Dd(v[a + 1298300 >> 2])) {
  b = v[a + 24620 >> 2];
  d = eb - 16 | 0;
  eb = d;
  e = Dc(536);
  v[31601] = 0;
  f = O(873, e | 0, b | 0) | 0;
  b = v[31601];
  v[31601] = 0;
  a: {
   if ((b | 0) != 1) {
    b = xf(d + 12 | 0, f);
    eb = d + 16 | 0;
    b = v[b >> 2];
    break a;
   }
   a = M() | 0;
   Bb(e);
   P(a | 0);
   p();
  }
  v[c + 12 >> 2] = b;
  b = a + 1298300 | 0;
  a = c + 12 | 0;
  gS(b, me(a));
  XA(a);
 }
 eb = c + 16 | 0;
}

function J$(a) {
 var b = 0, c = 0, d = 0, e = 0;
 if (!w[a + 12 | 0]) {
  c = eb - 16 | 0;
  eb = c;
  b = ub(c + 12 | 0, v[v[a + 8 >> 2] >> 2]);
  e = v[ub(c + 8 | 0, v[v[a + 4 >> 2] >> 2]) >> 2];
  d = eb - 16 | 0;
  eb = d;
  a = v[b >> 2];
  v[d + 12 >> 2] = a;
  while (1) {
   if (vi(a, e)) {
    b = eb - 16 | 0;
    eb = b;
    v[b + 12 >> 2] = a;
    v[b + 12 >> 2] = v[b + 12 >> 2] + 28;
    eb = b + 16 | 0;
    Gd(oE(v[b + 12 >> 2]));
    a = v[bm(d + 12 | 0) >> 2];
    continue;
   }
   break;
  }
  eb = d + 16 | 0;
  eb = c + 16 | 0;
 }
}

function xfa(a) {
 a = a | 0;
 var b = 0;
 v[31601] = 0;
 V(995, a | 0);
 b = v[31601];
 v[31601] = 0;
 a: {
  b: {
   if ((b | 0) != 1) {
    a = v[a + 20 >> 2];
    if (!a) {
     break b;
    }
    return Bg(a) | 0;
   }
   X(S(0) | 0) | 0;
   v[31601] = 0;
   U(982, 12243, a | 0, 0, 0);
   a = v[31601];
   v[31601] = 0;
   if ((a | 0) == 1) {
    break a;
   }
   Y();
   return 0;
  }
  return Bg(22256) | 0;
 }
 a = M() | 0;
 v[31601] = 0;
 W(26);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  P(a | 0);
  p();
 }
 S(0) | 0;
 Rb();
 p();
}

function sqa(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0;
 c = eb - 16 | 0;
 eb = c;
 v[a >> 2] = 0;
 v[a + 4 >> 2] = 0;
 sc(a + 8 | 0);
 Qd(c + 8 | 0, v[ub(c + 4 | 0, a) >> 2]);
 a: {
  if (!b) {
   break a;
  }
  v[31601] = 0;
  N(589, a | 0, b | 0);
  d = v[31601];
  v[31601] = 0;
  if ((d | 0) != 1) {
   v[31601] = 0;
   N(590, a | 0, b | 0);
   b = v[31601];
   v[31601] = 0;
   if ((b | 0) != 1) {
    break a;
   }
  }
  a = M() | 0;
  fY(c + 8 | 0);
  P(a | 0);
  p();
 }
 b = c + 8 | 0;
 Pd(b);
 fY(b);
 eb = c + 16 | 0;
 return a | 0;
}

function xta(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0;
 b = eb - 32 | 0;
 eb = b;
 d = b + 20 | 0;
 c = -1;
 a: {
  if (!dE(a, d)) {
   break a;
  }
  c = 0;
  if (!g$(d)) {
   break a;
  }
  if ((w[b + 20 | 0] | w[b + 21 | 0] << 8 | (w[b + 22 | 0] << 16 | w[b + 23 | 0] << 24)) == 1179472708) {
   c = -1;
   if (!hd(a, 4)) {
    break a;
   }
  }
  c = -1;
  if (!gk(a, b + 12 | 0)) {
   break a;
  }
  c = (w[b + 12 | 0] | w[b + 13 | 0] << 8 | (w[b + 14 | 0] << 16 | w[b + 15 | 0] << 24)) == 1196314451;
 }
 eb = b + 32 | 0;
 return c | 0;
}

function _0(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0;
 c = eb - 16 | 0;
 eb = c;
 v[a >> 2] = 0;
 v[a + 4 >> 2] = 0;
 sc(a + 8 | 0);
 Qd(c + 8 | 0, v[ub(c + 4 | 0, a) >> 2]);
 a: {
  if (!b) {
   break a;
  }
  v[31601] = 0;
  N(226, a | 0, b | 0);
  d = v[31601];
  v[31601] = 0;
  if ((d | 0) != 1) {
   v[31601] = 0;
   N(227, a | 0, b | 0);
   b = v[31601];
   v[31601] = 0;
   if ((b | 0) != 1) {
    break a;
   }
  }
  a = M() | 0;
  VE(c + 8 | 0);
  P(a | 0);
  p();
 }
 b = c + 8 | 0;
 Pd(b);
 VE(b);
 eb = c + 16 | 0;
 return a | 0;
}

function $8(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0;
 e = v[a + 44 >> 2];
 c = v[a + 24 >> 2];
 if (e >>> 0 < c >>> 0) {
  v[a + 44 >> 2] = c;
  e = c;
 }
 g = v[a + 8 >> 2];
 f = v[a + 12 >> 2];
 d = -1;
 a: {
  if (g >>> 0 >= f >>> 0) {
   break a;
  }
  if (lc(b, -1)) {
   Un(a, g, f - 1 | 0, e);
   return Ry(b) | 0;
  }
  c = b << 24 >> 24;
  if (!(v[a + 48 >> 2] & 16)) {
   d = -1;
   if (!lc(c, t[f - 1 | 0])) {
    break a;
   }
  }
  Un(a, g, f - 1 | 0, e);
  t[v[a + 12 >> 2]] = c;
  d = b;
 }
 return d | 0;
}

function rH(a, b, c) {
 var d = 0, e = 0;
 a: {
  d = eb - 32 | 0;
  eb = d;
  e = d + 8 | 0;
  Cc(e, b);
  v[31601] = 0;
  b = d + 20 | 0;
  R(123, b | 0, c | 0, e | 0);
  c = v[31601];
  v[31601] = 0;
  b: {
   c: {
    if ((c | 0) != 1) {
     v[31601] = 0;
     N(12, a | 0, b | 0);
     a = v[31601];
     v[31601] = 0;
     if ((a | 0) == 1) {
      break c;
     }
     Tb(b);
     sb(e);
     eb = d + 32 | 0;
     break a;
    }
    a = M() | 0;
    break b;
   }
   a = M() | 0;
   Tb(d + 20 | 0);
  }
  sb(d + 8 | 0);
  P(a | 0);
  p();
 }
}

function VW(a) {
 var b = 0;
 a: {
  if ((w[a + 44 | 0] | w[a + 45 | 0] << 8 | (w[a + 46 | 0] << 16 | w[a + 47 | 0] << 24)) != 1179472976 | w[a + 28 | 0] != 26 | (w[a + 40 | 0] | w[a + 41 | 0] << 8 | w[a + 30 | 0] > 2)) {
   break a;
  }
  if (((w[a + 38 | 0] | w[a + 39 | 0] << 8) - 33 & 65535) >>> 0 < 65504 | ((w[a + 32 | 0] | w[a + 33 | 0] << 8) - 257 & 65535) >>> 0 < 65280 | ((w[a + 34 | 0] | w[a + 35 | 0] << 8) - 256 & 65535) >>> 0 < 65281) {
   break a;
  }
  b = ((w[a + 36 | 0] | w[a + 37 | 0] << 8) - 1 & 65535) >>> 0 < 128;
 }
 return b;
}

function fua(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0;
 c = eb - 16 | 0;
 eb = c;
 ac(c + 8 | 0, b, 10);
 d = v[c + 12 >> 2];
 ic(c, v[a >> 2], v[a + 8 >> 2], v[c + 8 >> 2], v[c + 12 >> 2]);
 e = v[c + 4 >> 2];
 if ((e | 0) == (d | 0)) {
  Ub(a, v[c + 12 >> 2]);
 }
 eb = c + 16 | 0;
 a = (d | 0) == (e | 0);
 if (!a) {
  t[b | 0] = 0;
  t[b + 1 | 0] = 0;
  t[b + 2 | 0] = 0;
  t[b + 3 | 0] = 0;
  t[b + 4 | 0] = 0;
  t[b + 5 | 0] = 0;
  t[b + 6 | 0] = 0;
  t[b + 7 | 0] = 0;
  t[b + 8 | 0] = 0;
  t[b + 9 | 0] = 0;
 }
 return a | 0;
}

function Df(a) {
 var b = 0, c = 0, d = 0;
 a: {
  b: {
   b = a;
   if (!(b & 3)) {
    break b;
   }
   if (!w[b | 0]) {
    return 0;
   }
   while (1) {
    b = b + 1 | 0;
    if (!(b & 3)) {
     break b;
    }
    if (w[b | 0]) {
     continue;
    }
    break;
   }
   break a;
  }
  while (1) {
   c = b;
   b = b + 4 | 0;
   d = v[c >> 2];
   if (!((d ^ -1) & d - 16843009 & -2139062144)) {
    continue;
   }
   break;
  }
  while (1) {
   b = c;
   c = b + 1 | 0;
   if (w[b | 0]) {
    continue;
   }
   break;
  }
 }
 return b - a | 0;
}

function pra(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0;
 v[a >> 2] = 0;
 v[a + 4 >> 2] = 0;
 sc(a + 8 | 0);
 c = b + c | 0;
 e = c;
 d = Oj(b, c);
 c = eb - 16 | 0;
 eb = c;
 Qd(c + 8 | 0, v[ub(c + 4 | 0, a) >> 2]);
 a: {
  b: {
   if (d) {
    v[31601] = 0;
    N(345, a | 0, d | 0);
    f = v[31601];
    v[31601] = 0;
    if ((f | 0) == 1) {
     break b;
    }
    xn(a, b, e, d);
   }
   a = c + 8 | 0;
   Pd(a);
   Wi(a);
   eb = c + 16 | 0;
   break a;
  }
  a = M() | 0;
  Wi(c + 8 | 0);
  P(a | 0);
  p();
 }
}

function e2(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0;
 d = eb - 16 | 0;
 eb = d;
 v[d >> 2] = b;
 v[d + 4 >> 2] = c;
 v[d + 8 >> 2] = b;
 v[d + 12 >> 2] = c;
 f = eb - 16 | 0;
 eb = f;
 g = eb - 16 | 0;
 eb = g;
 e = g + 4 | 0;
 v[e + 4 >> 2] = 1;
 h = e, i = Dc(24), v[h + 8 >> 2] = i;
 b = qm(v[e + 8 >> 2]);
 v[b >> 2] = 78280;
 AG(mc(b), v[d >> 2], v[d + 4 >> 2]);
 c = f + 8 | 0;
 b = Qn(e);
 Pn(c, mc(b), b);
 rm(e);
 eb = g + 16 | 0;
 Ef(a, c);
 le(c);
 eb = f + 16 | 0;
 eb = d + 16 | 0;
}

function Xra(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0;
 d = eb - 16 | 0;
 eb = d;
 v[d + 12 >> 2] = c;
 a: {
  e = Lb(v[b >> 2], v[b + 8 >> 2], c << 2);
  if (!e) {
   break a;
  }
  wc(d + 12 | 0, 65535);
  ug(a, x[d + 12 >> 1]);
  c = vb(v[a >> 2]);
  v[d + 4 >> 2] = c;
  a = vb(v[a + 4 >> 2]);
  while (1) {
   if (!Hb(c, a)) {
    break a;
   }
   f = d + 8 | 0;
   if (!Mn(b, f)) {
    Bn(f);
   }
   u[c >> 1] = v[d + 8 >> 2];
   c = v[fe(d + 4 | 0) >> 2];
   continue;
  }
 }
 eb = d + 16 | 0;
 return e | 0;
}

function Fja(a) {
 a = a | 0;
 var b = 0, c = 0, d = 0;
 b = eb - 32 | 0;
 eb = b;
 t[b + 23 | 0] = 0;
 t[b + 24 | 0] = 0;
 t[b + 25 | 0] = 0;
 t[b + 26 | 0] = 0;
 t[b + 27 | 0] = 0;
 t[b + 28 | 0] = 0;
 t[b + 29 | 0] = 0;
 t[b + 30 | 0] = 0;
 v[b + 16 >> 2] = 0;
 v[b + 20 >> 2] = 0;
 d = b + 16 | 0;
 c = Yb(b, d, 15);
 ic(b + 8 | 0, v[a >> 2], v[a + 8 >> 2], v[c >> 2], v[c + 4 >> 2]);
 c = 0;
 a: {
  if (v[b + 12 >> 2] != 15) {
   break a;
  }
  if (id(d, 8525, 15)) {
   break a;
  }
  Ub(a, 15);
  c = 1;
 }
 eb = b + 32 | 0;
 return c | 0;
}

function mR(a) {
 var b = 0, c = 0;
 a: {
  if ((w[a | 0] | w[a + 1 | 0] << 8 | (w[a + 2 | 0] << 16 | w[a + 3 | 0] << 24)) != 1163089229) {
   break a;
  }
  b = w[a + 4 | 0] | w[a + 5 | 0] << 8 | (w[a + 6 | 0] << 16 | w[a + 7 | 0] << 24);
  if ((b | 0) != -1095062050 & (b | 0) != -1346458146) {
   break a;
  }
  b = w[a + 16 | 0] | w[a + 17 | 0] << 8 | (w[a + 18 | 0] << 16 | w[a + 19 | 0] << 24);
  if (!b) {
   break a;
  }
  c = (b + 24 | 0) == (w[a + 8 | 0] | w[a + 9 | 0] << 8 | (w[a + 10 | 0] << 16 | w[a + 11 | 0] << 24));
 }
 return c;
}

function Fka(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0;
 d = eb - 32 | 0;
 eb = d;
 b = ig(d + 8 | 0, b);
 v[31601] = 0;
 e = d + 20 | 0;
 R(836, e | 0, b | 0, c | 0);
 f = v[31601];
 v[31601] = 0;
 a: {
  b: {
   if ((f | 0) != 1) {
    v[31601] = 0;
    R(72, a | 0, e | 0, c | 0);
    a = v[31601];
    v[31601] = 0;
    if ((a | 0) == 1) {
     break b;
    }
    sb(e);
    sb(b);
    eb = d + 32 | 0;
    return;
   }
   c = M() | 0;
   break a;
  }
  c = M() | 0;
  sb(d + 20 | 0);
 }
 sb(b);
 P(c | 0);
 p();
}

function k_(a) {
 var b = 0, c = 0;
 a: {
  if (id(a, 13907, 3) | (w[a + 3 | 0] - 1 & 255) >>> 0 > 3) {
   break a;
  }
  if (Ab(w[a + 196 | 0] | w[a + 197 | 0] << 8) >>> 0 > 255) {
   break a;
  }
  if ((Ab(w[a + 198 | 0] | w[a + 199 | 0] << 8) - 1 & 65535) >>> 0 > 255) {
   break a;
  }
  if ((Ab(w[a + 200 | 0] | w[a + 201 | 0] << 8) - 1 & 65535) >>> 0 > 31) {
   break a;
  }
  b = Ab(w[a + 202 | 0] | w[a + 203 | 0] << 8);
  if (b >>> 0 > 256) {
   break a;
  }
  c = Ab(w[a + 204 | 0] | w[a + 205 | 0] << 8) >>> 0 < b >>> 0;
 }
 return c;
}

function p2(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0;
 d = eb - 32 | 0;
 eb = d;
 b = tm(d + 8 | 0, b);
 v[31601] = 0;
 e = d + 20 | 0;
 R(148, e | 0, b | 0, c | 0);
 f = v[31601];
 v[31601] = 0;
 a: {
  b: {
   if ((f | 0) != 1) {
    v[31601] = 0;
    R(4, a | 0, e | 0, c | 0);
    a = v[31601];
    v[31601] = 0;
    if ((a | 0) == 1) {
     break b;
    }
    sb(e);
    sb(b);
    eb = d + 32 | 0;
    return;
   }
   c = M() | 0;
   break a;
  }
  c = M() | 0;
  sb(d + 20 | 0);
 }
 sb(b);
 P(c | 0);
 p();
}

function lsa(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0;
 if (y[a + 4 >> 2] < y[zb(a) >> 2]) {
  d = eb - 16 | 0;
  eb = d;
  a = wh(d + 4 | 0, a, 1);
  RZ(v[a + 4 >> 2], x[b >> 1], w[c | 0]);
  v[a + 4 >> 2] = v[a + 4 >> 2] + 4;
  hc(a);
  eb = d + 16 | 0;
  return;
 }
 e = eb - 32 | 0;
 eb = e;
 d = zb(a);
 d = Yf(e + 12 | 0, Kf(a, nc(v[a >> 2], v[a + 4 >> 2]) + 1 | 0), nc(v[a >> 2], v[a + 4 >> 2]), d);
 RZ(v[d + 8 >> 2], x[b >> 1], w[c | 0]);
 v[d + 8 >> 2] = v[d + 8 >> 2] + 4;
 Zr(a, d);
 Xf(d);
 eb = e + 32 | 0;
}

function lla(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0;
 d = eb - 16 | 0;
 eb = d;
 c = Hf(a, c);
 $d(d, v[a + 36 >> 2]);
 a: {
  b: {
   if (!c) {
    Pc(d, a + 32 | 0, 5);
    e = -1;
    if (!Fb(v[v[d >> 2] >> 2], v[d + 4 >> 2])) {
     break b;
    }
    break a;
   }
   e = v[c + 16 >> 2];
  }
  f = v[a + 36 >> 2];
  c: {
   d: {
    switch (e + 1 | 0) {
    case 0:
    case 2:
     Di(f, b);
     break c;

    default:
     break d;
    }
   }
   lZ(f, b, e);
  }
  f = c;
 }
 ef(a, f);
 eb = d + 16 | 0;
}

function laa(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0, i = 0;
 e = eb - 16 | 0;
 eb = e;
 g = v[d + 4 >> 2];
 qz(b, c, g);
 f = v[b + 16 >> 2];
 a: {
  if (f >>> 0 <= c >>> 0) {
   ac(a, v[d >> 2], 0);
   break a;
  }
  v[e + 12 >> 2] = f - c;
  v[e + 8 >> 2] = g;
  d = v[d >> 2];
  f = v[Gb(e + 12 | 0, e + 8 | 0) >> 2];
  wr(e, d, g, 0, f);
  h = v[e >> 2];
  i = v[e + 4 >> 2];
  dw(Pe(vb(v[b + 4 >> 2]), c), Pe(Pe(vb(v[b + 4 >> 2]), c), i), h);
  wr(a, d, g, 0, f);
 }
 eb = e + 16 | 0;
}

function Mra(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0;
 e = v[a >> 2];
 d = Sc(e, v[a + 4 >> 2]);
 if (d >>> 0 < b >>> 0) {
  e = eb - 32 | 0;
  eb = e;
  b = b - d | 0;
  d = v[zb(a) >> 2];
  f = v[a + 4 >> 2];
  a: {
   if (b >>> 0 <= d - f >>> 0) {
    Ap(a, b, c);
    break a;
   }
   d = zb(a);
   d = on(e + 12 | 0, Tl(a, Sc(v[a >> 2], f) + b | 0), Sc(v[a >> 2], v[a + 4 >> 2]), d);
   cZ(d, b, c);
   cr(a, d);
   nn(d);
  }
  eb = e + 32 | 0;
  return;
 }
 if (b >>> 0 < d >>> 0) {
  Id(a, b + e | 0);
 }
}

function ME(a) {
 var b = 0, c = 0, d = 0, e = 0;
 c = w[a + 9 | 0] | w[a + 10 | 0] << 8;
 d = Aua(w[a + 3 | 0], 0, 18, 0);
 c = c + d | 0;
 b = gb;
 e = d >>> 0 > c >>> 0 ? b + 1 | 0 : b;
 d = w[a + 6 | 0] | w[a + 7 | 0] << 8;
 b = d >>> 31 | 0;
 d = d << 1;
 c = d + c | 0;
 b = b + e | 0;
 d = d >>> 0 > c >>> 0 ? b + 1 | 0 : b;
 a = w[a + 4 | 0] | w[a + 5 | 0] << 8;
 b = a >>> 30 | 0;
 e = c;
 c = a << 2;
 e = e + c | 0;
 a = b + d | 0;
 a = c >>> 0 > e >>> 0 ? a + 1 | 0 : a;
 b = e + 3 | 0;
 gb = b >>> 0 < 3 ? a + 1 | 0 : a;
 return b;
}

function VP(a) {
 var b = C(0), c = 0, d = C(0);
 b = z[a + 4224 >> 2];
 z[a + 4260 >> 2] = K(C(C(1) - C(b * b)));
 t[a + 4264 | 0] = z[a + 4236 >> 2] > C(.5);
 d = C(y[a + 4256 >> 2]);
 b = C(C(C(C(z[a + 4228 >> 2] * C(1999)) + C(1)) / C(1e3)) * d);
 a: {
  if (b < C(4294967296) & b >= C(0)) {
   c = ~~b >>> 0;
   break a;
  }
  c = 0;
 }
 v[a + 4248 >> 2] = c;
 b = C(C(C(C(z[a + 4232 >> 2] * C(1999)) + C(1)) / C(1e3)) * d);
 b: {
  if (b < C(4294967296) & b >= C(0)) {
   c = ~~b >>> 0;
   break b;
  }
  c = 0;
 }
 v[a + 4252 >> 2] = c;
}

function Oq(a) {
 var b = 0, c = 0, d = 0, e = 0, f = 0;
 d = eb - 16 | 0;
 eb = d;
 b = vb(v[a >> 2]);
 f = vb(v[a + 4 >> 2]);
 e = eb - 16 | 0;
 eb = e;
 v[e + 12 >> 2] = b;
 while (1) {
  if (Hb(b, f)) {
   c = c + A[b >> 3];
   b = v[PB(e + 12 | 0) >> 2];
   continue;
  }
  break;
 }
 eb = e + 16 | 0;
 b = vb(v[a >> 2]);
 v[d + 12 >> 2] = b;
 c = -c;
 a = vb(v[a + 4 >> 2]);
 while (1) {
  if (Hb(b, a)) {
   c = c + A[b >> 3];
   A[b >> 3] = c;
   b = v[PB(d + 12 | 0) >> 2];
   continue;
  } else {
   eb = d + 16 | 0;
  }
  break;
 }
}

function n7(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0;
 d = eb - 16 | 0;
 eb = d;
 i = v[b >> 2];
 h = v[a >> 2];
 e = v[fc(a) >> 2] == 1273;
 f = v[c >> 2] - h | 0;
 g = f << 1;
 f = f >>> 0 >= 2147483647 ? -1 : g >>> 0 <= 1 ? 1 : g;
 g = Vv(e ? 0 : h, f);
 if (g) {
  if (!e) {
   me(a);
  }
  v[d + 4 >> 2] = 1238;
  e = Ce(d + 8 | 0, g, d + 4 | 0);
  a = OJ(a, e);
  Kc(e);
  v[b >> 2] = v[a >> 2] + (i - h | 0);
  v[c >> 2] = f + v[a >> 2];
  eb = d + 16 | 0;
  return;
 }
 Ly();
 p();
}

function D3(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0;
 d = eb - 16 | 0;
 eb = d;
 a: {
  e = v[b >> 2];
  if (Dd(e)) {
   f = d + 4 | 0;
   if (!zd(v[c + 4 >> 2], w[c + 11 | 0])) {
    rP(c, 18371);
    e = v[b >> 2];
   }
   b = v[b + 4 >> 2];
   hb[v[v[b >> 2] + 24 >> 2]](f, b, e);
   v[31601] = 0;
   O(837, c | 0, f | 0) | 0;
   b = v[31601];
   v[31601] = 0;
   if ((b | 0) == 1) {
    break a;
   }
   sb(f);
  }
  Uc(a, c);
  eb = d + 16 | 0;
  return;
 }
 a = M() | 0;
 sb(d + 4 | 0);
 P(a | 0);
 p();
}

function st(a, b, c, d) {
 var e = 0;
 a: {
  if (!(d & 2048)) {
   break a;
  }
  e = d & 74;
  if (!c | ((e | 0) == 8 | (e | 0) == 64)) {
   break a;
  }
  t[a | 0] = 43;
  a = a + 1 | 0;
 }
 if (d & 512) {
  t[a | 0] = 35;
  a = a + 1 | 0;
 }
 while (1) {
  e = w[b | 0];
  if (e) {
   t[a | 0] = e;
   a = a + 1 | 0;
   b = b + 1 | 0;
   continue;
  }
  break;
 }
 e = d & 74;
 b = 111;
 b: {
  if ((e | 0) == 64) {
   break b;
  }
  b = d & 16384 ? 88 : 120;
  if ((e | 0) == 8) {
   break b;
  }
  b = c ? 100 : 117;
 }
 t[a | 0] = b;
}

function N2(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0;
 e = eb - 16 | 0;
 eb = e;
 bd(a, v[b + 28 >> 2]);
 v[31601] = 0;
 d = e + 12 | 0;
 R(108, d | 0, b | 0, c | 0);
 f = v[31601];
 v[31601] = 0;
 a: {
  if ((f | 0) == 1) {
   break a;
  }
  Zb(d);
  b = v[b + 24 >> 2];
  if (b) {
   v[31601] = 0;
   d = e + 8 | 0;
   R(109, d | 0, b | 0, c | 0);
   b = v[31601];
   v[31601] = 0;
   if ((b | 0) == 1) {
    break a;
   }
   Zb(d);
  }
  eb = e + 16 | 0;
  return;
 }
 b = M() | 0;
 Zb(a);
 P(b | 0);
 p();
}

function Ay(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0;
 d = a;
 f = eb - 16 | 0;
 eb = f;
 a: {
  if (b >>> 0 < 1073741808) {
   b: {
    if (fr(b)) {
     Me(d, b);
     break b;
    }
    Mj(f + 8 | 0, rn(b) + 1 | 0);
    e = v[f + 8 >> 2];
    xd(d, e);
    of(d, v[f + 12 >> 2]);
    Ad(d, b);
    d = e;
   }
   e = eb - 16 | 0;
   eb = e;
   v[e + 12 >> 2] = c;
   JF(d, b, e + 12 | 0);
   eb = e + 16 | 0;
   xd((b << 2) + d | 0, 0);
   eb = f + 16 | 0;
   break a;
  }
  pf();
  p();
 }
 return a | 0;
}

function j1(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0;
 e = eb - 784 | 0;
 eb = e;
 c = eb - 16 | 0;
 eb = c;
 f = e + 12 | 0;
 xF(c + 8 | 0, f);
 d = v[c + 12 >> 2];
 pd(c, a, v[c + 8 >> 2], v[c + 12 >> 2]);
 g = v[c + 4 >> 2];
 if ((g | 0) == (d | 0)) {
  hd(a, v[c + 12 >> 2]);
 }
 eb = c + 16 | 0;
 d = (d | 0) == (g | 0);
 if (!d) {
  wF(f);
 }
 c = -1;
 a: {
  if (!d) {
   break a;
  }
  c = 0;
  if (!zF(f)) {
   break a;
  }
  c = ve(a, b, yF(w[e + 527 | 0]), 0);
 }
 eb = e + 784 | 0;
 return c | 0;
}

function eia(a, b) {
 a = a | 0;
 b = b | 0;
 var c = C(0);
 a: {
  switch (b | 0) {
  case 0:
   return C(z[a + 4220 >> 2]);

  case 1:
   return C(z[a + 4224 >> 2]);

  case 2:
   return C(z[a + 4228 >> 2]);

  case 3:
   return C(w[a + 4240 | 0] ? C(1) : C(0));

  case 4:
   return C(C(C(v[a + 4232 >> 2]) * C(.03125)));

  case 5:
   return C(w[a + 4241 | 0] ? C(1) : C(0));

  case 6:
   return C(w[a + 4242 | 0] ? C(1) : C(0));

  case 7:
   c = w[a + 4244 | 0] ? C(1) : C(0);
   break;

  default:
   break a;
  }
 }
 return C(c);
}

function Sqa(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0;
 d = eb - 16 | 0;
 eb = d;
 e = v[a + 8 >> 2];
 c = d + 4 | 0;
 v[c + 8 >> 2] = a + 8;
 v[c >> 2] = e;
 v[c + 4 >> 2] = B(b, 20) + e;
 b = v[c >> 2];
 a: {
  while (1) {
   if (v[c + 4 >> 2] == (b | 0)) {
    break a;
   }
   v[31601] = 0;
   V(228, b | 0);
   a = v[31601];
   v[31601] = 0;
   if ((a | 0) != 1) {
    b = v[c >> 2] + 20 | 0;
    v[c >> 2] = b;
    continue;
   }
   break;
  }
  a = M() | 0;
  ie(c);
  P(a | 0);
  p();
 }
 ie(c);
 eb = d + 16 | 0;
}

function e1(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0;
 e = eb - 48 | 0;
 eb = e;
 c = eb - 16 | 0;
 eb = c;
 f = e + 10 | 0;
 hF(c + 8 | 0, f);
 d = v[c + 12 >> 2];
 pd(c, a, v[c + 8 >> 2], v[c + 12 >> 2]);
 g = v[c + 4 >> 2];
 if ((g | 0) == (d | 0)) {
  hd(a, v[c + 12 >> 2]);
 }
 eb = c + 16 | 0;
 d = (d | 0) == (g | 0);
 if (!d) {
  gF(f);
 }
 c = -1;
 a: {
  if (!d) {
   break a;
  }
  c = 0;
  if (!jF(f)) {
   break a;
  }
  c = ve(a, b, iF(w[e + 45 | 0]), gb);
 }
 eb = e + 48 | 0;
 return c | 0;
}

function Vna(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0;
 a: {
  b: {
   c = w[a + 11 | 0];
   c: {
    d: {
     if (ud(c)) {
      c = v[a + 4 >> 2];
      d = Yi(v[a + 8 >> 2]) - 1 | 0;
      if ((c | 0) == (d | 0)) {
       break d;
      }
      break c;
     }
     d = 1;
     c = Gh(c);
     if ((c | 0) != 1) {
      break b;
     }
    }
    rC(a, d, 1, d, d, 0);
    c = d;
   }
   d = v[a >> 2];
   Ad(a, c + 1 | 0);
   break a;
  }
  Me(a, c + 1 | 0);
  d = a;
 }
 a = (c << 2) + d | 0;
 xd(a, b);
 xd(a + 4 | 0, 0);
}

function Qoa(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0;
 d = eb - 608 | 0;
 eb = d;
 c = eb - 16 | 0;
 eb = c;
 TW(c + 8 | 0, d);
 e = v[c + 12 >> 2];
 pd(c, a, v[c + 8 >> 2], v[c + 12 >> 2]);
 f = v[c + 4 >> 2];
 if ((f | 0) == (e | 0)) {
  hd(a, v[c + 12 >> 2]);
 }
 eb = c + 16 | 0;
 e = (e | 0) == (f | 0);
 if (!e) {
  SW(d);
 }
 c = -1;
 a: {
  if (!e) {
   break a;
  }
  c = 0;
  if (!VW(d)) {
   break a;
  }
  c = ve(a, b, UW(w[d + 34 | 0] | w[d + 35 | 0] << 8), gb);
 }
 eb = d + 608 | 0;
 return c | 0;
}

function A4(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 a = 0;
 if (b & 1) {
  a = (Xs(c) | 0) != 0;
 }
 if (b & 2) {
  a = (Ws(c) | 0) != 0 | a;
 }
 if (b & 4) {
  a = (Vs(c) | 0) != 0 | a;
 }
 if (b & 8) {
  a = (Us(c) | 0) != 0 | a;
 }
 if (b & 16) {
  a = (Ts(c) | 0) != 0 | a;
 }
 if (b & 32) {
  a = (Ss(c) | 0) != 0 | a;
 }
 if (b & 64) {
  a = (Zn(c) | 0) != 0 | a;
 }
 if (b & 128) {
  a = (Rs(c) | 0) != 0 | a;
 }
 if (b & 256) {
  a = (_n(c) | 0) != 0 | a;
 }
 if (b & 512) {
  a = (Qs(c) | 0) != 0 | a;
 }
 return a | 0;
}

function xia(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0;
 d = v[a >> 2];
 c = nc(d, v[a + 4 >> 2]);
 if (c >>> 0 < b >>> 0) {
  d = eb - 32 | 0;
  eb = d;
  b = b - c | 0;
  c = v[zb(a) >> 2];
  e = v[a + 4 >> 2];
  a: {
   if (b >>> 0 <= c - e >> 2 >>> 0) {
    Vq(a, b);
    break a;
   }
   c = zb(a);
   c = Yf(d + 12 | 0, Kf(a, nc(v[a >> 2], e) + b | 0), nc(v[a >> 2], v[a + 4 >> 2]), c);
   lA(c, b);
   Rm(a, c);
   Xf(c);
  }
  eb = d + 32 | 0;
  return;
 }
 if (b >>> 0 < c >>> 0) {
  Id(a, d + (b << 2) | 0);
 }
}

function Jn(a, b, c, d) {
 var e = 0, f = 0, g = 0, h = 0, i = 0;
 a: {
  e = v[d >> 2];
  if (e | v[c >> 2]) {
   while (1) {
    if ((b | 0) == (g | 0)) {
     break a;
    }
    f = v[c >> 2];
    h = c, i = f - qd((qd(0 - f | 0, 31) & 255) + f | 0, 8) | 0, v[h >> 2] = i;
    h = d, i = v[d >> 2] - qd((qd(0 - e | 0, 31) & 255) + e | 0, 8) | 0, v[h >> 2] = i;
    e = (g << 3) + a | 0;
    v[e >> 2] = v[c >> 2];
    f = e;
    e = v[d >> 2];
    v[f + 4 >> 2] = e;
    g = g + 1 | 0;
    continue;
   }
  }
  Qb(a, 0, b << 3);
 }
}

function IQ(a) {
 var b = 0, c = 0, d = 0;
 c = eb - 32 | 0;
 eb = c;
 a: {
  d = eA(a);
  b = fk(v[a >> 2], v[a + 4 >> 2]);
  b: {
   if (d >>> 0 <= b >>> 0) {
    break b;
   }
   v[31601] = 0;
   b = aa(944, c + 12 | 0, b | 0, b | 0, zb(a) | 0) | 0;
   d = v[31601];
   v[31601] = 0;
   if ((d | 0) != 1) {
    FQ(a, b);
    EQ(b);
    break b;
   }
   X(S(0) | 0) | 0;
   v[31601] = 0;
   W(26);
   a = v[31601];
   v[31601] = 0;
   if ((a | 0) == 1) {
    break a;
   }
  }
  eb = c + 32 | 0;
  return;
 }
 S(0) | 0;
 Rb();
 p();
}

function HQ(a) {
 var b = 0, c = 0, d = 0;
 c = eb - 32 | 0;
 eb = c;
 a: {
  d = Ug(a);
  b = nc(v[a >> 2], v[a + 4 >> 2]);
  b: {
   if (d >>> 0 <= b >>> 0) {
    break b;
   }
   v[31601] = 0;
   b = aa(945, c + 12 | 0, b | 0, b | 0, zb(a) | 0) | 0;
   d = v[31601];
   v[31601] = 0;
   if ((d | 0) != 1) {
    Rm(a, b);
    Xf(b);
    break b;
   }
   X(S(0) | 0) | 0;
   v[31601] = 0;
   W(26);
   a = v[31601];
   v[31601] = 0;
   if ((a | 0) == 1) {
    break a;
   }
  }
  eb = c + 32 | 0;
  return;
 }
 S(0) | 0;
 Rb();
 p();
}

function Aha(a) {
 a = a | 0;
 var b = 0, c = 0, d = 0, e = 0;
 b = eb - 16 | 0;
 eb = b;
 v[v[a + 20 >> 2] + 148 >> 2] = -1;
 Jr(b + 8 | 0, a + 4228 | 0);
 c = v[a + 20 >> 2];
 d = vb(v[b + 8 >> 2]);
 e = Ok(v[b + 8 >> 2], v[b + 12 >> 2]);
 v[31601] = 0;
 R(964, c + 4 | 0, d | 0, e | 0);
 c = v[31601];
 v[31601] = 0;
 a: {
  if ((c | 0) == 1) {
   c = S(124508) | 0;
   if ((fb | 0) != (_(124508) | 0)) {
    break a;
   }
   X(c | 0) | 0;
   Mc(v[a + 20 >> 2] + 4 | 0);
   Y();
  }
  eb = b + 16 | 0;
  return;
 }
 P(c | 0);
 p();
}

function r3(a, b, c, d, e) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 if (kh(a, v[b + 8 >> 2], e)) {
  Vx(b, c, d);
  return;
 }
 a: {
  if (!kh(a, v[b >> 2], e)) {
   break a;
  }
  if (!(v[b + 16 >> 2] != (c | 0) & v[b + 20 >> 2] != (c | 0))) {
   if ((d | 0) != 1) {
    break a;
   }
   v[b + 32 >> 2] = 1;
   return;
  }
  v[b + 20 >> 2] = c;
  v[b + 32 >> 2] = d;
  v[b + 40 >> 2] = v[b + 40 >> 2] + 1;
  if (!(v[b + 36 >> 2] != 1 | v[b + 24 >> 2] != 2)) {
   t[b + 54 | 0] = 1;
  }
  v[b + 44 >> 2] = 4;
 }
}

function Sna(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0;
 d = eb - 16 | 0;
 eb = d;
 c = eb - 16 | 0;
 eb = c;
 v[c + 12 >> 2] = 4925421;
 v[c + 8 >> 2] = 2147483647;
 e = Gb(c + 12 | 0, c + 8 | 0);
 eb = c + 16 | 0;
 if (y[e >> 2] < b >>> 0) {
  dd();
  p();
 }
 if (b >>> 0 >= 4925422) {
  Sj();
  p();
 }
 c = Dc(B(b, 872));
 v[d + 12 >> 2] = b;
 v[d + 8 >> 2] = c;
 b = v[d + 8 >> 2];
 v[a + 4 >> 2] = b;
 v[a >> 2] = b;
 f = zb(a), g = b + B(v[d + 12 >> 2], 872) | 0, v[f >> 2] = g;
 eb = d + 16 | 0;
}

function Rp(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0;
 a: {
  b: {
   c = w[a + 11 | 0];
   c: {
    d: {
     if (ud(c)) {
      c = v[a + 4 >> 2];
      d = Yi(v[a + 8 >> 2]) - 1 | 0;
      if ((c | 0) == (d | 0)) {
       break d;
      }
      break c;
     }
     d = 10;
     c = Gh(c);
     if ((c | 0) != 10) {
      break b;
     }
    }
    $m(a, d, 1, d, d, 0, 0);
    c = d;
   }
   d = v[a >> 2];
   Ad(a, c + 1 | 0);
   break a;
  }
  Me(a, c + 1 | 0);
  d = a;
 }
 a = c + d | 0;
 gd(a, b);
 gd(a + 1 | 0, 0);
}

function rA(a, b, c) {
 var d = 0, e = 0, f = 0;
 e = eb - 16 | 0;
 eb = e;
 d = e + 4 | 0;
 v[d >> 2] = a;
 a = v[a + 4 >> 2];
 v[d + 4 >> 2] = a;
 v[d + 8 >> 2] = a + B(b, 52);
 b = v[d + 4 >> 2];
 f = v[d + 8 >> 2];
 a: {
  while (1) {
   if ((b | 0) == (f | 0)) {
    break a;
   }
   v[31601] = 0;
   N(919, b | 0, c | 0);
   a = v[31601];
   v[31601] = 0;
   if ((a | 0) != 1) {
    b = b + 52 | 0;
    v[d + 4 >> 2] = b;
    continue;
   }
   break;
  }
  a = M() | 0;
  hc(d);
  P(a | 0);
  p();
 }
 hc(d);
 eb = e + 16 | 0;
}

function Kqa(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0;
 c = xb(b, c);
 e = c;
 c = Rd(b, c);
 d = eb - 16 | 0;
 eb = d;
 a: {
  if (Ug(a) >>> 0 >= c >>> 0) {
   f = v[a >> 2];
   g = nc(f, v[a + 4 >> 2]);
   if (c >>> 0 > g >>> 0) {
    h = b;
    b = gD(b, g);
    Lv(h, b, f);
    qY(a, b, e, c - nc(v[a >> 2], v[a + 4 >> 2]) | 0);
    break a;
   }
   sY(d + 8 | 0, b, e, f);
   Id(a, v[d + 12 >> 2]);
   break a;
  }
  qr(a);
  hm(a, Kf(a, c));
  qY(a, b, e, c);
 }
 eb = d + 16 | 0;
}

function aha(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0;
 a = Ii(a, b, c, d);
 v[a >> 2] = 43764;
 b = a + 4208 | 0;
 e = xb(b, 0), f = 1060320051, v[e >> 2] = f;
 e = xb(b, 1), f = 1041865114, v[e >> 2] = f;
 e = xb(b, 2), f = 1065353216, v[e >> 2] = f;
 e = xb(b, 3), f = 1049951732, v[e >> 2] = f;
 e = xb(b, 4), f = 1049951732, v[e >> 2] = f;
 v[31601] = 0;
 N(940, a + 44 | 0, 2);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  return a | 0;
 }
 b = M() | 0;
 Zf(a);
 P(b | 0);
 p();
}

function Zka(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0;
 a: {
  b: {
   c = w[a + 11 | 0];
   c: {
    d: {
     if (ud(c)) {
      c = v[a + 4 >> 2];
      d = Yi(v[a + 8 >> 2]) - 1 | 0;
      if ((c | 0) == (d | 0)) {
       break d;
      }
      break c;
     }
     d = 10;
     c = Gh(c);
     if ((c | 0) != 10) {
      break b;
     }
    }
    VB(a, d, 1, d, d, 0);
    c = d;
   }
   d = v[a >> 2];
   Ad(a, c + 1 | 0);
   break a;
  }
  Me(a, c + 1 | 0);
  d = a;
 }
 a = c + d | 0;
 gd(a, b);
 gd(a + 1 | 0, 0);
}

function hk(a, b) {
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0, i = 0;
 c = v[a + 4 >> 2];
 e = v[a + 12 >> 2];
 i = v[a + 8 >> 2];
 d = v[a >> 2];
 while (1) {
  if ((b | 0) != (f | 0)) {
   if (!d) {
    v[a >> 2] = 8;
    c = i;
    if ((e | 0) != (c | 0)) {
     c = e - 1 | 0;
     v[a + 12 >> 2] = c;
    }
    d = 8;
    e = c;
    c = w[c | 0];
   }
   g = c;
   d = d - 1 | 0;
   v[a >> 2] = d;
   c = g >>> 1 | 0;
   v[a + 4 >> 2] = c;
   h = g & 1 | h << 1;
   f = f + 1 | 0;
   continue;
  }
  break;
 }
 return h;
}

function ZP(a) {
 a = a | 0;
 var b = 0, c = 0;
 c = eb - 16 | 0;
 eb = c;
 b = v[v[a + 16 >> 2] + 24620 >> 2] / 5 | 0;
 b = Fc(b, b >> 31);
 v[a + 4272 >> 2] = b;
 v[31601] = 0;
 v[c + 12 >> 2] = 0;
 R(946, a + 4256 | 0, b << 1, c + 12 | 0);
 b = v[31601];
 v[31601] = 0;
 a: {
  if ((b | 0) == 1) {
   b = S(124508) | 0;
   if ((fb | 0) != (_(124508) | 0)) {
    break a;
   }
   X(b | 0) | 0;
   v[a + 4272 >> 2] = 0;
   Y();
  }
  v[a + 4276 >> 2] = 0;
  v[a + 4268 >> 2] = 0;
  eb = c + 16 | 0;
  return;
 }
 P(b | 0);
 p();
}

function lua(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0;
 e = eb - 1968 | 0;
 eb = e;
 c = eb - 16 | 0;
 eb = c;
 f = e + 14 | 0;
 l0(c + 8 | 0, f);
 d = v[c + 12 >> 2];
 pd(c, a, v[c + 8 >> 2], v[c + 12 >> 2]);
 g = v[c + 4 >> 2];
 if ((g | 0) == (d | 0)) {
  hd(a, v[c + 12 >> 2]);
 }
 eb = c + 16 | 0;
 d = (d | 0) == (g | 0);
 if (!d) {
  k0(f);
 }
 c = -1;
 a: {
  if (!d) {
   break a;
  }
  c = 0;
  if (!n0(f)) {
   break a;
  }
  c = ve(a, b, 1024, 0);
 }
 eb = e + 1968 | 0;
 return c | 0;
}

function Pqa(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0;
 f = eb + -64 | 0;
 eb = f;
 c = eb - 16 | 0;
 eb = c;
 e = f + 12 | 0;
 DY(c + 8 | 0, e);
 d = v[c + 12 >> 2];
 pd(c, a, v[c + 8 >> 2], v[c + 12 >> 2]);
 g = v[c + 4 >> 2];
 if ((g | 0) == (d | 0)) {
  hd(a, v[c + 12 >> 2]);
 }
 eb = c + 16 | 0;
 d = (d | 0) == (g | 0);
 if (!d) {
  CY(e);
 }
 c = -1;
 a: {
  if (!d) {
   break a;
  }
  c = 0;
  if (!GY(e)) {
   break a;
  }
  c = ve(a, b, FY(e), gb);
 }
 eb = f - -64 | 0;
 return c | 0;
}

function L1(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0;
 c = eb - 32 | 0;
 eb = c;
 d = c + 8 | 0;
 Rk(d, b);
 v[31601] = 0;
 b = c + 20 | 0;
 N(14, b | 0, d | 0);
 e = v[31601];
 v[31601] = 0;
 a: {
  b: {
   if ((e | 0) != 1) {
    v[31601] = 0;
    N(15, a | 0, b | 0);
    a = v[31601];
    v[31601] = 0;
    if ((a | 0) == 1) {
     break b;
    }
    Tb(b);
    sb(d);
    eb = c + 32 | 0;
    return;
   }
   b = M() | 0;
   break a;
  }
  b = M() | 0;
  Tb(c + 20 | 0);
 }
 sb(c + 8 | 0);
 P(b | 0);
 p();
}

function md(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0;
 c = eb - 16 | 0;
 eb = c;
 mn(a);
 v[a + 16 >> 2] = 0;
 v[a + 8 >> 2] = 0;
 v[a + 12 >> 2] = 0;
 v[a >> 2] = 0;
 v[a + 4 >> 2] = 0;
 u[a + 32 >> 1] = 64;
 v[a + 24 >> 2] = 8363;
 v[a + 28 >> 2] = 16777344;
 v[a + 36 >> 2] = 0;
 t[a + 39 | 0] = 0;
 t[a + 40 | 0] = 0;
 t[a + 41 | 0] = 0;
 t[a + 42 | 0] = 0;
 d = x[a + 34 >> 1] & -25279;
 u[a + 34 >> 1] = (b | 0) == 4 ? d | 32 : d;
 b = Cc(c + 4 | 0, 22256);
 Ae(a + 43 | 0, b);
 sb(b);
 ZV(a);
 eb = c + 16 | 0;
}

function Ys(a, b, c) {
 var d = 0, e = 0, f = 0;
 e = eb - 16 | 0;
 eb = e;
 d = w[b | 0];
 a: {
  if (!d) {
   d = 0;
   break a;
  }
  b: {
   if (!w[b + 1 | 0]) {
    t[a | 0] = d;
    break b;
   }
   d = 0;
   if (!_p(e + 12 | 0, b, c)) {
    break a;
   }
   f = v[e + 12 >> 2];
   b = dy(f, c);
   c: {
    if ((b | 0) != -1) {
     break c;
    }
    b = 32;
    if ((f | 0) == 8239) {
     break c;
    }
    if ((f | 0) != 160) {
     break a;
    }
   }
   t[a | 0] = b;
  }
  d = 1;
 }
 eb = e + 16 | 0;
 return d;
}

function Msa(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0;
 f = eb - 208 | 0;
 eb = f;
 c = eb - 16 | 0;
 eb = c;
 e = f + 2 | 0;
 i_(c + 8 | 0, e);
 d = v[c + 12 >> 2];
 pd(c, a, v[c + 8 >> 2], v[c + 12 >> 2]);
 g = v[c + 4 >> 2];
 if ((g | 0) == (d | 0)) {
  hd(a, v[c + 12 >> 2]);
 }
 eb = c + 16 | 0;
 d = (d | 0) == (g | 0);
 if (!d) {
  h_(e);
 }
 c = -1;
 a: {
  if (!d) {
   break a;
  }
  c = 0;
  if (!k_(e)) {
   break a;
  }
  c = ve(a, b, j_(e), gb);
 }
 eb = f + 208 | 0;
 return c | 0;
}

function yX(a) {
 var b = 0, c = 0, d = 0, e = 0, f = 0;
 f = w[a + 28 | 0] | w[a + 29 | 0] << 8;
 c = Aua(w[a + 30 | 0], 0, 37, 0);
 d = gb;
 b = Aua(w[a + 24 | 0] | w[a + 25 | 0] << 8, 0, 192, 0);
 c = b + c | 0;
 d = gb + d | 0;
 b = b >>> 0 > c >>> 0 ? d + 1 | 0 : d;
 a = w[a + 26 | 0];
 d = a >>> 26 | 0;
 e = c;
 c = a << 6;
 e = e + c | 0;
 a = b + d | 0;
 a = c >>> 0 > e >>> 0 ? a + 1 | 0 : a;
 b = e + f | 0;
 a = b >>> 0 < e >>> 0 ? a + 1 | 0 : a;
 b = b + 192 | 0;
 gb = b >>> 0 < 192 ? a + 1 | 0 : a;
 return b;
}

function nM(a) {
 var b = 0, c = 0, d = 0, e = 0;
 b = eb - 32 | 0;
 eb = b;
 if (!w[a + 20 | 0]) {
  while (1) {
   if (!(hb[v[v[a >> 2] + 40 >> 2]](a) | 0)) {
    lM(a, 65536);
    c = Yb(b + 16 | 0, wb(v[a + 4 >> 2], v[a + 16 >> 2]), 65536);
    d = v[v[a >> 2] + 44 >> 2];
    e = v[c + 4 >> 2];
    v[b + 8 >> 2] = v[c >> 2];
    v[b + 12 >> 2] = e;
    hb[d | 0](b + 24 | 0, a, b + 8 | 0);
    v[a + 16 >> 2] = v[a + 16 >> 2] + v[b + 28 >> 2];
    continue;
   }
   break;
  }
  t[a + 20 | 0] = 1;
 }
 eb = b + 32 | 0;
}

function Ssa(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0;
 d = eb - 224 | 0;
 eb = d;
 c = eb - 16 | 0;
 eb = c;
 e = d + 6 | 0;
 s_(c + 8 | 0, e);
 f = v[c + 12 >> 2];
 pd(c, a, v[c + 8 >> 2], v[c + 12 >> 2]);
 g = v[c + 4 >> 2];
 if ((g | 0) == (f | 0)) {
  hd(a, v[c + 12 >> 2]);
 }
 eb = c + 16 | 0;
 c = -1;
 a: {
  if ((f | 0) != (g | 0)) {
   break a;
  }
  c = 0;
  if (!u_(e)) {
   break a;
  }
  c = ve(a, b, t_(w[d + 222 | 0], w[d + 223 | 0]), gb);
 }
 eb = d + 224 | 0;
 return c | 0;
}

function Lpa(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0;
 e = eb - 128 | 0;
 eb = e;
 c = eb - 16 | 0;
 eb = c;
 f = e + 2 | 0;
 EX(c + 8 | 0, f);
 d = v[c + 12 >> 2];
 pd(c, a, v[c + 8 >> 2], v[c + 12 >> 2]);
 g = v[c + 4 >> 2];
 if ((g | 0) == (d | 0)) {
  hd(a, v[c + 12 >> 2]);
 }
 eb = c + 16 | 0;
 d = (d | 0) == (g | 0);
 if (!d) {
  DX(f);
 }
 c = -1;
 a: {
  if (!d) {
   break a;
  }
  c = 0;
  if (!FX(f)) {
   break a;
  }
  c = ve(a, b, 256, 0);
 }
 eb = e + 128 | 0;
 return c | 0;
}

function sta(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0;
 e = eb - 32 | 0;
 eb = e;
 c = eb - 16 | 0;
 eb = c;
 f = e + 15 | 0;
 y0(c + 8 | 0, f);
 d = v[c + 12 >> 2];
 pd(c, a, v[c + 8 >> 2], v[c + 12 >> 2]);
 g = v[c + 4 >> 2];
 if ((g | 0) == (d | 0)) {
  hd(a, v[c + 12 >> 2]);
 }
 eb = c + 16 | 0;
 d = (d | 0) == (g | 0);
 if (!d) {
  HE(f);
 }
 c = -1;
 a: {
  if (!d) {
   break a;
  }
  c = 0;
  if (!Y_(f)) {
   break a;
  }
  c = ve(a, b, 72, 0);
 }
 eb = e + 32 | 0;
 return c | 0;
}

function aaa(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0;
 a: {
  if (!v[b + 28 >> 2]) {
   c = v[d >> 2];
   break a;
  }
  e = hb[v[b + 32 >> 2]](v[b + 24 >> 2], c, 0, 0) | 0;
  c = v[d >> 2];
  if ((e | 0) < 0) {
   break a;
  }
  d = v[d + 4 >> 2];
  e = c;
  while (1) {
   if (!d) {
    break a;
   }
   f = hb[v[b + 28 >> 2]](v[b + 24 >> 2], e, d) | 0;
   if (!f) {
    break a;
   }
   g = f + g | 0;
   d = d - f | 0;
   e = e + f | 0;
   continue;
  }
 }
 ac(a, c, g);
}

function Ks(a, b, c, d, e, f) {
 var g = 0, h = 0;
 g = eb - 16 | 0;
 eb = g;
 v[g + 12 >> 2] = d;
 d = g + 12 | 0;
 h = v[re(g + 8 | 0, d) >> 2];
 v[31601] = 0;
 ga(f | 0, a + 8 | 0, b | 0, c | 0, h | 0, e | 0) | 0;
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  a = Gz(a);
  b = Fz(a + 88 | 0);
  c = Ez(a + 92 | 0);
  e = Dz(a + 96 | 0);
  v[a >> 2] = 47676;
  v[b >> 2] = 47792;
  v[c >> 2] = 47872;
  v[e >> 2] = 47912;
  Wc(d);
  eb = g + 16 | 0;
  return a;
 }
 a = M() | 0;
 Wc(g + 12 | 0);
 P(a | 0);
 p();
}

function GQ(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0;
 e = eb - 16 | 0;
 eb = e;
 Kg(a + 12 | 0, d);
 a: {
  if (!b) {
   d = 0;
   b = 0;
   break a;
  }
  if (b >>> 0 >= 2097152) {
   Sj();
   p();
  }
  d = Dc(b << 11);
  v[e + 12 >> 2] = b;
  v[e + 8 >> 2] = d;
  d = v[e + 12 >> 2];
  b = v[e + 8 >> 2];
 }
 v[a >> 2] = b;
 c = b + (c << 11) | 0;
 v[a + 8 >> 2] = c;
 v[a + 4 >> 2] = c;
 f = mc(a), g = b + (d << 11) | 0, v[f >> 2] = g;
 eb = e + 16 | 0;
 return a | 0;
}

function nk(a, b) {
 a: {
  if ((b | 0) >= 1024) {
   a = a * 898846567431158e293;
   if (b >>> 0 < 2047) {
    b = b - 1023 | 0;
    break a;
   }
   a = a * 898846567431158e293;
   b = ((b | 0) >= 3069 ? 3069 : b) - 2046 | 0;
   break a;
  }
  if ((b | 0) > -1023) {
   break a;
  }
  a = a * 2004168360008973e-307;
  if (b >>> 0 > 4294965304) {
   b = b + 969 | 0;
   break a;
  }
  a = a * 2004168360008973e-307;
  b = ((b | 0) <= -2960 ? -2960 : b) + 1938 | 0;
 }
 l(0, 0);
 l(1, b + 1023 << 20);
 return a * +n();
}

function ZZ(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0;
 c = eb - 16 | 0;
 eb = c;
 a = ng(a);
 b = b + 236 | 0;
 e = ur(b);
 a: {
  while (1) {
   if ((b | 0) != (e | 0)) {
    d = x[b >> 1];
    u[c + 14 >> 1] = d;
    if (d) {
     v[31601] = 0;
     R(401, c + 4 | 0, a | 0, c + 14 | 0);
     d = v[31601];
     v[31601] = 0;
     if ((d | 0) == 1) {
      break a;
     }
    }
    b = b + 2 | 0;
    continue;
   }
   break;
  }
  eb = c + 16 | 0;
  return;
 }
 b = M() | 0;
 Yv(a);
 P(b | 0);
 p();
}

function x8(a, b, c, d, e) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 var f = 0, g = 0, h = 0;
 h = (e - d | 0) + b | 0;
 a: {
  while (1) {
   if ((d | 0) != (e | 0)) {
    a = -1;
    if ((b | 0) == (c | 0)) {
     break a;
    }
    f = t[b | 0];
    g = t[d | 0];
    if ((f | 0) < (g | 0)) {
     break a;
    }
    if ((f | 0) > (g | 0)) {
     return 1;
    } else {
     d = d + 1 | 0;
     b = b + 1 | 0;
     continue;
    }
   }
   break;
  }
  a = (c | 0) != (h | 0);
 }
 return a | 0;
}

function CA(a, b, c) {
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0;
 c = c >= .999 ? .999 : c;
 h = c * 3.141592653589793;
 i = av(b);
 while (1) {
  if ((e | 0) != 32768) {
   f = (e << 12 & 28672 | e >>> 3) ^ 28672;
   if ((f | 0) != 16384) {
    d = +(f - 16384 | 0) * .000244140625;
    g = h * d;
    d = Oi(g) * av(K(d * d * -.0625 + 1) * b) / (i * g);
   } else {
    d = 1;
   }
   j = a, k = vC(c * d * 32768), u[j >> 1] = k;
   e = e + 1 | 0;
   a = a + 2 | 0;
   continue;
  }
  break;
 }
}

function BU(a) {
 a = a | 0;
 var b = 0, c = 0, d = 0;
 b = eb - 16 | 0;
 eb = b;
 if (w[a + 534 | 0]) {
  while (1) {
   d = c & 65535;
   if (d >>> 0 >= 256) {
    t[a + 534 | 0] = 0;
   } else {
    Dj(a, d, 1);
    c = c + 1 | 0;
    continue;
   }
   break;
  }
 }
 t[b + 15 | 0] = 0;
 Rh(a + 8 | 0, 18, b + 15 | 0);
 Kv(a + 26 | 0, 18, 27498);
 t[b + 14 | 0] = 255;
 Rh(a + 62 | 0, 256, b + 14 | 0);
 zh(v[a >> 2], v[a + 4 >> 2], 65535, 261, 1);
 zh(v[a >> 2], v[a + 4 >> 2], 65535, 260, 0);
 eb = b + 16 | 0;
}

function RS(a, b, c) {
 var d = 0, e = 0, f = 0, g = 0, h = 0;
 d = (B(b, 872) + a | 0) + 616 | 0;
 b = 0;
 e = v[a + 16 >> 2];
 b = e ? w[d + 813 | 0] : b;
 f = v[a + 40 >> 2];
 t[d + 851 | 0] = w[d + 851 | 0] | 64;
 h = v[d + 852 >> 2];
 g = (+(e >>> 0) + 1) * +(c | 0) / +(f >>> 0);
 a: {
  if (D(g) < 2147483648) {
   a = ~~g;
   break a;
  }
  a = -2147483648;
 }
 v[d + 852 >> 2] = h + (a + ((c | 0) < 0 ? b : 0 - b | 0) | 0);
 b = (f | 0) == (e + 1 | 0) ? c : a;
 a = b >> 31;
 t[d + 813 | 0] = (a ^ b) - a;
}

function kea(a, b, c, d, e) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 var f = 0;
 v[31601] = 0;
 V(995, a | 0);
 f = v[31601];
 v[31601] = 0;
 if ((f | 0) != 1) {
  return iu(v[v[a + 24 >> 2] + 24 >> 2], b, c, d, e) | 0;
 }
 X(S(0) | 0) | 0;
 v[31601] = 0;
 U(982, 12486, a | 0, 0, 0);
 a = v[31601];
 v[31601] = 0;
 if ((a | 0) != 1) {
  Y();
  return 0;
 }
 a = M() | 0;
 v[31601] = 0;
 W(26);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  P(a | 0);
  p();
 }
 S(0) | 0;
 Rb();
 p();
}

function IG(a) {
 var b = 0;
 if (!((w[a | 0] | w[a + 1 | 0] << 8 | (w[a + 2 | 0] << 16 | w[a + 3 | 0] << 24)) != 1129474426 | (w[a + 4 | 0] | w[a + 5 | 0] << 8 | (w[a + 6 | 0] << 16 | w[a + 7 | 0] << 24)) != 1634291279 | (w[a + 8 | 0] | w[a + 9 | 0] << 8) != 14 | (!(w[a + 12 | 0] | w[a + 13 | 0] << 8) | (w[a + 14 | 0] | w[a + 15 | 0] << 8 | (w[a + 16 | 0] << 16 | w[a + 17 | 0] << 24)) <= 0))) {
  b = (w[a + 18 | 0] | w[a + 19 | 0] << 8 | (w[a + 20 | 0] << 16 | w[a + 21 | 0] << 24)) >>> 0 > 23;
 }
 return b;
}

function dr(a) {
 var b = 0, c = 0;
 b = v[a + 76 >> 2];
 a: {
  if (!((b | 0) >= 0 & (!b | v[124089] != (b & 1073741823)))) {
   b = v[a + 4 >> 2];
   if ((b | 0) != v[a + 8 >> 2]) {
    v[a + 4 >> 2] = b + 1;
    a = w[b | 0];
    break a;
   }
   a = zt(a);
   break a;
  }
  b = a + 76 | 0;
  c = v[b >> 2];
  v[b >> 2] = c ? c : 1073741823;
  c = v[a + 4 >> 2];
  b: {
   if ((c | 0) != v[a + 8 >> 2]) {
    v[a + 4 >> 2] = c + 1;
    a = w[c | 0];
    break b;
   }
   a = zt(a);
  }
  me(b);
 }
 return a;
}

function Nga(a, b, c, d, e) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 var f = 0, g = 0;
 b = kQ(a, b, c, d, e ^ 1);
 v[b >> 2] = 44376;
 a = b + 4208 | 0;
 f = xb(a, 0), g = 1056964608, v[f >> 2] = g;
 f = xb(a, 1), g = 1065353216, v[f >> 2] = g;
 f = xb(a, 2), g = 1020054733, v[f >> 2] = g;
 f = xb(a, 3), g = 1065353216, v[f >> 2] = g;
 f = xb(a, 4), g = 1056964608, v[f >> 2] = g;
 f = xb(a, 5), g = 1048406533, v[f >> 2] = g;
 f = xb(a, 6), g = 1056964608, v[f >> 2] = g;
 return b | 0;
}

function Dha(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 a = Ii(a, b, c, d);
 v[a >> 2] = 43264;
 c = Mb(a + 4208 | 0);
 v[a + 4220 >> 2] = 0;
 v[a + 4224 >> 2] = 1056964608;
 b = a + 4228 | 0;
 t[b + 6 | 0] = 1;
 t[b + 4 | 0] = 0;
 t[b + 5 | 0] = 4;
 t[b | 0] = 69;
 t[b + 1 | 0] = 99;
 t[b + 2 | 0] = 104;
 t[b + 3 | 0] = 111;
 v[31601] = 0;
 N(940, a + 44 | 0, 2);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  nu(a);
  return a | 0;
 }
 b = M() | 0;
 uc(c);
 Zf(a);
 P(b | 0);
 p();
}

function Xz(a) {
 var b = C(0), c = C(0), d = 0, e = C(0), f = 0;
 b = C(y[v[a + 16 >> 2] + 24620 >> 2]);
 c = C(C(C(hb[v[v[a >> 2] + 208 >> 2]](a)) * b) / C(1e3));
 d = a, e = C(C(c * C(hb[v[v[a >> 2] + 200 >> 2]](a))) * C(2048)), z[d + 4248 >> 2] = e;
 d = a, f = Jl(C(C(c + C(2)) * C(4096))), v[d + 4256 >> 2] = f;
 c = C(hb[v[v[a >> 2] + 212 >> 2]](a));
 z[a + 4252 >> 2] = c;
 b = C(c / b);
 if (!(hb[v[v[a >> 2] + 196 >> 2]](a) | 0)) {
  b = bQ(C(b * C(3.1415927410125732)));
 }
 z[a + 4244 >> 2] = b + b;
}

function Hs(a, b, c, d, e) {
 var f = 0, g = 0;
 f = eb - 16 | 0;
 eb = f;
 v[f + 12 >> 2] = c;
 c = f + 12 | 0;
 g = v[re(f + 8 | 0, c) >> 2];
 v[31601] = 0;
 aa(e | 0, a + 8 | 0, b | 0, g | 0, d | 0) | 0;
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  a = Gz(a);
  b = Fz(a + 88 | 0);
  d = Ez(a + 92 | 0);
  e = Dz(a + 96 | 0);
  v[a >> 2] = 47676;
  v[b >> 2] = 47792;
  v[d >> 2] = 47872;
  v[e >> 2] = 47912;
  Wc(c);
  eb = f + 16 | 0;
  return a;
 }
 a = M() | 0;
 Wc(f + 12 | 0);
 P(a | 0);
 p();
}

function kA(a, b) {
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0;
 d = eb - 16 | 0;
 eb = d;
 h = x[b >> 1];
 c = ce(a);
 e = fc(a);
 f = eb - 16 | 0;
 eb = f;
 while (1) {
  if (c) {
   g = Yq(x[c + 16 >> 1], h);
   e = g ? e : c;
   c = v[(g ? 4 : 0) + c >> 2];
   continue;
  }
  break;
 }
 c = v[ub(f + 12 | 0, e) >> 2];
 eb = f + 16 | 0;
 a: {
  if (Hb(c, og(a))) {
   if (!Yq(x[b >> 1], x[td(c) >> 1])) {
    break a;
   }
  }
  c = og(a);
 }
 a = ub(d + 12 | 0, c);
 eb = d + 16 | 0;
 return v[a >> 2];
}

function ira(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0;
 d = eb - 16 | 0;
 eb = d;
 sf(b);
 v[d + 12 >> 2] = 0;
 a: {
  if (!Ek(a, d + 12 | 0)) {
   break a;
  }
  f = c;
  c = v[d + 12 >> 2];
  if (f >>> 0 < c >>> 0) {
   break a;
  }
  while (1) {
   if ((c | 0) == (e | 0)) {
    e = 1;
    break a;
   }
   t[d + 11 | 0] = 0;
   if (fi(a, d + 11 | 0)) {
    Rp(b, t[d + 11 | 0]);
    e = e + 1 | 0;
    continue;
   }
   break;
  }
  e = 0;
 }
 eb = d + 16 | 0;
 return e | 0;
}

function aua(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0;
 d = eb - 16 | 0;
 eb = d;
 v[d + 12 >> 2] = c;
 a: {
  if (!Lb(v[b >> 2], v[b + 8 >> 2], c << 1)) {
   break a;
  }
  wc(d + 12 | 0, 65535);
  ug(a, x[d + 12 >> 1]);
  c = vb(v[a >> 2]);
  v[d + 4 >> 2] = c;
  a = vb(v[a + 4 >> 2]);
  while (1) {
   if (!Hb(c, a)) {
    break a;
   }
   ww(b, d + 10 | 0);
   e = c, f = Ab(x[d + 10 >> 1]), u[e >> 1] = f;
   c = v[fe(d + 4 | 0) >> 2];
   continue;
  }
 }
 eb = d + 16 | 0;
}

function XF(a, b, c) {
 var d = 0, e = 0, f = 0, g = 0, h = 0;
 d = v[a + 92 >> 2];
 e = v[a + 96 >> 2];
 if (d | e) {
  while (1) {
   if ((c | 0) == (g | 0)) {
    v[a + 96 >> 2] = e;
    v[a + 92 >> 2] = d;
   } else {
    f = (g << 3) + b | 0;
    h = v[f >> 2];
    d = d - qd((qd(0 - d | 0, 31) & 255) + d | 0, 8) | 0;
    v[f >> 2] = h + d;
    h = v[f + 4 >> 2];
    e = e - qd((qd(0 - e | 0, 31) & 255) + e | 0, 8) | 0;
    v[f + 4 >> 2] = h + e;
    g = g + 1 | 0;
    continue;
   }
   break;
  }
 }
}

function Kia(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0;
 if (v[a + 4 >> 2] != v[zb(a) >> 2]) {
  c = eb - 16 | 0;
  eb = c;
  a = wh(c + 4 | 0, a, 1);
  sk(v[a + 4 >> 2], z[b >> 2]);
  v[a + 4 >> 2] = v[a + 4 >> 2] + 4;
  hc(a);
  eb = c + 16 | 0;
  return;
 }
 d = eb - 32 | 0;
 eb = d;
 c = zb(a);
 c = Yf(d + 12 | 0, Kf(a, nc(v[a >> 2], v[a + 4 >> 2]) + 1 | 0), nc(v[a >> 2], v[a + 4 >> 2]), c);
 sk(v[c + 8 >> 2], z[b >> 2]);
 v[c + 8 >> 2] = v[c + 8 >> 2] + 4;
 oA(a, c);
 Xf(c);
 eb = d + 32 | 0;
}

function Al(a, b) {
 var c = 0, d = 0, e = 0;
 d = v[a >> 2];
 c = nc(d, v[a + 4 >> 2]);
 if (c >>> 0 < b >>> 0) {
  d = eb - 32 | 0;
  eb = d;
  b = b - c | 0;
  c = v[zb(a) >> 2];
  e = v[a + 4 >> 2];
  a: {
   if (b >>> 0 <= c - e >> 2 >>> 0) {
    Vq(a, b);
    break a;
   }
   c = zb(a);
   c = Yf(d + 12 | 0, Kf(a, nc(v[a >> 2], e) + b | 0), nc(v[a >> 2], v[a + 4 >> 2]), c);
   lA(c, b);
   oA(a, c);
   Xf(c);
  }
  eb = d + 32 | 0;
  return;
 }
 if (b >>> 0 < c >>> 0) {
  Id(a, d + (b << 2) | 0);
 }
}

function t0(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0;
 if (v[a + 4 >> 2] != v[zb(a) >> 2]) {
  c = eb - 16 | 0;
  eb = c;
  a = aj(c + 4 | 0, a, 1);
  km(v[a + 4 >> 2], x[b >> 1]);
  v[a + 4 >> 2] = v[a + 4 >> 2] + 2;
  hc(a);
  eb = c + 16 | 0;
  return;
 }
 d = eb - 32 | 0;
 eb = d;
 c = zb(a);
 c = dk(d + 12 | 0, ek(a, _c(v[a >> 2], v[a + 4 >> 2]) + 1 | 0), _c(v[a >> 2], v[a + 4 >> 2]), c);
 km(v[c + 8 >> 2], x[b >> 1]);
 v[c + 8 >> 2] = v[c + 8 >> 2] + 2;
 Ur(a, c);
 $i(c);
 eb = d + 32 | 0;
}

function sha(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = C(c);
 var d = 0, e = C(0);
 if (b >>> 0 <= 6) {
  c = Od(c, C(0));
  a: {
   b: {
    switch (b - 3 | 0) {
    case 0:
     c = ki(c);
     if (c == z[xb(a + 4208 | 0, 3) >> 2]) {
      break a;
     }
     v[a + 4236 >> 2] = 0;
     z[a + 4240 >> 2] = C(c * C(.5)) + C(.5);
     break a;

    case 1:
     break b;

    default:
     break a;
    }
   }
   c = C(ki(C(c * C(4))) * C(.25));
  }
  d = xb(a + 4208 | 0, b), e = c, z[d >> 2] = e;
  Xz(a);
 }
}

function Lga(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = C(c);
 var d = 0, e = C(0);
 if (b >>> 0 <= 6) {
  c = Od(c, C(0));
  a: {
   b: {
    switch (b - 1 | 0) {
    case 0:
     c = ki(c);
     if (c == z[xb(a + 4208 | 0, 1) >> 2]) {
      break a;
     }
     v[a + 4236 >> 2] = 0;
     z[a + 4240 >> 2] = C(c * C(.5)) + C(.5);
     break a;

    case 3:
     break b;

    default:
     break a;
    }
   }
   c = C(ki(C(c * C(4))) * C(.25));
  }
  d = xb(a + 4208 | 0, b), e = c, z[d >> 2] = e;
  Xz(a);
 }
}

function tQ(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0, h = 0;
 d = U_(b, c);
 e = eb - 16 | 0;
 eb = e;
 a: {
  if ($o(a) >>> 0 >= d >>> 0) {
   f = v[a >> 2];
   g = Sc(f, v[a + 4 >> 2]);
   if (g >>> 0 < d >>> 0) {
    h = b;
    b = S_(b, g);
    dw(h, b, f);
    xn(a, b, c, d - Sc(v[a >> 2], v[a + 4 >> 2]) | 0);
    break a;
   }
   aE(e + 8 | 0, b, c, f);
   Id(a, v[e + 12 >> 2]);
   break a;
  }
  ew(a);
  Tk(a, Tl(a, d));
  xn(a, b, c, d);
 }
 eb = e + 16 | 0;
}

function c0(a, b) {
 var c = 0, d = 0;
 a: {
  b: {
   a = a - 12 | 0;
   c: {
    if (a >>> 0 > 31) {
     break c;
    }
    d = 1 << a;
    c = 1;
    if (d & -2145904587) {
     break a;
    }
    if (d & 65792) {
     break b;
    }
    if ((a | 0) != 7) {
     break c;
    }
    b = b & 240;
    c = 1;
    if (!b | (b | 0) == 96 | (b | 0) == 224) {
     break a;
    }
   }
   return 0;
  }
  b = b - 96 | 0;
  c = 0;
  if (b >>> 0 >= 144) {
   break a;
  }
  c = 297 >>> (b >>> 4) & 1;
 }
 return c;
}

function p0(a, b, c) {
 var d = 0, e = 0;
 d = eb - 32 | 0;
 eb = d;
 e = d + 8 | 0;
 Tf(e, c);
 v[31601] = 0;
 c = d + 20 | 0;
 R(123, c | 0, b | 0, e | 0);
 b = v[31601];
 v[31601] = 0;
 a: {
  b: {
   if ((b | 0) != 1) {
    v[31601] = 0;
    N(12, a | 0, c | 0);
    a = v[31601];
    v[31601] = 0;
    if ((a | 0) == 1) {
     break b;
    }
    Tb(c);
    sb(e);
    eb = d + 32 | 0;
    return;
   }
   c = M() | 0;
   break a;
  }
  c = M() | 0;
  Tb(d + 20 | 0);
 }
 sb(d + 8 | 0);
 P(c | 0);
 p();
}

function NQ(a, b) {
 var c = 0, d = 0, e = 0, f = 0, g = C(0);
 c = eb - 16 | 0;
 eb = c;
 if (!v[(v[v[a >> 2] - 12 >> 2] + a | 0) + 16 >> 2]) {
  u[c + 14 >> 1] = 0;
  mg(a, c + 14 | 0);
  e = x[c + 14 >> 1];
  Al(b, e);
  while (1) {
   if ((d | 0) != (e | 0)) {
    v[c + 8 >> 2] = 0;
    wq(a, c + 8 | 0);
    f = xb(v[b >> 2], d), g = z[c + 8 >> 2], z[f >> 2] = g;
    d = d + 1 | 0;
    continue;
   }
   break;
  }
  d = !v[(v[v[a >> 2] - 12 >> 2] + a | 0) + 16 >> 2];
 }
 eb = c + 16 | 0;
 return d;
}

function yG(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0;
 c = eb - 32 | 0;
 eb = c;
 e = c + 8 | 0;
 Yw(e, b);
 v[31601] = 0;
 d = c + 20 | 0;
 R(11, d | 0, 1, e | 0);
 b = v[31601];
 v[31601] = 0;
 a: {
  if ((b | 0) != 1) {
   v[31601] = 0;
   N(12, a | 0, d | 0);
   a = v[31601];
   v[31601] = 0;
   if ((a | 0) == 1) {
    b = M() | 0;
    Tb(d);
    break a;
   }
   Tb(c + 20 | 0);
   sb(c + 8 | 0);
   eb = c + 32 | 0;
   return;
  }
  b = M() | 0;
 }
 sb(c + 8 | 0);
 P(b | 0);
 p();
}

function Sha(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0;
 d = eb - 32 | 0;
 eb = d;
 v[d + 28 >> 2] = c;
 v[d + 8 >> 2] = 33;
 e = v[a >> 2];
 f = v[a + 8 >> 2];
 c = v[Gb(d + 28 | 0, d + 8 | 0) >> 2];
 if (!Lb(e, f, c)) {
  c = jf(a);
 }
 e = d + 8 | 0;
 oD(e, b);
 f = Yb(d + 16 | 0, v[d + 8 >> 2], c);
 ic(d, v[a >> 2], v[a + 8 >> 2], v[f >> 2], v[f + 4 >> 2]);
 oD(e, b);
 Qb(v[d + 8 >> 2] + c | 0, 0, 33 - c | 0);
 Ub(a, v[d + 28 >> 2]);
 eb = d + 32 | 0;
 return c | 0;
}

function $ra(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0;
 d = eb - 192 | 0;
 eb = d;
 c = eb - 16 | 0;
 eb = c;
 sw(c + 8 | 0, d);
 e = v[c + 12 >> 2];
 pd(c, a, v[c + 8 >> 2], v[c + 12 >> 2]);
 f = v[c + 4 >> 2];
 if ((f | 0) == (e | 0)) {
  hd(a, v[c + 12 >> 2]);
 }
 eb = c + 16 | 0;
 e = (e | 0) == (f | 0);
 if (!e) {
  EZ(d);
 }
 c = -1;
 a: {
  if (!e) {
   break a;
  }
  c = 0;
  if (!GZ(d)) {
   break a;
  }
  c = ve(a, b, FZ(d), gb);
 }
 eb = d + 192 | 0;
 return c | 0;
}

function Hna(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0;
 d = eb - 80 | 0;
 eb = d;
 c = eb - 16 | 0;
 eb = c;
 $Y(c + 8 | 0, d);
 e = v[c + 12 >> 2];
 pd(c, a, v[c + 8 >> 2], v[c + 12 >> 2]);
 f = v[c + 4 >> 2];
 if ((f | 0) == (e | 0)) {
  hd(a, v[c + 12 >> 2]);
 }
 eb = c + 16 | 0;
 e = (e | 0) == (f | 0);
 if (!e) {
  sD(d);
 }
 c = -1;
 a: {
  if (!e) {
   break a;
  }
  c = 0;
  if (!wV(d)) {
   break a;
  }
  c = ve(a, b, vV(d), gb);
 }
 eb = d + 80 | 0;
 return c | 0;
}

function YF(a) {
 var b = 0, c = 0;
 a: {
  if ((w[a | 0] | w[a + 1 | 0] << 8 | (w[a + 2 | 0] << 16 | w[a + 3 | 0] << 24)) != 1179340888 | (w[a + 8 | 0] | w[a + 9 | 0] << 8 | (w[a + 10 | 0] << 16 | w[a + 11 | 0] << 24)) != 1213419859) {
   break a;
  }
  b = _b(w[a + 4 | 0] | w[a + 5 | 0] << 8 | (w[a + 6 | 0] << 16 | w[a + 7 | 0] << 24));
  if (!b) {
   break a;
  }
  c = (_b(w[a + 12 | 0] | w[a + 13 | 0] << 8 | (w[a + 14 | 0] << 16 | w[a + 15 | 0] << 24)) | 0) != 0 & b >>> 0 > 27;
 }
 return c;
}

function SI(a) {
 a = a | 0;
 var b = 0, c = 0, d = 0;
 c = a + 12 | 0;
 Tb(c + 520 | 0);
 Tb(c + 508 | 0);
 Tb(c + 496 | 0);
 b = 484;
 Tb(c + 484 | 0);
 while (1) {
  b = b - 12 | 0;
  Tb(b + c | 0);
  d = 460;
  if ((b | 0) != 460) {
   continue;
  }
  break;
 }
 while (1) {
  d = d - 12 | 0;
  Tb(d + c | 0);
  b = 172;
  if ((d | 0) != 172) {
   continue;
  }
  break;
 }
 while (1) {
  b = b - 12 | 0;
  Tb(b + c | 0);
  if ((b | 0) != 4) {
   continue;
  }
  break;
 }
 ct(c);
 return a | 0;
}

function II(a) {
 a = a | 0;
 var b = 0, c = 0, d = 0;
 c = a + 12 | 0;
 sb(c + 520 | 0);
 sb(c + 508 | 0);
 sb(c + 496 | 0);
 b = 484;
 sb(c + 484 | 0);
 while (1) {
  b = b - 12 | 0;
  sb(b + c | 0);
  d = 460;
  if ((b | 0) != 460) {
   continue;
  }
  break;
 }
 while (1) {
  d = d - 12 | 0;
  sb(d + c | 0);
  b = 172;
  if ((d | 0) != 172) {
   continue;
  }
  break;
 }
 while (1) {
  b = b - 12 | 0;
  sb(b + c | 0);
  if ((b | 0) != 4) {
   continue;
  }
  break;
 }
 ct(c);
 return a | 0;
}

function oB(a, b, c) {
 var d = 0;
 d = v[a + 480180 >> 2];
 a: {
  if ((d | 0) != 1048576) {
   if ((d | 0) != 4) {
    break a;
   }
   d = w[b + 813 | 0];
   if (c) {
    t[b + 813 | 0] = d & 15 | c << 4;
    break a;
   }
   c = (d & 240) >>> 4 | 0;
   break a;
  }
  if (c) {
   t[b + 813 | 0] = c;
   break a;
  }
  c = w[b + 813 | 0];
 }
 b: {
  if (!(t[b + 851 | 0] & 1) | !v[b + 700 >> 2]) {
   break b;
  }
  c = c & 255;
  if (!c) {
   break b;
  }
  vk(a, b, b + 700 | 0, c << 2, 0);
 }
}

function Pda(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0;
 v[31601] = 0;
 V(995, a | 0);
 d = v[31601];
 v[31601] = 0;
 if ((d | 0) != 1) {
  v[a + 16 >> 2] = 0;
  v[a + 12 >> 2] = c;
  v[a + 8 >> 2] = b;
  return;
 }
 X(S(0) | 0) | 0;
 v[31601] = 0;
 U(982, 13107, a | 0, 0, 0);
 a = v[31601];
 v[31601] = 0;
 if ((a | 0) != 1) {
  Y();
  return;
 }
 a = M() | 0;
 v[31601] = 0;
 W(26);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  P(a | 0);
  p();
 }
 S(0) | 0;
 Rb();
 p();
}

function t3(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0;
 if (kh(a, v[b + 8 >> 2], 0)) {
  Ux(b, c, d);
  return;
 }
 e = v[a + 12 >> 2];
 f = a + 16 | 0;
 iI(v[f >> 2], v[a + 20 >> 2], b, c, d);
 a: {
  if ((e | 0) < 2) {
   break a;
  }
  e = (e << 3) + f | 0;
  a = a + 24 | 0;
  while (1) {
   iI(v[a >> 2], v[a + 4 >> 2], b, c, d);
   if (w[b + 54 | 0]) {
    break a;
   }
   a = a + 8 | 0;
   if (e >>> 0 > a >>> 0) {
    continue;
   }
   break;
  }
 }
}

function su(a) {
 var b = 0, c = 0, d = 0;
 b = zi(+z[a + 4228 >> 2] * 8) * .25 + -.25;
 A[a + 4248 >> 3] = b;
 if (w[a + 4240 | 0]) {
  if (b > 45e-5) {
   c = mq(b) / .6931471805599453;
   b = c - H(c);
   d = c - b;
   c = 0;
   a: {
    if (b < .2075187496394219) {
     break a;
    }
    c = .4150374992788438;
    if (b < .5) {
     break a;
    }
    c = b < .792481250360578 ? .5849625007211562 : 1;
   }
   b = zi(d + c) * .5;
  } else {
   b = 0;
  }
  A[a + 4248 >> 3] = b;
 }
 ru(a);
}

function lpa(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0;
 if (v[a + 4 >> 2] != v[zb(a) >> 2]) {
  c = eb - 16 | 0;
  eb = c;
  a = Dw(c + 4 | 0, a, 1);
  pX(v[a + 4 >> 2], b);
  v[a + 4 >> 2] = v[a + 4 >> 2] + 20;
  hc(a);
  eb = c + 16 | 0;
  return;
 }
 d = eb - 32 | 0;
 eb = d;
 c = zb(a);
 c = VD(d + 12 | 0, WD(a, Rf(v[a >> 2], v[a + 4 >> 2]) + 1 | 0), Rf(v[a >> 2], v[a + 4 >> 2]), c);
 pX(v[c + 8 >> 2], b);
 v[c + 8 >> 2] = v[c + 8 >> 2] + 20;
 UD(a, c);
 bw(c);
 eb = d + 32 | 0;
}

function ko(a, b, c) {
 var d = 0, e = 0, f = 0;
 a: {
  if (!b) {
   d = a;
   break a;
  }
  while (1) {
   d = Cua(a, b, 10, 0);
   e = gb;
   a = Aua(d, e, 246, 0) + a | 0;
   c = c - 1 | 0;
   t[c | 0] = a | 48;
   f = b >>> 0 > 9;
   a = d;
   b = e;
   if (f) {
    continue;
   }
   break;
  }
 }
 if (d) {
  while (1) {
   c = c - 1 | 0;
   a = (d >>> 0) / 10 | 0;
   t[c | 0] = B(a, 246) + d | 48;
   b = d >>> 0 > 9;
   d = a;
   if (b) {
    continue;
   }
   break;
  }
 }
 return c;
}

function qla(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0;
 if (y[a + 4 >> 2] < y[zb(a) >> 2]) {
  c = eb - 16 | 0;
  eb = c;
  a = nC(c + 4 | 0, a, 1);
  YB(v[a + 4 >> 2], b);
  v[a + 4 >> 2] = v[a + 4 >> 2] + 32;
  hc(a);
  eb = c + 16 | 0;
  return;
 }
 d = eb - 32 | 0;
 eb = d;
 c = zb(a);
 c = jv(d + 12 | 0, Wq(a, Lg(v[a >> 2], v[a + 4 >> 2]) + 1 | 0), Lg(v[a >> 2], v[a + 4 >> 2]), c);
 YB(v[c + 8 >> 2], b);
 v[c + 8 >> 2] = v[c + 8 >> 2] + 32;
 KU(a, c);
 ZB(c);
 eb = d + 32 | 0;
}

function mE(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0;
 if (v[a + 4 >> 2] != v[zb(a) >> 2]) {
  c = eb - 16 | 0;
  eb = c;
  a = q$(c + 4 | 0, a, 1);
  p$(v[a + 4 >> 2], b);
  v[a + 4 >> 2] = v[a + 4 >> 2] + 40;
  hc(a);
  eb = c + 16 | 0;
  return;
 }
 d = eb - 32 | 0;
 eb = d;
 c = zb(a);
 c = n$(d + 12 | 0, o$(a, Br(v[a >> 2], v[a + 4 >> 2]) + 1 | 0), Br(v[a >> 2], v[a + 4 >> 2]), c);
 p$(v[c + 8 >> 2], b);
 v[c + 8 >> 2] = v[c + 8 >> 2] + 40;
 m$(a, c);
 l$(c);
 eb = d + 32 | 0;
}

function jh(a, b) {
 var c = 0, d = 0, e = 0, f = 0;
 d = eb - 16 | 0;
 eb = d;
 a: {
  if (!b) {
   b = 0;
   break a;
  }
  c = b >> 31;
  e = (c ^ b) - c | 0;
  c = E(e);
  _f(d, e, 0, 0, 0, c + 81 | 0);
  e = 0 + v[d + 8 >> 2] | 0;
  c = (v[d + 12 >> 2] ^ 65536) + (16414 - c << 16) | 0;
  c = e >>> 0 < f >>> 0 ? c + 1 | 0 : c;
  f = b & -2147483648 | c;
  c = v[d + 4 >> 2];
  b = v[d >> 2];
 }
 v[a >> 2] = b;
 v[a + 4 >> 2] = c;
 v[a + 8 >> 2] = e;
 v[a + 12 >> 2] = f;
 eb = d + 16 | 0;
}

function Xsa(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0;
 if (y[a + 4 >> 2] < y[zb(a) >> 2]) {
  c = eb - 16 | 0;
  eb = c;
  a = Dw(c + 4 | 0, a, 1);
  XD(v[a + 4 >> 2], b);
  v[a + 4 >> 2] = v[a + 4 >> 2] + 20;
  hc(a);
  eb = c + 16 | 0;
  return;
 }
 d = eb - 32 | 0;
 eb = d;
 c = zb(a);
 c = VD(d + 12 | 0, WD(a, Rf(v[a >> 2], v[a + 4 >> 2]) + 1 | 0), Rf(v[a >> 2], v[a + 4 >> 2]), c);
 XD(v[c + 8 >> 2], b);
 v[c + 8 >> 2] = v[c + 8 >> 2] + 20;
 UD(a, c);
 bw(c);
 eb = d + 32 | 0;
}

function yQ(a) {
 a = a | 0;
 var b = 0, c = 0;
 c = eb - 16 | 0;
 eb = c;
 b = v[a + 4232 >> 2];
 b = (b >>> 1) + (b >>> 6) | 0;
 v[a + 4220 >> 2] = b;
 v[31601] = 0;
 v[c + 12 >> 2] = 0;
 R(946, a + 4208 | 0, b << 1, c + 12 | 0);
 b = v[31601];
 v[31601] = 0;
 a: {
  if ((b | 0) == 1) {
   b = S(124508) | 0;
   if ((fb | 0) != (_(124508) | 0)) {
    break a;
   }
   X(b | 0) | 0;
   v[a + 4220 >> 2] = 0;
   Y();
  }
  v[a + 4224 >> 2] = 0;
  eb = c + 16 | 0;
  return;
 }
 P(b | 0);
 p();
}

function eB(a, b, c, d) {
 a: {
  if (v[a + 1074392 >> 2] != (c | 0)) {
   break a;
  }
  c = (B(b, 872) + a | 0) + 1074992 | 0;
  b: {
   if (d) {
    v[c + 696 >> 2] = 0;
    v[c + 8 >> 2] = 0;
    v[c + 12 >> 2] = 0;
    d = v[c + 88 >> 2] | 4096;
    break b;
   }
   v[c + 688 >> 2] = 0;
   d = v[c + 88 >> 2];
  }
  v[c + 88 >> 2] = d | 2097152;
  Wm(a, b, 255, 0);
  if (!(w[c + 89 | 0] & 2)) {
   break a;
  }
  a = v[a + 1298300 >> 2];
  if (!Dd(a)) {
   break a;
  }
  Dj(a, b, 0);
 }
}

function bl(a, b, c, d, e, f) {
 var g = 0, h = 0, i = 0, j = 0;
 h = eb - 16 | 0;
 eb = h;
 v[h + 8 >> 2] = a;
 v[h + 12 >> 2] = b;
 j = v[a + 8 >> 2] + 120 | 0;
 cu(w[j + 20 | 0]);
 i = eb - 16 | 0;
 eb = i;
 v[i + 12 >> 2] = h + 8;
 g = eb - 16 | 0;
 eb = g;
 v[g + 12 >> 2] = f;
 v[g + 8 >> 2] = e;
 v[g + 4 >> 2] = d;
 v[g >> 2] = c;
 hb[v[lq(g, rk(w[j + 20 | 0])) >> 2]](i + 12 | 0, j);
 eb = g + 16 | 0;
 eb = i + 16 | 0;
 v[a + 4 >> 2] = v[a + 4 >> 2] + v[b + 8 >> 2];
 eb = h + 16 | 0;
}

function Xja(a) {
 a = a | 0;
 var b = 0, c = 0, d = 0, e = 0, f = 0, g = 0;
 b = eb - 16 | 0;
 eb = b;
 u[a >> 1] = 0;
 c = Mb(a + 4 | 0);
 d = Mb(a + 16 | 0);
 v[a + 32 >> 2] = 0;
 v[a + 36 >> 2] = 0;
 v[a + 28 >> 2] = 65472;
 e = Eb(a + 40 | 0);
 f = ng(a + 52 | 0);
 v[31601] = 0;
 v[b + 12 >> 2] = 1065353216;
 N(878, c | 0, b + 12 | 0);
 g = v[31601];
 v[31601] = 0;
 if ((g | 0) != 1) {
  eb = b + 16 | 0;
  return a | 0;
 }
 a = M() | 0;
 qZ(f);
 sb(e);
 uc(d);
 uc(c);
 P(a | 0);
 p();
}

function voa(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0;
 if (v[a + 4 >> 2] != v[zb(a) >> 2]) {
  c = eb - 16 | 0;
  eb = c;
  a = Cx(c + 4 | 0, a);
  yC(v[a + 4 >> 2], b);
  v[a + 4 >> 2] = v[a + 4 >> 2] + 12;
  hc(a);
  eb = c + 16 | 0;
  return;
 }
 d = eb - 32 | 0;
 eb = d;
 c = zb(a);
 c = wm(d + 12 | 0, Qp(a, Td(v[a >> 2], v[a + 4 >> 2]) + 1 | 0), Td(v[a >> 2], v[a + 4 >> 2]), c);
 yC(v[c + 8 >> 2], b);
 v[c + 8 >> 2] = v[c + 8 >> 2] + 12;
 qW(a, c);
 pW(c);
 eb = d + 32 | 0;
}

function vna(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0;
 d = eb - 32 | 0;
 eb = d;
 v[d + 28 >> 2] = c;
 v[d + 8 >> 2] = 4896;
 e = v[a >> 2];
 f = v[a + 8 >> 2];
 c = v[Gb(d + 28 | 0, d + 8 | 0) >> 2];
 if (!Lb(e, f, c)) {
  c = jf(a);
 }
 e = d + 8 | 0;
 qD(e, b);
 f = Yb(d + 16 | 0, v[d + 8 >> 2], c);
 ic(d, v[a >> 2], v[a + 8 >> 2], v[f >> 2], v[f + 4 >> 2]);
 qD(e, b);
 Qb(v[d + 8 >> 2] + c | 0, 0, 4896 - c | 0);
 Ub(a, v[d + 28 >> 2]);
 eb = d + 32 | 0;
}

function pB(a, b, c) {
 var d = 0;
 d = v[a + 480180 >> 2];
 a: {
  if ((d | 0) != 1048576) {
   if ((d | 0) != 4) {
    break a;
   }
   d = w[b + 814 | 0];
   if (c) {
    t[b + 814 | 0] = d & 15 | c << 4;
    break a;
   }
   c = (d & 240) >>> 4 | 0;
   break a;
  }
  if (c) {
   t[b + 813 | 0] = c;
   break a;
  }
  c = w[b + 813 | 0];
 }
 b: {
  if (!(t[b + 851 | 0] & 1) | !v[b + 700 >> 2]) {
   break b;
  }
  c = c & 255;
  if (!c) {
   break b;
  }
  vk(a, b, b + 700 | 0, c, 0);
 }
}

function dja(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0;
 d = eb - 16 | 0;
 eb = d;
 c = Hf(a, c);
 $d(d, v[a + 36 >> 2]);
 a: {
  b: {
   if (!c) {
    Pc(d, a + 32 | 0, 5);
    e = -1;
    if (!Fb(v[v[d >> 2] >> 2], v[d + 4 >> 2])) {
     break b;
    }
    break a;
   }
   e = v[c + 16 >> 2];
  }
  f = v[a + 36 >> 2];
  c: {
   if (!((e | 0) != 4 & (e | 0) != -1)) {
    Ek(f, b);
    break c;
   }
   AN(f, b, e);
  }
  f = c;
 }
 ef(a, f);
 eb = d + 16 | 0;
}

function y1(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0;
 if (y[a + 4 >> 2] < y[zb(a) >> 2]) {
  c = eb - 16 | 0;
  eb = c;
  a = nG(c + 4 | 0, a);
  gx(v[a + 4 >> 2], b);
  v[a + 4 >> 2] = v[a + 4 >> 2] + 36;
  hc(a);
  eb = c + 16 | 0;
  return;
 }
 d = eb - 32 | 0;
 eb = d;
 c = zb(a);
 c = lG(d + 12 | 0, mG(a, fs(v[a >> 2], v[a + 4 >> 2]) + 1 | 0), fs(v[a >> 2], v[a + 4 >> 2]), c);
 gx(v[c + 8 >> 2], b);
 v[c + 8 >> 2] = v[c + 8 >> 2] + 36;
 kG(a, c);
 ix(c);
 eb = d + 32 | 0;
}

function ssa(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0;
 d = eb - 32 | 0;
 eb = d;
 v[d + 28 >> 2] = c;
 v[d + 8 >> 2] = 102;
 e = v[a >> 2];
 f = v[a + 8 >> 2];
 c = v[Gb(d + 28 | 0, d + 8 | 0) >> 2];
 if (!Lb(e, f, c)) {
  c = jf(a);
 }
 e = d + 8 | 0;
 UZ(e, b);
 f = Yb(d + 16 | 0, v[d + 8 >> 2], c);
 ic(d, v[a >> 2], v[a + 8 >> 2], v[f >> 2], v[f + 4 >> 2]);
 UZ(e, b);
 Qb(v[d + 8 >> 2] + c | 0, 0, 102 - c | 0);
 Ub(a, v[d + 28 >> 2]);
 eb = d + 32 | 0;
}

function haa(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0;
 a: {
  if (w[b + 40 | 0]) {
   break a;
  }
  b: {
   if (!v[b + 28 >> 2]) {
    break b;
   }
   d = v[c + 4 >> 2];
   f = v[c >> 2];
   while (1) {
    if (!d) {
     break a;
    }
    e = hb[v[b + 28 >> 2]](v[b + 24 >> 2], f, d) | 0;
    if (!e) {
     break b;
    }
    g = e + g | 0;
    d = d - e | 0;
    f = f + e | 0;
    continue;
   }
  }
  t[b + 40 | 0] = 1;
 }
 ac(a, v[c >> 2], g);
}

function Dna(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0;
 d = eb - 32 | 0;
 eb = d;
 v[d + 28 >> 2] = c;
 v[d + 8 >> 2] = 263;
 e = v[a >> 2];
 f = v[a + 8 >> 2];
 c = v[Gb(d + 28 | 0, d + 8 | 0) >> 2];
 if (!Lb(e, f, c)) {
  c = jf(a);
 }
 e = d + 8 | 0;
 sV(e, b);
 f = Yb(d + 16 | 0, v[d + 8 >> 2], c);
 ic(d, v[a >> 2], v[a + 8 >> 2], v[f >> 2], v[f + 4 >> 2]);
 sV(e, b);
 Qb(v[d + 8 >> 2] + c | 0, 0, 263 - c | 0);
 Ub(a, v[d + 28 >> 2]);
 eb = d + 32 | 0;
}

function LB(a, b, c, d) {
 var e = 0, f = 0, g = 0;
 e = ce(a);
 a: {
  if (e) {
   f = fc(a);
   while (1) {
    a = e;
    e = x[a + 16 >> 1];
    g = v[a + 20 >> 2];
    if (Ml(c, d, e, g)) {
     f = a;
     e = v[a >> 2];
     if (e) {
      continue;
     }
     break a;
    }
    if (!Ml(e, g, c, d)) {
     break a;
    }
    f = a + 4 | 0;
    e = v[a + 4 >> 2];
    if (e) {
     continue;
    }
    break;
   }
   break a;
  }
  a = fc(a);
  f = a;
 }
 v[b >> 2] = a;
 return f;
}

function gB(a, b, c, d) {
 var e = 0, f = 0, g = 0;
 e = ce(a);
 a: {
  if (e) {
   f = fc(a);
   while (1) {
    a = e;
    e = w[a + 16 | 0];
    g = v[a + 20 >> 2];
    if (Ao(c, d, e, g)) {
     f = a;
     e = v[a >> 2];
     if (e) {
      continue;
     }
     break a;
    }
    if (!Ao(e, g, c, d)) {
     break a;
    }
    f = a + 4 | 0;
    e = v[a + 4 >> 2];
    if (e) {
     continue;
    }
    break;
   }
   break a;
  }
  a = fc(a);
  f = a;
 }
 v[b >> 2] = a;
 return f;
}

function Lqa(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0;
 d = eb - 32 | 0;
 eb = d;
 v[d + 28 >> 2] = c;
 v[d + 8 >> 2] = 22;
 e = v[a >> 2];
 f = v[a + 8 >> 2];
 c = v[Gb(d + 28 | 0, d + 8 | 0) >> 2];
 if (!Lb(e, f, c)) {
  c = jf(a);
 }
 e = d + 8 | 0;
 cw(e, b);
 f = Yb(d + 16 | 0, v[d + 8 >> 2], c);
 ic(d, v[a >> 2], v[a + 8 >> 2], v[f >> 2], v[f + 4 >> 2]);
 cw(e, b);
 Qb(v[d + 8 >> 2] + c | 0, 0, 22 - c | 0);
 Ub(a, v[d + 28 >> 2]);
 eb = d + 32 | 0;
}

function Jqa(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0;
 d = eb - 32 | 0;
 eb = d;
 v[d + 28 >> 2] = c;
 v[d + 8 >> 2] = 40;
 e = v[a >> 2];
 f = v[a + 8 >> 2];
 c = v[Gb(d + 28 | 0, d + 8 | 0) >> 2];
 if (!Lb(e, f, c)) {
  c = jf(a);
 }
 e = d + 8 | 0;
 hD(e, b);
 f = Yb(d + 16 | 0, v[d + 8 >> 2], c);
 ic(d, v[a >> 2], v[a + 8 >> 2], v[f >> 2], v[f + 4 >> 2]);
 hD(e, b);
 Qb(v[d + 8 >> 2] + c | 0, 0, 40 - c | 0);
 Ub(a, v[d + 28 >> 2]);
 eb = d + 32 | 0;
}

function eo(a, b) {
 var c = 0, d = 0, e = 0;
 d = -1;
 a: {
  if ((a | 0) == -1) {
   break a;
  }
  e = v[b + 76 >> 2] < 0;
  b: {
   c = v[b + 4 >> 2];
   c: {
    if (!c) {
     At(b);
     c = v[b + 4 >> 2];
     if (!c) {
      break c;
     }
    }
    if (v[b + 44 >> 2] - 8 >>> 0 < c >>> 0) {
     break b;
    }
   }
   if (e) {
    break a;
   }
   return -1;
  }
  c = c - 1 | 0;
  v[b + 4 >> 2] = c;
  t[c | 0] = a;
  v[b >> 2] = v[b >> 2] & -17;
  d = a & 255;
 }
 return d;
}

function ZN(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0;
 b = eb - 16 | 0;
 eb = b;
 v[a + 4 >> 2] = 0;
 v[a >> 2] = 47556;
 a = cc(8);
 v[31601] = 0;
 b = O(36, b + 4 | 0, 12133) | 0;
 c = v[31601];
 v[31601] = 0;
 a: {
  b: {
   if ((c | 0) != 1) {
    rc(a, b);
    v[31601] = 0;
    R(97, a | 0, 48396, 999);
    a = v[31601];
    v[31601] = 0;
    if ((a | 0) != 1) {
     break a;
    }
    c = M() | 0;
    sb(b);
    break b;
   }
   c = M() | 0;
   jc(a);
  }
  P(c | 0);
 }
 p();
}

function W0(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0;
 d = eb - 32 | 0;
 eb = d;
 v[d + 28 >> 2] = c;
 v[d + 8 >> 2] = 65;
 e = v[a >> 2];
 f = v[a + 8 >> 2];
 c = v[Gb(d + 28 | 0, d + 8 | 0) >> 2];
 if (!Lb(e, f, c)) {
  c = jf(a);
 }
 e = d + 8 | 0;
 Cw(e, b);
 f = Yb(d + 16 | 0, v[d + 8 >> 2], c);
 ic(d, v[a >> 2], v[a + 8 >> 2], v[f >> 2], v[f + 4 >> 2]);
 Cw(e, b);
 Qb(v[d + 8 >> 2] + c | 0, 0, 65 - c | 0);
 Ub(a, v[d + 28 >> 2]);
 eb = d + 32 | 0;
}

function Lu(a, b, c, d) {
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0, k = 0;
 a: {
  if (!b) {
   break a;
  }
  i = Nb(a + 1074312 | 0, 73) ? c - -64 | 0 : c;
  c = 120;
  g = yj(a);
  j = g ^ -1;
  e = 1;
  while (1) {
   if (!c) {
    break a;
   }
   k = c;
   c = c >>> 1 | 0;
   h = e + c | 0;
   f = yh(a, h, i, d);
   if (!(f >>> 0 > b >>> 0 & j) & (!(!f | g) | b >>> 0 <= f >>> 0)) {
    continue;
   }
   e = h + 1 | 0;
   c = (c ^ -1) + k | 0;
   continue;
  }
 }
 return e;
}

function Isa(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0;
 d = eb - 32 | 0;
 eb = d;
 v[d + 28 >> 2] = c;
 v[d + 8 >> 2] = 5;
 e = v[a >> 2];
 f = v[a + 8 >> 2];
 c = v[Gb(d + 28 | 0, d + 8 | 0) >> 2];
 if (!Lb(e, f, c)) {
  c = jf(a);
 }
 e = d + 8 | 0;
 Zj(e, b);
 f = Yb(d + 16 | 0, v[d + 8 >> 2], c);
 ic(d, v[a >> 2], v[a + 8 >> 2], v[f >> 2], v[f + 4 >> 2]);
 Zj(e, b);
 Qb(v[d + 8 >> 2] + c | 0, 0, 5 - c | 0);
 Ub(a, v[d + 28 >> 2]);
 eb = d + 32 | 0;
}

function FX(a) {
 var b = 0;
 a: {
  if ((w[a | 0] | w[a + 1 | 0] << 8 | (w[a + 2 | 0] << 16 | w[a + 3 | 0] << 24)) != 808604749 | ((w[a + 8 | 0] | w[a + 9 | 0] << 8) - 768 & 65535) >>> 0 < 65280 | (((w[a + 112 | 0] | w[a + 113 | 0] << 8) - 65 & 65535) >>> 0 < 65472 | (w[a + 106 | 0] | w[a + 107 | 0] << 8) >>> 0 > 256)) {
   break a;
  }
  if ((w[a + 122 | 0] | w[a + 123 | 0] << 8) >>> 0 > 255) {
   break a;
  }
  b = (w[a + 124 | 0] | w[a + 125 | 0] << 8) >>> 0 < 4e3;
 }
 return b;
}

function u8(a, b, c, d, e) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 var f = 0, g = 0;
 a: {
  while (1) {
   if ((d | 0) != (e | 0)) {
    a = -1;
    if ((b | 0) == (c | 0)) {
     break a;
    }
    f = v[b >> 2];
    g = v[d >> 2];
    if ((f | 0) < (g | 0)) {
     break a;
    }
    if ((f | 0) > (g | 0)) {
     return 1;
    } else {
     d = d + 4 | 0;
     b = b + 4 | 0;
     continue;
    }
   }
   break;
  }
  a = (b | 0) != (c | 0);
 }
 return a | 0;
}

function toa(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0;
 d = eb - 16 | 0;
 eb = d;
 c = eb - 16 | 0;
 eb = c;
 v[c + 12 >> 2] = 477218588;
 v[c + 8 >> 2] = 2147483647;
 e = Gb(c + 12 | 0, c + 8 | 0);
 eb = c + 16 | 0;
 if (y[e >> 2] < b >>> 0) {
  dd();
  p();
 }
 c = Dc(B(b, 9));
 v[d + 12 >> 2] = b;
 v[d + 8 >> 2] = c;
 b = v[d + 8 >> 2];
 v[a + 4 >> 2] = b;
 v[a >> 2] = b;
 f = zb(a), g = b + B(v[d + 12 >> 2], 9) | 0, v[f >> 2] = g;
 eb = d + 16 | 0;
}

function tia(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0;
 a: {
  b: {
   c = v[a + 20 >> 2];
   b = v[c + 4 >> 2];
   if ((Sc(b, v[c + 8 >> 2]) | 0) != 8) {
    break b;
   }
   d = w[b | 0] | w[b + 1 | 0] << 8 | (w[b + 2 | 0] << 16 | w[b + 3 | 0] << 24);
   if ((d | 0) != 1869112133) {
    break b;
   }
   c = w[b + 4 | 0] | w[b + 5 | 0] << 8 | (w[b + 6 | 0] << 16 | w[b + 7 | 0] << 24);
   v[a + 4260 >> 2] = d;
   v[a + 4264 >> 2] = c;
   break a;
  }
  cA(a, a);
 }
 tu(a);
}

function jU(a, b, c) {
 var d = 0, e = 0, f = 0, g = 0;
 if (c == 0) {
  e = a;
  b = Qt(b);
  o(0);
  a = j(1) | 0;
  f = j(0) | 0;
  o(+c);
  d = j(1) | 0;
  j(0) | 0;
  l(0, f | 0);
  l(1, a & 2147483647 | d & -2147483648);
  Nl(e, b, +n());
  return;
 }
 a: {
  if (!zf(b)) {
   break a;
  }
  d = D(c) < Infinity;
  if (b < 0) {
   c = d ? c : 1;
   break a;
  }
  if (d) {
   break a;
  }
  Nl(a, b, zf(c) ? NaN : c);
  return;
 }
 b = Qt(b);
 g = Oi(c);
 Nl(a, b * hf(c), g * b);
}

function cua(a) {
 a = a | 0;
 var b = 0, c = 0, d = 0;
 c = eb - 32 | 0;
 eb = c;
 b = 255;
 a: {
  if (Fj(v[a >> 2], v[a + 4 >> 2]) >>> 0 <= 49) {
   b = cC(c, v[a + 12 >> 2]);
   v[31601] = 0;
   N(291, a | 0, b | 0);
   d = v[31601];
   v[31601] = 0;
   if ((d | 0) == 1) {
    break a;
   }
   zk(b);
   Vj(a, Fj(v[a >> 2], v[a + 4 >> 2]) - 1 & 255);
   b = Fj(v[a >> 2], v[a + 4 >> 2]) - 1 | 0;
  }
  eb = c + 32 | 0;
  return b & 255;
 }
 a = M() | 0;
 zk(b);
 P(a | 0);
 p();
}

function ux(a) {
 t[a | 0] = 0;
 t[a + 1 | 0] = 0;
 t[a + 2 | 0] = 0;
 t[a + 3 | 0] = 0;
 t[a + 4 | 0] = 0;
 t[a + 5 | 0] = 0;
 t[a + 6 | 0] = 0;
 t[a + 7 | 0] = 0;
 t[a + 16 | 0] = 0;
 t[a + 17 | 0] = 0;
 t[a + 18 | 0] = 0;
 t[a + 19 | 0] = 0;
 t[a + 20 | 0] = 0;
 t[a + 21 | 0] = 0;
 t[a + 22 | 0] = 0;
 t[a + 23 | 0] = 0;
 t[a + 8 | 0] = 0;
 t[a + 9 | 0] = 0;
 t[a + 10 | 0] = 0;
 t[a + 11 | 0] = 0;
 t[a + 12 | 0] = 0;
 t[a + 13 | 0] = 0;
 t[a + 14 | 0] = 0;
 t[a + 15 | 0] = 0;
}

function rt(a, b, c, d) {
 var e = 0, f = 0, g = 0;
 e = eb - 160 | 0;
 eb = e;
 f = b ? a : e + 158 | 0;
 v[e + 148 >> 2] = f;
 a = -1;
 g = b - 1 | 0;
 v[e + 152 >> 2] = b >>> 0 >= g >>> 0 ? g : 0;
 e = Qb(e, 0, 144);
 v[e + 76 >> 2] = -1;
 v[e + 36 >> 2] = 1265;
 v[e + 80 >> 2] = -1;
 v[e + 44 >> 2] = e + 159;
 v[e + 84 >> 2] = e + 148;
 a: {
  if ((b | 0) < 0) {
   v[31476] = 61;
   break a;
  }
  t[f | 0] = 0;
  a = tL(e, c, d, 1217, 1218);
 }
 eb = e + 160 | 0;
 return a;
}

function SP(a) {
 var b = 0, c = C(0), d = 0, e = 0;
 e = v[v[a + 16 >> 2] + 24620 >> 2];
 b = eb - 16 | 0;
 eb = b;
 v[b + 12 >> 2] = 0;
 v[b + 8 >> 2] = 1065353216;
 c = ki(C(z[Sv(a + 4208 | 0, b + 12 | 0, b + 8 | 0) >> 2] * C(999)));
 a: {
  if (c < C(4294967296) & c >= C(0)) {
   d = ~~c >>> 0;
   break a;
  }
  d = 0;
 }
 eb = b + 16 | 0;
 b = (e >>> 0) / (d + 1 >>> 0) | 0;
 b = b >>> 0 <= 2 ? 2 : b;
 v[a + 4216 >> 2] = b;
 v[a + 4220 >> 2] = b >>> 1;
 wc(a + 4224 | 0, b);
}

function L_(a) {
 t[a | 0] = 0;
 t[a + 1 | 0] = 0;
 t[a + 2 | 0] = 0;
 t[a + 3 | 0] = 0;
 t[a + 4 | 0] = 0;
 t[a + 5 | 0] = 0;
 t[a + 6 | 0] = 0;
 t[a + 7 | 0] = 0;
 t[a + 14 | 0] = 0;
 t[a + 15 | 0] = 0;
 t[a + 16 | 0] = 0;
 t[a + 17 | 0] = 0;
 t[a + 18 | 0] = 0;
 t[a + 19 | 0] = 0;
 t[a + 20 | 0] = 0;
 t[a + 21 | 0] = 0;
 t[a + 8 | 0] = 0;
 t[a + 9 | 0] = 0;
 t[a + 10 | 0] = 0;
 t[a + 11 | 0] = 0;
 t[a + 12 | 0] = 0;
 t[a + 13 | 0] = 0;
 t[a + 14 | 0] = 0;
 t[a + 15 | 0] = 0;
}

function Oda(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0;
 v[31601] = 0;
 V(995, a | 0);
 d = v[31601];
 v[31601] = 0;
 if ((d | 0) != 1) {
  v[a + 4 >> 2] = c;
  v[a >> 2] = b ? b : 976;
  return;
 }
 X(S(0) | 0) | 0;
 v[31601] = 0;
 U(982, 13137, a | 0, 0, 0);
 a = v[31601];
 v[31601] = 0;
 if ((a | 0) != 1) {
  Y();
  return;
 }
 a = M() | 0;
 v[31601] = 0;
 W(26);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  P(a | 0);
  p();
 }
 S(0) | 0;
 Rb();
 p();
}

function pka(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0;
 e = b + 616 | 0;
 c = yc(a, b, 614);
 f = c + 616 | 0;
 a = 0;
 while (1) {
  d = B(a, 872);
  Gq(d + f | 0, e + d | 0);
  a = a + 1 | 0;
  if ((a | 0) != 256) {
   continue;
  }
  break;
 }
 a = DC(c + 223848 | 0, b + 223848 | 0);
 v[31601] = 0;
 O(842, c + 223860 | 0, b + 223860 | 0) | 0;
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  return c | 0;
 }
 b = M() | 0;
 ec(a);
 P(b | 0);
 p();
}

function pP(a, b) {
 var c = 0, d = 0, e = 0, f = 0;
 c = eb - 96 | 0;
 eb = c;
 xQ(b, c, c + 96 | 0);
 b = 0;
 while (1) {
  if ((b | 0) == 12) {
   v[a + 104 >> 2] = 0;
   v[a + 96 >> 2] = !(v[a + 88 >> 2] | v[a + 92 >> 2]);
   v[a + 100 >> 2] = 0;
   eb = c + 96 | 0;
  } else {
   d = b << 3;
   e = d + a | 0;
   f = c + d | 0;
   d = v[f + 4 >> 2];
   v[e >> 2] = v[f >> 2];
   v[e + 4 >> 2] = d & 65535;
   b = b + 1 | 0;
   continue;
  }
  break;
 }
 v[a + 112 >> 2] = 0;
}

function nka(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0;
 a: {
  if (Hd(w[b + 24 | 0])) {
   a = ng(a);
   c = Si(v[b >> 2]);
   d = Of(b);
   v[31601] = 0;
   R(845, a | 0, c | 0, d | 0);
   c = v[31601];
   v[31601] = 0;
   if ((c | 0) == 1) {
    break a;
   }
   v[31601] = 0;
   O(844, a + 12 | 0, b + 12 | 0) | 0;
   b = v[31601];
   v[31601] = 0;
   if ((b | 0) == 1) {
    break a;
   }
   t[a + 24 | 0] = 1;
  }
  return;
 }
 b = M() | 0;
 US(a);
 P(b | 0);
 p();
}

function cq(a, b) {
 var c = 0, d = 0, e = 0;
 c = eb - 16 | 0;
 eb = c;
 d = c + 12 | 0;
 bd(d, a);
 v[31601] = 0;
 a = Q(1251, v[c + 12 >> 2]) | 0;
 e = v[31601];
 v[31601] = 0;
 a: {
  b: {
   if ((e | 0) == 1) {
    break b;
   }
   v[31601] = 0;
   U(1262, a | 0, 95136, 95162, b | 0);
   a = v[31601];
   v[31601] = 0;
   if ((a | 0) == 1) {
    break b;
   }
   Zb(d);
   eb = c + 16 | 0;
   break a;
  }
  a = M() | 0;
  Zb(c + 12 | 0);
  P(a | 0);
  p();
 }
 return b;
}

function K0(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0;
 d = eb - 16 | 0;
 eb = d;
 v[d + 12 >> 2] = c;
 a: {
  if (!Lb(v[b >> 2], v[b + 8 >> 2], c << 1)) {
   break a;
  }
  wc(d + 12 | 0, 65535);
  ug(a, x[d + 12 >> 1]);
  c = vb(v[a >> 2]);
  v[d + 4 >> 2] = c;
  a = vb(v[a + 4 >> 2]);
  while (1) {
   if (!Hb(c, a)) {
    break a;
   }
   ww(b, d + 10 | 0);
   u[c >> 1] = x[d + 10 >> 1];
   c = v[fe(d + 4 | 0) >> 2];
   continue;
  }
 }
 eb = d + 16 | 0;
}

function fga(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0;
 a = Ii(a, b, c, d);
 v[a >> 2] = 45644;
 b = a + 4208 | 0;
 e = xb(b, 0), f = 1065353216, v[e >> 2] = f;
 e = xb(b, 1), f = 1065353216, v[e >> 2] = f;
 e = xb(b, 2), f = 1051372203, v[e >> 2] = f;
 e = xb(b, 3), f = 0, v[e >> 2] = f;
 v[31601] = 0;
 N(940, a + 44 | 0, 2);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  return a | 0;
 }
 b = M() | 0;
 Zf(a);
 P(b | 0);
 p();
}

function lr(a) {
 var b = 0, c = 0;
 b = eb - 32 | 0;
 eb = b;
 v[b + 24 >> 2] = 0;
 v[b + 28 >> 2] = 0;
 v[b + 16 >> 2] = 0;
 v[b + 20 >> 2] = 0;
 v[b + 8 >> 2] = 0;
 v[b + 12 >> 2] = 0;
 v[b >> 2] = 0;
 v[b + 4 >> 2] = 0;
 c = a + 288 | 0;
 jC(c, mV(c), b);
 v[b + 24 >> 2] = 0;
 v[b + 28 >> 2] = 0;
 v[b + 16 >> 2] = 0;
 v[b + 20 >> 2] = 0;
 v[b + 8 >> 2] = 0;
 v[b + 12 >> 2] = 0;
 v[b >> 2] = 0;
 v[b + 4 >> 2] = 0;
 a = a + 800 | 0;
 jC(a, xC(a), b);
 eb = b + 32 | 0;
}

function SQ(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0;
 d = eb - 16 | 0;
 eb = d;
 v[d + 12 >> 2] = b;
 a: {
  if (Ug(a) >>> 0 >= b >>> 0) {
   f = v[a >> 2];
   e = nc(f, v[a + 4 >> 2]);
   v[d + 8 >> 2] = e;
   RQ(f, v[Gb(d + 12 | 0, d + 8 | 0) >> 2], c);
   if (b >>> 0 > e >>> 0) {
    pA(a, b - e | 0, c);
    break a;
   }
   Id(a, v[a >> 2] + (b << 2) | 0);
   break a;
  }
  qr(a);
  hm(a, Kf(a, b));
  pA(a, b, c);
 }
 eb = d + 16 | 0;
}

function Hpa(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0;
 d = eb - 16 | 0;
 eb = d;
 v[a >> 2] = 0;
 v[a + 4 >> 2] = 0;
 sc(a + 8 | 0);
 Qd(d + 8 | 0, v[ub(d + 4 | 0, a) >> 2]);
 a: {
  if (b) {
   v[31601] = 0;
   N(640, a | 0, b | 0);
   e = v[31601];
   v[31601] = 0;
   if ((e | 0) == 1) {
    break a;
   }
   tp(a, b, c);
  }
  b = d + 8 | 0;
  Pd(b);
  Rj(b);
  eb = d + 16 | 0;
  return a | 0;
 }
 a = M() | 0;
 Rj(d + 8 | 0);
 P(a | 0);
 p();
}

function rla(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0;
 d = eb - 16 | 0;
 eb = d;
 a = IV(d + 4 | 0, a + 8 | 0, b);
 b = v[a >> 2];
 a: {
  while (1) {
   if (v[a + 4 >> 2] == (b | 0)) {
    break a;
   }
   v[31601] = 0;
   N(783, b | 0, c | 0);
   b = v[31601];
   v[31601] = 0;
   if ((b | 0) != 1) {
    b = v[a >> 2] + 32 | 0;
    v[a >> 2] = b;
    continue;
   }
   break;
  }
  b = M() | 0;
  ie(a);
  P(b | 0);
  p();
 }
 ie(a);
 eb = d + 16 | 0;
}

function kE(a, b, c, d, e) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 var f = 0, g = 0, h = 0;
 f = eb - 32 | 0;
 eb = f;
 v[f + 8 >> 2] = c;
 g = f, h = jf(b), v[g + 28 >> 2] = h;
 c = f + 8 | 0;
 rg(c, b, v[Gb(c, f + 28 | 0) >> 2]);
 b = Ze(c);
 v[31601] = 0;
 $(236, a | 0, b | 0, v[f + 8 >> 2], d | 0, e | 0);
 a = v[31601];
 v[31601] = 0;
 if ((a | 0) != 1) {
  Jc(c);
  eb = f + 32 | 0;
  return;
 }
 a = M() | 0;
 Jc(f + 8 | 0);
 P(a | 0);
 p();
}

function CZ(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0;
 d = eb - 16 | 0;
 eb = d;
 v[a >> 2] = 0;
 v[a + 4 >> 2] = 0;
 sc(a + 8 | 0);
 Qd(d + 8 | 0, v[ub(d + 4 | 0, a) >> 2]);
 a: {
  if (b) {
   v[31601] = 0;
   N(460, a | 0, b | 0);
   e = v[31601];
   v[31601] = 0;
   if ((e | 0) == 1) {
    break a;
   }
   yD(a, b, c);
  }
  b = d + 8 | 0;
  Pd(b);
  _l(b);
  eb = d + 16 | 0;
  return a | 0;
 }
 a = M() | 0;
 _l(d + 8 | 0);
 P(a | 0);
 p();
}

function $0(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0;
 d = eb - 16 | 0;
 eb = d;
 v[a >> 2] = 0;
 v[a + 4 >> 2] = 0;
 sc(a + 8 | 0);
 Qd(d + 8 | 0, v[ub(d + 4 | 0, a) >> 2]);
 a: {
  if (b) {
   v[31601] = 0;
   N(225, a | 0, b | 0);
   e = v[31601];
   v[31601] = 0;
   if ((e | 0) == 1) {
    break a;
   }
   XE(a, b, c);
  }
  b = d + 8 | 0;
  Pd(b);
  ah(b);
  eb = d + 16 | 0;
  return a | 0;
 }
 a = M() | 0;
 ah(d + 8 | 0);
 P(a | 0);
 p();
}

function mga(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0;
 a = Ii(a, b, c, d);
 v[a + 4272 >> 2] = 1065353216;
 v[a >> 2] = 45408;
 b = a + 4208 | 0;
 e = xb(b, 0), f = 1056880300, v[e >> 2] = f;
 e = xb(b, 1), f = 1050733080, v[e >> 2] = f;
 e = xb(b, 2), f = 1056964608, v[e >> 2] = f;
 v[31601] = 0;
 N(940, a + 44 | 0, 2);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  return a | 0;
 }
 b = M() | 0;
 Zf(a);
 P(b | 0);
 p();
}

function P_(a, b, c) {
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0;
 d = eb - 16 | 0;
 eb = d;
 e = v[b + 4 >> 2];
 f = ub(d + 12 | 0, c);
 g = ub(d + 8 | 0, v[a >> 2]);
 h = ub(d + 4 | 0, v[b + 4 >> 2]);
 i = b, j = PW(v[f >> 2], v[g >> 2], v[h >> 2]), v[i + 4 >> 2] = j;
 i = b, j = O_(c, v[a + 4 >> 2], v[b + 8 >> 2]), v[i + 8 >> 2] = j;
 Sb(a, b + 4 | 0);
 Sb(a + 4 | 0, b + 8 | 0);
 Sb(zb(a), mc(b));
 v[b >> 2] = v[b + 4 >> 2];
 eb = d + 16 | 0;
 return e;
}

function PU(a, b, c) {
 var d = 0, e = 0, f = 0, g = 0, h = 0, i = 0, j = 0;
 d = eb - 16 | 0;
 eb = d;
 e = v[b + 4 >> 2];
 f = ub(d + 12 | 0, c);
 g = ub(d + 8 | 0, v[a >> 2]);
 h = ub(d + 4 | 0, v[b + 4 >> 2]);
 i = b, j = NF(v[f >> 2], v[g >> 2], v[h >> 2]), v[i + 4 >> 2] = j;
 i = b, j = SU(c, v[a + 4 >> 2], v[b + 8 >> 2]), v[i + 8 >> 2] = j;
 Sb(a, b + 4 | 0);
 Sb(a + 4 | 0, b + 8 | 0);
 Sb(zb(a), mc(b));
 v[b >> 2] = v[b + 4 >> 2];
 eb = d + 16 | 0;
 return e;
}

function E8(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0;
 a: {
  if (!w[a + 44 | 0]) {
   c = (c | 0) > 0 ? c : 0;
   while (1) {
    if ((c | 0) == (d | 0)) {
     break a;
    }
    if (((f = a, g = yf(t[b | 0]), e = v[v[a >> 2] + 52 >> 2], hb[e](f | 0, g | 0) | 0) | 0) == -1) {
     return d | 0;
    } else {
     b = b + 1 | 0;
     d = d + 1 | 0;
     continue;
    }
   }
  }
  c = gm(b, 1, c, v[a + 32 >> 2]);
 }
 return c | 0;
}

function xZ(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0;
 a: {
  c = eb + -64 | 0;
  eb = c;
  e = c + 44 | 0;
  rg(e, a, 32);
  a = v[c + 44 >> 2];
  d = c + 20 | 0;
  tg(d, 2, Ze(e), a);
  v[31601] = 0;
  a = c + 32 | 0;
  N(218, a | 0, d | 0);
  d = v[31601];
  v[31601] = 0;
  if ((d | 0) != 1) {
   d = c + 12 | 0;
   Dn(d, b);
   lm(d, a);
   sb(a);
   Jc(e);
   eb = c - -64 | 0;
   break a;
  }
  a = M() | 0;
  Jc(c + 44 | 0);
  P(a | 0);
  p();
 }
}

function Tp(a, b, c, d, e, f) {
 var g = 0, h = 0, i = 0;
 g = eb - 16 | 0;
 eb = g;
 Kg(a + 12 | 0, d);
 a: {
  if (!b) {
   d = 0;
   b = 0;
   break a;
  }
  if (b >>> 0 >= f >>> 0) {
   Sj();
   p();
  }
  d = Dc(B(b, e));
  v[g + 12 >> 2] = b;
  v[g + 8 >> 2] = d;
  d = v[g + 12 >> 2];
  b = v[g + 8 >> 2];
 }
 v[a >> 2] = b;
 c = b + B(c, e) | 0;
 v[a + 8 >> 2] = c;
 v[a + 4 >> 2] = c;
 h = mc(a), i = b + B(d, e) | 0, v[h >> 2] = i;
 eb = g + 16 | 0;
 return a;
}

function $pa(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0;
 c = eb - 16 | 0;
 eb = c;
 a = CJ(c + 4 | 0, a, b);
 b = v[a + 4 >> 2];
 d = v[a + 8 >> 2];
 a: {
  while (1) {
   if ((b | 0) == (d | 0)) {
    break a;
   }
   v[31601] = 0;
   V(597, b | 0);
   e = v[31601];
   v[31601] = 0;
   if ((e | 0) != 1) {
    b = b + 24 | 0;
    v[a + 4 >> 2] = b;
    continue;
   }
   break;
  }
  b = M() | 0;
  hc(a);
  P(b | 0);
  p();
 }
 hc(a);
 eb = c + 16 | 0;
}

function WE(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0;
 c = eb - 16 | 0;
 eb = c;
 a = Dw(c + 4 | 0, a, b);
 b = v[a + 4 >> 2];
 d = v[a + 8 >> 2];
 a: {
  while (1) {
   if ((b | 0) == (d | 0)) {
    break a;
   }
   v[31601] = 0;
   V(228, b | 0);
   e = v[31601];
   v[31601] = 0;
   if ((e | 0) != 1) {
    b = b + 20 | 0;
    v[a + 4 >> 2] = b;
    continue;
   }
   break;
  }
  b = M() | 0;
  hc(a);
  P(b | 0);
  p();
 }
 hc(a);
 eb = c + 16 | 0;
}

function hj(a, b, c, d) {
 var e = 0, f = 0, g = 0, h = 0;
 e = eb - 16 | 0;
 eb = e;
 v[e + 12 >> 2] = d;
 g = qh(e + 8 | 0, b);
 b = eb - 16 | 0;
 eb = b;
 d = v[e + 12 >> 2];
 v[b + 12 >> 2] = d;
 v[b + 8 >> 2] = d;
 f = -1;
 d = rt(0, 0, c, d);
 a: {
  if ((d | 0) < 0) {
   break a;
  }
  h = a;
  d = d + 1 | 0;
  a = Fd(d);
  v[h >> 2] = a;
  if (!a) {
   break a;
  }
  f = rt(a, d, c, v[b + 12 >> 2]);
 }
 eb = b + 16 | 0;
 ph(g);
 eb = e + 16 | 0;
 return f;
}

function Wka(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0;
 d = eb - 16 | 0;
 eb = d;
 v[d + 12 >> 2] = b;
 a: {
  if ($o(a) >>> 0 >= b >>> 0) {
   f = v[a >> 2];
   e = Sc(f, v[a + 4 >> 2]);
   v[d + 8 >> 2] = e;
   Rh(f, v[Gb(d + 12 | 0, d + 8 | 0) >> 2], c);
   if (b >>> 0 > e >>> 0) {
    Ap(a, b - e | 0, c);
    break a;
   }
   Id(a, v[a >> 2] + b | 0);
   break a;
  }
  ew(a);
  Tk(a, Tl(a, b));
  Ap(a, b, c);
 }
 eb = d + 16 | 0;
}

function TP(a) {
 a = a | 0;
 var b = 0, c = 0;
 c = eb - 16 | 0;
 eb = c;
 b = v[a + 4256 >> 2];
 v[a + 4240 >> 2] = b << 1;
 v[31601] = 0;
 v[c + 12 >> 2] = 0;
 R(946, a + 4208 | 0, b << 2, c + 12 | 0);
 b = v[31601];
 v[31601] = 0;
 a: {
  if ((b | 0) == 1) {
   b = S(124508) | 0;
   if ((fb | 0) != (_(124508) | 0)) {
    break a;
   }
   X(b | 0) | 0;
   v[a + 4240 >> 2] = 0;
   Y();
  }
  v[a + 4244 >> 2] = 0;
  eb = c + 16 | 0;
  return;
 }
 P(b | 0);
 p();
}

function pV(a) {
 var b = 0, c = 0, d = 0, e = 0;
 c = eb - 16 | 0;
 eb = c;
 e = c + 14 | 0;
 b = eb - 16 | 0;
 eb = b;
 d = v[a + 24 >> 2];
 a: {
  if (!d) {
   rp(e);
   break a;
  }
  hE(b + 8 | 0, Xb(Ri(mq(+(d >>> 0) * .00011957431543704412) * 2215.9795828054475), -16384, 16383), 128);
  d = v[b + 8 >> 2];
  t[b + 7 | 0] = v[b + 12 >> 2];
  de(e, d, b + 7 | 0);
 }
 eb = b + 16 | 0;
 b = c + 4 | 0;
 _D(b, a + 36 | 0, a + 37 | 0);
 ZD(b, e);
 eb = c + 16 | 0;
}

function LF(a, b, c) {
 var d = 0, e = 0, f = 0, g = 0;
 d = eb - 16 | 0;
 eb = d;
 e = v[a + 4 >> 2];
 f = e + b | 0;
 v[a + 4 >> 2] = f;
 a: {
  b: {
   if (!e) {
    g = f - 1 | 0;
    break b;
   }
   g = f - 1 | 0;
   if ((g ^ e - 1) >>> 0 > 31) {
    break b;
   }
   a = v[a >> 2];
   break a;
  }
  a = v[a >> 2];
  v[a + ((f >>> 0 >= 33 ? g >>> 5 | 0 : 0) << 2) >> 2] = 0;
 }
 yp(d + 8 | 0, a, e);
 Vw(v[d + 8 >> 2], v[d + 12 >> 2], b, c);
 eb = d + 16 | 0;
}

function BW(a) {
 var b = 0, c = 0, d = 0, e = 0;
 c = eb - 16 | 0;
 eb = c;
 b = vb(v[a >> 2]);
 v[c + 12 >> 2] = b;
 e = vb(v[a + 4 >> 2]);
 while (1) {
  a: {
   d = Hb(b, e);
   if (!d) {
    break a;
   }
   a = x[b >> 1];
   b: {
    if (!((a | 0) != 255 & (a | 0) != 99)) {
     u[b >> 1] = 65535;
     break b;
    }
    if (a >>> 0 > 63) {
     break a;
    }
   }
   b = v[fe(c + 12 | 0) >> 2];
   continue;
  }
  break;
 }
 eb = c + 16 | 0;
 return d ^ 1;
}

function lm(a, b) {
 var c = 0, d = 0, e = 0, f = 0;
 c = eb - 16 | 0;
 eb = c;
 d = Jb(b);
 e = c, f = Zc(v[b + 4 >> 2], w[b + 11 | 0]), v[e + 12 >> 2] = f;
 v[c + 8 >> 2] = v[a + 4 >> 2] - 1;
 wk(d, d + v[Gb(c + 12 | 0, c + 8 | 0) >> 2] | 0, v[a >> 2]);
 d = v[a >> 2];
 e = c, f = Zc(v[b + 4 >> 2], w[b + 11 | 0]), v[e + 12 >> 2] = f;
 a = v[a + 4 >> 2];
 v[c + 8 >> 2] = a - 1;
 Om(d + v[Gb(c + 12 | 0, c + 8 | 0) >> 2] | 0, a + d | 0, 78512);
 eb = c + 16 | 0;
}

function _x(a, b, c, d) {
 var e = 0, f = 0, g = 0, h = 0;
 e = eb - 160 | 0;
 eb = e;
 v[e + 60 >> 2] = b;
 v[e + 20 >> 2] = b;
 v[e + 24 >> 2] = -1;
 f = e + 16 | 0;
 Ai(f, 0, 0);
 wI(e, f, d, 1);
 d = v[e + 8 >> 2];
 g = v[e + 12 >> 2];
 f = v[e >> 2];
 h = v[e + 4 >> 2];
 if (c) {
  v[c >> 2] = v[e + 136 >> 2] + ((v[e + 20 >> 2] - v[e + 60 >> 2] | 0) + b | 0);
 }
 v[a + 8 >> 2] = d;
 v[a + 12 >> 2] = g;
 v[a >> 2] = f;
 v[a + 4 >> 2] = h;
 eb = e + 160 | 0;
}

function kra(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0;
 c = eb - 16 | 0;
 eb = c;
 v[c + 12 >> 2] = b;
 a: {
  if (nc(v[a >> 2], v[a + 4 >> 2]) >>> 0 > 511) {
   break a;
  }
  if (!Dd(b)) {
   break a;
  }
  v[31601] = 0;
  d = a;
  a = c + 12 | 0;
  N(500, d | 0, a | 0);
  e = v[31601];
  v[31601] = 0;
  d = b;
  if ((e | 0) != 1) {
   break a;
  }
  b = M() | 0;
  lg(a);
  P(b | 0);
  p();
 }
 lg(c + 12 | 0);
 eb = c + 16 | 0;
 return d | 0;
}

function AC(a, b, c, d, e) {
 var f = 0;
 a: {
  f = v[a >> 2];
  if (!ke(f, v[a + 20 >> 2]) | c >>> 0 >= f >>> 0 | f - c >>> 0 < d >>> 0) {
   break a;
  }
  mn(b);
  b = Wo(b, a);
  v[b + 20 >> 2] = 0;
  v[b >> 2] = d;
  if (!Fh(b)) {
   break a;
  }
  if (v[a >> 2] != (d | 0)) {
   cs(b + 68 | 0);
  }
  yc(v[b + 20 >> 2], v[a + 20 >> 2] + c | 0, d);
  v[b + 8 >> 2] = e ? d : 0;
  v[b + 4 >> 2] = 0;
  u[b + 34 >> 1] = x[b + 34 >> 1] & 65533 | (e ? 2 : 0);
 }
}

function r9(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0;
 d = eb - 16 | 0;
 eb = d;
 e = d + 8 | 0;
 c = v[b + 52 >> 2];
 a: {
  if (c & 16) {
   c = v[b + 48 >> 2];
   f = v[b + 28 >> 2];
   if (c >>> 0 < f >>> 0) {
    v[b + 48 >> 2] = f;
    c = f;
   }
   ul(e, v[b + 24 >> 2], c);
   break a;
  }
  if (c & 8) {
   ul(e, v[b + 12 >> 2], v[b + 20 >> 2]);
   break a;
  }
  Ld(e);
 }
 lK(a, v[d + 8 >> 2], v[d + 12 >> 2]);
 eb = d + 16 | 0;
}

function Mea(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0;
 v[31601] = 0;
 V(995, a | 0);
 c = v[31601];
 v[31601] = 0;
 if ((c | 0) != 1) {
  return C(_O(v[v[a + 24 >> 2] + 24 >> 2], b));
 }
 X(S(0) | 0) | 0;
 v[31601] = 0;
 U(982, 6229, a | 0, 0, 0);
 a = v[31601];
 v[31601] = 0;
 if ((a | 0) != 1) {
  Y();
  return C(C(0));
 }
 a = M() | 0;
 v[31601] = 0;
 W(26);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  P(a | 0);
  p();
 }
 S(0) | 0;
 Rb();
 p();
}

function Lea(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0;
 v[31601] = 0;
 V(995, a | 0);
 c = v[31601];
 v[31601] = 0;
 if ((c | 0) != 1) {
  return C(ZO(v[v[a + 24 >> 2] + 24 >> 2], b));
 }
 X(S(0) | 0) | 0;
 v[31601] = 0;
 U(982, 9377, a | 0, 0, 0);
 a = v[31601];
 v[31601] = 0;
 if ((a | 0) != 1) {
  Y();
  return C(C(0));
 }
 a = M() | 0;
 v[31601] = 0;
 W(26);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  P(a | 0);
  p();
 }
 S(0) | 0;
 Rb();
 p();
}

function Kea(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0;
 v[31601] = 0;
 V(995, a | 0);
 c = v[31601];
 v[31601] = 0;
 if ((c | 0) != 1) {
  return C(YO(v[v[a + 24 >> 2] + 24 >> 2], b));
 }
 X(S(0) | 0) | 0;
 v[31601] = 0;
 U(982, 6272, a | 0, 0, 0);
 a = v[31601];
 v[31601] = 0;
 if ((a | 0) != 1) {
  Y();
  return C(C(0));
 }
 a = M() | 0;
 v[31601] = 0;
 W(26);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  P(a | 0);
  p();
 }
 S(0) | 0;
 Rb();
 p();
}

function Iea(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0;
 v[31601] = 0;
 V(995, a | 0);
 c = v[31601];
 v[31601] = 0;
 if ((c | 0) != 1) {
  return C(XO(v[v[a + 24 >> 2] + 24 >> 2], b));
 }
 X(S(0) | 0) | 0;
 v[31601] = 0;
 U(982, 6174, a | 0, 0, 0);
 a = v[31601];
 v[31601] = 0;
 if ((a | 0) != 1) {
  Y();
  return C(C(0));
 }
 a = M() | 0;
 v[31601] = 0;
 W(26);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  P(a | 0);
  p();
 }
 S(0) | 0;
 Rb();
 p();
}

function Hea(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0;
 v[31601] = 0;
 V(995, a | 0);
 c = v[31601];
 v[31601] = 0;
 if ((c | 0) != 1) {
  return C(WO(v[v[a + 24 >> 2] + 24 >> 2], b));
 }
 X(S(0) | 0) | 0;
 v[31601] = 0;
 U(982, 6130, a | 0, 0, 0);
 a = v[31601];
 v[31601] = 0;
 if ((a | 0) != 1) {
  Y();
  return C(C(0));
 }
 a = M() | 0;
 v[31601] = 0;
 W(26);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  P(a | 0);
  p();
 }
 S(0) | 0;
 Rb();
 p();
}

function SK(a, b, c) {
 var d = 0, e = 0, f = 0, g = 0, h = 0;
 d = eb - 16 | 0;
 eb = d;
 a = Pt(a);
 v[a + 32 >> 2] = b;
 v[a >> 2] = 94572;
 e = d + 12 | 0;
 bd(e, v[a + 4 >> 2]);
 v[31601] = 0;
 b = Q(1233, v[d + 12 >> 2]) | 0;
 f = v[31601];
 v[31601] = 0;
 if ((f | 0) != 1) {
  Zb(e);
  v[a + 40 >> 2] = c;
  v[a + 36 >> 2] = b;
  g = a, h = ho(b), t[g + 44 | 0] = h;
  eb = d + 16 | 0;
  return;
 }
 b = M() | 0;
 Zb(d + 12 | 0);
 go(a);
 P(b | 0);
 p();
}

function y$(a, b, c) {
 var d = 0, e = 0;
 d = eb - 16 | 0;
 eb = d;
 e = 0;
 a: {
  if (!a) {
   break a;
  }
  b: {
   c: {
    if (a >>> 0 <= 15) {
     if (b >>> 0 < 2 | c) {
      break c;
     }
     break b;
    }
    if (b >>> 0 > 1) {
     break b;
    }
   }
   e = a | -16;
   break a;
  }
  t[d + 15 | 0] = 1;
  t[d + 14 | 0] = (a >>> 0) / ((b - 1 & 255) >>> 0);
  e = w[cf(d + 15 | 0, d + 14 | 0) | 0];
 }
 a = e;
 eb = d + 16 | 0;
 return a & 255;
}

function GZ(a) {
 var b = 0, c = 0;
 b = w[a | 0] | w[a + 1 | 0] << 8 | (w[a + 2 | 0] << 16 | w[a + 3 | 0] << 24);
 a: {
  b: {
   if ((b | 0) != 1297108297) {
    if ((b | 0) != 778924148) {
     break a;
    }
    if ((w[a + 34 | 0] | w[a + 35 | 0] << 8) >>> 0 <= 255) {
     break b;
    }
    break a;
   }
   if ((w[a + 34 | 0] | w[a + 35 | 0] << 8) >>> 0 > 255) {
    break a;
   }
  }
  c = (w[a + 36 | 0] | w[a + 37 | 0] << 8) >>> 0 < 4e3;
 }
 return c;
}

function xW(a) {
 var b = 0;
 a: {
  if ((w[a | 0] | w[a + 1 | 0] << 8 | (w[a + 2 | 0] << 16 | w[a + 3 | 0] << 24)) != 860902483) {
   break a;
  }
  if (Ab(w[a + 4 | 0] | w[a + 5 | 0] << 8) >>> 0 > 2 | w[a + 6 | 0] > 128) {
   break a;
  }
  if (Ab(w[a + 200 | 0] | w[a + 201 | 0] << 8) >>> 0 > 3999) {
   break a;
  }
  if (!Ab(w[a + 140 | 0] | w[a + 141 | 0] << 8)) {
   break a;
  }
  b = (Ab(w[a + 148 | 0] | w[a + 149 | 0] << 8) | 0) == 50;
 }
 return b;
}

function p_(a) {
 var b = 0;
 a: {
  if ((w[a | 0] | w[a + 1 | 0] << 8 | (w[a + 2 | 0] << 16 | w[a + 3 | 0] << 24)) != -28490681 | w[a + 68 | 0] != 13 | (w[a + 69 | 0] != 10 | w[a + 70 | 0] != 26)) {
   break a;
  }
  if (w[a + 76 | 0] | ((w[a + 71 | 0] | w[a + 72 | 0] << 8 | (w[a + 73 | 0] << 16 | w[a + 74 | 0] << 24)) != 1397116231 | w[a + 75 | 0] != 1)) {
   break a;
  }
  b = ((w[a + 116 | 0] | w[a + 117 | 0] << 8) - 1 & 65535) >>> 0 < 9;
 }
 return b;
}

function QK(a, b, c) {
 var d = 0, e = 0, f = 0, g = 0, h = 0;
 d = eb - 16 | 0;
 eb = d;
 a = aL(a);
 v[a + 32 >> 2] = b;
 v[a >> 2] = 94940;
 e = d + 12 | 0;
 bd(e, v[a + 4 >> 2]);
 v[31601] = 0;
 b = Q(38, v[d + 12 >> 2]) | 0;
 f = v[31601];
 v[31601] = 0;
 if ((f | 0) != 1) {
  Zb(e);
  v[a + 40 >> 2] = c;
  v[a + 36 >> 2] = b;
  g = a, h = ho(b), t[g + 44 | 0] = h;
  eb = d + 16 | 0;
  return;
 }
 b = M() | 0;
 Zb(d + 12 | 0);
 Dt(a);
 P(b | 0);
 p();
}

function Jda(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0;
 v[31601] = 0;
 V(995, a | 0);
 c = v[31601];
 v[31601] = 0;
 if ((c | 0) != 1) {
  mO(v[v[a + 24 >> 2] + 24 >> 2], b);
  return 1;
 }
 X(S(0) | 0) | 0;
 v[31601] = 0;
 U(982, 5784, a | 0, 0, 0);
 a = v[31601];
 v[31601] = 0;
 if ((a | 0) != 1) {
  Y();
  return 0;
 }
 a = M() | 0;
 v[31601] = 0;
 W(26);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  P(a | 0);
  p();
 }
 S(0) | 0;
 Rb();
 p();
}

function lea(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0;
 v[31601] = 0;
 V(995, a | 0);
 c = v[31601];
 v[31601] = 0;
 if ((c | 0) != 1) {
  return GO(v[v[a + 24 >> 2] + 24 >> 2], b) | 0;
 }
 X(S(0) | 0) | 0;
 v[31601] = 0;
 U(982, 6659, a | 0, 0, 0);
 a = v[31601];
 v[31601] = 0;
 if ((a | 0) != 1) {
  Y();
  return 0;
 }
 a = M() | 0;
 v[31601] = 0;
 W(26);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  P(a | 0);
  p();
 }
 S(0) | 0;
 Rb();
 p();
}

function lV(a) {
 var b = 0, c = 0, d = 0;
 d = Ro(a);
 while (1) {
  if ((a | 0) != (d | 0)) {
   b = w[a | 0];
   a: {
    b: {
     if ((b - 97 & 255) >>> 0 <= 5) {
      c = b - 32 | 0;
      break b;
     }
     if (!(b - 88 >>> 0 < 2 | b - 120 >>> 0 < 2)) {
      c = 99;
      if ((b | 0) == 75 | (b | 0) == 107) {
       break b;
      }
      break a;
     }
     c = 122;
    }
    t[a | 0] = c;
   }
   a = a + 1 | 0;
   continue;
  }
  break;
 }
}

function aba(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0;
 d = eb - 16 | 0;
 eb = d;
 c = d + 4 | 0;
 vo(c, a);
 if (v[b >> 2]) {
  Mc(b);
  a = v[b >> 2];
  jt(b);
  Bb(a);
  e = zb(b), f = 0, v[e >> 2] = f;
  v[b >> 2] = 0;
  v[b + 4 >> 2] = 0;
 }
 v[b >> 2] = v[c >> 2];
 v[b + 4 >> 2] = v[c + 4 >> 2];
 a = zb(c);
 e = zb(b), f = v[a >> 2], v[e >> 2] = f;
 v[a >> 2] = 0;
 v[c >> 2] = 0;
 v[c + 4 >> 2] = 0;
 nf(c);
 eb = d + 16 | 0;
}

function vqa(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0;
 c = eb - 16 | 0;
 eb = c;
 v[a >> 2] = 0;
 v[a + 4 >> 2] = 0;
 sc(a + 8 | 0);
 Qd(c + 8 | 0, v[ub(c + 4 | 0, a) >> 2]);
 a: {
  if (b) {
   v[31601] = 0;
   N(588, a | 0, b | 0);
   d = v[31601];
   v[31601] = 0;
   if ((d | 0) == 1) {
    break a;
   }
   pD(a, b);
  }
  b = c + 8 | 0;
  Pd(b);
  ah(b);
  eb = c + 16 | 0;
  return a | 0;
 }
 a = M() | 0;
 ah(c + 8 | 0);
 P(a | 0);
 p();
}

function h6(a) {
 a = a | 0;
 if (w[499880]) {
  return v[124969];
 }
 if (!w[500392]) {
  t[500392] = 1;
 }
 vd(500224, 103352);
 vd(500236, 103380);
 vd(500248, 103408);
 vd(500260, 103440);
 vd(500272, 103480);
 vd(500284, 103516);
 vd(500296, 103544);
 vd(500308, 103580);
 vd(500320, 103596);
 vd(500332, 103612);
 vd(500344, 103628);
 vd(500356, 103644);
 vd(500368, 103660);
 vd(500380, 103676);
 t[499880] = 1;
 v[124969] = 500224;
 return 500224;
}

function _B(a, b, c) {
 var d = 0, e = 0, f = 0;
 d = eb - 16 | 0;
 eb = d;
 a = nC(d + 4 | 0, a, b);
 b = v[a + 4 >> 2];
 e = v[a + 8 >> 2];
 a: {
  while (1) {
   if ((b | 0) == (e | 0)) {
    break a;
   }
   v[31601] = 0;
   N(783, b | 0, c | 0);
   f = v[31601];
   v[31601] = 0;
   if ((f | 0) != 1) {
    b = b + 32 | 0;
    v[a + 4 >> 2] = b;
    continue;
   }
   break;
  }
  b = M() | 0;
  hc(a);
  P(b | 0);
  p();
 }
 hc(a);
 eb = d + 16 | 0;
}

function Ana(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0;
 c = eb - 16 | 0;
 eb = c;
 v[a >> 2] = 0;
 v[a + 4 >> 2] = 0;
 sc(a + 8 | 0);
 Qd(c + 8 | 0, v[ub(c + 4 | 0, a) >> 2]);
 a: {
  if (b) {
   v[31601] = 0;
   N(225, a | 0, b | 0);
   d = v[31601];
   v[31601] = 0;
   if ((d | 0) == 1) {
    break a;
   }
   Vq(a, b);
  }
  b = c + 8 | 0;
  Pd(b);
  ah(b);
  eb = c + 16 | 0;
  return a | 0;
 }
 a = M() | 0;
 ah(c + 8 | 0);
 P(a | 0);
 p();
}

function x7(a, b, c, d, e, f) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 f = f | 0;
 var g = 0, h = 0;
 g = eb - 16 | 0;
 eb = g;
 v[g + 12 >> 2] = b;
 b = g + 8 | 0;
 bd(b, v[d + 28 >> 2]);
 v[31601] = 0;
 d = Q(1251, v[g + 8 >> 2]) | 0;
 h = v[31601];
 v[31601] = 0;
 if ((h | 0) != 1) {
  Zb(b);
  gK(a, f + 24 | 0, g + 12 | 0, c, e, d);
  eb = g + 16 | 0;
  return v[g + 12 >> 2];
 }
 a = M() | 0;
 Zb(g + 8 | 0);
 P(a | 0);
 p();
}

function w7(a, b, c, d, e, f) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 f = f | 0;
 var g = 0, h = 0;
 g = eb - 16 | 0;
 eb = g;
 v[g + 12 >> 2] = b;
 b = g + 8 | 0;
 bd(b, v[d + 28 >> 2]);
 v[31601] = 0;
 d = Q(1251, v[g + 8 >> 2]) | 0;
 h = v[31601];
 v[31601] = 0;
 if ((h | 0) != 1) {
  Zb(b);
  fK(a, f + 16 | 0, g + 12 | 0, c, e, d);
  eb = g + 16 | 0;
  return v[g + 12 >> 2];
 }
 a = M() | 0;
 Zb(g + 8 | 0);
 P(a | 0);
 p();
}

function tn(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0;
 d = a;
 c = QC(b);
 e = eb - 16 | 0;
 eb = e;
 a: {
  if (c >>> 0 < 1073741808) {
   b: {
    if (fr(c)) {
     Me(d, c);
     break b;
    }
    Mj(e + 8 | 0, rn(c) + 1 | 0);
    f = v[e + 8 >> 2];
    xd(d, f);
    of(d, v[e + 12 >> 2]);
    Ad(d, c);
    d = f;
   }
   xd(Qi(d, b, c) + (c << 2) | 0, 0);
   eb = e + 16 | 0;
   break a;
  }
  pf();
  p();
 }
 return a | 0;
}

function r0(a, b, c) {
 var d = 0, e = 0, f = 0;
 d = eb - 32 | 0;
 eb = d;
 v[d + 28 >> 2] = c;
 v[d + 8 >> 2] = 192;
 e = v[a >> 2];
 f = v[a + 8 >> 2];
 c = v[Gb(d + 28 | 0, d + 8 | 0) >> 2];
 if (!Lb(e, f, c)) {
  c = jf(a);
 }
 e = d + 8 | 0;
 sw(e, b);
 f = Yb(d + 16 | 0, v[d + 8 >> 2], c);
 ic(d, v[a >> 2], v[a + 8 >> 2], v[f >> 2], v[f + 4 >> 2]);
 sw(e, b);
 Qb(v[d + 8 >> 2] + c | 0, 0, 192 - c | 0);
 Ub(a, v[d + 28 >> 2]);
 eb = d + 32 | 0;
}

function Rha(a) {
 a = a | 0;
 var b = 0, c = 0, d = 0, e = 0;
 b = eb - 16 | 0;
 eb = b;
 v[b + 12 >> 2] = a;
 v[b + 8 >> 2] = 4104;
 a = 0;
 d = v[b + 8 >> 2];
 a: {
  if (d >>> 0 < 4096) {
   break a;
  }
  c = v[b + 12 >> 2];
  e = c + 7 & -8;
  c = e - c | 0;
  if (c >>> 0 > d - 4096 >>> 0) {
   break a;
  }
  v[b + 12 >> 2] = e;
  v[b + 8 >> 2] = d - c;
  a = e;
 }
 if (!a) {
  Z(6053, 9014, 88, 7400);
  p();
 }
 eb = b + 16 | 0;
 return a | 0;
}

function vH(a, b, c, d, e, f) {
 var g = 0, h = 0, i = 0, j = 0;
 g = eb - 16 | 0;
 eb = g;
 v[g + 12 >> 2] = c;
 c = g + 12 | 0;
 wc(c, f);
 wc(c, 65535);
 h = x[g + 12 >> 1];
 ug(a, h);
 c = 0;
 while (1) {
  if ((c | 0) == (h | 0)) {
   eb = g + 16 | 0;
  } else {
   f = w[b + c | 0];
   i = Sr(v[a >> 2], v[a + 4 >> 2], c), j = (d | 0) == (f | 0) ? -1 : (e | 0) == (f | 0) ? -2 : f, 
   u[i >> 1] = j;
   c = c + 1 | 0;
   continue;
  }
  break;
 }
}

function dM(a, b, c) {
 var d = 0, e = 0, f = 0, g = 0;
 f = eb - 16 | 0;
 eb = f;
 d = eb - 32 | 0;
 eb = d;
 ed(d + 24 | 0, a, b);
 a = eb - 16 | 0;
 eb = a;
 e = c;
 b = v[d + 28 >> 2];
 c = v[d + 24 >> 2];
 g = b - c | 0;
 e = e - g | 0;
 v[a + 12 >> 2] = e;
 YC(e, c, g >> 2);
 pc(d + 16 | 0, b, a + 12 | 0);
 eb = a + 16 | 0;
 a = v[d + 16 >> 2];
 v[d + 12 >> 2] = v[d + 20 >> 2];
 pc(f + 8 | 0, a, d + 12 | 0);
 eb = d + 32 | 0;
 eb = f + 16 | 0;
}

function Wm(a, b, c, d) {
 var e = 0, f = 0, g = 0;
 a: {
  f = B(b, 872) + a | 0;
  e = v[f + 1075648 >> 2];
  if (!e) {
   break a;
  }
  if (!Ij(w[e + 31 | 0])) {
   break a;
  }
  g = w[e + 34 | 0] - 1 | 0;
  if ((g & 255) >>> 0 > 249) {
   break a;
  }
  a = v[_d(a + 906300 | 0, g) >> 2];
  if (!a) {
   break a;
  }
  hb[v[v[a >> 2] + 96 >> 2]](a, e, c, d, b);
  if (c >>> 0 > 250) {
   break a;
  }
  u[(f + 1074992 | 0) + 842 >> 1] = 65535;
 }
}

function Hja(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0;
 a: {
  d = eb - 48 | 0;
  eb = d;
  sf(b);
  e = d + 28 | 0;
  rg(e, a, c);
  a = v[d + 28 >> 2];
  c = d + 4 | 0;
  tg(c, 1, Ze(e), a);
  v[31601] = 0;
  a = d + 16 | 0;
  N(218, a | 0, c | 0);
  c = v[31601];
  v[31601] = 0;
  if ((c | 0) != 1) {
   yb(b, a);
   sb(a);
   Jc(e);
   eb = d + 48 | 0;
   break a;
  }
  a = M() | 0;
  Jc(d + 28 | 0);
  P(a | 0);
  p();
 }
}

function D7(a, b, c, d, e, f) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 f = f | 0;
 var g = 0, h = 0;
 g = eb - 16 | 0;
 eb = g;
 v[g + 12 >> 2] = b;
 b = g + 8 | 0;
 bd(b, v[d + 28 >> 2]);
 v[31601] = 0;
 d = Q(28, v[g + 8 >> 2]) | 0;
 h = v[31601];
 v[31601] = 0;
 if ((h | 0) != 1) {
  Zb(b);
  kK(a, f + 24 | 0, g + 12 | 0, c, e, d);
  eb = g + 16 | 0;
  return v[g + 12 >> 2];
 }
 a = M() | 0;
 Zb(g + 8 | 0);
 P(a | 0);
 p();
}

function C7(a, b, c, d, e, f) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 f = f | 0;
 var g = 0, h = 0;
 g = eb - 16 | 0;
 eb = g;
 v[g + 12 >> 2] = b;
 b = g + 8 | 0;
 bd(b, v[d + 28 >> 2]);
 v[31601] = 0;
 d = Q(28, v[g + 8 >> 2]) | 0;
 h = v[31601];
 v[31601] = 0;
 if ((h | 0) != 1) {
  Zb(b);
  jK(a, f + 16 | 0, g + 12 | 0, c, e, d);
  eb = g + 16 | 0;
  return v[g + 12 >> 2];
 }
 a = M() | 0;
 Zb(g + 8 | 0);
 P(a | 0);
 p();
}

function Bea(a) {
 a = a | 0;
 var b = 0;
 v[31601] = 0;
 V(995, a | 0);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  return v[v[v[a + 24 >> 2] + 24 >> 2] + 1074416 >> 2];
 }
 X(S(0) | 0) | 0;
 v[31601] = 0;
 U(982, 12865, a | 0, 0, 0);
 a = v[31601];
 v[31601] = 0;
 if ((a | 0) != 1) {
  Y();
  return 0;
 }
 a = M() | 0;
 v[31601] = 0;
 W(26);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  P(a | 0);
  p();
 }
 S(0) | 0;
 Rb();
 p();
}

function zv(a, b) {
 a: {
  b: {
   if ((b | 0) != 31) {
    if ((b | 0) != 15) {
     break b;
    }
    b = 0;
    if ((w[a | 0] | w[a + 1 | 0] << 8 | (w[a + 2 | 0] << 16 | w[a + 3 | 0] << 24)) == 1196314451) {
     break b;
    }
    break a;
   }
   b = 0;
   if ((w[a | 0] | w[a + 1 | 0] << 8 | (w[a + 2 | 0] << 16 | w[a + 3 | 0] << 24)) != 825446227) {
    break a;
   }
  }
  b = Ab(w[a + 4 | 0] | w[a + 5 | 0] << 8) >>> 0 > 177;
 }
 return b;
}

function jH(a, b, c) {
 var d = 0, e = 0;
 d = eb - 32 | 0;
 eb = d;
 e = Eb(a + 16 | 0);
 v[a >> 2] = v[b >> 2];
 v[a + 4 >> 2] = v[b + 4 >> 2];
 v[a + 8 >> 2] = v[b + 8 >> 2];
 v[a + 12 >> 2] = v[b + 12 >> 2];
 v[31601] = 0;
 b = O(c | 0, d + 8 | 0, b + 16 | 0) | 0;
 c = v[31601];
 v[31601] = 0;
 if ((c | 0) != 1) {
  a = d + 20 | 0;
  Ph(a, b);
  yb(e, a);
  sb(a);
  sb(b);
  eb = d + 32 | 0;
  return;
 }
 b = M() | 0;
 Ih(a);
 P(b | 0);
 p();
}

function cE(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0;
 e = eb - 32 | 0;
 eb = e;
 v[e + 8 >> 2] = c;
 f = e, g = jf(b), v[f + 28 >> 2] = g;
 c = e + 8 | 0;
 rg(c, b, v[Gb(c, e + 28 | 0) >> 2]);
 b = Ze(c);
 v[31601] = 0;
 U(343, a | 0, b | 0, v[e + 8 >> 2], d | 0);
 a = v[31601];
 v[31601] = 0;
 if ((a | 0) != 1) {
  Jc(c);
  eb = e + 32 | 0;
  return;
 }
 a = M() | 0;
 Jc(e + 8 | 0);
 P(a | 0);
 p();
}

function Kx(a, b, c, d, e) {
 var f = 0, g = 0;
 a: {
  f = eb + -64 | 0;
  eb = f;
  g = f + 44 | 0;
  rg(g, a, e);
  a = v[f + 44 >> 2];
  e = f + 20 | 0;
  tg(e, d, Ze(g), a);
  v[31601] = 0;
  a = f + 32 | 0;
  N(218, a | 0, e | 0);
  d = v[31601];
  v[31601] = 0;
  if ((d | 0) != 1) {
   d = f + 12 | 0;
   Yb(d, b, c);
   lm(d, a);
   sb(a);
   Jc(g);
   eb = f - -64 | 0;
   break a;
  }
  a = M() | 0;
  Jc(f + 44 | 0);
  P(a | 0);
  p();
 }
}

function Cea(a) {
 a = a | 0;
 var b = 0;
 v[31601] = 0;
 V(995, a | 0);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  return v[v[v[a + 24 >> 2] + 24 >> 2] + 1074424 >> 2];
 }
 X(S(0) | 0) | 0;
 v[31601] = 0;
 U(982, 5319, a | 0, 0, 0);
 a = v[31601];
 v[31601] = 0;
 if ((a | 0) != 1) {
  Y();
  return 0;
 }
 a = M() | 0;
 v[31601] = 0;
 W(26);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  P(a | 0);
  p();
 }
 S(0) | 0;
 Rb();
 p();
}

function $V(a, b, c, d) {
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0;
 e = eb - 16 | 0;
 eb = e;
 v[e + 12 >> 2] = 6553600;
 i = e, j = _b(b), v[i + 8 >> 2] = j;
 f = +(d >>> 0) / 6553600;
 g = e + 12 | 0;
 b = e + 8 | 0;
 h = vr(f * +y[Gb(g, b) >> 2]);
 v[e + 8 >> 2] = 6553600;
 i = e, j = _b(c), v[i + 4 >> 2] = j;
 i = e, j = vr(f * +y[Gb(b, e + 4 | 0) >> 2]), v[i + 12 >> 2] = j;
 v[e + 8 >> 2] = d - h;
 pn(a, h, Gb(b, g));
 eb = e + 16 | 0;
}

function Rea(a) {
 a = a | 0;
 var b = 0;
 v[31601] = 0;
 V(1020, a | 0);
 b = v[31601];
 v[31601] = 0;
 a: {
  if ((b | 0) == 1) {
   X(S(0) | 0) | 0;
   v[31601] = 0;
   U(982, 11974, a | 0, 0, 0);
   a = v[31601];
   v[31601] = 0;
   if ((a | 0) == 1) {
    break a;
   }
   Y();
   a = 0;
  }
  return a | 0;
 }
 a = M() | 0;
 v[31601] = 0;
 W(26);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  P(a | 0);
  p();
 }
 S(0) | 0;
 Rb();
 p();
}

function gra(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0;
 c = eb - 16 | 0;
 eb = c;
 sf(b);
 t[c + 15 | 0] = 0;
 a: {
  if (!fi(a, c + 15 | 0)) {
   break a;
  }
  f = w[c + 15 | 0];
  d = 1;
  while (1) {
   if ((e & 255) == (f | 0)) {
    break a;
   }
   t[c + 14 | 0] = 0;
   if (fi(a, c + 14 | 0)) {
    Rp(b, t[c + 14 | 0]);
    e = e + 1 | 0;
    continue;
   }
   break;
  }
  d = 0;
 }
 eb = c + 16 | 0;
 return d | 0;
}

function Toa(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0;
 b = eb - 160 | 0;
 eb = b;
 e = -1;
 c = eb - 16 | 0;
 eb = c;
 d = b + 14 | 0;
 XW(c + 8 | 0, d);
 f = v[c + 12 >> 2];
 pd(c, a, v[c + 8 >> 2], v[c + 12 >> 2]);
 g = v[c + 4 >> 2];
 if ((g | 0) == (f | 0)) {
  hd(a, v[c + 12 >> 2]);
 }
 eb = c + 16 | 0;
 a = (f | 0) == (g | 0);
 if (!a) {
  WW(d);
 }
 if (a) {
  e = YW(d);
 }
 eb = b + 160 | 0;
 return e | 0;
}

function Mta(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0;
 b = eb - 624 | 0;
 eb = b;
 e = -1;
 c = eb - 16 | 0;
 eb = c;
 d = b + 14 | 0;
 H$(c + 8 | 0, d);
 f = v[c + 12 >> 2];
 pd(c, a, v[c + 8 >> 2], v[c + 12 >> 2]);
 g = v[c + 4 >> 2];
 if ((g | 0) == (f | 0)) {
  hd(a, v[c + 12 >> 2]);
 }
 eb = c + 16 | 0;
 a = (f | 0) == (g | 0);
 if (!a) {
  G$(d);
 }
 if (a) {
  e = I$(d);
 }
 eb = b + 624 | 0;
 return e | 0;
}

function rQ(a) {
 a = a | 0;
 var b = 0, c = 0, d = 0;
 b = A[a + 4264 >> 3] * +y[v[a + 16 >> 2] + 1074376 >> 2];
 a: {
  if (D(b) < 0x8000000000000000) {
   d = ~~b >>> 0;
   if (D(b) >= 1) {
    c = ~~(b > 0 ? F(H(b * 2.3283064365386963e-10), 4294967295) : I((b - +(~~b >>> 0 >>> 0)) * 2.3283064365386963e-10)) >>> 0;
   } else {
    c = 0;
   }
   break a;
  }
  c = -2147483648;
 }
 A[a + 4256 >> 3] = b - (+(d >>> 0) + +(c | 0) * 4294967296);
}

function Tn(a, b) {
 var c = 0, d = 0, e = 0, f = 0;
 c = eb - 16 | 0;
 eb = c;
 a: {
  if (!b) {
   b = 0;
   break a;
  }
  d = b;
  b = E(b);
  _f(c, d, 0, 0, 0, 112 - (b ^ 31) | 0);
  d = 0 + v[c + 8 >> 2] | 0;
  b = (v[c + 12 >> 2] ^ 65536) + (16414 - b << 16) | 0;
  f = e >>> 0 > d >>> 0 ? b + 1 | 0 : b;
  e = v[c + 4 >> 2];
  b = v[c >> 2];
 }
 v[a >> 2] = b;
 v[a + 4 >> 2] = e;
 v[a + 8 >> 2] = d;
 v[a + 12 >> 2] = f;
 eb = c + 16 | 0;
}

function Psa(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0;
 b = eb - 160 | 0;
 eb = b;
 e = -1;
 c = eb - 16 | 0;
 eb = c;
 d = b + 3 | 0;
 o_(c + 8 | 0, d);
 f = v[c + 12 >> 2];
 pd(c, a, v[c + 8 >> 2], v[c + 12 >> 2]);
 g = v[c + 4 >> 2];
 if ((g | 0) == (f | 0)) {
  hd(a, v[c + 12 >> 2]);
 }
 eb = c + 16 | 0;
 a = (f | 0) == (g | 0);
 if (!a) {
  n_(d);
 }
 if (a) {
  e = p_(d);
 }
 eb = b + 160 | 0;
 return e | 0;
}

function Boa(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0;
 b = eb - 208 | 0;
 eb = b;
 e = -1;
 c = eb - 16 | 0;
 eb = c;
 d = b + 4 | 0;
 wW(c + 8 | 0, d);
 f = v[c + 12 >> 2];
 pd(c, a, v[c + 8 >> 2], v[c + 12 >> 2]);
 g = v[c + 4 >> 2];
 if ((g | 0) == (f | 0)) {
  hd(a, v[c + 12 >> 2]);
 }
 eb = c + 16 | 0;
 a = (f | 0) == (g | 0);
 if (!a) {
  vW(d);
 }
 if (a) {
  e = xW(d);
 }
 eb = b + 208 | 0;
 return e | 0;
}

function wl(a, b, c) {
 var d = 0, e = 0, f = 0, g = 0, h = 0;
 while (1) {
  a: {
   if ((a | 0) != (b | 0)) {
    e = v[c >> 2];
    g = v[c + 4 >> 2];
    d = eb - 16 | 0;
    eb = d;
    f = oc(d + 8 | 0, v[a >> 2]);
    h = v[f + 4 >> 2];
    v[d >> 2] = v[f >> 2];
    v[d + 4 >> 2] = h;
    e = Hc(e, g, d);
    eb = d + 16 | 0;
    if (!e) {
     break a;
    }
   } else {
    a = b;
   }
   return a;
  }
  a = a + 8 | 0;
  continue;
 }
}

function gta(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0;
 b = eb - 32 | 0;
 eb = b;
 e = -1;
 c = eb - 16 | 0;
 eb = c;
 d = b + 10 | 0;
 cw(c + 8 | 0, d);
 f = v[c + 12 >> 2];
 pd(c, a, v[c + 8 >> 2], v[c + 12 >> 2]);
 g = v[c + 4 >> 2];
 if ((g | 0) == (f | 0)) {
  hd(a, v[c + 12 >> 2]);
 }
 eb = c + 16 | 0;
 a = (f | 0) == (g | 0);
 if (!a) {
  L_(d);
 }
 if (a) {
  e = M_(d);
 }
 eb = b + 32 | 0;
 return e | 0;
}

function dra(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0;
 b = eb - 16 | 0;
 eb = b;
 e = -1;
 c = eb - 16 | 0;
 eb = c;
 d = b + 11 | 0;
 Zj(c + 8 | 0, d);
 f = v[c + 12 >> 2];
 pd(c, a, v[c + 8 >> 2], v[c + 12 >> 2]);
 g = v[c + 4 >> 2];
 if ((g | 0) == (f | 0)) {
  hd(a, v[c + 12 >> 2]);
 }
 eb = c + 16 | 0;
 a = (f | 0) == (g | 0);
 if (!a) {
  SY(d);
 }
 if (a) {
  e = TY(d);
 }
 eb = b + 16 | 0;
 return e | 0;
}

function x_(a, b, c) {
 var d = 0, e = 0, f = 0, g = 0, h = 0;
 d = eb - 16 | 0;
 eb = d;
 v[d + 12 >> 2] = c;
 c = d + 12 | 0;
 wc(c, 256);
 wc(c, 65535);
 f = x[d + 12 >> 1];
 ug(a, f);
 c = 0;
 while (1) {
  if ((c | 0) == (f | 0)) {
   eb = d + 16 | 0;
  } else {
   e = w[b + c | 0];
   g = Sr(v[a >> 2], v[a + 4 >> 2], c), h = (e | 0) == 255 ? -1 : (e | 0) == 254 ? -2 : e, 
   u[g >> 1] = h;
   c = c + 1 | 0;
   continue;
  }
  break;
 }
}

function tl(a) {
 var b = 0, c = 0;
 a: {
  b = v[a + 1396 >> 2];
  if ((b | 0) > 24) {
   break a;
  }
  if (!b) {
   v[a + 1392 >> 2] = 0;
  }
  while (1) {
   if (w[a + 1376 | 0] ? 0 : v[a + 1384 >> 2]) {
    break a;
   }
   c = St(a);
   if ((c | 0) == -1) {
    break a;
   }
   b = v[a + 1396 >> 2];
   v[a + 1396 >> 2] = b + 8;
   v[a + 1392 >> 2] = v[a + 1392 >> 2] + (c << b);
   if ((b | 0) < 17) {
    continue;
   }
   break;
  }
 }
}

function o$(a, b) {
 var c = 0, d = 0, e = 0;
 d = eb - 16 | 0;
 eb = d;
 v[d + 12 >> 2] = b;
 c = eb - 16 | 0;
 eb = c;
 v[c + 12 >> 2] = 107374182;
 v[c + 8 >> 2] = 2147483647;
 e = Gb(c + 12 | 0, c + 8 | 0);
 eb = c + 16 | 0;
 c = b;
 b = v[e >> 2];
 if (c >>> 0 <= b >>> 0) {
  a = k$(a);
  if (a >>> 0 < b >>> 1 >>> 0) {
   v[d + 8 >> 2] = a << 1;
   b = v[ad(d + 8 | 0, d + 12 | 0) >> 2];
  }
  eb = d + 16 | 0;
  return b;
 }
 dd();
 p();
}

function nea(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0;
 v[31601] = 0;
 V(995, a | 0);
 c = v[31601];
 v[31601] = 0;
 if ((c | 0) != 1) {
  return IO(v[a + 24 >> 2], b) | 0;
 }
 X(S(0) | 0) | 0;
 v[31601] = 0;
 U(982, 9801, a | 0, 0, 0);
 a = v[31601];
 v[31601] = 0;
 if ((a | 0) != 1) {
  Y();
  return 0;
 }
 a = M() | 0;
 v[31601] = 0;
 W(26);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  P(a | 0);
  p();
 }
 S(0) | 0;
 Rb();
 p();
}

function M$(a, b) {
 var c = 0, d = 0, e = 0;
 d = eb - 16 | 0;
 eb = d;
 v[d + 12 >> 2] = b;
 c = eb - 16 | 0;
 eb = c;
 v[c + 12 >> 2] = 153391689;
 v[c + 8 >> 2] = 2147483647;
 e = Gb(c + 12 | 0, c + 8 | 0);
 eb = c + 16 | 0;
 c = b;
 b = v[e >> 2];
 if (c >>> 0 <= b >>> 0) {
  a = sE(a);
  if (a >>> 0 < b >>> 1 >>> 0) {
   v[d + 8 >> 2] = a << 1;
   b = v[ad(d + 8 | 0, d + 12 | 0) >> 2];
  }
  eb = d + 16 | 0;
  return b;
 }
 dd();
 p();
}

function v7(a, b, c, d, e, f) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 f = f | 0;
 var g = 0;
 a = eb - 16 | 0;
 eb = a;
 v[a + 12 >> 2] = b;
 b = a + 8 | 0;
 bd(b, v[d + 28 >> 2]);
 v[31601] = 0;
 d = Q(1251, v[a + 8 >> 2]) | 0;
 g = v[31601];
 v[31601] = 0;
 if ((g | 0) != 1) {
  Zb(b);
  eK(f + 20 | 0, a + 12 | 0, c, e, d);
  eb = a + 16 | 0;
  return v[a + 12 >> 2];
 }
 b = M() | 0;
 Zb(a + 8 | 0);
 P(b | 0);
 p();
}

function Tia(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0;
 c = eb - 32 | 0;
 eb = c;
 v[c + 12 >> 2] = -1;
 v[c + 16 >> 2] = 0;
 v[c + 4 >> 2] = 0;
 Eb(c + 20 | 0);
 v[31601] = 0;
 v[c + 4 >> 2] = v[c + 4 >> 2] & -1332 | 1058;
 v[c + 8 >> 2] = 1;
 d = a;
 a = c + 4 | 0;
 R(79, d | 0, b | 0, a | 0);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  Ih(a);
  eb = c + 32 | 0;
  return;
 }
 a = M() | 0;
 Ih(c + 4 | 0);
 P(a | 0);
 p();
}

function rf(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0;
 d = a;
 e = eb - 16 | 0;
 eb = e;
 a: {
  if (b >>> 0 < 2147483632) {
   b: {
    if (Kk(b)) {
     Me(d, b);
     break b;
    }
    pg(e + 8 | 0, Eh(b) + 1 | 0);
    f = v[e + 8 >> 2];
    xd(d, f);
    of(d, v[e + 12 >> 2]);
    Ad(d, b);
    d = f;
   }
   gd(Zl(d, b, c) + b | 0, 0);
   eb = e + 16 | 0;
   break a;
  }
  pf();
  p();
 }
 return a | 0;
}

function hB(a, b, c) {
 var d = 0, e = 0;
 d = ce(a);
 a: {
  if (d) {
   e = fc(a);
   while (1) {
    a = d;
    d = w[a + 16 | 0];
    if (Bo(c, d)) {
     e = a;
     d = v[a >> 2];
     if (d) {
      continue;
     }
     break a;
    }
    if (!Bo(d, c)) {
     break a;
    }
    e = a + 4 | 0;
    d = v[a + 4 >> 2];
    if (d) {
     continue;
    }
    break;
   }
   break a;
  }
  a = fc(a);
  e = a;
 }
 v[b >> 2] = a;
 return e;
}

function Tra(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0;
 a: {
  d = eb - 48 | 0;
  eb = d;
  e = d + 28 | 0;
  rg(e, a, c);
  a = v[d + 28 >> 2];
  c = d + 4 | 0;
  tg(c, 2, Ze(e), a);
  v[31601] = 0;
  a = d + 16 | 0;
  N(218, a | 0, c | 0);
  c = v[31601];
  v[31601] = 0;
  if ((c | 0) != 1) {
   em(b, a);
   sb(a);
   Jc(e);
   eb = d + 48 | 0;
   break a;
  }
  a = M() | 0;
  Jc(d + 28 | 0);
  P(a | 0);
  p();
 }
}

function Maa(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0;
 d = v[b >> 2];
 e = v[b + 8 >> 2];
 f = v[b + 4 >> 2];
 a = 0;
 a: while (1) {
  if ((a | 0) != (f | 0)) {
   g = (a << 2) + d | 0;
   b = 0;
   while (1) if ((b | 0) == (e | 0)) {
    a = a + 1 | 0;
    continue a;
   } else {
    c = v[g >> 2] + (b << 3) | 0;
    v[c >> 2] = 0;
    v[c + 4 >> 2] = 0;
    b = b + 1 | 0;
    continue;
   }
  }
  break;
 }
}

function Dja(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0;
 a: {
  d = eb - 48 | 0;
  eb = d;
  e = d + 28 | 0;
  rg(e, a, c);
  a = v[d + 28 >> 2];
  c = d + 4 | 0;
  tg(c, 1, Ze(e), a);
  v[31601] = 0;
  a = d + 16 | 0;
  N(218, a | 0, c | 0);
  c = v[31601];
  v[31601] = 0;
  if ((c | 0) != 1) {
   Ae(b, a);
   sb(a);
   Jc(e);
   eb = d + 48 | 0;
   break a;
  }
  a = M() | 0;
  Jc(d + 28 | 0);
  P(a | 0);
  p();
 }
}

function Xh(a) {
 var b = 0, c = 0, d = 0, e = 0, f = 0, g = 0, h = 0;
 d = eb - 16 | 0;
 eb = d;
 e = eb - 16 | 0;
 eb = e;
 c = e + 4 | 0;
 v[c + 4 >> 2] = 1;
 g = c, h = Dc(16), v[g + 8 >> 2] = h;
 b = qm(v[c + 8 >> 2]);
 v[b >> 2] = 41096;
 g = On(mc(b)), h = 41228, v[g >> 2] = h;
 b = d + 8 | 0;
 f = Qn(c);
 Pn(b, mc(f), f);
 rm(c);
 eb = e + 16 | 0;
 Ef(a, b);
 le(b);
 eb = d + 16 | 0;
 v[a + 8 >> 2] = 0;
 Ld(a + 12 | 0);
 return a;
}

function F$(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0;
 a: {
  d = eb - 48 | 0;
  eb = d;
  e = d + 28 | 0;
  rg(e, a, c);
  a = v[d + 28 >> 2];
  c = d + 4 | 0;
  tg(c, 2, Ze(e), a);
  v[31601] = 0;
  a = d + 16 | 0;
  N(218, a | 0, c | 0);
  c = v[31601];
  v[31601] = 0;
  if ((c | 0) != 1) {
   zc(b, a);
   sb(a);
   Jc(e);
   eb = d + 48 | 0;
   break a;
  }
  a = M() | 0;
  Jc(d + 28 | 0);
  P(a | 0);
  p();
 }
}

function B7(a, b, c, d, e, f) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 f = f | 0;
 var g = 0;
 a = eb - 16 | 0;
 eb = a;
 v[a + 12 >> 2] = b;
 b = a + 8 | 0;
 bd(b, v[d + 28 >> 2]);
 v[31601] = 0;
 d = Q(28, v[a + 8 >> 2]) | 0;
 g = v[31601];
 v[31601] = 0;
 if ((g | 0) != 1) {
  Zb(b);
  iK(f + 20 | 0, a + 12 | 0, c, e, d);
  eb = a + 16 | 0;
  return v[a + 12 >> 2];
 }
 b = M() | 0;
 Zb(a + 8 | 0);
 P(b | 0);
 p();
}

function a9(a) {
 a = a | 0;
 var b = 0, c = 0, d = 0;
 c = v[a + 44 >> 2];
 b = v[a + 24 >> 2];
 if (c >>> 0 < b >>> 0) {
  v[a + 44 >> 2] = b;
  c = b;
 }
 d = -1;
 a: {
  if (!(w[a + 48 | 0] & 8)) {
   break a;
  }
  b = v[a + 16 >> 2];
  if (b >>> 0 < c >>> 0) {
   Un(a, v[a + 8 >> 2], v[a + 12 >> 2], c);
   b = v[a + 16 >> 2];
  }
  a = v[a + 12 >> 2];
  if (a >>> 0 >= b >>> 0) {
   break a;
  }
  d = yf(t[a | 0]);
 }
 return d | 0;
}

function x1(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0;
 c = eb - 48 | 0;
 eb = c;
 d = -1;
 e = a;
 a = c + 12 | 0;
 a: {
  if (!ZF(e, a)) {
   break a;
  }
  d = 0;
  if (!YF(a)) {
   break a;
  }
  if (b) {
   a = v[b >> 2];
   if (!v[b + 4 >> 2] & a >>> 0 < _b(w[c + 16 | 0] | w[c + 17 | 0] << 8 | (w[c + 18 | 0] << 16 | w[c + 19 | 0] << 24)) - 8 >>> 0) {
    break a;
   }
  }
  d = 1;
 }
 eb = c + 48 | 0;
 return d | 0;
}

function uea(a) {
 a = a | 0;
 var b = 0;
 v[31601] = 0;
 V(995, a | 0);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  return wo(v[v[a + 24 >> 2] + 24 >> 2]) | 0;
 }
 X(S(0) | 0) | 0;
 v[31601] = 0;
 U(982, 7133, a | 0, 0, 0);
 a = v[31601];
 v[31601] = 0;
 if ((a | 0) != 1) {
  Y();
  return 0;
 }
 a = M() | 0;
 v[31601] = 0;
 W(26);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  P(a | 0);
  p();
 }
 S(0) | 0;
 Rb();
 p();
}

function tea(a) {
 a = a | 0;
 var b = 0;
 v[31601] = 0;
 V(995, a | 0);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  return qq(v[v[a + 24 >> 2] + 24 >> 2]) | 0;
 }
 X(S(0) | 0) | 0;
 v[31601] = 0;
 U(982, 6822, a | 0, 0, 0);
 a = v[31601];
 v[31601] = 0;
 if ((a | 0) != 1) {
  Y();
  return 0;
 }
 a = M() | 0;
 v[31601] = 0;
 W(26);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  P(a | 0);
  p();
 }
 S(0) | 0;
 Rb();
 p();
}

function sea(a) {
 a = a | 0;
 var b = 0;
 v[31601] = 0;
 V(995, a | 0);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  return MO(v[v[a + 24 >> 2] + 24 >> 2]) | 0;
 }
 X(S(0) | 0) | 0;
 v[31601] = 0;
 U(982, 6940, a | 0, 0, 0);
 a = v[31601];
 v[31601] = 0;
 if ((a | 0) != 1) {
  Y();
  return 0;
 }
 a = M() | 0;
 v[31601] = 0;
 W(26);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  P(a | 0);
  p();
 }
 S(0) | 0;
 Rb();
 p();
}

function rea(a) {
 a = a | 0;
 var b = 0;
 v[31601] = 0;
 V(995, a | 0);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  return LO(v[v[a + 24 >> 2] + 24 >> 2]) | 0;
 }
 X(S(0) | 0) | 0;
 v[31601] = 0;
 U(982, 7008, a | 0, 0, 0);
 a = v[31601];
 v[31601] = 0;
 if ((a | 0) != 1) {
  Y();
  return 0;
 }
 a = M() | 0;
 v[31601] = 0;
 W(26);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  P(a | 0);
  p();
 }
 S(0) | 0;
 Rb();
 p();
}

function qea(a) {
 a = a | 0;
 var b = 0;
 v[31601] = 0;
 V(995, a | 0);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  return pq(v[v[a + 24 >> 2] + 24 >> 2]) | 0;
 }
 X(S(0) | 0) | 0;
 v[31601] = 0;
 U(982, 7480, a | 0, 0, 0);
 a = v[31601];
 v[31601] = 0;
 if ((a | 0) != 1) {
  Y();
  return 0;
 }
 a = M() | 0;
 v[31601] = 0;
 W(26);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  P(a | 0);
  p();
 }
 S(0) | 0;
 Rb();
 p();
}

function hea(a) {
 a = a | 0;
 var b = 0;
 v[31601] = 0;
 V(995, a | 0);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  return DO(v[v[a + 24 >> 2] + 24 >> 2]) | 0;
 }
 X(S(0) | 0) | 0;
 v[31601] = 0;
 U(982, 5816, a | 0, 0, 0);
 a = v[31601];
 v[31601] = 0;
 if ((a | 0) != 1) {
  Y();
  return 0;
 }
 a = M() | 0;
 v[31601] = 0;
 W(26);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  P(a | 0);
  p();
 }
 S(0) | 0;
 Rb();
 p();
}

function Fea(a) {
 a = a | 0;
 var b = 0;
 v[31601] = 0;
 V(995, a | 0);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  return VO(v[v[a + 24 >> 2] + 24 >> 2]) | 0;
 }
 X(S(0) | 0) | 0;
 v[31601] = 0;
 U(982, 8796, a | 0, 0, 0);
 a = v[31601];
 v[31601] = 0;
 if ((a | 0) != 1) {
  Y();
  return 0;
 }
 a = M() | 0;
 v[31601] = 0;
 W(26);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  P(a | 0);
  p();
 }
 S(0) | 0;
 Rb();
 p();
}

function Dea(a) {
 a = a | 0;
 var b = 0;
 v[31601] = 0;
 V(995, a | 0);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  return TO(v[v[a + 24 >> 2] + 24 >> 2]) | 0;
 }
 X(S(0) | 0) | 0;
 v[31601] = 0;
 U(982, 7165, a | 0, 0, 0);
 a = v[31601];
 v[31601] = 0;
 if ((a | 0) != 1) {
  Y();
  return 0;
 }
 a = M() | 0;
 v[31601] = 0;
 W(26);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  P(a | 0);
  p();
 }
 S(0) | 0;
 Rb();
 p();
}

function Aea(a) {
 a = a | 0;
 var b = 0;
 v[31601] = 0;
 V(995, a | 0);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  return SO(v[v[a + 24 >> 2] + 24 >> 2]) | 0;
 }
 X(S(0) | 0) | 0;
 v[31601] = 0;
 U(982, 9330, a | 0, 0, 0);
 a = v[31601];
 v[31601] = 0;
 if ((a | 0) != 1) {
  Y();
  return 0;
 }
 a = M() | 0;
 v[31601] = 0;
 W(26);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  P(a | 0);
  p();
 }
 S(0) | 0;
 Rb();
 p();
}

function Aia(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 a = Ii(a, b, c, d);
 v[a >> 2] = 42204;
 b = Mb(a + 4208 | 0);
 v[a + 4228 >> 2] = 0;
 v[a + 4220 >> 2] = 0;
 v[a + 4224 >> 2] = 0;
 v[a + 4232 >> 2] = v[c + 24620 >> 2];
 _$(a + 4260 | 0, 80, 150, 80, 255);
 v[31601] = 0;
 N(940, a + 44 | 0, 2);
 c = v[31601];
 v[31601] = 0;
 if ((c | 0) != 1) {
  return a | 0;
 }
 c = M() | 0;
 uc(b);
 Zf(a);
 P(c | 0);
 p();
}

function zea(a) {
 a = a | 0;
 var b = 0;
 v[31601] = 0;
 V(995, a | 0);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  return +RO(v[v[a + 24 >> 2] + 24 >> 2]);
 }
 X(S(0) | 0) | 0;
 v[31601] = 0;
 U(982, 15137, a | 0, 0, 0);
 a = v[31601];
 v[31601] = 0;
 if ((a | 0) != 1) {
  Y();
  return 0;
 }
 a = M() | 0;
 v[31601] = 0;
 W(26);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  P(a | 0);
  p();
 }
 S(0) | 0;
 Rb();
 p();
}

function Tj(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0;
 d = vb(v[b >> 2]);
 f = vb(v[b + 4 >> 2]);
 e = eb - 16 | 0;
 eb = e;
 v[e + 12 >> 2] = d;
 while (1) {
  a: {
   if (!Hb(d, f)) {
    break a;
   }
   if (r$(c, v[d >> 2], v[d + 4 >> 2])) {
    break a;
   }
   d = v[bm(e + 12 | 0) >> 2];
   continue;
  }
  break;
 }
 eb = e + 16 | 0;
 if (lc(d, vb(v[b + 4 >> 2]))) {
  Xh(a);
  return;
 }
 mp(a, d);
}

function Gea(a) {
 a = a | 0;
 var b = 0;
 v[31601] = 0;
 V(995, a | 0);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  return +QA(v[v[a + 24 >> 2] + 24 >> 2]);
 }
 X(S(0) | 0) | 0;
 v[31601] = 0;
 U(982, 10149, a | 0, 0, 0);
 a = v[31601];
 v[31601] = 0;
 if ((a | 0) != 1) {
  Y();
  return 0;
 }
 a = M() | 0;
 v[31601] = 0;
 W(26);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  P(a | 0);
  p();
 }
 S(0) | 0;
 Rb();
 p();
}

function vY(a, b, c, d) {
 var e = 0, f = 0;
 e = eb - 16 | 0;
 eb = e;
 v[e + 12 >> 2] = a;
 a: {
  if (!(!c | b)) {
   a = Te(+(B(a, d) >>> 0) * .25 * 1e4);
   break a;
  }
  if (!(!a | !b)) {
   wc(e + 12 | 0, 10);
   a = B(w[v[e + 12 >> 2] + 25168 | 0], 1e4);
   break a;
  }
  f = +(a >>> 0);
  if (a - 1 >>> 0 <= 9) {
   a = Te(733.8401379310345 / f * 1e4);
   break a;
  }
  a = Te(f / .264 * 1e4);
 }
 eb = e + 16 | 0;
 return a;
}

function nla(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0;
 e = b;
 d = eb - 16 | 0;
 eb = d;
 b = Hf(a, c);
 $d(d, v[a + 36 >> 2]);
 a: {
  b: {
   if (!b) {
    Pc(d, a + 32 | 0, 5);
    c = -1;
    if (!Fb(v[v[d >> 2] >> 2], v[d + 4 >> 2])) {
     break b;
    }
    break a;
   }
   c = v[b + 16 >> 2];
  }
  XB(v[a + 36 >> 2], e, c);
  f = 1;
  g = b;
 }
 ef(a, g);
 eb = d + 16 | 0;
 return f | 0;
}

function lQ(a) {
 a = a | 0;
 var b = 0, c = 0;
 c = eb - 16 | 0;
 eb = c;
 b = v[v[a + 16 >> 2] + 1074404 >> 2];
 v[31601] = 0;
 v[c + 12 >> 2] = 0;
 R(946, a + 4208 | 0, B(b, 254) | 0, c + 12 | 0);
 b = v[31601];
 v[31601] = 0;
 a: {
  if ((b | 0) == 1) {
   b = S(124508) | 0;
   if ((fb | 0) != (_(124508) | 0)) {
    break a;
   }
   X(b | 0) | 0;
   Y();
  }
  v[a + 4220 >> 2] = 0;
  eb = c + 16 | 0;
  return;
 }
 P(b | 0);
 p();
}

function Ve(a) {
 var b = 0, c = 0;
 b = eb - 32 | 0;
 eb = b;
 t[b + 8 | 0] = 0;
 v[b >> 2] = 0;
 v[b + 4 >> 2] = 4194432;
 kF(b + 9 | 0);
 v[a >> 2] = v[b >> 2];
 c = v[b + 8 >> 2];
 v[a + 4 >> 2] = v[b + 4 >> 2];
 v[a + 8 >> 2] = c;
 c = v[b + 16 >> 2];
 v[a + 12 >> 2] = v[b + 12 >> 2];
 v[a + 16 >> 2] = c;
 c = v[b + 24 >> 2];
 v[a + 20 >> 2] = v[b + 20 >> 2];
 v[a + 24 >> 2] = c;
 t[a + 28 | 0] = w[b + 28 | 0];
 eb = b + 32 | 0;
}

function vha(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0;
 a: {
  if (v[b + 4 >> 2] != 8) {
   break a;
  }
  b = v[b >> 2];
  d = w[b + 1 | 0] << 8;
  e = w[b + 2 | 0] << 16 | w[b + 3 | 0] << 24;
  if ((w[b | 0] | d | e) != 1869112133) {
   break a;
  }
  c = w[b + 4 | 0] | w[b + 5 | 0] << 8 | (w[b + 6 | 0] << 16 | w[b + 7 | 0] << 24);
  v[a + 4228 >> 2] = e | (d | w[b | 0]);
  v[a + 4232 >> 2] = c;
  nu(a);
 }
}

function rd(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0;
 e = eb - 32 | 0;
 eb = e;
 g = v[b + 8 >> 2];
 f = v[b >> 2];
 lf(e + 16 | 0, c, d);
 c = v[v[f >> 2] + 28 >> 2];
 d = v[e + 20 >> 2];
 v[e + 8 >> 2] = v[e + 16 >> 2];
 v[e + 12 >> 2] = d;
 hb[c | 0](e + 24 | 0, f, g, e + 8 | 0);
 lf(a, v[e + 24 >> 2], v[e + 28 >> 2]);
 v[b + 8 >> 2] = v[b + 8 >> 2] + v[a + 4 >> 2];
 eb = e + 32 | 0;
}

function mY(a, b) {
 var c = 0, d = 0;
 a: {
  c = v[b >> 2];
  d = v[b + 20 >> 2];
  if (!ke(c, d)) {
   break a;
  }
  if (v[a + 20 >> 2] == (d | 0)) {
   v[a + 20 >> 2] = 0;
   c = v[b >> 2];
  }
  wc(a, c);
  c = x[a + 34 >> 1] & -2 | u[b + 34 >> 1] & 1;
  u[a + 34 >> 1] = c;
  u[a + 34 >> 1] = c & 65471 | x[b + 34 >> 1] & 64;
  if (!Fh(a)) {
   break a;
  }
  yc(v[a + 20 >> 2], v[b + 20 >> 2], Nk(v[a >> 2], x[a + 34 >> 1]));
 }
}

function lia(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0;
 a: {
  if (v[b + 4 >> 2] != 8) {
   break a;
  }
  b = v[b >> 2];
  d = w[b + 1 | 0] << 8;
  e = w[b + 2 | 0] << 16 | w[b + 3 | 0] << 24;
  if ((w[b | 0] | d | e) != 1869112133) {
   break a;
  }
  c = w[b + 4 | 0] | w[b + 5 | 0] << 8 | (w[b + 6 | 0] << 16 | w[b + 7 | 0] << 24);
  v[a + 4260 >> 2] = e | (d | w[b | 0]);
  v[a + 4264 >> 2] = c;
  tu(a);
 }
}

function Gka(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0;
 a: {
  c = eb - 48 | 0;
  eb = c;
  e = c + 28 | 0;
  rg(e, a, 32);
  a = v[c + 28 >> 2];
  d = c + 4 | 0;
  tg(d, 1, Ze(e), a);
  v[31601] = 0;
  a = c + 16 | 0;
  N(218, a | 0, d | 0);
  d = v[31601];
  v[31601] = 0;
  if ((d | 0) != 1) {
   zc(b, a);
   sb(a);
   Jc(e);
   eb = c + 48 | 0;
   break a;
  }
  a = M() | 0;
  Jc(c + 28 | 0);
  P(a | 0);
  p();
 }
}

function FZ(a) {
 var b = 0, c = 0, d = 0, e = 0;
 d = w[a + 32 | 0] | w[a + 33 | 0] << 8;
 e = w[a + 38 | 0] | w[a + 39 | 0] << 8;
 c = w[a + 34 | 0] | w[a + 35 | 0] << 8;
 b = c + (w[a + 36 | 0] | w[a + 37 | 0] << 8) | 0;
 a = 0;
 a = b >>> 0 < c >>> 0 ? 1 : a;
 c = b;
 b = b + e | 0;
 a = (c >>> 0 > b >>> 0 ? a + 1 | 0 : a) << 2 | b >>> 30;
 c = d;
 d = b << 2;
 b = c + d | 0;
 gb = b >>> 0 < d >>> 0 ? a + 1 | 0 : a;
 return b;
}

function jea(a) {
 a = a | 0;
 var b = 0;
 v[31601] = 0;
 V(995, a | 0);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  return +A[v[a + 24 >> 2] + 16 >> 3];
 }
 X(S(0) | 0) | 0;
 v[31601] = 0;
 U(982, 7642, a | 0, 0, 0);
 a = v[31601];
 v[31601] = 0;
 if ((a | 0) != 1) {
  Y();
  return 0;
 }
 a = M() | 0;
 v[31601] = 0;
 W(26);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  P(a | 0);
  p();
 }
 S(0) | 0;
 Rb();
 p();
}

function fea(a) {
 a = a | 0;
 var b = 0;
 v[31601] = 0;
 V(995, a | 0);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  return v[v[a + 24 >> 2] + 8 >> 2];
 }
 X(S(0) | 0) | 0;
 v[31601] = 0;
 U(982, 10930, a | 0, 0, 0);
 a = v[31601];
 v[31601] = 0;
 if ((a | 0) != 1) {
  Y();
  return -1;
 }
 a = M() | 0;
 v[31601] = 0;
 W(26);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  P(a | 0);
  p();
 }
 S(0) | 0;
 Rb();
 p();
}

function ue(a, b) {
 var c = 0, d = 0;
 c = v[a + 4 >> 2];
 d = c + b | 0;
 v[a + 4 >> 2] = d;
 if (v[a + 8 >> 2] >= (d | 0)) {
  d = v[a >> 2] + (c >> 3) | 0;
  a = c & 7;
  c = w[d | 0] & 255 >>> a;
  a = a + b | 0;
  b = 0;
  while (1) {
   if ((a | 0) >= 9) {
    a = a - 8 | 0;
    b = c << a | b;
    c = w[d + 1 | 0];
    d = d + 1 | 0;
    continue;
   }
   break;
  }
  a = c >>> 8 - a | b;
 } else {
  a = 0;
 }
 return a;
}

function Th(a, b) {
 var c = 0, d = 0, e = 0;
 a: {
  if (!(t[a + 480180 | 0] & 1 | b)) {
   break a;
  }
  c = a + 480280 | 0;
  d = v[a + 24616 >> 2] & 524288;
  a = 0;
  while (1) {
   if ((a | 0) == 127) {
    break a;
   }
   b = (a << 5) + c | 0;
   u[b + 6 >> 1] = 64;
   v[b >> 2] = v[b >> 2] & -257;
   e = b;
   b = (a & 3) - 1 >>> 0 < 2;
   u[e + 4 >> 1] = d ? b << 8 : b ? 192 : 64;
   a = a + 1 | 0;
   continue;
  }
 }
}

function u5(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0;
 d = eb - 16 | 0;
 eb = d;
 a = yJ(a, c);
 v[a >> 2] = 95200;
 c = kk(Jb(b));
 v[a + 8 >> 2] = c;
 a: {
  if (!c) {
   a = d + 4 | 0;
   Km(a, 17854, b);
   v[31601] = 0;
   V(1366, a | 0);
   b = v[31601];
   v[31601] = 0;
   if ((b | 0) != 1) {
    break a;
   }
   b = M() | 0;
   sb(a);
   P(b | 0);
   p();
  }
  eb = d + 16 | 0;
  return a | 0;
 }
 p();
}

function sH(a, b, c, d) {
 var e = 0;
 e = eb - 16 | 0;
 eb = e;
 v[a >> 2] = 0;
 v[a + 4 >> 2] = 0;
 sc(a + 8 | 0);
 Qd(e + 8 | 0, v[ub(e + 4 | 0, a) >> 2]);
 a: {
  if (b) {
   v[31601] = 0;
   N(d | 0, a | 0, b | 0);
   d = v[31601];
   v[31601] = 0;
   if ((d | 0) == 1) {
    break a;
   }
   Ap(a, b, c);
  }
  b = e + 8 | 0;
  Pd(b);
  Wi(b);
  eb = e + 16 | 0;
  return a;
 }
 a = M() | 0;
 Wi(e + 8 | 0);
 P(a | 0);
 p();
}

function s5(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0;
 d = eb - 16 | 0;
 eb = d;
 a = xJ(a, c);
 v[a >> 2] = 95232;
 c = kk(Jb(b));
 v[a + 8 >> 2] = c;
 a: {
  if (!c) {
   a = d + 4 | 0;
   Km(a, 18035, b);
   v[31601] = 0;
   V(1366, a | 0);
   b = v[31601];
   v[31601] = 0;
   if ((b | 0) != 1) {
    break a;
   }
   b = M() | 0;
   sb(a);
   P(b | 0);
   p();
  }
  eb = d + 16 | 0;
  return a | 0;
 }
 p();
}

function cM(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0;
 e = eb - 32 | 0;
 eb = e;
 lf(e + 24 | 0, b, c);
 b = Ef(e + 16 | 0, d);
 v[31601] = 0;
 c = v[b + 4 >> 2];
 v[e + 8 >> 2] = v[b >> 2];
 v[e + 12 >> 2] = c;
 gg(163, a, v[e + 24 >> 2], v[e + 28 >> 2], e + 8 | 0);
 a = v[31601];
 v[31601] = 0;
 if ((a | 0) != 1) {
  le(d);
  eb = e + 32 | 0;
  return;
 }
 a = M() | 0;
 le(d);
 P(a | 0);
 p();
}

function a6(a) {
 a = a | 0;
 if (w[499872]) {
  return v[124967];
 }
 if (!w[500216]) {
  t[500216] = 1;
 }
 kd(500048, 5240);
 kd(500060, 5247);
 kd(500072, 5213);
 kd(500084, 5221);
 kd(500096, 5204);
 kd(500108, 5254);
 kd(500120, 5231);
 kd(500132, 9758);
 kd(500144, 9964);
 kd(500156, 11294);
 kd(500168, 12930);
 kd(500180, 5503);
 kd(500192, 10797);
 kd(500204, 6622);
 t[499872] = 1;
 v[124967] = 500048;
 return 500048;
}

function WI(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0;
 d = eb - 16 | 0;
 eb = d;
 a = vJ(a, c);
 v[a >> 2] = 96396;
 c = kk(Jb(b));
 v[a + 8 >> 2] = c;
 a: {
  if (!c) {
   a = d + 4 | 0;
   Km(a, 17916, b);
   v[31601] = 0;
   V(1366, a | 0);
   b = v[31601];
   v[31601] = 0;
   if ((b | 0) != 1) {
    break a;
   }
   b = M() | 0;
   sb(a);
   P(b | 0);
   p();
  }
  eb = d + 16 | 0;
  return a | 0;
 }
 p();
}

function oF(a, b) {
 var c = 0, d = 0, e = 0;
 c = eb - 16 | 0;
 eb = c;
 d = c + 12 | 0;
 bd(d, a);
 v[31601] = 0;
 a = Q(28, v[c + 12 >> 2]) | 0;
 e = v[31601];
 v[31601] = 0;
 a: {
  if ((e | 0) == 1) {
   break a;
  }
  v[31601] = 0;
  a = O(29, a | 0, b | 0) | 0;
  b = v[31601];
  v[31601] = 0;
  if ((b | 0) == 1) {
   break a;
  }
  Zb(d);
  eb = c + 16 | 0;
  return a;
 }
 a = M() | 0;
 Zb(c + 12 | 0);
 P(a | 0);
 p();
}

function PF(a, b, c, d) {
 var e = 0, f = 0, g = 0;
 b = v[a + 1076 >> 2] + (b - (b & c ? c << 1 : 0) | 0) | 0;
 v[a + 1076 >> 2] = b;
 c = b + v[a + 1080 >> 2] | 0;
 v[a + 1080 >> 2] = c;
 e = d;
 d = v[a + 1068 >> 2];
 u[e + (d << 1) >> 1] = w[a + 1084 | 0] ? c : b;
 v[a + 1064 >> 2] = v[a + 1064 >> 2] + 1;
 f = a, g = Zd(x[v[a + 1060 >> 2] + 34 >> 1]) + d | 0, v[f + 1068 >> 2] = g;
 v[a + 1072 >> 2] = v[a + 1072 >> 2] - 1;
}

function O2(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0;
 c = a + 60 | 0;
 d = Ut(c);
 v[a >> 2] = 94032;
 v[d >> 2] = 94052;
 v[a + 60 >> 2] = 94092;
 v[a >> 2] = 94072;
 v[a + 4 >> 2] = 0;
 e = c;
 c = a + 8 | 0;
 oo(e, c);
 v[a >> 2] = 94032;
 v[d >> 2] = 94052;
 v[31601] = 0;
 O(107, c | 0, b | 0) | 0;
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  return a | 0;
 }
 a = M() | 0;
 sl(d);
 P(a | 0);
 p();
}

function w$(a, b, c) {
 var d = 0, e = 0;
 d = eb - 16 | 0;
 eb = d;
 t[d + 15 | 0] = 1;
 t[d + 14 | 0] = a >>> 2;
 a = w[cf(d + 15 | 0, d + 14 | 0) | 0];
 e = b >>> 0 < 2 | a >>> 0 < 15;
 if (!e) {
  t[d + 13 | 0] = 1;
  t[d + 12 | 0] = (((a + b | 0) - 2 & 65535) >>> 0) / ((b - 1 & 65535) >>> 0);
  a = w[cf(d + 13 | 0, d + 12 | 0) | 0];
 }
 eb = d + 16 | 0;
 return (c ? a << 4 | (e ? 15 : 0) : a & 15 | (e ? -16 : 0)) & 255;
}

function mra(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0;
 e = eb - 16 | 0;
 eb = e;
 while (1) {
  a: {
   c = v[a >> 2];
   if (nc(c, v[a + 4 >> 2]) >>> 0 > d >>> 0) {
    f = e + 4 | 0;
    tm(f, v[xb(c, d) >> 2] + 40 | 0);
    c = ir(f, b);
    sb(f);
    if (!c) {
     break a;
    }
    g = v[xb(v[a >> 2], d) >> 2];
   }
   eb = e + 16 | 0;
   return g | 0;
  }
  d = d + 1 | 0;
  continue;
 }
}

function cH(a, b, c, d, e) {
 var f = 0, g = 0;
 a: {
  f = eb - 48 | 0;
  eb = f;
  sf(b);
  g = f + 28 | 0;
  rg(g, a, d);
  a = v[f + 28 >> 2];
  d = f + 4 | 0;
  tg(d, e, Ze(g), a);
  v[31601] = 0;
  a = f + 16 | 0;
  R(598, a | 0, c | 0, d | 0);
  c = v[31601];
  v[31601] = 0;
  if ((c | 0) != 1) {
   yb(b, a);
   sb(a);
   Jc(g);
   eb = f + 48 | 0;
   break a;
  }
  a = M() | 0;
  Jc(f + 28 | 0);
  P(a | 0);
  p();
 }
}

function Yf(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0;
 e = eb - 16 | 0;
 eb = e;
 Kg(a + 12 | 0, d);
 a: {
  if (!b) {
   d = 0;
   b = 0;
   break a;
  }
  Mj(e + 8 | 0, b);
  d = v[e + 12 >> 2];
  b = v[e + 8 >> 2];
 }
 v[a >> 2] = b;
 c = b + (c << 2) | 0;
 v[a + 8 >> 2] = c;
 v[a + 4 >> 2] = c;
 f = mc(a), g = b + (d << 2) | 0, v[f >> 2] = g;
 eb = e + 16 | 0;
 return a | 0;
}

function IH(a, b, c, d) {
 var e = 0, f = 0, g = 0, h = 0;
 a: {
  f = eb - 16 | 0;
  eb = f;
  e = f + 4 | 0;
  v[e + 4 >> 2] = 1;
  g = e, h = Dc(d), v[g + 8 >> 2] = h;
  d = v[e + 8 >> 2];
  v[31601] = 0;
  O(c | 0, d | 0, b | 0) | 0;
  b = v[31601];
  v[31601] = 0;
  if ((b | 0) != 1) {
   b = a;
   a = Qn(e);
   Pn(b, mc(a), a);
   rm(e);
   eb = f + 16 | 0;
   break a;
  }
  a = M() | 0;
  rm(e);
  P(a | 0);
  p();
 }
}

function Eea(a) {
 a = a | 0;
 var b = 0;
 v[31601] = 0;
 V(995, a | 0);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  return UO(v[a + 24 >> 2]) | 0;
 }
 X(S(0) | 0) | 0;
 v[31601] = 0;
 U(982, 9766, a | 0, 0, 0);
 a = v[31601];
 v[31601] = 0;
 if ((a | 0) != 1) {
  Y();
  return 0;
 }
 a = M() | 0;
 v[31601] = 0;
 W(26);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  P(a | 0);
  p();
 }
 S(0) | 0;
 Rb();
 p();
}

function ki(a) {
 var b = C(0), c = 0, d = 0;
 c = (q(a), j(2));
 d = c >>> 23 & 255;
 if (d >>> 0 <= 149) {
  if (d >>> 0 <= 125) {
   return C(a * C(0));
  }
  a = C(D(a));
  b = C(C(C(a + C(8388608)) + C(-8388608)) - a);
  a: {
   if (b > C(.5)) {
    a = C(C(a + b) + C(-1));
    break a;
   }
   a = C(a + b);
   if (!(b <= C(-.5))) {
    break a;
   }
   a = C(a + C(1));
  }
  a = (c | 0) < 0 ? C(-a) : a;
 }
 return a;
}

function nu(a) {
 var b = 0, c = 0, d = C(0);
 c = w[a + 4232 | 0];
 if (c >>> 0 >= 5) {
  t[a + 4232 | 0] = 0;
  c = 0;
 }
 if (t[a + 4233 | 0] < 0) {
  t[a + 4233 | 0] = 127;
 }
 b = t[a + 4234 | 0];
 if ((b | 0) < 0) {
  t[a + 4234 | 0] = 127;
  b = 127;
 }
 a: {
  if ((c | 0) == 3) {
   d = C(C(1) - De(C(2), C(-C((b + 1 & 255) >>> 0))));
   break a;
  }
  d = De(C(2), C(-C((b & 255) >>> 0)));
 }
 z[a + 4224 >> 2] = d;
}

function hH(a, b, c) {
 var d = 0;
 d = eb - 16 | 0;
 eb = d;
 v[a >> 2] = 0;
 v[a + 4 >> 2] = 0;
 sc(a + 8 | 0);
 Qd(d + 8 | 0, v[ub(d + 4 | 0, a) >> 2]);
 a: {
  if (b) {
   v[31601] = 0;
   N(c | 0, a | 0, b | 0);
   c = v[31601];
   v[31601] = 0;
   if ((c | 0) == 1) {
    break a;
   }
   KX(a, b);
  }
  b = d + 8 | 0;
  Pd(b);
  Wi(b);
  eb = d + 16 | 0;
  return a;
 }
 a = M() | 0;
 Wi(d + 8 | 0);
 P(a | 0);
 p();
}

function Ht(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0;
 c = eb - 16 | 0;
 eb = c;
 d = cc(16);
 if (!w[501689]) {
  t[501689] = 1;
 }
 a = Yb(c + 8 | 0, a, 125896);
 v[31601] = 0;
 e = v[a + 4 >> 2];
 v[c >> 2] = v[a >> 2];
 v[c + 4 >> 2] = e;
 a = T(1219, d | 0, c | 0, b | 0) | 0;
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  ca(a | 0, 123816, 1220);
  p();
 }
 a = M() | 0;
 jc(d);
 P(a | 0);
 p();
}

function qK(a, b) {
 var c = 0, d = 0, e = 0, f = 0;
 c = eb - 16 | 0;
 eb = c;
 v[b >> 2] = 0;
 t[c + 15 | 0] = 0;
 fi(a, c + 15 | 0);
 d = w[c + 15 | 0];
 e = d >>> 2 | 0;
 f = d & 3;
 d = 0;
 while (1) {
  v[b >> 2] = e;
  if ((d | 0) == (f | 0)) {
   eb = c + 16 | 0;
  } else {
   t[c + 15 | 0] = 0;
   fi(a, c + 15 | 0);
   d = d + 1 | 0;
   e = v[b >> 2] | w[c + 15 | 0] << (d << 3) - 2;
   continue;
  }
  break;
 }
}

function X1(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0;
 e = eb - 32 | 0;
 eb = e;
 v[e + 24 >> 2] = d;
 v[e + 28 >> 2] = c;
 v[31601] = 0;
 c = e + 8 | 0;
 U(167, c | 0, b | 0, e + 28 | 0, e + 24 | 0);
 d = v[31601];
 v[31601] = 0;
 if ((d | 0) != 1) {
  d = e + 16 | 0;
  Jp(d, c);
  Ef(a, d);
  le(d);
  le(c);
  le(b);
  eb = e + 32 | 0;
  return;
 }
 a = M() | 0;
 le(b);
 P(a | 0);
 p();
}

function mm(a, b, c, d, e) {
 var f = 0;
 a: {
  if (c >>> 0 > 255) {
   break a;
  }
  if ((d | 0) != 3) {
   d = B(c, 872) + b | 0;
   f = MS(v[d + 720 >> 2], v[d + 1272 >> 2], e);
   if ((f + 5 & 255) >>> 0 > 5) {
    break a;
   }
   return LS(a, b, c, e);
  }
  f = LS(a, b, c, e);
  if ((f + 5 & 255) >>> 0 > 5) {
   break a;
  }
  a = B(c, 872) + b | 0;
  f = MS(v[a + 720 >> 2], v[a + 1272 >> 2], e);
 }
 return f;
}

function YS(a, b) {
 var c = 0, d = 0;
 a: {
  if (!(w[a + 89 | 0] & 16)) {
   break a;
  }
  c = v[a + 656 >> 2];
  if (!c) {
   break a;
  }
  c = v[c >> 2];
  b: {
   if (c) {
    d = a;
    a = v[a + 696 >> 2] - (c << 1) | 0;
    a = (a | 0) > 0 ? a : 0;
    v[d + 696 >> 2] = a;
    a = (B(a, v[b >> 2]) | 0) / 65536 | 0;
    break b;
   }
   if (v[a + 696 >> 2]) {
    break a;
   }
   a = 0;
  }
  v[b >> 2] = a;
 }
}

function HP(a, b, c) {
 t[a + 12 | 0] = 0;
 v[c >> 2] = 0;
 v[b >> 2] = 0;
 v[a + 28 >> 2] = 0;
 v[a + 32 >> 2] = 0;
 u[a + 24 >> 1] = 0;
 v[a + 36 >> 2] = 0;
 v[a + 40 >> 2] = 0;
 v[a + 44 >> 2] = 0;
 v[a + 48 >> 2] = 0;
 GP(a + 60 | 0);
 GP(a + 52 | 0);
 Dq(a + 49956 | 0);
 Dq(a + 58148 | 0);
 Dq(a + 66340 | 0);
 Dq(a + 74532 | 0);
 Qb(a + 228 | 0, 0, 32768);
 Qb(a + 32996 | 0, 0, 512);
 Qb(a + 33508 | 0, 0, 16384);
}

function yfa(a) {
 a = a | 0;
 var b = 0;
 v[31601] = 0;
 V(995, a | 0);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  return v[a + 16 >> 2];
 }
 X(S(0) | 0) | 0;
 v[31601] = 0;
 U(982, 5690, a | 0, 0, 0);
 a = v[31601];
 v[31601] = 0;
 if ((a | 0) != 1) {
  Y();
  return -1;
 }
 a = M() | 0;
 v[31601] = 0;
 W(26);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  P(a | 0);
  p();
 }
 S(0) | 0;
 Rb();
 p();
}

function fja(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0;
 e = eb - 16 | 0;
 eb = e;
 c = Hf(a, c);
 $d(e, v[a + 36 >> 2]);
 a: {
  b: {
   if (!c) {
    Pc(e, a + 32 | 0, 5);
    f = -1;
    if (!Fb(v[v[e >> 2] >> 2], v[e + 4 >> 2])) {
     break b;
    }
    break a;
   }
   f = v[c + 16 >> 2];
  }
  hb[d | 0](v[a + 36 >> 2], b, f);
  g = c;
 }
 ef(a, g);
 eb = e + 16 | 0;
}

function aN(a) {
 var b = 0, c = 0, d = 0, e = 0;
 if (!w[a + 12 | 0]) {
  b = eb - 16 | 0;
  eb = b;
  d = ub(b + 12 | 0, v[v[a + 8 >> 2] >> 2]);
  e = v[ub(b + 8 | 0, v[v[a + 4 >> 2] >> 2]) >> 2];
  c = eb - 16 | 0;
  eb = c;
  a = v[d >> 2];
  v[c + 12 >> 2] = a;
  while (1) {
   if (Ed(a, e)) {
    Nj(Cz(a));
    a = v[Xq(c + 12 | 0) >> 2];
    continue;
   }
   break;
  }
  eb = c + 16 | 0;
  eb = b + 16 | 0;
 }
}

function Lh(a, b, c, d, e, f) {
 var g = 0;
 g = eb - 32 | 0;
 eb = g;
 v[g + 12 >> 2] = -1;
 v[g + 16 >> 2] = 0;
 v[g + 4 >> 2] = 0;
 Eb(g + 20 | 0);
 v[g + 8 >> 2] = f;
 v[31601] = 0;
 v[g + 4 >> 2] = v[g + 4 >> 2] & e | d;
 d = a;
 a = g + 4 | 0;
 R(c | 0, d | 0, b | 0, a | 0);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  Ih(a);
  eb = g + 32 | 0;
  return;
 }
 a = M() | 0;
 Ih(g + 4 | 0);
 P(a | 0);
 p();
}

function $L(a) {
 var b = 0, c = 0, d = 0, e = 0;
 if (!w[a + 12 | 0]) {
  b = eb - 16 | 0;
  eb = b;
  d = ub(b + 12 | 0, v[v[a + 8 >> 2] >> 2]);
  e = v[ub(b + 8 | 0, v[v[a + 4 >> 2] >> 2]) >> 2];
  c = eb - 16 | 0;
  eb = c;
  a = v[d >> 2];
  v[c + 12 >> 2] = a;
  while (1) {
   if (Ed(a, e)) {
    Db(Pp(a));
    a = v[ik(c + 12 | 0) >> 2];
    continue;
   }
   break;
  }
  eb = c + 16 | 0;
  eb = b + 16 | 0;
 }
}

function Hha(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 v[a + 4 >> 2] = b;
 v[a >> 2] = 0;
 b = ou(a + 8 | 0, d);
 v[31601] = 0;
 O(960, a + 20 | 0, c | 0) | 0;
 c = v[31601];
 v[31601] = 0;
 if ((c | 0) != 1) {
  v[a + 32 >> 2] = 0;
  v[a + 36 >> 2] = 0;
  t[a + 42 | 0] = 0;
  t[a + 40 | 0] = 0;
  t[a + 41 | 0] = w[a + 41 | 0] & 224 | 25;
  return a | 0;
 }
 a = M() | 0;
 Db(b);
 P(a | 0);
 p();
}

function Ix(a, b, c, d, e) {
 var f = 0;
 f = eb - 32 | 0;
 eb = f;
 v[f + 12 >> 2] = -1;
 v[f + 16 >> 2] = 0;
 v[f + 4 >> 2] = 0;
 v[f + 8 >> 2] = 0;
 Eb(f + 20 | 0);
 v[31601] = 0;
 v[f + 4 >> 2] = v[f + 4 >> 2] & e | d;
 d = a;
 a = f + 4 | 0;
 R(c | 0, d | 0, b | 0, a | 0);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  Ih(a);
  eb = f + 32 | 0;
  return;
 }
 a = M() | 0;
 Ih(f + 4 | 0);
 P(a | 0);
 p();
}

function Cu(a, b) {
 var c = 0;
 a: {
  b: {
   c: {
    switch (b - 2 | 0) {
    default:
     c = 42188;
     if ((b | 0) == 16777216) {
      break a;
     }
     if ((b | 0) != 32) {
      break b;
     }
     c = 42040;
     break a;

    case 2:
     c = 42036;
     break a;

    case 1:
     break b;

    case 0:
     break c;
    }
   }
   c = 42032;
   break a;
  }
  c = 42028;
 }
 v[a >> 2] = v[c >> 2];
}

function rL(a) {
 var b = 0, c = 0, d = 0, e = 0, f = 0;
 d = v[a >> 2];
 b = t[d | 0] - 48 | 0;
 if (b >>> 0 > 9) {
  return 0;
 }
 while (1) {
  e = -1;
  if (c >>> 0 <= 214748364) {
   c = B(c, 10);
   e = (c ^ 2147483647) >>> 0 < b >>> 0 ? -1 : c + b | 0;
  }
  b = d + 1 | 0;
  v[a >> 2] = b;
  f = t[d + 1 | 0];
  c = e;
  d = b;
  b = f - 48 | 0;
  if (b >>> 0 < 10) {
   continue;
  }
  break;
 }
 return c;
}

function dP(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0;
 e = Oj(b, c);
 d = Lc(a);
 if (e >>> 0 > d >>> 0) {
  f = d;
  g = e - d | 0;
  d = Cb(v[a + 4 >> 2], w[a + 11 | 0]);
  $m(a, f, g, d, 0, d, 0);
 }
 d = Jb(a);
 while (1) {
  if ((b | 0) != (c | 0)) {
   gd(d, w[b | 0]);
   b = b + 1 | 0;
   d = d + 1 | 0;
   continue;
  }
  break;
 }
 gd(d, 0);
 kg(a, e);
 return a | 0;
}

function EJ(a) {
 var b = 0, c = 0, d = 0, e = 0, f = 0;
 b = eb - 16 | 0;
 eb = b;
 v[a >> 2] = 0;
 v[a + 4 >> 2] = 0;
 e = sc(a + 8 | 0), f = 0, t[e + 128 | 0] = f;
 c = b + 8 | 0;
 Qd(c, v[ub(b + 4 | 0, a) >> 2]);
 v[31601] = 0;
 N(1326, a | 0, 30);
 d = v[31601];
 v[31601] = 0;
 if ((d | 0) != 1) {
  Vq(a, 30);
  Pd(c);
  zJ(c);
  eb = b + 16 | 0;
  return a;
 }
 a = M() | 0;
 zJ(b + 8 | 0);
 P(a | 0);
 p();
}

function ae(a, b) {
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0;
 g = a + 26 | 0;
 d = x[a + 22 >> 1];
 h = d + x[a + 20 >> 1] | 0;
 c = d;
 while (1) {
  a: {
   if ((c | 0) != (h | 0)) {
    e = ((c & 127) << 2) + g | 0;
    f = x[e + 2 >> 1] + b | 0;
    u[e + 2 >> 1] = f;
    if ((f & 65535) >>> 0 < 2048) {
     break a;
    }
    u[a + 20 >> 1] = c - d;
   }
   return;
  }
  c = c + 1 | 0;
  continue;
 }
}

function x0(a, b, c) {
 var d = 0, e = 0, f = 0, g = 0;
 d = eb - 48 | 0;
 eb = d;
 sf(b);
 f = d + 28 | 0;
 rg(f, a, c);
 a = v[d + 28 >> 2];
 e = d + 4 | 0;
 tg(e, 3, Ze(f), a);
 v[31601] = 0;
 g = d + 16 | 0;
 N(218, g | 0, e | 0);
 e = v[31601];
 v[31601] = 0;
 if ((e | 0) != 1) {
  yb(b, g);
  sb(g);
  Jc(f);
  eb = d + 48 | 0;
  return !c | (a | 0) != 0;
 }
 a = M() | 0;
 Jc(d + 28 | 0);
 P(a | 0);
 p();
}

function on(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0;
 e = eb - 16 | 0;
 eb = e;
 Kg(a + 12 | 0, d);
 a: {
  if (!b) {
   d = 0;
   b = 0;
   break a;
  }
  pg(e + 8 | 0, b);
  d = v[e + 12 >> 2];
  b = v[e + 8 >> 2];
 }
 v[a >> 2] = b;
 c = b + c | 0;
 v[a + 8 >> 2] = c;
 v[a + 4 >> 2] = c;
 f = mc(a), g = b + d | 0, v[f >> 2] = g;
 eb = e + 16 | 0;
 return a | 0;
}

function nh(a, b) {
 var c = 0, d = 0, e = 0;
 d = w[a + 11 | 0];
 c = Cb(v[a + 4 >> 2], d);
 a: {
  if ((c | 0) != (Cb(v[b + 4 >> 2], w[b + 11 | 0]) | 0)) {
   break a;
  }
  a = Jb(a);
  b = Jb(b);
  if (!ud(d)) {
   while (1) {
    e = !c;
    if (!c | w[a | 0] != w[b | 0]) {
     break a;
    }
    b = b + 1 | 0;
    a = a + 1 | 0;
    c = c - 1 | 0;
    continue;
   }
  }
  e = !ot(a, b, c);
 }
 return e;
}

function jR(a, b, c, d) {
 var e = 0, f = 0, g = 0, h = 0, i = 0;
 e = eb - 32 | 0;
 eb = e;
 ed(e + 24 | 0, b, c);
 b = eb - 16 | 0;
 eb = b;
 f = v[e + 28 >> 2];
 g = v[e + 24 >> 2];
 c = f - g | 0;
 h = b, i = iR(d, g, (c | 0) / 6 | 0) + c | 0, v[h + 12 >> 2] = i;
 pc(e + 16 | 0, f, b + 12 | 0);
 eb = b + 16 | 0;
 b = v[e + 16 >> 2];
 v[e + 12 >> 2] = v[e + 20 >> 2];
 pc(a, b, e + 12 | 0);
 eb = e + 32 | 0;
}

function OF(a, b, c, d) {
 var e = 0, f = 0;
 b = v[a + 1076 >> 2] + (b - (b & c ? c << 1 : 0) | 0) | 0;
 v[a + 1076 >> 2] = b;
 c = b + v[a + 1080 >> 2] | 0;
 v[a + 1080 >> 2] = c;
 t[v[a + 1068 >> 2] + d | 0] = w[a + 1084 | 0] ? c : b;
 v[a + 1064 >> 2] = v[a + 1064 >> 2] + 1;
 e = a, f = v[a + 1068 >> 2] + Zd(x[v[a + 1060 >> 2] + 34 >> 1]) | 0, v[e + 1068 >> 2] = f;
 v[a + 1072 >> 2] = v[a + 1072 >> 2] - 1;
}

function Am(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0;
 e = Rd(b, c);
 d = sn(a);
 if (e >>> 0 > d >>> 0) {
  f = d;
  g = e - d | 0;
  d = Cb(v[a + 4 >> 2], w[a + 11 | 0]);
  rC(a, f, g, d, 0, d);
 }
 d = Jb(a);
 while (1) {
  if ((b | 0) != (c | 0)) {
   xd(d, v[b >> 2]);
   b = b + 4 | 0;
   d = d + 4 | 0;
   continue;
  }
  break;
 }
 xd(d, 0);
 kg(a, e);
 return a | 0;
}

function lja(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0;
 c = eb - 32 | 0;
 eb = c;
 d = -1;
 e = a;
 a = c + 8 | 0;
 a: {
  if (!JG(e, a)) {
   break a;
  }
  d = 0;
  if (!mR(a)) {
   break a;
  }
  if (b) {
   if (v[b >> 2] != (w[c + 16 | 0] | w[c + 17 | 0] << 8 | (w[c + 18 | 0] << 16 | w[c + 19 | 0] << 24)) | v[b + 4 >> 2]) {
    break a;
   }
  }
  d = 1;
 }
 eb = c + 32 | 0;
 return d | 0;
}

function fM(a) {
 var b = 0, c = 0, d = 0;
 b = eb - 48 | 0;
 eb = b;
 hg(v[v[a >> 2] - 12 >> 2] + a | 0, 0);
 $d(b + 32 | 0, a);
 a = Ci(a, 0, 0, 2);
 $d(b + 16 | 0, a);
 c = v[b + 44 >> 2];
 v[b + 8 >> 2] = v[b + 40 >> 2];
 v[b + 12 >> 2] = c;
 c = v[b + 36 >> 2];
 v[b >> 2] = v[b + 32 >> 2];
 v[b + 4 >> 2] = c;
 c = v[b + 28 >> 2];
 d = v[b + 24 >> 2];
 Sm(a, b);
 a = Uu(d, c);
 eb = b + 48 | 0;
 return a;
}

function X$(a) {
 var b = 0, c = 0, d = 0, e = 0, f = 0, g = 0;
 b = eb - 16 | 0;
 eb = b;
 f = wb(a, 31), g = 0, t[f | 0] = g;
 c = Ei(a, Ro(a), 0);
 t[b + 15 | 0] = 0;
 c = Oj(a, c);
 Om(c + a | 0, Ro(a), b + 15 | 0);
 while (1) {
  if ((c | 0) != (d | 0)) {
   e = wb(a, d);
   if ((w[e | 0] - 127 & 255) >>> 0 <= 160) {
    t[e | 0] = 32;
   }
   d = d + 1 | 0;
   continue;
  }
  break;
 }
 eb = b + 16 | 0;
}

function Pq(a, b, c, d) {
 var e = 0, f = 0, g = 0;
 a: {
  e = Ol(a, b);
  if ((e | 0) == 255) {
   break a;
  }
  g = v[a >> 2];
  if (Ej(g)) {
   break a;
  }
  f = Ud(a + 318 | 0, e);
  e = AU(e);
  if (t[wb(f, 10) | 0] & 1 | d) {
   zh(g, v[a + 4 >> 2], b, e - -64 & 65535, zU(c, w[wb(f, 2) | 0]));
  }
  if (d) {
   break a;
  }
  zh(v[a >> 2], v[a + 4 >> 2], b, e + 67 & 65535, zU(c, w[wb(f, 3) | 0]));
 }
}

function M8(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0;
 a: {
  if (!w[a + 44 | 0]) {
   c = (c | 0) > 0 ? c : 0;
   while (1) {
    if ((c | 0) == (d | 0)) {
     break a;
    }
    if ((hb[v[v[a >> 2] + 52 >> 2]](a, v[b >> 2]) | 0) == -1) {
     return d | 0;
    } else {
     b = b + 4 | 0;
     d = d + 1 | 0;
     continue;
    }
   }
  }
  c = gm(b, 4, c, v[a + 32 >> 2]);
 }
 return c | 0;
}

function nT(a, b) {
 var c = 0, d = 0;
 a: {
  if (!(t[a + 851 | 0] & 1)) {
   break a;
  }
  c = v[a + 104 >> 2];
  if (!c) {
   break a;
  }
  d = v[c >> 2];
  if (!d) {
   break a;
  }
  v[a + 76 >> 2] = d;
  v[a >> 2] = 0;
  v[a + 4 >> 2] = d - 1;
  c = v[a + 88 >> 2];
  if (!b) {
   v[a + 88 >> 2] = c & -135 | 128;
   return;
  }
  v[a + 84 >> 2] = d;
  v[a + 80 >> 2] = 0;
  v[a + 88 >> 2] = c | 134;
 }
}

function BE(a, b, c) {
 var d = 0, e = 0;
 d = (a & 65535) >>> B(c, 3) | 0;
 a = w[b + 12 | 0] & -4 | d >>> 2 & 1;
 e = a | d << 1 & 2;
 a: {
  b: {
   if (d & 2) {
    a = e;
    break b;
   }
   t[b + 12 | 0] = e & 251;
   if (!(d & 1) | !(d >>> 9 - (c << 1) & 1)) {
    break a;
   }
   c = w[b + 13 | 0] | w[b + 14 | 0] << 8;
   t[b + 15 | 0] = c;
   t[b + 16 | 0] = c >>> 8;
  }
  t[b + 12 | 0] = a | 4;
 }
}

function fP(a, b) {
 var c = 0, d = 0;
 v[a + 4 >> 2] = b;
 v[a >> 2] = 126412;
 v[a + 20 >> 2] = 0;
 v[a + 24 >> 2] = 0;
 c = (b >>> 5 | 0) + ((b & 31) != 0) | 0;
 v[a + 12 >> 2] = c;
 d = (b >>> 0) / (c >>> 0) | 0;
 v[a + 8 >> 2] = d;
 v[a + 32 >> 2] = d >>> 0 >= 31 ? -1 : -1 >>> (d ^ 31) | 0;
 v[a + 28 >> 2] = b >>> 0 >= c >>> 0 ? -1 >>> 32 - d | 0 : 0;
 v[a + 16 >> 2] = (B(c, d) - b | 0) + c;
 return a;
}

function WC(a, b, c) {
 var d = 0, e = 0, f = 0, g = 0, h = 0;
 e = eb - 1024 | 0;
 eb = e;
 d = eb - 16 | 0;
 eb = d;
 TC(d + 8 | 0, e);
 f = v[d + 12 >> 2];
 ic(d, v[a >> 2], v[a + 8 >> 2], v[d + 8 >> 2], v[d + 12 >> 2]);
 g = v[d + 4 >> 2];
 if ((g | 0) == (f | 0)) {
  Ub(a, v[d + 12 >> 2]);
 }
 eb = d + 16 | 0;
 if ((f | 0) == (g | 0)) {
  h = UC(e, c) >>> 0 <= b >>> 0;
 }
 eb = e + 1024 | 0;
 return h;
}

function kH(a, b, c, d) {
 var e = 0, f = 0;
 a: {
  e = eb - 48 | 0;
  eb = e;
  f = e + 28 | 0;
  rg(f, a, d);
  a = v[e + 28 >> 2];
  d = e + 4 | 0;
  tg(d, c, Ze(f), a);
  v[31601] = 0;
  a = e + 16 | 0;
  N(218, a | 0, d | 0);
  c = v[31601];
  v[31601] = 0;
  if ((c | 0) != 1) {
   Ae(b, a);
   sb(a);
   Jc(f);
   eb = e + 48 | 0;
   break a;
  }
  a = M() | 0;
  Jc(e + 28 | 0);
  P(a | 0);
  p();
 }
}

function SV(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0;
 d = eb - 16 | 0;
 eb = d;
 c = d + 4 | 0;
 v[c >> 2] = a;
 a = v[a + 4 >> 2];
 v[c + 4 >> 2] = a;
 v[c + 8 >> 2] = a + B(b, 872);
 b = v[c + 4 >> 2];
 a = v[c + 8 >> 2];
 while (1) {
  if ((a | 0) == (b | 0)) {
   hc(c);
   eb = d + 16 | 0;
  } else {
   RV(Qb(b, 0, 872));
   b = b + 872 | 0;
   v[c + 4 >> 2] = b;
   continue;
  }
  break;
 }
}

function Ee(a) {
 var b = 0, c = 0, d = 0;
 o(+a);
 c = j(1) | 0;
 j(0) | 0;
 d = c >>> 20 & 2047;
 if (d >>> 0 <= 1074) {
  if (d >>> 0 <= 1021) {
   return a * 0;
  }
  a = D(a);
  b = a + 4503599627370496 + -4503599627370496 - a;
  a: {
   if (b > .5) {
    a = a + b + -1;
    break a;
   }
   a = a + b;
   if (!(b <= -.5)) {
    break a;
   }
   a = a + 1;
  }
  a = (c | 0) < 0 ? -a : a;
 }
 return a;
}

function Oia(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0;
 e = b;
 d = eb - 16 | 0;
 eb = d;
 b = Hf(a, c);
 $d(d, v[a + 36 >> 2]);
 a: {
  b: {
   if (!b) {
    Pc(d, a + 32 | 0, 5);
    c = -1;
    if (!Fb(v[v[d >> 2] >> 2], v[d + 4 >> 2])) {
     break b;
    }
    break a;
   }
   c = v[b + 16 >> 2];
  }
  XB(v[a + 36 >> 2], e, c);
  f = b;
 }
 ef(a, f);
 eb = d + 16 | 0;
}

function Lca(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0;
 a: {
  if ((a | 0) == (b | 0)) {
   break a;
  }
  c = v[a + 4 >> 2];
  if (c) {
   Bb(c);
   v[a + 4 >> 2] = 0;
  }
  if (hb[v[v[b >> 2] + 8 >> 2]](b) | 0) {
   b = hb[v[v[b >> 2] + 8 >> 2]](b) | 0;
  } else {
   b = 22256;
  }
  c = Fd(Df(b) + 1 | 0);
  v[a + 4 >> 2] = c;
  if (!c) {
   break a;
  }
  yc(c, b, Df(b) + 1 | 0);
 }
 return a | 0;
}

function F7(a, b, c, d, e, f) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 f = f | 0;
 var g = 0, h = 0;
 g = eb - 16 | 0;
 eb = g;
 t[g + 8 | 0] = 37;
 t[g + 9 | 0] = 72;
 t[g + 10 | 0] = 58;
 t[g + 11 | 0] = 37;
 t[g + 12 | 0] = 77;
 t[g + 13 | 0] = 58;
 t[g + 14 | 0] = 37;
 t[g + 15 | 0] = 83;
 h = a;
 a = g + 16 | 0;
 b = qk(h, b, c, d, e, f, g + 8 | 0, a);
 eb = a;
 return b | 0;
}

function A0(a, b, c) {
 var d = 0, e = 0, f = 0, g = 0;
 d = eb - 48 | 0;
 eb = d;
 f = d + 28 | 0;
 rg(f, a, c);
 a = v[d + 28 >> 2];
 e = d + 4 | 0;
 tg(e, 3, Ze(f), a);
 v[31601] = 0;
 g = d + 16 | 0;
 N(218, g | 0, e | 0);
 e = v[31601];
 v[31601] = 0;
 if ((e | 0) != 1) {
  zc(b, g);
  sb(g);
  Jc(f);
  eb = d + 48 | 0;
  return !c | (a | 0) != 0;
 }
 a = M() | 0;
 Jc(d + 28 | 0);
 P(a | 0);
 p();
}

function sY(a, b, c, d) {
 var e = 0, f = 0, g = 0, h = 0, i = 0;
 e = eb - 32 | 0;
 eb = e;
 ed(e + 24 | 0, b, c);
 b = eb - 16 | 0;
 eb = b;
 f = v[e + 28 >> 2];
 g = v[e + 24 >> 2];
 c = f - g | 0;
 h = b, i = rY(d, g, c >> 2) + c | 0, v[h + 12 >> 2] = i;
 pc(e + 16 | 0, f, b + 12 | 0);
 eb = b + 16 | 0;
 b = v[e + 16 >> 2];
 v[e + 12 >> 2] = v[e + 20 >> 2];
 pc(a, b, e + 12 | 0);
 eb = e + 32 | 0;
}

function By(a, b) {
 var c = 0, d = 0, e = 0, f = 0;
 c = eb - 16 | 0;
 eb = c;
 u[b >> 1] = 0;
 t[c + 15 | 0] = 0;
 fi(a, c + 15 | 0);
 d = w[c + 15 | 0];
 e = d >>> 1 | 0;
 f = d & 1;
 d = 0;
 while (1) {
  u[b >> 1] = e;
  if (d >>> 0 >= f >>> 0) {
   eb = c + 16 | 0;
  } else {
   t[c + 15 | 0] = 0;
   fi(a, c + 15 | 0);
   e = x[b >> 1] | w[c + 15 | 0] << 7;
   d = 1;
   continue;
  }
  break;
 }
}

function xD(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0;
 a: {
  c = Mb(a + 8 | 0);
  v[31601] = 0;
  d = Q(202, b | 0) | 0;
  e = v[31601];
  v[31601] = 0;
  b: {
   if ((e | 0) == 1) {
    break b;
   }
   v[31601] = 0;
   R(169, a | 0, b | 0, d | 0);
   a = v[31601];
   v[31601] = 0;
   if ((a | 0) == 1) {
    break b;
   }
   break a;
  }
  a = M() | 0;
  ec(c);
  P(a | 0);
  p();
 }
}

function v0(a) {
 var b = 0, c = 0, d = 0, e = 0;
 c = w[a + 2 | 0];
 b = c + (w[a + 5 | 0] | w[a + 6 | 0] << 8) | 0;
 c = (b >>> 0 < c >>> 0 ? 1 : d) << 1 | b >>> 31;
 d = b << 1;
 b = c;
 a = w[a + 3 | 0] | w[a + 4 | 0] << 8;
 c = a >>> 30 | 0;
 e = d;
 d = a << 2;
 e = e + d | 0;
 a = b + c | 0;
 a = d >>> 0 > e >>> 0 ? a + 1 | 0 : a;
 b = e + 47 | 0;
 gb = b >>> 0 < 47 ? a + 1 | 0 : a;
 return b;
}

function oT(a, b) {
 var c = 0, d = 0;
 d = eb - 16 | 0;
 eb = d;
 c = v[a + 104 >> 2];
 a: {
  if (!c) {
   break a;
  }
  c = v[c >> 2];
  if (!c) {
   break a;
  }
  v[a + 76 >> 2] = c;
  v[a + 88 >> 2] = v[a + 88 >> 2] & -131 | 128;
  v[d + 12 >> 2] = b << 8;
  v[d + 8 >> 2] = c - 1;
  b = c + (v[Gb(d + 12 | 0, d + 8 | 0) >> 2] ^ -1) | 0;
  v[a >> 2] = 0;
  v[a + 4 >> 2] = b;
 }
 eb = d + 16 | 0;
}

function U3(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0;
 e = eb - 16 | 0;
 eb = e;
 b = eq(e + 4 | 0, c, d);
 c = BI(0, Jb(b), 0);
 v[31601] = 0;
 a = T(1385, a | 0, c | 0, 0) | 0;
 c = v[31601];
 v[31601] = 0;
 if ((c | 0) != 1) {
  BI(Jb(a), Jb(b), Cb(v[a + 4 >> 2], w[a + 11 | 0]) + 1 | 0);
  Tb(b);
  eb = e + 16 | 0;
  return;
 }
 a = M() | 0;
 Tb(b);
 P(a | 0);
 p();
}

function RM(a) {
 var b = 0, c = 0, d = 0;
 d = eb - 16 | 0;
 eb = d;
 b = a + 120 | 0;
 cu(w[b + 20 | 0]);
 c = eb - 16 | 0;
 eb = c;
 v[c + 12 >> 2] = d + 15;
 a = eb - 16 | 0;
 eb = a;
 v[a + 12 >> 2] = 1141;
 v[a + 8 >> 2] = 1142;
 v[a + 4 >> 2] = 1143;
 v[a >> 2] = 1144;
 b = hb[v[lq(a, rk(w[b + 20 | 0])) >> 2]](c + 12 | 0, b) | 0;
 eb = a + 16 | 0;
 eb = c + 16 | 0;
 eb = d + 16 | 0;
 return b;
}

function kx(a) {
 t[a | 0] = 0;
 t[a + 1 | 0] = 0;
 t[a + 2 | 0] = 0;
 t[a + 3 | 0] = 0;
 t[a + 4 | 0] = 0;
 t[a + 5 | 0] = 0;
 t[a + 6 | 0] = 0;
 t[a + 7 | 0] = 0;
 t[a + 16 | 0] = 0;
 t[a + 17 | 0] = 0;
 t[a + 18 | 0] = 0;
 t[a + 19 | 0] = 0;
 t[a + 8 | 0] = 0;
 t[a + 9 | 0] = 0;
 t[a + 10 | 0] = 0;
 t[a + 11 | 0] = 0;
 t[a + 12 | 0] = 0;
 t[a + 13 | 0] = 0;
 t[a + 14 | 0] = 0;
 t[a + 15 | 0] = 0;
}

function caa(a) {
 a = a | 0;
 var b = 0, c = 0, d = 0;
 b = eb - 32 | 0;
 eb = b;
 if (!w[a + 8 | 0]) {
  Qj(a + 12 | 0, v[a + 4 >> 2]);
  oe(b + 24 | 0, v[a + 12 >> 2], v[a + 16 >> 2]);
  c = v[v[a >> 2] + 40 >> 2];
  d = v[b + 28 >> 2];
  v[b + 8 >> 2] = v[b + 24 >> 2];
  v[b + 12 >> 2] = d;
  hb[c | 0](b + 16 | 0, a, 0, b + 8 | 0);
  t[a + 8 | 0] = 1;
 }
 eb = b + 32 | 0;
 return v[a + 12 >> 2];
}

function Y_(a) {
 var b = 0;
 if (!((w[a | 0] | w[a + 1 | 0] << 8 | (w[a + 2 | 0] << 16 | w[a + 3 | 0] << 24)) != 320012546 | (w[a + 4 | 0] | w[a + 5 | 0] << 8 | (w[a + 6 | 0] << 16 | w[a + 7 | 0] << 24)) != 184619540 | w[a + 8 | 0] > 1 | ((w[a + 9 | 0] - 1 & 255) >>> 0 > 7 | (w[a + 10 | 0] | w[a + 11 | 0] << 8) >>> 0 > 4096))) {
  b = (w[a + 12 | 0] | w[a + 13 | 0] << 8) >>> 0 < 4097;
 }
 return b;
}

function R3(a, b, c, d, e) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 a = eb - 32 | 0;
 eb = a;
 b = Vl(a + 20 | 0, b, c);
 v[31601] = 0;
 c = T(1386, a + 8 | 0, d | 0, e | 0) | 0;
 d = v[31601];
 v[31601] = 0;
 if ((d | 0) != 1) {
  d = gi(Jb(b), Jb(c));
  sb(c);
  sb(b);
  eb = a + 32 | 0;
  return ((d | 0) < 0 ? -1 : (d | 0) != 0) | 0;
 }
 a = M() | 0;
 sb(b);
 P(a | 0);
 p();
}

function Q3(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0;
 e = eb - 16 | 0;
 eb = e;
 b = Vl(e + 4 | 0, c, d);
 c = zI(0, Jb(b), 0);
 v[31601] = 0;
 a = T(541, a | 0, c | 0, 0) | 0;
 c = v[31601];
 v[31601] = 0;
 if ((c | 0) != 1) {
  zI(Jb(a), Jb(b), Cb(v[a + 4 >> 2], w[a + 11 | 0]) + 1 | 0);
  sb(b);
  eb = e + 16 | 0;
  return;
 }
 a = M() | 0;
 sb(b);
 P(a | 0);
 p();
}

function z7(a, b, c, d, e, f) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 f = f | 0;
 var g = 0, h = 0;
 g = eb - 32 | 0;
 eb = g;
 v[g + 24 >> 2] = 37;
 v[g + 28 >> 2] = 83;
 v[g + 16 >> 2] = 77;
 v[g + 20 >> 2] = 58;
 v[g + 8 >> 2] = 58;
 v[g + 12 >> 2] = 37;
 v[g >> 2] = 37;
 v[g + 4 >> 2] = 72;
 h = b;
 b = g + 32 | 0;
 a = pk(a, h, c, d, e, f, g, b);
 eb = b;
 return a | 0;
}

function At(a) {
 var b = 0, c = 0;
 b = v[a + 72 >> 2];
 v[a + 72 >> 2] = b - 1 | b;
 if (v[a + 20 >> 2] != v[a + 28 >> 2]) {
  hb[v[a + 36 >> 2]](a, 0, 0) | 0;
 }
 v[a + 28 >> 2] = 0;
 v[a + 16 >> 2] = 0;
 v[a + 20 >> 2] = 0;
 b = v[a >> 2];
 if (b & 4) {
  v[a >> 2] = b | 32;
  return -1;
 }
 c = v[a + 44 >> 2] + v[a + 48 >> 2] | 0;
 v[a + 8 >> 2] = c;
 v[a + 4 >> 2] = c;
 return b << 27 >> 31;
}

function kD(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 BY(a, b);
 cd(a, _b(w[b + 8 | 0] | w[b + 9 | 0] << 8 | (w[b + 10 | 0] << 16 | w[b + 11 | 0] << 24)) + 504 | 0);
 AY(a, d);
 a: {
  b = _b(w[b + 32 | 0] | w[b + 33 | 0] << 8 | (w[b + 34 | 0] << 16 | w[b + 35 | 0] << 24));
  if (!b) {
   break a;
  }
  if (!cd(a, b)) {
   break a;
  }
  mD(a, c);
  return;
 }
 Qb(c, 0, 80);
}

function Naa(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0;
 c = v[b >> 2];
 d = v[b + 8 >> 2];
 e = v[b + 4 >> 2];
 a = 0;
 a: while (1) {
  if ((a | 0) != (e | 0)) {
   f = (a << 2) + c | 0;
   b = 0;
   while (1) if ((b | 0) == (d | 0)) {
    a = a + 1 | 0;
    continue a;
   } else {
    v[v[f >> 2] + (b << 2) >> 2] = 0;
    b = b + 1 | 0;
    continue;
   }
  }
  break;
 }
}

function Ji(a) {
 var b = 0, c = 0, d = 0, e = 0;
 b = Yd(a);
 c = b & 63;
 e = b << 24 >> 24;
 a: {
  if (!(b & 64)) {
   break a;
  }
  b = 6;
  while (1) {
   d = Yd(a);
   c = (d & 127) << b | c;
   if (d << 24 >> 24 >= 0) {
    break a;
   }
   d = b >>> 0 < 25;
   b = b + 7 | 0;
   if (d) {
    continue;
   }
   break;
  }
 }
 return (e | 0) < 0 ? (c | 0) < 0 ? -2147483648 : 0 - c | 0 : c;
}

function VC(a, b, c) {
 var d = 0;
 d = eb - 16 | 0;
 eb = d;
 u[d + 12 >> 1] = c;
 u[d + 14 >> 1] = b;
 b = vb(v[a >> 2]);
 c = vb(v[a + 4 >> 2]);
 a = eb - 16 | 0;
 eb = a;
 v[a + 12 >> 2] = b;
 while (1) {
  if (Hb(b, c)) {
   if (x[b >> 1] == x[d + 14 >> 1]) {
    u[b >> 1] = x[d + 12 >> 1];
   }
   b = v[fe(a + 12 | 0) >> 2];
   continue;
  }
  break;
 }
 eb = a + 16 | 0;
 eb = d + 16 | 0;
}

function tua(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0;
 c = eb - 16 | 0;
 eb = c;
 d = Lb(v[a >> 2], v[a + 8 >> 2], 120);
 a: {
  if (!d) {
   a = 0;
   while (1) {
    if ((a | 0) != 120) {
     ch(a + b | 0);
     a = a + 1 | 0;
     continue;
    }
    break;
   }
   break a;
  }
  ac(c + 8 | 0, b, 120);
  rd(c, a, v[c + 8 >> 2], v[c + 12 >> 2]);
 }
 eb = c + 16 | 0;
 return d | 0;
}

function ij(a, b, c) {
 c = c & 176;
 if ((c | 0) == 32) {
  return b;
 }
 a: {
  if ((c | 0) != 16) {
   break a;
  }
  b: {
   c: {
    c = w[a | 0];
    switch (c - 43 | 0) {
    case 0:
    case 2:
     break c;

    default:
     break b;
    }
   }
   return a + 1 | 0;
  }
  if ((c | 0) != 48 | (b - a | 0) < 2 | (w[a + 1 | 0] | 32) != 120) {
   break a;
  }
  a = a + 2 | 0;
 }
 return a;
}

function PG() {
 var a = 0, b = 0, c = 0;
 b = eb - 16 | 0;
 eb = b;
 a = Cc(b + 4 | 0, 14962);
 a: {
  if (!Zc(v[a + 4 >> 2], w[a + 11 | 0])) {
   break a;
  }
  c = 1;
  if ((Sg(a, 14629) | 0) != -1) {
   break a;
  }
  if ((Sg(a, 16798) | 0) != -1) {
   break a;
  }
  if ((Sg(a, 13773) | 0) != -1) {
   break a;
  }
  c = (Sg(a, 13816) | 0) != -1;
 }
 sb(a);
 eb = b + 16 | 0;
 return c | 0;
}

function EW(a) {
 var b = 0, c = 0;
 a: {
  if (w[a + 29 | 0] != 2) {
   break a;
  }
  b = w[a + 28 | 0];
  if ((b | 0) != 26 & (b | 0) != 2 | w[a + 30 | 0] != 2) {
   break a;
  }
  b = w[a + 31 | 0];
  if (b >>> 0 > 21 | !(1 << b & 3146753) | w[a + 33 | 0] > 64) {
   break a;
  }
  b = w[a + 34 | 0];
  if (b >>> 0 >= 65 & (b | 0) != 88) {
   break a;
  }
  c = CW(a + 20 | 0);
 }
 return c;
}

function pL(a, b) {
 var c = 0, d = 0, e = 0;
 o(+a);
 d = j(1) | 0;
 e = j(0) | 0;
 c = d >>> 20 & 2047;
 if ((c | 0) != 2047) {
  if (!c) {
   if (a == 0) {
    c = 0;
   } else {
    a = pL(a * 0x10000000000000000, b);
    c = v[b >> 2] + -64 | 0;
   }
   v[b >> 2] = c;
   return a;
  }
  v[b >> 2] = c - 1022;
  l(0, e | 0);
  l(1, d & -2146435073 | 1071644672);
  a = +n();
 }
 return a;
}

function gba(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0;
 d = eb - 32 | 0;
 eb = d;
 e = d + 4 | 0;
 Gx(e, c);
 c = d + 16 | 0;
 v[c >> 2] = b;
 Uc(c + 4 | 0, e);
 v[31601] = 0;
 N(1124, a + 4 | 0, c | 0);
 a = v[31601];
 v[31601] = 0;
 if ((a | 0) != 1) {
  Nj(c);
  sb(e);
  eb = d + 32 | 0;
  return;
 }
 a = M() | 0;
 Nj(d + 16 | 0);
 sb(d + 4 | 0);
 P(a | 0);
 p();
}

function aT(a, b, c, d) {
 var e = 0;
 e = -2147483648;
 e = !c | !(t[c + 15 | 0] & 1) ? e : v[c + 8 >> 2];
 a: {
  b: {
   if (!(!d | !(w[d + 34 | 0] & 32))) {
    e = x[d + 28 >> 1];
    break b;
   }
   if ((e | 0) == -2147483648) {
    break a;
   }
  }
  Sq(b, e, a);
  if (!Nb(a + 1074312 | 0, 10) | w[a + 480209 | 0] & 64) {
   break a;
  }
  v[b + 88 >> 2] = v[b + 88 >> 2] & -257;
 }
}

function WN(a, b, c) {
 a = a | 0;
 b = +b;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0;
 d = eb - 16 | 0;
 eb = d;
 f = d, g = eO(c), v[f + 8 >> 2] = g;
 c = d + 8 | 0;
 e = v[re(d + 12 | 0, c) >> 2];
 v[31601] = 0;
 b = +oa(1113, a | 0, +b, e | 0);
 a = v[31601];
 v[31601] = 0;
 if ((a | 0) != 1) {
  Wc(c);
  eb = d + 16 | 0;
  return +b;
 }
 a = M() | 0;
 Wc(d + 8 | 0);
 P(a | 0);
 p();
}

function mH(a, b, c, d) {
 var e = 0, f = 0, g = 0, h = 0;
 e = eb - 16 | 0;
 eb = e;
 v[e + 12 >> 2] = c;
 c = e + 12 | 0;
 wc(c, d);
 wc(c, 65535);
 d = x[e + 12 >> 1];
 ug(a, d);
 c = 0;
 while (1) {
  if ((c | 0) == (d | 0)) {
   eb = e + 16 | 0;
  } else {
   f = w[b + c | 0];
   g = Sr(v[a >> 2], v[a + 4 >> 2], c), h = f, u[g >> 1] = h;
   c = c + 1 | 0;
   continue;
  }
  break;
 }
}

function Yra(a) {
 a = a | 0;
 var b = 0, c = 0, d = 0, e = 0;
 b = eb - 32 | 0;
 eb = b;
 t[b + 30 | 0] = 0;
 u[b + 28 >> 1] = 0;
 c = b + 28 | 0;
 d = Yb(b + 8 | 0, c, 3);
 ic(b + 20 | 0, v[a >> 2], v[a + 8 >> 2], v[d >> 2], v[d + 4 >> 2]);
 a: {
  if (v[b + 24 >> 2] != 3) {
   break a;
  }
  if (id(c, 14722, 3)) {
   break a;
  }
  Ub(a, 3);
  e = 1;
 }
 eb = b + 32 | 0;
 return e | 0;
}

function Xna(a) {
 a = a | 0;
 var b = 0, c = 0, d = 0, e = 0;
 b = eb - 32 | 0;
 eb = b;
 u[b + 28 >> 1] = 0;
 v[b + 24 >> 2] = 0;
 c = b + 24 | 0;
 d = Yb(b + 8 | 0, c, 6);
 ic(b + 16 | 0, v[a >> 2], v[a + 8 >> 2], v[d >> 2], v[d + 4 >> 2]);
 a: {
  if (v[b + 20 >> 2] != 6) {
   break a;
  }
  if (id(c, 3856, 6)) {
   break a;
  }
  Ub(a, 6);
  e = 1;
 }
 eb = b + 32 | 0;
 return e | 0;
}

function Wta(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0;
 a: {
  d = eb - 32 | 0;
  eb = d;
  e = d + 20 | 0;
  Gr(e, c);
  tj(d + 12 | 0, e);
  v[31601] = 0;
  U(301, a | 0, b | 0, v[d + 12 >> 2], v[d + 16 >> 2]);
  a = v[31601];
  v[31601] = 0;
  if ((a | 0) != 1) {
   Db(e);
   eb = d + 32 | 0;
   break a;
  }
  a = M() | 0;
  Db(d + 20 | 0);
  P(a | 0);
  p();
 }
}

function Gpa(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0;
 a: {
  d = eb - 32 | 0;
  eb = d;
  e = d + 20 | 0;
  br(e, c);
  tj(d + 12 | 0, e);
  v[31601] = 0;
  U(301, a | 0, b | 0, v[d + 12 >> 2], v[d + 16 >> 2]);
  a = v[31601];
  v[31601] = 0;
  if ((a | 0) != 1) {
   Db(e);
   eb = d + 32 | 0;
   break a;
  }
  a = M() | 0;
  Db(d + 20 | 0);
  P(a | 0);
  p();
 }
}

function zoa(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0;
 a: {
  d = eb - 32 | 0;
  eb = d;
  e = d + 20 | 0;
  OZ(e, c);
  tj(d + 12 | 0, e);
  v[31601] = 0;
  U(92, a | 0, b | 0, v[d + 12 >> 2], v[d + 16 >> 2]);
  a = v[31601];
  v[31601] = 0;
  if ((a | 0) != 1) {
   Db(e);
   eb = d + 32 | 0;
   break a;
  }
  a = M() | 0;
  Db(d + 20 | 0);
  P(a | 0);
  p();
 }
}

function Jra(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0;
 a: {
  d = eb - 32 | 0;
  eb = d;
  e = d + 20 | 0;
  Wv(e, c);
  tj(d + 12 | 0, e);
  v[31601] = 0;
  U(92, a | 0, b | 0, v[d + 12 >> 2], v[d + 16 >> 2]);
  a = v[31601];
  v[31601] = 0;
  if ((a | 0) != 1) {
   Db(e);
   eb = d + 32 | 0;
   break a;
  }
  a = M() | 0;
  Db(d + 20 | 0);
  P(a | 0);
  p();
 }
}

function Era(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0;
 a: {
  d = eb - 32 | 0;
  eb = d;
  e = d + 20 | 0;
  Op(e, c);
  tj(d + 12 | 0, e);
  v[31601] = 0;
  U(92, a | 0, b | 0, v[d + 12 >> 2], v[d + 16 >> 2]);
  a = v[31601];
  v[31601] = 0;
  if ((a | 0) != 1) {
   Db(e);
   eb = d + 32 | 0;
   break a;
  }
  a = M() | 0;
  Db(d + 20 | 0);
  P(a | 0);
  p();
 }
}

function yka(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0;
 c = eb - 16 | 0;
 eb = c;
 d = Lb(v[a >> 2], v[a + 8 >> 2], 16);
 a: {
  if (!d) {
   a = 0;
   while (1) {
    if ((a | 0) != 16) {
     ch(a + b | 0);
     a = a + 1 | 0;
     continue;
    }
    break;
   }
   break a;
  }
  fE(c + 8 | 0, b);
  rd(c, a, v[c + 8 >> 2], v[c + 12 >> 2]);
 }
 eb = c + 16 | 0;
 return d | 0;
}

function dta(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0;
 c = eb - 16 | 0;
 eb = c;
 d = Lb(v[a >> 2], v[a + 8 >> 2], 64);
 a: {
  if (!d) {
   a = 0;
   while (1) {
    if ((a | 0) != 64) {
     rp(a + b | 0);
     a = a + 2 | 0;
     continue;
    }
    break;
   }
   break a;
  }
  mw(c + 8 | 0, b);
  rd(c, a, v[c + 8 >> 2], v[c + 12 >> 2]);
 }
 eb = c + 16 | 0;
 return d | 0;
}

function _E(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0;
 a: {
  d = eb - 32 | 0;
  eb = d;
  e = d + 20 | 0;
  Bw(e, c);
  tj(d + 12 | 0, e);
  v[31601] = 0;
  U(92, a | 0, b | 0, v[d + 12 >> 2], v[d + 16 >> 2]);
  a = v[31601];
  v[31601] = 0;
  if ((a | 0) != 1) {
   Db(e);
   eb = d + 32 | 0;
   break a;
  }
  a = M() | 0;
  Db(d + 20 | 0);
  P(a | 0);
  p();
 }
}

function W_(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0;
 a: {
  d = eb - 32 | 0;
  eb = d;
  e = d + 20 | 0;
  GE(e, c);
  tj(d + 12 | 0, e);
  v[31601] = 0;
  U(92, a | 0, b | 0, v[d + 12 >> 2], v[d + 16 >> 2]);
  a = v[31601];
  v[31601] = 0;
  if ((a | 0) != 1) {
   Db(e);
   eb = d + 32 | 0;
   break a;
  }
  a = M() | 0;
  Db(d + 20 | 0);
  P(a | 0);
  p();
 }
}

function KG(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0;
 a: {
  d = eb - 32 | 0;
  eb = d;
  e = d + 20 | 0;
  $n(e, c);
  tj(d + 12 | 0, e);
  v[31601] = 0;
  U(92, a | 0, b | 0, v[d + 12 >> 2], v[d + 16 >> 2]);
  a = v[31601];
  v[31601] = 0;
  if ((a | 0) != 1) {
   Db(e);
   eb = d + 32 | 0;
   break a;
  }
  a = M() | 0;
  Db(d + 20 | 0);
  P(a | 0);
  p();
 }
}

function oZ(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0;
 d = sn(a);
 e = Cb(v[a + 4 >> 2], w[a + 11 | 0]);
 a: {
  if (d - e >>> 0 >= c >>> 0) {
   if (!c) {
    break a;
   }
   d = Jb(a);
   Qi(d + (e << 2) | 0, b, c);
   b = c + e | 0;
   kg(a, b);
   xd(d + (b << 2) | 0, 0);
   return a | 0;
  }
  nI(a, d, (c - d | 0) + e | 0, e, e, 0, c, b);
 }
 return a | 0;
}

function _P(a, b, c) {
 var d = 0, e = 0;
 if (C(D(a)) < C(0x8000000000000000)) {
  e = ~~a >>> 0;
 } else {
  e = 0;
 }
 d = e >> 31;
 d = (e ^ d) - d | 0;
 while (1) {
  if (!((d | 0) < 0 | (b | 0) <= 0)) {
   b = b - 1 | 0;
   d = d << 1;
   continue;
  }
  break;
 }
 b = (d >>> 31 | 0) + b << 31 - c | (d & 2147483647) >>> c;
 return C(((e | 0) < 0 ? b ^ -1 | -2147483648 : b) | 0);
}

function Dpa(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0;
 c = eb - 16 | 0;
 eb = c;
 d = Lb(v[a >> 2], v[a + 8 >> 2], 6);
 a: {
  if (!d) {
   a = 0;
   while (1) {
    if ((a | 0) != 6) {
     ch(a + b | 0);
     a = a + 1 | 0;
     continue;
    }
    break;
   }
   break a;
  }
  YD(c + 8 | 0, b);
  rd(c, a, v[c + 8 >> 2], v[c + 12 >> 2]);
 }
 eb = c + 16 | 0;
 return d | 0;
}

function DU(a, b) {
 a: {
  if (w[a + 76 | 0] == (b | 0)) {
   break a;
  }
  t[a + 76 | 0] = b;
  if (b) {
   b = 0;
   if (x[a + 24 >> 1] == 15) {
    u[a + 20 >> 1] = 0;
    b = 1;
   }
   v[a + 8 >> 2] = 0;
   v[a + 16 >> 2] = b;
   return;
  }
  b: {
   switch (v[a + 16 >> 2] + 1 | 0) {
   case 0:
   case 4:
    break a;

   default:
    break b;
   }
  }
  v[a + 16 >> 2] = 3;
 }
}

function CR(a, b, c) {
 var d = 0, e = 0, f = 0, g = 0, h = 0;
 g = c;
 h = c >> 31;
 c = 0;
 while (1) {
  if ((b | 0) != (c | 0)) {
   d = v[a >> 2];
   e = v[a + 4 >> 2];
   f = (d + e | 0) / 2 | 0;
   d = d - e | 0;
   d = Fc(Bua(Aua(d, d >> 31, g, h), gb, 256, 0), gb);
   v[a + 4 >> 2] = f - d;
   v[a >> 2] = d + f;
   c = c + 1 | 0;
   a = a + 8 | 0;
   continue;
  }
  break;
 }
}

function YQ(a, b, c) {
 var d = 0, e = 0, f = 0, g = 0;
 while (1) {
  if ((b | 0) != (c | 0)) {
   d = v[a >> 2];
   e = v[a + 4 >> 2];
   f = e >>> 8 | 0;
   g = (e & 255) << 24 | d >>> 8;
   d = (((w[b | 0] ^ d) & 255) << 3) + 22288 | 0;
   e = v[d >> 2];
   d = v[d + 4 >> 2] ^ f;
   v[a >> 2] = e ^ g;
   v[a + 4 >> 2] = d;
   b = b + 1 | 0;
   continue;
  }
  break;
 }
 return a;
}

function Eg(a, b) {
 var c = 0, d = 0, e = 0, f = 0;
 d = a + 26 | 0;
 c = x[a + 22 >> 1];
 e = c + x[a + 20 >> 1] | 0;
 a = x[a + 24 >> 1] << 17;
 while (1) {
  if ((c | 0) == (e | 0)) {
   a = (a | 0) / 32768 | 0;
  } else {
   f = a;
   a = ((c & 127) << 2) + d | 0;
   a = f - B(v[xb(b, x[a + 2 >> 1]) >> 2], u[a >> 1]) | 0;
   c = c + 1 | 0;
   continue;
  }
  break;
 }
 return a;
}

function jba(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0;
 e = eb - 16 | 0;
 eb = e;
 d = kv(e + 4 | 0, a, d);
 f = v[d + 4 >> 2];
 v[31601] = 0;
 a = aa(1122, zb(a) | 0, b | 0, c | 0, f | 0) | 0;
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  v[d + 4 >> 2] = a;
  hc(d);
  eb = e + 16 | 0;
  return;
 }
 a = M() | 0;
 hc(d);
 P(a | 0);
 p();
}

function Fga(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0;
 a = Ii(a, b, c, d);
 v[a >> 2] = 44880;
 b = a + 4208 | 0;
 e = xb(b, 0), f = 1017370378, v[e >> 2] = f;
 e = xb(b, 1), f = 0, v[e >> 2] = f;
 v[31601] = 0;
 N(940, a + 44 | 0, 2);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  return a | 0;
 }
 b = M() | 0;
 Zf(a);
 P(b | 0);
 p();
}

function kU(a) {
 var b = 0, c = 0, d = 0, e = 0;
 c = eb - 16 | 0;
 eb = c;
 b = v[a >> 2];
 e = Ck(b, v[a + 4 >> 2]);
 b = vb(b);
 v[c + 12 >> 2] = b;
 d = +(e >>> 0);
 a = vb(v[a + 4 >> 2]);
 while (1) {
  if (Hb(b, a)) {
   A[b >> 3] = A[b >> 3] / d;
   A[b + 8 >> 3] = A[b + 8 >> 3] / d;
   b = v[Uo(c + 12 | 0) >> 2];
   continue;
  } else {
   eb = c + 16 | 0;
  }
  break;
 }
}

function N9(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0;
 e = eb - 16 | 0;
 eb = e;
 d = wv(e + 4 | 0, a, d);
 f = v[d + 4 >> 2];
 v[31601] = 0;
 a = aa(1206, zb(a) | 0, b | 0, c | 0, f | 0) | 0;
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  v[d + 4 >> 2] = a;
  hc(d);
  eb = e + 16 | 0;
  return;
 }
 a = M() | 0;
 hc(d);
 P(a | 0);
 p();
}

function rg(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0;
 d = Mb(a + 8 | 0);
 v[31601] = 0;
 R(169, a | 0, b | 0, c | 0);
 c = v[31601];
 v[31601] = 0;
 a: {
  if ((c | 0) != 1) {
   a = v[a >> 2];
   v[31601] = 0;
   O(183, b | 0, a | 0) | 0;
   a = v[31601];
   v[31601] = 0;
   if ((a | 0) != 1) {
    break a;
   }
  }
  a = M() | 0;
  ec(d);
  P(a | 0);
  p();
 }
}

function c2(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0, h = 0;
 e = eb - 16 | 0;
 eb = e;
 f = v[d >> 2];
 g = v[b + 8 >> 2];
 if (g >>> 0 > c >>> 0) {
  v[e + 12 >> 2] = g - c;
  v[e + 8 >> 2] = v[d + 4 >> 2];
  b = v[b + 4 >> 2] + c | 0;
  h = v[Gb(e + 12 | 0, e + 8 | 0) >> 2];
  wk(b, b + h | 0, f);
 }
 ac(a, f, h);
 eb = e + 16 | 0;
}

function Ai(a, b, c) {
 var d = 0, e = 0, f = 0, g = 0;
 v[a + 112 >> 2] = b;
 v[a + 116 >> 2] = c;
 e = v[a + 4 >> 2];
 d = v[a + 44 >> 2] - e | 0;
 v[a + 120 >> 2] = d;
 v[a + 124 >> 2] = d >> 31;
 d = a;
 a = v[a + 8 >> 2];
 f = a - e | 0;
 g = f >> 31;
 if (!(!(b | c) | ((c | 0) >= (g | 0) & b >>> 0 >= f >>> 0 | (c | 0) > (g | 0)))) {
  a = b + e | 0;
 }
 v[d + 104 >> 2] = a;
}

function Y$(a, b, c) {
 var d = 0, e = 0;
 d = eb - 48 | 0;
 eb = d;
 sf(b);
 e = d + 28 | 0;
 rg(e, a, c);
 a = v[d + 28 >> 2];
 c = d + 4 | 0;
 tg(c, 2, Ze(e), a);
 v[31601] = 0;
 a = d + 16 | 0;
 N(218, a | 0, c | 0);
 c = v[31601];
 v[31601] = 0;
 if ((c | 0) != 1) {
  yb(b, a);
  sb(a);
  Jc(e);
  eb = d + 48 | 0;
  return;
 }
 a = M() | 0;
 Jc(d + 28 | 0);
 P(a | 0);
 p();
}

function FT(a, b) {
 var c = 0;
 c = w[b | 0] | w[b + 1 | 0] << 8 | (w[b + 2 | 0] << 16 | w[b + 3 | 0] << 24);
 t[a | 0] = c;
 t[a + 1 | 0] = c >>> 8;
 t[a + 2 | 0] = c >>> 16;
 t[a + 3 | 0] = c >>> 24;
 b = w[b + 3 | 0] | w[b + 4 | 0] << 8 | (w[b + 5 | 0] << 16 | w[b + 6 | 0] << 24);
 t[a + 3 | 0] = b;
 t[a + 4 | 0] = b >>> 8;
 t[a + 5 | 0] = b >>> 16;
 t[a + 6 | 0] = b >>> 24;
}

function Eta(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0;
 c = eb - 16 | 0;
 eb = c;
 dx(c + 8 | 0, b);
 d = v[c + 12 >> 2];
 ic(c, v[a >> 2], v[a + 8 >> 2], v[c + 8 >> 2], v[c + 12 >> 2]);
 e = v[c + 4 >> 2];
 if ((e | 0) == (d | 0)) {
  Ub(a, v[c + 12 >> 2]);
 }
 eb = c + 16 | 0;
 if ((d | 0) != (e | 0)) {
  t[b + 2 | 0] = 0;
  t[b | 0] = 0;
  t[b + 1 | 0] = 0;
 }
}

function EF(a, b) {
 var c = 0, d = 0;
 c = eb - 16 | 0;
 eb = c;
 a: {
  if (b >>> 0 < 2) {
   b: {
    if (!b) {
     break b;
    }
    if (!Lb(v[a >> 2], v[a + 8 >> 2], 1)) {
     break b;
    }
    t[c + 15 | 0] = 0;
    dh(a, c + 15 | 0);
    d = t[c + 15 | 0];
   }
   eb = c + 16 | 0;
   a = d << 24 >> 24;
   break a;
  }
  Z(11235, 9079, 324, 14199);
  p();
 }
 return a;
}

function c5(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0;
 a = sJ(a, 0);
 v[a >> 2] = 101304;
 c = Eb(a + 12 | 0);
 d = Eb(a + 24 | 0);
 e = Eb(a + 36 | 0);
 f = Eb(a + 48 | 0);
 b = Jb(b);
 v[31601] = 0;
 N(1369, a | 0, b | 0);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  return a | 0;
 }
 a = M() | 0;
 sb(f);
 sb(e);
 sb(d);
 sb(c);
 P(a | 0);
 p();
}

function a5(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0;
 a = rJ(a, 0);
 v[a >> 2] = 101408;
 c = Eb(a + 12 | 0);
 d = Eb(a + 24 | 0);
 e = Eb(a + 36 | 0);
 f = Eb(a + 48 | 0);
 b = Jb(b);
 v[31601] = 0;
 N(1370, a | 0, b | 0);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  return a | 0;
 }
 a = M() | 0;
 sb(f);
 sb(e);
 sb(d);
 sb(c);
 P(a | 0);
 p();
}

function _4(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0;
 a = qJ(a, 0);
 v[a >> 2] = 101512;
 c = Eb(a + 16 | 0);
 d = Eb(a + 28 | 0);
 e = Eb(a + 40 | 0);
 f = Eb(a + 52 | 0);
 b = Jb(b);
 v[31601] = 0;
 N(1371, a | 0, b | 0);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  return a | 0;
 }
 a = M() | 0;
 Tb(f);
 Tb(e);
 Tb(d);
 sb(c);
 P(a | 0);
 p();
}

function Y4(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0;
 a = pJ(a, 0);
 v[a >> 2] = 101616;
 c = Eb(a + 16 | 0);
 d = Eb(a + 28 | 0);
 e = Eb(a + 40 | 0);
 f = Eb(a + 52 | 0);
 b = Jb(b);
 v[31601] = 0;
 N(1372, a | 0, b | 0);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  return a | 0;
 }
 a = M() | 0;
 Tb(f);
 Tb(e);
 Tb(d);
 sb(c);
 P(a | 0);
 p();
}

function St(a) {
 var b = 0;
 a: {
  b = w[a + 1376 | 0];
  b: {
   if (!b) {
    b = -1;
    if (v[a + 1384 >> 2]) {
     break b;
    }
    if (!gz(a)) {
     break b;
    }
    b = w[a + 1376 | 0];
    if (!b) {
     break a;
    }
   }
   t[a + 1376 | 0] = b - 1;
   v[a + 1400 >> 2] = v[a + 1400 >> 2] + 1;
   b = ff(a);
  }
  return b;
 }
 Z(15740, 13258, 1578, 5429);
 p();
}

function ez(a) {
 var b = 0;
 a: {
  b: {
   while (1) {
    if (v[a + 1380 >> 2] != -1) {
     break b;
    }
    b = 0;
    if (!Rt(a)) {
     break a;
    }
    if (!(t[a + 1375 | 0] & 1)) {
     continue;
    }
    break;
   }
   bc(a, 32);
   return 0;
  }
  v[a + 1396 >> 2] = 0;
  v[a + 1400 >> 2] = 0;
  v[a + 1384 >> 2] = 0;
  t[a + 1376 | 0] = 0;
  b = 1;
 }
 return b;
}

function EV(a, b, c) {
 var d = 0, e = 0, f = 0;
 d = eb - 16 | 0;
 eb = d;
 a: {
  if (!(c & 32)) {
   break a;
  }
  c = yd(b);
  v[d + 12 >> 2] = c;
  f = Cf(b);
  while (1) {
   if (!Hb(c, f)) {
    break a;
   }
   e = w[c | 0];
   if ((e - 97 & 255) >>> 0 <= 25) {
    t[c | 0] = e - 32;
   }
   c = v[xe(d + 12 | 0) >> 2];
   continue;
  }
 }
 Uc(a, b);
 eb = d + 16 | 0;
}

function epa(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0;
 b = eb - 32 | 0;
 eb = b;
 d = b + 20 | 0;
 c = -1;
 a: {
  if (!dE(a, d)) {
   break a;
  }
  c = 0;
  if (!iX(d)) {
   break a;
  }
  c = -1;
  if (!gk(a, b + 12 | 0)) {
   break a;
  }
  c = 0;
  if (!v[b + 16 >> 2]) {
   break a;
  }
  c = !(v[b + 12 >> 2] & -2139062144);
 }
 eb = b + 32 | 0;
 return c | 0;
}

function zda(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0;
 a = v[a + 8 >> 2];
 a: {
  if (zd(v[b + 4 >> 2], w[b + 11 | 0])) {
   c = 0;
  } else {
   c = a;
   if (Md(b, 47264)) {
    break a;
   }
   c = a + 88 | 0;
   if (Md(b, 47276)) {
    break a;
   }
   c = a + 92 | 0;
   if (Md(b, 47288)) {
    break a;
   }
   c = Md(b, 47301) ? a + 96 | 0 : 0;
  }
 }
 return c | 0;
}

function nx(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0;
 e = eb - 16 | 0;
 eb = e;
 lf(e + 8 | 0, b, c);
 v[31601] = 0;
 La(165, a | 0, v[e + 8 >> 2], v[e + 12 >> 2]);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  v[a + 8 >> 2] = 0;
  Ef(a + 12 | 0, d);
  le(d);
  eb = e + 16 | 0;
  return a | 0;
 }
 a = M() | 0;
 le(d);
 P(a | 0);
 p();
}

function wm(a, b, c, d) {
 var e = 0, f = 0, g = 0;
 e = eb - 16 | 0;
 eb = e;
 Kg(a + 12 | 0, d);
 a: {
  if (!b) {
   d = 0;
   b = 0;
   break a;
  }
  VG(e + 8 | 0, b);
  d = v[e + 12 >> 2];
  b = v[e + 8 >> 2];
 }
 v[a >> 2] = b;
 c = b + B(c, 12) | 0;
 v[a + 8 >> 2] = c;
 v[a + 4 >> 2] = c;
 f = mc(a), g = b + B(d, 12) | 0, v[f >> 2] = g;
 eb = e + 16 | 0;
 return a;
}

function jv(a, b, c, d) {
 var e = 0, f = 0, g = 0;
 e = eb - 16 | 0;
 eb = e;
 Kg(a + 12 | 0, d);
 a: {
  if (!b) {
   d = 0;
   b = 0;
   break a;
  }
  JV(e + 8 | 0, b);
  d = v[e + 12 >> 2];
  b = v[e + 8 >> 2];
 }
 v[a >> 2] = b;
 c = b + (c << 5) | 0;
 v[a + 8 >> 2] = c;
 v[a + 4 >> 2] = c;
 f = mc(a), g = b + (d << 5) | 0, v[f >> 2] = g;
 eb = e + 16 | 0;
 return a;
}

function js(a, b, c, d) {
 var e = 0, f = 0, g = 0;
 e = eb - 16 | 0;
 eb = e;
 Kg(a + 12 | 0, d);
 a: {
  if (!b) {
   d = 0;
   b = 0;
   break a;
  }
  qG(e + 8 | 0, b);
  d = v[e + 12 >> 2];
  b = v[e + 8 >> 2];
 }
 v[a >> 2] = b;
 c = b + (c << 3) | 0;
 v[a + 8 >> 2] = c;
 v[a + 4 >> 2] = c;
 f = mc(a), g = b + (d << 3) | 0, v[f >> 2] = g;
 eb = e + 16 | 0;
 return a;
}

function dk(a, b, c, d) {
 var e = 0, f = 0, g = 0;
 e = eb - 16 | 0;
 eb = e;
 Kg(a + 12 | 0, d);
 a: {
  if (!b) {
   d = 0;
   b = 0;
   break a;
  }
  Zw(e + 8 | 0, b);
  d = v[e + 12 >> 2];
  b = v[e + 8 >> 2];
 }
 v[a >> 2] = b;
 c = b + (c << 1) | 0;
 v[a + 8 >> 2] = c;
 v[a + 4 >> 2] = c;
 f = mc(a), g = b + (d << 1) | 0, v[f >> 2] = g;
 eb = e + 16 | 0;
 return a;
}

function XB(a, b, c) {
 var d = 0;
 a: {
  switch (c + 1 | 0) {
  case 0:
  case 3:
   IU(a, b);
   return;

  default:
   break a;
  }
 }
 d = eb - 32 | 0;
 eb = d;
 v[d + 28 >> 2] = c;
 u[d + 26 >> 1] = 0;
 v[d + 12 >> 2] = 2;
 c = d + 16 | 0;
 sz(c, a, d + 26 | 0, v[Gb(d + 28 | 0, d + 12 | 0) >> 2]);
 _i(c, x[d + 26 >> 1]);
 u[b >> 1] = x[d + 16 >> 1];
 eb = d + 32 | 0;
}

function VD(a, b, c, d) {
 var e = 0, f = 0, g = 0;
 e = eb - 16 | 0;
 eb = e;
 Kg(a + 12 | 0, d);
 a: {
  if (!b) {
   d = 0;
   b = 0;
   break a;
  }
  RE(e + 8 | 0, b);
  d = v[e + 12 >> 2];
  b = v[e + 8 >> 2];
 }
 v[a >> 2] = b;
 c = b + B(c, 20) | 0;
 v[a + 8 >> 2] = c;
 v[a + 4 >> 2] = c;
 f = mc(a), g = b + B(d, 20) | 0, v[f >> 2] = g;
 eb = e + 16 | 0;
 return a;
}

function MV(a, b, c, d) {
 var e = 0, f = 0, g = 0;
 e = eb - 16 | 0;
 eb = e;
 Kg(a + 12 | 0, d);
 a: {
  if (!b) {
   d = 0;
   b = 0;
   break a;
  }
  LV(e + 8 | 0, b);
  d = v[e + 12 >> 2];
  b = v[e + 8 >> 2];
 }
 v[a >> 2] = b;
 c = b + (c << 4) | 0;
 v[a + 8 >> 2] = c;
 v[a + 4 >> 2] = c;
 f = mc(a), g = b + (d << 4) | 0, v[f >> 2] = g;
 eb = e + 16 | 0;
 return a;
}

function wT(a, b, c) {
 var d = 0;
 d = v[b + 48 >> 2] + 1 | 0;
 v[b + 52 >> 2] = d;
 a: {
  if (y[Vb(v[a + 484344 >> 2], x[b + 70 >> 1]) + 12 >> 2] > d >>> 0) {
   break a;
  }
  if (!c) {
   u[b + 74 >> 1] = x[b + 72 >> 1] + 1;
  }
  v[b + 52 >> 2] = 0;
  if (!Nb(a + 1074312 | 0, 63)) {
   break a;
  }
  a = v[b + 56 >> 2];
  v[b + 56 >> 2] = 0;
  v[b + 52 >> 2] = a;
 }
}

function iE(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0;
 e = v[a >> 2];
 f = fm(e, v[a + 4 >> 2]);
 while (1) {
  a: {
   c = d & 65535;
   if (c >>> 0 >= f >>> 0) {
    break a;
   }
   c = Zi(e, c);
   if (!Hb(v[c >> 2], v[c + 4 >> 2])) {
    break a;
   }
   d = d + 1 | 0;
   continue;
  }
  break;
 }
 return (Og(a, d & 65535, b) ? d : -1) & 65535;
}

function cr(a, b) {
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0;
 c = eb - 16 | 0;
 eb = c;
 d = ub(c + 12 | 0, v[a + 4 >> 2]);
 e = ub(c + 8 | 0, v[a >> 2]);
 f = ub(c + 4 | 0, v[b + 4 >> 2]);
 g = b, h = PW(v[d >> 2], v[e >> 2], v[f >> 2]), v[g + 4 >> 2] = h;
 Sb(a, b + 4 | 0);
 Sb(a + 4 | 0, b + 8 | 0);
 Sb(zb(a), mc(b));
 v[b >> 2] = v[b + 4 >> 2];
 eb = c + 16 | 0;
}

function Zr(a, b) {
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0;
 c = eb - 16 | 0;
 eb = c;
 d = ub(c + 12 | 0, v[a + 4 >> 2]);
 e = ub(c + 8 | 0, v[a >> 2]);
 f = ub(c + 4 | 0, v[b + 4 >> 2]);
 g = b, h = MF(v[d >> 2], v[e >> 2], v[f >> 2]), v[g + 4 >> 2] = h;
 Sb(a, b + 4 | 0);
 Sb(a + 4 | 0, b + 8 | 0);
 Sb(zb(a), mc(b));
 v[b >> 2] = v[b + 4 >> 2];
 eb = c + 16 | 0;
}

function Ur(a, b) {
 var c = 0, d = 0, e = 0, f = 0, g = 0, h = 0;
 c = eb - 16 | 0;
 eb = c;
 d = ub(c + 12 | 0, v[a + 4 >> 2]);
 e = ub(c + 8 | 0, v[a >> 2]);
 f = ub(c + 4 | 0, v[b + 4 >> 2]);
 g = b, h = NF(v[d >> 2], v[e >> 2], v[f >> 2]), v[g + 4 >> 2] = h;
 Sb(a, b + 4 | 0);
 Sb(a + 4 | 0, b + 8 | 0);
 Sb(zb(a), mc(b));
 v[b >> 2] = v[b + 4 >> 2];
 eb = c + 16 | 0;
}

function Jt(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0;
 d = Lc(a);
 e = Cb(v[a + 4 >> 2], w[a + 11 | 0]);
 a: {
  if (d - e >>> 0 >= c >>> 0) {
   if (!c) {
    break a;
   }
   d = Jb(a);
   Cg(d + e | 0, b, c);
   b = c + e | 0;
   kg(a, b);
   gd(b + d | 0, 0);
   return a | 0;
  }
  Zp(a, d, (c - d | 0) + e | 0, e, e, 0, c, b);
 }
 return a | 0;
}

function jZ(a, b, c, d) {
 var e = 0, f = 0, g = 0;
 e = eb - 16 | 0;
 eb = e;
 Kg(a + 12 | 0, d);
 a: {
  if (!b) {
   d = 0;
   b = 0;
   break a;
  }
  gZ(e + 8 | 0, b);
  d = v[e + 12 >> 2];
  b = v[e + 8 >> 2];
 }
 v[a >> 2] = b;
 c = b + B(c, 6) | 0;
 v[a + 8 >> 2] = c;
 v[a + 4 >> 2] = c;
 f = mc(a), g = b + B(d, 6) | 0, v[f >> 2] = g;
 eb = e + 16 | 0;
 return a;
}

function gX(a) {
 var b = 0, c = 0, d = 0, e = 0;
 c = eb - 16 | 0;
 eb = c;
 d = ub(c + 12 | 0, a);
 a = v[d >> 2];
 if (v[a >> 2]) {
  e = v[a >> 2];
  b = v[a + 4 >> 2];
  while (1) {
   if ((b | 0) != (e | 0)) {
    b = b - 56 | 0;
    ar(b);
    continue;
   }
   break;
  }
  v[a + 4 >> 2] = e;
  a = v[d >> 2];
  b = v[a >> 2];
  dX(a);
  Bb(b);
 }
 eb = c + 16 | 0;
}

function bu(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0;
 c = eb - 16 | 0;
 eb = c;
 d = v[b >> 2];
 b = nc(d, v[b + 4 >> 2]);
 a = 0;
 while (1) {
  if ((a | 0) == (b | 0)) {
   eb = c + 16 | 0;
  } else {
   v[c + 12 >> 2] = 0;
   e = sc(c + 12 | 0);
   f = xb(d, a), g = v[e >> 2], v[f >> 2] = g;
   a = a + 1 | 0;
   continue;
  }
  break;
 }
}

function C0(a, b, c) {
 var d = 0, e = 0;
 d = eb - 48 | 0;
 eb = d;
 e = d + 28 | 0;
 rg(e, a, c);
 a = v[d + 28 >> 2];
 c = d + 4 | 0;
 tg(c, 3, Ze(e), a);
 v[31601] = 0;
 a = d + 16 | 0;
 N(218, a | 0, c | 0);
 c = v[31601];
 v[31601] = 0;
 if ((c | 0) != 1) {
  em(b, a);
  sb(a);
  Jc(e);
  eb = d + 48 | 0;
  return;
 }
 a = M() | 0;
 Jc(d + 28 | 0);
 P(a | 0);
 p();
}

function Wf(a, b, c) {
 var d = 0;
 a: {
  if (y[b + 8 >> 2] < c >>> 0) {
   v[31601] = 0;
   U(1163, 17397, 9110, 435, 6381);
   a = v[31601];
   v[31601] = 0;
   if ((a | 0) == 1) {
    break a;
   }
   p();
  }
  d = v[b + 4 >> 2];
  v[a >> 2] = v[b >> 2];
  v[a + 4 >> 2] = d;
  v[a + 8 >> 2] = v[b + 8 >> 2];
  v[a + 12 >> 2] = c;
  return;
 }
 S(0) | 0;
 Rb();
 p();
}

function Bua(a, b, c, d) {
 var e = 0, f = 0, g = 0, h = 0;
 f = b ^ d;
 g = f >> 31;
 e = b >> 31;
 a = a ^ e;
 h = a - e | 0;
 e = (b ^ e) - ((a >>> 0 < e >>> 0) + e | 0) | 0;
 a = d >> 31;
 b = c ^ a;
 f = f >> 31;
 a = Cua(h, e, b - a | 0, (a ^ d) - ((a >>> 0 > b >>> 0) + a | 0) | 0) ^ f;
 b = a - f | 0;
 gb = (g ^ gb) - ((a >>> 0 < f >>> 0) + g | 0) | 0;
 return b;
}

function uT(a, b, c) {
 var d = 0, e = 0, f = 0;
 d = eb - 16 | 0;
 eb = d;
 a: {
  if (!c) {
   break a;
  }
  v[b + 40 >> 2] = c;
  if (!c | v[a + 480180 >> 2] != 256) {
   break a;
  }
  v[d + 12 >> 2] = c >>> 4;
  v[d + 8 >> 2] = 1;
  e = b, f = v[ad(d + 12 | 0, d + 8 | 0) >> 2], v[e + 40 >> 2] = f;
  e = b, f = BC(c & 255), v[e + 44 >> 2] = f;
 }
 eb = d + 16 | 0;
}

function rv(a) {
 var b = 0;
 a: {
  if (w[a + 4 | 0] | (w[a | 0] | w[a + 1 | 0] << 8 | (w[a + 2 | 0] << 16 | w[a + 3 | 0] << 24)) != 1414687062) {
   break a;
  }
  if (Ab(w[a + 6 | 0] | w[a + 7 | 0] << 8) >>> 0 > 1) {
   break a;
  }
  if (Ab(w[a + 12 | 0] | w[a + 13 | 0] << 8)) {
   break a;
  }
  b = (Ab(w[a + 16 | 0] | w[a + 17 | 0] << 8) | 0) == 20;
 }
 return b;
}

function _C(a, b, c, d) {
 var e = 0, f = 0;
 e = eb - 32 | 0;
 eb = e;
 f = v[b + 12 >> 2];
 lf(e + 16 | 0, c, d);
 c = v[v[b >> 2] + 28 >> 2];
 d = v[e + 20 >> 2];
 v[e + 8 >> 2] = v[e + 16 >> 2];
 v[e + 12 >> 2] = d;
 hb[c | 0](e + 24 | 0, b, f, e + 8 | 0);
 lf(a, v[e + 24 >> 2], v[e + 28 >> 2]);
 v[b + 12 >> 2] = v[b + 12 >> 2] + v[a + 4 >> 2];
 eb = e + 32 | 0;
}

function Nq(a, b, c) {
 var d = 0, e = 0, f = 0, g = 0, h = 0;
 f = 131072 / (A[Ip(b) >> 3] - A[a >> 3]);
 b = 0;
 while (1) {
  if ((b | 0) != 2048) {
   d = -Ee(f * A[Se(a, b) >> 3]);
   a: {
    if (D(d) < 2147483648) {
     e = ~~d;
     break a;
    }
    e = -2147483648;
   }
   g = xb(c, b), h = e, v[g >> 2] = h;
   b = b + 1 | 0;
   continue;
  }
  break;
 }
}

function Ura(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0;
 c = eb - 16 | 0;
 eb = c;
 qD(c + 8 | 0, b);
 d = v[c + 12 >> 2];
 ic(c, v[a >> 2], v[a + 8 >> 2], v[c + 8 >> 2], v[c + 12 >> 2]);
 e = v[c + 4 >> 2];
 if ((e | 0) == (d | 0)) {
  Ub(a, v[c + 12 >> 2]);
 }
 eb = c + 16 | 0;
 a = (d | 0) == (e | 0);
 if (!a) {
  Qb(b, 0, 4896);
 }
 return a | 0;
}

function Tqa(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0;
 c = eb - 16 | 0;
 eb = c;
 oD(c + 8 | 0, b);
 d = v[c + 12 >> 2];
 ic(c, v[a >> 2], v[a + 8 >> 2], v[c + 8 >> 2], v[c + 12 >> 2]);
 e = v[c + 4 >> 2];
 if ((e | 0) == (d | 0)) {
  Ub(a, v[c + 12 >> 2]);
 }
 eb = c + 16 | 0;
 a = (d | 0) == (e | 0);
 if (!a) {
  Qb(b, 0, 33);
 }
 return a | 0;
}

function A3(a) {
 a = a | 0;
 var b = 0;
 a: {
  b: {
   if (!a) {
    break b;
   }
   b = gl(a);
   if (lI(b, -1) | w[b + 13 | 0]) {
    break b;
   }
   b = v[b + 8 >> 2];
   if (b) {
    v[31601] = 0;
    Q(b | 0, a | 0) | 0;
    b = v[31601];
    v[31601] = 0;
    if ((b | 0) == 1) {
     break a;
    }
   }
   jc(a);
  }
  return;
 }
 S(0) | 0;
 Rb();
 p();
}

function a1(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0;
 c = eb - 16 | 0;
 eb = c;
 Cw(c + 8 | 0, b);
 d = v[c + 12 >> 2];
 ic(c, v[a >> 2], v[a + 8 >> 2], v[c + 8 >> 2], v[c + 12 >> 2]);
 e = v[c + 4 >> 2];
 if ((e | 0) == (d | 0)) {
  Ub(a, v[c + 12 >> 2]);
 }
 eb = c + 16 | 0;
 a = (d | 0) == (e | 0);
 if (!a) {
  Qb(b, 0, 65);
 }
 return a | 0;
}

function WM(a, b, c, d) {
 var e = 0, f = 0, g = 0, h = 0;
 e = eb - 16 | 0;
 eb = e;
 f = e + 8 | 0;
 yz(f, b);
 while (1) {
  if (d) {
   b = v[f + 4 >> 2];
   h = th(d);
   uj(b, c + g | 0, h);
   b = v[v[f + 4 >> 2] + 4 >> 2];
   d = d - b | 0;
   g = b + g | 0;
   if ((b | 0) == (h | 0)) {
    continue;
   }
  }
  break;
 }
 ac(a, c, g);
 eb = e + 16 | 0;
}

function OY(a) {
 t[a | 0] = 0;
 t[a + 1 | 0] = 0;
 t[a + 2 | 0] = 0;
 t[a + 3 | 0] = 0;
 t[a + 4 | 0] = 0;
 t[a + 5 | 0] = 0;
 t[a + 6 | 0] = 0;
 t[a + 7 | 0] = 0;
 t[a + 16 | 0] = 0;
 t[a + 17 | 0] = 0;
 t[a + 8 | 0] = 0;
 t[a + 9 | 0] = 0;
 t[a + 10 | 0] = 0;
 t[a + 11 | 0] = 0;
 t[a + 12 | 0] = 0;
 t[a + 13 | 0] = 0;
 t[a + 14 | 0] = 0;
 t[a + 15 | 0] = 0;
}

function W9(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0;
 f = v[c >> 2];
 c = v[c + 4 >> 2];
 while (1) {
  if (c) {
   d = v[b + 24 >> 2];
   g = th(c);
   uj(d, e + f | 0, g);
   d = v[v[b + 24 >> 2] + 4 >> 2];
   c = c - d | 0;
   e = e + d | 0;
   if ((d | 0) == (g | 0)) {
    continue;
   }
  }
  break;
 }
 ac(a, f, e);
}

function VI(a, b) {
 var c = 0, d = 0;
 c = eb - 16 | 0;
 eb = c;
 d = a;
 a = kk(Jb(b));
 v[d >> 2] = a;
 a: {
  if (!a) {
   a = c + 4 | 0;
   Km(a, 17598, b);
   v[31601] = 0;
   V(1366, a | 0);
   b = v[31601];
   v[31601] = 0;
   if ((b | 0) != 1) {
    break a;
   }
   b = M() | 0;
   sb(a);
   P(b | 0);
   p();
  }
  eb = c + 16 | 0;
  return;
 }
 p();
}

function QR(a) {
 var b = 0, c = 0, d = 0;
 c = eb - 544 | 0;
 eb = c;
 a: {
  if (!(w[a + 480210 | 0] & 128) | !v[a + 24668 >> 2]) {
   break a;
  }
  d = a + 112 | 0;
  b = 1074992;
  a = sC(c, v[a + 24620 >> 2]);
  while (1) {
   if ((b | 0) == 1298224) {
    break a;
   }
   yc(b + d | 0, a, 538);
   b = b + 872 | 0;
   continue;
  }
 }
 eb = c + 544 | 0;
}

function Kr(a) {
 var b = 0, c = 0, d = 0, e = 0;
 c = eb - 16 | 0;
 eb = c;
 b = eb - 16 | 0;
 eb = b;
 Vr(b + 8 | 0, c + 15 | 0);
 d = v[b + 12 >> 2];
 pd(b, a, v[b + 8 >> 2], v[b + 12 >> 2]);
 e = v[b + 4 >> 2];
 if ((e | 0) == (d | 0)) {
  hd(a, v[b + 12 >> 2]);
 }
 eb = b + 16 | 0;
 eb = c + 16 | 0;
 return ((d | 0) == (e | 0) ? w[c + 15 | 0] : 0) & 255;
}

function xL(a, b) {
 var c = 0, d = 0, e = 0;
 c = eb - 256 | 0;
 eb = c;
 if ((b | 0) >= 2) {
  v[(b << 2) + a >> 2] = c;
  yc(c, v[a >> 2], 4);
  while (1) {
   e = (d << 2) + a | 0;
   d = d + 1 | 0;
   yc(v[e >> 2], v[(d << 2) + a >> 2], 4);
   v[e >> 2] = v[e >> 2] + 4;
   if ((b | 0) != (d | 0)) {
    continue;
   }
   break;
  }
 }
 eb = c + 256 | 0;
}

function qA(a, b) {
 var c = 0, d = 0, e = 0, f = 0;
 c = a & 16711680;
 d = c >>> 8 | 0;
 e = c << 24;
 c = a & -16777216;
 f = c >>> 24 | 0;
 c = e | c << 8;
 e = d | f | (a << 24 | (a & 65280) << 8);
 d = 0;
 gb = e | (d | d);
 return ((b & 255) << 24 | a >>> 8) & -16777216 | ((b & 16777215) << 8 | a >>> 24) & 16711680 | (b >>> 8 & 65280 | b >>> 24) | c;
}

function dla(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0;
 c = eb - 16 | 0;
 eb = c;
 a: {
  if (!Lb(v[a >> 2], v[a + 8 >> 2], 27)) {
   a = 0;
   while (1) {
    if ((a | 0) != 27) {
     ch(a + b | 0);
     a = a + 1 | 0;
     continue;
    }
    break;
   }
   break a;
  }
  tU(c + 8 | 0, b);
  rd(c, a, v[c + 8 >> 2], v[c + 12 >> 2]);
 }
 eb = c + 16 | 0;
}

function Jta(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0;
 c = eb - 16 | 0;
 eb = c;
 a: {
  if (!Lb(v[a >> 2], v[a + 8 >> 2], 64)) {
   a = 0;
   while (1) {
    if ((a | 0) != 64) {
     ch(a + b | 0);
     a = a + 1 | 0;
     continue;
    }
    break;
   }
   break a;
  }
  mw(c + 8 | 0, b);
  rd(c, a, v[c + 8 >> 2], v[c + 12 >> 2]);
 }
 eb = c + 16 | 0;
}

function Jd(a, b) {
 var c = 0, d = 0;
 c = eb - 16 | 0;
 eb = c;
 a: {
  if (b >>> 0 < 2) {
   b: {
    if (!b) {
     break b;
    }
    if (!Lb(v[a >> 2], v[a + 8 >> 2], 1)) {
     break b;
    }
    t[c + 15 | 0] = 0;
    dh(a, c + 15 | 0);
    d = w[c + 15 | 0];
   }
   eb = c + 16 | 0;
   break a;
  }
  Z(11235, 9079, 324, 14199);
  p();
 }
 return d;
}

function sC(a, b) {
 var c = 0, d = 0, e = 0, f = 0;
 u[a + 24 >> 1] = 0;
 v[a + 20 >> 2] = 0;
 v[a >> 2] = 0;
 v[a + 4 >> 2] = 0;
 c = 3546895 / +(b >>> 0);
 d = c * .25;
 a: {
  if (D(d) < 2147483648) {
   b = ~~d;
   break a;
  }
  b = -2147483648;
 }
 v[a + 16 >> 2] = b;
 e = a, f = bW(c - +(b << 2)), v[e + 8 >> 2] = f;
 v[a + 12 >> 2] = gb;
 return a;
}

function era(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0;
 d = eb - 16 | 0;
 eb = d;
 c = -1;
 a: {
  if (!gk(a, d + 8 | 0)) {
   break a;
  }
  e = v[d + 12 >> 2];
  c = 0;
  if (!(v[d + 8 >> 2] == (Cn(8978) | 0) & e >>> 0 > 255 & e >>> 0 < 260)) {
   break a;
  }
  c = ve(a, b, e >>> 0 < 259 ? 80 : 76, 0);
 }
 eb = d + 16 | 0;
 return c | 0;
}

function ela(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0;
 c = eb - 16 | 0;
 eb = c;
 tU(c + 8 | 0, b);
 d = v[c + 12 >> 2];
 ic(c, v[a >> 2], v[a + 8 >> 2], v[c + 8 >> 2], v[c + 12 >> 2]);
 e = v[c + 4 >> 2];
 if ((e | 0) == (d | 0)) {
  Ub(a, v[c + 12 >> 2]);
 }
 eb = c + 16 | 0;
 a = (d | 0) == (e | 0);
 if (!a) {
  RB(b);
 }
 return a | 0;
}

function Gw(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0;
 c = eb - 16 | 0;
 eb = c;
 a: {
  if (!Lb(v[a >> 2], v[a + 8 >> 2], 32)) {
   a = 0;
   while (1) {
    if ((a | 0) != 32) {
     ch(a + b | 0);
     a = a + 1 | 0;
     continue;
    }
    break;
   }
   break a;
  }
  PE(c + 8 | 0, b);
  rd(c, a, v[c + 8 >> 2], v[c + 12 >> 2]);
 }
 eb = c + 16 | 0;
}

function zw(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0;
 c = eb - 16 | 0;
 eb = c;
 Lw(c + 8 | 0, b);
 d = v[c + 12 >> 2];
 ic(c, v[a >> 2], v[a + 8 >> 2], v[c + 8 >> 2], v[c + 12 >> 2]);
 e = v[c + 4 >> 2];
 if ((e | 0) == (d | 0)) {
  Ub(a, v[c + 12 >> 2]);
 }
 eb = c + 16 | 0;
 a = (d | 0) == (e | 0);
 if (!a) {
  LE(b);
 }
 return a | 0;
}

function ZK(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0;
 c = v[a >> 2];
 a: {
  if (!c) {
   break a;
  }
  d = v[c + 24 >> 2];
  b: {
   if ((d | 0) == v[c + 28 >> 2]) {
    b = hb[v[v[c >> 2] + 52 >> 2]](c, b) | 0;
    break b;
   }
   v[c + 24 >> 2] = d + 4;
   v[d >> 2] = b;
  }
  if (!jo(b)) {
   break a;
  }
  v[a >> 2] = 0;
 }
 return a | 0;
}

function Ev(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0;
 c = eb - 16 | 0;
 eb = c;
 jX(c + 8 | 0, b);
 d = v[c + 12 >> 2];
 ic(c, v[a >> 2], v[a + 8 >> 2], v[c + 8 >> 2], v[c + 12 >> 2]);
 e = v[c + 4 >> 2];
 if ((e | 0) == (d | 0)) {
  Ub(a, v[c + 12 >> 2]);
 }
 eb = c + 16 | 0;
 a = (d | 0) == (e | 0);
 if (!a) {
  kX(b);
 }
 return a | 0;
}

function ir(a, b) {
 var c = 0, d = 0;
 c = eb - 32 | 0;
 eb = c;
 ee(c + 24 | 0, a);
 ee(c + 16 | 0, b);
 a = v[c + 20 >> 2];
 v[c + 8 >> 2] = v[c + 16 >> 2];
 v[c + 12 >> 2] = a;
 a = v[c + 24 >> 2];
 b = v[c + 28 >> 2];
 d = v[c + 12 >> 2];
 if ((b | 0) == (d | 0)) {
  a = pZ(a, b, v[c + 8 >> 2], d);
 } else {
  a = 1;
 }
 eb = c + 32 | 0;
 return !a;
}

function iZ(a, b, c) {
 var d = 0, e = 0, f = 0;
 e = eb - 16 | 0;
 eb = e;
 f = v[a + 8 >> 2];
 d = e + 4 | 0;
 v[d + 8 >> 2] = a + 8;
 v[d >> 2] = f;
 v[d + 4 >> 2] = B(b, 6) + f;
 b = v[d >> 2];
 while (1) {
  if (v[d + 4 >> 2] != (b | 0)) {
   tD(b, c);
   b = v[d >> 2] + 6 | 0;
   v[d >> 2] = b;
   continue;
  }
  break;
 }
 ie(d);
 eb = e + 16 | 0;
}

function b0(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0;
 c = eb - 16 | 0;
 eb = c;
 a: {
  if (!Lb(v[a >> 2], v[a + 8 >> 2], 8)) {
   a = 0;
   while (1) {
    if ((a | 0) != 8) {
     ch(a + b | 0);
     a = a + 1 | 0;
     continue;
    }
    break;
   }
   break a;
  }
  Yk(c + 8 | 0, b);
  rd(c, a, v[c + 8 >> 2], v[c + 12 >> 2]);
 }
 eb = c + 16 | 0;
}

function aqa(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0;
 c = eb - 16 | 0;
 eb = c;
 if (th(178956970) >>> 0 < b >>> 0) {
  dd();
  p();
 }
 d = Dc(B(b, 24));
 v[c + 12 >> 2] = b;
 v[c + 8 >> 2] = d;
 b = v[c + 8 >> 2];
 v[a + 4 >> 2] = b;
 v[a >> 2] = b;
 e = zb(a), f = b + B(v[c + 12 >> 2], 24) | 0, v[e >> 2] = f;
 eb = c + 16 | 0;
}

function Una(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0;
 c = eb - 16 | 0;
 eb = c;
 if (th(119304647) >>> 0 < b >>> 0) {
  dd();
  p();
 }
 d = Dc(B(b, 36));
 v[c + 12 >> 2] = b;
 v[c + 8 >> 2] = d;
 b = v[c + 8 >> 2];
 v[a + 4 >> 2] = b;
 v[a >> 2] = b;
 e = zb(a), f = b + B(v[c + 12 >> 2], 36) | 0, v[e >> 2] = f;
 eb = c + 16 | 0;
}

function UO(a) {
 var b = 0, c = 0;
 b = v[a + 24 >> 2];
 c = x[b + 1074448 >> 1];
 if (c >>> 0 >= Gj(Wb(v[b + 484360 >> 2], w[b + 484376 | 0])) >>> 0) {
  return x[v[a + 24 >> 2] + 1074446 >> 1];
 }
 a = v[a + 24 >> 2];
 b = x[$b(v[Wb(v[a + 484360 >> 2], w[a + 484376 | 0]) >> 2], c) >> 1];
 return An(v[a + 484344 >> 2], v[a + 484348 >> 2], b) ? b : -1;
}

function UI(a, b) {
 var c = 0, d = 0;
 c = eb - 16 | 0;
 eb = c;
 d = kk(Jb(b));
 v[a >> 2] = d;
 a: {
  if (!d) {
   a = c + 4 | 0;
   Km(a, 17639, b);
   v[31601] = 0;
   V(1366, a | 0);
   b = v[31601];
   v[31601] = 0;
   if ((b | 0) != 1) {
    break a;
   }
   b = M() | 0;
   sb(a);
   P(b | 0);
   p();
  }
  eb = c + 16 | 0;
  return a;
 }
 p();
}

function Gsa(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0;
 c = eb - 16 | 0;
 eb = c;
 if (th(2147483647) >>> 0 < b >>> 0) {
  dd();
  p();
 }
 d = Dc(b << 1);
 v[c + 12 >> 2] = b;
 v[c + 8 >> 2] = d;
 b = v[c + 8 >> 2];
 v[a + 4 >> 2] = b;
 v[a >> 2] = b;
 e = zb(a), f = b + (v[c + 12 >> 2] << 1) | 0, v[e >> 2] = f;
 eb = c + 16 | 0;
}

function zta(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0;
 c = eb - 16 | 0;
 eb = c;
 if (th(715827882) >>> 0 < b >>> 0) {
  dd();
  p();
 }
 d = Dc(B(b, 6));
 v[c + 12 >> 2] = b;
 v[c + 8 >> 2] = d;
 b = v[c + 8 >> 2];
 v[a + 4 >> 2] = b;
 v[a >> 2] = b;
 e = zb(a), f = b + B(v[c + 12 >> 2], 6) | 0, v[e >> 2] = f;
 eb = c + 16 | 0;
}

function te(a, b) {
 var c = 0, d = 0, e = 0;
 b = b + 7 & -8;
 v[a + 8 >> 2] = b + v[a + 8 >> 2];
 d = v[a + 80 >> 2];
 a: {
  if (d) {
   c = b;
   b = v[a + 88 >> 2];
   e = c + b | 0;
   c = 0;
   if ((e | 0) > v[a + 92 >> 2]) {
    break a;
   }
   v[a + 88 >> 2] = e;
   return b + d | 0;
  }
  if (!b) {
   return 0;
  }
  c = Fd(b);
 }
 return c;
}

function fV(a) {
 var b = 0;
 b = u[a + 784 >> 1];
 if (b) {
  v[a + 692 >> 2] = (b & 32767) - 1;
  if ((b | 0) < 0) {
   v[a + 88 >> 2] = v[a + 88 >> 2] | 256;
  }
  u[a + 784 >> 1] = 0;
 }
 b = w[a + 795 | 0];
 if (b) {
  t[a + 795 | 0] = 0;
  t[a + 838 | 0] = b - 1;
 }
 b = w[a + 796 | 0];
 if (b) {
  t[a + 796 | 0] = 0;
  t[a + 837 | 0] = b - 1;
 }
}

function ura(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0;
 e = eb - 16 | 0;
 eb = e;
 c = Hf(a, c);
 $d(e, v[a + 36 >> 2]);
 a: {
  if (!c) {
   Pc(e, a + 32 | 0, 5);
   f = 0;
   if (Fb(v[v[e >> 2] >> 2], v[e + 4 >> 2])) {
    break a;
   }
  }
  uZ(v[a + 36 >> 2], b, d, 0);
  f = c;
 }
 ef(a, f);
 eb = e + 16 | 0;
}

function oV(a) {
 var b = 0, c = 0;
 a: {
  b: {
   c = a & 240;
   if ((c | 0) != 192) {
    if ((c | 0) == 240) {
     break b;
    }
    b = 3;
    if ((c | 0) != 208) {
     break a;
    }
   }
   b = 2;
   break a;
  }
  a = a + 15 | 0;
  b = 1;
  if ((a & 255) >>> 0 > 2) {
   break a;
  }
  b = 131842 >>> (a << 3 & 248) | 0;
 }
 return b & 255;
}

function Yp(a, b, c) {
 var d = 0, e = 0, f = 0;
 d = a * a;
 f = d * (d * d) * (d * 1.58969099521155e-10 + -2.5050760253406863e-8) + (d * (d * 27557313707070068e-22 + -.0001984126982985795) + .00833333333332249);
 e = d * a;
 if (!c) {
  return e * (d * f + -.16666666666666632) + a;
 }
 return a - (d * (b * .5 - f * e) - b + e * .16666666666666632);
}

function rr(a, b, c) {
 var d = 0, e = 0;
 e = x[a + 480192 >> 1];
 a: {
  if (e) {
   if (!Tc(b) | c >>> 0 > e >>> 0) {
    break a;
   }
   c = v[((c << 2) + a | 0) + 900380 >> 2];
   if (!c) {
    break a;
   }
   d = x[$b(c + 236 | 0, b - 1 | 0) >> 1];
   break a;
  }
  d = c;
 }
 return (x[a + 480190 >> 1] >= (d & 65535) >>> 0 ? d : 0) & 65535;
}

function dga(a) {
 a = a | 0;
 var b = 0;
 b = eb - 16 | 0;
 eb = b;
 a: {
  if (!Md(a, 10265)) {
   b = b + 4 | 0;
   Km(b, 18185, a);
   a = Jb(b);
   v[31601] = 0;
   N(67, 44, a | 0);
   a = v[31601];
   v[31601] = 0;
   if ((a | 0) != 1) {
    break a;
   }
   a = M() | 0;
   sb(b);
   P(a | 0);
   p();
  }
  eb = b + 16 | 0;
  return;
 }
 p();
}

function Y9(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0, f = 0, g = 0;
 e = eb - 16 | 0;
 eb = e;
 c = e + 4 | 0;
 v[c + 4 >> 2] = 1;
 f = c, g = Dc(40), v[f + 8 >> 2] = g;
 d = qm(v[c + 8 >> 2]);
 v[d >> 2] = 78008;
 d = rM(mc(d));
 v[d + 24 >> 2] = b;
 v[d >> 2] = 78156;
 b = a;
 a = Qn(c);
 Pn(b, mc(a), a);
 rm(c);
 eb = e + 16 | 0;
}

function Ux(a, b, c) {
 var d = 0;
 d = v[a + 16 >> 2];
 if (!d) {
  v[a + 36 >> 2] = 1;
  v[a + 24 >> 2] = c;
  v[a + 16 >> 2] = b;
  return;
 }
 a: {
  if ((b | 0) == (d | 0)) {
   if (v[a + 24 >> 2] != 2) {
    break a;
   }
   v[a + 24 >> 2] = c;
   return;
  }
  t[a + 54 | 0] = 1;
  v[a + 24 >> 2] = 2;
  v[a + 36 >> 2] = v[a + 36 >> 2] + 1;
 }
}

function UC(a, b) {
 var c = 0, d = 0, e = 0, f = 0;
 d = b ? 224 : 240;
 e = xG(a);
 a: while (1) {
  if ((a | 0) != (e | 0)) {
   f = td(a);
   b = a;
   while (1) if ((b | 0) == (f | 0)) {
    a = a + 16 | 0;
    continue a;
   } else {
    c = ((w[wb(b, 0) | 0] & d) != 0) + c | 0;
    b = b + 4 | 0;
    continue;
   }
  }
  break;
 }
 return c;
}

function Ria(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0;
 e = eb - 16 | 0;
 eb = e;
 c = Hf(a, c);
 $d(e, v[a + 36 >> 2]);
 a: {
  if (!c) {
   Pc(e, a + 32 | 0, 5);
   f = 0;
   if (Fb(v[v[e >> 2] >> 2], v[e + 4 >> 2])) {
    break a;
   }
  }
  PQ(d, v[a + 36 >> 2], b);
  f = c;
 }
 ef(a, f);
 eb = e + 16 | 0;
}

function $ha(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0;
 c = eb - 16 | 0;
 eb = c;
 d = wj(a);
 if (d) {
  e = v[b + 4 >> 2];
  b = v[b >> 2];
  v[c + 8 >> 2] = b;
  v[c + 12 >> 2] = e;
  a = v[v[d >> 2] + 72 >> 2];
  v[c >> 2] = b;
  v[c + 4 >> 2] = e;
  a = hb[a | 0](d, c) | 0;
 } else {
  a = 1;
 }
 eb = c + 16 | 0;
 return a | 0;
}

function Vf(a, b, c, d, e) {
 var f = 0;
 f = eb - 256 | 0;
 eb = f;
 if (!(e & 73728 | (c | 0) <= (d | 0))) {
  d = c - d | 0;
  c = d >>> 0 < 256;
  Qb(f, b & 255, c ? d : 256);
  if (!c) {
   while (1) {
    Jf(a, f, 256);
    d = d - 256 | 0;
    if (d >>> 0 > 255) {
     continue;
    }
    break;
   }
  }
  Jf(a, f, d);
 }
 eb = f + 256 | 0;
}

function SS(a, b) {
 var c = 0, d = 0, e = 0, f = 0;
 v[a >> 2] = v[b >> 2];
 v[a + 4 >> 2] = v[b + 4 >> 2];
 v[a + 8 >> 2] = v[b + 8 >> 2];
 d = zb(a);
 c = fc(a);
 a: {
  if (!v[d >> 2]) {
   v[a >> 2] = c;
   break a;
  }
  v[v[c >> 2] + 8 >> 2] = c;
  c = fc(b);
  v[b >> 2] = c;
  v[c >> 2] = 0;
  e = zb(b), f = 0, v[e >> 2] = f;
 }
 return a;
}

function fG(a, b, c) {
 var d = 0, e = 0;
 d = eb - 16 | 0;
 eb = d;
 if (c >>> 0 < 2147483632) {
  a: {
   if (Kk(c)) {
    Me(a, c);
    break a;
   }
   pg(d + 8 | 0, Eh(c) + 1 | 0);
   e = v[d + 8 >> 2];
   xd(a, e);
   of(a, v[d + 12 >> 2]);
   Ad(a, c);
   a = e;
  }
  gd(Wg(a, b, c) + c | 0, 0);
  eb = d + 16 | 0;
  return;
 }
 pf();
 p();
}

function Kja(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0;
 c = eb - 32 | 0;
 eb = c;
 a: {
  if (Ug(a) >>> 0 < b >>> 0) {
   if (th(1073741823) >>> 0 < b >>> 0) {
    break a;
   }
   d = zb(a);
   e = a;
   a = Yf(c + 12 | 0, b, nc(v[a >> 2], v[a + 4 >> 2]), d);
   Rm(e, a);
   Xf(a);
  }
  eb = c + 32 | 0;
  return;
 }
 dd();
 p();
}

function Gu(a, b, c) {
 var d = 0, e = 0;
 d = eb - 16 | 0;
 eb = d;
 if (c >>> 0 < 2147483632) {
  a: {
   if (Kk(c)) {
    Me(a, c);
    break a;
   }
   pg(d + 8 | 0, Eh(c) + 1 | 0);
   e = v[d + 8 >> 2];
   xd(a, e);
   of(a, v[d + 12 >> 2]);
   Ad(a, c);
   a = e;
  }
  gd(Cg(a, b, c) + c | 0, 0);
  eb = d + 16 | 0;
  return;
 }
 pf();
 p();
}

function woa(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0;
 c = eb - 32 | 0;
 eb = c;
 a: {
  if (al(a) >>> 0 < b >>> 0) {
   if (th(357913941) >>> 0 < b >>> 0) {
    break a;
   }
   d = zb(a);
   e = a;
   a = wm(c + 12 | 0, b, Td(v[a >> 2], v[a + 4 >> 2]), d);
   qW(e, a);
   pW(a);
  }
  eb = c + 32 | 0;
  return;
 }
 dd();
 p();
}

function wY(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0;
 c = eb - 32 | 0;
 eb = c;
 a: {
  if (Gn(a) >>> 0 < b >>> 0) {
   if (th(2147483647) >>> 0 < b >>> 0) {
    break a;
   }
   d = zb(a);
   e = a;
   a = dk(c + 12 | 0, b, _c(v[a >> 2], v[a + 4 >> 2]), d);
   Ur(e, a);
   $i(a);
  }
  eb = c + 32 | 0;
  return;
 }
 dd();
 p();
}

function uH(a, b, c, d, e) {
 var f = 0;
 f = eb - 32 | 0;
 eb = f;
 v[f + 24 >> 2] = a;
 v[f + 28 >> 2] = b;
 v[f + 16 >> 2] = d;
 v[f + 20 >> 2] = e;
 v[f + 8 >> 2] = c;
 v[f + 12 >> 2] = 0;
 a = q0(f + 24 | 0, f + 8 | 0);
 b = f + 16 | 0;
 a = ft(v[b >> 2], v[b + 4 >> 2], v[a >> 2], v[a + 4 >> 2]) ? a : b;
 eb = f + 32 | 0;
 return v[a >> 2];
}

function Yka(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0;
 c = eb - 32 | 0;
 eb = c;
 a: {
  if (Rn(a) >>> 0 < b >>> 0) {
   if (th(536870911) >>> 0 < b >>> 0) {
    break a;
   }
   d = zb(a);
   e = a;
   a = js(c + 12 | 0, b, hh(v[a >> 2], v[a + 4 >> 2]), d);
   NB(e, a);
   is(a);
  }
  eb = c + 32 | 0;
  return;
 }
 dd();
 p();
}

function Oka(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0;
 c = eb - 32 | 0;
 eb = c;
 a: {
  if (IB(a) >>> 0 < b >>> 0) {
   if (th(613566756) >>> 0 < b >>> 0) {
    break a;
   }
   d = zb(a);
   e = a;
   a = IT(c + 12 | 0, b, HB(v[a >> 2], v[a + 4 >> 2]), d);
   HT(e, a);
   GT(a);
  }
  eb = c + 32 | 0;
  return;
 }
 dd();
 p();
}

function Mja(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0;
 c = eb - 32 | 0;
 eb = c;
 a: {
  if (al(a) >>> 0 < b >>> 0) {
   if (th(357913941) >>> 0 < b >>> 0) {
    break a;
   }
   d = zb(a);
   e = a;
   a = wm(c + 12 | 0, b, Td(v[a >> 2], v[a + 4 >> 2]), d);
   Bx(e, a);
   ws(a);
  }
  eb = c + 32 | 0;
  return;
 }
 dd();
 p();
}

function u_(a) {
 var b = 0, c = 0, d = 0;
 a: {
  if (id(a, 22245, 11)) {
   break a;
  }
  b = 63;
  while (1) {
   d = (b | 0) == 215;
   if (d) {
    break a;
   }
   c = a + b | 0;
   if (w[c + 16 | 0] > 3 | w[c + 17 | 0] > 3) {
    break a;
   }
   b = b + 19 | 0;
   if (w[c + 18 | 0] < 16) {
    continue;
   }
   break;
  }
 }
 return d;
}

function OA(a, b) {
 var c = 0;
 c = v[b + 24 >> 2];
 c = c >>> 0 <= 1 ? 1 : c;
 v[a + 24628 >> 2] = c >>> 0 >= 512 ? 512 : c;
 a: {
  if (!(v[b + 16 >> 2] != v[a + 24620 >> 2] | v[b + 20 >> 2] != v[a + 24624 >> 2])) {
   c = 0;
   if (v[b + 12 >> 2] == v[a + 24616 >> 2]) {
    break a;
   }
  }
  c = 1;
 }
 yc(a + 24604 | 0, b, 40);
 LR(a, c);
}

function Dv(a, b) {
 var c = 0, d = 0, e = 0;
 if (v[a >> 2]) {
  W$(a);
  c = v[a >> 2];
  sE(a);
  Bb(c);
  d = zb(a), e = 0, v[d >> 2] = e;
  v[a >> 2] = 0;
  v[a + 4 >> 2] = 0;
 }
 v[a >> 2] = v[b >> 2];
 v[a + 4 >> 2] = v[b + 4 >> 2];
 c = zb(b);
 d = zb(a), e = v[c >> 2], v[d >> 2] = e;
 v[c >> 2] = 0;
 v[b >> 2] = 0;
 v[b + 4 >> 2] = 0;
}

function GW(a, b, c) {
 var d = 0;
 d = eb - 16 | 0;
 eb = d;
 t[d + 15 | 0] = a;
 a = 0;
 if (!(c >>> 0 < 25 | b >>> 0 < 25 | (b >>> 0 > 108 | b >>> 0 >= c >>> 0) | c >>> 0 > 108)) {
  t[d + 14 | 0] = (x[(b << 1) + 30958 >> 1] - x[(c << 1) + 30958 >> 1] | 0) / 5;
  a = w[Pb(d + 15 | 0, d + 14 | 0) | 0];
 }
 eb = d + 16 | 0;
 return a & 255;
}

function FU(a) {
 var b = 0, c = 0, d = 0;
 b = x[a + 20 >> 1];
 u[a + 28 >> 1] = x[a + 22 >> 1] << 1 | (w[v[a + 16 >> 2] + 3842 | 0] ? b >>> 9 | 0 : b >>> 8 & 1);
 b = 0;
 while (1) {
  if ((b | 0) != 4) {
   c = (b << 2) + a | 0;
   d = v[c >> 2];
   if (d) {
    Oo(d);
    EU(v[c >> 2]);
   }
   b = b + 1 | 0;
   continue;
  }
  break;
 }
}

function eba(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0;
 d = eb - 16 | 0;
 eb = d;
 e = d + 4 | 0;
 $M(e, c);
 a = v[a + 1298472 >> 2];
 v[31601] = 0;
 R(385, a | 0, b | 0, e | 0);
 a = v[31601];
 v[31601] = 0;
 if ((a | 0) != 1) {
  sb(e);
  eb = d + 16 | 0;
  return;
 }
 a = M() | 0;
 sb(d + 4 | 0);
 P(a | 0);
 p();
}

function HE(a) {
 t[a | 0] = 0;
 t[a + 1 | 0] = 0;
 t[a + 2 | 0] = 0;
 t[a + 3 | 0] = 0;
 t[a + 4 | 0] = 0;
 t[a + 5 | 0] = 0;
 t[a + 6 | 0] = 0;
 t[a + 7 | 0] = 0;
 t[a + 16 | 0] = 0;
 t[a + 8 | 0] = 0;
 t[a + 9 | 0] = 0;
 t[a + 10 | 0] = 0;
 t[a + 11 | 0] = 0;
 t[a + 12 | 0] = 0;
 t[a + 13 | 0] = 0;
 t[a + 14 | 0] = 0;
 t[a + 15 | 0] = 0;
}

function Zra(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0;
 c = eb - 16 | 0;
 eb = c;
 v[a + 480180 >> 2] = b;
 sr(c, tr(a));
 d = v[c + 12 >> 2];
 b = a + 1074320 | 0;
 v[b >> 2] = v[c + 8 >> 2];
 v[b + 4 >> 2] = d;
 b = v[c + 4 >> 2];
 v[a + 1074312 >> 2] = v[c >> 2];
 v[a + 1074316 >> 2] = b;
 Cu(a + 8 | 0, tr(a));
 eb = c + 16 | 0;
}
function Zh(a, b, c) {
 var d = 0, e = 0, f = 0;
 d = eb - 16 | 0;
 eb = d;
 ac(d + 8 | 0, b, c);
 e = v[d + 12 >> 2];
 ic(d, v[a >> 2], v[a + 8 >> 2], v[d + 8 >> 2], v[d + 12 >> 2]);
 f = v[d + 4 >> 2];
 if ((f | 0) == (e | 0)) {
  Ub(a, v[d + 12 >> 2]);
 }
 eb = d + 16 | 0;
 a = (e | 0) == (f | 0);
 if (!a) {
  Qb(b, 0, c);
 }
 return a;
}

function Hw(a, b) {
 var c = 0;
 c = eb - 16 | 0;
 eb = c;
 a: {
  if (!Lb(v[a >> 2], v[a + 8 >> 2], 256)) {
   a = 0;
   while (1) {
    if ((a | 0) != 256) {
     ch(a + b | 0);
     a = a + 1 | 0;
     continue;
    }
    break;
   }
   break a;
  }
  ac(c + 8 | 0, b, 256);
  rd(c, a, v[c + 8 >> 2], v[c + 12 >> 2]);
 }
 eb = c + 16 | 0;
}

function yB(a, b, c, d, e) {
 var f = 0, g = 0, h = 0, i = 0, j = 0;
 f = v[b + 480180 >> 2];
 if (f & 64671904) {
  b = w[(d & 15) + 42112 | 0];
  t[a + 2 | 0] = 0;
  u[a >> 1] = b;
  return;
 }
 g = a;
 a = (c & 255) == 4 & (f | 0) == 4;
 c = (d & 255) << a << 4;
 Wl(g, (h = Nb(b + 1074312 | 0, 66) ? 0 : c, i = c, j = e, j ? h : i), a);
}

function ita(a) {
 a = a | 0;
 var b = 0, c = 0, d = 0, e = 0;
 b = eb - 16 | 0;
 eb = b;
 if (th(1073741823) >>> 0 <= 8191) {
  dd();
  p();
 }
 c = Dc(32768);
 v[b + 12 >> 2] = 8192;
 v[b + 8 >> 2] = c;
 c = v[b + 8 >> 2];
 v[a + 4 >> 2] = c;
 v[a >> 2] = c;
 d = zb(a), e = c + (v[b + 12 >> 2] << 2) | 0, v[d >> 2] = e;
 eb = b + 16 | 0;
}

function Qx(a, b, c, d, e) {
 var f = 0, g = 0, h = 0;
 f = eb - 16 | 0;
 eb = f;
 g = Ef(f + 8 | 0, d);
 v[31601] = 0;
 h = v[g + 4 >> 2];
 v[f >> 2] = v[g >> 2];
 v[f + 4 >> 2] = h;
 a = gg(e, a, b, c, f);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  le(d);
  eb = f + 16 | 0;
  return a;
 }
 a = M() | 0;
 le(d);
 P(a | 0);
 p();
}

function so(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0;
 c = eb - 32 | 0;
 eb = c;
 a: {
  if ($o(a) >>> 0 < b >>> 0) {
   if (th(-1) >>> 0 < b >>> 0) {
    break a;
   }
   d = zb(a);
   e = a;
   a = on(c + 12 | 0, b, Sc(v[a >> 2], v[a + 4 >> 2]), d);
   cr(e, a);
   nn(a);
  }
  eb = c + 32 | 0;
  return;
 }
 dd();
 p();
}

function j_(a) {
 var b = 0, c = 0, d = 0;
 c = w[a + 3 | 0];
 b = Aua(c >>> 0 < 3 ? 48 : 64, 0, Ab(w[a + 196 | 0] | w[a + 197 | 0] << 8), 0);
 d = b;
 b = Aua(Aua(Ab(w[a + 198 | 0] | w[a + 199 | 0] << 8), 0, c >>> 0 < 4 ? 4 : 5, 0), gb, Ab(w[a + 200 | 0] | w[a + 201 | 0] << 8), 0);
 a = d + b | 0;
 a = a + 512 | 0;
 gb = 0;
 return a;
}

function M_(a) {
 var b = 0;
 a: {
  if ((w[a | 0] | w[a + 1 | 0] << 8 | (w[a + 2 | 0] << 16 | w[a + 3 | 0] << 24)) != 777268804) {
   break a;
  }
  if (_b(w[a + 4 | 0] | w[a + 5 | 0] << 8 | (w[a + 6 | 0] << 16 | w[a + 7 | 0] << 24)) - 257 >>> 0 < 4294967053) {
   break a;
  }
  b = !Ab(w[a + 8 | 0] | w[a + 9 | 0] << 8);
 }
 return b;
}

function j0(a, b) {
 var c = 0;
 c = eb - 16 | 0;
 eb = c;
 a: {
  if (!Lb(v[a >> 2], v[a + 8 >> 2], 512)) {
   a = 0;
   while (1) {
    if ((a | 0) != 512) {
     Bn(a + b | 0);
     a = a + 4 | 0;
     continue;
    }
    break;
   }
   break a;
  }
  yE(c + 8 | 0, b);
  rd(c, a, v[c + 8 >> 2], v[c + 12 >> 2]);
 }
 eb = c + 16 | 0;
}

function hU(a, b) {
 var c = 0, d = 0, e = 0, f = 0;
 e = A[a + 48 >> 3];
 c = A[a + 40 >> 3];
 A[a + 48 >> 3] = c;
 f = A[a + 64 >> 3];
 d = A[a + 56 >> 3];
 A[a + 64 >> 3] = d;
 A[a + 40 >> 3] = b;
 b = e * A[a + 16 >> 3] + (A[a >> 3] * b + c * A[a + 8 >> 3]) - d * A[a + 24 >> 3] - f * A[a + 32 >> 3];
 A[a + 56 >> 3] = b;
 return b;
}

function WX(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0;
 d = eb - 16 | 0;
 eb = d;
 a: {
  if (!Mn(b, a) | !c) {
   break a;
  }
  lh(d + 8 | 0, a);
  a = 0;
  while (1) {
   if (a >>> 0 >= 4) {
    break a;
   }
   b = v[d + 8 >> 2];
   qg(wb(b, a), wb(b, a | 1));
   a = a + 2 | 0;
   continue;
  }
 }
 eb = d + 16 | 0;
}

function SL(a, b) {
 var c = 0, d = 0, e = 0, f = C(0), g = C(0), h = 0;
 b = (b | 0) > 0 ? b : 0;
 h = a + 2304 | 0;
 while (1) {
  if ((b | 0) != (d | 0)) {
   c = d << 2;
   e = c + a | 0;
   f = z[e >> 2];
   c = c + h | 0;
   g = z[c >> 2];
   z[e >> 2] = f + g;
   z[c >> 2] = f - g;
   d = d + 1 | 0;
   continue;
  }
  break;
 }
}

function LS(a, b, c, d) {
 var e = 0, f = 0;
 b = B(c, 872) + b | 0;
 e = v[b + 704 >> 2];
 a: {
  if (!(!(e & 134218752) | (d | 0) != 1) | e & 67108864) {
   break a;
  }
  b = x[(b + 616 | 0) + 786 >> 1];
  b = (b ? b - 1 | 0 : c) & 65535;
  if (b >>> 0 > 126) {
   break a;
  }
  f = w[((b << 5) + a | 0) + 480288 | 0];
 }
 return f;
}

function Kz(a, b, c, d, e, f) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 f = f | 0;
 b = eb - 32 | 0;
 eb = b;
 v[b + 24 >> 2] = e;
 v[b + 28 >> 2] = f;
 c = Yb(b + 16 | 0, c, d);
 d = v[c + 4 >> 2];
 v[b + 8 >> 2] = v[c >> 2];
 v[b + 12 >> 2] = d;
 a = Bu(a, b + 8 | 0, b + 24 | 0);
 eb = b + 32 | 0;
 return a | 0;
}

function cja(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0;
 d = eb - 16 | 0;
 eb = d;
 c = Hf(a, c);
 $d(d, v[a + 36 >> 2]);
 a: {
  if (!c) {
   Pc(d, a + 32 | 0, 5);
   e = 0;
   if (Fb(v[v[d >> 2] >> 2], v[d + 4 >> 2])) {
    break a;
   }
  }
  yZ(v[a + 36 >> 2], b, a);
  e = c;
 }
 ef(a, e);
 eb = d + 16 | 0;
}

function bW(a) {
 var b = 0, c = 0;
 a = a * 4294967296;
 if (D(a) < 0x8000000000000000) {
  c = ~~a >>> 0;
  if (D(a) >= 1) {
   b = ~~(a > 0 ? F(H(a * 2.3283064365386963e-10), 4294967295) : I((a - +(~~a >>> 0 >>> 0)) * 2.3283064365386963e-10)) >>> 0;
  } else {
   b = 0;
  }
  gb = b;
  return c;
 }
 gb = -2147483648;
 return 0;
}

function TZ(a, b) {
 var c = 0, d = 0, e = 0;
 d = eb - 16 | 0;
 eb = d;
 c = wh(d + 4 | 0, a, 1);
 a = v[c + 4 >> 2];
 e = v[c + 8 >> 2];
 while (1) {
  if ((a | 0) == (e | 0)) {
   hc(c);
   eb = d + 16 | 0;
  } else {
   bp(a, x[b >> 1] | x[b + 2 >> 1] << 16);
   a = a + 4 | 0;
   v[c + 4 >> 2] = a;
   continue;
  }
  break;
 }
}

function Aua(a, b, c, d) {
 var e = 0, f = 0, g = 0, h = 0, i = 0, j = 0;
 e = c >>> 16 | 0;
 f = a >>> 16 | 0;
 j = B(e, f);
 g = c & 65535;
 h = a & 65535;
 i = B(g, h);
 f = (i >>> 16 | 0) + B(f, g) | 0;
 e = (f & 65535) + B(e, h) | 0;
 gb = (B(b, c) + j | 0) + B(a, d) + (f >>> 16) + (e >>> 16) | 0;
 return i & 65535 | e << 16;
}

function Lna(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0;
 c = eb - 16 | 0;
 eb = c;
 if ((b | 0) >= 0) {
  d = 2147483647;
  a = iv(a);
  if (a >>> 0 <= 1073741822) {
   v[c + 12 >> 2] = a << 1;
   v[c + 8 >> 2] = b + 31 & -32;
   d = v[ad(c + 12 | 0, c + 8 | 0) >> 2];
  }
  eb = c + 16 | 0;
  return d | 0;
 }
 dd();
 p();
}

function JA(a, b, c) {
 var d = 0, e = 0;
 d = v[b + 656 >> 2];
 if (!d) {
  return 0;
 }
 d = Nw(d, c);
 a = a + 1074312 | 0;
 if (!Nb(a, 31)) {
  e = Nb(a, 93) ^ 1;
 }
 a: {
  if (!(t[FR(b, c) + 6 | 0] & 1)) {
   a = 0;
   if (!(t[d + 12 | 0] & 1) | e) {
    break a;
   }
  }
  a = lc(v[d >> 2], v[d + 4 >> 2]) ^ 1;
 }
 return a;
}
function poa(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0;
 c = eb - 16 | 0;
 eb = c;
 hn(a, b);
 b = vb(v[a >> 2]);
 v[c + 12 >> 2] = b;
 a = vb(v[a + 4 >> 2]);
 while (1) {
  if (Hb(b, a)) {
   d = w[b | 0] + d | 0;
   t[b | 0] = d;
   b = v[xe(c + 12 | 0) >> 2];
   continue;
  } else {
   eb = c + 16 | 0;
  }
  break;
 }
}

function ji(a) {
 var b = 0, c = 0, d = 0, e = 0;
 b = eb - 16 | 0;
 eb = b;
 c = 2;
 if (a >>> 0 >= 2) {
  v[b + 12 >> 2] = a >>> 1;
  v[b + 8 >> 2] = a ^ -1;
  d = b, e = v[Gb(b + 12 | 0, b + 8 | 0) >> 2] + a | 0, v[d + 12 >> 2] = e;
  v[b + 8 >> 2] = -1;
  c = v[Gb(b + 12 | 0, b + 8 | 0) >> 2];
 }
 eb = b + 16 | 0;
 return c;
}

function gi(a, b) {
 var c = 0, d = 0;
 c = w[a | 0];
 d = w[b | 0];
 a: {
  if (!c | (d | 0) != (c | 0)) {
   break a;
  }
  while (1) {
   d = w[b + 1 | 0];
   c = w[a + 1 | 0];
   if (!c) {
    break a;
   }
   b = b + 1 | 0;
   a = a + 1 | 0;
   if ((c | 0) == (d | 0)) {
    continue;
   }
   break;
  }
 }
 return c - d | 0;
}

function be(a, b) {
 var c = 0, d = 0, e = 0;
 d = x[a + 24 >> 1];
 if ((d | 0) != (b & 65535)) {
  c = x[a + 22 >> 1] - 1 & 127;
  u[a + 22 >> 1] = c;
  e = x[a + 20 >> 1];
  if (e >>> 0 <= 127) {
   u[a + 20 >> 1] = e + 1;
  }
  c = (a + 26 | 0) + (c << 2) | 0;
  u[c >> 1] = b - d;
  u[c + 2 >> 1] = 0;
  u[a + 24 >> 1] = b;
 }
}

function $R(a, b, c) {
 var d = 0, e = 0;
 d = Lc(a);
 e = Cb(v[a + 4 >> 2], w[a + 11 | 0]);
 a: {
  if (d - e >>> 0 >= c >>> 0) {
   if (!c) {
    break a;
   }
   d = Jb(a);
   Wg(d + e | 0, b, c);
   b = c + e | 0;
   kg(a, b);
   gd(b + d | 0, 0);
   return a;
  }
  Uq(a, d, (c - d | 0) + e | 0, e, e, 0, c, b);
 }
 return a;
}

function xI(a, b, c, d) {
 a: {
  if (!a) {
   break a;
  }
  b: {
   switch (b + 2 | 0) {
   case 0:
    t[a | 0] = c;
    return;

   case 1:
    u[a >> 1] = c;
    return;

   case 2:
   case 3:
    v[a >> 2] = c;
    return;

   case 5:
    break b;

   default:
    break a;
   }
  }
  v[a >> 2] = c;
  v[a + 4 >> 2] = d;
 }
}

function TD(a, b) {
 var c = 0, d = 0, e = 0;
 c = eb - 16 | 0;
 eb = c;
 v_(c + 8 | 0, b);
 d = v[c + 12 >> 2];
 ic(c, v[a >> 2], v[a + 8 >> 2], v[c + 8 >> 2], v[c + 12 >> 2]);
 e = v[c + 4 >> 2];
 if ((e | 0) == (d | 0)) {
  Ub(a, v[c + 12 >> 2]);
 }
 eb = c + 16 | 0;
 a = (d | 0) == (e | 0);
 if (!a) {
  w_(b);
 }
 return a;
}

function Sk(a) {
 wc(a + 16 | 0, v[a >> 2]);
 wc(a + 8 | 0, v[a >> 2]);
 if (y[a + 12 >> 2] >= y[a + 16 >> 2]) {
  v[a + 12 >> 2] = 0;
  v[a + 16 >> 2] = 0;
  u[a + 34 >> 1] = x[a + 34 >> 1] & 65511;
 }
 if (y[a + 4 >> 2] >= y[a + 8 >> 2]) {
  v[a + 4 >> 2] = 0;
  v[a + 8 >> 2] = 0;
  u[a + 34 >> 1] = x[a + 34 >> 1] & 65529;
 }
}

function BY(a, b) {
 var c = 0, d = 0, e = 0;
 c = eb - 16 | 0;
 eb = c;
 DY(c + 8 | 0, b);
 d = v[c + 12 >> 2];
 ic(c, v[a >> 2], v[a + 8 >> 2], v[c + 8 >> 2], v[c + 12 >> 2]);
 e = v[c + 4 >> 2];
 if ((e | 0) == (d | 0)) {
  Ub(a, v[c + 12 >> 2]);
 }
 eb = c + 16 | 0;
 a = (d | 0) == (e | 0);
 if (!a) {
  CY(b);
 }
 return a;
}

function dK(a, b, c, d, e, f) {
 var g = 0, h = 0, i = 0;
 g = eb - 16 | 0;
 eb = g;
 t[g + 15 | 0] = 0;
 t[g + 14 | 0] = f;
 t[g + 13 | 0] = e;
 t[g + 12 | 0] = 37;
 if (f) {
  qg(g + 13 | 0, g + 14 | 0);
 }
 h = c, i = (ea(b | 0, Sc(b, v[c >> 2]) | 0, g + 12 | 0, d | 0, a | 0) | 0) + b | 0, 
 v[h >> 2] = i;
 eb = g + 16 | 0;
}

function TR(a) {
 var b = 0, c = 0;
 a = a + 906300 | 0;
 c = tk(a);
 while (1) {
  if ((a | 0) != (c | 0)) {
   b = v[a >> 2];
   a: {
    if (!b) {
     break a;
    }
    if (!(hb[v[v[b >> 2] + 120 >> 2]](b) | 0)) {
     break a;
    }
    hb[v[v[b >> 2] + 100 >> 2]](b);
   }
   a = a + 160 | 0;
   continue;
  }
  break;
 }
}

function sv(a, b, c) {
 var d = 0, e = 0, f = 0, g = 0;
 e = eb - 16 | 0;
 eb = e;
 d = eb - 32 | 0;
 eb = d;
 ed(d + 24 | 0, a, b);
 dv(d + 16 | 0, v[d + 24 >> 2], v[d + 28 >> 2], c);
 a = v[d + 16 >> 2];
 f = d, g = $D(c, v[d + 20 >> 2]), v[f + 12 >> 2] = g;
 pc(e + 8 | 0, a, d + 12 | 0);
 eb = d + 32 | 0;
 eb = e + 16 | 0;
}

function g$(a) {
 if (!((w[a | 0] | w[a + 1 | 0] << 8 | (w[a + 2 | 0] << 16 | w[a + 3 | 0] << 24)) != 1179011410 | (w[a + 8 | 0] | w[a + 9 | 0] << 8 | (w[a + 10 | 0] << 16 | w[a + 11 | 0] << 24)) != 1179472708)) {
  return 1;
 }
 return (w[a | 0] | w[a + 1 | 0] << 8 | (w[a + 2 | 0] << 16 | w[a + 3 | 0] << 24)) == 1179472708;
}

function Um(a, b) {
 var c = C(0), d = 0, e = 0;
 c = C(1);
 d = u[a + 28 >> 1];
 a: {
  if ((d | 0) > (b | 0)) {
   break a;
  }
  e = v[a + 4 >> 2];
  if ((nc(e, v[a + 8 >> 2]) + d | 0) - 1 << 16 >> 16 < (b | 0)) {
   break a;
  }
  c = z[xb(e, b - d | 0) >> 2];
  c = c <= C(10000000036274937e-31) ? C(1) : c;
 }
 return c;
}

function Jha(a) {
 a = a | 0;
 var b = 0, c = 0, d = 0;
 b = eb - 32 | 0;
 eb = b;
 a: {
  if (Ug(a) >>> 0 <= 12) {
   if (th(1073741823) >>> 0 <= 12) {
    break a;
   }
   c = zb(a);
   d = a;
   a = Yf(b + 12 | 0, 13, nc(v[a >> 2], v[a + 4 >> 2]), c);
   Rm(d, a);
   Xf(a);
  }
  eb = b + 32 | 0;
  return;
 }
 dd();
 p();
}

function Xp(a, b) {
 var c = 0, d = 0, e = 0, f = 0;
 c = a * a;
 d = c * .5;
 e = 1 - d;
 f = 1 - e - d;
 d = c * c;
 return e + (f + (c * (c * (c * (c * 2480158728947673e-20 + -.001388888888887411) + .0416666666666666) + d * d * (c * (c * -11359647557788195e-27 + 2.087572321298175e-9) + -2.7557314351390663e-7)) - a * b));
}

function MB(a) {
 var b = 0, c = 0;
 b = v[a >> 2];
 c = v[b >> 2];
 a: {
  if (!c) {
   while (1) {
    c = li(b);
    b = v[b + 8 >> 2];
    if (c) {
     continue;
    }
    break;
   }
   break a;
  }
  while (1) {
   b = c;
   c = v[b + 4 >> 2];
   if (c) {
    continue;
   }
   break;
  }
 }
 v[a >> 2] = b;
 return a;
}

function zx(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0;
 e = eb - 16 | 0;
 eb = e;
 v[e + 12 >> 2] = d;
 d = Cb(v[b + 4 >> 2], w[b + 11 | 0]);
 if (d >>> 0 < c >>> 0) {
  cn();
  p();
 }
 b = Jb(b);
 v[e + 8 >> 2] = d - c;
 Gu(a, b + c | 0, v[Gb(e + 12 | 0, e + 8 | 0) >> 2]);
 eb = e + 16 | 0;
}

function ys(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0;
 if (b) {
  d = Lc(a);
  e = Cb(v[a + 4 >> 2], w[a + 11 | 0]);
  if (d - e >>> 0 < b >>> 0) {
   $m(a, d, (b - d | 0) + e | 0, e, e, 0, 0);
  }
  d = Jb(a);
  Zl(d + e | 0, b, c);
  b = b + e | 0;
  kg(a, b);
  gd(b + d | 0, 0);
 }
 return a | 0;
}

function R2(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0;
 e = eb - 16 | 0;
 eb = e;
 v[e + 12 >> 2] = d;
 d = Cb(v[b + 4 >> 2], w[b + 11 | 0]);
 if (d >>> 0 < c >>> 0) {
  cn();
  p();
 }
 b = Jb(b);
 v[e + 8 >> 2] = d - c;
 fG(a, b + c | 0, v[Gb(e + 12 | 0, e + 8 | 0) >> 2]);
 eb = e + 16 | 0;
}

function Bja(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0;
 b = eb - 16 | 0;
 eb = b;
 c = -1;
 a: {
  if (!gk(a, b + 8 | 0)) {
   break a;
  }
  c = 0;
  if (!qR(v[b + 8 >> 2], v[b + 12 >> 2])) {
   break a;
  }
  c = -1;
  if (!eF(a, b + 4 | 0)) {
   break a;
  }
  c = pR(v[b + 4 >> 2]);
 }
 eb = b + 16 | 0;
 return c | 0;
}

function qS(a, b) {
 a = mS(a);
 mS(a + 368680 | 0);
 if (b) {
  lS(a, 1);
  return;
 }
 if (!w[495280]) {
  qS(126576, 1);
  t[495280] = 1;
 }
 zu(257688, 323224, a + 131112 | 0);
 zu(323224, 388760, a + 196648 | 0);
 zu(388760, 454296, a + 262184 | 0);
 zu(126600, 257688, a + 24 | 0);
 yc(a + 327720 | 0, 454296, 40960);
}

function KJ(a, b, c) {
 var d = 0, e = 0;
 e = eb - 16 | 0;
 eb = e;
 d = eb - 32 | 0;
 eb = d;
 ed(d + 24 | 0, a, b);
 cD(d + 16 | 0, v[d + 24 >> 2], v[d + 28 >> 2], c);
 a = mA(a, v[d + 16 >> 2]);
 v[d + 12 >> 2] = v[d + 20 >> 2];
 pc(e + 8 | 0, a, d + 12 | 0);
 eb = d + 32 | 0;
 eb = e + 16 | 0;
 return v[e + 12 >> 2];
}

function Fda(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0;
 c = eb - 16 | 0;
 eb = c;
 d = c + 4 | 0;
 $M(d, b);
 a = v[a + 1298472 >> 2];
 v[31601] = 0;
 R(385, a | 0, 1, d | 0);
 a = v[31601];
 v[31601] = 0;
 if ((a | 0) != 1) {
  sb(d);
  eb = c + 16 | 0;
  return;
 }
 a = M() | 0;
 sb(c + 4 | 0);
 P(a | 0);
 p();
}

function Dr(a) {
 t[a | 0] = 0;
 t[a + 1 | 0] = 0;
 t[a + 2 | 0] = 0;
 t[a + 3 | 0] = 0;
 t[a + 4 | 0] = 0;
 t[a + 5 | 0] = 0;
 t[a + 6 | 0] = 0;
 t[a + 7 | 0] = 0;
 t[a + 8 | 0] = 0;
 t[a + 9 | 0] = 0;
 t[a + 10 | 0] = 0;
 t[a + 11 | 0] = 0;
 t[a + 12 | 0] = 0;
 t[a + 13 | 0] = 0;
 t[a + 14 | 0] = 0;
 t[a + 15 | 0] = 0;
}

function yga(a, b, c, d, e) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 var f = 0;
 f = eb - 16 | 0;
 eb = f;
 b = Fc(Bua(Aua(d, d >> 31, b, 0), gb, 1e3, 0), gb);
 v[a + 16 >> 2] = 0;
 v[a + 12 >> 2] = b + c;
 RP(a, e);
 b = v[a + 12 >> 2];
 v[f + 12 >> 2] = 0;
 SQ(a, b, f + 12 | 0);
 eb = f + 16 | 0;
}

function yZ(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0;
 d = eb - 16 | 0;
 eb = d;
 mg(a, d + 14 | 0);
 e = x[d + 14 >> 1];
 ZR(b, e);
 c = 0;
 while (1) {
  if ((c | 0) == (e | 0)) {
   RA(b);
   eb = d + 16 | 0;
  } else {
   Ek(a, xb(v[b >> 2], c));
   c = c + 1 | 0;
   continue;
  }
  break;
 }
}

function wi(a, b, c) {
 var d = 0, e = 0, f = 0;
 d = eb - 16 | 0;
 eb = d;
 ac(d + 8 | 0, b, c);
 e = v[d + 12 >> 2];
 ic(d, v[a >> 2], v[a + 8 >> 2], v[d + 8 >> 2], v[d + 12 >> 2]);
 f = v[d + 4 >> 2];
 if ((f | 0) == (e | 0)) {
  Ub(a, v[d + 12 >> 2]);
 }
 eb = d + 16 | 0;
 if ((e | 0) != (f | 0)) {
  Qb(b, 0, c);
 }
}

function pha(a) {
 a = a | 0;
 var b = 0;
 hb[v[v[a >> 2] + 132 >> 2]](a);
 Xz(a);
 v[a + 4236 >> 2] = 0;
 t[a + 4202 | 0] = 1;
 b = hb[v[v[a >> 2] + 196 >> 2]](a) | 0;
 v[a + 4328 >> 2] = 0;
 v[a + 4312 >> 2] = 0;
 z[a + 4240 >> 2] = b ? C(.5) : C(1);
 b = v[a + 4256 >> 2];
 v[a + 4324 >> 2] = b;
 v[a + 4320 >> 2] = b;
}

function Tca(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0;
 d = eb - 16 | 0;
 eb = d;
 a = v[a + 4 >> 2];
 b = ig(d + 4 | 0, b);
 v[31601] = 0;
 U(1011, a | 0, b | 0, c | 0, 1);
 a = v[31601];
 v[31601] = 0;
 if ((a | 0) != 1) {
  sb(b);
  eb = d + 16 | 0;
  return;
 }
 a = M() | 0;
 sb(b);
 P(a | 0);
 p();
}

function Npa(a) {
 a = a | 0;
 var b = 0, c = 0, d = 0;
 b = eb - 32 | 0;
 eb = b;
 u[b + 30 >> 1] = 0;
 c = Yb(b + 8 | 0, b + 30 | 0, 2);
 ic(b + 20 | 0, v[a >> 2], v[a + 8 >> 2], v[c >> 2], v[c + 4 >> 2]);
 if (!(v[b + 24 >> 2] != 2 | x[b + 30 >> 1] != 21584)) {
  Ub(a, 2);
  d = 1;
 }
 eb = b + 32 | 0;
 return d | 0;
}

function MA(a, b) {
 var c = 0, d = 0;
 c = v[b + 4 >> 2];
 v[a + 24648 >> 2] = v[b >> 2];
 v[a + 24652 >> 2] = c;
 d = v[b + 20 >> 2];
 c = a + 24664 | 0;
 v[c >> 2] = v[b + 16 >> 2];
 v[c + 4 >> 2] = d;
 d = v[b + 12 >> 2];
 c = a + 24656 | 0;
 v[c >> 2] = v[b + 8 >> 2];
 v[c + 4 >> 2] = d;
 KR(a + 24648 | 0);
 QR(a);
}

function KS(a, b, c) {
 var d = 0, e = 0;
 d = eb - 16 | 0;
 eb = d;
 a = hs(d + 4 | 0, a, b);
 b = v[a + 4 >> 2];
 e = v[a + 8 >> 2];
 while (1) {
  if ((b | 0) == (e | 0)) {
   hc(a);
   eb = d + 16 | 0;
  } else {
   IS(b, v[c >> 2], v[c + 4 >> 2]);
   b = b + 8 | 0;
   v[a + 4 >> 2] = b;
   continue;
  }
  break;
 }
}

function HS(a, b) {
 var c = 0;
 c = v[b + 4 >> 2];
 v[a >> 2] = v[b >> 2];
 v[a + 4 >> 2] = c;
 c = v[b + 28 >> 2];
 v[a + 24 >> 2] = v[b + 24 >> 2];
 v[a + 28 >> 2] = c;
 c = v[b + 20 >> 2];
 v[a + 16 >> 2] = v[b + 16 >> 2];
 v[a + 20 >> 2] = c;
 c = v[b + 12 >> 2];
 v[a + 8 >> 2] = v[b + 8 >> 2];
 v[a + 12 >> 2] = c;
}

function h9(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0;
 d = eb - 16 | 0;
 eb = d;
 f = v[v[b >> 2] + 20 >> 2];
 e = v[c + 12 >> 2];
 v[d + 8 >> 2] = v[c + 8 >> 2];
 v[d + 12 >> 2] = e;
 e = v[c + 4 >> 2];
 v[d >> 2] = v[c >> 2];
 v[d + 4 >> 2] = e;
 hb[f | 0](a, b, d, 8);
 eb = d + 16 | 0;
}

function lda(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0;
 d = eb - 16 | 0;
 eb = d;
 e = v[a + 4 >> 2];
 a = v[b + 4 >> 2];
 b = v[b >> 2];
 v[d + 8 >> 2] = b;
 v[d + 12 >> 2] = a;
 f = v[c >> 2];
 c = v[c + 4 >> 2];
 v[d >> 2] = b;
 v[d + 4 >> 2] = a;
 Oz(e, d, f, c, 1);
 eb = d + 16 | 0;
}

function Wh(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0;
 c = eb - 16 | 0;
 eb = c;
 Yk(c + 8 | 0, b);
 b = v[c + 12 >> 2];
 ic(c, v[a >> 2], v[a + 8 >> 2], v[c + 8 >> 2], v[c + 12 >> 2]);
 d = v[c + 4 >> 2];
 if ((b | 0) == (d | 0)) {
  Ub(a, v[c + 12 >> 2]);
 }
 eb = c + 16 | 0;
 return (b | 0) == (d | 0) | 0;
}

function IY(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0;
 c = eb - 16 | 0;
 eb = c;
 YD(c + 8 | 0, b);
 b = v[c + 12 >> 2];
 ic(c, v[a >> 2], v[a + 8 >> 2], v[c + 8 >> 2], v[c + 12 >> 2]);
 d = v[c + 4 >> 2];
 if ((b | 0) == (d | 0)) {
  Ub(a, v[c + 12 >> 2]);
 }
 eb = c + 16 | 0;
 return (b | 0) == (d | 0) | 0;
}

function pd(a, b, c, d) {
 var e = 0, f = 0;
 e = eb - 32 | 0;
 eb = e;
 f = v[b + 12 >> 2];
 lf(e + 16 | 0, c, d);
 c = v[v[b >> 2] + 28 >> 2];
 d = v[e + 20 >> 2];
 v[e + 8 >> 2] = v[e + 16 >> 2];
 v[e + 12 >> 2] = d;
 hb[c | 0](e + 24 | 0, b, f, e + 8 | 0);
 lf(a, v[e + 24 >> 2], v[e + 28 >> 2]);
 eb = e + 32 | 0;
}

function _ka(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0;
 a = Mb(a);
 d = ng(a + 12 | 0);
 t[a + 32 | 0] = c;
 v[a + 28 >> 2] = 0;
 v[a + 24 >> 2] = b;
 v[31601] = 0;
 N(800, a | 0, 1);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  return a | 0;
 }
 b = M() | 0;
 _T(d);
 cU(a);
 P(b | 0);
 p();
}

function Vba(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0;
 d = eb - 16 | 0;
 eb = d;
 b = v[b + 4 >> 2];
 c = ig(d + 4 | 0, c);
 v[31601] = 0;
 R(997, a | 0, b | 0, c | 0);
 a = v[31601];
 v[31601] = 0;
 if ((a | 0) != 1) {
  sb(c);
  eb = d + 16 | 0;
  return;
 }
 a = M() | 0;
 sb(c);
 P(a | 0);
 p();
}

function P5(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 while (1) {
  if ((b | 0) != (c | 0)) {
   a = v[b >> 2];
   if (a >>> 0 <= 127) {
    a = v[(a << 2) + 95312 >> 2];
   } else {
    a = 0;
   }
   v[d >> 2] = a;
   d = d + 4 | 0;
   b = b + 4 | 0;
   continue;
  }
  break;
 }
 return c | 0;
}

function Gq(a, b) {
 a = yc(a, b, 88);
 v[a + 88 >> 2] = v[b + 88 >> 2];
 yc(a + 92 | 0, b + 92 | 0, 576);
 v[a + 668 >> 2] = v[b + 668 >> 2];
 yc(a + 672 | 0, b + 672 | 0, 52);
 kB(a + 724 | 0, b + 724 | 0);
 kB(a + 732 | 0, b + 732 | 0);
 kB(a + 740 | 0, b + 740 | 0);
 yc(a + 748 | 0, b + 748 | 0, 123);
 return a;
}

function FB(a, b, c, d) {
 var e = 0, f = 0, g = 0;
 e = c - b | 0;
 a: {
  if ((e | 0) <= 9) {
   g = e;
   e = B(32 - E(d | 1) | 0, 1233) >>> 12 | 0;
   f = 61;
   if ((g | 0) < (e + (y[(e << 2) + 121056 >> 2] <= d >>> 0) | 0)) {
    break a;
   }
  }
  c = BB(b, d);
  f = 0;
 }
 v[a + 4 >> 2] = f;
 v[a >> 2] = c;
}

function BX(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0;
 d = v[a >> 2];
 c = 65535;
 a: {
  if (!Ie(d, v[a + 4 >> 2], b)) {
   break a;
  }
  d = iE(a, v[Zi(d, b) + 12 >> 2]);
  c = 65535;
  if ((d | 0) == 65535) {
   break a;
  }
  c = v[a >> 2];
  a = Zi(c, b);
  fR(Zi(c, d), a);
  c = d;
 }
 return c | 0;
}

function AJ(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0;
 c = eb - 16 | 0;
 eb = c;
 if (th(1073741823) >>> 0 < b >>> 0) {
  dd();
  p();
 }
 iJ(c + 8 | 0, it(a), b);
 b = v[c + 8 >> 2];
 v[a + 4 >> 2] = b;
 v[a >> 2] = b;
 d = zb(a), e = b + (v[c + 12 >> 2] << 2) | 0, v[d >> 2] = e;
 eb = c + 16 | 0;
}

function id(a, b, c) {
 var d = 0, e = 0, f = 0;
 a: {
  if (!c) {
   break a;
  }
  while (1) {
   d = w[a | 0];
   e = w[b | 0];
   if ((d | 0) == (e | 0)) {
    b = b + 1 | 0;
    a = a + 1 | 0;
    c = c - 1 | 0;
    if (c) {
     continue;
    }
    break a;
   }
   break;
  }
  f = d - e | 0;
 }
 return f;
}

function GN(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0;
 a = Cj(a);
 v[a + 4 >> 2] = 0;
 v[a >> 2] = 47536;
 if (hb[v[v[b >> 2] + 8 >> 2]](b) | 0) {
  b = hb[v[v[b >> 2] + 8 >> 2]](b) | 0;
 } else {
  b = 22256;
 }
 c = Fd(Df(b) + 1 | 0);
 v[a + 4 >> 2] = c;
 if (c) {
  yc(c, b, Df(b) + 1 | 0);
 }
 return a | 0;
}

function YI(a) {
 a = a | 0;
 var b = 0, c = 0, d = 0;
 v[a >> 2] = 95180;
 d = a + 8 | 0;
 while (1) {
  b = v[a + 8 >> 2];
  if (nc(b, v[a + 12 >> 2]) >>> 0 > c >>> 0) {
   b = v[xb(b, c) >> 2];
   if (b) {
    sm(b);
   }
   c = c + 1 | 0;
   continue;
  }
  break;
 }
 sb(a + 152 | 0);
 oy(d);
 return a | 0;
}

function Dj(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0;
 a: {
  d = Ol(a, b);
  if ((d | 0) == 255) {
   break a;
  }
  xk(a, b);
  Pq(a, b, 0, 0);
  if (!c) {
   break a;
  }
  e = $b(a + 26 | 0, d), f = 65535, u[e >> 1] = f;
  a = wb(a + 62 | 0, b);
  t[a | 0] = w[a | 0] | 128;
 }
}

function iU(a, b, c, d, e, f) {
 v[a + 40 >> 2] = 0;
 v[a + 44 >> 2] = 0;
 A[a + 32 >> 3] = f;
 A[a + 24 >> 3] = e;
 A[a + 16 >> 3] = d;
 A[a + 8 >> 3] = c;
 A[a >> 3] = b;
 v[a + 48 >> 2] = 0;
 v[a + 52 >> 2] = 0;
 v[a + 56 >> 2] = 0;
 v[a + 60 >> 2] = 0;
 a = a - -64 | 0;
 v[a >> 2] = 0;
 v[a + 4 >> 2] = 0;
}

function _p(a, b, c) {
 var d = 0;
 d = eb - 16 | 0;
 eb = d;
 if (w[b | 0]) {
  v[d + 8 >> 2] = 0;
  v[d + 12 >> 2] = 0;
  b = py(d + 4 | 0, b, Df(b), d + 8 | 0, c);
  if (b >>> 0 <= 4294967293) {
   v[a >> 2] = v[d + 4 >> 2];
  }
  a = b >>> 0 < 4294967294;
 } else {
  a = 0;
 }
 eb = d + 16 | 0;
 return a;
}

function rj(a) {
 var b = 0;
 b = 32767;
 a: {
  if (a >= C(32766.5)) {
   break a;
  }
  b = 32768;
  if (a <= C(-32767.5)) {
   break a;
  }
  a = C(a + C(.5));
  b: {
   if (C(D(a)) < C(2147483648)) {
    b = ~~a;
    break b;
   }
   b = -2147483648;
  }
  b = b + (b >> 15) | 0;
 }
 return b << 16 >> 16;
}

function bqa(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0;
 c = eb - 16 | 0;
 eb = c;
 if (th(1073741823) >>> 0 < b >>> 0) {
  dd();
  p();
 }
 KF(c + 8 | 0, b);
 b = v[c + 8 >> 2];
 v[a + 4 >> 2] = b;
 v[a >> 2] = b;
 d = zb(a), e = b + (v[c + 12 >> 2] << 2) | 0, v[d >> 2] = e;
 eb = c + 16 | 0;
}

function $_(a) {
 var b = 0;
 a: {
  if ((w[a | 0] | w[a + 1 | 0] << 8 | (w[a + 2 | 0] << 16 | w[a + 3 | 0] << 24)) != 443372356 | w[a + 4 | 0] != 32 | (!w[a + 46 | 0] | (w[a + 45 | 0] - 17 & 255) >>> 0 < 240)) {
   break a;
  }
  if (!w[a + 47 | 0]) {
   break a;
  }
  b = w[a + 49 | 0] < 101;
 }
 return b;
}

function vV(a) {
 var b = 0, c = 0, d = 0;
 c = w[a + 64 | 0] | w[a + 65 | 0] << 8;
 b = w[a + 72 | 0] | w[a + 73 | 0] << 8;
 a = w[a + 70 | 0] | w[a + 71 | 0] << 8;
 b = b + a | 0;
 a = (a >>> 0 > b >>> 0 | d) << 2 | b >>> 30;
 b = b << 2;
 c = b + c | 0;
 gb = b >>> 0 > c >>> 0 ? a + 1 | 0 : a;
 return c;
}

function hm(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0;
 c = eb - 16 | 0;
 eb = c;
 if (th(1073741823) >>> 0 < b >>> 0) {
  dd();
  p();
 }
 Mj(c + 8 | 0, b);
 b = v[c + 8 >> 2];
 v[a + 4 >> 2] = b;
 v[a >> 2] = b;
 d = zb(a), e = b + (v[c + 12 >> 2] << 2) | 0, v[d >> 2] = e;
 eb = c + 16 | 0;
}

function ek(a, b) {
 var c = 0, d = 0;
 c = eb - 16 | 0;
 eb = c;
 v[c + 12 >> 2] = b;
 d = b;
 b = th(2147483647);
 if (d >>> 0 <= b >>> 0) {
  a = Gn(a);
  if (a >>> 0 < b >>> 1 >>> 0) {
   v[c + 8 >> 2] = a << 1;
   b = v[ad(c + 8 | 0, c + 12 | 0) >> 2];
  }
  eb = c + 16 | 0;
  return b;
 }
 dd();
 p();
}

function Vja(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0, g = 0;
 d = eb - 16 | 0;
 eb = d;
 e = x[a + 28 >> 1];
 u[d + 12 >> 1] = e;
 f = d, g = (nc(v[a + 4 >> 2], v[a + 8 >> 2]) + e | 0) - 1 | 0, u[f + 14 >> 1] = g;
 a = UQ(a, b, c, d + 12 | 0);
 eb = d + 16 | 0;
 return a | 0;
}

function QW(a) {
 var b = 0, c = 0, d = 0;
 c = w[a + 32 | 0] | w[a + 33 | 0] << 8;
 b = w[a + 36 | 0] | w[a + 37 | 0] << 8;
 a = w[a + 34 | 0] | w[a + 35 | 0] << 8;
 b = b + a | 0;
 a = (a >>> 0 > b >>> 0 | d) << 1 | b >>> 31;
 b = b << 1;
 c = b + c | 0;
 gb = b >>> 0 > c >>> 0 ? a + 1 | 0 : a;
 return c;
}

function Kf(a, b) {
 var c = 0, d = 0;
 c = eb - 16 | 0;
 eb = c;
 v[c + 12 >> 2] = b;
 d = b;
 b = th(1073741823);
 if (d >>> 0 <= b >>> 0) {
  a = Ug(a);
  if (a >>> 0 < b >>> 1 >>> 0) {
   v[c + 8 >> 2] = a << 1;
   b = v[ad(c + 8 | 0, c + 12 | 0) >> 2];
  }
  eb = c + 16 | 0;
  return b;
 }
 dd();
 p();
}

function KC(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0;
 c = eb - 16 | 0;
 eb = c;
 if (th(2147483647) >>> 0 < b >>> 0) {
  dd();
  p();
 }
 Zw(c + 8 | 0, b);
 b = v[c + 8 >> 2];
 v[a + 4 >> 2] = b;
 v[a >> 2] = b;
 d = zb(a), e = b + (v[c + 12 >> 2] << 1) | 0, v[d >> 2] = e;
 eb = c + 16 | 0;
}

function IO(a, b) {
 var c = 0, d = 0;
 c = -1;
 a: {
  if ((b | 0) < 0) {
   break a;
  }
  d = v[a + 24 >> 2];
  if (Gj(Wb(v[d + 484360 >> 2], w[d + 484376 | 0])) >>> 0 <= b >>> 0) {
   break a;
  }
  a = v[a + 24 >> 2];
  c = x[$b(v[Wb(v[a + 484360 >> 2], w[a + 484376 | 0]) >> 2], b) >> 1];
 }
 return c;
}

function uD(a, b) {
 var c = 0, d = 0;
 c = eb - 16 | 0;
 eb = c;
 v[c + 12 >> 2] = b;
 d = b;
 b = th(715827882);
 if (d >>> 0 <= b >>> 0) {
  a = iw(a);
  if (a >>> 0 < b >>> 1 >>> 0) {
   v[c + 8 >> 2] = a << 1;
   b = v[ad(c + 8 | 0, c + 12 | 0) >> 2];
  }
  eb = c + 16 | 0;
  return b;
 }
 dd();
 p();
}

function pZ(a, b, c, d) {
 var e = 0;
 e = eb - 16 | 0;
 eb = e;
 v[e + 12 >> 2] = b;
 v[e + 8 >> 2] = d;
 c = TG(a, c, v[Gb(e + 12 | 0, e + 8 | 0) >> 2]);
 a: {
  if (c) {
   break a;
  }
  c = 0;
  if ((b | 0) == (d | 0)) {
   break a;
  }
  c = b >>> 0 < d >>> 0 ? -1 : 1;
 }
 eb = e + 16 | 0;
 return c;
}

function m_(a, b, c, d) {
 var e = 0;
 e = eb - 16 | 0;
 eb = e;
 v[e + 12 >> 2] = b;
 v[e + 8 >> 2] = d;
 c = ot(a, c, v[Gb(e + 12 | 0, e + 8 | 0) >> 2]);
 a: {
  if (c) {
   break a;
  }
  c = 0;
  if ((b | 0) == (d | 0)) {
   break a;
  }
  c = b >>> 0 < d >>> 0 ? -1 : 1;
 }
 eb = e + 16 | 0;
 return c;
}

function mG(a, b) {
 var c = 0, d = 0;
 c = eb - 16 | 0;
 eb = c;
 v[c + 12 >> 2] = b;
 d = b;
 b = th(119304647);
 if (d >>> 0 <= b >>> 0) {
  a = hx(a);
  if (a >>> 0 < b >>> 1 >>> 0) {
   v[c + 8 >> 2] = a << 1;
   b = v[ad(c + 8 | 0, c + 12 | 0) >> 2];
  }
  eb = c + 16 | 0;
  return b;
 }
 dd();
 p();
}

function ks(a, b) {
 var c = 0, d = 0;
 c = eb - 16 | 0;
 eb = c;
 v[c + 12 >> 2] = b;
 d = b;
 b = th(536870911);
 if (d >>> 0 <= b >>> 0) {
  a = Rn(a);
  if (a >>> 0 < b >>> 1 >>> 0) {
   v[c + 8 >> 2] = a << 1;
   b = v[ad(c + 8 | 0, c + 12 | 0) >> 2];
  }
  eb = c + 16 | 0;
  return b;
 }
 dd();
 p();
}

function gU(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0;
 c = eb - 16 | 0;
 eb = c;
 if (th(536870911) >>> 0 < b >>> 0) {
  dd();
  p();
 }
 qG(c + 8 | 0, b);
 b = v[c + 8 >> 2];
 v[a + 4 >> 2] = b;
 v[a >> 2] = b;
 d = zb(a), e = b + (v[c + 12 >> 2] << 3) | 0, v[d >> 2] = e;
 eb = c + 16 | 0;
}

function fU(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0;
 c = eb - 16 | 0;
 eb = c;
 if (th(268435455) >>> 0 < b >>> 0) {
  dd();
  p();
 }
 LV(c + 8 | 0, b);
 b = v[c + 8 >> 2];
 v[a + 4 >> 2] = b;
 v[a >> 2] = b;
 d = zb(a), e = b + (v[c + 12 >> 2] << 4) | 0, v[d >> 2] = e;
 eb = c + 16 | 0;
}

function Wq(a, b) {
 var c = 0, d = 0;
 c = eb - 16 | 0;
 eb = c;
 v[c + 12 >> 2] = b;
 d = b;
 b = th(134217727);
 if (d >>> 0 <= b >>> 0) {
  a = Yo(a);
  if (a >>> 0 < b >>> 1 >>> 0) {
   v[c + 8 >> 2] = a << 1;
   b = v[ad(c + 8 | 0, c + 12 | 0) >> 2];
  }
  eb = c + 16 | 0;
  return b;
 }
 dd();
 p();
}

function WD(a, b) {
 var c = 0, d = 0;
 c = eb - 16 | 0;
 eb = c;
 v[c + 12 >> 2] = b;
 d = b;
 b = th(214748364);
 if (d >>> 0 <= b >>> 0) {
  a = TE(a);
  if (a >>> 0 < b >>> 1 >>> 0) {
   v[c + 8 >> 2] = a << 1;
   b = v[ad(c + 8 | 0, c + 12 | 0) >> 2];
  }
  eb = c + 16 | 0;
  return b;
 }
 dd();
 p();
}

function T0(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0;
 c = eb - 16 | 0;
 eb = c;
 if (th(214748364) >>> 0 < b >>> 0) {
  dd();
  p();
 }
 RE(c + 8 | 0, b);
 b = v[c + 8 >> 2];
 v[a + 4 >> 2] = b;
 v[a >> 2] = b;
 d = zb(a), e = b + B(v[c + 12 >> 2], 20) | 0, v[d >> 2] = e;
 eb = c + 16 | 0;
}

function Qp(a, b) {
 var c = 0, d = 0;
 c = eb - 16 | 0;
 eb = c;
 v[c + 12 >> 2] = b;
 d = b;
 b = th(357913941);
 if (d >>> 0 <= b >>> 0) {
  a = al(a);
  if (a >>> 0 < b >>> 1 >>> 0) {
   v[c + 8 >> 2] = a << 1;
   b = v[ad(c + 8 | 0, c + 12 | 0) >> 2];
  }
  eb = c + 16 | 0;
  return b;
 }
 dd();
 p();
}

function O9(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0;
 c = eb - 16 | 0;
 eb = c;
 if (th(357913941) >>> 0 < b >>> 0) {
  dd();
  p();
 }
 VG(c + 8 | 0, b);
 b = v[c + 8 >> 2];
 v[a + 4 >> 2] = b;
 v[a >> 2] = b;
 d = zb(a), e = b + B(v[c + 12 >> 2], 12) | 0, v[d >> 2] = e;
 eb = c + 16 | 0;
}

function O3(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0, f = 0;
 e = v[a + 84 >> 2];
 d = c + 256 | 0;
 f = Nz(e, 0, d);
 d = f ? f - e | 0 : d;
 c = c >>> 0 > d >>> 0 ? d : c;
 yc(b, e, c);
 b = e + d | 0;
 v[a + 84 >> 2] = b;
 v[a + 8 >> 2] = b;
 v[a + 4 >> 2] = c + e;
 return c | 0;
}

function NV(a, b) {
 var c = 0, d = 0;
 c = eb - 16 | 0;
 eb = c;
 v[c + 12 >> 2] = b;
 d = b;
 b = th(268435455);
 if (d >>> 0 <= b >>> 0) {
  a = lv(a);
  if (a >>> 0 < b >>> 1 >>> 0) {
   v[c + 8 >> 2] = a << 1;
   b = v[ad(c + 8 | 0, c + 12 | 0) >> 2];
  }
  eb = c + 16 | 0;
  return b;
 }
 dd();
 p();
}

function IJ(a, b) {
 var c = 0, d = 0;
 c = eb - 16 | 0;
 eb = c;
 v[c + 12 >> 2] = b;
 d = b;
 b = th(178956970);
 if (d >>> 0 <= b >>> 0) {
  a = jt(a);
  if (a >>> 0 < b >>> 1 >>> 0) {
   v[c + 8 >> 2] = a << 1;
   b = v[ad(c + 8 | 0, c + 12 | 0) >> 2];
  }
  eb = c + 16 | 0;
  return b;
 }
 dd();
 p();
}

function vZ(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0;
 c = eb - 16 | 0;
 eb = c;
 if (th(715827882) >>> 0 < b >>> 0) {
  dd();
  p();
 }
 gZ(c + 8 | 0, b);
 b = v[c + 8 >> 2];
 v[a + 4 >> 2] = b;
 v[a >> 2] = b;
 d = zb(a), e = b + B(v[c + 12 >> 2], 6) | 0, v[d >> 2] = e;
 eb = c + 16 | 0;
}

function tp(a, b, c) {
 var d = 0, e = 0;
 d = eb - 16 | 0;
 eb = d;
 a = aj(d + 4 | 0, a, b);
 b = v[a + 4 >> 2];
 e = v[a + 8 >> 2];
 while (1) {
  if ((b | 0) == (e | 0)) {
   hc(a);
   eb = d + 16 | 0;
  } else {
   km(b, x[c >> 1]);
   b = b + 2 | 0;
   v[a + 4 >> 2] = b;
   continue;
  }
  break;
 }
}

function qT(a, b, c, d) {
 a: {
  if ((a | 0) != 67108864) {
   break a;
  }
  a = c + 616 | 0;
  c = a + B(d, 872) | 0;
  v[c + 88 >> 2] = v[c + 88 >> 2] & -129;
  c = b & 65535;
  b = d ^ 1;
  if (c >>> 0 <= b >>> 0) {
   break a;
  }
  a = a + B(b, 872) | 0;
  v[a + 88 >> 2] = v[a + 88 >> 2] & -129;
 }
}

function pA(a, b, c) {
 var d = 0, e = 0;
 d = eb - 16 | 0;
 eb = d;
 a = wh(d + 4 | 0, a, b);
 b = v[a + 4 >> 2];
 e = v[a + 8 >> 2];
 while (1) {
  if ((b | 0) == (e | 0)) {
   hc(a);
   eb = d + 16 | 0;
  } else {
   sk(b, z[c >> 2]);
   b = b + 4 | 0;
   v[a + 4 >> 2] = b;
   continue;
  }
  break;
 }
}

function nX(a, b) {
 var c = 0, d = 0, e = 0;
 c = eb - 16 | 0;
 eb = c;
 jX(c + 8 | 0, b);
 d = v[c + 12 >> 2];
 pd(c, a, v[c + 8 >> 2], v[c + 12 >> 2]);
 e = v[c + 4 >> 2];
 if ((e | 0) == (d | 0)) {
  hd(a, v[c + 12 >> 2]);
 }
 eb = c + 16 | 0;
 a = (d | 0) == (e | 0);
 if (!a) {
  kX(b);
 }
 return a;
}

function gk(a, b) {
 var c = 0, d = 0, e = 0;
 c = eb - 16 | 0;
 eb = c;
 Yk(c + 8 | 0, b);
 d = v[c + 12 >> 2];
 pd(c, a, v[c + 8 >> 2], v[c + 12 >> 2]);
 e = v[c + 4 >> 2];
 if ((e | 0) == (d | 0)) {
  hd(a, v[c + 12 >> 2]);
 }
 eb = c + 16 | 0;
 a = (d | 0) == (e | 0);
 if (!a) {
  Zk(b);
 }
 return a;
}

function dE(a, b) {
 var c = 0, d = 0, e = 0;
 c = eb - 16 | 0;
 eb = c;
 zr(c + 8 | 0, b);
 d = v[c + 12 >> 2];
 pd(c, a, v[c + 8 >> 2], v[c + 12 >> 2]);
 e = v[c + 4 >> 2];
 if ((e | 0) == (d | 0)) {
  hd(a, v[c + 12 >> 2]);
 }
 eb = c + 16 | 0;
 a = (d | 0) == (e | 0);
 if (!a) {
  f$(b);
 }
 return a;
}

function cR(a, b) {
 var c = 0, d = 0;
 c = eb - 16 | 0;
 eb = c;
 v[c + 12 >> 2] = b;
 d = b;
 b = th(82595524);
 if (d >>> 0 <= b >>> 0) {
  a = Eu(a);
  if (a >>> 0 < b >>> 1 >>> 0) {
   v[c + 8 >> 2] = a << 1;
   b = v[ad(c + 8 | 0, c + 12 | 0) >> 2];
  }
  eb = c + 16 | 0;
  return b;
 }
 dd();
 p();
}

function a$(a, b) {
 var c = 0, d = 0, e = 0;
 c = eb - 16 | 0;
 eb = c;
 mw(c + 8 | 0, b);
 d = v[c + 12 >> 2];
 pd(c, a, v[c + 8 >> 2], v[c + 12 >> 2]);
 e = v[c + 4 >> 2];
 if ((e | 0) == (d | 0)) {
  hd(a, v[c + 12 >> 2]);
 }
 eb = c + 16 | 0;
 a = (d | 0) == (e | 0);
 if (!a) {
  gw(b);
 }
 return a;
}

function ZF(a, b) {
 var c = 0, d = 0, e = 0;
 c = eb - 16 | 0;
 eb = c;
 bs(c + 8 | 0, b);
 d = v[c + 12 >> 2];
 pd(c, a, v[c + 8 >> 2], v[c + 12 >> 2]);
 e = v[c + 4 >> 2];
 if ((e | 0) == (d | 0)) {
  hd(a, v[c + 12 >> 2]);
 }
 eb = c + 16 | 0;
 a = (d | 0) == (e | 0);
 if (!a) {
  cs(b);
 }
 return a;
}

function XE(a, b, c) {
 var d = 0, e = 0;
 d = eb - 16 | 0;
 eb = d;
 a = wh(d + 4 | 0, a, b);
 b = v[a + 4 >> 2];
 e = v[a + 8 >> 2];
 while (1) {
  if ((b | 0) == (e | 0)) {
   hc(a);
   eb = d + 16 | 0;
  } else {
   vq(b, v[c >> 2]);
   b = b + 4 | 0;
   v[a + 4 >> 2] = b;
   continue;
  }
  break;
 }
}

function KW(a, b) {
 var c = 0, d = 0, e = 0;
 c = eb - 16 | 0;
 eb = c;
 jx(c + 8 | 0, b);
 d = v[c + 12 >> 2];
 pd(c, a, v[c + 8 >> 2], v[c + 12 >> 2]);
 e = v[c + 4 >> 2];
 if ((e | 0) == (d | 0)) {
  hd(a, v[c + 12 >> 2]);
 }
 eb = c + 16 | 0;
 a = (d | 0) == (e | 0);
 if (!a) {
  kx(b);
 }
 return a;
}

function JG(a, b) {
 var c = 0, d = 0, e = 0;
 c = eb - 16 | 0;
 eb = c;
 HG(c + 8 | 0, b);
 d = v[c + 12 >> 2];
 pd(c, a, v[c + 8 >> 2], v[c + 12 >> 2]);
 e = v[c + 4 >> 2];
 if ((e | 0) == (d | 0)) {
  hd(a, v[c + 12 >> 2]);
 }
 eb = c + 16 | 0;
 a = (d | 0) == (e | 0);
 if (!a) {
  ux(b);
 }
 return a;
}

function FW(a, b) {
 var c = 0, d = 0, e = 0;
 c = eb - 16 | 0;
 eb = c;
 v_(c + 8 | 0, b);
 d = v[c + 12 >> 2];
 pd(c, a, v[c + 8 >> 2], v[c + 12 >> 2]);
 e = v[c + 4 >> 2];
 if ((e | 0) == (d | 0)) {
  hd(a, v[c + 12 >> 2]);
 }
 eb = c + 16 | 0;
 a = (d | 0) == (e | 0);
 if (!a) {
  w_(b);
 }
 return a;
}

function D$(a, b) {
 var c = 0, d = 0, e = 0;
 c = eb - 16 | 0;
 eb = c;
 lw(c + 8 | 0, b);
 d = v[c + 12 >> 2];
 pd(c, a, v[c + 8 >> 2], v[c + 12 >> 2]);
 e = v[c + 4 >> 2];
 if ((e | 0) == (d | 0)) {
  hd(a, v[c + 12 >> 2]);
 }
 eb = c + 16 | 0;
 a = (d | 0) == (e | 0);
 if (!a) {
  nE(b);
 }
 return a;
}

function eG(a) {
 var b = 0;
 if (!((w[a | 0] | w[a + 1 | 0] << 8 | (w[a + 2 | 0] << 16 | w[a + 3 | 0] << 24)) != 808603728 | (w[a + 4 | 0] - 16 & 255) >>> 0 < 249 | ((w[a + 5 | 0] - 16 & 255) >>> 0 < 249 | (w[a + 6 | 0] - 16 & 255) >>> 0 < 249))) {
  b = (w[a + 7 | 0] - 9 & 255) >>> 0 < 7;
 }
 return b;
}

function Ap(a, b, c) {
 var d = 0, e = 0;
 d = eb - 16 | 0;
 eb = d;
 a = Xo(d + 4 | 0, a, b);
 b = v[a + 4 >> 2];
 e = v[a + 8 >> 2];
 while (1) {
  if ((b | 0) == (e | 0)) {
   hc(a);
   eb = d + 16 | 0;
  } else {
   po(b, w[c | 0]);
   b = b + 1 | 0;
   v[a + 4 >> 2] = b;
   continue;
  }
  break;
 }
}

function gE(a, b) {
 var c = 0;
 c = eb - 16 | 0;
 eb = c;
 v[c + 12 >> 2] = 1;
 v[c + 8 >> 2] = a >>> 4;
 b = Xb(128 / (B(v[Ye(c + 12 | 0, c + 8 | 0) >> 2], b) | 0) | 0, 1, 15);
 t[c + 7 | 0] = 1;
 t[c + 6 | 0] = a & 15;
 a = cf(c + 7 | 0, c + 6 | 0);
 eb = c + 16 | 0;
 return w[a | 0] | b << 4 & 240;
}

function cta(a, b) {
 a = a | 0;
 b = b | 0;
 if (!b$(a, b)) {
  t[b | 0] = 0;
  t[b + 1 | 0] = 0;
  t[b + 2 | 0] = 0;
  t[b + 3 | 0] = 0;
  t[b + 4 | 0] = 0;
  t[b + 5 | 0] = 0;
  t[b + 6 | 0] = 0;
  t[b + 7 | 0] = 0;
  t[b + 8 | 0] = 0;
  t[b + 9 | 0] = 0;
  t[b + 10 | 0] = 0;
  t[b + 11 | 0] = 0;
 }
}

function to(a) {
 var b = 0, c = 0;
 b = eb - 16 | 0;
 eb = b;
 a: {
  if (!PM(w[a + 20 | 0])) {
   v[31601] = 0;
   N(1133, b + 15 | 0, a | 0);
   c = v[31601];
   v[31601] = 0;
   if ((c | 0) == 1) {
    break a;
   }
  }
  t[a + 20 | 0] = 255;
  eb = b + 16 | 0;
  return;
 }
 S(0) | 0;
 Rb();
 p();
}

function soa(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0;
 b = eb - 16 | 0;
 eb = b;
 d = b + 8 | 0;
 c = -1;
 a: {
  if (!gk(a, d)) {
   break a;
  }
  c = 0;
  if (!jW(d)) {
   break a;
  }
  c = -1;
  if (!ih(a, 4)) {
   break a;
  }
  c = IW(a) >>> 31 | 0;
 }
 eb = b + 16 | 0;
 return c | 0;
}

function Ska(a) {
 a = a | 0;
 var b = 0, c = 0, d = 0, e = 0;
 b = eb - 16 | 0;
 eb = b;
 if (th(2147483647) >>> 0 <= 2303) {
  dd();
  p();
 }
 Zw(b + 8 | 0, 2304);
 c = v[b + 8 >> 2];
 v[a + 4 >> 2] = c;
 v[a >> 2] = c;
 d = zb(a), e = (v[b + 12 >> 2] << 1) + c | 0, v[d >> 2] = e;
 eb = b + 16 | 0;
}

function i2(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 d = !b | (b >>> 0 > d >>> 0 | a >>> 0 >= d >>> 0 | d - a >>> 0 < b >>> 0);
 a: {
  if (d) {
   break a;
  }
  a = a + b | 0;
  if (Sc(v[c >> 2], v[c + 4 >> 2]) >>> 0 >= a >>> 0) {
   break a;
  }
  Qj(c, a);
 }
 return !d | 0;
}

function O5(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 while (1) {
  a: {
   if ((c | 0) != (d | 0)) {
    a = v[c >> 2];
    if (a >>> 0 > 127 | !(v[(a << 2) + 95312 >> 2] & b)) {
     break a;
    }
   } else {
    c = d;
   }
   return c | 0;
  }
  c = c + 4 | 0;
  continue;
 }
}

function L2(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0;
 a = Pt(a);
 v[a >> 2] = 93352;
 b = Uc(a + 32 | 0, b);
 v[a + 44 >> 2] = 0;
 v[a + 48 >> 2] = 8;
 v[31601] = 0;
 V(112, a | 0);
 c = v[31601];
 v[31601] = 0;
 if ((c | 0) != 1) {
  return a | 0;
 }
 c = M() | 0;
 sb(b);
 go(a);
 P(c | 0);
 p();
}

function $t(a) {
 var b = 0, c = 0, d = 0;
 b = eb - 16 | 0;
 eb = b;
 v[b + 12 >> 2] = 12;
 while (1) {
  v[b + 8 >> 2] = 32;
  if (y[Gb(b + 12 | 0, b + 8 | 0) >> 2] <= c >>> 0) {
   eb = b + 16 | 0;
   a = d & 4095;
  } else {
   c = c + 15 | 0;
   d = Co(a);
   continue;
  }
  break;
 }
 return a;
}

function Tl(a, b) {
 var c = 0, d = 0;
 c = eb - 16 | 0;
 eb = c;
 v[c + 12 >> 2] = b;
 d = b;
 b = th(-1);
 if (d >>> 0 <= b >>> 0) {
  a = $o(a);
  if (a >>> 0 < b >>> 1 >>> 0) {
   v[c + 8 >> 2] = a << 1;
   b = v[ad(c + 8 | 0, c + 12 | 0) >> 2];
  }
  eb = c + 16 | 0;
  return b;
 }
 dd();
 p();
}

function Pfa(a, b, c, d, e) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 var f = 0, g = 0;
 f = eb - 16 | 0;
 eb = f;
 v[f + 8 >> 2] = v[a + 8 >> 2];
 g = v[a + 4 >> 2];
 v[f >> 2] = v[a >> 2];
 v[f + 4 >> 2] = g;
 a = oP(f, b, c, d, 0, 0, 0, 0, e);
 eb = f + 16 | 0;
 return a | 0;
}

function GR(a) {
 var b = 0, c = 0, d = 0;
 b = eb - 16 | 0;
 eb = b;
 while (1) {
  v[b + 12 >> 2] = 7;
  v[b + 8 >> 2] = 32;
  if (y[Gb(b + 12 | 0, b + 8 | 0) >> 2] <= c >>> 0) {
   eb = b + 16 | 0;
   a = d & 127;
  } else {
   c = c + 15 | 0;
   d = Co(a);
   continue;
  }
  break;
 }
 return a;
}

function Au(a) {
 var b = 0;
 v[31601] = 0;
 a = Q(851, a | 0) | 0;
 b = v[31601];
 v[31601] = 0;
 a: {
  if ((b | 0) == 1) {
   X(S(0) | 0) | 0;
   v[31601] = 0;
   W(26);
   b = v[31601];
   v[31601] = 0;
   a = 0;
   if ((b | 0) == 1) {
    break a;
   }
  }
  return a;
 }
 S(0) | 0;
 Rb();
 p();
}

function yD(a, b, c) {
 var d = 0, e = 0;
 d = eb - 16 | 0;
 eb = d;
 a = Cr(d + 4 | 0, a, b);
 b = v[a + 4 >> 2];
 e = v[a + 8 >> 2];
 while (1) {
  if ((b | 0) == (e | 0)) {
   hc(a);
   eb = d + 16 | 0;
  } else {
   tD(b, c);
   b = b + 6 | 0;
   v[a + 4 >> 2] = b;
   continue;
  }
  break;
 }
}

function Xr(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0;
 c = eb - 16 | 0;
 eb = c;
 if ((b | 0) < 0) {
  dd();
  p();
 }
 KF(c + 8 | 0, (b - 1 >>> 5 | 0) + 1 | 0);
 b = v[c + 8 >> 2];
 v[a + 4 >> 2] = 0;
 v[a >> 2] = b;
 d = zb(a), e = v[c + 12 >> 2], v[d >> 2] = e;
 eb = c + 16 | 0;
}

function Uw(a) {
 var b = 0;
 b = v[a + 72 >> 2];
 v[a + 72 >> 2] = b - 1 | b;
 b = v[a >> 2];
 if (b & 8) {
  v[a >> 2] = b | 32;
  return -1;
 }
 v[a + 4 >> 2] = 0;
 v[a + 8 >> 2] = 0;
 b = v[a + 44 >> 2];
 v[a + 28 >> 2] = b;
 v[a + 20 >> 2] = b;
 v[a + 16 >> 2] = b + v[a + 48 >> 2];
 return 0;
}

function N5(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 a: {
  while (1) {
   if ((c | 0) == (d | 0)) {
    break a;
   }
   a = v[c >> 2];
   if (!(a >>> 0 > 127 | !(v[(a << 2) + 95312 >> 2] & b))) {
    c = c + 4 | 0;
    continue;
   }
   break;
  }
  d = c;
 }
 return d | 0;
}

function bN(a) {
 var b = 0, c = 0, d = 0;
 b = v[a >> 2];
 if (v[b >> 2]) {
  d = v[b >> 2];
  c = v[b + 4 >> 2];
  while (1) {
   if ((c | 0) != (d | 0)) {
    c = c - 16 | 0;
    Nj(c);
    continue;
   }
   break;
  }
  v[b + 4 >> 2] = d;
  a = v[a >> 2];
  b = v[a >> 2];
  lv(a);
  Bb(b);
 }
}

function aY(a) {
 var b = 0, c = 0, d = 0;
 b = v[a >> 2];
 if (v[b >> 2]) {
  d = v[b >> 2];
  c = v[b + 4 >> 2];
  while (1) {
   if ((c | 0) != (d | 0)) {
    c = c - 24 | 0;
    tb(c);
    continue;
   }
   break;
  }
  v[b + 4 >> 2] = d;
  a = v[a >> 2];
  b = v[a >> 2];
  jt(a);
  Bb(b);
 }
}

function PA(a, b) {
 var c = 0;
 a = iW(a, b);
 t[a + 12 | 0] = w[b + 12 | 0];
 c = w[b + 13 | 0] | w[b + 14 | 0] << 8 | (w[b + 15 | 0] << 16 | w[b + 16 | 0] << 24);
 t[a + 13 | 0] = c;
 t[a + 14 | 0] = c >>> 8;
 t[a + 15 | 0] = c >>> 16;
 t[a + 16 | 0] = c >>> 24;
 t[a + 17 | 0] = w[b + 17 | 0];
}

function LH(a) {
 var b = 0, c = 0, d = 0;
 b = v[a >> 2];
 if (v[b >> 2]) {
  d = v[b >> 2];
  c = v[b + 4 >> 2];
  while (1) {
   if ((c | 0) != (d | 0)) {
    c = c - 12 | 0;
    Db(c);
    continue;
   }
   break;
  }
  v[b + 4 >> 2] = d;
  a = v[a >> 2];
  b = v[a >> 2];
  al(a);
  Bb(b);
 }
}

function Fv(a) {
 var b = 0, c = 0, d = 0, e = 0;
 while (1) {
  a: {
   if ((b | 0) == 32) {
    e = c;
    break a;
   }
   d = w[a + b | 0];
   if ((d - 1 & 255) >>> 0 < 31 | ((c ^ 1) & 1 ? 0 : d)) {
    break a;
   }
   b = b + 1 | 0;
   c = !d | c;
   continue;
  }
  break;
 }
 return e & 1;
}

function Rra(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0;
 c = eb - 16 | 0;
 eb = c;
 d = Lb(v[a >> 2], v[a + 8 >> 2], 12);
 a: {
  if (!d) {
   t[c | 0] = 0;
   Rh(b, 12, c);
   break a;
  }
  zr(c + 8 | 0, b);
  rd(c, a, v[c + 8 >> 2], v[c + 12 >> 2]);
 }
 eb = c + 16 | 0;
 return d | 0;
}

function yg(a, b) {
 var c = 0, d = 0;
 c = eb - 16 | 0;
 eb = c;
 v[c + 8 >> 2] = v[b + 8 >> 2];
 d = v[b + 4 >> 2];
 v[c >> 2] = v[b >> 2];
 v[c + 4 >> 2] = d;
 b = v[c + 4 >> 2];
 v[a >> 2] = v[c >> 2];
 v[a + 4 >> 2] = b;
 v[a + 8 >> 2] = v[c + 8 >> 2];
 t[a + 12 | 0] = 0;
 eb = c + 16 | 0;
}

function o4(a, b, c, d, e) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 var f = 0;
 while (1) {
  if ((b | 0) != (c | 0)) {
   f = dy(v[b >> 2], v[a + 8 >> 2]);
   t[e | 0] = (f | 0) == -1 ? d : f;
   e = e + 1 | 0;
   b = b + 4 | 0;
   continue;
  }
  break;
 }
 return c | 0;
}

function SG(a) {
 var b = 0;
 a: {
  b: {
   if (a >>> 0 >= 18285141) {
    if (a >>> 0 > 18350591) {
     break b;
    }
    b = 1;
    if ((a | 0) != 18350080) {
     break a;
    }
   }
   return 0;
  }
  b = 0;
  if ((a | 0) == 18350592) {
   break a;
  }
  b = (a & 255) != 0;
 }
 return b;
}

function Jh(a, b, c) {
 a: {
  if (b >>> 0 <= c >>> 0) {
   a = cc(8);
   v[31601] = 0;
   b = Q(188, a | 0) | 0;
   c = v[31601];
   v[31601] = 0;
   if ((c | 0) != 1) {
    break a;
   }
   b = M() | 0;
   jc(a);
   P(b | 0);
   p();
  }
  return w[a + c | 0];
 }
 ca(b | 0, 24440, 162);
 p();
}

function sl(a) {
 a = a | 0;
 var b = 0;
 v[a >> 2] = 94548;
 v[31601] = 0;
 N(113, a | 0, 0);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  Zb(a + 28 | 0);
  Bb(v[a + 32 >> 2]);
  Bb(v[a + 36 >> 2]);
  Bb(v[a + 48 >> 2]);
  Bb(v[a + 60 >> 2]);
  return a | 0;
 }
 S(0) | 0;
 Rb();
 p();
}

function _1(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0;
 d = eb - 16 | 0;
 eb = d;
 v[d + 12 >> 2] = c;
 c = 0;
 a = hb[v[v[a >> 2] + 24 >> 2]](a) | 0;
 if (a >>> 0 > b >>> 0) {
  v[d + 8 >> 2] = a - b;
  c = v[Gb(d + 12 | 0, d + 8 | 0) >> 2];
 }
 eb = d + 16 | 0;
 return c | 0;
}

function Wna(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0;
 c = eb - 16 | 0;
 eb = c;
 d = Lb(v[a >> 2], v[a + 8 >> 2], 4);
 a: {
  if (!d) {
   t[c | 0] = 0;
   c$(b, 4, c);
   break a;
  }
  lh(c + 8 | 0, b);
  rd(c, a, v[c + 8 >> 2], v[c + 12 >> 2]);
 }
 eb = c + 16 | 0;
 return d | 0;
}

function ic(a, b, c, d, e) {
 var f = 0;
 f = eb - 32 | 0;
 eb = f;
 lf(f + 16 | 0, d, e);
 d = v[v[b >> 2] + 28 >> 2];
 e = v[f + 20 >> 2];
 v[f + 8 >> 2] = v[f + 16 >> 2];
 v[f + 12 >> 2] = e;
 hb[d | 0](f + 24 | 0, b, c, f + 8 | 0);
 lf(a, v[f + 24 >> 2], v[f + 28 >> 2]);
 eb = f + 32 | 0;
}

function Tk(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0;
 c = eb - 16 | 0;
 eb = c;
 if (th(-1) >>> 0 < b >>> 0) {
  dd();
  p();
 }
 pg(c + 8 | 0, b);
 b = v[c + 8 >> 2];
 v[a + 4 >> 2] = b;
 v[a >> 2] = b;
 d = zb(a), e = b + v[c + 12 >> 2] | 0, v[d >> 2] = e;
 eb = c + 16 | 0;
}

function BP(a, b, c, d, e) {
 a = a | 0;
 b = b | 0;
 c = +c;
 d = d | 0;
 e = e | 0;
 var f = 0, g = 0;
 f = eb - 16 | 0;
 eb = f;
 v[f + 8 >> 2] = v[a + 8 >> 2];
 g = v[a + 4 >> 2];
 v[f >> 2] = v[a >> 2];
 v[f + 4 >> 2] = g;
 c = AP(f, b, c, d, e, 0, 0, 0, 0);
 eb = f + 16 | 0;
 return +c;
}

function pD(a, b) {
 var c = 0, d = 0;
 c = eb - 16 | 0;
 eb = c;
 a = wh(c + 4 | 0, a, b);
 b = v[a + 4 >> 2];
 d = v[a + 8 >> 2];
 while (1) {
  if ((b | 0) == (d | 0)) {
   hc(a);
   eb = c + 16 | 0;
  } else {
   Bn(b);
   b = b + 4 | 0;
   v[a + 4 >> 2] = b;
   continue;
  }
  break;
 }
}

function Vq(a, b) {
 var c = 0, d = 0;
 c = eb - 16 | 0;
 eb = c;
 a = wh(c + 4 | 0, a, b);
 b = v[a + 4 >> 2];
 d = v[a + 8 >> 2];
 while (1) {
  if ((b | 0) == (d | 0)) {
   hc(a);
   eb = c + 16 | 0;
  } else {
   tV(b);
   b = b + 4 | 0;
   v[a + 4 >> 2] = b;
   continue;
  }
  break;
 }
}

function QE(a, b) {
 var c = 0, d = 0;
 c = eb - 16 | 0;
 eb = c;
 a = aj(c + 4 | 0, a, b);
 b = v[a + 4 >> 2];
 d = v[a + 8 >> 2];
 while (1) {
  if ((b | 0) == (d | 0)) {
   hc(a);
   eb = c + 16 | 0;
  } else {
   _w(b);
   b = b + 2 | 0;
   v[a + 4 >> 2] = b;
   continue;
  }
  break;
 }
}

function Lia(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0;
 d = eb - 16 | 0;
 eb = d;
 v[d + 12 >> 2] = b;
 while (1) {
  if (Hb(b, c)) {
   v[d + 8 >> 2] = v[b >> 2];
   yA(a, d + 8 | 0);
   b = v[Xe(d + 12 | 0) >> 2];
   continue;
  } else {
   eb = d + 16 | 0;
  }
  break;
 }
}

function KX(a, b) {
 var c = 0, d = 0;
 c = eb - 16 | 0;
 eb = c;
 a = Xo(c + 4 | 0, a, b);
 b = v[a + 4 >> 2];
 d = v[a + 8 >> 2];
 while (1) {
  if ((b | 0) == (d | 0)) {
   hc(a);
   eb = c + 16 | 0;
  } else {
   oX(b);
   b = b + 1 | 0;
   v[a + 4 >> 2] = b;
   continue;
  }
  break;
 }
}

function zE(a, b) {
 var c = 0, d = 0;
 c = eb - 16 | 0;
 eb = c;
 Jr(c + 8 | 0, b);
 b = v[c + 12 >> 2];
 ic(c, v[a >> 2], v[a + 8 >> 2], v[c + 8 >> 2], v[c + 12 >> 2]);
 d = v[c + 4 >> 2];
 if ((b | 0) == (d | 0)) {
  Ub(a, v[c + 12 >> 2]);
 }
 eb = c + 16 | 0;
 return (b | 0) == (d | 0);
}

function z0(a, b) {
 var c = 0, d = 0;
 c = eb - 16 | 0;
 eb = c;
 y0(c + 8 | 0, b);
 b = v[c + 12 >> 2];
 ic(c, v[a >> 2], v[a + 8 >> 2], v[c + 8 >> 2], v[c + 12 >> 2]);
 d = v[c + 4 >> 2];
 if ((b | 0) == (d | 0)) {
  Ub(a, v[c + 12 >> 2]);
 }
 eb = c + 16 | 0;
 return (b | 0) == (d | 0);
}

function u$(a, b) {
 var c = 0, d = 0;
 c = eb - 16 | 0;
 eb = c;
 fE(c + 8 | 0, b);
 b = v[c + 12 >> 2];
 ic(c, v[a >> 2], v[a + 8 >> 2], v[c + 8 >> 2], v[c + 12 >> 2]);
 d = v[c + 4 >> 2];
 if ((b | 0) == (d | 0)) {
  Ub(a, v[c + 12 >> 2]);
 }
 eb = c + 16 | 0;
 return (b | 0) == (d | 0);
}

function tX(a, b) {
 var c = 0, d = 0;
 c = eb - 16 | 0;
 eb = c;
 hD(c + 8 | 0, b);
 b = v[c + 12 >> 2];
 ic(c, v[a >> 2], v[a + 8 >> 2], v[c + 8 >> 2], v[c + 12 >> 2]);
 d = v[c + 4 >> 2];
 if ((b | 0) == (d | 0)) {
  Ub(a, v[c + 12 >> 2]);
 }
 eb = c + 16 | 0;
 return (b | 0) == (d | 0);
}

function lx(a, b) {
 var c = 0, d = 0;
 c = eb - 16 | 0;
 eb = c;
 jx(c + 8 | 0, b);
 b = v[c + 12 >> 2];
 ic(c, v[a >> 2], v[a + 8 >> 2], v[c + 8 >> 2], v[c + 12 >> 2]);
 d = v[c + 4 >> 2];
 if ((b | 0) == (d | 0)) {
  Ub(a, v[c + 12 >> 2]);
 }
 eb = c + 16 | 0;
 return (b | 0) == (d | 0);
}

function i$(a, b) {
 var c = 0, d = 0;
 c = eb - 16 | 0;
 eb = c;
 lw(c + 8 | 0, b);
 b = v[c + 12 >> 2];
 ic(c, v[a >> 2], v[a + 8 >> 2], v[c + 8 >> 2], v[c + 12 >> 2]);
 d = v[c + 4 >> 2];
 if ((b | 0) == (d | 0)) {
  Ub(a, v[c + 12 >> 2]);
 }
 eb = c + 16 | 0;
 return (b | 0) == (d | 0);
}

function gG(a, b) {
 var c = 0, d = 0;
 c = eb - 16 | 0;
 eb = c;
 HG(c + 8 | 0, b);
 b = v[c + 12 >> 2];
 ic(c, v[a >> 2], v[a + 8 >> 2], v[c + 8 >> 2], v[c + 12 >> 2]);
 d = v[c + 4 >> 2];
 if ((b | 0) == (d | 0)) {
  Ub(a, v[c + 12 >> 2]);
 }
 eb = c + 16 | 0;
 return (b | 0) == (d | 0);
}

function dh(a, b) {
 var c = 0, d = 0;
 c = eb - 16 | 0;
 eb = c;
 Vr(c + 8 | 0, b);
 b = v[c + 12 >> 2];
 ic(c, v[a >> 2], v[a + 8 >> 2], v[c + 8 >> 2], v[c + 12 >> 2]);
 d = v[c + 4 >> 2];
 if ((b | 0) == (d | 0)) {
  Ub(a, v[c + 12 >> 2]);
 }
 eb = c + 16 | 0;
 return (b | 0) == (d | 0);
}

function d$(a, b) {
 var c = 0, d = 0;
 c = eb - 16 | 0;
 eb = c;
 mw(c + 8 | 0, b);
 b = v[c + 12 >> 2];
 ic(c, v[a >> 2], v[a + 8 >> 2], v[c + 8 >> 2], v[c + 12 >> 2]);
 d = v[c + 4 >> 2];
 if ((b | 0) == (d | 0)) {
  Ub(a, v[c + 12 >> 2]);
 }
 eb = c + 16 | 0;
 return (b | 0) == (d | 0);
}

function b$(a, b) {
 var c = 0, d = 0;
 c = eb - 16 | 0;
 eb = c;
 zr(c + 8 | 0, b);
 b = v[c + 12 >> 2];
 ic(c, v[a >> 2], v[a + 8 >> 2], v[c + 8 >> 2], v[c + 12 >> 2]);
 d = v[c + 4 >> 2];
 if ((b | 0) == (d | 0)) {
  Ub(a, v[c + 12 >> 2]);
 }
 eb = c + 16 | 0;
 return (b | 0) == (d | 0);
}

function aZ(a, b) {
 var c = 0, d = 0;
 c = eb - 16 | 0;
 eb = c;
 $Y(c + 8 | 0, b);
 b = v[c + 12 >> 2];
 ic(c, v[a >> 2], v[a + 8 >> 2], v[c + 8 >> 2], v[c + 12 >> 2]);
 d = v[c + 4 >> 2];
 if ((b | 0) == (d | 0)) {
  Ub(a, v[c + 12 >> 2]);
 }
 eb = c + 16 | 0;
 return (b | 0) == (d | 0);
}

function _t(a) {
 var b = 0, c = 0, d = 0;
 c = 1;
 while (1) {
  if (c) {
   c = 0;
   b = v[a + 4 >> 2];
   d = ((b << 2) + (Sw(v[a >> 2], 1) ^ 270549120) | 0) + 2019860093 | 0;
   v[a >> 2] = d;
   b = b + B(Sw(d, 16), 5) | 0;
   v[a + 4 >> 2] = b;
   continue;
  }
  break;
 }
 return b;
}

function _F(a, b) {
 var c = 0, d = 0;
 c = eb - 16 | 0;
 eb = c;
 bs(c + 8 | 0, b);
 b = v[c + 12 >> 2];
 ic(c, v[a >> 2], v[a + 8 >> 2], v[c + 8 >> 2], v[c + 12 >> 2]);
 d = v[c + 4 >> 2];
 if ((b | 0) == (d | 0)) {
  Ub(a, v[c + 12 >> 2]);
 }
 eb = c + 16 | 0;
 return (b | 0) == (d | 0);
}

function Sf(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0;
 c = eb + -64 | 0;
 eb = c;
 d = sA(c + 12 | 0, a);
 v[31601] = 0;
 R(199, a | 0, b | 0, d | 0);
 a = v[31601];
 v[31601] = 0;
 if ((a | 0) != 1) {
  uk(d);
  eb = c - -64 | 0;
  return;
 }
 a = M() | 0;
 uk(d);
 P(a | 0);
 p();
}

function SX(a, b) {
 var c = 0, d = 0;
 c = eb - 16 | 0;
 eb = c;
 Hv(c + 8 | 0, b);
 b = v[c + 12 >> 2];
 ic(c, v[a >> 2], v[a + 8 >> 2], v[c + 8 >> 2], v[c + 12 >> 2]);
 d = v[c + 4 >> 2];
 if ((b | 0) == (d | 0)) {
  Ub(a, v[c + 12 >> 2]);
 }
 eb = c + 16 | 0;
 return (b | 0) == (d | 0);
}

function SC(a, b) {
 var c = 0, d = 0;
 c = eb - 16 | 0;
 eb = c;
 XC(c + 8 | 0, b);
 b = v[c + 12 >> 2];
 ic(c, v[a >> 2], v[a + 8 >> 2], v[c + 8 >> 2], v[c + 12 >> 2]);
 d = v[c + 4 >> 2];
 if ((b | 0) == (d | 0)) {
  Ub(a, v[c + 12 >> 2]);
 }
 eb = c + 16 | 0;
 return (b | 0) == (d | 0);
}

function OU(a) {
 a = a | 0;
 var b = 0, c = 0;
 b = eb - 32 | 0;
 eb = b;
 t[a + 16 | 0] = 0;
 c = cC(b, v[a + 12 >> 2]);
 v[31601] = 0;
 N(782, a | 0, c | 0);
 a = v[31601];
 v[31601] = 0;
 if ((a | 0) != 1) {
  zk(c);
  eb = b + 32 | 0;
  return;
 }
 a = M() | 0;
 zk(c);
 P(a | 0);
 p();
}

function Mn(a, b) {
 var c = 0, d = 0;
 c = eb - 16 | 0;
 eb = c;
 lh(c + 8 | 0, b);
 b = v[c + 12 >> 2];
 ic(c, v[a >> 2], v[a + 8 >> 2], v[c + 8 >> 2], v[c + 12 >> 2]);
 d = v[c + 4 >> 2];
 if ((b | 0) == (d | 0)) {
  Ub(a, v[c + 12 >> 2]);
 }
 eb = c + 16 | 0;
 return (b | 0) == (d | 0);
}

function Dp(a, b) {
 var c = 0, d = 0;
 c = eb - 16 | 0;
 eb = c;
 Cp(c + 8 | 0, b);
 b = v[c + 12 >> 2];
 ic(c, v[a >> 2], v[a + 8 >> 2], v[c + 8 >> 2], v[c + 12 >> 2]);
 d = v[c + 4 >> 2];
 if ((b | 0) == (d | 0)) {
  Ub(a, v[c + 12 >> 2]);
 }
 eb = c + 16 | 0;
 return (b | 0) == (d | 0);
}

function AE(a, b) {
 var c = 0, d = 0;
 c = eb - 16 | 0;
 eb = c;
 Zj(c + 8 | 0, b);
 b = v[c + 12 >> 2];
 ic(c, v[a >> 2], v[a + 8 >> 2], v[c + 8 >> 2], v[c + 12 >> 2]);
 d = v[c + 4 >> 2];
 if ((b | 0) == (d | 0)) {
  Ub(a, v[c + 12 >> 2]);
 }
 eb = c + 16 | 0;
 return (b | 0) == (d | 0);
}

function jaa(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0;
 d = eb - 16 | 0;
 eb = d;
 v[d + 12 >> 2] = c;
 qz(a, b, c);
 c = 0;
 a = v[a + 16 >> 2];
 if (a >>> 0 > b >>> 0) {
  v[d + 8 >> 2] = a - b;
  c = v[Gb(d + 8 | 0, d + 12 | 0) >> 2];
 }
 eb = d + 16 | 0;
 return c | 0;
}

function ZM() {
 var a = 0, b = 0, c = 0, d = 0;
 a = eb - 16 | 0;
 eb = a;
 b = Dc(1298480);
 v[31601] = 0;
 c = Q(1126, b | 0) | 0;
 d = v[31601];
 v[31601] = 0;
 if ((d | 0) != 1) {
  b = xf(a + 12 | 0, c);
  eb = a + 16 | 0;
  return v[b >> 2];
 }
 a = M() | 0;
 Bb(b);
 P(a | 0);
 p();
}

function Jx(a, b, c) {
 var d = 0;
 d = eb - 16 | 0;
 eb = d;
 ac(d + 8 | 0, b, c);
 b = v[d + 12 >> 2];
 ic(d, v[a >> 2], v[a + 8 >> 2], v[d + 8 >> 2], v[d + 12 >> 2]);
 c = v[d + 4 >> 2];
 if ((b | 0) == (c | 0)) {
  Ub(a, v[d + 12 >> 2]);
 }
 eb = d + 16 | 0;
 return (b | 0) == (c | 0);
}

function FP(a) {
 var b = 0, c = 0;
 if (!a) {
  return 1;
 }
 if ((a | 0) >= -99999) {
  b = +(a | 0) * 3.321928094887362 / 2e3;
  c = b + .5;
  a: {
   if (D(c) < 2147483648) {
    a = ~~c;
    break a;
   }
   a = -2147483648;
  }
  b = zi(b - +(a | 0));
 } else {
  b = 0;
 }
 return b;
}

function $2(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0;
 e = eb - 16 | 0;
 eb = e;
 a = v[a + 4 >> 2];
 f = v[b + 4 >> 2];
 b = v[b >> 2];
 v[e >> 2] = b;
 v[e + 4 >> 2] = f;
 v[e + 8 >> 2] = b;
 v[e + 12 >> 2] = f;
 Pz(a, e, c, d, 1);
 eb = e + 16 | 0;
}

function $1(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0;
 a = hb[v[v[a >> 2] + 24 >> 2]](a) | 0;
 a: {
  if (!c) {
   d = 1;
   if ((a | 0) == (b | 0)) {
    break a;
   }
  }
  d = 0;
  if (a >>> 0 <= b >>> 0) {
   break a;
  }
  d = a - b >>> 0 >= c >>> 0;
 }
 return d | 0;
}

function hp(a) {
 var b = 0, c = 0;
 b = v[31358];
 c = a + 7 & -8;
 a = b + c | 0;
 a: {
  if (!(a >>> 0 <= b >>> 0 ? c : 0)) {
   if (a >>> 0 <= ib() << 16 >>> 0) {
    break a;
   }
   if (db(a | 0) | 0) {
    break a;
   }
  }
  v[31476] = 48;
  return -1;
 }
 v[31358] = a;
 return b;
}

function Hz(a, b, c, d, e, f, g, h, i) {
 var j = 0;
 j = eb - 16 | 0;
 eb = j;
 Tg(j, b, c, d, e, f, g, h, i ^ -2147483648);
 d = v[j >> 2];
 c = v[j + 4 >> 2];
 b = v[j + 12 >> 2];
 v[a + 8 >> 2] = v[j + 8 >> 2];
 v[a + 12 >> 2] = b;
 v[a >> 2] = d;
 v[a + 4 >> 2] = c;
 eb = j + 16 | 0;
}

function y7(a, b, c, d, e, f) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 f = f | 0;
 var g = 0, h = 0;
 g = a;
 h = b;
 a = hb[v[v[a + 8 >> 2] + 20 >> 2]](a + 8 | 0) | 0;
 b = Jb(a);
 return pk(g, h, c, d, e, f, b, b + (Cb(v[a + 4 >> 2], w[a + 11 | 0]) << 2) | 0) | 0;
}

function ria(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = C(c);
 var d = 0, e = 0, f = C(0);
 d = eb - 16 | 0;
 eb = d;
 e = d, f = C(C(hb[v[v[a >> 2] + 48 >> 2]](a, b)) + c), z[e + 12 >> 2] = f;
 zT(d + 12 | 0, C(0), C(1));
 hb[v[v[a >> 2] + 44 >> 2]](a, b, z[d + 12 >> 2]);
 eb = d + 16 | 0;
}

function Ek(a, b) {
 var c = 0, d = 0;
 c = eb - 32 | 0;
 eb = c;
 v[c + 28 >> 2] = 0;
 cy(c + 8 | 0, c + 28 | 0);
 d = c + 20 | 0;
 Lm(d, a, v[c + 8 >> 2], v[c + 12 >> 2]);
 a = v[c + 24 >> 2];
 Jm(d, v[c + 28 >> 2]);
 v[b >> 2] = v[c + 20 >> 2];
 eb = c + 32 | 0;
 return (a | 0) == 4;
}

function kaa(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0;
 qz(a, b, c);
 a = v[a + 16 >> 2];
 a: {
  if (!c) {
   d = 1;
   if ((a | 0) == (b | 0)) {
    break a;
   }
  }
  d = 0;
  if (a >>> 0 <= b >>> 0) {
   break a;
  }
  d = a - b >>> 0 >= c >>> 0;
 }
 return d | 0;
}

function tD(a, b) {
 var c = 0;
 c = w[b | 0] | w[b + 1 | 0] << 8 | (w[b + 2 | 0] << 16 | w[b + 3 | 0] << 24);
 t[a | 0] = c;
 t[a + 1 | 0] = c >>> 8;
 t[a + 2 | 0] = c >>> 16;
 t[a + 3 | 0] = c >>> 24;
 b = w[b + 4 | 0] | w[b + 5 | 0] << 8;
 t[a + 4 | 0] = b;
 t[a + 5 | 0] = b >>> 8;
}

function rga(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = C(c);
 var d = 0, e = 0, f = C(0);
 if (b >>> 0 <= 12) {
  c = Od(c, C(0));
  d = a + 4208 | 0;
  if ((b | 0) == 12) {
   c = C(ki(C(c * C(3))) / C(3));
   b = 12;
  }
  e = xb(d, b), f = c, z[e >> 2] = f;
  t[a + 5046 | 0] = 1;
 }
}

function Wra(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0;
 d = eb - 16 | 0;
 eb = d;
 YY(b, c);
 c = Lb(v[a >> 2], v[a + 8 >> 2], c << 2);
 if (c) {
  XY(d + 8 | 0, v[b >> 2], v[b + 4 >> 2]);
  rd(d, a, v[d + 8 >> 2], v[d + 12 >> 2]);
 }
 eb = d + 16 | 0;
 return c | 0;
}

function TT(a, b, c, d) {
 var e = 0, f = 0;
 e = eb - 16 | 0;
 eb = e;
 while (1) {
  if (c) {
   f = Ml(x[c + 16 >> 1], v[c + 20 >> 2], a, b);
   d = f ? d : c;
   c = v[(f ? 4 : 0) + c >> 2];
   continue;
  }
  break;
 }
 a = ub(e + 12 | 0, d);
 eb = e + 16 | 0;
 return v[a >> 2];
}

function Ira(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0;
 c = eb - 32 | 0;
 eb = c;
 v[c + 24 >> 2] = 0;
 v[c + 28 >> 2] = 0;
 v[c + 16 >> 2] = 0;
 v[c + 20 >> 2] = 0;
 v[c + 8 >> 2] = 0;
 v[c + 12 >> 2] = 0;
 v[c >> 2] = 0;
 v[c + 4 >> 2] = 0;
 xZ(b, c);
 wZ(a, c);
 eb = c + 32 | 0;
}

function Hia(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0, g = 0;
 e = eb - 16 | 0;
 eb = e;
 f = v[c >> 2];
 if (f >>> 0 < Sc(a, b) >>> 0) {
  a = pl(e + 4 | 0, wb(a, f), x[c + 20 >> 1]);
  g = Jy(d, a);
  Db(a);
 }
 eb = e + 16 | 0;
 return g | 0;
}

function j2(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0;
 d = eb - 16 | 0;
 eb = d;
 sG(b, c);
 c = Lb(v[a >> 2], v[a + 8 >> 2], c << 3);
 if (c) {
  rG(d + 8 | 0, v[b >> 2], v[b + 4 >> 2]);
  rd(d, a, v[d + 8 >> 2], v[d + 12 >> 2]);
 }
 eb = d + 16 | 0;
 return c | 0;
}

function a3(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0;
 c = eb - 16 | 0;
 eb = c;
 a = v[a + 4 >> 2];
 d = v[b >> 2];
 b = v[b + 4 >> 2];
 v[c >> 2] = d;
 v[c + 4 >> 2] = b;
 v[c + 8 >> 2] = d;
 v[c + 12 >> 2] = b;
 a = hP(a, c, 1);
 eb = c + 16 | 0;
 fb = gb;
 return a | 0;
}

function S6(a) {
 a = a | 0;
 var b = 0, c = 0, d = 0;
 b = eb - 16 | 0;
 eb = b;
 c = qh(b + 12 | 0, v[a + 8 >> 2]);
 d = GK(0, 0, 4);
 ph(c);
 eb = b + 16 | 0;
 if (d) {
  a = -1;
 } else {
  a = v[a + 8 >> 2];
  if (!a) {
   return 1;
  }
  a = (FJ(a) | 0) == 1;
 }
 return a | 0;
}

function lo(a, b) {
 var c = 0, d = 0, e = 0;
 c = a * a;
 d = c * a;
 e = c * c;
 a = d * e * (e * (c * .009465647849436732 + .002974357433599673) + (c * .024528318116654728 + .05338123784456704)) + (d * (c * .13339200271297674 + .3333313950307914) + a);
 return C(b ? -1 / a : a);
}

function dS(a) {
 var b = 0, c = 0, d = 0;
 b = v[a + 112 >> 2];
 if ((b | 0) >= 11) {
  b = 378;
  while (1) {
   if (b | c) {
    cS(a);
    d = b;
    b = b - 1 | 0;
    c = c - !d | 0;
    continue;
   }
   break;
  }
  b = 0;
 }
 v[a + 112 >> 2] = b + 1;
 a = cS(a);
 return a;
}

function Zna(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0;
 d = eb - 16 | 0;
 eb = d;
 hW(b, c);
 if (Lb(v[a >> 2], v[a + 8 >> 2], c << 8)) {
  c = v[b >> 2];
  ac(d + 8 | 0, c, Qh(c, v[b + 4 >> 2]) << 8);
  rd(d, a, v[d + 8 >> 2], v[d + 12 >> 2]);
 }
 eb = d + 16 | 0;
}

function MM(a, b) {
 var c = 0, d = 0;
 c = eb - 16 | 0;
 eb = c;
 a = Xo(c + 4 | 0, a, b);
 b = v[a + 4 >> 2];
 d = v[a + 8 >> 2];
 while (1) {
  if ((b | 0) == (d | 0)) {
   hc(a);
   eb = c + 16 | 0;
  } else {
   b = b + 1 | 0;
   v[a + 4 >> 2] = b;
   continue;
  }
  break;
 }
}

function E7(a, b, c, d, e, f) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 f = f | 0;
 var g = 0, h = 0;
 g = a;
 h = b;
 a = hb[v[v[a + 8 >> 2] + 20 >> 2]](a + 8 | 0) | 0;
 b = Jb(a);
 return qk(g, h, c, d, e, f, b, Cb(v[a + 4 >> 2], w[a + 11 | 0]) + b | 0) | 0;
}

function uV(a, b, c, d) {
 a = Yb(a, b, c);
 b = v[a + 4 >> 2];
 a: {
  if ((d | 0) >= 0) {
   b = b + d | 0;
   c = v[a >> 2] + (b >>> 3 & 536870908) | 0;
   break a;
  }
  b = b + d | 0;
  c = v[a >> 2] + ((b - 31 | 0) / 32 << 2) | 0;
 }
 v[a >> 2] = c;
 v[a + 4 >> 2] = b & 31;
}

function hA(a, b) {
 var c = 0, d = 0;
 d = eb - 32 | 0;
 eb = d;
 c = zb(a);
 c = Yf(d + 12 | 0, Kf(a, nc(v[a >> 2], v[a + 4 >> 2]) + 1 | 0), nc(v[a >> 2], v[a + 4 >> 2]), c);
 vq(v[c + 8 >> 2], v[b >> 2]);
 v[c + 8 >> 2] = v[c + 8 >> 2] + 4;
 Rm(a, c);
 Xf(c);
 eb = d + 32 | 0;
}

function WH(a, b, c) {
 var d = 0;
 a: {
  if (!a) {
   a = cc(8);
   v[31601] = 0;
   c = Q(c | 0, a | 0) | 0;
   d = v[31601];
   v[31601] = 0;
   if ((d | 0) != 1) {
    break a;
   }
   b = M() | 0;
   jc(a);
   P(b | 0);
   p();
  }
  return;
 }
 ca(c | 0, b | 0, 999);
 p();
}

function bM(a, b) {
 var c = 0, d = 0;
 d = eb - 32 | 0;
 eb = d;
 c = zb(a);
 c = on(d + 12 | 0, Tl(a, Sc(v[a >> 2], v[a + 4 >> 2]) + 1 | 0), Sc(v[a >> 2], v[a + 4 >> 2]), c);
 po(v[c + 8 >> 2], w[b | 0]);
 v[c + 8 >> 2] = v[c + 8 >> 2] + 1;
 cr(a, c);
 nn(c);
 eb = d + 32 | 0;
}

function rF(a, b, c) {
 var d = 0;
 d = eb - 16 | 0;
 eb = d;
 a = Bp(d + 4 | 0, a + 8 | 0, b);
 b = v[a >> 2];
 while (1) {
  if ((b | 0) != v[a + 4 >> 2]) {
   km(b, x[c >> 1]);
   b = v[a >> 2] + 2 | 0;
   v[a >> 2] = b;
   continue;
  }
  break;
 }
 ie(a);
 eb = d + 16 | 0;
}

function lM(a, b) {
 var c = 0, d = 0;
 c = Sc(v[a + 4 >> 2], v[a + 8 >> 2]);
 b = v[a + 16 >> 2] + b | 0;
 if (c >>> 0 < b >>> 0) {
  d = a + 4 | 0;
  a: {
   if (c) {
    a = ji(c);
    if (b >>> 0 <= a >>> 0) {
     break a;
    }
   }
   a = mM(b, 65536);
  }
  Qj(d, a);
 }
}

function gca(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0;
 c = eb - 16 | 0;
 eb = c;
 a = v[a + 4 >> 2];
 d = v[b + 4 >> 2];
 b = v[b >> 2];
 v[c >> 2] = b;
 v[c + 4 >> 2] = d;
 v[c + 8 >> 2] = b;
 v[c + 12 >> 2] = d;
 e = iP(a, c, 1);
 eb = c + 16 | 0;
 return +e;
}

function cZ(a, b, c) {
 var d = 0;
 d = eb - 16 | 0;
 eb = d;
 a = CC(d + 4 | 0, a + 8 | 0, b);
 b = v[a >> 2];
 while (1) {
  if ((b | 0) != v[a + 4 >> 2]) {
   po(b, w[c | 0]);
   b = v[a >> 2] + 1 | 0;
   v[a >> 2] = b;
   continue;
  }
  break;
 }
 ie(a);
 eb = d + 16 | 0;
}

function Zz(a) {
 var b = 0, c = 0, d = 0;
 A[a + 4272 >> 3] = A[a + 4280 >> 3];
 c = a;
 d = a + 4296 | 0;
 a = 0;
 while (1) {
  if (a >>> 0 < 32) {
   a = a + 15 | 0;
   b = Co(d) | b << 15;
   continue;
  }
  break;
 }
 A[c + 4280 >> 3] = +(b | 0) * -4.656612873077393e-10;
}

function vd(a, b) {
 var c = 0, d = 0, e = 0;
 a: {
  c = QC(b);
  d = sn(a);
  if (c >>> 0 <= d >>> 0) {
   b = YC(Jb(a), b, c);
   kg(a, c);
   xd((c << 2) + b | 0, 0);
   break a;
  }
  e = a;
  a = Cb(v[a + 4 >> 2], w[a + 11 | 0]);
  nI(e, d, c - d | 0, a, 0, a, c, b);
 }
}

function Px(a, b, c, d, e) {
 var f = 0;
 a: {
  f = Au(4332);
  if (f) {
   v[31601] = 0;
   ga(e | 0, f | 0, a | 0, b | 0, c | 0, d | 0) | 0;
   a = v[31601];
   v[31601] = 0;
   if ((a | 0) == 1) {
    break a;
   }
  }
  return f;
 }
 a = M() | 0;
 Bb(f);
 P(a | 0);
 p();
}

function xsa(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0;
 d = eb - 16 | 0;
 eb = d;
 a: {
  if (a) {
   hb[v[v[a >> 2] + 8 >> 2]](a, b, c);
   break a;
  }
  if ((b | 0) >= 6) {
   break a;
  }
  bS(d, 9153, 10891, 171, 42);
  LG(d, b, c);
 }
 eb = d + 16 | 0;
}

function ZO(a, b) {
 var c = C(0), d = C(0);
 if (!((b | 0) < 0 | x[a + 480188 >> 1] <= b >>> 0)) {
  a = B(b, 872) + a | 0;
  c = C(C(w[a + 1075834 | 0]) * C(.0078125));
  d = C(c * c);
  c = C(C(w[a + 1075835 | 0]) * C(.0078125));
  c = C(K(C(d + C(c * c))));
 }
 return c;
}

function N1(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0;
 d = eb - 16 | 0;
 eb = d;
 v[d + 12 >> 2] = c;
 c = 0;
 a = v[a + 16 >> 2];
 if (a >>> 0 > b >>> 0) {
  v[d + 8 >> 2] = a - b;
  c = v[Gb(d + 12 | 0, d + 8 | 0) >> 2];
 }
 eb = d + 16 | 0;
 return c | 0;
}

function Iu(a, b) {
 var c = 0;
 a = vS(a);
 v[a >> 2] = v[b >> 2];
 v[a + 4 >> 2] = v[b + 4 >> 2];
 v[a + 8 >> 2] = v[b + 8 >> 2];
 v[a + 12 >> 2] = v[b + 12 >> 2];
 v[a + 16 >> 2] = v[b + 16 >> 2];
 c = v[b + 28 >> 2];
 v[a + 24 >> 2] = v[b + 24 >> 2];
 v[a + 28 >> 2] = c;
}

function Im(a, b) {
 v[a + 28 >> 2] = 0;
 u[a + 24 >> 1] = 65535;
 v[a + 16 >> 2] = 0;
 v[a + 20 >> 2] = 0;
 v[a + 4 >> 2] = 0;
 v[a + 8 >> 2] = 0;
 t[a | 0] = 0;
 v[a + 32 >> 2] = 11;
 v[a + 36 >> 2] = b;
 Mb(a + 40 | 0);
 Mb(a + 52 | 0);
 Qb(a - -64 | 0, 0, 48);
 return a;
}

function a2(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0;
 d = eb - 16 | 0;
 eb = d;
 v[d + 12 >> 2] = c;
 c = 0;
 a = v[a + 8 >> 2];
 if (a >>> 0 > b >>> 0) {
  v[d + 8 >> 2] = a - b;
  c = v[Gb(d + 12 | 0, d + 8 | 0) >> 2];
 }
 eb = d + 16 | 0;
 return c | 0;
}

function Hca(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0;
 c = eb - 16 | 0;
 eb = c;
 a = v[a + 4 >> 2];
 d = v[b + 4 >> 2];
 b = v[b >> 2];
 v[c >> 2] = b;
 v[c + 4 >> 2] = d;
 v[c + 8 >> 2] = b;
 v[c + 12 >> 2] = d;
 a = jP(a, c, 1);
 eb = c + 16 | 0;
 return a | 0;
}

function yq(a, b, c, d) {
 var e = 0, f = 0;
 e = eb - 16 | 0;
 eb = e;
 d = wh(e + 4 | 0, a, d);
 f = v[d + 4 >> 2];
 a = eb - 16 | 0;
 eb = a;
 ed(a + 8 | 0, b, c);
 b = uA(v[a + 8 >> 2], v[a + 12 >> 2], f);
 eb = a + 16 | 0;
 v[d + 4 >> 2] = b;
 hc(d);
 eb = e + 16 | 0;
}

function xn(a, b, c, d) {
 var e = 0, f = 0;
 e = eb - 16 | 0;
 eb = e;
 d = Xo(e + 4 | 0, a, d);
 f = v[d + 4 >> 2];
 a = eb - 16 | 0;
 eb = a;
 ed(a + 8 | 0, b, c);
 b = O_(v[a + 8 >> 2], v[a + 12 >> 2], f);
 eb = a + 16 | 0;
 v[d + 4 >> 2] = b;
 hc(d);
 eb = e + 16 | 0;
}

function tA(a, b, c, d) {
 var e = 0, f = 0;
 e = eb - 16 | 0;
 eb = e;
 d = Cr(e + 4 | 0, a, d);
 f = v[d + 4 >> 2];
 a = eb - 16 | 0;
 eb = a;
 ed(a + 8 | 0, b, c);
 b = hR(v[a + 8 >> 2], v[a + 12 >> 2], f);
 eb = a + 16 | 0;
 v[d + 4 >> 2] = b;
 hc(d);
 eb = e + 16 | 0;
}

function qY(a, b, c, d) {
 var e = 0, f = 0;
 e = eb - 16 | 0;
 eb = e;
 d = wh(e + 4 | 0, a, d);
 f = v[d + 4 >> 2];
 a = eb - 16 | 0;
 eb = a;
 ed(a + 8 | 0, b, c);
 b = pY(v[a + 8 >> 2], v[a + 12 >> 2], f);
 eb = a + 16 | 0;
 v[d + 4 >> 2] = b;
 hc(d);
 eb = e + 16 | 0;
}

function ida(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0;
 d = eb - 16 | 0;
 eb = d;
 a = v[a + 4 >> 2];
 e = v[b + 4 >> 2];
 b = v[b >> 2];
 v[d >> 2] = b;
 v[d + 4 >> 2] = e;
 v[d + 8 >> 2] = b;
 v[d + 12 >> 2] = e;
 Rz(a, d, c, 1);
 eb = d + 16 | 0;
}

function fi(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0;
 c = eb - 32 | 0;
 eb = c;
 t[c + 31 | 0] = 0;
 tj(c + 8 | 0, c + 31 | 0);
 Lm(c + 20 | 0, a, v[c + 8 >> 2], v[c + 12 >> 2]);
 a = v[c + 24 >> 2];
 t[b | 0] = w[c + 31 | 0];
 eb = c + 32 | 0;
 return (a | 0) == 1 | 0;
}

function ev(a, b, c, d) {
 var e = 0, f = 0;
 e = eb - 16 | 0;
 eb = e;
 d = aj(e + 4 | 0, a, d);
 f = v[d + 4 >> 2];
 a = eb - 16 | 0;
 eb = a;
 ed(a + 8 | 0, b, c);
 b = SU(v[a + 8 >> 2], v[a + 12 >> 2], f);
 eb = a + 16 | 0;
 v[d + 4 >> 2] = b;
 hc(d);
 eb = e + 16 | 0;
}

function WG(a, b) {
 var c = 0, d = 0;
 d = eb - 32 | 0;
 eb = d;
 c = zb(a);
 c = wm(d + 12 | 0, Qp(a, Td(v[a >> 2], v[a + 4 >> 2]) + 1 | 0), Td(v[a >> 2], v[a + 4 >> 2]), c);
 xs(v[c + 8 >> 2], b);
 v[c + 8 >> 2] = v[c + 8 >> 2] + 12;
 Bx(a, c);
 ws(c);
 eb = d + 32 | 0;
}

function Sh(a, b) {
 var c = 0;
 b = Vc(b);
 c = v[a + 8 >> 2];
 if (nc(c, v[a + 12 >> 2]) >>> 0 > b >>> 0) {
  a = v[xb(c, b) >> 2] != 0;
 } else {
  a = 0;
 }
 if (!a) {
  a = Cj(cc(4));
  v[a >> 2] = 124964;
  ca(a | 0, 125100, 1228);
  p();
 }
 return v[xb(c, b) >> 2];
}

function Kca(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0;
 d = eb - 16 | 0;
 eb = d;
 b = v[b + 4 >> 2];
 e = v[c + 4 >> 2];
 c = v[c >> 2];
 v[d >> 2] = c;
 v[d + 4 >> 2] = e;
 v[d + 8 >> 2] = c;
 v[d + 12 >> 2] = e;
 gP(a, b, d, 1);
 eb = d + 16 | 0;
}

function TL(a) {
 var b = 0, c = 0;
 a: {
  if (w[a | 0] != 255) {
   break a;
  }
  b = w[a + 1 | 0];
  if (!(b & 6) | (b & 240) != 240 & (b & 254) != 226) {
   break a;
  }
  a = w[a + 2 | 0];
  if ((a & 240) == 240) {
   break a;
  }
  c = (a & 12) != 12;
 }
 return c;
}

function Iz(a, b) {
 var c = 0, d = 0;
 if (b >>> 0 < 2147483632) {
  if (Kk(b)) {
   v[a >> 2] = 0;
   v[a + 4 >> 2] = 0;
   v[a + 8 >> 2] = 0;
   Me(a, b);
   return a;
  }
  c = Eh(b) + 1 | 0;
  d = Dc(c);
  of(a, c);
  xd(a, d);
  Ad(a, b);
  return a;
 }
 pf();
 p();
}

function yw(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0;
 d = eb - 16 | 0;
 eb = d;
 Qj(b, c);
 if (Lb(v[a >> 2], v[a + 8 >> 2], c)) {
  c = v[b >> 2];
  ac(d + 8 | 0, c, Sc(c, v[b + 4 >> 2]));
  rd(d, a, v[d + 8 >> 2], v[d + 12 >> 2]);
 }
 eb = d + 16 | 0;
}

function q4(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0, f = 0;
 while (1) {
  if ((b | 0) != (c | 0)) {
   e = d, f = JI(t[b | 0], v[a + 8 >> 2]), v[e >> 2] = f;
   d = d + 4 | 0;
   b = b + 1 | 0;
   continue;
  }
  break;
 }
 return c | 0;
}

function O1(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0;
 a = v[a + 16 >> 2];
 a: {
  if (!c) {
   d = 1;
   if ((a | 0) == (b | 0)) {
    break a;
   }
  }
  d = 0;
  if (a >>> 0 <= b >>> 0) {
   break a;
  }
  d = a - b >>> 0 >= c >>> 0;
 }
 return d | 0;
}

function Foa(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0;
 c = eb - 48 | 0;
 eb = c;
 d = -1;
 a: {
  if (!FW(a, c)) {
   break a;
  }
  d = 0;
  if (!EW(c)) {
   break a;
  }
  d = ve(a, b, DW(w[c + 31 | 0], w[c + 33 | 0]), gb);
 }
 eb = c + 48 | 0;
 return d | 0;
}

function AN(a, b, c) {
 var d = 0;
 d = eb - 32 | 0;
 eb = d;
 v[d + 28 >> 2] = c;
 v[d + 24 >> 2] = 0;
 v[d + 12 >> 2] = 4;
 c = d + 16 | 0;
 sz(c, a, d + 24 | 0, v[Gb(d + 28 | 0, d + 12 | 0) >> 2]);
 Jm(c, v[d + 24 >> 2]);
 v[b >> 2] = v[d + 16 >> 2];
 eb = d + 32 | 0;
}

function yA(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0;
 if (y[a + 4 >> 2] < y[zb(a) >> 2]) {
  c = eb - 16 | 0;
  eb = c;
  a = wh(c + 4 | 0, a, 1);
  vq(v[a + 4 >> 2], v[b >> 2]);
  v[a + 4 >> 2] = v[a + 4 >> 2] + 4;
  hc(a);
  eb = c + 16 | 0;
  return;
 }
 hA(a, b);
}

function qf(a, b, c) {
 var d = 0, e = 0, f = 0;
 d = eb - 16 | 0;
 eb = d;
 v[d + 8 >> 2] = c;
 v[d + 4 >> 2] = 31;
 e = d, f = U$(b, c), v[e + 12 >> 2] = f;
 c = b;
 b = tE(d + 4 | 0);
 wk(c, c + b | 0, a);
 e = wb(a, b), f = 0, t[e | 0] = f;
 X$(a);
 eb = d + 16 | 0;
}

function kr(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0;
 c = eb - 16 | 0;
 eb = c;
 d = Lb(v[a >> 2], v[a + 8 >> 2], 4);
 a: {
  if (!d) {
   rD(b);
   break a;
  }
  lh(c + 8 | 0, b);
  rd(c, a, v[c + 8 >> 2], v[c + 12 >> 2]);
 }
 eb = c + 16 | 0;
 return d | 0;
}

function eda(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = +c;
 var d = 0, e = 0;
 d = eb - 16 | 0;
 eb = d;
 a = v[a + 4 >> 2];
 e = v[b + 4 >> 2];
 b = v[b >> 2];
 v[d >> 2] = b;
 v[d + 4 >> 2] = e;
 v[d + 8 >> 2] = b;
 v[d + 12 >> 2] = e;
 Qz(a, d, c, 1);
 eb = d + 16 | 0;
}

function b2(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0;
 a = v[a + 8 >> 2];
 a: {
  if (!c) {
   d = 1;
   if ((a | 0) == (b | 0)) {
    break a;
   }
  }
  d = 0;
  if (a >>> 0 <= b >>> 0) {
   break a;
  }
  d = a - b >>> 0 >= c >>> 0;
 }
 return d | 0;
}

function Rl(a, b) {
 var c = 0, d = 0, e = 0;
 v[a >> 2] = 0;
 v[a + 4 >> 2] = 0;
 sc(a + 8 | 0);
 v[a >> 2] = v[b >> 2];
 v[a + 4 >> 2] = v[b + 4 >> 2];
 c = zb(b);
 d = zb(a), e = v[c >> 2], v[d >> 2] = e;
 v[c >> 2] = 0;
 v[b >> 2] = 0;
 v[b + 4 >> 2] = 0;
 return a;
}

function tE(a) {
 var b = 0, c = 0;
 a: {
  c = xb(a, 3);
  if ((c | 0) == (a | 0)) {
   break a;
  }
  b = a;
  while (1) {
   b = b + 4 | 0;
   if ((c | 0) == (b | 0)) {
    break a;
   }
   a = rE(v[b >> 2], v[a >> 2]) ? b : a;
   continue;
  }
 }
 return v[a >> 2];
}

function kV(a) {
 var b = 0, c = 0;
 a: {
  if (w[a | 0] != 255) {
   break a;
  }
  b = w[a + 1 | 0];
  if (!(b & 6) | (b & 224) != 224 | (b & 24) == 8) {
   break a;
  }
  a = w[a + 2 | 0];
  if ((a & 12) == 12) {
   break a;
  }
  c = (a & 240) != 240;
 }
 return c;
}

function JQ(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0;
 d = eb - 16 | 0;
 eb = d;
 while (1) {
  if ((b | 0) == (c | 0)) {
   eb = d + 16 | 0;
  } else {
   v[d + 12 >> 2] = v[b >> 2];
   yA(a, d + 12 | 0);
   b = b + 4 | 0;
   continue;
  }
  break;
 }
}

function I3(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0;
 d = eb - 16 | 0;
 eb = d;
 hb[v[v[a >> 2] + 12 >> 2]](d + 8 | 0, a, b);
 a = v[d + 8 >> 2];
 b = v[c >> 2];
 c = lc(v[d + 12 >> 2], v[c + 4 >> 2]);
 eb = d + 16 | 0;
 return (a | 0) == (b | 0) & c;
}

function Dc(a) {
 a = a | 0;
 var b = 0;
 a = a >>> 0 <= 1 ? 1 : a;
 a: {
  while (1) {
   b = Fd(a);
   if (b) {
    break a;
   }
   b = v[125423];
   if (b) {
    hb[b | 0]();
    continue;
   }
   break;
  }
  ca(Pm(cc(4)) | 0, 124508, 34);
  p();
 }
 return b | 0;
}

function xpa(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0;
 d = eb - 80 | 0;
 eb = d;
 e = d + 14 | 0;
 c = -1;
 a: {
  if (!D$(a, e)) {
   break a;
  }
  c = 0;
  if (!zX(e)) {
   break a;
  }
  c = ve(a, b, yX(e), gb);
 }
 eb = d + 80 | 0;
 return c | 0;
}

function mg(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0;
 c = eb - 32 | 0;
 eb = c;
 u[c + 30 >> 1] = 0;
 jk(c + 8 | 0, c + 30 | 0);
 d = c + 20 | 0;
 Lm(d, a, v[c + 8 >> 2], v[c + 12 >> 2]);
 _i(d, x[c + 30 >> 1]);
 u[b >> 1] = x[c + 20 >> 1];
 eb = c + 32 | 0;
}

function YX(a, b) {
 var c = 0, d = 0;
 c = eb - 16 | 0;
 eb = c;
 Hv(c + 8 | 0, b);
 b = v[c + 12 >> 2];
 pd(c, a, v[c + 8 >> 2], v[c + 12 >> 2]);
 d = v[c + 4 >> 2];
 if ((b | 0) == (d | 0)) {
  hd(a, v[c + 12 >> 2]);
 }
 eb = c + 16 | 0;
 return (b | 0) == (d | 0);
}

function WZ(a) {
 var b = 0;
 b = v[a + 4 >> 2];
 if (!b) {
  while (1) {
   b = li(a);
   a = v[a + 8 >> 2];
   if (!b) {
    continue;
   }
   break;
  }
  return a;
 }
 a = b;
 while (1) {
  b = a;
  a = v[a >> 2];
  if (a) {
   continue;
  }
  break;
 }
 return b;
}

function $E(a, b) {
 var c = 0, d = 0;
 c = eb - 16 | 0;
 eb = c;
 lh(c + 8 | 0, b);
 b = v[c + 12 >> 2];
 pd(c, a, v[c + 8 >> 2], v[c + 12 >> 2]);
 d = v[c + 4 >> 2];
 if ((b | 0) == (d | 0)) {
  hd(a, v[c + 12 >> 2]);
 }
 eb = c + 16 | 0;
 return (b | 0) == (d | 0);
}

function $$(a, b, c) {
 var d = 0;
 b = b - a >> 2;
 while (1) {
  if ((b | 0) > 0) {
   d = v[c >> 2];
   t[a | 0] = d;
   t[a + 1 | 0] = d >>> 8;
   t[a + 2 | 0] = d >>> 16;
   t[a + 3 | 0] = d >>> 24;
   b = b - 1 | 0;
   a = a + 4 | 0;
   continue;
  }
  break;
 }
}

function Fta(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0;
 c = eb - 16 | 0;
 eb = c;
 Yk(c + 8 | 0, b);
 b = v[c + 12 >> 2];
 ic(c, v[a >> 2], v[a + 8 >> 2], v[c + 8 >> 2], v[c + 12 >> 2]);
 if ((b | 0) == v[c + 4 >> 2]) {
  Ub(a, v[c + 12 >> 2]);
 }
 eb = c + 16 | 0;
}

function w9(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0;
 e = eb - 16 | 0;
 eb = e;
 a = $y(Oa(v[a + 60 >> 2], b | 0, c | 0, d & 255, e + 8 | 0) | 0);
 eb = e + 16 | 0;
 gb = a ? -1 : v[e + 12 >> 2];
 return (a ? -1 : v[e + 8 >> 2]) | 0;
}

function Csa(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0;
 c = eb - 16 | 0;
 eb = c;
 a: {
  if (!Lb(v[b >> 2], v[b + 8 >> 2], 12)) {
   u[c >> 1] = 0;
   NZ(a, 6, c);
   break a;
  }
  zr(c + 8 | 0, a);
  rd(c, b, v[c + 8 >> 2], v[c + 12 >> 2]);
 }
 eb = c + 16 | 0;
}

function C_(a) {
 var b = 0;
 a: {
  if ((w[a | 0] | w[a + 1 | 0] << 8 | (w[a + 2 | 0] << 16 | w[a + 3 | 0] << 24)) != -28163770) {
   break a;
  }
  if (id(a + 44 | 0, 18428, 3)) {
   break a;
  }
  b = (w[a + 47 | 0] | w[a + 48 | 0] << 8) >>> 0 > 97;
 }
 return b;
}

function wj(a) {
 var b = 0, c = 0;
 b = v[a + 20 >> 2];
 b = Hn(w[b + 28 | 0] | w[b + 29 | 0] << 8 | (w[b + 30 | 0] << 16 | w[b + 31 | 0] << 24));
 if (!(b >>> 0 > 249 | w[a + 4200 | 0] >= b >>> 0)) {
  c = v[_d(v[a + 16 >> 2] + 906300 | 0, b) >> 2];
 }
 return c;
}

function npa(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0;
 c = eb - 16 | 0;
 eb = c;
 a: {
  if (!Lb(v[b >> 2], v[b + 8 >> 2], 8)) {
   u[c >> 1] = 0;
   NZ(a, 4, c);
   break a;
  }
  Yk(c + 8 | 0, a);
  rd(c, b, v[c + 8 >> 2], v[c + 12 >> 2]);
 }
 eb = c + 16 | 0;
}

function kd(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0;
 a: {
  c = Df(b);
  d = Lc(a);
  if (c >>> 0 <= d >>> 0) {
   Xu(a, Mi(Jb(a), b, c), c);
   break a;
  }
  e = a;
  a = Cb(v[a + 4 >> 2], w[a + 11 | 0]);
  Zp(e, d, c - d | 0, a, 0, a, c, b);
 }
}

function Yh(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0;
 a: {
  c = es(b);
  d = Lc(a);
  if (c >>> 0 <= d >>> 0) {
   Xu(a, Mi(Jb(a), b, c), c);
   break a;
  }
  e = a;
  a = Cb(v[a + 4 >> 2], w[a + 11 | 0]);
  Uq(e, d, c - d | 0, a, 0, a, c, b);
 }
}

function KD(a, b) {
 var c = 0, d = 0, e = 0;
 c = eb - 16 | 0;
 eb = c;
 d = c, e = (mq(b) + -4.8737671609324025) * (a & 32768 ? 28.85390081777927 : 34.624680981335125), 
 A[d + 8 >> 3] = e;
 AT(c + 8 | 0, 127);
 a = Xl(A[c + 8 >> 3]);
 eb = c + 16 | 0;
 return a;
}

function s8(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0;
 a = 0;
 while (1) {
  if ((b | 0) != (c | 0)) {
   a = v[b >> 2] + (a << 4) | 0;
   d = a & -268435456;
   a = (d | d >>> 24) ^ a;
   b = b + 4 | 0;
   continue;
  }
  break;
 }
 return a | 0;
}

function rc(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0;
 a = Cj(a);
 v[a + 4 >> 2] = 0;
 v[a >> 2] = 47536;
 c = Fd(Zc(v[b + 4 >> 2], w[b + 11 | 0]) + 1 | 0);
 v[a + 4 >> 2] = c;
 if (c) {
  yc(c, Jb(b), Zc(v[b + 4 >> 2], w[b + 11 | 0]) + 1 | 0);
 }
 return a | 0;
}

function lA(a, b) {
 var c = 0;
 c = eb - 16 | 0;
 eb = c;
 a = En(c + 4 | 0, a + 8 | 0, b);
 b = v[a >> 2];
 while (1) {
  if ((b | 0) != v[a + 4 >> 2]) {
   tV(b);
   b = v[a >> 2] + 4 | 0;
   v[a >> 2] = b;
   continue;
  }
  break;
 }
 ie(a);
 eb = c + 16 | 0;
}

function iT(a, b, c) {
 var d = 0;
 d = c & 15;
 if (d) {
  t[b + 824 | 0] = d;
 }
 c = c & 240;
 if (c) {
  t[b + 823 | 0] = c >>> 4;
 }
 v[b + 88 >> 2] = v[b + 88 >> 2] | 131072;
 if (!(!d | !Nb(a + 1074312 | 0, 80))) {
  t[b + 824 | 0] = w[b + 824 | 0] << 2;
 }
}

function fpa(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0;
 c = eb - 16 | 0;
 eb = c;
 a: {
  if (!Lb(v[b >> 2], v[b + 8 >> 2], 5)) {
   t[c | 0] = 0;
   Rh(a, 5, c);
   break a;
  }
  Zj(c + 8 | 0, a);
  rd(c, b, v[c + 8 >> 2], v[c + 12 >> 2]);
 }
 eb = c + 16 | 0;
}

function Jl(a) {
 var b = 0;
 a = ki(a);
 b = 2147483647;
 a: {
  if (a >= C(2147483648)) {
   break a;
  }
  b = -2147483648;
  if (a <= C(-2147483648)) {
   break a;
  }
  b = ~~a;
  if (C(D(a)) < C(2147483648)) {
   break a;
  }
  b = -2147483648;
 }
 return b;
}

function G5(a, b, c, d, e) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 while (1) {
  if ((b | 0) != (c | 0)) {
   a = v[b >> 2];
   t[e | 0] = a >>> 0 < 128 ? a : d;
   e = e + 1 | 0;
   b = b + 4 | 0;
   continue;
  }
  break;
 }
 return c | 0;
}

function v8(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0;
 a = 0;
 while (1) {
  if ((b | 0) != (c | 0)) {
   a = t[b | 0] + (a << 4) | 0;
   d = a & -268435456;
   a = (d | d >>> 24) ^ a;
   b = b + 1 | 0;
   continue;
  }
  break;
 }
 return a | 0;
}

function tq(a) {
 var b = 0;
 b = v[a + 24 >> 2];
 v[31601] = 0;
 V(852, b | 0);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  Sd(a + 68 | 0);
  nf(a + 36 | 0);
  yl(a + 32 | 0);
  vh(a + 24 | 0);
  uh(a + 4 | 0);
  return Wc(a);
 }
 S(0) | 0;
 Rb();
 p();
}

function jm(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0;
 c = eb - 16 | 0;
 eb = c;
 a: {
  if (!Lb(v[b >> 2], v[b + 8 >> 2], 4)) {
   t[c | 0] = 0;
   Rh(a, 4, c);
   break a;
  }
  lh(c + 8 | 0, a);
  rd(c, b, v[c + 8 >> 2], v[c + 12 >> 2]);
 }
 eb = c + 16 | 0;
}

function J_(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0;
 c = eb - 16 | 0;
 eb = c;
 a: {
  if (!Lb(v[b >> 2], v[b + 8 >> 2], 6)) {
   t[c | 0] = 0;
   Rh(a, 6, c);
   break a;
  }
  YD(c + 8 | 0, a);
  rd(c, b, v[c + 8 >> 2], v[c + 12 >> 2]);
 }
 eb = c + 16 | 0;
}

function BT(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0;
 if (y[a + 4 >> 2] < y[zb(a) >> 2]) {
  c = eb - 16 | 0;
  eb = c;
  a = wv(c + 4 | 0, a, 1);
  xs(v[a + 4 >> 2], b);
  v[a + 4 >> 2] = v[a + 4 >> 2] + 12;
  hc(a);
  eb = c + 16 | 0;
  return;
 }
 WG(a, b);
}

function xk(a, b) {
 var c = 0, d = 0, e = 0;
 a: {
  c = Ol(a, b);
  if ((c | 0) == 255) {
   break a;
  }
  if (Ej(v[a >> 2])) {
   break a;
  }
  d = wb(a + 8 | 0, c);
  e = w[d | 0] & 223;
  t[d | 0] = e;
  zh(v[a >> 2], v[a + 4 >> 2], b, cv(c) | 176, e);
 }
}

function no(a, b) {
 var c = 0, d = 0;
 b = b + 7 & -8;
 d = v[a + 80 >> 2];
 a: {
  if (d) {
   b = v[a + 92 >> 2] - b | 0;
   c = 0;
   if ((b | 0) < v[a + 88 >> 2]) {
    break a;
   }
   v[a + 92 >> 2] = b;
   return b + d | 0;
  }
  c = Fd(b);
 }
 return c;
}

function JS(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0;
 c = Lc(a);
 d = Cb(v[a + 4 >> 2], w[a + 11 | 0]);
 if ((c | 0) == (d | 0)) {
  VB(a, c, 1, c, c, 0);
 }
 c = Jb(a);
 Zl(c + d | 0, 1, b);
 b = d + 1 | 0;
 kg(a, b);
 gd(b + c | 0, 0);
 return a | 0;
}

function zpa(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0;
 d = eb - 16 | 0;
 eb = d;
 sG(b, c);
 if (Lb(v[a >> 2], v[a + 8 >> 2], c << 3)) {
  rG(d + 8 | 0, v[b >> 2], v[b + 4 >> 2]);
  rd(d, a, v[d + 8 >> 2], v[d + 12 >> 2]);
 }
 eb = d + 16 | 0;
}

function yU(a) {
 var b = 0, c = 0, d = 0;
 d = a + 27 | 0;
 c = w[a + 26 | 0];
 b = c + 27 | 0;
 a = 0;
 while (1) {
  if ((a | 0) == (c | 0)) {
   a = b & 65535;
  } else {
   b = w[a + d | 0] + b | 0;
   a = a + 1 | 0;
   continue;
  }
  break;
 }
 return a;
}

function y5(a, b, c, d, e) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 while (1) {
  if ((b | 0) != (c | 0)) {
   a = t[b | 0];
   t[e | 0] = (a | 0) < 0 ? d : a;
   e = e + 1 | 0;
   b = b + 1 | 0;
   continue;
  }
  break;
 }
 return c | 0;
}

function lD(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0;
 d = eb - 16 | 0;
 eb = d;
 YY(b, c);
 if (Lb(v[a >> 2], v[a + 8 >> 2], c << 2)) {
  XY(d + 8 | 0, v[b >> 2], v[b + 4 >> 2]);
  rd(d, a, v[d + 8 >> 2], v[d + 12 >> 2]);
 }
 eb = d + 16 | 0;
}

function fl(a, b, c) {
 if (a >>> 0 < b >>> 0) {
  yc(a, b, c);
  return;
 }
 if (c) {
  a = a + c | 0;
  b = b + c | 0;
  while (1) {
   a = a - 1 | 0;
   b = b - 1 | 0;
   t[a | 0] = w[b | 0];
   c = c - 1 | 0;
   if (c) {
    continue;
   }
   break;
  }
 }
}

function dG(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0;
 a: {
  d = Mb(a + 8 | 0);
  v[31601] = 0;
  R(169, a | 0, b | 0, c | 0);
  a = v[31601];
  v[31601] = 0;
  if ((a | 0) != 1) {
   break a;
  }
  a = M() | 0;
  ec(d);
  P(a | 0);
  p();
 }
}

function Q2(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0;
 if (y[a + 4 >> 2] < y[zb(a) >> 2]) {
  c = eb - 16 | 0;
  eb = c;
  a = Cx(c + 4 | 0, a);
  xs(v[a + 4 >> 2], b);
  v[a + 4 >> 2] = v[a + 4 >> 2] + 12;
  hc(a);
  eb = c + 16 | 0;
  return;
 }
 WG(a, b);
}

function P8(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 var e = 0;
 e = eb - 16 | 0;
 eb = e;
 v[e >> 2] = c;
 v[e + 4 >> 2] = d;
 v[e + 8 >> 2] = c;
 v[e + 12 >> 2] = d;
 a = UK(a, e, b);
 v[a >> 2] = 94228;
 eb = e + 16 | 0;
 return a | 0;
}

function Mw(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0;
 c = eb - 16 | 0;
 eb = c;
 a: {
  if (!Lb(v[b >> 2], v[b + 8 >> 2], 2)) {
   t[c | 0] = 0;
   sF(a, c);
   break a;
  }
  Cp(c + 8 | 0, a);
  rd(c, b, v[c + 8 >> 2], v[c + 12 >> 2]);
 }
 eb = c + 16 | 0;
}

function $ja() {
 var a = 0, b = 0, c = 0;
 a = eb - 16 | 0;
 eb = a;
 b = Dc(1);
 v[31601] = 0;
 W(58);
 c = v[31601];
 v[31601] = 0;
 if ((c | 0) != 1) {
  b = xf(a + 12 | 0, b);
  eb = a + 16 | 0;
  return v[b >> 2];
 }
 a = M() | 0;
 Bb(b);
 P(a | 0);
 p();
}
function MW(a, b, c, d) {
 var e = 0;
 e = c & 4;
 a: {
  if ((b & 255) != 4) {
   b = e ? 16 : 8;
   break a;
  }
  b = 16;
  if (e) {
   break a;
  }
  b = 8;
  if (c & 2) {
   break a;
  }
  Yc(a, 8, 1, 0, 10);
  return;
 }
 Yc(a, b, c & 2 | 1, 0, d ^ 1);
}

function Ey(a, b, c) {
 var d = 0;
 d = b - a >> 2;
 a: {
  if (d) {
   while (1) {
    if (v[a >> 2] == (c | 0)) {
     break a;
    }
    a = a + 4 | 0;
    d = d - 1 | 0;
    if (d) {
     continue;
    }
    break;
   }
  }
  a = 0;
 }
 return a ? a : b;
}

function o3(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0;
 d = eb - 16 | 0;
 eb = d;
 v[d + 12 >> 2] = v[c >> 2];
 a = hb[v[v[a >> 2] + 16 >> 2]](a, b, d + 12 | 0) | 0;
 if (a) {
  v[c >> 2] = v[d + 12 >> 2];
 }
 eb = d + 16 | 0;
 return a | 0;
}

function Rja() {
 var a = 0, b = 0, c = 0;
 a = eb - 16 | 0;
 eb = a;
 b = Cc(a + 4 | 0, 10265);
 v[31601] = 0;
 V(62, b | 0);
 c = v[31601];
 v[31601] = 0;
 if ((c | 0) != 1) {
  sb(b);
  eb = a + 16 | 0;
  return;
 }
 a = M() | 0;
 sb(b);
 P(a | 0);
 p();
}

function KE(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0;
 c = eb - 16 | 0;
 eb = c;
 v[c + 12 >> 2] = -1;
 if (dh(a, c + 11 | 0)) {
  v[c + 4 >> 2] = w[c + 11 | 0];
  d = x0(a, b, v[Gb(c + 4 | 0, c + 12 | 0) >> 2]);
 }
 eb = c + 16 | 0;
 return d | 0;
}

function I0(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0;
 c = eb - 16 | 0;
 eb = c;
 v[c + 12 >> 2] = -1;
 if (dh(a, c + 11 | 0)) {
  v[c + 4 >> 2] = w[c + 11 | 0];
  d = A0(a, b, v[Gb(c + 4 | 0, c + 12 | 0) >> 2]);
 }
 eb = c + 16 | 0;
 return d | 0;
}

function eI(a) {
 var b = 0, c = 0;
 c = a >>> 23 & 255;
 b = 0;
 a: {
  if (c >>> 0 < 127) {
   break a;
  }
  b = 2;
  if (c >>> 0 > 150) {
   break a;
  }
  c = 1 << 150 - c;
  b = 0;
  if (c - 1 & a) {
   break a;
  }
  b = a & c ? 1 : 2;
 }
 return b;
}

function Uja(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0;
 c = eb - 16 | 0;
 eb = c;
 d = c, e = th(b), v[d + 12 >> 2] = e;
 v[c + 8 >> 2] = 0;
 d = a, e = v[Yj(c + 12 | 0, c + 8 | 0, 42192) >> 2], v[d + 36 >> 2] = e;
 xq(a);
 eb = c + 16 | 0;
}

function Qna(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0;
 d = eb - 48 | 0;
 eb = d;
 c = -1;
 a: {
  if (!FW(a, d)) {
   break a;
  }
  c = 0;
  if (!GV(d)) {
   break a;
  }
  c = ve(a, b, FV(w[d + 47 | 0]), gb);
 }
 eb = d + 48 | 0;
 return c | 0;
}

function jS() {
 var a = 0, b = 0, c = 0, d = 0;
 a = eb - 16 | 0;
 eb = a;
 b = a + 12 | 0;
 while (1) {
  if (c >>> 0 < 32) {
   c = c + 48 | 0;
   d = UA(126448);
   continue;
  }
  break;
 }
 v[b >> 2] = d;
 Co(b);
 eb = a + 16 | 0;
 return v[b >> 2];
}

function Qe(a, b) {
 var c = 0;
 c = v[a >> 2];
 v[a >> 2] = b;
 a: {
  if (c) {
   a = v[fc(a) >> 2];
   v[31601] = 0;
   V(a | 0, c | 0);
   a = v[31601];
   v[31601] = 0;
   if ((a | 0) == 1) {
    break a;
   }
  }
  return;
 }
 S(0) | 0;
 Rb();
 p();
}

function mka(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0;
 a = ng(a);
 c = Si(v[b >> 2]);
 b = Of(b);
 v[31601] = 0;
 R(846, a | 0, c | 0, b | 0);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  return a | 0;
 }
 b = M() | 0;
 VS(a);
 P(b | 0);
 p();
}

function dj(a, b, c, d, e) {
 a: {
  e = Au(e);
  if (e) {
   v[31601] = 0;
   aa(d | 0, e | 0, a | 0, b | 0, c | 0) | 0;
   a = v[31601];
   v[31601] = 0;
   if ((a | 0) == 1) {
    break a;
   }
  }
  return e;
 }
 a = M() | 0;
 Bb(e);
 P(a | 0);
 p();
}

function Pg(a, b, c, d) {
 var e = 0;
 a = ((b | 0) / 8 | 0) + a | 0;
 e = Jh(v[d >> 2], v[d + 4 >> 2], a);
 return ((Jh(v[d >> 2], v[d + 4 >> 2], a + 1 | 0) << 8 | e << 16 | Jh(v[d >> 2], v[d + 4 >> 2], a + 2 | 0)) << (b & 7) & 16777215) >>> 24 - c | 0;
}

function HW(a, b) {
 var c = 0;
 c = eb - 32 | 0;
 eb = c;
 sX(c + 24 | 0, a);
 ee(c + 16 | 0, b);
 a = v[c + 20 >> 2];
 v[c + 8 >> 2] = v[c + 16 >> 2];
 v[c + 12 >> 2] = a;
 a = Hc(v[c + 24 >> 2], v[c + 28 >> 2], c + 8 | 0);
 eb = c + 32 | 0;
 return a;
}

function CH(a, b, c) {
 var d = 0, e = 0;
 while (1) {
  if ((a | 0) != (b | 0)) {
   e = w[a | 0];
   d = e << 24 >> 24;
   if ((d | 0) >= 0) {
    d = v[(e << 2) + c >> 2];
   }
   t[a | 0] = d;
   a = a + 1 | 0;
   continue;
  }
  break;
 }
 return b;
}

function nZ(a, b, c) {
 var d = 0, e = 0, f = 0;
 d = eb - 16 | 0;
 eb = d;
 b = fc(b);
 a = Ch(a, Dc(32), Ng(d + 8 | 0, b));
 b = v[a >> 2] + 16 | 0;
 u[b >> 1] = x[v[c >> 2] >> 1];
 Eb(b + 4 | 0);
 e = fc(a), f = 1, t[e + 4 | 0] = f;
 eb = d + 16 | 0;
}

function h5(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 a = uJ(a, c);
 v[a >> 2] = 96636;
 b = Jb(b);
 v[31601] = 0;
 N(1367, a | 0, b | 0);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  return a | 0;
 }
 b = M() | 0;
 ky(a);
 P(b | 0);
 p();
}

function e5(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 a = tJ(a, c);
 v[a >> 2] = 96676;
 b = Jb(b);
 v[31601] = 0;
 N(1368, a | 0, b | 0);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  return a | 0;
 }
 b = M() | 0;
 ly(a);
 P(b | 0);
 p();
}

function cd(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0;
 a: {
  if (y[a + 8 >> 2] < b >>> 0) {
   d = v[a >> 2];
   c = 0;
   if (!(hb[v[v[d >> 2] + 32 >> 2]](d, 0, b) | 0)) {
    break a;
   }
  }
  v[a + 8 >> 2] = b;
  c = 1;
 }
 return c | 0;
}

function YO(a, b) {
 var c = C(0);
 a: {
  if ((b | 0) < 0 | x[a + 480188 >> 1] <= b >>> 0) {
   break a;
  }
  a = (a + 1074992 | 0) + B(b, 872) | 0;
  if (!(t[a + 89 | 0] & 1)) {
   break a;
  }
  c = C(C(w[a + 842 | 0]) * C(.0078125));
 }
 return c;
}

function XO(a, b) {
 var c = C(0);
 a: {
  if ((b | 0) < 0 | x[a + 480188 >> 1] <= b >>> 0) {
   break a;
  }
  a = (a + 1074992 | 0) + B(b, 872) | 0;
  if (!(t[a + 89 | 0] & 1)) {
   break a;
  }
  c = C(C(w[a + 843 | 0]) * C(.0078125));
 }
 return c;
}

function Ub(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0;
 c = Lb(v[a >> 2], v[a + 8 >> 2], b);
 a: {
  if (c) {
   b = v[a + 8 >> 2] + b | 0;
   break a;
  }
  b = v[a >> 2];
  b = hb[v[v[b >> 2] + 24 >> 2]](b) | 0;
 }
 v[a + 8 >> 2] = b;
 return c | 0;
}

function Md(a, b) {
 var c = 0;
 c = eb - 32 | 0;
 eb = c;
 ee(c + 24 | 0, a);
 a = oc(c + 16 | 0, b);
 b = v[a + 4 >> 2];
 v[c + 8 >> 2] = v[a >> 2];
 v[c + 12 >> 2] = b;
 a = Hc(v[c + 24 >> 2], v[c + 28 >> 2], c + 8 | 0);
 eb = c + 32 | 0;
 return a;
}

function AO(a, b, c, d, e, f, g) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 f = f | 0;
 g = g | 0;
 var h = 0, i = 0;
 h = eb - 32 | 0;
 eb = h;
 i = h + 8 | 0;
 YL(i, b, c, d, e, f, g);
 Uc(a, h + 20 | 0);
 _m(i);
 eb = h + 32 | 0;
}

function $w(a, b, c, d, e) {
 var f = 0;
 while (1) {
  if ((d | 0) != (f | 0)) {
   z[b >> 2] = C(v[a >> 2]) * e;
   z[c >> 2] = C(v[a + 4 >> 2]) * e;
   f = f + 1 | 0;
   c = c + 4 | 0;
   a = a + 8 | 0;
   b = b + 4 | 0;
   continue;
  }
  break;
 }
}

function dia(a) {
 a = a | 0;
 var b = 0;
 b = eb - 16 | 0;
 eb = b;
 uQ(b + 8 | 0, a, 0);
 if (v[b + 12 >> 2]) {
  a = v[a + 20 >> 2];
  v[a + 148 >> 2] = -1;
  tQ(a + 4 | 0, vb(v[b + 8 >> 2]), Ok(v[b + 8 >> 2], v[b + 12 >> 2]));
 }
 eb = b + 16 | 0;
}

function LP(a) {
 a = a | 0;
 var b = 0;
 v[a + 4240 >> 2] = 0;
 v[a + 4244 >> 2] = 0;
 b = a + 4264 | 0;
 v[b >> 2] = 0;
 v[b + 4 >> 2] = 0;
 b = a + 4256 | 0;
 v[b >> 2] = 0;
 v[b + 4 >> 2] = 0;
 a = a + 4248 | 0;
 v[a >> 2] = 0;
 v[a + 4 >> 2] = 0;
}

function hr(a, b) {
 var c = 0, d = 0;
 a: {
  if (!a) {
   break a;
  }
  c = Aua(a, 0, b, 0);
  d = gb;
  if ((a | b) >>> 0 < 65536) {
   break a;
  }
  c = d ? -1 : c;
 }
 a = Fd(c);
 if (!(!a | !(w[a - 4 | 0] & 3))) {
  Qb(a, 0, c);
 }
 return a;
}

function Od(a, b) {
 var c = 0, d = 0, e = 0, f = C(0);
 c = eb - 16 | 0;
 eb = c;
 v[c + 8 >> 2] = 1065353216;
 z[c + 12 >> 2] = b;
 e = c, f = $f(a), z[e + 4 >> 2] = f;
 d = Sv(c + 4 | 0, c + 12 | 0, c + 8 | 0);
 eb = c + 16 | 0;
 return z[d >> 2];
}

function LZ(a, b) {
 var c = 0;
 c = Aua(b & 65535, 0, 384, 0);
 b = a & 65535;
 a = b >>> 30 | 0;
 b = b << 2;
 c = c + b | 0;
 a = a + gb | 0;
 a = b >>> 0 > c >>> 0 ? a + 1 | 0 : a;
 b = c + 256 | 0;
 gb = b >>> 0 < 256 ? a + 1 | 0 : a;
 return b;
}

function pr(a) {
 var b = 0, c = 0, d = 0, e = 0;
 c = v[a + 4 >> 2];
 b = v[c >> 2];
 v[a + 4 >> 2] = b;
 if (b) {
  vn(b, a);
 }
 b = v[a + 8 >> 2];
 v[c + 8 >> 2] = b;
 d = b + (li(a) ? 0 : 4) | 0, e = c, v[d >> 2] = e;
 v[c >> 2] = a;
 vn(a, c);
}

function nr(a) {
 var b = 0, c = 0, d = 0, e = 0;
 c = v[a >> 2];
 b = v[c + 4 >> 2];
 v[a >> 2] = b;
 if (b) {
  vn(b, a);
 }
 b = v[a + 8 >> 2];
 v[c + 8 >> 2] = b;
 d = b + (li(a) ? 0 : 4) | 0, e = c, v[d >> 2] = e;
 v[c + 4 >> 2] = a;
 vn(a, c);
}

function _O(a, b) {
 var c = C(0);
 a: {
  if ((b | 0) < 0 | x[a + 480188 >> 1] <= b >>> 0) {
   break a;
  }
  a = (a + 1074992 | 0) + B(b, 872) | 0;
  if (t[a + 89 | 0] & 1) {
   break a;
  }
  c = C(C(w[a + 842 | 0]) * C(.0078125));
 }
 return c;
}

function WO(a, b) {
 var c = C(0);
 a: {
  if ((b | 0) < 0 | x[a + 480188 >> 1] <= b >>> 0) {
   break a;
  }
  a = (a + 1074992 | 0) + B(b, 872) | 0;
  if (t[a + 89 | 0] & 1) {
   break a;
  }
  c = C(C(w[a + 843 | 0]) * C(.0078125));
 }
 return c;
}

function Gda(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0;
 d = Cb(v[b + 4 >> 2], w[b + 11 | 0]);
 e = a;
 a = Cb(v[c + 4 >> 2], w[c + 11 | 0]);
 b = Wg(Jb(Iz(e, d + a | 0)), Jb(b), d) + d | 0;
 Zl(Wg(b, Jb(c), a) + a | 0, 1, 0);
}

function Cpa(a, b) {
 a = a | 0;
 b = b | 0;
 a: {
  if (a >>> 0 >= 515) {
   a = Qg(b);
   Qg(b);
   break a;
  }
  a = fh(b);
  fh(b);
 }
 while (1) {
  if (a) {
   if (a & 1) {
    Ub(b, 260);
   }
   a = a >>> 1 | 0;
   continue;
  }
  break;
 }
}

function GX(a) {
 if ((w[a | 0] | w[a + 1 | 0] << 8 | (w[a + 2 | 0] << 16 | w[a + 3 | 0] << 24)) == 1297239878) {
  a = (w[a + 8 | 0] | w[a + 9 | 0] << 8 | (w[a + 10 | 0] << 16 | w[a + 11 | 0] << 24)) == 1279545165;
 } else {
  a = 0;
 }
 return a;
}

function Rt(a) {
 var b = 0;
 a: {
  if ((ff(a) | 0) != 79) {
   break a;
  }
  if ((ff(a) | 0) != 103) {
   break a;
  }
  if ((ff(a) | 0) != 103) {
   break a;
  }
  b = (ff(a) | 0) == 83;
 }
 if (!b) {
  bc(a, 30);
  return 0;
 }
 return ML(a);
}

function Doa(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0;
 d = eb + -64 | 0;
 eb = d;
 c = -1;
 a: {
  if (!a$(a, d)) {
   break a;
  }
  c = 0;
  if (!zW(d)) {
   break a;
  }
  c = ve(a, b, yW(d), gb);
 }
 eb = d - -64 | 0;
 return c | 0;
}

function uta(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0;
 d = eb + -64 | 0;
 eb = d;
 c = -1;
 a: {
  if (!a$(a, d)) {
   break a;
  }
  c = 0;
  if (!$_(d)) {
   break a;
  }
  c = ve(a, b, __(d), 0);
 }
 eb = d - -64 | 0;
 return c | 0;
}

function jW(a) {
 if ((w[a | 0] | w[a + 1 | 0] << 8 | (w[a + 2 | 0] << 16 | w[a + 3 | 0] << 24)) == 1299020115) {
  a = (_b(w[a + 4 | 0] | w[a + 5 | 0] << 8 | (w[a + 6 | 0] << 16 | w[a + 7 | 0] << 24)) | 0) == 1;
 } else {
  a = 0;
 }
 return a;
}

function fL(a, b) {
 var c = 0, d = 0, e = 0, f = 0;
 c = v[a + 24 >> 2];
 if ((c | 0) == v[a + 28 >> 2]) {
  return e = a, f = yf(b), d = v[v[a >> 2] + 52 >> 2], hb[d](e | 0, f | 0) | 0;
 }
 v[a + 24 >> 2] = c + 1;
 t[c | 0] = b;
 return yf(b);
}

function _M(a, b) {
 var c = 0;
 c = v[b + 4 >> 2];
 v[a >> 2] = v[b >> 2];
 v[a + 4 >> 2] = c;
 c = v[b + 20 >> 2];
 v[a + 16 >> 2] = v[b + 16 >> 2];
 v[a + 20 >> 2] = c;
 c = v[b + 12 >> 2];
 v[a + 8 >> 2] = v[b + 8 >> 2];
 v[a + 12 >> 2] = c;
}

function Xs(a) {
 var b = 0, c = 0, d = 0;
 if (!a) {
  return 0;
 }
 d = 108112;
 while (1) {
  b = d;
  c = v[b >> 2];
  if (c) {
   d = b + 4 | 0;
   if ((a | 0) != (c | 0)) {
    continue;
   }
  }
  break;
 }
 return ((c ? b : 0) | 0) != 0;
}

function xS(a, b) {
 var c = 0;
 c = eb - 32 | 0;
 eb = c;
 a = we(c + 8 | 0, a, b);
 a = Hu(c + 16 | 0, v[a >> 2], v[a + 4 >> 2]);
 a = we(c + 24 | 0, v[a >> 2], v[a + 4 >> 2]);
 b = v[a >> 2];
 eb = c + 32 | 0;
 gb = v[a + 4 >> 2];
 return b;
}

function ws(a) {
 var b = 0, c = 0;
 c = v[a + 4 >> 2];
 while (1) {
  b = v[a + 8 >> 2];
  if ((b | 0) != (c | 0)) {
   b = b - 12 | 0;
   v[a + 8 >> 2] = b;
   Db(b);
   continue;
  }
  break;
 }
 c = v[a >> 2];
 if (c) {
  vs(a);
  Bb(c);
 }
}

function jpa(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0;
 d = eb - 96 | 0;
 eb = d;
 c = -1;
 a: {
  if (!nX(a, d)) {
   break a;
  }
  c = 0;
  if (!mX(d)) {
   break a;
  }
  c = ve(a, b, lX(d), gb);
 }
 eb = d + 96 | 0;
 return c | 0;
}

function ix(a) {
 var b = 0, c = 0;
 c = v[a + 4 >> 2];
 while (1) {
  b = v[a + 8 >> 2];
  if ((b | 0) != (c | 0)) {
   b = b - 36 | 0;
   v[a + 8 >> 2] = b;
   Hp(b);
   continue;
  }
  break;
 }
 c = v[a >> 2];
 if (c) {
  mc(a);
  Bb(c);
 }
}

function hla(a, b) {
 a = a | 0;
 b = b | 0;
 a = sc(a);
 t[a + 534 | 0] = 0;
 v[a + 4 >> 2] = 0;
 v[31601] = 0;
 N(787, a | 0, b | 0);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  return a | 0;
 }
 b = M() | 0;
 El(a);
 P(b | 0);
 p();
}

function cX(a) {
 var b = 0, c = 0;
 c = v[a + 4 >> 2];
 while (1) {
  b = v[a + 8 >> 2];
  if ((b | 0) != (c | 0)) {
   b = b - 56 | 0;
   v[a + 8 >> 2] = b;
   ar(b);
   continue;
  }
  break;
 }
 c = v[a >> 2];
 if (c) {
  mc(a);
  Bb(c);
 }
}

function bw(a) {
 var b = 0, c = 0;
 c = v[a + 4 >> 2];
 while (1) {
  b = v[a + 8 >> 2];
  if ((b | 0) != (c | 0)) {
   b = b - 20 | 0;
   v[a + 8 >> 2] = b;
   tb(b);
   continue;
  }
  break;
 }
 c = v[a >> 2];
 if (c) {
  mc(a);
  Bb(c);
 }
}

function aR(a) {
 var b = 0, c = 0;
 c = v[a + 4 >> 2];
 while (1) {
  b = v[a + 8 >> 2];
  if ((b | 0) != (c | 0)) {
   b = b - 52 | 0;
   v[a + 8 >> 2] = b;
   uk(b);
   continue;
  }
  break;
 }
 c = v[a >> 2];
 if (c) {
  mc(a);
  Bb(c);
 }
}

function ZB(a) {
 var b = 0, c = 0;
 c = v[a + 4 >> 2];
 while (1) {
  b = v[a + 8 >> 2];
  if ((b | 0) != (c | 0)) {
   b = b - 32 | 0;
   v[a + 8 >> 2] = b;
   zk(b);
   continue;
  }
  break;
 }
 c = v[a >> 2];
 if (c) {
  vs(a);
  Bb(c);
 }
}

function Moa(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0;
 d = eb - 96 | 0;
 eb = d;
 c = -1;
 a: {
  if (!nX(a, d)) {
   break a;
  }
  c = 0;
  if (!RW(d)) {
   break a;
  }
  c = ve(a, b, QW(d), gb);
 }
 eb = d + 96 | 0;
 return c | 0;
}

function K$(a) {
 var b = 0, c = 0;
 c = v[a + 4 >> 2];
 while (1) {
  b = v[a + 8 >> 2];
  if ((b | 0) != (c | 0)) {
   b = b - 28 | 0;
   v[a + 8 >> 2] = b;
   Gd(b);
   continue;
  }
  break;
 }
 c = v[a >> 2];
 if (c) {
  mc(a);
  Bb(c);
 }
}

function D9(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 a: {
  a = ig(a, b);
  v[31601] = 0;
  O(71, a + 12 | 0, c | 0) | 0;
  b = v[31601];
  v[31601] = 0;
  if ((b | 0) != 1) {
   break a;
  }
  b = M() | 0;
  sb(a);
  P(b | 0);
  p();
 }
}

function vC(a) {
 var b = 0;
 a = Ee(a);
 b = 32767;
 a: {
  if (a >= 32767) {
   break a;
  }
  b = 32768;
  if (a <= -32768) {
   break a;
  }
  b = ~~a;
  if (D(a) < 2147483648) {
   break a;
  }
  b = -2147483648;
 }
 return b << 16 >> 16;
}

function ef(a, b) {
 var c = 0;
 c = eb - 16 | 0;
 eb = c;
 a: {
  if (!b) {
   Pc(c + 8 | 0, a + 32 | 0, 5);
   if (Fb(v[v[c + 8 >> 2] >> 2], v[c + 12 >> 2])) {
    break a;
   }
  }
  v[a + 28 >> 2] = v[a + 28 >> 2] + 1;
 }
 eb = c + 16 | 0;
}

function cP(a, b, c, d, e, f, g) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 f = f | 0;
 g = g | 0;
 var h = 0, i = 0;
 h = eb - 32 | 0;
 eb = h;
 i = h + 8 | 0;
 YL(i, b, c, d, e, f, g);
 Uc(a, i);
 _m(i);
 eb = h + 32 | 0;
}

function Tq(a) {
 v[a + 8 >> 2] = 0;
 v[a + 12 >> 2] = 0;
 v[a >> 2] = 128;
 v[a + 4 >> 2] = 256;
 v[a + 32 >> 2] = 363;
 v[a + 36 >> 2] = 952;
 v[a + 16 >> 2] = 48e3;
 v[a + 20 >> 2] = 2;
 v[a + 24 >> 2] = 128;
 v[a + 28 >> 2] = 0;
 return a;
}

function K8(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0;
 b = LD(v[b >> 2]);
 v[a + 36 >> 2] = b;
 c = a, d = Kh(b), v[c + 44 >> 2] = d;
 c = a, d = ho(v[a + 36 >> 2]), t[c + 53 | 0] = d;
 if (v[a + 44 >> 2] >= 9) {
  fo(5563);
  p();
 }
}

function C8(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0;
 b = Qy(v[b >> 2]);
 v[a + 36 >> 2] = b;
 c = a, d = Kh(b), v[c + 44 >> 2] = d;
 c = a, d = ho(v[a + 36 >> 2]), t[c + 53 | 0] = d;
 if (v[a + 44 >> 2] >= 9) {
  fo(5563);
  p();
 }
}

function t_(a, b) {
 var c = 0;
 c = Aua(b & 255, 0, 9, 0);
 b = a & 255;
 a = b >>> 31 | 0;
 b = b << 1;
 c = c + b | 0;
 a = a + gb | 0;
 a = b >>> 0 > c >>> 0 ? a + 1 | 0 : a;
 b = c + 11 | 0;
 gb = b >>> 0 < 11 ? a + 1 | 0 : a;
 return b;
}

function f$(a) {
 t[a + 8 | 0] = 0;
 t[a + 9 | 0] = 0;
 t[a + 10 | 0] = 0;
 t[a + 11 | 0] = 0;
 t[a | 0] = 0;
 t[a + 1 | 0] = 0;
 t[a + 2 | 0] = 0;
 t[a + 3 | 0] = 0;
 t[a + 4 | 0] = 0;
 t[a + 5 | 0] = 0;
 t[a + 6 | 0] = 0;
 t[a + 7 | 0] = 0;
}

function aE(a, b, c, d) {
 var e = 0;
 e = eb - 32 | 0;
 eb = e;
 ed(e + 24 | 0, b, c);
 dv(e + 16 | 0, v[e + 24 >> 2], v[e + 28 >> 2], d);
 b = N_(b, v[e + 16 >> 2]);
 v[e + 12 >> 2] = v[e + 20 >> 2];
 pc(a, b, e + 12 | 0);
 eb = e + 32 | 0;
}

function WU(a, b, c, d) {
 var e = 0;
 e = eb - 32 | 0;
 eb = e;
 ed(e + 24 | 0, b, c);
 UU(e + 16 | 0, v[e + 24 >> 2], v[e + 28 >> 2], d);
 b = MX(b, v[e + 16 >> 2]);
 v[e + 12 >> 2] = v[e + 20 >> 2];
 pc(a, b, e + 12 | 0);
 eb = e + 32 | 0;
}

function Ju(a, b) {
 var c = 0, d = 0, e = C(0);
 c = eb - 16 | 0;
 eb = c;
 z[c + 12 >> 2] = b;
 v[c + 8 >> 2] = 0;
 v[c + 4 >> 2] = 1065353216;
 d = a, e = z[Sv(c + 12 | 0, c + 8 | 0, c + 4 | 0) >> 2], z[d + 144 >> 2] = e;
 eb = c + 16 | 0;
}

function qda(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0;
 a = cc(8);
 v[31601] = 0;
 b = O(1050, a | 0, 12097) | 0;
 c = v[31601];
 v[31601] = 0;
 if ((c | 0) != 1) {
  ca(b | 0, 124868, 162);
  p();
 }
 b = M() | 0;
 jc(a);
 P(b | 0);
 p();
}

function lX(a) {
 var b = 0, c = 0, d = 0, e = 0;
 d = w[a + 4 | 0];
 e = w[a + 92 | 0];
 c = w[a + 94 | 0] | w[a + 95 | 0] << 8;
 b = c + w[a + 93 | 0] | 0;
 a = 0;
 b = b + e | 0;
 a = (b << 2) + d | 0;
 a = a - 96 | 0;
 gb = 0;
 return a;
}

function kO(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 b = eb - 16 | 0;
 eb = b;
 c = Yb(b + 8 | 0, c, d);
 d = v[c + 4 >> 2];
 v[b >> 2] = v[c >> 2];
 v[b + 4 >> 2] = d;
 a = Bu(a, b, 0);
 eb = b + 16 | 0;
 return a | 0;
}

function LE(a) {
 t[a | 0] = 0;
 t[a + 1 | 0] = 0;
 t[a + 2 | 0] = 0;
 t[a + 3 | 0] = 0;
 t[a + 4 | 0] = 0;
 t[a + 5 | 0] = 0;
 t[a + 6 | 0] = 0;
 t[a + 7 | 0] = 0;
 t[a + 7 | 0] = 0;
 t[a + 8 | 0] = 0;
 t[a + 9 | 0] = 0;
 t[a + 10 | 0] = 0;
}

function KB(a) {
 var b = 0, c = 0;
 b = eb - 16 | 0;
 eb = b;
 v[b + 12 >> 2] = a;
 c = b + 12 | 0;
 a = 1;
 while (1) {
  if ((a | 0) > 0) {
   $g(c);
   a = a - 1 | 0;
   continue;
  }
  break;
 }
 eb = b + 16 | 0;
 return v[b + 12 >> 2];
}

function RW(a) {
 var b = 0;
 if (!((w[a + 44 | 0] | w[a + 45 | 0] << 8 | (w[a + 46 | 0] << 16 | w[a + 47 | 0] << 24)) != 1297236819 | w[a + 29 | 0] != 16)) {
  b = ((w[a + 42 | 0] | w[a + 43 | 0] << 8) - 1 & 65535) >>> 0 < 2;
 }
 return b;
}

function Eq(a, b, c) {
 var d = 0;
 a: {
  if (b & 134218752) {
   break a;
  }
  if (!Aj(c)) {
   break a;
  }
  b = w[c + 34 | 0];
  if ((b + 5 & 255) >>> 0 < 6) {
   break a;
  }
  d = v[_d(a + 906300 | 0, b - 1 | 0) >> 2];
 }
 return d;
}

function xj(a, b, c, d) {
 var e = 0;
 e = v[b + 4 >> 2];
 v[a >> 2] = v[b >> 2];
 v[a + 4 >> 2] = e;
 e = v[b + 12 >> 2];
 v[a + 8 >> 2] = v[b + 8 >> 2];
 v[a + 12 >> 2] = e;
 A[a >> 3] = A[a >> 3] - c;
 A[a + 8 >> 3] = A[a + 8 >> 3] - d;
}

function ex(a, b) {
 var c = 0;
 c = eb - 16 | 0;
 eb = c;
 a: {
  if (!Lb(v[b >> 2], v[b + 8 >> 2], 3)) {
   t[c | 0] = 0;
   Rh(a, 3, c);
   break a;
  }
  dx(c + 8 | 0, a);
  rd(c, b, v[c + 8 >> 2], v[c + 12 >> 2]);
 }
 eb = c + 16 | 0;
}

function Z_(a, b) {
 var c = 0;
 c = eb - 16 | 0;
 eb = c;
 a: {
  if (!Lb(v[b >> 2], v[b + 8 >> 2], 8)) {
   t[c | 0] = 0;
   Rh(a, 8, c);
   break a;
  }
  Yk(c + 8 | 0, a);
  rd(c, b, v[c + 8 >> 2], v[c + 12 >> 2]);
 }
 eb = c + 16 | 0;
}

function Jia(a) {
 a = a | 0;
 var b = 0;
 b = eb - 16 | 0;
 eb = b;
 Pc(b + 4 | 0, a + 32 | 0, 4);
 if (!Fb(v[v[b + 4 >> 2] >> 2], v[b + 8 >> 2])) {
  yy(a);
 }
 a = ub(b + 12 | 0, vb(v[a + 52 >> 2]));
 eb = b + 16 | 0;
 return v[a >> 2];
}

function Iia(a) {
 a = a | 0;
 var b = 0;
 b = eb - 16 | 0;
 eb = b;
 Pc(b + 4 | 0, a + 32 | 0, 4);
 if (!Fb(v[v[b + 4 >> 2] >> 2], v[b + 8 >> 2])) {
  yy(a);
 }
 a = ub(b + 12 | 0, vb(v[a + 56 >> 2]));
 eb = b + 16 | 0;
 return v[a >> 2];
}

function jq(a, b) {
 var c = 0;
 a: {
  if (!TL(b) | (w[b + 1 | 0] ^ w[a + 1 | 0]) >>> 0 > 1) {
   break a;
  }
  b = w[b + 2 | 0];
  a = w[a + 2 | 0];
  if ((b ^ a) & 12) {
   break a;
  }
  c = a >>> 0 < 16 ^ b >>> 0 > 15;
 }
 return c;
}

function iX(a) {
 if (!((w[a | 0] | w[a + 1 | 0] << 8 | (w[a + 2 | 0] << 16 | w[a + 3 | 0] << 24)) != 541938512 | (w[a + 8 | 0] | w[a + 9 | 0] << 8 | (w[a + 10 | 0] << 16 | w[a + 11 | 0] << 24)) != 1162627398)) {
  return 1;
 }
 return 0;
}

function _u(a, b) {
 var c = 0, d = 0;
 d = Xj(a, b);
 while (1) {
  a: {
   c = d;
   if (!(c & 65535)) {
    c = 0;
    break a;
   }
   d = c - 1 | 0;
   if (!Ie(a, b, d & 65535)) {
    continue;
   }
  }
  break;
 }
 return c & 65535;
}

function O8(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0;
 c = v[a + 40 >> 2];
 while (1) {
  if (c) {
   c = c - 1 | 0;
   d = c << 2;
   hb[v[v[a + 32 >> 2] + d >> 2]](b, a, v[d + v[a + 36 >> 2] >> 2]);
   continue;
  }
  break;
 }
}

function Dga(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = C(c);
 var d = 0, e = 0, f = C(0);
 if (b >>> 0 <= 1) {
  c = Od(c, C(0));
  if ((b | 0) == 1) {
   d = 1;
   c = ki(c);
  }
  e = xb(a + 4208 | 0, d), f = c, z[e >> 2] = f;
  SP(a);
 }
}

function vla(a, b) {
 a = a | 0;
 b = b | 0;
 a = Mb(a);
 t[a + 16 | 0] = 0;
 v[a + 12 >> 2] = b;
 v[31601] = 0;
 V(781, a | 0);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  return a | 0;
 }
 b = M() | 0;
 aC(a);
 P(b | 0);
 p();
}

function K2(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 a = Bs(a, v[b + 28 >> 2]);
 YG(b + 28 | 0, c);
 v[31601] = 0;
 N(113, b | 0, 1);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) == 1) {
  b = M() | 0;
  Zb(a);
  P(b | 0);
  p();
 }
}

function BI(a, b, c) {
 var d = 0, e = 0, f = 0, g = 0;
 d = QC(b);
 if (d >>> 0 < c >>> 0) {
  qI(a, b, d + 1 | 0);
  return d;
 }
 if (c) {
  e = a;
  a = c - 1 | 0;
  f = qI(e, b, a) + (a << 2) | 0, g = 0, v[f >> 2] = g;
 }
 return d;
}

function lZ(a, b, c) {
 var d = 0;
 d = eb - 32 | 0;
 eb = d;
 v[d + 28 >> 2] = c;
 t[d + 27 | 0] = 0;
 v[d + 12 >> 2] = 1;
 sz(d + 16 | 0, a, d + 27 | 0, v[Gb(d + 28 | 0, d + 12 | 0) >> 2]);
 t[b | 0] = w[d + 27 | 0];
 eb = d + 32 | 0;
}

function ND(a) {
 var b = 0, c = 0;
 b = eb - 16 | 0;
 eb = b;
 u[b + 14 >> 1] = a;
 Gf(b + 14 | 0, 4095);
 a = x[b + 14 >> 1];
 c = MD(zi(+((a & 255) >>> 0) * .00390625) * 32768);
 eb = b + 16 | 0;
 return c >>> 15 - (a >>> 8 | 0) | 0;
}

function xm(a, b) {
 var c = 0, d = 0;
 d = v[a + 4 >> 2];
 c = v[a + 8 >> 2];
 while (1) {
  if ((c | 0) != (d | 0)) {
   c = c - b | 0;
   v[a + 8 >> 2] = c;
   continue;
  }
  break;
 }
 b = v[a >> 2];
 if (b) {
  mc(a);
  Bb(b);
 }
}

function kz(a, b) {
 var c = 0;
 while (1) {
  c = (b | 0) >= 120 ? 120 : b;
  a = C(a * C(z[((c & 3) << 2) + 81952 >> 2] * C(1073741824 >>> (c >> 2) | 0)));
  b = b - c | 0;
  if ((b | 0) > 0) {
   continue;
  }
  break;
 }
 return a;
}

function Taa(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0;
 c = eb - 16 | 0;
 eb = c;
 v[c + 12 >> 2] = 1134;
 v[c + 8 >> 2] = 1135;
 v[c + 4 >> 2] = 1136;
 v[c >> 2] = 1137;
 hb[v[lq(c, rk(w[b + 20 | 0])) >> 2]](a, b);
 eb = c + 16 | 0;
}

function Sq(a, b, c) {
 a: {
  if (!Nb(c + 1074312 | 0, 102)) {
   break a;
  }
  c = x[a + 692 >> 1] + 1 | 0;
  u[a + 784 >> 1] = c;
  if (!(t[a + 89 | 0] & 1)) {
   break a;
  }
  u[a + 784 >> 1] = c | 32768;
 }
 v[a + 692 >> 2] = b;
}

function RU(a, b, c, d) {
 var e = 0;
 e = eb - 32 | 0;
 eb = e;
 ed(e + 24 | 0, b, c);
 UU(e + 16 | 0, v[e + 24 >> 2], v[e + 28 >> 2], d);
 b = v[e + 16 >> 2];
 v[e + 12 >> 2] = v[e + 20 >> 2];
 pc(a, b, e + 12 | 0);
 eb = e + 32 | 0;
}

function Iv(a, b, c, d) {
 var e = 0;
 e = eb - 32 | 0;
 eb = e;
 ed(e + 24 | 0, b, c);
 cD(e + 16 | 0, v[e + 24 >> 2], v[e + 28 >> 2], d);
 b = v[e + 16 >> 2];
 v[e + 12 >> 2] = v[e + 20 >> 2];
 pc(a, b, e + 12 | 0);
 eb = e + 32 | 0;
}

function BJ(a) {
 v[a >> 2] = 0;
 v[a + 4 >> 2] = 0;
 v[a + 16 >> 2] = 0;
 v[a + 20 >> 2] = 0;
 v[a + 8 >> 2] = 0;
 v[a + 12 >> 2] = 0;
 u[a + 20 >> 1] = 0;
 v[a + 16 >> 2] = -1;
 v[a + 8 >> 2] = 0;
 v[a + 12 >> 2] = 0;
 v[a >> 2] = 0;
}

function $B(a, b, c, d) {
 var e = 0;
 e = eb - 32 | 0;
 eb = e;
 ed(e + 24 | 0, b, c);
 dv(e + 16 | 0, v[e + 24 >> 2], v[e + 28 >> 2], d);
 b = v[e + 16 >> 2];
 v[e + 12 >> 2] = v[e + 20 >> 2];
 pc(a, b, e + 12 | 0);
 eb = e + 32 | 0;
}

function zt(a) {
 var b = 0, c = 0;
 b = eb - 16 | 0;
 eb = b;
 c = -1;
 a: {
  if (At(a)) {
   break a;
  }
  if ((hb[v[a + 32 >> 2]](a, b + 15 | 0, 1) | 0) != 1) {
   break a;
  }
  c = w[b + 15 | 0];
 }
 eb = b + 16 | 0;
 return c;
}

function zO(a, b, c, d, e, f) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 f = f | 0;
 var g = 0, h = 0;
 g = eb - 32 | 0;
 eb = g;
 h = g + 8 | 0;
 ZL(h, b, c, d, e, f);
 Uc(a, g + 20 | 0);
 _m(h);
 eb = g + 32 | 0;
}

function Wia(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0;
 c = eb - 32 | 0;
 eb = c;
 u[c + 30 >> 1] = b;
 b = c + 30 | 0;
 Cp(c + 20 | 0, b);
 d = v[c + 20 >> 2];
 Cp(c + 12 | 0, b);
 pl(a, d, v[c + 16 >> 2]);
 eb = c + 32 | 0;
}

function x3(a, b, c, d, e, f) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 f = f | 0;
 if (kh(a, v[b + 8 >> 2], f)) {
  Wx(b, c, d, e);
  return;
 }
 a = v[a + 8 >> 2];
 hb[v[v[a >> 2] + 20 >> 2]](a, b, c, d, e, f);
}

function pW(a) {
 var b = 0, c = 0;
 c = v[a + 4 >> 2];
 b = v[a + 8 >> 2];
 while (1) {
  if ((b | 0) != (c | 0)) {
   b = b - 12 | 0;
   v[a + 8 >> 2] = b;
   continue;
  }
  break;
 }
 b = v[a >> 2];
 if (b) {
  vs(a);
  Bb(b);
 }
}

function kla(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0;
 c = eb - 32 | 0;
 eb = c;
 t[c + 31 | 0] = b;
 b = c + 31 | 0;
 Vr(c + 20 | 0, b);
 d = v[c + 20 >> 2];
 Vr(c + 12 | 0, b);
 pl(a, d, v[c + 16 >> 2]);
 eb = c + 32 | 0;
}

function KV(a) {
 var b = 0, c = 0;
 c = v[a + 4 >> 2];
 b = v[a + 8 >> 2];
 while (1) {
  if ((b | 0) != (c | 0)) {
   b = b - 32 | 0;
   v[a + 8 >> 2] = b;
   continue;
  }
  break;
 }
 b = v[a >> 2];
 if (b) {
  vs(a);
  Bb(b);
 }
}

function un(a) {
 var b = 0;
 b = 2147483647;
 a: {
  if (a >= 2147483647) {
   break a;
  }
  b = -2147483648;
  if (a <= -2147483648) {
   break a;
  }
  if (D(a) < 2147483648) {
   return ~~a;
  }
  b = -2147483648;
 }
 return b;
}

function _ta(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0;
 c = eb - 16 | 0;
 eb = c;
 v[c + 12 >> 2] = -1;
 if (dh(a, c + 11 | 0)) {
  v[c + 4 >> 2] = w[c + 11 | 0];
  Y$(a, b, v[Gb(c + 4 | 0, c + 12 | 0) >> 2]);
 }
 eb = c + 16 | 0;
}

function RV(a) {
 v[a >> 2] = 0;
 v[a + 4 >> 2] = 0;
 v[a + 88 >> 2] = 0;
 v[a + 8 >> 2] = 0;
 v[a + 12 >> 2] = 0;
 sC(a + 112 | 0, 48e3);
 v[a + 668 >> 2] = 0;
 qC(a + 724 | 0);
 qC(a + 732 | 0);
 qC(a + 740 | 0);
 Mg(a + 788 | 0);
}

function Fm(a) {
 a = a << 24 | (a & 65280) << 8 | (a >>> 8 & 65280 | a >>> 24);
 a = a >>> 4 & 252645135 | (a & 252645135) << 4;
 a = a >>> 2 & 858993459 | (a & 858993459) << 2;
 return a >>> 1 & 1431655765 | (a & 1431655765) << 1;
}

function oo(a, b) {
 v[a + 20 >> 2] = 0;
 v[a + 24 >> 2] = b;
 v[a + 12 >> 2] = 0;
 v[a + 4 >> 2] = 4098;
 v[a + 8 >> 2] = 6;
 v[a + 16 >> 2] = !b;
 Qb(a + 32 | 0, 0, 40);
 kL(a + 28 | 0);
 v[a + 72 >> 2] = 0;
 v[a + 76 >> 2] = -1;
}

function aF(a, b) {
 var c = 0;
 a: {
  if (!(w[a + 2 | 0] | w[a + 3 | 0] << 8) | (!w[a | 0] | !w[a + 1 | 0])) {
   break a;
  }
  c = 1;
  if (b >>> 0 < 9) {
   break a;
  }
  c = (w[a + 4 | 0] - 1 & 255) >>> 0 < 32;
 }
 return c;
}

function QG() {
 var a = 0, b = 0, c = 0;
 b = eb - 16 | 0;
 eb = b;
 a = Cc(b + 4 | 0, 14962);
 if (Zc(v[a + 4 >> 2], w[a + 11 | 0])) {
  c = (Sg(a, 13898) | 0) != -1;
 } else {
  c = 0;
 }
 sb(a);
 eb = b + 16 | 0;
 return c | 0;
}

function O0(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0;
 c = eb - 16 | 0;
 eb = c;
 v[c + 12 >> 2] = -1;
 if (dh(a, c + 11 | 0)) {
  v[c + 4 >> 2] = w[c + 11 | 0];
  C0(a, b, v[Gb(c + 4 | 0, c + 12 | 0) >> 2]);
 }
 eb = c + 16 | 0;
}

function UB(a, b, c) {
 var d = 0, e = 0, f = 0;
 d = Ol(a, b);
 if ((d | 0) != 255) {
  e = $b(a + 26 | 0, d), f = c, u[e >> 1] = f;
  a = a + 62 | 0;
  e = wb(a, b), f = 255, t[e | 0] = f;
  e = wb(a, c), f = d, t[e | 0] = f;
 }
}

function R5(a, b, c, d, e) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 a = eb - 16 | 0;
 eb = a;
 v[a + 12 >> 2] = e;
 v[a + 8 >> 2] = d - c;
 b = Gb(a + 12 | 0, a + 8 | 0);
 eb = a + 16 | 0;
 return v[b >> 2];
}

function JI(a, b) {
 var c = 0, d = 0;
 c = eb - 16 | 0;
 eb = c;
 d = qh(c + 12 | 0, b);
 b = a & 255;
 if (b >>> 0 >= 128) {
  b = (a | 0) == -1 ? -1 : v[v[124107] >> 2] ? -1 : a & 57343;
 }
 ph(d);
 eb = c + 16 | 0;
 return b;
}

function DH(a, b, c) {
 var d = 0;
 while (1) {
  if ((a | 0) != (b | 0)) {
   d = v[a >> 2];
   if (d >>> 0 <= 127) {
    d = v[(d << 2) + c >> 2];
   }
   v[a >> 2] = d;
   a = a + 4 | 0;
   continue;
  }
  break;
 }
 return b;
}

function nQ(a, b) {
 var c = 0;
 c = v[b + 4 >> 2];
 if (v[a >> 2] == (b | 0)) {
  v[a >> 2] = c;
 }
 a = v[b + 8 >> 2];
 if (c) {
  v[c + 8 >> 2] = a;
 }
 if (a) {
  v[a + 4 >> 2] = c;
 }
 v[b + 4 >> 2] = 0;
 v[b + 8 >> 2] = 0;
}

function mX(a) {
 var b = 0;
 if (!((w[a | 0] | w[a + 1 | 0] << 8 | (w[a + 2 | 0] << 16 | w[a + 3 | 0] << 24)) != 441273424 | w[a + 5 | 0] != 16 | (w[a + 54 | 0] - 33 & 255) >>> 0 < 224)) {
  b = w[a + 4 | 0] > 95;
 }
 return b;
}

function gm(a, b, c, d) {
 var e = 0;
 e = B(b, c);
 a: {
  if (v[d + 76 >> 2] < 0) {
   a = Rr(a, e, d);
   break a;
  }
  a = Rr(a, e, d);
 }
 if ((e | 0) == (a | 0)) {
  return b ? c : 0;
 }
 return (a >>> 0) / (b >>> 0) | 0;
}

function zP(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0;
 d = eb - 16 | 0;
 eb = d;
 c = hu(Dc(12));
 v[c + 8 >> 2] = b;
 v[c + 4 >> 2] = a;
 v[c >> 2] = 47436;
 a = xf(d + 12 | 0, c);
 eb = d + 16 | 0;
 return v[a >> 2];
}

function CL(a, b, c, d, e, f) {
 var g = 0, h = 0;
 g = v[a + 32 >> 2];
 if (!w[a + 23 | 0]) {
  v[(c << 2) + g >> 2] = b;
  return;
 }
 h = g;
 g = d << 2;
 v[h + g >> 2] = b;
 t[v[a + 8 >> 2] + d | 0] = e;
 v[f + g >> 2] = c;
}

function yn(a, b) {
 var c = 0, d = 0, e = 0;
 ew(a);
 v[a >> 2] = v[b >> 2];
 v[a + 4 >> 2] = v[b + 4 >> 2];
 c = zb(b);
 d = zb(a), e = v[c >> 2], v[d >> 2] = e;
 v[c >> 2] = 0;
 v[b >> 2] = 0;
 v[b + 4 >> 2] = 0;
 return a;
}

function le(a) {
 var b = 0;
 a = v[a + 4 >> 2];
 if (a) {
  if (sm(a)) {
   a: {
    b = a + 8 | 0;
    if (v[b >> 2]) {
     if ((mx(b) | 0) != -1) {
      break a;
     }
    }
    hb[v[v[a >> 2] + 16 >> 2]](a);
   }
  }
 }
}

function iW(a, b) {
 var c = 0, d = 0, e = 0;
 qr(a);
 v[a >> 2] = v[b >> 2];
 v[a + 4 >> 2] = v[b + 4 >> 2];
 c = zb(b);
 d = zb(a), e = v[c >> 2], v[d >> 2] = e;
 v[c >> 2] = 0;
 v[b >> 2] = 0;
 v[b + 4 >> 2] = 0;
 return a;
}

function iI(a, b, c, d, e) {
 var f = 0;
 f = c;
 c = 0;
 a: {
  if (!d) {
   break a;
  }
  c = b >> 8;
  if (!(b & 1)) {
   break a;
  }
  c = Tx(v[d >> 2], c);
 }
 hb[v[v[a >> 2] + 28 >> 2]](a, f, c + d | 0, b & 2 ? e : 2);
}

function Lt(a, b) {
 var c = 0, d = 0;
 a: {
  if (b >>> 0 <= 31) {
   d = v[a >> 2];
   c = a + 4 | 0;
   break a;
  }
  b = b - 32 | 0;
  c = a;
 }
 c = v[c >> 2];
 v[a >> 2] = d << b;
 v[a + 4 >> 2] = c << b | d >>> 32 - b;
}

function vp(a, b) {
 var c = 0;
 a: {
  if (!b) {
   break a;
  }
  if (!Lb(v[a >> 2], v[a + 8 >> 2], b)) {
   break a;
  }
  if (b >>> 0 <= 3) {
   c = BF(a, b);
   break a;
  }
  c = Qg(a);
  Ub(a, b - 4 | 0);
 }
 return c;
}

function mh(a, b) {
 var c = 0;
 if (ud(w[a + 11 | 0])) {
  c = v[a >> 2];
  Yi(v[a + 8 >> 2]);
  Bb(c);
 }
 c = v[b + 4 >> 2];
 v[a >> 2] = v[b >> 2];
 v[a + 4 >> 2] = c;
 v[a + 8 >> 2] = v[b + 8 >> 2];
 Me(b, 0);
 xd(b, 0);
}

function bP(a, b, c, d, e, f) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 f = f | 0;
 var g = 0, h = 0;
 g = eb - 32 | 0;
 eb = g;
 h = g + 8 | 0;
 ZL(h, b, c, d, e, f);
 Uc(a, h);
 _m(h);
 eb = g + 32 | 0;
}

function Ow(a, b) {
 var c = 0;
 a: {
  if (!b) {
   break a;
  }
  if (!Lb(v[a >> 2], v[a + 8 >> 2], b)) {
   break a;
  }
  if ((b | 0) == 1) {
   c = AF(a, 1);
   break a;
  }
  c = fh(a);
  Ub(a, b - 2 | 0);
 }
 return c;
}

function v4(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0;
 while (1) {
  if ((b | 0) != (c | 0)) {
   d = b, e = $x(v[b >> 2]), v[d >> 2] = e;
   b = b + 4 | 0;
   continue;
  }
  break;
 }
 return c | 0;
}

function t4(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0;
 while (1) {
  if ((b | 0) != (c | 0)) {
   d = b, e = ay(v[b >> 2]), v[d >> 2] = e;
   b = b + 4 | 0;
   continue;
  }
  break;
 }
 return c | 0;
}

function dT(a, b) {
 t[a + 840 | 0] = b;
 t[a + 812 | 0] = b;
 t[a + 811 | 0] = b;
 t[a + 809 | 0] = b;
 t[a + 807 | 0] = b;
 t[a + 806 | 0] = b;
 t[a + 833 | 0] = b;
 t[a + 826 | 0] = b >>> 4;
 t[a + 827 | 0] = b << 2 & 60;
}

function Nka(a, b) {
 a = a | 0;
 b = b | 0;
 a = zE(a, b);
 if (!a) {
  t[b + 6 | 0] = 0;
  t[b + 2 | 0] = 0;
  t[b + 3 | 0] = 0;
  t[b + 4 | 0] = 0;
  t[b + 5 | 0] = 0;
  t[b | 0] = 0;
  t[b + 1 | 0] = 0;
 }
 return a | 0;
}

function Kb(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0;
 d = eb - 16 | 0;
 eb = d;
 if (b >>> 0 >= 122) {
  Qq(12210);
  p();
 }
 e = d + 8 | 0;
 Ib(e, a, b);
 kf(e, c);
 eb = d + 16 | 0;
 return a | 0;
}

function Es(a, b, c, d) {
 var e = 0;
 e = cc(8);
 v[31601] = 0;
 a = O(d | 0, e | 0, a | 0) | 0;
 d = v[31601];
 v[31601] = 0;
 if ((d | 0) != 1) {
  ca(a | 0, c | 0, b | 0);
  p();
 }
 a = M() | 0;
 jc(e);
 P(a | 0);
 p();
}

function nn(a) {
 var b = 0, c = 0;
 c = v[a + 4 >> 2];
 b = v[a + 8 >> 2];
 while (1) {
  if ((b | 0) != (c | 0)) {
   b = b - 1 | 0;
   v[a + 8 >> 2] = b;
   continue;
  }
  break;
 }
 a = v[a >> 2];
 if (a) {
  Bb(a);
 }
}

function kT(a, b, c) {
 var d = 0, e = 0;
 v[b + 56 >> 2] = 0;
 d = b, e = Fo(a, x[b + 70 >> 1], v[b + 48 >> 2], c, 0), u[d + 68 >> 1] = e;
 if (!(!(w[a + 480180 | 0] & 5) | v[b + 60 >> 2] == -1)) {
  v[b + 60 >> 2] = 0;
 }
}

function QQ(a) {
 var b = 0, c = 0;
 b = eb - 16 | 0;
 eb = b;
 z[b + 12 >> 2] = D(a);
 v[b + 8 >> 2] = 646978941;
 v[b + 4 >> 2] = 1259902592;
 c = Sv(b + 12 | 0, b + 8 | 0, b + 4 | 0);
 eb = b + 16 | 0;
 return z[c >> 2];
}

function Mca(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0;
 if ((a | 0) != (b | 0)) {
  c = v[a + 4 >> 2];
  if (c) {
   Bb(c);
   v[a + 4 >> 2] = 0;
  }
  v[a + 4 >> 2] = v[b + 4 >> 2];
  v[b + 4 >> 2] = 0;
 }
 return a | 0;
}

function sS(a, b) {
 var c = 0, d = 0;
 c = eb - 16 | 0;
 eb = c;
 b = we(c + 8 | 0, Aua(b, b >> 31, 500654080, 20), gb);
 d = v[b >> 2];
 b = v[b + 4 >> 2];
 eb = c + 16 | 0;
 v[a >> 2] = d;
 v[a + 4 >> 2] = b;
 return a;
}

function f4(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0;
 while (1) {
  if ((b | 0) != (c | 0)) {
   d = b, e = nl(w[b | 0]), t[d | 0] = e;
   b = b + 1 | 0;
   continue;
  }
  break;
 }
 return c | 0;
}

function d4(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0;
 while (1) {
  if ((b | 0) != (c | 0)) {
   d = b, e = ut(w[b | 0]), t[d | 0] = e;
   b = b + 1 | 0;
   continue;
  }
  break;
 }
 return c | 0;
}

function Tba(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 a = iu(v[a + 32 >> 2], b, c, d, 2);
 if (a >>> 0 <= 15) {
  a = w[a + 42096 | 0];
 } else {
  a = 0;
 }
 return (a >>> 0 < 5 ? a + 1 | 0 : 0) | 0;
}

function Sba(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 a = iu(v[a + 32 >> 2], b, c, d, 3);
 if (a >>> 0 <= 46) {
  a = w[a + 42048 | 0];
 } else {
  a = 0;
 }
 return (a >>> 0 < 5 ? a + 1 | 0 : 0) | 0;
}

function Nt(a, b) {
 var c = 0, d = 0;
 c = v[a + 4 >> 2];
 a: {
  if (b >>> 0 <= 31) {
   d = v[a >> 2];
   break a;
  }
  b = b - 32 | 0;
  d = c;
  c = 0;
 }
 v[a + 4 >> 2] = c >>> b;
 v[a >> 2] = c << 32 - b | d >>> b;
}

function Sfa(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 if (!b) {
  Jz(a, 0, 0, 0, 0, 0, 0, c, d);
  return;
 }
 Jz(a, v[b >> 2], v[b + 4 >> 2], v[b + 8 >> 2], v[b + 12 >> 2], v[b + 24 >> 2], b, c, d);
}

function nf(a) {
 var b = 0, c = 0, d = 0;
 d = eb - 16 | 0;
 eb = d;
 b = ub(d + 12 | 0, a);
 c = v[b >> 2];
 if (v[c >> 2]) {
  Mc(c);
  b = v[b >> 2];
  c = v[b >> 2];
  jt(b);
  Bb(c);
 }
 eb = d + 16 | 0;
 return a;
}

function G0(a, b) {
 a = a | 0;
 b = b | 0;
 v[a + 4 >> 2] = b;
 t[a | 0] = 0;
 b = v[v[b >> 2] - 12 >> 2] + b | 0;
 if (!v[b + 16 >> 2]) {
  b = v[b + 72 >> 2];
  if (b) {
   sp(b);
  }
  t[a | 0] = 1;
 }
 return a | 0;
}

function E$(a, b, c) {
 var d = 0;
 d = eb - 16 | 0;
 eb = d;
 jm(d + 12 | 0, b);
 v[d + 8 >> 2] = w[d + 12 | 0] | w[d + 13 | 0] << 8 | (w[d + 14 | 0] << 16 | w[d + 15 | 0] << 24);
 dp(a, d + 8 | 0, c);
 eb = d + 16 | 0;
}

function hG(a) {
 a = a | 0;
 var b = 0;
 a = Eb(a);
 v[31601] = 0;
 Q(168, a + 12 | 0) | 0;
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  sc(a + 32 | 0);
  return a | 0;
 }
 b = M() | 0;
 sb(a);
 P(b | 0);
 p();
}

function I5(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 while (1) {
  if ((b | 0) != (c | 0)) {
   v[d >> 2] = t[b | 0];
   d = d + 4 | 0;
   b = b + 1 | 0;
   continue;
  }
  break;
 }
 return c | 0;
}

function DP(a, b) {
 var c = 0;
 if (a > .999999) {
  c = 0;
 } else {
  a = a * a;
  b = hf(31415.926535897932 / b);
  c = Ri(32768 / (1 - a) * (1 - (a * b + K((a + a) * (1 - b) - a * a * (1 - b * b)))));
 }
 return c;
}

function d_(a) {
 var b = 0, c = 0, d = 0;
 b = eb - 16 | 0;
 eb = b;
 c = b, d = _b(a), v[c + 12 >> 2] = d;
 v[b + 8 >> 2] = 236;
 a = ad(b + 12 | 0, b + 8 | 0);
 eb = b + 16 | 0;
 gb = 0;
 return v[a >> 2] - 216 | 0;
}

function bk(a, b, c) {
 var d = 0, e = 0, f = 0;
 d = eb - 16 | 0;
 eb = d;
 t[d + 15 | 0] = b;
 t[d + 14 | 0] = 127;
 e = a, f = w[Pb(d + 15 | 0, d + 14 | 0) | 0] | (c ? -128 : 0), t[e + 21 | 0] = f;
 eb = d + 16 | 0;
}

function ak(a, b, c) {
 var d = 0, e = 0, f = 0;
 d = eb - 16 | 0;
 eb = d;
 t[d + 15 | 0] = b;
 t[d + 14 | 0] = 127;
 e = a, f = w[Pb(d + 15 | 0, d + 14 | 0) | 0] | (c ? -128 : 0), t[e + 22 | 0] = f;
 eb = d + 16 | 0;
}

function Du(a, b, c) {
 c = c & 255;
 while (1) {
  a: {
   if (!b) {
    a = 0;
    break a;
   }
   if (lc(w[a | 0], c)) {
    break a;
   }
   b = b - 1 | 0;
   a = a + 1 | 0;
   continue;
  }
  break;
 }
 return a;
}

function A5(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 while (1) {
  if ((b | 0) != (c | 0)) {
   t[d | 0] = w[b | 0];
   d = d + 1 | 0;
   b = b + 1 | 0;
   continue;
  }
  break;
 }
 return c | 0;
}

function lE(a, b) {
 var c = 0, d = 0, e = 0;
 c = eb - 16 | 0;
 eb = c;
 u[c + 14 >> 1] = 1;
 d = c, e = am(a, b), u[d + 12 >> 1] = e;
 a = qe(c + 14 | 0, c + 12 | 0);
 eb = c + 16 | 0;
 return x[a >> 1] - 1 & 65535;
}

function Km(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0;
 d = Df(b);
 e = a;
 a = Cb(v[c + 4 >> 2], w[c + 11 | 0]);
 b = Cg(Jb(Iz(e, d + a | 0)), b, d) + d | 0;
 Zl(Cg(b, Jb(c), a) + a | 0, 1, 0);
}

function Sga(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = C(c);
 var d = 0;
 if (b >>> 0 <= 4) {
  c = Od(c, C(0));
  d = ((b << 2) + a | 0) + 4220 | 0;
  if ((b | 0) == 4) {
   c = ki(c);
  }
  z[d >> 2] = c;
  VP(a);
 }
}

function NX(a, b, c) {
 c = c & 65535;
 while (1) {
  a: {
   if ((a | 0) != (b | 0)) {
    if ((c | 0) != x[a >> 1]) {
     break a;
    }
   } else {
    a = b;
   }
   return a;
  }
  a = a + 2 | 0;
  continue;
 }
}

function Hl(a) {
 var b = 0, c = 0, d = 0;
 b = eb - 16 | 0;
 eb = b;
 c = v[a + 24 >> 2];
 d = v[a + 40 >> 2];
 v[b + 12 >> 2] = 1;
 a = ad(a + 20 | 0, b + 12 | 0);
 eb = b + 16 | 0;
 return B(v[a >> 2], c + d | 0);
}

function Vi(a, b) {
 var c = 0;
 c = v[a >> 2];
 if (_c(c, v[a + 4 >> 2]) >>> 0 > b >>> 0) {
  a = v[a + 24 >> 2];
  a = Ie(v[a + 484344 >> 2], v[a + 484348 >> 2], x[$b(c, b) >> 1]);
 } else {
  a = 0;
 }
 return a;
}

function BL(a, b) {
 a: {
  if (a & 255) {
   a = 1;
   if ((b | 0) != 255) {
    break a;
   }
   Z(14218, 13258, 1180, 5734);
   p();
  }
  if ((b | 0) == 255) {
   return 0;
  }
  a = b >>> 0 > 10;
 }
 return a;
}

function xR(a, b) {
 var c = 0;
 c = eb - 16 | 0;
 eb = c;
 ee(c + 8 | 0, a);
 ee(c, b);
 b = v[c >> 2];
 a = pZ(v[c + 8 >> 2], v[c + 12 >> 2], b, v[c + 4 >> 2]);
 eb = c + 16 | 0;
 return ud(a ? a >> 31 | 1 : 0);
}

function rW(a) {
 var b = 0, c = 0;
 c = eb - 16 | 0;
 eb = c;
 b = ub(c + 12 | 0, a);
 a = v[b >> 2];
 if (v[a >> 2]) {
  nW(a, v[a >> 2]);
  a = v[b >> 2];
  b = v[a >> 2];
  al(a);
  Bb(b);
 }
 eb = c + 16 | 0;
}

function Vu(a, b) {
 var c = 0;
 c = eb - 16 | 0;
 eb = c;
 ee(c + 8 | 0, a);
 ee(c, b);
 b = v[c >> 2];
 a = m_(v[c + 8 >> 2], v[c + 12 >> 2], b, v[c + 4 >> 2]);
 eb = c + 16 | 0;
 return ud(a ? a >> 31 | 1 : 0);
}

function Ne(a, b, c) {
 t[a + 11 | 0] = c;
 t[a + 10 | 0] = b;
 t[a + 12 | 0] = w[a + 12 | 0] & 251;
 u[a + 8 >> 1] = 65535;
 v[a >> 2] = 0;
 v[a + 4 >> 2] = 0;
 t[a + 12 | 0] = w[a + 12 | 0] & 252 | 1;
 return a;
}

function hga(a) {
 a = a | 0;
 var b = 0, c = C(0);
 t[a + 4202 | 0] = 1;
 b = a, c = DB(C(C(C(C(y[v[a + 16 >> 2] + 24620 >> 2]) / C(3)) + C(-80)) / C(15920)), C(0), C(1)), 
 z[b + 4272 >> 2] = c;
 MP(a);
 LP(a);
}

function dy(a, b) {
 var c = 0;
 c = eb - 16 | 0;
 eb = c;
 b = qh(c + 12 | 0, b);
 if (a >>> 0 >= 128) {
  a = (a & -128) != 57216 ? -1 : v[v[124107] >> 2] ? -1 : a & 255;
 }
 ph(b);
 eb = c + 16 | 0;
 return a;
}

function cia(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0;
 b = eb - 16 | 0;
 eb = b;
 c = v[a + 20 >> 2];
 oe(b, v[c + 4 >> 2], v[c + 8 >> 2]);
 sQ(a, Yb(b + 8 | 0, v[b >> 2], v[b + 4 >> 2]), 0);
 eb = b + 16 | 0;
}

function Kn(a, b) {
 var c = 0;
 a = On(a);
 v[a >> 2] = 78416;
 c = v[b + 8 >> 2];
 v[a + 4 >> 2] = v[b + 4 >> 2];
 v[a + 8 >> 2] = c;
 t[a + 16 | 0] = w[b + 16 | 0];
 v[a + 12 >> 2] = v[b + 12 >> 2];
 return a;
}

function Fg(a, b, c) {
 var d = 0;
 d = 4;
 a: {
  b: {
   switch (b - 1 | 0) {
   case 0:
    d = c;
    break a;

   case 1:
    break b;

   default:
    break a;
   }
  }
  d = c ? 3 : 2;
 }
 return Mo(a, d);
}

function u9(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0;
 c = b;
 b = v[b >> 2] + 7 & -8;
 v[c >> 2] = b + 16;
 d = a, e = Fx(v[b >> 2], v[b + 4 >> 2], v[b + 8 >> 2], v[b + 12 >> 2]), A[d >> 3] = e;
}

function ZV(a) {
 var b = 0;
 if (!(w[a + 35 | 0] & 2)) {
  a = a + 68 | 0;
  b = 9;
  while (1) {
   if (b) {
    v[a >> 2] = 268435456;
    b = b - 1 | 0;
    a = a + 4 | 0;
    continue;
   }
   break;
  }
 }
}

function V_(a) {
 var b = 0, c = 0, d = 0;
 c = eb - 16 | 0;
 eb = c;
 b = c + 13 | 0;
 ex(b, a);
 a = w[wb(b, 0) | 0];
 d = w[wb(b, 1) | 0];
 b = w[wb(b, 2) | 0];
 eb = c + 16 | 0;
 return d << 8 | a | b << 16;
}

function pi(a, b, c) {
 t[a | 0] = b;
 t[a + 1 | 0] = b >>> 8;
 t[a + 2 | 0] = b >>> 16;
 t[a + 3 | 0] = b >>> 24;
 t[a + 4 | 0] = c;
 t[a + 5 | 0] = c >>> 8;
 t[a + 6 | 0] = c >>> 16;
 t[a + 7 | 0] = c >>> 24;
}

function kL(a) {
 var b = 0, c = 0;
 v[31601] = 0;
 c = ba(1221) | 0;
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  b = a;
  a = v[c >> 2];
  v[b >> 2] = a;
  nm(a);
  return;
 }
 S(0) | 0;
 Rb();
 p();
}

function fd(a) {
 var b = 0;
 b = eb - 16 | 0;
 eb = b;
 v[b + 12 >> 2] = a;
 v[b + 8 >> 2] = -32768;
 v[b + 4 >> 2] = 32767;
 a = Ye(b + 8 | 0, Bd(b + 12 | 0, b + 4 | 0));
 eb = b + 16 | 0;
 return u[a >> 1];
}

function ag(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0;
 c = eb - 16 | 0;
 eb = c;
 if (b >>> 0 >= 122) {
  Qq(12175);
  p();
 }
 d = c + 8 | 0;
 Ib(d, a, b);
 kf(d, 0);
 eb = c + 16 | 0;
 return a | 0;
}

function _X(a) {
 u[a + 10 >> 1] = 0;
 u[a + 12 >> 1] = 0;
 u[a + 8 >> 1] = 1084;
 v[a >> 2] = 0;
 v[a + 4 >> 2] = 40;
 t[a + 13 | 0] = 0;
 t[a + 14 | 0] = 0;
 t[a + 15 | 0] = 0;
 t[a + 16 | 0] = 0;
 return a;
}

function Zf(a) {
 a = a | 0;
 var b = 0;
 v[a >> 2] = 42680;
 v[v[a + 20 >> 2] >> 2] = 0;
 b = v[a + 16 >> 2];
 v[b + 946300 >> 2] = v[b + 946300 >> 2] - 1;
 v[a + 20 >> 2] = 0;
 qQ(a + 44 | 0);
 return a | 0;
}

function Wha(a, b, c, d, e) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 if (!(!d | !Tc(c & 255))) {
  vQ(a, 8, C(0));
 }
 a = wj(a);
 if (a) {
  hb[v[v[a >> 2] + 96 >> 2]](a, b, c, d, e);
 }
}

function Fp(a, b, c) {
 var d = 0;
 a: {
  if (b >>> 0 > c >>> 0) {
   break a;
  }
  d = v[a >> 2];
  if (d >>> 0 >= b >>> 0) {
   b = c;
   if (d >>> 0 <= b >>> 0) {
    break a;
   }
  }
  v[a >> 2] = b;
 }
}

function Fe(a, b, c) {
 var d = 0;
 a: {
  if ((b | 0) > (c | 0)) {
   break a;
  }
  d = v[a >> 2];
  if ((d | 0) >= (b | 0)) {
   b = c;
   if ((d | 0) <= (b | 0)) {
    break a;
   }
  }
  v[a >> 2] = b;
 }
}

function qi(a) {
 var b = 0;
 while (1) {
  a: {
   if ((b | 0) != 47) {
    if (w[b + 42128 | 0] != (a | 0)) {
     break a;
    }
   } else {
    b = 0;
   }
   return b;
  }
  b = b + 1 | 0;
  continue;
 }
}

function cD(a, b, c, d) {
 var e = 0, f = 0, g = 0, h = 0;
 e = eb - 16 | 0;
 eb = e;
 f = b;
 b = c - b | 0;
 g = e, h = YC(d, f, b >> 2) + b | 0, v[g + 12 >> 2] = h;
 pc(a, c, e + 12 | 0);
 eb = e + 16 | 0;
}

function UU(a, b, c, d) {
 var e = 0, f = 0, g = 0, h = 0;
 e = eb - 16 | 0;
 eb = e;
 f = b;
 b = c - b | 0;
 g = e, h = TU(d, f, b >> 1) + b | 0, v[g + 12 >> 2] = h;
 pc(a, c, e + 12 | 0);
 eb = e + 16 | 0;
}

function Kka(a) {
 a = a | 0;
 var b = 0;
 b = v[a >> 2];
 if (hb[v[v[b >> 2] + 32 >> 2]](b, 0, 32) | 0) {
  a = v[a >> 2];
  a = hb[v[v[a >> 2] + 32 >> 2]](a, 32, 1) ^ 1;
 } else {
  a = 0;
 }
 return a | 0;
}

function GO(a, b) {
 var c = 0, d = 0;
 a: {
  if (!Vt(b)) {
   break a;
  }
  c = v[a + 484344 >> 2];
  if (!Ie(c, v[a + 484348 >> 2], b & 65535)) {
   break a;
  }
  d = v[Vb(c, b) + 12 >> 2];
 }
 return d;
}

function ska(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0;
 c = eb - 16 | 0;
 eb = c;
 if (b >>> 0 >= 250) {
  Qq(12210);
  p();
 }
 d = c + 8 | 0;
 Ib(d, a, b);
 ap(d);
 eb = c + 16 | 0;
 return a | 0;
}

function EC(a, b) {
 var c = 0, d = 0;
 v[a >> 2] = v[b >> 2];
 v[a + 4 >> 2] = v[b + 4 >> 2];
 v[a + 8 >> 2] = v[b + 8 >> 2];
 v[b >> 2] = 0;
 v[b + 4 >> 2] = 0;
 c = zb(b), d = 0, v[c >> 2] = d;
 return a;
}

function yb(a, b) {
 var c = 0;
 if (ud(w[a + 11 | 0])) {
  Bb(v[a >> 2]);
 }
 c = v[b + 4 >> 2];
 v[a >> 2] = v[b >> 2];
 v[a + 4 >> 2] = c;
 v[a + 8 >> 2] = v[b + 8 >> 2];
 Me(b, 0);
 gd(b, 0);
 return a;
}

function vr(a) {
 var b = 0;
 b = -1;
 a: {
  if (a >= 4294967295) {
   break a;
  }
  b = 0;
  if (a <= 0) {
   break a;
  }
  if (a < 4294967296 & a >= 0) {
   return ~~a >>> 0;
  }
  b = 0;
 }
 return b;
}

function qI(a, b, c) {
 var d = 0;
 if (c) {
  d = a;
  while (1) {
   v[d >> 2] = v[b >> 2];
   d = d + 4 | 0;
   b = b + 4 | 0;
   c = c - 1 | 0;
   if (c) {
    continue;
   }
   break;
  }
 }
 return a;
}

function oka(a, b) {
 a = a | 0;
 b = b | 0;
 a = jB(a);
 v[31601] = 0;
 N(843, a | 0, b | 0);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) == 1) {
  b = M() | 0;
  Hq(a);
  P(b | 0);
  p();
 }
 return a | 0;
}

function nY(a) {
 var b = 0;
 if (!(id(a, 15004, 3) | (w[a + 4 | 0] | w[a + 5 | 0] << 8 | (w[a + 6 | 0] << 16 | w[a + 7 | 0] << 24)) - 2147483647 >>> 0 < 2147484072)) {
  b = w[a + 3 | 0] < 6;
 }
 return b;
}

function jT(a, b, c, d) {
 a: {
  if (d >>> 0 >= 64) {
   d = -1;
   if (w[a + 480180 | 0] & 2) {
    break a;
   }
  }
  v[b + 56 >> 2] = 0;
  d = Fo(a, x[b + 70 >> 1], v[b + 48 >> 2], c, 0);
 }
 return d;
}

function Rc(a, b, c) {
 var d = 0;
 d = a;
 a = c & 31;
 if ((c & 63) >>> 0 >= 32) {
  c = b >> 31;
  a = b >> a;
 } else {
  c = b >> a;
  a = ((1 << a) - 1 & b) << 32 - a | d >>> a;
 }
 gb = c;
 return a;
}

function p9(a) {
 a = a | 0;
 var b = 0;
 if ((hb[v[v[a >> 2] + 36 >> 2]](a) | 0) != -1) {
  b = a;
  a = v[a + 12 >> 2];
  v[b + 12 >> 2] = a + 1;
  a = yf(t[a | 0]);
 } else {
  a = -1;
 }
 return a | 0;
}

function Hu(a, b, c) {
 var d = 0;
 d = eb - 16 | 0;
 eb = d;
 b = we(d + 8 | 0, Aua(b, c, 1e6, 0), gb);
 c = v[b >> 2];
 b = v[b + 4 >> 2];
 eb = d + 16 | 0;
 v[a >> 2] = c;
 v[a + 4 >> 2] = b;
 return a;
}

function HU(a, b, c, d, e) {
 v[a + 12 >> 2] = e;
 v[a + 8 >> 2] = d;
 v[a + 4 >> 2] = c;
 v[a >> 2] = b;
 if (b) {
  Ad(b, a);
 }
 if (c) {
  Ad(c, a);
 }
 if (d) {
  Ad(d, a);
 }
 if (e) {
  Ad(e, a);
 }
}

function yc(a, b, c) {
 var d = 0;
 if (c) {
  d = a;
  while (1) {
   t[d | 0] = w[b | 0];
   d = d + 1 | 0;
   b = b + 1 | 0;
   c = c - 1 | 0;
   if (c) {
    continue;
   }
   break;
  }
 }
 return a;
}

function bY(a) {
 var b = 0;
 b = eb - 16 | 0;
 eb = b;
 v[b + 12 >> 2] = a;
 v[b + 8 >> 2] = -128;
 v[b + 4 >> 2] = 127;
 a = Ye(b + 8 | 0, Bd(b + 12 | 0, b + 4 | 0));
 eb = b + 16 | 0;
 return t[a | 0];
}

function Ws(a) {
 if (a >>> 0 <= 254) {
  return (a + 1 & 127) >>> 0 > 32;
 }
 return (a & 65534) != 65534 & a - 65532 >>> 0 < 1048580 | (a - 57344 >>> 0 < 8185 | a >>> 0 < 8232 | a - 8234 >>> 0 < 47062);
}

function NZ(a, b, c) {
 var d = 0;
 while (1) {
  if (b) {
   d = w[c | 0] | w[c + 1 | 0] << 8;
   t[a | 0] = d;
   t[a + 1 | 0] = d >>> 8;
   b = b - 1 | 0;
   a = a + 2 | 0;
   continue;
  }
  break;
 }
}

function f6(a) {
 a = a | 0;
 if (w[499912]) {
  return v[124977];
 }
 if (!w[501064]) {
  t[501064] = 1;
 }
 vd(501040, 104212);
 vd(501052, 104224);
 t[499912] = 1;
 v[124977] = 501040;
 return 501040;
}

function dv(a, b, c, d) {
 var e = 0, f = 0, g = 0, h = 0;
 e = eb - 16 | 0;
 eb = e;
 f = b;
 b = c - b | 0;
 g = e, h = dC(d, f, b) + b | 0, v[g + 12 >> 2] = h;
 pc(a, c, e + 12 | 0);
 eb = e + 16 | 0;
}

function aH(a, b, c) {
 a = ki(a);
 a: {
  if (a >= b) {
   break a;
  }
  c = 0;
  if (a <= C(0)) {
   break a;
  }
  if (a < C(4294967296) & a >= C(0)) {
   c = ~~a >>> 0;
   break a;
  }
 }
 return c;
}

function zC(a) {
 var b = 0, c = 0;
 c = eb - 16 | 0;
 eb = c;
 a = ub(c + 12 | 0, a);
 b = v[a >> 2];
 if (v[b >> 2]) {
  Mc(b);
  a = v[a >> 2];
  b = v[a >> 2];
  al(a);
  Bb(b);
 }
 eb = c + 16 | 0;
}

function uv(a) {
 var b = 0, c = 0;
 c = eb - 16 | 0;
 eb = c;
 a = ub(c + 12 | 0, a);
 b = v[a >> 2];
 if (v[b >> 2]) {
  Mc(b);
  a = v[a >> 2];
  b = v[a >> 2];
  pC(a);
  Bb(b);
 }
 eb = c + 16 | 0;
}

function pu(a) {
 var b = 0, c = 0;
 c = eb - 16 | 0;
 eb = c;
 a = ub(c + 12 | 0, a);
 b = v[a >> 2];
 if (v[b >> 2]) {
  Mc(b);
  a = v[a >> 2];
  b = v[a >> 2];
  eA(a);
  Bb(b);
 }
 eb = c + 16 | 0;
}

function oS(a) {
 var b = 0, c = 0;
 c = eb - 16 | 0;
 eb = c;
 a = ub(c + 12 | 0, a);
 b = v[a >> 2];
 if (v[b >> 2]) {
  Mc(b);
  a = v[a >> 2];
  b = v[a >> 2];
  k$(a);
  Bb(b);
 }
 eb = c + 16 | 0;
}

function je(a) {
 var b = 0, c = 0;
 c = eb - 16 | 0;
 eb = c;
 a = ub(c + 12 | 0, a);
 b = v[a >> 2];
 if (v[b >> 2]) {
  W$(b);
  a = v[a >> 2];
  b = v[a >> 2];
  sE(a);
  Bb(b);
 }
 eb = c + 16 | 0;
}

function hd(a, b) {
 var c = 0, d = 0, e = 0;
 c = ih(a, b);
 if (c) {
  v[a + 12 >> 2] = v[a + 12 >> 2] + b;
  return c;
 }
 d = a, e = hb[v[v[a >> 2] + 24 >> 2]](a) | 0, v[d + 12 >> 2] = e;
 return c;
}

function fS(a) {
 var b = 0, c = 0;
 c = eb - 16 | 0;
 eb = c;
 a = ub(c + 12 | 0, a);
 b = v[a >> 2];
 if (v[b >> 2]) {
  Fu(b);
  a = v[a >> 2];
  b = v[a >> 2];
  Eu(a);
  Bb(b);
 }
 eb = c + 16 | 0;
}

function d9(a) {
 a = a | 0;
 var b = 0;
 if ((hb[v[v[a >> 2] + 36 >> 2]](a) | 0) != -1) {
  b = a;
  a = v[a + 12 >> 2];
  v[b + 12 >> 2] = a + 4;
  a = v[a >> 2];
 } else {
  a = -1;
 }
 return a | 0;
}

function cU(a) {
 var b = 0, c = 0;
 c = eb - 16 | 0;
 eb = c;
 a = ub(c + 12 | 0, a);
 b = v[a >> 2];
 if (v[b >> 2]) {
  ZT(b);
  a = v[a >> 2];
  b = v[a >> 2];
  al(a);
  Bb(b);
 }
 eb = c + 16 | 0;
}

function av(a) {
 var b = 0, c = 0, d = 0;
 d = a * a;
 a = 0;
 b = 1;
 c = 1;
 while (1) {
  a = a + 2;
  c = d * c / (a * a);
  b = b + c;
  if (b * 1e-7 < c) {
   continue;
  }
  break;
 }
 return b;
}

function aC(a) {
 var b = 0, c = 0;
 c = eb - 16 | 0;
 eb = c;
 a = ub(c + 12 | 0, a);
 b = v[a >> 2];
 if (v[b >> 2]) {
  NU(b);
  a = v[a >> 2];
  b = v[a >> 2];
  Yo(a);
  Bb(b);
 }
 eb = c + 16 | 0;
}

function _R(a) {
 var b = 0, c = 0;
 c = eb - 16 | 0;
 eb = c;
 a = ub(c + 12 | 0, a);
 b = v[a >> 2];
 if (v[b >> 2]) {
  Lp(b);
  a = v[a >> 2];
  b = v[a >> 2];
  hx(a);
  Bb(b);
 }
 eb = c + 16 | 0;
}

function Zo(a) {
 var b = 0, c = 0;
 c = eb - 16 | 0;
 eb = c;
 a = ub(c + 12 | 0, a);
 b = v[a >> 2];
 if (v[b >> 2]) {
  Mc(b);
  a = v[a >> 2];
  b = v[a >> 2];
  MY(a);
  Bb(b);
 }
 eb = c + 16 | 0;
}

function Pi(a) {
 var b = 0, c = 0;
 c = eb - 16 | 0;
 eb = c;
 a = ub(c + 12 | 0, a);
 b = v[a >> 2];
 if (v[b >> 2]) {
  Mc(b);
  a = v[a >> 2];
  b = v[a >> 2];
  Yo(a);
  Bb(b);
 }
 eb = c + 16 | 0;
}

function JT(a) {
 var b = 0, c = 0;
 c = eb - 16 | 0;
 eb = c;
 a = ub(c + 12 | 0, a);
 b = v[a >> 2];
 if (v[b >> 2]) {
  Mc(b);
  a = v[a >> 2];
  b = v[a >> 2];
  IB(a);
  Bb(b);
 }
 eb = c + 16 | 0;
}

function hi(a, b) {
 var c = 0, d = 0;
 c = v[a >> 2];
 d = v[a + 4 >> 2];
 b = v[a + 16 >> 2] + b | 0;
 a = v[a + 12 >> 2];
 b = (b | 0) % (a | 0) | 0;
 return z[Oc(c, d, (b >> 31 & a) + b | 0) >> 2];
}

function _5(a) {
 a = a | 0;
 if (w[499904]) {
  return v[124975];
 }
 if (!w[501032]) {
  t[501032] = 1;
 }
 kd(501008, 13897);
 kd(501020, 13876);
 t[499904] = 1;
 v[124975] = 501008;
 return 501008;
}

function Ul(a, b) {
 var c = 0;
 a: {
  if (y[a + 12 >> 2] < b >>> 0) {
   c = 0;
   if (!(hb[v[v[a >> 2] + 32 >> 2]](a, 0, b) | 0)) {
    break a;
   }
  }
  v[a + 12 >> 2] = b;
  c = 1;
 }
 return c;
}

function Dh(a) {
 var b = 0;
 b = eb - 16 | 0;
 eb = b;
 v[b + 12 >> 2] = a;
 v[b + 8 >> 2] = 0;
 v[b + 4 >> 2] = 255;
 a = Ye(b + 8 | 0, Bd(b + 12 | 0, b + 4 | 0));
 eb = b + 16 | 0;
 return w[a | 0];
}

function CW(a) {
 var b = 0, c = 0;
 while (1) {
  b = c;
  if ((b | 0) != 8) {
   c = b + 1 | 0;
   if ((w[a + b | 0] - 32 & 255) >>> 0 < 95) {
    continue;
   }
  }
  break;
 }
 return (b | 0) == 8;
}

function QA(a) {
 if (w[a + 480224 | 0] == 2) {
  return +y[a + 1074420 >> 2] / 1e4;
 }
 return +y[a + 24620 >> 2] / (+y[a + 1074404 >> 2] * +(B(v[a + 1074408 >> 2], v[a + 1074416 >> 2]) >>> 0)) * 60;
}

function $C(a) {
 var b = 0;
 b = Ab(w[a + 26 | 0] | w[a + 27 | 0] << 8);
 return ((w[a + 24 | 0] > 15) + (w[a + 25 | 0] > 64) | 0) + (Ab(w[a + 22 | 0] | w[a + 23 | 0] << 8) << 1 >>> 0 < b >>> 0) | 0;
}

function vt(a, b) {
 a: {
  if ((a | 0) == (b | 0)) {
   break a;
  }
  while (1) {
   b = b - 4 | 0;
   if (b >>> 0 <= a >>> 0) {
    break a;
   }
   Sb(a, b);
   a = a + 4 | 0;
   continue;
  }
 }
}

function NY(a, b) {
 var c = 0;
 c = eb - 16 | 0;
 eb = c;
 a = wh(c + 4 | 0, a, 1);
 bp(v[a + 4 >> 2], x[b >> 1] | x[b + 2 >> 1] << 16);
 v[a + 4 >> 2] = v[a + 4 >> 2] + 4;
 hc(a);
 eb = c + 16 | 0;
}

function Bm(a, b) {
 a: {
  if ((a | 0) == (b | 0)) {
   break a;
  }
  while (1) {
   b = b - 1 | 0;
   if (b >>> 0 <= a >>> 0) {
    break a;
   }
   qg(a, b);
   a = a + 1 | 0;
   continue;
  }
 }
}

function wH(a, b, c) {
 var d = 0;
 d = eb - 16 | 0;
 eb = d;
 v[d + 8 >> 2] = a;
 v[d + 12 >> 2] = b;
 v[d >> 2] = c;
 v[d + 4 >> 2] = 0;
 a = Wr(d + 8 | 0, d);
 eb = d + 16 | 0;
 return v[a >> 2];
}

function yi(a) {
 var b = 0, c = 0;
 b = a * a;
 c = b * a;
 return C(c * (b * b) * (b * 2718311493989822e-21 + -.00019839334836096632) + (c * (b * .008333329385889463 + -.16666666641626524) + a));
}

function yY(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0;
 c = eb - 16 | 0;
 eb = c;
 u[c + 14 >> 1] = b;
 if ((am(v[a >> 2], v[a + 4 >> 2]) | 0) != 65535) {
  t0(a, c + 14 | 0);
 }
 eb = c + 16 | 0;
}

function or(a, b, c, d, e, f, g, h) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 f = f | 0;
 g = g | 0;
 h = h | 0;
 return hb[v[v[a >> 2] + 12 >> 2]](a, b, c, d, e, f, g, h) | 0;
}

function TM(a, b, c) {
 while (1) {
  a: {
   if ((a | 0) != (b | 0)) {
    if (!Md(c, v[a >> 2])) {
     break a;
    }
   } else {
    a = b;
   }
   return a;
  }
  a = a + 8 | 0;
  continue;
 }
}

function jK(a, b, c, d, e, f) {
 a = hb[v[v[a + 8 >> 2] + 4 >> 2]](a + 8 | 0) | 0;
 a = yt(c, d, a, a + 288 | 0, f, e, 0) - a | 0;
 if ((a | 0) <= 287) {
  v[b >> 2] = ((a | 0) / 12 | 0) % 12;
 }
}

function ff(a) {
 var b = 0;
 b = v[a + 32 >> 2];
 a: {
  if (b >>> 0 >= y[a + 40 >> 2]) {
   v[a + 96 >> 2] = 1;
   a = 0;
   break a;
  }
  v[a + 32 >> 2] = b + 1;
  a = w[b | 0];
 }
 return a;
}

function fK(a, b, c, d, e, f) {
 a = hb[v[v[a + 8 >> 2] + 4 >> 2]](a + 8 | 0) | 0;
 a = tt(c, d, a, a + 288 | 0, f, e, 0) - a | 0;
 if ((a | 0) <= 287) {
  v[b >> 2] = ((a | 0) / 12 | 0) % 12;
 }
}

function dF(a) {
 var b = 0;
 b = 0;
 a: {
  if (id(a, 14188, 3)) {
   break a;
  }
  a = w[a + 3 | 0];
  b = 1;
  if ((a | 0) == 1) {
   break a;
  }
  b = (a - 8 & 255) >>> 0 < 7;
 }
 return b;
}

function V2(a, b, c, d, e, f, g) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 f = f | 0;
 g = g | 0;
 var h = 0;
 h = b;
 b = 0;
 return hb[a | 0](h | b, c, d, e, b | f, g) | 0;
}

function BC(a) {
 a = 50 - (B(w[(a >>> 4 | 0) + 29840 | 0], a & 15) >>> 4 | 0) | 0;
 a = a >>> 0 > 23863 ? 65536 : 23863 / (a >>> 0) | 0;
 return Fc((a + 119315e4 >>> 0) / (a << 1 >>> 0) | 0, 0);
}

function v3(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 if (kh(a, v[b + 8 >> 2], 0)) {
  Ux(b, c, d);
  return;
 }
 a = v[a + 8 >> 2];
 hb[v[v[a >> 2] + 28 >> 2]](a, b, c, d);
}

function fH(a, b, c) {
 a = Ee(a);
 a: {
  if (a >= b) {
   break a;
  }
  c = 0;
  if (a <= 0) {
   break a;
  }
  if (a < 4294967296 & a >= 0) {
   c = ~~a >>> 0;
   break a;
  }
 }
 return c;
}

function Zx(a, b) {
 var c = 0, d = 0, e = 0, f = 0;
 c = Df(b);
 d = Dc(c + 13 | 0);
 v[d + 8 >> 2] = 0;
 v[d + 4 >> 2] = c;
 v[d >> 2] = c;
 e = a, f = yc(mc(d), b, c + 1 | 0), v[e >> 2] = f;
}

function Vy(a) {
 a = a | 0;
 var b = 0;
 b = v[a + 12 >> 2];
 if ((b | 0) == v[a + 16 >> 2]) {
  return hb[v[v[a >> 2] + 40 >> 2]](a) | 0;
 }
 v[a + 12 >> 2] = b + 1;
 return yf(t[b | 0]) | 0;
}

function Qfa(a) {
 a = a | 0;
 var b = 0;
 b = eb - 16 | 0;
 eb = b;
 if (a) {
  a = oc(b + 8 | 0, a);
  a = Tz(v[a >> 2], v[a + 4 >> 2]);
 } else {
  a = 0;
 }
 eb = b + 16 | 0;
 return a | 0;
}

function $X(a, b) {
 var c = 0;
 c = eb - 16 | 0;
 eb = c;
 a: {
  if (!ih(a, 4)) {
   rD(b);
   break a;
  }
  lh(c + 8 | 0, b);
  _C(c, a, v[c + 8 >> 2], v[c + 12 >> 2]);
 }
 eb = c + 16 | 0;
}

function yT(a) {
 vB(a);
 v[a >> 2] = 0;
 v[a + 4 >> 2] = 0;
 v[a + 16 >> 2] = 0;
 v[a + 20 >> 2] = 0;
 v[a + 8 >> 2] = 0;
 v[a + 12 >> 2] = 0;
 a = ng(a);
 ng(a + 12 | 0);
 t[a + 24 | 0] = 1;
}

function fz(a, b, c) {
 var d = 0;
 d = v[a + 32 >> 2];
 if (y[a + 40 >> 2] < d + c >>> 0) {
  v[a + 96 >> 2] = 1;
  return 0;
 }
 yc(b, d, c);
 v[a + 32 >> 2] = v[a + 32 >> 2] + c;
 return 1;
}

function cG(a, b) {
 var c = 0;
 c = v[b + 4 >> 2];
 if (c) {
  ac(a, c, v[b >> 2]);
  return;
 }
 c = v[b + 8 >> 2];
 b = v[b + 12 >> 2];
 if (!lc(c, b)) {
  oe(a, c, b);
  return;
 }
 Ld(a);
}

function eO(a) {
 a = a | 0;
 var b = 0, c = 0;
 b = eb - 16 | 0;
 eb = b;
 c = hu(Dc(8));
 v[c + 4 >> 2] = a;
 v[c >> 2] = 48384;
 a = xf(b + 12 | 0, c);
 eb = b + 16 | 0;
 return v[a >> 2];
}

function YM(a) {
 a = a | 0;
 var b = 0, c = 0;
 b = eb - 16 | 0;
 eb = b;
 c = JM(Dc(8));
 v[c + 4 >> 2] = a;
 v[c >> 2] = 73416;
 a = xf(b + 12 | 0, c);
 eb = b + 16 | 0;
 return v[a >> 2];
}

function kK(a, b, c, d, e, f) {
 a = hb[v[v[a + 8 >> 2] >> 2]](a + 8 | 0) | 0;
 a = yt(c, d, a, a + 168 | 0, f, e, 0) - a | 0;
 if ((a | 0) <= 167) {
  v[b >> 2] = ((a | 0) / 12 | 0) % 7;
 }
}

function gK(a, b, c, d, e, f) {
 a = hb[v[v[a + 8 >> 2] >> 2]](a + 8 | 0) | 0;
 a = tt(c, d, a, a + 168 | 0, f, e, 0) - a | 0;
 if ((a | 0) <= 167) {
  v[b >> 2] = ((a | 0) / 12 | 0) % 7;
 }
}

function W$(a) {
 var b = 0, c = 0;
 c = v[a >> 2];
 b = v[a + 4 >> 2];
 while (1) {
  if ((b | 0) != (c | 0)) {
   b = b - 28 | 0;
   Gd(b);
   continue;
  }
  break;
 }
 v[a + 4 >> 2] = c;
}

function Lp(a) {
 var b = 0, c = 0;
 c = v[a >> 2];
 b = v[a + 4 >> 2];
 while (1) {
  if ((b | 0) != (c | 0)) {
   b = b - 36 | 0;
   Hp(b);
   continue;
  }
  break;
 }
 v[a + 4 >> 2] = c;
}

function Hta(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0;
 b = eb - 80 | 0;
 eb = b;
 c = -1;
 d = a;
 a = b + 14 | 0;
 if (D$(d, a)) {
  c = C$(a);
 }
 eb = b + 80 | 0;
 return c | 0;
}

function iua(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0;
 b = eb - 16 | 0;
 eb = b;
 c = -1;
 d = a;
 a = b + 8 | 0;
 if (gk(d, a)) {
  c = g0(a);
 }
 eb = b + 16 | 0;
 return c | 0;
}

function dH(a, b, c, d) {
 a = Mb(a);
 v[31601] = 0;
 R(d | 0, a | 0, b | 0, c | 0);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) != 1) {
  return a;
 }
 b = M() | 0;
 uc(a);
 P(b | 0);
 p();
}

function Ppa(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0;
 b = eb - 16 | 0;
 eb = b;
 c = -1;
 d = a;
 a = b + 4 | 0;
 if (dE(d, a)) {
  c = GX(a);
 }
 eb = b + 16 | 0;
 return c | 0;
}

function FC(a, b) {
 var c = 0;
 c = eb - 16 | 0;
 eb = c;
 a = Yb(c + 8 | 0, (b >>> 3 & 536870908) + a | 0, 1 << b);
 a = Fb(v[v[a >> 2] >> 2], v[a + 4 >> 2]);
 eb = c + 16 | 0;
 return a;
}

function Dqa(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0;
 b = eb - 16 | 0;
 eb = b;
 c = -1;
 d = a;
 a = b + 8 | 0;
 if (gk(d, a)) {
  c = nY(a);
 }
 eb = b + 16 | 0;
 return c | 0;
}

function Bl(a, b, c, d) {
 var e = 0;
 e = v[b + 4 >> 2];
 v[a >> 2] = v[b >> 2];
 v[a + 4 >> 2] = e;
 e = v[b + 12 >> 2];
 v[a + 8 >> 2] = v[b + 8 >> 2];
 v[a + 12 >> 2] = e;
 AA(a, c, d);
}

function BS(a, b, c, d) {
 qB(a, a + 1074376 | 0, b, c, d);
 c = 0 - w[(B(b, 872) + a | 0) + 1075804 | 0] | 0;
 if (d) {
  d = 0;
 } else {
  d = Ku(v[a + 480180 >> 2]);
 }
 zo(a, b, c, d);
}

function kp(a) {
 v[a + 32 >> 2] = 0;
 v[a + 24 >> 2] = 0;
 v[a + 28 >> 2] = 0;
 v[a >> 2] = 0;
 v[a + 4 >> 2] = 0;
 v[a + 8 >> 2] = 0;
 v[a + 12 >> 2] = 0;
 v[a + 16 >> 2] = 0;
 return a;
}

function _U(a, b, c, d, e, f, g) {
 t[a + 17 | 0] = g;
 t[a + 16 | 0] = f;
 v[a + 12 >> 2] = e;
 v[a + 8 >> 2] = d;
 v[a + 4 >> 2] = c;
 v[a >> 2] = b;
 if (d) {
  ZU(a, 1);
  ZU(a, 0);
 }
}

function JC(a) {
 v[a >> 2] = 0;
 v[a + 4 >> 2] = 0;
 v[a + 24 >> 2] = 0;
 v[a + 28 >> 2] = 0;
 v[a + 16 >> 2] = 0;
 v[a + 20 >> 2] = 0;
 v[a + 8 >> 2] = 0;
 v[a + 12 >> 2] = 0;
 return a;
}

function $U(a, b, c, d, e, f, g) {
 t[a + 17 | 0] = g;
 t[a + 16 | 0] = f;
 v[a + 12 >> 2] = e;
 v[a + 8 >> 2] = d;
 v[a + 4 >> 2] = c;
 v[a >> 2] = b;
 if (d) {
  YU(a, 1);
  YU(a, 0);
 }
}

function wia(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = C(c);
 var d = 0, e = 0;
 if (b >>> 0 <= 3) {
  d = (a + b | 0) + 4264 | 0, e = Ah(C(Od(c, C(0)) * C(255))), t[d | 0] = e;
  tu(a);
 }
}

function p8(a) {
 a = a | 0;
 var b = 0, c = 0;
 c = v[a + 4 >> 2];
 b = v[a >> 2];
 a = v[a + 8 >> 2];
 b = b + (a >> 1) | 0;
 if (a & 1) {
  c = v[c + v[b >> 2] >> 2];
 }
 hb[c | 0](b);
}

function _G(a, b) {
 v[a >> 2] = b;
 kL(a + 4 | 0);
 v[a + 24 >> 2] = 0;
 v[a + 28 >> 2] = 0;
 v[a + 16 >> 2] = 0;
 v[a + 20 >> 2] = 0;
 v[a + 8 >> 2] = 0;
 v[a + 12 >> 2] = 0;
 return a;
}

function Nr(a, b) {
 return qn(w[b | 0] | w[b + 1 | 0] << 8 | (w[b + 2 | 0] << 16 | w[b + 3 | 0] << 24), w[a | 0] | w[a + 1 | 0] << 8 | (w[a + 2 | 0] << 16 | w[a + 3 | 0] << 24)) ? b : a;
}

function MG(a) {
 a = a | 0;
 var b = 0;
 a = Eb(a);
 v[31601] = 0;
 N(130, a | 0, 13724);
 b = v[31601];
 v[31601] = 0;
 if ((b | 0) == 1) {
  b = M() | 0;
  sb(a);
  P(b | 0);
  p();
 }
}

function Cha(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = C(c);
 var d = 0, e = 0;
 if (b >>> 0 <= 2) {
  d = (a + b | 0) + 4232 | 0, e = Ah(C(Od(c, C(0)) * C(127))), t[d | 0] = e;
  nu(a);
 }
}

function ii(a, b) {
 var c = 0, d = 0, e = 0;
 o(+a);
 c = j(1) | 0;
 d = j(0) | 0;
 o(+b);
 e = j(1) | 0;
 j(0) | 0;
 l(0, d | 0);
 l(1, c & 2147483647 | e & -2147483648);
 return +n();
}

function xH(a, b) {
 var c = 0, d = 0;
 c = a + 68 | 0;
 a = 0;
 while (1) {
  if ((a | 0) != 9) {
   d = xb(c, a);
   a = a + 1 | 0;
   v[d >> 2] = a << b;
   continue;
  }
  break;
 }
}

function ru(a) {
 var b = 0;
 b = A[a + 4248 >> 3] / +y[v[a + 16 >> 2] + 24620 >> 2];
 A[a + 4264 >> 3] = b;
 if (w[a + 4240 | 0]) {
  A[a + 4264 >> 3] = b * (A[a + 4288 >> 3] / 60);
 }
}

function pF(a, b) {
 var c = 0;
 c = Aua(b & 255, 0, 1536, 0);
 b = gb;
 a = Aua(a & 255, 0, 25, 0);
 c = a + c | 0;
 b = gb + b | 0;
 gb = a >>> 0 > c >>> 0 ? b + 1 | 0 : b;
 return c;
}

function UP(a) {
 var b = 0, c = 0;
 c = v[a + 4 >> 2];
 b = v[a + 8 >> 2];
 while (1) {
  if ((b | 0) != (c | 0)) {
   b = b - 4 | 0;
   v[a + 8 >> 2] = b;
   continue;
  }
  break;
 }
}

function zL(a, b, c) {
 var d = 0, e = 0, f = 0;
 e = c * c;
 A[a >> 3] = e;
 f = c;
 d = c * 134217729;
 c = d + (c - d);
 d = f - c;
 A[b >> 3] = d * d + ((c + c) * d + (c * c - e));
}

function vR(a, b) {
 var c = 0;
 if (!(w[a | 0] != w[b | 0] | A[a + 8 >> 3] != A[b + 8 >> 3] | w[a + 16 | 0] != w[b + 16 | 0])) {
  c = v[a + 20 >> 2] == v[b + 20 >> 2];
 }
 return c;
}

function cL(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0;
 c = v[a >> 2];
 a: {
  if (!c) {
   break a;
  }
  if (!lc(fL(c, b), -1)) {
   break a;
  }
  v[a >> 2] = 0;
 }
 return a | 0;
}

function R$(a) {
 var b = 0;
 if (!w[a + 12 | 0]) {
  b = eb - 16 | 0;
  eb = b;
  ub(b + 12 | 0, v[v[a + 8 >> 2] >> 2]);
  ub(b + 8 | 0, v[v[a + 4 >> 2] >> 2]);
  eb = b + 16 | 0;
 }
}

function oh(a, b, c, d, e) {
 var f = 0;
 f = eb - 16 | 0;
 eb = f;
 v[f + 12 >> 2] = e;
 c = qh(f + 8 | 0, c);
 a = rt(a, b, d, v[f + 12 >> 2]);
 ph(c);
 eb = f + 16 | 0;
 return a;
}

function hT(a, b) {
 var c = 0;
 c = b & 15;
 if (c) {
  t[a + 827 | 0] = c << 2;
 }
 b = b & 240;
 if (b) {
  t[a + 826 | 0] = b >>> 4;
 }
 v[a + 88 >> 2] = v[a + 88 >> 2] | 262144;
}

function _$(a, b, c, d, e) {
 t[a + 7 | 0] = e;
 t[a + 6 | 0] = d;
 t[a + 5 | 0] = c;
 t[a + 4 | 0] = b;
 t[a | 0] = 69;
 t[a + 1 | 0] = 99;
 t[a + 2 | 0] = 104;
 t[a + 3 | 0] = 111;
}

function Fl(a, b) {
 var c = 0;
 c = b & 15;
 if (c) {
  t[a + 824 | 0] = c << 2;
 }
 b = b & 240;
 if (b) {
  t[a + 823 | 0] = b >>> 4;
 }
 v[a + 88 >> 2] = v[a + 88 >> 2] | 131072;
}

function ne(a, b) {
 return (w[a | 0] | w[a + 1 | 0] << 8 | (w[a + 2 | 0] << 16 | w[a + 3 | 0] << 24)) == (w[b | 0] | w[b + 1 | 0] << 8 | (w[b + 2 | 0] << 16 | w[b + 3 | 0] << 24));
}

function kga(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = C(c);
 var d = 0, e = C(0);
 if (b >>> 0 <= 2) {
  c = Od(c, C(0));
  d = xb(a + 4208 | 0, b), e = c, z[d >> 2] = e;
  MP(a);
 }
}

function fha(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = C(c);
 var d = 0, e = C(0);
 if (b >>> 0 <= 5) {
  c = Od(c, C(0));
  d = xb(a + 4208 | 0, b), e = c, z[d >> 2] = e;
  $P(a);
 }
}

function cga(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = C(c);
 var d = 0, e = C(0);
 if (b >>> 0 <= 3) {
  c = Od(c, C(0));
  d = xb(a + 4208 | 0, b), e = c, z[d >> 2] = e;
  KP(a);
 }
}

function _ga(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = C(c);
 var d = 0, e = C(0);
 if (b >>> 0 <= 4) {
  c = Od(c, C(0));
  d = xb(a + 4208 | 0, b), e = c, z[d >> 2] = e;
  XP(a);
 }
}

function Mqa(a, b) {
 a = a | 0;
 b = b | 0;
 if (!IY(a, b)) {
  t[b + 4 | 0] = 0;
  t[b + 5 | 0] = 0;
  t[b | 0] = 0;
  t[b + 1 | 0] = 0;
  t[b + 2 | 0] = 0;
  t[b + 3 | 0] = 0;
 }
}

function CS(a, b, c, d) {
 rB(a, a + 1074376 | 0, b, c, d);
 c = w[(B(b, 872) + a | 0) + 1075803 | 0];
 if (d) {
  d = 0;
 } else {
  d = Ku(v[a + 480180 >> 2]);
 }
 zo(a, b, c, d);
}

function AT(a, b) {
 var c = 0, d = 0;
 a: {
  if (b < 0) {
   break a;
  }
  c = A[a >> 3];
  if (!(c < 0)) {
   d = b;
   if (!(b < c)) {
    break a;
   }
  }
  A[a >> 3] = d;
 }
}

function $S(a, b, c, d) {
 var e = 0, f = 0;
 if (c & 255) {
  e = a, f = Xb(v[a >> 2] + ((B(c << 24 >> 24, (d ^ -1 | -256) + b | 0) | 0) / 2 | 0) | 0, 0, 256), 
  v[e >> 2] = f;
 }
}

function zT(a, b, c) {
 var d = C(0);
 a: {
  if (b > c) {
   break a;
  }
  d = z[a >> 2];
  if (!(d < b)) {
   b = c;
   if (!(d > b)) {
    break a;
   }
  }
  z[a >> 2] = b;
 }
}

function qr(a) {
 var b = 0, c = 0, d = 0;
 if (v[a >> 2]) {
  Mc(a);
  b = v[a >> 2];
  Ug(a);
  Bb(b);
  c = zb(a), d = 0, v[c >> 2] = d;
  v[a >> 2] = 0;
  v[a + 4 >> 2] = 0;
 }
}

function m2(a) {
 a = a | 0;
 var b = 0, c = 0, d = 0;
 b = eb - 32 | 0;
 eb = b;
 c = -1;
 d = a;
 a = b + 8 | 0;
 if (JG(d, a)) {
  c = IG(a);
 }
 eb = b + 32 | 0;
 return c | 0;
}

function gV(a) {
 v[a + 700 >> 2] = 0;
 u[a + 842 >> 1] = 0;
 v[a + 688 >> 2] = 0;
 v[a >> 2] = 0;
 v[a + 4 >> 2] = 0;
 v[a + 8 >> 2] = 0;
 v[a + 12 >> 2] = 0;
 v[a + 16 >> 2] = 0;
}

function gR(a) {
 var b = 0, c = 0, d = 0;
 if (v[a >> 2]) {
  Mc(a);
  b = v[a >> 2];
  iw(a);
  Bb(b);
  c = zb(a), d = 0, v[c >> 2] = d;
  v[a >> 2] = 0;
  v[a + 4 >> 2] = 0;
 }
}

function VU(a) {
 var b = 0, c = 0, d = 0;
 if (v[a >> 2]) {
  Mc(a);
  b = v[a >> 2];
  Gn(a);
  Bb(b);
  c = zb(a), d = 0, v[c >> 2] = d;
  v[a >> 2] = 0;
  v[a + 4 >> 2] = 0;
 }
}

function VT(a) {
 var b = 0, c = 0, d = 0;
 if (v[a >> 2]) {
  Mc(a);
  b = v[a >> 2];
  Rn(a);
  Bb(b);
  c = zb(a), d = 0, v[c >> 2] = d;
  v[a >> 2] = 0;
  v[a + 4 >> 2] = 0;
 }
}

function G1(a) {
 a = a | 0;
 var b = 0, c = 0, d = 0;
 b = eb - 16 | 0;
 eb = b;
 c = -1;
 d = a;
 a = b + 8 | 0;
 if (gk(d, a)) {
  c = eG(a);
 }
 eb = b + 16 | 0;
 return c | 0;
}

function xi(a) {
 var b = 0;
 a = a * a;
 b = a * a;
 return C(a * b * (a * 2439044879627741e-20 + -.001388676377460993) + (b * .04166662332373906 + (a * -.499999997251031 + 1)));
}

function Qb(a, b, c) {
 var d = 0;
 if (c) {
  d = a;
  while (1) {
   t[d | 0] = b;
   d = d + 1 | 0;
   c = c - 1 | 0;
   if (c) {
    continue;
   }
   break;
  }
 }
 return a;
}

function Eda(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0, e = 0;
 if (a) {
  c = a;
  a = hb[v[v[b >> 2] + 8 >> 2]](b) | 0;
  d = c, e = Bg(a ? a : 22256), v[d >> 2] = e;
 }
}

function uI(a, b, c, d, e, f, g, h, i) {
 v[a >> 2] = b;
 v[a + 4 >> 2] = c;
 v[a + 8 >> 2] = d;
 v[a + 12 >> 2] = e & 65535 | (i >>> 16 & 32768 | (e & 2147418112) >>> 16) << 16;
}

function qX(a) {
 var b = 0;
 a = a & 15;
 b = 0;
 a: {
  if (!a) {
   break a;
  }
  b = 12 - a | 0;
  if (a >>> 0 <= 12) {
   break a;
  }
  b = 24 - a | 0;
 }
 return b & 255;
}

function OB(a, b) {
 var c = 0;
 c = v[a + 484360 >> 2];
 b = b & 255;
 if (Fj(c, v[a + 484364 >> 2]) >>> 0 <= b >>> 0) {
  return Wb(c, w[a + 484376 | 0]);
 }
 return Lj(c, b);
}

function N8(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0;
 hb[v[v[a >> 2] + 24 >> 2]](a) | 0;
 b = LD(v[b >> 2]);
 v[a + 36 >> 2] = b;
 c = a, d = ho(b), t[c + 44 | 0] = d;
}

function F8(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0;
 hb[v[v[a >> 2] + 24 >> 2]](a) | 0;
 b = Qy(v[b >> 2]);
 v[a + 36 >> 2] = b;
 c = a, d = ho(b), t[c + 44 | 0] = d;
}

function AR(a, b) {
 var c = 0, d = 0;
 c = v[a + 4 >> 2];
 d = v[b + 4 >> 2];
 if ((c | 0) == (d | 0)) {
  a = zR(v[a >> 2], c, v[b >> 2], d);
 } else {
  a = 1;
 }
 return !a;
}

function zX(a) {
 var b = 0;
 if (!(id(a, 13865, 3) | w[a + 3 | 0] > 31 | (t[a + 27 | 0] < 0 | w[a + 32 | 0] > 64))) {
  b = (w[a + 33 | 0] - 1 & 255) >>> 0 < 32;
 }
 return b;
}

function rK(a, b, c) {
 var d = 0;
 d = eb - 16 | 0;
 eb = d;
 v[d + 12 >> 2] = c;
 b = qh(d + 8 | 0, b);
 a = pK(a, 9262, v[d + 12 >> 2]);
 ph(b);
 eb = d + 16 | 0;
 return a;
}

function mj(a) {
 a: {
  a = a & 74;
  if (a) {
   if ((a | 0) == 64) {
    return 8;
   }
   if ((a | 0) != 8) {
    break a;
   }
   return 16;
  }
  return 0;
 }
 return 10;
}

function gM(a, b) {
 var c = 0;
 c = eb - 16 | 0;
 eb = c;
 a = Xo(c + 4 | 0, a, 1);
 po(v[a + 4 >> 2], w[b | 0]);
 v[a + 4 >> 2] = v[a + 4 >> 2] + 1;
 hc(a);
 eb = c + 16 | 0;
}

function _I(a, b, c, d, e, f, g, h) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 f = f | 0;
 g = g | 0;
 h = h | 0;
 v[e >> 2] = c;
 v[h >> 2] = f;
 return 3;
}

function Vka(a) {
 a = a | 0;
 var b = 0, c = 0;
 b = eb - 16 | 0;
 eb = b;
 c = xf(b + 12 | 0, Qb(Dc(6668), 0, 6668));
 eb = b + 16 | 0;
 v[a >> 2] = v[c >> 2];
 return a | 0;
}

function Qu(a) {
 var b = 0, c = 0;
 while (1) {
  if (b >>> 0 >= 8) {
   a = c << 24 >> 24;
  } else {
   b = b + 15 | 0;
   c = Co(a);
   continue;
  }
  break;
 }
 return a;
}

function gu(a) {
 a = a | 0;
 var b = 0;
 v[a >> 2] = 47596;
 Ad(a, 0);
 b = v[a + 8 >> 2];
 if (b) {
  hb[v[v[b >> 2] + 4 >> 2]](b);
 }
 v[a + 8 >> 2] = 0;
 return Nm(a) | 0;
}

function WP(a) {
 a = a | 0;
 v[a + 4244 >> 2] = 0;
 v[a + 4248 >> 2] = 0;
 v[a + 4228 >> 2] = 0;
 v[a + 4232 >> 2] = 0;
 a = a + 4252 | 0;
 v[a >> 2] = 0;
 v[a + 4 >> 2] = 0;
}

function th(a) {
 var b = 0;
 b = eb - 16 | 0;
 eb = b;
 v[b + 12 >> 2] = a;
 v[b + 8 >> 2] = 2147483647;
 a = Gb(b + 12 | 0, b + 8 | 0);
 eb = b + 16 | 0;
 return v[a >> 2];
}

function _K(a) {
 var b = 0;
 b = v[a + 12 >> 2];
 if ((b | 0) == v[a + 16 >> 2]) {
  return hb[v[v[a >> 2] + 40 >> 2]](a) | 0;
 }
 v[a + 12 >> 2] = b + 4;
 return v[b >> 2];
}

function WR(a, b) {
 var c = 0;
 c = eb - 16 | 0;
 eb = c;
 a = lC(c + 4 | 0, a);
 vq(v[a + 4 >> 2], v[b >> 2]);
 v[a + 4 >> 2] = v[a + 4 >> 2] + 4;
 hc(a);
 eb = c + 16 | 0;
}

function dI(a, b, c, d, e, f) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 f = f | 0;
 var g = 0;
 g = a;
 a = 0;
 return Kz(g | a, b, c, d, a | e, f) | 0;
}

function QP(a) {
 a = a | 0;
 var b = 0;
 b = 4960;
 while (1) {
  b = b - 24 | 0;
  uc(b + a | 0);
  if ((b | 0) != 4504) {
   continue;
  }
  break;
 }
 return Zf(a) | 0;
}

function Il(a, b) {
 var c = 0;
 c = 1;
 a: {
  switch ((b & 255) - 4 | 0) {
  default:
   c = (a & 255) == 11;
   break;

  case 0:
  case 2:
   break a;
  }
 }
 return c;
}

function Av(a) {
 var b = 0;
 b = v[a + 4 >> 2];
 a: {
  if ((b | 0) != 31) {
   b = b + 1 | 0;
   break a;
  }
  v[a >> 2] = v[a >> 2] + 4;
  b = 0;
 }
 v[a + 4 >> 2] = b;
}

function kf(a, b) {
 var c = 0;
 c = v[a + 4 >> 2];
 if (b) {
  a = v[a >> 2];
  v[a >> 2] = v[a >> 2] | c;
  return;
 }
 a = v[a >> 2];
 v[a >> 2] = v[a >> 2] & (c ^ -1);
}

function nW(a, b) {
 var c = 0;
 c = v[a + 4 >> 2];
 while (1) {
  if ((b | 0) != (c | 0)) {
   c = c - 12 | 0;
   zC(c);
   continue;
  }
  break;
 }
 v[a + 4 >> 2] = b;
}

function eS(a, b) {
 var c = 0;
 c = v[a + 4 >> 2];
 while (1) {
  if ((b | 0) != (c | 0)) {
   c = c - 52 | 0;
   uk(c);
   continue;
  }
  break;
 }
 v[a + 4 >> 2] = b;
}

function YT(a, b) {
 var c = 0;
 c = v[a + 4 >> 2];
 while (1) {
  if ((b | 0) != (c | 0)) {
   c = c - 12 | 0;
   tf(c);
   continue;
  }
  break;
 }
 v[a + 4 >> 2] = b;
}

function SE(a, b) {
 var c = 0;
 c = v[a + 4 >> 2];
 while (1) {
  if ((b | 0) != (c | 0)) {
   c = c - 20 | 0;
   tb(c);
   continue;
  }
  break;
 }
 v[a + 4 >> 2] = b;
}

function Ob(a, b, c) {
 var d = 0;
 c = c + v[a + 4 >> 2] | 0;
 d = b;
 b = v[a >> 2] + b | 0;
 c = d >>> 0 > b >>> 0 ? c + 1 | 0 : c;
 v[a >> 2] = b;
 v[a + 4 >> 2] = c;
}

function MU(a, b) {
 var c = 0;
 c = v[a + 4 >> 2];
 while (1) {
  if ((b | 0) != (c | 0)) {
   c = c - 32 | 0;
   zk(c);
   continue;
  }
  break;
 }
 v[a + 4 >> 2] = b;
}

function XQ(a) {
 var b = 0;
 b = eb - 16 | 0;
 eb = b;
 v[b + 12 >> 2] = a;
 v[b + 8 >> 2] = 32767;
 a = Gb(b + 12 | 0, b + 8 | 0);
 eb = b + 16 | 0;
 return u[a >> 1];
}

function Tda(a, b, c, d, e, f, g) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 f = f | 0;
 g = g | 0;
 return SH(a, b, c, d, e, f, g, 13045, 1084) | 0;
}

function TX(a, b) {
 t[a + 6 | 0] = 255;
 v[a + 16 >> 2] = 0;
 u[a + 4 >> 1] = 0;
 v[a >> 2] = 0;
 if (b >= 0) {
  A[a + 8 >> 3] = b;
  v[a + 16 >> 2] = 3;
 }
 return a;
}

function Kl(a, b, c, d) {
 var e = 0;
 e = eb - 16 | 0;
 eb = e;
 v[e + 12 >> 2] = d;
 v[e + 8 >> 2] = c;
 Yb(a, b, v[Gb(e + 12 | 0, e + 8 | 0) >> 2]);
 eb = e + 16 | 0;
}

function $l(a) {
 var b = 0;
 b = eb - 16 | 0;
 eb = b;
 v[b + 12 >> 2] = a;
 v[b + 8 >> 2] = 65535;
 a = Gb(b + 12 | 0, b + 8 | 0);
 eb = b + 16 | 0;
 return x[a >> 1];
}

function $da(a, b, c, d, e, f, g) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 f = f | 0;
 g = g | 0;
 return SH(a, b, c, d, e, f, g, 12977, 1077) | 0;
}

function fw(a) {
 var b = 0;
 b = eb - 16 | 0;
 eb = b;
 u[b + 14 >> 1] = a;
 u[b + 12 >> 1] = 255;
 a = Nc(b + 14 | 0, b + 12 | 0);
 eb = b + 16 | 0;
 return w[a | 0];
}

function Xca(a, b, c, d, e, f, g) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 f = f | 0;
 g = g | 0;
 return xO(v[a + 4 >> 2], b, c, d, e, f, g) | 0;
}

function Uca(a, b, c, d, e, f, g) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 f = f | 0;
 g = g | 0;
 return qO(v[a + 4 >> 2], b, c, d, e, f, g) | 0;
}

function Dk(a, b) {
 var c = 0;
 c = eb - 16 | 0;
 eb = c;
 v[c + 12 >> 2] = a;
 a = c + 12 | 0;
 v[a >> 2] = v[a >> 2] + (b << 2);
 eb = c + 16 | 0;
 return v[a >> 2];
}

function wq(a, b) {
 var c = 0;
 c = eb - 32 | 0;
 eb = c;
 lh(c + 16 | 0, b);
 Lm(c + 24 | 0, a, v[c + 16 >> 2], v[c + 20 >> 2]);
 lh(c + 8 | 0, b);
 eb = c + 32 | 0;
}

function via(a, b) {
 a = a | 0;
 b = b | 0;
 var c = C(0);
 if (b >>> 0 <= 3) {
  c = C(C(w[(a + b | 0) + 4264 | 0]) / C(255));
 } else {
  c = C(0);
 }
 return C(c);
}

function vS(a) {
 v[a >> 2] = 0;
 v[a + 4 >> 2] = 0;
 v[a + 24 >> 2] = 0;
 v[a + 28 >> 2] = 0;
 v[a + 8 >> 2] = 0;
 v[a + 12 >> 2] = 0;
 v[a + 16 >> 2] = 0;
 return a;
}

function iV(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0;
 c = Cb(v[a + 4 >> 2], w[a + 11 | 0]);
 if (c >>> 0 < b >>> 0) {
  ys(a, b - c | 0, 0);
  return;
 }
 RT(a, b);
}

function Sx(a, b, c, d, e, f, g) {
 var h = 0;
 h = b >> 8;
 if (b & 1) {
  h = Tx(v[e >> 2], h);
 }
 hb[v[v[a >> 2] + 20 >> 2]](a, c, d, e + h | 0, b & 2 ? f : 2, g);
}

function DW(a, b) {
 var c = 0;
 c = b & 255;
 b = c >>> 24 | 0;
 a = a & 255 ? 1120 : 1056;
 c = a + (c << 8) | 0;
 gb = a >>> 0 > c >>> 0 ? b + 1 | 0 : b;
 return c;
}

function Bha(a, b) {
 a = a | 0;
 b = b | 0;
 var c = C(0);
 if (b >>> 0 <= 2) {
  c = C(C(w[(a + b | 0) + 4232 | 0]) / C(127));
 } else {
  c = C(0);
 }
 return C(c);
}

function $A(a, b) {
 var c = 0;
 c = eb - 16 | 0;
 eb = c;
 a = we(c + 8 | 0, Bua(a, b, 1e6, 0), gb);
 b = v[a >> 2];
 eb = c + 16 | 0;
 gb = v[a + 4 >> 2];
 return b;
}

function ri(a) {
 var b = 0;
 b = eb - 16 | 0;
 eb = b;
 v[b + 12 >> 2] = a;
 v[b + 8 >> 2] = 255;
 a = Gb(b + 12 | 0, b + 8 | 0);
 eb = b + 16 | 0;
 return w[a | 0];
}

function Rs(a) {
 if (a >>> 0 <= 131071) {
  a = w[(a >>> 3 & 31 | w[(a >>> 8 | 0) + 116672 | 0] << 5) + 116672 | 0] >>> (a & 7) & 1;
 } else {
  a = 0;
 }
 return a;
}

function iK(a, b, c, d, e) {
 b = gj(b, c, d, e, 4);
 if (!(w[d | 0] & 4)) {
  v[a >> 2] = ((b | 0) < 69 ? b + 2e3 | 0 : b >>> 0 < 100 ? b + 1900 | 0 : b) - 1900;
 }
}

function eK(a, b, c, d, e) {
 b = fj(b, c, d, e, 4);
 if (!(w[d | 0] & 4)) {
  v[a >> 2] = ((b | 0) < 69 ? b + 2e3 | 0 : b >>> 0 < 100 ? b + 1900 | 0 : b) - 1900;
 }
}

function Ss(a) {
 if (a >>> 0 <= 131071) {
  return w[(a >>> 3 & 31 | w[(a >>> 8 | 0) + 112768 | 0] << 5) + 112768 | 0] >>> (a & 7) & 1;
 }
 return a >>> 0 < 196606;
}

function jw(a, b) {
 var c = 0;
 c = eb - 16 | 0;
 eb = c;
 v[c + 12 >> 2] = (B(a, b) >>> 0) / 255;
 Fe(c + 12 | 0, 0, 15);
 eb = c + 16 | 0;
 return w[c + 12 | 0];
}

function _z(a, b, c) {
 b = b - a >> 2;
 while (1) {
  if ((b | 0) > 0) {
   v[a >> 2] = v[c >> 2];
   b = b - 1 | 0;
   a = a + 4 | 0;
   continue;
  }
  break;
 }
}

function Zk(a) {
 t[a | 0] = 0;
 t[a + 1 | 0] = 0;
 t[a + 2 | 0] = 0;
 t[a + 3 | 0] = 0;
 t[a + 4 | 0] = 0;
 t[a + 5 | 0] = 0;
 t[a + 6 | 0] = 0;
 t[a + 7 | 0] = 0;
}

function FE(a) {
 t[a | 0] = 0;
 t[a + 1 | 0] = 0;
 t[a + 2 | 0] = 0;
 t[a + 3 | 0] = 0;
 t[a + 3 | 0] = 0;
 t[a + 4 | 0] = 0;
 t[a + 5 | 0] = 0;
 t[a + 6 | 0] = 0;
}

function AX(a) {
 var b = 0, c = 0;
 b = 1;
 c = v[a >> 2];
 a: {
  if ((c | 0) > 0) {
   b = 120;
   if (c >>> 0 < 121) {
    break a;
   }
  }
  v[a >> 2] = b;
 }
}

function Ml(a, b, c, d) {
 a = a & 65535;
 c = c & 65535;
 a = (a | 0) != (c | 0) ? a >>> 0 < c >>> 0 ? -1 : 1 : 0;
 if (Kj(a)) {
  a = UT(b, d);
 }
 return ud(a);
}

function op(a) {
 a = a | 0;
 var b = 0, c = 0;
 b = eb - 16 | 0;
 eb = b;
 if (Mn(a, b + 12 | 0)) {
  c = _b(v[b + 12 >> 2]);
 }
 eb = b + 16 | 0;
 return c | 0;
}

function kh(a, b, c) {
 if (!c) {
  return v[a + 4 >> 2] == v[b + 4 >> 2];
 }
 if ((a | 0) == (b | 0)) {
  return 1;
 }
 return !gi(v[a + 4 >> 2], v[b + 4 >> 2]);
}

function Mk(a) {
 a = a | 0;
 var b = 0, c = 0;
 b = eb - 16 | 0;
 eb = b;
 if (Dp(a, b + 14 | 0)) {
  c = Ab(x[b + 14 >> 1]);
 }
 eb = b + 16 | 0;
 return c | 0;
}

function HN(a, b) {
 a = a | 0;
 b = b | 0;
 a = Cj(a);
 v[a + 4 >> 2] = 0;
 v[a >> 2] = 47536;
 v[a + 4 >> 2] = v[b + 4 >> 2];
 v[b + 4 >> 2] = 0;
 return a | 0;
}

function Fh(a) {
 var b = 0;
 mn(a);
 b = qv(v[a >> 2], Xk(x[a + 34 >> 1]));
 v[a + 20 >> 2] = b;
 if (!b) {
  return 0;
 }
 return Nk(v[a >> 2], x[a + 34 >> 1]);
}

function Cn(a) {
 a = w[a | 0] | w[a + 1 | 0] << 8 | (w[a + 2 | 0] << 16 | w[a + 3 | 0] << 24);
 return a << 24 | (a & 65280) << 8 | (a >>> 8 & 65280 | a >>> 24);
}

function rua(a, b) {
 a = a | 0;
 b = b | 0;
 if (!AE(a, b)) {
  t[b + 1 | 0] = 0;
  t[b + 2 | 0] = 0;
  t[b + 3 | 0] = 0;
  t[b + 4 | 0] = 0;
  t[b | 0] = 0;
 }
}

function iJ(a, b, c) {
 a: {
  if (!(w[b + 120 | 0] | c >>> 0 > 30)) {
   t[b + 120 | 0] = 1;
   break a;
  }
  b = xY(c);
 }
 v[a + 4 >> 2] = c;
 v[a >> 2] = b;
}

function Q5(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 if (c >>> 0 <= 127) {
  a = (v[(c << 2) + 95312 >> 2] & b) != 0;
 } else {
  a = 0;
 }
 return a | 0;
}

function Ps(a, b, c, d, e, f) {
 var g = 0;
 g = b >> 8;
 if (b & 1) {
  g = Tx(v[d >> 2], g);
 }
 hb[v[v[a >> 2] + 24 >> 2]](a, c, d + g | 0, b & 2 ? e : 2, f);
}

function Om(a, b, c) {
 b = b - a | 0;
 while (1) {
  if ((b | 0) > 0) {
   t[a | 0] = w[c | 0];
   b = b - 1 | 0;
   a = a + 1 | 0;
   continue;
  }
  break;
 }
}

function Ax(a) {
 var b = 0;
 b = eb - 16 | 0;
 eb = b;
 v[b + 12 >> 2] = a;
 v[b + 12 >> 2] = v[b + 12 >> 2] + 12;
 eb = b + 16 | 0;
 return Pp(v[b + 12 >> 2]);
}

function sA(a, b) {
 a = Mb(a);
 v[a + 20 >> 2] = 0;
 v[a + 12 >> 2] = 0;
 v[a + 16 >> 2] = 0;
 Mb(a + 24 | 0);
 Eb(a + 36 | 0);
 v[a + 48 >> 2] = b;
 return a;
}

function s0(a, b) {
 a = a | 0;
 b = b | 0;
 if (!AE(a, b)) {
  t[b | 0] = 0;
  t[b + 1 | 0] = 0;
  t[b + 2 | 0] = 0;
  t[b + 3 | 0] = 0;
  t[b + 4 | 0] = 0;
 }
}

function pfa() {
 var a = 0;
 a = eb - 16 | 0;
 eb = a;
 if (_a(a + 12 | 0, 4) | 0) {
  Ht(v[31476], 12710);
  p();
 }
 eb = a + 16 | 0;
 return v[a + 12 >> 2];
}

function oda(a) {
 a = a | 0;
 var b = 0;
 b = eb - 16 | 0;
 eb = b;
 ee(b + 8 | 0, a);
 a = Tz(v[b + 8 >> 2], v[b + 12 >> 2]);
 eb = b + 16 | 0;
 return a | 0;
}

function tf(a) {
 var b = 0, c = 0;
 b = eb - 16 | 0;
 eb = b;
 a = v[ub(b + 12 | 0, a) >> 2];
 c = v[a >> 2];
 if (c) {
  zb(a);
  Bb(c);
 }
 eb = b + 16 | 0;
}

function cl(a, b) {
 var c = 0;
 c = eb - 16 | 0;
 eb = c;
 v[c + 12 >> 2] = a;
 v[c + 12 >> 2] = v[c + 12 >> 2] - b;
 eb = c + 16 | 0;
 return v[c + 12 >> 2];
}

function Yha(a, b, c, d, e) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 a = wj(a);
 if (a) {
  hb[v[v[a >> 2] + 88 >> 2]](a, b, c, d, e);
 }
}

function xua(a) {
 a = a | 0;
 var b = 0;
 b = v[a + 76 >> 2];
 if (lc(-1, b)) {
  b = oF(v[a + 28 >> 2], 32);
  v[a + 76 >> 2] = b;
 }
 return b << 24 >> 24;
}

function q1(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0;
 c = eb - 16 | 0;
 eb = c;
 Dn(c + 8 | 0, b);
 zp(a, v[c + 8 >> 2], v[c + 12 >> 2]);
 eb = c + 16 | 0;
}

function Hg(a, b, c) {
 var d = 0;
 d = v[a >> 2];
 c = v[a + 4 >> 2] - (c + (d >>> 0 < b >>> 0) | 0) | 0;
 b = d - b | 0;
 v[a >> 2] = b;
 v[a + 4 >> 2] = c;
}

function G9(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0;
 c = eb - 16 | 0;
 eb = c;
 B0(c + 8 | 0, b);
 zp(a, v[c + 8 >> 2], v[c + 12 >> 2]);
 eb = c + 16 | 0;
}

function qw(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0;
 c = eb - 16 | 0;
 eb = c;
 d = a;
 a = Cc(c + 4 | 0, b);
 Uc(d, a);
 sb(a);
 eb = c + 16 | 0;
}

function fg(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0;
 c = eb - 16 | 0;
 eb = c;
 d = a;
 a = tc(c + 4 | 0, b);
 Uc(d, a);
 sb(a);
 eb = c + 16 | 0;
}

function eca(a, b, c, d, e, f, g) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 f = f | 0;
 g = g | 0;
 cP(a, v[b + 4 >> 2], c, d, e, f, g);
}

function OZ(a, b) {
 var c = 0, d = 0, e = 0;
 c = eb - 16 | 0;
 eb = c;
 d = c, e = Ab(b & 65535), u[d + 14 >> 1] = e;
 Wv(a, c + 14 | 0);
 eb = c + 16 | 0;
}

function Nb(a, b) {
 var c = 0;
 c = eb - 16 | 0;
 eb = c;
 VF(c + 8 | 0, a, b);
 a = Fb(v[v[c + 8 >> 2] >> 2], v[c + 12 >> 2]);
 eb = c + 16 | 0;
 return a;
}

function $ba(a, b, c, d, e, f, g) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 f = f | 0;
 g = g | 0;
 AO(a, v[b + 4 >> 2], c, d, e, f, g);
}

function rZ(a, b) {
 var c = 0;
 c = v[a >> 2];
 v[a >> 2] = b;
 if (c) {
  qZ(c + 52 | 0);
  sb(c + 40 | 0);
  uc(c + 16 | 0);
  uc(c + 4 | 0);
  Bb(c);
 }
}

function pqa(a) {
 a = a | 0;
 var b = 0;
 b = eb - 16 | 0;
 eb = b;
 a = Dp(a, b + 14 | 0);
 eb = b + 16 | 0;
 return (a ? x[b + 14 >> 1] : 0) << 16 >> 16;
}

function p3(a, b, c, d, e, f) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 f = f | 0;
 if (kh(a, v[b + 8 >> 2], f)) {
  Wx(b, c, d, e);
 }
}

function lt(a, b) {
 a = a | 0;
 b = b | 0;
 b = v[b + 68 >> 2];
 t[a | 0] = b;
 t[a + 1 | 0] = b >>> 8;
 t[a + 2 | 0] = b >>> 16;
 t[a + 3 | 0] = b >>> 24;
}

function YJ(a, b) {
 a = a | 0;
 b = b | 0;
 b = v[b + 64 >> 2];
 t[a | 0] = b;
 t[a + 1 | 0] = b >>> 8;
 t[a + 2 | 0] = b >>> 16;
 t[a + 3 | 0] = b >>> 24;
}

function TJ(a, b) {
 a = a | 0;
 b = b | 0;
 b = v[b + 72 >> 2];
 t[a | 0] = b;
 t[a + 1 | 0] = b >>> 8;
 t[a + 2 | 0] = b >>> 16;
 t[a + 3 | 0] = b >>> 24;
}

function EU(a) {
 var b = 0;
 b = v[a + 4 >> 2];
 u[a + 70 >> 1] = w[((x[b + 20 >> 1] >>> 6 | x[b + 22 >> 1] << 4) & 65535) + 27360 | 0] >>> x[a + 68 >> 1];
}

function ew(a) {
 var b = 0, c = 0;
 if (v[a >> 2]) {
  Mc(a);
  Bb(v[a >> 2]);
  b = zb(a), c = 0, v[b >> 2] = c;
  v[a >> 2] = 0;
  v[a + 4 >> 2] = 0;
 }
}

function FJ(a) {
 var b = 0, c = 0;
 b = eb - 16 | 0;
 eb = b;
 a = qh(b + 12 | 0, a);
 c = v[v[124107] >> 2];
 ph(a);
 eb = b + 16 | 0;
 return c ? 4 : 1;
}

function m9(a, b, c, d, e, f) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 f = f | 0;
 hb[v[v[a >> 2] + 24 >> 2]](a, b, c, d, e, f) | 0;
}

function l9(a, b, c, d, e, f) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 f = f | 0;
 hb[v[v[a >> 2] + 16 >> 2]](a, b, c, d, e, f) | 0;
}

function kn(a, b, c) {
 var d = 0, e = 0;
 d = eb - 16 | 0;
 eb = d;
 e = a;
 a = Yb(d + 8 | 0, b, c);
 ac(e, v[a >> 2], v[a + 4 >> 2]);
 eb = d + 16 | 0;
}

function k9(a, b, c, d, e, f) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 f = f | 0;
 hb[v[v[a >> 2] + 28 >> 2]](a, b, c, d, e, f) | 0;
}

function j9(a, b, c, d, e, f) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 f = f | 0;
 hb[v[v[a >> 2] + 20 >> 2]](a, b, c, d, e, f) | 0;
}

function i9(a, b, c, d, e, f) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 f = f | 0;
 hb[v[v[a >> 2] + 44 >> 2]](a, b, c, d, e, f) | 0;
}

function Rb() {
 var a = 0;
 a = v[31475];
 v[31601] = 0;
 W(a | 0);
 a = v[31601];
 v[31601] = 0;
 if ((a | 0) == 1) {
  X(S(0) | 0) | 0;
 }
 kI();
 p();
}

function Pw(a) {
 a = a | 0;
 var b = 0;
 b = eb - 16 | 0;
 eb = b;
 a = dh(a, b + 15 | 0);
 eb = b + 16 | 0;
 return (a ? w[b + 15 | 0] : 0) << 24 >> 24;
}

function OL(a, b, c, d) {
 z[d + 4 >> 2] = a + c;
 a = C(a + C(c * C(-.5)));
 b = C(b * C(.8660253882408142));
 z[d + 8 >> 2] = a - b;
 z[d >> 2] = b + a;
}

function x2(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0, d = 0;
 c = eb - 16 | 0;
 eb = c;
 d = c + 4 | 0;
 TI(d, b);
 Ph(a, d);
 sb(d);
 eb = c + 16 | 0;
}

function RR(a, b) {
 if (b >>> 0 <= 255) {
  a = v[((b << 2) + a | 0) + 900380 >> 2];
  a = a ? a + 492 | 0 : 22256;
 } else {
  a = 22256;
 }
 return a;
}

function Ada(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0;
 b = Jb(b);
 c = v[a + 4 >> 2];
 if (c) {
  hb[c | 0](b, v[a + 8 >> 2]);
  return;
 }
 lu(b, a);
}

function hL(a) {
 var b = 0;
 b = v[a + 12 >> 2];
 if ((b | 0) == v[a + 16 >> 2]) {
  return hb[v[v[a >> 2] + 36 >> 2]](a) | 0;
 }
 return yf(t[b | 0]);
}

function _v(a) {
 a = a | 0;
 var b = 0;
 u[a + 34 >> 1] = 0;
 b = a + 43 | 0;
 Om(b, b + 22 | 0, 78512);
 v[a + 20 >> 2] = 0;
 md(a, 0);
 return a | 0;
}

function Xba(a, b, c, d, e, f) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 f = f | 0;
 bP(a, v[v[b + 4 >> 2] + 24 >> 2], c, d, e, f);
}

function Wba(a, b, c, d, e, f) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 f = f | 0;
 zO(a, v[v[b + 4 >> 2] + 24 >> 2], c, d, e, f);
}

function OH(a, b, c) {
 var d = 0;
 d = eb - 16 | 0;
 eb = d;
 c = Cc(d + 4 | 0, c);
 a = rc(a, c);
 sb(c);
 v[a >> 2] = b;
 eb = d + 16 | 0;
 return a;
}

function C$(a) {
 return (w[a | 0] | w[a + 1 | 0] << 8 | (w[a + 2 | 0] << 16 | w[a + 3 | 0] << 24)) == 1179468868 & (w[a + 4 | 0] - 1 & 255) >>> 0 < 10;
}

function gv(a, b) {
 b = Aua(a, a >> 31, b, b >> 31);
 a = gb;
 b = b + 5e5 | 0;
 a = b >>> 0 < 5e5 ? a + 1 | 0 : a;
 return Fc(Bua(b, a, 1e6, 0), gb);
}

function dea(a, b, c, d, e, f) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 f = f | 0;
 return VH(a, b, c, d, e, f, 10648, 1074) | 0;
}

function Zfa(a, b, c, d, e, f, g) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 f = f | 0;
 g = g | 0;
 Jz(a, b, c, d, e, 0, 0, f, g);
}

function Qea(a, b, c, d, e, f) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 f = f | 0;
 return VH(a, b, c, d, e, f, 10693, 1047) | 0;
}

function wV(a) {
 if (((w[a + 68 | 0] | w[a + 69 | 0] << 8) - 128 & 65535) >>> 0 >= 65409) {
  a = id(a, 18285, 17);
 } else {
  a = 1;
 }
 return !a;
}

function VQ(a, b) {
 var c = 0;
 c = eb - 16 | 0;
 eb = c;
 a = we(c + 8 | 0, a, b);
 b = v[a >> 2];
 eb = c + 16 | 0;
 gb = v[a + 4 >> 2];
 return b;
}

function QC(a) {
 var b = 0, c = 0;
 c = a;
 while (1) {
  b = c;
  c = b + 4 | 0;
  if (v[b >> 2]) {
   continue;
  }
  break;
 }
 return b - a >> 2;
}

function Ny(a) {
 if (!v[a + 136 >> 2]) {
  v[a + 136 >> 2] = v[v[124107] >> 2] ? 104896 : 104872;
 }
 if (!v[a + 72 >> 2]) {
  v[a + 72 >> 2] = 1;
 }
}

function Eh(a) {
 var b = 0;
 if (a >>> 0 >= 11) {
  b = a + 16 & -16;
  a = b - 1 | 0;
  a = (a | 0) == 11 ? b : a;
 } else {
  a = 10;
 }
 return a;
}

function ql(a) {
 var b = 0;
 b = v[a + 12 >> 2];
 if ((b | 0) == v[a + 16 >> 2]) {
  return hb[v[v[a >> 2] + 36 >> 2]](a) | 0;
 }
 return v[b >> 2];
}

function py(a, b, c, d, e) {
 var f = 0;
 f = eb - 16 | 0;
 eb = f;
 e = qh(f + 12 | 0, e);
 a = fq(a, b, c, d);
 ph(e);
 eb = f + 16 | 0;
 return a;
}

function o1(a, b) {
 a = a | 0;
 b = b | 0;
 v[a >> 2] = 0;
 v[a + 4 >> 2] = 0;
 Ec(a + 8 | 0, 0);
 Xr(a, 127);
 LF(a, 127, w[b | 0]);
 return a | 0;
}

function Z$(a, b) {
 a = om(a, v[b >> 2], v[b + 4 >> 2]);
 v[a + 8 >> 2] = v[b + 8 >> 2];
 om(a + 12 | 0, v[b + 12 >> 2], v[b + 16 >> 2]);
 return a;
}

function Lja(a, b) {
 a = a | 0;
 b = b | 0;
 Ji(a);
 Ji(a);
 a: {
  if (b >>> 0 >= 60) {
   Ub(a, 4);
   break a;
  }
  Ji(a);
 }
 return Ji(a) | 0;
}

function Bi(a, b, c, d, e) {
 var f = 0;
 f = eb - 16 | 0;
 eb = f;
 e = qh(f + 12 | 0, e);
 a = cK(a, b, c, d);
 ph(e);
 eb = f + 16 | 0;
 return a;
}

function vx(a, b) {
 a = a | 0;
 b = b | 0;
 b = b - 1 | 0;
 if (b >>> 0 <= 4) {
  b = v[(b << 2) + 22268 >> 2];
 } else {
  b = 9742;
 }
 tc(a, b);
}

function tS(a, b, c, d) {
 return (a | 0) != (c | 0) | (b | 0) != (d | 0) ? a >>> 0 < c >>> 0 & (b | 0) <= (d | 0) | (b | 0) < (d | 0) ? -1 : 1 : 0;
}

function rn(a) {
 var b = 0;
 if (a >>> 0 >= 2) {
  b = EY(a + 1 | 0);
  a = b - 1 | 0;
  a = (a | 0) == 2 ? b : a;
 } else {
  a = 1;
 }
 return a;
}

function pS(a) {
 a = Eb(a);
 Eb(a + 12 | 0);
 Eb(a + 24 | 0);
 Eb(a + 36 | 0);
 Eb(a + 48 | 0);
 Ec(a + 60 | 0, 0);
 v[a + 64 >> 2] = 0;
 return a;
}

function fra(a) {
 a = a | 0;
 var b = 0;
 b = eb - 16 | 0;
 eb = b;
 a = Mn(a, b + 12 | 0);
 eb = b + 16 | 0;
 return C(a ? z[b + 12 >> 2] : C(0));
}

function dg(a) {
 var b = 0, c = 0;
 while (1) {
  c = b & 65535;
  if (c >>> 0 < 127) {
   bE(a, c);
   b = b + 1 | 0;
   continue;
  }
  break;
 }
}

function Yd(a) {
 a = a | 0;
 var b = 0;
 b = eb - 16 | 0;
 eb = b;
 a = dh(a, b + 15 | 0);
 eb = b + 16 | 0;
 return (a ? w[b + 15 | 0] : 0) & 255;
}

function RD(a, b) {
 var c = 0;
 c = eb - 16 | 0;
 eb = c;
 v[c + 12 >> 2] = a;
 a = q_(c + 12 | 0, 0 - b | 0);
 eb = c + 16 | 0;
 return v[a >> 2];
}

function Zpa(a) {
 a = a | 0;
 var b = 0, c = 0;
 b = eb - 32 | 0;
 eb = b;
 c = a;
 a = Xh(b + 12 | 0);
 lY(c, a, 0, 0);
 tb(a);
 eb = b + 32 | 0;
}

function Uha(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 a = wj(a);
 if (!a) {
  return 0;
 }
 return hb[v[v[a >> 2] + 104 >> 2]](a, b, c) | 0;
}

function HF(a, b, c, d, e, f, g) {
 a = ub(a, b);
 ub(a + 4 | 0, c);
 ub(a + 8 | 0, d);
 ub(a + 12 | 0, e);
 ub(a + 16 | 0, f);
 ub(a + 20 | 0, g);
}

function zV(a) {
 je(a + 140 | 0);
 tb(a + 120 | 0);
 tb(a + 100 | 0);
 tb(a + 80 | 0);
 tb(a + 60 | 0);
 tb(a + 40 | 0);
 tb(a + 20 | 0);
 tb(a);
}

function sz(a, b, c, d) {
 var e = 0;
 e = eb - 16 | 0;
 eb = e;
 ac(e + 8 | 0, c, d);
 WM(a, b, v[e + 8 >> 2], v[e + 12 >> 2]);
 eb = e + 16 | 0;
}

function Uc(a, b) {
 var c = 0;
 c = v[b + 4 >> 2];
 v[a >> 2] = v[b >> 2];
 v[a + 4 >> 2] = c;
 v[a + 8 >> 2] = v[b + 8 >> 2];
 xx(b);
 return a;
}

function OD(a) {
 var b = 0, c = 0;
 b = eb - 16 | 0;
 eb = b;
 if (Dp(a, b + 14 | 0)) {
  c = ye(u[b + 14 >> 1]);
 }
 eb = b + 16 | 0;
 return c;
}

function Lm(a, b, c, d) {
 var e = 0;
 e = eb - 16 | 0;
 eb = e;
 lf(e + 8 | 0, c, d);
 WM(a, b, v[e + 8 >> 2], v[e + 12 >> 2]);
 eb = e + 16 | 0;
}

function IW(a) {
 var b = 0, c = 0;
 b = eb - 16 | 0;
 eb = b;
 if ($E(a, b + 12 | 0)) {
  c = _b(v[b + 12 >> 2]);
 }
 eb = b + 16 | 0;
 return c;
}

function _ba(a, b, c, d, e) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 return iu(v[v[a + 4 >> 2] + 24 >> 2], b, c, d, e) | 0;
}

function X8(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 hb[v[v[b >> 2] + 16 >> 2]](a, b, v[c + 8 >> 2], v[c + 12 >> 2], 0, d);
}

function Hc(a, b, c) {
 var d = 0;
 d = v[c + 4 >> 2];
 if ((d | 0) == (b | 0)) {
  a = m_(a, b, v[c >> 2], d);
 } else {
  a = 1;
 }
 return !a;
}

function Bv(a, b) {
 a: {
  if (b) {
   break a;
  }
  if (a >>> 0 <= 3) {
   a = a | -16;
   break a;
  }
  a = a >>> 2 | 0;
 }
 return a & 255;
}

function nz(a, b, c) {
 b = (B(B(lz(a), mz(a, b)), 125) >>> 0) / (WL(a, b) >>> 0) | 0;
 a = (a & 6) == 6 ? b & 134217724 : b;
 return a ? a : c;
}

function h0(a, b, c) {
 t[a + 2 | 0] = 1;
 b = b & 15;
 if (c) {
  b = w[b + 24640 | 0];
 } else {
  b = (b << 2) + 4 | 0;
 }
 t[a + 4 | 0] = b;
}

function es(a) {
 var b = 0;
 while (1) {
  if (!lc(w[a | 0], 0)) {
   a = a + 1 | 0;
   b = b + 1 | 0;
   continue;
  }
  break;
 }
 return b;
}

function Epa(a) {
 a = a | 0;
 var b = 0;
 b = eb - 16 | 0;
 eb = b;
 a = Wh(a, b + 8 | 0);
 eb = b + 16 | 0;
 return +(a ? A[b + 8 >> 3] : 0);
}

function EN(a, b, c, d, e) {
 if (!((b | 0) == (c | 0) | (d | 0) >= 0)) {
  t[b | 0] = 45;
  d = DN(d);
  b = b + 1 | 0;
 }
 qU(a, b, c, d, e);
}

function $T(a, b, c) {
 var d = 0;
 d = eb - 16 | 0;
 eb = d;
 a = ub(d + 12 | 0, TT(b, c, ce(a), fc(a)));
 eb = d + 16 | 0;
 return v[a >> 2];
}

function mS(a) {
 v[a + 20 >> 2] = 0;
 t[a + 16 | 0] = 7;
 v[a + 8 >> 2] = 1889785610;
 v[a + 12 >> 2] = 1072630333;
 t[a | 0] = 3;
 return a;
}

function bE(a, b) {
 if (b >>> 0 <= 126) {
  Ve(((b << 5) + a | 0) + 480280 | 0);
  Po((B(b, 872) + a | 0) + 1074992 | 0, a, b, 134217728);
 }
}

function uU(a, b, c) {
 while (1) {
  if ((b | 0) != (c | 0)) {
   sU(a, w[b | 0]);
   b = b + 1 | 0;
   continue;
  }
  break;
 }
 return a;
}

function gD(a, b) {
 var c = 0;
 c = eb - 16 | 0;
 eb = c;
 v[c + 12 >> 2] = a;
 oY(c + 12 | 0, b);
 eb = c + 16 | 0;
 return v[c + 12 >> 2];
}

function _ha(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 a = wj(a);
 if (a) {
  hb[v[v[a >> 2] + 76 >> 2]](a, b, c, d);
 }
}

function Zha(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 a = wj(a);
 if (a) {
  hb[v[v[a >> 2] + 84 >> 2]](a, b, c, d);
 }
}

function Xha(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 a = wj(a);
 if (a) {
  hb[v[v[a >> 2] + 92 >> 2]](a, b, c, d);
 }
}

function Uaa(a) {
 a = a | 0;
 var b = 0;
 b = eb - 16 | 0;
 eb = b;
 a = xf(b + 12 | 0, Rl(Dc(12), a));
 eb = b + 16 | 0;
 return v[a >> 2];
}

function S_(a, b) {
 var c = 0;
 c = eb - 16 | 0;
 eb = c;
 v[c + 12 >> 2] = a;
 R_(c + 12 | 0, b);
 eb = c + 16 | 0;
 return v[c + 12 >> 2];
}

function Nm(a) {
 a = a | 0;
 var b = 0;
 v[a >> 2] = 47556;
 b = v[a + 4 >> 2];
 if (b) {
  Bb(tq(b));
 }
 v[a + 4 >> 2] = 0;
 return a | 0;
}

function f9(a, b, c, d, e) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = +e;
 return hb[v[v[a >> 2] + 32 >> 2]](a, b, c, d, e) | 0;
}

function RP(a, b) {
 var c = 0;
 c = v[a + 12 >> 2];
 if ((c | 0) > 0) {
  v[a + 20 >> 2] = (v[a + 16 >> 2] + (b + c | 0) | 0) % (c | 0);
 }
}

function Pe(a, b) {
 var c = 0;
 c = eb - 16 | 0;
 eb = c;
 v[c + 12 >> 2] = a;
 a = vU(c + 12 | 0, b);
 eb = c + 16 | 0;
 return v[a >> 2];
}

function LX(a, b) {
 var c = 0;
 c = eb - 16 | 0;
 eb = c;
 v[c + 12 >> 2] = a;
 a = JX(c + 12 | 0, b);
 eb = c + 16 | 0;
 return v[a >> 2];
}

function GE(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0;
 c = eb - 16 | 0;
 eb = c;
 t[c + 15 | 0] = b;
 Bw(a, c + 15 | 0);
 eb = c + 16 | 0;
}

function tB(a) {
 var b = 0;
 v[a + 84 >> 2] = 0;
 v[a + 88 >> 2] = 0;
 b = v[a + 80 >> 2];
 v[a + 92 >> 2] = b;
 v[a + 96 >> 2] = b << 12;
}

function nS(a) {
 var b = 0;
 b = a + 4e4 | 0;
 while (1) {
  b = VA(b - 160 | 0);
  if ((b | 0) != (a | 0)) {
   continue;
  }
  break;
 }
}

function fh(a) {
 var b = 0;
 b = eb - 16 | 0;
 eb = b;
 a = Dp(a, b + 14 | 0);
 eb = b + 16 | 0;
 return (a ? x[b + 14 >> 1] : 0) & 65535;
}

function KQ(a) {
 var b = 0;
 b = eb - 16 | 0;
 eb = b;
 v[b + 12 >> 2] = a;
 oY(b + 12 | 0, -1);
 eb = b + 16 | 0;
 return v[b + 12 >> 2];
}

function ED(a) {
 var b = 0;
 b = nV(a);
 while (1) {
  if ((a | 0) != (b | 0)) {
   X$(a);
   a = a + 32 | 0;
   continue;
  }
  break;
 }
}

function oq(a) {
 a = a | 0;
 var b = 0;
 v[a >> 2] = 47536;
 b = v[a + 4 >> 2];
 if (b) {
  Bb(b);
  v[a + 4 >> 2] = 0;
 }
 return a | 0;
}

function et(a) {
 a = a | 0;
 var b = 0;
 v[a >> 2] = 95264;
 b = v[a + 8 >> 2];
 if (!(!b | !w[a + 12 | 0])) {
  Bb(b);
 }
 return a | 0;
}

function ax(a, b) {
 a = $F(a, v[b >> 2], v[b + 4 >> 2]);
 v[a + 8 >> 2] = v[b + 8 >> 2];
 $F(a + 12 | 0, v[b + 12 >> 2], v[b + 16 >> 2]);
}

function QD(a) {
 var b = 0;
 b = eb - 16 | 0;
 eb = b;
 v[b + 12 >> 2] = 0;
 Cu(b + 12 | 0, a);
 eb = b + 16 | 0;
 return v[b + 12 >> 2];
}

function ts(a, b, c, d) {
 if (!((b | 0) == (c | 0) | (d | 0) >= 0)) {
  t[b | 0] = 45;
  d = DN(d);
  b = b + 1 | 0;
 }
 FB(a, b, c, d);
}

function qy(a, b, c) {
 var d = 0;
 d = eb - 16 | 0;
 eb = d;
 c = qh(d + 12 | 0, c);
 a = It(a, b);
 ph(c);
 eb = d + 16 | 0;
 return a;
}

function iF(a) {
 var b = 0;
 b = a & 255;
 a = b >>> 21 | 0;
 b = (b << 11) + 2624 | 0;
 gb = b >>> 0 < 2624 ? a + 1 | 0 : a;
 return b;
}

function W7(a, b, c, d, e, f) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 f = f | 0;
 return GH(b, c, d, e, f, 1) | 0;
}

function UE(a) {
 var b = 0;
 b = v[a >> 2];
 if (v[b >> 2]) {
  SE(b, v[b >> 2]);
  a = v[a >> 2];
  b = v[a >> 2];
  TE(a);
  Bb(b);
 }
}

function U7(a, b, c, d, e, f) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 f = f | 0;
 return GH(b, c, d, e, f, 0) | 0;
}

function RQ(a, b, c) {
 while (1) {
  if (b) {
   z[a >> 2] = z[c >> 2];
   b = b - 1 | 0;
   a = a + 4 | 0;
   continue;
  }
  break;
 }
}

function QS(a, b) {
 var c = 0;
 c = w[a + 851 | 0];
 if (c & 1) {
  t[a + 851 | 0] = c | 64;
  v[a + 852 >> 2] = v[a + 852 >> 2] + b;
 }
}

function Mg(a) {
 t[a | 0] = 0;
 t[a + 1 | 0] = 0;
 t[a + 2 | 0] = 0;
 t[a + 3 | 0] = 0;
 t[a + 4 | 0] = 0;
 t[a + 5 | 0] = 0;
 return a;
}

function M7(a, b, c, d, e, f) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 f = f | 0;
 return EH(b, c, d, e, f, 1) | 0;
}

function Kv(a, b, c) {
 while (1) {
  if (b) {
   u[a >> 1] = x[c >> 1];
   b = b - 1 | 0;
   a = a + 2 | 0;
   continue;
  }
  break;
 }
}

function K7(a, b, c, d, e, f) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 f = f | 0;
 return EH(b, c, d, e, f, 0) | 0;
}

function JF(a, b, c) {
 while (1) {
  if (b) {
   v[a >> 2] = v[c >> 2];
   b = b - 1 | 0;
   a = a + 4 | 0;
   continue;
  }
  break;
 }
}

function P3() {
 if (w[499780]) {
  return v[124944];
 }
 Bs(499772, v[pH() >> 2]);
 t[499780] = 1;
 v[124944] = 499772;
 return 499772;
}

function I$(a) {
 var b = 0;
 if (!(id(a, 24692, 20) | (w[a + 25 | 0] - 9 & 255) >>> 0 < 248)) {
  b = t[a + 47 | 0] >= 0;
 }
 return b;
}

function ym(a, b, c) {
 var d = C(0);
 if (b >>> 0 <= c >>> 0) {
  d = z[xb(a + 4208 | 0, b) >> 2];
 } else {
  d = C(0);
 }
 return d;
}

function w2() {
 var a = 0;
 a: {
  if (SG(19989505)) {
   break a;
  }
  if (QG()) {
   break a;
  }
  a = PG() ^ 1;
 }
 return a | 0;
}

function sy(a, b, c, d) {
 var e = 0;
 e = eb - 16 | 0;
 eb = e;
 v[e + 12 >> 2] = d;
 a = rt(a, b, c, d);
 eb = e + 16 | 0;
 return a;
}

function r$(a, b, c) {
 var d = 0;
 d = eb - 16 | 0;
 eb = d;
 pi(d + 8 | 0, b, c);
 eb = d + 16 | 0;
 return v[d + 8 >> 2] == (a | 0);
}

function oK(a) {
 var b = 0;
 b = v[124107];
 if (a) {
  v[124107] = (a | 0) == -1 ? 501660 : a;
 }
 return (b | 0) == 501660 ? -1 : b;
}

function gL(a) {
 var b = 0;
 b = v[a >> 2];
 if (b) {
  if (!lc(hL(b), -1)) {
   return !v[a >> 2];
  }
  v[a >> 2] = 0;
 }
 return 1;
}

function f5(a, b, c, d, e) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 hb[v[v[b >> 2] + 16 >> 2]](a, b, c, d, e, 8);
}

function c$(a, b, c) {
 while (1) {
  if (b) {
   t[a | 0] = w[c | 0];
   b = b - 1 | 0;
   a = a + 1 | 0;
   continue;
  }
  break;
 }
}

function Dua(a, b) {
 var c = 0, d = 0;
 c = b & 31;
 d = (-1 >>> c & a) << c;
 c = a;
 a = 0 - b & 31;
 return d | (c & -1 << a) >>> a;
}
function $F(a, b, c) {
 var d = 0;
 d = eb - 16 | 0;
 eb = d;
 b = om(d + 8 | 0, b, c);
 CG(b, a);
 le(b);
 eb = d + 16 | 0;
 return a;
}

function sX(a, b) {
 var c = 0;
 c = eb - 16 | 0;
 eb = c;
 Dn(c + 8 | 0, b);
 kZ(a, v[c + 8 >> 2], v[c + 12 >> 2]);
 eb = c + 16 | 0;
}

function gT(a, b) {
 var c = 0;
 c = b & 15;
 if (c) {
  t[a + 830 | 0] = c;
 }
 b = b & 240;
 if (b) {
  t[a + 829 | 0] = b >>> 4;
 }
}

function en(a, b) {
 var c = 0;
 c = eb - 16 | 0;
 eb = c;
 a = ub(c + 12 | 0, (b << 1) + a | 0);
 eb = c + 16 | 0;
 return v[a >> 2];
}

function TY(a) {
 return (w[a | 0] | w[a + 1 | 0] << 8 | (w[a + 2 | 0] << 16 | w[a + 3 | 0] << 24)) == 1279544644 & w[a + 4 | 0] < 32;
}

function S4(a, b) {
 a = a | 0;
 b = b | 0;
 a = wd(a, 0);
 VI(a + 8 | 0, b);
 v[a >> 2] = 100292;
 v[a >> 2] = 100576;
 return a | 0;
}

function Q4(a, b) {
 a = a | 0;
 b = b | 0;
 a = wd(a, 0);
 VI(a + 8 | 0, b);
 v[a >> 2] = 100448;
 v[a >> 2] = 100692;
 return a | 0;
}

function J2(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 hb[v[v[b >> 2] + 8 >> 2]](b, c);
 Bs(a, v[b + 4 >> 2]);
 YG(b + 4 | 0, c);
}

function FV(a) {
 var b = 0;
 b = a & 255;
 a = b >>> 27 | 0;
 b = (b << 5) + 259 | 0;
 gb = b >>> 0 < 259 ? a + 1 | 0 : a;
 return b;
}

function z9(a, b) {
 a = a | 0;
 b = b | 0;
 a = v[a >> 2];
 b = v[b >> 2];
 return (a >>> 0 < b >>> 0 ? -1 : a >>> 0 > b >>> 0) | 0;
}

function nw(a, b) {
 var c = 0;
 c = eb - 16 | 0;
 eb = c;
 a = ub(c + 12 | 0, B(b, 6) + a | 0);
 eb = c + 16 | 0;
 return v[a >> 2];
}

function bea(a, b, c, d, e) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 return UH(a, b, c, d, e, 12433, 1075) | 0;
}

function Zl(a, b, c) {
 var d = 0;
 d = eb - 16 | 0;
 eb = d;
 t[d + 15 | 0] = c;
 Rh(a, b, d + 15 | 0);
 eb = d + 16 | 0;
 return a;
}

function Pea(a, b, c, d, e) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 return UH(a, b, c, d, e, 12533, 1048) | 0;
}

function A9(a, b) {
 a = a | 0;
 b = b | 0;
 a = x[a >> 1];
 b = x[b >> 1];
 return (a >>> 0 < b >>> 0 ? -1 : a >>> 0 > b >>> 0) | 0;
}

function zc(a, b) {
 var c = 0, d = 0;
 c = eb - 16 | 0;
 eb = c;
 d = c + 8 | 0;
 Dn(d, a);
 lm(d, b);
 eb = c + 16 | 0;
 return a;
}

function nA(a, b) {
 if ((a | 0) >= 0) {
  return (a >>> 0) % (b >>> 0) | 0;
 }
 return (((a ^ -1) >>> 0) % (b >>> 0) ^ -1) + b | 0;
}

function lu(a, b) {
 a = a | 0;
 b = b | 0;
 b = eb - 16 | 0;
 eb = b;
 v[b >> 2] = a;
 qP(18436, b);
 ku(125448);
 eb = b + 16 | 0;
}

function g0(a) {
 return (w[a | 0] | w[a + 1 | 0] << 8 | (w[a + 2 | 0] << 16 | w[a + 3 | 0] << 24)) == 810369604 & w[a + 4 | 0] < 4;
}

function _da(a, b, c, d, e) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 return RH(a, b, c, d, e, 9626, 1078) | 0;
}

function Yca(a, b, c, d, e) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 return wO(v[a + 4 >> 2], b, c, d, e) | 0;
}

function Vca(a, b, c, d, e) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 return pO(v[a + 4 >> 2], b, c, d, e) | 0;
}

function Rda(a, b, c, d, e) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 return RH(a, b, c, d, e, 9698, 1085) | 0;
}

function Ov(a, b) {
 var c = 0;
 c = eb - 16 | 0;
 eb = c;
 u[c + 14 >> 1] = b;
 Kv(a + 236 | 0, 128, c + 14 | 0);
 eb = c + 16 | 0;
}

function Lfa(a, b, c, d, e) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 return nP(a, b, c, d, 0, 0, 0, 0, e) | 0;
}

function wR(a) {
 var b = 0;
 b = v[a >> 2];
 v[a >> 2] = 0;
 if (b) {
  if (w[fc(a) + 4 | 0]) {
   Db(b + 16 | 0);
  }
  Bb(b);
 }
}

function sx() {
 var a = 0, b = 0;
 a = eb - 16 | 0;
 eb = a;
 b = xf(a + 12 | 0, Mb(Dc(12)));
 eb = a + 16 | 0;
 return v[b >> 2];
}

function mZ(a) {
 var b = 0;
 b = v[a >> 2];
 v[a >> 2] = 0;
 if (b) {
  if (w[fc(a) + 4 | 0]) {
   Nj(b + 16 | 0);
  }
  Bb(b);
 }
}

function YB(a, b) {
 a = Rl(a, b);
 Uc(a + 12 | 0, b + 12 | 0);
 u[a + 28 >> 1] = x[b + 28 >> 1];
 v[a + 24 >> 2] = v[b + 24 >> 2];
}

function WT(a) {
 var b = 0;
 b = v[a >> 2];
 v[a >> 2] = 0;
 if (b) {
  if (w[fc(a) + 4 | 0]) {
   XT(b + 16 | 0);
  }
  Bb(b);
 }
}

function Mx(a, b, c, d) {
 var e = 0;
 e = v[b >> 2];
 v[a + 8 >> 2] = b;
 v[a >> 2] = e;
 v[a + 4 >> 2] = (c << d) + e;
 return a;
}

function E5(a, b) {
 a = a | 0;
 b = b | 0;
 if ((b | 0) >= 0) {
  b = v[((b & 255) << 2) + 107088 >> 2];
 }
 return b << 24 >> 24;
}

function C5(a, b) {
 a = a | 0;
 b = b | 0;
 if ((b | 0) >= 0) {
  b = v[((b & 255) << 2) + 105552 >> 2];
 }
 return b << 24 >> 24;
}

function $K(a) {
 var b = 0;
 b = v[a >> 2];
 if (b) {
  if (!jo(ql(b))) {
   return !v[a >> 2];
  }
  v[a >> 2] = 0;
 }
 return 1;
}

function x$(a, b) {
 return (Xb((B(a >>> 4 | 0, b) >>> 0) / 15 | 0, 1, 15) << 4 | Xb((B(a & 15, b) >>> 0) / 15 | 0, 1, 15)) & 255;
}

function p4(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 a = dy(b, v[a + 8 >> 2]);
 return ((a | 0) == -1 ? c : a) << 24 >> 24;
}

function cu(a) {
 if (PM(a)) {
  a = cc(4);
  v[a >> 2] = 0;
  a = Cj(a);
  v[a >> 2] = 124032;
  ca(a | 0, 124068, 34);
  p();
 }
}

function Z2(a, b, c, d, e, f) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 f = f | 0;
 hb[a | 0](b, c, d, e, f);
}

function SJ(a, b) {
 var c = 0;
 c = eb - 16 | 0;
 eb = c;
 v[c + 12 >> 2] = b;
 a = pK(a, 11188, b);
 eb = c + 16 | 0;
 return a;
}

function HX(a) {
 var b = 0;
 while (1) {
  if ((b | 0) != 512) {
   ch(a + b | 0);
   b = b + 1 | 0;
   continue;
  }
  break;
 }
}

function wJ(a, b) {
 a = wd(a, b);
 t[a + 12 | 0] = 0;
 v[a + 8 >> 2] = 0;
 v[a >> 2] = 95264;
 v[a + 8 >> 2] = 95312;
 return a;
}

function Qg(a) {
 var b = 0;
 b = eb - 16 | 0;
 eb = b;
 a = Mn(a, b + 12 | 0);
 eb = b + 16 | 0;
 return a ? v[b + 12 >> 2] : 0;
}

function Fq(a, b, c) {
 a = Hl(a) - v[a + 16 >> 2] | 0;
 if (a >>> 0 >= 2) {
  c = C(C(C(c - b) / C(a >>> 0)) + b);
 }
 return c;
}

function DG(a, b) {
 var c = 0;
 c = eb - 16 | 0;
 eb = c;
 b = Ef(c + 8 | 0, b);
 CG(b, a);
 le(b);
 eb = c + 16 | 0;
 return a;
}

function wk(a, b, c) {
 var d = 0;
 d = eb - 16 | 0;
 eb = d;
 $B(d + 8 | 0, a, b, c);
 eb = d + 16 | 0;
 return v[d + 12 >> 2];
}

function vA(a, b, c) {
 var d = 0;
 d = eb - 16 | 0;
 eb = d;
 jR(d + 8 | 0, a, b, c);
 eb = d + 16 | 0;
 return v[d + 12 >> 2];
}

function uA(a, b, c) {
 var d = 0;
 d = eb - 16 | 0;
 eb = d;
 Iv(d + 8 | 0, a, b, c);
 eb = d + 16 | 0;
 return v[d + 12 >> 2];
}

function sm(a) {
 var b = 0;
 b = mx(a + 4 | 0);
 if ((b | 0) == -1) {
  hb[v[v[a >> 2] + 8 >> 2]](a);
 }
 return (b | 0) == -1;
}

function rD(a) {
 var b = 0;
 while (1) {
  if ((b | 0) != 4) {
   ch(a + b | 0);
   b = b + 1 | 0;
   continue;
  }
  break;
 }
}

function lW(a, b, c) {
 var d = 0;
 d = v[b >> 2];
 v[a + 8 >> 2] = b;
 v[a >> 2] = d;
 v[a + 4 >> 2] = B(c, 12) + d;
 return a;
}

function bC(a, b, c) {
 var d = 0;
 d = eb - 16 | 0;
 eb = d;
 RU(d + 8 | 0, a, b, c);
 eb = d + 16 | 0;
 return v[d + 12 >> 2];
}

function aia(a, b) {
 a = a | 0;
 b = b | 0;
 a = wj(a);
 if (!a) {
  return 1;
 }
 return hb[v[v[a >> 2] + 68 >> 2]](a, b) | 0;
}

function Lv(a, b, c) {
 var d = 0;
 d = eb - 16 | 0;
 eb = d;
 sY(d + 8 | 0, a, b, c);
 eb = d + 16 | 0;
 return v[d + 12 >> 2];
}

function LJ(a, b, c) {
 var d = 0;
 d = eb - 16 | 0;
 eb = d;
 aE(d + 8 | 0, a, b, c);
 eb = d + 16 | 0;
 return v[d + 12 >> 2];
}

function GL(a, b) {
 b = v[a + 32 >> 2] + b | 0;
 v[a + 32 >> 2] = b;
 if (b >>> 0 >= y[a + 40 >> 2]) {
  v[a + 96 >> 2] = 1;
 }
}

function zU(a, b) {
 return (a >>> 0 <= 62 ? 63 - (B((b ^ -1) & 63, (a ? a + 1 | 0 : 0) & 255) >>> 6 | 0) | b & 192 : b) & 255;
}

function yC(a, b) {
 var c = 0;
 c = v[b + 4 >> 2];
 v[a >> 2] = v[b >> 2];
 v[a + 4 >> 2] = c;
 v[a + 8 >> 2] = v[b + 8 >> 2];
}

function W2(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 a = hb[a | 0](b, c, d) | 0;
 fb = gb;
 return a | 0;
}

function Ok(a, b) {
 var c = 0;
 c = eb - 16 | 0;
 eb = c;
 a = ub(c + 12 | 0, a + b | 0);
 eb = c + 16 | 0;
 return v[a >> 2];
}

function Nd() {
 var a = 0;
 if (w[499756]) {
  return v[124938];
 }
 a = kk(14276);
 t[499756] = 1;
 v[124938] = a;
 return a;
}

function Ie(a, b, c) {
 if (An(a, b, c)) {
  a = Zi(a, c);
  a = Hb(v[a >> 2], v[a + 4 >> 2]);
 } else {
  a = 0;
 }
 return a;
}

function Hx(a, b) {
 b = a + b | 0;
 while (1) {
  b = sb(b - 12 | 0);
  if ((b | 0) != (a | 0)) {
   continue;
  }
  break;
 }
}

function DL(a) {
 var b = 0;
 b = +((a & 2097151) >>> 0);
 return C(nk(+C((a | 0) < 0 ? -b : b), (a >>> 21 & 1023) - 788 | 0));
}

function yda(a, b, c, d, e) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 return Ks(a, b, c, d, e, 1100) | 0;
}

function xda(a, b, c, d, e) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 return Ks(a, b, c, d, e, 1102) | 0;
}

function vda(a, b, c, d, e) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 return Ks(a, b, c, d, e, 1104) | 0;
}

function t$(a) {
 var b = 0;
 b = v[a >> 2];
 if (v[b >> 2]) {
  Mc(b);
  a = v[a >> 2];
  b = v[a >> 2];
  iw(a);
  Bb(b);
 }
}

function oW(a) {
 var b = 0;
 b = v[a >> 2];
 if (v[b >> 2]) {
  Mc(b);
  a = v[a >> 2];
  b = v[a >> 2];
  zb(a);
  Bb(b);
 }
}

function eW(a) {
 var b = 0;
 b = v[a >> 2];
 if (v[b >> 2]) {
  Mc(b);
  a = v[a >> 2];
  b = v[a >> 2];
  lv(a);
  Bb(b);
 }
}

function XV(a) {
 var b = 0;
 b = v[a >> 2];
 if (v[b >> 2]) {
  Mc(b);
  a = v[a >> 2];
  b = v[a >> 2];
  hx(a);
  Bb(b);
 }
}

function Vo(a) {
 t[a | 0] = 0;
 t[a + 1 | 0] = 0;
 t[a + 2 | 0] = 0;
 t[a + 3 | 0] = 0;
 t[a + 4 | 0] = 0;
 t[a + 5 | 0] = 0;
}

function UA(a) {
 var b = 0;
 b = eb - 16 | 0;
 eb = b;
 ub(b + 12 | 0, a + 116 | 0);
 a = dS(a);
 eb = b + 16 | 0;
 return a;
}

function Rca(a, b, c, d, e) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 return YH(a, b, c, d, e, 1115) | 0;
}

function RF(a) {
 var b = 0;
 b = v[a >> 2];
 if (v[b >> 2]) {
  Mc(b);
  a = v[a >> 2];
  b = v[a >> 2];
  Gn(a);
  Bb(b);
 }
}

function R1(a) {
 a = a | 0;
 var b = 0;
 b = v[a + 4 >> 2];
 return (hb[v[v[b >> 2] + 20 >> 2]](b) | 0) + v[a + 12 >> 2] | 0;
}

function LQ(a) {
 var b = 0;
 b = v[a >> 2];
 if (v[b >> 2]) {
  Mc(b);
  a = v[a >> 2];
  b = v[a >> 2];
  Ug(a);
  Bb(b);
 }
}

function IF(a, b) {
 while (1) {
  if (b) {
   v[a >> 2] = 0;
   b = b - 1 | 0;
   a = a + 4 | 0;
   continue;
  }
  break;
 }
}

function EG(a) {
 var b = 0;
 b = v[a >> 2];
 if (v[b >> 2]) {
  Mc(b);
  a = v[a >> 2];
  b = v[a >> 2];
  Rn(a);
  Bb(b);
 }
}

function tJ(a, b) {
 a = wd(a, b);
 v[a + 8 >> 2] = 46;
 v[a + 12 >> 2] = 44;
 v[a >> 2] = 96552;
 Eb(a + 16 | 0);
 return a;
}

function sfa(a, b, c, d, e) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 return Ks(a, b, c, d, e, 993) | 0;
}

function he(a) {
 var b = 0;
 b = eb - 16 | 0;
 eb = b;
 v[b + 12 >> 2] = 48520;
 pc(a, 48416, b + 12 | 0);
 eb = b + 16 | 0;
}

function gO(a, b, c, d, e) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 return Js(a, b, c, d, e, 1099) | 0;
}

function dO(a, b, c, d, e) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 return Js(a, b, c, d, e, 1101) | 0;
}

function cO(a, b, c, d, e) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 return Js(a, b, c, d, e, 1103) | 0;
}

function bO(a, b, c, d, e) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 return Js(a, b, c, d, e, 1019) | 0;
}

function VN(a, b, c, d, e) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 return Ox(a, b, c, d, e, 1100) | 0;
}

function UN(a, b, c, d, e) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 return Gs(a, b, c, d, e, 1100) | 0;
}

function Sv(a, b, c) {
 var d = C(0);
 d = z[a >> 2];
 if (!Rv(d, z[b >> 2])) {
  b = Rv(z[c >> 2], d) ? c : a;
 }
 return b;
}

function SN(a, b, c, d, e) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 return Ox(a, b, c, d, e, 1102) | 0;
}

function RN(a, b, c, d, e) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 return Gs(a, b, c, d, e, 1102) | 0;
}

function QN(a, b, c, d, e) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 return Ox(a, b, c, d, e, 1104) | 0;
}

function PN(a, b, c, d, e) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 return Gs(a, b, c, d, e, 1104) | 0;
}

function mP(a, b, c, d, e) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 return YH(a, b, c, d, e, 994) | 0;
}

function VR(a, b) {
 var c = 0, d = 0;
 c = eb - 16 | 0;
 eb = c;
 d = c + 4 | 0;
 LC(d, 1, b);
 Bc(a, d);
 eb = c + 16 | 0;
}

function TV(a, b, c, d, e, f) {
 a = ub(a, b);
 ub(a + 4 | 0, c);
 ub(a + 8 | 0, d);
 ub(a + 12 | 0, e);
 ub(a + 16 | 0, f);
}

function ON(a, b, c, d, e) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 return Gs(a, b, c, d, e, 993) | 0;
}

function Ls(a, b, c, d) {
 if (b >>> 0 >= d >>> 0) {
  Sj();
  p();
 }
 c = Dc(B(b, c));
 v[a + 4 >> 2] = b;
 v[a >> 2] = c;
}

function GF(a, b) {
 if ((a & 4088) >>> 0 >= 520) {
  b = Sw(0 - Dua(b ^ 1230262859, 25) | 0, 4) ^ 1247037516;
 }
 return b;
}

function u3(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 if (kh(a, v[b + 8 >> 2], 0)) {
  Ux(b, c, d);
 }
}

function ry(a) {
 a = a | 0;
 v[a >> 2] = 96464;
 if (v[a + 8 >> 2] != (Nd() | 0)) {
  hl(v[a + 8 >> 2]);
 }
 return a | 0;
}

function ed(a, b, c) {
 var d = 0;
 d = eb - 16 | 0;
 eb = d;
 v[d + 12 >> 2] = c;
 pn(a, b, d + 12 | 0);
 eb = d + 16 | 0;
}

function Wg(a, b, c) {
 var d = 0;
 d = eb - 16 | 0;
 eb = d;
 $B(d + 8 | 0, b, b + c | 0, a);
 eb = d + 16 | 0;
 return a;
}

function Up(a, b, c, d) {
 v[a >> 2] = b;
 b = v[b + 4 >> 2];
 v[a + 4 >> 2] = b;
 v[a + 8 >> 2] = b + (c << d);
 return a;
}

function T2(a, b, c, d, e) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 return hb[a | 0](b, c, d, e) | 0;
}

function Ou(a, b) {
 if (!(t[b + 851 | 0] & 1 & v[a + 480180 >> 2] == 8)) {
  KA(a, b, 0);
  KA(a, b, 1);
  KA(a, b, 2);
 }
}

function Nx(a, b, c, d) {
 if (b >>> 0 >= d >>> 0) {
  Sj();
  p();
 }
 c = Dc(b << c);
 v[a + 4 >> 2] = b;
 v[a >> 2] = c;
}

function If(a, b, c) {
 if ((c | 0) >= 0) {
  a = (v[((c & 255) << 2) + a >> 2] & b) != 0;
 } else {
  a = 0;
 }
 return a;
}

function Cl(a, b, c) {
 a = a + 1074992 | 0;
 return v[(a + B(b, 872) | 0) + 680 >> 2] > v[(a + B(c, 872) | 0) + 680 >> 2];
}

function Bba(a, b, c, d, e) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = +d;
 e = +e;
 return lN(a - 88 | 0, b, c, d, e) | 0;
}

function qP(a, b) {
 var c = 0;
 c = eb - 16 | 0;
 eb = c;
 v[c + 12 >> 2] = b;
 tL(125448, a, b, 0, 0);
 eb = c + 16 | 0;
}

function oJ(a, b) {
 a = wd(a, b);
 b = a + 8 | 0;
 v[b >> 2] = 104244;
 v[a >> 2] = 99228;
 v[b >> 2] = 99276;
 return a;
}

function nJ(a, b) {
 a = wd(a, b);
 b = a + 8 | 0;
 v[b >> 2] = 104280;
 v[a >> 2] = 99492;
 v[b >> 2] = 99540;
 return a;
}

function kJ(a) {
 var b = 0;
 b = v[a >> 2];
 if (v[b >> 2]) {
  Mc(b);
  a = v[a >> 2];
  ny(it(a), v[a >> 2], Ug(a));
 }
}

function Zw(a, b) {
 var c = 0;
 if ((b | 0) < 0) {
  Sj();
  p();
 }
 c = Dc(b << 1);
 v[a + 4 >> 2] = b;
 v[a >> 2] = c;
}

function Yl(a, b) {
 var c = 0, d = 0, e = 0;
 c = v[a + 24 >> 2];
 d = a, e = Te(zi(b) * +(c >>> 0)), v[d + 24 >> 2] = e;
}

function Yj(a, b, c) {
 var d = 0;
 d = v[a >> 2];
 if (!_q(d, v[b >> 2])) {
  b = _q(v[c >> 2], d) ? c : a;
 }
 return b;
}

function Xg(a, b, c) {
 var d = 0;
 d = A[a >> 3];
 if (!yV(d, A[b >> 3])) {
  b = yV(A[c >> 3], d) ? c : a;
 }
 return b;
}

function Sp(a, b, c, d) {
 v[a >> 2] = b;
 b = v[b + 4 >> 2];
 v[a + 4 >> 2] = b;
 v[a + 8 >> 2] = b + B(c, d);
 return a;
}

function Lk(a, b) {
 var c = 0;
 c = v[b + 4 >> 2];
 v[a >> 2] = v[b >> 2];
 v[a + 4 >> 2] = c;
 gc(a + 8 | 0, b + 8 | 0);
}

function GV(a) {
 if ((w[a + 14 | 0] - 53 & 255) >>> 0 >= 252) {
  a = id(a, 15608, 14);
 } else {
  a = 1;
 }
 return !a;
}

function Ef(a, b) {
 v[a >> 2] = v[b >> 2];
 v[a + 4 >> 2] = v[b + 4 >> 2];
 v[b >> 2] = 0;
 v[b + 4 >> 2] = 0;
 return a;
}

function jf(a) {
 a = a | 0;
 var b = 0;
 b = v[a >> 2];
 return (hb[v[v[b >> 2] + 24 >> 2]](b) | 0) - v[a + 8 >> 2] | 0;
}

function gq(a) {
 a = a | 0;
 v[a + 56 >> 2] = 93888;
 v[a >> 2] = 93868;
 Ct(a + 4 | 0);
 sl(a + 56 | 0);
 return a | 0;
}

function em(a, b) {
 var c = 0, d = 0;
 c = eb - 16 | 0;
 eb = c;
 d = c + 8 | 0;
 B0(d, a);
 lm(d, b);
 eb = c + 16 | 0;
}

function T$(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 return S$(a, b, Jb(c), Cb(v[c + 4 >> 2], w[c + 11 | 0])) | 0;
}

function Ff(a) {
 a = a | 0;
 v[a + 60 >> 2] = 94052;
 v[a >> 2] = 94032;
 Ct(a + 8 | 0);
 sl(a + 60 | 0);
 return a | 0;
}

function CC(a, b, c) {
 var d = 0;
 d = v[b >> 2];
 v[a + 8 >> 2] = b;
 v[a >> 2] = d;
 v[a + 4 >> 2] = c + d;
 return a;
}

function Ae(a, b) {
 var c = 0, d = 0;
 c = eb - 16 | 0;
 eb = c;
 d = c + 8 | 0;
 Tw(d, a);
 lm(d, b);
 eb = c + 16 | 0;
}

function og(a) {
 var b = 0;
 b = eb - 16 | 0;
 eb = b;
 a = ub(b + 12 | 0, fc(a));
 eb = b + 16 | 0;
 return v[a >> 2];
}

function mv(a, b) {
 a = Ab(a & 65535);
 b = Ab(b & 65535);
 return (a | 0) != (b | 0) ? a >>> 0 < b >>> 0 ? -1 : 1 : 0;
}

function iA(a, b) {
 if ((a | 0) >= 0) {
  return (a | 0) / (b | 0) | 0;
 }
 return ((a + 1 | 0) / (b | 0) | 0) - 1 | 0;
}

function Si(a) {
 var b = 0;
 b = eb - 16 | 0;
 eb = b;
 a = ub(b + 12 | 0, vb(a));
 eb = b + 16 | 0;
 return v[a >> 2];
}

function Of(a) {
 var b = 0;
 b = eb - 16 | 0;
 eb = b;
 a = ub(b + 12 | 0, og(a));
 eb = b + 16 | 0;
 return v[a >> 2];
}

function Hh(a, b) {
 var c = 0;
 c = a;
 a = v[a + 8 >> 2];
 b = a - b | 0;
 v[c + 8 >> 2] = a >>> 0 >= b >>> 0 ? b : 0;
}

function nia(a) {
 a = a | 0;
 t[a + 4202 | 0] = 1;
 v[a + 4232 >> 2] = v[v[a + 16 >> 2] + 24620 >> 2];
 tu(a);
 yQ(a);
}

function nL(a, b, c, d, e, f) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 f = f | 0;
 $h(a, -1, -1);
}

function Y7(a, b, c, d, e) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 return HH(b, c, d, e, 1) | 0;
}

function V7(a, b, c, d, e) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 return HH(b, c, d, e, 0) | 0;
}

function Pga(a) {
 a = a | 0;
 t[a + 4202 | 0] = 1;
 v[a + 4256 >> 2] = v[v[a + 16 >> 2] + 24620 >> 2];
 VP(a);
 TP(a);
}

function O7(a, b, c, d, e) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 return FH(b, c, d, e, 1) | 0;
}

function L7(a, b, c, d, e) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 return FH(b, c, d, e, 0) | 0;
}

function uK(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 hb[v[v[a >> 2] + 32 >> 2]](a, b, c, d) | 0;
}

function sI(a) {
 return (a | 0) != 0 & (a | 0) != 104872 & (a | 0) != 104896 & (a | 0) != 501568 & (a | 0) != 501592;
}

function nK(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 hb[v[v[a >> 2] + 48 >> 2]](a, b, c, d) | 0;
}

function jM(a, b) {
 a = On(a);
 t[a + 8 | 0] = 0;
 v[a + 4 >> 2] = b;
 v[a >> 2] = 77100;
 Mb(a + 12 | 0);
 return a;
}

function jA(a, b) {
 if ((a | 0) >= 0) {
  return (a | 0) % (b | 0) | 0;
 }
 return ((a ^ -1) % (b | 0) ^ -1) + b | 0;
}

function ge(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0;
 d = v[b + 8 >> 2];
 Ub(b, c);
 px(a, b, d, c);
}

function T_(a, b) {
 a = a | 0;
 b = b | 0;
 if (v[a + 4 >> 2] != v[zb(a) >> 2]) {
  gM(a, b);
  return;
 }
 bM(a, b);
}

function Q8(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 if ((c | 0) != 1) {
  VK(a, c);
  return;
 }
 Cc(a, 7920);
}

function OJ(a, b) {
 var c = 0, d = 0;
 Qe(a, me(b));
 b = fc(b);
 c = fc(a), d = v[b >> 2], v[c >> 2] = d;
 return a;
}

function K6() {
 var a = 0, b = 0, c = 0;
 a = wd(501120, 1);
 v[a >> 2] = 96464;
 b = a, c = Nd(), v[b + 8 >> 2] = c;
}

function EA(a, b) {
 a = a | 0;
 b = b | 0;
 if (v[a + 4 >> 2] != v[zb(a) >> 2]) {
  WR(a, b);
  return;
 }
 hA(a, b);
}

function YR(a, b) {
 a = a | 0;
 b = b | 0;
 if (y[a + 4 >> 2] < y[zb(a) >> 2]) {
  WR(a, b);
  return;
 }
 hA(a, b);
}

function Oha(a, b) {
 a = a | 0;
 b = b | 0;
 a = v[a + 20 >> 2];
 t[a + 24 | 0] = w[a + 24 | 0] & 253 | (b ? 2 : 0);
}

function M5(a, b) {
 a = a | 0;
 b = b | 0;
 if (b >>> 0 <= 127) {
  b = v[(b << 2) + 107088 >> 2];
 }
 return b | 0;
}

function K5(a, b) {
 a = a | 0;
 b = b | 0;
 if (b >>> 0 <= 127) {
  b = v[(b << 2) + 105552 >> 2];
 }
 return b | 0;
}

function vb(a) {
 var b = 0;
 b = eb - 16 | 0;
 eb = b;
 a = ub(b + 12 | 0, a);
 eb = b + 16 | 0;
 return v[a >> 2];
}

function sU(a, b) {
 var c = 0;
 c = a;
 a = v[a >> 2];
 v[c >> 2] = a << 8 ^ v[((a >>> 24 ^ b) << 2) + 27500 >> 2];
}

function rM(a) {
 a = On(a);
 v[a >> 2] = 77564;
 Mb(a + 4 | 0);
 t[a + 20 | 0] = 0;
 v[a + 16 >> 2] = 0;
 return a;
}

function pj(a, b, c) {
 if (v[a + 80 >> 2]) {
  v[a + 92 >> 2] = v[a + 92 >> 2] + (c + 7 & -8);
  return;
 }
 Bb(b);
}

function Wo(a, b) {
 a = yc(a, b, 34);
 u[a + 34 >> 1] = x[b + 34 >> 1];
 yc(a + 36 | 0, b + 36 | 0, 68);
 return a;
}

function Pj(a) {
 var b = 0;
 b = eb - 16 | 0;
 eb = b;
 a = xf(b + 12 | 0, a);
 eb = b + 16 | 0;
 return v[a >> 2];
}

function E3(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 if (!w[501688]) {
  t[501688] = 1;
 }
 Yb(a, c, 125892);
}

function zca(a, b) {
 a = a | 0;
 b = b | 0;
 a = v[a + 4 >> 2];
 return EO(v[a + 24 >> 2], z[a + 48 >> 2], b) | 0;
}

function ng(a) {
 var b = 0, c = 0;
 sc(a + 4 | 0);
 Ec(a + 8 | 0, 0);
 b = a, c = fc(a), v[b >> 2] = c;
 return a;
}

function gsa(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 Uc(a, oZ(b, Jb(c), Cb(v[c + 4 >> 2], w[c + 11 | 0])));
}

function ai(a, b) {
 a = a | 0;
 b = b | 0;
 t[a | 0] = 2;
 t[a + 1 | 0] = 3;
 t[a + 2 | 0] = 0;
 t[a + 3 | 0] = 4;
}

function Ze(a) {
 var b = 0;
 b = eb - 16 | 0;
 eb = b;
 Ln(b + 8 | 0, a);
 eb = b + 16 | 0;
 return v[b + 8 >> 2];
}

function Zda(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 return Vn(a, b, c, d, 12934, 1079) | 0;
}

function Wda(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 return Vn(a, b, c, d, 13008, 1081) | 0;
}

function Tb(a) {
 var b = 0;
 if (ud(w[a + 11 | 0])) {
  b = v[a >> 2];
  Yi(v[a + 8 >> 2]);
  Bb(b);
 }
 return a;
}

function Co(a) {
 var b = 0;
 b = a;
 a = v[a >> 2];
 v[b >> 2] = B(a, 214013) + 2531011;
 return a >>> 16 & 32767;
}

function CK() {
 var a = 0;
 a = eb - 16 | 0;
 v[a + 8 >> 2] = 0;
 v[a + 12 >> 2] = 1048576;
 return A[a + 8 >> 3];
}

function Bra(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0;
 d = c, e = vp(a, b), v[d >> 2] = e;
}

function Ara(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 var d = 0, e = 0;
 d = c, e = Ow(a, b), u[d >> 1] = e;
}

function AB(a) {
 var b = 0;
 if (!(w[a + 2 | 0] | (w[a | 0] | w[a + 1 | 0]))) {
  b = !w[a + 3 | 0];
 }
 return b;
}

function $p(a, b, c, d, e) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 v[e >> 2] = c;
 return 3;
}

function zH(a, b) {
 v[a >> 2] = b;
 Tb(a + 52 | 0);
 Tb(a + 40 | 0);
 Tb(a + 28 | 0);
 sb(a + 16 | 0);
 return a;
}

function yj(a) {
 if (Nb(a + 1074312 | 0, 7)) {
  a = wn(v[a + 480180 >> 2]) ^ 1;
 } else {
  a = 0;
 }
 return a;
}

function yH(a, b) {
 v[a >> 2] = b;
 sb(a + 48 | 0);
 sb(a + 36 | 0);
 sb(a + 24 | 0);
 sb(a + 12 | 0);
 return a;
}

function mz(a, b) {
 return w[(B(a >>> 1 & 3, 15) + B(a >>> 3 & 1, 45) + ((b & 240) >>> 4) | 0) + 80849 | 0] << 1;
}

function dda(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 return vO(v[a + 4 >> 2], b, c, d) | 0;
}

function cda(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 return tO(v[a + 4 >> 2], b, c, d) | 0;
}

function aea(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 return Vn(a, b, c, d, 9420, 1076) | 0;
}

function ada(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 return uO(v[a + 4 >> 2], b, c, d) | 0;
}

function _ca(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 return sO(v[a + 4 >> 2], b, c, d) | 0;
}

function Zca(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 return yO(v[a + 4 >> 2], b, c, d) | 0;
}

function Y6(a, b, c, d, e, f) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 f = f | 0;
 ig(a, f);
}

function Xda(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 return Vn(a, b, c, d, 9581, 1080) | 0;
}

function X6(a, b, c, d, e, f) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 f = f | 0;
 aq(a, f);
}

function Wca(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 return rO(v[a + 4 >> 2], b, c, d) | 0;
}

function Vda(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 return Vn(a, b, c, d, 9659, 1082) | 0;
}

function Uda(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 return Vn(a, b, c, d, 9451, 1083) | 0;
}

function Joa(a, b, c, d, e) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 eH(a, b, c, d, e, 133);
}

function H4(a, b) {
 a = a | 0;
 b = b | 0;
 a = Cj(a);
 v[a >> 2] = 124560;
 Zx(a + 4 | 0, Jb(b));
 return a | 0;
}

function iq(a) {
 if (w[a + 2 | 0] & 2) {
  a = (w[a + 1 | 0] & 6) == 6 ? 4 : 1;
 } else {
  a = 0;
 }
 return a;
}

function dsa(a, b, c, d, e) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 eH(a, b, c, d, e, 91);
}

function Xo(a, b, c) {
 v[a >> 2] = b;
 b = v[b + 4 >> 2];
 v[a + 4 >> 2] = b;
 v[a + 8 >> 2] = b + c;
 return a;
}

function MS(a, b, c) {
 var d = 0;
 return !b | !(w[a + 35 | 0] & 4 ? !a | (c | 0) != 1 : 1) ? d : w[b + 34 | 0];
}

function G_(a, b) {
 var c = 0;
 c = Jb(a);
 return F_(c, (Cb(v[a + 4 >> 2], w[a + 11 | 0]) + c | 0) + 1 | 0, b);
}

function X9(a) {
 a = a | 0;
 a = v[a + 24 >> 2];
 return hM(v[(v[v[a >> 2] - 12 >> 2] + a | 0) + 16 >> 2]) ^ 1;
}

function X2(a, b, c, d, e) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
 hb[a | 0](b, c, d, e);
}

function Rga(a, b) {
 a = a | 0;
 b = b | 0;
 return C(b >>> 0 <= 4 ? z[((b << 2) + a | 0) + 4220 >> 2] : C(0));
}

function lba(a, b) {
 a = a | 0;
 b = b | 0;
 sp(v[a + 4 >> 2]);
 oG(pG(v[a + 4 >> 2], b));
 sp(v[a + 4 >> 2]);
}

function jua(a) {
 a = a | 0;
 v[a + 16 >> 2] = v[a + 16 >> 2] | 1;
 if (t[a + 20 | 0] & 1) {
  ta();
  p();
 }
}

function Yc(a, b, c, d, e) {
 t[a + 3 | 0] = e;
 t[a + 2 | 0] = d;
 t[a + 1 | 0] = c;
 t[a | 0] = b;
 return a;
}

function Jp(a, b) {
 v[a >> 2] = v[b >> 2];
 v[a + 4 >> 2] = v[b + 4 >> 2];
 v[b >> 2] = 0;
 v[b + 4 >> 2] = 0;
}

function Jm(a, b) {
 t[a | 0] = b;
 t[a + 1 | 0] = b >>> 8;
 t[a + 2 | 0] = b >>> 16;
 t[a + 3 | 0] = b >>> 24;
}

function H3(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 return lc(a, v[b + 4 >> 2]) & v[b >> 2] == (c | 0);
}

function vG(a, b) {
 a = a | 0;
 b = b | 0;
 a = Cj(a);
 v[a >> 2] = 124560;
 Zx(a + 4 | 0, b);
 return a | 0;
}

function $h(a, b, c) {
 v[a + 8 >> 2] = b;
 v[a + 12 >> 2] = c;
 v[a >> 2] = 0;
 v[a + 4 >> 2] = 0;
 return a;
}

function sf(a) {
 if (ud(w[a + 11 | 0])) {
  gd(v[a >> 2], 0);
  Ad(a, 0);
  return;
 }
 gd(a, 0);
 Me(a, 0);
}

function Lc(a) {
 if (ud(w[a + 11 | 0])) {
  a = Yi(v[a + 8 >> 2]) - 1 | 0;
 } else {
  a = 10;
 }
 return a;
}

function yz(a, b) {
 var c = 0, d = 0;
 c = ub(a, v[v[b >> 2] - 12 >> 2] + b | 0), d = b, v[c + 4 >> 2] = d;
}

function uda(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 return Hs(a, b, c, d, 1106) | 0;
}

function uc(a) {
 var b = 0;
 b = eb - 16 | 0;
 eb = b;
 LQ(ub(b + 12 | 0, a));
 eb = b + 16 | 0;
 return a;
}

function tda(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 return Hs(a, b, c, d, 1108) | 0;
}

function sn(a) {
 if (ud(w[a + 11 | 0])) {
  a = Yi(v[a + 8 >> 2]) - 1 | 0;
 } else {
  a = 1;
 }
 return a;
}

function si(a) {
 return (fk(v[a >> 2], v[a + 4 >> 2]) | 0) != (0 - fk(v[a + 12 >> 2], v[a + 16 >> 2]) | 0);
}

function sda(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 return Hs(a, b, c, d, 1110) | 0;
}

function rda(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 return Hs(a, b, c, d, 1112) | 0;
}

function ov(a, b) {
 a = a & 255;
 b = b & 255;
 return (a | 0) != (b | 0) ? a >>> 0 < b >>> 0 ? -1 : 1 : 0;
}

function hE(a, b, c) {
 var d = 0;
 d = (b | 0) / (c | 0) | 0;
 v[a >> 2] = d;
 v[a + 4 >> 2] = b - B(c, d);
}

function ec(a) {
 var b = 0;
 b = eb - 16 | 0;
 eb = b;
 BZ(ub(b + 12 | 0, a));
 eb = b + 16 | 0;
 return a;
}

function bg(a) {
 var b = 0;
 b = wb(a, 2);
 return w[wb(a, 1) | 0] << 8 | w[b | 0] << 16 | w[wb(a, 0) | 0];
}

function UX(a, b) {
 t[a + 6 | 0] = 255;
 v[a + 16 >> 2] = b;
 u[a + 4 >> 1] = 0;
 v[a >> 2] = 0;
 return a;
}

function Oca(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 return NH(a, b, c, d, 1115) | 0;
}

function GU(a, b) {
 v[a + 4 >> 2] = 0;
 v[a + 8 >> 2] = 0;
 v[a >> 2] = b ? b : 49716;
 v[a + 12 >> 2] = 0;
}

function xB(a, b) {
 var c = 0;
 c = a;
 a = (b >>> 0) / 100 | 0;
 return Gl(Gl(c, a), B(a, -100) + b | 0);
}

function uB(a, b) {
 var c = 0;
 c = a;
 a = (b >>> 0) / 1e4 | 0;
 return xB(Gl(c, a), B(a, -1e4) + b | 0);
}

function ny(a, b, c) {
 a: {
  if ((a | 0) == (b | 0)) {
   t[b + 120 | 0] = 0;
   break a;
  }
  Bb(b);
 }
}

function np(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 return hb[v[v[a >> 2] + 48 >> 2]](a, b, c) | 0;
}

function nj(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 return hb[v[v[a >> 2] + 12 >> 2]](a, b, c) | 0;
}

function aO(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 return Is(a, b, c, d, 1105) | 0;
}

function _N(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 return Is(a, b, c, d, 1109) | 0;
}

function YN(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 return Is(a, b, c, d, 1111) | 0;
}

function SY(a) {
 t[a + 4 | 0] = 0;
 t[a | 0] = 0;
 t[a + 1 | 0] = 0;
 t[a + 2 | 0] = 0;
 t[a + 3 | 0] = 0;
}

function Ru(a, b) {
 var c = 0;
 c = a;
 a = (b >>> 0) / 1e6 | 0;
 return uB(Gl(c, a), B(a, -1e6) + b | 0);
}

function Qca(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 return NH(a, b, c, d, 994) | 0;
}

function NT(a) {
 v[a >> 2] = 0;
 v[a + 4 >> 2] = 0;
 v[a >> 2] = -2078137563;
 v[a + 4 >> 2] = -873292572;
}

function NN(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 return Fs(a, b, c, d, 1106) | 0;
}

function MN(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 return Fs(a, b, c, d, 1108) | 0;
}

function Lb(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 return hb[v[v[a >> 2] + 32 >> 2]](a, b, c) | 0;
}

function KN(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 return Fs(a, b, c, d, 1110) | 0;
}

function JN(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 return Fs(a, b, c, d, 1112) | 0;
}

function Aqa(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 return Qx(a, b, c, d, 585) | 0;
}

function $N(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 return Is(a, b, c, d, 1107) | 0;
}

function zI(a, b, c) {
 var d = 0;
 d = c;
 c = Df(b);
 if (d >>> 0 > c >>> 0) {
  jO(a, b);
 }
 return c;
}

function uJ(a, b) {
 a = wd(a, b);
 u[a + 8 >> 1] = 11310;
 v[a >> 2] = 96512;
 Eb(a + 12 | 0);
 return a;
}

function uG(a, b) {
 a = Ef(a, b);
 v[a + 8 >> 2] = v[b + 8 >> 2];
 Ef(a + 12 | 0, b + 12 | 0);
 return a;
}

function qx(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 return Qx(a, b, c, d, 163) | 0;
}

function jd(a, b) {
 a = DG(a, b);
 v[a + 8 >> 2] = v[b + 8 >> 2];
 DG(a + 12 | 0, b + 12 | 0);
 return a;
}

function X_(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 return Qx(a, b, c, d, 339) | 0;
}

function WL(a, b) {
 a = a ^ -1;
 return v[(b & 12) + 80852 >> 2] >>> (a >>> 3 & 1) >>> (a >>> 4 & 1) | 0;
}

function Jb(a) {
 var b = 0, c = 0, d = 0;
 return b = v[a >> 2], c = a, d = ud(w[a + 11 | 0]), d ? b : c;
}

function kB(a, b) {
 v[a >> 2] = v[b >> 2];
 u[a + 4 >> 1] = x[b + 4 >> 1];
 t[a + 6 | 0] = w[b + 6 | 0];
}

function jQ(a) {
 a = a | 0;
 v[a >> 2] = 44652;
 uc(a + 4276 | 0);
 uc(a + 4264 | 0);
 return Zf(a) | 0;
}

function bS(a, b, c, d, e) {
 v[a + 12 >> 2] = e;
 v[a + 8 >> 2] = d;
 v[a + 4 >> 2] = c;
 v[a >> 2] = b;
}

function Vx(a, b, c) {
 if (!(v[a + 28 >> 2] == 1 | v[a + 4 >> 2] != (b | 0))) {
  v[a + 28 >> 2] = c;
 }
}

function U2(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 return hb[a | 0](b, c, d) | 0;
}

function Bk(a) {
 var b = 0;
 b = x[a + 172 >> 1];
 a = x[a + 156 >> 1];
 return (AV(a) ? b : a) & 65535;
}

function zu(a, b, c) {
 var d = 0;
 d = eb - 16 | 0;
 eb = d;
 RU(d + 8 | 0, a, b, c);
 eb = d + 16 | 0;
}

function vO(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 return QH(a, b, c, d, 4) | 0;
}

function uO(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 return QH(a, b, c, d, 2) | 0;
}

function tO(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 return PH(a, b, c, d, 4) | 0;
}

function sO(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 return PH(a, b, c, d, 2) | 0;
}

function fD(a, b, c) {
 var d = 0;
 d = eb - 16 | 0;
 eb = d;
 Iv(d + 8 | 0, a, b, c);
 eb = d + 16 | 0;
}

function e6(a) {
 a = a | 0;
 if (!w[500008]) {
  tn(499996, 96780);
  t[500008] = 1;
 }
 return 499996;
}

function dw(a, b, c) {
 var d = 0;
 d = eb - 16 | 0;
 eb = d;
 aE(d + 8 | 0, a, b, c);
 eb = d + 16 | 0;
}

function ds(a) {
 v[a >> 2] = 0;
 v[a + 4 >> 2] = 0;
 v[a + 8 >> 2] = 0;
 v[a + 12 >> 2] = 0;
 return a;
}

function d6(a) {
 a = a | 0;
 if (!w[500040]) {
  tn(500028, 96864);
  t[500040] = 1;
 }
 return 500028;
}

function c6(a) {
 a = a | 0;
 if (!w[499944]) {
  tn(499932, 96708);
  t[499944] = 1;
 }
 return 499932;
}

function bU(a, b, c) {
 if (Ie(a, b, c)) {
  a = v[Vb(a, c) + 12 >> 2];
 } else {
  a = 1;
 }
 return a;
}

function b6(a) {
 a = a | 0;
 if (!w[499976]) {
  tn(499964, 96744);
  t[499976] = 1;
 }
 return 499964;
}

function Z5(a) {
 a = a | 0;
 if (!w[499992]) {
  Cc(499980, 13617);
  t[499992] = 1;
 }
 return 499980;
}

function XU(a, b, c) {
 var d = 0;
 d = eb - 16 | 0;
 eb = d;
 WU(d + 8 | 0, a, b, c);
 eb = d + 16 | 0;
}

function W5(a) {
 a = a | 0;
 if (!w[499960]) {
  Cc(499948, 13766);
  t[499960] = 1;
 }
 return 499948;
}

function VM(a, b) {
 var c = 0;
 c = v[a >> 2];
 v[a >> 2] = b;
 if (c) {
  to(c + 120 | 0);
  Bb(c);
 }
}

function yL(a, b) {
 a = wL(a - 1 | 0);
 if (!a) {
  a = wL(b);
  a = a ? a + 32 | 0 : 0;
 }
 return a;
}

function wD(a, b) {
 if (b) {
  wD(a, v[b >> 2]);
  wD(a, v[b + 4 >> 2]);
  Nj(b + 16 | 0);
  Bb(b);
 }
}

function vD(a, b) {
 if (b) {
  vD(a, v[b >> 2]);
  vD(a, v[b + 4 >> 2]);
  Nj(b + 16 | 0);
  Bb(b);
 }
}

function pg(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0;
 c = Dc(b);
 v[a + 4 >> 2] = b;
 v[a >> 2] = c;
}

function pG(a, b) {
 a = a | 0;
 b = b | 0;
 return CF(a, Jb(b), Cb(v[b + 4 >> 2], w[b + 11 | 0])) | 0;
}

function oc(a, b) {
 var c = 0, d = 0;
 v[a >> 2] = b;
 c = a, d = Df(b), v[c + 4 >> 2] = d;
 return a;
}

function my(a) {
 a = a | 0;
 if (v[a + 8 >> 2] != (Nd() | 0)) {
  hl(v[a + 8 >> 2]);
 }
 return a | 0;
}

function _W(a, b, c, d) {
 v[a >> 2] = b;
 v[a + 4 >> 2] = c;
 Yb(a + 8 | 0, v[d >> 2], v[d + 4 >> 2]);
}

function Y5(a) {
 a = a | 0;
 if (!w[500024]) {
  Cc(500012, 9253);
  t[500024] = 1;
 }
 return 500012;
}

function X5(a) {
 a = a | 0;
 if (!w[499928]) {
  Cc(499916, 5265);
  t[499928] = 1;
 }
 return 499916;
}

function Mq(a, b) {
 if (b) {
  Mq(a, v[b >> 2]);
  Mq(a, v[b + 4 >> 2]);
  XT(b + 16 | 0);
  Bb(b);
 }
}

function Mj(a, b) {
 a = a | 0;
 b = b | 0;
 var c = 0;
 c = xY(b);
 v[a + 4 >> 2] = b;
 v[a >> 2] = c;
}

function H5(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 return (b >>> 0 < 128 ? b : c) << 24 >> 24;
}

function GB(a, b) {
 if (b) {
  GB(a, v[b >> 2]);
  GB(a, v[b + 4 >> 2]);
  _m(b + 16 | 0);
  Bb(b);
 }
}

function DA(a, b) {
 if (b) {
  DA(a, v[b >> 2]);
  DA(a, v[b + 4 >> 2]);
  Db(b + 16 | 0);
  Bb(b);
 }
}

function Py(a, b) {
 var c = 0;
 c = Ut(a + 4 | 0);
 v[a >> 2] = 94680;
 v[c >> 2] = 94700;
 oo(c, b);
}

function Oy(a, b) {
 var c = 0;
 c = NK(a + 4 | 0);
 v[a >> 2] = 95048;
 v[c >> 2] = 95068;
 oo(c, b);
}

function HY(a, b) {
 v[a >> 2] = v[b >> 2];
 u[a + 4 >> 1] = x[b + 4 >> 1];
 gc(a + 8 | 0, b + 8 | 0);
}

function s$(a, b, c) {
 a = a & 255;
 return a >>> 0 >= (b & 255) >>> 0 & a >>> 0 <= (c & 255) >>> 0;
}

function pU(a, b) {
 b = 1 / (1 / (b * 6.283185307179586 / 3546895) + 1);
 iU(a, b, 0, 0, b + -1, 0);
}

function cI(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 return kO(a, b, c, d) | 0;
}

function cC(a, b) {
 a = Mb(a);
 Eb(a + 12 | 0);
 u[a + 28 >> 1] = 0;
 v[a + 24 >> 2] = b;
 return a;
}

function YK(a, b, c, d, e, f, g, h) {
 return hb[v[v[a >> 2] + 16 >> 2]](a, b, c, d, e, f, g, h) | 0;
}

function UV(a, b, c, d, e) {
 a = ub(a, b);
 ub(a + 4 | 0, c);
 ub(a + 8 | 0, d);
 ub(a + 12 | 0, e);
}

function q8(a) {
 a = a | 0;
 var b = 0;
 b = v[124946] + 1 | 0;
 v[124946] = b;
 v[a + 4 >> 2] = b;
}

function n3(a) {
 a = a | 0;
 if (!a) {
  return 0;
 }
 return (iB(a, 124116, 124260) | 0) != 0 | 0;
}

function Vs(a) {
 return a >>> 0 < 32 | a - 127 >>> 0 < 33 | (a & -2) == 8232 | a - 65529 >>> 0 < 3;
}

function Sr(a, b, c) {
 if (_c(a, b) >>> 0 <= c >>> 0) {
  Iw();
  p();
 }
 return (c << 1) + a | 0;
}

function Oc(a, b, c) {
 if (nc(a, b) >>> 0 <= c >>> 0) {
  Iw();
  p();
 }
 return (c << 2) + a | 0;
}

function aI(a, b, c, d, e, f, g) {
 return Ia(a | 0, b | 0, c | 0, d | 0, e | 0, f | 0, g | 0) | 0;
}

function BZ(a) {
 var b = 0;
 b = v[a >> 2];
 if (v[b >> 2]) {
  Mc(b);
  Bb(v[v[a >> 2] >> 2]);
 }
}

function AU(a) {
 if (a >>> 0 <= 8) {
  return w[a + 27488 | 0];
 }
 return w[a + 27479 | 0] | 256;
}

function PS(a, b) {
 v[a + 852 >> 2] = v[a + 852 >> 2] + b;
 t[a + 851 | 0] = w[a + 851 | 0] | 64;
}

function yv(a) {
 var b = 0;
 b = eb - 16 | 0;
 eb = b;
 oW(ub(b + 12 | 0, a));
 eb = b + 16 | 0;
}

function wz(a) {
 var b = 0;
 b = eb - 16 | 0;
 eb = b;
 bN(ub(b + 12 | 0, a));
 eb = b + 16 | 0;
}

function wsa(a, b) {
 a = a | 0;
 b = b | 0;
 a = QZ(a, b);
 if (!a) {
  PZ(b);
 }
 return a | 0;
}

function oy(a) {
 var b = 0;
 b = eb - 16 | 0;
 eb = b;
 kJ(ub(b + 12 | 0, a));
 eb = b + 16 | 0;
}

function nd(a) {
 var b = 0;
 b = eb - 16 | 0;
 eb = b;
 RF(ub(b + 12 | 0, a));
 eb = b + 16 | 0;
}

function l4(a, b) {
 a = a | 0;
 b = b | 0;
 a = XI(a, b, 1);
 v[a >> 2] = 104316;
 return a | 0;
}

function jn(a) {
 var b = 0;
 b = eb - 16 | 0;
 eb = b;
 eW(ub(b + 12 | 0, a));
 eb = b + 16 | 0;
}

function hY(a) {
 var b = 0;
 b = eb - 16 | 0;
 eb = b;
 aY(ub(b + 12 | 0, a));
 eb = b + 16 | 0;
}

function fia(a, b) {
 a = a | 0;
 b = b | 0;
 if (!v[31601]) {
  v[31601] = a;
  v[31602] = b;
 }
}

function fW(a) {
 var b = 0;
 b = eb - 16 | 0;
 eb = b;
 XV(ub(b + 12 | 0, a));
 eb = b + 16 | 0;
}

function bV(a, b) {
 var c = 0, d = 0;
 c = ub(a, v[b >> 2]), d = w[b + 4 | 0], t[c + 4 | 0] = d;
}

function _r(a, b) {
 var c = 0;
 c = b + 1 | 0;
 v[a >> 2] = v[a >> 2] > (c | 0) ? c : b + 2 | 0;
}

function Zs(a) {
 var b = 0;
 b = eb - 16 | 0;
 eb = b;
 ph(qh(b + 12 | 0, a));
 eb = b + 16 | 0;
}

function Xfa(a, b) {
 a = a | 0;
 b = b | 0;
 if (!b) {
  return 3;
 }
 v[b >> 2] = a;
 return 0;
}

function Sd(a) {
 var b = 0;
 b = eb - 16 | 0;
 eb = b;
 LH(ub(b + 12 | 0, a));
 eb = b + 16 | 0;
}

function Qc(a) {
 var b = 0;
 b = eb - 16 | 0;
 eb = b;
 UE(ub(b + 12 | 0, a));
 eb = b + 16 | 0;
}

function Pka(a, b) {
 a = a | 0;
 b = b | 0;
 a = PY(a, b);
 if (!a) {
  OY(b);
 }
 return a | 0;
}

function Jk(a) {
 var b = 0;
 b = eb - 16 | 0;
 eb = b;
 t$(ub(b + 12 | 0, a));
 eb = b + 16 | 0;
}

function G4(a, b) {
 a = a | 0;
 b = b | 0;
 a = WI(a, b, 1);
 v[a >> 2] = 104412;
 return a | 0;
}

function Be(a) {
 var b = 0;
 b = eb - 16 | 0;
 eb = b;
 EG(ub(b + 12 | 0, a));
 eb = b + 16 | 0;
}

function yr(a, b) {
 a = a | 0;
 b = b | 0;
 a = d$(a, b);
 if (!a) {
  gw(b);
 }
 return a | 0;
}

function ui(a, b) {
 a = a | 0;
 b = b | 0;
 a = Wh(a, b);
 if (!a) {
  Zk(b);
 }
 return a | 0;
}

function u0(a, b) {
 a = a | 0;
 b = b | 0;
 a = zE(a, b);
 if (!a) {
  FE(b);
 }
 return a | 0;
}

function ps(a, b) {
 a = a | 0;
 b = b | 0;
 a = gG(a, b);
 if (!a) {
  ux(b);
 }
 return a | 0;
}

function gga(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 return dj(a, b, c, 974, 86224) | 0;
}

function fp(a, b) {
 a = a | 0;
 b = b | 0;
 a = b$(a, b);
 if (!a) {
  f$(b);
 }
 return a | 0;
}

function cx(a, b) {
 a = a | 0;
 b = b | 0;
 a = _F(a, b);
 if (!a) {
  cs(b);
 }
 return a | 0;
}

function Ysa(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 gH(a, b, c, d, 363);
}

function Vj(a, b) {
 if (Lg(v[a >> 2], v[a + 4 >> 2]) >>> 0 > b >>> 0) {
  t[a + 16 | 0] = b;
 }
}

function Pr(a, b) {
 a = a | 0;
 b = b | 0;
 a = Mn(a, b);
 if (!a) {
  Bn(b);
 }
 return a | 0;
}

function Nra(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 gH(a, b, c, d, 474);
}

function Mp(a, b) {
 a = a | 0;
 b = b | 0;
 a = lx(a, b);
 if (!a) {
  kx(b);
 }
 return a | 0;
}

function Kta(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 nH(a, b, c, d, 133);
}

function DD(a, b) {
 a = a | 0;
 b = b | 0;
 a = aZ(a, b);
 if (!a) {
  sD(b);
 }
 return a | 0;
}

function CT(a, b) {
 a = a | 0;
 b = b | 0;
 a = u$(a, b);
 if (!a) {
  Dr(b);
 }
 return a | 0;
}

function xga(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 return dj(a, b, c, 971, 5048) | 0;
}

function nga(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 return dj(a, b, c, 973, 4276) | 0;
}

function kia(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 return dj(a, b, c, 947, 4304) | 0;
}

function kha(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 return dj(a, b, c, 966, 4280) | 0;
}

function jla(a, b) {
 a = a | 0;
 b = b | 0;
 a = aw(a, b);
 v[a >> 2] = 124768;
 return a | 0;
}

function hba(a, b) {
 a = a | 0;
 b = b | 0;
 v[a >> 2] = v[b >> 2];
 ig(a + 4 | 0, b + 4 | 0);
}

function bha(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 return dj(a, b, c, 967, 4276) | 0;
}

function _sa(a, b) {
 a = a | 0;
 b = b | 0;
 a = aw(a, b);
 v[a >> 2] = 124716;
 return a | 0;
}

function Vga(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 return dj(a, b, c, 968, 4268) | 0;
}

function Pra(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 nH(a, b, c, d, 91);
}

function K1(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 ac(a, v[d >> 2], 0);
}

function Gga(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 return dj(a, b, c, 970, 4228) | 0;
}

function Eha(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 return dj(a, b, c, 963, 4236) | 0;
}

function Bia(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 return dj(a, b, c, 939, 4268) | 0;
}

function zm(a, b) {
 return b ? a << 24 | (a & 65280) << 8 | (a >>> 8 & 65280 | a >>> 24) : a;
}

function xw(a, b) {
 return Te(zi((+(a | 0) * 128 + +(b | 0)) * .0006510416666666666) * 8363);
}

function gqa(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 cH(a, b, c, d, 3);
}

function f_(a, b) {
 a = a | 0;
 b = b | 0;
 a = aw(a, b);
 v[a >> 2] = 124580;
 return a | 0;
}

function cz(a) {
 return ((Mh(a) + (Mh(a) << 8) | 0) + (Mh(a) << 16) | 0) + (Mh(a) << 24) | 0;
}

function Y2(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 hb[a | 0](b, c, d);
}

function Sj() {
 var a = 0;
 a = Pm(cc(4));
 v[a >> 2] = 124444;
 ca(a | 0, 124520, 34);
 p();
}

function Mpa(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 cH(a, b, c, d, 2);
}

function AG(a, b, c) {
 a = On(a);
 v[a + 8 >> 2] = c;
 v[a + 4 >> 2] = b;
 v[a >> 2] = 78416;
}

function z5(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 return ((b | 0) < 0 ? c : b) | 0;
}

function y8(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 gb = 0;
 return 0;
}

function ro(a, b) {
 if (y[a + 4 >> 2] < y[zb(a) >> 2]) {
  gM(a, b);
  return;
 }
 bM(a, b);
}

function rS(a, b, c, d) {
 u[a >> 1] = b;
 t[a + 2 | 0] = w[c | 0];
 t[a + 3 | 0] = w[d | 0];
}

function lY(a, b, c, d) {
 a = Ge(a, b);
 u[a + 22 >> 1] = d;
 u[a + 20 >> 1] = c;
 return a;
}

function fu(a, b) {
 var c = 0;
 c = E(a) + 32 | 0;
 a = E(b);
 return (a | 0) == 32 ? c : a;
}

function ft(a, b, c, d) {
 return a >>> 0 < c >>> 0 & (b | 0) <= (d | 0) | (b | 0) < (d | 0);
}

function bda(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 return +oO(v[a + 4 >> 2], b, c);
}

function Wc(a) {
 var b = 0;
 b = v[a >> 2];
 v[a >> 2] = 0;
 if (b) {
  uu(b);
 }
 return a;
}

function Rw(a, b, c, d) {
 return (b | 0) == (d | 0) & a >>> 0 < c >>> 0 | b >>> 0 < d >>> 0;
}

function Q6(a) {
 a = a | 0;
 a = v[a + 8 >> 2];
 if (!a) {
  return 1;
 }
 return FJ(a) | 0;
}

function Os(a) {
 var b = 0;
 b = eb - 16 | 0;
 A[b + 8 >> 3] = a;
 return A[b + 8 >> 3] * a;
}

function Kp(a, b, c) {
 a = Ef(a, b);
 v[a + 8 >> 2] = 0;
 Ef(a + 12 | 0, c);
 le(c);
 le(b);
}

function zg(a, b, c, d) {
 v[a + 8 >> 2] = d;
 v[a + 4 >> 2] = c;
 v[a >> 2] = b;
 return a;
}

function um(a, b) {
 a = a | 0;
 b = b | 0;
 return hb[v[v[a >> 2] + 32 >> 2]](a, 0, b) | 0;
}

function uha(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 return Px(a, b, c, 0, 965) | 0;
}

function uN(a) {
 a = a | 0;
 return +(+y[v[a + 32 >> 2] + 480240 >> 2] * 152587890625e-16);
}

function ok(a, b) {
 a = a | 0;
 b = b | 0;
 return hb[v[v[a >> 2] + 52 >> 2]](a, b, 0) | 0;
}

function gx(a, b) {
 a = Uc(a, b);
 gc(a + 12 | 0, b + 12 | 0);
 re(a + 32 | 0, b + 32 | 0);
}

function eQ(a) {
 a = a | 0;
 return C(C(C(z[xb(a + 4208 | 0, 5) >> 2] * C(198)) + C(-99)));
}

function ZA(a) {
 sb(a + 48 | 0);
 sb(a + 36 | 0);
 sb(a + 24 | 0);
 sb(a + 12 | 0);
 sb(a);
}

function U$(a, b) {
 if (!b) {
  return -1;
 }
 b = sq(a, b, 0);
 return b ? b - a | 0 : -1;
}

function Oga(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 return Px(a, b, c, 0, 969) | 0;
}

function Hga(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 return Px(a, b, c, 1, 969) | 0;
}

function $z(a) {
 a = a | 0;
 v[a + 32 >> 2] = 0;
 v[a + 28 >> 2] = v[a + 28 >> 2] & -7 | 2;
}

function q0(a, b) {
 return ft(v[b >> 2], v[b + 4 >> 2], v[a >> 2], v[a + 4 >> 2]) ? b : a;
}

function om(a, b, c) {
 v[a + 4 >> 2] = c;
 v[a >> 2] = b;
 if (c) {
  nm(c);
 }
 return a;
}

function od(a) {
 a = (a | 0) >= 32767 ? 32767 : a;
 return (a | 0) <= -32768 ? -32768 : a;
}

function jca(a, b) {
 a = a | 0;
 b = b | 0;
 return GO(v[v[a + 4 >> 2] + 24 >> 2], b) | 0;
}

function er(a, b, c) {
 a = Ab(a & 65535);
 return (a | 0) >= (b | 0) & (a | 0) <= (c | 0);
}

function Wr(a, b) {
 return Rw(v[b >> 2], v[b + 4 >> 2], v[a >> 2], v[a + 4 >> 2]) ? b : a;
}

function S1(a) {
 a = a | 0;
 a = v[a + 4 >> 2];
 return hb[v[v[a >> 2] + 16 >> 2]](a) | 0;
}

function NR(a, b, c, d) {
 u[a + 4 >> 1] = c;
 t[a + 6 | 0] = b;
 v[a >> 2] = d;
 return a;
}

function Lx(a) {
 var b = 0;
 b = eb - 16 | 0;
 z[b + 12 >> 2] = a;
 return z[b + 12 >> 2];
}

function Gk(a) {
 var b = 0;
 b = v[a >> 2];
 v[a >> 2] = 0;
 if (b) {
  fc(a);
  Bb(b);
 }
}

function Bg(a) {
 var b = 0;
 b = hr(Df(a) + 1 | 0, 1);
 if (b) {
  jO(b, a);
 }
 return b;
}

function zp(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 Vl(a, b, Ei(b, b + c | 0, 0));
}

function wC(a, b) {
 return (+(a >>> 0) + +(b | 0) * 4294967296) * 2.3283064365386963e-10;
}

function qp(a, b) {
 v[a >> 2] = v[(v[v[b >> 2] - 12 >> 2] + b | 0) + 24 >> 2];
 return a;
}

function mM(a, b) {
 a = (a + b | 0) - 1 | 0;
 return a - ((a >>> 0) % (b >>> 0) | 0) | 0;
}

function lI(a, b) {
 var c = 0;
 c = a;
 a = v[a >> 2] + b | 0;
 v[c >> 2] = a;
 return a;
}

function dca(a, b) {
 a = a | 0;
 b = b | 0;
 return C(_O(v[v[a + 4 >> 2] + 24 >> 2], b));
}

function cca(a, b) {
 a = a | 0;
 b = b | 0;
 return C(ZO(v[v[a + 4 >> 2] + 24 >> 2], b));
}

function bca(a, b) {
 a = a | 0;
 b = b | 0;
 return C(WO(v[v[a + 4 >> 2] + 24 >> 2], b));
}

function Zba(a, b) {
 a = a | 0;
 b = b | 0;
 return C(YO(v[v[a + 4 >> 2] + 24 >> 2], b));
}

function Yba(a, b) {
 a = a | 0;
 b = b | 0;
 return C(XO(v[v[a + 4 >> 2] + 24 >> 2], b));
}

function T1(a) {
 a = a | 0;
 a = v[a + 4 >> 2];
 return hb[v[v[a >> 2] + 8 >> 2]](a) | 0;
}

function Ch(a, b, c) {
 a = ub(a, b);
 mr(a + 4 | 0, v[c >> 2], v[c + 4 >> 2]);
 return a;
}

function o7(a, b) {
 a = a | 0;
 b = b | 0;
 NS(a, Vy(v[b >> 2]) << 24 >> 24, v[b >> 2]);
}

function mL(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 $h(a, -1, -1);
}

function im(a, b) {
 a = a | 0;
 b = b | 0;
 return hb[v[v[a >> 2] + 28 >> 2]](a, b) | 0;
}

function gh(a, b, c, d) {
 gb = b - ((a >>> 0 < c >>> 0) + d | 0) | 0;
 return a - c | 0;
}

function gS(a, b) {
 var c = 0;
 c = v[a >> 2];
 v[a >> 2] = b;
 if (c) {
  Bb(El(c));
 }
}

function Ky(a, b) {
 a = a | 0;
 b = b | 0;
 return hb[v[v[a >> 2] + 12 >> 2]](a, b) | 0;
}

function FG(a, b) {
 var c = 0;
 c = v[a >> 2];
 v[a >> 2] = b;
 if (c) {
  Bb(ec(c));
 }
}

function Bt(a, b) {
 a = a | 0;
 b = b | 0;
 return hb[v[v[a >> 2] + 44 >> 2]](a, b) | 0;
}

function zQ(a, b, c, d, e) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 e = e | 0;
}

function yra(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 Vl(a, b, Sc(b, c) + b | 0);
}

function o0(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 return sH(a, b, c, 262) | 0;
}

function kw(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 return sH(a, b, c, 322) | 0;
}

function at(a) {
 a = a | 0;
 v[a >> 2] = 96344;
 hl(v[a + 16 >> 2]);
 return et(a) | 0;
}

function __(a) {
 return (w[a + 47 | 0] + w[a + 45 | 0] | 0) + (w[a + 46 | 0] << 5) | 0;
}

function Vha(a) {
 a = a | 0;
 a = wj(a);
 if (a) {
  hb[v[v[a >> 2] + 100 >> 2]](a);
 }
}

function Ol(a, b) {
 a = t[wb(a + 62 | 0, b) | 0];
 return ((a | 0) < 0 ? -1 : a) & 255;
}

function NW(a) {
 return w[a + 15 | 0] << 12 | w[a + 14 | 0] << 4 | w[a + 13 | 0] << 20;
}

function L5(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 return DH(b, c, 107088) | 0;
}

function J5(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 return DH(b, c, 105552) | 0;
}

function F_(a, b, c) {
 if (qn(c, a)) {
  a = 0;
 } else {
  a = qn(c, b);
 }
 return a;
}

function D5(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 return CH(b, c, 107088) | 0;
}

function Bn(a) {
 t[a | 0] = 0;
 t[a + 1 | 0] = 0;
 t[a + 2 | 0] = 0;
 t[a + 3 | 0] = 0;
}

function B5(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 return CH(b, c, 105552) | 0;
}

function Ao(a, b, c, d) {
 a = ov(a, c);
 if (Kj(a)) {
  a = UT(b, d);
 }
 return ud(a);
}

function Aja(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 return dH(a, b, c, 63) | 0;
}

function $g(a) {
 var b = 0, c = 0;
 b = a, c = WZ(v[a >> 2]), v[b >> 2] = c;
 return a;
}

function wL(a) {
 var b = 0, c = 0, d = 0;
 return b = zua(a), c = 0, d = a, d ? b : c;
}

function w8(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 Vl(a, c, d);
}

function t8(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
 eq(a, c, d);
}

function oba(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 Uc(a, S$(c, 0, b, Df(b)));
}

function mx(a) {
 var b = 0;
 b = a;
 a = v[a >> 2] - 1 | 0;
 v[b >> 2] = a;
 return a;
}

function lK(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 Gu(a, b, c);
 return a | 0;
}

function h2(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 px(a, b, v[b + 8 >> 2], c);
}

function Un(a, b, c, d) {
 v[a + 16 >> 2] = d;
 v[a + 12 >> 2] = c;
 v[a + 8 >> 2] = b;
}

function Sb(a, b) {
 var c = 0;
 c = v[a >> 2];
 v[a >> 2] = v[b >> 2];
 v[b >> 2] = c;
}

function DR(a, b) {
 var c = 0;
 c = x[a >> 1];
 u[a >> 1] = x[b >> 1];
 u[b >> 1] = c;
}

function vl(a) {
 var b = 0;
 b = v[a >> 2];
 v[a >> 2] = 0;
 if (b) {
  Bb(nf(b));
 }
}

function sN(a) {
 a = a | 0;
 return +(+v[v[a + 32 >> 2] + 1074456 >> 2] * .00390625);
}

function eg(a, b, c, d) {
 b = b + d | 0;
 gb = a + c >>> 0 < c >>> 0 ? b + 1 | 0 : b;
}

function WS(a) {
 var b = 0;
 b = v[a >> 2];
 v[a >> 2] = 0;
 if (b) {
  Bb(lB(b));
 }
}

function AA(a, b, c) {
 A[a >> 3] = A[a >> 3] + b;
 A[a + 8 >> 3] = A[a + 8 >> 3] + c;
}

function xo(a, b) {
 return (((a << 12 & b >> 31) + b | 0) / 4096 | 0) % (a | 0) | 0;
}

function uC(a, b) {
 if (b) {
  uC(a, v[b >> 2]);
  uC(a, v[b + 4 >> 2]);
  Bb(b);
 }
}

function tC(a, b) {
 if (b) {
  tC(a, v[b >> 2]);
  tC(a, v[b + 4 >> 2]);
  Bb(b);
 }
}

function iD(a, b) {
 if (b) {
  iD(a, v[b >> 2]);
  iD(a, v[b + 4 >> 2]);
  Bb(b);
 }
}

function UM(a, b) {
 var c = 0;
 c = v[a >> 2];
 v[a >> 2] = b;
 if (c) {
  uu(c);
 }
}

function SR(a, b) {
 return b >>> 0 >= 4e3 ? 22256 : ((b << 5) + a | 0) + 946304 | 0;
}

function Nu(a, b) {
 if (b) {
  Nu(a, v[b >> 2]);
  Nu(a, v[b + 4 >> 2]);
  Bb(b);
 }
}

function Mu(a, b) {
 if (b) {
  Mu(a, v[b >> 2]);
  Mu(a, v[b + 4 >> 2]);
  Bb(b);
 }
}

function LM(a, b) {
 a = a | 0;
 b = b | 0;
 return Rd(v[b >> 2], v[b + 4 >> 2]) | 0;
}

function LL(a) {
 while (1) {
  if ((St(a) | 0) != -1) {
   continue;
  }
  break;
 }
}

function KM(a, b) {
 a = a | 0;
 b = b | 0;
 return Oj(v[b >> 2], v[b + 4 >> 2]) | 0;
}

function Jca(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 OO(a, v[b + 4 >> 2], c);
}

function JD(a, b) {
 if (b) {
  JD(a, v[b >> 2]);
  JD(a, v[b + 4 >> 2]);
  Bb(b);
 }
}

function ID(a, b) {
 if (b) {
  ID(a, v[b >> 2]);
  ID(a, v[b + 4 >> 2]);
  Bb(b);
 }
}

function IA(a, b) {
 var c = 0;
 c = v[a >> 2];
 v[a >> 2] = b;
 if (c) {
  Bb(c);
 }
}

function Ex(a, b, c) {
 v[a + 28 >> 2] = c;
 v[a + 20 >> 2] = b;
 v[a + 24 >> 2] = b;
}

function xY(a) {
 if (a >>> 0 >= 1073741824) {
  Sj();
  p();
 }
 return Dc(a << 2);
}

function wha(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 Yb(a, b + 4228 | 0, 7);
}

function oj(a) {
 var b = 0;
 o(+a);
 b = j(1) | 0;
 j(0) | 0;
 return b >>> 20 | 0;
}

function mia(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 Yb(a, b + 4260 | 0, 8);
}

function kS(a) {
 v[a >> 2] = 0;
 Mb(a + 4 | 0);
 Qb(a + 16 | 0, 0, 144);
 return a;
}

function hda(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 Lz(v[a + 4 >> 2], b, c);
}
function gla(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 return Lb(a, b, c) | 0;
}

function fka(a) {
 a = a | 0;
 a = aw(a, 22256);
 v[a >> 2] = 124660;
 return a | 0;
}

function eM(a) {
 a = a | 0;
 v[a >> 2] = 77952;
 ec(a + 24 | 0);
 return Wt(a) | 0;
}

function ap(a) {
 var b = 0;
 b = v[a >> 2];
 v[b >> 2] = v[b >> 2] | v[a + 4 >> 2];
}

function Nh(a, b, c) {
 t[a | 0] = w[a | 0] | b;
 v[a + 4 >> 2] = v[a + 4 >> 2] | c;
}

function KF(a, b) {
 var c = 0;
 c = Dc(b << 2);
 v[a + 4 >> 2] = b;
 v[a >> 2] = c;
}

function FR(a, b) {
 return ((b | 0) == 2 ? 740 : (b | 0) == 1 ? 732 : 724) + a | 0;
}

function Ct(a) {
 a = a | 0;
 v[a >> 2] = 93352;
 sb(a + 32 | 0);
 return go(a) | 0;
}

function xja(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 ZG(a, b, c, 909, 908);
}

function uca(a) {
 a = a | 0;
 return v[v[v[a + 4 >> 2] + 24 >> 2] + 1074416 >> 2];
}

function qm(a) {
 a = BG(a, 0);
 v[a + 8 >> 2] = 0;
 v[a >> 2] = 120912;
 return a;
}

function qh(a, b) {
 var c = 0, d = 0;
 c = a, d = oK(b), v[c >> 2] = d;
 return a;
}

function qg(a, b) {
 var c = 0;
 c = w[a | 0];
 t[a | 0] = w[b | 0];
 t[b | 0] = c;
}

function dt(a) {
 a = a | 0;
 v[a >> 2] = 96396;
 hl(v[a + 8 >> 2]);
 return a | 0;
}

function cQ(a) {
 a = a | 0;
 return Ak(C(z[xb(a + 4208 | 0, 4) >> 2] * C(4))) | 0;
}

function bI(a, b, c) {
 b = Ka(1004, a | 0, b | 0, c | 0) | 0;
 gb = fb;
 return b;
}

function _s(a, b) {
 var c = 0, d = 0;
 c = a, d = kk(b), v[c >> 2] = d;
 return a;
}

function _b(a) {
 return a << 24 | (a & 65280) << 8 | (a >>> 8 & 65280 | a >>> 24);
}

function Xf(a) {
 var b = 0;
 UP(a);
 b = v[a >> 2];
 if (b) {
  Vz(a);
  Bb(b);
 }
}

function VL(a, b, c) {
 v[a + 4 >> 2] = 0;
 v[a >> 2] = b;
 v[a + 8 >> 2] = c << 3;
}

function TS(a, b) {
 a = SS(a, b);
 SS(a + 12 | 0, b + 12 | 0);
 t[a + 24 | 0] = 1;
}

function QB(a, b) {
 A[a >> 3] = A[a >> 3] * b;
 A[a + 8 >> 3] = A[a + 8 >> 3] * b;
}

function Ika(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 ZG(a, b, c, 833, 832);
}

function Gca(a) {
 a = a | 0;
 return v[v[v[a + 4 >> 2] + 24 >> 2] + 1074424 >> 2];
}

function Cka(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 _H(a, b, c, 837, 838);
}

function CI(a) {
 a = a | 0;
 v[a >> 2] = 95232;
 hl(v[a + 8 >> 2]);
 return a | 0;
}

function C9(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 return Fd(B(b, c)) | 0;
}

function Ar(a) {
 return v[a + 20 >> 2] + (v[a + 8 >> 2] - v[a + 24 >> 2] | 0) | 0;
}

function AI(a) {
 a = a | 0;
 v[a >> 2] = 95200;
 hl(v[a + 8 >> 2]);
 return a | 0;
}

function u1(a) {
 a = a | 0;
 a = wG(a, 13422);
 v[a >> 2] = 24460;
 return a | 0;
}

function jY(a) {
 var b = 0;
 b = v[a + 100 >> 2];
 v[a + 100 >> 2] = 0;
 return b;
}
function jJ(a) {
 var b = 0;
 b = v[a >> 2];
 v[a >> 2] = 0;
 if (b) {
  sm(b);
 }
}

function cba(a) {
 a = a | 0;
 Lz(a, 2, 100);
 Vj(v[a + 24 >> 2] + 484360 | 0, 0);
}

function aw(a, b) {
 a = Cj(a);
 v[a >> 2] = 124540;
 Zx(a + 4 | 0, b);
 return a;
}

function So(a) {
 v[a >> 2] = 0;
 v[a + 4 >> 2] = 0;
 Ec(a + 8 | 0, 0);
 return a;
}

function P$(a, b) {
 t[a | 0] = w[b | 0];
 t[a + 1 | 0] = w[b + 1 | 0];
 return a;
}

function MT(a) {
 var b = 0;
 b = v[a >> 2];
 v[a >> 2] = 0;
 if (b) {
  Bb(b);
 }
}

function Fba(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 pN(a - 88 | 0, b, c);
}

function Dba(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 nN(a - 88 | 0, b, c);
}

function Aga(a) {
 a = a | 0;
 SP(a);
 t[a + 4202 | 0] = 1;
 v[a + 4224 >> 2] = 0;
}

function yna(a, b) {
 a = a | 0;
 b = b | 0;
 if (!tX(a, b)) {
  Qb(b, 0, 40);
 }
}

function wN(a) {
 a = a | 0;
 return +(65536 / +y[v[a + 32 >> 2] + 480244 >> 2]);
}

function sq(a, b, c) {
 if (!b) {
  return 0;
 }
 return rq(a, c << 24 >> 24, b);
}

function r2(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 _H(a, b, c, 74, 147);
}

function ll(a) {
 return vb(Jb(a) + (Cb(v[a + 4 >> 2], w[a + 11 | 0]) << 2) | 0);
}

function kg(a, b) {
 if (ud(w[a + 11 | 0])) {
  Ad(a, b);
  return;
 }
 Me(a, b);
}

function ih(a, b) {
 return hb[v[v[a >> 2] + 32 >> 2]](a, v[a + 12 >> 2], b) | 0;
}

function g2(a) {
 a = a | 0;
 a = wG(a, 8704);
 v[a >> 2] = 28804;
 return a | 0;
}

function Xb(a, b, c) {
 return (a | 0) < (b | 0) ? b : (a | 0) < (c | 0) ? a : c;
}

function Nw(a, b) {
 return ((b | 0) == 2 ? 88 : (b | 0) == 1 ? 68 : 48) + a | 0;
}

function Kd(a, b, c) {
 return a >>> 0 < b >>> 0 ? b : a >>> 0 < c >>> 0 ? a : c;
}

function K3(a) {
 a = a | 0;
 a = f_(a, 7956);
 v[a >> 2] = 40168;
 return a | 0;
}

function zz(a) {
 return (Jb(a) + Cb(v[a + 4 >> 2], w[a + 11 | 0]) | 0) - 1 | 0;
}

function ox(a) {
 a = a | 0;
 v[a >> 2] = 124560;
 hI(a + 4 | 0);
 return a | 0;
}

function ly(a) {
 a = a | 0;
 v[a >> 2] = 96552;
 sb(a + 16 | 0);
 return a | 0;
}

function lha(a) {
 a = a | 0;
 return C(C(z[xb(a + 4208 | 0, 6) >> 2] * C(20)));
}

function ky(a) {
 a = a | 0;
 v[a >> 2] = 96512;
 sb(a + 12 | 0);
 return a | 0;
}

function hI(a) {
 a = $k(v[a >> 2]);
 if ((mx(a + 8 | 0) | 0) < 0) {
  Bb(a);
 }
}

function gda(a, b) {
 a = a | 0;
 b = b | 0;
 mO(v[v[a + 4 >> 2] + 24 >> 2], b);
}

function cF(a) {
 return !id(a, 14184, 3) & (w[a + 3 | 0] - 10 & 255) >>> 0 < 5;
}

function bf(a, b, c, d) {
 t[a + 8 | 0] = d;
 v[a + 4 >> 2] = c;
 v[a >> 2] = b;
}

function Wt(a) {
 a = a | 0;
 v[a >> 2] = 77100;
 ec(a + 12 | 0);
 return a | 0;
}

function UT(a, b) {
 return (a | 0) != (b | 0) ? a >>> 0 < b >>> 0 ? -1 : 1 : 0;
}

function H_(a) {
 a = a | 0;
 v[a >> 2] = 124540;
 hI(a + 4 | 0);
 return a | 0;
}

function Eqa(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 Uc(a, T$(c, 0, b));
}

function xea(a, b) {
 a = a | 0;
 b = b | 0;
 return Wn(a, b, 11782, 1056) | 0;
}

function wea(a, b) {
 a = a | 0;
 b = b | 0;
 return XH(a, b, 13394, 1057) | 0;
}

function vba(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = +c;
 hN(a - 92 | 0, b, c);
}

function tba(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = +c;
 fN(a - 92 | 0, b, c);
}

function tG(a) {
 a = a | 0;
 v[a >> 2] = 41472;
 le(a + 4 | 0);
 return a | 0;
}

function qM(a) {
 a = a | 0;
 v[a >> 2] = 77564;
 ec(a + 4 | 0);
 return a | 0;
}

function oea(a, b) {
 a = a | 0;
 b = b | 0;
 return Wn(a, b, 11817, 1064) | 0;
}

function mea(a, b) {
 a = a | 0;
 b = b | 0;
 return Wn(a, b, 11847, 1066) | 0;
}

function go(a) {
 a = a | 0;
 v[a >> 2] = 93224;
 Zb(a + 4 | 0);
 return a | 0;
}

function gg(a, b, c, d, e) {
 return Ma(a | 0, b | 0, c | 0, d | 0, e | 0) | 0;
}

function gea(a, b) {
 a = a | 0;
 b = b | 0;
 return Wn(a, b, 11943, 1069) | 0;
}

function eea(a, b) {
 a = a | 0;
 b = b | 0;
 return Wn(a, b, 11911, 1070) | 0;
}

function dQ(a) {
 a = a | 0;
 return C(C(z[xb(a + 4208 | 0, 2) >> 2] * C(10)));
}

function au(a) {
 a = a | 0;
 v[a >> 2] = 48604;
 wz(a + 4 | 0);
 return a | 0;
}

function ZD(a, b) {
 t[v[a >> 2]] = w[b | 0];
 t[v[a + 4 >> 2]] = w[b + 1 | 0];
}

function Qn(a) {
 var b = 0;
 b = v[a + 8 >> 2];
 v[a + 8 >> 2] = 0;
 return b;
}

function Oea(a, b) {
 a = a | 0;
 b = b | 0;
 return Wn(a, b, 11879, 1049) | 0;
}

function Nsa(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 l_(a, c, b, 0, 0);
}

function NP(a) {
 return C(C(z[xb(a + 4208 | 0, 11) >> 2] * C(19980)) + C(20));
}

function Mb(a) {
 v[a >> 2] = 0;
 v[a + 4 >> 2] = 0;
 sc(a + 8 | 0);
 return a;
}

function Iga(a) {
 a = a | 0;
 return C(C(z[xb(a + 4208 | 0, 6) >> 2] * C(4)));
}

function Hba(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = +c;
 rN(a - 88 | 0, b, c);
}

function Ei(a, b, c) {
 a = rq(a, c << 24 >> 24, b - a | 0);
 return a ? a : b;
}

function Dt(a) {
 a = a | 0;
 v[a >> 2] = 93288;
 Zb(a + 4 | 0);
 return a | 0;
}

function zM(a, b) {
 a = a | 0;
 b = b | 0;
 bl(a, b, 1171, 1170, 1169, 1168);
}

function yM(a, b) {
 a = a | 0;
 b = b | 0;
 bl(a, b, 1183, 1182, 1181, 1180);
}

function xra(a, b) {
 a = a | 0;
 b = b | 0;
 return Cc(a, b ? b : 22256) | 0;
}

function xM(a, b) {
 a = a | 0;
 b = b | 0;
 bl(a, b, 1179, 1178, 1177, 1176);
}

function wr(a, b, c, d, e) {
 Yb(a, b + d | 0, (e | 0) == -1 ? c - d | 0 : e);
}

function wX(a) {
 var b = 0;
 a = a + 8 | 0;
 gb = a >>> 0 < 8 | b;
 return a;
}

function uM(a, b) {
 a = a | 0;
 b = b | 0;
 bl(a, b, 1191, 1190, 1189, 1188);
}

function tM(a, b) {
 a = a | 0;
 b = b | 0;
 bl(a, b, 1187, 1186, 1185, 1184);
}

function saa(a, b) {
 a = a | 0;
 b = b | 0;
 BT(v[a >> 2], b);
 return a | 0;
}

function rh(a, b) {
 a = a | 0;
 b = b | 0;
 hb[v[v[b >> 2] + 20 >> 2]](a, b);
}

function rca(a, b) {
 a = a | 0;
 b = b | 0;
 return IO(v[a + 4 >> 2], b) | 0;
}

function oua(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 Wp(a, b, c, 261);
}

function dqa(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 Ds(a, b, c, 594);
}

function di(a, b) {
 a = a | 0;
 b = b | 0;
 hb[v[v[b >> 2] + 24 >> 2]](a, b);
}

function cqa(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 Ds(a, b, c, 595);
}

function ci(a, b) {
 a = a | 0;
 b = b | 0;
 hb[v[v[b >> 2] + 28 >> 2]](a, b);
}

function bsa(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 Wp(a, b, c, 416);
}

function _pa(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 lH(a, b, c, 502);
}

function Ypa(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 tH(a, b, c, 303);
}

function Xpa(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 $G(a, b, c, 303);
}

function Tta(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 Ds(a, b, c, 298);
}

function TN(a, b) {
 gb = 0 - (((a | 0) != 0) + b | 0) | 0;
 return 0 - a | 0;
}

function Qta(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 iH(a, b, c, 303);
}

function OP(a) {
 return C(C(z[xb(a + 4208 | 0, 0) >> 2] * C(1e4)) + C(-1e4));
}

function Nv(a) {
 uc(a + 88 | 0);
 uc(a + 68 | 0);
 uc(a + 48 | 0);
 return a;
}

function Ns(a, b, c, d, e, f) {
 Ja(a | 0, b | 0, c | 0, d | 0, e | 0, f | 0);
}

function Iqa(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 mH(a, b, c, 256);
}

function F9(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 Ds(a, b, c, 1209);
}

function EM(a, b) {
 a = a | 0;
 b = b | 0;
 bl(a, b, 1167, 1166, 1165, 1164);
}

function DM(a, b) {
 a = a | 0;
 b = b | 0;
 bl(a, b, 1162, 1161, 1160, 1159);
}

function AM(a, b) {
 a = a | 0;
 b = b | 0;
 bl(a, b, 1175, 1174, 1173, 1172);
}

function wda(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 Wp(a, b, c, 81);
}

function s4(a, b) {
 a = a | 0;
 b = b | 0;
 return JI(b, v[a + 8 >> 2]) | 0;
}

function pn(a, b, c) {
 v[a >> 2] = b;
 v[a + 4 >> 2] = v[c >> 2];
 return a;
}

function nua(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 tH(a, b, c, 47);
}

function nha(a) {
 a = a | 0;
 return z[xb(a + 4208 | 0, 3) >> 2] < C(1) | 0;
}

function kda(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 Wp(a, b, c, 82);
}

function h7(a, b) {
 a = a | 0;
 b = b | 0;
 Yb(a, _K(v[b >> 2]), v[b >> 2]);
}

function ZW(a, b, c, d) {
 return !((a | 0) == (c | 0) & (b | 0) == (d | 0));
}

function Rna(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 iH(a, b, c, 47);
}

function PD(a) {
 a = a & 255;
 return Tc(a) ^ 1 | (a - 49 & 255) >>> 0 < 36;
}

function Ona(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 Uc(a, yx(b, c));
}

function Mr(a, b, c) {
 if (b) {
  dP(a + 36 | 0, b, Ei(b, b + c | 0, 0));
 }
}

function Kga(a) {
 a = a | 0;
 return z[xb(a + 4208 | 0, 1) >> 2] < C(1) | 0;
}

function Kfa(a, b) {
 a = a | 0;
 b = b | 0;
 return XH(a, b, 6432, 997) | 0;
}

function Er(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 lH(a, b, c, 123);
}

function Cm(a, b) {
 v[a + 16 >> 2] = !v[a + 24 >> 2] | (v[a + 16 >> 2] | b);
}

function Bca(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 $G(a, b, c, 47);
}

function BV(a, b, c, d) {
 Yb(Yb(a, b, c) + 8 | 0, v[d >> 2], v[d + 4 >> 2]);
}

function yu(a) {
 a = a | 0;
 a = Xh(a);
 v[a + 20 >> 2] = 0;
 return a | 0;
}

function uua(a, b) {
 a = a | 0;
 b = b | 0;
 Lh(a, b, 260, 1025, -1284, 2);
}

function uY(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 Uc(a, Zy(b, c));
}

function tc(a, b) {
 a = a | 0;
 b = b | 0;
 fG(a, b, es(b));
 return a | 0;
}

function rY(a, b, c) {
 if (c) {
  fl(a, b, (c << 2) - 1 | 0);
 }
 return a;
}

function pna(a, b) {
 a = a | 0;
 b = b | 0;
 Lh(a, b, 586, 1058, -1332, 3);
}

function nU(a, b) {
 v[a + 8 >> 2] = 0;
 v[a + 12 >> 2] = 0;
 A[a >> 3] = b;
}

function mC(a, b) {
 Sb(a, b);
 Sb(a + 4 | 0, b + 4 | 0);
 Sb(zb(a), zb(b));
}

function m1(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 Wp(a, b, c, 18);
}

function jL(a) {
 a = a | 0;
 return Ft(v[v[a >> 2] - 12 >> 2] + a | 0) | 0;
}

function hz(a, b) {
 return v[((a >>> 24 ^ b) << 2) + 495296 >> 2] ^ a << 8;
}

function g4(a, b) {
 a = a | 0;
 b = b | 0;
 return nl(b & 255) << 24 >> 24;
}

function eL(a) {
 a = a | 0;
 return Et(v[v[a >> 2] - 12 >> 2] + a | 0) | 0;
}

function e4(a, b) {
 a = a | 0;
 b = b | 0;
 return ut(b & 255) << 24 >> 24;
}

function csa(a, b) {
 a = a | 0;
 b = b | 0;
 Lh(a, b, 415, 1042, -1332, 2);
}

function Xta(a, b) {
 a = a | 0;
 b = b | 0;
 Lh(a, b, 295, 1058, -1332, 2);
}

function W8(a) {
 a = a | 0;
 return gq(v[v[a >> 2] - 12 >> 2] + a | 0) | 0;
}

function U8(a) {
 a = a | 0;
 return Ff(v[v[a >> 2] - 12 >> 2] + a | 0) | 0;
}

function Ooa(a, b) {
 a = a | 0;
 b = b | 0;
 Lh(a, b, 260, 1042, -1332, 2);
}

function GG(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 Uc(a, fx(b, c));
}

function Cc(a, b) {
 a = a | 0;
 b = b | 0;
 Gu(a, b, Df(b));
 return a | 0;
}

function BN(a) {
 a = a | 0;
 a = v[a + 4 >> 2];
 return (a ? a : 5011) | 0;
}

function vz(a, b, c, d, e, f) {
 return KH(a, b, c, d, e, f, 73476, 74272);
}

function uz(a, b, c, d, e, f) {
 return KH(a, b, c, d, e, f, 74320, 75084);
}

function qQ(a) {
 uc(a + 36 | 0);
 uc(a + 24 | 0);
 pu(a + 12 | 0);
 pu(a);
}

function qC(a) {
 t[a + 6 | 0] = 0;
 u[a + 4 >> 1] = 65535;
 v[a >> 2] = 0;
}

function lz(a) {
 return (a & 6) == 6 ? 384 : 1152 >>> ((a & 14) == 2) | 0;
}

function lR(a, b) {
 return (b >>> 0 > 15 ? 63 : t[a + b | 0]) << 24 >> 24;
}

function kR(a, b) {
 return (b >>> 0 > 46 ? 63 : t[a + b | 0]) << 24 >> 24;
}

function fx(a, b) {
 return $R(a, Jb(b), Cb(v[b + 4 >> 2], w[b + 11 | 0]));
}

function eD(a, b) {
 a = a | 0;
 b = b | 0;
 Lh(a, b, 586, 1058, -1332, 2);
}

function cea(a, b) {
 a = a | 0;
 b = b | 0;
 Lh(a, b, 79, 1025, -1284, 4);
}

function _2(a) {
 a = a | 0;
 a = hb[a | 0]() | 0;
 fb = gb;
 return a | 0;
}

function Zy(a, b) {
 return Jt(a, Jb(b), Cb(v[b + 4 >> 2], w[b + 11 | 0]));
}

function YG(a, b) {
 nm(v[b >> 2]);
 sm(v[a >> 2]);
 v[a >> 2] = v[b >> 2];
}

function Tha(a) {
 a = a | 0;
 t[a + 4202 | 0] = 1;
 ru(a);
 Zz(a);
 rQ(a);
}

function Sda(a, b) {
 a = a | 0;
 b = b | 0;
 Lh(a, b, 13, 1025, -1284, 2);
}

function Lda(a, b) {
 a = a | 0;
 b = b | 0;
 Lh(a, b, 79, 1025, -1284, 2);
}

function Jv(a, b) {
 a = a | 0;
 b = b | 0;
 Lh(a, b, 587, 1058, -1332, 2);
}

function Fra(a, b) {
 a = a | 0;
 b = b | 0;
 Lh(a, b, 79, 1042, -1332, 2);
}

function Eba(a, b) {
 a = a | 0;
 b = b | 0;
 return oN(a - 88 | 0, b) | 0;
}

function EK(a, b, c) {
 a = ub(a, b);
 ub(a + 4 | 0, v[c >> 2]);
 return a;
}

function Cba(a, b) {
 a = a | 0;
 b = b | 0;
 return mN(a - 88 | 0, b) | 0;
}

function Bda(a, b) {
 a = a | 0;
 b = b | 0;
 Lh(a, b, 80, 1025, -1284, 2);
}

function zua(a) {
 if (a) {
  return 31 - E(a - 1 ^ a) | 0;
 }
 return 32;
}

function ld(a, b, c, d) {
 return Xc(a, B(x[b + 480188 >> 1], c) + d | 0);
}

function gC(a) {
 a = Mb(a);
 v[a + 12 >> 2] = 0;
 u[a + 16 >> 1] = 65280;
}

function de(a, b, c) {
 t[a | 0] = b;
 t[a + 1 | 0] = w[c | 0];
 return a;
}

function ao(a, b, c, d) {
 return (a | 0) == (c | 0) & (b | 0) == (d | 0);
}

function Wqa(a, b) {
 a = a | 0;
 b = b | 0;
 if (!PY(a, b)) {
  OY(b);
 }
}

function Mh(a) {
 var b = 0;
 b = St(a);
 v[a + 1396 >> 2] = 0;
 return b;
}

function Jpa(a, b) {
 a = a | 0;
 b = b | 0;
 if (!zE(a, b)) {
  FE(b);
 }
}

function Eja(a, b) {
 a = a | 0;
 b = b | 0;
 if (!gG(a, b)) {
  ux(b);
 }
}

function Cf(a) {
 return vb(Jb(a) + Cb(v[a + 4 >> 2], w[a + 11 | 0]) | 0);
}

function Bsa(a, b) {
 a = a | 0;
 b = b | 0;
 if (!QZ(a, b)) {
  PZ(b);
 }
}

function B4(a, b) {
 a = a | 0;
 b = b | 0;
 Lh(a, b, 13, 1058, -1332, 2);
}

function yca(a) {
 a = a | 0;
 return DO(v[v[a + 4 >> 2] + 24 >> 2]) | 0;
}

function ww(a, b) {
 a = a | 0;
 b = b | 0;
 if (!Dp(a, b)) {
  rp(b);
 }
}

function wd(a, b) {
 a = BG(a, b - 1 | 0);
 v[a >> 2] = 96920;
 return a;
}

function vca(a) {
 a = a | 0;
 return VO(v[v[a + 4 >> 2] + 24 >> 2]) | 0;
}

function ul(a, b, c) {
 v[a >> 2] = b;
 v[a + 4 >> 2] = c - b;
 return a;
}

function tca(a) {
 a = a | 0;
 return SO(v[v[a + 4 >> 2] + 24 >> 2]) | 0;
}

function sb(a) {
 if (ud(w[a + 11 | 0])) {
  Bb(v[a >> 2]);
 }
 return a;
}

function pua(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 p0(a, b, c);
}

function oL(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 return a | 0;
}

function mca(a) {
 a = a | 0;
 return qq(v[v[a + 4 >> 2] + 24 >> 2]) | 0;
}

function mD(a, b) {
 a = a | 0;
 b = b | 0;
 if (!aZ(a, b)) {
  sD(b);
 }
}

function jp(a, b) {
 a = a | 0;
 b = b | 0;
 if (!Wh(a, b)) {
  Zk(b);
 }
}

function jE(a, b) {
 a = a | 0;
 b = b | 0;
 if (!u$(a, b)) {
  Dr(b);
 }
}

function e$(a, b) {
 a = a | 0;
 b = b | 0;
 if (!d$(a, b)) {
  gw(b);
 }
}

function cla(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 ge(a, b, c);
}

function aca(a) {
 a = a | 0;
 return TO(v[v[a + 4 >> 2] + 24 >> 2]) | 0;
}

function aA(a, b, c, d) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 d = d | 0;
}

function XZ(a, b) {
 a = a | 0;
 b = b | 0;
 if (!_F(a, b)) {
  cs(b);
 }
}

function Ica(a) {
 a = a | 0;
 return MO(v[v[a + 4 >> 2] + 24 >> 2]) | 0;
}

function H0(a, b) {
 a = a | 0;
 b = b | 0;
 if (!z0(a, b)) {
  HE(b);
 }
}

function Fca(a) {
 a = a | 0;
 return pq(v[v[a + 4 >> 2] + 24 >> 2]) | 0;
}

function Ew(a, b) {
 a = a | 0;
 b = b | 0;
 if (!lx(a, b)) {
  kx(b);
 }
}

function Dca(a) {
 a = a | 0;
 return wo(v[v[a + 4 >> 2] + 24 >> 2]) | 0;
}

function Cca(a) {
 a = a | 0;
 return LO(v[v[a + 4 >> 2] + 24 >> 2]) | 0;
}

function yx(a, b) {
 a = a | 0;
 b = b | 0;
 return $R(a, b, es(b)) | 0;
}

function xx(a) {
 v[a >> 2] = 0;
 v[a + 4 >> 2] = 0;
 v[a + 8 >> 2] = 0;
}

function xE(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 Y$(a, b, c);
}

function uba(a, b) {
 a = a | 0;
 b = b | 0;
 return +gN(a - 92 | 0, b);
}

function sba(a, b) {
 a = a | 0;
 b = b | 0;
 return +eN(a - 92 | 0, b);
}

function rpa(a, b) {
 a = a | 0;
 b = b | 0;
 return Jx(a, b, 1100) | 0;
}

function qj(a) {
 return ff(a) | ff(a) << 8 | ff(a) << 16 | ff(a) << 24;
}

function ksa(a, b) {
 a = a | 0;
 b = b | 0;
 return Cs(a, b, 1227) | 0;
}

function fda(a, b) {
 a = a | 0;
 b = +b;
 return +nO(v[a + 4 >> 2], b);
}

function eua(a, b) {
 a = a | 0;
 b = b | 0;
 Ix(a, b, 260, 274, -1332);
}

function _A(a, b) {
 v[a >> 2] = b;
 v[a + 4 >> 2] = b >> 31;
 return a;
}

function Voa(a, b) {
 a = a | 0;
 b = b | 0;
 return Cs(a, b, 1223) | 0;
}

function UF(a, b) {
 return (w[b + 34 | 0] & 8) >>> 3 & (a & 2050) == 2;
}

function U1(a, b) {
 a = a | 0;
 b = b | 0;
 return CF(a, b, Df(b)) | 0;
}

function Saa(a, b) {
 a = a | 0;
 b = b | 0;
 return Cs(a, b, 1226) | 0;
}

function J3(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 Yb(a, c, b);
}

function Gba(a, b) {
 a = a | 0;
 b = b | 0;
 return +qN(a - 88 | 0, b);
}

function Fpa(a, b) {
 a = a | 0;
 b = b | 0;
 return Zh(a, b, 1030) | 0;
}

function AZ(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 x0(a, b, c);
}

function A$(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 A0(a, b, c);
}

function zqa(a, b) {
 a = a | 0;
 b = b | 0;
 return Zh(a, b, 422) | 0;
}

function vB(a) {
 if (w[a + 24 | 0]) {
  XS(a);
  t[a + 24 | 0] = 0;
 }
}

function usa(a, b) {
 a = a | 0;
 b = b | 0;
 return Zh(a, b, 308) | 0;
}

function uqa(a, b) {
 a = a | 0;
 b = b | 0;
 return Zh(a, b, 826) | 0;
}

function uja(a, b) {
 a = a | 0;
 b = b | 0;
 return Zh(a, b, 225) | 0;
}

function qja(a, b) {
 a = a | 0;
 b = b | 0;
 return Zh(a, b, 326) | 0;
}

function pm(a) {
 a = a | 0;
 a = mc(a);
 hb[v[v[a >> 2] >> 2]](a) | 0;
}

function ns(a, b) {
 a = gc(a, b);
 Qb(a + 20 | 0, 0, 1040);
 return a;
}

function nda(a) {
 a = a | 0;
 return Tz(v[a >> 2], v[a + 4 >> 2]) | 0;
}

function me(a) {
 var b = 0;
 b = v[a >> 2];
 v[a >> 2] = 0;
 return b;
}

function lj(a) {
 a = a | 0;
 return hb[v[v[a >> 2] + 16 >> 2]](a) | 0;
}

function jta(a, b) {
 a = a | 0;
 b = b | 0;
 return hH(a, b, 345) | 0;
}

function jj(a) {
 a = a | 0;
 return hb[v[v[a >> 2] + 12 >> 2]](a) | 0;
}

function eE(a, b) {
 a = Ge(a, b);
 Qb(a + 20 | 0, 0, 1040);
 return a;
}

function Wj(a, b) {
 a = a | 0;
 b = b | 0;
 V$(a, v[a + 16 >> 2] | b);
}

function MO(a) {
 return Gj(Wb(v[a + 484360 >> 2], w[a + 484376 | 0]));
}

function M2(a, b) {
 a = a | 0;
 b = b | 0;
 return Cs(a, b, 1225) | 0;
}

function Kh(a) {
 a = a | 0;
 return hb[v[v[a >> 2] + 24 >> 2]](a) | 0;
}

function Jj(a) {
 if (!a) {
  return 0;
 }
 return v[a + 44 >> 2] != 0;
}

function BG(a, b) {
 v[a + 4 >> 2] = b;
 v[a >> 2] = 124012;
 return a;
}

function wja(a, b) {
 a = a | 0;
 b = b | 0;
 return Zh(a, b, 73) | 0;
}

function tR(a, b) {
 return B(b & 65535, a & 65535) + 7 >>> 3 & 65535;
}

function sh(a, b) {
 a = a | 0;
 b = b | 0;
 return gL(a) ^ gL(b) ^ 1;
}

function rqa(a, b) {
 a = a | 0;
 b = b | 0;
 return Zh(a, b, 41) | 0;
}

function pR(a) {
 return (a | 0) == 1179012417 | (a | 0) == 538987841;
}

function oja(a, b) {
 a = a | 0;
 b = b | 0;
 return Zh(a, b, 60) | 0;
}

function oca(a) {
 a = a | 0;
 return +RO(v[v[a + 4 >> 2] + 24 >> 2]);
}

function hpa(a, b) {
 a = a | 0;
 b = b | 0;
 return Zh(a, b, 71) | 0;
}

function fca(a) {
 a = a | 0;
 return +QA(v[v[a + 4 >> 2] + 24 >> 2]);
}

function ei(a, b) {
 a = a | 0;
 b = b | 0;
 return $K(a) ^ $K(b) ^ 1;
}

function bx(a) {
 a = a | 0;
 return hb[v[v[a >> 2] + 8 >> 2]](a) | 0;
}

function Y1(a, b) {
 a = a | 0;
 b = b | 0;
 Ix(a, b, 13, 257, -1284);
}

function Xm(a) {
 zj(a + 724 | 0);
 zj(a + 732 | 0);
 zj(a + 740 | 0);
}

function Pn(a, b, c) {
 a = Ld(a);
 v[a + 4 >> 2] = c;
 v[a >> 2] = b;
}

function JJ(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 return -1;
}

function DZ(a, b) {
 a = a | 0;
 b = b | 0;
 return hH(a, b, 322) | 0;
}

function C4(a, b) {
 a = a | 0;
 b = b | 0;
 Ix(a, b, 13, 290, -1332);
}

function Bz(a, b) {
 v[a >> 2] = v[b >> 2];
 Uc(a + 4 | 0, b + 4 | 0);
}

function Asa(a, b) {
 a = a | 0;
 b = b | 0;
 return Zh(a, b, 78) | 0;
}

function $qa(a, b) {
 a = a | 0;
 b = b | 0;
 return Zh(a, b, 91) | 0;
}

function yp(a, b, c) {
 Yb(a, (c >>> 3 & 536870908) + b | 0, c & 31);
}

function we(a, b, c) {
 v[a >> 2] = b;
 v[a + 4 >> 2] = c;
 return a;
}

function qga(a, b) {
 a = a | 0;
 b = b | 0;
 return C(ym(a, b, 12));
}

function mha(a) {
 a = a | 0;
 return C(z[xb(a + 4208 | 0, 1) >> 2]);
}

function mI(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 VK(a, c);
}

function lB(a) {
 Hq(a + 223860 | 0);
 ec(a + 223848 | 0);
 return a;
}

function l1(a, b) {
 a = a | 0;
 b = b | 0;
 Rp(a, b);
 return a | 0;
}

function gp(a) {
 return (a | 0) <= 0 ? 1 : a >>> 0 >= 120 ? 120 : a;
}

function an(a, b, c) {
 v[a + 4 >> 2] = c;
 u[a >> 1] = b;
 return a;
}

function af(a, b, c, d) {
 ac(a, ld(b, c, d, 0), x[c + 480188 >> 1]);
}

function _n(a) {
 return a - 48 >>> 0 < 10 | (a | 32) - 97 >>> 0 < 6;
}

function Yb(a, b, c) {
 v[a + 4 >> 2] = c;
 v[a >> 2] = b;
 return a;
}

function VF(a, b, c) {
 Yb(a, (c >>> 3 & 536870908) + b | 0, 1 << c);
}

function UY(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 return 0;
}

function Nl(a, b, c) {
 A[a + 8 >> 3] = c;
 A[a >> 3] = b;
 return a;
}

function Jga(a) {
 a = a | 0;
 return C(z[xb(a + 4208 | 0, 3) >> 2]);
}

function Aj(a) {
 if (!a) {
  return 0;
 }
 return Ij(w[a + 31 | 0]);
}

function $y(a) {
 if (!a) {
  return 0;
 }
 v[31476] = a;
 return -1;
}

function tpa(a, b) {
 a = a | 0;
 b = b | 0;
 Vp(a, b, 648, 647, 8);
}

function rha(a, b) {
 a = a | 0;
 b = b | 0;
 return C(ym(a, b, 6));
}

function mba(a) {
 a = a | 0;
 v[a >> 2] = 48384;
 return hu(a) | 0;
}

function mT(a, b, c, d) {
 return fd(Fo(a, b, c, d, 0) - 32768 | 0);
}

function kl(a, b) {
 return hb[v[v[a >> 2] + 36 >> 2]](a, b, 0) | 0;
}

function jga(a, b) {
 a = a | 0;
 b = b | 0;
 return C(ym(a, b, 2));
}

function hJ(a) {
 var b = 0, c = 0;
 b = a, c = Nd(), v[b >> 2] = c;
}

function gua(a, b) {
 a = a | 0;
 b = b | 0;
 Vp(a, b, 297, 296, 8);
}

function fQ(a) {
 a = a | 0;
 return C(z[xb(a + 4208 | 0, 0) >> 2]);
}

function eha(a, b) {
 a = a | 0;
 b = b | 0;
 return C(ym(a, b, 5));
}

function ee(a, b) {
 Yb(a, Jb(b), Cb(v[b + 4 >> 2], w[b + 11 | 0]));
}

function eF(a, b) {
 a = $E(a, b);
 if (!a) {
  Bn(b);
 }
 return a;
}

function bra(a, b) {
 a = a | 0;
 b = b | 0;
 Vp(a, b, 519, 518, 6);
}

function bpa(a, b) {
 a = a | 0;
 b = b | 0;
 Vp(a, b, 681, 680, 8);
}

function bja(a, b) {
 a = a | 0;
 b = b | 0;
 RA(eR(a + 24 | 0, b));
}

function bga(a, b) {
 a = a | 0;
 b = b | 0;
 return C(ym(a, b, 3));
}

function Zga(a, b) {
 a = a | 0;
 b = b | 0;
 return C(ym(a, b, 4));
}

function Xn(a, b, c, d, e) {
 Na(a | 0, b | 0, c | 0, d | 0, e | 0);
}

function Wl(a, b, c) {
 t[a + 2 | 0] = c;
 u[a >> 1] = b;
 return a;
}

function WB(a) {
 v[a + 24 >> 2] = x[a + 20 >> 1] << x[a + 22 >> 1];
}

function Tv(a, b) {
 a = a | 0;
 b = b | 0;
 return Lb(a, b, 1) ^ 1;
}

function NS(a, b, c) {
 v[a + 4 >> 2] = c;
 t[a | 0] = b;
 return a;
}

function Ms(a, b, c, d, e) {
 Da(a | 0, b | 0, c | 0, d | 0, e | 0);
}

function LO(a) {
 return _u(v[a + 484344 >> 2], v[a + 484348 >> 2]);
}

function Jq(a, b) {
 v[a + 4 >> 2] = 256;
 v[a >> 2] = b;
 return a;
}

function Cga(a, b) {
 a = a | 0;
 b = b | 0;
 return C(ym(a, b, 1));
}

function B$(a, b) {
 a = i$(a, b);
 if (!a) {
  nE(b);
 }
 return a;
}

function xca(a, b) {
 a = a | 0;
 b = b | 0;
 CO(a, v[b + 4 >> 2]);
}

function wca(a, b) {
 a = a | 0;
 b = b | 0;
 aP(a, v[b + 4 >> 2]);
}

function wc(a, b) {
 if (y[a >> 2] > b >>> 0) {
  v[a >> 2] = b;
 }
}

function ti(a, b) {
 if (v[a >> 2] > (b | 0)) {
  v[a >> 2] = b;
 }
}

function qca(a, b) {
 a = a | 0;
 b = b | 0;
 HO(a, v[b + 4 >> 2]);
}

function pca(a, b) {
 a = a | 0;
 b = b | 0;
 BO(a, v[b + 4 >> 2]);
}

function oga(a) {
 a = a | 0;
 PP(a);
 Uz(a);
 t[a + 4202 | 0] = 1;
}

function kca(a, b) {
 a = a | 0;
 b = b | 0;
 PO(a, v[b + 4 >> 2]);
}

function jda(a, b) {
 a = a | 0;
 b = b | 0;
 Mz(v[a + 4 >> 2], b);
}

function iR(a, b, c) {
 if (c) {
  fl(a, b, B(c, 6));
 }
 return a;
}

function fO(a) {
 v[a + 4 >> 2] = 0;
 v[a >> 2] = 47556;
 return a;
}

function eta(a, b) {
 a = a | 0;
 b = b | 0;
 Vp(a, b, 362, 361, 8);
}
function cha(a) {
 a = a | 0;
 t[a + 4202 | 0] = 1;
 ZP(a);
 $P(a);
}

function Xga(a) {
 a = a | 0;
 t[a + 4202 | 0] = 1;
 XP(a);
 WP(a);
}

function Nha(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
 Ld(a);
}

function Gf(a, b) {
 if (x[a >> 1] > b >>> 0) {
  u[a >> 1] = b;
 }
}

function Eca(a, b) {
 a = a | 0;
 b = b | 0;
 JO(a, v[b + 4 >> 2]);
}

function BK(a, b, c) {
 a = oI(a, b, c, 0, -2147483648);
 return a;
}

function wQ(a) {
 a = a | 0;
 ec(a + 4208 | 0);
 return Zf(a) | 0;
}

function wG(a, b) {
 a = vG(a, b);
 v[a >> 2] = 124820;
 return a;
}

function vu(a) {
 a = a | 0;
 uc(a + 4208 | 0);
 return Zf(a) | 0;
}

function t5(a, b) {
 a = a | 0;
 b = b | 0;
 $c(a, b, Vc(499592));
}

function spa(a, b) {
 a = a | 0;
 b = b | 0;
 return tX(a, b) | 0;
}

function sJ(a, b) {
 a = wd(a, b);
 v[a >> 2] = 100808;
 return a;
}

function sE(a) {
 return (v[zb(a) >> 2] - v[a >> 2] | 0) / 28 | 0;
}

function rsa(a, b) {
 a = a | 0;
 b = b | 0;
 Kx(a, b, 17, 3, 16);
}

function rJ(a, b) {
 a = wd(a, b);
 v[a >> 2] = 100956;
 return a;
}

function r5(a, b) {
 a = a | 0;
 b = b | 0;
 $c(a, b, Vc(499600));
}

function qia(a, b) {
 a = a | 0;
 b = b | 0;
 t[a + 4201 | 0] = b;
}

function qJ(a, b) {
 a = wd(a, b);
 v[a >> 2] = 101072;
 return a;
}

function q5(a, b) {
 a = a | 0;
 b = b | 0;
 $c(a, b, Vc(499796));
}

function pJ(a, b) {
 a = wd(a, b);
 v[a >> 2] = 101188;
 return a;
}

function p5(a, b) {
 a = a | 0;
 b = b | 0;
 $c(a, b, Vc(499788));
}

function o5(a, b) {
 a = a | 0;
 b = b | 0;
 $c(a, b, Vc(499804));
}

function mJ(a, b) {
 a = wd(a, b);
 v[a >> 2] = 102376;
 return a;
}

function m5(a, b) {
 a = a | 0;
 b = b | 0;
 $c(a, b, Vc(499812));
}

function lJ(a, b) {
 a = wd(a, b);
 v[a >> 2] = 102496;
 return a;
}

function l5(a, b) {
 a = a | 0;
 b = b | 0;
 $c(a, b, Vc(499820));
}

function k5(a, b) {
 a = a | 0;
 b = b | 0;
 $c(a, b, Vc(499836));
}

function k$(a) {
 return (v[zb(a) >> 2] - v[a >> 2] | 0) / 40 | 0;
}

function jt(a) {
 return (v[zb(a) >> 2] - v[a >> 2] | 0) / 24 | 0;
}

function j5(a, b) {
 a = a | 0;
 b = b | 0;
 $c(a, b, Vc(499828));
}

function ica(a) {
 a = a | 0;
 return +A[v[a + 4 >> 2] + 16 >> 3];
}

function i5(a, b) {
 a = a | 0;
 b = b | 0;
 $c(a, b, Vc(499844));
}

function hx(a) {
 return (v[zb(a) >> 2] - v[a >> 2] | 0) / 36 | 0;
}

function g5(a, b) {
 a = a | 0;
 b = b | 0;
 $c(a, b, Vc(499852));
}

function dua(a, b) {
 a = a | 0;
 b = b | 0;
 Kx(a, b, 44, 2, 44);
}

function dX(a) {
 return (v[zb(a) >> 2] - v[a >> 2] | 0) / 56 | 0;
}

function d5(a, b) {
 a = a | 0;
 b = b | 0;
 $c(a, b, Vc(499860));
}

function b5(a, b) {
 a = a | 0;
 b = b | 0;
 $c(a, b, Vc(499672));
}

function al(a) {
 return (v[zb(a) >> 2] - v[a >> 2] | 0) / 12 | 0;
}

function aQ(a) {
 a = a | 0;
 uc(a + 4256 | 0);
 return Zf(a) | 0;
}

function Zaa(a, b) {
 a = a | 0;
 b = b | 0;
 Uc(a, iO(b, 18245));
}

function Z4(a, b) {
 a = a | 0;
 b = b | 0;
 $c(a, b, Vc(499688));
}

function Yda(a, b) {
 a = a | 0;
 b = b | 0;
 return fx(a, b) | 0;
}

function YC(a, b, c) {
 if (c) {
  fl(a, b, c << 2);
 }
 return a;
}

function X4(a, b) {
 a = a | 0;
 b = b | 0;
 $c(a, b, Vc(499696));
}

function Wk(a, b) {
 return (a & 65535) >>> 0 < (b & 65535) >>> 0;
}

function V4(a, b) {
 a = a | 0;
 b = b | 0;
 $c(a, b, Vc(499640));
}

function TU(a, b, c) {
 if (c) {
  fl(a, b, c << 1);
 }
 return a;
}

function TE(a) {
 return (v[zb(a) >> 2] - v[a >> 2] | 0) / 20 | 0;
}

function T4(a, b) {
 a = a | 0;
 b = b | 0;
 $c(a, b, Vc(499648));
}

function R4(a, b) {
 a = a | 0;
 b = b | 0;
 $c(a, b, Vc(499656));
}

function P4(a, b) {
 a = a | 0;
 b = b | 0;
 $c(a, b, Vc(499664));
}

function O4(a, b) {
 a = a | 0;
 b = b | 0;
 $c(a, b, Vc(499736));
}

function N4(a, b) {
 a = a | 0;
 b = b | 0;
 $c(a, b, Vc(499744));
}

function MY(a) {
 return (v[zb(a) >> 2] - v[a >> 2] | 0) / 33 | 0;
}

function Fc(a, b) {
 return uH(a, b, 2147483647, -2147483648, -1);
}

function Eu(a) {
 return (v[zb(a) >> 2] - v[a >> 2] | 0) / 52 | 0;
}

function Bka(a, b) {
 a = a | 0;
 b = b | 0;
 return Zy(a, b) | 0;
}

function $4(a, b) {
 a = a | 0;
 b = b | 0;
 $c(a, b, Vc(499680));
}

function yJ(a, b) {
 a = wd(a, b);
 v[a >> 2] = 98276;
 return a;
}

function y2(a, b) {
 a = a | 0;
 b = b | 0;
 return yx(a, b) | 0;
}

function xJ(a, b) {
 a = wd(a, b);
 v[a >> 2] = 98308;
 return a;
}

function w0(a, b) {
 return (b & 255) == 2 & (a & 255) >>> 0 < 3;
}

function vJ(a, b) {
 a = wd(a, b);
 v[a >> 2] = 96976;
 return a;
}

function rP(a, b) {
 a = a | 0;
 b = b | 0;
 return iO(a, b) | 0;
}

function qR(a, b) {
 return (a | 0) == 1179011410 & b >>> 0 > 80;
}

function paa(a, b) {
 a = a | 0;
 b = b | 0;
 IH(a, b, 1199, 52);
}

function ou(a, b) {
 a = a | 0;
 b = b | 0;
 return ig(a, b) | 0;
}

function o6() {
 wd(501352, 1);
 hJ(501360);
 v[125338] = 100292;
}

function mf(a, b) {
 t[a + 4 | 0] = 1;
 v[a >> 2] = b;
 return a;
}

function m6() {
 wd(501368, 1);
 hJ(501376);
 v[125342] = 100448;
}

function iw(a) {
 return (v[zb(a) >> 2] - v[a >> 2] | 0) / 6 | 0;
}

function hv(a, b, c, d) {
 return (b - d | 0) + (a - c << 3) | 0;
}

function dL(a) {
 a = a | 0;
 Uy(v[v[a >> 2] - 12 >> 2] + a | 0);
}

function cv(a) {
 return (a >>> 0 < 9 ? a : a - 9 | 256) & 65535;
}

function _h(a, b, c) {
 return Ea(1009, a | 0, b | 0, c | 0) | 0;
}

function Z9(a, b) {
 a = a | 0;
 b = b | 0;
 IH(a, b, 1203, 308);
}

function Vsa(a, b) {
 a = a | 0;
 b = b | 0;
 oH(a, b, 366, 365);
}

function V8(a) {
 a = a | 0;
 XK(v[v[a >> 2] - 12 >> 2] + a | 0);
}

function T8(a) {
 a = a | 0;
 WK(v[v[a >> 2] - 12 >> 2] + a | 0);
}

function Nta(a, b) {
 a = a | 0;
 b = b | 0;
 oH(a, b, 306, 305);
}

function Ng(a, b) {
 t[a + 4 | 0] = 0;
 v[a >> 2] = b;
 return a;
}

function Nf(a, b) {
 if (w[a | 0] > b >>> 0) {
  t[a | 0] = b;
 }
}

function Jf(a, b, c) {
 if (!(w[a | 0] & 32)) {
  Rr(b, c, a);
 }
}

function JX(a, b) {
 v[a >> 2] = v[a >> 2] + (b << 1);
 return a;
}

function IZ(a) {
 if (!(a & 255)) {
  return 1;
 }
 return Tc(a);
}

function IB(a) {
 return (v[zb(a) >> 2] - v[a >> 2] | 0) / 7 | 0;
}

function xba(a, b) {
 a = a | 0;
 b = b | 0;
 jN(a - 92 | 0, b);
}

function wba(a, b) {
 a = a | 0;
 b = b | 0;
 iN(a - 92 | 0, b);
}

function tY(a, b, c) {
 u[a >> 1] = b;
 t[a + 2 | 0] = w[c | 0];
}

function q_(a, b) {
 v[a >> 2] = v[a >> 2] + B(b, 6);
 return a;
}

function n$(a, b, c, d) {
 return Tp(a, b, c, d, 40, 107374183);
}

function lP(a) {
 v[a >> 2] = 0;
 v[a + 4 >> 2] = -1;
 return a;
}

function lG(a, b, c, d) {
 return Tp(a, b, c, d, 36, 119304648);
}

function jF(a) {
 return !id(a, 24544, 25) & w[a + 34 | 0] < 65;
}

function iL(a) {
 a = a | 0;
 Wy(v[v[a >> 2] - 12 >> 2] + a | 0);
}
function hca(a) {
 a = a | 0;
 return v[v[a + 4 >> 2] + 8 >> 2];
}

function gaa(a) {
 a = a | 0;
 v[a >> 2] = 77200;
 return a | 0;
}

function Zta(a, b) {
 a = a | 0;
 b = b | 0;
 EE(a + 36 | 0, b);
}

function Wja(a, b) {
 a = a | 0;
 b = b | 0;
 rs(a + 40 | 0, b);
}

function Pba(a, b) {
 a = a | 0;
 b = b | 0;
 zN(a - 88 | 0, b);
}

function Oba(a, b) {
 a = a | 0;
 b = b | 0;
 yN(a - 88 | 0, b);
}

function Lq(a) {
 return (a - 65 & 255) >>> 0 < 26 ? a | 32 : a;
}

function L$(a, b, c, d) {
 return Tp(a, b, c, d, 28, 153391690);
}

function GJ(a, b, c, d) {
 return Tp(a, b, c, d, 24, 178956971);
}

function Aba(a, b) {
 a = a | 0;
 b = b | 0;
 kN(a - 88 | 0, b);
}

function z$(a) {
 t[a + 12 | 0] = w[a + 12 | 0] | 2;
 return a;
}

function vy(a, b) {
 a = a | 0;
 b = b | 0;
 ig(a, b + 12 | 0);
}

function ty(a, b) {
 a = a | 0;
 b = b | 0;
 ig(a, b + 16 | 0);
}

function rk(a) {
 a = a & 255;
 return (a | 0) == 255 ? -1 : a;
}

function oz(a, b) {
 a = a | 0;
 b = b | 0;
 ig(a, b + 36 | 0);
}

function hu(a) {
 a = a | 0;
 v[a >> 2] = 48364;
 return a | 0;
}

function gY(a) {
 var b = 0;
 b = v[a >> 2];
 xe(a);
 return b;
}

function _J(a, b) {
 a = a | 0;
 b = b | 0;
 ig(a, b + 48 | 0);
}

function Z1(a) {
 a = a | 0;
 v[a >> 2] = 78280;
 return a | 0;
}

function XJ(a, b) {
 a = a | 0;
 b = b | 0;
 aq(a, b + 28 | 0);
}

function WJ(a, b) {
 a = a | 0;
 b = b | 0;
 aq(a, b + 40 | 0);
}

function VJ(a, b) {
 a = a | 0;
 b = b | 0;
 aq(a, b + 52 | 0);
}

function V9(a) {
 a = a | 0;
 v[a >> 2] = 78008;
 return a | 0;
}

function Ti(a, b) {
 return w[a + b | 0] != 63 & b >>> 0 <= 46;
}

function Q9(a) {
 a = a | 0;
 v[a >> 2] = 77620;
 return a | 0;
}

function M1(a) {
 a = a | 0;
 v[a >> 2] = 41336;
 return a | 0;
}

function Ld(a) {
 v[a >> 2] = 0;
 v[a + 4 >> 2] = 0;
 return a;
}

function Kt(a, b) {
 if (!a) {
  return 0;
 }
 return It(a, b);
}

function J1(a) {
 a = a | 0;
 v[a >> 2] = 41096;
 return a | 0;
}

function IT(a, b, c, d) {
 return Tp(a, b, c, d, 7, 613566757);
}

function I9(a, b) {
 a = a | 0;
 b = b | 0;
 tm(a, b + 12 | 0);
}

function Hn(a) {
 return (a >>> 0 <= 127 ? -1 : a ^ 128) & 255;
}

function B_(a) {
 a = (a & 65535) - 98 | 0;
 gb = 0;
 return a;
}

function $v(a, b) {
 return w[a + b | 0] != 63 & b >>> 0 <= 15;
}

function $J(a, b) {
 a = a | 0;
 b = b | 0;
 ig(a, b + 24 | 0);
}

function $9(a) {
 a = a | 0;
 v[a >> 2] = 76700;
 return a | 0;
}

function yoa(a, b) {
 a = a | 0;
 b = b | 0;
 kH(a, b, 2, 31);
}

function w4(a, b) {
 a = a | 0;
 b = b | 0;
 return $x(b) | 0;
}

function u4(a, b) {
 a = a | 0;
 b = b | 0;
 return ay(b) | 0;
}

function kZ(a, b, c) {
 Yb(a, b, Ei(b, b + c | 0, 0) - b | 0);
}

function jB(a) {
 t[a + 24 | 0] = 0;
 t[a | 0] = 0;
 return a;
}

function fI(a) {
 return (a << 1) + 16777216 >>> 0 < 16777217;
}

function bp(a, b) {
 u[a >> 1] = b;
 u[a + 2 >> 1] = b >>> 16;
}

function Zt(a, b) {
 return (a & 255) >>> 0 < (b & 255) >>> 0;
}

function Yw(a, b) {
 if (b) {
  Cc(a, b);
  return;
 }
 Eb(a);
}

function Dda(a) {
 a = a | 0;
 return OH(a, 47496, 12589) | 0;
}

function qe(a, b) {
 return Wk(x[a >> 1], x[b >> 1]) ? b : a;
}

function pba(a, b) {
 a = a | 0;
 b = +b;
 dN(a - 96 | 0, b);
}

function mi(a, b) {
 return (B(b, 104) + a | 0) + 484380 | 0;
}

function maa(a) {
 a = a | 0;
 nM(a);
 return v[a + 16 >> 2];
}

function dC(a, b, c) {
 if (c) {
  fl(a, b, c);
 }
 return a;
}

function ad(a, b) {
 return qn(v[a >> 2], v[b >> 2]) ? b : a;
}

function Yz(a, b) {
 return Rv(z[a >> 2], z[b >> 2]) ? b : a;
}

function Ye(a, b) {
 return _q(v[a >> 2], v[b >> 2]) ? b : a;
}

function Qm(a, b) {
 return Rv(z[b >> 2], z[a >> 2]) ? b : a;
}

function Nc(a, b) {
 return Wk(x[b >> 1], x[a >> 1]) ? b : a;
}

function Nba(a, b) {
 a = a | 0;
 b = +b;
 xN(a - 88 | 0, b);
}

function Lba(a, b) {
 a = a | 0;
 b = +b;
 vN(a - 88 | 0, b);
}

function Jba(a, b) {
 a = a | 0;
 b = +b;
 tN(a - 88 | 0, b);
}

function Gg(a, b, c) {
 a = Bua(a, b, c, c >> 31);
 return a;
}

function Gb(a, b) {
 return qn(v[b >> 2], v[a >> 2]) ? b : a;
}

function EB(a) {
 t[a + 4 | 0] = 0;
 t[a | 0] = 0;
 return a;
}

function Cda(a) {
 a = a | 0;
 return OH(a, 47516, 8191) | 0;
}

function Cb(a, b) {
 if (!ud(b)) {
  a = Gh(b);
 }
 return a;
}

function CB(a, b) {
 if (z[a >> 2] > b) {
  z[a >> 2] = b;
 }
}

function Bd(a, b) {
 return _q(v[b >> 2], v[a >> 2]) ? b : a;
}

function Ata(a, b) {
 a = a | 0;
 b = b | 0;
 kH(a, b, 3, 8);
}

function y9(a) {
 a = a | 0;
 return Aa(v[a + 60 >> 2]) | 0;
}

function wU(a) {
 RB(a);
 Qb(a + 27 | 0, 0, 255);
 return a;
}

function vea(a) {
 a = a | 0;
 return TH(a, 6626, 1061) | 0;
}

function psa(a, b) {
 a = a | 0;
 b = b | 0;
 wi(a, b, 282);
}

function nca(a) {
 a = a | 0;
 return UO(v[a + 4 >> 2]) | 0;
}

function naa(a) {
 a = a | 0;
 nM(a);
 return v[a + 4 >> 2];
}

function jN(a, b) {
 a = a | 0;
 b = b | 0;
 MH(a, b, 2048);
}

function iN(a, b) {
 a = a | 0;
 b = b | 0;
 MH(a, b, 4096);
}

function d2(a) {
 a = a | 0;
 return v[a + 4 >> 2] != 0 | 0;
}

function Vta(a, b) {
 a = a | 0;
 b = b | 0;
 wi(a, b, 136);
}

function Pm(a) {
 a = Cj(a);
 v[a >> 2] = 124424;
 return a;
}

function Nea(a) {
 a = a | 0;
 return TH(a, 7109, 1053) | 0;
}

function Ipa(a, b) {
 a = a | 0;
 b = b | 0;
 wi(a, b, 274);
}

function Gl(a, b) {
 return Zm((b << 1) + 121104 | 0, 2, a);
}

function Gi(a, b) {
 a = a | 0;
 b = b | 0;
 return C(C(0));
}

function Apa(a, b) {
 a = a | 0;
 b = b | 0;
 wi(a, b, 106);
}

function Aca(a) {
 a = a | 0;
 return KO(v[a + 4 >> 2]) | 0;
}

function ypa(a, b) {
 a = a | 0;
 b = b | 0;
 wi(a, b, 72);
}

function xha(a) {
 a = a | 0;
 t[a + 4202 | 0] = 1;
 lQ(a);
}

function uu(a) {
 a = a | 0;
 hb[v[v[a >> 2] + 4 >> 2]](a);
}

function qsa(a, b) {
 a = a | 0;
 b = b | 0;
 Mr(a, b, 17);
}

function nq(a) {
 a = a | 0;
 tq(a + 8 | 0);
 return a | 0;
}

function io(a) {
 a = a | 0;
 _K(v[a >> 2]);
 return a | 0;
}

function ho(a) {
 return hb[v[v[a >> 2] + 28 >> 2]](a) | 0;
}

function dW(a, b, c, d) {
 Yb(a, b, (d | 0) == -1 ? c : d);
}

function cf(a, b) {
 return Zt(w[a | 0], w[b | 0]) ? b : a;
}

function bua(a, b) {
 a = a | 0;
 b = b | 0;
 rH(a, b, 28);
}

function _i(a, b) {
 t[a | 0] = b;
 t[a + 1 | 0] = b >>> 8;
}

function Ut(a) {
 a = PL(a);
 v[a >> 2] = 94520;
 return a;
}

function Qf(a) {
 a = a | 0;
 Xh(a + 8 | 0);
 return a | 0;
}

function Pb(a, b) {
 return Zt(w[b | 0], w[a | 0]) ? b : a;
}

function NK(a) {
 a = PL(a);
 v[a >> 2] = 94912;
 return a;
}

function Iy(a, b, c) {
 a = oI(a, b, c, -1, -1);
 return a;
}

function Hqa(a, b) {
 a = a | 0;
 b = b | 0;
 wi(a, b, 42);
}

function Hk(a) {
 return hb[v[v[a >> 2] + 36 >> 2]](a) | 0;
}

function Ft(a) {
 a = a | 0;
 sl(a + 8 | 0);
 return a | 0;
}

function Et(a) {
 a = a | 0;
 sl(a + 4 | 0);
 return a | 0;
}

function Dm(a) {
 a = a | 0;
 Vy(v[a >> 2]);
 return a | 0;
}

function AY(a, b) {
 a = a | 0;
 b = b | 0;
 wi(a, b, 284);
}

function $sa(a, b) {
 a = a | 0;
 b = b | 0;
 wi(a, b, 34);
}

function wZ(a, b) {
 a = a | 0;
 b = b | 0;
 Mr(a, b, 32);
}

function vU(a, b) {
 v[a >> 2] = v[a >> 2] + b;
 return a;
}

function uk(a) {
 sb(a + 36 | 0);
 uc(a + 24 | 0);
 Jk(a);
}

function rm(a) {
 a = v[a + 8 >> 2];
 if (a) {
  Bb(a);
 }
}

function mr(a, b, c) {
 v[a >> 2] = b;
 v[a + 4 >> 2] = c;
}

function mn(a) {
 eC(v[a + 20 >> 2]);
 v[a + 20 >> 2] = 0;
}

function li(a) {
 return v[v[a + 8 >> 2] >> 2] == (a | 0);
}

function e0(a, b) {
 a = a | 0;
 b = b | 0;
 wi(a, b, 50);
}

function cY(a, b) {
 a = a | 0;
 b = b | 0;
 return b | 0;
}

function bK(a, b) {
 a = a | 0;
 b = b | 0;
 rf(a, 1, 45);
}

function ar(a) {
 tf(a + 24 | 0);
 ec(a + 12 | 0);
 ec(a);
}

function aK(a, b) {
 a = a | 0;
 b = b | 0;
 Ay(a, 1, 45);
}

function Z0(a, b) {
 a = a | 0;
 b = b | 0;
 wi(a, b, 59);
}

function Yq(a, b) {
 return a << 16 >> 16 < b << 16 >> 16;
}

function Vqa(a, b) {
 a = a | 0;
 b = b | 0;
 C0(a, b, 8);
}

function V5(a, b) {
 a = a | 0;
 b = b | 0;
 tn(a, 96584);
}

function UW(a) {
 a = Aua(a & 65535, 0, 80, 0);
 return a;
}

function U5(a, b) {
 a = a | 0;
 b = b | 0;
 tn(a, 96604);
}

function T5(a, b) {
 a = a | 0;
 b = b | 0;
 Cc(a, 11280);
}

function S5(a, b) {
 a = a | 0;
 b = b | 0;
 Cc(a, 11397);
}

function M0(a, b) {
 a = a | 0;
 b = b | 0;
 Mr(a, b, 11);
}

function Iq(a, b) {
 t[a | 0] = b + 48;
 return a + 1 | 0;
}

function Hp(a) {
 os(a + 32 | 0);
 tb(a + 12 | 0);
 sb(a);
}

function Gp(a, b, c, d) {
 a = Bua(a, b, c, d);
 return a;
}

function CQ(a) {
 v[a >> 2] = v[a >> 2] - 2048;
 return a;
}

function AQ(a, b, c) {
 a = a | 0;
 b = b | 0;
 c = c | 0;
}

function zba(a) {
 a = a | 0;
 return nq(a - 92 | 0) | 0;
}

function uX(a, b) {
 a = a | 0;
 b = b | 0;
 rH(a, b, 4);
}

function rba(a) {
 a = a | 0;
 return nq(a - 96 | 0) | 0;
}

function lca(a) {
 a = a | 0;
 return +QO(v[a + 4 >> 2]);
}

function eA(a) {
 return v[zb(a) >> 2] - v[a >> 2] >> 11;
}

function dl(a) {
 return (a | 0) == 32 | a - 9 >>> 0 < 5;
}

function Zv(a, b, c) {
 return a < b ? b : a > c ? c : a;
}

function Zg(a, b, c) {
 t[a + 4 | 0] = c;
 v[a >> 2] = b;
}

function Vt(a) {
 return (a | 0) <= 65535 & (a | 0) >= 0;
}

function Vfa(a) {
 a = a | 0;
 return (a | 0) == 277 | 0;
}

function Rba(a) {
 a = a | 0;
 return nq(a - 88 | 0) | 0;
}

function PV(a) {
 v[a >> 2] = v[a >> 2] - 256;
 return a;
}

function M4(a, b) {
 a = a | 0;
 b = b | 0;
 BH(a, b, 0);
}

function L4(a, b) {
 a = a | 0;
 b = b | 0;
 BH(a, b, 1);
}

function K4(a, b) {
 a = a | 0;
 b = b | 0;
 AH(a, b, 0);
}

function JP(a) {
 a = a | 0;
 Qb(a + 4296 | 0, 0, 81928);
}

function J4(a, b) {
 a = a | 0;
 b = b | 0;
 AH(a, b, 1);
}

function G2(a, b) {
 a = a | 0;
 b = b | 0;
 ys(a, 1, b);
}

function DB(a, b, c) {
 return a < b ? b : a > c ? c : a;
}

function CG(a, b) {
 Sb(a, b);
 Sb(a + 4 | 0, b + 4 | 0);
}

function B3(a) {
 a = a | 0;
 if (a) {
  lI(gl(a), 1);
 }
}

function As(a, b) {
 v[a + 24 >> 2] = v[a + 24 >> 2] + b;
}

function $H(a) {
 a = Ca(a | 0) | 0;
 gb = fb;
 return a;
}

function zj(a) {
 u[a + 4 >> 1] = 65535;
 v[a >> 2] = 0;
}

function zG(a) {
 return vL(a, C(2524354896707238e-44));
}

function z6(a) {
 a = a | 0;
 $c(a, 501248, Vc(499632));
}

function y6(a) {
 a = a | 0;
 $c(a, 501256, Vc(499672));
}

function x6(a) {
 a = a | 0;
 $c(a, 501264, Vc(499680));
}

function w6(a) {
 a = a | 0;
 $c(a, 501272, Vc(499688));
}

function vm(a) {
 v[a >> 2] = v[a >> 2] + 12;
 return a;
}

function v6(a) {
 a = a | 0;
 $c(a, 501280, Vc(499696));
}

function ut(a) {
 return a - 65 >>> 0 < 26 ? a | 32 : a;
}

function u6(a) {
 a = a | 0;
 $c(a, 501288, Vc(499704));
}

function t6(a) {
 a = a | 0;
 $c(a, 501296, Vc(499712));
}

function s6(a) {
 a = a | 0;
 $c(a, 501304, Vc(499720));
}

function r6(a) {
 a = a | 0;
 $c(a, 501312, Vc(499728));
}

function q6(a) {
 a = a | 0;
 $c(a, 501320, Vc(499640));
}

function pw(a) {
 v[a >> 2] = v[a >> 2] - 28;
 return a;
}

function pC(a) {
 return v[zb(a) >> 2] - v[a >> 2] >> 8;
}

function p6(a) {
 a = a | 0;
 $c(a, 501336, Vc(499648));
}

function nl(a) {
 return a - 97 >>> 0 < 26 ? a & 95 : a;
}

function n6(a) {
 a = a | 0;
 $c(a, 501352, Vc(499656));
}

function lv(a) {
 return v[zb(a) >> 2] - v[a >> 2] >> 4;
}

function l6(a) {
 a = a | 0;
 $c(a, 501368, Vc(499664));
}

function ke(a, b) {
 return (b | 0) != 0 & (a | 0) != 0;
}

function k6(a) {
 a = a | 0;
 $c(a, 501384, Vc(499736));
}

function jG(a) {
 v[a >> 2] = v[a >> 2] - 36;
 return a;
}

function j6(a) {
 a = a | 0;
 $c(a, 501392, Vc(499744));
}

function j$(a) {
 v[a >> 2] = v[a >> 2] - 40;
 return a;
}

function ik(a) {
 v[a >> 2] = v[a >> 2] - 12;
 return a;
}

function hc(a) {
 v[v[a >> 2] + 4 >> 2] = v[a + 4 >> 2];
}

function gt(a) {
 v[a >> 2] = v[a >> 2] - 24;
 return a;
}

function gA(a) {
 v[a >> 2] = v[a >> 2] + 24;
 return a;
}

function bm(a) {
 v[a >> 2] = v[a >> 2] + 28;
 return a;
}

function bX(a) {
 v[a >> 2] = v[a >> 2] - 56;
 return a;
}

function Zq(a) {
 v[a >> 2] = v[a >> 2] + 32;
 return a;
}

function Yo(a) {
 return v[zb(a) >> 2] - v[a >> 2] >> 5;
}

function Xq(a) {
 v[a >> 2] = v[a >> 2] - 16;
 return a;
}

function Vz(a) {
 return v[mc(a) >> 2] - v[a >> 2] >> 2;
}

function Uo(a) {
 v[a >> 2] = v[a >> 2] + 16;
 return a;
}

function Ug(a) {
 return v[zb(a) >> 2] - v[a >> 2] >> 2;
}

function To(a) {
 v[a >> 2] = v[a >> 2] - 32;
 return a;
}

function Sl(a) {
 v[a >> 2] = v[a >> 2] + 52;
 return a;
}

function Rn(a) {
 return v[zb(a) >> 2] - v[a >> 2] >> 3;
}

function RG(a) {
 return vL(a, C(15845632502852868e13));
}

function Pf(a) {
 v[a >> 2] = v[a >> 2] + 20;
 return a;
}

function P6(a) {
 a = a | 0;
 $c(a, 501072, Vc(499592));
}

function O6(a) {
 a = a | 0;
 $c(a, 501080, Vc(499600));
}

function N6(a) {
 a = a | 0;
 $c(a, 501088, Vc(499796));
}

function M6(a) {
 a = a | 0;
 $c(a, 501104, Vc(499788));
}

function L6(a) {
 a = a | 0;
 $c(a, 501112, Vc(499804));
}

function KY(a) {
 v[a >> 2] = v[a >> 2] - 33;
 return a;
}

function J6(a) {
 a = a | 0;
 $c(a, 501120, Vc(499812));
}

function I6(a) {
 a = a | 0;
 $c(a, 501136, Vc(499820));
}

function H6(a) {
 a = a | 0;
 $c(a, 501144, Vc(499836));
}

function Gn(a) {
 return v[zb(a) >> 2] - v[a >> 2] >> 1;
}

function G6(a) {
 a = a | 0;
 $c(a, 501152, Vc(499828));
}

function F6(a) {
 a = a | 0;
 $c(a, 501160, Vc(499844));
}

function E_(a) {
 v[a >> 2] = v[a >> 2] - 20;
 return a;
}

function E6(a) {
 a = a | 0;
 $c(a, 501168, Vc(499852));
}

function D6(a) {
 a = a | 0;
 $c(a, 501192, Vc(499860));
}

function C6(a) {
 a = a | 0;
 $c(a, 501224, Vc(499608));
}

function B6(a) {
 a = a | 0;
 $c(a, 501232, Vc(499616));
}

function An(a, b, c) {
 return Xj(a, b) >>> 0 > c >>> 0;
}

function A6(a) {
 a = a | 0;
 $c(a, 501240, Vc(499624));
}

function $Q(a) {
 v[a >> 2] = v[a >> 2] - 52;
 return a;
}

function xe(a) {
 v[a >> 2] = v[a >> 2] + 1;
 return a;
}

function wx(a, b) {
 v[a + 4 >> 2] = 3;
 v[a >> 2] = b;
}

function vj(a) {
 v[a >> 2] = v[a >> 2] - 4;
 return a;
}

function uf(a, b, c) {
 a = Aua(c, 0, a, b);
 return a;
}

function tj(a, b) {
 v[a + 4 >> 2] = 1;
 v[a >> 2] = b;
}

function tga(a) {
 a = a | 0;
 return v[a + 4260 >> 2];
}

function tW(a) {
 return Te(443250 / +(a >>> 0) * 1e4);
}

function sg(a) {
 v[a >> 2] = v[a >> 2] + 6;
 return a;
}

function sW(a) {
 v[a >> 2] = v[a >> 2] - 1;
 return a;
}

function rl(a) {
 a = a | 0;
 return hL(a) << 24 >> 24;
}

function rka(a, b) {
 a = a | 0;
 b = b | 0;
 eU(a, b);
}

function qka(a, b) {
 a = a | 0;
 b = b | 0;
 JS(a, b);
}

function pz(a, b, c) {
 Yb(a, (c << 12) + b | 0, 4096);
}

function n9(a) {
 a = a | 0;
 return Sh(a, 499608) | 0;
}

function jk(a, b) {
 v[a + 4 >> 2] = 2;
 v[a >> 2] = b;
}

function gs(a) {
 v[a >> 2] = v[a >> 2] - 8;
 return a;
}

function g9(a) {
 a = a | 0;
 return Sh(a, 499624) | 0;
}

function fo(a) {
 a = a | 0;
 Es(a, 162, 124868, 1050);
}

function fla(a, b) {
 a = a | 0;
 b = b | 0;
 Ub(a, b);
}

function fe(a) {
 v[a >> 2] = v[a >> 2] + 2;
 return a;
}

function dZ(a) {
 v[a >> 2] = v[a >> 2] - 6;
 return a;
}

function cy(a, b) {
 v[a + 4 >> 2] = 4;
 v[a >> 2] = b;
}

function Yfa(a, b) {
 a = a | 0;
 b = b | 0;
 return 3;
}

function Xe(a) {
 v[a >> 2] = v[a >> 2] + 4;
 return a;
}

function Wfa(a, b) {
 a = a | 0;
 b = b | 0;
 return 2;
}

function Uk(a) {
 v[a >> 2] = v[a >> 2] - 2;
 return a;
}

function Sy(a) {
 a = a | 0;
 return Sh(a, 499788) | 0;
}

function SO(a) {
 return y[a + 1074420 >> 2] / 1e4 | 0;
}

function Rta(a, b) {
 a = a | 0;
 b = b | 0;
 Zy(a, b);
}

function RI(a) {
 a = a | 0;
 return td(a - 8 | 0) | 0;
}

function Qy(a) {
 a = a | 0;
 return Sh(a, 499804) | 0;
}

function QI(a) {
 a = a | 0;
 return jy(a - 8 | 0) | 0;
}

function PI(a) {
 a = a | 0;
 return iy(a - 8 | 0) | 0;
}

function PB(a) {
 v[a >> 2] = v[a >> 2] + 8;
 return a;
}

function OK(a) {
 v[a + 4 >> 2] = v[a + 4 >> 2] | 8192;
}

function OI(a) {
 a = a | 0;
 return hy(a - 8 | 0) | 0;
}

function NI(a) {
 a = a | 0;
 return gy(a - 8 | 0) | 0;
}

function My(a) {
 a = a | 0;
 return Sh(a, 499852) | 0;
}

function MI(a) {
 a = a | 0;
 return fy(a - 8 | 0) | 0;
}

function LI(a) {
 a = a | 0;
 return ey(a - 8 | 0) | 0;
}

function LD(a) {
 a = a | 0;
 return Sh(a, 499812) | 0;
}

function Kha(a, b) {
 a = a | 0;
 b = b | 0;
 vF(a, b);
}

function I4(a) {
 a = a | 0;
 Es(a, 162, 124868, 1230);
}

function Gt(a, b) {
 a = a | 0;
 b = b | 0;
 return -1;
}

function GI(a) {
 a = a | 0;
 return zH(a, 101616) | 0;
}

function Fy(a) {
 a = a | 0;
 return Sh(a, 499860) | 0;
}

function Fw(a) {
 a = a | 0;
 return Sh(a, 499796) | 0;
}

function FI(a) {
 a = a | 0;
 return zH(a, 101512) | 0;
}

function EI(a) {
 a = a | 0;
 return yH(a, 101408) | 0;
}

function DT(a) {
 v[a >> 2] = v[a >> 2] - 7;
 return a;
}

function DI(a) {
 a = a | 0;
 return yH(a, 101304) | 0;
}

function Cg(a, b, c) {
 wk(b, b + c | 0, a);
 return a;
}

function Aka(a, b) {
 a = a | 0;
 b = b | 0;
 Gr(a, b);
}

function $o(a) {
 return v[zb(a) >> 2] - v[a >> 2] | 0;
}

function xP(a, b) {
 a = a | 0;
 b = b | 0;
 return 0;
}

function vF(a, b) {
 a = a | 0;
 b = b | 0;
 r_(a, b);
}

function pia(a) {
 a = a | 0;
 return w[a + 4201 | 0];
}

function ph(a) {
 a = v[a >> 2];
 if (a) {
  oK(a);
 }
}

function oia(a) {
 a = a | 0;
 return w[a + 4202 | 0];
}

function oY(a, b) {
 v[a >> 2] = v[a >> 2] + (b << 2);
}

function o2(a, b) {
 a = a | 0;
 b = b | 0;
 $n(a, b);
}

function kt(a, b) {
 hb[v[v[b >> 2] + 40 >> 2]](a, b);
}

function jl(a, b) {
 hb[v[v[b >> 2] + 44 >> 2]](a, b);
}

function jI(a) {
 return (x[a + 2 >> 1] << 2) + a | 0;
}

function il(a, b) {
 hb[v[v[b >> 2] + 32 >> 2]](a, b);
}

function iC(a, b) {
 a = a | 0;
 b = b | 0;
 iV(a, b);
}

function el(a) {
 a = v[a >> 2];
 if (a) {
  hl(a);
 }
}

function bA(a, b) {
 a = a | 0;
 b = b | 0;
 return 1;
}

function Tr(a, b) {
 a = a | 0;
 b = b | 0;
 ex(a, b);
}

function Tf(a, b) {
 a = a | 0;
 b = b | 0;
 ig(a, b);
}

function SM(a) {
 return a ? (a | 0) == 2 ? 3 : 2 : 1;
}

function Rk(a, b) {
 a = a | 0;
 b = b | 0;
 tm(a, b);
}

function Qs(a) {
 return (a | 0) == 32 | (a | 0) == 9;
}

function Q$(a, b) {
 v[a >> 2] = v[a >> 2] + (b << 1);
}

function P2(a, b) {
 a = a | 0;
 b = b | 0;
 Gx(a, b);
}

function Mba(a) {
 a = a | 0;
 return +wN(a - 88 | 0);
}

function M3(a, b) {
 a = a | 0;
 b = b | 0;
 fx(a, b);
}

function L9(a, b) {
 a = a | 0;
 b = b | 0;
 ou(a, b);
}

function Kba(a) {
 a = a | 0;
 return +uN(a - 88 | 0);
}

function Iba(a) {
 a = a | 0;
 return +sN(a - 88 | 0);
}

function H2(a, b) {
 a = a | 0;
 b = b | 0;
 zs(a, b);
}

function Gr(a, b) {
 a = a | 0;
 b = b | 0;
 Tf(a, b);
}

function Bs(a, b) {
 v[a >> 2] = b;
 nm(b);
 return a;
}

function A2(a, b) {
 a = a | 0;
 b = b | 0;
 Op(a, b);
}

function $n(a, b) {
 a = a | 0;
 b = b | 0;
 Rk(a, b);
}

function vL(a, b) {
 return C(Lx(a ? C(-b) : b) * b);
}

function of(a, b) {
 v[a + 8 >> 2] = b | -2147483648;
}

function Qr(a, b, c, d, e) {
 vH(a, b, c, d, e, 256);
}

function Pl(a, b) {
 return Yq(x[a >> 1], x[b >> 1]);
}

function Ly() {
 ca(Pm(cc(4)) | 0, 124508, 34);
 p();
}

function Jw(a, b, c, d, e) {
 vH(a, b, c, d, e, 128);
}

function zga(a) {
 a = a | 0;
 v[a + 4224 >> 2] = 0;
}

function uy(a) {
 a = a | 0;
 return v[a + 12 >> 2];
}

function sca(a, b) {
 a = a | 0;
 b = b | 0;
 NO(a);
}

function ona(a) {
 a = a | 0;
 OW(a);
 return a | 0;
}

function oR(a, b) {
 Yc(a, b & 4 ? 16 : 8, 1, 0, 0);
}

function nm(a) {
 v[a + 4 >> 2] = v[a + 4 >> 2] + 1;
}

function m0(a, b, c) {
 return !id(a, c, b - a | 0);
}

function jg(a, b) {
 a = Bua(0, a, b, 0);
 return a;
}

function ie(a) {
 v[v[a + 8 >> 2] >> 2] = v[a >> 2];
}

function iaa(a) {
 a = a | 0;
 return w[a + 40 | 0];
}

function ZJ(a) {
 a = a | 0;
 return v[a + 60 >> 2];
}

function Xu(a, b, c) {
 kg(a, c);
 gd(b + c | 0, 0);
}

function Wz(a) {
 return C(C(a * C(7900)) + C(100));
}

function Uba(a, b) {
 a = a | 0;
 b = b | 0;
 $O(a);
}

function UJ(a) {
 a = a | 0;
 return v[a + 64 >> 2];
}

function RO(a) {
 return +y[a + 1074420 >> 2] / 1e4;
}

function Q1(a) {
 a = a | 0;
 return v[a + 16 >> 2];
}

function GP(a) {
 v[a >> 2] = 0;
 v[a + 4 >> 2] = 0;
}

function Ab(a) {
 return (a << 8 | a >>> 8) & 65535;
}

function ye(a) {
 return Ab(a & 65535) << 16 >> 16;
}

function tT(a, b) {
 return (0 - b | 0) != (a | 0);
}

function oe(a, b, c) {
 ul(a, b, Sc(b, c) + b | 0);
}

function ms(a) {
 a = a | 0;
 return v[a + 4 >> 2];
}

function mo(a, b, c) {
 return hb[c | 0](a, b) | 0;
}

function ls(a) {
 a = a | 0;
 return v[a + 8 >> 2];
}

function daa(a) {
 a = a | 0;
 return w[a + 8 | 0];
}

function bi(a, b) {
 a = a | 0;
 b = b | 0;
 Eb(a);
}

function Zm(a, b, c) {
 return wk(a, a + b | 0, c);
}

function Ww(a) {
 t[a + 2 | 0] = 0;
 u[a >> 1] = 0;
}

function WY(a, b, c) {
 fD(a, (b << 2) + a | 0, c);
}

function OM(a, b) {
 a = a | 0;
 b = b | 0;
 Vm(b);
}

function NM(a, b) {
 a = a | 0;
 b = b | 0;
 ec(b);
}

function B9(a, b) {
 a = a | 0;
 b = b | 0;
 Bb(b);
}

function zJ(a) {
 if (!w[a + 4 | 0]) {
  kJ(a);
 }
}

function xy(a) {
 a = a | 0;
 return t[a + 8 | 0];
}

function xv(a) {
 if (!w[a + 4 | 0]) {
  oW(a);
 }
}

function wy(a) {
 a = a | 0;
 return t[a + 9 | 0];
}

function rp(a) {
 t[a | 0] = 0;
 t[a + 1 | 0] = 0;
}

function ni(a) {
 return (a & 65535) >>> 0 < 3999;
}

function ip(a, b) {
 u[a + 8 >> 1] = b;
 return a;
}

function fY(a) {
 if (!w[a + 4 | 0]) {
  aY(a);
 }
}

function ega(a) {
 a = a | 0;
 return -2013527448;
}

function dU(a) {
 if (!w[a + 4 | 0]) {
  eW(a);
 }
}

function cN(a) {
 if (!w[a + 4 | 0]) {
  bN(a);
 }
}

function ah(a) {
 if (!w[a + 4 | 0]) {
  LQ(a);
 }
}

function aM(a) {
 if (!w[a + 4 | 0]) {
  LH(a);
 }
}

function _l(a) {
 if (!w[a + 4 | 0]) {
  t$(a);
 }
}

function YV(a) {
 if (!w[a + 4 | 0]) {
  XV(a);
 }
}

function Xx(a) {
 return a - 501712 >>> 2 & 65535;
}

function Wi(a) {
 if (!w[a + 4 | 0]) {
  BZ(a);
 }
}

function We(a, b) {
 v[a + 4 >> 2] = b;
 return a;
}

function VE(a) {
 if (!w[a + 4 | 0]) {
  UE(a);
 }
}

function Rj(a) {
 if (!w[a + 4 | 0]) {
  RF(a);
 }
}

function RZ(a, b, c) {
 Wl(a, b & 65535, c & 255);
}

function OC(a, b, c) {
 return MX(a, NX(a, b, c));
}

function LW(a) {
 return (a | 0) >= 120 ? 120 : a;
}

function Ij(a) {
 return (a - 1 & 255) >>> 0 < 17;
}

function IP(a) {
 return C(C(a * C(96)) + C(-96));
}

function I8(a) {
 a = a | 0;
 return LK(a, 0) | 0;
}

function Hq(a) {
 if (w[a + 24 | 0]) {
  XS(a);
 }
}

function H8(a) {
 a = a | 0;
 return LK(a, 1) | 0;
}

function GS(a, b) {
 return (Ol(a, b) | 0) != 255;
}

function Fi(a) {
 a = a | 0;
 t[a + 4202 | 0] = 0;
}

function Bh(a) {
 nf(a + 52 | 0);
 ec(a + 40 | 0);
}

function B8(a) {
 a = a | 0;
 return JK(a, 0) | 0;
}

function Ak(a) {
 return aH(a, C(4294967296), -1);
}

function A8(a) {
 a = a | 0;
 return JK(a, 1) | 0;
}

function $u(a) {
 if (!w[a + 4 | 0]) {
  EG(a);
 }
}

function uga(a) {
 a = a | 0;
 return -275227023;
}

function tha(a) {
 a = a | 0;
 return -270114148;
}

function sj(a, b, c) {
 Uc(Uc(a, b) + 12 | 0, c);
}

function jy(a) {
 a = a | 0;
 return a + 184 | 0;
}

function iy(a) {
 a = a | 0;
 return a + 472 | 0;
}

function hy(a) {
 a = a | 0;
 return a + 496 | 0;
}

function hha(a) {
 a = a | 0;
 return -285139079;
}

function gy(a) {
 a = a | 0;
 return a + 508 | 0;
}

function fy(a) {
 a = a | 0;
 return a + 520 | 0;
}

function fv(a) {
 Om(a, Ro(a), 78512);
 return a;
}

function fs(a, b) {
 return (b - a | 0) / 36 | 0;
}

function fm(a, b) {
 return (b - a | 0) / 52 | 0;
}

function ey(a) {
 a = a | 0;
 return a + 532 | 0;
}

function ej(a, b) {
 return (b - a | 0) / 24 | 0;
}

function bT(a) {
 return (a + 5 & 255) >>> 0 < 2;
}

function az(a) {
 return (q(a), j(2)) >>> 20 | 0;
}

function ZI(a) {
 a = C(a - a);
 return C(a / a);
}

function Vd(a, b) {
 return Jb(a) + (b << 2) | 0;
}

function Tga(a) {
 a = a | 0;
 return -281111764;
}

function Td(a, b) {
 return (b - a | 0) / 12 | 0;
}

function Rf(a, b) {
 return (b - a | 0) / 20 | 0;
}

function Pv(a, b) {
 return (b - a | 0) / 33 | 0;
}

function PC(a, b) {
 if (!SX(a, b)) {
  IX(b);
 }
}

function OS(a, b) {
 return wH(a, b, 2147483647);
}

function Mga(a) {
 a = a | 0;
 return -271958638;
}

function IK(a, b) {
 return (eo(a, b) | 0) != -1;
}

function Hr(a, b) {
 return (b - a | 0) / 28 | 0;
}

function Ega(a) {
 a = a | 0;
 return -620920304;
}

function Cv(a, b) {
 return (b - a | 0) / 56 | 0;
}

function Br(a, b) {
 return (b - a | 0) / 40 | 0;
}

function Bj(a, b) {
 return sB(a & 255, b & 255);
}

function $ga(a) {
 a = a | 0;
 return -284078960;
}

function xu(a, b) {
 return (a - b | 0) / 6 | 0;
}

function xl(a, b) {
 return (a + b | 0) - 1 | 0;
}

function xka(a) {
 a = a | 0;
 return Kh(a) | 0;
}

function td(a) {
 a = a | 0;
 return a + 16 | 0;
}

function rG(a, b, c) {
 ac(a, b, hh(b, c) << 3);
}

function ota(a) {
 a = a | 0;
 return V_(a) | 0;
}

function mt(a) {
 a = a | 0;
 return 2147483647;
}

function lga(a) {
 a = a | 0;
 return 302837129;
}

function kP(a) {
 a = a | 0;
 WH(a, 47360, 998);
}

function kC(a, b, c, d, e) {
 qU(a, b, c, d, e);
}

function jr(a) {
 return (a & 255) == 1 ? 1 : 2;
}

function iY(a) {
 iz(a);
 Je(v[a + 80 >> 2], a);
}

function hta(a) {
 a = a | 0;
 return Dc(a) | 0;
}

function hia(a) {
 a = a | 0;
 return 542066252;
}

function hK(a) {
 A[(eb - 16 | 0) + 8 >> 3] = a;
}

function eC(a) {
 if (a) {
  Bb(a + -64 | 0);
 }
}

function cT(a) {
 Be(a + 8 | 0);
 WS(a + 4 | 0);
}

function _D(a, b, c) {
 ub(ub(a, b) + 4 | 0, c);
}

function XY(a, b, c) {
 ac(a, b, nc(b, c) << 2);
}

function Us(a) {
 return (ay(a) | 0) != (a | 0);
}

function Ts(a) {
 return ($x(a) | 0) != (a | 0);
}

function Sz(a) {
 a = a | 0;
 WH(a, 47416, 1e3);
}

function Ql(a, b) {
 return t[a | 0] < t[b | 0];
}

function Oja(a) {
 a = a | 0;
 return Ji(a) | 0;
}

function Ksa(a) {
 a = a | 0;
 return OD(a) | 0;
}

function Jg(a) {
 return C(D(a)) == C(Infinity);
}

function HB(a, b) {
 return (b - a | 0) / 7 | 0;
}

function Fk(a, b) {
 return (b - a | 0) / 6 | 0;
}

function Cj(a) {
 v[a >> 2] = 125120;
 return a;
}

function BQ(a) {
 a = a | 0;
 return 1869112133;
}

function wv(a, b, c) {
 return Sp(a, b, c, 12);
}

function uP(a, b, c) {
 return dH(a, b, c, 68);
}

function q$(a, b, c) {
 return Sp(a, b, c, 40);
}

function lc(a, b) {
 return (a | 0) == (b | 0);
}

function k2(a) {
 a = a | 0;
 return Qg(a) | 0;
}

function f0(a) {
 a = a | 0;
 return bx(a) | 0;
}

function bL(a) {
 a = a | 0;
 return sl(a) | 0;
}

function b9(a) {
 a = a | 0;
 return ql(a) | 0;
}

function Yx(a) {
 return (a << 2) + 501712 | 0;
}

function Yia(a) {
 a = a | 0;
 Mr(a, 22256, 1);
}

function Xk(a) {
 return B(In(a), Zd(a)) & 255;
}

function W6(a) {
 a = a | 0;
 return ry(a) | 0;
}

function Uu(a, b) {
 return uH(a, b, -1, 0, 0);
}

function Tm(a) {
 return C(D(a)) < C(Infinity);
}

function TK(a) {
 a = a | 0;
 return ox(a) | 0;
}

function Qi(a, b, c) {
 WY(b, c, a);
 return a;
}

function QF(a) {
 a = a | 0;
 return fh(a) | 0;
}

function PL(a) {
 v[a >> 2] = 94548;
 return a;
}

function On(a) {
 v[a >> 2] = 77152;
 return a;
}

function JW(a) {
 return (a & 255) >>> 0 < 129;
}

function JM(a) {
 v[a >> 2] = 48684;
 return a;
}

function I1(a) {
 a = a | 0;
 hG(Qb(a, 0, 36));
}

function H1(a) {
 a = a | 0;
 return Xh(a) | 0;
}

function Gz(a) {
 v[a >> 2] = 48200;
 return a;
}

function Fz(a) {
 v[a >> 2] = 48224;
 return a;
}

function FM(a) {
 v[a >> 2] = 74296;
 return a;
}

function Ez(a) {
 v[a >> 2] = 48304;
 return a;
}

function Ed(a, b) {
 return (a | 0) != (b | 0);
}

function Dz(a) {
 v[a >> 2] = 48344;
 return a;
}

function Dw(a, b, c) {
 return Sp(a, b, c, 20);
}

function Dka(a) {
 a = a | 0;
 ZH(a, 115, 114);
}

function DF(a) {
 a = a | 0;
 return Yd(a) | 0;
}

function CJ(a, b, c) {
 return Sp(a, b, c, 24);
}

function yba(a) {
 a = a | 0;
 eu(a - 92 | 0);
}

function wn(a) {
 return (a & 740327453) != 0;
}

function wh(a, b, c) {
 return Up(a, b, c, 2);
}

function ub(a, b) {
 v[a >> 2] = b;
 return a;
}

function qn(a, b) {
 return a >>> 0 < b >>> 0;
}

function qba(a) {
 a = a | 0;
 eu(a - 96 | 0);
}

function nC(a, b, c) {
 return Up(a, b, c, 5);
}

function kv(a, b, c) {
 return Up(a, b, c, 4);
}

function hs(a, b, c) {
 return Up(a, b, c, 3);
}

function cW(a, b) {
 return B(b, 872) + a | 0;
}

function as(a, b) {
 return (b << 11) + a | 0;
}

function aj(a, b, c) {
 return Up(a, b, c, 1);
}

function _q(a, b) {
 return (a | 0) < (b | 0);
}

function _d(a, b) {
 return B(b, 160) + a | 0;
}

function WQ(a, b) {
 return Dk(a, b - a >> 2);
}

function Qba(a) {
 a = a | 0;
 eu(a - 88 | 0);
}

function Mo(a, b) {
 return (b << 13) + a | 0;
}

function MX(a, b) {
 return LX(a, b - a >> 1);
}

function Kw(a, b) {
 u[a >> 1] = b;
 return a;
}

function IV(a, b, c) {
 return Mx(a, b, c, 5);
}

function En(a, b, c) {
 return Mx(a, b, c, 2);
}

function Cr(a, b, c) {
 return Sp(a, b, c, 6);
}

function Bp(a, b, c) {
 return Mx(a, b, c, 1);
}

function AV(a) {
 return (a & 65535) == 65534;
}

function zA(a, b) {
 return B(b, 28) + a | 0;
}

function yF(a) {
 return (a & 255) + 704 | 0;
}

function xb(a, b) {
 return (b << 2) + a | 0;
}

function vf(a, b) {
 return B(b, 24) + a | 0;
}

function uo(a, b) {
 v[a + 1298472 >> 2] = b;
}

function ud(a) {
 return (a & 128) >>> 7 | 0;
}

function tv(a, b) {
 return B(b, 36) + a | 0;
}

function ol(a) {
 return (a & 255) >>> 0 > 1;
}

function kq(a, b) {
 t[a | 0] = b;
 return a;
}

function gn(a, b) {
 return (b << 8) + a | 0;
}

function bh(a, b) {
 return B(b, 20) + a | 0;
}

function bF(a) {
 return a >>> 0 > 8 ? 5 : 4;
}

function bD(a, b) {
 return Pe(a, 0 - b | 0);
}

function Zi(a, b) {
 return B(b, 52) + a | 0;
}

function Xj(a, b) {
 return fm(a, b) & 65535;
}

function Xd(a, b) {
 return (b << 4) + a | 0;
}

function VO(a) {
 return x[a + 1074448 >> 1];
}

function VG(a, b) {
 Ls(a, b, 12, 357913942);
}

function Ud(a, b) {
 return B(b, 12) + a | 0;
}

function Se(a, b) {
 return (b << 3) + a | 0;
}

function RY(a, b) {
 return B(b, 33) + a | 0;
}

function RE(a, b) {
 Ls(a, b, 20, 214748365);
}

function Oe(a, b) {
 return (b << 5) + a | 0;
}

function Me(a, b) {
 t[a + 11 | 0] = b & 127;
}

function MD(a) {
 return fH(a, 65535, 65535);
}

function GC(a, b) {
 return B(b, 56) + a | 0;
}

function $b(a, b) {
 return (b << 1) + a | 0;
}

function $D(a, b) {
 return Pe(a, b - a | 0);
}

function zy(a, b) {
 return !(b >>> 31 | 0);
}

function wo(a) {
 return x[a + 480188 >> 1];
}

function qq(a) {
 return x[a + 480192 >> 1];
}

function qG(a, b) {
 Nx(a, b, 3, 536870912);
}

function q2(a) {
 a = a | 0;
 ZH(a, 50, 49);
}

function pq(a) {
 return x[a + 480190 >> 1];
}

function mO(a, b) {
 v[a + 480272 >> 2] = b;
}

function lf(a, b, c) {
 ul(a, b, b + c | 0);
}

function iv(a) {
 return v[zb(a) >> 2] << 5;
}

function iO(a, b) {
 return Jt(a, b, Df(b));
}

function gZ(a, b) {
 Ls(a, b, 6, 715827883);
}

function eqa(a) {
 a = a | 0;
 fg(a, 16818);
}

function bka(a) {
 a = a | 0;
 ug(a, Gj(a));
}

function bR(a, b) {
 Ls(a, b, 52, 82595525);
}

function Xc(a, b) {
 return B(b, 6) + a | 0;
}

function XN(a) {
 a = a | 0;
 gu(a);
 Bb(a);
}

function TO(a) {
 return x[a + 480214 >> 1];
}

function SF(a) {
 return (a & 16) >>> 4 | 0;
}

function Ora(a) {
 a = a | 0;
 fg(a, 16215);
}

function LV(a, b) {
 Nx(a, b, 4, 268435456);
}

function JV(a, b) {
 Nx(a, b, 5, 134217728);
}

function IN(a) {
 a = a | 0;
 Nm(a);
 Bb(a);
}

function FN(a) {
 a = a | 0;
 oq(a);
 Bb(a);
}

function DO(a) {
 return v[a + 480272 >> 2];
}

function Ah(a) {
 return aH(a, C(255), 255);
}

function $oa(a) {
 a = a | 0;
 yY(a, 65535);
}

function zn(a) {
 v[a >> 2] = 2;
 return a;
}

function zY(a, b) {
 yc(a, b + 4 | 0, 256);
}

function yqa(a) {
 a = a | 0;
 qw(a, 3863);
}

function wqa(a) {
 a = a | 0;
 qw(a, 4887);
}

function vua(a) {
 a = a | 0;
 fg(a, 4358);
}

function sc(a) {
 v[a >> 2] = 0;
 return a;
}

function s2(a) {
 a = a | 0;
 fg(a, 16845);
}

function rq(a, b, c) {
 return Nz(a, b, c);
}

function pl(a, b, c) {
 return lK(a, b, c);
}

function pY(a, b, c) {
 return Lv(a, b, c);
}

function ot(a, b, c) {
 return id(a, b, c);
}

function oQ(a) {
 return (a & 8) >>> 3 | 0;
}

function lta(a) {
 a = a | 0;
 fg(a, 3872);
}

function k3(a) {
 a = a | 0;
 return 13092;
}

function j3(a) {
 a = a | 0;
 return 10809;
}

function hR(a, b, c) {
 return vA(a, b, c);
}

function fqa(a) {
 a = a | 0;
 fg(a, 3985);
}

function dz(a) {
 return !id(a, 125440, 6);
}

function Zn(a) {
 return a - 48 >>> 0 < 10;
}

function Wb(a, b) {
 return Oe(a, b & 255);
}

function Vk(a) {
 u[a >> 1] = 0;
 return a;
}

function VA(a) {
 ec(a + 4 | 0);
 return a;
}

function Uh(a) {
 v[a >> 2] = 1;
 return a;
}

function TG(a, b, c) {
 return ot(a, b, c);
}

function TF(a) {
 return (a & 2) >>> 1 | 0;
}

function SU(a, b, c) {
 return bC(a, b, c);
}

function Ry(a) {
 return lc(a, -1) ? 0 : a;
}

function Re(a, b) {
 a = a | 0;
 b = b | 0;
}

function R8(a) {
 a = a | 0;
 return 10406;
}

function PM(a) {
 return (rk(a) | 0) == -1;
}

function O_(a, b, c) {
 return wk(a, b, c);
}

function Mi(a, b, c) {
 return dC(a, b, c);
}

function Le(a) {
 a = a | 0;
 return a | 0;
}

function Kra(a) {
 a = a | 0;
 fg(a, 4484);
}

function Koa(a) {
 a = a | 0;
 fg(a, 4165);
}

function Gra(a) {
 a = a | 0;
 fg(a, 4378);
}

function G3(a) {
 a = a | 0;
 return 13206;
}

function Fj(a, b) {
 return Lg(a, b) & 255;
}

function F3(a) {
 a = a | 0;
 return 10286;
}

function Ce(a, b, c) {
 return EK(a, b, c);
}

function CP(a) {
 return Ri(FP(a) * 32768);
}

function $f(a) {
 return a != a ? C(0) : a;
}

function zf(a) {
 return D(a) == Infinity;
}

function vv(a) {
 t[a | 0] = 0;
 return a;
}

function uF(a, b, c, d) {
 px(a, b, c, d);
}

function tg(a, b, c, d) {
 bf(a, c, d, b);
}

function t2(a) {
 a = a | 0;
 fg(a, 4532);
}

function m3(a) {
 a = a | 0;
 return 9845;
}

function i3(a) {
 a = a | 0;
 return 5720;
}

function hl(a) {
 if (sI(a)) {
  Bb(a);
 }
}

function dc(a, b) {
 return Jb(a) + b | 0;
}

function Tx(a, b) {
 return v[a + b >> 2];
}

function RK(a) {
 v[a + 72 >> 2] = 496644;
}

function PK(a) {
 v[a + 72 >> 2] = 496728;
}

function L3(a) {
 a = a | 0;
 return 6920;
}

function Ku(a) {
 return !(a & 204473357);
}

function Kg(a, b) {
 ub(sc(a) + 4 | 0, b);
}

function Je(a, b) {
 if (!a) {
  Bb(b);
 }
}

function CV(a, b, c, d) {
 BV(a, b, c, d);
}

function C3(a) {
 a = a | 0;
 return 6901;
}

function Aw(a, b, c, d) {
 FB(a, b, c, d);
}

function zk(a) {
 sb(a + 12 | 0);
 nd(a);
}

function wg(a) {
 sb(a + 20 | 0);
 sb(a);
}

function vga(a) {
 a = a | 0;
 Bb(QP(a));
}

function tb(a) {
 le(a + 12 | 0);
 le(a);
}

function sga(a) {
 a = a | 0;
 return 13;
}

function re(a, b) {
 return Ec(a, me(b));
}

function ow(a, b, c) {
 mH(a, b, c, 128);
}

function nt(a) {
 a = a | 0;
 return 127;
}

function nG(a, b) {
 return Xo(a, b, 36);
}

function iia(a) {
 a = a | 0;
 Bb(wQ(a));
}

function iha(a) {
 a = a | 0;
 Bb(aQ(a));
}

function eaa(a) {
 a = a | 0;
 Bb(Wt(a));
}

function bc(a, b) {
 v[a + 100 >> 2] = b;
}

function am(a, b) {
 return $l(_c(a, b));
}

function _m(a) {
 sb(a + 12 | 0);
 sb(a);
}

function _L(a) {
 return a + 1298412 | 0;
}

function Xl(a) {
 return fH(a, 255, 255);
}

function XS(a) {
 VS(a + 12 | 0);
 US(a);
}

function Su(a) {
 _T(a + 12 | 0);
 cU(a);
}

function QZ(a, b) {
 return Jx(a, b, 56);
}

function PY(a, b) {
 return Jx(a, b, 18);
}

function Ot(a, b, c) {
 Yb(a, b, 1 << c);
}

function Oaa(a) {
 a = a | 0;
 Bb(au(a));
}

function NA(a) {
 u[a + 480214 >> 1] = 0;
}

function N$(a, b) {
 return Xo(a, b, 28);
}

function Li(a, b) {
 return (a | b) != 0;
}

function Hb(a, b) {
 return lc(a, b) ^ 1;
}

function Fb(a, b) {
 return (a & b) != 0;
}

function Do(a) {
 return a + 1074328 | 0;
}

function Dl(a) {
 return s$(a, 251, 255);
}

function Cx(a, b) {
 return Xo(a, b, 12);
}

function Az(a, b) {
 return vR(a, b) ^ 1;
}

function Ac(a, b) {
 return wH(a, b, -1);
}

function x5(a) {
 a = a | 0;
 Bb(YI(a));
}

function wt(a, b) {
 return EK(a, 0, b);
}

function wE(a, b, c) {
 bf(a, c, 30, b);
}

function pM(a) {
 a = a | 0;
 Bb(qM(a));
}

function oi(a, b, c) {
 bf(a, c, 20, b);
}

function mu(a) {
 a = a | 0;
 Bb(Zf(a));
}

function lL(a) {
 a = a | 0;
 return -1;
}

function lC(a, b) {
 return Xo(a, b, 4);
}

function kj(a, b) {
 return a >>> b & 1;
}

function iQ(a) {
 a = a | 0;
 Bb(jQ(a));
}

function i4(a) {
 a = a | 0;
 Bb(II(a));
}

function ht(a) {
 a = a | 0;
 Bb(my(a));
}

function hO(a) {
 a = a | 0;
 Bb(oq(a));
}

function gia(a) {
 a = a | 0;
 return 9;
}

function gha(a) {
 a = a | 0;
 return 6;
}

function gJ(a) {
 a = a | 0;
 Bb(ly(a));
}

function fk(a, b) {
 return b - a >> 11;
}

function fJ(a) {
 a = a | 0;
 Bb(ky(a));
}

function eu(a) {
 a = a | 0;
 Bb(nq(a));
}

function du(a, b) {
 v[a + 32 >> 2] = b;
}

function dA(a) {
 a = a | 0;
 Bb(vu(a));
}

function ck(a, b, c) {
 bf(a, c, 13, b);
}

function a_(a, b, c) {
 bf(a, c, 24, b);
}

function a4(a) {
 a = a | 0;
 Bb(GI(a));
}

function _3(a) {
 a = a | 0;
 Bb(EI(a));
}

function Zd(a) {
 return a & 64 ? 2 : 1;
}

function Z3(a) {
 a = a | 0;
 Bb(DI(a));
}

function Yy(a) {
 a = a | 0;
 Bb(sl(a));
}

function Yn(a) {
 a = a | 0;
 Bb(H_(a));
}

function Yi(a) {
 return a & 2147483647;
}

function Y8(a) {
 a = a | 0;
 Bb(Ct(a));
}

function Xy(a) {
 a = a | 0;
 Bb(go(a));
}

function XK(a) {
 a = a | 0;
 Bb(gq(a));
}

function Wy(a) {
 a = a | 0;
 Bb(Ft(a));
}

function WK(a) {
 a = a | 0;
 Bb(Ff(a));
}

function W3(a) {
 a = a | 0;
 Bb(CI(a));
}

function V1(a) {
 a = a | 0;
 Bb(tG(a));
}

function Uy(a) {
 a = a | 0;
 Bb(Et(a));
}

function Ui(a, b, c) {
 bf(a, c, 28, b);
}

function Ue(a, b, c) {
 bf(a, c, 32, b);
}

function Ty(a) {
 a = a | 0;
 Bb(Dt(a));
}

function T9(a) {
 a = a | 0;
 Bb(eM(a));
}

function S3(a) {
 a = a | 0;
 Bb(AI(a));
}

function Qq(a) {
 Es(a, 17, 124800, 51);
}

function Pk(a, b, c) {
 bf(a, c, 22, b);
}

function PT(a, b) {
 return Xo(a, b, 8);
}

function O$(a) {
 Es(a, 17, 124748, 33);
}

function No(a, b) {
 v[a + 36 >> 2] = b;
}

function Nn(a) {
 a = a | 0;
 Bb(ox(a));
}

function Nk(a, b) {
 return B(Xk(b), a);
}

function NE(a) {
 return (a & 255) == 1;
}

function LC(a, b, c) {
 bf(a, c, 64, b);
}

function KI(a) {
 a = a | 0;
 Bb(dt(a));
}

function Ik(a, b, c) {
 bf(a, c, 12, b);
}

function Hd(a) {
 return (a & 255) != 0;
}

function HJ(a) {
 a = a | 0;
 Bb(ry(a));
}

function HI(a) {
 a = a | 0;
 Bb(at(a));
}

function F5(a) {
 a = a | 0;
 Bb(et(a));
}

function E4(a) {
 a = a | 0;
 Bb(SI(a));
}

function $e(a, b) {
 u[a + 28 >> 1] = b;
}

function $3(a) {
 a = a | 0;
 Bb(FI(a));
}

function zq(a, b) {
 t[a + 33 | 0] = b;
}

function yo(a) {
 a = a | 0;
 return 4;
}

function vn(a, b) {
 v[a + 8 >> 2] = b;
}

function sB(a, b) {
 return a << 8 | b;
}

function pp(a, b) {
 yb(a + 12 | 0, b);
}

function nc(a, b) {
 return b - a >> 2;
}

function mQ(a) {
 a = a | 0;
 return 3;
}

function lp(a, b) {
 return a - b >> 1;
}

function kc(a) {
 a = a | 0;
 return 0;
}

function jo(a) {
 return (a | 0) == -1;
}

function it(a) {
 return zb(a + 8 | 0);
}

function hh(a, b) {
 return b - a >> 3;
}

function hQ(a) {
 a = a | 0;
 return 7;
}

function fX(a, b) {
 Kx(a, b, 5, 3, 4);
}

function ce(a) {
 return v[fc(a) >> 2];
}

function _c(a, b) {
 return b - a >> 1;
}

function YP(a) {
 a = a | 0;
 return 5;
}

function Tc(a) {
 return s$(a, 1, 120);
}

function Qh(a, b) {
 return b - a >> 8;
}

function QJ(a) {
 return Sh(a, 499680);
}

function PJ(a) {
 return Sh(a, 499672);
}

function NJ(a) {
 return Sh(a, 499696);
}

function Mv(a, b) {
 return a - b >> 2;
}

function MJ(a) {
 return Sh(a, 499688);
}

function Lg(a, b) {
 return b - a >> 5;
}

function Ke(a) {
 a = a | 0;
 return 2;
}

function In(a) {
 return a & 1 ? 2 : 1;
}

function Ig(a) {
 return Ni(a) ? 0 : a;
}

function He(a) {
 a = a | 0;
 return 1;
}

function HA(a, b) {
 t[a + 34 | 0] = b;
}

function GA(a, b) {
 t[a + 32 | 0] = b;
}

function FA(a, b) {
 t[a + 35 | 0] = b;
}

function Ck(a, b) {
 return b - a >> 4;
}

function Bq(a, b) {
 z[a + 8 >> 2] = b;
}

function Aq(a, b) {
 z[a + 4 >> 2] = b;
}

function Ad(a, b) {
 v[a + 4 >> 2] = b;
}

function zd(a, b) {
 return !Cb(a, b);
}

function yk(a, b) {
 return a - b | 0;
}

function xG(a) {
 return a + 1024 | 0;
}

function xC(a) {
 return a + 4096 | 0;
}

function wp(a, b) {
 t[a + 1 | 0] = b;
}

function wb(a, b) {
 return a + b | 0;
}

function vg(a, b) {
 t[a + 3 | 0] = b;
}

function qu(a) {
 return a >>> 27 ^ a;
}

function nV(a) {
 return a + 4896 | 0;
}

function mp(a, b) {
 Ge(a, b + 8 | 0);
}

function mk(a) {
 return (a & 5) != 0;
}

function kF(a) {
 Om(a, Np(a), 78512);
}

function aL(a) {
 return _G(a, 93288);
}

function Via(a) {
 a = a | 0;
 fb = a;
}

function Sw(a, b) {
 return Dua(a, b);
}

function Sc(a, b) {
 return b - a | 0;
}

function Pt(a) {
 return _G(a, 93224);
}

function Ofa(a) {
 a = a | 0;
 eb = a;
}

function Kk(a) {
 return a >>> 0 < 11;
}

function JB(a) {
 t[a + 6152 | 0] = 0;
}

function El(a) {
 IA(a, 0);
 return a;
}

function Dd(a) {
 return (a | 0) != 0;
}

function DQ(a) {
 return a - 2048 | 0;
}

function y_(a, b) {
 bf(a, b, 40, 2);
}

function xt(a, b) {
 return Td(a, b);
}

function xh(a, b) {
 return Zc(a, b);
}

function xf(a, b) {
 return Ec(a, b);
}

function vi(a, b) {
 return Ed(a, b);
}

function ur(a) {
 return a + 256 | 0;
}

function up(a) {
 return a >>> 0 < 5;
}

function uR(a, b, c) {
 Nl(a, b, -c);
}

function uE(a) {
 v[a + 12 >> 2] = 0;
}

function tk(a) {
 return a + 4e4 | 0;
}

function rE(a, b) {
 return qn(a, b);
}

function qE(a, b) {
 return lp(b, a);
}

function mda(a) {
 a = a | 0;
 sP(a);
}

function mV(a) {
 return a + 512 | 0;
}

function mA(a, b) {
 return WQ(a, b);
}

function lq(a, b) {
 return xb(a, b);
}

function i0(a, b) {
 bf(a, b, 13, 1);
}

function hX(a, b) {
 bf(a, b, 33, 1);
}

function gc(a, b) {
 return uG(a, b);
}

function fr(a) {
 return a >>> 0 < 2;
}

function bZ(a, b) {
 ul(a, b, td(b));
}

function _o(a, b) {
 return Wk(a, b);
}

function Zc(a, b) {
 return Cb(a, b);
}

function Yr(a, b) {
 bf(a, b, 26, 3);
}

function Yg(a, b) {
 return Hb(a, b);
}

function XL(a, b) {
 return hh(a, b);
}

function Vh(a, b) {
 return Nw(a, b);
}

function Vg(a) {
 return bT(a & 255);
}

function Vb(a, b) {
 return Zi(a, b);
}

function U_(a, b) {
 return yk(b, a);
}

function UG(a, b) {
 return Uc(a, b);
}

function Rd(a, b) {
 return nc(a, b);
}

function RT(a, b) {
 Xu(a, Jb(a), b);
}

function RC(a) {
 return a + 128 | 0;
}

function Qw(a, b) {
 return BF(a, b);
}

function QV(a) {
 return a - 256 | 0;
}

function Oj(a, b) {
 return Sc(a, b);
}

function N_(a, b) {
 return $D(a, b);
}

function Lj(a, b) {
 return Oe(a, b);
}

function LT(a, b) {
 return _c(a, b);
}

function Jy(a, b) {
 return nh(a, b);
}

function HR(a, b) {
 return FR(a, b);
}

function Ge(a, b) {
 return Z$(a, b);
}

function Gc(a, b) {
 return as(a, b);
}

function FO(a, b) {
 bH(a, b, 22256);
}

function FF(a, b) {
 return AF(a, b);
}

function Ec(a, b) {
 return ub(a, b);
}

function CN(a, b) {
 bH(a, b, 13602);
}

function Bo(a, b) {
 return Zt(a, b);
}

function Af(a, b) {
 return dh(a, b);
}

function zZ(a) {
 return a + 36 | 0;
}

function yP(a) {
 return a + 48 | 0;
}

function xg(a) {
 t[a + 12 | 0] = 1;
}

function xc(a) {
 v[a + 8 >> 2] = 0;
}

function vc(a) {
 a = a | 0;
 Bb(a);
}

function vX(a, b) {
 ac(a, b, 1108);
}

function tF(a, b) {
 bf(a, b, 8, 3);
}

function ss(a) {
 a = a | 0;
 us(a);
}

function qD(a, b) {
 ac(a, b, 4896);
}

function pc(a, b, c) {
 pn(a, b, c);
}

function oC(a) {
 return a - 16 | 0;
}

function mc(a) {
 return a + 12 | 0;
}

function l0(a, b) {
 ac(a, b, 1954);
}

function hw(a) {
 return a - 40 | 0;
}

function gl(a) {
 return a - 24 | 0;
}

function eX(a) {
 return a - 56 | 0;
}

function dn(a) {
 return a - 32 | 0;
}

function cp(a) {
 return a + 14 | 0;
}

function bj(a) {
 return a - 36 | 0;
}

function ac(a, b, c) {
 Yb(a, b, c);
}

function _Z(a) {
 return a + 10 | 0;
}

function TC(a, b) {
 ac(a, b, 1024);
}

function SD(a, b) {
 bf(a, b, 8, 2);
}

function S0(a) {
 a = a | 0;
 Xh(a);
}

function Ro(a) {
 return a + 32 | 0;
}

function Rh(a, b, c) {
 c$(a, b, c);
}

function Pc(a, b, c) {
 Ot(a, b, c);
}

function OT(a, b, c) {
 we(a, b, c);
}

function Np(a) {
 return a + 20 | 0;
}

function NG(a, b, c) {
 gf(a, c, b);
}

function MR(a) {
 return a + 24 | 0;
}

function LY(a) {
 return a - 33 | 0;
}

function Kj(a) {
 return !(a & 255);
}

function Ib(a, b, c) {
 VF(a, b, c);
}

function IS(a, b, c) {
 mr(a, b, c);
}

function Fr(a) {
 return a - 28 | 0;
}

function EY(a) {
 return a + 3 & -4;
}

function D0(a, b, c) {
 df(a, c, b);
}

function AD(a, b, c) {
 de(a, b, c);
}

function $q(a, b, c) {
 yp(a, b, c);
}

function $k(a) {
 return a - 12 | 0;
}

function zb(a) {
 return a + 8 | 0;
}

function yd(a) {
 return vb(Jb(a));
}

function yE(a, b) {
 ac(a, b, 512);
}

function xd(a, b) {
 v[a >> 2] = b;
}

function xF(a, b) {
 ac(a, b, 772);
}

function wf(a) {
 return a - 4 | 0;
}

function wW(a, b) {
 ac(a, b, 204);
}

function uW(a) {
 return a - 1 | 0;
}

function sw(a, b) {
 ac(a, b, 192);
}

function sk(a, b) {
 z[a >> 2] = b;
}

function s_(a, b) {
 ac(a, b, 218);
}

function sV(a, b) {
 ac(a, b, 263);
}

function qd(a, b) {
 return a >> b;
}

function o_(a, b) {
 ac(a, b, 157);
}

function oE(a) {
 return cl(a, 28);
}

function nF(a, b) {
 ac(a, b, 497);
}

function i_(a, b) {
 ac(a, b, 206);
}

function iG(a) {
 return cl(a, 36);
}

function hM(a) {
 return mk(a) ^ 1;
}

function gr(a, b) {
 return a << b;
}

function fc(a) {
 return a + 4 | 0;
}

function eZ(a) {
 return a - 6 | 0;
}

function c_(a, b) {
 ac(a, b, 236);
}

function aX(a) {
 return cl(a, 56);
}

function aW(a, b) {
 yc(a, b, 128);
}

function _e(a) {
 return a + 2 | 0;
}

function _Y(a, b) {
 ac(a, b, 128);
}

function _Q(a) {
 return cl(a, 52);
}

function ZY(a) {
 kp(Qb(a, 0, 40));
}

function ZT(a) {
 YT(a, v[a >> 2]);
}

function Xi(a) {
 return a + 3 | 0;
}

function XW(a, b) {
 ac(a, b, 146);
}

function XC(a, b) {
 ac(a, b, 130);
}

function UZ(a, b) {
 ac(a, b, 102);
}

function Te(a) {
 return vr(Ee(a));
}

function TW(a, b) {
 ac(a, b, 608);
}

function Ri(a) {
 return un(Ee(a));
}

function QX(a, b) {
 ac(a, b, 600);
}

function Pp(a) {
 return cl(a, 12);
}

function Pd(a) {
 t[a + 4 | 0] = 1;
}

function NU(a) {
 MU(a, v[a >> 2]);
}

function Mc(a) {
 Ad(a, v[a >> 2]);
}

function KZ(a, b) {
 ac(a, b, 576);
}

function JU(a) {
 return cl(a, 32);
}

function Ip(a) {
 return a - 8 | 0;
}

function Ic(a) {
 return a + 1 | 0;
}

function HZ(a, b) {
 ac(a, b, 674);
}

function H$(a, b) {
 ac(a, b, 610);
}

function Fu(a) {
 eS(a, v[a >> 2]);
}

function Fn(a) {
 return a - 2 | 0;
}

function Ej(a) {
 return Dd(a) ^ 1;
}

function Eb(a) {
 xx(a);
 return a;
}

function EX(a, b) {
 ac(a, b, 126);
}

function ET(a) {
 return a - 7 | 0;
}

function D_(a) {
 return cl(a, 20);
}

function DN(a) {
 return 0 - a | 0;
}

function Cz(a) {
 return cl(a, 16);
}

function $Z(a) {
 return a + 6 | 0;
}

function zr(a, b) {
 ac(a, b, 12);
}

function yV(a, b) {
 return a < b;
}

function y0(a, b) {
 ac(a, b, 17);
}

function wA(a, b) {
 IA(a, me(b));
}

function v_(a, b) {
 ac(a, b, 48);
}

function vE(a, b) {
 qH(a, b, 32);
}

function tU(a, b) {
 ac(a, b, 27);
}

function rx(a, b) {
 FG(a, me(b));
}

function rw(a, b) {
 qH(a, b, 64);
}

function p$(a, b) {
 yc(a, b, 40);
}

function oD(a, b) {
 ac(a, b, 33);
}

function mw(a, b) {
 ac(a, b, 64);
}

function lw(a, b) {
 ac(a, b, 66);
}

function jx(a, b) {
 ac(a, b, 20);
}

function jX(a, b) {
 ac(a, b, 96);
}

function hF(a, b) {
 ac(a, b, 38);
}

function hD(a, b) {
 ac(a, b, 40);
}

function gd(a, b) {
 t[a | 0] = b;
}

function fF(a, b) {
 wi(a, b, 37);
}

function fE(a, b) {
 ac(a, b, 16);
}

function cw(a, b) {
 ac(a, b, 22);
}

function bs(a, b) {
 ac(a, b, 36);
}

function ay(a) {
 return pI(a, 0);
}

function Tw(a, b) {
 Yb(a, b, 22);
}

function Rv(a, b) {
 return a < b;
}

function Rg(a) {
 a = a | 0;
 p();
}

function PE(a, b) {
 ac(a, b, 32);
}

function Lw(a, b) {
 ac(a, b, 11);
}

function Hv(a, b) {
 ac(a, b, 30);
}

function HG(a, b) {
 ac(a, b, 24);
}

function Dn(a, b) {
 Yb(a, b, 32);
}

function DY(a, b) {
 ac(a, b, 52);
}

function Cw(a, b) {
 ac(a, b, 65);
}

function B0(a, b) {
 Yb(a, b, 20);
}

function A_(a, b) {
 ac(a, b, 98);
}

function $x(a) {
 return pI(a, 1);
}

function $Y(a, b) {
 ac(a, b, 80);
}

function yf(a) {
 return a & 255;
}

function wu(a) {
 Qb(a, 0, 2048);
}

function wP() {
 return 19989505;
}

function sF(a, b) {
 Rh(a, 2, b);
}

function pf() {
 O$(11034);
 p();
}

function ln(a, b) {
 yp(a, b, 0);
}

function lh(a, b) {
 ac(a, b, 4);
}

function k0(a) {
 Qb(a, 0, 1954);
}

function gQ(a, b) {
 RQ(a, 3, b);
}

function dx(a, b) {
 ac(a, b, 3);
}

function cn() {
 Qq(11034);
 p();
}

function Zj(a, b) {
 ac(a, b, 5);
}

function Yk(a, b) {
 ac(a, b, 8);
}

function YD(a, b) {
 ac(a, b, 6);
}

function WA(a) {
 Qb(a, 0, 4096);
}

function Vr(a, b) {
 ac(a, b, 1);
}

function Jr(a, b) {
 ac(a, b, 7);
}

function Ih(a) {
 sb(a + 16 | 0);
}

function Gh(a) {
 return a & 127;
}

function Dq(a) {
 Qb(a, 0, 8192);
}

function Cp(a, b) {
 ac(a, b, 2);
}

function wF(a) {
 Qb(a, 0, 772);
}

function vW(a) {
 Qb(a, 0, 204);
}

function n_(a) {
 Qb(a, 0, 157);
}

function mF(a) {
 Qb(a, 0, 497);
}

function h_(a) {
 Qb(a, 0, 206);
}

function dd() {
 O$(7718);
 p();
}

function ct(a) {
 hl(v[a >> 2]);
}

function b_(a) {
 Qb(a, 0, 236);
}

function Zb(a) {
 sm(v[a >> 2]);
}

function XT(a) {
 Be(a + 8 | 0);
}

function Wga() {
 return eb | 0;
}

function WW(a) {
 Qb(a, 0, 146);
}

function SW(a) {
 Qb(a, 0, 608);
}

function PX(a) {
 Qb(a, 0, 600);
}

function OV(a) {
 Qb(a, 0, 256);
}

function Nj(a) {
 sb(a + 4 | 0);
}

function Ni(a) {
 return a != a;
}

function NC(a) {
 Qb(a, 0, 130);
}

function Jc(a) {
 ec(a + 8 | 0);
}

function JZ(a) {
 Qb(a, 0, 576);
}

function Iw() {
 Qq(7718);
 p();
}

function Gd(a) {
 tb(a + 8 | 0);
}

function G$(a) {
 Qb(a, 0, 610);
}

function EZ(a) {
 Qb(a, 0, 192);
}

function DX(a) {
 Qb(a, 0, 126);
}

function z_(a) {
 Qb(a, 0, 98);
}

function yR(a) {
 DA(a, ce(a));
}

function w_(a) {
 Qb(a, 0, 48);
}

function vP() {
 return 458756;
}

function sZ(a) {
 vD(a, ce(a));
}

function sD(a) {
 Qb(a, 0, 80);
}

function qZ(a) {
 wD(a, ce(a));
}

function nE(a) {
 Qb(a, 0, 66);
}

function kX(a) {
 Qb(a, 0, 96);
}

function jD(a) {
 iD(a, ce(a));
}

function gw(a) {
 Qb(a, 0, 64);
}

function gF(a) {
 Qb(a, 0, 38);
}

function cs(a) {
 Qb(a, 0, 36);
}

function ch(a) {
 t[a | 0] = 0;
}

function _T(a) {
 Mq(a, ce(a));
}

function Yv(a) {
 ID(a, ce(a));
}

function WV(a) {
 tC(a, ce(a));
}

function VV(a) {
 uC(a, ce(a));
}

function VS(a) {
 Mu(a, ce(a));
}

function US(a) {
 Nu(a, ce(a));
}

function SZ(a) {
 JD(a, ce(a));
}

function PZ(a) {
 Qb(a, 0, 56);
}

function Ll(a) {
 GB(a, ce(a));
}

function JY(a) {
 Qb(a, 0, 33);
}

function Ep(a) {
 return a & 1;
}

function CY(a) {
 Qb(a, 0, 52);
}

function xs(a, b) {
 UG(a, b);
}

function xU(a, b) {
 Hh(a, b);
}

function vq(a, b) {
 ub(a, b);
}

function po(a, b) {
 kq(a, b);
}

function pX(a, b) {
 Ge(a, b);
}

function pE(a, b) {
 Lk(a, b);
}

function nD(a, b) {
 HY(a, b);
}

function km(a, b) {
 Kw(a, b);
}

function kW(a, b) {
 Rl(a, b);
}

function hg(a, b) {
 V$(a, b);
}

function fA(a, b) {
 re(a, b);
}

function dR(a, b) {
 eS(a, b);
}

function bd(a, b) {
 Bs(a, b);
}

function XD(a, b) {
 gc(a, b);
}

function Wu(a, b) {
 PR(a, b);
}

function R_(a, b) {
 vU(a, b);
}

function Qo(a, b) {
 Uc(a, b);
}

function Qd(a, b) {
 Ng(a, b);
}

function Ph(a, b) {
 Qo(a, b);
}

function Ln(a, b) {
 cG(a, b);
}

function LU(a, b) {
 MU(a, b);
}

function KT(a, b) {
 Q$(a, b);
}

function Id(a, b) {
 Ad(a, b);
}

function IU(a, b) {
 mg(a, b);
}

function EQ(a) {
 xm(a, 2048);
}

function Di(a, b) {
 fi(a, b);
}

function lO() {
 return 2048;
}

function Tja() {
 ta();
 p();
}

function z3() {
 kI();
 p();
}

function yI(a) {
 Hx(a, 48);
}

function xp(a) {
 xH(a, 11);
}

function l$(a) {
 xm(a, 40);
}

function kI() {
 ua();
 p();
}

function ep(a) {
 xH(a, 16);
}

function Sn(a) {
 Hx(a, 36);
}

function Mf(a) {
 a = a | 0;
}

function DJ(a) {
 xm(a, 24);
}

function Ag(a) {
 Hx(a, 24);
}

function yl(a) {
 VM(a, 0);
}

function vh(a) {
 XM(a, 0);
}

function uh(a) {
 UM(a, 0);
}

function os(a) {
 FG(a, 0);
}

function lg(a) {
 rZ(a, 0);
}

function is(a) {
 xm(a, 8);
}

function hZ(a) {
 xm(a, 6);
}

function YA(a) {
 hS(a, 0);
}

function XA(a) {
 gS(a, 0);
}

function Kc(a) {
 Qe(a, 0);
}

function KR(a) {
 lS(a, 0);
}

function GT(a) {
 xm(a, 7);
}

function $i(a) {
 xm(a, 2);
}

function vs(a) {
 mc(a);
}

function tV(a) {
 sc(a);
}

function oX(a) {
 vv(a);
}

function mW(a) {
 Mb(a);
}

function hV(a) {
 xe(a);
}

function gW(a) {
 Xe(a);
}

function _w(a) {
 Vk(a);
}

function Vm(a) {
 uc(a);
}

function ST(a) {
 So(a);
}

function MC(a) {
 sg(a);
}

function Db(a) {
 sb(a);
}


// EMSCRIPTEN_END_FUNCS

  e = w;
  var hb = c([ null, tc, GG, tm, f2, yG, Y1, U1, L1, pG, oG, pe, p1, m1, vF, h1, f_, H_, Rna, Jna, Ina, G0, xua, tw, Wj, jua, Y, Nsa, Fw, im, cL, Kh, np, _sa, Le, Vna, Cc, w5, LD, Qj, or, tn, gsa, l_, Vl, iV, iC, Oma, jma, eU, Zka, jla, pg, hka, Mj, $ja, Tja, Sja, Rja, yA, Aja, rja, dga, Lia, JQ, t9, s9, Ht, JQ, pfa, dP, ig, Jea, cea, Yda, Sda, Lda, Gda, Bda, wda, kda, Bca, $ca, Vy, ta, Lb, f5, C4, B4, r4, j4, $n, T3, rka, M3, qka, K3, ca, h3, S2, R2, Q2, P2, O2, pH, N2, M2, L2, K2, J2, H2, G2, I2, O8, zs, Rp, pg, F2, QG, PG, E2, zx, D2, OG, Tf, C2, A2, y2, ss, rs, Yh, fg, v2, Op, x2, w2, u2, B2, t2, KG, s2, KG, z2, MG, r2, q2, p2, o2, n2, cd, Lb, k2, Mp, j2, Kh, i2, rd, h2, _k, rd, qx, g2, ox, nx, I1, e2, X1, W1, H1, E1, B1, A1, bx, hG, z1, y1, Mja, Nja, BT, Kja, Lja, EA, yu, Ub, Oja, ge, dG, v1, u1, QF, s1, r1, QF, DF, Pw, l1, Og, DF, Mw, Zia, hja, Yia, jf, yka, t1, rg, mua, xka, yta, _E, ZE, a1, $0, YE, _0, cg, Z0, Y0, Bc, Ew, X0, W0, V0, Sf, U0, hm, T0, WE, S0, P0, KE, O0, N0, M0, yw, L0, lF, JE, K0, J0, I0, H0, F0, GE, E0, u0, Cd, EE, vua, uua, DE, CE, tua, sua, rua, Ew, qua, t0, pua, zw, oua, nua, Tk, gua, Ir, fua, Kb, ag, fg, eua, xE, dua, kd, Mk, cua, bua, aua, f0, e0, md, $ta, op, _ta, Zta, Yta, b0, a0, Qj, qw, Xta, Wta, qla, Vta, eh, Uta, Tta, Nta, Uj, Qta, Pta, Ota, Sta, Rta, Tf, T$, Wh, Qf, Kta, Jta, Ita, Fta, Uj, Tj, Eta, Dta, Cta, kE, A$, jE, Bta, Ata, zta, Tk, h$, e$, vta, qta, X_, so, pta, ug, F$, ota, yw, nta, mta, cE, lta, W_, nx, kta, jta, T_, g_, ita, Tk, eta, Ir, _j, dta, cta, e0, bta, ata, $sa, K_, J_, jm, Zsa, Ysa, Xsa, Vsa, Uj, I_, Wsa, Wh, Qf, iE, Qsa, Er, W_, Jsa, Isa, Hsa, Gsa, Dsa, Ir, Csa, Bsa, jp, K_, Asa, zsa, fg, ysa, xsa, wsa, vsa, usa, ZZ, tsa, ssa, lK, YZ, rsa, qsa, s0, XZ, psa, osa, nsa, wla, msa, VZ, lsa, VZ, Ksa, jsa, Uj, ksa, Wh, Qf, $j, dsa, csa, bsa, asa, Zra, Yra, Xra, Wra, Vra, jp, Ura, Tra, Sra, DD, n1, Rra, Qra, Pra, Ora, Nra, DZ, Mra, k1, Lra, Kra, Jra, Ira, CZ, Hra, esa, Gra, Fra, fg, Era, mE, Dra, fsa, Cra, Bra, Ara, zD, zD, AZ, zra, yra, yZ, zD, vZ, xra, J8, wra, vra, ura, tra, sra, rra, qra, uZ, rd, kr, fra, Wv, pra, Jia, Iia, Hia, Gia, Fia, Eia, ora, nra, mg, mra, lra, kra, jra, GG, pla, nla, Wia, fja, gja, ira, tZ, hra, gra, Yja, Cia, Rk, OG, lla, sla, kla, ila, bra, ara, $qa, _qa, Zqa, Yqa, Xqa, Wqa, Vqa, Uqa, Tqa, Rqa, Qqa, Sqa, IY, Qf, AY, mD, Nqa, lD, Mqa, Lqa, Kqa, Jqa, kD, Iqa, Pw, YE, Hqa, yY, wY, Gqa, Pr, Fqa, rf, Eqa, uY, jp, ww, jp, XZ, Tr, fg, _E, jp, so, Bqa, Aqa, zqa, yqa, eD, Jv, xqa, wqa, vqa, uqa, tqa, sqa, rqa, qqa, pqa, oqa, nqa, mqa, lqa, kqa, jqa, xD, iqa, hqa, gqa, fg, xZ, wZ, FD, fqa, eqa, DE, nx, dqa, cqa, bqa, aqa, $pa, Vka, Uka, Tka, Xpa, Ypa, Gr, Zpa, _pa, kw, WX, Upa, wka, _ka, Zu, vka, uka, vT, Tu, pT, tka, fT, BU, ska, SB, Dj, ui, Npa, Mpa, yr, Vpa, Tv, Jpa, o0, Ipa, Hpa, BX, kr, Gpa, Fpa, Epa, Dpa, Cpa, Gw, Bpa, tZ, Apa, zpa, xr, ypa, KC, tpa, IC, spa, rpa, uX, zp, qpa, Uj, Wh, Qf, ui, npa, mpa, lpa, kpa, lD, hpa, gpa, xr, fpa, hm, ija, cpa, bpa, Tj, rX, IC, zw, apa, uX, $oa, _oa, Zoa, Ev, Yoa, Ev, Xoa, um, o1, Uoa, Uj, Woa, DC, $W, Voa, Wh, Qf, yr, Roa, Ooa, mD, Noa, Koa, Joa, OW, Gw, DD, Ioa, DE, fg, zoa, yoa, Ew, xoa, woa, voa, uoa, _v, toa, op, qoa, poa, ooa, noa, moa, loa, hn, hW, koa, joa, ioa, hoa, goa, foa, eoa, doa, coa, boa, aoa, $na, _na, lD, Zna, Yna, Xna, Tv, Wna, Una, Tna, Ir, Kka, Mp, f0, Rka, Qka, Ir, Pka, ui, Mp, Oka, Nka, Mka, Sna, SV, Ona, Nna, Mna, Lna, Kna, Xr, Fna, Ena, Dna, Cna, Bna, Ana, zna, yna, xna, wna, vna, l3, TI, una, fg, tna, sna, Wka, xla, hta, OU, ula, tla, rla, ola, mla, CU, ela, gla, fla, dla, Yd, cla, rU, bla, ala, $ka, gU, fU, Lo, aU, Yka, Xka, Ska, fp, Ika, Tj, CT, ps, Jja, Ija, Hja, zka, Gja, q1, Fja, cx, ps, u0, Eja, CT, Gka, Dja, Lka, Uj, Wh, Qf, Jka, Uj, Wh, Qf, Hka, Uj, Wh, Qf, Eka, Bka, Aka, Le, E0, pka, oka, nka, mka, lka, kka, vla, ona, EP, jka, Dc, gka, aja, fka, m2, G1, x1, D1, dka, cka, w1, F1, l2, C1, ZR, bka, aka, _ja, YR, XR, TA, Zja, hla, Xja, Wja, Vja, Uja, ZQ, Tia, jja, yx, JS, yG, LG, EA, YR, Pja, Rk, ys, Or, Dka, Fka, yja, xja, Tj, wja, IC, vja, uja, tja, yr, sja, ui, qja, pja, oja, nja, mja, Uj, Wh, Qf, zja, eja, dja, cja, bja, fi, Mm, $ia, _ia, Xia, Ria, Qia, Pia, Oia, Nia, UQ, Uia, xq, TQ, ml, fi, mg, Kia, Dia, h9, Mia, Sia, Aia, zia, Rha, yia, xia, GQ, Yf, SQ, jia, Sha, on, Mha, Cja, Lha, Jha, Iha, Hha, EA, Kha, se, ou, ou, Gha, Fha, Dha, tQ, kQ, jha, aha, Uga, Nga, Fga, wga, yga, mga, fga, zP, lu, _fa, Zfa, qaa, raa, tP, Sfa, sP, rP, Qja, taa, Nfa, zP, Mfa, $aa, Paa, cba, mP, cM, kP, Sz, Jfa, Dda, oq, Cda, Km, jP, Yaa, hP, Xaa, iP, Waa, gP, lK, oba, Efa, Zaa, Rz, uY, Qz, Pz, Oz, ufa, sfa, kP, Sz, ofa, nfa, mfa, lfa, kfa, jfa, ifa, hfa, gfa, ffa, efa, dfa, cfa, bfa, afa, $ea, _ea, Zea, Yea, Xea, Wea, Vea, Uea, Tea, Sea, cP, bP, aP, vG, G9, dba, $O, QO, Uaa, PO, OO, nba, J9, K9, NO, P9, KO, JO, oz, HO, Sz, EO, CO, BO, vo, I9, H9, AO, zO, yO, xO, wO, vO, uO, tO, sO, rO, qO, pO, Mz, oO, nO, UR, Gv, Lz, Kz, Ida, kO, Hda, Fda, Eda, eO, yda, mP, xda, Sca, vda, Rca, uda, Qca, tda, Pca, sda, Oca, rda, Nca, pda, _9, cM, br, Cka, Gx, qs, fU, jba, iba, hba, fba, bba, ika, _aa, Saa, Vaa, r9, g9, f9, Taa, OM, NM, OM, NM, hm, Tk, Tk, LM, KM, LM, KM, bu, Re, bu, Re, Qaa, bu, Re, bu, Re, eka, aba, kba, eba, vx, CM, Jaa, CM, Iaa, Z, BM, Haa, BM, Gaa, tz, tz, tz, Daa, Yt, Yt, Yt, Yt, wM, Aaa, wM, zaa, vM, yaa, vM, xaa, rz, rz, rz, uaa, Xt, Xt, Xt, Xt, saa, ZM, YM, Kz, sM, paa, oaa, faa, iM, Z9, Y9, U9, O9, N9, M9, L9, F9, E9, D9, OR, pna, C9, B9, A9, z9, v9, u9, UK, TK, P3, n9, m9, l9, k9, j9, i9, Le, D3, H4, P8, TK, Qy, My, di, ci, yt, Bb, Ly, sh, rl, Ky, Dm, q8, p8, lj, rh, uK, jj, O3, Sy, Fy, di, ci, tt, ei, b9, im, io, lj, rh, nK, jj, X7, N3, S7, ZK, N7, Bt, np, I7, pt, Mf, q7, fo, p7, o7, n7, RJ, l7, Jt, j7, i7, nj, h7, RJ, f7, oZ, d7, c7, $6, _6, P6, O6, N6, M6, L6, K6, J6, I6, H6, G6, F6, E6, D6, C6, B6, A6, z6, y6, x6, w6, v6, u6, t6, s6, r6, q6, p6, o6, n6, m6, l6, k6, j6, AJ, i6, v5, u5, t5, s5, r5, XI, q5, WI, p5, o5, n5, m5, l5, k5, j5, i5, h5, g5, e5, d5, c5, b5, a5, $4, _4, Z4, Y4, X4, W4, V4, U4, T4, S4, R4, Q4, P4, O4, N4, I4, X3, Y3, M4, L4, K4, J4, Am, aq, l4, k4, G4, F4, n4, m4, ok, c4, b4, eq, Ay, Vl, Nn, ms, nna, mna, lna, kna, jna, ina, hna, gna, fna, ena, dna, cna, bna, ana, $ma, _ma, Zma, Yma, Xma, Wma, Vma, Uma, Tma, Sma, Rma, Qma, Pma, Nma, Mma, Lma, Kma, Jma, Ima, Hma, Gma, Fma, Ema, Dma, Cma, Bma, Ama, zma, yma, xma, wma, vma, uma, tma, sma, rma, qma, pma, oma, nma, mma, lma, kma, ima, hma, gma, fma, ema, dma, cma, bma, ama, $la, _la, Zla, Yla, Xla, Wla, Vla, Ula, Tla, Sla, Rla, Qla, Pla, Ola, Nla, Mla, Lla, Kla, Jla, Ila, Hla, Gla, Fla, Ela, Dla, Cla, Bla, Ala, zla, yla, Nn, Hna, Gna, $ra, _ra, Moa, Loa, Foa, Eoa, Pqa, Oqa, xpa, wpa, dra, cra, iua, hua, Usa, Tsa, R0, Q0, yua, wua, ppa, opa, Qoa, Poa, Qna, Pna, Hta, Gta, xta, wta, e1, d1, c1, b1, epa, dpa, Toa, Soa, Lpa, Kpa, era, UY, Psa, Osa, isa, hsa, Mta, Lta, gta, fta, jpa, ipa, Bja, lja, kja, Fsa, Esa, Msa, Lsa, Ppa, Opa, soa, roa, vpa, upa, Ssa, Rsa, Hoa, Goa, Boa, Aoa, sta, rta, Doa, Coa, Wpa, Rpa, Qpa, g1, f1, j1, i1, lua, kua, Dqa, Cqa, uta, tta, Tpa, Spa, rna, qna, Yn, ms, J1, vc, pm, xP, vc, Le, vc, kc, He, He, kc, kc, K1, $1, _1, M1, vc, pm, vc, tG, V1, T1, He, S1, R1, Q1, P1, O1, N1, vu, dA, uu, BQ, kc, Mf, kc, kc, kc, Re, yo, wia, via, uia, tia, sia, Gi, bA, bA, aA, AQ, aA, zQ, aA, zQ, Mf, UY, ria, qia, pia, oia, nia, Fi, yQ, Oha, kc, kc, He, $z, Ke, Ke, He, mia, lia, Re, Mf, Re, Mf, wQ, iia, hia, kc, Mf, kc, kc, kc, Re, gia, vQ, eia, dia, cia, bia, Gi, aia, $ha, _ha, Zha, Yha, Xha, Wha, Vha, Uha, Tha, Fi, rQ, kc, kc, He, Ke, Ke, He, uQ, sQ, Zf, Rg, z3, Qha, cA, Pha, kc, Nha, AQ, uha, kha, bha, Vga, Oga, Gga, xga, nga, gga, Hga, Bia, kia, Eha, vu, dA, BQ, kc, Mf, kc, kc, kc, Re, mQ, Cha, Bha, Aha, zha, yha, Gi, xha, Fi, lQ, kc, kc, He, Ke, Ke, He, wha, vha, aQ, iha, hha, kc, Mf, kc, kc, kc, Re, gha, fha, eha, dha, Gi, cha, Fi, ZP, kc, kc, He, Ke, Ke, mu, $ga, kc, Mf, kc, kc, kc, Re, YP, _ga, Zga, Yga, Gi, Xga, Fi, WP, kc, kc, He, Ke, Ke, vu, dA, Tga, kc, Mf, kc, kc, kc, Re, YP, Sga, Rga, Qga, Gi, Pga, Fi, TP, kc, kc, He, Ke, Ke, jQ, iQ, Mga, kc, Mf, kc, kc, kc, Re, hQ, Lga, rha, qha, Gi, pha, Fi, oha, kc, kc, He, Ke, Ke, Re, Mf, fQ, Kga, Jga, eQ, Iga, dQ, cQ, iQ, tha, hQ, sha, fQ, nha, mha, eQ, lha, dQ, cQ, mu, Ega, kc, Mf, kc, kc, kc, Re, Ke, Dga, Cga, Bga, Gi, Aga, Fi, zga, kc, kc, He, Ke, Ke, QP, vga, uga, kc, Mf, kc, kc, tga, Re, sga, rga, qga, pga, Gi, oga, Fi, Uz, kc, kc, He, Ke, Ke, Re, Mf, mu, lga, kc, Mf, kc, kc, kc, Re, mQ, kga, jga, iga, Gi, hga, Fi, LP, kc, kc, He, Ke, Ke, mu, ega, kc, Mf, kc, kc, kc, Re, yo, cga, bga, aga, Gi, $fa, Fi, JP, kc, kc, He, Ke, Ke, hu, vc, Ada, hO, BN, hO, FN, Nm, IN, gu, XN, nq, eu, Tba, Sba, zN, yN, xN, wN, vN, uN, tN, sN, rN, qN, pN, oN, nN, mN, lN, kN, jN, iN, hN, gN, fN, eN, dN, Rba, Qba, Pba, Oba, Nba, Mba, Lba, Kba, Jba, Iba, Hba, Gba, Fba, Eba, Dba, Cba, Bba, Aba, zba, yba, xba, wba, vba, uba, tba, sba, rba, qba, pba, Le, Rg, Le, Rg, Le, Rg, Le, Rg, Rg, mba, vc, lba, au, Oaa, gba, Le, Rg, Le, vc, Naa, Maa, Rg, vc, Raa, Le, vc, Laa, Kaa, vc, EM, DM, Rg, vc, Faa, Eaa, vc, AM, zM, vc, Caa, Baa, vc, yM, xM, vc, waa, vaa, vc, uM, tM, $9, vc, pm, vc, Wt, eaa, He, He, daa, caa, ms, baa, aaa, Rg, Rg, gaa, vc, pm, vc, qM, pM, He, kc, He, naa, maa, laa, kaa, jaa, iaa, haa, Rg, Q9, vc, pm, vc, eM, T9, S9, R9, Rg, V9, vc, pm, vc, pM, X9, W9, Z1, vc, pm, vc, vc, d2, He, He, ms, ls, c2, b2, a2, y9, x9, w9, go, Xy, Re, oL, nL, mL, kc, kc, q9, lL, p9, Gt, o9, Gt, Dt, Ty, Re, oL, nL, mL, kc, kc, e9, lL, d9, Gt, c9, Gt, Ct, Y8, Z8, X8, a9, $8, _8, gq, XK, W8, V8, Et, Uy, eL, dL, Ff, WK, U8, T8, Ft, Wy, jL, iL, Le, vc, R8, J3, I3, H3, Q8, Nn, Xy, C8, B8, A8, z8, bL, Yy, sl, Yy, Xy, F8, MK, E8, D8, Ty, K8, I8, H8, G8, Ft, Wy, jL, iL, bL, Yy, Ty, N8, MK, M8, L8, Et, Uy, eL, dL, S8, kc, y8, YI, x5, uu, AI, S3, R3, Q3, v8, CI, W3, V3, U3, s8, et, F5, E5, D5, C5, B5, cY, A5, z5, y5, at, HI, g4, f4, e4, d4, dt, KI, A4, z4, y4, x4, w4, v4, u4, t4, s4, q4, p4, o4, ry, HJ, V6, U6, T6, S6, kc, R6, Q6, ky, fJ, xy, wy, vy, T5, S5, ly, gJ, ls, uy, ty, V5, U5, fJ, gJ, Le, vc, vc, Q5, P5, O5, N5, M5, L5, K5, J5, cY, I5, H5, G5, vc, _I, _I, $p, He, He, R5, He, vc, bJ, aJ, $p, kc, kc, $I, yo, vc, bJ, aJ, $p, kc, kc, $I, yo, vc, eJ, dJ, $p, kc, kc, cJ, yo, vc, eJ, dJ, $p, kc, kc, cJ, yo, Le, vc, x8, w8, Le, vc, u8, t8, vc, r8, o8, n8, m8, yK, yK, l8, k8, j8, i8, h8, vc, g8, f8, e8, d8, mK, mK, c8, b8, a8, $7, _7, vc, Z7, Y7, W7, V7, U7, T7, R7, Q7, vc, P7, O7, M7, L7, K7, J7, H7, G7, Le, vc, Ke, F7, E7, D7, C7, B7, A7, a6, $5, _5, Z5, Y5, X5, W5, Le, vc, Ke, z7, y7, x7, w7, v7, u7, h6, g6, f6, e6, d6, c6, b6, II, i4, h4, td, jy, iy, hy, gy, fy, ey, RI, QI, PI, OI, NI, MI, LI, SI, E4, D4, td, jy, iy, hy, gy, fy, ey, RI, QI, PI, OI, NI, MI, LI, my, ht, t7, my, ht, s7, ht, ht, vc, nt, nt, bi, bi, bi, bK, kc, ai, ai, vc, nt, nt, bi, bi, bi, bK, kc, ai, ai, vc, mt, mt, bi, bi, bi, aK, kc, ai, ai, vc, mt, mt, bi, bi, bi, aK, kc, ai, ai, DI, Z3, xy, wy, vy, $J, oz, _J, ZJ, YJ, lt, EI, _3, xy, wy, vy, $J, oz, _J, ZJ, YJ, lt, FI, $3, ls, uy, ty, XJ, WJ, VJ, UJ, lt, TJ, GI, a4, ls, uy, ty, XJ, WJ, VJ, UJ, lt, TJ, vc, r7, m7, vc, k7, g7, vc, e7, b7, vc, a7, Z6, vc, JJ, Y6, Re, vc, JJ, X6, Re, vc, vc, Le, vc, W6, HJ, Le, vc, Le, vc, Le, vc, Le, vc, HI, KI, Le, Rg, vc, L3, vc, G3, mI, vc, F3, E3, mI, Nn, Rg, vc, C3, ua, Le, vc, Mf, Mf, y3, q3, s3, t3, vc, k3, vc, j3, Yn, Nn, Yn, Yn, Yn, Yn, Nn, vc, i3, vc, p3, r3, u3, vc, x3, w3, v3, vc, m3 ]);
  function ib() {
   return s.byteLength / 65536 | 0;
  }
  function nb(ob) {
   ob = ob | 0;
   var jb = ib() | 0;
   var kb = jb + ob | 0;
   if (jb < kb && kb < 65536) {
    var lb = new ArrayBuffer(B(kb, 65536));
    var mb = new Int8Array(lb);
    mb.set(t);
    t = new Int8Array(lb);
    u = new Int16Array(lb);
    v = new Int32Array(lb);
    w = new Uint8Array(lb);
    x = new Uint16Array(lb);
    y = new Uint32Array(lb);
    z = new Float32Array(lb);
    A = new Float64Array(lb);
    s = lb;
    e = w;
   }
   return jb;
  }
  return {
   "ua": Object.create(Object.prototype, {
    "grow": {
     "value": nb
    },
    "buffer": {
     "get": function() {
      return s;
     }
    }
   }),
   "va": IE,
   "wa": vP,
   "xa": vP,
   "ya": wP,
   "za": wP,
   "Aa": vc,
   "Ba": Bb,
   "Ca": Tfa,
   "Da": tP,
   "Ea": Rfa,
   "Fa": Qfa,
   "Ga": lu,
   "Ha": Re,
   "Ia": Vfa,
   "Ja": Ufa,
   "Ka": Yfa,
   "La": bA,
   "Ma": Wfa,
   "Na": xP,
   "Oa": Xfa,
   "Pa": Le,
   "Qa": BP,
   "Ra": AP,
   "Sa": BP,
   "Ta": lO,
   "Ua": g3,
   "Va": f3,
   "Wa": e3,
   "Xa": Pfa,
   "Ya": oP,
   "Za": Lfa,
   "_a": nP,
   "$a": Afa,
   "ab": Oda,
   "bb": Pda,
   "cb": yfa,
   "db": xfa,
   "eb": wfa,
   "fb": zfa,
   "gb": Qda,
   "hb": fea,
   "ib": Jda,
   "jb": hea,
   "kb": yea,
   "lb": Mda,
   "mb": jea,
   "nb": Nda,
   "ob": iea,
   "pb": Kda,
   "qb": Uda,
   "rb": Rda,
   "sb": Tda,
   "tb": aea,
   "ub": _da,
   "vb": $da,
   "wb": Vda,
   "xb": Wda,
   "yb": Xda,
   "zb": Zda,
   "Ab": vea,
   "Bb": wea,
   "Cb": Gea,
   "Db": Bea,
   "Eb": Aea,
   "Fb": zea,
   "Gb": Fea,
   "Hb": Eea,
   "Ib": Cea,
   "Jb": Dea,
   "Kb": Lea,
   "Lb": Mea,
   "Mb": Hea,
   "Nb": Kea,
   "Ob": Iea,
   "Pb": pea,
   "Qb": uea,
   "Rb": sea,
   "Sb": rea,
   "Tb": tea,
   "Ub": qea,
   "Vb": eea,
   "Wb": Oea,
   "Xb": oea,
   "Yb": mea,
   "Zb": xea,
   "_b": gea,
   "$b": nea,
   "ac": lea,
   "bc": kea,
   "cc": Pea,
   "dc": bea,
   "ec": Qea,
   "fc": dea,
   "gc": Nea,
   "hc": Kfa,
   "ic": Ifa,
   "jc": d3,
   "kc": Hfa,
   "lc": Gfa,
   "mc": Ffa,
   "nc": Dfa,
   "oc": c3,
   "pc": Cfa,
   "qc": Bfa,
   "rc": vfa,
   "sc": tfa,
   "tc": rfa,
   "uc": Rea,
   "vc": qfa,
   "wc": rc,
   "xc": BN,
   "yc": oq,
   "zc": Fd,
   "Ac": GN,
   "Bc": HN,
   "Cc": Lca,
   "Dc": Mca,
   "Ec": FN,
   "Fc": mda,
   "Gc": oda,
   "Hc": nda,
   "Ic": WN,
   "Jc": WN,
   "Kc": lO,
   "Lc": dI,
   "Mc": dI,
   "Nc": cI,
   "Oc": cI,
   "Pc": b3,
   "Qc": JN,
   "Rc": NN,
   "Sc": VN,
   "Tc": UN,
   "Uc": KN,
   "Vc": QN,
   "Wc": PN,
   "Xc": MN,
   "Yc": SN,
   "Zc": RN,
   "_c": ON,
   "$c": Nm,
   "ad": IN,
   "bd": jda,
   "cd": hca,
   "dd": gda,
   "ed": yca,
   "fd": lca,
   "gd": fda,
   "hd": ica,
   "id": bda,
   "jd": zca,
   "kd": hda,
   "ld": Wca,
   "md": Vca,
   "nd": Uca,
   "od": Zca,
   "pd": Yca,
   "qd": Xca,
   "rd": _ca,
   "sd": cda,
   "td": ada,
   "ud": dda,
   "vd": sca,
   "wd": Jca,
   "xd": fca,
   "yd": uca,
   "zd": tca,
   "Ad": oca,
   "Bd": vca,
   "Cd": nca,
   "Dd": Gca,
   "Ed": aca,
   "Fd": cca,
   "Gd": dca,
   "Hd": bca,
   "Id": Zba,
   "Jd": Yba,
   "Kd": Aca,
   "Ld": Dca,
   "Md": Ica,
   "Nd": Cca,
   "Od": mca,
   "Pd": Fca,
   "Qd": pca,
   "Rd": wca,
   "Sd": Eca,
   "Td": qca,
   "Ud": kca,
   "Vd": xca,
   "Wd": rca,
   "Xd": jca,
   "Yd": _ba,
   "Zd": Xba,
   "_d": Wba,
   "$d": eca,
   "ae": $ba,
   "be": Uba,
   "ce": Vba,
   "de": Hca,
   "ee": a3,
   "fe": gca,
   "ge": Kca,
   "he": Tca,
   "ie": ida,
   "je": $2,
   "ke": eda,
   "le": lda,
   "me": YN,
   "ne": _N,
   "oe": $N,
   "pe": aO,
   "qe": cO,
   "re": dO,
   "se": gO,
   "te": bO,
   "ue": gu,
   "ve": XN,
   "we": ZN,
   "xe": qda,
   "ye": zda,
   "ze": rc,
   "Ae": GN,
   "Be": HN,
   "Ce": oq,
   "De": JN,
   "Ee": NN,
   "Fe": VN,
   "Ge": UN,
   "He": KN,
   "Ie": QN,
   "Je": PN,
   "Ke": MN,
   "Le": SN,
   "Me": RN,
   "Ne": ON,
   "Oe": Nm,
   "Pe": YN,
   "Qe": _N,
   "Re": $N,
   "Se": aO,
   "Te": cO,
   "Ue": dO,
   "Ve": gO,
   "We": bO,
   "Xe": gu,
   "Ye": ZN,
   "Ze": hb,
   "_e": fia,
   "$e": Via,
   "af": Wga,
   "bf": Ofa,
   "cf": A3,
   "df": B3,
   "ef": o3,
   "ff": n3,
   "gf": _2,
   "hf": Z2,
   "jf": X2,
   "kf": T2,
   "lf": Y2,
   "mf": X2,
   "nf": W2,
   "of": U2,
   "pf": V2,
   "qf": U2,
   "rf": T2,
   "sf": T2
  };
 }
 return pb(rb);
}
// EMSCRIPTEN_END_ASM


)(info);
  },

  instantiate: /** @suppress{checkTypes} */ function(binary, info) {
    return {
      then: function(ok) {
        var module = new WebAssembly.Module(binary);
        ok({
          'instance': new WebAssembly.Instance(module, info)
        });
        // Emulate a simple WebAssembly.instantiate(..).then(()=>{}).catch(()=>{}) syntax.
        return { catch: function() {} };
      }
    };
  },

  RuntimeError: Error
};

// We don't need to actually download a wasm binary, mark it as present but empty.
wasmBinary = [];
